#--------------------------------------------------------------------------
# $Id: //depot/prod/test/Rsierranevada/ATI/ati_errno.pm#1 $
#
# Copyright (c) 1992-2004 Network Appliance, Inc.
# All rights reserved.
#--------------------------------------------------------------------------
#
# PACKAGE: ati_errno.pm
#
# AUTHOR: Will McGovern (will@netapp.com)
#
# This package contains all the ONTAPI error code mappings.
#
# The error codes for ONTAPI are automatically generated by the ONTAP build
# process which creates the perl package "$ONTAPDIR/files/zapi/ZapiErrno.pm".
#
# At present we cut and paste the exports and constant definitions from
# this automatically generated package file. This is obviously not an ideal
# solution because it only takes a snapshot of the error codes and requires
# manual care and feeding to keep current. However, because one of the goals
# of the ATI infrastructure is to detach and operate independently from any
# specific code line, there is no nicer way to handle this right now.
#
# TODO:
#
# o XXX - Figure out how to integrate better with the auto-generation.
# o XXX - Find out if the error code mappings are constant.
#
#--------------------------------------------------------------------------
#
package ATI::ati_errno;
#
# Always require hard-assed checking
#
use strict;
use warnings;
#
# Export symbols for external use
#
use Exporter;
our (@EXPORT, @ISA);
@ISA = qw(Exporter);

#============= START CUT & PASTE FROM ZapiErrno.pm HERE ==============#

@EXPORT = qw(
	EPERM
	ENOENT
	ESRCH
	EINTR
	EIO
	ENXIO
	E2BIG
	ENOEXEC
	EBADF
	ECHILD
	EDEADLK
	ENOMEM
	EACCES
	EFAULT
	ENOTBLK
	EBUSY
	EEXIST
	EXDEV
	ENODEV
	ENOTDIR
	EISDIR
	EINVAL
	ENFILE
	EMFILE
	ENOTTY
	ETXTBSY
	EFBIG
	ENOSPC
	ESPIPE
	EROFS
	EMLINK
	EPIPE
	EDOM
	ERANGE
	EAGAIN
	EINPROGRESS
	EALREADY
	ENOTSOCK
	EDESTADDRREQ
	EMSGSIZE
	EPROTOTYPE
	ENOPROTOOPT
	EPROTONOSUPPORT
	ESOCKTNOSUPPORT
	EOPNOTSUPP
	EPFNOSUPPORT
	EAFNOSUPPORT
	EADDRINUSE
	EADDRNOTAVAIL
	ENETDOWN
	ENETUNREACH
	ENETRESET
	ECONNABORTED
	ECONNRESET
	ENOBUFS
	EISCONN
	ENOTCONN
	ESHUTDOWN
	ETOOMANYREFS
	ETIMEDOUT
	ECONNREFUSED
	ELOOP
	ENAMETOOLONG
	EHOSTDOWN
	EHOSTUNREACH
	ENOTEMPTY
	EPROCLIM
	EUSERS
	EDQUOT
	ESTALE
	EREMOTE
	EBADRPC
	ERPCMSGDENIED
	EPROGUNAVAIL
	EPROGMISMATCH
	EPROCUNAVAIL
	ENOLCK
	ENOSYS
	EFTYPE
	EMTUTOOBIG
	EOFFLINE
	EBADSTREAM
	EBADSTREAMDIR
	ELOADCOMPLETE
	EMOUNTING
	EWFLUSH
	EBADPATH
	EBADCHAR
	ESHARECONFLICT
	ELOCKCONFLICT
	ENOTCOVERED
	EBADXINODE
	ENOTXINODE
	EBADOWNER
	ERMTWRITELEN
	EBADRMT
	EKNOWNBADRMT
	ERMTEOF
	EDELPENDING
	ETRUNCATED
	EREJECTED
	EREADONLY
	EPARTNERREJECT
	ETOOCOMPLEX
	EREGX
	EREGXBADVALUE
	EPERSISTENCE
	ESTHREAD
	EDISABLED
	ENOTVSCANNED
	EFABRIC
	ESYSTEMERR
	EGSSAPI
	ERPCGSSSEQNUM
	EPROXYME
	ERSRVCONFLICT
	ERSRVNSUPPORTED
	ENOQTREE
	ENOTLOCKED
	ELOCKCANCELLED
	ENOSPCSNAP
	ENOMORESNAPS
	ERECURSE
	ERECLAIM
	EZEROLENREC
	ENOTFSCREENED
	EISVDISK
	EWAFLMSGABORTED
	EMSGNULLIFY
	ECOMPRESSCHECK
	EVOLSMALL
	EVOLBIG
	EVOLPAIRED
	EVOLNOTFLEX
	EVOLSTALE
	ENOREG
	ENOREGKEY
	ECANNOTDELETE
	EVOLOPNOTSUPP
	ENOSPCAGGR
	EWORMNOCLOCK
	EWORMVOLWORM
	EWORMVOLSLC
	EWORMVOLNOTWORM
	EWORMSNAPLOCKED
	EWORMSNAPRENAME
	EWORMPERIOD
	EDENSEBIG
	EWORMSNAPNOTWORM
	EOPNEEDSWORMLOG
	EASYNC
	EPATH
	ENOTHERE
	EATEOF
	ELINKED
	EGRACE
	ENORECLAIM
	ESTALECURSOR
	EQUIESCING
	ENOVOL
	EGRACEEXPIRED
	ESYMLINK
	EJUNCTION
	EDSROOT
	EOPLOCKED
	ERANGENOTLOCKED
	EISJUNCTION
	EBADCRED
	EBADCREDHANDLE
	ECREDEXISTS
	EEXPORTPOINT
	ECREDNEEDED
	ECREDMISSING
	ENOSESSION
	ENOVIF
	EDELAY
	ETOOMANY
	ESTALECONFIG
	EBADCURSOR
	ENGROUPS
	EBADOPNUM
	EINCONSISTENTMIN
	EINCONSISTENTDIR
	EINCONSISTENTDIRENT
	EINCONSISTENTMAX
	EVDISK_ERROR_NOT_IMPLEMENTED
	EVDISKMIN
	EVDISK_ERROR_NOT_QTREE_ROOT
	EVDISK_ERROR_NOT_VDISK_TYPE
	EVDISK_ERROR_NO_SUCH_INITGROUP
	EVDISK_ERROR_INITGROUP_EXISTS
	EVDISK_ERROR_NOT_VALID_FC_WWN
	EVDISK_ERROR_NOT_VALID_ISCSI_NAME
	EVDISK_ERROR_NODE_NOT_IN_INITGROUP
	EVDISK_ERROR_INITGROUP_HAS_NODE
	EVDISK_ERROR_LUN_MAPPING_CONFLICT
	EVDISK_ERROR_INITGROUP_WRONG_TYPE
	EVDISK_ERROR_NO_SUCH_ATTRIBUTE
	EVDISK_ERROR_VDISK_EXISTS
	EVDISK_ERROR_VDISK_EXPORTED
	EVDISK_ERROR_VDISK_NOT_ENABLED
	EVDISK_ERROR_VDISK_NOT_DISABLED
	EVDISK_ERROR_NO_SUCH_LUNMAP
	EVDISK_ERROR_NO_SUCH_VDISK
	EVDISK_ERROR_NOT_IN_SAME_QTREE
	EVDISK_ERROR_SOURCE_IS_VDISK
	EVDISK_ERROR_NO_SUCH_DIRECTORY
	EVDISK_ERROR_INVALID_SNAPSHOT_PATH
	EVDISK_ERROR_NOT_IN_SAME_VOLUME
	EVDISK_ERROR_INITGROUP_HAS_VDISK
	EVDISK_ERROR_INITGROUP_HAS_LUN
	EVDISK_ERROR_INITGROUP_MISSING_ARGS
	EVDISK_ERROR_INITGROUP_INVALID_ATTR_TYPE
	EVDISK_ERROR_INITGROUP_INVALID_ATTR_VALUE
	EVDISK_ERROR_NO_EXPORTED_VDISK_SHARE_WRITE
	EVDISK_ERROR_INITGROUP_MAPS_EXIST
	EVDISK_ERROR_VOLUME_NOT_SPACE_RESERVED
	EVDISK_ERROR_SNAPSHOT_FILE_NOT_VDISK
	EVDISK_ERROR_NITGROUP_INVALID_ATTR_VALUE_OS_TYPE
	EVDISK_ERROR_MUST_SPECIFY_F_FLAG
	EVDISK_ERROR_SIZE_TOO_LARGE
	EVDISK_ERROR_RESIZE_TOO_LARGE
	EVDISK_ERROR_NO_SUCH_VOLUME
	EVDISK_ERROR_USER_ABORT_ACTION
	EVDISK_ERROR_CLONING
	EVDISK_ERROR_INITIATOR_HAS_VDISK
	EVDISK_ERROR_FILE_IS_SPC_RESERVED
	EVDISK_ERROR_SIZE_TOO_SMALL
	EVDISK_ERROR_SIZE_UNCHANGED
	EVDISK_ERROR_NO_SUCH_SNAPSHOT
	EVDISK_ERROR_IGROUP_NOT_THROTTLED
	EVDISK_ERROR_IGROUP_ALREDY_THROTTLED
	EVDISK_ERROR_THROTTLE_TOO_MUHC
	EVDISK_ERROR_THROTTLE_BEING_DELETED
	EVDISK_ERROR_NO_SUCH_CLONE
	EVDISK_ERROR_NO_ISCSI_THROTTLES
	EVDISK_ERROR_INVALID_ATTR_MODE_VALUE
	EVDISK_ERROR_INITGROUP_MEMBER_CONFLICTING_OS_TYPES
	EVDISK_ERROR_INITGROUP_SET_TYPE_CONFLICT
	EVDISK_ERROR_INITGROUP_MEMBER_VSA_MIXED
	EVDISK_ERROR_INITGROUP_SET_VSA_CONFLICT
	EVDISK_ERROR_RESIZE_FIXES_NOT_GEOM_ALIGNED
	EVDISK_ERROR_RESIZE_VLD_TYPE_LUN_FIXES
	EVDISK_ERROR_RESIZE_IMGAG_TYPE_LUN_FIXES
	EVDISK_ERROR_INITGROUP_F_FLAG_REQUIRED
	EVDISK_ERROR_USE_PARTNER_NOT_APPLICABLE
	EVDISK_ERROR_RESTORE_WALKOVER_EACHOTHER
	EVDISK_ERROR_VOLUME_SPARSE
	EVDISK_ERROR_DESTROY_LUN_BUSY
	EVDISK_ERROR_CANT_CREATE_INITGROUP_FILE
	EVDISK_ERROR_CANT_WRITE_INITGROUP_FILE
	EVDISK_ERROR_CANT_RENAME_INITGROUP_FILE
	EVDISK_ERROR_CANT_CREATE_VFILER_SHADOW_INITGROUP_FILE
	EVDISK_ERROR_CANT_WRITE_VFILER_SHADOW_INITGROUP_FILE
	EVDISK_ERROR_CANT_RENAME_VFILER_SHADOW_INITGROUP_FILE
	EVDISK_ERROR_INITGROUP_TOO_MANY_NODENAMES
	EVDISK_ERROR_LUN_MISSING_FROM_SNAPSHOT
	EVDISK_ERROR_SNAPVALIDATOR_ERROR
	EVDISK_ERROR_PARTNER_HAS_LUN
	EVDISK_ERROR_PARTNER_NOT_REACHABLE
	EVDISK_ERROR_PORTSET_NO_SUCH_SET
	EVDISK_ERROR_PORTSET_ALREADY_EXIST
	EVDISK_ERROR_PORTSET_HAS_PORT
	EVDISK_ERROR_PORTSET_INVALID_PORT_NAME
	EVDISK_ERROR_PORTSET_TOO_MANY_PORTS
	EVDISK_ERROR_PORTSET_WRONG_TYPE
	EVDISK_ERROR_INITGROUP_ALREADY_BOUND
	EVDISK_ERROR_INITGROUP_NOT_BOUND
	EVDISK_ERROR_INITGROUP_EMPTY_PSET_BIND
	EVDISK_ERROR_PORTSET_NO_SUCH_PORT
	EVDISK_ERROR_PORTSET_NO_SUCH_FILER_NAME
	EVDISK_ERROR_PARTNER_HAS_DIFFERENT_OS_TYPE
	EVDISK_ERROR_PARTNER_HAS_DIFFERENT_VSA_SETTING
	EVDISK_ERROR_PORTSET_CANT_CREATE_FILE
	EVDISK_ERROR_PORTSET_CANT_WRITE_FILE
	EVDISK_ERROR_PORTSET_CANT_READ_FILE
	EVDISK_ERROR_PORTSET_CANT_OPEN_FILE
	EVDISK_ERROR_LUN_TOO_LARGE
	EVDISK_ERROR_PORTSET_IC_DOWN
	EVDISK_ERROR_CLONE_NOT_SPLITTING
	EVDISK_ERROR_LUN_HAS_NO_SERIAL_NO
	EVDISK_ERROR_PORTSET_THROTTLE_EXCEEDED
	EVDISK_ERROR_PORTSET_CANT_DESTROY_BOUND_PORTSET
	EVDISK_ERROR_CFMODE_MISMATCH
	EVDISK_ERROR_PORTSET_NOT_VALID_CFMODE
	EVDISK_ERROR_CANNOT_CHANGE_SPCRES_DURING_SPLIT
	EVDISK_ERROR_INITGROUP_BIND_WRONG_TYPE
	EVDISK_ERROR_DB_BAD_INDEX
	EVDISK_ERROR_DB_NO_SUCH_DATABASE
	EVDISK_ERROR_ALUA_NOT_SUPPORTED_ON_ISCSI
	EVDISK_ERROR_ALUA_NOT_SUPPORTED_ON_CFMODE
	EVDISKMAX
	EBADHANDLE
	ENOTSYNC
	EBADCOOKIE
	ENOTSUPP
	ETOOSMALL
	ESERVERFAULT
	EBADTYPE
	EJUKEBOX
	EWRONGSEC
	EAPIERROR
	EAPIAUTHENTICATION
	EAPIPRIVILEDGE
	EAPIPRIVILEGE
	EAPIEXCEPTION
	EAPINOTFOUND
	EAPIMISSINGARGUMENT
	EAPINOTIMPLEMENTED
	EAPILICENSE
	EAPIINDEXTOOLARGE
	EAPIUNSUPPORTEDVERSION
	EAPITRANSMISSION
	EOPNOTSUPPORTED
	EALREADYSTARTED
	ENOTSTARTED
	ESERVICENOTSTOPPED
	ENOTWHILEWAITINGFORGIVEBACK
	ENOTINMAINTMODE
	ENOTINREADONLYMODE
	ESNAPSHOTEXISTS
	ESNAPSHOTDOESNOTEXIST
	ESNAPSHOTTOOMANY
	ESNAPSHOTNOTALLOWED
	ESNAPSHOTBUSY
	ESNAPSHOTNOSPACE
	EVOLUMESNAPRESTOREERROR
	EVOLUMEQUIESCED
	EVOLUMEDOESNOTEXIST
	EVOLUMEMOUNTING
	EVOLUMEOFFLINE
	EVOLUMEREADONLY
	EVOLUMENAMEINVALID
	EVOLUMERGSIZEINVALID
	EVOLUMELANGUAGEINVALID
	EVOLUMEDISKSIZEINVALID
	EVOLUMEDISKDUP
	EVOLUMERGINVALID
	EQUOTAPARSEERROR
	EQUOTAINVALID
	EQUOTAEXISTS
	EQUOTADOESNOTEXIST
	EQUOTADIRECTIVE
	EVFILEROPNOTALLOWED
	EVFILERNOTFOUND
	EVFILEROPNOTCOMPLETED
	EIPSPACENOTFOUND
	EQTREEEXISTS
	EQTREENOTOWNER
	EQTREEMAX
	ECMSINVALIDREQUEST
	ECMSNOTENABLED
	ECMSPROCESSINGERROR
	ESNAPMIRROROFF
	ESNAPMIRRORPARSERERROR
	ESNAPMIRRORERROR
	EISCSISECINVALIDINPUTERROR
	EISCSISECPROCESSINGERROR
	EISCSISECINITNOTFOUNDERROR
	EFILENOTFOUND
	EINTERNALERROR
	EINVALIDINPUTERROR
	ESETSPCRESERROR
	EADAPTERNOTFOUND
	EADAPTERPARTNER
	EADAPTERINVALIDTYPE
	ENOADAPTERPARTNER
	ENOVIRTUALADAPTERS
	ENOTCLUSTERED
	ECLUSTERED
	EDISKNOTFOUND
	ESWAPINPROGRESS
	ENOTDISKOWNER
	EDISKINRAIDZEROVOL
	EDISKISSPARE
	EVOLUMEPLEXINVALID
	EVOLUMEINUSE
	EVOLUMENOTONLINE
	EVOLUMEBUSY
	EVOLUMECIFSTERMINATE
	EVOLUMECREATING
	ECLIENTSTATSVFILER
	ECLIENTSTATSNOTENABLED
	ENOACTIVECLIENTS
	ECIFSNOTCONFIGURED
	EDNSNOTENABLED
	EHOSTNOTFOUND
	ELDAPSVRNOTFOUND
	ESVCDISABLED
	ESVCNOTAVAIL
	ESHAREACCESSDENIED
	ESHAREEXISTS
	ESHARETOOMANY
	ESANOWNNOTENABLED
	ECIFSSHARINGVIOLATION
	EINVALIDHOST
	EINVALIDOWNERID
	EINVALIDOWNER
	EINVALIDPASSWORD
	EEXPORTSINCOMPATIBLE
	EINODENUMBERTOOSMALL
	EINODENUMBERTOOLARGE
	EINVALIDINODE
	EINELIGIBLEINODE
	EPARENTINFONOTLOADED
	EI2PNOTENABLED
	ECIFS_LOGIN_FAILED
	ECIFS_BIND_FAILED
	ECIFS_DNS_REQUIRED
	ECIFS_KRB_CONFLICT
	ECIFS_AD_CLOCK_SKEW
	ECIFS_AD_RESET_REQUIRED
	ECIFS_LIST_UNAVAILABLE
	ECIFS_DC_CONNECT_FAILED
	EEMS_INVOKE_FAILED
	EEMS_INVOKE_BAD_PARAM
	EEMS_INVOKE_ID_BAD
	EEMS_INVOKE_SEVERITY_REQUIRED
	EEMS_INVOKE_SEVERITY_INVALID
	EEMS_INVOKE_SEVERITY_NOT_VARIABLE
	EEMS_INVOKE_PARAMS_INSUFFICIENT
	EEMS_INVOKE_VERSION_INVALID
	EEMS_INVOKE_SUPRESS_DUP
	EEMS_INVOKE_SUPRESS_TIMER
	EEMS_INVOKE_NVRAM_TOO_BIG
	EEMS_INVOKE_QUEUE_FULL
	EREALLOCATE_EXISTS
	EREALLOCATE_BADPATH
	EREALLOCATE_NOMEM
	EREALLOCATE_NOSCAN
	EREALLOCATE_BADVOL
	EREALLOCATE_READONLY
	EREALLOCATE_BADSCHED
	EREALLOCATE_OFF
	EREALLOCATE_SNAPSHOT
	EDISKNOTSPARE
	EDISKTOOSMALL
	ERAIDGROUPDEGRADED
	ESAVECOREDISK
	EINVALIDSTATE
	ENPMINVPLOC
	ENPMNOPKG
	ENPMNOMETA
	ENPMERXMETA
	EINCRCOPYFAILED
	EINCRCOPYOPNOTFOUND
	EINCRCOPYINVALIDUUID
	EINCRCOPYINVALIDOP
	EINCRCOPYNOMEM
	EINCRCOPYINVALIDINPUT
	EINCRCOPYINVALIDOPTYPE
	EINCRCOPYDUPLICATESESSION
	EINCRCOPYNOTSUPPORT
	EINCRCOPYVOLOFFLINE
	EINCRCOPYVOLNOTFOUND
	EINCRCOPYSNAPCREATIONFAIL
	EINCRCOPYSNAPSHOTEXIST
	EINCRCOPYNOSTREAMESTABLISHED
	ECGERROR
	ECGSNAPERR
	ECGOFF
	ECHARMAP_INVALID
	ECHARMAP_NO_PERSIST
	ETOERRMIN
	ESERVICENOTINITIALIZED
	ESERVICENOTLICENSED
	ESERVICENOTENABLED
	EMBOXDEGRADED
	EMBOXUNKNOWN
	EMBOXVERSIONMISMATCH
	EPARTNERDISABLEDTO
	EOPERATORDENY
	ENVRAMSIZEMISMATCH
	EVERSIONMISMATCH
	EINTERCONNECTERROR
	EPARTNERBOOTING
	ESHELFHOT
	EPARTNERREVERT
	ELOCALREVERT
	EPARTNERTRYINGTAKEOVER
	ETAKEOVERINPROGRESS
	EHALTNOTAKEOVER
	EUNSYNCNVRAM
	EUNKNOWNTAKEOVERERROR
	EWAITINGFORPARTNER
	ELOWMEMORY
	EHALTING
	EMBOXUNCERTAIN
	ENOAUTOTAKEOVER
	EPARTNERNOTWAITING
	ENOAGGRS
	ENOTHINGTOTAKEOVER
	ESENDHOMEINPROGRESS
	ENVRAMDOWN
	EINTERCONNECTRESET
	EBADOPTIONS
	ENOTHALTED
	EREVERTINPROGRESS
	ESERVICEENABLED
	EINTAKEOVER
	ETOERRMAX
	EINVALIDRESERVATION
	ENODISKSFOUND
	EMUSTBEINMAINTMODE
	EFILEEXISTS
	EJUNCTIONEXISTS
	EJUNCTIONDOESNOTEXIST
	EBADFILELENGTH
	EBADCOREID
	ESESNOTREADY
	ESESBUSY
	ESHAREKEY
	EICAPSKIP
);

use constant EPERM => 1;
use constant ENOENT => 2;
use constant ESRCH => 3;
use constant EINTR => 4;
use constant EIO => 5;
use constant ENXIO => 6;
use constant E2BIG => 7;
use constant ENOEXEC => 8;
use constant EBADF => 9;
use constant ECHILD => 10;
use constant EDEADLK => 11;
use constant ENOMEM => 12;
use constant EACCES => 13;
use constant EFAULT => 14;
use constant ENOTBLK => 15;
use constant EBUSY => 16;
use constant EEXIST => 17;
use constant EXDEV => 18;
use constant ENODEV => 19;
use constant ENOTDIR => 20;
use constant EISDIR => 21;
use constant EINVAL => 22;
use constant ENFILE => 23;
use constant EMFILE => 24;
use constant ENOTTY => 25;
use constant ETXTBSY => 26;
use constant EFBIG => 27;
use constant ENOSPC => 28;
use constant ESPIPE => 29;
use constant EROFS => 30;
use constant EMLINK => 31;
use constant EPIPE => 32;
use constant EDOM => 33;
use constant ERANGE => 34;
use constant EAGAIN => 35;
use constant EINPROGRESS => 36;
use constant EALREADY => 37;
use constant ENOTSOCK => 38;
use constant EDESTADDRREQ => 39;
use constant EMSGSIZE => 40;
use constant EPROTOTYPE => 41;
use constant ENOPROTOOPT => 42;
use constant EPROTONOSUPPORT => 43;
use constant ESOCKTNOSUPPORT => 44;
use constant EOPNOTSUPP => 45;
use constant EPFNOSUPPORT => 46;
use constant EAFNOSUPPORT => 47;
use constant EADDRINUSE => 48;
use constant EADDRNOTAVAIL => 49;
use constant ENETDOWN => 50;
use constant ENETUNREACH => 51;
use constant ENETRESET => 52;
use constant ECONNABORTED => 53;
use constant ECONNRESET => 54;
use constant ENOBUFS => 55;
use constant EISCONN => 56;
use constant ENOTCONN => 57;
use constant ESHUTDOWN => 58;
use constant ETOOMANYREFS => 59;
use constant ETIMEDOUT => 60;
use constant ECONNREFUSED => 61;
use constant ELOOP => 62;
use constant ENAMETOOLONG => 63;
use constant EHOSTDOWN => 64;
use constant EHOSTUNREACH => 65;
use constant ENOTEMPTY => 66;
use constant EPROCLIM => 67;
use constant EUSERS => 68;
use constant EDQUOT => 69;
use constant ESTALE => 70;
use constant EREMOTE => 71;
use constant EBADRPC => 72;
use constant ERPCMSGDENIED => 73;
use constant EPROGUNAVAIL => 74;
use constant EPROGMISMATCH => 75;
use constant EPROCUNAVAIL => 76;
use constant ENOLCK => 77;
use constant ENOSYS => 78;
use constant EFTYPE => 79;
use constant EMTUTOOBIG => 80;
use constant EOFFLINE => 81;
use constant EBADSTREAM => 82;
use constant EBADSTREAMDIR => 83;
use constant ELOADCOMPLETE => 84;
use constant EMOUNTING => 85;
use constant EWFLUSH => 99;
use constant EBADPATH => 100;
use constant EBADCHAR => 101;
use constant ESHARECONFLICT => 102;
use constant ELOCKCONFLICT => 103;
use constant ENOTCOVERED => 104;
use constant EBADXINODE => 105;
use constant ENOTXINODE => 106;
use constant EBADOWNER => 107;
use constant ERMTWRITELEN => 108;
use constant EBADRMT => 109;
use constant EKNOWNBADRMT => 110;
use constant ERMTEOF => 111;
use constant EDELPENDING => 112;
use constant ETRUNCATED => 113;
use constant EREJECTED => 114;
use constant EREADONLY => 115;
use constant EPARTNERREJECT => 116;
use constant ETOOCOMPLEX => 117;
use constant EREGX => 118;
use constant EREGXBADVALUE => 119;
use constant EPERSISTENCE => 120;
use constant ESTHREAD => 121;
use constant EDISABLED => 122;
use constant ENOTVSCANNED => 123;
use constant EFABRIC => 124;
use constant ESYSTEMERR => 125;
use constant EGSSAPI => 126;
use constant ERPCGSSSEQNUM => 127;
use constant EPROXYME => 128;
use constant ERSRVCONFLICT => 129;
use constant ERSRVNSUPPORTED => 130;
use constant ENOQTREE => 131;
use constant ENOTLOCKED => 132;
use constant ELOCKCANCELLED => 133;
use constant ENOSPCSNAP => 134;
use constant ENOMORESNAPS => 135;
use constant ERECURSE => 136;
use constant ERECLAIM => 137;
use constant EZEROLENREC => 138;
use constant ENOTFSCREENED => 139;
use constant EISVDISK => 140;
use constant EWAFLMSGABORTED => 141;
use constant EMSGNULLIFY => 142;
use constant ECOMPRESSCHECK => 143;
use constant EVOLSMALL => 144;
use constant EVOLBIG => 145;
use constant EVOLPAIRED => 146;
use constant EVOLNOTFLEX => 147;
use constant EVOLSTALE => 148;
use constant ENOREG => 149;
use constant ENOREGKEY => 150;
use constant ECANNOTDELETE => 151;
use constant EVOLOPNOTSUPP => 152;
use constant ENOSPCAGGR => 153;
use constant EWORMNOCLOCK => 154;
use constant EWORMVOLWORM => 155;
use constant EWORMVOLSLC => 156;
use constant EWORMVOLNOTWORM => 157;
use constant EWORMSNAPLOCKED => 158;
use constant EWORMSNAPRENAME => 159;
use constant EWORMPERIOD => 160;
use constant EDENSEBIG => 161;
use constant EWORMSNAPNOTWORM => 162;
use constant EOPNEEDSWORMLOG => 163;
use constant EASYNC => 256;
use constant EPATH => 257;
use constant ENOTHERE => 258;
use constant EATEOF => 259;
use constant ELINKED => 260;
use constant EGRACE => 261;
use constant ENORECLAIM => 262;
use constant ESTALECURSOR => 263;
use constant EQUIESCING => 264;
use constant ENOVOL => 265;
use constant EGRACEEXPIRED => 266;
use constant ESYMLINK => 267;
use constant EJUNCTION => 268;
use constant EDSROOT => 269;
use constant EOPLOCKED => 270;
use constant ERANGENOTLOCKED => 271;
use constant EISJUNCTION => 272;
use constant EBADCRED => 273;
use constant EBADCREDHANDLE => 274;
use constant ECREDEXISTS => 275;
use constant EEXPORTPOINT => 276;
use constant ECREDNEEDED => 277;
use constant ECREDMISSING => 278;
use constant ENOSESSION => 279;
use constant ENOVIF => 280;
use constant EDELAY => 281;
use constant ETOOMANY => 282;
use constant ESTALECONFIG => 283;
use constant EBADCURSOR => 284;
use constant ENGROUPS => 285;
use constant EBADOPNUM => 286;
use constant EINCONSISTENTMIN => 8000;
use constant EINCONSISTENTDIR => 8001;
use constant EINCONSISTENTDIRENT => 8002;
use constant EINCONSISTENTMAX => 8100;
use constant EVDISK_ERROR_NOT_IMPLEMENTED => 9000;
use constant EVDISKMIN => 9000;
use constant EVDISK_ERROR_NOT_QTREE_ROOT => 9001;
use constant EVDISK_ERROR_NOT_VDISK_TYPE => 9002;
use constant EVDISK_ERROR_NO_SUCH_INITGROUP => 9003;
use constant EVDISK_ERROR_INITGROUP_EXISTS => 9004;
use constant EVDISK_ERROR_NOT_VALID_FC_WWN => 9005;
use constant EVDISK_ERROR_NOT_VALID_ISCSI_NAME => 9006;
use constant EVDISK_ERROR_NODE_NOT_IN_INITGROUP => 9007;
use constant EVDISK_ERROR_INITGROUP_HAS_NODE => 9008;
use constant EVDISK_ERROR_LUN_MAPPING_CONFLICT => 9009;
use constant EVDISK_ERROR_INITGROUP_WRONG_TYPE => 9010;
use constant EVDISK_ERROR_NO_SUCH_ATTRIBUTE => 9011;
use constant EVDISK_ERROR_VDISK_EXISTS => 9012;
use constant EVDISK_ERROR_VDISK_EXPORTED => 9013;
use constant EVDISK_ERROR_VDISK_NOT_ENABLED => 9014;
use constant EVDISK_ERROR_VDISK_NOT_DISABLED => 9015;
use constant EVDISK_ERROR_NO_SUCH_LUNMAP => 9016;
use constant EVDISK_ERROR_NO_SUCH_VDISK => 9017;
use constant EVDISK_ERROR_NOT_IN_SAME_QTREE => 9018;
use constant EVDISK_ERROR_SOURCE_IS_VDISK => 9019;
use constant EVDISK_ERROR_NO_SUCH_DIRECTORY => 9020;
use constant EVDISK_ERROR_INVALID_SNAPSHOT_PATH => 9021;
use constant EVDISK_ERROR_NOT_IN_SAME_VOLUME => 9022;
use constant EVDISK_ERROR_INITGROUP_HAS_VDISK => 9023;
use constant EVDISK_ERROR_INITGROUP_HAS_LUN => 9024;
use constant EVDISK_ERROR_INITGROUP_MISSING_ARGS => 9025;
use constant EVDISK_ERROR_INITGROUP_INVALID_ATTR_TYPE => 9026;
use constant EVDISK_ERROR_INITGROUP_INVALID_ATTR_VALUE => 9027;
use constant EVDISK_ERROR_NO_EXPORTED_VDISK_SHARE_WRITE => 9028;
use constant EVDISK_ERROR_INITGROUP_MAPS_EXIST => 9029;
use constant EVDISK_ERROR_VOLUME_NOT_SPACE_RESERVED => 9030;
use constant EVDISK_ERROR_SNAPSHOT_FILE_NOT_VDISK => 9031;
use constant EVDISK_ERROR_NITGROUP_INVALID_ATTR_VALUE_OS_TYPE => 9032;
use constant EVDISK_ERROR_MUST_SPECIFY_F_FLAG => 9033;
use constant EVDISK_ERROR_SIZE_TOO_LARGE => 9034;
use constant EVDISK_ERROR_RESIZE_TOO_LARGE => 9035;
use constant EVDISK_ERROR_NO_SUCH_VOLUME => 9036;
use constant EVDISK_ERROR_USER_ABORT_ACTION => 9037;
use constant EVDISK_ERROR_CLONING => 9038;
use constant EVDISK_ERROR_INITIATOR_HAS_VDISK => 9039;
use constant EVDISK_ERROR_FILE_IS_SPC_RESERVED => 9040;
use constant EVDISK_ERROR_SIZE_TOO_SMALL => 9041;
use constant EVDISK_ERROR_SIZE_UNCHANGED => 9042;
use constant EVDISK_ERROR_NO_SUCH_SNAPSHOT => 9043;
use constant EVDISK_ERROR_IGROUP_NOT_THROTTLED => 9044;
use constant EVDISK_ERROR_IGROUP_ALREDY_THROTTLED => 9045;
use constant EVDISK_ERROR_THROTTLE_TOO_MUHC => 9046;
use constant EVDISK_ERROR_THROTTLE_BEING_DELETED => 9047;
use constant EVDISK_ERROR_NO_SUCH_CLONE => 9048;
use constant EVDISK_ERROR_NO_ISCSI_THROTTLES => 9049;
use constant EVDISK_ERROR_INVALID_ATTR_MODE_VALUE => 9050;
use constant EVDISK_ERROR_INITGROUP_MEMBER_CONFLICTING_OS_TYPES => 9051;
use constant EVDISK_ERROR_INITGROUP_SET_TYPE_CONFLICT => 9052;
use constant EVDISK_ERROR_INITGROUP_MEMBER_VSA_MIXED => 9053;
use constant EVDISK_ERROR_INITGROUP_SET_VSA_CONFLICT => 9054;
use constant EVDISK_ERROR_RESIZE_FIXES_NOT_GEOM_ALIGNED => 9055;
use constant EVDISK_ERROR_RESIZE_VLD_TYPE_LUN_FIXES => 9056;
use constant EVDISK_ERROR_RESIZE_IMGAG_TYPE_LUN_FIXES => 9057;
use constant EVDISK_ERROR_INITGROUP_F_FLAG_REQUIRED => 9058;
use constant EVDISK_ERROR_USE_PARTNER_NOT_APPLICABLE => 9059;
use constant EVDISK_ERROR_RESTORE_WALKOVER_EACHOTHER => 9060;
use constant EVDISK_ERROR_VOLUME_SPARSE => 9061;
use constant EVDISK_ERROR_DESTROY_LUN_BUSY => 9062;
use constant EVDISK_ERROR_CANT_CREATE_INITGROUP_FILE => 9063;
use constant EVDISK_ERROR_CANT_WRITE_INITGROUP_FILE => 9064;
use constant EVDISK_ERROR_CANT_RENAME_INITGROUP_FILE => 9065;
use constant EVDISK_ERROR_CANT_CREATE_VFILER_SHADOW_INITGROUP_FILE => 9066;
use constant EVDISK_ERROR_CANT_WRITE_VFILER_SHADOW_INITGROUP_FILE => 9067;
use constant EVDISK_ERROR_CANT_RENAME_VFILER_SHADOW_INITGROUP_FILE => 9068;
use constant EVDISK_ERROR_INITGROUP_TOO_MANY_NODENAMES => 9069;
use constant EVDISK_ERROR_LUN_MISSING_FROM_SNAPSHOT => 9070;
use constant EVDISK_ERROR_SNAPVALIDATOR_ERROR => 9071;
use constant EVDISK_ERROR_PARTNER_HAS_LUN => 9072;
use constant EVDISK_ERROR_PARTNER_NOT_REACHABLE => 9073;
use constant EVDISK_ERROR_PORTSET_NO_SUCH_SET => 9074;
use constant EVDISK_ERROR_PORTSET_ALREADY_EXIST => 9075;
use constant EVDISK_ERROR_PORTSET_HAS_PORT => 9076;
use constant EVDISK_ERROR_PORTSET_INVALID_PORT_NAME => 9077;
use constant EVDISK_ERROR_PORTSET_TOO_MANY_PORTS => 9078;
use constant EVDISK_ERROR_PORTSET_WRONG_TYPE => 9079;
use constant EVDISK_ERROR_INITGROUP_ALREADY_BOUND => 9080;
use constant EVDISK_ERROR_INITGROUP_NOT_BOUND => 9081;
use constant EVDISK_ERROR_INITGROUP_EMPTY_PSET_BIND => 9082;
use constant EVDISK_ERROR_PORTSET_NO_SUCH_PORT => 9083;
use constant EVDISK_ERROR_PORTSET_NO_SUCH_FILER_NAME => 9084;
use constant EVDISK_ERROR_PARTNER_HAS_DIFFERENT_OS_TYPE => 9085;
use constant EVDISK_ERROR_PARTNER_HAS_DIFFERENT_VSA_SETTING => 9086;
use constant EVDISK_ERROR_PORTSET_CANT_CREATE_FILE => 9087;
use constant EVDISK_ERROR_PORTSET_CANT_WRITE_FILE => 9088;
use constant EVDISK_ERROR_PORTSET_CANT_READ_FILE => 9089;
use constant EVDISK_ERROR_PORTSET_CANT_OPEN_FILE => 9090;
use constant EVDISK_ERROR_LUN_TOO_LARGE => 9091;
use constant EVDISK_ERROR_PORTSET_IC_DOWN => 9092;
use constant EVDISK_ERROR_CLONE_NOT_SPLITTING => 9093;
use constant EVDISK_ERROR_LUN_HAS_NO_SERIAL_NO => 9095;
use constant EVDISK_ERROR_PORTSET_THROTTLE_EXCEEDED => 9096;
use constant EVDISK_ERROR_PORTSET_CANT_DESTROY_BOUND_PORTSET => 9097;
use constant EVDISK_ERROR_CFMODE_MISMATCH => 9098;
use constant EVDISK_ERROR_PORTSET_NOT_VALID_CFMODE => 9099;
use constant EVDISK_ERROR_CANNOT_CHANGE_SPCRES_DURING_SPLIT => 9100;
use constant EVDISK_ERROR_INITGROUP_BIND_WRONG_TYPE => 9101;
use constant EVDISK_ERROR_DB_BAD_INDEX => 9102;
use constant EVDISK_ERROR_DB_NO_SUCH_DATABASE => 9103;
use constant EVDISK_ERROR_ALUA_NOT_SUPPORTED_ON_ISCSI => 9104;
use constant EVDISK_ERROR_ALUA_NOT_SUPPORTED_ON_CFMODE => 9105;
use constant EVDISKMAX => 9199;
use constant EBADHANDLE => 10001;
use constant ENOTSYNC => 10002;
use constant EBADCOOKIE => 10003;
use constant ENOTSUPP => 10004;
use constant ETOOSMALL => 10005;
use constant ESERVERFAULT => 10006;
use constant EBADTYPE => 10007;
use constant EJUKEBOX => 10008;
use constant EWRONGSEC => 10016;
use constant EAPIERROR => 13001;
use constant EAPIAUTHENTICATION => 13002;
use constant EAPIPRIVILEDGE => 13003;
use constant EAPIPRIVILEGE => 13003;
use constant EAPIEXCEPTION => 13004;
use constant EAPINOTFOUND => 13005;
use constant EAPIMISSINGARGUMENT => 13006;
use constant EAPINOTIMPLEMENTED => 13007;
use constant EAPILICENSE => 13008;
use constant EAPIINDEXTOOLARGE => 13009;
use constant EAPIUNSUPPORTEDVERSION => 13010;
use constant EAPITRANSMISSION => 13011;
use constant EOPNOTSUPPORTED => 13012;
use constant EALREADYSTARTED => 13013;
use constant ENOTSTARTED => 13014;
use constant ESERVICENOTSTOPPED => 13015;
use constant ENOTWHILEWAITINGFORGIVEBACK => 13016;
use constant ENOTINMAINTMODE => 13017;
use constant ENOTINREADONLYMODE => 13018;
use constant ESNAPSHOTEXISTS => 13020;
use constant ESNAPSHOTDOESNOTEXIST => 13021;
use constant ESNAPSHOTTOOMANY => 13022;
use constant ESNAPSHOTNOTALLOWED => 13023;
use constant ESNAPSHOTBUSY => 13024;
use constant ESNAPSHOTNOSPACE => 13025;
use constant EVOLUMESNAPRESTOREERROR => 13038;
use constant EVOLUMEQUIESCED => 13039;
use constant EVOLUMEDOESNOTEXIST => 13040;
use constant EVOLUMEMOUNTING => 13041;
use constant EVOLUMEOFFLINE => 13042;
use constant EVOLUMEREADONLY => 13043;
use constant EVOLUMENAMEINVALID => 13044;
use constant EVOLUMERGSIZEINVALID => 13045;
use constant EVOLUMELANGUAGEINVALID => 13046;
use constant EVOLUMEDISKSIZEINVALID => 13047;
use constant EVOLUMEDISKDUP => 13048;
use constant EVOLUMERGINVALID => 13049;
use constant EQUOTAPARSEERROR => 13050;
use constant EQUOTAINVALID => 13051;
use constant EQUOTAEXISTS => 13052;
use constant EQUOTADOESNOTEXIST => 13053;
use constant EQUOTADIRECTIVE => 13054;
use constant EVFILEROPNOTALLOWED => 13070;
use constant EVFILERNOTFOUND => 13071;
use constant EVFILEROPNOTCOMPLETED => 13072;
use constant EIPSPACENOTFOUND => 13073;
use constant EQTREEEXISTS => 13080;
use constant EQTREENOTOWNER => 13081;
use constant EQTREEMAX => 13082;
use constant ECMSINVALIDREQUEST => 13090;
use constant ECMSNOTENABLED => 13091;
use constant ECMSPROCESSINGERROR => 13092;
use constant ESNAPMIRROROFF => 13100;
use constant ESNAPMIRRORPARSERERROR => 13101;
use constant ESNAPMIRRORERROR => 13102;
use constant EISCSISECINVALIDINPUTERROR => 13110;
use constant EISCSISECPROCESSINGERROR => 13111;
use constant EISCSISECINITNOTFOUNDERROR => 13112;
use constant EFILENOTFOUND => 13113;
use constant EINTERNALERROR => 13114;
use constant EINVALIDINPUTERROR => 13115;
use constant ESETSPCRESERROR => 13116;
use constant EADAPTERNOTFOUND => 13122;
use constant EADAPTERPARTNER => 13123;
use constant EADAPTERINVALIDTYPE => 13125;
use constant ENOADAPTERPARTNER => 13126;
use constant ENOVIRTUALADAPTERS => 13127;
use constant ENOTCLUSTERED => 13128;
use constant ECLUSTERED => 13129;
use constant EDISKNOTFOUND => 13150;
use constant ESWAPINPROGRESS => 13151;
use constant ENOTDISKOWNER => 13152;
use constant EDISKINRAIDZEROVOL => 13153;
use constant EDISKISSPARE => 13154;
use constant EVOLUMEPLEXINVALID => 13155;
use constant EVOLUMEINUSE => 13156;
use constant EVOLUMENOTONLINE => 13157;
use constant EVOLUMEBUSY => 13158;
use constant EVOLUMECIFSTERMINATE => 13159;
use constant EVOLUMECREATING => 13160;
use constant ECLIENTSTATSVFILER => 13161;
use constant ECLIENTSTATSNOTENABLED => 13162;
use constant ENOACTIVECLIENTS => 13163;
use constant ECIFSNOTCONFIGURED => 13164;
use constant EDNSNOTENABLED => 13165;
use constant EHOSTNOTFOUND => 13166;
use constant ELDAPSVRNOTFOUND => 13167;
use constant ESVCDISABLED => 13200;
use constant ESVCNOTAVAIL => 13201;
use constant ESHAREACCESSDENIED => 13202;
use constant ESHAREEXISTS => 13203;
use constant ESHARETOOMANY => 13204;
use constant ESANOWNNOTENABLED => 13210;
use constant ECIFSSHARINGVIOLATION => 13210;
use constant EINVALIDHOST => 13211;
use constant EINVALIDOWNERID => 13212;
use constant EINVALIDOWNER => 13213;
use constant EINVALIDPASSWORD => 13214;
use constant EEXPORTSINCOMPATIBLE => 13215;
use constant EINODENUMBERTOOSMALL => 13216;
use constant EINODENUMBERTOOLARGE => 13217;
use constant EINVALIDINODE => 13218;
use constant EINELIGIBLEINODE => 13219;
use constant EPARENTINFONOTLOADED => 13220;
use constant EI2PNOTENABLED => 13221;
use constant ECIFS_LOGIN_FAILED => 13250;
use constant ECIFS_BIND_FAILED => 13251;
use constant ECIFS_DNS_REQUIRED => 13252;
use constant ECIFS_KRB_CONFLICT => 13253;
use constant ECIFS_AD_CLOCK_SKEW => 13254;
use constant ECIFS_AD_RESET_REQUIRED => 13255;
use constant ECIFS_LIST_UNAVAILABLE => 13256;
use constant ECIFS_DC_CONNECT_FAILED => 13257;
use constant EEMS_INVOKE_FAILED => 13301;
use constant EEMS_INVOKE_BAD_PARAM => 13303;
use constant EEMS_INVOKE_ID_BAD => 13310;
use constant EEMS_INVOKE_SEVERITY_REQUIRED => 13311;
use constant EEMS_INVOKE_SEVERITY_INVALID => 13312;
use constant EEMS_INVOKE_SEVERITY_NOT_VARIABLE => 13313;
use constant EEMS_INVOKE_PARAMS_INSUFFICIENT => 13314;
use constant EEMS_INVOKE_VERSION_INVALID => 13315;
use constant EEMS_INVOKE_SUPRESS_DUP => 13316;
use constant EEMS_INVOKE_SUPRESS_TIMER => 13317;
use constant EEMS_INVOKE_NVRAM_TOO_BIG => 13318;
use constant EEMS_INVOKE_QUEUE_FULL => 13319;
use constant EREALLOCATE_EXISTS => 13501;
use constant EREALLOCATE_BADPATH => 13502;
use constant EREALLOCATE_NOMEM => 13503;
use constant EREALLOCATE_NOSCAN => 13504;
use constant EREALLOCATE_BADVOL => 13505;
use constant EREALLOCATE_READONLY => 13506;
use constant EREALLOCATE_BADSCHED => 13507;
use constant EREALLOCATE_OFF => 13508;
use constant EREALLOCATE_SNAPSHOT => 13509;
use constant EDISKNOTSPARE => 13510;
use constant EDISKTOOSMALL => 13511;
use constant ERAIDGROUPDEGRADED => 13512;
use constant ESAVECOREDISK => 13513;
use constant EINVALIDSTATE => 13514;
use constant ENPMINVPLOC => 13600;
use constant ENPMNOPKG => 13601;
use constant ENPMNOMETA => 13602;
use constant ENPMERXMETA => 13603;
use constant EINCRCOPYFAILED => 13604;
use constant EINCRCOPYOPNOTFOUND => 13605;
use constant EINCRCOPYINVALIDUUID => 13606;
use constant EINCRCOPYINVALIDOP => 13607;
use constant EINCRCOPYNOMEM => 13608;
use constant EINCRCOPYINVALIDINPUT => 13609;
use constant EINCRCOPYINVALIDOPTYPE => 13610;
use constant EINCRCOPYDUPLICATESESSION => 13611;
use constant EINCRCOPYNOTSUPPORT => 13612;
use constant EINCRCOPYVOLOFFLINE => 13613;
use constant EINCRCOPYVOLNOTFOUND => 13614;
use constant EINCRCOPYSNAPCREATIONFAIL => 13615;
use constant EINCRCOPYSNAPSHOTEXIST => 13616;
use constant EINCRCOPYNOSTREAMESTABLISHED => 13617;
use constant ECGERROR => 13700;
use constant ECGSNAPERR => 13701;
use constant ECGOFF => 13702;
use constant ECHARMAP_INVALID => 13800;
use constant ECHARMAP_NO_PERSIST => 13801;
use constant ETOERRMIN => 13900;
use constant ESERVICENOTINITIALIZED => 13901;
use constant ESERVICENOTLICENSED => 13902;
use constant ESERVICENOTENABLED => 13903;
use constant EMBOXDEGRADED => 13904;
use constant EMBOXUNKNOWN => 13905;
use constant EMBOXVERSIONMISMATCH => 13906;
use constant EPARTNERDISABLEDTO => 13907;
use constant EOPERATORDENY => 13908;
use constant ENVRAMSIZEMISMATCH => 13909;
use constant EVERSIONMISMATCH => 13910;
use constant EINTERCONNECTERROR => 13911;
use constant EPARTNERBOOTING => 13912;
use constant ESHELFHOT => 13913;
use constant EPARTNERREVERT => 13914;
use constant ELOCALREVERT => 13915;
use constant EPARTNERTRYINGTAKEOVER => 13916;
use constant ETAKEOVERINPROGRESS => 13917;
use constant EHALTNOTAKEOVER => 13918;
use constant EUNSYNCNVRAM => 13919;
use constant EUNKNOWNTAKEOVERERROR => 13920;
use constant EWAITINGFORPARTNER => 13921;
use constant ELOWMEMORY => 13922;
use constant EHALTING => 13923;
use constant EMBOXUNCERTAIN => 13924;
use constant ENOAUTOTAKEOVER => 13925;
use constant EPARTNERNOTWAITING => 13926;
use constant ENOAGGRS => 13927;
use constant ENOTHINGTOTAKEOVER => 13945;
use constant ESENDHOMEINPROGRESS => 13946;
use constant ENVRAMDOWN => 13947;
use constant EINTERCONNECTRESET => 13948;
use constant EBADOPTIONS => 13949;
use constant ENOTHALTED => 13950;
use constant EREVERTINPROGRESS => 13951;
use constant ESERVICEENABLED => 13952;
use constant EINTAKEOVER => 13953;
use constant ETOERRMAX => 13954;
use constant EINVALIDRESERVATION => 14000;
use constant ENODISKSFOUND => 14001;
use constant EMUSTBEINMAINTMODE => 14002;
use constant EFILEEXISTS => 14003;
use constant EJUNCTIONEXISTS => 14004;
use constant EJUNCTIONDOESNOTEXIST => 14005;
use constant EBADFILELENGTH => 14006;
use constant EBADCOREID => 14100;
use constant ESESNOTREADY => 14200;
use constant ESESBUSY => 14201;
use constant ESHAREKEY => 30002;
use constant EICAPSKIP => 40000;

#============= END CUT & PASTE FROM ZapiErrno.pm HERE ==============#

#
# End of ati_errno package
#
1;
