#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/SharedTestBed/ConfigTypes.pm#2 $
#
#Copyright (c) 2002 Network Appliance, Inc.
#All rights reserved.
#
## @summary Definition of implied configuration types

## @description
## This package is meant to define all shared test bed configuration types 
## including implied configuration types.
## This package is used by NATE scripts and by web CGI scripts
## as found in the current ontap main branch.
## This package does not need to include the Tharn package.
## To keep compatibility with all recent ONTAP releases,
## it is best to only introduce new configuration types.
## Removal of existing types may impact test plans that
## include those values.
## @usage
##   use ConfigTypes ;
##
## @author Charlie Hedstrom (hedstrom@netapp.com)
## @keywords configuration type 
## @status public
## @change 2003-06-16 hedstrom: create from config_base.pm
## @change 2003-07-15 hedstrom: add solaris6 & 7 aix5.1ml3 aix5.1ml4
## @change 2003-07-23 hedstrom: add win2k-sp2 win2k-sp3 fe-mcdt6000, brocade fw versions
## drop ha entries that were not real configuration types
## @change 2003-07-23 hedstrom: rename hc-mcsg, imply fs-hfs and fs-vxfs from hpux
## @change 2003-08-12 hedstrom: include host attach kit versions
## @change 2003-08-15 hedstrom: add init-fcp
## @change 2003-08-15 hedstrom: add fcha-ql2312 
## @change 2003-10-07 hedstrom: add R1xx R2xx 
## @change 2003-10-16 hedstrom: pass lists by reference, fix dropped implications from second list 
## @change 2003-10-24 hedstrom: imply all valid file systems from each OS configuration type
## @change 2003-11-14 hedstrom: add ability to imply by prefix values - best used for OS or FW versions detected by testbed_setup
## @change 2004-01-12 hedstrom: add fcha-lsi929x ds-ds14mk2-fc-esh2-1g ds-ds14mk2-fc-esh2-2g ds-ds14mk2-fc-esh4-1g ds-ds14mk2-fc-esh4-2g
## @change 2004-01-14 hedstrom: add filer cpu count implications from the filer model configuration types
## @change 2004-01-21 hedstrom: add unix, h-{protocol} and rename f-toe-no and f-ipsec-no
## @change 2004-01-28 hedstrom: add gateway arrays, GF270c and disk implications for jura and cheetah models
## @change 2004-03-10 hedstrom: add rhas3.0 Fxxx Fxxxc
## @change 2004-03-18 hedstrom: add iscsi-hpux-1.1, imply clustered-no from unclustered
## @change 2004-04-30 hedstrom: add cfmode-ssi, disk drives: X237 X272 X274 X276
## @change 2004-06-04 hedstrom: add iscsi-hpux- as a config type prefix
## @change 2004-07-16 hedstrom: Netcache services
## @change 2004-09-03 hedstrom: suse8.0sp3 suse9.0
## @change 2004-09-24 hedstrom: add filer disk shelf config types, solaris10
## @change 2004-09-29 hedstrom: add fedora
## @change 2004-10-12 hedstrom: add atm support
## @change 2004-10-18 bringazi: add deux-filer and deux-netcache support
## @change 2004-10-18 hedstrom: tweaked deux support
## @change 2004-10-19 hedstrom: add iscsi-aix-5.3 and deux models
## @change 2004-11-08 hedstrom: f-nvram, target HBAs: ql2362 ql2462
## @change 2004-11-29 hedstrom: v-extents h-iscsi-mcs
## @change 2004-12-15 hedstrom: ap-silktest tar-iscsi-hw
## @change 2005-01-17 hedstrom: fcpu-i386-elf, sim-filer
## @change 2005-01-26 hedstrom: rhas and rhel prefix values
## @change 2005-03-07 hedstrom: wm (windows media) and sanlun-2.1
## @change 2005-03-09 hedstrom: mcdt4300
## @change 2005-03-15 hedstrom: hdmp
## @change 2005-04-14 hedstrom: expand Windows versions, add mac
## @change 2005-06-01 hedstrom: add defined fcp and iscsi burt releases
## @change 2005-06-02 hedstrom: R210
## @change 2005-06-09 hedstrom: rhes, tar-hba-qle2462, X600 X700, fix implications past 3 levels
## @change 2005-06-13 hedstrom: init-hba-em10000
## @change 2005-06-15 hedstrom: d-fw f-fw (to allow all disk controller and ontap (OFW and CFE) versions
## @change 2005-06-21 hedstrom: f-iscsi-merl f-iscsi-mcs
## @change 2005-06-27 hedstrom: EXCELSIOR
## @change 2005-06-28 hedstrom: NIC config types
## @change 2005-07-19 hedstrom: more NIC config types
## @change 2005-07-20 hedstrom: add testbed_unimplied_config_types function
## @change 2005-07-21 hedstrom: set final Excelsior filer model names
## @change 2005-07-25 hedstrom: Add IBM filer models see: http://web.netapp.com/engineering/design-depot/hw_platforms/projects/Deux/IBM/IBM-Deux%20Branding%2008jun05.pdf
## @change 2005-08-26 hedstrom: FAS6xxx FAS6xxxc
## @change 2005-09-07 hedstrom: replace fcpu-amd64 with fcpu-x86-64
## @change 2005-09-26 hedstrom: fedora4, IBM machine types
## @change 2005-10-05 hedstrom: f-rlm, implement regex support for config type "prefix" definitions
## @change 2005-10-25 hedstrom: fcha, dd-max* definitions, fix unclustered -> cluster-no
## @change 2005-11-23 hedstrom: rsh-root
## @change 2005-12-13 hedstrom: FAS2020 FAS2020c FAS2050 FAS2050c FAS2xxx FAS2xxxc
## @change 2006-01-12 hedstrom: S500 (first Puma filer), h-nfsv2 h-nfsv2-no nfsv2 nfsv3 nfsv4
## @change 2006-01-25 hedstrom: ds-fcx ds-scm2 ds-sas sha-sas3800e sha-sas3800x 
## @change 2006-02-02 hedstrom: IBM filer cluster models 
## @change 2006-02-14 hp: Cheetah3 disk drives 
## @change 2006-03-21 hedstrom: solaris\d+-(32|64), Drop solaris+win combined config types
## @change 2006-08-04 hedstrom: support descriptions and sub types
## @change 2006-08-28 hedstrom: drop DAFS support
## @change 2006-09-19 hedstrom: Shuar V-series filers from: 
## http://web.netapp.com/engineering/projects/Shuar/Overview/Config_Chart_v1.12.xls
## @change 2006-10-18 hedstrom: IBM DrWho filer model N5600: 
## http://web.netapp.com/engineering/projects/IBM_Release5/Contents_List/old%20functional%20specs%20R5/IBM%20N5600%20Prod%20Spec%20Plat%20HW%20old.doc
## @change 2006-11-10 hedstrom: add ntap. and ontap. prefixed client config types 
## @change 2007-01-16 hedstrom: add Excalibur models FAS6040 FAS6080, disk types galaxy, seagate15k 
## @change 2007-02-22 hedstrom: support QLE2464, FAS2010 and SPARC instruction set  
## @change 2007-03-02 hedstrom: support X1008A-R6 Dual TOE-10G Ethernet Controller (T320E-XFP)  
## @change 2007-09-20 hedstrom: Add Hitachi Gemini disk support
## @change 2007-10-29 hedstrom: Add EXCALIBUR and fix filer A suffix to imply c (clustered)
 
use strict;

package SharedTestBed::ConfigTypes;

use vars qw(@ISA @EXPORT
   );

require Exporter;
@ISA = ('Exporter');

@EXPORT = qw(
    append_unique_config
    testbed_config_data
    testbed_config_self_test
    testbed_config_subtypes
    testbed_config_type_check
    testbed_config_types
    testbed_implied_config_types
    testbed_testplan_config_types
    testbed_unimplied_config_types
    );

use English qw(-no_match_vars);
use Carp;

sub testbed_config_data ($);
sub testbed_config_self_test();
sub testbed_config_types(@);
sub testbed_implied_config_types($$);
sub testbed_unimplied_config_types($); 

# These valid configuration type values are defined at
# As of 10/18/2004 Valid config types are defined at:
#   http:/eng-web.corp.netapp.com/qa/process/config_types.html
# See NetApp Filer Models at:
# http://web.netapp.com/engineering/platformsw/Documentation/xref/xref.htm
# IBM machine type configtypes in the form IBM-nnnn-xxx 
#
# Each config type has:
# a name - the key to this hash
# an array of values:
# a description string
# a array of implied config types 
# a SQL LIKE clause to retrieve existing sub configuration types
my %valid_configs = (
    '-all-'                 => ["All configuration types",[]],
    '-all-client-'          => ["All client categories",['client','-all-']],
    '-all-client-aps-'      => ["Host/Client Applications",['-all-client-']],
    '-all-client-bios-'     => ["Host/Client BIOS vendors",['-all-client-']],
    '-all-client-cpu-'      => ["Host/Client CPU types",['-all-client-']],
    '-all-client-cpus-'     => ["Host/Client CPU counts",['-all-client-']],
    '-all-client-fixes-'    => ["Host/Client Software Fixes",['-all-client-'],'h-fix-%'],
    '-all-client-hbas-'     => ["Host/Client Host Bus Adapters",['-all-client-']],
    '-all-client-ntap-'     => ["Host/Client NetApp Software",['-all-client-']],
    '-all-client-test-'     => ["Host/Client Test Tools",['-all-client-']],
    '-all-client-os-'       => ["Host/Client Operating Systems",['-all-client-']],
    '-all-client-manufacturers-' => ["Host/Client Manufacturers",['-all-client-']],
    '-all-filer-'           => ["All filer categories",['-all-']],
    '-all-filer-cfo-'       => ["All filer CFO attributes",['-all-filer-']],
    '-all-filer-families-'  => ["All filer families",['-all-filer-']],
    '-all-filer-firmware-'  => ["All filer firmware versions",['-all-filer-']],
    '-all-filer-iscsi-'     => ["All filer iSCSI attributes",['-all-filer-']],
    '-all-filer-network-protocols-' => ["All filer network protocols",['-all-filer-']],
    '-all-filer-nics-'      => ["All filer nics",['-all-filer-']],
    '-all-filer-platforms-' => ["All filer platforms",['-all-filer-']],
    '-all-filer-services-'  => ["All filer licensed services",['-all-filer-']],
    '-all-filer-storage-'   => ["All filer storage attributes",['-all-filer-']],
    '-all-filer-storage-disk-parts-'  => ["All filer disk part numbers",['-all-filer-storage-'],"X___"],
    '-all-filer-storage-disk-layouts-' => ["All filer disk layouts",['-all-filer-storage-']],
    '-all-filer-storage-diskfamilies-' => ["All filer disk drives",['-all-filer-storage-']],
    '-all-filer-storage-diskloops-' => ["All filer disk loops",['-all-filer-storage-']],
    '-all-filer-storage-diskshelves-' => ["All filer disk shelves",['-all-filer-storage-']],
    '-all-filer-storage-diskcontroller-firmware-' => ["All filer disk controller firmware",['-all-filer-storage-']],
    '-all-filer-storage-fchafamilies-' => ["All filer fiber channel adapters",['-all-filer-storage-']],
    '-all-filer-volume-attributes-' => ["All filer volume attributes",['-all-filer-']],
    '-all-netcache-'        => ["All NetCache categories",['-all-']],
    '-all-netcache-families-' => ["All NetCache Families",['-all-netcache-']],
    '-all-switch-'          => ["All switch categories",['-all-']],
    '-all-switch-manufacturers-' => ["All switch manufacturers",['-all-switch-']],
    '-all-switch-be-'       => ["All back-end switch categories",['-all-']],
    '-all-switch-be-manufacturers-' => ["All back-end switch manufacturers",['-all-switch-be-']],
    '-all-testbed-'         => ["All test bed categories",['-all-']],
    
    'advanced-sis'=> ["Filer advanced_sis deduplication service",['-all-filer-services-']],
    'aix'         => ["Client with AIX operating system",['unix','fs-jfs','fs-jfs2','rawio']],
    'ap-oracle'   => ["Client with Oracle",['-all-client-aps-']],
    'ap-silktest' => ["Client with SilkTest",['-all-client-test-']],
    'b-bcs' => ["Filer disk drive with block checksums",['-all-filer-storage-disk-layouts-']],
    'b-zcs' => ["Filer disk drive zero checksums",['-all-filer-storage-disk-layouts-']],
    'be'          => ["Filer back-end switch",[]],
    'be-brcd'     => ["Back-end Brocade switches",['be','-all-switch-be-manufacturers-']],
    'be-brcd3xxx' => ["Back-end Brocade 3xxx back-end switches",['be-brcd']],
    'be-brcd3200' => ["Back-end Brocade 3200 back-end switch",['be-brcd3xxx']],
    'be-brcd3250' => ["Back-end Brocade 3250 switch",['be-brcd3xxx']],
    'be-brcd3800' => ["Back-end Brocade 3800 switch",['be-brcd3xxx']],
    'be-brcd3850' => ["Back-end Brocade 3850 switch",['be-brcd3xxx']],
    'be-brcd3900' => ["Back-end Brocade 3900 switch",['be-brcd3xxx']],
    'be-brcd12k'  => ["Back-end Brocade 12000 switch",['be-brcd']],
    'be-csco'     => ["Back-end Cisco switches",['be','-all-switch-be-manufacturers-']],
    'be-csco9xxx' => ["Back-end Cisco 9xxx switches",['be-csco']],
    'be-csco9020' => ["Back-end Cisco 9020 switch",['be-csco9xxx']],
    'be-csco9120' => ["Back-end Cisco 9120 switch",['be-csco9xxx']],
    'be-csco9124' => ["Back-end Cisco 9124 switch",['be-csco9xxx']],
    'be-csco9134' => ["Back-end Cisco 9134 switch",['be-csco9xxx']],
    'be-csco9140' => ["Back-end Cisco 9140 switch",['be-csco9xxx']],
    'be-csco9216' => ["Back-end Cisco 9216 switch",['be-csco9xxx']],
    'be-csco9222' => ["Back-end Cisco 9222 switch",['be-csco9xxx']],
    'be-csco9509' => ["Back-end Cisco 9509 switch",['be-csco9xxx']],
    'be-csco9513' => ["Back-end Cisco 9513 switch",['be-csco9xxx']],
    'be-mcdt'     => ["Back-end McData switches",['be','-all-switch-be-manufacturers-']],
    'be-mcdt4xxx' => ["Back-end McData 4xxx switches",['be-mcdt']],
    'be-mcdt4300' => ["Back-end McData 4300 switch",['be-mcdt4xxx']],
    'be-mcdt4500' => ["Back-end McData 4500 switch",['be-mcdt4xxx']],
    'be-mcdt6xxx' => ["Back-end McData 6xxx switches",['be-mcdt']],
    'be-mcdt6064' => ["Back-end McData 6064 switch",['be-mcdt6xxx']],
    'be-mcdt6140' => ["Back-end McData 6140 switch",['be-mcdt6xxx']],
    'brcd'        => ["Switches made by Brocade",['-all-switch-manufacturers-']],
    'brcd-'       => ["Switch firmware versions, Brocade",['-all-switch-'],'brcd-v%'],
    
    'Cxx'    => ["Cxx family Netcache",['-all-netcache-families-','netcache']],
    'Cxxx'   => ["Cxxx family Netcache",['-all-netcache-families-','netcache']],
    'Cxxxx'  => ["Cxxxx family Netcache",['-all-netcache-families-','netcache']],
    'C85'    => ["C85 Netcache",['Cxx','fcpus-1']],
    'C87'    => ["C87 Netcache",['Cxx','fcpus-1']],
    'C720'   => ["C720 Netcache",['C7xx','fcpus-1']],
    'C720s'  => ["C720s Netcache",['C7xx','fcpus-1']],
    'C760'   => ["C760 Netcache",['C7xx','fcpus-1']],
    'C7xx'   => ["C7xx family Netcache",['Cxxx','fcpus-1']],
    'C1100'  => ["C1100 Netcache",['Cxxxx','fcpus-1']],
    'C1100B' => ["C1100B Netcache",['Cxxxx','fcpus-1']],
    'C1105'  => ["C1105 Netcache",['Cxxxx','fcpus-1']],
    'C1200'  => ["C1200 Netcache",['Cxxxx','fcpus-1']],
    'C2100'  => ["C2100 Netcache",['Cxxxx','fcpus-1']],
    'C2300'  => ["C2300 Netcache",['deux-netcache','fcpus-1']],
    'C3100'  => ["C3100 Netcache",['Cxxxx','fcpus-1']],
    'C3300'  => ["C3300 Netcache",['deux-netcache','fcpus-1']],
    'C6100'  => ["C6100 Netcache",['Cxxxx','fcpus-1']],
    'C6200'  => ["C6200 Netcache",['Cxxxx','fcpus-1']],
    'C6300'  => ["C6300 Netcache",['deux-netcache','fcpus-1']],
    
    'cfmode-dual-fabric'             => ["FCP dual_fabric cluster failover mode",['-all-filer-cfo-']],
    'cfmode-mixed'                   => ["FCP mixed cluster failover mode",['-all-filer-cfo-']],
    'cfmode-partner'                 => ["FCP partner cluster failover mode",['-all-filer-cfo-']],
    'cfmode-single-image'            => ["FCP single_image cluster failover mode",['-all-filer-cfo-']],
    'cfmode-standby'                 => ["FCP standby cluster failover mode",['-all-filer-cfo-']],
    
    'cifs'                           => ["Filer CIFS license is available",['-all-filer-network-protocols-']],
    'nocifs'                         => ["Filer CIFS service NOT allowed",['-all-filer-network-protocols-']],
    'client'                  => ["Any client host"],
    'cluster'                        => ["Filer has a partner",['-all-filer-cfo-']],
    'cluster-no'                     => ["Filer has no partner",['-all-filer-cfo-']],
    'nocluster'                      => ["Filer Cluster service NOT allowed",['-all-filer-cfo-']],
    'unclustered'                    => ["Filer that is not clustered",['cluster-no']],
    'cluster-remote'                 => ["Metro-cluster is licensed",['-all-filer-cfo-']],
    'nocluster-remote'               => ["Metro-cluster NOT allowed",['-all-filer-cfo-']],
    'clustered'                      => ["Filer has a partner or a remote partner",['-all-filer-cfo-']],
    'notclustered'                   => ["Filer has neither a partner nor a remote partner",['-all-filer-cfo-']],
    'com-e'                          => ["NetCache com-e service",['nc-services-']],
    'csco6500'                       => ["",[]],
    
    'd-ata'                          => ["ATA/IDE Disk controller firmware versions",['-all-filer-storage-diskcontroller-firmware-'],"d-ata-%"],
    'd-fw-'                          => ["Disk controller firmware versions",['-all-filer-storage-diskcontroller-firmware-'],"d-fw-%"],
    'dd-cheetah3'                    => ["Seagate Cheetah-3",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah4'                    => ["Seagate Cheetah-4",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah5'                    => ["Seagate Cheetah-5",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah6'                    => ["Seagate Cheetah-6",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah7'                    => ["Seagate Cheetah-7",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah15k3'                 => ["Seagate Cheetah-x15k3",['-all-filer-storage-diskfamilies-']],
    'dd-cheetah15k4'                 => ["Seagate Cheetah-x15k4",['-all-filer-storage-diskfamilies-']],
    'dd-cuda'                        => ["Seagate Baracuda",['-all-filer-storage-diskfamilies-']],
    'dd-dec'                         => ["DEC branded drive",['-all-filer-storage-diskfamilies-']],
    'dd-fal9'                        => ["Fujitsu Alegro 9",['dd-fujitsu']],
    'dd-fal10'                       => ["Fujitsu Alegro 10",['dd-fujitsu']],
    'dd-fujitsu'                     => ["Fujitsu branded drive",['-all-filer-storage-diskfamilies-']],
    'dd-galaxy'                      => ["Galaxy",['-all-filer-storage-diskfamilies-']],
    'dd-moose'                       => ["Seagate Moose",['-all-filer-storage-diskfamilies-']],
    'dd-gemi'                        => ["Hitachi-Gemini",['-all-filer-storage-diskfamilies-']],
    'dd-hkuro'                       => ["Hitachi Kurofone II",['-all-filer-storage-diskfamilies-']],
    'dd-hkuro-sas'                   => ["Hitachi Kurofone II - SAS",['-all-filer-storage-diskfamilies-']],
    'dd-hpyta'                       => ["Hitachi Python Rev a",['-all-filer-storage-diskfamilies-']],
    'dd-ibm'                         => ["IBM branded drive",['-all-filer-storage-diskfamilies-']],
    'dd-jura-d'                      => ["Hitachi-Jura-D",['-all-filer-storage-diskfamilies-']],
    'dd-jura-e'                      => ["Hitachi-Jura-E",['-all-filer-storage-diskfamilies-']],
    'dd-jura-f'                      => ["Hitachi-Jura-F",['-all-filer-storage-diskfamilies-']],
    'dd-viper-b'                     => ["Hitachi-Viper-B",['-all-filer-storage-diskfamilies-']],
    'dd-viper-b-plus'                => ["Hitachi-Viper-B Plus",['-all-filer-storage-diskfamilies-']],
    'dd-maxcaly'                     => ["Maxtor Calypso drive",['-all-filer-storage-diskfamilies-']],
    'dd-maxsabr'                     => ["Maxtor Sabre drive",['-all-filer-storage-diskfamilies-']],
    'dd-maxtom'                      => ["Maxtor TOMCAT drive",['-all-filer-storage-diskfamilies-']],
    'dd-maxtor'                      => ["Maxtor branded drive",['-all-filer-storage-diskfamilies-']],
    'dd-maxgriz'                     => ["Maxtor Grizzly drive",['-all-filer-storage-diskfamilies-']],
    'dd-maxgriz-sas'                 => ["Maxtor Grizzly drive - SAS",['-all-filer-storage-diskfamilies-']],
    'dd-seagate'                     => ["Seagate branded drive",['-all-filer-storage-diskfamilies-']],
    'dd-seagate15k'                  => ["Seagate Timberland 15K drive",['-all-filer-storage-diskfamilies-']],
    'dd-stonk'                       => ["Seagate Tonka drive",['-all-filer-storage-diskfamilies-']],
    'dd-stonk-sas'                   => ["Seagate Tonka drive - SAS",['-all-filer-storage-diskfamilies-']],
    'dd-unisys'                      => ["UNISYS branded drive",['-all-filer-storage-diskfamilies-']],
    'dell5224'                       => ["",[]],
    'deux'                           => ["Deux platform filers and netcaches",['-all-filer-platforms-']],
    'deux-filer'                     => ["Deux platform filers",['deux']],
    'deux-filer-hi'                  => ["Deux platform high-range filers",['deux-filer']],
    'deux-filer-mid'                 => ["Deux platform mid-range filers",['deux-filer']],
    'deux-netcache'                  => ["Deux platform netcaches",['netcache','deux','Cxxxx']],
    'deux-filer-no'                  => ["Non Deux platform filers",[]],
    'deux-no'                        => ["Non Deux platforms",['-all-filer-platforms-']],
    'disk-sanitization'              => ["Filer disk_sanitization service",['-all-filer-services-']],
    'dl-'                            => ["Filer disk loops",['-all-filer-storage-diskloops-']],
    'dl-dual'                        => ["At least one redundant FC disk loop is present on this filer",['dl-']],
    'dl-dualonly'                    => ["Only redundant FC disk loops are present on this filer",['dl-','dl-dual']],
    'dl-single'                      => ["At least one non-redundant FC disk loop is present on this filer",['dl-']],
    'dl-singleonly'                  => ["Only non-redundant FC disk loops are present on this filer",['dl-','dl-single']],
    'dmp-mpio'           => ["IBM AIX Multi-Path I/O, or Windows MPIO",['hdmp']],
    'dmp-mpxio'          => ["Solaris Multi-Path I/O",['hdmp']],
    'dmp-mpxio-fcpalua'  => ["Solaris Multi-Path I/O with FCP ALUA",['dmp-mpxio']],
    'dmp-pvlinks'        => ["HP DMP",['hdmp']],
    'dmp-sanpath'        => ["Dot Hill System Corp SANpath",['hdmp']],
    'dmp-vxvm'           => ["Veritas VxVM with DMP",['hdmp']],
    'drwho'                          => ["Dr Who platform filers and netcaches",['-all-filer-platforms-']],
    'drwho-filer'                    => ["Dr Who platform filers",['drwho']],
    'drwho-no'                       => ["Non Dr Who platforms",['-all-filer-platforms-']],
    
    'ds-ata'                => ["Filer ATA disk shelves",['-all-filer-storage-diskshelves-']],
    'ds-ata-no'             => ["Filer ATA disk shelves not present",['-all-filer-storage-diskshelves-']],
    'ds-ds14'               => ["Any of the DS14 mk1 disk shelves ",[]],  # deprecated by ds-ds14-fc
    'ds-ds14-esh'           => ["Xyratex DS14 Shelf with ESH Controllers",['ds-ds14-fc']],
    'ds-ds14-esh2'          => ["Xyratex DS14 Shelf with ESH2 Controllers",['ds-ds14-fc']],
    'ds-ds14-esh4'          => ["Xyratex DS14 Shelf with ESH4 Controllers",['ds-ds14-fc']],
    'ds-ds14-fc'            => ["Any of the DS14-FC mk1 disk shelves ",['ds-fc','ds-ds14']],
    'ds-ds14-lrc'           => ["Xyratex DS14 Shelf with LRC Controllers",['ds-ds14-fc']],
    'ds-ds14mk2-at'         => ["Xyratex DS14Mk2-AT Shelf",['ds-ata']],
    'ds-ds14mk2-at-fcx'     => ["Xyratex DS14Mk2-AT Shelf with Jake Controllers",['ds-ds14mk2-at']],
    'ds-ds14mk2-at-scm'     => ["Xyratex DS14Mk2-AT Shelf with SCM Controller",['ds-ds14mk2-at']],
    'ds-ds14mk2-at-scm2'    => ["Xyratex DS14Mk2-AT Shelf with SCM2 Controller",['ds-ds14mk2-at']],
    'ds-ds14mk2-fc'         => ["Any of the DS14Mk2-FC disk shelves",['ds-fc']],
    'ds-ds14mk2-fc-esh'     => ["Xyratex DS14Mk2-FC Shelf with ESH Controllers",['ds-ds14mk2-fc']],
    'ds-ds14mk2-fc-esh2'    => ["Xyratex DS14Mk2-FC Shelf with ESH2 Controllers",['ds-ds14mk2-fc']],
    'ds-ds14mk2-fc-esh4'    => ["Xyratex DS14Mk2-FC Shelf with ESH4 Controllers",['ds-ds14mk2-fc']],
    'ds-ds14mk2-fc-lrc'     => ["Xyratex DS14Mk2-FC Shelf with LRC Controllers",['ds-ds14mk2-fc']],
    'ds-ds14mk4-fc'         => ["Any of the DS14Mk4-FC disk shelves",[]],
    'ds-ds14mk4-fc-esh'     => ["Xyratex DS14Mk4-FC Shelf with ESH Controllers",['ds-ds14mk4-fc']],
    'ds-ds14mk4-fc-esh2'    => ["Xyratex DS14Mk4-FC Shelf with ESH2 Controllers",['ds-ds14mk4-fc']],
    'ds-ds14mk4-fc-esh4'    => ["Xyratex DS14Mk4-FC Shelf with ESH4 Controllers",['ds-ds14mk4-fc']],
    'ds-ds14mk4-fc-lrc'     => ["Xyratex DS14Mk4-FC Shelf with LRC Controllers",['ds-ds14mk4-fc']],
    'ds-ds24-sas'           => ["Any of the Netapp DS24 Shelves",['ds-sas']],
    'ds-ds24-sas-iom'       => ["Netapp DS24 Shelf with IOM Controllers",['ds-ds24-sas']],
    'ds-edm'                => ["XL400 (Eurologic EDM) Shelf (was ds-xl400)",['ds-fc']],
    'ds-efh'                => ["Xyratex DS14 Shelf with Tsantsa or Jivaros module",['ds-fc']],
    'ds-esh'                => ["Any shelf with ESH Controllers",['ds-fc']],
    'ds-esh-fw'             => ["ESH Controller firmware versions",['-all-filer-storage-diskcontroller-firmware-']],
    'ds-esh2'               => ["Any shelf with ESH2 Controllers",['ds-fc']],
    'ds-esh2-fw'            => ["ESH2 Controller firmware versions",['-all-filer-storage-diskcontroller-firmware-']],
    'ds-esh4'               => ["Any shelf with ESH4 Controllers",['ds-fc']],
    'ds-esh4-fw'            => ["ESH4 Controller firmware versions",['-all-filer-storage-diskcontroller-firmware-']],
    'ds-fc'                 => ["Filer FC disk shelves",['-all-filer-storage-diskshelves-']],
    'ds-fcx'                => ["Any shelf with Jake Controllers",['ds-ata']],
    'ds-iom'                => ["Any shelf with IOM Controllers",['ds-sas']],
    'ds-lrc'                => ["Any shelf with LRC Controllers",['ds-fc']],
    'ds-r1xx'               => ["R1XXShelf Shelf",['ds-fc']],
    'ds-sas'                => ["Filer SAS disk shelves",['-all-filer-storage-diskshelves-']],
    'ds-scm'                => ["Any shelf with SCM Controller",['ds-ata']],
    'ds-scm2'               => ["Any shelf with SCM2 Controller",['ds-ata']],
    'ds-vem'                => ["XL500 Shelf (was ds-xl500)",['ds-fc']],

    'EXCALIBUR'                      => ["Excalibur platform filers",['-all-filer-platforms-']],
    'EXCALIBURc'                     => ["Excalibur platform clustered filers",['EXCALIBUR']],
    'EXCELSIOR'                      => ["Excelsior platform filers and netcaches",['-all-filer-platforms-']],
    'EXCELSIOR-no'                   => ["Non Excelsior platforms",['-all-filer-platforms-']],
    'EXCELSIORc'                     => ["Excelsior platform clustered filers",['EXCELSIOR']],
    'EXP200'                         => ["IBM TotalStorage EXP200 Expansion Unit (ATA)",['ds-ds14mk2-at']],
    'EXP600'                         => ["IBM TotalStorage EXP600 Expansion Unit (FC)",['ds-ds14mk2-fc']],

    'Fxx'      => ["Fxx family filer",['filer']],
    'F8x'      => ["F8x family filer",['Fxx','-all-filer-families-']],
    'F85'      => ["F85",['F8x','fcpus-1']],
    'F87'      => ["F87",['F8x','fcpus-1']],
    'Fxxx'     => ["Fxxx family filer",['filer']],
    'Fxxxc'    => ["Fxxx family clustered filer",['filer']],
    'F7xx'     => ["F7xx family filer",['Fxxx','-all-filer-families-']],
    'F7xxc'    => ["F7xx family clustered filer",['Fxxxc','-all-filer-families-']],
    'F720'     => ["F720",['F7xx','fcpus-1']],
    'F720c'    => ["F720 Cluster",['F720','F7xxc']],
    'F740'     => ["F740",['F7xx','fcpus-1']],
    'F740c'    => ["F740 Cluster",['F740','F7xxc']],
    'F760'     => ["F760",['F7xx','fcpus-1']],
    'F760c'    => ["F760 Cluster",['F760','F7xxc']],
    'F8xx'     => ["F8xx family filer",['Fxxx','-all-filer-families-']],
    'F8xxc'    => ["F8xx family clustered filer",['Fxxxc','-all-filer-families-']],
    'F810'     => ["F810",['F8xx','fcpus-1']],
    'F810c'    => ["F810 Cluster",['F810','F8xxc']],
    'F820'     => ["F820",['F8xx','fcpus-1']],
    'F820c'    => ["F820 Cluster",['F820','F8xxc']],
    'F825'     => ["F825",['F8xx','fcpus-1']],
    'F825c'    => ["F825 Cluster",['F825','F8xxc']],
    'F840'     => ["F840",['F8xx','fcpus-1']],
    'F840c'    => ["F840 Cluster",['F840','F8xxc']],
    'F880'     => ["F880",['F8xx','fcpus-2']],
    'F880c'    => ["F880 Cluster",['F880','F8xxc']],
    'FASxxx'   => ["FASxxx family filer",['filer']],
    'FASxxxc'  => ["FASxxx family clustered filer",['filer']],
    'FAS2xx'   => ["FAS2xx family filer",['FASxxx','-all-filer-families-']],
    'FAS2xxc'  => ["FAS2xx family clustered filer",['FASxxxc','-all-filer-families-']],
    'FAS250'   => ["FAS250",['FAS2xx','fcpus-2']],
    'FAS270'   => ["FAS270",['FAS2xx','fcpus-2']],
    'FAS270c'  => ["FAS270 Cluster",['FAS270','FAS2xxc']],
    'FAS9xx'   => ["FAS9xx family filer",['FASxxx','-all-filer-families-']],
    'FAS9xxc'  => ["FAS9xx family clustered filer",['FASxxxc','-all-filer-families-']],
    'FAS920'   => ["FAS920",['FAS9xx','fcpus-1']],
    'FAS920c'  => ["FAS920 Cluster",['FAS920','FAS9xxc']],
    'FAS940'   => ["FAS940",['FAS9xx','fcpus-1']],
    'FAS940c'  => ["FAS940 Cluster",['FAS940','FAS9xxc']],
    'FAS960'   => ["FAS960",['FAS9xx','fcpus-2']],
    'FAS960c'  => ["FAS960 Cluster",['FAS960','FAS9xxc']],
    'FAS980'   => ["FAS980",['FAS9xx','fcpus-4']],
    'FAS980c'  => ["FAS980 Cluster",['FAS980','FAS9xxc']],
    'FASxxxx'  => ["FASxxxx family filer",['filer']],
    'FASxxxxc' => ["FASxxxx family clustered filer",['filer']],
    'FAS2xxx'  => ["FAS2xxx family filer",['FASxxxx','-all-filer-families-']],
    'FAS2xxxc' => ["FAS2xxx family clustered filer",['FASxxxxc','-all-filer-families-']],
    'FAS2010'  => ["FAS2010",['FAS2xxx','fcpus-1','shuar-filer']],
    'FAS2010c' => ["FAS2010 Cluster",['FAS2010','FAS2xxxc']],
    'FAS2020'  => ["FAS2020",['FAS2xxx','fcpus-1','shuar-filer']],
    'FAS2020c' => ["FAS2020 Cluster",['FAS2020','FAS2xxxc']],
    'FAS2050'  => ["FAS2050",['FAS2xxx','fcpus-1','shuar-filer']],
    'FAS2050c' => ["FAS2050 Cluster",['FAS2050','FAS2xxxc']],
    'FAS2240-2' => ["FAS2240-2",['FAS2xxx']],
    'FAS2240-2c' => ["FAS2240-2 Cluster",['FAS2240-2','FAS2xxxc']],
    'FAS3xxx'  => ["FAS3xxx family filer",['FASxxxx','-all-filer-families-']],
    'FAS3xxxc' => ["FAS3xxx family clustered filer",['FASxxxxc','-all-filer-families-']],
    'FAS3020'  => ["FAS3020",['FAS3xxx','fcpus-1','deux-filer']],
    'FAS3020c' => ["FAS3020 Cluster",['FAS3020','FAS3xxxc']],
    'FAS3030'  => ["FAS3030",['FAS3xxx','fcpus-2']],
    'FAS3030c' => ["FAS3030 Cluster",['FAS3030','FAS3xxxc']],
    'FAS3040'  => ["FAS3040",['FAS3xxx','fcpus-2']],
    'FAS3040c' => ["FAS3040 Cluster",['FAS3040','FAS3xxxc']],
    'FAS3050'  => ["FAS3050",['FAS3xxx','fcpus-2','deux-filer']],
    'FAS3050-M'=> ["FAS3050-M",['FAS3xxx','fcpus-2','deux-filer']],
    'FAS3050c' => ["FAS3050 Cluster",['FAS3050','FAS3xxxc']],
    'FAS3070'  => ["FAS3070",['FAS3xxx','fcpus-2','drwho-filer']],
    'FAS3070c' => ["FAS3070 Cluster",['FAS3070','FAS3xxxc']],
    'FAS3140'  => ["FAS3140",['FAS3xxx','SPECTRE-l']],
    'FAS3140A' => ["FAS3140",['FAS3140c']],
    'FAS3140c' => ["FAS3140 Cluster",['FAS3140','FAS3xxxc']],
    'FAS3170'  => ["FAS3170",['FAS3xxx','SPECTRE-h']],
    'FAS3170A' => ["FAS3170",['FAS3170c']],
    'FAS3170c' => ["FAS3170 Cluster",['FAS3170','FAS3xxxc']],
    'FAS6xxx'  => ["FAS6xxx family filer",['FASxxxx','-all-filer-families-']],
    'FAS6xxxc' => ["FAS6xxx family clustered filer",['FASxxxxc','-all-filer-families-']],
    'FAS6030'  => ["FAS6030",['FAS6xxx','fcpus-2','EXCELSIOR']],
    'FAS6030A' => ["FAS6030",['FAS6030c']],
    'FAS6030c' => ["FAS6030 Cluster",['FAS6030','FAS6xxxc','EXCELSIORc']],
    'FAS6040'  => ["FAS6040",['FAS6xxx','fcpus-2','EXCALIBUR']],
    'FAS6040A' => ["FAS6040",['FAS6040c']],
    'FAS6040c' => ["FAS6040 Cluster",['FAS6040','FAS6xxxc']],
    'FAS6070'  => ["FAS6070",['FAS6xxx','fcpus-4','EXCELSIOR']],
    'FAS6070A' => ["FAS6070",['FAS6070c']],
    'FAS6070c' => ["FAS6070 Cluster",['FAS6070','FAS6xxxc','EXCELSIORc']],
    'FAS6080'  => ["FAS6080",['FAS6xxx','fcpus-8','EXCALIBUR']],
    'FAS6080A' => ["FAS6080",['FAS6080c']],
    'FAS6080c' => ["FAS6080 Cluster",['FAS6080','FAS6xxxc','EXCALIBURc']],

    'f-accel'          => ["NetApp Accelerator Cards",['-all-filer-cfo-']],
    'f-accel-no'       => ["NetApp Accelerator cards NOT present",['-all-filer-cfo-']],
    'f-accel-fpga-'    => ["NetApp Accelerator FPGA Releases",['f-accel-']],
    'f-accel-fpgab-'   => ["NetApp Accelerator FPGA Builds",['f-accel-']],
    'f-accel-rev-'     => ["NetApp Accelerator Board Revisions",['f-accel-']],
    'f-accel-size-'    => ["NetApp Accelerator memory sizes",['f-accel-']],
    'f-atm'                          => ["Filer ATM NICs",['-all-filer-nics-']],
    'f-atm-no'                       => ["Filer ATM NICs NOT present",['-all-filer-nics-']],
    'f-atm-x1201'                    => ["ATM 155 Mb UTP",['f-atm']],
    'f-atm-x1202'                    => ["ATM 155 Mb UTP",['f-atm']],
    'f-atm-x1203'                    => ["ATM OC-12",['f-atm']],

    'f-eth-'                          => ["Filer Ethernet NICs",['-all-filer-nics-']],
    'f-eth-speed-' => ["Filer Ethernet NICs by speed",['f-eth-']],
    'f-eth-100m'   => ["Filer Ethernet NIC - 100 M bits/sec",['f-eth-speed-']],
    'f-eth-1g'     => ["Filer Ethernet NIC - 1 Gigabit/sec",['f-eth-speed-']],
    'f-eth-10g'    => ["Filer Ethernet NIC - 10 Gigabit/sec",['f-eth-speed-']],
    'f-eth-1gt'    => ["Filer Ethernet NIC with TOE - 1 Gigabit/sec",['f-toe','f-eth-1g']],
    'f-eth-10gt'   => ["Filer Ethernet NIC with TOE - 10 Gigabit/sec",['f-toe','f-eth-10g']],
    'f-eth-mb-bcm1250'      => ["Dual SB1250-Gigabit Ethernet Controller",['f-eth-1g']],
    'f-eth-mb-bcm5703'      => ["BGE 10/100 Ethernet Controller",['f-eth-100m']],
    'f-eth-mb-bcm5714'      => ["BGE 10/100/1000 Ethernet Controller",['f-eth-1g']],
    'f-eth-mb-dec21143'     => ["Ethernet Controller e0",['f-eth-100m']],
    'f-eth-mb-intel82544gc' => ["10/100 Ethernet Controller IV",['f-eth-100m']],
    'f-eth-x-'     => ["Filer Ethernet NICs by part number",['f-eth-']],

    'f-eth-x1001'     => ["FastEnet-10/100 Ethernet Controller - 10/100Base-T",['f-eth-100m']],
    'f-eth-x1005'     => ["TOE-10G Ethernet Controller 10000 - Base-SX",['f-eth-10gt']],
    'f-eth-x1006'     => ["Quad TOE-1G Ethernet Controller (T204E) - 10/100/1000Base-T",['f-eth-1gt']],
    'f-eth-x1007'     => ["Quad TOE-1G Ethernet Controller (T204V) - 10/100/1000Base-T",['f-eth-1gt']],
    'f-eth-x1008'     => ["TOE-10G Ethernet Controller dual port PCIe (T320E-XFP)",['f-eth-10gt']],
    'f-eth-x1010'     => ["TOE-10G Ethernet Controller dual port PCIe (T320E-CX4)",['f-eth-10gt']],
    'f-eth-x1012'     => ["Quad FastEnet-10/100 Ethernet Controller - 10/100Base-T",['f-eth-100m']],
    'f-eth-x1021'     => ["Obsolete 10/100 Ethernet Controller - 10/100Base-T",['f-eth-100m']],
    'f-eth-x1025'     => ["Intel Gigabit Ethernet Controller - 1000Base-SX",['f-eth-1g']],
    'f-eth-x1026'     => ["Intel Gigabit Ethernet Controller - 1000Base-SX",['f-eth-1g']],
    'f-eth-x1027'     => ["Intel 100/1000 Ethernet Controller - 100/1000Base-T",['f-eth-1g']],
    'f-eth-x1029'     => ["iSCSI Target Host Adapter - 10/100/1000Base-T",['f-eth-1g']],
    'f-eth-x1035'     => ["Dual Gigabit Ethernet Controller - 1000Base-SX",['f-eth-1g']],
    'f-eth-x1037'     => ["Dual 10/100/1000 Ethernet Controller - 10/100/1000Base-T",['f-eth-1g']],
    'f-eth-x1038'     => ["Dual Gigabit Ethernet Controller - 1000Base-SX",['f-eth-1g']],
    'f-eth-x1039'     => ["Dual 10/100/1000 Ethernet Controller - 10/100/1000Base-T",['f-eth-1g']],
    'f-eth-x1047'     => ["Quad 10/100/1000 Ethernet Controller - 10/100/1000Base-T",['f-eth-1g']],
    'f-eth-x1049'     => ["Quad 10/100/1000 Ethernet Controller - 10/100/1000Base-T",['f-eth-1g']],
    'f-eth-x1129a-r5' => ["Emulex iSCSI target 1 GbE dual Cu (LPe100i-D1)",['f-eth-1g']],
    'f-eth-x1136a-r5' => ["Emulex iSCSI target 1 GbE dual FO (LPe100i-F1)",['f-eth-1g']],
#    'f-eth-x1047b-r6'                => ["Quad 10/100/1000 Ethernet Controller VII - 10/100/1000Base-T - RoHS Compliant",['f-eth-1g']],
#    'f-eth-x1049a-r6'                => ["Quad 10/100/1000 Ethernet Controller G20 - RoHS Compliant",['f-eth-1g']],
#    'f-eth-x1006a-r6'                => ["Quad TOE-1G Ethernet Controller (T204E) - 10/100/1000Base-T - RoHS Compliant",['f-eth-1gt']],

    'f-fw'           => ["non-CFE compatible firmware version",['-all-filer-firmware-']],
    'f-fw-agent'     => ["Filer agent version",['-all-filer-firmware-'],"f-fw-agent-%"],
    'f-fw-bios'      => ["Filer BIOS version",['-all-filer-firmware-'],"f-fw-bios-%"],
    'f-fw-cfe'       => ["CFE version",['-all-filer-firmware-'],"f-fw-cfe-%"],
    'f-fw-lcd'       => ["Filer LCD version",['-all-filer-firmware-'],"f-fw-lcd-%"],
    'f-fw-loader'    => ["Filer loader version",['-all-filer-firmware-'],"f-fw-loader-%"],
    'f-ipsec'        => ["Filer Cryptographic Accelerator Adapter installed",[]],
    'f-ipsec-no'     => ["Filer Cryptographic Accelerator Adapter NOT installed",[]],
    'f-iscsi-merl-'  => ["Filer iscsi.max_error_recovery_level",['-all-filer-iscsi-'],'f-iscsi-merl-%'],
    'f-iscsi-mcs'    => ["Filer iscsi.max_connections_per_session",['-all-filer-iscsi-'],'f-iscsi-mcs-%'],
    'f-jumbo'        => ["Filer jumbo frames configured",[]],
    'f-jumbo-no'     => ["Filer jumbo frames NOT configured",[]],
    'f-nvram-'       => ["NVRAM versions",['-all-filer-cfo-']],
    'f-nvram-size-'  => ["NVRAM memory size",['-all-filer-cfo-']],
    'f-nvram3'       => ["NVRAM 3",['f-nvram-']],
    'f-nvram4'       => ["NVRAM 4",['f-nvram-']],
    'f-nvram5'       => ["NVRAM 5",['f-nvram-']],
    'f-nvram6'       => ["NVRAM 6",['f-nvram-']],
    'f-nvram7'       => ["NVRAM 7",['f-nvram-']],
    'f-rlm'          => ["Filer Remote Management cards",['-all-filer-']],
    'f-sp'           => ["Service Processors",['f-rlm']],
    'full_init'      => ["Filer file system",['-all-filer-']],
    'fake_init'      => ["Filer file system",['-all-filer-']],
    'f-src-dst'      => ["Test bed has defined FILER_SRC and FILER_DST parameters",['-all-testbed-']],
    'f-toe'          => ["Filer TOE NICs",['f-eth-']],
    'f-toe-no'       => ["Filer TOE NICs NOT installed",['f-eth-']],
    'f-vifs'         => ["Filer VIFs",[]],
    'f-vlan'         => ["Filer Vlans",[]],
    'fcha'           => ["FC Host Adapters",['-all-filer-storage-fchafamilies-']],
    'fcha-adpt39160' => ["Adaptec 39160 FC Host Bus Adapter",['fcha']],
    'fcha-lsi929x'   => ["LSI 929x FC Host Bus Adapter",['fcha']],
    'fcha-lsi949e'   => ["LSI 949E FC Host Bus Adapter",['fcha']],
    'fcha-lsi949x'   => ["LSI 949X FC Host Bus Adapter",['fcha']],
    'fcha-ql1080'    => ["QLogic 1080 FC Host Bus Adapter",['fcha']],
    'fcha-ql2100'    => ["QLogic 2100 FC Host Bus Adapter",['fcha']],
    'fcha-ql22xx'    => ["QLogic 22xx FC Host Bus Adapter",['fcha']],
    'fcha-ql2200'    => ["QLogic 2200 FC Host Bus Adapter",['fcha-ql22xx']],
    'fcha-ql2212'    => ["QLogic 2212 FC Host Bus Adapter",['fcha-ql22xx']],
    'fcha-ql23xx'    => ["QLogic 23xx FC Host Bus Adapter",['fcha']],
    'fcha-ql2312'    => ["QLogic 2312 FC Host Bus Adapter",['fcha-ql23xx']],
    'fcha-ql2322'    => ["QLogic 2322 FC Host Bus Adapter",['fcha-ql23xx']],
    'fcha-ql2342'    => ["QLogic 2342 FC Host Bus Adapter",['fcha-ql23xx']],
    'fcha-ql2352'    => ["QLogic 2352 FC Host Bus Adapter",['fcha-ql23xx']],
    'fcha-qle24xx'   => ["QLogic PCI-Express 24xx FC Host Bus Adapter",['fcha']],
    'fcha-qle2464'   => ["QLogic PCI-Express 2464 FC Host Bus Adapter",['fcha-qle24xx']],
    'fcp'                            => ["Filer FCP service",['scsi', '-all-filer-network-protocols-']],
    'fcpiscsi'                       => ["Filer FCP and iSCSI services",['fcp','iscsi']],
    'fcpptp'                         => ["Filer FCP point-to-point",[]],
    'nofcp'                          => ["Filer FCP service NOT allowed",['-all-filer-network-protocols-']],
    'fcp-aix'   => ["AIX FCP Host Attach Kits",['fcp-hak'],"fcp-aix-_._"],
    'fcp-hak'   => ["FCP Host Attach Kits",[]],
    'fcp-hpux'  => ["HP-UX FCP Host Attach Kits",['fcp-hak'],"fcp-hpux-_._"],
    'fcp-linux' => ["Linux FCP Host Attach Kits",['fcp-hak'],"fcp-linux-_._"],
    'fcp-sun'   => ["Solaris FCP Host Attach Kits",['fcp-hak'],"fcp-sun-_._"],
    'fcp-win'   => ["Windows FCP Host Attach Kits",['fcp-hak'],"fcp-win-_._"],
    'fcpu-'          => ["Filer processor type",['-all-filer-']],
    'fcpu-alpha'     => ["Alpha processor",['fcpu-']],
    'fcpu-i386'      => ["Intel 386 compatible processor",['fcpu-']],
    'fcpu-i386-elf'  => ["Intel 386 compatible processor",['fcpu-']],
    'fcpu-i486'      => ["Intel 486 compatible processor",['fcpu-','fcpu-i386']],
    'fcpu-i586'      => ["Intel 586 compatible processor",['fcpu-','fcpu-i486']],
    'fcpu-i686'      => ["Intel 686 compatible processor",['fcpu-','fcpu-i586']],
    'fcpu-mips'      => ["MIPS processors",['fcpu-']],
    'fcpu-mips4'     => ["MIPS4 processors",['fcpu-mips']],
    'fcpu-mips-1250' => ["SiByte Inc's Mercurian SB-1250 MIPS processors",['fcpu-mips']],
    'fcpu-x86-64'    => ["Intel IA64 compatible processor",['fcpu-']],
    'fcpus-'    => ["Filer processor count",[]],
    'fcpus-1'   => ["Filer with 1 CPU",['fcpus-']],
    'fcpus-2'   => ["Filer with 2 CPUs",['fcpus-']],
    'fcpus-4'   => ["Filer with 4 CPUs",['fcpus-']],
    'fdryts8'                        => ["Foundry switch",[]],
    'fe-brcd'         => ["Front-end Brocade switches",['-all-switch-manufacturers-']],
    'fe-brcd3200'     => ["Front-end Brocade 3200 switch",['fe-brcd']],
    'fe-brcd3250'     => ["Front-end Brocade 3250 switch",['fe-brcd']],
    'fe-brcd3800'     => ["Front-end Brocade 3800 switch",['fe-brcd']],
    'fe-brcd3850'     => ["Front-end Brocade 3850 switch",['fe-brcd']],
    'fe-brcd3900'     => ["Front-end Brocade 3900 switch",['fe-brcd']],
    'fe-brcd12k'      => ["Front-end Brocade 12000 switch",['fe-brcd']],
    'fe-csco'         => ["Front-end Cisco switches",['-all-switch-manufacturers-']],
    'fe-csco9xxx'     => ["Front-end Cisco 9xxx switches",['fe-csco']],
    'fe-csco9020'     => ["Front-end Cisco 9020 switch",['fe-csco9xxx']],
    'fe-csco9120'     => ["Front-end Cisco 9120 switch",['fe-csco9xxx']],
    'fe-csco9124'     => ["Front-end Cisco 9124 switch",['fe-csco9xxx']],
    'fe-csco9134'     => ["Front-end Cisco 9134 switch",['fe-csco9xxx']],
    'fe-csco9140'     => ["Front-end Cisco 9140 switch",['fe-csco9xxx']],
    'fe-csco9216'     => ["Front-end Cisco 9216 switch",['fe-csco9xxx']],
    'fe-csco9222'     => ["Front-end Cisco 9222 switch",['fe-csco9xxx']],
    'fe-csco9509'     => ["Front-end Cisco 9509 switch",['fe-csco9xxx']],
    'fe-csco9513'     => ["Front-end Cisco 9513 switch",['fe-csco9xxx']],
    'fe-fdy'          => ["Front-end Foundry switches",['-all-switch-manufacturers-']],
    'fe-mcdt'                        => ["Front-end McData switches",['-all-switch-manufacturers-']],
    'fe-mcdt3216'                    => ["Front-end McData 3216 switch",['fe-mcdt']],
    'fe-mcdt4300'                    => ["Front-end McData 4300 switch",['fe-mcdt']],
    'fe-mcdt4500'                    => ["Front-end McData 4500 switch",['fe-mcdt']],
    'fe-mcdt6000'                    => ["Front-end McData 6000 switch",['fe-mcdt']],
    'fe-ql'                          => ["Front-end QLogic switches",['-all-switch-manufacturers-']],
    'fe-ql5xxx'                      => ["Front-end QLogic SANbox 5xxx switches",['fe-ql']],
    'fe-ql5600'                      => ["Front-end QLogic SANbox 5600 switches",['fe-ql5xxx']],
    'fe-ql5602'                      => ["Front-end QLogic SANbox 5602 switches",['fe-ql5xxx']],
    'fe-ql9xxx'                      => ["Front-end QLogic SANbox 9xxx switches",['fe-ql']],
    'fe-ql9000'                      => ["Front-end QLogic SANbox 9000 switches",['fe-ql9xxx']],
    'fe-ql9200'                      => ["Front-end QLogic SANbox 9200 switches",['fe-ql9xxx']],
    'filer'    => ["NetApp filer",[]],
    'filer-1'      => ["Test bed with at least 1 filer",['-all-testbed-']],
    'filer-2'      => ["Test bed with at least 2 filers",['filer-1','-all-testbed-']],
    'filer-3'      => ["Test bed with at least 3 filers",['filer-2','-all-testbed-']],
    'filer-4'      => ["Test bed with at least 4 filers",['filer-3','-all-testbed-']],
    'filer-5'      => ["Test bed with at least 5 filers",['filer-4','-all-testbed-']],
    'filer-6'      => ["Test bed with at least 6 filers",['filer-5','-all-testbed-']],
    'filer-7'      => ["Test bed with at least 7 filers",['filer-6','-all-testbed-']],
    'filer-8'      => ["Test bed with at least 8 filers",['filer-7','-all-testbed-']],
    'filer-9'      => ["Test bed with at least 9 filers",['filer-8','-all-testbed-']],
    'filer-10'     => ["Test bed with at least 10 filers",['filer-9','-all-testbed-']],
    'filer-11'     => ["Test bed with at least 11 filers",['filer-10','-all-testbed-']],
    'filer-12'     => ["Test bed with at least 12 filers",['filer-11','-all-testbed-']],
    'filer-13'     => ["Test bed with at least 13 filers",['filer-12','-all-testbed-']],
    'filer-14'     => ["Test bed with at least 14 filers",['filer-13','-all-testbed-']],
    'filer-15'     => ["Test bed with at least 15 filers",['filer-14','-all-testbed-']],
    'filer-16'     => ["Test bed with at least 16 filers",['filer-15','-all-testbed-']],
    'filer-17'     => ["Test bed with at least 17 filers",['filer-16','-all-testbed-']],
    'filer-18'     => ["Test bed with at least 18 filers",['filer-17','-all-testbed-']],
    'filer-19'     => ["Test bed with at least 19 filers",['filer-18','-all-testbed-']],
    'filer-20'     => ["Test bed with at least 20 filers",['filer-19','-all-testbed-']],
    'filer-21'     => ["Test bed with at least 21 filers",['filer-20','-all-testbed-']],
    'filer-22'     => ["Test bed with at least 22 filers",['filer-21','-all-testbed-']],
    'filer-23'     => ["Test bed with at least 23 filers",['filer-22','-all-testbed-']],
    'filer-24'     => ["Test bed with at least 24 filers",['filer-23','-all-testbed-']],
    'flex-cache'                     => ["Filer flex_cache service",['-all-filer-services-']],
    'flex-clone'                     => ["Filer flex_clone service",['-all-filer-services-']],
    'fmem-'                          => ["Filer memory sizes",[],'fmem-%'],
    'frsh'      => ["Filer with rsh access",[]],
    'frsh-no'   => ["Filer with rsh access NOT available",[]],
    'fssh'      => ["Filer with ssh access",[]],
    'fssh-no'   => ["Filer with ssh access NOT available",[]],
    'fs-ext'                         => ["Linux ext (extended) file system",[]],
    'fs-ext2'                        => ["Linux ext2 (second extended) file system",[]],
    'fs-ext3'                        => ["Linux ext3 file system",[]],
    'fs-fat32'                       => ["Windows FAT32",[]],
    'fs-hfs'                         => ["HFS, HP Hierarchical File System",[]],
    'fs-hfs-a'                       => ["HFS, Hierarchical File System, initially included with the Apple Macintosh, now included with Linux",[]],
    'fs-jfs'                         => ["JFS",[]],
    'fs-jfs2'                        => ["JFS 2",[]],
    'fs-ntfs'                        => ["Windows NTFS",[]],
    'fs-reiser'                      => ["Linux ReiserFS file system",[]],
    'fs-ufs'                         => ["UFS",[]],
    'fs-vxfs'                        => ["Veritas' VxFS, also bundled by HP as their JFS",[]],
    'fwhu'      => ["NetApp FCP Windows Host Utilities are installed",['-all-client-aps-']],
    'GFxxx'  => ["GFxxx gFiler",['filer','-all-filer-families-']],
    'GFxxxc' => ["GFxxx clustered gFiler",['filer','-all-filer-families-']],
    'GF270'  => ["GF270 gFiler",['GFxxx']],
    'GF270c' => ["GF270 clustered gFiler",['GFxxxc','GF270']],
    'GF825'  => ["GF825 gFiler",['GFxxx','fcpus-1']],
    'GF825c' => ["GF825 clustered gFiler",['GF825','GFxxxc']],
    'GF920'  => ["GF920 gFiler",['GFxxx','fcpus-1']],
    'GF920c' => ["GF920 clustered gFiler",['GF920']],
    'GF940'  => ["GF940 gFiler",['GFxxx','fcpus-1']],
    'GF940c' => ["GF940 clustered gFiler",['GF940','GFxxxc']],
    'GF960'  => ["GF960 gFiler",['GFxxx','fcpus-2']],
    'GF960c' => ["GF960 clustered gFiler",['GF960','GFxxxc']],
    'GF980'  => ["GF980 gFiler",['GFxxx','fcpus-4']],
    'GF980c' => ["GF980 clustered gFiler",['GF980','GFxxxc']],
    'ga-'             => ["Array storage vendors",['-all-filer-']],
    'ga-3par'         => ["3PARdata array storage models",['ga-']],
    'ga-apple'        => ["Apple array storage models",['ga-']],
    'ga-applexserver' => ["Apple Xserve array storage models",['ga-']],
    'ga-ddn'          => ["DataDirect Networks array storage models",['ga-']],
    'ga-emc'          => ["EMC array storage models",['ga-']],
    'ga-emcclarion'   => ["EMC Clarion storage array models",['ga-emc']],
    'ga-emcsymmetrix' => ["EMC Symmetrix array storage models",['ga-emc']],
    'ga-engenio'      => ["Engenio array storage models",['ga-'],'ga-engenio%'],
    'ga-flx'          => ["FLEXLINE array storage models",['ga-'],'ga-flx%'],
    'ga-fujitsu'      => ["Fujitsu array storage models",['ga-'],'ga-fujitsu%'],
    'ga-hds'          => ["Hitachi array storage models",['ga-'],'ga-hds%'],
    'ga-hp'           => ["HP array storage",['ga-']],
    'ga-hpxp'         => ["HP XP array storage",['ga-hp']],
    'ga-hpeva'        => ["HP EVA array storage",['ga-hp']],
    'ga-hpeva3000'    => ["HP EVA 3000 array storage",['ga-hpeva']],
    'ga-hpeva4000'    => ["HP EVA 4000 array storage",['ga-hpeva']],
    'ga-hpeva5000'    => ["HP EVA 5000 array storage",['ga-hpeva']],
    'ga-hpeva8000'    => ["HP EVA 8000 array storage",['ga-hpeva']],
    'ga-ibm'          => ["IBM array storage",['ga-']],
    'ga-ibmds6800'    => ["IBM DS6800 array storage",['ga-ibm']],
    'ga-ibmds8000'    => ["IBM DS8000 array storage",['ga-ibm']],
    'ga-ibmess800'    => ["IBM ESS800 array storage",['ga-ibm']],
    'ga-ibmfasttxxx'  => ["IBM FastT array storage",['ga-ibm'],"ga-ibmfastt%"],
    'ga-ibmfastt100'  => ["IBM FastT100 (DS4100) array storage",['ga-ibm','ga-ibmfasttxxx']],
    'ga-ibmfastt600'  => ["IBM FastT600 array storage",['ga-ibm','ga-ibmfasttxxx']],
    'ga-ibmfastt700'  => ["IBM FastT700 array storage",['ga-ibm','ga-ibmfasttxxx']],
    'ga-ibmfastt900'  => ["IBM FastT900 array storage",['ga-ibm','ga-ibmfasttxxx']],
    'ga-ibmfastt1815' => ["IBM FastT1815 (DS4800) array storage",['ga-ibm','ga-ibmfasttxxx']],
    'ga-lsi'          => ["LSI array storage models",['ga-']],
    'ga-stk'          => ["STK array storage models",['ga-']],
    'gateway-hitachi'                => ["Filer gateway_hitachi service",['-all-filer-services-']],
    'grm'                            => ["NetCache grm service",['nc-services-']],
    'gx-base'                    => ["GX Base license is available",['-all-filer-network-protocols-']],
    'gx-cifs'                    => ["GX CIFS license is available",['-all-filer-network-protocols-']],
    'gx-flexvol-hpo'             => ["GX FlexVol HPO license is available",['-all-filer-network-protocols-']],
    'gx-mirror'                  => ["GX Mirror license is available",['-all-filer-network-protocols-']],
    'gx-snaprestore'             => ["GX SnapRestore license is available",['-all-filer-network-protocols-']],
    'h-atm'                          => ["Host/Client ATM network adapter installed",[]],
    'h-atm-no'                       => ["Host/Client ATM network adapter NOT installed",[]],
    'h-cifs'                         => ["Host/Client CIFS use",[]],
    'h-cifs-no'                      => ["Host/Client CIFS use NOT allowed",[]],
    'h-chap'                         => ["Host/Client with iSCSI CHAP security configured ",[]],
    'h-ftp'                          => ["Host/Client FTP use",[]],
    'h-ftp-no'                       => ["Host/Client FTP use NOT allowed",[]],
    'h-http'                         => ["Host/Client HTTP use",[]],
    'h-http-no'                      => ["Host/Client HTTP use NOT allowed",[]],
    'h-iscsi-hdr-d-digest'           => ["Host/Client that supports iSCSI header data digest",[]],
    'h-iscsi-hdr-d-digest-no'        => ["Host/Client that does not support iSCSI header data digest",[]],
    'h-iscsi-immed'                  => ["Host/Client that supports iSCSI ImmediateData",[]],
    'h-iscsi-immed-no'               => ["Host/Client that does not support iSCSI ImmediateData",[]],
    'h-iscsi-mcs'                    => ["Host/Client that supports iSCSI Multi-Session connections",[],'h-iscsi-mcs-%'],
    'h-iscsi-mcs-no'                 => ["Host/Client that does not support iSCSI Multi-Session connections",[]],
    'h-iscsi-r2t'                    => ["Host/Client that waits for Ready-to-Transmit",[]],
    'h-iscsi-r2t-no'                 => ["Host/Client that does not wait for Ready-to-Transmit",[]],
    'h-isns'                         => ["Host/Client that ",[]],
    'h-jumbo'                        => ["Host/Client jumbo frame use",[]],
    'h-jumbo-no'                     => ["Host/Client with NO jumbo frame use",[]],
    'h-mcs'                  => ["Host/Client iSCSI Multi-Session Connections are in use without DSMs",[''],],
    'h-msdsm'                => ["Host/Client Microsoft DSM installed",[''],],
    'h-msdsm-mcs'            => ["Host/Client Microsoft DSM installed using iSCSI Multi-Session Connections",['h-msdsm'],],
    'h-msdsm-mcs-iscsi'          => ["Host/Client Microsoft DSM with iSCSI MCS support",['h-msdsm-mcs'],],
    'h-msdsm-mcs-iscsi-foo'      => ["Host/Client Microsoft DSM with iSCSI MCS and Fail Over Only load balancing",['h-msdsm-mcs-iscsi'],],
    'h-msdsm-mcs-iscsi-lqd'      => ["Host/Client Microsoft DSM with iSCSI MCS and Dynamic Least Queue Depth load balancing",['h-msdsm-mcs-iscsi'],],
    'h-msdsm-mcs-iscsi-rr'       => ["Host/Client Microsoft DSM with iSCSI MCS and Round-Robin load balancing",['h-msdsm-mcs-iscsi'],],
    'h-msdsm-mcs-iscsi-rrws'     => ["Host/Client Microsoft DSM with iSCSI MCS and Round-Robin with Subset of Paths load balancing",['h-msdsm-mcs-iscsi'],],
    'h-msdsm-mcs-iscsi-wp'       => ["Host/Client Microsoft DSM with iSCSI MCS and Weighted Paths load balancing",['h-msdsm-mcs-iscsi'],],
    'h-msdsm-mpio'           => ["Host/Client Microsoft DSM installed with MPIO",['h-msdsm'],],
    'h-msdsm-mpio-fcp'            => ["Host/Client Microsoft DSM with FCP MPIO support",['h-msdsm-mpio'],],
    'h-msdsm-mpio-fcp-foo'        => ["Host/Client Microsoft DSM with FCP MPIO and Fail Over Only load balancing",['h-msdsm-mpio-fcp'],],
    'h-msdsm-mpio-fcp-lqd'        => ["Host/Client Microsoft DSM with FCP MPIO and Dynamic Least Queue Depth load balancing",['h-msdsm-mpio-fcp'],],
    'h-msdsm-mpio-fcp-rr'         => ["Host/Client Microsoft DSM with FCP MPIO and Round-Robin load balancing",['h-msdsm-mpio-fcp'],],
    'h-msdsm-mpio-fcp-rrws'       => ["Host/Client Microsoft DSM with FCP MPIO and Round-Robin with Subset of Paths load balancing",['h-msdsm-mpio-fcp'],],
    'h-msdsm-mpio-fcp-wp'         => ["Host/Client Microsoft DSM with FCP MPIO and Weighted Paths load balancing",['h-msdsm-mpio-fcp'],],
    'h-msdsm-mpio-iscsi'          => ["Host/Client Microsoft DSM with iSCSI MPIO support",['h-msdsm-mpio'],],
    'h-msdsm-mpio-iscsi-foo'      => ["Host/Client Microsoft DSM with iSCSI MPIO and Fail Over Only load balancing",['h-msdsm-mpio-iscsi'],],
    'h-msdsm-mpio-iscsi-lqd'      => ["Host/Client Microsoft DSM with iSCSI MPIO and Dynamic Least Queue Depth load balancing",['h-msdsm-mpio-iscsi'],],
    'h-msdsm-mpio-iscsi-rr'       => ["Host/Client Microsoft DSM with iSCSI MPIO and Round-Robin load balancing",['h-msdsm-mpio-iscsi'],],
    'h-msdsm-mpio-iscsi-rrws'     => ["Host/Client Microsoft DSM with iSCSI MPIO and Round-Robin with Subset of Paths load balancing",['h-msdsm-mpio-iscsi'],],
    'h-msdsm-mpio-iscsi-wp'       => ["Host/Client Microsoft DSM with iSCSI MPIO and Weighted Paths load balancing",['h-msdsm-mpio-iscsi'],],
    'h-msiscdsm'                => ["Host/Client Microsoft ISC DSM installed",[''],],
    'h-msiscdsm-mcs'            => ["Host/Client Microsoft ISC DSM installed using iSCSI Multi-Session Connections",['h-msiscdsm'],],
    'h-msiscdsm-mcs-iscsi'          => ["Host/Client Microsoft ISC DSM with iSCSI MCS support",['h-msmsiscdsmisc-mcs'],],
    'h-msiscdsm-mcs-iscsi-foo'      => ["Host/Client Microsoft ISC DSM with iSCSI MCS and Fail Over Only load balancing",['h-msiscdsm-mcs-iscsi'],],
    'h-msiscdsm-mcs-iscsi-lqd'      => ["Host/Client Microsoft ISC DSM with iSCSI MCS and Dynamic Least Queue Depth load balancing",['h-msiscdsm-mcs-iscsi'],],
    'h-msiscdsm-mcs-iscsi-rr'       => ["Host/Client Microsoft ISC DSM with iSCSI MCS and Round-Robin load balancing",['h-msiscdsm-mcs-iscsi'],],
    'h-msiscdsm-mcs-iscsi-rrws'     => ["Host/Client Microsoft ISC DSM with iSCSI MCS and Round-Robin with Subset of Paths load balancing",['h-msiscdsm-mcs-iscsi'],],
    'h-msiscdsm-mcs-iscsi-wp'       => ["Host/Client Microsoft ISC DSM with iSCSI MCS and Weighted Paths load balancing",['h-msiscdsm-mcs-iscsi'],],
    'h-msiscdsm-mpio'           => ["Host/Client Microsoft ISC DSM installed with MPIO",['h-msiscdsm'],],
    'h-msiscdsm-mpio-iscsi'          => ["Host/Client Microsoft ISC DSM with iSCSI MPIO support",['h-msiscdsm-mpio'],],
    'h-msiscdsm-mpio-iscsi-foo'      => ["Host/Client Microsoft ISC DSM with iSCSI MPIO and Fail Over Only load balancing",['h-msiscdsm-mpio-iscsi'],],
    'h-msiscdsm-mpio-iscsi-lqd'      => ["Host/Client Microsoft ISC DSM with iSCSI MPIO and Dynamic Least Queue Depth load balancing",['h-msiscdsm-mpio-iscsi'],],
    'h-msiscdsm-mpio-iscsi-rr'       => ["Host/Client Microsoft ISC DSM with iSCSI MPIO and Round-Robin load balancing",['h-msiscdsm-mpio-iscsi'],],
    'h-msiscdsm-mpio-iscsi-rrws'     => ["Host/Client Microsoft ISC DSM with iSCSI MPIO and Round-Robin with Subset of Paths load balancing",['h-msiscdsm-mpio-iscsi'],],
    'h-msiscdsm-mpio-iscsi-wp'       => ["Host/Client Microsoft ISC DSM with iSCSI MPIO and Weighted Paths load balancing",['h-msiscdsm-mpio-iscsi'],],
    'h-nfs'                          => ["Host/Client NFS use",[]],
    'h-nfs-no'                       => ["Host/Client with NO NFS use",[]],
    'h-nfsv2'                        => ["Host/Client NFS version 2 use",['h-nfs']],
    'h-nfsv2-no'                     => ["Host/Client with NO NFS version 2 use",[]],
    'h-nfsv3'                        => ["Host/Client NFS version 3 use",['h-nfs']],
    'h-nfsv3-no'                     => ["Host/Client with NO NFS version 3 use",[]],
    'h-nfsv4'                        => ["Host/Client NFS version 4 use",['h-nfs']],
    'h-nfsv4-no'                     => ["Host/Client with NO NFS version 4 use",[]],
    'h-staf'                         => ["Host/Client with STAF service",['-all-client-test-']],
    'h-vifs'                         => ["",[]],
    'h-vm'          => ["Host/Client virtual machines",['-all-client-manufacturers-']],
    'h-vm-veridian' => ["Host/Client Microsoft Veridian virtual machine",['h-vm']],
    'h-vm-vmware'   => ["Host/Client VMware virtual machine",['h-vm']],
    'h-vm-xen'      => ["Host/Client XEN virtual machine",['h-vm']],
    'hba-brcm'      => ["Broadcom HBA",['-all-client-hbas-']],
    'hba-intel'     => ["Intel HBA",['-all-client-hbas-']],
    'hbios-dell'    => ["BIOS by Dell",['-all-client-bios-']],
    'hbios-ibm'     => ["BIOS by IBM",['-all-client-bios-']],
    'hbios-phoenix' => ["BIOS by Phoenix",['-all-client-bios-']],
    'hc-'           => ["Host/Client clustering",[]],
    'hc-haes'       => ["IBM HAES HA/CMP",['hc-']],
    'hc-sg'         => ["HP Service Guard ",['hc-']],
    'hc-mscs'       => ["Microsoft Cluster Server",['hc-']],
    'hc-vcs'        => ["Veritas VCS",['hc-']],
    'hcpu-alpha'    => ["Host/Client with Alpha processor",['-all-client-cpu-']],
    'hcpu-hppa'     => ["Host/Client with HPPA processor",['-all-client-cpu-']],
    'hcpu-hppa2'    => ["Host/Client with HPPA2 processor",['-all-client-cpu-']],
    'hcpu-i386'     => ["Host/Client with Intel 386 compatible processor",['-all-client-cpu-']],
    'hcpu-i486'     => ["Host/Client with Intel 486 compatible processor",['hcpu-i386']],
    'hcpu-i586'     => ["Host/Client with Intel 586 compatible processor",['hcpu-i486']],
    'hcpu-i686'     => ["Host/Client with Intel 686 compatible processor",['hcpu-i586']],
    'hcpu-i1586'    => ["Host/Client with Intel 1586 compatible processor",['hcpu-i686']],
    'hcpu-ia64'     => ["Host/Client with Intel IA64 processor",['-all-client-cpu-']],
    'hcpu-m88k'     => ["Host/Client with Motorola 88000 processor",['-all-client-cpu-']],
    'hcpu-mips4'    => ["Host/Client with MIPS 4 processor",['-all-client-cpu-']],
    'hcpu-powerpc'  => ["Host/Client with IBM Power PC processor",['-all-client-cpu-']],
    'hcpu-sparc'    => ["Host/Client with SPARC processor",['-all-client-cpu-']],
    'hcpu-x64'      => ["Host/Client with Intel compatible 64 bit processor",['-all-client-cpu-']],
    'hcpus-1'   => ["Host/Client processor count 1",['-all-client-cpus-']],
    'hcpus-2'   => ["Host/Client processor count 2",['-all-client-cpus-']],
    'hcpus-4'   => ["Host/Client processor count 4",['-all-client-cpus-']],
    'hcpus-6'   => ["Host/Client processor count 6",['-all-client-cpus-']],
    'hcpus-8'   => ["Host/Client processor count 8",['-all-client-cpus-']],
    'hcpus-10'  => ["Host/Client processor count 10",['-all-client-cpus-']],
    'hcpus-16'  => ["Host/Client processor count 16",['-all-client-cpus-']],
    'hdmp'         => ["Host/Client Dynamic Multi-Path support",[]],
    'hman-cmpq'        => ["Host/Client built by Compaq",['-all-client-manufacturers-']],
    'hman-dell'        => ["Host/Client built by Dell",['-all-client-manufacturers-']],
    'hman-gtw'         => ["Host/Client built by Gateway",['-all-client-manufacturers-']],
    'hman-hp'          => ["Host/Client built by HP",['-all-client-manufacturers-']],
    'hman-ibm'         => ["Host/Client built by IBM",['-all-client-manufacturers-']],
    'hman-sun'         => ["Host/Client built by Sun",['-all-client-manufacturers-']],
    'hman-supermicro'  => ["Host/Client built by Supermicro",['-all-client-manufacturers-']],
    
    'hpux'    => ["Client with HP-UX operating system",['unix','fs-hfs','fs-vxfs','dmp-pvlinks','rawio'],"hp__.__"],
    # Only list current valid entries (All hp\d\d entries are allowed in %implied_by_prefix_configs hash below)
    'hp11.11' => ["Client with HP-UX 11i v1 operating system",['hpux']],
    'hp11.23' => ["Client with HP-UX 11i v2 operating system",['hpux']],
    'hp11.31' => ["Client with HP-UX 11i v3 operating system",['hpux']],
    'hrsh'         => ["Client with rsh access",[]],
    'hrsh-wrshdnt' => ["Client with rsh access via Denicomp wrshdnt.exe",['hrsh']],
    'hrsh-no'      => ["Client with rsh access NOT available",[]],
    'hrsh-root'    => ["Client with rsh access only by root",[]],
    'http'                           => ["Filer HTTP service",['-all-filer-network-protocols-']],
    'nohttp'                         => ["Filer HTTP service NOT allowed",['-all-filer-network-protocols-']],
    'https-proxy'                    => ["NetCache https_proxy service",['nc-services-', '-all-filer-network-protocols-']],
    'ib'                             => ["IB interconnect HBA",['ic-']],
    'ibm-model-'   => ["IBM filer models",[],"IBM-____-___"],
    'ic-'          => ["Filer interconnection types",['-all-filer-cfo-']],
    'ic-ib-jni'    => ["Filer IB JNI interconnection",['ic-']], 
    'ic-ql2352'    => ["Filer qLogic 2352 interconnection",['ic-']], 
    'ic-sn'        => ["Filer Servernet interconnection",['ic-']], 
    'ic-tk'        => ["Filer Troika interconnection",['ic-']], 
    'ic-vi'        => ["VI Cluster Adapter",['ic-']],
    'ic-vi-a'      => ["VI Cluster Adapter Rev A",['ic-vi']],
    'ic-vi-b'      => ["VI Cluster Adapter Rev B",['ic-vi']],
    'icap'                           => ["NetCache icap service",['nc-services-']],
    'init-'      => ["Host/Client initiator",['-all-client-']],
    'init-fcp'   => ["Host/Client FCP initiator",['init-','init-hw']],
    'init-hba-cpci'     => ["Host/Client FCP initiator",['init-fcp']],
    'init-hba-em10000'  => ["Host/Client Emulex 10000 FCP initiator",['init-hba-pci']],
    'init-hba-em9002'   => ["Host/Client Emulex 9002 FCP initiator",['init-hba-pci']],
    'init-hba-hp5158'   => ["Host/Client HP 5158 FCP initiator",['init-hba-pci']],
    'init-hba-hp6684'   => ["Host/Client HP 6684 FCP initiator",['init-hba-hsc']],
    'init-hba-hp6685'   => ["Host/Client HP 6685 FCP initiator",['init-hba-hsc']],
    'init-hba-hp6795'   => ["Host/Client HP 6795 FCP initiator",['init-hba-pci']],
    'init-hba-hsc'      => ["Host/Client FCP initiator",['init-fcp']],
    'init-hba-lpe11000' => ["4 Gb/s PCI Express HBA",['init-hba-pcie']],
    'init-hba-pci'      => ["PCI FCP HBA",['init-fcp']],
    'init-hba-pcie'     => ["PCI Express FCP HBA",['init-fcp']],
    'init-hba-pcix'     => ["PCI-X FCP HBA",['init-fcp']],
    'init-hba-ql2342'   => ["Host/Client qLogic 2342 FCP initiator",['init-hba-pci']],
    'init-hba-ql2352'   => ["Host/Client qLogic 2352 FCP initiator",['init-hba-pci']],
    'init-hba-ql2362'   => ["Host/Client qLogic 2362 FCP initiator",['init-fcp']],
    'init-hba-ql2462'   => ["Host/Client qLogic 2462 FCP initiator",['init-fcp']],
    'init-hba-qmc2462s' => ["Host/Client qLogic QMC2462S FCP initiator",['init-fcp']],
    'init-hba-sbus'     => ["Host/Client S-Bus FCP initiator",['init-fcp']],
    'init-hw'                        => ["Host/Client FCP or iSCSI hardware initiator",['init-']],
    'init-iscsi'                     => ["Host/Client iSCSI initiator",['init-']],
    'init-iscsi-hw'                  => ["iSCSI hardware initiator",['init-iscsi','init-hw']],
    'init-iscsi-hw-intel'            => ["iSCSI hardware initiator from Intel",['init-iscsi-hw']],
    'init-iscsi-sw'                  => ["iSCSI software initiator",['init-iscsi']],
    'init-iscsi-sw-aix'              => ["iSCSI software initiator from AIX",['init-iscsi-sw']],
    'init-iscsi-sw-aix-5.2'          => ["iSCSI software initiator from AIX 5.2",['init-iscsi-sw-aix']],
    'init-iscsi-sw-aix-5.3'          => ["iSCSI software initiator from AIX 5.3",['init-iscsi-sw-aix']],
    'init-iscsi-sw-cisco'            => ["iSCSI software initiator from Cisco",['init-iscsi-sw']],
    'init-iscsi-sw-hp'               => ["iSCSI software initiator from HP",['init-iscsi-sw'],"iscsi-hpux-%.%.%"],
    'init-iscsi-sw-redhat'           => ["iSCSI software initiator from Redhat",['init-iscsi-sw']],
    'init-iscsi-sw-linux'            => ["iSCSI software initiator from Linux",['init-iscsi-sw']],
    'init-iscsi-sw-ms'               => ["iSCSI software initiator from Microsoft",['init-iscsi-sw']],
    'init-iscsi-sw-sun'              => ["iSCSI software initiator from Sun",['init-iscsi-sw']],
    'iscsi'                          => ["Filer iSCSI service",['scsi', '-all-filer-network-protocols-']],
    'noiscsi'                        => ["Filer iSCSI service NOT allowed",['-all-filer-network-protocols-']],
    'iscsi-aix'   => ["AIX iSCSI Host Attach Kits",['iscsi-hak','init-iscsi-sw'],"iscsi-aix-_._"],
    'iscsi-hak'   => ["iSCSI Host Attach Kits",[]],
    'iscsi-hpux'  => ["HP-UX iSCSI Host Attach Kits",['iscsi-hak'],"iscsi-hpux-_._"],
    'iscsi-hpux-03a' => ["",['init-iscsi-sw-hp']],
    'iscsi-hpux-1.0' => ["",['iscsi-hpux']],
    'iscsi-hpux-1.1' => ["",['iscsi-hpux']],
    'iscsi-linux' => ["Linux iSCSI Host Attach Kits",[],"iscsi-linux-_._"],
    'iscsi-linux-sw-1.0' => ["Linux iSCSI software initiator 1.0",['init-iscsi-sw-linux']],
    'iscsi-linux-sw-1.1' => ["Linux iSCSI software initiator 1.1",['init-iscsi-sw-linux']],
    'iscsi-linux-1.0' => ["Linux iSCSI Host Attach Kit 1.0",['iscsi-linux']],
    'iscsi-linux-1.1' => ["Linux iSCSI Host Attach Kit 1.1",['iscsi-linux']],
    'iscsi-linux' => ["",['iscsi-hak']],
    'iscsi-ms'                       => ["Windows iSCSI software initiator",['init-iscsi-sw-ms']],
    'iscsi-sun'   => ["Solaris iSCSI Host Attach Kits",[],"iscsi-sun-_._"],
    'iscsi-win'   => ["Windows iSCSI Host Attach Kits",['iscsi-hak'],"iscsi-win-_._"],
    'iscsi-win2003-sw-2.0'           => ["",['iscsi-win']],
    'iscsi-win2003-sw-1.0'           => ["",['iscsi-win']],
    'iscsi-win2003-1.1'              => ["",['iscsi-win']],
    'iscsi-win2003-1.0'              => ["",['iscsi-win']],
    'iscsi-win-1.0' => ["",['iscsi-win']],
    'iscsi-win-1.1' => ["",['iscsi-win']],
    'iscsi-win-2.0' => ["",['iscsi-win']],
    'iscsi-win-2.1' => ["",['iscsi-win']],
    'iscsi-win-sw-1.0'               => ["",['iscsi-win']],
    'iscsi-win-sw-2.0'               => ["",['iscsi-win']],
    'iscsi-ms1.01'                   => ["",['iscsi-ms']],
    'iscsi-ms1.0'                    => ["",['iscsi-ms']],
    'iscsi-ms1.02'                   => ["",['iscsi-ms']],
    'iscsi-ms1.03'                   => ["",['iscsi-ms']],
    'iscsi-ms1.04'                   => ["",['iscsi-ms']],
    'iscsi-ms1.05'                   => ["",['iscsi-ms']],
    'iscsi-ms1.06'                   => ["",['iscsi-ms']],
    'iscsi-ms2.00' => ["Microsoft iSCSI Service version 2.00 (Osaka) is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.01' => ["Microsoft iSCSI Service version 2.01 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.02' => ["Microsoft iSCSI Service version 2.02 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.03' => ["Microsoft iSCSI Service version 2.03 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.04' => ["Microsoft iSCSI Service version 2.04 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.05' => ["Microsoft iSCSI Service version 2.05 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms2.06' => ["Microsoft iSCSI Service version 2.06 is installed",['iscsi-ms','h-iscsi-mcs']],
    'iscsi-ms-unknown'               => ["",['iscsi-ms']],
    'iscsi-novell'                   => ["",[]],
    'iscsi-novell-sw-1.0' => ["",['iscsi-novell']],
    'iscsi-novell' => ["",['iscsi-hak']],
    'isns'         => ["Filer iSNS Server",[]],
    'linux'        => ["Client with Linux operating system",['unix','fs-ext','fs-ext2','fs-ext3','fs-hfs-a','fs-reiser','rawio']],
    'linux-centos' => ["Client with CentOS Linux operating system",['linux']],
    'linux-fedora' => ["Client with Fedora Linux operating system",['linux'],"fedora%"],
    'linux-gnu'    => ["Client with Gnu Linux operating system",['linux']],
    'linux-oel'    => ["Client with Oracle Enterprise Linux operating system",['linux']],
    'linux-rh'     => ["Client with RedHat Linux operating system",['linux']],
    'linux-suse'   => ["Client with SuSE Linux operating system",['linux']],
    'local-snapmirror'               => ["Filer local-snapmirror service",['-all-filer-services-']],
    'mc-fab' => ["Metrocluster Fabric configuration",['cluster-remote']],
    'mc-ql'  => ["Metrocluster QuickLoop configuration",['cluster-remote']],
    'minwin'                         => ["MinWin compatible",[]],
    'mms'                            => ["NetCache mms service",['nc-services-']],
    'nomms'                          => ["NetCache mms service NOT allowed",['nc-services-']],
    'mms-pro'                        => ["NetCache mms_pro service",['nc-services-']],
    'nomms-pro'                      => ["NetCache mms_pro service NOT allowed",['nc-services-']],
    'mms-ultra'                      => ["NetCache mms_ultra service",['nc-services-']],
    'nomms-ultra'                    => ["NetCache mms_ultra service NOT allowed",['nc-services-']],
    'mpeg4-isma'                     => ["NetCache mpeg4_isma service",['nc-services-']],
    'mpeg4-isma-pro'                 => ["NetCache mpeg4_isma_pro service",['nc-services-']],
    'mpeg4-isma-ultra'               => ["NetCache mpeg4_isma_ultra service",['nc-services-']],
    
    'Nxxxx' => ["IBM branded filer",['filer','-all-filer-families-']],
    'Nxxxxc'=> ["IBM branded clustered filer",['filer','-all-filer-families-']],
    'N1xxx' => ["N1xxx IBM branded filer",['Nxxxx']],
    'N1200' => ["N1200 IBM branded filer",['N1xxx']],
    'N1400' => ["N1400 IBM branded filer",['N1xxx']],
    'N3xxx' => ["N3xxx IBM branded filer",['Nxxxx']],
    'N3xxxc'=> ["N3xxx IBM branded clustered filer",['Nxxxxc']],
    'N3300' => ["N3300 IBM branded filer",['N3xxx','shuar-filer']],
    'N3300c'=> ["N3300 IBM branded clustered filer",['N3300','N3xxxc']],
    'N3600' => ["N3600 IBM branded filer",['N3xxx','shuar-filer']],
    'N3600c'=> ["N3600 IBM branded clustered filer",['N3600','N3xxxc']],
    'N3700' => ["N3700 IBM branded filer",['N3xxx']],
    'N3700c'=> ["N3700 IBM branded clustered filer",['N3700','N3xxxc']],
    'N5xxx' => ["N5xxx IBM branded filer",['Nxxxx']],
    'N5xxxc'=> ["N5xxx IBM branded clustered filer",['Nxxxxc']],
    'N5200' => ["N5200 IBM branded filer",['N5xxx']],
    'N5200c'=> ["N5200 IBM branded clustered filer",['N5200','N5xxxc']],
    'N5300' => ["N5300 IBM branded filer",['N5xxx','fcpus-2']],
    'N5500' => ["N5500 IBM branded filer",['N5xxx']],
    'N5500c'=> ["N5500 IBM branded clustered filer",['N5500','N5xxxc']],
    'N5600' => ["N5600 IBM branded filer",['N5xxx']],
    'N5600c'=> ["N5600 IBM branded clustered filer",['N5600','N5xxxc']],
    'N6xxx' => ["N6xxx IBM branded filer",['Nxxxx']],
    'N6xxxc'=> ["N6xxx IBM branded clustered filer",['Nxxxxc']],
    'N6040' => ["N6040 IBM branded filer",['N6xxx','SPECTRE-l']],
    'N6040c'=> ["N6040 IBM branded clustered filer",['N6040','N6xxxc']],
    'N6070' => ["N6070 IBM branded filer",['N6xxx','SPECTRE-h']],
    'N6070c'=> ["N6070 IBM branded clustered filer",['N6070','N6xxxc']],
    'N7xxx' => ["N7xxx IBM branded filer",['Nxxxx']],
    'N7xxxc'=> ["N7xxx IBM branded clustered filer",['Nxxxxc']],
    'N7600' => ["N7600 IBM branded filer",['N7xxx']],
    'N7600c'=> ["N7600 IBM branded clustered filer",['N7600','N7xxxc']],
    'N7700' => ["N7700 IBM branded filer",['N7xxx']],
    'N7700c'=> ["N7700 IBM branded clustered filer",['N7700','N7xxxc']],
    'N7800' => ["N7800 IBM branded filer",['N7xxx']],
    'N7800c'=> ["N7800 IBM branded clustered filer",['N7800','N7xxxc']],
    'N7900' => ["N7900 IBM branded filer",['N7xxx']],
    'N7900c'=> ["N7900 IBM branded clustered filer",['N7900','N7xxxc']],
    
    'ncagent'                        => ["NetCache ncagent service",['nc-services-']],
    'nc-services-'                   => ["NetCache services",['nc-services-']],
    'nearstore-asis1'                => ["Filer nearstore_asis1 service",['-all-filer-services-']],
    'nearstore-asis2'                => ["Filer nearstore_asis2 service",['-all-filer-services-']],
    'nearstore-option'               => ["Filer nearstore_option service",['-all-filer-services-']],
    'netcache'                       => ["NetApp NetCache",['nc-services-']],
    'nfs'                            => ["Network File System NFS",['-all-filer-network-protocols-']],
    'nonfs'                          => ["Network File System NFS NOT allowed",['-all-filer-network-protocols-']],
    'nfsv2'                          => ["NFS version 2",['nfs']],
    'nfsv3'                          => ["NFS version 3",['nfs']],
    'nfsv4'                          => ["NFS version 4",['nfs']],
    'nfscache'                       => ["NetCache nfscache service",['nc-services-']],
    'nntp'                           => ["NetCache nntp Network News Protocol service",['nc-services-']],
    'ntap.san-toolkit.sanlun'        => ["Host/Client NetApp SAN Toolkit sanlun installed",['-all-client-ntap-'],],
    'ntap.san-toolkit.scripts'       => ["Host/Client NetApp SAN Toolkit scripts installed",['-all-client-ntap-'],],
    'ntap.mpio-attach-kit.config'    => ["Host/Client NetApp MPIO Attach Kit Path Config Tool installed",['-all-client-ntap-'],],
    'ntap.mpio-attach-kit.fcp'       => ["Host/Client NetApp MPIO Attach Kit Path FCP Disk ODM Stanzas installed",['-all-client-ntap-'],],
    'ntap.mpio-attach-kit.iscsi'     => ["Host/Client NetApp MPIO Attach Kit iSCSI Disk ODM Stanzas installed",['-all-client-ntap-'],],
    'ntap.mpio-attach-kit.pcmodm'    => ["Host/Client NetApp MPIO Attach Kit PCM Friend ODM Stanzas installed",['-all-client-ntap-'],],
    'ntapdsm2.1'                     => ["Host/Client NetApp SnapDrive 2.1 installed",['ntapsd'],'ntapdsm2.1.%.%'],
    'ntapdsm3.0'                     => ["Host/Client NetApp SnapDrive 3.0 installed",['ntapsd'],'ntapdsm3.0.%.%'],
    'ntapdsm3.1'                     => ["Host/Client NetApp SnapDrive 3.1 installed",['ntapsd'],'ntapdsm3.1.%.%'],
    'ntapsd'                         => ["Host/Client NetApp SnapDrive installed",['-all-client-ntap-']],
    'ntapsd-no'                      => ["Host/Client NetApp SnapDrive NOT allowed",[]],
    'tape-drv'                       => ["Tape Drives",[]],
    'ontap.san-toolkit.sanlun'       => ["Host/Client rebranded SAN Toolkit sanlun installed",['-all-client-ntap-'],],
    'ontap.san-toolkit.scripts'      => ["Host/Client rebranded SAN Toolkit scripts installed",['-all-client-ntap-'],],
    'ontap.mpio-attach-kit.config'   => ["Host/Client rebranded MPIO Attach Kit Path Config Tool installed",['-all-client-ntap-'],],
    'ontap.mpio-attach-kit.fcp'      => ["Host/Client rebranded MPIO Attach Kit Path FCP Disk ODM Stanzas installed",['-all-client-ntap-'],],
    'ontap.mpio-attach-kit.iscsi'    => ["Host/Client rebranded MPIO Attach Kit iSCSI Disk ODM Stanzas installed",['-all-client-ntap-'],],
    'ontap.mpio-attach-kit.pcmodm'   => ["Host/Client rebranded MPIO Attach Kit PCM Friend ODM Stanzas installed",['-all-client-ntap-'],],
    'ontap-'      => ["OnTAP kernels",['-all-filer-']],
    'ontap-b-'    => ["OnTAP build names",['ontap-'],'ontap-b-%'],
    'ontap-d'     => ["OnTAP debug kernel",['ontap-']],
    'ontap-d-no'  => ["OnTAP non-debug kernel",['ontap-']],
    'ontap-o'     => ["OnTAP optimized kernel",['ontap-']],
    'ontapdsm'                       => ["Host/Client Data ONTAP DSM installed",[''],],
    'ontapdsm-mpio'                  => ["Host/Client Data ONTAP DSM MPIO DDK installed",[''],],
    'ontapdsm-mpio-fcp'              => ["Host/Client Data ONTAP DSM MPIO DDK with FCP support",['ontapdsm-mpio'],],
    'ontapdsm-mpio-fcp-foo'        => ["Host/Client Data ONTAP DSM MPIO DDK with FCP and Fail Over Only load balancing",['ontapdsm-mpio-fcp'],],
    'ontapdsm-mpio-fcp-lqd'        => ["Host/Client Data ONTAP DSM MPIO DDK with FCP and Dynamic Least Queue Depth load balancing",['ontapdsm-mpio-fcp'],],
    'ontapdsm-mpio-fcp-rr'         => ["Host/Client Data ONTAP DSM MPIO DDK with FCP and Round-Robin load balancing",['ontapdsm-mpio-fcp'],],
    'ontapdsm-mpio-fcp-rrws'       => ["Host/Client Data ONTAP DSM MPIO DDK with FCP and Round-Robin with Subset of Paths load balancing",['ontapdsm-mpio-fcp'],],
    'ontapdsm-mpio-fcp-wp'         => ["Host/Client Data ONTAP DSM MPIO DDK with FCP and Weighted Paths load balancing",['ontapdsm-mpio-fcp'],],
    'ontapdsm-mpio-iscsi'            => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI support",['ontapdsm-mpio'],],
    'ontapdsm-mpio-iscsi-foo'        => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI and Fail Over Only load balancing",['ontapdsm-mpio-iscsi'],],
    'ontapdsm-mpio-iscsi-lqd'        => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI and Dynamic Least Queue Depth load balancing",['ontapdsm-mpio-iscsi'],],
    'ontapdsm-mpio-iscsi-rr'         => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI and Round-Robin load balancing",['ontapdsm-mpio-iscsi'],],
    'ontapdsm-mpio-iscsi-rrws'       => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI and Round-Robin with Subset of Paths load balancing",['ontapdsm-mpio-iscsi'],],
    'ontapdsm-mpio-iscsi-wp'         => ["Host/Client Data ONTAP DSM MPIO DDK with iSCSI and Weighted Paths load balancing",['ontapdsm-mpio-iscsi'],],
    'osx'                            => ["Client with Mac OS X operating system",['-all-client-os-']],
    'pti'                            => ["Client with Aries PTI tool",['-all-client-test-']],
    'quicktime'                      => ["NetCache quicktime service",['nc-services-']],
    'Rxxx'  => ["NearStore filer",['filer','-all-filer-families-']],
    'R1xx'  => ["R1xx NearStore filer",['Rxxx']],
    'R100'  => ["R100 filer",['R1xx','fcpus-2']],
    'R150'  => ["R150 filer",['R1xx','fcpus-2']],
    'R2xx'  => ["R2xx NearStore filer",['Rxxx']],
    'R200'  => ["R200 filer",['R2xx','fcpus-2']],
    'R210'  => ["R210 filer",['R2xx','fcpus-1','deux-filer']],
    'R230'  => ["R230 filer",['R2xx','fcpus-2']],
    
    'rapid-restore'                  => ["Filer rapid_restore service",['-all-filer-services-']],
    'rawio'                          => ["Client with raw I/O capabilities",[]],
    'real'                           => ["NetCache real service",['nc-services-']],
    'real-pro'                       => ["NetCache real_pro service",['nc-services-']],
    'real-ultra'                     => ["NetCache real_ultra service",['nc-services-']],
    'rh7.2'      => ["Client with Redhat 7.2 Linux operating system",['linux-rh']],
    'rh7.3'      => ["Client with Redhat 7.3 Linux operating system",['linux-rh']],
    'rh8.0'      => ["Client with Redhat 8.0 Linux operating system",['linux-rh']],
    'rh9.0'      => ["Client with Redhat 9.0 Linux operating system",['linux-rh']],
    'rpc'             => ["Machine with power_cycle (remote power control)",['rpc']],
    'rpc-none'        => ["Machine with NO remote power control",[]],
    'rpc-powercycle' => ["Machine with power_cycle (remote power control)",['rpc']],
    'rpc-rpower'     => ["Machine with rpower (remote power control)",['rpc']],
    
    'SAxxx'  => ["Storage Accelator Appliances",['filer','-all-filer-families-']],
    'SAxxxA' => ["Storage Accelator Appliances",['filer','-all-filer-families-']],
    'SA200'  => ["S200 Storage Accelator Appliance",['SAxxx']],
    'SA300'  => ["S300 Storage Accelator Appliance",['SAxxx']],
    'SA310'  => ["S310 Storage Accelator Appliance",['SAxxx','SPECTRE-h']],
    'SA600'  => ["S600 Storage Accelator Appliance",['SAxxx']],
    'SA200A' => ["S200A Storage Accelator Appliance",['SA200','SAxxxA']],
    'SA300A' => ["S300A Storage Accelator Appliance",['SA300','SAxxxA']],
    'SA310A' => ["S310A Storage Accelator Appliance",['SA310','SAxxxA']],
    'SA600A' => ["S600A Storage Accelator Appliance",['SA600','SAxxxA']],
    
    'Sxxx'  => ["StoreVault filers",['filer','-all-filer-families-']],
    'S300'  => ["S300 (Lynx) filer",['Sxxx']],
    'S500'  => ["S500 (Puma) filer",['Sxxx','fcpus-1']],
    'S550'  => ["S550 (Panther) filer",['Sxxx']],
    'S700'  => ["S700 (Cheetah) filer",['Sxxx']],
    
    'SPECTRE'   => ["Spectre platform filers",['-all-filer-platforms-']],
    'SPECTRE-h' => ["Spectre-High platform filers",['SPECTRE','fcpus-4']],
    'SPECTRE-l' => ["Spectre-Low platform filers",['SPECTRE','fcpus-2']],
    
    's-fcp'    => ["FCP Switches",['-all-switch-']],
    's-ip'     => ["IP Switches",['-all-switch-']],
    's-jumbo'                        => ["Switch supporting jumbo frames",['s-ip']],
    's-jumbo-no'                     => ["Switch NOT supporting jumbo frames",['s-ip']],
    's-vifs'                         => ["Switch supporting VIFS",['s-ip']],
    's-vlan'                         => ["Switch supporting VLAN",['s-ip']],
    'sanlun'   => ["Client with sanlun utility",[],"sanlun-\%.\%"],
    'sanown'                         => ["filer recognizes the 'disk' (was once the 'sanown') command",['-all-filer-cfo-']],
    'santoolkit'                     => ["",[]],
    'sasha'    => ["Filer SAS Host Adapters",[]],
    'scsi'                           => ["Filer with either FCP or iSCSI licensed",[]],
    'noscsi'                         => ["Filer with neither FCP nor iSCSI licensed",[]],
    'shuar'                          => ["Shuar platform filers and netcaches",['-all-filer-platforms-']],
    'shuar-filer'                    => ["Shuar platform filers",['shuar']],
    'shuar-no'                       => ["Non Shuar platforms",['-all-filer-platforms-']],
    'sim-filer'                      => ["Simulated filer",['-all-filer-platforms-']],
    'sim-filer-linux'                => ["Simulated filer on Linux",['sim-filer']],
    'sim-filer-solaris'              => ["Simulated filer on Solaris",['sim-filer']],
    'sles'    => ["SuSE Linux Enterprise Server",['linux-suse']],
    'smdomino'                       => ["Filer smdomino service",['-all-filer-services-']],
    'smsql'                          => ["Filer smsql service",['-all-filer-services-']],
    'snaplock'                       => ["Filer snaplock Snaplock Compliance WORM Functionality service",['-all-filer-services-']],
    'snaplock-enterprise'            => ["Filer snaplock_enterprise service",['-all-filer-services-']],
    'snapmanagerexchange'            => ["Filer snapmanagerexchange service",['-all-filer-services-']],
    'snapmirror'                     => ["Filer snapmirror service",['-all-filer-services-']],
    'snapmirror-sync'                => ["Filer snapmirror_sync service",['-all-filer-services-']],
    'snapmover'                      => ["Filer snapmover service",['-all-filer-services-']], 
    'nosnapmover'                    => ["Filer snapmover service NOT allowed",['-all-filer-services-']],
    'snaprestore'                    => ["Filer snaprestore service",['-all-filer-services-']],
    'snapvalidator'                  => ["Filer snapvalidator service",['-all-filer-services-']],
    'nosnapvalidator'                => ["Filer snapvalidator service NOT allowed",['-all-filer-services-']],
    'solaris'    => ["Client with Solaris operating system",['unix','rawio']],
    'solaris-32' => ["Client with 32bit Solaris operating system",['solaris']],
    'solaris-64' => ["Client with 64bit Solaris operating system",['solaris']],
    'solaris6'   => ["Client with Solaris 6 operating system",['solaris']],
    'solaris7'   => ["Client with Solaris 7 operating system",['solaris']],
    'solaris8'   => ["Client with Solaris 8 operating system",['solaris']],
    'solaris9'   => ["Client with Solaris 9 operating system",['solaris']],
    'solaris10'  => ["Client with Solaris 10 operating system",['solaris','h-nfsv4']],
    'sparc-app-32'      => ["Client with SPARC 32 bit instruction set",['hcpu-sparc']],
    'sparc-app-64'      => ["Client with SPARC 64 bit instruction set",['hcpu-sparc']],
    'socks'                          => ["NetCache SOCKS protocol service",['nc-services-']],
    'stache'                         => ["NetCache stache service",['nc-services-']],
    'suse8.0'    => ["Client with SuSE Linux 8.0 operating system",['linux-suse']],
    'suse8.0sp3' => ["Client with SuSE Linux 8.0 SP3 operating system",['linux-suse']],
    'suse8.0sp4' => ["Client with SuSE Linux 8.0 SP4 operating system",['linux-suse']],
    'suse8.1'    => ["Client with SuSE Linux 8.1 operating system",['linux-suse']],
    'suse9.0'    => ["Client with SuSE Linux 9.0 operating system",['linux-suse']],
    'suse9.1'    => ["Client with SuSE Linux 9.1 operating system",['linux-suse']],
    'sv-dr-linux-pri'                => ["Filer sv_dr_linux_pri SnapVault Disaster Recovery Open Systems Linux Primary service",['-all-filer-services-']],
    'sv-dr-ontap-pri'                => ["Filer sv_dr_ontap_pri SnapVault Disaster Recovery ONTAP Primary service",['-all-filer-services-']],
    'sv-dr-unix-pri'                 => ["Filer sv_dr_unix_pri SnapVault Disaster Recovery OpenSystems Unix Primary service",['-all-filer-services-']],
    'sv-dr-windows-pri'              => ["Filer sv_dr_windows_pri SnapVault Disaster Recovery Open Systems Windows Primary service",['-all-filer-services-']],
    'sv-linux-pri'                   => ["Filer sv_linux_pri service",['-all-filer-services-']],
    'sv-ontap-pri'                   => ["Filer sv_ontap_pri service",['-all-filer-services-']],
    'sv-ontap-sec'                   => ["Filer sv_ontap_sec service",['-all-filer-services-']],
    'sv-unix-pri'                    => ["Filer sv_unix_pri service",['-all-filer-services-']],
    'sv-windows-ofm-pri'             => ["Filer sv_windows_ofm_pri service",['-all-filer-services-']],
    'sv-windows-pri'                 => ["Filer sv_windows_pri service",['-all-filer-services-']],
    'syncmirror-local'               => ["Filer syncmirror-local service",['-all-filer-storage-disk-layouts-']],
    'nosyncmirror-local'             => ["Filer syncmirror-local service NOT allowed",['-all-filer-storage-disk-layouts-']],
    'syncmirrored' => ["",['local-snapmirror']],
    'notsyncmirrored'                => ["",[]],
    'tar-hba-ql2342'                 => ["Filer with QL2342 target HBAs",[]],
    'tar-hba-ql2342-1'               => ["Filer with 1 QL2342 target HBA",['tar-hba-ql2342']],
    'tar-hba-ql2342-2'               => ["Filer with 2 QL2342 target HBAs",['tar-hba-ql2342']],
    'tar-hba-ql2342-3'               => ["Filer with 3 QL2342 target HBAs",['tar-hba-ql2342']],
    'tar-hba-ql2342-4'               => ["Filer with 4 QL2342 target HBAs",['tar-hba-ql2342']],
    'tar-hba-ql2352'                 => ["Filer with QL2352 target HBAs",[]],
    'tar-hba-ql2352-1'               => ["Filer with 1 QL2352 target HBA",['tar-hba-ql2352']],
    'tar-hba-ql2352-2'               => ["Filer with 2 QL2352 target HBAs",['tar-hba-ql2352']],
    'tar-hba-ql2352-3'               => ["Filer with 3 QL2352 target HBAs",['tar-hba-ql2352']],
    'tar-hba-ql2352-4'               => ["Filer with 4 QL2352 target HBAs",['tar-hba-ql2352']],
    'tar-hba-ql2362'                 => ["Filer with QL2362 target HBAs",[]],
    'tar-hba-ql2362-1'               => ["Filer with 1 QL2362 target HBA",['tar-hba-ql2362']],
    'tar-hba-ql2362-2'               => ["Filer with 2 QL2362 target HBAs",['tar-hba-ql2362']],
    'tar-hba-ql2362-3'               => ["Filer with 3 QL2362 target HBAs",['tar-hba-ql2362']],
    'tar-hba-ql2362-4'               => ["Filer with 4 QL2362 target HBAs",['tar-hba-ql2362']],
    'tar-hba-ql2462'                 => ["Filer with QL2462 target HBAs",[]],
    'tar-hba-ql2462-1'               => ["Filer with 1 QL2462 target HBA",['tar-hba-ql2462']],
    'tar-hba-ql2462-2'               => ["Filer with 2 QL2462 target HBAs",['tar-hba-ql2462']],
    'tar-hba-ql2462-3'               => ["Filer with 3 QL2462 target HBAs",['tar-hba-ql2462']],
    'tar-hba-ql2462-4'               => ["Filer with 4 QL2462 target HBAs",['tar-hba-ql2462']],
    'tar-hba-qle2462'                => ["Filer with QLE2462 target HBA",[]],
    'tar-hba-qle2462-1'              => ["Filer with 1 QLE2462 target HBA",['tar-hba-qle2462']],
    'tar-hba-qle2462-2'              => ["Filer with 2 QLE2462 target HBAs",['tar-hba-qle2462']],
    'tar-hba-qle2462-3'              => ["Filer with 3 QLE2462 target HBAs",['tar-hba-qle2462']],
    'tar-hba-qle2462-4'              => ["Filer with 4 QLE2462 target HBAs",['tar-hba-qle2462']],
    'tar-hba-qle2464'                => ["Filer with QLE2464 target HBA",[]],
    'tar-hba-qle2464-1'              => ["Filer with 1 QLE2464 target HBA",['tar-hba-qle2464']],
    'tar-hba-qle2464-2'              => ["Filer with 2 QLE2464 target HBAs",['tar-hba-qle2464']],
    'tar-hba-qle2464-3'              => ["Filer with 3 QLE2464 target HBAs",['tar-hba-qle2464']],
    'tar-hba-qle2464-4'              => ["Filer with 4 QLE2464 target HBAs",['tar-hba-qle2464']],
    'tar-hba-1'                      => ["Filer with 1 target HBA",[]],
    'tar-hba-2'                      => ["Filer with 2 target HBAs",[]],
    'tar-hba-3'                      => ["Filer with 3 target HBAs",[]],
    'tar-hba-4'                      => ["Filer with 4 target HBAs",[]],
    'tar-iscsi-hw'                   => ["Filer has at least one iSCSI hardware target HBA",[]],
    'tar-iscsi-hw-no'                => ["Filer has NO iSCSI hardware target HBAs",[]],
    'tar-iscsi-hw-emulex'            => ["Emulex iSCSI target HBAs",[]],
    'tar-iscsi-hw-emulex-lpe100i.d1' => ["Emulex iSCSI target 1 GbE dual Cu (LPe100i-D1)",['f-eth-x1129a-r5']],
    'tar-iscsi-hw-emulex-lpe100i.f1' => ["Emulex iSCSI target 1 GbE dual FO (LPe100i-F1)",['f-eth-x1136a-r5']],
    'tar-iscsi-sw'           => ["Filer has at least one iSCSI software target",[]],
    'tar-iscsi-sw-no'        => ["Filer has NO iSCSI software target",[]],
    'tb-'    => ["Filer storage capacity",[],'%tb'],
    'telnet-proxy'           => ["NetCache telnet_proxy service",['nc-services-']],
    'unix'   => ["Client with a UNIX operating system",['-all-client-os-']],
    
    'Vxxxx'  => ["V-series filer",['filer','-all-filer-families-']],
    'Vxxxxc' => ["V-series clustered filer",['filer','-all-filer-families-']],
    'V2xxx'  => ["V2xxx V-series filer",['Vxxxx']],
    'V2xxxc' => ["V2xxx V-series clustered filer",['Vxxxxc']],
    'V2020'  => ["V2020 filer",['V2xxx','fcpus-1','shuar-filer']],
    'V2020c' => ["V2020 clustered filer",['V2020','V2xxxc']],
    'V2050'  => ["V2050 filer",['V2xxx','fcpus-1','shuar-filer']],
    'V2050c' => ["V2050 clustered filer",['V2050','V2xxxc']],
    'V3xxx'  => ["V3xxx V-series filer",['Vxxxx']],
    'V3xxxc' => ["V3xxx V-series clustered filer",['Vxxxxc']],
    'V3020'  => ["V3020 filer",['V3xxx','fcpus-2','deux-filer']],
    'V3020c' => ["V3020 clustered filer",['V3020','V3xxxc']],
    'V3040'  => ["V3040",['V3xxx','fcpus-2']],
    'V3040c' => ["V3040 clustered filer",['V3040','V3xxxc']],
    'V3050'  => ["V3050 filer",['V3xxx','fcpus-4','deux-filer']],
    'V3050c' => ["V3050 clustered filer",['V3050','V3xxxc']],
    'V3140'  => ["V3140",['V3xxx','SPECTRE-l']],
    'V3140A' => ["V3140A filer",['V3140c']],
    'V3140c' => ["V3140 clustered filer",['V3140','V3xxxc']],
    'V3170'  => ["V3170",['V3xxx','SPECTRE-h']],
    'V3170A' => ["V3170A filer",['V3170c']],
    'V3170c' => ["V3170 clustered filer",['V3170','V3xxxc']],
    'V6xxx'  => ["V6xxx V-series filer",['Vxxxx']],
    'V6xxxc' => ["V6xxx V-series clustered filer",['Vxxxxc']],
    'V6030'  => ["V6030 filer",['V6xxx','fcpus-2']],
    'V6030A' => ["V6030A filer",['V6030c']],
    'V6030c' => ["V6030 clustered filer",['V6030','V6xxxc']],
    'V6040'  => ["V6040 filer",['V6xxx','fcpus-2']],
    'V6040A' => ["V6040A filer",['V6040c']],
    'V6040c' => ["V6040 clustered filer",['V6030','V6xxxc']],
    'V6070'  => ["V6070 filer",['V6xxx','fcpus-4']],
    'V6070A' => ["V6070A filer",['V6xxx','fcpus-4']],
    'V6070c' => ["V6070 clustered filer",['V6070','V6xxxc']],
    'V6080'  => ["V6080 filer",['V6xxx','fcpus-8']],
    'V6080A' => ["V6080A filer",['V6080c']],
    'V6080c' => ["V6080 clustered filer",['V6080','V6xxxc']],
    'VTLxxx'  => ["VTL filers",['filer','-all-filer-families-']],
    'VTL300'  => ["VTL300 filer",['VTLxxx']],
    'VTL1400' => ["VTL1400 filer",['VTLxxx']],
    'VTL700'  => ["VTL700 filer",['VTLxxx']],
    
    'v-'     => ["Filer volume attributes",['-all-filer-volume-attributes-']],
    'v-extents'              => ["filer has at least one volume configured with WAFL extents enabled",['v-']],
    'v-flex'                 => ["filer has at least one flexible volume configured",['v-']],
    'v-raid0'                => ["filer has at least one volume configured with RAID 0",['v-']],
    'v-raid4'                => ["filer has at least one volume configured with RAID 4",['v-']],
    'v-raiddp'               => ["filer has at least one volume configured with RAID DP",['v-']],
    'v-series'                       => ["Filer v-series service",['-all-filer-services-']],
    'v-svo'                  => ["filer has at least one volume with SnapValidator for Oracle",['v-']],
    'v-svo-no'               => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) not enabled",['v-']],
    'v-svo-checksum'         => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) checksumming enabled",['v-svo']],
    'v-svo-checksum-no'      => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) checksumming disabled",['v-svo']],
    'v-svo-rman'             => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) allow RMAN enabled",['v-svo']],
    'v-svo-rman-no'          => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) allow RMAN disabled",['v-svo']],
    'v-svo-reject-errors'    => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) reject errors enabled",['v-svo']],
    'v-svo-reject-errors-no' => ["filer has at least one volume with SnapValidator (Oracle H.A.R.D.) reject errors disabled",['v-svo']],
    'v-trad'                 => ["filer has at least one traditional volume configured",['v-']],
    'vfiler'                 => ["Filer Multistore service",['-all-filer-services-']],
    'novfiler'               => ["Filer Multistore service NOT allowed",['-all-filer-services-']],
    'vi'                     => ["VI interconnect HBA",['ic-']],
    'vld'                    => ["Filer VLD service",['-all-filer-services-']],
    'novld'                  => ["Filer VLD service NOT allowed",['-all-filer-services-']],
    'vm-lvm'                 => ["LVM volume manager",[]],
    'vm-vxvm'                => ["VXVM volume manager",[]],
    'waffinity'              => ["Filer has enabled waffinity use",['-all-filer-services-']],
    'waffinity-no'           => ["Filer does not have waffinity",['-all-filer-services-']],
    'wafl-compression'       => ["Filer has WAFL Compression service",['-all-filer-services-']],
    'win'          => ["Client with Windows operating system",['-all-client-os-','rawio','fs-ntfs']],
    'win-'         => ["Windows builds",['win'],'win-_._.____%'],
    'win03'        => ["Client with Windows 2003 operating system",['win']],
    'win03-32'     => ["Client with Windows 2003 32bit operating system",['win03']],
    'win03-32-sp2' => ["Client with Windows 2003 SP2 32bit operating system",['win03']],
    'win03-64'     => ["Client with Windows 2003 64bit operating system",['win03']],
    'win08'        => ["Client with Windows 2008 Server Enterprise Edition",['win']],
    'win08r2'      => ["Client with Windows 2008 Server R2 Enterprise Edition",['win08']],
    'win08-32'     => ["Client with Windows 2008 Server Enterprise Edition 32bit",['win08']],
    'win08-x64'    => ["Client with Windows 2008 Server Enterprise Edition Intel 64bit",['win08']],
    'win08-i64'    => ["Client with Windows 2008 Server Enterprise Edition Itanium 64bit",['win08']],
    'win08c'       => ["Client with Windows 2008 Server Core operating system",['win']],
    'win08c-32'    => ["Client with Windows 2008 Server Core 32bit operating system",['win08c']],
    'win08c-64'    => ["Client with Windows 2008 Server Core 64bit operating system",['win08c']],
    'win08d'       => ["Client with Windows 2008 Server Datacenter Edition",['win']],
    'win08dr2'     => ["Client with Windows 2008 Server R2 Datacenter Edition",['win08d']],
    'win08d-32'    => ["Client with Windows 2008 Server 32bit Datacenter Edition",['win08d']],
    'win08d-x64'   => ["Client with Windows 2008 Server Intel 64bit Datacenter Edition",['win08d']],
    'win08s'       => ["Client with Windows 2008 Server Standard Edition",['win']],
    'win08s-32'    => ["Client with Windows 2008 Server 32bit Standard Edition",['win08s']],
    'win08s-x64'   => ["Client with Windows 2008 Server Intel 64bit Standard Edition",['win08s']],
    'win7'         => ["Client with Windows Server 7 Enterprise Edition",['win']],
    'win2k'        => ["Client with Windows 2000 operating system",['win']],
    'win2k-sp2'    => ["Client with Windows 2000 SP2 operating system",[]],
    'win2k-sp3'    => ["Client with Windows 2000 SP3 operating system",[]],
    'win2k-sp4'    => ["Client with Windows 2000 SP4 operating system",[]],
    'winlh'        => ["Client with Windows Longhorn operating system",['win']],
    'winvista'     => ["Client with Windows Vista operating system",['win']],
    'winnt'        => ["Client with Windows NT operating system",['win']],
    'winnt-sp6a'   => ["Client with Windows NT SP6a operating system",['winnt']],
    'winxp'        => ["Client with Windows XP operating system",['win']],
    'winxp-32'     => ["Client with Windows XP 32bit operating system",['winxp']],
    'winxp-x64'    => ["Client with Windows XP Intel 64bit operating system",['winxp']],
    'winxp-sp1'    => ["Client with Windows XP SP1 operating system",['winxp']],
    'winxp-sp2'    => ["Client with Windows XP SP2 operating system",['winxp']],
    'wm'                     => ["NetCache wm service",['nc-services-']],
    'nowm'                   => ["NetCache wm service NOT allowed",['nc-services-']],
    'wm-pro'                 => ["NetCache wm_pro service",['nc-services-']],
    'nowm-pro'               => ["NetCache wm_pro service NOT allowed",['nc-services-']],
    'wm-ultra'               => ["NetCache wm_ultra service",['nc-services-']],
    'nowm-ultra'             => ["NetCache wm-ultra service NOT allowed",['nc-services-']],
    'worm'         => ["Filer worm service",['-all-filer-services-']], 
    'X232-ST173404FC'  => ["Seagate-Cheetah-4-72",['dd-cheetah4']],
    'X234-ST336704FC'  => ["Seagate-Cheetah-4-36",['dd-cheetah4']],
    'X234-SCHT5036F10' => ["Seagate-Cheetah-5-36",['dd-cheetah5']],
    'X235-SCHT5073F10' => ["Seagate-Cheetah-5-72",['dd-cheetah5']],
    'X234-SCHT6036F10' => ["Seagate-Cheetah-6-36",['dd-cheetah6']],
    'X235-SCHT6073F10' => ["Seagate-Cheetah-6-72",['dd-cheetah6']],
    'X236-SCHT6146F10' => ["Seagate-Cheetah-6-144",['dd-cheetah6']],
    'X235-S10K7073F10' => ["Seagate-Cheetah-7 72GB 520BPS",['dd-cheetah7']],
    'X236-S10K7146F10' => ["Seagate-Cheetah-7 144GB 520BPS",['dd-cheetah7']],
    'X237-S10K7288F10' => ["Seagate-Cheetah-7 288GB 520BPS",['dd-cheetah7']],
    'X272-S10K7073F10' => ["Seagate-Cheetah-7 72GB 520BPS",['dd-cheetah7']],
    'X274-S10K7146F10' => ["Seagate-Cheetah-7 144GB 520BPS",['dd-cheetah7']],
    'X276-S10K7288F10' => ["Seagate-Cheetah-7 288GB 520BPS",['dd-cheetah7']],
    'X233-HJURD018F10' => ["Hitachi-Jura-D-18",['dd-jura-d']],
    'X234-HJURD036F10' => ["Hitachi-Jura-D-36",['dd-jura-d']],
    'X235-HJURD073F10' => ["Hitachi-Jura-D-72",['dd-jura-d']],
    'X234-HJURE036F10' => ["Hitachi-Jura-E-36",['dd-jura-e']],
    'X235-HJURE073F10' => ["Hitachi-Jura-E-72",['dd-jura-e']],
    'X236-HJURE146F10' => ["Hitachi-Jura-E-144",['dd-jura-e']]
    );

# Define prefix values that imply a configuration type value
# This is best limited to supporting version configuration types
# whose new values are expected to be detected by testbed_setup.
# Anything with one of these prefix values will be accepted.
# Please limit this use so that misspelling errors will be detected. 
# Only a single match from this hash is expected.
# This list is search fully, so multiple implications are allowed
my %implied_by_prefix_configs = (
   '(\d+)tb$' => 'tb-',
   '(aix\d+)\.' => 'aix',
   'aix5\.3' => 'h-nfsv4',
   '(ap-)' => '$1',
   '(ap-oracle)-(9r2|10g)' => '$1',
   '(be)-' => '$1',
   '(be-brcd\d)\d\d\d$' => '${1}xxx',
   '(be-csco\d)\d\d\d$' => '${1}xxx',
   '(be-mcdt\d)\d\d\d$' => '${1}xxx',
   '(be-ql\d\d\d\d)-boot-' => '$1',
   '(be-ql\d\d\d\d)-fw-' => '$1',
   '(be-ql\d)\d\d\d$' => '${1}xxx',
   '(be-ql)\dxxx' => '$1',
   '(brcd)-v' => '$1',
   'centos\d+\.?\d*$' => 'linux-centos',
   '(d-fw-)' =>  '$1',
   
   '(dd-.*)-failed-.*$' => '$1',
   
   '(dd-cheetah\d+k\d+-\d+\.?\d*)-\w+$' => '$1',
   '(dd-cheetah\d+k\d+)-\d+\.?\d*$' => '$1',
   
   '(dd-cheetah\d-\d+\.?\d*)-\w+$' => '$1',
   '(dd-cheetah\d)-\d+\.?\d*$' => '$1',
   
   '(dd-cuda-\d+\.?\d*)-\w+$' => '$1',
   '(dd-cuda)-\d+\.?\d*$' => '$1',
   
   '(dd-dec-\d+\.?\d*)-\w+$' => '$1',
   '(dd-dec)-\d+\.?\d*$' => '$1',
   
   '(dd-fal[a-z0-9]+-\d+\.?\d*)-\w+$' => '$1',
   '(dd-fal[a-z0-9]+)-\d+\.?\d*$' => '$1',
   
   '(dd-fujitsu-\d+\.?\d*)-\w+$' => '$1',
   '(dd-fujitsu)-\d+\.?\d*$' => '$1',
   
   '(dd-galaxy-\d+\.?\d*)-\w+$' => '$1',
   '(dd-galaxy)-\d+\.?\d*$' => '$1',
    
   '(dd-gemi-\d+\.?\d*)-\w+$' => '$1',
   '(dd-gemi)-\d+\.?\d*$' => '$1',
    
   '(dd-hkuro-\d+\.?\d*)-\w+$' => '$1',
   '(dd-hkuro)-\d+\.?\d*$' => '$1',
   
   '(dd-hpyta-\d+\.?\d*)-\w+$' => '$1',
   '(dd-hpyta)-\d+\.?\d*$' => '$1',
   
   '(dd-ibm-\d+\.?\d*)-\w+$' => '$1',
   '(dd-ibm)-\d+\.?\d*$' => '$1',
   
   '(dd-ibm[a-z0-9]+-\d+\.?\d*)-\w+$' => '$1',
   '(dd-ibm[a-z0-9]+)-\d+\.?\d*$' => '$1',
   
   '(dd-jura-[de]-\d+\.?\d*)-\w+$' => '$1',
   '(dd-jura-[de])-\d+\.?\d*$' => '$1',
   
   '(dd-maxtor-\d+\.?\d*)-\w+$' => '$1',
   '(dd-maxtor)-\d+\.?\d*$' => '$1',
   
   '(dd-max[a-z0-9]+-\d+\.?\d*)-\w+$' => '$1',
   '(dd-max[a-z0-9]+)-\d+\.?\d*$' => '$1',
   
   '(dd-seagate-\d+\.?\d*)-\w+$' => '$1',
   '(dd-seagate)-\d+\.?\d*$' => '$1',
   
   '(dd-seagate15k\d-\d+\.?\d*)-\w+$' => '$1',
   '(dd-seagate15k\d)-\d+\.?\d*$' => '$1',
   '(dd-seagate15k)\d$' => '$1',
   
   '(dd-stonk-\d+\.?\d*)-\w+$' => '$1',
   '(dd-stonk)-\d+\.?\d*$' => '$1',
   
   '(dd-unisys-\d+\.?\d*)-\w+$' => '$1',
   '(dd-unisys)-\d+\.?\d*$' => '$1',
   
   '(dd-vd-\d+\.?\d*)-\w+$' => '$1',
   '(dd-vd)-\d+\.?\d*$' => '$1',
   
   '(dd-unknown-\d+\.?\d*)-\w+$' => '$1',
   '(dd-unknown)-\d+\.?\d*$' => '$1',
   
   '(dmp-mpio-mpdev)-\d+\.' => '$1',
   '(dmp-mpio-mpspfltr)-\d+\.' => '$1',
   '(dmp-mpio-sys)-\d+\.' => '$1',
   '(dmp-mpio)-' => '$1',
   '(dmp-sanpath)\.' => '$1',
   'ds-ds14-(lrc)-\d+g'  => 'ds-$1',
   'ds-ds14mk[24]-fc-(lrc)-\d+g'  => 'ds-$1',
   'ds-ds14-(esh[24]?)-\d+g' => 'ds-$1', 
   'ds-ds14mk[24]-(esh[24]?)-\d+g' => 'ds-$1', 
   'ds-ds14mk[24]-at-(fcx)-\d+g'  => 'ds-$1',
   'ds-ds14mk[24]-at-(scm2?)-\d+g' => 'ds-$1',
   '(ds-ds14-esh)-\d+g' => '$1', 
   '(ds-ds14-esh2)-\d+g' => '$1', 
   '(ds-ds14-esh4)-\d+g' => '$1', 
   '(ds-ds14-lrc)-\d+g' => '$1', 
   '(ds-ds14mk[24]-at-fcx)-\d+g'  => '$1',
   '(ds-ds14mk[24]-at-scm2?)-\d+g' => '$1',
   '(ds-ds14mk[24]-fc-esh[24]?)-\d+g'  => '$1',
   '(ds-ds14mk[24]-fc-lrc)-\d+g'  => '$1',
   '(ds-ds24-sas)-\d+g' => '$1', 
   '(ds-esh)-fw-\S+'  => '$1', 
   '(ds-esh2)-fw-\S+' => '$1', 
   '(ds-esh4)-fw-\S+' => '$1', 
   '(ds-fcx)-fw-\S+'  => '$1', 
   '(ds-lrc)-fw-\S+'  => '$1', 
   '(ds-sas)-fw-\S+'  => '$1', 
   '(ds-scm)-fw-\S+'  => '$1', 
   '(ds-scm2)-fw-\S+' => '$1', 
   
   '(f-accel)-[ivx]+$'           => '$1',  # versions
   '(f-accel)-(fpga|fpgab|rev|size)-'    => '$1',
   
   '(f-eth-mb-bcm5703)\S+' => '$1',        # map possible device types and versions
   '(f-eth-mb-[^-]+)-(dt|v)-\S+' => '$1',  # device types and versions
   '(f-eth-x\d\d\d\d)[a-zA-Z]' => '$1',
   '(f-eth-)x\d\d\d\d$' => '$1',
   '(f-eth-x\d\d\d\d[a-z])-r\d' => '$1',
   '(f-eth-x\d\d\d\d[a-z])-dt-' => '$1',
   '(f-eth-x\d\d\d\d[a-z])-v-' => '$1',
   '(f-fw-agent)-'  => '$1',
   '(f-fw-bios)-'   => '$1',
   '(f-fw-cfe)-'    => '$1',
   '(f-fw-lcd)-'    => '$1',
   '(f-fw-loader)-' => '$1',
   '(f-fw)-\d+' =>  '$1',
   '(f-rlm)-\S+' =>  '$1',
   '(f-sp)-\S+'  =>  '$1',
   '(f-iscsi-mcs)-' => '$1',
   '(f-iscsi-merl-)' => '$1',
   '(f-nvram\d+)-' => '$1',
   '(f-nvram-size-).+' => '$1',
   '(fcha-[^-]*)-' => '$1',
   '(fcha)-' => '$1',
   '(fcp-aix)-\d+\.\d+' => '$1',
   '(fcp-hpux)-\d+\.\d+' => '$1',
   '(fcp-linux)-\d+\.\d+' => '$1',
   '(fcp-sun)-\d+\.\d+' => '$1',
   '(fcp-win)-\d+\.\d+' => '$1',
   'fedora\d+$' => 'linux-fedora',
   '(fe)-' => '$1',
   '(fe-brcd)\S+'      => '${1}',
   '(fe-csco)\S+'      => '${1}',
   '(fe-csco\d)\d\d\d$' => '${1}xxx',
   '(fe-fdy-\S+)-\S+'  => '${1}',
   '(fe-fdy)-\S+'      => '${1}',
   '(fe-mcdt)\d\d\d\d$' => '$1',
   '(fe-ql\d\d\d\d)-boot-' => '$1',
   '(fe-ql\d\d\d\d)-fw-' => '$1',
   '(fe-ql\d)\d\d\d$' => '${1}xxx',
   '(fe-ql)\dxxx' => '$1',
   '(fmem-)\d+' => '$1',
   '(fwhu\d+\.\d+)\.' => '$1',    # minor versions of fwhu
   '(fwhu)\d+' => '$1',           # FCP Windows Host Utilities
   '(ga-ddn)-\S+' => '$1',        # DataDirect Networks
   '(ga-engenio)\S+' => '$1',
   '(ga-flx)\d+' => '$1',
   '(ga-fujitsu)\S+' => '$1',
   '(ga-hds)\S+' => '$1',         # any 'scsi inquiry' product names
   '(ga-hds\d\d)\d\d$'  => '${1}xx',
   '(ga-hpeva)\d+' => '$1',
   '(ga-ibmfastt)\d+$'  => '${1}xxx',
   '(ga-lsi)\S+' => '$1',
   '(ga-stk)\S+' => '$1',
   '(h-mcs)-\d+' => '$1',
   'h-fix-' => '-all-client-fixes-',
   '(h-staf)-\d+' => '$1',        # Versions of STAF
   '(h-vm)-' => '$1',
   '(hba-brcm)-' => '$1',
   '(hba-intel)-' => '$1',
   '(hbios-[0-9a-z]+)-' => '$1',
   '(hp\d\d\.\d\d)\.\d+' => '$1',
   'hp\d\d\.\d\d' => 'hpux',
   '(hrsh-wrshdnt)-' => '$1',     # versions of Denicomp rshd
   'IBM-\d\d\d\d-\S\d\d' => 'ibm-model-', 
   '(init-hba-[0-9a-z\.]+)$' =>  'init-fcp',
   '(init-hba-d)-'          =>  'init-fcp',
   '(init-hba-fw)-'         =>  'init-fcp',
   '(init-hba-orom)-'       =>  'init-fcp',
   '(init-iscsi-sw-aix-\d+\.\d+)\.' =>  '$1',
   '(init-iscsi-sw-aix)-\d+.\d+$' => '$1',
   '(init-iscsi-sw-linux)-' => '$1',
   '(iscsi-aix)-' => '$1',
   '(iscsi-hpux)-' => '$1',
   '(iscsi-linux)-\d+\.\d+' => '$1',
   '(iscsi-ms2.0\d).' => '$1',
   '(iscsi-win)-\d+\.\d+' => '$1',
   '(linux)-(centos|fedora|gnu|oel|rh|suse).+' => '$1-$2',
   'o?ntap\.\S+[^\d]$' => '-all-client-ntap-',
   '(o?ntap\.\S+)-\d+(\.\d+){1,}$' => '$1',
   '(ntapsd\d+\.\d+)\.\d+\.\d+' => '$1',
   '(ntapsd)\d+\.\d+$' => '$1',
   '(ontap-b-)\S+' => '$1',
   '(ontapdsm-\d+\.\d+)\.\d+\.\d+$' => '$1',   # Fuquay=3.2 Dare=3.1 Drexel=3.0
   '(ontapdsm)-\d+\.\d+\.\d+\.\d+$' => '$1',
   '(ontapdsm-mpio)-\d+\.\d+\.\d+\.\d+$' => '$1',
   '(osx)-' => '$1',
   'rh(as|es|el)?\d+\.\d+' => 'linux-rh',
   '(rhas|rhes|rhel)\d+\.\d+' => '$1',
   '(sanlun-\d+\.\d+)-' => '$1',
   '(santoolkit)-\d+\.\d+(\.\d+)?' => '$1',
   '(sas)-[^-]+$' => '$1',
   '(sas-[^-]+)-fw-' => '$1',
   '(sles)\d+\.\d+$' => '$1',
   '(solaris\d+)-(32|64)$' => '$1',
   '(solaris)\d+$' => '$1',
   '(sparc-app-\d+)-v\d+$' => '$1',
   '(tar-hba-ql[e]?\d\d\d\d)-\d+$' => '$1',
   '(tar-hba-)\S+-(\d+)$' => '$1$2',
   '(tar-iscsi-hw-.*-.*)-' => '$1',   # iSCSI HW target HBA vendor and model
   '(tar-iscsi-hw-.*)-' => '$1',      # iSCSI HW target HBA vendor
   '(tar-iscsi-hw)-[^n][^o]' => '$1', # iSCSI HW target HBA
   '(X\d\d\d)-\S+' => '$1',
   '(X\d\d\d)$' => 'filer-disk-parts-',
   '(win2k|win03s?|win08[cds]?|winlh|winxp|winvista)-(32|64|i64|x64)-(sp\d+)-' => '$1-$2-$3',
   '(win2k|win03s?|win08[cds]?|win7|winlh|winxp|winvista)-(sp\d+)-' => '$1-$2',
   '(win2k|win03s?|win08[cds]?|win7|winlh|winxp|winvista)-' => '$1',
   '(win-\d+\.\d+\.\d\d\d\d)-' => '$1',
   '(win-\d+\.\d+)\.\d\d\d\d' => '$1',
   '(win)-\d+\.\d+' => '$1',
   );

#######################################################################
#
# Function:    append_unique_config
#
# Description: Convert invalid config type characters,
#              add an element to the list if it is
# 1) not there already
# 2) not an empty string
#
# Parameters:  item and list REFERENCE
#
# History:
# 2003-02-21 hedstrom: Initial Revision.
#######################################################################
sub append_unique_config($$) {
    my $item = shift;
    my $list_ref = shift;

    if (defined($item) && $item ne '') {
        # Underscore or slash are invalid in config types, convert to minus
        $item =~ s/[_\/]/-/g;
        # Drop other invalid characters:
        # braces, brackets, parens, angle brackets, 
        # comma, bang and caret
        $item =~ s/[\{\}\[\]\(\)\<\>\,\$\@\+\=\&\%\#\~\*\:\;\'\"\/\?\!\^]//g;
        # be careful of any valid meta characters in config types such as a period
        my $quote_meta = quotemeta($item);
        if (0 == grep(/^$quote_meta$/, @$list_ref) ) {
            push(@$list_ref,$item);
            return 1;
        }
    }
    return 0;
}

#######################################################################
#
# Function:    push_any_unique
#
# Description: Add an element to the list if it is
# 1) not there already
# 2) not an empty string
#
# Parameters:  list and newitem
# Returns 1 if the item was added, else 0
#
# History:
# 2003-10-16 hedstrom: Initial Revision.
#######################################################################
sub push_any_unique($$) {
   my $list = shift;
   my $item = shift;

   if ($item ne '') {
      no strict 'refs';
      # be careful of meta characters in config types (.)
      my $quote_meta = quotemeta($item);
      if (0 == grep(/^$quote_meta$/, @{$list}) ) {
         push(@{$list},$item);
         return 1;
      }
      use strict 'refs';
   }
   return 0;
}

## @name ::testbed_config_data
## @summary Returns the data associated with a configuration type
## @arg configuration type
sub testbed_config_data ($) {
    my $config_type = shift;
    if ($valid_configs{$config_type}) {
        return @{$valid_configs{$config_type}};
    }
    return undef;
}

## @name ::testbed_config_self_test
## @summary Returns 1 if the %valid_configs is consistent
sub testbed_config_self_test () {
 
    my $return = 1;
 
    my @implied_value_array;
    foreach my $type (keys %valid_configs) {
        if ($type) {
            if (defined(${$valid_configs{$type}}[1])) {
                push(@implied_value_array,@{$valid_configs{$type}[1]});
                # Verify each implied config type is valid
                foreach my $implied_type (@{$valid_configs{$type}[1]}) {
                    if (!testbed_config_type_check($implied_type)) {
                        print "Error: Config type: $type implies an undefined config type: $implied_type in \%valid_configs\n";
                        $return = 0;
                    }
                }
            } else {
                print "Info: No array of implied config types for: $type is defined in \%valid_configs\n";
            }
        } else {
            print "Error: Any empty string acts as a key to \%valid_configs\n";
        }
    }
 
    return $return;
}

## @name ::testbed_config_subtypes
## @summary Returns the complete list of configuration types 
## that directly imply the specified config type
## @arg configuration type
sub testbed_config_subtypes  ($) {
    my $testbed_config = shift;
    my $search_type = quotemeta($testbed_config);

    # Start with an empty list
    my @sub_types = ();
    # Pick up configuration types that imply $testbed_config
    foreach my $this_type (keys %valid_configs) {
        #print("Debug: $this_type implies: ".join(',',@{$valid_configs{$this_type}[1]})."\n");
        # Add each key if the value contains the specified config type
        if ( grep {/^$search_type$/} @{$valid_configs{$this_type}[1]} ) { 
           push_any_unique(\@sub_types,$this_type);
        }
    }
    return @sub_types;
}

## @name ::testbed_config_types
## @summary Returns the complete list of configuration types implied by the list passed in
## @arg list of configuration types
sub testbed_config_types  (@) {
    my @testbed_configs = @_;

    # Start with an empty list
    my @new_types = ();
    # Pick up configuration types implied from the test bed specification
    foreach my $this_type (@testbed_configs) {
        # Add each unique entry and whatever it implies
        testbed_implied_config_types($this_type,\@new_types);
    }

    # Add test bed config combinations - (these may not be supported in the future)
    my @testbedtypes;
    if ( 0 < (@testbedtypes = grep { /^fcp$/ } @new_types) ) { 
        if ( 0 < (@testbedtypes = grep { /^iscsi$/ } @new_types) ) { 
            push_any_unique(\@new_types,'fcpiscsi');
        }
    }
    return @new_types;
}

## @name ::testbed_implied_config_types
## @summary Inserts missing implied configuration types into the specified list
## $type a configuration type name
## @arg list of configuration types associated with this test bed
sub testbed_implied_config_types($$) {
    my $this_type = shift;
    my $testbed_configs = shift;

    # Only process this config type if it is not a config type category
    # (categories end in a minus sign)
    if ($this_type !~ m/-$/) {
        # Add the new configuration type if it is missing from the list
        if (push_any_unique($testbed_configs,$this_type)) {
            # Look for known prefix values that have implied configuration types
            foreach my $prefix (keys %implied_by_prefix_configs) {
                if ($this_type =~ m/^$prefix/) {
                    my $one = $1;
                    my $two = $2;
                    my $implied_type = $this_type;
                    my $change = $implied_by_prefix_configs{$prefix};
                    eval{$implied_type =~ s/^$prefix.*/$change/};
                    if ($@) {
                        warn("WARNING: Trouble determining implied config type from: $this_type for prefix: '$prefix' and change: '$change'\n$@\n");
                    } else {
                        # Experience shows that $1 types of arguments are NOT substituted from $change
                        # The following code forces those changes
                        $implied_type =~ s/\$1/$one/g;
                        $implied_type =~ s/\$\{1\}/$one/g;
                        $implied_type =~ s/\$2/$two/g;
                        $implied_type =~ s/\$\{2\}/$two/g;
                        if ($implied_type =~ m/[\$\_\/\{\}]/) {
                            warn("WARNING: Invalid implied config type: $implied_type from: $this_type for prefix: '$prefix' and change: '$change'\n");
                        } else {
                            #print("DEBUG: Config type: $this_type implies: $implied_type\n");
                            testbed_implied_config_types($implied_type,$testbed_configs);
                        }
                    }
                }
            }
            # Now see what this new one implies
            no strict 'refs';
            if ($valid_configs{$this_type}[1] && @{$valid_configs{$this_type}[1]}) {
                foreach my $implied_config (@{$valid_configs{$this_type}[1]}) {
                    testbed_implied_config_types($implied_config,$testbed_configs);
                }
            }
            use strict 'refs';
        }
    }
}

## @name ::testbed_unimplied_config_types
## @summary Removes configuration types implied by others in the specified list
## @arg reference to a list of configuration types
sub testbed_unimplied_config_types($) {
    my $testbed_configs = shift;
   
    my @unimplied_configs;
    my %implied_configs;
   
    # For each config type, see if it implies any others that are in this list
    foreach my $config (@{$testbed_configs}) {
        my @implied_configs = testbed_config_types($config);
        foreach my $implied_config (@implied_configs) {
            if ($implied_config ne $config) {
                $implied_configs{$implied_config} = 1;
            }
        }
    }
    foreach my $config (@{$testbed_configs}) {
        if (!defined($implied_configs{$config})) {
            push(@unimplied_configs,$config);
        }
    }

    return @unimplied_configs;
}

## @name ::testbed_config_type_check
## @summary Returns 1 if the input configuration type is valid
## @arg $configtype The configuration type to be checked
## against the standard ones defined in this package.
sub testbed_config_type_check  ($) {
    my $type = shift;

    # See if this exact config type is defined
    if ($valid_configs{$type}) {
        return 1;
    }
    # Look for known prefix values that have implied configuration types
    foreach my $prefix (keys %implied_by_prefix_configs) {
        # Meta characters are EXPECTED in these "prefix" strings
        # Leave them in place to allow them to work
        if ($type =~ m/^$prefix/) {
            return 1;
        }
    }
    return 0;
}

## @name ::testbed_testplan_config_types
## @summary Returns the complete list of test plan configuration type combinations that are valid for the array passed in
## @arg $testplan_configs holds the TESTPLAN_CONFIGS value that defines a comma separated list of configuration type combinations
## @arg list of configuration types (usually for a single test bed)
sub testbed_testplan_config_types  ($@) {
   my $testplan_configs = shift;
   my @testbed_configs = @_;

   my @testbed_implied_configs = testbed_config_types(@testbed_configs);
   my $testbed_implied_configs_search = ",".join(",",@testbed_implied_configs).",";

   my @in_configs = split(",",$testplan_configs);
   my %ok_configs;
   my @out_configs = ();

   foreach my $in_config (@in_configs) {
      # Verify that each requested configuration type is present on this test bed
      my @config_types = split("[_\/]",$in_config);
      my $ok = 1;
      foreach my $plan_config_type (@config_types) {
         if ($testbed_implied_configs_search !~ m/,$plan_config_type,/) {
            $ok = 0;
            last;
         }
      }
      if ($ok) {
         # OK this is valid, Place valid ones in the ok hash
         my @this_plan_implied_configs = testbed_config_types(@config_types);
         $ok_configs{$in_config} = [@this_plan_implied_configs];
      }
   }

   foreach my $ok_config_list (keys %ok_configs) {
      # Verify that each requested configuration type combination is not found as a subset of another
      my $ok_implied_configs_search = ",".join(",",@{$ok_configs{$ok_config_list}}).",";
      my $ok = 1;
      foreach my $other_config_list (keys %ok_configs) {
         if ($ok_config_list eq $other_config_list) {
            next;
         }
         # skip any configuration lists that have been removed on a previous loop
         if (0 < @{$ok_configs{$other_config_list}}) {
            my $this_is_a_subset = 1;
            foreach my $other_config (@{$ok_configs{$other_config_list}}) {
               if ($ok_implied_configs_search !~ m/,$other_config,/) {
                  $this_is_a_subset = 0;
                  last;
               }
            }
            if ($this_is_a_subset) {
               # We just discovered a subset - that can be eliminated
               $ok_configs{$other_config_list} = [];
            }
         }
      }
   }
   # Place those without subsets in the @out_configs
   foreach my $ok_config_list (keys %ok_configs) {
      if (0 < @{$ok_configs{$ok_config_list}}) {
         # This one was not eliminated
         push(@out_configs,$ok_config_list);
      }
   }
   my $out_config = join(",",@out_configs);
   return $out_config;
}

1;
