#! /usr/local/bin/perl -w
#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/SharedTestBed/ConfigTypesPrint.pl#1 $
#
#Copyright (c) 2006 Network Appliance, Inc.
#All rights reserved.
#
## @summary Prints hierarchy of config types

## @description
## Prints implied and declared config types in hierarchical groupings.
##
## @author hedstrom@netapp.com,erickson@netapp.com
##
## @status public

use strict;
use FindBin qw($RealBin);
use lib "$RealBin";
use lib "$RealBin/../lib";
BEGIN { push @INC, "/usr/local/test/noarch/lib"; }

use SharedTestBed::ConfigTypes;

my @output_arr;
my $num_lines = -1;

sub drill_down ($$);

sub drill_down ($$) {
    my $start = shift;
    my $indent = shift;
    my $conf_line = "";
    
    for (my $j=$indent; $j>0; $j--) {
        $conf_line .= "  ";
    }

    my ($desc,$sub_ref,$like) = testbed_config_data($start);
    $conf_line .= "$start";

    if ($desc) {
        $conf_line .= " - $desc";
    } else { 
	$conf_line .= "- null";
    }

    $conf_line .= "\n";
    $output_arr[++$num_lines] = $conf_line;
    $indent++;
    my @sub_types = testbed_config_subtypes($start);

    if (@sub_types) {
        foreach my $subtype (sort(@sub_types)) {
            drill_down($subtype,$indent);
        }
    } else {
        if ($indent == 1) {
            $output_arr[++$num_lines] = "No sub configuration types for: $start\n";
        }
    }
}

drill_down('-all-',0);

for (my $i = 0;$i < @output_arr; $i++) {
    print $output_arr[$i];
}

