## $Id: //depot/prod/test/Rsierranevada/dp/TestArch/lib/Constants.pm#1 $
##
## @summary
##  Keep constants defined by Test Architecture in one place
##  http://wikid.netapp.com/w/SM_TestArchitecture
##
## @description
##
##  Naming conventions for volumes set to sc_src* and sc_dst* for
##  storage configured src and dsts for now.
##
##  Volumes counts and sizes roughly assigned per test type ie BOT/BAT,functional,RPO
##
## @author
##  dl-dpsas-svl
##

package dp::TestArch::lib::Constants;
use strict;

use base 'Exporter';

use constant { RAID_DP=>3, RAID4=>2 };
use constant { AGGR_CT=>2,AGGR_UTILIZE=>0.6,VS_CT=>5 };
use constant { MT_BOT_VOL_CT=>20,MT_FUNC_VOL_CT=>40,SYS_RPO_VOL_CT=>100,MT_FUNC_VOL_SIZE=>22212121212 };

use constant { SHIM_SUFFIX=>'_byte_shim', AGGR_PREFIX=>'sc_aggr_',
                VOL_SRC_PREFIX=>'sc_src', VOL_DST_PREFIX=>'sc_dst',
                VOL_SNAP_PREFIX=>'sc.dataset.', VOL_FIRSTSNAP=>'sc.dataset.null',
                VS_PREFIX=>'sc_vs_' };

use constant { RATIO_SHIM=>0.25,RATIO_CLONE=>0,RATIO_COMP=>0.1,RATIO_SIS=>0.8,RATIO_LUN=>0.25 };

use Exporter qw(import);

our @EXPORT_OK = qw(
                    RAID_DP RAID4
                    AGGR_CT AGGR_UTILIZE VS_CT 
                    MT_BOT_VOL_CT MT_FUNC_VOL_CT SYS_RPO_VOL_CT MT_FUNC_VOL_SIZE
                    SHIM_SUFFIX AGGR_PREFIX VOL_SRC_PREFIX VOL_DST_PREFIX
                    VOL_SNAP_PREFIX VOL_FIRSTSNAP VS_PREFIX 
                    RATIO_SHIM RATIO_CLONE RATIO_COMP RATIO_SIS RATIO_LUN 
                     );

our %EXPORT_TAGS = (

                    counts => [ qw( RAID_DP RAID4 AGGR_CT AGGR_UTILIZE VS_CT MT_BOT_VOL_CT
                                    MT_FUNC_VOL_CT SYS_RPO_VOL_CT MT_FUNC_VOL_SIZE ) ],

                    names => [ qw( SHIM_SUFFIX AGGR_PREFIX VOL_SRC_PREFIX VOL_DST_PREFIX
                                    VOL_SNAP_PREFIX VOL_FIRSTSNAP VS_PREFIX ) ],
                    
                    ratios => [ qw( RATIO_SHIM RATIO_CLONE RATIO_COMP RATIO_SIS RATIO_LUN ) ],

                    );

1;
