#!/usr/software/bin/perl

use strict;
use lib '/u/jaia/TestR';
use Utilities;

package TestObject;

use Data::Dumper;

my $DR_OPERATION = { 'SWITCHOVER' => 1,
                     'HEAL_AGGRS' => 2,
                     'HEAL_ROOTS' => 3,
                     'SWITCHBACK' => 4,
                   };

my $DR_OP_STEPS = { 'pre_op_validation'  => 1,
                    'failure_injection'  => 2,
                    'pre_op_setup'       => 3,
                    'run_operation'      => 4,
                    'verify_results'     => 5,
                    'post_op_processing' => 6,
                    'post_op_cleanup'    => 7
                  };

sub new {
    my $type = shift;
    my $class = ref($type) || $type;

    my $self = {};

    bless($self, $class);

    $self->{args} = shift;

    if (!$self->{args}->{dr_op}) {
        die "Error: Invalid invocation of method new() on package TestObject, 'dr_op' parameter missing\n";
    }

    if (!$DR_OPERATION->{$self->{args}->{dr_op}}) {
        die "Error: Invalid value passed in for the 'dr_op' parameter\n";
    }

    return $self;
}

############ PRE-OP VALIDATION ############

sub _pre_op_validation {
}

############ RUN OPERATION  ############

sub _run_switchover {

}

sub _run_heal_aggrs {

}

sub _run_heal_roots {

}

sub _run_switchback {

}

sub _run_operation {
    my $self = shift;

    my $dr_op = $self->{dr_op};

    if ($dr_op == 'SWITCHOVER') {
        _run_switchover();
    } elsif ($dr_op == 'HEAL_AGGRS') {
        _run_heal_aggrs();
    } elsif ($dr_op == 'HEAL_ROOTS') {
        _run_heal_roots();
    } elsif ($dr_op == 'SWITCHBACK') {
        _run_switchback();
    } else {
        die "Fatal Error\n";
    }
}


package TestDriver;

our @ISA = "TestObject";

sub run_tests {
    my @testObjs = @{$_[0]};

    foreach my $obj (@testObjs) {
        my $steps = $obj->{steps};

        my $count;
        my $num_steps = scalar $DR_OP_STEPS;

        for ($count = 0; $count < $num_steps; $count++) {

            my $current_step = $steps->{$count};

            if ($current_step) {
                $current_step->();
            }
        }
    }
}

1;
