#!/usr/software/bin/perl

sub _create_hash  {
    my $output = shift;
# Block 1 starts :Following code populates an array of Hash structures from the $CommandOutput into  @OutputArrOfHash
    my @OutputArrOfHash;
    my @temp   = split( /\n/,  $output );
    my @fields = split( /X;X/, $temp[0] );
    my $j      = 0;
    my $k      = 0;
    foreach my $variable (@temp) {
        #$Log->debug( "\n\n\n PRINT EACH LINE:" . $variable );
        my @values_array = split( /X;X/, $variable );
        my $i = 0;
        if ( $j >= 2 ) { 

            foreach my $del (@values_array) {
                $OutputArrOfHash[$k]{ $fields[$i] } = $del;
                #$Log->debug( "\n\n\n PRINT each FIELD VALUE("
                #      . $fields[$i] . "):"
                #      . $del );
                $i++;
            }   
            $k++;
        }   
        $j++;
    }

    return \@OutputArrOfHash;
}

sub get_DRC_FSM_state {
    my $node = shift;

    my $table_entries = $node->apiset(set =>'CMode')->execute_raw_command(command => 'debug smdb table mccDRCOperation show');

    my $parsed_output = _create_hash($table_entries);
    my $current_state = ($parsed_output->[0])->{'currentState'};
    return $current_state;
}

sub get_DRSOM_FSM_state {
    my $node = shift;

    my ($drsom_fsm_state_pri, $drsom_fsm_state_aux);

    my $output = $node->apiset(set => 'CMode')->execute_raw_command(command => 'node run local "priv set test; mcc status"');

    if ($output =~ /FSM state:([\s\w]+)/i) {
        $drsom_fsm_state_pri = $1;
        $drsom_fsm_state_pri =~ s/^\s+//;
        $drsom_fsm_state_pri =~ s/\s+$//;
    }

    $output = $node->apiset(set => 'CMode')->execute_raw_command(command => 'node run local "priv set test; mcc status -p"');

    if ($output =~ /FSM state:([\s\w]+)/i) {
        $drsom_fsm_state_aux = $1;
        $drsom_fsm_state_aux =~ s/^\s+//;
        $drsom_fsm_state_aux =~ s/\s+$//;
    }

    my $drsom_fsm_state = { dr_pri => $drsom_fsm_state_pri,
                            dr_aux => $drsom_fsm_state_aux };

    return $drsom_fsm_state;
}

1;
