# -*-perl-*-
# $Id: //depot/prod/test/Rsierranevada/dp/ossv/BR.1_Regression/joshi/ossvapi.pm#1 $

use POSIX qw(ceil floor);

#* start_baseline()  
#* wait_for_transfer_finish ()  
#* start_update ()  
#* start_restore ()  
#* start_resync()  

#use Tharn;

###################################################################
## This procedure starts a baseline transfer.
# @parameters -- 
#  $baseline_command,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub start_baseline {
        my($baseline_command,$fc) = @_;
        my @command=split(" ",$baseline_command);
        my $command_count = @command;
        my ($match,$before,$after);
        my $qtree;

        logcomment(" command count is :  $command_count ");
        logcomment("qtree is  : $command[$command_count -1]");
	
	if($command[$command_count - 1] =~ m/^$./) {
                logcomment("qtree is in a variable : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }elsif ($command[$command_count -1] =~ m/^\/./){
                logcomment("direct qtree is mentioned : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }else {
                logcomment("Waring: A proper qtree is NOT mentioned,Please check qtree name");
        }
         ($match,$before,$after)= say($fc,"snapvault start $baseline_command","Transfer started",-fail,"Couldn't start base line transfer",-timeout,7200);
         logcomment("$match,$before,$after ");

        if($match =~ m/Transfer started/) {
                logcomment("Succussefully started the baseline transfer");
                return 1;
        } else {
                logcomment("Failed to start the baseline transfer");
                logcomment("ERROR: m:$match b:$before,a:$after");
                return 0;
        }
}





###################################################################
## This procedure starts a update transfer.
# @parameters -- 
#  $update_command,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub start_update {

        my($update_command,$fc) = @_;
        my @command=split(" ",$update_command);
        my $command_count = @command;
        my ($match,$before,$after);
        my $qtree;
        
	logcomment(" command count is :  $command_count ");
        logcomment("qtree is  : $command[$command_count -1]");
	
	if($command[$command_count - 1] =~ m/^$./) {
                logcomment("qtree is in a variable : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }elsif ($command[$command_count -1] =~ m/^\/./){
                logcomment("direct qtree is mentioned : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }else {
                logcomment("Waring: A proper qtree is NOT mentioned,Please check qtree name");
        }
         ($match,$before,$after) = say($fc,"snapvault update $update_command","Transfer started",-fail,"Couldn't start update transfer",-timeout,7200);

        if($match =~ m/Transfer started/) {
                logcomment("Succussefully started the update transfer");
                return 1;
        } else {
                logcomment("Failed to start the update transfer");
                logcomment("ERROR:$after");
                return 0;
        }
}



###################################################################
## This procedure starts a restore transfer.
# @parameters -- 
#  $restore_command,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub start_restore1 {

        my($restore_command,$pc) = @_;
        #my @command=split(" ",$restore_command);
	logcomment(" command >  :  $restoree_command ");
        #my $command_count = @command;
        my ($match,$before,$after);
        my @restore_messages; 
	#logcomment(" command count is :  $command_count ");
        #logcomment("Restore Path is  : $command[$command_count -1]");
	
        ($match,$before,$after) = say($pc,"snapvault restore $restore_command ",-timeout,7200);
	
        logcomment("Restore Ouput: $after");
	@restore_messages= split("\n",$after);
	if((!$restore_messages[1])||($restore_messages[1]=~ /restarting to complete the restore/)) {
                logcomment("Restore done successfully");
                return 1;
        } else {
                #logcomment("FAIL: Restore is failed.");
                logcomment("ERROR: $after");
                return 0;
        }
        
}

###################################################################
## This procedure starts a resync transfer.
# @parameters -- 
#  $resync_command,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub start_resync   {

        my($resync_command,$fc) = @_;
        my @command=split(" ",$resync_command);
        my $command_count = @command;
        my ($match,$before,$after);
        my $qtree;

        logcomment(" command count is :  $command_count ");
        logcomment("qtree is  : $command[$command_count -1]");
	
	if($command[$command_count - 1] =~ m/^$./) {
                logcomment("qtree is in a variable : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }elsif ($command[$command_count -1] =~ m/^\/./){
                logcomment("direct qtree is mentioned : $command[$command_count-1]");
                $qtree=$command[$command_count];
        }else {
                logcomment("Waring: A proper qtree is NOT mentioned,Please check qtree name");
        }
        ($match,$before,$after) = say($fc,"snapvault start -r -f $resync_command","Transfer started",-ok,-timeout,1000);


        if($match =~ m/Transfer started/) {
                logcomment("Succussefully started the resync transfer");
                return 1;
        } else {
                logcomment("Failed to start the resync transfer");
                logcomment("ERROR: $after");
                return 0;
        }
}




###################################################################
## Wait for the transfer to complete###############################
## This procedure waits for the transfer to finish.
# @parameters -- 
#  $qtree,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub wait_for_transfer_finish {
	my($qtree,$fc) = @_;
	my (%svStatus,$timeout);
    
	$timeout=7200;
	%$svStatus = &get_snapvault_status($qtree,$fc);

        logcomment("Transfer Status>>>>:$$svStatus{'Status'}");
        #while($$svStatus{'Status'} =~ m/Transferring|Quiescing/i)
        #Fix for BURTverification23472 where restart has to complete after abort  
        while($$svStatus{'Status'} =~ m/Transferring|Quiescing|Pending|Aborting/i)
        {
                logcomment("Transfer Status>>>>:$$svStatus{'Status'}");
                if($$svStatus{'Current Transfer Error'} ne "-") {
                        logcomment("Transfer has an error:$$svStatus{'Current Transfer Error'}");
                        return 0;
                }
                if($timeout == 0 ) {
                        logcomment("Transfer Timed Out:");
                        return 0;
                }
                %$svStatus = &get_snapvault_status($qtree,$fc);
                sleep 5;
                $timeout = $timeout - "5";
        }

        if($$svStatus{'Current Transfer Error'} ne "-")
        {
          logcomment("Transfer failed. The current transfer error is $$svStatus{'Current Transfer Error'}");
          return 0;
        }
        return 1;

}


###################################################################
## Wait for the transfer to complete###############################
## This procedure waits for the Restart transfer to finish.
# @parameters --
#  $qtree,$Fc
# Returns
#  1 on sucuess
#  0 on failure if any
#
###################################################################

sub wait_for_Restart_transfer_finish {
        my($qtree,$fc) = @_;
        my (%svStatus,$timeout);

        $timeout=7200;
        %$svStatus = &get_snapvault_status($qtree,$fc);

        logcomment("Transfer Status>>>>:$$svStatus{'Status'}");
        #while($$svStatus{'Status'} =~ m/Transferring|Quiescing/i)
        #Fix for BURTverification23472 where restart has to complete after abort
        while($$svStatus{'Status'} =~ m/Transferring|Quiescing|Pending|Aborting/i)
        {
                logcomment("Transfer Status>>>>:$$svStatus{'Status'}");
                if($timeout == 0 ) {
                        logcomment("Transfer Timed Out:");
                        return 0;
                }
                %$svStatus = &get_snapvault_status($qtree,$fc);
                sleep 3;
                $timeout = $timeout - "5";
        }

        if($$svStatus{'Current Transfer Error'} ne "-")
        {
          logcomment("Transfer failed. The current transfer error is $$svStatus{'Current Transfer Error'}");
          return 0;
        }
        return 1;

}



###################################################################
## This procedure modifies the configuration variables  of variuos config files under snapvault/config directory.
# @parameters -- 
#  $config_parameter,$value,$Pc
# Returns
#  1 on sucuess
#  0 on failure if any
###################################################################
sub svconfig_mod {

   my($OSSV_INSTALL_LOC,$parameter,$value,$Pc) = @_;
   my($stanzautil,$config_file); 

   #Constructing the svsetstanza path
   #$stanzautil="$OSSV_INSTALL_LOC"."\\"."util"."\\"."svsetstanza";
   $stanzautil="svsetstanza";
   logcomment("svsetstanza tool's Path:  $stanzautil");

   if($parameter =~ /^BLI$/i) {

      say($Pc,"$stanzautil config snapvault.cfg Configuration Checksums VALUE $value FALSE");
      logcomment("BLI set to $value");

   }elsif ($parameter =~ /^Estimator$/i) {
   
      say($Pc,"$stanzautil config snapvault.cfg Configuration \"Run Estimator\" VALUE $value FALSE");
      logcomment("Run Estimator check set to $value");

   } elsif ($parameter =~ /^ACCESS$/i) {
   
      #say($Pc,"\"$stanzautil\" config snapvault.cfg QSM \"Check Access List\" VALUE $value FALSE");
      say($Pc,"$stanzautil config snapvault.cfg QSM \"Check Access List\" VALUE $value FALSE");
      logcomment("Access check set to $value");

   }elsif ($parameter =~ /^CheckerFixer$/i) {
   
      say($Pc,"$stanzautil config snapvault.cfg QSM GenerateVerifyChecksums VALUE $value FALSE");
      logcomment("CheckerFixer check set to $value");

   } elsif ($parameter =~ /^RESYNC$/i) {

      say($Pc,"$stanzautil config snapvault.cfg QSM \"Enable Restart\" VALUE $value FALSE");
      logcomment("Resync flag set to $value");

   } elsif ($parameter =~ /^DB$/i) {

      say($Pc,"$stanzautil config snapvault.cfg QSM \"Backup Database\" VALUE $value FALSE");
      logcomment("DB backup set to $value");

   } elsif ($parameter =~ /^ACCESSLIST_VALUE$/i) {

      say($Pc,"$stanzautil config snapvault.cfg QSM \"Access List\" VALUE $value value");
      logcomment("Access List set to $value");

   } elsif ($parameter =~ /^RESYNC_VERSION$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  \"Resync Version\" VALUE $value FALSE");
      logcomment("Resync version set to $value");

   } elsif ($parameter =~ /^NDMP_PORT$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' NDMP  'Listen Port' VALUE '$value' FALSE");
      logcomment("NDMP port set to $value");

   } elsif ($parameter =~ /^NDMP_HOSTID$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' NDMP  'Host Id' VALUE '$value' FALSE");
      logcomment("NDMP Id set to $value");

   } elsif($parameter =~ /^ROOT_INODE$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' QSM  'FixRootInodeChanges' VALUE '$value' FALSE");
      logcomment("FixRootInode flag set to $value");

   } elsif($parameter =~ /^CPRWTime$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  MaxCPRestartWaitTime VALUE $value FALSE");
      logcomment("MaxCPRestartWaitTime flag set to $value");

   } elsif($parameter =~ /^Compression$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  EnableCompression VALUE $value FALSE");
      logcomment("Compression flag set to $value");

   } elsif($parameter =~ /^CompressionLevel$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  CompressionLevel VALUE $value FALSE");
      logcomment("CompressionLevel flag set to $value");

   } elsif($parameter =~ /^CompressionLowPriority$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  CompressionLowPriority VALUE $value FALSE");
      logcomment("CompressionLowPriority flag set to $value");

   } elsif($parameter =~ /^CheckpointInterval$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  \"Checkpoint Interval\" VALUE $value FALSE");
      logcomment("CheckpointInterval flag set to $value");

   } elsif($parameter =~ /^NameBLI$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  \"Hybrid Inodes\" VALUE $value FALSE");
      logcomment("Name Based BLI flag set to $value");

   } elsif($parameter =~ /^DDrives$/i) {

      say($Pc,"\"$stanzautil\" config snapvault.cfg QSM  \"Disallowed Drives\" VALUE $value FALSE");
      logcomment("Disallowed Drives flag set to $value");

   } elsif($parameter =~ /^OFM$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' OFM  'WriteInactivityPeriod' VALUE '$value' FALSE");
      logcomment("OFM WriteInactivityPeriod flag set to $value");

   } elsif($parameter =~ /^OFMTimeout$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' OFM  'Timeout' VALUE '$value' FALSE");
      logcomment("OFMTimeout flag set to $value");

   } elsif($parameter =~ /^VSStimeout$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' VSS  'Snapshot creation timeout' VALUE '$value' FALSE");
      logcomment("VSStimeout flag set to $value");

   } elsif($parameter =~ /^EventLog$/i) {

      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' SS  'EventLog Text' VALUE '$value' FALSE");
      logcomment("EventLog flag set to $value");

   } elsif($parameter =~ /^UTF8$/i) {

      say($Pc,"'$stanzautil' config snapvault.cfg NDMP  ForceUTF8Encoding VALUE $value FALSE");
      logcomment("ForceUTF8Encoding flag set to $value");

   } elsif($parameter =~ /^Account$/i) {
      
      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' NDMP  'Account' VALUE '$value' FALSE");
      logcomment("Account flag set to $value");

   }elsif($parameter =~ /^HostName$/i) {
      
      say($Pc,"'$stanzautil' 'config' 'snapvault.cfg' NDMP  'Host Name' VALUE '$value' FALSE");
      logcomment("Host Name flag set to $value");
      
   } elsif($parameter =~ /^Generate$/i) {

      say($Pc,"'$stanzautil' 'config' 'configure.cfg' Trace  'Trace To File' VALUE '$value' FALSE");
      logcomment("Generate debugging files flag set to $value");

   } elsif($parameter =~ /^SnapVaultListener$/i) {

      say($Pc,"'$stanzautil' config programs.cfg 'SnapVault Listener'  'Trace Level' VALUE $value FALSE");
      logcomment("SnapVault Listener flag set to $value");

   } elsif($parameter =~ /^QSMServer$/i) {

      say($Pc,"'$stanzautil' config programs.cfg 'QSM Server'  'Trace Level' VALUE $value FALSE");
      logcomment("SnapVault Listener flag set to $value");
   }	

}

###################################################################
## This procedure adds NEW configuration variables  of variuos config files under snapvault/config directory.
# @parameters -- 
#  $parameter,$value,$Pc
# Returns
#  1 on sucuess
#  0 on failure if any
###################################################################
sub svconfig_add {

   my($OSSV_INSTALL_LOC,$configfile,$parameter,$value,$Pc) = @_;
   my($configpath); 

   #Constructing the config dir path
   $configpath="$OSSV_INSTALL_LOC"."//"."config"."//"."$configfile";
   logcomment("config file path is:   $configpath");

      say($Pc,"echo '$parameter'  >> '$configpath' ");
      say($Pc,"echo '$value'  >> '$configpath' ");
      #say($Pc,"echo "" >> '$configpath' ");
      logcomment("$parameter is added with value $valuen in $configfile");
}












###################################################################
## This procedure installs the OSSV on given Primary(Windows & Linux) 
# @parameters -- 
#  $Build_Loc,$OS,$Primary)
# Returns
#  1 on sucuess
#  0 on failure if any
###################################################################
sub install_ossv {

   my($Build_LOC,$OS,$PRIMARY) = @_;
	
   my $Ph = host($PRIMARY);
   my $Pc = connect("#rsh");

   my $upgrade = 0;
   my $status = 0;

        ## --------------
        ## Get Build Name
        ## --------------
        
        my @tmp_arr = split("\/", "$Build_LOC");
        my $size = @tmp_arr;
        my $bld_dir_name = $tmp_arr[$size-1];
        logcomment(" OSSV Build Directory Name is : $bld_dir_name");

        ## ------------------------------------------------
        ## Moving the build to a globally accessible location  \\butterball\ossv which on eng-sup chill machine
        ## Expecting it to be mounted on test machine or automation server
        ## ------------------------------------------------

        logcomment("Copying image to common-accessible location \\butterball\ossv");
        if(system("cp -r $Build_LOC /mnt/butter") != 0) {
           logresult("Fatal", "$?");
        }

        ## ---------------------------
        ## Get OSSV's install Location
        ## ---------------------------
        my $install_location = &checkossvinstallation($PRIMARY,$OS);

        ## ------------------------------------
        ## Default values for db, trace and tmp
        ## ------------------------------------

         my $install_db = "";
         my $install_trace = "";
         my $install_tmp = "";


         if(defined($install_location)) {

           logcomment("OSSV has been installed in $install_location");
           $upgrade = 1;

           if($OS =~ m/win/i ) {

		   #$install_db = $install_location . "\\" . "db";
		   #$install_trace = $install_location . "\\" . "trace";
		   #$install_tmp = $install_location . "\\" . "tmp";
               $status=&install_ossv_win($PRIMARY, "Z\:", $bld_dir_name);

           } else {

               $install_db = $install_location . "/" . "db";
               $install_trace = $install_location . "/" . "trace";
               $install_tmp = $install_location . "/" . "tmp";
               $status=&install_ossv_unix($PRIMARY, "/mnt/butter", $bld_dir_name,$install_location, $install_db, $install_trace, $upgrade);
           }

        } else {

            logcomment("OSSV not installed in the system.Start a fresh install");
            if($OS =~ m/win/i ) {

		    #$install_location = "C:\\Program Files\\netapp";
		    #$install_db = $install_location . "\\" . "db";
		    #$install_trace = $install_location . "\\" . "trace";
		    #$install_tmp = $install_location . "\\" . "tmp";
              		$status= &install_ossv_win($PRIMARY, "Z\:", $bld_dir_name);

            } else {

               $install_location = "/usr/snapvault";
               $install_db = $install_location . "/" . "db";
               $install_trace = $install_location . "/" . "trace";
               $install_tmp = $install_location . "/" . "tmp";
               $status=&install_ossv_unix($PRIMARY, "/mnt/butter", $bld_dir_name,$install_location, $install_db, $install_trace, $upgrade);

            }

       }
       return $status;
    }



## ---------------------------------------
## checks if ossv installed in the PRIMARY
## ---------------------------------------

sub checkossvinstallation() {

  my ($PRIMARY,$OSTYPE) =@_; 
  my $ret_val = undef;
  
  my $ph = host($PRIMARY);
  my $pc = connect("#telnet");

  my $op;
 
  if($OSTYPE !~ m/win/i) { 
     (undef,undef,$op) = say($pc,'cat /etc/.snapvault',"dummy", -ok,-timeout,100);
  } else {
     (undef, undef, $op) = say($pc, 'nvgetregvalue SOFTWARE\\\BakboneSoftware\\\SnapVault Directory' , "dummy", -ok, -timeout, 100);
  }

  if( $op =~ m/[\\,\/]snapvault/i ){
     my($dummy,$installed_location,$db_location) = split(/\n/,$op);
     $ret_val = $installed_location;
     logcomment("Previuos OSSV  install location is $ret_val");
  } else {
     logcomment("OSSV is not installed on $primary");
  }
  disconnect($pc); 
  return $ret_val;
}


## --------------------
## Install windows ossv
## --------------------
sub install_ossv_win {

  my($primary, $bld_loc, $bld_name) = @_;
  my $ph = host($PRIMARY);
  my $pc = connect("#rsh");

  ## ------------------
  ## Mount butterball
  ## Remove any old Z:\
  ## ------------------

  say($pc, "net use /delete $bld_loc", -ok, -timeout, 600); 

  ## ------------------------
  ## Flurry of \'s. blaah!!!!
  ## ------------------------
  say($pc,"net use $bld_loc \\\\\\\\butterball\\\\ossv /user:btclab\\\\btcdev netapp","command completed successfully", 
        -fatal, "Unable to access build location.No point proceeding further",
        -timeout, 600);  

  logcomment("Installing OSSV NOW"); 
my (undef, undef, $op) = say($pc,"cd $bld_loc\\\\$bld_name && msiexec \/i ossv.msi \/qn reboot=ReallySuppress", -timeout, 3600);
       
  logcomment("OSSV Install Log: $op");
  disconnect($pc);
  if( $op =~ m/Fail|Error/i) {
      return(0);
  } else {
      return(1);
  }
 
  #logcomment("Installing NHA NOW"); 
  #Installing the NHA on system,
  #$op = say($pc, "cd $bld_loc\\\\$bld_name\\\\manageability && ./agentsetup-win32.exe /S /v/qn", -ok, -timeout, 1200);

  #logcomment("NHA Install Log: $op");
} 


## -------------------------------------
## Install ossv on Linux
## Needs a response File to be generated
## -------------------------------------

sub install_ossv_unix {

  my($primary, $build_loc, $bld_name,$pkg_base,$tmp_loc,$db_loc,$trace_loc,$upgrade) = @_;
  my $upgrade =1;	
  ## -------------------
  ## Connect to the Host
  ## -------------------

  my $ph = host($PRIMARY);
  my $pc = connect("#telnet");

  ## --------------------
  ## Create Response file
  ## --------------------

  my $bld_path = $build_loc . "/" . $bld_name;
  my $resp_file = $build_loc . "/" . $bld_name . "/" . "responseFile";

  ## -----------------------------------
  ## Making sure any old file is removed
  ## -----------------------------------

  say($pc, "rm -rf $resp_file");

  say($pc, "echo UNATTENDED_INSTALL=1 > $resp_file");
  say($pc, "echo CONFIG_FILE=1 >> $resp_file");
  say($pc, "echo LICENSE_AGREED=1 >> $resp_file");
  say($pc, "echo NDMP_USERNAME= >> $resp_file");
  say($pc, "echo NDMP_PASSWORD= >> $resp_file");
  say($pc, "echo NDMP_PORT=10000 >> $resp_file");
  say($pc, "echo SECONDARY_NAMES=ossvqa270c-1 >> $resp_file");
  say($pc, "echo CAFFEINE_INSTALL=No >> $resp_file");
  say($pc, "echo CAFFEINE_UPGRADE=No >> $resp_file");
  say($pc, "echo CHOSEN_CLASSES=ossvcore >> $resp_file");
  say($pc, "echo PKG_BASE=$pkg_base >> $resp_file");
  say($pc, "echo TMP_DIR=$tmp_loc>> $resp_file");
  say($pc, "echo DB_DIR=$db_loc >> $resp_file");
  say($pc, "echo TRACE_DIR=$trace_loc >> $resp_file"); 

  ## ----------------------
  ## Set any upgrade params
  ## ----------------------
  if($upgrade) {
     say($pc, "echo NV_UPGRADE=TRUE >> $resp_file");
     say($pc, "echo HONOR_EXISTING_CONFIG=1 >> $resp_file");
  }

  ## -------
  ## Install
  ## -------
  my(undef, undef, $op) = say($pc, "cd $bld_path && ./install $resp_file", -timeout, 3600);

  disconnect($pc);

  if( $op =~ m/Fail|Error/i) {
      return(0);
  } else {
      return(1);
  }
}












###################################################################
## This procedure Uninstalls the OSSV on given Primary(Windows & Linux) 
# @parameters -- 
#  $OS,$Primary)
# Returns
#  1 on sucuess
#  0 on failure if any
###################################################################
sub Uninstall_ossv {

   my($OS,$PRIMARY) = @_;
	
   my $Ph = host($PRIMARY);
   my $Pc = connect("#telnet");

        ## ---------------------------
        ## Get OSSV's install Location
        ## ---------------------------
        my $install_location = &checkossvinstallation($PRIMARY,$OS);

         if(defined($install_location)) {

           logcomment("OSSV has been installed in $install_location");

        	if($OS =~ m/win/i ) {
	               &uninstall_ossv_win($PRIMARY, $install_location);
        	}elsif ($OS =~ m/linux/i ) {
	               &uninstall_ossv_linux($PRIMARY, $install_location);
        	}elsif ($OS =~ m/solaris/i ) {
               	       &uninstall_ossv_unix($PRIMARY, $install_location);
	       }       

        } else {

            logcomment("OSSV not installed in the system.Start a fresh install");
        }

}



## --------------------
## UNinstall windows ossv
## --------------------
sub uninstall_ossv_win {

  my($primary, $bld_loc) = @_;
  my $ph = host($PRIMARY);
  my $pc = connect("#telnet");

  say($pc,"net use $bld_loc \\\\\\\\butterball\\\\ossv /user:btclab\\\\btcdev netapp","command completed successfully", 
        -fatal, "Unable to access build location.No point proceeding further",
        -timeout, 600);  

  logcomment("Installing OSSV NOW"); 
my (undef, undef, $op) = say($pc,"cd $bld_loc\\\\$bld_name && msiexec \/i ossv.msi \/qn reboot=ReallySuppress", -timeout, 3600);
       
  logcomment("OSSV Install Log: $op");
 
  logcomment("Installing NHA NOW"); 
  #Installing the NHA on system,
  $op = say($pc, "cd $bld_loc\\\\$bld_name\\\\manageability && ./agentsetup-win32.exe /S /v/qn", -ok, -timeout, 1200);

  logcomment("NHA Install Log: $op");
   disconnect($pc);
} 



## --------------------
## UNinstall windows linux 
## --------------------
sub uninstall_ossv_linux {

  my($primary, $install_loc) = @_;
  my ($match,$before,$after,$prompt);
  my $ph = host($PRIMARY);
  my $pc = connect("#telnet");

	($match,$before,$after,$prompt)=say($pc,"cd $install_loc/util;./uninstall",-prompt,"n] :",-fatal,"Failure with UNinstallation of linux");
	logcomment("match>:$match");
	logcomment("before>:$before");
	logcomment("after>:$after");
	logcomment("prompt>:$prompt");
	($match,$before,$after,$prompt)=say($pc,"y","Removal completed successfully",-prompt,"n] :",-ok,"Uninstallation failed-2");
	logcomment("match>:$match");
	logcomment("before>:$before");
	logcomment("after>:$after");
	logcomment("prompt>:$prompt");
	if($prompt =~ m/n] :/) {
		$match=say($pc,"y","Removal completed successfully",-fail,"Uninstallation failed-3");
	}
	logcomment("match>:$match");
	if($match =~ m/Removal completed successfully/) {
		logresult("Pass","UNinstallation on [$install_loc] was successfull!!!!");
	}else {
		logresult("INFO","Didn't get expected message:Removal completed successfully");
		logresult("FAIL","UNinstallation on [$install_loc] was successfull!!!!");
	}
}
 





######################################################
## This procedure is for aborting a transfer on Primary or Secondary
#######################################################

sub abort_transfer {
	my($qtree,$filer,$c) = @_;
	my (%svStatus,$timeout);
        $timeout=7200;
        %$svStatus = &get_snapvault_status($qtree,$c);

        logcomment("Transfer Status>>>>:$$svStatus{'Status'}");

    	my($before,$match,$after) = say($c,"snapvault abort $filer:$qtree"); 
	if($after =~ m/not|Failed/) {
		logcomment("Unsuccessful abort.Might be missing something");
		return 0;	
	} else {
		logcomment("Successful abort");
 		return 1;	
	}

}

##################################
## This procedure starts a restore
##################################

sub restore1 {  

	my($primary,$filer,$restore_path,$qtree,$throttle,$snapshot,$pc) = @_;
        my ($match,$before,$after);
        if ($snapshot =~ "NONE")
        {
        	($match,$before,$after) = say($pc,"snapvault restore -S $filer:$qtree '$restore_path'","dummy",-ok,-timeout,3600);
        	logcomment("m:$match, b:$before a:$after");
        }
        else 
        {
        	($before,$match,$after) = say($pc,"snapvault restore -s $snapshot  -S $filer:$qtree '$restore_path'","dummy",-ok,-timeout,3600);
		logcomment("m:$match, b:$before a:$after");	
        }

        if($after =~ m/Failed|Error/i ) {
 		logcomment("Restore could have failed.Please check the snapvault log for more details");
                return 0;
        } else {
		logcomment("Restore done");
                return 1;
        }
}

###########################################
## This procedure starts a DB restore
########################################### 

sub start_db_restore {
   
        my($primary,$filer,$restore_path,$qtree,$pc) = @_;
       
        if($DB_FLAG =~ 0)
        {
         ($before,$match,$after) = say($pc,"'$OSSV_LOC//snapvault' restore -S $filer:$qtree/.OSSV_DATABASE_BACKUP                                                  '$TMP_DB_LOC'","dummy",-ok,-timeout,2000); 
        }
        else
        {
         ($before,$match,$after) = say($pc,"'$OSSV_LOC//snapvault' restore -S $filer:$qtree/.OSSV_DATABASE_BACKUP_1                                                '$TMP_DB_LOC'","dummy",-ok,-timeout,2000);  
        }

        if($after =~ m/[fF]ailed|[Ee]rror/ ) {
                logcomment("Restore could have failed.Please check the snapvault log for more details");
                return 0;
        } else {
                logcomment("Restore done");
                return 1;
        }
}
 
#####################################################################
## This procedure starts a update transfer.
###################################################################

sub start_update_transfer {

        my($qtree,$throttle,$fc) = @_;
        my $match = say($fc,"snapvault update -k $throttle $qtree","Transfer started",-ok,-timeout,3600);

        if($match =~ /Transfer started/) {
                return 1;
        } else {
                return 0;
        }
}

################################################
## This procedure starts a resync transfer
################################################

sub start_resync_transfer {

        my($primary,$restore_path,$qtree,$throttle,$fc) = @_;
        my $match = say($fc,"snapvault start -r -f -S $primary:$restore_path $qtree","Transfer started",-ok,-timeout,1000);

        if($match =~ /Transfer started/) {
          return 1;
        } else {
               return 0;
        }
}


#################################################################
## This procedure checks if a  file exists or not
#################################################################

sub check_file_exists {

     my($file,$db_location,$interval,$pc) = @_;
     my $i=0,$CHKPT_TIMEOUT=1800;
     my $latest_chkpt;
     my $db_file = &get_latest_db_files($db_location,$pc);
     #my($match,$before,$after) = say($pc,"ls -1a '$db_location'",-ok,-timeout,600);
     for($i = 0; $i < $CHKPT_TIMEOUT; $i += $interval ) {
        $latest_chkpt = &get_latest_chkpt($db_file,$db_location,$pc);
        if(defined($latest_chkpt) && $latest_chkpt =~ /$db_file-$file/ ) {
        	$found_chkpt = 1;
                logcomment("pjoshi--------------> Check Point File Found: $latest_chkpt");
                last;
         }else {
          logcomment("pjoshi--------------> Waiting to Check Point to Occur...Sleeping for 1 min");
          sleep $interval;
        }
     	if($found_chkpt) {
     		return(1);
     	} else {
       		 return(0);
     	}
      }
}

#################################################################
## This funtion wil tell the differences between given two paths
## this futions will take the follwoing parameters and retruns 1 or 0 based on comparision
##      1. Tools location
##      2. Source directory
##      3. Destination Directory
#################################################################
sub data_compare {
	my ($pc,$tool_location,$source,$destination)=@_;
	my $return=1;
	logcomment("source,$destination");
	my($before,$match,$after) = say($pc,"$tool_location\\AC.exe $source $destination /ikb /v=4");
	if ($after =~ m/different/i){
		return 0;
	}
	return 1;
}
	
#################################################################
## This funtion will give the UUI of given VM
## this futions will take the follwoing parameters and retruns UUID of the VM
##      1. ESX server conection handel
##		2. ESX server root password
##      3. VM name
## Author : rajeshkr@netapp.com
#################################################################

sub vm_uuid{
	my($pc,$password,$vmname)=@_;
	my($match,$befor,$after)=say($pc,"vcbVmName -h localhost -u root -p '$password' -s Name:$vmname", -timeout,200);
    my($uuid,@uuid2);
    logcomment("this information from ESX server :$after");
    my@match_arry=split("\n",$after);
    for(@match_arry){
        if($_=~ /uuid:/){
            $uuid=$_;
            }
        }
    logcomment("$uuid");
    @uuid2=split(":",$uuid);
    $uuid=@uuid2[1];
    #pop($uuid);
    @uuid2[1]=~s/\s//g;
    @uuid2[1];
}

##---------------------------------------------------------------------
## This function will  return the size of the Data set
## Parameters:
##              1. Primary Handel
##              2. Dataset location
##Author: rajeshkr@netapp.com
##----------------------------------------------------------------------

sub size_dataset {
my($pc,$location)=@_;
my($match,$before,$after)=say($pc,"du -h '$location'",-timeout,500);
my @array=split("\n",$after);
my $size=@array[$#array];
#my($size1,$temp)=split(".",$size);
#$size=~s/\D/ /g;
logcomment("Size of the given Directory is :$size");
return $size;
}

###################################################################
## This proceduRe creates data of given size on given path and takes follwoing parameters and returns no value
#       Primary connection handel
#       locaton where it requires to create data
#       OSSV tools location
#       Size of the data to be created in MB
##Authour:rajeshkr@netapp.com
###################################################################
sub create_data{
        my($pc,$location,$tool,$size)=@_;
        my $h2=$tool."\\h2.txt";
        my $h2_size = &size_dataset($pc,$h2);
        if ($h2_size =~ m/K|k/i) {
        $h2_size=($h2_size/1024);
        }elsif ($h2_size =~ m/M|m/i) {
        $h2_size=$h2_size;
        } elsif ($h2_size =~ m/G|g/i) {
        $h2_size=($h2_size*1024);
        }
        my $files=$size/($h2_size*36);
        $files=ceil($files);
        logcomment(" Number of files to be created is : $files");
        my($match,$before,$op)= say($pc,"sh '$tool\\crtdata.sh' '$location' 1 1 $files $files $files $files '$tool' ",-ok,-timeout,72000);
        logcomment("----------------------->m:$match\n b:$before\n a:$op\n");
        if(($op =~ m/Failed|Can't|Cannot|Error/)){
                logcomment("Warn---->Possible failure in data creation");
                logcomment("FAILURE  MESSAGE :$op");
        }
        return 1;
}



#########################################
## This funtions will do clean up activities on primary and filer 
## Author:rajeshkr@netapp.com
#########################################
sub cleanup_primary_data{
	my($pc,$bkp,$restore,$resync)=@_;
	say($pc,"rm -rf '$bkp';rm -rf '$restore'; rm -rf '$restore'");
}
sub cleanup_secondary_data{
	my($fc,$snap,$vol)=@_;
	say($fc,"snap delete $vol $snap");
}

##############################################################################

## This function will check the given statement in the snapvault  file (IPv6)
## Parameters:
##		1. Primary Handel
##		2.Path of the snapvault file
## 		3.String to be seaarched
## This function retuns  1 if given string is present in the file 
##Author: rajeshkr@netapp.com

###########################################################################

sub string_exist{
	my($pc,$path,$string,$filer_IP,$IP_family)=@_;
	my($match,$before,$after)=say($pc,"cd '$path';cat snapvault");
	my@array=split("\n",$after);
	for(@array){
		if($_=~/$string/){
			logcomment("INFO:Given string is present in the file \n");
			if($_=~/$filer_IP/){
				if($_=~/$IP_family/){
					logcomment("INFO:$_");
					return(1);
				}
			}
		}	
	}
}

###################################################
##  This funtion will parse the snapvault log file and find out the IPv4 or IPv6 connection mode is used for the relation 
##  This funtion will take following parameters and returns 0 or 1
#		1. Prmary Handel
#		2. Path of etc folder 
#		3. Secondary Qtree of the relation 
#		4. String inet or inet6 
## Returns 1 if snapvault log has any errors or warnings
## pjoshi@netapp.com 
##################################################				
sub check_connection_mode {
	my($pc,$etcpath,$qtree,$str)=@_;
        my $index=0,$result=0;
	my($match,$before,$after)=say($pc,"cat \"$etcpath\\etc\\snapvault\"");
    	my @array = split("\n",$after);
    	for(@array){
        	if(($_=~ m/$qtree/i)){
            		#logcomment("Qtree found:$_");
			if($array[$index-1] =~ /$str/){
				#logcomment("INFO:Given string is present in the file \n");
				logcomment("---------------------------------------------------- \n");
				logcomment("String is $array[$index-1] \n");
				logcomment("---------------------------------------------------- \n");
				$result=1;
				last;
			}
			if($array[$index-2] =~ /$str/){
                                #logcomment("INFO:Given string is present in the file \n");
				logcomment("---------------------------------------------------- \n");
                                logcomment("String is $array[$index-2] \n");
				logcomment("---------------------------------------------------- \n");
                                $result=1;
                                last;
                        }

		}
		$index++;
	}
	if($result == 1) {
		return 1;
	}else {
		return 0;
	}
}

###################################################
##  This funtion will parse the snapvault log file and find out the IPv4 or IPv6 connection mode is used for the  RESTORE relation
##  This funtion will take following parameters and returns 0 or 1
#               1. Prmary Handel
#               2. Path of etc folder
#               3. Primary Restore Qtree relation
#               4. String inet or inet6
## Returns 1 if snapvault log has any errors or warnings
## pjoshi@netapp.com
##################################################
sub check_Restore_connection_mode {
        my($pc,$etcpath,$qtree,$str)=@_;
        my $index=0,$result=0;
        my($match,$before,$after)=say($pc,"cat \"$etcpath\\etc\\snapvault\"");
        my @array = split("\n",$after);
        for(@array){
                if(($_=~ m/$qtree/i)){
                        #logcomment("Qtree found:$_");
                        if($array[$index+1] =~ /$str/){
                                logcomment("---------------------------------------------------- \n");
                                logcomment("String is $array[$index+1] \n");
                                logcomment("---------------------------------------------------- \n");
                                $result=1;
                                last;
                        }
                        if($array[$index+2] =~ /$str/){
                                #logcomment("INFO:Given string is present in the file \n");
                                logcomment("---------------------------------------------------- \n");
                                logcomment("String is $array[$index+2] \n");
                                logcomment("---------------------------------------------------- \n");
                                $result=1;
                                last;
                        }

                }
                $index++;
        }
        if($result == 1) {
                return 1;
        }else {
                return 0;
        }
}


###################################################################
## This procedure creates default data creation on given path and takes following parameters and returns true or false
#@param
# 	Primary connection handle
#	locaton where it requires to create data 
#	cygwin location
##Authour:pjoshi@netapp.com
###################################################################

sub create_default_data{
	my($pc,$location,$cygwin)=@_;
	#my($match,$before,$op)= say($pc,"$cygwin --login default_crtdata.sh $location ",-ok,-timeout,7200);
	my($match,$before,$op)= say($pc,"sh default_crtdata.sh $location ",-ok,-timeout,7200);
        logcomment("----------------------->m:$match\n b:$before\n a:$op\n");
        if(($op =~ m/Failed|Can't|Cannot|Error/)){
		logcomment("Warn---->Possible failure in data creation");
                logcomment("FAILURE  MESSAGE :$op");
		return 0;
        }else {

		logcomment("Data creation done");
		return 1;
	}
}




#####################################################################
## This procedure will enable/diasble the Ipv6 on filer side
##@param
# 	Filer connection handle
# 	option 0 or 1
##Authour:pjoshi@netapp.com
####################################################################

sub SV_Enable_disable_ipv6 {

        my($fc,$option) = @_;
        my ($be,$af,$match)= say($fc,"options ip.v6.enable $option",-timeout,3600);
        my ($be,$af,$match)= say($fc,"options ip.v6.enable",-timeout,3600);
       	logcomment("$match");

        if($match =~ m/$option/) {
                return 1;
        } else {
                return 0;
        }
}

#####################################################################
## This procedure will enable the Ipv6 on Primary side
##@param
# 	Filer connection handle
# 	option 0 or 1
##Authour:pjoshi@netapp.com
####################################################################
sub primary_ipv6_enable{
       my($pc,$OS) = @_;
       my $match,$af,$be;
	       if($OS =~ "win"){
        		($be,$af,$match) = say($pc,"netsh interface ipv6 install",-timeout,3600);
	       }elsif($OS =~ m/linux/){
        		($be,$af,$match)= say($pc,"/etc/init.d/ip6tables start",-timeout,3600);
	       }      
	       if($match=~ m/Failed/i){
		         return 0;
	       }else{
		     	return 1;
	       }	    
}

#####################################################################
## This procedure will diasble the Ipv6 on Primary side
#this function diable ipv6 
##@param
# 	Filer connection handle
# 	option 0 or 1
#returns 0 on failure if any 
##Authour:pjoshi@netapp.com
####################################################################
sub primary_ipv6_disable{
	my($pc,$OS) = @_;
        my $match,$af,$be;
       if($OS =~ m/win/){
       		($be,$af,$match) = say($pc,"netsh interface ipv6  uninstall",-timeout,3600);
       }elsif($OS =~ "linux"){
       		($be,$af,$match) = say($pc,"/etc/init.d/ip6tables stop",-timeout,3600);
       }      
       if($match=~ m/Failed/i){
	         return 0;
       }else{
	     	return 1;
       }
}	    


#####################################################################
## This procedure will delete the  Qtree on filer side
##@param
# 	Filer connection handle
#       Qtree Name
# 	Return  0 or 1
##Authour:pjoshi@netapp.com
####################################################################
sub  cleanup_secondary {
	my($fc,$qtree)=@_;
	my($output) = say($fc,"snapvault stop -f $qtree",-timeout,3600);
  	if($output =~ m/not/) {
       		logcomment("Not able to delete the qtree:$destination\n$output");
		return 0;
  	}
		return 1;
}


#####################################################################
## This procedure will delete the  relation on primary side
##@param
# 	Primary connection handle
#       Filer  Name
#       Destination Qtree Name
#       Source Qtree Name
# 	Return  0 or 1
##Authour:pjoshi@netapp.com
####################################################################
sub  cleanup_primary {
	my($ppc,$filer,$qtree,$src)=@_;
	#my($output) = say($ppc,"snapvault release $src $filer:$qtree",-timeout,3600);
	my ($be,$af,$match) = say($ppc,"snapvault release $src $filer:$qtree",-timeout,3600);
  	if($match =~ m/not/) {
       		logcomment("Not able to delete the qtree:$destination\n$output");
		return 0;
  	}
		return 1;
}



##############################################################
## This procedure abort transfer on primary side at particular checkpoints
##      Parameters:
##              1. Complete location of the OSSV database (D:\Program Files\netapp\snapvault\db\QsmDatabase\Files\QtreeHistory\0000)
##              2. checkpoint on which transfer to be aborted
##              3. Qtree
##              4. FIler
##              5. Primary handle
##              6. Connection handle for secondary
##    added by pjoshi:
##############################################################
sub  abortprimary_at_checkpoint{
        my($db_location,$checkpoint,$QTREE,$filer,$pc,$fc) = @_;
        my $chkptfile;
        my $DATABASEDIR_LOCATION;
        my $db_file,i;
        my $latest_chkpt;
        my $found_chkpt=0;

        my %svStatus = &get_snapvault_status($QTREE,$fc);
        my $transfer_status=$svStatus{'Status'};
        logcomment("Qtree status is :$svStatus{'Status'}");
        if($transfer_status =~ m/Transferring/) {

                $DATABASEDIR_LOCATION = &get_latest_db_location($db_location,$pc);
                $DATABASEDIR_LOCATION = &get_latest_db_location($db_location,$pc);
                logcomment("pjoshi-------------->latest DATABASEDIR_LOCATION : $DATABASEDIR_LOCATION");
                $db_file = &get_latest_db_files($DATABASEDIR_LOCATION,$pc);
                #$chkptfile = "$db_file".'-checkpoint*';
                my $interval = 60;
                logcomment("pjoshi--------------> Check Point File to be Found : $checkpoint");
                #Now check if the checkpoints are created by Polling
                for($i = 0; $i < 1800; $i += $interval ) {
                        $latest_chkpt = &get_latest_chkpt($db_file,$DATABASEDIR_LOCATION,$pc);
                        if(defined($latest_chkpt) && $latest_chkpt =~ /$checkpoint/ ) {
                                $found_chkpt = 1;
                                logcomment("pjoshi--------------> Check Point File Found: $latest_chkpt");
                                last;
                        }

                        #logcomment("pjoshi--------------> Waiting to Check Point to Occur...Sleeping for 1 min");
                        sleep $interval;
                }
                %svStatus = &get_snapvault_status($QTREE,$pc);
                $transfer_status=$svStatus{'Status'};
                logcomment("Qtree status is :$svStatus{'Status'}");
                if(($found_chkpt) && ($transfer_status =~ m/Transferring/)) {
                        $result=&abort_transfer($QTREE,$filer,$pc);
                        if($result) {
                                return 1;
                        }else {
                                return 0;
                        }
                } else {
                        logcomment("checkpoint not found or qtree is not in transfering state");
               }
        }else {
                logcomment("Didn't find the Expected  Transfer Status as  'Transffering'\n");
                return 0;
        }
}


#####################################################################
## This procedure will display the compression ratio on Primary side
##@param
#       Primary connection handle
#       filer
#       qtree
##Authour:pjoshi@netapp.com
####################################################################

sub get_compression_ratio      {
        my($filer,$qtree,$pc) = @_;
        my($before,$match,$output) = say($pc,"snapvault status -l $filer:$qtree","ON");
        my(@contents) = split("\n",$output);
        shift(@contents);
        foreach $ele (@contents) {
        $ele =~ m/:/;
        $field = $`;
        $value = $';
      $value =~ s/^\s+//;
      $value =~ s/\s+$//;
                $field =~ s/^\s+//;
                $field =~ s/\s+$//;
                $ret_val{$field} = $value;
        }
        return(%ret_val);
}





###################################################
##  This funtion will parse the snapvault log file and find out compression ratio of that relation/qtree 
##  This funtion will take following parameters and returns 0 or 1
#               1. Prmary Handel
#               2. Path of  OSSV installation or snapvualt  folder
#               3. Secondary Qtree of the relation
## Returns 0 if snapvault log has any errors or warnings
## pjoshi@netapp.com
##################################################
sub check_backup_compression_info {
        my($pc,$etcpath,$qtree)=@_;
        my $index=0,$result=0;
        my($match,$before,$after)=say($pc,"cat \"$etcpath\\etc\\snapvault\"");
        my @array = split("\n",$after);
        my $mstring="$qtree " . "Backup Operation End"; 
        for(@array){
                if(($_=~ m/$mstring/i)){
                        if($array[$index-1] =~ /compression ratio/){
                                logcomment("---------------------------------------------------- \n");
                                logcomment(" Compression Info is :  $array[$index-1] \n");
                                logcomment("---------------------------------------------------- \n");
                                $result=1;
                                last;
                        }
                }
                $index++;
        }
        if($result == 1) {
                return 1;
        }else {
                return 0;
        }
}



###################################################
##  This funtion will parse the snapvault log file and find out compression ratio of that relation/qtree after Restore
##  This funtion will take following parameters and returns 0 or 1
#               1. Primary Handel
#               2. Path of  OSSV installation or snapvualt  folder
#               3. Primary Restore Path 
## Returns 0 if snapvault log has any errors or warnings
## pjoshi@netapp.com
##################################################
sub check_restore_compression_info {
        my($pc,$etcpath,$primary_qtree)=@_;
        my $index=0,$result=0;
        my($match,$before,$after)=say($pc,"cat \"$etcpath\\etc\\snapvault\"");
        my @array = split("\n",$after);
        my $mstring="$primary_qtree " . "Restore Operation Complete";
        for(@array){
                if(($_=~ m/$mstring/i)){
                        if($array[$index-1] =~ /compression ratio/){
                                logcomment("---------------------------------------------------- \n");
                                logcomment(" Compression Info is :  $array[$index-1] \n");
                                logcomment("---------------------------------------------------- \n");
                                $result=1;
                                last;
                        }
                }
                $index++;
        }
        if($result == 1) {
                return 1;
        }else {
                return 0;
        }
}



##############################################################
## This procedure abort transfer on SECONDARY side at particular checkpoints
##      Parameters:
##              1. Complete location of the OSSV database (D:\Program Files\netapp\snapvault\db\QsmDatabase\Files\QtreeHistory\0000)
##              2. checkpoint on which transfer to be aborted 
##		3. Qtree
##		4. FIler
##		5. Primary handle 
##              6. Connection handle for secondary 
##    added by pjoshi:
##############################################################
sub  abortsecondary_at_checkpoint{
        my($db_location,$checkpoint,$QTREE,$filer,$pc,$fc) = @_;
        my $chkptfile;
        my $DATABASEDIR_LOCATION;
        my $db_file,i;
        my $latest_chkpt;
        my $found_chkpt=0;

        my %svStatus = &get_snapvault_status($QTREE,$fc);
        my $transfer_status=$svStatus{'Status'};
        logcomment("Qtree status is :$svStatus{'Status'}");
        if($transfer_status =~ m/Transferring/) {

                $DATABASEDIR_LOCATION = &get_latest_db_location($db_location,$pc);
                $DATABASEDIR_LOCATION = &get_latest_db_location($db_location,$pc);
                logcomment("pjoshi-------------->latest DATABASEDIR_LOCATION : $DATABASEDIR_LOCATION");
                $db_file = &get_latest_db_files($DATABASEDIR_LOCATION,$pc);
                #$chkptfile = "$db_file".'-checkpoint*';
                my $interval = 60;
                logcomment("pjoshi--------------> Check Point File to be Found : $checkpoint");
                #Now check if the checkpoints are created by Polling
                for($i = 0; $i < 1800; $i += $interval ) {
                        $latest_chkpt = &get_latest_chkpt($db_file,$DATABASEDIR_LOCATION,$pc);
                        if(defined($latest_chkpt) && $latest_chkpt =~ /$checkpoint/ ) {
                                $found_chkpt = 1;
                                logcomment("pjoshi--------------> Check Point File Found: $latest_chkpt");
                                last;
                        }

                        #logcomment("pjoshi--------------> Waiting to Check Point to Occur...Sleeping for 1 min");
                        sleep $interval;
                }
                %svStatus = &get_snapvault_status($QTREE,$fc);
                $transfer_status=$svStatus{'Status'};
                logcomment("Qtree status is :$svStatus{'Status'}");
                if(($found_chkpt) && ($transfer_status =~ m/Transferring/)) {
                        $result=&abort_transfer($QTREE,$filer,$fc);
                        if($result) {
                                return 1;
                        }else {
                                return 0;
                        }
                } else {
                        logcomment("checkpoint not found or qtree is not in transfering state");
               }
        }else {
                logcomment("Didn't find the Expected  Transfer Status as  'Transffering'\n");
                return 0;
        }
}

#####################################################################
## This procedure will enable/diasble the compression on filer side
##@param
#       Filer connection handle
#       option  on or off
##Authour:pjoshi@netapp.com
####################################################################

sub SV_enable_disable_compression {

        my($fc,$option) = @_;
        my ($be,$af,$match)= say($fc,"options snapvault.ossv.compression $option",-timeout,3600);
        ($be,$af,$match)= say($fc,"options snapvault.ossv.compression",-timeout,3600);
        logcomment("$match");

        if($match =~ m/$option/i) {
                return 1;
        } else {
                return 0;
        }
}

1;
__END__
