# -*-perl-*-
# $Id: //depot/prod/test/Rsierranevada/dp/ossv/Dataset/basic.pm#1 $

#use Tharn;

###################################################################
## This procedure starts a baseline transfer.
## This procedure is needed for those scripts which don't need to run 
## backup as subtests.
###################################################################

sub start_baseline_transfer {

 	my($filer,$primary,$primary_path,$qtree,$throttle,$retry,$fc) = @_;
	#pjsohi
	#my $match = say($fc,"snapvault start -k $throttle -S $primary:$primary_path $qtree","Transfer started",-fail,"Couldn't start base line transfer",-timeout,18600);	
  my $match;

	if($ENABLE_COMPRESSION =~ 1){
		logcomment(">>>>>>>COMPRESSION is Enabled for Baseline");
	 $match = say($fc,"snapvault start -k $throttle -t $retry -o compression=on  -S $primary:$primary_path $qtree","Transfer started",-fail,"Couldn't start base line transfer",-timeout,3600);	
	}else {
	 $match = say($fc,"snapvault start -k $throttle -t $retry -S $primary:$primary_path $qtree","Transfer started",-fail,"Couldn't start base line transfer",-timeout,3600);	

	}
	if($match =~ /Transfer started/) {
		return 1;
	} else {
		return 0;
	}
}

sub start_transfer {

        my($filer,$primary,$primary_path,$qtree,$throttle,$fc) = @_;
        my $match = say($fc,"snapvault start -k $throttle -S $primary:$primary_path $qtree","Transfer started",-ok,-timeout,3600);

        if($match =~ /Transfer started/) {
                return 1;
        } else {
                return 0;
        }
}

######################################################
## This procedure is for aborting a transfer
#######################################################

sub abort_transfer {
	my($qtree,$device,$filer,$fc,$pc) = @_;
        my ($match,$before, $after); #added pjoshi
 	
	if($device =~ m/^PRIMARY$/) {
    	 ($match,$before,$after) = say($pc,"snapvault abort $filer:$qtree"); 
	} else {
   	 ($match,$before,$after) = say($fc,"snapvault abort $qtree","dummy",-ok);	
	}
	#if( $RESPONSE =~ m/couldn't find destination/) {
	if( $after  =~ m/not find/) {
		logcomment("Unsuccessful abort.Might be missing something");
		return 0;	
	} else {
		logcomment("Successful abort");
 		return 1;	
	}

}

##################################
## This procedure starts a restore
##################################

sub start_restore {  

	my($primary,$filer,$restore_path,$qtree,$throttle,$snapshot,$pc) = @_;
        my ($match,$before, $after); #added pjoshi
        @restore_messages;
        if ($snapshot =~ m/NONE/)
        {
		 if($ENABLE_COMPRESSION == 1) {

        		($match,$before,$after) = say($pc,"snapvault restore -c -S $filer:$qtree '$restore_path'",-ignore,"One or more files have not been restored. Check snapvault log",-timeout,36000);
        		logcomment(" Compression Enabled during Restore :m:$match, b:$before a:$after");
		 }else {
        		($match,$before,$after) = say($pc,"snapvault restore -S $filer:$qtree '$restore_path'",-ignore,"One or more files have not been restored. Check snapvault log",-timeout,36000);
        		logcomment("m:$match, b:$before a:$after");
		}
        }else {
		 if($ENABLE_COMPRESSION == 1) {
			($match,$before,$after) = say($pc,"snapvault restore  -c -s $snapshot  -S $filer:$qtree '$restore_path'",-ignore,"One or more files have not been restored. Check snapvault log",-timeout,36000);
 	        	logcomment("Compression Enabled during Restore  m:$match, b:$before a:$after");
		}else {
			 logcomment("SNAPNAME in retsore function :$snapshot");
			($match,$before,$after) = say($pc,"snapvault restore -s $snapshot  -S $filer:$qtree '$restore_path'",-ignore,"One or more files have not been restored. Check snapvault log",-timeout,3600);
 	        	logcomment("m:$match, b:$before a:$after");
		}
        }
         
        @restore_messages= split("\n",$after);
         
        logcomment("---------->0 :$restore_messages[0]\n 1:$restore_messages[1]\n 2:$restore_messages[2]");
        #if(!($restore_messages[1] =~ m/Failed|Error|Check snapvault|could not be started|Unable|could not|cannot|not/)) {
        if(($restore_messages[1] =~ m/Access is denied ||Failed to link/)) {
        if(!$restore_messages[1]) {
		logcomment("Restore done successfully");
                return 1;
        } else {
 		logcomment("FAIL: Restore could have failed.Please check the snapvault log for more details");
 		logcomment("FAIL: $after");

                return 0;
        }
        
}
}
###########################################
## This procedure starts a DB restore
########################################### 

sub start_db_restore {
   
        my($primary,$filer,$restore_path,$qtree,$pc) = @_;
        my ($match,$before, $after); #added pjoshi
        
	if($DB_FLAG =~ 0)
        {
         ($match,$before,$after) = say($pc,"'$OSSV_LOC//snapvault' restore -S $filer:$qtree/.OSSV_DATABASE_BACKUP                                                  '$TMP_DB_LOC'","dummy",-ok,-timeout,2000); 
        }
        else
        {
         ($match,$before,$after) = say($pc,"'$OSSV_LOC//snapvault' restore -S $filer:$qtree/.OSSV_DATABASE_BACKUP_1                                                '$TMP_DB_LOC'","dummy",-ok,-timeout,2000);  
        }

        if($after =~ m/Failed|Error/i ) {
                logcomment("DB Restore could have failed.Please check the snapvault log for more details");
       		logcomment("m:$match, b:$before a:$after");
                return 0;
        } else {
                logcomment("DB Restore done successfully");
	logcomment("m:$match, b:$before, a:$after");
                return 1;
        }
        
}
 
#####################################################################
## This procedure starts a update transfer.
###################################################################

sub start_update_transfer {

        my($qtree,$throttle,$fc) = @_;
        my ($match,$before,$after); #ad pjoshi 
        
	($match,$before,$after) = say($fc,"snapvault update -k $throttle $qtree","Transfer started",-swallow,-timeout,7200);

        if($match =~ /Transfer started/) {
		logcomment("m:$match, b:$before, a:$after");
                return 1;

        } else {
		logcomment("m:$match, b:$before, a:$after");
                return 0;
        }
}

################################################
## This procedure starts a resync transfer
################################################

sub start_resync_transfer {

        my($primary,$restore_path,$qtree,$throttle,$fc) = @_;
        
        my ($match,$before,$after); #ad pjoshi 
	 ($match,$before,$after) = say($fc,"snapvault start -r -f -S $primary:$restore_path $qtree","Transfer started",-ok,-timeout,1000);

        if($match =~ /Transfer started/) {
		logcomment("m:$match, b:$before, a:$after");
          	return 1;
        } else {
		logcomment("m:$match, b:$before, a:$after");
                return 0;
        }
}

1;
__END__
