# $Id: //depot/prod/test/Rsierranevada/dp/ossv/Linux_sanity/svutils.pm#1 $
##-------------------------------------------------------
## This perl module has procedures needed to create 
## datasets and a few procedures to execute commands on the
## secondary and to perform a few primary side checks.
## Most of the code/procedures are extensions or modifications
## to procedures borrowed from and written by mukherje@netapp.com
##
##------------------------------------------------------

my($toolLocation,$configLocation);

##-------------------------------------------------
## Standard locations of data,tools and config 
## files.
##-------------------------------------------------

$toolLocation = '/ossv_tools/testing/bin';
$configLocation = '/ossv_tools/testing/config';

$toolLocation_win = 'c:\\\ossv_testing\\\tools';
$configLocation_win = 'c:\\\ossv_testing\\\tools';

##---------------------------------------------------
## This procedure is used to create/modify Dataset
##
##---------------------------------------------------

sub create_data {

   my($config_file,$mode,$dataLocation,$fc) = @_;
   if($mode !~ /mod/i) {
     	$config_file = "mk_".$config_file;
   } else {
  	$config_file = "mod_".$config_file;
   }

   say($fc,"$toolLocation/nvtdsetup -cf $configLocation/$config_file -di $dataLocation",-prompt,"$PRIMARY",-timeout,900);
}

sub create_data_windows {

}

##-------------------------------------------------
## This procedure is used to profile a dataset
## 	Parameters:
##
##-------------------------------------------------

sub create_profile {

   my($data_type,$num,$data_path,$fc) = @_;
   say($fc,"$toolLocation/nvtdprofile $data_path $data_type $num",-timeout,600);   
} 

##-------------------------------------------------
## This procedure is used to compare 2 profiles
##	Parameters:
##
##-------------------------------------------------

sub compare_profile {

    my($dataPath,$dataType,$profile1,$profile2,$fc) = @_;
    my($match,$before,$after) = say($fc,"$toolLocation/nvtddiff -t $dataPath $dataType $profile1 $profile2","dummy",-ok,-timeout,600);

	if( $after =~ m/No differences/) {
		return(1);
	} else {
		return(0);
	}
}

##-------------------------------------------------------------
## This is a hack used by us to compare data.
## Restore the backed-up data to a different location.
## Rename the location to the original backedup location.
## Profile the data.Now compare it with the older profiles.
##-------------------------------------------------------------

sub manipulator {

   my($primary_path,$data_set,$restore_path,$restore_dir,$pc)=@_;
   my $dataPath = "$primary_path" . "/" ."$data_set";
   my $restored_path = "$restore_path" . "/" ."$restore_dir";
   my $altName = "$dataPath"."729";
   say($pc,"mv $dataPath $altName");
   say($pc,"mv $restored_path $dataPath");
   say($pc,"mv $altName $restored_path");

}

##----------------------------------------------------------------
## List database files for the locations
##	Parameters:
##		1. Complete location of the OSSV database
##		2. Connection handle for Primary
##
##
##----------------------------------------------------------------

sub get_latest_db_files {

	my($db_location,$fc)= @_;
	my($match,$before,$after) = say($fc,"ls -1t $db_location | grep ^[0-9a-z][0-9a-z]\$",-timeout,600);
	@list_files = split("\n",$after);
    
	#my($db_file) = $list_files[0]; 
	my($db_file) = $list_files[1]; 

	chop($db_file);
	if(defined($db_file)) {
		return($db_file);
	} else { 
		return;     
	}
}

##----------------------------------------------------------------
## Lists latest database directories like 00,01,02 
##	Parameters:
##		1. Complete location of the OSSV database
##		2. Connection handle for Primary
##    added by pjoshi: 
##----------------------------------------------------------------

sub get_latest_db_location {

	my($db_location,$fc)= @_;
	my($match,$before,$after) = say($fc,"ls -1t $db_location | grep ^[0-9a-z][0-9a-z]\$",-timeout,600);
	@list_files = split("\n",$after);
    
	#my($db_dir) = $list_files[0]; 
	my($db_dir) = $list_files[1]; 
        logcomment("---> dbdir: $db_dir");
 
	chop($db_dir);
	if(defined($db_dir)) {
		my $db_dirlocation  = "$db_location" . "$db_dir" ;	
        	logcomment("--------------------> dbdirlocation: $db_dirlocation");
		return($db_dirlocation);
	} else { 
		return;     
	}
}


##-----------------------------------------------------------------
## Delete the database file
##	Parameters:
##		1. Database File to be deleted.
##		2. Complete location of the database file.
##		3. Connection handle for the Primary.
##
##-----------------------------------------------------------------

sub delete_db_files {
	my($db_file,$db_location,$pc) = @_;
	my($match,$before,$after) = say($pc,"rm -f $db_location/$db_file*","dummy",-ok,-timeout,600);

	logcomment("m:$match, b:$before,a:$after");	
	
	my($match,$before,$after) = say($pc,"ls -l $db_location/$db_file","dummy",-ok,-timeout,600);
	
	logcomment("m:$match, b:$before,a:$after");	
	
	if($after =~ m/Cannot/i) {
		return(0);
	} else {
		return(1);
	}

}


##-----------------------------------------------------------------
## This procedure lists all the checkpoints in the database
##	Parameters:
##			1. The db file for which the checkpoint is created.
##			2. The OSSV database location
##			3. Connection handle for the Primary.
##
##------------------------------------------------------------------

sub get_latest_chkpt {
 
	my($db_file,$db_location,$fc) = @_;
	my $chkptfile = "$db_file"."-checkpoints*";
	my($match,$before,$after) = say($fc,"ls -1t $db_location | grep $chkptfile",-timeout,300);
	my(@chkpt_list) = split("\n",$after); 
	#my($latest_chkpt) = $chkpt_list[0];
	my($latest_chkpt) = $chkpt_list[1];

	if(defined($latest_chkpt)) {
		return($latest_chkpt);
	} else {
		return;
	}
}

##--------------------------------------------------------------------------
## This procedure deletes checkpoint
##  Parameters:
##		1. DB file of the transfer
##		2. Location of the checkpoint file.(OSSV DB)
##		3. The number of the checkpoint files to be deleted.
##-------------------------------------------------------------------------

sub delete_chkpt_files {
	my($db_file,$chkpt_location,$num,$pc) = @_;
	my($match,$before,$after) = say($pc,"ls -1t $chkpt_location | grep $db_file-checkpoint* | tail -$num | xargs rm -f",-ok,-timeout,600);

	if($after =~ m/Cannot|Failed|Error/i) {
		return(0);
	} else {
 		return(1);
	}

}


##------------------------------------------------------------------------
## This procedure gets the number of checkpoint for a transfer
## Parameters:
##		1. DB file of the transfer for which the checkpoint is created
##		2. Location of the Checkpoint.(OSSV DB)
##		3. Connection handle for the primary.
##-------------------------------------------------------------------------

sub get_chkpt_count {
	
	my($db_file,$db_location,$fc) = @_;
	my $search_pattern = "$db_file"."-checkpoints*";
	my($match,$before,$after) = say($fc,"ls -1t $db_location | grep $searchpattern | wc -l",-timeout,300);
	return($after);	
}

##-----------------------------------------------------------------------------
## This procedure gets the status of a qtree by executing the 
## "snapvault status -l" command.It returns an associative array.
## The associative array can be indexed by the named of fields in the "snapvault status" output.
##
##	Parameters:
##		1.Name of the qtree
##		2.Connection handle of the Filer
##
##-------------------------------------------------------------------------------

sub get_snapvault_status {

	my($qtree,$fc) = @_;

	logcomment("$qtree, $fc");
	my($match,$before,$output) = say($fc,"snapvault status -l $qtree","ON");

	my(@contents) = split("\n",$output);
	shift(@contents);
	foreach $ele (@contents) {
		$ele =~ m/:/;
		$field = $`;
		$value = $';
		$value =~ s/^\s+//;
		$value =~ s/\s+$//;
		$field =~ s/^\s+//;
		$field =~ s/\s+$//;
		$ret_val{$field} = $value;
	}
	return(%ret_val);
}

##----------------------------------------------------------------------------
## This procedure starts a baseline transfer.
## This procedure is needed for those scripts which don't need to run 
## backup as subtests.
##		Parameters:
##			1. Name of the Primary.
##			2. Name of the Filer.
##			3. Location of data to be backed up.
##			4. Name of Qtree.
##			5. Throttle value for the transfer.
##			6. Filer connection handler.
##----------------------------------------------------------------------------

sub start_baseline_transfer {

 	my($primary,$filer,$primary_path,$qtree,$throttle,$fc) = @_;
	my ($match,$before,$after) = say($fc,"snapvault start -k $throttle -S $primary:$primary_path $qtree","dummy",-ok,"Couldn't start base line transfer",-timeout,3600);	
 	
	if($after =~ m/Transfer started/) {
		return 1;
	} else {
		return 0;
	}
}

##------------------------------------------
## This procedure starts a resync operation.
##
##
##	Parameters:
##          1. Name of the Primary
##          2. Name of the Filer
##          3. Resync location
##          4. qtree name
##          5. Throttle
##          6. Filer connection handler
##-----------------------------------------

sub start_resync {

        my($primary,$filer,$resync_path,$qtree,$throttle,$fc) = @_;
        my ($match,$before,$after) = say($fc,"snapvault start -r -f -k $throttle -S $primary:$resync_path $qtree","dummy",-ok, "Resync didn't start", timeout,3600);

        if($after =~ m/The resync base snapshot will be/ && $after =~ m/Transfer started/) {
                return 1;
        } else {
                return 0;
        }
}


##---------------------------------------------
## This procedure breaks the snapvault realtion
## and converts the qtree to a writable qtree
##
##
##---------------------------------------------

sub convert_qtree_writable {

	my($qtree, $fc) = @_;
       
        say($fc, "priv set diag"); 
        say($fc, "snapmirror off", -timeout, 600);
        say($fc, "options snapvault.enable off", -timeout, 600);
    
        say($fc, "snapmirror convert $qtree", -timeout, 600);
        say($fc, "snapmirror on", -timeout, 600);
        say($fc, "snapmirror quiesce $qtree", -timeout, 600);
        say($fc, "snapmirror break $qtree", -timeout, 600);
        say($fc, "options snapvault.enable on", -timeout , 600);
        
}

##----------------------------------------------------------------------
## This procedure is for aborting a transfer
##		Parameter: 
##			1. Qtree name
##			2. Keywords "PRIMARY" or "SECONDARY"
##			3. Filer name
##			4. Connection handler for Primary/Secondary
##---------------------------------------------------------------------

sub abort_transfer {
	my($qtree,$device,$filer,$fc) = @_;
 	if($device =~ m/^PRIMARY$/) {
    	 my($match,$before,$after) = say($fc,"/usr/snapvault/bin/snapvault abort $filer:$qtree"); 
	} else {
   	my($match,$before,$after) = say($fc,"snapvault abort $qtree","dummy",-ok);	
	}
	if( $after =~ m/couldn't find destination/) {
		logcomment("Unsuccessful abort.Might be missing something");
		return 0;	
	} else {
		logcomment("Successful abort");
 		return 1;	
	}

}

##--------------------------------------------------------------
## This procedure is to start a restore
##	Parameters:
##		1.Name of Primary
##		2.Name of Filer
##		3.Restore Path
##		4.Qtree name
##		5.Snapshots. NULL if you want to restore from the latest snapshot.
##		6.Primary connection handle
##
##---------------------------------------------------------------

sub start_restore {  

	my($primary,$filer,$restore_path,$qtree,$snapshot,$pc) = @_;
	my ($before,$match,$after);
	chomp($qtree);
	chomp($restore_path);
	if( $snapshot =~ m/NULL/i ) {
		($match,$before,$after) = say($pc,"snapvault restore -S $filer:$qtree $restore_path","dummy",-ok,-timeout,3600);
	} else {
		($match,$before,$after) = say($pc,"snapvault restore -s $snapshot -S $filer:$qtree $restore_path","dummy",-ok,-timeout,3600);
	}

    if($after =~ m/failed|error|Invalid/i ) {
	logcomment("Restore could have failed.Please check the snapvault log for more details");
	return(0);
    } else {
	logcomment("Restore done");
	return(1);
    }
}

##--------------------------------------------------
## This procedure starts an update
##
## Parameters:
##	1.Qtree name
##	2.Throttle
##	3.Connection handle
##
##-------------------------------------------------

sub start_update {
	
	my($qtree,$throttle,$fc) = @_;
	my($match,$before,$after) = say($fc,"snapvault update -k $throttle $qtree","dummy",-ok,-timeout,3600);
	
	if( $after =~ m/Transfer started/) {
		logcomment("Update started");
		return(1);
	} else {
		logcomment("Update didn't start for some reason");
		return(0);
	}	
}
	
##--------------------------------------------------------------------------------
## This procedure starts a db restore.
## The restore is done in location named "db" in the "restore path" specified.
##
## Parameters:
##	1.Name of the primary
##	2.Name of the Filer
##	3.Restore path
##	4.Qtree name
##	5.Suffix if any(used only if a file by name .OSSV_DATABASE_BACKUP already exists)
##	6.Connection handle of primary
##
##--------------------------------------------------------------------------------

sub start_db_restore {

	my($primary,$filer,$restore_path,$qtree,$suffix,$pc) = @_;
	my $db_file = ".OSSV_DATABASE_BACKUP" . "$suffix";
	my($match,$before,$after) = say($pc,"snapvault restore -S $filer:$qtree/$db_file $restore_path/db","dummy",-ok,-timeout,3600);

	if($after =~ m/[fF]ailed|[Ee]rror/ ) {
		logcomment("Restore could have failed.Please check the snapvaultlog for more details");
		return(0);
  } else {
		logcomment("Restore done");
		return(1);
	}
}

##-----------------------------------------------
## This procedure creates a snapvault schedule
## using the snap sched command
## 
## Parameters:
##	1.Name of Schedule
##	2.Name of volume
##	3.The Schedule string(e.g.5@12@mon-fri)
##
##----------------------------------------------

sub create_sched {
	my($schedName,$volume,$schedspec,$fc) = @_;
	my($match,$before,$after) = say($fc,"snapvault snap sched $volume $schedName $schedspec");
	if( $after =~ m/error|Failed|Can\'t/i ) {
		logcomment("Cannot create a snapvault sched");
		return(0);
	} else {
		logcomment("successfully created snapvault sched");
		return(1);
	}
}
	

##--------------------------------------------
## This procedure is used to create named snapshots
## using snapvault
##
## Parameter:
##	1.Name of the created schedule	
##	2.Volume name
##	3.Connection handle
##
##
##-----------------------------------------


sub create_named_snapshot {

	my($name,$volume,$fc) = @_;
	my($match, $before, $after) = say($fc,"snapvault snap create -w $volume $name", -timeout, 600);

	if($after =~ m/error|Failed|can\'t/i ) {

		logcomment("Cannot create a snapvault sched");
		return(0);

	} else {

		logcomment("Successfully created a named snapshot");
		return(1);
	}
}

##----------------------------------------------------
## This procedure is used to cleanup any residual configurations after the test
##
## Parameter:
##	1. Filer name
##	2. Qtree
##	3. Primary Name
##	4. Primary Path
##	5. Data set name
##	6. Restore path
##	7. Restore directory
##	8. Connection handle for filer
##	9. Connection handle for primary
##       
##----------------------------------------------------

sub cleanup {

    my($filer,$qtree,$primary,$primary_path,$data_set,$restore_path,$restore_dir,$fc,$pc) = @_;
    my $reg_exp = "qtree deleted";
    
    say($fc,"snapvault stop -f $qtree","$reg_exp",-fail,"Couldn't remove qtree",-timeout,1200);
    say($fc,"snapvault release $qtree $primary:$restore_path/$restore_dir ",-timeout,1200);

    say($pc,"/usr/snapvault/bin/snapvault release $primary_path/$data_set $filer:$qtree",-timeout,1200);
    say($pc,"/usr/snapvault/bin/snapvault release $restore_path/$restore_dir $filer:$qtree",-timeout,1200);

    #say($pc,"mv $primary_path/$data_set /tmp/$data_set",-timeout,1200);
    #say($pc,"mv $restore_path/$restore_dir /tmp/$restore_dir",-timeout,1200);
     
    say($pc, "rm -rf $restore_path/$restore_dir", -timeout, 1200);
    say($pc, "rm -rf $primary_path/$data_set", -timeout, 1200);
    
    #say($pc,'rm -rf /tmp/* &', -timeout, 3600);

}


##---------------------------------------------
## A set of handy procedures to be used our tests 
##---------------------------------------------

##---------------------------------------------
## This procedure creates a file of a particular name
## This uses the tools mksparse to create a File
##
## Parameters:
##		1. Path of the File
##		2. Name of the File
##		3. Size of the File
##		4. Connection handle
##
## 
##---------------------------------------------

sub file_create
{
	my ($path,$filename,$size,$pc) = @_;
	say($pc,"$toolLocation/mksparse $path/$filename $size 0 0",-timeout,3600);
}

sub file_create_holey
{
	my ($path,$filename,$format,$pc) = @_;
	say($pc,"$toolLocation/mksparse $path/$filename $format",-timeout,3600);
}

sub file_create_os
{

    my ($path,$filename,$size,$os,$pc) = @_;
   
    if($os =~ m/win/i) {

        say($pc,"$toolLocation_win/mksparse \'$path/$filename\' $size 0 0",-timeout,3600);

    } else {

        say($pc,"$toolLocation/mksparse $path/$filename $size 0 0",-timeout,3600);
    
    }
}


##--------------------------------------------------------------
## This procedure sets the acl for a particular file
##
## Parameters:
##		1.The OS type to determine the command
##		2.The path of the file
##		3.The connection handle
##
##--------------------------------------------------------------


sub create_acl
{
my ($os,$path,$pc) = @_;
my ($match,$before,$after) = say($pc,"mount -o remount,acl /dev /",-timeout,100);
logcomment("after mounting ACL     :$after");

##---------------------------------------
#Creating users
##---------------------------------------
my $adduser;
my $addgroup;
my $usercount =5;
logcomment("Given OS is : $os");
if ($os =~ /FreeBSD/i){
	$adduser="pw adduser";
	$addgroup="pw addgroup";
}else {
	($match,$before,$after) = say($pc,"useradd",-timeout,100);
	if($after =~ /command|not|found/i){
		$adduser="adduser";
		$addgroup="groupadd";
	}else{
		$adduser="useradd";
		$addgroup="groupadd";
	}
}	

while($usercount){
	($match,$before,$after) = say($pc,"$adduser testuser$usercount ",-timeout,100);
	($match,$before,$after) = say($pc,"$addgroup tstgrp$usercount ",-timeout,100);
	--$usercount;
}
logcomment("After creation of group:	 $after");


##-----------------------------------------
##  Files whose acls need to be modified
##-----------------------------------------
my @aclFiles = ("FilewithAcl",
		"FileWithoutAcl",
		"MoreAcls",
		"FiletobeModified",
		" ");

##-----------------------------------------------------
##  The Acls that needed to be specified to the Files
##-----------------------------------------------------

my @commandStrings = (  "-m u:testuser1:rwx, -m g:tstgrp1:r--",
						"-m u:testuser2:r-x, -m m::rwx, -m o::r--",
						"-m u:testuser3:r--, -m g:tstgrp2:rwx",
			"-m u:testuser4:r-x,u:testuser5:rwx,u:testuser1:rwx,u:testuser2:r--,u:testuser3:---,u:testuser4:-wx",
						"-m u:testuser5:r--, -m g:tstgrp1:r-x, -m m::-wx"); 
my $command;
if($os =~ m/LINUX|FreeBSD/i) {

		$command = "setfacl";

	} elsif ($os =~ m/SOLARIS/i) {

		$command = "setfacl";
        @commandStrings = (  "-m u:testuser1:rwx",
						"-m g:tstgrp1:r--",
						"-m m:rwx",
			            "-m o:r--",
						"-m u:testuser5:r-x"); 
	} 
	elsif ($os =~ m/HPUX/i) {
		$command = "setacl";
		@commandStrings = (  "-m u:testuser1:rwx",
						"-m g:tstgrp1:r--",
						"-m m:rwx",
			            "-m o:r--",
						"-m u:testuser5:r-x"); 
	} 
			
my $file;
my $aclString;
my $i=0;

	foreach $file (@aclFiles) {
	file_create("$path",$file,"5",$pc);
	$aclString=$commandStrings[$i];
    say($pc,"$command $aclString $path/$file",-timeout,3600);	
	$i++;
	}	
}


##--------------------------------------------------------------
## This procedure Modify the acl for a particular file
##
## Parameters:
##		1.The OS type to determine the command
##		2.The path of the file
##		3.The connection handle
##
##--------------------------------------------------------------


sub modify_acl
{
my ($os,$path,$pc) = @_;

##-----------------------------------------
##  Files whose acls need to be modified
##-----------------------------------------
my @aclFiles = ("FilewithAcl",
		"FileWithoutAcl",
		"MoreAcls",
		"FiletobeModified",
		" ");

##-----------------------------------------------------
##  The Acls that needed to be specified to the Files
##-----------------------------------------------------

my @commandStrings = (  "-k -x u:testuser1, -x g:tstgrp1",
			"-m u:testuser2:rwx, -m m::x, -m o::rwx",
			"-x u:testuser3:r--",
			"-x u:testuser4,u:testuser5,u:testuser1,u:testuser2,u:testuser3,u:testuser4",
			"-m u:testuser5:rx, -m g:tstgrp1:r-x, -m m::rx"); 
my $command;
if($os =~ m/LINUX|FreeBSD/i) {

		$command = "setfacl";

	} elsif ($os =~ m/SOLARIS/i) {

		$command = "setfacl";
    @commandStrings = (  "-m u:testuser1:r--",
						"-d g:tstgrp1:r--",
						"-m m:r--",
			                        "-m o:rw-",
						"-d u:testuser5:r-x"); 
	} 
	elsif ($os =~ m/HPUX/i) {
		$command = "setacl";
		@commandStrings = (  "-m u:testuser1:r--",
						"-d g:tstgrp1:r--",
						"-m m:r--",
			                        "-m o:rw-",
						"-d u:testuser5:r-x");
	} 
			
my $file;
my $aclString;
my $i=0;

	foreach $file (@aclFiles) {
	$aclString=$commandStrings[$i];
    say($pc,"$command $aclString $path/$file",-timeout,3600);	
	$i++;
	}	
}



##-----------------------------------------------------------------
##	This procedure gets acl of a File.It returns the output of a getfacl/getacl etc.
##
##	Parameters:
##		1.the OS type to determine the command
##		2.The path of the file
##		3.Name of the file
##		4.Connection handle
##
##------------------------------------------------------------------

sub get_acl {
	
    my ($os,$path,$filename,$pc) = @_;

    if($os =~ m/LINUX|FreeBSD/i) {

        $command = "getfacl";

    } elsif ($os =~ m/SOLARIS/i) {

        $command = "getfacl";

    } elsif ($os =~ m/HPUX/i) {

        $command = "getacl";

    }

	my($match,$dummy,$acl) = say($pc, "$command $path/$filename", -timeout,3600);

        ## --------------------
	## get rid of file name
        ## --------------------

	$path =~ s"\/"\\/"g;
	$acl =~ s/\# file: $path\/$filename/_/;
	logcomment("$acl");
	return($acl);
}



####---------------------------------------
## This procedure will checks if Given files ACL's are same or not
##  parameter:
##        1. OS type
##        2. Sourse path
##        3. Destination pth
##        4. Primary machine handel
###-------------------------------------------
  sub compare_acl {
    my ($os,$sourcepath,$destpath,$pc) = @_;   
	
##-----------------------------------------
##  Files whose acls need to be modified
##-----------------------------------------
my @aclFiles = ("FilewithAcl",
		"FileWithoutAcl",
		"MoreAcls",
		"FiletobeModified",
		" ");
my ($file,@backup,@restore,$i);   
my $temp=0;
foreach $file (@aclFiles) {

	my $origAcl = &get_acl($OS, "$sourcepath",$file,$pc);
	my $restAcl = &get_acl($OS, "$destpath",$file,$pc);
    @backup = split ("\n",$origAcl);
	@restore=split ("\n",$restAcl);
	$origAcl=" ";
	$restAcl=" ";
	$i=3;
	while($i <= $#backup)
	{
	$restAcl="$restAcl"."$backup[$i]";
	$origAcl="$origAcl"."$restore[$i]";
	$i++;
	} 
	if($origAcl eq $restAcl) {
		logcomment("Acls are the same");
		$temp++;
		logcomment("Backed UP files ACLS are $origAcl");
        logcomment("Restore files ACLS are $restAcl");

	} else {
		logcomment("Acls are not consistent for file $file");
        logcomment("Backed UP files ACLS are $origAcl");
        logcomment("Restore files ACLS are $restAcl");
		}
 }
 if($temp== ++$#aclFiles)
  {
    return 1;
  }else{
  logcomment("going to return 0   $temp   $#aclFiles");
  return 0;
}
}

##----------------------------------------------------------
#This procedure will create both soft and hard link to the files
##  parameter:
##        1. Sourse path
##       2. Primary machine handel
###----------------------------------------------------------
sub create_link {
	my($path,$pc)=@_;
	my @files = ("soft_file1",
	              " ",
				  "hard_file1",
				  "hard_file2",
				);
	my @links =( "soft_link1",
	             "soft_link2",
				 "hard_link1",
				 "hard_link2"
				);
	my $file;
	my $time=200;
	foreach $file (@files) {
	file_create("$path",$file,"5",$pc);
	}
	say($pc,"ln -s '$path/$files[0]' '$path/$links[0]'",-timeout,$time);
	say($pc,"ln -s '/usr' '$path/$links[1]'",-timeout,$time);
	say($pc,"ln  '$path/$files[2]' '$path/$links[2]'",-timeout,$time);
	say($pc,"ln  '$path/$files[3]' '$path/$links[3]'",-timeout,$time);
}

##----------------------------------------------------------
#This procedure will modify soft and hard link of the files
##  parameter:
##        1. Sourse path
##       2. Primary machine handel
###----------------------------------------------------------

sub modify_link {
	my($path,$pc)=@_;
	my @files = ("soft_file1",
	              " ",
				  "hard_file1",
				  "hard_file2",
				);
	my @links =( "soft_link1",
	             "soft_link2",
				 "hard_link1",
				 "hard_link2"
				);
	my $file;
	my $time=200;
	foreach $file (@files) {
	file_create("$path",$file,"5",$pc);
	}
	say($pc,"rm '$path/$files[0]'",-timeout,$time);
	say($pc,"rm '$path/$links[1]'",-timeout,$time);
	say($pc,"rm  '$path/$files[2]' ",-timeout,$time);
	say($pc,"rm  '$path/$links[3]'",-timeout,$time);
}
				 
	


##-------------------------------------------
## This procedure checks if a File exists.
##
##	Parameters:
##		1.Name of File to be checked
##		2.Location of the file(File path)
##		3.Connection handle
##
##
##-------------------------------------------

sub check_file_exists
{
	my($fileName,$fileLocation,$pc) = @_;
	my($match,$before,$after) = say($pc,"ls -1a $fileLocation",-ok,-timeout,600);
	if( $after =~ /$fileName/) {
		return(1);
	} else {
		return(0);
	}
}

1;

__END__



