# $Id: //depot/prod/test/Rsierranevada/dp/ossv/Linux_sanity/tasks.pm#1 $
##-----------------------------------------------------------------------------
##  This procedure waits for a transfer to finish for a specific period of time.
##  Executes the snapvault status command to get the details of the transfer 
##	Parameters:
##		1. Reference to an associative array which has the values of the field
##		2. Timeout.
##		3. Qtree
##		4. Connection Handler
##-----------------------------------------------------------------------------

sub wait_for_transfer_finish {

   my($svStatus,$timeout,$qtree,$fc) = @_;
	
   if(defined($timeout)) {
      logcomment("Transfer timeout is $timeout");
   } else {
      logcomment("Timeout not defined.Setting to 3600");
      $timeout = "3600";
   }
	
   %$svStatus = &get_snapvault_status($qtree,$fc);
	
   while($$svStatus{'Status'} =~ m/Transferring|Quiescing/i) {

      if($timeout == 0 || $$svStatus{'Current Transfer Error'} ne "-") {
         logcomment("Transfer Timedout:$$svStatus{'Current Transfer Error'}");
         return 0;
      }
      %$svStatus = &get_snapvault_status($qtree,$fc);
      sleep 30;
      $timeout = $timeout - "30";
   }
   return 1;
}


sub check_match {
   my($output,$regExp) = @_;
   return($output =~ m/$regExp/i);
} 


##--------------------------------------------
##  Procedure to kill a process
##	Parameters:
##		1. Process name
##		2. Primary Connection handler
##-------------------------------------------

sub kill_process {

    my($procName, $pc) = @_;
    my(undef, undef, $output) = say($pc, "ps -ef | grep $procName", -timeout, 3600);
    my @dummy = split("\n", $output);
    my $ele;

    for $ele (@dummy) {
	if($ele =~ m/grep/i) {

		logcomment("ignore Grep");

	} else {	

    	    $ele =~ m/([0-9]+)/;
            $procId = $1;
	    last;

	}
    }

    my(undef, undef, $output) = say($pc, "kill -9 $procId", -timeout, 3600);
    
    if($output =~ /Can\'t|Fail|Error|No/i ) {

	return(0);

    } else {

	return(1);

    }	
} 

##------------------------------------------------------------------------------------------------------
##  Procedure to do a cleanup and logresult
##  This procedure takes a refernce to a boilerplate hash and does a cleanup on the filer and the primary
##  and logs the results
##
##------------------------------------------------------------------------------------------------------

sub cleanup_logresult {
    my($cleanupRef, $resultType, $resultString) = @_;

   logcomment($$cleanupRef{'QTREE'});

    &cleanup($cleanupRef->{'FILER'}, $cleanupRef->{'QTREE'}, $cleanupRef->{'PRIMARY'}, $cleanupRef->{'PRIMARY_PATH'}, 
                  $cleanupRef->{'DATA_SET'}, $cleanupRef->{'RESTORE_PATH'}, $cleanupRef->{'RESTORE_DIR'}, 
                  $cleanupRef->{'FC'}, $cleanupRef->{'PC'});
	
    if( $resultType =~ /^Fail$/i ) {
        logresult($resultType, abort=>1, $resultString);
    } else {
	logresult($resultType, $resultString);
    }
}



##------------------------------------------------------
##  Procedure to check if all ossv processes are running
##------------------------------------------------------


sub check_ossv_services_running {

    my($conn) = $_[0];
    my(undef, undef, $output) = say($conn, 'ps -ef | grep sv', -timeout, 3600);
  
    if( $output !~ m/svpmgr|svcmgr|svlistener/ ) {
       logcomment("Not all processes are running");
       return 0;
    }
    
    return 1;
}

##----------------------------------------------------------------------
## Pause on Fail Function
## Clumsily implemented.A better way to implement this is to use signals
##----------------------------------------------------------------------

sub pause_on_fail {
   
  if(system("touch .PAUSE") != 0) {
     logresult("Warn", "Unable to create .PAUSE file"); 
     return;
  }

  while( -e ".PAUSE") {
    sleep 5;    
  }
  return;
}

1;
_END_
