# $Id: //depot/prod/test/Rsierranevada/dp/ossv/Windows_sanity/cleanup.pm#1 $
##---------------------------------------------------------------------
## This function will clean up all the relations related to specific Q tree at secondary side
## Parameters:
##		1. Secondary Handel
## 		2. Qtree
## This function retuns no value
##Author: rajeshkr@netapp.com
##--------------------------------------------------------------

sub cleanup_secondary {
	my($fc,$qtree)=@_;
	my @relation_list;
	my ($source,$destination,$element);
	my $time=100; # need to change (Get timeout from config file)
	# Going to release the Restore relations on secondary
	my ($match,$before,$after) = say($fc,"snapvault destinations",-timeout,$time);
	shift(@relation_list);   # Removing the heading information( Path and destination)
	@relation_list = split("\n",$after);
	foreach $element (@relation_list) {
		if($element =~ /$qtree/i) {  # checking for Qtree before removing
			logcomment(" The releation is :$element");
                        chmod($element);
                        logcomment(" The releation is after triming :$element"); # need to remove  
                        my ($filer_path,$host_path)=split(/\s+/,$element);
			($match,$before,$after) = say ($fc,"snapvault release '$filer_path' '$host_path'",-swallow,-timeout,$time);
			if($after =~ /no|error|not|failed|Illegal/i) {
				logcomment("There is some problem while deleating the restore relation : $after");
			}
		}
	}
	# Going to stop backup relations on secondary
	#$match=$before=$after=""; # flushing the values
	($match,$before,$after) = say($fc,"snapvault status" ,-swallow,-timeout,$time);
	@relation_list="";
	@relation_list=split("\n",$after);
	shift(@relation_list);
	shift(@relation_list);  #  Removing the heading information
	foreach $element (@relation_list) {
		if ($element =~ /$qtree/i) { # checking for Qtree before removing
			logcomment(" The releation is :$element");
			($source,$destination) = split(/\s+/,$element);
			($match,$before,$after) = say ($fc, "snapvault stop -f '$destination'",-swallow,-timeout,$time);
			if($after =~ /no|error|not|failed|Illegal/i) {
				logcomment("There is some problem while deleating the restore relation : $after");
			}
		}
	}
}


##---------------------------------------------------------------------
## This function will clean up all the relations related to specific Q tree at primary side
## Parameters:
##		1. Primary Handel
## 		2. Qtree
## This function retuns no value
##Author: rajeshkr@netapp.com
##--------------------------------------------------------------
sub cleanup_primary {
	my($pc,$qtree)=@_;
	my @relation_list;
	my ($source,$destination,$element);
	my $time=100; # need to change (Get timeout from config file)
	# Going to release the Backup relations on primary
	my ($match,$before,$after) = say($pc,"snapvault destinations" ,-timeout,$time);
	shift(@relation_list);   # Removing the heading information( Path and destination)
	@relation_list = split("\n",$after);
	foreach $element (@relation_list) {
		if($element =~ /$qtree/i) {  # checking for Qtree before removing
			logcomment(" The releation is :$element");
			chmod($element);
                        my ($bkp_path,$filer_path)=split(/\s+/,$element);
			($match,$before,$after) = say ($pc,"snapvault release '$bkp_path' '$filer_path'",-swallow,-timeout,$time);
			if($after =~ /no|error|not|failed|Illegal/i) {
				logcomment("There is some problem while deleating the restore relation : $after");
			}
		}
	}
	# Going to release  backup relations on primary
	#$match=$before=$after=""; # flushing the values
	($match,$before,$after) = say($pc,"snapvault status" ,-swallow,-timeout,$time);
	@relation_list="";
	@relation_list=split("\n",$after);
	shift(@relation_list);
	shift(@relation_list);  #  Removing the heading information
	foreach $element (@relation_list) {
		if ($element =~ /$qtree/i) { # checking for Qtree before removing
			logcomment(" The releation is :$element");
			($source,$destination) = split(/\s+/,$element);
			my ($host,$path,$os_determination) = split(":",$destination);
                        if (defined($os_determination)){
				logcomment("Given OS type is windows ");
				$path=$path . ":" . $os_determination;
			} 
                        logcomment("after spliting the backup path path is :$path"); 
			($match,$before,$after) = say ($pc, "snapvault release '$path' '$source'",-swallow,-timeout,$time);
			if($after =~ /no|error|not|failed|Illegal/i) {
				logcomment("There is some problem while deleating the restore relation : $after");
			}
		}
	}
}

1;

__END__

