# -*-perl-*-
# $Id: //depot/prod/test/Rsierranevada/dp/ossv/Windows_sanity/utils.pm#1 $

#use Tharn;
use BURTS;
#############################################################
## List database files for the locations
##############################################################

sub run_toolon_primary {

     my($db_location,$fc)= @_;
     $db_location = &set_right_win_path($db_location); 
     my($before,$match,$after) = say($fc,"ls -1t '$db_location' | grep ^[0-9a-z][0-9a-z]\$", -swallow, -timeout,600);
     
     @list_files = split("\n",$after);
   
    logcomment("----------------------->  $list_files[1]: $list_files[2]");
}    



sub get_latest_db_files {

     my($db_location,$fc)= @_;
     $db_location = &set_right_win_path($db_location); 
     my($before,$match,$after) = say($fc,"ls -1t '$db_location' | grep ^[0-9a-z][0-9a-z]\$", -swallow, -timeout,600);
     
     @list_files = split("\n",$after);
   
    logcomment("----------------------->  $list_files[1]: $list_files[2]");
    
     #naveenm changed it to 2 from 1 
     #my($db_file) = $list_files[2]; 
     
      #pjoshi
      my($db_file) = $list_files[1]; 
     

    logcomment("DB File is **********  - $db_file");
     

	chop($db_file);
     if(defined($db_file)) {
	return($db_file);
     } else { 
	return;     
     }
}


##----------------------------------------------------------------
## Lists latest database directories like 00,01,02 
##	Parameters:
##		1. Complete location of the OSSV database (D:\Program Files\netapp\snapvault\db\QsmDatabase\Files\QtreeHistory\0000)
##		2. Connection handle for Primary
##    added by pjoshi: 
##----------------------------------------------------------------

sub get_latest_db_location {

	my($db_location,$fc)= @_;
	my($match,$before,$after) = say($fc,"ls -1t '$db_location' | grep ^[0-9a-z][0-9a-z]\$",-timeout,600);
	
        logcomment("---------------> m:$match b:$before  a:$after");

	@list_dir = split("\n",$after);
    
        logcomment("---------------> $list_dir[0] : $list_dir[1] $list_dir[2] $list_dir[3]");
	my($db_dir) = $list_dir[1]; 
        logcomment("---------------> latest dbdir: $db_dir");
 
	chop($db_dir);
	if(defined($db_dir)) {
		my $db_dirlocation  = "$db_location" ."\\" . "$db_dir" ;
        	logcomment("--------------------> dbdirlocation: $db_dirlocation");
		return($db_dirlocation);
	} else { 
		return;     
	}
}
##############################################################
## This procedure lists all the checkpoints in the database
##############################################################

sub get_latest_chkpt {
 
     my($db_file,$db_location,$fc) = @_;
     my $chkptfile = "$db_file".'-checkpoint*';
     logcomment(" Looking for the Chkptfile -> $chkptfile"); 
     $db_location = &set_right_win_path($db_location);
     my($before,$match,$after) = say($fc,"ls -1t '$db_location' | grep $chkptfile", -swallow, -timeout,300);
     logcomment("*******************************************");
     logcomment("Before - $before");
     logcomment("After- $after");
     logcomment("Match- $match");
     logcomment("*******************************************");
		
     my(@chkpt_list) = split("\n",$after);
 
     logcomment("pjosh------------------------:chkpt_list[0]->@chkpt_list[0]");
     logcomment("pjosh------------------------:chkpt_list[1]->@chkpt_list[1]");
     logcomment("pjosh------------------------:chkpt_list[2]->@chkpt_list[2]");
     
	#my($latest_chkpt) = $chkpt_list[2];
        #pjoshi  
	my($latest_chkpt) = $chkpt_list[1];
    
     logcomment("latest_chkpt -$latest_chkpt");
     

     if(defined($latest_chkpt)) {
	return($latest_chkpt);
     } else {
	return;
     }
}

#################################################################
## This procedure checks if a checksum file exists or not
#################################################################  

sub check_file_exists {

     my($cksumfile,$db_location,$pc) = @_;

     my($match,$before,$after) = say($pc,"ls -1a '$db_location'",-ok,-timeout,600);

        if( $after =~ /$cksumfile/) {
                return(1);
        } else {
                return(0);
        }
}

##################################################################
## This procedure gets the status of a qtree by executing the 
## "snapvault status -l" command.It returns an associative array.
##################################################################

sub get_snapvault_status {

	my($qtree,$fc) = @_;
	my($before,$match,$output) = say($fc,"snapvault status -l $qtree","ON");

	my(@contents) = split("\n",$output);
	shift(@contents);
	foreach $ele (@contents) {
   	$ele =~ m/:/;
   	$field = $`;
		$value = $';
      $value =~ s/^\s+//;
      $value =~ s/\s+$//;
		$field =~ s/^\s+//;
		$field =~ s/\s+$//;
		$ret_val{$field} = $value;
	}

	return(%ret_val);
   
}

###################################################################
## Wait for the transfer to complete
###################################################################

sub wait_for_transfer_finish {
    my($svStatus,$timeout,$qtree,$fc) = @_;

        if(defined($timeout)) {
                logcomment("Transfer timeout is $timeout");
        } else {
                logcomment("Timeout not defined.Setting to 3600");
                $timeout = "3600";
        }

        %$svStatus = &get_snapvault_status($qtree,$fc);

        while($$svStatus{'Status'} =~ m/Transferring|Quiescing/i)
        {
                if($timeout == 0 || $$svStatus{'Current Transfer Error'} ne "-") {
                        logcomment("Transfer Timedout:$$svStatus{'Current Transfer Error'}");
                        return 0;
                }
                %$svStatus = &get_snapvault_status($qtree,$fc);
                sleep 5;
                $timeout = $timeout - "5";
        }

        if($$svStatus{'Current Transfer Error'} ne "-")
        {
          logcomment("Transfer failed. The current transfer error is $$svStatus{'Current Transfer Error'}");
          return 0;
        }
        return 1;

}
     
###################################
## 
## Set the config parameters
##
################################### 

sub svconfig {

   my($util,$config_file,$parameter,$value,$fc) = @_;

   if($parameter =~ '^BLI$')
   {
   say($fc,"'$util/svsetstanza' 'config' $config_file Configuration 'Checksums' VALUE $value FALSE");
   logcomment("BLI set to $value");
   }
   elsif
   ($parameter =~ '^ACCESS$')
   {
   say($fc,"'$util/svsetstanza' 'config' $config_file QSM 'Check Access List' VALUE $value FALSE");
   logcomment("Access check set to $value");
   }
   elsif
   ($parameter =~ '^RESYNC$')
   {
   say($fc,"'$util/svsetstanza' 'config' $config_file QSM 'Enable Restart' VALUE $value FALSE");
   logcomment("Resync flag set to $value");
   }
   elsif
   ($parameter =~ '^DB$')
   {
   say($fc,"'$util/svsetstanza' 'config' $config_file QSM 'Backup Database' VALUE $value FALSE");
   logcomment("DB backup set to $value");
   }
   elsif
   ($parameter =~ '^ACCESSLIST_VALUE$')
   {
    say($fc,"'$util/svsetstanza' 'config' $config_file QSM 'Access List' VALUE '$value' FALSE");
   logcomment("Access List set to $value");
   }
   elsif
   ($parameter =~ '^RESYNC_VERSION$')
   {
    say($fc,"'$util/svsetstanza' 'config' $config_file QSM  'Resync Version' VALUE '$value' FALSE");
    logcomment("Resync version set to $value");
   }
   elsif
   ($parameter =~ '^NDMP_PORT$')
   {
    say($fc,"'$util/svsetstanza' 'config' $config_file NDMP  'Listen Port' VALUE '$value' FALSE");
    logcomment("NDMP port set to $value");
   }
    elsif
   ($parameter =~ '^NDMP_HOSTID$')
   {
    say($fc,"'$util/svsetstanza' 'config' $config_file NDMP  'Host Id' VALUE '$value' FALSE");
    logcomment("NDMP Id set to $value");
   }
   elsif($parameter =~ /^ROOT_INODE$/) {
    say($fc,"'$util/svsetstanza' 'config' $config_file QSM  'FixRootInodeChanges' VALUE '$value' FALSE");
    logcomment("FixRootInode flag set to $value");
   }

}


####################################################
## This procedure releases the relation on primary
####################################################

sub release_rel_pri{
   my($primary,$filer,$qtree,$primary_path,$ossv_loc,$pc) = @_;
   say($pc,"'$ossv_loc//snapvault' release '$primary_path' $filer:$qtree");

} 

###################################################
## This procedure deletes the DB file
################################################### 

sub deldbfile {
   my($db_file,$db_loc,$type,$pc) = @_;
   
   my $cksum_file = "$db_file".-checksums;   
   if($type =~ 'DB only')
   { 
    say($pc,"rm '$db_loc\\$db_file'");
   }
   elsif ($type =~ 'BLI')
   {
    say($pc,"rm '$db_loc\\$db_file'");
    say($pc,"rm '$db_loc\\$cksum_file'");
   }
}         

#####################################################
## This procedure is used to break a relation
#####################################################

sub break_relation {
   my($qtree,$fc) = @_;

   say($fc,"options snapvault.enable off");
   say($fc,"snapmirror off");
   say($fc,"priv set diag; snapmirror convert $qtree");
   say($fc,"snapmirror on");
   say($fc,"snapmirror quiesce $qtree");
   say($fc,"snapmirror break $qtree");
   say($fc,"options snapvault.enable on");
} 

########################################################
## this procedure is used to create a snapvault schedule
########################################################

sub create_sv_sched {
    my($vol,$snapname,$sched,$fc) = @_;
    say($fc,"snapvault snap sched $vol $snapname $sched");

}

########################################################
## This procedure is used to create a snapshot
########################################################

sub create_snapshot {
    my($vol,$snapname,$fc) = @_;
    my $match = say($fc,"snapvault snap create -w $vol $snapname","Snapshot creation successful",-fail,"Snapshot creation failed",-timeout,600); 

} 



## ----------------
## Added by naveenm
## ----------------


## ----------------------
## Set right Windows Path
## ----------------------

sub set_right_win_path($) {

   my $path = $_[0];
   $path =~ s/\\/\\\\/g;
   return($path);
}


1;

__END__
