# -*- perl -*-
# $Id: //depot/prod/test/main/dp/snapdiff/zapi/lib/CommonParams.pm#1 $

##
## @synopsis 
##   Perl module that contains the common params for SnapDiff tests
##

package dp::snapdiff::zapi::lib::CommonParams;

use strict;
use warnings;
use NACL::STask::Node;

package main;

use vars qw(
    $AGGR_NAME
    $BASE_SNAPSHOT
    $CLEANUP
    $CLIENT
    $DBG
    $DIFF_SNAPSHOT
    $NIS_DOMAIN
    $NODES
    $PASSWORD
    $REPOSITORY
    $SETUP_DONE
    $USERNAME
    $USE_ZAPI
    $USE_DATA_LIF
    $USE_DATA_LIF_IP
    $SUDO_PATH
    $USE_DIFFSNAPSHOT_ONLY
    $VOL_SIZE
    $VOLUME
    $VSERVER
    $CIFS_SETUP
    $DATASET_DIR
    $DATASET_DIR_WINDOWS
    $DATASET_COPY_TIMEOUT
    $DATASET_CIFS_USER
    $DATASET_CIFS_PASSWORD
    $AD_SERVER_IP
    $AD_SERVER_USER
    $AD_SERVER_PASSWORD
    $CIFS_DOMAIN
    $CIFS_DOMAIN_LONG
    $CIFS_SUPERUSERS
    $CIFS_USER
    $CIFS_PASSWD
    $PRINT_XML_OUTPUT
    $SNAPDIFF_VERIFY
    $FILE_ACCESS_PROTOCOL
    $SITE_FILE
    $CLUSTERED_ONTAP
    $IPV
    );

package dp::snapdiff::zapi::lib::CommonParams;

use Tharn;

# Local variables
my $Node;

param('NODES','-default','');
param('NIS_DOMAIN','-default','netapp.com');
param('NIS_SERVERS','-default','10.56.32.32,10.56.32.33,10.60.132.113');
param('CIFS_SETUP','-default',0);
param('CIFS_DOMAIN','-default','rtplab');
param('CIFS_DOMAIN_LONG','-default','rtp.netapp.com');
param('AD_SERVER_IP','-default','10.60.248.235,10.60.248.236');
param('AD_SERVER_USER','-default','labclient');
param('AD_SERVER_PASSWORD','-default','sundance');
param('CIFS_SUPERUSERS','-default','labclient');
param('CIFS_USER','-default','labclient');
param('CIFS_PASSWD','-default','sundance');
param('CLUSTERED_ONTAP','-default','1');
param('DATASET_DIR', '-default', 
        "/x/eng/rtp-testbeds/dpg/snapdiff/dataset/bots");
param('DATASET_DIR_WINDOWS','-default', 
        "\\svlinf03.eng.netapp.com\\snapdiff\\bots\\cifs");
param('DATASET_COPY_TIMEOUT', '-default', 7200);
param('DATASET_CIFS_USER', '-default', "rtplab\\labclient");
param('DATASET_CIFS_PASSWORD', '-default', 'sundance');
param('IPV','-default','ipv4');
param('VOLUME','-default', '');
param('VSERVER','-default', 'vs0');
param('REPOSITORY','-default',0);
param('AGGR_NAME','-default','aggr_sdtest');
param('VOL_SIZE','-default','1g');
param('CLIENT','-default','localhost');
param('USERNAME','-default','');
param('PASSWORD','-default','');
param('BASE_SNAPSHOT','-default','');
param('DIFF_SNAPSHOT','-default','');
param('SETUP_DONE','-default','reuse');
param('CLEANUP','-default','0');
param('USE_ZAPI','-default','0');
param('USE_DATA_LIF','-default','0');
param('USE_DIFFSNAPSHOT_ONLY','-default','0');
param('DBG','-default','');
param('ENABLE_SNAPDIFF','-default','true');
param('USE_DATA_LIF_IP','-default','');
param('FILE_ACCESS_PROTOCOL','-default','nfs');
param('SNAPDIFF_VERIFY','-default','1');
param('SITE_FILE','-default',"TestUtils/site_info.dat");

1;

