
ROUTINE get_lif_info
   <CODE>
        my %opt  = validate( @_,
                             {
                                 nodes       => { type  => ARRAYREF },
                                 type        => { type  => SCALAR,
                                                  default => "data",
                                                  regex => qr/^(mgmt|data|intercluster|cluster|cluster_mgmt)$/ },
                                 verbose     => { type  => SCALAR, default => 0 },
                             }
                   );

        my @nodes  = @{$opt{nodes}};
        my $type   = $opt{type};
        my @return;

        my $type = "_".$type."_";

        my %lif_data;

        my @suffixes = qw( node name ip mask gateway port mtu );
        foreach my $node ( @nodes ) {
            foreach my $suffix (@suffixes) {
                my $key = $type.$suffix."_";
                if ( exists $node->{$key} ) {
                    if ( exists $lif_data{$suffix} ) {
                        push( @{$lif_data{$suffix}}, @{$node->{$key}} );
                    } else {
                        $lif_data{$suffix} = [ @{$node->{$key}} ];
                    }
                }
            }
        }

        my $len = scalar(@{$lif_data{name}});
        my $index = 0;
        my %lif;
        while ( $index < $len ) {
            foreach my $suffix (@suffixes) {
                my $key = $suffix;
                if ( $suffix eq "ip" ) {
                    $key = "address";
                } elsif ( $suffix eq "name" ) {
                    $key = "lif";
                }
                $lif{$key} = $lif_data{$suffix}->[$index];
            }
            push( @return, {%lif} );
            %lif = ();
            $index++;
        }

        if ( $opt{verbose} ) {
            print "get_lif_info = ".Dumper(\@return)."\n";
        }

        return @return;
    </CODE>;

