# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/CConfig/TEST/ListIterActionFixture.pm#1 $

## @summary ListIterActionFixture 
## @author kenneth.gates@netapp.com
## @cf     false
## @status public
## @pod here

=head1 NAME

ListIterActionFixture - FIT Fixture

=head1 SYNOPSIS

  use CConfig::TEST::ListIterActionFixture

=head1 DESCRIPTION

FIT Adapter

=cut

# --------------------------------------------------------
# Class: CConfig::TEST::ListIterActionFixture
#   FIT Adapter
# --------------------------------------------------------

package CConfig::TEST::ListIterActionFixture;

use Data::Dumper;
use NCPAN::Test::C2FIT;
use NCPAN::Test::C2FIT::GenericArrayAdapter;
use NCPAN::Test::Error qw( :try );
use HTML::Entities;
use base 'NCPAN::Test::C2FIT::ActionFixture';
use strict;

our $LI;

sub new {
    my $pkg = shift;
    # methodSetterTypeMap - argument conversion
    # methodColumnTypeMap -  
    bless $pkg->SUPER::new( 
        methodSetterTypeMap => { 
            'advance'  => 'CConfig::TEST::EvalAdapter',
            'get_next' => 'CConfig::TEST::EvalAdapter' 
        },
        fieldColumnTypeMap => { 
            'get_next' => 'NCPAN::Test::C2FIT::GenericArrayAdapter' 
        } 
    ),$pkg;
}

sub do_start {
    my $self = shift;

    my $pkg  = $self->{'cells'}->more()->text();
    my $args  = decode_entities($self->{'cells'}->more()->more()->text());

    my $perlPackageName = $self->_java2PerlFixtureName($pkg);

    $LI = eval "$perlPackageName->new($args)";
    if ($@) {
        # ok so try "using" the package first
        eval "use $perlPackageName;";
        if ($@) { throw NCPAN::Test::C2FIT::Exception( "$perlPackageName - not found"); }
        $LI = eval "$perlPackageName->new($args)";
        if ($@) { throw NCPAN::Test::C2FIT::Exception( "$perlPackageName - instantiation error: $@"); }
    }

    $NCPAN::Test::C2FIT::ActionFixture::actor=$LI;
}

#sub do_get_next { 
#    my $self = shift;
#    my $args  = decode_entities($self->{'cells'}->more()->text());
#    print "get_next: args=$args\n";
#    eval "\$LI->get_next($args)";
#    if ($@) { throw NCPAN::Test::C2FIT::Exception( "get_next failed with: $@"); }
#
#
#    my $method = $self->method();
#    print "method=$method\n";
#    my $adapter = NCPAN::Test::C2FIT::TypeAdapter->onMethod( $LI, $method() );
#    print "adapter=$adapter\n";
#    my $expected=decode_entities($self->{'cells'}->more()->more());
#    print "expected=$expected\n";
#    $self->check( $expected, $adapter );
#}
#
#sub do_advance  { 
#    my $self = shift;
#    my $args  = decode_entities($self->{'cells'}->more()->text());
#    print "advance: args=$args\n";
#    eval "\$LI->advance($args)";
#    if ($@) { throw NCPAN::Test::C2FIT::Exception( "advance failed with: $@"); }
#}

# this is like do_enter combined with check
sub do_call {
    my $self = shift;

    throw NCPAN::Test::C2FIT::Exception("no actor") unless defined($NCPAN::Test::C2FIT::ActionFixture::actor);

    my $method      = $self->method();
    my $args        = decode_entities($self->{'cells'}->more()->more()->text());
    my $typeAdapter = NCPAN::Test::C2FIT::TypeAdapter->onSetter( $self, $method );
    my $res         = $NCPAN::Test::C2FIT::ActionFixture::actor->$method( $typeAdapter->parse($args) );

    $self->{$method}=$res;

    # this is the do_check part
    #   fields have the same name as the method, onField will create an adapter that retrieves the field from $self
    #   if exepected test is undefined or null then check will just place the value of the field into the output table
    #       TODO: we need a way to check for NULL, need a way to put NULL in the field and have the adapter handle that
    my $adapter = NCPAN::Test::C2FIT::TypeAdapter->onField( $self, $method );
    $self->check( $self->{'cells'}->more()->more()->more(), $adapter );
}

1;
