# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/CConfig/TEST/ServerActionFixture.pm#1 $

## @summary ServerActionFixture 
## @author kenneth.gates@netapp.com
## @cf     false
## @status public
## @pod here

=head1 NAME

ServerActionFixture - Fit Fixture

=head1 SYNOPSIS

  use CConfig::TEST::ServerActionFixture

=head1 DESCRIPTION

FIT Fixture

=cut

# --------------------------------------------------------
# Class: CConfig::TEST::ServerActionFixture 
#   FIT Fixture
# --------------------------------------------------------

package CConfig::TEST::ServerActionFixture;

use Data::Dumper;
use NCPAN::Test::C2FIT;
use NCPAN::Test::C2FIT::GenericArrayAdapter;
use NCPAN::Test::Error qw( :try );
use base 'NCPAN::Test::C2FIT::ActionFixture';
use strict;

our @RESULT;

sub new {
    my $pkg = shift;
    bless $pkg->SUPER::new( 
        methodSetterTypeMap => { 
            'server'  => 'CConfig::TEST::EvalAdapter',
        },
        fieldColumnTypeMap => { 
            'server' => 'CConfig::TEST::HashArrayAdapter' 
        } 
    ),$pkg;
}

sub do_send {
    my $self = shift;
    $DB::single=1;

    throw NCPAN::Test::C2FIT::Exception("no actor") unless defined($NCPAN::Test::C2FIT::ActionFixture::actor);

    # this is the do_enter part
    my $method = $self->camel( $self->{'cells'}->more()->text() );
    my $args        = $self->{'cells'}->more()->more()->text();
    my $typeAdapter = NCPAN::Test::C2FIT::TypeAdapter->onSetter( $self, "server" );
    my $res         = $NCPAN::Test::C2FIT::ActionFixture::actor->$method( $typeAdapter->parse($args) );

    $self->{"server"}=$res;

    my $adapter = NCPAN::Test::C2FIT::TypeAdapter->onField( $self, "server" );
    $self->check( $self->{'cells'}->more()->more()->more(), $adapter );
}

1;
