#!/bin/bash

PROC_NAME='fps_server'
ARCHIVER_NAME='archive.sh'
LOG_FILE='deadbeef'
KILL_FILE='deadbeef'
IFCONFIG='/sbin/ifconfig'

IP=$( $IFCONFIG eth0 | grep inet\ addr | cut -d\: -f 2 | cut -d\  -f 1 )

PORT=$1
RESPONSE=$2
AUTH=$3
MODE=$4
DELAY=$5

if [ $# -ne 5 ]; then
    echo "USAGE: $0   <port>   <response- 1 Allow,2 Deny>   <AUTH - 1 Enabled 0,Disabled>   <Mode - 0 SYNC,1 ASYNC> <DELAY>"
    exit
fi

LOG_FILE=$PWD/'log_Fpolicy_server.'$PORT
KILL_FILE=$PWD/'killme.'$PORT'.sh'

echo "port:         $PORT"
echo "vserver:      $VSERVER"
echo "logfile:      $LOG_FILE" 
echo "snuff-file:   $KILL_FILE" 

prog_pid=$( ps ax | grep fps_server | grep $PORT | grep -v grep | awk -F\  '{ print $1 }' )
if [[ $prog_pid ]]; then
    echo "killing existing process: $prog_pid"
    if [[ $( kill -9 $prog_pid 2>&1 3>&1 | grep -v Killed ) ]]; then
        echo "failed to kill existing process. aborting..."
        exit
    fi
fi

echo "" > $LOG_FILE

echo "current directory: $PWD"

$PWD/$PROC_NAME  -p "$PORT" -l "$IP" -r "$RESPONSE" -C "DES-CBC-SHA" -A "$AUTH"  -V 4  -M "$MODE" -F "$LOG_FILE" -D "$DELAY" -P "testpolicy" 2>/dev/null 3>/dev/null 1>/dev/null  &

sleep 2;
chmod 777 $LOG_FILE


# archiver_pid=$( pgrep $ARCHIVER_NAME )
# if [[ ! $archiver_pid ]]; then
#     echo "running archiver..."
#     $PWD/$ARCHIVER_NAME $LOG_FILE 2>/dev/null 3>/dev/null 1>/dev/null &
# fi

prog_pid=$( ps ax | grep fps_server | grep $PORT | grep -v grep | awk -F\  '{ print $1 }' )

# archiver_pid=$( pgrep $ARCHIVER_NAME | head -n 1 )
# echo "program restarted. New pid : $prog_pid "
# echo "archiver pid: $archiver_pid " 
# echo "kill commands ~~~~~~~~~~~~@@@@@@@@@: kill -9 $prog_pid $archiver_pid"
# echo "kill -9 $prog_pid $archiver_pid" > $KILL_FILE
# chmod +x $KILL_FILE

echo "kill commands ~~~~~~~~~~~~@@@@@@@@@: kill -9 $prog_pid"
echo "kill -9 $prog_pid" > $KILL_FILE
chmod +x $KILL_FILE

