#new parser

package CIFS::FPolicy::Excelparse;

use Spreadsheet::ParseExcel;
use Data::Dumper;
use NACL::APISet;
use NACL::APISet::Exceptions::ResponseException qw(:try);
use TCD;
use Tharn;
use Burt;
use strict; 
use NACL::MTask::PacketCapture;
use NACL::C::Client;

 
my $Html_Begin = "<html>\n<head>\n<title>Report</title>\n<script language=\"JavaScript\" type=\"text/JavaScript\">\n</script></head><body onload=dateDisp();> <p align=\"center\">TEST_REPORT</p>";
my $Html_End = "\n</body>\n<script>\n function dateDisp()\n{\n}\n</script>\n</html>";
#my $Html_Tbl_Start = "\n<table border=\"1\" align=\"center\" width=\"65%\" cellpadding=\"1\" cellspacing=\"0\" >";
my $Html_Tbl_Start = "\n<table border=\"1\" align=\"center\" width=\"65%\" cellpadding=\"1\" cellspacing=\"0\" >";
my $Html_Tbl_End = "\n</table>";
my $Html_paraspace = "\n<p>&nbsp;</p>";

my $Html_GrpStart = "\n<tr><td align=\"center\" colspan=\"4\" bgcolor=#3366FF>";
my $Html_GrpEnd = "</td></tr>";

my $Html_TcStart_Pass = "<tr bgcolor=\"green\">";
my $Html_TcStart_Fail = "<tr bgcolor=#B00000 >";
my $Html_TcEnd = "</tr>";
my $index = 1;
 
my %g_cleanup;
my %g_clients;
my $g_passCnt = 0;
my $g_failCnt = 0;
my $pass_flag = 0;
my %TcsetHash; 
my %zapiMap;
my $continue_flag = 0;
my $delayflag = 0;
my $vserver_value;
my $g_self;
my $g_excel_workbook;
my $g_pkt = 0;
my @Client_pkkt;
my $PacketCapture;

 
 sub new {
     my($class) = shift;        # Class name is in the first parameter
	 my %replhash = @_;
     my $self = {%replhash};  # Anonymous hash reference holds instance attributes

     bless($self, $class);          # Say: $self is a $class
     return $self;
 }

 sub clean{
	my($class) = shift;  
	
	%g_cleanup = ();
	%g_clients = ();
	%TcsetHash = (); 
 }
 
sub ExecuteTest(){
	my $self               = shift;
    my $excel_workbook = shift;
    my $Api_Set_Obj    = shift;
	my @tcinc_arr ;
	my @tcexc_arr ;
	my $exec_flag = 1;
	my $Packetcapture ;
	my $dirname;
	
	$g_self = $self;
	$g_excel_workbook = $excel_workbook;
	 
	if(exists($self->{'Test-include'})){
		@tcinc_arr = @{$self->{'Test-include'}};
		delete($self->{'Test-include'});
	}	
	
	if(exists($self->{'Test-exclude'})){
		@tcexc_arr = @{$self->{'Test-exclude'}};
		delete($self->{'Test-exclude'});
	}
	
	_executeSceTest($self,$excel_workbook); 
	
	if(exists($self->{'systemnode'})){
		&_xprint("\r\n###### PACKET TRACE IS ENABLED########");
		$g_pkt=1;
		
	}	
	# by default execute all the testcases.
	
	my %inc_hash;
	if(@tcinc_arr != 0){
		for(my $i = 0;$i < @tcinc_arr;$i++){
			$inc_hash{trim($tcinc_arr[$i])} = $i;			
		}
	}
	
	my %exc_hash;
	if(@tcexc_arr != 0){
		for(my $i = 0;$i < @tcexc_arr;$i++){
			$exc_hash{trim($tcexc_arr[$i])} = $i;			
		}
	}	
	
	my $testcasename;
	my @lenarr = %TcsetHash;
	my $len = @lenarr;
	$len=($len/2);
	
	##added for TC name 
	foreach my $k(1..$len){
		_xprinttoLog("\r\n");
		_xprinttoLog($TcsetHash{$k}->{'TestCase-Name'});
	}
	
	foreach my $k(1..$len){
		$exec_flag = 1;
		$testcasename = trim($TcsetHash{$k}->{'TestCase-Name'}); 
		if(@tcinc_arr != 0){
			if(exists($inc_hash{$testcasename})){
				$exec_flag = 1;
			}else{
				$exec_flag = 0;
			}		
		}
		
		if(@tcexc_arr != 0){
			if(exists($exc_hash{$testcasename})){
				$exec_flag = 0;
			}	
		}
		
		if($exec_flag == 1){
			_xprinttoLog("\r\n $testcasename");
			
			if($g_pkt){
				$dirname = $self->{'parserLogPath'}."/$testcasename";
				_xprinttoLog("\r\n LOG PATH : $dirname");
				 mkdir $dirname;
				 _start_pkkt($self->{'systemnode'}); 
			}
			
			_batch_execute($self,$Api_Set_Obj,$TcsetHash{$k});
			
			_stop_pkkt($dirname) if($g_pkt);
		}
	}
	
	
	
	 &_closereport();
}


sub _start_pkkt{
    my $Node = shift;

    my @arg      = ( { target_machine => $Node })	;
	
	# foreach(@Client_pkkt){
		# my $temp = { target_machine => $_ };
		# push @arg,$temp;
	# }
	
	#_xprint(Dumper(\@arg);
	
	try {	
		$PacketCapture
			= NACL::MTask::PacketCapture->new(packet_capture_details => \@arg);
		_xprint("\r\nStarting Packet trace");
		$PacketCapture->start();
		}otherwise{
			 my $e = shift;
			_xprint($e->text());
		};

}

sub _print_packet_trace {
    _xprint("Printing packet trace");
   # _xprint($PacketCapture->show());
}



sub _stop_pkkt{
	my $logdir   = shift;

	_xprint("\r\nStopping Packet trace");
    $PacketCapture->stop();
  
    _xprint("\r\nCopying Packet trace");
    try {
		if($logdir){
			_xprint("\r\n Directory provided is $logdir");
			$PacketCapture->get(path => $logdir);
		}else{
			$PacketCapture->get();
		}
    }
    catch NATE::BaseException with {
        my $e = shift;
        _xprint("Unable to copy packet trace "
                . "(No write permission?):\n"
                . $e->text());

        _print_packet_trace();
    };
   
    $PacketCapture->cleanup();
}




sub _executeSceTest() { 
	my $self = shift;
    my $excel_workbook = shift;
    my %replacehash;
    my $retval;
	my $parser   = Spreadsheet::ParseExcel->new();
	my $workbook = $parser->parse($excel_workbook);
	#my $workbook = $parser->parse('excelParse.xls');

	if ( !defined $workbook ) {
		die $parser->error(), ".\n";
	}
	&_generate_cleanup_tbl($workbook);
	$retval = &_generate_Client_tbl($self,$workbook);
        if($retval == 1){
		_xprint("\r\nThe client creation is failed");	
		return 0;	
	}
	
	if($self->{'execType'} eq "ZAPI"){
		_generateZAPICLIMap($workbook);
	}
	
	&openreport($self->{'parserLogPath'});
	
	my $worksheet = $workbook->worksheet('Scenario');
	if ( !defined $workbook ) {
		die "\r\n excel sheet Scenario does not exist", ".\n";
	}

	%replacehash = %{$self};
	delete($replacehash{'execType'});
	delete($replacehash{'parserLogPath'});
	
	_xprinttoLog("\r\n REPLACEMENT HASH \r\n");
	_xprinttoLog(Dumper(\%replacehash));
	
	
	my ( $row_min, $row_max ) = $worksheet->row_range();
	my ( $col_min, $col_max ) = $worksheet->col_range();
    
        print "ROW RANGE $row_min and  $row_max";
        print "\r\n COULMN RANGE $col_min and $col_max";
	
	my ($Apiname,$header_flag,$counter,$cnt);
	$header_flag = 1;
	$counter = 0;
	$cnt = 0;
    OUTER: for my $row ( $row_min .. $row_max ) {
	INNER:	for my $col ($col_min .. $col_max){
				
				my $cell = $worksheet->get_cell( $row, $col);	
				if(1 == $header_flag){
					next OUTER unless ($cell && $cell->value());
					$TcsetHash{++$cnt}->{'TestCase-Name'} = $cell->value();
					_xprinttoLog("\r\n".$cell->value());
					$header_flag++;
					$counter = 0;
					next OUTER;
				 }
				 
				if($col == $col_min){
					if ($cell && $cell->value()){
						$TcsetHash{$cnt}->{$counter}->{'Test-Desc'} = &trim($cell->value());
					}else{
						$TcsetHash{$cnt}->{'rec-count'} = $counter;
						$header_flag =1;
					}
				}elsif($col == ($col_min+1)){
					if ($cell && $cell->value()){
						$TcsetHash{$cnt}->{$counter}->{'API-Name'} = &trim($cell->value());
					}
				}elsif($cell && $cell->value()){
					my $value = $cell->value();
					if($value =~ /expected/i){
						my @arr = split(",",$value);
						my @arr1 = split("=>",$arr[0],2);
						shift(@arr);
						my $string = $arr1[1]; 
						unshift @arr,$string;
						$string = join(",",@arr);
						foreach my $k(keys(%replacehash)){
							$k = trim($k);
							_xprinttoLog("\r\n REPLACEMENT KEY :$k");
							_xprinttoLog("\r\n STRING:".$string);
							if($string =~ /$k/){
									$string =~ s/$k/$replacehash{$k}/g;								
							}							
						} 
						
						$TcsetHash{$cnt}->{$counter}->{'expected'} = $string;
					}else{
											
						my @valueArr = split("=>",$cell->value(),2);
						
						foreach my $k(keys(%replacehash)){
							 $k = trim($k);
							 _xprinttoLog("\r\n REPLACEMENT KEY :$k");
                                                        _xprinttoLog("\r\n STRING:".$valueArr[1]);

							if($valueArr[1] =~ /$k/){
								$valueArr[1] =~ s/$k/$replacehash{$k}/g;
								#last;	
							}
						}
						
						$TcsetHash{$cnt}->{$counter}->{&trim($valueArr[0])} = &trim($valueArr[1]);
					}
					if($col == $col_max){
							$counter++;
							next OUTER;
					}
				}else{
					$counter++;
					next OUTER;
				}
			}
		}
		_xprinttoLog("\r\n----------TESTCASE SET-------------\r\n");
		$TcsetHash{$cnt}->{'rec-count'} = $counter;
		#&_batch_execute($Api_Set_Obj,%Tchash);
		_xprinttoLog(Dumper(\%TcsetHash));
		
}



sub _batch_execute{
	my $self = shift;
	my $Api_Set_Obj = shift;
	my $reftcset = shift;
	my $tc_name = $reftcset->{'TestCase-Name'};
	my $rec_cnt = $reftcset->{'rec-count'};
	my $cnt = 0;
	my $retval;
	
	
	$pass_flag = 0;
	$continue_flag = 0;

	## write for the group header in the report file
	&_xprint("\r\n\n################################## TESTCASE :$tc_name ################################## \r\n"); 
	&_write_grp($tc_name);
	foreach my $num(0..($rec_cnt-1))
	{		
		$cnt = $num;
		if($self->{'execType'} eq "ZAPI"){
			$retval = _single_executeZapi($Api_Set_Obj,$reftcset->{$num});
		}else{
			$retval = &_single_execute($Api_Set_Obj,$reftcset->{$num});			
		}
		last if($retval eq "fail");
	}
		
	_cleanup($self,$Api_Set_Obj,$cnt,$reftcset);
	
	if($tc_name !~ /CLEANUP|SETUP/i){
		if ($pass_flag == 0){
			$g_passCnt++;
			logresult("PASS", "Test case $tc_name");
		}else{
			$g_failCnt++;
			logresult("FAIL", "Test case $tc_name");
		}
	}
}


sub _single_execute{
	my $Api_Set_Obj = shift;
	my $hashRef = shift;
	my %input_para = %$hashRef;
	my @client_cmd;
	my $response;
	my $exception_string;
	my $job_wait = 0;
	
	#check if continue on error flag is set in the testcase set.
	if($continue_flag == 0){
		$continue_flag = 1 if(exists($input_para{'ContinueOnError'}));
	}
	
	if(exists($input_para{'job_watch_progress'})){
		$job_wait=1;
		delete $input_para{'job_watch_progress'};
	}
	
	
	foreach my $k(keys(%input_para)){
		 delete $input_para{$k} if( $k =~/Test-Desc/i || $k =~ /cleanup/i || $k =~ /API-Name/i || $k =~ /expected/i || $k =~ /ContinueOnError/i);
	}

	my $cli_cmd = $hashRef->{'API-Name'};
	my $Test_desc = $hashRef->{'Test-Desc'};
	&_xprint("\r\n\n[Parser_Tool_log]################### TEST ITEM DESCRIPTION :$Test_desc \r\n"); 
	&_xprint("\r\n[Parser_Tool_log] COMMAND NAME:$cli_cmd"); 
	my $expected_Out = $hashRef->{'expected'};
	&_xprint("\r\n[Parser_Tool_log] INPUT PARA:");	
	&_xprint(Dumper(\%input_para));
	&_xprint("\r\n[Parser_Tool_log] EXPECTED : $expected_Out \r\n");
	
	
	my @expec = split(",\n",$expected_Out);
		try {
			#&_xprint("\r\n----> ACTUAL RESULT :\r\n");
			if($cli_cmd =~ /-/){
				#sleep(8);
				@client_cmd = split("-",$cli_cmd);
				my $cmd = $client_cmd[1];
				if($cli_cmd =~ /execute_raw_command/ && defined($client_cmd[2])){
					$input_para{'additional_prompts'} = [$client_cmd[2]];
				}
				if($delayflag == 0){
					sleep(8);
				}
				
				$delayflag = 1;	
				$response = $g_clients{trim($client_cmd[0])}->$cmd(%input_para);
			}elsif($cli_cmd =~ /^sleep$/i) {
                                my $time = $input_para{'time'};
                                 &_xprint("\r\n[Parser_Tool_log]SLEEP TIME  : $time \r\n");
                                sleep($time);
                        }elsif($cli_cmd =~ /resetclient/i) {
					my $parser   = Spreadsheet::ParseExcel->new();
					my $workbook = $parser->parse($g_excel_workbook);
					_generate_Client_tbl($g_self,$workbook);
			}else{
				$delayflag = 0;
				$response = $Api_Set_Obj->$cli_cmd(%input_para);
				if($job_wait == 1){
					my $jobid = $response->get_job_ids();
					_job_watch($Api_Set_Obj,$jobid);
				}
			}
			
			_xprint("\r\n[Parser_Tool_log] response or parsed output :");
			if($cli_cmd =~ /execute_raw_command/){
				&_xprint(Dumper($response));
			}
			
			if($expec[0] =~ /Error/i){
				## testcase fail;
				&_write_test($Test_desc,$cli_cmd,"FAILED","Expected Error but the operation succeded");
				$pass_flag = 1;
				#return "fail";
				($continue_flag == 1)? return "success": return "fail";
			}else{
				## testcase pass
				if((@expec == 1) ||(@expec == 0)){
					my $len = length($response);
					#&_xprint("Length is ".$len);
					if(($cli_cmd =~ /-/) && ($cli_cmd =~ /execute_raw_command/) && (@expec == 1) && ($len > 2)){
						&_xprint("Length is ".$len);
						&_write_test($Test_desc,$cli_cmd,"FAILED","The raw command returned: $response");	
					}else{
						&_write_test($Test_desc,$cli_cmd,"PASSED");
					}
					return "success";
				}else{
					shift(@expec);
					my $result;
					if(($cli_cmd =~ /-/) && ($cli_cmd =~ /execute_raw_command/)){
						$result = _execraw_search($response,@expec);
					
						# # # # # # # # # # # # # # # my @exe_response = split("=>",&trim($expec[0]),2);
						# # # # # # # # # # # # # # # _xprint("\r\n[Parser_Tool_log] $exe_response[1] \r\n");
						# # # # # # # # # # # # # # # _xprint("\r\n[Parser_Tool_log] $response \r\n");
						# # # # # # # # # # # # # # # my $result_expec = &trim($exe_response[1]);
						# # # # # # # # # # # # # # # if($response =~ /$result_expec/){
							# # # # # # # # # # # # # # # $result = 1;
						# # # # # # # # # # # # # # # }else{
							# # # # # # # # # # # # # # # $result = 0;
						# # # # # # # # # # # # # # # }
						
					}else{
						if($cli_cmd =~ /execute_raw_command/){
							$result = _execraw_search($response,@expec);
							# # # # # # # # # # # # # # # my @cli_exec = split("=>",&trim($expec[0]));
							# # # # # # # # # # # # # # # _xprint("\r\n[Parser_Tool_log] FILER Execuate raw_command:Expected:  $cli_exec[1] \r\n");
							# # # # # # # # # # # # # # # _xprint("\r\n[Parser_Tool_log] RESPONSE: $response \r\n");
							# # # # # # # # # # # # # # # my $result_cli_exec = &trim($cli_exec[1]);
							
							# # # # # # # # # # # # # # # if( $result_cli_exec =~ /^!/ ){
								# # # # # # # # # # # # # # # _xprinttoLog("\r\n[Parser_Tool_log] Negate pattern Found");
								# # # # # # # # # # # # # # # $result_cli_exec =~ tr/!/ /;
								# # # # # # # # # # # # # # # $result_cli_exec = trim($result_cli_exec);
								# # # # # # # # # # # # # # # _xprinttoLog("\r\n[Parser_Tool_log] result_cli_exec");
								# # # # # # # # # # # # # # # if(!($response =~ /$result_cli_exec/)){
									# # # # # # # # # # # # # # # $result = 1;
								# # # # # # # # # # # # # # # }else{
									# # # # # # # # # # # # # # # $result = 0;
								# # # # # # # # # # # # # # # }
								
							# # # # # # # }elsif($response =~ /$result_cli_exec/){
								# # # # # # # $result = 1;
							# # # # # # # }else{
								# # # # # # # $result = 0;
							# # # # # # # }
						}else{
							$result = &_checkexist($response,@expec);
						}
					}	
						
					if ($result == 1){
						&_write_test($Test_desc,$cli_cmd,"PASSED");
					}else{
						$pass_flag = 1;
						&_write_test($Test_desc,$cli_cmd,"FAILED","Expected value is not present");
						#return "fail";
						($continue_flag == 1)? return "success": return "fail";
					}					
				}
			}
		}
		otherwise {
			my $e = shift;
			_xprint( "\r\nFailed due to a " . ref $e );
			_xprint( "\r\nException text is: " . $e->text );
			$exception_string = replaceEscapeSeq($e->text);
			if($expec[0] =~ /success/i){
				## testcase fail;
				$pass_flag = 1;
				&_write_test($Test_desc,$cli_cmd,"FAILED","Expected: Success <br/>Actual: Exception:".$exception_string);
				#return "fail";
				($continue_flag == 1)? return "success": return "fail";
			}else{
				if((@expec == 1) || (@expec == 0)){
					&_write_test($Test_desc,$cli_cmd,"PASSED");
					return "success";
				}else {
					my @resarr = split("=>",$expec[1]);
					#print "\r\n RES: @resarr";
					my $resultstr = trim($resarr[1]);
					_xprint("\r\n[Parser_Tool_log] Expected result	:$resultstr");
					_xprint("\r\n\r\n[Parser_Tool_log] Actual result :".$e->text);
					if($e->text =~ /\Q$resultstr\E/i){
						&_write_test($Test_desc,$cli_cmd,"PASSED");
					}else{
						$pass_flag = 1;
						&_write_test($Test_desc,$cli_cmd,"FAILED","Expected: Exception $resarr[1] <br/>Actual: Exception:".$exception_string); 
						($continue_flag == 1)? return "success": return "fail";
						#return "fail";
					}
					# ( $e->text =~ /$resarr[1]/i) ? &_write_test($cli_cmd,"PASSED") 
										# : &_write_test($cli_cmd,"FAILED","Expected: Exception $resarr[1] <br/>Actual: Exception:".$e->text); ;
				}
			}
		};  
}


    sub replaceEscapeSeq{
	my $exception = shift;
	$exception =~ s/</&lt;/g;
	$exception =~ s/>/&gt;/g;
	
	return $exception;
    }

    sub trimarr{
	    my $string = shift;
	    $string =~ s/\[//;
	    $string =~ s/\]//;
	    $string =~ s/^\s+//;
	    $string =~ s/\s+$//;
	    return $string;
    }
    
    sub _inputZapi{
	    my %input_para = @_;
	    my $cliapi = $input_para{'API-Name'};
	    my %parameter;	
		
		if($cliapi =~ /-/){
			my @client_cmd = split("-",$cliapi);
			$cliapi = $client_cmd[1];
	    }
		
	    foreach my $k(keys(%input_para)){
		     if( $k =~/Test-Desc/i || $k =~ /cleanup/i ||$k =~ /API-Name/i || $k =~ /expected/i || $k =~ /ContinueOnError/i){
			    next;
		     }
		     my $para = $zapiMap{$cliapi}->{$k};
		 if(defined($para)){
			 if($para =~ /\[/){
				my @refarr = split(",",$input_para{$k});
				$parameter{trimarr($para)} = \@refarr;		 
			 }else{
				$parameter{$para} = $input_para{$k};
			 }
		 }
	}
	
	#print "\r\n-------ZAPI INPUT----\r\n";
	#print Dumper(\%parameter);
	return %parameter;
}

sub _job_watch{
	my $apiset= shift;
	my $jobid= shift;
	
	
	my $conn = $apiset->get_connection();
    my $is_resync = 0;
	my $timeout = $apiset->get_timeout();

	_xprint("\r\n THE JOB ID is:".$jobid);
	_xprint("\r\n Timeout is : $timeout \r\n");
    
	
	try {
		$apiset->set_timeout('timeout' => 600);
        $apiset->job_watch_progress(
            id=>$jobid,
            "connectrec-match_table" => [
                "(?m:^|\\r)Complete" => sub {
                    $conn->send_intr() unless ($is_resync);
                    $is_resync = 1;
                    undef;
                },
            ],
        );
    } ## end try
    catch NACL::APISet::Exceptions::ResponseException with {
        my $ex = shift;
        _xprint(
            "\r\njob watch-progress failed with the reason: " . $ex->text());
		if($ex->text =~ /There are no entries matching/i){
			return;
		}	
		
        if ($ex->text !~ /Response exception\:\sInterrupted/) {
            _xprint("\r\nThis is not an exception thrown because of "
                    . "intentionally interrupting the command");
            $ex->throw();
        }
    };

    # Resync only on sending interrupt character.
    $conn->resync() if ($is_resync);
	$apiset->set_timeout('timeout' => $timeout);
	
}



sub _single_executeZapi{
	my $Api_Set_Obj = shift;
	my $hashRef = shift;
	my %input_para = %$hashRef;
	my @client_cmd;
	my $response;
	my $zapicmd;
	
	#check if continue on error flag is set in the testcase set.
	if($continue_flag == 0){
		$continue_flag = 1 if(exists($input_para{'ContinueOnError'}));
	}
	
	
	

	my $cli_cmd = $hashRef->{'API-Name'};
	my $Test_desc = $hashRef->{'Test-Desc'};
	&_xprint("\r\n\n[Parser_Tool_log] ################## TEST ITEM DESCRIPTION :$Test_desc \r\n"); 
	my $expected_Out = $hashRef->{'expected'};
	###added for setting the vserver
	if(defined($input_para{'vserver'})){
		my $vs = trim($input_para{'vserver'});
		if($vs ne $vserver_value){
			$vserver_value = $vs;
			$Api_Set_Obj->set_vserver('vserver-name' => $vserver_value);
			_xprint("\r\n[Parser_Tool_log] VSERVER VALUE : $vserver_value");
		}
	}
	###end of setting vserver
	
	&_xprint("\r\n[Parser_Tool_log] INPUT PARA:");
	%input_para = _inputZapi(%input_para);
	&_xprint(Dumper(\%input_para));
	&_xprint("\r\n[Parser_Tool_log] EXPECTED : $expected_Out");
	
	
	my @expec = split(",\n",$expected_Out);
		try {
			#&_xprint("\r\n----> ACTUAL RESULT :\r\n");
			if($cli_cmd =~ /-/){
				sleep(8);
				@client_cmd = split("-",$cli_cmd);
				my $cmd = $client_cmd[1];
				if($cli_cmd =~ /execute_raw_command/ && defined($client_cmd[2])){
					$input_para{'additional_prompts'} = [$client_cmd[2]];
				}
				$zapicmd = $zapiMap{$cmd}->{'ZAPI-NAME'};
				
				$response = $g_clients{trim($client_cmd[0])}->$zapicmd(%input_para);
			}else{
				foreach my $i(@expec){
					my @res	= split("=>",$i);
					if($res[0] =~ /vserver/){
						$res[1] = trim($res[1]);		
						if($res[1] ne $vserver_value){
							$vserver_value = $res[1];
							$Api_Set_Obj->set_vserver('vserver-name' => $vserver_value);
							_xprint("\r\n[Parser_Tool_log] VSERVER VALUE : $vserver_value");
							last;
						}
					}
				}	
			
				$zapicmd = $zapiMap{$cli_cmd}->{'ZAPI-NAME'};
				&_xprint("\r\n[Parser_Tool_log] COMMAND NAME:$cli_cmd"); 
				$response = $Api_Set_Obj->$zapicmd(%input_para);
			}
			
			if($cli_cmd =~ /execute_raw_command/){
				&_xprint($response);
			}else{
				&_xprint(Dumper(\$response->{'parsed_output'}));
			}
			
			if($expec[0] =~ /Error/i){
				## testcase fail;
				&_write_test($Test_desc,$cli_cmd,"FAILED","Expected Error but the operation succeded");
				$pass_flag = 1;
				#return "fail";
				($continue_flag == 1)? return "success": return "fail";
			}else{
				## testcase pass
				if((@expec == 1) ||(@expec == 0)){
					&_write_test($Test_desc,$cli_cmd,"PASSED");
					return "success";
				}else{
					shift(@expec);
					my $result;
					if(($cli_cmd =~ /-/) && ($cli_cmd =~ /execute_raw_command/)){
						my @exe_response = split("=>",&trim($expec[0]));
						print "\r\n[Parser_Tool_log]############# $exe_response[1] \r\n";
						print "\r\n[Parser_Tool_log]############# $response \r\n";
						my $result_expec = &trim($exe_response[1]);
						if($response =~ /$result_expec/){
							$result = 1;
						}else{
							$result = 0;
						}
						
					}else{
						$result = _checkexistZapi($response,$cli_cmd,$Api_Set_Obj,@expec);
					}	
						
					if ($result == 1){
						&_write_test($Test_desc,$cli_cmd,"PASSED");
					}else{
						$pass_flag = 1;
						&_write_test($Test_desc,$cli_cmd,"FAILED","Expected value is not present");
						#return "fail";
						($continue_flag == 1)? return "success": return "fail";
					}					
				}
			}
		}
		otherwise {
			my $e = shift;
			_xprint( "\r\nFailed due to a " . ref $e );
			_xprint( "\r\nException text is: " . $e->text );
			if($expec[0] =~ /success/i){
				## testcase fail;
				$pass_flag = 1;
				&_write_test($Test_desc,$cli_cmd,"FAILED","Expected: Success <br/>Actual: Exception:".$e->text);
				#return "fail";
				($continue_flag == 1)? return "success": return "fail";
			}else{
				if((@expec == 1) || (@expec == 0)){
					&_write_test($Test_desc,$cli_cmd,"PASSED");
					return "success";
				}else {
					my @resarr = split("=>",$expec[1]);
					#print "\r\n RES: @resarr";
					my $resultstr = trim($resarr[1]);
					_xprint("\r\n[Parser_Tool_log] Expected result	:$resultstr");
					_xprint("\r\n[Parser_Tool_log] Actual result is	:".$e->text);
					if($e->text =~ /$resultstr/i){
						&_write_test($Test_desc,$cli_cmd,"PASSED");
					}else{
						$pass_flag = 1;
						&_write_test($Test_desc,$cli_cmd,"FAILED","Expected: Exception $resarr[1] <br/>Actual: Exception:".$e->text); 
						($continue_flag == 1)? return "success": return "fail";
						#return "fail";
					}
					# ( $e->text =~ /$resarr[1]/i) ? &_write_test($cli_cmd,"PASSED") 
										# : &_write_test($cli_cmd,"FAILED","Expected: Exception $resarr[1] <br/>Actual: Exception:".$e->text); ;
				}
			}
		};  
}



sub _checkexistZapi{
	my $response = shift;
	my $cliapi = shift;
	my $Api_Set_Obj = shift; 
	my @expec = @_;
	my $pass_flag = 0;
	my @parsed_output = @{$response->get_parsed_output()};
	my $lenarr = @parsed_output;
	my @outarr;
	my %obj2;
	my $str;

	if(($lenarr > 0) && (exists($parsed_output[0]->{'attributes-list'}))){
		%obj2 = %{$parsed_output[0]->{'attributes-list'}->[0]};
		foreach my$k (keys(%obj2)){
			@outarr = @{$obj2{$k}};
			last;	
		}
	
	}	
	
	_xprint("\r\n[Parser_Tool_log] expected array:");
	_xprint(Dumper(\@expec));
	
	if($cliapi =~ /-/){
		my @client_cmd = split("-",$cliapi);
		$cliapi = $client_cmd[1];		
	}
	
	if($expec[0] =~ /vserver/ ){
		my @vs = split("=>",$expec[0]);
		$vs[1] = trim($vs[1]);
		
		if($vs[1] ne $vserver_value){
			$vserver_value = $vs[1];
			$Api_Set_Obj->set_vserver('vserver-name' => $vserver_value);
			_xprint("\r\n[Parser_Tool_log] VSERVER VALUE : $vserver_value");
		}
		shift(@expec);
	}
	
	#&_xprint(Dumper(\@outarr));
	&_xprint(Dumper(\@expec));
	
	foreach my $parse(@outarr){
			_xprinttoLog("\r\n[Parser_Tool_log] -----LOOP-------\r\n");
			$pass_flag = 0;
			foreach my $exp(@expec){
				_xprinttoLog("\r\n$exp");
				my @res	= split("=>",$exp);
				_xprinttoLog("\r\n[Parser_Tool_log]---- NAME ----: $cliapi");
				_xprinttoLog("\r\n[Parser_Tool_log] para: $res[0]");
				my $zapipara = $zapiMap{$cliapi}->{trim($res[0])};
				
				
				_xprinttoLog("\r\n[Parser_Tool_log] ZAPI PARA : $zapipara");	
				if(defined($zapipara)){
					 if($zapipara =~ /\[/){
						$zapipara = trimarr($zapipara);
						
						if(exists($parse->{$zapipara})){
								my @valuearr = @{$parse->{$zapipara}};
								$lenarr = @valuearr;
								if($lenarr > 0){
									my %obj3 = %{$valuearr[0]};
									_xprinttoLog("\r\n DUMP");
									_xprinttoLog(Dumper(\%obj3));
									foreach my$k (keys(%obj3)){
										$str = $obj3{$k};
										last;	
									}
								}
							if(ref($str) eq "ARRAY"){
								my @newarr = @{$str};
								$str = join(",",@newarr);
							}							
							$str = trim($str);
							$res[1] = trim($res[1]);	
							_xprinttoLog("\r\n[Parser_Tool_log] compare value is $str\r\n And $res[1]\r\n");
							if((trim($str) eq trim($res[1])) || ($str =~ /$res[1]/)){
								_xprinttoLog("\r\n[Parser_Tool_log] MATCHING");
								$pass_flag++;
							}							
						}
						
						
						
					 }else{
						_xprinttoLog("\r\n[Parser_Tool_log]IN ELSE");
						if(exists($parse->{trim($zapipara)})){
							#print "\r\n--->".$parse->{trim($zapipara)};
							#print "\r\n--->".trim($res[1]);
							$res[1] = trim($res[1]);
							if($res[1] =~ /^!/){
								_xprinttoLog("\r\n[Parser_Tool_log] Negate pattern Found");
								$res[1] =~ tr/!/ /;
								$res[1] = trim($res[1]);
								$pass_flag++ if($parse->{trim($zapipara)} ne trim$res[1]);
							}elsif($parse->{trim($zapipara)} eq trim($res[1])){
								_xprinttoLog("\r\n[Parser_Tool_log] MATCHING");
								$pass_flag++;
							}else{
								_xprinttoLog("\r\n[Parser_Tool_log] NOT MATCHING");
							}
						}
					 }
				 }
				
				
				
				
			}
		return 1 if($pass_flag == @expec);	
		
	}
	return 0;		
}




sub _execraw_search{
    my $response = shift;
	my @expec = @_;
	my $result;
	my $elem;

	_xprint("\r\n[Parser_Tool_log] _execraw_search: $response \r\n");
	
	foreach $elem(@expec){
		my @exe_response = split("=>",&trim($elem),2);
		my $result_cli_exec = trim($exe_response[1]);
		_xprinttoLog("\r\n[Parser_Tool_log] _execraw_search :$result_cli_exec");
		
		if( $result_cli_exec =~ /^!/ ){
				_xprint("\r\n[Parser_Tool_log] _execraw_search :: Negate pattern Found");
				$result_cli_exec =~ tr/!/ /;
				$result_cli_exec = trim($result_cli_exec);
				_xprint("\r\n[Parser_Tool_log] _execraw_search :$result_cli_exec");
				if(!($response =~ /\Q$result_cli_exec\E/i)){
					$result = 1;
				}else{
					$result = 0;
					_xprint("\r\n[Parser_Tool_log] _execraw_search :FAILED TO MATCH :$result_cli_exec");
					last;
				}
								
		}else{
			if($result_cli_exec =~ /\Q|\E/){
				my @matchelem = split(/\|/,$result_cli_exec);
				_xprinttoLog("\r\n[Parser_Tool_log] FOUND OR Sentence");
				foreach my $i(@matchelem){
					$result_cli_exec = trim($i);
					_xprinttoLog("\r\n[Parser_Tool_log] OR >>$result_cli_exec");
					if($response =~ /\Q$result_cli_exec\E/i){
						$result = 1;
						last;
					}else{
						$result = 0;
					}
				}
			}else{
				if($response =~ /\Q$result_cli_exec\E/i){
					$result = 1;
				}else{
					$result = 0;
					last;
				}
			}
		}
	}
	
	return $result;
}




sub _checkexist{
	my $response = shift;
	my @expec = @_;
	my $pass_flag = 0;
	my $elem;
	my @parsed_output = @{$response->get_parsed_output()};
	my $flagneg = 0;
	
	_xprint(Dumper(\@parsed_output));
	_xprint("\r\n[Parser_Tool_log] Expected result:");
	_xprint(Dumper(\@expec));
	
	foreach my $parse(@parsed_output){
			$pass_flag = 0;
			foreach my $exp(@expec){
				_xprinttoLog("\r\n[Parser_Tool_log] Expected: $exp");
				my @res	= split("=>",$exp);
				if(exists($parse->{&trim($res[0])})){
					$elem = $parse->{trim($res[0])};
					_xprinttoLog("\r\n[Parser_Tool_log] Actual :".$parse->{trim($res[0])});
					
					if(ref($parse->{trim($res[0])}) eq "ARRAY"){
							my @arr = @{$parse->{trim($res[0])}};
							$elem = join(",",@arr);
							_xprinttoLog("\r\n[Parser_Tool_log] Actual :".$elem);
					}
					_xprinttoLog("\r\n[Parser_Tool_log] >> $res[1]"); 
					#if($parse->{&trim($res[0])} eq &trim($res[1])){
				#	if($elem eq &trim($res[1])){
					$res[1] = trim($res[1]);
					if( $res[1] =~ /^!/ ){
						_xprinttoLog("\r\n[Parser_Tool_log] Negate pattern Found");
						$res[1] =~ tr/!/ /;
						$res[1] = trim($res[1]);
						_xprinttoLog("\r\n[Parser_Tool_log] $res[1]");
						$flagneg = 1;
					}elsif($res[1] =~ /\Q||\E/){
						my @matchelem = split(/\|\|/,$res[1]);
						_xprinttoLog("\r\n[Parser_Tool_log] FOUND OR Sentence");
						foreach my $i(@matchelem){
							$res[1] = trim($i);
							_xprinttoLog("\r\n[Parser_Tool_log] OR >>$res[1]");
							if(($elem =~ /\Q$res[1]\E/i) || ($elem eq $res[1])){
								_xprinttoLog("\r\n[Parser_Tool_log]OR MATCHING");
								$pass_flag++;
								last;
							}
						}
						next;
					}else{
						$flagneg = 0;
					}

					
					#$elem=chomp($elem);$res[1]=chomp($res[1]);
					_xprinttoLog("\r\n[Parser_Tool_log] Actual :".$elem);
					_xprinttoLog("\r\n[Parser_Tool_log] >>$res[1]");
					if($flagneg == 1){
						if(($elem =~ /\Q$res[1]\E/i) || ($elem eq $res[1])){
							_xprinttoLog("\r\n[Parser_Tool_log] NEGATE ELEMET IS MATCHING");							
						}else{
							$pass_flag++;
						}
					}else{		
						if(($elem =~ /\Q$res[1]\E/i) || ($elem eq $res[1])){
							_xprinttoLog("\r\n[Parser_Tool_log] MATCHING");
							$pass_flag++;
						}
					}	
				}
			}
		return 1 if($pass_flag == @expec);	
		
	}
	return 0;		
}


sub _cleanup{
	my $self = shift;
	my $Api_Set_Obj = shift;
	my $count = shift;
	my $reftcset = shift;
	my %cl_input_para;
	my @cmd;
	my $checkflag = 0;
	
	&_xprint("\r\n[Parser_Tool_log]=======> CLEANUP");
	foreach my $num(0..$count)
		{
			$checkflag = 0;	
			if(exists($reftcset->{$num}->{'cleanup'})){
				#extract cleanup tasks
				my $cleanup_cmd = $reftcset->{$num}->{'cleanup'};
				#get the input para for the cleanup.
				
				if($cleanup_cmd =~ /-/){
					@cmd = split("-",$cleanup_cmd);
					$cleanup_cmd = trim($cmd[1]);
					$checkflag = 1;					
				}
				%cl_input_para = &_get_cleanuppara($self,$Api_Set_Obj,$cleanup_cmd,$reftcset->{$num});
				if($self->{'execType'} eq "ZAPI"){
					$cleanup_cmd = $zapiMap{$cleanup_cmd}->{'ZAPI-NAME'};;
				}				
				
				### execute the cleanup cmd
				try{
					&_xprint("\r\n[Parser_Tool_log] Cleanup para: $cleanup_cmd \r\n");
					&_xprint(Dumper(\%cl_input_para));
					if($checkflag == 1){
						$g_clients{trim($cmd[0])}->$cleanup_cmd(%cl_input_para);
					}else{
					my $response = $Api_Set_Obj->$cleanup_cmd(%cl_input_para);
					}
										
				}catch NACL::APISet::Exceptions::MissingRequiredParamException with{
					my $ex = shift;
					$ex->throw();
				}otherwise {
					my $e = shift;
					&_xprint("\r\n[Parser_Tool_log] Cleanup failed : ". $e->text());
				};  							
			}
		}
}


sub _get_cleanuppara{
	my $self = shift;
	my $Api_Set_Obj = shift;
	my $cleanup_cmd = shift;
	my $tc_ref = shift;
	my $exist_flag = 0;
	my $loop;

	#&_xprint("\r\n----> CLEANUP CMD: $cleanup_cmd");
	#search in the global cleanup hash to find the Api and also the 
	foreach my $k (keys(%g_cleanup)){
		if($g_cleanup{$k}->{'API-Name'} eq $cleanup_cmd){
		$exist_flag = 1;
		$loop = $k;
		last;
		}
	}
	unless($exist_flag == 0){
		my %tc_clean = %{$g_cleanup{$loop}};
		&_xprint("\r\n");
		#&_xprint(Dumper(\%tc_clean));
		foreach my $k (keys(%tc_clean)){
			#&_xprint("\r\n k: $k");
			$tc_clean{$k}=$tc_ref->{$k} if(exists($tc_ref->{$k}));
			if(($k eq 'API-Name') &&  ($self->{'execType'} ne "ZAPI")){
				delete($tc_clean{$k});
			}
		}
		
		if($self->{'execType'} eq "ZAPI"){
			###added for setting the vserver
			if(defined($tc_clean{'vserver'})){
				my $vs = trim($tc_clean{'vserver'});
				if($vs ne $vserver_value){
					$vserver_value = $vs;
					$Api_Set_Obj->set_vserver('vserver-name' => $vserver_value);
					_xprint("\r\n[Parser_Tool_log] VSERVER VALUE : $vserver_value");
				}
			}
			###end of setting vserver
			%tc_clean = _inputZapi(%tc_clean);
		}
		
		return %tc_clean;
	}else{
		&_xprint("[Parser_Tool_log] Cleanup: $cleanup_cmd is not there in the excel sheet");
	}	
}

sub _generateZAPICLIMap{
	 my $workbook = shift;
	 my $value;
	 my @zapiarr;
	 my $apiname;
    
	
	
	my $worksheet = $workbook->worksheet('Zapi-Cli-Map');
	if ( !defined $worksheet ) {
		print "\r\n[Parser_Tool_log] excel sheet Zapi-Cli-Map does not exist", ".\n";
		return 0;
	}
	my ( $row_min, $row_max ) = $worksheet->row_range();
	my ( $col_min, $col_max ) = $worksheet->col_range();
    
	OUTER: for my $row ( $row_min .. $row_max ) {
	INNER:	for my $col ($col_min .. $col_max){
				
				my $cell = $worksheet->get_cell( $row, $col);	
							 
				if($col == $col_min){
					if ($cell && $cell->value()){
						$value = $cell->value();
						@zapiarr = split("=>",$value);
						$apiname = trim($zapiarr[0]);
						$zapiMap{trim($zapiarr[0])}->{'ZAPI-NAME'} = trim($zapiarr[1]);
					}else{
						next OUTER;
					}
				}elsif($cell && $cell->value()){
					$value = $cell->value();
					@zapiarr = split("=>",$value);
					$zapiMap{trim($apiname)}->{trim($zapiarr[0])} = trim($zapiarr[1]);
									
				}else{
					next OUTER;
				}
			}
		}
		
	_xprint("\r\n[Parser_Tool_log]--ZAPI HASH----\r\n");
	_xprint(Dumper(\%zapiMap));

}


sub _generate_cleanup_tbl{
	
	my $workbook = shift;
	
	my $worksheet = $workbook->worksheet('cleanup');
	if ( !defined $worksheet ) {
		print "\r\n[Parser_Tool_log] excel sheet Cleanup does not exist", ".\n";
		return 0;
	}
	my ( $row_min, $row_max ) = $worksheet->row_range();
	my ( $col_min, $col_max ) = $worksheet->col_range();
	my $counter = 0;

    OUTER: for my $row ( $row_min .. $row_max ) {
	INNER:	for my $col ($col_min .. $col_max){
				my $cell = $worksheet->get_cell( $row, $col);	
			 	if($col == $col_min){
					if ($cell && $cell->value()){
						$g_cleanup{$counter}->{'API-Name'} = $cell->value();
					}else{
						last OUTER
					}
				}elsif($cell && $cell->value()){
						$g_cleanup{$counter}->{$cell->value()} = undef;
					 if($col == $col_max){
						$counter++;
						next OUTER;
					 }
				}else{
					$counter++;
					next OUTER;
				}
			}
		}
		&_xprint("\r\n[Parser_Tool_log]------------CLEAN UP----------\r\n");
		&_xprint(Dumper(\%g_cleanup));
		
}


sub _generate_Client_tbl{
	my $self = shift;
	my $workbook = shift;
	my @table;
	my %inp;
	my $set;
	my $interface;
	my $category;
	my $Hostobj;
	my $name;
	my $checkflag;
	my %replacehash;
	my $error = 0;
	my $Hosttype;
	my $worksheet = $workbook->worksheet('CLIENT');
	if ( !defined $worksheet ) {
		print "\r\n[Parser_Tool_log] excel sheet CLIENT does not exist", ".\n";
		return 0;
	}
	$interface = "CLI";
	print "\r\n[Parser_Tool_log] New changes ##############";
	
	my ( $row_min, $row_max ) = $worksheet->row_range();
	my ( $col_min, $col_max ) = $worksheet->col_range();
	
	%replacehash = %{$self};
	for my $row ( $row_min .. $row_max ) {
		$checkflag = 0;
		for my $col ($col_min .. $col_max){
			my $cell = $worksheet->get_cell( $row, $col);	
			if(($col == $col_min) && $cell && ($cell->value())){
				@table = split("=>",$cell->value());
				$name = trim($table[0]);
				foreach my $k(keys(%replacehash)){
     					$k = trim($k);
				     #_xprinttoLog("\r\n[Parser_Tool_log] REPLACEMENT KEY :$k");
    				 #    _xprinttoLog("\r\n[Parser_Tool_log] STRING:".$table[1]);

					if($table[1] =~ /$k/){
			       		     $table[1] =~ s/$k/$replacehash{$k}/;
			                	last;
   				 	}
				}	

				$Hostobj = host(trim($table[1]));
				$Hosttype = $Hostobj->{hosttype};
				_xprint("\r\n[Parser_Tool_log] HOSTTYPE $Hosttype");
				if($Hosttype =~ /windows/i){
					$set = "Windows";
					$category = "Host";
					$inp{'connid'} = 'login';
					$inp{'conntype'} = 'rsh-persist';
					#print "\r\n HOST $Hosttype";
				}elsif($Hosttype =~ /linux/i){
					$set = "Linux";
					$category = "Host";
				}else{
					$category = "Node";
					$set = "CMode";					
				}
				$checkflag = 1;	
			}elsif($cell && $cell->value()){
				#push (@table,$cell->value());
				@table = split("=>",$cell->value());
				$inp{trim($table[0])} = trim($table[1]);
		   		if (exists($inp{'set'})) {
					$set=$inp{'set'};
				}
				if (exists($inp{'interface'})) {
					$interface =$inp{'interface'};
				}	
				$checkflag = 1;
			}
		}

			#&_xprint("\r\n[Parser_Tool_log]----------------CLIENT TABLE------------\r\n");
			&_xprint(Dumper(\%inp));
			#&_xprint("\r\n category  => $category");
			#&_xprint("\r\nset       => $set");
			if($checkflag == 1){
				try{
					my $APISet_obj = NACL::APISet->new(hostobj => $Hostobj,
											category  => $category,
											interface => $interface,
											set       => $set,
											%inp		
											);
					$g_clients{$name} = $APISet_obj;
					if($Hosttype =~ /windows|linux/i ){
						my $Id = $Hostobj->id();
						my $cliobj = NACL::C::Client->new(name => $Id);
						push @Client_pkkt,$cliobj;
					}
				}otherwise {
					my $e = shift;
					print( 'Failed due to a ' . ref $e );
					print( 'Exception text is: ' . $e->text );
					&_xprint("\r\n APISet creation failed for CLIENT :");
					&_xprint(Dumper(\%inp));
					$error = 1;
				}; 
			}
			if($error == 1){
				return 1;
			}
			%inp=();
	}
	#&_xprint(Dumper(\%g_clients));
	
}


sub openreport{
	my $logpath = shift;
	my $report;
	my $log;
	
	$logpath  = trim($logpath);
	
	if($logpath =~ /\//){
		$report = $logpath."/testreport.html";
		$log = $logpath."/test_log.txt";
	}else{
		$report = "testreport.html";
		$log = "test_log.txt";
	}

	
	 if( -e  $report) {
	  open REPFILE1,"+>", $report or die "\r\n Report file open: $!";
	  close REPFILE1;
	 }

	 open REPFILE,">>", $report or die "\r\n Report file open: $!";
	 open LOGFILE,"+>",$log or die "\r\n Log file open: $!";
	 
	 print REPFILE $Html_Begin;
	 print REPFILE $Html_Tbl_Start;
 
}

sub _write_grp{
	my $groupName = shift;
	$index = 1;
	my $buf =sprintf("%s<b>%s</b>%s",$Html_GrpStart,$groupName,$Html_GrpEnd);
	print REPFILE $buf;
	
	if($groupName !~ /CLEANUP|SETUP/i){
		testcase_start($groupName,"beginning of $groupName");
	}
}

sub _write_test{
	 my $Test_desc = shift;
	 my $api_name = shift;
	 my $result = shift;
	 my $failreason = shift;
	 my $buf;

	if ($result eq "PASSED"){ 
		$buf = sprintf("%s<td align=\"center\" width=\"5%%\">%d</td> \n",$Html_TcStart_Pass,$index);
		print REPFILE $buf;

		$buf = sprintf("<td  align=\"center\" width=\"30%%\">%s</td>\n",$Test_desc);
		print REPFILE $buf;
		
		$buf = sprintf("<td  align=\"center\" width=\"30%%\">%s</td>\n",$api_name);
		print REPFILE $buf;

		$buf = sprintf("<td  align=\"center\" width=\"30%%\">PASSED</td>%s\n",$Html_TcEnd);
		print REPFILE $buf;
		&_xprint("\r\n\n=====> TEST ITEM PASSED \r\n");
	}else {
		$buf = sprintf("%s<td align=\"center\" width=\"5%%\">%d</td>\n",$Html_TcStart_Fail,$index);
		print REPFILE $buf;
		$buf = sprintf("<td  align=\"center\" width=\"30%%\">%s</td>\n",$Test_desc);
		print REPFILE $buf;
		$buf = sprintf("<td  align=\"center\" width=\"30%%\">%s</td>\n",$api_name);
		print REPFILE $buf;
		$failreason =~ tr/</&lt;/;
		$failreason =~ tr/>/&gt;/;
		$buf = sprintf("<td  align=\"left\" width=\"30%%\">%s:</td>%s\n",$failreason,$Html_TcEnd);
		print REPFILE $buf;
		&_xprint("\r\n\n=====> TEST ITEM FAILED \r\n");
	}
	$index++;
}

sub _closereport{
	my $buf;
	
	print REPFILE $Html_Tbl_End;
	
	print REPFILE "<p>&nbsp;</p>\n";
	print REPFILE "\n<table border=\"1\" align=\"center\" width=\"35%\" cellpadding=\"1\" cellspacing=\"0\"  bgcolor=#E9967A >";
	$buf = sprintf("<tr><td align=\"center\" width=\"25%%\"><b>TOTAL TEST CASE EXECUTED </b></td><td align=\"center\" width=\"10%%\"><b>%d</b></td></tr>\n",($g_passCnt + $g_failCnt));
	print REPFILE $buf;

	$buf = sprintf("<tr><td align=\"center\" width=\"25%%\"><b>TOTAL TEST CASE PASSED </b></td><td align=\"center\" width=\"10%%\"><b>%d</b></td></tr>\n",$g_passCnt);
	print REPFILE $buf;

	$buf = sprintf("<tr><td align=\"center\" width=\"25%%\"><b>TOTAL TEST CASE FAILED </b></td><td align=\"center\" width=\"10%%\"><b>%d</b></td></tr>\n",$g_failCnt);
	print REPFILE $buf;

	print REPFILE $Html_End;

	close REPFILE;
	close LOGFILE;
}

sub result{
	my $self = shift;
	my $tcd = shift;
	
	if($tcd){
		$tcd->description("Test cases Run	:".($g_passCnt + $g_failCnt));
		$tcd->description("Test cases Pass	:".$g_passCnt );
		$tcd->description("Test cases Fail	:".$g_failCnt );
	}
}

sub _xprint{
	my $buf = shift;
	print $buf;
	print LOGFILE $buf; 
}

sub _xprinttoLog{
	my $buf = shift;
	print LOGFILE $buf; 
}

sub trim{
	my $string = shift;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}

1;
