 package CIFS::FPolicy::fpolicyXmlparser;
 use XML::Simple;
 use Data::Dumper;
 use strict;

my %reqtype = ('SMB_REN' => "SmbRenReq",
			'SMB_SET_ATTR' => "SmbSetAttrReq",
			'SMB_CREAT' =>	"SmbCreatReq",
			'SMB_REN_DIR' => "SmbRenReq",
			'SMB_CREAT_DIR' => "SmbCreatReq",
			'SMB_OPEN' => "SmbOpenReq",
			'SMB_DEL' => "SmbDelReq",
			'SMB_DEL_DIR' => "SmbDelReq",
			'SMB_RD' => "SmbRdReq",
			'SMB_WR' => "SmbWrReq",
			'SMB_CLOSE' => "SmbCloseReq",
			'SMB_GET_ATTR' => "SmbGetAttrReq",
			'NFS_GET_ATTR' => "NfsGetAttrReq",
			'NFS_SET_ATTR' => "NfsSetAttrReq",
			'NFS_CREAT' => "NfsCreatReq",
			'NFS_CREAT_DIR' => "NfsCreatReq",
			'NFS_DEL' => "NfsDelReq",
			'NFS_OPEN' => "NfsOpenReq",
			'NFS_REN' => "NfsRenReq",
			'NFS_REN_DIR' => "NfsRenReq",
			'NFS_SYM_LNK' => "NfsSymLnkReq",
			'NFS_LNK' => "NfsLnkReq",
			'NFS_WR' => "NfsWrReq",
			'NFS_RD' => "NfsRdReq",
			'NFS_DEL_DIR' => "NfsDelReq",
			'NFS_CLOSE' => "NfsCloseReq",
			'NFS_LOOKUP' => "NfsLookupReq"
			); 
						
 sub new {
	my($class) = shift;        # Class name is in the first parameter
	my $xmlpath = shift;
	my $self;

	# create object
   my $xml = new XML::Simple;
   
   # read XML file
   my $data = eval {$xml->XMLin($xmlpath)};
   if($@){
		return $self;
	}
   
   # print output
   print Dumper($data);
   $self = {'data' => $data};  # Anonymous hash reference holds instance attributes
	
	bless($self, $class);          # Say: $self is a $class
	return $self;	
 }  


sub xmlInp{
	my $self = shift;
	my $xmlpath = shift;
	my $newself;
	my $xml = new XML::Simple;
   
   # read XML file
   my $data = eval {$xml->XMLin($xmlpath)};
   if($@){
		return $newself;
	}
   
   # print output
   print Dumper($data);
   $self = {'data' => $data};  # Anonymous hash reference holds instance attributes

   return $self;	
} 
 
 
sub get_CommonInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	my $ProtVerNum;
	
	if (exists($self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}}->{'CommonInfo'})){
		$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}}->{'CommonInfo'};
	}else{
		$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}}->{'CommonInfo'};
	}
	
	if(exists($dataref->{'ProtVerNum'}->{'MajorNum'})){
		$ProtVerNum = $dataref->{'ProtVerNum'}->{'MajorNum'}.".".$dataref->{'ProtVerNum'}->{'MinorNum'};
	}else{
		$ProtVerNum = $dataref->{'ProtVer'}->{'MajorNum'}.".".$dataref->{'ProtVer'}->{'MinorNum'};
		$commonInfo->{'UserGids'} = $dataref->{'UserGids'};
	}
	
	$commonInfo->{'ProtVerNum'} = $ProtVerNum;
	#$commonInfo->{'IsStream'} = $dataref->{'ProtCommonInfo' }->{'IsStream'};
    #$commonInfo->{'SymLnk'} = $dataref->{'ProtCommonInfo' }->{'SymLnk'} ;
	if(exists($dataref->{'ProtCommonInfo' }->{'UsrContext'}->{'MappedId'}->{'WinSid'})){
		$commonInfo->{'WinSid' } = $dataref->{'ProtCommonInfo' }->{'UsrContext'}->{'MappedId'}->{'WinSid'};
		$commonInfo->{'UsrContext' } = $dataref->{'ProtCommonInfo' }->{'UsrContext'}->{'MappedId'}->{'Uid'};
	}else{
		$commonInfo->{'UsrContext' } = $dataref->{'ProtCommonInfo' }->{'UsrContext'}->{'UnixUid'};
	}
	
	$commonInfo->{'FileType'} = $dataref->{'ProtCommonInfo' }->{'FileType'};
    $commonInfo->{'VolMsid'} = $dataref->{'ProtCommonInfo' }->{'VolMsid'};
    $commonInfo->{'UnixUid'} = $dataref->{'ProtCommonInfo' }->{'FileOwner'}->{'UnixUid'};
    $commonInfo->{'IsSparse'} = $dataref->{'ProtCommonInfo' }->{'IsSparse'};
    $commonInfo->{'IsOfflineAttr'} = $dataref->{'ProtCommonInfo' }->{'IsOfflineAttr'};
    $commonInfo->{'ClientIp'} = $dataref->{'ProtCommonInfo' }->{'ClientIp'};
    $commonInfo->{'UsrIdType'} = $dataref->{'ProtCommonInfo' }->{'UsrIdType'};
    $commonInfo->{'NumHardLnk'} = $dataref->{'ProtCommonInfo' }->{'NumHardLnk'};
    $commonInfo->{'IsDense'} = $dataref->{'ProtCommonInfo' }->{'IsDense'};
    $commonInfo->{'FileSize'} = $dataref->{'ProtCommonInfo' }->{'FileSize'};
    $commonInfo->{'WinAccessPathType'} = $dataref->{'ProtCommonInfo'}->{'AccessPath'}->{'Path'}->[0]->{'PathName'};
	$commonInfo->{'UnixAccessPathType'} = $dataref->{'ProtCommonInfo'}->{'AccessPath'}->{'Path'}->[1]->{'PathName'};
    $commonInfo->{'DisplayPath'} = $dataref->{'DisplayPath'};
	$commonInfo->{'ReqId'} = $self->{'data'}->{'ReqId'};
	
	return $commonInfo;
} 


sub get_renInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}}->{'TargetAccessPath'};
	
	$commonInfo->{'WinTargetAccessPathType'} = $dataref->{'Path'}->[0]->{'PathName'};
	$commonInfo->{'UnixTargetAccessPathType'} = $dataref->{'Path'}->[1]->{'PathName'};
	
	return $commonInfo;
	
}

sub get_SetAttrInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}};
	
	if($self->{'data'}->{'ReqType'} eq "SMB_SET_ATTR"){
		$commonInfo->{'SmbSetattrAtime'} = $dataref->{'SmbSetattrAtime'}->{'Secs'} .".". $dataref->{'SmbSetattrAtime'}->{'NanoSecs'};
		$commonInfo->{'SmbSetattrNewOwner'} = $dataref->{'SmbSetattrNewOwner'}->{'UnixUid'};
		$commonInfo->{'SmbSetattrChangeAttr'} = $dataref->{'SmbSetattrChangeAttr'};
		$commonInfo->{'SmbSetattrUserIdType'} = $dataref->{'SmbSetattrChangeAttr'};
		$commonInfo->{'SmbSetattrMtime'} = $dataref->{'SmbSetattrMtime'}->{'Secs'} .".". $dataref->{'SmbSetattrMtime'}->{'NanoSecs'};
		$commonInfo->{'SmbSetattrFileSize'} = $dataref->{'SmbSetattrFileSize'};
	}else{
		$commonInfo->{'NfsSetattrAtime'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetattrAtime'}->{'Secs'} .".". $dataref->{'NfsSetAttrCommon'}->{'NfsSetattrAtime'}->{'NanoSecs'};
		$commonInfo->{'NfsSetAttrGid'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetAttrGid'};
		$commonInfo->{'NfsSetAttrGid'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetAttrGid'};
		$commonInfo->{'NfsSetAttrMode'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetAttrMode'};
		$commonInfo->{'NfsSetattrMtime'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetattrMtime'}->{'Secs'} .".". $dataref->{'NfsSetAttrCommon'}->{'NfsSetattrMtime'}->{'NanoSecs'};
		$commonInfo->{'NfsSetAttrSize'} = $dataref->{'NfsSetAttrCommon'}->{'NfsSetAttrSize'};
		$commonInfo->{'ChangeAttr'} = $dataref->{'ChangeAttr'};
	}
	return $commonInfo ;
}


sub get_CreateInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}};
	
	if($self->{'data'}->{'ReqType'} eq "SMB_CREAT"){
		$commonInfo->{'CreatSharemode'} = $dataref->{'CreatSharemode'};
		$commonInfo->{'CreatDisposition'} = $dataref->{'CreatDisposition'};
		$commonInfo->{'CreatAccmode'} = $dataref->{'CreatAccmode'};
	}
	return $commonInfo ;
}


sub get_OpenInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}};
	
	if($self->{'data'}->{'ReqType'} eq "SMB_OPEN"){
		$commonInfo->{'OpenSharemode'} = $dataref->{'OpenSharemode'};
		$commonInfo->{'OpenAccmode'} = $dataref->{'OpenAccmode'};
		$commonInfo->{'OpenOptions'} = $dataref->{'OpenOptions'};
	}
	return $commonInfo ;
}


sub get_ReadInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}};
	
	$commonInfo->{'RdOffset'} = $dataref->{'RdOffset'};
	$commonInfo->{'RdLength'} = $dataref->{'RdLength'};
	
	return $commonInfo ;
}


sub get_WriteInfo{
	my $self = shift;
	my $commonInfo ;
	my $dataref ;
	
	$dataref = $self->{'data'}->{'NotfInfo'}->{$reqtype{$self->{'data'}->{'ReqType'}}};
	
	$commonInfo->{'WrOffset'} = $dataref->{'WrOffset'};
	$commonInfo->{'WrLength'} = $dataref->{'WrLength'};
	
	return $commonInfo ;
}




1;










