#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/CIFS/Utils_gui.pm#1 $
#
## @summary Utils_gui - Library for the GUI tests
## @author	dl-maryv (FSS Protocols QA)
## @status	public
## @notes	Created by EP Network Storage Performance Lab, Inc.
## @pod here

=head1 NAME

Utils_gui - Library for Win32 GUI manipulation functions

=head1 SYNOPSIS

    use CIFS::Utils_gui;

    screen_lock(setting => 'on');

    $win = get_property_window(target_text => $text, window => $win);

    $win = check_tab_present(target_text => $text, window => $win);

    find_target_explorer(target_text => 'tdir', window => $win);

    %res = verify_previous_version_tab(target_text => $name,
                                       window => $win);

    $win = explorer_open_with_target(target_text => 'T:');

    @res = previous_version_text_get(version => 5);

    @res = previous_version_copy_get(test_file_name => 'vsstest001.txt',
                                     version => 0);

    $res = previous_version_restore_get(version => 5);

    $whandle = filer_default_webpage_open(filer => $FILER);

    close_window(window => $win);

    close_properties_window(window => $win);

    $rc = filerview_open(filer => $FILER, window => $whandle);

    app_window_close();

    $msg = filerview_cifs_config(domain => $CIFS_DOMAIN,
                     domain_admin => $CIFS_DOMAIN_ADMIN,
                     domain_admin_passwd => $CIFS_DOMAIN_ADMIN_PASSWD);

    $msg = filerview_hosts_config(dns_domain => $domain,
                                  dns_srv_ip_addr => $ip);

    $msg = filer_web_man_verify(window => $whandle);

    $fname = save_win_as_bmpfile(window => $whandle);

    $win = open_mmc(filer => $filer);

    close_mmc(window => $window);

    add_share_xp(window => $win, filer => $filer, share => $share,
                 caching => $share_attr);

    $ret = delete_share(window => $win, filer => $filer,
                        share => $share);

    $txt = verify_share_path_and_option(window => $win, filer => $filer,
                                        share => $share, path => $path,
                                        caching => $caching);

    $msg = verify_caching_button(window     => $win,
                                 filer      => $filer,
                                 share      => $share,
                                 share_attr => $share_attr);

    $msg = change_caching_option(window  => $win,
                                 filer   => $filer,
                                 share   => $share,
                                 caching => $share_attr);

    $ret = share_exists(window => $win, filer => $filer,
                        share => $share);

    $ret = mmc_cifs_sessions(window => $win, filer => $filer);

    $ret = mmc_browse_files(window => $win, filer  => $filer);

    $ret = mmc_local_users(window => $win, filer  => $filer);

    @groups = mmc_local_groups(window => $win, filer  => $filer);

    $ret = mmc_add_local_user(window => $win, filer => $filer,
                              user => $user, passwd => $pass);

    $ret = mmc_close_open_files(window => $win, filer => $filer,
                                file => $file);

    $ret = mmc_close_cifs_sessions(window => $win, filer => $filer,
                                   user => $user);

    @list = mmc_share_properties(window => $win, filer => $filer,
                                 share => $share);

    $hwnd = create_files(file_name  => $file,
                         file_ext   => $file_extension,
                         file_path  => $file_path
                         close_file => 1);

    $hwnd = edit_file(file_name  => $file,
                      file_ext   => $file_extension,
                      file_path  => $file_path
                      edit_text  => 1,
                      close_file => 1);

    $hwnd = edit_file_expect_prompt(file_name  => $file,
                                    file_ext   => $file_extension,
                                    file_path  => $file_path
                                    close_file => 0);

    $hwnd = edit_file_answer_prompt(handle     => $hwnd,
                                    file_name  => $file,
                                    file_ext   => $file_extension,
                                    file_path  => $file_path
                                    close_file => 0);

    $hwnd = edit_file_already_open(handle     => $hwnd,
                                   close_file => 0);

    $win = open_my_computer();

    close_my_computer(window => $win);

    $ret = make_available_offline(whnd     => $win,
                                  filer_ip => $filer_ip,
                                  share    => $share,
                                  drive    => $drive,
                                  option   => 'yes');

    $ret = check_available_offline(whnd     => $win,
                                   filer_ip => $filer_ip,
                                   share    => $share,
                                   drive    => $drive);

    $whnd = vdthrash(filer => $filer, share => $share);

    vdthrash_close();

    $ret = encryption_support(filer_ip => $filer_ip,
                              share    => $share,
                              drive    => $drive,
                              file     => $file,
                              whnd     => $whnd);

    $ret = advanced_button(filer_ip => $ip, share => $share,
                           drive => $drive, whnd => $whnd);

    $ret = view_files(filer_ip => $filer_ip,
                      share    => $share,
                      drive    => $drive,
                      whnd     => $whnd);

    $ret = delete_offline_files(filer_ip => $ip, share => $share,
                                drive => $drive, whnd => $whnd);

    $ret = offline_shortcut(whnd => $whnd);

    $ret = sync_via_tools(filer_ip => $filer_ip,
                          share    => $share,
                          drive    => $drive,
                          whnd     => $whnd);

    $ret = select_listview_item(whnd     => $win,
                                target   => $target,
                                item     => $item,
                                wnd_text => $text);

    $ret = sync_folder(filer_ip => $filer_ip,
                       share    => $share,
                       drive    => $drive,
                       whnd     => $whnd);

    $ret = manual_sync(filer_ip => $filer_ip,
                       share    => $share,
                       drive    => $drive,
                       file     => $file,
                       whnd     => $whnd);

    sync_via_my_network(filer    => $filer,
                        filer_ip => $filer_ip,
                        share    => $share,
                        drive    => $drive,
                        whnd     => $whnd);

    $ret = folder_avail_offline(whnd     => $win,
                                filer_ip => $filer_ip,
                                share    => $share,
                                folder   => $folder,
                                drive    => $drive,
                                option   => 'yes');

    $ret = folder_properties(whnd     => $whnd,
                             target   => $target,
                             item     => $item,
                             drive    => $drive,
                             action   => $action);

    $drive = explorer_map_drive(window => $hwnd,
                                filer  => $filer,
                                share  => $share,
                                user   => $user,
                                pass   => $pass);

    $ret = explorer_unmap_drive(window => $hwnd,
                                filer  => $filer,
                                share  => $share,
                                drive  => $drive);

=head1 DESCRIPTION

Provides the common routines for GUI manipulation of Windows computers.

This library invokes PERL GUI test routines which do not work
correctly if somebody else is using the console graphical interface.

This library invokes PERL GUI test routines which do not work if
the screen saver is enabled and running on the minwin client. Users of
this routine should use the screen_lock routine to test and see if
the screen saver was enabled and to also disable the screen saver.

In general routines in this library should not croak but should
return errors. This allows the caller to cleanup the windows
they know they have open.

=head1 STATUS

    Shared

=head1 AUTHOR

    dl-maryv (FSS Protocols QA)
    $Id: //depot/prod/test/Rsierranevada/lib/CIFS/Utils_gui.pm#1 $
    Last revised $Date: 2013/01/22 $

=head1 COPYRIGHT

    Copyright 2006, Network Appliance Inc., All Rights Reserved.

=head1 ROUTINES

=cut

package CIFS::Utils_gui;

use strict;
use warnings;
use base qw(Exporter);
use Tharn qw(host logcomment logresult);
use Carp qw(croak);
use Win32::GuiTest qw(FindWindowLike SendKeys WaitWindow GetChildWindows
                      TabCtrl_SetCurFocus WMGetText GetClassName MouseClick
                      PushChildButton SetFocus WMSetText GetListViewContents
                      GetTreeViewSelPath SelTreeViewItemPath GetWindowText
                      CheckButton GetForegroundWindow SelListViewItemText
                      SendMouse IsListViewItemSel GetDesktopWindow
                      SetActiveWindow TabCtrl_SetCurSel GetWindowID
                      SetForegroundWindow IsCheckedButton GetTabItems
                      IsWindowEnabled ShowWindow SW_MINIMIZE SW_RESTORE);
use SPARSE::Util::Logger;
use Params::Validate qw(validate SCALAR UNDEF);
use TestEnv::MinWin qw(minwin_compatible);
use POSIX qw(uname);

BEGIN {
    # Die with a script error when an
    # input parameter fails validation
    Params::Validate::validation_options(
        on_fail => sub { my @msgs = @_;
                         chomp(@msgs);
                         Carp::confess(Tharn::script_result(@msgs)) }
    );
};

#----------------------------------------------------------------------
# Global variables
#----------------------------------------------------------------------
our @EXPORT_OK = qw(
    screen_lock
    get_property_window
    check_tab_present
    find_target_explorer
    verify_previous_version_tab
    close_window
    close_properties_window
    explorer_open_with_target
    previous_version_text_get
    previous_version_copy_get
    previous_version_restore_get
    filer_default_webpage_open
    filerview_open
    app_window_close
    filerview_cifs_config
    filerview_hosts_config
    filer_web_man_verify
    save_win_as_bmpfile
    open_mmc
    close_mmc
    verify_caching_button
    add_share_xp
    delete_share
    verify_share_path_and_option
    change_caching_option
    mmc_cifs_sessions
    mmc_close_cifs_sessions
    mmc_browse_files
    mmc_local_users
    mmc_local_groups
    mmc_add_local_user
    mmc_close_open_files
    mmc_share_properties
    mmc_add_to_local_group
    open_my_computer
    close_my_computer
    make_available_offline
    check_available_offline
    create_files
    edit_file
    edit_file_expect_prompt
    edit_file_answer_prompt
    edit_file_already_open
    sync_folder
    manual_sync
    view_files
    encryption_support
    delete_offline_files
    offline_shortcut
    sync_via_tools
    advanced_button
    sync_via_my_network
    vdthrash
    vdthrash_close
    share_exists
    folder_avail_offline
    folder_properties
    explorer_map_drive
    explorer_unmap_drive
    testme
);

#----------------------------------------------------------------------
# Package global variables
#----------------------------------------------------------------------
our $VERSION = '1.0';

# Number of seconds to wait after a sendkey. Use a conservative
# value as things will take longer on slower computers.
my $sleeptime = 4;

# Number of seconds to wait for a wizards next window to redraw
my $wizard_sleep = 15;

# Number of seconds to wait for a wizard to do a commit
my $wizard_commit_sleep = 180;

# Number to ensure window dump files have unique file names
my $bmp_dump_cnt = 1;

my $compmgmt = 'Computer Management';
my $exec_mmc = 'mmc.exe C:\WINDOWS\system32\compmgmt.msc|';
my $share_wizard = 'Create A Shared Folder Wizard';
my $offline_wizard = 'Offline Files Wizard';
my $sync_window = 'Synchronization Complete';
my $confirm_offline_subfolders = 'Confirm Offline Subfolders';
my $remove_offline_folders = 'Remove Offline Folders';
my $offline_files = 'Offline Files';
my $office_path = '';
my $word_pgm;
my $excel_pgm;
my $ppt_pgm;
my $note_pgm = 'notepad.exe|';
my $vdthrash = 'X:\bin\vdthrash.exe';

#---------------------------------------------------------------------
# Windows XP button text
#---------------------------------------------------------------------
my $enable_caching = '&Allow caching of files in this shared folder';
my $document_caching = 'Automatic caching of documents';
my $program_caching = 'Automatic caching of programs and documents';
my $manual_caching = 'Manual caching of documents';

#---------------------------------------------------------------------
# Test data to write to test files
#---------------------------------------------------------------------
my $test_data = "This is some test data to write to WORD documents and TXT ".
                "files. This text is used on Client Side Caching test ".
                "scripts. All test scripts that need to create, edit ".
                "Microsoft Office files can use this test data.";

my $edit_data = "Testing 2, some more test data to add to test file";

#----------------------------------------------------------------------
# Function prototypes
#----------------------------------------------------------------------
sub screen_lock(%);
sub get_my_computer_name();
sub get_office_path();
sub _wait_window_by_name(%);
sub get_property_window(%);
sub check_tab_present(%);
sub find_target_explorer(%);
sub verify_previous_version_tab(%);
sub close_window(%);
sub close_properties_window(%);
sub explorer_open_with_target(%);
sub previous_version_text_get(%);
sub previous_version_copy_get(%);
sub previous_version_restore_get(%);
sub filer_default_webpage_open(%);
sub filerview_open(%);
sub app_window_close();
sub _reset_filerview_window();
sub _check_filerview_error();
sub filerview_cifs_config(%);
sub filerview_hosts_config(%);
sub filer_web_man_verify(%);
sub save_win_as_bmpfile(%);
sub open_mmc(%);
sub close_mmc(%);
sub verify_caching_button(%);
sub add_share_xp(%);
sub delete_share(%);
sub verify_share_path_and_option(%);
sub change_caching_option(%);
sub mmc_cifs_sessions(%);
sub mmc_close_cifs_sessions(%);
sub mmc_browse_files(%);
sub mmc_local_users(%);
sub mmc_local_groups(%);
sub mmc_add_local_user(%);
sub mmc_close_open_files(%);
sub mmc_share_properties(%);
sub mmc_add_to_local_group(%);
sub open_my_computer();
sub close_my_computer(%);
sub make_available_offline(%);
sub check_available_offline(%);
sub create_files(%);
sub edit_file(%);
sub edit_file_expect_prompt(%);
sub edit_file_answer_prompt(%);
sub edit_file_already_open(%);
sub encryption_support(%);
sub delete_offline_files(%);
sub offline_shortcut(%);
sub advanced_button(%);
sub view_files(%);
sub sync_folder(%);
sub manual_sync(%);
sub sync_via_tools(%);
sub sync_via_my_network(%);
sub vdthrash(%);
sub vdthrash_close();
sub select_listview_item(%);
sub share_exists(%);
sub folder_avail_offline(%);
sub folder_properties(%);
sub _folder_redirect(%);
sub _folder_restore(%);
sub _access_denied_popup(%);
sub explorer_map_drive(%);
sub explorer_unmap_drive(%);
sub testme();

#----------------------------------------------------------------------

=head2 screen_lock

screen_lock(setting => 'on');

Enables or disables the screen saver registry key if the
enable option is passed in. It will return the current value
of the screen saver registry key. If enable is set to 'no'
and the screen saver is on then setting the registry key
will not kill the screen saver process.

Note that this routine will iterate over all users in
HKEY_USERS so if one or more users have the screen saver
turned on then it will return on. When setting the registry
key it will croak if it cannot set the default users key.

=over

=item Arguments

=over

=item croak_if_on

(Optional): If the screen lock was on and this flag is set
to yes then croak will be called terminating the test.
Value is either 'yes' or 'no'.

=item setting

(Required): The screen lock setting that will be set in
the registry. Value is either 'on' or 'off'.

=back

=back

=for html <hr />

=cut

#----------------------------------------------------------------------

sub screen_lock ( % ) {
    my %opts = validate(
        @_,
        {
            croak_if_on => { type => SCALAR, default => 'no',
                             regex => qr/^(no|yes)$/ },
            setting     => { type => SCALAR,
                             regex => qr/^(on|off)$/ },
        }
    );
    my ($cc, $hkey, $key, @key_list, $value, %values);
    my $keyname = "ScreenSaveActive";

    require Win32::Registry;

    $cc = 0;
    $::HKEY_USERS->GetKeys(\@key_list);
    foreach $key (@key_list) {
        if ($::HKEY_USERS->Open("$key\\Control Panel\\Desktop", $hkey)) {
            # Get the current value of the key
            $hkey->GetValues(\%values);
            if (defined($values{$keyname})) {
                # If the settings option is set then set the value on the
                # registry key.
                if (defined($opts{setting})) {
                    # 0 - disable, 1 - enable
                    $value = 0;
                    if ($opts{setting} eq 'on') {
                        $value = 1;
                    }
                    $hkey->SetValueEx($keyname, undef, $values{$keyname}->[1],
                                      $value);
                }

                # Set the call croak flag if the screen saver is turned on.
                if ($values{$keyname}->[2] == 1) {
                    $cc = 1;
                }

            }
            $hkey->Close();
        } else {
            # Change only user keys that exist and we have permission to change
            if ($key =~ /default/i) {
                croak("screen_lock: failed to get registry key for user $key");
            }
        }
    }
    if ($cc == 1 && $opts{croak_if_on} eq 'yes') {
        croak("screen_lock: minwin CLIENT had screen lock enabled but " .
              "screen lock might be running which will fail any tests " .
              "of GUIs. Screen lock has been disabled via the " .
              "registry. You need to verify screen lock is not currently " .
              "running on the display, if it is manually log in on console " .
              "to stop screen saver from running and then re-run the test.");
    }

    return;
}

#----------------------------------------------------------------------

=head2 get_my_computer_name

get_my_computer_name();

Returns the name of the My Computer icon. If it cannot be determined then
'My Computer' will be returned. The routine looks in the registry for
the name of the icon.

=for html <hr />

=cut

#----------------------------------------------------------------------

sub get_my_computer_name ( ) {
    my ($hkey, $key, @key_list, $value, %values);

    require Win32::Registry;

    $::HKEY_USERS->GetKeys(\@key_list);
    foreach $key (@key_list) {
        if ($::HKEY_USERS->Open("$key\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\CLSID\\{20D04FE0-3AEA-1069-A2D8-08002B30309D}", $hkey)) {
            # Get the current value of the key
            $hkey->GetValues(\%values);
            $hkey->Close();
            if (defined($values{''}[2])) {
                return $values{''}[2];
            }
        }
    }

    return 'My Computer'
}

#----------------------------------------------------------------------

=head2 get_office_path

get_office_path()

Sets the global variable that holds the path to the Microsoft Office
directory if it can determine the path. If the path is already set
then just return.

=for html <hr />

=cut

#----------------------------------------------------------------------

sub get_office_path ( ) {
    my (@dirs);
    my $path = 'C:\Program Files\Microsoft Office';

    if ($office_path eq '' && opendir(DIR, $path)) {
        @dirs = readdir DIR;
        closedir DIR;
        foreach (@dirs) {
            if (/^Office\d+/i) {
                $office_path = "$path\\$_\\";
                last;
            }
        }
    }
    $word_pgm = $office_path . 'winword.exe|';
    $excel_pgm = $office_path . 'excel.exe|';
    $ppt_pgm = $office_path . 'powerpnt.exe|';
}

#----------------------------------------------------------------------
#
# _wait_window_by_name (Internal use only subroutine)
#
# $win = _wait_window_by_name(name => $text, timeout => 30);
#
# description
#
# Waits for the window that has the regex expression in the name
# parameter to appear. It checks every 2 seconds to see if the
# window has appeared. It will wait for a maximum of timeout seconds.
#
# The following named arguments are accepted:
#
# name
#
# (Required) : the regex expression for the name in the title of
# the window.
#
# not_window
#
# (Optional) : do not return this window handle. Typically used when
# more than one window with the same title is open.
#
# timeout
#
# (Optional) : total amount of seconds to wait. Default is 30.
#
# Returns
#
# Handle to window waited for or undef if not found
#
#----------------------------------------------------------------------

sub _wait_window_by_name( % ) {
    my %opts = validate(
        @_,
        {
            name       => { type => SCALAR },
            not_window => { type => SCALAR, optional => 1 },
            timeout    => { type => SCALAR, regex => qr/^\d+$/, default => 30 },
        }
    );
    my ($i, $sleeptime, $text, $timeleft, $window, @wnds);

    $sleeptime = 2;
    $timeleft = $opts{timeout};
    while ($timeleft > 0) {
        # Wait for the specified window to appear and then return the
        # window handle for it.
        WaitWindow($opts{name}, $sleeptime);
        @wnds = FindWindowLike(undef, $opts{name}, undef);
        foreach $i (@wnds) {
            $text = WMGetText($i);
            if ($text =~ /$opts{name}/ &&
                (!defined($opts{not_window}) || $i != $opts{not_window})) {
                    $window = $i;
                    $timeleft = 0;
                    last;
            }
        }
        $timeleft -= $sleeptime;
    }
    return $window;
}

#----------------------------------------------------------------------

=head2 get_property_window

$win = get_property_window(target_text => $text, window => $win);

=head2 description

Enters the keystrokes to get the property window for whatever
is referenced in the passed in window handler. It will wait
for the property window to appear. It is smart enough to know
that some windows come up with file extensions in the window
title and others do not so it makes two attempts at finding
the right window.

The following named arguments are accepted:

=over

=item Arguments

=over

=item target_text

(Required) : part of the text that should appear in the property window
title.

=item window

(Required) : window handle that has item currently selected.

=back

=item Returns

Handle to the property window or undef if the window did not come up.

=back

=for html <hr />

=cut

#----------------------------------------------------------------------

sub get_property_window( % ) {
    my %opts = validate(
        @_,
        {
            target_text => { type => SCALAR },
            window      => { type => SCALAR },
        }
    );
    my ($text, $window);

    # Bring up the properties window for the passed in window
    SetForegroundWindow($opts{window});
    SendKeys("%f");
    sleep($sleeptime);
    SendKeys("r");

    # Some versions of Windows will strip off any extensions that it
    # knows about when using the filename in a window title others do not.
    # (XP, W2000 strip off extension, W2003 does not).
    # First try with the name passed in and if that doesn't work then
    # strip off the extension and try again.
    $window = _wait_window_by_name(name => "$opts{target_text} Properties");
    if (!defined($window)) {
        $text = $opts{target_text};
        $text =~ s/\..*$//;
        if ($text ne $opts{target_text}) {
            $window = _wait_window_by_name(name => "$text Properties");
        }
    }
    return $window
}

#----------------------------------------------------------------------

=head2 check_tab_present

$win = check_tab_present(target_text => $text, window => $win);

=head2 description

Returns a handle to the tab control and the index of the tab that has
the requested text on it. The tab index numbering scheme starts at 0.

The following named arguments are accepted:

=over

=item Arguments

=over

=item target_text

(Required) : part of the text that should appear in the tab.

=item window

(Required) : window handle that has tabs in it.

=back

=item Returns

Handle to the tab window or undef if the tab was not found. Also
returns the index of the tab.

=back

=for html <hr />

=cut

#----------------------------------------------------------------------

sub check_tab_present ( % ) {
    my %opts = validate(
        @_,
        {
            text   => { type => SCALAR },
            window => { type => SCALAR },
        }
    );
    my ($class, $i, $j, $k, $present, $prev_idx, @tabview, $tabwindow, @wnds,
        @wnds_fix);

    # Look at all the children of the window and find the one
    # with the tab identified by the text
    @wnds = GetChildWindows($opts{window});
    $present = 0;
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTabControl32)$/) {
            @tabview = GetTabItems($i);
            for ($j = 0; $j <= $#tabview; $j++) {
                # If the tabviews are returned but all empty strings
                # then this is a guitest bug when running on W2003/W2000
                # and another method has to be used to get the tab text.
                if ($tabview[$j] eq '') {
                    TabCtrl_SetCurFocus($i, $j);
                    $prev_idx = TabCtrl_SetCurSel($i, $j);
                    sleep(2 * $sleeptime);
                    if ($prev_idx != -1) {
                        @wnds_fix = GetChildWindows($opts{window});
                        foreach $k (@wnds_fix) {
                            my $text = WMGetText($k);
                            if ($text =~ /$opts{text}/i) {
                                $present = 1;
                                last;
                            }
                        }
                    }
                } elsif ($tabview[$j] =~ /$opts{text}/i) {
                    $present = 1;
                }
                if ($present == 1) {
                    $tabwindow = $i;
                    last;
                }
            }
        }
    }
    return ($tabwindow, $j);
}

#----------------------------------------------------------------------

=head2 find_target_explorer

find_target_explorer(target_text => $ttext, window => $win);

=head2 description

Passed a window containing the "My Computer" GUI, then selects
the item with the specified text from the "My Computer" GUI list.
It will strip off any file extension on the target_text.

The following named arguments are accepted:

=over

=item Arguments

=over

=item target_text

(Required) : string containing text of target to look for
in "My Computer"

=item window

(Required) : handle to window

=back

=item Returns

Error string, empty if there was no error.

=back

=for html <hr />

=cut

#----------------------------------------------------------------------

sub find_target_explorer ( % ) {
    my %opts = validate(
        @_,
        {
            target_text => { type => SCALAR },
            window      => { type => SCALAR },
        }
    );

    my ($i, $msg, $proptext, $prevproptext, $ttext, $window, @wnds, $window2);

    $ttext = $opts{target_text};

    # Strip off any file extension
    $ttext =~ s/\..*$//;

    $window = $opts{window};

    $proptext = '';
    do {
        $prevproptext = $proptext;
        $window2 = get_property_window(window => $opts{window},
                                       target_text => '');
        if (defined($window2)) {
            $proptext = GetWindowText($window2);
            close_properties_window(window => $window2);

            if ($proptext !~ /$ttext/) {
                SendKeys("{DOWN}");
                sleep($sleeptime);
            }
        } else {
            $msg = 'find_target_explorer: Cannot bring up property window';
            # Cause exit of loop
            $prevproptext = $proptext;
        }
    } while ($proptext !~ /$ttext/ && $prevproptext ne $proptext);

    if (!defined($msg) && $proptext !~ /$ttext/) {
        $msg = "find_target_explorer: Target $ttext not found in window";
    }
    return ($msg);
}

#----------------------------------------------------------------------

=head2 verify_previous_version_tab

%results = verify_previous_version_tab(target_text => $name, window => $win);

%results = (present => 1|0
            listed  => # of previous versions populated in the listbox
            window  => window handle if properties window was not closed)

The following named arguments are accepted:

=over

=item Arguments

=over

=item closewin

(Optional): Close properties window before exiting. Default is yes.
If set to no then caller is responsible for closing properties
window.

=item target_text

(Required): The text that should be in the properties window title.
Usually is the name of the file/folder.

=item window

(Required): handle to window containing selected object from
find_target_explorer

=back

=item Returns

Results hash indicating whether tab was present and number of previous versions
populated in the listbox. The hash also contains the properties window
handle if the closewin option was set to no.

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub verify_previous_version_tab ( % ) {
    my %opts = validate(
        @_,
        {
            closewin    => { type => SCALAR, regex => qr/^(yes|no)$/,
                             default => 'yes' },
            target_text => { type => SCALAR },
            window      => { type => SCALAR },
        }
    );

    my ($i, $idx, $listed, @listview, $present, $prev_idx, %resh, $tabwindow,
        $text, $window, @wnds);

    # Get the property window
    $window = get_property_window(window => $opts{window},
                                  target_text => $opts{target_text});
    if (!defined($window)) {
        $resh{"present"} = 0;
        $resh{"listed"} = 0;
        return %resh;
    }

    # Get the tab control and index for the Previous Version tab.
    ($tabwindow, $idx) = check_tab_present(window => $window,
                                           text => 'Previous Versions');

    # Select the Previous Version tab and get all the text
    $listed = 0;
    if (defined($tabwindow)) {
        $present = 1;
        TabCtrl_SetCurFocus($tabwindow, $idx);
        sleep(2 * $sleeptime);
        $prev_idx = TabCtrl_SetCurSel($tabwindow, $idx);
        if ($prev_idx != -1) {
            @wnds = GetChildWindows($window);
            foreach $i (@wnds) {
                @listview = GetListViewContents($i);
                $text = GetWindowText($i);
                if ($text =~ /^(Folder|File) versions$/) {
                    $listed = scalar(@listview);
                    last;
                }
            }
        }
    } else {
        $present = 0;
    }

    if ($opts{closewin} eq 'yes') {
        close_properties_window(window => $window);
    } else {
        SetForegroundWindow($window);
        SetActiveWindow($window);
        SetFocus($window);
        $resh{"window"} = $window;
    }

    $resh{"present"} = $present;
    $resh{"listed"} = $listed;

    return %resh;
}

#----------------------------------------------------------------------

=head2 close_window

close_window(window => $win);

Closes the window associated with the window handle passed in.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window

=item close_char

(Optional): character to indicate close on the menu. Default is 'c'.

=back

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub close_window ( % ) {
    my %opts = validate(
        @_,
        {
            close_char => { type => SCALAR, default => 'c' },
            window     => { type => SCALAR },
        }
    );

    SetForegroundWindow($opts{window});
    SetActiveWindow($opts{window});
    SetFocus($opts{window});
    SendKeys('%f');
    SendKeys("$opts{close_char}");
    sleep($sleeptime);
    return;
}

#----------------------------------------------------------------------

=head2 close_properties_window

close_properties_window(window => $win);

Closes the properties window associated with the window handle passed in.
This is accomplished by pushing the cancel button.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window

=back

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub close_properties_window( % ) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR | UNDEF },
        }
    );

    if (defined($opts{window})) {
        SetForegroundWindow($opts{window});
        PushChildButton($opts{window}, "Cancel");
        sleep($sleeptime);
    }
    return;
}

#----------------------------------------------------------------------

=head2 explorer_open_with_target

$win = explorer_open_with_target(target_text => $ttext);

Opens the indicated target on the "Explorer" GUI on the local
Windows computer.  This is used for finding the share with the
Previous Version Tab. The function returns a handle to the
explorer window opened.

The following named arguments are accepted:

=over

=item Arguments

=over

=item target_text

(Required): The target to open in explorer.

=back

=item Returns

Handle to window containing "Explorer" or undef if window could not
be opened.

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub explorer_open_with_target ( % ) {
    my %opts = validate(
        @_,
        {
            target_text => { type => SCALAR },
        }
    );

    my ($text, $ttext, $window);

    $ttext = $opts{target_text};

    # Move the mouse towards the upper lefthand side of the screen so the
    # windows are all visible if trying to watch the test
    SendMouse("{ABS32767,32767}");
    SendMouse("{LEFTCLICK}");
    sleep($sleeptime);

    # Note that explorer runs in the background
    open(PGM, "explorer $ttext|");

    # Get the last component of the path
    $ttext =~ s/^.*\\//g;

    # Some versions of Windows will strip off any extensions that it
    # knows about when using the filename in a window title others do not.
    # (XP, W2000 strip off extension, W2003 does not).
    # First try with the name passed in and if that doesn't work then
    # strip off the extension and try again.
    $window = _wait_window_by_name(name => $ttext, timeout => 120);
    if (!defined($window)) {
        $text = $ttext;
        $text =~ s/\..*$//;
        if ($text ne $ttext) {
            $window = _wait_window_by_name(name => $text);
        }
    }

    if (defined($window)) {
        SetForegroundWindow($window);

        SendKeys("%(v)");
        sleep($sleeptime);
        SendKeys("l");
        sleep($sleeptime);
        SendKeys("{DOWN}{UP}");
        sleep($sleeptime);
        SendKeys("{RIGHT}{LEFT}");
        sleep($sleeptime);
    } else {
        close(PGM);
    }
    return $window;
}

#----------------------------------------------------------------------

=head2 previous_version_text_get

@results = previous_version_text_get(version => $version);

@results = text from file's previous version or undef if file not found.

This function returns a list of the contents of the snapshot on the test file
containing the previous version. It assumes that the properties window
is already open and has the current focus. It is usually run after
verify_previous_version_tab with closewin set to no.

The following named arguments are accepted:

=over

=item Arguments

=over

=item version

(Required): The number of the previous version to get, where 0 is from the
most recent snapshot taken.

=back

=item Returns

Array containing text from file's previous version or undef.

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub previous_version_text_get ( % ) {
    my %opts = validate(
        @_,
        {
            version => { type => SCALAR, regex => qr/^\d+$/ },
        }
    );

    my ($i, @res, $retries, $window);
    my $filename = 'C:\vss_tmp'.$$.'.txt';
    unlink $filename;
    @res = ();

    for ($i = 0; $i<$opts{version}; $i++) {
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }
    SendKeys("%(v)");
    sleep($sleeptime * 4);
    SendKeys("%(f)");
    sleep($sleeptime);
    SendKeys("a");
    $window = _wait_window_by_name(name => 'Save As', timeout => 120);
    if (defined($window)) {
        SetForegroundWindow($window);
        sleep($sleeptime);
        PushChildButton($window, 'OK');
        sleep($sleeptime);
        SendKeys("%(n)");
        sleep($sleeptime);
        SendKeys("$filename");
        sleep($sleeptime);
        SendKeys("{ENTER}");

        # Wait for the file to appear
        $retries = 30;
        while (! -f $filename && $retries-- > 0) {
            sleep($sleeptime);
        }
        if (-f $filename) {
            open(INFILE, "<$filename");
            @res = <INFILE>;
            close(INFILE);
            unlink $filename;
        }
    }

    # Close the notepad window
    SendKeys("%(f)");
    sleep($sleeptime);
    SendKeys("x");
    sleep($sleeptime);

    return @res;
}

#----------------------------------------------------------------------

=head2 previous_version_copy_get

@results = previous_version_copy_get(test_file_name => $test_file_name,
                                     version        => $version);

@results = text from file's copied previous version or undef if file not
found.

This function returns a list of the contents of the snapshot on the test file
containing the copied previous version. It assumes that the properties window
is already open and has the current focus. It is usually run after
verify_previous_version_tab with closewin set to no.

The following named arguments are accepted:

=over

=item Arguments

=over

=item test_file_name

(Required): The test file name to copy from the Previous Version Tab.

=item version

(Required): The number of the Previous Version to copy, where 0 corresponds
to the most recent snapshot taken.

=back

=item Returns

Array containing text from file's copied previous version. An empty
array will be returned if the file could not be copied.

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub previous_version_copy_get ( % ) {
    my %opts = validate(
        @_,
        {
            test_file_name => { type => SCALAR },
            version        => { type => SCALAR, regex => qr/^\d+$/ }
        }
    );

    my ($i, @osrel, @res, $retries, $window);

    # Make sure the test file doesn't already exist
    my $filename = "C:\\$opts{test_file_name}";
    unlink $filename;

    @osrel = uname();
    @res = ();

    for ($i = 0; $i < $opts{version}; $i++) {
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    SendKeys("%(c)");

    $window = _wait_window_by_name(name => 'Copy Items', timeout => 90);
    if (defined($window)) {
        sleep($sleeptime * 4);

        if ($osrel[2] eq '5.0') {
            SendKeys("+{TAB}");
        } else {
            SendKeys("+{TAB 2}");
        }
        sleep($sleeptime);
        SendKeys("{UP 20}");
        sleep(2 * $sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        # Send 'L' for Local Disk
        SendKeys("L");
        sleep($sleeptime);
        if ($osrel[2] eq '5.0') {
            SendKeys("{TAB}");
        } else {
            SendKeys("{TAB 2}");
        }
        sleep($sleeptime);
        SendKeys("{ENTER}");

        # Wait for the copy items window to go away to indicate that the
        # copy is done.
        $retries = 30;
        do {
            sleep($sleeptime);
            $window = _wait_window_by_name(name => 'Copy Items', timeout => 2);
        } while (defined($window) && $retries-- > 0);

        if (defined($window) && $retries == 0) {
            PushChildButton($window, "Cancel");
        }

        # Wait for the file to appear
        $retries = 30;
        while (! -f $filename && $retries-- > 0) {
            sleep($sleeptime);
        }
        if (-f $filename) {
            open(INFILE, "<$filename");
            @res = <INFILE>;
            close(INFILE);
            unlink $filename;
        }
    }
    return @res;
}

#----------------------------------------------------------------------

=head2 previous_version_restore_get

$res = previous_version_restore_get(version => $version);

This function restores the specified version of whatever the current
property Previous Version view is on.

The following named arguments are accepted:

=over

=item Arguments

=over

=item version

(Required): The Previous Version number to restore, where 0 corresponds to the
most recent snapshot taken.

=back

=item Returns

0 indicating restore was successful, 1 otherwise

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub previous_version_restore_get ( % ) {
    my %opts = validate(
        @_,
        {
            version     => { type => SCALAR, regex => qr/^\d+$/ },
        }
    );

    my ($i, $prop_window, $rc, @windows);

    $prop_window = GetForegroundWindow();

    $rc = 0;
    for ($i = 0; $i < $opts{version}; $i++) {
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }
    SendKeys("%(r)");
    sleep($sleeptime);
    SendKeys("y");
    sleep($sleeptime * 2);
    @windows = FindWindowLike(undef, 'Error Copying', '');
    foreach $i (@windows) {
        SetFocus($i);
        sleep($sleeptime);
        PushChildButton($i, 'OK');
        sleep($sleeptime);
        $rc = 1;
    }
    # Wait for copying window to go away
    do {
        @windows = FindWindowLike(undef, 'Copying\.\.\.', '');
        sleep($sleeptime);
    } while ($#windows >= 0);

    # Close the informational window
    @windows = FindWindowLike(0, '(Previous Versions|Shadow Copy Client)', '');
    foreach $i (@windows) {
        if ($i != $prop_window) {
            SetFocus($i);
            sleep($sleeptime);
            PushChildButton($i, 'OK');
            sleep($sleeptime);
        }
    }
    return ($rc);
}

#----------------------------------------------------------------------

=head2 filer_default_webpage_open

$whandle = filer_default_webpage_open(filer => $FILER);

Opens the default webpage for the filer. Filer_name is not a hostspec
but the name of the filer.

The following named arguments are accepted:

=over

=item Arguments

=over

=item filer

(Required): Hostspec of the filer to open the default web page from.

=back

=item Returns

Windows handle, undef if default web page could not be opened.

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub filer_default_webpage_open(%) {
    my %opts = validate(
        @_,
        {
            filer => { type => SCALAR },
        }
    );

    my ($filer_name, $host, $window);

    # Move the mouse towards the upper lefthand side of the screen so the
    # windows are all visible if trying to watch the test
    SendMouse("{ABS32767,32767}");
    SendMouse("{LEFTCLICK}");
    sleep($sleeptime);

    $host = host($opts{filer});
    $filer_name = $host->hostname();
    open(PGM, "explorer http://$filer_name/na_admin|");
    $window = _wait_window_by_name(name => "$filer_name: FilerView",
                                   timeout => 60);
    if (!defined($window)) {
        close(PGM);
    }
    return $window;
}

#----------------------------------------------------------------------

=head2 filer_open

$rc = filerview_open(filer => $FILER, window => $whandle);

Opens the filer view page from the filer.

The following named arguments are accepted:

=over

=item Arguments

=over

=item filer

(Required): Hostspec of the filer to open the default web page from.

=item window

(Required): Window handle for filer's default web page.

=back

=item Returns

0 Success, 1 if the filer view window could not be opened.

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub filerview_open(%) {
    my %opts = validate(
        @_,
        {
            filer  => { type => SCALAR },
            window => { type => SCALAR },
        }
    );

    my ($filer_name, $host, $login_window_name, @osrel, $rc, $window);
    $rc = 0;

    # Set the focus to the IE window and tab to the FilerView button
    # and press enter.
    SetFocus($opts{window});

    SendKeys("^{TAB}");
    sleep($sleeptime);
    SendKeys("{TAB 4}");
    sleep($sleeptime);
    SendKeys("{ENTER}");

    $host = host($opts{filer});
    $filer_name = $host->hostname();

    @osrel = uname();
    if ($osrel[2] eq '5.0') {
        $login_window_name = 'Enter Network Password';
    } else {
        $login_window_name = "Connect to $filer_name";
    }
    # Wait for the FilerView login window
    $window = _wait_window_by_name(name => $login_window_name, timeout => 30);
    if (defined($window)) {
        SendKeys("root");
        sleep($sleeptime);
        SendKeys("{TAB 3}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        # At this point there is no good way to wait for the Filer View
        # window since it has the same window handle as the IE window.
        # Just sleep and return.
        sleep(30);
    } else {
        $rc = 1;
    }
    return $rc;
}

#----------------------------------------------------------------------

=head2 app_window_close

app_window_close();

Closes the current application window open using ALT F4. Use this to
close the filer view window.

=for html <hr />

=cut
#----------------------------------------------------------------------

sub app_window_close() {
    SendKeys("%{F4}");
    sleep($sleeptime);
    return;
}

#----------------------------------------------------------------------
#
# _reset_filerview_window() (Internal use only subroutine)
#
# Reset the filerview window so that it looks just like it did when
# filerview was first started.
#----------------------------------------------------------------------

sub _reset_filerview_window() {
    my (@osrel);

    SendKeys("{F5}");
    sleep(3 * $sleeptime);

    # On Windows 2000 after doing an F5 (reset FilerView window) the
    # current window position is on the frame that holds the tree and
    # not the most top left object. Therefore backtab 5 to get to where
    # we expect to be when first in the FilerView window.
    @osrel = uname();
    if ($osrel[2] eq '5.0') {
        SendKeys("+{TAB 5}");
        sleep($sleeptime);
    }
    return;
}

#----------------------------------------------------------------------
#
# _check_filerview_error() (Internal use only subroutine)
#
# Check if the filer JAVA program died and if so save the window for
# debugging purposes. Returns undef on success or an error message.
#-----------------------------------------------------------------------

sub _check_filerview_error() {
    my ($fname, $i, $msg, @wnds);

    # Make sure the Host Name Resolution Policy Wizard window went away
    @wnds = FindWindowLike(undef, 'Internal server error', '');
    $msg = '';
    foreach $i (@wnds) {
        $fname = save_win_as_bmpfile(window => $i);
        app_window_close();
        $msg .= "Filerview died. Error window image in $fname";
    }
    undef $msg if ($msg eq '');
    return ($msg);
}

#----------------------------------------------------------------------

=head2 filerview_cifs_config

$msg = filerview_cifs_config(domain => $CIFS_DOMAIN,
                             domain_admin => $CIFS_DOMAIN_ADMIN,
                             domain_admin_passwd => $CIFS_DOMAIN_ADMIN_PASSWD);

Run the filerview CIFS configuration wizard. Note that PERL GuiTest
cannot seem to see inside the filerview window so all that can
be done is to tab around to make things happen and check window
title bars. This is not a robust approach as the code can break
if the contents of the filerview window changes. Assuming that
the filer has been configured to use Active Directory, otherwise
this won't work.

The following named arguments are accepted:

=over

=item Arguments

=over

=item domain

(Required): Active directory domain to specify in the CIFS Setup Wizard.

=item domain_admin

(Required): domain administrator name that has permissions to add the filer
to the domain.

=item domain_admin_passwd

(Required): password for the domain administrator.

=item security

(Optional): Used to define the default security mode to use in
the CIFS Setup Wizard.

=back

=item Returns

undef for success, or an error message on failure

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub filerview_cifs_config(%) {
    my %opts = validate(
        @_,
        {
            domain              => { type => SCALAR },
            domain_admin        => { type => SCALAR },
            domain_admin_passwd => { type => SCALAR },
            security            => { type => SCALAR, optional => 1,
                                     regex => qr/^(multi|ntfs)$/ },
        }
    );
    my ($msg, @osrel, $window, @windows);

    @osrel = uname();

    # Launch CIFS Configuration Wizard
    SendKeys("{TAB 29}");
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");
    sleep($wizard_sleep);
    if ($osrel[2] eq '5.0') {
        SendKeys("{TAB 28}");
    } else {
        SendKeys("{TAB 33}");
    }
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");
    sleep($wizard_sleep);
    if ($osrel[2] eq '5.0') {
        SendKeys("{TAB 30}");
    } else {
        SendKeys("{TAB 35}");
    }
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");

    $msg = _check_filerview_error();
    return ($msg) if (defined($msg));

    # Wait for the CIFS setup wizard
    $window = _wait_window_by_name(name => "CIFS Setup Wizard", timeout => 30);
    if (defined($window)) {
        # Step through Configuration Wizard
        SendKeys("{TAB 2}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Filer Name
        SendKeys("{TAB 12}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Authentication - Assuming Windows 2000 is already selected
        SendKeys("{TAB 5}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Domain
        SendKeys("{TAB}");
        sleep($sleeptime);
        if (defined($opts{domain})) {
            SendKeys($opts{domain});
        }
        sleep($sleeptime);
        SendKeys("{TAB 2}");
        sleep($sleeptime);
        if (defined($opts{domain_admin})) {
            SendKeys($opts{domain_admin});
        }
        sleep($sleeptime);
        SendKeys("{TAB 2}");
        sleep($sleeptime);
        if (defined($opts{domain_admin_passwd})) {
            # Clear out previous password
            SendKeys("{DEL 32}");
            sleep($sleeptime);
            SendKeys($opts{domain_admin_passwd});
        }
        sleep($sleeptime);
        SendKeys("{TAB 4}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Security Style
        SendKeys("{TAB}");
        sleep($sleeptime);
        if (defined($opts{security})) {
            if ($opts{security} eq 'ntfs') {
                # Select NTFS
                SendKeys("{DOWN}");
            } else {
                # Select Multi-protocol
                SendKeys("{UP}");
            }
        }
        sleep($sleeptime);
        SendKeys("{TAB 4}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Commit CIFS Setup changes
        SendKeys("{TAB 4}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        # Long sleep time because there is no good way to check
        # that it is done. (perhaps poll the filer?)
        sleep($wizard_commit_sleep);

        # Close the CIFS Setup Wizard
        SendKeys("{TAB}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        $msg = _check_filerview_error();
        if (!defined($msg)) {
            # Make sure the CIFS Setup Wizard window went away
            @windows = FindWindowLike(undef, 'CIFS Setup Wizard', '');
            if ($#windows >= 0) {
                app_window_close();
                $msg = 'CIFS Setup Wizard commit failed';
            }
        }
    }
    _reset_filerview_window();
    return $msg;
}

#----------------------------------------------------------------------

=head2 filerview_hosts_config

$msg = filerview_hosts_config(dns_domain => $domain, dns_srv_ip_addr => $ip);

Run the filerview Host Name Resolution Policy Wizard. Note that PERL GuiTest
cannot seem to see inside the filerview window so all that can
be done is to tab around to make things happen and check window
title bars. This is not a robust approach as the code can break
if the contents of the filerview window changes.

The following named arguments are accepted:

=over

=item Arguments

=over

=item again

(Optional): If the again option is set then that means the CIFS configuration
window was previously up so it is currently selected on the filerview
window and all we need to do is push ENTER to bring up the CIFS
configuration wizard.

=item dns_domain

(Required): The DNS domain name to set on the filer.

=item dns_srv_ip_addr

(Optional): The IP address of the DNS server. This will be set on the filer.

=back

=item Returns

undef for success, or an error message on failure

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub filerview_hosts_config(%) {
    my %opts = validate(
        @_,
        {
            dns_domain      => { type => SCALAR },
            dns_srv_ip_addr => { type => SCALAR },
        }
    );
    my ($msg, $window, @windows);

    # Launch HOST NAME Resolution Wizard
    SendKeys("{TAB 38}");
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");
    sleep($sleeptime);
    SendKeys("{TAB 46}");
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");
    sleep($wizard_sleep);

    $msg = _check_filerview_error();
    return ($msg) if (defined($msg));

    # Wait for the Host Name Resolution Policy wizard
    $window = _wait_window_by_name(name => "Host Name Resolution Policy Wizard",
                                   timeout => 30);
    if (defined($window)) {
        SendKeys("{TAB 2}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Enable DNS
        SendKeys("{TAB 1}");
        sleep($sleeptime);
        SendKeys("{SPACEBAR}");
        sleep($sleeptime);
        SendKeys("{TAB 6}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Set the DNS Name
        SendKeys("{TAB 1}");
        sleep($sleeptime);
        SendKeys("$opts{dns_domain}");
        sleep($sleeptime);
        SendKeys("{TAB 11}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Set the DNS Server IP Address
        SendKeys("{TAB 1}");
        sleep($sleeptime);
        SendKeys("$opts{dns_srv_ip_addr}");
        sleep($sleeptime);
        SendKeys("{TAB 10}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Set the NIS Server Parameters
        SendKeys("{TAB 13}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        ## @step Set the NIS Group Parameters
        logStep("Set the NIS Group Parameters");
        SendKeys("{TAB 4}");
        sleep($sleeptime);
        SendKeys("{DOWN 22}");
        sleep(2 * $sleeptime);
        SendKeys("{TAB 4}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Set the Name Service Configuration
        SendKeys("{TAB 21}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        # Commit changes
        SendKeys("{TAB 4}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        # Long sleep time because there is no good way to check
        # that it is done. (perhaps poll the filer?)
        sleep($wizard_commit_sleep);

        # Close the Wizard
        SendKeys("{TAB}");
        sleep($sleeptime);
        SendKeys("{ENTER}");
        sleep($wizard_sleep);

        $msg = _check_filerview_error();
        if (!defined($msg)) {
            # Make sure the Host Name Resolution Policy Wizard window went away
            @windows = FindWindowLike(undef,
                                      'Host Name Resolution Policy Wizard', '');
            if ($#windows >= 0) {
                app_window_close();
                $msg = 'filerview_hosts_config: Host Name Resolution Policy ' .
                       'Wizard commit failed';
            }
        }
    } else {
        $msg = 'filerview_hosts_config: Timeout waiting for HOST NAME ' .
               'Resolution Policy Wizard';
    }
    _reset_filerview_window();
    return $msg;
}

#----------------------------------------------------------------------

=head2 filer_web_man_verify

$msg = filer_web_man_verify(window => $whandle);

Verifies that one of the CIFS man pages is accessible through
the web interface.

The following named arguments are accepted:

=over

=item Arguments

=over

=item window

(Required): window handle of the filer's default web page

=back

=item Returns

undef for success, or an error message on failure

=back

=for html <hr />

=cut
#-----------------------------------------------------------------------

sub filer_web_man_verify(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
        }
    );
    my ($msg, $window1, $window2);

    # Set focus on the default Filer web page
    SetFocus($opts{window});

    # Access html man pages
    SendKeys("^{TAB}");
    sleep($sleeptime);
    SendKeys("{TAB 8}");
    sleep(2 * $sleeptime);
    SendKeys("{ENTER}");

    # Wait for the Data ONTAP manual pages
    $window1 = _wait_window_by_name(name => "Data ONTAP Manual Pages",
                                    timeout => 30);
    if (defined($window1)) {
        # Reload html man page
        SendKeys("{F5}");
        sleep(3 * $sleeptime);

        # Navigate html man page
        SendKeys("^{TAB}");
        sleep($sleeptime);
        SendKeys("{TAB 26}");
        sleep(2 * $sleeptime);
        SendKeys("{ENTER}");
        $window2 = _wait_window_by_name(name => "na_cifs_access",
                                        timeout => 30);
        if (defined($window2)) {
            # Reload man page
            SendKeys("{F5}");
            sleep(3 * $sleeptime);
            $window2 = _wait_window_by_name(name => "na_cifs_access",
                                            timeout => 30);
            app_window_close();
            if (!defined($window2)) {
                $msg = 'Could not refresh na_cifs_access man page window';
            }
        } else {
            app_window_close();
            $msg = 'Could not bring up na_cifs_access man page window';
        }
    } else {
        app_window_close();
        $msg = 'Could not bring up Data ONTAP Manual Pages window';
    }
    return $msg;
}

#----------------------------------------------------------------------

=head2 save_win_as_file

$fname = save_win_as_bmpfile(window => $whandle);

Saves the given window as a bmp file. Typically used to save
windows associated with failed operations for diagnostic
purposes.

The following named arguments are accepted:

=over

=item Arguments

=over

=item window

(Required): window handle of the window to save

=back

=item Returns

Name of file window image was saved in.

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub save_win_as_bmpfile(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
        }
    );
    my ($ds, $fname);

    $fname = "failed_window_$bmp_dump_cnt.bmp";
    if (defined($ENV{LOGDIR_WINDOWS})) {
        $fname = "$ENV{LOGDIR_WINDOWS}\\$fname";
    }
    $bmp_dump_cnt++;

    $ds = new Win32::GuiTest::DibSect;
    $ds->CopyWindow($opts{window});
    $ds->SaveAs($fname);
    return ($fname);
}

#--------------------------------------------------------------

=head2 open_mmc

$win = open_mmc(filer => $filer);

Opens the "MMC|Computer Management" GUI on the local Windows computer.
This is used in the CSC tests for adding, deleting, and changing caching
options for shares on the filer.

The following named arguments are accepted:

=over

=item Arguments

=over

=item filer

(Required) : name of filer to connect to.

=back

=item Returns

Handle to the "Computer Management" window that was opened.

=back

=for html <hr />

=cut

#----------------------------------------------------------------

sub open_mmc ( % ) {
    my %opts = validate(
        @_,
        {
            filer => { type => SCALAR },
        }
    );

    my ($counter, @windows, $i, $filer, $popup, $text, $wnd);

    $filer = $opts{filer};

    # Close any Computer Management windows that were already open
    @windows = FindWindowLike(undef, $compmgmt, '');
    foreach $i (@windows) {
        close_window(window => $i, close_char => 'x');
    }

    # Run MMC Computer Management
    open(PGM, $exec_mmc);

    # If the MMC was connected to a different computer last time then
    # it will try to reconnect to the same computer which may no longer
    # be on. We need a long timeout to wait for that case.
    $windows[0] = _wait_window_by_name(name => $compmgmt, timeout => 150);
    if ($windows[0]) {
        # MMC may pop-up a window to let us know that it couldn't
        # connect to the last computer so if there is more than one
        # window close out the popup.
        PushChildButton($windows[0], "OK");
        sleep($sleeptime);
    }

    # Get the next Computer Management window again
    $windows[0] = _wait_window_by_name(name => $compmgmt);
    if ($windows[0]) {
        # There is a bug in GuiTest library if another window is open
        # when MMC opens it will have focus and not MMC then the usual
        # SetForegroundWindow, SetActiveWindow, SetFocus routines do
        # not bring it to the foreground, in fact both window titles
        # are highlighted as if they are both selected. To workaround this
        # problem  minimize the MMC window and restore it and it will go
        # to the foreground.
        SetForegroundWindow($windows[0]);
        SetActiveWindow($windows[0]);
        SetFocus($windows[0]);
        $wnd = GetForegroundWindow();
        if ($wnd != $windows[0]) {
            ShowWindow($windows[0], SW_MINIMIZE);
            ShowWindow($windows[0], SW_RESTORE);
        }
        SetForegroundWindow($windows[0]);
        SetActiveWindow($windows[0]);
        SetFocus($windows[0]);

        # MMC remembers where it was the last time MMC was opened
        # so we need to start at the top of the tree on the MMCChildFrm
        # control. No other way to do this using Guitest, so where ever we
        # start on the MMCChildFrm we check the text and if it doesn't match
        # what we're looking for we move up one item till we find our match
        # or our counter reaches 30. If counter reaches 30, assume we never
        # found our match, so close MMC and let script report unable to
        # open MMC error. If we find our match, then we'll connect to another
        # computer.
        my @wnds = GetChildWindows($windows[0]);
        foreach my $i (@wnds) {
            my $class = GetClassName($i);
            my $text = GetWindowText($i);
            if ($class eq 'MMCChildFrm') {
                SetForegroundWindow($i);
                SetActiveWindow($i);
                SetFocus($i);

                $counter = 0;
                while ($text !~ /Computer Management \(.+\)$/ &&
                       $counter < 30) {

                    SendKeys("{UP}");
                    sleep($sleeptime);

                    # Handle popups
                    $popup = GetForegroundWindow();
                    if ($popup != $windows[0]) {
                        PushChildButton($popup, "OK");
                        sleep($sleeptime);
                    }

                    $text = GetWindowText($i);
                    $counter++;
                }
                last;
            }
        }

        if ($counter < 30) {
            SetForegroundWindow($windows[0]);
            sleep($sleeptime);
            SetActiveWindow($windows[0]);
            sleep($sleeptime);
            SetFocus($windows[0]);
            sleep($sleeptime);
            SendKeys("%a");
            sleep($sleeptime);
            SendKeys("c");
            sleep($sleeptime);

            SendKeys("$filer");
            sleep($sleeptime * 2);
            SendKeys("{TAB 2}");
            sleep($sleeptime);
            SendKeys("{ENTER}");
            sleep($sleeptime);

            # It can take a little while to connect to a new filer
            sleep(30);

            $popup = GetForegroundWindow();
            if ($popup != $windows[0]) {
                PushChildButton($popup, "OK");
                close_mmc(window => $windows[0]);
                close(PGM);
                $windows[0] = undef;
            }
        } else {
            close_mmc(window => $windows[0]);
            close(PGM);
            $windows[0] = undef;
        }
    } else {
        close(PGM);
    }
    if (!defined($windows[0])) {
        # Save image of desktop if this routine failed
        save_win_as_bmpfile(window => GetDesktopWindow());
    }
    return $windows[0];
}

#--------------------------------------------------------------

=head2 close_mmc

close_mmc(window => $window);

Passed a window handle to the MMC GUI, closes the window and
all of its children.

The following named arguments are accepted:

=over

=item Arguments

=over

=item window

(Required) : handle to MMC window.

=back

=back

=for html <hr />

=cut

#----------------------------------------------------------------

sub close_mmc(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
        }
    );

    my ($window, @windows, $i);

    $window = $opts{window};

    @windows = GetChildWindows($window);
    foreach $i (@windows) {
        # Anything to try to close the childs window
        PushChildButton($i, "Cancel");
        PushChildButton($i, "OK");
    }

    sleep($sleeptime);

    close_window(window => $window, close_char => 'x');

    @windows = FindWindowLike(undef, $compmgmt, '');

    foreach $i (@windows) {
        close_window(window => $i, close_char => 'x');
    }
    return;
}

#--------------------------------------------------------------

=head2 add_share_xp

add_share_xp(window  => $win,
             filer   => $filer,
             share   => $share,
             caching => $share_attr);

Passed a window handle to "MMC Computer Management" GUI.
Adds a share to the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window opened by
open_my_computer

=item filer

(Required): name of filer to add share to

=item share

(Required): name of share to add to filer

=item vol

(Required): name of filer volume

=item caching

(Optional): share caching attribute, defaults to manual caching

=back

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub add_share_xp (%) {
    my %opts = validate(
        @_,
        {
            window     => { type => SCALAR },
            filer      => { type => SCALAR },
            vol        => { type => SCALAR },
            share      => { type => SCALAR },
            desc       => { type => SCALAR | UNDEF, optional => 1 },
            security   => { type => SCALAR | UNDEF, optional => 1 },
            caching    => { type => SCALAR, default => 'manual',
                            regex => qr/^(manual|no|document|program)$/ },
        }
    );

    my($class, $text, $i, $filer, $whandle2, $security);
    my($share, $share_attr, $volume, @wnds, $treeview_path, $desc);
    my($path, $oldpath, $id, $found, @windows, $popup, @share_wizard);
    my($no_caching, $document_caching, $program_caching);
    my($sec_button1, $sec_button2, $sec_button3, $sec_button4, $custom_button);

    $filer      = uc($opts{filer});
    $windows[0] = $opts{window};
    $volume     = $opts{vol};
    $share      = $opts{share};
    $desc       = (defined($opts{desc})) ? $opts{desc} : '';
    $security   = (defined($opts{security})) ? $opts{security} : '1';
    $share_attr = $opts{caching};

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;

    SetForegroundWindow($windows[0]);
    sleep($sleeptime);
    SetActiveWindow($windows[0]);
    sleep($sleeptime);
    SetFocus($windows[0]);
    sleep($sleeptime);

    @wnds = GetChildWindows($windows[0]);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    $text = GetWindowText(GetForegroundWindow());
    if ($text =~ /Shared Folders/) {
        SendKeys("{ENTER}");
        return "Access denied, share $share not added";
    }

    # Add new share
    SendKeys("%a");
    sleep($sleeptime);
    SendKeys("{ENTER}");
    sleep($sleeptime * 2);

    @share_wizard = FindWindowLike(undef, $share_wizard, '');

    if ($share_wizard[0]) {
        SetForegroundWindow($share_wizard[0]);
        SetActiveWindow($share_wizard[0]);
        SetFocus($share_wizard[0]);
    } else {
        return "Create A Shared Folder Wizard not displayed";
    }

    # Share a Folder Wizard
    PushChildButton(GetForegroundWindow(), "&Next >");
    sleep($sleeptime);

    @wnds = GetChildWindows($share_wizard[0]);
    foreach $i (@wnds) {
        $id   = GetWindowID($i);
        $class = GetClassName($i);

        if ($id == 1001 && $class eq 'Edit') {
            WMSetText($i, $volume);
            sleep($sleeptime);
        }

        if ($id == 1002 && $class eq 'Edit') {
            WMSetText($i, $share);
            sleep($sleeptime);
        }

        if ($id == 1003 && $class eq 'Edit') {
            WMSetText($i, $desc);
            sleep($sleeptime);
        }
    }

    SendKeys("{ENTER}");
    sleep($sleeptime);

    @wnds = GetChildWindows($share_wizard[0]);
    foreach $i (@wnds) {
        $id   = GetWindowID($i);
        $class = GetClassName($i);

        if ($id == 1009 && $class eq 'Button') {
            $sec_button1 = $id;
        }

        if ($id == 1010 && $class eq 'Button') {
            $sec_button2 = $id;
        }

        if ($id == 1011 && $class eq 'Button') {
            $sec_button3 = $id;
        }

        if ($id == 1012 && $class eq 'Button') {
            $sec_button4 = $id;
        }

        if ($id == 1013 && $class eq 'Button') {
            $custom_button = $id;
        }
    }

    if ($security eq '2') {
        MouseClick($sec_button2, $share_wizard[0]);
    }
    elsif ($security eq '3') {
        MouseClick($sec_button3, $share_wizard[0]);
    }
    elsif ($security eq '4') {
        MouseClick($sec_button4, $share_wizard[0]);
        sleep($sleeptime);
        PushChildButton($share_wizard[0], "C&ustom...");
        sleep($sleeptime * 2);

        my @properties = FindWindowLike(undef, "Customize Permissions", '');
        if ($properties[0]) {
            PushChildButton($properties[0], "OK");
            sleep($sleeptime);
        }
        else {
            # Share a Folder Wizard
            PushChildButton(GetForegroundWindow(), "Cancel");
            sleep($sleeptime);

            SetForegroundWindow($windows[0]);
            sleep($sleeptime);
            SetActiveWindow($windows[0]);
            sleep($sleeptime);
            SetFocus($windows[0]);
            sleep($sleeptime);
            return;
        }
    }

    $whandle2 = GetForegroundWindow();
    PushChildButton($whandle2, "&Next >");
    sleep($sleeptime);

    SendKeys("{DOWN}");
    sleep($sleeptime);
    PushChildButton($whandle2, "Finish");
    sleep($sleeptime);
    SendKeys("{ENTER}");
    sleep($sleeptime);

    SetForegroundWindow($windows[0]);
    sleep($sleeptime);
    SetActiveWindow($windows[0]);
    sleep($sleeptime);
    SetFocus($windows[0]);
    sleep($sleeptime);

    return;
}

#--------------------------------------------------------------

=head2 delete_share

$ret = delete_share(window => $win,
                    filer  => $filer,
                    share  => $share);

Passed a window containing the "MMC Computer Management" GUI.
Deletes the share from the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window opened by
open_my_computer or explorer_open_with_target

=item filer

(Required): name of filer to delete share from

=item share

(Required): name of share to delete from filer

=back

=item Returns

Returns 1 if share deleted, otherwise 0 if not found in MMC listview.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub delete_share ( % ) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            share  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share, $ret_val);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});
    $share   = $opts{share};
    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        $ret_val = 1;
        SendKeys("%a");
        SendKeys("S");
        sleep($sleeptime);

        $whandle2 = GetForegroundWindow();
        sleep($sleeptime);
        SetFocus($whandle2);
        sleep($sleeptime);
        PushChildButton($whandle2, "Yes");
        sleep($sleeptime);
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 change_caching_option

$msg = change_caching_option(window  => $win,
                             filer   => $filer,
                             share   => $share,
                             caching => $share_attr);

Passed a window containing the "MMC Computer Management" GUI.
Changes the share caching option on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window opened by open_my_computer

=item filer

(Required): name of filer to change share caching option on

=item share

(Required): name of share on filer to change caching option on

=item caching

(Required): share caching attribute

=back

=item Returns

Returns a text message if some error or share not
found in listview.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub change_caching_option ( % ) {
    my %opts = validate(
        @_,
        {
            window     => { type => SCALAR },
            filer      => { type => SCALAR },
            share      => { type => SCALAR },
            caching    => { type => SCALAR,
                            regex =>
                              qr/^(manual|no|document|program)$/ },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share);
    my($found, @windows, @list, $class, $treeview_path);
    my($path, $id, $whandle3, $properties, $text, $caching);
    my($no_caching, $ret_msg);

    my($properties_whandle, @properties_wnds);

    my($share_attr, $volume, $no_hwnd, $combobox_id, $combo_text);

    $whandle    = $opts{window};
    $filer      = uc($opts{filer});
    $share      = $opts{share};
    $share_attr = $opts{caching};

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        SendKeys("%a");
        SendKeys("r");

        $properties = _wait_window_by_name(name => "$share Properties");
        $text = GetWindowText($properties);
        if ($text !~ /$share Properties/) {
            return "share properties window not opened";
        }

        PushChildButton($properties, "Cac&hing...");
        sleep($sleeptime);
        $caching = GetForegroundWindow();
        $text = WMGetText($caching);
        if ($text ne "Caching Settings") {
            PushChildButton($properties, "Cancel");
            sleep($sleeptime);
            return "caching setting window not opened";
        }

        @wnds = GetChildWindows($caching);
        foreach $i (@wnds) {
            $text = WMGetText($i);
            $id   = GetWindowID($i);
            $class = GetClassName($i);

            if ($text eq $enable_caching) {
                $no_caching = $id;
                $no_hwnd = $i;
            }

            if ($class eq 'ComboBox') {
                $combobox_id = $i;
                $combo_text = $text;
            }
        }

        if ($share_attr eq 'no') {
            if (IsCheckedButton($no_hwnd)) {
                MouseClick($no_caching , $caching);
            }
        } elsif ($share_attr eq 'manual') {
            if (!IsCheckedButton($no_hwnd)) {
                MouseClick($no_caching , $caching);
            }

            if ($combo_text =~ /$document_caching/) {
                SetFocus($combobox_id);
                SendKeys("{DOWN 2}");
            } elsif ($combo_text =~ /$program_caching/) {
                SetFocus($combobox_id);
                SendKeys("{DOWN 1}");
            }
        } elsif ($share_attr eq 'program') {
            if (!IsCheckedButton($no_hwnd)) {
                MouseClick($no_caching , $caching);
            }

            if ($combo_text =~ /$manual_caching/) {
                SetFocus($combobox_id);
                SendKeys("{UP 1}");
            } elsif ($combo_text =~ /$document_caching/) {
                SetFocus($combobox_id);
                SendKeys("{DOWN 1}");
            }
        } else {
            if (!IsCheckedButton($no_hwnd)) {
                MouseClick($no_caching , $caching);
            }

            if ($combo_text =~ /$manual_caching/) {
                SetFocus($combobox_id);
                SendKeys("{UP 2}");
            } elsif ($combo_text =~ /$program_caching/) {
                SetFocus($combobox_id);
                SendKeys("{UP 1}");
            }
        }

        sleep($sleeptime);
        PushChildButton($caching, "OK");
        sleep($sleeptime);

        PushChildButton($properties, "OK");
        sleep($sleeptime * 2);
    } else {
        $ret_msg = "share $share not found not found in listview";
    }
    return $ret_msg;
}

#--------------------------------------------------------------

=head2 share_exists

$ret = share_exists(window => $win, filer => $filer, share => $share);

Passed a window handle to "MMC Computer Management" GUI.
Checks if the the share is displayed on the MMC gui.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer where share exists

=item share

(Required): name of share to search for

=back

=item Returns

Returns 1 if share exists, otherwise 0 if not found in MMC listview.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub share_exists(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            share  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share, $ret_val);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});
    $share   = $opts{share};
    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        $ret_val = 1;
    }

    return $ret_val;
}

#--------------------------------------------------------------

=head2 verify_share_path_and_option

$msg = verify_share_path_and_option(window  => $win,
                                    filer   => $filer,
                                    share   => $share,
                                    path    => $path,
                                    caching => $caching);

Passed a window containing the "MMC Computer Management" GUI.
Verifies the share caching option on the filer is displayed on the MMC console.
Also verifies the share name and path is displayed on MMC.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window opened by open_mmc.

=item filer

(Required): filer where share exists.

=item share

(Required): name of share on filer to verify caching option for.

=item path

(Required): path where share on filer should exist.

=item caching

(Required): share caching attribute share should be set to.

=back

=item Returns

Returns a text message if some error or share path or
caching option not what expected.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub verify_share_path_and_option ( % ) {
    my %opts = validate(
        @_,
        {
            window     => { type => SCALAR },
            filer      => { type => SCALAR },
            share      => { type => SCALAR },
            path       => { type => SCALAR },
            caching    => { type => SCALAR,
                            regex => qr/^(manual|no|auto_document|auto_program)$/ },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share, $ret_val);
    my($found, @windows, @list, $class, $treeview_path);
    my($path, $id, $whandle3, $properties, $text, $caching);
    my($no_caching);
    my($properties_whandle, @properties);
    my($share_attr, $volume, $no_hwnd, $combobox_id, $combo_text);
    my($share_path, $share_found, $path_found, $share_caching);
    my($msg1, $msg2, $msg3, $msg4, $msg5, $msg6, $ret_msg);

    $whandle       = $opts{window};
    $filer         = uc($opts{filer});
    $share         = $opts{share};
    $share_caching = $opts{caching};
    $share_path    = $opts{path};

    $msg1 = "share $share properties window not opened";
    $msg2 = "share $share not visible with correct share name";
    $msg3 = "share $share not visible with correct path name";
    $msg4 = "share $share not $share_caching caching";
    $msg5 = "share $share not found in listview";
    $msg6 = "share $share caching setting window not opened";

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;
    $share_found = 0;
    $path_found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
                sleep($sleeptime);
                SendKeys("{DOWN}");
                sleep($sleeptime);
                SendKeys("{RIGHT}");
                sleep($sleeptime);
                SendKeys("{DOWN 2}");
                sleep($sleeptime);
                SendKeys("{RIGHT}");
                sleep($sleeptime);
                SendKeys("{DOWN}");
                sleep($sleeptime);
            }

            last;
        }
    }

    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        $ret_val = 1;
        SendKeys("%a");
        sleep($sleeptime);
        SendKeys("r");
        sleep($sleeptime * 2);

        @properties = FindWindowLike(undef, "$share Properties", '');
        if (!$properties[0]) {
            return $msg1;
        }

        $properties = GetForegroundWindow();
        @wnds = GetChildWindows($properties);
        foreach $i (@wnds) {
            $text = WMGetText($i);

            if ($text eq $share) {
                $share_found = 1;
            }

            if ($text eq $share_path) {
                $path_found = 1;
            }
        }

        if (!$share_found) {
            $ret_msg = $msg2;
        }

        if (!$path_found) {
            $ret_msg = $msg3;
        }

        if (!$ret_msg) {
            $whandle3 = GetForegroundWindow();
            PushChildButton($whandle3, "Cac&hing...");

            sleep($sleeptime * 2);
            $caching = GetForegroundWindow();
            $text = WMGetText($caching);
            if ($text ne "Caching Settings") {
                PushChildButton($properties, "Cancel");
                sleep($sleeptime);
                return $msg6;
            }

            @wnds = GetChildWindows($caching);
            foreach $i (@wnds) {
                $text = WMGetText($i);
                $id   = GetWindowID($i);
                $class = GetClassName($i);

                if ($text eq $enable_caching) {
                    $no_caching = $id;
                    $no_hwnd = $i;
                }

                if ($class eq 'ComboBox') {
                    $combobox_id = $i;
                    $combo_text = $text;
                }
            }

            if ($share_caching eq 'no') {
                if (IsCheckedButton($no_hwnd)) {
                    $ret_msg = $msg4;
                }
            } elsif ($share_caching eq 'manual') {
                if (!IsCheckedButton($no_hwnd)) {
                    $ret_msg = $msg4;
                }

                if ($combo_text !~ /$manual_caching/) {
                    $ret_msg = $msg4;
                }
            } elsif ($share_caching eq 'auto_program') {
                if (!IsCheckedButton($no_hwnd)) {
                    $ret_msg = $msg4;
                }

                if ($combo_text !~ /$program_caching/) {
                    $ret_msg = $msg4;
                }
            } else {
                if (!IsCheckedButton($no_hwnd)) {
                    $ret_msg = $msg4;
                }

                if ($combo_text ne $document_caching) {
                    $ret_msg = $msg4;
                }
            }
        }

        sleep($sleeptime);
        PushChildButton($caching, "Cancel");
        sleep($sleeptime);

        PushChildButton($properties, "Cancel");
        sleep($sleeptime * 2);
    } else {
        $ret_msg = $msg5;
    }
    return $ret_msg;
}

#--------------------------------------------------------------

=head2 verify_caching_button

$msg = verify_caching_button(window     => $win,
                             filer      => $filer,
                             share      => $share,
                             share_attr => $share_attr);

Passed a window containing the "MMC Computer Management" GUI.
Verifies the MMC caching button displays the correct caching option
for share on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window opened by
open_my_computer or explorer_open_with_target

=item filer

(Required): name of filer to add share to

=item share

(Required): name of share on filer to verify caching option for.

=item caching

(Required): share caching attribute of share on filer.

=back

=item Returns

Returns a text message if unsuccessful or caching option not what expected.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub verify_caching_button(%) {
    my %opts = validate(
        @_,
        {
            window     => { type => SCALAR },
            filer      => { type => SCALAR },
            share      => { type => SCALAR },
            caching    => { type => SCALAR,
                            regex => qr/^(manual|no|auto_document|auto_program)$/ },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share, $ret_val);
    my($found, @windows, @list, $class, $treeview_path);
    my($path, $id, $whandle3, $properties, $text, $caching);
    my($no_caching, $share_caching, $popup);
    my($properties_whandle, @properties_wnds);
    my($volume, $no_hwnd, $combobox_id, $combo_text);
    my($msg1, $msg2, $msg3, $msg4, $msg5, $msg6, $msg7, $ret_msg);
    my($no_cach, $manual_cach, $document_cach, $program_cach) = 0;

    $whandle       = $opts{window};
    $filer         = uc($opts{filer});
    $share         = $opts{share};
    $share_caching = $opts{caching};

    # Verify cach button return messages
    $msg1 = "caching option for $share not set to no_caching";
    $msg2 = "caching option for $share not set to manual_caching";
    $msg3 = "caching option for $share not set to program_caching";
    $msg4 = "caching option for $share not set to document_caching";
    $msg5 = 'share not found in listview';
    $msg6 = 'share properties window not opened';
    $msg7 = 'caching settings window not opened';

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        $ret_val = 1;
        SendKeys("%a");
        SendKeys("r");

        sleep($sleeptime * 3);
        $properties = GetForegroundWindow();
        $text = GetWindowText($properties);
        if ($text !~ /$share Properties/) {
            return $msg6;
        }

        $whandle3 = GetForegroundWindow();
        PushChildButton($whandle3, "Cac&hing...");

        sleep($sleeptime);
        $caching = GetForegroundWindow();
        $text = WMGetText($caching);
        if ($text ne "Caching Settings") {
            PushChildButton($properties, "Cancel");
            sleep($sleeptime);
            return $msg7;
        }

        @wnds = GetChildWindows($caching);
        foreach $i (@wnds) {
            $text = WMGetText($i);
            $id   = GetWindowID($i);
            $class = GetClassName($i);

            if ($text eq $enable_caching) {
                $no_caching = $id;
                $no_hwnd = $i;
                $no_cach = 1;
                $manual_cach = 1;
            }

            if ($class eq 'ComboBox') {
                $combobox_id = $i;
                $combo_text = $text;
            }
        }

        if ($share_caching eq 'no') {
            if (IsCheckedButton($no_hwnd)) {
                $ret_msg = $msg1;
            }
        } elsif ($share_caching eq 'manual') {
            if (!IsCheckedButton($no_hwnd)) {
                $ret_msg = $msg2;
            }

            if ($combo_text ne $manual_caching) {
                $ret_msg = $msg2;
            }
        } elsif ($share_caching eq 'auto_program') {
            if (!IsCheckedButton($no_hwnd)) {
                $ret_msg = $msg3;
            }

            if ($combo_text ne $program_caching) {
                $ret_msg = $msg3;
            }
        } else {
            if (!IsCheckedButton($no_hwnd)) {
                $ret_msg = $msg4;
            }

            if ($combo_text ne $document_caching) {
                $ret_msg = $msg4;
            }
        }

        sleep($sleeptime);
        PushChildButton($caching, "Cancel");
        sleep($sleeptime);

        PushChildButton($properties, "Cancel");
        sleep($sleeptime * 2);
    } else {
        $ret_msg = $msg5;
    }
    return $ret_msg;
}

#--------------------------------------------------------------

=head2 mmc_cifs_sessions

$ret = mmc_cifs_sessions(window => $win, filer => $filer);

Passed a window handle to "MMC Computer Management" GUI.
Browses CIFS sessions on filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer where sessions exists

=back

=item Returns

Returns 1 if open sessions, otherwise 0 if not found in MMC listview.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_cifs_sessions(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $ret_val);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});

    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Sessions";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $list[0]);
            }
        }
    }

    if ($found) {
        $ret_val = 1;
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_browse_files

$ret = mmc_browse_files(window => $win, filer  => $filer);

Passed a window handle to "MMC Computer Management" GUI.
Browses open files on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer to browse for open files

=back

=item Returns

Returns 1.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_browse_files(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $ret_val);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});

    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Open Files";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 3}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $list[0]);
            }
        }
    }

    if ($found) {
        $ret_val = 1;
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_local_users

$ret = mmc_local_users(window => $win, filer  => $filer);

Passed a window handle to "MMC Computer Management" GUI.
Browses local users on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer to browse local users

=back

=item Returns

Returns 1.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_local_users(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $ret_val);
    my($path, $found, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});

    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Local Users and Groups|Users";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 3}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
    }

    if ($found) {
        $ret_val = 1;
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_local_groups

@groups = mmc_local_groups(window => $win, filer  => $filer);

Passed a window handle to "MMC Computer Management" GUI.
Browses local groups on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer to browse local group

=back

=item Returns

Returns array of groups.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_local_groups(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});

    $treeview_path =
        "Computer Management ($filer)|System Tools|Local Users and Groups|Groups";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 3}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
    }

    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            last;
        }
    }
    return @list;
}

#--------------------------------------------------------------

=head2 mmc_add_local_user

$ret = mmc_add_local_user(window => $win, filer => $filer, user => $user,
                          passwd => $pass);

Passed a window handle to "MMC Computer Management" GUI.
Adds a user to filer local group.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer to add user to

=item user

(Required): user to add to filer

=item passwd

(Required): user's password

=back

=item Returns

Returns 1 if user added, 2 if access denied, otherwise 0.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_add_local_user(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            user   => { type => SCALAR },
            passwd => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $hwnd, $whandle2, $ret_val, $create, $close);
    my($path, $found, @windows, @list, $class, $treeview_path, $set);
    my($access_denied);

    $hwnd = $opts{window};
    $filer   = uc($opts{filer});

    $ret_val = 0;
    $access_denied = 0;

    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 3}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);

    # Menu
    SendKeys("%a");
    sleep($sleeptime);
    SendKeys("n");
    sleep($sleeptime);

    my $new_user = _wait_window_by_name(name => "New User");
    if ($new_user) {
        SetForegroundWindow($new_user);
        SetActiveWindow($new_user);
        SetFocus($new_user);
    } else {
        return $ret_val;
    }

    @windows = GetChildWindows($new_user);
    foreach my $i (@windows) {
        my $id    = GetWindowID($i);

        if ($id == 1002) {
            $set = WMSetText($i, "$opts{user}");
            sleep($sleeptime);
        }
        if ($id == 1172) {
            $set = WMSetText($i, "$opts{passwd}");
            sleep($sleeptime);
        }
        if ($id == 1173) {
            $set = WMSetText($i, "$opts{passwd}");
            sleep($sleeptime);
        }
        if ($id == 1170) {
            $create = $i;
        }
        if ($id == 2) {
            $close = $i;
        }
    }

    my $is_enabled = IsWindowEnabled($create);
    if ($is_enabled) {
        PushChildButton($new_user, "Cr&eate");
        sleep($sleeptime);

        # Look for Access denied popup window
        my $desk = GetDesktopWindow();
        my @desk_wnds = GetChildWindows($desk);
        foreach my $j (@desk_wnds) {
            my $desk_text = WMGetText($j);
            my $desk_class = GetClassName($j);
            if (($desk_text eq "Local Users and Groups") && ($desk_class eq '#32770')) {
                PushChildButton($j, "OK");
                sleep($sleeptime);
                $access_denied = 1;
                last;
            }
        }

        if ($access_denied) {
            PushChildButton($new_user, "Cl&ose");
            $ret_val = 2;
        } else {
            $ret_val = 1;
        }
    } else {
        PushChildButton($new_user, "Cl&ose");
        sleep($sleeptime);
        $ret_val = 0;
    }

    SetForegroundWindow($hwnd);
    sleep($sleeptime);
    SetActiveWindow($hwnd);
    sleep($sleeptime);
    SetFocus($hwnd);
    sleep($sleeptime);

    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_close_open_files

$ret = mmc_close_open_files(window => $win, filer => $filer, file => $file);

Passed a window handle to "MMC Computer Management" GUI.
Closes an open file on filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer where open file exists

=item file

(Required): name of file to close

=back

=item Returns

Returns 1 if file found and closed, otherwise 0 if not found in listview.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_close_open_files(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            file   => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $hwnd, $whandle2, $ret_val, $create, $close);
    my($path, $found, @windows, @list, $class, $treeview_path, $set);
    my($access_denied);

    $hwnd = $opts{window};
    $filer   = uc($opts{filer});

    $ret_val = 0;
    $access_denied = 0;

    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 2}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 3}");
    sleep($sleeptime);

    $found = 0;
    @windows = GetChildWindows($hwnd);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $opts{file});
                if (IsListViewItemSel($i, $opts{file})) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        # Menu
        SendKeys("%a");
        sleep($sleeptime);
        SendKeys("o");
        sleep($sleeptime);

        # Look for Access denied popup window
        my $desk = GetDesktopWindow();
        my @desk_wnds = GetChildWindows($desk);
        foreach my $j (@desk_wnds) {
            my $desk_text = WMGetText($j);
            my $desk_class = GetClassName($j);
            if ($desk_text eq "Shared Folders") {
                PushChildButton($j, "Yes");
                sleep($sleeptime);
                $ret_val = 1;
                last;
            }
        }
    } else {
        $ret_val = 0;
    }

    SetForegroundWindow($hwnd);
    sleep($sleeptime);
    SetActiveWindow($hwnd);
    sleep($sleeptime);
    SetFocus($hwnd);
    sleep($sleeptime);

    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_close_cifs_sessions

$ret = mmc_close_cifs_sessions(window => $win, filer => $filer,
                               user => $user);

Passed a window handle to "MMC Computer Management" GUI.
Closes a CIFS session on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer where sessions exists

=item user

(Required): name of user of session to close

=back

=item Returns

Returns 1 if user session found and closed, otherwise 0 if session not listed.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_close_cifs_sessions(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            user   => { type => SCALAR }
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $ret_val, $user);
    my($path, $found, @windows, @list, $class, $treeview_path);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});
    $user    = $opts{user};

    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Sessions";

    $found = 0;

    @wnds = GetChildWindows($whandle);
    foreach $i (@wnds) {
        $class = GetClassName($i);
        if ($class =~ /^(SysTreeView32)$/) {
            $path = GetTreeViewSelPath($i);
            if ($path eq $treeview_path) {
                $found = 1;
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            } elsif ($path eq "Computer Management ($filer)") {
                SelTreeViewItemPath($i, $path);
                SetFocus($i);
            }

            last;
        }
    }

    if (!$found) {
        sleep($sleeptime);
        SendKeys("{DOWN}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
        SendKeys("{RIGHT}");
        sleep($sleeptime);
        SendKeys("{DOWN 2}");
        sleep($sleeptime);
    }

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
             SetFocus($i);
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $user);
                if (IsListViewItemSel($i, $user)) {
                    sleep($sleeptime);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        # Menu
        SendKeys("%a");
        sleep($sleeptime);
        SendKeys("s");
        sleep($sleeptime);

        my $desk = GetDesktopWindow();
        my @desk_wnds = GetChildWindows($desk);
        foreach my $j (@desk_wnds) {
            my $desk_text = WMGetText($j);
            my $desk_class = GetClassName($j);
            if ($desk_text eq "Shared Folders") {
                PushChildButton($j, "Yes");
                sleep($sleeptime);
                $ret_val = 1;
                last;
            }
        }
    } else {
        $ret_val = 0;
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 mmc_share_properties

@list = mmc_share_properties(window => $win, filer => $filer,
                             share => $share);

Passed a window handle to "MMC Computer Management" GUI.
Returns the share permissions for the specified share.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer where sessions exists

=item share

(Required): name of share to return permissions for

=back

=item Returns

Returns an array of share permissions if share exists otherwise array is empty.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_share_properties(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            share  => { type => SCALAR },
        }
    );

    my($i, @wnds, $filer, $whandle, $whandle2, $share, $ret_val);
    my($path, $found, @windows, @list, $class, $treeview_path);
    my($tabwindow, $idx, $prev_idx, @listview);

    $whandle = $opts{window};
    $filer   = uc($opts{filer});
    $share   = $opts{share};
    $ret_val = 0;

    $treeview_path =
        "Computer Management ($filer)|System Tools|Shared Folders|Shares";

    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 2}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);

    $found = 0;
    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $share);
                if (IsListViewItemSel($i, $share)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        SendKeys("%a");
        sleep($sleeptime);
        SendKeys("r");
        sleep($sleeptime);

        my $properties = _wait_window_by_name(name => "$share Properties");
        if ($properties) {
            SetForegroundWindow($properties);
            SetActiveWindow($properties);
            SetFocus($properties);

            # Get the tab control and index for the Share Permissions tab.
            ($tabwindow, $idx) = check_tab_present(window => $properties,
                                                   text => 'Share Permissions');

            # Select the Share Permissions tab and get all the text
            if (defined($tabwindow)) {
                TabCtrl_SetCurFocus($tabwindow, $idx);
                sleep(2 * $sleeptime);
                $prev_idx = TabCtrl_SetCurSel($tabwindow, $idx);

                my @desk_wnds = GetChildWindows($properties);
                foreach my $j (@desk_wnds) {
                    my $desk_text = WMGetText($j);
                    my $desk_class = GetClassName($j);
                    if (($desk_text eq 'Permissions for:') && ($desk_class eq 'SysListView32')) {
                        @listview = GetListViewContents($j);
                        last;
                    }
                }
            }

            PushChildButton($properties, "Cancel");
            sleep($sleeptime);
        } else {
            return @listview;
        }
    }
    return @listview;
}

#--------------------------------------------------------------

=head2 mmc_add_to_local_group

mmc_add_to_local_group(window   => $win,
                       filer    => $filer,
                       location => 'domain',
                       add_user => $user,
                       group    => 'Users',
                       user     => $cifs_user,
                       passwd   => $cifs_user_passwd);

Passed a window handle to "MMC Computer Management" GUI.
Add a local user to a local group on the filer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to MMC window

=item filer

(Required): name of filer

=item location

(Required): location where to search for the user to add to the group.
It can be either 'domain' or 'local' where local searches the filer.

=item add_user

(Required): name of user that already exists locally on the filer

=item group

(Required): name of local group on filer to add user to

=item user

(Required): name of user to log in as, or authenticate as, when doing
the operation on the filer.

=item passwd

(Required): password for authenticated user

=back

=item Returns

Returns 0 on success, 1 on failure.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub mmc_add_to_local_group(%) {
    my %opts = validate(
        @_,
        {
            window   => { type => SCALAR },
            filer    => { type => SCALAR },
            location => { type => SCALAR, regex => qr/^(domain|local)$/ },
            add_user => { type => SCALAR },
            group    => { type => SCALAR },
            user     => { type => SCALAR },
            passwd   => { type => SCALAR },
        }
    );

    my($class, $connect, $filer, $found, $group, $i, $id, @list, $location,
       $pass, $ret, $text, $treeview_path, $user, $whandle, @windows, @wnds);

    $whandle  = $opts{window};
    $filer    = uc($opts{filer});
    $location = $opts{location};
    $group    = $opts{group};
    $user     = $opts{user};
    $pass     = $opts{passwd};

    $treeview_path =
        "Computer Management ($filer)|System Tools|Local Users and Groups|Groups";
    $ret = 1;
    $found = 0;

    sleep($sleeptime);
    SendKeys("{DOWN}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 3}");
    sleep($sleeptime);
    SendKeys("{RIGHT}");
    sleep($sleeptime);
    SendKeys("{DOWN 2}");
    sleep($sleeptime * 2);

    @windows = GetChildWindows($whandle);
    foreach $i (@windows) {
        $class = GetClassName($i);
        @list = undef;
        if ($class =~ /^(SysListView32)$/) {
            @list = GetListViewContents($i);
            if (@list) {
                SelListViewItemText($i, $group);
                if (IsListViewItemSel($i, $group)) {
                    SetFocus($i);
                    $found = 1;
                    last;
                }
            }
        }
    }

    if ($found) {
        sleep($sleeptime);
        SendKeys("%a");
        sleep($sleeptime);
        SendKeys("a");
        sleep($sleeptime);

        my $properties = _wait_window_by_name(name => "$group Properties");
        if ($properties) {
            SetForegroundWindow($properties);
            SetActiveWindow($properties);
            SetFocus($properties);

            PushChildButton($properties, "A&dd...");
            sleep($sleeptime);

            my $select = _wait_window_by_name(name => "Select Users, Computers, or Groups");
            if ($select) {
                # Enter the object name (user name)
                @wnds = GetChildWindows($select);
                foreach my $j (@wnds) {
                    $id   = GetWindowID($j);
                    $class = GetClassName($j);

                    if ($id == 214 && $class eq 'RichEdit20W') {
                        WMSetText($j, $opts{add_user});
                        last;
                    }
                }

                if ($location eq 'local') {
                    # Change the location to the filer (i.e. local)
                    PushChildButton($select, "Locations...");
                    sleep($sleeptime);

                    # The first password prompt is for the domain account,
                    # we do not want that. Cancel the window so we can
                    # choose the location
                    $connect = _wait_window_by_name(name => "Enter Network Password");
                    if ($connect) {
                        PushChildButton($connect, "Cancel");
                        sleep($sleeptime);
                    }
                    # Move the location pointer up to the top where the filer
                    # is listed.
                    $connect = _wait_window_by_name(name => "Locations");
                    if ($connect) {
                        SendKeys("{UP 20}");
                        sleep($sleeptime);
                        PushChildButton($connect, "OK");
                        sleep($sleeptime);
                    }
                }

                # Push OK button on Select Users window
                PushChildButton($select, "OK");
                sleep($sleeptime);

                $connect = _wait_window_by_name(name => "Enter Network Password");
                if ($connect) {
                    @wnds = GetChildWindows($connect);
                    foreach my $j (@wnds) {
                        $class = GetClassName($j);
                        $id    = GetWindowID($j);

                        if ($class eq 'Edit' && $id == 1003) {
                            SetFocus($j);
                            SendKeys("$user");
                            sleep($sleeptime);
                        }

                        if ($class eq 'Edit' && $id == 1005) {
                            SetFocus($j);
                            SendKeys("$pass");
                            sleep($sleeptime);
                        }
                    }

                    PushChildButton($connect, "OK");
                    sleep($sleeptime);
                }
                # At this point the operation has succeeded unless an
                # error window is detected.
                $ret = 0;

                # If this window came up the operation failed
                $connect = _wait_window_by_name(name => "Name Not Found");
                if ($connect) {
                    PushChildButton($connect, "Cancel");
                    sleep($sleeptime);
                    PushChildButton($select, "Cancel");
                    sleep($sleeptime);
                    logcomment('mmc_add_to_local_group: Name Not Found');
                    $ret = 1;
                }

                # Search all open windows to see if we got a popup that
                # indicates the user is already in the group.
                @windows = GetChildWindows(GetDesktopWindow());
                foreach $i (@windows) {
                    $class = GetClassName($i);
                    $id    = GetWindowID($i);
                    $text = WMGetText($i);
                    if ($class eq '#32770' &&
                        $text eq 'Local Users and Groups') {
                        PushChildButton($i, "OK");
                        sleep($sleeptime);
                        logcomment("mmc_add_to_local_group: $opts{add_user} already in $group group on $filer");
                        $ret = 1;
                        last;
                    }
                }
            }
            PushChildButton($properties, "OK");
            sleep($sleeptime);
        }
    }

    return $ret;
}

#--------------------------------------------------------------

=head2 create_files

create_files(file_name  => $file,
             file_ext   => $file_extension,
             file_path  => $file_path
             close_file => 1);

Creates a file of type extension in the specified mapped share.

The following named arguments are accepted,

=over

=item Arguments

=over

=item file

(Required): name of file to create

=item file_ext

(Required): type of file to create. Supported types are 'doc', 'xls', 'ppt',
            'txt', and 'NONE'. 'doc', 'xls', 'ppt', and 'txt' will be
            dot appended to the filename.

=item file_path

(Required): path where file is to be created

=item close_file

(Optional): close file window when done if 1. Allowed values are 0|1,
            default is 1.

=back

=item Returns

Returns the handle to the window if not closed, or 0.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub create_files(%) {
    my %opts = validate(
        @_,
        {
            file_name  => { type => SCALAR },
            file_ext   => { type => SCALAR,
                            regex => qr/^(doc|xls|ppt|txt)$/ },
            file_path  => { type => SCALAR },
            close_file => { type => SCALAR, default => 1,
                            regex => qr/^(0|1)$/ },
        }
    );

    my(@wnds, $pgm, $croak_txt, @save_as, @replace);
    my($whnd, $file_name, $file_ext, $file_path, $hwnd);
    my($i, $j, $class, $id, $set, $win_title);

    $file_name = $opts{file_name};
    $file_ext  = $opts{file_ext};
    $file_path = "$opts{file_path}\\$file_name.$file_ext";

    get_office_path();
    if ($file_ext eq 'doc') {
        $pgm = $word_pgm;
        $win_title = '^Document\d+ - Microsoft Word';
    } elsif ($file_ext eq 'xls') {
        $pgm = $excel_pgm;
        $win_title = "^Microsoft Excel";
    } elsif ($file_ext eq 'ppt') {
        $pgm = $ppt_pgm;
        $win_title = "^Microsoft PowerPoint";
    } else {
        $pgm = $note_pgm;
        $win_title = "Notepad";
    }

    open(PGM, $pgm);

    $wnds[0] = _wait_window_by_name(name => $win_title);
    if ($wnds[0]) {
        SetActiveWindow($wnds[0]);
        SendMouse("{ABS32767,32767}");
        SetFocus($wnds[0]);
        SetForegroundWindow($wnds[0]);

        sleep($sleeptime);
        SendKeys("$test_data");
        sleep($sleeptime * 3);
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("a");

        $save_as[0] = _wait_window_by_name(name => "Save As");
        if ($save_as[0]) {
            SendKeys("$file_path");
            sleep($sleeptime * 2);
            SendKeys("{ENTER}");
            sleep($sleeptime * 2);
        }

        if ( $opts{close_file} ) {
            SendKeys("%f");
            sleep($sleeptime);
            SendKeys("x");
            sleep($sleeptime * 2);
        } else {
            sleep($sleeptime * 2);
            return $wnds[0];
        }
    }
    close(PGM);
    return 0;
}

#--------------------------------------------------------------

=head2 edit_file

$hwnd = edit_file(file_name  => $file,
                  file_ext   => $file_extension,
                  file_path  => $file_path,
                  edit_text  => 1,
                  close_file => 1);

Edits a file of type extension in the specified mapped share.

The following named arguments are accepted,

=over

=item Arguments

=over

=item file

(Required): name of file to edit

=item file_ext

(Required): type of file to edit. Supported types are 'doc', 'xls', 'ppt',
            'txt', and 'NONE'. 'doc', 'xls', 'ppt', and 'txt' will be
            dot appended to the filename. 'NONE' indicates to
            not use an extension, and open with notepad.

=item file_path

(Required): path where file is located

=item edit_text

(Optional): enter text into file if 1. Allowed values are 0|1, default is 1.

=item close_file

(Optional): close file window when done if 1. Allowed values are 0|1,
            default is 1.

=back

=item Returns

Returns the handle to the window if not closed, or 0.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub edit_file(%) {
    my %opts = validate(
        @_,
        {
            file_name  => { type => SCALAR },
            file_ext   => { type => SCALAR,
                            regex => qr/^(doc|xls|ppt|txt|NONE)$/ },
            file_path  => { type => SCALAR },
            edit_text  => { type => SCALAR, default => 1,
                            regex => qr/^(0|1)$/ },
            close_file => { type => SCALAR, default => 1,
                            regex => qr/^(0|1)$/ },
        }
    );

    my(@wnds, $pgm, $croak_txt, @open, $win_title);
    my($whnd, $file_name, $file_ext, $file_path);
    my($i, $j, $class, $id, $set);

    $file_name = $opts{file_name};
    $file_ext  = $opts{file_ext};
    $file_path = "$opts{file_path}\\$file_name";
    $file_path .= ".$file_ext" if ($file_ext ne 'NONE');

    # If the file doesn't exist return an error
    if (! -e $file_path) {
        return 0;
    }

    get_office_path();
    if ($file_ext eq 'doc') {
        $pgm = $word_pgm;
        $win_title = '^Document\d+ - Microsoft Word';
    } elsif ($file_ext eq 'xls') {
        $pgm = $excel_pgm;
        $win_title = "^Microsoft Excel";
    } elsif ($file_ext eq 'ppt') {
        $pgm = $ppt_pgm;
        $win_title = "^Microsoft PowerPoint";
    } else { # Open .txt and files without extension using Notepad
        $pgm = $note_pgm;
        $win_title = "Notepad";
    }

    open(PGM, $pgm);

    $wnds[0] = _wait_window_by_name(name => $win_title);
    if ($wnds[0]) {
        SendMouse("{ABS32767,32767}");
        SetActiveWindow($wnds[0]);
        SetFocus($wnds[0]);
        SetForegroundWindow($wnds[0]);

        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("o");

        $open[0] = _wait_window_by_name(name => "Open");
        if ($open[0]) {
            sleep($sleeptime);
            SendKeys("$file_path");
            sleep($sleeptime * 2);
            SendKeys("{ENTER}");

            if ( $opts{edit_text} ) {
                SetFocus($wnds[0]);
                sleep($sleeptime);
                SendKeys("$edit_data");
                sleep($sleeptime * 5);
                SendKeys("%f");
                sleep($sleeptime);
                SendKeys("s");
            }
        }

        if ( $opts{close_file} ) {
            sleep($sleeptime);
            SendKeys("%f");
            sleep($sleeptime);
            SendKeys("x");

            sleep($sleeptime * 2);
        } else {
            sleep($sleeptime * 2);
            return $wnds[0];
        }
    }
    close(PGM);
    return 0;
}

#--------------------------------------------------------------

=head2 edit_file_expect_prompt

$hwnd = edit_file_expect_prompt(file_name  => $file,
                                file_ext   => $file_extension,
                                file_path  => $file_path
                                close_file => 0);

Edits a file of type extension in the specified mapped share. Expects
to receive a prompt indicating file is in use. Will either close the
prompt and the application, or leave the application running with the
prompt displayed.

The following named arguments are accepted,

=over

=item Arguments

=over

=item file

(Required): name of file to edit

=item file_ext

(Required): type of file to edit. Supported types are 'doc', 'xls', 'ppt',
            'txt', and 'NONE'. 'doc', 'xls', 'ppt', and 'txt' will be
            dot appended to the filename. 'NONE' indicates to
            not use an extension, and open with notepad.

=item file_path

(Required): path where file is located

=item close_file

(Required): close the prompt and the application if 1. Leaves the prompt
            dialog active otherwise.

=back

=item Returns

Returns handle to prompt window if prompt encountered, undef otherwise.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub edit_file_expect_prompt(%) {
    my %opts = validate(
        @_,
        {
            file_name  => { type => SCALAR },
            file_ext   => { type => SCALAR,
                            regex => qr/^(doc|xls|ppt|txt|NONE)$/ },
            file_path  => { type => SCALAR },
            close_file => { type => SCALAR, regex => qr/^(0|1)$/ },
        }
    );

    my(@wnds, $pgm, $croak_txt, @open, $win_title, $prompt);
    my($file_name, $file_ext, $file_path);

    $file_name = $opts{file_name};
    $file_ext  = $opts{file_ext};
    $file_path = "$opts{file_path}\\$file_name";
    $file_path .= ".$file_ext" if ($file_ext ne 'NONE');

    # If the file doesn't exist return an error
    if (! -e $file_path) {
        return 0;
    }

    get_office_path();
    if ($file_ext eq 'doc') {
        $pgm = $word_pgm;
        $win_title = '^Document\d+ - Microsoft Word';
    } elsif ($file_ext eq 'xls') {
        $pgm = $excel_pgm;
        $win_title = "^Microsoft Excel";
    } elsif ($file_ext eq 'ppt') {
        $pgm = $ppt_pgm;
        $win_title = "^Microsoft PowerPoint";
    } else { # Open .txt and files without extension using Notepad
        $pgm = $note_pgm;
        $win_title = "Notepad";
    }

    open(PGM, $pgm);
    $wnds[0] = _wait_window_by_name(name => $win_title);
    if ($wnds[0]) {
        SendMouse("{ABS32767,32767}");
        SetActiveWindow($wnds[0]);
        SetFocus($wnds[0]);
        SetForegroundWindow($wnds[0]);

        sleep($sleeptime);
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("o");

        $open[0] = _wait_window_by_name(name => "Open");
        if ($open[0]) {
            sleep($sleeptime);
            SendKeys("$file_path");
            sleep($sleeptime * 2);
            SendKeys("{ENTER}");

            $prompt = _wait_window_by_name(name => "File In Use");

            if ( $prompt && $opts{close_file} ) {
                # Close the File In Use prompt dialog
                sleep($sleeptime);
                SendKeys("{ESC}");
            }
        }

        if ( $opts{close_file} ) {
            sleep($sleeptime);
            SendKeys("%f");
            sleep($sleeptime);
            SendKeys("x");

            sleep($sleeptime * 2);
        }
    }
    if (!defined($prompt)) {
        close(PGM);
    }
    return $prompt;
}

#--------------------------------------------------------------

=head2 edit_file_answer_prompt

$hwnd = edit_file_answer_prompt(handle     => $hwnd,
                                file_name  => $file,
                                file_ext   => $file_extension,
                                file_path  => $file_path,
                                selection  => 'r',
                                close_file => 0);

Responds to the File In Use prompt from edit_file_expect_prompt().

The following named arguments are accepted,

=over

=item Arguments

=over

=item handle

(Required): handle to the File In Use prompt from edit_file_expect_prompt

=item file

(Required): name of file to edit

=item file_ext

(Required): type of file to edit. Supported types are .doc, .xls, and .ppt

=item file_path

(Required): path where file is located

=item selection

(Required): selection from File In Use prompt to be chosen:
            'r' - Open file in read only mode
            'm' - Open file and merge changes later
            'n' - Open file and notify when file is free

=item close_file

(Required): close the prompt and the application if 1. Leaves the prompt
            dialog active otherwise.

=back

=item Returns

Returns handle to prompt window if prompt encountered, undef otherwise.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub edit_file_answer_prompt(%) {
    my %opts = validate(
        @_,
        {
            handle     => { type => SCALAR },
            file_name  => { type => SCALAR },
            file_ext   => { type => SCALAR,
                            regex => qr/^(doc|xls|ppt|txt|NONE)$/ },
            file_path  => { type => SCALAR },
            selection  => { type => SCALAR, regex => qr/^(r|m|n)$/ },
            close_file => { type => SCALAR, regex => qr/^(0|1)$/ },
        }
    );

    my($file_name, $file_ext, $selection, $hwnd);

    $file_name = $opts{file_name};
    $file_ext  = $opts{file_ext};
    $selection = $opts{selection};

    # Select the window (hopefully it's already the active window)
    SendMouse("{ABS32767,32767}");
    SetActiveWindow($opts{handle});
    SetFocus($opts{handle});

    sleep($sleeptime);
    SendKeys("%$selection");
    sleep($sleeptime);
    SendKeys("{ENTER}");

    $hwnd = _wait_window_by_name(name => $file_name);
    if ( $hwnd && $opts{close_file} ) {
        SetActiveWindow($hwnd);
        SetFocus($hwnd);

        sleep($sleeptime);
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("x");

        sleep($sleeptime * 2);
    } elsif ( $hwnd ) {
        return $hwnd;
    }

    return undef;
}

#--------------------------------------------------------------

=head2 edit_file_already_open

$hwnd = edit_file_already_open(handle     => $hwnd,
                               close_file => 0);

Responds to the File In Use prompt from edit_file_expect_prompt().

The following named arguments are accepted,

=over

=item Arguments

=over

=item handle

(Required): handle to the file window to be edited

=item close_file

(Required): close the prompt and the application if 1. Leaves the prompt
            dialog active otherwise.

=back

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub edit_file_already_open(%) {
    my %opts = validate(
        @_,
        {
            handle     => { type => SCALAR },
            close_file => { type => SCALAR, regex => qr/^(0|1)$/ },
        }
    );

    # Select the window (hopefully it's already the active window)
    SendMouse("{ABS32767,32767}");
    SetActiveWindow($opts{handle});
    SetFocus($opts{handle});

    sleep($sleeptime);
    SendKeys("$edit_data");
    sleep($sleeptime * 5);
    SendKeys("%f");
    sleep($sleeptime);
    SendKeys("s");

    if ( $opts{close_file} ) {
        sleep($sleeptime);
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("x");
    }

    sleep($sleeptime * 2);
    return;
}

#--------------------------------------------------------------

=head2 open_my_computer

$win = open_my_computer();

Opens the "Explorer|My Computer" on the local Windows computer.
Calls get_my_computer_name() to get the name of the 'My Computer'
icon.
This is used in the CSC tests.

=over

=item Returns

Handle to the "Explorer" window that was opened.

=back

=for html <hr />

=cut

#----------------------------------------------------------------

sub open_my_computer () {
    my ($class, $i, $j, $id, $hwnd, $hwnd_mydoc, $mycomputer, $ret, $set,
        @wnds);

    $mycomputer = get_my_computer_name();

    open(PGM, 'explorer.exe|');
    sleep(10);

    # If we get a Windows Explorer dialog box then folder redirection
    # for My Documents didn't get reset the last time a folder
    # redirection test was run. Push the Ok button and then reset
    # folder redirection to the default.
    $i = _wait_window_by_name(name => "Windows Explorer");
    if ($i) {
        PushChildButton($i, "OK");

        $i = _wait_window_by_name(name => "Desktop");
        if ($i) {
            $ret = folder_properties(whnd     => $i,
                                     target   => "Desktop",
                                     item     => "My Documents",
                                     drive    => 'UNUSED',
                                     action   => 'restore');
        }
        # Close open window and explorer and restart it
        close_window(window => $i);
        close(PGM);
        open(PGM, 'explorer.exe|');
    }

    $hwnd_mydoc = _wait_window_by_name(name => "My Documents", timeout => 60);
    if ($hwnd_mydoc) {
        SetActiveWindow($hwnd_mydoc);
        SetFocus($hwnd_mydoc);

        @wnds = GetChildWindows($hwnd_mydoc);
        foreach $i (@wnds) {
            $class = GetClassName($i);
            if ($class =~ /^(Edit)$/) {
                SetFocus($i);
                $set = WMSetText($i, "$mycomputer");
                SendKeys("{ENTER}");
                sleep($sleeptime);
                last;
            }
        }
    }

    $hwnd = _wait_window_by_name(name => "^$mycomputer\$");
    if ($hwnd) {
        SetActiveWindow($hwnd);
        SetFocus($hwnd);
    } else {
        # Save image of desktop if this routine failed
        save_win_as_bmpfile(window => GetDesktopWindow());

        # Close the original 'My Document' window
        if ($hwnd_mydoc) {
            close_window(window => $hwnd_mydoc);
        }

        # Search for any 'My Document' windows we might have started
        # and close them.
        @wnds = FindWindowLike(undef, "My Documents", '');
        foreach $i (@wnds) {
            close_window(window => $i);
        }
        close(PGM);
    }
    sleep($sleeptime);

    return $hwnd;
}

#--------------------------------------------------------------

=head2 close_my_computer

close_my_computer(window => $win);

Passed a window containing the "Explorer" GUI.
Closes the window and any open property windows.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to window opened by
open_my_computer or explorer_open_with_target

=back

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub close_my_computer ( % ) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
        }
    );

    my ($mycomputer, $window, @windows, $i);

    $window = $opts{window};

    sleep($sleeptime);

    if ($window) {
        close_window(window => $window);

        $mycomputer = get_my_computer_name();
        @windows = FindWindowLike(undef, "^$mycomputer\$", '');

        foreach $i (@windows) {
            close_window(window => $i);
        }
    }
    return;
}

#--------------------------------------------------------------

=head2 make_available_offline

$ret = make_available_offline(whnd     => $win,
                              filer_ip => $filer_ip,
                              share    => $share,
                              drive    => $drive,
                              option   => 'yes');

Passed a window handle to "Explorer My Computer" GUI.
Makes a share available offline.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item option

(Optional): option to make share available or not available offline.
Default is yes to make available offline.

=back

=item Returns

Returns 1 if requested operation was performed, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub make_available_offline(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            option   => { type => SCALAR, default => 'yes',
                          regex => qr/^(yes|no)$/ }
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, @list);
    my($id, $menu_id, $cnt, %menu_item, $mycomputer);
    my(@offline_wizard, $hwnd, $ret_val);

    $whandle = $opts{whnd};
    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $ret_val = select_listview_item(whnd   => $whandle,
                                    target => "$mycomputer",
                                    item   => $treeview_path);
    if ($ret_val) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("a");
        sleep($sleeptime);

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);
        if ($opts{option} eq 'yes') {
            if (($text eq $remove_offline_folders) ||
                ($text eq $offline_files)) {
                PushChildButton($hwnd, "Cancel");
            } elsif ($text eq $confirm_offline_subfolders) {
                PushChildButton($hwnd, "OK");
            }
        } else {
            if ($text eq $offline_files) {
                PushChildButton($hwnd, "OK");
                sleep($sleeptime);

                $hwnd = GetForegroundWindow();
                $text = WMGetText($hwnd);

                if ($text eq $remove_offline_folders) {
                    sleep($sleeptime);
                    PushChildButton($hwnd, "OK");
                }
            } elsif ($text eq $remove_offline_folders) {
                PushChildButton($hwnd, "OK");
            } elsif ($text eq $confirm_offline_subfolders) {
                PushChildButton($hwnd, "Cancel");
            }
        }
        sleep($sleeptime);
    }
    return $ret_val;
}

#--------------------------------------------------------------

=head2 check_available_offline

$ret = check_available_offline(whnd     => $win,
                               filer_ip => $filer_ip,
                               share    => $share,
                               drive    => $drive);

Passed a window handle to "Explorer My Computer" GUI.
Checks if the share is available offline.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item share

(Required): name of share to check if available offline

=item drive

(Optional): drive on windows client where share is mapped to

=back

=item Returns

Returns 1 if share is not available offline, 0 if it is available offline.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub check_available_offline(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            target   => { type => SCALAR },
            item     => { type => SCALAR }
        }
    );

    my($text, $ret_msg, $ret_val);

    $ret_val = select_listview_item(whnd   => $opts{whnd},
                                    target => $opts{target},
                                    item   => $opts{item});

    if ($ret_val) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("a");
        sleep($sleeptime);

        $text = WMGetText(GetForegroundWindow());
        if ($text eq $sync_window) {
            $ret_msg = 1;
        } elsif ($text eq $offline_wizard) {
            PushChildButton(GetForegroundWindow(), "Cancel");
            $ret_msg = 1;
        } elsif ($text eq $confirm_offline_subfolders) {
            PushChildButton(GetForegroundWindow(), "Cancel");
            $ret_msg = 1;
        }
        sleep($sleeptime);
    } else {
        $ret_msg = 0;
    }
    return $ret_msg;
}

#---------------------------------------------------------------------

=head2 vdthrash

$whnd = vdthrash(filer => $filer, share => $share);

This function runs vdthrash.exe on the filer.

The following named arguments are accepted:

=over

=item Arguments

=over

=item filer

(Required) : Name of filer to run test on.

=item share

(Required) : Share on filer to run test in.

=item drive

(Required) : Mapped drive to run test in.

=item exec_path

(Optional) : Path to run vdthrash executable. Default is
'X:\bin\vdthrash.exe'.

=back

=item Returns

Returns handle to vdthrash window if successfully opened, 0 otherwise.

=back

=for html <hr />

=cut

#---------------------------------------------------------------------
sub vdthrash(%) {
    my %opts = validate(
        @_,
        {
            filer     => { type => SCALAR },
            share     => { type => SCALAR },
            drive     => { type => SCALAR },
            exec_path => { type => SCALAR, optional => 1 }
        }
    );

    my $filer = $opts{filer};
    my $share = $opts{share};
    my $drive = $opts{drive};
    my ($exec_path, $i, $id, $class, $hwnd, @wnds, @vdthrash);

    if (defined($opts{exec_path})) {
        $exec_path = $opts{exec_path};
    } else {
        $exec_path = $vdthrash;
    }

    # Execute vdthrash command
    open(PGM, "$exec_path|");
    if ($?) {
        return 0;
    }

    sleep($sleeptime);
    @vdthrash = FindWindowLike(undef, "Vdthrash", '');
    if ($vdthrash[0]) {
        @wnds = GetChildWindows($vdthrash[0]);
        foreach $i (@wnds) {
            $class = GetClassName($i);
            $id = GetWindowID($i);

            if (($class eq 'Edit') && $id == 101) {
                WMSetText($i, "$drive\\$share\\testfile.txt");
            }
        }

        PushChildButton(GetForegroundWindow(), "OK");
    } else {
        close(PGM);
    }
    return $vdthrash[0];
}

#---------------------------------------------------------------------

=head2 vdthrash_close

vdthrash_close();

This function closes vdthrash window.

The following named arguments are accepted:

=over

=item Arguments

=over

=back

=back

=for html <hr />

=cut

#---------------------------------------------------------------------
sub vdthrash_close() {
    qx(taskkill /f /im VDTHRASH.EXE /t 2>&1);
    if ($? != 0) {
        logcomment("vdthrash_close: kill of vdthrash.exe failed: $?");
    }
    return;
}

#--------------------------------------------------------------

=head2 encryption_support

$ret = encryption_support(filer_ip => $filer_ip,
                          share    => $share,
                          drive    => $drive,
                          file     => $file,
                          whnd     => $whnd);

This function is used to verify the advanced button on a folder's properties.
Used for encrypting a folder's contents.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to where file is stored

=item drive

(Required): drive on windows client where share is mapped to

=item file

(Required): file to use

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the folder's properties window supports the Advanced
button used for file encryption, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub encryption_support(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            file     => { type => SCALAR },
            whnd     => { type => SCALAR },
        }
    );

    my($filer_ip, $whandle, $share, $share_drive, $treeview_path);
    my($ret, $file, $hwnd, $text, @wnds);
    my($i, $class, $id);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $file = $opts{file};
    $whandle = $opts{whnd};
    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $ret = select_listview_item(whnd     => $whandle,
                                target   => "$share_drive\\",
                                item     => $file,
                                wnd_text => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("r");
        sleep($sleeptime);

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);

        if ($hwnd) {
            $ret = 0;
            @wnds = GetChildWindows($hwnd);
            foreach $i (@wnds) {
                $text = WMGetText($i);
                $class = GetClassName($i);
                $id = GetWindowID($i);

                if ($text eq 'A&dvanced...') {
                    $ret = 1;
                    last;
                }
            }
        } else {
            $ret = 0;
        }

        PushChildButton(GetForegroundWindow(), "OK");
        sleep($sleeptime);
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 advanced_button

$ret = advanced_button(filer_ip => $ip, share => $share, drive => $drive,
                       whnd => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Handles the advanced offline settings button.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item option

(Optional): Option for going offline notification.
Defaults to notify, when going offline.

=back

=item Returns

Returns 1 if the share is in listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub advanced_button(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR },
            option   => { type => SCALAR, default => 'notify',
                          regex => qr/^(notify|never)$/ }
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, @list, $prev_idx);
    my($id, $ret, @advance_wnds, $k, $option, $mycomputer);
    my($hwnd, $j, $state);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};
    $option = $opts{option};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $ret = select_listview_item(whnd   => $whandle,
                                target => "$mycomputer",
                                item   => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("o");
        sleep($sleeptime);

        @wnds = GetChildWindows(GetForegroundWindow());
        foreach $i (@wnds) {
            $class = GetClassName($i);
            if ($class =~ /^(SysTabControl32)$/) {
                TabCtrl_SetCurFocus($i, 3);
                $prev_idx = TabCtrl_SetCurSel($i, 3);
                sleep($sleeptime);
                PushChildButton(GetForegroundWindow(), "Ad&vanced");
                last;
            }
        }

        sleep($sleeptime);
        @advance_wnds = FindWindowLike(undef,
                                       "Offline Files - Advanced Settings", '');
        if ($advance_wnds[0]) {
            SetForegroundWindow($advance_wnds[0]);
            @wnds = GetChildWindows($advance_wnds[0]);
            foreach $i (@wnds) {
                $text = WMGetText($i);
                $class = GetClassName($i);
                $id = GetWindowID($i);

                if ($text eq '&Notify me and begin working offline') {
                    $state = IsCheckedButton($i);
                    if ($option eq 'notify') {
                        if (!$state) {
                            SetFocus($i);
                            SendKeys("n");
                        }
                    }
                }

                if ($text eq 'Ne&ver allow my computer to go offline') {
                   $state = IsCheckedButton($i);
                   if ($option eq 'never') {
                       if (!$state) {
                           SetFocus($i);
                           SendKeys("v");
                       }
                   }
               }
            }
        }

        PushChildButton(GetForegroundWindow(), "OK");
        sleep($sleeptime);

        PushChildButton(GetForegroundWindow(), "OK");
        sleep($sleeptime);
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 view_files

$ret = view_files(filer_ip => $filer_ip,
                  share    => $share,
                  drive    => $drive,
                  whnd     => $whnd);

This function is used to view the files in the offline files folder, and to
sync selected files.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to where file is stored

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the offline files folder is displayed and are allowed
to sync selected items, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub view_files(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR }
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, $prev_idx);
    my($id, $ret, $offline_wnds, $k, $option, $folder_options);
    my($mycomputer, $hwnd, $j, $sync_wnd);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};
    $option = $opts{option};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $ret = select_listview_item(whnd   => $whandle,
                                target => "$mycomputer",
                                item   => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("o");
        sleep($sleeptime);

        $ret = 0;
        $folder_options = _wait_window_by_name(name => 'Folder Options');
        if ($folder_options) {
            @wnds = GetChildWindows($folder_options);
            foreach $i (@wnds) {
                $class = GetClassName($i);
                if ($class =~ /^(SysTabControl32)$/) {
                    TabCtrl_SetCurFocus($i, 3);
                    $prev_idx = TabCtrl_SetCurSel($i, 3);
                    sleep($sleeptime);
                    PushChildButton($folder_options, "Vie&w Files");
                    sleep($sleeptime);
                    $ret = 1;
                    last;
                }
            }
        }

        $offline_wnds = _wait_window_by_name(name => 'Offline Files Folder');
        if ($ret == 1 && $offline_wnds) {
            SetForegroundWindow($offline_wnds);

            # Select files to sync
            SendKeys("%e");
            sleep($sleeptime);
            SendKeys("a");
            sleep($sleeptime);

            # Menu
            SendKeys("%t");
            sleep($sleeptime);
            SendKeys("s");
            sleep($sleeptime);

            $sync_wnd = _wait_window_by_name(name => 'Items to Synchronize');
            if ($sync_wnd) {
                SetForegroundWindow($sync_wnd);
                PushChildButton($sync_wnd, "&Synchronize");
                sleep(1);

                $hwnd = GetForegroundWindow();
                $text = WMGetText($hwnd);
                if ($text eq 'Network Version of File Missing') {
                    PushChildButton($hwnd, "OK");
                    sleep($sleeptime);
                    $ret = 0;
                } elsif ($text eq 'Close Open Files') {
                    SendKeys("{ENTER}");
                    sleep($sleeptime);
                } elsif ($text eq 'Synchronizing') {
                    while ($text eq 'Synchronizing') {
                        sleep($sleeptime);
                        $hwnd = GetForegroundWindow();
                        $text = WMGetText($hwnd);
                    }
                }
            }

            $sync_wnd = _wait_window_by_name(name => 'Synchronization Complete',
                                             timeout => 5);
            if ($sync_wnd) {
                PushChildButton($sync_wnd, "Clo&se");
            }

            # Menu
            SetForegroundWindow($offline_wnds);
            SendKeys("%f");
            sleep($sleeptime);
            SendKeys("c");
            sleep($sleeptime);
        }

        if ($folder_options) {
            SetForegroundWindow($folder_options);
            PushChildButton($folder_options, "OK");
            sleep($sleeptime);
        }
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 delete_offline_files

$ret = delete_offline_files(filer_ip => $ip, share => $share,
                            drive => $drive, whnd => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Handles the delete button in the folder tools options menu item.
Used to delete offline files.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item option

(Optional): Option to delete both temporary files or all files.
Defaults to temp.

=back

=item Returns

Returns 1 if the share is in the listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub delete_offline_files(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR },
            option   => { type => SCALAR, default => 'temp',
                          regex => qr/^(temp|both)$/ }
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, @list, $prev_idx);
    my($id, $ret, @delete_wnds, $k, $option, $mycomputer);
    my($hwnd, $j, $state);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};
    $option = $opts{option};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $ret = select_listview_item(whnd   => $whandle,
                                target => "$mycomputer",
                                item   => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("o");
        sleep($sleeptime);

        @wnds = GetChildWindows(GetForegroundWindow());
        foreach $i (@wnds) {
            $class = GetClassName($i);
            if ($class =~ /^(SysTabControl32)$/) {
                TabCtrl_SetCurFocus($i, 3);
                $prev_idx = TabCtrl_SetCurSel($i, 3);

                @list = GetChildWindows(GetForegroundWindow());
                foreach $j (@list) {
                    $text = WMGetText($j);
                    $class = GetClassName($j);
                    $id = GetWindowID($j);
                    if ($text eq '&Delete Files...') {
                        PushChildButton(GetForegroundWindow(), "&Delete Files...");
                        sleep($sleeptime);
                        @delete_wnds = GetChildWindows(GetForegroundWindow());
                        foreach $k (@delete_wnds) {
                            $text = WMGetText($k);
                            $class = GetClassName($k);
                            $id = GetWindowID($k);
                            if ($text eq 'Delete only the &temporary offline '.
                                         'versions') {
                                $state = IsCheckedButton($k);
                                if ($option eq 'temp') {
                                    if (!$state) {
                                        SetFocus($k);
                                        SendKeys("t");
                                    }
                                }
                            }

                            if ($text eq 'Delete &both the temporary offline '.
                                         'versions and the versions that are '.
                                         'always available offline.') {
                                $state = IsCheckedButton($k);
                                if ($option eq 'both') {
                                    if (!$state) {
                                        SetFocus($k);
                                        SendKeys("b");
                                    }
                                }
                            }
                        }
                    }
                }

                last;
            }
        }

        PushChildButton(GetForegroundWindow(), "OK");
        sleep($sleeptime);
        PushChildButton(GetForegroundWindow(), "OK");
        sleep($sleeptime);
        PushChildButton(GetForegroundWindow(), "OK");
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 offline_shortcut

$ret = offline_shortcut(whnd => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Creates an offline files folder shortcut on the desktop.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the offline files folder is in the listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub offline_shortcut(%) {
    my %opts = validate(
        @_,
        {
            whnd => { type => SCALAR },
        }
    );

    my($treeview_path, $whnd, $ret);

    $whnd = $opts{whnd};
    $treeview_path = "Shortcut to Offline Files";

    $ret = select_listview_item(whnd   => $whnd,
                                target => "Desktop",
                                item   => $treeview_path);

    return $ret;
}

#--------------------------------------------------------------

=head2 sync_via_tools

$ret = sync_via_tools(filer_ip => $filer_ip,
                      share    => $share,
                      drive    => $drive,
                      whnd     => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Sync a offline folder via the tools menu option.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the item found in listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub sync_via_tools(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR },
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, @list, $prev_idx);
    my($id, $ret, $menu_id, $cnt, %menu_item, $sync_item, $mycomputer);
    my(@offline_wizard, $hwnd, $j, $state);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $ret = select_listview_item(whnd   => $whandle,
                                target => "$mycomputer",
                                item   => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("o");
        sleep($sleeptime);

        @wnds = GetChildWindows(GetForegroundWindow());
        foreach $i (@wnds) {
            $class = GetClassName($i);
            if ($class =~ /^(SysTabControl32)$/) {
                TabCtrl_SetCurFocus($i, 3);
                $prev_idx = TabCtrl_SetCurSel($i, 3);

                @list = GetChildWindows(GetForegroundWindow());
                foreach $j (@list) {
                    $text = WMGetText($j);
                    $class = GetClassName($j);
                    $id = GetWindowID($j);

                    if ($text eq '&Enable Offline Files') {
                        $state = IsCheckedButton($j);
                        if (!$state) {
                            CheckButton($j);
                        }
                    }

                    if ($text eq '&Create an Offline Files shortcut on the desktop') {
                        $state = IsCheckedButton($j);
                        if (!$state) {
                            CheckButton($j);
                        }
                    }

                    if ($text eq 'E&ncrypt offline files to secure data') {
                        $state = IsCheckedButton($j);
                        if (!$state) {
                            CheckButton($j);
                        }
                    }

                    if ($text eq 'Display a &reminder every:') {
                        $state = IsCheckedButton($j);
                        if (!$state) {
                            CheckButton($j);
                        }
                    }

                    if ($class eq 'Edit') {
                        WMSetText($j, '1');
                    }
                }

                PushChildButton(GetForegroundWindow(), "&Apply");
                sleep($sleeptime);
                last;
            }
        }

        PushChildButton(GetForegroundWindow(), "OK");
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 select_listview_item

$ret = select_listview_item(whnd     => $win,
                            target   => $target,
                            item     => $item,
                            wnd_text => $text);

Passed a window handle to "Explorer My Computer" GUI.
Selects an item from the listview.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item target

(Required): target for explorer address edit control

=item item

(Required): list item to select in target

=item wnd_text

(Optional): window text of window to wait for,
defaults to target name

=back

=item Returns

Returns 1 if the item found in listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------
sub select_listview_item(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            target   => { type => SCALAR },
            item     => { type => SCALAR },
            wnd_text => { type => SCALAR, optional => 1 }
        }
    );

    my ($my_explorer, $my_target, $listview_item, $ret);
    my($class, $i, @wnds, @list, @windows, $wind_text);

    $my_explorer   = $opts{whnd};
    $my_target     = $opts{target};
    $listview_item = $opts{item};
    $wind_text     = exists($opts{wnd_text}) ? $opts{wnd_text} : $my_target;

    $ret = 0;

    SetActiveWindow($my_explorer);
    SetFocus($my_explorer);

    @wnds = GetChildWindows($my_explorer);
    foreach $i (@wnds) {
        $class = GetClassName($i);

        if ($class =~ /^(Edit)$/) {
            SetFocus($i);
            WMSetText($i, $my_target);
            SendKeys("{ENTER}");
            last;
        }
    }

    $windows[0] = _wait_window_by_name(name => $wind_text);
    if (!$windows[0]) {
        my $hwnd = GetForegroundWindow();
        my $text = WMGetText($hwnd);
        if ($text eq $wind_text) {
            $windows[0] = $hwnd;
        }
    }

    if ($windows[0]) {
        @wnds = GetChildWindows($windows[0]);
        foreach $i (@wnds) {
            $class = GetClassName($i);

            if ($class =~ /^(SysListView32)$/) {
                @list = GetListViewContents($i);
                if (@list) {
                    SelListViewItemText($i, $listview_item);
                    if (IsListViewItemSel($i, $listview_item)) {
                        SetFocus($i);
                        $ret = 1;
                        last;
                    }
                }
            }
        }
    }

    sleep($sleeptime);
    return $ret;
}

#--------------------------------------------------------------

=head2 sync_folder

$ret = sync_folder(filer_ip => $filer_ip,
                   share    => $share,
                   drive    => $drive,
                   whnd     => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Syncs a folder with the filer's share.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the share is in the listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub sync_folder(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR },
        }
    );

    my($filer_ip, $hwnd, $i, $item_found, $label, %menu_item, $mycomputer,
       $share, $share_drive, $text, $treeview_path, $whandle, @wnds);

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};

    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $mycomputer = get_my_computer_name();
    $item_found = select_listview_item(whnd   => $whandle,
                                       target => "$mycomputer",
                                       item   => $treeview_path);
    if ($item_found) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("y");
        sleep($sleeptime * 4);

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);

        # There is a chance the Windows client explorer has crashed.
        # Search through the windows to see if there are any error windows.
        foreach $label ('Windows Explorer', 'Task List',
                        'DrWatson Postmortem Debugger') {
            sleep($sleeptime);
            @wnds = FindWindowLike(undef, $label, '');
            foreach $i (@wnds) {
                if ($item_found) {
                    # First time save image of desktop if this routine failed
                    save_win_as_bmpfile(window => GetDesktopWindow());
                }
                SetActiveWindow($i);
                SetFocus($i);
                # Closes failure window
                SendKeys("{ENTER}");
                sleep($sleeptime);
                $item_found = 0;
            }
        }
        if ($item_found == 0) {
            logcomment('BURT: sync_folder: Windows Explorer encountered a ' .
                'problem and was closed. Either an ONTAP or Windows Burt.');
            return 0;
        }

        if ($text eq 'Network Version of File Missing') {
            PushChildButton($hwnd, "OK");
        } elsif ($text eq 'Close Open Files') {
            SendKeys("{ENTER}");
        } elsif ($text eq 'Synchronizing') {
            $i = 0;
            while ($text eq 'Synchronizing' && $i++ < 10) {
                sleep($sleeptime);
                $hwnd = GetForegroundWindow();
                $text = WMGetText($hwnd);
            }

            $hwnd = GetForegroundWindow();
            $text = WMGetText($hwnd);
            if ($text eq $sync_window) {
                PushChildButton($hwnd, "Clo&se");
            } elsif ($text eq 'Network Version of File Missing') {
                PushChildButton($hwnd, "OK");
            }
        } else {
            # Unknown condition
            $item_found = 0;
        }
        sleep($sleeptime);
    }
    return $item_found;
}

#--------------------------------------------------------------

=head2 manual_sync

$ret = manual_sync(filer_ip => $filer_ip,
                   share    => $share,
                   drive    => $drive,
                   file     => $file,
                   whnd     => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Manually syncs local file with net work file.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to where file is stored

=item drive

(Required): drive on windows client where share is mapped to

=item file

(Required): name of file to manually sync

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=item Returns

Returns 1 if the file is in the listview, 0 otherwise.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub manual_sync(%) {
    my %opts = validate(
        @_,
        {
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            file     => { type => SCALAR },
            whnd     => { type => SCALAR },
        }
    );

    my($filer_ip, $whandle, $share, $share_drive, $treeview_path);
    my($ret, $file, $hwnd, $text, $i, $class);
    my($sync, $resolve, $close, $missing) = 0;

    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $file = $opts{file};
    $whandle = $opts{whnd};
    $treeview_path = "$share on \'$filer_ip\' ($share_drive)";

    $ret = select_listview_item(whnd     => $whandle,
                                target   => "$share_drive\\",
                                item     => $file,
                                wnd_text => $treeview_path);
    if ($ret) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("y");
        sleep($sleeptime * 4);

        _access_denied_popup(wnd_txt => $treeview_path);

        my $desk = GetDesktopWindow();
        my @desk_wnds = GetChildWindows($desk);
        foreach my $j (@desk_wnds) {
            my $desk_text = WMGetText($j);

            if (($desk_text eq 'Synchronizing') ||
                ($desk_text eq 'Close Open Files')) {
                $sync = $j;
                # Took out SetForegroundWindow and 'last'
                # If 'Close Open Files' there and 'Synchronizing' found first,
                # 'Close Open Files' will drop below and not get closed,
                # resulting in hang. This allows the 'Close Open Files' window
                # to stay in the foreground to be handled.

                # SetForegroundWindow($sync);
                SetActiveWindow($sync);
                SetFocus($sync);
                # last;
            } elsif (($desk_text eq 'Resolve File Conflicts')) {
                $resolve = $j;
            } elsif (($desk_text eq 'Network Version of File Missing')) {
                $missing = $j;
            }
        }

        if ($resolve) {
            SetForegroundWindow($resolve);
            SetActiveWindow($resolve);
            sleep($sleeptime);
            SetFocus($resolve);
            sleep($sleeptime);
            PushChildButton($hwnd, "OK");
            sleep($sleeptime);
        }

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);
        $class = GetClassName($hwnd);

        while ($text eq 'Synchronizing' ||
               $text eq 'Network Version of File Missing' ||
               $text eq 'Close Open Files' ||
               $text eq 'Resolve File Conflicts') {
            if ($text eq 'Network Version of File Missing') {
                MouseClick(2193, $hwnd);
                sleep($sleeptime);
                PushChildButton($hwnd, "OK");
            } elsif ($text eq 'Close Open Files') {
                SendKeys("{ENTER}");
                sleep($sleeptime);
            } elsif ($text eq 'Resolve File Conflicts') {
                SetForegroundWindow($resolve);
                SetActiveWindow($resolve);
                SetFocus($resolve);
                PushChildButton($hwnd, "OK");
                sleep($sleeptime);
            }

            $hwnd = GetForegroundWindow();
            $text = WMGetText($hwnd);

            sleep($sleeptime);
        }
    }

    _access_denied_popup(wnd_txt => $treeview_path);

    return $ret;
}

#--------------------------------------------------------------

=head2 sync_via_my_network

sync_via_my_network(filer    => $filer,
                    filer_ip => $filer_ip,
                    share    => $share,
                    drive    => $drive,
                    whnd     => $whnd);

Passed a window handle to "Explorer My Computer" GUI.
Syncs an offline share with filer via my network.

The following named arguments are accepted,

=over

=item Arguments

=over

=item filer

(Required): name of the filer

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item drive

(Required): drive on windows client where share is mapped to

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=back

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub sync_via_my_network(%) {
    my %opts = validate(
        @_,
        {
            filer    => { type => SCALAR },
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            drive    => { type => SCALAR },
            whnd     => { type => SCALAR },
        }
    );

    my($class, $text, $i, $filer_ip, $whandle, $whandle2);
    my($share, $share_drive, @wnds, $treeview_path, @list);
    my($id, $menu_id, $cnt, %menu_item, $sync_item);
    my(@offline_wizard, $hwnd, $filer, $j, $ret);

    $filer = $opts{filer};
    $filer_ip   = $opts{filer_ip};
    $share   = $opts{share};
    $share_drive = $opts{drive};
    $whandle = $opts{whnd};

    $treeview_path = "$share on $filer";
    $sync_item = "\\\\$filer_ip\\$share on $filer_ip";

    $ret = select_listview_item(whnd     => $opts{whnd},
                                target   => 'My Network Places',
                                item     => $treeview_path);

    if ($ret) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("s");
        sleep($sleeptime);

        $ret = 0;
        $hwnd = GetForegroundWindow();
        @wnds = GetChildWindows($hwnd);
        foreach $i (@wnds) {
            $text = WMGetText($i);
            $class = GetClassName($i);

            if ($class =~ /^(SysListView32)$/) {
                @list = GetListViewContents($i);
                if (@list) {
                    SelListViewItemText($i, $sync_item);
                    if (IsListViewItemSel($i, $sync_item)) {
                        SetFocus($i);
                        $ret = 1;
                        last;
                    }
                }
            }
        }

        PushChildButton($hwnd, "&Synchronize");
        sleep($sleeptime * 10);
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 folder_avail_offline

$ret = folder_avail_offline(whnd     => $win,
                            filer_ip => $filer_ip,
                            share    => $share,
                            folder   => $folder,
                            drive    => $drive,
                            option   => 'yes');

Passed a window handle to "Explorer My Computer" GUI.
Makes a share available offline.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item filer_ip

(Required): the filer's ip address

=item share

(Required): name of share to make available offline

=item folder

(Required): folder to use

=item drive

(Required): drive on windows client where share is mapped to

=item option

(Optional): option to make share available or not available offline.
Default to make available offline.

=back

=item Returns

Returns 1 or 0 depending on option. If option 'yes' returns 1
if share was not available offline, returns 0 if was available offline.
If option 'no' returns 1 if share was available offline, returns 0
if share was not available offline.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub folder_avail_offline(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            filer_ip => { type => SCALAR },
            share    => { type => SCALAR },
            folder   => { type => SCALAR },
            drive    => { type => SCALAR },
            option   => { type => SCALAR, default => 'yes',
                          regex => qr/^(yes|no)$/  }
        }
    );

    my ($whandle, $folder, $drive, $filer_ip, $share);
    my ($item_found, $msg2, $hwnd, $text, $wnd_text);

    $whandle  = $opts{whnd};
    $filer_ip = $opts{filer_ip};
    $share    = $opts{share},
    $folder   = $opts{folder};
    $drive    = $opts{drive};

    $wnd_text = "$share on \'$filer_ip\' ($drive)";

    $item_found = 0;

    $item_found = select_listview_item(whnd     => $whandle,
                                       target   => "$drive",
                                       item     => "$folder",
                                       wnd_text => $wnd_text);

    if ($item_found) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("a");
        sleep($sleeptime);

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);

        if ($text eq $remove_offline_folders) {
            if ($opts{option} eq 'yes') {
                PushChildButton($hwnd, "Cancel");
            } else {
                PushChildButton($hwnd, "OK");
            }
        } elsif ($text eq $offline_files) {
            PushChildButton($hwnd, "Cancel");
        } elsif ($text eq $confirm_offline_subfolders) {
            SendKeys("{DOWN}");
            sleep($sleeptime);
            PushChildButton($hwnd, "OK");
            sleep($sleeptime * 2);
        } else {
            return 0;
        }
    }
    return $item_found;
}

#--------------------------------------------------------------

=head2 folder_properties

$ret = folder_properties(whnd     => $whnd,
                         target   => $target,
                         item     => $item,
                         drive    => $drive,
                         action   => $action);

Passed a window handle to Explorer, opens a folders properties
window for folder redirection or restoration to default location
based on param action.

The following named arguments are accepted,

=over

=item Arguments

=over

=item whnd

(Required): handle to Explorer window

=item target

(Required): where folder resides, (Desktop)

=item item

(Required): folder in target, folder to opens properties window for.

=item drive

(Required): if action is folder redirection, share drive to redirect
folder to.

=item action

(Optional): action to take, folder redirection (redirect) or
restoration (restore) to default location. Defaults to 'redirect'.

=back

=item Returns

Returns 1 if action successful, 0 otherwise.

=back

=for html <hr />

=cut

#--------------------------------------------------------------

sub folder_properties(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            target   => { type => SCALAR },
            item     => { type => SCALAR },
            drive    => { type => SCALAR },
            action   => { type => SCALAR, default => 'redirect',
                          regex => qr/^(redirect|restore)$/ },
        }
    );

    my ($item_found, $hwnd, $ret, $text, @wnds);

    $item_found = 0;
    $ret = 0;

    $item_found = select_listview_item(whnd     => $opts{whnd},
                                       target   => $opts{target},
                                       item     => $opts{item});

    if ($item_found) {
        # Menu
        SendKeys("%f");
        sleep($sleeptime);
        SendKeys("r");
        sleep($sleeptime);

        $hwnd = GetForegroundWindow();
        $text = WMGetText($hwnd);

        if ($text eq "$opts{item} Properties") {
            if ($opts{action} eq 'redirect') {
                $ret = _folder_redirect(whnd  => $hwnd,
                                        item  => $opts{item},
                                        drive => $opts{drive});
                if ($ret == 0) {
                    PushChildButton($hwnd, "Cancel");
                } else {
                    PushChildButton($hwnd, "OK");
                }
            } else {
                _folder_restore(whnd => $hwnd);
                PushChildButton($hwnd, "OK");
                $ret = 1;
            }
        }
    }

    sleep($sleeptime);
    return $ret;
}

#----------------------------------------------------------------------
#
# _folder_redirect (Internal use only subroutine)
#
# _folder_redirect(whnd  => $whnd,
#                  item  => $item,
#                  drive => $drive);
#
# description
#
# Redirect a folder from its default location to a share on the filer.
# Passed a window handle a folders Explorer properties window
# redirects a folder from its original location to a mapped share
# on the filer
#
# The following named arguments are accepted:
#
# whnd
#
# (Required) : window handle to a folders explorer properties
# window.
#
# item
#
# (Required) : the folder to redirect.
#
# drive
#
# (Required) : share drive where to redirect folder to.
#
# Returns
#
# Returns 1 if folder redirection successful, 0 otherwise.
#
#----------------------------------------------------------------------

sub _folder_redirect(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
            item     => { type => SCALAR },
            drive    => { type => SCALAR },
        }
    );

    my ($drive, $text, @wnds, $i, $class, $set, $create_hwnd);
    my ($desk, @desk_wnds, $ret);

    $ret = 0;

    @wnds = GetChildWindows($opts{whnd});
    foreach $i (@wnds) {
        $text = WMGetText($i);
        $class = GetClassName($i);
        if ($class =~ /^(Edit)$/ && $text =~ /$opts{item}/) {
            $set = WMSetText($i, "$opts{drive}\\$opts{item}");
            PushChildButton($opts{whnd}, "&Apply");
            sleep($sleeptime * 2);

            $desk = GetDesktopWindow();
            @desk_wnds = GetChildWindows($desk);
            foreach my $j (@desk_wnds) {
                my $desk_text = WMGetText($j);
                if ($desk_text eq 'Create Folder') {
                    $create_hwnd = $j;
                    PushChildButton($j, "&Yes");
                    sleep($sleeptime);
                    last;
                }
            }

            $desk = GetDesktopWindow();
            @desk_wnds = GetChildWindows($desk);
            foreach my $j (@desk_wnds) {
                my $desk_text = WMGetText($j);
                if ($desk_text eq 'Move Documents') {
                    PushChildButton($j, "&Yes");
                    sleep($sleeptime * 4);
                    $ret = 1;
                    last;
                }
            }
            last;
        }
    }

    # If there was an error there may be Target popup windows that
    # need to be closed. Do not set the return value to 0 here as
    # it also picks up the 'Target' tab in the window which is not
    # an error popup window. If there was an error, there will be an
    # Invalid Target popup window.
    $desk = GetDesktopWindow();
    @desk_wnds = GetChildWindows($desk);
    foreach $i (@desk_wnds) {
        $text = WMGetText($i);
        if ($text eq 'Target') {
            PushChildButton($i, "OK");
            sleep($sleeptime);
        }
    }

    # If there was an error there may be Invalid Target popup windows that
    # need to be closed.
    $ret = _access_denied_popup(wnd_txt => 'Invalid Target');

    return $ret;
}

#----------------------------------------------------------------------
#
# _folder_restore (Internal use only subroutine)
#
# _folder_restore(whnd => $whnd);
#
# description
#
# Redirect a folder to its default location.
# Passed a window handle a folders Explorer properties window
# redirects a folder to its original location.
#
# The following named arguments are accepted:
#
# whnd
#
# (Required) : window handle to a folders explorer properties
# window.
#
#----------------------------------------------------------------------

sub _folder_restore(%) {
    my %opts = validate(
        @_,
        {
            whnd     => { type => SCALAR },
        }
    );

    my ($text);

    PushChildButton($opts{whnd}, "Restore Default");
    sleep($sleeptime);
    PushChildButton($opts{whnd}, "&Apply");
    sleep($sleeptime * 2);

    my $desk = GetDesktopWindow();
    my @desk_wnds = GetChildWindows($desk);
    foreach my $j (@desk_wnds) {
        my $desk_text = WMGetText($j);
        if ($desk_text eq 'Move Documents') {
            PushChildButton($j, "&No");
            sleep($sleeptime * 4);
            last;
        }
    }

    $desk = GetDesktopWindow();
    @desk_wnds = GetChildWindows($desk);
    foreach my $j (@desk_wnds) {
        my $desk_text = WMGetText($j);
        if ($desk_text eq 'Move Target') {
            PushChildButton($j, "&No");
            sleep($sleeptime);
            last;
        }
    }

    $desk = GetDesktopWindow();
    @desk_wnds = GetChildWindows($desk);
    foreach my $j (@desk_wnds) {
        my $desk_text = WMGetText($j);
        if ($desk_text eq 'Error Moving File or Folder') {
            PushChildButton($j, "OK");
            sleep($sleeptime);

            my $fore = GetForegroundWindow();
            my $fore_text = WMGetText($fore);

            if ($fore_text eq 'Error Moving Documents') {
                PushChildButton($fore, "OK");
                sleep($sleeptime);
            }
            last;
        }
    }
    return;
}

#----------------------------------------------------------------------
#
# _access_denied_popup (Internal use only subroutine)
#
# _access_denied_popup(wnd_txt => $text);
#
# description
#
# Handles the Access Denied popup window. Returns 0 if a popup window
# was closed, 1 otherwise.
#
#----------------------------------------------------------------------

sub _access_denied_popup(%) {
    my %opts = validate(
        @_,
        {
            wnd_txt => { type => SCALAR },
        }
    );

    my ($i, $ret);

    # Look for Access denied popup window
    $ret = 1;
    for ($i = 0; $i < 10; $i++) {
        my $desk = GetDesktopWindow();
        my @desk_wnds = GetChildWindows($desk);
        foreach my $j (@desk_wnds) {
            my $desk_text = WMGetText($j);
            my $desk_class = GetClassName($j);
            if (($desk_text eq $opts{wnd_txt}) &&
                ($desk_class eq '#32770')) {
                PushChildButton($j, "OK");
                sleep($sleeptime * 2);
                $ret = 0;
                last;
            }
        }
    }
    return $ret;
}

#--------------------------------------------------------------

=head2 explorer_map_drive

$drive = explorer_map_drive(window => $hwnd,
                            filer  => $filer,
                            share  => $share,
                            user   => $user,
                            pass   => $pass);

This function is used to map a share onto a network drive via explorer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item filer

(Required): the filer's name

=item share

(Required): name of share to map

=item user

(Required): user to map share

=item pass

(Required): user's password

=back

=item Returns

Returns the drive letter which the share is mapped to.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub explorer_map_drive(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            share  => { type => SCALAR },
            user   => { type => SCALAR },
            pass   => { type => SCALAR }
        }
    );

    my($filer, $hwnd, $share, $share_drive, $treeview_path);
    my($drive, $file, $text, @wnds);
    my($i, $class, $id, $user, $pass);

    $filer = $opts{filer};
    $share = $opts{share};
    $user  = $opts{user};
    $pass  = $opts{pass};
    $hwnd  = $opts{whnd};

    # Menu
    SendKeys("%t");
    sleep($sleeptime);
    SendKeys("n");
    sleep($sleeptime);

    my $map_drive = _wait_window_by_name(name => "Map Network Drive");
    if ($map_drive) {
        my @desk_wnds = GetChildWindows($map_drive);
        foreach my $j (@desk_wnds) {
            my $desk_text  = WMGetText($j);
            my $desk_class = GetClassName($j);
            my $desk_id    = GetWindowID($j);

            if ($desk_class eq 'ComboBox' && $desk_id == 1036) {
                $drive = $desk_text;
            }

            if ($desk_class eq 'ComboBox' && $desk_id == 1034) {
                SetFocus($j);
                SendKeys("\\\\$filer\\$share");
                sleep($sleeptime);
            }

            if ($desk_class eq 'Link Window' && $desk_id == 1044) {
                SetFocus($j);
                SendKeys("{ENTER}");
            }
        }

        my $connect = _wait_window_by_name(name => "Connect As");
        if ($connect) {
            my @desk_wnds = GetChildWindows($connect);
            foreach my $j (@desk_wnds) {
                my $desk_text  = WMGetText($j);
                my $desk_class = GetClassName($j);
                my $desk_id    = GetWindowID($j);

                if ($desk_class eq 'Edit' && $desk_id == 1003) {
                    SetFocus($j);
                    SendKeys("$user");
                    sleep($sleeptime);
                }

                if ($desk_class eq 'Edit' && $desk_id == 1005) {
                    SetFocus($j);
                    SendKeys("$pass");
                    sleep($sleeptime);
                }
            }

            PushChildButton($connect, "OK");
            sleep($sleeptime);
        }

        PushChildButton($map_drive, "Finish");
        sleep($sleeptime);
    }
    return $drive;
}

#--------------------------------------------------------------

=head2 explorer_unmap_drive

$ret = explorer_unmap_drive(window => $hwnd,
                            filer  => $filer,
                            share  => $share,
                            drive  => $drive);

This function is used to unmap a network via explorer.

The following named arguments are accepted,

=over

=item Arguments

=over

=item window

(Required): handle to Explorer My Computer window opened by
open_my_computer

=item filer

(Required): the filer's name

=item share

(Required): name of share to unmap

=item drive

(Required): drive letter to disconnect

=back

=item Returns

Returns 1.

=back

=for html <hr />

=cut
#--------------------------------------------------------------

sub explorer_unmap_drive(%) {
    my %opts = validate(
        @_,
        {
            window => { type => SCALAR },
            filer  => { type => SCALAR },
            share  => { type => SCALAR },
            drive  => { type => SCALAR },
        }
    );

    my($filer, $hwnd, $share, $drive, $treeview_path, $item_found, @list,
       $mycomputer);
    my $dc_drives = "Disconnect Network Drives";
    my $dc_drive  = "Disconnect Network Drive";

    $filer = $opts{filer};
    $share = $opts{share};
    $drive = $opts{drive};
    $hwnd  = $opts{window};

    $treeview_path = "$share on \'$filer\' ($drive)";

    $mycomputer = get_my_computer_name();
    $item_found = select_listview_item(whnd   => $hwnd,
                                       target => "$mycomputer",
                                       item   => $treeview_path);
    if ($item_found) {
        # Menu
        SendKeys("%t");
        sleep($sleeptime);
        SendKeys("d");
        sleep($sleeptime);

        my $connect = _wait_window_by_name(name => $dc_drives);
        if ($connect) {
            my @desk_wnds = GetChildWindows($connect);
            foreach my $j (@desk_wnds) {
                my $desk_text  = WMGetText($j);
                my $desk_class = GetClassName($j);
                my $desk_id    = GetWindowID($j);

                if ($desk_class =~ /^(SysListView32)$/ &&
                    $desk_text eq "Network Drives") {
                    @list = GetListViewContents($j);
                    if (@list) {
                        SelListViewItemText($j, $drive);
                        if (IsListViewItemSel($j, $drive)) {
                            SendKeys("{ENTER}");
                            sleep($sleeptime);

                            my $dc =
                            _wait_window_by_name(name => $dc_drive);

                            if ($dc) {
                                PushChildButton($dc, "&Yes");
                            }
                        } else {
                            SendKeys("{TAB}");
                            sleep($sleeptime);
                            SendKeys("{ENTER}");
                            sleep($sleeptime);
                        }
                        last;
                    }
                }
            }
        }
    }
    return 1;
}

#---------------------------------------------------------------------

=head2 testme

Self test routine for this library.

Use test_lib.thpl to invoke this routine.

NOTE: This testme routine must be invoked from a minwin compatible
client. The util/test_pkg.thpl script will import the entire Utils_gui.pm
library, which will attempt to import Win32::GuiTest. If the util/test_pkg.thpl
test is not started on a minwin client, the test will fail with a script error.

Example
    ntest -sim PKGNAME="CIFS::Utils_gui" SUBNAME=testme CLIENT='minwin_clnt'
    util/test_pkg.thpl

=over

=item Arguments

=over

=item CLIENT

(Required) : Minwin compatible client on which to run testme.

=back

=back

=for html <hr />

=cut
#----------------------------------------------------------------------

sub testme() {
    use CIFS::CommonParams;
    use Utils qw(subtest_remote);
    use TestEnv::MinWin qw(minwin_compatible);

    my $host = host($main::CLIENT);
    if ($host->hosttype() !~ /windows/ || !minwin_compatible($main::CLIENT)) {
        logresult('CONFIG', 'The host ' . $host->hostname() .
                  ' is not MinWin compatible, exiting.');
        return;
    }

    if ($main::CLIENT ne 'localhost') {
        eval {
            subtest_remote(test   => 'util/test_pkg.thpl',
                           client => $main::CLIENT);
        };

        logresult('CONFIG', $@) if ($@);
        exit(0);
    }

    my $win;

    screen_lock(croak_if_on => 'yes', setting => 'off');

    $win = explorer_open_with_target(target_text => "C:");

    close_window(window => $win);

    logresult('PASS', 'testme(): Utils_gui.pm');

    return;
}

1;
