function adddacls ($file, $user, $dacls, $flags1) {
    foreach ($dacl in $dacls) {
        foreach ($flag in $flags1) {
            echo "Looping with acl=$dacl flag=$flag"
            $acl = get-acl -audit $file
#$acl = new-object system.security.accesscontrol.filesecurity
            $rule = new-object system.security.accesscontrol.filesystemaccessrule($user, $dacl, $flag)
            $acl.addaccessrule($rule)
        }
    }
    $acl | set-acl $file
}

function setdacls_sacls ($file, $user, $dacls, $flags1, $sacls, $flags2) {
    $acl = new-object System.Security.AccessControl.FileSecurity
    $acl = get-acl -audit $file
    $inheritance = [System.Security.AccessControl.InheritanceFlags]"ContainerInherit,ObjectInherit"
    $propagation = [System.Security.AccessControl.PropagationFlags]"None"

#$acl.setaccessruleprotection($false, $true)
    if ($dacls -eq 0){
        echo "No Dacls to be set"
    }else{
        foreach ($dacl in $dacls) {
#            $access = [System.Security.AccessControl.FileSystemRights]"$sacl"
            foreach ($flag in $flags1) {
#                $auditflag = [System.Security.AccessControl.AuditFlags]"$flag"
                if (test-path $file -pathtype container) {
                    $rule = new-object System.Security.AccessControl.FileSystemAccessRule($user, $dacl, $inheritance, $propagation, $flag)
                }
                else {
                    $rule = new-object System.Security.AccessControl.FileSystemAccessRule($user, $dacl, $flag)
                }
                $acl.addaccessrule($rule)
            }
        }
    }

    if ($sacls -eq 0){
        echo "No Sacls to be set"
    }else{
        foreach ($sacl in $sacls) {
            $access = [System.Security.AccessControl.FileSystemRights]"$sacl"
            foreach ($flag in $flags2) {
                $auditflag = [System.Security.AccessControl.AuditFlags]"$flag"
                if (test-path $file -pathtype container) {
                    $rule = new-object System.Security.AccessControl.FileSystemAuditRule($user, $access, $inheritance, $propagation, $auditflag)
                }
                else {
                    $rule = new-object System.Security.AccessControl.FileSystemAuditRule($user, $access, $auditflag)
                }
                $acl.addauditrule($rule)
            }
        }
    }
    $acl | set-acl $file
}

function getops {
    echo "Traverse ExecuteFile ListDirectory ReadData ReadAttributes ReadExtendedAttributes CreateFiles WriteData CreateDirectories AppendData WriteAttributes WriteExtendedAttributes Delete ChangePermissions ReadPermissions TakeOwnership FullControl Read Write ReadAndExecute DeleteSubdirectoriesAndFiles Synchronize Modify"
}

function getflags {
    echo "None Success Failure"
}

function clearacls ($file, $user) {
    $acl = new-object System.Security.AccessControl.FileSecurity
#$acl.setaccessrule($rule)
    $acl | set-acl $file
   # get-acl -audit $file | format-list
}

$file = $args[0]
$who = $args[1]
$dacls = $args[2]
$flags1 = $args[3]
$sacls = $args[4]
$flags2 = $args[5]


echo "$file $who $dacls $flags1 $sacls $flags2"

clearacls $file $who

setdacls_sacls $file $who $dacls $flags1 $sacls $flags2

#get-acl -audit $file | format-list

