# $Id: //depot/prod/test/Rsierranevada/lib/CR/C/DebugSmdbTableRecord.pm#1 $
#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Debug Smdb Table result object
## @author dl-crqa-autov@netapp.com
## @status shared
## @pod here

=head1 NAME

CR::C::DebugSmdbTableRecord

=head1 DESCRIPTION

CR::C::DebugSmdbTableRecord is a class simluated the NACL::C::Component
object. This function provide basic NACL like functions for tables in
Debug Smdb Table <bah> show where <bah> is the table name

This record is read only and will not update if the table row changes

=head1 ATTRIBUTES

=head2 data

The hash of a single table row

=cut

package CR::C::DebugSmdbTableRecord;

use strict;
use warnings;

use Tharn qw($Log);
use Params::Validate qw(:all);
use Data::Dumper;

=head1 METHODS

=head2 NEW

my $record = CR::C::DebugSmdbTableRecord->new( data =>
                ('col1'=>'data1', 'col2'=>'data2'),
             );

Create a CR::C::DebugSmdbTableRecord object

=cut
sub new {
    $Log->enter();

    my ($proto, %args) = @_;
    my $class = ref($proto) || $proto;

    my $self = validate_with(
                    params  => \%args,
                    spec    => {
                        data    => { type => HASHREF, optional => 0 },
                    },);
    my %new_hash = %{$self->{data}};
    $self->{ data } = \%new_hash;
    bless $self, $class;
    $Log->exit();
    return $self;
}

=head1 METHODS

=head2 get_one_state_attribute

imy $column1 = $record->get_one_state_attribute('col1');

=cut
sub get_one_state_attribute{
    $Log->enter();
    my ($self, $key) = @_;
    $Log->exit();
    return $self->{ 'data' }->{$key};
}

1;
