#
# $Id: //depot/prod/test/Rsierranevada/lib/CR/Exceptions/InvalidNetmask.pm#1 $:
#
# Copyright (c) 2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          CR::Exception that will be thrown
##          when an invalid Netmask is passed 
##
## @author ngok@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

CR::Exceptions::InvalidNetmask.pm

=head1 Author

ngok@netapp.com

=head1 Description

An exception for when netmask is detected to be of an invalid value.

=head1 See Also

Package inherits from the Exception module in CR.

=head1 CR::Exceptions::InvalidNetmask

=head2 Expected use

Netmask has to correpond to a bitmask with all 1's as the higher order bits
and all 0's as the lower order bits.
Any deviation from this is a malformed value and
this exception will be thrown.

=head2 Usage

Same as for exceptions defined by Exception.pm

=head2 Base Class

CR::Exception

=cut

package CR::Exceptions::InvalidNetmask;
use base qw(CR::Exception);
1;
