#
# $Id: //depot/prod/test/Rsierranevada/lib/CR/Exceptions/ResidueVolumes.pm#1 $:
#
# Copyright (c) 2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          CR::Exception that will be thrown
##          when residue volumes remain from previous repository of the same name.
##
## @author ngok@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

CR::Exceptions::ResidueVolumes.pm

=head1 Author

ngok@netapp.com

=head1 Description

An exception for when there are volumes remain after deleting the previous repository of the same name
This indicates an error during previous repository deletion.

=head1 See Also

Package inherits from the Exception module in CR.

=head1 CR::Exceptions::ResidueVolumes

=head2 Expected use

After deleting a repository and waited for its completion,
no volumes will be expected on this repository.
If so, this exception will be thrown.

=head2 Usage

Same as for exceptions defined by Exception.pm

=head2 Base Class

CR::Exception

=cut

package CR::Exceptions::ResidueVolumes;
use base qw(CR::Exception);
1;
