################################################################################
# Copyright (c) 2012 NetApp, Inc.
# All rights reserved.
################################################################################

package CR::Setup::Cleanup;

sub new
{
    my $class = shift;
    my $self = {};
    bless $self, $class;

    return $self;
}

sub cleanup
{
    my $self = shift;
    return $self->_cleanup('cleanup', @_);
}

sub uninit
{
    my $self = shift;
    return $self->_cleanup('uninit', @_);
}

sub _cleanup
{
    my $self = shift;
    my $list = shift;
    if (@_) {
        # Add to cleanup list
        push(@{$self->{$list}}, @_);
    } else {
        # Run cleanup list, in LIFO order
        while (my $f = pop(@{$self->{$list}})) {
            $f->();
        }
    }
}

1;
