# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Setup Library Constants
## @author  Adam.Ciapponi@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Constants

=head1 DESCRIPTION

This module contains constants for the setup library;

=head1 METHODS

=cut

package CR::Setup::Constants;

# Compiler directives.
use strict;
use warnings;
use base 'Exporter';
use Readonly;

# Boolean Constants
Readonly our $TRUE  => 1;
Readonly our $FALSE => 0;

# Size Constants
Readonly our $KB => 1024;
Readonly our $MB => 1024 * $KB;
Readonly our $GB => 1024 * $MB;
Readonly our $TB => 1024 * $GB;
Readonly our $PB => 1024 * $TB;

our @EXPORT = qw(
    $TRUE
    $FALSE
    $KB
    $MB
    $GB
    $TB
    $PB
);

1;
