# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Setup Library Constants - 8.2 SierraNevada Version Specific Constants
## @author  Adam.Ciapponi@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Constants::SierraNevada

=head1 DESCRIPTION

This module contains constants for the setup library;

=head1 METHODS

=cut

package CR::Setup::Constants::SierraNevada;

# Compiler directives.
use strict;
use warnings;
use base 'Exporter';
use CR::Setup::Constants;
use Readonly;

# Max/Min/Default Size
Readonly our $WAFL_BLOCK                => 4 * $KB;
Readonly our $DEFAULT_TOLERANCE         => 4 * $WAFL_BLOCK;
Readonly our $CONSTITUENT_CREATION_TAX  => 500 * $KB;
Readonly our $CONSTITUENT_EXPANSION_TAX => 80 * $KB;
Readonly our $DEFAULT_NS_MAX_SIZE       => 10 * $TB;
Readonly our $MIN_NS_SIZE               => 256 * $MB;
Readonly our $DEFAULT_OLS_MAX_SIZE      => 1.5 * $TB;
Readonly our $MIN_OLS_SIZE              => 256 * $MB;

#FIXME: WAFL_AGGR_RESERVE does not apply anymore
Readonly our $WAFL_AGGR_RESERVE                  => 0.07;
Readonly our $THICK_PROVISIONING_RATIO           => 0.9895;
Readonly our $THIN_PROVISIONING_RATIO            => 100;
Readonly our $THICK_PROVISIONING_MAX_SIZE_BUFFER => 10 * $MB;
Readonly our $THIN_PROVISIONING_MAX_SIZE_BUFFER  => 1 * $GB;

our @EXPORT = qw(
    $WAFL_BLOCK
    $DEFAULT_TOLERANCE
    $CONSTITUENT_CREATION_TAX
    $CONSTITUENT_EXPANSION_TAX
    $DEFAULT_NS_MAX_SIZE
    $MIN_NS_SIZE
    $DEFAULT_OLS_MAX_SIZE
    $MIN_OLS_SIZE
    $WAFL_AGGR_RESERVE
    $THICK_PROVISIONING_RATIO
    $THIN_PROVISIONING_RATIO
    $THICK_PROVISIONING_MAX_SIZE_BUFFER
    $THIN_PROVISIONING_MAX_SIZE_BUFFER
);

1;
