# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Defaults
## @author  dl-crqa-auto@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Defaults

=head1 DESCRIPTION

Factory module to initialize defaults for the proper version.

=head1 METHODS

=cut

package CR::Setup::Defaults;

# Compiler directives.
use strict;
use warnings;

use CR::Setup::Exception;
use CR::Setup::Defaults::FullSteam;
use CR::Setup::Defaults::SierraNevada;

=head2 new

This factory method initializes the correct defaults for the version specified.

=cut

sub new {
    my ( $class, $version ) = @_;
    my $defaults;

    if ( $version eq 'latest' ) {
        $defaults = CR::Setup::Defaults::SierraNevada->new();
    }
    elsif ( $version =~ m/^8\.3\./ ) {
        $defaults = CR::Setup::Defaults::FullSteam->new();
    }
    elsif ( $version =~ m/^8\.2\./ ) {
        $defaults = CR::Setup::Defaults::SierraNevada->new();
    }
    else {
        CR::Setup::Exception->throw(
            'Invalid version for CR::Setup::Defaults - ' . $version
        );
    }

    return $defaults;
}

1;
