# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Base Defaults Library
## @author  dl-crqa-auto@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Defaults::Base

=head1 DESCRIPTION

This module implements base defaults

=head1 METHODS

=cut

package CR::Setup::Defaults::Base;
use Moose;

has 'Aggregate' => (
    isa     => 'CR::Setup::Defaults::Base::Aggregate',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::Base::Aggregate->new() },
);

has 'Common' => (
    isa     => 'CR::Setup::Defaults::Base::Common',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::Base::Common->new() },
);

has 'Infinitevol' => (
    isa     => 'CR::Setup::Defaults::Base::Infinitevol',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::Base::Infinitevol->new() },
);

has 'Vserver' => (
    isa     => 'CR::Setup::Defaults::Base::Vserver',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::Base::Vserver->new() },
);

package CR::Setup::Defaults::Base::Aggregate;
use Moose;

has 'diskcount' => (
    isa     => 'Str',
    is      => 'ro',
    default => '3',
);

has 'raidtype' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'raid4',
);

package CR::Setup::Defaults::Base::Common;
use Moose;

has 'timeout' => (
    isa     => 'Str',
    is      => 'ro',
    default => '600',
);

package CR::Setup::Defaults::Base::Infinitevol;
use Moose;

has 'junction-path' => (
    isa     => 'Str',
    is      => 'ro',
    default => '/NS',
    reader  => 'junction_path',
);

has 'snapshot-policy' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'none',
    reader  => 'snapshot_policy',
);

has 'unix-permissions' => (
    isa     => 'Str',
    is      => 'ro',
    default => '---rwxrwxrwx',
    reader  => 'unix_permissions',
);

has 'volume' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'repo_vol',
);

package CR::Setup::Defaults::Base::Vserver;
use Moose;

has 'aggregate' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'vs_aggr',
);

has 'is-repository' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'true',
    reader  => 'is_repository',
);

has 'ns-switch' => (
    isa     => 'ArrayRef[Str]',
    is      => 'ro',
    default => sub { [ 'nis', 'file' ] },
    reader  => 'ns_switch',
);

has 'rootvolume' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'vs0_root',
);

has 'rootvolume-security-style' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'mixed',
    reader  => 'rootvolume_security_style',
);

has 'vserver' => (
    isa     => 'Str',
    is      => 'ro',
    default => 'vs0',
);

1;
