# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Defaults Library - 8.3 FullSteam Release
## @author  dl-crqa-auto@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Defaults::FullSteam

=head1 DESCRIPTION

This module implements defaults for the FullSteam release.

=head1 METHODS

=cut

package CR::Setup::Defaults::FullSteam;
use Moose;

extends 'CR::Setup::Defaults::SierraNevada';

has 'Aggregate' => (
    isa => 'CR::Setup::Defaults::FullSteam::Aggregate',
    is  => 'ro',
    default =>
        sub { return CR::Setup::Defaults::FullSteam::Aggregate->new() },
);

has 'Common' => (
    isa     => 'CR::Setup::Defaults::FullSteam::Common',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::FullSteam::Common->new() },
);

has 'Infinitevol' => (
    isa     => 'CR::Setup::Defaults::FullSteam::Infinitevol',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::FullSteam::Infinitevol->new() },
);

has 'Vserver' => (
    isa     => 'CR::Setup::Defaults::FullSteam::Vserver',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::FullSteam::Vserver->new() },
);

package CR::Setup::Defaults::FullSteam::Aggregate;
use Moose;

extends 'CR::Setup::Defaults::SierraNevada::Aggregate';

package CR::Setup::Defaults::FullSteam::Common;
use Moose;

extends 'CR::Setup::Defaults::SierraNevada::Common';

package CR::Setup::Defaults::FullSteam::Infinitevol;
use Moose;

extends 'CR::Setup::Defaults::SierraNevada::Infinitevol';

package CR::Setup::Defaults::FullSteam::Vserver;
use Moose;

extends 'CR::Setup::Defaults::SierraNevada::Vserver';

1;
