# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Defaults Library - 8.2 SierraNevada Release
## @author  dl-crqa-auto@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Defaults::SierraNevada

=head1 DESCRIPTION

This module implements defaults for the SierraNevada release.

=head1 METHODS

=cut

package CR::Setup::Defaults::SierraNevada;
use Moose;

extends 'CR::Setup::Defaults::Base';

has 'Aggregate' => (
    isa => 'CR::Setup::Defaults::SierraNevada::Aggregate',
    is  => 'ro',
    default =>
        sub { return CR::Setup::Defaults::SierraNevada::Aggregate->new() },
);

has 'Common' => (
    isa     => 'CR::Setup::Defaults::SierraNevada::Common',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::SierraNevada::Common->new() },
);

has 'Infinitevol' => (
    isa     => 'CR::Setup::Defaults::SierraNevada::Infinitevol',
    is      => 'ro',
    default => sub { return CR::Setup::Defaults::SierraNevada::Infinitevol->new() },
);

has 'Vserver' => (
    isa => 'CR::Setup::Defaults::SierraNevada::Vserver',
    is  => 'ro',
    default =>
        sub { return CR::Setup::Defaults::SierraNevada::Vserver->new() },
);

package CR::Setup::Defaults::SierraNevada::Aggregate;
use Moose;

extends 'CR::Setup::Defaults::Base::Aggregate';

package CR::Setup::Defaults::SierraNevada::Common;
use Moose;

extends 'CR::Setup::Defaults::Base::Common';

package CR::Setup::Defaults::SierraNevada::Infinitevol;
use Moose;

extends 'CR::Setup::Defaults::Base::Infinitevol';

package CR::Setup::Defaults::SierraNevada::Vserver;
use Moose;

extends 'CR::Setup::Defaults::Base::Vserver';

1;

