#
# $Id: //depot/prod/test/main/lib/CR/Setup/Exception.pm#1 $:
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of CR::Exception
##          that is the base class of all Setup library exceptions
##
## @author ciapponi@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

CR::Setup::Exception.pm

=head1 Author

ciapponi@netapp.com

=head1 Description

Base exception class for all setup library exceptions.

=head1 See Also

Package inherits from the Exception module in CR.

=head1 CR::Setup::Exception

=head2 Expected use

Use when the setup library returns a generic error.

=head2 Usage

Same as for exceptions defined by Exception.pm

=head2 Base Class

CR::Exception

=cut

package CR::Setup::Exception;
use base qw(CR::Exception);
1;
