#
# $Id: //depot/prod/test/main/lib/CR/Setup/Exceptions/ExpectationNotMetError.pm#1 $:
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of CR::Setup::Exception
##          that provices exceptions for matchers not matching an expectation
##
## @author ciapponi@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

CR::Setup::Exceptions::ExpectationNotMetError.pm

=head1 Author

ciapponi@netapp.com

=head1 Description

Provides an exception for when expectations are not met when using matchers.

=head1 See Also

Package inherits from the Exception module in CR::Setup.

=head1 CR::Setup::Exceptions::ExpectationNotMetError

=head2 Expected use

Use when an expecation is not met when using a matcher.

=head2 Usage

Same as for exceptions defined by Exception.pm

=head2 Base Class

CR::Setup::Exception

=cut

package CR::Setup::Exceptions::ExpectationNotMetError;
use base qw(CR::Setup::Exception);
1;
