# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Setup Deep Equality Matcher
## @author  Adam.Ciapponi@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Matchers::DeeplyEqualMatcher

=head1 DESCRIPTION

This module implements a matcher that determines whether it matches by calling eq_deeply

=head1 METHODS

=cut

package CR::Setup::Matchers::DeeplyEqualMatcher;

# Compiler directives.
use strict;
use warnings;
use CR::Setup::Constants;
use CR::Setup::Unbless;
use Data::Dumper::Concise;
use Test::Deep::NoTest;
use base qw(CR::Setup::Matcher);

=head2 matches

Builds up a string to evaluate comparisons/expressions and return a boolean value.
This only evaluates the value stored in the object, not equality of objects.

=cut

sub matches {
    my ( $self, $target ) = @_;

    $self->{'actual'} = unbless_this($target);

    if ( eq_deeply( $self->{'actual'} , $self->{'expected'} ) ) {
        return $TRUE;
    }
    else {
        return $FALSE;
    }
}
1;
