# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Space - Base
## @author  galane@netapp.com
## @pod     here

=head1 NAME

CR::Setup::BasicSetup::Base

=head1 DESCRIPTION

Base space module.

=cut

package CR::Setup::Space::Base;
use strict;
use warnings;

our @ISA = qw(CR::Setup::Space);

##------------------------------------------------------------
# Public Interfaces
##------------------------------------------------------------

=head2 new

Handles inialization of the space module.

=cut

sub new {
    my $class = shift;
    my %params = @_;

    my $self = {
        helpers  => $params{'helpers'},
        node     => $params{'node'},
    };

    bless $self, $class;
    return $self;
}

1;
