# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Setup Params for Test Driver
## @author  Adam.Ciapponi@netapp.com
## @pod     here

=head1 NAME

CR::Setup::TestParams

=head1 DESCRIPTION

This module implements params that are used by the test driver.

=head1 METHODS

=cut

package CR::Setup::TestParams;
use strict;
use warnings;
use Options;
use Params::Common;

my $Options = new Options;
$Options->parameters(
    definitions => [
        {   name        => 'TESTSETS',
            description => 'Array of test sets that we want to run',
            spec        => 's@',
            default     => ['all']
        },
        {   name        => 'FORCE_VERSION',
            description => 'Value to force the versioning logic to use.',
            spec        => 's',
            default     => 'auto',
        },
    ]
);
$Options->process();

1;
