# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

## @summary Setup Validation Library - Base Version
## @author  Adam.Ciapponi@netapp.com
## @pod     here

=head1 NAME

CR::Setup::Validation::Base

=head1 DESCRIPTION

This module implements version independent validation and is a base class for the version specific validation.

=head1 METHODS

=cut

package CR::Setup::Validation::Base;
use strict;
use warnings;
use CR::Setup::Constants;
use CR::Setup::Expectation;
use Tharn qw($Log);

our @ISA = qw(CR::Setup::Validation);

=head2 new

Basic initialization for the validation library.

=cut

sub new {
    my $class = shift;
    my %params = @_;

    my $self = {
        defaults => $params{'defaults'},
        helpers => $params{'helpers'},
        version => $params{'version'},
    };
    bless $self, $class;
    return $self;
}

1;
