#
# $Id: //depot/prod/test/Rsierranevada/lib/CR/UniqueName.pm#1 $:
#
# Copyright (c) 2010 NetApp Inc.
# All rights reserved.
#
## @summary Generate unique name for the passed in argument kind.
##
## @author ngok@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

CR::UniqueName.pm

=head1 Author

ngok@netapp.com

=head1 Description

This class contains only one method - unique_name.
Unique_name($arg) return a 3 parts name separated by '_'.

=over 4

=item 1.
the argument string.

=item 2.
a unique number for the current process. (the process id.)

=item 3.
a consecutive count starting from 1.

=back

=head2 Example

my $name = unique_name('vserver');
# $name becomes 'vserver_<some-unique-number>_1'

$name = unique_name('volume');
# $name becomes 'volume_<same-unique-number>_1'

$name = unique_name('vserver');
# $name contains 'vserver_<same-unique-number>_2'

=cut

package CR::UniqueName;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(unique_name);

use warnings;

sub unique_name {
    my ($kind) = @_;
    $$kind++;
    return "$kind\_$$\_$$kind";
}

1;
