#
# $Id: //depot/prod/test/Rsierranevada/lib/CR/Vserver.pm#1 $
#
# Copyright (c) 2011 NetApp Inc.
# All rights reserved.
#
## @summary Volume Class
## @author davidnew@netapp.com
## @status shared
## @pod here

package CR::Vserver;

use strict;
use warnings;

use Data::Dumper;
use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::APISet;
use Params::Validate qw(:all);
use SPARSE::Util::Logger;
use Tharn qw($Log);

=head1 NAME

Vserver - The class to encapsulate methods and data of "vserver" commands set

=head1 SYNOPSIS

=begin text

 use Vserver;

 $cr->vserver_show();

 =end text

=head1 AUTHOR

David New (davidnew@netapp.com)

=cut
logLevel('info');

#*****************************************
# Vserver Show
#*****************************************

=head2 vserver_show

Show vserver

Required parameters are

None

=back

=cut

sub vserver_show {
  logStep("Calling vserver show");

  my ($self, %args) = @_;
  my $admin_cli = $self->{ngsh};
  my @parsed_output;

  @parsed_output = @{$admin_cli->vserver_show()->get_parsed_output()};
  logInfo("Vserver show success.\n");
  return @parsed_output;
}

