


sub wait_for_resources {

        my $wait=1;
        while($wait)
        {
                my $flag=0;
                my $response=$APISetCmode->system_health_cluster_switch_fan_show();
                my $parsed=$response->get_parsed_output();
                $flag=1 if(@$parsed[0]);
                $response=$APISetCmode->system_health_cluster_switch_power_show();
                $parsed=$response->get_parsed_output();
                $flag=0 unless((@$parsed[0]) and ($flag));
                $response=$APISetCmode->system_health_cluster_switch_temperature_show();
                $parsed=$response->get_parsed_output();
                $flag=0 unless((@$parsed[0]) and ($flag));
                $response=$APISetCmode->system_health_cluster_switch_interface_show();
                $parsed=$response->get_parsed_output();
                $flag=0 unless((@$parsed[0]) and ($flag));
                $response=$APISetCmode->system_health_cluster_switch_utilization_show();
                $parsed=$response->get_parsed_output();
                $flag=0 unless((@$parsed[0]) and ($flag));
                unless($flag)
                {
                        return $TCD::FAIL if($wait > 60);
                        $Test->nlog("Waiting 15 seconds for devices to get created. $wait*15 seconds lapsed so far");
                        $wait++;
                        sleep 15;
                } else {
                        $wait=0;
                }
        }
        return $TCD::PASS
}

#Returns SNMP MIB of device
# Synopsys: get_snmp_mib(switch type, device, entity)
sub get_snmp_mib {

	my ($type,$device,$entity)=@_;

#NEXUS DEVICES
my %snmp_nexus_device = ( 
'if' => '1.3.6.1.2.1.2.2.1.2',
'fan' => '1.3.6.1.2.1.47.1.1.1.1.7',
'temperature' => '1.3.6.1.2.1.47.1.1.1.1.7' ,
'power' => '1.3.6.1.2.1.47.1.1.1.1.7'
);

#NEXUS CPU
my %snmp_nexus_cpu = (
'5sec_cpu' => '1.3.6.1.4.1.9.9.109.1.1.1.1.6',
'1min_cpu' => '1.3.6.1.4.1.9.9.109.1.1.1.1.7',
'5min_cpu' => '1.3.6.1.4.1.9.9.109.1.1.1.1.8',
'mem_free' => '1.3.6.1.4.1.9.9.109.1.1.1.1.13',
'mem_used' => '1.3.6.1.4.1.9.9.109.1.1.1.1.12',
);

#NEXUS INTERFACE
my %snmp_nexus_if = (
'descr' => '1.3.6.1.2.1.2.2.1.2',
'index' => '1.3.6.1.2.1.2.2.1.1',
'type' => '1.3.6.1.2.1.2.2.1.3',
'mtu' => '1.3.6.1.2.1.2.2.1.4',
'duplexstatus' => '1.3.6.1.2.1.10.7.2.1.19',
'speed' => '1.3.6.1.2.1.31.1.1.1.15',
'adminstatus' => '1.3.6.1.2.1.2.2.1.7',
'operstatus' => '1.3.6.1.2.1.2.2.1.8',
'inoctets' => '1.3.6.1.2.1.2.2.1.10',
'inerrors' => '1.3.6.1.2.1.2.2.1.14',
'indiscards' => '1.3.6.1.2.1.2.2.1.13',
'outoctets' => '1.3.6.1.2.1.2.2.1.16',
'outerrors' => '1.3.6.1.2.1.2.2.1.20',
'outdiscards' => '1.3.6.1.2.1.2.2.1.19'
);                                                          

#NEXUS FAN
my %snmp_nexus_fan = (
'fan_name' => '1.3.6.1.2.1.47.1.1.1.1.7',
'is_fru' => '1.3.6.1.2.1.47.1.1.1.1.16',
'psu_fan' => '1.3.6.1.2.1.47.1.1.1.1.16',
'status' => '1.3.6.1.4.1.9.9.117.1.4.1.1.1'
#'psu_fan' => '1.3.6.1.2.1.47.1.1.1.1.5'
);

#NEXUS TEMPARATURE
my %snmp_nexus_temp = (
'temp_name' => '1.3.6.1.2.1.47.1.1.1.1.7',
'value' => '1.3.6.1.4.1.9.9.91.1.1.1.1.4',
'threshold-sev' => '1.3.6.1.4.1.9.9.91.1.2.1.1.2',
'threshold-val' => '1.3.6.1.4.1.9.9.91.1.2.1.1.4',
'status' => '1.3.6.1.4.1.9.9.91.1.1.1.1.5'
);

#NEXUS POWER
my %snmp_nexus_power = (
'psu_name' => '1.3.6.1.2.1.47.1.1.1.1.7',
'oper_status' => '1.3.6.1.4.1.9.9.117.1.1.2.1.2'
);

	my $variable='snmp_'.$type.'_'.$device;
	$Test->nlog("VARIABLE is : $variable");
	if($variable =~ /snmp_nexus_device/)
	{
		my $mib_id=$snmp_nexus_device{$entity};
		($mib_id) ? return $mib_id:return 0;
	} elsif ($variable =~ /snmp_nexus_cpu/) {
		my $mib_id=$snmp_nexus_cpu{$entity};
		($mib_id) ? return $mib_id:return 0;
	} elsif ($variable =~ /snmp_nexus_if/) {
		my $mib_id=$snmp_nexus_if{$entity};
		($mib_id) ? return $mib_id:return 0;
	} elsif ($variable =~ /snmp_nexus_fan/) {
		my $mib_id=$snmp_nexus_fan{$entity};
		($mib_id) ? return $mib_id:return 0;
	} elsif ($variable =~ /snmp_nexus_power/) {
		my $mib_id=$snmp_nexus_power{$entity};
		($mib_id) ? return $mib_id:return 0;
	} else {
		return 0;
	}
}

sub delete_all_switches {
	try {
  		$APISetCmode->system_health_cluster_switch_delete(device => '*',);
	} 
	catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
		$Test->nlog("There are no switches created");
	};
}

sub exec_snmp {

	my $snmp_command=shift;
 	my $command='/usr/software/bin/snmpwalk -v 2c -c public -Oa '.$SWITCH_IP.' '.$snmp_command;
	my $output=$APISetClient->execute_command(command => $command);
	return $output;
}

sub verify_resources {
	
	my $resource=shift;
	my $fail_flag=$TCD::PASS;
	

	my %device_mib;
	#Verifying Fan resources
	if($resource=~ /fan/)
	{
		my $fan_mibs=get_snmp_mib('nexus','device','fan');
		my $fan_mibs_out=exec_snmp($fan_mibs);
		my @lines=split(/\n/,$fan_mibs_out);
		foreach my $line (@lines)
		{
			if(($line =~ /Fan/) and ($line !~ /Bay/))
			{
				my ($mib_info,$dev_name)=split(/= STRING:/,$line);
				chomp $dev_name;
				chomp $dev_name;
				my @mib_split=split(/\./,$mib_info);
				$mib_info=$mib_split[-1];	
				$device_mib{$dev_name}=$mib_info;
				$Test->nlog("Device Hash:key:$dev_name Value:$device_mib{$dev_name}");
			}
		}
		my @snmp_objects=('fan_name','is_fru','status','psu_fan');
		foreach my $object(@snmp_objects)
		{
			my $mib_id=get_snmp_mib('nexus','fan',$object);
			foreach my $device(keys(%device_mib))
			{
				my $mib_info=$mib_id.'.'.$device_mib{$device};
				my $snmp_out=exec_snmp($mib_info);
				my @snmp_out=split(/:/,$snmp_out);	
				$snmp_out=$snmp_out[-1];
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				$object =~ s/_/\-/;
				if($object =~ /fan\-name/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_fan_show($object => $snmp_out);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				$snmp_out =~ /\d+/;
				$snmp_out=$&;
				if($object =~ /is\-fru/)
				{
					my %is_fru = (
						 	1 => 'yes',
							 2 => 'no'
							);
					my $smf_value=$is_fru{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_fan_show($object => $smf_value, 'fan-name' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $is_fru{$snmp_out} Key is $snmp_out XXXXX");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /status/)
				{
					my %op_status=(1 => 'unknown', 2 => 'operational',3 => 'notoperational', 4 => 'notoperational');
					my $smf_value=$op_status{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_fan_show($object => $smf_value, 'fan-name' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $op_status{$snmp_out}");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /psu\-fan/)
				{
					my %psu_fan=(1 => 'no', 2 => 'yes');
					my $smf_value=$psu_fan{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_fan_show($object => $smf_value, 'fan-name' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $psu_fan{$snmp_out}");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
			}
		}
	}
	if($resource=~ /power/)
	{
		my $fan_mibs=get_snmp_mib('nexus','device','power');
		my $fan_mibs_out=exec_snmp($fan_mibs);
		my @lines=split(/\n/,$fan_mibs_out);
		foreach my $line (@lines)
		{
			if(($line =~ /PowerSupply/) and ($line !~ /(Bay|Fan|Sensor)/))
			{
				my ($mib_info,$dev_name)=split(/= STRING:/,$line);
				chomp $dev_name;
				chomp $dev_name;
				my @mib_split=split(/\./,$mib_info);
				$mib_info=$mib_split[-1];	
				$device_mib{$dev_name}=$mib_info;
				$Test->nlog("Device Hash:key:$dev_name Value:$device_mib{$dev_name}");
			}
		}
		my @snmp_objects=('psu_name','oper_status');
		foreach my $object(@snmp_objects)
		{
			my $mib_id=get_snmp_mib('nexus','power',$object);
			foreach my $device(keys(%device_mib))
			{
				my $mib_info=$mib_id.'.'.$device_mib{$device};
				my $snmp_out=exec_snmp($mib_info);
				my @snmp_out=split(/:/,$snmp_out);	
				$snmp_out=$snmp_out[-1];
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				$object =~ s/_/\-/;
				if($object =~ /psu\-name/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_power_show($object => $snmp_out);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				$snmp_out =~ /\d+/;
				$snmp_out=$&;
				if($object =~ /oper\-status/)
				{
					my %oper_status = (
					 	2 => 'operational',
 						3 => 'notoperational',
 						8 => 'failed',
 						1 => 'notoperational',
 						4 => 'notoperational',
 						5 => 'notoperational',
 						6 => 'notoperational',
 						7 => 'notoperational',
 						9 => 'notoperational',
 						10 => 'notoperational',
 						11 => 'notoperational',
 						12 => 'notoperational'
							);
					my $smf_value=$oper_status{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_power_show($object => $smf_value, 'psu-name' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $oper_status{$snmp_out} Key is $snmp_out XXXXX");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
			}
		}
	}
	if($resource=~ /interface/)
	{
		my $fan_mibs=get_snmp_mib('nexus','device','if');
		my $fan_mibs_out=exec_snmp($fan_mibs);
		my @lines=split(/\n/,$fan_mibs_out);
		foreach my $line (@lines)
		{
			if($line =~ /(Ethernet|mgmt)/)
			{
				my ($mib_info,$dev_name)=split(/= STRING:/,$line);
				chomp $dev_name;
				chomp $dev_name;
				my @mib_split=split(/\./,$mib_info);
				$mib_info=$mib_split[-1];	
				$device_mib{$dev_name}=$mib_info;
				$Test->nlog("Device Hash:key:$dev_name Value:$device_mib{$dev_name}");
			}
		}
		my @snmp_objects=('descr','index','type','mtu','duplexstatus','speed','adminstatus','operstatus','inoctets','inerrors','indiscards','outoctets','outerrors','outdiscards');
		foreach my $object(@snmp_objects)
		{
			my $mib_id=get_snmp_mib('nexus','if',$object);
			foreach my $device(keys(%device_mib))
			{
				my $mib_info=$mib_id.'.'.$device_mib{$device};
				my $snmp_out=exec_snmp($mib_info);
				my @snmp_out=split(/:/,$snmp_out);	
				$snmp_out=$snmp_out[-1];
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				chomp $snmp_out;
				$object =~ s/_/\-/;
				if($object =~ /descr/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				$snmp_out =~ /\d+/;
				$snmp_out=$&;
				if($object =~ /index/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out ");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /type/)
				{
					my %if_type = (
							1 => 'other',
							 6 => 'ethernetCsmacd',
							 53 => 'propVirtual',
							 69 => 'fastEtherFX',
							 117 => 'gigabitEthernet',
							 131 => 'tunnel'
							);
					my $smf_value=$if_type{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $smf_value, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $smf_value");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /duplexstatus/)
				{
					  my %duplex = ( 1 => 'unknown' , 2 => 'halfDuplex', 3 => 'fullDuplex' );
					my $smf_value=$duplex{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $smf_value, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $smf_value");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /adminstatus/)
				{
					  my %duplex = ( 1 => 'up' , 2 => 'down', 3 => 'testing' );
					my $smf_value=$duplex{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $smf_value, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $smf_value");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /operstatus/)
				{
					my %operstatus = ( 1 => 'up', 2 => 'down', 3 => 'testing', 4 => 'unknown', 5 => 'dormant', 6 => 'notPresent', 7 => 'lowerLayerDown' );
					my $smf_value=$operstatus{$snmp_out};
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $smf_value, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $smf_value");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /mtu/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /speed/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /inoctets/)
				{
					try {
						my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
						my $parsed=$response->get_parsed_output();
						if(@$parsed[0])
						{
							$Test->nlog("$object is verified for $snmp_out");
						} else {
							$Test->nlog("$object = $snmp_out failed");
							$fail_flag=$TCD::FAIL;
						}
					}
					catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
						$Test->nlog("Interface Query failed for $object $snmp_out for device $device");
						$fail_flag=$TCD::FAIL;
					};
				}
				if($object =~ /inerrors/)
				{
					try {
						my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
						my $parsed=$response->get_parsed_output();
						if(@$parsed[0])
						{
							$Test->nlog("$object is verified for $snmp_out");
						} else {
							$Test->nlog("$object = $snmp_out failed");
							$fail_flag=$TCD::FAIL;
						}
					}
					catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
						$Test->nlog("Interface Query failed for $object $snmp_out for device $device");
						$fail_flag=$TCD::FAIL;
					};
				}
				if($object =~ /outoctets/)
				{
					try {
						my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
						my $parsed=$response->get_parsed_output();
						if(@$parsed[0])
						{
							$Test->nlog("$object is verified for $snmp_out");
						} else {
							$Test->nlog("$object = $snmp_out failed");
							$fail_flag=$TCD::FAIL;
						}
					}
					catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
						$Test->nlog("Interface Query failed for $object $snmp_out for device $device");
						$fail_flag=$TCD::FAIL;
					};
				}
				if($object =~ /outerrors/)
				{
					try {
						my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
						my $parsed=$response->get_parsed_output();
						if(@$parsed[0])
						{
							$Test->nlog("$object is verified for $snmp_out");
						} else {
							$Test->nlog("$object = $snmp_out failed");
							$fail_flag=$TCD::FAIL;
						}
					}
					catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
						$Test->nlog("Interface Query failed for $object $snmp_out for device $device");
						$fail_flag=$TCD::FAIL;
					};
				}
				if($object =~ /indiscards/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
				if($object =~ /outdiscards/)
				{
					my $response=$APISetCmode->system_health_cluster_switch_interface_show($object => $snmp_out, 'descr' => $device);
					my $parsed=$response->get_parsed_output();
					if(@$parsed[0])
					{
						$Test->nlog("$object is verified for $snmp_out");
					} else {
						$Test->nlog("$object = $snmp_out failed");
						$fail_flag=$TCD::FAIL;
					}
				}
			}
		}
	}
	if($resource=~ /cpu/)
	{
		my @snmp_objects=('5sec_cpu','1min_cpu','5min_cpu','mem_free','mem_used');
		foreach my $object(@snmp_objects)
		{
			my $mib_id=get_snmp_mib('nexus','cpu',$object);
			my $snmp_out=exec_snmp($mib_id);
			my @snmp_out=split(/:/,$snmp_out);	
			$snmp_out=$snmp_out[-1];
			chomp $snmp_out;
			chomp $snmp_out;
			chomp $snmp_out;
			chomp $snmp_out;
			$object =~ s/_/\-/;
			$snmp_out =~ /\d+/;
			$snmp_out=$&;
			try {
				my $response=$APISetCmode->system_health_cluster_switch_utilization_show($object => $snmp_out);
				my $parsed=$response->get_parsed_output();
				if(@$parsed[0])
				{
					$Test->nlog("$object is verified for $snmp_out ");
				} else {
					$Test->nlog("$object = $snmp_out failed");
					$fail_flag=$TCD::FAIL;
				}
			}
			catch NACL::APISet::Exceptions::NoMatchingEntriesException with {
				$Test->nlog("Interface Query failed for $object $snmp_out for utilization ");
				$fail_flag=$TCD::FAIL;
			};
		}

	}

	return $fail_flag;

}

1

