# Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/ClientRPC/Stress.pm#1 $
## @summary     Interface class for inheriting methods supporting NATE3 RPC
## @author      lippe@netapp.com
## @status      private
## @pod here
###############################################
##   NOT READY FOR PUBLIC CONSUMPTION
###############################################
package ClientRPC::Stress;

use strict;

use Tharn qw ($Log);

### Inheritance order of package INTERFACE methods
### available for client execution via rpc.
### "ClientRPC" should always be first.

use base qw(
	    ClientRPC
	    ClientRPC::Intf::Mount
	    ClientRPC::Intf::Dt
	    );

### Packages with IMPLEMENTATIONS needed by client
### rpc server.
my $RpcWinLibs = << 'CODE';
use Tharn qw(param $Log);
use ClientRPC::Impl::DtWin;
use ClientRPC::Impl::Mount;
$Log->comment("LIB: ".param('NATE_LIB'));
CODE

my $RpcUnixLibs = << 'CODE';
use Tharn qw(param $Log);
use ClientRPC::Impl::DtLin;
use ClientRPC::Impl::Mount;
$Log->comment("LIB: ".param('NATE_LIB'));
CODE

###############################################################################
# Method:    new()
# Objective: Create a new ClientRPC object to support interface methods
# Details:   See POD documentation at the end of this file.
###############################################################################
sub new {
    my ($class,%args) = @_;
    my (
        $code,
        $self,
        );
   
    ### Create ClientRPC object which
    ### starts up RPC server
    $self=$class->SUPER::_new(%args);
    return $self if ($self->{error});
   
    ### Determine what implementation libraries
    ### need to be imported onto the remote rpc
    ### server so it can execute test call
    ### requests
    $code=($self->hosttype()=~/win/)
        ? $RpcWinLibs        
        : $RpcUnixLibs;

    ### Load required libraries 
    eval { 
        $self->load_libs(code=>$code);  
    };
    if ($@){
       ($self->on_err()=~/die/)
            ? croak $@
            : $self->_set_err($@);
    }

    return $self; 
}

###############################################################################
# Method:    destroy()
# Objective: delete ClientRPC object
# Details:   See POD documentation at the end of this file.
###############################################################################
sub destroy {
    my ($self) = @_;
   
    return $self->SUPER::_destroy();
        
}

1;
