#
# $Id: //depot/prod/test/Rsierranevada/lib/Compression/Constants.pm#1 $
#

## @summary Compression constants
##
## @description
##    This module defines the constants required for the Compression library,
##    and also, for all the compression scripts.
##
## @synopsis
##
## use Compression::Constants qw(:all);
##
## Here is the list of all constants
## 
## #################
## # Defaults
## #################
## TRUE 
## FALSE
## C_FLAG_KEEP_VALUE_AS_IS
##
##  COMPRESSION             
##  C_DFLT_FILER_CONN       
##  C_DFLT_CLIENT_CONN      
##  C_DFLT_TIMEOUT          
##  C_DFLT_FILER_CONN_STATS
##  C_DFLT_REQUIRE_DEBUG_BUILD
##  C_DFLT_REQUIRE_HW_PLATFORM
##  C_DFLT_MAX_RETRIES     
##  C_DFLT_EXTRA_WAIT
##  C_DFLT_CF_DISABLE
##  C_DFLT_CHECK_OPTION_FIRST
##
##  C_LOG_TO_HISTORY       
##  ONE_CP_TIME        
##
##  C_DFLT_POSTTEST       
##
##  C_ONTAP_7G              
##  C_ONTAP_7MODE          
##  C_ONTAP_CMODE       
##  C_ONTAP_BOOT_MODE
##
##  C_DFLT_BOOTUP_WAIT_TIME
##  C_DFLT_WACK_TIMEOUT
##  C_DFLT_SFSR_TIMEOUT
##  C_DFLT_CONSOLE_WAIT_TIMEOUT
##  C_DFLT_CLONE_SPLIT_TIMEOUT
##
## #################
## # Aggregate
## #################
##  C_DFLT_AGGREGATE
##  C_DFLT_AGGREGATE_COPY
##  C_DFLT_AGGREGATE_DEST
##  C_DFLT_AGGR_TYPE       
##  C_DFLT_AGGR_DISKS      
##  C_DFLT_AGGR_PURGE      
##  C_DFLT_AGGR_REUSE_TYPE 
##  C_DFLT_RAID_TYPE       
##  C_DFLT_AGGR_MIRROR
##  C_AGGR_32_BIT
##  C_AGGR_64_BIT
##  C_DFLT_AGGR_INDIRECT_TYPE
##
## #################
## # Volume
## #################
##  C_DFLT_VOLUME       
##  C_DFLT_TEST_VOLUME
##  C_DFLT_BASE_VOLUME
##  C_DFLT_TRAD_VOLUME
##  C_DFLT_IPU_VOLUME
##  C_DFLT_PARTNERNODE_VOLUME
##  C_DFLT_VOL_SIZE     
##  C_VOL_TYPE_TRAD
##  C_VOL_TYPE_FLEX
##  C_DFLT_VOL_PURGE
##  C_DFLT_TRAD_VOL_RECYCLE
##  C_DFLT_VOL_TYPE     
##  C_DFLT_VOL_EXPORTFS 
##  C_DFLT_VOL_MOUNT
##  C_VOL_STATE_ONLINE
##  C_VOL_STATE_OFFLINE
##  C_VOL_STATE_RESTRICTED
##  C_VOL_STATE_BUSY
##
## #################
## # License
## #################
##  C_LICENSE_SERVICE            
##  C_LICENSE_SERVICE_DEPENDENCY 
##
##  C_LICENSE_NFS               
##  C_LICENSE_CIFS               
##  C_LICENSE_SNAPMIRROR         
##  C_LICENSE_HTTP               
##  C_LICENSE_COMPRESSION       
##  C_LICENSE_NEARSTORE
##  C_LICENSE_ASIS
##  C_LICENSE_CLUSTER
##  C_LICENSE_SNAPLOCK
##  C_LICENSE_CMODE_BASE
##  C_DFLT_LICENSE_READY
##  C_DFLT_ADD_NSP_LICENSE
##
## #################
## # Enable
## #################
##  C_ENABLE_COMPRESSION 
##  C_ENABLE_DEDUPE     
##  C_ENABLE_SNAPLOCK        
##
## #################
## # Dedupe
## #################
##  C_MIN_SHARE_BLKS
##  C_DEDUPE_STATE_ON
##  C_DEDUPE_STATE_OFF
##  C_DEDUPE_STATE_ENABLED
##  C_DEDUPE_STATUS
##  C_DEDUPE_STATUS_INITIALIZING
##  C_DEDUPE_STATUS_IDLE
##  C_DEDUPE_STATUS_ACTIVE
##  C_DEDUPE_STATUS_UNDOING
##  C_DEDUPE_STATUS_NOSTATUS
##  C_DEDUPE_STATUS_DONE
##  C_DEDUPE_STATUS_DASH
##  C_DEDUPE_STAGE
##  C_DEDUPE_STAGE_GATHING
##  C_DEDUPE_STAGE_SORTING
##  C_DEDUPE_STAGE_CHECK_P1
##  C_DEDUPE_STAGE_CHECK_P2
##  C_DEDUPE_STAGE_SAVING
##  C_DEDUPE_STAGE_DONE
##  C_DEDUPE_STAGE_DASH
##
## #################
## # Dataset
## #################
##  C_DATASET_SPARSE              
##  C_DATASET_DENSE              
##  C_DATASET_RICHDATA             
##  C_DFLT_COMPRESSION_DATASET_TYPE 
##  C_DFLT_COMPRESSION_DATASET      
##  KB                              
##  MB                             
##  GB                              
##  C_MIN_DATASET_SIZE             
##  C_DFLT_DATASET_FORMAT          
##  C_ONE_BYTE                     
##
##  C_DATASET_SMALL_SIZE           
##  C_DATASET_MEDIUM_SIZE          
##  C_DATASET_LARGE_SIZE          
##  C_DATASET_JUMBO_SIZE          
##
## #################
## # CG
## #################
##  C_WAFL_BLOCK_SIZE      
##  C_ONE_WAFL_BLOCK      
##  C_MIN_CG_BLKS          
##  C_MAX_CG_BLKS          
##  C_DFLT_CG_BLKS         
##  C_CG_SIZE              
##  C_FIXED_8_BLKS_CG      
##  C_ALTERNATE_89_CG     
##  C_DFLT_CG_TYPE         
##  C_MIN_DATA_TO_COMPRESS 
##
## #################
## # UI
## #################
##  C_UI_CLI      
##  C_UI_ZAPI      
##  C_DFLT_UI_TYPE
##  C_CONN_CONSOLE
##
## Options:
##  C_OPTION_COMPRESSION  
##
## Command codes supported by the Compression library:
##  C_CMD_GET_SAVINGS       
##  C_CMD_OPTION_SET         
##  C_CMD_DECOMPRESS_START  
##  C_CMD_DECOMPRESS_STOP
##  C_CMD_DECOMPRESS_STATUS
##  C_CMD_COMPRESS_START     
##  C_CMD_COMPRESS_STOP      
##  C_CMD_COMPRESS_STATUS    
##  C_CMD_LICENSE_ADD
##  C_CMD_LICENSE_REMOVE
##  C_CMD_VOL_CLONE_SPLIT_START
##  C_CMD_VOL_CLONE_SPLIT_STOP
##
## Fylesystem corruption codes
##  C_CORRUPT_FSINFO_INOS_USED
##  C_CORRUPT_FSINFO_BLKS_USED_BY_PLANE0
##  C_CORRUPT_FSINFO_BLKS_COMPRESS_HOLES
##  C_CORRUPT_INODE_BLK_CNT
##  C_CORRUPT_REFCOUNT
##  C_CORRUPT_CHECKSUM
##  C_CORRUPT_CG_HEADER_VBN
##  C_CORRUPT_CG_HEADER_VVBN
##  C_CORRUPT_CG_TRAILER_VBN
##  C_CORRUPT_CG_TRAILER_VVBN
##  C_CORRUPT_REP
##
##  Console message codes
##  C_CONSOLE_VOLUME_FULL
##  C_CONSOLE_OUT_OF_SPACE_SFSR_ABORTED
##  C_CONSOLE_INSUFFICIENT_SPACE_FOR_SFSR
##  C_CONSOLE_VOL_RESTORE_STARTED
##  C_CONSOLE_DECOMPRESS_ABORTED
##  C_CONSOLE_WAFL_INCONSISTENT
##
## #################
## # Client
## #################
##  C_CLIENT_NFS_TAG
##  C_CLIENT_CIFS_TAG
##  C_CLIENT_TYPE_ANY
##  C_CLIENT_NFS_LOCAL
##  C_DFLT_CLIENT_TYPE
##
## #################
## # Decompress
## #################
##  C_DFLT_DECOMPRESS_INTERVAL
##  C_DFLT_DECOMPRESS_TIMEOUT
##
## #################
## # Compress
## #################
##  C_DFLT_COMPRESS_INTERVAL
##  C_DFLT_COMPRESS_TIMEOUT
##
## #################
## # Verify
## #################
##  C_VERIFY_OPERATION
##  C_VERIFY_OP_COMPRESS_ENABLE
##
## #################
## # Fiji
## #################
##  C_FIJI_TAG_DISABLE_CP
##  C_FIJI_TAG_ENABLE_CP
##  C_FIJI_TAG_PANIC_ON_COMPRESS
##  C_FIJI_TAG_PANIC_ON_DECOMPRESS
##  C_FIJI_TAG_COMPR_CORRUPT_CHECKSUM
##  C_FIJI_TAG_DECOMPR_CORRUPT_CHECKSUM
##  C_FIJI_TAG_SUPPRESS_DECOMPR_COMPLETION_EMS
##  C_FIJI_TAG_SLEEP_WHILE_COMPR_SCANNER
##  C_FIJI_TAG_SIMULATE_REP_METAFILE_ERROR
##  C_FIJI_TAG_SIMULATE_REP_ERROR_WHILE_READING_CHNGLOG
##
## ##############
## # Return codes
## ##############
## C_RC_SUCCESS
## C_RC_FAILURE
## C_RC_FAILURE_NON_FATAL
## C_RC_COMPRESSION_NOT_TURNED_OFF
## C_RC_COMPRESSION_NOT_TURNED_ON
## C_RC_INSUFFICIENT_SPACE
## C_RC_NO_DATA_TO_DECOMPRESS
## C_RC_NO_DECOMPRESSION_IN_PROGR
## C_RC_PERCENTAGE_MISSED
## C_RC_WAFLIRON_IDLE
## C_RC_NO_WAFLIRON_IN_PROGRESS
## C_RC_WAFLIRON_CORRUPTION_FOUND
## C_RC_VOLUME_NOT_FOUND
## C_RC_VOLUME_NOT_ONLINE
## C_RC_NO_NEARSTORE_LICENSE
## C_RC_NO_COMPRESSION_LICENSE
## C_RC_DECOMPRESSION_STILL_IN_PROGRESS
## C_RC_INVALID_COMMAND_ARGUMENT
## C_RC_VOLUME_TYPE_NOT_FLEX
## C_RC_ILLEGAL_OPTION_FOR_SNAPLOCK_VOL
## C_RC_NO_COMPRESSION_IN_PROGR  
## C_RC_COMPRESSION_STILL_IN_PROGRESS
## C_RC_OP_NOT_ALLOWED_ON_ROOT_VOL
## C_RC_VOLUME_IS_NOT_BEING_SPLIT
## C_RC_VOLUME_IS_NOT_A_CLONE
## C_RC_CHECKPOINT_FILE_EMPTY
## 
## @examples
## use Compression::Contants qw(:dflt);
## use Compression::Contants qw(:enable);
## use Compression::Contants qw(:dedupe);
## use Compression::Contants qw(:ds);
## use Compression::Contants qw(:lic);
## use Compression::Contants qw(:ui);
## use Compression::Contants qw(:client);
## use Compression::Contants qw(:vol :aggr);
## use Compression::Contants qw(:all);
##
## 
## @author sureshb@netapp.com, dl-compression-qa@netapp.com
## @status private (in-progress)

package Compression::Constants;


use strict;
use warnings;




BEGIN
{
use base qw(Exporter);

#################
# Defaults
#################
use constant TRUE                    => 1;
use constant FALSE                   => 0;
use constant C_FLAG_KEEP_VALUE_AS_IS => 2;

use constant COMPRESSION	        => "compression";
use constant C_DFLT_FILER_CONN	        => "#rsh";
use constant C_DFLT_10MODE_FILER_CONN   => 'shell,cli';
use constant C_DFLT_CLIENT_CONN	        => "#rsh";
use constant C_DFLT_TIMEOUT	        => 7200;
use constant C_DFLT_CMD_TIMEOUT         => 40;
use constant C_DFLT_ISCSI_CMD_TIMEOUT   => 60;
use constant C_DFLT_FILER_CONN_STATS	=> FALSE;
use constant C_DFLT_REQUIRE_DEBUG_BUILD => FALSE;
use constant C_DFLT_REQUIRE_HW_PLATFORM => FALSE;
use constant C_DFLT_MAX_RETRIES         => 3;
use constant C_DFLT_EXTRA_WAIT          => 1;
use constant C_DFLT_CF_DISABLE          => TRUE;
use constant C_DFLT_CHECK_OPTION_FIRST  => TRUE;
use constant C_DFLT_CONFIGURE_SCHEDULER => TRUE;
use constant C_DFLT_RECYCLE_VFILER      => FALSE;
use constant C_DFLT_MIN_WAIT_UNTIL_UP => 120;
use constant C_DFLT_WAFL_SCAN_SPEED   => 10000;
use constant C_DFLT_MAX_SCANNER_ABORT_TIME => 60;
use constant C_DFLT_LUN_SIZE            => '10m';

use constant C_LOG_TO_HISTORY 	=> TRUE;
use constant ONE_CP_TIME 	=> 10;

use constant C_DFLT_POSTTEST	=> "wafliron";

use constant C_ONTAP_7G		=> "7M";
use constant C_ONTAP_7MODE	=> "7M";
use constant C_ONTAP_CMODE	=> "CM";
use constant C_ONTAP_BOOT_MODE	=> C_ONTAP_7G;

use constant C_DFLT_BOOTUP_WAIT_TIME => 900;
use constant C_DFLT_WACK_TIMEOUT => 3600;
use constant C_DFLT_SFSR_TIMEOUT => 600;
use constant C_DFLT_CONSOLE_WAIT_TIMEOUT => 3600;
use constant C_DFLT_CLONE_SPLIT_TIMEOUT => 1200;
use constant C_DFLT_FIJI_DENSE_SLEEP_TIME => 60;
use constant C_DFLT_FIJI_COMPR_SCANNER_SLEEP_TIME => 10;

#################
# Aggregate
#################
use constant C_DFLT_AGGREGATE 		=> "compr";
use constant C_DFLT_AGGREGATE_COPY      => "compr_copy";
use constant C_DFLT_AGGREGATE_DEST      => "compr_dest";
use constant C_DFLT_AGGR_TYPE 	        => "regular";
use constant C_DFLT_AGGR_DISKS		=> 3;
use constant C_DFLT_AGGR_PURGE 		=> TRUE;
use constant C_DFLT_AGGR_REUSE_TYPE	=> "NO_CLEANUP";
use constant C_DFLT_RAID_TYPE		=> "";
use constant C_DFLT_AGGR_MIRROR		=> FALSE;
use constant C_AGGR_32_BIT              => 32;
use constant C_AGGR_64_BIT              => 64;
use constant C_DFLT_AGGR_INDIRECT_TYPE  => C_AGGR_64_BIT;
use constant C_LA_IPU_MODE_CHECK        => 'check';
use constant C_LA_IPU_MODE_NORMAL       => 'normal';
use constant C_LA_IPU_MODE_GROW_RESERVED => 'grow-reserved';
use constant C_LA_IPU_MODE_GROW_ALL      => 'grow-all';
use constant C_SNAPLOCK_COMPLIANCE       => 'compliance';
use constant C_SNAPLOCK_ENTERPRISE       => 'enterprise';
use constant C_DFLT_SNAPLOCK_AGGREGATE   => 'compr_snaplock';
use constant C_AGGR_STATE_ONLINE         => 'online';
use constant C_AGGR_STATE_RESTRICTED     => 'restricted';
use constant C_AGGR_STATE_OFFLINE        => 'offline';
use constant C_DFLT_AGGR_COPY_THROTTLE => 10;

#################
# Volume
#################
use constant C_DFLT_VOLUME		=> undef;  #Anonymous volume.
use constant C_DFLT_TEST_VOLUME         => undef;  #Anonymous volume.
use constant C_DFLT_BASE_VOLUME         => undef;  #Anonymous volume.
use constant C_DFLT_TRAD_VOLUME         => 'tradvol';
use constant C_DFLT_IPU_VOLUME          => 'ipu_vol';
use constant C_DFLT_PARTNERNODE_VOLUME  => undef;  #Anonymous volume.
use constant C_DFLT_VOL_SIZE		=> "20m";
use constant C_DFLT_VOL_PURGE		=> FALSE;
use constant C_DFLT_TRAD_VOL_RECYCLE    => TRUE;
use constant C_VOL_TYPE_TRAD            => 'trad';
use constant C_VOL_TYPE_FLEX            => 'flex';
use constant C_DFLT_VOL_TYPE		=> C_VOL_TYPE_FLEX;
use constant C_DFLT_VOL_EXPORTFS        => 'rw,nosuid,anon=0';
use constant C_DFLT_VOL_MOUNT           => TRUE;  # NOTE::Volume constructor mounts the volume for us by default
use constant C_VOL_STATE_ONLINE         => 'online';
use constant C_VOL_STATE_OFFLINE        => 'offline';
use constant C_VOL_STATE_RESTRICTED     => 'restricted';
use constant C_VOL_STATE_BUSY           => 'busy';
use constant C_VOL_USED_SPACE_MIN_JITTER => 300;
use constant C_VOL_DFLT_SNAPLOCK_RETENTION => '10s'; 
use constant C_VOL_MIN_SNAPLOCK_RETENTION => '10s'; 
use constant C_VOL_MAX_SNAPLOCK_RETENTION => '10s';
use constant C_DFLT_VOL_COPY_THROTTLE => 10;
use constant C_VOL_MOVE_STATE_SETUP => 'setup';
use constant C_VOL_MOVE_STATE_MOVE => 'move';
use constant C_VOL_MOVE_STATE_CUTOVER => 'cutover';
use constant C_VOL_MOVE_STATE_CUTOVER_DEFERRED => 'cutover_deferred';

#################
# License
#################
use constant C_LICENSE_SERVICE => "compression";
use constant C_LICENSE_SERVICE_DEPENDENCY => "nearstore_option";

use constant C_LICENSE_NFS              => "nfs";
use constant C_LICENSE_CIFS             => "cifs";
use constant C_LICENSE_SNAPMIRROR	=> "snapmirror";
use constant C_LICENSE_HTTP	        => "http";
use constant C_LICENSE_COMPRESSION	=> "compression";
use constant C_LICENSE_NEARSTORE        => "nearstore_option";
use constant C_LICENSE_ASIS             => "a_sis";
use constant C_LICENSE_CLUSTER          => "cluster";
use constant C_LICENSE_SNAPRESTORE      => "snaprestore";
use constant C_LICENSE_SNAPLOCK         => "snaplock";
use constant C_LICENSE_SNAPVAULT_PRI    => "sv_ontap_pri";
use constant C_LICENSE_SNAPVAULT_SEC    => "sv_ontap_sec";
use constant C_LICENSE_MULTISTORE       => "multistore";
use constant C_LICENSE_ISCSI            => "iscsi";
use constant C_DFLT_LICENSE_READY       => TRUE;
use constant C_DFLT_ADD_NSP_LICENSE     => TRUE;
use constant C_LICENSE_CMODE_BASE       => "Base";

#################
# Enable
#################
use constant C_ENABLE_COMPRESSION	=> TRUE;
use constant C_ENABLE_DEDUPE		=> FALSE;
use constant C_ENABLE_SNAPLOCK		=> FALSE;

#################
# Dedupe
#################
use constant C_MIN_SHARE_BLKS		  => 1;
use constant C_DEDUPE_STATE_ON            => 'on';
use constant C_DEDUPE_STATE_OFF           => 'off';
use constant C_DEDUPE_STATE_ENABLED       => 'ENABLED';
use constant C_DEDUPE_STATUS              => 'STATUS';
use constant C_DEDUPE_STATUS_INITIALIZING => 'INITIALIZING';
use constant C_DEDUPE_STATUS_IDLE         => 'IDLE';
use constant C_DEDUPE_STATUS_ACTIVE       => 'ACTIVE';
use constant C_DEDUPE_STATUS_UNDOING      => 'UNDOING';
use constant C_DEDUPE_STATUS_NOSTATUS     => 'NOSTATUS';
use constant C_DEDUPE_STATUS_DONE         => 'DONE';
use constant C_DEDUPE_STATUS_DASH         => 'DASH';
use constant C_DEDUPE_STAGE               => 'STAGE';
use constant C_DEDUPE_STAGE_GATHING       => 'GATHING';
use constant C_DEDUPE_STAGE_SORTING       => 'SORTING';
use constant C_DEDUPE_STAGE_CHECK_P1      => 'CHECKING_P1';
use constant C_DEDUPE_STAGE_CHECK_P2      => 'CHECKING_P2';
use constant C_DEDUPE_STAGE_SAVING        => 'SAVING';
use constant C_DEDUPE_STAGE_DONE          => 'DONE';
use constant C_DEDUPE_STAGE_DASH          => 'DASH';
use constant C_DEDUPE_SCHEDULE_NONE       => '-';
use constant C_DFLT_SIS_SCHEDULE          => C_DEDUPE_SCHEDULE_NONE;

#################
# Dataset
#################
use constant C_DATASET_SPARSE		=> "ds_sparse";
use constant C_DATASET_DENSE		=> "ds_dense";
use constant C_DATASET_RICHDATA		=> "ds_richdata";
use constant C_DFLT_COMPRESSION_DATASET_TYPE => "STATIC"; 
use constant C_DFLT_COMPRESSION_DATASET => C_DATASET_SPARSE;
use constant KB                         => 1024 ;
use constant MB                         => ( KB * KB );
use constant GB                         => ( KB * KB * KB );
use constant C_MIN_DATASET_SIZE 	=> ( 65 * KB ); 
use constant C_DFLT_DATASET_FORMAT 	=> "";
use constant C_ONE_BYTE			=> 1;

use constant C_DATASET_SMALL_SIZE	=> ( 65 * KB );
use constant C_DATASET_MEDIUM_SIZE	=> MB;
use constant C_DATASET_LARGE_SIZE	=> ( 10 * MB );
use constant C_DATASET_JUMBO_SIZE       => ( 3 * GB );

#################
# File
#################
use constant C_FILE_RESERVATION_ON => 'on';
use constant C_FILE_RESERVATION_OFF => 'off';

#################
# CG
#################
use constant C_NR_KB_IN_WAFL_BLOCK      => 4;
use constant C_WAFL_BLOCK_SIZE		=> ( C_NR_KB_IN_WAFL_BLOCK * KB );
use constant C_ONE_WAFL_BLOCK		=> C_WAFL_BLOCK_SIZE;
use constant C_MIN_CG_BLKS		=> 3;
use constant C_MAX_CG_BLKS		=> 8;
use constant C_DFLT_CG_BLKS		=> C_MAX_CG_BLKS; 
use constant C_CG_SIZE			=> ( 8 * C_ONE_WAFL_BLOCK );
use constant C_FIXED_8_BLKS_CG		=> "FIXED_8_BLKS";
use constant C_ALTERNATE_89_CG		=> "ALTERNATE_89_BLKS";
use constant C_DFLT_CG_TYPE		=> C_FIXED_8_BLKS_CG;
use constant C_MIN_DATA_TO_COMPRESS     => ( 2 * C_WAFL_BLOCK_SIZE + 1);
use constant C_CHECKSUM_SIZE            => (4 * C_ONE_BYTE);
# Byte number within the data block at which the compression checksum starts
use constant C_CHECKSUM_START_BYTE      => 0;
# Byte nummber within the data block at which the compression checksum ends
use constant C_CHECKSUM_END_BYTE        => (C_CHECKSUM_SIZE - 1);
use constant C_MAX_BLOCKS_PER_ONE_L1    => 255;

#################
# UI
#################
use constant C_UI_CLI		=> "CLI";
use constant C_UI_ZAPI		=> "ZAPI";
use constant C_DFLT_UI_TYPE 	=> C_UI_CLI;
use constant C_CONN_CONSOLE     => '#console';
use constant C_STR_ZAPI_NOT_AVAILABLE => "";

# Options
# They need to be in sync with option definition key hashes in Options.pm
use constant C_OPTION_COMPRESSION  => 'COMPRESSION';
use constant C_OPTION_GUARANTEE => 'GUARANTEE';
use constant C_OPTION_FRACTIONAL_RESERVE => 'FRACTIONAL_RESERVE';
use constant C_OPTION_TRY_FIRST => 'TRY_FIRST';
use constant C_OPTION_SNAPLOCK_AUTOCOMMIT_PERIOD => 'SNAPLOCK_AUTOCOMMIT_PERIOD';

# Command codes supported by the Compression library
# They need to be in sync with key hashes in Formats.pm and/or Messages/Constants_<release_specific>.pm
use constant C_CMD_GET_SAVINGS        => 'GET_SPACE_SAVINGS';
use constant C_CMD_OPTION_SET         => 'OPTION_SET';
use constant C_CMD_DECOMPRESS_START   => 'DECOMPRESS_START';
use constant C_CMD_DECOMPRESS_STOP    => 'DECOMPRESS_STOP';
use constant C_CMD_DECOMPRESS_STATUS  => 'DECOMPRESS_STATUS';
use constant C_CMD_LICENSE_ADD        => 'LICENSE_ADD';
use constant C_CMD_LICENSE_REMOVE     => 'LICENSE_REMOVE';
use constant C_CMD_AUTOSIZE           => 'AUTOSIZE';
use constant C_CMD_COMPRESS_START     => 'COMPRESS_START';
use constant C_CMD_COMPRESS_STOP      => 'COMPRESS_STOP';
use constant C_CMD_COMPRESS_STATUS    => 'COMPRESS_STATUS';
use constant C_CMD_COMPRESS_STATUS_CHECKPOINT => 'COMPRESS_STATUS_CHECKPOINT';
use constant _C_CMD_PARSE_CHECKPOINT_TIME => '_PARSE_CHECKPOINT_TIME';
use constant C_CMD_VOL_CLONE_SPLIT_START => 'VOL_CLONE_SPLIT_START';
use constant C_CMD_VOL_CLONE_SPLIT_STOP => 'VOL_CLONE_SPLIT_STOP';
use constant C_CMD_VOL_ONLINE => 'VOL_ONLINE';
use constant C_CMD_IS_COMPRESSION_ENABLED => 'IS_COMPRESSION_ENABLED';
use constant C_CMD_ENABLE_COMPRESSION => 'ENABLE_COMPRESSION';
use constant C_CMD_DISABLE_COMPRESSION => 'DISABLE_COMPRESSION';
use constant C_CMD_SFSR_START => 'SFSR_START';
use constant C_CMD_SFSR_TO_PATH_START => 'SFSR_TO_PATH_START';
use constant C_CMD_GET_STATS => 'GET_STATS';
use constant C_CMD_VERIFY_COMPRESSION_ATTEMPTED => 'VERIFY_COMPR_ATTEMPTED_BIT';
use constant C_CMD_VERIFY_SIS_LS => 'VERIFY_SIS_LS';
use constant _C_CMD_CHANGELOG_FINGERPRINTS => '_CHANGELOG_FINGERPRINTS';
use constant C_CMD_DEDUPE_START => 'DEDUPE_START';
use constant C_CMD_DEDUPE_SET_STATE => 'DEDUPE_SET_STATE';
use constant C_CMD_DEDUPE_STOP => 'DEDUPE_STOP';
use constant C_CMD_DEDUPE_OFF_UNDO => 'DEDUPE_OFF_UNDO';
use constant C_CMD_GET_VBN_INFO => 'GET_VBN_INFO';
use constant C_CMD_DUMPBLOCK_FILE => 'DUMPBLOCK_FILE';
use constant C_CMD_FILE_RESERVATION => 'FILE_RESERVATION';
use constant C_CMD_GET_FILE_ID => 'GET_FILE_ID';
use constant C_CMD_SYNC => 'SYNC';
use constant C_CMD_GET_SNAP_RECLAIMABLE => 'GET_SNAP_RECLAIMABLE';
use constant C_CMD_DISK_FREE => 'DISK_FREE';
use constant C_CMD_GET_RESERVED => 'GET_RESERVED';
use constant C_CMD_AGGR_SNAP_LIST => 'AGGR_SNAP_LIST';
use constant C_CMD_AGGR_SNAP_DELETE => 'AGGR_SNAP_DELETE';
use constant C_CMD_DEDUPE_WAIT => 'DEDUPE_WAIT';
use constant C_CMD_DETECT_ROOT_VOL => 'DETECT_ROOT_VOL';
use constant C_CMD_FILE_FOLDING_START => 'FILE_FOLDING_START';
use constant C_CMD_FILE_FOLDING_STATUS => 'FILE_FOLDING_STATUS';
use constant C_CMD_FILE_FOLDING_ABORT => 'FILE_FOLDING_ABORT';
use constant C_CMD_DUMPBLOCK_INFO => 'DUMPBLOCK_INFO';
use constant C_CMD_DUMPBLOCK_INFO_L1 => 'DUMPBLOCK_INFO_L1';
use constant C_CMD_GET_REFCOUNT => 'GET_REFCOUNT';
use constant C_CMD_SIS_CHECK => 'SIS_CHECK';
use constant C_CMD_LA_IPU_STATUS => 'LA_IPU_STATUS';
use constant C_CMD_GET_CONTAINMENT_VERSION => 'GET_CONTAINMENT_VERSION';
use constant C_CMD_GET_COMPRESSION_STATS => 'GET_COMPRESSION_STATS';
use constant C_CMD_COMPRESSION_STATS_START => 'COMPRESSION_STATS_START';
use constant C_CMD_COMPRESSION_STATS_STOP => 'COMPRESSION_STATS_STOP';
use constant C_CMD_DECOMPRESS_REVERT => 'DECOMPRESS_REVERT';
use constant C_CMD_BUFTREE_CHECK => 'BUFTREE_CHECK';
use constant C_CMD_SET_SNAPLOCK_AUTO_COMMIT => 'SET_SNAPLOCK_AUTO_COMMIT';
use constant C_CMD_SNAPMIRROR_RESYNC => 'SNAPMIRROR_RESYNC';
use constant C_CMD_SNAPVAULT_UPDATE => 'SNAPVAULT_UPDATE';
use constant C_CMD_SET_WAFL_SCAN_SPEED => 'SET_WAFL_SCAN_SPEED';
use constant C_CMD_GET_WAFL_SCAN_SPEED => 'GET_WAFL_SCAN_SPEED';
use constant C_CMD_VOL_COPY_START => 'VOL_COPY_START';
use constant C_CMD_AGGR_COPY_START => 'AGGR_COPY_START';
use constant C_CMD_VOL_SNAP_RESTORE => 'VOL_SNAP_RESTORE';
use constant C_CMD_SNAPMIRROR_INITIALIZE => 'SNAPMIRROR_INITIALIZE';
use constant C_CMD_DELETE_FILE => 'DELETE_FILE';
use constant C_CMD_GET_SNAPLOCK_CONTAINMENT_BITS => 'GET_SNAPLOCK_CONTAINMENT_BITS';
use constant C_CMD_FILE_CLONE_START => 'FILE_CLONE_START';
use constant C_CMD_FILE_CLONE_CLEAR => 'FILE_CLONE_CLEAR';
use constant C_CMD_FILE_CLONE_STOP => 'FILE_CLONE_STOP';
use constant C_CMD_BG_FILE_CLONE_STATUS => 'BG_FILE_CLONE_STATUS';
use constant C_CMD_AGGR_BLOCK_CHECK_START => 'AGGR_BLOCK_CHECK_START';
use constant C_CMD_GET_DATA_DISKS => 'GET_DATA_DISKS';
use constant C_CMD_VOL_MOVE_START => 'VOL_MOVE_START';
use constant C_CMD_VOL_MOVE_STATUS => 'VOL_MOVE_STATUS';
use constant C_CMD_VOL_MOVE_CUTOVER => 'VOL_MOVE_CUTOVER';
use constant C_CMD_VOL_MOVE_PAUSE => 'VOL_MOVE_PAUSE';
use constant C_CMD_VOL_MOVE_IS_PAUSED => 'VOL_MOVE_IS_PAUSED';
use constant C_CMD_FIND_VOL_MOVE_STATE => 'FIND_VOL_MOVE_STATE';
use constant C_CMD_VFILER_MIGRATE_STATUS => 'VFILER_MIGRATE_STATUS';
use constant C_CMD_VOL_ONLINE_RO => 'VOL_ONLINE_RO';
use constant C_CMD_VOL_STATUS => 'VOL_STATUS';
use constant C_CMD_WAFL_PUNCH => 'WAFL_PUNCH';
use constant C_CMD_GET_VOLUME_STATS => 'GET_VOLUME_STATS';
use constant C_CMD_GET_WAFL_STATS => 'GET_WAFL_STATS';
use constant C_CMD_GET_VBN_INFO_ERROR => 'GET_VBN_INFO_ERROR';
use constant C_CMD_SNAPMIRROR_UPDATE => 'SNAPMIRROR_UPDATE';
use constant C_CMD_CONFIGURE_IDD => 'CONFIGURE_IDD';
use constant C_CMD_IS_IDD_ENABLED => 'IS_IDD_ENABLED';

# Format types
use constant C_FORMAT_TYPE_1 => 1;
use constant C_FORMAT_TYPE_2 => 2;
                                         

# Filesystem corruption codes
# They need to be in sync with key hashes in CorruptionMessages.pm
use constant C_CORRUPT_FSINFO_INOS_USED => 'fsinfo_inos_used';
use constant C_CORRUPT_FSINFO_BLKS_USED_BY_PLANE0 => 'fsinfo_blks_used_by_plane0';
use constant C_CORRUPT_FSINFO_BLKS_COMPRESS_HOLES => 'fsinfo_blks_compress_holes';
use constant C_CORRUPT_INODE_BLK_CNT => 'inode_blk_cnt';
use constant C_CORRUPT_REFCOUNT => 'refcount_set';
use constant C_CORRUPT_CHECKSUM => 'corrupt_checksum'; # This is not a standard wreck inject command: using block pattern
use constant C_CORRUPT_CG_HEADER_VBN => 'corrupt_cg_header_vbn'; # This is not a standard wreck inject command: using ind_vol_bno
use constant C_CORRUPT_CG_HEADER_VVBN => 'corrupt_cg_header_vvbn'; # This is not a standard wreck inject command: using ind_vol_vbno
use constant C_CORRUPT_CG_TRAILER_VBN => 'corrupt_cg_trailer_vbn'; # This is not a standard wreck inject command: using ind_vol_bno
use constant C_CORRUPT_CG_TRAILER_VVBN => 'corrupt_cg_trailer_vvbn'; # This is not a standard wreck inject command: using ind_vol_vbno
use constant C_CORRUPT_CG_DATA_VBN => 'corrupt_cg_data_vbn'; # This is not a standard wreck inject command: using ind_vol_bno
use constant C_CORRUPT_CG_DATA_VVBN => 'corrupt_cg_data_vvbn'; # This is not a standard wreck inject command: using ind_vol_vbno
use constant C_CORRUPT_REP => 'corrupt_rep';
# Note:
# This is a list of corruptions that are not to be supported yet by the library.
# They are not fixed (wafliron and wack will not report or fix them). Some may panic the filer.
# fsinfo_inos_total
# fsinfo_inos_reserve
# fsinfo_blks_used
# fsinfo_blks_total
# fsinfo_blks_reserve
# fsinfo_blks_cifs_holes_reservation
# fsinfo_blks_holes_reservation
# fsinfo_blks_overwrite_reservation
# fsinfo_blks_rsv_absent
# fsinfo_blks_rsv_parent
# fsinfo_snap_reserve

# Console messages
# They need to be in sync with key hashes in ConsoleMessages.pm
use constant C_CONSOLE_VOLUME_FULL => 'C_CONSOLE_VOLUME_FULL';
use constant C_CONSOLE_OUT_OF_SPACE_SFSR_ABORTED => 'C_CONSOLE_OUT_OF_SPACE_SFSR_ABORTED';
use constant C_CONSOLE_INSUFFICIENT_SPACE_FOR_SFSR => 'C_CONSOLE_INSUFFICIENT_SPACE_FOR_SFSR';
use constant C_CONSOLE_INSUFFICIENT_SPACE_TO_GROW_VOLUME => 'C_CONSOLE_INSUFFICIENT_SPACE_TO_GROW_VOLUME';
use constant C_CONSOLE_VOL_RESTORE_STARTED => 'C_CONSOLE_VOL_RESTORE_STARTED';
use constant C_CONSOLE_DECOMPRESS_ABORTED => 'C_CONSOLE_DECOMPRESS_ABORTED';
use constant C_CONSOLE_DECOMPRESS_COMPLETED => 'C_CONSOLE_DECOMPRESS_COMPLETED';
use constant C_CONSOLE_COMPRESS_CHECKPOINT_DELETED => 'C_CONSOLE_COMPRESS_CHECKPOINT_DELETED';
use constant C_CONSOLE_COMPRESSION_ABORTED_AS_SNAPSHOT_IS_CREATED => 'C_CONSOLE_COMPRESSION_ABORTED_AS_SNAPSHOT_IS_CREATED';
use constant C_CONSOLE_OUT_OF_SPACE_SIS_ABORTED => 'C_CONSOLE_OUT_OF_SPACE_SIS_ABORTED';
use constant C_CONSOLE_WAFL_INCONSISTENT => 'C_CONSOLE_WAFL_INCONSISTENT';


# Constants for scanner stages/status (used by UI::Constants)
use constant C_STATUS_ACTIVE => 'C_STATUS_ACTIVE';
use constant C_STATUS_IDLE => 'C_STATUS_IDLE';
use constant C_STATUS_UNDOING => 'C_STATUS_UNDOING';
use constant C_STAGE_COMPRESS_PREPROC => 'C_STAGE_COMPRESS_PREPROC';
use constant C_STAGE_COMPRESSING => 'C_STAGE_COMPRESSING';
use constant C_STAGE_NONE => 'C_STAGE_NONE';
use constant C_STAGE_SORTING => 'C_STAGE_SORTING';
use constant C_STAGE_SAVING => 'C_STAGE_SAVING';
use constant C_STAGE_GATHERING => 'C_STAGE_GATHERING';
use constant C_STAGE_DONE => 'C_STAGE_DONE';
use constant C_STAGE_CHECKING_P1 => 'C_STAGE_CHECKING_P1';
use constant C_STAGE_CHECKING_P2 => 'C_STAGE_CHECKING_P2';
use constant C_CHECKPOINT_STAGE_NONE => 'C_CHECKPOINT_STAGE_NONE';
use constant C_CHECKPOINT_STAGE_SORTING => 'C_CHECKPOINT_STAGE_SORTING';
use constant C_CHECKPOINT_STAGE_SAVING_PASS1 => 'C_CHECKPOINT_STAGE_SAVING_PASS1';
use constant C_CHECKPOINT_STAGE_SAVING_PASS2 => 'C_CHECKPOINT_STAGE_SAVING_PASS2';
use constant C_CHECKPOINT_STAGE_SAVING_SHARING => 'C_CHECKPOINT_STAGE_SAVING_SHARING';
use constant C_CHECKPOINT_STAGE_SAVING_END => 'C_CHECKPOINT_STAGE_SAVING_END';
use constant C_CHECKPOINT_STAGE_COMPRESSING => 'C_CHECKPOINT_STAGE_COMPRESSING';
# Constants for compression states, used by Compress::verify_containment_version
use constant C_STATE_AT_LEAST_ONCE_ENABLED => 'WAS_ENABLED';
use constant C_STATE_NEVER_ENABLED => 'NEVER_ENABLED';

# Feature codes. They need to be in sync with hash keys in Version::is_feature_supported
use constant C_FEATURE_PRE_CP => 'PRE_CP';
use constant C_FEATURE_LA_IPU => 'LA_IPU';
use constant C_FEATURE_DECOMPRESS_REVERT => 'DECOMPRESS_REVERT';
use constant C_FEATURE_WAFLIRON_WHILE_DECOMPRESS => 'WAFLIRON_WHILE_DECOMPRESS';
use constant C_FEATURE_INLINE_COMPRESSION_ON_PARTIAL_CG => 'INLINE_COMPRESSION_ON_PARTIAL_CG';
use constant C_FEATURE_SNAPLOCK =>'SNAPLOCK';
use constant C_FEATURE_CTIME_FILE_CLONE => 'CTIME_FILE_CLONE';
use constant C_FEATURE_NON_CTIME_FILE_CLONE => 'NON_CTIME_FILE_CLONE';
use constant C_FEATURE_IDD => 'IDD';
use constant C_FEATURE_BCE => 'BCE';
use constant C_FEATURE_VBN_ZERO => 'VBN_ZERO';

# PerfStats counters codes. They need to be in sync with hash keys in UI::get_perf_stats_counter
# Warning!!!!! The value string needs to be exactly the same as the constant, for the PerfStats module to work properly
use constant C_PERF_STATS_COUNTER_BUFFERS_CACHEABLE_IN_EC => 'C_PERF_STATS_COUNTER_BUFFERS_CACHEABLE_IN_EC';
use constant C_PERF_STATS_COUNTER_DECOMPRESS_NOMEM => 'C_PERF_STATS_COUNTER_DECOMPRESS_NOMEM';

# Flags codes. They need to be in sync with the release-agnostic definitions in UI/Constants.pm
use constant C_FLAG_WAFL_INCONSISTENT_PANIC_TESTING => 'WAFL_INCONSISTENT_PANIC_TESTING';
use constant C_FLAG_WAFL_DECOMPRESS_FAIL_TESTING => 'WAFL_DECOMPRESS_FAIL_TESTING';
use constant C_FLAG_WAFL_64BIT_UPGRADE_SCAN_DISABLE => 'WAFL_64BIT_UPGRADE_SCAN_DISABLE';
use constant C_FLAG_WAFL_IRON_PANIC_ON_CORRUPTION => 'WAFL_IRON_PANIC_ON_CORRUPTION';
use constant C_FLAG_WAFL_DISABLE_FILE_CLONE_BG_SHARING => 'DISABLE_FILE_CLONE_BG_SHARING';

# Privileges
use constant C_PRIV_DIAG => 'diag';
use constant C_PRIV_ADVANCED => 'advanced';
use constant C_PRIV_TEST => 'test';
use constant C_PRIV_ADMIN => 'admin';

# Events - supportability testing
use constant C_EVENT_COMPRESSION_ENABLED => 'COMPRESSION_ENABLED';
use constant C_EVENT_COMPRESSION_DISABLED => 'COMPRESSION_DISABLED';
use constant C_EVENT_COMPRESS_STARTED => 'COMPRESS_STARTED';
use constant C_EVENT_COMPRESS_ABORTED => 'COMPRESS_ABORTED';
use constant C_EVENT_COMPRESS_COMPLETED => 'COMPRESS_COMPLETED';
use constant C_EVENT_DECOMPRESS_STARTED => 'DECOMPRESS_STARTED';
use constant C_EVENT_DECOMPRESS_COMPLETED => 'DECOMPRESS_COMPLETED';
use constant C_EVENT_DECOMPRESS_ABORTED => 'DECOMPRESS_ABORTED';
use constant C_EVENT_DECOMPRESS_SPACE_FULL => 'DECOMPRESS_SPACE_FULL';
use constant C_EVENT_COMPRESSED_VOL_IS_OFFLINED => 'COMPRESSED_VOL_IS_OFFLINED';


# Status constants for vol copy
use constant C_VOL_COPY_STATUS_IDLE => 'idle';
use constant C_VOL_COPY_STATUS_TRANSFERRING => 'transferring';
use constant C_AGGR_COPY_STATUS_IDLE => 'idle';
use constant C_AGGR_COPY_STATUS_TRANSFERRING => 'transferring';

#################
# Client
#################
use constant C_CLIENT_NFS_TAG	=> "nfs";
use constant C_CLIENT_CIFS_TAG	=> "cifs";
use constant C_CLIENT_TYPE_ANY  => "any";
use constant C_DFLT_CLIENT_TYPE => C_CLIENT_TYPE_ANY;
use constant C_CLIENT_NFS_LOCAL	=> "localhost";
use constant C_CIFS_ADMIN_USER => "Administrator";
use constant C_CIFS_ADMIN_PASSWORD => "netapp1!";

#################
# Decompress
#################
use constant C_DFLT_DECOMPRESS_INTERVAL => 1;
use constant C_DFLT_DECOMPRESS_TIMEOUT => 7200;

####################
# CompressionScanner
####################
use constant C_DFLT_COMPRESS_INTERVAL => 1;
use constant C_DFLT_COMPRESS_TIMEOUT => 1800; 
use constant C_MAX_DATA_SIZE_CHECKPOINT_ALLOWED_EMPTY => GB;

####################
# PerfStats
####################
use constant C_WAFL_STATS => 'wafl_stats';
use constant C_WAFL_CPSTATS => 'cpstats';
use constant C_STATS => 'stats';

#################
# Verify
#################
use constant C_VERIFY_OPERATION	=> TRUE;
use constant C_VERIFY_OP_COMPRESS_ENABLE => TRUE;

#################
# Fiji
#################
# They need to be in sync with fiji point definition key hashes in UI::CLI::FijiPoints
use constant C_FIJI_TAG_DISABLE_CP => 'Disable timer-triggered CP';
use constant C_FIJI_TAG_ENABLE_CP => 'Enable timer-triggered CP';
use constant C_FIJI_TAG_PANIC_ON_COMPRESS => 'Panic on compress';
use constant C_FIJI_TAG_PANIC_ON_DECOMPRESS => 'Panic on decompress';
use constant C_FIJI_TAG_COMPR_CORRUPT_CHECKSUM => 'Corrupt checksum on compress';
use constant C_FIJI_TAG_DECOMPR_CORRUPT_CHECKSUM => 'Corrupt checksum on decompress';
use constant C_FIJI_TAG_SUPPRESS_DECOMPR_COMPLETION_EMS => 'Suppress decompress completion ems';
use constant C_FIJI_TAG_SLEEP_AT_STAGE => 'Dense sleep at stage';
use constant C_FIJI_TAG_SLEEP_BEFORE_RECORD_CHECKPOINT => 'Dense sleep before record checkpoint';
use constant C_FIJI_TAG_SLEEP_AFTER_RECORD_CHECKPOINT => 'Dense sleep after record checkpoint';
use constant C_FIJI_TAG_SLEEP_WHILE_COMPR_SCANNER => 'Sleep during compress scanner';
use constant C_FIJI_TAG_SIMULATE_REP_METAFILE_ERROR => 'Simulate REP error on compression metafile';
use constant C_FIJI_TAG_SIMULATE_REP_ERROR_WHILE_READING_CHNGLOG => 'Simulate REP error while reading changelog';
use constant C_FIJI_TAG_SUSPEND_SCAN_64BIT_UPGRADE => 'Suspend 64-bit upgrade scan';
use constant C_FIJI_TAG_SUSPEND_FILE_CLONE => 'Suspend file clone operation';
use constant C_FIJI_DFLT_REP_METAFILE_ERROR => 80;
use constant C_FIJI_DENSE_SLEEP_STAGE_NOP => 'C_FIJI_DENSE_SLEEP_STAGE_NOP';
use constant C_FIJI_DENSE_SLEEP_STAGE_LOGGING => 'C_FIJI_DENSE_SLEEP_STAGE_LOGGING';
use constant C_FIJI_DENSE_SLEEP_STAGE_WOC_SORTING => 'C_FIJI_DENSE_SLEEP_STAGE_WOC_SORTING';
use constant C_FIJI_DENSE_SLEEP_STAGE_WOC_COMPRESSING => 'C_FIJI_DENSE_SLEEP_STAGE_WOC_COMPRESSING';
use constant C_FIJI_DENSE_SLEEP_STAGE_GATHERING => 'C_FIJI_DENSE_SLEEP_STAGE_GATHERING';
use constant C_FIJI_DENSE_SLEEP_STAGE_SORTING => 'C_FIJI_DENSE_SLEEP_STAGE_SORTING';
use constant C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P1 => 'C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P1';
use constant C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P2 => 'C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P2';
use constant C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_SHARING => 'C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_SHARING';
use constant C_FIJI_DENSE_SLEEP_STAGE_CHECKING => 'C_FIJI_DENSE_SLEEP_STAGE_CHECKING';
use constant C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P1 => 'C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P1';
use constant C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P2 => 'C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P2';
use constant C_FIJI_DENSE_SLEEP_STAGE_DONE => 'C_FIJI_DENSE_SLEEP_STAGE_DONE';

##############
# 10-mode
##############
use constant C_10MODE_BUILD_TYPE_SIM => 'SIM';
use constant C_10MODE_BUILD_TYPE_DEBUG => 'DEBUG';

####################
# UpgradeRevert
####################
use constant C_CURRENT_RELEASE => 'CURRENT_REL';
use constant C_KERNEL_TYPE_RELEASES => 'releases';
use constant C_KERNEL_TYPE_DEBUG => 'releases_debug';
use constant C_KERNEL_TYPE_RELEASES_PBO => 'releases_pbo';
use constant C_DFLT_KERNEL_TYPE => C_KERNEL_TYPE_DEBUG;
# Warning: this needs to be large (if sis revert is needed for the root volume, it will take a really long time)
use constant C_DFLT_SIS_REVERT_TIMEOUT => 3600;
use constant C_MIN_REL_ALLOWING_64BIT_ROOT_VOL => '8.0.1';

####################
# Paloma bre
####################
use constant C_SNAPMIRROR_STATE => 'state';
use constant C_SNAPMIRROR_STATUS => 'status';
use constant C_SNAPMIRROR_PROGRESS => 'progress';
use constant C_SNAPMIRROR_HEALTHY => 'healthy';
use constant C_SNAPMIRROR_STATE_SNAPMIRRORED => 'snapmirrored';
use constant C_SNAPMIRROR_STATE_UNINITIALIZED => 'uninitialized';
use constant C_SNAPMIRROR_STATE_BROKEN_OFF => 'broken-off';
use constant C_SNAPMIRROR_STATUS_TRANSFERRING => 'transferring';
use constant C_SNAPMIRROR_STATUS_IDLE => 'idle';
use constant C_SNAPMIRROR_SCHEDULE_CLEAR => 'clear';
use constant C_SNAPMIRROR_SCHEDULE_RESTORE => 'restore';
use constant C_SNAPMIRROR_SCHEDULE_GET => 'get';

####################
# Tape 
####################
use constant C_NDMP_TAPE_PROTOCOL => 'ndmp';
use constant C_DUMP_TAPE_PROTOCOL => 'dumprestore';
use constant C_SMTAPE_TAPE_PROTOCOL => 'smtape';
use constant C_NDMP_VERSION => '4';
use constant C_NDMP_AUTHTYPE => 'plaintext,challenge';
use constant C_NDMP_ACCESS => 'all';
use constant C_NDMP_DUMP_OPTION => 'u';
use constant C_NDMP_DUMP_DIR => 'dump_dir';

##############
# Return codes
##############
use constant C_RC_SUCCESS	=> TRUE;
use constant C_RC_FAILURE	=> FALSE;
use constant C_RC_FAILURE_NON_FATAL               => 2;
use constant C_RC_COMPRESSION_NOT_TURNED_OFF      => 3;
use constant C_RC_COMPRESSION_NOT_TURNED_ON       => 4;
use constant C_RC_INSUFFICIENT_SPACE              => 5;
use constant C_RC_NO_DATA_TO_DECOMPRESS           => 6;
use constant C_RC_NO_DECOMPRESSION_IN_PROGR       => 7;
use constant C_RC_PERCENTAGE_MISSED               => 8;
use constant C_RC_WAFLIRON_IDLE                   => 9;
use constant C_RC_NO_WAFLIRON_IN_PROGRESS         => 10;
use constant C_RC_WAFLIRON_CORRUPTION_FOUND       => 11;
use constant C_RC_VOLUME_NOT_FOUND                => 12;
use constant C_RC_NO_NEARSTORE_LICENSE            => 13;
use constant C_RC_NO_COMPRESSION_LICENSE          => 14;
use constant C_RC_DECOMPRESSION_STILL_IN_PROGRESS => 15;
use constant C_RC_VOLUME_NOT_ONLINE               => 16;
use constant C_RC_INVALID_COMMAND_ARGUMENT        => 17;
use constant C_RC_WACK_ERRORS_FOUND               => 18;
use constant C_RC_WACK_NOT_RUN                    => 19;
use constant C_RC_WACK_INFO_NEEDED                => 20;
use constant C_RC_WACK_NOT_CONSOLE_LOGGED         => 21;
use constant C_RC_VOLUME_TYPE_NOT_FLEX            => 22;
use constant C_RC_ILLEGAL_OPTION_FOR_SNAPLOCK_VOL => 23;
use constant C_RC_NO_COMPRESSION_IN_PROGR         => 24;
use constant C_RC_COMPRESSION_STILL_IN_PROGRESS   => 25;
use constant C_RC_OP_NOT_ALLOWED_ON_ROOT_VOL      => 26;
use constant C_RC_VOLUME_IS_NOT_BEING_SPLIT       => 27;
use constant C_RC_VOLUME_IS_NOT_A_CLONE           => 28;
use constant C_RC_CHECKPOINT_FILE_EMPTY           => 29;
use constant C_RC_INVALID_PATH                    => 30;
use constant _C_RC_COMPR_ON_FULLY_FUNCTIONAL      => 31;
use constant _C_RC_COMPR_ON_NO_INLINE             => 32;
use constant _C_RC_COMPR_OFF                      => 33;
use constant C_RC_INLINE_COMPRESSION_NOT_OFF      => 34;
use constant C_RC_SCANNER_IDLE                    => 35;
use constant C_RC_UNEXPECTED_SCANNER_STAGE        => 36;
use constant C_RC_COMPRESSION_ALLOWED_ONLY_ON_64_BIT => 37;
use constant C_RC_COMPRESSION_NOT_ALLOWED_ON_RSM_VOL => 38;
use constant C_RC_VOL_CLONE_IN_PROGRESS              => 39;
use constant C_RC_DATA_RANGE_MISSED                  => 40;
use constant C_RC_COMPRESSION_ATTEMPTED              => 41;
use constant C_RC_COMPRESSION_NOT_ATTEMPTED          => 42;
use constant C_RC_MIXED_COMPRESSION_BITS             => 43;
use constant C_RC_UNEXPECTED_CHECKPOINT_STAGE        => 44;
use constant C_RC_CHECKPOINT_DOES_NOT_EXIST          => 45;
use constant C_RC_SCANNER_STILL_ACTIVE               => 46;
use constant C_RC_SIS_NOT_TURNED_ON                  => 47;
use constant C_RC_DUMPED_COMPRESSED_BLOCK            => 48;
use constant C_RC_DUMPED_UNCOMPRESSED_BLOCK          => 49;
use constant C_RC_FILE_RESERVATION_ON                => 50;
use constant C_RC_FILE_RESERVATION_OFF               => 51;
use constant C_RC_ROOT_VOLUME_DETECTED               => 52;
use constant C_RC_LA_IPU_NOT_IN_PROGRESS             => 53;
use constant C_RC_LA_IPU_STOPPED                     => 54;
use constant C_RC_VOLUME_IS_READ_ONLY                => 55;
use constant C_RC_VOLUME_HAS_COMPRESSED_DATA         => 56;
use constant C_RC_VOLUME_HAS_RSM_RELATIONSHIPS       => 57;
use constant C_RC_PROCESS_WAS_ABORTED                => 58;
use constant C_RC_QTREE_INVOLVED_IN_OTHER_OPERATION  => 59;
use constant C_RC_SIS_SCANNER_IS_ACTIVE              => 60;
use constant C_RC_VOLUME_HAS_RESTRICTED_SNAPSHOTS    => 61;
use constant C_RC_COMPRESSION_NOT_SUPPORTED_ON_DEST  => 62;
use constant C_RC_NOT_ALLOWED_ON_SNAPVAULT_SECONDARY => 63;
use constant C_RC_SE_OPERATION_IS_QUEUED             => 64;
use constant C_RC_READ_ONLY_FILESYSTEM               => 65;
use constant C_RC_FILE_DOES_NOT_EXIST                => 66;
use constant C_RC_CORRUPTED_DISKS_FOUND              => 67;
use constant C_RC_LOST_BLOCKS_FOUND                  => 68;
use constant C_RC_PVBN_INFO_MISSING                  => 69;
use constant C_RC_INCORRECT_PVBN_INFO                => 70;
use constant C_RC_AGGR_BLOCK_CHECK_IN_PROGRESS       => 71;
use constant C_RC_VOL_IS_NOT_BEING_MOVED             => 72;
use constant C_RC_VOL_MOVE_IS_IN_PROGRESS            => 73;
use constant _C_RC_VOL_MOVE__SETUP_STATE             => 74;
use constant _C_RC_VOL_MOVE__MOVE_STATE              => 75;
use constant _C_RC_VOL_MOVE__CUTOVER_STATE           => 76;
use constant _C_RC_VOL_MOVE__CUTOVER_DEFERRED_STATE  => 77;
use constant C_RC_VOL_STATE_TRANSITION_IN_PROGRESS   => 78;
use constant C_RC_VOL_MOVE_SRC_HAS_CLONE             => 79;
use constant C_RC_VOL_MOVE_SRC_IS_CLONE              => 80;
use constant C_RC_VOL_MOVE_SRC_IS_SNAPLOCK           => 81;
use constant C_RC_SRC_AND_DEST_VOLS_NOT_HOMOGENEOUS  => 82;
use constant C_RC_VOL_IS_RESTRICTED                  => 83;
use constant C_RC_VOL_IS_OFFLINE                     => 84;
use constant C_RC_COMPRESSION_NOT_SUPPORTED          => 85;
use constant C_RC_NOT_ALLOWED_VOL_MOVE_IN_PROGRESS   => 86;
use constant C_RC_NOT_ALLOWED_VOL_MOVE_TRANSFER_SIS_METADATA => 87;
use constant C_RC_FBN_NOT_ACCESSIBLE_ERROR_302 => 88;
use constant C_RC_IDD_ON => 89;
use constant C_RC_IDD_OFF => 90;

my @dflt = qw(
	TRUE FALSE C_FLAG_KEEP_VALUE_AS_IS COMPRESSION
        C_DFLT_FILER_CONN C_DFLT_CLIENT_CONN C_DFLT_TIMEOUT  C_DFLT_CMD_TIMEOUT C_DFLT_ISCSI_CMD_TIMEOUT
	C_LOG_TO_HISTORY ONE_CP_TIME C_DFLT_POSTTEST C_DFLT_FILER_CONN_STATS
	C_ONTAP_BOOT_MODE C_ONTAP_7MODE C_ONTAP_CMODE C_ONTAP_7G 
	C_DISABLE_COMPRESSION_STATE C_ENABLE_COMPRESSION_STATE
        C_DFLT_MAX_RETRIES C_MIN_DATA_TO_COMPRESS C_DFLT_EXTRA_WAIT
        C_DFLT_BOOTUP_WAIT_TIME C_DFLT_REQUIRE_DEBUG_BUILD
        C_DFLT_REQUIRE_HW_PLATFORM C_DFLT_CF_DISABLE
        C_DFLT_CHECK_OPTION_FIRST C_DFLT_WACK_TIMEOUT C_DFLT_SFSR_TIMEOUT
        C_DFLT_CONSOLE_WAIT_TIMEOUT C_DFLT_CLONE_SPLIT_TIMEOUT C_DFLT_CONFIGURE_SCHEDULER C_DFLT_RECYCLE_VFILER
        C_DFLT_MIN_WAIT_UNTIL_UP C_DFLT_WAFL_SCAN_SPEED C_DFLT_MAX_SCANNER_ABORT_TIME C_DFLT_LUN_SIZE
        C_DFLT_FIJI_DENSE_SLEEP_TIME C_DFLT_FIJI_COMPR_SCANNER_SLEEP_TIME C_DFLT_10MODE_FILER_CONN 
);

my @verify = qw(
	C_VERIFY_OP_COMPRESS_ENABLE
	C_VERIFY_OPERATION
);

my @cg = qw(
	C_WAFL_BLOCK_SIZE C_ONE_WAFL_BLOCK C_MIN_CG_BLKS C_MAX_CG_BLKS
	C_DFLT_CG_BLKS C_CG_SIZE C_FIXED_8_BLKS_CG C_ALTERNATE_89_CG C_DFLT_CG_TYPE
        C_CHECKSUM_SIZE C_CHECKSUM_START_BYTE C_CHECKSUM_END_BYTE C_NR_KB_IN_WAFL_BLOCK
        C_MAX_BLOCKS_PER_ONE_L1
);

my @aggr = qw(
	C_DFLT_AGGREGATE
        C_DFLT_AGGREGATE_COPY
        C_DFLT_AGGREGATE_DEST
        C_DFLT_AGGR_DISKS
        C_DFLT_AGGR_TYPE
	C_DFLT_RAID_TYPE
        C_DFLT_AGGR_PURGE
	C_DFLT_AGGR_REUSE_TYPE
        C_DFLT_AGGR_MIRROR
        C_AGGR_32_BIT
        C_AGGR_64_BIT
        C_DFLT_AGGR_INDIRECT_TYPE
        C_LA_IPU_MODE_CHECK
        C_LA_IPU_MODE_NORMAL
        C_LA_IPU_MODE_GROW_RESERVED
        C_LA_IPU_MODE_GROW_ALL
        C_SNAPLOCK_COMPLIANCE
        C_SNAPLOCK_ENTERPRISE
        C_DFLT_SNAPLOCK_AGGREGATE
        C_AGGR_STATE_ONLINE
        C_AGGR_STATE_RESTRICTED
        C_AGGR_STATE_OFFLINE
        C_DFLT_AGGR_COPY_THROTTLE
);

my @vol = qw(
	C_DFLT_VOLUME
        C_DFLT_TEST_VOLUME
        C_DFLT_BASE_VOLUME
        C_DFLT_TRAD_VOLUME
        C_DFLT_IPU_VOLUME
        C_DFLT_PARTNERNODE_VOLUME
        C_DFLT_VOL_SIZE
	C_DFLT_VOL_PURGE
        C_DFLT_TRAD_VOL_RECYCLE
        C_VOL_TYPE_TRAD
        C_VOL_TYPE_FLEX
        C_DFLT_VOL_TYPE
        C_DFLT_VOL_EXPORTFS
        C_DFLT_VOL_MOUNT
        C_VOL_STATE_ONLINE
        C_VOL_STATE_OFFLINE
        C_VOL_STATE_RESTRICTED
        C_VOL_STATE_BUSY
        C_VOL_USED_SPACE_MIN_JITTER
        C_VOL_DFLT_SNAPLOCK_RETENTION
        C_VOL_MIN_SNAPLOCK_RETENTION
        C_VOL_MAX_SNAPLOCK_RETENTION
        C_DFLT_VOL_COPY_THROTTLE
        C_VOL_MOVE_STATE_SETUP
        C_VOL_MOVE_STATE_MOVE
        C_VOL_MOVE_STATE_CUTOVER
        C_VOL_MOVE_STATE_CUTOVER_DEFERRED
);

my @enable = qw(
	C_ENABLE_COMPRESSION C_ENABLE_DEDUPE C_ENABLE_SNAPLOCK
);

my @ded = qw(
	C_MIN_SHARE_BLKS
        C_DEDUPE_STATE_ON
        C_DEDUPE_STATE_OFF
	C_DEDUPE_STATE_ENABLED
        C_DEDUPE_STATUS
        C_DEDUPE_STATUS_INITIALIZING
        C_DEDUPE_STATUS_IDLE
        C_DEDUPE_STATUS_ACTIVE
        C_DEDUPE_STATUS_UNDOING
        C_DEDUPE_STATUS_NOSTATUS
        C_DEDUPE_STATUS_DONE
        C_DEDUPE_STATUS_DASH
        C_DEDUPE_STAGE
        C_DEDUPE_STAGE_GATHING
        C_DEDUPE_STAGE_SORTING
        C_DEDUPE_STAGE_CHECK_P1
        C_DEDUPE_STAGE_CHECK_P2
        C_DEDUPE_STAGE_SAVING
        C_DEDUPE_STAGE_DONE
        C_DEDUPE_STAGE_DASH
        C_DEDUPE_SCHEDULE_NONE
        C_DFLT_SIS_SCHEDULE
);

my @ds = qw(
	C_DFLT_COMPRESSION_DATASET
	C_MIN_DATASET_SIZE C_DFLT_DATASET_FORMAT
	C_ONE_BYTE
        KB
        MB
        GB
	C_DATASET_SPARSE
	C_DATASET_DENSE
	C_DATASET_RICHDATA
        C_DATASET_SMALL_SIZE
        C_DATASET_MEDIUM_SIZE
        C_DATASET_LARGE_SIZE
        C_DATASET_JUMBO_SIZE
);

my @file = qw(
	C_FILE_RESERVATION_ON
        C_FILE_RESERVATION_OFF
);

my @license = qw(
	C_LICENSE_SERVICE
	C_LICENSE_SERVICE_DEPENDENCY
	C_LICENSE_NFS
	C_LICENSE_CIFS
	C_LICENSE_SNAPMIRROR
	C_LICENSE_HTTP
	C_LICENSE_COMPRESSION
	C_LICENSE_NEARSTORE
        C_LICENSE_ASIS
        C_LICENSE_CLUSTER
	C_LICENSE_SNAPRESTORE
        C_LICENSE_SNAPLOCK
        C_LICENSE_SNAPVAULT_PRI
        C_LICENSE_SNAPVAULT_SEC
        C_LICENSE_MULTISTORE
        C_LICENSE_ISCSI
        C_LICENSE_CMODE_BASE
        C_DFLT_LICENSE_READY
        C_DFLT_ADD_NSP_LICENSE
);

my @ui = qw(
	C_DFLT_UI_TYPE
	C_UI_CLI
	C_UI_ZAPI
        C_STR_ZAPI_NOT_AVAILABLE
        C_CONN_CONSOLE
        C_OPTION_COMPRESSION
        C_OPTION_GUARANTEE
        C_OPTION_FRACTIONAL_RESERVE
        C_OPTION_TRY_FIRST
        C_OPTION_SNAPLOCK_AUTOCOMMIT_PERIOD
        C_CMD_GET_SAVINGS
        C_CMD_OPTION_SET
        C_CMD_DECOMPRESS_START
        C_CMD_DECOMPRESS_STOP
        C_CMD_DECOMPRESS_STATUS
        C_CMD_COMPRESS_START
        C_CMD_COMPRESS_STATUS
        C_CMD_COMPRESS_STATUS_CHECKPOINT
        _C_CMD_PARSE_CHECKPOINT_TIME
        C_CMD_COMPRESS_STOP
        C_CMD_LICENSE_ADD
        C_CMD_LICENSE_REMOVE
        C_CMD_AUTOSIZE
        C_CMD_VOL_CLONE_SPLIT_START
        C_CMD_VOL_CLONE_SPLIT_STOP
        C_CMD_VOL_ONLINE
        C_CMD_IS_COMPRESSION_ENABLED
        C_CMD_ENABLE_COMPRESSION
        C_CMD_DISABLE_COMPRESSION
        C_CMD_SFSR_START
        C_CMD_SFSR_TO_PATH_START
        C_CMD_GET_STATS
        C_CMD_VERIFY_COMPRESSION_ATTEMPTED
        C_CMD_VERIFY_SIS_LS
        _C_CMD_CHANGELOG_FINGERPRINTS
        C_CMD_DEDUPE_START
        C_CMD_DEDUPE_SET_STATE
        C_CMD_DEDUPE_STOP
        C_CMD_DEDUPE_OFF_UNDO
        C_CMD_GET_VBN_INFO
        C_CMD_DUMPBLOCK_FILE
        C_CMD_FILE_RESERVATION
        C_CMD_GET_FILE_ID
        C_CMD_SYNC
        C_CMD_GET_SNAP_RECLAIMABLE
        C_CMD_DISK_FREE
        C_CMD_GET_RESERVED
        C_CMD_AGGR_SNAP_LIST
        C_CMD_AGGR_SNAP_DELETE
        C_CMD_DEDUPE_WAIT
        C_CMD_DETECT_ROOT_VOL
        C_CMD_FILE_FOLDING_START
        C_CMD_FILE_FOLDING_STATUS
        C_CMD_FILE_FOLDING_ABORT
        C_CMD_DUMPBLOCK_INFO
        C_CMD_DUMPBLOCK_INFO_L1
        C_CMD_GET_REFCOUNT
        C_CMD_SIS_CHECK
        C_CMD_LA_IPU_STATUS
        C_CMD_GET_CONTAINMENT_VERSION
        C_CMD_GET_COMPRESSION_STATS
        C_CMD_COMPRESSION_STATS_START
        C_CMD_COMPRESSION_STATS_STOP
        C_CMD_DECOMPRESS_REVERT
        C_CMD_BUFTREE_CHECK
        C_CMD_SET_SNAPLOCK_AUTO_COMMIT
        C_CMD_SNAPMIRROR_RESYNC
        C_CMD_SNAPVAULT_UPDATE
        C_CMD_SET_WAFL_SCAN_SPEED
        C_CMD_GET_WAFL_SCAN_SPEED
        C_CMD_VOL_COPY_START
        C_CMD_AGGR_COPY_START
        C_CMD_VOL_SNAP_RESTORE
        C_CMD_SNAPMIRROR_INITIALIZE
        C_CMD_DELETE_FILE
        C_CMD_GET_SNAPLOCK_CONTAINMENT_BITS
        C_CMD_FILE_CLONE_START
        C_CMD_FILE_CLONE_CLEAR
        C_CMD_FILE_CLONE_STOP
        C_CMD_BG_FILE_CLONE_STATUS
        C_CMD_AGGR_BLOCK_CHECK_START
        C_CMD_GET_DATA_DISKS
        C_CMD_VOL_MOVE_START
        C_CMD_VOL_MOVE_STATUS
        C_CMD_VOL_MOVE_CUTOVER
        C_CMD_VOL_MOVE_PAUSE
        C_CMD_VOL_MOVE_IS_PAUSED
        C_CMD_FIND_VOL_MOVE_STATE
        C_CMD_VFILER_MIGRATE_STATUS
        C_CMD_VOL_ONLINE_RO
        C_CMD_VOL_STATUS
        C_CMD_WAFL_PUNCH
        C_CMD_GET_VOLUME_STATS
        C_CMD_GET_WAFL_STATS
        C_CMD_GET_VBN_INFO_ERROR
        C_CMD_SNAPMIRROR_UPDATE
        C_CMD_CONFIGURE_IDD
        C_CMD_IS_IDD_ENABLED
        C_FORMAT_TYPE_1
        C_FORMAT_TYPE_2
        C_CORRUPT_FSINFO_INOS_USED
        C_CORRUPT_FSINFO_BLKS_USED_BY_PLANE0
        C_CORRUPT_FSINFO_BLKS_COMPRESS_HOLES
        C_CORRUPT_INODE_BLK_CNT
        C_CORRUPT_REFCOUNT
        C_CORRUPT_CHECKSUM
        C_CORRUPT_CG_HEADER_VBN
        C_CORRUPT_CG_HEADER_VVBN
        C_CORRUPT_CG_TRAILER_VBN
        C_CORRUPT_CG_TRAILER_VVBN
        C_CORRUPT_CG_DATA_VBN
        C_CORRUPT_CG_DATA_VVBN
        C_CORRUPT_REP
        C_CONSOLE_VOLUME_FULL
        C_CONSOLE_OUT_OF_SPACE_SFSR_ABORTED
        C_CONSOLE_INSUFFICIENT_SPACE_FOR_SFSR
	C_CONSOLE_INSUFFICIENT_SPACE_TO_GROW_VOLUME
        C_CONSOLE_VOL_RESTORE_STARTED
        C_CONSOLE_DECOMPRESS_ABORTED
	C_CONSOLE_DECOMPRESS_COMPLETED
        C_CONSOLE_COMPRESS_CHECKPOINT_DELETED
        C_CONSOLE_COMPRESSION_ABORTED_AS_SNAPSHOT_IS_CREATED
        C_CONSOLE_OUT_OF_SPACE_SIS_ABORTED
        C_CONSOLE_WAFL_INCONSISTENT
        C_STATUS_ACTIVE
        C_STATUS_IDLE
        C_STATUS_UNDOING
        C_STAGE_COMPRESS_PREPROC
        C_STAGE_COMPRESSING
        C_STAGE_CHECKING_P1
        C_STAGE_CHECKING_P2
        C_STAGE_NONE
        C_STAGE_SORTING
        C_STAGE_SAVING
        C_STAGE_GATHERING
        C_STAGE_DONE
        C_CHECKPOINT_STAGE_NONE
        C_CHECKPOINT_STAGE_SORTING
        C_CHECKPOINT_STAGE_SAVING_PASS1
        C_CHECKPOINT_STAGE_SAVING_PASS2
        C_CHECKPOINT_STAGE_SAVING_SHARING
        C_CHECKPOINT_STAGE_SAVING_END
        C_CHECKPOINT_STAGE_COMPRESSING
        C_STATE_AT_LEAST_ONCE_ENABLED
        C_STATE_NEVER_ENABLED
        C_FEATURE_PRE_CP
        C_FEATURE_LA_IPU
        C_FEATURE_DECOMPRESS_REVERT
        C_FEATURE_WAFLIRON_WHILE_DECOMPRESS
        C_FEATURE_INLINE_COMPRESSION_ON_PARTIAL_CG
        C_FEATURE_SNAPLOCK
        C_FEATURE_CTIME_FILE_CLONE
        C_FEATURE_NON_CTIME_FILE_CLONE
        C_FEATURE_IDD
        C_FEATURE_BCE
        C_FEATURE_VBN_ZERO
        C_PERF_STATS_COUNTER_BUFFERS_CACHEABLE_IN_EC
        C_PERF_STATS_COUNTER_DECOMPRESS_NOMEM
        C_FLAG_WAFL_INCONSISTENT_PANIC_TESTING
        C_FLAG_WAFL_DECOMPRESS_FAIL_TESTING
        C_FLAG_WAFL_64BIT_UPGRADE_SCAN_DISABLE
        C_FLAG_WAFL_IRON_PANIC_ON_CORRUPTION
        C_FLAG_WAFL_DISABLE_FILE_CLONE_BG_SHARING
        C_PRIV_DIAG
        C_PRIV_ADVANCED
        C_PRIV_TEST
        C_PRIV_ADMIN
        C_EVENT_COMPRESSION_ENABLED
        C_EVENT_COMPRESSION_DISABLED
        C_EVENT_COMPRESS_STARTED
        C_EVENT_COMPRESS_ABORTED
        C_EVENT_COMPRESS_COMPLETED
        C_EVENT_DECOMPRESS_STARTED
        C_EVENT_DECOMPRESS_COMPLETED
        C_EVENT_DECOMPRESS_ABORTED
        C_EVENT_DECOMPRESS_SPACE_FULL
        C_EVENT_COMPRESSED_VOL_IS_OFFLINED
        C_VOL_COPY_STATUS_IDLE
        C_VOL_COPY_STATUS_TRANSFERRING
        C_AGGR_COPY_STATUS_IDLE
        C_AGGR_COPY_STATUS_TRANSFERRING
        
);

my @client = qw(
	C_DFLT_CLIENT_TYPE
	C_CLIENT_NFS_TAG
	C_CLIENT_CIFS_TAG
        C_CLIENT_TYPE_ANY
	C_CLIENT_NFS_LOCAL
	C_CIFS_ADMIN_USER
	C_CIFS_ADMIN_PASSWORD
);

my @decompress = qw(
	C_DFLT_DECOMPRESS_INTERVAL
	C_DFLT_DECOMPRESS_TIMEOUT
);

my @compressionscanner = qw(
	C_DFLT_COMPRESS_INTERVAL
	C_DFLT_COMPRESS_TIMEOUT
        C_MAX_DATA_SIZE_CHECKPOINT_ALLOWED_EMPTY
);

my @perfstats = qw(
        C_WAFL_STATS
        C_WAFL_CPSTATS
        C_STATS
);

my @fiji = qw(
	C_FIJI_TAG_DISABLE_CP
	C_FIJI_TAG_ENABLE_CP
        C_FIJI_TAG_PANIC_ON_COMPRESS
        C_FIJI_TAG_PANIC_ON_DECOMPRESS
        C_FIJI_TAG_COMPR_CORRUPT_CHECKSUM
        C_FIJI_TAG_DECOMPR_CORRUPT_CHECKSUM
        C_FIJI_TAG_SUPPRESS_DECOMPR_COMPLETION_EMS
        C_FIJI_TAG_SLEEP_AT_STAGE
        C_FIJI_TAG_SLEEP_BEFORE_RECORD_CHECKPOINT
        C_FIJI_TAG_SLEEP_AFTER_RECORD_CHECKPOINT
        C_FIJI_TAG_SLEEP_WHILE_COMPR_SCANNER
        C_FIJI_TAG_SIMULATE_REP_METAFILE_ERROR
        C_FIJI_TAG_SIMULATE_REP_ERROR_WHILE_READING_CHNGLOG
        C_FIJI_TAG_SUSPEND_SCAN_64BIT_UPGRADE
        C_FIJI_TAG_SUSPEND_FILE_CLONE
        C_FIJI_DFLT_REP_METAFILE_ERROR
        C_FIJI_DENSE_SLEEP_STAGE_NOP
        C_FIJI_DENSE_SLEEP_STAGE_LOGGING
        C_FIJI_DENSE_SLEEP_STAGE_WOC_SORTING
        C_FIJI_DENSE_SLEEP_STAGE_WOC_COMPRESSING
        C_FIJI_DENSE_SLEEP_STAGE_GATHERING
        C_FIJI_DENSE_SLEEP_STAGE_SORTING
        C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P1
        C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_P2
        C_FIJI_DENSE_SLEEP_STAGE_DEDUPING_SHARING
        C_FIJI_DENSE_SLEEP_STAGE_CHECKING
        C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P1
        C_FIJI_DENSE_SLEEP_STAGE_CHECKING_P2
        C_FIJI_DENSE_SLEEP_STAGE_DONE
);

my @cmode = qw(
        C_10MODE_BUILD_TYPE_SIM
        C_10MODE_BUILD_TYPE_DEBUG
);

my @upgrade_revert = qw(
        C_CURRENT_RELEASE
        C_KERNEL_TYPE_RELEASES
        C_KERNEL_TYPE_DEBUG
        C_KERNEL_TYPE_RELEASES_PBO
        C_DFLT_KERNEL_TYPE
        C_DFLT_SIS_REVERT_TIMEOUT
        C_MIN_REL_ALLOWING_64BIT_ROOT_VOL
);
my @paloma_bre = qw(
        C_SNAPMIRROR_STATE
        C_SNAPMIRROR_STATUS
        C_SNAPMIRROR_PROGRESS
        C_SNAPMIRROR_HEALTHY
        C_SNAPMIRROR_STATE_SNAPMIRRORED
        C_SNAPMIRROR_STATE_UNINITIALIZED
        C_SNAPMIRROR_STATE_BROKEN_OFF
        C_SNAPMIRROR_STATUS_TRANSFERRING
        C_SNAPMIRROR_STATUS_IDLE
        C_SNAPMIRROR_SCHEDULE_GET
        C_SNAPMIRROR_SCHEDULE_CLEAR
        C_SNAPMIRROR_SCHEDULE_RESTORE
);

my @tape = qw(
        C_NDMP_TAPE_PROTOCOL
        C_DUMP_TAPE_PROTOCOL
        C_SMTAPE_TAPE_PROTOCOL
        C_NDMP_VERSION 
        C_NDMP_AUTHTYPE
        C_NDMP_ACCESS
        C_NDMP_DUMP_OPTION
        C_NDMP_DUMP_DIR
);

my @returncode = qw(
	C_RC_SUCCESS
	C_RC_FAILURE
        C_RC_FAILURE_NON_FATAL
	C_RC_COMPRESSION_NOT_TURNED_OFF
        C_RC_COMPRESSION_NOT_TURNED_ON
	C_RC_INSUFFICIENT_SPACE
	C_RC_NO_DATA_TO_DECOMPRESS
	C_RC_NO_DATA_TO_COMPRESS
	C_RC_NO_DECOMPRESSION_IN_PROGR
        C_RC_DECOMPRESSION_STILL_IN_PROGRESS
        C_RC_NO_COMPRESSION_IN_PROGR
        C_RC_COMPRESSION_STILL_IN_PROGRESS
	C_RC_PERCENTAGE_MISSED
	C_RC_WAFLIRON_IDLE
	C_RC_NO_WAFLIRON_IN_PROGRESS
	C_RC_WAFLIRON_CORRUPTION_FOUND
        C_RC_VOLUME_NOT_FOUND
        C_RC_NO_NEARSTORE_LICENSE
        C_RC_NO_COMPRESSION_LICENSE
        C_RC_VOLUME_NOT_ONLINE
        C_RC_INVALID_COMMAND_ARGUMENT
        C_RC_WACK_ERRORS_FOUND
        C_RC_WACK_NOT_RUN
        C_RC_WACK_INFO_NEEDED
        C_RC_WACK_NOT_CONSOLE_LOGGED
        C_RC_VOLUME_TYPE_NOT_FLEX
        C_RC_ILLEGAL_OPTION_FOR_SNAPLOCK_VOL
        C_RC_OP_NOT_ALLOWED_ON_ROOT_VOL
        C_RC_VOLUME_IS_NOT_BEING_SPLIT
        C_RC_VOLUME_IS_NOT_A_CLONE
        C_RC_CHECKPOINT_FILE_EMPTY
        C_RC_INVALID_PATH
        _C_RC_COMPR_ON_FULLY_FUNCTIONAL
        _C_RC_COMPR_ON_NO_INLINE
        _C_RC_COMPR_OFF
        C_RC_INLINE_COMPRESSION_NOT_OFF
        C_RC_SCANNER_IDLE
        C_RC_UNEXPECTED_SCANNER_STAGE
        C_RC_COMPRESSION_ALLOWED_ONLY_ON_64_BIT
        C_RC_COMPRESSION_NOT_ALLOWED_ON_RSM_VOL
        C_RC_VOL_CLONE_IN_PROGRESS
        C_RC_DATA_RANGE_MISSED
        C_RC_COMPRESSION_ATTEMPTED
        C_RC_COMPRESSION_NOT_ATTEMPTED
        C_RC_MIXED_COMPRESSION_BITS
        C_RC_UNEXPECTED_CHECKPOINT_STAGE
        C_RC_CHECKPOINT_DOES_NOT_EXIST
        C_RC_SCANNER_STILL_ACTIVE
        C_RC_SIS_NOT_TURNED_ON
        C_RC_DUMPED_COMPRESSED_BLOCK
        C_RC_DUMPED_UNCOMPRESSED_BLOCK
        C_RC_FILE_RESERVATION_ON
        C_RC_FILE_RESERVATION_OFF
        C_RC_ROOT_VOLUME_DETECTED
        C_RC_LA_IPU_NOT_IN_PROGRESS
        C_RC_LA_IPU_STOPPED
        C_RC_VOLUME_IS_READ_ONLY
        C_RC_VOLUME_HAS_COMPRESSED_DATA
        C_RC_VOLUME_HAS_RSM_RELATIONSHIPS
        C_RC_PROCESS_WAS_ABORTED
        C_RC_QTREE_INVOLVED_IN_OTHER_OPERATION
        C_RC_SIS_SCANNER_IS_ACTIVE
        C_RC_VOLUME_HAS_RESTRICTED_SNAPSHOTS
        C_RC_COMPRESSION_NOT_SUPPORTED_ON_DEST
        C_RC_NOT_ALLOWED_ON_SNAPVAULT_SECONDARY
        C_RC_SE_OPERATION_IS_QUEUED
        C_RC_READ_ONLY_FILESYSTEM
        C_RC_FILE_DOES_NOT_EXIST
        C_RC_CORRUPTED_DISKS_FOUND
        C_RC_LOST_BLOCKS_FOUND
        C_RC_PVBN_INFO_MISSING
        C_RC_INCORRECT_PVBN_INFO
        C_RC_AGGR_BLOCK_CHECK_IN_PROGRESS
        C_RC_VOL_IS_NOT_BEING_MOVED
        C_RC_VOL_MOVE_IS_IN_PROGRESS
        _C_RC_VOL_MOVE__SETUP_STATE
        _C_RC_VOL_MOVE__MOVE_STATE
        _C_RC_VOL_MOVE__CUTOVER_STATE
        _C_RC_VOL_MOVE__CUTOVER_DEFERRED_STATE
        C_RC_VOL_STATE_TRANSITION_IN_PROGRESS
        C_RC_VOL_MOVE_SRC_HAS_CLONE
        C_RC_VOL_MOVE_SRC_IS_CLONE
        C_RC_VOL_MOVE_SRC_IS_SNAPLOCK
        C_RC_SRC_AND_DEST_VOLS_NOT_HOMOGENEOUS
        C_RC_VOL_IS_RESTRICTED
        C_RC_VOL_IS_OFFLINE
        C_RC_COMPRESSION_NOT_SUPPORTED
        C_RC_NOT_ALLOWED_VOL_MOVE_IN_PROGRESS
        C_RC_NOT_ALLOWED_VOL_MOVE_TRANSFER_SIS_METADATA
        C_RC_FBN_NOT_ACCESSIBLE_ERROR_302
        C_RC_IDD_ON
        C_RC_IDD_OFF
);

our %EXPORT_TAGS = (
	dflt 	=> [ @dflt ],
	aggr 	=> [ @aggr ],
	vol 	=> [ @vol ],
	enable 	=> [ @enable ],
	dedupe 	=> [ @ded ],
	ds 	=> [ @ds ],
        file    => [ @file ],
	lic	=> [ @license ],
	ui	=> [ @ui ],
	client	=> [ @client ],
	dec	=> [ @decompress ],
	com     => [@compressionscanner],
        stats   => [@perfstats],
	cg	=> [ @cg ],
	verify	=> [ @verify ],
        fiji    => [ @fiji ],
        cmode   => [ @cmode ],
        upg_rev => [ @upgrade_revert ],
        bre     => [ @paloma_bre ],
        tape    => [ @tape ],
	rc	=> [ @returncode ],
);

$EXPORT_TAGS{'all'} = [@dflt, @aggr, @vol, @enable, @ded, @ds, @file, @license, @ui, @client, @decompress, @compressionscanner, @perfstats, @cg, @verify, @fiji, @cmode, @upgrade_revert, @paloma_bre, @tape, @returncode];
Exporter::export_ok_tags('all');

} # BEGIN


1;
