#
# $Id: //depot/prod/test/Rsierranevada/lib/Compression/base_import.pl#1 $
#

## @summary Base compression imports
##
## @description
##    defines the basic modules required for compression
## 
## @author sureshb@netapp.com, dl-compression-qa@netapp.com
## @status private (in-progress)

use strict;
use warnings;

use Carp qw(confess);
use Params::Validate qw(validate SCALAR HASHREF ARRAYREF BOOLEAN UNDEF OBJECT);
use Data::Dumper;
$Data::Dumper::Indent = 3;

use Module::Common;

use Tharn;
use filer;
use Volume qw(:vol :df);
use FSR::FSRutils qw(worstType);

use Compression::Constants qw(:all);
use Compression::UI;
use Compression::UI::CLI;
use Compression::Compress;
use Compression::Filer;
use Compression::Aggregate;
use Compression::Volume;
use Compression::Qtree;
use Compression::SnapVault;
use Compression::SnapMirror;
use Compression::Cluster;
use Compression::Utils;

use Data::Dumper;

BEGIN 
{
	require Exporter;
	our @ISA = qw(Exporter);

	Params::Validate::validation_options
	(
	    on_fail => sub {my @msgs = @_; chomp(@msgs);
	    Carp::confess(Tharn::script_result(@msgs))}
	);
	
	my $vserver = $main::VSERVER;
	if (defined($vserver))
	{
		eval "use GNOTE";
		eval "use GNOTE::GX::Fiji";
	}
	else
	{
		eval "use NOTE";
		eval "use NOTE::Vfiler";
		eval "use NOTE::LUN";
	}
	
	if ($@)
	{
		logresult('config', "Failed to import the underlying library:\n" . $@);
	}
}

1;
