#!/usr/software/bin/perl -w
use CGI::Carp qw(fatalsToBrowser);
use strict;
use CGI;
use Data::Dumper;
use Switch;
use CBTemplate;

my $cgi= CGI->new();
my $testbed;
my $logfile;
my $rg;
my $cb;

&forms();
&output();

# $Id: $
## @summary Perl module for ConfigBroker GUI
## @status Public
## @author Sreekumar Methil (sreekuma@netapp.com, dl-nst-tools@netapp.com)
## @pod here

=head1 NAME

main.cgi

=head1 DESCRIPTION

This is the main page which has all the ConfigBroker Resource Group functions such as Create Resource Group , Edit resource group etc
.It displays the form for all functions and passes the parameters to subpage.cgi . The page also has a left pane which lists all the
resource groups existing in the database and on clicking redirects the user to resource page.

=cut



## Prints the main form with the resource groups in a left pane and the configbroker functions on the main frame

sub forms

{
	$logfile=$cgi->param('logfile');
	$testbed=$cgi->param('testbed');
	
	print $cgi->header();
	print "<head><title>ConfigBroker-Main-Page</title></head>";
	print "<img src='http://brand.netapp.com/images/logos/color-vert/na_logo_vrt_2c_rgb.png' align='right' width='158' height='150'/>";

## HTML <div> which is used to print the left pane of the main page which has the list of all resource groups .

	print "<div id='menu' style='background-color:silver;float:left; overflow-y:scroll; width: 20%; height: 100%;'>";
	print "<h1><b>ResourceGroups</b><br></h1>";
	redirect_log();
	my @rgs= CBTemplate::get_resourcegroup_names(testbed => "$testbed");
	stop_redirect_log();

## Gets the resource group names and prints it in left pane as a submit button . Here each resource group acts like a form
## which on clicking would expand to the corresponding resource types and further the resource names

 		for my $it (@rgs) 
 			{
 				my %rghash = %$it;
 				print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/leftpane.cgi'>";
 				print "<input type='hidden' name='testbed' value='$testbed' />";
				print "<input type='hidden' name='logfile' value='$logfile' />";
 				print "<input type='submit' style='padding:0; margin:0,border:0;background-color:transparent;' name=rg value=$rghash{'name'} /><br>";	
 				print "</form>";
 			}

print "</div>";

## Prints the title of the page with the resource functions which needs to be accessed.
	print "<div style='float:center;width: 80%; height: 10%;'>";
	print "<center><h1>ConfigBroker Main Page</h1></center></div>";
	print "<div style='float:left;width: 80%; height: 20%;'>";

	print "<form>";
	print "<h1>Resource Group Functions</h1>";
	print "<input type='hidden' name='testbed' value='$testbed' />";
	print "<input type='hidden' name='logfile' value='$logfile' />";
	print "<b><input type='radio' name=fname value='create_resource_group'/>CREATE RESOURCE GROUP</b>";
	print "<b><input type='radio' name=fname value='discover_create_resource_group' />DISCOVER AND CREATE RESOURCE GROUP</b>";
	print "<b><input type='radio' name=fname value='edit_resource_group' />EDIT RESOURCE GROUPS</b>";	
	print "<b><input type='radio' name=fname value='delete_resource_group' />DELETE RESOURCE GROUPS</b><br>";
	print "<b><input type='radio' name=fname value='create_new_resource_type' />CREATE NEW RESOURCE TYPE</b>";
	print "<b><input type='radio' name=fname value='delete_resource_type' />DELETE RESOURCE TYPE<br></b>";
	print "<input type='submit' name=go value='Submit' />";
	print "</form>";
	print "</div>";

print $cgi->end_html();
}

## This function is used to print the forms when the user submits a resource group function form.

sub output
	{

		if ($cgi->param('fname')) 
			{
				print "<html>";

				my $func=$cgi->param('fname');
				$testbed=$cgi->param('testbed');
				$logfile=$cgi->param('logfile');

## If the user selects create resource group function from the main page.This is a HTML form which takes in all the input parameters
## required for the function. Only user can enter name of the resource group to be created and other parameters are disabled.

		if ($func eq 'create_resource_group')
			{
 				print "<div style='float:left;width: 80%; height: 70%; overflow-y:scroll; overflow-x:scroll;'>";
 				print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
 				print "<br><h1> Create Resource Group Page</h1><br>";
 				print "<input type='hidden' name='testbed' value='$testbed' />";
 				print "<input type='hidden' name='logfile' value='$logfile' />";
 				print "<b>Name </b>: <input type='text' name='name' /><br>";
 				print "<b>ConfigFile</b> : <input type='text' name='configfile' disabled='disabled' /><br>";
				print "<b>ConfigEngine</b> : <input type='radio' name='configengine' value='CCL' disabled='disabled'/>CCL";
 				print "<input type='radio' name='configengine' value='EnGenX' checked disabled='disabled' />EnGenX<br>";
 				print "<b>ConfigReuse</b> : <input type='radio' name='reuse' value='REUSE' checked />REUSE";
 				print "<input type='radio' name='reuse' value='NOREUSE'  />NOREUSE";
		 		print "<input type='radio' name='reuse' value='CREATENEW' />CREATENEW<br>";
 				print "<b>CMDLineString</b> : <input type='text' name='cmdlinestring' disabled='disabled' /><br>";
 				print "<b>Status of the resource</b> : <input type='radio' name='status' value='INUSE' />INUSE";
 				print "<input type='radio' name='status' value='PENDING' checked />PENDING";
 				print "<input type='radio' name='status' value='ACTIVE' />ACTIVE<br>";
 				print "<b>CleanupFile </b>: <input type='text' name='cleanupfile' disabled='disabled' /><br>";
 				print "<b>Resource Share</b> : <input type='radio' name='share' value='SHARE' checked/>SHARE";
 				print "<input type='radio' name='share' value='EXCLUSIVE'  />EXCLUSIVE<br>";
 				print "<input type='submit' name=func value='create_resource_group' />";
 				print "</form></div>";
			}

## If the user selects discover and create function.It is HTML form

		if ($func eq 'discover_create_resource_group')
			{
				redirect_log();
				my @types=CBTemplate::get_resourcetypes_discover(testbed=>"$testbed");
				stop_redirect_log();
				print "<div style='float:left;width: 80%; height: 70%; overflow-y:scroll; overflow-x:scroll;'>";
				print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
				print "<h1> Discover and Create Resource Group</h1><br>";
				print "<input type='hidden' name='testbed' value='$testbed' />";
				print "<input type='hidden' name='logfile' value='$logfile' />";
				print "<b>Name</b> : <input type='text' name='groupname' /><br>";
				print "<b>Node Name to search </b>: <input type='text' name='node' /><br>";
				print "<b>Type of resource to be discovered </b>: ";

##Used to get all the resource types which needs to be discovered
		for my $type (@types){

				print "<input type='checkbox' name='distype' value=$type  />$type";
			}
	
				print "<input type='checkbox' name='distype' value='all'  />All";
				print "<br><b>ConfigReuse </b>: <input type='radio' name='reuse' value='REUSE' checked />REUSE";
				print "<input type='radio' name='reuse' value='NOREUSE'  />NOREUSE";
				print "<input type='radio' name='reuse' value='CREATENEW' />CREATENEW<br>";
				print "<b>Resource Share</b> : <input type='radio' name='share' value='SHARE' checked/>SHARE";
				print "<input type='radio' name='share' value='EXCLUSIVE'  />EXCLUSIVE<br>";
				print "<input type='submit' name=func value='discovercreate' />";
				print "</form></div>";
			}
	
## Used to edit the paramenters of the resource group . The share and reuse fields have been disabled for now . Need to add corresponding
## function to configbrker .

		if ($func eq 'edit_resource_group')
			{
				print "<div style='float:left;width: 80%; height: 60%; overflow-y:scroll; overflow-x:scroll;'>";

				redirect_log();
				my @rgs= CBTemplate::get_resourcegroup_names(testbed => "$testbed");
				stop_redirect_log();

				my @headers = ("Groupname");
				print "<h1> Edit Resource Group Forms-Update/Reserve/Unreserve Resource Groups</h1><br>";
  				print "<table border=10>\n";
  				print "<tr>";
   			
   				foreach my $header (@headers) 
   				{
        			print "<td>$header</td>";
    			}
  		
  				print "</tr>";
 				 
 			 for my $it (@rgs) 
 			 	{
  	
        
        			my %rghash = %$it;
       
        		print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
        		print "<input type='hidden' name='testbed' value='$testbed' />";
       			print "<input type='hidden' name='logfile' value='$logfile' />";
       			print "<td><input type='hidden' name='resourcegroup' value=$rghash{'name'} />";
     			print "<tr>";
     			print "<td><input type='text' name='resourcegroup' value=$rghash{'name'} disabled='disbaled' /></td>";
			
			## Print drop down box for resource status			
				my $status_index=0;
				my $status_remove_index;
				my @statusarray=('READY','INUSE','PENDING');
		
				for my $status(@statusarray)
					{
						if($status eq $rghash{'status'}) 
							{
								$status_remove_index =$status_index;
							}
						$status_index=$status_index+1;
					}  
		
				splice @statusarray,$status_remove_index,1;
		
			## Print drop down box for resource reuse
				my $reuse_index=0;
				my $reuse_remove_index;
				my @reusearray=('REUSE','NOREUSE','CREATENEW');
		
				for my $reuse(@reusearray)
					{
						if($reuse eq $rghash{'reuse'}) 
							{
								$reuse_remove_index =$reuse_index;
							}
			
				$reuse_index=$reuse_index+1;
					}  
		
				splice @reusearray,$reuse_remove_index,1;		
		
			##Print drop down box for resource share
		
				my $share_index=0;
				my $share_remove_index;
				my @sharearray=('SHARE','EXCLUSIVE');
		
				for my $share(@sharearray)
					{
						if($share eq $rghash{'share'}) 
							{
								$share_remove_index =$share_index;
							}
				$share_index=$share_index+1;
					}  
		
				splice @sharearray,$share_remove_index,1;	
        
        		print "<td><b>Status</b><select name='status'>"; 
        		print "<option value=$rghash{'status'}>$rghash{'status'}</option>";
        		print "<option value='$statusarray[0]'>$statusarray[0]</option> ";
     			print "<option value='$statusarray[1]'>$statusarray[1]</option></select></td> ";
        		print "<td><b>Reuse</b><select name='reuse'>"; 
        		print "<option value=$rghash{'reuse'}>$rghash{'reuse'}</option> ";
        		print "<option value='$reusearray[0]'>$reusearray[0]</option>";
        		print "<option value='$reusearray[1]'>$reusearray[1]</option></select></td>";
        		print "<td><b>Share</b><select name='share' >"; 
        		print "<option value=$rghash{'share'}>$rghash{'share'}</option> ";
        		print "<option value='$sharearray[0]'>$sharearray[0]</option></select></td>";
        		print "<td><b>Reserve Code</b>: <input type='text' name='reservecode' /></td>";
				print "<td><input type='submit' name=func value='update_resourcegroup' /></td>"; 
				print "<td><input type='submit' name=func value='reserve_resourcegroup' /></td>"; 
				print "<td><input type='submit' name=func value='unreserve_resourcegroup' /></td>";
				print "</tr>"	;
				print "</form></div>";
    }
 
}

## Used to delete a resource group . The clean up file name has been disabled . It is a HTML form

			if ($func eq 'delete_resource_group')
				{
				print "<div style='float:left;width: 80%; height: 70%; overflow-y:scroll; overflow-x:scroll;'>";
				redirect_log();
				my @rgs= CBTemplate::get_resourcegroup_names(testbed => "$testbed");
				stop_redirect_log();

				my @headers = ("Groupname");
				print "<h1>Delete Resource Groups</h1><br>";
  				print "<table border=10>\n";
  				print "<tr>\n";
   
   				foreach my $header (@headers) 
   					{
        				print "<td>".$header."</td>";
    				}
		
				for my $it (@rgs) 
					{
        				print "<tr>"; 
        				my %rghash = %$it;
        		
        		print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
        		print "<input type='hidden' name='testbed' value='$testbed' />";
        		print "<input type='hidden' name='logfile' value='$logfile' />";
        		print "<td><input type='checkbox' name='resourcegroup' value=$rghash{'name'} />$rghash{'name'}</td>";
				print "</tr>";
					}
				print "</table>";
        		#print "<td><b>CleanupFile Name</b>: <input type='text' name='cleanupfile' disabled='disabled' /></td>";
        		print "<input type='submit' name=func value='delete_resource_group' />";
        		
        		print "</form></div>";
			
		}
		
## If the user wants to create a custom resource type it prints the HTML form.

		if ($func eq 'create_new_resource_type')
			{
				print "<div style='float:left;width: 80%; height: 70%; overflow-y:scroll; overflow-x:scroll;'>";
				print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
				print "<h1> Create New Resource Type</h1><br>";
				print "<input type='hidden' name='testbed' value='$testbed' />";
				print "<input type='hidden' name='logfile' value='$logfile' />";
				print "<b>Name of the resource type</b> : <input type='text' name='resourcetype' /><br>";
				print "<b>Columns of the table (Enter fields seperated by commas</b> <input type='text' name='tabledefn' /><br>";
				print "<b>Primary keys for the Table (Enter each field seperated by commas)</b>: <input type='text' name='primarykey' /><br>";
				print "<input type='submit' name=func value='create_resource_type' />";
				print "</form></div>";
			}
		
## If the user wants to delete a custom resource type it prints It is a HTML form 
		
	if ($func eq 'delete_resource_type')
			{
				print "<div style='float:left;width: 80%; height: 70%; overflow-y:scroll; overflow-x:scroll;'>";
				print "<form action='http://csiqa-web.rtp.netapp.com/cgi-bin/ConfigBroker/subpage.cgi'>";
				print "<h1>Delete Resource Type</h1><br>";
				print "<input type='hidden' name='testbed' value='$testbed' />";
				print "<input type='hidden' name='logfile' value='$logfile' />";
				redirect_log();
				my @resource_types=CBTemplate::get_custom_resourcetypes(testbed=>"$testbed");
				stop_redirect_log();
			
				print "<center><br><br><b>Select the resource type to delete </b>:<br>";
				print "<table border=10>\n";
  				print "<tr>\n";	
				for my $type(@resource_types)
					{
						print "<tr>";
						print "<td><input type=checkbox name='resourcetype' value='$type' />$type</td>";
						print "</tr>";
					}
			
				print "</table>";
				print "<input type='submit' name=func value='delete_resource_type' />";
				print "</form></center></div>";
			}

print $cgi->end_html();
}
}


##Function to redirect log output to the logfile created
sub redirect_log
{
	open (OLDOUT, ">&STDOUT") or die $!;
	open OUTPUT, '>>', $logfile or die $!;
	STDERR->fdopen(\*OUTPUT, 'w') or die $!;
	STDOUT->fdopen(\*OUTPUT, 'w') or die $!;	
}

##Routine to stop redirecting and print html on screen 
 sub stop_redirect_log
 {
 	STDOUT->fdopen(\*OLDOUT, 'w') or die $!;	
 	
 }
