package CreateOptionsENV;

use Data::Dumper;
use strict;
use Params::Validate qw(validate :types);


# use lib "/u/saggar/NATE/PROJECTS/Options/Libs/";
# use String::Tokenizer;


#Write class method here i.e. constructor
sub new(){
	my $class = shift;
	my %args = (
				ENVSTATE => {
							Vserver => {
										NodeVs => [],
										AdminVs => [],
										ClusterVs => [],
							},
							Options => {
										admin => {
												  NodeVs => [],
												  AdminVs => [],
											      ClusterVs => [],
												 },
							},
				},		   
			   );
	return bless(\%args,$class);
}

#Write object methods here 
sub addVserverStateToOptionsENV{
	my $self = shift;
	my $Server_Object = shift;
	
	# ADDED to let it refresh state after each call
	$self->{ENVSTATE}->{Vserver} = {
									NodeVs => [],
									AdminVs => [],
									ClusterVs => [],
							     };
	
	my $refToVserver = $self->{ENVSTATE}->{Vserver};
	# printf Dumper($refToVserver);
	# printf Dumper($Server_Object);
	
	# Step1: For NodeVs
	# saggar-vsim1::> vserver show -type node -fields vserver 
		eval{
			my @results = $Server_Object->vserver_show(
												"type" => "node",
												"fields" => "vserver",
										  );
			my @NodeVsArr = undef;
			
			printf("##################################\n");							  
				foreach(@results){
					# printf Dumper($_);							  
					# printf("NodeVs::[".$_->{vserver}."]\n");
					push(@NodeVsArr, $_->{vserver});
					
				}
				$refToVserver->{NodeVs} = \@NodeVsArr;
				# printf Dumper($refToVserver->{NodeVs});
			printf("\n##################################\n");	
		};
		if($@){
			printf("Error:$@\n");
		}	

	# Step2: For AdminVs
	# saggar-vsim1::> vserver show -type admin -fields vserver 
		eval{
			my @results = $Server_Object->vserver_show(
												"type" => "admin",
												"fields" => "vserver",
										  );
			my @AdminVsArr = undef;
			
			printf("##################################\n");							  
				foreach(@results){
					# printf Dumper($_);							  
					# printf("AdminVs::[".$_->{vserver}."]\n");
					push(@AdminVsArr, $_->{vserver});
					
				}
				$refToVserver->{AdminVs} = \@AdminVsArr;
				# printf Dumper($refToVserver->{AdminVs});
			printf("\n##################################\n");	
		};
		if($@){
			printf("Error:$@\n");
		}
	
	# Step3: For ClusterVs
	
	################################ NOTE:: ###################################
	# Have scope to change Vserver creation to Vserver Setup so that it can be 
	# scalable in future.
	################################ NOTE:: ###################################
	
	   #&CreateOptionsENV::Vserver_Setup($Server_Object);
    
    ################################ NOTE:: ###################################
	# Have scope to change Vserver creation to Vserver Setup so that it can be 
	# scalable in future.
	################################ NOTE:: ###################################
		
		eval{
			my @results = $Server_Object->vserver_show(
												"type" => "cluster",
												"fields" => "vserver",
										  );
			my @ClusterVsArr = undef;
			
			printf("##################################\n");							  
				foreach(@results){
					# printf Dumper($_);							  
					# printf("ClusterVs::[".$_->{vserver}."]\n");
					push(@ClusterVsArr, $_->{vserver});
					
				}
				$refToVserver->{ClusterVs} = \@ClusterVsArr;
				# printf Dumper($refToVserver->{ClusterVs});
			printf("\n##################################\n");	
		};
		if($@){
			printf("Error:$@\n");
		}
	
	
}# Function addVserverStateToOptionsENV() ends here

sub Vserver_Setup(){
    my ($Server_Object) = @_;
	# saggar-vsim1::> vserver show -type cluster -fields vserver 
	# Add Creation Step
	# ::> storage aggregate create -aggregate see -diskcount 3 -raidtype raid_dp
	# ::> vserver create -vserver ac -rootvolume de -aggregate aggrex 
		  # -ns-switch file -nm-switch file -rootvolume-security-style mixed 
		my $timeAggr = time();
		eval{
			
			my @results = $Server_Object->storage_aggregate_create(
												"aggregate" => "aggr_".$timeAggr,
												"diskcount" => 3,
												"raidtype" => "raid_dp",
										  );
		};
		if($@){
			printf("Error Aggregate Creation[aggr_$timeAggr]:$@\n");
		}
	
		my $timeVserver = time();
		eval{
			
			my @results = $Server_Object->vserver_create(
												"vserver" => "clusterVs_".$timeVserver,
												"rootvolume" => "root_clusterVs_$timeVserver",
												"aggregate" => "aggr_$timeAggr",
												"ns-switch" => "file",
												"nm-switch" => "file",
												"rootvolume-security-style" => "mixed",
										  );
		};
		if($@){
			printf("Error Vserver Creation[clusterVs_$timeVserver]:$@\n");
		}
}

sub addOptionsStateToOptionsENV{
	my $self = shift;
	my $Server_Object = shift;
	
	my $refToOptions = $self->{ENVSTATE}->{Options};
	# printf Dumper($refToOptions);
	# printf Dumper($Server_Object);
	
		eval{
			# ::> set -confirmations off
			my @results = $Server_Object->set(
												"confirmations" => "off",
										  );
			# ::> set -privilege admin 		
			@results = $Server_Object->set(
												"privilege" => "admin",
										  );					  
		};
		if($@){
			printf("Error [set -confirmations off]:$@\n");
			printf("Error [set -privilege admin]:$@\n");
		}
	# Step1: For NodeVs
	# ::> options -vserver NodeVs
		
		eval{
			my $NodeVs = $self->{ENVSTATE}->{Vserver}->{NodeVs}[1];
			
			my $resultRow = $Server_Object->vserver_options(
											"vserver" => "$NodeVs",
											"fields" => "option-name",
										);
			my @OptionsKeyArr_AdminLevel = undef;
			my @temp = split(/${NodeVs}X;X/, $resultRow);
			# Remove first 
			# [vserverX;Xoption-nameX;Xoption-valueX;Xvserver nameX;Xoption nameX;Xoption valueX;X]
				shift(@temp);
			printf("##################################\n");							  
				# printf($resultRow);
			printf("##################################\n");							  
				printf("	Selected NodeVs is::[$NodeVs]\n");
				foreach(@temp){
					$_ =~ s/\s+//;
					if($_ =~ m/(.*?)X;X/){#autosupport.mailhostX;XmailhostX;X
						$_ = $1;
					}
					
					# printf("[".$_."]\n"); 
					push(@OptionsKeyArr_AdminLevel, $_);
					
				}
				$refToOptions->{admin}->{NodeVs} = \@OptionsKeyArr_AdminLevel;
			printf("\n##################################\n");	

		};
		if($@){
			printf("Error:$@\n");
		}

	# Step2: For AdminVs
	# ::> options -vserver AdminVs
		
		eval{
			my $AdminVs = $self->{ENVSTATE}->{Vserver}->{AdminVs}[1];
			
			my $resultRow = $Server_Object->vserver_options(
											"vserver" => "$AdminVs",
											"fields" => "option-name",
										);
			my @OptionsKeyArr_AdminLevel = undef;
			my @temp = split(/${AdminVs}X;X/, $resultRow);
			# Remove first 
			# [vserverX;Xoption-nameX;Xoption-valueX;Xvserver nameX;Xoption nameX;Xoption valueX;X]
				shift(@temp);
			printf("##################################\n");							  
				# printf($resultRow);
			printf("##################################\n");							  
				printf("	Selected AdminVs is::[$AdminVs]\n");
				foreach(@temp){
					$_ =~ s/\s+//;
					if($_ =~ m/(.*?)X;X/){#autosupport.mailhostX;XmailhostX;X
						$_ = $1;
					}
					
					# printf("[".$_."]\n"); 
					push(@OptionsKeyArr_AdminLevel, $_);
					
				}
				$refToOptions->{admin}->{AdminVs} = \@OptionsKeyArr_AdminLevel;
			printf("\n##################################\n");	

		};
		if($@){
			printf("Error:$@\n");
		}
	
	# Step3: For ClusterVs
	# ::> options -vserver ClusterVs
		
		eval{
			my $ClusterVs = $self->{ENVSTATE}->{Vserver}->{ClusterVs}[1];
			
			my $resultRow = $Server_Object->vserver_options(
											"vserver" => "$ClusterVs",
											"fields" => "option-name",
										);
			my @OptionsKeyArr_AdminLevel = undef;
			my @temp = split(/${ClusterVs}X;X/, $resultRow);
			# Remove first 
			# [vserverX;Xoption-nameX;Xoption-valueX;Xvserver nameX;Xoption nameX;Xoption valueX;X]
				shift(@temp);
			printf("##################################\n");							  
				# printf($resultRow);
			printf("##################################\n");							  
				printf("	Selected ClusterVs is::[$ClusterVs]\n");
				foreach(@temp){
					$_ =~ s/\s+//;
					if($_ =~ m/(.*?)X;X/){#autosupport.mailhostX;XmailhostX;X
						$_ = $1;
					}
					
					# printf("[".$_."]\n"); 
					push(@OptionsKeyArr_AdminLevel, $_);
					
				}
				$refToOptions->{admin}->{ClusterVs} = \@OptionsKeyArr_AdminLevel;
			printf("\n##################################\n");	

		};
		if($@){
			printf("Error:$@\n");
		}
	
	# Step: Set Privilege Level back to Diag 
		eval{
		    # ::> set -confirmations off
			my @results = $Server_Object->set(
												"confirmations" => "off",
										  );
			# ::> set -privilege diagnostic 		
			 @results = $Server_Object->set(
												"privilege" => "diagnostic",
										  );					  
		};
		if($@){
			printf("Error [set -confirmations off]:$@\n");
			printf("Error BACK [set -privilege diagnostic]:$@\n");
	
		}	
		
}# Function addOptionsStateToOptionsENV() ends here

sub getAnyVserver_Node(){
	my $self = shift;
	return $self->{ENVSTATE}->{Vserver}->{NodeVs}[1];
}# Function getAnyVserver_Node() ends here

sub getAnyVserver_Admin(){
	my $self = shift;
	return $self->{ENVSTATE}->{Vserver}->{AdminVs}[1];
}# Function getAnyVserver_Admin() ends here

sub getAnyVserver_Cluster(){
	my $self = shift;
	return $self->{ENVSTATE}->{Vserver}->{ClusterVs}[1];
}# Function getAnyVserver_Cluster() ends here

sub genValidHostname(){
    my ($self, $hostname) = @_;
    my $validHostname;
    my $time = time();
    if($hostname =~ m/^(.*?)___/igs){
        $validHostname = $1.$time;
    }else{
        $validHostname = $hostname."___".$time;
    }
    return $validHostname;
}

sub genInValidHostname(){
    my ($self, $hostname) = @_;
    my $time = time();
    my $invalidHostname = $time."___".$hostname;
   
    return $invalidHostname;
}

sub addSystemConfigBackupToOptionsENV{
	my $self = shift;
	my $Server_Object = shift;
	
	# ADDED to let it refresh state after each call
	$self->{ENVSTATE}->{Backup} = undef;
	
	my $refToBackup = $self->{ENVSTATE}->{Backup};
	# printf Dumper($refToBackup);
	# printf Dumper($Server_Object);
	
	# Step1: For NodeVs
	# csiqa-3070-22::system configuration backup*> show -node csiqa-3070-21
		eval{
			my @results = $Server_Object->system_configuration_backup_show("-Verification" => "0",);
			printf Dumper(\@results);
			# my @NodeVsArr = undef;
			$self->{ENVSTATE}->{Backup} = \@results;
			
			# printf("##################################\n");							  
				# foreach(@results){
					# # printf Dumper($_);							  
					# # printf("NodeVs::[".$_->{'node'}."] BackupName::[".$_->{'backup'}."] Type::[".$_->{'backup-type'}."]\n");
					# # push(@NodeVsArr, $_->{node});
					# my $node = $_->{'node'};
					# my $backup = $_->{'backup'};
					# my $type = $_->{'backup-type'};
					# push($refToBackup->{$node}->{$type}, $backup);
				# }
				# # $refToVserver->{NodeVs} = \@NodeVsArr;
				# # printf Dumper($refToVserver->{NodeVs});
			# printf("\n##################################\n");	
		};
		if($@){
			printf("Error:$@\n");
		}	
	
}# Function addSystemConfigBackupToOptionsENV() ends here


1;
