# $Id:
#
# Copyright (c) 2010 NetApp.
# All rights reserved.
#
################################################################################
## @summary Library of functions to access DFM Soap APIs to perform
##          the OM(operation manager) operations.
##
## @author Chetna Samant (chetna@netapp.com)
##
## @status public
##
## @pod here
################################################################################

#
# Package Name
#
package OpsMgrSoapMisc;

#
# Imported modules
#
#use lib '/usr/software/test/share/nate/latest/lib';
#use strict;

use NATE::Log;
use Tharn;
use Data::Dumper;
use strict;


BEGIN {
    use vars qw(@ISA @EXPORT $Test);
    require Exporter;
    @ISA = qw(Exporter);
    @EXPORT = qw(process_json_query_result);    
}


#use vars qw(process_json_query_result);

#
#  Global variables declaration
#

##############################################################################
# Function:  process_json_query_result
# Objective: Function which is to be invoked to process the result ONLY in
#            json format returned by the NACL APISet call to 
#            report-query-get-data ZAPi. It takes the NACL APISet response 
#            object as input and returns a refernce to an array of hash .
#            Example:
#            my $queryResult = process_json_query_result($response);
#            $Test -> nlog (Dumper $queryResult->[0]->{"alarm-disabled"});
#            will give the value of "alarm-disabled" for the first alarm listed.
#
# Inputs:    (Named parameters)
#            1. Reponse object
##############################################################################

sub process_json_query_result {
    my $responseObj = shift;
    my $debug = 0;
    if (@_ > 0){
        $debug = shift;
    }
    $Log->comment("responseObj is ".Dumper($responseObj)) if ($debug);
    my $modStr =
              Dumper $responseObj->get_parsed_output()->[0]->{'query-result'};
    #string manipulation on json format          
    $modStr =~ s/: /=>/g;
    $modStr =~ s/^\$VAR1 = \'/\$VAR1 = /;
    $modStr =~ s/\'\;$/\;/;
    $modStr =~ s/\@/\\@/g;
            
    #$Log->comment($modStr);
    
    #Convert the json-formatted string into the required data structure
    my $VAR1;
    eval $modStr;
    $Log->comment("return value is ".Dumper($VAR1->{rows})) if ($debug);
    #$Log->comment(Dumper $VAR1->{rows}->[0]);
    
    return $VAR1->{rows};
    
}


1;
