
package MyElements::AggregateListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('AggregateListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateType_of :ATTR(:get<AggregateType>);
my %BlockType_of :ATTR(:get<BlockType>);
my %IncludeDatasetSpaceInfo_of :ATTR(:get<IncludeDatasetSpaceInfo>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IsDirectMemberOnly_of :ATTR(:get<IsDirectMemberOnly>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsUnprotected_of :ATTR(:get<IsUnprotected>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %RbacOperation_of :ATTR(:get<RbacOperation>);
my %ResourcepoolFilter_of :ATTR(:get<ResourcepoolFilter>);
my %VolumesToMigrate_of :ATTR(:get<VolumesToMigrate>);

__PACKAGE__->_factory(
    [ qw(        AggregateType
        BlockType
        IncludeDatasetSpaceInfo
        IncludeIsAvailable
        IsDirectMemberOnly
        IsDpIgnored
        IsInDataset
        IsUnprotected
        ObjectManagementFilter
        ObjectNameOrId
        RbacOperation
        ResourcepoolFilter
        VolumesToMigrate

    ) ],
    {
        'AggregateType' => \%AggregateType_of,
        'BlockType' => \%BlockType_of,
        'IncludeDatasetSpaceInfo' => \%IncludeDatasetSpaceInfo_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IsDirectMemberOnly' => \%IsDirectMemberOnly_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsUnprotected' => \%IsUnprotected_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'RbacOperation' => \%RbacOperation_of,
        'ResourcepoolFilter' => \%ResourcepoolFilter_of,
        'VolumesToMigrate' => \%VolumesToMigrate_of,
    },
    {
        'AggregateType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BlockType' => 'MyTypes::FileSystemBlockType',
        'IncludeDatasetSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolFilter' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumesToMigrate' => 'MyTypes::ArrayOfObjectNameOrId',
    },
    {

        'AggregateType' => 'AggregateType',
        'BlockType' => 'BlockType',
        'IncludeDatasetSpaceInfo' => 'IncludeDatasetSpaceInfo',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IsDirectMemberOnly' => 'IsDirectMemberOnly',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsUnprotected' => 'IsUnprotected',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'RbacOperation' => 'RbacOperation',
        'ResourcepoolFilter' => 'ResourcepoolFilter',
        'VolumesToMigrate' => 'VolumesToMigrate',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::AggregateListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
AggregateListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateType

 $element->set_AggregateType($data);
 $element->get_AggregateType();




=item * BlockType

 $element->set_BlockType($data);
 $element->get_BlockType();




=item * IncludeDatasetSpaceInfo

 $element->set_IncludeDatasetSpaceInfo($data);
 $element->get_IncludeDatasetSpaceInfo();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IsDirectMemberOnly

 $element->set_IsDirectMemberOnly($data);
 $element->get_IsDirectMemberOnly();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsInDataset

 $element->set_IsInDataset($data);
 $element->get_IsInDataset();




=item * IsUnprotected

 $element->set_IsUnprotected($data);
 $element->get_IsUnprotected();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * RbacOperation

 $element->set_RbacOperation($data);
 $element->get_RbacOperation();




=item * ResourcepoolFilter

 $element->set_ResourcepoolFilter($data);
 $element->get_ResourcepoolFilter();




=item * VolumesToMigrate

 $element->set_VolumesToMigrate($data);
 $element->get_VolumesToMigrate();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::AggregateListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   AggregateType =>  $some_value, # string
   BlockType => $some_value, # FileSystemBlockType
   IncludeDatasetSpaceInfo =>  $some_value, # boolean
   IncludeIsAvailable =>  $some_value, # boolean
   IsDirectMemberOnly =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsUnprotected =>  $some_value, # boolean
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   ObjectNameOrId =>  $some_value, # string
   RbacOperation =>  $some_value, # string
   ResourcepoolFilter =>  $some_value, # string
   VolumesToMigrate =>  { # MyTypes::ArrayOfObjectNameOrId
     ObjectNameOrId => $some_value, # ObjectNameOrId
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

