
package MyElements::AggregateSpaceManagementAddOperation;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('AggregateSpaceManagementAddOperation');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SpaceManagementOperationInfo_of :ATTR(:get<SpaceManagementOperationInfo>);
my %SpaceManagementSessionId_of :ATTR(:get<SpaceManagementSessionId>);

__PACKAGE__->_factory(
    [ qw(        SpaceManagementOperationInfo
        SpaceManagementSessionId

    ) ],
    {
        'SpaceManagementOperationInfo' => \%SpaceManagementOperationInfo_of,
        'SpaceManagementSessionId' => \%SpaceManagementSessionId_of,
    },
    {
        'SpaceManagementOperationInfo' => 'MyTypes::SpaceManagementOperationInfo',

        'SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementAddOperation::_SpaceManagementSessionId',
    },
    {

        'SpaceManagementOperationInfo' => 'SpaceManagementOperationInfo',
        'SpaceManagementSessionId' => 'SpaceManagementSessionId',
    }
);

} # end BLOCK




package MyElements::AggregateSpaceManagementAddOperation::_SpaceManagementSessionId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::AggregateSpaceManagementAddOperation

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
AggregateSpaceManagementAddOperation from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SpaceManagementOperationInfo

 $element->set_SpaceManagementOperationInfo($data);
 $element->get_SpaceManagementOperationInfo();




=item * SpaceManagementSessionId

 $element->set_SpaceManagementSessionId($data);
 $element->get_SpaceManagementSessionId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::AggregateSpaceManagementAddOperation->new($data);

Constructor. The following data structure may be passed to new():

 {
   SpaceManagementOperationInfo =>  { # MyTypes::SpaceManagementOperationInfo
     BackupDeletionRequestInfo =>  { # MyTypes::BackupDeletionRequestInfo
       BackupIds =>  { # MyTypes::ArrayOfBackupId
         BackupId => $some_value, # BackupId
       },
     },
     DedupeRequestInfo =>  { # MyTypes::DedupeRequestInfo
       FullVolumeDedupe =>  $some_value, # boolean
     },
     ObjectNameOrId => $some_value, # ObjNameOrId
     ResizeVolumeRequestInfo =>  { # MyTypes::ResizeVolumeRequestInfo
       MaximumCapacity => $some_value, # atomic
       NewSize => $some_value, # atomic
       SnapReserve => $some_value, # atomic
     },
     SnapshotDeletionRequestInfo =>  { # MyTypes::SnapshotDeletionRequestInfo
       Snapshots =>  { # MyTypes::ArrayOfSnapshot
         Snapshot =>  { # MyTypes::Snapshot
           SnapshotName =>  $some_value, # string
           UniqueId =>  $some_value, # string
         },
       },
     },
     SpaceManagementOpType => $some_value, # SpaceManagementOpType
     VolumeMigrationRequestInfo =>  { # MyTypes::VolumeMigrationRequestInfo
       CleanupStaleStorage => $some_value, # CleanupStaleStorage
       DestinationAggregateNameOrId => $some_value, # ObjNameOrId
       RetentionType => $some_value, # DpBackupRetentionType
       RunDedupeScan =>  $some_value, # boolean
       RunOnDemandUpdate =>  $some_value, # boolean
     },
   },
   SpaceManagementSessionId => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

