
package MyElements::AggregateSpaceManagementCommitResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('AggregateSpaceManagementCommitResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateSpaceInfos_of :ATTR(:get<AggregateSpaceInfos>);
my %SpaceManagementResults_of :ATTR(:get<SpaceManagementResults>);

__PACKAGE__->_factory(
    [ qw(        AggregateSpaceInfos
        SpaceManagementResults

    ) ],
    {
        'AggregateSpaceInfos' => \%AggregateSpaceInfos_of,
        'SpaceManagementResults' => \%SpaceManagementResults_of,
    },
    {
        'AggregateSpaceInfos' => 'MyTypes::ArrayOfAggregateSpaceInfo',
        'SpaceManagementResults' => 'MyTypes::ArrayOfSpaceManagementResultInfo',
    },
    {

        'AggregateSpaceInfos' => 'AggregateSpaceInfos',
        'SpaceManagementResults' => 'SpaceManagementResults',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::AggregateSpaceManagementCommitResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
AggregateSpaceManagementCommitResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateSpaceInfos

 $element->set_AggregateSpaceInfos($data);
 $element->get_AggregateSpaceInfos();




=item * SpaceManagementResults

 $element->set_SpaceManagementResults($data);
 $element->get_SpaceManagementResults();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::AggregateSpaceManagementCommitResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   AggregateSpaceInfos =>  { # MyTypes::ArrayOfAggregateSpaceInfo
     AggregateSpaceInfo =>  { # MyTypes::AggregateSpaceInfo
       AggregateId => $some_value, # ObjId
       AggregateName => $some_value, # ObjName
       CommittedSpace => $some_value, # atomic
       UsedSpace => $some_value, # atomic
     },
   },
   SpaceManagementResults =>  { # MyTypes::ArrayOfSpaceManagementResultInfo
     SpaceManagementResultInfo =>  { # MyTypes::SpaceManagementResultInfo
       DryRunResults =>  { # MyTypes::ArrayOfDryRunResult
         DryRunResult =>  { # MyTypes::DryRunResult
           DryRunAction =>  $some_value, # string
           DryRunEffect =>  $some_value, # string
           DryRunReason =>  $some_value, # string
           DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
             ResultDetail =>  { # MyTypes::ResultDetail
               Action =>  $some_value, # string
               Effect =>  $some_value, # string
               Reason =>  $some_value, # string
               Severity => $some_value, # ObjStatus
               Suggestion =>  $some_value, # string
             },
           },
           DryRunSeverity => $some_value, # ObjStatus
           DryRunSuggestion =>  $some_value, # string
         },
       },
       JobId =>  $some_value, # integer
       ObjectId => $some_value, # ObjId
       ObjectName => $some_value, # ObjFullName
       SpaceManagementOpType => $some_value, # SpaceManagementOpType
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

