
package MyElements::ApiProxy;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ApiProxy');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Request_of :ATTR(:get<Request>);
my %Target_of :ATTR(:get<Target>);
my %Timeout_of :ATTR(:get<Timeout>);
my %Username_of :ATTR(:get<Username>);

__PACKAGE__->_factory(
    [ qw(        Request
        Target
        Timeout
        Username

    ) ],
    {
        'Request' => \%Request_of,
        'Target' => \%Target_of,
        'Timeout' => \%Timeout_of,
        'Username' => \%Username_of,
    },
    {
        'Request' => 'MyTypes::Request',
        'Target' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Timeout' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'Username' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Request' => 'Request',
        'Target' => 'Target',
        'Timeout' => 'Timeout',
        'Username' => 'Username',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ApiProxy

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ApiProxy from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Request

 $element->set_Request($data);
 $element->get_Request();




=item * Target

 $element->set_Target($data);
 $element->get_Target();




=item * Timeout

 $element->set_Timeout($data);
 $element->get_Timeout();




=item * Username

 $element->set_Username($data);
 $element->get_Username();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ApiProxy->new($data);

Constructor. The following data structure may be passed to new():

 {
   Request =>  { # MyTypes::Request
     Args =>  {
     },
     Name =>  $some_value, # string
   },
   Target =>  $some_value, # string
   Timeout =>  $some_value, # integer
   Username =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

