
package MyElements::ApplicationPolicyCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ApplicationPolicyCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationPolicyInfo_of :ATTR(:get<ApplicationPolicyInfo>);

__PACKAGE__->_factory(
    [ qw(        ApplicationPolicyInfo

    ) ],
    {
        'ApplicationPolicyInfo' => \%ApplicationPolicyInfo_of,
    },
    {
        'ApplicationPolicyInfo' => 'MyTypes::ApplicationPolicyInfo',
    },
    {

        'ApplicationPolicyInfo' => 'ApplicationPolicyInfo',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ApplicationPolicyCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ApplicationPolicyCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationPolicyInfo

 $element->set_ApplicationPolicyInfo($data);
 $element->get_ApplicationPolicyInfo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ApplicationPolicyCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationPolicyInfo =>  { # MyTypes::ApplicationPolicyInfo
     ApplicationBackupOperationInfo =>  { # MyTypes::ApplicationBackupOperationInfo
       BackupSchedules =>  { # MyTypes::ArrayOfApplicationBackupScheduleInfo
         ApplicationBackupScheduleInfo =>  { # MyTypes::ApplicationBackupScheduleInfo
           HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
             AllowSavedStateBackup =>  $some_value, # boolean
           },
           RetentionType => $some_value, # DpBackupRetentionType
           ScheduleId =>  $some_value, # integer
           SimpleScheduleInfo =>  { # MyTypes::SimpleScheduleInfo
             DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
               DayOfMonth => $some_value, # DayOfMonth
             },
             DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
               DayOfWeek => $some_value, # DayOfWeek
             },
             TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
               EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                 TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                   Hour => $some_value, # atomic
                   Minute => $some_value, # atomic
                 },
               },
               Frequency => $some_value, # atomic
               StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                 TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                   Hour => $some_value, # atomic
                   Minute => $some_value, # atomic
                 },
               },
             },
           },
           StartRemoteBackupAfterLocalBackup =>  $some_value, # boolean
           VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
             CreateVmwareSnapshot =>  $some_value, # boolean
             IncludeIndependentDisks =>  $some_value, # boolean
           },
         },
       },
     },
     ApplicationPolicyDescription =>  $some_value, # string
     ApplicationPolicyId => $some_value, # ObjId
     ApplicationPolicyName => $some_value, # ObjName
     ApplicationPolicySettingsInfo =>  { # MyTypes::ApplicationPolicySettingsInfo
       BackupScript =>  $some_value, # string
       DailyRetentionCount => $some_value, # atomic
       DailyRetentionDuration => $some_value, # atomic
       HourlyRetentionCount => $some_value, # atomic
       HourlyRetentionDuration => $some_value, # atomic
       IsLagErrorEnabled =>  $some_value, # boolean
       IsLagWarningEnabled =>  $some_value, # boolean
       LagErrorThreshold => $some_value, # atomic
       LagWarningThreshold => $some_value, # atomic
       MonthlyRetentionCount => $some_value, # atomic
       MonthlyRetentionDuration => $some_value, # atomic
       WeeklyRetentionCount => $some_value, # atomic
       WeeklyRetentionDuration => $some_value, # atomic
     },
     ApplicationPolicyType => $some_value, # ApplicationPolicyType
     GroupNameOrId => $some_value, # ObjNameOrId
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

