
package MyElements::AuditLogAddEntry;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('AuditLogAddEntry');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AuditApplicationName_of :ATTR(:get<AuditApplicationName>);
my %AuditInterface_of :ATTR(:get<AuditInterface>);
my %AuditIpAddress_of :ATTR(:get<AuditIpAddress>);
my %AuditMessage_of :ATTR(:get<AuditMessage>);
my %AuditPriority_of :ATTR(:get<AuditPriority>);
my %AuditType_of :ATTR(:get<AuditType>);

__PACKAGE__->_factory(
    [ qw(        AuditApplicationName
        AuditInterface
        AuditIpAddress
        AuditMessage
        AuditPriority
        AuditType

    ) ],
    {
        'AuditApplicationName' => \%AuditApplicationName_of,
        'AuditInterface' => \%AuditInterface_of,
        'AuditIpAddress' => \%AuditIpAddress_of,
        'AuditMessage' => \%AuditMessage_of,
        'AuditPriority' => \%AuditPriority_of,
        'AuditType' => \%AuditType_of,
    },
    {
        'AuditApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AuditInterface' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AuditIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AuditMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AuditPriority' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AuditType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AuditApplicationName' => 'AuditApplicationName',
        'AuditInterface' => 'AuditInterface',
        'AuditIpAddress' => 'AuditIpAddress',
        'AuditMessage' => 'AuditMessage',
        'AuditPriority' => 'AuditPriority',
        'AuditType' => 'AuditType',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::AuditLogAddEntry

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
AuditLogAddEntry from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AuditApplicationName

 $element->set_AuditApplicationName($data);
 $element->get_AuditApplicationName();




=item * AuditInterface

 $element->set_AuditInterface($data);
 $element->get_AuditInterface();




=item * AuditIpAddress

 $element->set_AuditIpAddress($data);
 $element->get_AuditIpAddress();




=item * AuditMessage

 $element->set_AuditMessage($data);
 $element->get_AuditMessage();




=item * AuditPriority

 $element->set_AuditPriority($data);
 $element->get_AuditPriority();




=item * AuditType

 $element->set_AuditType($data);
 $element->get_AuditType();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::AuditLogAddEntry->new($data);

Constructor. The following data structure may be passed to new():

 {
   AuditApplicationName =>  $some_value, # string
   AuditInterface =>  $some_value, # string
   AuditIpAddress =>  $some_value, # string
   AuditMessage =>  $some_value, # string
   AuditPriority =>  $some_value, # string
   AuditType =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

