
package MyElements::ClientRegistrySet;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ClientRegistrySet');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationName_of :ATTR(:get<ApplicationName>);
my %Options_of :ATTR(:get<Options>);

__PACKAGE__->_factory(
    [ qw(        ApplicationName
        Options

    ) ],
    {
        'ApplicationName' => \%ApplicationName_of,
        'Options' => \%Options_of,
    },
    {
        'ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Options' => 'MyTypes::ArrayOfClientOptionInfo',
    },
    {

        'ApplicationName' => 'ApplicationName',
        'Options' => 'Options',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ClientRegistrySet

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ClientRegistrySet from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationName

 $element->set_ApplicationName($data);
 $element->get_ApplicationName();




=item * Options

 $element->set_Options($data);
 $element->get_Options();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ClientRegistrySet->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationName =>  $some_value, # string
   Options =>  { # MyTypes::ArrayOfClientOptionInfo
     ClientOptionInfo =>  { # MyTypes::ClientOptionInfo
       Option =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

