
package MyElements::DatasetAddMember;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetAddMember');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetMemberParameters_of :ATTR(:get<DatasetMemberParameters>);
my %EditLockId_of :ATTR(:get<EditLockId>);
my %IsExistingMemberOk_of :ATTR(:get<IsExistingMemberOk>);

__PACKAGE__->_factory(
    [ qw(        DatasetMemberParameters
        EditLockId
        IsExistingMemberOk

    ) ],
    {
        'DatasetMemberParameters' => \%DatasetMemberParameters_of,
        'EditLockId' => \%EditLockId_of,
        'IsExistingMemberOk' => \%IsExistingMemberOk_of,
    },
    {
        'DatasetMemberParameters' => 'MyTypes::ArrayOfDatasetMemberParameter',

        'EditLockId' => 'MyElements::DatasetAddMember::_EditLockId',
        'IsExistingMemberOk' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DatasetMemberParameters' => 'DatasetMemberParameters',
        'EditLockId' => 'EditLockId',
        'IsExistingMemberOk' => 'IsExistingMemberOk',
    }
);

} # end BLOCK




package MyElements::DatasetAddMember::_EditLockId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetAddMember

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetAddMember from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetMemberParameters

 $element->set_DatasetMemberParameters($data);
 $element->get_DatasetMemberParameters();




=item * EditLockId

 $element->set_EditLockId($data);
 $element->get_EditLockId();




=item * IsExistingMemberOk

 $element->set_IsExistingMemberOk($data);
 $element->get_IsExistingMemberOk();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetAddMember->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetMemberParameters =>  { # MyTypes::ArrayOfDatasetMemberParameter
     DatasetMemberParameter =>  { # MyTypes::DatasetMemberParameter
       DpNodeName => $some_value, # DpPolicyNodeName
       ObjectNameOrId => $some_value, # ObjNameOrId
     },
   },
   EditLockId => $some_value, # atomic
   IsExistingMemberOk =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

