
package MyElements::DatasetDynamicReferenceListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetDynamicReferenceListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %DynamicReferenceType_of :ATTR(:get<DynamicReferenceType>);
my %IncludeDeleted_of :ATTR(:get<IncludeDeleted>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %StoragesetNameOrId_of :ATTR(:get<StoragesetNameOrId>);
my %SuppressStatusRefresh_of :ATTR(:get<SuppressStatusRefresh>);

__PACKAGE__->_factory(
    [ qw(        DatasetNameOrId
        DpNodeName
        DynamicReferenceType
        IncludeDeleted
        IncludeIsAvailable
        StoragesetNameOrId
        SuppressStatusRefresh

    ) ],
    {
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DpNodeName' => \%DpNodeName_of,
        'DynamicReferenceType' => \%DynamicReferenceType_of,
        'IncludeDeleted' => \%IncludeDeleted_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'StoragesetNameOrId' => \%StoragesetNameOrId_of,
        'SuppressStatusRefresh' => \%SuppressStatusRefresh_of,
    },
    {
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'DynamicReferenceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'StoragesetNameOrId' => 'MyTypes::ObjNameOrId',
        'SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DatasetNameOrId' => 'DatasetNameOrId',
        'DpNodeName' => 'DpNodeName',
        'DynamicReferenceType' => 'DynamicReferenceType',
        'IncludeDeleted' => 'IncludeDeleted',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'StoragesetNameOrId' => 'StoragesetNameOrId',
        'SuppressStatusRefresh' => 'SuppressStatusRefresh',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetDynamicReferenceListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetDynamicReferenceListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DpNodeName

 $element->set_DpNodeName($data);
 $element->get_DpNodeName();




=item * DynamicReferenceType

 $element->set_DynamicReferenceType($data);
 $element->get_DynamicReferenceType();




=item * IncludeDeleted

 $element->set_IncludeDeleted($data);
 $element->get_IncludeDeleted();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * StoragesetNameOrId

 $element->set_StoragesetNameOrId($data);
 $element->get_StoragesetNameOrId();




=item * SuppressStatusRefresh

 $element->set_SuppressStatusRefresh($data);
 $element->get_SuppressStatusRefresh();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetDynamicReferenceListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetNameOrId => $some_value, # ObjNameOrId
   DpNodeName => $some_value, # DpPolicyNodeName
   DynamicReferenceType =>  $some_value, # string
   IncludeDeleted =>  $some_value, # boolean
   IncludeIsAvailable =>  $some_value, # boolean
   StoragesetNameOrId => $some_value, # ObjNameOrId
   SuppressStatusRefresh =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

