
package MyElements::DatasetListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationName_of :ATTR(:get<ApplicationName>);
my %ApplicationResourceNamespace_of :ATTR(:get<ApplicationResourceNamespace>);
my %ApplicationServerName_of :ATTR(:get<ApplicationServerName>);
my %DrState_of :ATTR(:get<DrState>);
my %HasApplicationPolicy_of :ATTR(:get<HasApplicationPolicy>);
my %HasProtection_of :ATTR(:get<HasProtection>);
my %HasProtectionPolicy_of :ATTR(:get<HasProtectionPolicy>);
my %IncludeCanContainApplicationResourcesOnly_of :ATTR(:get<IncludeCanContainApplicationResourcesOnly>);
my %IncludeCanContainStorageResourcesOnly_of :ATTR(:get<IncludeCanContainStorageResourcesOnly>);
my %IncludeConformanceCheckResults_of :ATTR(:get<IncludeConformanceCheckResults>);
my %IncludeConformanceRunReasonDetails_of :ATTR(:get<IncludeConformanceRunReasonDetails>);
my %IncludeExportSettings_of :ATTR(:get<IncludeExportSettings>);
my %IncludeMetadata_of :ATTR(:get<IncludeMetadata>);
my %IncludeMigrationInfo_of :ATTR(:get<IncludeMigrationInfo>);
my %IncludeProtectionStatusProblems_of :ATTR(:get<IncludeProtectionStatusProblems>);
my %IsApplicationData_of :ATTR(:get<IsApplicationData>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsDrCapable_of :ATTR(:get<IsDrCapable>);
my %IsProtected_of :ATTR(:get<IsProtected>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %RequiresNonDisruptiveRestore_of :ATTR(:get<RequiresNonDisruptiveRestore>);
my %SuppressStatusRefresh_of :ATTR(:get<SuppressStatusRefresh>);
my %VolumeQtreeNamePrefix_of :ATTR(:get<VolumeQtreeNamePrefix>);

__PACKAGE__->_factory(
    [ qw(        ApplicationName
        ApplicationResourceNamespace
        ApplicationServerName
        DrState
        HasApplicationPolicy
        HasProtection
        HasProtectionPolicy
        IncludeCanContainApplicationResourcesOnly
        IncludeCanContainStorageResourcesOnly
        IncludeConformanceCheckResults
        IncludeConformanceRunReasonDetails
        IncludeExportSettings
        IncludeMetadata
        IncludeMigrationInfo
        IncludeProtectionStatusProblems
        IsApplicationData
        IsDpIgnored
        IsDrCapable
        IsProtected
        ObjectNameOrId
        RequiresNonDisruptiveRestore
        SuppressStatusRefresh
        VolumeQtreeNamePrefix

    ) ],
    {
        'ApplicationName' => \%ApplicationName_of,
        'ApplicationResourceNamespace' => \%ApplicationResourceNamespace_of,
        'ApplicationServerName' => \%ApplicationServerName_of,
        'DrState' => \%DrState_of,
        'HasApplicationPolicy' => \%HasApplicationPolicy_of,
        'HasProtection' => \%HasProtection_of,
        'HasProtectionPolicy' => \%HasProtectionPolicy_of,
        'IncludeCanContainApplicationResourcesOnly' => \%IncludeCanContainApplicationResourcesOnly_of,
        'IncludeCanContainStorageResourcesOnly' => \%IncludeCanContainStorageResourcesOnly_of,
        'IncludeConformanceCheckResults' => \%IncludeConformanceCheckResults_of,
        'IncludeConformanceRunReasonDetails' => \%IncludeConformanceRunReasonDetails_of,
        'IncludeExportSettings' => \%IncludeExportSettings_of,
        'IncludeMetadata' => \%IncludeMetadata_of,
        'IncludeMigrationInfo' => \%IncludeMigrationInfo_of,
        'IncludeProtectionStatusProblems' => \%IncludeProtectionStatusProblems_of,
        'IsApplicationData' => \%IsApplicationData_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsDrCapable' => \%IsDrCapable_of,
        'IsProtected' => \%IsProtected_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'RequiresNonDisruptiveRestore' => \%RequiresNonDisruptiveRestore_of,
        'SuppressStatusRefresh' => \%SuppressStatusRefresh_of,
        'VolumeQtreeNamePrefix' => \%VolumeQtreeNamePrefix_of,
    },
    {
        'ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
        'ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DrState' => 'MyTypes::DrState',
        'HasApplicationPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HasProtection' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HasProtectionPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeCanContainApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeCanContainStorageResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeConformanceCheckResults' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeConformanceRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeExportSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeProtectionStatusProblems' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
        'SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplicationName' => 'ApplicationName',
        'ApplicationResourceNamespace' => 'ApplicationResourceNamespace',
        'ApplicationServerName' => 'ApplicationServerName',
        'DrState' => 'DrState',
        'HasApplicationPolicy' => 'HasApplicationPolicy',
        'HasProtection' => 'HasProtection',
        'HasProtectionPolicy' => 'HasProtectionPolicy',
        'IncludeCanContainApplicationResourcesOnly' => 'IncludeCanContainApplicationResourcesOnly',
        'IncludeCanContainStorageResourcesOnly' => 'IncludeCanContainStorageResourcesOnly',
        'IncludeConformanceCheckResults' => 'IncludeConformanceCheckResults',
        'IncludeConformanceRunReasonDetails' => 'IncludeConformanceRunReasonDetails',
        'IncludeExportSettings' => 'IncludeExportSettings',
        'IncludeMetadata' => 'IncludeMetadata',
        'IncludeMigrationInfo' => 'IncludeMigrationInfo',
        'IncludeProtectionStatusProblems' => 'IncludeProtectionStatusProblems',
        'IsApplicationData' => 'IsApplicationData',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsDrCapable' => 'IsDrCapable',
        'IsProtected' => 'IsProtected',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'RequiresNonDisruptiveRestore' => 'RequiresNonDisruptiveRestore',
        'SuppressStatusRefresh' => 'SuppressStatusRefresh',
        'VolumeQtreeNamePrefix' => 'VolumeQtreeNamePrefix',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationName

 $element->set_ApplicationName($data);
 $element->get_ApplicationName();




=item * ApplicationResourceNamespace

 $element->set_ApplicationResourceNamespace($data);
 $element->get_ApplicationResourceNamespace();




=item * ApplicationServerName

 $element->set_ApplicationServerName($data);
 $element->get_ApplicationServerName();




=item * DrState

 $element->set_DrState($data);
 $element->get_DrState();




=item * HasApplicationPolicy

 $element->set_HasApplicationPolicy($data);
 $element->get_HasApplicationPolicy();




=item * HasProtection

 $element->set_HasProtection($data);
 $element->get_HasProtection();




=item * HasProtectionPolicy

 $element->set_HasProtectionPolicy($data);
 $element->get_HasProtectionPolicy();




=item * IncludeCanContainApplicationResourcesOnly

 $element->set_IncludeCanContainApplicationResourcesOnly($data);
 $element->get_IncludeCanContainApplicationResourcesOnly();




=item * IncludeCanContainStorageResourcesOnly

 $element->set_IncludeCanContainStorageResourcesOnly($data);
 $element->get_IncludeCanContainStorageResourcesOnly();




=item * IncludeConformanceCheckResults

 $element->set_IncludeConformanceCheckResults($data);
 $element->get_IncludeConformanceCheckResults();




=item * IncludeConformanceRunReasonDetails

 $element->set_IncludeConformanceRunReasonDetails($data);
 $element->get_IncludeConformanceRunReasonDetails();




=item * IncludeExportSettings

 $element->set_IncludeExportSettings($data);
 $element->get_IncludeExportSettings();




=item * IncludeMetadata

 $element->set_IncludeMetadata($data);
 $element->get_IncludeMetadata();




=item * IncludeMigrationInfo

 $element->set_IncludeMigrationInfo($data);
 $element->get_IncludeMigrationInfo();




=item * IncludeProtectionStatusProblems

 $element->set_IncludeProtectionStatusProblems($data);
 $element->get_IncludeProtectionStatusProblems();




=item * IsApplicationData

 $element->set_IsApplicationData($data);
 $element->get_IsApplicationData();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsDrCapable

 $element->set_IsDrCapable($data);
 $element->get_IsDrCapable();




=item * IsProtected

 $element->set_IsProtected($data);
 $element->get_IsProtected();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * RequiresNonDisruptiveRestore

 $element->set_RequiresNonDisruptiveRestore($data);
 $element->get_RequiresNonDisruptiveRestore();




=item * SuppressStatusRefresh

 $element->set_SuppressStatusRefresh($data);
 $element->get_SuppressStatusRefresh();




=item * VolumeQtreeNamePrefix

 $element->set_VolumeQtreeNamePrefix($data);
 $element->get_VolumeQtreeNamePrefix();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationName =>  $some_value, # string
   ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   ApplicationServerName =>  $some_value, # string
   DrState => $some_value, # DrState
   HasApplicationPolicy =>  $some_value, # boolean
   HasProtection =>  $some_value, # boolean
   HasProtectionPolicy =>  $some_value, # boolean
   IncludeCanContainApplicationResourcesOnly =>  $some_value, # boolean
   IncludeCanContainStorageResourcesOnly =>  $some_value, # boolean
   IncludeConformanceCheckResults =>  $some_value, # boolean
   IncludeConformanceRunReasonDetails =>  $some_value, # boolean
   IncludeExportSettings =>  $some_value, # boolean
   IncludeMetadata =>  $some_value, # boolean
   IncludeMigrationInfo =>  $some_value, # boolean
   IncludeProtectionStatusProblems =>  $some_value, # boolean
   IsApplicationData =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsDrCapable =>  $some_value, # boolean
   IsProtected =>  $some_value, # boolean
   ObjectNameOrId => $some_value, # ObjNameOrId
   RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
   SuppressStatusRefresh =>  $some_value, # boolean
   VolumeQtreeNamePrefix =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

