
package MyElements::DatasetMemberListInfoIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetMemberListInfoIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetMembers_of :ATTR(:get<DatasetMembers>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        DatasetMembers
        Records

    ) ],
    {
        'DatasetMembers' => \%DatasetMembers_of,
        'Records' => \%Records_of,
    },
    {
        'DatasetMembers' => 'MyTypes::ArrayOfDatasetMemberInfo',
        'Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'DatasetMembers' => 'DatasetMembers',
        'Records' => 'Records',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetMemberListInfoIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetMemberListInfoIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetMembers

 $element->set_DatasetMembers($data);
 $element->get_DatasetMembers();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetMemberListInfoIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetMembers =>  { # MyTypes::ArrayOfDatasetMemberInfo
     DatasetMemberInfo =>  { # MyTypes::DatasetMemberInfo
       CifsShareNames =>  { # MyTypes::ArrayOfCifsShareName
         CifsShareName => $some_value, # CifsShareName
       },
       CifsSharesInfo =>  { # MyTypes::ArrayOfCifsShareInfo
         CifsShareInfo =>  { # MyTypes::CifsShareInfo
           CifsShareName => $some_value, # CifsShareName
           CifsSharePermissions =>  { # MyTypes::ArrayOfCifsSharePermission
             CifsSharePermission =>  { # MyTypes::CifsSharePermission
               CifsUsername =>  $some_value, # string
               Permission =>  $some_value, # string
             },
           },
         },
       },
       DpNodeName => $some_value, # DpPolicyNodeName
       IsAvailable =>  $some_value, # boolean
       IsDeleted =>  $some_value, # boolean
       LunIgroupsInfo =>  { # MyTypes::ArrayOfLunIgroupInfo
         LunIgroupInfo =>  { # MyTypes::LunIgroupInfo
           IgroupInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
             LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
               Hostname =>  $some_value, # string
               InitiatorId => $some_value, # InitiatorId
             },
           },
           IgroupLunId => $some_value, # atomic
           IgroupName => $some_value, # ObjName
           IgroupOsType =>  $some_value, # string
           IgroupProtocol =>  $some_value, # string
         },
       },
       MemberId => $some_value, # ObjId
       MemberName => $some_value, # ObjName
       MemberPerfStatus => $some_value, # ObjStatus
       MemberStatus => $some_value, # ObjStatus
       MemberType =>  $some_value, # string
       NfsExportName =>  $some_value, # string
       NfsExportRules =>  { # MyTypes::NfsExportRules
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
       SpaceInfo =>  { # MyTypes::SpaceInfo
         AvailableSpace => $some_value, # atomic
         SpaceConditions =>  { # MyTypes::ArrayOfSpaceCondition
           SpaceCondition =>  { # MyTypes::SpaceCondition
             Condition =>  $some_value, # string
             Reason =>  $some_value, # string
             Severity =>  $some_value, # string
             Suggestion =>  $some_value, # string
           },
         },
         SpaceStatus => $some_value, # SpaceStatus
         TotalSpace => $some_value, # atomic
         UsedSpace => $some_value, # atomic
       },
       StoragesetId => $some_value, # ObjId
       StoragesetName => $some_value, # ObjName
     },
   },
   Records =>  $some_value, # integer
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

