
package MyElements::DatasetMemberListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetMemberListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IncludeDeleted_of :ATTR(:get<IncludeDeleted>);
my %IncludeExportsInfo_of :ATTR(:get<IncludeExportsInfo>);
my %IncludeIndirect_of :ATTR(:get<IncludeIndirect>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IncludeSpaceInfo_of :ATTR(:get<IncludeSpaceInfo>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberNameOrId_of :ATTR(:get<MemberNameOrId>);
my %MemberType_of :ATTR(:get<MemberType>);
my %StoragesetNameOrId_of :ATTR(:get<StoragesetNameOrId>);
my %SuppressStatusRefresh_of :ATTR(:get<SuppressStatusRefresh>);

__PACKAGE__->_factory(
    [ qw(        DatasetNameOrId
        DpNodeName
        IncludeDeleted
        IncludeExportsInfo
        IncludeIndirect
        IncludeIsAvailable
        IncludeSpaceInfo
        MemberId
        MemberNameOrId
        MemberType
        StoragesetNameOrId
        SuppressStatusRefresh

    ) ],
    {
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DpNodeName' => \%DpNodeName_of,
        'IncludeDeleted' => \%IncludeDeleted_of,
        'IncludeExportsInfo' => \%IncludeExportsInfo_of,
        'IncludeIndirect' => \%IncludeIndirect_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IncludeSpaceInfo' => \%IncludeSpaceInfo_of,
        'MemberId' => \%MemberId_of,
        'MemberNameOrId' => \%MemberNameOrId_of,
        'MemberType' => \%MemberType_of,
        'StoragesetNameOrId' => \%StoragesetNameOrId_of,
        'SuppressStatusRefresh' => \%SuppressStatusRefresh_of,
    },
    {
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeExportsInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MemberId' => 'MyTypes::ObjId',
        'MemberNameOrId' => 'MyTypes::ObjNameOrId',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StoragesetNameOrId' => 'MyTypes::ObjNameOrId',
        'SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DatasetNameOrId' => 'DatasetNameOrId',
        'DpNodeName' => 'DpNodeName',
        'IncludeDeleted' => 'IncludeDeleted',
        'IncludeExportsInfo' => 'IncludeExportsInfo',
        'IncludeIndirect' => 'IncludeIndirect',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IncludeSpaceInfo' => 'IncludeSpaceInfo',
        'MemberId' => 'MemberId',
        'MemberNameOrId' => 'MemberNameOrId',
        'MemberType' => 'MemberType',
        'StoragesetNameOrId' => 'StoragesetNameOrId',
        'SuppressStatusRefresh' => 'SuppressStatusRefresh',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetMemberListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetMemberListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DpNodeName

 $element->set_DpNodeName($data);
 $element->get_DpNodeName();




=item * IncludeDeleted

 $element->set_IncludeDeleted($data);
 $element->get_IncludeDeleted();




=item * IncludeExportsInfo

 $element->set_IncludeExportsInfo($data);
 $element->get_IncludeExportsInfo();




=item * IncludeIndirect

 $element->set_IncludeIndirect($data);
 $element->get_IncludeIndirect();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IncludeSpaceInfo

 $element->set_IncludeSpaceInfo($data);
 $element->get_IncludeSpaceInfo();




=item * MemberId

 $element->set_MemberId($data);
 $element->get_MemberId();




=item * MemberNameOrId

 $element->set_MemberNameOrId($data);
 $element->get_MemberNameOrId();




=item * MemberType

 $element->set_MemberType($data);
 $element->get_MemberType();




=item * StoragesetNameOrId

 $element->set_StoragesetNameOrId($data);
 $element->get_StoragesetNameOrId();




=item * SuppressStatusRefresh

 $element->set_SuppressStatusRefresh($data);
 $element->get_SuppressStatusRefresh();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetMemberListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetNameOrId => $some_value, # ObjNameOrId
   DpNodeName => $some_value, # DpPolicyNodeName
   IncludeDeleted =>  $some_value, # boolean
   IncludeExportsInfo =>  $some_value, # boolean
   IncludeIndirect =>  $some_value, # boolean
   IncludeIsAvailable =>  $some_value, # boolean
   IncludeSpaceInfo =>  $some_value, # boolean
   MemberId => $some_value, # ObjId
   MemberNameOrId => $some_value, # ObjNameOrId
   MemberType =>  $some_value, # string
   StoragesetNameOrId => $some_value, # ObjNameOrId
   SuppressStatusRefresh =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

