
package MyElements::DatasetModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationInfo_of :ATTR(:get<ApplicationInfo>);
my %ApplicationPolicyNameOrId_of :ATTR(:get<ApplicationPolicyNameOrId>);
my %CheckProtectionPolicyOnCommit_of :ATTR(:get<CheckProtectionPolicyOnCommit>);
my %DatasetContact_of :ATTR(:get<DatasetContact>);
my %DatasetDescription_of :ATTR(:get<DatasetDescription>);
my %DatasetMetadata_of :ATTR(:get<DatasetMetadata>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DatasetOwner_of :ATTR(:get<DatasetOwner>);
my %EditLockId_of :ATTR(:get<EditLockId>);
my %IsApplicationData_of :ATTR(:get<IsApplicationData>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsDpSuspended_of :ATTR(:get<IsDpSuspended>);
my %IsSuspended_of :ATTR(:get<IsSuspended>);
my %PrimaryVolumeNameFormat_of :ATTR(:get<PrimaryVolumeNameFormat>);
my %ProtectionPolicyId_of :ATTR(:get<ProtectionPolicyId>);
my %ProtectionPolicyNameOrId_of :ATTR(:get<ProtectionPolicyNameOrId>);
my %RequiresNonDisruptiveRestore_of :ATTR(:get<RequiresNonDisruptiveRestore>);
my %SecondaryQtreeNameFormat_of :ATTR(:get<SecondaryQtreeNameFormat>);
my %SecondaryVolumeNameFormat_of :ATTR(:get<SecondaryVolumeNameFormat>);
my %SnapshotNameFormat_of :ATTR(:get<SnapshotNameFormat>);
my %VolumeQtreeNamePrefix_of :ATTR(:get<VolumeQtreeNamePrefix>);

__PACKAGE__->_factory(
    [ qw(        ApplicationInfo
        ApplicationPolicyNameOrId
        CheckProtectionPolicyOnCommit
        DatasetContact
        DatasetDescription
        DatasetMetadata
        DatasetName
        DatasetOwner
        EditLockId
        IsApplicationData
        IsDpIgnored
        IsDpSuspended
        IsSuspended
        PrimaryVolumeNameFormat
        ProtectionPolicyId
        ProtectionPolicyNameOrId
        RequiresNonDisruptiveRestore
        SecondaryQtreeNameFormat
        SecondaryVolumeNameFormat
        SnapshotNameFormat
        VolumeQtreeNamePrefix

    ) ],
    {
        'ApplicationInfo' => \%ApplicationInfo_of,
        'ApplicationPolicyNameOrId' => \%ApplicationPolicyNameOrId_of,
        'CheckProtectionPolicyOnCommit' => \%CheckProtectionPolicyOnCommit_of,
        'DatasetContact' => \%DatasetContact_of,
        'DatasetDescription' => \%DatasetDescription_of,
        'DatasetMetadata' => \%DatasetMetadata_of,
        'DatasetName' => \%DatasetName_of,
        'DatasetOwner' => \%DatasetOwner_of,
        'EditLockId' => \%EditLockId_of,
        'IsApplicationData' => \%IsApplicationData_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsDpSuspended' => \%IsDpSuspended_of,
        'IsSuspended' => \%IsSuspended_of,
        'PrimaryVolumeNameFormat' => \%PrimaryVolumeNameFormat_of,
        'ProtectionPolicyId' => \%ProtectionPolicyId_of,
        'ProtectionPolicyNameOrId' => \%ProtectionPolicyNameOrId_of,
        'RequiresNonDisruptiveRestore' => \%RequiresNonDisruptiveRestore_of,
        'SecondaryQtreeNameFormat' => \%SecondaryQtreeNameFormat_of,
        'SecondaryVolumeNameFormat' => \%SecondaryVolumeNameFormat_of,
        'SnapshotNameFormat' => \%SnapshotNameFormat_of,
        'VolumeQtreeNamePrefix' => \%VolumeQtreeNamePrefix_of,
    },
    {
        'ApplicationInfo' => 'MyTypes::ApplicationInfo',
        'ApplicationPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'CheckProtectionPolicyOnCommit' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetContact' => 'MyTypes::EmailAddressList',
        'DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
        'DatasetName' => 'MyTypes::ObjName',
        'DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'EditLockId' => 'MyElements::DatasetModify::_EditLockId',
        'IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PrimaryVolumeNameFormat' => 'MyTypes::PrimaryVolumeNameFormat',
        'ProtectionPolicyId' => 'MyTypes::ObjId',
        'ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
        'SecondaryQtreeNameFormat' => 'MyTypes::SecondaryQtreeNameFormat',
        'SecondaryVolumeNameFormat' => 'MyTypes::SecondaryVolumeNameFormat',
        'SnapshotNameFormat' => 'MyTypes::SnapshotNameFormat',
        'VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplicationInfo' => 'ApplicationInfo',
        'ApplicationPolicyNameOrId' => 'ApplicationPolicyNameOrId',
        'CheckProtectionPolicyOnCommit' => 'CheckProtectionPolicyOnCommit',
        'DatasetContact' => 'DatasetContact',
        'DatasetDescription' => 'DatasetDescription',
        'DatasetMetadata' => 'DatasetMetadata',
        'DatasetName' => 'DatasetName',
        'DatasetOwner' => 'DatasetOwner',
        'EditLockId' => 'EditLockId',
        'IsApplicationData' => 'IsApplicationData',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsDpSuspended' => 'IsDpSuspended',
        'IsSuspended' => 'IsSuspended',
        'PrimaryVolumeNameFormat' => 'PrimaryVolumeNameFormat',
        'ProtectionPolicyId' => 'ProtectionPolicyId',
        'ProtectionPolicyNameOrId' => 'ProtectionPolicyNameOrId',
        'RequiresNonDisruptiveRestore' => 'RequiresNonDisruptiveRestore',
        'SecondaryQtreeNameFormat' => 'SecondaryQtreeNameFormat',
        'SecondaryVolumeNameFormat' => 'SecondaryVolumeNameFormat',
        'SnapshotNameFormat' => 'SnapshotNameFormat',
        'VolumeQtreeNamePrefix' => 'VolumeQtreeNamePrefix',
    }
);

} # end BLOCK




package MyElements::DatasetModify::_EditLockId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationInfo

 $element->set_ApplicationInfo($data);
 $element->get_ApplicationInfo();




=item * ApplicationPolicyNameOrId

 $element->set_ApplicationPolicyNameOrId($data);
 $element->get_ApplicationPolicyNameOrId();




=item * CheckProtectionPolicyOnCommit

 $element->set_CheckProtectionPolicyOnCommit($data);
 $element->get_CheckProtectionPolicyOnCommit();




=item * DatasetContact

 $element->set_DatasetContact($data);
 $element->get_DatasetContact();




=item * DatasetDescription

 $element->set_DatasetDescription($data);
 $element->get_DatasetDescription();




=item * DatasetMetadata

 $element->set_DatasetMetadata($data);
 $element->get_DatasetMetadata();




=item * DatasetName

 $element->set_DatasetName($data);
 $element->get_DatasetName();




=item * DatasetOwner

 $element->set_DatasetOwner($data);
 $element->get_DatasetOwner();




=item * EditLockId

 $element->set_EditLockId($data);
 $element->get_EditLockId();




=item * IsApplicationData

 $element->set_IsApplicationData($data);
 $element->get_IsApplicationData();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsDpSuspended

 $element->set_IsDpSuspended($data);
 $element->get_IsDpSuspended();




=item * IsSuspended

 $element->set_IsSuspended($data);
 $element->get_IsSuspended();




=item * PrimaryVolumeNameFormat

 $element->set_PrimaryVolumeNameFormat($data);
 $element->get_PrimaryVolumeNameFormat();




=item * ProtectionPolicyId

 $element->set_ProtectionPolicyId($data);
 $element->get_ProtectionPolicyId();




=item * ProtectionPolicyNameOrId

 $element->set_ProtectionPolicyNameOrId($data);
 $element->get_ProtectionPolicyNameOrId();




=item * RequiresNonDisruptiveRestore

 $element->set_RequiresNonDisruptiveRestore($data);
 $element->get_RequiresNonDisruptiveRestore();




=item * SecondaryQtreeNameFormat

 $element->set_SecondaryQtreeNameFormat($data);
 $element->get_SecondaryQtreeNameFormat();




=item * SecondaryVolumeNameFormat

 $element->set_SecondaryVolumeNameFormat($data);
 $element->get_SecondaryVolumeNameFormat();




=item * SnapshotNameFormat

 $element->set_SnapshotNameFormat($data);
 $element->get_SnapshotNameFormat();




=item * VolumeQtreeNamePrefix

 $element->set_VolumeQtreeNamePrefix($data);
 $element->get_VolumeQtreeNamePrefix();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationInfo =>  { # MyTypes::ApplicationInfo
     ApplicationName =>  $some_value, # string
     ApplicationServerName =>  $some_value, # string
     ApplicationVersion =>  $some_value, # string
     CarryPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
   },
   ApplicationPolicyNameOrId => $some_value, # ObjNameOrId
   CheckProtectionPolicyOnCommit =>  $some_value, # boolean
   DatasetContact => $some_value, # EmailAddressList
   DatasetDescription =>  $some_value, # string
   DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
     DfmMetadataField =>  { # MyTypes::DfmMetadataField
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   DatasetName => $some_value, # ObjName
   DatasetOwner =>  $some_value, # string
   EditLockId => $some_value, # atomic
   IsApplicationData =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsDpSuspended =>  $some_value, # boolean
   IsSuspended =>  $some_value, # boolean
   PrimaryVolumeNameFormat => $some_value, # PrimaryVolumeNameFormat
   ProtectionPolicyId => $some_value, # ObjId
   ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
   RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
   SecondaryQtreeNameFormat => $some_value, # SecondaryQtreeNameFormat
   SecondaryVolumeNameFormat => $some_value, # SecondaryVolumeNameFormat
   SnapshotNameFormat => $some_value, # SnapshotNameFormat
   VolumeQtreeNamePrefix =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

