
package MyElements::DatasetModifyNode;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetModifyNode');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetAccessDetails_of :ATTR(:get<DatasetAccessDetails>);
my %DatasetExportInfo_of :ATTR(:get<DatasetExportInfo>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %EditLockId_of :ATTR(:get<EditLockId>);
my %OnlineMigration_of :ATTR(:get<OnlineMigration>);
my %ProvisioningPolicyNameOrId_of :ATTR(:get<ProvisioningPolicyNameOrId>);
my %RelinquishVfiler_of :ATTR(:get<RelinquishVfiler>);
my %ResourcepoolNameOrId_of :ATTR(:get<ResourcepoolNameOrId>);
my %TimezoneName_of :ATTR(:get<TimezoneName>);
my %VfilerNameOrId_of :ATTR(:get<VfilerNameOrId>);

__PACKAGE__->_factory(
    [ qw(        DatasetAccessDetails
        DatasetExportInfo
        DpNodeName
        EditLockId
        OnlineMigration
        ProvisioningPolicyNameOrId
        RelinquishVfiler
        ResourcepoolNameOrId
        TimezoneName
        VfilerNameOrId

    ) ],
    {
        'DatasetAccessDetails' => \%DatasetAccessDetails_of,
        'DatasetExportInfo' => \%DatasetExportInfo_of,
        'DpNodeName' => \%DpNodeName_of,
        'EditLockId' => \%EditLockId_of,
        'OnlineMigration' => \%OnlineMigration_of,
        'ProvisioningPolicyNameOrId' => \%ProvisioningPolicyNameOrId_of,
        'RelinquishVfiler' => \%RelinquishVfiler_of,
        'ResourcepoolNameOrId' => \%ResourcepoolNameOrId_of,
        'TimezoneName' => \%TimezoneName_of,
        'VfilerNameOrId' => \%VfilerNameOrId_of,
    },
    {
        'DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
        'DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'RelinquishVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
        'TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'DatasetAccessDetails' => 'DatasetAccessDetails',
        'DatasetExportInfo' => 'DatasetExportInfo',
        'DpNodeName' => 'DpNodeName',
        'EditLockId' => 'EditLockId',
        'OnlineMigration' => 'OnlineMigration',
        'ProvisioningPolicyNameOrId' => 'ProvisioningPolicyNameOrId',
        'RelinquishVfiler' => 'RelinquishVfiler',
        'ResourcepoolNameOrId' => 'ResourcepoolNameOrId',
        'TimezoneName' => 'TimezoneName',
        'VfilerNameOrId' => 'VfilerNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetModifyNode

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetModifyNode from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetAccessDetails

 $element->set_DatasetAccessDetails($data);
 $element->get_DatasetAccessDetails();




=item * DatasetExportInfo

 $element->set_DatasetExportInfo($data);
 $element->get_DatasetExportInfo();




=item * DpNodeName

 $element->set_DpNodeName($data);
 $element->get_DpNodeName();




=item * EditLockId

 $element->set_EditLockId($data);
 $element->get_EditLockId();




=item * OnlineMigration

 $element->set_OnlineMigration($data);
 $element->get_OnlineMigration();




=item * ProvisioningPolicyNameOrId

 $element->set_ProvisioningPolicyNameOrId($data);
 $element->get_ProvisioningPolicyNameOrId();




=item * RelinquishVfiler

 $element->set_RelinquishVfiler($data);
 $element->get_RelinquishVfiler();




=item * ResourcepoolNameOrId

 $element->set_ResourcepoolNameOrId($data);
 $element->get_ResourcepoolNameOrId();




=item * TimezoneName

 $element->set_TimezoneName($data);
 $element->get_TimezoneName();




=item * VfilerNameOrId

 $element->set_VfilerNameOrId($data);
 $element->get_VfilerNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetModifyNode->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
     IpAddress =>  $some_value, # string
     Netmask =>  $some_value, # string
   },
   DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
     DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
       CifsDomain =>  $some_value, # string
       DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
         DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission => $some_value, # CifsPermission
         },
       },
     },
     DatasetExportProtocol => $some_value, # DatasetExportProtocol
     DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
       IgroupOsType =>  $some_value, # string
       LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
     },
     DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsProtocolVersion =>  $some_value, # string
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
   },
   DpNodeName => $some_value, # DpPolicyNodeName
   EditLockId =>  $some_value, # integer
   OnlineMigration =>  $some_value, # boolean
   ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
   RelinquishVfiler =>  $some_value, # boolean
   ResourcepoolNameOrId => $some_value, # ObjNameOrId
   TimezoneName =>  $some_value, # string
   VfilerNameOrId => $some_value, # ObjNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

