
package MyElements::DatasetProvisionMember;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetProvisionMember');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EditLockId_of :ATTR(:get<EditLockId>);
my %ProvisionMemberRequestInfo_of :ATTR(:get<ProvisionMemberRequestInfo>);

__PACKAGE__->_factory(
    [ qw(        EditLockId
        ProvisionMemberRequestInfo

    ) ],
    {
        'EditLockId' => \%EditLockId_of,
        'ProvisionMemberRequestInfo' => \%ProvisionMemberRequestInfo_of,
    },
    {

        'EditLockId' => 'MyElements::DatasetProvisionMember::_EditLockId',
        'ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
    },
    {

        'EditLockId' => 'EditLockId',
        'ProvisionMemberRequestInfo' => 'ProvisionMemberRequestInfo',
    }
);

} # end BLOCK




package MyElements::DatasetProvisionMember::_EditLockId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetProvisionMember

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetProvisionMember from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EditLockId

 $element->set_EditLockId($data);
 $element->get_EditLockId();




=item * ProvisionMemberRequestInfo

 $element->set_ProvisionMemberRequestInfo($data);
 $element->get_ProvisionMemberRequestInfo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetProvisionMember->new($data);

Constructor. The following data structure may be passed to new():

 {
   EditLockId => $some_value, # atomic
   ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
     Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
       ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
         CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
         CommentValue => $some_value, # CommentValue
       },
     },
     CreateNewVfiler =>  $some_value, # boolean
     DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
       DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
         CifsDomain =>  $some_value, # string
         DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
           DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission => $some_value, # CifsPermission
           },
         },
       },
       DatasetExportProtocol => $some_value, # DatasetExportProtocol
       DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
         IgroupOsType =>  $some_value, # string
         LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
       },
       DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsProtocolVersion =>  $some_value, # string
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
     },
     Description =>  $some_value, # string
     InitialSnapshotSpace => $some_value, # atomic
     MaximumDataSize => $some_value, # atomic
     MaximumSnapshotSpace => $some_value, # atomic
     Name =>  $some_value, # string
     OnlineMigration =>  $some_value, # boolean
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjFullName
     ResourceNameOrId => $some_value, # ObjNameOrId
     Size => $some_value, # atomic
     VfilerNameOrId => $some_value, # ObjNameOrId
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

