
package MyElements::DatasetSet;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DatasetSet');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %IsAllowCustomSettings_of :ATTR(:get<IsAllowCustomSettings>);
my %IsEnableWriteGuaranteeChecks_of :ATTR(:get<IsEnableWriteGuaranteeChecks>);
my %MaximumLunsPerVolume_of :ATTR(:get<MaximumLunsPerVolume>);
my %MaximumQtreesPerVolume_of :ATTR(:get<MaximumQtreesPerVolume>);

__PACKAGE__->_factory(
    [ qw(        DatasetNameOrId
        IsAllowCustomSettings
        IsEnableWriteGuaranteeChecks
        MaximumLunsPerVolume
        MaximumQtreesPerVolume

    ) ],
    {
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'IsAllowCustomSettings' => \%IsAllowCustomSettings_of,
        'IsEnableWriteGuaranteeChecks' => \%IsEnableWriteGuaranteeChecks_of,
        'MaximumLunsPerVolume' => \%MaximumLunsPerVolume_of,
        'MaximumQtreesPerVolume' => \%MaximumQtreesPerVolume_of,
    },
    {
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'IsAllowCustomSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsEnableWriteGuaranteeChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MaximumLunsPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MaximumQtreesPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'DatasetNameOrId' => 'DatasetNameOrId',
        'IsAllowCustomSettings' => 'IsAllowCustomSettings',
        'IsEnableWriteGuaranteeChecks' => 'IsEnableWriteGuaranteeChecks',
        'MaximumLunsPerVolume' => 'MaximumLunsPerVolume',
        'MaximumQtreesPerVolume' => 'MaximumQtreesPerVolume',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DatasetSet

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DatasetSet from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * IsAllowCustomSettings

 $element->set_IsAllowCustomSettings($data);
 $element->get_IsAllowCustomSettings();




=item * IsEnableWriteGuaranteeChecks

 $element->set_IsEnableWriteGuaranteeChecks($data);
 $element->get_IsEnableWriteGuaranteeChecks();




=item * MaximumLunsPerVolume

 $element->set_MaximumLunsPerVolume($data);
 $element->get_MaximumLunsPerVolume();




=item * MaximumQtreesPerVolume

 $element->set_MaximumQtreesPerVolume($data);
 $element->get_MaximumQtreesPerVolume();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DatasetSet->new($data);

Constructor. The following data structure may be passed to new():

 {
   DatasetNameOrId => $some_value, # ObjNameOrId
   IsAllowCustomSettings =>  $some_value, # boolean
   IsEnableWriteGuaranteeChecks =>  $some_value, # boolean
   MaximumLunsPerVolume =>  $some_value, # integer
   MaximumQtreesPerVolume =>  $some_value, # integer
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

