
package MyElements::DfmAboutResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmAboutResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CpuCount_of :ATTR(:get<CpuCount>);
my %DfmDirectories_of :ATTR(:get<DfmDirectories>);
my %HostName_of :ATTR(:get<HostName>);
my %InstallDir_of :ATTR(:get<InstallDir>);
my %InstalledPlugins_of :ATTR(:get<InstalledPlugins>);
my %LicensedFeatures_of :ATTR(:get<LicensedFeatures>);
my %NodeLimit_of :ATTR(:get<NodeLimit>);
my %OperatingSystem_of :ATTR(:get<OperatingSystem>);
my %ProtMgrNodeLimit_of :ATTR(:get<ProtMgrNodeLimit>);
my %ProvMgrNodeLimit_of :ATTR(:get<ProvMgrNodeLimit>);
my %SerialNumber_of :ATTR(:get<SerialNumber>);
my %SystemMemory_of :ATTR(:get<SystemMemory>);
my %SystemTime_of :ATTR(:get<SystemTime>);
my %Type_of :ATTR(:get<Type>);
my %Version_of :ATTR(:get<Version>);

__PACKAGE__->_factory(
    [ qw(        CpuCount
        DfmDirectories
        HostName
        InstallDir
        InstalledPlugins
        LicensedFeatures
        NodeLimit
        OperatingSystem
        ProtMgrNodeLimit
        ProvMgrNodeLimit
        SerialNumber
        SystemMemory
        SystemTime
        Type
        Version

    ) ],
    {
        'CpuCount' => \%CpuCount_of,
        'DfmDirectories' => \%DfmDirectories_of,
        'HostName' => \%HostName_of,
        'InstallDir' => \%InstallDir_of,
        'InstalledPlugins' => \%InstalledPlugins_of,
        'LicensedFeatures' => \%LicensedFeatures_of,
        'NodeLimit' => \%NodeLimit_of,
        'OperatingSystem' => \%OperatingSystem_of,
        'ProtMgrNodeLimit' => \%ProtMgrNodeLimit_of,
        'ProvMgrNodeLimit' => \%ProvMgrNodeLimit_of,
        'SerialNumber' => \%SerialNumber_of,
        'SystemMemory' => \%SystemMemory_of,
        'SystemTime' => \%SystemTime_of,
        'Type' => \%Type_of,
        'Version' => \%Version_of,
    },
    {
        'CpuCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DfmDirectories' => 'MyTypes::ArrayOfDirectoryInfo',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'InstallDir' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'InstalledPlugins' => 'MyTypes::ArrayOfPlugin',
        'LicensedFeatures' => 'MyTypes::ArrayOfFeature',
        'NodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OperatingSystem' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProtMgrNodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProvMgrNodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SerialNumber' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SystemMemory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SystemTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Version' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CpuCount' => 'CpuCount',
        'DfmDirectories' => 'DfmDirectories',
        'HostName' => 'HostName',
        'InstallDir' => 'InstallDir',
        'InstalledPlugins' => 'InstalledPlugins',
        'LicensedFeatures' => 'LicensedFeatures',
        'NodeLimit' => 'NodeLimit',
        'OperatingSystem' => 'OperatingSystem',
        'ProtMgrNodeLimit' => 'ProtMgrNodeLimit',
        'ProvMgrNodeLimit' => 'ProvMgrNodeLimit',
        'SerialNumber' => 'SerialNumber',
        'SystemMemory' => 'SystemMemory',
        'SystemTime' => 'SystemTime',
        'Type' => 'Type',
        'Version' => 'Version',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmAboutResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmAboutResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CpuCount

 $element->set_CpuCount($data);
 $element->get_CpuCount();




=item * DfmDirectories

 $element->set_DfmDirectories($data);
 $element->get_DfmDirectories();




=item * HostName

 $element->set_HostName($data);
 $element->get_HostName();




=item * InstallDir

 $element->set_InstallDir($data);
 $element->get_InstallDir();




=item * InstalledPlugins

 $element->set_InstalledPlugins($data);
 $element->get_InstalledPlugins();




=item * LicensedFeatures

 $element->set_LicensedFeatures($data);
 $element->get_LicensedFeatures();




=item * NodeLimit

 $element->set_NodeLimit($data);
 $element->get_NodeLimit();




=item * OperatingSystem

 $element->set_OperatingSystem($data);
 $element->get_OperatingSystem();




=item * ProtMgrNodeLimit

 $element->set_ProtMgrNodeLimit($data);
 $element->get_ProtMgrNodeLimit();




=item * ProvMgrNodeLimit

 $element->set_ProvMgrNodeLimit($data);
 $element->get_ProvMgrNodeLimit();




=item * SerialNumber

 $element->set_SerialNumber($data);
 $element->get_SerialNumber();




=item * SystemMemory

 $element->set_SystemMemory($data);
 $element->get_SystemMemory();




=item * SystemTime

 $element->set_SystemTime($data);
 $element->get_SystemTime();




=item * Type

 $element->set_Type($data);
 $element->get_Type();




=item * Version

 $element->set_Version($data);
 $element->get_Version();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmAboutResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   CpuCount =>  $some_value, # string
   DfmDirectories =>  { # MyTypes::ArrayOfDirectoryInfo
     DirectoryInfo =>  { # MyTypes::DirectoryInfo
       DiskFreeSpace => $some_value, # atomic
       DiskFreeSpacePercent =>  $some_value, # string
       FileCount => $some_value, # atomic
       Name =>  $some_value, # string
       Size => $some_value, # atomic
       Type =>  $some_value, # string
     },
   },
   HostName =>  $some_value, # string
   InstallDir =>  $some_value, # string
   InstalledPlugins =>  { # MyTypes::ArrayOfPlugin
     Plugin =>  { # MyTypes::Plugin
       PluginType =>  $some_value, # string
       ProductVersion =>  $some_value, # string
       SpecialBuild =>  $some_value, # string
     },
   },
   LicensedFeatures =>  { # MyTypes::ArrayOfFeature
     Feature =>  { # MyTypes::Feature
       IsLicenseExpired =>  $some_value, # boolean
       Name =>  $some_value, # string
       Summary =>  $some_value, # string
     },
   },
   NodeLimit =>  $some_value, # string
   OperatingSystem =>  $some_value, # string
   ProtMgrNodeLimit =>  $some_value, # string
   ProvMgrNodeLimit =>  $some_value, # string
   SerialNumber =>  $some_value, # string
   SystemMemory =>  $some_value, # string
   SystemTime =>  $some_value, # integer
   Type =>  $some_value, # string
   Version =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

