
package MyElements::DfmBackupScheduleGetResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmBackupScheduleGetResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupType_of :ATTR(:get<BackupType>);
my %Day_of :ATTR(:get<Day>);
my %Hour_of :ATTR(:get<Hour>);
my %IsScheduleEnabled_of :ATTR(:get<IsScheduleEnabled>);
my %Minute_of :ATTR(:get<Minute>);
my %RepeatInterval_of :ATTR(:get<RepeatInterval>);
my %ScheduleType_of :ATTR(:get<ScheduleType>);

__PACKAGE__->_factory(
    [ qw(        BackupType
        Day
        Hour
        IsScheduleEnabled
        Minute
        RepeatInterval
        ScheduleType

    ) ],
    {
        'BackupType' => \%BackupType_of,
        'Day' => \%Day_of,
        'Hour' => \%Hour_of,
        'IsScheduleEnabled' => \%IsScheduleEnabled_of,
        'Minute' => \%Minute_of,
        'RepeatInterval' => \%RepeatInterval_of,
        'ScheduleType' => \%ScheduleType_of,
    },
    {
        'BackupType' => 'MyTypes::BackupType',

        'Day' => 'MyElements::DfmBackupScheduleGetResult::_Day',

        'Hour' => 'MyElements::DfmBackupScheduleGetResult::_Hour',
        'IsScheduleEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'Minute' => 'MyElements::DfmBackupScheduleGetResult::_Minute',

        'RepeatInterval' => 'MyElements::DfmBackupScheduleGetResult::_RepeatInterval',
        'ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BackupType' => 'BackupType',
        'Day' => 'Day',
        'Hour' => 'Hour',
        'IsScheduleEnabled' => 'IsScheduleEnabled',
        'Minute' => 'Minute',
        'RepeatInterval' => 'RepeatInterval',
        'ScheduleType' => 'ScheduleType',
    }
);

} # end BLOCK




package MyElements::DfmBackupScheduleGetResult::_Day;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::DfmBackupScheduleGetResult::_Hour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::DfmBackupScheduleGetResult::_Minute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::DfmBackupScheduleGetResult::_RepeatInterval;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmBackupScheduleGetResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmBackupScheduleGetResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupType

 $element->set_BackupType($data);
 $element->get_BackupType();




=item * Day

 $element->set_Day($data);
 $element->get_Day();




=item * Hour

 $element->set_Hour($data);
 $element->get_Hour();




=item * IsScheduleEnabled

 $element->set_IsScheduleEnabled($data);
 $element->get_IsScheduleEnabled();




=item * Minute

 $element->set_Minute($data);
 $element->get_Minute();




=item * RepeatInterval

 $element->set_RepeatInterval($data);
 $element->get_RepeatInterval();




=item * ScheduleType

 $element->set_ScheduleType($data);
 $element->get_ScheduleType();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmBackupScheduleGetResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupType => $some_value, # BackupType
   Day => $some_value, # atomic
   Hour => $some_value, # atomic
   IsScheduleEnabled =>  $some_value, # boolean
   Minute => $some_value, # atomic
   RepeatInterval => $some_value, # atomic
   ScheduleType =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

