
package MyElements::DfmRelatedObjectsListInfoResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmRelatedObjectsListInfoResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ChildCountList_of :ATTR(:get<ChildCountList>);
my %ParentDatasetList_of :ATTR(:get<ParentDatasetList>);
my %ParentGroupList_of :ATTR(:get<ParentGroupList>);
my %ParentObjectList_of :ATTR(:get<ParentObjectList>);
my %ParentResourcepoolList_of :ATTR(:get<ParentResourcepoolList>);

__PACKAGE__->_factory(
    [ qw(        ChildCountList
        ParentDatasetList
        ParentGroupList
        ParentObjectList
        ParentResourcepoolList

    ) ],
    {
        'ChildCountList' => \%ChildCountList_of,
        'ParentDatasetList' => \%ParentDatasetList_of,
        'ParentGroupList' => \%ParentGroupList_of,
        'ParentObjectList' => \%ParentObjectList_of,
        'ParentResourcepoolList' => \%ParentResourcepoolList_of,
    },
    {
        'ChildCountList' => 'MyTypes::ArrayOfChildCount',
        'ParentDatasetList' => 'MyTypes::ArrayOfParentDataset',
        'ParentGroupList' => 'MyTypes::ArrayOfParentGroup',
        'ParentObjectList' => 'MyTypes::ArrayOfParentObject',
        'ParentResourcepoolList' => 'MyTypes::ArrayOfParentResourcepool',
    },
    {

        'ChildCountList' => 'ChildCountList',
        'ParentDatasetList' => 'ParentDatasetList',
        'ParentGroupList' => 'ParentGroupList',
        'ParentObjectList' => 'ParentObjectList',
        'ParentResourcepoolList' => 'ParentResourcepoolList',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmRelatedObjectsListInfoResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmRelatedObjectsListInfoResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ChildCountList

 $element->set_ChildCountList($data);
 $element->get_ChildCountList();




=item * ParentDatasetList

 $element->set_ParentDatasetList($data);
 $element->get_ParentDatasetList();




=item * ParentGroupList

 $element->set_ParentGroupList($data);
 $element->get_ParentGroupList();




=item * ParentObjectList

 $element->set_ParentObjectList($data);
 $element->get_ParentObjectList();




=item * ParentResourcepoolList

 $element->set_ParentResourcepoolList($data);
 $element->get_ParentResourcepoolList();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmRelatedObjectsListInfoResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   ChildCountList =>  { # MyTypes::ArrayOfChildCount
     ChildCount =>  { # MyTypes::ChildCount
       Count => $some_value, # atomic
       Type =>  $some_value, # string
     },
   },
   ParentDatasetList =>  { # MyTypes::ArrayOfParentDataset
     ParentDataset =>  { # MyTypes::ParentDataset
       Id => $some_value, # ObjId
       Name => $some_value, # ObjName
     },
   },
   ParentGroupList =>  { # MyTypes::ArrayOfParentGroup
     ParentGroup =>  { # MyTypes::ParentGroup
       FullName => $some_value, # ObjFullName
       Id => $some_value, # ObjId
       Name => $some_value, # ObjName
     },
   },
   ParentObjectList =>  { # MyTypes::ArrayOfParentObject
     ParentObject =>  { # MyTypes::ParentObject
       FullName => $some_value, # ObjFullName
       Id => $some_value, # ObjId
       Name => $some_value, # ObjName
       Type =>  $some_value, # string
     },
   },
   ParentResourcepoolList =>  { # MyTypes::ArrayOfParentResourcepool
     ParentResourcepool =>  { # MyTypes::ParentResourcepool
       Id => $some_value, # ObjId
       Name => $some_value, # ObjName
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

