
package MyElements::DfmScheduleDailyAdd;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmScheduleDailyAdd');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DailyContent_of :ATTR(:get<DailyContent>);
my %DailyScheduleNameOrId_of :ATTR(:get<DailyScheduleNameOrId>);
my %ScheduleCategory_of :ATTR(:get<ScheduleCategory>);

__PACKAGE__->_factory(
    [ qw(        DailyContent
        DailyScheduleNameOrId
        ScheduleCategory

    ) ],
    {
        'DailyContent' => \%DailyContent_of,
        'DailyScheduleNameOrId' => \%DailyScheduleNameOrId_of,
        'ScheduleCategory' => \%ScheduleCategory_of,
    },
    {
        'DailyContent' => 'MyTypes::WrapperOfDailyInfo',
        'DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
        'ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DailyContent' => 'DailyContent',
        'DailyScheduleNameOrId' => 'DailyScheduleNameOrId',
        'ScheduleCategory' => 'ScheduleCategory',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmScheduleDailyAdd

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmScheduleDailyAdd from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DailyContent

 $element->set_DailyContent($data);
 $element->get_DailyContent();




=item * DailyScheduleNameOrId

 $element->set_DailyScheduleNameOrId($data);
 $element->get_DailyScheduleNameOrId();




=item * ScheduleCategory

 $element->set_ScheduleCategory($data);
 $element->get_ScheduleCategory();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmScheduleDailyAdd->new($data);

Constructor. The following data structure may be passed to new():

 {
   DailyContent =>  { # MyTypes::WrapperOfDailyInfo
     DailyInfo =>  { # MyTypes::DailyInfo
       ItemId => $some_value, # atomic
       StartHour => $some_value, # atomic
       StartMinute => $some_value, # atomic
     },
   },
   DailyScheduleNameOrId => $some_value, # ObjNameOrId
   ScheduleCategory =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

