
package MyElements::DfmScheduleListInfoIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmScheduleListInfoIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Records_of :ATTR(:get<Records>);
my %ScheduleContentList_of :ATTR(:get<ScheduleContentList>);

__PACKAGE__->_factory(
    [ qw(        Records
        ScheduleContentList

    ) ],
    {
        'Records' => \%Records_of,
        'ScheduleContentList' => \%ScheduleContentList_of,
    },
    {
        'Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ScheduleContentList' => 'MyTypes::ArrayOfScheduleContentInfo',
    },
    {

        'Records' => 'Records',
        'ScheduleContentList' => 'ScheduleContentList',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmScheduleListInfoIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmScheduleListInfoIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Records

 $element->set_Records($data);
 $element->get_Records();




=item * ScheduleContentList

 $element->set_ScheduleContentList($data);
 $element->get_ScheduleContentList();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmScheduleListInfoIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   Records =>  $some_value, # integer
   ScheduleContentList =>  { # MyTypes::ArrayOfScheduleContentInfo
     ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
       DailyList =>  { # MyTypes::ArrayOfDailyInfo
         DailyInfo =>  { # MyTypes::DailyInfo
           ItemId => $some_value, # atomic
           StartHour => $some_value, # atomic
           StartMinute => $some_value, # atomic
         },
       },
       HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
         HourlyInfo =>  { # MyTypes::HourlyInfo
           EndHour => $some_value, # atomic
           EndMinute => $some_value, # atomic
           Frequency => $some_value, # atomic
           ItemId => $some_value, # atomic
           StartHour => $some_value, # atomic
           StartMinute => $some_value, # atomic
         },
       },
       IsModifiable =>  $some_value, # boolean
       MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
         MonthlyInfo =>  { # MyTypes::MonthlyInfo
           DayOfMonth => $some_value, # atomic
           DayOfWeek => $some_value, # atomic
           ItemId => $some_value, # atomic
           StartHour => $some_value, # atomic
           StartMinute => $some_value, # atomic
           WeekOfMonth => $some_value, # atomic
         },
       },
       MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
         MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
           SubscheduleId => $some_value, # ObjId
           SubscheduleName => $some_value, # ObjName
         },
       },
       ScheduleCategory =>  $some_value, # string
       ScheduleDescription =>  $some_value, # string
       ScheduleId => $some_value, # ObjId
       ScheduleName => $some_value, # ObjName
       ScheduleType =>  $some_value, # string
       WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
         WeeklyInfo =>  { # MyTypes::WeeklyInfo
           DayOfWeek => $some_value, # atomic
           ItemId => $some_value, # atomic
           StartHour => $some_value, # atomic
           StartMinute => $some_value, # atomic
         },
       },
       WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
         WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
           EndDayOfWeek => $some_value, # atomic
           ItemId => $some_value, # atomic
           StartDayOfWeek => $some_value, # atomic
           SubscheduleId => $some_value, # ObjId
           SubscheduleName => $some_value, # ObjName
         },
       },
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

