
package MyElements::DfmSnmpSettingAdd;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DfmSnmpSettingAdd');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %NetworkAddress_of :ATTR(:get<NetworkAddress>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);
my %PrivacyPassword_of :ATTR(:get<PrivacyPassword>);
my %SnmpAuthenticationLogin_of :ATTR(:get<SnmpAuthenticationLogin>);
my %SnmpAuthenticationPassword_of :ATTR(:get<SnmpAuthenticationPassword>);
my %SnmpAuthenticationProtocol_of :ATTR(:get<SnmpAuthenticationProtocol>);
my %SnmpCommunityName_of :ATTR(:get<SnmpCommunityName>);
my %SnmpVersion_of :ATTR(:get<SnmpVersion>);

__PACKAGE__->_factory(
    [ qw(        NetworkAddress
        PrefixLength
        PrivacyPassword
        SnmpAuthenticationLogin
        SnmpAuthenticationPassword
        SnmpAuthenticationProtocol
        SnmpCommunityName
        SnmpVersion

    ) ],
    {
        'NetworkAddress' => \%NetworkAddress_of,
        'PrefixLength' => \%PrefixLength_of,
        'PrivacyPassword' => \%PrivacyPassword_of,
        'SnmpAuthenticationLogin' => \%SnmpAuthenticationLogin_of,
        'SnmpAuthenticationPassword' => \%SnmpAuthenticationPassword_of,
        'SnmpAuthenticationProtocol' => \%SnmpAuthenticationProtocol_of,
        'SnmpCommunityName' => \%SnmpCommunityName_of,
        'SnmpVersion' => \%SnmpVersion_of,
    },
    {
        'NetworkAddress' => 'MyTypes::NetworkAddress',
        'PrefixLength' => 'MyTypes::PrefixLength',
        'PrivacyPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpAuthenticationLogin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpAuthenticationPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpAuthenticationProtocol' => 'MyTypes::SnmpAuthenticationProtocol',
        'SnmpCommunityName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpVersion' => 'MyTypes::SnmpVersion',
    },
    {

        'NetworkAddress' => 'NetworkAddress',
        'PrefixLength' => 'PrefixLength',
        'PrivacyPassword' => 'PrivacyPassword',
        'SnmpAuthenticationLogin' => 'SnmpAuthenticationLogin',
        'SnmpAuthenticationPassword' => 'SnmpAuthenticationPassword',
        'SnmpAuthenticationProtocol' => 'SnmpAuthenticationProtocol',
        'SnmpCommunityName' => 'SnmpCommunityName',
        'SnmpVersion' => 'SnmpVersion',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DfmSnmpSettingAdd

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DfmSnmpSettingAdd from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * NetworkAddress

 $element->set_NetworkAddress($data);
 $element->get_NetworkAddress();




=item * PrefixLength

 $element->set_PrefixLength($data);
 $element->get_PrefixLength();




=item * PrivacyPassword

 $element->set_PrivacyPassword($data);
 $element->get_PrivacyPassword();




=item * SnmpAuthenticationLogin

 $element->set_SnmpAuthenticationLogin($data);
 $element->get_SnmpAuthenticationLogin();




=item * SnmpAuthenticationPassword

 $element->set_SnmpAuthenticationPassword($data);
 $element->get_SnmpAuthenticationPassword();




=item * SnmpAuthenticationProtocol

 $element->set_SnmpAuthenticationProtocol($data);
 $element->get_SnmpAuthenticationProtocol();




=item * SnmpCommunityName

 $element->set_SnmpCommunityName($data);
 $element->get_SnmpCommunityName();




=item * SnmpVersion

 $element->set_SnmpVersion($data);
 $element->get_SnmpVersion();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DfmSnmpSettingAdd->new($data);

Constructor. The following data structure may be passed to new():

 {
   NetworkAddress => $some_value, # NetworkAddress
   PrefixLength => $some_value, # PrefixLength
   PrivacyPassword =>  $some_value, # string
   SnmpAuthenticationLogin =>  $some_value, # string
   SnmpAuthenticationPassword =>  $some_value, # string
   SnmpAuthenticationProtocol => $some_value, # SnmpAuthenticationProtocol
   SnmpCommunityName =>  $some_value, # string
   SnmpVersion => $some_value, # SnmpVersion
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

