
package MyElements::DpAgentConfigure;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpAgentConfigure');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DfmServerIpAddress_of :ATTR(:get<DfmServerIpAddress>);
my %DpAgentNameOrId_of :ATTR(:get<DpAgentNameOrId>);
my %StorageSystemsConfiguration_of :ATTR(:get<StorageSystemsConfiguration>);
my %VcenterIpAddress_of :ATTR(:get<VcenterIpAddress>);
my %VcenterPassword_of :ATTR(:get<VcenterPassword>);
my %VcenterUsername_of :ATTR(:get<VcenterUsername>);

__PACKAGE__->_factory(
    [ qw(        DfmServerIpAddress
        DpAgentNameOrId
        StorageSystemsConfiguration
        VcenterIpAddress
        VcenterPassword
        VcenterUsername

    ) ],
    {
        'DfmServerIpAddress' => \%DfmServerIpAddress_of,
        'DpAgentNameOrId' => \%DpAgentNameOrId_of,
        'StorageSystemsConfiguration' => \%StorageSystemsConfiguration_of,
        'VcenterIpAddress' => \%VcenterIpAddress_of,
        'VcenterPassword' => \%VcenterPassword_of,
        'VcenterUsername' => \%VcenterUsername_of,
    },
    {
        'DfmServerIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpAgentNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageSystemsConfiguration' => 'MyTypes::ArrayOfStorageSystemConfiguration',
        'VcenterIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VcenterPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VcenterUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DfmServerIpAddress' => 'DfmServerIpAddress',
        'DpAgentNameOrId' => 'DpAgentNameOrId',
        'StorageSystemsConfiguration' => 'StorageSystemsConfiguration',
        'VcenterIpAddress' => 'VcenterIpAddress',
        'VcenterPassword' => 'VcenterPassword',
        'VcenterUsername' => 'VcenterUsername',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpAgentConfigure

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpAgentConfigure from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DfmServerIpAddress

 $element->set_DfmServerIpAddress($data);
 $element->get_DfmServerIpAddress();




=item * DpAgentNameOrId

 $element->set_DpAgentNameOrId($data);
 $element->get_DpAgentNameOrId();




=item * StorageSystemsConfiguration

 $element->set_StorageSystemsConfiguration($data);
 $element->get_StorageSystemsConfiguration();




=item * VcenterIpAddress

 $element->set_VcenterIpAddress($data);
 $element->get_VcenterIpAddress();




=item * VcenterPassword

 $element->set_VcenterPassword($data);
 $element->get_VcenterPassword();




=item * VcenterUsername

 $element->set_VcenterUsername($data);
 $element->get_VcenterUsername();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpAgentConfigure->new($data);

Constructor. The following data structure may be passed to new():

 {
   DfmServerIpAddress =>  $some_value, # string
   DpAgentNameOrId => $some_value, # ObjNameOrId
   StorageSystemsConfiguration =>  { # MyTypes::ArrayOfStorageSystemConfiguration
     StorageSystemConfiguration =>  { # MyTypes::StorageSystemConfiguration
       LoginProtocol =>  $some_value, # string
       PushCredentials =>  $some_value, # boolean
       StorageSystemNameOrId => $some_value, # ObjNameOrId
     },
   },
   VcenterIpAddress =>  $some_value, # string
   VcenterPassword =>  $some_value, # string
   VcenterUsername =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

