
package MyElements::DpBackupGetLocation;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupGetLocation');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %Paths_of :ATTR(:get<Paths>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupVersion
        DatasetNameOrId
        Paths

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'Paths' => \%Paths_of,
    },
    {

        'BackupId' => 'MyElements::DpBackupGetLocation::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'Paths' => 'MyTypes::ArrayOfDpBackupPathInfo',
    },
    {

        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'Paths' => 'Paths',
    }
);

} # end BLOCK




package MyElements::DpBackupGetLocation::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupGetLocation

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupGetLocation from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * Paths

 $element->set_Paths($data);
 $element->get_Paths();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupGetLocation->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   DatasetNameOrId => $some_value, # ObjNameOrId
   Paths =>  { # MyTypes::ArrayOfDpBackupPathInfo
     DpBackupPathInfo =>  { # MyTypes::DpBackupPathInfo
       MemberId => $some_value, # ObjId
       MemberName => $some_value, # ObjName
       Path =>  $some_value, # string
       PrimarySnapshotName =>  $some_value, # string
       PrimarySnapshotUniqueId =>  $some_value, # string
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

