
package MyElements::DpBackupListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Backups_of :ATTR(:get<Backups>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        Backups
        Records

    ) ],
    {
        'Backups' => \%Backups_of,
        'Records' => \%Records_of,
    },
    {
        'Backups' => 'MyTypes::ArrayOfDpBackupInfo',

        'Records' => 'MyElements::DpBackupListIterNextResult::_Records',
    },
    {

        'Backups' => 'Backups',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::DpBackupListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Backups

 $element->set_Backups($data);
 $element->get_Backups();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   Backups =>  { # MyTypes::ArrayOfDpBackupInfo
     DpBackupInfo =>  { # MyTypes::DpBackupInfo
       ApplicationBackupInfos =>  { # MyTypes::ArrayOfApplicationBackupInfo
         ApplicationBackupInfo =>  { # MyTypes::ApplicationBackupInfo
           ApplicationBackupProperties =>  { # MyTypes::ArrayOfPropertyInfo
             PropertyInfo =>  { # MyTypes::PropertyInfo
               PropertyName =>  $some_value, # string
               PropertyValue =>  $some_value, # string
             },
           },
           ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
           BackupGraphInfo =>  { # MyTypes::BackupGraphInfo
             GraphEdges =>  { # MyTypes::ArrayOfBackupGraphEdgeInfo
               BackupGraphEdgeInfo =>  { # MyTypes::BackupGraphEdgeInfo
                 FromResourceId => $some_value, # ObjId
                 ToResourceId => $some_value, # ObjId
               },
             },
             GraphResources =>  { # MyTypes::ArrayOfBackupGraphResourceInfo
               BackupGraphResourceInfo =>  { # MyTypes::BackupGraphResourceInfo
                 ApplicationResourceProperties =>  { # MyTypes::ArrayOfPropertyInfo
                   PropertyInfo =>  { # MyTypes::PropertyInfo
                     PropertyName =>  $some_value, # string
                     PropertyValue =>  $some_value, # string
                   },
                 },
                 HostServiceObjectId => $some_value, # HostServiceUniqueId
                 IsRestorable =>  $some_value, # boolean
                 ObjectId => $some_value, # ObjId
                 ObjectName => $some_value, # ObjName
                 ObjectNameWhenBackedUp => $some_value, # ObjName
                 ResourceType => $some_value, # ApplicationObjectType
                 Snapshots =>  { # MyTypes::ArrayOfSnapshotMemberInfo
                   SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
                     PrimaryId => $some_value, # ObjId
                     PrimaryName => $some_value, # ObjName
                     PrimarySnapshotHostServiceId =>  $some_value, # string
                     PrimarySnapshotName =>  $some_value, # string
                     PrimarySnapshotUniqueId =>  $some_value, # string
                     SecondaryQtreeId => $some_value, # ObjId
                     SecondaryQtreeName =>  $some_value, # string
                     SecondaryQtreeNameOrId =>  $some_value, # string
                   },
                 },
               },
             },
           },
           HostServiceBackupId => $some_value, # HostServiceUniqueId
           HostServiceId => $some_value, # ObjId
         },
       },
       BackupDescription =>  $some_value, # string
       BackupId => $some_value, # atomic
       BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
         DfmMetadata =>  { # MyTypes::DfmMetadata
           FieldName =>  $some_value, # string
           FieldValue =>  $some_value, # string
         },
       },
       BackupTransferInfos =>  { # MyTypes::ArrayOfDpBackupTransferInfo
         DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
           BackupTransferNeeded =>  $some_value, # boolean
           BackupTransferStatus =>  $some_value, # string
           ConnectionType =>  $some_value, # string
           DestinationBackupId => $some_value, # atomic
           DestinationNodeId => $some_value, # atomic
           DestinationNodeName =>  $some_value, # string
           DestinationStoragesetId => $some_value, # atomic
           JobId =>  $some_value, # integer
           SourceBackupId => $some_value, # atomic
           SourceNodeId => $some_value, # atomic
           SourceNodeName =>  $some_value, # string
           SourceStoragesetId => $some_value, # atomic
         },
       },
       BackupTransferStatus =>  $some_value, # string
       BackupVersion => $some_value, # DpTimestamp
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       IsAddingMembers =>  $some_value, # boolean
       IsBackupDestinationNode =>  $some_value, # boolean
       IsForPropagation =>  $some_value, # boolean
       IsMirrorDestinationNode =>  $some_value, # boolean
       NodeId =>  $some_value, # integer
       NodeName =>  $some_value, # string
       RetentionDuration => $some_value, # atomic
       RetentionType => $some_value, # DpBackupRetentionType
       SupportsNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
       VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
         VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
           HostAddress => $some_value, # IpAddress
           HostFqdn =>  $some_value, # string
           HostId => $some_value, # ObjId
           IsAvailable =>  $some_value, # boolean
           SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
             SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
               PrimaryId => $some_value, # ObjId
               PrimaryName => $some_value, # ObjName
               PrimarySnapshotHostServiceId =>  $some_value, # string
               PrimarySnapshotName =>  $some_value, # string
               PrimarySnapshotUniqueId =>  $some_value, # string
               SecondaryQtreeId => $some_value, # ObjId
               SecondaryQtreeName =>  $some_value, # string
               SecondaryQtreeNameOrId =>  $some_value, # string
             },
           },
           SnapshotName =>  $some_value, # string
           SnapshotUniqueId =>  $some_value, # string
           VolumeId => $some_value, # ObjId
           VolumeName => $some_value, # ObjName
         },
       },
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

