
package MyElements::DpBackupListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationResourceNamespace_of :ATTR(:get<ApplicationResourceNamespace>);
my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %HasApplicationResourcesOnly_of :ATTR(:get<HasApplicationResourcesOnly>);
my %HasStorageResourcesOnly_of :ATTR(:get<HasStorageResourcesOnly>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IncludeMetadata_of :ATTR(:get<IncludeMetadata>);
my %IncludeMetadataHostService_of :ATTR(:get<IncludeMetadataHostService>);
my %IsRootObjectRestorable_of :ATTR(:get<IsRootObjectRestorable>);
my %RootObjectNameOrId_of :ATTR(:get<RootObjectNameOrId>);
my %SearchKeys_of :ATTR(:get<SearchKeys>);
my %SnapshotUniqueId_of :ATTR(:get<SnapshotUniqueId>);
my %SubPath_of :ATTR(:get<SubPath>);
my %VolumeId_of :ATTR(:get<VolumeId>);

__PACKAGE__->_factory(
    [ qw(        ApplicationResourceNamespace
        BackupId
        BackupVersion
        DatasetNameOrId
        HasApplicationResourcesOnly
        HasStorageResourcesOnly
        IncludeIsAvailable
        IncludeMetadata
        IncludeMetadataHostService
        IsRootObjectRestorable
        RootObjectNameOrId
        SearchKeys
        SnapshotUniqueId
        SubPath
        VolumeId

    ) ],
    {
        'ApplicationResourceNamespace' => \%ApplicationResourceNamespace_of,
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'HasApplicationResourcesOnly' => \%HasApplicationResourcesOnly_of,
        'HasStorageResourcesOnly' => \%HasStorageResourcesOnly_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IncludeMetadata' => \%IncludeMetadata_of,
        'IncludeMetadataHostService' => \%IncludeMetadataHostService_of,
        'IsRootObjectRestorable' => \%IsRootObjectRestorable_of,
        'RootObjectNameOrId' => \%RootObjectNameOrId_of,
        'SearchKeys' => \%SearchKeys_of,
        'SnapshotUniqueId' => \%SnapshotUniqueId_of,
        'SubPath' => \%SubPath_of,
        'VolumeId' => \%VolumeId_of,
    },
    {
        'ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',

        'BackupId' => 'MyElements::DpBackupListIterStart::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'HasApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HasStorageResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMetadataHostService' => 'MyTypes::ObjNameOrId',
        'IsRootObjectRestorable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'RootObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'SearchKeys' => 'MyTypes::ArrayOfSearchKey',
        'SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SubPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeId' => 'MyTypes::ObjId',
    },
    {

        'ApplicationResourceNamespace' => 'ApplicationResourceNamespace',
        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'HasApplicationResourcesOnly' => 'HasApplicationResourcesOnly',
        'HasStorageResourcesOnly' => 'HasStorageResourcesOnly',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IncludeMetadata' => 'IncludeMetadata',
        'IncludeMetadataHostService' => 'IncludeMetadataHostService',
        'IsRootObjectRestorable' => 'IsRootObjectRestorable',
        'RootObjectNameOrId' => 'RootObjectNameOrId',
        'SearchKeys' => 'SearchKeys',
        'SnapshotUniqueId' => 'SnapshotUniqueId',
        'SubPath' => 'SubPath',
        'VolumeId' => 'VolumeId',
    }
);

} # end BLOCK




package MyElements::DpBackupListIterStart::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationResourceNamespace

 $element->set_ApplicationResourceNamespace($data);
 $element->get_ApplicationResourceNamespace();




=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * HasApplicationResourcesOnly

 $element->set_HasApplicationResourcesOnly($data);
 $element->get_HasApplicationResourcesOnly();




=item * HasStorageResourcesOnly

 $element->set_HasStorageResourcesOnly($data);
 $element->get_HasStorageResourcesOnly();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IncludeMetadata

 $element->set_IncludeMetadata($data);
 $element->get_IncludeMetadata();




=item * IncludeMetadataHostService

 $element->set_IncludeMetadataHostService($data);
 $element->get_IncludeMetadataHostService();




=item * IsRootObjectRestorable

 $element->set_IsRootObjectRestorable($data);
 $element->get_IsRootObjectRestorable();




=item * RootObjectNameOrId

 $element->set_RootObjectNameOrId($data);
 $element->get_RootObjectNameOrId();




=item * SearchKeys

 $element->set_SearchKeys($data);
 $element->get_SearchKeys();




=item * SnapshotUniqueId

 $element->set_SnapshotUniqueId($data);
 $element->get_SnapshotUniqueId();




=item * SubPath

 $element->set_SubPath($data);
 $element->get_SubPath();




=item * VolumeId

 $element->set_VolumeId($data);
 $element->get_VolumeId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   DatasetNameOrId => $some_value, # ObjNameOrId
   HasApplicationResourcesOnly =>  $some_value, # boolean
   HasStorageResourcesOnly =>  $some_value, # boolean
   IncludeIsAvailable =>  $some_value, # boolean
   IncludeMetadata =>  $some_value, # boolean
   IncludeMetadataHostService => $some_value, # ObjNameOrId
   IsRootObjectRestorable =>  $some_value, # boolean
   RootObjectNameOrId => $some_value, # ObjNameOrId
   SearchKeys =>  { # MyTypes::ArrayOfSearchKey
     SearchKey => $some_value, # SearchKey
   },
   SnapshotUniqueId =>  $some_value, # string
   SubPath =>  $some_value, # string
   VolumeId => $some_value, # ObjId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

