
package MyElements::DpBackupStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupDescription_of :ATTR(:get<BackupDescription>);
my %BackupDestination_of :ATTR(:get<BackupDestination>);
my %BackupDestinationNameOrId_of :ATTR(:get<BackupDestinationNameOrId>);
my %BackupMembers_of :ATTR(:get<BackupMembers>);
my %BackupScript_of :ATTR(:get<BackupScript>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %HypervBackupSettingsInfo_of :ATTR(:get<HypervBackupSettingsInfo>);
my %RetentionDuration_of :ATTR(:get<RetentionDuration>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %VmwareBackupSettingsInfo_of :ATTR(:get<VmwareBackupSettingsInfo>);

__PACKAGE__->_factory(
    [ qw(        BackupDescription
        BackupDestination
        BackupDestinationNameOrId
        BackupMembers
        BackupScript
        DatasetNameOrId
        HypervBackupSettingsInfo
        RetentionDuration
        RetentionType
        VmwareBackupSettingsInfo

    ) ],
    {
        'BackupDescription' => \%BackupDescription_of,
        'BackupDestination' => \%BackupDestination_of,
        'BackupDestinationNameOrId' => \%BackupDestinationNameOrId_of,
        'BackupMembers' => \%BackupMembers_of,
        'BackupScript' => \%BackupScript_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'HypervBackupSettingsInfo' => \%HypervBackupSettingsInfo_of,
        'RetentionDuration' => \%RetentionDuration_of,
        'RetentionType' => \%RetentionType_of,
        'VmwareBackupSettingsInfo' => \%VmwareBackupSettingsInfo_of,
    },
    {
        'BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupDestination' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupDestinationNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupMembers' => 'MyTypes::ArrayOfObjNameOrId',
        'BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'HypervBackupSettingsInfo' => 'MyTypes::WrapperOfHypervBackupScheduleSettingsInfo',

        'RetentionDuration' => 'MyElements::DpBackupStart::_RetentionDuration',
        'RetentionType' => 'MyTypes::DpBackupRetentionType',
        'VmwareBackupSettingsInfo' => 'MyTypes::WrapperOfVmwareBackupScheduleSettingsInfo',
    },
    {

        'BackupDescription' => 'BackupDescription',
        'BackupDestination' => 'BackupDestination',
        'BackupDestinationNameOrId' => 'BackupDestinationNameOrId',
        'BackupMembers' => 'BackupMembers',
        'BackupScript' => 'BackupScript',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'HypervBackupSettingsInfo' => 'HypervBackupSettingsInfo',
        'RetentionDuration' => 'RetentionDuration',
        'RetentionType' => 'RetentionType',
        'VmwareBackupSettingsInfo' => 'VmwareBackupSettingsInfo',
    }
);

} # end BLOCK




package MyElements::DpBackupStart::_RetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupDescription

 $element->set_BackupDescription($data);
 $element->get_BackupDescription();




=item * BackupDestination

 $element->set_BackupDestination($data);
 $element->get_BackupDestination();




=item * BackupDestinationNameOrId

 $element->set_BackupDestinationNameOrId($data);
 $element->get_BackupDestinationNameOrId();




=item * BackupMembers

 $element->set_BackupMembers($data);
 $element->get_BackupMembers();




=item * BackupScript

 $element->set_BackupScript($data);
 $element->get_BackupScript();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * HypervBackupSettingsInfo

 $element->set_HypervBackupSettingsInfo($data);
 $element->get_HypervBackupSettingsInfo();




=item * RetentionDuration

 $element->set_RetentionDuration($data);
 $element->get_RetentionDuration();




=item * RetentionType

 $element->set_RetentionType($data);
 $element->get_RetentionType();




=item * VmwareBackupSettingsInfo

 $element->set_VmwareBackupSettingsInfo($data);
 $element->get_VmwareBackupSettingsInfo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupDescription =>  $some_value, # string
   BackupDestination =>  $some_value, # string
   BackupDestinationNameOrId =>  $some_value, # string
   BackupMembers =>  { # MyTypes::ArrayOfObjNameOrId
     ObjNameOrId => $some_value, # ObjNameOrId
   },
   BackupScript =>  $some_value, # string
   DatasetNameOrId => $some_value, # ObjNameOrId
   HypervBackupSettingsInfo =>  { # MyTypes::WrapperOfHypervBackupScheduleSettingsInfo
     HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
       AllowSavedStateBackup =>  $some_value, # boolean
     },
   },
   RetentionDuration => $some_value, # atomic
   RetentionType => $some_value, # DpBackupRetentionType
   VmwareBackupSettingsInfo =>  { # MyTypes::WrapperOfVmwareBackupScheduleSettingsInfo
     VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
       CreateVmwareSnapshot =>  $some_value, # boolean
       IncludeIndependentDisks =>  $some_value, # boolean
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

