
package MyElements::DpBackupVersionCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupVersionCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupDescription_of :ATTR(:get<BackupDescription>);
my %BackupMetadata_of :ATTR(:get<BackupMetadata>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %IsAddingMembers_of :ATTR(:get<IsAddingMembers>);
my %IsComplete_of :ATTR(:get<IsComplete>);
my %IsForPropagation_of :ATTR(:get<IsForPropagation>);
my %IsNative_of :ATTR(:get<IsNative>);
my %JobId_of :ATTR(:get<JobId>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %StoragesetId_of :ATTR(:get<StoragesetId>);
my %VersionMembers_of :ATTR(:get<VersionMembers>);
my %VersionTimestamp_of :ATTR(:get<VersionTimestamp>);

__PACKAGE__->_factory(
    [ qw(        BackupDescription
        BackupMetadata
        DatasetNameOrId
        IsAddingMembers
        IsComplete
        IsForPropagation
        IsNative
        JobId
        RetentionType
        StoragesetId
        VersionMembers
        VersionTimestamp

    ) ],
    {
        'BackupDescription' => \%BackupDescription_of,
        'BackupMetadata' => \%BackupMetadata_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'IsAddingMembers' => \%IsAddingMembers_of,
        'IsComplete' => \%IsComplete_of,
        'IsForPropagation' => \%IsForPropagation_of,
        'IsNative' => \%IsNative_of,
        'JobId' => \%JobId_of,
        'RetentionType' => \%RetentionType_of,
        'StoragesetId' => \%StoragesetId_of,
        'VersionMembers' => \%VersionMembers_of,
        'VersionTimestamp' => \%VersionTimestamp_of,
    },
    {
        'BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsComplete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsForPropagation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsNative' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'RetentionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StoragesetId' => 'MyTypes::ObjId',
        'VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
        'VersionTimestamp' => 'MyTypes::DpTimestamp',
    },
    {

        'BackupDescription' => 'BackupDescription',
        'BackupMetadata' => 'BackupMetadata',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'IsAddingMembers' => 'IsAddingMembers',
        'IsComplete' => 'IsComplete',
        'IsForPropagation' => 'IsForPropagation',
        'IsNative' => 'IsNative',
        'JobId' => 'JobId',
        'RetentionType' => 'RetentionType',
        'StoragesetId' => 'StoragesetId',
        'VersionMembers' => 'VersionMembers',
        'VersionTimestamp' => 'VersionTimestamp',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupVersionCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupVersionCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupDescription

 $element->set_BackupDescription($data);
 $element->get_BackupDescription();




=item * BackupMetadata

 $element->set_BackupMetadata($data);
 $element->get_BackupMetadata();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * IsAddingMembers

 $element->set_IsAddingMembers($data);
 $element->get_IsAddingMembers();




=item * IsComplete

 $element->set_IsComplete($data);
 $element->get_IsComplete();




=item * IsForPropagation

 $element->set_IsForPropagation($data);
 $element->get_IsForPropagation();




=item * IsNative

 $element->set_IsNative($data);
 $element->get_IsNative();




=item * JobId

 $element->set_JobId($data);
 $element->get_JobId();




=item * RetentionType

 $element->set_RetentionType($data);
 $element->get_RetentionType();




=item * StoragesetId

 $element->set_StoragesetId($data);
 $element->get_StoragesetId();




=item * VersionMembers

 $element->set_VersionMembers($data);
 $element->get_VersionMembers();




=item * VersionTimestamp

 $element->set_VersionTimestamp($data);
 $element->get_VersionTimestamp();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupVersionCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupDescription =>  $some_value, # string
   BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
     DfmMetadata =>  { # MyTypes::DfmMetadata
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   DatasetNameOrId => $some_value, # ObjNameOrId
   IsAddingMembers =>  $some_value, # boolean
   IsComplete =>  $some_value, # boolean
   IsForPropagation =>  $some_value, # boolean
   IsNative =>  $some_value, # boolean
   JobId =>  $some_value, # integer
   RetentionType =>  $some_value, # string
   StoragesetId => $some_value, # ObjId
   VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
     VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
       HostAddress => $some_value, # IpAddress
       HostFqdn =>  $some_value, # string
       HostId => $some_value, # ObjId
       IsAvailable =>  $some_value, # boolean
       SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
         SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
           PrimaryId => $some_value, # ObjId
           PrimaryName => $some_value, # ObjName
           PrimarySnapshotHostServiceId =>  $some_value, # string
           PrimarySnapshotName =>  $some_value, # string
           PrimarySnapshotUniqueId =>  $some_value, # string
           SecondaryQtreeId => $some_value, # ObjId
           SecondaryQtreeName =>  $some_value, # string
           SecondaryQtreeNameOrId =>  $some_value, # string
         },
       },
       SnapshotName =>  $some_value, # string
       SnapshotUniqueId =>  $some_value, # string
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
   VersionTimestamp => $some_value, # DpTimestamp
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

