
package MyElements::DpBackupVersionDelete;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupVersionDelete');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AllowDeferredDelete_of :ATTR(:get<AllowDeferredDelete>);
my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DeleteMultipleBackups_of :ATTR(:get<DeleteMultipleBackups>);
my %NodeName_of :ATTR(:get<NodeName>);

__PACKAGE__->_factory(
    [ qw(        AllowDeferredDelete
        BackupId
        BackupVersion
        DatasetNameOrId
        DeleteMultipleBackups
        NodeName

    ) ],
    {
        'AllowDeferredDelete' => \%AllowDeferredDelete_of,
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DeleteMultipleBackups' => \%DeleteMultipleBackups_of,
        'NodeName' => \%NodeName_of,
    },
    {
        'AllowDeferredDelete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'BackupId' => 'MyElements::DpBackupVersionDelete::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DeleteMultipleBackups' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AllowDeferredDelete' => 'AllowDeferredDelete',
        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'DeleteMultipleBackups' => 'DeleteMultipleBackups',
        'NodeName' => 'NodeName',
    }
);

} # end BLOCK




package MyElements::DpBackupVersionDelete::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupVersionDelete

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupVersionDelete from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AllowDeferredDelete

 $element->set_AllowDeferredDelete($data);
 $element->get_AllowDeferredDelete();




=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DeleteMultipleBackups

 $element->set_DeleteMultipleBackups($data);
 $element->get_DeleteMultipleBackups();




=item * NodeName

 $element->set_NodeName($data);
 $element->get_NodeName();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupVersionDelete->new($data);

Constructor. The following data structure may be passed to new():

 {
   AllowDeferredDelete =>  $some_value, # boolean
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   DatasetNameOrId => $some_value, # ObjNameOrId
   DeleteMultipleBackups =>  $some_value, # boolean
   NodeName =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

