
package MyElements::DpBackupVersionListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupVersionListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupVersions_of :ATTR(:get<BackupVersions>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        BackupVersions
        Records

    ) ],
    {
        'BackupVersions' => \%BackupVersions_of,
        'Records' => \%Records_of,
    },
    {
        'BackupVersions' => 'MyTypes::ArrayOfDpBackupVersionInfo',

        'Records' => 'MyElements::DpBackupVersionListIterNextResult::_Records',
    },
    {

        'BackupVersions' => 'BackupVersions',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::DpBackupVersionListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupVersionListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupVersionListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupVersions

 $element->set_BackupVersions($data);
 $element->get_BackupVersions();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupVersionListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupVersions =>  { # MyTypes::ArrayOfDpBackupVersionInfo
     DpBackupVersionInfo =>  { # MyTypes::DpBackupVersionInfo
       BackupDescription =>  $some_value, # string
       BackupIdInfos =>  { # MyTypes::ArrayOfDpBackupIdInfo
         DpBackupIdInfo =>  { # MyTypes::DpBackupIdInfo
           BackupId => $some_value, # atomic
           BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
             DfmMetadata =>  { # MyTypes::DfmMetadata
               FieldName =>  $some_value, # string
               FieldValue =>  $some_value, # string
             },
           },
           JobId =>  $some_value, # integer
           NodeId => $some_value, # atomic
           NodeName =>  $some_value, # string
         },
       },
       BackupTransferInfos =>  { # MyTypes::ArrayOfDpBackupTransferInfo
         DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
           BackupTransferNeeded =>  $some_value, # boolean
           BackupTransferStatus =>  $some_value, # string
           ConnectionType =>  $some_value, # string
           DestinationBackupId => $some_value, # atomic
           DestinationNodeId => $some_value, # atomic
           DestinationNodeName =>  $some_value, # string
           DestinationStoragesetId => $some_value, # atomic
           JobId =>  $some_value, # integer
           SourceBackupId => $some_value, # atomic
           SourceNodeId => $some_value, # atomic
           SourceNodeName =>  $some_value, # string
           SourceStoragesetId => $some_value, # atomic
         },
       },
       BackupVersion => $some_value, # DpTimestamp
       IsFullyPropagated =>  $some_value, # boolean
       RetentionType => $some_value, # DpBackupRetentionType
       VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
         VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
           HostAddress => $some_value, # IpAddress
           HostFqdn =>  $some_value, # string
           HostId => $some_value, # ObjId
           IsAvailable =>  $some_value, # boolean
           SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
             SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
               PrimaryId => $some_value, # ObjId
               PrimaryName => $some_value, # ObjName
               PrimarySnapshotHostServiceId =>  $some_value, # string
               PrimarySnapshotName =>  $some_value, # string
               PrimarySnapshotUniqueId =>  $some_value, # string
               SecondaryQtreeId => $some_value, # ObjId
               SecondaryQtreeName =>  $some_value, # string
               SecondaryQtreeNameOrId =>  $some_value, # string
             },
           },
           SnapshotName =>  $some_value, # string
           SnapshotUniqueId =>  $some_value, # string
           VolumeId => $some_value, # ObjId
           VolumeName => $some_value, # ObjName
         },
       },
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

