
package MyElements::DpBackupVersionListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupVersionListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IncludeMetadata_of :ATTR(:get<IncludeMetadata>);
my %RootObjectNameOrId_of :ATTR(:get<RootObjectNameOrId>);
my %SnapshotUniqueId_of :ATTR(:get<SnapshotUniqueId>);
my %SubPath_of :ATTR(:get<SubPath>);
my %VolumeId_of :ATTR(:get<VolumeId>);

__PACKAGE__->_factory(
    [ qw(        BackupVersion
        DatasetNameOrId
        IncludeIsAvailable
        IncludeMetadata
        RootObjectNameOrId
        SnapshotUniqueId
        SubPath
        VolumeId

    ) ],
    {
        'BackupVersion' => \%BackupVersion_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IncludeMetadata' => \%IncludeMetadata_of,
        'RootObjectNameOrId' => \%RootObjectNameOrId_of,
        'SnapshotUniqueId' => \%SnapshotUniqueId_of,
        'SubPath' => \%SubPath_of,
        'VolumeId' => \%VolumeId_of,
    },
    {
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'RootObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SubPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeId' => 'MyTypes::ObjId',
    },
    {

        'BackupVersion' => 'BackupVersion',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IncludeMetadata' => 'IncludeMetadata',
        'RootObjectNameOrId' => 'RootObjectNameOrId',
        'SnapshotUniqueId' => 'SnapshotUniqueId',
        'SubPath' => 'SubPath',
        'VolumeId' => 'VolumeId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupVersionListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupVersionListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IncludeMetadata

 $element->set_IncludeMetadata($data);
 $element->get_IncludeMetadata();




=item * RootObjectNameOrId

 $element->set_RootObjectNameOrId($data);
 $element->get_RootObjectNameOrId();




=item * SnapshotUniqueId

 $element->set_SnapshotUniqueId($data);
 $element->get_SnapshotUniqueId();




=item * SubPath

 $element->set_SubPath($data);
 $element->get_SubPath();




=item * VolumeId

 $element->set_VolumeId($data);
 $element->get_VolumeId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupVersionListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupVersion => $some_value, # DpTimestamp
   DatasetNameOrId => $some_value, # ObjNameOrId
   IncludeIsAvailable =>  $some_value, # boolean
   IncludeMetadata =>  $some_value, # boolean
   RootObjectNameOrId => $some_value, # ObjNameOrId
   SnapshotUniqueId =>  $some_value, # string
   SubPath =>  $some_value, # string
   VolumeId => $some_value, # ObjId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

