
package MyElements::DpBackupVersionModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpBackupVersionModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupDescription_of :ATTR(:get<BackupDescription>);
my %BackupId_of :ATTR(:get<BackupId>);
my %BackupMetadata_of :ATTR(:get<BackupMetadata>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DpBackupTransferInfo_of :ATTR(:get<DpBackupTransferInfo>);
my %IsAddingMembers_of :ATTR(:get<IsAddingMembers>);
my %IsComplete_of :ATTR(:get<IsComplete>);
my %NodeNameOrId_of :ATTR(:get<NodeNameOrId>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %VersionMembers_of :ATTR(:get<VersionMembers>);

__PACKAGE__->_factory(
    [ qw(        BackupDescription
        BackupId
        BackupMetadata
        BackupVersion
        DatasetNameOrId
        DpBackupTransferInfo
        IsAddingMembers
        IsComplete
        NodeNameOrId
        RetentionType
        VersionMembers

    ) ],
    {
        'BackupDescription' => \%BackupDescription_of,
        'BackupId' => \%BackupId_of,
        'BackupMetadata' => \%BackupMetadata_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DpBackupTransferInfo' => \%DpBackupTransferInfo_of,
        'IsAddingMembers' => \%IsAddingMembers_of,
        'IsComplete' => \%IsComplete_of,
        'NodeNameOrId' => \%NodeNameOrId_of,
        'RetentionType' => \%RetentionType_of,
        'VersionMembers' => \%VersionMembers_of,
    },
    {
        'BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'BackupId' => 'MyElements::DpBackupVersionModify::_BackupId',
        'BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DpBackupTransferInfo' => 'MyTypes::DpBackupTransferInfo',
        'IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsComplete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NodeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RetentionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
    },
    {

        'BackupDescription' => 'BackupDescription',
        'BackupId' => 'BackupId',
        'BackupMetadata' => 'BackupMetadata',
        'BackupVersion' => 'BackupVersion',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'DpBackupTransferInfo' => 'DpBackupTransferInfo',
        'IsAddingMembers' => 'IsAddingMembers',
        'IsComplete' => 'IsComplete',
        'NodeNameOrId' => 'NodeNameOrId',
        'RetentionType' => 'RetentionType',
        'VersionMembers' => 'VersionMembers',
    }
);

} # end BLOCK




package MyElements::DpBackupVersionModify::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpBackupVersionModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpBackupVersionModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupDescription

 $element->set_BackupDescription($data);
 $element->get_BackupDescription();




=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * BackupMetadata

 $element->set_BackupMetadata($data);
 $element->get_BackupMetadata();




=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DpBackupTransferInfo

 $element->set_DpBackupTransferInfo($data);
 $element->get_DpBackupTransferInfo();




=item * IsAddingMembers

 $element->set_IsAddingMembers($data);
 $element->get_IsAddingMembers();




=item * IsComplete

 $element->set_IsComplete($data);
 $element->get_IsComplete();




=item * NodeNameOrId

 $element->set_NodeNameOrId($data);
 $element->get_NodeNameOrId();




=item * RetentionType

 $element->set_RetentionType($data);
 $element->get_RetentionType();




=item * VersionMembers

 $element->set_VersionMembers($data);
 $element->get_VersionMembers();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpBackupVersionModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupDescription =>  $some_value, # string
   BackupId => $some_value, # atomic
   BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
     DfmMetadata =>  { # MyTypes::DfmMetadata
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   BackupVersion => $some_value, # DpTimestamp
   DatasetNameOrId => $some_value, # ObjNameOrId
   DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
     BackupTransferNeeded =>  $some_value, # boolean
     BackupTransferStatus =>  $some_value, # string
     ConnectionType =>  $some_value, # string
     DestinationBackupId => $some_value, # atomic
     DestinationNodeId => $some_value, # atomic
     DestinationNodeName =>  $some_value, # string
     DestinationStoragesetId => $some_value, # atomic
     JobId =>  $some_value, # integer
     SourceBackupId => $some_value, # atomic
     SourceNodeId => $some_value, # atomic
     SourceNodeName =>  $some_value, # string
     SourceStoragesetId => $some_value, # atomic
   },
   IsAddingMembers =>  $some_value, # boolean
   IsComplete =>  $some_value, # boolean
   NodeNameOrId =>  $some_value, # string
   RetentionType =>  $some_value, # string
   VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
     VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
       HostAddress => $some_value, # IpAddress
       HostFqdn =>  $some_value, # string
       HostId => $some_value, # ObjId
       IsAvailable =>  $some_value, # boolean
       SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
         SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
           PrimaryId => $some_value, # ObjId
           PrimaryName => $some_value, # ObjName
           PrimarySnapshotHostServiceId =>  $some_value, # string
           PrimarySnapshotName =>  $some_value, # string
           PrimarySnapshotUniqueId =>  $some_value, # string
           SecondaryQtreeId => $some_value, # ObjId
           SecondaryQtreeName =>  $some_value, # string
           SecondaryQtreeNameOrId =>  $some_value, # string
         },
       },
       SnapshotName =>  $some_value, # string
       SnapshotUniqueId =>  $some_value, # string
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

