
package MyElements::DpJobListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpJobListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %JobContextApplicationResourceNamespace_of :ATTR(:get<JobContextApplicationResourceNamespace>);
my %JobContextApplicationResourcesOnly_of :ATTR(:get<JobContextApplicationResourcesOnly>);
my %JobContextObjNameOrId_of :ATTR(:get<JobContextObjNameOrId>);
my %JobId_of :ATTR(:get<JobId>);
my %JobState_of :ATTR(:get<JobState>);
my %JobType_of :ATTR(:get<JobType>);
my %JobTypes_of :ATTR(:get<JobTypes>);
my %MaxJobs_of :ATTR(:get<MaxJobs>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %StartedTimestampFrom_of :ATTR(:get<StartedTimestampFrom>);
my %StartedTimestampTo_of :ATTR(:get<StartedTimestampTo>);

__PACKAGE__->_factory(
    [ qw(        JobContextApplicationResourceNamespace
        JobContextApplicationResourcesOnly
        JobContextObjNameOrId
        JobId
        JobState
        JobType
        JobTypes
        MaxJobs
        ObjectNameOrId
        StartedTimestampFrom
        StartedTimestampTo

    ) ],
    {
        'JobContextApplicationResourceNamespace' => \%JobContextApplicationResourceNamespace_of,
        'JobContextApplicationResourcesOnly' => \%JobContextApplicationResourcesOnly_of,
        'JobContextObjNameOrId' => \%JobContextObjNameOrId_of,
        'JobId' => \%JobId_of,
        'JobState' => \%JobState_of,
        'JobType' => \%JobType_of,
        'JobTypes' => \%JobTypes_of,
        'MaxJobs' => \%MaxJobs_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'StartedTimestampFrom' => \%StartedTimestampFrom_of,
        'StartedTimestampTo' => \%StartedTimestampTo_of,
    },
    {
        'JobContextApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
        'JobContextApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'JobContextObjNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'JobId' => 'MyElements::DpJobListIterStart::_JobId',
        'JobState' => 'MyTypes::DpJobState',
        'JobType' => 'MyTypes::DpJobType',
        'JobTypes' => 'MyTypes::ArrayOfJobType',

        'MaxJobs' => 'MyElements::DpJobListIterStart::_MaxJobs',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'StartedTimestampFrom' => 'MyTypes::DpTimestamp',
        'StartedTimestampTo' => 'MyTypes::DpTimestamp',
    },
    {

        'JobContextApplicationResourceNamespace' => 'JobContextApplicationResourceNamespace',
        'JobContextApplicationResourcesOnly' => 'JobContextApplicationResourcesOnly',
        'JobContextObjNameOrId' => 'JobContextObjNameOrId',
        'JobId' => 'JobId',
        'JobState' => 'JobState',
        'JobType' => 'JobType',
        'JobTypes' => 'JobTypes',
        'MaxJobs' => 'MaxJobs',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'StartedTimestampFrom' => 'StartedTimestampFrom',
        'StartedTimestampTo' => 'StartedTimestampTo',
    }
);

} # end BLOCK




package MyElements::DpJobListIterStart::_JobId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::DpJobListIterStart::_MaxJobs;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpJobListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpJobListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * JobContextApplicationResourceNamespace

 $element->set_JobContextApplicationResourceNamespace($data);
 $element->get_JobContextApplicationResourceNamespace();




=item * JobContextApplicationResourcesOnly

 $element->set_JobContextApplicationResourcesOnly($data);
 $element->get_JobContextApplicationResourcesOnly();




=item * JobContextObjNameOrId

 $element->set_JobContextObjNameOrId($data);
 $element->get_JobContextObjNameOrId();




=item * JobId

 $element->set_JobId($data);
 $element->get_JobId();




=item * JobState

 $element->set_JobState($data);
 $element->get_JobState();




=item * JobType

 $element->set_JobType($data);
 $element->get_JobType();




=item * JobTypes

 $element->set_JobTypes($data);
 $element->get_JobTypes();




=item * MaxJobs

 $element->set_MaxJobs($data);
 $element->get_MaxJobs();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * StartedTimestampFrom

 $element->set_StartedTimestampFrom($data);
 $element->get_StartedTimestampFrom();




=item * StartedTimestampTo

 $element->set_StartedTimestampTo($data);
 $element->get_StartedTimestampTo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpJobListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   JobContextApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   JobContextApplicationResourcesOnly =>  $some_value, # boolean
   JobContextObjNameOrId =>  $some_value, # string
   JobId => $some_value, # atomic
   JobState => $some_value, # DpJobState
   JobType => $some_value, # DpJobType
   JobTypes =>  { # MyTypes::ArrayOfJobType
     JobType => $some_value, # JobType
   },
   MaxJobs => $some_value, # atomic
   ObjectNameOrId => $some_value, # ObjNameOrId
   StartedTimestampFrom => $some_value, # DpTimestamp
   StartedTimestampTo => $some_value, # DpTimestamp
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

