
package MyElements::DpJobProgressEventListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpJobProgressEventListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConnectionId_of :ATTR(:get<ConnectionId>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %EndTime_of :ATTR(:get<EndTime>);
my %History_of :ATTR(:get<History>);
my %JobId_of :ATTR(:get<JobId>);
my %JobType_of :ATTR(:get<JobType>);
my %JobTypes_of :ATTR(:get<JobTypes>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %StartTime_of :ATTR(:get<StartTime>);

__PACKAGE__->_factory(
    [ qw(        ConnectionId
        DatasetNameOrId
        EndTime
        History
        JobId
        JobType
        JobTypes
        ObjectNameOrId
        StartTime

    ) ],
    {
        'ConnectionId' => \%ConnectionId_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'EndTime' => \%EndTime_of,
        'History' => \%History_of,
        'JobId' => \%JobId_of,
        'JobType' => \%JobType_of,
        'JobTypes' => \%JobTypes_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'StartTime' => \%StartTime_of,
    },
    {

        'ConnectionId' => 'MyElements::DpJobProgressEventListIterStart::_ConnectionId',
        'DatasetNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EndTime' => 'MyTypes::DpTimestamp',
        'History' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'JobId' => 'MyElements::DpJobProgressEventListIterStart::_JobId',
        'JobType' => 'MyTypes::DpJobType',
        'JobTypes' => 'MyTypes::ArrayOfJobType',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'StartTime' => 'MyTypes::DpTimestamp',
    },
    {

        'ConnectionId' => 'ConnectionId',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'EndTime' => 'EndTime',
        'History' => 'History',
        'JobId' => 'JobId',
        'JobType' => 'JobType',
        'JobTypes' => 'JobTypes',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'StartTime' => 'StartTime',
    }
);

} # end BLOCK




package MyElements::DpJobProgressEventListIterStart::_ConnectionId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::DpJobProgressEventListIterStart::_JobId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpJobProgressEventListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpJobProgressEventListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConnectionId

 $element->set_ConnectionId($data);
 $element->get_ConnectionId();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * EndTime

 $element->set_EndTime($data);
 $element->get_EndTime();




=item * History

 $element->set_History($data);
 $element->get_History();




=item * JobId

 $element->set_JobId($data);
 $element->get_JobId();




=item * JobType

 $element->set_JobType($data);
 $element->get_JobType();




=item * JobTypes

 $element->set_JobTypes($data);
 $element->get_JobTypes();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * StartTime

 $element->set_StartTime($data);
 $element->get_StartTime();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpJobProgressEventListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   ConnectionId => $some_value, # atomic
   DatasetNameOrId =>  $some_value, # string
   EndTime => $some_value, # DpTimestamp
   History =>  $some_value, # boolean
   JobId => $some_value, # atomic
   JobType => $some_value, # DpJobType
   JobTypes =>  { # MyTypes::ArrayOfJobType
     JobType => $some_value, # JobType
   },
   ObjectNameOrId => $some_value, # ObjNameOrId
   StartTime => $some_value, # DpTimestamp
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

