
package MyElements::DpPolicyListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpPolicyListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpPolicyInfos_of :ATTR(:get<DpPolicyInfos>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        DpPolicyInfos
        Records

    ) ],
    {
        'DpPolicyInfos' => \%DpPolicyInfos_of,
        'Records' => \%Records_of,
    },
    {
        'DpPolicyInfos' => 'MyTypes::ArrayOfDpPolicyInfo',

        'Records' => 'MyElements::DpPolicyListIterNextResult::_Records',
    },
    {

        'DpPolicyInfos' => 'DpPolicyInfos',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::DpPolicyListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpPolicyListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpPolicyListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpPolicyInfos

 $element->set_DpPolicyInfos($data);
 $element->get_DpPolicyInfos();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpPolicyListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   DpPolicyInfos =>  { # MyTypes::ArrayOfDpPolicyInfo
     DpPolicyInfo =>  { # MyTypes::DpPolicyInfo
       DpPolicyContent =>  { # MyTypes::DpPolicyContent
         Description =>  $some_value, # string
         DpPolicyConnections =>  { # MyTypes::ArrayOfDpPolicyConnectionInfo
           DpPolicyConnectionInfo =>  { # MyTypes::DpPolicyConnectionInfo
             BackupScheduleId => $some_value, # ObjId
             BackupScheduleName => $some_value, # ObjName
             FromNodeId => $some_value, # atomic
             FromNodeName =>  $some_value, # string
             Id => $some_value, # atomic
             IsDrCapable =>  $some_value, # boolean
             IsLagErrorEnabled =>  $some_value, # boolean
             IsLagWarningEnabled =>  $some_value, # boolean
             LagErrorThreshold => $some_value, # atomic
             LagWarningThreshold => $some_value, # atomic
             MirrorScheduleId => $some_value, # ObjId
             MirrorScheduleName => $some_value, # ObjName
             ThrottleScheduleId => $some_value, # ObjId
             ThrottleScheduleName => $some_value, # ObjName
             ToNodeId => $some_value, # atomic
             ToNodeName =>  $some_value, # string
             Type =>  $some_value, # string
           },
         },
         DpPolicyNodes =>  { # MyTypes::ArrayOfDpPolicyNodeInfo
           DpPolicyNodeInfo =>  { # MyTypes::DpPolicyNodeInfo
             BackupScriptPath =>  $some_value, # string
             BackupScriptRunAs =>  $some_value, # string
             DailyRetentionCount => $some_value, # atomic
             DailyRetentionDuration => $some_value, # atomic
             FailoverScriptPath =>  $some_value, # string
             FailoverScriptRunAs =>  $some_value, # string
             HourlyRetentionCount => $some_value, # atomic
             HourlyRetentionDuration => $some_value, # atomic
             Id => $some_value, # atomic
             IsLagErrorEnabled =>  $some_value, # boolean
             IsLagWarningEnabled =>  $some_value, # boolean
             LagErrorThreshold => $some_value, # atomic
             LagWarningThreshold => $some_value, # atomic
             MonthlyRetentionCount => $some_value, # atomic
             MonthlyRetentionDuration => $some_value, # atomic
             Name => $some_value, # DpPolicyNodeName
             SnapshotScheduleId => $some_value, # ObjId
             SnapshotScheduleName => $some_value, # ObjName
             WeeklyRetentionCount => $some_value, # atomic
             WeeklyRetentionDuration => $some_value, # atomic
           },
         },
         Name => $some_value, # ObjName
       },
       Id => $some_value, # ObjId
       IsApplicationCompatible =>  $some_value, # boolean
       IsModifiable =>  $some_value, # boolean
       IsNonDisruptiveRestoreCompatible =>  $some_value, # boolean
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

