
package MyElements::DpRelationshipListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpRelationshipListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConnectionId_of :ATTR(:get<ConnectionId>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DestinationId_of :ATTR(:get<DestinationId>);
my %DestinationType_of :ATTR(:get<DestinationType>);
my %IncludeDeleted_of :ATTR(:get<IncludeDeleted>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsDpManaged_of :ATTR(:get<IsDpManaged>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsMigrationRelationship_of :ATTR(:get<IsMigrationRelationship>);
my %OperationalStatuses_of :ATTR(:get<OperationalStatuses>);
my %RelationshipId_of :ATTR(:get<RelationshipId>);
my %RelationshipStates_of :ATTR(:get<RelationshipStates>);
my %RelationshipType_of :ATTR(:get<RelationshipType>);
my %SourceId_of :ATTR(:get<SourceId>);
my %SourceOrDestinationId_of :ATTR(:get<SourceOrDestinationId>);
my %SourceType_of :ATTR(:get<SourceType>);

__PACKAGE__->_factory(
    [ qw(        ConnectionId
        DatasetNameOrId
        DestinationId
        DestinationType
        IncludeDeleted
        IsDpIgnored
        IsDpManaged
        IsInDataset
        IsMigrationRelationship
        OperationalStatuses
        RelationshipId
        RelationshipStates
        RelationshipType
        SourceId
        SourceOrDestinationId
        SourceType

    ) ],
    {
        'ConnectionId' => \%ConnectionId_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DestinationId' => \%DestinationId_of,
        'DestinationType' => \%DestinationType_of,
        'IncludeDeleted' => \%IncludeDeleted_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsDpManaged' => \%IsDpManaged_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsMigrationRelationship' => \%IsMigrationRelationship_of,
        'OperationalStatuses' => \%OperationalStatuses_of,
        'RelationshipId' => \%RelationshipId_of,
        'RelationshipStates' => \%RelationshipStates_of,
        'RelationshipType' => \%RelationshipType_of,
        'SourceId' => \%SourceId_of,
        'SourceOrDestinationId' => \%SourceOrDestinationId_of,
        'SourceType' => \%SourceType_of,
    },
    {

        'ConnectionId' => 'MyElements::DpRelationshipListInfoIterStart::_ConnectionId',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DestinationId' => 'MyTypes::ObjId',
        'DestinationType' => 'MyTypes::RelationshipEndpointType',
        'IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpManaged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsMigrationRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'OperationalStatuses' => 'MyTypes::ArrayOfOperationalStatus',
        'RelationshipId' => 'MyTypes::ObjId',
        'RelationshipStates' => 'MyTypes::ArrayOfRelationshipState',
        'RelationshipType' => 'MyTypes::RelationshipType',
        'SourceId' => 'MyTypes::ObjId',
        'SourceOrDestinationId' => 'MyTypes::ObjId',
        'SourceType' => 'MyTypes::RelationshipEndpointType',
    },
    {

        'ConnectionId' => 'ConnectionId',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'DestinationId' => 'DestinationId',
        'DestinationType' => 'DestinationType',
        'IncludeDeleted' => 'IncludeDeleted',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsDpManaged' => 'IsDpManaged',
        'IsInDataset' => 'IsInDataset',
        'IsMigrationRelationship' => 'IsMigrationRelationship',
        'OperationalStatuses' => 'OperationalStatuses',
        'RelationshipId' => 'RelationshipId',
        'RelationshipStates' => 'RelationshipStates',
        'RelationshipType' => 'RelationshipType',
        'SourceId' => 'SourceId',
        'SourceOrDestinationId' => 'SourceOrDestinationId',
        'SourceType' => 'SourceType',
    }
);

} # end BLOCK




package MyElements::DpRelationshipListInfoIterStart::_ConnectionId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpRelationshipListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpRelationshipListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConnectionId

 $element->set_ConnectionId($data);
 $element->get_ConnectionId();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DestinationId

 $element->set_DestinationId($data);
 $element->get_DestinationId();




=item * DestinationType

 $element->set_DestinationType($data);
 $element->get_DestinationType();




=item * IncludeDeleted

 $element->set_IncludeDeleted($data);
 $element->get_IncludeDeleted();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsDpManaged

 $element->set_IsDpManaged($data);
 $element->get_IsDpManaged();




=item * IsInDataset

 $element->set_IsInDataset($data);
 $element->get_IsInDataset();




=item * IsMigrationRelationship

 $element->set_IsMigrationRelationship($data);
 $element->get_IsMigrationRelationship();




=item * OperationalStatuses

 $element->set_OperationalStatuses($data);
 $element->get_OperationalStatuses();




=item * RelationshipId

 $element->set_RelationshipId($data);
 $element->get_RelationshipId();




=item * RelationshipStates

 $element->set_RelationshipStates($data);
 $element->get_RelationshipStates();




=item * RelationshipType

 $element->set_RelationshipType($data);
 $element->get_RelationshipType();




=item * SourceId

 $element->set_SourceId($data);
 $element->get_SourceId();




=item * SourceOrDestinationId

 $element->set_SourceOrDestinationId($data);
 $element->get_SourceOrDestinationId();




=item * SourceType

 $element->set_SourceType($data);
 $element->get_SourceType();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpRelationshipListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   ConnectionId => $some_value, # atomic
   DatasetNameOrId => $some_value, # ObjNameOrId
   DestinationId => $some_value, # ObjId
   DestinationType => $some_value, # RelationshipEndpointType
   IncludeDeleted =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsDpManaged =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsMigrationRelationship =>  $some_value, # boolean
   OperationalStatuses =>  { # MyTypes::ArrayOfOperationalStatus
     OperationalStatus => $some_value, # OperationalStatus
   },
   RelationshipId => $some_value, # ObjId
   RelationshipStates =>  { # MyTypes::ArrayOfRelationshipState
     RelationshipState => $some_value, # RelationshipState
   },
   RelationshipType => $some_value, # RelationshipType
   SourceId => $some_value, # ObjId
   SourceOrDestinationId => $some_value, # ObjId
   SourceType => $some_value, # RelationshipEndpointType
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

