
package MyElements::DpRestoreToPrimary;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpRestoreToPrimary');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %CheckOverwrite_of :ATTR(:get<CheckOverwrite>);
my %CheckSpaceStatus_of :ATTR(:get<CheckSpaceStatus>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %Paths_of :ATTR(:get<Paths>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupVersion
        CheckOverwrite
        CheckSpaceStatus
        DatasetNameOrId
        Paths

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'CheckOverwrite' => \%CheckOverwrite_of,
        'CheckSpaceStatus' => \%CheckSpaceStatus_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'Paths' => \%Paths_of,
    },
    {

        'BackupId' => 'MyElements::DpRestoreToPrimary::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'CheckOverwrite' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'CheckSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'Paths' => 'MyTypes::ArrayOfDpPathInfo',
    },
    {

        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'CheckOverwrite' => 'CheckOverwrite',
        'CheckSpaceStatus' => 'CheckSpaceStatus',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'Paths' => 'Paths',
    }
);

} # end BLOCK




package MyElements::DpRestoreToPrimary::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpRestoreToPrimary

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpRestoreToPrimary from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * BackupVersion

 $element->set_BackupVersion($data);
 $element->get_BackupVersion();




=item * CheckOverwrite

 $element->set_CheckOverwrite($data);
 $element->get_CheckOverwrite();




=item * CheckSpaceStatus

 $element->set_CheckSpaceStatus($data);
 $element->get_CheckSpaceStatus();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * Paths

 $element->set_Paths($data);
 $element->get_Paths();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpRestoreToPrimary->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   CheckOverwrite =>  $some_value, # boolean
   CheckSpaceStatus =>  $some_value, # boolean
   DatasetNameOrId => $some_value, # ObjNameOrId
   Paths =>  { # MyTypes::ArrayOfDpPathInfo
     DpPathInfo =>  { # MyTypes::DpPathInfo
       MemberNameOrId => $some_value, # ObjNameOrId
       Path =>  $some_value, # string
       PrimarySnapshotName =>  $some_value, # string
       PrimarySnapshotUniqueId =>  $some_value, # string
       RestoreConfiguration =>  $some_value, # boolean
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

