
package MyElements::DpRestoreViStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('DpRestoreViStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %DpViRestoreObjects_of :ATTR(:get<DpViRestoreObjects>);
my %DpViRestoreSettings_of :ATTR(:get<DpViRestoreSettings>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        DpViRestoreObjects
        DpViRestoreSettings

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'DpViRestoreObjects' => \%DpViRestoreObjects_of,
        'DpViRestoreSettings' => \%DpViRestoreSettings_of,
    },
    {

        'BackupId' => 'MyElements::DpRestoreViStart::_BackupId',
        'DpViRestoreObjects' => 'MyTypes::ArrayOfDpViRestoreObject',
        'DpViRestoreSettings' => 'MyTypes::DpViRestoreSettings',
    },
    {

        'BackupId' => 'BackupId',
        'DpViRestoreObjects' => 'DpViRestoreObjects',
        'DpViRestoreSettings' => 'DpViRestoreSettings',
    }
);

} # end BLOCK




package MyElements::DpRestoreViStart::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::DpRestoreViStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
DpRestoreViStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId

 $element->set_BackupId($data);
 $element->get_BackupId();




=item * DpViRestoreObjects

 $element->set_DpViRestoreObjects($data);
 $element->get_DpViRestoreObjects();




=item * DpViRestoreSettings

 $element->set_DpViRestoreSettings($data);
 $element->get_DpViRestoreSettings();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::DpRestoreViStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   BackupId => $some_value, # atomic
   DpViRestoreObjects =>  { # MyTypes::ArrayOfDpViRestoreObject
     DpViRestoreObject =>  { # MyTypes::DpViRestoreObject
       DpViObjectRestoreSettings =>  { # MyTypes::DpViObjectRestoreSettings
         DpViVmwareObjectRestoreSettings =>  { # MyTypes::DpViVmwareObjectRestoreSettings
           DestinationDatastoreNameOrId => $some_value, # ObjNameOrId
         },
       },
       RestoreObjectNameOrId => $some_value, # ObjNameOrId
     },
   },
   DpViRestoreSettings =>  { # MyTypes::DpViRestoreSettings
     DpViHypervRestoreSettings =>  { # MyTypes::DpViHypervRestoreSettings
       StartVmAfterRestore =>  $some_value, # boolean
     },
     DpViVmwareRestoreSettings =>  { # MyTypes::DpViVmwareRestoreSettings
       EsxServerNameOrId => $some_value, # ObjNameOrId
       StartVmAfterRestore =>  $some_value, # boolean
     },
     RestoreScript =>  $some_value, # string
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

