
package MyElements::EventGenerate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('EventGenerate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventMessage_of :ATTR(:get<EventMessage>);
my %EventName_of :ATTR(:get<EventName>);
my %Source_of :ATTR(:get<Source>);
my %Timestamp_of :ATTR(:get<Timestamp>);

__PACKAGE__->_factory(
    [ qw(        EventMessage
        EventName
        Source
        Timestamp

    ) ],
    {
        'EventMessage' => \%EventMessage_of,
        'EventName' => \%EventName_of,
        'Source' => \%Source_of,
        'Timestamp' => \%Timestamp_of,
    },
    {
        'EventMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Source' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Timestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'EventMessage' => 'EventMessage',
        'EventName' => 'EventName',
        'Source' => 'Source',
        'Timestamp' => 'Timestamp',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::EventGenerate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
EventGenerate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventMessage

 $element->set_EventMessage($data);
 $element->get_EventMessage();




=item * EventName

 $element->set_EventName($data);
 $element->get_EventName();




=item * Source

 $element->set_Source($data);
 $element->get_Source();




=item * Timestamp

 $element->set_Timestamp($data);
 $element->get_Timestamp();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::EventGenerate->new($data);

Constructor. The following data structure may be passed to new():

 {
   EventMessage =>  $some_value, # string
   EventName =>  $some_value, # string
   Source =>  $some_value, # string
   Timestamp =>  $some_value, # integer
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

