
package MyElements::EventListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('EventListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Events_of :ATTR(:get<Events>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        Events
        Records

    ) ],
    {
        'Events' => \%Events_of,
        'Records' => \%Records_of,
    },
    {
        'Events' => 'MyTypes::ArrayOfEventInfo',

        'Records' => 'MyElements::EventListIterNextResult::_Records',
    },
    {

        'Events' => 'Events',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::EventListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::EventListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
EventListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Events

 $element->set_Events($data);
 $element->get_Events();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::EventListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   Events =>  { # MyTypes::ArrayOfEventInfo
     EventInfo =>  { # MyTypes::EventInfo
       EventAbout =>  $some_value, # string
       EventAcknowledged =>  $some_value, # integer
       EventAcknowledgedUser =>  $some_value, # string
       EventArguments =>  { # MyTypes::ArrayOfKeyValuePair
         KeyValuePair =>  { # MyTypes::KeyValuePair
           Key =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       EventCondition =>  $some_value, # string
       EventDeleted =>  $some_value, # integer
       EventDeletedUser =>  $some_value, # string
       EventId => $some_value, # atomic
       EventName =>  $some_value, # string
       EventOriginatingId => $some_value, # atomic
       EventSeverity => $some_value, # ObjStatus
       EventSourceId => $some_value, # atomic
       EventSourceName =>  $some_value, # string
       EventSourceNodeName =>  $some_value, # string
       EventSourceType =>  $some_value, # string
       EventTime =>  $some_value, # integer
       EventType =>  $some_value, # string
       IsDeleted =>  $some_value, # boolean
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

