
package MyElements::EventListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('EventListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventApplicationList_of :ATTR(:get<EventApplicationList>);
my %EventId_of :ATTR(:get<EventId>);
my %EventSeverities_of :ATTR(:get<EventSeverities>);
my %EventSourceId_of :ATTR(:get<EventSourceId>);
my %EventTypeFilterList_of :ATTR(:get<EventTypeFilterList>);
my %GreaterThanId_of :ATTR(:get<GreaterThanId>);
my %IncludeDatasetResourceStatusEvents_of :ATTR(:get<IncludeDatasetResourceStatusEvents>);
my %IncludeDeletedObjects_of :ATTR(:get<IncludeDeletedObjects>);
my %IncludeEventArguments_of :ATTR(:get<IncludeEventArguments>);
my %IncludeRelated_of :ATTR(:get<IncludeRelated>);
my %IsAcknowledged_of :ATTR(:get<IsAcknowledged>);
my %IsDeleted_of :ATTR(:get<IsDeleted>);
my %IsHistory_of :ATTR(:get<IsHistory>);
my %IsMostSevereFirst_of :ATTR(:get<IsMostSevereFirst>);
my %IsOldestFirst_of :ATTR(:get<IsOldestFirst>);
my %MaxEvents_of :ATTR(:get<MaxEvents>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %TimeRange_of :ATTR(:get<TimeRange>);
my %Timeout_of :ATTR(:get<Timeout>);

__PACKAGE__->_factory(
    [ qw(        EventApplicationList
        EventId
        EventSeverities
        EventSourceId
        EventTypeFilterList
        GreaterThanId
        IncludeDatasetResourceStatusEvents
        IncludeDeletedObjects
        IncludeEventArguments
        IncludeRelated
        IsAcknowledged
        IsDeleted
        IsHistory
        IsMostSevereFirst
        IsOldestFirst
        MaxEvents
        ObjectManagementFilter
        TimeRange
        Timeout

    ) ],
    {
        'EventApplicationList' => \%EventApplicationList_of,
        'EventId' => \%EventId_of,
        'EventSeverities' => \%EventSeverities_of,
        'EventSourceId' => \%EventSourceId_of,
        'EventTypeFilterList' => \%EventTypeFilterList_of,
        'GreaterThanId' => \%GreaterThanId_of,
        'IncludeDatasetResourceStatusEvents' => \%IncludeDatasetResourceStatusEvents_of,
        'IncludeDeletedObjects' => \%IncludeDeletedObjects_of,
        'IncludeEventArguments' => \%IncludeEventArguments_of,
        'IncludeRelated' => \%IncludeRelated_of,
        'IsAcknowledged' => \%IsAcknowledged_of,
        'IsDeleted' => \%IsDeleted_of,
        'IsHistory' => \%IsHistory_of,
        'IsMostSevereFirst' => \%IsMostSevereFirst_of,
        'IsOldestFirst' => \%IsOldestFirst_of,
        'MaxEvents' => \%MaxEvents_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'TimeRange' => \%TimeRange_of,
        'Timeout' => \%Timeout_of,
    },
    {
        'EventApplicationList' => 'MyTypes::ArrayOfEventApplicationType',
        'EventId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventSeverities' => 'MyTypes::ArrayOfObjStatus',
        'EventSourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventTypeFilterList' => 'MyTypes::ArrayOfEventTypeFilter',
        'GreaterThanId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'IncludeDatasetResourceStatusEvents' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeEventArguments' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeRelated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsHistory' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsMostSevereFirst' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsOldestFirst' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'MaxEvents' => 'MyElements::EventListIterStart::_MaxEvents',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'TimeRange' => 'MyTypes::WrapperOfEventTimestampRange',
        'Timeout' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'EventApplicationList' => 'EventApplicationList',
        'EventId' => 'EventId',
        'EventSeverities' => 'EventSeverities',
        'EventSourceId' => 'EventSourceId',
        'EventTypeFilterList' => 'EventTypeFilterList',
        'GreaterThanId' => 'GreaterThanId',
        'IncludeDatasetResourceStatusEvents' => 'IncludeDatasetResourceStatusEvents',
        'IncludeDeletedObjects' => 'IncludeDeletedObjects',
        'IncludeEventArguments' => 'IncludeEventArguments',
        'IncludeRelated' => 'IncludeRelated',
        'IsAcknowledged' => 'IsAcknowledged',
        'IsDeleted' => 'IsDeleted',
        'IsHistory' => 'IsHistory',
        'IsMostSevereFirst' => 'IsMostSevereFirst',
        'IsOldestFirst' => 'IsOldestFirst',
        'MaxEvents' => 'MaxEvents',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'TimeRange' => 'TimeRange',
        'Timeout' => 'Timeout',
    }
);

} # end BLOCK




package MyElements::EventListIterStart::_MaxEvents;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::EventListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
EventListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventApplicationList

 $element->set_EventApplicationList($data);
 $element->get_EventApplicationList();




=item * EventId

 $element->set_EventId($data);
 $element->get_EventId();




=item * EventSeverities

 $element->set_EventSeverities($data);
 $element->get_EventSeverities();




=item * EventSourceId

 $element->set_EventSourceId($data);
 $element->get_EventSourceId();




=item * EventTypeFilterList

 $element->set_EventTypeFilterList($data);
 $element->get_EventTypeFilterList();




=item * GreaterThanId

 $element->set_GreaterThanId($data);
 $element->get_GreaterThanId();




=item * IncludeDatasetResourceStatusEvents

 $element->set_IncludeDatasetResourceStatusEvents($data);
 $element->get_IncludeDatasetResourceStatusEvents();




=item * IncludeDeletedObjects

 $element->set_IncludeDeletedObjects($data);
 $element->get_IncludeDeletedObjects();




=item * IncludeEventArguments

 $element->set_IncludeEventArguments($data);
 $element->get_IncludeEventArguments();




=item * IncludeRelated

 $element->set_IncludeRelated($data);
 $element->get_IncludeRelated();




=item * IsAcknowledged

 $element->set_IsAcknowledged($data);
 $element->get_IsAcknowledged();




=item * IsDeleted

 $element->set_IsDeleted($data);
 $element->get_IsDeleted();




=item * IsHistory

 $element->set_IsHistory($data);
 $element->get_IsHistory();




=item * IsMostSevereFirst

 $element->set_IsMostSevereFirst($data);
 $element->get_IsMostSevereFirst();




=item * IsOldestFirst

 $element->set_IsOldestFirst($data);
 $element->get_IsOldestFirst();




=item * MaxEvents

 $element->set_MaxEvents($data);
 $element->get_MaxEvents();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * TimeRange

 $element->set_TimeRange($data);
 $element->get_TimeRange();




=item * Timeout

 $element->set_Timeout($data);
 $element->get_Timeout();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::EventListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   EventApplicationList =>  { # MyTypes::ArrayOfEventApplicationType
     EventApplicationType => $some_value, # EventApplicationType
   },
   EventId =>  $some_value, # integer
   EventSeverities =>  { # MyTypes::ArrayOfObjStatus
     ObjStatus => $some_value, # ObjStatus
   },
   EventSourceId =>  $some_value, # integer
   EventTypeFilterList =>  { # MyTypes::ArrayOfEventTypeFilter
     EventTypeFilter =>  { # MyTypes::EventTypeFilter
       EventFilter =>  $some_value, # string
     },
   },
   GreaterThanId =>  $some_value, # integer
   IncludeDatasetResourceStatusEvents =>  $some_value, # boolean
   IncludeDeletedObjects =>  $some_value, # boolean
   IncludeEventArguments =>  $some_value, # boolean
   IncludeRelated =>  $some_value, # boolean
   IsAcknowledged =>  $some_value, # boolean
   IsDeleted =>  $some_value, # boolean
   IsHistory =>  $some_value, # boolean
   IsMostSevereFirst =>  $some_value, # boolean
   IsOldestFirst =>  $some_value, # boolean
   MaxEvents => $some_value, # atomic
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   TimeRange =>  { # MyTypes::WrapperOfEventTimestampRange
     EventTimestampRange =>  { # MyTypes::EventTimestampRange
       EndTime =>  $some_value, # integer
       StartTime =>  $some_value, # integer
     },
   },
   Timeout =>  $some_value, # integer
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

