
package MyElements::EventclassAddCustom;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('EventclassAddCustom');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AboutMessage_of :ATTR(:get<AboutMessage>);
my %EventClassName_of :ATTR(:get<EventClassName>);
my %EventNames_of :ATTR(:get<EventNames>);
my %EventNamespaceName_of :ATTR(:get<EventNamespaceName>);
my %IsAllowDuplicates_of :ATTR(:get<IsAllowDuplicates>);
my %IsMultiCurrent_of :ATTR(:get<IsMultiCurrent>);

__PACKAGE__->_factory(
    [ qw(        AboutMessage
        EventClassName
        EventNames
        EventNamespaceName
        IsAllowDuplicates
        IsMultiCurrent

    ) ],
    {
        'AboutMessage' => \%AboutMessage_of,
        'EventClassName' => \%EventClassName_of,
        'EventNames' => \%EventNames_of,
        'EventNamespaceName' => \%EventNamespaceName_of,
        'IsAllowDuplicates' => \%IsAllowDuplicates_of,
        'IsMultiCurrent' => \%IsMultiCurrent_of,
    },
    {
        'AboutMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventNames' => 'MyTypes::ArrayOfEventNameInfo',
        'EventNamespaceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAllowDuplicates' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsMultiCurrent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'AboutMessage' => 'AboutMessage',
        'EventClassName' => 'EventClassName',
        'EventNames' => 'EventNames',
        'EventNamespaceName' => 'EventNamespaceName',
        'IsAllowDuplicates' => 'IsAllowDuplicates',
        'IsMultiCurrent' => 'IsMultiCurrent',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::EventclassAddCustom

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
EventclassAddCustom from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AboutMessage

 $element->set_AboutMessage($data);
 $element->get_AboutMessage();




=item * EventClassName

 $element->set_EventClassName($data);
 $element->get_EventClassName();




=item * EventNames

 $element->set_EventNames($data);
 $element->get_EventNames();




=item * EventNamespaceName

 $element->set_EventNamespaceName($data);
 $element->get_EventNamespaceName();




=item * IsAllowDuplicates

 $element->set_IsAllowDuplicates($data);
 $element->get_IsAllowDuplicates();




=item * IsMultiCurrent

 $element->set_IsMultiCurrent($data);
 $element->get_IsMultiCurrent();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::EventclassAddCustom->new($data);

Constructor. The following data structure may be passed to new():

 {
   AboutMessage =>  $some_value, # string
   EventClassName =>  $some_value, # string
   EventNames =>  { # MyTypes::ArrayOfEventNameInfo
     EventNameInfo =>  { # MyTypes::EventNameInfo
       EventNamePretty =>  $some_value, # string
       EventNameShort =>  $some_value, # string
       Severity =>  $some_value, # string
     },
   },
   EventNamespaceName =>  $some_value, # string
   IsAllowDuplicates =>  $some_value, # boolean
   IsMultiCurrent =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

