
package MyElements::EventclassListResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('EventclassListResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventClasses_of :ATTR(:get<EventClasses>);

__PACKAGE__->_factory(
    [ qw(        EventClasses

    ) ],
    {
        'EventClasses' => \%EventClasses_of,
    },
    {
        'EventClasses' => 'MyTypes::ArrayOfEventClassInfo',
    },
    {

        'EventClasses' => 'EventClasses',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::EventclassListResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
EventclassListResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventClasses

 $element->set_EventClasses($data);
 $element->get_EventClasses();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::EventclassListResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   EventClasses =>  { # MyTypes::ArrayOfEventClassInfo
     EventClassInfo =>  { # MyTypes::EventClassInfo
       AboutMessage =>  $some_value, # string
       EventClassId =>  $some_value, # integer
       EventClassName =>  $some_value, # string
       EventNames =>  { # MyTypes::ArrayOfEventNameInfo
         EventNameInfo =>  { # MyTypes::EventNameInfo
           EventNamePretty =>  $some_value, # string
           EventNameShort =>  $some_value, # string
           Severity =>  $some_value, # string
         },
       },
       IsAllowDuplicates =>  $some_value, # boolean
       IsMultiCurrent =>  $some_value, # boolean
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

