
package MyElements::GraphDataListInfo;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('GraphDataListInfo');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EndDate_of :ATTR(:get<EndDate>);
my %GraphName_of :ATTR(:get<GraphName>);
my %GraphPeriod_of :ATTR(:get<GraphPeriod>);
my %PrimaryObject_of :ATTR(:get<PrimaryObject>);
my %SecondaryObject_of :ATTR(:get<SecondaryObject>);
my %StartDate_of :ATTR(:get<StartDate>);

__PACKAGE__->_factory(
    [ qw(        EndDate
        GraphName
        GraphPeriod
        PrimaryObject
        SecondaryObject
        StartDate

    ) ],
    {
        'EndDate' => \%EndDate_of,
        'GraphName' => \%GraphName_of,
        'GraphPeriod' => \%GraphPeriod_of,
        'PrimaryObject' => \%PrimaryObject_of,
        'SecondaryObject' => \%SecondaryObject_of,
        'StartDate' => \%StartDate_of,
    },
    {
        'EndDate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GraphPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimaryObject' => 'MyTypes::ObjNameOrId',
        'SecondaryObject' => 'MyTypes::ObjNameOrId',
        'StartDate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'EndDate' => 'EndDate',
        'GraphName' => 'GraphName',
        'GraphPeriod' => 'GraphPeriod',
        'PrimaryObject' => 'PrimaryObject',
        'SecondaryObject' => 'SecondaryObject',
        'StartDate' => 'StartDate',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::GraphDataListInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
GraphDataListInfo from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EndDate

 $element->set_EndDate($data);
 $element->get_EndDate();




=item * GraphName

 $element->set_GraphName($data);
 $element->get_GraphName();




=item * GraphPeriod

 $element->set_GraphPeriod($data);
 $element->get_GraphPeriod();




=item * PrimaryObject

 $element->set_PrimaryObject($data);
 $element->get_PrimaryObject();




=item * SecondaryObject

 $element->set_SecondaryObject($data);
 $element->get_SecondaryObject();




=item * StartDate

 $element->set_StartDate($data);
 $element->get_StartDate();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::GraphDataListInfo->new($data);

Constructor. The following data structure may be passed to new():

 {
   EndDate =>  $some_value, # integer
   GraphName =>  $some_value, # string
   GraphPeriod =>  $some_value, # string
   PrimaryObject => $some_value, # ObjNameOrId
   SecondaryObject => $some_value, # ObjNameOrId
   StartDate =>  $some_value, # integer
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

