
package MyElements::GroupMemberListIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('GroupMemberListIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Groups_of :ATTR(:get<Groups>);
my %HideSubgroupMembers_of :ATTR(:get<HideSubgroupMembers>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        Groups
        HideSubgroupMembers
        ObjectManagementFilter
        Type

    ) ],
    {
        'Groups' => \%Groups_of,
        'HideSubgroupMembers' => \%HideSubgroupMembers_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'Type' => \%Type_of,
    },
    {
        'Groups' => 'MyTypes::ArrayOfGroup',
        'HideSubgroupMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Groups' => 'Groups',
        'HideSubgroupMembers' => 'HideSubgroupMembers',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'Type' => 'Type',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::GroupMemberListIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
GroupMemberListIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Groups

 $element->set_Groups($data);
 $element->get_Groups();




=item * HideSubgroupMembers

 $element->set_HideSubgroupMembers($data);
 $element->get_HideSubgroupMembers();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * Type

 $element->set_Type($data);
 $element->get_Type();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::GroupMemberListIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   Groups =>  { # MyTypes::ArrayOfGroup
     Group => $some_value, # Group
   },
   HideSubgroupMembers =>  $some_value, # boolean
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   Type =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

