
package MyElements::GroupSetOptions;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('GroupSetOptions');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %GroupOptionInfo_of :ATTR(:get<GroupOptionInfo>);

__PACKAGE__->_factory(
    [ qw(        GroupNameOrId
        GroupOptionInfo

    ) ],
    {
        'GroupNameOrId' => \%GroupNameOrId_of,
        'GroupOptionInfo' => \%GroupOptionInfo_of,
    },
    {
        'GroupNameOrId' => 'MyTypes::GroupNameOrId',
        'GroupOptionInfo' => 'MyTypes::GroupOptionInfo',
    },
    {

        'GroupNameOrId' => 'GroupNameOrId',
        'GroupOptionInfo' => 'GroupOptionInfo',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::GroupSetOptions

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
GroupSetOptions from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * GroupOptionInfo

 $element->set_GroupOptionInfo($data);
 $element->get_GroupOptionInfo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::GroupSetOptions->new($data);

Constructor. The following data structure may be passed to new():

 {
   GroupNameOrId => $some_value, # GroupNameOrId
   GroupOptionInfo =>  { # MyTypes::GroupOptionInfo
     ChargebackRate =>  $some_value, # string
     GroupContact => $some_value, # EmailAddressList
     GroupOwner =>  $some_value, # string
     SrmMaxLargeFiles => $some_value, # atomic
     SrmMaxNewMtimeFiles => $some_value, # atomic
     SrmMaxOldAtimeFiles => $some_value, # atomic
     SrmMaxOldMtimeFiles => $some_value, # atomic
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

