
package MyElements::HostAdd;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostAdd');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AddNetwork_of :ATTR(:get<AddNetwork>);
my %AdminPort_of :ATTR(:get<AdminPort>);
my %BlockCmode_of :ATTR(:get<BlockCmode>);
my %HostNameOrId_of :ATTR(:get<HostNameOrId>);

__PACKAGE__->_factory(
    [ qw(        AddNetwork
        AdminPort
        BlockCmode
        HostNameOrId

    ) ],
    {
        'AddNetwork' => \%AddNetwork_of,
        'AdminPort' => \%AdminPort_of,
        'BlockCmode' => \%BlockCmode_of,
        'HostNameOrId' => \%HostNameOrId_of,
    },
    {
        'AddNetwork' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'AdminPort' => 'MyElements::HostAdd::_AdminPort',
        'BlockCmode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HostNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AddNetwork' => 'AddNetwork',
        'AdminPort' => 'AdminPort',
        'BlockCmode' => 'BlockCmode',
        'HostNameOrId' => 'HostNameOrId',
    }
);

} # end BLOCK




package MyElements::HostAdd::_AdminPort;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostAdd

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostAdd from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AddNetwork

 $element->set_AddNetwork($data);
 $element->get_AddNetwork();




=item * AdminPort

 $element->set_AdminPort($data);
 $element->get_AdminPort();




=item * BlockCmode

 $element->set_BlockCmode($data);
 $element->get_BlockCmode();




=item * HostNameOrId

 $element->set_HostNameOrId($data);
 $element->get_HostNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostAdd->new($data);

Constructor. The following data structure may be passed to new():

 {
   AddNetwork =>  $some_value, # boolean
   AdminPort => $some_value, # atomic
   BlockCmode =>  $some_value, # boolean
   HostNameOrId =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

