
package MyElements::HostListInfoIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostListInfoIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Hosts_of :ATTR(:get<Hosts>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        Hosts
        Records

    ) ],
    {
        'Hosts' => \%Hosts_of,
        'Records' => \%Records_of,
    },
    {
        'Hosts' => 'MyTypes::ArrayOfHostInfo',

        'Records' => 'MyElements::HostListInfoIterNextResult::_Records',
    },
    {

        'Hosts' => 'Hosts',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::HostListInfoIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostListInfoIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostListInfoIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Hosts

 $element->set_Hosts($data);
 $element->get_Hosts();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostListInfoIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   Hosts =>  { # MyTypes::ArrayOfHostInfo
     HostInfo =>  { # MyTypes::HostInfo
       AdminPort => $some_value, # IpPortNumber
       AdminTransport =>  $some_value, # string
       CifsDomainInfo =>  { # MyTypes::CifsDomainInfo
         CifsDnsDomainName =>  $some_value, # string
         CifsDomainId => $some_value, # atomic
         CifsDomainName =>  $some_value, # string
       },
       HostAddress =>  $some_value, # string
       HostCommunicationStatus =>  $some_value, # string
       HostCredentialsStatus =>  $some_value, # string
       HostDescription =>  $some_value, # string
       HostDpInfo =>  { # MyTypes::HostDpInfo
         Datasets =>  { # MyTypes::ArrayOfDatasetReference
           DatasetReference =>  { # MyTypes::DatasetReference
             DatasetId => $some_value, # ObjId
             DatasetName => $some_value, # ObjName
           },
         },
         HostDataset => $some_value, # ObjName
         HostResourcepool => $some_value, # ObjName
         IsAgentOssvEnabled =>  $some_value, # boolean
         IsDpIgnored =>  $some_value, # boolean
         IsInDataset =>  $some_value, # boolean
         IsLinuxPrimary =>  $some_value, # boolean
         IsNdmpEnabled =>  $some_value, # boolean
         IsNearstore =>  $some_value, # boolean
         IsSnapmirrorEnabled =>  $some_value, # boolean
         IsSnapmirrorHost =>  $some_value, # boolean
         IsSnapvaultEnabled =>  $some_value, # boolean
         IsSnapvaultPrimary =>  $some_value, # boolean
         IsSnapvaultSecondary =>  $some_value, # boolean
         IsUnixPrimary =>  $some_value, # boolean
         IsWindowsOfmPrimary =>  $some_value, # boolean
         IsWindowsPrimary =>  $some_value, # boolean
         NdmpAccessSpecifier =>  $some_value, # string
         SnapmirrorAccessSpecifier =>  $some_value, # string
         SnapvaultAccessSpecifier =>  $some_value, # string
         SnapvaultMaxBackupThreads => $some_value, # atomic
       },
       HostFqdn =>  $some_value, # string
       HostId => $some_value, # HostId
       HostModel =>  $some_value, # string
       HostName =>  $some_value, # string
       HostObjStatus => $some_value, # ObjStatus
       HostOs =>  $some_value, # string
       HostPerfInfo =>  { # MyTypes::HostPerfInfo
         DataUnavailableReason =>  { # MyTypes::ArrayOfPerfStatusError
           PerfStatusError =>  { # MyTypes::PerfStatusError
             Error =>  $some_value, # string
           },
         },
         HostPerfStatus => $some_value, # ObjStatus
         IsDataAvailable =>  $some_value, # boolean
         LastClientStatsCollectionTime => $some_value, # Timestamp
         PercentageSpaceConsumed =>  $some_value, # string
         SpaceConsumed =>  $some_value, # integer
         SpaceProjected =>  $some_value, # integer
       },
       HostStatus =>  $some_value, # string
       HostType => $some_value, # HostType
       HostUsername =>  $some_value, # string
       HostVersion =>  $some_value, # string
       IsAvailable =>  $some_value, # boolean
       Licenses =>  { # MyTypes::ArrayOfLicense
         License => $some_value, # License
       },
       NdmpAgentStatus =>  $some_value, # string
       NdmpCommunicationStatus =>  $some_value, # string
       NdmpCommunicationTimestamp =>  $some_value, # integer
       NdmpCredentials =>  { # MyTypes::NdmpCredentials
         NdmpPassword => $some_value, # HostPassword
         NdmpPort => $some_value, # IpPortNumber
         NdmpUsername => $some_value, # NdmpUsername
       },
       NdmpCredentialsStatus =>  $some_value, # string
       NdmpTimestamp =>  $some_value, # integer
       OtherHostId => $some_value, # HostId
       PartnerStorageSystemId => $some_value, # ObjId
       PartnerStorageSystemName => $some_value, # ObjFullName
       PerfAdvisorTransport => $some_value, # PerfAdvisorTransport
       ServiceStatuses =>  { # MyTypes::ArrayOfServiceStatus
         ServiceStatus =>  { # MyTypes::ServiceStatus
           Service =>  $some_value, # string
         },
       },
       UseHostsEquiv =>  $some_value, # boolean
       VfilerInfo =>  { # MyTypes::VfilerInfo
         HostingFilerId => $some_value, # ObjId
         HostingFilerName => $some_value, # ObjFullName
         VfilerAllowedProtocols =>  { # MyTypes::ArrayOfProtocol
           Protocol => $some_value, # Protocol
         },
         VfilerIpspace =>  $some_value, # string
         VfilerMigrationInfo =>  { # MyTypes::VfilerMigrationInfo
           DestinationFilerId => $some_value, # ObjId
           DestinationFilerName => $some_value, # ObjFullName
           DestinationVfilerId => $some_value, # ObjId
           DestinationVfilerName => $some_value, # ObjFullName
           MigrationStatus => $some_value, # MigrationStatus
           SourceFilerId => $some_value, # ObjId
           SourceFilerName => $some_value, # ObjFullName
           SourceVfilerId => $some_value, # ObjId
           SourceVfilerName => $some_value, # ObjFullName
         },
         VfilerNetworkResources =>  { # MyTypes::ArrayOfVfilerNetworkResource
           VfilerNetworkResource =>  { # MyTypes::VfilerNetworkResource
             InterfaceId => $some_value, # ObjId
             InterfaceName => $some_value, # ObjName
             IpAddress => $some_value, # IpAddress
             MtuSize =>  $some_value, # integer
             PrefixLength =>  $some_value, # integer
           },
         },
       },
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

