
package MyElements::HostListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ExpandFilerToVfilers_of :ATTR(:get<ExpandFilerToVfilers>);
my %HostDpFilterInfo_of :ATTR(:get<HostDpFilterInfo>);
my %HostTypes_of :ATTR(:get<HostTypes>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IncludeMigrationInfo_of :ATTR(:get<IncludeMigrationInfo>);
my %IncludePerfSpaceDetails_of :ATTR(:get<IncludePerfSpaceDetails>);
my %IsDirectMemberOnly_of :ATTR(:get<IsDirectMemberOnly>);
my %LicenseFilter_of :ATTR(:get<LicenseFilter>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %QueryHost_of :ATTR(:get<QueryHost>);
my %VfilerIpspace_of :ATTR(:get<VfilerIpspace>);

__PACKAGE__->_factory(
    [ qw(        ExpandFilerToVfilers
        HostDpFilterInfo
        HostTypes
        IncludeIsAvailable
        IncludeMigrationInfo
        IncludePerfSpaceDetails
        IsDirectMemberOnly
        LicenseFilter
        ObjectManagementFilter
        ObjectNameOrId
        QueryHost
        VfilerIpspace

    ) ],
    {
        'ExpandFilerToVfilers' => \%ExpandFilerToVfilers_of,
        'HostDpFilterInfo' => \%HostDpFilterInfo_of,
        'HostTypes' => \%HostTypes_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IncludeMigrationInfo' => \%IncludeMigrationInfo_of,
        'IncludePerfSpaceDetails' => \%IncludePerfSpaceDetails_of,
        'IsDirectMemberOnly' => \%IsDirectMemberOnly_of,
        'LicenseFilter' => \%LicenseFilter_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'QueryHost' => \%QueryHost_of,
        'VfilerIpspace' => \%VfilerIpspace_of,
    },
    {
        'ExpandFilerToVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HostDpFilterInfo' => 'MyTypes::HostDpFilterInfo',
        'HostTypes' => 'MyTypes::ArrayOfHostType',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludePerfSpaceDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LicenseFilter' => 'MyTypes::ArrayOfLicense',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'QueryHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'VfilerIpspace' => 'MyTypes::VfilerIpspace',
    },
    {

        'ExpandFilerToVfilers' => 'ExpandFilerToVfilers',
        'HostDpFilterInfo' => 'HostDpFilterInfo',
        'HostTypes' => 'HostTypes',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IncludeMigrationInfo' => 'IncludeMigrationInfo',
        'IncludePerfSpaceDetails' => 'IncludePerfSpaceDetails',
        'IsDirectMemberOnly' => 'IsDirectMemberOnly',
        'LicenseFilter' => 'LicenseFilter',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'QueryHost' => 'QueryHost',
        'VfilerIpspace' => 'VfilerIpspace',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ExpandFilerToVfilers

 $element->set_ExpandFilerToVfilers($data);
 $element->get_ExpandFilerToVfilers();




=item * HostDpFilterInfo

 $element->set_HostDpFilterInfo($data);
 $element->get_HostDpFilterInfo();




=item * HostTypes

 $element->set_HostTypes($data);
 $element->get_HostTypes();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IncludeMigrationInfo

 $element->set_IncludeMigrationInfo($data);
 $element->get_IncludeMigrationInfo();




=item * IncludePerfSpaceDetails

 $element->set_IncludePerfSpaceDetails($data);
 $element->get_IncludePerfSpaceDetails();




=item * IsDirectMemberOnly

 $element->set_IsDirectMemberOnly($data);
 $element->get_IsDirectMemberOnly();




=item * LicenseFilter

 $element->set_LicenseFilter($data);
 $element->get_LicenseFilter();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * QueryHost

 $element->set_QueryHost($data);
 $element->get_QueryHost();




=item * VfilerIpspace

 $element->set_VfilerIpspace($data);
 $element->get_VfilerIpspace();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   ExpandFilerToVfilers =>  $some_value, # boolean
   HostDpFilterInfo =>  { # MyTypes::HostDpFilterInfo
     IsDpIgnored =>  $some_value, # boolean
     IsInDataset =>  $some_value, # boolean
     IsInResourcepool =>  $some_value, # boolean
     IsSnapmirroredOnly =>  $some_value, # boolean
     IsSnapvaultPrimaryOnly =>  $some_value, # boolean
     IsSnapvaultSecondaryOnly =>  $some_value, # boolean
     IsUnprotected =>  $some_value, # boolean
   },
   HostTypes =>  { # MyTypes::ArrayOfHostType
     HostType => $some_value, # HostType
   },
   IncludeIsAvailable =>  $some_value, # boolean
   IncludeMigrationInfo =>  $some_value, # boolean
   IncludePerfSpaceDetails =>  $some_value, # boolean
   IsDirectMemberOnly =>  $some_value, # boolean
   LicenseFilter =>  { # MyTypes::ArrayOfLicense
     License => $some_value, # License
   },
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   ObjectNameOrId => $some_value, # ObjNameOrId
   QueryHost =>  $some_value, # boolean
   VfilerIpspace => $some_value, # VfilerIpspace
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

