
package MyElements::HostModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostModifyInfo_of :ATTR(:get<HostModifyInfo>);
my %HostNameOrId_of :ATTR(:get<HostNameOrId>);

__PACKAGE__->_factory(
    [ qw(        HostModifyInfo
        HostNameOrId

    ) ],
    {
        'HostModifyInfo' => \%HostModifyInfo_of,
        'HostNameOrId' => \%HostNameOrId_of,
    },
    {
        'HostModifyInfo' => 'MyTypes::HostModifyInfo',
        'HostNameOrId' => 'MyTypes::HostNameOrId',
    },
    {

        'HostModifyInfo' => 'HostModifyInfo',
        'HostNameOrId' => 'HostNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostModifyInfo

 $element->set_HostModifyInfo($data);
 $element->get_HostModifyInfo();




=item * HostNameOrId

 $element->set_HostNameOrId($data);
 $element->get_HostNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   HostModifyInfo =>  { # MyTypes::HostModifyInfo
     AdminPort => $some_value, # IpPortNumber
     AdminTransport =>  $some_value, # string
     HostAddress =>  $some_value, # string
     HostDescription =>  $some_value, # string
     HostDpModifyInfo =>  { # MyTypes::HostDpModifyInfo
       IsDpIgnored =>  $some_value, # boolean
       SnapvaultMaxBackupThreads => $some_value, # atomic
     },
     HostName => $some_value, # ObjName
     HostPassword => $some_value, # HostPassword
     HostUsername =>  $some_value, # string
     NdmpCredentials =>  { # MyTypes::NdmpCredentials
       NdmpPassword => $some_value, # HostPassword
       NdmpPort => $some_value, # IpPortNumber
       NdmpUsername => $some_value, # NdmpUsername
     },
     PerfAdvisorTransport => $some_value, # PerfAdvisorTransport
     UseHostsEquiv =>  $some_value, # boolean
   },
   HostNameOrId => $some_value, # HostNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

