
package MyElements::HostModifyAgentCredentials;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostModifyAgentCredentials');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AgentNameOrId_of :ATTR(:get<AgentNameOrId>);
my %ManagementPassword_of :ATTR(:get<ManagementPassword>);
my %OsPassword_of :ATTR(:get<OsPassword>);
my %OsUsername_of :ATTR(:get<OsUsername>);

__PACKAGE__->_factory(
    [ qw(        AgentNameOrId
        ManagementPassword
        OsPassword
        OsUsername

    ) ],
    {
        'AgentNameOrId' => \%AgentNameOrId_of,
        'ManagementPassword' => \%ManagementPassword_of,
        'OsPassword' => \%OsPassword_of,
        'OsUsername' => \%OsUsername_of,
    },
    {
        'AgentNameOrId' => 'MyTypes::HostNameOrId',
        'ManagementPassword' => 'MyTypes::HostPassword',
        'OsPassword' => 'MyTypes::HostPassword',
        'OsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AgentNameOrId' => 'AgentNameOrId',
        'ManagementPassword' => 'ManagementPassword',
        'OsPassword' => 'OsPassword',
        'OsUsername' => 'OsUsername',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostModifyAgentCredentials

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostModifyAgentCredentials from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AgentNameOrId

 $element->set_AgentNameOrId($data);
 $element->get_AgentNameOrId();




=item * ManagementPassword

 $element->set_ManagementPassword($data);
 $element->get_ManagementPassword();




=item * OsPassword

 $element->set_OsPassword($data);
 $element->get_OsPassword();




=item * OsUsername

 $element->set_OsUsername($data);
 $element->get_OsUsername();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostModifyAgentCredentials->new($data);

Constructor. The following data structure may be passed to new():

 {
   AgentNameOrId => $some_value, # HostNameOrId
   ManagementPassword => $some_value, # HostPassword
   OsPassword => $some_value, # HostPassword
   OsUsername =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

