
package MyElements::HostSetOption;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('HostSetOption');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostNameOrId_of :ATTR(:get<HostNameOrId>);
my %HostOptionName_of :ATTR(:get<HostOptionName>);
my %HostOptionValue_of :ATTR(:get<HostOptionValue>);

__PACKAGE__->_factory(
    [ qw(        HostNameOrId
        HostOptionName
        HostOptionValue

    ) ],
    {
        'HostNameOrId' => \%HostNameOrId_of,
        'HostOptionName' => \%HostOptionName_of,
        'HostOptionValue' => \%HostOptionValue_of,
    },
    {
        'HostNameOrId' => 'MyTypes::HostNameOrId',
        'HostOptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostOptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'HostNameOrId' => 'HostNameOrId',
        'HostOptionName' => 'HostOptionName',
        'HostOptionValue' => 'HostOptionValue',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::HostSetOption

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
HostSetOption from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostNameOrId

 $element->set_HostNameOrId($data);
 $element->get_HostNameOrId();




=item * HostOptionName

 $element->set_HostOptionName($data);
 $element->get_HostOptionName();




=item * HostOptionValue

 $element->set_HostOptionValue($data);
 $element->get_HostOptionValue();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::HostSetOption->new($data);

Constructor. The following data structure may be passed to new():

 {
   HostNameOrId => $some_value, # HostNameOrId
   HostOptionName =>  $some_value, # string
   HostOptionValue =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

