
package MyElements::MigrateComplete;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('MigrateComplete');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DryRun_of :ATTR(:get<DryRun>);
my %MaxCutoverTime_of :ATTR(:get<MaxCutoverTime>);
my %MigrateOffline_of :ATTR(:get<MigrateOffline>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %PersistentMigratedRoutes_of :ATTR(:get<PersistentMigratedRoutes>);
my %RouteMigrationMode_of :ATTR(:get<RouteMigrationMode>);
my %RunDedupeScan_of :ATTR(:get<RunDedupeScan>);
my %ScriptPath_of :ATTR(:get<ScriptPath>);

__PACKAGE__->_factory(
    [ qw(        DryRun
        MaxCutoverTime
        MigrateOffline
        ObjectNameOrId
        PersistentMigratedRoutes
        RouteMigrationMode
        RunDedupeScan
        ScriptPath

    ) ],
    {
        'DryRun' => \%DryRun_of,
        'MaxCutoverTime' => \%MaxCutoverTime_of,
        'MigrateOffline' => \%MigrateOffline_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'PersistentMigratedRoutes' => \%PersistentMigratedRoutes_of,
        'RouteMigrationMode' => \%RouteMigrationMode_of,
        'RunDedupeScan' => \%RunDedupeScan_of,
        'ScriptPath' => \%ScriptPath_of,
    },
    {
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MaxCutoverTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MigrateOffline' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'PersistentMigratedRoutes' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'RouteMigrationMode' => 'MyTypes::RouteMigrationMode',
        'RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DryRun' => 'DryRun',
        'MaxCutoverTime' => 'MaxCutoverTime',
        'MigrateOffline' => 'MigrateOffline',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'PersistentMigratedRoutes' => 'PersistentMigratedRoutes',
        'RouteMigrationMode' => 'RouteMigrationMode',
        'RunDedupeScan' => 'RunDedupeScan',
        'ScriptPath' => 'ScriptPath',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::MigrateComplete

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
MigrateComplete from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * MaxCutoverTime

 $element->set_MaxCutoverTime($data);
 $element->get_MaxCutoverTime();




=item * MigrateOffline

 $element->set_MigrateOffline($data);
 $element->get_MigrateOffline();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * PersistentMigratedRoutes

 $element->set_PersistentMigratedRoutes($data);
 $element->get_PersistentMigratedRoutes();




=item * RouteMigrationMode

 $element->set_RouteMigrationMode($data);
 $element->get_RouteMigrationMode();




=item * RunDedupeScan

 $element->set_RunDedupeScan($data);
 $element->get_RunDedupeScan();




=item * ScriptPath

 $element->set_ScriptPath($data);
 $element->get_ScriptPath();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::MigrateComplete->new($data);

Constructor. The following data structure may be passed to new():

 {
   DryRun =>  $some_value, # boolean
   MaxCutoverTime =>  $some_value, # integer
   MigrateOffline =>  $some_value, # boolean
   ObjectNameOrId => $some_value, # ObjNameOrId
   PersistentMigratedRoutes =>  $some_value, # boolean
   RouteMigrationMode => $some_value, # RouteMigrationMode
   RunDedupeScan =>  $some_value, # boolean
   ScriptPath =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

