
package MyElements::MigrateStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('MigrateStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BandwidthThrottle_of :ATTR(:get<BandwidthThrottle>);
my %Description_of :ATTR(:get<Description>);
my %DryRun_of :ATTR(:get<DryRun>);
my %IpBindings_of :ATTR(:get<IpBindings>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %OnlineMigration_of :ATTR(:get<OnlineMigration>);
my %PerformCutover_of :ATTR(:get<PerformCutover>);
my %PersistentMigratedRoutes_of :ATTR(:get<PersistentMigratedRoutes>);
my %ProvisioningPolicyNameOrId_of :ATTR(:get<ProvisioningPolicyNameOrId>);
my %ResourceNameOrId_of :ATTR(:get<ResourceNameOrId>);
my %RouteMigrationMode_of :ATTR(:get<RouteMigrationMode>);
my %RunDedupeScan_of :ATTR(:get<RunDedupeScan>);
my %ScriptPath_of :ATTR(:get<ScriptPath>);
my %VolumeAggregateMap_of :ATTR(:get<VolumeAggregateMap>);

__PACKAGE__->_factory(
    [ qw(        BandwidthThrottle
        Description
        DryRun
        IpBindings
        ObjectNameOrId
        OnlineMigration
        PerformCutover
        PersistentMigratedRoutes
        ProvisioningPolicyNameOrId
        ResourceNameOrId
        RouteMigrationMode
        RunDedupeScan
        ScriptPath
        VolumeAggregateMap

    ) ],
    {
        'BandwidthThrottle' => \%BandwidthThrottle_of,
        'Description' => \%Description_of,
        'DryRun' => \%DryRun_of,
        'IpBindings' => \%IpBindings_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'OnlineMigration' => \%OnlineMigration_of,
        'PerformCutover' => \%PerformCutover_of,
        'PersistentMigratedRoutes' => \%PersistentMigratedRoutes_of,
        'ProvisioningPolicyNameOrId' => \%ProvisioningPolicyNameOrId_of,
        'ResourceNameOrId' => \%ResourceNameOrId_of,
        'RouteMigrationMode' => \%RouteMigrationMode_of,
        'RunDedupeScan' => \%RunDedupeScan_of,
        'ScriptPath' => \%ScriptPath_of,
        'VolumeAggregateMap' => \%VolumeAggregateMap_of,
    },
    {

        'BandwidthThrottle' => 'MyElements::MigrateStart::_BandwidthThrottle',

        'Description' => 'MyElements::MigrateStart::_Description',
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IpBindings' => 'MyTypes::ArrayOfIpBindingInfo',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PerformCutover' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PersistentMigratedRoutes' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'ResourceNameOrId' => 'MyTypes::ObjNameOrId',
        'RouteMigrationMode' => 'MyTypes::RouteMigrationMode',
        'RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeAggregateMap' => 'MyTypes::ArrayOfVolumeAggregatePair',
    },
    {

        'BandwidthThrottle' => 'BandwidthThrottle',
        'Description' => 'Description',
        'DryRun' => 'DryRun',
        'IpBindings' => 'IpBindings',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'OnlineMigration' => 'OnlineMigration',
        'PerformCutover' => 'PerformCutover',
        'PersistentMigratedRoutes' => 'PersistentMigratedRoutes',
        'ProvisioningPolicyNameOrId' => 'ProvisioningPolicyNameOrId',
        'ResourceNameOrId' => 'ResourceNameOrId',
        'RouteMigrationMode' => 'RouteMigrationMode',
        'RunDedupeScan' => 'RunDedupeScan',
        'ScriptPath' => 'ScriptPath',
        'VolumeAggregateMap' => 'VolumeAggregateMap',
    }
);

} # end BLOCK




package MyElements::MigrateStart::_BandwidthThrottle;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::MigrateStart::_Description;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::MigrateStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
MigrateStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BandwidthThrottle

 $element->set_BandwidthThrottle($data);
 $element->get_BandwidthThrottle();




=item * Description

 $element->set_Description($data);
 $element->get_Description();




=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * IpBindings

 $element->set_IpBindings($data);
 $element->get_IpBindings();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * OnlineMigration

 $element->set_OnlineMigration($data);
 $element->get_OnlineMigration();




=item * PerformCutover

 $element->set_PerformCutover($data);
 $element->get_PerformCutover();




=item * PersistentMigratedRoutes

 $element->set_PersistentMigratedRoutes($data);
 $element->get_PersistentMigratedRoutes();




=item * ProvisioningPolicyNameOrId

 $element->set_ProvisioningPolicyNameOrId($data);
 $element->get_ProvisioningPolicyNameOrId();




=item * ResourceNameOrId

 $element->set_ResourceNameOrId($data);
 $element->get_ResourceNameOrId();




=item * RouteMigrationMode

 $element->set_RouteMigrationMode($data);
 $element->get_RouteMigrationMode();




=item * RunDedupeScan

 $element->set_RunDedupeScan($data);
 $element->get_RunDedupeScan();




=item * ScriptPath

 $element->set_ScriptPath($data);
 $element->get_ScriptPath();




=item * VolumeAggregateMap

 $element->set_VolumeAggregateMap($data);
 $element->get_VolumeAggregateMap();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::MigrateStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   BandwidthThrottle => $some_value, # atomic
   Description => $some_value, # atomic
   DryRun =>  $some_value, # boolean
   IpBindings =>  { # MyTypes::ArrayOfIpBindingInfo
     IpBindingInfo =>  { # MyTypes::IpBindingInfo
       Interface => $some_value, # ObjNameOrId
       IpAddress => $some_value, # IpAddress
       MtuSize => $some_value, # atomic
       Netmask =>  $some_value, # string
       PartnerInterface => $some_value, # ObjNameOrId
       PrefixLength => $some_value, # atomic
       VlanIdentifier => $some_value, # atomic
     },
   },
   ObjectNameOrId => $some_value, # ObjNameOrId
   OnlineMigration =>  $some_value, # boolean
   PerformCutover =>  $some_value, # boolean
   PersistentMigratedRoutes =>  $some_value, # boolean
   ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
   ResourceNameOrId => $some_value, # ObjNameOrId
   RouteMigrationMode => $some_value, # RouteMigrationMode
   RunDedupeScan =>  $some_value, # boolean
   ScriptPath =>  $some_value, # string
   VolumeAggregateMap =>  { # MyTypes::ArrayOfVolumeAggregatePair
     VolumeAggregatePair =>  { # MyTypes::VolumeAggregatePair
       Aggregate => $some_value, # ObjNameOrId
       Volume => $some_value, # ObjNameOrId
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

