
package MyElements::MigrateVolume;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('MigrateVolume');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DryRun_of :ATTR(:get<DryRun>);
my %MigrationRequestInfo_of :ATTR(:get<MigrationRequestInfo>);

__PACKAGE__->_factory(
    [ qw(        DryRun
        MigrationRequestInfo

    ) ],
    {
        'DryRun' => \%DryRun_of,
        'MigrationRequestInfo' => \%MigrationRequestInfo_of,
    },
    {
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MigrationRequestInfo' => 'MyTypes::MigrationRequestInfo',
    },
    {

        'DryRun' => 'DryRun',
        'MigrationRequestInfo' => 'MigrationRequestInfo',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::MigrateVolume

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
MigrateVolume from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * MigrationRequestInfo

 $element->set_MigrationRequestInfo($data);
 $element->get_MigrationRequestInfo();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::MigrateVolume->new($data);

Constructor. The following data structure may be passed to new():

 {
   DryRun =>  $some_value, # boolean
   MigrationRequestInfo =>  { # MyTypes::MigrationRequestInfo
     CleanupStaleStorage => $some_value, # CleanupStaleStorage
     DestinationAggregateNameOrId => $some_value, # ObjNameOrId
     RetentionType => $some_value, # DpBackupRetentionType
     RunDedupeScan =>  $some_value, # boolean
     RunOnDemandUpdate =>  $some_value, # boolean
     Volumes =>  { # MyTypes::ArrayOfObjNameOrId
       ObjNameOrId => $some_value, # ObjNameOrId
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

