
package MyElements::MigrateVolumeResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('MigrateVolumeResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %MigrationDryRunResults_of :ATTR(:get<MigrationDryRunResults>);
my %MigrationJobs_of :ATTR(:get<MigrationJobs>);

__PACKAGE__->_factory(
    [ qw(        MigrationDryRunResults
        MigrationJobs

    ) ],
    {
        'MigrationDryRunResults' => \%MigrationDryRunResults_of,
        'MigrationJobs' => \%MigrationJobs_of,
    },
    {
        'MigrationDryRunResults' => 'MyTypes::ArrayOfMigrationDryRunResult',
        'MigrationJobs' => 'MyTypes::ArrayOfMigrationJobInfo',
    },
    {

        'MigrationDryRunResults' => 'MigrationDryRunResults',
        'MigrationJobs' => 'MigrationJobs',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::MigrateVolumeResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
MigrateVolumeResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * MigrationDryRunResults

 $element->set_MigrationDryRunResults($data);
 $element->get_MigrationDryRunResults();




=item * MigrationJobs

 $element->set_MigrationJobs($data);
 $element->get_MigrationJobs();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::MigrateVolumeResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   MigrationDryRunResults =>  { # MyTypes::ArrayOfMigrationDryRunResult
     MigrationDryRunResult =>  { # MyTypes::MigrationDryRunResult
       DryRunResults =>  { # MyTypes::ArrayOfDryRunResult
         DryRunResult =>  { # MyTypes::DryRunResult
           DryRunAction =>  $some_value, # string
           DryRunEffect =>  $some_value, # string
           DryRunReason =>  $some_value, # string
           DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
             ResultDetail =>  { # MyTypes::ResultDetail
               Action =>  $some_value, # string
               Effect =>  $some_value, # string
               Reason =>  $some_value, # string
               Severity => $some_value, # ObjStatus
               Suggestion =>  $some_value, # string
             },
           },
           DryRunSeverity => $some_value, # ObjStatus
           DryRunSuggestion =>  $some_value, # string
         },
       },
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
   MigrationJobs =>  { # MyTypes::ArrayOfMigrationJobInfo
     MigrationJobInfo =>  { # MyTypes::MigrationJobInfo
       JobId =>  $some_value, # integer
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

