
package MyElements::PerfCopyCounterConfiguration;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCopyCounterConfiguration');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DestinationObjects_of :ATTR(:get<DestinationObjects>);
my %Preview_of :ATTR(:get<Preview>);
my %SourceHostNameOrId_of :ATTR(:get<SourceHostNameOrId>);
my %SrcIsDefault_of :ATTR(:get<SrcIsDefault>);

__PACKAGE__->_factory(
    [ qw(        DestinationObjects
        Preview
        SourceHostNameOrId
        SrcIsDefault

    ) ],
    {
        'DestinationObjects' => \%DestinationObjects_of,
        'Preview' => \%Preview_of,
        'SourceHostNameOrId' => \%SourceHostNameOrId_of,
        'SrcIsDefault' => \%SrcIsDefault_of,
    },
    {
        'DestinationObjects' => 'MyTypes::ArrayOfObjNameOrId',
        'Preview' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'SourceHostNameOrId' => 'MyTypes::HostNameOrId',
        'SrcIsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DestinationObjects' => 'DestinationObjects',
        'Preview' => 'Preview',
        'SourceHostNameOrId' => 'SourceHostNameOrId',
        'SrcIsDefault' => 'SrcIsDefault',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCopyCounterConfiguration

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCopyCounterConfiguration from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DestinationObjects

 $element->set_DestinationObjects($data);
 $element->get_DestinationObjects();




=item * Preview

 $element->set_Preview($data);
 $element->get_Preview();




=item * SourceHostNameOrId

 $element->set_SourceHostNameOrId($data);
 $element->get_SourceHostNameOrId();




=item * SrcIsDefault

 $element->set_SrcIsDefault($data);
 $element->get_SrcIsDefault();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCopyCounterConfiguration->new($data);

Constructor. The following data structure may be passed to new():

 {
   DestinationObjects =>  { # MyTypes::ArrayOfObjNameOrId
     ObjNameOrId => $some_value, # ObjNameOrId
   },
   Preview =>  $some_value, # boolean
   SourceHostNameOrId => $some_value, # HostNameOrId
   SrcIsDefault =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

