
package MyElements::PerfCopyCounterConfigurationResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCopyCounterConfigurationResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CopyResult_of :ATTR(:get<CopyResult>);
my %MissingHostObjectCounters_of :ATTR(:get<MissingHostObjectCounters>);
my %PurgedHostObjectCounters_of :ATTR(:get<PurgedHostObjectCounters>);

__PACKAGE__->_factory(
    [ qw(        CopyResult
        MissingHostObjectCounters
        PurgedHostObjectCounters

    ) ],
    {
        'CopyResult' => \%CopyResult_of,
        'MissingHostObjectCounters' => \%MissingHostObjectCounters_of,
        'PurgedHostObjectCounters' => \%PurgedHostObjectCounters_of,
    },
    {
        'CopyResult' => 'MyTypes::ArrayOfDestinationHostInfo',
        'MissingHostObjectCounters' => 'MyTypes::ArrayOfPerfMissingHostObjectCounter',
        'PurgedHostObjectCounters' => 'MyTypes::ArrayOfPerfPurgedHostObjectCounter',
    },
    {

        'CopyResult' => 'CopyResult',
        'MissingHostObjectCounters' => 'MissingHostObjectCounters',
        'PurgedHostObjectCounters' => 'PurgedHostObjectCounters',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCopyCounterConfigurationResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCopyCounterConfigurationResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CopyResult

 $element->set_CopyResult($data);
 $element->get_CopyResult();




=item * MissingHostObjectCounters

 $element->set_MissingHostObjectCounters($data);
 $element->get_MissingHostObjectCounters();




=item * PurgedHostObjectCounters

 $element->set_PurgedHostObjectCounters($data);
 $element->get_PurgedHostObjectCounters();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCopyCounterConfigurationResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   CopyResult =>  { # MyTypes::ArrayOfDestinationHostInfo
     DestinationHostInfo =>  { # MyTypes::DestinationHostInfo
       ErrorReason =>  $some_value, # string
       HostId => $some_value, # ObjId
       HostName => $some_value, # ObjFullName
     },
   },
   MissingHostObjectCounters =>  { # MyTypes::ArrayOfPerfMissingHostObjectCounter
     PerfMissingHostObjectCounter =>  { # MyTypes::PerfMissingHostObjectCounter
       HostNameOrId => $some_value, # HostNameOrId
       MissingObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
     },
   },
   PurgedHostObjectCounters =>  { # MyTypes::ArrayOfPerfPurgedHostObjectCounter
     PerfPurgedHostObjectCounter =>  { # MyTypes::PerfPurgedHostObjectCounter
       HostNameOrId => $some_value, # HostNameOrId
       PurgedObjectCountersDetails =>  { # MyTypes::ArrayOfPerfPurgedObjectCountersDetails
         PerfPurgedObjectCountersDetails =>  { # MyTypes::PerfPurgedObjectCountersDetails
           CurrentRetentionPeriod =>  $some_value, # integer
           NewRetentionPeriod =>  $some_value, # integer
           PurgedObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
             PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
               CounterDescription =>  $some_value, # string
               CounterName =>  $some_value, # string
               IsCalculatedStats =>  $some_value, # boolean
               LabelNames =>  $some_value, # string
               Metrics =>  { # MyTypes::ArrayOfMetric
                 Metric =>  { # MyTypes::Metric
                   Id =>  $some_value, # string
                   MetricResult =>  $some_value, # string
                   Period => $some_value, # atomic
                   Slide =>  $some_value, # string
                   Type =>  $some_value, # string
                   Value =>  $some_value, # string
                 },
               },
               ObjectType =>  $some_value, # string
               PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
                 PerfLabel =>  { # MyTypes::PerfLabel
                   LabelNames =>  $some_value, # string
                 },
               },
               TimeConsolidationMethod =>  $some_value, # string
             },
           },
         },
       },
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

