
package MyElements::PerfCounterGroupGetData;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCounterGroupGetData');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %DataGroup_of :ATTR(:get<DataGroup>);
my %EndTime_of :ATTR(:get<EndTime>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %SampleRate_of :ATTR(:get<SampleRate>);
my %StartTime_of :ATTR(:get<StartTime>);
my %TimeConsolidationMethod_of :ATTR(:get<TimeConsolidationMethod>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        CounterGroupName
        DataGroup
        EndTime
        GroupNameOrId
        SampleRate
        StartTime
        TimeConsolidationMethod

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'DataGroup' => \%DataGroup_of,
        'EndTime' => \%EndTime_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'SampleRate' => \%SampleRate_of,
        'StartTime' => \%StartTime_of,
        'TimeConsolidationMethod' => \%TimeConsolidationMethod_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
        'EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'CounterGroupName' => 'CounterGroupName',
        'DataGroup' => 'DataGroup',
        'EndTime' => 'EndTime',
        'GroupNameOrId' => 'GroupNameOrId',
        'SampleRate' => 'SampleRate',
        'StartTime' => 'StartTime',
        'TimeConsolidationMethod' => 'TimeConsolidationMethod',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCounterGroupGetData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCounterGroupGetData from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId

 $element->set_ApplianceNameOrId($data);
 $element->get_ApplianceNameOrId();




=item * CounterGroupName

 $element->set_CounterGroupName($data);
 $element->get_CounterGroupName();




=item * DataGroup

 $element->set_DataGroup($data);
 $element->get_DataGroup();




=item * EndTime

 $element->set_EndTime($data);
 $element->get_EndTime();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * SampleRate

 $element->set_SampleRate($data);
 $element->get_SampleRate();




=item * StartTime

 $element->set_StartTime($data);
 $element->get_StartTime();




=item * TimeConsolidationMethod

 $element->set_TimeConsolidationMethod($data);
 $element->get_TimeConsolidationMethod();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCounterGroupGetData->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplianceNameOrId =>  $some_value, # string
   CounterGroupName =>  $some_value, # string
   DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
     PerfDataGroup =>  { # MyTypes::PerfDataGroup
       DataGroupMethod =>  $some_value, # string
       DataSources =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
     },
   },
   EndTime =>  $some_value, # integer
   GroupNameOrId =>  $some_value, # string
   SampleRate =>  $some_value, # integer
   StartTime =>  $some_value, # integer
   TimeConsolidationMethod =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

