
package MyElements::PerfCounterGroupGetDynamicDataSources;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCounterGroupGetDynamicDataSources');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %DynamicDataSources_of :ATTR(:get<DynamicDataSources>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        CounterGroupName
        DynamicDataSources
        GroupNameOrId

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'DynamicDataSources' => \%DynamicDataSources_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'CounterGroupName' => 'CounterGroupName',
        'DynamicDataSources' => 'DynamicDataSources',
        'GroupNameOrId' => 'GroupNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCounterGroupGetDynamicDataSources

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCounterGroupGetDynamicDataSources from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId

 $element->set_ApplianceNameOrId($data);
 $element->get_ApplianceNameOrId();




=item * CounterGroupName

 $element->set_CounterGroupName($data);
 $element->get_CounterGroupName();




=item * DynamicDataSources

 $element->set_DynamicDataSources($data);
 $element->get_DynamicDataSources();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCounterGroupGetDynamicDataSources->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplianceNameOrId =>  $some_value, # string
   CounterGroupName =>  $some_value, # string
   DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
     PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
       Color =>  $some_value, # string
       DataSource =>  { # MyTypes::WrapperOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       MaximumInstances =>  $some_value, # integer
       SelectAllInstances =>  $some_value, # boolean
       SortOrder =>  $some_value, # string
       TimeInterval =>  $some_value, # integer
     },
   },
   GroupNameOrId =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

