
package MyElements::PerfCounterGroupListInfo;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCounterGroupListInfo');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %ConsolidateHosts_of :ATTR(:get<ConsolidateHosts>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %CounterInfoOnly_of :ATTR(:get<CounterInfoOnly>);
my %CustomOnly_of :ATTR(:get<CustomOnly>);
my %DisabledCounterInfoOnly_of :ATTR(:get<DisabledCounterInfoOnly>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %IncludeCalculatedStats_of :ATTR(:get<IncludeCalculatedStats>);
my %MetaDataOnly_of :ATTR(:get<MetaDataOnly>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        ConsolidateHosts
        CounterGroupName
        CounterInfoOnly
        CustomOnly
        DisabledCounterInfoOnly
        GroupNameOrId
        IncludeCalculatedStats
        MetaDataOnly
        ObjectNameOrId

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'ConsolidateHosts' => \%ConsolidateHosts_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'CounterInfoOnly' => \%CounterInfoOnly_of,
        'CustomOnly' => \%CustomOnly_of,
        'DisabledCounterInfoOnly' => \%DisabledCounterInfoOnly_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'IncludeCalculatedStats' => \%IncludeCalculatedStats_of,
        'MetaDataOnly' => \%MetaDataOnly_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConsolidateHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterInfoOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'CustomOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DisabledCounterInfoOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IncludeCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MetaDataOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'ConsolidateHosts' => 'ConsolidateHosts',
        'CounterGroupName' => 'CounterGroupName',
        'CounterInfoOnly' => 'CounterInfoOnly',
        'CustomOnly' => 'CustomOnly',
        'DisabledCounterInfoOnly' => 'DisabledCounterInfoOnly',
        'GroupNameOrId' => 'GroupNameOrId',
        'IncludeCalculatedStats' => 'IncludeCalculatedStats',
        'MetaDataOnly' => 'MetaDataOnly',
        'ObjectNameOrId' => 'ObjectNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCounterGroupListInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCounterGroupListInfo from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId

 $element->set_ApplianceNameOrId($data);
 $element->get_ApplianceNameOrId();




=item * ConsolidateHosts

 $element->set_ConsolidateHosts($data);
 $element->get_ConsolidateHosts();




=item * CounterGroupName

 $element->set_CounterGroupName($data);
 $element->get_CounterGroupName();




=item * CounterInfoOnly

 $element->set_CounterInfoOnly($data);
 $element->get_CounterInfoOnly();




=item * CustomOnly

 $element->set_CustomOnly($data);
 $element->get_CustomOnly();




=item * DisabledCounterInfoOnly

 $element->set_DisabledCounterInfoOnly($data);
 $element->get_DisabledCounterInfoOnly();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * IncludeCalculatedStats

 $element->set_IncludeCalculatedStats($data);
 $element->get_IncludeCalculatedStats();




=item * MetaDataOnly

 $element->set_MetaDataOnly($data);
 $element->get_MetaDataOnly();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCounterGroupListInfo->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplianceNameOrId =>  $some_value, # string
   ConsolidateHosts =>  $some_value, # boolean
   CounterGroupName =>  $some_value, # string
   CounterInfoOnly =>  $some_value, # boolean
   CustomOnly =>  $some_value, # boolean
   DisabledCounterInfoOnly =>  $some_value, # boolean
   GroupNameOrId =>  $some_value, # string
   IncludeCalculatedStats =>  $some_value, # boolean
   MetaDataOnly =>  $some_value, # boolean
   ObjectNameOrId => $some_value, # ObjNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

