
package MyElements::PerfCounterGroupListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCounterGroupListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterGroups_of :ATTR(:get<CounterGroups>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        CounterGroups
        Records

    ) ],
    {
        'CounterGroups' => \%CounterGroups_of,
        'Records' => \%Records_of,
    },
    {
        'CounterGroups' => 'MyTypes::ArrayOfPerfCounterGroup',

        'Records' => 'MyElements::PerfCounterGroupListIterNextResult::_Records',
    },
    {

        'CounterGroups' => 'CounterGroups',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::PerfCounterGroupListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCounterGroupListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCounterGroupListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterGroups

 $element->set_CounterGroups($data);
 $element->get_CounterGroups();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCounterGroupListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   CounterGroups =>  { # MyTypes::ArrayOfPerfCounterGroup
     PerfCounterGroup =>  { # MyTypes::PerfCounterGroup
       ApplianceNameOrId =>  $some_value, # string
       CounterGroupName =>  $some_value, # string
       CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
       DataSources =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       EndTime =>  $some_value, # integer
       GroupNameOrId =>  $some_value, # string
       IsDefault =>  $some_value, # boolean
       IsDisableAll =>  $some_value, # boolean
       IsStopped =>  $some_value, # boolean
       NumberRecords =>  $some_value, # integer
       PerfFileName =>  $some_value, # string
       RealTime =>  $some_value, # boolean
       SampleBuffer =>  $some_value, # integer
       SampleRate =>  $some_value, # integer
       SpaceConsumed =>  $some_value, # unsignedLong
       SpaceProjected =>  $some_value, # unsignedLong
       StartTime =>  $some_value, # integer
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

