
package MyElements::PerfCounterGroupModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfCounterGroupModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %CounterGroup_of :ATTR(:get<CounterGroup>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        CounterGroup
        CounterGroupName
        GroupNameOrId

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'CounterGroup' => \%CounterGroup_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterGroup' => 'MyTypes::WrapperOfPerfCounterGroup',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'CounterGroup' => 'CounterGroup',
        'CounterGroupName' => 'CounterGroupName',
        'GroupNameOrId' => 'GroupNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfCounterGroupModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfCounterGroupModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId

 $element->set_ApplianceNameOrId($data);
 $element->get_ApplianceNameOrId();




=item * CounterGroup

 $element->set_CounterGroup($data);
 $element->get_CounterGroup();




=item * CounterGroupName

 $element->set_CounterGroupName($data);
 $element->get_CounterGroupName();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfCounterGroupModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplianceNameOrId =>  $some_value, # string
   CounterGroup =>  { # MyTypes::WrapperOfPerfCounterGroup
     PerfCounterGroup =>  { # MyTypes::PerfCounterGroup
       ApplianceNameOrId =>  $some_value, # string
       CounterGroupName =>  $some_value, # string
       CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
       DataSources =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       EndTime =>  $some_value, # integer
       GroupNameOrId =>  $some_value, # string
       IsDefault =>  $some_value, # boolean
       IsDisableAll =>  $some_value, # boolean
       IsStopped =>  $some_value, # boolean
       NumberRecords =>  $some_value, # integer
       PerfFileName =>  $some_value, # string
       RealTime =>  $some_value, # boolean
       SampleBuffer =>  $some_value, # integer
       SampleRate =>  $some_value, # integer
       SpaceConsumed =>  $some_value, # unsignedLong
       SpaceProjected =>  $some_value, # unsignedLong
       StartTime =>  $some_value, # integer
     },
   },
   CounterGroupName =>  $some_value, # string
   GroupNameOrId =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

