
package MyElements::PerfGetCounterData;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfGetCounterData');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Direction_of :ATTR(:get<Direction>);
my %Duration_of :ATTR(:get<Duration>);
my %EndTime_of :ATTR(:get<EndTime>);
my %InstanceCounterInfo_of :ATTR(:get<InstanceCounterInfo>);
my %NumberSamples_of :ATTR(:get<NumberSamples>);
my %SampleRate_of :ATTR(:get<SampleRate>);
my %StartTime_of :ATTR(:get<StartTime>);
my %TimeConsolidationMethod_of :ATTR(:get<TimeConsolidationMethod>);
my %TimeFilter_of :ATTR(:get<TimeFilter>);

__PACKAGE__->_factory(
    [ qw(        Direction
        Duration
        EndTime
        InstanceCounterInfo
        NumberSamples
        SampleRate
        StartTime
        TimeConsolidationMethod
        TimeFilter

    ) ],
    {
        'Direction' => \%Direction_of,
        'Duration' => \%Duration_of,
        'EndTime' => \%EndTime_of,
        'InstanceCounterInfo' => \%InstanceCounterInfo_of,
        'NumberSamples' => \%NumberSamples_of,
        'SampleRate' => \%SampleRate_of,
        'StartTime' => \%StartTime_of,
        'TimeConsolidationMethod' => \%TimeConsolidationMethod_of,
        'TimeFilter' => \%TimeFilter_of,
    },
    {
        'Direction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Duration' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'InstanceCounterInfo' => 'MyTypes::InstanceCounterInfo',

        'NumberSamples' => 'MyElements::PerfGetCounterData::_NumberSamples',

        'SampleRate' => 'MyElements::PerfGetCounterData::_SampleRate',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TimeFilter' => 'MyTypes::TimeFilter',
    },
    {

        'Direction' => 'Direction',
        'Duration' => 'Duration',
        'EndTime' => 'EndTime',
        'InstanceCounterInfo' => 'InstanceCounterInfo',
        'NumberSamples' => 'NumberSamples',
        'SampleRate' => 'SampleRate',
        'StartTime' => 'StartTime',
        'TimeConsolidationMethod' => 'TimeConsolidationMethod',
        'TimeFilter' => 'TimeFilter',
    }
);

} # end BLOCK




package MyElements::PerfGetCounterData::_NumberSamples;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::PerfGetCounterData::_SampleRate;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfGetCounterData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfGetCounterData from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Direction

 $element->set_Direction($data);
 $element->get_Direction();




=item * Duration

 $element->set_Duration($data);
 $element->get_Duration();




=item * EndTime

 $element->set_EndTime($data);
 $element->get_EndTime();




=item * InstanceCounterInfo

 $element->set_InstanceCounterInfo($data);
 $element->get_InstanceCounterInfo();




=item * NumberSamples

 $element->set_NumberSamples($data);
 $element->get_NumberSamples();




=item * SampleRate

 $element->set_SampleRate($data);
 $element->get_SampleRate();




=item * StartTime

 $element->set_StartTime($data);
 $element->get_StartTime();




=item * TimeConsolidationMethod

 $element->set_TimeConsolidationMethod($data);
 $element->get_TimeConsolidationMethod();




=item * TimeFilter

 $element->set_TimeFilter($data);
 $element->get_TimeFilter();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfGetCounterData->new($data);

Constructor. The following data structure may be passed to new():

 {
   Direction =>  $some_value, # string
   Duration =>  $some_value, # unsignedInt
   EndTime =>  $some_value, # unsignedInt
   InstanceCounterInfo =>  { # MyTypes::InstanceCounterInfo
     CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
       PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
         CounterDescription =>  $some_value, # string
         CounterName =>  $some_value, # string
         IsCalculatedStats =>  $some_value, # boolean
         LabelNames =>  $some_value, # string
         Metrics =>  { # MyTypes::ArrayOfMetric
           Metric =>  { # MyTypes::Metric
             Id =>  $some_value, # string
             MetricResult =>  $some_value, # string
             Period => $some_value, # atomic
             Slide =>  $some_value, # string
             Type =>  $some_value, # string
             Value =>  $some_value, # string
           },
         },
         ObjectType =>  $some_value, # string
         PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
           PerfLabel =>  { # MyTypes::PerfLabel
             LabelNames =>  $some_value, # string
           },
         },
         TimeConsolidationMethod =>  $some_value, # string
       },
     },
     InstanceName =>  $some_value, # string
     ObjectNameOrId => $some_value, # ObjNameOrId
   },
   NumberSamples => $some_value, # atomic
   SampleRate => $some_value, # atomic
   StartTime =>  $some_value, # unsignedInt
   TimeConsolidationMethod =>  $some_value, # string
   TimeFilter =>  { # MyTypes::TimeFilter
     Days =>  { # MyTypes::ArrayOfDay
       Day => $some_value, # Day
     },
     Months =>  { # MyTypes::ArrayOfMonth
       Month => $some_value, # Month
     },
     TimeRanges =>  { # MyTypes::ArrayOfTimeRange
       TimeRange =>  { # MyTypes::TimeRange
         From => $some_value, # atomic
         To => $some_value, # atomic
       },
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

