
package MyElements::PerfGetCounterDataResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfGetCounterDataResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %InvalidCounterInstances_of :ATTR(:get<InvalidCounterInstances>);
my %PerfInstances_of :ATTR(:get<PerfInstances>);

__PACKAGE__->_factory(
    [ qw(        InvalidCounterInstances
        PerfInstances

    ) ],
    {
        'InvalidCounterInstances' => \%InvalidCounterInstances_of,
        'PerfInstances' => \%PerfInstances_of,
    },
    {
        'InvalidCounterInstances' => 'MyTypes::ArrayOfInvalidCounterInstance',
        'PerfInstances' => 'MyTypes::ArrayOfPerfInstanceCounterData',
    },
    {

        'InvalidCounterInstances' => 'InvalidCounterInstances',
        'PerfInstances' => 'PerfInstances',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfGetCounterDataResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfGetCounterDataResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * InvalidCounterInstances

 $element->set_InvalidCounterInstances($data);
 $element->get_InvalidCounterInstances();




=item * PerfInstances

 $element->set_PerfInstances($data);
 $element->get_PerfInstances();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfGetCounterDataResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   InvalidCounterInstances =>  { # MyTypes::ArrayOfInvalidCounterInstance
     InvalidCounterInstance =>  { # MyTypes::InvalidCounterInstance
       CounterInfo =>  { # MyTypes::WrapperOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
       ErrCode =>  $some_value, # string
       ErrReason =>  $some_value, # string
       HostId => $some_value, # ObjId
       InstanceName =>  $some_value, # string
     },
   },
   PerfInstances =>  { # MyTypes::ArrayOfPerfInstanceCounterData
     PerfInstanceCounterData =>  { # MyTypes::PerfInstanceCounterData
       Counters =>  { # MyTypes::ArrayOfPerfCounterData
         PerfCounterData =>  { # MyTypes::PerfCounterData
           CounterData =>  $some_value, # string
           CounterName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           Unit =>  $some_value, # string
         },
       },
       InstanceName =>  $some_value, # string
       ObjectId => $some_value, # ObjId
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

