
package MyElements::PerfGetCounterDependentsResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfGetCounterDependentsResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BaseCounters_of :ATTR(:get<BaseCounters>);
my %DependentCounters_of :ATTR(:get<DependentCounters>);
my %Reports_of :ATTR(:get<Reports>);
my %ThresholdTemplates_of :ATTR(:get<ThresholdTemplates>);
my %Thresholds_of :ATTR(:get<Thresholds>);
my %Views_of :ATTR(:get<Views>);

__PACKAGE__->_factory(
    [ qw(        BaseCounters
        DependentCounters
        Reports
        ThresholdTemplates
        Thresholds
        Views

    ) ],
    {
        'BaseCounters' => \%BaseCounters_of,
        'DependentCounters' => \%DependentCounters_of,
        'Reports' => \%Reports_of,
        'ThresholdTemplates' => \%ThresholdTemplates_of,
        'Thresholds' => \%Thresholds_of,
        'Views' => \%Views_of,
    },
    {
        'BaseCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
        'DependentCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
        'Reports' => 'MyTypes::ArrayOfPerfReport',
        'ThresholdTemplates' => 'MyTypes::ArrayOfThresholdTemplate',
        'Thresholds' => 'MyTypes::ArrayOfPerfThreshold',
        'Views' => 'MyTypes::ArrayOfPerfView',
    },
    {

        'BaseCounters' => 'BaseCounters',
        'DependentCounters' => 'DependentCounters',
        'Reports' => 'Reports',
        'ThresholdTemplates' => 'ThresholdTemplates',
        'Thresholds' => 'Thresholds',
        'Views' => 'Views',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfGetCounterDependentsResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfGetCounterDependentsResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BaseCounters

 $element->set_BaseCounters($data);
 $element->get_BaseCounters();




=item * DependentCounters

 $element->set_DependentCounters($data);
 $element->get_DependentCounters();




=item * Reports

 $element->set_Reports($data);
 $element->get_Reports();




=item * ThresholdTemplates

 $element->set_ThresholdTemplates($data);
 $element->get_ThresholdTemplates();




=item * Thresholds

 $element->set_Thresholds($data);
 $element->get_Thresholds();




=item * Views

 $element->set_Views($data);
 $element->get_Views();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfGetCounterDependentsResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   BaseCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
   DependentCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
   Reports =>  { # MyTypes::ArrayOfPerfReport
     PerfReport =>  { # MyTypes::PerfReport
       ReportName =>  $some_value, # string
     },
   },
   ThresholdTemplates =>  { # MyTypes::ArrayOfThresholdTemplate
     ThresholdTemplate =>  { # MyTypes::ThresholdTemplate
       TemplateName =>  $some_value, # string
     },
   },
   Thresholds =>  { # MyTypes::ArrayOfPerfThreshold
     PerfThreshold =>  { # MyTypes::PerfThreshold
       PerfThresholdName =>  $some_value, # string
     },
   },
   Views =>  { # MyTypes::ArrayOfPerfView
     PerfView =>  { # MyTypes::PerfView
       ApplianceNameOrId =>  $some_value, # string
       AreEventsShown =>  $some_value, # boolean
       AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
         PerfAssocObjType => $some_value, # PerfAssocObjType
       },
       Charts =>  { # MyTypes::ArrayOfPerfChart
         PerfChart =>  { # MyTypes::PerfChart
           ChartName =>  $some_value, # string
           DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
             PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
               Color =>  $some_value, # string
               DataSource =>  { # MyTypes::WrapperOfPerfDataSource
                 PerfDataSource =>  { # MyTypes::PerfDataSource
                   ApplianceNameOrId =>  $some_value, # string
                   CounterName =>  $some_value, # string
                   GroupNameOrId =>  $some_value, # string
                   InstanceName =>  $some_value, # string
                   LabelNames =>  $some_value, # string
                   ObjectFullName => $some_value, # ObjFullName
                   ObjectName =>  $some_value, # string
                   ObjectNameOrId => $some_value, # ObjNameOrId
                   ObjectType =>  $some_value, # string
                 },
               },
               MaximumInstances =>  $some_value, # integer
               SelectAllInstances =>  $some_value, # boolean
               SortOrder =>  $some_value, # string
               TimeInterval =>  $some_value, # integer
             },
           },
           Lines =>  { # MyTypes::ArrayOfPerfLine
             PerfLine =>  { # MyTypes::PerfLine
               Color =>  $some_value, # string
               DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
                 PerfDataGroup =>  { # MyTypes::PerfDataGroup
                   DataGroupMethod =>  $some_value, # string
                   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                     PerfDataSource =>  { # MyTypes::PerfDataSource
                       ApplianceNameOrId =>  $some_value, # string
                       CounterName =>  $some_value, # string
                       GroupNameOrId =>  $some_value, # string
                       InstanceName =>  $some_value, # string
                       LabelNames =>  $some_value, # string
                       ObjectFullName => $some_value, # ObjFullName
                       ObjectName =>  $some_value, # string
                       ObjectNameOrId => $some_value, # ObjNameOrId
                       ObjectType =>  $some_value, # string
                     },
                   },
                 },
               },
               LineName =>  $some_value, # string
               Type =>  $some_value, # string
             },
           },
           MaximumY =>  $some_value, # integer
           Type =>  $some_value, # string
         },
       },
       CounterGroupName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       IsDefault =>  $some_value, # boolean
       IsStopped =>  $some_value, # boolean
       SampleBuffer =>  $some_value, # integer
       SampleRate =>  $some_value, # integer
       ViewName =>  $some_value, # string
       ViewType => $some_value, # ViewType
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

