
package MyElements::PerfThresholdTemplateCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfThresholdTemplateCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %MemberThresholds_of :ATTR(:get<MemberThresholds>);
my %TemplateDescription_of :ATTR(:get<TemplateDescription>);
my %TemplateName_of :ATTR(:get<TemplateName>);

__PACKAGE__->_factory(
    [ qw(        MemberThresholds
        TemplateDescription
        TemplateName

    ) ],
    {
        'MemberThresholds' => \%MemberThresholds_of,
        'TemplateDescription' => \%TemplateDescription_of,
        'TemplateName' => \%TemplateName_of,
    },
    {
        'MemberThresholds' => 'MyTypes::ArrayOfThresholdInfo2',
        'TemplateDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'MemberThresholds' => 'MemberThresholds',
        'TemplateDescription' => 'TemplateDescription',
        'TemplateName' => 'TemplateName',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfThresholdTemplateCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfThresholdTemplateCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * MemberThresholds

 $element->set_MemberThresholds($data);
 $element->get_MemberThresholds();




=item * TemplateDescription

 $element->set_TemplateDescription($data);
 $element->get_TemplateDescription();




=item * TemplateName

 $element->set_TemplateName($data);
 $element->get_TemplateName();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfThresholdTemplateCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   MemberThresholds =>  { # MyTypes::ArrayOfThresholdInfo2
     ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
       CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
         CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
           PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
             CounterDescription =>  $some_value, # string
             CounterName =>  $some_value, # string
             IsCalculatedStats =>  $some_value, # boolean
             LabelNames =>  $some_value, # string
             Metrics =>  { # MyTypes::ArrayOfMetric
               Metric =>  { # MyTypes::Metric
                 Id =>  $some_value, # string
                 MetricResult =>  $some_value, # string
                 Period => $some_value, # atomic
                 Slide =>  $some_value, # string
                 Type =>  $some_value, # string
                 Value =>  $some_value, # string
               },
             },
             ObjectType =>  $some_value, # string
             PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
               PerfLabel =>  { # MyTypes::PerfLabel
                 LabelNames =>  $some_value, # string
               },
             },
             TimeConsolidationMethod =>  $some_value, # string
           },
           ThresholdType =>  $some_value, # string
           ThresholdUnit => $some_value, # CounterUnit
           ThresholdValue =>  $some_value, # unsignedLong
         },
       },
       IsEnabled =>  $some_value, # boolean
       IsIndirect =>  $some_value, # boolean
       ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
         ObjectInfo =>  { # MyTypes::ObjectInfo
           ObjectFullName => $some_value, # ObjFullName
           ObjectId => $some_value, # ObjId
           ObjectName => $some_value, # ObjName
           ObjectType =>  $some_value, # string
         },
       },
       ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
         ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
           Name =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       TemplateId => $some_value, # atomic
       TemplateName =>  $some_value, # string
       ThresholdEventName =>  $some_value, # string
       ThresholdId => $some_value, # ThresholdId
       ThresholdInterval => $some_value, # atomic
     },
   },
   TemplateDescription =>  $some_value, # string
   TemplateName =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

