
package MyElements::PerfViewCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfViewCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DataSources_of :ATTR(:get<DataSources>);
my %RealTime_of :ATTR(:get<RealTime>);
my %View_of :ATTR(:get<View>);

__PACKAGE__->_factory(
    [ qw(        DataSources
        RealTime
        View

    ) ],
    {
        'DataSources' => \%DataSources_of,
        'RealTime' => \%RealTime_of,
        'View' => \%View_of,
    },
    {
        'DataSources' => 'MyTypes::ArrayOfPerfDataSource',
        'RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'View' => 'MyTypes::WrapperOfPerfView',
    },
    {

        'DataSources' => 'DataSources',
        'RealTime' => 'RealTime',
        'View' => 'View',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfViewCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfViewCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DataSources

 $element->set_DataSources($data);
 $element->get_DataSources();




=item * RealTime

 $element->set_RealTime($data);
 $element->get_RealTime();




=item * View

 $element->set_View($data);
 $element->get_View();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfViewCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
     PerfDataSource =>  { # MyTypes::PerfDataSource
       ApplianceNameOrId =>  $some_value, # string
       CounterName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       InstanceName =>  $some_value, # string
       LabelNames =>  $some_value, # string
       ObjectFullName => $some_value, # ObjFullName
       ObjectName =>  $some_value, # string
       ObjectNameOrId => $some_value, # ObjNameOrId
       ObjectType =>  $some_value, # string
     },
   },
   RealTime =>  $some_value, # boolean
   View =>  { # MyTypes::WrapperOfPerfView
     PerfView =>  { # MyTypes::PerfView
       ApplianceNameOrId =>  $some_value, # string
       AreEventsShown =>  $some_value, # boolean
       AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
         PerfAssocObjType => $some_value, # PerfAssocObjType
       },
       Charts =>  { # MyTypes::ArrayOfPerfChart
         PerfChart =>  { # MyTypes::PerfChart
           ChartName =>  $some_value, # string
           DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
             PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
               Color =>  $some_value, # string
               DataSource =>  { # MyTypes::WrapperOfPerfDataSource
                 PerfDataSource =>  { # MyTypes::PerfDataSource
                   ApplianceNameOrId =>  $some_value, # string
                   CounterName =>  $some_value, # string
                   GroupNameOrId =>  $some_value, # string
                   InstanceName =>  $some_value, # string
                   LabelNames =>  $some_value, # string
                   ObjectFullName => $some_value, # ObjFullName
                   ObjectName =>  $some_value, # string
                   ObjectNameOrId => $some_value, # ObjNameOrId
                   ObjectType =>  $some_value, # string
                 },
               },
               MaximumInstances =>  $some_value, # integer
               SelectAllInstances =>  $some_value, # boolean
               SortOrder =>  $some_value, # string
               TimeInterval =>  $some_value, # integer
             },
           },
           Lines =>  { # MyTypes::ArrayOfPerfLine
             PerfLine =>  { # MyTypes::PerfLine
               Color =>  $some_value, # string
               DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
                 PerfDataGroup =>  { # MyTypes::PerfDataGroup
                   DataGroupMethod =>  $some_value, # string
                   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                     PerfDataSource =>  { # MyTypes::PerfDataSource
                       ApplianceNameOrId =>  $some_value, # string
                       CounterName =>  $some_value, # string
                       GroupNameOrId =>  $some_value, # string
                       InstanceName =>  $some_value, # string
                       LabelNames =>  $some_value, # string
                       ObjectFullName => $some_value, # ObjFullName
                       ObjectName =>  $some_value, # string
                       ObjectNameOrId => $some_value, # ObjNameOrId
                       ObjectType =>  $some_value, # string
                     },
                   },
                 },
               },
               LineName =>  $some_value, # string
               Type =>  $some_value, # string
             },
           },
           MaximumY =>  $some_value, # integer
           Type =>  $some_value, # string
         },
       },
       CounterGroupName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       IsDefault =>  $some_value, # boolean
       IsStopped =>  $some_value, # boolean
       SampleBuffer =>  $some_value, # integer
       SampleRate =>  $some_value, # integer
       ViewName =>  $some_value, # string
       ViewType => $some_value, # ViewType
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

