
package MyElements::PerfViewGetData;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfViewGetData');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Direction_of :ATTR(:get<Direction>);
my %Duration_of :ATTR(:get<Duration>);
my %DynamicObjectInfo_of :ATTR(:get<DynamicObjectInfo>);
my %EndTime_of :ATTR(:get<EndTime>);
my %Instance_of :ATTR(:get<Instance>);
my %IsDynamic_of :ATTR(:get<IsDynamic>);
my %NumberSamples_of :ATTR(:get<NumberSamples>);
my %SampleRate_of :ATTR(:get<SampleRate>);
my %StartTime_of :ATTR(:get<StartTime>);
my %TimeConsolidationMethod_of :ATTR(:get<TimeConsolidationMethod>);
my %ViewName_of :ATTR(:get<ViewName>);

__PACKAGE__->_factory(
    [ qw(        Direction
        Duration
        DynamicObjectInfo
        EndTime
        Instance
        IsDynamic
        NumberSamples
        SampleRate
        StartTime
        TimeConsolidationMethod
        ViewName

    ) ],
    {
        'Direction' => \%Direction_of,
        'Duration' => \%Duration_of,
        'DynamicObjectInfo' => \%DynamicObjectInfo_of,
        'EndTime' => \%EndTime_of,
        'Instance' => \%Instance_of,
        'IsDynamic' => \%IsDynamic_of,
        'NumberSamples' => \%NumberSamples_of,
        'SampleRate' => \%SampleRate_of,
        'StartTime' => \%StartTime_of,
        'TimeConsolidationMethod' => \%TimeConsolidationMethod_of,
        'ViewName' => \%ViewName_of,
    },
    {
        'Direction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Duration' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'DynamicObjectInfo' => 'MyTypes::WrapperOfPerfDynamicDataSources',
        'EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'Instance' => 'MyTypes::WrapperOfPerfCounterInstance',
        'IsDynamic' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'NumberSamples' => 'MyElements::PerfViewGetData::_NumberSamples',

        'SampleRate' => 'MyElements::PerfViewGetData::_SampleRate',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Direction' => 'Direction',
        'Duration' => 'Duration',
        'DynamicObjectInfo' => 'DynamicObjectInfo',
        'EndTime' => 'EndTime',
        'Instance' => 'Instance',
        'IsDynamic' => 'IsDynamic',
        'NumberSamples' => 'NumberSamples',
        'SampleRate' => 'SampleRate',
        'StartTime' => 'StartTime',
        'TimeConsolidationMethod' => 'TimeConsolidationMethod',
        'ViewName' => 'ViewName',
    }
);

} # end BLOCK




package MyElements::PerfViewGetData::_NumberSamples;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyElements::PerfViewGetData::_SampleRate;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfViewGetData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfViewGetData from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Direction

 $element->set_Direction($data);
 $element->get_Direction();




=item * Duration

 $element->set_Duration($data);
 $element->get_Duration();




=item * DynamicObjectInfo

 $element->set_DynamicObjectInfo($data);
 $element->get_DynamicObjectInfo();




=item * EndTime

 $element->set_EndTime($data);
 $element->get_EndTime();




=item * Instance

 $element->set_Instance($data);
 $element->get_Instance();




=item * IsDynamic

 $element->set_IsDynamic($data);
 $element->get_IsDynamic();




=item * NumberSamples

 $element->set_NumberSamples($data);
 $element->get_NumberSamples();




=item * SampleRate

 $element->set_SampleRate($data);
 $element->get_SampleRate();




=item * StartTime

 $element->set_StartTime($data);
 $element->get_StartTime();




=item * TimeConsolidationMethod

 $element->set_TimeConsolidationMethod($data);
 $element->get_TimeConsolidationMethod();




=item * ViewName

 $element->set_ViewName($data);
 $element->get_ViewName();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfViewGetData->new($data);

Constructor. The following data structure may be passed to new():

 {
   Direction =>  $some_value, # string
   Duration =>  $some_value, # unsignedInt
   DynamicObjectInfo =>  { # MyTypes::WrapperOfPerfDynamicDataSources
     PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
       Color =>  $some_value, # string
       DataSource =>  { # MyTypes::WrapperOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
       MaximumInstances =>  $some_value, # integer
       SelectAllInstances =>  $some_value, # boolean
       SortOrder =>  $some_value, # string
       TimeInterval =>  $some_value, # integer
     },
   },
   EndTime =>  $some_value, # unsignedInt
   Instance =>  { # MyTypes::WrapperOfPerfCounterInstance
     PerfCounterInstance =>  { # MyTypes::PerfCounterInstance
       CounterInfo =>  { # MyTypes::WrapperOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
       InstanceName =>  $some_value, # string
       ObjectNameOrId => $some_value, # ObjNameOrId
     },
   },
   IsDynamic =>  $some_value, # boolean
   NumberSamples => $some_value, # atomic
   SampleRate => $some_value, # atomic
   StartTime =>  $some_value, # unsignedInt
   TimeConsolidationMethod =>  $some_value, # string
   ViewName =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

