
package MyElements::PerfViewModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('PerfViewModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %View_of :ATTR(:get<View>);
my %ViewName_of :ATTR(:get<ViewName>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        GroupNameOrId
        View
        ViewName

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'View' => \%View_of,
        'ViewName' => \%ViewName_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'View' => 'MyTypes::WrapperOfPerfView',
        'ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'GroupNameOrId' => 'GroupNameOrId',
        'View' => 'View',
        'ViewName' => 'ViewName',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::PerfViewModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
PerfViewModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId

 $element->set_ApplianceNameOrId($data);
 $element->get_ApplianceNameOrId();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * View

 $element->set_View($data);
 $element->get_View();




=item * ViewName

 $element->set_ViewName($data);
 $element->get_ViewName();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::PerfViewModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplianceNameOrId =>  $some_value, # string
   GroupNameOrId =>  $some_value, # string
   View =>  { # MyTypes::WrapperOfPerfView
     PerfView =>  { # MyTypes::PerfView
       ApplianceNameOrId =>  $some_value, # string
       AreEventsShown =>  $some_value, # boolean
       AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
         PerfAssocObjType => $some_value, # PerfAssocObjType
       },
       Charts =>  { # MyTypes::ArrayOfPerfChart
         PerfChart =>  { # MyTypes::PerfChart
           ChartName =>  $some_value, # string
           DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
             PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
               Color =>  $some_value, # string
               DataSource =>  { # MyTypes::WrapperOfPerfDataSource
                 PerfDataSource =>  { # MyTypes::PerfDataSource
                   ApplianceNameOrId =>  $some_value, # string
                   CounterName =>  $some_value, # string
                   GroupNameOrId =>  $some_value, # string
                   InstanceName =>  $some_value, # string
                   LabelNames =>  $some_value, # string
                   ObjectFullName => $some_value, # ObjFullName
                   ObjectName =>  $some_value, # string
                   ObjectNameOrId => $some_value, # ObjNameOrId
                   ObjectType =>  $some_value, # string
                 },
               },
               MaximumInstances =>  $some_value, # integer
               SelectAllInstances =>  $some_value, # boolean
               SortOrder =>  $some_value, # string
               TimeInterval =>  $some_value, # integer
             },
           },
           Lines =>  { # MyTypes::ArrayOfPerfLine
             PerfLine =>  { # MyTypes::PerfLine
               Color =>  $some_value, # string
               DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
                 PerfDataGroup =>  { # MyTypes::PerfDataGroup
                   DataGroupMethod =>  $some_value, # string
                   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                     PerfDataSource =>  { # MyTypes::PerfDataSource
                       ApplianceNameOrId =>  $some_value, # string
                       CounterName =>  $some_value, # string
                       GroupNameOrId =>  $some_value, # string
                       InstanceName =>  $some_value, # string
                       LabelNames =>  $some_value, # string
                       ObjectFullName => $some_value, # ObjFullName
                       ObjectName =>  $some_value, # string
                       ObjectNameOrId => $some_value, # ObjNameOrId
                       ObjectType =>  $some_value, # string
                     },
                   },
                 },
               },
               LineName =>  $some_value, # string
               Type =>  $some_value, # string
             },
           },
           MaximumY =>  $some_value, # integer
           Type =>  $some_value, # string
         },
       },
       CounterGroupName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       IsDefault =>  $some_value, # boolean
       IsStopped =>  $some_value, # boolean
       SampleBuffer =>  $some_value, # integer
       SampleRate =>  $some_value, # integer
       ViewName =>  $some_value, # string
       ViewType => $some_value, # ViewType
     },
   },
   ViewName =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

