
package MyElements::ProvisioningPolicyListIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ProvisioningPolicyListIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ProvisioningPolicies_of :ATTR(:get<ProvisioningPolicies>);
my %Records_of :ATTR(:get<Records>);

__PACKAGE__->_factory(
    [ qw(        ProvisioningPolicies
        Records

    ) ],
    {
        'ProvisioningPolicies' => \%ProvisioningPolicies_of,
        'Records' => \%Records_of,
    },
    {
        'ProvisioningPolicies' => 'MyTypes::ArrayOfProvisioningPolicyInfo',

        'Records' => 'MyElements::ProvisioningPolicyListIterNextResult::_Records',
    },
    {

        'ProvisioningPolicies' => 'ProvisioningPolicies',
        'Records' => 'Records',
    }
);

} # end BLOCK




package MyElements::ProvisioningPolicyListIterNextResult::_Records;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}





} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ProvisioningPolicyListIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ProvisioningPolicyListIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ProvisioningPolicies

 $element->set_ProvisioningPolicies($data);
 $element->get_ProvisioningPolicies();




=item * Records

 $element->set_Records($data);
 $element->get_Records();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ProvisioningPolicyListIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   ProvisioningPolicies =>  { # MyTypes::ArrayOfProvisioningPolicyInfo
     ProvisioningPolicyInfo =>  { # MyTypes::ProvisioningPolicyInfo
       AdvancedOptions =>  { # MyTypes::ArrayOfAdvancedOptionInfo
         AdvancedOptionInfo =>  { # MyTypes::AdvancedOptionInfo
           OptionName =>  $some_value, # string
           OptionValue =>  $some_value, # string
         },
       },
       CustomProvisioningScriptSettings =>  { # MyTypes::CustomProvisioningScriptSettings
         ScriptPath =>  $some_value, # string
       },
       DatasetMemberUsedSpaceThresholds =>  { # MyTypes::DatasetMemberUsedSpaceThresholds
         FullThreshold => $some_value, # atomic
         NearlyFullThreshold => $some_value, # atomic
       },
       DedupeEnabled =>  $some_value, # boolean
       DedupeSchedule =>  $some_value, # string
       IsPolicyReadonly =>  $some_value, # boolean
       NasContainerSettings =>  { # MyTypes::NasContainerSettings
         AutoDeleteSnapshots =>  $some_value, # boolean
         AutoGrowCapacity =>  $some_value, # boolean
         DefaultGroupQuota => $some_value, # atomic
         DefaultUserQuota => $some_value, # atomic
         SnapshotReserve =>  $some_value, # boolean
         SpaceOnDemand =>  $some_value, # boolean
         StorageContainerType => $some_value, # StorageContainerType
         ThinProvision =>  $some_value, # boolean
       },
       ProvisioningPolicyDescription =>  $some_value, # string
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjName
       ProvisioningPolicyType => $some_value, # ProvisioningPolicyType
       ResourceTag =>  $some_value, # string
       SanContainerSettings =>  { # MyTypes::SanContainerSettings
         GuaranteeWrites =>  $some_value, # boolean
         StorageContainerType => $some_value, # StorageContainerType
         ThinProvision =>  $some_value, # boolean
         ThinProvisioningConfiguration =>  $some_value, # string
       },
       StorageReliability =>  { # MyTypes::StorageReliability
         ControllerFailure =>  $some_value, # boolean
         DiskFailure =>  $some_value, # string
         SubSystemFailure =>  $some_value, # boolean
       },
     },
   },
   Records => $some_value, # atomic
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

