
package MyElements::QtreeListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('QtreeListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IsDirectMemberOnly_of :ATTR(:get<IsDirectMemberOnly>);
my %IsDirectVfilerChild_of :ATTR(:get<IsDirectVfilerChild>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsSnapvaultSecondaryQtrees_of :ATTR(:get<IsSnapvaultSecondaryQtrees>);
my %IsUnprotected_of :ATTR(:get<IsUnprotected>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %RbacOperation_of :ATTR(:get<RbacOperation>);
my %SortResults_of :ATTR(:get<SortResults>);

__PACKAGE__->_factory(
    [ qw(        IncludeIsAvailable
        IsDirectMemberOnly
        IsDirectVfilerChild
        IsDpIgnored
        IsInDataset
        IsSnapvaultSecondaryQtrees
        IsUnprotected
        ObjectManagementFilter
        ObjectNameOrId
        RbacOperation
        SortResults

    ) ],
    {
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IsDirectMemberOnly' => \%IsDirectMemberOnly_of,
        'IsDirectVfilerChild' => \%IsDirectVfilerChild_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsSnapvaultSecondaryQtrees' => \%IsSnapvaultSecondaryQtrees_of,
        'IsUnprotected' => \%IsUnprotected_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'RbacOperation' => \%RbacOperation_of,
        'SortResults' => \%SortResults_of,
    },
    {
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectVfilerChild' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryQtrees' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SortResults' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IsDirectMemberOnly' => 'IsDirectMemberOnly',
        'IsDirectVfilerChild' => 'IsDirectVfilerChild',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsSnapvaultSecondaryQtrees' => 'IsSnapvaultSecondaryQtrees',
        'IsUnprotected' => 'IsUnprotected',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'RbacOperation' => 'RbacOperation',
        'SortResults' => 'SortResults',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::QtreeListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
QtreeListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IsDirectMemberOnly

 $element->set_IsDirectMemberOnly($data);
 $element->get_IsDirectMemberOnly();




=item * IsDirectVfilerChild

 $element->set_IsDirectVfilerChild($data);
 $element->get_IsDirectVfilerChild();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsInDataset

 $element->set_IsInDataset($data);
 $element->get_IsInDataset();




=item * IsSnapvaultSecondaryQtrees

 $element->set_IsSnapvaultSecondaryQtrees($data);
 $element->get_IsSnapvaultSecondaryQtrees();




=item * IsUnprotected

 $element->set_IsUnprotected($data);
 $element->get_IsUnprotected();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * RbacOperation

 $element->set_RbacOperation($data);
 $element->get_RbacOperation();




=item * SortResults

 $element->set_SortResults($data);
 $element->get_SortResults();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::QtreeListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   IncludeIsAvailable =>  $some_value, # boolean
   IsDirectMemberOnly =>  $some_value, # boolean
   IsDirectVfilerChild =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsSnapvaultSecondaryQtrees =>  $some_value, # boolean
   IsUnprotected =>  $some_value, # boolean
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   ObjectNameOrId =>  $some_value, # string
   RbacOperation =>  $some_value, # string
   SortResults =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

