
package MyElements::ReportDesignerShare;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ReportDesignerShare');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EmailAddressList_of :ATTR(:get<EmailAddressList>);
my %OutputFormat_of :ATTR(:get<OutputFormat>);
my %ReportNameOrId_of :ATTR(:get<ReportNameOrId>);
my %SubjectField_of :ATTR(:get<SubjectField>);
my %TargetObjectNameOrId_of :ATTR(:get<TargetObjectNameOrId>);

__PACKAGE__->_factory(
    [ qw(        EmailAddressList
        OutputFormat
        ReportNameOrId
        SubjectField
        TargetObjectNameOrId

    ) ],
    {
        'EmailAddressList' => \%EmailAddressList_of,
        'OutputFormat' => \%OutputFormat_of,
        'ReportNameOrId' => \%ReportNameOrId_of,
        'SubjectField' => \%SubjectField_of,
        'TargetObjectNameOrId' => \%TargetObjectNameOrId_of,
    },
    {
        'EmailAddressList' => 'MyTypes::EmailAddressList',
        'OutputFormat' => 'MyTypes::ReportOutputFormat',
        'ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SubjectField' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'EmailAddressList' => 'EmailAddressList',
        'OutputFormat' => 'OutputFormat',
        'ReportNameOrId' => 'ReportNameOrId',
        'SubjectField' => 'SubjectField',
        'TargetObjectNameOrId' => 'TargetObjectNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ReportDesignerShare

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ReportDesignerShare from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EmailAddressList

 $element->set_EmailAddressList($data);
 $element->get_EmailAddressList();




=item * OutputFormat

 $element->set_OutputFormat($data);
 $element->get_OutputFormat();




=item * ReportNameOrId

 $element->set_ReportNameOrId($data);
 $element->get_ReportNameOrId();




=item * SubjectField

 $element->set_SubjectField($data);
 $element->get_SubjectField();




=item * TargetObjectNameOrId

 $element->set_TargetObjectNameOrId($data);
 $element->get_TargetObjectNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ReportDesignerShare->new($data);

Constructor. The following data structure may be passed to new():

 {
   EmailAddressList => $some_value, # EmailAddressList
   OutputFormat => $some_value, # ReportOutputFormat
   ReportNameOrId =>  $some_value, # string
   SubjectField =>  $some_value, # string
   TargetObjectNameOrId => $some_value, # ObjNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

