
package MyElements::ResourcepoolListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ResourcepoolListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CheckLicenses_of :ATTR(:get<CheckLicenses>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IncludeFreeSpace_of :ATTR(:get<IncludeFreeSpace>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %ResourceTag_of :ATTR(:get<ResourceTag>);
my %StorageReliability_of :ATTR(:get<StorageReliability>);

__PACKAGE__->_factory(
    [ qw(        CheckLicenses
        DpNodeName
        IncludeFreeSpace
        ObjectNameOrId
        ResourceTag
        StorageReliability

    ) ],
    {
        'CheckLicenses' => \%CheckLicenses_of,
        'DpNodeName' => \%DpNodeName_of,
        'IncludeFreeSpace' => \%IncludeFreeSpace_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'ResourceTag' => \%ResourceTag_of,
        'StorageReliability' => \%StorageReliability_of,
    },
    {
        'CheckLicenses' => 'MyTypes::ArrayOfLicense',
        'DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IncludeFreeSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'ResourceTag' => 'MyTypes::ResourceTag',
        'StorageReliability' => 'MyTypes::StorageReliability',
    },
    {

        'CheckLicenses' => 'CheckLicenses',
        'DpNodeName' => 'DpNodeName',
        'IncludeFreeSpace' => 'IncludeFreeSpace',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'ResourceTag' => 'ResourceTag',
        'StorageReliability' => 'StorageReliability',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ResourcepoolListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ResourcepoolListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CheckLicenses

 $element->set_CheckLicenses($data);
 $element->get_CheckLicenses();




=item * DpNodeName

 $element->set_DpNodeName($data);
 $element->get_DpNodeName();




=item * IncludeFreeSpace

 $element->set_IncludeFreeSpace($data);
 $element->get_IncludeFreeSpace();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * ResourceTag

 $element->set_ResourceTag($data);
 $element->get_ResourceTag();




=item * StorageReliability

 $element->set_StorageReliability($data);
 $element->get_StorageReliability();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ResourcepoolListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   CheckLicenses =>  { # MyTypes::ArrayOfLicense
     License => $some_value, # License
   },
   DpNodeName =>  $some_value, # string
   IncludeFreeSpace =>  $some_value, # boolean
   ObjectNameOrId => $some_value, # ObjNameOrId
   ResourceTag => $some_value, # ResourceTag
   StorageReliability =>  { # MyTypes::StorageReliability
     ControllerFailure =>  $some_value, # boolean
     DiskFailure =>  $some_value, # string
     SubSystemFailure =>  $some_value, # boolean
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

