
package MyElements::ResourcepoolMemberListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ResourcepoolMemberListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IncludeDatasetSpaceInfo_of :ATTR(:get<IncludeDatasetSpaceInfo>);
my %IncludeIndirect_of :ATTR(:get<IncludeIndirect>);
my %MemberType_of :ATTR(:get<MemberType>);
my %ProvisionMemberRequestInfo_of :ATTR(:get<ProvisionMemberRequestInfo>);
my %ProvisioningPolicyNameOrId_of :ATTR(:get<ProvisioningPolicyNameOrId>);
my %ResourcepoolMemberNameOrId_of :ATTR(:get<ResourcepoolMemberNameOrId>);
my %ResourcepoolNameOrId_of :ATTR(:get<ResourcepoolNameOrId>);
my %RunProvisioningChecks_of :ATTR(:get<RunProvisioningChecks>);

__PACKAGE__->_factory(
    [ qw(        IncludeDatasetSpaceInfo
        IncludeIndirect
        MemberType
        ProvisionMemberRequestInfo
        ProvisioningPolicyNameOrId
        ResourcepoolMemberNameOrId
        ResourcepoolNameOrId
        RunProvisioningChecks

    ) ],
    {
        'IncludeDatasetSpaceInfo' => \%IncludeDatasetSpaceInfo_of,
        'IncludeIndirect' => \%IncludeIndirect_of,
        'MemberType' => \%MemberType_of,
        'ProvisionMemberRequestInfo' => \%ProvisionMemberRequestInfo_of,
        'ProvisioningPolicyNameOrId' => \%ProvisioningPolicyNameOrId_of,
        'ResourcepoolMemberNameOrId' => \%ResourcepoolMemberNameOrId_of,
        'ResourcepoolNameOrId' => \%ResourcepoolNameOrId_of,
        'RunProvisioningChecks' => \%RunProvisioningChecks_of,
    },
    {
        'IncludeDatasetSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
        'ProvisioningPolicyNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolMemberNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RunProvisioningChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'IncludeDatasetSpaceInfo' => 'IncludeDatasetSpaceInfo',
        'IncludeIndirect' => 'IncludeIndirect',
        'MemberType' => 'MemberType',
        'ProvisionMemberRequestInfo' => 'ProvisionMemberRequestInfo',
        'ProvisioningPolicyNameOrId' => 'ProvisioningPolicyNameOrId',
        'ResourcepoolMemberNameOrId' => 'ResourcepoolMemberNameOrId',
        'ResourcepoolNameOrId' => 'ResourcepoolNameOrId',
        'RunProvisioningChecks' => 'RunProvisioningChecks',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ResourcepoolMemberListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ResourcepoolMemberListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IncludeDatasetSpaceInfo

 $element->set_IncludeDatasetSpaceInfo($data);
 $element->get_IncludeDatasetSpaceInfo();




=item * IncludeIndirect

 $element->set_IncludeIndirect($data);
 $element->get_IncludeIndirect();




=item * MemberType

 $element->set_MemberType($data);
 $element->get_MemberType();




=item * ProvisionMemberRequestInfo

 $element->set_ProvisionMemberRequestInfo($data);
 $element->get_ProvisionMemberRequestInfo();




=item * ProvisioningPolicyNameOrId

 $element->set_ProvisioningPolicyNameOrId($data);
 $element->get_ProvisioningPolicyNameOrId();




=item * ResourcepoolMemberNameOrId

 $element->set_ResourcepoolMemberNameOrId($data);
 $element->get_ResourcepoolMemberNameOrId();




=item * ResourcepoolNameOrId

 $element->set_ResourcepoolNameOrId($data);
 $element->get_ResourcepoolNameOrId();




=item * RunProvisioningChecks

 $element->set_RunProvisioningChecks($data);
 $element->get_RunProvisioningChecks();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ResourcepoolMemberListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   IncludeDatasetSpaceInfo =>  $some_value, # boolean
   IncludeIndirect =>  $some_value, # boolean
   MemberType =>  $some_value, # string
   ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
     Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
       ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
         CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
         CommentValue => $some_value, # CommentValue
       },
     },
     CreateNewVfiler =>  $some_value, # boolean
     DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
       DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
         CifsDomain =>  $some_value, # string
         DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
           DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission => $some_value, # CifsPermission
           },
         },
       },
       DatasetExportProtocol => $some_value, # DatasetExportProtocol
       DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
         IgroupOsType =>  $some_value, # string
         LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
       },
       DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsProtocolVersion =>  $some_value, # string
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
     },
     Description =>  $some_value, # string
     InitialSnapshotSpace => $some_value, # atomic
     MaximumDataSize => $some_value, # atomic
     MaximumSnapshotSpace => $some_value, # atomic
     Name =>  $some_value, # string
     OnlineMigration =>  $some_value, # boolean
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjFullName
     ResourceNameOrId => $some_value, # ObjNameOrId
     Size => $some_value, # atomic
     VfilerNameOrId => $some_value, # ObjNameOrId
   },
   ProvisioningPolicyNameOrId =>  $some_value, # string
   ResourcepoolMemberNameOrId =>  $some_value, # string
   ResourcepoolNameOrId =>  $some_value, # string
   RunProvisioningChecks =>  $some_value, # boolean
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

