
package MyElements::ResourcepoolModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('ResourcepoolModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Resourcepool_of :ATTR(:get<Resourcepool>);
my %ResourcepoolNameOrId_of :ATTR(:get<ResourcepoolNameOrId>);

__PACKAGE__->_factory(
    [ qw(        Resourcepool
        ResourcepoolNameOrId

    ) ],
    {
        'Resourcepool' => \%Resourcepool_of,
        'ResourcepoolNameOrId' => \%ResourcepoolNameOrId_of,
    },
    {
        'Resourcepool' => 'MyTypes::WrapperOfResourcepoolInfo',
        'ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Resourcepool' => 'Resourcepool',
        'ResourcepoolNameOrId' => 'ResourcepoolNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::ResourcepoolModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
ResourcepoolModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Resourcepool

 $element->set_Resourcepool($data);
 $element->get_Resourcepool();




=item * ResourcepoolNameOrId

 $element->set_ResourcepoolNameOrId($data);
 $element->get_ResourcepoolNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::ResourcepoolModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   Resourcepool =>  { # MyTypes::WrapperOfResourcepoolInfo
     ResourcepoolInfo =>  { # MyTypes::ResourcepoolInfo
       AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
       AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
       ResourceTag => $some_value, # ResourceTag
       ResourcepoolContact => $some_value, # EmailAddressList
       ResourcepoolDescription =>  $some_value, # string
       ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
       ResourcepoolFullThreshold => $some_value, # atomic
       ResourcepoolId =>  $some_value, # integer
       ResourcepoolIsProvisionable =>  $some_value, # boolean
       ResourcepoolKbytesAvailable => $some_value, # atomic
       ResourcepoolKbytesTotal => $some_value, # atomic
       ResourcepoolKbytesUsed => $some_value, # atomic
       ResourcepoolMemberCount => $some_value, # atomic
       ResourcepoolName =>  $some_value, # string
       ResourcepoolNearlyFullThreshold => $some_value, # atomic
       ResourcepoolOwner =>  $some_value, # string
       ResourcepoolPerfStatus => $some_value, # ObjStatus
       ResourcepoolSpaceStatus =>  $some_value, # string
       ResourcepoolStatus => $some_value, # ObjStatus
       ResourcepoolTimezone =>  $some_value, # string
     },
   },
   ResourcepoolNameOrId =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

