
package MyElements::StorageServiceCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %ProtectionPolicyNameOrId_of :ATTR(:get<ProtectionPolicyNameOrId>);
my %StorageServiceContact_of :ATTR(:get<StorageServiceContact>);
my %StorageServiceDescription_of :ATTR(:get<StorageServiceDescription>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);
my %StorageServiceNodeList_of :ATTR(:get<StorageServiceNodeList>);
my %StorageServiceOwner_of :ATTR(:get<StorageServiceOwner>);

__PACKAGE__->_factory(
    [ qw(        GroupNameOrId
        ProtectionPolicyNameOrId
        StorageServiceContact
        StorageServiceDescription
        StorageServiceName
        StorageServiceNodeList
        StorageServiceOwner

    ) ],
    {
        'GroupNameOrId' => \%GroupNameOrId_of,
        'ProtectionPolicyNameOrId' => \%ProtectionPolicyNameOrId_of,
        'StorageServiceContact' => \%StorageServiceContact_of,
        'StorageServiceDescription' => \%StorageServiceDescription_of,
        'StorageServiceName' => \%StorageServiceName_of,
        'StorageServiceNodeList' => \%StorageServiceNodeList_of,
        'StorageServiceOwner' => \%StorageServiceOwner_of,
    },
    {
        'GroupNameOrId' => 'MyTypes::ObjNameOrId',
        'ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageServiceContact' => 'MyTypes::EmailAddressList',
        'StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageServiceName' => 'MyTypes::ObjName',
        'StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
        'StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'GroupNameOrId' => 'GroupNameOrId',
        'ProtectionPolicyNameOrId' => 'ProtectionPolicyNameOrId',
        'StorageServiceContact' => 'StorageServiceContact',
        'StorageServiceDescription' => 'StorageServiceDescription',
        'StorageServiceName' => 'StorageServiceName',
        'StorageServiceNodeList' => 'StorageServiceNodeList',
        'StorageServiceOwner' => 'StorageServiceOwner',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * ProtectionPolicyNameOrId

 $element->set_ProtectionPolicyNameOrId($data);
 $element->get_ProtectionPolicyNameOrId();




=item * StorageServiceContact

 $element->set_StorageServiceContact($data);
 $element->get_StorageServiceContact();




=item * StorageServiceDescription

 $element->set_StorageServiceDescription($data);
 $element->get_StorageServiceDescription();




=item * StorageServiceName

 $element->set_StorageServiceName($data);
 $element->get_StorageServiceName();




=item * StorageServiceNodeList

 $element->set_StorageServiceNodeList($data);
 $element->get_StorageServiceNodeList();




=item * StorageServiceOwner

 $element->set_StorageServiceOwner($data);
 $element->get_StorageServiceOwner();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   GroupNameOrId => $some_value, # ObjNameOrId
   ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
   StorageServiceContact => $some_value, # EmailAddressList
   StorageServiceDescription =>  $some_value, # string
   StorageServiceName => $some_value, # ObjName
   StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
     StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
       DpNodeName => $some_value, # DpPolicyNodeName
       OldDpNodeName => $some_value, # DpPolicyNodeName
       ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
       Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
         ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
       },
       VfilerTemplateNameOrId => $some_value, # ObjNameOrId
     },
   },
   StorageServiceOwner =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

