
package MyElements::StorageServiceDatasetModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceDatasetModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AssumeConfirmation_of :ATTR(:get<AssumeConfirmation>);
my %DatasetNameOrId_of :ATTR(:get<DatasetNameOrId>);
my %DryRun_of :ATTR(:get<DryRun>);
my %IncludeDryRunReasonDetails_of :ATTR(:get<IncludeDryRunReasonDetails>);
my %OperationType_of :ATTR(:get<OperationType>);
my %StorageServiceNameOrId_of :ATTR(:get<StorageServiceNameOrId>);
my %StorageServiceNodeList_of :ATTR(:get<StorageServiceNodeList>);

__PACKAGE__->_factory(
    [ qw(        AssumeConfirmation
        DatasetNameOrId
        DryRun
        IncludeDryRunReasonDetails
        OperationType
        StorageServiceNameOrId
        StorageServiceNodeList

    ) ],
    {
        'AssumeConfirmation' => \%AssumeConfirmation_of,
        'DatasetNameOrId' => \%DatasetNameOrId_of,
        'DryRun' => \%DryRun_of,
        'IncludeDryRunReasonDetails' => \%IncludeDryRunReasonDetails_of,
        'OperationType' => \%OperationType_of,
        'StorageServiceNameOrId' => \%StorageServiceNameOrId_of,
        'StorageServiceNodeList' => \%StorageServiceNodeList_of,
    },
    {
        'AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetNameOrId' => 'MyTypes::ObjNameOrId',
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'OperationType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
    },
    {

        'AssumeConfirmation' => 'AssumeConfirmation',
        'DatasetNameOrId' => 'DatasetNameOrId',
        'DryRun' => 'DryRun',
        'IncludeDryRunReasonDetails' => 'IncludeDryRunReasonDetails',
        'OperationType' => 'OperationType',
        'StorageServiceNameOrId' => 'StorageServiceNameOrId',
        'StorageServiceNodeList' => 'StorageServiceNodeList',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceDatasetModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceDatasetModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AssumeConfirmation

 $element->set_AssumeConfirmation($data);
 $element->get_AssumeConfirmation();




=item * DatasetNameOrId

 $element->set_DatasetNameOrId($data);
 $element->get_DatasetNameOrId();




=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * IncludeDryRunReasonDetails

 $element->set_IncludeDryRunReasonDetails($data);
 $element->get_IncludeDryRunReasonDetails();




=item * OperationType

 $element->set_OperationType($data);
 $element->get_OperationType();




=item * StorageServiceNameOrId

 $element->set_StorageServiceNameOrId($data);
 $element->get_StorageServiceNameOrId();




=item * StorageServiceNodeList

 $element->set_StorageServiceNodeList($data);
 $element->get_StorageServiceNodeList();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceDatasetModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   AssumeConfirmation =>  $some_value, # boolean
   DatasetNameOrId => $some_value, # ObjNameOrId
   DryRun =>  $some_value, # boolean
   IncludeDryRunReasonDetails =>  $some_value, # boolean
   OperationType =>  $some_value, # string
   StorageServiceNameOrId => $some_value, # ObjNameOrId
   StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
     StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
       DpNodeName => $some_value, # DpPolicyNodeName
       OldDpNodeName => $some_value, # DpPolicyNodeName
       ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
       Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
         ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
       },
       VfilerTemplateNameOrId => $some_value, # ObjNameOrId
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

