
package MyElements::StorageServiceDatasetModifyResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceDatasetModifyResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConformanceAlerts_of :ATTR(:get<ConformanceAlerts>);
my %DryRunResults_of :ATTR(:get<DryRunResults>);

__PACKAGE__->_factory(
    [ qw(        ConformanceAlerts
        DryRunResults

    ) ],
    {
        'ConformanceAlerts' => \%ConformanceAlerts_of,
        'DryRunResults' => \%DryRunResults_of,
    },
    {
        'ConformanceAlerts' => 'MyTypes::ArrayOfConformanceAlert',
        'DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
    },
    {

        'ConformanceAlerts' => 'ConformanceAlerts',
        'DryRunResults' => 'DryRunResults',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceDatasetModifyResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceDatasetModifyResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConformanceAlerts

 $element->set_ConformanceAlerts($data);
 $element->get_ConformanceAlerts();




=item * DryRunResults

 $element->set_DryRunResults($data);
 $element->get_DryRunResults();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceDatasetModifyResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   ConformanceAlerts =>  { # MyTypes::ArrayOfConformanceAlert
     ConformanceAlert =>  { # MyTypes::ConformanceAlert
       ConformanceAlertEffect =>  $some_value, # string
       ConformanceAlertReason =>  $some_value, # string
       ConformanceAlertSeverity => $some_value, # ObjStatus
       ConformanceAlertSuggestion =>  $some_value, # string
       ConformanceAlertType => $some_value, # ConformanceAlertType
     },
   },
   DryRunResults =>  { # MyTypes::ArrayOfDryRunResult
     DryRunResult =>  { # MyTypes::DryRunResult
       DryRunAction =>  $some_value, # string
       DryRunEffect =>  $some_value, # string
       DryRunReason =>  $some_value, # string
       DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
         ResultDetail =>  { # MyTypes::ResultDetail
           Action =>  $some_value, # string
           Effect =>  $some_value, # string
           Reason =>  $some_value, # string
           Severity => $some_value, # ObjStatus
           Suggestion =>  $some_value, # string
         },
       },
       DryRunSeverity => $some_value, # ObjStatus
       DryRunSuggestion =>  $some_value, # string
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

