
package MyElements::StorageServiceDatasetProvision;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceDatasetProvision');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationInfo_of :ATTR(:get<ApplicationInfo>);
my %AssumeConfirmation_of :ATTR(:get<AssumeConfirmation>);
my %DatasetContact_of :ATTR(:get<DatasetContact>);
my %DatasetDescription_of :ATTR(:get<DatasetDescription>);
my %DatasetMetadata_of :ATTR(:get<DatasetMetadata>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DatasetOwner_of :ATTR(:get<DatasetOwner>);
my %DryRun_of :ATTR(:get<DryRun>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %IncludeDryRunReasonDetails_of :ATTR(:get<IncludeDryRunReasonDetails>);
my %IsApplicationData_of :ATTR(:get<IsApplicationData>);
my %IsSuspended_of :ATTR(:get<IsSuspended>);
my %OnlineMigration_of :ATTR(:get<OnlineMigration>);
my %ProvisionMember_of :ATTR(:get<ProvisionMember>);
my %RequiresNonDisruptiveRestore_of :ATTR(:get<RequiresNonDisruptiveRestore>);
my %StorageServiceNameOrId_of :ATTR(:get<StorageServiceNameOrId>);
my %StorageSetDetails_of :ATTR(:get<StorageSetDetails>);
my %VolumeQtreeNamePrefix_of :ATTR(:get<VolumeQtreeNamePrefix>);

__PACKAGE__->_factory(
    [ qw(        ApplicationInfo
        AssumeConfirmation
        DatasetContact
        DatasetDescription
        DatasetMetadata
        DatasetName
        DatasetOwner
        DryRun
        GroupNameOrId
        IncludeDryRunReasonDetails
        IsApplicationData
        IsSuspended
        OnlineMigration
        ProvisionMember
        RequiresNonDisruptiveRestore
        StorageServiceNameOrId
        StorageSetDetails
        VolumeQtreeNamePrefix

    ) ],
    {
        'ApplicationInfo' => \%ApplicationInfo_of,
        'AssumeConfirmation' => \%AssumeConfirmation_of,
        'DatasetContact' => \%DatasetContact_of,
        'DatasetDescription' => \%DatasetDescription_of,
        'DatasetMetadata' => \%DatasetMetadata_of,
        'DatasetName' => \%DatasetName_of,
        'DatasetOwner' => \%DatasetOwner_of,
        'DryRun' => \%DryRun_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'IncludeDryRunReasonDetails' => \%IncludeDryRunReasonDetails_of,
        'IsApplicationData' => \%IsApplicationData_of,
        'IsSuspended' => \%IsSuspended_of,
        'OnlineMigration' => \%OnlineMigration_of,
        'ProvisionMember' => \%ProvisionMember_of,
        'RequiresNonDisruptiveRestore' => \%RequiresNonDisruptiveRestore_of,
        'StorageServiceNameOrId' => \%StorageServiceNameOrId_of,
        'StorageSetDetails' => \%StorageSetDetails_of,
        'VolumeQtreeNamePrefix' => \%VolumeQtreeNamePrefix_of,
    },
    {
        'ApplicationInfo' => 'MyTypes::ApplicationInfo',
        'AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetContact' => 'MyTypes::EmailAddressList',
        'DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
        'DatasetName' => 'MyTypes::ObjName',
        'DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'GroupNameOrId' => 'MyTypes::ObjNameOrId',
        'IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProvisionMember' => 'MyTypes::WrapperOfProvisionMemberRequestInfo',
        'RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
        'StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageSetDetails' => 'MyTypes::ArrayOfStorageSetInfo',
        'VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplicationInfo' => 'ApplicationInfo',
        'AssumeConfirmation' => 'AssumeConfirmation',
        'DatasetContact' => 'DatasetContact',
        'DatasetDescription' => 'DatasetDescription',
        'DatasetMetadata' => 'DatasetMetadata',
        'DatasetName' => 'DatasetName',
        'DatasetOwner' => 'DatasetOwner',
        'DryRun' => 'DryRun',
        'GroupNameOrId' => 'GroupNameOrId',
        'IncludeDryRunReasonDetails' => 'IncludeDryRunReasonDetails',
        'IsApplicationData' => 'IsApplicationData',
        'IsSuspended' => 'IsSuspended',
        'OnlineMigration' => 'OnlineMigration',
        'ProvisionMember' => 'ProvisionMember',
        'RequiresNonDisruptiveRestore' => 'RequiresNonDisruptiveRestore',
        'StorageServiceNameOrId' => 'StorageServiceNameOrId',
        'StorageSetDetails' => 'StorageSetDetails',
        'VolumeQtreeNamePrefix' => 'VolumeQtreeNamePrefix',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceDatasetProvision

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceDatasetProvision from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationInfo

 $element->set_ApplicationInfo($data);
 $element->get_ApplicationInfo();




=item * AssumeConfirmation

 $element->set_AssumeConfirmation($data);
 $element->get_AssumeConfirmation();




=item * DatasetContact

 $element->set_DatasetContact($data);
 $element->get_DatasetContact();




=item * DatasetDescription

 $element->set_DatasetDescription($data);
 $element->get_DatasetDescription();




=item * DatasetMetadata

 $element->set_DatasetMetadata($data);
 $element->get_DatasetMetadata();




=item * DatasetName

 $element->set_DatasetName($data);
 $element->get_DatasetName();




=item * DatasetOwner

 $element->set_DatasetOwner($data);
 $element->get_DatasetOwner();




=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * GroupNameOrId

 $element->set_GroupNameOrId($data);
 $element->get_GroupNameOrId();




=item * IncludeDryRunReasonDetails

 $element->set_IncludeDryRunReasonDetails($data);
 $element->get_IncludeDryRunReasonDetails();




=item * IsApplicationData

 $element->set_IsApplicationData($data);
 $element->get_IsApplicationData();




=item * IsSuspended

 $element->set_IsSuspended($data);
 $element->get_IsSuspended();




=item * OnlineMigration

 $element->set_OnlineMigration($data);
 $element->get_OnlineMigration();




=item * ProvisionMember

 $element->set_ProvisionMember($data);
 $element->get_ProvisionMember();




=item * RequiresNonDisruptiveRestore

 $element->set_RequiresNonDisruptiveRestore($data);
 $element->get_RequiresNonDisruptiveRestore();




=item * StorageServiceNameOrId

 $element->set_StorageServiceNameOrId($data);
 $element->get_StorageServiceNameOrId();




=item * StorageSetDetails

 $element->set_StorageSetDetails($data);
 $element->get_StorageSetDetails();




=item * VolumeQtreeNamePrefix

 $element->set_VolumeQtreeNamePrefix($data);
 $element->get_VolumeQtreeNamePrefix();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceDatasetProvision->new($data);

Constructor. The following data structure may be passed to new():

 {
   ApplicationInfo =>  { # MyTypes::ApplicationInfo
     ApplicationName =>  $some_value, # string
     ApplicationServerName =>  $some_value, # string
     ApplicationVersion =>  $some_value, # string
     CarryPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
   },
   AssumeConfirmation =>  $some_value, # boolean
   DatasetContact => $some_value, # EmailAddressList
   DatasetDescription =>  $some_value, # string
   DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
     DfmMetadataField =>  { # MyTypes::DfmMetadataField
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   DatasetName => $some_value, # ObjName
   DatasetOwner =>  $some_value, # string
   DryRun =>  $some_value, # boolean
   GroupNameOrId => $some_value, # ObjNameOrId
   IncludeDryRunReasonDetails =>  $some_value, # boolean
   IsApplicationData =>  $some_value, # boolean
   IsSuspended =>  $some_value, # boolean
   OnlineMigration =>  $some_value, # boolean
   ProvisionMember =>  { # MyTypes::WrapperOfProvisionMemberRequestInfo
     ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
       Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
         ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
           CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
           CommentValue => $some_value, # CommentValue
         },
       },
       CreateNewVfiler =>  $some_value, # boolean
       DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
         DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
           CifsDomain =>  $some_value, # string
           DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
             DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
               CifsUsername =>  $some_value, # string
               Permission => $some_value, # CifsPermission
             },
           },
         },
         DatasetExportProtocol => $some_value, # DatasetExportProtocol
         DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
           IgroupOsType =>  $some_value, # string
           LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
             LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
               Hostname =>  $some_value, # string
               InitiatorId => $some_value, # InitiatorId
             },
           },
         },
         DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
           AnonymousAccessUser => $some_value, # atomic
           DisableSetuid =>  $some_value, # boolean
           IsReadonlyForAllHosts =>  $some_value, # boolean
           IsReadwriteForAllHosts =>  $some_value, # boolean
           NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsProtocolVersion =>  $some_value, # string
           NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
             NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
           },
         },
       },
       Description =>  $some_value, # string
       InitialSnapshotSpace => $some_value, # atomic
       MaximumDataSize => $some_value, # atomic
       MaximumSnapshotSpace => $some_value, # atomic
       Name =>  $some_value, # string
       OnlineMigration =>  $some_value, # boolean
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjFullName
       ResourceNameOrId => $some_value, # ObjNameOrId
       Size => $some_value, # atomic
       VfilerNameOrId => $some_value, # ObjNameOrId
     },
   },
   RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
   StorageServiceNameOrId => $some_value, # ObjNameOrId
   StorageSetDetails =>  { # MyTypes::ArrayOfStorageSetInfo
     StorageSetInfo =>  { # MyTypes::StorageSetInfo
       DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
         IpAddress =>  $some_value, # string
         Netmask =>  $some_value, # string
       },
       DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
         DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
           CifsDomain =>  $some_value, # string
           DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
             DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
               CifsUsername =>  $some_value, # string
               Permission => $some_value, # CifsPermission
             },
           },
         },
         DatasetExportProtocol => $some_value, # DatasetExportProtocol
         DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
           IgroupOsType =>  $some_value, # string
           LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
             LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
               Hostname =>  $some_value, # string
               InitiatorId => $some_value, # InitiatorId
             },
           },
         },
         DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
           AnonymousAccessUser => $some_value, # atomic
           DisableSetuid =>  $some_value, # boolean
           IsReadonlyForAllHosts =>  $some_value, # boolean
           IsReadwriteForAllHosts =>  $some_value, # boolean
           NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsProtocolVersion =>  $some_value, # string
           NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
             NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
           },
         },
       },
       DpNodeName => $some_value, # DpPolicyNodeName
       ServerNameOrId => $some_value, # ObjNameOrId
       TimezoneName =>  $some_value, # string
     },
   },
   VolumeQtreeNamePrefix =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

