
package MyElements::StorageServiceListInfoIterNextResult;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceListInfoIterNextResult');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Records_of :ATTR(:get<Records>);
my %StorageServices_of :ATTR(:get<StorageServices>);

__PACKAGE__->_factory(
    [ qw(        Records
        StorageServices

    ) ],
    {
        'Records' => \%Records_of,
        'StorageServices' => \%StorageServices_of,
    },
    {
        'Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'StorageServices' => 'MyTypes::ArrayOfStorageServiceInfo',
    },
    {

        'Records' => 'Records',
        'StorageServices' => 'StorageServices',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceListInfoIterNextResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceListInfoIterNextResult from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Records

 $element->set_Records($data);
 $element->get_Records();




=item * StorageServices

 $element->set_StorageServices($data);
 $element->get_StorageServices();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceListInfoIterNextResult->new($data);

Constructor. The following data structure may be passed to new():

 {
   Records =>  $some_value, # integer
   StorageServices =>  { # MyTypes::ArrayOfStorageServiceInfo
     StorageServiceInfo =>  { # MyTypes::StorageServiceInfo
       Datasets =>  { # MyTypes::ArrayOfDatasetReference
         DatasetReference =>  { # MyTypes::DatasetReference
           DatasetId => $some_value, # ObjId
           DatasetName => $some_value, # ObjName
         },
       },
       IsDrCapable =>  $some_value, # boolean
       ProtectionPolicyId => $some_value, # ObjId
       ProtectionPolicyName => $some_value, # ObjName
       StorageServiceContact => $some_value, # EmailAddressList
       StorageServiceDescription =>  $some_value, # string
       StorageServiceId => $some_value, # ObjId
       StorageServiceName => $some_value, # ObjName
       StorageServiceNodes =>  { # MyTypes::ArrayOfStorageServiceNodeInfo
         StorageServiceNodeInfo =>  { # MyTypes::StorageServiceNodeInfo
           DpNodeId => $some_value, # ObjId
           DpNodeName => $some_value, # ObjName
           ProvisioningPolicyId => $some_value, # ObjId
           ProvisioningPolicyName => $some_value, # ObjName
           Resourcepools =>  { # MyTypes::ArrayOfResourcepoolInfo
             ResourcepoolInfo =>  { # MyTypes::ResourcepoolInfo
               AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
               AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
               ResourceTag => $some_value, # ResourceTag
               ResourcepoolContact => $some_value, # EmailAddressList
               ResourcepoolDescription =>  $some_value, # string
               ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
               ResourcepoolFullThreshold => $some_value, # atomic
               ResourcepoolId =>  $some_value, # integer
               ResourcepoolIsProvisionable =>  $some_value, # boolean
               ResourcepoolKbytesAvailable => $some_value, # atomic
               ResourcepoolKbytesTotal => $some_value, # atomic
               ResourcepoolKbytesUsed => $some_value, # atomic
               ResourcepoolMemberCount => $some_value, # atomic
               ResourcepoolName =>  $some_value, # string
               ResourcepoolNearlyFullThreshold => $some_value, # atomic
               ResourcepoolOwner =>  $some_value, # string
               ResourcepoolPerfStatus => $some_value, # ObjStatus
               ResourcepoolSpaceStatus =>  $some_value, # string
               ResourcepoolStatus => $some_value, # ObjStatus
               ResourcepoolTimezone =>  $some_value, # string
             },
           },
           VfilerTemplateId => $some_value, # ObjId
           VfilerTemplateName => $some_value, # ObjName
         },
       },
       StorageServiceOwner =>  $some_value, # string
     },
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

