
package MyElements::StorageServiceModify;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('StorageServiceModify');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AssumeConfirmation_of :ATTR(:get<AssumeConfirmation>);
my %DryRun_of :ATTR(:get<DryRun>);
my %IncludeDryRunReasonDetails_of :ATTR(:get<IncludeDryRunReasonDetails>);
my %ProtectionPolicyNameOrId_of :ATTR(:get<ProtectionPolicyNameOrId>);
my %StorageServiceContact_of :ATTR(:get<StorageServiceContact>);
my %StorageServiceDescription_of :ATTR(:get<StorageServiceDescription>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);
my %StorageServiceNameOrId_of :ATTR(:get<StorageServiceNameOrId>);
my %StorageServiceNodeList_of :ATTR(:get<StorageServiceNodeList>);
my %StorageServiceOwner_of :ATTR(:get<StorageServiceOwner>);

__PACKAGE__->_factory(
    [ qw(        AssumeConfirmation
        DryRun
        IncludeDryRunReasonDetails
        ProtectionPolicyNameOrId
        StorageServiceContact
        StorageServiceDescription
        StorageServiceName
        StorageServiceNameOrId
        StorageServiceNodeList
        StorageServiceOwner

    ) ],
    {
        'AssumeConfirmation' => \%AssumeConfirmation_of,
        'DryRun' => \%DryRun_of,
        'IncludeDryRunReasonDetails' => \%IncludeDryRunReasonDetails_of,
        'ProtectionPolicyNameOrId' => \%ProtectionPolicyNameOrId_of,
        'StorageServiceContact' => \%StorageServiceContact_of,
        'StorageServiceDescription' => \%StorageServiceDescription_of,
        'StorageServiceName' => \%StorageServiceName_of,
        'StorageServiceNameOrId' => \%StorageServiceNameOrId_of,
        'StorageServiceNodeList' => \%StorageServiceNodeList_of,
        'StorageServiceOwner' => \%StorageServiceOwner_of,
    },
    {
        'AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageServiceContact' => 'MyTypes::EmailAddressList',
        'StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageServiceName' => 'MyTypes::ObjName',
        'StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
        'StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
        'StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AssumeConfirmation' => 'AssumeConfirmation',
        'DryRun' => 'DryRun',
        'IncludeDryRunReasonDetails' => 'IncludeDryRunReasonDetails',
        'ProtectionPolicyNameOrId' => 'ProtectionPolicyNameOrId',
        'StorageServiceContact' => 'StorageServiceContact',
        'StorageServiceDescription' => 'StorageServiceDescription',
        'StorageServiceName' => 'StorageServiceName',
        'StorageServiceNameOrId' => 'StorageServiceNameOrId',
        'StorageServiceNodeList' => 'StorageServiceNodeList',
        'StorageServiceOwner' => 'StorageServiceOwner',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::StorageServiceModify

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
StorageServiceModify from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AssumeConfirmation

 $element->set_AssumeConfirmation($data);
 $element->get_AssumeConfirmation();




=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * IncludeDryRunReasonDetails

 $element->set_IncludeDryRunReasonDetails($data);
 $element->get_IncludeDryRunReasonDetails();




=item * ProtectionPolicyNameOrId

 $element->set_ProtectionPolicyNameOrId($data);
 $element->get_ProtectionPolicyNameOrId();




=item * StorageServiceContact

 $element->set_StorageServiceContact($data);
 $element->get_StorageServiceContact();




=item * StorageServiceDescription

 $element->set_StorageServiceDescription($data);
 $element->get_StorageServiceDescription();




=item * StorageServiceName

 $element->set_StorageServiceName($data);
 $element->get_StorageServiceName();




=item * StorageServiceNameOrId

 $element->set_StorageServiceNameOrId($data);
 $element->get_StorageServiceNameOrId();




=item * StorageServiceNodeList

 $element->set_StorageServiceNodeList($data);
 $element->get_StorageServiceNodeList();




=item * StorageServiceOwner

 $element->set_StorageServiceOwner($data);
 $element->get_StorageServiceOwner();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::StorageServiceModify->new($data);

Constructor. The following data structure may be passed to new():

 {
   AssumeConfirmation =>  $some_value, # boolean
   DryRun =>  $some_value, # boolean
   IncludeDryRunReasonDetails =>  $some_value, # boolean
   ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
   StorageServiceContact => $some_value, # EmailAddressList
   StorageServiceDescription =>  $some_value, # string
   StorageServiceName => $some_value, # ObjName
   StorageServiceNameOrId => $some_value, # ObjNameOrId
   StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
     StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
       DpNodeName => $some_value, # DpPolicyNodeName
       OldDpNodeName => $some_value, # DpPolicyNodeName
       ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
       Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
         ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
       },
       VfilerTemplateNameOrId => $some_value, # ObjNameOrId
     },
   },
   StorageServiceOwner =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

