
package MyElements::VfilerCreate;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('VfilerCreate');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AllowedProtocols_of :ATTR(:get<AllowedProtocols>);
my %DryRun_of :ATTR(:get<DryRun>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %Ipspace_of :ATTR(:get<Ipspace>);
my %Name_of :ATTR(:get<Name>);
my %ResourceNameOrId_of :ATTR(:get<ResourceNameOrId>);

__PACKAGE__->_factory(
    [ qw(        AllowedProtocols
        DryRun
        IpAddress
        Ipspace
        Name
        ResourceNameOrId

    ) ],
    {
        'AllowedProtocols' => \%AllowedProtocols_of,
        'DryRun' => \%DryRun_of,
        'IpAddress' => \%IpAddress_of,
        'Ipspace' => \%Ipspace_of,
        'Name' => \%Name_of,
        'ResourceNameOrId' => \%ResourceNameOrId_of,
    },
    {
        'AllowedProtocols' => 'MyTypes::ArrayOfProtocol',
        'DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IpAddress' => 'MyTypes::IpAddress',
        'Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Name' => 'MyTypes::ObjName',
        'ResourceNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'AllowedProtocols' => 'AllowedProtocols',
        'DryRun' => 'DryRun',
        'IpAddress' => 'IpAddress',
        'Ipspace' => 'Ipspace',
        'Name' => 'Name',
        'ResourceNameOrId' => 'ResourceNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::VfilerCreate

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
VfilerCreate from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AllowedProtocols

 $element->set_AllowedProtocols($data);
 $element->get_AllowedProtocols();




=item * DryRun

 $element->set_DryRun($data);
 $element->get_DryRun();




=item * IpAddress

 $element->set_IpAddress($data);
 $element->get_IpAddress();




=item * Ipspace

 $element->set_Ipspace($data);
 $element->get_Ipspace();




=item * Name

 $element->set_Name($data);
 $element->get_Name();




=item * ResourceNameOrId

 $element->set_ResourceNameOrId($data);
 $element->get_ResourceNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::VfilerCreate->new($data);

Constructor. The following data structure may be passed to new():

 {
   AllowedProtocols =>  { # MyTypes::ArrayOfProtocol
     Protocol => $some_value, # Protocol
   },
   DryRun =>  $some_value, # boolean
   IpAddress => $some_value, # IpAddress
   Ipspace =>  $some_value, # string
   Name => $some_value, # ObjName
   ResourceNameOrId => $some_value, # ObjNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

