
package MyElements::VfilerSetup;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('VfilerSetup');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AllowedProtocols_of :ATTR(:get<AllowedProtocols>);
my %CifsDomainPassword_of :ATTR(:get<CifsDomainPassword>);
my %CifsDomainUser_of :ATTR(:get<CifsDomainUser>);
my %CifsWorkgroupName_of :ATTR(:get<CifsWorkgroupName>);
my %IpBindings_of :ATTR(:get<IpBindings>);
my %RootPassword_of :ATTR(:get<RootPassword>);
my %RunCifsSetup_of :ATTR(:get<RunCifsSetup>);
my %ScriptPath_of :ATTR(:get<ScriptPath>);
my %VfilerNameOrId_of :ATTR(:get<VfilerNameOrId>);
my %VfilerTemplateNameOrId_of :ATTR(:get<VfilerTemplateNameOrId>);

__PACKAGE__->_factory(
    [ qw(        AllowedProtocols
        CifsDomainPassword
        CifsDomainUser
        CifsWorkgroupName
        IpBindings
        RootPassword
        RunCifsSetup
        ScriptPath
        VfilerNameOrId
        VfilerTemplateNameOrId

    ) ],
    {
        'AllowedProtocols' => \%AllowedProtocols_of,
        'CifsDomainPassword' => \%CifsDomainPassword_of,
        'CifsDomainUser' => \%CifsDomainUser_of,
        'CifsWorkgroupName' => \%CifsWorkgroupName_of,
        'IpBindings' => \%IpBindings_of,
        'RootPassword' => \%RootPassword_of,
        'RunCifsSetup' => \%RunCifsSetup_of,
        'ScriptPath' => \%ScriptPath_of,
        'VfilerNameOrId' => \%VfilerNameOrId_of,
        'VfilerTemplateNameOrId' => \%VfilerTemplateNameOrId_of,
    },
    {
        'AllowedProtocols' => 'MyTypes::ArrayOfProtocol',
        'CifsDomainPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CifsDomainUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CifsWorkgroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IpBindings' => 'MyTypes::ArrayOfIpBindingInfo',
        'RootPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RunCifsSetup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerNameOrId' => 'MyTypes::ObjNameOrId',
        'VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'AllowedProtocols' => 'AllowedProtocols',
        'CifsDomainPassword' => 'CifsDomainPassword',
        'CifsDomainUser' => 'CifsDomainUser',
        'CifsWorkgroupName' => 'CifsWorkgroupName',
        'IpBindings' => 'IpBindings',
        'RootPassword' => 'RootPassword',
        'RunCifsSetup' => 'RunCifsSetup',
        'ScriptPath' => 'ScriptPath',
        'VfilerNameOrId' => 'VfilerNameOrId',
        'VfilerTemplateNameOrId' => 'VfilerTemplateNameOrId',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::VfilerSetup

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
VfilerSetup from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AllowedProtocols

 $element->set_AllowedProtocols($data);
 $element->get_AllowedProtocols();




=item * CifsDomainPassword

 $element->set_CifsDomainPassword($data);
 $element->get_CifsDomainPassword();




=item * CifsDomainUser

 $element->set_CifsDomainUser($data);
 $element->get_CifsDomainUser();




=item * CifsWorkgroupName

 $element->set_CifsWorkgroupName($data);
 $element->get_CifsWorkgroupName();




=item * IpBindings

 $element->set_IpBindings($data);
 $element->get_IpBindings();




=item * RootPassword

 $element->set_RootPassword($data);
 $element->get_RootPassword();




=item * RunCifsSetup

 $element->set_RunCifsSetup($data);
 $element->get_RunCifsSetup();




=item * ScriptPath

 $element->set_ScriptPath($data);
 $element->get_ScriptPath();




=item * VfilerNameOrId

 $element->set_VfilerNameOrId($data);
 $element->get_VfilerNameOrId();




=item * VfilerTemplateNameOrId

 $element->set_VfilerTemplateNameOrId($data);
 $element->get_VfilerTemplateNameOrId();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::VfilerSetup->new($data);

Constructor. The following data structure may be passed to new():

 {
   AllowedProtocols =>  { # MyTypes::ArrayOfProtocol
     Protocol => $some_value, # Protocol
   },
   CifsDomainPassword =>  $some_value, # string
   CifsDomainUser =>  $some_value, # string
   CifsWorkgroupName =>  $some_value, # string
   IpBindings =>  { # MyTypes::ArrayOfIpBindingInfo
     IpBindingInfo =>  { # MyTypes::IpBindingInfo
       Interface => $some_value, # ObjNameOrId
       IpAddress => $some_value, # IpAddress
       MtuSize => $some_value, # atomic
       Netmask =>  $some_value, # string
       PartnerInterface => $some_value, # ObjNameOrId
       PrefixLength => $some_value, # atomic
       VlanIdentifier => $some_value, # atomic
     },
   },
   RootPassword =>  $some_value, # string
   RunCifsSetup =>  $some_value, # boolean
   ScriptPath =>  $some_value, # string
   VfilerNameOrId => $some_value, # ObjNameOrId
   VfilerTemplateNameOrId => $some_value, # ObjNameOrId
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

