
package MyElements::VolumeListInfoIterStart;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'http://www.netapp.com/management/v1' }

__PACKAGE__->__set_name('VolumeListInfoIterStart');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BlockType_of :ATTR(:get<BlockType>);
my %IncludeIsAvailable_of :ATTR(:get<IncludeIsAvailable>);
my %IncludeMigrationInfo_of :ATTR(:get<IncludeMigrationInfo>);
my %IncludeNextScheduledBackupTime_of :ATTR(:get<IncludeNextScheduledBackupTime>);
my %IsDirectMemberOnly_of :ATTR(:get<IsDirectMemberOnly>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsSisVolume_of :ATTR(:get<IsSisVolume>);
my %IsSnapmirrorPrimaryCapable_of :ATTR(:get<IsSnapmirrorPrimaryCapable>);
my %IsSnapmirrorSecondaryCapable_of :ATTR(:get<IsSnapmirrorSecondaryCapable>);
my %IsSnapvaultPrimaryCapable_of :ATTR(:get<IsSnapvaultPrimaryCapable>);
my %IsSnapvaultSecondaryCapable_of :ATTR(:get<IsSnapvaultSecondaryCapable>);
my %IsUnprotected_of :ATTR(:get<IsUnprotected>);
my %ObjectManagementFilter_of :ATTR(:get<ObjectManagementFilter>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %RbacOperation_of :ATTR(:get<RbacOperation>);
my %SnapvaultSecondaryScheduleName_of :ATTR(:get<SnapvaultSecondaryScheduleName>);
my %VolumeType_of :ATTR(:get<VolumeType>);

__PACKAGE__->_factory(
    [ qw(        BlockType
        IncludeIsAvailable
        IncludeMigrationInfo
        IncludeNextScheduledBackupTime
        IsDirectMemberOnly
        IsDpIgnored
        IsInDataset
        IsSisVolume
        IsSnapmirrorPrimaryCapable
        IsSnapmirrorSecondaryCapable
        IsSnapvaultPrimaryCapable
        IsSnapvaultSecondaryCapable
        IsUnprotected
        ObjectManagementFilter
        ObjectNameOrId
        RbacOperation
        SnapvaultSecondaryScheduleName
        VolumeType

    ) ],
    {
        'BlockType' => \%BlockType_of,
        'IncludeIsAvailable' => \%IncludeIsAvailable_of,
        'IncludeMigrationInfo' => \%IncludeMigrationInfo_of,
        'IncludeNextScheduledBackupTime' => \%IncludeNextScheduledBackupTime_of,
        'IsDirectMemberOnly' => \%IsDirectMemberOnly_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsSisVolume' => \%IsSisVolume_of,
        'IsSnapmirrorPrimaryCapable' => \%IsSnapmirrorPrimaryCapable_of,
        'IsSnapmirrorSecondaryCapable' => \%IsSnapmirrorSecondaryCapable_of,
        'IsSnapvaultPrimaryCapable' => \%IsSnapvaultPrimaryCapable_of,
        'IsSnapvaultSecondaryCapable' => \%IsSnapvaultSecondaryCapable_of,
        'IsUnprotected' => \%IsUnprotected_of,
        'ObjectManagementFilter' => \%ObjectManagementFilter_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'RbacOperation' => \%RbacOperation_of,
        'SnapvaultSecondaryScheduleName' => \%SnapvaultSecondaryScheduleName_of,
        'VolumeType' => \%VolumeType_of,
    },
    {
        'BlockType' => 'MyTypes::FileSystemBlockType',
        'IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeNextScheduledBackupTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSisVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
        'ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnapvaultSecondaryScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BlockType' => 'BlockType',
        'IncludeIsAvailable' => 'IncludeIsAvailable',
        'IncludeMigrationInfo' => 'IncludeMigrationInfo',
        'IncludeNextScheduledBackupTime' => 'IncludeNextScheduledBackupTime',
        'IsDirectMemberOnly' => 'IsDirectMemberOnly',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsSisVolume' => 'IsSisVolume',
        'IsSnapmirrorPrimaryCapable' => 'IsSnapmirrorPrimaryCapable',
        'IsSnapmirrorSecondaryCapable' => 'IsSnapmirrorSecondaryCapable',
        'IsSnapvaultPrimaryCapable' => 'IsSnapvaultPrimaryCapable',
        'IsSnapvaultSecondaryCapable' => 'IsSnapvaultSecondaryCapable',
        'IsUnprotected' => 'IsUnprotected',
        'ObjectManagementFilter' => 'ObjectManagementFilter',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'RbacOperation' => 'RbacOperation',
        'SnapvaultSecondaryScheduleName' => 'SnapvaultSecondaryScheduleName',
        'VolumeType' => 'VolumeType',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::VolumeListInfoIterStart

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
VolumeListInfoIterStart from the namespace http://www.netapp.com/management/v1.







=head1 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BlockType

 $element->set_BlockType($data);
 $element->get_BlockType();




=item * IncludeIsAvailable

 $element->set_IncludeIsAvailable($data);
 $element->get_IncludeIsAvailable();




=item * IncludeMigrationInfo

 $element->set_IncludeMigrationInfo($data);
 $element->get_IncludeMigrationInfo();




=item * IncludeNextScheduledBackupTime

 $element->set_IncludeNextScheduledBackupTime($data);
 $element->get_IncludeNextScheduledBackupTime();




=item * IsDirectMemberOnly

 $element->set_IsDirectMemberOnly($data);
 $element->get_IsDirectMemberOnly();




=item * IsDpIgnored

 $element->set_IsDpIgnored($data);
 $element->get_IsDpIgnored();




=item * IsInDataset

 $element->set_IsInDataset($data);
 $element->get_IsInDataset();




=item * IsSisVolume

 $element->set_IsSisVolume($data);
 $element->get_IsSisVolume();




=item * IsSnapmirrorPrimaryCapable

 $element->set_IsSnapmirrorPrimaryCapable($data);
 $element->get_IsSnapmirrorPrimaryCapable();




=item * IsSnapmirrorSecondaryCapable

 $element->set_IsSnapmirrorSecondaryCapable($data);
 $element->get_IsSnapmirrorSecondaryCapable();




=item * IsSnapvaultPrimaryCapable

 $element->set_IsSnapvaultPrimaryCapable($data);
 $element->get_IsSnapvaultPrimaryCapable();




=item * IsSnapvaultSecondaryCapable

 $element->set_IsSnapvaultSecondaryCapable($data);
 $element->get_IsSnapvaultSecondaryCapable();




=item * IsUnprotected

 $element->set_IsUnprotected($data);
 $element->get_IsUnprotected();




=item * ObjectManagementFilter

 $element->set_ObjectManagementFilter($data);
 $element->get_ObjectManagementFilter();




=item * ObjectNameOrId

 $element->set_ObjectNameOrId($data);
 $element->get_ObjectNameOrId();




=item * RbacOperation

 $element->set_RbacOperation($data);
 $element->get_RbacOperation();




=item * SnapvaultSecondaryScheduleName

 $element->set_SnapvaultSecondaryScheduleName($data);
 $element->get_SnapvaultSecondaryScheduleName();




=item * VolumeType

 $element->set_VolumeType($data);
 $element->get_VolumeType();





=back


=head1 METHODS

=head2 new

 my $element = MyElements::VolumeListInfoIterStart->new($data);

Constructor. The following data structure may be passed to new():

 {
   BlockType => $some_value, # FileSystemBlockType
   IncludeIsAvailable =>  $some_value, # boolean
   IncludeMigrationInfo =>  $some_value, # boolean
   IncludeNextScheduledBackupTime =>  $some_value, # boolean
   IsDirectMemberOnly =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsSisVolume =>  $some_value, # boolean
   IsSnapmirrorPrimaryCapable =>  $some_value, # boolean
   IsSnapmirrorSecondaryCapable =>  $some_value, # boolean
   IsSnapvaultPrimaryCapable =>  $some_value, # boolean
   IsSnapvaultSecondaryCapable =>  $some_value, # boolean
   IsUnprotected =>  $some_value, # boolean
   ObjectManagementFilter => $some_value, # ObjectManagementInterface
   ObjectNameOrId =>  $some_value, # string
   RbacOperation =>  $some_value, # string
   SnapvaultSecondaryScheduleName =>  $some_value, # string
   VolumeType =>  $some_value, # string
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

