package MyTypes::AdminInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminId_of :ATTR(:get<AdminId>);
my %AdminName_of :ATTR(:get<AdminName>);
my %EmailAddress_of :ATTR(:get<EmailAddress>);
my %PagerAddress_of :ATTR(:get<PagerAddress>);

__PACKAGE__->_factory(
    [ qw(        AdminId
        AdminName
        EmailAddress
        PagerAddress

    ) ],
    {
        'AdminId' => \%AdminId_of,
        'AdminName' => \%AdminName_of,
        'EmailAddress' => \%EmailAddress_of,
        'PagerAddress' => \%PagerAddress_of,
    },
    {
        'AdminId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'AdminName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EmailAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PagerAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AdminId' => 'AdminId',
        'AdminName' => 'AdminName',
        'EmailAddress' => 'EmailAddress',
        'PagerAddress' => 'PagerAddress',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::AdminInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AdminInfo from the namespace http://www.netapp.com/management/v1.

Details of a administrator.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminId


=item * AdminName


=item * EmailAddress


=item * PagerAddress




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AdminInfo
   AdminId =>  $some_value, # integer
   AdminName =>  $some_value, # string
   EmailAddress =>  $some_value, # string
   PagerAddress =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

