package MyTypes::AdvancedOptionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %OptionName_of :ATTR(:get<OptionName>);
my %OptionValue_of :ATTR(:get<OptionValue>);

__PACKAGE__->_factory(
    [ qw(        OptionName
        OptionValue

    ) ],
    {
        'OptionName' => \%OptionName_of,
        'OptionValue' => \%OptionValue_of,
    },
    {
        'OptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'OptionName' => 'OptionName',
        'OptionValue' => 'OptionValue',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::AdvancedOptionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AdvancedOptionInfo from the namespace http://www.netapp.com/management/v1.

A set of advanced Options To be set on the provisioned storage containers.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * OptionName


=item * OptionValue




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AdvancedOptionInfo
   OptionName =>  $some_value, # string
   OptionValue =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

