package MyTypes::AggregateInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateFullThreshold_of :ATTR(:get<AggregateFullThreshold>);
my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);
my %AggregateNearlyFullThreshold_of :ATTR(:get<AggregateNearlyFullThreshold>);
my %AggregateNearlyOvercommittedThreshold_of :ATTR(:get<AggregateNearlyOvercommittedThreshold>);
my %AggregateOvercommittedThreshold_of :ATTR(:get<AggregateOvercommittedThreshold>);
my %AggregatePerfStatus_of :ATTR(:get<AggregatePerfStatus>);
my %AggregateSize_of :ATTR(:get<AggregateSize>);
my %AggregateSpaceStatus_of :ATTR(:get<AggregateSpaceStatus>);
my %AggregateStatus_of :ATTR(:get<AggregateStatus>);
my %AggregateType_of :ATTR(:get<AggregateType>);
my %BlockType_of :ATTR(:get<BlockType>);
my %Datasets_of :ATTR(:get<Datasets>);
my %DatasetsSpaceInfo_of :ATTR(:get<DatasetsSpaceInfo>);
my %FilerId_of :ATTR(:get<FilerId>);
my %FilerName_of :ATTR(:get<FilerName>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %ResourcepoolName_of :ATTR(:get<ResourcepoolName>);
my %TimeToFull_of :ATTR(:get<TimeToFull>);

__PACKAGE__->_factory(
    [ qw(        AggregateFullThreshold
        AggregateId
        AggregateName
        AggregateNearlyFullThreshold
        AggregateNearlyOvercommittedThreshold
        AggregateOvercommittedThreshold
        AggregatePerfStatus
        AggregateSize
        AggregateSpaceStatus
        AggregateStatus
        AggregateType
        BlockType
        Datasets
        DatasetsSpaceInfo
        FilerId
        FilerName
        IsAvailable
        IsDpIgnored
        IsInDataset
        ResourcepoolName
        TimeToFull

    ) ],
    {
        'AggregateFullThreshold' => \%AggregateFullThreshold_of,
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
        'AggregateNearlyFullThreshold' => \%AggregateNearlyFullThreshold_of,
        'AggregateNearlyOvercommittedThreshold' => \%AggregateNearlyOvercommittedThreshold_of,
        'AggregateOvercommittedThreshold' => \%AggregateOvercommittedThreshold_of,
        'AggregatePerfStatus' => \%AggregatePerfStatus_of,
        'AggregateSize' => \%AggregateSize_of,
        'AggregateSpaceStatus' => \%AggregateSpaceStatus_of,
        'AggregateStatus' => \%AggregateStatus_of,
        'AggregateType' => \%AggregateType_of,
        'BlockType' => \%BlockType_of,
        'Datasets' => \%Datasets_of,
        'DatasetsSpaceInfo' => \%DatasetsSpaceInfo_of,
        'FilerId' => \%FilerId_of,
        'FilerName' => \%FilerName_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'ResourcepoolName' => \%ResourcepoolName_of,
        'TimeToFull' => \%TimeToFull_of,
    },
    {

        'AggregateFullThreshold' => 'MyTypes::AggregateInfo::_AggregateFullThreshold',

        'AggregateId' => 'MyTypes::AggregateInfo::_AggregateId',
        'AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'AggregateNearlyFullThreshold' => 'MyTypes::AggregateInfo::_AggregateNearlyFullThreshold',
        'AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
        'AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
        'AggregatePerfStatus' => 'MyTypes::ObjStatus',
        'AggregateSize' => 'MyTypes::AggregateSize',
        'AggregateSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
        'AggregateStatus' => 'MyTypes::ObjStatus',
        'AggregateType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BlockType' => 'MyTypes::FileSystemBlockType',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'DatasetsSpaceInfo' => 'MyTypes::ArrayOfDatasetSpaceInfo',

        'FilerId' => 'MyTypes::AggregateInfo::_FilerId',
        'FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ResourcepoolName' => 'MyTypes::ObjName',

        'TimeToFull' => 'MyTypes::AggregateInfo::_TimeToFull',
    },
    {

        'AggregateFullThreshold' => 'AggregateFullThreshold',
        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
        'AggregateNearlyFullThreshold' => 'AggregateNearlyFullThreshold',
        'AggregateNearlyOvercommittedThreshold' => 'AggregateNearlyOvercommittedThreshold',
        'AggregateOvercommittedThreshold' => 'AggregateOvercommittedThreshold',
        'AggregatePerfStatus' => 'AggregatePerfStatus',
        'AggregateSize' => 'AggregateSize',
        'AggregateSpaceStatus' => 'AggregateSpaceStatus',
        'AggregateStatus' => 'AggregateStatus',
        'AggregateType' => 'AggregateType',
        'BlockType' => 'BlockType',
        'Datasets' => 'Datasets',
        'DatasetsSpaceInfo' => 'DatasetsSpaceInfo',
        'FilerId' => 'FilerId',
        'FilerName' => 'FilerName',
        'IsAvailable' => 'IsAvailable',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'ResourcepoolName' => 'ResourcepoolName',
        'TimeToFull' => 'TimeToFull',
    }
);

} # end BLOCK




package MyTypes::AggregateInfo::_AggregateFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateInfo::_AggregateId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateInfo::_AggregateNearlyFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateInfo::_FilerId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateInfo::_TimeToFull;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::AggregateInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AggregateInfo from the namespace http://www.netapp.com/management/v1.

Information about a Aggregate.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateFullThreshold


=item * AggregateId


=item * AggregateName


=item * AggregateNearlyFullThreshold


=item * AggregateNearlyOvercommittedThreshold


=item * AggregateOvercommittedThreshold


=item * AggregatePerfStatus


=item * AggregateSize


=item * AggregateSpaceStatus


=item * AggregateStatus


=item * AggregateType


=item * BlockType


=item * Datasets


=item * DatasetsSpaceInfo


=item * FilerId


=item * FilerName


=item * IsAvailable


=item * IsDpIgnored


=item * IsInDataset


=item * ResourcepoolName


=item * TimeToFull




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AggregateInfo
   AggregateFullThreshold => $some_value, # atomic
   AggregateId => $some_value, # atomic
   AggregateName =>  $some_value, # string
   AggregateNearlyFullThreshold => $some_value, # atomic
   AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
   AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
   AggregatePerfStatus => $some_value, # ObjStatus
   AggregateSize =>  { # MyTypes::AggregateSize
     SizeAvailable => $some_value, # atomic
     SizeTotal => $some_value, # atomic
     SizeUsed => $some_value, # atomic
     SpaceTotalCommitted => $some_value, # atomic
   },
   AggregateSpaceStatus => $some_value, # ObjectSpaceStatus
   AggregateStatus => $some_value, # ObjStatus
   AggregateType =>  $some_value, # string
   BlockType => $some_value, # FileSystemBlockType
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   DatasetsSpaceInfo =>  { # MyTypes::ArrayOfDatasetSpaceInfo
     DatasetSpaceInfo =>  { # MyTypes::DatasetSpaceInfo
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DpNodeId => $some_value, # atomic
       DpNodeName =>  $some_value, # string
       IsCapableOfMigration =>  $some_value, # boolean
       IsDpNodeEffectivePrimary =>  $some_value, # boolean
       UsedSpace =>  $some_value, # unsignedLong
     },
   },
   FilerId => $some_value, # atomic
   FilerName =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   ResourcepoolName => $some_value, # ObjName
   TimeToFull => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

