package MyTypes::AggregateNameOrId;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
    },
    {
        'AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::AggregateNameOrId

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AggregateNameOrId from the namespace http://www.netapp.com/management/v1.

Details of an Aggregate Name or Id. When used as input only one of AggregateName or AggregateId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AggregateNameOrId
   AggregateId =>  $some_value, # unsignedInt
   AggregateName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

