package MyTypes::AggregateResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateResourceNameOrId_of :ATTR(:get<AggregateResourceNameOrId>);
my %FilerIdentifier_of :ATTR(:get<FilerIdentifier>);

__PACKAGE__->_factory(
    [ qw(        AggregateResourceNameOrId
        FilerIdentifier

    ) ],
    {
        'AggregateResourceNameOrId' => \%AggregateResourceNameOrId_of,
        'FilerIdentifier' => \%FilerIdentifier_of,
    },
    {
        'AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
        'FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
    },
    {

        'AggregateResourceNameOrId' => 'AggregateResourceNameOrId',
        'FilerIdentifier' => 'FilerIdentifier',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::AggregateResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AggregateResource from the namespace http://www.netapp.com/management/v1.

Details of an Aggregate Resource. AggregateResourceNameOrId must be specified. If AggregateName is specified, then need To also specify FilerIdentifier.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateResourceNameOrId


=item * FilerIdentifier




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AggregateResource
   AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
     AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
       AggregateId =>  $some_value, # unsignedInt
       AggregateName =>  $some_value, # string
     },
   },
   FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
     FilerResource =>  { # MyTypes::FilerResource
       FilerId =>  $some_value, # unsignedInt
       FilerName =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

