package MyTypes::AggregateSize;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SizeAvailable_of :ATTR(:get<SizeAvailable>);
my %SizeTotal_of :ATTR(:get<SizeTotal>);
my %SizeUsed_of :ATTR(:get<SizeUsed>);
my %SpaceTotalCommitted_of :ATTR(:get<SpaceTotalCommitted>);

__PACKAGE__->_factory(
    [ qw(        SizeAvailable
        SizeTotal
        SizeUsed
        SpaceTotalCommitted

    ) ],
    {
        'SizeAvailable' => \%SizeAvailable_of,
        'SizeTotal' => \%SizeTotal_of,
        'SizeUsed' => \%SizeUsed_of,
        'SpaceTotalCommitted' => \%SpaceTotalCommitted_of,
    },
    {

        'SizeAvailable' => 'MyTypes::AggregateSize::_SizeAvailable',

        'SizeTotal' => 'MyTypes::AggregateSize::_SizeTotal',

        'SizeUsed' => 'MyTypes::AggregateSize::_SizeUsed',

        'SpaceTotalCommitted' => 'MyTypes::AggregateSize::_SpaceTotalCommitted',
    },
    {

        'SizeAvailable' => 'SizeAvailable',
        'SizeTotal' => 'SizeTotal',
        'SizeUsed' => 'SizeUsed',
        'SpaceTotalCommitted' => 'SpaceTotalCommitted',
    }
);

} # end BLOCK




package MyTypes::AggregateSize::_SizeAvailable;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateSize::_SizeTotal;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateSize::_SizeUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateSize::_SpaceTotalCommitted;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::AggregateSize

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AggregateSize from the namespace http://www.netapp.com/management/v1.

Sizes of various parameters of an Aggregate.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SizeAvailable


=item * SizeTotal


=item * SizeUsed


=item * SpaceTotalCommitted




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AggregateSize
   SizeAvailable => $some_value, # atomic
   SizeTotal => $some_value, # atomic
   SizeUsed => $some_value, # atomic
   SpaceTotalCommitted => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

