package MyTypes::AggregateSpaceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);
my %CommittedSpace_of :ATTR(:get<CommittedSpace>);
my %UsedSpace_of :ATTR(:get<UsedSpace>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName
        CommittedSpace
        UsedSpace

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
        'CommittedSpace' => \%CommittedSpace_of,
        'UsedSpace' => \%UsedSpace_of,
    },
    {
        'AggregateId' => 'MyTypes::ObjId',
        'AggregateName' => 'MyTypes::ObjName',

        'CommittedSpace' => 'MyTypes::AggregateSpaceInfo::_CommittedSpace',

        'UsedSpace' => 'MyTypes::AggregateSpaceInfo::_UsedSpace',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
        'CommittedSpace' => 'CommittedSpace',
        'UsedSpace' => 'UsedSpace',
    }
);

} # end BLOCK




package MyTypes::AggregateSpaceInfo::_CommittedSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AggregateSpaceInfo::_UsedSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::AggregateSpaceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AggregateSpaceInfo from the namespace http://www.netapp.com/management/v1.

Information about space charecteristics of an Aggregate.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName


=item * CommittedSpace


=item * UsedSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AggregateSpaceInfo
   AggregateId => $some_value, # ObjId
   AggregateName => $some_value, # ObjName
   CommittedSpace => $some_value, # atomic
   UsedSpace => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

