package MyTypes::AlarmDefaults;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupId_of :ATTR(:get<GroupId>);
my %IsDisabled_of :ATTR(:get<IsDisabled>);
my %IsRepeatNotify_of :ATTR(:get<IsRepeatNotify>);
my %RepeatInterval_of :ATTR(:get<RepeatInterval>);
my %TrapPort_of :ATTR(:get<TrapPort>);

__PACKAGE__->_factory(
    [ qw(        GroupId
        IsDisabled
        IsRepeatNotify
        RepeatInterval
        TrapPort

    ) ],
    {
        'GroupId' => \%GroupId_of,
        'IsDisabled' => \%IsDisabled_of,
        'IsRepeatNotify' => \%IsRepeatNotify_of,
        'RepeatInterval' => \%RepeatInterval_of,
        'TrapPort' => \%TrapPort_of,
    },
    {
        'GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'RepeatInterval' => 'MyTypes::AlarmDefaults::_RepeatInterval',

        'TrapPort' => 'MyTypes::AlarmDefaults::_TrapPort',
    },
    {

        'GroupId' => 'GroupId',
        'IsDisabled' => 'IsDisabled',
        'IsRepeatNotify' => 'IsRepeatNotify',
        'RepeatInterval' => 'RepeatInterval',
        'TrapPort' => 'TrapPort',
    }
);

} # end BLOCK




package MyTypes::AlarmDefaults::_RepeatInterval;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AlarmDefaults::_TrapPort;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::AlarmDefaults

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AlarmDefaults from the namespace http://www.netapp.com/management/v1.

The default Values of the Attributes defined by this ZAPI.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupId


=item * IsDisabled


=item * IsRepeatNotify


=item * RepeatInterval


=item * TrapPort




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AlarmDefaults
   GroupId =>  $some_value, # integer
   IsDisabled =>  $some_value, # boolean
   IsRepeatNotify =>  $some_value, # boolean
   RepeatInterval => $some_value, # atomic
   TrapPort => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

