package MyTypes::AlarmInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminLoginNames_of :ATTR(:get<AdminLoginNames>);
my %AlarmId_of :ATTR(:get<AlarmId>);
my %AlarmScript_of :ATTR(:get<AlarmScript>);
my %AlarmScriptRunas_of :ATTR(:get<AlarmScriptRunas>);
my %EmailAddresses_of :ATTR(:get<EmailAddresses>);
my %EventClass_of :ATTR(:get<EventClass>);
my %EventName_of :ATTR(:get<EventName>);
my %EventSeverity_of :ATTR(:get<EventSeverity>);
my %GroupId_of :ATTR(:get<GroupId>);
my %GroupName_of :ATTR(:get<GroupName>);
my %IsDisabled_of :ATTR(:get<IsDisabled>);
my %IsRepeatNotify_of :ATTR(:get<IsRepeatNotify>);
my %PagerAdminLoginNames_of :ATTR(:get<PagerAdminLoginNames>);
my %PagerEmailAddresses_of :ATTR(:get<PagerEmailAddresses>);
my %RepeatInterval_of :ATTR(:get<RepeatInterval>);
my %TimeFrom_of :ATTR(:get<TimeFrom>);
my %TimeTo_of :ATTR(:get<TimeTo>);
my %TrapDestinations_of :ATTR(:get<TrapDestinations>);

__PACKAGE__->_factory(
    [ qw(        AdminLoginNames
        AlarmId
        AlarmScript
        AlarmScriptRunas
        EmailAddresses
        EventClass
        EventName
        EventSeverity
        GroupId
        GroupName
        IsDisabled
        IsRepeatNotify
        PagerAdminLoginNames
        PagerEmailAddresses
        RepeatInterval
        TimeFrom
        TimeTo
        TrapDestinations

    ) ],
    {
        'AdminLoginNames' => \%AdminLoginNames_of,
        'AlarmId' => \%AlarmId_of,
        'AlarmScript' => \%AlarmScript_of,
        'AlarmScriptRunas' => \%AlarmScriptRunas_of,
        'EmailAddresses' => \%EmailAddresses_of,
        'EventClass' => \%EventClass_of,
        'EventName' => \%EventName_of,
        'EventSeverity' => \%EventSeverity_of,
        'GroupId' => \%GroupId_of,
        'GroupName' => \%GroupName_of,
        'IsDisabled' => \%IsDisabled_of,
        'IsRepeatNotify' => \%IsRepeatNotify_of,
        'PagerAdminLoginNames' => \%PagerAdminLoginNames_of,
        'PagerEmailAddresses' => \%PagerEmailAddresses_of,
        'RepeatInterval' => \%RepeatInterval_of,
        'TimeFrom' => \%TimeFrom_of,
        'TimeTo' => \%TimeTo_of,
        'TrapDestinations' => \%TrapDestinations_of,
    },
    {
        'AdminLoginNames' => 'MyTypes::ArrayOfAdminName',

        'AlarmId' => 'MyTypes::AlarmInfo::_AlarmId',
        'AlarmScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AlarmScriptRunas' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
        'EventClass' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventSeverity' => 'MyTypes::ObjStatus',

        'GroupId' => 'MyTypes::AlarmInfo::_GroupId',
        'GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PagerAdminLoginNames' => 'MyTypes::ArrayOfAdminName',
        'PagerEmailAddresses' => 'MyTypes::ArrayOfEmailAddress',

        'RepeatInterval' => 'MyTypes::AlarmInfo::_RepeatInterval',

        'TimeFrom' => 'MyTypes::AlarmInfo::_TimeFrom',

        'TimeTo' => 'MyTypes::AlarmInfo::_TimeTo',
        'TrapDestinations' => 'MyTypes::ArrayOfTrapDestination',
    },
    {

        'AdminLoginNames' => 'AdminLoginNames',
        'AlarmId' => 'AlarmId',
        'AlarmScript' => 'AlarmScript',
        'AlarmScriptRunas' => 'AlarmScriptRunas',
        'EmailAddresses' => 'EmailAddresses',
        'EventClass' => 'EventClass',
        'EventName' => 'EventName',
        'EventSeverity' => 'EventSeverity',
        'GroupId' => 'GroupId',
        'GroupName' => 'GroupName',
        'IsDisabled' => 'IsDisabled',
        'IsRepeatNotify' => 'IsRepeatNotify',
        'PagerAdminLoginNames' => 'PagerAdminLoginNames',
        'PagerEmailAddresses' => 'PagerEmailAddresses',
        'RepeatInterval' => 'RepeatInterval',
        'TimeFrom' => 'TimeFrom',
        'TimeTo' => 'TimeTo',
        'TrapDestinations' => 'TrapDestinations',
    }
);

} # end BLOCK




package MyTypes::AlarmInfo::_AlarmId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AlarmInfo::_GroupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AlarmInfo::_RepeatInterval;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AlarmInfo::_TimeFrom;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::AlarmInfo::_TimeTo;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::AlarmInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
AlarmInfo from the namespace http://www.netapp.com/management/v1.

Information about a single alarm. This structure is used in three places: creating new alarms, modifying alarms, and listing alarms.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminLoginNames


=item * AlarmId


=item * AlarmScript


=item * AlarmScriptRunas


=item * EmailAddresses


=item * EventClass


=item * EventName


=item * EventSeverity


=item * GroupId


=item * GroupName


=item * IsDisabled


=item * IsRepeatNotify


=item * PagerAdminLoginNames


=item * PagerEmailAddresses


=item * RepeatInterval


=item * TimeFrom


=item * TimeTo


=item * TrapDestinations




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::AlarmInfo
   AdminLoginNames =>  { # MyTypes::ArrayOfAdminName
     AdminName => $some_value, # AdminName
   },
   AlarmId => $some_value, # atomic
   AlarmScript =>  $some_value, # string
   AlarmScriptRunas =>  $some_value, # string
   EmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
     EmailAddress => $some_value, # EmailAddress
   },
   EventClass =>  $some_value, # string
   EventName =>  $some_value, # string
   EventSeverity => $some_value, # ObjStatus
   GroupId => $some_value, # atomic
   GroupName =>  $some_value, # string
   IsDisabled =>  $some_value, # boolean
   IsRepeatNotify =>  $some_value, # boolean
   PagerAdminLoginNames =>  { # MyTypes::ArrayOfAdminName
     AdminName => $some_value, # AdminName
   },
   PagerEmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
     EmailAddress => $some_value, # EmailAddress
   },
   RepeatInterval => $some_value, # atomic
   TimeFrom => $some_value, # atomic
   TimeTo => $some_value, # atomic
   TrapDestinations =>  { # MyTypes::ArrayOfTrapDestination
     TrapDestination =>  { # MyTypes::TrapDestination
       TrapCommunity =>  $some_value, # string
       TrapHost =>  $some_value, # string
       TrapPort => $some_value, # atomic
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

