package MyTypes::ApiStat;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApiName_of :ATTR(:get<ApiName>);
my %CallCount_of :ATTR(:get<CallCount>);
my %CpuMaxTime_of :ATTR(:get<CpuMaxTime>);
my %CpuMeanTime_of :ATTR(:get<CpuMeanTime>);
my %CpuMinTime_of :ATTR(:get<CpuMinTime>);
my %DbMaxCalls_of :ATTR(:get<DbMaxCalls>);
my %DbMaxTime_of :ATTR(:get<DbMaxTime>);
my %DbMeanCalls_of :ATTR(:get<DbMeanCalls>);
my %DbMeanTime_of :ATTR(:get<DbMeanTime>);
my %DbMinCalls_of :ATTR(:get<DbMinCalls>);
my %DbMinTime_of :ATTR(:get<DbMinTime>);
my %MaxTime_of :ATTR(:get<MaxTime>);
my %MeanTime_of :ATTR(:get<MeanTime>);
my %MinTime_of :ATTR(:get<MinTime>);

__PACKAGE__->_factory(
    [ qw(        ApiName
        CallCount
        CpuMaxTime
        CpuMeanTime
        CpuMinTime
        DbMaxCalls
        DbMaxTime
        DbMeanCalls
        DbMeanTime
        DbMinCalls
        DbMinTime
        MaxTime
        MeanTime
        MinTime

    ) ],
    {
        'ApiName' => \%ApiName_of,
        'CallCount' => \%CallCount_of,
        'CpuMaxTime' => \%CpuMaxTime_of,
        'CpuMeanTime' => \%CpuMeanTime_of,
        'CpuMinTime' => \%CpuMinTime_of,
        'DbMaxCalls' => \%DbMaxCalls_of,
        'DbMaxTime' => \%DbMaxTime_of,
        'DbMeanCalls' => \%DbMeanCalls_of,
        'DbMeanTime' => \%DbMeanTime_of,
        'DbMinCalls' => \%DbMinCalls_of,
        'DbMinTime' => \%DbMinTime_of,
        'MaxTime' => \%MaxTime_of,
        'MeanTime' => \%MeanTime_of,
        'MinTime' => \%MinTime_of,
    },
    {
        'ApiName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'CallCount' => 'MyTypes::ApiStat::_CallCount',

        'CpuMaxTime' => 'MyTypes::ApiStat::_CpuMaxTime',

        'CpuMeanTime' => 'MyTypes::ApiStat::_CpuMeanTime',

        'CpuMinTime' => 'MyTypes::ApiStat::_CpuMinTime',
        'DbMaxCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',

        'DbMaxTime' => 'MyTypes::ApiStat::_DbMaxTime',
        'DbMeanCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',

        'DbMeanTime' => 'MyTypes::ApiStat::_DbMeanTime',
        'DbMinCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',

        'DbMinTime' => 'MyTypes::ApiStat::_DbMinTime',

        'MaxTime' => 'MyTypes::ApiStat::_MaxTime',

        'MeanTime' => 'MyTypes::ApiStat::_MeanTime',

        'MinTime' => 'MyTypes::ApiStat::_MinTime',
    },
    {

        'ApiName' => 'ApiName',
        'CallCount' => 'CallCount',
        'CpuMaxTime' => 'CpuMaxTime',
        'CpuMeanTime' => 'CpuMeanTime',
        'CpuMinTime' => 'CpuMinTime',
        'DbMaxCalls' => 'DbMaxCalls',
        'DbMaxTime' => 'DbMaxTime',
        'DbMeanCalls' => 'DbMeanCalls',
        'DbMeanTime' => 'DbMeanTime',
        'DbMinCalls' => 'DbMinCalls',
        'DbMinTime' => 'DbMinTime',
        'MaxTime' => 'MaxTime',
        'MeanTime' => 'MeanTime',
        'MinTime' => 'MinTime',
    }
);

} # end BLOCK




package MyTypes::ApiStat::_CallCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_CpuMaxTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_CpuMeanTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_CpuMinTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_DbMaxTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_DbMeanTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_DbMinTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_MaxTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_MeanTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApiStat::_MinTime;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ApiStat

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApiStat from the namespace http://www.netapp.com/management/v1.

Statistics about a single server API




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApiName


=item * CallCount


=item * CpuMaxTime


=item * CpuMeanTime


=item * CpuMinTime


=item * DbMaxCalls


=item * DbMaxTime


=item * DbMeanCalls


=item * DbMeanTime


=item * DbMinCalls


=item * DbMinTime


=item * MaxTime


=item * MeanTime


=item * MinTime




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApiStat
   ApiName =>  $some_value, # string
   CallCount => $some_value, # atomic
   CpuMaxTime => $some_value, # atomic
   CpuMeanTime => $some_value, # atomic
   CpuMinTime => $some_value, # atomic
   DbMaxCalls =>  $some_value, # unsignedInt
   DbMaxTime => $some_value, # atomic
   DbMeanCalls =>  $some_value, # unsignedInt
   DbMeanTime => $some_value, # atomic
   DbMinCalls =>  $some_value, # unsignedInt
   DbMinTime => $some_value, # atomic
   MaxTime => $some_value, # atomic
   MeanTime => $some_value, # atomic
   MinTime => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

