package MyTypes::ApplicationBackupScheduleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HypervBackupScheduleSettingsInfo_of :ATTR(:get<HypervBackupScheduleSettingsInfo>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %ScheduleId_of :ATTR(:get<ScheduleId>);
my %SimpleScheduleInfo_of :ATTR(:get<SimpleScheduleInfo>);
my %StartRemoteBackupAfterLocalBackup_of :ATTR(:get<StartRemoteBackupAfterLocalBackup>);
my %VmwareBackupScheduleSettingsInfo_of :ATTR(:get<VmwareBackupScheduleSettingsInfo>);

__PACKAGE__->_factory(
    [ qw(        HypervBackupScheduleSettingsInfo
        RetentionType
        ScheduleId
        SimpleScheduleInfo
        StartRemoteBackupAfterLocalBackup
        VmwareBackupScheduleSettingsInfo

    ) ],
    {
        'HypervBackupScheduleSettingsInfo' => \%HypervBackupScheduleSettingsInfo_of,
        'RetentionType' => \%RetentionType_of,
        'ScheduleId' => \%ScheduleId_of,
        'SimpleScheduleInfo' => \%SimpleScheduleInfo_of,
        'StartRemoteBackupAfterLocalBackup' => \%StartRemoteBackupAfterLocalBackup_of,
        'VmwareBackupScheduleSettingsInfo' => \%VmwareBackupScheduleSettingsInfo_of,
    },
    {
        'HypervBackupScheduleSettingsInfo' => 'MyTypes::HypervBackupScheduleSettingsInfo',
        'RetentionType' => 'MyTypes::DpBackupRetentionType',
        'ScheduleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SimpleScheduleInfo' => 'MyTypes::SimpleScheduleInfo',
        'StartRemoteBackupAfterLocalBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'VmwareBackupScheduleSettingsInfo' => 'MyTypes::VmwareBackupScheduleSettingsInfo',
    },
    {

        'HypervBackupScheduleSettingsInfo' => 'HypervBackupScheduleSettingsInfo',
        'RetentionType' => 'RetentionType',
        'ScheduleId' => 'ScheduleId',
        'SimpleScheduleInfo' => 'SimpleScheduleInfo',
        'StartRemoteBackupAfterLocalBackup' => 'StartRemoteBackupAfterLocalBackup',
        'VmwareBackupScheduleSettingsInfo' => 'VmwareBackupScheduleSettingsInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ApplicationBackupScheduleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApplicationBackupScheduleInfo from the namespace http://www.netapp.com/management/v1.

One or more application specific operational Values, schedules and associated backup Retention Type created by the schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HypervBackupScheduleSettingsInfo


=item * RetentionType


=item * ScheduleId


=item * SimpleScheduleInfo


=item * StartRemoteBackupAfterLocalBackup


=item * VmwareBackupScheduleSettingsInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApplicationBackupScheduleInfo
   HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
     AllowSavedStateBackup =>  $some_value, # boolean
   },
   RetentionType => $some_value, # DpBackupRetentionType
   ScheduleId =>  $some_value, # integer
   SimpleScheduleInfo =>  { # MyTypes::SimpleScheduleInfo
     DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
       DayOfMonth => $some_value, # DayOfMonth
     },
     DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
       DayOfWeek => $some_value, # DayOfWeek
     },
     TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
       EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
         TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
           Hour => $some_value, # atomic
           Minute => $some_value, # atomic
         },
       },
       Frequency => $some_value, # atomic
       StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
         TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
           Hour => $some_value, # atomic
           Minute => $some_value, # atomic
         },
       },
     },
   },
   StartRemoteBackupAfterLocalBackup =>  $some_value, # boolean
   VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
     CreateVmwareSnapshot =>  $some_value, # boolean
     IncludeIndependentDisks =>  $some_value, # boolean
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

