package MyTypes::ApplicationInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationName_of :ATTR(:get<ApplicationName>);
my %ApplicationServerName_of :ATTR(:get<ApplicationServerName>);
my %ApplicationVersion_of :ATTR(:get<ApplicationVersion>);
my %CarryPrimaryBackupRetention_of :ATTR(:get<CarryPrimaryBackupRetention>);
my %IsApplicationManagingPrimaryBackupRetention_of :ATTR(:get<IsApplicationManagingPrimaryBackupRetention>);
my %IsApplicationResponsibleForPrimaryBackup_of :ATTR(:get<IsApplicationResponsibleForPrimaryBackup>);

__PACKAGE__->_factory(
    [ qw(        ApplicationName
        ApplicationServerName
        ApplicationVersion
        CarryPrimaryBackupRetention
        IsApplicationManagingPrimaryBackupRetention
        IsApplicationResponsibleForPrimaryBackup

    ) ],
    {
        'ApplicationName' => \%ApplicationName_of,
        'ApplicationServerName' => \%ApplicationServerName_of,
        'ApplicationVersion' => \%ApplicationVersion_of,
        'CarryPrimaryBackupRetention' => \%CarryPrimaryBackupRetention_of,
        'IsApplicationManagingPrimaryBackupRetention' => \%IsApplicationManagingPrimaryBackupRetention_of,
        'IsApplicationResponsibleForPrimaryBackup' => \%IsApplicationResponsibleForPrimaryBackup_of,
    },
    {
        'ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ApplicationVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CarryPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsApplicationManagingPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsApplicationResponsibleForPrimaryBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'ApplicationName' => 'ApplicationName',
        'ApplicationServerName' => 'ApplicationServerName',
        'ApplicationVersion' => 'ApplicationVersion',
        'CarryPrimaryBackupRetention' => 'CarryPrimaryBackupRetention',
        'IsApplicationManagingPrimaryBackupRetention' => 'IsApplicationManagingPrimaryBackupRetention',
        'IsApplicationResponsibleForPrimaryBackup' => 'IsApplicationResponsibleForPrimaryBackup',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ApplicationInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApplicationInfo from the namespace http://www.netapp.com/management/v1.

Information about an application.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationName


=item * ApplicationServerName


=item * ApplicationVersion


=item * CarryPrimaryBackupRetention


=item * IsApplicationManagingPrimaryBackupRetention


=item * IsApplicationResponsibleForPrimaryBackup




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApplicationInfo
   ApplicationName =>  $some_value, # string
   ApplicationServerName =>  $some_value, # string
   ApplicationVersion =>  $some_value, # string
   CarryPrimaryBackupRetention =>  $some_value, # boolean
   IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
   IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

