package MyTypes::ApplicationPolicyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationBackupOperationInfo_of :ATTR(:get<ApplicationBackupOperationInfo>);
my %ApplicationPolicyDescription_of :ATTR(:get<ApplicationPolicyDescription>);
my %ApplicationPolicyId_of :ATTR(:get<ApplicationPolicyId>);
my %ApplicationPolicyName_of :ATTR(:get<ApplicationPolicyName>);
my %ApplicationPolicySettingsInfo_of :ATTR(:get<ApplicationPolicySettingsInfo>);
my %ApplicationPolicyType_of :ATTR(:get<ApplicationPolicyType>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);

__PACKAGE__->_factory(
    [ qw(        ApplicationBackupOperationInfo
        ApplicationPolicyDescription
        ApplicationPolicyId
        ApplicationPolicyName
        ApplicationPolicySettingsInfo
        ApplicationPolicyType
        GroupNameOrId

    ) ],
    {
        'ApplicationBackupOperationInfo' => \%ApplicationBackupOperationInfo_of,
        'ApplicationPolicyDescription' => \%ApplicationPolicyDescription_of,
        'ApplicationPolicyId' => \%ApplicationPolicyId_of,
        'ApplicationPolicyName' => \%ApplicationPolicyName_of,
        'ApplicationPolicySettingsInfo' => \%ApplicationPolicySettingsInfo_of,
        'ApplicationPolicyType' => \%ApplicationPolicyType_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
    },
    {
        'ApplicationBackupOperationInfo' => 'MyTypes::ApplicationBackupOperationInfo',
        'ApplicationPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ApplicationPolicyId' => 'MyTypes::ObjId',
        'ApplicationPolicyName' => 'MyTypes::ObjName',
        'ApplicationPolicySettingsInfo' => 'MyTypes::ApplicationPolicySettingsInfo',
        'ApplicationPolicyType' => 'MyTypes::ApplicationPolicyType',
        'GroupNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'ApplicationBackupOperationInfo' => 'ApplicationBackupOperationInfo',
        'ApplicationPolicyDescription' => 'ApplicationPolicyDescription',
        'ApplicationPolicyId' => 'ApplicationPolicyId',
        'ApplicationPolicyName' => 'ApplicationPolicyName',
        'ApplicationPolicySettingsInfo' => 'ApplicationPolicySettingsInfo',
        'ApplicationPolicyType' => 'ApplicationPolicyType',
        'GroupNameOrId' => 'GroupNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ApplicationPolicyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApplicationPolicyInfo from the namespace http://www.netapp.com/management/v1.

Contains information about a single application Policy.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationBackupOperationInfo


=item * ApplicationPolicyDescription


=item * ApplicationPolicyId


=item * ApplicationPolicyName


=item * ApplicationPolicySettingsInfo


=item * ApplicationPolicyType


=item * GroupNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApplicationPolicyInfo
   ApplicationBackupOperationInfo =>  { # MyTypes::ApplicationBackupOperationInfo
     BackupSchedules =>  { # MyTypes::ArrayOfApplicationBackupScheduleInfo
       ApplicationBackupScheduleInfo =>  { # MyTypes::ApplicationBackupScheduleInfo
         HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
           AllowSavedStateBackup =>  $some_value, # boolean
         },
         RetentionType => $some_value, # DpBackupRetentionType
         ScheduleId =>  $some_value, # integer
         SimpleScheduleInfo =>  { # MyTypes::SimpleScheduleInfo
           DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
             DayOfMonth => $some_value, # DayOfMonth
           },
           DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
             DayOfWeek => $some_value, # DayOfWeek
           },
           TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
             EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
               TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                 Hour => $some_value, # atomic
                 Minute => $some_value, # atomic
               },
             },
             Frequency => $some_value, # atomic
             StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
               TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                 Hour => $some_value, # atomic
                 Minute => $some_value, # atomic
               },
             },
           },
         },
         StartRemoteBackupAfterLocalBackup =>  $some_value, # boolean
         VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
           CreateVmwareSnapshot =>  $some_value, # boolean
           IncludeIndependentDisks =>  $some_value, # boolean
         },
       },
     },
   },
   ApplicationPolicyDescription =>  $some_value, # string
   ApplicationPolicyId => $some_value, # ObjId
   ApplicationPolicyName => $some_value, # ObjName
   ApplicationPolicySettingsInfo =>  { # MyTypes::ApplicationPolicySettingsInfo
     BackupScript =>  $some_value, # string
     DailyRetentionCount => $some_value, # atomic
     DailyRetentionDuration => $some_value, # atomic
     HourlyRetentionCount => $some_value, # atomic
     HourlyRetentionDuration => $some_value, # atomic
     IsLagErrorEnabled =>  $some_value, # boolean
     IsLagWarningEnabled =>  $some_value, # boolean
     LagErrorThreshold => $some_value, # atomic
     LagWarningThreshold => $some_value, # atomic
     MonthlyRetentionCount => $some_value, # atomic
     MonthlyRetentionDuration => $some_value, # atomic
     WeeklyRetentionCount => $some_value, # atomic
     WeeklyRetentionDuration => $some_value, # atomic
   },
   ApplicationPolicyType => $some_value, # ApplicationPolicyType
   GroupNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

