package MyTypes::ApplicationPolicySettingsInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupScript_of :ATTR(:get<BackupScript>);
my %DailyRetentionCount_of :ATTR(:get<DailyRetentionCount>);
my %DailyRetentionDuration_of :ATTR(:get<DailyRetentionDuration>);
my %HourlyRetentionCount_of :ATTR(:get<HourlyRetentionCount>);
my %HourlyRetentionDuration_of :ATTR(:get<HourlyRetentionDuration>);
my %IsLagErrorEnabled_of :ATTR(:get<IsLagErrorEnabled>);
my %IsLagWarningEnabled_of :ATTR(:get<IsLagWarningEnabled>);
my %LagErrorThreshold_of :ATTR(:get<LagErrorThreshold>);
my %LagWarningThreshold_of :ATTR(:get<LagWarningThreshold>);
my %MonthlyRetentionCount_of :ATTR(:get<MonthlyRetentionCount>);
my %MonthlyRetentionDuration_of :ATTR(:get<MonthlyRetentionDuration>);
my %WeeklyRetentionCount_of :ATTR(:get<WeeklyRetentionCount>);
my %WeeklyRetentionDuration_of :ATTR(:get<WeeklyRetentionDuration>);

__PACKAGE__->_factory(
    [ qw(        BackupScript
        DailyRetentionCount
        DailyRetentionDuration
        HourlyRetentionCount
        HourlyRetentionDuration
        IsLagErrorEnabled
        IsLagWarningEnabled
        LagErrorThreshold
        LagWarningThreshold
        MonthlyRetentionCount
        MonthlyRetentionDuration
        WeeklyRetentionCount
        WeeklyRetentionDuration

    ) ],
    {
        'BackupScript' => \%BackupScript_of,
        'DailyRetentionCount' => \%DailyRetentionCount_of,
        'DailyRetentionDuration' => \%DailyRetentionDuration_of,
        'HourlyRetentionCount' => \%HourlyRetentionCount_of,
        'HourlyRetentionDuration' => \%HourlyRetentionDuration_of,
        'IsLagErrorEnabled' => \%IsLagErrorEnabled_of,
        'IsLagWarningEnabled' => \%IsLagWarningEnabled_of,
        'LagErrorThreshold' => \%LagErrorThreshold_of,
        'LagWarningThreshold' => \%LagWarningThreshold_of,
        'MonthlyRetentionCount' => \%MonthlyRetentionCount_of,
        'MonthlyRetentionDuration' => \%MonthlyRetentionDuration_of,
        'WeeklyRetentionCount' => \%WeeklyRetentionCount_of,
        'WeeklyRetentionDuration' => \%WeeklyRetentionDuration_of,
    },
    {
        'BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DailyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionCount',

        'DailyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionDuration',

        'HourlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionCount',

        'HourlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionDuration',
        'IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'LagErrorThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagErrorThreshold',

        'LagWarningThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagWarningThreshold',

        'MonthlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionCount',

        'MonthlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionDuration',

        'WeeklyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionCount',

        'WeeklyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionDuration',
    },
    {

        'BackupScript' => 'BackupScript',
        'DailyRetentionCount' => 'DailyRetentionCount',
        'DailyRetentionDuration' => 'DailyRetentionDuration',
        'HourlyRetentionCount' => 'HourlyRetentionCount',
        'HourlyRetentionDuration' => 'HourlyRetentionDuration',
        'IsLagErrorEnabled' => 'IsLagErrorEnabled',
        'IsLagWarningEnabled' => 'IsLagWarningEnabled',
        'LagErrorThreshold' => 'LagErrorThreshold',
        'LagWarningThreshold' => 'LagWarningThreshold',
        'MonthlyRetentionCount' => 'MonthlyRetentionCount',
        'MonthlyRetentionDuration' => 'MonthlyRetentionDuration',
        'WeeklyRetentionCount' => 'WeeklyRetentionCount',
        'WeeklyRetentionDuration' => 'WeeklyRetentionDuration',
    }
);

} # end BLOCK




package MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_LagErrorThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_LagWarningThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ApplicationPolicySettingsInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApplicationPolicySettingsInfo from the namespace http://www.netapp.com/management/v1.

Policy level settings




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupScript


=item * DailyRetentionCount


=item * DailyRetentionDuration


=item * HourlyRetentionCount


=item * HourlyRetentionDuration


=item * IsLagErrorEnabled


=item * IsLagWarningEnabled


=item * LagErrorThreshold


=item * LagWarningThreshold


=item * MonthlyRetentionCount


=item * MonthlyRetentionDuration


=item * WeeklyRetentionCount


=item * WeeklyRetentionDuration




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApplicationPolicySettingsInfo
   BackupScript =>  $some_value, # string
   DailyRetentionCount => $some_value, # atomic
   DailyRetentionDuration => $some_value, # atomic
   HourlyRetentionCount => $some_value, # atomic
   HourlyRetentionDuration => $some_value, # atomic
   IsLagErrorEnabled =>  $some_value, # boolean
   IsLagWarningEnabled =>  $some_value, # boolean
   LagErrorThreshold => $some_value, # atomic
   LagWarningThreshold => $some_value, # atomic
   MonthlyRetentionCount => $some_value, # atomic
   MonthlyRetentionDuration => $some_value, # atomic
   WeeklyRetentionCount => $some_value, # atomic
   WeeklyRetentionDuration => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

