package MyTypes::ApplicationResourceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationObjectType_of :ATTR(:get<ApplicationObjectType>);
my %ApplicationResourceNamespace_of :ATTR(:get<ApplicationResourceNamespace>);
my %Count_of :ATTR(:get<Count>);

__PACKAGE__->_factory(
    [ qw(        ApplicationObjectType
        ApplicationResourceNamespace
        Count

    ) ],
    {
        'ApplicationObjectType' => \%ApplicationObjectType_of,
        'ApplicationResourceNamespace' => \%ApplicationResourceNamespace_of,
        'Count' => \%Count_of,
    },
    {
        'ApplicationObjectType' => 'MyTypes::ApplicationObjectType',
        'ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',

        'Count' => 'MyTypes::ApplicationResourceInfo::_Count',
    },
    {

        'ApplicationObjectType' => 'ApplicationObjectType',
        'ApplicationResourceNamespace' => 'ApplicationResourceNamespace',
        'Count' => 'Count',
    }
);

} # end BLOCK




package MyTypes::ApplicationResourceInfo::_Count;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ApplicationResourceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ApplicationResourceInfo from the namespace http://www.netapp.com/management/v1.

Information about an application Resource's namespace, Type and Count.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationObjectType


=item * ApplicationResourceNamespace


=item * Count




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ApplicationResourceInfo
   ApplicationObjectType => $some_value, # ApplicationObjectType
   ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   Count => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

