package MyTypes::ArrayOfDatasetInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetInfo_of :ATTR(:get<DatasetInfo>);

__PACKAGE__->_factory(
    [ qw(        DatasetInfo

    ) ],
    {
        'DatasetInfo' => \%DatasetInfo_of,
    },
    {
        'DatasetInfo' => 'MyTypes::DatasetInfo',
    },
    {

        'DatasetInfo' => 'DatasetInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDatasetInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDatasetInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDatasetInfo
   DatasetInfo =>  { # MyTypes::DatasetInfo
     ApplicationInfo =>  { # MyTypes::ApplicationInfo
       ApplicationName =>  $some_value, # string
       ApplicationServerName =>  $some_value, # string
       ApplicationVersion =>  $some_value, # string
       CarryPrimaryBackupRetention =>  $some_value, # boolean
       IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
       IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
     },
     ApplicationPolicyId => $some_value, # ObjId
     ApplicationPolicyName => $some_value, # ObjName
     ApplicationResourceNamespaces =>  { # MyTypes::ArrayOfApplicationResourceNamespace
       ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
     },
     CanContainApplicationResources =>  $some_value, # boolean
     CanContainStorageResources =>  $some_value, # boolean
     DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
       IpAddress =>  $some_value, # string
       Netmask =>  $some_value, # string
     },
     DatasetContact => $some_value, # EmailAddressList
     DatasetDescription =>  $some_value, # string
     DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
       DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
         CifsDomain =>  $some_value, # string
         DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
           DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission => $some_value, # CifsPermission
           },
         },
       },
       DatasetExportProtocol => $some_value, # DatasetExportProtocol
       DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
         IgroupOsType =>  $some_value, # string
         LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
       },
       DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsProtocolVersion =>  $some_value, # string
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
     },
     DatasetId => $some_value, # ObjId
     DatasetMap =>  { # MyTypes::ArrayOfDatasetMapEntry
       DatasetMapEntry =>  { # MyTypes::DatasetMapEntry
         DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
           IpAddress =>  $some_value, # string
           Netmask =>  $some_value, # string
         },
         DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
           DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
             CifsDomain =>  $some_value, # string
             DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
               DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
                 CifsUsername =>  $some_value, # string
                 Permission => $some_value, # CifsPermission
               },
             },
           },
           DatasetExportProtocol => $some_value, # DatasetExportProtocol
           DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
             IgroupOsType =>  $some_value, # string
             LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
               LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
                 Hostname =>  $some_value, # string
                 InitiatorId => $some_value, # InitiatorId
               },
             },
           },
           DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
             AnonymousAccessUser => $some_value, # atomic
             DisableSetuid =>  $some_value, # boolean
             IsReadonlyForAllHosts =>  $some_value, # boolean
             IsReadwriteForAllHosts =>  $some_value, # boolean
             NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsProtocolVersion =>  $some_value, # string
             NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
               NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
             },
           },
         },
         DpNodeId => $some_value, # atomic
         DpNodeName => $some_value, # DpPolicyNodeName
         IsDrCapable =>  $some_value, # boolean
         IsVfilerCreatedForMigration =>  $some_value, # boolean
         ProvisioningPolicyId => $some_value, # ObjId
         ProvisioningPolicyName => $some_value, # ObjName
         ResourcepoolId => $some_value, # ObjId
         ResourcepoolName => $some_value, # ObjName
         Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
           DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
             ResourcepoolId => $some_value, # ObjId
             ResourcepoolName => $some_value, # ObjName
           },
         },
         StoragesetId => $some_value, # ObjId
         StoragesetName => $some_value, # ObjName
         StoragesetTimezone =>  $some_value, # string
         VfilerId => $some_value, # ObjId
         VfilerName => $some_value, # ObjFullName
       },
     },
     DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
       DfmMetadataField =>  { # MyTypes::DfmMetadataField
         FieldName =>  $some_value, # string
         FieldValue =>  $some_value, # string
       },
     },
     DatasetMigrationInfo =>  { # MyTypes::DatasetMigrationInfo
       Description =>  $some_value, # string
       DestinationFilerId => $some_value, # ObjId
       DestinationFilerName => $some_value, # ObjFullName
       DestinationVfilerId => $some_value, # ObjId
       DestinationVfilerName => $some_value, # ObjFullName
       MigrationStatus => $some_value, # MigrationStatus
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjFullName
       SourceFilerId => $some_value, # ObjId
       SourceFilerName => $some_value, # ObjFullName
       SourceVfilerId => $some_value, # ObjId
       SourceVfilerName => $some_value, # ObjFullName
     },
     DatasetName => $some_value, # ObjName
     DatasetOwner =>  $some_value, # string
     DatasetStatus =>  { # MyTypes::DatasetStatus
       ConformanceCheckResults =>  { # MyTypes::ArrayOfConformanceRunResult
         ConformanceRunResult =>  { # MyTypes::ConformanceRunResult
           ConformanceJobId => $some_value, # ObjId
           ConformanceRunAction =>  $some_value, # string
           ConformanceRunEffect =>  $some_value, # string
           ConformanceRunReason =>  $some_value, # string
           ConformanceRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
             ResultDetail =>  { # MyTypes::ResultDetail
               Action =>  $some_value, # string
               Effect =>  $some_value, # string
               Reason =>  $some_value, # string
               Severity => $some_value, # ObjStatus
               Suggestion =>  $some_value, # string
             },
           },
           ConformanceRunSeverity => $some_value, # ObjStatus
           ConformanceRunSuggestion =>  $some_value, # string
         },
       },
       ConformanceStatus =>  $some_value, # string
       DrProtectionStatus =>  $some_value, # string
       DrStatus => $some_value, # DrStatus
       DrStatusProblems =>  { # MyTypes::ArrayOfDrStatusProblem
         DrStatusProblem =>  { # MyTypes::DrStatusProblem
           DrStatusDescription =>  $some_value, # string
           DrStatusSeverity =>  $some_value, # string
         },
       },
       PerformanceStatus => $some_value, # ObjStatus
       ProtectionStatus =>  $some_value, # string
       ProtectionStatusProblems =>  { # MyTypes::ArrayOfProtectionStatusProblem
         ProtectionStatusProblem =>  { # MyTypes::ProtectionStatusProblem
           ProtectionStatusDescription =>  $some_value, # string
           ProtectionStatusJobDetails =>  { # MyTypes::ArrayOfProtectionStatusJobDetail
             ProtectionStatusJobDetail =>  { # MyTypes::ProtectionStatusJobDetail
               ProtectionStatusJobDescription =>  $some_value, # string
               ProtectionStatusJobId => $some_value, # atomic
               ProtectionStatusJobStatus => $some_value, # DpJobOverallStatus
               ProtectionStatusJobType => $some_value, # DpJobType
             },
           },
           ProtectionStatusName =>  $some_value, # string
         },
       },
       ResourceStatus => $some_value, # ObjStatus
       SpaceStatus => $some_value, # SpaceStatus
     },
     DrState => $some_value, # DrState
     DynamicReferenceCount => $some_value, # atomic
     HasProtection =>  $some_value, # boolean
     HasProtectionPolicy =>  $some_value, # boolean
     IsAllowCustomSettings =>  $some_value, # boolean
     IsApplicationData =>  $some_value, # boolean
     IsDpIgnored =>  $some_value, # boolean
     IsDpSuspended =>  $some_value, # boolean
     IsDrCapable =>  $some_value, # boolean
     IsEnableWriteGuaranteeChecks =>  $some_value, # boolean
     IsProtected =>  $some_value, # boolean
     IsSuspended =>  $some_value, # boolean
     IsVfilerCreatedForMigration =>  $some_value, # boolean
     MaximumLunsPerVolume =>  $some_value, # integer
     MaximumQtreesPerVolume =>  $some_value, # integer
     MemberCount => $some_value, # atomic
     OnlineMigration =>  $some_value, # boolean
     PrimaryVolumeNameFormat => $some_value, # PrimaryVolumeNameFormat
     ProtectionPolicyId => $some_value, # ObjId
     ProtectionPolicyName => $some_value, # ObjName
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjName
     RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
     ResourcepoolId => $some_value, # ObjId
     ResourcepoolName => $some_value, # ObjName
     Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
       DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
         ResourcepoolId => $some_value, # ObjId
         ResourcepoolName => $some_value, # ObjName
       },
     },
     SecondaryQtreeNameFormat => $some_value, # SecondaryQtreeNameFormat
     SecondaryVolumeNameFormat => $some_value, # SecondaryVolumeNameFormat
     SnapshotNameFormat => $some_value, # SnapshotNameFormat
     StorageServiceId => $some_value, # ObjId
     StorageServiceName => $some_value, # ObjName
     StoragesetId => $some_value, # ObjId
     StoragesetName => $some_value, # ObjName
     StoragesetTimezone =>  $some_value, # string
     VfilerId => $some_value, # ObjId
     VfilerName => $some_value, # ObjFullName
     VolumeQtreeNamePrefix =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

