package MyTypes::ArrayOfDatasetMapEntry;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetMapEntry_of :ATTR(:get<DatasetMapEntry>);

__PACKAGE__->_factory(
    [ qw(        DatasetMapEntry

    ) ],
    {
        'DatasetMapEntry' => \%DatasetMapEntry_of,
    },
    {
        'DatasetMapEntry' => 'MyTypes::DatasetMapEntry',
    },
    {

        'DatasetMapEntry' => 'DatasetMapEntry',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDatasetMapEntry

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDatasetMapEntry from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetMapEntry




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDatasetMapEntry
   DatasetMapEntry =>  { # MyTypes::DatasetMapEntry
     DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
       IpAddress =>  $some_value, # string
       Netmask =>  $some_value, # string
     },
     DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
       DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
         CifsDomain =>  $some_value, # string
         DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
           DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission => $some_value, # CifsPermission
           },
         },
       },
       DatasetExportProtocol => $some_value, # DatasetExportProtocol
       DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
         IgroupOsType =>  $some_value, # string
         LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
       },
       DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsProtocolVersion =>  $some_value, # string
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
     },
     DpNodeId => $some_value, # atomic
     DpNodeName => $some_value, # DpPolicyNodeName
     IsDrCapable =>  $some_value, # boolean
     IsVfilerCreatedForMigration =>  $some_value, # boolean
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjName
     ResourcepoolId => $some_value, # ObjId
     ResourcepoolName => $some_value, # ObjName
     Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
       DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
         ResourcepoolId => $some_value, # ObjId
         ResourcepoolName => $some_value, # ObjName
       },
     },
     StoragesetId => $some_value, # ObjId
     StoragesetName => $some_value, # ObjName
     StoragesetTimezone =>  $some_value, # string
     VfilerId => $some_value, # ObjId
     VfilerName => $some_value, # ObjFullName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

