package MyTypes::ArrayOfDatasetMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetMemberInfo_of :ATTR(:get<DatasetMemberInfo>);

__PACKAGE__->_factory(
    [ qw(        DatasetMemberInfo

    ) ],
    {
        'DatasetMemberInfo' => \%DatasetMemberInfo_of,
    },
    {
        'DatasetMemberInfo' => 'MyTypes::DatasetMemberInfo',
    },
    {

        'DatasetMemberInfo' => 'DatasetMemberInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDatasetMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDatasetMemberInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetMemberInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDatasetMemberInfo
   DatasetMemberInfo =>  { # MyTypes::DatasetMemberInfo
     CifsShareNames =>  { # MyTypes::ArrayOfCifsShareName
       CifsShareName => $some_value, # CifsShareName
     },
     CifsSharesInfo =>  { # MyTypes::ArrayOfCifsShareInfo
       CifsShareInfo =>  { # MyTypes::CifsShareInfo
         CifsShareName => $some_value, # CifsShareName
         CifsSharePermissions =>  { # MyTypes::ArrayOfCifsSharePermission
           CifsSharePermission =>  { # MyTypes::CifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission =>  $some_value, # string
           },
         },
       },
     },
     DpNodeName => $some_value, # DpPolicyNodeName
     IsAvailable =>  $some_value, # boolean
     IsDeleted =>  $some_value, # boolean
     LunIgroupsInfo =>  { # MyTypes::ArrayOfLunIgroupInfo
       LunIgroupInfo =>  { # MyTypes::LunIgroupInfo
         IgroupInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
         IgroupLunId => $some_value, # atomic
         IgroupName => $some_value, # ObjName
         IgroupOsType =>  $some_value, # string
         IgroupProtocol =>  $some_value, # string
       },
     },
     MemberId => $some_value, # ObjId
     MemberName => $some_value, # ObjName
     MemberPerfStatus => $some_value, # ObjStatus
     MemberStatus => $some_value, # ObjStatus
     MemberType =>  $some_value, # string
     NfsExportName =>  $some_value, # string
     NfsExportRules =>  { # MyTypes::NfsExportRules
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
     SpaceInfo =>  { # MyTypes::SpaceInfo
       AvailableSpace => $some_value, # atomic
       SpaceConditions =>  { # MyTypes::ArrayOfSpaceCondition
         SpaceCondition =>  { # MyTypes::SpaceCondition
           Condition =>  $some_value, # string
           Reason =>  $some_value, # string
           Severity =>  $some_value, # string
           Suggestion =>  $some_value, # string
         },
       },
       SpaceStatus => $some_value, # SpaceStatus
       TotalSpace => $some_value, # atomic
       UsedSpace => $some_value, # atomic
     },
     StoragesetId => $some_value, # ObjId
     StoragesetName => $some_value, # ObjName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

