package MyTypes::ArrayOfDatastore;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Datastore_of :ATTR(:get<Datastore>);

__PACKAGE__->_factory(
    [ qw(        Datastore

    ) ],
    {
        'Datastore' => \%Datastore_of,
    },
    {
        'Datastore' => 'MyTypes::Datastore',
    },
    {

        'Datastore' => 'Datastore',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDatastore

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDatastore from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Datastore




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDatastore
   Datastore =>  { # MyTypes::Datastore
     AllocatedCapacity =>  $some_value, # unsignedLong
     DatacenterReference =>  { # MyTypes::DatacenterReference
       DatacenterId => $some_value, # ObjId
       DatacenterName => $some_value, # ObjName
     },
     Datasets =>  { # MyTypes::ArrayOfDatasetReference
       DatasetReference =>  { # MyTypes::DatasetReference
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
       },
     },
     DatastoreId => $some_value, # ObjId
     DatastoreName => $some_value, # ObjName
     DatastoreOnOntap =>  $some_value, # boolean
     DatastoreType =>  $some_value, # string
     DeletedBy =>  $some_value, # string
     DeletedTimestamp => $some_value, # DpTimestamp
     HostServiceId => $some_value, # ObjId
     IsProtected =>  $some_value, # boolean
     NfsExportPath =>  $some_value, # string
     UsedCapacity =>  $some_value, # unsignedLong
     VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
       VirtualCenterId => $some_value, # ObjId
       VirtualCenterName => $some_value, # ObjName
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

