package MyTypes::ArrayOfDpBackupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpBackupInfo_of :ATTR(:get<DpBackupInfo>);

__PACKAGE__->_factory(
    [ qw(        DpBackupInfo

    ) ],
    {
        'DpBackupInfo' => \%DpBackupInfo_of,
    },
    {
        'DpBackupInfo' => 'MyTypes::DpBackupInfo',
    },
    {

        'DpBackupInfo' => 'DpBackupInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDpBackupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDpBackupInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpBackupInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDpBackupInfo
   DpBackupInfo =>  { # MyTypes::DpBackupInfo
     ApplicationBackupInfos =>  { # MyTypes::ArrayOfApplicationBackupInfo
       ApplicationBackupInfo =>  { # MyTypes::ApplicationBackupInfo
         ApplicationBackupProperties =>  { # MyTypes::ArrayOfPropertyInfo
           PropertyInfo =>  { # MyTypes::PropertyInfo
             PropertyName =>  $some_value, # string
             PropertyValue =>  $some_value, # string
           },
         },
         ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
         BackupGraphInfo =>  { # MyTypes::BackupGraphInfo
           GraphEdges =>  { # MyTypes::ArrayOfBackupGraphEdgeInfo
             BackupGraphEdgeInfo =>  { # MyTypes::BackupGraphEdgeInfo
               FromResourceId => $some_value, # ObjId
               ToResourceId => $some_value, # ObjId
             },
           },
           GraphResources =>  { # MyTypes::ArrayOfBackupGraphResourceInfo
             BackupGraphResourceInfo =>  { # MyTypes::BackupGraphResourceInfo
               ApplicationResourceProperties =>  { # MyTypes::ArrayOfPropertyInfo
                 PropertyInfo =>  { # MyTypes::PropertyInfo
                   PropertyName =>  $some_value, # string
                   PropertyValue =>  $some_value, # string
                 },
               },
               HostServiceObjectId => $some_value, # HostServiceUniqueId
               IsRestorable =>  $some_value, # boolean
               ObjectId => $some_value, # ObjId
               ObjectName => $some_value, # ObjName
               ObjectNameWhenBackedUp => $some_value, # ObjName
               ResourceType => $some_value, # ApplicationObjectType
               Snapshots =>  { # MyTypes::ArrayOfSnapshotMemberInfo
                 SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
                   PrimaryId => $some_value, # ObjId
                   PrimaryName => $some_value, # ObjName
                   PrimarySnapshotHostServiceId =>  $some_value, # string
                   PrimarySnapshotName =>  $some_value, # string
                   PrimarySnapshotUniqueId =>  $some_value, # string
                   SecondaryQtreeId => $some_value, # ObjId
                   SecondaryQtreeName =>  $some_value, # string
                   SecondaryQtreeNameOrId =>  $some_value, # string
                 },
               },
             },
           },
         },
         HostServiceBackupId => $some_value, # HostServiceUniqueId
         HostServiceId => $some_value, # ObjId
       },
     },
     BackupDescription =>  $some_value, # string
     BackupId => $some_value, # atomic
     BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
       DfmMetadata =>  { # MyTypes::DfmMetadata
         FieldName =>  $some_value, # string
         FieldValue =>  $some_value, # string
       },
     },
     BackupTransferInfos =>  { # MyTypes::ArrayOfDpBackupTransferInfo
       DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
         BackupTransferNeeded =>  $some_value, # boolean
         BackupTransferStatus =>  $some_value, # string
         ConnectionType =>  $some_value, # string
         DestinationBackupId => $some_value, # atomic
         DestinationNodeId => $some_value, # atomic
         DestinationNodeName =>  $some_value, # string
         DestinationStoragesetId => $some_value, # atomic
         JobId =>  $some_value, # integer
         SourceBackupId => $some_value, # atomic
         SourceNodeId => $some_value, # atomic
         SourceNodeName =>  $some_value, # string
         SourceStoragesetId => $some_value, # atomic
       },
     },
     BackupTransferStatus =>  $some_value, # string
     BackupVersion => $some_value, # DpTimestamp
     DatasetId => $some_value, # ObjId
     DatasetName => $some_value, # ObjName
     IsAddingMembers =>  $some_value, # boolean
     IsBackupDestinationNode =>  $some_value, # boolean
     IsForPropagation =>  $some_value, # boolean
     IsMirrorDestinationNode =>  $some_value, # boolean
     NodeId =>  $some_value, # integer
     NodeName =>  $some_value, # string
     RetentionDuration => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
     SupportsNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
     VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
       VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
         HostAddress => $some_value, # IpAddress
         HostFqdn =>  $some_value, # string
         HostId => $some_value, # ObjId
         IsAvailable =>  $some_value, # boolean
         SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
           SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
             PrimaryId => $some_value, # ObjId
             PrimaryName => $some_value, # ObjName
             PrimarySnapshotHostServiceId =>  $some_value, # string
             PrimarySnapshotName =>  $some_value, # string
             PrimarySnapshotUniqueId =>  $some_value, # string
             SecondaryQtreeId => $some_value, # ObjId
             SecondaryQtreeName =>  $some_value, # string
             SecondaryQtreeNameOrId =>  $some_value, # string
           },
         },
         SnapshotName =>  $some_value, # string
         SnapshotUniqueId =>  $some_value, # string
         VolumeId => $some_value, # ObjId
         VolumeName => $some_value, # ObjName
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

