package MyTypes::ArrayOfDpBackupVersionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpBackupVersionInfo_of :ATTR(:get<DpBackupVersionInfo>);

__PACKAGE__->_factory(
    [ qw(        DpBackupVersionInfo

    ) ],
    {
        'DpBackupVersionInfo' => \%DpBackupVersionInfo_of,
    },
    {
        'DpBackupVersionInfo' => 'MyTypes::DpBackupVersionInfo',
    },
    {

        'DpBackupVersionInfo' => 'DpBackupVersionInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDpBackupVersionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDpBackupVersionInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpBackupVersionInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDpBackupVersionInfo
   DpBackupVersionInfo =>  { # MyTypes::DpBackupVersionInfo
     BackupDescription =>  $some_value, # string
     BackupIdInfos =>  { # MyTypes::ArrayOfDpBackupIdInfo
       DpBackupIdInfo =>  { # MyTypes::DpBackupIdInfo
         BackupId => $some_value, # atomic
         BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
           DfmMetadata =>  { # MyTypes::DfmMetadata
             FieldName =>  $some_value, # string
             FieldValue =>  $some_value, # string
           },
         },
         JobId =>  $some_value, # integer
         NodeId => $some_value, # atomic
         NodeName =>  $some_value, # string
       },
     },
     BackupTransferInfos =>  { # MyTypes::ArrayOfDpBackupTransferInfo
       DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
         BackupTransferNeeded =>  $some_value, # boolean
         BackupTransferStatus =>  $some_value, # string
         ConnectionType =>  $some_value, # string
         DestinationBackupId => $some_value, # atomic
         DestinationNodeId => $some_value, # atomic
         DestinationNodeName =>  $some_value, # string
         DestinationStoragesetId => $some_value, # atomic
         JobId =>  $some_value, # integer
         SourceBackupId => $some_value, # atomic
         SourceNodeId => $some_value, # atomic
         SourceNodeName =>  $some_value, # string
         SourceStoragesetId => $some_value, # atomic
       },
     },
     BackupVersion => $some_value, # DpTimestamp
     IsFullyPropagated =>  $some_value, # boolean
     RetentionType => $some_value, # DpBackupRetentionType
     VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
       VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
         HostAddress => $some_value, # IpAddress
         HostFqdn =>  $some_value, # string
         HostId => $some_value, # ObjId
         IsAvailable =>  $some_value, # boolean
         SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
           SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
             PrimaryId => $some_value, # ObjId
             PrimaryName => $some_value, # ObjName
             PrimarySnapshotHostServiceId =>  $some_value, # string
             PrimarySnapshotName =>  $some_value, # string
             PrimarySnapshotUniqueId =>  $some_value, # string
             SecondaryQtreeId => $some_value, # ObjId
             SecondaryQtreeName =>  $some_value, # string
             SecondaryQtreeNameOrId =>  $some_value, # string
           },
         },
         SnapshotName =>  $some_value, # string
         SnapshotUniqueId =>  $some_value, # string
         VolumeId => $some_value, # ObjId
         VolumeName => $some_value, # ObjName
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

