package MyTypes::ArrayOfDpJobInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpJobInfo_of :ATTR(:get<DpJobInfo>);

__PACKAGE__->_factory(
    [ qw(        DpJobInfo

    ) ],
    {
        'DpJobInfo' => \%DpJobInfo_of,
    },
    {
        'DpJobInfo' => 'MyTypes::DpJobInfo',
    },
    {

        'DpJobInfo' => 'DpJobInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDpJobInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDpJobInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpJobInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDpJobInfo
   DpJobInfo =>  { # MyTypes::DpJobInfo
     AbortRequestedTimestamp => $some_value, # DpTimestamp
     BytesTransferred => $some_value, # atomic
     CompletedTimestamp => $some_value, # DpTimestamp
     DatasetId => $some_value, # atomic
     DatasetName =>  $some_value, # string
     DestinationNodeId => $some_value, # atomic
     DestinationNodeName =>  $some_value, # string
     JobContextApplicationResourceNamespaces =>  { # MyTypes::ArrayOfApplicationResourceNamespace
       ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
     },
     JobContextObjId => $some_value, # ObjId
     JobContextObjName => $some_value, # ObjFullName
     JobContextObjType =>  $some_value, # string
     JobDescription =>  $some_value, # string
     JobId => $some_value, # atomic
     JobOverallStatus => $some_value, # DpJobOverallStatus
     JobProgress => $some_value, # DpJobProgress
     JobState => $some_value, # DpJobState
     JobType => $some_value, # DpJobType
     ObjectId => $some_value, # ObjId
     ObjectName => $some_value, # ObjFullName
     ObjectType =>  $some_value, # string
     PolicyId => $some_value, # atomic
     PolicyName =>  $some_value, # string
     ProvisionRequestInfo =>  { # MyTypes::ProvisionRequestInfo
       DedupeMemberRequestInfo =>  { # MyTypes::DedupeMemberRequestInfo
         FullVolumeDedupe =>  $some_value, # boolean
         VolumeId => $some_value, # ObjId
         VolumeName => $some_value, # ObjName
       },
       DeleteSnapshotsRequestInfo =>  { # MyTypes::DeleteSnapshotsRequestInfo
         Snapshots =>  { # MyTypes::ArrayOfSnapshot
           Snapshot =>  { # MyTypes::Snapshot
             SnapshotName =>  $some_value, # string
             UniqueId =>  $some_value, # string
           },
         },
         VolumeId => $some_value, # ObjId
         VolumeName => $some_value, # ObjName
       },
       DestroyMemberRequestInfo =>  { # MyTypes::DestroyMemberRequestInfo
         MemberId => $some_value, # ObjId
         MemberName => $some_value, # ObjFullName
         MemberType =>  $some_value, # string
       },
       ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
         Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
           ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
             CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
             CommentValue => $some_value, # CommentValue
           },
         },
         CreateNewVfiler =>  $some_value, # boolean
         DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
           DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
             CifsDomain =>  $some_value, # string
             DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
               DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
                 CifsUsername =>  $some_value, # string
                 Permission => $some_value, # CifsPermission
               },
             },
           },
           DatasetExportProtocol => $some_value, # DatasetExportProtocol
           DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
             IgroupOsType =>  $some_value, # string
             LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
               LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
                 Hostname =>  $some_value, # string
                 InitiatorId => $some_value, # InitiatorId
               },
             },
           },
           DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
             AnonymousAccessUser => $some_value, # atomic
             DisableSetuid =>  $some_value, # boolean
             IsReadonlyForAllHosts =>  $some_value, # boolean
             IsReadwriteForAllHosts =>  $some_value, # boolean
             NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
               NfsExportHost =>  { # MyTypes::NfsExportHost
                 Hostname =>  $some_value, # string
                 IsAnException =>  $some_value, # boolean
               },
             },
             NfsProtocolVersion =>  $some_value, # string
             NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
               NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
             },
           },
         },
         Description =>  $some_value, # string
         InitialSnapshotSpace => $some_value, # atomic
         MaximumDataSize => $some_value, # atomic
         MaximumSnapshotSpace => $some_value, # atomic
         Name =>  $some_value, # string
         OnlineMigration =>  $some_value, # boolean
         ProvisioningPolicyId => $some_value, # ObjId
         ProvisioningPolicyName => $some_value, # ObjFullName
         ResourceNameOrId => $some_value, # ObjNameOrId
         Size => $some_value, # atomic
         VfilerNameOrId => $some_value, # ObjNameOrId
       },
       ResizeMemberRequestInfo =>  { # MyTypes::ResizeMemberRequestInfo
         MaximumCapacity => $some_value, # atomic
         MemberId => $some_value, # ObjId
         MemberName => $some_value, # ObjName
         NewSize => $some_value, # atomic
         SnapReserve => $some_value, # atomic
       },
       UndedupeMemberRequestInfo =>  { # MyTypes::UndedupeMemberRequestInfo
         VolumeId => $some_value, # ObjId
         VolumeName => $some_value, # ObjName
       },
     },
     SourceNodeId => $some_value, # atomic
     SourceNodeName =>  $some_value, # string
     StartedTimestamp => $some_value, # DpTimestamp
     SubmittedBy =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

