package MyTypes::ArrayOfDpJobProgressEventInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpJobProgressEventInfo_of :ATTR(:get<DpJobProgressEventInfo>);

__PACKAGE__->_factory(
    [ qw(        DpJobProgressEventInfo

    ) ],
    {
        'DpJobProgressEventInfo' => \%DpJobProgressEventInfo_of,
    },
    {
        'DpJobProgressEventInfo' => 'MyTypes::DpJobProgressEventInfo',
    },
    {

        'DpJobProgressEventInfo' => 'DpJobProgressEventInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDpJobProgressEventInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDpJobProgressEventInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpJobProgressEventInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDpJobProgressEventInfo
   DpJobProgressEventInfo =>  { # MyTypes::DpJobProgressEventInfo
     DpProgressBackupInfo =>  { # MyTypes::DpProgressBackupInfo
       BackupId => $some_value, # atomic
       BackupVersion => $some_value, # DpTimestamp
       Retention => $some_value, # DpBackupRetentionType
     },
     DpProgressFailoverInfo =>  { # MyTypes::DpProgressFailoverInfo
       DestinationPath =>  $some_value, # string
       EnvironmentVariableList =>  { # MyTypes::ArrayOfEnvironmentVariableInfo
         EnvironmentVariableInfo =>  { # MyTypes::EnvironmentVariableInfo
           Name =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       RelationshipId => $some_value, # ObjId
       ScriptExitStatus =>  $some_value, # int
       ScriptPath =>  $some_value, # string
       ScriptRunAs =>  $some_value, # string
       ScriptSummary =>  $some_value, # string
     },
     DpProgressJobAbortInfo =>  { # MyTypes::DpProgressJobAbortInfo
       AbortedBy =>  $some_value, # string
     },
     DpProgressRelationshipInfo =>  { # MyTypes::DpProgressRelationshipInfo
       BytesTransferred => $some_value, # atomic
       DestinationVolumeOrQtreeId => $some_value, # atomic
       DestinationVolumeOrQtreeName =>  $some_value, # string
       RelationshipType =>  $some_value, # string
       SourceVolumeOrQtreeId => $some_value, # atomic
       SourceVolumeOrQtreeName =>  $some_value, # string
     },
     DpProgressRestoreInfo =>  { # MyTypes::DpProgressRestoreInfo
       BackupId => $some_value, # atomic
       BackupVersion => $some_value, # DpTimestamp
       BytesTransferred => $some_value, # atomic
       DestinationPath =>  $some_value, # string
       MemberId => $some_value, # atomic
       MemberName =>  $some_value, # string
       Path =>  $some_value, # string
     },
     DpProgressSnapmirrorInfo =>  { # MyTypes::DpProgressSnapmirrorInfo
       BytesTransferred => $some_value, # atomic
       DestinationVolumeOrQtreeId => $some_value, # atomic
       DestinationVolumeOrQtreeName =>  $some_value, # string
       SourceVolumeOrQtreeId => $some_value, # atomic
       SourceVolumeOrQtreeName =>  $some_value, # string
     },
     DpProgressSnapshotInfo =>  { # MyTypes::DpProgressSnapshotInfo
       SnapshotName =>  $some_value, # string
       VolumeId => $some_value, # atomic
       VolumeName =>  $some_value, # string
     },
     DpProgressSnapvaultInfo =>  { # MyTypes::DpProgressSnapvaultInfo
       BytesTransferred => $some_value, # atomic
       DestinationQtreeId => $some_value, # atomic
       DestinationQtreeName =>  $some_value, # string
       SourceQtreeId => $some_value, # atomic
       SourceQtreeName =>  $some_value, # string
     },
     ErrorMessage =>  $some_value, # string
     EventId => $some_value, # atomic
     EventMessage =>  $some_value, # string
     EventStatus => $some_value, # ObjStatus
     EventTimestamp => $some_value, # DpTimestamp
     EventType =>  $some_value, # string
     JobId => $some_value, # atomic
     JobType => $some_value, # DpJobType
     ProgressAggregateInfo =>  { # MyTypes::ProgressAggregateInfo
       AggregateId => $some_value, # ObjId
       AggregateName => $some_value, # ObjFullName
     },
     ProgressCifsShareInfo =>  { # MyTypes::ProgressCifsShareInfo
       CifsAclList =>  { # MyTypes::ArrayOfCifsAcl
         CifsAcl =>  { # MyTypes::CifsAcl
           AccessRights =>  $some_value, # string
           UserName =>  $some_value, # string
         },
       },
       CifsShareName =>  $some_value, # string
       VolOrQtreeId => $some_value, # ObjId
       VolOrQtreeName => $some_value, # ObjFullName
     },
     ProgressHostServiceInfo =>  { # MyTypes::ProgressHostServiceInfo
       HostServiceId => $some_value, # ObjId
       HostServiceName => $some_value, # ObjFullName
       OperationId => $some_value, # HostServiceUniqueId
     },
     ProgressIgroupConfigInfo =>  { # MyTypes::ProgressIgroupConfigInfo
       IgroupId => $some_value, # ObjId
       IgroupName => $some_value, # ObjFullName
       Initiators =>  $some_value, # string
     },
     ProgressIgroupInfo =>  { # MyTypes::ProgressIgroupInfo
       IgroupId => $some_value, # ObjId
       IgroupName => $some_value, # ObjFullName
     },
     ProgressLunInfo =>  { # MyTypes::ProgressLunInfo
       LunName => $some_value, # ObjFullName
       LunPathId => $some_value, # ObjId
     },
     ProgressLunMapInfo =>  { # MyTypes::ProgressLunMapInfo
       IgroupId => $some_value, # ObjId
       IgroupName => $some_value, # ObjFullName
       LunName => $some_value, # ObjFullName
       LunPathId => $some_value, # ObjId
     },
     ProgressNfsexportInfo =>  { # MyTypes::ProgressNfsexportInfo
       Path =>  $some_value, # string
       QtreeId => $some_value, # ObjId
       QtreeName => $some_value, # ObjFullName
     },
     ProgressQtreeInfo =>  { # MyTypes::ProgressQtreeInfo
       QtreeId => $some_value, # ObjId
       QtreeName => $some_value, # ObjFullName
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjFullName
     },
     ProgressQuotaInfo =>  { # MyTypes::ProgressQuotaInfo
       DefaultGroupQuota => $some_value, # atomic
       DefaultUserQuota => $some_value, # atomic
       QtreeId => $some_value, # ObjId
       QtreeName => $some_value, # ObjFullName
       TreeQuota => $some_value, # atomic
     },
     ProgressResourcePoolInfo =>  { # MyTypes::ProgressResourcePoolInfo
       ResourcePoolId => $some_value, # ObjId
       ResourcePoolMembers =>  { # MyTypes::ArrayOfResourcePoolMember
         ResourcePoolMember =>  { # MyTypes::ResourcePoolMember
           ResourcePoolMemberId => $some_value, # ObjId
           ResourcePoolMemberName => $some_value, # ObjFullName
         },
       },
       ResourcePoolName => $some_value, # ObjFullName
     },
     ProgressScriptRunInfo =>  { # MyTypes::ProgressScriptRunInfo
       ScriptName =>  $some_value, # string
     },
     ProgressStorageServiceInfo =>  { # MyTypes::ProgressStorageServiceInfo
       StorageServiceDescription =>  $some_value, # string
       StorageServiceId => $some_value, # ObjId
       StorageServiceName => $some_value, # ObjFullName
     },
     ProgressStorageSystemInfo =>  { # MyTypes::ProgressStorageSystemInfo
       StorageSystemId => $some_value, # ObjId
       StorageSystemName => $some_value, # ObjFullName
     },
     ProgressVfilerInfo =>  { # MyTypes::ProgressVfilerInfo
       FilerId => $some_value, # ObjId
       FilerName => $some_value, # ObjFullName
       Ipaddress =>  $some_value, # string
       Ipspace =>  $some_value, # string
       VfilerId => $some_value, # ObjId
       VfilerName => $some_value, # ObjFullName
     },
     ProgressVfilerStorageInfo =>  { # MyTypes::ProgressVfilerStorageInfo
       VfilerId => $some_value, # ObjId
       VfilerName => $some_value, # ObjFullName
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjFullName
     },
     ProgressVolumeDedupeInfo =>  { # MyTypes::ProgressVolumeDedupeInfo
       DedupeProgress =>  $some_value, # string
       DedupeSchedule =>  $some_value, # string
       DedupeStatus =>  $some_value, # string
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjFullName
     },
     ProgressVolumeInfo =>  { # MyTypes::ProgressVolumeInfo
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjFullName
     },
     ProgressVolumeOptionInfo =>  { # MyTypes::ProgressVolumeOptionInfo
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjFullName
       VolumeOptions =>  { # MyTypes::ArrayOfVolumeOption
         VolumeOption =>  { # MyTypes::VolumeOption
           OptionName =>  $some_value, # string
           OptionValue =>  $some_value, # string
         },
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

