package MyTypes::ArrayOfDynamicData;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DynamicData_of :ATTR(:get<DynamicData>);

__PACKAGE__->_factory(
    [ qw(        DynamicData

    ) ],
    {
        'DynamicData' => \%DynamicData_of,
    },
    {
        'DynamicData' => 'MyTypes::DynamicData',
    },
    {

        'DynamicData' => 'DynamicData',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfDynamicData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfDynamicData from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DynamicData




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfDynamicData
   DynamicData =>  { # MyTypes::DynamicData
     Hostname => $some_value, # ObjName
     InstanceName =>  { # MyTypes::WrapperOfPerfInstance
       PerfInstance =>  { # MyTypes::PerfInstance
         InstanceName =>  $some_value, # string
       },
     },
     ObjId => $some_value, # ObjId
     Value =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

