package MyTypes::ArrayOfEventInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventInfo_of :ATTR(:get<EventInfo>);

__PACKAGE__->_factory(
    [ qw(        EventInfo

    ) ],
    {
        'EventInfo' => \%EventInfo_of,
    },
    {
        'EventInfo' => 'MyTypes::EventInfo',
    },
    {

        'EventInfo' => 'EventInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfEventInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfEventInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfEventInfo
   EventInfo =>  { # MyTypes::EventInfo
     EventAbout =>  $some_value, # string
     EventAcknowledged =>  $some_value, # integer
     EventAcknowledgedUser =>  $some_value, # string
     EventArguments =>  { # MyTypes::ArrayOfKeyValuePair
       KeyValuePair =>  { # MyTypes::KeyValuePair
         Key =>  $some_value, # string
         Value =>  $some_value, # string
       },
     },
     EventCondition =>  $some_value, # string
     EventDeleted =>  $some_value, # integer
     EventDeletedUser =>  $some_value, # string
     EventId => $some_value, # atomic
     EventName =>  $some_value, # string
     EventOriginatingId => $some_value, # atomic
     EventSeverity => $some_value, # ObjStatus
     EventSourceId => $some_value, # atomic
     EventSourceName =>  $some_value, # string
     EventSourceNodeName =>  $some_value, # string
     EventSourceType =>  $some_value, # string
     EventTime =>  $some_value, # integer
     EventType =>  $some_value, # string
     IsDeleted =>  $some_value, # boolean
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

