package MyTypes::ArrayOfPerfView;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PerfView_of :ATTR(:get<PerfView>);

__PACKAGE__->_factory(
    [ qw(        PerfView

    ) ],
    {
        'PerfView' => \%PerfView_of,
    },
    {
        'PerfView' => 'MyTypes::PerfView',
    },
    {

        'PerfView' => 'PerfView',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfPerfView

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfPerfView from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PerfView




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfPerfView
   PerfView =>  { # MyTypes::PerfView
     ApplianceNameOrId =>  $some_value, # string
     AreEventsShown =>  $some_value, # boolean
     AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
       PerfAssocObjType => $some_value, # PerfAssocObjType
     },
     Charts =>  { # MyTypes::ArrayOfPerfChart
       PerfChart =>  { # MyTypes::PerfChart
         ChartName =>  $some_value, # string
         DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
           PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
             Color =>  $some_value, # string
             DataSource =>  { # MyTypes::WrapperOfPerfDataSource
               PerfDataSource =>  { # MyTypes::PerfDataSource
                 ApplianceNameOrId =>  $some_value, # string
                 CounterName =>  $some_value, # string
                 GroupNameOrId =>  $some_value, # string
                 InstanceName =>  $some_value, # string
                 LabelNames =>  $some_value, # string
                 ObjectFullName => $some_value, # ObjFullName
                 ObjectName =>  $some_value, # string
                 ObjectNameOrId => $some_value, # ObjNameOrId
                 ObjectType =>  $some_value, # string
               },
             },
             MaximumInstances =>  $some_value, # integer
             SelectAllInstances =>  $some_value, # boolean
             SortOrder =>  $some_value, # string
             TimeInterval =>  $some_value, # integer
           },
         },
         Lines =>  { # MyTypes::ArrayOfPerfLine
           PerfLine =>  { # MyTypes::PerfLine
             Color =>  $some_value, # string
             DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
               PerfDataGroup =>  { # MyTypes::PerfDataGroup
                 DataGroupMethod =>  $some_value, # string
                 DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                   PerfDataSource =>  { # MyTypes::PerfDataSource
                     ApplianceNameOrId =>  $some_value, # string
                     CounterName =>  $some_value, # string
                     GroupNameOrId =>  $some_value, # string
                     InstanceName =>  $some_value, # string
                     LabelNames =>  $some_value, # string
                     ObjectFullName => $some_value, # ObjFullName
                     ObjectName =>  $some_value, # string
                     ObjectNameOrId => $some_value, # ObjNameOrId
                     ObjectType =>  $some_value, # string
                   },
                 },
               },
             },
             LineName =>  $some_value, # string
             Type =>  $some_value, # string
           },
         },
         MaximumY =>  $some_value, # integer
         Type =>  $some_value, # string
       },
     },
     CounterGroupName =>  $some_value, # string
     GroupNameOrId =>  $some_value, # string
     IsDefault =>  $some_value, # boolean
     IsStopped =>  $some_value, # boolean
     SampleBuffer =>  $some_value, # integer
     SampleRate =>  $some_value, # integer
     ViewName =>  $some_value, # string
     ViewType => $some_value, # ViewType
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

