package MyTypes::ArrayOfPlugin;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Plugin_of :ATTR(:get<Plugin>);

__PACKAGE__->_factory(
    [ qw(        Plugin

    ) ],
    {
        'Plugin' => \%Plugin_of,
    },
    {
        'Plugin' => 'MyTypes::Plugin',
    },
    {

        'Plugin' => 'Plugin',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfPlugin

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfPlugin from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Plugin




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfPlugin
   Plugin =>  { # MyTypes::Plugin
     PluginType =>  $some_value, # string
     ProductVersion =>  $some_value, # string
     SpecialBuild =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

