package MyTypes::ArrayOfSnapshotInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SnapshotInfo_of :ATTR(:get<SnapshotInfo>);

__PACKAGE__->_factory(
    [ qw(        SnapshotInfo

    ) ],
    {
        'SnapshotInfo' => \%SnapshotInfo_of,
    },
    {
        'SnapshotInfo' => 'MyTypes::SnapshotInfo',
    },
    {

        'SnapshotInfo' => 'SnapshotInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfSnapshotInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfSnapshotInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SnapshotInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfSnapshotInfo
   SnapshotInfo =>  { # MyTypes::SnapshotInfo
     Backups =>  { # MyTypes::ArrayOfBackupInfo
       BackupInfo =>  { # MyTypes::BackupInfo
         BackupId => $some_value, # atomic
         BackupVersion => $some_value, # DpTimestamp
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
         DpBackupExpiryTimestamp => $some_value, # DpTimestamp
         DpNodeId =>  $some_value, # integer
         DpNodeName =>  $some_value, # string
         IsApplicationBackup =>  $some_value, # boolean
       },
     },
     CreationTimestamp => $some_value, # DpTimestamp
     CumulativePercentageOfTotalBlocks => $some_value, # atomic
     Dependencies =>  { # MyTypes::ArrayOfSnapshotDependency
       SnapshotDependency => $some_value, # SnapshotDependency
     },
     IsBusy =>  $some_value, # boolean
     IsPartOfBackupVersion =>  $some_value, # boolean
     PercentageOfTotalBlocks => $some_value, # atomic
     SnapshotId => $some_value, # atomic
     SnapshotName =>  $some_value, # string
     UniqueId =>  $some_value, # string
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

