package MyTypes::ArrayOfVirtualMachine;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VirtualMachine_of :ATTR(:get<VirtualMachine>);

__PACKAGE__->_factory(
    [ qw(        VirtualMachine

    ) ],
    {
        'VirtualMachine' => \%VirtualMachine_of,
    },
    {
        'VirtualMachine' => 'MyTypes::VirtualMachine',
    },
    {

        'VirtualMachine' => 'VirtualMachine',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfVirtualMachine

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfVirtualMachine from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VirtualMachine




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfVirtualMachine
   VirtualMachine =>  { # MyTypes::VirtualMachine
     DatacenterReference =>  { # MyTypes::DatacenterReference
       DatacenterId => $some_value, # ObjId
       DatacenterName => $some_value, # ObjName
     },
     Datasets =>  { # MyTypes::ArrayOfDatasetReference
       DatasetReference =>  { # MyTypes::DatasetReference
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
       },
     },
     DeletedBy =>  $some_value, # string
     DeletedTimestamp => $some_value, # DpTimestamp
     DnsName =>  $some_value, # string
     GuestOsType =>  $some_value, # string
     HostServiceId => $some_value, # ObjId
     HypervisorReference =>  { # MyTypes::HypervisorReference
       HypervisorId => $some_value, # ObjId
       HypervisorName => $some_value, # ObjName
     },
     IpAddressList =>  { # MyTypes::ArrayOfIpAddress
       IpAddress => $some_value, # IpAddress
     },
     IsProtected =>  $some_value, # boolean
     Status =>  $some_value, # string
     VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
       VirtualCenterId => $some_value, # ObjId
       VirtualCenterName => $some_value, # ObjName
     },
     VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
     VirtualMachineId => $some_value, # ObjId
     VirtualMachineName => $some_value, # ObjName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

