package MyTypes::ArrayOfVolumeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VolumeInfo_of :ATTR(:get<VolumeInfo>);

__PACKAGE__->_factory(
    [ qw(        VolumeInfo

    ) ],
    {
        'VolumeInfo' => \%VolumeInfo_of,
    },
    {
        'VolumeInfo' => 'MyTypes::VolumeInfo',
    },
    {

        'VolumeInfo' => 'VolumeInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ArrayOfVolumeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ArrayOfVolumeInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VolumeInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ArrayOfVolumeInfo
   VolumeInfo =>  { # MyTypes::VolumeInfo
     AggregateId =>  $some_value, # integer
     AggregateName =>  $some_value, # string
     BlockType => $some_value, # FileSystemBlockType
     DatasetId => $some_value, # atomic
     DatasetNodes =>  { # MyTypes::ArrayOfDatasetNodeInfo
       DatasetNodeInfo =>  { # MyTypes::DatasetNodeInfo
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
         DpNodeId => $some_value, # atomic
         DpNodeName => $some_value, # DpPolicyNodeName
         IsDpNodeEffectivePrimary =>  $some_value, # boolean
       },
     },
     Datasets =>  { # MyTypes::ArrayOfDatasetReference
       DatasetReference =>  { # MyTypes::DatasetReference
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
       },
     },
     HostId =>  $some_value, # integer
     HostName =>  $some_value, # string
     IsAvailable =>  $some_value, # boolean
     IsCapableOfMigration =>  $some_value, # boolean
     IsDpIgnored =>  $some_value, # boolean
     IsInDataset =>  $some_value, # boolean
     IsReadonlyVolume =>  $some_value, # boolean
     IsSnapmirrorPrimaryCapable =>  $some_value, # boolean
     IsSnapmirrorPrimaryVolume =>  $some_value, # boolean
     IsSnapmirrorSecondaryCapable =>  $some_value, # boolean
     IsSnapmirrorSecondaryVolume =>  $some_value, # boolean
     IsSnapvaultPrimaryCapable =>  $some_value, # boolean
     IsSnapvaultPrimaryVolume =>  $some_value, # boolean
     IsSnapvaultSecondaryCapable =>  $some_value, # boolean
     IsSnapvaultSecondaryVolume =>  $some_value, # boolean
     IsVsmSecondaryVolume =>  $some_value, # boolean
     JunctionPath =>  $some_value, # string
     JunctionPathActive =>  $some_value, # boolean
     MigrationIncompatibilityReasons =>  { # MyTypes::ArrayOfMigrationIncompatibilityReason
       MigrationIncompatibilityReason => $some_value, # MigrationIncompatibilityReason
     },
     NextScheduledBackupTime => $some_value, # DpTimestamp
     SnapshotVolumeId => $some_value, # ObjId
     SnapshotVolumeName => $some_value, # ObjFullName
     SnapvaultLagWarningThreshold =>  $some_value, # integer
     SnapvaultSecondaryScheduleName =>  $some_value, # string
     SpaceGuarantee =>  $some_value, # string
     VolumeDedupeInfo =>  { # MyTypes::VolumeDedupeInfo
       DedupeProgress =>  $some_value, # string
       DedupeSpaceSavings => $some_value, # atomic
       DedupeSpaceSavingsPercentage => $some_value, # atomic
       DedupeStatus =>  $some_value, # string
       IsDedupeEnabled =>  $some_value, # boolean
       LastDedupeBeginTimestamp => $some_value, # Timestamp
       LastDedupeEndTimestamp => $some_value, # Timestamp
       LastDedupeError =>  $some_value, # string
       LastDedupeScannedSize => $some_value, # atomic
     },
     VolumeFullThreshold => $some_value, # atomic
     VolumeId =>  $some_value, # integer
     VolumeName =>  $some_value, # string
     VolumeNearlyFullThreshold => $some_value, # atomic
     VolumePerfStatus => $some_value, # ObjStatus
     VolumeQtree =>  { # MyTypes::VolumeQtree
       ProtectedDataSize =>  $some_value, # integer
       ProtectedQtreeCount =>  $some_value, # integer
       TotalQtreeCount =>  $some_value, # integer
       UnprotectedDataSize =>  $some_value, # integer
       UnprotectedQtreeCount =>  $some_value, # integer
     },
     VolumeSize =>  { # MyTypes::VolumeSize
       ActualVolumeSize =>  $some_value, # integer
       AfsAvail => $some_value, # atomic
       AfsData => $some_value, # atomic
       AfsTotal => $some_value, # atomic
       AfsUsed => $some_value, # atomic
       AfsUsedPerDay => $some_value, # atomic
       HoleReserve => $some_value, # atomic
       IsAutosizeEnabled =>  $some_value, # boolean
       MaximumSize => $some_value, # atomic
       OverwriteReserveAvail => $some_value, # atomic
       OverwriteReserveTotal => $some_value, # atomic
       OverwriteReserveUsed => $some_value, # atomic
       SnapshotReserveAvail => $some_value, # atomic
       SnapshotReserveTotal => $some_value, # atomic
       SnapshotReserveUsed => $some_value, # atomic
       SpaceAllocatedFromAggr =>  $some_value, # integer
       Total => $some_value, # atomic
     },
     VolumeSpaceStatus => $some_value, # ObjectSpaceStatus
     VolumeState =>  $some_value, # string
     VolumeStatus => $some_value, # ObjStatus
     VolumeType =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

