package MyTypes::BackupGraphEdgeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FromResourceId_of :ATTR(:get<FromResourceId>);
my %ToResourceId_of :ATTR(:get<ToResourceId>);

__PACKAGE__->_factory(
    [ qw(        FromResourceId
        ToResourceId

    ) ],
    {
        'FromResourceId' => \%FromResourceId_of,
        'ToResourceId' => \%ToResourceId_of,
    },
    {
        'FromResourceId' => 'MyTypes::ObjId',
        'ToResourceId' => 'MyTypes::ObjId',
    },
    {

        'FromResourceId' => 'FromResourceId',
        'ToResourceId' => 'ToResourceId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::BackupGraphEdgeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
BackupGraphEdgeInfo from the namespace http://www.netapp.com/management/v1.

An edge in the backup graph. These are used To traverse From a Resource To another Resource in the backup graph, To extract more specific information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FromResourceId


=item * ToResourceId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::BackupGraphEdgeInfo
   FromResourceId => $some_value, # ObjId
   ToResourceId => $some_value, # ObjId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

