package MyTypes::BackupGraphResourceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationResourceProperties_of :ATTR(:get<ApplicationResourceProperties>);
my %HostServiceObjectId_of :ATTR(:get<HostServiceObjectId>);
my %IsRestorable_of :ATTR(:get<IsRestorable>);
my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %ObjectNameWhenBackedUp_of :ATTR(:get<ObjectNameWhenBackedUp>);
my %ResourceType_of :ATTR(:get<ResourceType>);
my %Snapshots_of :ATTR(:get<Snapshots>);

__PACKAGE__->_factory(
    [ qw(        ApplicationResourceProperties
        HostServiceObjectId
        IsRestorable
        ObjectId
        ObjectName
        ObjectNameWhenBackedUp
        ResourceType
        Snapshots

    ) ],
    {
        'ApplicationResourceProperties' => \%ApplicationResourceProperties_of,
        'HostServiceObjectId' => \%HostServiceObjectId_of,
        'IsRestorable' => \%IsRestorable_of,
        'ObjectId' => \%ObjectId_of,
        'ObjectName' => \%ObjectName_of,
        'ObjectNameWhenBackedUp' => \%ObjectNameWhenBackedUp_of,
        'ResourceType' => \%ResourceType_of,
        'Snapshots' => \%Snapshots_of,
    },
    {
        'ApplicationResourceProperties' => 'MyTypes::ArrayOfPropertyInfo',
        'HostServiceObjectId' => 'MyTypes::HostServiceUniqueId',
        'IsRestorable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectName' => 'MyTypes::ObjName',
        'ObjectNameWhenBackedUp' => 'MyTypes::ObjName',
        'ResourceType' => 'MyTypes::ApplicationObjectType',
        'Snapshots' => 'MyTypes::ArrayOfSnapshotMemberInfo',
    },
    {

        'ApplicationResourceProperties' => 'ApplicationResourceProperties',
        'HostServiceObjectId' => 'HostServiceObjectId',
        'IsRestorable' => 'IsRestorable',
        'ObjectId' => 'ObjectId',
        'ObjectName' => 'ObjectName',
        'ObjectNameWhenBackedUp' => 'ObjectNameWhenBackedUp',
        'ResourceType' => 'ResourceType',
        'Snapshots' => 'Snapshots',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::BackupGraphResourceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
BackupGraphResourceInfo from the namespace http://www.netapp.com/management/v1.

Resource is an application object.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationResourceProperties


=item * HostServiceObjectId


=item * IsRestorable


=item * ObjectId


=item * ObjectName


=item * ObjectNameWhenBackedUp


=item * ResourceType


=item * Snapshots




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::BackupGraphResourceInfo
   ApplicationResourceProperties =>  { # MyTypes::ArrayOfPropertyInfo
     PropertyInfo =>  { # MyTypes::PropertyInfo
       PropertyName =>  $some_value, # string
       PropertyValue =>  $some_value, # string
     },
   },
   HostServiceObjectId => $some_value, # HostServiceUniqueId
   IsRestorable =>  $some_value, # boolean
   ObjectId => $some_value, # ObjId
   ObjectName => $some_value, # ObjName
   ObjectNameWhenBackedUp => $some_value, # ObjName
   ResourceType => $some_value, # ApplicationObjectType
   Snapshots =>  { # MyTypes::ArrayOfSnapshotMemberInfo
     SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
       PrimaryId => $some_value, # ObjId
       PrimaryName => $some_value, # ObjName
       PrimarySnapshotHostServiceId =>  $some_value, # string
       PrimarySnapshotName =>  $some_value, # string
       PrimarySnapshotUniqueId =>  $some_value, # string
       SecondaryQtreeId => $some_value, # ObjId
       SecondaryQtreeName =>  $some_value, # string
       SecondaryQtreeNameOrId =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

