package MyTypes::BackupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DpBackupExpiryTimestamp_of :ATTR(:get<DpBackupExpiryTimestamp>);
my %DpNodeId_of :ATTR(:get<DpNodeId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IsApplicationBackup_of :ATTR(:get<IsApplicationBackup>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupVersion
        DatasetId
        DatasetName
        DpBackupExpiryTimestamp
        DpNodeId
        DpNodeName
        IsApplicationBackup

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DpBackupExpiryTimestamp' => \%DpBackupExpiryTimestamp_of,
        'DpNodeId' => \%DpNodeId_of,
        'DpNodeName' => \%DpNodeName_of,
        'IsApplicationBackup' => \%IsApplicationBackup_of,
    },
    {

        'BackupId' => 'MyTypes::BackupInfo::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'DpBackupExpiryTimestamp' => 'MyTypes::DpTimestamp',
        'DpNodeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsApplicationBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DpBackupExpiryTimestamp' => 'DpBackupExpiryTimestamp',
        'DpNodeId' => 'DpNodeId',
        'DpNodeName' => 'DpNodeName',
        'IsApplicationBackup' => 'IsApplicationBackup',
    }
);

} # end BLOCK




package MyTypes::BackupInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::BackupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
BackupInfo from the namespace http://www.netapp.com/management/v1.

Information of a Dataset backup.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId


=item * BackupVersion


=item * DatasetId


=item * DatasetName


=item * DpBackupExpiryTimestamp


=item * DpNodeId


=item * DpNodeName


=item * IsApplicationBackup




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::BackupInfo
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   DpBackupExpiryTimestamp => $some_value, # DpTimestamp
   DpNodeId =>  $some_value, # integer
   DpNodeName =>  $some_value, # string
   IsApplicationBackup =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

