package MyTypes::BackupLocationInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %Path_of :ATTR(:get<Path>);
my %PathFound_of :ATTR(:get<PathFound>);
my %PrimarySnapshotName_of :ATTR(:get<PrimarySnapshotName>);
my %PrimarySnapshotUniqueId_of :ATTR(:get<PrimarySnapshotUniqueId>);
my %SecondaryQtreeId_of :ATTR(:get<SecondaryQtreeId>);
my %SecondaryQtreeName_of :ATTR(:get<SecondaryQtreeName>);
my %SnapshotName_of :ATTR(:get<SnapshotName>);
my %StorageSystemId_of :ATTR(:get<StorageSystemId>);
my %StorageSystemName_of :ATTR(:get<StorageSystemName>);
my %VolumeId_of :ATTR(:get<VolumeId>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        MemberId
        MemberName
        Path
        PathFound
        PrimarySnapshotName
        PrimarySnapshotUniqueId
        SecondaryQtreeId
        SecondaryQtreeName
        SnapshotName
        StorageSystemId
        StorageSystemName
        VolumeId

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'Path' => \%Path_of,
        'PathFound' => \%PathFound_of,
        'PrimarySnapshotName' => \%PrimarySnapshotName_of,
        'PrimarySnapshotUniqueId' => \%PrimarySnapshotUniqueId_of,
        'SecondaryQtreeId' => \%SecondaryQtreeId_of,
        'SecondaryQtreeName' => \%SecondaryQtreeName_of,
        'SnapshotName' => \%SnapshotName_of,
        'StorageSystemId' => \%StorageSystemId_of,
        'StorageSystemName' => \%StorageSystemName_of,
        'VolumeId' => \%VolumeId_of,
    },
    {

        'BackupId' => 'MyTypes::BackupLocationInfo::_BackupId',
        'MemberId' => 'MyTypes::ObjId',
        'MemberName' => 'MyTypes::ObjName',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PathFound' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SecondaryQtreeId' => 'MyTypes::ObjId',
        'SecondaryQtreeName' => 'MyTypes::ObjName',
        'SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageSystemId' => 'MyTypes::ObjId',
        'StorageSystemName' => 'MyTypes::ObjName',
        'VolumeId' => 'MyTypes::ObjId',
    },
    {

        'BackupId' => 'BackupId',
        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'Path' => 'Path',
        'PathFound' => 'PathFound',
        'PrimarySnapshotName' => 'PrimarySnapshotName',
        'PrimarySnapshotUniqueId' => 'PrimarySnapshotUniqueId',
        'SecondaryQtreeId' => 'SecondaryQtreeId',
        'SecondaryQtreeName' => 'SecondaryQtreeName',
        'SnapshotName' => 'SnapshotName',
        'StorageSystemId' => 'StorageSystemId',
        'StorageSystemName' => 'StorageSystemName',
        'VolumeId' => 'VolumeId',
    }
);

} # end BLOCK




package MyTypes::BackupLocationInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::BackupLocationInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
BackupLocationInfo from the namespace http://www.netapp.com/management/v1.

location information for backup. Only the Members which are found are returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId


=item * MemberId


=item * MemberName


=item * Path


=item * PathFound


=item * PrimarySnapshotName


=item * PrimarySnapshotUniqueId


=item * SecondaryQtreeId


=item * SecondaryQtreeName


=item * SnapshotName


=item * StorageSystemId


=item * StorageSystemName


=item * VolumeId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::BackupLocationInfo
   BackupId => $some_value, # atomic
   MemberId => $some_value, # ObjId
   MemberName => $some_value, # ObjName
   Path =>  $some_value, # string
   PathFound =>  $some_value, # boolean
   PrimarySnapshotName =>  $some_value, # string
   PrimarySnapshotUniqueId =>  $some_value, # string
   SecondaryQtreeId => $some_value, # ObjId
   SecondaryQtreeName => $some_value, # ObjName
   SnapshotName =>  $some_value, # string
   StorageSystemId => $some_value, # ObjId
   StorageSystemName => $some_value, # ObjName
   VolumeId => $some_value, # ObjId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

