package MyTypes::CategoryDocumentation;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Name_of :ATTR(:get<Name>);
my %Synopsis_of :ATTR(:get<Synopsis>);
my %Discussion_of :ATTR(:get<Discussion>);

__PACKAGE__->_factory(
    [ qw(        Name
        Synopsis
        Discussion

    ) ],
    {
        'Name' => \%Name_of,
        'Synopsis' => \%Synopsis_of,
        'Discussion' => \%Discussion_of,
    },
    {
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Synopsis' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Discussion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Name' => 'Name',
        'Synopsis' => 'Synopsis',
        'Discussion' => 'Discussion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CategoryDocumentation

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CategoryDocumentation from the namespace http://www.netapp.com/management/v1.

The CategoryDocumentation type is used to document categories. Categories are groups of related operations.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Name


=item * Synopsis


=item * Discussion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CategoryDocumentation
   Name =>  $some_value, # string
   Synopsis =>  $some_value, # string
   Discussion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

