package MyTypes::CifsAcl;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AccessRights_of :ATTR(:get<AccessRights>);
my %UserName_of :ATTR(:get<UserName>);

__PACKAGE__->_factory(
    [ qw(        AccessRights
        UserName

    ) ],
    {
        'AccessRights' => \%AccessRights_of,
        'UserName' => \%UserName_of,
    },
    {
        'AccessRights' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AccessRights' => 'AccessRights',
        'UserName' => 'UserName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CifsAcl

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CifsAcl from the namespace http://www.netapp.com/management/v1.

Information about the user and the Permission with which the user can access the CIFS share.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AccessRights


=item * UserName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CifsAcl
   AccessRights =>  $some_value, # string
   UserName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

