package MyTypes::CifsShareInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsShareName_of :ATTR(:get<CifsShareName>);
my %CifsSharePermissions_of :ATTR(:get<CifsSharePermissions>);

__PACKAGE__->_factory(
    [ qw(        CifsShareName
        CifsSharePermissions

    ) ],
    {
        'CifsShareName' => \%CifsShareName_of,
        'CifsSharePermissions' => \%CifsSharePermissions_of,
    },
    {
        'CifsShareName' => 'MyTypes::CifsShareName',
        'CifsSharePermissions' => 'MyTypes::ArrayOfCifsSharePermission',
    },
    {

        'CifsShareName' => 'CifsShareName',
        'CifsSharePermissions' => 'CifsSharePermissions',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CifsShareInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CifsShareInfo from the namespace http://www.netapp.com/management/v1.

Specifies the Properties of a CIFS share on Data ONTPAP system.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsShareName


=item * CifsSharePermissions




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CifsShareInfo
   CifsShareName => $some_value, # CifsShareName
   CifsSharePermissions =>  { # MyTypes::ArrayOfCifsSharePermission
     CifsSharePermission =>  { # MyTypes::CifsSharePermission
       CifsUsername =>  $some_value, # string
       Permission =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

