package MyTypes::CifsSharePermission;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsUsername_of :ATTR(:get<CifsUsername>);
my %Permission_of :ATTR(:get<Permission>);

__PACKAGE__->_factory(
    [ qw(        CifsUsername
        Permission

    ) ],
    {
        'CifsUsername' => \%CifsUsername_of,
        'Permission' => \%Permission_of,
    },
    {
        'CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Permission' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CifsUsername' => 'CifsUsername',
        'Permission' => 'Permission',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CifsSharePermission

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CifsSharePermission from the namespace http://www.netapp.com/management/v1.

CIFS ACL information configured for a CIFS share.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsUsername


=item * Permission




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CifsSharePermission
   CifsUsername =>  $some_value, # string
   Permission =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

