package MyTypes::ClientOptionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Option_of :ATTR(:get<Option>);
my %Value_of :ATTR(:get<Value>);

__PACKAGE__->_factory(
    [ qw(        Option
        Value

    ) ],
    {
        'Option' => \%Option_of,
        'Value' => \%Value_of,
    },
    {
        'Option' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Option' => 'Option',
        'Value' => 'Value',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ClientOptionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ClientOptionInfo from the namespace http://www.netapp.com/management/v1.

Single name/value pair.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Option


=item * Value




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ClientOptionInfo
   Option =>  $some_value, # string
   Value =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

