package MyTypes::ClientStatError;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsError_of :ATTR(:get<CifsError>);
my %NfsError_of :ATTR(:get<NfsError>);
my %ObjectName_of :ATTR(:get<ObjectName>);

__PACKAGE__->_factory(
    [ qw(        CifsError
        NfsError
        ObjectName

    ) ],
    {
        'CifsError' => \%CifsError_of,
        'NfsError' => \%NfsError_of,
        'ObjectName' => \%ObjectName_of,
    },
    {
        'CifsError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NfsError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectName' => 'MyTypes::ObjName',
    },
    {

        'CifsError' => 'CifsError',
        'NfsError' => 'NfsError',
        'ObjectName' => 'ObjectName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ClientStatError

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ClientStatError from the namespace http://www.netapp.com/management/v1.

Describes an Error encountered while collecting per-client statistics on the storage system or Vfiler.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsError


=item * NfsError


=item * ObjectName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ClientStatError
   CifsError =>  $some_value, # string
   NfsError =>  $some_value, # string
   ObjectName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

