package MyTypes::ClientStats;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsOpStats_of :ATTR(:get<CifsOpStats>);
my %ClientNameOrIp_of :ATTR(:get<ClientNameOrIp>);
my %NfsOpStats_of :ATTR(:get<NfsOpStats>);

__PACKAGE__->_factory(
    [ qw(        CifsOpStats
        ClientNameOrIp
        NfsOpStats

    ) ],
    {
        'CifsOpStats' => \%CifsOpStats_of,
        'ClientNameOrIp' => \%ClientNameOrIp_of,
        'NfsOpStats' => \%NfsOpStats_of,
    },
    {
        'CifsOpStats' => 'MyTypes::CifsOpStats',
        'ClientNameOrIp' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NfsOpStats' => 'MyTypes::NfsOpStats',
    },
    {

        'CifsOpStats' => 'CifsOpStats',
        'ClientNameOrIp' => 'ClientNameOrIp',
        'NfsOpStats' => 'NfsOpStats',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ClientStats

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ClientStats from the namespace http://www.netapp.com/management/v1.

Contains the per-protocol operations performed by a client on a storage system.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsOpStats


=item * ClientNameOrIp


=item * NfsOpStats




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ClientStats
   CifsOpStats =>  { # MyTypes::CifsOpStats
     OtherOperations => $some_value, # atomic
     ReadOperations => $some_value, # atomic
     WriteOperations => $some_value, # atomic
   },
   ClientNameOrIp =>  $some_value, # string
   NfsOpStats =>  { # MyTypes::NfsOpStats
     OtherOperations => $some_value, # atomic
     ReadOperations => $some_value, # atomic
     WriteOperations => $some_value, # atomic
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

