package MyTypes::CommentFieldInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CommentFieldId_of :ATTR(:get<CommentFieldId>);
my %CommentFieldName_of :ATTR(:get<CommentFieldName>);
my %CommentFieldObjectTypes_of :ATTR(:get<CommentFieldObjectTypes>);
my %IsSystemComment_of :ATTR(:get<IsSystemComment>);

__PACKAGE__->_factory(
    [ qw(        CommentFieldId
        CommentFieldName
        CommentFieldObjectTypes
        IsSystemComment

    ) ],
    {
        'CommentFieldId' => \%CommentFieldId_of,
        'CommentFieldName' => \%CommentFieldName_of,
        'CommentFieldObjectTypes' => \%CommentFieldObjectTypes_of,
        'IsSystemComment' => \%IsSystemComment_of,
    },
    {
        'CommentFieldId' => 'MyTypes::CommentFieldId',
        'CommentFieldName' => 'MyTypes::CommentFieldName',
        'CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
        'IsSystemComment' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'CommentFieldId' => 'CommentFieldId',
        'CommentFieldName' => 'CommentFieldName',
        'CommentFieldObjectTypes' => 'CommentFieldObjectTypes',
        'IsSystemComment' => 'IsSystemComment',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CommentFieldInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CommentFieldInfo from the namespace http://www.netapp.com/management/v1.

Information about the comment field.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CommentFieldId


=item * CommentFieldName


=item * CommentFieldObjectTypes


=item * IsSystemComment




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CommentFieldInfo
   CommentFieldId => $some_value, # CommentFieldId
   CommentFieldName => $some_value, # CommentFieldName
   CommentFieldObjectTypes =>  { # MyTypes::ArrayOfCommentFieldObjectType
     CommentFieldObjectType => $some_value, # CommentFieldObjectType
   },
   IsSystemComment =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

