package MyTypes::CommentFieldValue;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CommentFieldId_of :ATTR(:get<CommentFieldId>);
my %CommentFieldName_of :ATTR(:get<CommentFieldName>);
my %CommentValue_of :ATTR(:get<CommentValue>);
my %ObjectFullName_of :ATTR(:get<ObjectFullName>);
my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectType_of :ATTR(:get<ObjectType>);

__PACKAGE__->_factory(
    [ qw(        CommentFieldId
        CommentFieldName
        CommentValue
        ObjectFullName
        ObjectId
        ObjectType

    ) ],
    {
        'CommentFieldId' => \%CommentFieldId_of,
        'CommentFieldName' => \%CommentFieldName_of,
        'CommentValue' => \%CommentValue_of,
        'ObjectFullName' => \%ObjectFullName_of,
        'ObjectId' => \%ObjectId_of,
        'ObjectType' => \%ObjectType_of,
    },
    {
        'CommentFieldId' => 'MyTypes::CommentFieldId',
        'CommentFieldName' => 'MyTypes::CommentFieldName',
        'CommentValue' => 'MyTypes::CommentValue',
        'ObjectFullName' => 'MyTypes::ObjFullName',
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CommentFieldId' => 'CommentFieldId',
        'CommentFieldName' => 'CommentFieldName',
        'CommentValue' => 'CommentValue',
        'ObjectFullName' => 'ObjectFullName',
        'ObjectId' => 'ObjectId',
        'ObjectType' => 'ObjectType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::CommentFieldValue

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
CommentFieldValue from the namespace http://www.netapp.com/management/v1.

A single comment field Value.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CommentFieldId


=item * CommentFieldName


=item * CommentValue


=item * ObjectFullName


=item * ObjectId


=item * ObjectType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::CommentFieldValue
   CommentFieldId => $some_value, # CommentFieldId
   CommentFieldName => $some_value, # CommentFieldName
   CommentValue => $some_value, # CommentValue
   ObjectFullName => $some_value, # ObjFullName
   ObjectId => $some_value, # ObjId
   ObjectType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

