package MyTypes::ConformanceAlert;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConformanceAlertEffect_of :ATTR(:get<ConformanceAlertEffect>);
my %ConformanceAlertReason_of :ATTR(:get<ConformanceAlertReason>);
my %ConformanceAlertSeverity_of :ATTR(:get<ConformanceAlertSeverity>);
my %ConformanceAlertSuggestion_of :ATTR(:get<ConformanceAlertSuggestion>);
my %ConformanceAlertType_of :ATTR(:get<ConformanceAlertType>);

__PACKAGE__->_factory(
    [ qw(        ConformanceAlertEffect
        ConformanceAlertReason
        ConformanceAlertSeverity
        ConformanceAlertSuggestion
        ConformanceAlertType

    ) ],
    {
        'ConformanceAlertEffect' => \%ConformanceAlertEffect_of,
        'ConformanceAlertReason' => \%ConformanceAlertReason_of,
        'ConformanceAlertSeverity' => \%ConformanceAlertSeverity_of,
        'ConformanceAlertSuggestion' => \%ConformanceAlertSuggestion_of,
        'ConformanceAlertType' => \%ConformanceAlertType_of,
    },
    {
        'ConformanceAlertEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceAlertReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceAlertSeverity' => 'MyTypes::ObjStatus',
        'ConformanceAlertSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceAlertType' => 'MyTypes::ConformanceAlertType',
    },
    {

        'ConformanceAlertEffect' => 'ConformanceAlertEffect',
        'ConformanceAlertReason' => 'ConformanceAlertReason',
        'ConformanceAlertSeverity' => 'ConformanceAlertSeverity',
        'ConformanceAlertSuggestion' => 'ConformanceAlertSuggestion',
        'ConformanceAlertType' => 'ConformanceAlertType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ConformanceAlert

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ConformanceAlert from the namespace http://www.netapp.com/management/v1.

A Description of one conformance check alert that should be noted by a user.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConformanceAlertEffect


=item * ConformanceAlertReason


=item * ConformanceAlertSeverity


=item * ConformanceAlertSuggestion


=item * ConformanceAlertType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ConformanceAlert
   ConformanceAlertEffect =>  $some_value, # string
   ConformanceAlertReason =>  $some_value, # string
   ConformanceAlertSeverity => $some_value, # ObjStatus
   ConformanceAlertSuggestion =>  $some_value, # string
   ConformanceAlertType => $some_value, # ConformanceAlertType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

