package MyTypes::ConformanceRunResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConformanceJobId_of :ATTR(:get<ConformanceJobId>);
my %ConformanceRunAction_of :ATTR(:get<ConformanceRunAction>);
my %ConformanceRunEffect_of :ATTR(:get<ConformanceRunEffect>);
my %ConformanceRunReason_of :ATTR(:get<ConformanceRunReason>);
my %ConformanceRunReasonDetails_of :ATTR(:get<ConformanceRunReasonDetails>);
my %ConformanceRunSeverity_of :ATTR(:get<ConformanceRunSeverity>);
my %ConformanceRunSuggestion_of :ATTR(:get<ConformanceRunSuggestion>);

__PACKAGE__->_factory(
    [ qw(        ConformanceJobId
        ConformanceRunAction
        ConformanceRunEffect
        ConformanceRunReason
        ConformanceRunReasonDetails
        ConformanceRunSeverity
        ConformanceRunSuggestion

    ) ],
    {
        'ConformanceJobId' => \%ConformanceJobId_of,
        'ConformanceRunAction' => \%ConformanceRunAction_of,
        'ConformanceRunEffect' => \%ConformanceRunEffect_of,
        'ConformanceRunReason' => \%ConformanceRunReason_of,
        'ConformanceRunReasonDetails' => \%ConformanceRunReasonDetails_of,
        'ConformanceRunSeverity' => \%ConformanceRunSeverity_of,
        'ConformanceRunSuggestion' => \%ConformanceRunSuggestion_of,
    },
    {
        'ConformanceJobId' => 'MyTypes::ObjId',
        'ConformanceRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConformanceRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
        'ConformanceRunSeverity' => 'MyTypes::ObjStatus',
        'ConformanceRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ConformanceJobId' => 'ConformanceJobId',
        'ConformanceRunAction' => 'ConformanceRunAction',
        'ConformanceRunEffect' => 'ConformanceRunEffect',
        'ConformanceRunReason' => 'ConformanceRunReason',
        'ConformanceRunReasonDetails' => 'ConformanceRunReasonDetails',
        'ConformanceRunSeverity' => 'ConformanceRunSeverity',
        'ConformanceRunSuggestion' => 'ConformanceRunSuggestion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ConformanceRunResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ConformanceRunResult from the namespace http://www.netapp.com/management/v1.

A Description of one Action and the predicted effects of taking that Action.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConformanceJobId


=item * ConformanceRunAction


=item * ConformanceRunEffect


=item * ConformanceRunReason


=item * ConformanceRunReasonDetails


=item * ConformanceRunSeverity


=item * ConformanceRunSuggestion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ConformanceRunResult
   ConformanceJobId => $some_value, # ObjId
   ConformanceRunAction =>  $some_value, # string
   ConformanceRunEffect =>  $some_value, # string
   ConformanceRunReason =>  $some_value, # string
   ConformanceRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
     ResultDetail =>  { # MyTypes::ResultDetail
       Action =>  $some_value, # string
       Effect =>  $some_value, # string
       Reason =>  $some_value, # string
       Severity => $some_value, # ObjStatus
       Suggestion =>  $some_value, # string
     },
   },
   ConformanceRunSeverity => $some_value, # ObjStatus
   ConformanceRunSuggestion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

