package MyTypes::DailyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ItemId_of :ATTR(:get<ItemId>);
my %StartHour_of :ATTR(:get<StartHour>);
my %StartMinute_of :ATTR(:get<StartMinute>);

__PACKAGE__->_factory(
    [ qw(        ItemId
        StartHour
        StartMinute

    ) ],
    {
        'ItemId' => \%ItemId_of,
        'StartHour' => \%StartHour_of,
        'StartMinute' => \%StartMinute_of,
    },
    {

        'ItemId' => 'MyTypes::DailyInfo::_ItemId',

        'StartHour' => 'MyTypes::DailyInfo::_StartHour',

        'StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
    },
    {

        'ItemId' => 'ItemId',
        'StartHour' => 'StartHour',
        'StartMinute' => 'StartMinute',
    }
);

} # end BLOCK




package MyTypes::DailyInfo::_ItemId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DailyInfo::_StartHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DailyInfo::_StartMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DailyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DailyInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a daily schedule. May only be used in a daily schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ItemId


=item * StartHour


=item * StartMinute




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DailyInfo
   ItemId => $some_value, # atomic
   StartHour => $some_value, # atomic
   StartMinute => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

