package MyTypes::Datacenter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatacenterId_of :ATTR(:get<DatacenterId>);
my %DatacenterName_of :ATTR(:get<DatacenterName>);
my %Datasets_of :ATTR(:get<Datasets>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %IsProtected_of :ATTR(:get<IsProtected>);
my %VirtualCenterReference_of :ATTR(:get<VirtualCenterReference>);

__PACKAGE__->_factory(
    [ qw(        DatacenterId
        DatacenterName
        Datasets
        DeletedBy
        DeletedTimestamp
        HostServiceId
        IsProtected
        VirtualCenterReference

    ) ],
    {
        'DatacenterId' => \%DatacenterId_of,
        'DatacenterName' => \%DatacenterName_of,
        'Datasets' => \%Datasets_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'HostServiceId' => \%HostServiceId_of,
        'IsProtected' => \%IsProtected_of,
        'VirtualCenterReference' => \%VirtualCenterReference_of,
    },
    {
        'DatacenterId' => 'MyTypes::ObjId',
        'DatacenterName' => 'MyTypes::ObjName',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'HostServiceId' => 'MyTypes::ObjId',
        'IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
    },
    {

        'DatacenterId' => 'DatacenterId',
        'DatacenterName' => 'DatacenterName',
        'Datasets' => 'Datasets',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'HostServiceId' => 'HostServiceId',
        'IsProtected' => 'IsProtected',
        'VirtualCenterReference' => 'VirtualCenterReference',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Datacenter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Datacenter from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatacenterId


=item * DatacenterName


=item * Datasets


=item * DeletedBy


=item * DeletedTimestamp


=item * HostServiceId


=item * IsProtected


=item * VirtualCenterReference




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Datacenter
   DatacenterId => $some_value, # ObjId
   DatacenterName => $some_value, # ObjName
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   HostServiceId => $some_value, # ObjId
   IsProtected =>  $some_value, # boolean
   VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
     VirtualCenterId => $some_value, # ObjId
     VirtualCenterName => $some_value, # ObjName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

