package MyTypes::DatacenterReference;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatacenterId_of :ATTR(:get<DatacenterId>);
my %DatacenterName_of :ATTR(:get<DatacenterName>);

__PACKAGE__->_factory(
    [ qw(        DatacenterId
        DatacenterName

    ) ],
    {
        'DatacenterId' => \%DatacenterId_of,
        'DatacenterName' => \%DatacenterName_of,
    },
    {
        'DatacenterId' => 'MyTypes::ObjId',
        'DatacenterName' => 'MyTypes::ObjName',
    },
    {

        'DatacenterId' => 'DatacenterId',
        'DatacenterName' => 'DatacenterName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatacenterReference

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatacenterReference from the namespace http://www.netapp.com/management/v1.

Information about a Hypervisor.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatacenterId


=item * DatacenterName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatacenterReference
   DatacenterId => $some_value, # ObjId
   DatacenterName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

