package MyTypes::DatasetAccessDetails;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IpAddress_of :ATTR(:get<IpAddress>);
my %Netmask_of :ATTR(:get<Netmask>);

__PACKAGE__->_factory(
    [ qw(        IpAddress
        Netmask

    ) ],
    {
        'IpAddress' => \%IpAddress_of,
        'Netmask' => \%Netmask_of,
    },
    {
        'IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'IpAddress' => 'IpAddress',
        'Netmask' => 'Netmask',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetAccessDetails

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetAccessDetails from the namespace http://www.netapp.com/management/v1.

The data access details of a Dataset. Currently, this is used To configure a Dataset in a way that it is capable of transparent migration. A Dataset can be configured and provisioned in a way that it is capable of transparent migration. IP Address and Netmask has To be configured on the Dataset in order To make the Dataset capable of transparent migration. Provisioning Manager will create a vFiler Unit with this IP Address and all the storage provisioned for this Dataset will be accessed From this vFiler Unit or this IP Address. As input, it is valid only when: - There are no Members in the Dataset. - There is no vFiler Unit attached To the Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IpAddress


=item * Netmask




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetAccessDetails
   IpAddress =>  $some_value, # string
   Netmask =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

