package MyTypes::DatasetCifsExportSetting;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsDomain_of :ATTR(:get<CifsDomain>);
my %DatasetCifsSharePermissions_of :ATTR(:get<DatasetCifsSharePermissions>);

__PACKAGE__->_factory(
    [ qw(        CifsDomain
        DatasetCifsSharePermissions

    ) ],
    {
        'CifsDomain' => \%CifsDomain_of,
        'DatasetCifsSharePermissions' => \%DatasetCifsSharePermissions_of,
    },
    {
        'CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
    },
    {

        'CifsDomain' => 'CifsDomain',
        'DatasetCifsSharePermissions' => 'DatasetCifsSharePermissions',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetCifsExportSetting

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetCifsExportSetting from the namespace http://www.netapp.com/management/v1.

If storage inside this Dataset node is exported over CIFS, this specifies some of the common Properties that will be applied To all such provisioned storage.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsDomain


=item * DatasetCifsSharePermissions




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetCifsExportSetting
   CifsDomain =>  $some_value, # string
   DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
     DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
       CifsUsername =>  $some_value, # string
       Permission => $some_value, # CifsPermission
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

