package MyTypes::DatasetDynamicReferenceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %DynamicReferenceId_of :ATTR(:get<DynamicReferenceId>);
my %DynamicReferenceName_of :ATTR(:get<DynamicReferenceName>);
my %DynamicReferenceStatus_of :ATTR(:get<DynamicReferenceStatus>);
my %DynamicReferenceSubtype_of :ATTR(:get<DynamicReferenceSubtype>);
my %DynamicReferenceType_of :ATTR(:get<DynamicReferenceType>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsDeleted_of :ATTR(:get<IsDeleted>);
my %StoragesetId_of :ATTR(:get<StoragesetId>);
my %StoragesetName_of :ATTR(:get<StoragesetName>);

__PACKAGE__->_factory(
    [ qw(        DpNodeName
        DynamicReferenceId
        DynamicReferenceName
        DynamicReferenceStatus
        DynamicReferenceSubtype
        DynamicReferenceType
        IsAvailable
        IsDeleted
        StoragesetId
        StoragesetName

    ) ],
    {
        'DpNodeName' => \%DpNodeName_of,
        'DynamicReferenceId' => \%DynamicReferenceId_of,
        'DynamicReferenceName' => \%DynamicReferenceName_of,
        'DynamicReferenceStatus' => \%DynamicReferenceStatus_of,
        'DynamicReferenceSubtype' => \%DynamicReferenceSubtype_of,
        'DynamicReferenceType' => \%DynamicReferenceType_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsDeleted' => \%IsDeleted_of,
        'StoragesetId' => \%StoragesetId_of,
        'StoragesetName' => \%StoragesetName_of,
    },
    {
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'DynamicReferenceId' => 'MyTypes::ObjId',
        'DynamicReferenceName' => 'MyTypes::ObjName',
        'DynamicReferenceStatus' => 'MyTypes::ObjStatus',
        'DynamicReferenceSubtype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DynamicReferenceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'StoragesetId' => 'MyTypes::ObjId',
        'StoragesetName' => 'MyTypes::ObjName',
    },
    {

        'DpNodeName' => 'DpNodeName',
        'DynamicReferenceId' => 'DynamicReferenceId',
        'DynamicReferenceName' => 'DynamicReferenceName',
        'DynamicReferenceStatus' => 'DynamicReferenceStatus',
        'DynamicReferenceSubtype' => 'DynamicReferenceSubtype',
        'DynamicReferenceType' => 'DynamicReferenceType',
        'IsAvailable' => 'IsAvailable',
        'IsDeleted' => 'IsDeleted',
        'StoragesetId' => 'StoragesetId',
        'StoragesetName' => 'StoragesetName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetDynamicReferenceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetDynamicReferenceInfo from the namespace http://www.netapp.com/management/v1.

Information about one dynamic reference in a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpNodeName


=item * DynamicReferenceId


=item * DynamicReferenceName


=item * DynamicReferenceStatus


=item * DynamicReferenceSubtype


=item * DynamicReferenceType


=item * IsAvailable


=item * IsDeleted


=item * StoragesetId


=item * StoragesetName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetDynamicReferenceInfo
   DpNodeName => $some_value, # DpPolicyNodeName
   DynamicReferenceId => $some_value, # ObjId
   DynamicReferenceName => $some_value, # ObjName
   DynamicReferenceStatus => $some_value, # ObjStatus
   DynamicReferenceSubtype =>  $some_value, # string
   DynamicReferenceType =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   IsDeleted =>  $some_value, # boolean
   StoragesetId => $some_value, # ObjId
   StoragesetName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

