package MyTypes::DatasetExportInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetCifsExportSetting_of :ATTR(:get<DatasetCifsExportSetting>);
my %DatasetExportProtocol_of :ATTR(:get<DatasetExportProtocol>);
my %DatasetLunMappingInfo_of :ATTR(:get<DatasetLunMappingInfo>);
my %DatasetNfsExportSetting_of :ATTR(:get<DatasetNfsExportSetting>);

__PACKAGE__->_factory(
    [ qw(        DatasetCifsExportSetting
        DatasetExportProtocol
        DatasetLunMappingInfo
        DatasetNfsExportSetting

    ) ],
    {
        'DatasetCifsExportSetting' => \%DatasetCifsExportSetting_of,
        'DatasetExportProtocol' => \%DatasetExportProtocol_of,
        'DatasetLunMappingInfo' => \%DatasetLunMappingInfo_of,
        'DatasetNfsExportSetting' => \%DatasetNfsExportSetting_of,
    },
    {
        'DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
        'DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
        'DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
        'DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
    },
    {

        'DatasetCifsExportSetting' => 'DatasetCifsExportSetting',
        'DatasetExportProtocol' => 'DatasetExportProtocol',
        'DatasetLunMappingInfo' => 'DatasetLunMappingInfo',
        'DatasetNfsExportSetting' => 'DatasetNfsExportSetting',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetExportInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetExportInfo from the namespace http://www.netapp.com/management/v1.

Specifies the NAS or SAN export settings for a Dataset node.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetCifsExportSetting


=item * DatasetExportProtocol


=item * DatasetLunMappingInfo


=item * DatasetNfsExportSetting




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetExportInfo
   DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
     CifsDomain =>  $some_value, # string
     DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
       DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
         CifsUsername =>  $some_value, # string
         Permission => $some_value, # CifsPermission
       },
     },
   },
   DatasetExportProtocol => $some_value, # DatasetExportProtocol
   DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
     IgroupOsType =>  $some_value, # string
     LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
       LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
         Hostname =>  $some_value, # string
         InitiatorId => $some_value, # InitiatorId
       },
     },
   },
   DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
     AnonymousAccessUser => $some_value, # atomic
     DisableSetuid =>  $some_value, # boolean
     IsReadonlyForAllHosts =>  $some_value, # boolean
     IsReadwriteForAllHosts =>  $some_value, # boolean
     NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsProtocolVersion =>  $some_value, # string
     NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
       NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

