package MyTypes::DatasetInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationInfo_of :ATTR(:get<ApplicationInfo>);
my %ApplicationPolicyId_of :ATTR(:get<ApplicationPolicyId>);
my %ApplicationPolicyName_of :ATTR(:get<ApplicationPolicyName>);
my %ApplicationResourceNamespaces_of :ATTR(:get<ApplicationResourceNamespaces>);
my %CanContainApplicationResources_of :ATTR(:get<CanContainApplicationResources>);
my %CanContainStorageResources_of :ATTR(:get<CanContainStorageResources>);
my %DatasetAccessDetails_of :ATTR(:get<DatasetAccessDetails>);
my %DatasetContact_of :ATTR(:get<DatasetContact>);
my %DatasetDescription_of :ATTR(:get<DatasetDescription>);
my %DatasetExportInfo_of :ATTR(:get<DatasetExportInfo>);
my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetMap_of :ATTR(:get<DatasetMap>);
my %DatasetMetadata_of :ATTR(:get<DatasetMetadata>);
my %DatasetMigrationInfo_of :ATTR(:get<DatasetMigrationInfo>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DatasetOwner_of :ATTR(:get<DatasetOwner>);
my %DatasetStatus_of :ATTR(:get<DatasetStatus>);
my %DrState_of :ATTR(:get<DrState>);
my %DynamicReferenceCount_of :ATTR(:get<DynamicReferenceCount>);
my %HasProtection_of :ATTR(:get<HasProtection>);
my %HasProtectionPolicy_of :ATTR(:get<HasProtectionPolicy>);
my %IsAllowCustomSettings_of :ATTR(:get<IsAllowCustomSettings>);
my %IsApplicationData_of :ATTR(:get<IsApplicationData>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsDpSuspended_of :ATTR(:get<IsDpSuspended>);
my %IsDrCapable_of :ATTR(:get<IsDrCapable>);
my %IsEnableWriteGuaranteeChecks_of :ATTR(:get<IsEnableWriteGuaranteeChecks>);
my %IsProtected_of :ATTR(:get<IsProtected>);
my %IsSuspended_of :ATTR(:get<IsSuspended>);
my %IsVfilerCreatedForMigration_of :ATTR(:get<IsVfilerCreatedForMigration>);
my %MaximumLunsPerVolume_of :ATTR(:get<MaximumLunsPerVolume>);
my %MaximumQtreesPerVolume_of :ATTR(:get<MaximumQtreesPerVolume>);
my %MemberCount_of :ATTR(:get<MemberCount>);
my %OnlineMigration_of :ATTR(:get<OnlineMigration>);
my %PrimaryVolumeNameFormat_of :ATTR(:get<PrimaryVolumeNameFormat>);
my %ProtectionPolicyId_of :ATTR(:get<ProtectionPolicyId>);
my %ProtectionPolicyName_of :ATTR(:get<ProtectionPolicyName>);
my %ProvisioningPolicyId_of :ATTR(:get<ProvisioningPolicyId>);
my %ProvisioningPolicyName_of :ATTR(:get<ProvisioningPolicyName>);
my %RequiresNonDisruptiveRestore_of :ATTR(:get<RequiresNonDisruptiveRestore>);
my %ResourcepoolId_of :ATTR(:get<ResourcepoolId>);
my %ResourcepoolName_of :ATTR(:get<ResourcepoolName>);
my %Resourcepools_of :ATTR(:get<Resourcepools>);
my %SecondaryQtreeNameFormat_of :ATTR(:get<SecondaryQtreeNameFormat>);
my %SecondaryVolumeNameFormat_of :ATTR(:get<SecondaryVolumeNameFormat>);
my %SnapshotNameFormat_of :ATTR(:get<SnapshotNameFormat>);
my %StorageServiceId_of :ATTR(:get<StorageServiceId>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);
my %StoragesetId_of :ATTR(:get<StoragesetId>);
my %StoragesetName_of :ATTR(:get<StoragesetName>);
my %StoragesetTimezone_of :ATTR(:get<StoragesetTimezone>);
my %VfilerId_of :ATTR(:get<VfilerId>);
my %VfilerName_of :ATTR(:get<VfilerName>);
my %VolumeQtreeNamePrefix_of :ATTR(:get<VolumeQtreeNamePrefix>);

__PACKAGE__->_factory(
    [ qw(        ApplicationInfo
        ApplicationPolicyId
        ApplicationPolicyName
        ApplicationResourceNamespaces
        CanContainApplicationResources
        CanContainStorageResources
        DatasetAccessDetails
        DatasetContact
        DatasetDescription
        DatasetExportInfo
        DatasetId
        DatasetMap
        DatasetMetadata
        DatasetMigrationInfo
        DatasetName
        DatasetOwner
        DatasetStatus
        DrState
        DynamicReferenceCount
        HasProtection
        HasProtectionPolicy
        IsAllowCustomSettings
        IsApplicationData
        IsDpIgnored
        IsDpSuspended
        IsDrCapable
        IsEnableWriteGuaranteeChecks
        IsProtected
        IsSuspended
        IsVfilerCreatedForMigration
        MaximumLunsPerVolume
        MaximumQtreesPerVolume
        MemberCount
        OnlineMigration
        PrimaryVolumeNameFormat
        ProtectionPolicyId
        ProtectionPolicyName
        ProvisioningPolicyId
        ProvisioningPolicyName
        RequiresNonDisruptiveRestore
        ResourcepoolId
        ResourcepoolName
        Resourcepools
        SecondaryQtreeNameFormat
        SecondaryVolumeNameFormat
        SnapshotNameFormat
        StorageServiceId
        StorageServiceName
        StoragesetId
        StoragesetName
        StoragesetTimezone
        VfilerId
        VfilerName
        VolumeQtreeNamePrefix

    ) ],
    {
        'ApplicationInfo' => \%ApplicationInfo_of,
        'ApplicationPolicyId' => \%ApplicationPolicyId_of,
        'ApplicationPolicyName' => \%ApplicationPolicyName_of,
        'ApplicationResourceNamespaces' => \%ApplicationResourceNamespaces_of,
        'CanContainApplicationResources' => \%CanContainApplicationResources_of,
        'CanContainStorageResources' => \%CanContainStorageResources_of,
        'DatasetAccessDetails' => \%DatasetAccessDetails_of,
        'DatasetContact' => \%DatasetContact_of,
        'DatasetDescription' => \%DatasetDescription_of,
        'DatasetExportInfo' => \%DatasetExportInfo_of,
        'DatasetId' => \%DatasetId_of,
        'DatasetMap' => \%DatasetMap_of,
        'DatasetMetadata' => \%DatasetMetadata_of,
        'DatasetMigrationInfo' => \%DatasetMigrationInfo_of,
        'DatasetName' => \%DatasetName_of,
        'DatasetOwner' => \%DatasetOwner_of,
        'DatasetStatus' => \%DatasetStatus_of,
        'DrState' => \%DrState_of,
        'DynamicReferenceCount' => \%DynamicReferenceCount_of,
        'HasProtection' => \%HasProtection_of,
        'HasProtectionPolicy' => \%HasProtectionPolicy_of,
        'IsAllowCustomSettings' => \%IsAllowCustomSettings_of,
        'IsApplicationData' => \%IsApplicationData_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsDpSuspended' => \%IsDpSuspended_of,
        'IsDrCapable' => \%IsDrCapable_of,
        'IsEnableWriteGuaranteeChecks' => \%IsEnableWriteGuaranteeChecks_of,
        'IsProtected' => \%IsProtected_of,
        'IsSuspended' => \%IsSuspended_of,
        'IsVfilerCreatedForMigration' => \%IsVfilerCreatedForMigration_of,
        'MaximumLunsPerVolume' => \%MaximumLunsPerVolume_of,
        'MaximumQtreesPerVolume' => \%MaximumQtreesPerVolume_of,
        'MemberCount' => \%MemberCount_of,
        'OnlineMigration' => \%OnlineMigration_of,
        'PrimaryVolumeNameFormat' => \%PrimaryVolumeNameFormat_of,
        'ProtectionPolicyId' => \%ProtectionPolicyId_of,
        'ProtectionPolicyName' => \%ProtectionPolicyName_of,
        'ProvisioningPolicyId' => \%ProvisioningPolicyId_of,
        'ProvisioningPolicyName' => \%ProvisioningPolicyName_of,
        'RequiresNonDisruptiveRestore' => \%RequiresNonDisruptiveRestore_of,
        'ResourcepoolId' => \%ResourcepoolId_of,
        'ResourcepoolName' => \%ResourcepoolName_of,
        'Resourcepools' => \%Resourcepools_of,
        'SecondaryQtreeNameFormat' => \%SecondaryQtreeNameFormat_of,
        'SecondaryVolumeNameFormat' => \%SecondaryVolumeNameFormat_of,
        'SnapshotNameFormat' => \%SnapshotNameFormat_of,
        'StorageServiceId' => \%StorageServiceId_of,
        'StorageServiceName' => \%StorageServiceName_of,
        'StoragesetId' => \%StoragesetId_of,
        'StoragesetName' => \%StoragesetName_of,
        'StoragesetTimezone' => \%StoragesetTimezone_of,
        'VfilerId' => \%VfilerId_of,
        'VfilerName' => \%VfilerName_of,
        'VolumeQtreeNamePrefix' => \%VolumeQtreeNamePrefix_of,
    },
    {
        'ApplicationInfo' => 'MyTypes::ApplicationInfo',
        'ApplicationPolicyId' => 'MyTypes::ObjId',
        'ApplicationPolicyName' => 'MyTypes::ObjName',
        'ApplicationResourceNamespaces' => 'MyTypes::ArrayOfApplicationResourceNamespace',
        'CanContainApplicationResources' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'CanContainStorageResources' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
        'DatasetContact' => 'MyTypes::EmailAddressList',
        'DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetMap' => 'MyTypes::ArrayOfDatasetMapEntry',
        'DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
        'DatasetMigrationInfo' => 'MyTypes::DatasetMigrationInfo',
        'DatasetName' => 'MyTypes::ObjName',
        'DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatasetStatus' => 'MyTypes::DatasetStatus',
        'DrState' => 'MyTypes::DrState',

        'DynamicReferenceCount' => 'MyTypes::DatasetInfo::_DynamicReferenceCount',
        'HasProtection' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'HasProtectionPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsAllowCustomSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsEnableWriteGuaranteeChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsVfilerCreatedForMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MaximumLunsPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MaximumQtreesPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'MemberCount' => 'MyTypes::DatasetInfo::_MemberCount',
        'OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'PrimaryVolumeNameFormat' => 'MyTypes::PrimaryVolumeNameFormat',
        'ProtectionPolicyId' => 'MyTypes::ObjId',
        'ProtectionPolicyName' => 'MyTypes::ObjName',
        'ProvisioningPolicyId' => 'MyTypes::ObjId',
        'ProvisioningPolicyName' => 'MyTypes::ObjName',
        'RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
        'ResourcepoolId' => 'MyTypes::ObjId',
        'ResourcepoolName' => 'MyTypes::ObjName',
        'Resourcepools' => 'MyTypes::ArrayOfDatasetResourcepoolInfo',
        'SecondaryQtreeNameFormat' => 'MyTypes::SecondaryQtreeNameFormat',
        'SecondaryVolumeNameFormat' => 'MyTypes::SecondaryVolumeNameFormat',
        'SnapshotNameFormat' => 'MyTypes::SnapshotNameFormat',
        'StorageServiceId' => 'MyTypes::ObjId',
        'StorageServiceName' => 'MyTypes::ObjName',
        'StoragesetId' => 'MyTypes::ObjId',
        'StoragesetName' => 'MyTypes::ObjName',
        'StoragesetTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerId' => 'MyTypes::ObjId',
        'VfilerName' => 'MyTypes::ObjFullName',
        'VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplicationInfo' => 'ApplicationInfo',
        'ApplicationPolicyId' => 'ApplicationPolicyId',
        'ApplicationPolicyName' => 'ApplicationPolicyName',
        'ApplicationResourceNamespaces' => 'ApplicationResourceNamespaces',
        'CanContainApplicationResources' => 'CanContainApplicationResources',
        'CanContainStorageResources' => 'CanContainStorageResources',
        'DatasetAccessDetails' => 'DatasetAccessDetails',
        'DatasetContact' => 'DatasetContact',
        'DatasetDescription' => 'DatasetDescription',
        'DatasetExportInfo' => 'DatasetExportInfo',
        'DatasetId' => 'DatasetId',
        'DatasetMap' => 'DatasetMap',
        'DatasetMetadata' => 'DatasetMetadata',
        'DatasetMigrationInfo' => 'DatasetMigrationInfo',
        'DatasetName' => 'DatasetName',
        'DatasetOwner' => 'DatasetOwner',
        'DatasetStatus' => 'DatasetStatus',
        'DrState' => 'DrState',
        'DynamicReferenceCount' => 'DynamicReferenceCount',
        'HasProtection' => 'HasProtection',
        'HasProtectionPolicy' => 'HasProtectionPolicy',
        'IsAllowCustomSettings' => 'IsAllowCustomSettings',
        'IsApplicationData' => 'IsApplicationData',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsDpSuspended' => 'IsDpSuspended',
        'IsDrCapable' => 'IsDrCapable',
        'IsEnableWriteGuaranteeChecks' => 'IsEnableWriteGuaranteeChecks',
        'IsProtected' => 'IsProtected',
        'IsSuspended' => 'IsSuspended',
        'IsVfilerCreatedForMigration' => 'IsVfilerCreatedForMigration',
        'MaximumLunsPerVolume' => 'MaximumLunsPerVolume',
        'MaximumQtreesPerVolume' => 'MaximumQtreesPerVolume',
        'MemberCount' => 'MemberCount',
        'OnlineMigration' => 'OnlineMigration',
        'PrimaryVolumeNameFormat' => 'PrimaryVolumeNameFormat',
        'ProtectionPolicyId' => 'ProtectionPolicyId',
        'ProtectionPolicyName' => 'ProtectionPolicyName',
        'ProvisioningPolicyId' => 'ProvisioningPolicyId',
        'ProvisioningPolicyName' => 'ProvisioningPolicyName',
        'RequiresNonDisruptiveRestore' => 'RequiresNonDisruptiveRestore',
        'ResourcepoolId' => 'ResourcepoolId',
        'ResourcepoolName' => 'ResourcepoolName',
        'Resourcepools' => 'Resourcepools',
        'SecondaryQtreeNameFormat' => 'SecondaryQtreeNameFormat',
        'SecondaryVolumeNameFormat' => 'SecondaryVolumeNameFormat',
        'SnapshotNameFormat' => 'SnapshotNameFormat',
        'StorageServiceId' => 'StorageServiceId',
        'StorageServiceName' => 'StorageServiceName',
        'StoragesetId' => 'StoragesetId',
        'StoragesetName' => 'StoragesetName',
        'StoragesetTimezone' => 'StoragesetTimezone',
        'VfilerId' => 'VfilerId',
        'VfilerName' => 'VfilerName',
        'VolumeQtreeNamePrefix' => 'VolumeQtreeNamePrefix',
    }
);

} # end BLOCK




package MyTypes::DatasetInfo::_DynamicReferenceCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DatasetInfo::_MemberCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DatasetInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetInfo from the namespace http://www.netapp.com/management/v1.

Information about a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationInfo


=item * ApplicationPolicyId


=item * ApplicationPolicyName


=item * ApplicationResourceNamespaces


=item * CanContainApplicationResources


=item * CanContainStorageResources


=item * DatasetAccessDetails


=item * DatasetContact


=item * DatasetDescription


=item * DatasetExportInfo


=item * DatasetId


=item * DatasetMap


=item * DatasetMetadata


=item * DatasetMigrationInfo


=item * DatasetName


=item * DatasetOwner


=item * DatasetStatus


=item * DrState


=item * DynamicReferenceCount


=item * HasProtection


=item * HasProtectionPolicy


=item * IsAllowCustomSettings


=item * IsApplicationData


=item * IsDpIgnored


=item * IsDpSuspended


=item * IsDrCapable


=item * IsEnableWriteGuaranteeChecks


=item * IsProtected


=item * IsSuspended


=item * IsVfilerCreatedForMigration


=item * MaximumLunsPerVolume


=item * MaximumQtreesPerVolume


=item * MemberCount


=item * OnlineMigration


=item * PrimaryVolumeNameFormat


=item * ProtectionPolicyId


=item * ProtectionPolicyName


=item * ProvisioningPolicyId


=item * ProvisioningPolicyName


=item * RequiresNonDisruptiveRestore


=item * ResourcepoolId


=item * ResourcepoolName


=item * Resourcepools


=item * SecondaryQtreeNameFormat


=item * SecondaryVolumeNameFormat


=item * SnapshotNameFormat


=item * StorageServiceId


=item * StorageServiceName


=item * StoragesetId


=item * StoragesetName


=item * StoragesetTimezone


=item * VfilerId


=item * VfilerName


=item * VolumeQtreeNamePrefix




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetInfo
   ApplicationInfo =>  { # MyTypes::ApplicationInfo
     ApplicationName =>  $some_value, # string
     ApplicationServerName =>  $some_value, # string
     ApplicationVersion =>  $some_value, # string
     CarryPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
     IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
   },
   ApplicationPolicyId => $some_value, # ObjId
   ApplicationPolicyName => $some_value, # ObjName
   ApplicationResourceNamespaces =>  { # MyTypes::ArrayOfApplicationResourceNamespace
     ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   },
   CanContainApplicationResources =>  $some_value, # boolean
   CanContainStorageResources =>  $some_value, # boolean
   DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
     IpAddress =>  $some_value, # string
     Netmask =>  $some_value, # string
   },
   DatasetContact => $some_value, # EmailAddressList
   DatasetDescription =>  $some_value, # string
   DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
     DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
       CifsDomain =>  $some_value, # string
       DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
         DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission => $some_value, # CifsPermission
         },
       },
     },
     DatasetExportProtocol => $some_value, # DatasetExportProtocol
     DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
       IgroupOsType =>  $some_value, # string
       LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
     },
     DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsProtocolVersion =>  $some_value, # string
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
   },
   DatasetId => $some_value, # ObjId
   DatasetMap =>  { # MyTypes::ArrayOfDatasetMapEntry
     DatasetMapEntry =>  { # MyTypes::DatasetMapEntry
       DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
         IpAddress =>  $some_value, # string
         Netmask =>  $some_value, # string
       },
       DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
         DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
           CifsDomain =>  $some_value, # string
           DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
             DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
               CifsUsername =>  $some_value, # string
               Permission => $some_value, # CifsPermission
             },
           },
         },
         DatasetExportProtocol => $some_value, # DatasetExportProtocol
         DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
           IgroupOsType =>  $some_value, # string
           LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
             LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
               Hostname =>  $some_value, # string
               InitiatorId => $some_value, # InitiatorId
             },
           },
         },
         DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
           AnonymousAccessUser => $some_value, # atomic
           DisableSetuid =>  $some_value, # boolean
           IsReadonlyForAllHosts =>  $some_value, # boolean
           IsReadwriteForAllHosts =>  $some_value, # boolean
           NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsProtocolVersion =>  $some_value, # string
           NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
             NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
           },
         },
       },
       DpNodeId => $some_value, # atomic
       DpNodeName => $some_value, # DpPolicyNodeName
       IsDrCapable =>  $some_value, # boolean
       IsVfilerCreatedForMigration =>  $some_value, # boolean
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjName
       ResourcepoolId => $some_value, # ObjId
       ResourcepoolName => $some_value, # ObjName
       Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
         DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
           ResourcepoolId => $some_value, # ObjId
           ResourcepoolName => $some_value, # ObjName
         },
       },
       StoragesetId => $some_value, # ObjId
       StoragesetName => $some_value, # ObjName
       StoragesetTimezone =>  $some_value, # string
       VfilerId => $some_value, # ObjId
       VfilerName => $some_value, # ObjFullName
     },
   },
   DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
     DfmMetadataField =>  { # MyTypes::DfmMetadataField
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   DatasetMigrationInfo =>  { # MyTypes::DatasetMigrationInfo
     Description =>  $some_value, # string
     DestinationFilerId => $some_value, # ObjId
     DestinationFilerName => $some_value, # ObjFullName
     DestinationVfilerId => $some_value, # ObjId
     DestinationVfilerName => $some_value, # ObjFullName
     MigrationStatus => $some_value, # MigrationStatus
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjFullName
     SourceFilerId => $some_value, # ObjId
     SourceFilerName => $some_value, # ObjFullName
     SourceVfilerId => $some_value, # ObjId
     SourceVfilerName => $some_value, # ObjFullName
   },
   DatasetName => $some_value, # ObjName
   DatasetOwner =>  $some_value, # string
   DatasetStatus =>  { # MyTypes::DatasetStatus
     ConformanceCheckResults =>  { # MyTypes::ArrayOfConformanceRunResult
       ConformanceRunResult =>  { # MyTypes::ConformanceRunResult
         ConformanceJobId => $some_value, # ObjId
         ConformanceRunAction =>  $some_value, # string
         ConformanceRunEffect =>  $some_value, # string
         ConformanceRunReason =>  $some_value, # string
         ConformanceRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
           ResultDetail =>  { # MyTypes::ResultDetail
             Action =>  $some_value, # string
             Effect =>  $some_value, # string
             Reason =>  $some_value, # string
             Severity => $some_value, # ObjStatus
             Suggestion =>  $some_value, # string
           },
         },
         ConformanceRunSeverity => $some_value, # ObjStatus
         ConformanceRunSuggestion =>  $some_value, # string
       },
     },
     ConformanceStatus =>  $some_value, # string
     DrProtectionStatus =>  $some_value, # string
     DrStatus => $some_value, # DrStatus
     DrStatusProblems =>  { # MyTypes::ArrayOfDrStatusProblem
       DrStatusProblem =>  { # MyTypes::DrStatusProblem
         DrStatusDescription =>  $some_value, # string
         DrStatusSeverity =>  $some_value, # string
       },
     },
     PerformanceStatus => $some_value, # ObjStatus
     ProtectionStatus =>  $some_value, # string
     ProtectionStatusProblems =>  { # MyTypes::ArrayOfProtectionStatusProblem
       ProtectionStatusProblem =>  { # MyTypes::ProtectionStatusProblem
         ProtectionStatusDescription =>  $some_value, # string
         ProtectionStatusJobDetails =>  { # MyTypes::ArrayOfProtectionStatusJobDetail
           ProtectionStatusJobDetail =>  { # MyTypes::ProtectionStatusJobDetail
             ProtectionStatusJobDescription =>  $some_value, # string
             ProtectionStatusJobId => $some_value, # atomic
             ProtectionStatusJobStatus => $some_value, # DpJobOverallStatus
             ProtectionStatusJobType => $some_value, # DpJobType
           },
         },
         ProtectionStatusName =>  $some_value, # string
       },
     },
     ResourceStatus => $some_value, # ObjStatus
     SpaceStatus => $some_value, # SpaceStatus
   },
   DrState => $some_value, # DrState
   DynamicReferenceCount => $some_value, # atomic
   HasProtection =>  $some_value, # boolean
   HasProtectionPolicy =>  $some_value, # boolean
   IsAllowCustomSettings =>  $some_value, # boolean
   IsApplicationData =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsDpSuspended =>  $some_value, # boolean
   IsDrCapable =>  $some_value, # boolean
   IsEnableWriteGuaranteeChecks =>  $some_value, # boolean
   IsProtected =>  $some_value, # boolean
   IsSuspended =>  $some_value, # boolean
   IsVfilerCreatedForMigration =>  $some_value, # boolean
   MaximumLunsPerVolume =>  $some_value, # integer
   MaximumQtreesPerVolume =>  $some_value, # integer
   MemberCount => $some_value, # atomic
   OnlineMigration =>  $some_value, # boolean
   PrimaryVolumeNameFormat => $some_value, # PrimaryVolumeNameFormat
   ProtectionPolicyId => $some_value, # ObjId
   ProtectionPolicyName => $some_value, # ObjName
   ProvisioningPolicyId => $some_value, # ObjId
   ProvisioningPolicyName => $some_value, # ObjName
   RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
   ResourcepoolId => $some_value, # ObjId
   ResourcepoolName => $some_value, # ObjName
   Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
     DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
       ResourcepoolId => $some_value, # ObjId
       ResourcepoolName => $some_value, # ObjName
     },
   },
   SecondaryQtreeNameFormat => $some_value, # SecondaryQtreeNameFormat
   SecondaryVolumeNameFormat => $some_value, # SecondaryVolumeNameFormat
   SnapshotNameFormat => $some_value, # SnapshotNameFormat
   StorageServiceId => $some_value, # ObjId
   StorageServiceName => $some_value, # ObjName
   StoragesetId => $some_value, # ObjId
   StoragesetName => $some_value, # ObjName
   StoragesetTimezone =>  $some_value, # string
   VfilerId => $some_value, # ObjId
   VfilerName => $some_value, # ObjFullName
   VolumeQtreeNamePrefix =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

