package MyTypes::DatasetIoMetricInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetNode_of :ATTR(:get<DatasetNode>);
my %IoMeasurement_of :ATTR(:get<IoMeasurement>);
my %IsIoDataPartial_of :ATTR(:get<IsIoDataPartial>);
my %IsOvercharge_of :ATTR(:get<IsOvercharge>);
my %Timestamp_of :ATTR(:get<Timestamp>);

__PACKAGE__->_factory(
    [ qw(        DatasetNode
        IoMeasurement
        IsIoDataPartial
        IsOvercharge
        Timestamp

    ) ],
    {
        'DatasetNode' => \%DatasetNode_of,
        'IoMeasurement' => \%IoMeasurement_of,
        'IsIoDataPartial' => \%IsIoDataPartial_of,
        'IsOvercharge' => \%IsOvercharge_of,
        'Timestamp' => \%Timestamp_of,
    },
    {
        'DatasetNode' => 'MyTypes::WrapperOfMetricDatasetNodeInfo',
        'IoMeasurement' => 'MyTypes::IoMeasurement',
        'IsIoDataPartial' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsOvercharge' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Timestamp' => 'MyTypes::DpTimestamp',
    },
    {

        'DatasetNode' => 'DatasetNode',
        'IoMeasurement' => 'IoMeasurement',
        'IsIoDataPartial' => 'IsIoDataPartial',
        'IsOvercharge' => 'IsOvercharge',
        'Timestamp' => 'Timestamp',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetIoMetricInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetIoMetricInfo from the namespace http://www.netapp.com/management/v1.

A single I/O usage measurement record for a Dataset node.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetNode


=item * IoMeasurement


=item * IsIoDataPartial


=item * IsOvercharge


=item * Timestamp




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetIoMetricInfo
   DatasetNode =>  { # MyTypes::WrapperOfMetricDatasetNodeInfo
     MetricDatasetNodeInfo =>  { # MyTypes::MetricDatasetNodeInfo
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DeletedTimestamp => $some_value, # DpTimestamp
       DpNodeName => $some_value, # DpPolicyNodeName
       ProtectionPolicyName => $some_value, # ObjName
       ProvisioningPolicyName => $some_value, # ObjName
       StorageServiceName => $some_value, # ObjName
     },
   },
   IoMeasurement =>  { # MyTypes::IoMeasurement
     DataRead => $some_value, # atomic
     DataWritten => $some_value, # atomic
   },
   IsIoDataPartial =>  $some_value, # boolean
   IsOvercharge =>  $some_value, # boolean
   Timestamp => $some_value, # DpTimestamp
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

