package MyTypes::DatasetLunMappingInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IgroupOsType_of :ATTR(:get<IgroupOsType>);
my %LunMappingInitiators_of :ATTR(:get<LunMappingInitiators>);

__PACKAGE__->_factory(
    [ qw(        IgroupOsType
        LunMappingInitiators

    ) ],
    {
        'IgroupOsType' => \%IgroupOsType_of,
        'LunMappingInitiators' => \%LunMappingInitiators_of,
    },
    {
        'IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
    },
    {

        'IgroupOsType' => 'IgroupOsType',
        'LunMappingInitiators' => 'LunMappingInitiators',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetLunMappingInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetLunMappingInfo from the namespace http://www.netapp.com/management/v1.

Specifies the Hosts and/or Initiators To which LUNs in this Dataset node will be mapped, and the igroup OS Type.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IgroupOsType


=item * LunMappingInitiators




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetLunMappingInfo
   IgroupOsType =>  $some_value, # string
   LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
     LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
       Hostname =>  $some_value, # string
       InitiatorId => $some_value, # InitiatorId
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

