package MyTypes::DatasetMapEntry;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetAccessDetails_of :ATTR(:get<DatasetAccessDetails>);
my %DatasetExportInfo_of :ATTR(:get<DatasetExportInfo>);
my %DpNodeId_of :ATTR(:get<DpNodeId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IsDrCapable_of :ATTR(:get<IsDrCapable>);
my %IsVfilerCreatedForMigration_of :ATTR(:get<IsVfilerCreatedForMigration>);
my %ProvisioningPolicyId_of :ATTR(:get<ProvisioningPolicyId>);
my %ProvisioningPolicyName_of :ATTR(:get<ProvisioningPolicyName>);
my %ResourcepoolId_of :ATTR(:get<ResourcepoolId>);
my %ResourcepoolName_of :ATTR(:get<ResourcepoolName>);
my %Resourcepools_of :ATTR(:get<Resourcepools>);
my %StoragesetId_of :ATTR(:get<StoragesetId>);
my %StoragesetName_of :ATTR(:get<StoragesetName>);
my %StoragesetTimezone_of :ATTR(:get<StoragesetTimezone>);
my %VfilerId_of :ATTR(:get<VfilerId>);
my %VfilerName_of :ATTR(:get<VfilerName>);

__PACKAGE__->_factory(
    [ qw(        DatasetAccessDetails
        DatasetExportInfo
        DpNodeId
        DpNodeName
        IsDrCapable
        IsVfilerCreatedForMigration
        ProvisioningPolicyId
        ProvisioningPolicyName
        ResourcepoolId
        ResourcepoolName
        Resourcepools
        StoragesetId
        StoragesetName
        StoragesetTimezone
        VfilerId
        VfilerName

    ) ],
    {
        'DatasetAccessDetails' => \%DatasetAccessDetails_of,
        'DatasetExportInfo' => \%DatasetExportInfo_of,
        'DpNodeId' => \%DpNodeId_of,
        'DpNodeName' => \%DpNodeName_of,
        'IsDrCapable' => \%IsDrCapable_of,
        'IsVfilerCreatedForMigration' => \%IsVfilerCreatedForMigration_of,
        'ProvisioningPolicyId' => \%ProvisioningPolicyId_of,
        'ProvisioningPolicyName' => \%ProvisioningPolicyName_of,
        'ResourcepoolId' => \%ResourcepoolId_of,
        'ResourcepoolName' => \%ResourcepoolName_of,
        'Resourcepools' => \%Resourcepools_of,
        'StoragesetId' => \%StoragesetId_of,
        'StoragesetName' => \%StoragesetName_of,
        'StoragesetTimezone' => \%StoragesetTimezone_of,
        'VfilerId' => \%VfilerId_of,
        'VfilerName' => \%VfilerName_of,
    },
    {
        'DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
        'DatasetExportInfo' => 'MyTypes::DatasetExportInfo',

        'DpNodeId' => 'MyTypes::DatasetMapEntry::_DpNodeId',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsVfilerCreatedForMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProvisioningPolicyId' => 'MyTypes::ObjId',
        'ProvisioningPolicyName' => 'MyTypes::ObjName',
        'ResourcepoolId' => 'MyTypes::ObjId',
        'ResourcepoolName' => 'MyTypes::ObjName',
        'Resourcepools' => 'MyTypes::ArrayOfDatasetResourcepoolInfo',
        'StoragesetId' => 'MyTypes::ObjId',
        'StoragesetName' => 'MyTypes::ObjName',
        'StoragesetTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerId' => 'MyTypes::ObjId',
        'VfilerName' => 'MyTypes::ObjFullName',
    },
    {

        'DatasetAccessDetails' => 'DatasetAccessDetails',
        'DatasetExportInfo' => 'DatasetExportInfo',
        'DpNodeId' => 'DpNodeId',
        'DpNodeName' => 'DpNodeName',
        'IsDrCapable' => 'IsDrCapable',
        'IsVfilerCreatedForMigration' => 'IsVfilerCreatedForMigration',
        'ProvisioningPolicyId' => 'ProvisioningPolicyId',
        'ProvisioningPolicyName' => 'ProvisioningPolicyName',
        'ResourcepoolId' => 'ResourcepoolId',
        'ResourcepoolName' => 'ResourcepoolName',
        'Resourcepools' => 'Resourcepools',
        'StoragesetId' => 'StoragesetId',
        'StoragesetName' => 'StoragesetName',
        'StoragesetTimezone' => 'StoragesetTimezone',
        'VfilerId' => 'VfilerId',
        'VfilerName' => 'VfilerName',
    }
);

} # end BLOCK




package MyTypes::DatasetMapEntry::_DpNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DatasetMapEntry

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetMapEntry from the namespace http://www.netapp.com/management/v1.

Map a storage set To a Policy node. The root node is not included in the map.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetAccessDetails


=item * DatasetExportInfo


=item * DpNodeId


=item * DpNodeName


=item * IsDrCapable


=item * IsVfilerCreatedForMigration


=item * ProvisioningPolicyId


=item * ProvisioningPolicyName


=item * ResourcepoolId


=item * ResourcepoolName


=item * Resourcepools


=item * StoragesetId


=item * StoragesetName


=item * StoragesetTimezone


=item * VfilerId


=item * VfilerName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetMapEntry
   DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
     IpAddress =>  $some_value, # string
     Netmask =>  $some_value, # string
   },
   DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
     DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
       CifsDomain =>  $some_value, # string
       DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
         DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission => $some_value, # CifsPermission
         },
       },
     },
     DatasetExportProtocol => $some_value, # DatasetExportProtocol
     DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
       IgroupOsType =>  $some_value, # string
       LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
     },
     DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsProtocolVersion =>  $some_value, # string
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
   },
   DpNodeId => $some_value, # atomic
   DpNodeName => $some_value, # DpPolicyNodeName
   IsDrCapable =>  $some_value, # boolean
   IsVfilerCreatedForMigration =>  $some_value, # boolean
   ProvisioningPolicyId => $some_value, # ObjId
   ProvisioningPolicyName => $some_value, # ObjName
   ResourcepoolId => $some_value, # ObjId
   ResourcepoolName => $some_value, # ObjName
   Resourcepools =>  { # MyTypes::ArrayOfDatasetResourcepoolInfo
     DatasetResourcepoolInfo =>  { # MyTypes::DatasetResourcepoolInfo
       ResourcepoolId => $some_value, # ObjId
       ResourcepoolName => $some_value, # ObjName
     },
   },
   StoragesetId => $some_value, # ObjId
   StoragesetName => $some_value, # ObjName
   StoragesetTimezone =>  $some_value, # string
   VfilerId => $some_value, # ObjId
   VfilerName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

