package MyTypes::DatasetMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsShareNames_of :ATTR(:get<CifsShareNames>);
my %CifsSharesInfo_of :ATTR(:get<CifsSharesInfo>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsDeleted_of :ATTR(:get<IsDeleted>);
my %LunIgroupsInfo_of :ATTR(:get<LunIgroupsInfo>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %MemberPerfStatus_of :ATTR(:get<MemberPerfStatus>);
my %MemberStatus_of :ATTR(:get<MemberStatus>);
my %MemberType_of :ATTR(:get<MemberType>);
my %NfsExportName_of :ATTR(:get<NfsExportName>);
my %NfsExportRules_of :ATTR(:get<NfsExportRules>);
my %SpaceInfo_of :ATTR(:get<SpaceInfo>);
my %StoragesetId_of :ATTR(:get<StoragesetId>);
my %StoragesetName_of :ATTR(:get<StoragesetName>);

__PACKAGE__->_factory(
    [ qw(        CifsShareNames
        CifsSharesInfo
        DpNodeName
        IsAvailable
        IsDeleted
        LunIgroupsInfo
        MemberId
        MemberName
        MemberPerfStatus
        MemberStatus
        MemberType
        NfsExportName
        NfsExportRules
        SpaceInfo
        StoragesetId
        StoragesetName

    ) ],
    {
        'CifsShareNames' => \%CifsShareNames_of,
        'CifsSharesInfo' => \%CifsSharesInfo_of,
        'DpNodeName' => \%DpNodeName_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsDeleted' => \%IsDeleted_of,
        'LunIgroupsInfo' => \%LunIgroupsInfo_of,
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'MemberPerfStatus' => \%MemberPerfStatus_of,
        'MemberStatus' => \%MemberStatus_of,
        'MemberType' => \%MemberType_of,
        'NfsExportName' => \%NfsExportName_of,
        'NfsExportRules' => \%NfsExportRules_of,
        'SpaceInfo' => \%SpaceInfo_of,
        'StoragesetId' => \%StoragesetId_of,
        'StoragesetName' => \%StoragesetName_of,
    },
    {
        'CifsShareNames' => 'MyTypes::ArrayOfCifsShareName',
        'CifsSharesInfo' => 'MyTypes::ArrayOfCifsShareInfo',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LunIgroupsInfo' => 'MyTypes::ArrayOfLunIgroupInfo',
        'MemberId' => 'MyTypes::ObjId',
        'MemberName' => 'MyTypes::ObjName',
        'MemberPerfStatus' => 'MyTypes::ObjStatus',
        'MemberStatus' => 'MyTypes::ObjStatus',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NfsExportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NfsExportRules' => 'MyTypes::NfsExportRules',
        'SpaceInfo' => 'MyTypes::SpaceInfo',
        'StoragesetId' => 'MyTypes::ObjId',
        'StoragesetName' => 'MyTypes::ObjName',
    },
    {

        'CifsShareNames' => 'CifsShareNames',
        'CifsSharesInfo' => 'CifsSharesInfo',
        'DpNodeName' => 'DpNodeName',
        'IsAvailable' => 'IsAvailable',
        'IsDeleted' => 'IsDeleted',
        'LunIgroupsInfo' => 'LunIgroupsInfo',
        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'MemberPerfStatus' => 'MemberPerfStatus',
        'MemberStatus' => 'MemberStatus',
        'MemberType' => 'MemberType',
        'NfsExportName' => 'NfsExportName',
        'NfsExportRules' => 'NfsExportRules',
        'SpaceInfo' => 'SpaceInfo',
        'StoragesetId' => 'StoragesetId',
        'StoragesetName' => 'StoragesetName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetMemberInfo from the namespace http://www.netapp.com/management/v1.

Information about one member of a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsShareNames


=item * CifsSharesInfo


=item * DpNodeName


=item * IsAvailable


=item * IsDeleted


=item * LunIgroupsInfo


=item * MemberId


=item * MemberName


=item * MemberPerfStatus


=item * MemberStatus


=item * MemberType


=item * NfsExportName


=item * NfsExportRules


=item * SpaceInfo


=item * StoragesetId


=item * StoragesetName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetMemberInfo
   CifsShareNames =>  { # MyTypes::ArrayOfCifsShareName
     CifsShareName => $some_value, # CifsShareName
   },
   CifsSharesInfo =>  { # MyTypes::ArrayOfCifsShareInfo
     CifsShareInfo =>  { # MyTypes::CifsShareInfo
       CifsShareName => $some_value, # CifsShareName
       CifsSharePermissions =>  { # MyTypes::ArrayOfCifsSharePermission
         CifsSharePermission =>  { # MyTypes::CifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission =>  $some_value, # string
         },
       },
     },
   },
   DpNodeName => $some_value, # DpPolicyNodeName
   IsAvailable =>  $some_value, # boolean
   IsDeleted =>  $some_value, # boolean
   LunIgroupsInfo =>  { # MyTypes::ArrayOfLunIgroupInfo
     LunIgroupInfo =>  { # MyTypes::LunIgroupInfo
       IgroupInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
       IgroupLunId => $some_value, # atomic
       IgroupName => $some_value, # ObjName
       IgroupOsType =>  $some_value, # string
       IgroupProtocol =>  $some_value, # string
     },
   },
   MemberId => $some_value, # ObjId
   MemberName => $some_value, # ObjName
   MemberPerfStatus => $some_value, # ObjStatus
   MemberStatus => $some_value, # ObjStatus
   MemberType =>  $some_value, # string
   NfsExportName =>  $some_value, # string
   NfsExportRules =>  { # MyTypes::NfsExportRules
     AnonymousAccessUser => $some_value, # atomic
     DisableSetuid =>  $some_value, # boolean
     IsReadonlyForAllHosts =>  $some_value, # boolean
     IsReadwriteForAllHosts =>  $some_value, # boolean
     NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
       NfsExportHost =>  { # MyTypes::NfsExportHost
         Hostname =>  $some_value, # string
         IsAnException =>  $some_value, # boolean
       },
     },
     NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
       NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
     },
   },
   SpaceInfo =>  { # MyTypes::SpaceInfo
     AvailableSpace => $some_value, # atomic
     SpaceConditions =>  { # MyTypes::ArrayOfSpaceCondition
       SpaceCondition =>  { # MyTypes::SpaceCondition
         Condition =>  $some_value, # string
         Reason =>  $some_value, # string
         Severity =>  $some_value, # string
         Suggestion =>  $some_value, # string
       },
     },
     SpaceStatus => $some_value, # SpaceStatus
     TotalSpace => $some_value, # atomic
     UsedSpace => $some_value, # atomic
   },
   StoragesetId => $some_value, # ObjId
   StoragesetName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

