package MyTypes::DatasetMemberParameter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);

__PACKAGE__->_factory(
    [ qw(        DpNodeName
        ObjectNameOrId

    ) ],
    {
        'DpNodeName' => \%DpNodeName_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
    },
    {
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'DpNodeName' => 'DpNodeName',
        'ObjectNameOrId' => 'ObjectNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetMemberParameter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetMemberParameter from the namespace http://www.netapp.com/management/v1.

Information about one member of a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpNodeName


=item * ObjectNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetMemberParameter
   DpNodeName => $some_value, # DpPolicyNodeName
   ObjectNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

