package MyTypes::DatasetNodeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DpNodeId_of :ATTR(:get<DpNodeId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IsDpNodeEffectivePrimary_of :ATTR(:get<IsDpNodeEffectivePrimary>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        DpNodeId
        DpNodeName
        IsDpNodeEffectivePrimary

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DpNodeId' => \%DpNodeId_of,
        'DpNodeName' => \%DpNodeName_of,
        'IsDpNodeEffectivePrimary' => \%IsDpNodeEffectivePrimary_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',

        'DpNodeId' => 'MyTypes::DatasetNodeInfo::_DpNodeId',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'IsDpNodeEffectivePrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DpNodeId' => 'DpNodeId',
        'DpNodeName' => 'DpNodeName',
        'IsDpNodeEffectivePrimary' => 'IsDpNodeEffectivePrimary',
    }
);

} # end BLOCK




package MyTypes::DatasetNodeInfo::_DpNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DatasetNodeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetNodeInfo from the namespace http://www.netapp.com/management/v1.

Information about a Dataset node.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * DpNodeId


=item * DpNodeName


=item * IsDpNodeEffectivePrimary




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetNodeInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   DpNodeId => $some_value, # atomic
   DpNodeName => $some_value, # DpPolicyNodeName
   IsDpNodeEffectivePrimary =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

