package MyTypes::DatasetResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
    },
    {
        'DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetResource from the namespace http://www.netapp.com/management/v1.

Details of a DFM Dataset Resource. DFM Dataset Name or object Id of a DFM Dataset. When used as input only one of DatasetName or DatasetId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetResource
   DatasetId =>  $some_value, # unsignedInt
   DatasetName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

