package MyTypes::DatasetSpaceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DpNodeId_of :ATTR(:get<DpNodeId>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %IsCapableOfMigration_of :ATTR(:get<IsCapableOfMigration>);
my %IsDpNodeEffectivePrimary_of :ATTR(:get<IsDpNodeEffectivePrimary>);
my %UsedSpace_of :ATTR(:get<UsedSpace>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        DpNodeId
        DpNodeName
        IsCapableOfMigration
        IsDpNodeEffectivePrimary
        UsedSpace

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DpNodeId' => \%DpNodeId_of,
        'DpNodeName' => \%DpNodeName_of,
        'IsCapableOfMigration' => \%IsCapableOfMigration_of,
        'IsDpNodeEffectivePrimary' => \%IsDpNodeEffectivePrimary_of,
        'UsedSpace' => \%UsedSpace_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',

        'DpNodeId' => 'MyTypes::DatasetSpaceInfo::_DpNodeId',
        'DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsCapableOfMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpNodeEffectivePrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'UsedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DpNodeId' => 'DpNodeId',
        'DpNodeName' => 'DpNodeName',
        'IsCapableOfMigration' => 'IsCapableOfMigration',
        'IsDpNodeEffectivePrimary' => 'IsDpNodeEffectivePrimary',
        'UsedSpace' => 'UsedSpace',
    }
);

} # end BLOCK




package MyTypes::DatasetSpaceInfo::_DpNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DatasetSpaceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetSpaceInfo from the namespace http://www.netapp.com/management/v1.

Information about a datset consuming space From the Aggregate.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * DpNodeId


=item * DpNodeName


=item * IsCapableOfMigration


=item * IsDpNodeEffectivePrimary


=item * UsedSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetSpaceInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   DpNodeId => $some_value, # atomic
   DpNodeName =>  $some_value, # string
   IsCapableOfMigration =>  $some_value, # boolean
   IsDpNodeEffectivePrimary =>  $some_value, # boolean
   UsedSpace =>  $some_value, # unsignedLong
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

