package MyTypes::DatasetSpaceMetricInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AvgSpaceMeasurement_of :ATTR(:get<AvgSpaceMeasurement>);
my %DatasetNode_of :ATTR(:get<DatasetNode>);
my %IsOvercharge_of :ATTR(:get<IsOvercharge>);
my %IsSpaceDataPartial_of :ATTR(:get<IsSpaceDataPartial>);
my %MaxSpaceMeasurement_of :ATTR(:get<MaxSpaceMeasurement>);
my %Timestamp_of :ATTR(:get<Timestamp>);

__PACKAGE__->_factory(
    [ qw(        AvgSpaceMeasurement
        DatasetNode
        IsOvercharge
        IsSpaceDataPartial
        MaxSpaceMeasurement
        Timestamp

    ) ],
    {
        'AvgSpaceMeasurement' => \%AvgSpaceMeasurement_of,
        'DatasetNode' => \%DatasetNode_of,
        'IsOvercharge' => \%IsOvercharge_of,
        'IsSpaceDataPartial' => \%IsSpaceDataPartial_of,
        'MaxSpaceMeasurement' => \%MaxSpaceMeasurement_of,
        'Timestamp' => \%Timestamp_of,
    },
    {
        'AvgSpaceMeasurement' => 'MyTypes::WrapperOfSpaceMeasurement',
        'DatasetNode' => 'MyTypes::WrapperOfMetricDatasetNodeInfo',
        'IsOvercharge' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSpaceDataPartial' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MaxSpaceMeasurement' => 'MyTypes::WrapperOfSpaceMeasurement',
        'Timestamp' => 'MyTypes::DpTimestamp',
    },
    {

        'AvgSpaceMeasurement' => 'AvgSpaceMeasurement',
        'DatasetNode' => 'DatasetNode',
        'IsOvercharge' => 'IsOvercharge',
        'IsSpaceDataPartial' => 'IsSpaceDataPartial',
        'MaxSpaceMeasurement' => 'MaxSpaceMeasurement',
        'Timestamp' => 'Timestamp',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetSpaceMetricInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetSpaceMetricInfo from the namespace http://www.netapp.com/management/v1.

A single space usage measurement record for a Dataset node.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AvgSpaceMeasurement


=item * DatasetNode


=item * IsOvercharge


=item * IsSpaceDataPartial


=item * MaxSpaceMeasurement


=item * Timestamp




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetSpaceMetricInfo
   AvgSpaceMeasurement =>  { # MyTypes::WrapperOfSpaceMeasurement
     SpaceMeasurement =>  { # MyTypes::SpaceMeasurement
       EffectiveUsedDataSpace => $some_value, # atomic
       GuaranteedSpace => $some_value, # atomic
       PhysicalUsedDataSpace => $some_value, # atomic
       SnapshotReserve => $some_value, # atomic
       TotalDataSpace => $some_value, # atomic
       TotalSpace => $some_value, # atomic
       UsedSnapshotSpace => $some_value, # atomic
     },
   },
   DatasetNode =>  { # MyTypes::WrapperOfMetricDatasetNodeInfo
     MetricDatasetNodeInfo =>  { # MyTypes::MetricDatasetNodeInfo
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DeletedTimestamp => $some_value, # DpTimestamp
       DpNodeName => $some_value, # DpPolicyNodeName
       ProtectionPolicyName => $some_value, # ObjName
       ProvisioningPolicyName => $some_value, # ObjName
       StorageServiceName => $some_value, # ObjName
     },
   },
   IsOvercharge =>  $some_value, # boolean
   IsSpaceDataPartial =>  $some_value, # boolean
   MaxSpaceMeasurement =>  { # MyTypes::WrapperOfSpaceMeasurement
     SpaceMeasurement =>  { # MyTypes::SpaceMeasurement
       EffectiveUsedDataSpace => $some_value, # atomic
       GuaranteedSpace => $some_value, # atomic
       PhysicalUsedDataSpace => $some_value, # atomic
       SnapshotReserve => $some_value, # atomic
       TotalDataSpace => $some_value, # atomic
       TotalSpace => $some_value, # atomic
       UsedSnapshotSpace => $some_value, # atomic
     },
   },
   Timestamp => $some_value, # DpTimestamp
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

