package MyTypes::DatasetStatus;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ConformanceCheckResults_of :ATTR(:get<ConformanceCheckResults>);
my %ConformanceStatus_of :ATTR(:get<ConformanceStatus>);
my %DrProtectionStatus_of :ATTR(:get<DrProtectionStatus>);
my %DrStatus_of :ATTR(:get<DrStatus>);
my %DrStatusProblems_of :ATTR(:get<DrStatusProblems>);
my %PerformanceStatus_of :ATTR(:get<PerformanceStatus>);
my %ProtectionStatus_of :ATTR(:get<ProtectionStatus>);
my %ProtectionStatusProblems_of :ATTR(:get<ProtectionStatusProblems>);
my %ResourceStatus_of :ATTR(:get<ResourceStatus>);
my %SpaceStatus_of :ATTR(:get<SpaceStatus>);

__PACKAGE__->_factory(
    [ qw(        ConformanceCheckResults
        ConformanceStatus
        DrProtectionStatus
        DrStatus
        DrStatusProblems
        PerformanceStatus
        ProtectionStatus
        ProtectionStatusProblems
        ResourceStatus
        SpaceStatus

    ) ],
    {
        'ConformanceCheckResults' => \%ConformanceCheckResults_of,
        'ConformanceStatus' => \%ConformanceStatus_of,
        'DrProtectionStatus' => \%DrProtectionStatus_of,
        'DrStatus' => \%DrStatus_of,
        'DrStatusProblems' => \%DrStatusProblems_of,
        'PerformanceStatus' => \%PerformanceStatus_of,
        'ProtectionStatus' => \%ProtectionStatus_of,
        'ProtectionStatusProblems' => \%ProtectionStatusProblems_of,
        'ResourceStatus' => \%ResourceStatus_of,
        'SpaceStatus' => \%SpaceStatus_of,
    },
    {
        'ConformanceCheckResults' => 'MyTypes::ArrayOfConformanceRunResult',
        'ConformanceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DrProtectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DrStatus' => 'MyTypes::DrStatus',
        'DrStatusProblems' => 'MyTypes::ArrayOfDrStatusProblem',
        'PerformanceStatus' => 'MyTypes::ObjStatus',
        'ProtectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProtectionStatusProblems' => 'MyTypes::ArrayOfProtectionStatusProblem',
        'ResourceStatus' => 'MyTypes::ObjStatus',
        'SpaceStatus' => 'MyTypes::SpaceStatus',
    },
    {

        'ConformanceCheckResults' => 'ConformanceCheckResults',
        'ConformanceStatus' => 'ConformanceStatus',
        'DrProtectionStatus' => 'DrProtectionStatus',
        'DrStatus' => 'DrStatus',
        'DrStatusProblems' => 'DrStatusProblems',
        'PerformanceStatus' => 'PerformanceStatus',
        'ProtectionStatus' => 'ProtectionStatus',
        'ProtectionStatusProblems' => 'ProtectionStatusProblems',
        'ResourceStatus' => 'ResourceStatus',
        'SpaceStatus' => 'SpaceStatus',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DatasetStatus

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DatasetStatus from the namespace http://www.netapp.com/management/v1.

The complex Status of the Dataset at the time it was last re-calculated.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ConformanceCheckResults


=item * ConformanceStatus


=item * DrProtectionStatus


=item * DrStatus


=item * DrStatusProblems


=item * PerformanceStatus


=item * ProtectionStatus


=item * ProtectionStatusProblems


=item * ResourceStatus


=item * SpaceStatus




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DatasetStatus
   ConformanceCheckResults =>  { # MyTypes::ArrayOfConformanceRunResult
     ConformanceRunResult =>  { # MyTypes::ConformanceRunResult
       ConformanceJobId => $some_value, # ObjId
       ConformanceRunAction =>  $some_value, # string
       ConformanceRunEffect =>  $some_value, # string
       ConformanceRunReason =>  $some_value, # string
       ConformanceRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
         ResultDetail =>  { # MyTypes::ResultDetail
           Action =>  $some_value, # string
           Effect =>  $some_value, # string
           Reason =>  $some_value, # string
           Severity => $some_value, # ObjStatus
           Suggestion =>  $some_value, # string
         },
       },
       ConformanceRunSeverity => $some_value, # ObjStatus
       ConformanceRunSuggestion =>  $some_value, # string
     },
   },
   ConformanceStatus =>  $some_value, # string
   DrProtectionStatus =>  $some_value, # string
   DrStatus => $some_value, # DrStatus
   DrStatusProblems =>  { # MyTypes::ArrayOfDrStatusProblem
     DrStatusProblem =>  { # MyTypes::DrStatusProblem
       DrStatusDescription =>  $some_value, # string
       DrStatusSeverity =>  $some_value, # string
     },
   },
   PerformanceStatus => $some_value, # ObjStatus
   ProtectionStatus =>  $some_value, # string
   ProtectionStatusProblems =>  { # MyTypes::ArrayOfProtectionStatusProblem
     ProtectionStatusProblem =>  { # MyTypes::ProtectionStatusProblem
       ProtectionStatusDescription =>  $some_value, # string
       ProtectionStatusJobDetails =>  { # MyTypes::ArrayOfProtectionStatusJobDetail
         ProtectionStatusJobDetail =>  { # MyTypes::ProtectionStatusJobDetail
           ProtectionStatusJobDescription =>  $some_value, # string
           ProtectionStatusJobId => $some_value, # atomic
           ProtectionStatusJobStatus => $some_value, # DpJobOverallStatus
           ProtectionStatusJobType => $some_value, # DpJobType
         },
       },
       ProtectionStatusName =>  $some_value, # string
     },
   },
   ResourceStatus => $some_value, # ObjStatus
   SpaceStatus => $some_value, # SpaceStatus
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

