package MyTypes::Datastore;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AllocatedCapacity_of :ATTR(:get<AllocatedCapacity>);
my %DatacenterReference_of :ATTR(:get<DatacenterReference>);
my %Datasets_of :ATTR(:get<Datasets>);
my %DatastoreId_of :ATTR(:get<DatastoreId>);
my %DatastoreName_of :ATTR(:get<DatastoreName>);
my %DatastoreOnOntap_of :ATTR(:get<DatastoreOnOntap>);
my %DatastoreType_of :ATTR(:get<DatastoreType>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %IsProtected_of :ATTR(:get<IsProtected>);
my %NfsExportPath_of :ATTR(:get<NfsExportPath>);
my %UsedCapacity_of :ATTR(:get<UsedCapacity>);
my %VirtualCenterReference_of :ATTR(:get<VirtualCenterReference>);

__PACKAGE__->_factory(
    [ qw(        AllocatedCapacity
        DatacenterReference
        Datasets
        DatastoreId
        DatastoreName
        DatastoreOnOntap
        DatastoreType
        DeletedBy
        DeletedTimestamp
        HostServiceId
        IsProtected
        NfsExportPath
        UsedCapacity
        VirtualCenterReference

    ) ],
    {
        'AllocatedCapacity' => \%AllocatedCapacity_of,
        'DatacenterReference' => \%DatacenterReference_of,
        'Datasets' => \%Datasets_of,
        'DatastoreId' => \%DatastoreId_of,
        'DatastoreName' => \%DatastoreName_of,
        'DatastoreOnOntap' => \%DatastoreOnOntap_of,
        'DatastoreType' => \%DatastoreType_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'HostServiceId' => \%HostServiceId_of,
        'IsProtected' => \%IsProtected_of,
        'NfsExportPath' => \%NfsExportPath_of,
        'UsedCapacity' => \%UsedCapacity_of,
        'VirtualCenterReference' => \%VirtualCenterReference_of,
    },
    {
        'AllocatedCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'DatacenterReference' => 'MyTypes::DatacenterReference',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'DatastoreId' => 'MyTypes::ObjId',
        'DatastoreName' => 'MyTypes::ObjName',
        'DatastoreOnOntap' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatastoreType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'HostServiceId' => 'MyTypes::ObjId',
        'IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NfsExportPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'UsedCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
    },
    {

        'AllocatedCapacity' => 'AllocatedCapacity',
        'DatacenterReference' => 'DatacenterReference',
        'Datasets' => 'Datasets',
        'DatastoreId' => 'DatastoreId',
        'DatastoreName' => 'DatastoreName',
        'DatastoreOnOntap' => 'DatastoreOnOntap',
        'DatastoreType' => 'DatastoreType',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'HostServiceId' => 'HostServiceId',
        'IsProtected' => 'IsProtected',
        'NfsExportPath' => 'NfsExportPath',
        'UsedCapacity' => 'UsedCapacity',
        'VirtualCenterReference' => 'VirtualCenterReference',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Datastore

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Datastore from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AllocatedCapacity


=item * DatacenterReference


=item * Datasets


=item * DatastoreId


=item * DatastoreName


=item * DatastoreOnOntap


=item * DatastoreType


=item * DeletedBy


=item * DeletedTimestamp


=item * HostServiceId


=item * IsProtected


=item * NfsExportPath


=item * UsedCapacity


=item * VirtualCenterReference




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Datastore
   AllocatedCapacity =>  $some_value, # unsignedLong
   DatacenterReference =>  { # MyTypes::DatacenterReference
     DatacenterId => $some_value, # ObjId
     DatacenterName => $some_value, # ObjName
   },
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   DatastoreId => $some_value, # ObjId
   DatastoreName => $some_value, # ObjName
   DatastoreOnOntap =>  $some_value, # boolean
   DatastoreType =>  $some_value, # string
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   HostServiceId => $some_value, # ObjId
   IsProtected =>  $some_value, # boolean
   NfsExportPath =>  $some_value, # string
   UsedCapacity =>  $some_value, # unsignedLong
   VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
     VirtualCenterId => $some_value, # ObjId
     VirtualCenterName => $some_value, # ObjName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

