package MyTypes::DeleteSnapshotsRequestInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Snapshots_of :ATTR(:get<Snapshots>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        Snapshots
        VolumeId
        VolumeName

    ) ],
    {
        'Snapshots' => \%Snapshots_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'Snapshots' => 'MyTypes::ArrayOfSnapshot',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjName',
    },
    {

        'Snapshots' => 'Snapshots',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DeleteSnapshotsRequestInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DeleteSnapshotsRequestInfo from the namespace http://www.netapp.com/management/v1.

Details on which Snapshot copies are To be deleted.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Snapshots


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DeleteSnapshotsRequestInfo
   Snapshots =>  { # MyTypes::ArrayOfSnapshot
     Snapshot =>  { # MyTypes::Snapshot
       SnapshotName =>  $some_value, # string
       UniqueId =>  $some_value, # string
     },
   },
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

