package MyTypes::DestinationHostInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ErrorReason_of :ATTR(:get<ErrorReason>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);

__PACKAGE__->_factory(
    [ qw(        ErrorReason
        HostId
        HostName

    ) ],
    {
        'ErrorReason' => \%ErrorReason_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
    },
    {
        'ErrorReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjFullName',
    },
    {

        'ErrorReason' => 'ErrorReason',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DestinationHostInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DestinationHostInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ErrorReason


=item * HostId


=item * HostName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DestinationHostInfo
   ErrorReason =>  $some_value, # string
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

