package MyTypes::DestroyMemberRequestInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %MemberType_of :ATTR(:get<MemberType>);

__PACKAGE__->_factory(
    [ qw(        MemberId
        MemberName
        MemberType

    ) ],
    {
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'MemberType' => \%MemberType_of,
    },
    {
        'MemberId' => 'MyTypes::ObjId',
        'MemberName' => 'MyTypes::ObjFullName',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'MemberType' => 'MemberType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DestroyMemberRequestInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DestroyMemberRequestInfo from the namespace http://www.netapp.com/management/v1.

Details specific To the 'destroy_member' Request.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * MemberId


=item * MemberName


=item * MemberType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DestroyMemberRequestInfo
   MemberId => $some_value, # ObjId
   MemberName => $some_value, # ObjFullName
   MemberType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

