package MyTypes::DfmDiagCounterGroup;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupName_of :ATTR(:get<GroupName>);
my %Histogram_of :ATTR(:get<Histogram>);
my %HostName_of :ATTR(:get<HostName>);
my %LastUpdated_of :ATTR(:get<LastUpdated>);

__PACKAGE__->_factory(
    [ qw(        GroupName
        Histogram
        HostName
        LastUpdated

    ) ],
    {
        'GroupName' => \%GroupName_of,
        'Histogram' => \%Histogram_of,
        'HostName' => \%HostName_of,
        'LastUpdated' => \%LastUpdated_of,
    },
    {
        'GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Histogram' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'LastUpdated' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'GroupName' => 'GroupName',
        'Histogram' => 'Histogram',
        'HostName' => 'HostName',
        'LastUpdated' => 'LastUpdated',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DfmDiagCounterGroup

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DfmDiagCounterGroup from the namespace http://www.netapp.com/management/v1.

Descriptive diagnostic information about a counter Group.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupName


=item * Histogram


=item * HostName


=item * LastUpdated




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DfmDiagCounterGroup
   GroupName =>  $some_value, # string
   Histogram =>  $some_value, # string
   HostName =>  $some_value, # string
   LastUpdated =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

