package MyTypes::DfmMetadataField;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FieldName_of :ATTR(:get<FieldName>);
my %FieldValue_of :ATTR(:get<FieldValue>);

__PACKAGE__->_factory(
    [ qw(        FieldName
        FieldValue

    ) ],
    {
        'FieldName' => \%FieldName_of,
        'FieldValue' => \%FieldValue_of,
    },
    {
        'FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'FieldName' => 'FieldName',
        'FieldValue' => 'FieldValue',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DfmMetadataField

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DfmMetadataField from the namespace http://www.netapp.com/management/v1.

Named field in the metadata.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FieldName


=item * FieldValue




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DfmMetadataField
   FieldName =>  $some_value, # string
   FieldValue =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

