package MyTypes::DirectoryInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DiskFreeSpace_of :ATTR(:get<DiskFreeSpace>);
my %DiskFreeSpacePercent_of :ATTR(:get<DiskFreeSpacePercent>);
my %FileCount_of :ATTR(:get<FileCount>);
my %Name_of :ATTR(:get<Name>);
my %Size_of :ATTR(:get<Size>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        DiskFreeSpace
        DiskFreeSpacePercent
        FileCount
        Name
        Size
        Type

    ) ],
    {
        'DiskFreeSpace' => \%DiskFreeSpace_of,
        'DiskFreeSpacePercent' => \%DiskFreeSpacePercent_of,
        'FileCount' => \%FileCount_of,
        'Name' => \%Name_of,
        'Size' => \%Size_of,
        'Type' => \%Type_of,
    },
    {

        'DiskFreeSpace' => 'MyTypes::DirectoryInfo::_DiskFreeSpace',
        'DiskFreeSpacePercent' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'FileCount' => 'MyTypes::DirectoryInfo::_FileCount',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'Size' => 'MyTypes::DirectoryInfo::_Size',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DiskFreeSpace' => 'DiskFreeSpace',
        'DiskFreeSpacePercent' => 'DiskFreeSpacePercent',
        'FileCount' => 'FileCount',
        'Name' => 'Name',
        'Size' => 'Size',
        'Type' => 'Type',
    }
);

} # end BLOCK




package MyTypes::DirectoryInfo::_DiskFreeSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DirectoryInfo::_FileCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DirectoryInfo::_Size;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DirectoryInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DirectoryInfo from the namespace http://www.netapp.com/management/v1.

Lists the information about DFM Directories. These Directories include Performance Advisor data Directory, Database Backup Directory, Data Export Directory and Reports Archival Directory.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DiskFreeSpace


=item * DiskFreeSpacePercent


=item * FileCount


=item * Name


=item * Size


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DirectoryInfo
   DiskFreeSpace => $some_value, # atomic
   DiskFreeSpacePercent =>  $some_value, # string
   FileCount => $some_value, # atomic
   Name =>  $some_value, # string
   Size => $some_value, # atomic
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

