package MyTypes::DiskInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);
my %DiskId_of :ATTR(:get<DiskId>);
my %DiskName_of :ATTR(:get<DiskName>);
my %DiskSize_of :ATTR(:get<DiskSize>);
my %DiskType_of :ATTR(:get<DiskType>);
my %DiskUidOrWwn_of :ATTR(:get<DiskUidOrWwn>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %PlexName_of :ATTR(:get<PlexName>);
my %RaidgroupName_of :ATTR(:get<RaidgroupName>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName
        DiskId
        DiskName
        DiskSize
        DiskType
        DiskUidOrWwn
        HostId
        HostName
        PlexName
        RaidgroupName

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
        'DiskId' => \%DiskId_of,
        'DiskName' => \%DiskName_of,
        'DiskSize' => \%DiskSize_of,
        'DiskType' => \%DiskType_of,
        'DiskUidOrWwn' => \%DiskUidOrWwn_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'PlexName' => \%PlexName_of,
        'RaidgroupName' => \%RaidgroupName_of,
    },
    {
        'AggregateId' => 'MyTypes::ObjId',
        'AggregateName' => 'MyTypes::ObjFullName',
        'DiskId' => 'MyTypes::ObjId',
        'DiskName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DiskSize' => 'MyTypes::DiskInfo::_DiskSize',
        'DiskType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DiskUidOrWwn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'PlexName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RaidgroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
        'DiskId' => 'DiskId',
        'DiskName' => 'DiskName',
        'DiskSize' => 'DiskSize',
        'DiskType' => 'DiskType',
        'DiskUidOrWwn' => 'DiskUidOrWwn',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'PlexName' => 'PlexName',
        'RaidgroupName' => 'RaidgroupName',
    }
);

} # end BLOCK




package MyTypes::DiskInfo::_DiskSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DiskInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DiskInfo from the namespace http://www.netapp.com/management/v1.

Information about a disk.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName


=item * DiskId


=item * DiskName


=item * DiskSize


=item * DiskType


=item * DiskUidOrWwn


=item * HostId


=item * HostName


=item * PlexName


=item * RaidgroupName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DiskInfo
   AggregateId => $some_value, # ObjId
   AggregateName => $some_value, # ObjFullName
   DiskId => $some_value, # ObjId
   DiskName =>  $some_value, # string
   DiskSize => $some_value, # atomic
   DiskType =>  $some_value, # string
   DiskUidOrWwn =>  $some_value, # string
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   PlexName =>  $some_value, # string
   RaidgroupName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

