package MyTypes::DpAgentInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminPort_of :ATTR(:get<AdminPort>);
my %DpAgentId_of :ATTR(:get<DpAgentId>);
my %DpAgentIpAddress_of :ATTR(:get<DpAgentIpAddress>);
my %DpAgentName_of :ATTR(:get<DpAgentName>);
my %DpAgentPlugins_of :ATTR(:get<DpAgentPlugins>);
my %DpAgentStatus_of :ATTR(:get<DpAgentStatus>);
my %DpAgentVersion_of :ATTR(:get<DpAgentVersion>);
my %LastDiscoveryStatus_of :ATTR(:get<LastDiscoveryStatus>);
my %MgmtPort_of :ATTR(:get<MgmtPort>);
my %NeedsUpgrade_of :ATTR(:get<NeedsUpgrade>);
my %TimezoneInfo_of :ATTR(:get<TimezoneInfo>);
my %UpdateServicePort_of :ATTR(:get<UpdateServicePort>);
my %UpdateServiceVersion_of :ATTR(:get<UpdateServiceVersion>);

__PACKAGE__->_factory(
    [ qw(        AdminPort
        DpAgentId
        DpAgentIpAddress
        DpAgentName
        DpAgentPlugins
        DpAgentStatus
        DpAgentVersion
        LastDiscoveryStatus
        MgmtPort
        NeedsUpgrade
        TimezoneInfo
        UpdateServicePort
        UpdateServiceVersion

    ) ],
    {
        'AdminPort' => \%AdminPort_of,
        'DpAgentId' => \%DpAgentId_of,
        'DpAgentIpAddress' => \%DpAgentIpAddress_of,
        'DpAgentName' => \%DpAgentName_of,
        'DpAgentPlugins' => \%DpAgentPlugins_of,
        'DpAgentStatus' => \%DpAgentStatus_of,
        'DpAgentVersion' => \%DpAgentVersion_of,
        'LastDiscoveryStatus' => \%LastDiscoveryStatus_of,
        'MgmtPort' => \%MgmtPort_of,
        'NeedsUpgrade' => \%NeedsUpgrade_of,
        'TimezoneInfo' => \%TimezoneInfo_of,
        'UpdateServicePort' => \%UpdateServicePort_of,
        'UpdateServiceVersion' => \%UpdateServiceVersion_of,
    },
    {
        'AdminPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'DpAgentId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'DpAgentIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpAgentName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpAgentPlugins' => 'MyTypes::ArrayOfDpAgentPluginInfo',
        'DpAgentStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpAgentVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'LastDiscoveryStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MgmtPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'NeedsUpgrade' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TimezoneInfo' => 'MyTypes::TimezoneInfo',
        'UpdateServicePort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'UpdateServiceVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AdminPort' => 'AdminPort',
        'DpAgentId' => 'DpAgentId',
        'DpAgentIpAddress' => 'DpAgentIpAddress',
        'DpAgentName' => 'DpAgentName',
        'DpAgentPlugins' => 'DpAgentPlugins',
        'DpAgentStatus' => 'DpAgentStatus',
        'DpAgentVersion' => 'DpAgentVersion',
        'LastDiscoveryStatus' => 'LastDiscoveryStatus',
        'MgmtPort' => 'MgmtPort',
        'NeedsUpgrade' => 'NeedsUpgrade',
        'TimezoneInfo' => 'TimezoneInfo',
        'UpdateServicePort' => 'UpdateServicePort',
        'UpdateServiceVersion' => 'UpdateServiceVersion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpAgentInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpAgentInfo from the namespace http://www.netapp.com/management/v1.

Information about a Host Service.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminPort


=item * DpAgentId


=item * DpAgentIpAddress


=item * DpAgentName


=item * DpAgentPlugins


=item * DpAgentStatus


=item * DpAgentVersion


=item * LastDiscoveryStatus


=item * MgmtPort


=item * NeedsUpgrade


=item * TimezoneInfo


=item * UpdateServicePort


=item * UpdateServiceVersion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpAgentInfo
   AdminPort =>  $some_value, # integer
   DpAgentId =>  $some_value, # integer
   DpAgentIpAddress =>  $some_value, # string
   DpAgentName =>  $some_value, # string
   DpAgentPlugins =>  { # MyTypes::ArrayOfDpAgentPluginInfo
     DpAgentPluginInfo =>  { # MyTypes::DpAgentPluginInfo
       PluginType =>  $some_value, # string
       PluginVersion =>  $some_value, # string
     },
   },
   DpAgentStatus =>  $some_value, # string
   DpAgentVersion =>  $some_value, # string
   LastDiscoveryStatus =>  $some_value, # string
   MgmtPort =>  $some_value, # integer
   NeedsUpgrade =>  $some_value, # string
   TimezoneInfo =>  { # MyTypes::TimezoneInfo
     TimezoneName =>  $some_value, # string
   },
   UpdateServicePort =>  $some_value, # integer
   UpdateServiceVersion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

