package MyTypes::DpAgentPackageInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PackageId_of :ATTR(:get<PackageId>);
my %PackageName_of :ATTR(:get<PackageName>);
my %PackageVersion_of :ATTR(:get<PackageVersion>);

__PACKAGE__->_factory(
    [ qw(        PackageId
        PackageName
        PackageVersion

    ) ],
    {
        'PackageId' => \%PackageId_of,
        'PackageName' => \%PackageName_of,
        'PackageVersion' => \%PackageVersion_of,
    },
    {
        'PackageId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'PackageName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PackageVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'PackageId' => 'PackageId',
        'PackageName' => 'PackageName',
        'PackageVersion' => 'PackageVersion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpAgentPackageInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpAgentPackageInfo from the namespace http://www.netapp.com/management/v1.

Information about Host Service package.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PackageId


=item * PackageName


=item * PackageVersion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpAgentPackageInfo
   PackageId =>  $some_value, # integer
   PackageName =>  $some_value, # string
   PackageVersion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

