package MyTypes::DpAgentPluginInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PluginType_of :ATTR(:get<PluginType>);
my %PluginVersion_of :ATTR(:get<PluginVersion>);

__PACKAGE__->_factory(
    [ qw(        PluginType
        PluginVersion

    ) ],
    {
        'PluginType' => \%PluginType_of,
        'PluginVersion' => \%PluginVersion_of,
    },
    {
        'PluginType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PluginVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'PluginType' => 'PluginType',
        'PluginVersion' => 'PluginVersion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpAgentPluginInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpAgentPluginInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PluginType


=item * PluginVersion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpAgentPluginInfo
   PluginType =>  $some_value, # string
   PluginVersion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

