package MyTypes::DpAgentVersionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpAgentId_of :ATTR(:get<DpAgentId>);
my %DpAgentName_of :ATTR(:get<DpAgentName>);
my %DpAgentVersion_of :ATTR(:get<DpAgentVersion>);

__PACKAGE__->_factory(
    [ qw(        DpAgentId
        DpAgentName
        DpAgentVersion

    ) ],
    {
        'DpAgentId' => \%DpAgentId_of,
        'DpAgentName' => \%DpAgentName_of,
        'DpAgentVersion' => \%DpAgentVersion_of,
    },
    {
        'DpAgentId' => 'MyTypes::ObjId',
        'DpAgentName' => 'MyTypes::ObjName',
        'DpAgentVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DpAgentId' => 'DpAgentId',
        'DpAgentName' => 'DpAgentName',
        'DpAgentVersion' => 'DpAgentVersion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpAgentVersionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpAgentVersionInfo from the namespace http://www.netapp.com/management/v1.

Host Services' Version information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpAgentId


=item * DpAgentName


=item * DpAgentVersion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpAgentVersionInfo
   DpAgentId => $some_value, # ObjId
   DpAgentName => $some_value, # ObjName
   DpAgentVersion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

