package MyTypes::DpBackupContentInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpFileInfo_of :ATTR(:get<DpFileInfo>);
my %PrimarySnapshotName_of :ATTR(:get<PrimarySnapshotName>);
my %PrimarySnapshotUniqueId_of :ATTR(:get<PrimarySnapshotUniqueId>);
my %RootObjectId_of :ATTR(:get<RootObjectId>);
my %RootObjectName_of :ATTR(:get<RootObjectName>);
my %RootObjectType_of :ATTR(:get<RootObjectType>);

__PACKAGE__->_factory(
    [ qw(        DpFileInfo
        PrimarySnapshotName
        PrimarySnapshotUniqueId
        RootObjectId
        RootObjectName
        RootObjectType

    ) ],
    {
        'DpFileInfo' => \%DpFileInfo_of,
        'PrimarySnapshotName' => \%PrimarySnapshotName_of,
        'PrimarySnapshotUniqueId' => \%PrimarySnapshotUniqueId_of,
        'RootObjectId' => \%RootObjectId_of,
        'RootObjectName' => \%RootObjectName_of,
        'RootObjectType' => \%RootObjectType_of,
    },
    {
        'DpFileInfo' => 'MyTypes::DpFileInfo',
        'PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RootObjectId' => 'MyTypes::ObjId',
        'RootObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RootObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DpFileInfo' => 'DpFileInfo',
        'PrimarySnapshotName' => 'PrimarySnapshotName',
        'PrimarySnapshotUniqueId' => 'PrimarySnapshotUniqueId',
        'RootObjectId' => 'RootObjectId',
        'RootObjectName' => 'RootObjectName',
        'RootObjectType' => 'RootObjectType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpBackupContentInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpBackupContentInfo from the namespace http://www.netapp.com/management/v1.

Information about contents of a backup of Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpFileInfo


=item * PrimarySnapshotName


=item * PrimarySnapshotUniqueId


=item * RootObjectId


=item * RootObjectName


=item * RootObjectType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpBackupContentInfo
   DpFileInfo =>  { # MyTypes::DpFileInfo
     ChildCount => $some_value, # atomic
     FileName =>  $some_value, # string
     FileSize =>  $some_value, # unsignedLong
     FileType =>  $some_value, # string
     IsEmpty =>  $some_value, # boolean
     LastModifiedTimestamp =>  $some_value, # integer
   },
   PrimarySnapshotName =>  $some_value, # string
   PrimarySnapshotUniqueId =>  $some_value, # string
   RootObjectId => $some_value, # ObjId
   RootObjectName =>  $some_value, # string
   RootObjectType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

