package MyTypes::DpBackupIdInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupMetadata_of :ATTR(:get<BackupMetadata>);
my %JobId_of :ATTR(:get<JobId>);
my %NodeId_of :ATTR(:get<NodeId>);
my %NodeName_of :ATTR(:get<NodeName>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupMetadata
        JobId
        NodeId
        NodeName

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupMetadata' => \%BackupMetadata_of,
        'JobId' => \%JobId_of,
        'NodeId' => \%NodeId_of,
        'NodeName' => \%NodeName_of,
    },
    {

        'BackupId' => 'MyTypes::DpBackupIdInfo::_BackupId',
        'BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
        'JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'NodeId' => 'MyTypes::DpBackupIdInfo::_NodeId',
        'NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BackupId' => 'BackupId',
        'BackupMetadata' => 'BackupMetadata',
        'JobId' => 'JobId',
        'NodeId' => 'NodeId',
        'NodeName' => 'NodeName',
    }
);

} # end BLOCK




package MyTypes::DpBackupIdInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupIdInfo::_NodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpBackupIdInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpBackupIdInfo from the namespace http://www.netapp.com/management/v1.

Backup-version Instance information including Id and node Name for this Version.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId


=item * BackupMetadata


=item * JobId


=item * NodeId


=item * NodeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpBackupIdInfo
   BackupId => $some_value, # atomic
   BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
     DfmMetadata =>  { # MyTypes::DfmMetadata
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   JobId =>  $some_value, # integer
   NodeId => $some_value, # atomic
   NodeName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

