package MyTypes::DpBackupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplicationBackupInfos_of :ATTR(:get<ApplicationBackupInfos>);
my %BackupDescription_of :ATTR(:get<BackupDescription>);
my %BackupId_of :ATTR(:get<BackupId>);
my %BackupMetadata_of :ATTR(:get<BackupMetadata>);
my %BackupTransferInfos_of :ATTR(:get<BackupTransferInfos>);
my %BackupTransferStatus_of :ATTR(:get<BackupTransferStatus>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %IsAddingMembers_of :ATTR(:get<IsAddingMembers>);
my %IsBackupDestinationNode_of :ATTR(:get<IsBackupDestinationNode>);
my %IsForPropagation_of :ATTR(:get<IsForPropagation>);
my %IsMirrorDestinationNode_of :ATTR(:get<IsMirrorDestinationNode>);
my %NodeId_of :ATTR(:get<NodeId>);
my %NodeName_of :ATTR(:get<NodeName>);
my %RetentionDuration_of :ATTR(:get<RetentionDuration>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %SupportsNonDisruptiveRestore_of :ATTR(:get<SupportsNonDisruptiveRestore>);
my %VersionMembers_of :ATTR(:get<VersionMembers>);

__PACKAGE__->_factory(
    [ qw(        ApplicationBackupInfos
        BackupDescription
        BackupId
        BackupMetadata
        BackupTransferInfos
        BackupTransferStatus
        BackupVersion
        DatasetId
        DatasetName
        IsAddingMembers
        IsBackupDestinationNode
        IsForPropagation
        IsMirrorDestinationNode
        NodeId
        NodeName
        RetentionDuration
        RetentionType
        SupportsNonDisruptiveRestore
        VersionMembers

    ) ],
    {
        'ApplicationBackupInfos' => \%ApplicationBackupInfos_of,
        'BackupDescription' => \%BackupDescription_of,
        'BackupId' => \%BackupId_of,
        'BackupMetadata' => \%BackupMetadata_of,
        'BackupTransferInfos' => \%BackupTransferInfos_of,
        'BackupTransferStatus' => \%BackupTransferStatus_of,
        'BackupVersion' => \%BackupVersion_of,
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'IsAddingMembers' => \%IsAddingMembers_of,
        'IsBackupDestinationNode' => \%IsBackupDestinationNode_of,
        'IsForPropagation' => \%IsForPropagation_of,
        'IsMirrorDestinationNode' => \%IsMirrorDestinationNode_of,
        'NodeId' => \%NodeId_of,
        'NodeName' => \%NodeName_of,
        'RetentionDuration' => \%RetentionDuration_of,
        'RetentionType' => \%RetentionType_of,
        'SupportsNonDisruptiveRestore' => \%SupportsNonDisruptiveRestore_of,
        'VersionMembers' => \%VersionMembers_of,
    },
    {
        'ApplicationBackupInfos' => 'MyTypes::ArrayOfApplicationBackupInfo',
        'BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'BackupId' => 'MyTypes::DpBackupInfo::_BackupId',
        'BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
        'BackupTransferInfos' => 'MyTypes::ArrayOfDpBackupTransferInfo',
        'BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsBackupDestinationNode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsForPropagation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsMirrorDestinationNode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NodeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'RetentionDuration' => 'MyTypes::DpBackupInfo::_RetentionDuration',
        'RetentionType' => 'MyTypes::DpBackupRetentionType',
        'SupportsNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
        'VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
    },
    {

        'ApplicationBackupInfos' => 'ApplicationBackupInfos',
        'BackupDescription' => 'BackupDescription',
        'BackupId' => 'BackupId',
        'BackupMetadata' => 'BackupMetadata',
        'BackupTransferInfos' => 'BackupTransferInfos',
        'BackupTransferStatus' => 'BackupTransferStatus',
        'BackupVersion' => 'BackupVersion',
        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'IsAddingMembers' => 'IsAddingMembers',
        'IsBackupDestinationNode' => 'IsBackupDestinationNode',
        'IsForPropagation' => 'IsForPropagation',
        'IsMirrorDestinationNode' => 'IsMirrorDestinationNode',
        'NodeId' => 'NodeId',
        'NodeName' => 'NodeName',
        'RetentionDuration' => 'RetentionDuration',
        'RetentionType' => 'RetentionType',
        'SupportsNonDisruptiveRestore' => 'SupportsNonDisruptiveRestore',
        'VersionMembers' => 'VersionMembers',
    }
);

} # end BLOCK




package MyTypes::DpBackupInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupInfo::_RetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpBackupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpBackupInfo from the namespace http://www.netapp.com/management/v1.

Backup is a single backed up image of a Dataset. If backup is too large To fit on a single Volume, the management station uses multiple Volumes in the same storageset. In such cases, a single backup may span multiple Volumes in a single storageset. The management station keeps track of actual Volumes that hold the backup. Caller can identify backup by its numeric identifier.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplicationBackupInfos


=item * BackupDescription


=item * BackupId


=item * BackupMetadata


=item * BackupTransferInfos


=item * BackupTransferStatus


=item * BackupVersion


=item * DatasetId


=item * DatasetName


=item * IsAddingMembers


=item * IsBackupDestinationNode


=item * IsForPropagation


=item * IsMirrorDestinationNode


=item * NodeId


=item * NodeName


=item * RetentionDuration


=item * RetentionType


=item * SupportsNonDisruptiveRestore


=item * VersionMembers




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpBackupInfo
   ApplicationBackupInfos =>  { # MyTypes::ArrayOfApplicationBackupInfo
     ApplicationBackupInfo =>  { # MyTypes::ApplicationBackupInfo
       ApplicationBackupProperties =>  { # MyTypes::ArrayOfPropertyInfo
         PropertyInfo =>  { # MyTypes::PropertyInfo
           PropertyName =>  $some_value, # string
           PropertyValue =>  $some_value, # string
         },
       },
       ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
       BackupGraphInfo =>  { # MyTypes::BackupGraphInfo
         GraphEdges =>  { # MyTypes::ArrayOfBackupGraphEdgeInfo
           BackupGraphEdgeInfo =>  { # MyTypes::BackupGraphEdgeInfo
             FromResourceId => $some_value, # ObjId
             ToResourceId => $some_value, # ObjId
           },
         },
         GraphResources =>  { # MyTypes::ArrayOfBackupGraphResourceInfo
           BackupGraphResourceInfo =>  { # MyTypes::BackupGraphResourceInfo
             ApplicationResourceProperties =>  { # MyTypes::ArrayOfPropertyInfo
               PropertyInfo =>  { # MyTypes::PropertyInfo
                 PropertyName =>  $some_value, # string
                 PropertyValue =>  $some_value, # string
               },
             },
             HostServiceObjectId => $some_value, # HostServiceUniqueId
             IsRestorable =>  $some_value, # boolean
             ObjectId => $some_value, # ObjId
             ObjectName => $some_value, # ObjName
             ObjectNameWhenBackedUp => $some_value, # ObjName
             ResourceType => $some_value, # ApplicationObjectType
             Snapshots =>  { # MyTypes::ArrayOfSnapshotMemberInfo
               SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
                 PrimaryId => $some_value, # ObjId
                 PrimaryName => $some_value, # ObjName
                 PrimarySnapshotHostServiceId =>  $some_value, # string
                 PrimarySnapshotName =>  $some_value, # string
                 PrimarySnapshotUniqueId =>  $some_value, # string
                 SecondaryQtreeId => $some_value, # ObjId
                 SecondaryQtreeName =>  $some_value, # string
                 SecondaryQtreeNameOrId =>  $some_value, # string
               },
             },
           },
         },
       },
       HostServiceBackupId => $some_value, # HostServiceUniqueId
       HostServiceId => $some_value, # ObjId
     },
   },
   BackupDescription =>  $some_value, # string
   BackupId => $some_value, # atomic
   BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
     DfmMetadata =>  { # MyTypes::DfmMetadata
       FieldName =>  $some_value, # string
       FieldValue =>  $some_value, # string
     },
   },
   BackupTransferInfos =>  { # MyTypes::ArrayOfDpBackupTransferInfo
     DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
       BackupTransferNeeded =>  $some_value, # boolean
       BackupTransferStatus =>  $some_value, # string
       ConnectionType =>  $some_value, # string
       DestinationBackupId => $some_value, # atomic
       DestinationNodeId => $some_value, # atomic
       DestinationNodeName =>  $some_value, # string
       DestinationStoragesetId => $some_value, # atomic
       JobId =>  $some_value, # integer
       SourceBackupId => $some_value, # atomic
       SourceNodeId => $some_value, # atomic
       SourceNodeName =>  $some_value, # string
       SourceStoragesetId => $some_value, # atomic
     },
   },
   BackupTransferStatus =>  $some_value, # string
   BackupVersion => $some_value, # DpTimestamp
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   IsAddingMembers =>  $some_value, # boolean
   IsBackupDestinationNode =>  $some_value, # boolean
   IsForPropagation =>  $some_value, # boolean
   IsMirrorDestinationNode =>  $some_value, # boolean
   NodeId =>  $some_value, # integer
   NodeName =>  $some_value, # string
   RetentionDuration => $some_value, # atomic
   RetentionType => $some_value, # DpBackupRetentionType
   SupportsNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
   VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
     VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
       HostAddress => $some_value, # IpAddress
       HostFqdn =>  $some_value, # string
       HostId => $some_value, # ObjId
       IsAvailable =>  $some_value, # boolean
       SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
         SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
           PrimaryId => $some_value, # ObjId
           PrimaryName => $some_value, # ObjName
           PrimarySnapshotHostServiceId =>  $some_value, # string
           PrimarySnapshotName =>  $some_value, # string
           PrimarySnapshotUniqueId =>  $some_value, # string
           SecondaryQtreeId => $some_value, # ObjId
           SecondaryQtreeName =>  $some_value, # string
           SecondaryQtreeNameOrId =>  $some_value, # string
         },
       },
       SnapshotName =>  $some_value, # string
       SnapshotUniqueId =>  $some_value, # string
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

