package MyTypes::DpBackupPathInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %Path_of :ATTR(:get<Path>);
my %PrimarySnapshotName_of :ATTR(:get<PrimarySnapshotName>);
my %PrimarySnapshotUniqueId_of :ATTR(:get<PrimarySnapshotUniqueId>);

__PACKAGE__->_factory(
    [ qw(        MemberId
        MemberName
        Path
        PrimarySnapshotName
        PrimarySnapshotUniqueId

    ) ],
    {
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'Path' => \%Path_of,
        'PrimarySnapshotName' => \%PrimarySnapshotName_of,
        'PrimarySnapshotUniqueId' => \%PrimarySnapshotUniqueId_of,
    },
    {
        'MemberId' => 'MyTypes::ObjId',
        'MemberName' => 'MyTypes::ObjName',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'Path' => 'Path',
        'PrimarySnapshotName' => 'PrimarySnapshotName',
        'PrimarySnapshotUniqueId' => 'PrimarySnapshotUniqueId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpBackupPathInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpBackupPathInfo from the namespace http://www.netapp.com/management/v1.

Information about backup Path




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * MemberId


=item * MemberName


=item * Path


=item * PrimarySnapshotName


=item * PrimarySnapshotUniqueId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpBackupPathInfo
   MemberId => $some_value, # ObjId
   MemberName => $some_value, # ObjName
   Path =>  $some_value, # string
   PrimarySnapshotName =>  $some_value, # string
   PrimarySnapshotUniqueId =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

