package MyTypes::DpBackupTransferInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupTransferNeeded_of :ATTR(:get<BackupTransferNeeded>);
my %BackupTransferStatus_of :ATTR(:get<BackupTransferStatus>);
my %ConnectionType_of :ATTR(:get<ConnectionType>);
my %DestinationBackupId_of :ATTR(:get<DestinationBackupId>);
my %DestinationNodeId_of :ATTR(:get<DestinationNodeId>);
my %DestinationNodeName_of :ATTR(:get<DestinationNodeName>);
my %DestinationStoragesetId_of :ATTR(:get<DestinationStoragesetId>);
my %JobId_of :ATTR(:get<JobId>);
my %SourceBackupId_of :ATTR(:get<SourceBackupId>);
my %SourceNodeId_of :ATTR(:get<SourceNodeId>);
my %SourceNodeName_of :ATTR(:get<SourceNodeName>);
my %SourceStoragesetId_of :ATTR(:get<SourceStoragesetId>);

__PACKAGE__->_factory(
    [ qw(        BackupTransferNeeded
        BackupTransferStatus
        ConnectionType
        DestinationBackupId
        DestinationNodeId
        DestinationNodeName
        DestinationStoragesetId
        JobId
        SourceBackupId
        SourceNodeId
        SourceNodeName
        SourceStoragesetId

    ) ],
    {
        'BackupTransferNeeded' => \%BackupTransferNeeded_of,
        'BackupTransferStatus' => \%BackupTransferStatus_of,
        'ConnectionType' => \%ConnectionType_of,
        'DestinationBackupId' => \%DestinationBackupId_of,
        'DestinationNodeId' => \%DestinationNodeId_of,
        'DestinationNodeName' => \%DestinationNodeName_of,
        'DestinationStoragesetId' => \%DestinationStoragesetId_of,
        'JobId' => \%JobId_of,
        'SourceBackupId' => \%SourceBackupId_of,
        'SourceNodeId' => \%SourceNodeId_of,
        'SourceNodeName' => \%SourceNodeName_of,
        'SourceStoragesetId' => \%SourceStoragesetId_of,
    },
    {
        'BackupTransferNeeded' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ConnectionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DestinationBackupId' => 'MyTypes::DpBackupTransferInfo::_DestinationBackupId',

        'DestinationNodeId' => 'MyTypes::DpBackupTransferInfo::_DestinationNodeId',
        'DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DestinationStoragesetId' => 'MyTypes::DpBackupTransferInfo::_DestinationStoragesetId',
        'JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'SourceBackupId' => 'MyTypes::DpBackupTransferInfo::_SourceBackupId',

        'SourceNodeId' => 'MyTypes::DpBackupTransferInfo::_SourceNodeId',
        'SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SourceStoragesetId' => 'MyTypes::DpBackupTransferInfo::_SourceStoragesetId',
    },
    {

        'BackupTransferNeeded' => 'BackupTransferNeeded',
        'BackupTransferStatus' => 'BackupTransferStatus',
        'ConnectionType' => 'ConnectionType',
        'DestinationBackupId' => 'DestinationBackupId',
        'DestinationNodeId' => 'DestinationNodeId',
        'DestinationNodeName' => 'DestinationNodeName',
        'DestinationStoragesetId' => 'DestinationStoragesetId',
        'JobId' => 'JobId',
        'SourceBackupId' => 'SourceBackupId',
        'SourceNodeId' => 'SourceNodeId',
        'SourceNodeName' => 'SourceNodeName',
        'SourceStoragesetId' => 'SourceStoragesetId',
    }
);

} # end BLOCK




package MyTypes::DpBackupTransferInfo::_DestinationBackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupTransferInfo::_DestinationNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupTransferInfo::_DestinationStoragesetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupTransferInfo::_SourceBackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupTransferInfo::_SourceNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpBackupTransferInfo::_SourceStoragesetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpBackupTransferInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpBackupTransferInfo from the namespace http://www.netapp.com/management/v1.

Indicates the transfer Status of the backup between the two nodes directly connected To each other. When present in the input, you must specify at least one of DestinationStoragesetId, DestinationNodeName or DestinationNodeId.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupTransferNeeded


=item * BackupTransferStatus


=item * ConnectionType


=item * DestinationBackupId


=item * DestinationNodeId


=item * DestinationNodeName


=item * DestinationStoragesetId


=item * JobId


=item * SourceBackupId


=item * SourceNodeId


=item * SourceNodeName


=item * SourceStoragesetId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpBackupTransferInfo
   BackupTransferNeeded =>  $some_value, # boolean
   BackupTransferStatus =>  $some_value, # string
   ConnectionType =>  $some_value, # string
   DestinationBackupId => $some_value, # atomic
   DestinationNodeId => $some_value, # atomic
   DestinationNodeName =>  $some_value, # string
   DestinationStoragesetId => $some_value, # atomic
   JobId =>  $some_value, # integer
   SourceBackupId => $some_value, # atomic
   SourceNodeId => $some_value, # atomic
   SourceNodeName =>  $some_value, # string
   SourceStoragesetId => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

