package MyTypes::DpDatasetLagInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %LagStatus_of :ATTR(:get<LagStatus>);
my %WorstLag_of :ATTR(:get<WorstLag>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        LagStatus
        WorstLag

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'LagStatus' => \%LagStatus_of,
        'WorstLag' => \%WorstLag_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'LagStatus' => 'MyTypes::ObjStatus',

        'WorstLag' => 'MyTypes::DpDatasetLagInfo::_WorstLag',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'LagStatus' => 'LagStatus',
        'WorstLag' => 'WorstLag',
    }
);

} # end BLOCK




package MyTypes::DpDatasetLagInfo::_WorstLag;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpDatasetLagInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpDatasetLagInfo from the namespace http://www.netapp.com/management/v1.

Information about a single Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * LagStatus


=item * WorstLag




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpDatasetLagInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   LagStatus => $some_value, # ObjStatus
   WorstLag => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

