package MyTypes::DpFileInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ChildCount_of :ATTR(:get<ChildCount>);
my %FileName_of :ATTR(:get<FileName>);
my %FileSize_of :ATTR(:get<FileSize>);
my %FileType_of :ATTR(:get<FileType>);
my %IsEmpty_of :ATTR(:get<IsEmpty>);
my %LastModifiedTimestamp_of :ATTR(:get<LastModifiedTimestamp>);

__PACKAGE__->_factory(
    [ qw(        ChildCount
        FileName
        FileSize
        FileType
        IsEmpty
        LastModifiedTimestamp

    ) ],
    {
        'ChildCount' => \%ChildCount_of,
        'FileName' => \%FileName_of,
        'FileSize' => \%FileSize_of,
        'FileType' => \%FileType_of,
        'IsEmpty' => \%IsEmpty_of,
        'LastModifiedTimestamp' => \%LastModifiedTimestamp_of,
    },
    {

        'ChildCount' => 'MyTypes::DpFileInfo::_ChildCount',
        'FileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FileSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'FileType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsEmpty' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LastModifiedTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'ChildCount' => 'ChildCount',
        'FileName' => 'FileName',
        'FileSize' => 'FileSize',
        'FileType' => 'FileType',
        'IsEmpty' => 'IsEmpty',
        'LastModifiedTimestamp' => 'LastModifiedTimestamp',
    }
);

} # end BLOCK




package MyTypes::DpFileInfo::_ChildCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpFileInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpFileInfo from the namespace http://www.netapp.com/management/v1.

Information about file, Directory, Qtree, drive etc. on a primary Host or in a backup.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ChildCount


=item * FileName


=item * FileSize


=item * FileType


=item * IsEmpty


=item * LastModifiedTimestamp




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpFileInfo
   ChildCount => $some_value, # atomic
   FileName =>  $some_value, # string
   FileSize =>  $some_value, # unsignedLong
   FileType =>  $some_value, # string
   IsEmpty =>  $some_value, # boolean
   LastModifiedTimestamp =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

