package MyTypes::DpJobData;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DpJobType_of :ATTR(:get<DpJobType>);
my %DpLocalSnapshotJobData_of :ATTR(:get<DpLocalSnapshotJobData>);
my %DpSnapmirrorTransferJobData_of :ATTR(:get<DpSnapmirrorTransferJobData>);
my %DpSnapvaultTransferJobData_of :ATTR(:get<DpSnapvaultTransferJobData>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DpJobType
        DpLocalSnapshotJobData
        DpSnapmirrorTransferJobData
        DpSnapvaultTransferJobData

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DpJobType' => \%DpJobType_of,
        'DpLocalSnapshotJobData' => \%DpLocalSnapshotJobData_of,
        'DpSnapmirrorTransferJobData' => \%DpSnapmirrorTransferJobData_of,
        'DpSnapvaultTransferJobData' => \%DpSnapvaultTransferJobData_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DpJobType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpLocalSnapshotJobData' => 'MyTypes::DpLocalSnapshotJobData',
        'DpSnapmirrorTransferJobData' => 'MyTypes::DpSnapmirrorTransferJobData',
        'DpSnapvaultTransferJobData' => 'MyTypes::DpSnapvaultTransferJobData',
    },
    {

        'DatasetId' => 'DatasetId',
        'DpJobType' => 'DpJobType',
        'DpLocalSnapshotJobData' => 'DpLocalSnapshotJobData',
        'DpSnapmirrorTransferJobData' => 'DpSnapmirrorTransferJobData',
        'DpSnapvaultTransferJobData' => 'DpSnapvaultTransferJobData',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpJobData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpJobData from the namespace http://www.netapp.com/management/v1.

Describes an unscheduled data protection job. Type of job is specified in DpJobType element. Only one of all possible dp-*-job-data elements can be present.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DpJobType


=item * DpLocalSnapshotJobData


=item * DpSnapmirrorTransferJobData


=item * DpSnapvaultTransferJobData




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpJobData
   DatasetId => $some_value, # ObjId
   DpJobType =>  $some_value, # string
   DpLocalSnapshotJobData =>  { # MyTypes::DpLocalSnapshotJobData
     IsConfirmationData =>  $some_value, # boolean
     NodeId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
   DpSnapmirrorTransferJobData =>  { # MyTypes::DpSnapmirrorTransferJobData
     ConnectionId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
   DpSnapvaultTransferJobData =>  { # MyTypes::DpSnapvaultTransferJobData
     ConnectionId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

