package MyTypes::DpJobInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AbortRequestedTimestamp_of :ATTR(:get<AbortRequestedTimestamp>);
my %BytesTransferred_of :ATTR(:get<BytesTransferred>);
my %CompletedTimestamp_of :ATTR(:get<CompletedTimestamp>);
my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DestinationNodeId_of :ATTR(:get<DestinationNodeId>);
my %DestinationNodeName_of :ATTR(:get<DestinationNodeName>);
my %JobContextApplicationResourceNamespaces_of :ATTR(:get<JobContextApplicationResourceNamespaces>);
my %JobContextObjId_of :ATTR(:get<JobContextObjId>);
my %JobContextObjName_of :ATTR(:get<JobContextObjName>);
my %JobContextObjType_of :ATTR(:get<JobContextObjType>);
my %JobDescription_of :ATTR(:get<JobDescription>);
my %JobId_of :ATTR(:get<JobId>);
my %JobOverallStatus_of :ATTR(:get<JobOverallStatus>);
my %JobProgress_of :ATTR(:get<JobProgress>);
my %JobState_of :ATTR(:get<JobState>);
my %JobType_of :ATTR(:get<JobType>);
my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %ObjectType_of :ATTR(:get<ObjectType>);
my %PolicyId_of :ATTR(:get<PolicyId>);
my %PolicyName_of :ATTR(:get<PolicyName>);
my %ProvisionRequestInfo_of :ATTR(:get<ProvisionRequestInfo>);
my %SourceNodeId_of :ATTR(:get<SourceNodeId>);
my %SourceNodeName_of :ATTR(:get<SourceNodeName>);
my %StartedTimestamp_of :ATTR(:get<StartedTimestamp>);
my %SubmittedBy_of :ATTR(:get<SubmittedBy>);

__PACKAGE__->_factory(
    [ qw(        AbortRequestedTimestamp
        BytesTransferred
        CompletedTimestamp
        DatasetId
        DatasetName
        DestinationNodeId
        DestinationNodeName
        JobContextApplicationResourceNamespaces
        JobContextObjId
        JobContextObjName
        JobContextObjType
        JobDescription
        JobId
        JobOverallStatus
        JobProgress
        JobState
        JobType
        ObjectId
        ObjectName
        ObjectType
        PolicyId
        PolicyName
        ProvisionRequestInfo
        SourceNodeId
        SourceNodeName
        StartedTimestamp
        SubmittedBy

    ) ],
    {
        'AbortRequestedTimestamp' => \%AbortRequestedTimestamp_of,
        'BytesTransferred' => \%BytesTransferred_of,
        'CompletedTimestamp' => \%CompletedTimestamp_of,
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DestinationNodeId' => \%DestinationNodeId_of,
        'DestinationNodeName' => \%DestinationNodeName_of,
        'JobContextApplicationResourceNamespaces' => \%JobContextApplicationResourceNamespaces_of,
        'JobContextObjId' => \%JobContextObjId_of,
        'JobContextObjName' => \%JobContextObjName_of,
        'JobContextObjType' => \%JobContextObjType_of,
        'JobDescription' => \%JobDescription_of,
        'JobId' => \%JobId_of,
        'JobOverallStatus' => \%JobOverallStatus_of,
        'JobProgress' => \%JobProgress_of,
        'JobState' => \%JobState_of,
        'JobType' => \%JobType_of,
        'ObjectId' => \%ObjectId_of,
        'ObjectName' => \%ObjectName_of,
        'ObjectType' => \%ObjectType_of,
        'PolicyId' => \%PolicyId_of,
        'PolicyName' => \%PolicyName_of,
        'ProvisionRequestInfo' => \%ProvisionRequestInfo_of,
        'SourceNodeId' => \%SourceNodeId_of,
        'SourceNodeName' => \%SourceNodeName_of,
        'StartedTimestamp' => \%StartedTimestamp_of,
        'SubmittedBy' => \%SubmittedBy_of,
    },
    {
        'AbortRequestedTimestamp' => 'MyTypes::DpTimestamp',

        'BytesTransferred' => 'MyTypes::DpJobInfo::_BytesTransferred',
        'CompletedTimestamp' => 'MyTypes::DpTimestamp',

        'DatasetId' => 'MyTypes::DpJobInfo::_DatasetId',
        'DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DestinationNodeId' => 'MyTypes::DpJobInfo::_DestinationNodeId',
        'DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'JobContextApplicationResourceNamespaces' => 'MyTypes::ArrayOfApplicationResourceNamespace',
        'JobContextObjId' => 'MyTypes::ObjId',
        'JobContextObjName' => 'MyTypes::ObjFullName',
        'JobContextObjType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'JobDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'JobId' => 'MyTypes::DpJobInfo::_JobId',
        'JobOverallStatus' => 'MyTypes::DpJobOverallStatus',
        'JobProgress' => 'MyTypes::DpJobProgress',
        'JobState' => 'MyTypes::DpJobState',
        'JobType' => 'MyTypes::DpJobType',
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectName' => 'MyTypes::ObjFullName',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'PolicyId' => 'MyTypes::DpJobInfo::_PolicyId',
        'PolicyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProvisionRequestInfo' => 'MyTypes::ProvisionRequestInfo',

        'SourceNodeId' => 'MyTypes::DpJobInfo::_SourceNodeId',
        'SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StartedTimestamp' => 'MyTypes::DpTimestamp',
        'SubmittedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AbortRequestedTimestamp' => 'AbortRequestedTimestamp',
        'BytesTransferred' => 'BytesTransferred',
        'CompletedTimestamp' => 'CompletedTimestamp',
        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DestinationNodeId' => 'DestinationNodeId',
        'DestinationNodeName' => 'DestinationNodeName',
        'JobContextApplicationResourceNamespaces' => 'JobContextApplicationResourceNamespaces',
        'JobContextObjId' => 'JobContextObjId',
        'JobContextObjName' => 'JobContextObjName',
        'JobContextObjType' => 'JobContextObjType',
        'JobDescription' => 'JobDescription',
        'JobId' => 'JobId',
        'JobOverallStatus' => 'JobOverallStatus',
        'JobProgress' => 'JobProgress',
        'JobState' => 'JobState',
        'JobType' => 'JobType',
        'ObjectId' => 'ObjectId',
        'ObjectName' => 'ObjectName',
        'ObjectType' => 'ObjectType',
        'PolicyId' => 'PolicyId',
        'PolicyName' => 'PolicyName',
        'ProvisionRequestInfo' => 'ProvisionRequestInfo',
        'SourceNodeId' => 'SourceNodeId',
        'SourceNodeName' => 'SourceNodeName',
        'StartedTimestamp' => 'StartedTimestamp',
        'SubmittedBy' => 'SubmittedBy',
    }
);

} # end BLOCK




package MyTypes::DpJobInfo::_BytesTransferred;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobInfo::_DatasetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobInfo::_DestinationNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobInfo::_JobId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobInfo::_PolicyId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobInfo::_SourceNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpJobInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpJobInfo from the namespace http://www.netapp.com/management/v1.

A job is used To run one or more Data Protection or provisioning operations.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AbortRequestedTimestamp


=item * BytesTransferred


=item * CompletedTimestamp


=item * DatasetId


=item * DatasetName


=item * DestinationNodeId


=item * DestinationNodeName


=item * JobContextApplicationResourceNamespaces


=item * JobContextObjId


=item * JobContextObjName


=item * JobContextObjType


=item * JobDescription


=item * JobId


=item * JobOverallStatus


=item * JobProgress


=item * JobState


=item * JobType


=item * ObjectId


=item * ObjectName


=item * ObjectType


=item * PolicyId


=item * PolicyName


=item * ProvisionRequestInfo


=item * SourceNodeId


=item * SourceNodeName


=item * StartedTimestamp


=item * SubmittedBy




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpJobInfo
   AbortRequestedTimestamp => $some_value, # DpTimestamp
   BytesTransferred => $some_value, # atomic
   CompletedTimestamp => $some_value, # DpTimestamp
   DatasetId => $some_value, # atomic
   DatasetName =>  $some_value, # string
   DestinationNodeId => $some_value, # atomic
   DestinationNodeName =>  $some_value, # string
   JobContextApplicationResourceNamespaces =>  { # MyTypes::ArrayOfApplicationResourceNamespace
     ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
   },
   JobContextObjId => $some_value, # ObjId
   JobContextObjName => $some_value, # ObjFullName
   JobContextObjType =>  $some_value, # string
   JobDescription =>  $some_value, # string
   JobId => $some_value, # atomic
   JobOverallStatus => $some_value, # DpJobOverallStatus
   JobProgress => $some_value, # DpJobProgress
   JobState => $some_value, # DpJobState
   JobType => $some_value, # DpJobType
   ObjectId => $some_value, # ObjId
   ObjectName => $some_value, # ObjFullName
   ObjectType =>  $some_value, # string
   PolicyId => $some_value, # atomic
   PolicyName =>  $some_value, # string
   ProvisionRequestInfo =>  { # MyTypes::ProvisionRequestInfo
     DedupeMemberRequestInfo =>  { # MyTypes::DedupeMemberRequestInfo
       FullVolumeDedupe =>  $some_value, # boolean
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
     DeleteSnapshotsRequestInfo =>  { # MyTypes::DeleteSnapshotsRequestInfo
       Snapshots =>  { # MyTypes::ArrayOfSnapshot
         Snapshot =>  { # MyTypes::Snapshot
           SnapshotName =>  $some_value, # string
           UniqueId =>  $some_value, # string
         },
       },
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
     DestroyMemberRequestInfo =>  { # MyTypes::DestroyMemberRequestInfo
       MemberId => $some_value, # ObjId
       MemberName => $some_value, # ObjFullName
       MemberType =>  $some_value, # string
     },
     ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
       Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
         ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
           CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
           CommentValue => $some_value, # CommentValue
         },
       },
       CreateNewVfiler =>  $some_value, # boolean
       DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
         DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
           CifsDomain =>  $some_value, # string
           DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
             DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
               CifsUsername =>  $some_value, # string
               Permission => $some_value, # CifsPermission
             },
           },
         },
         DatasetExportProtocol => $some_value, # DatasetExportProtocol
         DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
           IgroupOsType =>  $some_value, # string
           LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
             LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
               Hostname =>  $some_value, # string
               InitiatorId => $some_value, # InitiatorId
             },
           },
         },
         DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
           AnonymousAccessUser => $some_value, # atomic
           DisableSetuid =>  $some_value, # boolean
           IsReadonlyForAllHosts =>  $some_value, # boolean
           IsReadwriteForAllHosts =>  $some_value, # boolean
           NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
             NfsExportHost =>  { # MyTypes::NfsExportHost
               Hostname =>  $some_value, # string
               IsAnException =>  $some_value, # boolean
             },
           },
           NfsProtocolVersion =>  $some_value, # string
           NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
             NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
           },
         },
       },
       Description =>  $some_value, # string
       InitialSnapshotSpace => $some_value, # atomic
       MaximumDataSize => $some_value, # atomic
       MaximumSnapshotSpace => $some_value, # atomic
       Name =>  $some_value, # string
       OnlineMigration =>  $some_value, # boolean
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjFullName
       ResourceNameOrId => $some_value, # ObjNameOrId
       Size => $some_value, # atomic
       VfilerNameOrId => $some_value, # ObjNameOrId
     },
     ResizeMemberRequestInfo =>  { # MyTypes::ResizeMemberRequestInfo
       MaximumCapacity => $some_value, # atomic
       MemberId => $some_value, # ObjId
       MemberName => $some_value, # ObjName
       NewSize => $some_value, # atomic
       SnapReserve => $some_value, # atomic
     },
     UndedupeMemberRequestInfo =>  { # MyTypes::UndedupeMemberRequestInfo
       VolumeId => $some_value, # ObjId
       VolumeName => $some_value, # ObjName
     },
   },
   SourceNodeId => $some_value, # atomic
   SourceNodeName =>  $some_value, # string
   StartedTimestamp => $some_value, # DpTimestamp
   SubmittedBy =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

