package MyTypes::DpJobProgressEventInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpProgressBackupInfo_of :ATTR(:get<DpProgressBackupInfo>);
my %DpProgressFailoverInfo_of :ATTR(:get<DpProgressFailoverInfo>);
my %DpProgressJobAbortInfo_of :ATTR(:get<DpProgressJobAbortInfo>);
my %DpProgressRelationshipInfo_of :ATTR(:get<DpProgressRelationshipInfo>);
my %DpProgressRestoreInfo_of :ATTR(:get<DpProgressRestoreInfo>);
my %DpProgressSnapmirrorInfo_of :ATTR(:get<DpProgressSnapmirrorInfo>);
my %DpProgressSnapshotInfo_of :ATTR(:get<DpProgressSnapshotInfo>);
my %DpProgressSnapvaultInfo_of :ATTR(:get<DpProgressSnapvaultInfo>);
my %ErrorMessage_of :ATTR(:get<ErrorMessage>);
my %EventId_of :ATTR(:get<EventId>);
my %EventMessage_of :ATTR(:get<EventMessage>);
my %EventStatus_of :ATTR(:get<EventStatus>);
my %EventTimestamp_of :ATTR(:get<EventTimestamp>);
my %EventType_of :ATTR(:get<EventType>);
my %JobId_of :ATTR(:get<JobId>);
my %JobType_of :ATTR(:get<JobType>);
my %ProgressAggregateInfo_of :ATTR(:get<ProgressAggregateInfo>);
my %ProgressCifsShareInfo_of :ATTR(:get<ProgressCifsShareInfo>);
my %ProgressHostServiceInfo_of :ATTR(:get<ProgressHostServiceInfo>);
my %ProgressIgroupConfigInfo_of :ATTR(:get<ProgressIgroupConfigInfo>);
my %ProgressIgroupInfo_of :ATTR(:get<ProgressIgroupInfo>);
my %ProgressLunInfo_of :ATTR(:get<ProgressLunInfo>);
my %ProgressLunMapInfo_of :ATTR(:get<ProgressLunMapInfo>);
my %ProgressNfsexportInfo_of :ATTR(:get<ProgressNfsexportInfo>);
my %ProgressQtreeInfo_of :ATTR(:get<ProgressQtreeInfo>);
my %ProgressQuotaInfo_of :ATTR(:get<ProgressQuotaInfo>);
my %ProgressResourcePoolInfo_of :ATTR(:get<ProgressResourcePoolInfo>);
my %ProgressScriptRunInfo_of :ATTR(:get<ProgressScriptRunInfo>);
my %ProgressStorageServiceInfo_of :ATTR(:get<ProgressStorageServiceInfo>);
my %ProgressStorageSystemInfo_of :ATTR(:get<ProgressStorageSystemInfo>);
my %ProgressVfilerInfo_of :ATTR(:get<ProgressVfilerInfo>);
my %ProgressVfilerStorageInfo_of :ATTR(:get<ProgressVfilerStorageInfo>);
my %ProgressVolumeDedupeInfo_of :ATTR(:get<ProgressVolumeDedupeInfo>);
my %ProgressVolumeInfo_of :ATTR(:get<ProgressVolumeInfo>);
my %ProgressVolumeOptionInfo_of :ATTR(:get<ProgressVolumeOptionInfo>);

__PACKAGE__->_factory(
    [ qw(        DpProgressBackupInfo
        DpProgressFailoverInfo
        DpProgressJobAbortInfo
        DpProgressRelationshipInfo
        DpProgressRestoreInfo
        DpProgressSnapmirrorInfo
        DpProgressSnapshotInfo
        DpProgressSnapvaultInfo
        ErrorMessage
        EventId
        EventMessage
        EventStatus
        EventTimestamp
        EventType
        JobId
        JobType
        ProgressAggregateInfo
        ProgressCifsShareInfo
        ProgressHostServiceInfo
        ProgressIgroupConfigInfo
        ProgressIgroupInfo
        ProgressLunInfo
        ProgressLunMapInfo
        ProgressNfsexportInfo
        ProgressQtreeInfo
        ProgressQuotaInfo
        ProgressResourcePoolInfo
        ProgressScriptRunInfo
        ProgressStorageServiceInfo
        ProgressStorageSystemInfo
        ProgressVfilerInfo
        ProgressVfilerStorageInfo
        ProgressVolumeDedupeInfo
        ProgressVolumeInfo
        ProgressVolumeOptionInfo

    ) ],
    {
        'DpProgressBackupInfo' => \%DpProgressBackupInfo_of,
        'DpProgressFailoverInfo' => \%DpProgressFailoverInfo_of,
        'DpProgressJobAbortInfo' => \%DpProgressJobAbortInfo_of,
        'DpProgressRelationshipInfo' => \%DpProgressRelationshipInfo_of,
        'DpProgressRestoreInfo' => \%DpProgressRestoreInfo_of,
        'DpProgressSnapmirrorInfo' => \%DpProgressSnapmirrorInfo_of,
        'DpProgressSnapshotInfo' => \%DpProgressSnapshotInfo_of,
        'DpProgressSnapvaultInfo' => \%DpProgressSnapvaultInfo_of,
        'ErrorMessage' => \%ErrorMessage_of,
        'EventId' => \%EventId_of,
        'EventMessage' => \%EventMessage_of,
        'EventStatus' => \%EventStatus_of,
        'EventTimestamp' => \%EventTimestamp_of,
        'EventType' => \%EventType_of,
        'JobId' => \%JobId_of,
        'JobType' => \%JobType_of,
        'ProgressAggregateInfo' => \%ProgressAggregateInfo_of,
        'ProgressCifsShareInfo' => \%ProgressCifsShareInfo_of,
        'ProgressHostServiceInfo' => \%ProgressHostServiceInfo_of,
        'ProgressIgroupConfigInfo' => \%ProgressIgroupConfigInfo_of,
        'ProgressIgroupInfo' => \%ProgressIgroupInfo_of,
        'ProgressLunInfo' => \%ProgressLunInfo_of,
        'ProgressLunMapInfo' => \%ProgressLunMapInfo_of,
        'ProgressNfsexportInfo' => \%ProgressNfsexportInfo_of,
        'ProgressQtreeInfo' => \%ProgressQtreeInfo_of,
        'ProgressQuotaInfo' => \%ProgressQuotaInfo_of,
        'ProgressResourcePoolInfo' => \%ProgressResourcePoolInfo_of,
        'ProgressScriptRunInfo' => \%ProgressScriptRunInfo_of,
        'ProgressStorageServiceInfo' => \%ProgressStorageServiceInfo_of,
        'ProgressStorageSystemInfo' => \%ProgressStorageSystemInfo_of,
        'ProgressVfilerInfo' => \%ProgressVfilerInfo_of,
        'ProgressVfilerStorageInfo' => \%ProgressVfilerStorageInfo_of,
        'ProgressVolumeDedupeInfo' => \%ProgressVolumeDedupeInfo_of,
        'ProgressVolumeInfo' => \%ProgressVolumeInfo_of,
        'ProgressVolumeOptionInfo' => \%ProgressVolumeOptionInfo_of,
    },
    {
        'DpProgressBackupInfo' => 'MyTypes::DpProgressBackupInfo',
        'DpProgressFailoverInfo' => 'MyTypes::DpProgressFailoverInfo',
        'DpProgressJobAbortInfo' => 'MyTypes::DpProgressJobAbortInfo',
        'DpProgressRelationshipInfo' => 'MyTypes::DpProgressRelationshipInfo',
        'DpProgressRestoreInfo' => 'MyTypes::DpProgressRestoreInfo',
        'DpProgressSnapmirrorInfo' => 'MyTypes::DpProgressSnapmirrorInfo',
        'DpProgressSnapshotInfo' => 'MyTypes::DpProgressSnapshotInfo',
        'DpProgressSnapvaultInfo' => 'MyTypes::DpProgressSnapvaultInfo',
        'ErrorMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'EventId' => 'MyTypes::DpJobProgressEventInfo::_EventId',
        'EventMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventStatus' => 'MyTypes::ObjStatus',
        'EventTimestamp' => 'MyTypes::DpTimestamp',
        'EventType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'JobId' => 'MyTypes::DpJobProgressEventInfo::_JobId',
        'JobType' => 'MyTypes::DpJobType',
        'ProgressAggregateInfo' => 'MyTypes::ProgressAggregateInfo',
        'ProgressCifsShareInfo' => 'MyTypes::ProgressCifsShareInfo',
        'ProgressHostServiceInfo' => 'MyTypes::ProgressHostServiceInfo',
        'ProgressIgroupConfigInfo' => 'MyTypes::ProgressIgroupConfigInfo',
        'ProgressIgroupInfo' => 'MyTypes::ProgressIgroupInfo',
        'ProgressLunInfo' => 'MyTypes::ProgressLunInfo',
        'ProgressLunMapInfo' => 'MyTypes::ProgressLunMapInfo',
        'ProgressNfsexportInfo' => 'MyTypes::ProgressNfsexportInfo',
        'ProgressQtreeInfo' => 'MyTypes::ProgressQtreeInfo',
        'ProgressQuotaInfo' => 'MyTypes::ProgressQuotaInfo',
        'ProgressResourcePoolInfo' => 'MyTypes::ProgressResourcePoolInfo',
        'ProgressScriptRunInfo' => 'MyTypes::ProgressScriptRunInfo',
        'ProgressStorageServiceInfo' => 'MyTypes::ProgressStorageServiceInfo',
        'ProgressStorageSystemInfo' => 'MyTypes::ProgressStorageSystemInfo',
        'ProgressVfilerInfo' => 'MyTypes::ProgressVfilerInfo',
        'ProgressVfilerStorageInfo' => 'MyTypes::ProgressVfilerStorageInfo',
        'ProgressVolumeDedupeInfo' => 'MyTypes::ProgressVolumeDedupeInfo',
        'ProgressVolumeInfo' => 'MyTypes::ProgressVolumeInfo',
        'ProgressVolumeOptionInfo' => 'MyTypes::ProgressVolumeOptionInfo',
    },
    {

        'DpProgressBackupInfo' => 'DpProgressBackupInfo',
        'DpProgressFailoverInfo' => 'DpProgressFailoverInfo',
        'DpProgressJobAbortInfo' => 'DpProgressJobAbortInfo',
        'DpProgressRelationshipInfo' => 'DpProgressRelationshipInfo',
        'DpProgressRestoreInfo' => 'DpProgressRestoreInfo',
        'DpProgressSnapmirrorInfo' => 'DpProgressSnapmirrorInfo',
        'DpProgressSnapshotInfo' => 'DpProgressSnapshotInfo',
        'DpProgressSnapvaultInfo' => 'DpProgressSnapvaultInfo',
        'ErrorMessage' => 'ErrorMessage',
        'EventId' => 'EventId',
        'EventMessage' => 'EventMessage',
        'EventStatus' => 'EventStatus',
        'EventTimestamp' => 'EventTimestamp',
        'EventType' => 'EventType',
        'JobId' => 'JobId',
        'JobType' => 'JobType',
        'ProgressAggregateInfo' => 'ProgressAggregateInfo',
        'ProgressCifsShareInfo' => 'ProgressCifsShareInfo',
        'ProgressHostServiceInfo' => 'ProgressHostServiceInfo',
        'ProgressIgroupConfigInfo' => 'ProgressIgroupConfigInfo',
        'ProgressIgroupInfo' => 'ProgressIgroupInfo',
        'ProgressLunInfo' => 'ProgressLunInfo',
        'ProgressLunMapInfo' => 'ProgressLunMapInfo',
        'ProgressNfsexportInfo' => 'ProgressNfsexportInfo',
        'ProgressQtreeInfo' => 'ProgressQtreeInfo',
        'ProgressQuotaInfo' => 'ProgressQuotaInfo',
        'ProgressResourcePoolInfo' => 'ProgressResourcePoolInfo',
        'ProgressScriptRunInfo' => 'ProgressScriptRunInfo',
        'ProgressStorageServiceInfo' => 'ProgressStorageServiceInfo',
        'ProgressStorageSystemInfo' => 'ProgressStorageSystemInfo',
        'ProgressVfilerInfo' => 'ProgressVfilerInfo',
        'ProgressVfilerStorageInfo' => 'ProgressVfilerStorageInfo',
        'ProgressVolumeDedupeInfo' => 'ProgressVolumeDedupeInfo',
        'ProgressVolumeInfo' => 'ProgressVolumeInfo',
        'ProgressVolumeOptionInfo' => 'ProgressVolumeOptionInfo',
    }
);

} # end BLOCK




package MyTypes::DpJobProgressEventInfo::_EventId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpJobProgressEventInfo::_JobId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpJobProgressEventInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpJobProgressEventInfo from the namespace http://www.netapp.com/management/v1.

One historical progress event for a data protection or provisioning job.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpProgressBackupInfo


=item * DpProgressFailoverInfo


=item * DpProgressJobAbortInfo


=item * DpProgressRelationshipInfo


=item * DpProgressRestoreInfo


=item * DpProgressSnapmirrorInfo


=item * DpProgressSnapshotInfo


=item * DpProgressSnapvaultInfo


=item * ErrorMessage


=item * EventId


=item * EventMessage


=item * EventStatus


=item * EventTimestamp


=item * EventType


=item * JobId


=item * JobType


=item * ProgressAggregateInfo


=item * ProgressCifsShareInfo


=item * ProgressHostServiceInfo


=item * ProgressIgroupConfigInfo


=item * ProgressIgroupInfo


=item * ProgressLunInfo


=item * ProgressLunMapInfo


=item * ProgressNfsexportInfo


=item * ProgressQtreeInfo


=item * ProgressQuotaInfo


=item * ProgressResourcePoolInfo


=item * ProgressScriptRunInfo


=item * ProgressStorageServiceInfo


=item * ProgressStorageSystemInfo


=item * ProgressVfilerInfo


=item * ProgressVfilerStorageInfo


=item * ProgressVolumeDedupeInfo


=item * ProgressVolumeInfo


=item * ProgressVolumeOptionInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpJobProgressEventInfo
   DpProgressBackupInfo =>  { # MyTypes::DpProgressBackupInfo
     BackupId => $some_value, # atomic
     BackupVersion => $some_value, # DpTimestamp
     Retention => $some_value, # DpBackupRetentionType
   },
   DpProgressFailoverInfo =>  { # MyTypes::DpProgressFailoverInfo
     DestinationPath =>  $some_value, # string
     EnvironmentVariableList =>  { # MyTypes::ArrayOfEnvironmentVariableInfo
       EnvironmentVariableInfo =>  { # MyTypes::EnvironmentVariableInfo
         Name =>  $some_value, # string
         Value =>  $some_value, # string
       },
     },
     RelationshipId => $some_value, # ObjId
     ScriptExitStatus =>  $some_value, # int
     ScriptPath =>  $some_value, # string
     ScriptRunAs =>  $some_value, # string
     ScriptSummary =>  $some_value, # string
   },
   DpProgressJobAbortInfo =>  { # MyTypes::DpProgressJobAbortInfo
     AbortedBy =>  $some_value, # string
   },
   DpProgressRelationshipInfo =>  { # MyTypes::DpProgressRelationshipInfo
     BytesTransferred => $some_value, # atomic
     DestinationVolumeOrQtreeId => $some_value, # atomic
     DestinationVolumeOrQtreeName =>  $some_value, # string
     RelationshipType =>  $some_value, # string
     SourceVolumeOrQtreeId => $some_value, # atomic
     SourceVolumeOrQtreeName =>  $some_value, # string
   },
   DpProgressRestoreInfo =>  { # MyTypes::DpProgressRestoreInfo
     BackupId => $some_value, # atomic
     BackupVersion => $some_value, # DpTimestamp
     BytesTransferred => $some_value, # atomic
     DestinationPath =>  $some_value, # string
     MemberId => $some_value, # atomic
     MemberName =>  $some_value, # string
     Path =>  $some_value, # string
   },
   DpProgressSnapmirrorInfo =>  { # MyTypes::DpProgressSnapmirrorInfo
     BytesTransferred => $some_value, # atomic
     DestinationVolumeOrQtreeId => $some_value, # atomic
     DestinationVolumeOrQtreeName =>  $some_value, # string
     SourceVolumeOrQtreeId => $some_value, # atomic
     SourceVolumeOrQtreeName =>  $some_value, # string
   },
   DpProgressSnapshotInfo =>  { # MyTypes::DpProgressSnapshotInfo
     SnapshotName =>  $some_value, # string
     VolumeId => $some_value, # atomic
     VolumeName =>  $some_value, # string
   },
   DpProgressSnapvaultInfo =>  { # MyTypes::DpProgressSnapvaultInfo
     BytesTransferred => $some_value, # atomic
     DestinationQtreeId => $some_value, # atomic
     DestinationQtreeName =>  $some_value, # string
     SourceQtreeId => $some_value, # atomic
     SourceQtreeName =>  $some_value, # string
   },
   ErrorMessage =>  $some_value, # string
   EventId => $some_value, # atomic
   EventMessage =>  $some_value, # string
   EventStatus => $some_value, # ObjStatus
   EventTimestamp => $some_value, # DpTimestamp
   EventType =>  $some_value, # string
   JobId => $some_value, # atomic
   JobType => $some_value, # DpJobType
   ProgressAggregateInfo =>  { # MyTypes::ProgressAggregateInfo
     AggregateId => $some_value, # ObjId
     AggregateName => $some_value, # ObjFullName
   },
   ProgressCifsShareInfo =>  { # MyTypes::ProgressCifsShareInfo
     CifsAclList =>  { # MyTypes::ArrayOfCifsAcl
       CifsAcl =>  { # MyTypes::CifsAcl
         AccessRights =>  $some_value, # string
         UserName =>  $some_value, # string
       },
     },
     CifsShareName =>  $some_value, # string
     VolOrQtreeId => $some_value, # ObjId
     VolOrQtreeName => $some_value, # ObjFullName
   },
   ProgressHostServiceInfo =>  { # MyTypes::ProgressHostServiceInfo
     HostServiceId => $some_value, # ObjId
     HostServiceName => $some_value, # ObjFullName
     OperationId => $some_value, # HostServiceUniqueId
   },
   ProgressIgroupConfigInfo =>  { # MyTypes::ProgressIgroupConfigInfo
     IgroupId => $some_value, # ObjId
     IgroupName => $some_value, # ObjFullName
     Initiators =>  $some_value, # string
   },
   ProgressIgroupInfo =>  { # MyTypes::ProgressIgroupInfo
     IgroupId => $some_value, # ObjId
     IgroupName => $some_value, # ObjFullName
   },
   ProgressLunInfo =>  { # MyTypes::ProgressLunInfo
     LunName => $some_value, # ObjFullName
     LunPathId => $some_value, # ObjId
   },
   ProgressLunMapInfo =>  { # MyTypes::ProgressLunMapInfo
     IgroupId => $some_value, # ObjId
     IgroupName => $some_value, # ObjFullName
     LunName => $some_value, # ObjFullName
     LunPathId => $some_value, # ObjId
   },
   ProgressNfsexportInfo =>  { # MyTypes::ProgressNfsexportInfo
     Path =>  $some_value, # string
     QtreeId => $some_value, # ObjId
     QtreeName => $some_value, # ObjFullName
   },
   ProgressQtreeInfo =>  { # MyTypes::ProgressQtreeInfo
     QtreeId => $some_value, # ObjId
     QtreeName => $some_value, # ObjFullName
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
   },
   ProgressQuotaInfo =>  { # MyTypes::ProgressQuotaInfo
     DefaultGroupQuota => $some_value, # atomic
     DefaultUserQuota => $some_value, # atomic
     QtreeId => $some_value, # ObjId
     QtreeName => $some_value, # ObjFullName
     TreeQuota => $some_value, # atomic
   },
   ProgressResourcePoolInfo =>  { # MyTypes::ProgressResourcePoolInfo
     ResourcePoolId => $some_value, # ObjId
     ResourcePoolMembers =>  { # MyTypes::ArrayOfResourcePoolMember
       ResourcePoolMember =>  { # MyTypes::ResourcePoolMember
         ResourcePoolMemberId => $some_value, # ObjId
         ResourcePoolMemberName => $some_value, # ObjFullName
       },
     },
     ResourcePoolName => $some_value, # ObjFullName
   },
   ProgressScriptRunInfo =>  { # MyTypes::ProgressScriptRunInfo
     ScriptName =>  $some_value, # string
   },
   ProgressStorageServiceInfo =>  { # MyTypes::ProgressStorageServiceInfo
     StorageServiceDescription =>  $some_value, # string
     StorageServiceId => $some_value, # ObjId
     StorageServiceName => $some_value, # ObjFullName
   },
   ProgressStorageSystemInfo =>  { # MyTypes::ProgressStorageSystemInfo
     StorageSystemId => $some_value, # ObjId
     StorageSystemName => $some_value, # ObjFullName
   },
   ProgressVfilerInfo =>  { # MyTypes::ProgressVfilerInfo
     FilerId => $some_value, # ObjId
     FilerName => $some_value, # ObjFullName
     Ipaddress =>  $some_value, # string
     Ipspace =>  $some_value, # string
     VfilerId => $some_value, # ObjId
     VfilerName => $some_value, # ObjFullName
   },
   ProgressVfilerStorageInfo =>  { # MyTypes::ProgressVfilerStorageInfo
     VfilerId => $some_value, # ObjId
     VfilerName => $some_value, # ObjFullName
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
   },
   ProgressVolumeDedupeInfo =>  { # MyTypes::ProgressVolumeDedupeInfo
     DedupeProgress =>  $some_value, # string
     DedupeSchedule =>  $some_value, # string
     DedupeStatus =>  $some_value, # string
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
   },
   ProgressVolumeInfo =>  { # MyTypes::ProgressVolumeInfo
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
   },
   ProgressVolumeOptionInfo =>  { # MyTypes::ProgressVolumeOptionInfo
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjFullName
     VolumeOptions =>  { # MyTypes::ArrayOfVolumeOption
       VolumeOption =>  { # MyTypes::VolumeOption
         OptionName =>  $some_value, # string
         OptionValue =>  $some_value, # string
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

