package MyTypes::DpOssvDirectoryInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %Datasets_of :ATTR(:get<Datasets>);
my %DirId_of :ATTR(:get<DirId>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsBrowsable_of :ATTR(:get<IsBrowsable>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInBackupRelationship_of :ATTR(:get<IsInBackupRelationship>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %Path_of :ATTR(:get<Path>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        Datasets
        DirId
        HostId
        HostName
        IsAvailable
        IsBrowsable
        IsDpIgnored
        IsInBackupRelationship
        IsInDataset
        Path

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'Datasets' => \%Datasets_of,
        'DirId' => \%DirId_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsBrowsable' => \%IsBrowsable_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInBackupRelationship' => \%IsInBackupRelationship_of,
        'IsInDataset' => \%IsInDataset_of,
        'Path' => \%Path_of,
    },
    {
        'DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',

        'DirId' => 'MyTypes::DpOssvDirectoryInfo::_DirId',

        'HostId' => 'MyTypes::DpOssvDirectoryInfo::_HostId',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsBrowsable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInBackupRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DatasetId' => 'DatasetId',
        'Datasets' => 'Datasets',
        'DirId' => 'DirId',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'IsAvailable' => 'IsAvailable',
        'IsBrowsable' => 'IsBrowsable',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInBackupRelationship' => 'IsInBackupRelationship',
        'IsInDataset' => 'IsInDataset',
        'Path' => 'Path',
    }
);

} # end BLOCK




package MyTypes::DpOssvDirectoryInfo::_DirId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpOssvDirectoryInfo::_HostId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpOssvDirectoryInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpOssvDirectoryInfo from the namespace http://www.netapp.com/management/v1.

Information about one Directory.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * Datasets


=item * DirId


=item * HostId


=item * HostName


=item * IsAvailable


=item * IsBrowsable


=item * IsDpIgnored


=item * IsInBackupRelationship


=item * IsInDataset


=item * Path




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpOssvDirectoryInfo
   DatasetId =>  $some_value, # integer
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   DirId => $some_value, # atomic
   HostId => $some_value, # atomic
   HostName =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   IsBrowsable =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInBackupRelationship =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   Path =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

