package MyTypes::DpOssvDirectoryRootInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FilesystemDevice_of :ATTR(:get<FilesystemDevice>);
my %FilesystemState_of :ATTR(:get<FilesystemState>);
my %FilesystemType_of :ATTR(:get<FilesystemType>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %RootPath_of :ATTR(:get<RootPath>);

__PACKAGE__->_factory(
    [ qw(        FilesystemDevice
        FilesystemState
        FilesystemType
        HostId
        HostName
        RootPath

    ) ],
    {
        'FilesystemDevice' => \%FilesystemDevice_of,
        'FilesystemState' => \%FilesystemState_of,
        'FilesystemType' => \%FilesystemType_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'RootPath' => \%RootPath_of,
    },
    {
        'FilesystemDevice' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FilesystemState' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FilesystemType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'HostId' => 'MyTypes::DpOssvDirectoryRootInfo::_HostId',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RootPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'FilesystemDevice' => 'FilesystemDevice',
        'FilesystemState' => 'FilesystemState',
        'FilesystemType' => 'FilesystemType',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'RootPath' => 'RootPath',
    }
);

} # end BLOCK




package MyTypes::DpOssvDirectoryRootInfo::_HostId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpOssvDirectoryRootInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpOssvDirectoryRootInfo from the namespace http://www.netapp.com/management/v1.

Information about one filesystem root.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FilesystemDevice


=item * FilesystemState


=item * FilesystemType


=item * HostId


=item * HostName


=item * RootPath




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpOssvDirectoryRootInfo
   FilesystemDevice =>  $some_value, # string
   FilesystemState =>  $some_value, # string
   FilesystemType =>  $some_value, # string
   HostId => $some_value, # atomic
   HostName =>  $some_value, # string
   RootPath =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

