package MyTypes::DpPathInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %MemberNameOrId_of :ATTR(:get<MemberNameOrId>);
my %Path_of :ATTR(:get<Path>);
my %PrimarySnapshotName_of :ATTR(:get<PrimarySnapshotName>);
my %PrimarySnapshotUniqueId_of :ATTR(:get<PrimarySnapshotUniqueId>);
my %RestoreConfiguration_of :ATTR(:get<RestoreConfiguration>);

__PACKAGE__->_factory(
    [ qw(        MemberNameOrId
        Path
        PrimarySnapshotName
        PrimarySnapshotUniqueId
        RestoreConfiguration

    ) ],
    {
        'MemberNameOrId' => \%MemberNameOrId_of,
        'Path' => \%Path_of,
        'PrimarySnapshotName' => \%PrimarySnapshotName_of,
        'PrimarySnapshotUniqueId' => \%PrimarySnapshotUniqueId_of,
        'RestoreConfiguration' => \%RestoreConfiguration_of,
    },
    {
        'MemberNameOrId' => 'MyTypes::ObjNameOrId',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RestoreConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'MemberNameOrId' => 'MemberNameOrId',
        'Path' => 'Path',
        'PrimarySnapshotName' => 'PrimarySnapshotName',
        'PrimarySnapshotUniqueId' => 'PrimarySnapshotUniqueId',
        'RestoreConfiguration' => 'RestoreConfiguration',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpPathInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpPathInfo from the namespace http://www.netapp.com/management/v1.

Information about a Path inside a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * MemberNameOrId


=item * Path


=item * PrimarySnapshotName


=item * PrimarySnapshotUniqueId


=item * RestoreConfiguration




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpPathInfo
   MemberNameOrId => $some_value, # ObjNameOrId
   Path =>  $some_value, # string
   PrimarySnapshotName =>  $some_value, # string
   PrimarySnapshotUniqueId =>  $some_value, # string
   RestoreConfiguration =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

