package MyTypes::DpPolicyConnectionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupScheduleId_of :ATTR(:get<BackupScheduleId>);
my %BackupScheduleName_of :ATTR(:get<BackupScheduleName>);
my %FromNodeId_of :ATTR(:get<FromNodeId>);
my %FromNodeName_of :ATTR(:get<FromNodeName>);
my %Id_of :ATTR(:get<Id>);
my %IsDrCapable_of :ATTR(:get<IsDrCapable>);
my %IsLagErrorEnabled_of :ATTR(:get<IsLagErrorEnabled>);
my %IsLagWarningEnabled_of :ATTR(:get<IsLagWarningEnabled>);
my %LagErrorThreshold_of :ATTR(:get<LagErrorThreshold>);
my %LagWarningThreshold_of :ATTR(:get<LagWarningThreshold>);
my %MirrorScheduleId_of :ATTR(:get<MirrorScheduleId>);
my %MirrorScheduleName_of :ATTR(:get<MirrorScheduleName>);
my %ThrottleScheduleId_of :ATTR(:get<ThrottleScheduleId>);
my %ThrottleScheduleName_of :ATTR(:get<ThrottleScheduleName>);
my %ToNodeId_of :ATTR(:get<ToNodeId>);
my %ToNodeName_of :ATTR(:get<ToNodeName>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        BackupScheduleId
        BackupScheduleName
        FromNodeId
        FromNodeName
        Id
        IsDrCapable
        IsLagErrorEnabled
        IsLagWarningEnabled
        LagErrorThreshold
        LagWarningThreshold
        MirrorScheduleId
        MirrorScheduleName
        ThrottleScheduleId
        ThrottleScheduleName
        ToNodeId
        ToNodeName
        Type

    ) ],
    {
        'BackupScheduleId' => \%BackupScheduleId_of,
        'BackupScheduleName' => \%BackupScheduleName_of,
        'FromNodeId' => \%FromNodeId_of,
        'FromNodeName' => \%FromNodeName_of,
        'Id' => \%Id_of,
        'IsDrCapable' => \%IsDrCapable_of,
        'IsLagErrorEnabled' => \%IsLagErrorEnabled_of,
        'IsLagWarningEnabled' => \%IsLagWarningEnabled_of,
        'LagErrorThreshold' => \%LagErrorThreshold_of,
        'LagWarningThreshold' => \%LagWarningThreshold_of,
        'MirrorScheduleId' => \%MirrorScheduleId_of,
        'MirrorScheduleName' => \%MirrorScheduleName_of,
        'ThrottleScheduleId' => \%ThrottleScheduleId_of,
        'ThrottleScheduleName' => \%ThrottleScheduleName_of,
        'ToNodeId' => \%ToNodeId_of,
        'ToNodeName' => \%ToNodeName_of,
        'Type' => \%Type_of,
    },
    {
        'BackupScheduleId' => 'MyTypes::ObjId',
        'BackupScheduleName' => 'MyTypes::ObjName',

        'FromNodeId' => 'MyTypes::DpPolicyConnectionInfo::_FromNodeId',
        'FromNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'Id' => 'MyTypes::DpPolicyConnectionInfo::_Id',
        'IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'LagErrorThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagErrorThreshold',

        'LagWarningThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagWarningThreshold',
        'MirrorScheduleId' => 'MyTypes::ObjId',
        'MirrorScheduleName' => 'MyTypes::ObjName',
        'ThrottleScheduleId' => 'MyTypes::ObjId',
        'ThrottleScheduleName' => 'MyTypes::ObjName',

        'ToNodeId' => 'MyTypes::DpPolicyConnectionInfo::_ToNodeId',
        'ToNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BackupScheduleId' => 'BackupScheduleId',
        'BackupScheduleName' => 'BackupScheduleName',
        'FromNodeId' => 'FromNodeId',
        'FromNodeName' => 'FromNodeName',
        'Id' => 'Id',
        'IsDrCapable' => 'IsDrCapable',
        'IsLagErrorEnabled' => 'IsLagErrorEnabled',
        'IsLagWarningEnabled' => 'IsLagWarningEnabled',
        'LagErrorThreshold' => 'LagErrorThreshold',
        'LagWarningThreshold' => 'LagWarningThreshold',
        'MirrorScheduleId' => 'MirrorScheduleId',
        'MirrorScheduleName' => 'MirrorScheduleName',
        'ThrottleScheduleId' => 'ThrottleScheduleId',
        'ThrottleScheduleName' => 'ThrottleScheduleName',
        'ToNodeId' => 'ToNodeId',
        'ToNodeName' => 'ToNodeName',
        'Type' => 'Type',
    }
);

} # end BLOCK




package MyTypes::DpPolicyConnectionInfo::_FromNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyConnectionInfo::_Id;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyConnectionInfo::_LagErrorThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyConnectionInfo::_LagWarningThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyConnectionInfo::_ToNodeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpPolicyConnectionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpPolicyConnectionInfo from the namespace http://www.netapp.com/management/v1.

Information about a connection From one node To another in a DP Policy. The connection's Properties are represented by optional elements. The rules for when a property is present or absent are defined in the property's <b>Description</b>, and depend on the Type of connection.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupScheduleId


=item * BackupScheduleName


=item * FromNodeId


=item * FromNodeName


=item * Id


=item * IsDrCapable


=item * IsLagErrorEnabled


=item * IsLagWarningEnabled


=item * LagErrorThreshold


=item * LagWarningThreshold


=item * MirrorScheduleId


=item * MirrorScheduleName


=item * ThrottleScheduleId


=item * ThrottleScheduleName


=item * ToNodeId


=item * ToNodeName


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpPolicyConnectionInfo
   BackupScheduleId => $some_value, # ObjId
   BackupScheduleName => $some_value, # ObjName
   FromNodeId => $some_value, # atomic
   FromNodeName =>  $some_value, # string
   Id => $some_value, # atomic
   IsDrCapable =>  $some_value, # boolean
   IsLagErrorEnabled =>  $some_value, # boolean
   IsLagWarningEnabled =>  $some_value, # boolean
   LagErrorThreshold => $some_value, # atomic
   LagWarningThreshold => $some_value, # atomic
   MirrorScheduleId => $some_value, # ObjId
   MirrorScheduleName => $some_value, # ObjName
   ThrottleScheduleId => $some_value, # ObjId
   ThrottleScheduleName => $some_value, # ObjName
   ToNodeId => $some_value, # atomic
   ToNodeName =>  $some_value, # string
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

