package MyTypes::DpPolicyContent;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Description_of :ATTR(:get<Description>);
my %DpPolicyConnections_of :ATTR(:get<DpPolicyConnections>);
my %DpPolicyNodes_of :ATTR(:get<DpPolicyNodes>);
my %Name_of :ATTR(:get<Name>);

__PACKAGE__->_factory(
    [ qw(        Description
        DpPolicyConnections
        DpPolicyNodes
        Name

    ) ],
    {
        'Description' => \%Description_of,
        'DpPolicyConnections' => \%DpPolicyConnections_of,
        'DpPolicyNodes' => \%DpPolicyNodes_of,
        'Name' => \%Name_of,
    },
    {
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DpPolicyConnections' => 'MyTypes::ArrayOfDpPolicyConnectionInfo',
        'DpPolicyNodes' => 'MyTypes::ArrayOfDpPolicyNodeInfo',
        'Name' => 'MyTypes::ObjName',
    },
    {

        'Description' => 'Description',
        'DpPolicyConnections' => 'DpPolicyConnections',
        'DpPolicyNodes' => 'DpPolicyNodes',
        'Name' => 'Name',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpPolicyContent

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpPolicyContent from the namespace http://www.netapp.com/management/v1.

All content of a single Policy, including its Name, Description, topology (nodes and connections), and the Properties for each node and connection.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Description


=item * DpPolicyConnections


=item * DpPolicyNodes


=item * Name




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpPolicyContent
   Description =>  $some_value, # string
   DpPolicyConnections =>  { # MyTypes::ArrayOfDpPolicyConnectionInfo
     DpPolicyConnectionInfo =>  { # MyTypes::DpPolicyConnectionInfo
       BackupScheduleId => $some_value, # ObjId
       BackupScheduleName => $some_value, # ObjName
       FromNodeId => $some_value, # atomic
       FromNodeName =>  $some_value, # string
       Id => $some_value, # atomic
       IsDrCapable =>  $some_value, # boolean
       IsLagErrorEnabled =>  $some_value, # boolean
       IsLagWarningEnabled =>  $some_value, # boolean
       LagErrorThreshold => $some_value, # atomic
       LagWarningThreshold => $some_value, # atomic
       MirrorScheduleId => $some_value, # ObjId
       MirrorScheduleName => $some_value, # ObjName
       ThrottleScheduleId => $some_value, # ObjId
       ThrottleScheduleName => $some_value, # ObjName
       ToNodeId => $some_value, # atomic
       ToNodeName =>  $some_value, # string
       Type =>  $some_value, # string
     },
   },
   DpPolicyNodes =>  { # MyTypes::ArrayOfDpPolicyNodeInfo
     DpPolicyNodeInfo =>  { # MyTypes::DpPolicyNodeInfo
       BackupScriptPath =>  $some_value, # string
       BackupScriptRunAs =>  $some_value, # string
       DailyRetentionCount => $some_value, # atomic
       DailyRetentionDuration => $some_value, # atomic
       FailoverScriptPath =>  $some_value, # string
       FailoverScriptRunAs =>  $some_value, # string
       HourlyRetentionCount => $some_value, # atomic
       HourlyRetentionDuration => $some_value, # atomic
       Id => $some_value, # atomic
       IsLagErrorEnabled =>  $some_value, # boolean
       IsLagWarningEnabled =>  $some_value, # boolean
       LagErrorThreshold => $some_value, # atomic
       LagWarningThreshold => $some_value, # atomic
       MonthlyRetentionCount => $some_value, # atomic
       MonthlyRetentionDuration => $some_value, # atomic
       Name => $some_value, # DpPolicyNodeName
       SnapshotScheduleId => $some_value, # ObjId
       SnapshotScheduleName => $some_value, # ObjName
       WeeklyRetentionCount => $some_value, # atomic
       WeeklyRetentionDuration => $some_value, # atomic
     },
   },
   Name => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

