package MyTypes::DpPolicyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpPolicyContent_of :ATTR(:get<DpPolicyContent>);
my %Id_of :ATTR(:get<Id>);
my %IsApplicationCompatible_of :ATTR(:get<IsApplicationCompatible>);
my %IsModifiable_of :ATTR(:get<IsModifiable>);
my %IsNonDisruptiveRestoreCompatible_of :ATTR(:get<IsNonDisruptiveRestoreCompatible>);

__PACKAGE__->_factory(
    [ qw(        DpPolicyContent
        Id
        IsApplicationCompatible
        IsModifiable
        IsNonDisruptiveRestoreCompatible

    ) ],
    {
        'DpPolicyContent' => \%DpPolicyContent_of,
        'Id' => \%Id_of,
        'IsApplicationCompatible' => \%IsApplicationCompatible_of,
        'IsModifiable' => \%IsModifiable_of,
        'IsNonDisruptiveRestoreCompatible' => \%IsNonDisruptiveRestoreCompatible_of,
    },
    {
        'DpPolicyContent' => 'MyTypes::DpPolicyContent',
        'Id' => 'MyTypes::ObjId',
        'IsApplicationCompatible' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsNonDisruptiveRestoreCompatible' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DpPolicyContent' => 'DpPolicyContent',
        'Id' => 'Id',
        'IsApplicationCompatible' => 'IsApplicationCompatible',
        'IsModifiable' => 'IsModifiable',
        'IsNonDisruptiveRestoreCompatible' => 'IsNonDisruptiveRestoreCompatible',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpPolicyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpPolicyInfo from the namespace http://www.netapp.com/management/v1.

Contains all information about a single DP Policy, including its content and metadata such as its ID.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpPolicyContent


=item * Id


=item * IsApplicationCompatible


=item * IsModifiable


=item * IsNonDisruptiveRestoreCompatible




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpPolicyInfo
   DpPolicyContent =>  { # MyTypes::DpPolicyContent
     Description =>  $some_value, # string
     DpPolicyConnections =>  { # MyTypes::ArrayOfDpPolicyConnectionInfo
       DpPolicyConnectionInfo =>  { # MyTypes::DpPolicyConnectionInfo
         BackupScheduleId => $some_value, # ObjId
         BackupScheduleName => $some_value, # ObjName
         FromNodeId => $some_value, # atomic
         FromNodeName =>  $some_value, # string
         Id => $some_value, # atomic
         IsDrCapable =>  $some_value, # boolean
         IsLagErrorEnabled =>  $some_value, # boolean
         IsLagWarningEnabled =>  $some_value, # boolean
         LagErrorThreshold => $some_value, # atomic
         LagWarningThreshold => $some_value, # atomic
         MirrorScheduleId => $some_value, # ObjId
         MirrorScheduleName => $some_value, # ObjName
         ThrottleScheduleId => $some_value, # ObjId
         ThrottleScheduleName => $some_value, # ObjName
         ToNodeId => $some_value, # atomic
         ToNodeName =>  $some_value, # string
         Type =>  $some_value, # string
       },
     },
     DpPolicyNodes =>  { # MyTypes::ArrayOfDpPolicyNodeInfo
       DpPolicyNodeInfo =>  { # MyTypes::DpPolicyNodeInfo
         BackupScriptPath =>  $some_value, # string
         BackupScriptRunAs =>  $some_value, # string
         DailyRetentionCount => $some_value, # atomic
         DailyRetentionDuration => $some_value, # atomic
         FailoverScriptPath =>  $some_value, # string
         FailoverScriptRunAs =>  $some_value, # string
         HourlyRetentionCount => $some_value, # atomic
         HourlyRetentionDuration => $some_value, # atomic
         Id => $some_value, # atomic
         IsLagErrorEnabled =>  $some_value, # boolean
         IsLagWarningEnabled =>  $some_value, # boolean
         LagErrorThreshold => $some_value, # atomic
         LagWarningThreshold => $some_value, # atomic
         MonthlyRetentionCount => $some_value, # atomic
         MonthlyRetentionDuration => $some_value, # atomic
         Name => $some_value, # DpPolicyNodeName
         SnapshotScheduleId => $some_value, # ObjId
         SnapshotScheduleName => $some_value, # ObjName
         WeeklyRetentionCount => $some_value, # atomic
         WeeklyRetentionDuration => $some_value, # atomic
       },
     },
     Name => $some_value, # ObjName
   },
   Id => $some_value, # ObjId
   IsApplicationCompatible =>  $some_value, # boolean
   IsModifiable =>  $some_value, # boolean
   IsNonDisruptiveRestoreCompatible =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

