package MyTypes::DpPolicyNodeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupScriptPath_of :ATTR(:get<BackupScriptPath>);
my %BackupScriptRunAs_of :ATTR(:get<BackupScriptRunAs>);
my %DailyRetentionCount_of :ATTR(:get<DailyRetentionCount>);
my %DailyRetentionDuration_of :ATTR(:get<DailyRetentionDuration>);
my %FailoverScriptPath_of :ATTR(:get<FailoverScriptPath>);
my %FailoverScriptRunAs_of :ATTR(:get<FailoverScriptRunAs>);
my %HourlyRetentionCount_of :ATTR(:get<HourlyRetentionCount>);
my %HourlyRetentionDuration_of :ATTR(:get<HourlyRetentionDuration>);
my %Id_of :ATTR(:get<Id>);
my %IsLagErrorEnabled_of :ATTR(:get<IsLagErrorEnabled>);
my %IsLagWarningEnabled_of :ATTR(:get<IsLagWarningEnabled>);
my %LagErrorThreshold_of :ATTR(:get<LagErrorThreshold>);
my %LagWarningThreshold_of :ATTR(:get<LagWarningThreshold>);
my %MonthlyRetentionCount_of :ATTR(:get<MonthlyRetentionCount>);
my %MonthlyRetentionDuration_of :ATTR(:get<MonthlyRetentionDuration>);
my %Name_of :ATTR(:get<Name>);
my %SnapshotScheduleId_of :ATTR(:get<SnapshotScheduleId>);
my %SnapshotScheduleName_of :ATTR(:get<SnapshotScheduleName>);
my %WeeklyRetentionCount_of :ATTR(:get<WeeklyRetentionCount>);
my %WeeklyRetentionDuration_of :ATTR(:get<WeeklyRetentionDuration>);

__PACKAGE__->_factory(
    [ qw(        BackupScriptPath
        BackupScriptRunAs
        DailyRetentionCount
        DailyRetentionDuration
        FailoverScriptPath
        FailoverScriptRunAs
        HourlyRetentionCount
        HourlyRetentionDuration
        Id
        IsLagErrorEnabled
        IsLagWarningEnabled
        LagErrorThreshold
        LagWarningThreshold
        MonthlyRetentionCount
        MonthlyRetentionDuration
        Name
        SnapshotScheduleId
        SnapshotScheduleName
        WeeklyRetentionCount
        WeeklyRetentionDuration

    ) ],
    {
        'BackupScriptPath' => \%BackupScriptPath_of,
        'BackupScriptRunAs' => \%BackupScriptRunAs_of,
        'DailyRetentionCount' => \%DailyRetentionCount_of,
        'DailyRetentionDuration' => \%DailyRetentionDuration_of,
        'FailoverScriptPath' => \%FailoverScriptPath_of,
        'FailoverScriptRunAs' => \%FailoverScriptRunAs_of,
        'HourlyRetentionCount' => \%HourlyRetentionCount_of,
        'HourlyRetentionDuration' => \%HourlyRetentionDuration_of,
        'Id' => \%Id_of,
        'IsLagErrorEnabled' => \%IsLagErrorEnabled_of,
        'IsLagWarningEnabled' => \%IsLagWarningEnabled_of,
        'LagErrorThreshold' => \%LagErrorThreshold_of,
        'LagWarningThreshold' => \%LagWarningThreshold_of,
        'MonthlyRetentionCount' => \%MonthlyRetentionCount_of,
        'MonthlyRetentionDuration' => \%MonthlyRetentionDuration_of,
        'Name' => \%Name_of,
        'SnapshotScheduleId' => \%SnapshotScheduleId_of,
        'SnapshotScheduleName' => \%SnapshotScheduleName_of,
        'WeeklyRetentionCount' => \%WeeklyRetentionCount_of,
        'WeeklyRetentionDuration' => \%WeeklyRetentionDuration_of,
    },
    {
        'BackupScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BackupScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DailyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionCount',

        'DailyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionDuration',
        'FailoverScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FailoverScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'HourlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionCount',

        'HourlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionDuration',

        'Id' => 'MyTypes::DpPolicyNodeInfo::_Id',
        'IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'LagErrorThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagErrorThreshold',

        'LagWarningThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagWarningThreshold',

        'MonthlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionCount',

        'MonthlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionDuration',
        'Name' => 'MyTypes::DpPolicyNodeName',
        'SnapshotScheduleId' => 'MyTypes::ObjId',
        'SnapshotScheduleName' => 'MyTypes::ObjName',

        'WeeklyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionCount',

        'WeeklyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionDuration',
    },
    {

        'BackupScriptPath' => 'BackupScriptPath',
        'BackupScriptRunAs' => 'BackupScriptRunAs',
        'DailyRetentionCount' => 'DailyRetentionCount',
        'DailyRetentionDuration' => 'DailyRetentionDuration',
        'FailoverScriptPath' => 'FailoverScriptPath',
        'FailoverScriptRunAs' => 'FailoverScriptRunAs',
        'HourlyRetentionCount' => 'HourlyRetentionCount',
        'HourlyRetentionDuration' => 'HourlyRetentionDuration',
        'Id' => 'Id',
        'IsLagErrorEnabled' => 'IsLagErrorEnabled',
        'IsLagWarningEnabled' => 'IsLagWarningEnabled',
        'LagErrorThreshold' => 'LagErrorThreshold',
        'LagWarningThreshold' => 'LagWarningThreshold',
        'MonthlyRetentionCount' => 'MonthlyRetentionCount',
        'MonthlyRetentionDuration' => 'MonthlyRetentionDuration',
        'Name' => 'Name',
        'SnapshotScheduleId' => 'SnapshotScheduleId',
        'SnapshotScheduleName' => 'SnapshotScheduleName',
        'WeeklyRetentionCount' => 'WeeklyRetentionCount',
        'WeeklyRetentionDuration' => 'WeeklyRetentionDuration',
    }
);

} # end BLOCK




package MyTypes::DpPolicyNodeInfo::_DailyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_DailyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_HourlyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_HourlyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_Id;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_LagErrorThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_LagWarningThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_MonthlyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_MonthlyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_WeeklyRetentionCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpPolicyNodeInfo::_WeeklyRetentionDuration;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpPolicyNodeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpPolicyNodeInfo from the namespace http://www.netapp.com/management/v1.

Information about a node in a DP Policy. The node's Properties are represented by optional elements. The rules for when a property is present or absent are defined in the property's <b>Description</b>, and depend on the Type of node. <p> There is a set of Properties associated with nodes that determine how long the system retains Backups. Each backup falls into one of these four <b>Retention classes</b>: <b>hourly</b>, <b>daily</b>, <b>weekly</b>, or <b>monthly</b>. The following eight Properties determine how long Backups are retained for each of the Retention classes: <UL> <LI> <b>HourlyRetentionCount</b> <LI> <b>HourlyRetentionDuration</b> <LI> <b>DailyRetentionCount</b> <LI> <b>DailyRetentionDuration</b> <LI> <b>WeeklyRetentionCount</b> <LI> <b>WeeklyRetentionDuration</b> <LI> <b>MonthlyRetentionCount</b> <LI> <b>MonthlyRetentionDuration</b> </UL> A backup <b>expires</b> when its age, in seconds, exceeds the Retention Duration set for its Retention class on the node on which it is stored. After a backup expires, whenever the number of newer Backups in its Retention class at least equals the Retention Count for its class, then the expired backup is deleted. <p> All eight of the Retention Properties are present only on the root node and on backup secondary nodes. On the root node, the Retention Properties apply To local Snapshots created on the root node. On backup secondary nodes, the Retention Properties apply To Backups of primary node data that are stored on the backup secondary node. The Retention Properties are absent From mirror destination nodes because a mirror destination retains the same set of Backups as its mirror Source.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupScriptPath


=item * BackupScriptRunAs


=item * DailyRetentionCount


=item * DailyRetentionDuration


=item * FailoverScriptPath


=item * FailoverScriptRunAs


=item * HourlyRetentionCount


=item * HourlyRetentionDuration


=item * Id


=item * IsLagErrorEnabled


=item * IsLagWarningEnabled


=item * LagErrorThreshold


=item * LagWarningThreshold


=item * MonthlyRetentionCount


=item * MonthlyRetentionDuration


=item * Name


=item * SnapshotScheduleId


=item * SnapshotScheduleName


=item * WeeklyRetentionCount


=item * WeeklyRetentionDuration




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpPolicyNodeInfo
   BackupScriptPath =>  $some_value, # string
   BackupScriptRunAs =>  $some_value, # string
   DailyRetentionCount => $some_value, # atomic
   DailyRetentionDuration => $some_value, # atomic
   FailoverScriptPath =>  $some_value, # string
   FailoverScriptRunAs =>  $some_value, # string
   HourlyRetentionCount => $some_value, # atomic
   HourlyRetentionDuration => $some_value, # atomic
   Id => $some_value, # atomic
   IsLagErrorEnabled =>  $some_value, # boolean
   IsLagWarningEnabled =>  $some_value, # boolean
   LagErrorThreshold => $some_value, # atomic
   LagWarningThreshold => $some_value, # atomic
   MonthlyRetentionCount => $some_value, # atomic
   MonthlyRetentionDuration => $some_value, # atomic
   Name => $some_value, # DpPolicyNodeName
   SnapshotScheduleId => $some_value, # ObjId
   SnapshotScheduleName => $some_value, # ObjName
   WeeklyRetentionCount => $some_value, # atomic
   WeeklyRetentionDuration => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

