package MyTypes::DpPolicyNodeName;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
DpPolicyNodeName from the namespace http://www.netapp.com/management/v1.

Name of a node in a DP Policy graph. This typedef is an alias for the builtin ZAPI Type <b>string</b>. A node Name may contain From 1 To 64 characters. It may start with any character and may contain any combination of characters, except that it may not consist solely of decimal digits ('0' through '9'). <p> The Name of each node in a DP Policy must be unique, but nodes in different policies may share the same Name. Node names are always compared in a case-insensitive manner. This means that, for example, "a" and "A" are considered To be the same Name for purposes of: creating new nodes for a new Policy, renaming nodes of an existing Policy, or looking up a Policy's nodes by Name. On the other hand, ZAPIs that return node names do not change the capitalization at all. For example, if a node's Name has been set To "Backup", then <b>DpPolicyListIterNext</b> returns its Name as "Backup". <p> Note that a node Name has the same format as an <b>ObjName</b>, and has similar Properties such as case-insensitivity. However, a node Name is not a kind of <b>ObjName</b> because a DP Policy node is a part of a DP Policy object, but is not itself a first-class DFM object.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

