package MyTypes::DpProgressBackupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %Retention_of :ATTR(:get<Retention>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupVersion
        Retention

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'Retention' => \%Retention_of,
    },
    {

        'BackupId' => 'MyTypes::DpProgressBackupInfo::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',
        'Retention' => 'MyTypes::DpBackupRetentionType',
    },
    {

        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'Retention' => 'Retention',
    }
);

} # end BLOCK




package MyTypes::DpProgressBackupInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpProgressBackupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpProgressBackupInfo from the namespace http://www.netapp.com/management/v1.

Information about the creation or deletion of a backup Version.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId


=item * BackupVersion


=item * Retention




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpProgressBackupInfo
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   Retention => $some_value, # DpBackupRetentionType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

