package MyTypes::DpProgressFailoverInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DestinationPath_of :ATTR(:get<DestinationPath>);
my %EnvironmentVariableList_of :ATTR(:get<EnvironmentVariableList>);
my %RelationshipId_of :ATTR(:get<RelationshipId>);
my %ScriptExitStatus_of :ATTR(:get<ScriptExitStatus>);
my %ScriptPath_of :ATTR(:get<ScriptPath>);
my %ScriptRunAs_of :ATTR(:get<ScriptRunAs>);
my %ScriptSummary_of :ATTR(:get<ScriptSummary>);

__PACKAGE__->_factory(
    [ qw(        DestinationPath
        EnvironmentVariableList
        RelationshipId
        ScriptExitStatus
        ScriptPath
        ScriptRunAs
        ScriptSummary

    ) ],
    {
        'DestinationPath' => \%DestinationPath_of,
        'EnvironmentVariableList' => \%EnvironmentVariableList_of,
        'RelationshipId' => \%RelationshipId_of,
        'ScriptExitStatus' => \%ScriptExitStatus_of,
        'ScriptPath' => \%ScriptPath_of,
        'ScriptRunAs' => \%ScriptRunAs_of,
        'ScriptSummary' => \%ScriptSummary_of,
    },
    {
        'DestinationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EnvironmentVariableList' => 'MyTypes::ArrayOfEnvironmentVariableInfo',
        'RelationshipId' => 'MyTypes::ObjId',
        'ScriptExitStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ScriptSummary' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DestinationPath' => 'DestinationPath',
        'EnvironmentVariableList' => 'EnvironmentVariableList',
        'RelationshipId' => 'RelationshipId',
        'ScriptExitStatus' => 'ScriptExitStatus',
        'ScriptPath' => 'ScriptPath',
        'ScriptRunAs' => 'ScriptRunAs',
        'ScriptSummary' => 'ScriptSummary',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpProgressFailoverInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpProgressFailoverInfo from the namespace http://www.netapp.com/management/v1.

Information about a failover job.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DestinationPath


=item * EnvironmentVariableList


=item * RelationshipId


=item * ScriptExitStatus


=item * ScriptPath


=item * ScriptRunAs


=item * ScriptSummary




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpProgressFailoverInfo
   DestinationPath =>  $some_value, # string
   EnvironmentVariableList =>  { # MyTypes::ArrayOfEnvironmentVariableInfo
     EnvironmentVariableInfo =>  { # MyTypes::EnvironmentVariableInfo
       Name =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   RelationshipId => $some_value, # ObjId
   ScriptExitStatus =>  $some_value, # int
   ScriptPath =>  $some_value, # string
   ScriptRunAs =>  $some_value, # string
   ScriptSummary =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

