package MyTypes::DpProgressRelationshipInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BytesTransferred_of :ATTR(:get<BytesTransferred>);
my %DestinationVolumeOrQtreeId_of :ATTR(:get<DestinationVolumeOrQtreeId>);
my %DestinationVolumeOrQtreeName_of :ATTR(:get<DestinationVolumeOrQtreeName>);
my %RelationshipType_of :ATTR(:get<RelationshipType>);
my %SourceVolumeOrQtreeId_of :ATTR(:get<SourceVolumeOrQtreeId>);
my %SourceVolumeOrQtreeName_of :ATTR(:get<SourceVolumeOrQtreeName>);

__PACKAGE__->_factory(
    [ qw(        BytesTransferred
        DestinationVolumeOrQtreeId
        DestinationVolumeOrQtreeName
        RelationshipType
        SourceVolumeOrQtreeId
        SourceVolumeOrQtreeName

    ) ],
    {
        'BytesTransferred' => \%BytesTransferred_of,
        'DestinationVolumeOrQtreeId' => \%DestinationVolumeOrQtreeId_of,
        'DestinationVolumeOrQtreeName' => \%DestinationVolumeOrQtreeName_of,
        'RelationshipType' => \%RelationshipType_of,
        'SourceVolumeOrQtreeId' => \%SourceVolumeOrQtreeId_of,
        'SourceVolumeOrQtreeName' => \%SourceVolumeOrQtreeName_of,
    },
    {

        'BytesTransferred' => 'MyTypes::DpProgressRelationshipInfo::_BytesTransferred',

        'DestinationVolumeOrQtreeId' => 'MyTypes::DpProgressRelationshipInfo::_DestinationVolumeOrQtreeId',
        'DestinationVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RelationshipType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SourceVolumeOrQtreeId' => 'MyTypes::DpProgressRelationshipInfo::_SourceVolumeOrQtreeId',
        'SourceVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BytesTransferred' => 'BytesTransferred',
        'DestinationVolumeOrQtreeId' => 'DestinationVolumeOrQtreeId',
        'DestinationVolumeOrQtreeName' => 'DestinationVolumeOrQtreeName',
        'RelationshipType' => 'RelationshipType',
        'SourceVolumeOrQtreeId' => 'SourceVolumeOrQtreeId',
        'SourceVolumeOrQtreeName' => 'SourceVolumeOrQtreeName',
    }
);

} # end BLOCK




package MyTypes::DpProgressRelationshipInfo::_BytesTransferred;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpProgressRelationshipInfo::_DestinationVolumeOrQtreeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpProgressRelationshipInfo::_SourceVolumeOrQtreeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpProgressRelationshipInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpProgressRelationshipInfo from the namespace http://www.netapp.com/management/v1.

Information about the creation or destruction of a SnapVault or SnapMirror relationship.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BytesTransferred


=item * DestinationVolumeOrQtreeId


=item * DestinationVolumeOrQtreeName


=item * RelationshipType


=item * SourceVolumeOrQtreeId


=item * SourceVolumeOrQtreeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpProgressRelationshipInfo
   BytesTransferred => $some_value, # atomic
   DestinationVolumeOrQtreeId => $some_value, # atomic
   DestinationVolumeOrQtreeName =>  $some_value, # string
   RelationshipType =>  $some_value, # string
   SourceVolumeOrQtreeId => $some_value, # atomic
   SourceVolumeOrQtreeName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

