package MyTypes::DpProgressRestoreInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupId_of :ATTR(:get<BackupId>);
my %BackupVersion_of :ATTR(:get<BackupVersion>);
my %BytesTransferred_of :ATTR(:get<BytesTransferred>);
my %DestinationPath_of :ATTR(:get<DestinationPath>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %Path_of :ATTR(:get<Path>);

__PACKAGE__->_factory(
    [ qw(        BackupId
        BackupVersion
        BytesTransferred
        DestinationPath
        MemberId
        MemberName
        Path

    ) ],
    {
        'BackupId' => \%BackupId_of,
        'BackupVersion' => \%BackupVersion_of,
        'BytesTransferred' => \%BytesTransferred_of,
        'DestinationPath' => \%DestinationPath_of,
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'Path' => \%Path_of,
    },
    {

        'BackupId' => 'MyTypes::DpProgressRestoreInfo::_BackupId',
        'BackupVersion' => 'MyTypes::DpTimestamp',

        'BytesTransferred' => 'MyTypes::DpProgressRestoreInfo::_BytesTransferred',
        'DestinationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'MemberId' => 'MyTypes::DpProgressRestoreInfo::_MemberId',
        'MemberName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BackupId' => 'BackupId',
        'BackupVersion' => 'BackupVersion',
        'BytesTransferred' => 'BytesTransferred',
        'DestinationPath' => 'DestinationPath',
        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'Path' => 'Path',
    }
);

} # end BLOCK




package MyTypes::DpProgressRestoreInfo::_BackupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpProgressRestoreInfo::_BytesTransferred;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::DpProgressRestoreInfo::_MemberId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpProgressRestoreInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpProgressRestoreInfo from the namespace http://www.netapp.com/management/v1.

Information about restore of a Path.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupId


=item * BackupVersion


=item * BytesTransferred


=item * DestinationPath


=item * MemberId


=item * MemberName


=item * Path




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpProgressRestoreInfo
   BackupId => $some_value, # atomic
   BackupVersion => $some_value, # DpTimestamp
   BytesTransferred => $some_value, # atomic
   DestinationPath =>  $some_value, # string
   MemberId => $some_value, # atomic
   MemberName =>  $some_value, # string
   Path =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

