package MyTypes::DpRelationshipInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %DestinationAggregateId_of :ATTR(:get<DestinationAggregateId>);
my %DestinationFullName_of :ATTR(:get<DestinationFullName>);
my %DestinationHostId_of :ATTR(:get<DestinationHostId>);
my %DestinationHostName_of :ATTR(:get<DestinationHostName>);
my %DestinationId_of :ATTR(:get<DestinationId>);
my %DestinationName_of :ATTR(:get<DestinationName>);
my %DestinationStoragesetId_of :ATTR(:get<DestinationStoragesetId>);
my %DestinationType_of :ATTR(:get<DestinationType>);
my %DestinationVolumeId_of :ATTR(:get<DestinationVolumeId>);
my %DiscoveredTimestamp_of :ATTR(:get<DiscoveredTimestamp>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsDpImported_of :ATTR(:get<IsDpImported>);
my %IsDpManaged_of :ATTR(:get<IsDpManaged>);
my %IsDpOrphan_of :ATTR(:get<IsDpOrphan>);
my %IsDpRedundant_of :ATTR(:get<IsDpRedundant>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %Lag_of :ATTR(:get<Lag>);
my %LagStatus_of :ATTR(:get<LagStatus>);
my %OperationalStatus_of :ATTR(:get<OperationalStatus>);
my %RelationshipId_of :ATTR(:get<RelationshipId>);
my %RelationshipState_of :ATTR(:get<RelationshipState>);
my %RelationshipType_of :ATTR(:get<RelationshipType>);
my %SourceAggregateId_of :ATTR(:get<SourceAggregateId>);
my %SourceFullName_of :ATTR(:get<SourceFullName>);
my %SourceHostId_of :ATTR(:get<SourceHostId>);
my %SourceHostName_of :ATTR(:get<SourceHostName>);
my %SourceId_of :ATTR(:get<SourceId>);
my %SourceName_of :ATTR(:get<SourceName>);
my %SourceStoragesetId_of :ATTR(:get<SourceStoragesetId>);
my %SourceType_of :ATTR(:get<SourceType>);
my %SourceVolumeId_of :ATTR(:get<SourceVolumeId>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        DeletedBy
        DeletedTimestamp
        DestinationAggregateId
        DestinationFullName
        DestinationHostId
        DestinationHostName
        DestinationId
        DestinationName
        DestinationStoragesetId
        DestinationType
        DestinationVolumeId
        DiscoveredTimestamp
        IsDpIgnored
        IsDpImported
        IsDpManaged
        IsDpOrphan
        IsDpRedundant
        IsInDataset
        Lag
        LagStatus
        OperationalStatus
        RelationshipId
        RelationshipState
        RelationshipType
        SourceAggregateId
        SourceFullName
        SourceHostId
        SourceHostName
        SourceId
        SourceName
        SourceStoragesetId
        SourceType
        SourceVolumeId

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'DestinationAggregateId' => \%DestinationAggregateId_of,
        'DestinationFullName' => \%DestinationFullName_of,
        'DestinationHostId' => \%DestinationHostId_of,
        'DestinationHostName' => \%DestinationHostName_of,
        'DestinationId' => \%DestinationId_of,
        'DestinationName' => \%DestinationName_of,
        'DestinationStoragesetId' => \%DestinationStoragesetId_of,
        'DestinationType' => \%DestinationType_of,
        'DestinationVolumeId' => \%DestinationVolumeId_of,
        'DiscoveredTimestamp' => \%DiscoveredTimestamp_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsDpImported' => \%IsDpImported_of,
        'IsDpManaged' => \%IsDpManaged_of,
        'IsDpOrphan' => \%IsDpOrphan_of,
        'IsDpRedundant' => \%IsDpRedundant_of,
        'IsInDataset' => \%IsInDataset_of,
        'Lag' => \%Lag_of,
        'LagStatus' => \%LagStatus_of,
        'OperationalStatus' => \%OperationalStatus_of,
        'RelationshipId' => \%RelationshipId_of,
        'RelationshipState' => \%RelationshipState_of,
        'RelationshipType' => \%RelationshipType_of,
        'SourceAggregateId' => \%SourceAggregateId_of,
        'SourceFullName' => \%SourceFullName_of,
        'SourceHostId' => \%SourceHostId_of,
        'SourceHostName' => \%SourceHostName_of,
        'SourceId' => \%SourceId_of,
        'SourceName' => \%SourceName_of,
        'SourceStoragesetId' => \%SourceStoragesetId_of,
        'SourceType' => \%SourceType_of,
        'SourceVolumeId' => \%SourceVolumeId_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'DestinationAggregateId' => 'MyTypes::ObjId',
        'DestinationFullName' => 'MyTypes::ObjFullName',
        'DestinationHostId' => 'MyTypes::ObjId',
        'DestinationHostName' => 'MyTypes::ObjFullName',
        'DestinationId' => 'MyTypes::ObjId',
        'DestinationName' => 'MyTypes::ObjName',
        'DestinationStoragesetId' => 'MyTypes::ObjId',
        'DestinationType' => 'MyTypes::RelationshipEndpointType',
        'DestinationVolumeId' => 'MyTypes::ObjId',
        'DiscoveredTimestamp' => 'MyTypes::DpTimestamp',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpImported' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpManaged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpOrphan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpRedundant' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'Lag' => 'MyTypes::DpRelationshipInfo::_Lag',
        'LagStatus' => 'MyTypes::ObjStatus',
        'OperationalStatus' => 'MyTypes::OperationalStatus',
        'RelationshipId' => 'MyTypes::ObjId',
        'RelationshipState' => 'MyTypes::RelationshipState',
        'RelationshipType' => 'MyTypes::RelationshipType',
        'SourceAggregateId' => 'MyTypes::ObjId',
        'SourceFullName' => 'MyTypes::ObjFullName',
        'SourceHostId' => 'MyTypes::ObjId',
        'SourceHostName' => 'MyTypes::ObjFullName',
        'SourceId' => 'MyTypes::ObjId',
        'SourceName' => 'MyTypes::ObjName',
        'SourceStoragesetId' => 'MyTypes::ObjId',
        'SourceType' => 'MyTypes::RelationshipEndpointType',
        'SourceVolumeId' => 'MyTypes::ObjId',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'DestinationAggregateId' => 'DestinationAggregateId',
        'DestinationFullName' => 'DestinationFullName',
        'DestinationHostId' => 'DestinationHostId',
        'DestinationHostName' => 'DestinationHostName',
        'DestinationId' => 'DestinationId',
        'DestinationName' => 'DestinationName',
        'DestinationStoragesetId' => 'DestinationStoragesetId',
        'DestinationType' => 'DestinationType',
        'DestinationVolumeId' => 'DestinationVolumeId',
        'DiscoveredTimestamp' => 'DiscoveredTimestamp',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsDpImported' => 'IsDpImported',
        'IsDpManaged' => 'IsDpManaged',
        'IsDpOrphan' => 'IsDpOrphan',
        'IsDpRedundant' => 'IsDpRedundant',
        'IsInDataset' => 'IsInDataset',
        'Lag' => 'Lag',
        'LagStatus' => 'LagStatus',
        'OperationalStatus' => 'OperationalStatus',
        'RelationshipId' => 'RelationshipId',
        'RelationshipState' => 'RelationshipState',
        'RelationshipType' => 'RelationshipType',
        'SourceAggregateId' => 'SourceAggregateId',
        'SourceFullName' => 'SourceFullName',
        'SourceHostId' => 'SourceHostId',
        'SourceHostName' => 'SourceHostName',
        'SourceId' => 'SourceId',
        'SourceName' => 'SourceName',
        'SourceStoragesetId' => 'SourceStoragesetId',
        'SourceType' => 'SourceType',
        'SourceVolumeId' => 'SourceVolumeId',
    }
);

} # end BLOCK




package MyTypes::DpRelationshipInfo::_Lag;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpRelationshipInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpRelationshipInfo from the namespace http://www.netapp.com/management/v1.

Information about a single SnapVault or SnapMirror relationship. Currently, there are three kinds of relationships: SnapVault, Qtree SnapMirror (QSM) and Volume SnapMirror (VSM).




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * DeletedBy


=item * DeletedTimestamp


=item * DestinationAggregateId


=item * DestinationFullName


=item * DestinationHostId


=item * DestinationHostName


=item * DestinationId


=item * DestinationName


=item * DestinationStoragesetId


=item * DestinationType


=item * DestinationVolumeId


=item * DiscoveredTimestamp


=item * IsDpIgnored


=item * IsDpImported


=item * IsDpManaged


=item * IsDpOrphan


=item * IsDpRedundant


=item * IsInDataset


=item * Lag


=item * LagStatus


=item * OperationalStatus


=item * RelationshipId


=item * RelationshipState


=item * RelationshipType


=item * SourceAggregateId


=item * SourceFullName


=item * SourceHostId


=item * SourceHostName


=item * SourceId


=item * SourceName


=item * SourceStoragesetId


=item * SourceType


=item * SourceVolumeId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpRelationshipInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   DestinationAggregateId => $some_value, # ObjId
   DestinationFullName => $some_value, # ObjFullName
   DestinationHostId => $some_value, # ObjId
   DestinationHostName => $some_value, # ObjFullName
   DestinationId => $some_value, # ObjId
   DestinationName => $some_value, # ObjName
   DestinationStoragesetId => $some_value, # ObjId
   DestinationType => $some_value, # RelationshipEndpointType
   DestinationVolumeId => $some_value, # ObjId
   DiscoveredTimestamp => $some_value, # DpTimestamp
   IsDpIgnored =>  $some_value, # boolean
   IsDpImported =>  $some_value, # boolean
   IsDpManaged =>  $some_value, # boolean
   IsDpOrphan =>  $some_value, # boolean
   IsDpRedundant =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   Lag => $some_value, # atomic
   LagStatus => $some_value, # ObjStatus
   OperationalStatus => $some_value, # OperationalStatus
   RelationshipId => $some_value, # ObjId
   RelationshipState => $some_value, # RelationshipState
   RelationshipType => $some_value, # RelationshipType
   SourceAggregateId => $some_value, # ObjId
   SourceFullName => $some_value, # ObjFullName
   SourceHostId => $some_value, # ObjId
   SourceHostName => $some_value, # ObjFullName
   SourceId => $some_value, # ObjId
   SourceName => $some_value, # ObjName
   SourceStoragesetId => $some_value, # ObjId
   SourceType => $some_value, # RelationshipEndpointType
   SourceVolumeId => $some_value, # ObjId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

