package MyTypes::DpRelationshipLagInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Lag_of :ATTR(:get<Lag>);
my %RelationshipId_of :ATTR(:get<RelationshipId>);
my %RelationshipSource_of :ATTR(:get<RelationshipSource>);
my %RelationshipState_of :ATTR(:get<RelationshipState>);
my %RelationshipType_of :ATTR(:get<RelationshipType>);

__PACKAGE__->_factory(
    [ qw(        Lag
        RelationshipId
        RelationshipSource
        RelationshipState
        RelationshipType

    ) ],
    {
        'Lag' => \%Lag_of,
        'RelationshipId' => \%RelationshipId_of,
        'RelationshipSource' => \%RelationshipSource_of,
        'RelationshipState' => \%RelationshipState_of,
        'RelationshipType' => \%RelationshipType_of,
    },
    {

        'Lag' => 'MyTypes::DpRelationshipLagInfo::_Lag',
        'RelationshipId' => 'MyTypes::ObjId',
        'RelationshipSource' => 'MyTypes::ObjName',
        'RelationshipState' => 'MyTypes::RelationshipState',
        'RelationshipType' => 'MyTypes::RelationshipType',
    },
    {

        'Lag' => 'Lag',
        'RelationshipId' => 'RelationshipId',
        'RelationshipSource' => 'RelationshipSource',
        'RelationshipState' => 'RelationshipState',
        'RelationshipType' => 'RelationshipType',
    }
);

} # end BLOCK




package MyTypes::DpRelationshipLagInfo::_Lag;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpRelationshipLagInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpRelationshipLagInfo from the namespace http://www.netapp.com/management/v1.

Information about a single SnapVault or SnapMirror relationship.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Lag


=item * RelationshipId


=item * RelationshipSource


=item * RelationshipState


=item * RelationshipType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpRelationshipLagInfo
   Lag => $some_value, # atomic
   RelationshipId => $some_value, # ObjId
   RelationshipSource => $some_value, # ObjName
   RelationshipState => $some_value, # RelationshipState
   RelationshipType => $some_value, # RelationshipType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

