package MyTypes::DpScheduledJob;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DpLocalSnapshotJobData_of :ATTR(:get<DpLocalSnapshotJobData>);
my %DpSnapmirrorTransferJobData_of :ATTR(:get<DpSnapmirrorTransferJobData>);
my %DpSnapvaultTransferJobData_of :ATTR(:get<DpSnapvaultTransferJobData>);
my %ScheduledTime_of :ATTR(:get<ScheduledTime>);
my %StartTime_of :ATTR(:get<StartTime>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DpLocalSnapshotJobData
        DpSnapmirrorTransferJobData
        DpSnapvaultTransferJobData
        ScheduledTime
        StartTime

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DpLocalSnapshotJobData' => \%DpLocalSnapshotJobData_of,
        'DpSnapmirrorTransferJobData' => \%DpSnapmirrorTransferJobData_of,
        'DpSnapvaultTransferJobData' => \%DpSnapvaultTransferJobData_of,
        'ScheduledTime' => \%ScheduledTime_of,
        'StartTime' => \%StartTime_of,
    },
    {

        'DatasetId' => 'MyTypes::DpScheduledJob::_DatasetId',
        'DpLocalSnapshotJobData' => 'MyTypes::DpLocalSnapshotJobData',
        'DpSnapmirrorTransferJobData' => 'MyTypes::DpSnapmirrorTransferJobData',
        'DpSnapvaultTransferJobData' => 'MyTypes::DpSnapvaultTransferJobData',
        'ScheduledTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'DatasetId' => 'DatasetId',
        'DpLocalSnapshotJobData' => 'DpLocalSnapshotJobData',
        'DpSnapmirrorTransferJobData' => 'DpSnapmirrorTransferJobData',
        'DpSnapvaultTransferJobData' => 'DpSnapvaultTransferJobData',
        'ScheduledTime' => 'ScheduledTime',
        'StartTime' => 'StartTime',
    }
);

} # end BLOCK




package MyTypes::DpScheduledJob::_DatasetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::DpScheduledJob

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpScheduledJob from the namespace http://www.netapp.com/management/v1.

Describes a scheduled data protection job. Each job has a scheduled start time and protects a single Dataset. Scheduler Service is responsible for starting job at its scheduled time. Type of job is inferred From which dp-*-job-data element is present. Only one of all possible dp-*-job-data elements can be present. Scheduled job does not have a job Id. When scheduler Service is about To start the job, it creates a job record in the persistent database and at that time job gets its Id.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DpLocalSnapshotJobData


=item * DpSnapmirrorTransferJobData


=item * DpSnapvaultTransferJobData


=item * ScheduledTime


=item * StartTime




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpScheduledJob
   DatasetId => $some_value, # atomic
   DpLocalSnapshotJobData =>  { # MyTypes::DpLocalSnapshotJobData
     IsConfirmationData =>  $some_value, # boolean
     NodeId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
   DpSnapmirrorTransferJobData =>  { # MyTypes::DpSnapmirrorTransferJobData
     ConnectionId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
   DpSnapvaultTransferJobData =>  { # MyTypes::DpSnapvaultTransferJobData
     ConnectionId => $some_value, # atomic
     RetentionType => $some_value, # DpBackupRetentionType
   },
   ScheduledTime =>  $some_value, # integer
   StartTime =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

