package MyTypes::DpViRestoreObject;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpViObjectRestoreSettings_of :ATTR(:get<DpViObjectRestoreSettings>);
my %RestoreObjectNameOrId_of :ATTR(:get<RestoreObjectNameOrId>);

__PACKAGE__->_factory(
    [ qw(        DpViObjectRestoreSettings
        RestoreObjectNameOrId

    ) ],
    {
        'DpViObjectRestoreSettings' => \%DpViObjectRestoreSettings_of,
        'RestoreObjectNameOrId' => \%RestoreObjectNameOrId_of,
    },
    {
        'DpViObjectRestoreSettings' => 'MyTypes::DpViObjectRestoreSettings',
        'RestoreObjectNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'DpViObjectRestoreSettings' => 'DpViObjectRestoreSettings',
        'RestoreObjectNameOrId' => 'RestoreObjectNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpViRestoreObject

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpViRestoreObject from the namespace http://www.netapp.com/management/v1.

A list of virtual Objects To be restored, and per object settings for this restore Operation.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpViObjectRestoreSettings


=item * RestoreObjectNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpViRestoreObject
   DpViObjectRestoreSettings =>  { # MyTypes::DpViObjectRestoreSettings
     DpViVmwareObjectRestoreSettings =>  { # MyTypes::DpViVmwareObjectRestoreSettings
       DestinationDatastoreNameOrId => $some_value, # ObjNameOrId
     },
   },
   RestoreObjectNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

