package MyTypes::DpViRestoreSettings;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpViHypervRestoreSettings_of :ATTR(:get<DpViHypervRestoreSettings>);
my %DpViVmwareRestoreSettings_of :ATTR(:get<DpViVmwareRestoreSettings>);
my %RestoreScript_of :ATTR(:get<RestoreScript>);

__PACKAGE__->_factory(
    [ qw(        DpViHypervRestoreSettings
        DpViVmwareRestoreSettings
        RestoreScript

    ) ],
    {
        'DpViHypervRestoreSettings' => \%DpViHypervRestoreSettings_of,
        'DpViVmwareRestoreSettings' => \%DpViVmwareRestoreSettings_of,
        'RestoreScript' => \%RestoreScript_of,
    },
    {
        'DpViHypervRestoreSettings' => 'MyTypes::DpViHypervRestoreSettings',
        'DpViVmwareRestoreSettings' => 'MyTypes::DpViVmwareRestoreSettings',
        'RestoreScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DpViHypervRestoreSettings' => 'DpViHypervRestoreSettings',
        'DpViVmwareRestoreSettings' => 'DpViVmwareRestoreSettings',
        'RestoreScript' => 'RestoreScript',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DpViRestoreSettings

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DpViRestoreSettings from the namespace http://www.netapp.com/management/v1.

Various settings for the Operation To restore the virtualization Objects.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpViHypervRestoreSettings


=item * DpViVmwareRestoreSettings


=item * RestoreScript




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DpViRestoreSettings
   DpViHypervRestoreSettings =>  { # MyTypes::DpViHypervRestoreSettings
     StartVmAfterRestore =>  $some_value, # boolean
   },
   DpViVmwareRestoreSettings =>  { # MyTypes::DpViVmwareRestoreSettings
     EsxServerNameOrId => $some_value, # ObjNameOrId
     StartVmAfterRestore =>  $some_value, # boolean
   },
   RestoreScript =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

