package MyTypes::DrStatus;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
DrStatus from the namespace http://www.netapp.com/management/v1.

The DR Status has one of the following Values: <ul> <li> <b>normal</b> : A DR Operation would likely succeed, and the amount of lost data would be within the Duration specified by the Lag warning threshold. <li> <b>warning</b> : A DR Operation would likely succeed, but the amount of lost data would exceed that specified by the Policy's Lag warning threshold. <li> <b>Error</b> : A DR Operation would likely fail, or would succeed but the amount of lost data would be unacceptable. </ul> <P> The DR Status is computed based on all of the following: <ul> <li> The Resource Status of the Dataset's DR secondaries. The specific Condition that impacts the Resource Status is the availability of the secondary filers and Volumes. The Status will be Error if either is unavailable. <li> Whether there is sufficient space on the DR secondaries To meet the space guarantees of the primaries. <li> The existence and state of the relationships associated with the Dataset's disaster recovery capable connection. <li> Whether the relationships associated with the Dataset's DR-capable connection are within their Thresholds for Lag warnings and Errors. </ul> <P> If the Dataset list iteration's output element <b>IsDrCapable</b> is true, then this element appears in the output. Otherwise, if <b>IsDrCapable</b> is false, this element does not appear in the output.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

