package MyTypes::DrStatusProblem;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DrStatusDescription_of :ATTR(:get<DrStatusDescription>);
my %DrStatusSeverity_of :ATTR(:get<DrStatusSeverity>);

__PACKAGE__->_factory(
    [ qw(        DrStatusDescription
        DrStatusSeverity

    ) ],
    {
        'DrStatusDescription' => \%DrStatusDescription_of,
        'DrStatusSeverity' => \%DrStatusSeverity_of,
    },
    {
        'DrStatusDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DrStatusSeverity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DrStatusDescription' => 'DrStatusDescription',
        'DrStatusSeverity' => 'DrStatusSeverity',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DrStatusProblem

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DrStatusProblem from the namespace http://www.netapp.com/management/v1.

An explanation of a single problem that causes the Dataset not To have a <b>DrStatus</b> of "normal".




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DrStatusDescription


=item * DrStatusSeverity




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DrStatusProblem
   DrStatusDescription =>  $some_value, # string
   DrStatusSeverity =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

