package MyTypes::DryRunResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DryRunAction_of :ATTR(:get<DryRunAction>);
my %DryRunEffect_of :ATTR(:get<DryRunEffect>);
my %DryRunReason_of :ATTR(:get<DryRunReason>);
my %DryRunReasonDetails_of :ATTR(:get<DryRunReasonDetails>);
my %DryRunSeverity_of :ATTR(:get<DryRunSeverity>);
my %DryRunSuggestion_of :ATTR(:get<DryRunSuggestion>);

__PACKAGE__->_factory(
    [ qw(        DryRunAction
        DryRunEffect
        DryRunReason
        DryRunReasonDetails
        DryRunSeverity
        DryRunSuggestion

    ) ],
    {
        'DryRunAction' => \%DryRunAction_of,
        'DryRunEffect' => \%DryRunEffect_of,
        'DryRunReason' => \%DryRunReason_of,
        'DryRunReasonDetails' => \%DryRunReasonDetails_of,
        'DryRunSeverity' => \%DryRunSeverity_of,
        'DryRunSuggestion' => \%DryRunSuggestion_of,
    },
    {
        'DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
        'DryRunSeverity' => 'MyTypes::ObjStatus',
        'DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DryRunAction' => 'DryRunAction',
        'DryRunEffect' => 'DryRunEffect',
        'DryRunReason' => 'DryRunReason',
        'DryRunReasonDetails' => 'DryRunReasonDetails',
        'DryRunSeverity' => 'DryRunSeverity',
        'DryRunSuggestion' => 'DryRunSuggestion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DryRunResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DryRunResult from the namespace http://www.netapp.com/management/v1.

A Description of one Action and the predicted effects of taking that Action.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DryRunAction


=item * DryRunEffect


=item * DryRunReason


=item * DryRunReasonDetails


=item * DryRunSeverity


=item * DryRunSuggestion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DryRunResult
   DryRunAction =>  $some_value, # string
   DryRunEffect =>  $some_value, # string
   DryRunReason =>  $some_value, # string
   DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
     ResultDetail =>  { # MyTypes::ResultDetail
       Action =>  $some_value, # string
       Effect =>  $some_value, # string
       Reason =>  $some_value, # string
       Severity => $some_value, # ObjStatus
       Suggestion =>  $some_value, # string
     },
   },
   DryRunSeverity => $some_value, # ObjStatus
   DryRunSuggestion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

