package MyTypes::DynamicData;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Hostname_of :ATTR(:get<Hostname>);
my %InstanceName_of :ATTR(:get<InstanceName>);
my %ObjId_of :ATTR(:get<ObjId>);
my %Value_of :ATTR(:get<Value>);

__PACKAGE__->_factory(
    [ qw(        Hostname
        InstanceName
        ObjId
        Value

    ) ],
    {
        'Hostname' => \%Hostname_of,
        'InstanceName' => \%InstanceName_of,
        'ObjId' => \%ObjId_of,
        'Value' => \%Value_of,
    },
    {
        'Hostname' => 'MyTypes::ObjName',
        'InstanceName' => 'MyTypes::WrapperOfPerfInstance',
        'ObjId' => 'MyTypes::ObjId',
        'Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Hostname' => 'Hostname',
        'InstanceName' => 'InstanceName',
        'ObjId' => 'ObjId',
        'Value' => 'Value',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::DynamicData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
DynamicData from the namespace http://www.netapp.com/management/v1.

Contains data for top-N Objects




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Hostname


=item * InstanceName


=item * ObjId


=item * Value




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::DynamicData
   Hostname => $some_value, # ObjName
   InstanceName =>  { # MyTypes::WrapperOfPerfInstance
     PerfInstance =>  { # MyTypes::PerfInstance
       InstanceName =>  $some_value, # string
     },
   },
   ObjId => $some_value, # ObjId
   Value =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

