package MyTypes::EventActionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ErrorCode_of :ATTR(:get<ErrorCode>);
my %ErrorMessage_of :ATTR(:get<ErrorMessage>);
my %EventId_of :ATTR(:get<EventId>);
my %Timestamp_of :ATTR(:get<Timestamp>);

__PACKAGE__->_factory(
    [ qw(        ErrorCode
        ErrorMessage
        EventId
        Timestamp

    ) ],
    {
        'ErrorCode' => \%ErrorCode_of,
        'ErrorMessage' => \%ErrorMessage_of,
        'EventId' => \%EventId_of,
        'Timestamp' => \%Timestamp_of,
    },
    {

        'ErrorCode' => 'MyTypes::EventActionInfo::_ErrorCode',
        'ErrorMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'Timestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
    },
    {

        'ErrorCode' => 'ErrorCode',
        'ErrorMessage' => 'ErrorMessage',
        'EventId' => 'EventId',
        'Timestamp' => 'Timestamp',
    }
);

} # end BLOCK




package MyTypes::EventActionInfo::_ErrorCode;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::EventActionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
EventActionInfo from the namespace http://www.netapp.com/management/v1.

Result of Action taken on event. Timestamp returned on success, and Error code on failure.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ErrorCode


=item * ErrorMessage


=item * EventId


=item * Timestamp




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::EventActionInfo
   ErrorCode => $some_value, # atomic
   ErrorMessage =>  $some_value, # string
   EventId =>  $some_value, # unsignedInt
   Timestamp =>  $some_value, # unsignedInt
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

