package MyTypes::EventClassInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AboutMessage_of :ATTR(:get<AboutMessage>);
my %EventClassId_of :ATTR(:get<EventClassId>);
my %EventClassName_of :ATTR(:get<EventClassName>);
my %EventNames_of :ATTR(:get<EventNames>);
my %IsAllowDuplicates_of :ATTR(:get<IsAllowDuplicates>);
my %IsMultiCurrent_of :ATTR(:get<IsMultiCurrent>);

__PACKAGE__->_factory(
    [ qw(        AboutMessage
        EventClassId
        EventClassName
        EventNames
        IsAllowDuplicates
        IsMultiCurrent

    ) ],
    {
        'AboutMessage' => \%AboutMessage_of,
        'EventClassId' => \%EventClassId_of,
        'EventClassName' => \%EventClassName_of,
        'EventNames' => \%EventNames_of,
        'IsAllowDuplicates' => \%IsAllowDuplicates_of,
        'IsMultiCurrent' => \%IsMultiCurrent_of,
    },
    {
        'AboutMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventClassId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventNames' => 'MyTypes::ArrayOfEventNameInfo',
        'IsAllowDuplicates' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsMultiCurrent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'AboutMessage' => 'AboutMessage',
        'EventClassId' => 'EventClassId',
        'EventClassName' => 'EventClassName',
        'EventNames' => 'EventNames',
        'IsAllowDuplicates' => 'IsAllowDuplicates',
        'IsMultiCurrent' => 'IsMultiCurrent',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::EventClassInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
EventClassInfo from the namespace http://www.netapp.com/management/v1.

Information about an event class.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AboutMessage


=item * EventClassId


=item * EventClassName


=item * EventNames


=item * IsAllowDuplicates


=item * IsMultiCurrent




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::EventClassInfo
   AboutMessage =>  $some_value, # string
   EventClassId =>  $some_value, # integer
   EventClassName =>  $some_value, # string
   EventNames =>  { # MyTypes::ArrayOfEventNameInfo
     EventNameInfo =>  { # MyTypes::EventNameInfo
       EventNamePretty =>  $some_value, # string
       EventNameShort =>  $some_value, # string
       Severity =>  $some_value, # string
     },
   },
   IsAllowDuplicates =>  $some_value, # boolean
   IsMultiCurrent =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

