package MyTypes::EventClassObject;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventClassName_of :ATTR(:get<EventClassName>);

__PACKAGE__->_factory(
    [ qw(        EventClassName

    ) ],
    {
        'EventClassName' => \%EventClassName_of,
    },
    {
        'EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'EventClassName' => 'EventClassName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::EventClassObject

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
EventClassObject from the namespace http://www.netapp.com/management/v1.

Custom event class.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventClassName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::EventClassObject
   EventClassName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

