package MyTypes::EventInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EventAbout_of :ATTR(:get<EventAbout>);
my %EventAcknowledged_of :ATTR(:get<EventAcknowledged>);
my %EventAcknowledgedUser_of :ATTR(:get<EventAcknowledgedUser>);
my %EventArguments_of :ATTR(:get<EventArguments>);
my %EventCondition_of :ATTR(:get<EventCondition>);
my %EventDeleted_of :ATTR(:get<EventDeleted>);
my %EventDeletedUser_of :ATTR(:get<EventDeletedUser>);
my %EventId_of :ATTR(:get<EventId>);
my %EventName_of :ATTR(:get<EventName>);
my %EventOriginatingId_of :ATTR(:get<EventOriginatingId>);
my %EventSeverity_of :ATTR(:get<EventSeverity>);
my %EventSourceId_of :ATTR(:get<EventSourceId>);
my %EventSourceName_of :ATTR(:get<EventSourceName>);
my %EventSourceNodeName_of :ATTR(:get<EventSourceNodeName>);
my %EventSourceType_of :ATTR(:get<EventSourceType>);
my %EventTime_of :ATTR(:get<EventTime>);
my %EventType_of :ATTR(:get<EventType>);
my %IsDeleted_of :ATTR(:get<IsDeleted>);

__PACKAGE__->_factory(
    [ qw(        EventAbout
        EventAcknowledged
        EventAcknowledgedUser
        EventArguments
        EventCondition
        EventDeleted
        EventDeletedUser
        EventId
        EventName
        EventOriginatingId
        EventSeverity
        EventSourceId
        EventSourceName
        EventSourceNodeName
        EventSourceType
        EventTime
        EventType
        IsDeleted

    ) ],
    {
        'EventAbout' => \%EventAbout_of,
        'EventAcknowledged' => \%EventAcknowledged_of,
        'EventAcknowledgedUser' => \%EventAcknowledgedUser_of,
        'EventArguments' => \%EventArguments_of,
        'EventCondition' => \%EventCondition_of,
        'EventDeleted' => \%EventDeleted_of,
        'EventDeletedUser' => \%EventDeletedUser_of,
        'EventId' => \%EventId_of,
        'EventName' => \%EventName_of,
        'EventOriginatingId' => \%EventOriginatingId_of,
        'EventSeverity' => \%EventSeverity_of,
        'EventSourceId' => \%EventSourceId_of,
        'EventSourceName' => \%EventSourceName_of,
        'EventSourceNodeName' => \%EventSourceNodeName_of,
        'EventSourceType' => \%EventSourceType_of,
        'EventTime' => \%EventTime_of,
        'EventType' => \%EventType_of,
        'IsDeleted' => \%IsDeleted_of,
    },
    {
        'EventAbout' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventAcknowledgedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventArguments' => 'MyTypes::ArrayOfKeyValuePair',
        'EventCondition' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventDeletedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'EventId' => 'MyTypes::EventInfo::_EventId',
        'EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'EventOriginatingId' => 'MyTypes::EventInfo::_EventOriginatingId',
        'EventSeverity' => 'MyTypes::ObjStatus',

        'EventSourceId' => 'MyTypes::EventInfo::_EventSourceId',
        'EventSourceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventSourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventSourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'EventTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'EventType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'EventAbout' => 'EventAbout',
        'EventAcknowledged' => 'EventAcknowledged',
        'EventAcknowledgedUser' => 'EventAcknowledgedUser',
        'EventArguments' => 'EventArguments',
        'EventCondition' => 'EventCondition',
        'EventDeleted' => 'EventDeleted',
        'EventDeletedUser' => 'EventDeletedUser',
        'EventId' => 'EventId',
        'EventName' => 'EventName',
        'EventOriginatingId' => 'EventOriginatingId',
        'EventSeverity' => 'EventSeverity',
        'EventSourceId' => 'EventSourceId',
        'EventSourceName' => 'EventSourceName',
        'EventSourceNodeName' => 'EventSourceNodeName',
        'EventSourceType' => 'EventSourceType',
        'EventTime' => 'EventTime',
        'EventType' => 'EventType',
        'IsDeleted' => 'IsDeleted',
    }
);

} # end BLOCK




package MyTypes::EventInfo::_EventId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::EventInfo::_EventOriginatingId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::EventInfo::_EventSourceId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::EventInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
EventInfo from the namespace http://www.netapp.com/management/v1.

Event information structure




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EventAbout


=item * EventAcknowledged


=item * EventAcknowledgedUser


=item * EventArguments


=item * EventCondition


=item * EventDeleted


=item * EventDeletedUser


=item * EventId


=item * EventName


=item * EventOriginatingId


=item * EventSeverity


=item * EventSourceId


=item * EventSourceName


=item * EventSourceNodeName


=item * EventSourceType


=item * EventTime


=item * EventType


=item * IsDeleted




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::EventInfo
   EventAbout =>  $some_value, # string
   EventAcknowledged =>  $some_value, # integer
   EventAcknowledgedUser =>  $some_value, # string
   EventArguments =>  { # MyTypes::ArrayOfKeyValuePair
     KeyValuePair =>  { # MyTypes::KeyValuePair
       Key =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   EventCondition =>  $some_value, # string
   EventDeleted =>  $some_value, # integer
   EventDeletedUser =>  $some_value, # string
   EventId => $some_value, # atomic
   EventName =>  $some_value, # string
   EventOriginatingId => $some_value, # atomic
   EventSeverity => $some_value, # ObjStatus
   EventSourceId => $some_value, # atomic
   EventSourceName =>  $some_value, # string
   EventSourceNodeName =>  $some_value, # string
   EventSourceType =>  $some_value, # string
   EventTime =>  $some_value, # integer
   EventType =>  $some_value, # string
   IsDeleted =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

