package MyTypes::EventTimestampRange;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EndTime_of :ATTR(:get<EndTime>);
my %StartTime_of :ATTR(:get<StartTime>);

__PACKAGE__->_factory(
    [ qw(        EndTime
        StartTime

    ) ],
    {
        'EndTime' => \%EndTime_of,
        'StartTime' => \%StartTime_of,
    },
    {
        'EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'EndTime' => 'EndTime',
        'StartTime' => 'StartTime',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::EventTimestampRange

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
EventTimestampRange from the namespace http://www.netapp.com/management/v1.

range of event timestamps




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EndTime


=item * StartTime




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::EventTimestampRange
   EndTime =>  $some_value, # integer
   StartTime =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

