package MyTypes::ExcludedObjectInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %ObjectType_of :ATTR(:get<ObjectType>);

__PACKAGE__->_factory(
    [ qw(        ObjectId
        ObjectName
        ObjectType

    ) ],
    {
        'ObjectId' => \%ObjectId_of,
        'ObjectName' => \%ObjectName_of,
        'ObjectType' => \%ObjectType_of,
    },
    {
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectName' => 'MyTypes::ObjName',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ObjectId' => 'ObjectId',
        'ObjectName' => 'ObjectName',
        'ObjectType' => 'ObjectType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ExcludedObjectInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ExcludedObjectInfo from the namespace http://www.netapp.com/management/v1.

Information about a Datastore in a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ObjectId


=item * ObjectName


=item * ObjectType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ExcludedObjectInfo
   ObjectId => $some_value, # ObjId
   ObjectName => $some_value, # ObjName
   ObjectType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

