package MyTypes::FaultDetail;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %OperationError_of :ATTR(:get<OperationError>);
my %Reason_of :ATTR(:get<Reason>);

__PACKAGE__->_factory(
    [ qw(        OperationError
        Reason

    ) ],
    {
        'OperationError' => \%OperationError_of,
        'Reason' => \%Reason_of,
    },
    {
        'OperationError' => 'MyTypes::OperationError',
        'Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'OperationError' => 'OperationError',
        'Reason' => 'Reason',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::FaultDetail

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
FaultDetail from the namespace http://www.netapp.com/management/v1.

Faults will use this type to provide access to error information and reason.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * OperationError


=item * Reason




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::FaultDetail
   OperationError =>  { # MyTypes::OperationError
     Code =>  $some_value, # unsignedInt
     Name =>  $some_value, # string
   },
   Reason =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

