package MyTypes::Feature;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IsLicenseExpired_of :ATTR(:get<IsLicenseExpired>);
my %Name_of :ATTR(:get<Name>);
my %Summary_of :ATTR(:get<Summary>);

__PACKAGE__->_factory(
    [ qw(        IsLicenseExpired
        Name
        Summary

    ) ],
    {
        'IsLicenseExpired' => \%IsLicenseExpired_of,
        'Name' => \%Name_of,
        'Summary' => \%Summary_of,
    },
    {
        'IsLicenseExpired' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Summary' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'IsLicenseExpired' => 'IsLicenseExpired',
        'Name' => 'Name',
        'Summary' => 'Summary',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Feature

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Feature from the namespace http://www.netapp.com/management/v1.

Information about a licensed Feature.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IsLicenseExpired


=item * Name


=item * Summary




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Feature
   IsLicenseExpired =>  $some_value, # boolean
   Name =>  $some_value, # string
   Summary =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

