package MyTypes::FilerResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FilerId_of :ATTR(:get<FilerId>);
my %FilerName_of :ATTR(:get<FilerName>);

__PACKAGE__->_factory(
    [ qw(        FilerId
        FilerName

    ) ],
    {
        'FilerId' => \%FilerId_of,
        'FilerName' => \%FilerName_of,
    },
    {
        'FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'FilerId' => 'FilerId',
        'FilerName' => 'FilerName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::FilerResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
FilerResource from the namespace http://www.netapp.com/management/v1.

Details of a storage system Resource. When used as input only one of FilerName or FilerId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FilerId


=item * FilerName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::FilerResource
   FilerId =>  $some_value, # unsignedInt
   FilerName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

