package MyTypes::FullNdmpCredentials;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %NdmpPassword_of :ATTR(:get<NdmpPassword>);
my %NdmpPort_of :ATTR(:get<NdmpPort>);
my %NdmpUsername_of :ATTR(:get<NdmpUsername>);

__PACKAGE__->_factory(
    [ qw(        NdmpPassword
        NdmpPort
        NdmpUsername

    ) ],
    {
        'NdmpPassword' => \%NdmpPassword_of,
        'NdmpPort' => \%NdmpPort_of,
        'NdmpUsername' => \%NdmpUsername_of,
    },
    {
        'NdmpPassword' => 'MyTypes::HostPassword',
        'NdmpPort' => 'MyTypes::IpPortNumber',
        'NdmpUsername' => 'MyTypes::NdmpUsername',
    },
    {

        'NdmpPassword' => 'NdmpPassword',
        'NdmpPort' => 'NdmpPort',
        'NdmpUsername' => 'NdmpUsername',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::FullNdmpCredentials

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
FullNdmpCredentials from the namespace http://www.netapp.com/management/v1.

A full set of ndmp credentials with no empty fields which is a specific requirement for this zapi since NdmpUsername and NdmpPassword are both required in order To add an ossv Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * NdmpPassword


=item * NdmpPort


=item * NdmpUsername




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::FullNdmpCredentials
   NdmpPassword => $some_value, # HostPassword
   NdmpPort => $some_value, # IpPortNumber
   NdmpUsername => $some_value, # NdmpUsername
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

