package MyTypes::GraphInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DeprecatedBy_of :ATTR(:get<DeprecatedBy>);
my %Description_of :ATTR(:get<Description>);
my %GraphLines_of :ATTR(:get<GraphLines>);
my %GraphName_of :ATTR(:get<GraphName>);
my %GraphPrettyName_of :ATTR(:get<GraphPrettyName>);
my %IsDefault_of :ATTR(:get<IsDefault>);
my %IsDeprecated_of :ATTR(:get<IsDeprecated>);

__PACKAGE__->_factory(
    [ qw(        DeprecatedBy
        Description
        GraphLines
        GraphName
        GraphPrettyName
        IsDefault
        IsDeprecated

    ) ],
    {
        'DeprecatedBy' => \%DeprecatedBy_of,
        'Description' => \%Description_of,
        'GraphLines' => \%GraphLines_of,
        'GraphName' => \%GraphName_of,
        'GraphPrettyName' => \%GraphPrettyName_of,
        'IsDefault' => \%IsDefault_of,
        'IsDeprecated' => \%IsDeprecated_of,
    },
    {
        'DeprecatedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GraphLines' => 'MyTypes::ArrayOfGraphLineInfo',
        'GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GraphPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDeprecated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'DeprecatedBy' => 'DeprecatedBy',
        'Description' => 'Description',
        'GraphLines' => 'GraphLines',
        'GraphName' => 'GraphName',
        'GraphPrettyName' => 'GraphPrettyName',
        'IsDefault' => 'IsDefault',
        'IsDeprecated' => 'IsDeprecated',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GraphInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GraphInfo from the namespace http://www.netapp.com/management/v1.

Describes the meta data of a graph




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DeprecatedBy


=item * Description


=item * GraphLines


=item * GraphName


=item * GraphPrettyName


=item * IsDefault


=item * IsDeprecated




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GraphInfo
   DeprecatedBy =>  $some_value, # string
   Description =>  $some_value, # string
   GraphLines =>  { # MyTypes::ArrayOfGraphLineInfo
     GraphLineInfo =>  { # MyTypes::GraphLineInfo
       SampleFormat =>  $some_value, # string
       SampleName =>  $some_value, # string
       SamplePrettyName =>  $some_value, # string
       SampleSuffix =>  $some_value, # string
     },
   },
   GraphName =>  $some_value, # string
   GraphPrettyName =>  $some_value, # string
   IsDefault =>  $some_value, # boolean
   IsDeprecated =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

