package MyTypes::GraphLineInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SampleFormat_of :ATTR(:get<SampleFormat>);
my %SampleName_of :ATTR(:get<SampleName>);
my %SamplePrettyName_of :ATTR(:get<SamplePrettyName>);
my %SampleSuffix_of :ATTR(:get<SampleSuffix>);

__PACKAGE__->_factory(
    [ qw(        SampleFormat
        SampleName
        SamplePrettyName
        SampleSuffix

    ) ],
    {
        'SampleFormat' => \%SampleFormat_of,
        'SampleName' => \%SampleName_of,
        'SamplePrettyName' => \%SamplePrettyName_of,
        'SampleSuffix' => \%SampleSuffix_of,
    },
    {
        'SampleFormat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SampleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SamplePrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SampleSuffix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'SampleFormat' => 'SampleFormat',
        'SampleName' => 'SampleName',
        'SamplePrettyName' => 'SamplePrettyName',
        'SampleSuffix' => 'SampleSuffix',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GraphLineInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GraphLineInfo from the namespace http://www.netapp.com/management/v1.

Describes the meta data of a line in a graph.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SampleFormat


=item * SampleName


=item * SamplePrettyName


=item * SampleSuffix




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GraphLineInfo
   SampleFormat =>  $some_value, # string
   SampleName =>  $some_value, # string
   SamplePrettyName =>  $some_value, # string
   SampleSuffix =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

