package MyTypes::GraphLineValueInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SampleName_of :ATTR(:get<SampleName>);
my %SampleValues_of :ATTR(:get<SampleValues>);

__PACKAGE__->_factory(
    [ qw(        SampleName
        SampleValues

    ) ],
    {
        'SampleName' => \%SampleName_of,
        'SampleValues' => \%SampleValues_of,
    },
    {
        'SampleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SampleValues' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'SampleName' => 'SampleName',
        'SampleValues' => 'SampleValues',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GraphLineValueInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GraphLineValueInfo from the namespace http://www.netapp.com/management/v1.

The sample Values of a line in a graph.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SampleName


=item * SampleValues




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GraphLineValueInfo
   SampleName =>  $some_value, # string
   SampleValues =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

