package MyTypes::GroupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupPerfStatus_of :ATTR(:get<GroupPerfStatus>);
my %GroupStatus_of :ATTR(:get<GroupStatus>);
my %HasPrivilege_of :ATTR(:get<HasPrivilege>);
my %Id_of :ATTR(:get<Id>);
my %Name_of :ATTR(:get<Name>);
my %ParentGroupId_of :ATTR(:get<ParentGroupId>);
my %ShortName_of :ATTR(:get<ShortName>);
my %SubgroupCount_of :ATTR(:get<SubgroupCount>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        GroupPerfStatus
        GroupStatus
        HasPrivilege
        Id
        Name
        ParentGroupId
        ShortName
        SubgroupCount
        Type

    ) ],
    {
        'GroupPerfStatus' => \%GroupPerfStatus_of,
        'GroupStatus' => \%GroupStatus_of,
        'HasPrivilege' => \%HasPrivilege_of,
        'Id' => \%Id_of,
        'Name' => \%Name_of,
        'ParentGroupId' => \%ParentGroupId_of,
        'ShortName' => \%ShortName_of,
        'SubgroupCount' => \%SubgroupCount_of,
        'Type' => \%Type_of,
    },
    {
        'GroupPerfStatus' => 'MyTypes::ObjStatus',
        'GroupStatus' => 'MyTypes::ObjStatus',
        'HasPrivilege' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'Id' => 'MyTypes::GroupInfo::_Id',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ParentGroupId' => 'MyTypes::GroupInfo::_ParentGroupId',
        'ShortName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SubgroupCount' => 'MyTypes::GroupInfo::_SubgroupCount',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'GroupPerfStatus' => 'GroupPerfStatus',
        'GroupStatus' => 'GroupStatus',
        'HasPrivilege' => 'HasPrivilege',
        'Id' => 'Id',
        'Name' => 'Name',
        'ParentGroupId' => 'ParentGroupId',
        'ShortName' => 'ShortName',
        'SubgroupCount' => 'SubgroupCount',
        'Type' => 'Type',
    }
);

} # end BLOCK




package MyTypes::GroupInfo::_Id;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::GroupInfo::_ParentGroupId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::GroupInfo::_SubgroupCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::GroupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GroupInfo from the namespace http://www.netapp.com/management/v1.

Information about a single Group.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupPerfStatus


=item * GroupStatus


=item * HasPrivilege


=item * Id


=item * Name


=item * ParentGroupId


=item * ShortName


=item * SubgroupCount


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GroupInfo
   GroupPerfStatus => $some_value, # ObjStatus
   GroupStatus => $some_value, # ObjStatus
   HasPrivilege =>  $some_value, # boolean
   Id => $some_value, # atomic
   Name =>  $some_value, # string
   ParentGroupId => $some_value, # atomic
   ShortName =>  $some_value, # string
   SubgroupCount => $some_value, # atomic
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

