package MyTypes::GroupMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupMemberAttributes_of :ATTR(:get<GroupMemberAttributes>);
my %Id_of :ATTR(:get<Id>);
my %Name_of :ATTR(:get<Name>);
my %PerfStatus_of :ATTR(:get<PerfStatus>);
my %Status_of :ATTR(:get<Status>);
my %SubType_of :ATTR(:get<SubType>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        GroupMemberAttributes
        Id
        Name
        PerfStatus
        Status
        SubType
        Type

    ) ],
    {
        'GroupMemberAttributes' => \%GroupMemberAttributes_of,
        'Id' => \%Id_of,
        'Name' => \%Name_of,
        'PerfStatus' => \%PerfStatus_of,
        'Status' => \%Status_of,
        'SubType' => \%SubType_of,
        'Type' => \%Type_of,
    },
    {
        'GroupMemberAttributes' => 'MyTypes::ArrayOfGroupMemberAttribute',
        'Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PerfStatus' => 'MyTypes::ObjStatus',
        'Status' => 'MyTypes::ObjStatus',
        'SubType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'GroupMemberAttributes' => 'GroupMemberAttributes',
        'Id' => 'Id',
        'Name' => 'Name',
        'PerfStatus' => 'PerfStatus',
        'Status' => 'Status',
        'SubType' => 'SubType',
        'Type' => 'Type',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GroupMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GroupMemberInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupMemberAttributes


=item * Id


=item * Name


=item * PerfStatus


=item * Status


=item * SubType


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GroupMemberInfo
   GroupMemberAttributes =>  { # MyTypes::ArrayOfGroupMemberAttribute
     GroupMemberAttribute =>  { # MyTypes::GroupMemberAttribute
       Name =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   Id =>  $some_value, # string
   Name =>  $some_value, # string
   PerfStatus => $some_value, # ObjStatus
   Status => $some_value, # ObjStatus
   SubType =>  $some_value, # string
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

