package MyTypes::GroupOptionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ChargebackRate_of :ATTR(:get<ChargebackRate>);
my %GroupContact_of :ATTR(:get<GroupContact>);
my %GroupOwner_of :ATTR(:get<GroupOwner>);
my %SrmMaxLargeFiles_of :ATTR(:get<SrmMaxLargeFiles>);
my %SrmMaxNewMtimeFiles_of :ATTR(:get<SrmMaxNewMtimeFiles>);
my %SrmMaxOldAtimeFiles_of :ATTR(:get<SrmMaxOldAtimeFiles>);
my %SrmMaxOldMtimeFiles_of :ATTR(:get<SrmMaxOldMtimeFiles>);

__PACKAGE__->_factory(
    [ qw(        ChargebackRate
        GroupContact
        GroupOwner
        SrmMaxLargeFiles
        SrmMaxNewMtimeFiles
        SrmMaxOldAtimeFiles
        SrmMaxOldMtimeFiles

    ) ],
    {
        'ChargebackRate' => \%ChargebackRate_of,
        'GroupContact' => \%GroupContact_of,
        'GroupOwner' => \%GroupOwner_of,
        'SrmMaxLargeFiles' => \%SrmMaxLargeFiles_of,
        'SrmMaxNewMtimeFiles' => \%SrmMaxNewMtimeFiles_of,
        'SrmMaxOldAtimeFiles' => \%SrmMaxOldAtimeFiles_of,
        'SrmMaxOldMtimeFiles' => \%SrmMaxOldMtimeFiles_of,
    },
    {
        'ChargebackRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GroupContact' => 'MyTypes::EmailAddressList',
        'GroupOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SrmMaxLargeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxLargeFiles',

        'SrmMaxNewMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxNewMtimeFiles',

        'SrmMaxOldAtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldAtimeFiles',

        'SrmMaxOldMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldMtimeFiles',
    },
    {

        'ChargebackRate' => 'ChargebackRate',
        'GroupContact' => 'GroupContact',
        'GroupOwner' => 'GroupOwner',
        'SrmMaxLargeFiles' => 'SrmMaxLargeFiles',
        'SrmMaxNewMtimeFiles' => 'SrmMaxNewMtimeFiles',
        'SrmMaxOldAtimeFiles' => 'SrmMaxOldAtimeFiles',
        'SrmMaxOldMtimeFiles' => 'SrmMaxOldMtimeFiles',
    }
);

} # end BLOCK




package MyTypes::GroupOptionInfo::_SrmMaxLargeFiles;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::GroupOptionInfo::_SrmMaxNewMtimeFiles;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::GroupOptionInfo::_SrmMaxOldAtimeFiles;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::GroupOptionInfo::_SrmMaxOldMtimeFiles;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::GroupOptionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GroupOptionInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ChargebackRate


=item * GroupContact


=item * GroupOwner


=item * SrmMaxLargeFiles


=item * SrmMaxNewMtimeFiles


=item * SrmMaxOldAtimeFiles


=item * SrmMaxOldMtimeFiles




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GroupOptionInfo
   ChargebackRate =>  $some_value, # string
   GroupContact => $some_value, # EmailAddressList
   GroupOwner =>  $some_value, # string
   SrmMaxLargeFiles => $some_value, # atomic
   SrmMaxNewMtimeFiles => $some_value, # atomic
   SrmMaxOldAtimeFiles => $some_value, # atomic
   SrmMaxOldMtimeFiles => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

