package MyTypes::GroupResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GroupId_of :ATTR(:get<GroupId>);
my %GroupName_of :ATTR(:get<GroupName>);

__PACKAGE__->_factory(
    [ qw(        GroupId
        GroupName

    ) ],
    {
        'GroupId' => \%GroupId_of,
        'GroupName' => \%GroupName_of,
    },
    {
        'GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'GroupId' => 'GroupId',
        'GroupName' => 'GroupName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GroupResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GroupResource from the namespace http://www.netapp.com/management/v1.

Details of a DFM Group Resource. DFM Group Name or object Id of a DFM Group. When used as input only one of GroupName or GroupId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GroupId


=item * GroupName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GroupResource
   GroupId =>  $some_value, # unsignedInt
   GroupName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

