package MyTypes::HostClientStats;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CollectionPeriod_of :ATTR(:get<CollectionPeriod>);
my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %StartTime_of :ATTR(:get<StartTime>);
my %StatId_of :ATTR(:get<StatId>);
my %Stats_of :ATTR(:get<Stats>);

__PACKAGE__->_factory(
    [ qw(        CollectionPeriod
        ObjectId
        ObjectName
        StartTime
        StatId
        Stats

    ) ],
    {
        'CollectionPeriod' => \%CollectionPeriod_of,
        'ObjectId' => \%ObjectId_of,
        'ObjectName' => \%ObjectName_of,
        'StartTime' => \%StartTime_of,
        'StatId' => \%StatId_of,
        'Stats' => \%Stats_of,
    },
    {

        'CollectionPeriod' => 'MyTypes::HostClientStats::_CollectionPeriod',
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectName' => 'MyTypes::ObjName',
        'StartTime' => 'MyTypes::Timestamp',
        'StatId' => 'MyTypes::StatId',
        'Stats' => 'MyTypes::ArrayOfClientStats',
    },
    {

        'CollectionPeriod' => 'CollectionPeriod',
        'ObjectId' => 'ObjectId',
        'ObjectName' => 'ObjectName',
        'StartTime' => 'StartTime',
        'StatId' => 'StatId',
        'Stats' => 'Stats',
    }
);

} # end BLOCK




package MyTypes::HostClientStats::_CollectionPeriod;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::HostClientStats

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostClientStats from the namespace http://www.netapp.com/management/v1.

Contains the per-client operations on a Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CollectionPeriod


=item * ObjectId


=item * ObjectName


=item * StartTime


=item * StatId


=item * Stats




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostClientStats
   CollectionPeriod => $some_value, # atomic
   ObjectId => $some_value, # ObjId
   ObjectName => $some_value, # ObjName
   StartTime => $some_value, # Timestamp
   StatId => $some_value, # StatId
   Stats =>  { # MyTypes::ArrayOfClientStats
     ClientStats =>  { # MyTypes::ClientStats
       CifsOpStats =>  { # MyTypes::CifsOpStats
         OtherOperations => $some_value, # atomic
         ReadOperations => $some_value, # atomic
         WriteOperations => $some_value, # atomic
       },
       ClientNameOrIp =>  $some_value, # string
       NfsOpStats =>  { # MyTypes::NfsOpStats
         OtherOperations => $some_value, # atomic
         ReadOperations => $some_value, # atomic
         WriteOperations => $some_value, # atomic
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

