package MyTypes::HostDefaults;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminPortAgent_of :ATTR(:get<AdminPortAgent>);
my %AdminPortCacheHttp_of :ATTR(:get<AdminPortCacheHttp>);
my %AdminPortCacheHttps_of :ATTR(:get<AdminPortCacheHttps>);
my %AdminPortHost_of :ATTR(:get<AdminPortHost>);
my %AdminPortHostHttp_of :ATTR(:get<AdminPortHostHttp>);
my %AdminPortHostHttps_of :ATTR(:get<AdminPortHostHttps>);
my %AdminTransportAgent_of :ATTR(:get<AdminTransportAgent>);
my %AdminTransportCache_of :ATTR(:get<AdminTransportCache>);
my %AdminTransportHost_of :ATTR(:get<AdminTransportHost>);
my %NdmpPort_of :ATTR(:get<NdmpPort>);
my %PerfAdvisorTransportHost_of :ATTR(:get<PerfAdvisorTransportHost>);
my %SnapvaultMaxBackupThreads_of :ATTR(:get<SnapvaultMaxBackupThreads>);
my %Timeout_of :ATTR(:get<Timeout>);
my %UseHostsEquiv_of :ATTR(:get<UseHostsEquiv>);

__PACKAGE__->_factory(
    [ qw(        AdminPortAgent
        AdminPortCacheHttp
        AdminPortCacheHttps
        AdminPortHost
        AdminPortHostHttp
        AdminPortHostHttps
        AdminTransportAgent
        AdminTransportCache
        AdminTransportHost
        NdmpPort
        PerfAdvisorTransportHost
        SnapvaultMaxBackupThreads
        Timeout
        UseHostsEquiv

    ) ],
    {
        'AdminPortAgent' => \%AdminPortAgent_of,
        'AdminPortCacheHttp' => \%AdminPortCacheHttp_of,
        'AdminPortCacheHttps' => \%AdminPortCacheHttps_of,
        'AdminPortHost' => \%AdminPortHost_of,
        'AdminPortHostHttp' => \%AdminPortHostHttp_of,
        'AdminPortHostHttps' => \%AdminPortHostHttps_of,
        'AdminTransportAgent' => \%AdminTransportAgent_of,
        'AdminTransportCache' => \%AdminTransportCache_of,
        'AdminTransportHost' => \%AdminTransportHost_of,
        'NdmpPort' => \%NdmpPort_of,
        'PerfAdvisorTransportHost' => \%PerfAdvisorTransportHost_of,
        'SnapvaultMaxBackupThreads' => \%SnapvaultMaxBackupThreads_of,
        'Timeout' => \%Timeout_of,
        'UseHostsEquiv' => \%UseHostsEquiv_of,
    },
    {
        'AdminPortAgent' => 'MyTypes::IpPortNumber',
        'AdminPortCacheHttp' => 'MyTypes::IpPortNumber',
        'AdminPortCacheHttps' => 'MyTypes::IpPortNumber',
        'AdminPortHost' => 'MyTypes::IpPortNumber',
        'AdminPortHostHttp' => 'MyTypes::IpPortNumber',
        'AdminPortHostHttps' => 'MyTypes::IpPortNumber',
        'AdminTransportAgent' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AdminTransportCache' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AdminTransportHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NdmpPort' => 'MyTypes::IpPortNumber',
        'PerfAdvisorTransportHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SnapvaultMaxBackupThreads' => 'MyTypes::HostDefaults::_SnapvaultMaxBackupThreads',

        'Timeout' => 'MyTypes::HostDefaults::_Timeout',
        'UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'AdminPortAgent' => 'AdminPortAgent',
        'AdminPortCacheHttp' => 'AdminPortCacheHttp',
        'AdminPortCacheHttps' => 'AdminPortCacheHttps',
        'AdminPortHost' => 'AdminPortHost',
        'AdminPortHostHttp' => 'AdminPortHostHttp',
        'AdminPortHostHttps' => 'AdminPortHostHttps',
        'AdminTransportAgent' => 'AdminTransportAgent',
        'AdminTransportCache' => 'AdminTransportCache',
        'AdminTransportHost' => 'AdminTransportHost',
        'NdmpPort' => 'NdmpPort',
        'PerfAdvisorTransportHost' => 'PerfAdvisorTransportHost',
        'SnapvaultMaxBackupThreads' => 'SnapvaultMaxBackupThreads',
        'Timeout' => 'Timeout',
        'UseHostsEquiv' => 'UseHostsEquiv',
    }
);

} # end BLOCK




package MyTypes::HostDefaults::_SnapvaultMaxBackupThreads;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HostDefaults::_Timeout;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::HostDefaults

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostDefaults from the namespace http://www.netapp.com/management/v1.

The default Values for the Attributes defined by the Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminPortAgent


=item * AdminPortCacheHttp


=item * AdminPortCacheHttps


=item * AdminPortHost


=item * AdminPortHostHttp


=item * AdminPortHostHttps


=item * AdminTransportAgent


=item * AdminTransportCache


=item * AdminTransportHost


=item * NdmpPort


=item * PerfAdvisorTransportHost


=item * SnapvaultMaxBackupThreads


=item * Timeout


=item * UseHostsEquiv




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostDefaults
   AdminPortAgent => $some_value, # IpPortNumber
   AdminPortCacheHttp => $some_value, # IpPortNumber
   AdminPortCacheHttps => $some_value, # IpPortNumber
   AdminPortHost => $some_value, # IpPortNumber
   AdminPortHostHttp => $some_value, # IpPortNumber
   AdminPortHostHttps => $some_value, # IpPortNumber
   AdminTransportAgent =>  $some_value, # string
   AdminTransportCache =>  $some_value, # string
   AdminTransportHost =>  $some_value, # string
   NdmpPort => $some_value, # IpPortNumber
   PerfAdvisorTransportHost =>  $some_value, # string
   SnapvaultMaxBackupThreads => $some_value, # atomic
   Timeout => $some_value, # atomic
   UseHostsEquiv =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

