package MyTypes::HostDomainuserInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Sid_of :ATTR(:get<Sid>);
my %Capabilities_of :ATTR(:get<Capabilities>);
my %HostDomainuserId_of :ATTR(:get<HostDomainuserId>);
my %HostDomainuserName_of :ATTR(:get<HostDomainuserName>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %HostRoleIds_of :ATTR(:get<HostRoleIds>);
my %HostRoleNames_of :ATTR(:get<HostRoleNames>);
my %HostUsergroupIds_of :ATTR(:get<HostUsergroupIds>);
my %HostUsergroupNames_of :ATTR(:get<HostUsergroupNames>);

__PACKAGE__->_factory(
    [ qw(        Sid
        Capabilities
        HostDomainuserId
        HostDomainuserName
        HostId
        HostName
        HostRoleIds
        HostRoleNames
        HostUsergroupIds
        HostUsergroupNames

    ) ],
    {
        'Sid' => \%Sid_of,
        'Capabilities' => \%Capabilities_of,
        'HostDomainuserId' => \%HostDomainuserId_of,
        'HostDomainuserName' => \%HostDomainuserName_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'HostRoleIds' => \%HostRoleIds_of,
        'HostRoleNames' => \%HostRoleNames_of,
        'HostUsergroupIds' => \%HostUsergroupIds_of,
        'HostUsergroupNames' => \%HostUsergroupNames_of,
    },
    {
        'Sid' => 'MyTypes::Sid',
        'Capabilities' => 'MyTypes::ArrayOfCapability',
        'HostDomainuserId' => 'MyTypes::AccessObjectId',
        'HostDomainuserName' => 'MyTypes::DomainuserName',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
        'HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
        'HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
        'HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
    },
    {

        'Sid' => 'Sid',
        'Capabilities' => 'Capabilities',
        'HostDomainuserId' => 'HostDomainuserId',
        'HostDomainuserName' => 'HostDomainuserName',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'HostRoleIds' => 'HostRoleIds',
        'HostRoleNames' => 'HostRoleNames',
        'HostUsergroupIds' => 'HostUsergroupIds',
        'HostUsergroupNames' => 'HostUsergroupNames',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostDomainuserInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostDomainuserInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of a domain user on the Host. The Host can be a Storage System or a vFiler Unit. Output will always contain all the elements present in the Type definition.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Sid


=item * Capabilities


=item * HostDomainuserId


=item * HostDomainuserName


=item * HostId


=item * HostName


=item * HostRoleIds


=item * HostRoleNames


=item * HostUsergroupIds


=item * HostUsergroupNames




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostDomainuserInfo
   Sid => $some_value, # Sid
   Capabilities =>  { # MyTypes::ArrayOfCapability
     Capability => $some_value, # Capability
   },
   HostDomainuserId => $some_value, # AccessObjectId
   HostDomainuserName => $some_value, # DomainuserName
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
     HostRoleId => $some_value, # HostRoleId
   },
   HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
     HostRoleName => $some_value, # HostRoleName
   },
   HostUsergroupIds =>  { # MyTypes::ArrayOfHostUsergroupId
     HostUsergroupId => $some_value, # HostUsergroupId
   },
   HostUsergroupNames =>  { # MyTypes::ArrayOfHostUsergroupName
     HostUsergroupName => $some_value, # HostUsergroupName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

