package MyTypes::HostDpFilterInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsInResourcepool_of :ATTR(:get<IsInResourcepool>);
my %IsSnapmirroredOnly_of :ATTR(:get<IsSnapmirroredOnly>);
my %IsSnapvaultPrimaryOnly_of :ATTR(:get<IsSnapvaultPrimaryOnly>);
my %IsSnapvaultSecondaryOnly_of :ATTR(:get<IsSnapvaultSecondaryOnly>);
my %IsUnprotected_of :ATTR(:get<IsUnprotected>);

__PACKAGE__->_factory(
    [ qw(        IsDpIgnored
        IsInDataset
        IsInResourcepool
        IsSnapmirroredOnly
        IsSnapvaultPrimaryOnly
        IsSnapvaultSecondaryOnly
        IsUnprotected

    ) ],
    {
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsInResourcepool' => \%IsInResourcepool_of,
        'IsSnapmirroredOnly' => \%IsSnapmirroredOnly_of,
        'IsSnapvaultPrimaryOnly' => \%IsSnapvaultPrimaryOnly_of,
        'IsSnapvaultSecondaryOnly' => \%IsSnapvaultSecondaryOnly_of,
        'IsUnprotected' => \%IsUnprotected_of,
    },
    {
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInResourcepool' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirroredOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultPrimaryOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsInResourcepool' => 'IsInResourcepool',
        'IsSnapmirroredOnly' => 'IsSnapmirroredOnly',
        'IsSnapvaultPrimaryOnly' => 'IsSnapvaultPrimaryOnly',
        'IsSnapvaultSecondaryOnly' => 'IsSnapvaultSecondaryOnly',
        'IsUnprotected' => 'IsUnprotected',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostDpFilterInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostDpFilterInfo from the namespace http://www.netapp.com/management/v1.

Data Protection specific information for this iterator. Default is false.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IsDpIgnored


=item * IsInDataset


=item * IsInResourcepool


=item * IsSnapmirroredOnly


=item * IsSnapvaultPrimaryOnly


=item * IsSnapvaultSecondaryOnly


=item * IsUnprotected




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostDpFilterInfo
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsInResourcepool =>  $some_value, # boolean
   IsSnapmirroredOnly =>  $some_value, # boolean
   IsSnapvaultPrimaryOnly =>  $some_value, # boolean
   IsSnapvaultSecondaryOnly =>  $some_value, # boolean
   IsUnprotected =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

