package MyTypes::HostDpInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Datasets_of :ATTR(:get<Datasets>);
my %HostDataset_of :ATTR(:get<HostDataset>);
my %HostResourcepool_of :ATTR(:get<HostResourcepool>);
my %IsAgentOssvEnabled_of :ATTR(:get<IsAgentOssvEnabled>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsLinuxPrimary_of :ATTR(:get<IsLinuxPrimary>);
my %IsNdmpEnabled_of :ATTR(:get<IsNdmpEnabled>);
my %IsNearstore_of :ATTR(:get<IsNearstore>);
my %IsSnapmirrorEnabled_of :ATTR(:get<IsSnapmirrorEnabled>);
my %IsSnapmirrorHost_of :ATTR(:get<IsSnapmirrorHost>);
my %IsSnapvaultEnabled_of :ATTR(:get<IsSnapvaultEnabled>);
my %IsSnapvaultPrimary_of :ATTR(:get<IsSnapvaultPrimary>);
my %IsSnapvaultSecondary_of :ATTR(:get<IsSnapvaultSecondary>);
my %IsUnixPrimary_of :ATTR(:get<IsUnixPrimary>);
my %IsWindowsOfmPrimary_of :ATTR(:get<IsWindowsOfmPrimary>);
my %IsWindowsPrimary_of :ATTR(:get<IsWindowsPrimary>);
my %NdmpAccessSpecifier_of :ATTR(:get<NdmpAccessSpecifier>);
my %SnapmirrorAccessSpecifier_of :ATTR(:get<SnapmirrorAccessSpecifier>);
my %SnapvaultAccessSpecifier_of :ATTR(:get<SnapvaultAccessSpecifier>);
my %SnapvaultMaxBackupThreads_of :ATTR(:get<SnapvaultMaxBackupThreads>);

__PACKAGE__->_factory(
    [ qw(        Datasets
        HostDataset
        HostResourcepool
        IsAgentOssvEnabled
        IsDpIgnored
        IsInDataset
        IsLinuxPrimary
        IsNdmpEnabled
        IsNearstore
        IsSnapmirrorEnabled
        IsSnapmirrorHost
        IsSnapvaultEnabled
        IsSnapvaultPrimary
        IsSnapvaultSecondary
        IsUnixPrimary
        IsWindowsOfmPrimary
        IsWindowsPrimary
        NdmpAccessSpecifier
        SnapmirrorAccessSpecifier
        SnapvaultAccessSpecifier
        SnapvaultMaxBackupThreads

    ) ],
    {
        'Datasets' => \%Datasets_of,
        'HostDataset' => \%HostDataset_of,
        'HostResourcepool' => \%HostResourcepool_of,
        'IsAgentOssvEnabled' => \%IsAgentOssvEnabled_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsLinuxPrimary' => \%IsLinuxPrimary_of,
        'IsNdmpEnabled' => \%IsNdmpEnabled_of,
        'IsNearstore' => \%IsNearstore_of,
        'IsSnapmirrorEnabled' => \%IsSnapmirrorEnabled_of,
        'IsSnapmirrorHost' => \%IsSnapmirrorHost_of,
        'IsSnapvaultEnabled' => \%IsSnapvaultEnabled_of,
        'IsSnapvaultPrimary' => \%IsSnapvaultPrimary_of,
        'IsSnapvaultSecondary' => \%IsSnapvaultSecondary_of,
        'IsUnixPrimary' => \%IsUnixPrimary_of,
        'IsWindowsOfmPrimary' => \%IsWindowsOfmPrimary_of,
        'IsWindowsPrimary' => \%IsWindowsPrimary_of,
        'NdmpAccessSpecifier' => \%NdmpAccessSpecifier_of,
        'SnapmirrorAccessSpecifier' => \%SnapmirrorAccessSpecifier_of,
        'SnapvaultAccessSpecifier' => \%SnapvaultAccessSpecifier_of,
        'SnapvaultMaxBackupThreads' => \%SnapvaultMaxBackupThreads_of,
    },
    {
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'HostDataset' => 'MyTypes::ObjName',
        'HostResourcepool' => 'MyTypes::ObjName',
        'IsAgentOssvEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLinuxPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsNdmpEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsNearstore' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsUnixPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsWindowsOfmPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsWindowsPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NdmpAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnapmirrorAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnapvaultAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'SnapvaultMaxBackupThreads' => 'MyTypes::HostDpInfo::_SnapvaultMaxBackupThreads',
    },
    {

        'Datasets' => 'Datasets',
        'HostDataset' => 'HostDataset',
        'HostResourcepool' => 'HostResourcepool',
        'IsAgentOssvEnabled' => 'IsAgentOssvEnabled',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsLinuxPrimary' => 'IsLinuxPrimary',
        'IsNdmpEnabled' => 'IsNdmpEnabled',
        'IsNearstore' => 'IsNearstore',
        'IsSnapmirrorEnabled' => 'IsSnapmirrorEnabled',
        'IsSnapmirrorHost' => 'IsSnapmirrorHost',
        'IsSnapvaultEnabled' => 'IsSnapvaultEnabled',
        'IsSnapvaultPrimary' => 'IsSnapvaultPrimary',
        'IsSnapvaultSecondary' => 'IsSnapvaultSecondary',
        'IsUnixPrimary' => 'IsUnixPrimary',
        'IsWindowsOfmPrimary' => 'IsWindowsOfmPrimary',
        'IsWindowsPrimary' => 'IsWindowsPrimary',
        'NdmpAccessSpecifier' => 'NdmpAccessSpecifier',
        'SnapmirrorAccessSpecifier' => 'SnapmirrorAccessSpecifier',
        'SnapvaultAccessSpecifier' => 'SnapvaultAccessSpecifier',
        'SnapvaultMaxBackupThreads' => 'SnapvaultMaxBackupThreads',
    }
);

} # end BLOCK




package MyTypes::HostDpInfo::_SnapvaultMaxBackupThreads;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::HostDpInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostDpInfo from the namespace http://www.netapp.com/management/v1.

Data Protection specific information for this iterator.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Datasets


=item * HostDataset


=item * HostResourcepool


=item * IsAgentOssvEnabled


=item * IsDpIgnored


=item * IsInDataset


=item * IsLinuxPrimary


=item * IsNdmpEnabled


=item * IsNearstore


=item * IsSnapmirrorEnabled


=item * IsSnapmirrorHost


=item * IsSnapvaultEnabled


=item * IsSnapvaultPrimary


=item * IsSnapvaultSecondary


=item * IsUnixPrimary


=item * IsWindowsOfmPrimary


=item * IsWindowsPrimary


=item * NdmpAccessSpecifier


=item * SnapmirrorAccessSpecifier


=item * SnapvaultAccessSpecifier


=item * SnapvaultMaxBackupThreads




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostDpInfo
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   HostDataset => $some_value, # ObjName
   HostResourcepool => $some_value, # ObjName
   IsAgentOssvEnabled =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsLinuxPrimary =>  $some_value, # boolean
   IsNdmpEnabled =>  $some_value, # boolean
   IsNearstore =>  $some_value, # boolean
   IsSnapmirrorEnabled =>  $some_value, # boolean
   IsSnapmirrorHost =>  $some_value, # boolean
   IsSnapvaultEnabled =>  $some_value, # boolean
   IsSnapvaultPrimary =>  $some_value, # boolean
   IsSnapvaultSecondary =>  $some_value, # boolean
   IsUnixPrimary =>  $some_value, # boolean
   IsWindowsOfmPrimary =>  $some_value, # boolean
   IsWindowsPrimary =>  $some_value, # boolean
   NdmpAccessSpecifier =>  $some_value, # string
   SnapmirrorAccessSpecifier =>  $some_value, # string
   SnapvaultAccessSpecifier =>  $some_value, # string
   SnapvaultMaxBackupThreads => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

