package MyTypes::HostInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminPort_of :ATTR(:get<AdminPort>);
my %AdminTransport_of :ATTR(:get<AdminTransport>);
my %CifsDomainInfo_of :ATTR(:get<CifsDomainInfo>);
my %HostAddress_of :ATTR(:get<HostAddress>);
my %HostCommunicationStatus_of :ATTR(:get<HostCommunicationStatus>);
my %HostCredentialsStatus_of :ATTR(:get<HostCredentialsStatus>);
my %HostDescription_of :ATTR(:get<HostDescription>);
my %HostDpInfo_of :ATTR(:get<HostDpInfo>);
my %HostFqdn_of :ATTR(:get<HostFqdn>);
my %HostId_of :ATTR(:get<HostId>);
my %HostModel_of :ATTR(:get<HostModel>);
my %HostName_of :ATTR(:get<HostName>);
my %HostObjStatus_of :ATTR(:get<HostObjStatus>);
my %HostOs_of :ATTR(:get<HostOs>);
my %HostPerfInfo_of :ATTR(:get<HostPerfInfo>);
my %HostStatus_of :ATTR(:get<HostStatus>);
my %HostType_of :ATTR(:get<HostType>);
my %HostUsername_of :ATTR(:get<HostUsername>);
my %HostVersion_of :ATTR(:get<HostVersion>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %Licenses_of :ATTR(:get<Licenses>);
my %NdmpAgentStatus_of :ATTR(:get<NdmpAgentStatus>);
my %NdmpCommunicationStatus_of :ATTR(:get<NdmpCommunicationStatus>);
my %NdmpCommunicationTimestamp_of :ATTR(:get<NdmpCommunicationTimestamp>);
my %NdmpCredentials_of :ATTR(:get<NdmpCredentials>);
my %NdmpCredentialsStatus_of :ATTR(:get<NdmpCredentialsStatus>);
my %NdmpTimestamp_of :ATTR(:get<NdmpTimestamp>);
my %OtherHostId_of :ATTR(:get<OtherHostId>);
my %PartnerStorageSystemId_of :ATTR(:get<PartnerStorageSystemId>);
my %PartnerStorageSystemName_of :ATTR(:get<PartnerStorageSystemName>);
my %PerfAdvisorTransport_of :ATTR(:get<PerfAdvisorTransport>);
my %ServiceStatuses_of :ATTR(:get<ServiceStatuses>);
my %UseHostsEquiv_of :ATTR(:get<UseHostsEquiv>);
my %VfilerInfo_of :ATTR(:get<VfilerInfo>);

__PACKAGE__->_factory(
    [ qw(        AdminPort
        AdminTransport
        CifsDomainInfo
        HostAddress
        HostCommunicationStatus
        HostCredentialsStatus
        HostDescription
        HostDpInfo
        HostFqdn
        HostId
        HostModel
        HostName
        HostObjStatus
        HostOs
        HostPerfInfo
        HostStatus
        HostType
        HostUsername
        HostVersion
        IsAvailable
        Licenses
        NdmpAgentStatus
        NdmpCommunicationStatus
        NdmpCommunicationTimestamp
        NdmpCredentials
        NdmpCredentialsStatus
        NdmpTimestamp
        OtherHostId
        PartnerStorageSystemId
        PartnerStorageSystemName
        PerfAdvisorTransport
        ServiceStatuses
        UseHostsEquiv
        VfilerInfo

    ) ],
    {
        'AdminPort' => \%AdminPort_of,
        'AdminTransport' => \%AdminTransport_of,
        'CifsDomainInfo' => \%CifsDomainInfo_of,
        'HostAddress' => \%HostAddress_of,
        'HostCommunicationStatus' => \%HostCommunicationStatus_of,
        'HostCredentialsStatus' => \%HostCredentialsStatus_of,
        'HostDescription' => \%HostDescription_of,
        'HostDpInfo' => \%HostDpInfo_of,
        'HostFqdn' => \%HostFqdn_of,
        'HostId' => \%HostId_of,
        'HostModel' => \%HostModel_of,
        'HostName' => \%HostName_of,
        'HostObjStatus' => \%HostObjStatus_of,
        'HostOs' => \%HostOs_of,
        'HostPerfInfo' => \%HostPerfInfo_of,
        'HostStatus' => \%HostStatus_of,
        'HostType' => \%HostType_of,
        'HostUsername' => \%HostUsername_of,
        'HostVersion' => \%HostVersion_of,
        'IsAvailable' => \%IsAvailable_of,
        'Licenses' => \%Licenses_of,
        'NdmpAgentStatus' => \%NdmpAgentStatus_of,
        'NdmpCommunicationStatus' => \%NdmpCommunicationStatus_of,
        'NdmpCommunicationTimestamp' => \%NdmpCommunicationTimestamp_of,
        'NdmpCredentials' => \%NdmpCredentials_of,
        'NdmpCredentialsStatus' => \%NdmpCredentialsStatus_of,
        'NdmpTimestamp' => \%NdmpTimestamp_of,
        'OtherHostId' => \%OtherHostId_of,
        'PartnerStorageSystemId' => \%PartnerStorageSystemId_of,
        'PartnerStorageSystemName' => \%PartnerStorageSystemName_of,
        'PerfAdvisorTransport' => \%PerfAdvisorTransport_of,
        'ServiceStatuses' => \%ServiceStatuses_of,
        'UseHostsEquiv' => \%UseHostsEquiv_of,
        'VfilerInfo' => \%VfilerInfo_of,
    },
    {
        'AdminPort' => 'MyTypes::IpPortNumber',
        'AdminTransport' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CifsDomainInfo' => 'MyTypes::CifsDomainInfo',
        'HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostCommunicationStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostCredentialsStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostDpInfo' => 'MyTypes::HostDpInfo',
        'HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::HostId',
        'HostModel' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostObjStatus' => 'MyTypes::ObjStatus',
        'HostOs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostPerfInfo' => 'MyTypes::HostPerfInfo',
        'HostStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostType' => 'MyTypes::HostType',
        'HostUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Licenses' => 'MyTypes::ArrayOfLicense',
        'NdmpAgentStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NdmpCommunicationStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NdmpCommunicationTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'NdmpCredentials' => 'MyTypes::NdmpCredentials',
        'NdmpCredentialsStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NdmpTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'OtherHostId' => 'MyTypes::HostId',
        'PartnerStorageSystemId' => 'MyTypes::ObjId',
        'PartnerStorageSystemName' => 'MyTypes::ObjFullName',
        'PerfAdvisorTransport' => 'MyTypes::PerfAdvisorTransport',
        'ServiceStatuses' => 'MyTypes::ArrayOfServiceStatus',
        'UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'VfilerInfo' => 'MyTypes::VfilerInfo',
    },
    {

        'AdminPort' => 'AdminPort',
        'AdminTransport' => 'AdminTransport',
        'CifsDomainInfo' => 'CifsDomainInfo',
        'HostAddress' => 'HostAddress',
        'HostCommunicationStatus' => 'HostCommunicationStatus',
        'HostCredentialsStatus' => 'HostCredentialsStatus',
        'HostDescription' => 'HostDescription',
        'HostDpInfo' => 'HostDpInfo',
        'HostFqdn' => 'HostFqdn',
        'HostId' => 'HostId',
        'HostModel' => 'HostModel',
        'HostName' => 'HostName',
        'HostObjStatus' => 'HostObjStatus',
        'HostOs' => 'HostOs',
        'HostPerfInfo' => 'HostPerfInfo',
        'HostStatus' => 'HostStatus',
        'HostType' => 'HostType',
        'HostUsername' => 'HostUsername',
        'HostVersion' => 'HostVersion',
        'IsAvailable' => 'IsAvailable',
        'Licenses' => 'Licenses',
        'NdmpAgentStatus' => 'NdmpAgentStatus',
        'NdmpCommunicationStatus' => 'NdmpCommunicationStatus',
        'NdmpCommunicationTimestamp' => 'NdmpCommunicationTimestamp',
        'NdmpCredentials' => 'NdmpCredentials',
        'NdmpCredentialsStatus' => 'NdmpCredentialsStatus',
        'NdmpTimestamp' => 'NdmpTimestamp',
        'OtherHostId' => 'OtherHostId',
        'PartnerStorageSystemId' => 'PartnerStorageSystemId',
        'PartnerStorageSystemName' => 'PartnerStorageSystemName',
        'PerfAdvisorTransport' => 'PerfAdvisorTransport',
        'ServiceStatuses' => 'ServiceStatuses',
        'UseHostsEquiv' => 'UseHostsEquiv',
        'VfilerInfo' => 'VfilerInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostInfo from the namespace http://www.netapp.com/management/v1.

Host's information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminPort


=item * AdminTransport


=item * CifsDomainInfo


=item * HostAddress


=item * HostCommunicationStatus


=item * HostCredentialsStatus


=item * HostDescription


=item * HostDpInfo


=item * HostFqdn


=item * HostId


=item * HostModel


=item * HostName


=item * HostObjStatus


=item * HostOs


=item * HostPerfInfo


=item * HostStatus


=item * HostType


=item * HostUsername


=item * HostVersion


=item * IsAvailable


=item * Licenses


=item * NdmpAgentStatus


=item * NdmpCommunicationStatus


=item * NdmpCommunicationTimestamp


=item * NdmpCredentials


=item * NdmpCredentialsStatus


=item * NdmpTimestamp


=item * OtherHostId


=item * PartnerStorageSystemId


=item * PartnerStorageSystemName


=item * PerfAdvisorTransport


=item * ServiceStatuses


=item * UseHostsEquiv


=item * VfilerInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostInfo
   AdminPort => $some_value, # IpPortNumber
   AdminTransport =>  $some_value, # string
   CifsDomainInfo =>  { # MyTypes::CifsDomainInfo
     CifsDnsDomainName =>  $some_value, # string
     CifsDomainId => $some_value, # atomic
     CifsDomainName =>  $some_value, # string
   },
   HostAddress =>  $some_value, # string
   HostCommunicationStatus =>  $some_value, # string
   HostCredentialsStatus =>  $some_value, # string
   HostDescription =>  $some_value, # string
   HostDpInfo =>  { # MyTypes::HostDpInfo
     Datasets =>  { # MyTypes::ArrayOfDatasetReference
       DatasetReference =>  { # MyTypes::DatasetReference
         DatasetId => $some_value, # ObjId
         DatasetName => $some_value, # ObjName
       },
     },
     HostDataset => $some_value, # ObjName
     HostResourcepool => $some_value, # ObjName
     IsAgentOssvEnabled =>  $some_value, # boolean
     IsDpIgnored =>  $some_value, # boolean
     IsInDataset =>  $some_value, # boolean
     IsLinuxPrimary =>  $some_value, # boolean
     IsNdmpEnabled =>  $some_value, # boolean
     IsNearstore =>  $some_value, # boolean
     IsSnapmirrorEnabled =>  $some_value, # boolean
     IsSnapmirrorHost =>  $some_value, # boolean
     IsSnapvaultEnabled =>  $some_value, # boolean
     IsSnapvaultPrimary =>  $some_value, # boolean
     IsSnapvaultSecondary =>  $some_value, # boolean
     IsUnixPrimary =>  $some_value, # boolean
     IsWindowsOfmPrimary =>  $some_value, # boolean
     IsWindowsPrimary =>  $some_value, # boolean
     NdmpAccessSpecifier =>  $some_value, # string
     SnapmirrorAccessSpecifier =>  $some_value, # string
     SnapvaultAccessSpecifier =>  $some_value, # string
     SnapvaultMaxBackupThreads => $some_value, # atomic
   },
   HostFqdn =>  $some_value, # string
   HostId => $some_value, # HostId
   HostModel =>  $some_value, # string
   HostName =>  $some_value, # string
   HostObjStatus => $some_value, # ObjStatus
   HostOs =>  $some_value, # string
   HostPerfInfo =>  { # MyTypes::HostPerfInfo
     DataUnavailableReason =>  { # MyTypes::ArrayOfPerfStatusError
       PerfStatusError =>  { # MyTypes::PerfStatusError
         Error =>  $some_value, # string
       },
     },
     HostPerfStatus => $some_value, # ObjStatus
     IsDataAvailable =>  $some_value, # boolean
     LastClientStatsCollectionTime => $some_value, # Timestamp
     PercentageSpaceConsumed =>  $some_value, # string
     SpaceConsumed =>  $some_value, # integer
     SpaceProjected =>  $some_value, # integer
   },
   HostStatus =>  $some_value, # string
   HostType => $some_value, # HostType
   HostUsername =>  $some_value, # string
   HostVersion =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   Licenses =>  { # MyTypes::ArrayOfLicense
     License => $some_value, # License
   },
   NdmpAgentStatus =>  $some_value, # string
   NdmpCommunicationStatus =>  $some_value, # string
   NdmpCommunicationTimestamp =>  $some_value, # integer
   NdmpCredentials =>  { # MyTypes::NdmpCredentials
     NdmpPassword => $some_value, # HostPassword
     NdmpPort => $some_value, # IpPortNumber
     NdmpUsername => $some_value, # NdmpUsername
   },
   NdmpCredentialsStatus =>  $some_value, # string
   NdmpTimestamp =>  $some_value, # integer
   OtherHostId => $some_value, # HostId
   PartnerStorageSystemId => $some_value, # ObjId
   PartnerStorageSystemName => $some_value, # ObjFullName
   PerfAdvisorTransport => $some_value, # PerfAdvisorTransport
   ServiceStatuses =>  { # MyTypes::ArrayOfServiceStatus
     ServiceStatus =>  { # MyTypes::ServiceStatus
       Service =>  $some_value, # string
     },
   },
   UseHostsEquiv =>  $some_value, # boolean
   VfilerInfo =>  { # MyTypes::VfilerInfo
     HostingFilerId => $some_value, # ObjId
     HostingFilerName => $some_value, # ObjFullName
     VfilerAllowedProtocols =>  { # MyTypes::ArrayOfProtocol
       Protocol => $some_value, # Protocol
     },
     VfilerIpspace =>  $some_value, # string
     VfilerMigrationInfo =>  { # MyTypes::VfilerMigrationInfo
       DestinationFilerId => $some_value, # ObjId
       DestinationFilerName => $some_value, # ObjFullName
       DestinationVfilerId => $some_value, # ObjId
       DestinationVfilerName => $some_value, # ObjFullName
       MigrationStatus => $some_value, # MigrationStatus
       SourceFilerId => $some_value, # ObjId
       SourceFilerName => $some_value, # ObjFullName
       SourceVfilerId => $some_value, # ObjId
       SourceVfilerName => $some_value, # ObjFullName
     },
     VfilerNetworkResources =>  { # MyTypes::ArrayOfVfilerNetworkResource
       VfilerNetworkResource =>  { # MyTypes::VfilerNetworkResource
         InterfaceId => $some_value, # ObjId
         InterfaceName => $some_value, # ObjName
         IpAddress => $some_value, # IpAddress
         MtuSize =>  $some_value, # integer
         PrefixLength =>  $some_value, # integer
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

