package MyTypes::HostModifyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdminPort_of :ATTR(:get<AdminPort>);
my %AdminTransport_of :ATTR(:get<AdminTransport>);
my %HostAddress_of :ATTR(:get<HostAddress>);
my %HostDescription_of :ATTR(:get<HostDescription>);
my %HostDpModifyInfo_of :ATTR(:get<HostDpModifyInfo>);
my %HostName_of :ATTR(:get<HostName>);
my %HostPassword_of :ATTR(:get<HostPassword>);
my %HostUsername_of :ATTR(:get<HostUsername>);
my %NdmpCredentials_of :ATTR(:get<NdmpCredentials>);
my %PerfAdvisorTransport_of :ATTR(:get<PerfAdvisorTransport>);
my %UseHostsEquiv_of :ATTR(:get<UseHostsEquiv>);

__PACKAGE__->_factory(
    [ qw(        AdminPort
        AdminTransport
        HostAddress
        HostDescription
        HostDpModifyInfo
        HostName
        HostPassword
        HostUsername
        NdmpCredentials
        PerfAdvisorTransport
        UseHostsEquiv

    ) ],
    {
        'AdminPort' => \%AdminPort_of,
        'AdminTransport' => \%AdminTransport_of,
        'HostAddress' => \%HostAddress_of,
        'HostDescription' => \%HostDescription_of,
        'HostDpModifyInfo' => \%HostDpModifyInfo_of,
        'HostName' => \%HostName_of,
        'HostPassword' => \%HostPassword_of,
        'HostUsername' => \%HostUsername_of,
        'NdmpCredentials' => \%NdmpCredentials_of,
        'PerfAdvisorTransport' => \%PerfAdvisorTransport_of,
        'UseHostsEquiv' => \%UseHostsEquiv_of,
    },
    {
        'AdminPort' => 'MyTypes::IpPortNumber',
        'AdminTransport' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostDpModifyInfo' => 'MyTypes::HostDpModifyInfo',
        'HostName' => 'MyTypes::ObjName',
        'HostPassword' => 'MyTypes::HostPassword',
        'HostUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NdmpCredentials' => 'MyTypes::NdmpCredentials',
        'PerfAdvisorTransport' => 'MyTypes::PerfAdvisorTransport',
        'UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'AdminPort' => 'AdminPort',
        'AdminTransport' => 'AdminTransport',
        'HostAddress' => 'HostAddress',
        'HostDescription' => 'HostDescription',
        'HostDpModifyInfo' => 'HostDpModifyInfo',
        'HostName' => 'HostName',
        'HostPassword' => 'HostPassword',
        'HostUsername' => 'HostUsername',
        'NdmpCredentials' => 'NdmpCredentials',
        'PerfAdvisorTransport' => 'PerfAdvisorTransport',
        'UseHostsEquiv' => 'UseHostsEquiv',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostModifyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostModifyInfo from the namespace http://www.netapp.com/management/v1.

Host information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdminPort


=item * AdminTransport


=item * HostAddress


=item * HostDescription


=item * HostDpModifyInfo


=item * HostName


=item * HostPassword


=item * HostUsername


=item * NdmpCredentials


=item * PerfAdvisorTransport


=item * UseHostsEquiv




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostModifyInfo
   AdminPort => $some_value, # IpPortNumber
   AdminTransport =>  $some_value, # string
   HostAddress =>  $some_value, # string
   HostDescription =>  $some_value, # string
   HostDpModifyInfo =>  { # MyTypes::HostDpModifyInfo
     IsDpIgnored =>  $some_value, # boolean
     SnapvaultMaxBackupThreads => $some_value, # atomic
   },
   HostName => $some_value, # ObjName
   HostPassword => $some_value, # HostPassword
   HostUsername =>  $some_value, # string
   NdmpCredentials =>  { # MyTypes::NdmpCredentials
     NdmpPassword => $some_value, # HostPassword
     NdmpPort => $some_value, # IpPortNumber
     NdmpUsername => $some_value, # NdmpUsername
   },
   PerfAdvisorTransport => $some_value, # PerfAdvisorTransport
   UseHostsEquiv =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

