package MyTypes::HostPerfInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DataUnavailableReason_of :ATTR(:get<DataUnavailableReason>);
my %HostPerfStatus_of :ATTR(:get<HostPerfStatus>);
my %IsDataAvailable_of :ATTR(:get<IsDataAvailable>);
my %LastClientStatsCollectionTime_of :ATTR(:get<LastClientStatsCollectionTime>);
my %PercentageSpaceConsumed_of :ATTR(:get<PercentageSpaceConsumed>);
my %SpaceConsumed_of :ATTR(:get<SpaceConsumed>);
my %SpaceProjected_of :ATTR(:get<SpaceProjected>);

__PACKAGE__->_factory(
    [ qw(        DataUnavailableReason
        HostPerfStatus
        IsDataAvailable
        LastClientStatsCollectionTime
        PercentageSpaceConsumed
        SpaceConsumed
        SpaceProjected

    ) ],
    {
        'DataUnavailableReason' => \%DataUnavailableReason_of,
        'HostPerfStatus' => \%HostPerfStatus_of,
        'IsDataAvailable' => \%IsDataAvailable_of,
        'LastClientStatsCollectionTime' => \%LastClientStatsCollectionTime_of,
        'PercentageSpaceConsumed' => \%PercentageSpaceConsumed_of,
        'SpaceConsumed' => \%SpaceConsumed_of,
        'SpaceProjected' => \%SpaceProjected_of,
    },
    {
        'DataUnavailableReason' => 'MyTypes::ArrayOfPerfStatusError',
        'HostPerfStatus' => 'MyTypes::ObjStatus',
        'IsDataAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LastClientStatsCollectionTime' => 'MyTypes::Timestamp',
        'PercentageSpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'DataUnavailableReason' => 'DataUnavailableReason',
        'HostPerfStatus' => 'HostPerfStatus',
        'IsDataAvailable' => 'IsDataAvailable',
        'LastClientStatsCollectionTime' => 'LastClientStatsCollectionTime',
        'PercentageSpaceConsumed' => 'PercentageSpaceConsumed',
        'SpaceConsumed' => 'SpaceConsumed',
        'SpaceProjected' => 'SpaceProjected',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostPerfInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostPerfInfo from the namespace http://www.netapp.com/management/v1.

Performance specific information for this iterator




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DataUnavailableReason


=item * HostPerfStatus


=item * IsDataAvailable


=item * LastClientStatsCollectionTime


=item * PercentageSpaceConsumed


=item * SpaceConsumed


=item * SpaceProjected




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostPerfInfo
   DataUnavailableReason =>  { # MyTypes::ArrayOfPerfStatusError
     PerfStatusError =>  { # MyTypes::PerfStatusError
       Error =>  $some_value, # string
     },
   },
   HostPerfStatus => $some_value, # ObjStatus
   IsDataAvailable =>  $some_value, # boolean
   LastClientStatsCollectionTime => $some_value, # Timestamp
   PercentageSpaceConsumed =>  $some_value, # string
   SpaceConsumed =>  $some_value, # integer
   SpaceProjected =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

