package MyTypes::HostResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);

__PACKAGE__->_factory(
    [ qw(        HostId
        HostName

    ) ],
    {
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
    },
    {
        'HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'HostId' => 'HostId',
        'HostName' => 'HostName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostResource from the namespace http://www.netapp.com/management/v1.

Identifies a Host Resource. When used as input only one of HostName orhost-id is specified. When used as output, both of them will be returned




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostId


=item * HostName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostResource
   HostId =>  $some_value, # unsignedInt
   HostName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

