package MyTypes::HostRoleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Capabilities_of :ATTR(:get<Capabilities>);
my %Description_of :ATTR(:get<Description>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %HostRoleId_of :ATTR(:get<HostRoleId>);
my %HostRoleName_of :ATTR(:get<HostRoleName>);

__PACKAGE__->_factory(
    [ qw(        Capabilities
        Description
        HostId
        HostName
        HostRoleId
        HostRoleName

    ) ],
    {
        'Capabilities' => \%Capabilities_of,
        'Description' => \%Description_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'HostRoleId' => \%HostRoleId_of,
        'HostRoleName' => \%HostRoleName_of,
    },
    {
        'Capabilities' => 'MyTypes::ArrayOfCapability',
        'Description' => 'MyTypes::AccessObjectDescription',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'HostRoleId' => 'MyTypes::AccessObjectId',
        'HostRoleName' => 'MyTypes::AccessObjectName',
    },
    {

        'Capabilities' => 'Capabilities',
        'Description' => 'Description',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'HostRoleId' => 'HostRoleId',
        'HostRoleName' => 'HostRoleName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostRoleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostRoleInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of a role on the Host. The Host can be a storage system or a vFiler Unit. Output will always contain all the elements present in the Type definition.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Capabilities


=item * Description


=item * HostId


=item * HostName


=item * HostRoleId


=item * HostRoleName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostRoleInfo
   Capabilities =>  { # MyTypes::ArrayOfCapability
     Capability => $some_value, # Capability
   },
   Description => $some_value, # AccessObjectDescription
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   HostRoleId => $some_value, # AccessObjectId
   HostRoleName => $some_value, # AccessObjectName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

