package MyTypes::HostUserInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Capabilities_of :ATTR(:get<Capabilities>);
my %Description_of :ATTR(:get<Description>);
my %FullName_of :ATTR(:get<FullName>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %HostRoleIds_of :ATTR(:get<HostRoleIds>);
my %HostRoleNames_of :ATTR(:get<HostRoleNames>);
my %HostUserId_of :ATTR(:get<HostUserId>);
my %HostUserName_of :ATTR(:get<HostUserName>);
my %HostUsergroupIds_of :ATTR(:get<HostUsergroupIds>);
my %HostUsergroupNames_of :ATTR(:get<HostUsergroupNames>);
my %MaximumPasswordAge_of :ATTR(:get<MaximumPasswordAge>);
my %MinimumPasswordAge_of :ATTR(:get<MinimumPasswordAge>);
my %Password_of :ATTR(:get<Password>);
my %Status_of :ATTR(:get<Status>);

__PACKAGE__->_factory(
    [ qw(        Capabilities
        Description
        FullName
        HostId
        HostName
        HostRoleIds
        HostRoleNames
        HostUserId
        HostUserName
        HostUsergroupIds
        HostUsergroupNames
        MaximumPasswordAge
        MinimumPasswordAge
        Password
        Status

    ) ],
    {
        'Capabilities' => \%Capabilities_of,
        'Description' => \%Description_of,
        'FullName' => \%FullName_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'HostRoleIds' => \%HostRoleIds_of,
        'HostRoleNames' => \%HostRoleNames_of,
        'HostUserId' => \%HostUserId_of,
        'HostUserName' => \%HostUserName_of,
        'HostUsergroupIds' => \%HostUsergroupIds_of,
        'HostUsergroupNames' => \%HostUsergroupNames_of,
        'MaximumPasswordAge' => \%MaximumPasswordAge_of,
        'MinimumPasswordAge' => \%MinimumPasswordAge_of,
        'Password' => \%Password_of,
        'Status' => \%Status_of,
    },
    {
        'Capabilities' => 'MyTypes::ArrayOfCapability',
        'Description' => 'MyTypes::AccessObjectDescription',
        'FullName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
        'HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
        'HostUserId' => 'MyTypes::AccessObjectId',
        'HostUserName' => 'MyTypes::AccessObjectName',
        'HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
        'HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
        'MaximumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'MinimumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'Password' => 'MyTypes::HostUserPassword',
        'Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Capabilities' => 'Capabilities',
        'Description' => 'Description',
        'FullName' => 'FullName',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'HostRoleIds' => 'HostRoleIds',
        'HostRoleNames' => 'HostRoleNames',
        'HostUserId' => 'HostUserId',
        'HostUserName' => 'HostUserName',
        'HostUsergroupIds' => 'HostUsergroupIds',
        'HostUsergroupNames' => 'HostUsergroupNames',
        'MaximumPasswordAge' => 'MaximumPasswordAge',
        'MinimumPasswordAge' => 'MinimumPasswordAge',
        'Password' => 'Password',
        'Status' => 'Status',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostUserInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostUserInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of a local user on the Host. The Host Type can be a Storage System or a vFiler Unit. Minimum Password age, Maximum Password age, and Status are applicable for Hosts running ONTAP versions 7.1 and above. Apart From these fields, output will always contain all the elements present in the Type definition.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Capabilities


=item * Description


=item * FullName


=item * HostId


=item * HostName


=item * HostRoleIds


=item * HostRoleNames


=item * HostUserId


=item * HostUserName


=item * HostUsergroupIds


=item * HostUsergroupNames


=item * MaximumPasswordAge


=item * MinimumPasswordAge


=item * Password


=item * Status




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostUserInfo
   Capabilities =>  { # MyTypes::ArrayOfCapability
     Capability => $some_value, # Capability
   },
   Description => $some_value, # AccessObjectDescription
   FullName =>  $some_value, # string
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
     HostRoleId => $some_value, # HostRoleId
   },
   HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
     HostRoleName => $some_value, # HostRoleName
   },
   HostUserId => $some_value, # AccessObjectId
   HostUserName => $some_value, # AccessObjectName
   HostUsergroupIds =>  { # MyTypes::ArrayOfHostUsergroupId
     HostUsergroupId => $some_value, # HostUsergroupId
   },
   HostUsergroupNames =>  { # MyTypes::ArrayOfHostUsergroupName
     HostUsergroupName => $some_value, # HostUsergroupName
   },
   MaximumPasswordAge =>  $some_value, # unsignedInt
   MinimumPasswordAge =>  $some_value, # unsignedInt
   Password => $some_value, # HostUserPassword
   Status =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

