package MyTypes::HostUsergroupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Capabilities_of :ATTR(:get<Capabilities>);
my %Description_of :ATTR(:get<Description>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %HostRoleIds_of :ATTR(:get<HostRoleIds>);
my %HostRoleNames_of :ATTR(:get<HostRoleNames>);
my %HostUsergroupId_of :ATTR(:get<HostUsergroupId>);
my %HostUsergroupName_of :ATTR(:get<HostUsergroupName>);

__PACKAGE__->_factory(
    [ qw(        Capabilities
        Description
        HostId
        HostName
        HostRoleIds
        HostRoleNames
        HostUsergroupId
        HostUsergroupName

    ) ],
    {
        'Capabilities' => \%Capabilities_of,
        'Description' => \%Description_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'HostRoleIds' => \%HostRoleIds_of,
        'HostRoleNames' => \%HostRoleNames_of,
        'HostUsergroupId' => \%HostUsergroupId_of,
        'HostUsergroupName' => \%HostUsergroupName_of,
    },
    {
        'Capabilities' => 'MyTypes::ArrayOfCapability',
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
        'HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
        'HostUsergroupId' => 'MyTypes::AccessObjectId',
        'HostUsergroupName' => 'MyTypes::UsergroupName',
    },
    {

        'Capabilities' => 'Capabilities',
        'Description' => 'Description',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'HostRoleIds' => 'HostRoleIds',
        'HostRoleNames' => 'HostRoleNames',
        'HostUsergroupId' => 'HostUsergroupId',
        'HostUsergroupName' => 'HostUsergroupName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostUsergroupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostUsergroupInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of a usergroup on the Host. The Host can be a storage system or a vFiler. Output will always contain all the elements present in the Type definition.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Capabilities


=item * Description


=item * HostId


=item * HostName


=item * HostRoleIds


=item * HostRoleNames


=item * HostUsergroupId


=item * HostUsergroupName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostUsergroupInfo
   Capabilities =>  { # MyTypes::ArrayOfCapability
     Capability => $some_value, # Capability
   },
   Description =>  $some_value, # string
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
     HostRoleId => $some_value, # HostRoleId
   },
   HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
     HostRoleName => $some_value, # HostRoleName
   },
   HostUsergroupId => $some_value, # AccessObjectId
   HostUsergroupName => $some_value, # UsergroupName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

