package MyTypes::HostserviceModifyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AccessProtocol_of :ATTR(:get<AccessProtocol>);
my %AdminPort_of :ATTR(:get<AdminPort>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %MgmtPort_of :ATTR(:get<MgmtPort>);
my %UpdateServicePort_of :ATTR(:get<UpdateServicePort>);

__PACKAGE__->_factory(
    [ qw(        AccessProtocol
        AdminPort
        IpAddress
        MgmtPort
        UpdateServicePort

    ) ],
    {
        'AccessProtocol' => \%AccessProtocol_of,
        'AdminPort' => \%AdminPort_of,
        'IpAddress' => \%IpAddress_of,
        'MgmtPort' => \%MgmtPort_of,
        'UpdateServicePort' => \%UpdateServicePort_of,
    },
    {
        'AccessProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AdminPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MgmtPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'UpdateServicePort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'AccessProtocol' => 'AccessProtocol',
        'AdminPort' => 'AdminPort',
        'IpAddress' => 'IpAddress',
        'MgmtPort' => 'MgmtPort',
        'UpdateServicePort' => 'UpdateServicePort',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HostserviceModifyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HostserviceModifyInfo from the namespace http://www.netapp.com/management/v1.

Host Service modify info




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AccessProtocol


=item * AdminPort


=item * IpAddress


=item * MgmtPort


=item * UpdateServicePort




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HostserviceModifyInfo
   AccessProtocol =>  $some_value, # string
   AdminPort =>  $some_value, # integer
   IpAddress =>  $some_value, # string
   MgmtPort =>  $some_value, # integer
   UpdateServicePort =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

