package MyTypes::HourlyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EndHour_of :ATTR(:get<EndHour>);
my %EndMinute_of :ATTR(:get<EndMinute>);
my %Frequency_of :ATTR(:get<Frequency>);
my %ItemId_of :ATTR(:get<ItemId>);
my %StartHour_of :ATTR(:get<StartHour>);
my %StartMinute_of :ATTR(:get<StartMinute>);

__PACKAGE__->_factory(
    [ qw(        EndHour
        EndMinute
        Frequency
        ItemId
        StartHour
        StartMinute

    ) ],
    {
        'EndHour' => \%EndHour_of,
        'EndMinute' => \%EndMinute_of,
        'Frequency' => \%Frequency_of,
        'ItemId' => \%ItemId_of,
        'StartHour' => \%StartHour_of,
        'StartMinute' => \%StartMinute_of,
    },
    {

        'EndHour' => 'MyTypes::HourlyInfo::_EndHour',

        'EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',

        'Frequency' => 'MyTypes::HourlyInfo::_Frequency',

        'ItemId' => 'MyTypes::HourlyInfo::_ItemId',

        'StartHour' => 'MyTypes::HourlyInfo::_StartHour',

        'StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
    },
    {

        'EndHour' => 'EndHour',
        'EndMinute' => 'EndMinute',
        'Frequency' => 'Frequency',
        'ItemId' => 'ItemId',
        'StartHour' => 'StartHour',
        'StartMinute' => 'StartMinute',
    }
);

} # end BLOCK




package MyTypes::HourlyInfo::_EndHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HourlyInfo::_EndMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HourlyInfo::_Frequency;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HourlyInfo::_ItemId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HourlyInfo::_StartHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::HourlyInfo::_StartMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::HourlyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HourlyInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of an hourly schedule. May only be used in a daily schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EndHour


=item * EndMinute


=item * Frequency


=item * ItemId


=item * StartHour


=item * StartMinute




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HourlyInfo
   EndHour => $some_value, # atomic
   EndMinute => $some_value, # atomic
   Frequency => $some_value, # atomic
   ItemId => $some_value, # atomic
   StartHour => $some_value, # atomic
   StartMinute => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

