package MyTypes::Hypervisor;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatacenterName_of :ATTR(:get<DatacenterName>);
my %DatacenterReference_of :ATTR(:get<DatacenterReference>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %DomainName_of :ATTR(:get<DomainName>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %HypervisorId_of :ATTR(:get<HypervisorId>);
my %HypervisorName_of :ATTR(:get<HypervisorName>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %VirtualCenterName_of :ATTR(:get<VirtualCenterName>);
my %VirtualCenterReference_of :ATTR(:get<VirtualCenterReference>);
my %VirtualInfrastructureType_of :ATTR(:get<VirtualInfrastructureType>);

__PACKAGE__->_factory(
    [ qw(        DatacenterName
        DatacenterReference
        DeletedBy
        DeletedTimestamp
        DomainName
        HostServiceId
        HypervisorId
        HypervisorName
        IpAddress
        VirtualCenterName
        VirtualCenterReference
        VirtualInfrastructureType

    ) ],
    {
        'DatacenterName' => \%DatacenterName_of,
        'DatacenterReference' => \%DatacenterReference_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'DomainName' => \%DomainName_of,
        'HostServiceId' => \%HostServiceId_of,
        'HypervisorId' => \%HypervisorId_of,
        'HypervisorName' => \%HypervisorName_of,
        'IpAddress' => \%IpAddress_of,
        'VirtualCenterName' => \%VirtualCenterName_of,
        'VirtualCenterReference' => \%VirtualCenterReference_of,
        'VirtualInfrastructureType' => \%VirtualInfrastructureType_of,
    },
    {
        'DatacenterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DatacenterReference' => 'MyTypes::DatacenterReference',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'DomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostServiceId' => 'MyTypes::ObjId',
        'HypervisorId' => 'MyTypes::ObjId',
        'HypervisorName' => 'MyTypes::ObjName',
        'IpAddress' => 'MyTypes::IpAddress',
        'VirtualCenterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
        'VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
    },
    {

        'DatacenterName' => 'DatacenterName',
        'DatacenterReference' => 'DatacenterReference',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'DomainName' => 'DomainName',
        'HostServiceId' => 'HostServiceId',
        'HypervisorId' => 'HypervisorId',
        'HypervisorName' => 'HypervisorName',
        'IpAddress' => 'IpAddress',
        'VirtualCenterName' => 'VirtualCenterName',
        'VirtualCenterReference' => 'VirtualCenterReference',
        'VirtualInfrastructureType' => 'VirtualInfrastructureType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Hypervisor

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Hypervisor from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatacenterName


=item * DatacenterReference


=item * DeletedBy


=item * DeletedTimestamp


=item * DomainName


=item * HostServiceId


=item * HypervisorId


=item * HypervisorName


=item * IpAddress


=item * VirtualCenterName


=item * VirtualCenterReference


=item * VirtualInfrastructureType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Hypervisor
   DatacenterName =>  $some_value, # string
   DatacenterReference =>  { # MyTypes::DatacenterReference
     DatacenterId => $some_value, # ObjId
     DatacenterName => $some_value, # ObjName
   },
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   DomainName =>  $some_value, # string
   HostServiceId => $some_value, # ObjId
   HypervisorId => $some_value, # ObjId
   HypervisorName => $some_value, # ObjName
   IpAddress => $some_value, # IpAddress
   VirtualCenterName =>  $some_value, # string
   VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
     VirtualCenterId => $some_value, # ObjId
     VirtualCenterName => $some_value, # ObjName
   },
   VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

