package MyTypes::HypervisorReference;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HypervisorId_of :ATTR(:get<HypervisorId>);
my %HypervisorName_of :ATTR(:get<HypervisorName>);

__PACKAGE__->_factory(
    [ qw(        HypervisorId
        HypervisorName

    ) ],
    {
        'HypervisorId' => \%HypervisorId_of,
        'HypervisorName' => \%HypervisorName_of,
    },
    {
        'HypervisorId' => 'MyTypes::ObjId',
        'HypervisorName' => 'MyTypes::ObjName',
    },
    {

        'HypervisorId' => 'HypervisorId',
        'HypervisorName' => 'HypervisorName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::HypervisorReference

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
HypervisorReference from the namespace http://www.netapp.com/management/v1.

Information about a Hypervisor.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HypervisorId


=item * HypervisorName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::HypervisorReference
   HypervisorId => $some_value, # ObjId
   HypervisorName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

