package MyTypes::IfcInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %IfcId_of :ATTR(:get<IfcId>);
my %IfcName_of :ATTR(:get<IfcName>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %IpAddressType_of :ATTR(:get<IpAddressType>);
my %Ipspace_of :ATTR(:get<Ipspace>);
my %IsVlanCapable_of :ATTR(:get<IsVlanCapable>);
my %MtuSize_of :ATTR(:get<MtuSize>);
my %Netmask_of :ATTR(:get<Netmask>);
my %PartnerInterfaceId_of :ATTR(:get<PartnerInterfaceId>);
my %PartnerInterfaceName_of :ATTR(:get<PartnerInterfaceName>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);
my %Status_of :ATTR(:get<Status>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        HostId
        HostName
        IfcId
        IfcName
        IpAddress
        IpAddressType
        Ipspace
        IsVlanCapable
        MtuSize
        Netmask
        PartnerInterfaceId
        PartnerInterfaceName
        PrefixLength
        Status
        Type

    ) ],
    {
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'IfcId' => \%IfcId_of,
        'IfcName' => \%IfcName_of,
        'IpAddress' => \%IpAddress_of,
        'IpAddressType' => \%IpAddressType_of,
        'Ipspace' => \%Ipspace_of,
        'IsVlanCapable' => \%IsVlanCapable_of,
        'MtuSize' => \%MtuSize_of,
        'Netmask' => \%Netmask_of,
        'PartnerInterfaceId' => \%PartnerInterfaceId_of,
        'PartnerInterfaceName' => \%PartnerInterfaceName_of,
        'PrefixLength' => \%PrefixLength_of,
        'Status' => \%Status_of,
        'Type' => \%Type_of,
    },
    {
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IfcId' => 'MyTypes::ObjId',
        'IfcName' => 'MyTypes::ObjName',
        'IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IpAddressType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsVlanCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MtuSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PartnerInterfaceId' => 'MyTypes::ObjId',
        'PartnerInterfaceName' => 'MyTypes::ObjFullName',

        'PrefixLength' => 'MyTypes::IfcInfo::_PrefixLength',
        'Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'IfcId' => 'IfcId',
        'IfcName' => 'IfcName',
        'IpAddress' => 'IpAddress',
        'IpAddressType' => 'IpAddressType',
        'Ipspace' => 'Ipspace',
        'IsVlanCapable' => 'IsVlanCapable',
        'MtuSize' => 'MtuSize',
        'Netmask' => 'Netmask',
        'PartnerInterfaceId' => 'PartnerInterfaceId',
        'PartnerInterfaceName' => 'PartnerInterfaceName',
        'PrefixLength' => 'PrefixLength',
        'Status' => 'Status',
        'Type' => 'Type',
    }
);

} # end BLOCK




package MyTypes::IfcInfo::_PrefixLength;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::IfcInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
IfcInfo from the namespace http://www.netapp.com/management/v1.

Information of about one Interface.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostId


=item * HostName


=item * IfcId


=item * IfcName


=item * IpAddress


=item * IpAddressType


=item * Ipspace


=item * IsVlanCapable


=item * MtuSize


=item * Netmask


=item * PartnerInterfaceId


=item * PartnerInterfaceName


=item * PrefixLength


=item * Status


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::IfcInfo
   HostId => $some_value, # ObjId
   HostName =>  $some_value, # string
   IfcId => $some_value, # ObjId
   IfcName => $some_value, # ObjName
   IpAddress =>  $some_value, # string
   IpAddressType =>  $some_value, # string
   Ipspace =>  $some_value, # string
   IsVlanCapable =>  $some_value, # boolean
   MtuSize =>  $some_value, # integer
   Netmask =>  $some_value, # string
   PartnerInterfaceId => $some_value, # ObjId
   PartnerInterfaceName => $some_value, # ObjFullName
   PrefixLength => $some_value, # atomic
   Status =>  $some_value, # string
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

