package MyTypes::InvalidCounterInstance;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterInfo_of :ATTR(:get<CounterInfo>);
my %ErrCode_of :ATTR(:get<ErrCode>);
my %ErrReason_of :ATTR(:get<ErrReason>);
my %HostId_of :ATTR(:get<HostId>);
my %InstanceName_of :ATTR(:get<InstanceName>);

__PACKAGE__->_factory(
    [ qw(        CounterInfo
        ErrCode
        ErrReason
        HostId
        InstanceName

    ) ],
    {
        'CounterInfo' => \%CounterInfo_of,
        'ErrCode' => \%ErrCode_of,
        'ErrReason' => \%ErrReason_of,
        'HostId' => \%HostId_of,
        'InstanceName' => \%InstanceName_of,
    },
    {
        'CounterInfo' => 'MyTypes::WrapperOfPerfObjectCounter',
        'ErrCode' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ErrReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CounterInfo' => 'CounterInfo',
        'ErrCode' => 'ErrCode',
        'ErrReason' => 'ErrReason',
        'HostId' => 'HostId',
        'InstanceName' => 'InstanceName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::InvalidCounterInstance

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
InvalidCounterInstance from the namespace http://www.netapp.com/management/v1.

A performance counter, an object Instance pair.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterInfo


=item * ErrCode


=item * ErrReason


=item * HostId


=item * InstanceName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::InvalidCounterInstance
   CounterInfo =>  { # MyTypes::WrapperOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
   ErrCode =>  $some_value, # string
   ErrReason =>  $some_value, # string
   HostId => $some_value, # ObjId
   InstanceName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

