package MyTypes::IoMeasurement;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DataRead_of :ATTR(:get<DataRead>);
my %DataWritten_of :ATTR(:get<DataWritten>);

__PACKAGE__->_factory(
    [ qw(        DataRead
        DataWritten

    ) ],
    {
        'DataRead' => \%DataRead_of,
        'DataWritten' => \%DataWritten_of,
    },
    {

        'DataRead' => 'MyTypes::IoMeasurement::_DataRead',

        'DataWritten' => 'MyTypes::IoMeasurement::_DataWritten',
    },
    {

        'DataRead' => 'DataRead',
        'DataWritten' => 'DataWritten',
    }
);

} # end BLOCK




package MyTypes::IoMeasurement::_DataRead;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::IoMeasurement::_DataWritten;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::IoMeasurement

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
IoMeasurement from the namespace http://www.netapp.com/management/v1.

Dataset node's I/O usage measurements.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DataRead


=item * DataWritten




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::IoMeasurement
   DataRead => $some_value, # atomic
   DataWritten => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

