package MyTypes::IpBindingInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Interface_of :ATTR(:get<Interface>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %MtuSize_of :ATTR(:get<MtuSize>);
my %Netmask_of :ATTR(:get<Netmask>);
my %PartnerInterface_of :ATTR(:get<PartnerInterface>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);
my %VlanIdentifier_of :ATTR(:get<VlanIdentifier>);

__PACKAGE__->_factory(
    [ qw(        Interface
        IpAddress
        MtuSize
        Netmask
        PartnerInterface
        PrefixLength
        VlanIdentifier

    ) ],
    {
        'Interface' => \%Interface_of,
        'IpAddress' => \%IpAddress_of,
        'MtuSize' => \%MtuSize_of,
        'Netmask' => \%Netmask_of,
        'PartnerInterface' => \%PartnerInterface_of,
        'PrefixLength' => \%PrefixLength_of,
        'VlanIdentifier' => \%VlanIdentifier_of,
    },
    {
        'Interface' => 'MyTypes::ObjNameOrId',
        'IpAddress' => 'MyTypes::IpAddress',

        'MtuSize' => 'MyTypes::IpBindingInfo::_MtuSize',
        'Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PartnerInterface' => 'MyTypes::ObjNameOrId',

        'PrefixLength' => 'MyTypes::IpBindingInfo::_PrefixLength',

        'VlanIdentifier' => 'MyTypes::IpBindingInfo::_VlanIdentifier',
    },
    {

        'Interface' => 'Interface',
        'IpAddress' => 'IpAddress',
        'MtuSize' => 'MtuSize',
        'Netmask' => 'Netmask',
        'PartnerInterface' => 'PartnerInterface',
        'PrefixLength' => 'PrefixLength',
        'VlanIdentifier' => 'VlanIdentifier',
    }
);

} # end BLOCK




package MyTypes::IpBindingInfo::_MtuSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::IpBindingInfo::_PrefixLength;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::IpBindingInfo::_VlanIdentifier;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::IpBindingInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
IpBindingInfo from the namespace http://www.netapp.com/management/v1.

vFiler IP Address To Interface binding information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Interface


=item * IpAddress


=item * MtuSize


=item * Netmask


=item * PartnerInterface


=item * PrefixLength


=item * VlanIdentifier




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::IpBindingInfo
   Interface => $some_value, # ObjNameOrId
   IpAddress => $some_value, # IpAddress
   MtuSize => $some_value, # atomic
   Netmask =>  $some_value, # string
   PartnerInterface => $some_value, # ObjNameOrId
   PrefixLength => $some_value, # atomic
   VlanIdentifier => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

