package MyTypes::LdapServer;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %LdapServerAddr_of :ATTR(:get<LdapServerAddr>);
my %LdapServerPort_of :ATTR(:get<LdapServerPort>);

__PACKAGE__->_factory(
    [ qw(        LdapServerAddr
        LdapServerPort

    ) ],
    {
        'LdapServerAddr' => \%LdapServerAddr_of,
        'LdapServerPort' => \%LdapServerPort_of,
    },
    {
        'LdapServerAddr' => 'MyTypes::NetworkAddress',

        'LdapServerPort' => 'MyTypes::LdapServer::_LdapServerPort',
    },
    {

        'LdapServerAddr' => 'LdapServerAddr',
        'LdapServerPort' => 'LdapServerPort',
    }
);

} # end BLOCK




package MyTypes::LdapServer::_LdapServerPort;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::LdapServer

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LdapServer from the namespace http://www.netapp.com/management/v1.

Information of one LDAP server contains ip Address and port number. This uniquely identifies the LDAP server in DFM.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * LdapServerAddr


=item * LdapServerPort




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LdapServer
   LdapServerAddr => $some_value, # NetworkAddress
   LdapServerPort => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

