package MyTypes::LdapServerInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %LastFailedTime_of :ATTR(:get<LastFailedTime>);
my %LastUsedTime_of :ATTR(:get<LastUsedTime>);
my %LdapServer_of :ATTR(:get<LdapServer>);

__PACKAGE__->_factory(
    [ qw(        LastFailedTime
        LastUsedTime
        LdapServer

    ) ],
    {
        'LastFailedTime' => \%LastFailedTime_of,
        'LastUsedTime' => \%LastUsedTime_of,
        'LdapServer' => \%LdapServer_of,
    },
    {
        'LastFailedTime' => 'MyTypes::Timestamp',
        'LastUsedTime' => 'MyTypes::Timestamp',
        'LdapServer' => 'MyTypes::LdapServer',
    },
    {

        'LastFailedTime' => 'LastFailedTime',
        'LastUsedTime' => 'LastUsedTime',
        'LdapServer' => 'LdapServer',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::LdapServerInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LdapServerInfo from the namespace http://www.netapp.com/management/v1.

Information of one LDAP server.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * LastFailedTime


=item * LastUsedTime


=item * LdapServer




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LdapServerInfo
   LastFailedTime => $some_value, # Timestamp
   LastUsedTime => $some_value, # Timestamp
   LdapServer =>  { # MyTypes::LdapServer
     LdapServerAddr => $some_value, # NetworkAddress
     LdapServerPort => $some_value, # atomic
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

