package MyTypes::LunIgroupInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IgroupInitiators_of :ATTR(:get<IgroupInitiators>);
my %IgroupLunId_of :ATTR(:get<IgroupLunId>);
my %IgroupName_of :ATTR(:get<IgroupName>);
my %IgroupOsType_of :ATTR(:get<IgroupOsType>);
my %IgroupProtocol_of :ATTR(:get<IgroupProtocol>);

__PACKAGE__->_factory(
    [ qw(        IgroupInitiators
        IgroupLunId
        IgroupName
        IgroupOsType
        IgroupProtocol

    ) ],
    {
        'IgroupInitiators' => \%IgroupInitiators_of,
        'IgroupLunId' => \%IgroupLunId_of,
        'IgroupName' => \%IgroupName_of,
        'IgroupOsType' => \%IgroupOsType_of,
        'IgroupProtocol' => \%IgroupProtocol_of,
    },
    {
        'IgroupInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',

        'IgroupLunId' => 'MyTypes::LunIgroupInfo::_IgroupLunId',
        'IgroupName' => 'MyTypes::ObjName',
        'IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IgroupProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'IgroupInitiators' => 'IgroupInitiators',
        'IgroupLunId' => 'IgroupLunId',
        'IgroupName' => 'IgroupName',
        'IgroupOsType' => 'IgroupOsType',
        'IgroupProtocol' => 'IgroupProtocol',
    }
);

} # end BLOCK




package MyTypes::LunIgroupInfo::_IgroupLunId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::LunIgroupInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LunIgroupInfo from the namespace http://www.netapp.com/management/v1.

If the LUN has been mapped To any Igroups or Hosts, this structure contains information relevant To the same.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IgroupInitiators


=item * IgroupLunId


=item * IgroupName


=item * IgroupOsType


=item * IgroupProtocol




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LunIgroupInfo
   IgroupInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
     LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
       Hostname =>  $some_value, # string
       InitiatorId => $some_value, # InitiatorId
     },
   },
   IgroupLunId => $some_value, # atomic
   IgroupName => $some_value, # ObjName
   IgroupOsType =>  $some_value, # string
   IgroupProtocol =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

