package MyTypes::LunInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %Igroups_of :ATTR(:get<Igroups>);
my %IsLunSpaceReserved_of :ATTR(:get<IsLunSpaceReserved>);
my %LunId_of :ATTR(:get<LunId>);
my %LunPath_of :ATTR(:get<LunPath>);
my %LunSerialNumber_of :ATTR(:get<LunSerialNumber>);
my %LunSize_of :ATTR(:get<LunSize>);
my %LunUsedSpace_of :ATTR(:get<LunUsedSpace>);
my %ObjectPerfStatus_of :ATTR(:get<ObjectPerfStatus>);
my %ObjectStatus_of :ATTR(:get<ObjectStatus>);
my %QtreeId_of :ATTR(:get<QtreeId>);
my %QtreeName_of :ATTR(:get<QtreeName>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        HostId
        HostName
        Igroups
        IsLunSpaceReserved
        LunId
        LunPath
        LunSerialNumber
        LunSize
        LunUsedSpace
        ObjectPerfStatus
        ObjectStatus
        QtreeId
        QtreeName
        VolumeId
        VolumeName

    ) ],
    {
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'Igroups' => \%Igroups_of,
        'IsLunSpaceReserved' => \%IsLunSpaceReserved_of,
        'LunId' => \%LunId_of,
        'LunPath' => \%LunPath_of,
        'LunSerialNumber' => \%LunSerialNumber_of,
        'LunSize' => \%LunSize_of,
        'LunUsedSpace' => \%LunUsedSpace_of,
        'ObjectPerfStatus' => \%ObjectPerfStatus_of,
        'ObjectStatus' => \%ObjectStatus_of,
        'QtreeId' => \%QtreeId_of,
        'QtreeName' => \%QtreeName_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'MyTypes::ObjName',
        'Igroups' => 'MyTypes::ArrayOfIgroupReference',
        'IsLunSpaceReserved' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LunId' => 'MyTypes::ObjId',
        'LunPath' => 'MyTypes::ObjName',
        'LunSerialNumber' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'LunSize' => 'MyTypes::LunInfo::_LunSize',

        'LunUsedSpace' => 'MyTypes::LunInfo::_LunUsedSpace',
        'ObjectPerfStatus' => 'MyTypes::ObjStatus',
        'ObjectStatus' => 'MyTypes::ObjStatus',
        'QtreeId' => 'MyTypes::ObjId',
        'QtreeName' => 'MyTypes::ObjName',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjName',
    },
    {

        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'Igroups' => 'Igroups',
        'IsLunSpaceReserved' => 'IsLunSpaceReserved',
        'LunId' => 'LunId',
        'LunPath' => 'LunPath',
        'LunSerialNumber' => 'LunSerialNumber',
        'LunSize' => 'LunSize',
        'LunUsedSpace' => 'LunUsedSpace',
        'ObjectPerfStatus' => 'ObjectPerfStatus',
        'ObjectStatus' => 'ObjectStatus',
        'QtreeId' => 'QtreeId',
        'QtreeName' => 'QtreeName',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK




package MyTypes::LunInfo::_LunSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::LunInfo::_LunUsedSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::LunInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LunInfo from the namespace http://www.netapp.com/management/v1.

Information about a Lun.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostId


=item * HostName


=item * Igroups


=item * IsLunSpaceReserved


=item * LunId


=item * LunPath


=item * LunSerialNumber


=item * LunSize


=item * LunUsedSpace


=item * ObjectPerfStatus


=item * ObjectStatus


=item * QtreeId


=item * QtreeName


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LunInfo
   HostId => $some_value, # ObjId
   HostName => $some_value, # ObjName
   Igroups =>  { # MyTypes::ArrayOfIgroupReference
     IgroupReference =>  { # MyTypes::IgroupReference
       IgroupId => $some_value, # ObjId
       IgroupName => $some_value, # ObjName
     },
   },
   IsLunSpaceReserved =>  $some_value, # boolean
   LunId => $some_value, # ObjId
   LunPath => $some_value, # ObjName
   LunSerialNumber =>  $some_value, # string
   LunSize => $some_value, # atomic
   LunUsedSpace => $some_value, # atomic
   ObjectPerfStatus => $some_value, # ObjStatus
   ObjectStatus => $some_value, # ObjStatus
   QtreeId => $some_value, # ObjId
   QtreeName => $some_value, # ObjName
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

