package MyTypes::LunMappingInitiator;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Hostname_of :ATTR(:get<Hostname>);
my %InitiatorId_of :ATTR(:get<InitiatorId>);

__PACKAGE__->_factory(
    [ qw(        Hostname
        InitiatorId

    ) ],
    {
        'Hostname' => \%Hostname_of,
        'InitiatorId' => \%InitiatorId_of,
    },
    {
        'Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'InitiatorId' => 'MyTypes::InitiatorId',
    },
    {

        'Hostname' => 'Hostname',
        'InitiatorId' => 'InitiatorId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::LunMappingInitiator

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LunMappingInitiator from the namespace http://www.netapp.com/management/v1.

Specifies an initiator To map LUNs in the Dataset node To, and, optionally, the Host To which it belongs.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Hostname


=item * InitiatorId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LunMappingInitiator
   Hostname =>  $some_value, # string
   InitiatorId => $some_value, # InitiatorId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

