package MyTypes::LunNameOrId;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %LunId_of :ATTR(:get<LunId>);
my %LunName_of :ATTR(:get<LunName>);

__PACKAGE__->_factory(
    [ qw(        LunId
        LunName

    ) ],
    {
        'LunId' => \%LunId_of,
        'LunName' => \%LunName_of,
    },
    {
        'LunId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'LunName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'LunId' => 'LunId',
        'LunName' => 'LunName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::LunNameOrId

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
LunNameOrId from the namespace http://www.netapp.com/management/v1.

Details of a LUN Name or Id. When used as input only one of LunName or LunId is specified. When used as as output both will be returned. If a LunName is specified, then either VolumeIdentifier or HostIdentifier must also be specified.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * LunId


=item * LunName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::LunNameOrId
   LunId =>  $some_value, # unsignedInt
   LunName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

