package MyTypes::Metric;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Id_of :ATTR(:get<Id>);
my %MetricResult_of :ATTR(:get<MetricResult>);
my %Period_of :ATTR(:get<Period>);
my %Slide_of :ATTR(:get<Slide>);
my %Type_of :ATTR(:get<Type>);
my %Value_of :ATTR(:get<Value>);

__PACKAGE__->_factory(
    [ qw(        Id
        MetricResult
        Period
        Slide
        Type
        Value

    ) ],
    {
        'Id' => \%Id_of,
        'MetricResult' => \%MetricResult_of,
        'Period' => \%Period_of,
        'Slide' => \%Slide_of,
        'Type' => \%Type_of,
        'Value' => \%Value_of,
    },
    {
        'Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'Period' => 'MyTypes::Metric::_Period',
        'Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Id' => 'Id',
        'MetricResult' => 'MetricResult',
        'Period' => 'Period',
        'Slide' => 'Slide',
        'Type' => 'Type',
        'Value' => 'Value',
    }
);

} # end BLOCK




package MyTypes::Metric::_Period;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::Metric

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Metric from the namespace http://www.netapp.com/management/v1.

Contains the computation performed and the Value




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Id


=item * MetricResult


=item * Period


=item * Slide


=item * Type


=item * Value




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Metric
   Id =>  $some_value, # string
   MetricResult =>  $some_value, # string
   Period => $some_value, # atomic
   Slide =>  $some_value, # string
   Type =>  $some_value, # string
   Value =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

