package MyTypes::MetricDatasetNodeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %ProtectionPolicyName_of :ATTR(:get<ProtectionPolicyName>);
my %ProvisioningPolicyName_of :ATTR(:get<ProvisioningPolicyName>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        DeletedTimestamp
        DpNodeName
        ProtectionPolicyName
        ProvisioningPolicyName
        StorageServiceName

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'DpNodeName' => \%DpNodeName_of,
        'ProtectionPolicyName' => \%ProtectionPolicyName_of,
        'ProvisioningPolicyName' => \%ProvisioningPolicyName_of,
        'StorageServiceName' => \%StorageServiceName_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'ProtectionPolicyName' => 'MyTypes::ObjName',
        'ProvisioningPolicyName' => 'MyTypes::ObjName',
        'StorageServiceName' => 'MyTypes::ObjName',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'DpNodeName' => 'DpNodeName',
        'ProtectionPolicyName' => 'ProtectionPolicyName',
        'ProvisioningPolicyName' => 'ProvisioningPolicyName',
        'StorageServiceName' => 'StorageServiceName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::MetricDatasetNodeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MetricDatasetNodeInfo from the namespace http://www.netapp.com/management/v1.

Information about the Dataset node




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * DeletedTimestamp


=item * DpNodeName


=item * ProtectionPolicyName


=item * ProvisioningPolicyName


=item * StorageServiceName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MetricDatasetNodeInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   DeletedTimestamp => $some_value, # DpTimestamp
   DpNodeName => $some_value, # DpPolicyNodeName
   ProtectionPolicyName => $some_value, # ObjName
   ProvisioningPolicyName => $some_value, # ObjName
   StorageServiceName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

