package MyTypes::MigrationDryRunResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DryRunResults_of :ATTR(:get<DryRunResults>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        DryRunResults
        VolumeId
        VolumeName

    ) ],
    {
        'DryRunResults' => \%DryRunResults_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjName',
    },
    {

        'DryRunResults' => 'DryRunResults',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::MigrationDryRunResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MigrationDryRunResult from the namespace http://www.netapp.com/management/v1.

Dry run Results of migration of each individual Volume




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DryRunResults


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MigrationDryRunResult
   DryRunResults =>  { # MyTypes::ArrayOfDryRunResult
     DryRunResult =>  { # MyTypes::DryRunResult
       DryRunAction =>  $some_value, # string
       DryRunEffect =>  $some_value, # string
       DryRunReason =>  $some_value, # string
       DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
         ResultDetail =>  { # MyTypes::ResultDetail
           Action =>  $some_value, # string
           Effect =>  $some_value, # string
           Reason =>  $some_value, # string
           Severity => $some_value, # ObjStatus
           Suggestion =>  $some_value, # string
         },
       },
       DryRunSeverity => $some_value, # ObjStatus
       DryRunSuggestion =>  $some_value, # string
     },
   },
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

