package MyTypes::MigrationRequestInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CleanupStaleStorage_of :ATTR(:get<CleanupStaleStorage>);
my %DestinationAggregateNameOrId_of :ATTR(:get<DestinationAggregateNameOrId>);
my %RetentionType_of :ATTR(:get<RetentionType>);
my %RunDedupeScan_of :ATTR(:get<RunDedupeScan>);
my %RunOnDemandUpdate_of :ATTR(:get<RunOnDemandUpdate>);
my %Volumes_of :ATTR(:get<Volumes>);

__PACKAGE__->_factory(
    [ qw(        CleanupStaleStorage
        DestinationAggregateNameOrId
        RetentionType
        RunDedupeScan
        RunOnDemandUpdate
        Volumes

    ) ],
    {
        'CleanupStaleStorage' => \%CleanupStaleStorage_of,
        'DestinationAggregateNameOrId' => \%DestinationAggregateNameOrId_of,
        'RetentionType' => \%RetentionType_of,
        'RunDedupeScan' => \%RunDedupeScan_of,
        'RunOnDemandUpdate' => \%RunOnDemandUpdate_of,
        'Volumes' => \%Volumes_of,
    },
    {
        'CleanupStaleStorage' => 'MyTypes::CleanupStaleStorage',
        'DestinationAggregateNameOrId' => 'MyTypes::ObjNameOrId',
        'RetentionType' => 'MyTypes::DpBackupRetentionType',
        'RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'RunOnDemandUpdate' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Volumes' => 'MyTypes::ArrayOfObjNameOrId',
    },
    {

        'CleanupStaleStorage' => 'CleanupStaleStorage',
        'DestinationAggregateNameOrId' => 'DestinationAggregateNameOrId',
        'RetentionType' => 'RetentionType',
        'RunDedupeScan' => 'RunDedupeScan',
        'RunOnDemandUpdate' => 'RunOnDemandUpdate',
        'Volumes' => 'Volumes',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::MigrationRequestInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MigrationRequestInfo from the namespace http://www.netapp.com/management/v1.

Details of a Volume migration Request.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CleanupStaleStorage


=item * DestinationAggregateNameOrId


=item * RetentionType


=item * RunDedupeScan


=item * RunOnDemandUpdate


=item * Volumes




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MigrationRequestInfo
   CleanupStaleStorage => $some_value, # CleanupStaleStorage
   DestinationAggregateNameOrId => $some_value, # ObjNameOrId
   RetentionType => $some_value, # DpBackupRetentionType
   RunDedupeScan =>  $some_value, # boolean
   RunOnDemandUpdate =>  $some_value, # boolean
   Volumes =>  { # MyTypes::ArrayOfObjNameOrId
     ObjNameOrId => $some_value, # ObjNameOrId
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

