package MyTypes::MissingMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);
my %CifsShareNames_of :ATTR(:get<CifsShareNames>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %HostId_of :ATTR(:get<HostId>);
my %Hostname_of :ATTR(:get<Hostname>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %MemberType_of :ATTR(:get<MemberType>);
my %NfsExportName_of :ATTR(:get<NfsExportName>);
my %QuotaHardLimit_of :ATTR(:get<QuotaHardLimit>);
my %QuotaSoftLimit_of :ATTR(:get<QuotaSoftLimit>);
my %SpaceGuarantee_of :ATTR(:get<SpaceGuarantee>);
my %TotalSpace_of :ATTR(:get<TotalSpace>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName
        CifsShareNames
        DeletedTimestamp
        HostId
        Hostname
        MemberId
        MemberName
        MemberType
        NfsExportName
        QuotaHardLimit
        QuotaSoftLimit
        SpaceGuarantee
        TotalSpace

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
        'CifsShareNames' => \%CifsShareNames_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'HostId' => \%HostId_of,
        'Hostname' => \%Hostname_of,
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'MemberType' => \%MemberType_of,
        'NfsExportName' => \%NfsExportName_of,
        'QuotaHardLimit' => \%QuotaHardLimit_of,
        'QuotaSoftLimit' => \%QuotaSoftLimit_of,
        'SpaceGuarantee' => \%SpaceGuarantee_of,
        'TotalSpace' => \%TotalSpace_of,
    },
    {
        'AggregateId' => 'MyTypes::ObjId',
        'AggregateName' => 'MyTypes::ObjName',
        'CifsShareNames' => 'MyTypes::ArrayOfCifsShareName',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'HostId' => 'MyTypes::ObjId',
        'Hostname' => 'MyTypes::ObjName',
        'MemberId' => 'MyTypes::ObjId',
        'MemberName' => 'MyTypes::ObjName',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NfsExportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'QuotaHardLimit' => 'MyTypes::MissingMemberInfo::_QuotaHardLimit',

        'QuotaSoftLimit' => 'MyTypes::MissingMemberInfo::_QuotaSoftLimit',
        'SpaceGuarantee' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'TotalSpace' => 'MyTypes::MissingMemberInfo::_TotalSpace',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
        'CifsShareNames' => 'CifsShareNames',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'HostId' => 'HostId',
        'Hostname' => 'Hostname',
        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'MemberType' => 'MemberType',
        'NfsExportName' => 'NfsExportName',
        'QuotaHardLimit' => 'QuotaHardLimit',
        'QuotaSoftLimit' => 'QuotaSoftLimit',
        'SpaceGuarantee' => 'SpaceGuarantee',
        'TotalSpace' => 'TotalSpace',
    }
);

} # end BLOCK




package MyTypes::MissingMemberInfo::_QuotaHardLimit;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MissingMemberInfo::_QuotaSoftLimit;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MissingMemberInfo::_TotalSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::MissingMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MissingMemberInfo from the namespace http://www.netapp.com/management/v1.

Information about one missing member of a Dataset.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName


=item * CifsShareNames


=item * DeletedTimestamp


=item * HostId


=item * Hostname


=item * MemberId


=item * MemberName


=item * MemberType


=item * NfsExportName


=item * QuotaHardLimit


=item * QuotaSoftLimit


=item * SpaceGuarantee


=item * TotalSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MissingMemberInfo
   AggregateId => $some_value, # ObjId
   AggregateName => $some_value, # ObjName
   CifsShareNames =>  { # MyTypes::ArrayOfCifsShareName
     CifsShareName => $some_value, # CifsShareName
   },
   DeletedTimestamp => $some_value, # DpTimestamp
   HostId => $some_value, # ObjId
   Hostname => $some_value, # ObjName
   MemberId => $some_value, # ObjId
   MemberName => $some_value, # ObjName
   MemberType =>  $some_value, # string
   NfsExportName =>  $some_value, # string
   QuotaHardLimit => $some_value, # atomic
   QuotaSoftLimit => $some_value, # atomic
   SpaceGuarantee =>  $some_value, # string
   TotalSpace => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

