package MyTypes::MonthlyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DayOfMonth_of :ATTR(:get<DayOfMonth>);
my %DayOfWeek_of :ATTR(:get<DayOfWeek>);
my %ItemId_of :ATTR(:get<ItemId>);
my %StartHour_of :ATTR(:get<StartHour>);
my %StartMinute_of :ATTR(:get<StartMinute>);
my %WeekOfMonth_of :ATTR(:get<WeekOfMonth>);

__PACKAGE__->_factory(
    [ qw(        DayOfMonth
        DayOfWeek
        ItemId
        StartHour
        StartMinute
        WeekOfMonth

    ) ],
    {
        'DayOfMonth' => \%DayOfMonth_of,
        'DayOfWeek' => \%DayOfWeek_of,
        'ItemId' => \%ItemId_of,
        'StartHour' => \%StartHour_of,
        'StartMinute' => \%StartMinute_of,
        'WeekOfMonth' => \%WeekOfMonth_of,
    },
    {

        'DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',

        'DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',

        'ItemId' => 'MyTypes::MonthlyInfo::_ItemId',

        'StartHour' => 'MyTypes::MonthlyInfo::_StartHour',

        'StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',

        'WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
    },
    {

        'DayOfMonth' => 'DayOfMonth',
        'DayOfWeek' => 'DayOfWeek',
        'ItemId' => 'ItemId',
        'StartHour' => 'StartHour',
        'StartMinute' => 'StartMinute',
        'WeekOfMonth' => 'WeekOfMonth',
    }
);

} # end BLOCK




package MyTypes::MonthlyInfo::_DayOfMonth;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MonthlyInfo::_DayOfWeek;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MonthlyInfo::_ItemId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MonthlyInfo::_StartHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MonthlyInfo::_StartMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::MonthlyInfo::_WeekOfMonth;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::MonthlyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MonthlyInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a monthly schedule. May only be used in a monthly schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DayOfMonth


=item * DayOfWeek


=item * ItemId


=item * StartHour


=item * StartMinute


=item * WeekOfMonth




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MonthlyInfo
   DayOfMonth => $some_value, # atomic
   DayOfWeek => $some_value, # atomic
   ItemId => $some_value, # atomic
   StartHour => $some_value, # atomic
   StartMinute => $some_value, # atomic
   WeekOfMonth => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

