package MyTypes::MonthlySubscheduleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SubscheduleId_of :ATTR(:get<SubscheduleId>);
my %SubscheduleName_of :ATTR(:get<SubscheduleName>);

__PACKAGE__->_factory(
    [ qw(        SubscheduleId
        SubscheduleName

    ) ],
    {
        'SubscheduleId' => \%SubscheduleId_of,
        'SubscheduleName' => \%SubscheduleName_of,
    },
    {
        'SubscheduleId' => 'MyTypes::ObjId',
        'SubscheduleName' => 'MyTypes::ObjName',
    },
    {

        'SubscheduleId' => 'SubscheduleId',
        'SubscheduleName' => 'SubscheduleName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::MonthlySubscheduleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
MonthlySubscheduleInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a monthly subschedule. May only be used in a monthly schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SubscheduleId


=item * SubscheduleName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::MonthlySubscheduleInfo
   SubscheduleId => $some_value, # ObjId
   SubscheduleName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

