package MyTypes::NasContainerSettings;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AutoDeleteSnapshots_of :ATTR(:get<AutoDeleteSnapshots>);
my %AutoGrowCapacity_of :ATTR(:get<AutoGrowCapacity>);
my %DefaultGroupQuota_of :ATTR(:get<DefaultGroupQuota>);
my %DefaultUserQuota_of :ATTR(:get<DefaultUserQuota>);
my %SnapshotReserve_of :ATTR(:get<SnapshotReserve>);
my %SpaceOnDemand_of :ATTR(:get<SpaceOnDemand>);
my %StorageContainerType_of :ATTR(:get<StorageContainerType>);
my %ThinProvision_of :ATTR(:get<ThinProvision>);

__PACKAGE__->_factory(
    [ qw(        AutoDeleteSnapshots
        AutoGrowCapacity
        DefaultGroupQuota
        DefaultUserQuota
        SnapshotReserve
        SpaceOnDemand
        StorageContainerType
        ThinProvision

    ) ],
    {
        'AutoDeleteSnapshots' => \%AutoDeleteSnapshots_of,
        'AutoGrowCapacity' => \%AutoGrowCapacity_of,
        'DefaultGroupQuota' => \%DefaultGroupQuota_of,
        'DefaultUserQuota' => \%DefaultUserQuota_of,
        'SnapshotReserve' => \%SnapshotReserve_of,
        'SpaceOnDemand' => \%SpaceOnDemand_of,
        'StorageContainerType' => \%StorageContainerType_of,
        'ThinProvision' => \%ThinProvision_of,
    },
    {
        'AutoDeleteSnapshots' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'AutoGrowCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'DefaultGroupQuota' => 'MyTypes::NasContainerSettings::_DefaultGroupQuota',

        'DefaultUserQuota' => 'MyTypes::NasContainerSettings::_DefaultUserQuota',
        'SnapshotReserve' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'SpaceOnDemand' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'StorageContainerType' => 'MyTypes::StorageContainerType',
        'ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'AutoDeleteSnapshots' => 'AutoDeleteSnapshots',
        'AutoGrowCapacity' => 'AutoGrowCapacity',
        'DefaultGroupQuota' => 'DefaultGroupQuota',
        'DefaultUserQuota' => 'DefaultUserQuota',
        'SnapshotReserve' => 'SnapshotReserve',
        'SpaceOnDemand' => 'SpaceOnDemand',
        'StorageContainerType' => 'StorageContainerType',
        'ThinProvision' => 'ThinProvision',
    }
);

} # end BLOCK




package MyTypes::NasContainerSettings::_DefaultGroupQuota;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NasContainerSettings::_DefaultUserQuota;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::NasContainerSettings

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NasContainerSettings from the namespace http://www.netapp.com/management/v1.

Details of capacity settings like space guarantees, quotas, out of space actions when provisioning storage for NAS access.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AutoDeleteSnapshots


=item * AutoGrowCapacity


=item * DefaultGroupQuota


=item * DefaultUserQuota


=item * SnapshotReserve


=item * SpaceOnDemand


=item * StorageContainerType


=item * ThinProvision




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NasContainerSettings
   AutoDeleteSnapshots =>  $some_value, # boolean
   AutoGrowCapacity =>  $some_value, # boolean
   DefaultGroupQuota => $some_value, # atomic
   DefaultUserQuota => $some_value, # atomic
   SnapshotReserve =>  $some_value, # boolean
   SpaceOnDemand =>  $some_value, # boolean
   StorageContainerType => $some_value, # StorageContainerType
   ThinProvision =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

