package MyTypes::NetifIpInterfaceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdministrativeStatus_of :ATTR(:get<AdministrativeStatus>);
my %BytesIn_of :ATTR(:get<BytesIn>);
my %BytesOut_of :ATTR(:get<BytesOut>);
my %DiscardsIn_of :ATTR(:get<DiscardsIn>);
my %DiscardsOut_of :ATTR(:get<DiscardsOut>);
my %ErrorsIn_of :ATTR(:get<ErrorsIn>);
my %ErrorsOut_of :ATTR(:get<ErrorsOut>);
my %IpAddresses_of :ATTR(:get<IpAddresses>);
my %Name_of :ATTR(:get<Name>);
my %OperationalStatus_of :ATTR(:get<OperationalStatus>);
my %PacketsIn_of :ATTR(:get<PacketsIn>);
my %PacketsOut_of :ATTR(:get<PacketsOut>);
my %PhysicalAddress_of :ATTR(:get<PhysicalAddress>);
my %Speed_of :ATTR(:get<Speed>);

__PACKAGE__->_factory(
    [ qw(        AdministrativeStatus
        BytesIn
        BytesOut
        DiscardsIn
        DiscardsOut
        ErrorsIn
        ErrorsOut
        IpAddresses
        Name
        OperationalStatus
        PacketsIn
        PacketsOut
        PhysicalAddress
        Speed

    ) ],
    {
        'AdministrativeStatus' => \%AdministrativeStatus_of,
        'BytesIn' => \%BytesIn_of,
        'BytesOut' => \%BytesOut_of,
        'DiscardsIn' => \%DiscardsIn_of,
        'DiscardsOut' => \%DiscardsOut_of,
        'ErrorsIn' => \%ErrorsIn_of,
        'ErrorsOut' => \%ErrorsOut_of,
        'IpAddresses' => \%IpAddresses_of,
        'Name' => \%Name_of,
        'OperationalStatus' => \%OperationalStatus_of,
        'PacketsIn' => \%PacketsIn_of,
        'PacketsOut' => \%PacketsOut_of,
        'PhysicalAddress' => \%PhysicalAddress_of,
        'Speed' => \%Speed_of,
    },
    {
        'AdministrativeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'BytesIn' => 'MyTypes::NetifIpInterfaceInfo::_BytesIn',

        'BytesOut' => 'MyTypes::NetifIpInterfaceInfo::_BytesOut',

        'DiscardsIn' => 'MyTypes::NetifIpInterfaceInfo::_DiscardsIn',

        'DiscardsOut' => 'MyTypes::NetifIpInterfaceInfo::_DiscardsOut',

        'ErrorsIn' => 'MyTypes::NetifIpInterfaceInfo::_ErrorsIn',

        'ErrorsOut' => 'MyTypes::NetifIpInterfaceInfo::_ErrorsOut',
        'IpAddresses' => 'MyTypes::ArrayOfString',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OperationalStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'PacketsIn' => 'MyTypes::NetifIpInterfaceInfo::_PacketsIn',

        'PacketsOut' => 'MyTypes::NetifIpInterfaceInfo::_PacketsOut',
        'PhysicalAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Speed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
    },
    {

        'AdministrativeStatus' => 'AdministrativeStatus',
        'BytesIn' => 'BytesIn',
        'BytesOut' => 'BytesOut',
        'DiscardsIn' => 'DiscardsIn',
        'DiscardsOut' => 'DiscardsOut',
        'ErrorsIn' => 'ErrorsIn',
        'ErrorsOut' => 'ErrorsOut',
        'IpAddresses' => 'IpAddresses',
        'Name' => 'Name',
        'OperationalStatus' => 'OperationalStatus',
        'PacketsIn' => 'PacketsIn',
        'PacketsOut' => 'PacketsOut',
        'PhysicalAddress' => 'PhysicalAddress',
        'Speed' => 'Speed',
    }
);

} # end BLOCK




package MyTypes::NetifIpInterfaceInfo::_BytesIn;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_BytesOut;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_DiscardsIn;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_DiscardsOut;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_ErrorsIn;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_ErrorsOut;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_PacketsIn;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NetifIpInterfaceInfo::_PacketsOut;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::NetifIpInterfaceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NetifIpInterfaceInfo from the namespace http://www.netapp.com/management/v1.

Information about one network Interface.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdministrativeStatus


=item * BytesIn


=item * BytesOut


=item * DiscardsIn


=item * DiscardsOut


=item * ErrorsIn


=item * ErrorsOut


=item * IpAddresses


=item * Name


=item * OperationalStatus


=item * PacketsIn


=item * PacketsOut


=item * PhysicalAddress


=item * Speed




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NetifIpInterfaceInfo
   AdministrativeStatus =>  $some_value, # string
   BytesIn => $some_value, # atomic
   BytesOut => $some_value, # atomic
   DiscardsIn => $some_value, # atomic
   DiscardsOut => $some_value, # atomic
   ErrorsIn => $some_value, # atomic
   ErrorsOut => $some_value, # atomic
   IpAddresses =>  { # MyTypes::ArrayOfString
     String =>  $some_value, # string
   },
   Name =>  $some_value, # string
   OperationalStatus =>  $some_value, # string
   PacketsIn => $some_value, # atomic
   PacketsOut => $some_value, # atomic
   PhysicalAddress =>  $some_value, # string
   Speed =>  $some_value, # unsignedInt
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

