package MyTypes::NetworkInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HopCount_of :ATTR(:get<HopCount>);
my %LastSearchedTime_of :ATTR(:get<LastSearchedTime>);
my %NetworkAddress_of :ATTR(:get<NetworkAddress>);
my %NetworkId_of :ATTR(:get<NetworkId>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);

__PACKAGE__->_factory(
    [ qw(        HopCount
        LastSearchedTime
        NetworkAddress
        NetworkId
        PrefixLength

    ) ],
    {
        'HopCount' => \%HopCount_of,
        'LastSearchedTime' => \%LastSearchedTime_of,
        'NetworkAddress' => \%NetworkAddress_of,
        'NetworkId' => \%NetworkId_of,
        'PrefixLength' => \%PrefixLength_of,
    },
    {

        'HopCount' => 'MyTypes::NetworkInfo::_HopCount',
        'LastSearchedTime' => 'MyTypes::Timestamp',
        'NetworkAddress' => 'MyTypes::NetworkAddress',
        'NetworkId' => 'MyTypes::NetworkId',
        'PrefixLength' => 'MyTypes::PrefixLength',
    },
    {

        'HopCount' => 'HopCount',
        'LastSearchedTime' => 'LastSearchedTime',
        'NetworkAddress' => 'NetworkAddress',
        'NetworkId' => 'NetworkId',
        'PrefixLength' => 'PrefixLength',
    }
);

} # end BLOCK




package MyTypes::NetworkInfo::_HopCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::NetworkInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NetworkInfo from the namespace http://www.netapp.com/management/v1.

Information of one network.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HopCount


=item * LastSearchedTime


=item * NetworkAddress


=item * NetworkId


=item * PrefixLength




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NetworkInfo
   HopCount => $some_value, # atomic
   LastSearchedTime => $some_value, # Timestamp
   NetworkAddress => $some_value, # NetworkAddress
   NetworkId => $some_value, # NetworkId
   PrefixLength => $some_value, # PrefixLength
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

