package MyTypes::NetworkSnmpCredentialInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IsSnmpPrivacyEnabled_of :ATTR(:get<IsSnmpPrivacyEnabled>);
my %NetworkAddress_of :ATTR(:get<NetworkAddress>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);
my %SnmpAuthenticationLogin_of :ATTR(:get<SnmpAuthenticationLogin>);
my %SnmpAuthenticationProtocol_of :ATTR(:get<SnmpAuthenticationProtocol>);
my %SnmpCommunityName_of :ATTR(:get<SnmpCommunityName>);
my %SnmpId_of :ATTR(:get<SnmpId>);
my %SnmpVersion_of :ATTR(:get<SnmpVersion>);

__PACKAGE__->_factory(
    [ qw(        IsSnmpPrivacyEnabled
        NetworkAddress
        PrefixLength
        SnmpAuthenticationLogin
        SnmpAuthenticationProtocol
        SnmpCommunityName
        SnmpId
        SnmpVersion

    ) ],
    {
        'IsSnmpPrivacyEnabled' => \%IsSnmpPrivacyEnabled_of,
        'NetworkAddress' => \%NetworkAddress_of,
        'PrefixLength' => \%PrefixLength_of,
        'SnmpAuthenticationLogin' => \%SnmpAuthenticationLogin_of,
        'SnmpAuthenticationProtocol' => \%SnmpAuthenticationProtocol_of,
        'SnmpCommunityName' => \%SnmpCommunityName_of,
        'SnmpId' => \%SnmpId_of,
        'SnmpVersion' => \%SnmpVersion_of,
    },
    {
        'IsSnmpPrivacyEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NetworkAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrefixLength' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SnmpAuthenticationLogin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpAuthenticationProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpCommunityName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnmpId' => 'MyTypes::SnmpId',
        'SnmpVersion' => 'MyTypes::SnmpVersion',
    },
    {

        'IsSnmpPrivacyEnabled' => 'IsSnmpPrivacyEnabled',
        'NetworkAddress' => 'NetworkAddress',
        'PrefixLength' => 'PrefixLength',
        'SnmpAuthenticationLogin' => 'SnmpAuthenticationLogin',
        'SnmpAuthenticationProtocol' => 'SnmpAuthenticationProtocol',
        'SnmpCommunityName' => 'SnmpCommunityName',
        'SnmpId' => 'SnmpId',
        'SnmpVersion' => 'SnmpVersion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::NetworkSnmpCredentialInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NetworkSnmpCredentialInfo from the namespace http://www.netapp.com/management/v1.

SNMP credential information of a network or Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IsSnmpPrivacyEnabled


=item * NetworkAddress


=item * PrefixLength


=item * SnmpAuthenticationLogin


=item * SnmpAuthenticationProtocol


=item * SnmpCommunityName


=item * SnmpId


=item * SnmpVersion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NetworkSnmpCredentialInfo
   IsSnmpPrivacyEnabled =>  $some_value, # boolean
   NetworkAddress =>  $some_value, # string
   PrefixLength =>  $some_value, # integer
   SnmpAuthenticationLogin =>  $some_value, # string
   SnmpAuthenticationProtocol =>  $some_value, # string
   SnmpCommunityName =>  $some_value, # string
   SnmpId => $some_value, # SnmpId
   SnmpVersion => $some_value, # SnmpVersion
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

