package MyTypes::NfsExportHost;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Hostname_of :ATTR(:get<Hostname>);
my %IsAnException_of :ATTR(:get<IsAnException>);

__PACKAGE__->_factory(
    [ qw(        Hostname
        IsAnException

    ) ],
    {
        'Hostname' => \%Hostname_of,
        'IsAnException' => \%IsAnException_of,
    },
    {
        'Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'Hostname' => 'Hostname',
        'IsAnException' => 'IsAnException',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::NfsExportHost

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NfsExportHost from the namespace http://www.netapp.com/management/v1.

Specifies a single Host or all-hosts. A Host can be a Host Name (DNS Name), an IP Address, a subnet or a domain Name. If an 'all-hosts' entry is present, all other Host Name entries must be negated.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Hostname


=item * IsAnException




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NfsExportHost
   Hostname =>  $some_value, # string
   IsAnException =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

