package MyTypes::NfsExportRules;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AnonymousAccessUser_of :ATTR(:get<AnonymousAccessUser>);
my %DisableSetuid_of :ATTR(:get<DisableSetuid>);
my %IsReadonlyForAllHosts_of :ATTR(:get<IsReadonlyForAllHosts>);
my %IsReadwriteForAllHosts_of :ATTR(:get<IsReadwriteForAllHosts>);
my %NfsExportRoHosts_of :ATTR(:get<NfsExportRoHosts>);
my %NfsExportRootHosts_of :ATTR(:get<NfsExportRootHosts>);
my %NfsExportRwHosts_of :ATTR(:get<NfsExportRwHosts>);
my %NfsSecurityFlavors_of :ATTR(:get<NfsSecurityFlavors>);

__PACKAGE__->_factory(
    [ qw(        AnonymousAccessUser
        DisableSetuid
        IsReadonlyForAllHosts
        IsReadwriteForAllHosts
        NfsExportRoHosts
        NfsExportRootHosts
        NfsExportRwHosts
        NfsSecurityFlavors

    ) ],
    {
        'AnonymousAccessUser' => \%AnonymousAccessUser_of,
        'DisableSetuid' => \%DisableSetuid_of,
        'IsReadonlyForAllHosts' => \%IsReadonlyForAllHosts_of,
        'IsReadwriteForAllHosts' => \%IsReadwriteForAllHosts_of,
        'NfsExportRoHosts' => \%NfsExportRoHosts_of,
        'NfsExportRootHosts' => \%NfsExportRootHosts_of,
        'NfsExportRwHosts' => \%NfsExportRwHosts_of,
        'NfsSecurityFlavors' => \%NfsSecurityFlavors_of,
    },
    {

        'AnonymousAccessUser' => 'MyTypes::NfsExportRules::_AnonymousAccessUser',
        'DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
        'NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
        'NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
        'NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
    },
    {

        'AnonymousAccessUser' => 'AnonymousAccessUser',
        'DisableSetuid' => 'DisableSetuid',
        'IsReadonlyForAllHosts' => 'IsReadonlyForAllHosts',
        'IsReadwriteForAllHosts' => 'IsReadwriteForAllHosts',
        'NfsExportRoHosts' => 'NfsExportRoHosts',
        'NfsExportRootHosts' => 'NfsExportRootHosts',
        'NfsExportRwHosts' => 'NfsExportRwHosts',
        'NfsSecurityFlavors' => 'NfsSecurityFlavors',
    }
);

} # end BLOCK




package MyTypes::NfsExportRules::_AnonymousAccessUser;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::NfsExportRules

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NfsExportRules from the namespace http://www.netapp.com/management/v1.

Specifies the NFS security configuration Options provided by Data ONTAP operating system.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AnonymousAccessUser


=item * DisableSetuid


=item * IsReadonlyForAllHosts


=item * IsReadwriteForAllHosts


=item * NfsExportRoHosts


=item * NfsExportRootHosts


=item * NfsExportRwHosts


=item * NfsSecurityFlavors




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NfsExportRules
   AnonymousAccessUser => $some_value, # atomic
   DisableSetuid =>  $some_value, # boolean
   IsReadonlyForAllHosts =>  $some_value, # boolean
   IsReadwriteForAllHosts =>  $some_value, # boolean
   NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
     NfsExportHost =>  { # MyTypes::NfsExportHost
       Hostname =>  $some_value, # string
       IsAnException =>  $some_value, # boolean
     },
   },
   NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
     NfsExportHost =>  { # MyTypes::NfsExportHost
       Hostname =>  $some_value, # string
       IsAnException =>  $some_value, # boolean
     },
   },
   NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
     NfsExportHost =>  { # MyTypes::NfsExportHost
       Hostname =>  $some_value, # string
       IsAnException =>  $some_value, # boolean
     },
   },
   NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
     NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

