package MyTypes::NfsOpStats;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %OtherOperations_of :ATTR(:get<OtherOperations>);
my %ReadOperations_of :ATTR(:get<ReadOperations>);
my %WriteOperations_of :ATTR(:get<WriteOperations>);

__PACKAGE__->_factory(
    [ qw(        OtherOperations
        ReadOperations
        WriteOperations

    ) ],
    {
        'OtherOperations' => \%OtherOperations_of,
        'ReadOperations' => \%ReadOperations_of,
        'WriteOperations' => \%WriteOperations_of,
    },
    {

        'OtherOperations' => 'MyTypes::NfsOpStats::_OtherOperations',

        'ReadOperations' => 'MyTypes::NfsOpStats::_ReadOperations',

        'WriteOperations' => 'MyTypes::NfsOpStats::_WriteOperations',
    },
    {

        'OtherOperations' => 'OtherOperations',
        'ReadOperations' => 'ReadOperations',
        'WriteOperations' => 'WriteOperations',
    }
);

} # end BLOCK




package MyTypes::NfsOpStats::_OtherOperations;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NfsOpStats::_ReadOperations;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::NfsOpStats::_WriteOperations;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::NfsOpStats

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
NfsOpStats from the namespace http://www.netapp.com/management/v1.

Contains the NFS operations performed by the client on the storage system.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * OtherOperations


=item * ReadOperations


=item * WriteOperations




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::NfsOpStats
   OtherOperations => $some_value, # atomic
   ReadOperations => $some_value, # atomic
   WriteOperations => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

