package MyTypes::ObjFullName;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
ObjFullName from the namespace http://www.netapp.com/management/v1.

Full Name of a DFM object. This typedef is an alias for the builtin ZAPI Type <b>string</b>. An object full Name conforms To all the rules of an ObjName, except that the full Name may be up To 255 characters long. <P> DFM creates full names by concatenating an object Name with any parent object names, so as To create a unique Name for an object. The format of full names is as follows: <ul> <li> <B>Host</B> full names are the either the fully-qualified domain Name or the IP Address of the Host. <li> <B>Aggregate</B> full names are the Host Name and the Aggregate Name, separated by a colon, e.g. <I>Hostname:aggr0</I>. <li> <B>Volume</B> full names are the Host Name and the Volume Name, separated by ":/", e.g. <I>Hostname:/volume</I>. Note this does not include "/vol". Volume and Aggregate full names are distinguished by the presence of a forward slash after the colon. <li> <B>Qtree</B> full names are the containing Volume full Name and the Qtree Name, separated by a slash, e.g. <I>Hostname:/volume/qtree</I>. The data not contained by any Qtree may be represented by "-", e.g. <I>Hostname:/volume/-</I>. <li> <B>Lun Path</B> full names are either a Volume or Qtree full Name and the LUN Path, separated by a slash, e.g. <I>Hostname:/volume/LUN</I> or <I>Hostname:/volume/qtree/LUN</I>. <li> <B>Network</B> full names are a network Address block in CIDR format, e.g. <I>1.2.3.0/8</I>. <li> <B>OSSV Directory</B> full names are the OSSV Host Name and the OSSV Path, separated by a colon, e.g. <I>host-lnx:/usr/local</I> or <I>host-w2k:c:/temp</I> <li> <I>Include any others here...</I> <li> <B>Initiator Group</B> full names are Host Name and the initiator Group Name, separated by a colon, e.g. <I>Hostname:igroup</I>. </ul> <P> For any DFM object not listed above, the ObjName and ObjFullName are identical.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

