package MyTypes::ObjId;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
ObjId from the namespace http://www.netapp.com/management/v1.

Identification number (ID) for a DFM object. This typedef is an alias for the builtin ZAPI Type <b>integer</b>. Object IDs are unsigned integers in the range [1..2^31 - 1]. In some contexts, an object ID is also allowed To be 0, which is interpreted as a null Value, e.g., a reference To no object at all. <p> The ID for a DFM object is always assigned by the system; the user is never allowed To assign an ID To an object. Therefore, an input element of Type <b>ObjId</b> is always used To refer To an existing object by its ID. The ZAPI must specify the object's DFM object Type (e.g. Dataset, Host, DP Policy, etc.). Some ZAPIs allow the object To be one of several different types. <p> If the Value of an <b>ObjId</b> input element does not Match the ID of any existing DFM object of the specified Type or types, then typically the ZAPI fails with Error code <b>EOBJECTNOTFOUND</b>. A ZAPI may deviate From this general rule, for example, it may return a more specific Error code. In either case, the ZAPI specification must document its behavior.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::integer
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

