package MyTypes::ObjStatus;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
ObjStatus from the namespace http://www.netapp.com/management/v1.

A Status Value which can be associated with a DFM object. This typedef is an alias for the builtin ZAPI Type <b>string</b>. The Severity associated with an event has this Type.<p> Possible Values are: 'unknown', 'normal', 'information', 'unmanaged' 'warning', 'Error', 'critical', 'emergency'. <ul> <li>unknown: An object has an unknown Status when it transitions From one state To another. Ideally, an object will have this Status briefly. For example, when an object has been added, but not yet discovered. <li>normal: An object has normal Status when it is working within the Thresholds specified in DFM. <li>information: The information Events are normal occurrences on an object for which you can define alarms. <li>unmanaged: An object is considered To be unmanaged when the login and Password are not set for the storage system or agent. <li>warning: An object has the warning Status when an event related To the object occurred that an administrator should know about. The event will not cause Service disruption. <li>Error: An object has Error Status when it does not cause any Service disruption, but it may affect performance. <li>critical: An object has critical Status when it is still performing, but Service disruption may occur if corrective Action is not taken immediately. <li>emergency: An object is in emergency Status when it stops performing unexpectedly and could lose data. </ul> In some contexts, it is important that severities are ordered (as above). For example, an alarm might be triggered if an event with a given Severity "or worse" occurs. In this example, worse means "after" in the list above.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

