package MyTypes::ObjStatusInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %ObjectPerfStatus_of :ATTR(:get<ObjectPerfStatus>);
my %ObjectStatus_of :ATTR(:get<ObjectStatus>);

__PACKAGE__->_factory(
    [ qw(        ObjectNameOrId
        ObjectPerfStatus
        ObjectStatus

    ) ],
    {
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'ObjectPerfStatus' => \%ObjectPerfStatus_of,
        'ObjectStatus' => \%ObjectStatus_of,
    },
    {
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'ObjectPerfStatus' => 'MyTypes::ObjStatus',
        'ObjectStatus' => 'MyTypes::ObjStatus',
    },
    {

        'ObjectNameOrId' => 'ObjectNameOrId',
        'ObjectPerfStatus' => 'ObjectPerfStatus',
        'ObjectStatus' => 'ObjectStatus',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ObjStatusInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ObjStatusInfo from the namespace http://www.netapp.com/management/v1.

Status of the dfm object




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ObjectNameOrId


=item * ObjectPerfStatus


=item * ObjectStatus




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ObjStatusInfo
   ObjectNameOrId => $some_value, # ObjNameOrId
   ObjectPerfStatus => $some_value, # ObjStatus
   ObjectStatus => $some_value, # ObjStatus
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

