package MyTypes::OperationDocumentation;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Description_of :ATTR(:get<Description>);
my %Category_of :ATTR(:get<Category>);
my %Status_of :ATTR(:get<Status>);
my %OperationErrors_of :ATTR(:get<OperationErrors>);

__PACKAGE__->_factory(
    [ qw(        Description
        Category
        Status
        OperationErrors

    ) ],
    {
        'Description' => \%Description_of,
        'Category' => \%Category_of,
        'Status' => \%Status_of,
        'OperationErrors' => \%OperationErrors_of,
    },
    {
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Category' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Status' => 'MyTypes::OperationStatus',
        'OperationErrors' => 'MyTypes::ArrayOfOperationError',
    },
    {

        'Description' => 'Description',
        'Category' => 'Category',
        'Status' => 'Status',
        'OperationErrors' => 'OperationErrors',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::OperationDocumentation

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
OperationDocumentation from the namespace http://www.netapp.com/management/v1.

The OperationDocumentation type is used to document operations.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Description


=item * Category


=item * Status


=item * OperationErrors




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::OperationDocumentation
   Description =>  $some_value, # string
   Category =>  $some_value, # string
   Status => $some_value, # OperationStatus
   OperationErrors =>  { # MyTypes::ArrayOfOperationError
     OperationError =>  { # MyTypes::OperationError
       Code =>  $some_value, # unsignedInt
       Name =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

