package MyTypes::OperationError;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Code_of :ATTR(:get<Code>);
my %Name_of :ATTR(:get<Name>);

__PACKAGE__->_factory(
    [ qw(        Code
        Name

    ) ],
    {
        'Code' => \%Code_of,
        'Name' => \%Name_of,
    },
    {
        'Code' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Code' => 'Code',
        'Name' => 'Name',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::OperationError

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
OperationError from the namespace http://www.netapp.com/management/v1.

OperationError is returned as part of FaultDetail, and used for documenting possible errors returned from an operation




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Code


=item * Name




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::OperationError
   Code =>  $some_value, # unsignedInt
   Name =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

