package MyTypes::OssvApplicationInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CanBackup_of :ATTR(:get<CanBackup>);
my %IsLeaf_of :ATTR(:get<IsLeaf>);
my %Name_of :ATTR(:get<Name>);
my %Path_of :ATTR(:get<Path>);
my %UniqueId_of :ATTR(:get<UniqueId>);

__PACKAGE__->_factory(
    [ qw(        CanBackup
        IsLeaf
        Name
        Path
        UniqueId

    ) ],
    {
        'CanBackup' => \%CanBackup_of,
        'IsLeaf' => \%IsLeaf_of,
        'Name' => \%Name_of,
        'Path' => \%Path_of,
        'UniqueId' => \%UniqueId_of,
    },
    {
        'CanBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsLeaf' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CanBackup' => 'CanBackup',
        'IsLeaf' => 'IsLeaf',
        'Name' => 'Name',
        'Path' => 'Path',
        'UniqueId' => 'UniqueId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::OssvApplicationInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
OssvApplicationInfo from the namespace http://www.netapp.com/management/v1.

Application related information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CanBackup


=item * IsLeaf


=item * Name


=item * Path


=item * UniqueId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::OssvApplicationInfo
   CanBackup =>  $some_value, # boolean
   IsLeaf =>  $some_value, # boolean
   Name =>  $some_value, # string
   Path =>  $some_value, # string
   UniqueId =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

