package MyTypes::OverwriteResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DestHost_of :ATTR(:get<DestHost>);
my %FilePath_of :ATTR(:get<FilePath>);
my %OverwriteStatus_of :ATTR(:get<OverwriteStatus>);

__PACKAGE__->_factory(
    [ qw(        DestHost
        FilePath
        OverwriteStatus

    ) ],
    {
        'DestHost' => \%DestHost_of,
        'FilePath' => \%FilePath_of,
        'OverwriteStatus' => \%OverwriteStatus_of,
    },
    {
        'DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'FilePath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OverwriteStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DestHost' => 'DestHost',
        'FilePath' => 'FilePath',
        'OverwriteStatus' => 'OverwriteStatus',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::OverwriteResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
OverwriteResult from the namespace http://www.netapp.com/management/v1.

Information about the member and the destination.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DestHost


=item * FilePath


=item * OverwriteStatus




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::OverwriteResult
   DestHost =>  $some_value, # string
   FilePath =>  $some_value, # string
   OverwriteStatus =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

