package MyTypes::PerfCounter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BaseCounter_of :ATTR(:get<BaseCounter>);
my %Desc_of :ATTR(:get<Desc>);
my %IsDisplay_of :ATTR(:get<IsDisplay>);
my %Labels_of :ATTR(:get<Labels>);
my %Name_of :ATTR(:get<Name>);
my %PrivilegeLevel_of :ATTR(:get<PrivilegeLevel>);
my %Properties_of :ATTR(:get<Properties>);
my %Type_of :ATTR(:get<Type>);
my %Unit_of :ATTR(:get<Unit>);

__PACKAGE__->_factory(
    [ qw(        BaseCounter
        Desc
        IsDisplay
        Labels
        Name
        PrivilegeLevel
        Properties
        Type
        Unit

    ) ],
    {
        'BaseCounter' => \%BaseCounter_of,
        'Desc' => \%Desc_of,
        'IsDisplay' => \%IsDisplay_of,
        'Labels' => \%Labels_of,
        'Name' => \%Name_of,
        'PrivilegeLevel' => \%PrivilegeLevel_of,
        'Properties' => \%Properties_of,
        'Type' => \%Type_of,
        'Unit' => \%Unit_of,
    },
    {
        'BaseCounter' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Desc' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDisplay' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Labels' => 'MyTypes::ArrayOfPerfLabel',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrivilegeLevel' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Properties' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'BaseCounter' => 'BaseCounter',
        'Desc' => 'Desc',
        'IsDisplay' => 'IsDisplay',
        'Labels' => 'Labels',
        'Name' => 'Name',
        'PrivilegeLevel' => 'PrivilegeLevel',
        'Properties' => 'Properties',
        'Type' => 'Type',
        'Unit' => 'Unit',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfCounter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfCounter from the namespace http://www.netapp.com/management/v1.

Describes a performance counter (a measurable quantity on a performance object). This might be, for example, the number of writes per second on a specific Volume.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BaseCounter


=item * Desc


=item * IsDisplay


=item * Labels


=item * Name


=item * PrivilegeLevel


=item * Properties


=item * Type


=item * Unit




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfCounter
   BaseCounter =>  $some_value, # string
   Desc =>  $some_value, # string
   IsDisplay =>  $some_value, # boolean
   Labels =>  { # MyTypes::ArrayOfPerfLabel
     PerfLabel =>  { # MyTypes::PerfLabel
       LabelNames =>  $some_value, # string
     },
   },
   Name =>  $some_value, # string
   PrivilegeLevel =>  $some_value, # string
   Properties =>  $some_value, # string
   Type =>  $some_value, # string
   Unit =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

