package MyTypes::PerfCounterData;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterData_of :ATTR(:get<CounterData>);
my %CounterName_of :ATTR(:get<CounterName>);
my %LabelNames_of :ATTR(:get<LabelNames>);
my %Metrics_of :ATTR(:get<Metrics>);
my %ObjectType_of :ATTR(:get<ObjectType>);
my %Unit_of :ATTR(:get<Unit>);

__PACKAGE__->_factory(
    [ qw(        CounterData
        CounterName
        LabelNames
        Metrics
        ObjectType
        Unit

    ) ],
    {
        'CounterData' => \%CounterData_of,
        'CounterName' => \%CounterName_of,
        'LabelNames' => \%LabelNames_of,
        'Metrics' => \%Metrics_of,
        'ObjectType' => \%ObjectType_of,
        'Unit' => \%Unit_of,
    },
    {
        'CounterData' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Metrics' => 'MyTypes::ArrayOfMetric',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CounterData' => 'CounterData',
        'CounterName' => 'CounterName',
        'LabelNames' => 'LabelNames',
        'Metrics' => 'Metrics',
        'ObjectType' => 'ObjectType',
        'Unit' => 'Unit',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfCounterData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfCounterData from the namespace http://www.netapp.com/management/v1.

Value of the performance counter.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterData


=item * CounterName


=item * LabelNames


=item * Metrics


=item * ObjectType


=item * Unit




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfCounterData
   CounterData =>  $some_value, # string
   CounterName =>  $some_value, # string
   LabelNames =>  $some_value, # string
   Metrics =>  { # MyTypes::ArrayOfMetric
     Metric =>  { # MyTypes::Metric
       Id =>  $some_value, # string
       MetricResult =>  $some_value, # string
       Period => $some_value, # atomic
       Slide =>  $some_value, # string
       Type =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   ObjectType =>  $some_value, # string
   Unit =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

