package MyTypes::PerfCounterGroup;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %CounterInfo_of :ATTR(:get<CounterInfo>);
my %DataSources_of :ATTR(:get<DataSources>);
my %DataSourcesToBeDisabled_of :ATTR(:get<DataSourcesToBeDisabled>);
my %EndTime_of :ATTR(:get<EndTime>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %IsDefault_of :ATTR(:get<IsDefault>);
my %IsDisableAll_of :ATTR(:get<IsDisableAll>);
my %IsStopped_of :ATTR(:get<IsStopped>);
my %NumberRecords_of :ATTR(:get<NumberRecords>);
my %PerfFileName_of :ATTR(:get<PerfFileName>);
my %RealTime_of :ATTR(:get<RealTime>);
my %SampleBuffer_of :ATTR(:get<SampleBuffer>);
my %SampleRate_of :ATTR(:get<SampleRate>);
my %SpaceConsumed_of :ATTR(:get<SpaceConsumed>);
my %SpaceProjected_of :ATTR(:get<SpaceProjected>);
my %StartTime_of :ATTR(:get<StartTime>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        CounterGroupName
        CounterInfo
        DataSources
        DataSourcesToBeDisabled
        EndTime
        GroupNameOrId
        IsDefault
        IsDisableAll
        IsStopped
        NumberRecords
        PerfFileName
        RealTime
        SampleBuffer
        SampleRate
        SpaceConsumed
        SpaceProjected
        StartTime

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'CounterInfo' => \%CounterInfo_of,
        'DataSources' => \%DataSources_of,
        'DataSourcesToBeDisabled' => \%DataSourcesToBeDisabled_of,
        'EndTime' => \%EndTime_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'IsDefault' => \%IsDefault_of,
        'IsDisableAll' => \%IsDisableAll_of,
        'IsStopped' => \%IsStopped_of,
        'NumberRecords' => \%NumberRecords_of,
        'PerfFileName' => \%PerfFileName_of,
        'RealTime' => \%RealTime_of,
        'SampleBuffer' => \%SampleBuffer_of,
        'SampleRate' => \%SampleRate_of,
        'SpaceConsumed' => \%SpaceConsumed_of,
        'SpaceProjected' => \%SpaceProjected_of,
        'StartTime' => \%StartTime_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
        'DataSources' => 'MyTypes::ArrayOfPerfDataSource',
        'DataSourcesToBeDisabled' => 'MyTypes::ArrayOfPerfDataSource',
        'EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDisableAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NumberRecords' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'PerfFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'CounterGroupName' => 'CounterGroupName',
        'CounterInfo' => 'CounterInfo',
        'DataSources' => 'DataSources',
        'DataSourcesToBeDisabled' => 'DataSourcesToBeDisabled',
        'EndTime' => 'EndTime',
        'GroupNameOrId' => 'GroupNameOrId',
        'IsDefault' => 'IsDefault',
        'IsDisableAll' => 'IsDisableAll',
        'IsStopped' => 'IsStopped',
        'NumberRecords' => 'NumberRecords',
        'PerfFileName' => 'PerfFileName',
        'RealTime' => 'RealTime',
        'SampleBuffer' => 'SampleBuffer',
        'SampleRate' => 'SampleRate',
        'SpaceConsumed' => 'SpaceConsumed',
        'SpaceProjected' => 'SpaceProjected',
        'StartTime' => 'StartTime',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfCounterGroup

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfCounterGroup from the namespace http://www.netapp.com/management/v1.

A counter Group. A counter Group is a collection of measurable data sources coupled with an associated sampling rate and sample History.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId


=item * CounterGroupName


=item * CounterInfo


=item * DataSources


=item * DataSourcesToBeDisabled


=item * EndTime


=item * GroupNameOrId


=item * IsDefault


=item * IsDisableAll


=item * IsStopped


=item * NumberRecords


=item * PerfFileName


=item * RealTime


=item * SampleBuffer


=item * SampleRate


=item * SpaceConsumed


=item * SpaceProjected


=item * StartTime




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfCounterGroup
   ApplianceNameOrId =>  $some_value, # string
   CounterGroupName =>  $some_value, # string
   CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
     PerfDataSource =>  { # MyTypes::PerfDataSource
       ApplianceNameOrId =>  $some_value, # string
       CounterName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       InstanceName =>  $some_value, # string
       LabelNames =>  $some_value, # string
       ObjectFullName => $some_value, # ObjFullName
       ObjectName =>  $some_value, # string
       ObjectNameOrId => $some_value, # ObjNameOrId
       ObjectType =>  $some_value, # string
     },
   },
   DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
     PerfDataSource =>  { # MyTypes::PerfDataSource
       ApplianceNameOrId =>  $some_value, # string
       CounterName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       InstanceName =>  $some_value, # string
       LabelNames =>  $some_value, # string
       ObjectFullName => $some_value, # ObjFullName
       ObjectName =>  $some_value, # string
       ObjectNameOrId => $some_value, # ObjNameOrId
       ObjectType =>  $some_value, # string
     },
   },
   EndTime =>  $some_value, # integer
   GroupNameOrId =>  $some_value, # string
   IsDefault =>  $some_value, # boolean
   IsDisableAll =>  $some_value, # boolean
   IsStopped =>  $some_value, # boolean
   NumberRecords =>  $some_value, # integer
   PerfFileName =>  $some_value, # string
   RealTime =>  $some_value, # boolean
   SampleBuffer =>  $some_value, # integer
   SampleRate =>  $some_value, # integer
   SpaceConsumed =>  $some_value, # unsignedLong
   SpaceProjected =>  $some_value, # unsignedLong
   StartTime =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

