package MyTypes::PerfDataGroup;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DataGroupMethod_of :ATTR(:get<DataGroupMethod>);
my %DataSources_of :ATTR(:get<DataSources>);

__PACKAGE__->_factory(
    [ qw(        DataGroupMethod
        DataSources

    ) ],
    {
        'DataGroupMethod' => \%DataGroupMethod_of,
        'DataSources' => \%DataSources_of,
    },
    {
        'DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DataSources' => 'MyTypes::ArrayOfPerfDataSource',
    },
    {

        'DataGroupMethod' => 'DataGroupMethod',
        'DataSources' => 'DataSources',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfDataGroup

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfDataGroup from the namespace http://www.netapp.com/management/v1.

Definition of a set of data sources and a consolidation method.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DataGroupMethod


=item * DataSources




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfDataGroup
   DataGroupMethod =>  $some_value, # string
   DataSources =>  { # MyTypes::ArrayOfPerfDataSource
     PerfDataSource =>  { # MyTypes::PerfDataSource
       ApplianceNameOrId =>  $some_value, # string
       CounterName =>  $some_value, # string
       GroupNameOrId =>  $some_value, # string
       InstanceName =>  $some_value, # string
       LabelNames =>  $some_value, # string
       ObjectFullName => $some_value, # ObjFullName
       ObjectName =>  $some_value, # string
       ObjectNameOrId => $some_value, # ObjNameOrId
       ObjectType =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

