package MyTypes::PerfDataSource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %CounterName_of :ATTR(:get<CounterName>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %InstanceName_of :ATTR(:get<InstanceName>);
my %LabelNames_of :ATTR(:get<LabelNames>);
my %ObjectFullName_of :ATTR(:get<ObjectFullName>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %ObjectType_of :ATTR(:get<ObjectType>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        CounterName
        GroupNameOrId
        InstanceName
        LabelNames
        ObjectFullName
        ObjectName
        ObjectNameOrId
        ObjectType

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'CounterName' => \%CounterName_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'InstanceName' => \%InstanceName_of,
        'LabelNames' => \%LabelNames_of,
        'ObjectFullName' => \%ObjectFullName_of,
        'ObjectName' => \%ObjectName_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'ObjectType' => \%ObjectType_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectFullName' => 'MyTypes::ObjFullName',
        'ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'CounterName' => 'CounterName',
        'GroupNameOrId' => 'GroupNameOrId',
        'InstanceName' => 'InstanceName',
        'LabelNames' => 'LabelNames',
        'ObjectFullName' => 'ObjectFullName',
        'ObjectName' => 'ObjectName',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'ObjectType' => 'ObjectType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfDataSource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfDataSource from the namespace http://www.netapp.com/management/v1.

An unique identifier for a Source of data. When optional InstanceName field is not specified, PerfDataSource represents all relevant Instances in a storage system or in a Group.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId


=item * CounterName


=item * GroupNameOrId


=item * InstanceName


=item * LabelNames


=item * ObjectFullName


=item * ObjectName


=item * ObjectNameOrId


=item * ObjectType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfDataSource
   ApplianceNameOrId =>  $some_value, # string
   CounterName =>  $some_value, # string
   GroupNameOrId =>  $some_value, # string
   InstanceName =>  $some_value, # string
   LabelNames =>  $some_value, # string
   ObjectFullName => $some_value, # ObjFullName
   ObjectName =>  $some_value, # string
   ObjectNameOrId => $some_value, # ObjNameOrId
   ObjectType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

