package MyTypes::PerfDependentCounterInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterName_of :ATTR(:get<CounterName>);
my %ObjectCounters_of :ATTR(:get<ObjectCounters>);

__PACKAGE__->_factory(
    [ qw(        CounterName
        ObjectCounters

    ) ],
    {
        'CounterName' => \%CounterName_of,
        'ObjectCounters' => \%ObjectCounters_of,
    },
    {
        'CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
    },
    {

        'CounterName' => 'CounterName',
        'ObjectCounters' => 'ObjectCounters',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfDependentCounterInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfDependentCounterInfo from the namespace http://www.netapp.com/management/v1.

Describes a performance counter and its dependent Counters list, for example system:load_inbound_mbps is dependent on system:net_data_recv, fcp:fcp_write_data, iscsi:iscsi_write_data Counters.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterName


=item * ObjectCounters




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfDependentCounterInfo
   CounterName =>  $some_value, # string
   ObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

