package MyTypes::PerfDiagCategory;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CategoryName_of :ATTR(:get<CategoryName>);
my %CategoryStatus_of :ATTR(:get<CategoryStatus>);
my %HealthChecks_of :ATTR(:get<HealthChecks>);

__PACKAGE__->_factory(
    [ qw(        CategoryName
        CategoryStatus
        HealthChecks

    ) ],
    {
        'CategoryName' => \%CategoryName_of,
        'CategoryStatus' => \%CategoryStatus_of,
        'HealthChecks' => \%HealthChecks_of,
    },
    {
        'CategoryName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CategoryStatus' => 'MyTypes::ObjStatus',
        'HealthChecks' => 'MyTypes::ArrayOfPerfHealthCheck',
    },
    {

        'CategoryName' => 'CategoryName',
        'CategoryStatus' => 'CategoryStatus',
        'HealthChecks' => 'HealthChecks',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfDiagCategory

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfDiagCategory from the namespace http://www.netapp.com/management/v1.

Diagnosis Category.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CategoryName


=item * CategoryStatus


=item * HealthChecks




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfDiagCategory
   CategoryName =>  $some_value, # string
   CategoryStatus => $some_value, # ObjStatus
   HealthChecks =>  { # MyTypes::ArrayOfPerfHealthCheck
     PerfHealthCheck =>  { # MyTypes::PerfHealthCheck
       HealthCheckName =>  $some_value, # string
       HealthCheckStatus => $some_value, # ObjStatus
       Observation =>  $some_value, # string
       Recommendation =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

