package MyTypes::PerfHealthCheck;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HealthCheckName_of :ATTR(:get<HealthCheckName>);
my %HealthCheckStatus_of :ATTR(:get<HealthCheckStatus>);
my %Observation_of :ATTR(:get<Observation>);
my %Recommendation_of :ATTR(:get<Recommendation>);

__PACKAGE__->_factory(
    [ qw(        HealthCheckName
        HealthCheckStatus
        Observation
        Recommendation

    ) ],
    {
        'HealthCheckName' => \%HealthCheckName_of,
        'HealthCheckStatus' => \%HealthCheckStatus_of,
        'Observation' => \%Observation_of,
        'Recommendation' => \%Recommendation_of,
    },
    {
        'HealthCheckName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HealthCheckStatus' => 'MyTypes::ObjStatus',
        'Observation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Recommendation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'HealthCheckName' => 'HealthCheckName',
        'HealthCheckStatus' => 'HealthCheckStatus',
        'Observation' => 'Observation',
        'Recommendation' => 'Recommendation',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfHealthCheck

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfHealthCheck from the namespace http://www.netapp.com/management/v1.

A check which if violated could affect the performance of the given object.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HealthCheckName


=item * HealthCheckStatus


=item * Observation


=item * Recommendation




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfHealthCheck
   HealthCheckName =>  $some_value, # string
   HealthCheckStatus => $some_value, # ObjStatus
   Observation =>  $some_value, # string
   Recommendation =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

