package MyTypes::PerfInstance;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %InstanceName_of :ATTR(:get<InstanceName>);

__PACKAGE__->_factory(
    [ qw(        InstanceName

    ) ],
    {
        'InstanceName' => \%InstanceName_of,
    },
    {
        'InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'InstanceName' => 'InstanceName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfInstance

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfInstance from the namespace http://www.netapp.com/management/v1.

Describes an Instance. An Instance is a manifestation of a performance object. For example, the performance object might be "VOLUME" whereas the Instance might be "vol0".




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * InstanceName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfInstance
   InstanceName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

