package MyTypes::PerfInstanceCounterData;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Counters_of :ATTR(:get<Counters>);
my %InstanceName_of :ATTR(:get<InstanceName>);
my %ObjectId_of :ATTR(:get<ObjectId>);

__PACKAGE__->_factory(
    [ qw(        Counters
        InstanceName
        ObjectId

    ) ],
    {
        'Counters' => \%Counters_of,
        'InstanceName' => \%InstanceName_of,
        'ObjectId' => \%ObjectId_of,
    },
    {
        'Counters' => 'MyTypes::ArrayOfPerfCounterData',
        'InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectId' => 'MyTypes::ObjId',
    },
    {

        'Counters' => 'Counters',
        'InstanceName' => 'InstanceName',
        'ObjectId' => 'ObjectId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfInstanceCounterData

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfInstanceCounterData from the namespace http://www.netapp.com/management/v1.

Array of counter Values of an Instance.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Counters


=item * InstanceName


=item * ObjectId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfInstanceCounterData
   Counters =>  { # MyTypes::ArrayOfPerfCounterData
     PerfCounterData =>  { # MyTypes::PerfCounterData
       CounterData =>  $some_value, # string
       CounterName =>  $some_value, # string
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       Unit =>  $some_value, # string
     },
   },
   InstanceName =>  $some_value, # string
   ObjectId => $some_value, # ObjId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

