package MyTypes::PerfLabel;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %LabelNames_of :ATTR(:get<LabelNames>);

__PACKAGE__->_factory(
    [ qw(        LabelNames

    ) ],
    {
        'LabelNames' => \%LabelNames_of,
    },
    {
        'LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'LabelNames' => 'LabelNames',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfLabel

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfLabel from the namespace http://www.netapp.com/management/v1.

When a counter has more than one Value (an array), the Labels describe the indvidual array entries, and define an implicit indexing scheme into the array. The array may be multi-dimensional, in which case each occurrence of a PerfLabel represents a dimension in the array of Labels.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * LabelNames




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfLabel
   LabelNames =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

