package MyTypes::PerfLine;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Color_of :ATTR(:get<Color>);
my %DataGroup_of :ATTR(:get<DataGroup>);
my %LineName_of :ATTR(:get<LineName>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        Color
        DataGroup
        LineName
        Type

    ) ],
    {
        'Color' => \%Color_of,
        'DataGroup' => \%DataGroup_of,
        'LineName' => \%LineName_of,
        'Type' => \%Type_of,
    },
    {
        'Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
        'LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Color' => 'Color',
        'DataGroup' => 'DataGroup',
        'LineName' => 'LineName',
        'Type' => 'Type',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfLine

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfLine from the namespace http://www.netapp.com/management/v1.

A line of data on the chart. Often a line will have a single data Source (e.g. CPU percent busy), but we allow for the Capability for many sources To be combined (e.g. average CPU busy over 10 storage systems).




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Color


=item * DataGroup


=item * LineName


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfLine
   Color =>  $some_value, # string
   DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
     PerfDataGroup =>  { # MyTypes::PerfDataGroup
       DataGroupMethod =>  $some_value, # string
       DataSources =>  { # MyTypes::ArrayOfPerfDataSource
         PerfDataSource =>  { # MyTypes::PerfDataSource
           ApplianceNameOrId =>  $some_value, # string
           CounterName =>  $some_value, # string
           GroupNameOrId =>  $some_value, # string
           InstanceName =>  $some_value, # string
           LabelNames =>  $some_value, # string
           ObjectFullName => $some_value, # ObjFullName
           ObjectName =>  $some_value, # string
           ObjectNameOrId => $some_value, # ObjNameOrId
           ObjectType =>  $some_value, # string
         },
       },
     },
   },
   LineName =>  $some_value, # string
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

