package MyTypes::PerfMissingHostObjectCounter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostNameOrId_of :ATTR(:get<HostNameOrId>);
my %MissingObjectCounters_of :ATTR(:get<MissingObjectCounters>);

__PACKAGE__->_factory(
    [ qw(        HostNameOrId
        MissingObjectCounters

    ) ],
    {
        'HostNameOrId' => \%HostNameOrId_of,
        'MissingObjectCounters' => \%MissingObjectCounters_of,
    },
    {
        'HostNameOrId' => 'MyTypes::HostNameOrId',
        'MissingObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
    },
    {

        'HostNameOrId' => 'HostNameOrId',
        'MissingObjectCounters' => 'MissingObjectCounters',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfMissingHostObjectCounter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfMissingHostObjectCounter from the namespace http://www.netapp.com/management/v1.

Counters not available with a particular Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostNameOrId


=item * MissingObjectCounters




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfMissingHostObjectCounter
   HostNameOrId => $some_value, # HostNameOrId
   MissingObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

