package MyTypes::PerfObject;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AssocObjType_of :ATTR(:get<AssocObjType>);
my %ObjectName_of :ATTR(:get<ObjectName>);

__PACKAGE__->_factory(
    [ qw(        AssocObjType
        ObjectName

    ) ],
    {
        'AssocObjType' => \%AssocObjType_of,
        'ObjectName' => \%ObjectName_of,
    },
    {
        'AssocObjType' => 'MyTypes::PerfAssocObjType',
        'ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AssocObjType' => 'AssocObjType',
        'ObjectName' => 'ObjectName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfObject

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfObject from the namespace http://www.netapp.com/management/v1.

A performance object. A performance object is a (somewhat abstract) representation of a class of measurable items. These are roughly akin To system subcomponents or protocols, for example "VOLUME", "DISK" or "NFS". These are broad classes and do not represent specific Instances.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AssocObjType


=item * ObjectName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfObject
   AssocObjType => $some_value, # PerfAssocObjType
   ObjectName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

