package MyTypes::PerfObjectCounter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterDescription_of :ATTR(:get<CounterDescription>);
my %CounterName_of :ATTR(:get<CounterName>);
my %IsCalculatedStats_of :ATTR(:get<IsCalculatedStats>);
my %LabelNames_of :ATTR(:get<LabelNames>);
my %Metrics_of :ATTR(:get<Metrics>);
my %ObjectType_of :ATTR(:get<ObjectType>);
my %PerfLabels_of :ATTR(:get<PerfLabels>);
my %TimeConsolidationMethod_of :ATTR(:get<TimeConsolidationMethod>);

__PACKAGE__->_factory(
    [ qw(        CounterDescription
        CounterName
        IsCalculatedStats
        LabelNames
        Metrics
        ObjectType
        PerfLabels
        TimeConsolidationMethod

    ) ],
    {
        'CounterDescription' => \%CounterDescription_of,
        'CounterName' => \%CounterName_of,
        'IsCalculatedStats' => \%IsCalculatedStats_of,
        'LabelNames' => \%LabelNames_of,
        'Metrics' => \%Metrics_of,
        'ObjectType' => \%ObjectType_of,
        'PerfLabels' => \%PerfLabels_of,
        'TimeConsolidationMethod' => \%TimeConsolidationMethod_of,
    },
    {
        'CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Metrics' => 'MyTypes::ArrayOfMetric',
        'ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
        'TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'CounterDescription' => 'CounterDescription',
        'CounterName' => 'CounterName',
        'IsCalculatedStats' => 'IsCalculatedStats',
        'LabelNames' => 'LabelNames',
        'Metrics' => 'Metrics',
        'ObjectType' => 'ObjectType',
        'PerfLabels' => 'PerfLabels',
        'TimeConsolidationMethod' => 'TimeConsolidationMethod',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfObjectCounter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfObjectCounter from the namespace http://www.netapp.com/management/v1.

Performance Counters can be a combination of an object and a counter.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterDescription


=item * CounterName


=item * IsCalculatedStats


=item * LabelNames


=item * Metrics


=item * ObjectType


=item * PerfLabels


=item * TimeConsolidationMethod




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfObjectCounter
   CounterDescription =>  $some_value, # string
   CounterName =>  $some_value, # string
   IsCalculatedStats =>  $some_value, # boolean
   LabelNames =>  $some_value, # string
   Metrics =>  { # MyTypes::ArrayOfMetric
     Metric =>  { # MyTypes::Metric
       Id =>  $some_value, # string
       MetricResult =>  $some_value, # string
       Period => $some_value, # atomic
       Slide =>  $some_value, # string
       Type =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   ObjectType =>  $some_value, # string
   PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
     PerfLabel =>  { # MyTypes::PerfLabel
       LabelNames =>  $some_value, # string
     },
   },
   TimeConsolidationMethod =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

