package MyTypes::PerfPurgedHostObjectCounter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostNameOrId_of :ATTR(:get<HostNameOrId>);
my %PurgedObjectCountersDetails_of :ATTR(:get<PurgedObjectCountersDetails>);

__PACKAGE__->_factory(
    [ qw(        HostNameOrId
        PurgedObjectCountersDetails

    ) ],
    {
        'HostNameOrId' => \%HostNameOrId_of,
        'PurgedObjectCountersDetails' => \%PurgedObjectCountersDetails_of,
    },
    {
        'HostNameOrId' => 'MyTypes::HostNameOrId',
        'PurgedObjectCountersDetails' => 'MyTypes::ArrayOfPerfPurgedObjectCountersDetails',
    },
    {

        'HostNameOrId' => 'HostNameOrId',
        'PurgedObjectCountersDetails' => 'PurgedObjectCountersDetails',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfPurgedHostObjectCounter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfPurgedHostObjectCounter from the namespace http://www.netapp.com/management/v1.

Lists the effected Counters deatils for a particular Host.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostNameOrId


=item * PurgedObjectCountersDetails




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfPurgedHostObjectCounter
   HostNameOrId => $some_value, # HostNameOrId
   PurgedObjectCountersDetails =>  { # MyTypes::ArrayOfPerfPurgedObjectCountersDetails
     PerfPurgedObjectCountersDetails =>  { # MyTypes::PerfPurgedObjectCountersDetails
       CurrentRetentionPeriod =>  $some_value, # integer
       NewRetentionPeriod =>  $some_value, # integer
       PurgedObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
         PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
           CounterDescription =>  $some_value, # string
           CounterName =>  $some_value, # string
           IsCalculatedStats =>  $some_value, # boolean
           LabelNames =>  $some_value, # string
           Metrics =>  { # MyTypes::ArrayOfMetric
             Metric =>  { # MyTypes::Metric
               Id =>  $some_value, # string
               MetricResult =>  $some_value, # string
               Period => $some_value, # atomic
               Slide =>  $some_value, # string
               Type =>  $some_value, # string
               Value =>  $some_value, # string
             },
           },
           ObjectType =>  $some_value, # string
           PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
             PerfLabel =>  { # MyTypes::PerfLabel
               LabelNames =>  $some_value, # string
             },
           },
           TimeConsolidationMethod =>  $some_value, # string
         },
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

