package MyTypes::PerfPurgedObjectCountersDetails;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CurrentRetentionPeriod_of :ATTR(:get<CurrentRetentionPeriod>);
my %NewRetentionPeriod_of :ATTR(:get<NewRetentionPeriod>);
my %PurgedObjectCounters_of :ATTR(:get<PurgedObjectCounters>);

__PACKAGE__->_factory(
    [ qw(        CurrentRetentionPeriod
        NewRetentionPeriod
        PurgedObjectCounters

    ) ],
    {
        'CurrentRetentionPeriod' => \%CurrentRetentionPeriod_of,
        'NewRetentionPeriod' => \%NewRetentionPeriod_of,
        'PurgedObjectCounters' => \%PurgedObjectCounters_of,
    },
    {
        'CurrentRetentionPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'NewRetentionPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'PurgedObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
    },
    {

        'CurrentRetentionPeriod' => 'CurrentRetentionPeriod',
        'NewRetentionPeriod' => 'NewRetentionPeriod',
        'PurgedObjectCounters' => 'PurgedObjectCounters',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfPurgedObjectCountersDetails

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfPurgedObjectCountersDetails from the namespace http://www.netapp.com/management/v1.

Lists the effected Counters for each object along with Retention Period details.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CurrentRetentionPeriod


=item * NewRetentionPeriod


=item * PurgedObjectCounters




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfPurgedObjectCountersDetails
   CurrentRetentionPeriod =>  $some_value, # integer
   NewRetentionPeriod =>  $some_value, # integer
   PurgedObjectCounters =>  { # MyTypes::ArrayOfPerfObjectCounter
     PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
       CounterDescription =>  $some_value, # string
       CounterName =>  $some_value, # string
       IsCalculatedStats =>  $some_value, # boolean
       LabelNames =>  $some_value, # string
       Metrics =>  { # MyTypes::ArrayOfMetric
         Metric =>  { # MyTypes::Metric
           Id =>  $some_value, # string
           MetricResult =>  $some_value, # string
           Period => $some_value, # atomic
           Slide =>  $some_value, # string
           Type =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       ObjectType =>  $some_value, # string
       PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
         PerfLabel =>  { # MyTypes::PerfLabel
           LabelNames =>  $some_value, # string
         },
       },
       TimeConsolidationMethod =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

