package MyTypes::PerfServerStatus;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DataCollectionStatus_of :ATTR(:get<DataCollectionStatus>);
my %ObjectUpdateStatus_of :ATTR(:get<ObjectUpdateStatus>);
my %ServerStatus_of :ATTR(:get<ServerStatus>);

__PACKAGE__->_factory(
    [ qw(        DataCollectionStatus
        ObjectUpdateStatus
        ServerStatus

    ) ],
    {
        'DataCollectionStatus' => \%DataCollectionStatus_of,
        'ObjectUpdateStatus' => \%ObjectUpdateStatus_of,
        'ServerStatus' => \%ServerStatus_of,
    },
    {
        'DataCollectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ObjectUpdateStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ServerStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DataCollectionStatus' => 'DataCollectionStatus',
        'ObjectUpdateStatus' => 'ObjectUpdateStatus',
        'ServerStatus' => 'ServerStatus',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfServerStatus

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfServerStatus from the namespace http://www.netapp.com/management/v1.

Describes the Status of perf server.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DataCollectionStatus


=item * ObjectUpdateStatus


=item * ServerStatus




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfServerStatus
   DataCollectionStatus =>  $some_value, # string
   ObjectUpdateStatus =>  $some_value, # string
   ServerStatus =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

