package MyTypes::PerfView;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ApplianceNameOrId_of :ATTR(:get<ApplianceNameOrId>);
my %AreEventsShown_of :ATTR(:get<AreEventsShown>);
my %AssocObjType_of :ATTR(:get<AssocObjType>);
my %Charts_of :ATTR(:get<Charts>);
my %CounterGroupName_of :ATTR(:get<CounterGroupName>);
my %GroupNameOrId_of :ATTR(:get<GroupNameOrId>);
my %IsDefault_of :ATTR(:get<IsDefault>);
my %IsStopped_of :ATTR(:get<IsStopped>);
my %SampleBuffer_of :ATTR(:get<SampleBuffer>);
my %SampleRate_of :ATTR(:get<SampleRate>);
my %ViewName_of :ATTR(:get<ViewName>);
my %ViewType_of :ATTR(:get<ViewType>);

__PACKAGE__->_factory(
    [ qw(        ApplianceNameOrId
        AreEventsShown
        AssocObjType
        Charts
        CounterGroupName
        GroupNameOrId
        IsDefault
        IsStopped
        SampleBuffer
        SampleRate
        ViewName
        ViewType

    ) ],
    {
        'ApplianceNameOrId' => \%ApplianceNameOrId_of,
        'AreEventsShown' => \%AreEventsShown_of,
        'AssocObjType' => \%AssocObjType_of,
        'Charts' => \%Charts_of,
        'CounterGroupName' => \%CounterGroupName_of,
        'GroupNameOrId' => \%GroupNameOrId_of,
        'IsDefault' => \%IsDefault_of,
        'IsStopped' => \%IsStopped_of,
        'SampleBuffer' => \%SampleBuffer_of,
        'SampleRate' => \%SampleRate_of,
        'ViewName' => \%ViewName_of,
        'ViewType' => \%ViewType_of,
    },
    {
        'ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
        'Charts' => 'MyTypes::ArrayOfPerfChart',
        'CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ViewType' => 'MyTypes::ViewType',
    },
    {

        'ApplianceNameOrId' => 'ApplianceNameOrId',
        'AreEventsShown' => 'AreEventsShown',
        'AssocObjType' => 'AssocObjType',
        'Charts' => 'Charts',
        'CounterGroupName' => 'CounterGroupName',
        'GroupNameOrId' => 'GroupNameOrId',
        'IsDefault' => 'IsDefault',
        'IsStopped' => 'IsStopped',
        'SampleBuffer' => 'SampleBuffer',
        'SampleRate' => 'SampleRate',
        'ViewName' => 'ViewName',
        'ViewType' => 'ViewType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PerfView

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PerfView from the namespace http://www.netapp.com/management/v1.

A performance View.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ApplianceNameOrId


=item * AreEventsShown


=item * AssocObjType


=item * Charts


=item * CounterGroupName


=item * GroupNameOrId


=item * IsDefault


=item * IsStopped


=item * SampleBuffer


=item * SampleRate


=item * ViewName


=item * ViewType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PerfView
   ApplianceNameOrId =>  $some_value, # string
   AreEventsShown =>  $some_value, # boolean
   AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
     PerfAssocObjType => $some_value, # PerfAssocObjType
   },
   Charts =>  { # MyTypes::ArrayOfPerfChart
     PerfChart =>  { # MyTypes::PerfChart
       ChartName =>  $some_value, # string
       DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
         PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
           Color =>  $some_value, # string
           DataSource =>  { # MyTypes::WrapperOfPerfDataSource
             PerfDataSource =>  { # MyTypes::PerfDataSource
               ApplianceNameOrId =>  $some_value, # string
               CounterName =>  $some_value, # string
               GroupNameOrId =>  $some_value, # string
               InstanceName =>  $some_value, # string
               LabelNames =>  $some_value, # string
               ObjectFullName => $some_value, # ObjFullName
               ObjectName =>  $some_value, # string
               ObjectNameOrId => $some_value, # ObjNameOrId
               ObjectType =>  $some_value, # string
             },
           },
           MaximumInstances =>  $some_value, # integer
           SelectAllInstances =>  $some_value, # boolean
           SortOrder =>  $some_value, # string
           TimeInterval =>  $some_value, # integer
         },
       },
       Lines =>  { # MyTypes::ArrayOfPerfLine
         PerfLine =>  { # MyTypes::PerfLine
           Color =>  $some_value, # string
           DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
             PerfDataGroup =>  { # MyTypes::PerfDataGroup
               DataGroupMethod =>  $some_value, # string
               DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                 PerfDataSource =>  { # MyTypes::PerfDataSource
                   ApplianceNameOrId =>  $some_value, # string
                   CounterName =>  $some_value, # string
                   GroupNameOrId =>  $some_value, # string
                   InstanceName =>  $some_value, # string
                   LabelNames =>  $some_value, # string
                   ObjectFullName => $some_value, # ObjFullName
                   ObjectName =>  $some_value, # string
                   ObjectNameOrId => $some_value, # ObjNameOrId
                   ObjectType =>  $some_value, # string
                 },
               },
             },
           },
           LineName =>  $some_value, # string
           Type =>  $some_value, # string
         },
       },
       MaximumY =>  $some_value, # integer
       Type =>  $some_value, # string
     },
   },
   CounterGroupName =>  $some_value, # string
   GroupNameOrId =>  $some_value, # string
   IsDefault =>  $some_value, # boolean
   IsStopped =>  $some_value, # boolean
   SampleBuffer =>  $some_value, # integer
   SampleRate =>  $some_value, # integer
   ViewName =>  $some_value, # string
   ViewType => $some_value, # ViewType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

