package MyTypes::Plugin;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PluginType_of :ATTR(:get<PluginType>);
my %ProductVersion_of :ATTR(:get<ProductVersion>);
my %SpecialBuild_of :ATTR(:get<SpecialBuild>);

__PACKAGE__->_factory(
    [ qw(        PluginType
        ProductVersion
        SpecialBuild

    ) ],
    {
        'PluginType' => \%PluginType_of,
        'ProductVersion' => \%ProductVersion_of,
        'SpecialBuild' => \%SpecialBuild_of,
    },
    {
        'PluginType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProductVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SpecialBuild' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'PluginType' => 'PluginType',
        'ProductVersion' => 'ProductVersion',
        'SpecialBuild' => 'SpecialBuild',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Plugin

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Plugin from the namespace http://www.netapp.com/management/v1.

Installed plugins.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PluginType


=item * ProductVersion


=item * SpecialBuild




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Plugin
   PluginType =>  $some_value, # string
   ProductVersion =>  $some_value, # string
   SpecialBuild =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

