package MyTypes::PolicyResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PolicyId_of :ATTR(:get<PolicyId>);
my %PolicyName_of :ATTR(:get<PolicyName>);

__PACKAGE__->_factory(
    [ qw(        PolicyId
        PolicyName

    ) ],
    {
        'PolicyId' => \%PolicyId_of,
        'PolicyName' => \%PolicyName_of,
    },
    {
        'PolicyId' => 'MyTypes::ObjId',
        'PolicyName' => 'MyTypes::ObjName',
    },
    {

        'PolicyId' => 'PolicyId',
        'PolicyName' => 'PolicyName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PolicyResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PolicyResource from the namespace http://www.netapp.com/management/v1.

Identifies a Policy Resource. When used as input one or more of PolicyName or PolicyId is specified. When used as output, both of them will be returned. Policy can refer To either a protection Policy, a provisioning Policy or an application Policy.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PolicyId


=item * PolicyName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PolicyResource
   PolicyId => $some_value, # ObjId
   PolicyName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

