package MyTypes::ProgressAggregateInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
    },
    {
        'AggregateId' => 'MyTypes::ObjId',
        'AggregateName' => 'MyTypes::ObjFullName',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressAggregateInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressAggregateInfo from the namespace http://www.netapp.com/management/v1.

Information about the Aggregate




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressAggregateInfo
   AggregateId => $some_value, # ObjId
   AggregateName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

