package MyTypes::ProgressCifsShareInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CifsAclList_of :ATTR(:get<CifsAclList>);
my %CifsShareName_of :ATTR(:get<CifsShareName>);
my %VolOrQtreeId_of :ATTR(:get<VolOrQtreeId>);
my %VolOrQtreeName_of :ATTR(:get<VolOrQtreeName>);

__PACKAGE__->_factory(
    [ qw(        CifsAclList
        CifsShareName
        VolOrQtreeId
        VolOrQtreeName

    ) ],
    {
        'CifsAclList' => \%CifsAclList_of,
        'CifsShareName' => \%CifsShareName_of,
        'VolOrQtreeId' => \%VolOrQtreeId_of,
        'VolOrQtreeName' => \%VolOrQtreeName_of,
    },
    {
        'CifsAclList' => 'MyTypes::ArrayOfCifsAcl',
        'CifsShareName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolOrQtreeId' => 'MyTypes::ObjId',
        'VolOrQtreeName' => 'MyTypes::ObjFullName',
    },
    {

        'CifsAclList' => 'CifsAclList',
        'CifsShareName' => 'CifsShareName',
        'VolOrQtreeId' => 'VolOrQtreeId',
        'VolOrQtreeName' => 'VolOrQtreeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressCifsShareInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressCifsShareInfo from the namespace http://www.netapp.com/management/v1.

Information about the CIFS share created as part of provisioning Operation.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CifsAclList


=item * CifsShareName


=item * VolOrQtreeId


=item * VolOrQtreeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressCifsShareInfo
   CifsAclList =>  { # MyTypes::ArrayOfCifsAcl
     CifsAcl =>  { # MyTypes::CifsAcl
       AccessRights =>  $some_value, # string
       UserName =>  $some_value, # string
     },
   },
   CifsShareName =>  $some_value, # string
   VolOrQtreeId => $some_value, # ObjId
   VolOrQtreeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

