package MyTypes::ProgressHostServiceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %HostServiceName_of :ATTR(:get<HostServiceName>);
my %OperationId_of :ATTR(:get<OperationId>);

__PACKAGE__->_factory(
    [ qw(        HostServiceId
        HostServiceName
        OperationId

    ) ],
    {
        'HostServiceId' => \%HostServiceId_of,
        'HostServiceName' => \%HostServiceName_of,
        'OperationId' => \%OperationId_of,
    },
    {
        'HostServiceId' => 'MyTypes::ObjId',
        'HostServiceName' => 'MyTypes::ObjFullName',
        'OperationId' => 'MyTypes::HostServiceUniqueId',
    },
    {

        'HostServiceId' => 'HostServiceId',
        'HostServiceName' => 'HostServiceName',
        'OperationId' => 'OperationId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressHostServiceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressHostServiceInfo from the namespace http://www.netapp.com/management/v1.

Information about the storage Service.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostServiceId


=item * HostServiceName


=item * OperationId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressHostServiceInfo
   HostServiceId => $some_value, # ObjId
   HostServiceName => $some_value, # ObjFullName
   OperationId => $some_value, # HostServiceUniqueId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

