package MyTypes::ProgressIgroupConfigInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IgroupId_of :ATTR(:get<IgroupId>);
my %IgroupName_of :ATTR(:get<IgroupName>);
my %Initiators_of :ATTR(:get<Initiators>);

__PACKAGE__->_factory(
    [ qw(        IgroupId
        IgroupName
        Initiators

    ) ],
    {
        'IgroupId' => \%IgroupId_of,
        'IgroupName' => \%IgroupName_of,
        'Initiators' => \%Initiators_of,
    },
    {
        'IgroupId' => 'MyTypes::ObjId',
        'IgroupName' => 'MyTypes::ObjFullName',
        'Initiators' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'IgroupId' => 'IgroupId',
        'IgroupName' => 'IgroupName',
        'Initiators' => 'Initiators',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressIgroupConfigInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressIgroupConfigInfo from the namespace http://www.netapp.com/management/v1.

Information about Initiators being added or removed to/from an initiator Group of a job.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IgroupId


=item * IgroupName


=item * Initiators




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressIgroupConfigInfo
   IgroupId => $some_value, # ObjId
   IgroupName => $some_value, # ObjFullName
   Initiators =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

