package MyTypes::ProgressLunMapInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IgroupId_of :ATTR(:get<IgroupId>);
my %IgroupName_of :ATTR(:get<IgroupName>);
my %LunName_of :ATTR(:get<LunName>);
my %LunPathId_of :ATTR(:get<LunPathId>);

__PACKAGE__->_factory(
    [ qw(        IgroupId
        IgroupName
        LunName
        LunPathId

    ) ],
    {
        'IgroupId' => \%IgroupId_of,
        'IgroupName' => \%IgroupName_of,
        'LunName' => \%LunName_of,
        'LunPathId' => \%LunPathId_of,
    },
    {
        'IgroupId' => 'MyTypes::ObjId',
        'IgroupName' => 'MyTypes::ObjFullName',
        'LunName' => 'MyTypes::ObjFullName',
        'LunPathId' => 'MyTypes::ObjId',
    },
    {

        'IgroupId' => 'IgroupId',
        'IgroupName' => 'IgroupName',
        'LunName' => 'LunName',
        'LunPathId' => 'LunPathId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressLunMapInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressLunMapInfo from the namespace http://www.netapp.com/management/v1.

Information about the mapping of a LUN.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IgroupId


=item * IgroupName


=item * LunName


=item * LunPathId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressLunMapInfo
   IgroupId => $some_value, # ObjId
   IgroupName => $some_value, # ObjFullName
   LunName => $some_value, # ObjFullName
   LunPathId => $some_value, # ObjId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

