package MyTypes::ProgressNfsexportInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Path_of :ATTR(:get<Path>);
my %QtreeId_of :ATTR(:get<QtreeId>);
my %QtreeName_of :ATTR(:get<QtreeName>);

__PACKAGE__->_factory(
    [ qw(        Path
        QtreeId
        QtreeName

    ) ],
    {
        'Path' => \%Path_of,
        'QtreeId' => \%QtreeId_of,
        'QtreeName' => \%QtreeName_of,
    },
    {
        'Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'QtreeId' => 'MyTypes::ObjId',
        'QtreeName' => 'MyTypes::ObjFullName',
    },
    {

        'Path' => 'Path',
        'QtreeId' => 'QtreeId',
        'QtreeName' => 'QtreeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressNfsexportInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressNfsexportInfo from the namespace http://www.netapp.com/management/v1.

Information about the NFS export created as part of provisioning Operation.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Path


=item * QtreeId


=item * QtreeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressNfsexportInfo
   Path =>  $some_value, # string
   QtreeId => $some_value, # ObjId
   QtreeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

