package MyTypes::ProgressQtreeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %QtreeId_of :ATTR(:get<QtreeId>);
my %QtreeName_of :ATTR(:get<QtreeName>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        QtreeId
        QtreeName
        VolumeId
        VolumeName

    ) ],
    {
        'QtreeId' => \%QtreeId_of,
        'QtreeName' => \%QtreeName_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'QtreeId' => 'MyTypes::ObjId',
        'QtreeName' => 'MyTypes::ObjFullName',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjFullName',
    },
    {

        'QtreeId' => 'QtreeId',
        'QtreeName' => 'QtreeName',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressQtreeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressQtreeInfo from the namespace http://www.netapp.com/management/v1.

Information about a Qtree which is created or destroyed in the provisioning job.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * QtreeId


=item * QtreeName


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressQtreeInfo
   QtreeId => $some_value, # ObjId
   QtreeName => $some_value, # ObjFullName
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

