package MyTypes::ProgressResourcePoolInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourcePoolId_of :ATTR(:get<ResourcePoolId>);
my %ResourcePoolMembers_of :ATTR(:get<ResourcePoolMembers>);
my %ResourcePoolName_of :ATTR(:get<ResourcePoolName>);

__PACKAGE__->_factory(
    [ qw(        ResourcePoolId
        ResourcePoolMembers
        ResourcePoolName

    ) ],
    {
        'ResourcePoolId' => \%ResourcePoolId_of,
        'ResourcePoolMembers' => \%ResourcePoolMembers_of,
        'ResourcePoolName' => \%ResourcePoolName_of,
    },
    {
        'ResourcePoolId' => 'MyTypes::ObjId',
        'ResourcePoolMembers' => 'MyTypes::ArrayOfResourcePoolMember',
        'ResourcePoolName' => 'MyTypes::ObjFullName',
    },
    {

        'ResourcePoolId' => 'ResourcePoolId',
        'ResourcePoolMembers' => 'ResourcePoolMembers',
        'ResourcePoolName' => 'ResourcePoolName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressResourcePoolInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressResourcePoolInfo from the namespace http://www.netapp.com/management/v1.

Information about the Resource pool and its Members.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourcePoolId


=item * ResourcePoolMembers


=item * ResourcePoolName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressResourcePoolInfo
   ResourcePoolId => $some_value, # ObjId
   ResourcePoolMembers =>  { # MyTypes::ArrayOfResourcePoolMember
     ResourcePoolMember =>  { # MyTypes::ResourcePoolMember
       ResourcePoolMemberId => $some_value, # ObjId
       ResourcePoolMemberName => $some_value, # ObjFullName
     },
   },
   ResourcePoolName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

