package MyTypes::ProgressStorageServiceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %StorageServiceDescription_of :ATTR(:get<StorageServiceDescription>);
my %StorageServiceId_of :ATTR(:get<StorageServiceId>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);

__PACKAGE__->_factory(
    [ qw(        StorageServiceDescription
        StorageServiceId
        StorageServiceName

    ) ],
    {
        'StorageServiceDescription' => \%StorageServiceDescription_of,
        'StorageServiceId' => \%StorageServiceId_of,
        'StorageServiceName' => \%StorageServiceName_of,
    },
    {
        'StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageServiceId' => 'MyTypes::ObjId',
        'StorageServiceName' => 'MyTypes::ObjFullName',
    },
    {

        'StorageServiceDescription' => 'StorageServiceDescription',
        'StorageServiceId' => 'StorageServiceId',
        'StorageServiceName' => 'StorageServiceName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressStorageServiceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressStorageServiceInfo from the namespace http://www.netapp.com/management/v1.

Information about the storage Service.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * StorageServiceDescription


=item * StorageServiceId


=item * StorageServiceName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressStorageServiceInfo
   StorageServiceDescription =>  $some_value, # string
   StorageServiceId => $some_value, # ObjId
   StorageServiceName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

