package MyTypes::ProgressStorageSystemInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %StorageSystemId_of :ATTR(:get<StorageSystemId>);
my %StorageSystemName_of :ATTR(:get<StorageSystemName>);

__PACKAGE__->_factory(
    [ qw(        StorageSystemId
        StorageSystemName

    ) ],
    {
        'StorageSystemId' => \%StorageSystemId_of,
        'StorageSystemName' => \%StorageSystemName_of,
    },
    {
        'StorageSystemId' => 'MyTypes::ObjId',
        'StorageSystemName' => 'MyTypes::ObjFullName',
    },
    {

        'StorageSystemId' => 'StorageSystemId',
        'StorageSystemName' => 'StorageSystemName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressStorageSystemInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressStorageSystemInfo from the namespace http://www.netapp.com/management/v1.

Information about the discovered storage system.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * StorageSystemId


=item * StorageSystemName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressStorageSystemInfo
   StorageSystemId => $some_value, # ObjId
   StorageSystemName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

