package MyTypes::ProgressVfilerInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FilerId_of :ATTR(:get<FilerId>);
my %FilerName_of :ATTR(:get<FilerName>);
my %Ipaddress_of :ATTR(:get<Ipaddress>);
my %Ipspace_of :ATTR(:get<Ipspace>);
my %VfilerId_of :ATTR(:get<VfilerId>);
my %VfilerName_of :ATTR(:get<VfilerName>);

__PACKAGE__->_factory(
    [ qw(        FilerId
        FilerName
        Ipaddress
        Ipspace
        VfilerId
        VfilerName

    ) ],
    {
        'FilerId' => \%FilerId_of,
        'FilerName' => \%FilerName_of,
        'Ipaddress' => \%Ipaddress_of,
        'Ipspace' => \%Ipspace_of,
        'VfilerId' => \%VfilerId_of,
        'VfilerName' => \%VfilerName_of,
    },
    {
        'FilerId' => 'MyTypes::ObjId',
        'FilerName' => 'MyTypes::ObjFullName',
        'Ipaddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerId' => 'MyTypes::ObjId',
        'VfilerName' => 'MyTypes::ObjFullName',
    },
    {

        'FilerId' => 'FilerId',
        'FilerName' => 'FilerName',
        'Ipaddress' => 'Ipaddress',
        'Ipspace' => 'Ipspace',
        'VfilerId' => 'VfilerId',
        'VfilerName' => 'VfilerName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressVfilerInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressVfilerInfo from the namespace http://www.netapp.com/management/v1.

Information about creating a Vfiler




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FilerId


=item * FilerName


=item * Ipaddress


=item * Ipspace


=item * VfilerId


=item * VfilerName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressVfilerInfo
   FilerId => $some_value, # ObjId
   FilerName => $some_value, # ObjFullName
   Ipaddress =>  $some_value, # string
   Ipspace =>  $some_value, # string
   VfilerId => $some_value, # ObjId
   VfilerName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

