package MyTypes::ProgressVfilerStorageInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VfilerId_of :ATTR(:get<VfilerId>);
my %VfilerName_of :ATTR(:get<VfilerName>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        VfilerId
        VfilerName
        VolumeId
        VolumeName

    ) ],
    {
        'VfilerId' => \%VfilerId_of,
        'VfilerName' => \%VfilerName_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'VfilerId' => 'MyTypes::ObjId',
        'VfilerName' => 'MyTypes::ObjFullName',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjFullName',
    },
    {

        'VfilerId' => 'VfilerId',
        'VfilerName' => 'VfilerName',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressVfilerStorageInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressVfilerStorageInfo from the namespace http://www.netapp.com/management/v1.

Information about adding storage To a vFiler.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VfilerId


=item * VfilerName


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressVfilerStorageInfo
   VfilerId => $some_value, # ObjId
   VfilerName => $some_value, # ObjFullName
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

