package MyTypes::ProgressVolumeDedupeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DedupeProgress_of :ATTR(:get<DedupeProgress>);
my %DedupeSchedule_of :ATTR(:get<DedupeSchedule>);
my %DedupeStatus_of :ATTR(:get<DedupeStatus>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        DedupeProgress
        DedupeSchedule
        DedupeStatus
        VolumeId
        VolumeName

    ) ],
    {
        'DedupeProgress' => \%DedupeProgress_of,
        'DedupeSchedule' => \%DedupeSchedule_of,
        'DedupeStatus' => \%DedupeStatus_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'DedupeProgress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DedupeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjFullName',
    },
    {

        'DedupeProgress' => 'DedupeProgress',
        'DedupeSchedule' => 'DedupeSchedule',
        'DedupeStatus' => 'DedupeStatus',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressVolumeDedupeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressVolumeDedupeInfo from the namespace http://www.netapp.com/management/v1.

Information about the deduplication Operation on the Volume.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DedupeProgress


=item * DedupeSchedule


=item * DedupeStatus


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressVolumeDedupeInfo
   DedupeProgress =>  $some_value, # string
   DedupeSchedule =>  $some_value, # string
   DedupeStatus =>  $some_value, # string
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

