package MyTypes::ProgressVolumeOptionInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);
my %VolumeOptions_of :ATTR(:get<VolumeOptions>);

__PACKAGE__->_factory(
    [ qw(        VolumeId
        VolumeName
        VolumeOptions

    ) ],
    {
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
        'VolumeOptions' => \%VolumeOptions_of,
    },
    {
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjFullName',
        'VolumeOptions' => 'MyTypes::ArrayOfVolumeOption',
    },
    {

        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
        'VolumeOptions' => 'VolumeOptions',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProgressVolumeOptionInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProgressVolumeOptionInfo from the namespace http://www.netapp.com/management/v1.

Information about the Volume Options set.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VolumeId


=item * VolumeName


=item * VolumeOptions




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProgressVolumeOptionInfo
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjFullName
   VolumeOptions =>  { # MyTypes::ArrayOfVolumeOption
     VolumeOption =>  { # MyTypes::VolumeOption
       OptionName =>  $some_value, # string
       OptionValue =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

