package MyTypes::PropertyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PropertyName_of :ATTR(:get<PropertyName>);
my %PropertyValue_of :ATTR(:get<PropertyValue>);

__PACKAGE__->_factory(
    [ qw(        PropertyName
        PropertyValue

    ) ],
    {
        'PropertyName' => \%PropertyName_of,
        'PropertyValue' => \%PropertyValue_of,
    },
    {
        'PropertyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PropertyValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'PropertyName' => 'PropertyName',
        'PropertyValue' => 'PropertyValue',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::PropertyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
PropertyInfo from the namespace http://www.netapp.com/management/v1.

Describes a property of an object.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PropertyName


=item * PropertyValue




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::PropertyInfo
   PropertyName =>  $some_value, # string
   PropertyValue =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

