package MyTypes::ProtectionStatusProblem;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ProtectionStatusDescription_of :ATTR(:get<ProtectionStatusDescription>);
my %ProtectionStatusJobDetails_of :ATTR(:get<ProtectionStatusJobDetails>);
my %ProtectionStatusName_of :ATTR(:get<ProtectionStatusName>);

__PACKAGE__->_factory(
    [ qw(        ProtectionStatusDescription
        ProtectionStatusJobDetails
        ProtectionStatusName

    ) ],
    {
        'ProtectionStatusDescription' => \%ProtectionStatusDescription_of,
        'ProtectionStatusJobDetails' => \%ProtectionStatusJobDetails_of,
        'ProtectionStatusName' => \%ProtectionStatusName_of,
    },
    {
        'ProtectionStatusDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProtectionStatusJobDetails' => 'MyTypes::ArrayOfProtectionStatusJobDetail',
        'ProtectionStatusName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ProtectionStatusDescription' => 'ProtectionStatusDescription',
        'ProtectionStatusJobDetails' => 'ProtectionStatusJobDetails',
        'ProtectionStatusName' => 'ProtectionStatusName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProtectionStatusProblem

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProtectionStatusProblem from the namespace http://www.netapp.com/management/v1.

Information about a problem that resulted in the Dataset To not have <b>ProtectionStatus</b> as "protected".




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ProtectionStatusDescription


=item * ProtectionStatusJobDetails


=item * ProtectionStatusName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProtectionStatusProblem
   ProtectionStatusDescription =>  $some_value, # string
   ProtectionStatusJobDetails =>  { # MyTypes::ArrayOfProtectionStatusJobDetail
     ProtectionStatusJobDetail =>  { # MyTypes::ProtectionStatusJobDetail
       ProtectionStatusJobDescription =>  $some_value, # string
       ProtectionStatusJobId => $some_value, # atomic
       ProtectionStatusJobStatus => $some_value, # DpJobOverallStatus
       ProtectionStatusJobType => $some_value, # DpJobType
     },
   },
   ProtectionStatusName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

