package MyTypes::ProvisionMemberRequestInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Comments_of :ATTR(:get<Comments>);
my %CreateNewVfiler_of :ATTR(:get<CreateNewVfiler>);
my %DatasetExportInfo_of :ATTR(:get<DatasetExportInfo>);
my %Description_of :ATTR(:get<Description>);
my %InitialSnapshotSpace_of :ATTR(:get<InitialSnapshotSpace>);
my %MaximumDataSize_of :ATTR(:get<MaximumDataSize>);
my %MaximumSnapshotSpace_of :ATTR(:get<MaximumSnapshotSpace>);
my %Name_of :ATTR(:get<Name>);
my %OnlineMigration_of :ATTR(:get<OnlineMigration>);
my %ProvisioningPolicyId_of :ATTR(:get<ProvisioningPolicyId>);
my %ProvisioningPolicyName_of :ATTR(:get<ProvisioningPolicyName>);
my %ResourceNameOrId_of :ATTR(:get<ResourceNameOrId>);
my %Size_of :ATTR(:get<Size>);
my %VfilerNameOrId_of :ATTR(:get<VfilerNameOrId>);

__PACKAGE__->_factory(
    [ qw(        Comments
        CreateNewVfiler
        DatasetExportInfo
        Description
        InitialSnapshotSpace
        MaximumDataSize
        MaximumSnapshotSpace
        Name
        OnlineMigration
        ProvisioningPolicyId
        ProvisioningPolicyName
        ResourceNameOrId
        Size
        VfilerNameOrId

    ) ],
    {
        'Comments' => \%Comments_of,
        'CreateNewVfiler' => \%CreateNewVfiler_of,
        'DatasetExportInfo' => \%DatasetExportInfo_of,
        'Description' => \%Description_of,
        'InitialSnapshotSpace' => \%InitialSnapshotSpace_of,
        'MaximumDataSize' => \%MaximumDataSize_of,
        'MaximumSnapshotSpace' => \%MaximumSnapshotSpace_of,
        'Name' => \%Name_of,
        'OnlineMigration' => \%OnlineMigration_of,
        'ProvisioningPolicyId' => \%ProvisioningPolicyId_of,
        'ProvisioningPolicyName' => \%ProvisioningPolicyName_of,
        'ResourceNameOrId' => \%ResourceNameOrId_of,
        'Size' => \%Size_of,
        'VfilerNameOrId' => \%VfilerNameOrId_of,
    },
    {
        'Comments' => 'MyTypes::ArrayOfProvisionMemberComment',
        'CreateNewVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'InitialSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace',

        'MaximumDataSize' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize',

        'MaximumSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace',
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProvisioningPolicyId' => 'MyTypes::ObjId',
        'ProvisioningPolicyName' => 'MyTypes::ObjFullName',
        'ResourceNameOrId' => 'MyTypes::ObjNameOrId',

        'Size' => 'MyTypes::ProvisionMemberRequestInfo::_Size',
        'VfilerNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'Comments' => 'Comments',
        'CreateNewVfiler' => 'CreateNewVfiler',
        'DatasetExportInfo' => 'DatasetExportInfo',
        'Description' => 'Description',
        'InitialSnapshotSpace' => 'InitialSnapshotSpace',
        'MaximumDataSize' => 'MaximumDataSize',
        'MaximumSnapshotSpace' => 'MaximumSnapshotSpace',
        'Name' => 'Name',
        'OnlineMigration' => 'OnlineMigration',
        'ProvisioningPolicyId' => 'ProvisioningPolicyId',
        'ProvisioningPolicyName' => 'ProvisioningPolicyName',
        'ResourceNameOrId' => 'ResourceNameOrId',
        'Size' => 'Size',
        'VfilerNameOrId' => 'VfilerNameOrId',
    }
);

} # end BLOCK




package MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ProvisionMemberRequestInfo::_Size;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ProvisionMemberRequestInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProvisionMemberRequestInfo from the namespace http://www.netapp.com/management/v1.

Details specific To the 'provision_member' Request.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Comments


=item * CreateNewVfiler


=item * DatasetExportInfo


=item * Description


=item * InitialSnapshotSpace


=item * MaximumDataSize


=item * MaximumSnapshotSpace


=item * Name


=item * OnlineMigration


=item * ProvisioningPolicyId


=item * ProvisioningPolicyName


=item * ResourceNameOrId


=item * Size


=item * VfilerNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProvisionMemberRequestInfo
   Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
     ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
       CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
       CommentValue => $some_value, # CommentValue
     },
   },
   CreateNewVfiler =>  $some_value, # boolean
   DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
     DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
       CifsDomain =>  $some_value, # string
       DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
         DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission => $some_value, # CifsPermission
         },
       },
     },
     DatasetExportProtocol => $some_value, # DatasetExportProtocol
     DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
       IgroupOsType =>  $some_value, # string
       LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
     },
     DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsProtocolVersion =>  $some_value, # string
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
   },
   Description =>  $some_value, # string
   InitialSnapshotSpace => $some_value, # atomic
   MaximumDataSize => $some_value, # atomic
   MaximumSnapshotSpace => $some_value, # atomic
   Name =>  $some_value, # string
   OnlineMigration =>  $some_value, # boolean
   ProvisioningPolicyId => $some_value, # ObjId
   ProvisioningPolicyName => $some_value, # ObjFullName
   ResourceNameOrId => $some_value, # ObjNameOrId
   Size => $some_value, # atomic
   VfilerNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

