package MyTypes::ProvisionRequestInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DedupeMemberRequestInfo_of :ATTR(:get<DedupeMemberRequestInfo>);
my %DeleteSnapshotsRequestInfo_of :ATTR(:get<DeleteSnapshotsRequestInfo>);
my %DestroyMemberRequestInfo_of :ATTR(:get<DestroyMemberRequestInfo>);
my %ProvisionMemberRequestInfo_of :ATTR(:get<ProvisionMemberRequestInfo>);
my %ResizeMemberRequestInfo_of :ATTR(:get<ResizeMemberRequestInfo>);
my %UndedupeMemberRequestInfo_of :ATTR(:get<UndedupeMemberRequestInfo>);

__PACKAGE__->_factory(
    [ qw(        DedupeMemberRequestInfo
        DeleteSnapshotsRequestInfo
        DestroyMemberRequestInfo
        ProvisionMemberRequestInfo
        ResizeMemberRequestInfo
        UndedupeMemberRequestInfo

    ) ],
    {
        'DedupeMemberRequestInfo' => \%DedupeMemberRequestInfo_of,
        'DeleteSnapshotsRequestInfo' => \%DeleteSnapshotsRequestInfo_of,
        'DestroyMemberRequestInfo' => \%DestroyMemberRequestInfo_of,
        'ProvisionMemberRequestInfo' => \%ProvisionMemberRequestInfo_of,
        'ResizeMemberRequestInfo' => \%ResizeMemberRequestInfo_of,
        'UndedupeMemberRequestInfo' => \%UndedupeMemberRequestInfo_of,
    },
    {
        'DedupeMemberRequestInfo' => 'MyTypes::DedupeMemberRequestInfo',
        'DeleteSnapshotsRequestInfo' => 'MyTypes::DeleteSnapshotsRequestInfo',
        'DestroyMemberRequestInfo' => 'MyTypes::DestroyMemberRequestInfo',
        'ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
        'ResizeMemberRequestInfo' => 'MyTypes::ResizeMemberRequestInfo',
        'UndedupeMemberRequestInfo' => 'MyTypes::UndedupeMemberRequestInfo',
    },
    {

        'DedupeMemberRequestInfo' => 'DedupeMemberRequestInfo',
        'DeleteSnapshotsRequestInfo' => 'DeleteSnapshotsRequestInfo',
        'DestroyMemberRequestInfo' => 'DestroyMemberRequestInfo',
        'ProvisionMemberRequestInfo' => 'ProvisionMemberRequestInfo',
        'ResizeMemberRequestInfo' => 'ResizeMemberRequestInfo',
        'UndedupeMemberRequestInfo' => 'UndedupeMemberRequestInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProvisionRequestInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProvisionRequestInfo from the namespace http://www.netapp.com/management/v1.

Information of a single provisioning Request




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DedupeMemberRequestInfo


=item * DeleteSnapshotsRequestInfo


=item * DestroyMemberRequestInfo


=item * ProvisionMemberRequestInfo


=item * ResizeMemberRequestInfo


=item * UndedupeMemberRequestInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProvisionRequestInfo
   DedupeMemberRequestInfo =>  { # MyTypes::DedupeMemberRequestInfo
     FullVolumeDedupe =>  $some_value, # boolean
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjName
   },
   DeleteSnapshotsRequestInfo =>  { # MyTypes::DeleteSnapshotsRequestInfo
     Snapshots =>  { # MyTypes::ArrayOfSnapshot
       Snapshot =>  { # MyTypes::Snapshot
         SnapshotName =>  $some_value, # string
         UniqueId =>  $some_value, # string
       },
     },
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjName
   },
   DestroyMemberRequestInfo =>  { # MyTypes::DestroyMemberRequestInfo
     MemberId => $some_value, # ObjId
     MemberName => $some_value, # ObjFullName
     MemberType =>  $some_value, # string
   },
   ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
     Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
       ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
         CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
         CommentValue => $some_value, # CommentValue
       },
     },
     CreateNewVfiler =>  $some_value, # boolean
     DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
       DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
         CifsDomain =>  $some_value, # string
         DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
           DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
             CifsUsername =>  $some_value, # string
             Permission => $some_value, # CifsPermission
           },
         },
       },
       DatasetExportProtocol => $some_value, # DatasetExportProtocol
       DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
         IgroupOsType =>  $some_value, # string
         LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
           LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
             Hostname =>  $some_value, # string
             InitiatorId => $some_value, # InitiatorId
           },
         },
       },
       DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
         AnonymousAccessUser => $some_value, # atomic
         DisableSetuid =>  $some_value, # boolean
         IsReadonlyForAllHosts =>  $some_value, # boolean
         IsReadwriteForAllHosts =>  $some_value, # boolean
         NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
           NfsExportHost =>  { # MyTypes::NfsExportHost
             Hostname =>  $some_value, # string
             IsAnException =>  $some_value, # boolean
           },
         },
         NfsProtocolVersion =>  $some_value, # string
         NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
           NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
         },
       },
     },
     Description =>  $some_value, # string
     InitialSnapshotSpace => $some_value, # atomic
     MaximumDataSize => $some_value, # atomic
     MaximumSnapshotSpace => $some_value, # atomic
     Name =>  $some_value, # string
     OnlineMigration =>  $some_value, # boolean
     ProvisioningPolicyId => $some_value, # ObjId
     ProvisioningPolicyName => $some_value, # ObjFullName
     ResourceNameOrId => $some_value, # ObjNameOrId
     Size => $some_value, # atomic
     VfilerNameOrId => $some_value, # ObjNameOrId
   },
   ResizeMemberRequestInfo =>  { # MyTypes::ResizeMemberRequestInfo
     MaximumCapacity => $some_value, # atomic
     MemberId => $some_value, # ObjId
     MemberName => $some_value, # ObjName
     NewSize => $some_value, # atomic
     SnapReserve => $some_value, # atomic
   },
   UndedupeMemberRequestInfo =>  { # MyTypes::UndedupeMemberRequestInfo
     VolumeId => $some_value, # ObjId
     VolumeName => $some_value, # ObjName
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

