package MyTypes::ProvisioningPolicyInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdvancedOptions_of :ATTR(:get<AdvancedOptions>);
my %CustomProvisioningScriptSettings_of :ATTR(:get<CustomProvisioningScriptSettings>);
my %DatasetMemberUsedSpaceThresholds_of :ATTR(:get<DatasetMemberUsedSpaceThresholds>);
my %DedupeEnabled_of :ATTR(:get<DedupeEnabled>);
my %DedupeSchedule_of :ATTR(:get<DedupeSchedule>);
my %IsPolicyReadonly_of :ATTR(:get<IsPolicyReadonly>);
my %NasContainerSettings_of :ATTR(:get<NasContainerSettings>);
my %ProvisioningPolicyDescription_of :ATTR(:get<ProvisioningPolicyDescription>);
my %ProvisioningPolicyId_of :ATTR(:get<ProvisioningPolicyId>);
my %ProvisioningPolicyName_of :ATTR(:get<ProvisioningPolicyName>);
my %ProvisioningPolicyType_of :ATTR(:get<ProvisioningPolicyType>);
my %ResourceTag_of :ATTR(:get<ResourceTag>);
my %SanContainerSettings_of :ATTR(:get<SanContainerSettings>);
my %StorageReliability_of :ATTR(:get<StorageReliability>);

__PACKAGE__->_factory(
    [ qw(        AdvancedOptions
        CustomProvisioningScriptSettings
        DatasetMemberUsedSpaceThresholds
        DedupeEnabled
        DedupeSchedule
        IsPolicyReadonly
        NasContainerSettings
        ProvisioningPolicyDescription
        ProvisioningPolicyId
        ProvisioningPolicyName
        ProvisioningPolicyType
        ResourceTag
        SanContainerSettings
        StorageReliability

    ) ],
    {
        'AdvancedOptions' => \%AdvancedOptions_of,
        'CustomProvisioningScriptSettings' => \%CustomProvisioningScriptSettings_of,
        'DatasetMemberUsedSpaceThresholds' => \%DatasetMemberUsedSpaceThresholds_of,
        'DedupeEnabled' => \%DedupeEnabled_of,
        'DedupeSchedule' => \%DedupeSchedule_of,
        'IsPolicyReadonly' => \%IsPolicyReadonly_of,
        'NasContainerSettings' => \%NasContainerSettings_of,
        'ProvisioningPolicyDescription' => \%ProvisioningPolicyDescription_of,
        'ProvisioningPolicyId' => \%ProvisioningPolicyId_of,
        'ProvisioningPolicyName' => \%ProvisioningPolicyName_of,
        'ProvisioningPolicyType' => \%ProvisioningPolicyType_of,
        'ResourceTag' => \%ResourceTag_of,
        'SanContainerSettings' => \%SanContainerSettings_of,
        'StorageReliability' => \%StorageReliability_of,
    },
    {
        'AdvancedOptions' => 'MyTypes::ArrayOfAdvancedOptionInfo',
        'CustomProvisioningScriptSettings' => 'MyTypes::CustomProvisioningScriptSettings',
        'DatasetMemberUsedSpaceThresholds' => 'MyTypes::DatasetMemberUsedSpaceThresholds',
        'DedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsPolicyReadonly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'NasContainerSettings' => 'MyTypes::NasContainerSettings',
        'ProvisioningPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ProvisioningPolicyId' => 'MyTypes::ObjId',
        'ProvisioningPolicyName' => 'MyTypes::ObjName',
        'ProvisioningPolicyType' => 'MyTypes::ProvisioningPolicyType',
        'ResourceTag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SanContainerSettings' => 'MyTypes::SanContainerSettings',
        'StorageReliability' => 'MyTypes::StorageReliability',
    },
    {

        'AdvancedOptions' => 'AdvancedOptions',
        'CustomProvisioningScriptSettings' => 'CustomProvisioningScriptSettings',
        'DatasetMemberUsedSpaceThresholds' => 'DatasetMemberUsedSpaceThresholds',
        'DedupeEnabled' => 'DedupeEnabled',
        'DedupeSchedule' => 'DedupeSchedule',
        'IsPolicyReadonly' => 'IsPolicyReadonly',
        'NasContainerSettings' => 'NasContainerSettings',
        'ProvisioningPolicyDescription' => 'ProvisioningPolicyDescription',
        'ProvisioningPolicyId' => 'ProvisioningPolicyId',
        'ProvisioningPolicyName' => 'ProvisioningPolicyName',
        'ProvisioningPolicyType' => 'ProvisioningPolicyType',
        'ResourceTag' => 'ResourceTag',
        'SanContainerSettings' => 'SanContainerSettings',
        'StorageReliability' => 'StorageReliability',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ProvisioningPolicyInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ProvisioningPolicyInfo from the namespace http://www.netapp.com/management/v1.

Contains all information about a single provisioning Policy.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdvancedOptions


=item * CustomProvisioningScriptSettings


=item * DatasetMemberUsedSpaceThresholds


=item * DedupeEnabled


=item * DedupeSchedule


=item * IsPolicyReadonly


=item * NasContainerSettings


=item * ProvisioningPolicyDescription


=item * ProvisioningPolicyId


=item * ProvisioningPolicyName


=item * ProvisioningPolicyType


=item * ResourceTag


=item * SanContainerSettings


=item * StorageReliability




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ProvisioningPolicyInfo
   AdvancedOptions =>  { # MyTypes::ArrayOfAdvancedOptionInfo
     AdvancedOptionInfo =>  { # MyTypes::AdvancedOptionInfo
       OptionName =>  $some_value, # string
       OptionValue =>  $some_value, # string
     },
   },
   CustomProvisioningScriptSettings =>  { # MyTypes::CustomProvisioningScriptSettings
     ScriptPath =>  $some_value, # string
   },
   DatasetMemberUsedSpaceThresholds =>  { # MyTypes::DatasetMemberUsedSpaceThresholds
     FullThreshold => $some_value, # atomic
     NearlyFullThreshold => $some_value, # atomic
   },
   DedupeEnabled =>  $some_value, # boolean
   DedupeSchedule =>  $some_value, # string
   IsPolicyReadonly =>  $some_value, # boolean
   NasContainerSettings =>  { # MyTypes::NasContainerSettings
     AutoDeleteSnapshots =>  $some_value, # boolean
     AutoGrowCapacity =>  $some_value, # boolean
     DefaultGroupQuota => $some_value, # atomic
     DefaultUserQuota => $some_value, # atomic
     SnapshotReserve =>  $some_value, # boolean
     SpaceOnDemand =>  $some_value, # boolean
     StorageContainerType => $some_value, # StorageContainerType
     ThinProvision =>  $some_value, # boolean
   },
   ProvisioningPolicyDescription =>  $some_value, # string
   ProvisioningPolicyId => $some_value, # ObjId
   ProvisioningPolicyName => $some_value, # ObjName
   ProvisioningPolicyType => $some_value, # ProvisioningPolicyType
   ResourceTag =>  $some_value, # string
   SanContainerSettings =>  { # MyTypes::SanContainerSettings
     GuaranteeWrites =>  $some_value, # boolean
     StorageContainerType => $some_value, # StorageContainerType
     ThinProvision =>  $some_value, # boolean
     ThinProvisioningConfiguration =>  $some_value, # string
   },
   StorageReliability =>  { # MyTypes::StorageReliability
     ControllerFailure =>  $some_value, # boolean
     DiskFailure =>  $some_value, # string
     SubSystemFailure =>  $some_value, # boolean
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

