package MyTypes::QtreeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %Datasets_of :ATTR(:get<Datasets>);
my %FilerId_of :ATTR(:get<FilerId>);
my %FilerName_of :ATTR(:get<FilerName>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsDirectVfilerChild_of :ATTR(:get<IsDirectVfilerChild>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsSnapvaultSecondaryQtree_of :ATTR(:get<IsSnapvaultSecondaryQtree>);
my %QtreeId_of :ATTR(:get<QtreeId>);
my %QtreeName_of :ATTR(:get<QtreeName>);
my %QtreeSize_of :ATTR(:get<QtreeSize>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        Datasets
        FilerId
        FilerName
        IsAvailable
        IsDirectVfilerChild
        IsDpIgnored
        IsInDataset
        IsSnapvaultSecondaryQtree
        QtreeId
        QtreeName
        QtreeSize
        VolumeId
        VolumeName

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'Datasets' => \%Datasets_of,
        'FilerId' => \%FilerId_of,
        'FilerName' => \%FilerName_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsDirectVfilerChild' => \%IsDirectVfilerChild_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsSnapvaultSecondaryQtree' => \%IsSnapvaultSecondaryQtree_of,
        'QtreeId' => \%QtreeId_of,
        'QtreeName' => \%QtreeName_of,
        'QtreeSize' => \%QtreeSize_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {

        'DatasetId' => 'MyTypes::QtreeInfo::_DatasetId',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',

        'FilerId' => 'MyTypes::QtreeInfo::_FilerId',
        'FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDirectVfilerChild' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryQtree' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'QtreeId' => 'MyTypes::QtreeInfo::_QtreeId',
        'QtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'QtreeSize' => 'MyTypes::WrapperOfQtreeSizeInfo',

        'VolumeId' => 'MyTypes::QtreeInfo::_VolumeId',
        'VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DatasetId' => 'DatasetId',
        'Datasets' => 'Datasets',
        'FilerId' => 'FilerId',
        'FilerName' => 'FilerName',
        'IsAvailable' => 'IsAvailable',
        'IsDirectVfilerChild' => 'IsDirectVfilerChild',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsSnapvaultSecondaryQtree' => 'IsSnapvaultSecondaryQtree',
        'QtreeId' => 'QtreeId',
        'QtreeName' => 'QtreeName',
        'QtreeSize' => 'QtreeSize',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK




package MyTypes::QtreeInfo::_DatasetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::QtreeInfo::_FilerId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::QtreeInfo::_QtreeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::QtreeInfo::_VolumeId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::QtreeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
QtreeInfo from the namespace http://www.netapp.com/management/v1.

Information about a Qtree.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * Datasets


=item * FilerId


=item * FilerName


=item * IsAvailable


=item * IsDirectVfilerChild


=item * IsDpIgnored


=item * IsInDataset


=item * IsSnapvaultSecondaryQtree


=item * QtreeId


=item * QtreeName


=item * QtreeSize


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::QtreeInfo
   DatasetId => $some_value, # atomic
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   FilerId => $some_value, # atomic
   FilerName =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   IsDirectVfilerChild =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsSnapvaultSecondaryQtree =>  $some_value, # boolean
   QtreeId => $some_value, # atomic
   QtreeName =>  $some_value, # string
   QtreeSize =>  { # MyTypes::WrapperOfQtreeSizeInfo
     QtreeSizeInfo =>  { # MyTypes::QtreeSizeInfo
       FilesLimit =>  $some_value, # integer
       FilesUsed =>  $some_value, # integer
       HardLimit => $some_value, # atomic
       QtreePerfStatus => $some_value, # ObjStatus
       QtreeStatus => $some_value, # ObjStatus
       SoftLimit => $some_value, # atomic
       SpaceUsed => $some_value, # atomic
     },
   },
   VolumeId => $some_value, # atomic
   VolumeName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

