package MyTypes::QtreeNameOrId;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %QtreeId_of :ATTR(:get<QtreeId>);
my %QtreeName_of :ATTR(:get<QtreeName>);

__PACKAGE__->_factory(
    [ qw(        QtreeId
        QtreeName

    ) ],
    {
        'QtreeId' => \%QtreeId_of,
        'QtreeName' => \%QtreeName_of,
    },
    {
        'QtreeId' => 'MyTypes::ObjId',
        'QtreeName' => 'MyTypes::ObjName',
    },
    {

        'QtreeId' => 'QtreeId',
        'QtreeName' => 'QtreeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::QtreeNameOrId

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
QtreeNameOrId from the namespace http://www.netapp.com/management/v1.

A Qtree Name or Id. When used as input only one of QtreeName or QtreeId is specified. When used as output, both of them will be returned. If QtreeName is specified, then either HostIdentifier or VolumeIdentifier must also be specified but not both.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * QtreeId


=item * QtreeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::QtreeNameOrId
   QtreeId => $some_value, # ObjId
   QtreeName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

