package MyTypes::QtreeResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostIdentifier_of :ATTR(:get<HostIdentifier>);
my %QtreeIdentifierNameOrId_of :ATTR(:get<QtreeIdentifierNameOrId>);
my %VolumeIdentifier_of :ATTR(:get<VolumeIdentifier>);

__PACKAGE__->_factory(
    [ qw(        HostIdentifier
        QtreeIdentifierNameOrId
        VolumeIdentifier

    ) ],
    {
        'HostIdentifier' => \%HostIdentifier_of,
        'QtreeIdentifierNameOrId' => \%QtreeIdentifierNameOrId_of,
        'VolumeIdentifier' => \%VolumeIdentifier_of,
    },
    {
        'HostIdentifier' => 'MyTypes::WrapperOfHostResource',
        'QtreeIdentifierNameOrId' => 'MyTypes::WrapperOfQtreeNameOrId',
        'VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
    },
    {

        'HostIdentifier' => 'HostIdentifier',
        'QtreeIdentifierNameOrId' => 'QtreeIdentifierNameOrId',
        'VolumeIdentifier' => 'VolumeIdentifier',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::QtreeResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
QtreeResource from the namespace http://www.netapp.com/management/v1.

Details of a Qtree. QtreeIdentifierNameOrId must be specified. If QtreeName is specified, then either VolumeIdentifier or HostIdentifier must also be specified. See the Description for QtreeName for more information.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostIdentifier


=item * QtreeIdentifierNameOrId


=item * VolumeIdentifier




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::QtreeResource
   HostIdentifier =>  { # MyTypes::WrapperOfHostResource
     HostResource =>  { # MyTypes::HostResource
       HostId =>  $some_value, # unsignedInt
       HostName =>  $some_value, # string
     },
   },
   QtreeIdentifierNameOrId =>  { # MyTypes::WrapperOfQtreeNameOrId
     QtreeNameOrId =>  { # MyTypes::QtreeNameOrId
       QtreeId => $some_value, # ObjId
       QtreeName => $some_value, # ObjName
     },
   },
   VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
     VolumeResource =>  { # MyTypes::VolumeResource
       AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
         AggregateResource =>  { # MyTypes::AggregateResource
           AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
             AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
               AggregateId =>  $some_value, # unsignedInt
               AggregateName =>  $some_value, # string
             },
           },
           FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
             FilerResource =>  { # MyTypes::FilerResource
               FilerId =>  $some_value, # unsignedInt
               FilerName =>  $some_value, # string
             },
           },
         },
       },
       HostIdentifier =>  { # MyTypes::WrapperOfHostResource
         HostResource =>  { # MyTypes::HostResource
           HostId =>  $some_value, # unsignedInt
           HostName =>  $some_value, # string
         },
       },
       VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
         VfilerResource =>  { # MyTypes::VfilerResource
           VfilerId =>  $some_value, # unsignedInt
           VfilerNameOrUuid =>  $some_value, # string
         },
       },
       VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
         VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
           VolumeId =>  $some_value, # unsignedInt
           VolumeName =>  $some_value, # string
         },
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

