package MyTypes::QtreeSizeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FilesLimit_of :ATTR(:get<FilesLimit>);
my %FilesUsed_of :ATTR(:get<FilesUsed>);
my %HardLimit_of :ATTR(:get<HardLimit>);
my %QtreePerfStatus_of :ATTR(:get<QtreePerfStatus>);
my %QtreeStatus_of :ATTR(:get<QtreeStatus>);
my %SoftLimit_of :ATTR(:get<SoftLimit>);
my %SpaceUsed_of :ATTR(:get<SpaceUsed>);

__PACKAGE__->_factory(
    [ qw(        FilesLimit
        FilesUsed
        HardLimit
        QtreePerfStatus
        QtreeStatus
        SoftLimit
        SpaceUsed

    ) ],
    {
        'FilesLimit' => \%FilesLimit_of,
        'FilesUsed' => \%FilesUsed_of,
        'HardLimit' => \%HardLimit_of,
        'QtreePerfStatus' => \%QtreePerfStatus_of,
        'QtreeStatus' => \%QtreeStatus_of,
        'SoftLimit' => \%SoftLimit_of,
        'SpaceUsed' => \%SpaceUsed_of,
    },
    {
        'FilesLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'FilesUsed' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'HardLimit' => 'MyTypes::QtreeSizeInfo::_HardLimit',
        'QtreePerfStatus' => 'MyTypes::ObjStatus',
        'QtreeStatus' => 'MyTypes::ObjStatus',

        'SoftLimit' => 'MyTypes::QtreeSizeInfo::_SoftLimit',

        'SpaceUsed' => 'MyTypes::QtreeSizeInfo::_SpaceUsed',
    },
    {

        'FilesLimit' => 'FilesLimit',
        'FilesUsed' => 'FilesUsed',
        'HardLimit' => 'HardLimit',
        'QtreePerfStatus' => 'QtreePerfStatus',
        'QtreeStatus' => 'QtreeStatus',
        'SoftLimit' => 'SoftLimit',
        'SpaceUsed' => 'SpaceUsed',
    }
);

} # end BLOCK




package MyTypes::QtreeSizeInfo::_HardLimit;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::QtreeSizeInfo::_SoftLimit;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::QtreeSizeInfo::_SpaceUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::QtreeSizeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
QtreeSizeInfo from the namespace http://www.netapp.com/management/v1.

Sizes of various parameters of a Qtree. File counts are simple counts.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FilesLimit


=item * FilesUsed


=item * HardLimit


=item * QtreePerfStatus


=item * QtreeStatus


=item * SoftLimit


=item * SpaceUsed




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::QtreeSizeInfo
   FilesLimit =>  $some_value, # integer
   FilesUsed =>  $some_value, # integer
   HardLimit => $some_value, # atomic
   QtreePerfStatus => $some_value, # ObjStatus
   QtreeStatus => $some_value, # ObjStatus
   SoftLimit => $some_value, # atomic
   SpaceUsed => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

