package MyTypes::RbacOperation;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %OperationName_of :ATTR(:get<OperationName>);
my %OperationNameDetails_of :ATTR(:get<OperationNameDetails>);

__PACKAGE__->_factory(
    [ qw(        OperationName
        OperationNameDetails

    ) ],
    {
        'OperationName' => \%OperationName_of,
        'OperationNameDetails' => \%OperationNameDetails_of,
    },
    {
        'OperationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'OperationNameDetails' => 'MyTypes::WrapperOfRbacOperationNameDetails',
    },
    {

        'OperationName' => 'OperationName',
        'OperationNameDetails' => 'OperationNameDetails',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::RbacOperation

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
RbacOperation from the namespace http://www.netapp.com/management/v1.

An Operation




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * OperationName


=item * OperationNameDetails




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::RbacOperation
   OperationName =>  $some_value, # string
   OperationNameDetails =>  { # MyTypes::WrapperOfRbacOperationNameDetails
     RbacOperationNameDetails =>  { # MyTypes::RbacOperationNameDetails
       OperationDescription =>  $some_value, # string
       OperationSynopsis =>  $some_value, # string
       ResourceType =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

