package MyTypes::RelationshipState;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
RelationshipState from the namespace http://www.netapp.com/management/v1.

State of the relationship. Possible Values are "uninitialized", "snapvaulted", "snapmirrored", "broken_off", "quiesced", "Source", "unknown" or "restoring" <ul> <li>uninitialized: The destination storage Volume or Qtree is not yet initialized or is being initialized. <li>snapvaulted: Valid only in case of 'snapvault' relationships. The relationship is created and the Qtree is a SnapVault secondary destination. <li>snapmirrored: Valid only in case of 'qtree_snapmirror' or 'volume_snapmirror' relationships. The destination Volume or Qtree is in a SnapMirror relationship. <li>broken_off: Valid only in case of 'qtree_snapmirror' or 'volume_snapmirror' relationships. The destination was in a SnapMirror relationship, but a snapmirror break command made the Volume or Qtree writable. This state is reported as long as the base Snapshot copy is still present in the Volume. If the Snapshot copy is deleted, the state is listed as "uninitialized" if the destination is in the /etc/snapmirror.conf filen then the Snapshot copy is no longer listed. A successful snapmirror resync command restores the snapmirrored Status. <li>quiesced: Valid only in case of 'qtree_snapmirror' or 'volume_snapmirror' relationships. SnapMirror is in a consistent internal state and no SnapMirror activity is occurring. In this state, you can create Snapshot copies with confidence that all destinations are consistent. The snapmirror quiesce command brings the destination into this state. The snapmirror resume command restarts all SnapMirror activities. <li>Source: This state is reported when the snapvault Status or snapmirror Status command is run on the primary storage system. When the destination is on another system, its Status is unknown, so the Source Status is reported. In case of 'snapvault' relationships, it also appears if snapvault Status is run on secondary storage systems after the snapvault restore command was run on an associated primary storage system. <li>unknown: The destination Volume or the Volume that contains the destination Qtree is in an unknown state. It might be offline or restricted <li>restoring: Valid only in case of 'snapvault' relationships. </ul>



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

