package MyTypes::ReplaceResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %MemberType_of :ATTR(:get<MemberType>);
my %NewPrimaryMemberId_of :ATTR(:get<NewPrimaryMemberId>);
my %NewPrimaryMemberName_of :ATTR(:get<NewPrimaryMemberName>);
my %OldPrimaryMemberId_of :ATTR(:get<OldPrimaryMemberId>);
my %OldPrimaryMemberName_of :ATTR(:get<OldPrimaryMemberName>);
my %ReplaceStatus_of :ATTR(:get<ReplaceStatus>);
my %SecondaryMemberId_of :ATTR(:get<SecondaryMemberId>);
my %SecondaryMemberName_of :ATTR(:get<SecondaryMemberName>);

__PACKAGE__->_factory(
    [ qw(        DpNodeName
        MemberType
        NewPrimaryMemberId
        NewPrimaryMemberName
        OldPrimaryMemberId
        OldPrimaryMemberName
        ReplaceStatus
        SecondaryMemberId
        SecondaryMemberName

    ) ],
    {
        'DpNodeName' => \%DpNodeName_of,
        'MemberType' => \%MemberType_of,
        'NewPrimaryMemberId' => \%NewPrimaryMemberId_of,
        'NewPrimaryMemberName' => \%NewPrimaryMemberName_of,
        'OldPrimaryMemberId' => \%OldPrimaryMemberId_of,
        'OldPrimaryMemberName' => \%OldPrimaryMemberName_of,
        'ReplaceStatus' => \%ReplaceStatus_of,
        'SecondaryMemberId' => \%SecondaryMemberId_of,
        'SecondaryMemberName' => \%SecondaryMemberName_of,
    },
    {
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NewPrimaryMemberId' => 'MyTypes::ObjId',
        'NewPrimaryMemberName' => 'MyTypes::ObjName',
        'OldPrimaryMemberId' => 'MyTypes::ObjId',
        'OldPrimaryMemberName' => 'MyTypes::ObjName',
        'ReplaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SecondaryMemberId' => 'MyTypes::ObjId',
        'SecondaryMemberName' => 'MyTypes::ObjName',
    },
    {

        'DpNodeName' => 'DpNodeName',
        'MemberType' => 'MemberType',
        'NewPrimaryMemberId' => 'NewPrimaryMemberId',
        'NewPrimaryMemberName' => 'NewPrimaryMemberName',
        'OldPrimaryMemberId' => 'OldPrimaryMemberId',
        'OldPrimaryMemberName' => 'OldPrimaryMemberName',
        'ReplaceStatus' => 'ReplaceStatus',
        'SecondaryMemberId' => 'SecondaryMemberId',
        'SecondaryMemberName' => 'SecondaryMemberName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ReplaceResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReplaceResult from the namespace http://www.netapp.com/management/v1.

A Description of one replace Action.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpNodeName


=item * MemberType


=item * NewPrimaryMemberId


=item * NewPrimaryMemberName


=item * OldPrimaryMemberId


=item * OldPrimaryMemberName


=item * ReplaceStatus


=item * SecondaryMemberId


=item * SecondaryMemberName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReplaceResult
   DpNodeName => $some_value, # DpPolicyNodeName
   MemberType =>  $some_value, # string
   NewPrimaryMemberId => $some_value, # ObjId
   NewPrimaryMemberName => $some_value, # ObjName
   OldPrimaryMemberId => $some_value, # ObjId
   OldPrimaryMemberName => $some_value, # ObjName
   ReplaceStatus =>  $some_value, # string
   SecondaryMemberId => $some_value, # ObjId
   SecondaryMemberName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

