package MyTypes::ReportInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DeprecatedBy_of :ATTR(:get<DeprecatedBy>);
my %Description_of :ATTR(:get<Description>);
my %DisplayTab_of :ATTR(:get<DisplayTab>);
my %IsDeprecated_of :ATTR(:get<IsDeprecated>);
my %OutputFormatList_of :ATTR(:get<OutputFormatList>);
my %RbacOperation_of :ATTR(:get<RbacOperation>);
my %ReportApplication_of :ATTR(:get<ReportApplication>);
my %ReportId_of :ATTR(:get<ReportId>);
my %ReportName_of :ATTR(:get<ReportName>);
my %ReportPrettyName_of :ATTR(:get<ReportPrettyName>);
my %ReportType_of :ATTR(:get<ReportType>);

__PACKAGE__->_factory(
    [ qw(        DeprecatedBy
        Description
        DisplayTab
        IsDeprecated
        OutputFormatList
        RbacOperation
        ReportApplication
        ReportId
        ReportName
        ReportPrettyName
        ReportType

    ) ],
    {
        'DeprecatedBy' => \%DeprecatedBy_of,
        'Description' => \%Description_of,
        'DisplayTab' => \%DisplayTab_of,
        'IsDeprecated' => \%IsDeprecated_of,
        'OutputFormatList' => \%OutputFormatList_of,
        'RbacOperation' => \%RbacOperation_of,
        'ReportApplication' => \%ReportApplication_of,
        'ReportId' => \%ReportId_of,
        'ReportName' => \%ReportName_of,
        'ReportPrettyName' => \%ReportPrettyName_of,
        'ReportType' => \%ReportType_of,
    },
    {
        'DeprecatedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DisplayTab' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDeprecated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'OutputFormatList' => 'MyTypes::ArrayOfReportOutputFormat',
        'RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportApplication' => 'MyTypes::ReportApplication',

        'ReportId' => 'MyTypes::ReportInfo::_ReportId',
        'ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DeprecatedBy' => 'DeprecatedBy',
        'Description' => 'Description',
        'DisplayTab' => 'DisplayTab',
        'IsDeprecated' => 'IsDeprecated',
        'OutputFormatList' => 'OutputFormatList',
        'RbacOperation' => 'RbacOperation',
        'ReportApplication' => 'ReportApplication',
        'ReportId' => 'ReportId',
        'ReportName' => 'ReportName',
        'ReportPrettyName' => 'ReportPrettyName',
        'ReportType' => 'ReportType',
    }
);

} # end BLOCK




package MyTypes::ReportInfo::_ReportId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ReportInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReportInfo from the namespace http://www.netapp.com/management/v1.

Describes the Name of the report.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DeprecatedBy


=item * Description


=item * DisplayTab


=item * IsDeprecated


=item * OutputFormatList


=item * RbacOperation


=item * ReportApplication


=item * ReportId


=item * ReportName


=item * ReportPrettyName


=item * ReportType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReportInfo
   DeprecatedBy =>  $some_value, # string
   Description =>  $some_value, # string
   DisplayTab =>  $some_value, # string
   IsDeprecated =>  $some_value, # boolean
   OutputFormatList =>  { # MyTypes::ArrayOfReportOutputFormat
     ReportOutputFormat => $some_value, # ReportOutputFormat
   },
   RbacOperation =>  $some_value, # string
   ReportApplication => $some_value, # ReportApplication
   ReportId => $some_value, # atomic
   ReportName =>  $some_value, # string
   ReportPrettyName =>  $some_value, # string
   ReportType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

