package MyTypes::ReportListInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CategoryId_of :ATTR(:get<CategoryId>);
my %IsIntervalAllowed_of :ATTR(:get<IsIntervalAllowed>);
my %ReportDescription_of :ATTR(:get<ReportDescription>);
my %ReportDesignFileName_of :ATTR(:get<ReportDesignFileName>);
my %ReportId_of :ATTR(:get<ReportId>);
my %ReportName_of :ATTR(:get<ReportName>);
my %ReportPrettyName_of :ATTR(:get<ReportPrettyName>);
my %ReportProvenance_of :ATTR(:get<ReportProvenance>);

__PACKAGE__->_factory(
    [ qw(        CategoryId
        IsIntervalAllowed
        ReportDescription
        ReportDesignFileName
        ReportId
        ReportName
        ReportPrettyName
        ReportProvenance

    ) ],
    {
        'CategoryId' => \%CategoryId_of,
        'IsIntervalAllowed' => \%IsIntervalAllowed_of,
        'ReportDescription' => \%ReportDescription_of,
        'ReportDesignFileName' => \%ReportDesignFileName_of,
        'ReportId' => \%ReportId_of,
        'ReportName' => \%ReportName_of,
        'ReportPrettyName' => \%ReportPrettyName_of,
        'ReportProvenance' => \%ReportProvenance_of,
    },
    {

        'CategoryId' => 'MyTypes::ReportListInfo::_CategoryId',
        'IsIntervalAllowed' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ReportDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportDesignFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ReportId' => 'MyTypes::ReportListInfo::_ReportId',
        'ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportProvenance' => 'MyTypes::ReportProvenance',
    },
    {

        'CategoryId' => 'CategoryId',
        'IsIntervalAllowed' => 'IsIntervalAllowed',
        'ReportDescription' => 'ReportDescription',
        'ReportDesignFileName' => 'ReportDesignFileName',
        'ReportId' => 'ReportId',
        'ReportName' => 'ReportName',
        'ReportPrettyName' => 'ReportPrettyName',
        'ReportProvenance' => 'ReportProvenance',
    }
);

} # end BLOCK




package MyTypes::ReportListInfo::_CategoryId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ReportListInfo::_ReportId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ReportListInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReportListInfo from the namespace http://www.netapp.com/management/v1.

Contains the details of the Reports.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CategoryId


=item * IsIntervalAllowed


=item * ReportDescription


=item * ReportDesignFileName


=item * ReportId


=item * ReportName


=item * ReportPrettyName


=item * ReportProvenance




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReportListInfo
   CategoryId => $some_value, # atomic
   IsIntervalAllowed =>  $some_value, # boolean
   ReportDescription =>  $some_value, # string
   ReportDesignFileName =>  $some_value, # string
   ReportId => $some_value, # atomic
   ReportName =>  $some_value, # string
   ReportPrettyName =>  $some_value, # string
   ReportProvenance => $some_value, # ReportProvenance
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

