package MyTypes::ReportOutputInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %FailureReason_of :ATTR(:get<FailureReason>);
my %GraphName_of :ATTR(:get<GraphName>);
my %ReportApplication_of :ATTR(:get<ReportApplication>);
my %ReportId_of :ATTR(:get<ReportId>);
my %ReportName_of :ATTR(:get<ReportName>);
my %ReportOutputId_of :ATTR(:get<ReportOutputId>);
my %ReportScheduleId_of :ATTR(:get<ReportScheduleId>);
my %ReportScheduleName_of :ATTR(:get<ReportScheduleName>);
my %RunBy_of :ATTR(:get<RunBy>);
my %RunStatus_of :ATTR(:get<RunStatus>);
my %RunTime_of :ATTR(:get<RunTime>);
my %TargetObjectId_of :ATTR(:get<TargetObjectId>);
my %TargetObjectName_of :ATTR(:get<TargetObjectName>);

__PACKAGE__->_factory(
    [ qw(        FailureReason
        GraphName
        ReportApplication
        ReportId
        ReportName
        ReportOutputId
        ReportScheduleId
        ReportScheduleName
        RunBy
        RunStatus
        RunTime
        TargetObjectId
        TargetObjectName

    ) ],
    {
        'FailureReason' => \%FailureReason_of,
        'GraphName' => \%GraphName_of,
        'ReportApplication' => \%ReportApplication_of,
        'ReportId' => \%ReportId_of,
        'ReportName' => \%ReportName_of,
        'ReportOutputId' => \%ReportOutputId_of,
        'ReportScheduleId' => \%ReportScheduleId_of,
        'ReportScheduleName' => \%ReportScheduleName_of,
        'RunBy' => \%RunBy_of,
        'RunStatus' => \%RunStatus_of,
        'RunTime' => \%RunTime_of,
        'TargetObjectId' => \%TargetObjectId_of,
        'TargetObjectName' => \%TargetObjectName_of,
    },
    {
        'FailureReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportApplication' => 'MyTypes::ReportApplication',

        'ReportId' => 'MyTypes::ReportOutputInfo::_ReportId',
        'ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ReportOutputId' => 'MyTypes::ReportOutputInfo::_ReportOutputId',
        'ReportScheduleId' => 'MyTypes::ObjId',
        'ReportScheduleName' => 'MyTypes::ObjName',
        'RunBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RunStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'RunTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'TargetObjectId' => 'MyTypes::ReportOutputInfo::_TargetObjectId',
        'TargetObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'FailureReason' => 'FailureReason',
        'GraphName' => 'GraphName',
        'ReportApplication' => 'ReportApplication',
        'ReportId' => 'ReportId',
        'ReportName' => 'ReportName',
        'ReportOutputId' => 'ReportOutputId',
        'ReportScheduleId' => 'ReportScheduleId',
        'ReportScheduleName' => 'ReportScheduleName',
        'RunBy' => 'RunBy',
        'RunStatus' => 'RunStatus',
        'RunTime' => 'RunTime',
        'TargetObjectId' => 'TargetObjectId',
        'TargetObjectName' => 'TargetObjectName',
    }
);

} # end BLOCK




package MyTypes::ReportOutputInfo::_ReportId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ReportOutputInfo::_ReportOutputId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ReportOutputInfo::_TargetObjectId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ReportOutputInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReportOutputInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of an output.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * FailureReason


=item * GraphName


=item * ReportApplication


=item * ReportId


=item * ReportName


=item * ReportOutputId


=item * ReportScheduleId


=item * ReportScheduleName


=item * RunBy


=item * RunStatus


=item * RunTime


=item * TargetObjectId


=item * TargetObjectName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReportOutputInfo
   FailureReason =>  $some_value, # string
   GraphName =>  $some_value, # string
   ReportApplication => $some_value, # ReportApplication
   ReportId => $some_value, # atomic
   ReportName =>  $some_value, # string
   ReportOutputId => $some_value, # atomic
   ReportScheduleId => $some_value, # ObjId
   ReportScheduleName => $some_value, # ObjName
   RunBy =>  $some_value, # string
   RunStatus =>  $some_value, # string
   RunTime =>  $some_value, # integer
   TargetObjectId => $some_value, # atomic
   TargetObjectName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

