package MyTypes::ReportScheduleContentInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ArchivalFormat_of :ATTR(:get<ArchivalFormat>);
my %EmailAddressList_of :ATTR(:get<EmailAddressList>);
my %GraphName_of :ATTR(:get<GraphName>);
my %IncludeDeletedObjects_of :ATTR(:get<IncludeDeletedObjects>);
my %IsEnabled_of :ATTR(:get<IsEnabled>);
my %IsSuccessful_of :ATTR(:get<IsSuccessful>);
my %LastRunTime_of :ATTR(:get<LastRunTime>);
my %ReportApplication_of :ATTR(:get<ReportApplication>);
my %ReportId_of :ATTR(:get<ReportId>);
my %ReportName_of :ATTR(:get<ReportName>);
my %ReportScheduleId_of :ATTR(:get<ReportScheduleId>);
my %ReportScheduleName_of :ATTR(:get<ReportScheduleName>);
my %SaveAllFields_of :ATTR(:get<SaveAllFields>);
my %ScheduleId_of :ATTR(:get<ScheduleId>);
my %ScheduleName_of :ATTR(:get<ScheduleName>);
my %TargetObjectId_of :ATTR(:get<TargetObjectId>);
my %TargetObjectName_of :ATTR(:get<TargetObjectName>);

__PACKAGE__->_factory(
    [ qw(        ArchivalFormat
        EmailAddressList
        GraphName
        IncludeDeletedObjects
        IsEnabled
        IsSuccessful
        LastRunTime
        ReportApplication
        ReportId
        ReportName
        ReportScheduleId
        ReportScheduleName
        SaveAllFields
        ScheduleId
        ScheduleName
        TargetObjectId
        TargetObjectName

    ) ],
    {
        'ArchivalFormat' => \%ArchivalFormat_of,
        'EmailAddressList' => \%EmailAddressList_of,
        'GraphName' => \%GraphName_of,
        'IncludeDeletedObjects' => \%IncludeDeletedObjects_of,
        'IsEnabled' => \%IsEnabled_of,
        'IsSuccessful' => \%IsSuccessful_of,
        'LastRunTime' => \%LastRunTime_of,
        'ReportApplication' => \%ReportApplication_of,
        'ReportId' => \%ReportId_of,
        'ReportName' => \%ReportName_of,
        'ReportScheduleId' => \%ReportScheduleId_of,
        'ReportScheduleName' => \%ReportScheduleName_of,
        'SaveAllFields' => \%SaveAllFields_of,
        'ScheduleId' => \%ScheduleId_of,
        'ScheduleName' => \%ScheduleName_of,
        'TargetObjectId' => \%TargetObjectId_of,
        'TargetObjectName' => \%TargetObjectName_of,
    },
    {
        'ArchivalFormat' => 'MyTypes::ReportOutputFormat',
        'EmailAddressList' => 'MyTypes::EmailAddressList',
        'GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSuccessful' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LastRunTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ReportApplication' => 'MyTypes::ReportApplication',

        'ReportId' => 'MyTypes::ReportScheduleContentInfo::_ReportId',
        'ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportScheduleId' => 'MyTypes::ObjId',
        'ReportScheduleName' => 'MyTypes::ObjName',
        'SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'ScheduleId' => 'MyTypes::ReportScheduleContentInfo::_ScheduleId',
        'ScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'TargetObjectId' => 'MyTypes::ReportScheduleContentInfo::_TargetObjectId',
        'TargetObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ArchivalFormat' => 'ArchivalFormat',
        'EmailAddressList' => 'EmailAddressList',
        'GraphName' => 'GraphName',
        'IncludeDeletedObjects' => 'IncludeDeletedObjects',
        'IsEnabled' => 'IsEnabled',
        'IsSuccessful' => 'IsSuccessful',
        'LastRunTime' => 'LastRunTime',
        'ReportApplication' => 'ReportApplication',
        'ReportId' => 'ReportId',
        'ReportName' => 'ReportName',
        'ReportScheduleId' => 'ReportScheduleId',
        'ReportScheduleName' => 'ReportScheduleName',
        'SaveAllFields' => 'SaveAllFields',
        'ScheduleId' => 'ScheduleId',
        'ScheduleName' => 'ScheduleName',
        'TargetObjectId' => 'TargetObjectId',
        'TargetObjectName' => 'TargetObjectName',
    }
);

} # end BLOCK




package MyTypes::ReportScheduleContentInfo::_ReportId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ReportScheduleContentInfo::_ScheduleId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ReportScheduleContentInfo::_TargetObjectId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ReportScheduleContentInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReportScheduleContentInfo from the namespace http://www.netapp.com/management/v1.

Describes the contents of a report schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ArchivalFormat


=item * EmailAddressList


=item * GraphName


=item * IncludeDeletedObjects


=item * IsEnabled


=item * IsSuccessful


=item * LastRunTime


=item * ReportApplication


=item * ReportId


=item * ReportName


=item * ReportScheduleId


=item * ReportScheduleName


=item * SaveAllFields


=item * ScheduleId


=item * ScheduleName


=item * TargetObjectId


=item * TargetObjectName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReportScheduleContentInfo
   ArchivalFormat => $some_value, # ReportOutputFormat
   EmailAddressList => $some_value, # EmailAddressList
   GraphName =>  $some_value, # string
   IncludeDeletedObjects =>  $some_value, # boolean
   IsEnabled =>  $some_value, # boolean
   IsSuccessful =>  $some_value, # boolean
   LastRunTime =>  $some_value, # integer
   ReportApplication => $some_value, # ReportApplication
   ReportId => $some_value, # atomic
   ReportName =>  $some_value, # string
   ReportScheduleId => $some_value, # ObjId
   ReportScheduleName => $some_value, # ObjName
   SaveAllFields =>  $some_value, # boolean
   ScheduleId => $some_value, # atomic
   ScheduleName =>  $some_value, # string
   TargetObjectId => $some_value, # atomic
   TargetObjectName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

