package MyTypes::ReportScheduleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ArchivalFormat_of :ATTR(:get<ArchivalFormat>);
my %EmailAddressList_of :ATTR(:get<EmailAddressList>);
my %GraphName_of :ATTR(:get<GraphName>);
my %IncludeDeletedObjects_of :ATTR(:get<IncludeDeletedObjects>);
my %ReportApplication_of :ATTR(:get<ReportApplication>);
my %ReportNameOrId_of :ATTR(:get<ReportNameOrId>);
my %ReportScheduleName_of :ATTR(:get<ReportScheduleName>);
my %SaveAllFields_of :ATTR(:get<SaveAllFields>);
my %ScheduleNameOrId_of :ATTR(:get<ScheduleNameOrId>);
my %TargetObjectNameOrId_of :ATTR(:get<TargetObjectNameOrId>);

__PACKAGE__->_factory(
    [ qw(        ArchivalFormat
        EmailAddressList
        GraphName
        IncludeDeletedObjects
        ReportApplication
        ReportNameOrId
        ReportScheduleName
        SaveAllFields
        ScheduleNameOrId
        TargetObjectNameOrId

    ) ],
    {
        'ArchivalFormat' => \%ArchivalFormat_of,
        'EmailAddressList' => \%EmailAddressList_of,
        'GraphName' => \%GraphName_of,
        'IncludeDeletedObjects' => \%IncludeDeletedObjects_of,
        'ReportApplication' => \%ReportApplication_of,
        'ReportNameOrId' => \%ReportNameOrId_of,
        'ReportScheduleName' => \%ReportScheduleName_of,
        'SaveAllFields' => \%SaveAllFields_of,
        'ScheduleNameOrId' => \%ScheduleNameOrId_of,
        'TargetObjectNameOrId' => \%TargetObjectNameOrId_of,
    },
    {
        'ArchivalFormat' => 'MyTypes::ReportOutputFormat',
        'EmailAddressList' => 'MyTypes::EmailAddressList',
        'GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ReportApplication' => 'MyTypes::ReportApplication',
        'ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReportScheduleName' => 'MyTypes::ObjName',
        'SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
        'TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'ArchivalFormat' => 'ArchivalFormat',
        'EmailAddressList' => 'EmailAddressList',
        'GraphName' => 'GraphName',
        'IncludeDeletedObjects' => 'IncludeDeletedObjects',
        'ReportApplication' => 'ReportApplication',
        'ReportNameOrId' => 'ReportNameOrId',
        'ReportScheduleName' => 'ReportScheduleName',
        'SaveAllFields' => 'SaveAllFields',
        'ScheduleNameOrId' => 'ScheduleNameOrId',
        'TargetObjectNameOrId' => 'TargetObjectNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ReportScheduleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ReportScheduleInfo from the namespace http://www.netapp.com/management/v1.

Detailed contents of a report schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ArchivalFormat


=item * EmailAddressList


=item * GraphName


=item * IncludeDeletedObjects


=item * ReportApplication


=item * ReportNameOrId


=item * ReportScheduleName


=item * SaveAllFields


=item * ScheduleNameOrId


=item * TargetObjectNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ReportScheduleInfo
   ArchivalFormat => $some_value, # ReportOutputFormat
   EmailAddressList => $some_value, # EmailAddressList
   GraphName =>  $some_value, # string
   IncludeDeletedObjects =>  $some_value, # boolean
   ReportApplication => $some_value, # ReportApplication
   ReportNameOrId =>  $some_value, # string
   ReportScheduleName => $some_value, # ObjName
   SaveAllFields =>  $some_value, # boolean
   ScheduleNameOrId => $some_value, # ObjNameOrId
   TargetObjectNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

