package MyTypes::RequiresNonDisruptiveRestore;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::boolean);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
RequiresNonDisruptiveRestore from the namespace http://www.netapp.com/management/v1.

When this attribute is set, the Dataset is configured To allow LUNs To be restored From Backups in such a way that the Host need not detach From the LUN. <P>Configuring the Dataset for non-disruptive restore does not guarantee that all backup Instances may be restored non-disruptively. It only applies To backup Instances reached through a <b>Backup</b> connection. The caller must check the <b>SupportsNonDisruptiveRestore</b> output element returned by <b>dp-backup-list-info-next</b> To tell whether a given backup Instance can be restored non-disruptively. <P>Specifically, when this attribute is set: <ul> <li>All storage systems must be running ONTAP 7.3 or later. <li>Protection Manager must have working ZAPI credentials for all storage systems in use by this Dataset. <li>All <b>Backup</b> connections will be implemented using SnapVault, not Qtree SnapMirror. <li>All non-primary storage systems used by the data set must have a SnapVault Secondary License. </ul> <P>If any of these constraints is not met when adding a member To the Dataset, the Dataset will not be in conformance and the addition will generate conformance Errors. Addition of Members with ONTAP Version less than 7.3 To the primary node of the Dataset will fail with Errors. <P><b>requires-nondisruptive-restore</b> may only be specified if: <ul> <li> No <b>Backup</b> connection in the protection Policy used by the Dataset is DR capable (i.e. the <b>IsDrCapable</b> attribute may not be set for any <b>Backup</b> connection of the Policy). <li> The Dataset must be an application Dataset. </ul> Thus, if <b>RequiresNonDisruptiveRestore</b> is specified as true, <b>IsApplicationData</b> must also be present and true. Callers may check the <b>non-disruptive-restore-compatible</b> output element of the <b>dp-policy-list-info-iter-next</b> API To tell which policies may be applied To Datasets requiring non-disruptive restores.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::boolean
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

