package MyTypes::ResourcePoolMember;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourcePoolMemberId_of :ATTR(:get<ResourcePoolMemberId>);
my %ResourcePoolMemberName_of :ATTR(:get<ResourcePoolMemberName>);

__PACKAGE__->_factory(
    [ qw(        ResourcePoolMemberId
        ResourcePoolMemberName

    ) ],
    {
        'ResourcePoolMemberId' => \%ResourcePoolMemberId_of,
        'ResourcePoolMemberName' => \%ResourcePoolMemberName_of,
    },
    {
        'ResourcePoolMemberId' => 'MyTypes::ObjId',
        'ResourcePoolMemberName' => 'MyTypes::ObjFullName',
    },
    {

        'ResourcePoolMemberId' => 'ResourcePoolMemberId',
        'ResourcePoolMemberName' => 'ResourcePoolMemberName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResourcePoolMember

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcePoolMember from the namespace http://www.netapp.com/management/v1.

Information about the member of the Resource pool.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourcePoolMemberId


=item * ResourcePoolMemberName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcePoolMember
   ResourcePoolMemberId => $some_value, # ObjId
   ResourcePoolMemberName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

