package MyTypes::ResourcePoolResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourcePoolId_of :ATTR(:get<ResourcePoolId>);
my %ResourcePoolName_of :ATTR(:get<ResourcePoolName>);

__PACKAGE__->_factory(
    [ qw(        ResourcePoolId
        ResourcePoolName

    ) ],
    {
        'ResourcePoolId' => \%ResourcePoolId_of,
        'ResourcePoolName' => \%ResourcePoolName_of,
    },
    {
        'ResourcePoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'ResourcePoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ResourcePoolId' => 'ResourcePoolId',
        'ResourcePoolName' => 'ResourcePoolName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResourcePoolResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcePoolResource from the namespace http://www.netapp.com/management/v1.

Details of a DFM ResourcePool Resource. DFM ResourcePool Name or object Id of a DFM ResourcePool. When used as input only one of ResourcePoolName or ResourcePoolId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourcePoolId


=item * ResourcePoolName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcePoolResource
   ResourcePoolId =>  $some_value, # unsignedInt
   ResourcePoolName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

