package MyTypes::ResourcePropertyCondition;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Name_of :ATTR(:get<Name>);
my %Value_of :ATTR(:get<Value>);

__PACKAGE__->_factory(
    [ qw(        Name
        Value

    ) ],
    {
        'Name' => \%Name_of,
        'Value' => \%Value_of,
    },
    {
        'Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Name' => 'Name',
        'Value' => 'Value',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResourcePropertyCondition

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcePropertyCondition from the namespace http://www.netapp.com/management/v1.

Specifies conditions on Resource Properties. In case of Values for the same property, the conditions are assumed To be either-or conditions. For example, if the conditions "Disk RPM=7200" and "Disk RPM=10000" are specified, the threshold applies To all Disks with Speed 7200 RPM or 10000 RPM. In case of conditions on different Properties, the conditions are assumed To be "and" conditions. For example, if the conditions Name = "Disk RPM", Value = "10000" and name="Filer Model", value="FAS270" are specified, the threshold applies To all Disks with Speed 10000 RPM on FAS270 storage systems. During template modification, if no Resource Properties are specified, existing Resource Properties, if any, will be cleared.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Name


=item * Value




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcePropertyCondition
   Name =>  $some_value, # string
   Value =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

