package MyTypes::ResourcePropertyValues;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourceProperty_of :ATTR(:get<ResourceProperty>);
my %Values_of :ATTR(:get<Values>);

__PACKAGE__->_factory(
    [ qw(        ResourceProperty
        Values

    ) ],
    {
        'ResourceProperty' => \%ResourceProperty_of,
        'Values' => \%Values_of,
    },
    {
        'ResourceProperty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Values' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'ResourceProperty' => 'ResourceProperty',
        'Values' => 'Values',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResourcePropertyValues

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcePropertyValues from the namespace http://www.netapp.com/management/v1.

Provides information on Resource Properties and the possible Values




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourceProperty


=item * Values




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcePropertyValues
   ResourceProperty =>  $some_value, # string
   Values =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

