package MyTypes::ResourcepoolDefaults;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourcepoolFullThreshold_of :ATTR(:get<ResourcepoolFullThreshold>);
my %ResourcepoolNearlyFullThreshold_of :ATTR(:get<ResourcepoolNearlyFullThreshold>);

__PACKAGE__->_factory(
    [ qw(        ResourcepoolFullThreshold
        ResourcepoolNearlyFullThreshold

    ) ],
    {
        'ResourcepoolFullThreshold' => \%ResourcepoolFullThreshold_of,
        'ResourcepoolNearlyFullThreshold' => \%ResourcepoolNearlyFullThreshold_of,
    },
    {

        'ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolDefaults::_ResourcepoolFullThreshold',

        'ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolDefaults::_ResourcepoolNearlyFullThreshold',
    },
    {

        'ResourcepoolFullThreshold' => 'ResourcepoolFullThreshold',
        'ResourcepoolNearlyFullThreshold' => 'ResourcepoolNearlyFullThreshold',
    }
);

} # end BLOCK




package MyTypes::ResourcepoolDefaults::_ResourcepoolFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolDefaults::_ResourcepoolNearlyFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ResourcepoolDefaults

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcepoolDefaults from the namespace http://www.netapp.com/management/v1.

The default Values of the Attributes defined by this ZAPI.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourcepoolFullThreshold


=item * ResourcepoolNearlyFullThreshold




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcepoolDefaults
   ResourcepoolFullThreshold => $some_value, # atomic
   ResourcepoolNearlyFullThreshold => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

