package MyTypes::ResourcepoolInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateNearlyOvercommittedThreshold_of :ATTR(:get<AggregateNearlyOvercommittedThreshold>);
my %AggregateOvercommittedThreshold_of :ATTR(:get<AggregateOvercommittedThreshold>);
my %ResourceTag_of :ATTR(:get<ResourceTag>);
my %ResourcepoolContact_of :ATTR(:get<ResourcepoolContact>);
my %ResourcepoolDescription_of :ATTR(:get<ResourcepoolDescription>);
my %ResourcepoolFreeVfilers_of :ATTR(:get<ResourcepoolFreeVfilers>);
my %ResourcepoolFullThreshold_of :ATTR(:get<ResourcepoolFullThreshold>);
my %ResourcepoolId_of :ATTR(:get<ResourcepoolId>);
my %ResourcepoolIsProvisionable_of :ATTR(:get<ResourcepoolIsProvisionable>);
my %ResourcepoolKbytesAvailable_of :ATTR(:get<ResourcepoolKbytesAvailable>);
my %ResourcepoolKbytesTotal_of :ATTR(:get<ResourcepoolKbytesTotal>);
my %ResourcepoolKbytesUsed_of :ATTR(:get<ResourcepoolKbytesUsed>);
my %ResourcepoolMemberCount_of :ATTR(:get<ResourcepoolMemberCount>);
my %ResourcepoolName_of :ATTR(:get<ResourcepoolName>);
my %ResourcepoolNearlyFullThreshold_of :ATTR(:get<ResourcepoolNearlyFullThreshold>);
my %ResourcepoolOwner_of :ATTR(:get<ResourcepoolOwner>);
my %ResourcepoolPerfStatus_of :ATTR(:get<ResourcepoolPerfStatus>);
my %ResourcepoolSpaceStatus_of :ATTR(:get<ResourcepoolSpaceStatus>);
my %ResourcepoolStatus_of :ATTR(:get<ResourcepoolStatus>);
my %ResourcepoolTimezone_of :ATTR(:get<ResourcepoolTimezone>);

__PACKAGE__->_factory(
    [ qw(        AggregateNearlyOvercommittedThreshold
        AggregateOvercommittedThreshold
        ResourceTag
        ResourcepoolContact
        ResourcepoolDescription
        ResourcepoolFreeVfilers
        ResourcepoolFullThreshold
        ResourcepoolId
        ResourcepoolIsProvisionable
        ResourcepoolKbytesAvailable
        ResourcepoolKbytesTotal
        ResourcepoolKbytesUsed
        ResourcepoolMemberCount
        ResourcepoolName
        ResourcepoolNearlyFullThreshold
        ResourcepoolOwner
        ResourcepoolPerfStatus
        ResourcepoolSpaceStatus
        ResourcepoolStatus
        ResourcepoolTimezone

    ) ],
    {
        'AggregateNearlyOvercommittedThreshold' => \%AggregateNearlyOvercommittedThreshold_of,
        'AggregateOvercommittedThreshold' => \%AggregateOvercommittedThreshold_of,
        'ResourceTag' => \%ResourceTag_of,
        'ResourcepoolContact' => \%ResourcepoolContact_of,
        'ResourcepoolDescription' => \%ResourcepoolDescription_of,
        'ResourcepoolFreeVfilers' => \%ResourcepoolFreeVfilers_of,
        'ResourcepoolFullThreshold' => \%ResourcepoolFullThreshold_of,
        'ResourcepoolId' => \%ResourcepoolId_of,
        'ResourcepoolIsProvisionable' => \%ResourcepoolIsProvisionable_of,
        'ResourcepoolKbytesAvailable' => \%ResourcepoolKbytesAvailable_of,
        'ResourcepoolKbytesTotal' => \%ResourcepoolKbytesTotal_of,
        'ResourcepoolKbytesUsed' => \%ResourcepoolKbytesUsed_of,
        'ResourcepoolMemberCount' => \%ResourcepoolMemberCount_of,
        'ResourcepoolName' => \%ResourcepoolName_of,
        'ResourcepoolNearlyFullThreshold' => \%ResourcepoolNearlyFullThreshold_of,
        'ResourcepoolOwner' => \%ResourcepoolOwner_of,
        'ResourcepoolPerfStatus' => \%ResourcepoolPerfStatus_of,
        'ResourcepoolSpaceStatus' => \%ResourcepoolSpaceStatus_of,
        'ResourcepoolStatus' => \%ResourcepoolStatus_of,
        'ResourcepoolTimezone' => \%ResourcepoolTimezone_of,
    },
    {
        'AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
        'AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
        'ResourceTag' => 'MyTypes::ResourceTag',
        'ResourcepoolContact' => 'MyTypes::EmailAddressList',
        'ResourcepoolDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolFreeVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',

        'ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold',
        'ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ResourcepoolIsProvisionable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'ResourcepoolKbytesAvailable' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable',

        'ResourcepoolKbytesTotal' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal',

        'ResourcepoolKbytesUsed' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed',

        'ResourcepoolMemberCount' => 'MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount',
        'ResourcepoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold',
        'ResourcepoolOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolPerfStatus' => 'MyTypes::ObjStatus',
        'ResourcepoolSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ResourcepoolStatus' => 'MyTypes::ObjStatus',
        'ResourcepoolTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AggregateNearlyOvercommittedThreshold' => 'AggregateNearlyOvercommittedThreshold',
        'AggregateOvercommittedThreshold' => 'AggregateOvercommittedThreshold',
        'ResourceTag' => 'ResourceTag',
        'ResourcepoolContact' => 'ResourcepoolContact',
        'ResourcepoolDescription' => 'ResourcepoolDescription',
        'ResourcepoolFreeVfilers' => 'ResourcepoolFreeVfilers',
        'ResourcepoolFullThreshold' => 'ResourcepoolFullThreshold',
        'ResourcepoolId' => 'ResourcepoolId',
        'ResourcepoolIsProvisionable' => 'ResourcepoolIsProvisionable',
        'ResourcepoolKbytesAvailable' => 'ResourcepoolKbytesAvailable',
        'ResourcepoolKbytesTotal' => 'ResourcepoolKbytesTotal',
        'ResourcepoolKbytesUsed' => 'ResourcepoolKbytesUsed',
        'ResourcepoolMemberCount' => 'ResourcepoolMemberCount',
        'ResourcepoolName' => 'ResourcepoolName',
        'ResourcepoolNearlyFullThreshold' => 'ResourcepoolNearlyFullThreshold',
        'ResourcepoolOwner' => 'ResourcepoolOwner',
        'ResourcepoolPerfStatus' => 'ResourcepoolPerfStatus',
        'ResourcepoolSpaceStatus' => 'ResourcepoolSpaceStatus',
        'ResourcepoolStatus' => 'ResourcepoolStatus',
        'ResourcepoolTimezone' => 'ResourcepoolTimezone',
    }
);

} # end BLOCK




package MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ResourcepoolInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcepoolInfo from the namespace http://www.netapp.com/management/v1.

Information about a Resource pool.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateNearlyOvercommittedThreshold


=item * AggregateOvercommittedThreshold


=item * ResourceTag


=item * ResourcepoolContact


=item * ResourcepoolDescription


=item * ResourcepoolFreeVfilers


=item * ResourcepoolFullThreshold


=item * ResourcepoolId


=item * ResourcepoolIsProvisionable


=item * ResourcepoolKbytesAvailable


=item * ResourcepoolKbytesTotal


=item * ResourcepoolKbytesUsed


=item * ResourcepoolMemberCount


=item * ResourcepoolName


=item * ResourcepoolNearlyFullThreshold


=item * ResourcepoolOwner


=item * ResourcepoolPerfStatus


=item * ResourcepoolSpaceStatus


=item * ResourcepoolStatus


=item * ResourcepoolTimezone




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcepoolInfo
   AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
   AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
   ResourceTag => $some_value, # ResourceTag
   ResourcepoolContact => $some_value, # EmailAddressList
   ResourcepoolDescription =>  $some_value, # string
   ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
   ResourcepoolFullThreshold => $some_value, # atomic
   ResourcepoolId =>  $some_value, # integer
   ResourcepoolIsProvisionable =>  $some_value, # boolean
   ResourcepoolKbytesAvailable => $some_value, # atomic
   ResourcepoolKbytesTotal => $some_value, # atomic
   ResourcepoolKbytesUsed => $some_value, # atomic
   ResourcepoolMemberCount => $some_value, # atomic
   ResourcepoolName =>  $some_value, # string
   ResourcepoolNearlyFullThreshold => $some_value, # atomic
   ResourcepoolOwner =>  $some_value, # string
   ResourcepoolPerfStatus => $some_value, # ObjStatus
   ResourcepoolSpaceStatus =>  $some_value, # string
   ResourcepoolStatus => $some_value, # ObjStatus
   ResourcepoolTimezone =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

