package MyTypes::ResourcepoolMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetsSpaceInfo_of :ATTR(:get<DatasetsSpaceInfo>);
my %MemberCommittedSpace_of :ATTR(:get<MemberCommittedSpace>);
my %MemberId_of :ATTR(:get<MemberId>);
my %MemberName_of :ATTR(:get<MemberName>);
my %MemberSize_of :ATTR(:get<MemberSize>);
my %MemberSpaceStatus_of :ATTR(:get<MemberSpaceStatus>);
my %MemberStatus_of :ATTR(:get<MemberStatus>);
my %MemberType_of :ATTR(:get<MemberType>);
my %MemberUsedSpace_of :ATTR(:get<MemberUsedSpace>);
my %ProvisioningChecksPassed_of :ATTR(:get<ProvisioningChecksPassed>);
my %ResourceTag_of :ATTR(:get<ResourceTag>);

__PACKAGE__->_factory(
    [ qw(        DatasetsSpaceInfo
        MemberCommittedSpace
        MemberId
        MemberName
        MemberSize
        MemberSpaceStatus
        MemberStatus
        MemberType
        MemberUsedSpace
        ProvisioningChecksPassed
        ResourceTag

    ) ],
    {
        'DatasetsSpaceInfo' => \%DatasetsSpaceInfo_of,
        'MemberCommittedSpace' => \%MemberCommittedSpace_of,
        'MemberId' => \%MemberId_of,
        'MemberName' => \%MemberName_of,
        'MemberSize' => \%MemberSize_of,
        'MemberSpaceStatus' => \%MemberSpaceStatus_of,
        'MemberStatus' => \%MemberStatus_of,
        'MemberType' => \%MemberType_of,
        'MemberUsedSpace' => \%MemberUsedSpace_of,
        'ProvisioningChecksPassed' => \%ProvisioningChecksPassed_of,
        'ResourceTag' => \%ResourceTag_of,
    },
    {
        'DatasetsSpaceInfo' => 'MyTypes::ArrayOfDatasetSpaceInfo',
        'MemberCommittedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MemberId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MemberName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MemberSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'MemberSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
        'MemberStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'MemberUsedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ProvisioningChecksPassed' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ResourceTag' => 'MyTypes::ResourceTag',
    },
    {

        'DatasetsSpaceInfo' => 'DatasetsSpaceInfo',
        'MemberCommittedSpace' => 'MemberCommittedSpace',
        'MemberId' => 'MemberId',
        'MemberName' => 'MemberName',
        'MemberSize' => 'MemberSize',
        'MemberSpaceStatus' => 'MemberSpaceStatus',
        'MemberStatus' => 'MemberStatus',
        'MemberType' => 'MemberType',
        'MemberUsedSpace' => 'MemberUsedSpace',
        'ProvisioningChecksPassed' => 'ProvisioningChecksPassed',
        'ResourceTag' => 'ResourceTag',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResourcepoolMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResourcepoolMemberInfo from the namespace http://www.netapp.com/management/v1.

Information about one member of a Resource pool.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetsSpaceInfo


=item * MemberCommittedSpace


=item * MemberId


=item * MemberName


=item * MemberSize


=item * MemberSpaceStatus


=item * MemberStatus


=item * MemberType


=item * MemberUsedSpace


=item * ProvisioningChecksPassed


=item * ResourceTag




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResourcepoolMemberInfo
   DatasetsSpaceInfo =>  { # MyTypes::ArrayOfDatasetSpaceInfo
     DatasetSpaceInfo =>  { # MyTypes::DatasetSpaceInfo
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DpNodeId => $some_value, # atomic
       DpNodeName =>  $some_value, # string
       IsCapableOfMigration =>  $some_value, # boolean
       IsDpNodeEffectivePrimary =>  $some_value, # boolean
       UsedSpace =>  $some_value, # unsignedLong
     },
   },
   MemberCommittedSpace =>  $some_value, # integer
   MemberId =>  $some_value, # integer
   MemberName =>  $some_value, # string
   MemberSize =>  $some_value, # integer
   MemberSpaceStatus => $some_value, # ObjectSpaceStatus
   MemberStatus =>  $some_value, # string
   MemberType =>  $some_value, # string
   MemberUsedSpace =>  $some_value, # integer
   ProvisioningChecksPassed =>  $some_value, # boolean
   ResourceTag => $some_value, # ResourceTag
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

