package MyTypes::Response;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Errno_of :ATTR(:get<Errno>);
my %Reason_of :ATTR(:get<Reason>);
my %Results_of :ATTR(:get<Results>);
my %Status_of :ATTR(:get<Status>);

__PACKAGE__->_factory(
    [ qw(        Errno
        Reason
        Results
        Status

    ) ],
    {
        'Errno' => \%Errno_of,
        'Reason' => \%Reason_of,
        'Results' => \%Results_of,
        'Status' => \%Status_of,
    },
    {
        'Errno' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'Results' => 'MyTypes::Response::_Results',
        'Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Errno' => 'Errno',
        'Reason' => 'Reason',
        'Results' => 'Results',
        'Status' => 'Status',
    }
);

} # end BLOCK




package MyTypes::Response::_Results;
use strict;
use warnings;
{
our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables


__PACKAGE__->_factory(
    [ qw(
    ) ],
    {
    },
    {
    },
    {

    }
);

} # end BLOCK






}






1;


=pod

=head1 NAME

MyTypes::Response

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Response from the namespace http://www.netapp.com/management/v1.

One API Response.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Errno


=item * Reason


=item * Results


=item * Status




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Response
   Errno =>  $some_value, # integer
   Reason =>  $some_value, # string
   Results =>  {
   },
   Status =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

