package MyTypes::ResultDetail;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Action_of :ATTR(:get<Action>);
my %Effect_of :ATTR(:get<Effect>);
my %Reason_of :ATTR(:get<Reason>);
my %Severity_of :ATTR(:get<Severity>);
my %Suggestion_of :ATTR(:get<Suggestion>);

__PACKAGE__->_factory(
    [ qw(        Action
        Effect
        Reason
        Severity
        Suggestion

    ) ],
    {
        'Action' => \%Action_of,
        'Effect' => \%Effect_of,
        'Reason' => \%Reason_of,
        'Severity' => \%Severity_of,
        'Suggestion' => \%Suggestion_of,
    },
    {
        'Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Severity' => 'MyTypes::ObjStatus',
        'Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Action' => 'Action',
        'Effect' => 'Effect',
        'Reason' => 'Reason',
        'Severity' => 'Severity',
        'Suggestion' => 'Suggestion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ResultDetail

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ResultDetail from the namespace http://www.netapp.com/management/v1.

Details on a specific Action that adds information intended To explain more about a higher level Result. For example, the detail may be used To explain a DryRun Result by explaining why resources were not selected.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Action


=item * Effect


=item * Reason


=item * Severity


=item * Suggestion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ResultDetail
   Action =>  $some_value, # string
   Effect =>  $some_value, # string
   Reason =>  $some_value, # string
   Severity => $some_value, # ObjStatus
   Suggestion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

