package MyTypes::SanContainerSettings;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %GuaranteeWrites_of :ATTR(:get<GuaranteeWrites>);
my %StorageContainerType_of :ATTR(:get<StorageContainerType>);
my %ThinProvision_of :ATTR(:get<ThinProvision>);
my %ThinProvisioningConfiguration_of :ATTR(:get<ThinProvisioningConfiguration>);

__PACKAGE__->_factory(
    [ qw(        GuaranteeWrites
        StorageContainerType
        ThinProvision
        ThinProvisioningConfiguration

    ) ],
    {
        'GuaranteeWrites' => \%GuaranteeWrites_of,
        'StorageContainerType' => \%StorageContainerType_of,
        'ThinProvision' => \%ThinProvision_of,
        'ThinProvisioningConfiguration' => \%ThinProvisioningConfiguration_of,
    },
    {
        'GuaranteeWrites' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'StorageContainerType' => 'MyTypes::StorageContainerType',
        'ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ThinProvisioningConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'GuaranteeWrites' => 'GuaranteeWrites',
        'StorageContainerType' => 'StorageContainerType',
        'ThinProvision' => 'ThinProvision',
        'ThinProvisioningConfiguration' => 'ThinProvisioningConfiguration',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SanContainerSettings

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SanContainerSettings from the namespace http://www.netapp.com/management/v1.

Space settings when provisioning storage for san access, specify how space will be allocated To various components in san environment.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * GuaranteeWrites


=item * StorageContainerType


=item * ThinProvision


=item * ThinProvisioningConfiguration




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SanContainerSettings
   GuaranteeWrites =>  $some_value, # boolean
   StorageContainerType => $some_value, # StorageContainerType
   ThinProvision =>  $some_value, # boolean
   ThinProvisioningConfiguration =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

