package MyTypes::ScheduleIdInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Id_of :ATTR(:get<Id>);
my %Name_of :ATTR(:get<Name>);
my %Type_of :ATTR(:get<Type>);

__PACKAGE__->_factory(
    [ qw(        Id
        Name
        Type

    ) ],
    {
        'Id' => \%Id_of,
        'Name' => \%Name_of,
        'Type' => \%Type_of,
    },
    {
        'Id' => 'MyTypes::ObjId',
        'Name' => 'MyTypes::ObjName',
        'Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Id' => 'Id',
        'Name' => 'Name',
        'Type' => 'Type',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ScheduleIdInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ScheduleIdInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a Id list




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Id


=item * Name


=item * Type




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ScheduleIdInfo
   Id => $some_value, # ObjId
   Name => $some_value, # ObjName
   Type =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

