package MyTypes::ServiceStatus;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Service_of :ATTR(:get<Service>);

__PACKAGE__->_factory(
    [ qw(        Service

    ) ],
    {
        'Service' => \%Service_of,
    },
    {
        'Service' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Service' => 'Service',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ServiceStatus

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ServiceStatus from the namespace http://www.netapp.com/management/v1.

Status indicating whether a Service is up or down.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Service




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ServiceStatus
   Service =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

