package MyTypes::SimpleScheduleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DaysOfMonth_of :ATTR(:get<DaysOfMonth>);
my %DaysOfWeek_of :ATTR(:get<DaysOfWeek>);
my %TimesOfDayInfo_of :ATTR(:get<TimesOfDayInfo>);

__PACKAGE__->_factory(
    [ qw(        DaysOfMonth
        DaysOfWeek
        TimesOfDayInfo

    ) ],
    {
        'DaysOfMonth' => \%DaysOfMonth_of,
        'DaysOfWeek' => \%DaysOfWeek_of,
        'TimesOfDayInfo' => \%TimesOfDayInfo_of,
    },
    {
        'DaysOfMonth' => 'MyTypes::ArrayOfDayOfMonth',
        'DaysOfWeek' => 'MyTypes::ArrayOfDayOfWeek',
        'TimesOfDayInfo' => 'MyTypes::TimesOfDayInfo',
    },
    {

        'DaysOfMonth' => 'DaysOfMonth',
        'DaysOfWeek' => 'DaysOfWeek',
        'TimesOfDayInfo' => 'TimesOfDayInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SimpleScheduleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SimpleScheduleInfo from the namespace http://www.netapp.com/management/v1.

Simple schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DaysOfMonth


=item * DaysOfWeek


=item * TimesOfDayInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SimpleScheduleInfo
   DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
     DayOfMonth => $some_value, # DayOfMonth
   },
   DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
     DayOfWeek => $some_value, # DayOfWeek
   },
   TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
     EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
       TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
         Hour => $some_value, # atomic
         Minute => $some_value, # atomic
       },
     },
     Frequency => $some_value, # atomic
     StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
       TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
         Hour => $some_value, # atomic
         Minute => $some_value, # atomic
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

