package MyTypes::Snapshot;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %SnapshotName_of :ATTR(:get<SnapshotName>);
my %UniqueId_of :ATTR(:get<UniqueId>);

__PACKAGE__->_factory(
    [ qw(        SnapshotName
        UniqueId

    ) ],
    {
        'SnapshotName' => \%SnapshotName_of,
        'UniqueId' => \%UniqueId_of,
    },
    {
        'SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'SnapshotName' => 'SnapshotName',
        'UniqueId' => 'UniqueId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::Snapshot

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
Snapshot from the namespace http://www.netapp.com/management/v1.

Information of one Snapshot copy. Either UniqueId or Name of the Snapshot copy should be specified.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * SnapshotName


=item * UniqueId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::Snapshot
   SnapshotName =>  $some_value, # string
   UniqueId =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

