package MyTypes::SnapshotInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Backups_of :ATTR(:get<Backups>);
my %CreationTimestamp_of :ATTR(:get<CreationTimestamp>);
my %CumulativePercentageOfTotalBlocks_of :ATTR(:get<CumulativePercentageOfTotalBlocks>);
my %Dependencies_of :ATTR(:get<Dependencies>);
my %IsBusy_of :ATTR(:get<IsBusy>);
my %IsPartOfBackupVersion_of :ATTR(:get<IsPartOfBackupVersion>);
my %PercentageOfTotalBlocks_of :ATTR(:get<PercentageOfTotalBlocks>);
my %SnapshotId_of :ATTR(:get<SnapshotId>);
my %SnapshotName_of :ATTR(:get<SnapshotName>);
my %UniqueId_of :ATTR(:get<UniqueId>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        Backups
        CreationTimestamp
        CumulativePercentageOfTotalBlocks
        Dependencies
        IsBusy
        IsPartOfBackupVersion
        PercentageOfTotalBlocks
        SnapshotId
        SnapshotName
        UniqueId
        VolumeId
        VolumeName

    ) ],
    {
        'Backups' => \%Backups_of,
        'CreationTimestamp' => \%CreationTimestamp_of,
        'CumulativePercentageOfTotalBlocks' => \%CumulativePercentageOfTotalBlocks_of,
        'Dependencies' => \%Dependencies_of,
        'IsBusy' => \%IsBusy_of,
        'IsPartOfBackupVersion' => \%IsPartOfBackupVersion_of,
        'PercentageOfTotalBlocks' => \%PercentageOfTotalBlocks_of,
        'SnapshotId' => \%SnapshotId_of,
        'SnapshotName' => \%SnapshotName_of,
        'UniqueId' => \%UniqueId_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'Backups' => 'MyTypes::ArrayOfBackupInfo',
        'CreationTimestamp' => 'MyTypes::DpTimestamp',

        'CumulativePercentageOfTotalBlocks' => 'MyTypes::SnapshotInfo::_CumulativePercentageOfTotalBlocks',
        'Dependencies' => 'MyTypes::ArrayOfSnapshotDependency',
        'IsBusy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsPartOfBackupVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'PercentageOfTotalBlocks' => 'MyTypes::SnapshotInfo::_PercentageOfTotalBlocks',

        'SnapshotId' => 'MyTypes::SnapshotInfo::_SnapshotId',
        'SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjFullName',
    },
    {

        'Backups' => 'Backups',
        'CreationTimestamp' => 'CreationTimestamp',
        'CumulativePercentageOfTotalBlocks' => 'CumulativePercentageOfTotalBlocks',
        'Dependencies' => 'Dependencies',
        'IsBusy' => 'IsBusy',
        'IsPartOfBackupVersion' => 'IsPartOfBackupVersion',
        'PercentageOfTotalBlocks' => 'PercentageOfTotalBlocks',
        'SnapshotId' => 'SnapshotId',
        'SnapshotName' => 'SnapshotName',
        'UniqueId' => 'UniqueId',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK




package MyTypes::SnapshotInfo::_CumulativePercentageOfTotalBlocks;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SnapshotInfo::_PercentageOfTotalBlocks;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SnapshotInfo::_SnapshotId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::SnapshotInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SnapshotInfo from the namespace http://www.netapp.com/management/v1.

Information on one particular Snapshot copy.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Backups


=item * CreationTimestamp


=item * CumulativePercentageOfTotalBlocks


=item * Dependencies


=item * IsBusy


=item * IsPartOfBackupVersion


=item * PercentageOfTotalBlocks


=item * SnapshotId


=item * SnapshotName


=item * UniqueId


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SnapshotInfo
   Backups =>  { # MyTypes::ArrayOfBackupInfo
     BackupInfo =>  { # MyTypes::BackupInfo
       BackupId => $some_value, # atomic
       BackupVersion => $some_value, # DpTimestamp
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DpBackupExpiryTimestamp => $some_value, # DpTimestamp
       DpNodeId =>  $some_value, # integer
       DpNodeName =>  $some_value, # string
       IsApplicationBackup =>  $some_value, # boolean
     },
   },
   CreationTimestamp => $some_value, # DpTimestamp
   CumulativePercentageOfTotalBlocks => $some_value, # atomic
   Dependencies =>  { # MyTypes::ArrayOfSnapshotDependency
     SnapshotDependency => $some_value, # SnapshotDependency
   },
   IsBusy =>  $some_value, # boolean
   IsPartOfBackupVersion =>  $some_value, # boolean
   PercentageOfTotalBlocks => $some_value, # atomic
   SnapshotId => $some_value, # atomic
   SnapshotName =>  $some_value, # string
   UniqueId =>  $some_value, # string
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

