package MyTypes::SnapshotMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PrimaryId_of :ATTR(:get<PrimaryId>);
my %PrimaryName_of :ATTR(:get<PrimaryName>);
my %PrimarySnapshotHostServiceId_of :ATTR(:get<PrimarySnapshotHostServiceId>);
my %PrimarySnapshotName_of :ATTR(:get<PrimarySnapshotName>);
my %PrimarySnapshotUniqueId_of :ATTR(:get<PrimarySnapshotUniqueId>);
my %SecondaryQtreeId_of :ATTR(:get<SecondaryQtreeId>);
my %SecondaryQtreeName_of :ATTR(:get<SecondaryQtreeName>);
my %SecondaryQtreeNameOrId_of :ATTR(:get<SecondaryQtreeNameOrId>);

__PACKAGE__->_factory(
    [ qw(        PrimaryId
        PrimaryName
        PrimarySnapshotHostServiceId
        PrimarySnapshotName
        PrimarySnapshotUniqueId
        SecondaryQtreeId
        SecondaryQtreeName
        SecondaryQtreeNameOrId

    ) ],
    {
        'PrimaryId' => \%PrimaryId_of,
        'PrimaryName' => \%PrimaryName_of,
        'PrimarySnapshotHostServiceId' => \%PrimarySnapshotHostServiceId_of,
        'PrimarySnapshotName' => \%PrimarySnapshotName_of,
        'PrimarySnapshotUniqueId' => \%PrimarySnapshotUniqueId_of,
        'SecondaryQtreeId' => \%SecondaryQtreeId_of,
        'SecondaryQtreeName' => \%SecondaryQtreeName_of,
        'SecondaryQtreeNameOrId' => \%SecondaryQtreeNameOrId_of,
    },
    {
        'PrimaryId' => 'MyTypes::ObjId',
        'PrimaryName' => 'MyTypes::ObjName',
        'PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SecondaryQtreeId' => 'MyTypes::ObjId',
        'SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'PrimaryId' => 'PrimaryId',
        'PrimaryName' => 'PrimaryName',
        'PrimarySnapshotHostServiceId' => 'PrimarySnapshotHostServiceId',
        'PrimarySnapshotName' => 'PrimarySnapshotName',
        'PrimarySnapshotUniqueId' => 'PrimarySnapshotUniqueId',
        'SecondaryQtreeId' => 'SecondaryQtreeId',
        'SecondaryQtreeName' => 'SecondaryQtreeName',
        'SecondaryQtreeNameOrId' => 'SecondaryQtreeNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SnapshotMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SnapshotMemberInfo from the namespace http://www.netapp.com/management/v1.

Information of one Qtree or ossv dir that is in Snapshot.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PrimaryId


=item * PrimaryName


=item * PrimarySnapshotHostServiceId


=item * PrimarySnapshotName


=item * PrimarySnapshotUniqueId


=item * SecondaryQtreeId


=item * SecondaryQtreeName


=item * SecondaryQtreeNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SnapshotMemberInfo
   PrimaryId => $some_value, # ObjId
   PrimaryName => $some_value, # ObjName
   PrimarySnapshotHostServiceId =>  $some_value, # string
   PrimarySnapshotName =>  $some_value, # string
   PrimarySnapshotUniqueId =>  $some_value, # string
   SecondaryQtreeId => $some_value, # ObjId
   SecondaryQtreeName =>  $some_value, # string
   SecondaryQtreeNameOrId =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

