package MyTypes::SnapshotNameFormat;
use strict;
use warnings;

sub get_xmlns { 'http://www.netapp.com/management/v1'};

# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::string);



1;

__END__

=pod

=head1 NAME



=head1 DESCRIPTION

Perl data type class for the XML Schema defined simpleType
SnapshotNameFormat from the namespace http://www.netapp.com/management/v1.

Format string for creating Snapshot names. This string is free form text with substitution tokens. Allowed substitution tokens are: <ol> <li>%T: Scheduled creation time of Snapshot in format yyyy-mm-dd_hh.mm.ss<utc Offset>. The time is in the Dataset time zone and if no time zone is assigned To the Dataset, then default system time zone will be used. <utc Offset> is the Offset From utc in standard format (+hhmm or ?hhmm). For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). If the Timezone is "UTC" or "GMT", no Offset is included in the Name. <li>%R: Retention Type of Snapshot. Values are "hourly", "daily", "weekly" "monthly" or "unlimited". <li>%L: Dataset label (dl), previously called the Dataset prefix. This is the <b>VolumeQtreeNamePrefix</b> element specified in <b>DatasetCreate</b> or <b>DatasetModify</b>. If the Dataset label is not set, substitute the Dataset Name instead. <li>%H: Name of storage system which owns the Volume which will contain the Snapshot. <li>%N: Name of Volume which will contain the Snapshot. <li>%A: Application-specific data. When included, allow the utility, creating the Snapshot Name for the application, To embed any application specific data that the utility wants in the Snapshot Name. User has no control over what goes in this field. </ul> Format string can include any or all substitution tokens in any order. %T is mandatory.



This clase is derived from 
   SOAP::WSDL::XSD::Typelib::Builtin::string
. SOAP::WSDL's schema implementation does not validate data, so you can use it exactly
like it's base type.

# Description of restrictions not implemented yet.


=head1 METHODS

=head2 new

Constructor.

=head2 get_value / set_value

Getter and setter for the simpleType's value.

=head1 OVERLOADING

Depending on the simple type's base type, the following operations are overloaded

 Stringification
 Numerification
 Boolification

Check L<SOAP::WSDL::XSD::Typelib::Builtin> for more information.

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

