package MyTypes::SpaceCondition;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Condition_of :ATTR(:get<Condition>);
my %Reason_of :ATTR(:get<Reason>);
my %Severity_of :ATTR(:get<Severity>);
my %Suggestion_of :ATTR(:get<Suggestion>);

__PACKAGE__->_factory(
    [ qw(        Condition
        Reason
        Severity
        Suggestion

    ) ],
    {
        'Condition' => \%Condition_of,
        'Reason' => \%Reason_of,
        'Severity' => \%Severity_of,
        'Suggestion' => \%Suggestion_of,
    },
    {
        'Condition' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Severity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Condition' => 'Condition',
        'Reason' => 'Reason',
        'Severity' => 'Severity',
        'Suggestion' => 'Suggestion',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SpaceCondition

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceCondition from the namespace http://www.netapp.com/management/v1.

Represents a space Condition of a Dataset member.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Condition


=item * Reason


=item * Severity


=item * Suggestion




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceCondition
   Condition =>  $some_value, # string
   Reason =>  $some_value, # string
   Severity =>  $some_value, # string
   Suggestion =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

