package MyTypes::SpaceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AvailableSpace_of :ATTR(:get<AvailableSpace>);
my %SpaceConditions_of :ATTR(:get<SpaceConditions>);
my %SpaceStatus_of :ATTR(:get<SpaceStatus>);
my %TotalSpace_of :ATTR(:get<TotalSpace>);
my %UsedSpace_of :ATTR(:get<UsedSpace>);

__PACKAGE__->_factory(
    [ qw(        AvailableSpace
        SpaceConditions
        SpaceStatus
        TotalSpace
        UsedSpace

    ) ],
    {
        'AvailableSpace' => \%AvailableSpace_of,
        'SpaceConditions' => \%SpaceConditions_of,
        'SpaceStatus' => \%SpaceStatus_of,
        'TotalSpace' => \%TotalSpace_of,
        'UsedSpace' => \%UsedSpace_of,
    },
    {

        'AvailableSpace' => 'MyTypes::SpaceInfo::_AvailableSpace',
        'SpaceConditions' => 'MyTypes::ArrayOfSpaceCondition',
        'SpaceStatus' => 'MyTypes::SpaceStatus',

        'TotalSpace' => 'MyTypes::SpaceInfo::_TotalSpace',

        'UsedSpace' => 'MyTypes::SpaceInfo::_UsedSpace',
    },
    {

        'AvailableSpace' => 'AvailableSpace',
        'SpaceConditions' => 'SpaceConditions',
        'SpaceStatus' => 'SpaceStatus',
        'TotalSpace' => 'TotalSpace',
        'UsedSpace' => 'UsedSpace',
    }
);

} # end BLOCK




package MyTypes::SpaceInfo::_AvailableSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceInfo::_TotalSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceInfo::_UsedSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::SpaceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceInfo from the namespace http://www.netapp.com/management/v1.

Specifies the Total, available and used space in a Dataset member, the space Status and various space related conditions of the member.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AvailableSpace


=item * SpaceConditions


=item * SpaceStatus


=item * TotalSpace


=item * UsedSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceInfo
   AvailableSpace => $some_value, # atomic
   SpaceConditions =>  { # MyTypes::ArrayOfSpaceCondition
     SpaceCondition =>  { # MyTypes::SpaceCondition
       Condition =>  $some_value, # string
       Reason =>  $some_value, # string
       Severity =>  $some_value, # string
       Suggestion =>  $some_value, # string
     },
   },
   SpaceStatus => $some_value, # SpaceStatus
   TotalSpace => $some_value, # atomic
   UsedSpace => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

