package MyTypes::SpaceManagementOperationInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %BackupDeletionRequestInfo_of :ATTR(:get<BackupDeletionRequestInfo>);
my %DedupeRequestInfo_of :ATTR(:get<DedupeRequestInfo>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %ResizeVolumeRequestInfo_of :ATTR(:get<ResizeVolumeRequestInfo>);
my %SnapshotDeletionRequestInfo_of :ATTR(:get<SnapshotDeletionRequestInfo>);
my %SpaceManagementOpType_of :ATTR(:get<SpaceManagementOpType>);
my %VolumeMigrationRequestInfo_of :ATTR(:get<VolumeMigrationRequestInfo>);

__PACKAGE__->_factory(
    [ qw(        BackupDeletionRequestInfo
        DedupeRequestInfo
        ObjectNameOrId
        ResizeVolumeRequestInfo
        SnapshotDeletionRequestInfo
        SpaceManagementOpType
        VolumeMigrationRequestInfo

    ) ],
    {
        'BackupDeletionRequestInfo' => \%BackupDeletionRequestInfo_of,
        'DedupeRequestInfo' => \%DedupeRequestInfo_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'ResizeVolumeRequestInfo' => \%ResizeVolumeRequestInfo_of,
        'SnapshotDeletionRequestInfo' => \%SnapshotDeletionRequestInfo_of,
        'SpaceManagementOpType' => \%SpaceManagementOpType_of,
        'VolumeMigrationRequestInfo' => \%VolumeMigrationRequestInfo_of,
    },
    {
        'BackupDeletionRequestInfo' => 'MyTypes::BackupDeletionRequestInfo',
        'DedupeRequestInfo' => 'MyTypes::DedupeRequestInfo',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'ResizeVolumeRequestInfo' => 'MyTypes::ResizeVolumeRequestInfo',
        'SnapshotDeletionRequestInfo' => 'MyTypes::SnapshotDeletionRequestInfo',
        'SpaceManagementOpType' => 'MyTypes::SpaceManagementOpType',
        'VolumeMigrationRequestInfo' => 'MyTypes::VolumeMigrationRequestInfo',
    },
    {

        'BackupDeletionRequestInfo' => 'BackupDeletionRequestInfo',
        'DedupeRequestInfo' => 'DedupeRequestInfo',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'ResizeVolumeRequestInfo' => 'ResizeVolumeRequestInfo',
        'SnapshotDeletionRequestInfo' => 'SnapshotDeletionRequestInfo',
        'SpaceManagementOpType' => 'SpaceManagementOpType',
        'VolumeMigrationRequestInfo' => 'VolumeMigrationRequestInfo',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SpaceManagementOperationInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceManagementOperationInfo from the namespace http://www.netapp.com/management/v1.

Details of a space management Operation. Only one of the Request info in SpaceManagementOperationInfo should be sent in input.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * BackupDeletionRequestInfo


=item * DedupeRequestInfo


=item * ObjectNameOrId


=item * ResizeVolumeRequestInfo


=item * SnapshotDeletionRequestInfo


=item * SpaceManagementOpType


=item * VolumeMigrationRequestInfo




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceManagementOperationInfo
   BackupDeletionRequestInfo =>  { # MyTypes::BackupDeletionRequestInfo
     BackupIds =>  { # MyTypes::ArrayOfBackupId
       BackupId => $some_value, # BackupId
     },
   },
   DedupeRequestInfo =>  { # MyTypes::DedupeRequestInfo
     FullVolumeDedupe =>  $some_value, # boolean
   },
   ObjectNameOrId => $some_value, # ObjNameOrId
   ResizeVolumeRequestInfo =>  { # MyTypes::ResizeVolumeRequestInfo
     MaximumCapacity => $some_value, # atomic
     NewSize => $some_value, # atomic
     SnapReserve => $some_value, # atomic
   },
   SnapshotDeletionRequestInfo =>  { # MyTypes::SnapshotDeletionRequestInfo
     Snapshots =>  { # MyTypes::ArrayOfSnapshot
       Snapshot =>  { # MyTypes::Snapshot
         SnapshotName =>  $some_value, # string
         UniqueId =>  $some_value, # string
       },
     },
   },
   SpaceManagementOpType => $some_value, # SpaceManagementOpType
   VolumeMigrationRequestInfo =>  { # MyTypes::VolumeMigrationRequestInfo
     CleanupStaleStorage => $some_value, # CleanupStaleStorage
     DestinationAggregateNameOrId => $some_value, # ObjNameOrId
     RetentionType => $some_value, # DpBackupRetentionType
     RunDedupeScan =>  $some_value, # boolean
     RunOnDemandUpdate =>  $some_value, # boolean
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

