package MyTypes::SpaceManagementResultInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DryRunResults_of :ATTR(:get<DryRunResults>);
my %JobId_of :ATTR(:get<JobId>);
my %ObjectId_of :ATTR(:get<ObjectId>);
my %ObjectName_of :ATTR(:get<ObjectName>);
my %SpaceManagementOpType_of :ATTR(:get<SpaceManagementOpType>);

__PACKAGE__->_factory(
    [ qw(        DryRunResults
        JobId
        ObjectId
        ObjectName
        SpaceManagementOpType

    ) ],
    {
        'DryRunResults' => \%DryRunResults_of,
        'JobId' => \%JobId_of,
        'ObjectId' => \%ObjectId_of,
        'ObjectName' => \%ObjectName_of,
        'SpaceManagementOpType' => \%SpaceManagementOpType_of,
    },
    {
        'DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
        'JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ObjectId' => 'MyTypes::ObjId',
        'ObjectName' => 'MyTypes::ObjFullName',
        'SpaceManagementOpType' => 'MyTypes::SpaceManagementOpType',
    },
    {

        'DryRunResults' => 'DryRunResults',
        'JobId' => 'JobId',
        'ObjectId' => 'ObjectId',
        'ObjectName' => 'ObjectName',
        'SpaceManagementOpType' => 'SpaceManagementOpType',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SpaceManagementResultInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceManagementResultInfo from the namespace http://www.netapp.com/management/v1.

Results of the space management session.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DryRunResults


=item * JobId


=item * ObjectId


=item * ObjectName


=item * SpaceManagementOpType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceManagementResultInfo
   DryRunResults =>  { # MyTypes::ArrayOfDryRunResult
     DryRunResult =>  { # MyTypes::DryRunResult
       DryRunAction =>  $some_value, # string
       DryRunEffect =>  $some_value, # string
       DryRunReason =>  $some_value, # string
       DryRunReasonDetails =>  { # MyTypes::ArrayOfResultDetail
         ResultDetail =>  { # MyTypes::ResultDetail
           Action =>  $some_value, # string
           Effect =>  $some_value, # string
           Reason =>  $some_value, # string
           Severity => $some_value, # ObjStatus
           Suggestion =>  $some_value, # string
         },
       },
       DryRunSeverity => $some_value, # ObjStatus
       DryRunSuggestion =>  $some_value, # string
     },
   },
   JobId =>  $some_value, # integer
   ObjectId => $some_value, # ObjId
   ObjectName => $some_value, # ObjFullName
   SpaceManagementOpType => $some_value, # SpaceManagementOpType
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

