package MyTypes::SpaceMeasurement;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EffectiveUsedDataSpace_of :ATTR(:get<EffectiveUsedDataSpace>);
my %GuaranteedSpace_of :ATTR(:get<GuaranteedSpace>);
my %PhysicalUsedDataSpace_of :ATTR(:get<PhysicalUsedDataSpace>);
my %SnapshotReserve_of :ATTR(:get<SnapshotReserve>);
my %TotalDataSpace_of :ATTR(:get<TotalDataSpace>);
my %TotalSpace_of :ATTR(:get<TotalSpace>);
my %UsedSnapshotSpace_of :ATTR(:get<UsedSnapshotSpace>);

__PACKAGE__->_factory(
    [ qw(        EffectiveUsedDataSpace
        GuaranteedSpace
        PhysicalUsedDataSpace
        SnapshotReserve
        TotalDataSpace
        TotalSpace
        UsedSnapshotSpace

    ) ],
    {
        'EffectiveUsedDataSpace' => \%EffectiveUsedDataSpace_of,
        'GuaranteedSpace' => \%GuaranteedSpace_of,
        'PhysicalUsedDataSpace' => \%PhysicalUsedDataSpace_of,
        'SnapshotReserve' => \%SnapshotReserve_of,
        'TotalDataSpace' => \%TotalDataSpace_of,
        'TotalSpace' => \%TotalSpace_of,
        'UsedSnapshotSpace' => \%UsedSnapshotSpace_of,
    },
    {

        'EffectiveUsedDataSpace' => 'MyTypes::SpaceMeasurement::_EffectiveUsedDataSpace',

        'GuaranteedSpace' => 'MyTypes::SpaceMeasurement::_GuaranteedSpace',

        'PhysicalUsedDataSpace' => 'MyTypes::SpaceMeasurement::_PhysicalUsedDataSpace',

        'SnapshotReserve' => 'MyTypes::SpaceMeasurement::_SnapshotReserve',

        'TotalDataSpace' => 'MyTypes::SpaceMeasurement::_TotalDataSpace',

        'TotalSpace' => 'MyTypes::SpaceMeasurement::_TotalSpace',

        'UsedSnapshotSpace' => 'MyTypes::SpaceMeasurement::_UsedSnapshotSpace',
    },
    {

        'EffectiveUsedDataSpace' => 'EffectiveUsedDataSpace',
        'GuaranteedSpace' => 'GuaranteedSpace',
        'PhysicalUsedDataSpace' => 'PhysicalUsedDataSpace',
        'SnapshotReserve' => 'SnapshotReserve',
        'TotalDataSpace' => 'TotalDataSpace',
        'TotalSpace' => 'TotalSpace',
        'UsedSnapshotSpace' => 'UsedSnapshotSpace',
    }
);

} # end BLOCK




package MyTypes::SpaceMeasurement::_EffectiveUsedDataSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_GuaranteedSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_PhysicalUsedDataSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_SnapshotReserve;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_TotalDataSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_TotalSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::SpaceMeasurement::_UsedSnapshotSpace;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::SpaceMeasurement

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceMeasurement from the namespace http://www.netapp.com/management/v1.

Dataset node's space usage measurements.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EffectiveUsedDataSpace


=item * GuaranteedSpace


=item * PhysicalUsedDataSpace


=item * SnapshotReserve


=item * TotalDataSpace


=item * TotalSpace


=item * UsedSnapshotSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceMeasurement
   EffectiveUsedDataSpace => $some_value, # atomic
   GuaranteedSpace => $some_value, # atomic
   PhysicalUsedDataSpace => $some_value, # atomic
   SnapshotReserve => $some_value, # atomic
   TotalDataSpace => $some_value, # atomic
   TotalSpace => $some_value, # atomic
   UsedSnapshotSpace => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

