package MyTypes::SpaceStatusResult;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AvailSpace_of :ATTR(:get<AvailSpace>);
my %DestHost_of :ATTR(:get<DestHost>);
my %DestVol_of :ATTR(:get<DestVol>);
my %ReqSpace_of :ATTR(:get<ReqSpace>);

__PACKAGE__->_factory(
    [ qw(        AvailSpace
        DestHost
        DestVol
        ReqSpace

    ) ],
    {
        'AvailSpace' => \%AvailSpace_of,
        'DestHost' => \%DestHost_of,
        'DestVol' => \%DestVol_of,
        'ReqSpace' => \%ReqSpace_of,
    },
    {
        'AvailSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
        'DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DestVol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ReqSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
    },
    {

        'AvailSpace' => 'AvailSpace',
        'DestHost' => 'DestHost',
        'DestVol' => 'DestVol',
        'ReqSpace' => 'ReqSpace',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SpaceStatusResult

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SpaceStatusResult from the namespace http://www.netapp.com/management/v1.

Information about the destination Volume which does not have enough space for the restore




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AvailSpace


=item * DestHost


=item * DestVol


=item * ReqSpace




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SpaceStatusResult
   AvailSpace =>  $some_value, # unsignedLong
   DestHost =>  $some_value, # string
   DestVol =>  $some_value, # string
   ReqSpace =>  $some_value, # unsignedLong
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

