package MyTypes::StorageServiceDatasetInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetName_of :ATTR(:get<DatasetName>);
my %StorageServiceId_of :ATTR(:get<StorageServiceId>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);

__PACKAGE__->_factory(
    [ qw(        DatasetId
        DatasetName
        StorageServiceId
        StorageServiceName

    ) ],
    {
        'DatasetId' => \%DatasetId_of,
        'DatasetName' => \%DatasetName_of,
        'StorageServiceId' => \%StorageServiceId_of,
        'StorageServiceName' => \%StorageServiceName_of,
    },
    {
        'DatasetId' => 'MyTypes::ObjId',
        'DatasetName' => 'MyTypes::ObjName',
        'StorageServiceId' => 'MyTypes::ObjId',
        'StorageServiceName' => 'MyTypes::ObjName',
    },
    {

        'DatasetId' => 'DatasetId',
        'DatasetName' => 'DatasetName',
        'StorageServiceId' => 'StorageServiceId',
        'StorageServiceName' => 'StorageServiceName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::StorageServiceDatasetInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
StorageServiceDatasetInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetId


=item * DatasetName


=item * StorageServiceId


=item * StorageServiceName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::StorageServiceDatasetInfo
   DatasetId => $some_value, # ObjId
   DatasetName => $some_value, # ObjName
   StorageServiceId => $some_value, # ObjId
   StorageServiceName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

