package MyTypes::StorageServiceInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Datasets_of :ATTR(:get<Datasets>);
my %IsDrCapable_of :ATTR(:get<IsDrCapable>);
my %ProtectionPolicyId_of :ATTR(:get<ProtectionPolicyId>);
my %ProtectionPolicyName_of :ATTR(:get<ProtectionPolicyName>);
my %StorageServiceContact_of :ATTR(:get<StorageServiceContact>);
my %StorageServiceDescription_of :ATTR(:get<StorageServiceDescription>);
my %StorageServiceId_of :ATTR(:get<StorageServiceId>);
my %StorageServiceName_of :ATTR(:get<StorageServiceName>);
my %StorageServiceNodes_of :ATTR(:get<StorageServiceNodes>);
my %StorageServiceOwner_of :ATTR(:get<StorageServiceOwner>);

__PACKAGE__->_factory(
    [ qw(        Datasets
        IsDrCapable
        ProtectionPolicyId
        ProtectionPolicyName
        StorageServiceContact
        StorageServiceDescription
        StorageServiceId
        StorageServiceName
        StorageServiceNodes
        StorageServiceOwner

    ) ],
    {
        'Datasets' => \%Datasets_of,
        'IsDrCapable' => \%IsDrCapable_of,
        'ProtectionPolicyId' => \%ProtectionPolicyId_of,
        'ProtectionPolicyName' => \%ProtectionPolicyName_of,
        'StorageServiceContact' => \%StorageServiceContact_of,
        'StorageServiceDescription' => \%StorageServiceDescription_of,
        'StorageServiceId' => \%StorageServiceId_of,
        'StorageServiceName' => \%StorageServiceName_of,
        'StorageServiceNodes' => \%StorageServiceNodes_of,
        'StorageServiceOwner' => \%StorageServiceOwner_of,
    },
    {
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ProtectionPolicyId' => 'MyTypes::ObjId',
        'ProtectionPolicyName' => 'MyTypes::ObjName',
        'StorageServiceContact' => 'MyTypes::EmailAddressList',
        'StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'StorageServiceId' => 'MyTypes::ObjId',
        'StorageServiceName' => 'MyTypes::ObjName',
        'StorageServiceNodes' => 'MyTypes::ArrayOfStorageServiceNodeInfo',
        'StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Datasets' => 'Datasets',
        'IsDrCapable' => 'IsDrCapable',
        'ProtectionPolicyId' => 'ProtectionPolicyId',
        'ProtectionPolicyName' => 'ProtectionPolicyName',
        'StorageServiceContact' => 'StorageServiceContact',
        'StorageServiceDescription' => 'StorageServiceDescription',
        'StorageServiceId' => 'StorageServiceId',
        'StorageServiceName' => 'StorageServiceName',
        'StorageServiceNodes' => 'StorageServiceNodes',
        'StorageServiceOwner' => 'StorageServiceOwner',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::StorageServiceInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
StorageServiceInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Datasets


=item * IsDrCapable


=item * ProtectionPolicyId


=item * ProtectionPolicyName


=item * StorageServiceContact


=item * StorageServiceDescription


=item * StorageServiceId


=item * StorageServiceName


=item * StorageServiceNodes


=item * StorageServiceOwner




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::StorageServiceInfo
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   IsDrCapable =>  $some_value, # boolean
   ProtectionPolicyId => $some_value, # ObjId
   ProtectionPolicyName => $some_value, # ObjName
   StorageServiceContact => $some_value, # EmailAddressList
   StorageServiceDescription =>  $some_value, # string
   StorageServiceId => $some_value, # ObjId
   StorageServiceName => $some_value, # ObjName
   StorageServiceNodes =>  { # MyTypes::ArrayOfStorageServiceNodeInfo
     StorageServiceNodeInfo =>  { # MyTypes::StorageServiceNodeInfo
       DpNodeId => $some_value, # ObjId
       DpNodeName => $some_value, # ObjName
       ProvisioningPolicyId => $some_value, # ObjId
       ProvisioningPolicyName => $some_value, # ObjName
       Resourcepools =>  { # MyTypes::ArrayOfResourcepoolInfo
         ResourcepoolInfo =>  { # MyTypes::ResourcepoolInfo
           AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
           AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
           ResourceTag => $some_value, # ResourceTag
           ResourcepoolContact => $some_value, # EmailAddressList
           ResourcepoolDescription =>  $some_value, # string
           ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
           ResourcepoolFullThreshold => $some_value, # atomic
           ResourcepoolId =>  $some_value, # integer
           ResourcepoolIsProvisionable =>  $some_value, # boolean
           ResourcepoolKbytesAvailable => $some_value, # atomic
           ResourcepoolKbytesTotal => $some_value, # atomic
           ResourcepoolKbytesUsed => $some_value, # atomic
           ResourcepoolMemberCount => $some_value, # atomic
           ResourcepoolName =>  $some_value, # string
           ResourcepoolNearlyFullThreshold => $some_value, # atomic
           ResourcepoolOwner =>  $some_value, # string
           ResourcepoolPerfStatus => $some_value, # ObjStatus
           ResourcepoolSpaceStatus =>  $some_value, # string
           ResourcepoolStatus => $some_value, # ObjStatus
           ResourcepoolTimezone =>  $some_value, # string
         },
       },
       VfilerTemplateId => $some_value, # ObjId
       VfilerTemplateName => $some_value, # ObjName
     },
   },
   StorageServiceOwner =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

