package MyTypes::StorageServiceNodeAttributes;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %OldDpNodeName_of :ATTR(:get<OldDpNodeName>);
my %ProvisioningPolicyNameOrId_of :ATTR(:get<ProvisioningPolicyNameOrId>);
my %Resourcepools_of :ATTR(:get<Resourcepools>);
my %VfilerTemplateNameOrId_of :ATTR(:get<VfilerTemplateNameOrId>);

__PACKAGE__->_factory(
    [ qw(        DpNodeName
        OldDpNodeName
        ProvisioningPolicyNameOrId
        Resourcepools
        VfilerTemplateNameOrId

    ) ],
    {
        'DpNodeName' => \%DpNodeName_of,
        'OldDpNodeName' => \%OldDpNodeName_of,
        'ProvisioningPolicyNameOrId' => \%ProvisioningPolicyNameOrId_of,
        'Resourcepools' => \%Resourcepools_of,
        'VfilerTemplateNameOrId' => \%VfilerTemplateNameOrId_of,
    },
    {
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'OldDpNodeName' => 'MyTypes::DpPolicyNodeName',
        'ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
        'Resourcepools' => 'MyTypes::ArrayOfResourcepoolNameOrId',
        'VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'DpNodeName' => 'DpNodeName',
        'OldDpNodeName' => 'OldDpNodeName',
        'ProvisioningPolicyNameOrId' => 'ProvisioningPolicyNameOrId',
        'Resourcepools' => 'Resourcepools',
        'VfilerTemplateNameOrId' => 'VfilerTemplateNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::StorageServiceNodeAttributes

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
StorageServiceNodeAttributes from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DpNodeName


=item * OldDpNodeName


=item * ProvisioningPolicyNameOrId


=item * Resourcepools


=item * VfilerTemplateNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::StorageServiceNodeAttributes
   DpNodeName => $some_value, # DpPolicyNodeName
   OldDpNodeName => $some_value, # DpPolicyNodeName
   ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
   Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
     ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
   },
   VfilerTemplateNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

