package MyTypes::StorageSetInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatasetAccessDetails_of :ATTR(:get<DatasetAccessDetails>);
my %DatasetExportInfo_of :ATTR(:get<DatasetExportInfo>);
my %DpNodeName_of :ATTR(:get<DpNodeName>);
my %ServerNameOrId_of :ATTR(:get<ServerNameOrId>);
my %TimezoneName_of :ATTR(:get<TimezoneName>);

__PACKAGE__->_factory(
    [ qw(        DatasetAccessDetails
        DatasetExportInfo
        DpNodeName
        ServerNameOrId
        TimezoneName

    ) ],
    {
        'DatasetAccessDetails' => \%DatasetAccessDetails_of,
        'DatasetExportInfo' => \%DatasetExportInfo_of,
        'DpNodeName' => \%DpNodeName_of,
        'ServerNameOrId' => \%ServerNameOrId_of,
        'TimezoneName' => \%TimezoneName_of,
    },
    {
        'DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
        'DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
        'DpNodeName' => 'MyTypes::DpPolicyNodeName',
        'ServerNameOrId' => 'MyTypes::ObjNameOrId',
        'TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DatasetAccessDetails' => 'DatasetAccessDetails',
        'DatasetExportInfo' => 'DatasetExportInfo',
        'DpNodeName' => 'DpNodeName',
        'ServerNameOrId' => 'ServerNameOrId',
        'TimezoneName' => 'TimezoneName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::StorageSetInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
StorageSetInfo from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatasetAccessDetails


=item * DatasetExportInfo


=item * DpNodeName


=item * ServerNameOrId


=item * TimezoneName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::StorageSetInfo
   DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
     IpAddress =>  $some_value, # string
     Netmask =>  $some_value, # string
   },
   DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
     DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
       CifsDomain =>  $some_value, # string
       DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
         DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
           CifsUsername =>  $some_value, # string
           Permission => $some_value, # CifsPermission
         },
       },
     },
     DatasetExportProtocol => $some_value, # DatasetExportProtocol
     DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
       IgroupOsType =>  $some_value, # string
       LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
         LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
           Hostname =>  $some_value, # string
           InitiatorId => $some_value, # InitiatorId
         },
       },
     },
     DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
       AnonymousAccessUser => $some_value, # atomic
       DisableSetuid =>  $some_value, # boolean
       IsReadonlyForAllHosts =>  $some_value, # boolean
       IsReadwriteForAllHosts =>  $some_value, # boolean
       NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
         NfsExportHost =>  { # MyTypes::NfsExportHost
           Hostname =>  $some_value, # string
           IsAnException =>  $some_value, # boolean
         },
       },
       NfsProtocolVersion =>  $some_value, # string
       NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
         NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
       },
     },
   },
   DpNodeName => $some_value, # DpPolicyNodeName
   ServerNameOrId => $some_value, # ObjNameOrId
   TimezoneName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

