package MyTypes::StorageSystemConfiguration;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %LoginProtocol_of :ATTR(:get<LoginProtocol>);
my %PushCredentials_of :ATTR(:get<PushCredentials>);
my %StorageSystemNameOrId_of :ATTR(:get<StorageSystemNameOrId>);

__PACKAGE__->_factory(
    [ qw(        LoginProtocol
        PushCredentials
        StorageSystemNameOrId

    ) ],
    {
        'LoginProtocol' => \%LoginProtocol_of,
        'PushCredentials' => \%PushCredentials_of,
        'StorageSystemNameOrId' => \%StorageSystemNameOrId_of,
    },
    {
        'LoginProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'PushCredentials' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'StorageSystemNameOrId' => 'MyTypes::ObjNameOrId',
    },
    {

        'LoginProtocol' => 'LoginProtocol',
        'PushCredentials' => 'PushCredentials',
        'StorageSystemNameOrId' => 'StorageSystemNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::StorageSystemConfiguration

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
StorageSystemConfiguration from the namespace http://www.netapp.com/management/v1.

storage system configuration.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * LoginProtocol


=item * PushCredentials


=item * StorageSystemNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::StorageSystemConfiguration
   LoginProtocol =>  $some_value, # string
   PushCredentials =>  $some_value, # boolean
   StorageSystemNameOrId => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

