package MyTypes::TargetInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %TargetId_of :ATTR(:get<TargetId>);
my %TargetName_of :ATTR(:get<TargetName>);
my %TargetPortName_of :ATTR(:get<TargetPortName>);
my %TargetStatus_of :ATTR(:get<TargetStatus>);

__PACKAGE__->_factory(
    [ qw(        HostId
        HostName
        TargetId
        TargetName
        TargetPortName
        TargetStatus

    ) ],
    {
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'TargetId' => \%TargetId_of,
        'TargetName' => \%TargetName_of,
        'TargetPortName' => \%TargetPortName_of,
        'TargetStatus' => \%TargetStatus_of,
    },
    {
        'HostId' => 'MyTypes::ObjId',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TargetId' => 'MyTypes::ObjId',
        'TargetName' => 'MyTypes::ObjName',
        'TargetPortName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TargetStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'TargetId' => 'TargetId',
        'TargetName' => 'TargetName',
        'TargetPortName' => 'TargetPortName',
        'TargetStatus' => 'TargetStatus',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::TargetInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
TargetInfo from the namespace http://www.netapp.com/management/v1.

Information of about one Target.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostId


=item * HostName


=item * TargetId


=item * TargetName


=item * TargetPortName


=item * TargetStatus




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::TargetInfo
   HostId => $some_value, # ObjId
   HostName =>  $some_value, # string
   TargetId => $some_value, # ObjId
   TargetName => $some_value, # ObjName
   TargetPortName =>  $some_value, # string
   TargetStatus =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

