package MyTypes::ThresholdInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IsEnabled_of :ATTR(:get<IsEnabled>);
my %ObjectFullName_of :ATTR(:get<ObjectFullName>);
my %ObjectNameOrId_of :ATTR(:get<ObjectNameOrId>);
my %PerfObjectCounter_of :ATTR(:get<PerfObjectCounter>);
my %ThresholdId_of :ATTR(:get<ThresholdId>);
my %ThresholdInterval_of :ATTR(:get<ThresholdInterval>);
my %ThresholdType_of :ATTR(:get<ThresholdType>);
my %ThresholdUnit_of :ATTR(:get<ThresholdUnit>);
my %ThresholdValue_of :ATTR(:get<ThresholdValue>);

__PACKAGE__->_factory(
    [ qw(        IsEnabled
        ObjectFullName
        ObjectNameOrId
        PerfObjectCounter
        ThresholdId
        ThresholdInterval
        ThresholdType
        ThresholdUnit
        ThresholdValue

    ) ],
    {
        'IsEnabled' => \%IsEnabled_of,
        'ObjectFullName' => \%ObjectFullName_of,
        'ObjectNameOrId' => \%ObjectNameOrId_of,
        'PerfObjectCounter' => \%PerfObjectCounter_of,
        'ThresholdId' => \%ThresholdId_of,
        'ThresholdInterval' => \%ThresholdInterval_of,
        'ThresholdType' => \%ThresholdType_of,
        'ThresholdUnit' => \%ThresholdUnit_of,
        'ThresholdValue' => \%ThresholdValue_of,
    },
    {
        'IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectFullName' => 'MyTypes::ObjFullName',
        'ObjectNameOrId' => 'MyTypes::ObjNameOrId',
        'PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
        'ThresholdId' => 'MyTypes::ThresholdId',

        'ThresholdInterval' => 'MyTypes::ThresholdInfo::_ThresholdInterval',
        'ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ThresholdUnit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ThresholdValue' => 'MyTypes::ThresholdInfo::_ThresholdValue',
    },
    {

        'IsEnabled' => 'IsEnabled',
        'ObjectFullName' => 'ObjectFullName',
        'ObjectNameOrId' => 'ObjectNameOrId',
        'PerfObjectCounter' => 'PerfObjectCounter',
        'ThresholdId' => 'ThresholdId',
        'ThresholdInterval' => 'ThresholdInterval',
        'ThresholdType' => 'ThresholdType',
        'ThresholdUnit' => 'ThresholdUnit',
        'ThresholdValue' => 'ThresholdValue',
    }
);

} # end BLOCK




package MyTypes::ThresholdInfo::_ThresholdInterval;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThresholdInfo::_ThresholdValue;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ThresholdInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ThresholdInfo from the namespace http://www.netapp.com/management/v1.

Defines all the Attributes of a threshold.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IsEnabled


=item * ObjectFullName


=item * ObjectNameOrId


=item * PerfObjectCounter


=item * ThresholdId


=item * ThresholdInterval


=item * ThresholdType


=item * ThresholdUnit


=item * ThresholdValue




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ThresholdInfo
   IsEnabled =>  $some_value, # boolean
   ObjectFullName => $some_value, # ObjFullName
   ObjectNameOrId => $some_value, # ObjNameOrId
   PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
     CounterDescription =>  $some_value, # string
     CounterName =>  $some_value, # string
     IsCalculatedStats =>  $some_value, # boolean
     LabelNames =>  $some_value, # string
     Metrics =>  { # MyTypes::ArrayOfMetric
       Metric =>  { # MyTypes::Metric
         Id =>  $some_value, # string
         MetricResult =>  $some_value, # string
         Period => $some_value, # atomic
         Slide =>  $some_value, # string
         Type =>  $some_value, # string
         Value =>  $some_value, # string
       },
     },
     ObjectType =>  $some_value, # string
     PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
       PerfLabel =>  { # MyTypes::PerfLabel
         LabelNames =>  $some_value, # string
       },
     },
     TimeConsolidationMethod =>  $some_value, # string
   },
   ThresholdId => $some_value, # ThresholdId
   ThresholdInterval => $some_value, # atomic
   ThresholdType =>  $some_value, # string
   ThresholdUnit =>  $some_value, # string
   ThresholdValue => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

