package MyTypes::ThresholdInfo2;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CounterThresholds_of :ATTR(:get<CounterThresholds>);
my %IsEnabled_of :ATTR(:get<IsEnabled>);
my %IsIndirect_of :ATTR(:get<IsIndirect>);
my %ObjectsInfo_of :ATTR(:get<ObjectsInfo>);
my %ResourcePropertyConditions_of :ATTR(:get<ResourcePropertyConditions>);
my %TemplateId_of :ATTR(:get<TemplateId>);
my %TemplateName_of :ATTR(:get<TemplateName>);
my %ThresholdEventName_of :ATTR(:get<ThresholdEventName>);
my %ThresholdId_of :ATTR(:get<ThresholdId>);
my %ThresholdInterval_of :ATTR(:get<ThresholdInterval>);

__PACKAGE__->_factory(
    [ qw(        CounterThresholds
        IsEnabled
        IsIndirect
        ObjectsInfo
        ResourcePropertyConditions
        TemplateId
        TemplateName
        ThresholdEventName
        ThresholdId
        ThresholdInterval

    ) ],
    {
        'CounterThresholds' => \%CounterThresholds_of,
        'IsEnabled' => \%IsEnabled_of,
        'IsIndirect' => \%IsIndirect_of,
        'ObjectsInfo' => \%ObjectsInfo_of,
        'ResourcePropertyConditions' => \%ResourcePropertyConditions_of,
        'TemplateId' => \%TemplateId_of,
        'TemplateName' => \%TemplateName_of,
        'ThresholdEventName' => \%ThresholdEventName_of,
        'ThresholdId' => \%ThresholdId_of,
        'ThresholdInterval' => \%ThresholdInterval_of,
    },
    {
        'CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
        'IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
        'ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',

        'TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
        'TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ThresholdId' => 'MyTypes::ThresholdId',

        'ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
    },
    {

        'CounterThresholds' => 'CounterThresholds',
        'IsEnabled' => 'IsEnabled',
        'IsIndirect' => 'IsIndirect',
        'ObjectsInfo' => 'ObjectsInfo',
        'ResourcePropertyConditions' => 'ResourcePropertyConditions',
        'TemplateId' => 'TemplateId',
        'TemplateName' => 'TemplateName',
        'ThresholdEventName' => 'ThresholdEventName',
        'ThresholdId' => 'ThresholdId',
        'ThresholdInterval' => 'ThresholdInterval',
    }
);

} # end BLOCK




package MyTypes::ThresholdInfo2::_TemplateId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThresholdInfo2::_ThresholdInterval;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ThresholdInfo2

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ThresholdInfo2 from the namespace http://www.netapp.com/management/v1.

Defines a performance counter based threshold.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CounterThresholds


=item * IsEnabled


=item * IsIndirect


=item * ObjectsInfo


=item * ResourcePropertyConditions


=item * TemplateId


=item * TemplateName


=item * ThresholdEventName


=item * ThresholdId


=item * ThresholdInterval




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ThresholdInfo2
   CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
     CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
       PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
         CounterDescription =>  $some_value, # string
         CounterName =>  $some_value, # string
         IsCalculatedStats =>  $some_value, # boolean
         LabelNames =>  $some_value, # string
         Metrics =>  { # MyTypes::ArrayOfMetric
           Metric =>  { # MyTypes::Metric
             Id =>  $some_value, # string
             MetricResult =>  $some_value, # string
             Period => $some_value, # atomic
             Slide =>  $some_value, # string
             Type =>  $some_value, # string
             Value =>  $some_value, # string
           },
         },
         ObjectType =>  $some_value, # string
         PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
           PerfLabel =>  { # MyTypes::PerfLabel
             LabelNames =>  $some_value, # string
           },
         },
         TimeConsolidationMethod =>  $some_value, # string
       },
       ThresholdType =>  $some_value, # string
       ThresholdUnit => $some_value, # CounterUnit
       ThresholdValue =>  $some_value, # unsignedLong
     },
   },
   IsEnabled =>  $some_value, # boolean
   IsIndirect =>  $some_value, # boolean
   ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
     ObjectInfo =>  { # MyTypes::ObjectInfo
       ObjectFullName => $some_value, # ObjFullName
       ObjectId => $some_value, # ObjId
       ObjectName => $some_value, # ObjName
       ObjectType =>  $some_value, # string
     },
   },
   ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
     ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
       Name =>  $some_value, # string
       Value =>  $some_value, # string
     },
   },
   TemplateId => $some_value, # atomic
   TemplateName =>  $some_value, # string
   ThresholdEventName =>  $some_value, # string
   ThresholdId => $some_value, # ThresholdId
   ThresholdInterval => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

