package MyTypes::ThresholdTemplateInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AppliedObjects_of :ATTR(:get<AppliedObjects>);
my %IsEnabled_of :ATTR(:get<IsEnabled>);
my %MemberThresholds_of :ATTR(:get<MemberThresholds>);
my %TemplateDescription_of :ATTR(:get<TemplateDescription>);
my %TemplateId_of :ATTR(:get<TemplateId>);
my %TemplateName_of :ATTR(:get<TemplateName>);

__PACKAGE__->_factory(
    [ qw(        AppliedObjects
        IsEnabled
        MemberThresholds
        TemplateDescription
        TemplateId
        TemplateName

    ) ],
    {
        'AppliedObjects' => \%AppliedObjects_of,
        'IsEnabled' => \%IsEnabled_of,
        'MemberThresholds' => \%MemberThresholds_of,
        'TemplateDescription' => \%TemplateDescription_of,
        'TemplateId' => \%TemplateId_of,
        'TemplateName' => \%TemplateName_of,
    },
    {
        'AppliedObjects' => 'MyTypes::ArrayOfObjectInfo',
        'IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MemberThresholds' => 'MyTypes::ArrayOfThresholdInfo2',
        'TemplateDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'TemplateId' => 'MyTypes::ThresholdTemplateInfo::_TemplateId',
        'TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AppliedObjects' => 'AppliedObjects',
        'IsEnabled' => 'IsEnabled',
        'MemberThresholds' => 'MemberThresholds',
        'TemplateDescription' => 'TemplateDescription',
        'TemplateId' => 'TemplateId',
        'TemplateName' => 'TemplateName',
    }
);

} # end BLOCK




package MyTypes::ThresholdTemplateInfo::_TemplateId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ThresholdTemplateInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ThresholdTemplateInfo from the namespace http://www.netapp.com/management/v1.

Contains info on performance threshold templates




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AppliedObjects


=item * IsEnabled


=item * MemberThresholds


=item * TemplateDescription


=item * TemplateId


=item * TemplateName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ThresholdTemplateInfo
   AppliedObjects =>  { # MyTypes::ArrayOfObjectInfo
     ObjectInfo =>  { # MyTypes::ObjectInfo
       ObjectFullName => $some_value, # ObjFullName
       ObjectId => $some_value, # ObjId
       ObjectName => $some_value, # ObjName
       ObjectType =>  $some_value, # string
     },
   },
   IsEnabled =>  $some_value, # boolean
   MemberThresholds =>  { # MyTypes::ArrayOfThresholdInfo2
     ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
       CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
         CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
           PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
             CounterDescription =>  $some_value, # string
             CounterName =>  $some_value, # string
             IsCalculatedStats =>  $some_value, # boolean
             LabelNames =>  $some_value, # string
             Metrics =>  { # MyTypes::ArrayOfMetric
               Metric =>  { # MyTypes::Metric
                 Id =>  $some_value, # string
                 MetricResult =>  $some_value, # string
                 Period => $some_value, # atomic
                 Slide =>  $some_value, # string
                 Type =>  $some_value, # string
                 Value =>  $some_value, # string
               },
             },
             ObjectType =>  $some_value, # string
             PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
               PerfLabel =>  { # MyTypes::PerfLabel
                 LabelNames =>  $some_value, # string
               },
             },
             TimeConsolidationMethod =>  $some_value, # string
           },
           ThresholdType =>  $some_value, # string
           ThresholdUnit => $some_value, # CounterUnit
           ThresholdValue =>  $some_value, # unsignedLong
         },
       },
       IsEnabled =>  $some_value, # boolean
       IsIndirect =>  $some_value, # boolean
       ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
         ObjectInfo =>  { # MyTypes::ObjectInfo
           ObjectFullName => $some_value, # ObjFullName
           ObjectId => $some_value, # ObjId
           ObjectName => $some_value, # ObjName
           ObjectType =>  $some_value, # string
         },
       },
       ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
         ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
           Name =>  $some_value, # string
           Value =>  $some_value, # string
         },
       },
       TemplateId => $some_value, # atomic
       TemplateName =>  $some_value, # string
       ThresholdEventName =>  $some_value, # string
       ThresholdId => $some_value, # ThresholdId
       ThresholdInterval => $some_value, # atomic
     },
   },
   TemplateDescription =>  $some_value, # string
   TemplateId => $some_value, # atomic
   TemplateName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

