package MyTypes::ThrottleContent;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %IsModifiable_of :ATTR(:get<IsModifiable>);
my %ThrottleDescription_of :ATTR(:get<ThrottleDescription>);
my %ThrottleId_of :ATTR(:get<ThrottleId>);
my %ThrottleItemList_of :ATTR(:get<ThrottleItemList>);
my %ThrottleName_of :ATTR(:get<ThrottleName>);

__PACKAGE__->_factory(
    [ qw(        IsModifiable
        ThrottleDescription
        ThrottleId
        ThrottleItemList
        ThrottleName

    ) ],
    {
        'IsModifiable' => \%IsModifiable_of,
        'ThrottleDescription' => \%ThrottleDescription_of,
        'ThrottleId' => \%ThrottleId_of,
        'ThrottleItemList' => \%ThrottleItemList_of,
        'ThrottleName' => \%ThrottleName_of,
    },
    {
        'IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'ThrottleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'ThrottleId' => 'MyTypes::ThrottleContent::_ThrottleId',
        'ThrottleItemList' => 'MyTypes::ArrayOfThrottleItemInfo',
        'ThrottleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'IsModifiable' => 'IsModifiable',
        'ThrottleDescription' => 'ThrottleDescription',
        'ThrottleId' => 'ThrottleId',
        'ThrottleItemList' => 'ThrottleItemList',
        'ThrottleName' => 'ThrottleName',
    }
);

} # end BLOCK




package MyTypes::ThrottleContent::_ThrottleId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ThrottleContent

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ThrottleContent from the namespace http://www.netapp.com/management/v1.

Attributes of a throttle schedule




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * IsModifiable


=item * ThrottleDescription


=item * ThrottleId


=item * ThrottleItemList


=item * ThrottleName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ThrottleContent
   IsModifiable =>  $some_value, # boolean
   ThrottleDescription =>  $some_value, # string
   ThrottleId => $some_value, # atomic
   ThrottleItemList =>  { # MyTypes::ArrayOfThrottleItemInfo
     ThrottleItemInfo =>  { # MyTypes::ThrottleItemInfo
       DayList =>  { # MyTypes::ArrayOfDayInfo
         DayInfo =>  { # MyTypes::DayInfo
           Day => $some_value, # atomic
         },
       },
       EndHour => $some_value, # atomic
       EndMinute => $some_value, # atomic
       ItemId => $some_value, # atomic
       StartHour => $some_value, # atomic
       StartMinute => $some_value, # atomic
       Throughput => $some_value, # atomic
     },
   },
   ThrottleName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

