package MyTypes::ThrottleItemInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DayList_of :ATTR(:get<DayList>);
my %EndHour_of :ATTR(:get<EndHour>);
my %EndMinute_of :ATTR(:get<EndMinute>);
my %ItemId_of :ATTR(:get<ItemId>);
my %StartHour_of :ATTR(:get<StartHour>);
my %StartMinute_of :ATTR(:get<StartMinute>);
my %Throughput_of :ATTR(:get<Throughput>);

__PACKAGE__->_factory(
    [ qw(        DayList
        EndHour
        EndMinute
        ItemId
        StartHour
        StartMinute
        Throughput

    ) ],
    {
        'DayList' => \%DayList_of,
        'EndHour' => \%EndHour_of,
        'EndMinute' => \%EndMinute_of,
        'ItemId' => \%ItemId_of,
        'StartHour' => \%StartHour_of,
        'StartMinute' => \%StartMinute_of,
        'Throughput' => \%Throughput_of,
    },
    {
        'DayList' => 'MyTypes::ArrayOfDayInfo',

        'EndHour' => 'MyTypes::ThrottleItemInfo::_EndHour',

        'EndMinute' => 'MyTypes::ThrottleItemInfo::_EndMinute',

        'ItemId' => 'MyTypes::ThrottleItemInfo::_ItemId',

        'StartHour' => 'MyTypes::ThrottleItemInfo::_StartHour',

        'StartMinute' => 'MyTypes::ThrottleItemInfo::_StartMinute',

        'Throughput' => 'MyTypes::ThrottleItemInfo::_Throughput',
    },
    {

        'DayList' => 'DayList',
        'EndHour' => 'EndHour',
        'EndMinute' => 'EndMinute',
        'ItemId' => 'ItemId',
        'StartHour' => 'StartHour',
        'StartMinute' => 'StartMinute',
        'Throughput' => 'Throughput',
    }
);

} # end BLOCK




package MyTypes::ThrottleItemInfo::_EndHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThrottleItemInfo::_EndMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThrottleItemInfo::_ItemId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThrottleItemInfo::_StartHour;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThrottleItemInfo::_StartMinute;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::ThrottleItemInfo::_Throughput;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::ThrottleItemInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ThrottleItemInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a throttle item




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DayList


=item * EndHour


=item * EndMinute


=item * ItemId


=item * StartHour


=item * StartMinute


=item * Throughput




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ThrottleItemInfo
   DayList =>  { # MyTypes::ArrayOfDayInfo
     DayInfo =>  { # MyTypes::DayInfo
       Day => $some_value, # atomic
     },
   },
   EndHour => $some_value, # atomic
   EndMinute => $some_value, # atomic
   ItemId => $some_value, # atomic
   StartHour => $some_value, # atomic
   StartMinute => $some_value, # atomic
   Throughput => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

