package MyTypes::TimeFilter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Days_of :ATTR(:get<Days>);
my %Months_of :ATTR(:get<Months>);
my %TimeRanges_of :ATTR(:get<TimeRanges>);

__PACKAGE__->_factory(
    [ qw(        Days
        Months
        TimeRanges

    ) ],
    {
        'Days' => \%Days_of,
        'Months' => \%Months_of,
        'TimeRanges' => \%TimeRanges_of,
    },
    {
        'Days' => 'MyTypes::ArrayOfDay',
        'Months' => 'MyTypes::ArrayOfMonth',
        'TimeRanges' => 'MyTypes::ArrayOfTimeRange',
    },
    {

        'Days' => 'Days',
        'Months' => 'Months',
        'TimeRanges' => 'TimeRanges',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::TimeFilter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
TimeFilter from the namespace http://www.netapp.com/management/v1.

Filter data based on selected time range.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Days


=item * Months


=item * TimeRanges




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::TimeFilter
   Days =>  { # MyTypes::ArrayOfDay
     Day => $some_value, # Day
   },
   Months =>  { # MyTypes::ArrayOfMonth
     Month => $some_value, # Month
   },
   TimeRanges =>  { # MyTypes::ArrayOfTimeRange
     TimeRange =>  { # MyTypes::TimeRange
       From => $some_value, # atomic
       To => $some_value, # atomic
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

