package MyTypes::TimesOfDayInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EndTime_of :ATTR(:get<EndTime>);
my %Frequency_of :ATTR(:get<Frequency>);
my %StartTime_of :ATTR(:get<StartTime>);

__PACKAGE__->_factory(
    [ qw(        EndTime
        Frequency
        StartTime

    ) ],
    {
        'EndTime' => \%EndTime_of,
        'Frequency' => \%Frequency_of,
        'StartTime' => \%StartTime_of,
    },
    {
        'EndTime' => 'MyTypes::WrapperOfTimeOfDayInfo',

        'Frequency' => 'MyTypes::TimesOfDayInfo::_Frequency',
        'StartTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
    },
    {

        'EndTime' => 'EndTime',
        'Frequency' => 'Frequency',
        'StartTime' => 'StartTime',
    }
);

} # end BLOCK




package MyTypes::TimesOfDayInfo::_Frequency;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::TimesOfDayInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
TimesOfDayInfo from the namespace http://www.netapp.com/management/v1.

Times of Day on which the scheduled event occurs.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EndTime


=item * Frequency


=item * StartTime




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::TimesOfDayInfo
   EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
     TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
       Hour => $some_value, # atomic
       Minute => $some_value, # atomic
     },
   },
   Frequency => $some_value, # atomic
   StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
     TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
       Hour => $some_value, # atomic
       Minute => $some_value, # atomic
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

