package MyTypes::TimezoneDefaults;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DefaultTimezone_of :ATTR(:get<DefaultTimezone>);
my %ServerTimezoneDescription_of :ATTR(:get<ServerTimezoneDescription>);

__PACKAGE__->_factory(
    [ qw(        DefaultTimezone
        ServerTimezoneDescription

    ) ],
    {
        'DefaultTimezone' => \%DefaultTimezone_of,
        'ServerTimezoneDescription' => \%ServerTimezoneDescription_of,
    },
    {
        'DefaultTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'ServerTimezoneDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'DefaultTimezone' => 'DefaultTimezone',
        'ServerTimezoneDescription' => 'ServerTimezoneDescription',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::TimezoneDefaults

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
TimezoneDefaults from the namespace http://www.netapp.com/management/v1.

The default time zone settings.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DefaultTimezone


=item * ServerTimezoneDescription




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::TimezoneDefaults
   DefaultTimezone =>  $some_value, # string
   ServerTimezoneDescription =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

