package MyTypes::TrapDestination;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %TrapCommunity_of :ATTR(:get<TrapCommunity>);
my %TrapHost_of :ATTR(:get<TrapHost>);
my %TrapPort_of :ATTR(:get<TrapPort>);

__PACKAGE__->_factory(
    [ qw(        TrapCommunity
        TrapHost
        TrapPort

    ) ],
    {
        'TrapCommunity' => \%TrapCommunity_of,
        'TrapHost' => \%TrapHost_of,
        'TrapPort' => \%TrapPort_of,
    },
    {
        'TrapCommunity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'TrapHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'TrapPort' => 'MyTypes::TrapDestination::_TrapPort',
    },
    {

        'TrapCommunity' => 'TrapCommunity',
        'TrapHost' => 'TrapHost',
        'TrapPort' => 'TrapPort',
    }
);

} # end BLOCK




package MyTypes::TrapDestination::_TrapPort;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::TrapDestination

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
TrapDestination from the namespace http://www.netapp.com/management/v1.

Destination parameters for a SNMP trap.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * TrapCommunity


=item * TrapHost


=item * TrapPort




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::TrapDestination
   TrapCommunity =>  $some_value, # string
   TrapHost =>  $some_value, # string
   TrapPort => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

