package MyTypes::UserReportInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Count_of :ATTR(:get<Count>);
my %UserName_of :ATTR(:get<UserName>);

__PACKAGE__->_factory(
    [ qw(        Count
        UserName

    ) ],
    {
        'Count' => \%Count_of,
        'UserName' => \%UserName_of,
    },
    {
        'Count' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'Count' => 'Count',
        'UserName' => 'UserName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::UserReportInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
UserReportInfo from the namespace http://www.netapp.com/management/v1.

Report Count of users.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Count


=item * UserName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::UserReportInfo
   Count =>  $some_value, # integer
   UserName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

