package MyTypes::VersionMemberInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostAddress_of :ATTR(:get<HostAddress>);
my %HostFqdn_of :ATTR(:get<HostFqdn>);
my %HostId_of :ATTR(:get<HostId>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %SnapshotContents_of :ATTR(:get<SnapshotContents>);
my %SnapshotName_of :ATTR(:get<SnapshotName>);
my %SnapshotUniqueId_of :ATTR(:get<SnapshotUniqueId>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        HostAddress
        HostFqdn
        HostId
        IsAvailable
        SnapshotContents
        SnapshotName
        SnapshotUniqueId
        VolumeId
        VolumeName

    ) ],
    {
        'HostAddress' => \%HostAddress_of,
        'HostFqdn' => \%HostFqdn_of,
        'HostId' => \%HostId_of,
        'IsAvailable' => \%IsAvailable_of,
        'SnapshotContents' => \%SnapshotContents_of,
        'SnapshotName' => \%SnapshotName_of,
        'SnapshotUniqueId' => \%SnapshotUniqueId_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'HostAddress' => 'MyTypes::IpAddress',
        'HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostId' => 'MyTypes::ObjId',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'SnapshotContents' => 'MyTypes::ArrayOfSnapshotMemberInfo',
        'SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeId' => 'MyTypes::ObjId',
        'VolumeName' => 'MyTypes::ObjName',
    },
    {

        'HostAddress' => 'HostAddress',
        'HostFqdn' => 'HostFqdn',
        'HostId' => 'HostId',
        'IsAvailable' => 'IsAvailable',
        'SnapshotContents' => 'SnapshotContents',
        'SnapshotName' => 'SnapshotName',
        'SnapshotUniqueId' => 'SnapshotUniqueId',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VersionMemberInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VersionMemberInfo from the namespace http://www.netapp.com/management/v1.

Describes one Snapshot member of a backup Version.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostAddress


=item * HostFqdn


=item * HostId


=item * IsAvailable


=item * SnapshotContents


=item * SnapshotName


=item * SnapshotUniqueId


=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VersionMemberInfo
   HostAddress => $some_value, # IpAddress
   HostFqdn =>  $some_value, # string
   HostId => $some_value, # ObjId
   IsAvailable =>  $some_value, # boolean
   SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
     SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
       PrimaryId => $some_value, # ObjId
       PrimaryName => $some_value, # ObjName
       PrimarySnapshotHostServiceId =>  $some_value, # string
       PrimarySnapshotName =>  $some_value, # string
       PrimarySnapshotUniqueId =>  $some_value, # string
       SecondaryQtreeId => $some_value, # ObjId
       SecondaryQtreeName =>  $some_value, # string
       SecondaryQtreeNameOrId =>  $some_value, # string
     },
   },
   SnapshotName =>  $some_value, # string
   SnapshotUniqueId =>  $some_value, # string
   VolumeId => $some_value, # ObjId
   VolumeName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

