package MyTypes::VfilerInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %HostingFilerId_of :ATTR(:get<HostingFilerId>);
my %HostingFilerName_of :ATTR(:get<HostingFilerName>);
my %VfilerAllowedProtocols_of :ATTR(:get<VfilerAllowedProtocols>);
my %VfilerIpspace_of :ATTR(:get<VfilerIpspace>);
my %VfilerMigrationInfo_of :ATTR(:get<VfilerMigrationInfo>);
my %VfilerNetworkResources_of :ATTR(:get<VfilerNetworkResources>);

__PACKAGE__->_factory(
    [ qw(        HostingFilerId
        HostingFilerName
        VfilerAllowedProtocols
        VfilerIpspace
        VfilerMigrationInfo
        VfilerNetworkResources

    ) ],
    {
        'HostingFilerId' => \%HostingFilerId_of,
        'HostingFilerName' => \%HostingFilerName_of,
        'VfilerAllowedProtocols' => \%VfilerAllowedProtocols_of,
        'VfilerIpspace' => \%VfilerIpspace_of,
        'VfilerMigrationInfo' => \%VfilerMigrationInfo_of,
        'VfilerNetworkResources' => \%VfilerNetworkResources_of,
    },
    {
        'HostingFilerId' => 'MyTypes::ObjId',
        'HostingFilerName' => 'MyTypes::ObjFullName',
        'VfilerAllowedProtocols' => 'MyTypes::ArrayOfProtocol',
        'VfilerIpspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VfilerMigrationInfo' => 'MyTypes::VfilerMigrationInfo',
        'VfilerNetworkResources' => 'MyTypes::ArrayOfVfilerNetworkResource',
    },
    {

        'HostingFilerId' => 'HostingFilerId',
        'HostingFilerName' => 'HostingFilerName',
        'VfilerAllowedProtocols' => 'VfilerAllowedProtocols',
        'VfilerIpspace' => 'VfilerIpspace',
        'VfilerMigrationInfo' => 'VfilerMigrationInfo',
        'VfilerNetworkResources' => 'VfilerNetworkResources',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerInfo from the namespace http://www.netapp.com/management/v1.

information of a vFiler Unit. Avaiblable only if HostType is "Vfiler".




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * HostingFilerId


=item * HostingFilerName


=item * VfilerAllowedProtocols


=item * VfilerIpspace


=item * VfilerMigrationInfo


=item * VfilerNetworkResources




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerInfo
   HostingFilerId => $some_value, # ObjId
   HostingFilerName => $some_value, # ObjFullName
   VfilerAllowedProtocols =>  { # MyTypes::ArrayOfProtocol
     Protocol => $some_value, # Protocol
   },
   VfilerIpspace =>  $some_value, # string
   VfilerMigrationInfo =>  { # MyTypes::VfilerMigrationInfo
     DestinationFilerId => $some_value, # ObjId
     DestinationFilerName => $some_value, # ObjFullName
     DestinationVfilerId => $some_value, # ObjId
     DestinationVfilerName => $some_value, # ObjFullName
     MigrationStatus => $some_value, # MigrationStatus
     SourceFilerId => $some_value, # ObjId
     SourceFilerName => $some_value, # ObjFullName
     SourceVfilerId => $some_value, # ObjId
     SourceVfilerName => $some_value, # ObjFullName
   },
   VfilerNetworkResources =>  { # MyTypes::ArrayOfVfilerNetworkResource
     VfilerNetworkResource =>  { # MyTypes::VfilerNetworkResource
       InterfaceId => $some_value, # ObjId
       InterfaceName => $some_value, # ObjName
       IpAddress => $some_value, # IpAddress
       MtuSize =>  $some_value, # integer
       PrefixLength =>  $some_value, # integer
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

