package MyTypes::VfilerMigrationInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DestinationFilerId_of :ATTR(:get<DestinationFilerId>);
my %DestinationFilerName_of :ATTR(:get<DestinationFilerName>);
my %DestinationVfilerId_of :ATTR(:get<DestinationVfilerId>);
my %DestinationVfilerName_of :ATTR(:get<DestinationVfilerName>);
my %MigrationStatus_of :ATTR(:get<MigrationStatus>);
my %SourceFilerId_of :ATTR(:get<SourceFilerId>);
my %SourceFilerName_of :ATTR(:get<SourceFilerName>);
my %SourceVfilerId_of :ATTR(:get<SourceVfilerId>);
my %SourceVfilerName_of :ATTR(:get<SourceVfilerName>);

__PACKAGE__->_factory(
    [ qw(        DestinationFilerId
        DestinationFilerName
        DestinationVfilerId
        DestinationVfilerName
        MigrationStatus
        SourceFilerId
        SourceFilerName
        SourceVfilerId
        SourceVfilerName

    ) ],
    {
        'DestinationFilerId' => \%DestinationFilerId_of,
        'DestinationFilerName' => \%DestinationFilerName_of,
        'DestinationVfilerId' => \%DestinationVfilerId_of,
        'DestinationVfilerName' => \%DestinationVfilerName_of,
        'MigrationStatus' => \%MigrationStatus_of,
        'SourceFilerId' => \%SourceFilerId_of,
        'SourceFilerName' => \%SourceFilerName_of,
        'SourceVfilerId' => \%SourceVfilerId_of,
        'SourceVfilerName' => \%SourceVfilerName_of,
    },
    {
        'DestinationFilerId' => 'MyTypes::ObjId',
        'DestinationFilerName' => 'MyTypes::ObjFullName',
        'DestinationVfilerId' => 'MyTypes::ObjId',
        'DestinationVfilerName' => 'MyTypes::ObjFullName',
        'MigrationStatus' => 'MyTypes::MigrationStatus',
        'SourceFilerId' => 'MyTypes::ObjId',
        'SourceFilerName' => 'MyTypes::ObjFullName',
        'SourceVfilerId' => 'MyTypes::ObjId',
        'SourceVfilerName' => 'MyTypes::ObjFullName',
    },
    {

        'DestinationFilerId' => 'DestinationFilerId',
        'DestinationFilerName' => 'DestinationFilerName',
        'DestinationVfilerId' => 'DestinationVfilerId',
        'DestinationVfilerName' => 'DestinationVfilerName',
        'MigrationStatus' => 'MigrationStatus',
        'SourceFilerId' => 'SourceFilerId',
        'SourceFilerName' => 'SourceFilerName',
        'SourceVfilerId' => 'SourceVfilerId',
        'SourceVfilerName' => 'SourceVfilerName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerMigrationInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerMigrationInfo from the namespace http://www.netapp.com/management/v1.

Migration information for a vFiler Unit.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DestinationFilerId


=item * DestinationFilerName


=item * DestinationVfilerId


=item * DestinationVfilerName


=item * MigrationStatus


=item * SourceFilerId


=item * SourceFilerName


=item * SourceVfilerId


=item * SourceVfilerName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerMigrationInfo
   DestinationFilerId => $some_value, # ObjId
   DestinationFilerName => $some_value, # ObjFullName
   DestinationVfilerId => $some_value, # ObjId
   DestinationVfilerName => $some_value, # ObjFullName
   MigrationStatus => $some_value, # MigrationStatus
   SourceFilerId => $some_value, # ObjId
   SourceFilerName => $some_value, # ObjFullName
   SourceVfilerId => $some_value, # ObjId
   SourceVfilerName => $some_value, # ObjFullName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

