package MyTypes::VfilerNetworkResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %InterfaceId_of :ATTR(:get<InterfaceId>);
my %InterfaceName_of :ATTR(:get<InterfaceName>);
my %IpAddress_of :ATTR(:get<IpAddress>);
my %MtuSize_of :ATTR(:get<MtuSize>);
my %PrefixLength_of :ATTR(:get<PrefixLength>);

__PACKAGE__->_factory(
    [ qw(        InterfaceId
        InterfaceName
        IpAddress
        MtuSize
        PrefixLength

    ) ],
    {
        'InterfaceId' => \%InterfaceId_of,
        'InterfaceName' => \%InterfaceName_of,
        'IpAddress' => \%IpAddress_of,
        'MtuSize' => \%MtuSize_of,
        'PrefixLength' => \%PrefixLength_of,
    },
    {
        'InterfaceId' => 'MyTypes::ObjId',
        'InterfaceName' => 'MyTypes::ObjName',
        'IpAddress' => 'MyTypes::IpAddress',
        'MtuSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'PrefixLength' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'InterfaceId' => 'InterfaceId',
        'InterfaceName' => 'InterfaceName',
        'IpAddress' => 'IpAddress',
        'MtuSize' => 'MtuSize',
        'PrefixLength' => 'PrefixLength',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerNetworkResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerNetworkResource from the namespace http://www.netapp.com/management/v1.

Information about one vFiler Unit IP Address




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * InterfaceId


=item * InterfaceName


=item * IpAddress


=item * MtuSize


=item * PrefixLength




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerNetworkResource
   InterfaceId => $some_value, # ObjId
   InterfaceName => $some_value, # ObjName
   IpAddress => $some_value, # IpAddress
   MtuSize =>  $some_value, # integer
   PrefixLength =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

