package MyTypes::VfilerResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VfilerId_of :ATTR(:get<VfilerId>);
my %VfilerNameOrUuid_of :ATTR(:get<VfilerNameOrUuid>);

__PACKAGE__->_factory(
    [ qw(        VfilerId
        VfilerNameOrUuid

    ) ],
    {
        'VfilerId' => \%VfilerId_of,
        'VfilerNameOrUuid' => \%VfilerNameOrUuid_of,
    },
    {
        'VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'VfilerId' => 'VfilerId',
        'VfilerNameOrUuid' => 'VfilerNameOrUuid',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerResource from the namespace http://www.netapp.com/management/v1.

Details of a Vfiler Resource. When used as input only one of VfilerNameOrUuid or VfilerId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VfilerId


=item * VfilerNameOrUuid




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerResource
   VfilerId =>  $some_value, # unsignedInt
   VfilerNameOrUuid =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

