package MyTypes::VfilerTemplateInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AdministrativeHostIpAddress_of :ATTR(:get<AdministrativeHostIpAddress>);
my %CifsAuthType_of :ATTR(:get<CifsAuthType>);
my %CifsDomain_of :ATTR(:get<CifsDomain>);
my %CifsSecurityStyle_of :ATTR(:get<CifsSecurityStyle>);
my %Description_of :ATTR(:get<Description>);
my %DnsDomain_of :ATTR(:get<DnsDomain>);
my %DnsServers_of :ATTR(:get<DnsServers>);
my %NisDomain_of :ATTR(:get<NisDomain>);
my %NisServers_of :ATTR(:get<NisServers>);
my %VfilerTemplateId_of :ATTR(:get<VfilerTemplateId>);
my %VfilerTemplateName_of :ATTR(:get<VfilerTemplateName>);

__PACKAGE__->_factory(
    [ qw(        AdministrativeHostIpAddress
        CifsAuthType
        CifsDomain
        CifsSecurityStyle
        Description
        DnsDomain
        DnsServers
        NisDomain
        NisServers
        VfilerTemplateId
        VfilerTemplateName

    ) ],
    {
        'AdministrativeHostIpAddress' => \%AdministrativeHostIpAddress_of,
        'CifsAuthType' => \%CifsAuthType_of,
        'CifsDomain' => \%CifsDomain_of,
        'CifsSecurityStyle' => \%CifsSecurityStyle_of,
        'Description' => \%Description_of,
        'DnsDomain' => \%DnsDomain_of,
        'DnsServers' => \%DnsServers_of,
        'NisDomain' => \%NisDomain_of,
        'NisServers' => \%NisServers_of,
        'VfilerTemplateId' => \%VfilerTemplateId_of,
        'VfilerTemplateName' => \%VfilerTemplateName_of,
    },
    {
        'AdministrativeHostIpAddress' => 'MyTypes::IpAddress',
        'CifsAuthType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'CifsSecurityStyle' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DnsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DnsServers' => 'MyTypes::ArrayOfIpAddress',
        'NisDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'NisServers' => 'MyTypes::ArrayOfIpAddress',
        'VfilerTemplateId' => 'MyTypes::ObjId',
        'VfilerTemplateName' => 'MyTypes::ObjName',
    },
    {

        'AdministrativeHostIpAddress' => 'AdministrativeHostIpAddress',
        'CifsAuthType' => 'CifsAuthType',
        'CifsDomain' => 'CifsDomain',
        'CifsSecurityStyle' => 'CifsSecurityStyle',
        'Description' => 'Description',
        'DnsDomain' => 'DnsDomain',
        'DnsServers' => 'DnsServers',
        'NisDomain' => 'NisDomain',
        'NisServers' => 'NisServers',
        'VfilerTemplateId' => 'VfilerTemplateId',
        'VfilerTemplateName' => 'VfilerTemplateName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerTemplateInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerTemplateInfo from the namespace http://www.netapp.com/management/v1.

Information about a vFiler Template.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AdministrativeHostIpAddress


=item * CifsAuthType


=item * CifsDomain


=item * CifsSecurityStyle


=item * Description


=item * DnsDomain


=item * DnsServers


=item * NisDomain


=item * NisServers


=item * VfilerTemplateId


=item * VfilerTemplateName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerTemplateInfo
   AdministrativeHostIpAddress => $some_value, # IpAddress
   CifsAuthType =>  $some_value, # string
   CifsDomain =>  $some_value, # string
   CifsSecurityStyle =>  $some_value, # string
   Description =>  $some_value, # string
   DnsDomain =>  $some_value, # string
   DnsServers =>  { # MyTypes::ArrayOfIpAddress
     IpAddress => $some_value, # IpAddress
   },
   NisDomain =>  $some_value, # string
   NisServers =>  { # MyTypes::ArrayOfIpAddress
     IpAddress => $some_value, # IpAddress
   },
   VfilerTemplateId => $some_value, # ObjId
   VfilerTemplateName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

