package MyTypes::VfilerTemplateResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VfilerTemplateId_of :ATTR(:get<VfilerTemplateId>);
my %VfilerTemplateName_of :ATTR(:get<VfilerTemplateName>);

__PACKAGE__->_factory(
    [ qw(        VfilerTemplateId
        VfilerTemplateName

    ) ],
    {
        'VfilerTemplateId' => \%VfilerTemplateId_of,
        'VfilerTemplateName' => \%VfilerTemplateName_of,
    },
    {
        'VfilerTemplateId' => 'MyTypes::ObjId',
        'VfilerTemplateName' => 'MyTypes::ObjName',
    },
    {

        'VfilerTemplateId' => 'VfilerTemplateId',
        'VfilerTemplateName' => 'VfilerTemplateName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VfilerTemplateResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VfilerTemplateResource from the namespace http://www.netapp.com/management/v1.

Identifies a Vfiler template Resource. When used as input only one of VfilerTemplateName or VfilerTemplateId is specified. When used as output, both of them will be returned.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VfilerTemplateId


=item * VfilerTemplateName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VfilerTemplateResource
   VfilerTemplateId => $some_value, # ObjId
   VfilerTemplateName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

