package MyTypes::VirtualCenter;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %VirtualCenterId_of :ATTR(:get<VirtualCenterId>);
my %VirtualCenterName_of :ATTR(:get<VirtualCenterName>);

__PACKAGE__->_factory(
    [ qw(        DeletedBy
        DeletedTimestamp
        HostServiceId
        VirtualCenterId
        VirtualCenterName

    ) ],
    {
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'HostServiceId' => \%HostServiceId_of,
        'VirtualCenterId' => \%VirtualCenterId_of,
        'VirtualCenterName' => \%VirtualCenterName_of,
    },
    {
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'HostServiceId' => 'MyTypes::ObjId',
        'VirtualCenterId' => 'MyTypes::ObjId',
        'VirtualCenterName' => 'MyTypes::ObjName',
    },
    {

        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'HostServiceId' => 'HostServiceId',
        'VirtualCenterId' => 'VirtualCenterId',
        'VirtualCenterName' => 'VirtualCenterName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VirtualCenter

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VirtualCenter from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DeletedBy


=item * DeletedTimestamp


=item * HostServiceId


=item * VirtualCenterId


=item * VirtualCenterName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VirtualCenter
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   HostServiceId => $some_value, # ObjId
   VirtualCenterId => $some_value, # ObjId
   VirtualCenterName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

