package MyTypes::VirtualDisk;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatastoreId_of :ATTR(:get<DatastoreId>);
my %DatastoreName_of :ATTR(:get<DatastoreName>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %VhdType_of :ATTR(:get<VhdType>);
my %VirtualDiskId_of :ATTR(:get<VirtualDiskId>);
my %VirtualDiskName_of :ATTR(:get<VirtualDiskName>);
my %VirtualInfrastructureType_of :ATTR(:get<VirtualInfrastructureType>);
my %VirtualMachineId_of :ATTR(:get<VirtualMachineId>);
my %VirtualMachineName_of :ATTR(:get<VirtualMachineName>);

__PACKAGE__->_factory(
    [ qw(        DatastoreId
        DatastoreName
        DeletedBy
        DeletedTimestamp
        HostServiceId
        VhdType
        VirtualDiskId
        VirtualDiskName
        VirtualInfrastructureType
        VirtualMachineId
        VirtualMachineName

    ) ],
    {
        'DatastoreId' => \%DatastoreId_of,
        'DatastoreName' => \%DatastoreName_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'HostServiceId' => \%HostServiceId_of,
        'VhdType' => \%VhdType_of,
        'VirtualDiskId' => \%VirtualDiskId_of,
        'VirtualDiskName' => \%VirtualDiskName_of,
        'VirtualInfrastructureType' => \%VirtualInfrastructureType_of,
        'VirtualMachineId' => \%VirtualMachineId_of,
        'VirtualMachineName' => \%VirtualMachineName_of,
    },
    {
        'DatastoreId' => 'MyTypes::ObjId',
        'DatastoreName' => 'MyTypes::ObjName',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'HostServiceId' => 'MyTypes::ObjId',
        'VhdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VirtualDiskId' => 'MyTypes::ObjId',
        'VirtualDiskName' => 'MyTypes::ObjName',
        'VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
        'VirtualMachineId' => 'MyTypes::ObjId',
        'VirtualMachineName' => 'MyTypes::ObjName',
    },
    {

        'DatastoreId' => 'DatastoreId',
        'DatastoreName' => 'DatastoreName',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'HostServiceId' => 'HostServiceId',
        'VhdType' => 'VhdType',
        'VirtualDiskId' => 'VirtualDiskId',
        'VirtualDiskName' => 'VirtualDiskName',
        'VirtualInfrastructureType' => 'VirtualInfrastructureType',
        'VirtualMachineId' => 'VirtualMachineId',
        'VirtualMachineName' => 'VirtualMachineName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VirtualDisk

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VirtualDisk from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatastoreId


=item * DatastoreName


=item * DeletedBy


=item * DeletedTimestamp


=item * HostServiceId


=item * VhdType


=item * VirtualDiskId


=item * VirtualDiskName


=item * VirtualInfrastructureType


=item * VirtualMachineId


=item * VirtualMachineName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VirtualDisk
   DatastoreId => $some_value, # ObjId
   DatastoreName => $some_value, # ObjName
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   HostServiceId => $some_value, # ObjId
   VhdType =>  $some_value, # string
   VirtualDiskId => $some_value, # ObjId
   VirtualDiskName => $some_value, # ObjName
   VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
   VirtualMachineId => $some_value, # ObjId
   VirtualMachineName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

