package MyTypes::VirtualMachine;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DatacenterReference_of :ATTR(:get<DatacenterReference>);
my %Datasets_of :ATTR(:get<Datasets>);
my %DeletedBy_of :ATTR(:get<DeletedBy>);
my %DeletedTimestamp_of :ATTR(:get<DeletedTimestamp>);
my %DnsName_of :ATTR(:get<DnsName>);
my %GuestOsType_of :ATTR(:get<GuestOsType>);
my %HostServiceId_of :ATTR(:get<HostServiceId>);
my %HypervisorReference_of :ATTR(:get<HypervisorReference>);
my %IpAddressList_of :ATTR(:get<IpAddressList>);
my %IsProtected_of :ATTR(:get<IsProtected>);
my %Status_of :ATTR(:get<Status>);
my %VirtualCenterReference_of :ATTR(:get<VirtualCenterReference>);
my %VirtualInfrastructureType_of :ATTR(:get<VirtualInfrastructureType>);
my %VirtualMachineId_of :ATTR(:get<VirtualMachineId>);
my %VirtualMachineName_of :ATTR(:get<VirtualMachineName>);

__PACKAGE__->_factory(
    [ qw(        DatacenterReference
        Datasets
        DeletedBy
        DeletedTimestamp
        DnsName
        GuestOsType
        HostServiceId
        HypervisorReference
        IpAddressList
        IsProtected
        Status
        VirtualCenterReference
        VirtualInfrastructureType
        VirtualMachineId
        VirtualMachineName

    ) ],
    {
        'DatacenterReference' => \%DatacenterReference_of,
        'Datasets' => \%Datasets_of,
        'DeletedBy' => \%DeletedBy_of,
        'DeletedTimestamp' => \%DeletedTimestamp_of,
        'DnsName' => \%DnsName_of,
        'GuestOsType' => \%GuestOsType_of,
        'HostServiceId' => \%HostServiceId_of,
        'HypervisorReference' => \%HypervisorReference_of,
        'IpAddressList' => \%IpAddressList_of,
        'IsProtected' => \%IsProtected_of,
        'Status' => \%Status_of,
        'VirtualCenterReference' => \%VirtualCenterReference_of,
        'VirtualInfrastructureType' => \%VirtualInfrastructureType_of,
        'VirtualMachineId' => \%VirtualMachineId_of,
        'VirtualMachineName' => \%VirtualMachineName_of,
    },
    {
        'DatacenterReference' => 'MyTypes::DatacenterReference',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'DeletedTimestamp' => 'MyTypes::DpTimestamp',
        'DnsName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'GuestOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'HostServiceId' => 'MyTypes::ObjId',
        'HypervisorReference' => 'MyTypes::HypervisorReference',
        'IpAddressList' => 'MyTypes::ArrayOfIpAddress',
        'IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
        'VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
        'VirtualMachineId' => 'MyTypes::ObjId',
        'VirtualMachineName' => 'MyTypes::ObjName',
    },
    {

        'DatacenterReference' => 'DatacenterReference',
        'Datasets' => 'Datasets',
        'DeletedBy' => 'DeletedBy',
        'DeletedTimestamp' => 'DeletedTimestamp',
        'DnsName' => 'DnsName',
        'GuestOsType' => 'GuestOsType',
        'HostServiceId' => 'HostServiceId',
        'HypervisorReference' => 'HypervisorReference',
        'IpAddressList' => 'IpAddressList',
        'IsProtected' => 'IsProtected',
        'Status' => 'Status',
        'VirtualCenterReference' => 'VirtualCenterReference',
        'VirtualInfrastructureType' => 'VirtualInfrastructureType',
        'VirtualMachineId' => 'VirtualMachineId',
        'VirtualMachineName' => 'VirtualMachineName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VirtualMachine

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VirtualMachine from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DatacenterReference


=item * Datasets


=item * DeletedBy


=item * DeletedTimestamp


=item * DnsName


=item * GuestOsType


=item * HostServiceId


=item * HypervisorReference


=item * IpAddressList


=item * IsProtected


=item * Status


=item * VirtualCenterReference


=item * VirtualInfrastructureType


=item * VirtualMachineId


=item * VirtualMachineName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VirtualMachine
   DatacenterReference =>  { # MyTypes::DatacenterReference
     DatacenterId => $some_value, # ObjId
     DatacenterName => $some_value, # ObjName
   },
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   DeletedBy =>  $some_value, # string
   DeletedTimestamp => $some_value, # DpTimestamp
   DnsName =>  $some_value, # string
   GuestOsType =>  $some_value, # string
   HostServiceId => $some_value, # ObjId
   HypervisorReference =>  { # MyTypes::HypervisorReference
     HypervisorId => $some_value, # ObjId
     HypervisorName => $some_value, # ObjName
   },
   IpAddressList =>  { # MyTypes::ArrayOfIpAddress
     IpAddress => $some_value, # IpAddress
   },
   IsProtected =>  $some_value, # boolean
   Status =>  $some_value, # string
   VirtualCenterReference =>  { # MyTypes::VirtualCenterReference
     VirtualCenterId => $some_value, # ObjId
     VirtualCenterName => $some_value, # ObjName
   },
   VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
   VirtualMachineId => $some_value, # ObjId
   VirtualMachineName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

