package MyTypes::VmwareBackupScheduleSettingsInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %CreateVmwareSnapshot_of :ATTR(:get<CreateVmwareSnapshot>);
my %IncludeIndependentDisks_of :ATTR(:get<IncludeIndependentDisks>);

__PACKAGE__->_factory(
    [ qw(        CreateVmwareSnapshot
        IncludeIndependentDisks

    ) ],
    {
        'CreateVmwareSnapshot' => \%CreateVmwareSnapshot_of,
        'IncludeIndependentDisks' => \%IncludeIndependentDisks_of,
    },
    {
        'CreateVmwareSnapshot' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IncludeIndependentDisks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
    },
    {

        'CreateVmwareSnapshot' => 'CreateVmwareSnapshot',
        'IncludeIndependentDisks' => 'IncludeIndependentDisks',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VmwareBackupScheduleSettingsInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VmwareBackupScheduleSettingsInfo from the namespace http://www.netapp.com/management/v1.

Schedule level settings for the VMware backup Operation.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * CreateVmwareSnapshot


=item * IncludeIndependentDisks




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VmwareBackupScheduleSettingsInfo
   CreateVmwareSnapshot =>  $some_value, # boolean
   IncludeIndependentDisks =>  $some_value, # boolean
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

