package MyTypes::VolumeAggregatePair;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %Aggregate_of :ATTR(:get<Aggregate>);
my %Volume_of :ATTR(:get<Volume>);

__PACKAGE__->_factory(
    [ qw(        Aggregate
        Volume

    ) ],
    {
        'Aggregate' => \%Aggregate_of,
        'Volume' => \%Volume_of,
    },
    {
        'Aggregate' => 'MyTypes::ObjNameOrId',
        'Volume' => 'MyTypes::ObjNameOrId',
    },
    {

        'Aggregate' => 'Aggregate',
        'Volume' => 'Volume',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VolumeAggregatePair

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeAggregatePair from the namespace http://www.netapp.com/management/v1.

A Volume and Aggregate pair.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * Aggregate


=item * Volume




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeAggregatePair
   Aggregate => $some_value, # ObjNameOrId
   Volume => $some_value, # ObjNameOrId
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

