package MyTypes::VolumeDedupeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %DedupeProgress_of :ATTR(:get<DedupeProgress>);
my %DedupeSpaceSavings_of :ATTR(:get<DedupeSpaceSavings>);
my %DedupeSpaceSavingsPercentage_of :ATTR(:get<DedupeSpaceSavingsPercentage>);
my %DedupeStatus_of :ATTR(:get<DedupeStatus>);
my %IsDedupeEnabled_of :ATTR(:get<IsDedupeEnabled>);
my %LastDedupeBeginTimestamp_of :ATTR(:get<LastDedupeBeginTimestamp>);
my %LastDedupeEndTimestamp_of :ATTR(:get<LastDedupeEndTimestamp>);
my %LastDedupeError_of :ATTR(:get<LastDedupeError>);
my %LastDedupeScannedSize_of :ATTR(:get<LastDedupeScannedSize>);

__PACKAGE__->_factory(
    [ qw(        DedupeProgress
        DedupeSpaceSavings
        DedupeSpaceSavingsPercentage
        DedupeStatus
        IsDedupeEnabled
        LastDedupeBeginTimestamp
        LastDedupeEndTimestamp
        LastDedupeError
        LastDedupeScannedSize

    ) ],
    {
        'DedupeProgress' => \%DedupeProgress_of,
        'DedupeSpaceSavings' => \%DedupeSpaceSavings_of,
        'DedupeSpaceSavingsPercentage' => \%DedupeSpaceSavingsPercentage_of,
        'DedupeStatus' => \%DedupeStatus_of,
        'IsDedupeEnabled' => \%IsDedupeEnabled_of,
        'LastDedupeBeginTimestamp' => \%LastDedupeBeginTimestamp_of,
        'LastDedupeEndTimestamp' => \%LastDedupeEndTimestamp_of,
        'LastDedupeError' => \%LastDedupeError_of,
        'LastDedupeScannedSize' => \%LastDedupeScannedSize_of,
    },
    {
        'DedupeProgress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'DedupeSpaceSavings' => 'MyTypes::VolumeDedupeInfo::_DedupeSpaceSavings',

        'DedupeSpaceSavingsPercentage' => 'MyTypes::VolumeDedupeInfo::_DedupeSpaceSavingsPercentage',
        'DedupeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsDedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'LastDedupeBeginTimestamp' => 'MyTypes::Timestamp',
        'LastDedupeEndTimestamp' => 'MyTypes::Timestamp',
        'LastDedupeError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'LastDedupeScannedSize' => 'MyTypes::VolumeDedupeInfo::_LastDedupeScannedSize',
    },
    {

        'DedupeProgress' => 'DedupeProgress',
        'DedupeSpaceSavings' => 'DedupeSpaceSavings',
        'DedupeSpaceSavingsPercentage' => 'DedupeSpaceSavingsPercentage',
        'DedupeStatus' => 'DedupeStatus',
        'IsDedupeEnabled' => 'IsDedupeEnabled',
        'LastDedupeBeginTimestamp' => 'LastDedupeBeginTimestamp',
        'LastDedupeEndTimestamp' => 'LastDedupeEndTimestamp',
        'LastDedupeError' => 'LastDedupeError',
        'LastDedupeScannedSize' => 'LastDedupeScannedSize',
    }
);

} # end BLOCK




package MyTypes::VolumeDedupeInfo::_DedupeSpaceSavings;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeDedupeInfo::_DedupeSpaceSavingsPercentage;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeDedupeInfo::_LastDedupeScannedSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::VolumeDedupeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeDedupeInfo from the namespace http://www.netapp.com/management/v1.

Volume deduplication information. Optional fields will not be returned if deduplication has never run on the Volume.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * DedupeProgress


=item * DedupeSpaceSavings


=item * DedupeSpaceSavingsPercentage


=item * DedupeStatus


=item * IsDedupeEnabled


=item * LastDedupeBeginTimestamp


=item * LastDedupeEndTimestamp


=item * LastDedupeError


=item * LastDedupeScannedSize




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeDedupeInfo
   DedupeProgress =>  $some_value, # string
   DedupeSpaceSavings => $some_value, # atomic
   DedupeSpaceSavingsPercentage => $some_value, # atomic
   DedupeStatus =>  $some_value, # string
   IsDedupeEnabled =>  $some_value, # boolean
   LastDedupeBeginTimestamp => $some_value, # Timestamp
   LastDedupeEndTimestamp => $some_value, # Timestamp
   LastDedupeError =>  $some_value, # string
   LastDedupeScannedSize => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

