package MyTypes::VolumeInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateId_of :ATTR(:get<AggregateId>);
my %AggregateName_of :ATTR(:get<AggregateName>);
my %BlockType_of :ATTR(:get<BlockType>);
my %DatasetId_of :ATTR(:get<DatasetId>);
my %DatasetNodes_of :ATTR(:get<DatasetNodes>);
my %Datasets_of :ATTR(:get<Datasets>);
my %HostId_of :ATTR(:get<HostId>);
my %HostName_of :ATTR(:get<HostName>);
my %IsAvailable_of :ATTR(:get<IsAvailable>);
my %IsCapableOfMigration_of :ATTR(:get<IsCapableOfMigration>);
my %IsDpIgnored_of :ATTR(:get<IsDpIgnored>);
my %IsInDataset_of :ATTR(:get<IsInDataset>);
my %IsReadonlyVolume_of :ATTR(:get<IsReadonlyVolume>);
my %IsSnapmirrorPrimaryCapable_of :ATTR(:get<IsSnapmirrorPrimaryCapable>);
my %IsSnapmirrorPrimaryVolume_of :ATTR(:get<IsSnapmirrorPrimaryVolume>);
my %IsSnapmirrorSecondaryCapable_of :ATTR(:get<IsSnapmirrorSecondaryCapable>);
my %IsSnapmirrorSecondaryVolume_of :ATTR(:get<IsSnapmirrorSecondaryVolume>);
my %IsSnapvaultPrimaryCapable_of :ATTR(:get<IsSnapvaultPrimaryCapable>);
my %IsSnapvaultPrimaryVolume_of :ATTR(:get<IsSnapvaultPrimaryVolume>);
my %IsSnapvaultSecondaryCapable_of :ATTR(:get<IsSnapvaultSecondaryCapable>);
my %IsSnapvaultSecondaryVolume_of :ATTR(:get<IsSnapvaultSecondaryVolume>);
my %IsVsmSecondaryVolume_of :ATTR(:get<IsVsmSecondaryVolume>);
my %JunctionPath_of :ATTR(:get<JunctionPath>);
my %JunctionPathActive_of :ATTR(:get<JunctionPathActive>);
my %MigrationIncompatibilityReasons_of :ATTR(:get<MigrationIncompatibilityReasons>);
my %NextScheduledBackupTime_of :ATTR(:get<NextScheduledBackupTime>);
my %SnapshotVolumeId_of :ATTR(:get<SnapshotVolumeId>);
my %SnapshotVolumeName_of :ATTR(:get<SnapshotVolumeName>);
my %SnapvaultLagWarningThreshold_of :ATTR(:get<SnapvaultLagWarningThreshold>);
my %SnapvaultSecondaryScheduleName_of :ATTR(:get<SnapvaultSecondaryScheduleName>);
my %SpaceGuarantee_of :ATTR(:get<SpaceGuarantee>);
my %VolumeDedupeInfo_of :ATTR(:get<VolumeDedupeInfo>);
my %VolumeFullThreshold_of :ATTR(:get<VolumeFullThreshold>);
my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);
my %VolumeNearlyFullThreshold_of :ATTR(:get<VolumeNearlyFullThreshold>);
my %VolumePerfStatus_of :ATTR(:get<VolumePerfStatus>);
my %VolumeQtree_of :ATTR(:get<VolumeQtree>);
my %VolumeSize_of :ATTR(:get<VolumeSize>);
my %VolumeSpaceStatus_of :ATTR(:get<VolumeSpaceStatus>);
my %VolumeState_of :ATTR(:get<VolumeState>);
my %VolumeStatus_of :ATTR(:get<VolumeStatus>);
my %VolumeType_of :ATTR(:get<VolumeType>);

__PACKAGE__->_factory(
    [ qw(        AggregateId
        AggregateName
        BlockType
        DatasetId
        DatasetNodes
        Datasets
        HostId
        HostName
        IsAvailable
        IsCapableOfMigration
        IsDpIgnored
        IsInDataset
        IsReadonlyVolume
        IsSnapmirrorPrimaryCapable
        IsSnapmirrorPrimaryVolume
        IsSnapmirrorSecondaryCapable
        IsSnapmirrorSecondaryVolume
        IsSnapvaultPrimaryCapable
        IsSnapvaultPrimaryVolume
        IsSnapvaultSecondaryCapable
        IsSnapvaultSecondaryVolume
        IsVsmSecondaryVolume
        JunctionPath
        JunctionPathActive
        MigrationIncompatibilityReasons
        NextScheduledBackupTime
        SnapshotVolumeId
        SnapshotVolumeName
        SnapvaultLagWarningThreshold
        SnapvaultSecondaryScheduleName
        SpaceGuarantee
        VolumeDedupeInfo
        VolumeFullThreshold
        VolumeId
        VolumeName
        VolumeNearlyFullThreshold
        VolumePerfStatus
        VolumeQtree
        VolumeSize
        VolumeSpaceStatus
        VolumeState
        VolumeStatus
        VolumeType

    ) ],
    {
        'AggregateId' => \%AggregateId_of,
        'AggregateName' => \%AggregateName_of,
        'BlockType' => \%BlockType_of,
        'DatasetId' => \%DatasetId_of,
        'DatasetNodes' => \%DatasetNodes_of,
        'Datasets' => \%Datasets_of,
        'HostId' => \%HostId_of,
        'HostName' => \%HostName_of,
        'IsAvailable' => \%IsAvailable_of,
        'IsCapableOfMigration' => \%IsCapableOfMigration_of,
        'IsDpIgnored' => \%IsDpIgnored_of,
        'IsInDataset' => \%IsInDataset_of,
        'IsReadonlyVolume' => \%IsReadonlyVolume_of,
        'IsSnapmirrorPrimaryCapable' => \%IsSnapmirrorPrimaryCapable_of,
        'IsSnapmirrorPrimaryVolume' => \%IsSnapmirrorPrimaryVolume_of,
        'IsSnapmirrorSecondaryCapable' => \%IsSnapmirrorSecondaryCapable_of,
        'IsSnapmirrorSecondaryVolume' => \%IsSnapmirrorSecondaryVolume_of,
        'IsSnapvaultPrimaryCapable' => \%IsSnapvaultPrimaryCapable_of,
        'IsSnapvaultPrimaryVolume' => \%IsSnapvaultPrimaryVolume_of,
        'IsSnapvaultSecondaryCapable' => \%IsSnapvaultSecondaryCapable_of,
        'IsSnapvaultSecondaryVolume' => \%IsSnapvaultSecondaryVolume_of,
        'IsVsmSecondaryVolume' => \%IsVsmSecondaryVolume_of,
        'JunctionPath' => \%JunctionPath_of,
        'JunctionPathActive' => \%JunctionPathActive_of,
        'MigrationIncompatibilityReasons' => \%MigrationIncompatibilityReasons_of,
        'NextScheduledBackupTime' => \%NextScheduledBackupTime_of,
        'SnapshotVolumeId' => \%SnapshotVolumeId_of,
        'SnapshotVolumeName' => \%SnapshotVolumeName_of,
        'SnapvaultLagWarningThreshold' => \%SnapvaultLagWarningThreshold_of,
        'SnapvaultSecondaryScheduleName' => \%SnapvaultSecondaryScheduleName_of,
        'SpaceGuarantee' => \%SpaceGuarantee_of,
        'VolumeDedupeInfo' => \%VolumeDedupeInfo_of,
        'VolumeFullThreshold' => \%VolumeFullThreshold_of,
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
        'VolumeNearlyFullThreshold' => \%VolumeNearlyFullThreshold_of,
        'VolumePerfStatus' => \%VolumePerfStatus_of,
        'VolumeQtree' => \%VolumeQtree_of,
        'VolumeSize' => \%VolumeSize_of,
        'VolumeSpaceStatus' => \%VolumeSpaceStatus_of,
        'VolumeState' => \%VolumeState_of,
        'VolumeStatus' => \%VolumeStatus_of,
        'VolumeType' => \%VolumeType_of,
    },
    {
        'AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'BlockType' => 'MyTypes::FileSystemBlockType',

        'DatasetId' => 'MyTypes::VolumeInfo::_DatasetId',
        'DatasetNodes' => 'MyTypes::ArrayOfDatasetNodeInfo',
        'Datasets' => 'MyTypes::ArrayOfDatasetReference',
        'HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsCapableOfMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsReadonlyVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorPrimaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapmirrorSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultPrimaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsSnapvaultSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'IsVsmSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'JunctionPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'JunctionPathActive' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
        'MigrationIncompatibilityReasons' => 'MyTypes::ArrayOfMigrationIncompatibilityReason',
        'NextScheduledBackupTime' => 'MyTypes::DpTimestamp',
        'SnapshotVolumeId' => 'MyTypes::ObjId',
        'SnapshotVolumeName' => 'MyTypes::ObjFullName',
        'SnapvaultLagWarningThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'SnapvaultSecondaryScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'SpaceGuarantee' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeDedupeInfo' => 'MyTypes::VolumeDedupeInfo',

        'VolumeFullThreshold' => 'MyTypes::VolumeInfo::_VolumeFullThreshold',
        'VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',

        'VolumeNearlyFullThreshold' => 'MyTypes::VolumeInfo::_VolumeNearlyFullThreshold',
        'VolumePerfStatus' => 'MyTypes::ObjStatus',
        'VolumeQtree' => 'MyTypes::VolumeQtree',
        'VolumeSize' => 'MyTypes::VolumeSize',
        'VolumeSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
        'VolumeState' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'VolumeStatus' => 'MyTypes::ObjStatus',
        'VolumeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'AggregateId' => 'AggregateId',
        'AggregateName' => 'AggregateName',
        'BlockType' => 'BlockType',
        'DatasetId' => 'DatasetId',
        'DatasetNodes' => 'DatasetNodes',
        'Datasets' => 'Datasets',
        'HostId' => 'HostId',
        'HostName' => 'HostName',
        'IsAvailable' => 'IsAvailable',
        'IsCapableOfMigration' => 'IsCapableOfMigration',
        'IsDpIgnored' => 'IsDpIgnored',
        'IsInDataset' => 'IsInDataset',
        'IsReadonlyVolume' => 'IsReadonlyVolume',
        'IsSnapmirrorPrimaryCapable' => 'IsSnapmirrorPrimaryCapable',
        'IsSnapmirrorPrimaryVolume' => 'IsSnapmirrorPrimaryVolume',
        'IsSnapmirrorSecondaryCapable' => 'IsSnapmirrorSecondaryCapable',
        'IsSnapmirrorSecondaryVolume' => 'IsSnapmirrorSecondaryVolume',
        'IsSnapvaultPrimaryCapable' => 'IsSnapvaultPrimaryCapable',
        'IsSnapvaultPrimaryVolume' => 'IsSnapvaultPrimaryVolume',
        'IsSnapvaultSecondaryCapable' => 'IsSnapvaultSecondaryCapable',
        'IsSnapvaultSecondaryVolume' => 'IsSnapvaultSecondaryVolume',
        'IsVsmSecondaryVolume' => 'IsVsmSecondaryVolume',
        'JunctionPath' => 'JunctionPath',
        'JunctionPathActive' => 'JunctionPathActive',
        'MigrationIncompatibilityReasons' => 'MigrationIncompatibilityReasons',
        'NextScheduledBackupTime' => 'NextScheduledBackupTime',
        'SnapshotVolumeId' => 'SnapshotVolumeId',
        'SnapshotVolumeName' => 'SnapshotVolumeName',
        'SnapvaultLagWarningThreshold' => 'SnapvaultLagWarningThreshold',
        'SnapvaultSecondaryScheduleName' => 'SnapvaultSecondaryScheduleName',
        'SpaceGuarantee' => 'SpaceGuarantee',
        'VolumeDedupeInfo' => 'VolumeDedupeInfo',
        'VolumeFullThreshold' => 'VolumeFullThreshold',
        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
        'VolumeNearlyFullThreshold' => 'VolumeNearlyFullThreshold',
        'VolumePerfStatus' => 'VolumePerfStatus',
        'VolumeQtree' => 'VolumeQtree',
        'VolumeSize' => 'VolumeSize',
        'VolumeSpaceStatus' => 'VolumeSpaceStatus',
        'VolumeState' => 'VolumeState',
        'VolumeStatus' => 'VolumeStatus',
        'VolumeType' => 'VolumeType',
    }
);

} # end BLOCK




package MyTypes::VolumeInfo::_DatasetId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeInfo::_VolumeFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeInfo::_VolumeNearlyFullThreshold;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::VolumeInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeInfo from the namespace http://www.netapp.com/management/v1.

Information about a Volume.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateId


=item * AggregateName


=item * BlockType


=item * DatasetId


=item * DatasetNodes


=item * Datasets


=item * HostId


=item * HostName


=item * IsAvailable


=item * IsCapableOfMigration


=item * IsDpIgnored


=item * IsInDataset


=item * IsReadonlyVolume


=item * IsSnapmirrorPrimaryCapable


=item * IsSnapmirrorPrimaryVolume


=item * IsSnapmirrorSecondaryCapable


=item * IsSnapmirrorSecondaryVolume


=item * IsSnapvaultPrimaryCapable


=item * IsSnapvaultPrimaryVolume


=item * IsSnapvaultSecondaryCapable


=item * IsSnapvaultSecondaryVolume


=item * IsVsmSecondaryVolume


=item * JunctionPath


=item * JunctionPathActive


=item * MigrationIncompatibilityReasons


=item * NextScheduledBackupTime


=item * SnapshotVolumeId


=item * SnapshotVolumeName


=item * SnapvaultLagWarningThreshold


=item * SnapvaultSecondaryScheduleName


=item * SpaceGuarantee


=item * VolumeDedupeInfo


=item * VolumeFullThreshold


=item * VolumeId


=item * VolumeName


=item * VolumeNearlyFullThreshold


=item * VolumePerfStatus


=item * VolumeQtree


=item * VolumeSize


=item * VolumeSpaceStatus


=item * VolumeState


=item * VolumeStatus


=item * VolumeType




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeInfo
   AggregateId =>  $some_value, # integer
   AggregateName =>  $some_value, # string
   BlockType => $some_value, # FileSystemBlockType
   DatasetId => $some_value, # atomic
   DatasetNodes =>  { # MyTypes::ArrayOfDatasetNodeInfo
     DatasetNodeInfo =>  { # MyTypes::DatasetNodeInfo
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
       DpNodeId => $some_value, # atomic
       DpNodeName => $some_value, # DpPolicyNodeName
       IsDpNodeEffectivePrimary =>  $some_value, # boolean
     },
   },
   Datasets =>  { # MyTypes::ArrayOfDatasetReference
     DatasetReference =>  { # MyTypes::DatasetReference
       DatasetId => $some_value, # ObjId
       DatasetName => $some_value, # ObjName
     },
   },
   HostId =>  $some_value, # integer
   HostName =>  $some_value, # string
   IsAvailable =>  $some_value, # boolean
   IsCapableOfMigration =>  $some_value, # boolean
   IsDpIgnored =>  $some_value, # boolean
   IsInDataset =>  $some_value, # boolean
   IsReadonlyVolume =>  $some_value, # boolean
   IsSnapmirrorPrimaryCapable =>  $some_value, # boolean
   IsSnapmirrorPrimaryVolume =>  $some_value, # boolean
   IsSnapmirrorSecondaryCapable =>  $some_value, # boolean
   IsSnapmirrorSecondaryVolume =>  $some_value, # boolean
   IsSnapvaultPrimaryCapable =>  $some_value, # boolean
   IsSnapvaultPrimaryVolume =>  $some_value, # boolean
   IsSnapvaultSecondaryCapable =>  $some_value, # boolean
   IsSnapvaultSecondaryVolume =>  $some_value, # boolean
   IsVsmSecondaryVolume =>  $some_value, # boolean
   JunctionPath =>  $some_value, # string
   JunctionPathActive =>  $some_value, # boolean
   MigrationIncompatibilityReasons =>  { # MyTypes::ArrayOfMigrationIncompatibilityReason
     MigrationIncompatibilityReason => $some_value, # MigrationIncompatibilityReason
   },
   NextScheduledBackupTime => $some_value, # DpTimestamp
   SnapshotVolumeId => $some_value, # ObjId
   SnapshotVolumeName => $some_value, # ObjFullName
   SnapvaultLagWarningThreshold =>  $some_value, # integer
   SnapvaultSecondaryScheduleName =>  $some_value, # string
   SpaceGuarantee =>  $some_value, # string
   VolumeDedupeInfo =>  { # MyTypes::VolumeDedupeInfo
     DedupeProgress =>  $some_value, # string
     DedupeSpaceSavings => $some_value, # atomic
     DedupeSpaceSavingsPercentage => $some_value, # atomic
     DedupeStatus =>  $some_value, # string
     IsDedupeEnabled =>  $some_value, # boolean
     LastDedupeBeginTimestamp => $some_value, # Timestamp
     LastDedupeEndTimestamp => $some_value, # Timestamp
     LastDedupeError =>  $some_value, # string
     LastDedupeScannedSize => $some_value, # atomic
   },
   VolumeFullThreshold => $some_value, # atomic
   VolumeId =>  $some_value, # integer
   VolumeName =>  $some_value, # string
   VolumeNearlyFullThreshold => $some_value, # atomic
   VolumePerfStatus => $some_value, # ObjStatus
   VolumeQtree =>  { # MyTypes::VolumeQtree
     ProtectedDataSize =>  $some_value, # integer
     ProtectedQtreeCount =>  $some_value, # integer
     TotalQtreeCount =>  $some_value, # integer
     UnprotectedDataSize =>  $some_value, # integer
     UnprotectedQtreeCount =>  $some_value, # integer
   },
   VolumeSize =>  { # MyTypes::VolumeSize
     ActualVolumeSize =>  $some_value, # integer
     AfsAvail => $some_value, # atomic
     AfsData => $some_value, # atomic
     AfsTotal => $some_value, # atomic
     AfsUsed => $some_value, # atomic
     AfsUsedPerDay => $some_value, # atomic
     HoleReserve => $some_value, # atomic
     IsAutosizeEnabled =>  $some_value, # boolean
     MaximumSize => $some_value, # atomic
     OverwriteReserveAvail => $some_value, # atomic
     OverwriteReserveTotal => $some_value, # atomic
     OverwriteReserveUsed => $some_value, # atomic
     SnapshotReserveAvail => $some_value, # atomic
     SnapshotReserveTotal => $some_value, # atomic
     SnapshotReserveUsed => $some_value, # atomic
     SpaceAllocatedFromAggr =>  $some_value, # integer
     Total => $some_value, # atomic
   },
   VolumeSpaceStatus => $some_value, # ObjectSpaceStatus
   VolumeState =>  $some_value, # string
   VolumeStatus => $some_value, # ObjStatus
   VolumeType =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

