package MyTypes::VolumeNameOrId;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %VolumeId_of :ATTR(:get<VolumeId>);
my %VolumeName_of :ATTR(:get<VolumeName>);

__PACKAGE__->_factory(
    [ qw(        VolumeId
        VolumeName

    ) ],
    {
        'VolumeId' => \%VolumeId_of,
        'VolumeName' => \%VolumeName_of,
    },
    {
        'VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
        'VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'VolumeId' => 'VolumeId',
        'VolumeName' => 'VolumeName',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VolumeNameOrId

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeNameOrId from the namespace http://www.netapp.com/management/v1.

A Volume Name or Id. When used as input only one of VolumeName or VolumeId is specified. When used as output, both of them will be returned. If VolumeName is specified, then either HostIdentifier, VfilerIdentifier or AggregateIdentifier must also be specified but not both.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * VolumeId


=item * VolumeName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeNameOrId
   VolumeId =>  $some_value, # unsignedInt
   VolumeName =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

