package MyTypes::VolumeQtree;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ProtectedDataSize_of :ATTR(:get<ProtectedDataSize>);
my %ProtectedQtreeCount_of :ATTR(:get<ProtectedQtreeCount>);
my %TotalQtreeCount_of :ATTR(:get<TotalQtreeCount>);
my %UnprotectedDataSize_of :ATTR(:get<UnprotectedDataSize>);
my %UnprotectedQtreeCount_of :ATTR(:get<UnprotectedQtreeCount>);

__PACKAGE__->_factory(
    [ qw(        ProtectedDataSize
        ProtectedQtreeCount
        TotalQtreeCount
        UnprotectedDataSize
        UnprotectedQtreeCount

    ) ],
    {
        'ProtectedDataSize' => \%ProtectedDataSize_of,
        'ProtectedQtreeCount' => \%ProtectedQtreeCount_of,
        'TotalQtreeCount' => \%TotalQtreeCount_of,
        'UnprotectedDataSize' => \%UnprotectedDataSize_of,
        'UnprotectedQtreeCount' => \%UnprotectedQtreeCount_of,
    },
    {
        'ProtectedDataSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'ProtectedQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'TotalQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'UnprotectedDataSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
        'UnprotectedQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
    },
    {

        'ProtectedDataSize' => 'ProtectedDataSize',
        'ProtectedQtreeCount' => 'ProtectedQtreeCount',
        'TotalQtreeCount' => 'TotalQtreeCount',
        'UnprotectedDataSize' => 'UnprotectedDataSize',
        'UnprotectedQtreeCount' => 'UnprotectedQtreeCount',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VolumeQtree

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeQtree from the namespace http://www.netapp.com/management/v1.

Information on Qtrees in the Volume




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ProtectedDataSize


=item * ProtectedQtreeCount


=item * TotalQtreeCount


=item * UnprotectedDataSize


=item * UnprotectedQtreeCount




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeQtree
   ProtectedDataSize =>  $some_value, # integer
   ProtectedQtreeCount =>  $some_value, # integer
   TotalQtreeCount =>  $some_value, # integer
   UnprotectedDataSize =>  $some_value, # integer
   UnprotectedQtreeCount =>  $some_value, # integer
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

