package MyTypes::VolumeResource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %AggregateIdentifier_of :ATTR(:get<AggregateIdentifier>);
my %HostIdentifier_of :ATTR(:get<HostIdentifier>);
my %VfilerIdentifier_of :ATTR(:get<VfilerIdentifier>);
my %VolumeIdentifierNameOrId_of :ATTR(:get<VolumeIdentifierNameOrId>);

__PACKAGE__->_factory(
    [ qw(        AggregateIdentifier
        HostIdentifier
        VfilerIdentifier
        VolumeIdentifierNameOrId

    ) ],
    {
        'AggregateIdentifier' => \%AggregateIdentifier_of,
        'HostIdentifier' => \%HostIdentifier_of,
        'VfilerIdentifier' => \%VfilerIdentifier_of,
        'VolumeIdentifierNameOrId' => \%VolumeIdentifierNameOrId_of,
    },
    {
        'AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
        'HostIdentifier' => 'MyTypes::WrapperOfHostResource',
        'VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
        'VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
    },
    {

        'AggregateIdentifier' => 'AggregateIdentifier',
        'HostIdentifier' => 'HostIdentifier',
        'VfilerIdentifier' => 'VfilerIdentifier',
        'VolumeIdentifierNameOrId' => 'VolumeIdentifierNameOrId',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::VolumeResource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeResource from the namespace http://www.netapp.com/management/v1.

Details of a Volume.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * AggregateIdentifier


=item * HostIdentifier


=item * VfilerIdentifier


=item * VolumeIdentifierNameOrId




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeResource
   AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
     AggregateResource =>  { # MyTypes::AggregateResource
       AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
         AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
           AggregateId =>  $some_value, # unsignedInt
           AggregateName =>  $some_value, # string
         },
       },
       FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
         FilerResource =>  { # MyTypes::FilerResource
           FilerId =>  $some_value, # unsignedInt
           FilerName =>  $some_value, # string
         },
       },
     },
   },
   HostIdentifier =>  { # MyTypes::WrapperOfHostResource
     HostResource =>  { # MyTypes::HostResource
       HostId =>  $some_value, # unsignedInt
       HostName =>  $some_value, # string
     },
   },
   VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
     VfilerResource =>  { # MyTypes::VfilerResource
       VfilerId =>  $some_value, # unsignedInt
       VfilerNameOrUuid =>  $some_value, # string
     },
   },
   VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
     VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
       VolumeId =>  $some_value, # unsignedInt
       VolumeName =>  $some_value, # string
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

