package MyTypes::VolumeSize;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ActualVolumeSize_of :ATTR(:get<ActualVolumeSize>);
my %AfsAvail_of :ATTR(:get<AfsAvail>);
my %AfsData_of :ATTR(:get<AfsData>);
my %AfsTotal_of :ATTR(:get<AfsTotal>);
my %AfsUsed_of :ATTR(:get<AfsUsed>);
my %AfsUsedPerDay_of :ATTR(:get<AfsUsedPerDay>);
my %HoleReserve_of :ATTR(:get<HoleReserve>);
my %IsAutosizeEnabled_of :ATTR(:get<IsAutosizeEnabled>);
my %MaximumSize_of :ATTR(:get<MaximumSize>);
my %OverwriteReserveAvail_of :ATTR(:get<OverwriteReserveAvail>);
my %OverwriteReserveTotal_of :ATTR(:get<OverwriteReserveTotal>);
my %OverwriteReserveUsed_of :ATTR(:get<OverwriteReserveUsed>);
my %SnapshotReserveAvail_of :ATTR(:get<SnapshotReserveAvail>);
my %SnapshotReserveTotal_of :ATTR(:get<SnapshotReserveTotal>);
my %SnapshotReserveUsed_of :ATTR(:get<SnapshotReserveUsed>);
my %SpaceAllocatedFromAggr_of :ATTR(:get<SpaceAllocatedFromAggr>);
my %Total_of :ATTR(:get<Total>);

__PACKAGE__->_factory(
    [ qw(        ActualVolumeSize
        AfsAvail
        AfsData
        AfsTotal
        AfsUsed
        AfsUsedPerDay
        HoleReserve
        IsAutosizeEnabled
        MaximumSize
        OverwriteReserveAvail
        OverwriteReserveTotal
        OverwriteReserveUsed
        SnapshotReserveAvail
        SnapshotReserveTotal
        SnapshotReserveUsed
        SpaceAllocatedFromAggr
        Total

    ) ],
    {
        'ActualVolumeSize' => \%ActualVolumeSize_of,
        'AfsAvail' => \%AfsAvail_of,
        'AfsData' => \%AfsData_of,
        'AfsTotal' => \%AfsTotal_of,
        'AfsUsed' => \%AfsUsed_of,
        'AfsUsedPerDay' => \%AfsUsedPerDay_of,
        'HoleReserve' => \%HoleReserve_of,
        'IsAutosizeEnabled' => \%IsAutosizeEnabled_of,
        'MaximumSize' => \%MaximumSize_of,
        'OverwriteReserveAvail' => \%OverwriteReserveAvail_of,
        'OverwriteReserveTotal' => \%OverwriteReserveTotal_of,
        'OverwriteReserveUsed' => \%OverwriteReserveUsed_of,
        'SnapshotReserveAvail' => \%SnapshotReserveAvail_of,
        'SnapshotReserveTotal' => \%SnapshotReserveTotal_of,
        'SnapshotReserveUsed' => \%SnapshotReserveUsed_of,
        'SpaceAllocatedFromAggr' => \%SpaceAllocatedFromAggr_of,
        'Total' => \%Total_of,
    },
    {
        'ActualVolumeSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'AfsAvail' => 'MyTypes::VolumeSize::_AfsAvail',

        'AfsData' => 'MyTypes::VolumeSize::_AfsData',

        'AfsTotal' => 'MyTypes::VolumeSize::_AfsTotal',

        'AfsUsed' => 'MyTypes::VolumeSize::_AfsUsed',

        'AfsUsedPerDay' => 'MyTypes::VolumeSize::_AfsUsedPerDay',

        'HoleReserve' => 'MyTypes::VolumeSize::_HoleReserve',
        'IsAutosizeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',

        'MaximumSize' => 'MyTypes::VolumeSize::_MaximumSize',

        'OverwriteReserveAvail' => 'MyTypes::VolumeSize::_OverwriteReserveAvail',

        'OverwriteReserveTotal' => 'MyTypes::VolumeSize::_OverwriteReserveTotal',

        'OverwriteReserveUsed' => 'MyTypes::VolumeSize::_OverwriteReserveUsed',

        'SnapshotReserveAvail' => 'MyTypes::VolumeSize::_SnapshotReserveAvail',

        'SnapshotReserveTotal' => 'MyTypes::VolumeSize::_SnapshotReserveTotal',

        'SnapshotReserveUsed' => 'MyTypes::VolumeSize::_SnapshotReserveUsed',
        'SpaceAllocatedFromAggr' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',

        'Total' => 'MyTypes::VolumeSize::_Total',
    },
    {

        'ActualVolumeSize' => 'ActualVolumeSize',
        'AfsAvail' => 'AfsAvail',
        'AfsData' => 'AfsData',
        'AfsTotal' => 'AfsTotal',
        'AfsUsed' => 'AfsUsed',
        'AfsUsedPerDay' => 'AfsUsedPerDay',
        'HoleReserve' => 'HoleReserve',
        'IsAutosizeEnabled' => 'IsAutosizeEnabled',
        'MaximumSize' => 'MaximumSize',
        'OverwriteReserveAvail' => 'OverwriteReserveAvail',
        'OverwriteReserveTotal' => 'OverwriteReserveTotal',
        'OverwriteReserveUsed' => 'OverwriteReserveUsed',
        'SnapshotReserveAvail' => 'SnapshotReserveAvail',
        'SnapshotReserveTotal' => 'SnapshotReserveTotal',
        'SnapshotReserveUsed' => 'SnapshotReserveUsed',
        'SpaceAllocatedFromAggr' => 'SpaceAllocatedFromAggr',
        'Total' => 'Total',
    }
);

} # end BLOCK




package MyTypes::VolumeSize::_AfsAvail;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_AfsData;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_AfsTotal;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_AfsUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_AfsUsedPerDay;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_HoleReserve;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_MaximumSize;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_OverwriteReserveAvail;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_OverwriteReserveTotal;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_OverwriteReserveUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_SnapshotReserveAvail;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_SnapshotReserveTotal;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_SnapshotReserveUsed;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::VolumeSize::_Total;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::VolumeSize

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
VolumeSize from the namespace http://www.netapp.com/management/v1.

Collected Size information about a Volume. Optional items will not be returned if DFM does not know the Value.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ActualVolumeSize


=item * AfsAvail


=item * AfsData


=item * AfsTotal


=item * AfsUsed


=item * AfsUsedPerDay


=item * HoleReserve


=item * IsAutosizeEnabled


=item * MaximumSize


=item * OverwriteReserveAvail


=item * OverwriteReserveTotal


=item * OverwriteReserveUsed


=item * SnapshotReserveAvail


=item * SnapshotReserveTotal


=item * SnapshotReserveUsed


=item * SpaceAllocatedFromAggr


=item * Total




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::VolumeSize
   ActualVolumeSize =>  $some_value, # integer
   AfsAvail => $some_value, # atomic
   AfsData => $some_value, # atomic
   AfsTotal => $some_value, # atomic
   AfsUsed => $some_value, # atomic
   AfsUsedPerDay => $some_value, # atomic
   HoleReserve => $some_value, # atomic
   IsAutosizeEnabled =>  $some_value, # boolean
   MaximumSize => $some_value, # atomic
   OverwriteReserveAvail => $some_value, # atomic
   OverwriteReserveTotal => $some_value, # atomic
   OverwriteReserveUsed => $some_value, # atomic
   SnapshotReserveAvail => $some_value, # atomic
   SnapshotReserveTotal => $some_value, # atomic
   SnapshotReserveUsed => $some_value, # atomic
   SpaceAllocatedFromAggr =>  $some_value, # integer
   Total => $some_value, # atomic
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

