package MyTypes::WeeklySubscheduleInfo;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %EndDayOfWeek_of :ATTR(:get<EndDayOfWeek>);
my %ItemId_of :ATTR(:get<ItemId>);
my %StartDayOfWeek_of :ATTR(:get<StartDayOfWeek>);
my %SubscheduleId_of :ATTR(:get<SubscheduleId>);
my %SubscheduleName_of :ATTR(:get<SubscheduleName>);

__PACKAGE__->_factory(
    [ qw(        EndDayOfWeek
        ItemId
        StartDayOfWeek
        SubscheduleId
        SubscheduleName

    ) ],
    {
        'EndDayOfWeek' => \%EndDayOfWeek_of,
        'ItemId' => \%ItemId_of,
        'StartDayOfWeek' => \%StartDayOfWeek_of,
        'SubscheduleId' => \%SubscheduleId_of,
        'SubscheduleName' => \%SubscheduleName_of,
    },
    {

        'EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',

        'ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',

        'StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
        'SubscheduleId' => 'MyTypes::ObjId',
        'SubscheduleName' => 'MyTypes::ObjName',
    },
    {

        'EndDayOfWeek' => 'EndDayOfWeek',
        'ItemId' => 'ItemId',
        'StartDayOfWeek' => 'StartDayOfWeek',
        'SubscheduleId' => 'SubscheduleId',
        'SubscheduleName' => 'SubscheduleName',
    }
);

} # end BLOCK




package MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::WeeklySubscheduleInfo::_ItemId;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}



package MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek;
use strict;
use warnings;
{
# derivation by restriction
use base qw(
    SOAP::WSDL::XSD::Typelib::Builtin::integer);


}






1;


=pod

=head1 NAME

MyTypes::WeeklySubscheduleInfo

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
WeeklySubscheduleInfo from the namespace http://www.netapp.com/management/v1.

The Attributes of a weekly subschedule. May only be used in a weekly schedule.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * EndDayOfWeek


=item * ItemId


=item * StartDayOfWeek


=item * SubscheduleId


=item * SubscheduleName




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::WeeklySubscheduleInfo
   EndDayOfWeek => $some_value, # atomic
   ItemId => $some_value, # atomic
   StartDayOfWeek => $some_value, # atomic
   SubscheduleId => $some_value, # ObjId
   SubscheduleName => $some_value, # ObjName
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

