package MyTypes::WrapperOfPerfCounterGroup;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PerfCounterGroup_of :ATTR(:get<PerfCounterGroup>);

__PACKAGE__->_factory(
    [ qw(        PerfCounterGroup

    ) ],
    {
        'PerfCounterGroup' => \%PerfCounterGroup_of,
    },
    {
        'PerfCounterGroup' => 'MyTypes::PerfCounterGroup',
    },
    {

        'PerfCounterGroup' => 'PerfCounterGroup',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::WrapperOfPerfCounterGroup

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
WrapperOfPerfCounterGroup from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PerfCounterGroup




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::WrapperOfPerfCounterGroup
   PerfCounterGroup =>  { # MyTypes::PerfCounterGroup
     ApplianceNameOrId =>  $some_value, # string
     CounterGroupName =>  $some_value, # string
     CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
       PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
         CounterDescription =>  $some_value, # string
         CounterName =>  $some_value, # string
         IsCalculatedStats =>  $some_value, # boolean
         LabelNames =>  $some_value, # string
         Metrics =>  { # MyTypes::ArrayOfMetric
           Metric =>  { # MyTypes::Metric
             Id =>  $some_value, # string
             MetricResult =>  $some_value, # string
             Period => $some_value, # atomic
             Slide =>  $some_value, # string
             Type =>  $some_value, # string
             Value =>  $some_value, # string
           },
         },
         ObjectType =>  $some_value, # string
         PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
           PerfLabel =>  { # MyTypes::PerfLabel
             LabelNames =>  $some_value, # string
           },
         },
         TimeConsolidationMethod =>  $some_value, # string
       },
     },
     DataSources =>  { # MyTypes::ArrayOfPerfDataSource
       PerfDataSource =>  { # MyTypes::PerfDataSource
         ApplianceNameOrId =>  $some_value, # string
         CounterName =>  $some_value, # string
         GroupNameOrId =>  $some_value, # string
         InstanceName =>  $some_value, # string
         LabelNames =>  $some_value, # string
         ObjectFullName => $some_value, # ObjFullName
         ObjectName =>  $some_value, # string
         ObjectNameOrId => $some_value, # ObjNameOrId
         ObjectType =>  $some_value, # string
       },
     },
     DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
       PerfDataSource =>  { # MyTypes::PerfDataSource
         ApplianceNameOrId =>  $some_value, # string
         CounterName =>  $some_value, # string
         GroupNameOrId =>  $some_value, # string
         InstanceName =>  $some_value, # string
         LabelNames =>  $some_value, # string
         ObjectFullName => $some_value, # ObjFullName
         ObjectName =>  $some_value, # string
         ObjectNameOrId => $some_value, # ObjNameOrId
         ObjectType =>  $some_value, # string
       },
     },
     EndTime =>  $some_value, # integer
     GroupNameOrId =>  $some_value, # string
     IsDefault =>  $some_value, # boolean
     IsDisableAll =>  $some_value, # boolean
     IsStopped =>  $some_value, # boolean
     NumberRecords =>  $some_value, # integer
     PerfFileName =>  $some_value, # string
     RealTime =>  $some_value, # boolean
     SampleBuffer =>  $some_value, # integer
     SampleRate =>  $some_value, # integer
     SpaceConsumed =>  $some_value, # unsignedLong
     SpaceProjected =>  $some_value, # unsignedLong
     StartTime =>  $some_value, # integer
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

