package MyTypes::WrapperOfPerfDataSource;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %PerfDataSource_of :ATTR(:get<PerfDataSource>);

__PACKAGE__->_factory(
    [ qw(        PerfDataSource

    ) ],
    {
        'PerfDataSource' => \%PerfDataSource_of,
    },
    {
        'PerfDataSource' => 'MyTypes::PerfDataSource',
    },
    {

        'PerfDataSource' => 'PerfDataSource',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::WrapperOfPerfDataSource

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
WrapperOfPerfDataSource from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * PerfDataSource




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::WrapperOfPerfDataSource
   PerfDataSource =>  { # MyTypes::PerfDataSource
     ApplianceNameOrId =>  $some_value, # string
     CounterName =>  $some_value, # string
     GroupNameOrId =>  $some_value, # string
     InstanceName =>  $some_value, # string
     LabelNames =>  $some_value, # string
     ObjectFullName => $some_value, # ObjFullName
     ObjectName =>  $some_value, # string
     ObjectNameOrId => $some_value, # ObjNameOrId
     ObjectType =>  $some_value, # string
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

