package MyTypes::WrapperOfResourceIdentifier;
use strict;
use warnings;


__PACKAGE__->_set_element_form_qualified(1);

sub get_xmlns { 'http://www.netapp.com/management/v1' };

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %ResourceIdentifier_of :ATTR(:get<ResourceIdentifier>);

__PACKAGE__->_factory(
    [ qw(        ResourceIdentifier

    ) ],
    {
        'ResourceIdentifier' => \%ResourceIdentifier_of,
    },
    {
        'ResourceIdentifier' => 'MyTypes::ResourceIdentifier',
    },
    {

        'ResourceIdentifier' => 'ResourceIdentifier',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::WrapperOfResourceIdentifier

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
WrapperOfResourceIdentifier from the namespace http://www.netapp.com/management/v1.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * ResourceIdentifier




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::WrapperOfResourceIdentifier
   ResourceIdentifier =>  { # MyTypes::ResourceIdentifier
     Aggregate =>  { # MyTypes::WrapperOfAggregateResource
       AggregateResource =>  { # MyTypes::AggregateResource
         AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
           AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
             AggregateId =>  $some_value, # unsignedInt
             AggregateName =>  $some_value, # string
           },
         },
         FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
           FilerResource =>  { # MyTypes::FilerResource
             FilerId =>  $some_value, # unsignedInt
             FilerName =>  $some_value, # string
           },
         },
       },
     },
     Dataset =>  { # MyTypes::WrapperOfDatasetResource
       DatasetResource =>  { # MyTypes::DatasetResource
         DatasetId =>  $some_value, # unsignedInt
         DatasetName =>  $some_value, # string
       },
     },
     Filer =>  { # MyTypes::WrapperOfFilerResource
       FilerResource =>  { # MyTypes::FilerResource
         FilerId =>  $some_value, # unsignedInt
         FilerName =>  $some_value, # string
       },
     },
     Group =>  { # MyTypes::WrapperOfGroupResource
       GroupResource =>  { # MyTypes::GroupResource
         GroupId =>  $some_value, # unsignedInt
         GroupName =>  $some_value, # string
       },
     },
     Host =>  { # MyTypes::WrapperOfHostResource
       HostResource =>  { # MyTypes::HostResource
         HostId =>  $some_value, # unsignedInt
         HostName =>  $some_value, # string
       },
     },
     Lun =>  { # MyTypes::WrapperOfLunResource
       LunResource =>  { # MyTypes::LunResource
         HostIdentifier =>  { # MyTypes::WrapperOfHostResource
           HostResource =>  { # MyTypes::HostResource
             HostId =>  $some_value, # unsignedInt
             HostName =>  $some_value, # string
           },
         },
         LunIdentifierNameOrId =>  { # MyTypes::WrapperOfLunNameOrId
           LunNameOrId =>  { # MyTypes::LunNameOrId
             LunId =>  $some_value, # unsignedInt
             LunName =>  $some_value, # string
           },
         },
         VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
           VolumeResource =>  { # MyTypes::VolumeResource
             AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
               AggregateResource =>  { # MyTypes::AggregateResource
                 AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                   AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                     AggregateId =>  $some_value, # unsignedInt
                     AggregateName =>  $some_value, # string
                   },
                 },
                 FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                   FilerResource =>  { # MyTypes::FilerResource
                     FilerId =>  $some_value, # unsignedInt
                     FilerName =>  $some_value, # string
                   },
                 },
               },
             },
             HostIdentifier =>  { # MyTypes::WrapperOfHostResource
               HostResource =>  { # MyTypes::HostResource
                 HostId =>  $some_value, # unsignedInt
                 HostName =>  $some_value, # string
               },
             },
             VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
               VfilerResource =>  { # MyTypes::VfilerResource
                 VfilerId =>  $some_value, # unsignedInt
                 VfilerNameOrUuid =>  $some_value, # string
               },
             },
             VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
               VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                 VolumeId =>  $some_value, # unsignedInt
                 VolumeName =>  $some_value, # string
               },
             },
           },
         },
       },
     },
     Policy =>  { # MyTypes::WrapperOfPolicyResource
       PolicyResource =>  { # MyTypes::PolicyResource
         PolicyId => $some_value, # ObjId
         PolicyName => $some_value, # ObjName
       },
     },
     Qtree =>  { # MyTypes::WrapperOfQtreeResource
       QtreeResource =>  { # MyTypes::QtreeResource
         HostIdentifier =>  { # MyTypes::WrapperOfHostResource
           HostResource =>  { # MyTypes::HostResource
             HostId =>  $some_value, # unsignedInt
             HostName =>  $some_value, # string
           },
         },
         QtreeIdentifierNameOrId =>  { # MyTypes::WrapperOfQtreeNameOrId
           QtreeNameOrId =>  { # MyTypes::QtreeNameOrId
             QtreeId => $some_value, # ObjId
             QtreeName => $some_value, # ObjName
           },
         },
         VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
           VolumeResource =>  { # MyTypes::VolumeResource
             AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
               AggregateResource =>  { # MyTypes::AggregateResource
                 AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                   AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                     AggregateId =>  $some_value, # unsignedInt
                     AggregateName =>  $some_value, # string
                   },
                 },
                 FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                   FilerResource =>  { # MyTypes::FilerResource
                     FilerId =>  $some_value, # unsignedInt
                     FilerName =>  $some_value, # string
                   },
                 },
               },
             },
             HostIdentifier =>  { # MyTypes::WrapperOfHostResource
               HostResource =>  { # MyTypes::HostResource
                 HostId =>  $some_value, # unsignedInt
                 HostName =>  $some_value, # string
               },
             },
             VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
               VfilerResource =>  { # MyTypes::VfilerResource
                 VfilerId =>  $some_value, # unsignedInt
                 VfilerNameOrUuid =>  $some_value, # string
               },
             },
             VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
               VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                 VolumeId =>  $some_value, # unsignedInt
                 VolumeName =>  $some_value, # string
               },
             },
           },
         },
       },
     },
     RbacRole =>  { # MyTypes::WrapperOfRbacRoleResource
       RbacRoleResource =>  { # MyTypes::RbacRoleResource
         RbacRoleId =>  $some_value, # unsignedInt
         RbacRoleName =>  $some_value, # string
       },
     },
     ResourceId =>  $some_value, # unsignedInt
     ResourcePool =>  { # MyTypes::WrapperOfResourcePoolResource
       ResourcePoolResource =>  { # MyTypes::ResourcePoolResource
         ResourcePoolId =>  $some_value, # unsignedInt
         ResourcePoolName =>  $some_value, # string
       },
     },
     StorageService =>  { # MyTypes::WrapperOfStorageServiceResource
       StorageServiceResource =>  { # MyTypes::StorageServiceResource
         StorageServiceId => $some_value, # ObjId
         StorageServiceName => $some_value, # ObjName
       },
     },
     Vfiler =>  { # MyTypes::WrapperOfVfilerResource
       VfilerResource =>  { # MyTypes::VfilerResource
         VfilerId =>  $some_value, # unsignedInt
         VfilerNameOrUuid =>  $some_value, # string
       },
     },
     VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateResource
       VfilerTemplateResource =>  { # MyTypes::VfilerTemplateResource
         VfilerTemplateId => $some_value, # ObjId
         VfilerTemplateName => $some_value, # ObjName
       },
     },
     Volume =>  { # MyTypes::WrapperOfVolumeResource
       VolumeResource =>  { # MyTypes::VolumeResource
         AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
           AggregateResource =>  { # MyTypes::AggregateResource
             AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
               AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                 AggregateId =>  $some_value, # unsignedInt
                 AggregateName =>  $some_value, # string
               },
             },
             FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
               FilerResource =>  { # MyTypes::FilerResource
                 FilerId =>  $some_value, # unsignedInt
                 FilerName =>  $some_value, # string
               },
             },
           },
         },
         HostIdentifier =>  { # MyTypes::WrapperOfHostResource
           HostResource =>  { # MyTypes::HostResource
             HostId =>  $some_value, # unsignedInt
             HostName =>  $some_value, # string
           },
         },
         VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
           VfilerResource =>  { # MyTypes::VfilerResource
             VfilerId =>  $some_value, # unsignedInt
             VfilerNameOrUuid =>  $some_value, # string
           },
         },
         VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
           VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
             VolumeId =>  $some_value, # unsignedInt
             VolumeName =>  $some_value, # string
           },
         },
       },
     },
   },
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

