package Data::PixarFileCreator;

use strict;

use Data::File::Directory;

sub new {
	my ( $class ) = @_;
	my $self = bless {}, $class;
	return $self;
}

sub set_root {
	my ( $self, $root ) = @_;
	$self->{root} = $root;
}
sub get_root { my ( $self ) = @_; return $self->{root} }

sub set_dir_count {
	my ( $self, $count ) = @_;
	$self->{dir_count} = $count;
}
sub get_dir_count { my ( $self ) = @_; return $self->{dir_count} }

sub set_template {
	my ( $self, $template ) = @_;
	$self->{template} = $template;
}
sub get_template { my ( $self ) = @_; return $self->{template} }

sub create_dirs {

	my ( $self ) = @_;
	
	for ( 1..$self->get_dir_count ) {
		my $d = Data::File::Directory->new;
		$d->set_name( $self->get_root . "/dir$_" );
		$d->create;
	}
}

sub create_files {

	my ( $self, $repeat ) = @_;

	# Make one of every file in the template

	for ( @{$self->get_template->get_files} ) {
		$_->set_name( $self->get_root . "/dir1/" . $_->get_name . '-1' );
		$_->set_fast( 1 );
		$_->create;
	}
	
	# Make multiple copies of every file in the directory
	
	for my $rep ( 1..$repeat ) {
		
		for ( @{$self->get_template->get_files} ) {
		
			my $name = $_->get_name;
			my $suffix = $rep + 1;
			$name =~ s/-1/-$suffix/;
			my $old_name = $_->get_name;
		
			my $result = `cp $old_name $name`;
		}
	}
	
	# Copy all the files in the directory to the other directories.
	
	for ( 2..$self->get_dir_count ) {
		my $from = $self->get_root . "/dir1";
		my $to = $self->get_root . "/dir$_";
		my $result = `cp $from/* $to`;
		print $result;
	}
}

1;
