{ package Dense::Agnostic::7mode::Aggr;

    use Tharn;
    use SPARSE::Resource::Filer qw(sparse_filer);
    use Params::Validate qw(validate SCALAR);
    use Dense::WackIron qw(iron_and_report); 
    use filer;

    sub wafliron_start (@)
    {
        my  ($A, %opts, $filer, $speed, $error_expected, $wait );

        $A  = shift();
        %opts = validate (@_, { Nodename=>{type=>SCALAR},
				Aggrname=>{ type=>SCALAR, optional=>1, default=>"$A->{name}" },
				error_expected=>{type=>SCALAR,optional=>1,default=>0,regex=>qr/^(0|1)$/},
				speed => { type=>SCALAR, default=>2000, regex=>qr/^\d+$/ },
				wait => { type=>SCALAR, default=>1, regex=>qr/^(0|1)$/ } }
			); 

         
        $filer = sparse_filer($opts{Nodename},{subTest => 1});
	$speed = $opts{speed};
	print "Speed value : $speed \n";
        eval {
            iron_and_report(filer => $filer , aggr => $A->{name}, error_expected => $opts{error_expected}, wait => $opts{wait}, speed => $speed);
        };
        if ($@) {
            die("Wafliron Failed with error message:$@");
        }
    }
=head2 $A->wafliron_wait(speed=>10, timeout=>120)
Wait for wafliron to complete within the given timeout

=item speed

Optional parameter to set wafl scan speed before waiting for wafliron run to complete

=item timeout

Duration within which wafliron has to complete

=cut

    sub wafliron_wait (@)
    {
	my ($A, %opts, $speed, $wafliron_status);

	$A = shift();
	%opts = validate (@_, { speed => { type=>SCALAR, optional=>1 },
				timeout => { type=>SCALAR, optional=>1, default=>900 }, }
			);

	my $timeout = time() + $opts{timeout};
	$speed = $opts{speed};
	if ($speed) {
	    $A->{F}->say(command=>"wafl scan speed $speed");
	}
	while (time() < $timeout) {
	    $wafliron_status = $A->{F}->say(command=>"aggr wafliron status $A->{name}");
	    if ($wafliron_status =~ /wafliron is not currently active/) {
		return 1;
	    } else {
		sleep 5;
	    }
	}
	die "Wafliron has not completed";
    }

=head2 $A->is_iron_active()

Returns 1 if iron is running on the aggr, else returns 0

=cut

    sub is_iron_active()
    {
	my ($A, $status);

	$A = shift();
	$status = $A->{F}->say(command=>"aggr wafliron status $A->{name}");
	if ($status =~ /wafliron is not currently active/) {
	    return 0;
	} else {
	    return 1;
	}
    }

    return 1;
}
