{ package   Dense::Agnostic::Cmode::Volume;
    use strict;
    use warnings;

    use Dense::Agnostic::Cmode::Volume::Sis_Fmap;    
    use Dense::Agnostic::Cmode::Volume::Snap_Fmap;    

    use vars    qw($Fmap $Vol_Fmap $Clone_Fmap);

    $Vol_Fmap   = {
        show    => {
            fname   => 'volume_show',
            m_args  => [qw(vserver volume)],
            d_args  => undef,
            retval  => undef,
        },

        offline => {
            fname   => 'volume_offline',
            m_args  => [qw(vserver volume)],
            d_args  => undef,
            retval  => undef,
        },

       online => {
            fname   => 'volume_online',
            m_args  => [qw(vserver volume)],
            d_args  => undef,
            retval  => undef,
        },

       destroy => {
            fname   => 'volume_destroy',
            m_args  => [qw(vserver volume)],
            d_args  => {force=>'true'},
            retval  => undef,
        },
       move =>  {
            fname   => 'volume_move',
            m_args  => [qw(vserver volume destination-aggregate)],
            d_args  => undef,
            retval  => undef,

        },
       copy =>  {
		    fname   => 'volume_copy',
		    m_args  => [qw(vserver volume destination-volume destination-aggregate)],
		    d_args  => undef,
		    retval  => undef,

       },
       unmount => {
	    fname   => 'volume_unmount',
	    m_args  => [qw(vserver volume)],
	    d_args  => {force=>'true'},
	    retval  => undef,
	   },

	   restrict => {
            fname   => 'volume_restrict',
            m_args  => [qw(vserver volume)],
            d_args  => undef,
            retval  => undef,
       },

        modify => {
            fname   => 'volume_modify',
            m_args  => [qw(vserver volume)],
            d_args  => undef,
            retval  => undef,
        },
         upgrade_start => {
		     fname   => 'volume_64bit_upgrade_start',
		     m_args  => [qw(vserver volume)],
		     d_args  => undef,
		     retval  => undef,
		},
		upgrade_status => {
		    fname   => 'volume_64bit_upgrade_status',
		    m_args  => [qw(vserver volume)],
		    d_args  => undef,
		    retval  => undef,
		},

       clone_create => {
            fname               => 'volume_clone_create',
            m_args              => [qw(vserver)],
			d_args 				=> undef,
			retval  			=> undef,
       },

       clone_split => {
            fname               => 'volume_clone_split_start',
            m_args              => [qw(vserver)],
			d_args 				=> {'foreground' => 'true'},
            retval		        => undef,
       },
   };

    $Clone_Fmap = {
       clone_start => {
            fname               => 'file_clone_create',
			m_args              => [qw(vserver volume)],
			d_args              => undef,
			retval              => undef,
       },
    };

    $Fmap   = {( @{[%$Sis_Fmap]}, @{[%$Vol_Fmap]}, @{[%$Clone_Fmap]}, @{[%$Snap_Fmap]})};

    return 1;
} #Package
