# -*- perl -*-
## @summary	Library that defines dense messages in BR.
## @description
##	        This file defines dense messages used by BR.
##
## @usage
##	Not to be used directly. To be invoked by lib/Dense/Constant/Message.pm.
##  Make sure that the @EXPORT variable defined in that file contains ALL
##  constants defined here.
## @author dl-drg-qa@netapp.com
## @author karthiks@netapp.com
## @status review
## @pod here

=head1 NAME

 Message_br.pm - Message file for dense operation. Contains BR specific
 messages.

=head1 SYNOPSIS

 Not to be used directly. To be invoked by lib/Dense/Constant/Message.pm.
 Make sure that the @EXPORT variable defined in that file contains ALL
 constants defined here.

=cut

package Dense::Constant::Message_br;

use strict;

#BEGIN {
#	use vars ('@ISA', '@EXPORT');
#	require	Exporter;
#
#	@ISA	= qw(Exporter);
#	@EXPORT	= qw(
#			BRConsts
#		    );
#}

our @Filer_Models = (
                       "FAS2040",
                       "FAS3040",
                       "FAS3050",
                       "FAS3070",
                       "FAS3140",
                       "FAS3160",
                       "FAS3170",
                       "FAS3210",
                       "FAS3240",
                       "FAS3260",
                       "FAS6030",
                       "FAS6040",
                       "FAS6070",
                       "FAS6080",
                       "FAS6210",
                       "FAS6240",
                       "FAS6280",
                       "VSA1000",
                       "VSA2000",
    # IBM Names
                       "N3400",    # equivalent to FAS2040
                       "N5300",    # equivalent to FAS3040
                       "N5500",    # equivalent to FAS3050
                       "N5600",    # equivalent to FAS3070
                       "N6040",    # equivalent to FAS3140
                       "N6060",    # equivalent to FAS3160
                       "N6070",    # equivalent to FAS3170
                       "N6210",    # equivalent to FAS3210
                       "N6240",    # equivalent to FAS3240
                       "N6260",    # equivalent to FAS3260
                       "N7600",    # equivalent to FAS6030
                       "N7700",    # equivalent to FAS6040
                       "N7800",    # equivalent to FAS6070
                       "N7900",    # equivalent to FAS6080
                       "N7550T",   # equivalent to FAS6210
                       "N7750T",   # equivalent to FAS6240
                       "N7950T",   # equivalent to FAS6280
        );

our %BRConsts = (
# the following messages are from common/dense/utils.c file
"-"                     => "-",
DENSE_OK                => "Operation succeeded",
DENSE_STOP              => "Operation was stopped",
DENSE_STOP_IDLE         => "Operation is currently idle",
DENSE_REVERTING         => "Revert is in progress",
DENSE_IRON_RUNNING      => "WAFL_Iron is running",
DENSE_VOL_NONEXIST      => "Volume does not exist",
DENSE_VOL_OFFLINE       => "Volume is offline",
DENSE_VOL_NOFLEX        => "Volume type has to be Flexvol",
DENSE_VOL_RDONLY        => "Volume is read-only",
DENSE_VOL_NOFLAG        => "Volume is not SIS enabled",
DENSE_VOL_BIG           => "Volume or maxfiles exceeded max allowed for SIS",
DENSE_VOL_TRANSITING    => "Volume state transition is in progress",
DENSE_VOL_RESTRICTED    => "Volume is restricted",
DENSE_NO_CHANGELOGGING  => "SIS logging is not enabled",
DENSE_SNAPSHOT_CREATE   => "Snapshot creation failed",
DENSE_SNAPSHOT_DELETE   => "Snapshot deletion failed",
DENSE_SNAPSHOT_NONEXIST => "Snapshot does not exist",
DENSE_METAFILE_CREATE   => "Creation of metafile failed",
DENSE_METAFILE_DELETE   => "Deletion of metafile failed",
DENSE_METAFILE_NONEXIST => "Metafile does not exist",
DENSE_METAFILE_READ     => "Read from metafile failed",
DENSE_METAFILE_WRITE    => "Write to metafile failed",
DENSE_METAFILE_GETATTR  => "Getattr on metafile failed",
DENSE_METAFILE_SETATTR  => "Setattr on metafile failed",
DENSE_METAFILE_RENAME   => "Rename of metafile failed",
DENSE_METAFILE_CHECK    => "Metafile check operation failed",
DENSE_METAFILE_INVAL_HDR=> "Metafile has invalid header",
DENSE_INVAL_SCHED       => "Invalid schedule string specified",
DENSE_NOT_CONFIGURED    => "Operation is not configured",
DENSE_NOT_ENABLED       => "Operation is not enabled",
DENSE_NOT_DISABLED      => "Operation is not disabled",
DENSE_ALREADY_ENABLED   => "Operation has already been enabled",
DENSE_ALREADY_DISABLED  => "Operation has already been disabled",
DENSE_REG_SET_FAILED    => "Failed to save configuration",
DENSE_REG_GET_FAILED    => "Failed to retrieve configuration",
DENSE_BUSY              => "Operation is currently active",
DENSE_IDLE              => "Operation is currently idle",
DENSE_CONCURRENT_LIMIT  => "Too many concurrent operations",
DENSE_SCAN_FAILED       => "Failed to start scanner",
DENSE_ABORTED           => "Operation was aborted",
DENSE_ABORT_PENDING     => "Operation was no longer pending",
DENSE_NOMEM             => "Not enough memory",
DENSE_PARTNER_UNSUP_OP => "Operation not supported on partner volume",
DENSE_IS_SV_TYPE        => "Invalid operation on a SnapVault secondary volume",
DENSE_UNINITIALIZED     => "SIS is not initialized",
DENSE_NOT_LICENSED      => "SIS is not licensed",
DENSE_LICENSE_EXPIRED   => "SIS license has expired",
DENSE_INVAL_CONFIG_FILE => "SIS configuration file content is invalid",
DENSE_CREATE_MISSING_CONFIG => "Creating missing configuration for SIS volume",
DENSE_PROCESS_CREATE    => "Not enough internal resources",
DENSE_LOGFILE_WRITE     => "Not enough disk space in root volume to log information",
DENSE_LOGFILE_CREATE    => "Creation of undo log file failed",
DENSE_RESTART_FAIL      => "Checkpoint restore failed",
DENSE_CHKPNT_EXPIRED    => "Checkpoint is older than expected",

DENSE_STALE_DINODE      => "Stale donor inode",
DENSE_STALE_RINODE      => "Stale recipient inode",
DENSE_STALE_DBUF        => "Donor block no longer exists",
DENSE_STALE_RBUF        => "Recipient block no longer exists",
DENSE_DATA_MISMATCH     => "Data block mismatch",
DENSE_MAX_REFCOUNT      => "Too many references",
DENSE_HOLE_RERVD        => "The recipient file has hole reservation",
DENSE_VOL_DIFF          => "Donor and recipient exist on different volume",
DENSE_DONOR_TOO_SMALL   => "The donor file is too small",
DENSE_RECIPIENT_TOO_SMALL => "The recipient file is too small",
DENSE_NO_SPACE          =>  "Not enough disk space for the operation",
DENSE_SHARE_NO_SPACE          =>  "Not enough disk space for the operation",
DENSE_NO_INODE          => "Not enough inodes exist for the operation",
DENSE_SHUTDOWN          => "System is shutting down",
DENSE_FAILOVER          => "System is doing takeover or giveback",
DENSE_DONOR_RANGE       => "Donor file is out of range",
DENSE_RECPT_RANGE       => "Recipient file is out of range",
DENSE_VFILER_ACCESS     => "VFiler doesn't have access to the Volume",
DENSE_VFILER_LIMIT      => "Maximum SIS operation limit reached on VFiler",
DENSE_VFILER_NOEXIST    => "VFiler doesn't exist",
DENSE_VFILER_NO_ACCESS	=> "VFiler does not have access to the Volume",
MAX_DENSE_VFILER_OPS	=> "8",

DENSE_SAME_VBN          => "Blocks have already been shared",
DENSE_SAME_CONTENT      => "Blocks have the same content",
DENSE_UNSUPPORTED_VOLUME => "ASIS is not supported on this volume Type",
DENSE_CLONE_SPLITTING   => "Clone split is running on the volume",
DENSE_CLONE_SRC_RANGE_CHECK => "Source block range out of file",
DENSE_CLONE_DST_RANGE_CHECK => "Destination block range out of file",
DENSE_QUOTA_CHECK		=> "Quota check failed",

# the following messages are strings returned by command line.
DENSE_SIS_FOR           => "SIS for",
DENSE_OP_MESSAGE        => "The SIS operation for",
DENSE_OP_STARTED        => "is started.",
DENSE_OP_ON 	         => "The operation on",
DENSE_OP_STOPPED        => "is being stopped.",
DENSE_OP_ENABLED	     => "is enabled.",
DENSE_OP_DISABLED	     => "is disabled.",
DENSE_UNDO_WRONG		=> "The 'sis undo -t wrong -d' command detected improperly shared inodes in the volume 'sisundo'. Run the 'sis undo -t wrong' or 'sis undo -i' command to remove improperly shared inodes. Details about improperly shared inodes are available at",
DENSE_UNDO_RM_WRONG		=> "The 'sis undo -t wrong' command removed sharings on improperly shared inodes in the volume 'sisundo'. Details about cleaned inodes are available at",

# These are SIS related messages returned by the revert_to command on the filer
DENSE_CANNOT_REVERT     => "Cannot revert the volume (\\S+) because volume size or maxfiles exceeded max allowed for SIS.",
DENSE_RUN_REVERT        => "Please revert SIS metafiles on Volume (\\S+)",
DENSE_UPGRADE_NOT_DONE  => "SIS metafiles upgrade not yet done",
DENSE_DOWNGRADE_EXIST   => "Previously downgraded SIS metafiles exists",
DENSE_REVERT_SUCCESS	=> "'sis revert_to' command has succeeded on volume",

# JSM - these are new.  they replace the three messages below.  these actually
# are different between GB and IC/BR.
WAFL_MAX_DENSE_SIZE_EXCEEDED     => "vol size: Selected SIS volume size is too large",
WAFL_MAX_DENSE_AUTOSIZE_EXCEEDED => "vol autosize: Selected SIS volume size is too large",
WAFL_MAX_VOL_SIZE_EXCEEDED		 => "vol size: Selected volume size is too large",
WAFL_MAX_VOL_AUTOSIZE_EXCEEDED	 => "vol autosize: Selected volume size is too large",

# the following message are strings from cmds/vol.c
# JSM - These should go away.  They remain here for legacy support:
WAFL_MAX_DENSE_SIZE_MB_SPECIFIED => "vol size: Specified SIS volume size is too large",
WAFL_MAX_DENSE_SIZE_MB_SELECTED  => "vol autosize: Selected SIS volume size is too large",
WAFL_MAX_DENSE_SIZE_IC_SPECIFIED => "Selected Volume size is too large",

# the following message are strings from cmds/dense.c
DENSE_CONFIG_NOT_FOUND  => "No Config entry found",
DENSE_STAT_NOT_FOUND    => "No statistics entry found",
DENSE_STATUS_NOT_FOUND  => "No status entry found",
DENSE_FINGER_PRINT      => "Fingerprints of",
DENSE_VERIFY            => "are being verified.",

# the following message are strings from dense/admin.c
DENSE_ASIS2_DEFAULT_SCHED_STR => 'sun-sat@0',
DENSE_ASIS1_DEFAULT_SCHED_STR => '-',

# The following constants are for options
DENSE_OPT_ALLOW_PLATFORMS => "sis.allow_platforms",
DENSE_OPT_ON => "on",
DENSE_OPT_OFF => "off",
SIS_MAX_ACTIVE_OPS => "8",

clog0_name  =>  "clogdir.0",
clog1_name  =>  "clogdir.1",

# Release specific failure messages can be catagorized here
COMPRESSION_NOT_ACTIVE => "Compression of existing data is not active on volume",

# Starting sis on snapmirror secondary gives different errors in different releases
DENSE_START_SECONDARY    => "Volume is read-only",

# Sis status returns different messages for renamed volumes in GB/IC and BR
DENSE_VOL_RENAMED       => "Volume does not exist", 
# Sis status returns different messages for non existant volumes in different releases
DENSE_NONEXISTENT_VOL	=> "Volume does not exist", 

# The following messages are returned in /etc/messages
MESG_DELETE_SNAP => "deleted by the Data ONTAP function dense_delete_snapshot",

# Maximum volume size possible on BR codelines for 32 bit volumes, in GB
MAX_DENSE_VOL_SIZE      => "14716g",

# Minimum blocks that sis metafiles can occupy in aggregate
MIN_BLOCKS_DENSE_METAFILES_AGGR => "64",

# Maximum Volume Size Table, moved from Command.pm
# NOTE these values apply to BR.0 with 32-bit aggregates for BR.0 with 64-bit
# aggregates, entries that return 14716g should be replaced withwith 16384g.
VOL_SIZE_LIMIT => { map {$_=>'14716g'} @Filer_Models },
    # BRSizes
LA_VOL_SIZE_LIMIT => { map {$_=>'16384g'} @Filer_Models },
);
#BRConsts

# end of file
1;
