# -*- perl -*-
## @summary Library that defines dense constants
## @usage
##	use Dense::Constants;
##
## @author dl-dpgqa-automation@netapp.com
## @status under development

package Dense::Constants;
use strict;

use constant DFLT_VOLNAME		=> "dense_vol";
use constant DFLT_VOLNAME_PURGE	=> "dense_vol_purge";
use constant DFLT_AGGRNAME		=> "dense_aggr";
use constant DFLT_VOLSIZE		=> "5g";
use constant DFLT_AGGRSIZE		=> "5";		# number of disks
use constant DFLT_MIN_AGGRSIZE	=> "7340032";	# in KB - 7GB
use constant DFLT_FILER_CONN	=> "#rsh-socket";
use constant MIN_SHARE_BLKS		=> "1";
use constant HIGH_END_MIN_MEMORY=> "8192"; # memory size of FAS3070 in MB, low-end platforms should have less memory than this and high-end greater or equal

our %DENSE_FSFLAGS_LIST =
(
	FSFLAGS_NEEDS_INOMAP_BITS		=> 0x0000000000000001,
	FSFLAGS_NEEDS_FLAGS_CLEANUP		=> 0x0000000000000002,
	FSFLAGS_SPLITTING_BLOCKMAP		=> 0x0000000000000004,
	FSFLAGS_TYPE_BITS_VALID			=> 0x0000000000000008,
	FSFLAGS_NEEDS_STRMDIR_CLEANUP	=> 0x0000000000000010,
	FSFLAGS_QUOTANAME_CLEANUP		=> 0x0000000000000020,
	FSFLAGS_ACTIVE_CHKSM_CLEAR		=> 0x0000000000000040,
	FSFLAGS_CHKSUM_CLEAR			=> 0x0000000000000080,
	FSFLAGS_CLEAN_SUMMARY	  		=> 0x0000000000000100,
	FSFLAGS_FS_ALMOST_FULL	  		=> 0x0000000000000200,
	FSFLAGS_COPY_CLEANUP	  		=> 0x0000000000000400,
	FSFLAGS_OWNBLOCKS_VALID	  		=> 0x0000000000000800,
	FSFLAGS_LASTWACK_BOOT	  		=> 0x0000000000001000,
	FSFLAGS_FS_IS_DIRTY				=> 0x0000000000002000,
	FSFLAGS_NEEDS_TID_CLEANUP  		=> 0x0000000000004000,
	FSFLAGS_SPLITTING_INOFILE  		=> 0x0000000000008000,
	FSFLAGS_SPCRES_UPGRADE_NEEDED	=> 0x0000000000010000,
	FSFLAGS_UPGRADING_INOFILE		=> 0x0000000000020000,
	FSFLAGS_KILL_OLD_INOFILE		=> 0x0000000000040000,
	FSFLAGS_CLEAN_FLAGS_PRE_UPGRADE	=> 0x0000000000080000,
	FSFLAGS_SNAP_CLEANUP			=> 0x0000000000100000,
	FSFLAGS_SPARSE_VOLUME			=> 0x0000000000200000,
	FSFLAGS_VOL_IS_FLEX				=> 0x0000000000400000,
	FSFLAGS_PENDING_REPLAY	 		=> 0x0000000000800000,
	FSFLAGS_VOL_HAS_I2P				=> 0x0000000001000000,
	FSFLAGS_NEEDS_WORM_SCAN	 		=> 0x0000000002000000,
	FSFLAGS_NEEDS_NRV_CLEANUP		=> 0x0000000004000000,
	FSFLAGS_DECOMPRESS_VOLUME	 	=> 0x0000000008000000,
	FSFLAGS_SPLIT_AGGR				=> 0x0000000010000000,
	FSFLAGS_DENSE					=> 0x0000000020000000,
	FSFLAGS_VOL_IS_NG				=> 0x0000000040000000,
	FSFLAGS_SUMMARY_STALE			=> 0x0000000080000000,
);

### FSFLAGS
use constant DENSE_FSFLAGS => \%DENSE_FSFLAGS_LIST;

use vars ('@ISA', '@EXPORT');
require Exporter;
@ISA    = qw(Exporter);
@EXPORT = qw(
	     DFLT_VOLNAME 
	     DFLT_VOLNAME_PURGE
	     DFLT_AGGRNAME 
	     DFLT_VOLSIZE 
	     DFLT_AGGRSIZE 
	     DFLT_MIN_AGGRSIZE 
	     DFLT_FILER_CONN
	     MIN_SHARE_BLKS
		 DENSE_FSFLAGS
		 DENSE_FSFLAGS_LIST
		 HIGH_END_MIN_MEMORY
	);

1;
