# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/Dense/cmode/api/dense_cmds.pm#1 $

## @summary
## @author arvindks@netapp.com
## @status draft
## @pod here

=head1 NAME

Dense::cmode::api::dense_cmds - Dense commands library

=head1 DESCRIPTION

This library contains the interfaces for dense apis. It would have two sub-classes one for cli and another for zapi

=head1 SEE-ALSO

Dense::cmode::api::dense_cmds_cli.pm and Dense::cmode::api::dense_cmds_zapi.pm

=head1 ROUTINES

dense_on()
dense_start()
dense_status()
dense_stop()
dense_off()

All these methods has to be implemented by the sub-classes inheriting this class

=cut

package Dense::cmode::api::dense_cmds;

use strict;
use warnings;
use Tharn;
use base qw(Exporter);
use Params::Validate qw(validate validate_pos OBJECT SCALAR BOOLEAN HASHREF ARRAYREF UNDEF);
use Server;

sub new {
	my $class = shift;
	my (%opt) = validate(@_, {	
								filer	=> {type=>SCALAR, optional=>1 },
								server	=> {type=>OBJECT, optional=>1 },
								volume	=> {type=>SCALAR, optional=>1 },
								vserver	=> {type=>SCALAR, optional=>1 },
#								aggr	=> {type=>SCALAR, optional=>1 },
							});
	die("filer or server is an required parameter") if(!$opt{filer} && !$opt{server});
	$opt{server} = Server->new(nodes=>$opt{filer}) if(!$opt{server});
	
	my $self = \%opt;
	bless $self, $class;
	return $self;
	
}

1;
