# $Id: //depot/prod/test/Rsierranevada/lib/Dense/setup_simple.pl#2 $
#
# Basic testing environment
#
use strict;

# ------------------------------------------------------------------------
#
use filer;
use Tharn;
use Volume;
use SPARSE::Util::Logger;
use SPARSE::Util::FSTest0;
use SPARSE::Util::FileIO;
use SPARSE::Resource::Filer;
use SPARSE::Resource::Volume;

use Dense::Constants;
use Dense::Constant::Message;
use Dense::Constant::Message qw($DENSE_ONTAP_VERSION $AGGR_NAME);
use Dense::Constant::Command;
use Dense::storagemotion;
use Dense::Status qw($PARSE_STRICT);
use Dense::Utils;
use Dense::Utils qw($CHECK_32K_REFCNT);
use Dense::TestData;
use Dense::WackIron;
use Dense::dense_vfiler;
use Dense qw(:all);

use Dense::sis_zapi;
use Dense::sis_zapi qw(:all);

use Dense::Clone qw(:all);
use Dense::Constant::Clone_Command;
use Dense::Constant::Clone_Message;
#use Filer::Version qw(:get_wafl_version get_ontap_version);
use TestUtils;

# ------------------------------------------------------------------------
# parameters
use Filer::Version qw(get_wafl_version);
use vars qw($ONTAPDIR $FILER $FILER_CONN $CLIENT $CLIENT_CONN $PATH_NAME
        $TIMEOUT $SUDO_PATH $ENABLE_COMPRESSION $MIN_SHARE_BLKS
        $DENSE_ONTAP_VERSION $SITE $DENSE_DATA_MOTION_NOT_SUPP
        $DENSE_REP_NOT_SUPP $DENSE_CLONE_VFILER_NOT_SUPP $DENSE_IOD_NOT_SUPP
        $FILER_DST $DENSE_NDVM_NOT_SUPP $DENSE_COMPRESSION_NOT_SUPP $DEFAULT_DLOG_SIS_FILES
        $CHECK_32K_REFCNT $PARSE_STRICT $DENSE_SORT_IMP_NOT_SUPP $DENSE_BLK_SHARE_IMP_NOT_SUPP 
		$DENSE_REF_CNT_IN_CP_NOT_SUPP $DENSE_RR_FEATURE_NOT_SUPP $DENSE_WAFL_CHECK_NOT_SUPP $RR_BRANCH);

param("ONTAPDIR",       "-default", "/rlse/mainN");
param("FILER",          "-mesg",    "Filer name");
param("FILER_CONN",     "-default", DFLT_FILER_CONN);
param("CLIENT",         "-default", "localhost");
param("CLIENT_CONN",    "-default", "#rsh");
param("PATH_NAME",      "-default", "");
param("TIMEOUT",        "-default", "7200");
param("SUDO_PATH",      "-default", "/usr/local/bin/sudo");
param("ENABLE_COMPRESSION",      "-default", "0");
param("MIN_SHARE_BLKS",      "-default", Dense::Constants::MIN_SHARE_BLKS);
param("DEFAULT_DLOG_SIS_FILES",      "-default", 2);
param("CHECK_32K_REFCNT",      "-default", 1);
param("PARSE_STRICT",      "-default", 1);
param("AGGR_NAME",      "-default", "dense_aggr");

print("Beginning of setup_simple.pl");
## Change the filer_cli_say() timeout value 
$filer::FILER_CLI_SAY_TIMEOUT = 900;

### Add new input param "DENSE_ONTAP_VERSION". Default value is current filer version
param("DENSE_ONTAP_VERSION",          "-default",    "SN");
param("DENSE_DATA_MOTION_NOT_SUPP", "-default", 1);
param("DENSE_CLONE_VFILER_NOT_SUPP", "-default", 1);
param("DENSE_REP_NOT_SUPP", "-default", 1);
param("DENSE_IOD_NOT_SUPP", "-default", 1);
param("DENSE_NDVM_NOT_SUPP", "-default", 1);
param("DENSE_COMPRESSION_NOT_SUPP", "-default", 1);
param("DENSE_SORT_IMP_NOT_SUPP", "-default", 1);
param("DENSE_BLK_SHARE_IMP_NOT_SUPP", "-default", 1);
param("DENSE_REF_CNT_IN_CP_NOT_SUPP", "-default", 1);
param("DENSE_RR_FEATURE_NOT_SUPP", "-default", 1);
param("DENSE_WAFL_CHECK_NOT_SUPP", "-default","0");
param('RR_BRANCH', '-default', undef); # Should be removed after all the fixes in RR merges in to the main

my $fh = host($FILER);
my $site = guess_site($fh);
param("SITE","-default",$site);

## my $sudo;
## if (defined($SUDO_PATH)) {
##      $SUDO_PATH =~ s%/sudo$%%;
##      $sudo = $SUDO_PATH . "/sudo";
## } else {
##      $sudo = "sudo";
## }


my $wafl_version = Filer::Version::get_wafl_version(host($FILER));
my $source_ontap = Filer::Version::get_ontap_version(host($FILER));

if ($wafl_version >= Filer::Version::WV_ROLLINGROCK_MIN){
	logcomment("ONTAP Version number: $wafl_version");
	$DENSE_RR_FEATURE_NOT_SUPP = 0;
}

if ( $DENSE_ONTAP_VERSION eq "RR" ) {
    $DENSE_SORT_IMP_NOT_SUPP = 0;
    print(" inside RR $DENSE_SORT_IMP_NOT_SUPP ");
    $DENSE_BLK_SHARE_IMP_NOT_SUPP = 0;
    $DENSE_REF_CNT_IN_CP_NOT_SUPP = 0;
    $DENSE_WAFL_CHECK_NOT_SUPP = 1;
}
if(defined($FILER_DST)) {
    my $dest_ontap = Filer::Version::get_ontap_version(host($FILER_DST));
    if( ($source_ontap eq "7.3") && ($dest_ontap eq "7.3") ){
	if( get_wafl_version(host($FILER)) > 19743 && get_wafl_version(host($FILER_DST)) > 19743 ){
	    $DENSE_DATA_MOTION_NOT_SUPP = 0;
        }
     }
} else {
    if( $source_ontap eq "7.3" ){
	if( $wafl_version > 19743 ){
	    $DENSE_DATA_MOTION_NOT_SUPP = 0;
	}
    }
}
if ($source_ontap eq "7.3") {
    if ( $wafl_version > 19743 ) {
	$DENSE_CLONE_VFILER_NOT_SUPP = 0;
	$DENSE_IOD_NOT_SUPP = 0;
	$DENSE_REP_NOT_SUPP = 0;
    }

} elsif($source_ontap eq "8.0") {
    if ( $wafl_version >= 21057 ) {
	$DENSE_NDVM_NOT_SUPP = 0;
	$DENSE_CLONE_VFILER_NOT_SUPP = 0;
	$DENSE_IOD_NOT_SUPP = 0;
	$DENSE_REP_NOT_SUPP = 0;
	$DENSE_COMPRESSION_NOT_SUPP = 0;
	$DENSE_SORT_IMP_NOT_SUPP = 0;	
	print (" inside BR $DENSE_SORT_IMP_NOT_SUPP ");
    }
} elsif($source_ontap eq "8.1") {
	$DENSE_IOD_NOT_SUPP = 0;
	$DENSE_REP_NOT_SUPP = 0;
	$DENSE_NDVM_NOT_SUPP = 0;
} elsif($source_ontap eq "8.2") {
	$DENSE_REP_NOT_SUPP = 0;
}




# ------------------------------------------------------------------------

1;
