# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Exception for Abort SFO states
## @author hrivera@netapp.com
## @status private
## @pod here

package EventMan::Exceptions::EncounteredSFOAbortState;

use base qw(NATE::BaseException);

sub new {
    my $pkg = shift;
    my (%args) = @_;

    my $text = delete $args{text};

    my $self = $pkg->SUPER::new($text, %args);

    $self->{node_sf_output} = $args{node_sf_output};
    $self->{nodename} = $args{nodename};
    $self->{abort_state} = $args{abort_state};

    return $self;
}

sub get_node_sf_output {
    my $self = shift;

    if (not defined($self->{node_sf_output})) {
        $self->{node_sf_output} = {};
    }

    return $self->{node_sf_output};
}

sub get_nodename {
    my $self = shift;

    if (not defined($self->{nodename})) {
        $self->{nodename} = ""
    }

    return $self->{nodename};
}

sub get_abort_state {
    my $self = shift;

    if (not defined($self->{abort_state})) {
        $self->{abort_state} = ""
    }

    return $self->{abort_state};
}

1;
