# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Exception for when an unexpected SFO state is encountered
## @author hrivera@netapp.com
## @status private
## @pod here

package EventMan::Exceptions::UnexpectedSFOState;

use base qw(NATE::BaseException);

sub new {
    my $pkg = shift;
    my (%args) = @_;

    my $text = delete $args{text};

    my $self = $pkg->SUPER::new($text, %args);

    $self->{sf_output} = $args{sf_output};
    return $self;
}

sub get_sf_states {
    my $self = shift;

    if (not $self->{sf_output}) {
        $self->{sf_output} = [];
    }

    return wantarray() ? @{$self->{sf_output}} : $self->{sf_output};
}

1;
