# -*- perl -*-
#  $Id: //depot/prod/test/Rsierranevada/lib/FPolicy/VFiler.pm#1 $


## @summary Library of FPolicy VFiler
## @author  sureshb@netapp.com
## @status  private
## @pod     here

package FPolicy::VFiler;

use strict;

use warnings;
use Utils qw(make_host make_conn);
use Params::Validate qw(validate_pos validate BOOLEAN SCALAR ARRAYREF HASHREF OBJECT);
use Tharn qw(say logcomment logresult);
use Carp qw(croak);
use SayWrap qw(sayEOF);
use Subtest;
use VFILER::Util;
use FPolicy::Execute;
use FPolicy::Utils qw(make_NV make_hash_fromArrayHash make_connection);
use FPolicy::Grammer;
use FPolicy::Parser;
use FPolicy::Generator;

BEGIN {
	require "FPolicy/commonParams.pl";

	our @EXPORT = qw(
			vf_create
			vf_run
			vf_destroy
		);
};


sub new
{
	my $object = shift;
	my $class = ref($object) || $object;

	my %NV = make_NV(@_);

	my $CLI = {
		name  =>  $NV{name}
	};

	bless($CLI, $class); 
	return $CLI;
}


sub vf_create($@)
{
	my $self = shift;
	my @params = @_;
	my %NV = make_hash_fromArrayHash(@params);

	my $conn = $NV{conn};
	my $hostrec = $NV{conn}->hostp();
	my %param = $hostrec->param_fields();

	my $vfname = "vf1";
	my $fc = $NV{hostspec};
	my $ipsname = "default-ipspace";
	my $gateway="172.17.180.1";

#	return eval {
#		VFILER::Util::vfiler_create_non_default_ipspace($fc, $vfname, $ipsname,
#			if_to_use => $NV{if_to_use}, 
#			ipaddr_paths=>"-i 172.17.180.241 /vol/vol1" ) or
#			die("can't create $vfname using non-default ipspace: $@");
#
#		VFILER::Util::vfiler_run_vfiler_setup($fc, $vfname,
#			if_to_use => $NV{if_to_use}, 
#			netmask=>$NV{netmask}, 
#			dnsdomain => "lab.netapp.com", 
#			dnsserver => "172.19.2.30", 
#			dnsserver1 => "172.19.3.32", 
#			dnsserver2 => "172.19.4.34", 
#			nisdomain=>"",
#			nisserver=>"",
#			ipaddr_count=>"") or
#			die("vfiler run $vfname setup failed: $@");
#
#		VFILER::Util::vfiler_run_vfiler_add_default_route($fc, $vfname, $gateway) or
#			die("can't add a default route for $vfname: $@");
#
#		if (!$NV{no_cifs}) {
#			VFILER::Util::vfiler_run_vfiler_cifs_setup($fc, $vfname,
#				wins_ipaddr1=>"",
#				wins_ipaddr2=>"",
#				wins_ipaddr_count=>"",
#				workgroup_name=>"",
#				user_auth_type=>"",
#				cifs_name=>"",
#				wins_domain=>"cifs.lab.netapp.com",
#				wins_user=>"Administrator",
#				wins_user_passwd=>"BigCheese"
#			) or die("vfiler run $vfname cifs setup failed: $@");
#		}
#
#		VFILER::Util::vfiler_run_vfiler_exportfs($fc, $vfname, "/vol/vol1") or
#			die("vfiler run $vfname exportfs -i -o anon=0 /vol/vol1 failed: $@");
#
#		return(1);
#	};

}

sub vf_run
{
	my %NV = validate(@_, { 
		conn => {type => HASHREF},
		vfiler => {type => SCALAR, regex => qr/(\w+)/},
		cmd => {type => SCALAR, regex => qr/((\s)+(\w+)(\s)+)+/},
		args => {type => HASHREF, optional => 1}
		});

	return 
	vfiler_run($NV{conn}, $NV{vfiler}, $NV{cmd}, $NV{args});
}

sub testme
{
#	package main;
#	our ($FILER, $FILER_CONN, $CLIENT, $POLICY, $VFILER, $NETMASK_X);

#	param('FILER',       '-mesg',    "Filer to test");
#	param('FILER_CONN','-default',"#rsh");
#	param('VFILER',       '-mesg',    "VFiler to test");
	
#	use FPolicy::VFiler;
	my $FILER = "nss-u50";
	my $VFILER = "vf1";
	my $vf = new FPolicy::VFiler ("name=$VFILER");
	my $ptr = make_connection("conn_type=cli", "filer=$FILER");

	$vf->vf_create(hostspec => ${$ptr}{conn}, 
		conn => ${$ptr}{conn},
		filer => "$FILER", 
		vfiler => "$VFILER", 
		if_to_use => "e0b", 
		ip_to_use => "172.17.180.241", 
		ipsname => "isp1",
		vol => "/vol/vol1",
		netmask => "255.255.252.0", 
#		dnsdomain => "lab.netapp.com", 
#		dnsserver => "172.19.2.30",
#		dnsserver1 => "172.19.3.32",
#		dnsserver2 => "172.19.4.34",
#		user_auth_type => "ad", 
#		ipaddr_paths => "-i 172.17.180.241 \/vol\/vol1", 
#		rdate_server => "mir", 
#		aduser_passwd => "BigCheese", 
#		cifs_name => "Administrator\@cifs.lab.netapp.com",
#		aduser => "Administrator\@cifs.lab.netapp.com"
		);

}
1;
