# -*- perl -*-

## @summary legacy script for defaulting commonly-used parameters
## @author mcrae@netapp.com, dl-waflqa@netapp.com
## @status public
## @pod here

=head1 NAME

FS::commonParams.pl - provide legacy support for managing commonly-used parameters

=head1 SYNOPSIS

    use Tharn;

    # set param values here, before loading FS::commonParams
    param('EXAMPLE_PARAM', -default, 'example_value');

    # load the module
    require "FS/commonParams.pl";

=head1 DESCRIPTION

commonParams - this module provides backwards-compatible support for legacy test code. newer
               code should use FS::commonParams.pm.

=head1 STATUS

  Shared

=head1 AUTHOR

  mcrae@netapp.com, dl-waflqa-automation@netapp.com
  $Id$
  Last revised $Date: 2008/09/02 $

=head1 COPYRIGHT

  Copyright 2008, Network Appliance Inc., All Rights Reserved.

=cut

use FS::commonParams;

# this declares the common parameters in the 'main' package, and sets default
# values for any of them which are undefined.
FS::commonParams->new(set_legacy_defaults => 1);

