#!perl -w

package Finisar::Extern;

use Exporter;

use strict;
use warnings;

use vars qw(@ISA @EXPORT); 

@ISA = qw(Exporter);
@EXPORT = qw($configDir $logDir $telnetTimeout
             $hostName $logLevel $tmpDir);
use vars qw($configDir $logDir $telnetTimeout
            $hostName $logLevel $tmpDir);

$configDir     = 'C:\temp';
$logDir        = 'C:\temp';
$telnetTimeout = 30;

# Get the environment variables depending on the OS
if ( $ENV{'OS'} eq 'Windows_NT' ) {

    $hostName = $ENV{'COMPUTERNAME'};
    $tmpDir   = $ENV{'TMP'};
} else {
    # Linux or Solaris
    $hostName = `hostname`;
    $tmpDir   = '/tmp';
}

$logLevel = $ENV{'LOGLEVEL'};


1;
