#
# $Id: //depot/prod/test/Rsierranevada/lib/FlexCache/Constants.pm#3 $
#

#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary FlexCache constants.
## @author voicu@netapp.com, dl-flexcache-qa
## @status Private
## @pod here

=head1 NAME

FlexCache::Constants

=head1 DESCRIPTION

This module defines the constants needed for FlexCache testing.
These constants are used by the FlexCache library and scripts.

=head1 SYNOPSIS

use FlexCache::Constants  qw(:all);

=head1 CONSTANTS

        Basic:
        TRUE
        FALSE
        FCACHE_ONTAP_CMODE
        FCACHE_ONTAP_7MODE
        FCACHE_LOGRESULT_PASS
        FCACHE_LOGRESULT_NA
        FCACHE_LOGRESULT_FATAL
        FCACHE_LOGRESULT_SCRIPT
        FCACHE_LOGRESULT_CONFIG
        FCACHE_ENTITY_ANY
        FCACHE_STATE_ENABLED
        FCACHE_STATE_DISABLED
        FCACHE_STATE_ON
        FCACHE_STATE_OFF
        FCACHE_SETTING_FALSE
        FCACHE_SETTING_TRUE
        FCACHE_MODE_ENABLE
        FCACHE_MODE_DISABLE
        FCACHE_LICENSE_NFS
        FCACHE_LICENSE_CIFS
        FCACHE_SFO_STATE_UP
        FCACHE_SFO_STATE_TAKEOVER
        FCACHE_SFO_STATE_WAIT_FOR_GIVEBACK
        FCACHE_SFO_STATE_NOCHECK
        FCACHE_UI_TYPE_CLI
        FCACHE_UI_TYPE_ZAPI
        FCACHE_CP_DURATION
        FCACHE_ZAPI_CMD_TYPE_GET
        FCACHE_ZAPI_CMD_TYPE_GET_ITER
        FCACHE_TOGB_TIMEOUT

        Aggregate:
        FCACHE_AGGR_ORIGIN
        FCACHE_AGGR_CACHE
        FCACHE_DFLT_AGGR_DISKS
        FCACHE_DFLT_AGGR_RECYCLE
        FCACHE_AGGR_BLOCK_TYPE_32
        FCACHE_AGGR_BLOCK_TYPE_64
        FCACHE_DFLT_AGGR_BLOCK_TYPE
        FCACHE_CORRUPTION_QTREE_METADATA
        FCACHE_CORRUPTION_WI_INDIRECT_BLK_CNT
        FCACHE_CORRUPTION_VOL_SNAPDIR
        FCACHE_CORRUPTION_FSINFO_BLKS_USED

        Volume:
        FCACHE_VOL_ORIGIN
        FCACHE_VOL_CACHE
        FCACHE_DFLT_VOL_SIZE
        FCACHE_DFLT_VOL_PERMS
        FCACHE_DFLT_VOL_POLICY
        FCACHE_DFLT_VOL_SEC_STYLE
        FCACHE_DFLT_VOL_RECYCLE
        FCACHE_CIFS_SHARE_PROP_OPLOCKS
        FCACHE_CIFS_SHARE_PROP_BROWSABLE
        FCACHE_CIFS_SHARE_PROP_CHANGENOTIFY
        FCACHE_CIFS_SHARE_PROP_SHOWSNAPSHOT
        FCACHE_VOL_TYPE_RW
        FCACHE_VOL_TYPE_DC
        FCACHE_VOL_TYPE_DP
        FCACHE_DFLT_VOL_AUTOSIZE
        FCACHE_DFLT_VOL_AUTOSIZE_INCR
        FCACHE_DFLT_VOL_MAX_AUTOSIZE
        FCACHE_DFLT_EXPORTFS_ORIGIN
        FCACHE_DFLT_EXPORTFS_CACHE
        FCACHE_VOL_STATE_ONLINE
        FCACHE_VOL_STATE_OFFLINE
        FCACHE_VOL_DELEGATION_MODE_READ
        FCACHE_VOL_DELEGATION_MODE_WRITE
        FCACHE_VOL_DELEGATION_STATE_LOCKED
        FCACHE_VOL_DELEGATION_STATE_UNLOCKED
        FCACHE_VOL_DELEGATION_STATE_GRANTED
        FCACHE_VOL_OPLOCK_LEVEL_READ_BATCH
        FCACHE_VOL_OPLOCK_LEVEL_LEVEL2
        FCACHE_VOL_OPLOCK_LEVEL_NONE
        FCACHE_VOL_OPLOCK_TYPE_BYTE_RANGE
        FCACHE_VOL_OPLOCK_TYPE_SHARE_LEVEL
        FCACHE_VOL_SECURITY_STYLE_MIXED
        FCACHE_VOL_SECURITY_STYLE_NTFS
        FCACHE_VOL_SECURITY_STYLE_UNIX

        Vserver:
        FCACHE_VSERVER
        FCACHE_DLIF_ORIGIN
        FCACHE_DFLT_DLIF_ID
        FCACHE_DLIF_ID_ORIGIN
        FCACHE_DLIF_CACHE
        FCACHE_DLIF_ID_CACHE
        FCACHE_DFLT_VSERVER_RECYCLE
        FCACHE_DFLT_VSERVER_NS_SWITCH
        FCACHE_DFLT_VSERVER_NM_SWITCH
        FCACHE_DFLT_VSERVER_ROOTVOL_SEC
        FCACHE_DLIF_FAILOVER_POLICY_DISABLED
        FCACHE_DLIF_FAILOVER_POLICY_NEXTAVAIL
        FCACHE_DLIF_FAILOVER_POLICY_PRIORITY
        FCACHE_REQUIRED_DLIF_FAILOVER_POLICY
        FCACHE_DFLT_DLIF_USE_FAILOVER_GROUP
        FCACHE_DLIF_ROLE
        FCACHE_DLIF_IP_MATCH_ALL
        FCACHE_DFLT_EXPORT_POLICY_RULE
        FCACHE_DFLT_EXPORT_POLICY_RULEINDEX
        FCACHE_DFLT_EXPORT_RORULE
        FCACHE_DFLT_EXPORT_RWRULE
        FCACHE_DFLT_EXPORT_ALLOW_SUID
        FCACHE_DFLT_EXPORT_ALLOW_DEV
        FCACHE_DFLT_EXPORT_PROTOCOL
        FCACHE_DFLT_EXPORT_SUPERUSER
        FCACHE_DFLT_EXPORT_ANON
        FCACHE_DFLT_UNIX_USER
        FCACHE_DFLT_UNIX_GROUP
        FCACHE_DFLT_UNIX_UID
        FCACHE_DFLT_UNIX_GID
        FCACHE_DFLT_WIN_USER
        FCACHE_NAME_MAPPING_UNIX_WIN
        FCACHE_NAME_MAPPING_WIN_UNIX
        FCACHE_DFLT_NAME_MAPPING_POSITION
        FCACHE_DFLT_CIFS_OU
        FCACHE_DFLT_VFILER_ROOT_SIZE
        FCACHE_DFLT_VFILER_RECYCLE
        FCACHE_AV_PROTOCOL_CIFS
        FCACHE_AV_PROTOCOL_NFS4
        FCACHE_AV_PROTOCOL_NFS3
        FCACHE_DLIF_STATUS_UP
        FCACHE_DLIF_STATUS_DOWN
        FCACHE_FILE_LOCAL_FLAGS_UNVERIFIED
        FCACHE_FILE_LOCAL_FLAGS_DELEGATED

        Node:
        FCACHE_NODE_STATISTICS_OBJ_LMGR_NG
        FCACHE_NODE_STATISTICS_OBJ_AVOA
        FCACHE_NODE_STATISTICS_INST_AVOA
        FCACHE_NODE_STATISTICS_FLEXCACHE
        FCACHE_FIJI_TAG_WI_INDIRECT_BLK_CNT_SET
        FCACHE_FIJI_TAG_IICU_SCAN_RESTART
        FCACHE_FIJI_TAG_PFS_FILL_DELEG_ERROR
        FCACHE_CAPABILITY_FLEXCACHE_DELEGATIONS
        FCACHE_PRIVILEGE_ADMIN
        FCACHE_PRIVILEGE_ADVANCED
        FCACHE_PRIVILEGE_DIAG
        FCACHE_PRIVILEGE_TEST
        FCACHE_FLAG_FLEXCACHE_FORWARDING

        Client operations:
        FCACHE_DFLT_CLIENT
        FCACHE_DFLT_AUTO_MOUNT
        FCACHE_CLIENT_TYPE_UNIX
        FCACHE_CLIENT_TYPE_WINDOWS
        FCACHE_CLIENT_PROTOCOL_NFSv3
        FCACHE_CLIENT_PROTOCOL_NFSv4
        FCACHE_CLIENT_PROTOCOL_SMBv1
        FCACHE_CLIENT_PROTOCOL_SMBv2_0
        FCACHE_CLIENT_PROTOCOL_SMBv2_1
        FCACHE_DFLT_CHMOD
        FCACHE_FILE_ACCESS_MODE_R
        FCACHE_FILE_ACCESS_MODE_W
        FCACHE_FILE_ACCESS_MODE_RW
        FCACHE_FILE_OPEN_MODE_OPEN_EXIST
        FCACHE_FILE_OPEN_MODE_OPEN_ALWS
        FCACHE_FILE_OPEN_MODE_OPEN_APPEND
        FCACHE_FILE_OPEN_MODE_CREATE_NEW
        FCACHE_FILE_OPEN_MODE_CREATE_ALWS
        FCACHE_FILE_OPEN_MODE_TRUNC_EXIST
        FCACHE_FILE_SHARE_MODE_D
        FCACHE_FILE_SHARE_MODE_R
        FCACHE_FILE_SHARE_MODE_W
        FCACHE_FILE_SHARE_MODE_RD
        FCACHE_FILE_SHARE_MODE_WD
        FCACHE_FILE_SHARE_MODE_RW
        FCACHE_FILE_SHARE_MODE_RWD
        FCACHE_FILE_SHARE_MODE_NONE
        KB
        MB
        GB
        FCACHE_WAFL_BLOCK_SIZE
        FCACHE_LOCK_TYPE_EXCLUSIVE
        FCACHE_LOCK_TYPE_SHARED
        FCACHE_LOCK_WAITING
        FCACHE_LOCK_NON_WAITING
        FCACHE_DFLT_FIFO_MODE
        FCACHE_DFLT_FIFO_UMASK
        FCACHE_CHMOD_RWX
        FCACHE_CHMOD_RX
        FCACHE_CHMOD_R

        Snapmirror:
        FCACHE_SNAPMIRROR_TYPE_DP
        FCACHE_SNAPMIRROR_TYPE_LS
        FCACHE_SNAPMIRROR_TYPE_XDP
        FCACHE_SNAPMIRROR_SCHEDULE_DAILY
        FCACHE_SNAPMIRROR_SCHEDULE_HOURLY
        FCACHE_SNAPMIRROR_DFLT_SYNC_TYPE

        Return codes:
        FCACHE_RC_SUCCESS
        FCACHE_RC_FAILURE
        FCACHE_RC_NO_ENTRY_FOUND
        FCACHE_BRE_NOT_POSSIBLE_ON_A_CACHE
        FCACHE_RC_LS_SOURCE_CANNOT_BE_AN_ORIGIN
        FCACHE_RC_FILE_LOCK_REQUEST_GRANTED
        FCACHE_RC_FILE_LOCK_REQUEST_WAITING
        FCACHE_RC_FILE_ALREADY_EXISTS
        FCACHE_RC_PATH_IS_NOT_A_SYMLINK
        FCACHE_RC_DIR_ALREADY_EXISTS
        FCACHE_RC_NO_CONTENTS_FOUND
        FCACHE_RC_NOT_ALLOWED_ON_RW_VOL
        FCACHE_RC_FILE_ALREADY_LOCKED
        FCACHE_RC_OPERATION_NOT_ALLOWED_ON_A_CACHE
        FCACHE_RC_FILES_ARE_EQUAL
        FCACHE_RC_FILES_ARE_NOT_EQUAL
        FCACHE_RC_PERMISSION_DENIED
        FCACHE_RC_INVALID_CMD_ARGUMENT
        FCACHE_RC_INPUT_OUTPUT_ERROR
        FCACHE_RC_READ_ONLY_FILE_SYSTEM
        FCACHE_RC_NOT_ENOUGH_SPACE
        FCACHE_RC_DISK_QUOTA_EXCEEDED
        FCACHE_RC_FILES_NOT_EQUAL

=cut

package FlexCache::Constants;

use strict;
use warnings;

BEGIN {
    use base qw(Exporter);

    #################
    # Basic
    #################
    use constant TRUE                               => 1;
    use constant FALSE                              => 0;
    use constant FCACHE_ONTAP_CMODE                 => 'CMode';
    use constant FCACHE_ONTAP_7MODE                 => '7Mode';
    use constant FCACHE_LOGRESULT_PASS              => 'PASS';
    use constant FCACHE_LOGRESULT_NA                => 'NOT_APPLICABLE';
    use constant FCACHE_LOGRESULT_FATAL             => 'FATAL';
    use constant FCACHE_LOGRESULT_SCRIPT            => 'SCRIPT';
    use constant FCACHE_LOGRESULT_CONFIG            => 'CONFIG';
    use constant FCACHE_ENTITY_ANY                  => '*';
    use constant FCACHE_STATE_ENABLED               => 'enabled';
    use constant FCACHE_STATE_DISABLED              => 'disabled';
    use constant FCACHE_STATE_ON                    => 'on';
    use constant FCACHE_STATE_OFF                   => 'off';
    use constant FCACHE_SETTING_FALSE               => 'false';
    use constant FCACHE_SETTING_TRUE                => 'true';
    use constant FCACHE_MODE_ENABLE                 => 'enable';
    use constant FCACHE_MODE_DISABLE                => 'disable';
    use constant FCACHE_LICENSE_NFS                 => 'NFS';
    use constant FCACHE_LICENSE_CIFS                => 'CIFS';
    use constant FCACHE_SFO_STATE_UP                => 'up';
    use constant FCACHE_SFO_STATE_TAKEOVER          => 'takeover';
    use constant FCACHE_SFO_STATE_WAIT_FOR_GIVEBACK => 'wfg';
    use constant FCACHE_SFO_STATE_NOCHECK           => 'nocheck';
    use constant FCACHE_UI_TYPE_CLI                 => 'CLI';
    use constant FCACHE_UI_TYPE_ZAPI                => 'ZAPI';
    use constant FCACHE_CP_DURATION                 => 10;
    use constant FCACHE_ZAPI_CMD_TYPE_GET           => 'get';
    use constant FCACHE_ZAPI_CMD_TYPE_GET_ITER      => 'get_iter';
    use constant FCACHE_TOGB_TIMEOUT                => 1200;

    #################
    # Aggregate
    #################
    use constant FCACHE_AGGR_ORIGIN          => 'ofcache';
    use constant FCACHE_AGGR_CACHE           => 'cfcache';
    use constant FCACHE_DFLT_AGGR_DISKS      => 3;
    use constant FCACHE_DFLT_AGGR_RECYCLE    => TRUE;
    use constant FCACHE_AGGR_BLOCK_TYPE_32   => '32-bit';
    use constant FCACHE_AGGR_BLOCK_TYPE_64   => '64-bit';
    use constant FCACHE_DFLT_AGGR_BLOCK_TYPE => FCACHE_AGGR_BLOCK_TYPE_64;
    use constant FCACHE_CORRUPTION_QTREE_METADATA => 'QTREE_METADATA';
    use constant FCACHE_CORRUPTION_WI_INDIRECT_BLK_CNT =>
        'WI_INDIRECT_BLK_CNT';
    use constant FCACHE_CORRUPTION_VOL_SNAPDIR => 'VOL_SNAPDIR';
    use constant FCACHE_CORRUPTION_FSINFO_BLKS_USED =>
        'FSINFO_BLKS_USED';

    #################
    # Volume
    #################
    use constant FCACHE_VOL_ORIGIN                   => undef;
    use constant FCACHE_VOL_CACHE                    => undef;
    use constant FCACHE_DFLT_VOL_SIZE                => '100m';
    use constant FCACHE_DFLT_VOL_PERMS               => 'rwxrwxrwx';
    use constant FCACHE_DFLT_VOL_POLICY              => 'default';
    use constant FCACHE_DFLT_VOL_SEC_STYLE           => 'mixed';
    use constant FCACHE_DFLT_VOL_RECYCLE             => FALSE;
    use constant FCACHE_CIFS_SHARE_PROP_OPLOCKS      => 'oplocks';
    use constant FCACHE_CIFS_SHARE_PROP_BROWSABLE    => 'browsable';
    use constant FCACHE_CIFS_SHARE_PROP_CHANGENOTIFY => 'changenotify';
    use constant FCACHE_CIFS_SHARE_PROP_SHOWSNAPSHOT => 'showsnapshot';
    use constant FCACHE_VOL_TYPE_RW                  => 'RW';
    use constant FCACHE_VOL_TYPE_DC                  => 'DC';
    use constant FCACHE_VOL_TYPE_DP                  => 'DP';
    use constant FCACHE_DFLT_VOL_AUTOSIZE            => FALSE;
    use constant FCACHE_DFLT_VOL_AUTOSIZE_INCR       => '50m';
    use constant FCACHE_DFLT_VOL_MAX_AUTOSIZE        => '120m';
    use constant FCACHE_DFLT_EXPORTFS_ORIGIN         => 'rw,anon=0';
    use constant FCACHE_DFLT_EXPORTFS_CACHE          => 'rw,anon=0';
    use constant FCACHE_VOL_STATE_ONLINE             => 'online';
    use constant FCACHE_VOL_STATE_OFFLINE            => 'offline';
    use constant FCACHE_VOL_DELEGATION_MODE_READ =>
        'FCACHE_VOL_DELEGATION_MODE_READ';
    use constant FCACHE_VOL_DELEGATION_MODE_WRITE =>
        'FCACHE_VOL_DELEGATION_MODE_WRITE';
    use constant FCACHE_VOL_DELEGATION_STATE_LOCKED =>
        'FCACHE_VOL_DELEGATION_STATE_LOCKED';
    use constant FCACHE_VOL_DELEGATION_STATE_UNLOCKED =>
        'FCACHE_VOL_DELEGATION_STATE_UNLOCKED';
    use constant FCACHE_VOL_DELEGATION_STATE_GRANTED =>
        'FCACHE_VOL_DELEGATION_STATE_GRANTED';
    use constant FCACHE_VOL_OPLOCK_LEVEL_READ_BATCH =>
        'FCACHE_VOL_OPLOCK_LEVEL_READ_BATCH';
    use constant FCACHE_VOL_OPLOCK_LEVEL_LEVEL2 =>
        'FCACHE_VOL_OPLOCK_LEVEL_LEVEL2';
    use constant FCACHE_VOL_OPLOCK_LEVEL_NONE =>
        'FCACHE_VOL_OPLOCK_LEVEL_NONE';
    use constant FCACHE_VOL_OPLOCK_TYPE_BYTE_RANGE =>
        'FCACHE_VOL_OPLOCK_TYPE_BYTE_RANGE';
    use constant FCACHE_VOL_OPLOCK_TYPE_SHARE_LEVEL =>
        'FCACHE_VOL_OPLOCK_TYPE_SHARE_LEVEL';
    use constant FCACHE_VOL_SECURITY_STYLE_MIXED => 'mixed';
    use constant FCACHE_VOL_SECURITY_STYLE_NTFS  => 'ntfs';
    use constant FCACHE_VOL_SECURITY_STYLE_UNIX  => 'unix';

    #################
    # Vserver
    #################
    use constant FCACHE_VSERVER        => 'vs0';
    use constant FCACHE_DLIF_ORIGIN    => FCACHE_VSERVER . '_origin_dlif';
    use constant FCACHE_DFLT_DLIF_ID   => 1;
    use constant FCACHE_DLIF_ID_ORIGIN => 1;
    use constant FCACHE_DLIF_CACHE     => FCACHE_VSERVER . '_cache_dlif';
    use constant FCACHE_DLIF_ID_CACHE  => 1;
    use constant FCACHE_DFLT_VSERVER_RECYCLE           => TRUE;
    use constant FCACHE_DFLT_VSERVER_NS_SWITCH         => 'file';
    use constant FCACHE_DFLT_VSERVER_NM_SWITCH         => 'file';
    use constant FCACHE_DFLT_VSERVER_ROOTVOL_SEC       => 'mixed';
    use constant FCACHE_DLIF_FAILOVER_POLICY_DISABLED  => 'disabled';
    use constant FCACHE_DLIF_FAILOVER_POLICY_NEXTAVAIL => 'nextavail';
    use constant FCACHE_DLIF_FAILOVER_POLICY_PRIORITY  => 'priority';
    use constant FCACHE_REQUIRED_DLIF_FAILOVER_POLICY =>
        FCACHE_DLIF_FAILOVER_POLICY_NEXTAVAIL;
    use constant FCACHE_DFLT_DLIF_USE_FAILOVER_GROUP => FCACHE_STATE_DISABLED;
    use constant FCACHE_DLIF_ROLE                    => 'data';
    use constant FCACHE_DLIF_IP_MATCH_ALL            => '0.0.0.0/0';
    use constant FCACHE_DFLT_EXPORT_POLICY_RULE      => 'default';
    use constant FCACHE_DFLT_EXPORT_POLICY_RULEINDEX => 1;
    use constant FCACHE_DFLT_EXPORT_RORULE           => 'any';
    use constant FCACHE_DFLT_EXPORT_RWRULE           => 'any';
    use constant FCACHE_DFLT_EXPORT_ALLOW_SUID       => 'true';
    use constant FCACHE_DFLT_EXPORT_ALLOW_DEV        => 'true';
    use constant FCACHE_DFLT_EXPORT_PROTOCOL         => 'any';
    use constant FCACHE_DFLT_EXPORT_SUPERUSER        => 'any';
    use constant FCACHE_DFLT_EXPORT_ANON             => 0;
    use constant FCACHE_DFLT_UNIX_USER               => 'root';
    use constant FCACHE_DFLT_UNIX_GROUP              => 'root';
    use constant FCACHE_DFLT_UNIX_UID                => 0;
    use constant FCACHE_DFLT_UNIX_GID                => 0;
    use constant FCACHE_DFLT_WIN_USER                => 'administrator';
    use constant FCACHE_NAME_MAPPING_UNIX_WIN        => 'unix-win';
    use constant FCACHE_NAME_MAPPING_WIN_UNIX        => 'win-unix';
    use constant FCACHE_DFLT_NAME_MAPPING_POSITION   => 1;
    use constant FCACHE_DFLT_CIFS_OU                 => 'CN=Computers';
    use constant FCACHE_DFLT_VFILER_ROOT_SIZE        => '20m';
    use constant FCACHE_DFLT_VFILER_RECYCLE          => FALSE;
    use constant FCACHE_AV_PROTOCOL_CIFS             => 'cifs';
    use constant FCACHE_AV_PROTOCOL_NFS4             => 'nfs4';
    use constant FCACHE_AV_PROTOCOL_NFS3             => 'nfs3';
    use constant FCACHE_DLIF_STATUS_UP               => 'up';
    use constant FCACHE_DLIF_STATUS_DOWN             => 'down';
    use constant FCACHE_FILE_LOCAL_FLAGS_UNVERIFIED  => 'UNVERIFIED';
    use constant FCACHE_FILE_LOCAL_FLAGS_DELEGATED   => 'DELEGATED';

    #################
    # Node
    #################
    use constant FCACHE_NODE_STATISTICS_OBJ_LMGR_NG => 'lmgr_ng';
    use constant FCACHE_NODE_STATISTICS_OBJ_AVOA    => 'avoa';
    use constant FCACHE_NODE_STATISTICS_INST_AVOA   => 'avoa';
    use constant FCACHE_NODE_STATISTICS_FLEXCACHE   => 'flexcache';
    use constant FCACHE_FIJI_TAG_WI_INDIRECT_BLK_CNT_SET =>
        'WI_INDIRECT_BLK_CNT_SET';
    use constant FCACHE_FIJI_TAG_IICU_SCAN_RESTART => 'IICU_SCAN_RESTART';
    use constant FCACHE_FIJI_TAG_RAID_RETURN_PSEUDO_BAD_ERROR =>
        'RAID_RETURN_PSEUDO_BAD_ERROR';
    use constant FCACHE_FIJI_TAG_PFS_FILL_DELEG_ERROR =>
        'PFS_FILL_DELEG_ERROR';
    use constant FCACHE_CAPABILITY_FLEXCACHE_DELEGATIONS =>
        'flexcache.delegations';
    use constant FCACHE_PRIVILEGE_ADMIN           => 'admin';
    use constant FCACHE_PRIVILEGE_ADVANCED        => 'advanced';
    use constant FCACHE_PRIVILEGE_DIAG            => 'diag';
    use constant FCACHE_PRIVILEGE_TEST            => 'test';
    use constant FCACHE_FLAG_FLEXCACHE_FORWARDING => 'flexcache_forwarding';

    #################
    # Client
    #################
    use constant FCACHE_DFLT_CLIENT                 => 'localhost';
    use constant FCACHE_DFLT_AUTO_MOUNT             => TRUE;
    use constant FCACHE_DFLT_DATASET_CREATE_TIMEOUT => 9000;
    use constant FCACHE_CLIENT_TYPE_UNIX =>
        'linux';    # As provided by Protocol::ClientFileOperations
    use constant FCACHE_CLIENT_TYPE_WINDOWS =>
        'windows';    # As provided by Protocol::ClientFileOperations
    use constant FCACHE_CLIENT_PROTOCOL_NFSv3      => 'NFS_3';
    use constant FCACHE_CLIENT_PROTOCOL_NFSv4      => 'NFS_4';
    use constant FCACHE_CLIENT_PROTOCOL_SMBv1      => 'SMB_1';
    use constant FCACHE_CLIENT_PROTOCOL_SMBv2_0    => 'SMB_2.0';
    use constant FCACHE_CLIENT_PROTOCOL_SMBv2_1    => 'SMB_2.1';
    use constant FCACHE_DFLT_CHMOD                 => '777';
    use constant FCACHE_FILE_ACCESS_MODE_R         => 'read';
    use constant FCACHE_FILE_ACCESS_MODE_W         => 'write';
    use constant FCACHE_FILE_ACCESS_MODE_RW        => 'read-write';
    use constant FCACHE_FILE_OPEN_MODE_OPEN_EXIST  => 'open-existing';
    use constant FCACHE_FILE_OPEN_MODE_OPEN_ALWS   => 'open-always';
    use constant FCACHE_FILE_OPEN_MODE_OPEN_APPEND => 'open-append';
    use constant FCACHE_FILE_OPEN_MODE_CREATE_NEW  => 'create-new';
    use constant FCACHE_FILE_OPEN_MODE_CREATE_ALWS => 'create-always';
    use constant FCACHE_FILE_OPEN_MODE_TRUNC_EXIST => 'truncate-existing';
    use constant FCACHE_FILE_SHARE_MODE_D          => 'shared-delete';
    use constant FCACHE_FILE_SHARE_MODE_R          => 'shared-read';
    use constant FCACHE_FILE_SHARE_MODE_W          => 'shared-write';
    use constant FCACHE_FILE_SHARE_MODE_RD         => 'shared-read-delete';
    use constant FCACHE_FILE_SHARE_MODE_WD         => 'shared-write-delete';
    use constant FCACHE_FILE_SHARE_MODE_RW         => 'shared-read-write';
    use constant FCACHE_FILE_SHARE_MODE_RWD  => 'shared-read-write-delete';
    use constant FCACHE_FILE_SHARE_MODE_NONE => ' none';
    use constant KB                          => 1024;
    use constant MB                          => (KB * KB);
    use constant GB                          => (KB * KB * KB);
    use constant FCACHE_WAFL_BLOCK_SIZE      => (4 * KB);
    use constant FCACHE_LOCK_TYPE_EXCLUSIVE  => 'exclusive';
    use constant FCACHE_LOCK_TYPE_SHARED     => 'shared';
    use constant FCACHE_LOCK_WAITING         => 'waiting';
    use constant FCACHE_LOCK_NON_WAITING     => 'non-waiting';
    use constant FCACHE_DFLT_FIFO_MODE       => '0777';
    use constant FCACHE_DFLT_FIFO_UMASK      => '0000';
    use constant FCACHE_CHMOD_RWX            => '777';
    use constant FCACHE_CHMOD_RX             => '555';
    use constant FCACHE_CHMOD_R              => '444';

    #################
    # Snapmirror
    #################
    use constant FCACHE_SNAPMIRROR_TYPE_DP         => 'DP';
    use constant FCACHE_SNAPMIRROR_TYPE_LS         => 'LS';
    use constant FCACHE_SNAPMIRROR_TYPE_XDP        => 'XDP';
    use constant FCACHE_SNAPMIRROR_SCHEDULE_DAILY  => 'daily';
    use constant FCACHE_SNAPMIRROR_SCHEDULE_HOURLY => 'hourly';
    use constant FCACHE_SNAPMIRROR_DFLT_SYNC_TYPE  => 'sync';

    #################
    # Return codes
    #################
    use constant FCACHE_RC_FAILURE                          => 0;
    use constant FCACHE_RC_SUCCESS                          => 1;
    use constant FCACHE_RC_FAILURE_NON_FATAL                => 2;
    use constant FCACHE_RC_NO_ENTRY_FOUND                   => 3;
    use constant FCACHE_BRE_NOT_POSSIBLE_ON_A_CACHE         => 4;
    use constant FCACHE_RC_LS_SOURCE_CANNOT_BE_AN_ORIGIN    => 5;
    use constant FCACHE_RC_FILE_LOCK_REQUEST_GRANTED        => 6;
    use constant FCACHE_RC_FILE_LOCK_REQUEST_WAITING        => 7;
    use constant FCACHE_RC_FILE_ALREADY_EXISTS              => 8;
    use constant FCACHE_RC_PATH_IS_NOT_A_SYMLINK            => 9;
    use constant FCACHE_RC_DIR_ALREADY_EXISTS               => 10;
    use constant FCACHE_RC_NO_CONTENTS_FOUND                => 11;
    use constant FCACHE_RC_NOT_ALLOWED_ON_RW_VOL            => 12;
    use constant FCACHE_RC_FILE_ALREADY_LOCKED              => 13;
    use constant FCACHE_RC_OPERATION_NOT_ALLOWED_ON_A_CACHE => 14;
    use constant FCACHE_RC_FILES_ARE_EQUAL                  => 15;
    use constant FCACHE_RC_FILES_ARE_NOT_EQUAL              => 16;
    use constant FCACHE_RC_PERMISSION_DENIED                => 17;
    use constant FCACHE_RC_INVALID_CMD_ARGUMENT             => 18;
    use constant FCACHE_RC_INPUT_OUTPUT_ERROR               => 19;
    use constant FCACHE_RC_READ_ONLY_FILE_SYSTEM            => 20;
    use constant FCACHE_RC_NOT_ENOUGH_SPACE                 => 21;
    use constant FCACHE_RC_DISK_QUOTA_EXCEEDED              => 22;
    use constant FCACHE_RC_FILES_NOT_EQUAL                  => 23;

    #################
    # Internal use
    #################
    use constant _FCACHE_NAME_TYPE_VOL       => 'vol';
    use constant _FCACHE_VSERVER_NO_VFILER   => '__No_Vfiler__';
    use constant FCACHE_CMD_SNAPMIRROR_NEW   => 'SNAPMIRROR_NEW_RELATIONSHIP';
    use constant FCACHE_CMD_VFILER_FIND      => 'VFILER_FIND';
    use constant FCACHE_CMD_DELEGATIONS_FIND => 'DELEGATIONS_FIND';
    use constant FCACHE_CMD_VOL_FLEXCACHE_POLICY_SET =>
        'VOL_FLEXCACHE_POLICY_SET';
    use constant FCACHE_CMD_VOL_SNAPSHOT_CREATE  => 'VOL_SNAPSHOT_CREATE';
    use constant FCACHE_CMD_VOL_SNAPSHOT_RESTORE => 'VOL_SNAPSHOT_RESTORE';
    use constant FCACHE_CMD_VOL_SNAPSHOT_RESTORE_FILE =>
        'VOL_SNAPSHOT_RESTORE_FILE';
    use constant FCACHE_CMD_VOL_SNAPSHOT_DELETE   => 'VOL_SNAPSHOT_DELETE';
    use constant FCACHE_CMD_VOL_MOVE              => 'VOL_MOVE';
    use constant FCACHE_CMD_VOL_OPLOCKS_MODE_SET  => 'VOL_OPLOCKS_MODE_SET';
    use constant FCACHE_CMD_VOL_QTREE_CREATE      => 'VOL_QTREE_CREATE';
    use constant FCACHE_CMD_VOL_QTREE_STATISTICS  => 'VOL_QTREE_STATISTICS';
    use constant FCACHE_CMD_VOL_FLEXCACHE_CREATE  => 'VOL_FLEXCACHE_CREATE';
    use constant FCACHE_CMD_VOL_FLEXCACHE_DELETE  => 'VOL_FLEXCACHE_DELETE';
    use constant FCACHE_CMD_VSERVER_LOCKS_FIND    => 'VSERVER_LOCKS_FIND';
    use constant FCACHE_CMD_VOL_MODIFY            => 'VOL_MODIFY';
    use constant FCACHE_CMD_SE_ENABLE             => 'SE_ENABLE';
    use constant FCACHE_CMD_VOL_FILE_CLONE_CREATE => 'VOL_FILE_CLONE_CREATE';
    use constant FCACHE_CMD_VOL_QUOTA_ENABLE      => 'VOL_QUOTA_ENABLE';
    use constant FCACHE_CLIENT_CMD_FILE_COPY      => 'FILE_COPY';
    use constant FCACHE_CLIENT_CMD_FILE_OPEN      => 'FILE_OPEN';
    use constant FCACHE_CLIENT_CMD_FILE_CLOSE     => 'FILE_CLOSE';
    use constant FCACHE_CLIENT_CMD_FILE_DELETE    => 'FILE_DELETE';
    use constant FCACHE_CLIENT_CMD_PIPE_OPEN      => 'PIPE_OPEN';
    use constant FCACHE_CLIENT_CMD_DIR_CREATE     => 'DIR_CREATE';
    use constant FCACHE_CLIENT_CMD_DIR_DELETE     => 'DIR_DELETE';
    use constant FCACHE_CLIENT_CMD_DIR_LIST       => 'DIR_LIST';
    use constant FCACHE_CLIENT_CMD_FILE_LOCK      => 'FILE_LOCK';
    use constant FCACHE_CLIENT_CMD_FILE_WRITE     => 'FILE_WRITE';
    use constant FCACHE_CLIENT_CMD_FILE_READ      => 'FILE_READ';
    use constant FCACHE_CLIENT_CMD_FILE_SET_ACL   => 'FILE_SET_ACL';
    use constant FCACHE_CLIENT_CMD_PATH_ATTRIBUTES_MODIFY =>
        'PATH_ATTRIBUTES_MODIFY';
    use constant FCACHE_MAX_FILE_SIZE => (10 * MB);

    my @basic = qw(TRUE
        FALSE
        FCACHE_ONTAP_CMODE
        FCACHE_ONTAP_7MODE
        FCACHE_LOGRESULT_PASS
        FCACHE_LOGRESULT_NA
        FCACHE_LOGRESULT_FATAL
        FCACHE_LOGRESULT_SCRIPT
        FCACHE_LOGRESULT_CONFIG
        FCACHE_ENTITY_ANY
        FCACHE_STATE_ENABLED
        FCACHE_STATE_DISABLED
        FCACHE_STATE_ON
        FCACHE_STATE_OFF
        FCACHE_SETTING_FALSE
        FCACHE_SETTING_TRUE
        FCACHE_MODE_ENABLE
        FCACHE_MODE_DISABLE
        FCACHE_LICENSE_NFS
        FCACHE_LICENSE_CIFS
        FCACHE_SFO_STATE_UP
        FCACHE_SFO_STATE_TAKEOVER
        FCACHE_SFO_STATE_WAIT_FOR_GIVEBACK
        FCACHE_SFO_STATE_NOCHECK
        FCACHE_UI_TYPE_CLI
        FCACHE_UI_TYPE_ZAPI
        FCACHE_CP_DURATION
        FCACHE_ZAPI_CMD_TYPE_GET
        FCACHE_ZAPI_CMD_TYPE_GET_ITER
        FCACHE_TOGB_TIMEOUT);

    my @aggr = qw(FCACHE_AGGR_ORIGIN
        FCACHE_AGGR_CACHE
        FCACHE_DFLT_AGGR_DISKS
        FCACHE_DFLT_AGGR_RECYCLE
        FCACHE_AGGR_BLOCK_TYPE_32
        FCACHE_AGGR_BLOCK_TYPE_64
        FCACHE_DFLT_AGGR_BLOCK_TYPE
        FCACHE_CORRUPTION_QTREE_METADATA
        FCACHE_CORRUPTION_WI_INDIRECT_BLK_CNT
        FCACHE_CORRUPTION_VOL_SNAPDIR
        FCACHE_CORRUPTION_FSINFO_BLKS_USED);

    my @vol = qw(FCACHE_VOL_ORIGIN
        FCACHE_VOL_CACHE
        FCACHE_DFLT_VOL_SIZE
        FCACHE_DFLT_VOL_PERMS
        FCACHE_DFLT_VOL_POLICY
        FCACHE_DFLT_VOL_SEC_STYLE
        FCACHE_DFLT_VOL_RECYCLE
        FCACHE_CIFS_SHARE_PROP_OPLOCKS
        FCACHE_CIFS_SHARE_PROP_BROWSABLE
        FCACHE_CIFS_SHARE_PROP_CHANGENOTIFY
        FCACHE_CIFS_SHARE_PROP_SHOWSNAPSHOT
        FCACHE_VOL_TYPE_RW
        FCACHE_VOL_TYPE_DC
        FCACHE_VOL_TYPE_DP
        FCACHE_DFLT_VOL_AUTOSIZE
        FCACHE_DFLT_VOL_AUTOSIZE_INCR
        FCACHE_DFLT_VOL_MAX_AUTOSIZE
        FCACHE_DFLT_EXPORTFS_ORIGIN
        FCACHE_DFLT_EXPORTFS_CACHE
        FCACHE_VOL_STATE_ONLINE
        FCACHE_VOL_STATE_OFFLINE
        FCACHE_VOL_DELEGATION_MODE_READ
        FCACHE_VOL_DELEGATION_MODE_WRITE
        FCACHE_VOL_DELEGATION_STATE_LOCKED
        FCACHE_VOL_DELEGATION_STATE_UNLOCKED
        FCACHE_VOL_DELEGATION_STATE_GRANTED
        FCACHE_VOL_OPLOCK_LEVEL_READ_BATCH
        FCACHE_VOL_OPLOCK_LEVEL_LEVEL2
        FCACHE_VOL_OPLOCK_LEVEL_NONE
        FCACHE_VOL_OPLOCK_TYPE_BYTE_RANGE
        FCACHE_VOL_OPLOCK_TYPE_SHARE_LEVEL
        FCACHE_VOL_SECURITY_STYLE_MIXED
        FCACHE_VOL_SECURITY_STYLE_NTFS
        FCACHE_VOL_SECURITY_STYLE_UNIX);

    my @vserver = qw(FCACHE_VSERVER
        FCACHE_DLIF_ORIGIN
        FCACHE_DFLT_DLIF_ID
        FCACHE_DLIF_ID_ORIGIN
        FCACHE_DLIF_CACHE
        FCACHE_DLIF_ID_CACHE
        FCACHE_DFLT_VSERVER_RECYCLE
        FCACHE_DFLT_VSERVER_NS_SWITCH
        FCACHE_DFLT_VSERVER_NM_SWITCH
        FCACHE_DFLT_VSERVER_ROOTVOL_SEC
        FCACHE_DLIF_FAILOVER_POLICY_DISABLED
        FCACHE_DLIF_FAILOVER_POLICY_NEXTAVAIL
        FCACHE_DLIF_FAILOVER_POLICY_PRIORITY
        FCACHE_REQUIRED_DLIF_FAILOVER_POLICY
        FCACHE_DFLT_DLIF_USE_FAILOVER_GROUP
        FCACHE_DLIF_ROLE
        FCACHE_DLIF_IP_MATCH_ALL
        FCACHE_DFLT_EXPORT_POLICY_RULE
        FCACHE_DFLT_EXPORT_POLICY_RULEINDEX
        FCACHE_DFLT_EXPORT_RORULE
        FCACHE_DFLT_EXPORT_RWRULE
        FCACHE_DFLT_EXPORT_ALLOW_SUID
        FCACHE_DFLT_EXPORT_ALLOW_DEV
        FCACHE_DFLT_EXPORT_PROTOCOL
        FCACHE_DFLT_EXPORT_SUPERUSER
        FCACHE_DFLT_EXPORT_ANON
        FCACHE_DFLT_UNIX_USER
        FCACHE_DFLT_UNIX_GROUP
        FCACHE_DFLT_UNIX_UID
        FCACHE_DFLT_UNIX_GID
        FCACHE_DFLT_WIN_USER
        FCACHE_NAME_MAPPING_UNIX_WIN
        FCACHE_NAME_MAPPING_WIN_UNIX
        FCACHE_DFLT_NAME_MAPPING_POSITION
        FCACHE_DFLT_CIFS_OU
        FCACHE_DFLT_VFILER_ROOT_SIZE
        FCACHE_DFLT_VFILER_RECYCLE
        FCACHE_AV_PROTOCOL_CIFS
        FCACHE_AV_PROTOCOL_NFS4
        FCACHE_AV_PROTOCOL_NFS3
        FCACHE_DLIF_STATUS_UP
        FCACHE_DLIF_STATUS_DOWN
        FCACHE_FILE_LOCAL_FLAGS_UNVERIFIED
        FCACHE_FILE_LOCAL_FLAGS_DELEGATED);

    my @node = qw(FCACHE_NODE_STATISTICS_OBJ_LMGR_NG
        FCACHE_NODE_STATISTICS_OBJ_AVOA
        FCACHE_NODE_STATISTICS_INST_AVOA
        FCACHE_NODE_STATISTICS_FLEXCACHE
        FCACHE_FIJI_TAG_WI_INDIRECT_BLK_CNT_SET
        FCACHE_FIJI_TAG_IICU_SCAN_RESTART
        FCACHE_FIJI_TAG_RAID_RETURN_PSEUDO_BAD_ERROR
        FCACHE_FIJI_TAG_PFS_FILL_DELEG_ERROR
        FCACHE_CAPABILITY_FLEXCACHE_DELEGATIONS
        FCACHE_PRIVILEGE_ADMIN
        FCACHE_PRIVILEGE_ADVANCED
        FCACHE_PRIVILEGE_DIAG
        FCACHE_PRIVILEGE_TEST
        FCACHE_FLAG_FLEXCACHE_FORWARDING);

    my @client = qw(FCACHE_DFLT_CLIENT
        FCACHE_DFLT_AUTO_MOUNT
        FCACHE_DFLT_DATASET_CREATE_TIMEOUT
        FCACHE_CLIENT_TYPE_UNIX
        FCACHE_CLIENT_TYPE_WINDOWS
        FCACHE_CLIENT_PROTOCOL_NFSv3
        FCACHE_CLIENT_PROTOCOL_NFSv4
        FCACHE_CLIENT_PROTOCOL_SMBv1
        FCACHE_CLIENT_PROTOCOL_SMBv2_0
        FCACHE_CLIENT_PROTOCOL_SMBv2_1
        FCACHE_DFLT_CHMOD
        FCACHE_FILE_ACCESS_MODE_R
        FCACHE_FILE_ACCESS_MODE_W
        FCACHE_FILE_ACCESS_MODE_RW
        FCACHE_FILE_OPEN_MODE_OPEN_EXIST
        FCACHE_FILE_OPEN_MODE_OPEN_ALWS
        FCACHE_FILE_OPEN_MODE_OPEN_APPEND
        FCACHE_FILE_OPEN_MODE_CREATE_NEW
        FCACHE_FILE_OPEN_MODE_CREATE_ALWS
        FCACHE_FILE_OPEN_MODE_TRUNC_EXIST
        FCACHE_FILE_SHARE_MODE_D
        FCACHE_FILE_SHARE_MODE_R
        FCACHE_FILE_SHARE_MODE_W
        FCACHE_FILE_SHARE_MODE_RD
        FCACHE_FILE_SHARE_MODE_WD
        FCACHE_FILE_SHARE_MODE_RW
        FCACHE_FILE_SHARE_MODE_RWD
        FCACHE_FILE_SHARE_MODE_NONE
        KB
        MB
        GB
        FCACHE_WAFL_BLOCK_SIZE
        FCACHE_LOCK_TYPE_EXCLUSIVE
        FCACHE_LOCK_TYPE_SHARED
        FCACHE_LOCK_WAITING
        FCACHE_LOCK_NON_WAITING
        FCACHE_DFLT_FIFO_MODE
        FCACHE_DFLT_FIFO_UMASK
        FCACHE_CHMOD_RWX
        FCACHE_CHMOD_RX
        FCACHE_CHMOD_R);

    my @snapmirror = qw(FCACHE_SNAPMIRROR_TYPE_DP
        FCACHE_SNAPMIRROR_TYPE_LS
        FCACHE_SNAPMIRROR_TYPE_XDP
        FCACHE_SNAPMIRROR_SCHEDULE_DAILY
        FCACHE_SNAPMIRROR_SCHEDULE_HOURLY
        FCACHE_SNAPMIRROR_DFLT_SYNC_TYPE);

    my @returncode = qw(FCACHE_RC_SUCCESS
        FCACHE_RC_FAILURE
        FCACHE_RC_FAILURE_NON_FATAL
        FCACHE_RC_NO_ENTRY_FOUND
        FCACHE_BRE_NOT_POSSIBLE_ON_A_CACHE
        FCACHE_RC_LS_SOURCE_CANNOT_BE_AN_ORIGIN
        FCACHE_RC_FILE_LOCK_REQUEST_GRANTED
        FCACHE_RC_FILE_LOCK_REQUEST_WAITING
        FCACHE_RC_FILE_ALREADY_EXISTS
        FCACHE_RC_PATH_IS_NOT_A_SYMLINK
        FCACHE_RC_DIR_ALREADY_EXISTS
        FCACHE_RC_NO_CONTENTS_FOUND
        FCACHE_RC_NOT_ALLOWED_ON_RW_VOL
        FCACHE_RC_FILE_ALREADY_LOCKED
        FCACHE_RC_OPERATION_NOT_ALLOWED_ON_A_CACHE
        FCACHE_RC_FILES_ARE_EQUAL
        FCACHE_RC_FILES_ARE_NOT_EQUAL
        FCACHE_RC_PERMISSION_DENIED
        FCACHE_RC_INVALID_CMD_ARGUMENT
        FCACHE_RC_INPUT_OUTPUT_ERROR
        FCACHE_RC_READ_ONLY_FILE_SYSTEM
        FCACHE_RC_NOT_ENOUGH_SPACE
        FCACHE_RC_DISK_QUOTA_EXCEEDED
        FCACHE_RC_FILES_NOT_EQUAL);

    my @internal = qw(_FCACHE_NAME_TYPE_VOL
        _FCACHE_VSERVER_NO_VFILER
        FCACHE_CMD_SNAPMIRROR_NEW
        FCACHE_CMD_VFILER_FIND
        FCACHE_CMD_DELEGATIONS_FIND
        FCACHE_CMD_VOL_FLEXCACHE_POLICY_SET
        FCACHE_CMD_VOL_SNAPSHOT_CREATE
        FCACHE_CMD_VOL_SNAPSHOT_RESTORE
        FCACHE_CMD_VOL_SNAPSHOT_RESTORE_FILE
        FCACHE_CMD_VOL_SNAPSHOT_DELETE
        FCACHE_CMD_VOL_MOVE
        FCACHE_CMD_VOL_OPLOCKS_MODE_SET
        FCACHE_CMD_VOL_QTREE_CREATE
        FCACHE_CMD_VOL_QTREE_STATISTICS
        FCACHE_CMD_VOL_FLEXCACHE_CREATE
        FCACHE_CMD_VOL_FLEXCACHE_DELETE
        FCACHE_CMD_VSERVER_LOCKS_FIND
        FCACHE_CMD_VOL_MODIFY
        FCACHE_CMD_SE_ENABLE
        FCACHE_CMD_VOL_FILE_CLONE_CREATE
        FCACHE_CMD_VOL_QUOTA_ENABLE
        FCACHE_CLIENT_CMD_FILE_COPY
        FCACHE_CLIENT_CMD_FILE_OPEN
        FCACHE_CLIENT_CMD_FILE_CLOSE
        FCACHE_CLIENT_CMD_FILE_DELETE
        FCACHE_CLIENT_CMD_PIPE_OPEN
        FCACHE_CLIENT_CMD_DIR_CREATE
        FCACHE_CLIENT_CMD_DIR_DELETE
        FCACHE_CLIENT_CMD_DIR_LIST
        FCACHE_CLIENT_CMD_FILE_LOCK
        FCACHE_CLIENT_CMD_FILE_WRITE
        FCACHE_CLIENT_CMD_FILE_READ
        FCACHE_CLIENT_CMD_FILE_SET_ACL
        FCACHE_CLIENT_CMD_PATH_ATTRIBUTES_MODIFY
        FCACHE_MAX_FILE_SIZE);

    our %EXPORT_TAGS = (
        basic      => [@basic],
        aggr       => [@aggr],
        vol        => [@vol],
        vserver    => [@vserver],
        node       => [@node],
        client     => [@client],
        snapmirror => [@snapmirror],
        rc         => [@returncode],
        _internal  => [@internal],
    );

    $EXPORT_TAGS{'all'} = [
        @basic, @aggr,   @vol,        @vserver,
        @node,  @client, @snapmirror, @returncode
    ];
    Exporter::export_ok_tags(
        'all',        '_internal', 'basic', 'aggr',
        'vol',        'vserver',   'node',  'client',
        'snapmirror', 'rc'
    );

}    # BEGIN

1;
