#!/usr/bin/perl

# $Id: //depot/prod/test/Rsierranevada/lib/GNOTE/extras/testsuite/common/runtest.pl#1 $

use IO::Handle;

my $script = $ARGV[0];
my $name   = $script;
shift @ARGV;
my $args    = join( ' ', @ARGV );
my $arglist = join( ',', @ARGV );
# TODO: fix up $args so it doesn't have any illegal chars

$name =~ s/\.thpl$//;
$fullname = $name;
$fullname .= "[$arglist]" if ( $args );
autoflush STDOUT 1;

my $passed = "";
my $failed = "";

printf( "%8s %s\r", "        ", $fullname );
if ( -e "checkpoint/$fullname" ) {
    printf( "%8s\n", "DONE" );
} else {
    open( S, "ntest $script NOTE_TRACE=-bspr $args 2>&1 |" ) or die "Can't run $script: $?";
    open( L, ">logs/$fullname.log" ) or die "Can't open $fullname.log: $?";
    autoflush L 1;
    my $lineno = 0;
    while( <S> ) {
	$lineno++;
	print L;
	printf( "%8d\r", $lineno );
	if ( /^ntest:.*FAIL/ ) {
	    $failed .= $_;
	} elsif ( /^ntest:.*WARN/ ) {
	    $passed .= $_;
	} elsif ( /^ntest:.*PASS\n$/ ) {
	    $passed .= $_;
	} elsif ( /^ntest:.*\s+(\w+)\n$/ ) {
	    $failed .= $_;
	}
    }
    close( L );
    close( S );
    if ( $failed ) {
	printf( "%-8s\n", "fail" );
    } elsif ( $passed ) {
	printf( "%8s\n", "PASS" );
	open( C, ">checkpoint/$fullname" ) or die "Can't open checkpoint/$fullname: $?";
	print C $passed;
	close( C );
    }
}
