#!/usr/bin/perl 
# Hey emacs, this is basically -*- perl -*-
#
#Copyright (c) 2011 NetApp Inc.
#All rights reserved.
#
## @summary HA compliance library
##
## @description
##
## $Id: //depot/prod/ontap/main/HA/HA_SFO/ $
##
## These test functions use various commands to verify takeover and giveback.
##
##
## @usage
##   use HAconstants;
##
## @keywords HApackage takeover giveback
## @dependencies
##
##
## @author dl-ha-qa
##
## @status public
##
package HAconstants;

use strict;
use warnings;

##
use constant YES     => 1;
use constant NO      => 0;
use constant TRUE    => 1;
use constant FALSE   => 0;
use constant PASS    => 1;
use constant FAIL    => 0;

##
use constant ONE_MIN => 60;
use constant TWO_MINS => 120;

##
use constant POLLING_INTERVAL => 10;
use constant TAKEOVER_COMMAND_TIMEOUT => 10;
use constant RANGE => 10000;
use constant DISKCOUNT => 3;
use constant RAIDTYPE => "raid4";

## Takeover timeouts
use constant MAX_TAKEOVER_TIME_NORMAL => 180;
use constant MAX_TAKEOVER_TIME_FORCED => 60; 
use constant MAX_TO_GB_DURATION => 60;

##Aggregate timeouts

use constant HA_SFO_AGGR_ONLINE_TIMEOUT => 30;

## Giveback timeouts
use constant MAX_WFG_TIME => 300;
use constant MAX_WFG_TO_UP => 220;

## Reboot time
use constant MAX_REBOOT_TIME => 480;
use constant MAX_HALT_TIME => 180;
use constant MAX_PANIC_HALT_TIME => 1200;
use constant MAX_PANIC_TO_UP_TIME => 3600;

##prefix
use constant SFO_DATALIF   => "sfo_datalif";
use constant SFO_AGGR      => "sfo_aggr";
use constant SFO_VSERVER   => "sfo_vserver";
use constant SFO_VOL_JUNCTION_PATH => "/sfo_vol_junction_path";
use constant SFO_VOL       => "sfo_vol";

## Default Count
use constant NUM_AGGR => 1;
use constant NUM_VOL => 1;

##
use constant DEFAULT_MTU => 1500;

## Default HA constant
our %DEFAULT_HA_FLAG = (
          'hwassist' => 'true',
          'abort_operations' => 'false',
          'auto_giveback' => 'true',
          'onfailure' => 'true',
          'onreboot' => 'true',
          'onpanic' => 'true',
          'check_partner' => 'true',
          'bypass_takeover_optimization' => 'false',
          'auto_giveback_after_panic' => 'true',
          'hwassist_partner_port' => '4444',
          'delay_seconds' => '600',
          'detection_time' => '15',
          ); 
our %DEFAULT_NONHA_FLAG = (
          'hwassist' => 'false',
          'auto_giveback' => 'false',
          'onfailure' => 'true',
          'onreboot' => 'false',
          'onpanic' => 'false',
          'check_partner' => 'false',
          'delay_seconds' => '600',
          'detection_time' => '15'
          );

## IO tools location
use constant HAMMER => "HA/HA_SFO/tools/hammer.thpl";
use constant SIO => "HA/HA_SFO/tools/sio.thpl";
use constant CUSTOM => "HA/HA_SFO/tools/custom.thpl";
## Export
use vars ('@ISA', '@EXPORT');
require Exporter;
@ISA    = qw(Exporter);
@EXPORT = qw(
                YES
                NO
                TRUE
                FALSE
                PASS
                FAIL
                ONE_MIN
                TWO_MINS
                POLLING_INTERVAL
                MAX_TAKEOVER_TIME_NORMAL
                MAX_TAKEOVER_TIME_FORCED
                MAX_WFG_TIME
                MAX_REBOOT_TIME
                MAX_HALT_TIME
                TAKEOVER_COMMAND_TIMEOUT
		HA_SFO_AGGR_ONLINE_TIMEOUT
                MAX_WFG_TO_UP
                MAX_PANIC_HALT_TIME
                MAX_PANIC_TO_UP_TIME
                SFO_DATALIF  
                SFO_AGGR
                SFO_VSERVER
                SFO_VOL_JUNCTION_PATH
                SFO_VOL
                RANGE
                DISKCOUNT
                NUM_AGGR
                NUM_VOL
                MAX_TO_GB_DURATION
                DEFAULT_MTU
                HAMMER
				SIO
				CUSTOM
                %DEFAULT_HA_FLAG
                %DEFAULT_NONHA_FLAG
                RAIDTYPE
        );

1;
