#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/HTTP_Daemon.pm#1 $

#***********************************************************************
#
# NAME
#   HTTP_Daemon.pm -
#
# SYNOPSIS
#   A wrapper for HTTP::Daemon which provides IPv6 support.
#
#
# AUTHOR
#   dl-cluster-qa
#
# HISTORY
# 9/16/2010 Initial version
#***********************************************************************

package HTTP_Daemon;

use strict;
use vars qw(@ISA);
use HTTP::Daemon;

use IO::Socket qw(AF_INET AF_INET6 INADDR_ANY inet_ntoa);
use IO::Socket::INET6;

@ISA=qw(HTTP::Daemon);

sub new {

    @HTTP::Daemon::ISA            =qw(IO::Socket::INET6);
    @HTTP::Daemon::ClientConn::ISA=qw(IO::Socket::INET6);

    my($class, %args) = @_;
    my $self = $class->SUPER::new(%args);

    return $self;
}


sub url {
    my $self = shift;
    my $url = $self->_default_scheme . "://";
    my $addr = $self->sockaddr;
    my $host = $self->sockhost;
    if (!$addr || $addr eq INADDR_ANY) {
 	    require Sys::Hostname;
 	    $url .= lc Sys::Hostname::hostname();
    } else {
        $url .= $host;
    }
    my $port = $self->sockport;
    $url .= ":$port" if $port != $self->_default_port;
    $url .= "/";
    $url;
}



1;

