#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/main/lib/HTTP_Proxy_IPv6.pm#1 $

#***********************************************************************
#
# NAME
#   HTTP_Proxy_IPv6.pm -
#
# SYNOPSIS
#   Overwrite one HTTP::Proxy method to provide IPv6 support.
#
#
# AUTHOR
#   dl-cluster-qa
#
# HISTORY
# 11/30/2011 Initial version
#***********************************************************************

package HTTP_Proxy_IPv6;

use strict;
use vars qw(@ISA);
use HTTP_Daemon;

use IO::Socket qw(AF_INET AF_INET6 INADDR_ANY inet_ntoa);
use IO::Socket::INET6;

@ISA=qw(HTTP::Proxy);

sub _init_daemon {
    my $self = shift;
    my %args = (
        LocalAddr => $self->host,
        LocalPort => $self->port,
        ReuseAddr => 1,
    );
    delete $args{LocalPort} unless $self->port;    # 0 means autoselect
    my $daemon = HTTP_Daemon->new(%args)
      or die "Cannot initialize proxy daemon: $!";
    $self->daemon($daemon);

    return $daemon;
}



1;

