#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/lib/IFT/FreeCacheTest.pm#1 $
#
# Copyright (c) 2006 Network Appliance, Inc.
# All rights reserved.

## @summary       Free Cache Test (monitor) for Integration test
## @description
##       resource aginition via setral and monitor filer's wafl stats 
##
## @author dl-johny

use strict;

package FreeCacheTest;

use Tharn;
#use SayWrap qw(sayEOF);
use Utils qw(make_conn);
use Data::Dumper;
use SPARSE::Util::Logger qw(logStep logWarn logDbg logError);
use filer qw(filer_resource_agitation_set);

## new is called with the class (FreeCacheTest::new) and filers hostspec 
## (full hostspec of filer i.e. u43;hosttype=filer)

sub new {
    my $class = shift;
    my @filers = shift;
    my $self = {};
    $self->{subtests} = {};
    my $subtests = $self->{subtests};
    foreach my $flr (@filers) {
      my $conn  = make_conn( $flr, "#console" ); #rsh got refused easily, tmp solution
      my $hostname = $conn->hostp()->hostname();
      my $subt = subtest(
         sub {
          my $consume_value=20;  # start from 20%
          my $eating_suspends;
          my $eating_restarts = 0;
          my $prev_eating_restarts; 

          while (1) {
            my (undef, undef, $after) = say($conn, "priv set diag; wafl stats",'-timeout', 600);
            my @lines = split(/\n/, $after);
            foreach my $line (@lines) {
                if ($line =~ /eating_suspends\s+=\s*(\d+)/) {
                    $eating_suspends = $1;
                }
                elsif ($line =~ /eating_restarts\s+=\s*(\d+)/) {
                    $prev_eating_restarts = $eating_restarts;
                    $eating_restarts = $1;
                }
            } 
            if ($eating_suspends ==0 ) {  # not at low mem stat
                logcomment("not low mem, $consume_value");
                $consume_value++ if ($consume_value<99);
                filer_resource_agitation_set($conn, "malloc", 
                    consume_pct=>$consume_value, random_N=>0);
                sleep(30);
            }
            else {
                logcomment("low mem, $consume_value");
                if ($eating_restarts <= $prev_eating_restarts) {
                  logcomment("low mem, $consume_value, $eating_restarts, $prev_eating_restarts");
                  sleep(5);
                  my (undef, undef, $af) = 
                    say($conn, "priv set diag; wafl stats",'-timeout',600);
                  my @li = split(/\n/, $af);
                  foreach my $line (@li) {
                     if ($line =~ /eating_restarts\s+=\s*(\d+)/) {
                         $prev_eating_restarts = $eating_restarts;
                         $eating_restarts= $1;
                         last;
                     }   
                  }
                  if ($eating_restarts <= $prev_eating_restarts) {
                    # eating_restarts not increse, give back some mem
                    $consume_value-- if ($consume_value>0);
                    filer_resource_agitation_set($conn, "malloc", consume_pct=>$consume_value);
                    sleep(10);
                  }   
                }
                else { # just the right condition
                    logcomment("just the right condition");
                    sleep(30);
                }
             }
          }
        },
        '-bg',
        -runid, "$hostname"."_mem_monitor",
        '-onexit',
        sub {
        },    # don't pass results to parent
      );
      if (!$subt) { 
logcomment("error when start freecache subtest on $flr");
        $self->{error} = "error when start freecache subtest on $flr"; 
        last;
      };
      $subtests->{$subt}{subt}   = $subt;
    } 
    
    return $self if ( $self->{error} );

    bless $self, $class;
    return $self;
}

sub stop_children {
    my $self = shift;
    logcomment("Stopping all subtests");
    my $subtests = $self->{subtests};
    foreach my $subtinfo (values(%$subtests)) {
       my $subt = $subtinfo->{subt};
       $subt->kill();
    }
}

1;

