# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/IFT/IFTCmd.pm#1 $

### Commands implemented by IFTFDOTest RPC server.
### Must be in 'main' package

use strict;
use Data::Dumper;
use Fcntl qw(:DEFAULT);
use File::Copy;
use File::Compare;
use File::Path;
use File::Find;
use File::Basename;
use IFT::IFTComm;
use IO::Handle;
use Cwd;
use Tharn;
use SPARSE::Util::Logger qw(logError logTrc logStep logWarn);
use Quota qw(convertQuotaValue);

#    my $sserv = shift;
my $hostname = `hostname`;
#    $sserv->connect_to_status_server(client=>$hostname);

#### Subtest::ipc()->serve();
my $tests = {};
my $RETRIES = 3;
my $DBGCEB = 0;
my $DBGTMP = 0;


sub test_control {
    my $params = shift;
    print "\n\nDBGCEB:test_control: calling $params->{test}\n\n" if $DBGCEB;
    my $pid = fork();
    return if $pid;
    &{$params->{test}}($params);
    return;
}


sub _send_msg {
    my $tid = shift;
logcomment("Enter _send_msg");
    if (!exists $tests->{$tid}) {
        logWarn("CmdServer:_send_msg: no test obj exists for $tid");
system("echo \"\n\n=====================================================\nCmdServer:_send_msg: no test obj exists for TID: $tid\" >>/tmp/send.log");
        return; 
    }
    my $test = $tests->{$tid};
    $test->{id} = $tid unless (defined($test->{tid}));
    logcomment("_send_msg:  TID: $tid   TEST:\n\n",Dumper($test));
    $test->{starttime} = time()
        if (!exists $test->{starttime});
    my $tmp = { %$test };
    my $msg = "";
    if ($tmp->{type} eq "START") {
        logcomment("_send_msg: got a START message to send from $test");
        $msg .= ";STARTTEST;";
    } elsif ($tmp->{type} eq "RESULT" || $tmp->{endtest}) {
        logcomment("_send_msg: got a RESULT message to send from $test");
        $msg .= ";ENDTEST;RESULT=$tmp->{result};RESULTSTR=$tmp->{text};";
        delete $tmp->{text};
        delete $tmp->{resultstr};
        delete $tmp->{result};
    } else {
        ### $msg .= "EMSG";
   }
    foreach my $key (keys %{$tmp}) {
        $msg .= uc($key) . "=" . $tmp->{$key} . ";";
    }
   logcomment($msg);
system("echo \"\n\n===================================================\nCmdServer::_send_msg  TID: $tid  TEST:\n".Dumper($test)."\nTYPE: $tmp->{type}\nMSG: $msg\" >> /tmp/send.log");
   _send($test,$msg);
logcomment("Exit _send_msg");
   return;
}


sub _send {
   my $tid = shift;
   my $msg = shift;
logcomment("Enter _send");
   my $testinfo = $tests->{$tid};
   my $ack = undef;
   my $retry = undef;
   my $retries = undef;
logcomment("before write_message: $msg");
system("echo \"\n\n===============================================\nCmdServer::_send  Message:\n$msg\" >> /tmp/send.log");
   Subtest::ipc()->write_message($msg);
   $testinfo->{msg}++;
logcomment("Exit _send");
   return;
}


sub _OLD_send {
   my $test = shift;
   my $msg = shift;
logcomment("Enter _send");
#      my $testinfo = $tests->{$test};
   my $ack = undef;
   my $retry = undef;
   my $retries = undef;
   print "DBGCEB: sending $msg\n" if $DBGCEB;
#       print "DBGCEB:CmdServer:_send sserv = ",Dumper($sserv);
#       my $sock = $sserv->{server};
#       print $sock $msg;
#       Subtest::ipc()->write_obj($tests->{$test});
   logcomment("before write_message: $msg") if ($DBGCEB);
   Subtest::ipc()->write_message($msg);
#       my @frozen_args = map { NATE::RPC::Freeze::freeze($_) } $tests->{$test};
#       Subtest::ipc()->write_message(@frozen_args);
#       sleep(10);
#       while (!$ack) {
#         if (Subtest::ipc()->can_read()) {
#             my $input = Subtest::ipc()->read_message();
#             my $input = Subtest::ipc()->read_obj();
#             print "DBGCEB:_send:received: ",Dumper($input) if $DBGCEB;
#             next if ($input->{testname} ne $test);
#             if ($input->{ack} eq "ACK") {
#                 $input->{ack} = "";
#                 $ack = 1;
#                 $tests->{$test} = $input;
#                 last;
#             }
#         } else {
#           print "DBGCEB:_send can_read failed\n" if $DBGCEB;
#         }
#         if (!$ack) {
#          print "DBGCEB:_send: no ack retry = $retry retries = $retries\n" if $DBGCEB;
#          last if ($retry && !$retries);
#          $retries = 3 if (!$retry);
#          $retry = 1;
#          print "DBGCEB:_send: retry number ",(3 - $retries) if $DBGCEB;
#          print "DBGCEB: sending again:$retries  $msg\n" if $DBGCEB;
#          Subtest::ipc()->write_obj($tests->{$test});

##          Subtest::ipc()->write_message($msg);
#          $retries--;
#          sleep(10);
#         }
#       }
#       logcomment ("WARN:unable to notify parent") if (!$ack);
   logcomment ($msg);
   $tests->{$test}{msg}++;
#       getc;  #DBGCEB
   return;
}


sub _send_endtest {
    my $test_or_tid = shift;
logcomment("Enter _send_endtest");
    my $result = shift;
    my $text = shift;
    my $test;
    my $tid;
    my $write_size;
    my $file_count; 

    if (ref($test_or_tid)) {
        $test = $test_or_tid;
        $tid = $test->{id};
        # 'text' & 'result' are taken from 'test_or_tid' HASHREF, args are ignored.
        foreach my $key (keys %{$test}) {
           $tests->{$tid}{$key} = $test->{$key};
        }
    } else {
        $tid = $test_or_tid;
        $test = $tests->{$tid} || {};
        $tests->{$tid} = $test;
        $test->{text} = $text;
        $test->{result} = $result;
    }

    $test->{type} = "RESULT";
    $test->{endtest} = "ENDTEST";
    $test->{endtime} = time();
    $test->{duration} = $test->{endtime} - $test->{starttime};
    logcomment("_send_endtest: tinfo = ",Dumper($test));
#        $sserv->ift_send_endtest($test);
logcomment("Exit _send_endtest");
system("echo \"\n\n====================================================\nCmdServer::_send_endttest  TID: $tid:\n".Dumper($test)."\" >> /tmp/send.log");
    _send_msg($tid);
    delete($tests->{$tid});
###    return ( "_send_endtest: test=$tid\nresult=$result\ntext=$text" );
    return;
}


sub _send_starttest {
    my $test_or_tid = shift;
logcomment("Enter _send_starttest");
    my $testname = shift;
    my $client = shift;
    my $mp = shift;
    my $text = shift;
    my $test;
    my $tid;
    my $is_ref = (ref($test_or_tid))?"IS ref":"IS NOT ref";
    if (ref($test_or_tid)) {
       $test = $test_or_tid;
       $tid = $test->{id};
       $tests->{$tid} = { %$test };

    } else {
       $tid = $test_or_tid;
       $test = $tests->{$tid} || {};
       $tests->{$tid} = $test;
       $test->{id} = $tid;
       $test->{client} = $client;
       $test->{mp} = $mp;
       $test->{text} = $text;
       $test->{testname} = $testname;
    }
    $test->{type} = "START";
    $test->{starttime} = time();
logcomment("_send_starttest: tinfo = ",Dumper($test));
system("echo \"\n\n====================================================\nCmdServer::_send_starttest   $is_ref  TID: $tid:\n".Dumper($test)."\" >> /tmp/send.log");
#        $sserv->ift_send_starttest($tests->{$tid});
    _send_msg($tid);
logcomment("Exit _send_starttest");
    return;
}


sub _send_noend_msg {
    my $tid = shift;
logcomment("Enter _send_noend_msg");
    my $type = shift;
    my $text = shift;
    my $result = shift;
    my $test = $tests->{$tid};
    $test->{type} = $type;
    $test->{text} = $text;
logcomment("DBGCEB:_send_noend_msg: tinfo = ",Dumper($test));
#        $sserv->ift_send_noend_msg($tests->{$tid});
system("echo \"\n\n====================================================\nCmdServer::_send_noend_msg   TID: $tid:\n".Dumper($test)."\" >> /tmp/send.log");
    _send_msg($tid);
logcomment("Exit _send_noend_msg");
    return;
}


sub quota_size {
    my $size = shift; # bytes
    if ($size <= 64) { 
		return 0; # doesn't occupy data block
    }
    my $kbytes = int($size/1024);
    if (($size % 1024) != 0) { 
		$kbytes++;
    } 
    $kbytes = convertQuotaValue($kbytes);
    logcomment("after convertQuotaValue: $kbytes") if ($DBGCEB);
    return ($kbytes*1024);
}

sub my_create_files ( $ ) {
    my $params = shift;
    my $path = $params->{path};
    my $ownname = "my_create_file";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    my $error = undef;
    return if (!_check_path($tid,$path));
    chdir($path);
    my $currpath = getcwd();
    print "DBGCEB:$ownname: working directory is $currpath\n" if $DBGCEB;
    my $line_count = $params->{lcount} if (exists $params->{lcount});
    my $filename = $path ."/testfile".time();
    $line_count = 300 unless $line_count;
    my $line = undef;
    for (my $i = 0;$i < 80; $i++) {
       $line .= chr(rand(118)+32);
    }
    open(FILE, ">$filename") or $error = "cannot open $filename  $!";
    return (_send_endtest($tid,"FAIL",$error)) if ($error);
    for (my $i=0; $i<$line_count; $i++) {
        print FILE "$line\n" or $error = "unable to write to $filename: $!";
        return (_send_endtest($tid,"FAIL",$error)) if ($error);
    }
    close(FILE) or $error = "unable to close $filename $!";
    return (_send_endtest($tid,"FAIL",$error)) if ($error);
    my $file_count = 1;
    my $write_size = $line_count * 81;
    my $msg = "FILE_COUNT=$file_count:WRITE_SIZE=$write_size";
    _send_noend_msg($tid,"INFO",$msg);
    _send_endtest($tid,"PASS");
    return;
}


  sub my_check_path ( $ ) {
      my $params = shift;
      my $path = $params->{path};
      my $ownname = "my_check_path";
      my $tid = $params->{tid};
      _send_starttest($tid,$ownname,$params->{client},$path);
      _send_noend_msg($tid,"INFO", "my_check_path: $path");
      my $error = undef;
      $error = "check_path \"$path\" failed" unless (_check_path($tid,$path));
      _send_endtest($tid,"FAIL",$error) if ($error);
      _send_endtest($tid,"PASS");
}


  sub my_echo_params ( $ ) {
      my $params = shift;
      my $ownname = "my_echo_params";
      my $tid = $params->{tid};
      my $param_str = Dumper($params);
      my $msg = "$ownname: TID: $tid  PARAMS\n\n$param_str";
system("echo \"\n\n======================================================\nmy_echo_params \n".Dumper($params)."\"> /tmp/log.log");
      _send_starttest($tid,$ownname,$params->{client}, $params->{path});
      _send_noend_msg($tid,"INFO", "$ownname: PARAMS\n\n$param_str");
      return( _send_endtest($tid,"PASS") );
}


  sub my_echo_error ( $ ) {
      my $params = shift;
      my $ownname = "my_echo_error";
      my $tid = $params->{tid};
      _send_starttest($tid,$ownname,$params->{client}, "");
      my $param_str = Dumper($params);
      _send_noend_msg($tid,"INFO", "$ownname: PARAMS\n\n$param_str");
      my $error = "my_echo_error returning ERROR";
      _send_endtest($tid,"FAIL",$error);
      return($error);
}


sub _check_path {
    my $tid = shift;
    my $path = shift;
    if (!$path) {
        my $text =  "no directory specified";
        _send_endtest($tid,"FAIL",$text);
        return 0;
    } elsif (! -e $path) {
        my $text =  "directory does not exist $path";
        _send_endtest($tid,"FAIL",$text);
        return 0;
    }
    return 1;
}

sub my_truncate_files ( $ ) {
    my $params = shift;
    my $path = $params->{path};
    my $basename = $params->{file_prefix};
    my $client = $params->{client};
    my $ownname = "my_truncate_files";
    my $error = undef;
    my $delete_bytes = undef;
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    return if (!_check_path($tid,$path));
    chdir($path);
    my $currpath = getcwd();
    print "DBGCEB:$ownname: working directory is $currpath\n" if $DBGCEB;
    my $count = 5;
    my @files = _get_filer_files($path,$basename);
    my $filecount = (@files);
    $count = 1 if ($count >= $filecount);
    my $cnt = $count+1;
    foreach my $file (@files) {
       next if (-d $file);
       print "DBGCEB:$ownname basename = $basename\n" if $DBGCEB;
       next if ($file !~ /$basename/);
       $cnt-- if ($cnt > 0);
       next if ($cnt > 0);
       next if (! -e $file);
       print "$ownname: truncating $file\n";
       my $size = ( -s $file) ;
       my $trunc = int($size/2);
       $cnt = $count+1;
       open(FILE, "+>$file") or $error = "Unable to open file $file $!";
        if ($error) {
           _send_noend_msg($tid,"ERROR",$error);
           $error = "";
           $result = "FAIL";
           next;
        }
       truncate(FILE, $trunc)
               or $error = "Unable to truncate file $file $!";
       close(FILE) or $error = "Unable to close file $file $!";
       if ($error) {
           _send_noend_msg($tid,"ERROR",$error);
           $error = "";
           $result = "FAIL";
       }

    }
    return (_send_endtest($tid,$result));
}

sub my_copy_file ( $ ) {
    my $params = shift;
    my $path = $params->{path};
    my $prefix = $params->{file_prefix};
    my $ownname = "my_copy_file";
    my $file_info = {};
    my $error = undef;
    logcomment("$ownname started");
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    return if (!_check_path($tid,$path));
    chdir($path);
    $file_info->{localpath} = $path;
    $file_info->{basename} = $prefix;
    $file_info->{size} = $params->{fsize};
    _create_source_file($file_info);
    if (exists $file_info->{error}) {
        my $text = "No source file created in $path: $file_info->{error}";
        return (_send_endtest($tid,"FAIL",$text));
    }
    my $source_file = $file_info->{file};
    my $file_size = $file_info->{size};
    my $write_size = $file_info->{size};
    my $target_file = $prefix . time();
    my $currpath = getcwd();
    print "DBGCEB:$ownname: working directory path is $currpath\n" if $DBGCEB;
    copy ($source_file, $target_file)
        or $error = "unable to copy $source_file to $target_file  $!" ;
    return (_send_endtest($tid,"FAIL",$error)) if $error;
    $write_size += $file_size;
    return (_send_endtest($tid,"PASS"));
}


sub my_overwrite_files {
    my $params = shift;
    my $ownname = "my_overwrite_files";
    my $quotas = ($params->{quotas} ? $params->{quotas} : 0);
    my $path = $params->{path};
    my $basename = $params->{file_prefix};
    my $dir_prefix = $params->{dir_prefix};
    my $tree = $params->{tree};
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    return if (!_check_path($tid,$path));
    my @files = _get_filer_files($path,$basename);
    my $count = 10;
    my $error = undef;
    my $result = "PASS";
    my $filecount = (@files);
    $count = 1 if ($count > $filecount);
    foreach my $file (@files) {
       next if ($file !~ /$basename/);
       next if ($file =~ /snap/);
       $count--;
       next if ($count);

       my $dirname = dirname($file);
       my $tmpfile = $dirname."/"."temp_".time();
       copy($file,$tmpfile) or $error = "cannot copy $file to temp file".
            " $tmpfile: $!";
       return (_send_endtest($tid,"FAIL",$error)) if $error;
       copy($tmpfile,$file)
          or $error = "cannot copy $tmpfile to $file:$!";
       if ($error) {
         _send_noend_msg($tid,"ERROR",$error);
         $error = "";
         $result = "FAIL";
       }
       unlink $tmpfile;
    }
    return (_send_endtest($tid,$result));
}


sub my_write_files ( $ ) {
    my $params = shift;
    my $quotas = ($params->{quotas} ? $params->{quotas} : 0);
    my $free_cache_test = ($params->{free_cache_test} ? $params->{free_cache_test} : 0);
    my $filerpath = $params->{path};
    my $basename = $params->{file_prefix};
    my $dir_prefix = $params->{dir_prefix};
    my $tree = $params->{tree};
    my $dircount = $params->{dircount};
    my $basesize;
    if ($free_cache_test) {
        $basesize = 1;
    }
    else {
        $basesize = $params->{fsize};
    }
    my $filecount = $params->{filecount};
    my $write_size = undef;
	my $quota_size;
    my $error = undef;
    my $rc = undef;
    $filecount = -1 unless $filecount;
    my $size = $basesize;
    $basename = "testfile" unless $basename;
    my $nospace = "No space left on device";
    my $nodir = "No such file or directory";
    my $Errlevel = undef;
    my $ownname = "my_write_files";
    my $result = "PASS";
    my $tid = $params->{tid};
    my $tinfo = {};
    $tinfo->{id} = $tid;
    $tinfo->{testname} = $ownname;
    $tinfo->{client} = $params->{client};
    $tinfo->{mp} = $filerpath;
    $tinfo->{result} = "PASS";
    if ($params->{quotas}) {
        $tinfo->{uid} = $params->{uid};
        $tinfo->{gid} = $params->{gid};
        $tinfo->{write_size} = 0;
        $tinfo->{file_count} = 0;
        _set_user_group($params);
        $tinfo->{text} = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        logcomment("before _send_noend_msg: $tinfo->{text}")
            if ($DBGCEB);
#            _send_noend_msg($tid,"INFO",$msg);
    }
     _send_starttest($tinfo);
     return(_send_endtest($tid,"FAIL","$filerpath does not exist"))
                  if (!_check_path($tid,$filerpath));
    chdir($filerpath);
    my $currpath = getcwd();
    print "DBGCEB:$ownname: current working dir is $currpath\n" if $DBGCEB;
    # by design, a count of -1 will make this loop forever.
    #create local testdir on client and chdir
    my @filer_dirs = _get_filer_dirs($tid, $filerpath, $dir_prefix, $tree);
    if (!@filer_dirs) {
      return ( _send_endtest($tid,"NA", "unable to get directories in $filerpath") );
    }
    my @dirs = ();
    foreach (1 .. $dircount) {
         push(@dirs, $filer_dirs[ int(rand(@filer_dirs)) ]);
    }
    my $retries = 3;
    print "DBGCEB:$ownname creating local file on $filerpath $basename ".
          "$size\n" if $DBGCEB;
    my $file_info = {};
    $file_info->{localpath} = $filerpath;
    $file_info->{basename} = $basename;
    $file_info->{size} = $size;
    _create_source_file($file_info);
    if (exists $file_info->{error}) {
        my $text = "No source file created in $filerpath: " .
                    "$file_info->{error}";
        return (_send_endtest($tid,"FAIL",$text));
    }
    $tinfo->{file_count}++;
    my $source_file = $file_info->{file};
#        logcomment("created file: $source_file, uid=$>");
    $file_info->{size} = (-s $source_file);
    logcomment("after create, get the file size: $file_info->{size}")
        if ($DBGCEB);
    $quota_size = quota_size($file_info->{size});
#        $tinfo->{write_size} += $file_info->{size};
    $tinfo->{write_size} += $quota_size;
    logcomment("write_size for $file_info->{localpath}: $tinfo->{write_size}")
        if ($DBGCEB);

    return (_send_endtest($tid,"FAIL",
           "MYSTERY! $source_file does not exist but we just created it"))
                          if (! -e $source_file);
    print "DBGCEB:$ownname: source file = $source_file ".
           "size = $file_info->{size}\n"
           if $DBGCEB;
    my $file_count = 1;
    # foreach directory on mount point...
    foreach my $dir (@dirs) {
        if (! -e $dir) {
            print "DBGCEB:$ownname: DIR DOES NOT EXIST: $dir\n" if $DBGTMP;
            next;
        }
        chdir $dir;
        print "DBGCEB:$ownname creating $filecount number of files\n"
               if $DBGCEB;
        # create $filecount number of files
        for my $loop_count (1 .. $filecount) {
             my $ts = time();
             #copy local source file to filer directory
             if (! -e $dir) {
                 print "DBGCEB:$tid:$ownname $dir does not exist\n" if $DBGTMP;
                 last;
             }
             my $target_file = sprintf("%s/%s_%s",$dir,$basename,$ts);
             print "DBGCEB:$ownname copying $source_file to $target_file,uid=$>\n" if $DBGTMP;
             copy($source_file, $target_file) or my $error = $!;
             if (($error =~ /$nospace/) ||
                 ($error =~ /$nodir/) || $error =~ /exceed/i) {
                  return(_send_endtest($tid,"FAIL",$error));
             }
             if ($error) {
                 _send_noend_msg($tid,"ERROR","unable to copy ".
                                 "$source_file to $target_file  $error");
                 $tinfo->{result} = "FAIL";
                 next;
             } else {
               $tinfo->{file_count}++;
               my $copy_size = (-s $target_file);
		   $quota_size = quota_size($copy_size);
#                   $tinfo->{write_size} += (-s $target_file);
               $tinfo->{write_size} += $quota_size;
             }
             # verify target file is the same as the source file
             print "DBGCEB:$ownname: comparing source=$source_file target=$target_file\n" if $DBGCEB;
             sleep(1);
             for(my $ii=0 ; $ii<30 ; $ii+=1 ) {
                $error = _compare_files($ownname,$source_file,$target_file);
                if($error) { sleep(2); next; }
                else { last; }
             }
             if ($error) {
                 _send_noend_msg($tid,"ERROR",$error);
                 $tinfo->{result} = "FAIL";
                 $error = "";
             }

             # alter original file
             if ($file_info->{size} >= ($basesize * 10)) {
                  $file_info->{size}  = $basesize;
                  my $sourcesize = (-s $source_file);
		      $quota_size = quota_size($sourcesize);
                  unlink $source_file;
#                      $tinfo->{write_size} -= $sourcesize;
                  $tinfo->{write_size} -= $quota_size;
                  _create_source_file($file_info);
                  $source_file = $file_info->{file};
		      $sourcesize = (-s $source_file);
		      $quota_size = quota_size($sourcesize);
                  $tinfo->{write_size} += $quota_size; 
             } else {
                my $tmpsize =  (-s $source_file);
		    my $tmp_quotasize = quota_size($tmpsize);
                if (!$free_cache_test) {
                  $size = int ($file_info->{size}/2);
                  $rc = _append_source_file($source_file, $size, $tid);
                }
                $file_info->{size} = (-s $source_file);
		    my $new_quotasize = quota_size($file_info->{size});
#                    $tinfo->{write_size} += ($file_info->{size} - $tmpsize);
                $tinfo->{write_size} += ($new_quotasize - $tmp_quotasize);
             }
        } # end while loop
    } # end foreach loop
    if ($params->{quotas}) {

       return (_send_endtest($tinfo));
    }
    return (_send_endtest($tid,$result));
}


sub _append_source_file {
    my $source_file = shift;
    my $size = shift;
    my $tid = shift;

    open(FILE, "+>>$source_file") or my $error = $!;
    if ($error) {
        my $msg = sprintf "cannot open file %s %s",
                  $source_file, $error;
        _send_noend_msg($tid,"ERROR",$msg);
        return $error;
    }

    my $text = undef;
    for (my $i = 0;$i < $size; $i++) {
        $text .= chr(rand(118)+32);
    }
    print FILE $text
       or $error = "unable to print to $source_file $!";
    close(FILE)
       or $error = "unable to close $source_file $!";
    if ($error) {
        _send_noend_msg($tid,"ERROR",$error);
        return $error;
    }
    return $size;
}

sub my_delete_files {
    my $params = shift;
    my $basename = $params->{file_prefix};
    my $count = 5;
    my $ownname = "my_delete_files";
    my $error = undef;
    logcomment("$ownname started");
    my $path = $params->{path};
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    my $tinfo = {};
    $tinfo->{id} = $params->{tid};
    my $tid = $params->{tid};
    $tinfo->{testname} = $ownname;
    $tinfo->{client} = $params->{client};
    $tinfo->{mp} = $path;
    $tinfo->{result} = "PASS";
    if ($params->{quotas}) {
        logcomment("my_delete_files: quotas is set") if ($DBGCEB);
        $tinfo->{uid} = $params->{uid};
        $tinfo->{gid} = $params->{gid};
        $tinfo->{write_size} = 0;
        $tinfo->{file_count} = 0;
        _set_user_group($params);
        $tinfo->{text} = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
#            _send_noend_msg($tid,"INFO",$msg);
    }
     _send_starttest($tinfo);
    return if (!_check_path($tid,$path));
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
#            _send_noend_msg($tid,"INFO",$msg);
    }
    chdir($path);
    my $currpath = getcwd();
    $path = getcwd() unless $path;;
    $basename = 'test' unless $basename;
    my @files = ();
    my $cnt = $count+1;
    @files = _get_filer_files($path,$basename);
    if (!@files) {
        my $msg = "no files were found in tree $path";
        return (_send_endtest($tid,"FAIL",$msg));
    }
    my $file_size = undef;
    my $file_count = undef;
    my $fcount = (@files);
    $cnt = 1 if ($cnt >= $fcount);
    foreach my $file (@files) {
       next if (-d $file);
       next if ($file !~ /$basename/);
       print "$ownname: deleting $file\n";
       print "DBGCEB:$ownname: basename = $basename file = $file\n" if $DBGCEB;
       $cnt-- if ($cnt > 0);
       my $file_size = (-s $file);
       unlink($file) or $error = "could not delete file $file  $!";
       if ($error) {
          _send_noend_msg($tid,"ERROR",$error);
          $error = "";
          $tinfo->{result} = "FAIL";
          next;
       }
       $tinfo->{write_size} -= quota_size($file_size);
       $tinfo->{file_count} -= 1;
       last if ($cnt <= 0);
    }
    return (_send_endtest($tinfo));
}


sub my_file_attributes {
    my $params = shift;
    my $path = $params->{path};
    my $dir_prefix = $params->{dir_prefix};
    my $its = $params->{iterations};
    my $client = $params->{client};
    my $ownname = "my_filer_attributes";
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    return if (!_check_path($tid,$path));

    chdir($path);

    my $currpath = getcwd();

    my $getcmd = undef;
    my $error = undef;
    my @files = _get_filer_files($path,$dir_prefix);
    if (@files eq ()) {
        my $msg = sprintf "%s:%s:directory %s does not exist",
                          $ownname,$client,$path;
        return(_send_endtest($tid,"FAIL",$msg));
    }

    my $cmds = { 'getatt' => { 'win' => "attrib /S ",
                               'unix' => "ls -lR "},
                 'setuid' => { 'win' => undef,
                               'unix' => undef },
                 'setgid' => { 'win' => undef,
                               'unix' => undef },
                 'rdatt' => { 'win' => "attrib +R",
                               'unix' => 'sudo chmod 0111'},
                 'wratt' => { 'win' => "attrib -R",
                               'unix' => 'sudo chmod 0777'},
                };



    my $os = ($^O eq "MSWin32") ? "win" : "unix";

    for (1..$its) {
         my $contents = `r $cmds->{gettatt}{$os} $path` or $error = $!;
         if ($error) {
             my $msg = sprintf "%s:%s: unable to get attributes on %s:%s",
                               $ownname,$client,$path,$error;
             _send_noend_msg($tid,"ERROR",$msg);
             $result = "FAIL";
         }
    }
    return (_send_endtest($tid,$result));

}


sub my_populate_directories {
    my $params = shift;
    my $tid = $params->{tid};
    my $min_dirs = $params->{min_dircount};
    if (!$min_dirs) {
        $min_dirs = 5 * $params->{dircount};
    }
    if (!$min_dirs) {
        $min_dirs = $params->{max_dirs};
    }
    if (!$min_dirs) {
        $min_dirs = $params->{iterations};
    }
    my $ownname = "my_populate_directories";
logcomment("CmdServer:my_populate_directoreies:  MIN_DIRS: $min_dirs  MIN_DIRCOUNT: $params->{min_dircount}  DIRCOUNT: $params->{dircount}");
system("echo \"\n\n=====================================================\nCmdServer:my_populate_directoreies:  MIN_DIRS: $min_dirs  MIN_DIRCOUNT: $params->{min_dircount}  DIRCOUNT: $params->{dircount}\" >>/tmp/send.log");
    return unless ($min_dirs);
    my $basedir = $params->{path};
    my $basename = $params->{dir_prefix};
logcomment("CmdServer:my_populate_directories:  Calling:  _get_filer_dirs  basedir: $basedir  basename: $basename");
system("echo \"\nCmdServer:my_populate_directories:  Calling:  _get_filer_dirs  basedir: $basedir  basename: $basename\" >>/tmp/send.log");
    my @filer_dirs = _get_filer_dirs($tid, $basedir, $basename, 1);
    my $num_existing = scalar(@filer_dirs);
logcomment("CmdServer:my_populate_directories:  Returned from:  _get_filer_dirs:  NUM_EXISTING: $num_existing");
system("echo \"\nCmdServer:my_populate_directories:  Returned from:  _get_filer_dirs:  NUM_EXISTING: $num_existing\" >>/tmp/send.log");
    my $ndirs =  $min_dirs - $num_existing;
    if ($ndirs <= 0) {
        _send_starttest($tid, $ownname, $params->{client}, $basedir);
logcomment("CmdServer:my_populate_directories:  Existing directories: $num_existing  Exceeds min_dircount: $min_dirs");
        return( _send_endtest($tid, "PASS","Existing directories: $num_existing  Exceeds min_dircount: $min_dirs") );
    }
    $params->{iterations} = $ndirs + 2;
logcomment("CmdServer:my_populate_directories:  Calling my_create_directory_tree  DIRCOUNT: $params->{dircount}");
system("echo \"\nCmdServer:my_populate_directories:  Calling my_create_directory_tree  DIRCOUNT: $params->{dircount}\" >>/tmp/send.log");
    return( my_create_directory_tree($params) );
}


sub my_create_directory_tree {
    my $params = shift;
    my $path = $params->{path};
    my $basedir = $params->{path};
    my $basename = $params->{dir_prefix};
    my $depth = $params->{depth};
    my $width = $params->{width};
    my $iterations = $params->{iterations};
    my $dircount = $params->{dircount};
logcomment("CmdServer:my_create_directory_tree:  DIRCOUNT: $dircount");
system("echo \"\n\n=====================================================\nCmdServer:my_create_directory_tree:  DIRCOUNT: $dircount\" >>/tmp/send.log");
    my $ownname = "my_create_directory_tree";
    my $file_count = 0;
    my $result = "PASS";
    my $nospace = "No space left on device";
    my $nodir = "No such file or directory";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$basedir);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if (!_check_path($tid,$path)) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
        _send_endtest($tid, "FAIL","check_path failed for: $path");
        return;
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    chdir($path);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $currpath = getcwd();
    my $msg = undef;
    my $cmd = "sudo chmod 0777 $basedir";
    `$cmd`;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    chdir($basedir);
    my $error = 0;
    my @filer_dirs = _get_filer_dirs($tid, $basedir, $basename, 1);
    if (!@filer_dirs) {
        push(@filer_dirs,$basedir);
    }

 _send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    while (1) {
        my $dir =  $filer_dirs[ int(rand(@filer_dirs)) ];
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."   File Count: $file_count  Dir: $dir");
        if (! -e $dir) {
           logcomment("$ownname: DIR DOES NOT EXIST: $dir");
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
            next;
        }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       chdir($dir);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $wcount = $width;
    while ($wcount) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."  wcount: $wcount");
       my $mybase = $basedir;
       my $count = $depth;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       while ($count) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."  count: $count");
           my $ts = time();
           my $target = sprintf "%s/\%s%s",$mybase,$basename,$ts;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           next if (-e $target);
           print "$ownname: create directory $target\n";
           mkdir($target, 0777) or $error = $!;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           if ($error) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               $msg = sprintf "%s:Unable to create %s: %s",$ownname,
                              $target,$error;
               if (($error =~ /$nospace/) ||
                   ($error =~ /$nospace/)) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
                   return(_send_endtest($tid,"FAIL",$error));
                   return;
               }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               _send_noend_msg($tid,"ERROR",$msg);
               $result = "FAIL";
               $error = "";
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               last;
           }  else {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
              $msg = "created directory $target";
              $file_count++;
              if ($file_count >= $iterations) {
                  goto my_create_directory_tree_DONE;
              }
              $mybase = sprintf "%s",$target;
              $count--;
           }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           ### sleep (2);
       }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       $wcount--;
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    }

my_create_directory_tree_DONE:
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if (!$file_count) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       _send_endtest($tid,"FAIL","no directories were created");
       return;
    }

_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if ($quotas) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       my $msg = "FILE_COUNT=$file_count";
       _send_noend_msg($tid,"INFO",$msg);
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    return (_send_endtest($tid,$result));
}




sub my_create_directory_tree_AUX {
    my $params = shift;
    my $path = $params->{path};
    my $basedir = $params->{path};
    my $basename = $params->{dir_prefix};
    my $depth = $params->{depth};
    my $width = $params->{width};
    my $iterations = $params->{iterations};
    my $dircount = $params->{dircount};
logcomment("CmdServer:my_create_directory_tree:  DIRCOUNT: $dircount");
system("echo \"\n\n=====================================================\nCmdServer:my_create_directory_tree:  DIRCOUNT: $dircount\" >>/tmp/send.log");
    my $ownname = "my_create_directory_tree";
    my $file_count = 0;
    my $result = "PASS";
    my $nospace = "No space left on device";
    my $nodir = "No such file or directory";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$basedir);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if (!_check_path($tid,$path)) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
        _send_endtest($tid, "FAIL","check_path failed for: $path");
        return;
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    chdir($path);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $currpath = getcwd();
    my $msg = undef;
    my $cmd = "sudo chmod 0777 $basedir";
    `$cmd`;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    chdir($basedir);
    my $error = 0;
    my @filer_dirs = _get_filer_dirs($tid, $basedir, $basename, 1);
    if (!@filer_dirs) {
        push(@filer_dirs,$basedir);
    }

 _send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    while (1) {
        my $dir =  $filer_dirs[ int(rand(@filer_dirs)) ];
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."   File Count: $file_count  Dir: $dir");
        if (! -e $dir) {
           logcomment("$ownname: DIR DOES NOT EXIST: $dir");
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
            next;
        }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       chdir($dir);
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    my $wcount = $width;
    while ($wcount) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."  wcount: $wcount");
       my $mybase = $basedir;
       my $count = $depth;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       while ($count) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__."  count: $count");
           my $ts = time();
           my $target = sprintf "%s/\%s%s",$mybase,$basename,$ts;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           next if (-e $target);
           print "$ownname: create directory $target\n";
           mkdir($target, 0777) or $error = $!;
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           if ($error) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               $msg = sprintf "%s:Unable to create %s: %s",$ownname,
                              $target,$error;
               if (($error =~ /$nospace/) ||
                   ($error =~ /$nospace/)) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
                   return(_send_endtest($tid,"FAIL",$error));
                   return;
               }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               _send_noend_msg($tid,"ERROR",$msg);
               $result = "FAIL";
               $error = "";
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
               last;
           }  else {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
              $msg = "created directory $target";
              $file_count++;
              if ($file_count >= $iterations) {
                  goto my_create_directory_tree_DONE;
              }
              $mybase = sprintf "%s",$target;
              $count--;
           }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
           ### sleep (2);
       }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       $wcount--;
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    }

my_create_directory_tree_DONE:
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if (!$file_count) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       _send_endtest($tid,"FAIL","no directories were created");
       return;
    }

_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    if ($quotas) {
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
       my $msg = "FILE_COUNT=$file_count";
       _send_noend_msg($tid,"INFO",$msg);
    }
_send_noend_msg($tid,"INFO", "my_create_directory_tree  Line: ".__LINE__);
    return (_send_endtest($tid,$result));
}




















sub my_mkdir ( $ ) {
    my $params = shift;
    my $path = $params->{path};
    my $ownname = "my_mkdir";
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    my $error = undef;
    return if (!_check_path($tid,$path));
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
    chdir($path);
    mkdir($path) or $error = "could not create dir $path :$!";
    if ($error) {
        _send_noend_msg($tid,"ERROR",$error);
        $result = "FAIL";
    } elsif ($quotas) {
       my $msg = "FILE_COUNT=1";
       _send_noend_msg($tid,"INFO",$msg);
    }
    return (_send_endtest($tid,$result));
}


sub my_rmdir ( $ ) {
    my $params = shift;
    my $path = $params->{path};
    my $ownname = "my_rmdir";
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$path);
    my $error = undef;
    return if (!_check_path($tid,$path));
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
    # TODO: need to figure how many files are deleted and their total size
    chdir($path);
    my $currpath = getcwd();
    rmdir($path) or $error = "could not remove dir $path :$!";
    if ($error) {
        $result = "FAIL";
    } elsif ($quotas) {
       my $msg = "FILE_COUNT=?:WRITE_BYTES=?";
       _send_noend_msg($tid,"INFO",$msg);
    }
    $result = "FAIL" if $error;
    return (_send_endtest($tid,$result,$error));
}


# deletes directories from tree starting from basedir.  if $count
# equal -1 all directories will be deleted.  Otherwise, every $count
# directory will be deleted. If $iterations == -1 this will loop forever
sub my_delete_directory_tree {
    my $params = shift;
    my $basedir = $params->{path};
    my $basename = $params->{dir_prefix};
    my $ownname = "my_delete_directory_tree";
    my $error = undef;
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$basedir);
    return if (!_check_path($tid,$basedir));
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
    chdir($basedir);
    my $dircount = $params->{dircount};
    my $iterations = $params->{iterations};
    my $message = undef;
    my $tree = 1;
    print "DBGCEB:$ownname iterations = $iterations\n" if $DBGCEB;
    my @filer_dirs = _get_filer_dirs($tid, $basedir, $basename, $tree);
    if (!@filer_dirs) {
 #             return(_send_endtest($tid,"FAIL",
 #                   "unable to get directories in $basedir"));
    }

        my @dirs = [ @filer_dirs ];

     for (my $iter=0; $iter<=$iterations; $iter++) {
            my $idx = int(rand(@dirs));
            my $dir =  $filer_dirs[ int(rand(@filer_dirs)) ];
            next unless  (-e $dir);
            next if ($dir !~ /$basename/);
            next if ($dir eq $basedir);
    print "DBGCEB:$ownname basedir = $basedir basename = $basename\n"  if $DBGCEB;
            my $cmd = "rm -fr $dir";
            my $res = `$cmd`;
            print "DBGCEB:$ownname: deleting $dir result = $res\n" if $DBGTMP;
    }
    print "\n\n****DBCGEB:$ownname: PASSED sending end test***\n" if $DBGTMP;
    return (_send_endtest($tid,$result,$error));
}


sub my_readdir {
    my $params = shift;
    my $path = $params->{path};
    my $count = $params->{rdcount};
    my $dir_prefix = $params->{dir_prefix};
    my $ownname = "my_readdir";
    my $error = undef;
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client}, $path);
    return if (!_check_path($tid,$path));
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
    chdir($path);
    my $currpath = getcwd();
    print "DBGCEB:$ownname: path is $currpath count = $count\n" if $DBGCEB;

    my @filer_dirs = _get_filer_dirs($tid, $path, $dir_prefix, 1);
    for (0 .. $count) {
       my $dir = $filer_dirs[ int(rand(@filer_dirs)) ];
       print "DBGCEB:$ownname: reading directories\n" if $DBGTMP;
       ### find (sub { push @dirs, $Find::File::name; },$path);
        opendir(DIR, $dir)
            or return ( _send_endtest($tid, "FAIL", "my_readdir: No such directory: $dir") );
        while ( my $entry = readdir(DIR) ) {
            print "DBGCEB:$ownname: reading directories:  $entry\n" if $DBGTMP;
        }
        closedir(DIR);
    }
    return (_send_endtest($tid,$result,$error));
}


sub my_copydir {
    my $params = shift;
    my $basedir = $params->{path};
    my $dir_prefix = $params->{dir_prefix};
    my $dircount = $params->{dircount};
    my $ownname = "my_copydir";
    my $error = undef;
    my $result = "PASS";
    my $tid = $params->{tid};
    _send_starttest($tid,$ownname,$params->{client},$basedir);
    return if (!_check_path($tid,$basedir));
    my $quotas = $params->{quotas} if (exists $params->{quotas});
    if ($quotas) {
        _set_user_group($params);
        my $msg = "using quotas:UID=$params->{uid}:GID=$params->{gid}";
        _send_noend_msg($tid,"INFO",$msg);
    }
    chdir($basedir);
    my $currpath = getcwd();
    print "DBGCEB:$ownname: path is $currpath\n" if $DBGCEB;
    my $tree = 1;
    my @filer_dirs = _get_filer_dirs($tid, $basedir, $dir_prefix, $tree);
    if (!(@filer_dirs)) {
        $error = "no directories to copy in $basedir";
        return (_send_endtest($tid,"FAIL",$error));
    }
    my @dirs = ();
    foreach (1 .. $dircount) {
         push(@dirs, $filer_dirs[ rand($#filer_dirs) ]);
    }
    print "DBGCEB:$ownname: processing $dircount number of directories\n" if $DBGTMP;
    foreach my $dir (@dirs) {
        if (! -e $dir) {
            print "DBGCEB:$ownname: DIR DOES NOT EXIST: $dir\n" if $DBGTMP;
            next;
        }
        my $ts = time();
        my $bdir = dirname($dir);
        my $dname = basename($dir);
        $dname =~ s/_.*//;
        my $newdir = "$bdir/${dname}_copy_$ts";
        my $cmd = "cp -fr $dir $newdir";
        my $rc = `$cmd`;
        print "DBGCEB:$ownname: rc from copy = $rc\n" if $DBGCEB;
        $error = "cannot copy $dir to $newdir: $!" if ($!);
#            copy($dir,$newdir) or $error = "unable to copy $dir to $newdir: $!";
        if ($error) {
            $result = "FAIL";
            _send_noend_msg($tid,"ERROR",$error);
            $error = "";
        }
    }
    return (_send_endtest($tid,$result,$error));
}


sub _check_message {
    my $message = lc Subtest::ipc()->read_message()
            if (Subtest::rpc()->can_read);
    return 0 unless $message;
    if ($message =~ /pause.?(\d+)/) {
        sleep($1);
       return 0;
    } elsif ($message =~ /quit/) {
       return 1;
    }
    return 0;
}


sub _create_source_file {
    my $file_info = shift;
    my $localpath = $file_info->{localpath};
    my $basename = $file_info->{basename};
    my $size = $file_info->{size};
    my $ts = time();
    my $source_file = sprintf("%s/%s_%s", $localpath, $basename, $ts );
    $file_info->{file} = $source_file;

    if (!open(FILE, ">$source_file")) {
        my @cinfo = caller(1);
        my ($subname) = ($cinfo[3] =~ /.*\:\:(.*)/);
        $file_info->{error} = sprintf "FAIL:%s:cannot open %s:%s",
                     $subname,$source_file,$!;
        return 0;
    }

    if ($size == 1) { # for free_cache_size
     my $text .= chr(rand(118)+32); 
     print FILE "$text" or
            $file_info->{error} = "Unable to write to $source_file:$!";
     if ($file_info->{error}) {
            close(FILE);
            return 0;
     }
     close(FILE) or $file_info->{error} = "Unable to close $source_file
:$!";
     my $file_size = (-s $source_file);
     $file_info->{size} = $file_size;
     return 0 if (!exists $file_info->{error});
     return $source_file, $file_size;

    }
    else {
     my $mb = undef;
     if ($size) {
       $mb = ($size / 1024);
     } else {
       $mb = 1;
     }

     my $text = undef;
     for (my $j = 0; $j < $mb; $j++) {
        for (my $i = 0;$i < 1024; $i++) {
           $text .= chr(rand(118)+32);
        }
        print FILE "$text" or
            $file_info->{error} = "Unable to write to $source_file:$!";
        if ($file_info->{error}) {
            close(FILE);
            return 0;
        }
     }
     close(FILE) or $file_info->{error} = "Unable to close $source_file:$!";
     my $file_size = (-s $source_file);
     $file_info->{size} = $mb * 1024;
     return 0 if (!exists $file_info->{error});
     return $source_file, $mb * 1024;
    }

}

sub _compare_files {
    my ($subname, $file1, $file2) = @_;
    my $Error = undef;
    my $rc = compare($file1,$file2);
    return 0 if (!$rc);
    if ($rc == 1) {
        $Error = sprintf "$subname:%s not equal %s",$file1,$file2;
    } else {
        $Error = "$subname:error attempting to compare $file1, $file2:$!";
    }
    return $Error;
}

sub _get_filer_files {
    my $path = shift;
    my $prefix = shift;
    my @dirs = ();
    return 0 if (!-e $path);
    find (sub {
        push @dirs, $File::Find::name
                if ((!-d $File::Find::name) &&
                   ### ($File: //depot/prod/test/Rsierranevada/lib/IFT/IFTCmd.pm $prefix/) &&
                   ($File::Find::name !~ /snap/));
        }, $path);
    return @dirs;
}


sub _get_filer_dirs {
    my $tid = shift;
    my $path = shift;
    my $prefix = shift;
    my $tree = shift;
    my @dirs = ();
    if (!-d $path) {
          return ( _send_endtest($tid, "FAIL", "_get_filer_dirs: No such directory: $path") );
    }
    if ($tree) {
        find (sub {
        push @dirs, $File::Find::name
              if ((-d $File::Find::name) &&
                   ($File::Find::name !~ /snap/));
              }, $path);
    } else {
        push(@dirs, $path);
        opendir(DIR, $path)
            or return ( _send_endtest($tid, "FAIL", "_get_filer_dirs: No such directory: $path") );
        while ( my $entry = readdir(DIR) ) {
            if (-d "$path//$entry" && $entry ne "." && $entry ne "..") {
		push(@dirs, "$path//$entry");
            }
        }
        closedir(DIR);
    }
    return @dirs;
}


sub _set_user_group {
    my $params = shift;
logcomment("_set_user_group: olduid=$>, oldgid=$),params uid = $params->{uid},$params->{gid}");
    $> = $params->{ori_uid};
    $) = $params->{ori_gid};
#logcomment("_set_user_group: oriuid=$>, origid=$)");
#        $params->{o_uid} = $>;
    $> = $params->{uid};
#        $params->{o_gid} = $);
    $) = $params->{gid};
# logcomment("_set_user_group: new= $>, $)");
    return;
}
sub _reset_user_group {
    my $params = shift;
    $> = $params->{o_uid};
    $) = $params->{o_gid};
    return;
}

# ------------------------------------------------------------------------
1;

