#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/lib/IFT/NfsFuncs.pm#1 $
#
#Copyright (c) 2005 Network Appliance, Inc.
#All rights reserved.
#
## @summary
##     NfsFuncs - perform  directory and file operations.
##
## @description
##
## @usage
##     use FSH::NfsFuncs;
##
## @author dl-johny@netapp.com (FSS WAFL Quality) bundy
## @status publicuse strict;
package NfsFuncs;

use Tharn;
use SPARSE::Util::Logger qw(logError logTrc logStep logWarn);
use IFT::NfsServer;
our $SUSPEND = "suspend";
our $QUIT    = "quit";
our $PAUSE   = "pause ";
our $RESUME  = "resume";
our $MOUNTED = "mounted";
our $DELETED = "deleted";
our $UMOUNT  = "umount";
our $MOUNT   = "mount";
our $RMDIR   = "rmdir";
our $MOUNTS  = "mounts";
our $NOT_OK  = "NK";
our $OK      = "OK";
our $ERROR   = "error";
our $RESULTS = "results";
our $DISABLEMOUNT = "DISABLEMOUNT";
our $ENABLEMOUNT = "ENABLEMOUNT";
our $DELETEMOUNT = "DELETEMOUNT";
our $ADDMOUNT = "ADDMOUNT";
our $ACK = "ACK";
our $NCK = "NCK";
our $DBGCEB  = 0;
our $DBGTMP  = 0;
use Data::Dumper;

# Configure NFS copy job.

sub new( $$$$;$ ) {
    my ( $class, $client, $type );
    $class   = shift;
    $client  = shift;
    $type    = shift;
    $mp_type = shift;
    my $mounts = $client->{mounts};
    my $self   = {};

    foreach my $mp ( keys %{$mounts} ) {
        next if ( $mp_type && $mp_type ne $mounts->{$mp}{type} );
        $self->{mounts}{$mp} = $mounts->{$mp};
    }

    #    $self->{server} = NfsServer->new($client);
    #    $server->rpc_finish();
    $Data::Dumper::Maxdepth   = 2;
    $self->{client}{fullname} = $client->{fullname};
    $self->{client}{hname}    = $client->{hname};
    $self->{client}{hosttype} = $client->{hosttype};
    $self->{filers}           = $client->{filers};
    $self->{quotas}           = $client->{quotas};
    $self->{free_cache_test}  = $client->{free_cache_test};
    bless $self, $class;
#    print "DBGCEB:nfsfuncs:new client = ", Dumper($client) if ($DBGCEB);

    #    getc; #DBGCEB

    #    $self->log_event('nfs funcs', 'new');
    return $self;
}

sub start_ops {
    my $self   = shift;
    my $client = shift;
    $Data::Dumper::Maxdepth = 1;

#    print "DBGCEB:NfsFuncs:start_ops self = ",Dumper($self)," \n that was self\n";
#    getc;
#    print "DBGCEB:NfsFuncs:start_ops self->{client} = ",Dumper($self->{client})," \n that was self->{client}\n";
#    getc;
#    print "DBGCEB:NfsFuncs:start_ops client = ",Dumper($client)," \n that was client\n";
#    getc; #DBGCEB
#    my $subtst = undef;
    print "DBGCEB:NfsFuncs:start_ops\n" if ($DBGCEB);

#    $self->{subtest} =  subtest( "fs/Integrated/nfsfuncs.thpl", '-bg', '-ipc',
#                -runid, "directory_and_file_ops $self->{client}{hname}",
#                -client, $self->{client}{fullname},
#               "--", $self );
#     subtest( \&test_ops, '-bg', '-ipc', '-runid', "directory ops",
#       "--", $self );
#    print "DBGCEB:NfsFuncs:start_ops: start file ops\n";
#    $self->{testname} = "file_ops";
#    print "DBGCEB:start_ops: self = ", Dumper($self),"\nstart_ops: that was self\n";
#    getc;
    if ( $self->{quotas} ) {
        $self->{testname} = "quotas_nfs_directory_and_file_ops";
    }
    elsif ( $self->{free_cache_test} ) {
        $self->{testname} = "free_cache_test_file_ops";
    } else {
        $self->{testname} = "nfs_directory_and_file_ops";
    }
    $self->test_ops();
#    $self->{dfops}{subtest} =
#      subtest( \&test_ops, '-bg', '-ipc', '-runid',
#        "$self->{client}{hname}_$self->{testname}",
#        '-onexit', \&_subtest_exit_handler, "--", $self );

    #      subtest( \&test_ops, '-bg', '-ipc', '-runid', "file ops",
    #       "--", $self );
    return;
}

# Create the source file that will be repeatedly copied during
# reconstruction.
sub subtest_setup ( $ ) {
    my $self = shift;
    $self->{subcount} = 0 if ( !exists $self->{subcount} );
    $self->{subcount}++;
    my $server =
      NfsServer->new( $self->{client}, $self->{subcount}  );
    print "\nDBGCEB:subtest_setup: starting nfs subtest $self->{subcount}\n" if $DBGTMP;

    #    $self->log_event('nfs funcs', 'setup begin');
    $server->setup_rpc_server();

    #    $self->log_event('nfs funcs', 'setup end');
    return $server;
}

#####################################################################
#
#  Subtests
#
####################################################################
sub test_ops {
    my ( $self, %opts ) = @_;
    my $ownname = $self->{testname};
    $self->{parent} = Subtest::ipc();
    print "\nDBGCEB:$ownname has started\n" if ($DBGCEB);
    my $subtestid = 1;

    #    while (1) { sleep 20; }
    my @tests   = directory_and_file_ops_data( $self, %opts );
    my $lastidx = $#tests;

    my $server  = undef;
    my @servers = ();

    # start rpc servers
    my $firstmp = refresh_mounts($self);
    my $mntcnt = (keys %{$self->{mounts}});
    my $servno = ($mntcnt < 5) ? $mntcnt : 5;
    print "DBGCEB: number of servers started $servno\n" if ($DBGCEB);
    for ( 1 .. $servno  ) {    #DBGCEB put this back
        $server = $self->subtest_setup();
        last if ( !$server );
        push @servers, $server;
    }
    die config_result("Unable to start servers") if ( @servers eq () );
    print "DBGCEB:test_ops: rpc servers are started\n" if $DBGTMP;

    #    getc; #DBGCEB
    my $mp      = $firstmp;
    $Data::Dumper::Maxdepth = 1;
    my $ori_uid = $>;
    my $ori_gid = $);
    logcomment("ORIGINAL UID = $ori_uid, gid = $ori_gid") if ($DBGCEB);
    while (1) {
        $mp = $self->{mounts}{$mp}{nxt};
        next if ($self->{mounts}{$mp}{status} eq $DISABLEMOUNT);
        $self->{params}{path} = $mp;
        my $mpobj = $self->{mounts}{$mp};
        print "\n\nDBGCEB:$ownname mp = $mp\n\n", Dumper($mpobj) if ($DBGCEB);
        logcomment("mount point info: $mpobj->{max_files}, ".
                   "$mpobj->{max_size}, $mpobj->{uid}, $mpobj->{gid}") 
            if ($mpobj->{mp_type} =~ /qtree/);
        # if there is no test running for this mp, grab a server and start one
        if ( ( !$mpobj->{subtest} ) || ( !exists $mpobj->{subtest} ) ) {
#            print "DBGCEB:$ownname: do we have a server?\n" if ($DBGCEB);
            $server = pop @servers;

#            print "DBGCEB:$ownname: No we don't!\n"
#              if ( ( !$server ) && ($DBGCEB) );
            next if ( !$server );

            if (!$server->{SUBTEST}->is_alive()) {
                 $server = $self->subtest_setup();
            }


 #           print "DBGCEB:$ownname: yes we do!  starting tests on $mp\n"
 #             if ($DBGCEB);
            $mpobj->{subtest} = $server;
            $mpobj->{test}{idx} = 0;
        } else {

            # if there is a test running check if it's done
            $server = $mpobj->{subtest};
#            print "\n\nDBGCEB:$ownname: checking subtest for $mp\n"
#              if ($DBGCEB);
#            print "DBGCEB:$ownname: subtest name = "
#              . "$mpobj->{subtest}{SUBTEST}{runid}\n"
#              if ($DBGCEB);
#            print
#              "DBGCEB:$ownname: subtest name $tests[$mpobj->{test}{idx}]\n\n"
#              if ($DBGCEB);
            my ( $msg, $var ) = _check_result( $self, $mpobj );
            logcomment("after check_result: $mpobj->{mp_type}, $msg")
               if $DBGCEB;
 #           $self->_process_quota_limits( $var, $mp ) if $var;
            if ( $msg ne "END" ) {
                next;  #DBGCEB take this out if you put the endtime check back

#                if ( time() >= $mpobj->{endtime} ) {
#                    my $logmsg =
#                      "subtest $mp:$test[$mpobj->{test}{idx}] ran "
#                      . "over 10 minutes - stopping subtest";
#                    _logcomment($logmsg);
#                    $self->restart_server($mpobj);
#                    next if ( !$mpobj->{subtest} );
#                } else {
#                    next;
#                }
            }
            print "DBGCEB:test_ops:$tests[$mpobj->{test}{idx}] "
              . "on $mp ended\n"  if ($DBGCEB);
            $mpobj->{test}{idx} += 1;

            # if it's cycled through all the test, let another mp have a shot
            if ( $mpobj->{test}{idx} > $lastidx ) {
                print "\n\nDBGCEB: giving up the server for the greater good"
                  . " runid = $server->{SUBTEST}{runid}\n" if $DBGTMP;
                $mpobj->{subtest} = "";
                push @servers, $server;
                next;
            }
        }

        # start a new test
        $> = $ori_uid;
        $) = $ori_gid;
        my $idx  = $mpobj->{test}{idx};
        my $test = $tests[$idx];
        $mpobj->{test}{name} = $test;
        print "DBGCEB:$ownname calling $tests[$idx] for $mp\n" if ($DBGCEB);
        $self->{params}{test} = $test;
        if (!$server->{SUBTEST}->is_alive()) {
             $mpobj->{subtest} = $self->subtest_setup();
        }
        $mpobj->{params} = $self->{params};
        if ($self->{quotas}) {
logcomment("QUOTAS: $mpobj->{uid}, $mpobj->{gid},$mpobj->{mp_type},$mpobj->{max_files}, $mpobj->{max_size}");
             $mpobj->{params}{uid} = $mpobj->{uid};
             $mpobj->{params}{gid} = $mpobj->{gid};
             $mpobj->{params}{ori_uid} = $ori_uid;
             $mpobj->{params}{ori_gid} = $ori_gid; 
        }
        my $tid = "$mpobj->{subtest}{tid}:$subtestid";
        $subtestid++;
        $self->{params}{tid} = $tid;
        $mpobj->{subtest}->_call_subtest( $test,$mpobj->{params} );
        $mpobj->{endtime} = time() + 600;

        my ( $msg, $var ) = _check_result( $self, $mpobj );


#        if ( ( !$self->{quotas} ) && ( $mp eq $firstmp ) ) {
#            $mp = "";
#            my $retries = 5;
#            while ( !$mp ) {
#                $firstmp = refresh_mounts($self) if ( !$self->{quotas} );
#                $mp = $firstmp;
#                $retries--;
#                if ( !$retries ) {
#                    logresult( "FATAL",
#                        "$self->{hname}: no mountpoints exist" );
#                }
#            }
#        }

    }
}

sub _check_mounts {
    my $self = shift;
    my $mp   = shift;

    #    logcomment("In _check_mounts");

    my @output = `mount`;
    my @mounts = ();
    my $gotit  = 0;

    foreach $line (@output) {
        push @mounts, ( $line =~ /(\/t\/[\d\.]*\/test[\w]*)/ );
    }

    if ($mp) {
        foreach my $mnt (@mounts) {
            if ( $mnt eq $mp ) {
                $gotit = 1;
                print "DBGCEB:_check_mounts $mnt matches mp $mp\n" if ($DBGCEB);
                last;
            }
        }
        return 1                                           if ($gotit);
        print "DBGCEB:_check_mounts: no match to mp $mp\n" if ($DBGCEB);
        return 0;
    }

    my $mnthash = {};
    foreach my $mnt (@mounts) {
        foreach my $f ( keys %{ $self->{filers} } ) {
            my $ipaddr = $self->{filers}{$f}{ipaddr};
            if ( $mnt =~ /$ipaddr/ ) {
                print "DBGCEB:_check_mounts: $msg matched $ipaddr\n"
                  if ($DBGCEB);
                $mnthash->{$mnt} = 1;
                last;
            }
        }
        if ( !exists $mnthash->{$mnt} ) {
            print "DBGCEB:_check_mounts: no filer match for $mnt\n"
              if ($DBGCEB);
        }
    }

    $Data::Dumper::Maxdepth = 1;

    foreach my $mnt ( keys %{ $self->{mounts} } ) {
        print
"DBGCEB:_check_mounts: saved mounts -> $mnt  current mounts $mnthash->{$mnt}\n"
          if ($DBGCEB);
        next if !$mnt;
        if ( !exists $mnthash->{$mnt} ) {
            delete $self->{mounts}{$mnt};
            $self->_logcomment("$mnt has been removed");
        } else {
            delete $mnthash->{$mnt};
        }
    }
    my ( $ip, $vol );
    foreach my $mnt ( keys %{$mnthash} ) {
        print
"DBGCEB:_check_mounts: current mounts -> $mnt  saved mounts $self->{mounts}{$mnt}\n"
          if ($DBGCEB);
        if ( !exists $self->{mounts}{$mnt} ) {
            $self->_logcomment("$mnt is a new mountpoint");
            ( undef, undef, $ip, $vol ) = split /\//, $mnt;
            foreach $f ( keys %{ $self->{filers} } ) {
                if ( $self->{filers}{$f}{ipaddr} eq $ip ) {
                    $self->{mounts}{$mnt}{ $self->{filers}{$f}{fname} } =
                      $self->{filers}{$f};
                }
            }
            $self->{mounts}{$mnt}{path} = "/vol/$vol";
            $self->{mounts}{$mnt}{vol}  = $vol;
        } else {
            print "DBGCEB:_check_mounts: we already got this one $mnt\n"
              if ($DBGCEB);
        }
    }
}

sub restart_server {
    my $self   = shift;
    my $mpobj  = shift;
    my $server = $mpobj->{subtest};
    $server->kill_subtest();
    my $serverid = $server->{SUBTEST}{runid};

    #    $server =  $self->subtest_setup();
    #    logWarn("Cannot restart subtest $serverid") if (!$server);
    $mpobj->{subtest} = undef;
    print
      "DBGCEB: stopped server $serverid new id is $server->{SUBTEST}{runid}\n"
      if ($DBGCEB);
    return;
}

sub _process_quota_limits_old {
    my $self = shift;
    my $var  = shift;
    my $mp   = shift;

    my ($file_size)  = ( $var =~ /FILE_SIZE\=(\d*)/ );
    my ($file_count) = ( $var =~ /FILE_COUNT\=(\-?\d*)/ );
    my $qtree = $self->{mounts}{$mp};
    $qtree->{size_used}  += int($file_size);
    $qtree->{files_used} += int($file_count);
    return;
}

sub _process_quota_limits {
#    my $self = shift;
    my $mp  = shift;  #self->{mounts}{$mp}
    my $tinfo   = shift; #msg
    logcomment("at _process_quota_limits: $mp->{mp_type}");
    if ($mp->{mp_type} !~ /qtree/i) {
      logcomment("not a qtree mount point, return");
      return; 
    }
    my $qhash = Client::quota_info_for_mp($mp);
    logcomment("after get quota_info_for_mp: $qhash->{curr_files},$qhash->{max_files},$qhash->{max_size},$qhash->{curr_size}");
    if ((!exists $tinfo->{write_size}) && (!exists $tinfo->{file_count})) {
      # we errored out, we may have or have not created files and written
      # to files, but it's too complicated to figure out what was written
      # successfully and what wasn't
      #get quota report and update $mpobj with current info;
      #
         logcomment("no write size: $tinfo->{write_size} && no file count:$tinfo->{file_count}");
         if ( $tinfo->{text} =~ /exceed/i) {
            logcomment("NOTICE: fail but message is excceed");
            
            if (($qhash->{max_files} ne "-" 
                 && $qhash->{curr_files} >= $qhash->{max_files}) ||
                $qhash->{curr_size} >= $qhash->{max_size}) {
                $tinfo->{result} = "PASS";
            logcomment("NOTICE: fail but message says exceed quota limit");
            }
         }
         $mp->{curr_size} = $qhash->{curr_size};
         $mp->{max_size} = $qhash->{max_size};
         $mp->{curr_files} = $qhash->{curr_files};
         $mp->{max_files} = $qhash->{max_files};

         return;
    }
    my $write_size  = $tinfo->{write_size};
    my $file_count = $tinfo->{file_count};
    my $result = $tinfo->{result};
    if ($write_size) {
      logcomment("_process_quota_limit: write size = $write_size");
      my $new_size = $write_size+$mp->{curr_size};
      if ($result eq "PASS") {
        if ($qhash->{curr_size} > $qhash->{max_size}) {
             logcomment("NOTICE: passed but curr>max: $qhash->{curr_size}, $qhash->{max_size}");
             $tinfo->{result} = "FAIL";
             $tinfo->{text} = "quota(size) exceed at $mp->{filer_info} ".
                 "$mp->{mount_dir}, max_size: $qhash->{max_size}, but ".
                 "current size : $qhash->{curr_size}";
        }
        elsif ($new_size > $qhash->{max_size}) {
             logcomment("NOTICE: passed but new>max: $new_size,  $qhash->{max_size}");
             $tinfo->{result} = "FAIL";
             $tinfo->{text} = "writed size exceed quota size limit at ".
                "$mp->{filer_info}, $mp->{mount_dir}, max_size=".
                "$qhash->{max_size}, previous size=$mp->{curr_size},".
                "writed size=$write_size";
        }
#        elsif ( ($qhash->{curr_size}) && ($qhash->{curr_size} - $new_size)/$qhash->{curr_size} > 0.2) {
#             logcomment("NOTICE: passed but new/curr: $new_size,  $qhash->{curr_size}");
#             $tinfo->{result} = "FAIL";
#             $tinfo->{text} = "writed size and the real size has more ".
#                "than 20% difference: writed size=$new_size,".
#                " current size: $qhash->{curr_size}";
#         }
      }
      else # $result eq "FAIL"
      {
        logcomment("NOTICE: message return failed:$tinfo->{text} ");
        if ($new_size >= $qhash->{max_size} ) {
            logcomment("NOTICE: message return failed, new>max:$new_size, $qhash->{max_size} ");
            $tinfo->{result} = "PASS";
        }
        elsif ($qhash->{curr_size} >= $qhash->{max_size}) {
            logcomment("NOTICE: message return failed, curr>max:$qhash->{curr_size}, $qhash->{max_size} ");
            $tinfo->{result} = "PASS";
        }
      }
    }

    if ($file_count) {
      logcomment("_process_quota_limit: got file_count $file_count ");
      my $new_count = $file_count+$mp->{curr_files};
      if ($result eq "PASS") {
        if (($qhash->{max_files} ne "-") && 
            ($qhash->{curr_files} > $qhash->{max_files})) {
             logcomment("NOTICE: passed but cur>max: $qhash->{curr_files} > $qhash->{max_files} ");
             $tinfo->{result} = "FAIL";
             $tinfo->{text} = "quota(files) exceed at $mp->{filer_info} ".
                 "$mp->{mount_dir}, max_files: $qhash->{max_files}, but ".
                 "current files count : $qhash->{curr_files}";
        }
        elsif (($qhash->{max_files} ne "-") && 
               ($new_count > $qhash->{max_files})) {
             logcomment("NOTICE: passed but new>max: $new_count > $qhash->{max_files} ");
             $tinfo->{result} = "FAIL";
             $tinfo->{text} = "writed file count exceed quota limit at ".
                "$mp->{filer_info}, $mp->{mount_dir}, max_files=".
                "$qhash->{max_files}, previous files=$mp->{curr_files},".
                "writed file count=$file_count";
        }
#        elsif ($new_count != $qhash->{curr_files}) {
#             logcomment("NOTICE: passed but new!= curr: $new_count != $qhash->{curr_files} ");
#             $tinfo->{result} = "FAIL";
#             $tinfo->{text} = "writed file count is not the same as the ".
#                "real file count: writed count=$new_count,".
#                " current file count: $qhash->{curr_files}";
#        }
     }
     else {  # fail
        logcomment("NOTICE: message says failed: $tinfo->{text}");
        if ($qhash->{max_files} ne "-" && $new_count >= $qhash->{max_files} ) {
            logcomment("NOTICE: message says failed, new>max: $new_count >= $qhash->{max_files}");
            $tinfo->{result} = "PASS";
        }
        elsif ($qhash->{max_files} ne "-" && $qhash->{curr_size} >= $qhash->{max_size}) {
           logcomment("NOTICE: message says failed, cur>max: $qhash->{curr_size}>= $qhash->{max_files}");
            $tinfo->{result} = "PASS";
        }
     }
   }

   $mp->{curr_size} = $qhash->{curr_size};
   $mp->{max_size} = $qhash->{max_size};
   $mp->{curr_files} = $qhash->{curr_files};
   $mp->{max_files} = $qhash->{max_files};
   return;
}
sub directory_and_file_ops_data {
    my $self = shift;
    my %opts = @_;
    $self->{params}{width}      = $opts{dir_width}  ? $opts{dir_width}  : 5;
    $self->{params}{depth}      = $opts{dir_depth}  ? $opts{dir_depth}  : 3;
    $self->{params}{dircount}   = $opts{dir_count}  ? $opts{dir_count}  : 2;
    $self->{params}{rdcount}    = $opts{rdcount}    ? $opts{rdcount}    : 50;
    $self->{params}{iterations} = $opts{iterations} ? $opts{iterations} : 5;
    $self->{params}{filecount}  = $opts{file_count} ? $opts{file_count} : 2;
    $self->{params}{client}      = $self->{client}{hname};
    $self->{params}{fsize}       = $opts{file_size} ? $opts{file_size} : 1024;
    $self->{params}{file_prefix} =
      $opts{file_prefix} ? $opts{file_prefix} : "tfile";
    $self->{params}{dir_prefix} =
      $opts{dir_prefix} ? $opts{dir_prefix} : "testdir";
    $self->{params}{tree}   = 1;
    $self->{params}{quotas} = $self->{quotas};
    $self->{params}{free_cache_test} = $self->{free_cache_test};

    my @tests = ();
    if ( $self->{quotas} || $self->{free_cache_test} ) {
        @tests = ( "my_write_files", "my_delete_files" );
    } else {
        @tests = (
            "my_delete_directory_tree", "my_create_directory_tree",
            "my_write_files",           "my_readdir",
            "my_copydir",               "my_truncate_files",
            "my_delete_files",
            "my_file_attributes",
        );
    }
    return @tests;
}

sub refresh_mounts {
    my $self = shift;
    logcomment("In refresh_mounts");
#    $self->_check_mounts();
    return ( $self->_llmounts() );
}

sub _llmounts {
    my $self = shift;

    #    logcomment("In _llmounts");
    # make mountpoint into a linked list
    my @mps   = ( keys %{ $self->{mounts} } );
    print "DBGCEB:NfsFuncs:mountpoints for $self->{hname}\n" if $DBGTMP;
    foreach $mp (@mps) {
       print "   $mp\n";
    }
    my $lstmp = $#mps;
    my $idx   = 0;
    while ( $idx < $lstmp ) {
#    while ( $idx < 4 ) {
        if ( $idx == 0 ) {
            $self->{mounts}{ $mps[$idx] }{prv} = $mps[$lstmp];
        } else {
            $self->{mounts}{ $mps[$idx] }{prv} = $mps[ $idx - 1 ];
        }
        $self->{mounts}{ $mps[$idx] }{nxt} = $mps[ $idx + 1 ];
        $self->{mounts}{ $mps[$idx] }{mp}  = $mps[$idx];
        $idx++;
    }
    $self->{mounts}{ $mps[$idx] }{nxt} = $mps[0];
    $self->{mounts}{ $mps[$idx] }{prv} = $mps[ $idx - 1 ];
    $self->{mounts}{ $mps[$idx] }{mp} = $mps[$idx];
    if ($DBGCEB) {
        print "DBGCEB:_llmounts:self mounts = ", Dumper( $self->{mounts} )
          if ($DBGCEB);
        print "DBGCEB:_llmounts:that was self mounts\n" if ($DBGCEB);

        #    getc;
    }
    my $firstmp = $mps[0];
    return $firstmp;
}

#sub get_current_mounts {
#    my $self = shift;
#    my @bnames = ();
#    my @alldirs = ();
#    my $dh = {};
#    foreach my $filer (keys %{$self->{filers}}) {
#        my $basename = "/t/".$self->{filers}{$filer}{ipaddr};
#        $self->_logcomment("$self->{hname}: getting mounts from $basename");
#        if (! -e $basename) {
#            $self->{error} =
#                ("get_current_mounts:$self->{hname}:$basename does not exist");
#            return 0;
#        }
#        opendir(DIR, $basename);
#        if (!DIR) {
#            $self->{error} =
#                ("get_current_mounts:$self->{hname}: cannot open $basename");
#            return 0;
#        }
#        my @dirs = readdir(DIR);
#        closedir DIR;
#        foreach my $dir (@dirs) {
#          next if ($dir !~ /test/);
#          $dh->{$dir} = {};
#        }
#     }
#     $self->_logcomment("DBGCEB:get_current_mounts:$self->{hname}:mounts = ".
#                 Dumper($dh)) if ($DBGCEB);
#     return $dh;

#}

sub _check_result {
    my $self   = shift;
    my $mpobj  = shift;
    my @msgs   = ();
    my $result = undef;
    my $server = $mpobj->{subtest};
    my $parent = $self->{parent};
    $server->_check_client();

#    logcomment("_check_result:$server->{SUBTEST}{runid}:$mpobj->{test}{name}");
    my $results = $server->{result};
    return if ( !$results );
    my $logmsg = undef;
    my $var    = undef;

    foreach my $msg (@$results) {
        next if ( $msg eq "" );
        next if (!defined $msg);
        print "DBGCEB:_check_result msg = ",Dumper($msg) if $DBGTMP;
#        getc;

#        if ($msg =~ /ENDTEST/) {   #DBGCEB working around NATE problems
        if ( $msg->{endtest} eq "ENDTEST" ) {
            $result = "END";
        }
#       _logcomment($msg);
#       next;
        my $msgheader =
          "ID=$msg->{id} TESTNAME=$msg->{testname} " . "MSGNO=$msg->{msg} ";
        if ( $msg->{type} eq "START" ) {
          $logmsg = sprintf "%s:START CLIENT=%s STARTTIME=%s MOUNTPOINT=%s %s",
              $msgheader, $msg->{client}, $msg->{starttime}, $msg->{mp},
              $msg->{text};
logcomment("START: $msg->{mp}, $mpobj->{uid}, $mpobj->{mp_type}");
        } elsif ( $msg->{endtest} eq "ENDTEST" ) {
            $result = "END";
logcomment("GOT ENDTEST, QUOTAS: $self->{quotas}");
logcomment("before _process_quota_limits: $mpobj->{uid}, $mpobj->{mp_type}");
#            $msg = $self->_process_quota_limits($mpobj,$msg) if ($self->{qutas});
logcomment("before _process_quota_limits:$msg->{write_size}, $msg->{file_count}");
            $msg = _process_quota_limits($mpobj,$msg) if ($self->{quotas});

            $logmsg = sprintf "%s:ENDTEST RESULT=%s ENDTIME=%s DURATION=%s %s",
              $msgheader, $msg->{result}, $msg->{endtime}, $msg->{duration},
              $msg->{text};
#            if ( $msg->{result} eq "WARN" ) {
#                my $robj =
#                  warn_result(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#                logresult($robj);
#            } elsif ( $msg->{result} eq "CONFIG" ) {
#                my $robj =
#                  config_result(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#                logresult($robj);
#            } elsif ( $msg->{result} eq "FAIL" ) {
#                my $robj =
#                  logcomment(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#                logresult($robj);
#            } elsif ( $msg->{result} eq "FATAL" ) {
#                $self->_logcomment($logmsg);
#                die fatal_result(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#            } elsif ( $msg->{result} eq "PASS" ) {
#                my $robj =
#                  pass_result(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#            } elsif ( $msg->{result} eq "NA" ) {
#                my $robj =
#                  na_result(
#                    "$msg->{testname} $msg->{client} " . "$msg->{text}" );
#            }

        } else {
              $logmsg = sprintf "%s:%s:%s",
              $msgheader, $msg->{type}, $msg->{text};
 logcomment("check result got other message:  $logmsg");
        }


        if ($logmsg) {
           $self->_logcomment($logmsg);
           push @msgs, $logmsg;
        }
    }
    $server->{results} = ();

    logcomment("sending results to parent... ");
    _send_parent($self,$RESULTS,@msgs) if (@msgs ne ());
    @msgs = ();
    return $result, $var;
}

sub _send_parent {
    my $self    = shift;
    my $type     = shift;
    my $msgs     = shift;
    my $sock = $self->{parent};
    my $retries = 3;
    return;

    #    return if (!_can_write($sock,$msg));
    foreach my $msg (@msgs) {
    print "DBGCEB:test_ops:_send_parent:$msg\n" if ($DBGCEB);
      eval {
            $sock->write_message($msg);
            };
      if ($@) {
          logWarn("NfsFuncs:_send_parent: unable to write message $msg");
          return;
      }

        sleep(1);
    }
#    return if ( !_getack( $sock, $msg ) );
#    return if ( !$obj );

    #    return if (!_can_write($sock,$msg));
#    $sock->write_obj($obj);
#    _getack( $sock, $msg );
    return;
}

sub _read_parent {
    my $self = shift;
    my $sock = $self->{parent};
    my $msg = undef;

    while ($sock->can_read()) {
       my $msg = $sock->read_message();
       next if (!$msg);
       next if ($msg eq "");
       if (_process_message($self,$msg)) {
           _send_ack($sock,"ACK");
       } else {
           _send_ack($sock,"NCK");
       }
    }
}

sub _process_message {
    my $self = shift;
    my $msg = shift;
    _logcomment("$self->{hname} received unknown msg from parent: $msg");
    if ($msg =~ /$ADDMOUNT\=(.*)\;EMSG/) {
        my $mp = $1;
        print "DBGCEB:_client_subtest:_process_message:ADDMOUNT $mp\n" if $DBGTMP;
        $self->{mounts}{$mp} = {} if (!exists $self->{mounts}{$mp});
        return $ADDMOUNT;
    } elsif ($msg =~ /$DELETEMOUNT\=(.*)\;EMSG/) {
        my $mp = $1;
        print "DBGCEB:_client_subtest:_process_message:DELETEMOUNT $mp\n" if $DBGTMP;
        # if a test is current running on this mp, wait for it to finish
        if ((exists $self->{mounts}{$mp}{subtest}) &&
            ($self->{mounts}{$mp}{subtest})) {
               my $result = undef;
               while ($result ne "END") {
                 _check_result($self, $self->{mounts}{$mp});
               }
        }
        # remove mp from linked list
        $self->{mounts}{$self->{mounts}{$mp}{nxt}}{prv} =
               $self->{mounts}{$mp}{prv};
        $self->{mounts}{$self->{mounts}{$mp}{prv}}{nxt} =
               $self->{mounts}{$mp}{nxt};
        delete $self->{mounts}{$mp};
    } elsif ($msg =~ /$DISABLEMOUNT\=(.*)\;EMSG/) {
        my $mp = $1;
        print "DBGCEB:_client_subtest:_process_message:DISABLEMOUNT $mp\n" if $DBGTMP;
        $self->{mounts}{$mp}{status} = $DISABLEMOUNT;
    } elsif ($msg =~ /$ENABLEMOUNT\=(.*)\;EMSG/) {
        my $mp = $1;
        print "DBGCEB:_client_subtest:_process_message:ENMOUNT $mp\n" if $DBGTMP;
        $self->{mounts}{$mp}{status} = $ENABLEMOUNT;
    } elsif ($msg =~ /$PAUSE/) {
        print "DBGCEB:_client_subtest:_process_message:ADDMOUNT $mp\n" if $DBGTMP;
         $self->{teststatus} = $PAUSE;
    } elsif ($msg =~ /$RESUME/) {
        print "DBGCEB:_client_subtest:_process_message:ADDMOUNT $mp\n" if $DBGTMP;
         $self->{teststatus} = $RESUME;
    } elsif ($msg =~ /$QUIT/) {
        print "DBGCEB:_client_subtest:_process_message:ADDMOUNT $mp\n" if $DBGTMP;
         $self->{teststatus} = $QUIT;
    } else {
      _logcomment("$self->{hname} received unknown msg from parent: $msg");
      return;
    }
    return;
}

sub _getack {
    my $sock    = shift;
    my $msg     = shift;
    my $retries = 3;
    my $result  = 0;
    for ( 1 .. $retries ) {
        sleep 2;
        next if ( !$sock->can_read() );
        my $message = $sock->read_message();
        if ( $message !~ /$msg OK/ ) {
            print "DBGCEB: message from parent (not ack) $message\n"
              if ($DBGCEB);
            $self->{lastmsgfromparent} = $message;
            last;
        }
        return 1;
    }
    logWarn(
        "NfsFunc:_getack: sending $msg or object: no ack from " . "parent" )
      if ( !$result );

    return $result;
}

sub _change_mounts {
    my $self   = shift;
    my $parent = $self->{parent};

    #    _stop_subtests( $self, $self->{mounts} );
    my $mounts = $parent->read_obj();
    $parent->write_message("OK");
    my $changed = 0;
    foreach my $mnt ( keys %{$mounts} ) {
        if (   ( $mounts->{$mnt}{status} eq $DELETED )
            && ( exists $self->{mounts}{$mnt}{subtest} ) )
        {
            $self->{mounts}{$mnt}{subtest}->kill();
            delete $self->{mounts}{$mnt};
            $changed = 1;
        } elsif ( !exists $self->{mounts}{$mnt} ) {
            $self->$self->{mounts}{$mnt} = $mounts->{$mnt};
            $changed = 1;
        }
    }
    return $changed;
}


sub _send_subtests {
    my $self   = shift;
    my $parent = $self->{parent};

    my $msg = shift;
    foreach $key ( keys %{ $self->{mounts} } ) {
        my $server = $self->{mounts}{$key}{subtest};
        $server->{SUBTEST}->ipc()->write_message($msg);
        my $rsp = $server->{SUBTEST}->ipc()->read_message();
        if ( $rsp !~ /$msg\sOK/ ) {
            my $err = sprintf "WARN:%s:subtest on %s not responding to $msg",
              $self->{subname}, $key, $msg;
            printf "DBGCEB: $err\n" if ($DBGCEB);
            push @{ $self->{errors} }, $err;
            $parent->write_message($RESULT);
            my $message = $parent->read_message();
            $parent->write_obj( $self->{errors} );

        }
    }
    return;
}

sub _stop_subtests {
    my $self       = shift;
    my $subtstests = shift;
    foreach my $key ( keys %{ $self->{mounts} } ) {
        my $subtst = $self->{mounts}{$key}{subtest};
        $subtst->rpc_finish();
    }
    return;
}

sub _logcomment {
    my $self = shift;
    my $msg  = shift;
    print "DBGCEB:In _logcomment $self->{client}{hname}\n" if ($DBGCEB);
    logcomment($msg);
    my $logdir = "/u/bundy/logs/$self->{client}{hname}/";
    mkdir $logdir if ( !-e $logdir );

    #    if ($!) {
    #        logcomment("cannot create dir $logdir");
    #        return;
    #    }
    my $logfile = undef;
    if ( !$self->{logfile} ) {
        $logfile = $logdir . $self->{client}{hname} . time();
        $self->{logfile} = $logfile;
    } else {
        $logfile = $self->{logfile};
    }
    open LOGFILE, ">>$logfile";
    if ( !LOGFILE ) {
        logcomment("cannot open $logfile");
        return;
    }
    print LOGFILE "$msg\n";
    close LOGFILE;
    return;
}

# Wait for all background copy tasks to complete.
sub finish( $ ) {
    my ($self) = @_;
    foreach my $server ( @{ $self->{server} } ) {
        my $server = $self->{server};
        $server->rpc_finish();
    }
}

sub log_event( $ ) {
    my ( $self, $event, $message ) = @_;
    $self->_logcomment("NfsFuncs: $event : $message");

}

sub _subtest_exit_handler {
    my $subtest = shift;
    my @results = $subtest->rslts();

    foreach my $result (@results) {
        if ( ref($result) =~ /Fatal/ ) {
            my $message = sprintf($result);
            logresult( "FAIL", $message, abort => 1 );
        } else {
            logresult($result);
        }
    }
}

1;
