#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/lib/IOMgr/IO.pm#1 $ 
#$DateTime: 

## @summary Base class for IO objects
## @author lippe@netapp.com
## @status private
## @pod here


# Package Name
##############
package IOMgr::IO;

use strict;
use Error;
use vars qw(@ISA);

@ISA = qw(Error);

################################################################################
# Subroutine Name: destroy
# Objective:       destroy a dt object
# Details:         See POD documentation at the end of this file
################################################################################
sub destroy {
    my ($self) = @_;
    my ($fail_cnt,
	$name,
        @IO);

    $name = $self->get_name();

    $fail_cnt = 0;

    # Remove the dt ref from the parent vol object
    foreach my $IOObj (@{$self->{iomgr}{io}{$self->{path}}}) { 
        if ($IOObj->get_name() =~ /^$name$/) {
	    $self->_stop();
	    $fail_cnt++ if ($self->error);

	    $self->_clean();
	    $fail_cnt++ if ($self->error);
	} else {
	    push @IO, $IOObj;
        }
    }
    
    $self->{iomgr}{io}{$self->{path}} = \@IO;

    return ($fail_cnt eq 0) ? $ClientUtil::TRUE : $ClientUtil::FALSE;
}

################################################################################
# Subroutine Name: stop (OVERRIDE)
# Objective:       stop routine overriden by IO objects
# Details:         See POD documentation at the end of this file
################################################################################
sub stop {
    my ($self) = @_;

    eval { 
	$self->_stop(); 
    };

    if ($@) {
	$self->_set_err("Error: IO::stop() Method not implemented");
	return $ClientUtil::FALSE;
    }

    return $ClientUtil::TRUE;
}

################################################################################
# Subroutine Name: _clean (OVERRIDE)
# Objective:       cleanup routine overriden by IO objects
# Details:         See POD documentation at the end of this file
################################################################################
sub _clean {
    my ($self) = @_;

    $self->_set_err("Error: IO::clean() Method not implemented");
    return $ClientUtil::FALSE;
}

1;

