#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/ontap/main/test/lib/Packet_tracer.pm#4 $
#
# Copyright (c) 2011 Network Appliance, Inc.
# All rights reserved.
#

package Load_gen;

use strict;
use TCD;
use Connectrec;
use NACL::APISet;
use NACL::C::Client;
use NACL::MTask::NASTraffic;
use NACL::STask::Volume;


use Params::Validate qw(validate OBJECT SCALAR UNDEF ARRAYREF);
use Exporter qw(import);
use vars qw( @ISA );
use Carp qw(croak);

our @EXPORT_OK = qw(&start_nfs_load
                    &stop_nfs_load);
					
our @traffic_list = qw();
					
sub	start_nfs_load	{

    my (%opts) = @_;
	
	my $Node = $opts{'command_interface'};

	my @vms = split(',',$opts{clients});
	
	my $ADDRESS = $opts{'Mount_ip'};
	
	my $VSERVER = $opts{'vserver'};
	
	my $LIF     = $opts{'lif'};
	
	my $Api_Set_Obj = $opts{'Api_Set_Obj'};;
	
	my $load_chk = $opts{'load_check'};
	
	my $cnt=0;
	
	my @traffic;
	
	my $procs = 1;
	
	my %cmd;
	
	my $sysstat_cmd;
	
	foreach my $client (@vms)	{

		print("\n=================================================");
		print("\nRunning the Load on the Client : $client");
		print("\n=================================================");
		
		if($VSERVER)	{
	
			%cmd = ('command_interface' => $Node, 'volume' => "VOL_".$client, 'server' => $ADDRESS, 'vserver' => $VSERVER, 'home-node' => $Node->node(), lif => $LIF, 'junction-path' => "VOL_".$client,);
		
			$sysstat_cmd = "run local sysstat -c 1 -x";
	
		} else	{
		
			%cmd = ('command_interface' => $Node, 'volume' => "VOL_".$client, 'server' => $ADDRESS,);
		
			$sysstat_cmd = "sysstat -c 1 -x";
	
		}

                # Check if windows client and skip

                my $host = NACL::C::Client->new(name => $client); # to be removed
                my $host_type = $host->type(); # to be removed

		if($host_type !~ /windows/)	{ # to be removed after windows io is added	
		$traffic[$cnt] = NACL::MTask::NASTraffic->start(
						    'node_info' => {
							
							    %cmd,
								
        					},
		
        'host_info' => [
            {
                command_interface => NACL::C::Client->new(name => $client),

		tool              => 'dt',

		'tool_options'    => {
	
	        'of' => 'Sample.txt', 'limit' => '500m', 'procs' => $procs, 'errors' => '1', 'min' =>  '4k', 'max' =>  '512k', 'runtime' =>  '4320m', 'iotype' => 'random', 'logt' => 'log1', 'oncerr' =>  'abort', 'enable' => 'noprog', 'noprogt' => '15s', 'noprogtt' => '120s',

        }

            }
        ],
		
        nacltask_traffic_type => 'nfs',
        nacltask_traffic_direction => 'read',

	);

	} 

	$cnt++;
		
	}
	
	#################################################################

	my $disk_util=0;

	$cnt = 0;

	do	{

	my $disk_util_avg=0;

		foreach (1..5)	{	

			my $output = $Api_Set_Obj->execute_raw_command(command => "$sysstat_cmd");

	       		my @output = split(/\n/, $output);
		
		    foreach my $line (@output) {

			$line =~ s/^\s+//;

			if ($line !~ /^\d+\%/) {

			    next;

		    } else {
			
			   	my @parts = split(/\s+/, $line);

			    $disk_util = $parts[15];

			    $disk_util =~ s/\%//g;
		
				$disk_util_avg = $disk_util_avg + $disk_util;
		
        	}

		}

			sleep(60);

		}

	$disk_util = ($disk_util_avg / 5);

	print("\n=================================================");
	print("\n$disk_util");
	print("\n=================================================");

	if($disk_util < $load_chk)	{

		if($cnt == 0) {

			$procs++;

		}
		
	print("\n=================================================");
	print("\nRunning the Load  on the Client : $vms[$cnt]");
	print("\nRunning the dt procs on the Client : $procs");
	print("\n=================================================");

	if($traffic[$cnt])	{

	$traffic[$cnt]->stop_only_traffic();

	$traffic[$cnt]->stop();

	} # to be removed after windows suppourt is added
	
			if($VSERVER)	{
	
			%cmd = ('command_interface' => $Node, 'volume' => "VOL_".$vms[$cnt], 'server' => $ADDRESS, 'vserver' => $VSERVER, 'home-node' => $Node->node(), lif => $LIF, 'junction-path' => "VOL_".$vms[$cnt],);
		
			$sysstat_cmd = "run local sysstat -c 1 -x";
	
		} else	{
		
			%cmd = ('command_interface' => $Node, 'volume' => "VOL_".$vms[$cnt], 'server' => $ADDRESS,);
		
			$sysstat_cmd = "sysstat -c 1 -x";
	
		}

		my $host = NACL::C::Client->new(name => $vms[$cnt]); # to be removed
                my $host_type = $host->type(); # to be removed


                if($host_type !~ /windows/)     { # to be removed after windows io is added

	$traffic[$cnt] = NACL::MTask::NASTraffic->start(
                        'node_info' => {
     
							%cmd,
                        
						},

	        'host_info' => [
        	    {
	                command_interface => NACL::C::Client->new(name => $vms[$cnt]),,

                	tool              => 'dt',

        	        'tool_options'    => {
					
	                       'of' => 'Sample.txt', 'limit' => '500m', 'procs' => $procs, 'errors' => '1', 'min' =>  '4k', 'max' =>  '512k', 'runtime' =>  '4320m', 'iotype' => 'random', 'logt' => 'log1', 'oncerr' =>  'abort', 'enable' => 'noprog', 'noprogt' => '15s', 'noprogtt' => '120s',

                	}

        	    }
	        ],

        	nacltask_traffic_type => 'nfs',

	        nacltask_traffic_direction => 'read',

        		);

		}

	        	sleep(60);

        		$cnt++;

			if($cnt > $#vms)	{

				$cnt=0;

			}

		}

	} while($disk_util < $load_chk);
	
	#################################################################
	
	push(@traffic_list , @traffic);
	
	return (\@traffic);
	
}

sub	stop_nfs_load	{

	my (%opts) = @_;
	
	my @traffic = @{$opts{traffic_con}};

	foreach  my $traffic (@traffic)      {

		if($traffic)	{

			print("\nStop the traffic and perform cleanup");

			$traffic->stop_only_traffic();

			$traffic->stop();

		}

	}

}


1;
