#-------------------------------------------------------------------------------
# Author: Mauricio Sanchez
#   Date: 2012-Apr-11
#-------------------------------------------------------------------------------
# Description:
#   Basic File IO
#------------------------------------------------------------------------------

package Mercury::File::IO;

use strict;
use warnings;

use Exporter 'import';

our @EXPORT = qw(file_get_contents file_put_contents);
our @ISA    = qw(Exporter);

#------------------------------------------------------------------------------
# Static call to get a file's contents into an array
#------------------------------------------------------------------------------
sub file_get_contents {

    # Declare the file array
    my @file;

    # Get the hashed arguments
    my %args = @_;

    # Parse the hashed arguments
    my $file = $args{file};

    # See if the file exists
    if ( -e $file ) {

        # Open the file for reading
        open IN, "< $file" or die "Can't open $file $!";

        # Get the contents of the file into an array
        @file = <IN>;

        # Close the file
        close IN;
    }

    # Return the array or return a reference to the array
    return wantarray ? @file: \@file;
}

#------------------------------------------------------------------------------
# Static call to put an array's contents into a file
#------------------------------------------------------------------------------
sub file_put_contents {

    # Get the hashed arguments
    my %args = @_;

    # Parse the hashed arguments
    my $file  = $args{file};
    my $array = $args{array};

    open( OUT, ">$file" ) || die "Can't create $file: $!\n";
    print OUT @{$array};

    close(OUT);

    # Return pass
    return 1;
}

1;
