# hg_cmdlets.pm
package Mercury::hg_cmdlets;

use NACL::APISet;
use Data::Dumper;
use San::SanClient;
use San::SanUtil;
use San::SanClient::ClientUtil;

###########################################################################################
#
#
###########################################################################################
# Global variables continued
our $powershell_cmd = "echo | powershell.exe";

################################################################################
# Method: new
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################
sub new {
    my ($class, %args) = @_;

    #my $class = shift;
    my $self = {};
    bless($self, $class);
    foreach my $param (keys %args) {
        if ($param =~ /^-?hg_VMs$/) {
            $Clients = $args{$param};
        }
    }
    foreach my $client (@$Clients) {

        my ($Host, $Api_Set_Obj);

        print "Create an APISet object.\n";

        $Host = Tharn::host($client);

        unless ($Host) {
            print "host() call failed!!";
        }

        $Api_Set_Obj = NACL::APISet->new(hostobj   => $Host,
                                         category  => "Host",
                                         interface => "CLI",
                                         set       => "PowerShell",);

        $self->{client} = $Api_Set_Obj;
    } ## end foreach my $client (@$Clients)
    return $self;
} ## end sub new

################################################################################
# The command methods are located below
#
################################################################################
# Method: getHgCache
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub getHgCache() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "get-facache";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if Metrics
        if ($param =~ /^-?Metrics$/) {
            $metrics = $args{$param};
            $params  = $params . " -Metrics " . $metrics;

            # if Detailed
        } elsif ($param =~ /^-?Detailed$/) {
            $detailed = $args{$param};
            $params   = $params . " -Detailed " . $detailed;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub getHgCache()

################################################################################
# Method: setHgCache
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################
sub setHgCache() {

    my ($self, %args) = @_;

    my $Clients;
    my $results;

    my $params = "set-facache";
    foreach my $param (keys %args) {

        # if CacheMode
        if ($param =~ /^-?CacheMode$/) {
            $cache_mode = $args{$param};
            $params     = $params . " -CacheMode " . $cache_mode;

            # if CacheAdminState
        } elsif ($param =~ /^-?CacheAdminState$/) {
            $cache_admin_state = $args{$param};
            $params = $params . " -CacheAdminState " . $cache_admin_state;

            # if PerfState
        } elsif ($param =~ /^-?PerfState$/) {
            $perf_state = $args{$param};
            $params     = $params . " -PerfState " . $perf_state;

            # if CacheDeviceId
        } elsif ($param =~ /^-?CacheDeviceId$/) {
            $cache_device_id = $args{$param};
            $params          = $params . " -CacheDeviceId " . $cache_device_id;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if PerfState
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)
    $params = $params . " -force";

    my $output =
      $self->{client}
      ->execute_command(command => "c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    my @myarray = split /\r\n/, $output;
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub setHgCache()
################################################################################
# Method: setHgDevice
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################
sub setHgDevice() {

    my ($self, %args) = @_;

    my $Clients;
    my $results;

    my $params = "set-fadevice";
    print Dumper $params;
    foreach my $param (keys %args) {

        # if Disk
        if ($param =~ /^-?Disks$/) {
            $disk   = $args{$param};
            $params = $params . " -Disks " . $disk;

            # if SerialNumber
        } elsif ($param =~ /^-?SerialNumbers$/) {
            $serial_numbers = $args{$param};
            $params         = $params . " -SerialNumbers " . $serial_numbers;

            # if Metrics
        } elsif ($param =~ /^-?DeviceAdminState$/) {
            $device_admin_state = $args{$param};
            $params = $params . " -DeviceAdminState " . $device_admin_state;

            # if Detailed
        } elsif ($param =~ /^-DeviceCacheMode$/) {
            $device_cache_mode = $args{$param};
            $params = $params . " -DeviceCacheMode " . $device_cache_mode;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if PerfState
        } elsif ($param =~ /^-?PerfState$/) {
            $perf_state = $args{$param};
            $params     = $params . " -PerfState " . $perf_state;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    $params = $params . " -force";
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    my @myarray = split /\r\n/, $output;

    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub setHgDevice()
################################################################################
# Method: getHgDevice
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub getHgDevice() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "get-fadevice";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if Disk
        if ($param =~ /^-?Disks$/) {
            $disk   = $args{$param};
            $params = $params . " -Disks " . $disk;

            # if SerialNumber
        } elsif ($param =~ /^-?SerialNumbers$/) {
            $serial_numbers = $args{$param};
            $params         = $params . " -SerialNumbers " . $serial_numbers;

            # if Metrics
        } elsif ($param =~ /^-?Metrics$/) {
            $metrics = $args{$param};
            $params  = $params . " -Metrics " . $metrics;

            # if Detailed
        } elsif ($param =~ /^-?Detailed$/) {
            $detailed = $args{$param};
            $params   = $params . " -Detailed " . $detailed;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub getHgDevice()
################################################################################
# Method: getHgOptions
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub getHgOptions() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "get-faoptions";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if ComputerName
        if ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params = $computer_name . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub getHgOptions()
################################################################################
# Method: setHgOptions
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub setHgOptions() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "set-faoptions";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if DefaultDeviceState
        if ($param =~ /^-?DefaultDeviceState$/) {
            $default_device_state = $args{$param};
            $params = $params . " -DefaultDeviceState " . $default_device_state;

            # if DefaultDeviceCacheMode
        } elsif ($param =~ /^-?DefaultDeviceCacheMode$/) {
            $default_device_cache_mode = $args{$param};
            $params =
                $params
              . " -DefaultDeviceCacheMode "
              . $default_device_cache_mode;

            # if EventLogLevel
        } elsif ($param =~ /^-?EventLogLevel$/) {
            $event_log_level = $args{$param};
            $params          = $params . " -EventLogLevel " . $event_log_level;

            # if ChecksumEnabled
        } elsif ($param =~ /^-?ChecksumEnabled$/) {
            $checksum_enabled = $args{$param};
            $params = $params . " -ChecksumEnabled " . $checksum_enabled;

            # if MetricsResetInterval
        } elsif ($param =~ /^-?MetricsResetInterval$/) {
            $metrics_reset_interval = $args{$param};
            $params =
              $params . " -Metrics_Reset_Interval " . $metrics_reset_interval;

            # if InternalTimeout
        } elsif ($param =~ /^-?InternalTimeout$/) {
            $internal_timeout = $args{$param};
            $params = $params . " -InternalTimeout " . $internal_timeout;

            # if InternalRetryInterval
        } elsif ($param =~ /^-?InternalRetryInterval$/) {
            $internal_retry_interval = $args{$param};
            $params =
              $params . " -InternalRetryInterval " . $internal_retry_interval;

            # if InternalRetryCount
        } elsif ($param =~ /^-?InternalRetryCount$/) {
            $internal_retry_count = $args{$param};
            $params = $params . " -InternalRetryCount " . $internal_retry_count;

            # if CacheTimeout
        } elsif ($param =~ /^-?CacheTimeout$/) {
            $cache_timeout = $args{$param};
            $params        = $params . " -CacheTimeout " . $cache_timeout;

            # if CacheRetryCount
        } elsif ($param =~ /^-?CacheRetryCount$/) {
            $cache_retry_count = $args{$param};
            $params = $params . " -CacheRetryCount " . $cache_retry_count;

            # if MinIoSize
        } elsif ($param =~ /^-?MinIoSize$/) {
            $min_io_size = $args{$param};
            $params      = $params . " -MinIoSize " . $min_io_size;

            # if MaxIoSize
        } elsif ($param =~ /^-?MaxIoSize$/) {
            $max_io_size = $args{$param};
            $params      = $params . " -MaxIoSize " . $max_io_size;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    $params = $params . " -force";

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub setHgOptions()
################################################################################
# Method: clearHgMetrics
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub clearHgMetrics() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "clear-fametrics";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if Disk
        if ($param =~ /^-?Disks$/) {
            $disk   = $args{$param};
            $params = $params . " -Disks " . $disk;

            # if SerialNumber
        } elsif ($param =~ /^-?SerialNumbers$/) {
            $serial_numbers = $args{$param};
            $params         = $params . " -SerialNumbers " . $serial_numbers;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub clearHgMetrics()
################################################################################
# Method: resetHgDevice
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub resetHgDevice() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "reset-fadevice";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if Disk
        if ($param =~ /^-?Disks$/) {
            $disk   = $args{$param};
            $params = $params . " -Disks " . $disk;

            # if SerialNumber
        } elsif ($param =~ /^-?SerialNumbers$/) {
            $serial_numbers = $args{$param};
            $params         = $params . " -SerialNumbers " . $serial_numbers;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub resetHgDevice()
################################################################################
# Method: formatHgCache
# Objective: create a new hg_cmdlets oject
# Details:
################################################################################

sub formatHgCache() {

    my ($self, %args) = @_;

    my $results;

    # start of the arguements string for the test
    my $params = "format-facache";

    # determine which other intputs to add to the arguements
    # and add them to the string
    foreach my $param (keys %args) {

        # if ReplacementPolicy
        if ($param =~ /^-?ReplacementPolicy$/) {
            $replacement_policy = $args{$param};
            $params = $params . " -ReplacementPolicy " . $replacement_policy;

            # if BlockSize
        } elsif ($param =~ /^-?BlockSize$/) {
            $block_size = $args{$param};
            $params     = $params . " -BlockSize " . $block_size;

            # if BlocksPerChunck
        } elsif ($param =~ /^-?BlocksPerChunk$/) {
            $blocks_per_chunk = $args{$param};
            $params = $params . " -BlocksPerChunk " . $blocks_per_chunk;

            # if sizeLimitGb
        } elsif ($param =~ /^-?sizeLimitGb$/) {
            $size_limit_gb = $args{$param};
            $params        = $params . " -sizeLimitGb " . $size_limit_gb;

            # if Async
        } elsif ($param =~ /^-?Async$/) {
            $async  = $args{$param};
            $params = $params . " -Async " . $async;

            # if ComputerName
        } elsif ($param =~ /^-?ComputerName$/) {
            $computer_name = $args{$param};
            $params        = $params . " -ComputerName " . $computer_name;

            # if Credential
        } elsif ($param =~ /^-?Credential$/) {
            $credential = $args{$param};
            $params     = $params . " -Credential " . $credential;

            # if none of the above, then it is not a valid input
        } else {
            print "invalid Param : $param\n";
        }
    } ## end foreach my $param (keys %args)

    # execute the command on the VM
    my $output =
      $self->{client}
      ->execute_command(command => " c:\\Mercury_Test\\hg_wrapper.ps1 $params");

    print Dumper $output;

    # Since the returned output is in the form of a string
    # we need to split the string by new line characters
    # and put the output into the form of an array.
    my @myarray = split /\r\n/, $output;

    # Trim off any excess new line characters
    chomp @myarray;

    foreach my $record (@myarray) {
        my ($key, $value) = split /:/, $record;
        $key   =~ s/\s//g;
        $value =~ s/\s//g;
        $results{$key} = $value;
    }

    return \%results;
} ## end sub formatHgCache()
1;

=pod
d

=head1 Package Name

hg_cmdlets.pm

=head1 Author

Natalie Kerby
knatalie@netapp.com

=head1 Description

This module verifies that input parameters are valid and will then create the 
command to be sent to the script file.

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<Error.pm>

B<San/SanClient.pm>

=head1 B<Public Methods>

=head2 B<new(%args)>

=head1 Package Name

hg_cmdlets.pm

=head1 Author

Natalie Kerby
knatalie@netapp.com

=head1 Description

This module verifies that input parameters are valid and will then create the 
command to be sent to the script file.

=head1 See Also

Package inherits from the following modules. See these modules for further
interface detail.

B<Error.pm>

B<San/SanClient.pm>

=head1 B<Public Methods>

=head2 B<new(%args)>

Creates a NACL API object

=over 4

=item Inputs

=item Outputs

Returns a NACL API object

=item Examples

=back

=head2 B<getHgCache()>

This method will typically not take in any inputs however it can take in anywhere from zero to multiple key, value pairs. 

=over 4

=item Inputs

=item *I<-Metrics>  

Displays performance metrics of the cache device.

=item *I<-Detailed>  

Displays all variable attributes of the cache, including performance metrics.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run the command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test. For getHgCache, the hash table will conatin information concerning the CacheMode, AdminState, and DeviceIDs.

=item Examples

=back

=head2 B<setHgCache()>

This method can take in anywhere from zero to multiple key, value pairs and will set the options to their desired values. 

=over 4

=item Inputs

=item *I<-CacheMode>  

The global cache mode for the devices.

=item *I<-CacheAdminState>  

The global administrative state for the devices.

=item *I<-PerfState>  

Global performance statistics gathering for the devices.

=item *I<-CacheDeviceID>  

Set the ID for the cache.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test. For setHgCache, the hash table will typically be empty however an error can sometimes to returned.

=item Examples

=back

=head2 B<getHgDevice()>

This method will typically not take in any inputs however it can take in anywhere from zero to multiple key, value pairs. 

=over 4

=item Inputs

=item *I<-Metrics>  

Displays performance metrics of the cache device.

=item *I<-Detailed>  

Displays all variable attributes of the cache, including performance metrics.

item *I<-Disks>  

List of data disks for which attributes need to be set.

=item *I<-SerialNumbers>  

List of serial numbers of the data disks for which attributes need to be set.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<setHgDevice()>

This method can take in anywhere from zero to multiple key, value pairs and will set the options to their desired values. 

=over 4

=item Inputs

=item *I<-DeviceCacheMode>  

The cache mode for the devices.

=item *I<-DeviceAdminState>  

The administrative state for the devices.

=item *I<-PerfState>  

Performance statistics gathering for the devices.

=item *I<-Disks>  

List of data disks for which attributes need to be set.

=item *I<-SerialNumbers>  

List of serial numbers of the data disks for which attributes need to be set.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<getHgOptions()>

This method will typically not take in any inputs however it can take in anywhere from zero to multiple key, value pairs. 

=over 4

=item Inputs

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<setHgOptions()>

This method can take in anywhere from zero to multiple key, value pairs and will set the options to their desired values. 

=over 4

=item Inputs

=item *I<-DefaultDeviceState>  

The default admin state of cache for newly enumerated devices.

=item *I<-DefaultDeviceCacheMode>  

The default cache mode for newly enumerated devices.

=item *I<-EventLogLevel>  

Verbosity of windows event logging.

=item *I<-ChecksumEnabled>  

Checksum calculation for the cache device block.

=item *I<-MetricsResetInterval>  

The interval to reset device metrics.

=item *I<-InternalTimeout>  

The timeout (in ms) for internal commands.

=item *I<-InternalRetryInterval>  

The retry interval (in ms) for internal commands.

=item *I<-InternalRetryCount>  

The retry count for cache requests.

=item *I<-CacheTimeout>  

The timeout (in us) for cache requests.

=item *I<-CacheRetryCount> 

The retry count for cache requests.

=item *I<-MinIoSize>  

The minimum IO size to cache.

=item *I<-MaxIoSize> 

The maximum IO size to cache.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<clearHgMetrics()>

Load additional XML files into SanMgr.

=over 4

=item Inputs

item *I<-Disks>  

List of data disks for which attributes need to be set.

=item *I<-SerialNumbers>  

List of serial numbers of the data disks for which attributes need to be set.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<resetHgDevice()>

Initialize an EventMan object based on the <eventman> tags specified in the
XML configuration file.

=over 4

=item Inputs

item *I<-Disks>  

List of data disks for which attributes need to be set.

=item *I<-SerialNumbers>  

List of serial numbers of the data disks for which attributes need to be set.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=item Examples

=back

=head2 B<formatHgCache()>
 
Access the Controller module

=over 4

=item Inputs

item *I<-ReplacementPolicy>  

Cache block replacement policy

=item *I<-BlockSize>  

Cache blocks size in bytes.

item *I<-BlocksPerChunck>  

Cache blocks per chunk (including overhead).

=item *I<-sizeLimitGb>  

Cache size limit in GB.

=item *I<-Async>  

Perform the format asynchronously.

=item *I<-ComputerName>  

Specifies a remote Windows computer on which you want to run teh command.

=item *I<-Credentials> 

Specifies a user account that you want to use to run this command.

=item Outputs

A hash that the .thpl file will use to check the test.

=back

=cut

