#! /usr/software/bin/perl
# $Id: //depot/prod/test/Rsierranevada/lib/MiniXFUN/Viewer.pm#1 $

# Library to find NATE viewers for ndisp queue and test logs.

package MiniXFUN::Viewer;

BEGIN {
    require Exporter;
    @ISA       = qw(Exporter);
    @EXPORT_OK = qw(log_url queue_url request_url);
}

use strict;
use warnings;

my $nate_url =
  exists($ENV{NATE_URL})
  ? $ENV{NATE_URL}
  : 'http://web.netapp.com/engineering/nate/releases/last';

my $log_cgi   = "$nate_url/cgi-bin/natejobs.cgi";
my $ndisp_cgi = "$nate_url/cgi-bin/ndispviewer.cgi";

sub log_url($$) {
    my ($testbed, $id) = @_;
    return "$log_cgi?testbed=$testbed;logdir=$id;pagesize=99999";
}

sub queue_url($$) {
    my ($host, $port) = @_;
    return "$ndisp_cgi?operation=View+Requests;"
      . "ndisp_addr=$host;ndisp_port=$port";
}

sub request_url($$$) {
    my ($host, $port, $id) = @_;
    return "$ndisp_cgi?operation=view_req_info;"
      . "ndisp_addr=$host;ndisp_port=$port;request_id=$id";
}

