#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/NASClient/NFS.pm#1 $
## @summary NFS class
## @author snider@netapp.com
## @status in progress
## @pod here

=head1 NAME

NASClient::NFS:: - Class definition for a NFS clients

=head1 DESCRIPTION

Please see the documentation in C<NASClient> which describes the API for all
of the NASClient objects. This class file defines methods that support all
of the NFS clients.

=cut

package NASClient::NFS;
use base qw(NASClient);
use nfs::NfsClient;
use Params::NFS;
use strict;
use warnings;
use TracePkg;
use Params::NFS;
use Options;# qw(-no_Filer_required);
use Data::Dumper;
use Params::Validate qw(validate SCALAR HASHREF ARRAYREF OBJECT UNDEF);
use Module::Common qw(validate_mixed);

my $Trace = new TracePkg;
my $Options = new Options;
$Options->parameters(definitions=>
          [
           {
               name => "protocol",
               default => "tcp",
           },
           ]);

sub _set_defaults {
    my $self = shift;
    $Trace->entry();
    my $options = $Options->get_hash();
    $self->{rsize} = $options->{"RSIZE"};
    $self->{wsize} = $options->{"WSIZE"};
    $self->{hard_mount} = 1 if ($options->{"MOUNT_TYPE"} eq "hard");
    $self->{options} = $Options;
    $self->{jukebox_sleep} = 0;
    $self->{jukebox} = 0;
    $Trace->exit();
}

sub get_caller_info {
    my ($self, $level) = @_;
    my @lines;
    
    for(my $int_level = 1; $int_level <= $level; $int_level++) {
        my ($package, $file, $line, $subr, $hargs) = caller($int_level);
        push(@lines, "\t$package:$subr called at $file line $line");
    }

    return join("\n", @lines);
}

1;
