# this is basically -*- perl -*-
# $Id: $
#
## @summary Synthetic RHEL4 Linux Client
## @description This is not the exact Rhel4 client yet, but close.
## @author	gvg@netapp.com, snider@netapp.com
## @status	in progress
## @pod here

# RHEL 4
package NASClient::NFS::Synth::Rhel4;
use strict;
use warnings;
use base qw(NASClient::NFS::Synth::Linux);
use Data::Dumper;
use Params::Validate qw(validate SCALAR HASHREF ARRAYREF OBJECT UNDEF);
use nfs::NfsDef qw(:NFSCONSTANTS);
use TracePkg;
my $Trace = new TracePkg;

=head1 NAME

NASClient::NFS::Synth::Rhel4 - Class definition for a Redhat 4 NAS client

=head1 DESCRIPTION

Please see the documentation in C<NASClient> which describes the API for all
of the NASClient objects.

This class creates an object which maps the NASClient API to the actual
implementation for a Redhat Enterprise Linux version 4 client. For 
example, the NASClient API defines a method called ls() which is 
supposed to run the equivalent of an 'ls' on the given filesystem. The
ls() implemented in this class will send the proper sequence of NFS
calls to the filer based upon the observed sequence on a real Rhel4 client.

=cut

#-------------------------------------------------------------------
# Snider notes: my testing of this package has been primarily for v3
#-------------------------------------------------------------------

#-------------------------------------------------------------------
sub getfacl {
    my $self = shift;
    my $class = ref($self);
    $Trace->fatal(msg=>"$class->getfacl() is not supported by Linux Rhel4.", result=>"SCRIPT");
}

#-------------------------------------------------------------------
sub setfacl {
    my $self = shift;
    my $class = ref($self);
    $Trace->fatal(msg=>"$class->setfacl() is not supported by Linux Rhel4.", result=>"SCRIPT");
}

1;
