package NBU::Info;

use NBU::Command;

@ISA = qw(NBU::Command);

use Data::Dumper;
use strict;

############################# Accessors ##############################

sub set_policy {
	my ( $self, $p ) = @_;
	die "policy must be an instance of NBU::Policy" unless ref( $p ) eq 'NBU::Policy';
	$self->{policy} = $p;
}
sub get_policy { my ( $self ) = @_; return $self->{policy} }

sub set_follownfs {
	my ( $self, $follownfs ) = @_;
	die "follownfs must be 1 or 0" unless ( $follownfs == 1 || $follownfs == 0 );
	$self->{follownfs} = $follownfs;
}
sub get_follownfs { my ( $self ) = @_; return $self->{follownfs} }

#sub set_L {
#	my ( $self, $L ) = @_;
#	die "L must be 1 or 0" unless ( $L == 1 || $L == 0 );
#	$self->{L} = $L;
#}
#sub get_L { my ( $self ) = @_; return $self->{L} }

sub set_crossmp {
	my ( $self, $cross ) = @_;
	die "crossmp must be 1 or 0" unless ( $cross == 1 || $cross == 0 );
	$self->{crossmp} = $cross;
}
sub get_crossmp { my ( $self ) = @_; return $self->{crossmp} }

sub set_collect_bmr_info {
	my ( $self, $collect ) = @_;
	die "collect_bmr_info must be 1 or 0" unless ( $collect == 1 || $collect == 0 );
	$self->{collect_bmr_info} = $collect;
}
sub get_collect_bmr_info { my ( $self ) = @_; return $self->{collect_bmr_info} }

sub set_multiple_streams {
	my ( $self, $multiple ) = @_;
	die "multiple_streams must be 1 or 0" unless ( $multiple == 1 || $multiple == 0 );
	$self->{multiple_streams} = $multiple;
}
sub get_multiple_streams { my ( $self ) = @_; return $self->{multiple_streams} }

sub set_collect_tir_info {
	my ( $self, $collect ) = @_;
	die "collect_tir_info must be 2 or 1 or 0" unless ( $collect == 1 || $collect == 0 || $collect == 2 );
	$self->{collect_tir_info} = $collect;
}
sub get_collect_tir_info { my ( $self ) = @_; return $self->{collect_tir_info} }

sub set_offhost_backup {
	my ( $self, $offhost ) = @_;
	die "offhost_backup must be 1 or 0" unless ( $offhost == 1 || $offhost == 0 );
	$self->{offhost_backup} = $offhost;
}
sub get_offhost_backup { my ( $self ) = @_; return $self->{offhost_backup} }

sub set_use_data_mover {
	my ( $self, $mover ) = @_;
	die "use_data_mover must be 1 or 0" unless ( $mover == 1 || $mover == 0 );
	$self->{use_data_mover} = $mover;
}
sub get_use_data_mover { my ( $self ) = @_; return $self->{use_data_mover} }

sub set_data_mover_type {
	my ( $self, $type ) = @_;
	die "data_mover_type must be 1, 2, or 3" unless ( $type == 1 || $type == 2 || $type == 3 );
	$self->{data_mover_type} = $type;
}
sub get_data_mover_type { my ( $self ) = @_; return $self->{data_mover_type} }

sub set_snapshot_method {
	my ( $self, $method ) = @_;
	die "snapshot_method must be 'NAS_Snapshot'" unless ( $method eq 'NAS_Snapshot' );
	$self->{snapshot_method} = $method;
}
sub get_snapshot_method { my ( $self ) = @_; return $self->{snapshot_method} }

sub set_fi {
	my ( $self, $snapshot ) = @_;
	die "fi must be 1 or 0" unless ( $snapshot == 1 || $snapshot == 0 );
	$self->{fi} = $snapshot;
}
sub get_fi { my ( $self ) = @_; return $self->{fi} }

sub set_enable_pfi {
	my ( $self, $recovery ) = @_;
	die "pfi must be 1 or 0" unless ( $recovery == 1 || $recovery == 0 );
	$self->{enable_pfi} = $recovery;
}
sub get_enable_pfi { my ( $self ) = @_; return $self->{enable_pfi} }

sub set_ct {
	my ( $self, $ct ) = @_;
	die "ct must be 'Standard'" unless ( $ct eq 'Standard' );
	$self->{ct} = $ct;
}
sub get_ct { my ( $self ) = @_; return $self->{ct} }
	
sub set_ef {
	my ( $self, $ef ) = @_;
	die "ef must be of the form: mm/dd/yyyy" unless $ef =~ /^\d\d\/\d\d\/\d\d\d\d$/;
	$self->{ef} = $ef;
}
sub get_ef { my ( $self ) = @_; return $self->{ef} }

sub to_create_string {

	my ( $self ) = @_;

	my $string .= $NBU::Command::ROOT . 'bin/admincmd/bpplinfo';
	$string .= " $self->{policy}{name}";
	$string .= " -set";
	$string .= " -M $self->{policy}{storage_unit}{M}";
	$string .= " -residence $self->{policy}{storage_unit}{label}";
	$string .= " -crossmp $self->{crossmp}" if defined $self->{crossmp};
	$string .= " -collect_bmr_info $self->{collect_bmr_info}" if defined $self->{collect_bmr_info};
	$string .= " -multiple_streams $self->{multiple_streams}" if defined $self->{multiple_streams};
	$string .= " -collect_tir_info $self->{collect_tir_info}" if defined $self->{collect_tir_info};
	$string .= " -offhost_backup $self->{offhost_backup}" if defined $self->{offhost_backup};
	$string .= " -use_data_mover $self->{use_data_mover}" if defined $self->{use_data_mover};
	$string .= " -data_mover_type $self->{data_mover_type}" if defined $self->{data_mover_type};
	$string .= " -snapshot_method $self->{snapshot_method}" if defined $self->{snapshot_method};
	$string .= " -enable_pfi $self->{enable_pfi}" if defined $self->{enable_pfi};
	$string .= " -fi $self->{fi}" if defined $self->{fi};
	$string .= " -ct $self->{ct}" if defined $self->{ct};
	$string .= " -ef $self->{ef}" if defined $self->{ef};
	$string .= " -follownfs $self->{follownfs}" if $self->{follownfs};
	
	return $string;
}

# No need to provide an implementation for this since destroying the policy
# destroys this too.

sub to_delete_string {

	my ( $self ) = @_;
	
	return undef;
}

sub create_results {

	my ( $self ) = @_;
	
	return 0;
}

sub delete_results {

	my ( $self ) = @_;
	
	return 0;
}

1;

=head1 NAME

  NBU::Info - Modify NetBackup Policies
  
=head1 DESCRIPTION

  This is a wrapper around the bpplinfo command.  The object caches command 
  results internally.  For the most part, the variable names are the same 
  as the NBU command switches.
  
=head1 SYNOPSIS

  use NBU::Command;
  use NBU::StorageUnit;
  use NBU::Policy;
  use NBU::Info;
  
  $NBU::Command::VERBOSE = 1;

  my $s = NBU::StorageUnit->new;
  ... set values

  my $p = NBU::Policy->new;
  ... set values

  # p3

  my $i = NBU::Info->new;
  $i->set_policy( $p );                       # The policy to which to add the client
  $i->set_follownfs( 1 );                     # Whether to follow NFS
  $i->set_crossmp( 1 );                       # Whether to cross mount points.
  $i->set_collect_bmr_info( 0 );              # Whether to collect bare metal restore info
  $i->set_multiple_streams( 1 );              # Whether to allow multiple streams
  $i->set_collect_tir_info( 2 );              # Whether to collect true image restor info

  # p2
  
  my $i = NBU::Info->new;
  m$i->set_policy( $p );                      # The policy to which to add the client
  m$i->set_collect_bmr_info( 0 );             # Whether to collect bare metal restore info
  m$i->set_collect_tir_info( 0 );             #
  m$i->set_offhost_backup( 1 );               #
  m$i->set_use_data_mover( 1 );               #
  m$i->set_data_mover_type( 3 );              # Same as 'dt'.  ?
  m$i->set_snapshot_method( 'NAS_Snapshot' ); #
  m$i->set_multiple_streams( 1 );             # Whether to allow multiple streams
  m$i->set_fi( 1 );                           # Perform snapshot backups
  m$i->set_enable_pfi( 1 );                   # Retain snapshots for instant recovery
  m$i->set_ct( 'Standard' );                  #
  m$i->set_ef( '01/01/1970' );                #

  # Issue the create command
  $s->execute_create;

  # Issue the delete command
  # $s->execute_delete;

=head1 TODO

  - Fill in POD for missing p2 variables
  
=head1 DEPENDENCIES

  NBU::Command.pm
  Data::Dumper.pm
  
=head1 AUTHOR

  Todd Shoenfelt (todd@netapp.com)
  
=cut

__END__

/usr/openv/netbackup/bin/admincmd/bpplinfo djohnP \
	-M perf280er.lab.netapp.com
	-modify \
	-residence "djohnSU" \
	-follownfs 1 \

djohnP		Policy Name
-M			Master Server
-modify		Modify the Listed Values (or you can use -set)
-set		Set All Values to Default, then set Listed Values
-residence	Storage Unit to Use
-follownfs	Allows Backups to Be Done Via NFS

/usr/openv/netbackup/bin/admincmd/bpplinfo djohnP-W \
	-M perf280er.lab.netapp.com
	-modify \
	-residence "djohnSU" \
	-follownfs 1 \

djohnP-W	Policy Name
-M		Master Sesrver
-modify		Modify the Listed Values (or you can use -set)
-set		Set All Values to Default, then set Listed Values
-resiaggr status -r vp3dence	Storage Unit to Use
-follownfs	Allows Backups to Be Done Via NFS (OK, in this case CIFS)



/usr/openv/netbackup/bin/admincmd/bpplinfo djohnP-W \
	-L \
	-M perf280er.lab.netapp.com

djohnP-W	Policy name
-L		Long Output (Human Readable)
-M		Master Server

-------------------------------------------------------------------------------

/usr/openv/netbackup/bin/admincmd/bpplinfo 
	<name of policy> 
	-modify 
	-enable_pfi 1 						
	-use_data_mover 1 
	-data_mover_type 3 
	-fi 1 
	-offhost_backup 1 
	-snapshot_method NAS_Snapshot 
	-snapshot_method_args max_snapshots=<max number of snapshots to keep>  
	-ct Standard 						<
	-multiple_streams 1 
	-collect_tir_info 0 				<
	-collect_bmr_info 0 				<
	-residence <storage utit> 

Additional p2 variables:
------------------------

Perform snapshot backups										-fi 1
Retain snapshots for Instant Recovery							-enable_pfi 1

Perform offhost backup											-offhost_backup 1				# Done
Use data mover: Network Attached Storage						-use_data_mover 1 		 		# Done
																-data_mover_type 3 				# Done
Advanced Snapshot Options: Snapshot method > NAS_Snapshot		-snapshot_method NAS_Snapshot	# Done

/usr/openv/netbackup/bin/admincmd/bpplinfo 
	p2_policy 
	-set 
	-M perf280er.lab.netapp.com 
	-residence p2_stu 
	-collect_bmr_info 0 
	-multiple_streams 1 				x
	-offhost_backup 1 					x
	-use_data_mover 1 					x
	-data_mover_type 3 					x
	-snapshot_method NAS_Snapshot 		x
	-enable_pfi 1 						x
	-fi 1								x
	
	-ct Standard
	-collect_tir_info 0					
