
include CConfig/Rulesets/Dumper.rs;
include CConfig/Rulesets/Lif/GetLifInfo.rs;
include CConfig/Rulesets/IfGrp/IfGrp.rs;

# Delete all data lifs and re-create some of them on the ifgroup
strict_find ALL interface as @original_data_lifs with role=data;

if ( NUM @original_data_lifs > 0 )

    delete interface with vserver=@_{vserver} lif=@_{lif} foreach @original_data_lifs;

    set @ifgrp_create   as 
        CALL_ROUTINE ifgrp_data( nodes => @NODES, 
                                 type => "ifgrp_create" );
    
    find port_ifgrp as @ifgrp with 
         node=@_{node}
         ifgrp=@_{ifgrp}
         mode=@_{mode}
         distr-func=@_{distr-func}
             foreach @ifgrp_create;
    
    set @ifgrp_port_add as 
        CALL_ROUTINE ifgrp_data( nodes => @NODES, 
                                 type => "ifgrp_port_add" );
    add-port port_ifgrp with
         node=@_{node}
         ifgrp=@_{ifgrp}
         port=@_{port}
             foreach @ifgrp_port_add;

    # Replace ports with ifgrps
    set @data_lifs_ifgrps as 
        CALL_ROUTINE replace_ports_with_ifgrps( lifs          => @original_data_lifs, 
                                                ifgrp_ports   => @ifgrp_port_add,
                                                use_home_port => 1 );
    find interface as @data_lifs with
                    role=data
                    vserver=@_{vserver}
                    lif=@_{lif}
                    home-node=@_{home_node}
                    home-port=@_{home_port}
                    address=@_{address}
                    netmask=@_{netmask}
                        foreach @data_lifs_ifgrps;

else
    print "No data lifs found\n";
endif
