# Perl Module
# $Id: //depot/prod/test/Rsierranevada/lib/Network/SCON_DB/IPMsite.pm#1 $ 
# vim: ft=perl
#
# Purpose: Store IPManger site info
# 
#
## @summary
##
## @description
##
## @author      parsons@netapp.com
##
## @pod here
#
# POD at end of file



package Network::SCON_DB::IPMsite;

use strict;


BEGIN {
   use Exporter();
   our @ISA           = qw(Exporter);
}

# Define TAGs
our @SITE_TAGS = qw(ipm_site ipm_sites);
our @FUNC_TAGS = qw();

# Exports

our @EXPORT  = (
   @SITE_TAGS,
   @FUNC_TAGS,
);

our @EXPORT_OK  = qw();
our %EXPORT_TAGS = (
   'site'    => [@SITE_TAGS],
   'func'    => [@FUNC_TAGS],
   'general' => [@SITE_TAGS, @FUNC_TAGS],

);


our $ERROR = '';

our %IPM_DBs = (
    'rtp_cqa'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'RTP GDL'
    },
    'sti'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'CTL-PB, RTP GDL'
    },
    'rtp'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'RTP VSIM Domain'
    },
    'rtpeng'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'RTP GDL, QA Perf'
    },
    'rtp_eng'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'RTP GDL, QA Perf'
    },
    'ptc'  => {
        'hostname'    => 'csiqa-jams-admin-prod.rtp.netapp.com',
        'database'    => 'SCON',
        'username'    => 'sqluser',
        'password'    => '',
        'description' => 'PTC, RTP-GDL'
    },
    'smoke_bubble' => {
        'hostname'    => 'monitor.mgmt.smoke',
        'database'    => 'SCON_DB',
        'username'    => 'ipmanager',
        'password'    => 'sconDB',
        'description' => 'Smoke Bubbles'
    },
);




#================================ Functions =================================
#
# Return hash for given site
# 
# Args
#   $_[0] site index
#
# Return
#   wantarray ? ( ref, err) : ref
#
sub ipm_site {

    if ( defined($IPM_DBs{$_[0]}) ) {
        return( wantarray ? (\%{$IPM_DBs{$_[0]}}, '') : \%{$IPM_DBs{$_[0]}});    
    } 
    else {
        $ERROR = "IPMsite::ipm_site: site index: [$_[0]] not defined"; 
        return( wantarray ? (undef, $ERROR) : undef);
    }
}
#-----------------------------------------------------------------------------
# Return reference to the site IPM site hash
#
# Args 
#   none
# Return
#   ref to hash
#
sub ipm_sites {
    return(\%IPM_DBs);
}


1;
__END__


=head1 NAME Network::SCON_DB::IPMsite

=head1 DESCRIPTION

    IPManager Site definitions and functions

=head1 SYNOPSIS

    use Network::SCON_DB::IPMsite;
    my $site = shift || 'rtp_cqa';
    my ($href, $error) = &ipm_site($site);
    printf("site: %s:\n %s\n", $site, Dumper $href);


=head1 PARAMS

    none

=head1 Functions

=head2 ipm_site

    ($href, $error) = ipm_site($site); 
    printf("site: %s:\n %s\n", $site, Dumper $href);

    Return ref to hash IPManager site given.

=head2 ipm_sites

    $href = &ipm_sites;
    printf("Sites:\n %s\n", Dumper $href); 

    Return ref to hash IPManager sites.

=head1 STATUS

   Current

=head1 AUTHOR

  Scott Parsons (parsons@netapp.com)
  Last revised $Date: 2013/01/22 $

=head1 COPYRIGHT

Copyright 2011, Network Appliance., All Rights Reserved

=cut



