#***********************************************************************
# This is the comment section for tharndoc
#***********************************************************************
## @summary Perl module used by Filer.pm to implement all "aggr" commands in ONTAP 6.X
## @author dl-central-libs
## @pod here

=head1 NAME

Node::Classic::Aggr.pm

=head1 AUTHOR

dl-central-libs

=head1 DESCRIPTION

This module implements all of the "aggr" commands in ONTAP 6.X

=head1 SYNOPSIS

This module is instantiated by all test scripts that use the Server.pm module
and is not directly called.
See the descriptions below if you need the syntax for using a specific method

=head1 EXAMPLES

No examples needed

=cut

use strict;
use TracePkg;
our $Trace;
our %Aggrconversion = (
			);
#************************************************************************
my %command_definitions = (
		      );

my %Compatability = (
		     );

sub SetupAggrCommands {
    my ($self, @servers) = @_;
    return 1;
}

sub aggr_exists {
    my ($self, %params) = @_;
    $self->{Trace}->entry();
    my $rc = $self->vol_exists(%params, volume=>$params{aggregate});
    $self->{Trace}->exit(msg=>"return $rc");
    return $rc;
}

sub aggr_status {
    my ($self, %params) = @_;
    $self->{Trace}->entry();
    my $aggr = $self->vol_status(%params, volume=>$params{aggregate});
    foreach my $aggrh (@$aggr) {
	$aggrh->{aggregate} = $aggrh->{volume};
	my $aggr_list = $self->Df(pathname=>"/vol/$aggrh->{volume}/", MB=>"true");
	my $blocksh = $$aggr_list[0];
	grep($aggrh->{$_} = $blocksh->{$_}, keys %$blocksh);
	$aggrh->{type} = "trad";
	$aggrh->{filers} = $self->{server};
    }
    $self->{Trace}->exit();
    return $aggr;
}

sub aggr_create {
    my ($self, %params) = @_;
    $self->{Trace}->entry();
    my $rc = $self->vol_create(%params, volume=>$params{aggregate});
    $self->{Trace}->exit();
    return $rc;
}

1;
