#***********************************************************************
# This is the comment section for tharndoc
#***********************************************************************
## @summary Enables remote programmatic administration of a Filer running
##          FlexCache
## @author dl-central-libs
## @pod here

=head1 NAME

FlexCache.pm

=head1 AUTHOR

dl-central-libs

=head1 DESCRIPTION

This module is meant to be programmatic way of administering FlexCache filers

=head1 SYNOPSIS

This module is instantiated by Server.pm and is not directly called.
See documentation below for help on individual methods 

=head1 EXAMPLES

No examples needed

=cut

#***********************************************************************

# the following chunk of code allows this module to be overridded with another
# one if the variable is set. If it is set then print a warning, delete the ENV
# variable so that it is not seen in the new module, load the new one, and
# set the flag that indicates that we have already loaded the module (so that
# we don't load the new one
my $LibraryLoaded;
if ($ENV{OVERRIDECLASSIC_FLEXCACHE}) {
    my $newModule = $ENV{OVERRIDECLASSIC_FLEXCACHE};
    delete $ENV{OVERRIDECLASSIC_FLEXCACHE};
    print "The main Classic::FlexCache module will be replaced with $newModule\n";
    require($newModule);
    $LibraryLoaded = 1;
}
return 1 if ($LibraryLoaded);

package Node::Classic::7_X::FlexCache;
use strict;
use base qw(Node::Classic::7_X);

use TracePkg;
my $Trace = new TracePkg();

sub is_cache {
    my $self = shift;
    $Trace->entry();
    my $cache = "yes";

    # default the answer to yes.
    # If there is only one filer during this test run, then 
    #  set the answer to no
    if ($self->{server_object}->servers() == 1) {
	$cache = undef;
    }
    $Trace->exit(msg=>$cache);
    return $cache;
}

1; # Do NOT remove this. It is needed by the package.

