#***********************************************************************
# This is the comment section for tharndoc
#***********************************************************************
## @summary Perl module used by Filer.pm to implement all "dns" commands in ONTAP
## @author dl-central-libs
## @pod here

=head1 NAME

DNS.pm

=head1 AUTHOR

dl-central-libs

=head1 DESCRIPTION

This module implements all of the "dns" commands in ONTAP

=head1 SYNOPSIS

This module is instantiated by all test scripts that use the Filer.pm module
and is not directly called.
See the descriptions below if you need the syntax for using a specific method

=head1 EXAMPLES

No examples needed

=cut

#***********************************************************************
# the following chunk of code allows this module to be overridded with another
# one if the variable is set. If it is set then print a warning, delete the ENV
# variable so that it is not seen in the new module, load the new one, and
# set the flag that indicates that we have already loaded the module (so that
# we don't load the new one
my $LibraryLoaded;
if ($ENV{OVERRIDECLASSIC_DNS}) {
    my $newModule = $ENV{OVERRIDECLASSIC_DNS};
    delete $ENV{OVERRIDECLASSIC_DNS};
    print "The main Classic::DNS module will be replaced with $newModule\n";
    require($newModule);
    $LibraryLoaded = 1;
}
return 1 if ($LibraryLoaded);

our %DNSconversion = (
			);
my %options = (
		    );
#************************************************************************

=head1 C<DNSInfo()>

=over 4

=item Description

This method implements the "dns info" command

=item Arguments

None

=item Returns

None

=back

=cut

#************************************************************************

=head1 C<DNSFlush()>

=over 4

=item Description

This method implements the "dns flush" command

=item Arguments

None

=item Returns

None

=back

=cut

#************************************************************************

my %command_definitions = (
			       DNSInfo => {
				   command => "dns info",
				   conversion => \%DNSconversion,
				   options => \%options,
				   verification => "_ReturnOutputverification",
				   failure_output => [("DNS is disabled")],
			       },
			       DNSFlush => {
                                   command => "dns flush",
                                   conversion => \%DNSconversion,
                                   options => \%options,
                                   verification => "_ReturnOutputverification",
				   successful_output => [("DNS cache flushed")],
                               },

			       );
			       
my %Compatability = (
		     );

sub SetupDNSCommands {
    my ($self, @servers) = @_;
    $self->_define_commands(Definitions => \%command_definitions,
			    Compatability => \%Compatability,
			    Servers => \@servers);
    return 1;
}

1;
