#***********************************************************************
# This is the comment section for tharndoc
#***********************************************************************
## @summary Perl module used by Filer.pm to implement all "disk_fw_update" commands in ONTAP
## @author dl-central-libs
## @pod here

=head1 NAME

DiskFWUpdate.pm

=head1 AUTHOR

dl-central-libs

=head1 DESCRIPTION

This module implements all of the "disk_fw_update" commands in ONTAP

=head1 SYNOPSIS

This module is instantiated by all test scripts that use the Filer.pm module
and is not directly called.
See the descriptions below if you need the syntax for using a specific method

=head1 EXAMPLES

No examples needed

=cut

#************************************************************************

# the following chunk of code allows this module to be overridded with another
# one if the variable is set. If it is set then print a warning, delete the ENV
# variable so that it is not seen in the new module, load the new one, and
# set the flag that indicates that we have already loaded the module (so that
# we don't load the new one
my $LibraryLoaded;
if ($ENV{OVERRIDECLASSIC_DISKFWUPDATE}) {
    my $newModule = $ENV{OVERRIDECLASSIC_DISKFWUPDATE};
    delete $ENV{OVERRIDECLASSIC_DISKFWUPDATE};
    print "The main Classic::DiskFWUpdate module will be replaced with $newModule\n";
    require($newModule);
    $LibraryLoaded = 1;
}
return 1 if ($LibraryLoaded);

our %DiskFWUpdateconversion = (
			);
my %options = (
		   DiskList => " ",
		    );
#************************************************************************

=head1 C<DiskFWUpdate()>

=over 4

=item Description

This method implements the "disk_fw_update" command

=item Arguments

=over 4

=item DiskList
(Optional)

This is the specific list of disks to upgrade

=back

=item Returns

None

=back

=cut

#************************************************************************

my %command_definitions = (
			       DiskFWUpdate => {
				   command => "disk_fw_update",
				   conversion => \%DiskFWUpdateconversion,
				   options => \%options,
                                   optional_options => [qw(DiskList)],
				   verification => "_ReturnOutputverification",
                                   failure_output => [("does not exist")],
			       },
			       );
			       
my %Compatability = (
		     );

sub SetupDiskFWUpdateCommands {
    my ($self, @servers) = @_;
    $self->_define_commands(Definitions => \%command_definitions,
			    Compatability => \%Compatability,
			    Servers => \@servers);
    return 1;
}

1;
