#***********************************************************************
# This is the comment section for tharndoc
#***********************************************************************
## @summary Perl module used by Filer.pm to implement all "echo" commands in ONTAP
## @author dl-central-libs
## @pod here

=head1 NAME

Echo.pm

=head1 AUTHOR

dl-central-libs

=head1 DESCRIPTION

This module implements all of the "echo" commands in ONTAP

=head1 SYNOPSIS

This module is instantiated by all test scripts that use the Filer.pm module
and is not directly called.
See the descriptions below if you need the syntax for using a specific method

=head1 EXAMPLES

No examples needed

=cut

#***********************************************************************
# the following chunk of code allows this module to be overridded with another
# one if the variable is set. If it is set then print a warning, delete the ENV
# variable so that it is not seen in the new module, load the new one, and
# set the flag that indicates that we have already loaded the module (so that
# we don't load the new one
my $LibraryLoaded;
if ($ENV{OVERRIDECLASSIC_ECHO}) {
    my $newModule = $ENV{OVERRIDECLASSIC_ECHO};
    delete $ENV{OVERRIDECLASSIC_ECHO};
    print "The main Classic::Echo module will be replaced with $newModule\n";
    require($newModule);
    $LibraryLoaded = 1;
}
return 1 if ($LibraryLoaded);

our %Echoconversion = (
			);
my %options = (
		   String => " ",
		    );
#************************************************************************

=head1 C<Echo()>

=over 4

=item Description

This method implements the "echo" command

=item Arguments

=over 4

=item String
(Optional)

This is the text to echo to screen

=back

=item Returns

None

=back

=cut

#************************************************************************

my %command_definitions = (
			       Echo => {
				   command => "echo",
				   conversion => \%Echoconversion,
				   options => \%options,
				   optional_options => [qw(String)],
				   verification => "_ReturnOutputverification",
			       },

			       );
			       
my %Compatability = (
		     );

sub SetupEchoCommands {
    my ($self, @servers) = @_;
    $self->_define_commands(Definitions => \%command_definitions,
			    Compatability => \%Compatability,
			    Servers => \@servers);
    return 1;
}

1;
