#Hey emacs, this is basically -*- perl -*-
#$Id$
## @summary Interface implementation for IOTools functions
## @author dl-kernel-qa
## @status private
## @pod ./IOTools.pm

package Os::IOTools;
use strict;

use NACL::APISet;
use NACL::APISet::Exceptions::ResponseException qw(:try);

use Data::Dumper qw(Dumper);
use Module::Common qw(validate_mixed);
use Params::Validate
  qw(validate validate_with BOOLEAN HASHREF OBJECT ARRAYREF SCALAR UNDEF);
use Time::Local;
use Tharn qw($Log);
use TestUtils qw(get_site_info);

################################################################################
# Subroutine Name: new()
# Objective:       Create a new IOTool object
# Details:         See POD documentation at the end of this file
################################################################################
sub new {
    my $class = shift;

    my %args = validate_with(
        params => \@_,
        spec   => {
            api_set_obj => { isa  => 'NACL::APISet' },
            tool        => { type => SCALAR, }
        },
        allow_extra => 1
    );

    my ( $self, );

    ### bless instance into class
    $self = bless {}, $class;

    my $tool_name = lc( $args{tool} );

    if ( $tool_name eq "iozone" ) {
        require Os::IOTools::IOZONE;
        $self = Os::IOTools::IOZONE->_new(%args);
    }
    else {
        $Log->comment("The specified iotool $tool_name is not supported");
        return undef;
    }

    return $self;
}

1;

############################################################################
#  P O D
############################################################################
