
sub set_fru_state_freebsd
{
        my ($fruname, $set_state, $state_value) = @_;

        my $cmd = "sudo envcmdtool set_state -n \"$fruname\" forced";
        my $response_obj = $APISetSS->execute_raw_command(command => $cmd);

        my $cmd = "sudo envcmdtool get_state -n \"$fruname\"";
        my $response_obj = $APISetSS->execute_raw_command(command => $cmd);

	if ($state_value =~ /set_val/)
	{
		my $cmd = "sudo envcmdtool set_val -n \"$fruname\" \"$set_state\"";
        	my $response_obj = $APISetSS->execute_raw_command(command => $cmd);
	}
	else
	{
        	my $cmd = "sudo envcmdtool set_state -n \"$fruname\" \"$set_state\"";
        	my $response_obj = $APISetSS->execute_raw_command(command => $cmd);
	}

        my $cmd = "sudo envcmdtool get_state -n \"$fruname\"";
        my $response_obj = $APISetSS->execute_raw_command(command => $cmd);

}


sub wait_for_alert
{
    my $alert_to_wait = shift @_;
    chomp($alert_to_wait);
    my $count;

    if (($alert_to_wait  =~ /\w/) && ( $alert_to_wait =~ /Alert/) ){
        $count=0;
        while ($count < 80) {
            try {
                 $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => "$alert_to_wait" );
                 last;
            }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
            };
            sleep(30);
            $count++;
        }

    }else{
        $count=0;
        while ($count < 80) {
                my $response_obj = $APISetCmode->system_health_status_show();
                if(($response_obj->{'processed_output'}) !~ /degraded/) {
                        tstlog -comment, "The status is ok, waiting for degraded, sleeping for 30 seconds";
                        sleep 30;
                        $count++;
                }else{
                        last;
                }
        }

    }
}

sub wait_for_OK()
{
        my $count=0;
        while ($count < 80)
        {
                my $response_obj = $APISetCmode->system_health_status_show();
                if(($response_obj->{'processed_output'}) !~ /ok/)
                {
                        tstlog -comment, "The status is degraded, waiting for ok, sleeping for 30 seconds";
                        sleep 30;
                        $count++;
                }
                else{
                        last;
                }
        }

}


#Get the installed dimm numbers
#synopsis:get_dimms_list
sub get_dimms_list{
        my $command='sudo spd -a';
        my $spd_info=$APISetSS->execute_raw_command(command => $command);
        my @dimms_list;
        foreach my $line(split(/\n/,$spd_info))
        {
                if($line =~ /Flag/)
                {
                        $line=~/Id\s0x(\d|[a-f])+/;
                        my $dimm=$&;
                        $dimm=substr $dimm,3;
                        push(@dimms_list,$dimm);

                }

        }
        return @dimms_list;
}

#Simulat injection of memory errors by writing into SPD registers
#synopsis:inject_spd_error(dimm number, no of errors, u or c) # u for uncorrectable and c for correctable
#Default values: dimm=2, errors=6, type=correctable - There is a problem with default values. $dimm_no is getting some hashref when nothing is passed
sub inject_spd_error{

        my ($dimm_no,$errors,$type)=@_;
        my $command;
        $errors=6 unless($errors);
        $dimm_no=2 unless($dimm_no =~ /\d+/);#This is not working. need to check
        $type='c' unless($type);
        if($type =~ /^c$/)
        {
                $command='sudo spd -n '.$dimm_no.' -o 208 -w 1 '.$errors;
        } else {

                $command='sudo spd -n '.$dimm_no.' -o 188 -w 1 '.$errors;
        }
                my $spd_info=$APISetSS->execute_raw_command(command => $command);
}

#Clear all dimms spd counters for correctable and uncorrectable errors
#synopsys: clear_spd
sub clear_spd{

        my @dimms=get_dimms_list;
        foreach my $dimm(@dimms)
        {
                my $command='sudo spd -n '.$dimm.' -o 208 -w 1 0';
                my $spd_info=$APISetSS->execute_raw_command(command => $command);
                my $command='sudo spd -n '.$dimm.' -o 188 -w 1 0';
                my $spd_info=$APISetSS->execute_raw_command(command => $command);
        }
}

#Returns an hash of no of cecc and uecc errors
#Synopsis: get_dimm_errors(dimm no)
sub get_dimm_errors{

        my $dimm_no=shift;
        my %error_info;
        my $command='sudo spd -n '.$dimm_no.' -a';
        my $spd_info=$APISetSS->execute_raw_command(command => $command);
        foreach my $line(split(/\n/,$spd_info))
        {
                if($line =~ /[CU]ECC\s+cnt/)
                {
                        my ($error_type,$error_count)=split(/:/,$line);
                        chomp $error_count;
                        $error_type=substr $error_type, 0, 4;
                        $error_info{$error_type}=$error_count;
                }
        }
        return \%error_info;
}

#Returns hash for all the Fru's and Fru-id's
#Synopsis: get_fru_list

sub get_fru_list
{
    my $a, $b, $c, $temp;
    my $cmd = "system fru list";
    my $response_obj = $APISetSPmode->execute_raw_command(command => $cmd);
    my %values;
    foreach  $temp (split(/\n/,$response_obj)) {
         $temp =~ s/\s+/:/g;
         $temp =~ s/://;
         ($b,$c) = split (':',$temp,3) ;
         chomp($b);
         chomp($c);

         if ($b =~ /\d/){
            $values{$c} = $b;
         }

         if( $c =~ /Midplane/){
            $values{Midplane} = $b;
         }
    }
    return %values;
}

sub dimm_list_sysconfig
{
        my $mode = $Node->mode();
        tstlog -comment,"========$mode=========";

        my @dimms;
        if ($mode =~ /CMode/)
        {
                my $cmd = "run local sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                $line=~/DIMM-\d+/;
                                my $dimm = $&;
                                push(@dimms,$dimm);
                        }
                }
        }
        elsif ($mode =~ /7Mode/)
        {
                my $cmd = "sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                $line=~/DIMM-\d+/;
                                my $dimm = $&;
                                push(@dimms,$dimm);
                        }
                }
        }

        return @dimms;
}

sub dimm_serialnum_sysconfig
{
        my $mode = $Node->mode();
        tstlog -comment,"========$mode=========";

        my @seral_nums;
        if ($mode =~ /CMode/)
        {
                my $cmd = "run local sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                my @array = split("!",$line);
                                push(@seral_nums,$array[2]);
                        }
                }
        }
        elsif ($mode =~ /7Mode/)
        {
                my $cmd = "sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                my @array = split("!",$line);
                                push(@seral_nums,$array[2]);
                        }
                }
        }

        return @seral_nums;
}

sub dimm_part_sysconfig{

        my $mode = $Node->mode();
        tstlog -comment,"========$mode=========";

        my @part_no_nums;
        if ($mode =~ /CMode/)
        {
                my $cmd = "run local sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                my @array = split("!",$line);
                                push(@part_no_nums,$array[3]);
                        }
                }
        }
        elsif ($mode =~ /7Mode/)
        {
                my $cmd = "sysconfig -M";
                my $response_obj = $APISetCmode->execute_raw_command(command => $cmd);

                foreach my $line (split(/\n/,$response_obj))
                {
                        if($line =~ /DIMM-/)
                        {
                                my @array = split("!",$line);
                                push(@part_no_nums,$array[3]);
                        }
                }
        }

        return @part_no_nums;
}



# Boot-Media Related function
#  sub raise_bootmedia_alert is for raising Boot-media alert

sub  raise_bootmedia_alert {
        my ($set_state) = shift @_;
        chomp($set_state);
        my $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" $set_state ";
        my $response_obj = $APISetSS->execute_raw_command(command => $cmd);
        my $response_obj = $APISetSS->execute_raw_command(command => $cmd);
}



# sub make_bootmedia_state_ok is for making bootmedia state good
sub make_bootmedia_state_ok {
         my $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" 1 ";
         my $response_obj = $APISetSS->execute_raw_command(command => $cmd);
}


# SP related function
#    sub raise_sp_alert is for raising SP related Alert

sub raise_sp_alert {
    my $alert_name = shift @_;
    chomp($alert_name);
    my $response_obj;

    if($alert_name =~ /SPNewVersionAvailableAlert/) {
        try {
             $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => $alert_name);
        }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
             $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");

             eval {
                   my @prompts_answers = ( '.*Do you want to reboot the SP now?.*' => 'y', );
                   $APISetSP->sp_update('url' => "$SPFW", 'force' => '', 'connectrec-match_table' => \@prompts_answers, );
                  };

             sleep(420);
             my $response;
             my $count=0;
             while($count <= 10){
                   $response=$APISetCmode->execute_raw_command(command => "system  service-processor image show -instance");

                    if($response =~ /auto-updating/) {
                       $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate false -node local");
                       $APISetCmode->execute_raw_command(command => "system service-processor reboot-sp -node local -image primary");
                       sleep(420);
                       last;
                     }
                     sleep(120);
                     $count++;
             }
       };

    }elsif($alert_name =~ /SPNotConfiguredAlert/ ) {
           $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate false -node local");
    }elsif($alert_name =~ /SPAutoUpgradeFailedMajorAlert/) {
       try {
            $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => $alert_name);
       }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
            $APISetCmode->system_service_processor_image_modify('autoupdate' => 'true', 'node' => 'local');
            eval {
                  my @prompts_answers = ( '.*Do you want to reboot the SP now?.*' => 'y', );
                  $APISetSP->sp_update('url' => "$SPFW", 'force' => '', 'connectrec-match_table' => \@prompts_answers, );
                 };

            sleep(420);

            my $response;
            my $count=0;
            my $auto_update_count=0;
            while(($count <= 20) || ($auto_update_count == 3)){
                   $response=$APISetCmode->execute_raw_command(command => "system service-processor image show -instance");
                   if($response =~ /auto-updating/) {
                      $APISetCmode->execute_raw_command(command => "system service-processor reboot-sp -node local -image primary");
                      $auto_update_count++;
                   }
                   sleep(120);
                   $count++;

                   try {
                        $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => $alert_name);
                        last;
                   }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
                        #$Test->nlog("Waiting for $alert_name Alert");
                   };
            }
       };

       try {
            $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => $alert_name);
            $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");
       }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
            $Test->nlog("SPAutoUpgradeFailedMajorAlert Alert is not raised ");
            $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");
       };

   }else{
          $Test->log("Alert name is not valid");
    }

}


# sub remove_sp_alert is for removing SP related Alert
sub remove_sp_alert {
    my $alert_name = shift @_;
    chomp($alert_name);
    my $response_obj;
    my $count=0;

    if($alert_name =~ /SPNewVersionAvailableAlert/) {
         $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");
         $APISetCmode->execute_raw_command(command => "system service-processor reboot-sp -node local -image primary");
         sleep(600);
         $response_obj=$APISetCmode->execute_raw_command(command => "system health alert show -alert-id SPNewVersionAvailableAlert -node local");  
         if($response_obj !~ /SPNewVersionAvailableAlert/ ){
	    return $TCD::PASS;
         }else{
	    my $response;
            $count=0;
            while($count <= 30){
                  $response=$APISetCmode->execute_raw_command(command => "system service-processor image show -instance");
                  if($response =~ /Auto-Updating/) {
                     sleep(120);
                     $count++;
                  }else{
                     last;
                  }
            }
        }
   }elsif($alert_name =~ /SPNotConfiguredAlert/) {
       $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");
       $count=0;
       while($count <= 30){
            my $response = $APISetCmode->execute_raw_command(command => "system health alert show -alert-id SPNotConfiguredAlert -node local");
            if($response !~ /SPNotConfiguredAlert/) {
	       last;	
            }else{
	       sleep(120);
               $count++;
	    }
       }
   }elsif($alert_name =~ /SPAutoUpgradeFailedMajorAlert/){
          $APISetCmode->execute_raw_command(command => "system service-processor image modify -autoupdate true -node local");
          $count=0;
          while($count <= 30){
                $response_obj = $APISetCmode->execute_raw_command(command => "system health alert show -alert-id SPAutoUpgradeFailedMajorAlert -node local");      
                if($response_obj !~ /SPAutoUpgradeFailedMajorAlert/) {
                   last;
                }else{
                   sleep(120);
                   $count++;
                }
         }
   }

}

# Generic Function
#     sub wait_for_SP_BM_alert is for waiting for SP and bootmedia alert after raising alert
#     sub wait_for_SP_BM_OK is for waiting for health state to become ok after removal of  SP and bootmedia alert

sub wait_for_SP_BM_alert {
    my $alert_name = shift @_;
    chomp($alert_name);
    my $response_obj;
    my $cmd;

    my $count=0;
    while($count < 30) {
       $response_obj = $APISetCmode->system_health_status_show();
       my @parsed_output = @{$response_obj->get_parsed_output()};

       if($parsed_output[0]->{'status'} =~ /degraded/) {
           try {
                $response_obj = $APISetCmode->system_health_alert_show( 'alert-id' => $alert_name);
                last;
           }catch  NACL::APISet::Exceptions::NoMatchingEntriesException  with  {
                sleep(120);
                $count++;
           };

                if($alert_name =~ /BootmediaWarnAlert/){
                   $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" 2 ";
                   my $warn_state = $APISetSS->execute_raw_command(command => $cmd);
                }

                if($alert_name =~ /BootmediaReplaceAlert/){
                   $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" 3 ";
                   my $bad_state = $APISetSS->execute_raw_command(command => $cmd);
                }

      }else{
           tstlog -comment, "waiting for degraded state, sleeping for 120 seconds";
           sleep(120);
           $count++;

                if($alert_name =~ /BootmediaWarnAlert/){
                   my $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" 2 ";
                   my $warn_state = $APISetSS->execute_raw_command(command => $cmd);
                }

                if($alert_name =~ /BootmediaReplaceAlert/){
                   my $cmd = "sudo envcmdtool set_val -n \"Usbmon Status\" 3 ";
                   my $warn_state = $APISetSS->execute_raw_command(command => $cmd);
                }

     }
  }
}


sub wait_for_SP_BM_OK {

        my $response_obj = $APISetCmode->system_health_status_show();
        my @parsed_output = @{$response_obj->get_parsed_output()};

        my $count=0;
        while ($count < 45 ) {
                my $response_obj = $APISetCmode->system_health_status_show();
                my @parsed_output = @{$response_obj->get_parsed_output()};
                if($parsed_output[0]->{'status'} !~ /ok/) {
                   sleep 60;
                   $count++;
                }else {
                   last;
                }
        }
}

1;
