# this is basically -*- perl -*-
# vim: set ft=perl tabstop=4 shiftwidth=4 expandtab shiftround: 
#
# $Id: //depot/prod/test/Rsierranevada/lib/Params/JAMS.pm#1 $
#
# Copyright (c) 2010 Network Appliance Inc.
# All rights reserved.
#

=head1 NAME

Params::JAMS - common definitions for Options.pm parameters used by
               the various pieces of JAMS.

=head1 SYNOPSIS

   use Options;
   use Params::JAMS;

=head1 DESCRIPTION

This package is used to define the common JAMS NATE parameters used by
JAMS scripts. It can be used by anyone using the L<Options> package
as a convenient way to keep your options all consistent across all the scripts.

=head1 METHODS

none

=cut

use Options;

$Options = new Options;
$Options->parameters( definitions=> [
    {
        name            => "REGRESSION_TEST_MODE",
        description     => "mode (e.g. SEVEN or TEN)",
        spec            => "s",
        default         => "",
        valid_values    => ["", "SEVEN", "TEN"],
    },
]);

# If there are any options that have changed names here is where we would put them
$Options->compatability( definitions=>
    {
    });
1;
