# this is basically -*- perl -*-
# vim: set ft=perl tabstop=4 shiftwidth=4 expandtab shiftround: 
#
# $Id:$
#
# Copyright (c) 2007 Network Appliance Inc.
# All rights reserved.
#

=head1 NAME

Params::NS - common Name Server definitions for Options.pm parameters

=head1 SYNOPSIS

   use Options;
   use Params::NS;

=head1 DESCRIPTION

This package is used to define the common Name Server parameters used by
test scripts. It can be used by anyone using the L<Options> package
as a convienient way to keep your options all consistent.

=head1 METHODS

none

=cut

use Options;

$Options = new Options;
$Options->parameters( definitions=> [
    {
        name        => "NIS_SERVER",
        description => "NIS Server Name(s) or IP addresse(s)",
        spec        =>  "s@",
    },
    {
        name        => "NIS_USER",
        description => "User in NIS Domain to use",
    },
    {
        name        => "NIS_DOMAIN",
        description => "NIS domain name",
    },
]);

# If there are any options that have changed names here is where we would put them
$Options->compatability( definitions=>
    {
    });
1;
