# this is basically -*- perl -*-
# vim: set ft=perl tabstop=4 shiftwidth=4 expandtab shiftround: 
#
# $Id$
#
# Copyright (c) 2012 Network Appliance Inc.
# All rights reserved.
#

=head1 NAME

Params::TestBranch - Paths to the current test automation branches

=head1 SYNOPSIS

   use Options;
   use Params::TestBranch;

=head1 DESCRIPTION

This package is used to define the paths to the current test automation
branches.

=head1 METHODS

none

=cut

use Options;

$Options = new Options;
$Options->parameters( definitions=> [
    {
        name            => "TEST_BRANCH_MAIN",
        description     => "Test Automation Branch for main",
        spec            => "s",
        default         => "/x/eng/localtest/noarch/main",
    },
    {
        name            => "TEST_BRANCH_SN",
        description     => "Test Automation Branch for Rsierranevada",
        spec            => "s",
        default         => "/x/eng/localtest/noarch/Rsierranevada",
    },
    {
        name            => "TEST_BRANCH_RR",
        description     => "Test Automation Branch for Rrollingrock",
        spec            => "s",
        default         => "/x/eng/localtest/noarch/Rrollingrock",
    },
    {
        name            => "TEST_BRANCH_RR0",
        description     => "Test Automation Branch for R8.1x",
        spec            => "s",
        default         => "/x/eng/localtest/noarch/R8.1x",
    },
    {
        name            => "TEST_BRANCH_BR",
        description     => "Test Automation Branch for Rboilermaker",
        spec            => "s",
        default         => "/x/eng/localtest/noarch/Rboilermaker",
    },
]);

# If there are any options that have changed names here is where we would put them
$Options->compatability( definitions=>
    {
    });
1;
