# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary  
## @status   private
##
## @pod here

=head1 NAME

File::Lock::Write::Unix - Write Lock Operation on Unix hosts

=head1 DESCRIPTION

It is written using the "inside-out" object paradigm and the package Object::InsideOut specifically.

=over

=item References

=over

=item More on inside-out objects:      http://www.perlfoundation.org/perl5/index.cgi?inside_out_object

=item Object::InsideOut Documentation: http://search.cpan.org/dist/Object-InsideOut/lib/Object/InsideOut.pod

=back

=back

=head1 METHODS

=cut

package Perf::DataSet::Operation::File::Lock::Write::Unix;
{
    use strict;
    use warnings;
    use Carp qw( confess );    
    use Tharn qw( $Log );
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use File::FcntlLock;    
    use Perf::DataSet::Operation::File::Lock::Write;
    use Perf::DataSet::Operation::File::Lock::Unix;
    use base qw(Perf::DataSet::Operation::File::Lock::Unix Perf::DataSet::Operation::File::Lock::Write);
    
    sub _init {
        my ($self,$args) = @_;
        $self->SUPER::_init($args);
        $self->_l_type( F_WRLCK );
        return;                                                
    }
    
 }
1; 