# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary  Creates Perf::DataSet::Sparser objects
## @status

package Perf::DataSet::SparserFactory;

use strict;
use warnings;
use Carp qw(confess);
use Tharn qw($Log);
BEGIN{
    my @c = caller(2);
    $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
}
use Perf::Utils qw(as_string);
use Params::Validate qw(validate SCALAR HASHREF ARRAYREF OBJECT UNDEF CODEREF);
use Perf::DataSet::Sparser;

sub new {
    my $class = shift;
    my %params = validate( @_,
                           {
                               vol => {type => OBJECT, isa => 'Perf::Depot::Resource::Volume' },
                           });
    my $self = {};
    $self->{vol_type} = $params{vol}->get_type();
    $self->{large_aggr} = $params{vol}->is_in_large_aggr();
    bless $self, $class;
    return $self;
}

sub sparser {
    my $self = shift;
    my $sparser = Perf::DataSet::Sparser->new( vol_type   => $self->{vol_type},
                                         large_aggr => $self->{large_aggr},
                                         @_,
                                        );
    return $sparser;
}
1;
