# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary
## @status   private
##
## @pod here

package Perf::DataSet::test_suite::ModularWorkloadRandReadWrite;{

    use strict;
    use warnings;
    use Tharn qw($Log);
    use Carp qw(confess);
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Perf::Utils qw(in_bytes);
    use Perf::DataSet::Sequence;
    use Object::InsideOut qw(Perf::DataSet::Sequence::File);
    use Perf::DataSet::Operation::File::Overwrite;
    use Perf::DataSet::Operation::File::Read;

    my @io_size :Field :Name('io_size') :Arg(Name=>'io_size',      Mandatory=>1);

    sub _init :Init {
        my $self = shift;
        $io_size[$$self] = in_bytes($io_size[$$self]);
    }

    sub get_operations {
        return ['Perf::DataSet::Operation::File::Overwrite', 'Perf::DataSet::Operation::File::Read'];
    }

    sub next_operation {
        my ($self) = @_;
        my $rand = $self->rand(2);
        my $file = $self->random_element;
        my $offset = $self->random_offset($file, $io_size[$$self]);
        my $size = $file->before_eof($offset, $io_size[$$self]);

        if (!$rand){
            return Perf::DataSet::Operation::File::Overwrite->new(element => $file,
                                                            offset  => $offset,
                                                            size    => $size);
        }
        else{
            return Perf::DataSet::Operation::File::Read->new( element => $file,
                                                        offset  => $offset,
                                                        size    => $size);
        }
    }
}
1;
