## @author   dl-perf-qa-automation@netapp.com
## @summary
## @status   private
##
## @pod here

=head1 NAME

Resource::IGroup - Representation of an initiator group on an appliance

=cut


package Perf::Depot::Resource::IGroup;
{
    use strict;
    use warnings;
    use Carp qw(confess);
    use Tharn qw($Log);
    BEGIN {
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Object::InsideOut qw(Perf::Depot::Resource);

    my @appliance :Field
                  :Arg(name => 'appliance', mandatory => 1)
                  :Get(get_appliance)
                  :Type(Perf::Depot::Resource::Appliance);
    my @san_service :Field
        :Arg(name => 'san_service', mandatory => 1)
        :Type(Perf::Depot::Resource::SANService)
        :Get(get_san_service);
    my @protocol  :Field
                  :Get(get_protocol)
                  :Arg(name => 'protocol', mandatory => 1);


    sub _init :Init {
        my $self = shift();
        my $host = $san_service[$$self]->get_host();

        my $name =
          $appliance[$$self]->igroup_create(
                 hosttype        => $host->get_lun_type(),
                 'protocol-type' => $protocol[$$self],
                 initObjs =>
                   $host->get_initiators(protocol => $protocol[$$self]),
                 name => $host->get_name() . '_' . $protocol[$$self],);

        $self->set_name($name);

        $self->add_dependencies([$appliance[$$self], $san_service[$$self]]);
    }


    sub get_host {
        my $self = shift();

        return $san_service[$$self]->get_host();
    }


    sub cleanup {
        my $self = shift();

        $appliance[$$self]->igroup_destroy($self->get_name());
    }
}

1;
