# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary
## @status   private
##
## @pod here

=head1 NAME

Resource::Mountpoint::NFS - Representation of an nfs mountpoint on a host

=head1 DESCRIPTION

It is written using the "inside-out" object paradigm and the package Object::InsideOut specifically.

=over

=item References

=over

=item More on inside-out objects:      http://www.perlfoundation.org/perl5/index.cgi?inside_out_object

=item Object::InsideOut Documentation: http://search.cpan.org/dist/Object-InsideOut/lib/Object/InsideOut.pod

=back

=back

=head1 METHODS

=cut

package Perf::Depot::Resource::Mountpoint::NFS;
{
    use strict;
    use warnings;
    use Carp qw( confess );
    use Tharn qw( $Log );
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }

    use namespace::clean;
    use Perf::Depot::Resource::Mountpoint::NAS;
    use Object::InsideOut qw(Perf::Depot::Resource::Mountpoint::NAS);


    sub get_mount_target {
        my $self = shift();
        my %arg = (path => $self->get_volume()->get_export_path());

        return %arg;
    }
}
1;
