# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary  Class responsible for generating named aliases
## @status   review
## @pod here

package Perf::Stats::AliasFactory::Name;{
    use strict;
    use warnings;
    use Tharn qw($Log);
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Data::Dumper;
    use Carp qw( confess );
    use Perf::Stats::Alias;
    use Perf::Stats::AliasFactory;
    use Object::InsideOut qw( Perf::Stats::AliasFactory );

    sub process_aliases {
        my ($self, $counters) = @_;
        my $alias = Perf::Stats::Alias->new(   name => $self->get_name,
                                         counters => $counters,
                                    );
        return [$alias];
    }
}
1;
