# Class representing a userspace/BSD/diag/cm_client counter

package Perf::Stats::Counter::CM::RPC::CM_Client; {
    use strict;
    use warnings;
    use Tharn qw($Log);
    use Carp qw(confess);
    use Data::Dumper;
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Object::InsideOut qw(Perf::Stats::Counter::CM::RPC);

    my @cm_process   :Field :Get('get_cm_process');

    sub _preinit :PreInit {
        my $self = shift();
        my $args = shift();

        $cm_process[$$self] = delete($args->{spec}->{process});

        confess("Required parameter 'process' missing from counter spec:\n"
                    . Dumper($args->{spec}))
            if (!defined($cm_process[$$self])
                    || q{} eq $cm_process[$$self]);
    }

    sub get_name {
        my $self = shift();

        my $postfix = $self->SUPER::get_name();

        return "$cm_process[$$self]:$postfix";
    }
}

1;
