# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary  Handler for 'statistics' command output.
##                   Specific to cluster wide counters.
## @status   review
## @pod here
package Perf::Stats::Handler::CM::Cluster::Statistics;{

    use strict;
    use warnings;
    use Carp qw(confess);
    use Tharn qw($Log);
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Readonly;
    use Params::Validate qw(validate SCALAR HASHREF UNDEF);
    use NACL::APISet::Response::CLI::CMode;
    use Object::InsideOut qw(Perf::Stats::Handler::CM::Cluster Perf::Stats::Handler::CM::Statistics);
    use NATE::BaseException qw(:try);
    use Data::Dumper;

    sub _preinit :PreInit {
        my $self = shift();
        my $args = shift();

        my $nodes = $args->{nodes};
        $self->set_nodes($nodes);
        $args->{node} = $nodes->[0];
        $self->set_current_node($nodes->[0]);
    }

    sub cache_build_command {
        my ($self, $regexs) = @_;
        #make sure method knows to build off no_node objects
        return $self->SUPER::cache_build_command($regexs,key=>'no_node');
    }

    sub sample_build_command {
        my ($self,%args) = @_;
        $args{no_node} = 1;
        return $self->SUPER::sample_build_command(%args);
    }

}
1;