package Perf::Stats::Handler::CM::Cluster::ZAPI;{

    use strict;
    use warnings;
    use Carp qw(confess);
    use Tharn qw($Log);
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Readonly;
    use Params::Validate qw(validate SCALAR HASHREF UNDEF);
    use NACL::APISet::Response::CLI::CMode;
    use Object::InsideOut qw(Perf::Stats::Handler::CM::Cluster Perf::Stats::Handler::CM::ZAPI );
    use NATE::BaseException qw(:try);
    use Data::Dumper;

    sub _preinit :PreInit {
        my $self = shift();
        my $args = shift();

        my $nodes = $args->{nodes};
        $self->set_nodes($nodes);
        $args->{node} = $nodes->[0];
        $self->set_current_node($nodes->[0]);
    }

    sub cache_build_command {
        my ($self, $regexs) = @_;
        #make sure method knows to build off no_node objects
        return $self->SUPER::cache_build_command($regexs,key=>'no_node');
    }
    sub get_all_instances {
        my ($self, $object) = @_;
        #make sure method knows to not filter by node
        return $self->SUPER::get_all_instances($object, no_node=>1);
    }
    sub sample_build_command {
        my ($self) = shift;
        return $self->SUPER::sample_build_command(no_node=>1);
    }

}
1;