# -*- perl -*-
#
## @author   jroussin@netapp.com
## @summary  Internal class
## @status   review

package Perf::Stats::InstanceInfo;{

    use strict;
    use warnings;
    use Tharn qw(logcomment say subtest param connect $Log);
    BEGIN{
        my @c = caller(2);
        $Log->debug("Loading " . __FILE__ . " from $c[1]:$c[2]");
    }
    use Params::Validate qw(validate validate_with SCALAR HASHREF ARRAYREF OBJECT UNDEF CODEREF);
    use Carp qw();
    use Object::InsideOut;
    use Perf::Stats::InstanceInfo::disk;
    use Perf::Stats::InstanceInfo::lun;

    my @node     :Field :Arg(Name=>'node', Mandatory=>1) :Get('get_node');
    my @handler  :Field :Arg(Name=>'handler', Mandatory=>1) :Get('get_handler');

    sub new {
        my $class = shift;
        if ($class ne __PACKAGE__){
            return $class->Object::InsideOut::new(@_);
        }
        my $type = shift;
        my $subclass_package = $class . "::" .$type;
        return $subclass_package->new(@_);
    }

}
1;
