/**
 * This is the main internal header file for the Counter Manager Archiver Parsing Library API.
 *
 * The Counter Manager Archiver Parsing Library (CMAPL) is a C library used to manipulate the
 * CM Archiver Binary File Format. The internal CM Archiver file format is retracted in SN.0,
 * in favor of this interface for on-box and off-box tools. The library will handle forward
 * compatibility as well as data indexing for increased search performance. Consumers of the
 * Binary CM Archiver File Format will use the CMAPL to query data within the files. Off-box
 * internal tools such as LatX and PerfViewer will also use the CMAPL to provide query access
 * into the Binary CM Archiver File Format. In addition, the CMAPL will be backwards compatible
 * with older file formats, including RR, BR and IC archiver files.
 */

#ifndef _CMAPL_INT_H_
#define _CMAPL_INT_H_

#include "cmapl_common_defs.h"
#include "cmapl_int_defs.h"
#include "cmapl_write.h"
#include "cmapl_write_int.h"

#endif /* _CMAPL_INT_H_ */
