use strict;
use warnings;

package PostProc::EmsLogMessage;

use TracePkg;
use Data::Dumper;

my $Trace = new TracePkg();
$Trace->set_options(separateNewline => 1);

use base qw/PostProc::LogMessage/;

sub new
{
    $Trace->entry();
    my $class = shift();

    my %p = @_;

    my $self = ();

    $self->{num} = $p{num};
    $self->{toss_re} = $p{'toss-regexes'};
    $self->{remove_re} = $p{'remove-regexes'};

    $self->{line} = $p{line};

    $self->{tokens} = [];
    $self->{line} =~ s/=\".*?\"/=/g;

    bless($self, $class);

    $Trace->exit();
    return $self;
}

sub hash_entry()
{
    my $self = shift();
    $Trace->entry();

    if (!exists($self->{hashed}) || ($self->{hashed} != 1)) {

        if (exists(($self->msg_by_tokens)->{ $self->{line} })) {
            $self->{tokens} = [];
        }
        push(@{($self->msg_by_tokens)->{ $self->{line} }}, $self);

        if (scalar(@{($self->msg_by_tokens)->{ $self->{line} }}) > 10) {
            delete($self->{line});
        }

        $self->{hashed} = 1;
    }
    $Trace->exit();
}

1;
