#
# $Id: //depot/prod/test/Rsierranevada/lib/PostProc/Log/Mgwd.pm#1 $
#

use strict;
use warnings;

package PostProc::Log::Mgwd;

my $Trace = new TracePkg();
$Trace->set_options(separateNewline => 1);

use base qw/PostProc::Log/;

sub new 
{
    $Trace->entry();
    my $self = PostProc::Log::new(@_);
    $self->{tossable} = $self->init_tossable_re();
    $Trace->exit();
    return $self;
}

sub init_tossable_re
{
    $Trace->entry();
    my $tre = PostProc::Log::init_tossable_re();
    my @toss;

    #
    # Mgwd-specific token regexes
    #

    #Explanation for regex defined below with examples:

    #^\w+\.cnc\.spin\.eng\.netapp\.com$   --> smkbc1b13.cnc.spin.eng.netapp.com
    #^\(\d+\)$                            --> (123) 
    #^e\d[^0-9]                           --> e1a port
    #^\d+:\d+$                            --> RpcConnection
    #^(<LR|d=|n=|t=|id=|p=|s=|o=|vf=|type=|seq=) --> Ems event
    #^\d\d:\d\d:\d\d\"$                   --> Ems event
    #^\(\d+$                              --> (32 tests remaining)

    push(@toss, 
        qw!
        ^\[(kern|user)_mgwd:\S+:\d+\]$
	^\w+\.cnc\.spin\.eng\.netapp\.com$  
	^\(\d+\)$                           
        ^(ldap_domains|name_mappings|nis_domains|secd_unix_group_membership)$
        ^(kerberos_spns|ns_switch|secd_unix_groups|kerberos_keyblocks|secd_unix_users|secd_cifs_server)$
        ^(vifmgr.portup|vifmgr.portdown)$
        ^e\d[^0-9]                          
        ^(op=|tid=|txn=|label=|num-cb-pending=|depth=|ec=|itr=|iter=|row=|table=|map_size=|status=)
        ^/mroot/etc/cluster_config/rdb
        ^(getDatabase|createDatabase)\(
        ^\d+:\d+$                          
        ^localhost$
        ^(Pending|Success)$
        ^(<LR|d=|n=|t=|id=|p=|s=|o=|vf=|type=|seq=)
	^\d\d:\d\d:\d\d\"$                
        ^\(\d+$                           
        !
    );

    push(@{$tre}, 
        map( { qr/$_/; } @toss));

    $Trace->exit(msg => join(" ", @{$tre}));
    return $tre;
}

sub init_remove_re
{
    my $sre = PostProc::Log::init_substitutions();

    #
    # Mgwd-specific substring substitutions
    #

    return $sre;
}

1;
