#
# $Id: //depot/prod/test/Rsierranevada/lib/PostProc/Log/Vldb.pm#1 $
#

use strict;
use warnings;

package PostProc::Log::Vldb;

my $Trace = new TracePkg();
$Trace->set_options(separateNewline => 1);

use base qw/PostProc::Log/;

sub new 
{
    $Trace->entry();
    my $self = PostProc::Log::new(@_);
    $self->{tossable} = $self->init_tossable_re();
    $Trace->exit();
    return $self;
}

sub init_tossable_re
{
    $Trace->entry();
    my $tre = PostProc::Log::init_tossable_re();
    my @toss;

    #
    # Vldb-specific token regexes
    #

    push(@toss, 
        qw!
        ^\[(kern|user)_vldb:\S+:\d+\]$
        !
    );

    push(@{$tre}, 
        map( { qr/$_/; } @toss));

    $Trace->exit(msg => join(" ", @{$tre}));
    return $tre;
}

sub init_remove_re
{
    my $sre = PostProc::Log::init_substitutions();

    #
    # Vldb-specific substring substitutions
    #

    return $sre;
}

1;
