#!/bin/sh /usr/software/bin/perl 

#
#  Class that models an SMF Command
#
package Command;

use strict;

sub new {

    # an instance of "this" is always the first arg
    # the second arg is a set of named arguments used to init
    #  a hash.
    my ($self, %arg) = @_;

    # Fill the member vars for this instance
    my $object = {
	_name     => $arg{name} || "???" ,
	_command  => $arg{command} || "???",
	_priv     => $arg{priv} || "???",
	_showDirs => undef,
	_args     => undef,
	_table    => $arg{table} || "???",
	};

    # This tags the hash pointed to by $object as a 
    #  type of Method
    bless $object, $self;


    #print "Returning cmd: $arg{name}, $arg{command}, $arg{table}\n";

    # And give the caller the referece to the bless object.
    return $object;

}


sub getName {
    my ($self) = @_;
    return $self->{_name};
}


sub getCmdString {
    my ($self) = @_;
    return $self->{_command};
}


sub setCmdString {
    my ($self, $cmdString) = @_;
    $self->{_command} = $cmdString;
}


sub setPriv {
    my ($self, $priv) = @_;
    $self->{_priv} = $priv;
}


sub getPriv {
    my ($self) = @_;
    return $self->{_priv};
}


sub addShowDirs {
    
    my ($self, @showDirs) = @_;

    @{ $self->{_showDirs} } = @showDirs;
}


sub setTable {
    my ($self, $table) = @_;
    $self->{_table} = $table;
}


sub getTable {
    my ($self) = @_;
    return $self->{_table};
}


sub printMe {

    my ($self) = @_;
    my $key;

    print "\tCommand: $self->{_name}, $self->{_command}, $self->{_priv} \n";
#    print "\t\tShow Directives:\n";
#    for $key ( @{  $self->{_showDirs} } ) {
#	$key->printMe();
#    } 
}


1;
