#!/bin/sh /usr/software/bin/perl 

#
#  Enum Class, derived version of type.
#
package Enum;
use SMF::Type;
use Random;
@ISA = ("Type");


use strict;

sub new {
    my $self = shift;
    
    # We now will pull off any params we need locally.  We will
    # blindly pass any others to our parent.
    my %params = (
		  @_
		  );
    my $values = $params{values};
    delete $params{values};
    $params{baseType} = "enum";
    
    # Call our parents constructor
    my $object = self->SUPER::new(%params);

    # Define the values being 
    # We may want to add error checks here to make sure that 
    # -values is an array.
    $object->{_values} = $values;

    bless $object, $self;

    return $object;
}

sub GetMin {
    my $self = shift;
    # Min will be the first enumerated item stored in member
    # _values.
    return $self->{_values}[0];
}

sub GetMax {
    my $self = shift;
    # Max will be the last enumerated item stored in member 
    # _values.
    my $length = scalar @{$self->{_values}};
    # Error check needs added here.
    return $self->{_values}[$length -1];
}


sub getValues {
    my $self = shift;
    return $self->{_values};
}



