#!/bin/sh /usr/software/bin/perl 

#
#  Numeric Class, derived version of type.
#
package Numeric;
use SMF::Type;
use Random;
@ISA = ("Type");


use strict;


sub new {
    my $self = shift;

    # We now will pull off any params we need locally.  We will
    # blindly pass any others to our parent.
    my %params = (
		  @_
		  );
    # Investigate if there is a simpler way to do this?
    my $min = $params{min};
    my $max = $params{max};
    delete $params{min};
    delete $params{max};    

    # define our type in the parameter hash
    $params{baseType} = "numeric";

    # Call our parents constructor.
    my $object = self->SUPER::new(%params);

    $object->{_min} = $min;
    $object->{_max} = $max;

    bless $object, $self;

    #And give the caller the reference to the blessed object
    return $object;

}

sub GetMin {
    my $self = shift;
    
    return $self->{_min};
}

sub GetMax {
    my $self = shift;
    
    return $self->{_max};
}


