#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/SMTP_Daemon.pm#1 $

#***********************************************************************
#
# NAME
#   SMTP_Daemon.pm -
#
# SYNOPSIS
#   A wrapper for Net::SMTP::Server which provides IPv6 support.
#
#
# AUTHOR
#   dl-cluster-qa
#
# HISTORY
# 9/16/2010 Initial version
#***********************************************************************

package SMTP_Daemon;

use strict;
use vars qw(@ISA);
use Net::SMTP::Server;
use IO::Socket::INET6;
use Data::Dumper;

@ISA=qw(Net::SMTP::Server);

sub new {
    my($class, @args) = @_;

    my $self;

    # I can't call SUPER on Net::SMTP::Server because it won't
    # return a reference to the object if it can't open the socket
    # which it might not be able to if we pass in a IPv6 address

    $self->{HOST} = $args[0];
    $self->{PORT} = $args[1];

    $self->{SOCK} = IO::Socket::INET6->new(Proto => 'tcp',
                                           LocalAddr => $self->{HOST},
                                           LocalPort => $self->{PORT},
                                           Listen    => SOMAXCONN,
                                           Reuse     => 1);

    bless( $self, $class );

    return defined($self->{SOCK}) ? $self : undef;
}

1;

