# $Id: //depot/prod/ontap/main/test/lib/SPARSE/Frameworks/BasicCIFS.pm# $
#
## @summary Basic CIFS sparse testing environment
#
# Define globals, import sparse libs, set up test environment.
#
#----------------------------------------------------------------------
## @author dl-sparseeng

BEGIN {
	use vars qw($CIFS_PASSWORD $CLIENT);

	# XXX DEFAULT WINDOWS CLIENT -- should really be CIFS_CLIENT
	# CLIENTS needs to have rshd running
	param("CLIENT", "-default", "sv-w2k752;hosttype=windows");
	logError("Client \"$CLIENT\" must be \"hosttype=windows\"")
		unless ($CLIENT =~ /hosttype=windows/);

	use SPARSE::Frameworks::Basic;

	logTrc("Testing for MinWin compatibility on $CLIENT");
	use TestEnv::MinWin qw(:all);
	logError("WINCLIENT $CLIENT is not minwin-compatible")
		unless minwin_compatible($CLIENT);

	logTrc("enable CIFS on $FILER_DST");
	setup_cifs($FILER_DST);

	if ($FILER_SRC ne $FILER_DST) {
		logTrc("enable CIFS on $FILER_SRC");
		setup_cifs($FILER_SRC);
	}
};

1;
