# $Id: //depot/prod/test/Rsierranevada/lib/SPARSE/Frameworks/Simple.pm#1 $
#
## @summary Basic sparse testing environment
#
# Define globals, import sparse libs, set up test environment.
# Set-up destination and source volume objects and establish a
# sparse relationship (based on SPARSE_TYPE).
#
## @author dl-sparseeng

#----------------------------------------------------------------------
package main;

require "SPARSE/Util/setupCommon.pl";
use vars qw($EXPLICIT_SETUP_ALLOWED);
param("EXPLICIT_SETUP_ALLOWED", "-default", 0);

#----------------------------------------------------------------------
package SPARSE::Frameworks::Simple;

use strict;
use Exporter;

use SPARSE::Resource::Filer;
use SPARSE::Resource::Volume;
use SPARSE::Util::Filer_Utils;
use SPARSE::Util::Logger;
use SPARSE::Util::FSTest0;
use SPARSE::Util::FileIO;
use SPARSE::Constants;

our @ISA = qw(Exporter);
our @EXPORT = qw($dvol $svol &do_not_complete_sparse_relation
		  &sparse_setup &sparse_cleanup &sparse_skip_cleanup);

our ($svol, $dvol);
our $complete_sparse_relation = DO_CLEANUP;
our $setup_started = 0;
&sparse_setup() unless (EXPLICIT_SETUP && $main::EXPLICIT_SETUP_ALLOWED);

sub sparse_setup() {
	return if ($setup_started);
	$setup_started = 1;
	($svol, $dvol) = &sparse_quick_common_setup();
}

sub do_not_complete_sparse_relation() {
	$complete_sparse_relation = 0;
}

sub sparse_skip_cleanup() {
	$complete_sparse_relation = 0;
}

sub sparse_cleanup() {
	if ($complete_sparse_relation && $setup_started) {
		sparse_complete_relation($dvol);
	}
	$setup_started = 0;
}

# Clean up and perform extra tests after the successful completion of
# the test case
END {
	&sparse_cleanup();
}

1;
