#$Id: //depot/prod/test/main/lib/SPARSE/cmode/AggrObject.pm#1 $
#
#Hey emacs, this is basically -*- perl -*-
#vim:filetype=perl
#
# Copyright (c) 2010 Network Appliance, Inc.
# All rights reserved.

## @summary	
##      Library which defines Aggr Object  
##      
## @description
##	Abstract common object tasks.
##
## @usage
##	use SPARSE::fcluster::AggrObject;
##
## @author mica@netapp.com

package SPARSE::cmode::AggrObject;

use strict;
use Tharn;
use filer;
use Data::Dumper;
use Params::Validate qw(validate SCALAR HASHREF ARRAYREF OBJECT UNDEF);

# Internal reference classes 
use SPARSE::cmode::NodeObject qw();
use SPARSE::cmode::VserverObject qw();
use SPARSE::cmode::VolumeObject qw();

#NACL libs
use NACL::APISet;
use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::APISet::Exceptions::RowNotFoundException qw(:try);
use NACL::APISet::Exceptions::CDEFNotFoundException qw(:try);
use NACL::APISet::Exceptions::MissingRequiredParamException qw(:try);
use NACL::APISet::Exceptions::InvalidParamValueException qw(:try);
use NACL::APISet::Exceptions::MethodNotFoundException qw(:try);
use NACL::APISet::Exceptions::UnsupportedOptionException qw(:try);

# ------------------------------------------------------------------------

use vars ('@ISA', '@EXPORT');
require Exporter;
@ISA	= qw(Exporter);
@EXPORT	= qw(
		&aggr
		);

# ------------------------------------------------------------------------

## Aggr class definition

## @name	::aggr
## @summary	create a 10mode aggr object
## @description
##	Create a 10Mode aggr object.
## @arg		node object to filer required
## @arg		aggrname required
## @arg		opts optional
## @return	aggr object
				
sub aggr(%)
{
    my %fparams = validate(
        @_,
        {
           node    => { type => HASHREF },
           opts    => { type => HASHREF },
        });

	my $node = $fparams{node};
    my $opts = $fparams{opts};

	my $aggr = {};
    my $properties = {};

	$aggr->{name} = $opts->{'name'};
	$aggr->{node} = $node;
    $aggr->{properties} = $properties;

	bless($aggr);

	return $aggr;
}

sub DESTROY($)
{
	my ($aggr) = @_;
	my $exc_state = $@;
	$aggr->{node}->{test}->nlog("destroying $aggr->{name} object");
	$@ = $exc_state;
}


1;


