#$Id: //depot/prod/test/main/lib/SPARSE/cmode/CommonParams.pm#1 $
#
#Hey emacs, this is basically -*- perl -*-
#vim:filetype=perl
#
# Copyright (c) 2010 Network Appliance, Inc.
# All rights reserved.
#
## @summary	
##      Library which defines the common params and their default 
##      values.
##
## @description
##	Common params and their default values.
##
## @usage
##	use SPARSE::cmode::CommonParams;
##
## @author mica@netapp.com

package SPARSE::cmode::CommonParams;

use strict;

#
# The following package declaration is required for these variables
# to be declared global in the main name space. It was done this
# way because 'use vars' doesn't support package names in the
# variable name, ex: $main::variable. Neither does the 'our'
# statement.

package main;

# Please keep the list in alphabetic order
use vars qw(
	    $AGGR_SIZE
            $CIFS_DOMAIN
            $CIFS_DOMAIN_ADMIN
            $CIFS_DOMAIN_ADMIN_PASSWD
	    $CIFS_DRIVE
	    $CIFS_PASSWD
	    $CIFS_SHARE
	    $CIFS_USER
	    $CLEANUP
	    $CLIENT
	    $CMDTIMEOUT
	    $EXTERN_SETUP
	    $FILER_MODE
	    $FILER
	    $FILERA
	    $FILERB
	    $FILER_AGGR
	    $FILER_CONN
	    $FILER_IP
	    $FILER_QTREE
	    $FILER_VOL
	    $FILER_VOL_MNT
	    $MOUNTPOINT
	    $NBLADE_START
	    $NBLADE_HOST
	    $NBLADE_DIR
            $NFS_V4_DELEGATIONS
            $NFS_V4_ID_DOMAIN
            $NIS_DOMAIN
            $NIS_DOMAIN_SERVER
	    $ONTAPDIR
	    $PFILER
	    $TIMEOUT
	    $VOL_SIZE
	    $TRAD_SIZE
	    $FLEX_SIZE
	    $VOL_TYPE
	    $RAID_TYPE
	    $MOUNT_VERS
	    $CONTAINER
	    $SETUP_DONE
	    $WORM_VOL
	    $WORM_AGGR
	    $WORM_RETENTION
	    $WAFLIRON_TIMEOUT
	    $SKIP_SNAPLOCK_RETENTION_SETUP
	    $SLCC_STRICT
            $ADDR_TYPE
	    $VOL_GX_TYPE
	    $FILER_GX_VOL
	    $FILER_GX_AGGR
	    $AGGR_GX_TYPE
	    $VSERVER_GX_NAME
	    $EXPORT_GX_POL
	   );

# Change the name space back
package SPARSE::cmode::CommonParams;

use Tharn;
# param sets up the variables in main's name space
param('CLEANUP',         '-default', 'test');
param('CLIENT',          '-default', 'localhost');
param('SETUP_DONE',      '-default', 'reuse');
param('TIMEOUT',         '-default', 600);
param('NUM_VSERVERS',    '-default', '1');

param('VSERVER1_NAME',   '-default', 'vs1');
param('VSERVER1_DLIF',   '-default', 'vs1_dlif1');
param('VSERVER1_DATA_IP','-default', '1.1.1.1');
param('VSERVER2_NAME',   '-default', 'vs2');
param('VSERVER2_DLIF',   '-default', 'vs2_dlif1');
param('VSERVER2_DATA_IP','-default', '2.2.1.1');

param('NODE1_DATAAGGR',      '-default', 'testaggr37');
param('NODE1_DATAAGGR_DISKS','-default', '3');
param('NODE2_DATAAGGR',      '-default', 'testaggr38');
param('NODE2_DATAAGGR_DISKS','-default', '3');
param('NODE3_DATAAGGR',      '-default', 'testaggr37_3');
param('NODE3_DATAAGGR_DISKS','-default', '3');
param('NODE4_DATAAGGR',      '-default', 'testaggr37_4');
param('NODE4_DATAAGGR_DISKS','-default', '3');

1;

