#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/ontap/main/test/lib/SPARSE/Constants.pm# $
#
# Copyright (c) 2002 Network Appliance, Inc.
# All rights reserved.

## @summary	Library that defines sparse constants
## @description
##	This package defines generic SPARSE constants
##
## @usage
##	use SPARSE::Constants;
##
## @author dl-sparseeng
# ------------------------------------------------------------------------
package SPARSE::Constants;
use strict;

use constant DFLT_AGGR		=> $ENV{DFLT_AGGR} || "testaggr"; 
use constant DFLT_RAID_TYPE	=> $ENV{DFLT_RAID_TYPE} || "raid_dp";
use constant DFLT_AGGR_SIZE     => $ENV{DFLT_AGGR_SIZE} || "3"; #disks
use constant MIN_AGGR_SIZE      => "51200"; #kbytes
use constant DFLT_VOL_SIZE	=> "3g";
use constant DFLT_STDSRC_SIZE	=> "10g";
use constant DFLT_TEST_DIR	=> "TEST";
use constant DFLT_ARC_VOL	=> "ArcVol";
use constant DFLT_STDSRC_VOL	=> "stdSrcVol";
use constant DFLT_MODSRC_VOL	=> "modSrcVol";
use constant DFLT_SVOL		=> $ENV{FILER_VOL} || "GearsVolSrc";
use constant DFLT_DVOL		=> $ENV{CACHE_VOL} || "GearsVolDst";
use constant DFLT_SVOL_TYPE	=> $ENV{DFLT_SVOL_TYPE} || "flex";
use constant PRIVSETTEST	=> "priv -level test;";
use constant PRIVSETADVANCED	=> "priv -level advanced;";
use constant PRIVSETDIAG	=> "priv -level diag;";
use constant CMDTIMEOUT		=> $ENV{CMDTIMEOUT} ||"300";
use constant DFLT_FILER_CONN	=> "#rsh";
use constant BLOCKSIZE		=> "4096";
use constant DFLT_VFILER	=> "vfiler1";
use constant DFLT_VFILER_ROOT	=> "vfroot";
use constant VFILER_TESTING	=> $ENV{VFILER_TESTING} || 0;
use constant DO_CLEANUP		=> $ENV{DO_CLEANUP} || 1;
use constant EXPLICIT_SETUP => $ENV{EXPLICIT_SETUP} || 0;

# derived from NRV heartbeat timeout =
#                       NRV_HEARTBEAT_TIMEOUT + NRV_HEARTBEAT_INTERVAL
use constant NRV_TIMEOUT	=> "16";
use constant NRV_PORT		=> "2050";

# from common/sparse/sparse_rsmgmt.c - same as RM_TIMEOUT
use constant RM_TIMEOUT		=> "25";

# mica - 10Mode source volume , if present take val or else 0
use constant SRC_10MODE     => $ENV{SRC_10MODE} || 0; 
use constant FILER10M_AGGR => $ENV{FILER10M_AGGR} || "testaggr";
use constant VSERVER_ROOTAGGR => $ENV{VSERVER_ROOTAGGR} || "aggr0";
use constant VSERVER_NAME => $ENV{VSERVER_NAME} || "pfs_vs1";
use constant VSERVER_ROOTVOL => $ENV{VSERVER_ROOTVOL} || "pfs_vs1_rootvol";
use constant VSERVER_ROOTVOLUME_SECURITY_STYLE => $ENV{VSERVER_ROOTVOLUME_SECURITY_STYLE} || "mixed"; 
use constant VSERVER_DLIF => $ENV{VSERVER_DLIF} || "dlif1";
use constant VSERVER_DATAPORT => $ENV{VSERVER_DATAPORT} || "e0d";
use constant VSERVER_DATAIP => $ENV{VSERVER_DATAIP} || "10.72.234.61";
use constant VSERVER_DATAMASK => $ENV{VSERVER_DATAMASk} || "255.255.255.128";
use constant VSERVER_AGGR_TYPE => $ENV{VSERVER_AGGR_TYPE} || "flex";
use constant VSERVER_AGGR_DISKS => $ENV{VSERVER_AGGR_DISKS} || "3";

use vars ('@ISA', '@EXPORT');
require Exporter;
@ISA    = qw(Exporter);
@EXPORT = qw(
	    DFLT_STDSRC_SIZE
	    DFLT_ARC_VOL DFLT_STDSRC_VOL DFLT_MODSRC_VOL
            DFLT_AGGR DFLT_AGGR_SIZE MIN_AGGR_SIZE DFLT_VOL_SIZE 
	    DFLT_TEST_DIR PRIVSETTEST DFLT_RAID_TYPE
	    PRIVSETADVANCED PRIVSETDIAG CMDTIMEOUT DFLT_FILER_CONN
	    NRV_TIMEOUT NRV_PORT RM_TIMEOUT BLOCKSIZE
	    DFLT_SVOL DFLT_DVOL DFLT_SVOL_TYPE DFLT_VFILER
	    DFLT_VFILER_ROOT VFILER_TESTING DO_VERSION_CHECK
            DO_CLEANUP EXPLICIT_SETUP SRC_10MODE
	  );

# ------------------------------------------------------------------------

1;
