# $Id: //depot/prod/test/main/lib/SPARSE/Frameworks/SimplePerf.pm#1 $
#
## @summary Basic performance testing environment
#
## @author dl-sparseeng

#----------------------------------------------------------------------
package main;

use vars qw($FILER_DST $FILER_SRC $ONTAPDIR $SPARSE_TYPE);
param("ONTAPDIR", "-default", "/rlse/mainN");
param("FILER_DST", "-mesg", "Primary Filer");
param("FILER", "-default", $FILER_DST);
param("FILER_SRC", "-default", $FILER);
param("SPARSE_TYPE", "-mesg", "Required: 'rod_remote', 'rod_snapvault', or 'pfs'");

use SPARSE::Resource::Filer;
use SPARSE::Resource::Volume;
use SPARSE::Util::Filer_Utils;
use SPARSE::Util::Logger;
use SPARSE::Util::FSTest0;
use SPARSE::Util::FileIO;
use SPARSE::Util::Perf;

no strict qw(refs);
for (qw(FILER_DST FILER_SRC)) {
        @{$_} = split(/,/, ${$_});
        ${$_} = ${$_}[0];
}
if (logCond('trc')) {
        for my $var (qw(FILER_DST FILER_SRC)) {
                logTrc("$var=${$var}\n");
                for (1..$#{$var}) {
                        logTrc("$var\[$_]=${$var}[$_]\n");
                }
        }
}

#----------------------------------------------------------------------
package SPARSE::Frameworks::SimplePerf;

use strict;
use Exporter;

use SPARSE::Resource::Filer;
use SPARSE::Resource::Volume;
use SPARSE::Util::Filer_Utils;
use SPARSE::Util::Logger;
use SPARSE::Util::FSTest0;
use SPARSE::Util::FileIO;
use SPARSE::Util::Perf;

our @ISA = qw(Exporter);
our @EXPORT = qw($dvol $svol $perf &PerfFiles);

our $filename = "testfile";
our $filesize = 16 * 1024 * 1024;

# XXX: PFS only until we combine volume setup with pre-pop
logError("SimplePerf only supports PFS for now") if $main::SPARSE_TYPE ne "pfs";

our ($svol, $dvol) = sparse_quick_common_setup($main::SPARSE_TYPE,
	$main::FILER_SRC, "vvolSrc_$main::SPARSE_TYPE",
	$main::FILER_DST, "vvolDst_$main::SPARSE_TYPE");

our $perf = PerfCreate();

$perf->monitor_filer($dvol->{filer});
if ($dvol->{filer} != $svol->{filer}) {
	$perf->monitor_filer($svol->{filer});
}

sub _create_fileset {
	logStep("creating new src fileset");

	my $f = fioOpen($svol, "testfile", "+>");

	for (0..($filesize/4096)) {
		$f->WriteSeq(4096);
	}
}

&_create_fileset;

sub PerfFiles {
	my ($dvol) = @_;
	return (fioOpen($dvol, $filename));
}

1;
