#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/main/lib/SPARSE/Tests.pm#1 $
#
# Copyright (c) 2002 Network Appliance, Inc.
# All rights reserved.

## @summary	Library that defines sparse tests
## @description
##	This package defines generic SPARSE tests
##
## @usage
##	use SPARSE::Tests;
##
## @author dl-sparseeng

# This file defines all the sparse tests that we have
# MAKING CHANGES TO THE NIGHTLY PFS SECTION DOES NOT CHANGE NIGHTLIES!
# Please add any changes to nightly tests here and in 
# /x/eng/testbeds/pfs/svl_pfs_hw01/plans/pfs_nfs_hw.plan
# /x/eng/testbeds/pfs/svl_pfs_hw01/plans/pfs_non_nfs_hw.plan

package SPARSE::Tests;
use strict;
my @pfs_nfs = (
				"pfs/NFS/GETATTR/get_attr_eaccess",
				"pfs/NFS/GETATTR/get_attr_eperm",
				"pfs/NFS/GETATTR/get_attr_estale",
				"pfs/NFS/GETATTR/get_attr_hit",
				"pfs/NFS/GETATTR/get_attr_miss",
				"pfs/NFS/SETATTR/set_attr_eperm",
				"pfs/NFS/SETATTR/set_attr_erofs",
				"pfs/NFS/SETATTR/set_attr_mode_origin",
				"pfs/NFS/SETATTR/set_attr_size_origin",
				"pfs/NFS/SETATTR/set_attr_time_origin",
				"pfs/NFS/SETATTR/set_attr_toss",
				"pfs/NFS/SETATTR/set_attr_uid_gid_origin",
				"pfs/NFS/MKDIR/mkdir_attrs_fh_client",
				"pfs/NFS/MKDIR/mkdir_eaccess",
				"pfs/NFS/MKDIR/mkdir_eexist",
				"pfs/NFS/MKDIR/mkdir_erofs",
				"pfs/NFS/MKDIR/mkdir_fill",
				"pfs/NFS/MKDIR/mkdir_toss",
				"pfs/NFS/RMDIR/rmdir_attrs_fh_client",
			        "pfs/NFS/RMDIR/rmdir_eaccess",
				"pfs/NFS/RMDIR/rmdir_enoent",
				"pfs/NFS/RMDIR/rmdir_erofs",
				"pfs/NFS/RMDIR/rmdir_toss",
				"pfs/NFS/SYMLINK/symlink_data_attrs_origin",
				"pfs/NFS/SYMLINK/symlink_eacces",
				"pfs/NFS/SYMLINK/symlink_erofs",
				"pfs/NFS/SYMLINK/symlink_toss",
				"pfs/NFS/SYMLINK/symlink_data_attrs_proxy",
				"pfs/NFS/SYMLINK/symlink_eexist",
				"pfs/NFS/SYMLINK/symlink_fill",
				"pfs/NFS/CREATE/create_eacces",
				"pfs/NFS/CREATE/create_erofs",
				"pfs/NFS/CREATE/create_origin",
				"pfs/NFS/CREATE/create_toss",
				"pfs/NFS/CREATE/create_eexist",
				"pfs/NFS/CREATE/create_fill",
				"pfs/NFS/CREATE/create_proxy",
				"pfs/NFS/LINK/link_delegation",
				"pfs/NFS/LINK/link_eacces",
				"pfs/NFS/LINK/link_erofs",
				"pfs/NFS/LINK/link_proxy",
				"pfs/NFS/LINK/link_toss",
				"pfs/NFS/LINK/link_eexist",
				"pfs/NFS/LINK/link_fill",
				"pfs/NFS/LINK/link_server",
				"pfs/NFS/REMOVE/rmv_eacces",
				"pfs/NFS/REMOVE/rmv_enoent",
				"pfs/NFS/REMOVE/rmv_erofs",
				"pfs/NFS/REMOVE/rmv_origin",
				"pfs/NFS/REMOVE/rmv_proxy",
				"pfs/NFS/REMOVE/rmv_toss",
				"pfs/NFS/RENAME/rename_eacces",
				"pfs/NFS/RENAME/rename_enoent",
				"pfs/NFS/RENAME/rename_erofs",
				"pfs/NFS/RENAME/rename_file_attrs",
				"pfs/NFS/RENAME/rename_fill",
				"pfs/NFS/RENAME/rename_origin",
				"pfs/NFS/RENAME/rename_proxy",
				"pfs/NFS/RENAME/rename_toss",	
				"pfs/NFS/MKNOD/mknod_eacces",
				"pfs/NFS/MKNOD/mknod_erofs",
				"pfs/NFS/MKNOD/mknod_origin",
				"pfs/NFS/MKNOD/mknod_toss",
				"pfs/NFS/MKNOD/mknod_eexist",
				"pfs/NFS/MKNOD/mknod_fill",
				"pfs/NFS/MKNOD/mknod_proxy",
	       			"pfs/NFS/WRITE/write_store",
	       			"pfs/NFS/WRITE/write_unverify",
				"pfs/NFS/READ/read_verify",
				"pfs/NFS/READ/read_noverify",
				"pfs/NFS/READLINK/readlink_verify",
				"pfs/NFS/READLINK/readlink_noverify",
				"pfs/NFS/LOOKUP/lookup_verify",
				"pfs/NFS/LOOKUP/lookup_noverify",
				"pfs/NFS/READDIR/readdir_miss_verify",
				"pfs/NFS/READDIRPLUS/readdirplus_miss_verify",
				"pfs/NFS/misc_tests/forward"
);

our %categories = (
		rod_ui			=> [
				"rod/ui/abort/pause",
				"rod/ui/abort/abandon",
				"rod/ui/start/access",
				"rod/ui/start/sv_enable",
				"rod/ui/status/log_status",
				"rod/ui/general/dr_license",
				"rod/ui/general/snapshot",
				"rod/ui/general/sv_restore",
				"rod/ui/throttle/speed",
		],

		rod_restore		=> [
				"rod/restore/compare",
				"rod/restore/del_snapshot",
				"rod/restore/multiple",
				"rod/restore/network",
				"rod/restore/offline",
				"rod/restore/reboot",
				"rod/restore/rename",
				"rod/restore/restrict",
				"rod/restore/snapshot",
		],

		rod_reserve		=> [
				"rod/reserve/file",
				"rod/reserve/full_dst",
				"rod/reserve/full_src",
		],

		rod_wack	        => [
				"rod/wack/wack_dir",
				"rod/wack/wack_done",
				"rod/wack/wack_file",
				"rod/wack/wack_init",
				"rod/wack/wack_inode",
				"rod/wack/wack_nlinks",
		],

		rod_wafliron        	=> [
				#"rod/wafliron/online/after_init",
				#"rod/wafliron/online/restore_inode",
				"rod/wafliron/online/restore_dir",
				"rod/wafliron/online/restore_done",
				"rod/wafliron/online/restore_file",
		],

		common			=> [
				"common/files/general",
				"common/files/grow",
				"common/files/truncate",
				"common/files/slowmode",
				"common/files/readfill_writealloc",
				"common/files/overwrite",
				"common/dirs/general",
		],

		pfs_admin		=> [
				"pfs/admin/dst_size",
				"pfs/admin/eject",
				"pfs/admin/fstat01",
				"pfs/admin/fstat02",
				"pfs/admin/fstat03",
				"pfs/admin/license",
				"pfs/admin/license_server",
				"pfs/admin/map_to_caching_vol",
				"pfs/admin/options",
				"pfs/admin/pfs_status",
				"pfs/admin/stats",
		],

		pfs_nfs			=> [
				@pfs_nfs
		],

		pfs_cons		=> [
				"pfs/consistency/acdirmax",
				"pfs/consistency/acdirmax_actimeo",
				"pfs/consistency/acregmax",
				"pfs/consistency/acregmax_actimeo",
				"pfs/consistency/acsymmax",
				"pfs/consistency/acsymmax_actimeo",
				"pfs/consistency/actimeo",
		],

		pfs_snap		=> [
				"pfs/snapshots/snap_cmds",
				"pfs/snapshots/snap_dir1",
				"pfs/snapshots/snap_dir2",
				"pfs/snapshots/snap_dir3",
				"pfs/snapshots/snap_mod_ops",
				"pfs/snapshots/snap_nonmod_ops",
				"pfs/snapshots/snap_restore_vol",
				"pfs/snapshots/snap_restore_file",
		],

		pfs_nlm			=> [
				"pfs/nlm/auto/connectathon2003",
		],

		pfs_other		=> [
				"pfs/misc_tests/map0",
				"pfs/misc_tests/map1",
				"pfs/misc_tests/ezls",
				"pfs/misc_tests/rquota",
				"pfs/misc_tests/ddcheck",
				"pfs/misc_tests/chmodcheck",
				"pfs/misc_tests/lookup",
		],
);

our %test_suite = (
		rod_smoke		=> [
				"rod/misc_tests/basic_restore",
				#"rod/restore/offline",
				"rod/ui/abort/abandon",
				"rod/ui/abort/pause",
				"rod/integration/quotas/quota",
				"rod/wafliron/online/restore_done",
		],

		rod_nightly		=> [
				"rod/misc_tests/basic_restore",
				#"rod/restore/offline",
				#"rod/backup/sv_during_rod",
				#"rod/backup/sv_after_rod",
				"rod/ui/abort/pause",
				"rod/ui/abort/abandon",
				"rod/ui/start/access",
				"rod/ui/start/sv_enable",
				"rod/ui/general/rod_license",
				"rod/ui/general/snapshot",
				"rod/ui/general/sv_client_license",
				"rod/ui/status/vol_status",
				"rod/ui/throttle/speed",
				"rod/integration/quotas/quota",
				#"rod/wafliron/online/after_init",
				#"rod/wafliron/online/restore_inode",
				"rod/wafliron/online/restore_dir",
				"rod/wafliron/online/restore_file",
				"rod/wafliron/online/restore_done",
		],

		pfs_smoke		=> [
				"pfs/misc_tests/map0",
				"pfs/misc_tests/map1",
				"pfs/misc_tests/ezls",
				"pfs/misc_tests/rquota",
				"pfs/nlm/auto/connectathon2003",
				"pfs/NFS/misc_tests/forward",
				"pfs/admin/stats",
		],

		pfs_regression		=> [
				"pfs/misc_tests/chmodcheck",
				"pfs/misc_tests/ddcheck",
				"pfs/misc_tests/lookup",
				"pfs/consistency/actimeo",
				"pfs/storage/truncator_basic",
#				"pfs/storage/storage1",
		],

		pfs_nightly		=> [
				"pfs/misc_tests/map0",
				"pfs/misc_tests/map1",
				"pfs/misc_tests/ezls",
				"pfs/misc_tests/rquota",
				"pfs/misc_tests/ddcheck",
				"pfs/misc_tests/chmodcheck",
				"pfs/misc_tests/lookup",
				"pfs/misc_tests/nvfail",
				"pfs/admin/dst_size",
				"pfs/admin/eject",
				"pfs/admin/fstat01",
				"pfs/admin/fstat02",
				"pfs/admin/fstat03",
				"pfs/admin/license",
				"pfs/admin/license_server",
				"pfs/admin/map_to_caching_vol",
				"pfs/admin/options",
				"pfs/admin/pfs_status",
				"pfs/admin/stats",
				"pfs/fill/eoffline",
				"pfs/fill/estale",
				"pfs/fill/level_0_fill",
				"pfs/fill/level_1_fill",
				"pfs/fill/sparse_unalloc",
				@pfs_nfs,
				"pfs/snapshots/snap_cmds",
				"pfs/snapshots/snap_dir1",
				"pfs/snapshots/snap_dir2",
				"pfs/snapshots/snap_dir3",
				"pfs/snapshots/snap_mod_ops",
				"pfs/snapshots/snap_nonmod_ops",
				"pfs/snapshots/snap_restore_vol",
				"pfs/snapshots/snap_restore_file",
				"pfs/consistency/acdirmax",
				"pfs/consistency/acdirmax_actimeo",
				"pfs/consistency/acregmax",
				"pfs/consistency/acregmax_actimeo",
				"pfs/consistency/acsymmax",
				"pfs/consistency/acsymmax_actimeo",
				"pfs/consistency/actimeo",
				"pfs/nlm/auto/connectathon2003",
				"pfs/storage/truncator_basic",
#				"pfs/storage/storage1",
		],

);

our %exclusions = (
		# remove tests that keep other pfs/rod volumes from working
		jwag		=> [
				"rod/restore/reboot",
				"rod/ui/general/dr_license",
				"pfs/admin/license",
				"pfs/admin/license_server",
		],
);

use vars ('@ISA', '@EXPORT');
require Exporter;
our @ISA    = qw(Exporter);
our @EXPORT = qw( %categories %test_suite %exclusions);

# ------------------------------------------------------------------------

1;

