## Routines for the manipulation of NFS export policies
##
## @author      dascenj@netapp.com
##
## @pod here

=head1 NAME

    SSQA::Cmode::ExportPolicyRule - manipulates export policy rules

=head1 SYNOPSIS

    Routines for manipulation of NFS export policy rules

=head1 DESCRIPTION

    This library is based on NACL, and requires a NACL node object to be
    supplied. (See NACL docs for more information). This is a central
    place to store routines that interact with NFS export policy rules

=head1 TODO

    I don't know, it is already pretty awesome.

=head1 BUGS

    Some probably exist but have not been listed yet.

=head1 STATUS

  Shared

=head1 AUTHOR

  Jd (dascenj@netapp.com)

=head1 COPYRIGHT

Copyright 2010, Network Appliance., All Rights Reserved


=cut

package SSQA::CMode::ExportPolicyRule;

use strict;
use warnings;

use NATE::BaseException qw(:try);
use Data::Dumper;
use Tharn qw($Log config_result);

=head2 generate_random 

    Creates a new rule with a random string in 
    the clientmatch field. Returns a hash ref of 
    all the fields required to successfully create 
    a rule using the NACL libraries.

=cut


sub generate_random {
    my (%params) = @_;

    require String::Random;
    my $RS = new String::Random;
    if (! $RS) { 
        $Log->warn("Failed to created random policy name.");
    }

    my @any = ("any");   
    my $rule = {ruleindex     => undef,
                vserver       => undef,
                exportRuleSet => undef,
                anon          => 0,
                protocol      => \@any,
                clientmatch => $RS->randregex('[a-z][a-z][a-z][a-z][a-z][a-z]'),
                rorule      => \@any,
                rwrule      => \@any,
                superuser   => \@any,};

    return ($rule);
}

1;
