# -*- perl -*-
# $Id: //depot/prod/test/main/lib/San/Application/Lunconstant.pm
#
# Copyright (c) 2010 NetApp, Inc.
# All rights reserved.
#
##
## @summary constant definitions for igroup (cmode) testing
## @author SAN QA (c-dl-ssan-test@netapp.com)
## @status public
package San::Application::Lunconstant;

use strict;
require Exporter;
use Readonly;

our @ISA    = qw(Exporter);
our @EXPORT = qw(
    $SUPPORTED_OSTYPES
    $LUN_ATTR_OBJ
    $LUN_ATTR_NAME
    $LUN_ATTR_QTREE
    $LUN_ATTR_PATH
    $LUN_ATTR_OSTYPE
    $LUN_ATTR_VSERVER
    $LUN_ATTR_VOLUME
    $LUN_ATTR_SIZE
    $LUN_ATTR_BLOCK_SIZE
    $LUN_ATTR_READ_ONLY
    $LUN_ATTR_SIZE_USED
    $LUN_ATTR_COMMENT
    $LUN_ATTR_DEVICE_TEXT_ID
    $LUN_ATTR_DEVICE_BINARY_ID
    $LUN_ATTR_DEVICE_LEGACY_ID
    $LUN_ATTR_SPACE_RESV
    $LUN_ATTR_SPACE_RESV_HONORED
    $LUN_ATTR_SPACE_ALLOC
    $LUN_ATTR_EMPTY
    $LUN_ATTR_ROOT_QTREE
    $LUN_ATTR_SPACE_RESV_ENABLE
    $LUN_ATTR_SPACE_RESV_DISABLE
    $LUN_ATTR_SPACE_RESV_HONORED_TRUE
    $LUN_ATTR_SPACE_RESV_HONORED_FALSE
    $LUN_ATTR_SPACE_ALLOC_ENABLE
    $LUN_ATTR_SPACE_ALLOC_DISABLE
    $LUN_ATTR_SUFFIX_SIZE
    $LUN_ATTR_PREFIX_SIZE
    $LUN_ATTR_STATE
    $LUN_ATTR_MAPPED
    $LUN_ATTR_SPACE_RESV_TRUE
    $LUN_ATTR_SPACE_RESV_FALSE
    $LUN_ATTR_STATE_ONLINE
    $LUN_ATTR_STATE_OFFLINE
    $LUN_ATTR_MAPPED_MAPPED
    $LUN_ATTR_MAPPED_UNMAPPED
    $LUN_ATTR_EXTENT_SIZE
    $LUN_ATTR_STATE
    $LUN_ATTR_MAPPED
    $LUN_ATTR_SERIAL
    $LUN_ATTR_READ_ONLY
    $LUN_ATTR_CREATION_TIME
    $LUN_ATTR_UUID
    $LUN_ATTR_VDISK_ID
    $LUN_ATTR_NVFAIL
    $LUN_ATTR_INCONSIST_FILE_SYS
    $LUN_ATTR_INCONSIST_FILE_SYS_TRUE
    $LUN_ATTR_INCONSIST_FILE_SYS_FALSE
    $LUN_ATTR_INCONSIST_BLOCKS
    $LUN_ATTR_INCONSIST_BLOCKS_TRUE
    $LUN_ATTR_INCONSIST_BLOCKS_FALSE
    $LUN_ATTR_READ_ONLY_FALSE
    $LUN_ATTR_NVFAIL_FALSE
    $LUN_ATTR_ALIGNMENT
    $LUN_ATTR_ALIGNMENT_INDETERMINATE
    $LUN_ATTR_RESTORE_INACCESSIBLE
    $LUN_ATTR_RESTORE_INACCESSIBLE_TRUE
    $LUN_ATTR_RESTORE_INACCESSIBLE_FALSE
    $LUN_ATTR_MAX_RESIZE_SIZE
    $LUN_ATTR_CLASS
    $LUN_ATTR_IS_CLONE
    $LUN_ATTR_IS_CLONE_TRUE
    $LUN_ATTR_IS_CLONE_FALSE
    $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED
    $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED_TRUE
    $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED_FALSE
    $LUN_ATTR_HAS_METADATA_PROVISIONED
    $LUN_ATTR_HAS_METADATA_PROVISIONED_TRUE
    $LUN_ATTR_HAS_METADATA_PROVISIONED_FALSE
    $LUN_ATTR_QOS_POLICY_GROUP
    $LUN_ATTR_EXTERNAL_CACHE
    @LunAttrsInherited
    @LunAttrsNonInherited
    %LunAttrsNonInheritedDefault
);

Readonly our $SUPPORTED_OSTYPES  => 'vmware:hyper_v:windows:windows_2008:windows_gpt:linux:xen:solaris:solaris_efi:hpux:aix:netware:openvms';

# lun object definitions
Readonly our $LUN_ATTR_OBJ => 'lun_obj';

# lun attributes definitions
Readonly our $LUN_ATTR_NAME               => 'lun';
Readonly our $LUN_ATTR_QTREE              => 'qtree';
Readonly our $LUN_ATTR_PATH               => 'path';
Readonly our $LUN_ATTR_OSTYPE             => 'ostype';
Readonly our $LUN_ATTR_VSERVER            => 'vserver';
Readonly our $LUN_ATTR_VOLUME             => 'volume';
Readonly our $LUN_ATTR_SIZE               => 'size';
Readonly our $LUN_ATTR_BLOCK_SIZE         => 'block_size';
Readonly our $LUN_ATTR_READ_ONLY          => 'read_only';
Readonly our $LUN_ATTR_SIZE_USED          => 'size_used';
Readonly our $LUN_ATTR_COMMENT            => 'comment';
Readonly our $LUN_ATTR_DEVICE_TEXT_ID     => 'device_text_id';
Readonly our $LUN_ATTR_DEVICE_BINARY_ID   => 'device_binary_id';
Readonly our $LUN_ATTR_DEVICE_LEGACY_ID   => 'device_legacy_id';
Readonly our $LUN_ATTR_SPACE_RESV         => 'space_reserve';
Readonly our $LUN_ATTR_SPACE_RESV_HONORED => 'space_reserve_honored';
Readonly our $LUN_ATTR_SPACE_ALLOC        => 'space_allocation';
Readonly our $LUN_ATTR_PREFIX_SIZE        => 'prefix_size';
Readonly our $LUN_ATTR_SUFFIX_SIZE        => 'suffix_size';
Readonly our $LUN_ATTR_EXTENT_SIZE        => 'extent_size';
Readonly our $LUN_ATTR_STATE              => 'state';
Readonly our $LUN_ATTR_MAPPED             => 'mapped';
Readonly our $LUN_ATTR_SERIAL             => 'serial';
Readonly our $LUN_ATTR_UUID               => 'uuid';
Readonly our $LUN_ATTR_VDISK_ID           => 'vdiskId';
Readonly our $LUN_ATTR_NVFAIL             => 'nvfail';
Readonly our $LUN_ATTR_INCONSIST_FILE_SYS => 'inconsistent_filesystem';
Readonly our $LUN_ATTR_INCONSIST_BLOCKS   => 'inconsistent_blocks';
Readonly our $LUN_ATTR_CREATION_TIME      => 'creation_timestamp';
Readonly our $LUN_ATTR_ALIGNMENT          => 'alignment';
Readonly our $LUN_ATTR_RESTORE_INACCESSIBLE  => 'restore_inaccessible';
Readonly our $LUN_ATTR_MAX_RESIZE_SIZE    => 'max_resize_size';
Readonly our $LUN_ATTR_CLASS              => 'class';   
Readonly our $LUN_ATTR_IS_CLONE           => 'is_clone';
Readonly our $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED => 'is_clone_autodelete_enabled';
Readonly our $LUN_ATTR_HAS_METADATA_PROVISIONED    => 'has_metadata_provisioned';
Readonly our $LUN_ATTR_QOS_POLICY_GROUP   => 'qos_policy_group';
Readonly our $LUN_ATTR_EXTERNAL_CACHE     => 'external_cache';

# lun attributes (value) definitions
Readonly our $LUN_ATTR_ROOT_QTREE               => '""';
Readonly our $LUN_ATTR_EMPTY                    => "-";
Readonly our $LUN_ATTR_SPACE_RESV_ENABLE        => 'enabled';
Readonly our $LUN_ATTR_SPACE_RESV_DISABLE       => 'disabled';
Readonly our $LUN_ATTR_SPACE_RESV_HONORED_TRUE  => 'true';
Readonly our $LUN_ATTR_SPACE_RESV_HONORED_FALSE => 'false';
Readonly our $LUN_ATTR_SPACE_ALLOC_ENABLE       => 'enabled';
Readonly our $LUN_ATTR_SPACE_ALLOC_DISABLE      => 'disabled';
Readonly our $LUN_ATTR_STATE_ONLINE             => 'online';
Readonly our $LUN_ATTR_STATE_OFFLINE            => 'offline';
Readonly our $LUN_ATTR_MAPPED_MAPPED            => 'mapped';
Readonly our $LUN_ATTR_MAPPED_UNMAPPED          => 'unmapped';
Readonly our $LUN_ATTR_READ_ONLY_FALSE          => 'false';
Readonly our $LUN_ATTR_NVFAIL_FALSE             => 'false';
Readonly our $LUN_ATTR_ALIGNMENT_INDETERMINATE  => 'indeterminate';
Readonly our $LUN_ATTR_RESTORE_INACCESSIBLE_TRUE  => 'true';
Readonly our $LUN_ATTR_RESTORE_INACCESSIBLE_FALSE => 'false';
Readonly our $LUN_ATTR_IS_CLONE_TRUE              => 'true';
Readonly our $LUN_ATTR_IS_CLONE_FALSE             => 'false';
Readonly our $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED_TRUE  => 'true';
Readonly our $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED_FALSE => 'false';
Readonly our $LUN_ATTR_HAS_METADATA_PROVISIONED_TRUE     => 'true';
Readonly our $LUN_ATTR_HAS_METADATA_PROVISIONED_FALSE    => 'false';
Readonly our $LUN_ATTR_INCONSIST_FILE_SYS_TRUE  => 'true'; 
Readonly our $LUN_ATTR_INCONSIST_FILE_SYS_FALSE  => 'false'; 
Readonly our $LUN_ATTR_INCONSIST_BLOCKS_TRUE    => 'true';
Readonly our $LUN_ATTR_INCONSIST_BLOCKS_FALSE   => 'false';

Readonly our @LunAttrsInherited => (
    $LUN_ATTR_OSTYPE,      $LUN_ATTR_VSERVER,    $LUN_ATTR_VOLUME,
    $LUN_ATTR_SIZE,        $LUN_ATTR_BLOCK_SIZE, $LUN_ATTR_READ_ONLY,
    $LUN_ATTR_SIZE_USED,   $LUN_ATTR_COMMENT,    $LUN_ATTR_PREFIX_SIZE,
    $LUN_ATTR_SUFFIX_SIZE, $LUN_ATTR_SPACE_RESV
);

Readonly our @LunAttrsNonInherited => (
    $LUN_ATTR_DEVICE_TEXT_ID, $LUN_ATTR_DEVICE_BINARY_ID,
    $LUN_ATTR_DEVICE_LEGACY_ID,
    $LUN_ATTR_SPACE_RESV_HONORED, $LUN_ATTR_SPACE_ALLOC,
    $LUN_ATTR_RESTORE_INACCESSIBLE, $LUN_ATTR_MAX_RESIZE_SIZE,
    $LUN_ATTR_CLASS, $LUN_ATTR_IS_CLONE,
    $LUN_ATTR_IS_CLONE_AUTODELETE_ENABLED,
    $LUN_ATTR_HAS_METADATA_PROVISIONED,
    $LUN_ATTR_QOS_POLICY_GROUP,
    $LUN_ATTR_EXTERNAL_CACHE,
    $LUN_ATTR_ALIGNMENT

);

Readonly our %LunAttrsNonInheritedDefault => (
    $LUN_ATTR_DEVICE_TEXT_ID     => $LUN_ATTR_EMPTY,
    $LUN_ATTR_DEVICE_BINARY_ID   => $LUN_ATTR_EMPTY,
    $LUN_ATTR_DEVICE_LEGACY_ID   => $LUN_ATTR_EMPTY,
    $LUN_ATTR_SPACE_RESV_HONORED => $LUN_ATTR_SPACE_RESV_HONORED_TRUE,
    $LUN_ATTR_SPACE_ALLOC        => $LUN_ATTR_SPACE_ALLOC_DISABLE
);

1;
