# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/San/Application/Portsetconstant.pm#1 $
#
# Copyright (c) 2010 NetApp, Inc.
# All rights reserved.
#
##
## @summary constant definitions for portset (cmode) testing
## @author SAN QA (c-dl-ssan-test@netapp.com)
## @status public

package San::Application::Portsetconstant;

use strict;
use Exporter;

our (@ISA, @EXPORT);

use Exporter;
@ISA    = qw(Exporter);
@EXPORT = qw(PS_ATTR_PORTSET_NAME
  PS_ATTR_VSERVER_NAME
  PS_ATTR_PROTOCOL
  PS_ATTR_PORT_NAME
  PS_ATTR_PORT_COUNT
  PS_ATTR_IGROUP

  PS_ATTR_PORTSET_OBJ

  PS_PARAM_PS_ATTR_INFO
  PS_PARAM_VSERVER_OBJ
  PS_PARAM_VSERVER_NAME
  PS_PARAM_TPGROUP_NAME
  PS_PARAM_ISCSI_LIF_NAME
  PS_PARAM_IGROUP_OBJ

  PORT_NONE
  PORT_FCP
  PORT_TPG_EMPTY
  PORT_TPG_DEFAULT
  PORT_TPG_LIF
  SINGLE_PORT
  MULTI_PORT

  PROTOCOLS_SUPPORTED
  @ExpectedPortsetAttributes
  );

# portset attributes (parameter) definitions
use constant PS_ATTR_PORTSET_NAME => 'portset';
use constant PS_ATTR_VSERVER_NAME => 'vserver';
use constant PS_ATTR_PROTOCOL     => 'protocol';
use constant PS_ATTR_IGROUP       => 'igroups';
use constant PS_ATTR_PORT_NAME    => 'port_name';
use constant PS_ATTR_PORT_COUNT   => 'port_count';

use constant PS_ATTR_PORTSET_OBJ => 'portset_obj';

use constant PS_PARAM_PS_ATTR_INFO   => 'ps_attr_info';
use constant PS_PARAM_VSERVER_OBJ    => 'vserver_obj';
use constant PS_PARAM_VSERVER_NAME   => 'vserver_name';
use constant PS_PARAM_TPGROUP_NAME   => 'tpgroup_name';
use constant PS_PARAM_ISCSI_LIF_NAME => 'iscsi_lif_name';
use constant PS_PARAM_IGROUP_OBJ     => 'igroup_obj';

# Bit definition
# Bit 0: NO PROTS - just default portset
# Bit 1: FCP lif
# Bit 2: Tpgroup - empty
# Bit 3: Tpgroup - defualt, iscsi lif defualt tpgroup name
# Bit 4: Tpgroup - with one or more lif in tpgroup
# Bit 5: NOT USED - for feature!!!
# Bit 6: Single port
# Bit 7: Multiple ports

use constant {PORT_NONE        => 0b00000000,
              PORT_FCP         => 0b00000001,
              PORT_TPG_EMPTY   => 0b00000010,
              PORT_TPG_DEFAULT => 0b00000100,
              PORT_TPG_LIF     => 0b00001000,
              SINGLE_PORT      => 0b01000000,
              MULTI_PORT       => 0b10000000};

use constant PROTOCOLS_SUPPORTED => qw(iscsi fcp mixed);

# expected "portset show" attributes
# since portset attributes output is changing frequently (by developers)
# its defined here, so that once place to change....
our @ExpectedPortsetAttributes =
  (PS_ATTR_PORTSET_NAME, PS_ATTR_VSERVER_NAME, PS_ATTR_PROTOCOL, PS_ATTR_IGROUP, PS_ATTR_PORT_NAME, PS_ATTR_PORT_COUNT);

1;

