#
# This library is used to create the Windows Cluster objects
#
# This is THARN Doc
#
## @summary
##  Wrapper for SanCluster Windows functionality.
##
## @author  Jonathan.Dascenzo@Netapp.com
## @status  private
##
#
#

use strict;

package San::SanClientCluster::Windows;

# import common libs
use Tharn;
use TestEnv::MinWin;
use Error;
use San::SanClientCluster::Windows::MSCS;
use San::SanClient::ClientUtil;

use vars qw( @ISA @EXPORT );
@ISA = qw( Error );

################################################################################
# Subroutine Name: _new()
# Objective:       Call libraries to create a new SanClientClusterObject 
# Details:         Not much more to say about this really
################################################################################

sub _new {
   
    my $self = {}; 
    my ($class, %args) = @_;

    bless $self,$class;

    $self = San::SanClientCluster::Windows::MSCS->_new(%args);

    return $self;

}
                        
1;
