## @summary Constants for SnapLock functions
##
## @author anusuya@netapp.com
## @status Private
## @pod here


package SnapLock::Snaplock_constants;

use strict;
use NATE;
use Tharn;

# Constant definitions
# required for the various snaplock qsm data set 
#use constant TRUE => 1;
#use constant FALSE => 0;
use constant NSEC_LESS_THAN_ONE_BILLION => "100000000";
use constant NSEC_ONE_BILLION => "1000000000";
use constant NSEC_GREATER_THAN_ONE_BILLION => "2020202020";
use constant NSEC_NEGETIVE_VALUE => "-1000000000";
use constant NFS_VERIFIER_FLAG => "0x00000800";
use constant NFS_VERIFIER_ON_WORM => '0x00000906';
use constant NFS_VERIFIER_ON_WORM_APPEND => '0x00040902';
use constant NFS_VERIFIER_ON_REGULAR_FILE => '0x00000802';
use constant PRIVDEL_ERROR_NONSLE => "Volume is not a SnapLock Enterprise volume";
use constant PRIVDEL_ERROR_AGGR => "cannot get option: Volume does not exist or is offline";
use constant SNAPLOCK_REVERT_MESSAGE => 'The autocommit periods of the Snaplock volumes in the system are not the same';

use vars ('@ISA', '@EXPORT', '@EXPORT_OK');
require Exporter;

@ISA = qw(Exporter);

@EXPORT = qw(
		NSEC_LESS_THAN_ONE_BILLION
		NSEC_ONE_BILLION
		NSEC_GREATER_THAN_ONE_BILLION
		NSEC_NEGETIVE_VALUE
		NFS_VERIFIER_FLAG
		PRIVDEL_ERROR_NONSLE
		PRIVDEL_ERROR_AGGR
		SNAPLOCK_REVERT_MESSAGE
		NFS_VERIFIER_ON_WORM
		NFS_VERIFIER_ON_WORM_APPEND
		NFS_VERIFIER_ON_REGULAR_FILE
	   );

1;

