#!/usr/bin/perl

=head1 NAME

Snapshot - Abstract Class for verifying Snapshots 

=head1 SYNOPSIS

use SnapshotVerifier;



=head1 DESCRIPTION


=cut

package SnapshotVerifier;
#require Exporter;
#
#our @ISA;
#our @EXPORT_OK;
#
#push @ISA, qw(Exporter);
#push @EXPORT_OK, qw(freeze check);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = { 
        # Path to mounted volume
        vol_path => undef,
        
        # Volume information to use on server calls
        vol_name => undef,
        snapshot_name => undef,
        server => undef,
       
        # Private var to cache access
        snapshot_exists => undef,
        @_,
    };

    if (!defined $self{vol_path}) {
        die "Need to have a vol_path pointing to a mounted volume!\n";
    }
    if (!defined $self{vol_name}) {
        die "Need to have a vol_name for the target volume of snapshots\n";
    }
    if (!defined $self{snapshot_name}) {
        die "Can't do snapshot testing without a snapshot_name\n";
    }
    if (!defined $self{server}) {
        die "No server object passed, no hope of running commands\n";
    }
    
    print "new SnapshotVerifier\n";
    bless($self, $class);

    _update_snapshot_exist($self);

    return $self;
}

sub import {
    push @{caller().'::ISA'},__PACKAGE__;
}

sub _update_snapshot_exist {
    my $self = shift;

    eval {
        $self->{server}->volume_snapshot_show(volume => $vol_name);
    };
    if ($@) {
        $self->{snapshot_exists} = 0;
    } else {
        $self->{snapshot_exists} = 1;
    }
}

sub freeze {
    
}

sub check {

}

1;
