#!/usr/bin/perl

=head1 NAME

SnapshotVerifier::Pathdiff - Class for verifying Snapshots using pathdiffs

=head1 SYNOPSIS

use SnapshotVerifier;



=head1 DESCRIPTION


=cut

package SnapshotVerifier::Pathdiff;
use SnapshotVerifier;
use Pathdiff;

#require Exporter;

#our @ISA;
#our @EXPORT_OK;
#
#push @ISA, qw(Exporter);
#push @EXPORT_OK, qw(freeze check);



sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new();

    $self->{Pathdiff} = new Pathdiff;

    print "new SnapshotVerifier::Pathdiff\n";
    bless($self, $class);
    return $self;
}

sub freeze {
    my $self = shift;
    print "SnapshotVerifier::Pathdiff feeze()\n";    
    
    $self->{db_file} = $self->{Pathdiff}->snapshot(directory => 
                                                    $self->{vol_path});
}

sub check {
    my $self = shift;
    print "SnapshotVerifier::Pathdiff check()\n";
    
    $self->{Pathdiff}->compare(source => $self->{db_file},
                                target => $self->{vol_path});
}

1;
