# $Id: //depot/prod/test/Rsierranevada/lib/SpinClient.pm#1 $

# Import libSC into the namespace of the caller, explicitly pulling in to the
# importing package all symbols that point to scalars.
use lib "$ENV{ROOT}/share/linux/usr/lib";
use lib "$ENV{ROOT}/share/common/lib/perl";
use SC;

for my $k (keys %SC::) {
	local *sym = $SC::{$k};
	if (defined $sym) {
		eval "*" . __PACKAGE__ . "::$k = *SC::$k";
		if ($@) { print "FAILED to import: $@\n"; die $@; }
	}
}

package SpinClient;

use lib "$ENV{ROOT}/share/linux/usr/lib";
use lib "$ENV{ROOT}/share/common/lib/perl";

use SpinClient::NFS;
use SpinClient::CIFS;
use SC;

sub new
{
	# Ignore the class name, as we don't use it. We just want to get to
	# the paramater hash.
	shift;

	my %params = (
		@_,
	);

	SC::sc_init();

	if ($params{nfs}) {
		return new SpinClient::NFS($params{nfs});
	} elsif ($params{cifs}) {
		return new SpinClient::CIFS($params{cifs});
	} else {
		return undef;
	}
}

1;
