#$Id:
#
## @summary ACP_EXP Command and Utility Library
##
## @author nivedita@netapp.com
## 


package Storage::ACP_EXP;
use Tharn qw(say script_result host logcomment logresult param);
use Storage::Sapphire qw(gem_cmd_api);
use Storage::SASUtils qw(
    filer_cmd
    storage_logresult
);
use JSON;
BEGIN
{
    use base qw(Exporter);
    our @EXPORT_OK = qw(
            set_date
            back_toacp
            transit_acpcon_toacploader
            transit_acp_toexp
            transit_expdiag_expcon
            transit_expcon_expdiag
            imageA
            imageB
            _acp_login
            );
}
my $output;

#setting date on the ACP linux machine
#Whenever the Linux machine boots up the date gets reset to epoch
#In order to set the logs straight we need to set the date using
#this module

sub set_date ( $;$;$;$ ) {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $c = 0;
    while($$acpCon[$c]){
        my $date_cmd;
        #Get the current time from the machine to set ACP linux system
        my $current_date =  `date`;
        print "$current_date \n";
    
        my @months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

        #Format of the date is in the form of e.g., Wed Jun  5 16:05:43 PDT 2013.
        #We now need this date onto the ACP console.
        #Usage: date [OPTION]... [MMDDhhmm[[CC]YY][.ss]] [+FORMAT]
    
        my @current_date_split =split(' ', $current_date);

        my $i;
        for($i =0 ; $i < 12 ; $i++){
            if($months[$i] eq $current_date_split[1]){
                $current_date_split[1] = $i + 1;
                print "@current_date_split[1] \n\n";
                $i = 12;
            }
        }

        #split time.
        my @current_time_split = split(':', $current_date_split[3]);
    
        #Display time in accordance with the UTC standard
        $current_time_split[0] = $current_time_split[0] + 7;
        if ($current_time_split[0] >= 24){
            $current_time_split[0] = $current_time_split[0] - 24;
            if($current_time_split[0] < 10){
                $current_time_split[0] = "0".$current_time_split[0];
            }
        }
    
        #Append a "0" in case the month is before Oct
    
        if($current_date_split[1] < 10){
            $current_date_split[1] = "0".$current_date_split[1];
        }
        if($current_date_split[2] < 10){
            $current_date_split[2] = "0".$current_date_split[2];
        }
        $date_cmd = "date". " " . $current_date_split[1].$current_date_split[2].$current_time_split[0].$current_time_split[1].$current_date_split[5].".".$current_time_split[2];

        logcomment("Setting DATE");
        $output = gem_cmd_api(conn=>$$acp_ctrlConn[$c], host=>$$acpCon[$c],cmd=>$date_cmd,timeout=>$TIMEOUT,connmode=>$CONNMODE);
        if($output =~ $current_date_split[5]){
            logresult("PASS","Date is set to the current time and date $output\n");
        }else {
            logresult("FAIL","Unable to set date");
        }
        $c++;
    }

        return $output;

}

#
#This module by the end of its execution ensures
#that you return to the ACP linux box prompt
#Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode

sub back_toacp ( $;$;$;$ ) {

    my($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acpCon[$i]){
        logcomment("Running @.");
        my $output = gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acpCon[$i],cmd=>'@.',timeout=>$TIMEOUT,connmode=>$CONNMODE);
        if($output =~ /Syntax error/){
            logcomment("ACP Diag prompt");
            transit_acpdig_acpconsole($$acpCon[$i], $$acp_ctrlConn[$i], $TIMEOUT, $CONNMODE);
        } elsif($output =~ /Unknown command/){
            logcomment("ACP loader prompt output");
            transit_acploader_acpconsole($$acpCon[$i], $$acp_ctrlConn[$i], $TIMEOUT, $CONNMODE);
        }
        $i++;
    }
}

#
#This module is executed to  
#move your console from ACP linux prompt to 
#expander shell prompt
##Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode


sub transit_acp_toexp {
    my ($acp_ctrl, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acp_ctrl[$i]){
        logcomment("Setting directory to /netapp/bin");
        gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acp_ctrl[$i],cmd=>"cd /netapp/bin",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        $output = gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acp_ctrl[$i],cmd=>"pwd",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        if($output =~ /\/netapp\/bin/){
            logresult("PASS", "In /netapp/bin");
        }else{
            logresult("FAIL", "Unable to set the directory");
        }
        logcomment("Executing ./exp_shell");
        $output = gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acp_ctrl[$i],cmd=>"./exp_shell",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        print "$output \n";

        #Check in which mode is expander shell is in.
        $$acp_ctrlConn[$i]->discardbuff(timeout=>1);
        $output = gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acp_ctrl[$i],cmd=>"ver",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        logcomment("$output");
        if($output =~ /EBOD/){
            logcomment("In expander diag shell");
            logcomment("Getting into expander shell");
            transit_expdiag_expcon($$acp_ctrl[$i],$$acp_ctrlConn[$i], $TIMEOUT, $CONNMODE);
            logcomment("In expander shell");
        }elsif($output =~ /Canister/) {
            logcomment("In expander shell");
        } else{
            logresult("FAIL", "Not Working");
            die "Not in expander shell mode\n";
        }
 
        $i++;
    }
}
#
#This module is executed to  
#move your console from ACP linux prompt to 
#acp loader prompt
##Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode


sub transit_acpcon_toacploader ( $;$;$;$ ) {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acpCon[$i]){
        gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acpCon[$i],cmd=>"reboot",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        $i++;
    }
}

#
#This module is executed to  
#move your console from ACP diag prompt to 
#ACP linux prompt
##Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode



sub transit_acpdig_acpconsole ( $;$;$;$ ){
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    gem_cmd_api(conn=>$acp_ctrlConn, host=>$acpCon,cmd=>"exit",timeout=>$TIMEOUT,connmode=>$CONNMODE);
    gem_cmd_api(conn=>$acp_ctrlConn, host=>$acpCon,cmd=>"reset",timeout=>$TIMEOUT,connmode=>$CONNMODE);
    _acp_login($acp_ctrlConn);
}



#
#This module is executed to  
#move your console from ACP loader prompt to 
#ACP linux console
#Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode


sub transit_acploader_acpconsole ( $;$;$;$ ) {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    gem_cmd_api(conn=>$acp_ctrlConn, host=>$acpCon,cmd=>"reset",timeout=>$TIMEOUT,connmode=>$CONNMODE);
    _acp_login($acp_ctrlConn);
}

#Loading Image A

sub imageA {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acpCon[$i]){
        gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acpCon[$i],cmd=>"reboot A",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        $i++;
    }
}

#loading image B

sub imageB {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acpCon[$i]){
        gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acpCon[$i],cmd=>"reboot B",timeout=>$TIMEOUT,connmode=>$CONNMODE);
        $i++;
    }
}

#
#This module is executed to  
#move your console from expander diag to 
#expander console
##Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode


sub transit_expdiag_expcon ( $;$;$;$ ) {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    gem_cmd_api(conn=>$acp_ctrlConn, host=>$acpCon,cmd=>"exit",timeout=>$TIMEOUT,connmode=>$CONNMODE);
}


#
#This module is executed to  
#move your console from expander prompt 
# to expander diag
##Parameters required are 
#1>hostrec object
#2>connecrec object
#3>timeout and the connection mode


sub transit_expcon_expdiag ( $;$;$;$ ) {
    my ($acpCon, $acp_ctrlConn, $TIMEOUT, $CONNMODE) = @_;
    my $i = 0;
    while($$acpCon[$i]){
        gem_cmd_api(conn=>$$acp_ctrlConn[$i], host=>$$acpCon[$i],cmd=>"reboot",timeout=>$TIMEOUT,connmode=>$CONNMODE);

        $i++;
    }
}


#This module logs into the ACP linux box
#

sub _acp_login($) {
    my ($acp_ctrlConn) = @_;
    my $tout = 120;
    my $response;
    undef($output);

    $acp_ctrlConn->timeout($tout);
    $output = $acp_ctrlConn->send("\r");
    $response = $acp_ctrlConn->expect(match => 'local login:|Password:|local#|\$|=>|^*l2O3> |Login incorrect');

    if($response =~ /Login incorrect/){
        logcomment("Login Incorrect : Trying to relogin again");
        sleep 10;
        $acp_ctrlConn->send("\r");
        $response = $acp_ctrlConn->expect(match => "local login:");
    }

    if($response =~ /login:/){
        $output = $acp_ctrlConn->send("root\r");
        $response = $acp_ctrlConn->expect(match => "Password:");

        $output = $acp_ctrlConn->send("kX18tDOuDp\r");
        $response = $acp_ctrlConn->expect(match => "local#");

    }elsif($response  =~ /Password:/){
        $output = $acp_ctrlConn->send("kX18tDOuDp\r");
        $response = $acp_ctrlConn->expect(match => "local#");
    } elsif($response  =~  /local#\s*$/ || $response =~ '^=>|\$|l2O3>'){
        logcomment("Logged in");
    }else {
        die "Unable to login into ACPP console";
    }
=comment

    ($a,$b,$output) = say($acpCon,"\r", -swallow, "-noprompt", '-wait', 'local login:|Password:|local#|\$|=>|^*l2O3> |Login incorrect', -timeout, "$tout");
    if($b =~ /^Login incorrect$/ || $a =~ /^Login incorrect$/){
        logcomment("Login Incorrect : Trying to relogin again");
        sleep 10;
        ($a, $b, $output) = say($acpCon, "\r", -swallow, "-noprompt", '-wait', "local login:", -timeout, "$tout");
    }
    if($output =~ /login:/ || $a =~ /login:$/){
        $output = say($acpCon, "root", -swallow, -noprompt, '-wait', "Password:", -timeout, "$tout");
        $output = say($acpCon, "kX18tDOuDp", -swallow, -noprompt, '-wait', "local#", -timeout, "$tout");
        print "\n\n IN local login: $output\n\n";
    }
    elsif($output =~ /Password:/){
        $output = say($acpCon, "kX18tDOuDp", -swallow, -noprompt, '-wait', "local#", -timeout, "$tout");
        print "\n\n In Password: $output\n\n";
    }
    elsif($output =~ /local#\s*$/ || $a =~ /^local#$/ || $a =~ '^=>|\$|l2O3>' || $output =~ '=>|\$|l2O3> ' ){
        logcomment("Logged in");
    }
    else {
        die "Unable to login into ACPP console";
    }
=cut
}

1;
