
## @summary 
##        Hammer.pm is a library for hammer local

## @description
##        Function calls include hammer_status and hammer_abort	


## @author 
##        David Halliwell hdavid@netapp.com

## @status 
##        testme



package Storage::Hammer;

# Standard libs
use strict;
use warnings;
use Carp qw(confess croak);
# http://search.cpan.org/~drolsky/Params-Validate-0.78/lib/Params/Validate.pm
use Params::Validate qw(validate validate_pos SCALAR OBJECT HASHREF); 
BEGIN {
	Params::Validate::validation_options(
		on_fail => sub {my @msgs = @_; 
				chomp(@msgs);
				Carp::confess(Tharn::script_result(@msgs))
				}
	);
}
use Data::Dumper;
use base qw(Exporter);
our @EXPORT_OK = qw(	
			hammer_abort
			hammer_status
			);	# export on request

# NetApp libs
use Tharn;			
# http://web.netapp.com/engineering/nate/releases/latest/html/Tharn.html
use Utils qw(make_conn);	# make a host connection with name of host, Hostspec, or Connspec
use boot;

our $timeout = 60;


#     output fron connect
#     $host = host($FILER); 
#     $fc   = connect($FILER_CONN);  
#     $output = hammer_abort($fc);

sub hammer_abort
{
    my($fc, $timeout) = @_;
    my $output;
    (undef, undef, $output) = say($fc, "priv set test;hammer abort", "-timeout", $timeout);
    return $output;
}

#     output fron connect
#     $host = host($FILER); 
#     $fc   = connect($FILER_CONN);  
#     $output = hammer_abort($fc);
sub hammer_status
{
    my($fc, $timeout) = @_;
    my $output;
    (undef, undef, $output) = say($fc, "priv set test;hammer status", "-timeout", $timeout);
    return $output;
}
