#Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/main/lib/Syslog.pm#1

#***********************************************************************
#
# NAME
#   Syslog.pm - 
#
# SYNOPSIS
#   
#
# DESCRIPTION
#   
#
# AUTHOR
#   
#
#***********************************************************************

## @summary     Syslog library    

package Syslog::syslog;

#use statements
use Data::Dumper;
use Server;
use TracePkg;
use Options;
use Params::Common;
use CLI::FileIO qw(rdfile wrfile);

use Sys::Hostname;

#Global variables
my $Trace = new TracePkg();
my $Server = new Server();

#Methods

###############################################################################
#Sub: create_syslog_message
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub create_syslog_message {
    my %params = (
            mode => "7G",
            repeat_cnt => 1,
            priority => 6,
            facility => "kern",
            message => "This is a test syslog message",
            cfo => 0,
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        eval {
            $Trace->debug(msg=>"Invoking command: syslog $params{repeat_cnt} $params{priority} $params{facility} $params{message} \n");
            if ($params{cfo}) {
                $Server->console(cmd => "partner; priv set diag; syslog $params{repeat_cnt} $params{priority} $params{facility} $params{message}; partner");  
            }
            else {
                $Server->cli(cmd => "priv set diag; syslog $params{repeat_cnt} $params{priority} $params{facility} $params{message}");
            }
        };
        if ($@ =~ /command failed/) {
            $Trace->fatal(msg=>"Could not create syslog message... \n");
        }
    }
    else {
        
    }
}
###############################################################################
#Sub: restart_syslogd
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub restart_syslogd {
    my %params = (
            mode => "7G",
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        eval {
            $Trace->debug(msg=>"Invoking command: syslog reset_syslog \n");
            $Server->cli(cmd => "priv set diag; syslog reset_syslog");
        };
        if ($@ =~ /command failed/) {
            $Trace->comment(msg=>"Could not reset the syslog daemon \n");
            return 0;
        }
        else {
            return 1;
        }
    }
    else {
        
    }
}
###############################################################################
#Sub: rotate_syslog
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub rotate_syslog {
    my %params = (
            mode => "7G",
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        eval {
            $Trace->debug(msg=>"Invoking command: syslog rotate_syslog \n");
            $Server->cli(cmd => "priv set diag; syslog rotate_syslog");
        };
        if ($@ =~ /command failed/) {
            $Trace->comment(msg=>"Could not rotate the syslog \n");
            return 0;
        }
        else {
            return 1;
        }
    }
    else {
        
    }
}
###############################################################################
#Sub: create_syslog_conf
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub create_syslog_conf {
    my %params = (
            mode => "7G",
            selector => undef,
            action => undef,
            syslog_hash => undef,
            text => undef, 
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        #$Trace->debug(msg=>"Creating new syslog.conf file in /etc \n");
        #my $connection = main::connect($params{node}."#rsh");
        #my $result=wrfile($connection,'/etc/syslog.conf','');
        #if ($result != 1) {
        #    $Trace->fatal(msg=>"Could not create syslog.conf file... \n");
        #}
        eval {
            $Trace->debug(msg=>"Creating new syslog.conf file in /etc \n");
            $Server->cli(cmd => "priv set diag; rm /etc/syslog.conf");
            $Server->cli(cmd => "wrfile -a /etc/syslog.conf");
        };
        if ($@) {
            $Trace->fatal(msg => "Could not create syslog.conf file... $@\n");
        }
        if ($params{selector} and $params{action}) {
            $result=modify_syslog_conf(selector=>$params{selector},action=>$params{action});
            if ($result != 1) {
                $Trace->fatal(msg=>"Could not write selector and action to syslog.conf file... \n");
            }
        }
        if ($params{text}) {
            $result=modify_syslog_conf(text=>$params{text});
            if ($result != 1) {
                $Trace->fatal(msg=>"Could not write text to syslog.conf file... \n");
            }
        }
        if ($params{syslog_hash}) {
           # $Trace->comment(msg=>"Selector: ".$params{syslog_hash}->[0]->{selector}."\n");
            $Trace->comment(msg=>"Number: ".@$params{syslog_hash}."\n");
            my $syslog_hash_array=$params{syslog_hash};
            foreach my $syslogconfighash (@$syslog_hash_array) {
                $result=modify_syslog_conf(selector=>$syslogconfighash->{selector}, action=>$syslogconfighash->{action});
            }
            if ($result != 1) {
                $Trace->fatal(msg=>"Could not write entries to syslog.conf file... \n");
            }
        }
        
        if (!read_syslog_conf()) { #verify the syslog.conf was created, if not return 0
            return 0;
        }
        else { #syslog.conf create successfully
            return 1;
        }
    }
    else {
        
    }
}

###############################################################################
#Sub: modify_syslog_conf
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub modify_syslog_conf {
    my %params = (
            node => undef,
            mode => "7G",
            selector => undef,
            action => undef,
            text => undef,
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        $Trace->debug(msg=>"Modifying syslog.conf file in /etc \n");
        if ($params{text}) {
            eval { #-a option appends to file, not available in FileIO.pm
                $Server->cli(cmd => "wrfile -a /etc/syslog.conf \'$params{text}\'");
            };
            if ($@ =~ /command failed/) {
                $Trace->comment(msg=>"Could not append entry to syslog.conf file... \n");
                return 0;
            }
            else {
                return 1;
            }
        }
        else {
            eval { #-a option appends to file, not available in FileIO.pm
                $Server->cli(cmd => "wrfile -a /etc/syslog.conf \'$params{selector} $params{action}\'");
            };
            if ($@ =~ /command failed/) {
                $Trace->comment(msg=>"Could not append entry to syslog.conf file... \n");
                return 0;
            }
            else {
                return 1;
            }
        }
    }
    else {
        
    }
}

###############################################################################
#Sub: delete_syslog_conf
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub delete_syslog_conf {
    my %params = (
            mode => "7G",
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        $Trace->debug(msg=>"Deleting syslog.conf file in /etc \n");
        eval {
            $Server->cli(cmd => "priv set diag; rm /etc/syslog.conf");
        };
        if (!read_syslog_conf()) { #verify the syslog.conf file was removed
            return 1;
        }
        else { #else file still exists
            return 0;
        }
    }
    else {
        
    }
}

###############################################################################
#Sub: read_syslog_conf
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub read_syslog_conf {
    my %params = (
            mode => "7G",
            @_,
    );
    my $result;
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        $Trace->debug(msg=>"Reading syslog.conf file in /etc \n");
        #my $connection = main::connect($params{node}."#rsh");
        #$result=rdfile($connection,'/etc/syslog.conf');
        $result=$Server->cli(cmd=>'rdfile /etc/syslog.conf');
        if ($result eq undef) {
            $Trace->comment(msg=>"Syslog.conf file does not exist... \n");
            return 0;
        }
        elsif ($result =~ /No such file or directory/){
            $Trace->comment(msg=>"Syslog.conf file does not exist... \n");
            return 0;
        }
        else { #else return the contents
            return $result;
        }
    }
    else {
        
    }
}

###############################################################################
#Sub: delete_file
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub delete_file {
    my %params = (
            mode => "7G",
            file => undef,
            @_,
    );
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        $Trace->debug(msg=>"Deleting $params{file} \n");
        eval {
            $Server->cli(cmd => "priv set diag; rm $params{file}");
        };
        if (!read_file(file=>$params{file})) { #verify the file was removed
            return 1;
        }
        else { #else file still exists
            return 0;
        }
    }
    else {
        
    }
}

###############################################################################
#Sub: read_file
#Input Params: 
#Return values: 
#Summary: 
###############################################################################
sub read_file {
    my %params = (
            mode => "7G",
            file => undef,
            @_,
    );
    my $result;
    if ($params{mode} eq '7M' || $params{mode} eq '7G') {   
        $Trace->debug(msg=>"Reading $params{file} file \n");
        $result=$Server->cli(cmd=>"rdfile $params{file}");
        if ($result eq undef) {
            $Trace->comment(msg=>"No information returned about file... \n");
            return 0;
        }
        elsif ($result =~ /$params{file}: No such file or directory/){
            $Trace->comment(msg=>"$params{file} file does not exist... \n");
            return 0;
        }
        else { #else return the contents
            return $result;
        }
    }
    else {
        
    }
}
