#Hey emacs, this is basically -*- perl -*-
# $Id: $

## @summary     Default - Default topology
##
## @author      gvg@netapp.com
##
## @pod here

=head1 NAME

Default - Default topology

=head1 SYNOPSIS
    
use Topology;
my $self = new Topology(topology=>"default");

=head1 DESCRIPTION

C<Default> defines default topology for tests. This does nothing for now.

=head2 filer_setup:
    None

=head2 client_setup:
    None

=head2 client_cleanup:
    None

=head2 filer_cleanup:
    None

=head1 SEE ALSO

Topology Options TracePkg TestManagerLite 

=head1 BUGS

Some probably exist but have not been listed yet.

=head1 STATUS

  Shared

=head1 AUTHOR

  GV Govindasamy (gvg@netapp.com)
  $Id: $
  Last revised $Date: 2006/04/12 $
    
=head1 COPYRIGHT

Copyright 2006, Network Appliance., All Rights Reserved

=cut

package Topology::Default;

use base qw(Topology); # Define Super class

use Tharn;
use strict;

use TracePkg;
my $Trace = new TracePkg;

use Options;
my $Options = new Options;
my $Options_hash;

sub new {
    my $invocant = shift;
    my $class = ref($invocant) || $invocant;
    my $self = {};
    $Trace->entry();
    bless($self, $class);
    return $self;
}

##############################################################

sub filer_setup {
    my $self = shift;
    $Trace->debug(msg=>"This topology doesn't do any filer setup");
}

##############################################################

sub client_setup {
    my $self = shift;
    $Trace->debug(msg=>"This topology doesn't do any client setup");
}

sub client_cleanup {
    my $self = shift;
    $Trace->debug(msg=>"This topology doesn't do any client cleanup");
}
    
##############################################################

sub filer_cleanup {
    my $self = shift;
    $Trace->debug(msg=>"This topology doesn't do any filer cleanup");
}

##############################################################

1;
