# -*- perl -*-
# $Id: //depot/prod/test/Rsierranevada/lib/VFILER/params.pl#1 $

## @summary vfiler parameters
##
## @description
##	parameters for the vFiler automation
##
## @usage
##	require "VFILER/params.pl";
##
## @author dl-johny@netapp.com (FSS WAFL Quality)
##
## @status public
##

use strict;
use Tharn;

use vars qw(
	$AGGR_SIZE
	$CIFS_NAME
	$CIFS_DOMAIN
	$CIFS_DOMAIN_ADMIN
	$CIFS_DOMAIN_ADMIN_PASSWD
	$CIFS_PASSWD
	$CIFS_USER
	$CMDTIMEOUT
	$DNS_DOMAIN
	$FILER_CONN
	$FILER
	$FILERA
	$FILERB
	$FILER_MODE
	$FILER_VOL
	$FILER_VOL1
	$FILER_VOL2
	$FILER_VOL3
	$FILER_AGGR
	$FILER_AGGR_1
	$FILER_AGGR_2
	$FILER_VVOL
	$FILER_VVOL_1
	$FILER_VVOL_2
	$FILER_VVOL_3
	$FLEX_SIZE
	$VFILER_GATEWAY
	$IPSPACE_1
	$NAMESERVER
	$NIS_DOMAIN
	$NIS_SERVER
        $NO_IF_SEARCH
	$RDATE_HOST
	$SLEEPTIME
        $TIMEOUT
	$TRAD_SIZE
	$VFILERNAME
	$VFILERNAME_1
	$VFILERNAME_2
	$VFILER_IPADDR_1
	$VFILER_IPADDR_2
	$VFILER_IPADDR_3
	$VFILER_IPADDR_4
	$VFILER_NETMASK
	$VFILER_NETMASK_1
	$VFILER_NETMASK_2
	$VFILER_NETMASK_3
	$VFILER_IF_TO_USE
	$VFILER_IF_TO_USE_1
	$VFILER_IF_TO_USE_2
	$VFILER_IF_TO_USE_3
	$VFILER_DNS_DOMAIN
	$VFILER_DNS_SERVER
	$VFILER_DNS_SERVER_1
	$VFILER_DNS_SERVER_2
	$VFILER_NIS_DOMAIN
	$VFILER_NIS_SERVER
	$VFILER_QTREE_1
	$VFILER_QTREE_2
	$VFILER_SETUP
	$VFILER_WINS_IPADDR_1
	$VFILER_WINS_IPADDR_2
	$VFILER_WINS_DOMAIN
	$VFILER_WINS_USER
	$VFILER_WINS_USER_PASSWD
	$VOL_TYPE
	$VVOL_SIZE
	$VVOL_SIZE_1
	$VVOL_SIZE_2
	$WINS_DOMAIN
	$WINS_DOMAIN_IPADDR
	$WINS_IPADDR_1
	$WINS_IPADDR_2
	$WINS_USER
	$WINS_USER_PASSWD
	);

##
## Filer
##
param("FILER_MODE",	"-default",	'mono');
param("FILER_CONN",	"-default",	"#telnet");
param('FILER_VOL',      '-default',	'vol0');
param('VFILER_SETUP',   '-default',      '1');

##
## AGGREGATES
##
param('AGGR_SIZE',	'-default',	'3');
param('FILER_AGGR',	'-default',     'testaggr');
param('FILER_AGGR_1',	'-default',     'testaggr1');
param('FILER_AGGR_2',	'-default',     'testaggr2');

##
## FLEXIBLE VOLUMES
##
param('FILER_VVOL',     '-default',        'vvolVFT0');
param('FILER_VVOL_1',	'-default',        'vvolVFT1');
param('FILER_VVOL_2',	'-default',        'vvolVFT2');
param('FILER_VVOL_3',	'-default',        'vvolVFT3');

param("TRAD_SIZE",      '-default',        undef);

##
## GATEWAY
##
param("VFILER_GATEWAY",		"-default",	undef);

##
## DNS
##
param('DNS_DOMAIN',	'-default',	'lab.netapp.com');
param('NAMESERVER',	'-default',	'172.19.2.30');

##
## NIS
##
param('NIS_DOMAIN',		'-default',	'lab.netapp.com');
param('NIS_SERVER',		'-default',     '172.19.2.16');

##
## CIFS
##
param('RDATE_HOST',		'-default',	'timehost1.eng.netapp.com') ;
param('WINS_DOMAIN',		'-default',     'lab.netapp.com');
param('WINS_DOMAIN_IPADDR',	'-default',     '172.19.2.20');
param('WINS_IPADDR_1',		'-default',     '10.10.20.250');
param('WINS_IPADDR_2',		'-default',     '10.10.20.42');
param('WINS_USER',		'-default',     'labclient');
param('WINS_USER_PASSWD',	'-default',     'sundance');
param('CIFS_NAME',		'-default',     'vf_cifs_name');
# Map old vfiler cifs paramters to what tests use now
param('CIFS_DOMAIN',		'-default',	$::WINS_DOMAIN);
param('CIFS_DOMAIN_ADMIN',	'-default', "$::CIFS_DOMAIN\\labclient");
param('CIFS_DOMAIN_ADMIN_PASSWD', '-default',	'sundance');
param('CIFS_PASSWD',		'-default',	'cifspass');
param('CIFS_USER',		'-default',	'administrator');

##
## parameters for Vfiler
##
param('VFILERNAME',        	'-default',     'vFiler100');
param('VFILERNAME_1',        	'-default',     'vFiler101');
param('VFILERNAME_2',        	'-default',     'vFiler102');

param('VFILER_IPADDR_1',        '-default',     '172.16.20.221');
param('VFILER_IPADDR_2',        '-default',     '172.16.20.222');
param('VFILER_IPADDR_3',        '-default',     '172.16.20.223');
param('VFILER_IPADDR_4',        '-default',     '172.16.20.224');

param('VFILER_QTREE_1',        '-default',     'vf1qtree');
param('VFILER_QTREE_2',        '-default',     'vf2qtree');

param('VFILER_WINS_IPADDR_1',           '-default',     '10.10.20.250');
param('VFILER_WINS_IPADDR_2',           '-default',     '10.10.20.42');
param('VFILER_WINS_DOMAIN',             '-default',     'lab.netapp.com');
param('VFILER_WINS_USER',               '-default',     'labclient');
param('VFILER_WINS_USER_PASSWD',        '-default',     'sundance');

param('VFILER_DNS_SERVER_1',      '-default',     '172.19.2.30');
param('VFILER_DNS_SERVER_2',      '-default',     '172.19.3.32');


##
## IPspaces
##
param('IPSPACE_1',	'-default',	'ips1');

##
## CFO
##
param('SLEEPTIME',	'-default',	"120");

##
## timeout for commands
##
param("CMDTIMEOUT",	"-default", 240);

##
## timeout for connections
##
param('TIMEOUT',        '-default', 600); # 10 mins

if($FILER_MODE eq 'mono') {
	param("FILER",		"-mesg",	"  hostspec of filer");
} else {
	param("FILERA",		"-mesg",	"  FILERA for cluster");
	param("FILERB",		"-mesg",	"  FILERB for cluster");
	param("FILER",		"-default",	$FILERA);
}

use config_base;
use Filer::Version qw(get_wafl_version WV_SCRIMSHAW_MAX);
my $wv;
my $fh = host($::FILER);
eval {
    $wv = get_wafl_version($fh);
};
if ($@ and ! defined($ENV{"VOL_TYPE"}) and ! defined($::VOL_TYPE)) {
    logresult('CONFIG', "filer/sim is down or unreachable -- define \$VOL_TYPE to continue");
} elsif ($wv > WV_SCRIMSHAW_MAX) {
    param('VOL_TYPE',   '-default', 'flex');
} else {
    param('VOL_TYPE',   '-default', 'trad');
    param('SKIP_SNAPLOCK_RETENTION_SETUP', '-default', 1);
}

if ($::VOL_TYPE eq 'flex') {
    param('FILER_VOL1',	'-default', 'testvol_flex');
    param('FILER_VOL2',	'-default', 'volVFT2');
    param('FILER_VOL3',	'-default', 'volVFT3');
} else {
    param('FILER_VOL1',	'-default', 'testvol_trad');
    param('FILER_VOL2',	'-default', 'volVFT2');
    param('FILER_VOL3',	'-default', 'volVFT3');
}

##
## for simulators
##
if (ref($fh->hosttype()) =~ /Simulator|simulator/) {
	param('VFILER_DNS_DOMAIN',      '-default',     'sim.netapp.com');
	param('VFILER_DNS_SERVER',      '-default',     '10.56.16.21');
	param('VFILER_NIS_DOMAIN',      '-default',     'sim.netapp.com');
	param('VFILER_NIS_SERVER',      '-default',     '10.56.16.21');
	param('VVOL_SIZE',		'-default',     '60m');
	param('VVOL_SIZE_1',		'-default',     '120m');
	param('VVOL_SIZE_2',		'-default',     '30m');
} else {
	param('VFILER_DNS_DOMAIN',      '-default',     'lab.netapp.com');
	param('VFILER_DNS_SERVER',      '-default',     '172.19.2.20');
	param('VFILER_NIS_DOMAIN',      '-default',     'lab.netapp.com');
	param('VFILER_NIS_SERVER',      '-default',     '172.19.2.16');
	param('VVOL_SIZE',		'-default',     '1g');
	param('VVOL_SIZE_1',		'-default',     '2g');
	param('VVOL_SIZE_2',		'-default',     '3g');
}

# Set the VFILER interface defaults automatically by looking at the
# FILER and basing it on which interface name works for the given IP address.
# If NO_IF_SEARCH is set, do not do the interface search, but default
# the interface and netmask to undef. User defined values will always
# overwrite these values.
param('NO_IF_SEARCH', '-default', 0);
my ($if, $netmask);
if ($NO_IF_SEARCH) {
    ($if, $netmask) = (undef, undef);
} else {
    use VFILER::Setup qw(vfiler_find_if);
    ($if, $netmask) = vfiler_find_if(filer   => $::FILER,
                                     if => $::VFILER_IF_TO_USE,
                                     ip_addr => $::VFILER_IPADDR_1);
    if (!defined $if) {
        die "Cannot find a network interface to use on the filer that " .
          "is on the same network as the VFILER IP address " .
            "specified: $VFILER_IPADDR_1";
    }
}
param('VFILER_NETMASK',         '-default',     $netmask);
param('VFILER_IF_TO_USE',       '-default',     $if);
param('VFILER_NETMASK_1',       '-default',     $::VFILER_NETMASK);
param('VFILER_IF_TO_USE_1',     '-default',     $::VFILER_IF_TO_USE);
param('VFILER_NETMASK_2',       '-default',     $::VFILER_NETMASK);
param('VFILER_IF_TO_USE_2',     '-default',     $::VFILER_IF_TO_USE);
param('VFILER_NETMASK_3',       '-default',     $::VFILER_NETMASK);
param('VFILER_IF_TO_USE_3',     '-default',     $::VFILER_IF_TO_USE);

1;
