#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/lib/VSA/Vmhost/ESXDev.pm#1 $
## @summary ESX device
## @author dl-vsa-qa
## @status private

package VSA::Vmhost::ESXDev;

use strict;
use Data::Dumper qw(Dumper);
use Error qw(_clear_err _set_err);
use File::Basename qw (basename);
use Module::Common qw(validate_mixed);
use Params::Validate qw(SCALAR SCALARREF BOOLEAN OBJECT ARRAYREF UNDEF);
use VSA::UICommon qw(_caller _reformat_err _log _refresh_cache
                     _size_to_mbytes _trim);
use base qw(VSA::UICommon Error);


################################################################################
# P U B L I C   M E T H O D S
################################################################################
sub get_filer       { my ($self) = @_;     $self->{filer};      }
sub get_size        { my ($self) = @_;     $self->{lun_size};   }
sub get_name        { my ($self) = @_;     $self->{device_name};}
sub get_raw_device  { my ($self) = @_;     ($self->get_name()); }
sub get_lun         { my ($self) = @_;     $self->{lun_path};}
sub get_lun_name    { my ($self) = @_;     basename($self->{lun_path});}
sub get_lun_path    { my ($self) = @_;     $self->{lun_path};}
sub get_vmkdisk_name {my ($self) = @_;     $self->{vmkdisk_name};}
    
################################################################################
# P R I V A T E   M E T H O D S
################################################################################

################################################################################
# Subroutine Name: _new()
# Objective:       Create a new dev object
# Details:         See POD documentation at the end of this file
################################################################################
sub _new {
    my ($class, %args) = @_;
    my ($self,
        $adapter,
        $device_name,
        $filer,
        $lun_path,
        $lun_size, 
        $lun_state,
        $protocol, 
        $vmkdisk_name
        );

    ### bless instance into class
    $self= bless{}, $class;
    
    ### Validate input arguments
    ($class,%args) = validate_mixed (
        @_,
        [ { type => SCALAR} ],
        {
            adapter      => { type=>SCALAR },
            filer        => { type=>SCALAR },
            lun_path     => { type=>SCALAR },
            lun_size     => { type=>SCALAR },
            lun_state    => { type=>SCALAR },
            protocol     => { type=>SCALAR },
            device_name  =>  { type=>SCALAR },
            vmkdisk_name => { type=>SCALAR },
   
        }
    );
    #         _parent      => {type => OBJECT},
    #       _loghdl      => {type => SCALARREF|UNDEF, optional=>1}
  
    
    #$self->{loghdl}=$args{_loghdl};
    #$self->{parent}=$args{_parent};
    #$hosttype=$self->{parent}->get_hosttype();

    # initilize the object members
    $self->{adapter}      = $args{adapter};  
    $self->{filer}        = $args{filer};
    $self->{device_name}  = $args{device_name};
    $self->{protocol}     = $args{protocol};
    $self->{lun_path}     = $args{lun_path};
    $self->{lun_size}     = $args{lun_size};
    $self->{lun_state}    = $args{lun_state};
    $self->{vmkdisk_name} = $args{vmkdisk_name}; 
    $self->{device_is_free} = 1;

    $self->{lun_type} = "vmfs";

    return $self;
}

1;
