#Hey emacs, this is basically -*- perl -*-
#$Id: //depot/prod/test/Rsierranevada/lib/VSA/Vmhost/ESXSanlun.pm#1 $
## @summary Sanlun specific 
## @author dl-vsa-qa
## @status private

package VSA::Vmhost::ESXSanlun;

use strict;
use Data::Dumper qw(Dumper);
use Error qw(_clear_err _set_err);
use Module::Common qw(validate_mixed);
use Params::Validate qw(SCALAR SCALARREF BOOLEAN OBJECT ARRAYREF UNDEF);
use Tharn qw($Log);
use VSA::Vmhost::Sanlun;
use VSA::UICommon qw(_caller _reformat_err _log _refresh_cache
                     _size_to_mbytes _trim);                   
use base qw(VSA::Vmhost::Sanlun VSA::UICommon Error );


################################################################################
# P U B L I C   M E T H O D S
################################################################################

################################################################################
# Subroutine Name: lun_show()
# Objective:       display information about luns. 
# Details:         See POD documentation at the end of this file
################################################################################
sub lun_show {
    my ($self, %args ) = @_;
    my (
        $cmd,
        $errmsg,
        $status,
        @outputs,
    );
    
    ### Initialize error buffer    
    $self->_clear_err();

    $cmd = "/usr/sbin/sanlun lun show";   
    eval {
        ($status, @outputs) = $self->{parent}->_execute(cmd=>$cmd, hide=>1);
        if ($status > 0 and "@outputs" !~ /no controller luns/i ) {
            die "sanlun lun show command failed";
        }
    };
    if ($@){
        $errmsg=$self->_reformat_err($@);
        ($self->{parent}->on_err()=~/die/)
            ? die ($self->_caller($errmsg),"\n")
            : $self->_set_err($errmsg);
        return $self; 
    }
        
    return (wantarray()) ? @outputs : \@outputs;
}


################################################################################
# P R I V A T E   M E T H O D S
################################################################################

################################################################################
# Subroutine Name: _new()
# Objective:       Create a new sanlun object
# Details:         See POD documentation at the end of this file
################################################################################
sub _new {
    my ($class, %args) = @_;
    my (
        $self,
        );
 
    ### bless instance into class
    $self= bless{}, $class;
    
    ### Validate input arguments
    ($class,%args) = validate_mixed (
        @_,
        [ { type => SCALAR} ],
        {
            parent    => {type => OBJECT},
        }
    );
    
    $self->{parent}=$args{parent};
    ##$self->{conn} = $parent->get_connection();
        
    return $self;
}

1;

