#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a method use is
##          deemed to be invalid.  E.g., a temporary work-around method
##          that is able to determine that it's usage is no longer valid
##          due to changes in ONTAP.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package WaflMCC::MCC::Exceptions::BaseException;

use strict;
use warnings;
use Carp;

use base qw(NATE::BaseException);

=pod

=head1 Package Name

WaflMCC::MCC::Exceptions::BaseException

=head1 Author/Maintainer

dl-mcc-dpg@netapp.com

=head1 Description

WaflMCC::MCC::Exceptions::BaseException is a subclass of
NATE::BaseException that serves as the base MCC Exception for future MCC
exceptions.

    WaflMCC::MCC::Exceptions::BaseException->throw('my error message');


=head1 See Also

Package inherits from the BaseException module in NATE.

=head2 Base Class

NATE::BaseException

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

