#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when multiple DiskState
##          exceptions occur simultaneously.  It can also be used to
##          catch any of the different DiskState exceptions.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package WaflMCC::MCC::Exceptions::DiskState;

use strict;
use warnings;
use Carp;

use base qw(WaflMCC::MCC::Exceptions::BaseException);

=pod

=head1 Package Name

WaflMCC::MCC::Exceptions::DiskState

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

WaflMCC::MCC::Exceptions::DiskState is a subclass of
NATE::BaseException that will be thrown when multiple DiskState exceptions
occur simultaneously.  It can also be used to catch any of the different
DiskState exceptions.

    WaflMCC::MCC::Exceptions::DiskState->throw('my error message');

See WaflMCC::MCC::Metrocluster::get_singleton_DR_group() for an example
usage.

=head1 See Also

Package inherits from the BaseException module in WaflMCC::MCC::Exceptions.

=head2 Base Class

WaflMCC::MCC::Exceptions::BaseException

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

