# $Id: //depot/prod/test/Rsierranevada/lib/WinClient/DsmTest.pm#1 $
#
# Copyright (c) 2006 Network Appliance, Inc.
# All rights reserved.
#
# This library executes DsmTest on the host.  These methods are designed
# to be called via the host object and not directly from a thpl.
#
# TODO: Complete documentation pending.
#
## @summary
##  Wrapper for WinClient host functionality.
##
## @author  kenny speer
## @status  private
##

use strict;

package WinClient::DsmTest;

# define the routines used in this package
sub runDsmTest;                        # execute tests passed in as param

use lib(); 

#
#
#
sub runDsmTest
{
    my ($this, %args) = @_;

    my ($status, @output);
    my ($msg, $cmd, $line, $verbose, $tests);

    foreach (keys %args)
    {
        if (/^-verbose$/i)
        {
            if (!length($verbose = $args{$_}))
            {
                $msg = "DsmTest::runDsmTest - invalid value for -verbose: $args{$_}";
                &main::logcomment($msg);
                $this->_set_err($msg);
            }
            next;
        }
        if (/^-tests$/i)
        {
            if (!length($tests = $args{$_}))
            {
                $msg = "DsmTest::runDsmTest - invalid value for -tests: $args{$_}";
                &main::logcomment($msg);
                $this->_set_err($msg);
            }
            next;
        }
    }

    # build the command for dsmtest
    $cmd = $Host::DSMTEST;

    $cmd .= " /v" if ($verbose);

    $cmd .= " /t:$tests" if ($tests);

    # execute DsmTest
    ($status, @output) = $this->execute($cmd);

    if ($status != $Host::TRUE)
    {
        &main::logcomment("DsmTest::runDsmTest - Command failed: $cmd");
        $this->_set_err(@output);
        goto runDsmTest_EXIT;
    }

    foreach $line (@output)
    {
        if ($line =~ /^(TC\d+)\s+--\s+(\w+)/i)
        {
            if ($2 !~ /PASS/i)
            {
                &main::logcomment("ERROR: DsmTest::runDsmTest - $line");
                $this->_set_err($line);
                goto runDsmTest_EXIT;
            }
            else
            {
                &main::logcomment("PASS: DsmTest::runDsmTest - $line");
            }
        }
    }

runDsmTest_EXIT:

    return;

} # END runDsmTest

1;
