# 
#  $Id: //depot/prod/test/Rsierranevada/lib/ZapiTest.pm#1 $
# 
#  Copyright (c) 2002 Network Appliance, Inc.
#  All rights reserved.
#

# -----------------------------------------------------------
##
## @summary Support routines for Zapi tests
##
## @description
##	This file contains all NATE-specific Zapi things, so that
##	the Zapi.pm module can be completely generic.
##
## @author tjt@netapp.com

package     ZapiTest;

use	Zapi;
use	strict;
use	NaElement;
use	vars ('@ISA', '@EXPORT');
require     Exporter;
@ISA        = qw(Exporter);
@EXPORT     = qw(nate_fail);
@EXPORT     = qw(nate_log);

@ZapiTest::ISA = qw(Zapi);

sub new {
	my $class = shift;
	my $self = new Zapi(@_);
	$self->set_fail_routine(\&ZapiTest::nate_fail);
	$self->set_log_routine(\&ZapiTest::nate_log);
	bless $self, $class;
}

sub nate_fail {
        my $msg = shift;
	Tharn::tstlog('-fail',$msg);
}

sub nate_log {
        my $msg = shift;
	Tharn::tstlog('-commline',$msg);
}

1;
