# Hey emacs, this is basically -*- perl -*-
# $Id: //depot/prod/test/lib/hw-assist-cfo.pm#1
# 
# Copyright (c) 2007 Network Appliance, Inc.
# All rights reserved.
#
##  
## @summary
## Some Lib functions for testing, Implement for HW_Assist_CFO.
## 	
## @description
## This test is to check the generation of snmp trap when Watchdog resets.
##
## @author paulsli@netapp.com
## @status Draft
##

package hw_assist_cfo;
@ISA = Exporter;
require Exporter;
@EXPORT = qw( get_record_id no_hb delete_traphost );

use strict;
use Tharn;
use boot;

sub get_record_id {
    my ($rlm, $cmd ) = @_;

    my (undef, undef, $output) = say($rlm, "$cmd");
    my @output = split ( /\r\n/, $output );
    my $num = 4001;
    for ( my $i = @output; $i > 0; $i -- ) {
        if ( $output[$i -1] =~ /Record\s+(\d+):.+/ ) {
            $num = $1;
            last;
        }
    }
    if ( $num > 4000 ) {
        tstlog ( -config,  "HB id is incorrect." );
    } else {
        tstlog ( -comment, "Latest HB id is $num." );
    }

    return $num;
}

sub no_hb {
    my ( $num1, $num2 ) = @_;

    if ( $num1 < $num2 ) {
        return 0;
    } elsif ( $num1 > $num2 ) {
        if ( $num1 > 3000 && $num2 < 1000 ) {
            return 0;
        } else {
            tstlog ( -config,  "Events id is not resonable." );
        }
    } else {
        return 1;
    }
}

sub delete_traphost {
    my ( $fc ) = @_;

    my (undef, undef, $output ) = say ( $fc, "snmp traphost" ); 
    my @list = split ( /\n/, $output );

    foreach ( @list ) {
        if ( $_ =~ /\s+(\S+)\s+\S+\s+\S+/ ) {
            say ( $fc, "snmp traphost delete $1" );
        }
    }
}

1;
