use Socket;
package TCP;

sub determineDevice
{
    my ($ip, $device) = @_;
    my $hostdevice = "";
    my $gatedevice = "";
    my $gateway = "";
    my $ethernet = "";
    open(NETSTAT, "/bin/netstat -rn|") || die "Could not run netstat: $!\n";
    while (<NETSTAT>) {
	my @route = split(/\s+/, $_);
	next if ($route[0] !~ /\d/);
	next if ($route[3] =~ /H/);
	next if ($route[0] =~ /224.0.0.0/);
	if ($route[0] eq "0.0.0.0") {
	    next if ($device && $device ne $route[7]);
	    $gateway = $route[1];
	    $gatedevice = $route[7];
	    next;
	}
	if ((Socket::inet_aton($ip) & Socket::inet_aton($route[2])) eq (Socket::inet_aton($route[0]))) {
	    if ($device && $device eq $route[7]) {
		$hostdevice = $device;
	    } elsif (!$device) {
		$hostdevice = $route[7];
	    }
	}
    }
    if ($hostdevice ne "") {
	$device = $hostdevice;
    } elsif ($gateway ne "") {
	$device = $gatedevice;
	`/bin/ping -c 1 $gateway`;
	open(ARP, "/sbin/arp -n $gateway|") || die "Could not run /sbin/arp: $!\n";
	while (<ARP>) {
	    my @arp = split(/\s+/, $_);
	    if ($arp[0] eq $gateway) {
		$ethernet = $arp[2];
	    }
	}
	close ARP;
	if ($ethernet eq "") {
	    die "Could not determine ethernet address of gateway $gateway\n";
	}
    } else {
	die "Could not determine device\n";
    }
    close NETSTAT;
    return ($device, $ethernet);
}

1;
