################################################################################
#                                                                              #
# Created by  : Ramya.M.R                                           		   #
# File Name   : OptionOrder.pm                                                 #
#                                                                              #
# Methods     : new         						                           #	
#	          : getOptionOrderArray						                       #	 
# Copyright SMQA , NetApp                                                      #
#                                                                              #
################################################################################

package CommonLibs::OptionOrder;
use strict;
use warnings;
use Data::Dumper;

sub new {
    my $class = shift;
    my $self  = {};
    bless $self, $class;
    return $self;
}
################################################################################
# Subroutine  : getOptionorderArray	                                           #
#                                                                              #
# Description : Obtain OptionOrder for each sub command                        #
#                                                                              #
#                                                                              #
# Returns :   Sorted Array containing Option Order                             #
#                                                                              #
################################################################################

sub getOptionorderArray {
   my $class = shift;
   my $cmd_name = shift;
   my $fullsynopsis = shift; #contains synopsis of each sub command
   my $synopsisref = shift; #contains the hash of each subcommand
   my ($commandname,$synopsis) = split (/[\<\[\{-]/,$fullsynopsis,2);
   my %optionorderhash;
   my %hash = %$synopsisref;
   
   while (my($key,$value) = each(%hash) ) {
	if ((ref ($value) eq 'ARRAY') && ($key !~ /-[a-zA-Z]/)) {#handles mandatory options,alternate param options
	my @array =@$value;
	foreach (@array) {
	unless (ref($_) eq 'HASH') {
	if ($synopsis =~$_) {
	
	$optionorderhash{$_} = index ($synopsis,$_);
	}
	}
	elsif (ref($_) eq 'HASH')
	{
	my %alternateoptions = %$_;
	while (my($mykey,$myvalue) = each(%alternateoptions)) {
	if(ref($myvalue) eq 'ARRAY') {
	my @altopt = @$myvalue;
	foreach(@altopt) {
	if ($synopsis =~$_) {
	# print "FOUND ALT PARAM:$_".index ($synopsis,$_)."is the index\n";
	$optionorderhash{$_} = index ($synopsis,$_);
						}
					}
				}
			}
		}
	}
	}	
	# single switches that map to two or more values egs. -t {shared | dedicated}
		elsif ((ref ($value) eq 'ARRAY') && ($key =~ /-[a-zA-Z]/)) {
		if (($synopsis =~$key))  {
		# print "FOUND IT:$value".index ($synopsis,$key)."is the index\n";
		$optionorderhash{$key."switch"} = index ($synopsis,$key);
	}
		}
	
	unless (ref($value) eq 'ARRAY'| ref($value) eq 'HASH') {#handles switches mapped to programmatic parameter names
	if (($synopsis =~$value) &&($key ne "cmd_sep")) {
	# print "FOUND IT:$value".index ($synopsis,$value)."is the index\n";
	$optionorderhash{$value} = index ($synopsis,$value);
	}
	}
	if (ref($value) eq 'HASH') {#handles single switches
	my %valuehash =%$value;
	while(my($k,$v) = each(%valuehash) ) {
	if ($synopsis =~$k) {
	# print "FOUND single switch:$k".index ($synopsis,$k)."is the index\n";
	$optionorderhash{$v} = index ($synopsis,$k);
	}
	}
	}
  
   }
    # print "OPTIONORDER\n";
  
  # print Dumper(%optionorderhash);
 
    my @sortedarray = (sort { $optionorderhash{$a} <=> $optionorderhash{$b} } keys %optionorderhash);
	# print "SORTEDARRAY:@sortedarray\n";	
   return (\@sortedarray);
   
   
   
   
}
  1;