## @author		khanhn@netapp.com 
## @notes		Created for NFS-v4.x Migration & Referrals testing


# This is to balance the brackets in this file :/
# If you cannot find a matching bracket for these, 
# then there are some brackets inside the file that are not matched !
#{[(

use strict;

use DateTime::Format::Strptime;
use Data::Dumper;
use vars qw($Test);
use Tharn qw($Log);
use Carp qw(croak);
use SPARSE::Util::Logger;
use nfs::Migration;
use nfs::NfsDef qw(DATA_SYNC NFREG UNCHECKED OPEN4_SHARE_ACCESS_BOTH FATTR4_MODE STATEID1
		NFLNK FILE_SYNC FATTR4_SIZE FATTR4_MAXFILESIZE nfs_error);

# Some common variables.
my $NFS_RETRY = 15;     # number of retries following NFS4ERR_DELAY
my $NFS_DELAY = 5;      # delay in seconds between retries
my $MAJOR_VERSION = 4;

#---------------------------------------------------------------------


sub newcc($$$) {
        my $server = shift;
	my $min_ver = shift;
	my $addr_type = shift;

        my $CLIENT;
        my %opts;
        $opts{nfs_retry} = $NFS_RETRY;
        $opts{nfs_delay} = $NFS_DELAY;

        eval {
            $CLIENT = nfs::Migration->new(hostname=>$server,
                                        addr_type=>$addr_type,
                                        %opts,
                                        version=>$MAJOR_VERSION, minor_version=>$min_ver);
        };
        if ($@) {
            $Test->nlog("newcc: Cannot create connection to server $server $@\n");
            return -1;
        }
        return $CLIENT;
}

sub mountme($$) {
        my $CLIENT = shift;
        my $path = shift;
        my %opts;

        # const EXCHGID4_FLAG_SUPP_MOVED_REFER    = 0x00000001;
        # const EXCHGID4_FLAG_SUPP_MOVED_MIGR     = 0x00000002;
        if ($main::MINOR) {
            $opts{eia_flags} = 0x00000003;
        }
        $Test->nlog("mountme: Try to mount $path ");
        eval {
            $CLIENT->mount(path => $path, %opts);
        };
        if ($@) {
            $Test->nlog("mountme: Cannot mount $path $@\n");
            return $@;
        }
        return 0;
}


#)]} --- DO NOT DELETE THIS LINE ---
1;
