# -*- perl -*-
#package chipset_machine;
require "tharnit_lib.pl";
use Data::Dumper;

use vars qw/%flag %chipset_errors/;

sub extract_csv_file ($;$) {
	my $csv_file_name = shift;
	my $socket = shift;
	my $line, @field_header, $prop_flag, $err_flag, $reg_type;

	open (FILE, "$csv_file_name") || logresult ('SCRIPT', "Invalid file or File not exist: $csv_file_name");
	while ($line=<FILE>) {
		$line =~ s/\,+$//;				# Deleting comma(,) at every end of line
		if ($line =~ /^\s*$/) {			# Go to next line, if it is a blank line
			$prop_flag = 0;
			$err_flag = 0;
			next;
		}
		chomp($line);					# Removing newline characters
		$line =~ s/\,\s+|\s+\,/\,/g;	# Removing spaces in every cell

		if ($line =~ /Flag\,Value/i) {
			$prop_flag = 1;
			next;
		}
		if ($prop_flag) {				# Creating %flag hash table
			$line =~ /(\w+)\,(\w+)/;
			$flag{$1} = $2;
		}

		if ($line =~ /^(\w+) (?:Core\s)?Error$/i) {	#/^Global Error$/) {
			$err_flag=1;
			$reg_type = "\U$1\E";
			$line = <FILE>;
			chomp($line);
			$line =~ s/\,\s+|\s+\,/\,/g;	# Removing spaces in every cell
			@field_header = split(/\,/, $line);
			next;
		}
		if ($err_flag) {
			my @field_value = split(/\,/, $line);
			map (s/0x00/0x80/, @field_value) if ($socket == 1);
			$chipset_errors{"$reg_type"}->{$field_value[0]} = {$field_header[0] => $field_value[1], $field_header[1] => $field_value[2], $field_header[2] => $field_value[3]} if (scalar(@field_value) == 4);
			$chipset_errors{"$reg_type"}->{$field_value[0]} = {$field_header[0] => $field_value[1], $field_header[1] => [@field_value[2,3]], $field_header[2] => $field_value[4]} if (scalar(@field_value) == 5);
		}

		if ($line =~ /(\w+) Error (?:Status\s)?Bit Mask\,(\d+)/i) {
			my $mask_size = $2;
			if ($reg_type =~ /$1/i) {
				$chipset_errors{$reg_type .'_MASK_SIZE'} = $mask_size;
			} else {
				logcomment("error in the csv file: reg_type: $reg_type, $1 ");
			}
			$line = <FILE>;
			chomp ($line);
			$line =~ s/\,\s+|\s+\,/\,/g;	# Removing spaces in every cell
			my @bits = split(/\,/, $line);
			shift @bits;
			$line = <FILE>;
			$line =~ s/\,\s+|\s+\,/\,/g;	# Removing spaces in every cell
			chomp ($line);
			my @errs = split(/\,/, $line);
			shift @errs;
	 
			foreach my $x (@errs) {
				$chipset_errors{"$reg_type" . '_MASK'}->{"\U$x\E"} = shift @bits;
			}
		}
	}

#        foreach my $g_err (keys %{$chipset_errors{'GLOBAL_MASK'}}) {
#                if ($g_err =~ /UERR/i) {
#                        my $temp = $g_err;
#                        $temp =~ s/UERR/CERR/i;
#                        $chipset_errors{GLOBAL_MASK}->{"\U$temp\E"} = $chipset_errors{'GLOBAL_MASK'}->{$g_err};
#                }
#        }

}

sub random_order ($) {
	my $matrix = shift;
	my %combinations_hash, @combinations_case_coverage_order=();
	until (scalar (keys %combinations_hash) == scalar @{$matrix} ) {
		my $index = int rand (scalar @{$matrix});
		next if (exists $combinations_hash{$index});
		$combinations_hash{$index} = '';
		push @combinations_case_coverage_order, $matrix->[$index];
	}
	return \@combinations_case_coverage_order;
}
1;
