# $Id: //depot/prod/test/main/lib/platval/platsw/cpr.pm#1 $
#
#       Copyright (c) 2012 Network Appliance, Inc.
#       All Rights reserved
#
## @summary Routines for validating CPR framework
##
####################################################################################################

#package cpr;
require "tharnit_lib.pl";

sub cpr_get_system_config ($) {
        my $conn = shift;
        logcomment ("Getting the system configuration");
        say ($conn, "priv set test", -swallow);
        #say ($conn, "sysconfig -a", -noprompt, -prompt, "$FILER\\*\>", -swallow, '-timeout', 500);
        say ($conn, "sysconfig -a", -noprompt, -prompt, "$FILER".'(\-\d+)?\*\>', -swallow, '-timeout', 500);
        say ($conn, "sysconfig -P", -swallow, '-timeout', 500);
        say ($conn, "sysconfig -M", -swallow, '-timeout', 500);
        my(undef, undef, $output) = say ($conn, "sysconfig -ac", '-swallow', '-timeout', 500);
        if ($output !~ /There are no configuration errors/) {
                logresult ('WARN', "There are configuration errors in the system");
        }
        say ($conn, "vol status -r", '-swallow', '-timeout', 100);
	say ($conn, "df -Vh", '-swallow', '-timeout', 100);
	say ($conn, "df -Ah", '-swallow', '-timeout', 100);
        say ($conn, "sasadmin adapter_state", '-swallow', '-timeout', 100);
	my (undef, undef, $output) = say ($conn, "sasadmin expander_map", '-swallow', '-timeout', 100);
	return ($output);
}

sub cpr_goto_systemshell ($;$) {
        #goto_systemshell(1);
        my $conn = shift;
	my $h = shift;
        if ($h->{hosttype} =~ /ng/) {
		say ($conn, "exit", -swallow);
                say ($conn, "set diag -c off", -swallow);
        } else {
                say ($conn, "priv set test", -swallow);
        }
        say($conn,"systemshell",-noprompt,-prompt,"login:",-swallow,-timeout,30);
        say($conn,"diag",-noprompt,-prompt,"Password:",-swallow,-timeout,30);
        my (undef,undef,$output)=say($conn,"netapp1!",-swallow, -timeout,30);
        if($output !~ /Warning\:  The system shell provides access to low-level/) {
                logresult('FAIL',"Could not connect to systemshell, please ensure login and password are correct\n");
        }
        say ($conn, "sudo bash", -swallow, '-timeout', 300);
}

sub cpr_get_pci_info ($) {
        my $conn = shift;
        my (undef, undef, $pcidump) = say ($conn, "pciscrounge \'*\'", -swallow, '-timeout', 300);
        if ($pcidump =~ /0xffff/) {
                logresult ('FAIL', "PCIe device configuration should not be ffffs, make sure all the devices configuration is proper");
        }
        my (undef, undef, $slot) = say ($conn, "sysctl -n debug.pci_slot.status", -swallow, '-timeout', 300);
	#(my $nvslot_bdf) = $slot =~ /^Slot 2.+Br\[8648\]\((\d\,\d\,\d)\)/mg;	#Temporary till burt fix 595085 available
	#$nvslot_bdf =~ s/\,/\//g;
	#return ($nvslot_bdf, $slot);
	return $slot;
}

sub cpr_get_recoverable_devices_list ($) {
        my $conn = shift;
	my %recv_devices, @sas_downstream_ports, @sas_upstream_ports, @downstream_port_connected_to_sas_card;
        logcomment ("Getting the recoverable devices list");
        my (undef, undef, $output) = say ($conn, "sysctl -n debug.cpr.recoverable_devices", -swallow, '-timeout', 300);
        $output =~ s/^.+0x0\,.+$//mg;
        my @temp_arr = $output =~ /Device ([\d\/]+)\:\s([\d\/]+)/g;

        #say ($conn, "sysctl -n debug.pci_switch.diffmask", -swallow, '-timeout', 30);           #Temporary: Burt: 595263

        for ($i=0; $i<scalar(@temp_arr); $i=$i+2) {
                push @{$recv_devices{$temp_arr[$i+1]}}, $temp_arr[$i];
        }

        foreach my $k (keys %recv_devices) {
                foreach my $d (@{$recv_devices{$k}}) {
                        $d =~ s/\//:/g;
                        if ($d =~ /\d+:0:0/) {
                                push @sas_upstream_ports, $d;
                                next;
                        }
                        push @sas_downstream_ports, $d;
                }
                $k =~ s/\//:/g;
                push @downstream_port_connected_to_sas_card, $k;
        }

        logcomment ("SAS card Downstream Recoverable Devices: @sas_downstream_ports");
        logcomment ("SAS card Upstream Recoverable devices: @sas_upstream_ports");
        logcomment ("MB/IOXM Downstream connected to SAS card devices: @downstream_port_connected_to_sas_card");

	return (\@sas_downstream_ports, \@sas_upstream_ports, \@downstream_port_connected_to_sas_card, \%recv_devices);
}

1;
