##This pm file consists of following functions:
##
##Apiset_creation : param 'sp_agent object''object type of filer'
##
##Create a connection to object of type systemshell or 7mode or cmode or nodescope or firmware.
##
## Apiset_creation_for_sp : param 'sp_agent object''object type of filer'
##
## Create a connection to object of type sp or spshell.
##
## verify_watchdog_1 :param 'sp_agent object'.
##
## Simulate watchdog L1 timer and verifies indeed it happened.
##
## verify_watchdog_2 :param 'sp_agent object'.
##
## Simulate watchdog L2 timer and verifies system is reset.
##
## pelog_dump :param 'sp_agent object'.
##
## It execute pelog dump output for ONTAP region.
##
## delete_ems :param 'sp_agent object'.
##
## It delete ems file from systemshell.
##
## reboot_reason:param 'sp_agent object'.
##
## It outputs contents of EMS file.
##
## clear_sel:param 'sp_agent object'.
##
## Clears events logs from spshell.
##
## verify_events :param 'sp_agent object'.
##
## Execute "Events all" command from SP.
##
## @author:swarup.kulkarni@mindteck.com;dl-pvt-platsw@netapp.com.
##

package sp_agent;

use TCD;
use NACL::APISet;
use NACL::Transit;
use warnings;
use Tharn;
use Carp qw(croak);

#global variables used
our ($FILER,     $PASSWORD, $TIMEOUT,         $Test, $Testcases,
     @Testcases, $Node,     $Obj_systemshell, $flag, $dump_flag,
     $Host,      $Conn,     $Obj_transit,     $SP_IP);

undef $SP_IP;

#local parameters
my ($current_state, $apiset, $apiset_sp, $sp_root_conn,);

#create a new function which is used to access class functions

sub new {
    my $class = shift;
    $FILER = shift;
    _init($FILER);
    my $ref = {};
    bless $ref, $class;
}

sub _init {
    my $FILER = shift;
    $Host        = host($FILER);
    $Conn        = connect("#console");
    $Node        = $Host->hosttype();
    $PASSWORD    = $Host->{'default_password'};
    $Obj_transit = NACL::Transit->new(name => $FILER);
}

sub Apiset_creation {
    my ($arg_no, $self, $object_type);

    $arg_no = scalar(@_);
    if ($arg_no == 2) {
        ($self, $object_type) = ($_[0], $_[1]);
    } else {
        $object_type = $_[0];
    }
    $apiset = NACL::APISet->new(connection => $Conn,
                                category   => "Node",
                                interface  => "CLI",
                                set        => "$object_type");
    return $apiset;
} ## end sub Apiset_creation

#creates apiset obbject for sp or spshell depending on param
sub Apiset_creation_for_sp {
    my ($arg_no, $self, $object_type);

    $arg_no = scalar(@_);

    unless (defined($SP_IP)) {
        $SP_IP = Get_sp_ip();
    }
    if ($arg_no == 2) {
        ($self, $object_type) = ($_[0], $_[1]);
    } else {
        $object_type = $_[0];
    }
    print "object type is $object_type";

    $sp_root_conn = sp_conn($object_type);
    eval {
        $apiset = NACL::APISet->new(connection => $sp_root_conn,
                                    category   => "Node",
                                    interface  => "CLI",
                                    set        => "$object_type");
    };

    if ($@) {
        print "Error is :$@";

    }
    return $apiset;
} ## end sub Apiset_creation_for_sp

#TO get sp connection handler
sub sp_conn {
    my ($SP_LOGIN, $object_typ);

    $object_type = shift;

    if ($Node =~ /ng/) {
        $SP_LOGIN = 'admin';
    } else {
        $SP_LOGIN = 'naroot';
    }
    print "SP Ip is $SP_IP";

    if ($object_type eq 'SPShell') {
        $sp_root_conn = $Host->connect(id       => "sp_shell",
                                       conntype => "ssh-persist",
                                       connhost => $SP_IP,
                                       username => 'root',
                                       password => 'superuser',
                                       prompts  => ["# "]);
    } else {
        $sp_root_conn = $Host->connect(id       => "sp_login",
                                       conntype => "ssh-persist",
                                       connhost => $SP_IP,
                                       username => $SP_LOGIN,
                                       password => $PASSWORD);
    }
    return $sp_root_conn;
} ## end sub sp_conn

#Simulate watchdog 1 Timer
sub verify_watchdog_1 {
    my ($out, @watchog_output, $self);

    $self = shift;
    undef $Obj_systemshell;
    @watchog_output = 'watchdog nmi on';
    $Obj_transit->change_state(to => 'SYSTEMSHELL', password => "$PASSWORD", timeout => '500');
    $Obj_systemshell = Apiset_creation('Systemshell');

    try {
        $Obj_systemshell->execute_raw_command(command => "sudo sysctl debug.watchdog.hang_cpu=1",
                                              prompts => (\@watchog_output));
        return 1;
    }
    catch NATE::BaseException with {
        my $exception = shift;
        my $message   = $exception->text();
        print("Got message as :$message");
        return 0;
    };
} ## end sub verify_watchdog_1

#Simulate watchdog 2 Timer
sub verify_watchdog_2 {
    my ($out, @watchog_output, $self);

    undef $Obj_systemshell;
    $self           = shift;
    @watchog_output = 'Bios Version';

    $Obj_transit->change_state(to => 'SYSTEMSHELL', password => "$PASSWORD", timeout => '500');
    $Obj_systemshell = Apiset_creation('Systemshell');

    try {
        $Obj_systemshell->execute_raw_command(command => "sudo sysctl debug.watchdog.hang_cpu=1",
                                              prompts => (\@watchog_output),
                                              timeout => '100');
        return 1;
    }
    catch NATE::BaseException with {
        my $exception = shift;
        my $message   = $exception->text();
        print("Got message as :$message");
        return 0;
    };
} ## end sub verify_watchdog_2

#Dump Pelog info on loader for ONTAP
sub pelog_dump {
    my ($output);
    my $self = shift;
    $apiset_loader = Apiset_creation('Firmware');
    $apiset_loader->execute_raw_command(command => 'priv set test');
    $output = $apiset_loader->execute_raw_command(command => 'pelog -g=2 -a');
    return $output;
}

#To delete EMS messages
sub delete_ems {
    my $self = shift;
    $Obj_transit->change_state(to => 'SYSTEMSHELL', password => "$PASSWORD", timeout => '500');
    $Obj_systemshell = Apiset_creation('Systemshell');
    $Obj_systemshell->execute_raw_command(command => 'rm /mroot/etc/log/ems*');
}

#To verify reboot reason from ems log
sub reboot_reason {
    my ($self, @match);
    @match = 'reboot_reason';
    $self  = shift;
    $Obj_transit->change_state(to => 'SYSTEMSHELL', password => "$PASSWORD", timeout => '500');
    snooze(100);

    $Obj_systemshell = Apiset_creation('Systemshell');
    $output =
      $Obj_systemshell->execute_raw_command(command => 'cat /mroot/etc/log/ems', timeout => '300');
    return $output;
} ## end sub reboot_reason

#clear the events logs
sub clear_sel {
    my ($self);

    $self = shift;
    $Obj_transit->change_state(to => 'SP_ROOT');
    $spshell = Apiset_creation_for_sp('SPShell');
    $spshell->execute_raw_command(command => "sel clear");

}

#Verify the events from SP
sub verify_events {
    my ($output, $self);

    $self    = shift;
    $spshell = Apiset_creation_for_sp('SP');
    snooze(30);
    $temp_output = $spshell->sp_events('all' => '1');
    $output = $temp_output->get_processed_output();
    return $output;
} ## end sub verify_events

#To get Sp Ip for getting info creating Sp object
sub Get_sp_ip {
    my ($output, $SP_IP, $object_type, $Node, $apiset_ontap, $current_state, $apiset_loader);

    $output = 0;
    $Host   = host($FILER);
    $Conn   = connect("#console");

    # creating transit object
    $Node = $Host->hosttype();

    if ($Obj_transit->get_state() eq 'FIRMWARE') {
        $apiset_loader = Apiset_creation("Firmware");
        $output = $apiset_loader->execute_raw_command(command => 'sp status', timeout => '300');

    } else {
        $Obj_transit->change_state(to => 'CLI', password => "$PASSWORD", timeout => '300');
        if ($Node =~ /ng/) {
            $object_type = 'Nodescope';
        } else {
            $object_type = '7Mode';
        }
        $apiset_ontap = Apiset_creation("$object_type");
        $output = $apiset_ontap->execute_command(command => "sp status", timeout => '300');
    } ## end else [ if ($Obj_transit->get_state...
    if ($output =~ /IP+\s+Address:+\s+([\d\.]+)/ig) {
        $SP_IP = $1;
    }
    return $SP_IP;
} ## end sub Get_sp_ip

1;
