require "tharnit_lib.pl";
use cluster;
#use rlm_ipv6;
use platval::service_processor::rlm_ipv6;

use vars qw/%hw_test_states $self_partner_ip $part_partner_ip/;

$DEBUG = 0;

sub load_ipv4_ipv6_HW_ASSIST_config_cases {
        %hw_test_cases = (
                1 => ["Case 1. hw_assist partners are IPv4 addresses and $RLM_PROMPT's have IPv4 addresses",2,1,1,1],
        );

        unless ($NO_IPv6) {
                %hw_test_cases = (%hw_test_cases,
                        2 => ["Case 2. hw_assist partners are IPv4 addresses and both $RLM_PROMPT's have IPv4 and Ipv6 addresses",5,1,1,1],
                        3 => ["Case 3. hw_assist partners are IPv6 addresses and both $RLM_PROMPT's have only Ipv6 addresses",4,1,1,1],
                        4 => ["Case 4. hw_assist partners are IPv6 addresses and both $RLM_PROMPT's have IPv4 and Ipv6 addresses",5,1,1,1],
                        5 => ["Case 5. hw_assist partners are IPv4 addresses and both $RLM_PROMPT's have only Ipv6 addresses",4,0,0,0],
                        6 => ["Case 6. hw_assist partners are IPv6 addresses and both $RLM_PROMPT's have only IPv4 addresses",2,0,0,0],
                );
        }
}


sub hwassist_test_results {
	
	my $case = shift;
	my $type = shift;
	my $stats_results = shift;
	my $statistics_results = shift;
        my $events_results = shift;

	my $stats = 1;
	my $statistics = 1;
        my $events = 1;

        tstlog -comment,"Case:$case \n Type:$type";

	if(($type == 3) || ($type == 4)) {
		$hw_test_cases{$case}->[2] = 0;
		$hw_test_cases{$case}->[3] = 0;
		$hw_test_cases{$case}->[4] = 0;
	}

	unless($stats_results == $hw_test_cases{$case}->[2]) {
                logresult('FAIL',"Stats are Not updated properly");
                $stats = 0;
        }

	unless($statistics_results == $hw_test_cases{$case}->[3]) {
                logresult('FAIL',"Statistics are Not updated properly");
                $statistics = 0;
        }

        if ($RLM_PROMPT !~ /RLM/) {
                unless($events_results == $hw_test_cases{$case}->[4]) {
                        logresult('FAIL',"Events are Not updated properly");
                        $events = 0;
                }
        }

	return $stats,$statistics,$events;
}





sub verify_HW_ASSIST_testcase_validity {

	my $TEST_CASE = shift;
        my $no_ipv6;

        if ($NO_IPv6) {
                $no_ipv6 = $NO_IPv6;
                undef ($NO_IPv6);
                load_ipv4_ipv6_HW_ASSIST_config_cases();
        }

        if ($TEST_CASE > 0 && $TEST_CASE <= scalar(keys %hw_test_cases)) {
                logresult ('NA', "Case: $TEST_CASE :- " . $hw_test_cases{$TEST_CASE}->[0] . " can't be execuated as \"$no_ipv6\" ");
        } else {
                logresult ('NA', "Invalid test case/state: $TEST_CASE. See the tharndoc for more info");
        }
}



sub check_ontap_rlm_config_status {
	my $FILERA = shift;
	my $FILERB = shift;
        my $case = shift;
        
	cf_status_precheck($FILERA,$FILERB,1);

        $self_partner_ip = check_ontap_config_status($FILERA,$FILERB,$case);
	$part_partner_ip = check_ontap_config_status($FILERB,$FILERA,$case);

	rlm_load_ipv4_ipv6_config_cases($FILERA);
	set_rlm_per_case($FILERA,$FILERB,$case,$part_partner_ip) if($case > 4);
	logcomment ("$RLM_PROMPT is setting for the configuration. Testcase: " . $hw_test_cases{$case}->[1] . "\n");
	sleep 20;
        rlm_setup($FILERA,$test_states{$hw_test_cases{$case}->[1]});
	rlm_reboot_rlm($FILERA);	
	sleep(60);
        rlm_verify_rlm_status($FILERA,'ONTAP',$hw_test_cases{$case}->[1]);

	rlm_load_ipv4_ipv6_config_cases($FILERB);
	set_rlm_per_case($FILERB,$FILERA,$case,$self_partner_ip) if($case > 4);
	logcomment ("$RLM_PROMPT is setting for the configuration. Testcase: " . $hw_test_cases{$case}->[1] . "\n");
	sleep 20;
        rlm_setup($FILERB,$test_states{$hw_test_cases{$case}->[1]});
        rlm_reboot_rlm($FILERB);
	sleep(60);
        rlm_verify_rlm_status($FILERB,'ONTAP',$hw_test_cases{$case}->[1]);

	unless($case > 4) {
		logcomment ("FILERB = $FILERB have $self_partner_ip");
		set_cf_hwassist_partner_ip($FILERB,$FILERA,$self_partner_ip);
		logcomment ("FILERA = $FILERA have $part_partner_ip");
		set_cf_hwassist_partner_ip($FILERA,$FILERB,$part_partner_ip);

		sleep(60);
	}	
}



sub set_rlm_per_case {

	my $FILERA = shift;
	my $FILERB = shift;
	my $case = shift;
	my $ip = shift;

	rlm_setup($FILERA,$test_states{5});
	rlm_reboot_rlm($FILERA);
        sleep(60);
        rlm_verify_rlm_status($FILERA,'ONTAP',5);
	
	logcomment ("FILERA = $FILERA have $ip");
	set_cf_hwassist_partner_ip($FILERA,$FILERB,$ip);
}

sub check_ontap_config_status {
        my $FILERA = shift;
        my $FILERB = shift;
        my $setup = shift;

	my $partner_ip;

	my $fcA = rlm_make_conn_to_ontap($FILERA);
	my $fhA = rlm_make_host_to_ontap($FILERA);

	my $self_default_ip = $fhA->default_ip;
	
	my $self_default_ipv6 = $fhA->default_ipv6;

	tstlog -comment, "Default_IPv4_IP = $self_default_ip \n Default_IPv6_IP = $self_default_ipv6 \n ";

	unless ($self_default_ip && $self_default_ipv6) {
		logresult ('SCRIPT', "To run this script, filer tharnhost file should have the following fileds: default_ip and default_ipv6");
	}

	my (undef,undef,$out) = say($fcA,"\r\n",'-swallow','-timeout', 60);
	sleep 2;
        my (undef,undef,$out) = say($fcA,"ifconfig -a",'-swallow','-timeout', 60);

        if ($setup == 1) {
                if($out =~ /$self_default_ip/) {
                        $partner_ip = $self_default_ip;
                } else {
                        tstlog -comment,"Setup Proper IPv4 IP for FILER";
                }
        } elsif ($setup == 2) {
                if($out =~ /$self_default_ip/) {
                        $partner_ip = $self_default_ip;
                } else {
                        tstlog -comment,"Setup Proper IPv4 IP for FILER";
                }
        } elsif ($setup == 3) {
                if($out =~ /$self_default_ipv6/) {
                        $partner_ip = $self_default_ipv6;
                } else {
                        tstlog -comment,"Setup Proper IPv4 IP for FILER";
                }
        } elsif ($setup == 4) {
                if($out =~ /$self_default_ipv6/) {
                        $partner_ip = $self_default_ipv6;
                } else {
                        tstlog -comment,"Setup Proper IPv4 IP for FILER";
                }
        } elsif ($setup == 5) {
                if($out =~ /$self_default_ip/) {
                        $partner_ip = $self_default_ip;
                } else {
                        tstlog -FAIL,"Setup Proper IPv4 IP for FILER";
                }
        } elsif ($setup == 6) {
                if($out =~ /$self_default_ipv6/) {
                        $partner_ip = $self_default_ipv6;
                } else {
                        tstlog -FAIL,"Setup Proper IPv4 IP for FILER";
                }
        }

	tstlog -comment,"PARTNER_IP:$partner_ip";
	return $partner_ip;
}

my $ssh_index = 1;

sub cf_hwassist_statistics {

        my $FILER = shift;

	my $fh = rlm_make_host_to_ontap($FILER);

        tstlog -comment,"Checking $RLM Status -d Command for $FILER";

	if($ipv4_ip) {
                $ip = $fh->{'RLM_IP'};
        } elsif(($ipv6_global_ip !~ /Disabled|unknown/i) && $ipv6_global_ip && ($ipv6_global_ip ne $ipv6_gateway)) {
                $ip = $fh->{'RLM_IPV6_IP'};
        } elsif($ipv6_router_ip) {
                $ip = $fh->{'RLM_IPV6_ROUTER'};
        }

	my $rlm_pt = rlm_make_conn_to_rlm($FILER,$ip);

        my (undef,undef,$out,undef) = say($rlm_pt,"$RLM status -d",'-timeout',1000);
        my %hwassist_status_d = $out =~ /trap\sdaemon.+(takeover enable)\s+(\d+).+(takeover trap power_off_via_$RLM)\s+(\d+).+(takeover trap power_cycle_via_$RLM)\s+(\d+).+(takeover trap reset_via_$RLM)\s+(\d+).+(takeover trap post_error)\s+(\d+).+(takeover trap abnormal_reboot)\s+(\d+).+(takeover trap l2_watchdog_timeout)\s+(\d+).+(takeover trap power_loss)\s+(\d+).+(takeover trap loss_of_heartbeat)\s+(\d+).+(takeover test trap)\s+(\d+).+(takeover test trap failure)\s+(\d+).+/s;

	my %hwassist_conf_status_d;

	($hwassist_conf_status_d{'takeover_enable'})	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+takeover_enable\s+(\w+)/s;
	($hwassist_conf_status_d{'partner_ip'})		= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+partner_ip\s+([\w\.\:]+)/s;
	($hwassist_conf_status_d{'partner_port'})       = $out =~ /\/mnt\/logs\/etc\/takeover_conf.+partner_port\s+(\d+)/s;
	($hwassist_conf_status_d{'hello_interval'}) 	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+hello_interval\s+(\d+)/s;
	($hwassist_conf_status_d{'repeat_count'}) 	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+repeat_count\s+(\d+)/s;
	($hwassist_conf_status_d{'secret'})       	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+secret\s+(\w+)/s;
	($hwassist_conf_status_d{'ip_family'})    	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+ip_family\s+(\d+)/s;
	($hwassist_conf_status_d{'partner_ip6'})  	= $out =~ /\/mnt\/logs\/etc\/takeover_conf.+partner_ip6\s+([\w\:]+)/s;

	disconnect($rlm_pt);

        return \%hwassist_status_d,\%hwassist_conf_status_d;
}


sub test_hwassist_statistics {
        my ($before,$after) = @_;

        foreach my $k (keys %{$before}) {
		unless ($after->{$k} >= ($before->{$k})) {
			logresult('FAIL', "Count Not Incremented");
                }
        }

        logcomment ("hwassist_statistics Incremented or As Expected");
}


sub test_hwassist_statistics_check($$$;$) {
        my ($before,$after,$msg,$negative) = @_;
        foreach my $k (keys %{$before}) {
                if ($k =~ /$msg/) {
                        if ($after->{$k} == ($before->{$k}+1)) {
				logcomment ("PASS\n After = $after->{$k} \n Before = $before->{$k} \n");
				return 1;
			} elsif ($after->{$k} == ($before->{$k}) && $negative =~ /cf_takeover|halt|panic|reboot|watchdog_hang|watchdog_hard_hang/) {
		# elseif to check negative testcases
                                logcomment ("PASS\n After = $after->{$k} \n Before = $before->{$k} \n");
                                return 1;
                            } else {
				logcomment ("FAIL\n After = $after->{$k} \n Before = $before->{$k} \n");
				return 0;
                        }
                }
        }
}



sub cf_hwassist_stats {
    	my $FILER = shift;

    	my $fcA = rlm_make_conn_to_ontap($FILER);

	my (undef,undef,$out) = say($fcA,"\r\n",'-swallow','-timeout',60,'-eval_error');
    	my (undef,undef,$out) = say($fcA,"cf hw_assist stats",'-swallow','-timeout',60);
	tstlog -comment, "OUT= $out\n";	

	#sleep 10;

	my %hw_assist_stats;

	($hw_assist_stats{'power_loss'}) 	   = $out =~ /power_loss\s+(\d+)/;
	($hw_assist_stats{'l2_watchdog_reset'})    = $out =~ /l2_watchdog_reset\s+(\d+)/;
	($hw_assist_stats{"power_off_via_$RLM"})   = $out =~ /power_off_via_$RLM\s+(\d+)/;
	($hw_assist_stats{"power_cycle_via_$RLM"}) = $out =~ /power_cycle_via_$RLM\s+(\d+)/;
	($hw_assist_stats{"reset_via_$RLM"})       = $out =~ /reset_via_$RLM\s+(\d+)/;
	($hw_assist_stats{'post_error'})           = $out =~ /post_error\s+(\d+)/;
	($hw_assist_stats{'abnormal_reboot'})      = $out =~ /abnormal_reboot\s+(\d+)/;
	($hw_assist_stats{'loss_of_heartbeat'})    = $out =~ /loss_of_heartbeat\s+(\d+)/;
	($hw_assist_stats{'test'})		   = $out =~ /test\s+(\d+)/;
	($hw_assist_stats{'periodic_message'})	   = $out =~ /periodic_message\s+(\d+)/;

	return \%hw_assist_stats;
}



sub test_hwassist_stats {
        my ($before,$after,$msg) = @_;

        foreach my $k (keys %{$before}) {
		if ($k eq "$msg") {
			if ($after->{$k} == ($before->{$k}+2)) {
				return 1;
			} else {
				return 0;
			}
                } elsif ($after->{$k} ne $before->{$k}) {
			return 0;
                } else {
			return 0;
		}
        }
}




sub test_hwassist_stats_check($$$;$) {
        my ($before,$after,$msg,$negative) = @_;
                foreach my $k (keys %{$before}) {
		#tstlog -comment,"Inside Stats Forloop Check";
                if ($k =~ /$msg/) { 
			if($after->{$k} == ($before->{$k}+2)) {
				logcomment ("PASS\n After = $after->{$k} \n Before = $before->{$k} \n");
				return 1;
                                     } elsif($after->{$k} == ($before->{$k})&& $negative =~ /cf_takeover|halt|panic|reboot|watchdog_hang|watchdog_hard_hang/) {
		# elseif Codition to check negative testcases 
                                logcomment ("PASS\n After = $after->{$k} \n Before = $before->{$k} \n");
                                return 1;
                           }    else {
				logcomment ("FAIL\n After = $after->{$k} \n Before = $before->{$k} \n");
				return 0;
			}
                }
        }
	#tstlog -comment,"Outside Stats Check";
}



sub cf_hwassist_ss_get {
	my $FILER = shift;

	my $fcA = rlm_make_conn_to_ontap($FILER);

	my (undef, undef, $out) = say($fcA,"priv set test;cf test_hw_assist ss get",'-swallow','-timeout', 60);
	tstlog -comment, "OUT= $out\n";

	my %hw_assist_ss_get = $out =~ /(Local ss)\s+(\w+)\s+(Partner ss)\s+(\w+)\s+/;

	return \%hw_assist_ss_get;	
}


sub test_hwassist_ss_get {
	my ($before,$after) = @_;

	if(($before->{'Local ss'} eq $after->{'Partner ss'}) &&	($before->{'Partner ss'} eq $after->{'Local ss'})) {
		return 1;
	} else {
		return 0;
	}
}


sub test_hwassist_ss_update {
        my ($beforeA,$afterA,$beforeB,$afterB) = @_;

        if(($beforeA->{'Local ss'} ne $afterA->{'Local ss'}) && ($beforeB->{'Partner ss'} ne $afterB->{'Partner ss'})) {
                return 1;
        } else {
                return 0;
        }
}



sub cf_hwassist_events {
	my $FILER = shift;

        my $fh = rlm_make_host_to_ontap($FILER);

        tstlog -comment,"Checking SP/RLM Events Commands";

	if($ipv4_ip) {
                $ip = $fh->{'RLM_IP'};
        } elsif(($ipv6_global_ip !~ /Disabled|unknown/i) && $ipv6_global_ip && ($ipv6_global_ip ne $ipv6_gateway)) {
                $ip = $fh->{'RLM_IPV6_IP'};
        } elsif($ipv6_router_ip) {
                $ip = $fh->{'RLM_IPV6_ROUTER'};
        }	

        my $rlm_pt = rlm_make_conn_to_rlm($FILER,$ip);

        my (undef,undef,$out) = say($rlm_pt, "events search hwassist",'-swallow','-timeout',120);

	disconnect($rlm_pt);

	return $out;
}



sub test_hwassist_events_check($$$;$) {
        my ($before,$after,$msg,$negative) = @_;

	my @out1 = $before =~ /Record.+hwassist $msg/mg;

	my @out2 = $after =~ /Record.+hwassist $msg/mg;

	if($out1[-1] ne $out2[-1]) {
		logcomment("PASS\nEvents Occured Are \nAfter :$out1[-1] \n Before :$out2[-1]");
		return 1;
	}elsif ($out1[-1] eq $out2[-1] && $negative =~ /cf_takeover|halt|panic|reboot|watchdog_hang|watchdog_hard_hang/)  {
	# To check negative testcases
                logcomment("PASS\nEvents Occured Are \nAfter :$out1[-1] \n Before :$out2[-1]");
                return 1;
		} else {
		logcomment("FAIL\nEvents Occured Are \nAfter :$out1[-1] \n Before :$out2[-1]");
		return 0;
        }
}	



sub cf_hwassist_partner_details {

	my $FILER = shift;

	my $fcA = rlm_make_conn_to_ontap($FILER);
	
	my (undef,undef,$out) = say($fcA,"\r\n",'-swallow','-timeout',60);
	my (undef,undef,$out1) = say($fcA,"options cf.hw_assist",'-swallow','-timeout',60);

	tstlog -comment, "OUT1= $out1\n" if($DEBUG);

	my %hw_assist_partner_conf = $out1 =~ /(enable)\s+(\w+).+(address)\s+([\w\.\:]+).+(port)\s+(\d+).+/s;

	my (undef,undef,$out2) = say($fcA,"options cf.hw_assist.health_check_interval",'-swallow','-timeout', 60);

	tstlog -comment, "OUT2= $out2\n" if($DEBUG);

	%hw_assist_partner_conf = (%hw_assist_partner_conf, $out2 =~ /(health_check_interval)\s+(\d+)/);

	my (undef,undef,$out3) = say($fcA,"priv set test;cf test_hw_assist ss get",'-swallow','-timeout', 60);

	tstlog -comment, "OUT3= $out3\n" if($DEBUG);

	%hw_assist_partner_conf = (%hw_assist_partner_conf, $out3 =~ /(Local ss)\s+(\w+)/);

	my $hw_assist_partner = \%hw_assist_partner_conf;

	tstlog -comment, "$hw_assist_partner->{'enable'} \n $hw_assist_partner->{'address'} \n $hw_assist_partner->{'port'} \n $hw_assist_partner->{'health_check_interval'} \n $hw_assist_partner->{'Local ss'} \n" if($DEBUG);

	return \%hw_assist_partner_conf;
}



sub test_hwassist_get_partner_details {

	my ($before,$after) = @_;

	tstlog -comment,"$before->{'enable'} \n $before->{'address'} \n $before->{'port'} \n $before->{'health_check_interval'} \n $before->{'Local ss'} \n" if($DEBUG);

	tstlog -comment,"$after->{'takeover_enable'} \n $after->{'partner_ip'} \n $after->{'partner_port'} \n $after->{'hello_interval'} \n $after->{'secret'} \n $after->{'ip_family'} \n $after->{'repeat_count'}" if($DEBUG);

	unless($before->{'enable'} eq $after->{'takeover_enable'}) {
		logcomment("Partner Details Are Mismatching(1) \n Before = $before->{'enable'} \n After = $after->{'takeover enable'}\n");
		return 0;
	}

	unless(($before->{'address'} eq $after->{'partner_ip'}) || ($before->{'address'} eq $after->{'partner_ip6'})) {
                logcomment("Partner Details Are Mismatching(2) \n Before = $before->{'address'} \n After = $after->{'partner_ip'}\n");
		return 0;
        }

	unless($before->{'port'} eq $after->{'partner_port'}) {
                logcomment("Partner Details Are Mismatching(3) \n Before = $before->{'port'} \n After = $after->{'partner_port'}\n");
		return 0;
        }

	unless($before->{'health_check_interval'} eq $after->{'hello_interval'}) {
                logcomment("Partner Details Are Mismatching(4) \n Before = $before->{'health_check_interval'} \n After = $after->{'hello_interval'}\n");
		return 0;
        }

	unless($before->{'Local ss'} eq $after->{'secret'}) {
                logcomment("Partner Details Are Mismatching(5) \n Before = $before->{'Local ss'} \n After = $after->{'secret'}\n");
		return 0;
        }

	unless(($after->{'ip_family'} == 2) || ($after->{'ip_family'} == 10)) {
                logcomment("Partner Details Are Mismatching(6) \n IP_FAMILY = $after->{'ip_family'}\n");
		return 0;
        }	

	unless($after->{'repeat_count'} == 2) {
                logcomment("Partner Details Are Mismatching(7) \n REPEAT_COUNT = $after->{'repeat_count'}\n");
		return 0;
        }
	
	return 1;
}


sub test_cf_hwassist_partner_port {
	
	my $self = shift;
        my $part = shift;
        my $port = shift;

	my $result;

	$result = set_cf_hwassist_partner_port($self,$part,0);
	unless ($result == 2) {
		 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
	}

	$result = set_cf_hwassist_partner_port($self,$part,100);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,-100);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,4501);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,3900);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,-4000);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,-4500);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG Port number and it was successful or the expected msgs are not printed";
        }	

	$result = set_cf_hwassist_partner_port($self,$part,4444);
	unless ($result == 1) {
                 tstlog -FATAL, "Tried to set the Port number and it was not successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_port($self,$part,$port);
	unless ($result == 1) {
                 tstlog -FATAL, "Tried to set the Port number and it was not successful or the expected msgs are not printed";
        }

	if($result == 1) {
                logresult(PASS,"Test Check for partner_port of $self Successful");
        } else {
                logresult(FATAL,"Test Check for partner_port of $self Not Successful");
        }
}


sub set_cf_hwassist_partner_port {

	my $self = shift;
        my $part = shift;
        my $port = shift;

        my $fc = rlm_make_conn_to_ontap($self);

	my @wait_strings = ('Validating the new hw\-assist configuration\. Please wait','Warning\: Same partner port is being set\, so partner port is not modified\!\!','Partner port number should be in the range 4000 to 4500');

	say($fc,"\r\n",'-swallow','-timeout',60);
	sleep 2;
	my ($out,$undef1,$undef2,$undef3) = say($fc,"options cf.hw_assist.partner.port $port",'-swallow','-noprompt','-wait',@wait_strings,'-prompt',@prompts,'-timeout',60);
	#tstlog -comment, "OUT1= $out\n";
	#tstlog -comment, "UNDEF1= $undef1\n";
	#tstlog -comment, "UNDEF2= $undef2\n";
	#tstlog -comment, "UNDEF3= $undef3\n";
	sleep 2;
	say($fc,"\r\n",'-swallow','-timeout',60);
	my ($out3,$undef4,$undef5,$undef6) = say($fc,"options cf.hw_assist.partner.port",'-swallow','-noprompt','-wait','cf\.hw_assist\.partner\.port\s+\d+','-prompt',@prompts,'-timeout',60);
	#tstlog -comment, "OUT3= $out3\n";
	#tstlog -comment, "UNDEF1= $undef1\n";
        #tstlog -comment, "UNDEF2= $undef2\n";
        #tstlog -comment, "UNDEF3= $undef3\n";
	sleep 2;
        my (undef,undef,$out2) = say($fc,"cf hw_assist status",'-swallow','-timeout',60);
	#tstlog -comment, "OUT2= $out2\n";
	sleep 2;

	if($DEBUG) {
		tstlog -comment, "OUT1= $out\n";
		tstlog -comment, "UNDEF1= $undef1\n";
		tstlog -comment, "UNDEF2= $undef2\n";
		tstlog -comment, "UNDEF3= $undef3\n";
		tstlog -comment, "OUT3= $out3\n";
                tstlog -comment, "UNDEF4= $undef4\n";
                tstlog -comment, "UNDEF5= $undef5\n";
                tstlog -comment, "UNDEF6= $undef6\n";
		tstlog -comment, "OUT2= $out2\n";
	}

        if ($out3 =~ /$port/ && ($out =~ /Validating the new hw-assist configuration. Please wait/ || $out =~ /Warning: Same partner port is being set, so partner port is not modified!!/) && $out2 =~ /Active: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Active: $part monitoring alerts from partner\($self\)/) {
                return 1;
        } elsif ($out =~ /Partner port number should be in the range 4000 to 4500/ && $out2 =~ /Active: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Active: $part monitoring alerts from partner\($self\)/) {
                return 2;
        } else {
                return 0;
        }
}


sub test_cf_hwassist_health_check_interval {

	my $self = shift;
        my $part = shift;
        my $interval = shift;

        my $result;

        $result = set_cf_hwassist_health_check_interval($self,$part,0);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,1000);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,20);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,-50);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,-80);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,-900);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,59);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,-60);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,901);
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,"abc");
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG health_check_interval and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_health_check_interval($self,$part,90);
        unless ($result == 1) {
                 tstlog -FATAL, "Tried to set the health_check_interval and it was not successful or the expected msgs are not printed";
        }

	#sleep 20;

	$result = set_cf_hwassist_health_check_interval($self,$part,$interval);
	unless ($result == 1) {
                 tstlog -FATAL, "Tried to set the health_check_interval and it was not successful or the expected msgs are not printed";
        }

	if($result == 1) {
                logresult(PASS,"Test Check for health_check_interval of $self Successful");
        } else {
                logresult(FATAL,"Test Check for health_check_interval of $self Not Successful");
        }
}


sub set_cf_hwassist_health_check_interval {

	my $self = shift;
        my $part = shift;
        my $interval = shift;

        my $fc = rlm_make_conn_to_ontap($self);

	my @wait_strings = ('Same health interval is being set\, so health interval is not modified','Health interval should be in the range 60 to 900');

	say($fc,"\r\n",'-swallow','-timeout',60);
	sleep 2;
	my ($undef1,$undef2,$out,$undef3) = say($fc,"options cf.hw_assist.health_check_interval $interval",'-swallow','-timeout', 60);
	#tstlog -comment, "OUT1= $out\n";
	sleep 2;
	say($fc,"\r\n",'-swallow','-timeout',60);
	my ($out3,$undef4,$undef5,$undef6) = say($fc,"options cf.hw_assist.health_check_interval",'-swallow','-noprompt','-wait','cf\.hw_assist\.health_check_interval\s+\d+','-prompt',@prompts,'-timeout',60);
	my ($temp_interval) = $out3 =~ /cf\.hw_assist\.health_check_interval\s+(\d+)/;
	#tstlog -comment, "OUT3= $out3\n temp_interval=$temp_interval\n";
	sleep 2;
        my (undef,undef,$out2) = say($fc,"cf hw_assist status",'-swallow','-timeout', 60);
	#tstlog -comment, "OUT2= $out2\n";
	sleep 2;

	if($DEBUG) {
                tstlog -comment, "OUT1= $out\n";
                tstlog -comment, "UNDEF1= $undef1\n";
                tstlog -comment, "UNDEF2= $undef2\n";
                tstlog -comment, "UNDEF3= $undef3\n";
                tstlog -comment, "OUT3= $out3\n";
                tstlog -comment, "UNDEF4= $undef4\n";
                tstlog -comment, "UNDEF5= $undef5\n";
                tstlog -comment, "UNDEF6= $undef6\n";
                tstlog -comment, "OUT2= $out2\n";
        }

	if ($out2 =~ /Active: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Active: $part monitoring alerts from partner\($self\)/) {
		if (($temp_interval eq $interval) && $out =~ /Same health interval is being set, so health interval is not modified/) {
			tstlog -comment, "RETURN:1";
			return 1;
		} elsif ($temp_interval eq $interval) {
			tstlog -comment, "RETURN:1";
			return 1;
		} elsif ($out =~ /Health interval should be in the range 60 to 900/) {
			tstlog -comment, "RETURN:2";
			return 2;
		}
	} else {
		tstlog -comment, "RETURN:0";
                return 0;
        }
}


sub test_cf_hwassist_partner_ip {

	my $self = shift;
        my $part = shift;
        my $ip = shift;

        my $result;

        $result = set_cf_hwassist_partner_ip($self,$part,"0.0.0.0");
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG IP Address and it was successful or the expected msgs are not printed";
        }	

#	$result = set_cf_hwassist_partner_ip($self,$part,4000);
#	unless ($result == 2) {
#                 tstlog -FATAL, "Tried to set the WRONG IP Address and it was successful or the expected msgs are not printed";
#        }

	$result = set_cf_hwassist_partner_ip($self,$part,"abc");
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG IP Address and it was successful or the expected msgs are not printed";
        }

#	$result = set_cf_hwassist_partner_ip($self,$part,0);
#	unless ($result == 2) {
#                 tstlog -FATAL, "Tried to set the WRONG IP Address and it was successful or the expected msgs are not printed";
#        }

	$result = set_cf_hwassist_partner_ip($self,$part,"2.2.2.2");
	unless ($result == 2) {
                 tstlog -FATAL, "Tried to set the WRONG IP Address and it was successful or the expected msgs are not printed";
        }

	$result = set_cf_hwassist_partner_ip($self,$part,$ip);
	unless ($result == 1) {
                 tstlog -FATAL, "Tried to set the Partner IP Address and it was not successful or the expected msgs are not printed";
        }

	if($result == 1) {
                logresult(PASS,"Test Check for partner_ip of $self Successful");
        } else {
                logresult(FATAL,"Test Check for partner_ip of $self Not Successful");
        }
}


sub set_cf_hwassist_partner_ip {

	my $self = shift;
        my $part = shift;
        my $ip = shift;

        my $fc = rlm_make_conn_to_ontap($self);

	my @wait_strings = ('Validating the new hw-assist configuration. Please wait','Same partner address is being set, so partner address is not modified','Invalid IP address','Couldn\'t convert the hostname into IP address','RLM has no IPv4 address configured\.Configure a valid IPv4 address for RLM');

	say($fc,"\r\n",'-swallow','-timeout', 60);
	my ($out,$undef1,$undef2,$undef3) = say($fc,"options cf.hw_assist.partner.address $ip",'-swallow','-noprompt','-wait',@wait_strings,'-prompt',@prompts,'-timeout',60);
	#tstlog -comment, "OUT1= $out\n";
	sleep 2;
	say($fc,"\r\n",'-swallow','-timeout',60);
	my ($out3,$undef4,$undef5,$undef6) = say($fc,"options cf.hw_assist.partner.address",'-swallow','-noprompt','-wait','cf\.hw_assist\.partner\.address\s[\w\:\.\d]+','-prompt',@prompts,'-timeout',60);
	#tstlog -comment, "OUT3= $out3\n";
	sleep 2;
        my (undef,undef,$out2) = say($fc,"cf hw_assist status",'-swallow','-timeout', 60);
	#tstlog -comment, "OUT2= $out2\n";
	sleep 2;

	if($DEBUG) {
                tstlog -comment, "OUT1= $out\n";
                tstlog -comment, "UNDEF1= $undef1\n";
                tstlog -comment, "UNDEF2= $undef2\n";
                tstlog -comment, "UNDEF3= $undef3\n";
                tstlog -comment, "OUT3= $out3\n";
                tstlog -comment, "UNDEF4= $undef4\n";
                tstlog -comment, "UNDEF5= $undef5\n";
                tstlog -comment, "UNDEF6= $undef6\n";
                tstlog -comment, "OUT2= $out2\n";
        }

        if ($out3 =~ /$ip/ && ($out =~ /Validating the new hw\-assist configuration\. Please wait/ || $out =~ /Same partner address is being set\, so partner address is not modified/) && $out2 =~ /Active\: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Active\: $part monitoring alerts from partner\($self\)/) {
                return 1;
        } elsif (($out =~ /Invalid IP address/ || $out =~ /Couldn\'t convert the hostname into IP address/ || $out =~/has no IPv4 address configured\.Configure a valid IPv4 address for RLM/) && $out2 =~ /Active\: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Active\: $part monitoring alerts from partner\($self\)/) {
                return 2;
	} elsif ($out =~ /Validating the new hw\-assist configuration\. Please wait/ && $out2 =~ /Active\: $self monitoring alerts from partner\($part\)/ && $out2 =~ /Inactive\: $part not monitoring alerts from partner\($self\)/ && ($out2 =~ /Fail to bind UDP socket/ || $out2 =~ /No valid port\/IP address config received/)) {
		return 2;
        } else {
                return 0;
        }
}
