#* $Id: //depot/prod/test/main/lib/platval/service_processor/rlmPhoenix.pm#1 $ */
package platval::service_processor::rlmPhoenix;

use strict;
use File::stat;
use Time::localtime;
use Time::gmtime;
use Tharn;

BEGIN {
    use Exporter ();

    @platval::service_processor::rlmPhoenix::ISA         = qw(Exporter);
    @platval::service_processor::rlmPhoenix::EXPORT      = qw(md5sum_compare validate_dir mount_filer get_dir copy_common_files statusRsa_getResult showRsa_getResult testRsa_getResult create_ontap_user rlm_verify_rlm_version rlm_verify_ssl_enable rlm_set_ontap_options rlm_verify_rsa rlm_make_filer_takeover get_msg_from_console send_cmd_to_filer rlm_verify_ha);
    @platval::service_processor::rlmPhoenix::EXPORT_OK   = qw($test_result $status_result $show_result $md_results $HarnessAction $cmdname $dir_nos $dl_Result);
  }

use vars qw($test_result $status_result $show_result $md_results $HarnessAction $cmdname $dir_nos $dl_Result);
#### RSA TEST VALIDATION ##########################
sub testRsa_getResult($;$)
#sub testRsa_getResult($$$$$$$$$$;$$) #added by shilpa
{
   my $testRsa = shift;
   my $rsa_setup_new = shift;
   my @result1 = ('RSA');

#jkonjeti 12Jul10: Added the following code
  if($rsa_setup_new =~/true/)
  {
   if ($testRsa =~ /Testing (cluster management LIF HTTP) connection.*ok/) {
	push (@result1, ",", $1, "PASS");
   } else {
	push (@result1, ",", $1, "FAIL");
   }
  } else
  {
    if ($testRsa =~ /(HTTP) connection.*ok/) {
#   if ($testRsa =~ /Testing storage controller (HTTP).*ok/) {
	push (@result1, ",", $1, "PASS");
   } else {
	push (@result1, ",", $1, "FAIL");
   }
   }

#jkonjeti 12Jul10: Blocked the foreach code as $1 will not have any value
#    foreach my $line1 (split(/\n/, $testRsa)) {
#     if ($line1 =~ /Testing storage controller (HTTP).*(ok|failed)(.*)/){
#        if ($2 =~ /ok/){
#           push (@result1,",", $1, "PASS");
#           print "@result1\n";
#         } # ends if
#        else {
#           push (@result1, ",", $1, "FAIL");
#           print "@result1\n";
#         } # ends else

#       } # ends if

#   } # ends foreach for results

  $test_result=join(":",@result1);
  print "$test_result\n";

} # ends sub testRsa_getResult
1;

#### RSA STATUS VALIDATION ##########################
sub statusRsa_getResult
{
   my $statusRsa = shift;
   my @result1 = ('RSA');

    foreach my $line1 (split(/\n/, $statusRsa)) {
     if ($line1 =~ /^(HTTP).*: (ok|failed|alert)(.*)/){
        if ($2 =~ /ok/){
           push (@result1,",", $1, "PASS");
           print "@result1\n";
         } # ends if
        else {
           push (@result1, ",", $1, "FAIL");
           print "@result1\n";
         } # ends else
       } # ends if

# Modified by Feroz to check for SEP not appearing with 'rsa status' command.
     elsif ($line1 =~ /^(SEP entitlement).*/){
           push (@result1, ",", $1, "FAIL");
           print "@result1\n";
		} # ends if
   } # ends foreach for results

  $status_result=join(":",@result1);
  print "$status_result\n";

} # ends sub statusRsa_getResult
1;


#### RSA SHOW VALIDATION ########################
sub showRsa_getResult($$$$$$$$$$;$$)
{
  my $showRsa = shift;
  our $FILER_FQDN = shift;
  our $usrname = shift;
# our $telnet_port = shift;
  our $http_port = shift;
  our $https_enable = shift;
  our $PROXY = shift;
  our $PROXY_PROTOCOL = shift;
  our $PROXY_IP = shift;
  our $PROXY_PORT_NUMBER = shift;
  our $PROXY_USER_NAME = shift;
  our $rsa_setup_new = shift;
  our $cluster_mgmt_ip = shift;
  our @result1;
  @result1 = ('RSA');

  foreach my $line1 (split(/\n/, $showRsa)) {
   if ($line1 =~ /not|invalid.*/i) {
        push (@result1, ",", $line1, "FAIL");

   }
   if ($line1 =~ /(Remote Support Agent is enabled.*)/) {
    if ($1 =~ /Remote Support Agent is enabled.*/) {
        push (@result1, ",", $line1, "PASS");
        }
       else {
          push (@result1, "," ,$line1,"FAIL");
       } #ends else
   } # ends if
   if($rsa_setup_new =~ /true/){
      if ($line1 =~ /Cluster Management LIF: (.*)/) {
     		if ($1 =~ $cluster_mgmt_ip) {
          	push (@result1, ","," Pass SHOW host",$FILER_FQDN, "PASS");
        	}
       	else {
          	push (@result1, ",","Fail SHOW host",$FILER_FQDN, "FAIL");
       	} #ends else
   	} # ends if
   } else {
   	if ($line1 =~ /Storage controller (HTTP) host: (.*)/) {
     		if ($2 =~ $FILER_FQDN) {
          	push (@result1, ","," Pass SHOW host",$FILER_FQDN, "PASS");
        	}
       	else {
          	push (@result1, ",","Fail SHOW host",$FILER_FQDN, "FAIL");
       	} #ends else
   	} # ends if
   }
    if ($line1 =~ /Use proxy: (\w\w+)/) {
	if ($1 eq $PROXY) {
		 push (@result1, ","," Pass Proxy Use",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Use",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy protocol: (\w\w\w\w+)/) {
      if ($1 eq $PROXY_PROTOCOL) {
		 push (@result1, ","," Pass Proxy Protocol",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Protocol",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy host: (\d\d\.\d\d\.\d\d\.\d\d\d)/) {
      if ($1 eq $PROXY_IP) {
		 push (@result1, ","," Pass Proxy IP",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy IP",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy port: (\d\d\d\d)/) {
      if ($1 eq $PROXY_PORT_NUMBER) {
		 push (@result1, ","," Pass Proxy Port",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Port",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Use username\/password.*: (\w\w+)/) {
	  if ($1 eq "no") {
		  if ($PROXY_USER_NAME eq "NA") {
			 push (@result1, ",", "Pass proxy authentication not required",$1, "PASS");
		  }
		  else {
			 push (@result1, ",", "Fail proxy authentication required",$1, "FAIL");
	      }
	  }
	  if ($1 eq "yes") {
		  if ($PROXY_USER_NAME ne "NA") {
			 push (@result1, ",", "Pass proxy authentication required",$1, "PASS");
		  }
		  else {
			 push (@result1, ",", "Fail proxy authentication not required",$1, "FAIL");
	      }
	  }
	}
    if ($line1 =~ /Proxy username: (\w+\\*\w*)/) {
      if ($PROXY_USER_NAME ne "NA") {
      	 if ($1 eq $PROXY_USER_NAME) {
            push (@result1, ","," Pass Proxy username matches",$PROXY_USER_NAME, "PASS");
         }
         else {
         push (@result1, ",","Fail Proxy username mismatch",$PROXY_USER_NAME, "FAIL");
         } #ends else
	  }
    } # ends if
   if ($line1 =~ /Storage controller (HTTP) username: (.*)/) {
     if ($2 =~ $usrname) {
          push (@result1, ",","SHOW $1 username",$usrname, "PASS");
        }
       else {
          push (@result1, ",","SHOW $1 username",$usrname, "FAIL");
       } #ends else
   } # ends if
   if ($line1 =~ /Storage controller (HTTP) port: (.*)/) {
     if ($2 =~ $http_port) {
          push (@result1, ",","SHOW $1 port",$http_port, "PASS");
        }
       else {
          push (@result1, ",","SHOW $1 port",$http_port, "FAIL");
       } #ends else
   } # ends if
 if ($line1 =~ /HTTP with SSL enabled: (.*)/) {
     if ($1 =~ $https_enable) {
          push (@result1, ",","SHOW $1 https enabled",$https_enable, "PASS");
        }
       else {
          push (@result1, ",","SHOW $1 https",$https_enable, "FAIL");
       } #ends else
   } # ends if

 } #ends foreach
  $show_result=join(":",@result1);
  print "Printing results captured $show_result\n\n\n";
} # ends sub showRsa_getResult
1;

###########Get Test Harness Details #################
sub get_harness_details
{
  our $testcase = shift;
  our $file = shift;
  our $rsaid = shift;
  our $HarnessServer = shift;
  our $corePath = "etc/crash/"."$file";

  our $case_id;
  print "$testcase received \n\n";

  my $range = 100;
  $case_id = int(rand($range));

  if ($testcase =~/^6.2..*/) {
    $cmdname = "coreUpload";
    $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/auto/0/case/$case_id/core/$corePath";
  }
  if ($testcase =~/^6.3..*/) {
    $cmdname = "fileUpload";
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/file/$file";
  }
  if ($testcase =~/^6.4..*/) {
    $cmdname = "dirList";
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/?list=$file";
  }
  if ($testcase =~/^6.5..*/) {
    $cmdname = "triggerASUP";
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid";
  }
} #ends sub get_harness_server
1;

########### md5sum Compare ###################
sub md5sum_compare
{
  my $mdout = shift;
  our $reqd_file = shift;
  our $orig_file = shift;
  our $reqd_file_md;
  our $orig_file_md;

  foreach my $line1 (split(/\n/, $mdout)) {
   if ($line1 =~ /(.*) $reqd_file/) {
      $reqd_file_md = $1;
    }
   if ($line1 =~ /(.*) $orig_file/)  {
      $orig_file_md = $1;
    }
  } #ends foreach
  if ($reqd_file_md =~ /^$orig_file_md$/) {
    $md_results = "PASS";
 #     print "$md_results \n\n";
  } # ends if
  else {
    $md_results = "FAIL";
 #     print "$md_results \n\n";
  } # ends else
} # ends sub md4sum_compare
1;

########### get dir listing details ###################
sub get_dir
{
  #my @dir_names = shift;       #jkonjeti 05feb10: commented this line as declaration is wrong to receive array of values
  my @dir_names = @{shift @_};
#  my $dirlist_file = shift;    #jkonjeti 05feb10: commented this line
  my $dirlist_name_file = shift;
  $dir_nos = 0;

      print "FILE NAME = $dirlist_name_file\n";
 open DFH1, "> $dirlist_name_file" or die $!;
  foreach my $dir (@dir_names) {
      print DFH1 "$dir\n";
      $dir_nos = $dir_nos + 1;
      print "$dir dirs nos $dir_nos\n";
  } #ends foreach
  close DFH1;
} # ends sub get_dir
1;


###########validate dir listing results ##################
sub validate_dir
{
     print "INSIDE validate_dir\n";
  our $FILER = shift;
  our $dirlist_name_file = shift;
  our $destn_buf_file = shift;

#   open DFH2, "< $destn_buf_file" or die $!;	#jkonjeti 08sep10: Commented this line
   open DFH2, "< $destn_buf_file" or die ("Unable to open file: $destn_buf_file");	#jkonjeti 08sep10: Added this line
   while (<DFH2>) {
     my $line = $_;	#jkonjeti 08sep10: Added this line and changing following lines from $_ to $line
print "\$line = $line\n";
     next if ($line =~ /^\s*$/);	#jkonjeti 08sep10: Added this line, to skip empty lines
     $line =~ s/^\s+//; #jkonjeti 08sep10: leading whitespace
     $line =~ s/\s+$//; #jkonjeti 08sep10: trailing whitespace
     print "Validating list dir Results \n\n";
          if ($line =~ /.*(Index|directory not found).*/i) {
              if ($1 =~ /(Index)/i) {
                   valid_dir_chk($destn_buf_file, $FILER, $dirlist_name_file);
              }
              else {
                 $dl_Result = "FAIL";
                 print "$line = $dl_Result\n\n";
              }
           }
   } # ends while
   close DFH2;
}# ends sub validate_dir
1;

###########valid_dir_chk ##################
sub valid_dir_chk
{
  our $destn_buf_file = shift;
  our $FILER=shift;
  our $dirlist_name_file=shift;
#  our $dirlist_filer = "$destn_buf_file" . "_from_filer.txt"; 	#jkonjeti 08sep10: blocked this variable as it is of no use
  our $dir_filer_location = "/t/$FILER/root";

  my ($node, $mod_time, $size, $mtime, %filer_dir_hash, %buffer_dir_hash);	#jkonjeti 08sep10: added two hashes (%filer_dir_hash, %buffer_dir_hash) into the list

  # jkonjeti 08sep10: Added the following code to compare directory & files between filer($dir_name) and buffer file($destn_buf_file)
  ###############################################################################################
  # Reading the contents from buffer file(filename & size) and storing in hash (%buffer_dir_hash)
  open (DFH3, "< $destn_buf_file") || die ("Unable to open file: $destn_buf_file");
  logcomment ("Reading contents(filename, size) from the buffer file : \"$destn_buf_file\"");
  foreach my $line (<DFH3>) {
        my ($k, $v) = $line =~ /^([\w\.]+).+\s+(\d+)k/;
        $buffer_dir_hash{$k} = $v if($k);
  }
  close (DFH3);

  # Reading the directory names from the dir listed name file i.e /etc/log, /etc/crash etc.
  open DFH2, "< $dirlist_name_file" || die ("Unable to open file: $dirlist_name_file");
  logcomment ("Reading contents(directory names) from the dirlist_name file: \"$dirlist_name_file\"");
  while (<DFH2>){
        my $dir_name = "$dir_filer_location"."$_";
        chomp ($dir_name);
        opendir (MYDIR, "$dir_name") || die ("Unable to open directory: $dir_name");
        logcomment ("Reading files under the directory: $dir_name\n");
        my @contents = readdir (MYDIR);
        logcomment ("Files under the $dir_name directory:\n@contents");
        foreach my $listitem ( @contents )
        {
                if (-d "$dir_name$listitem") {
                        next;
                } elsif (-l "$dir_name$listitem") {
                        my $org_file = readlink("$dir_name$listitem");
                        $node = stat("$dir_filer_location$org_file");
                } else {
                        $node = stat("$dir_name$listitem");
                }
                my $mtime = $node->mtime;
                $mod_time=gmctime($mtime);  ## gives us a string format
                $size  = int($node->size / 1024);
                $filer_dir_hash{$listitem} = $size;
        } # ends foreach

        # Comparing contents of both "buffer directory" and "directory in filer" w.r.t size
	logcomment ("Comparing contents of both directories w.r.t filename & size", "Buffer directory in file: $destn_buf_file", "Directory in filer: $dir_name");
        foreach my $k (keys %filer_dir_hash) {
                if ($filer_dir_hash{$k} == $buffer_dir_hash{$k}) {
                        delete $filer_dir_hash{$k};
                        delete $buffer_dir_hash{$k};
                } elsif (($buffer_dir_hash{$k} > 0) && ($filer_dir_hash{$k} >= $buffer_dir_hash{$k})) {
                        delete $filer_dir_hash{$k};
                        delete $buffer_dir_hash{$k};
                } else {
                        logresult ('FAIL', "$filer_dir_hash{$k} file missing in the buffer directory: $buffer_dir_hash{$k}");
			close (DFH2);
			$dl_Result = "FAIL";
			return $dl_Result;
                }
        }
	logresult ('PASS', "Compared the directories, there is no difference");
  } # ends while
  close (DFH2);
  $dl_Result = "PASS";
# jkonjeti 08sep10: end

# jkonjeti 08sep10: blocked thed following code
#  open DFH2, "< $dirlist_name_file" or die $!;
#  while (<DFH2>){
#     my $dir_name = "$dir_filer_location"."$_";
#     print "Validating directory contents....  $dir_name\n\n";
# jkonjeti 08sep10: end

#     opendir MYDIR, "$dir_name" or die $!;
#     my @contents = readdir MYDIR;
#     print "dir contents @contents \n\n";
#     foreach my $listitem ( @contents )
#     {
#            print "Validating dir $listitem\n\n";
#            $node = stat("$dir_name$listitem");
#            $mtime = $node->mtime;
#            $size  = $node->size / 1024;
#            $mod_time=gmctime($mtime);  ## gives us a string format
#            if ($size =~/(.*)\.(.*)/) {
#              $size = $1;
#            }
#            print "$listitem\t $mod_time\t $size \n";
#            $dl_Result = "PASS";
#            print "dl Result value = $dl_Result\n\n";
#  } # ends foreach
# } # ends while
# close DFH2;
} # ends valid_dir_chk

########### copy_common_files ##################
# Modified by Feroz - Added code for coping the dependency files.
sub copy_common_files
{
print "Inside COMMON FILES\n";
	our $cc			= shift;
	our $home_dir	= shift;
	our $pr_folder 	= shift;
	our $common_files_path = shift;
	our $file_name 	= shift;

# Check if the file is located in common location.
	our (undef, undef, $out) = say ($cc, "ls -l $common_files_path/$file_name");

	if($out=~ /.*(such file|Failed|unable|perm).*/i){
		logresult('FAIL', "File \"$file_name\" is missing at \"$common_files_path\".");
		tstlog(-comment,"Pre-requisite NOT met. Copy \"$file_name\" to \"$common_files_path\".");
		print "Exiting script, Follow steps in Pre-requiste and re-run script\n";
		exit;
	}

	print ("\n\nHOME_DIR : $home_dir\nPR_FOLDER : $pr_folder \nCOMMON : $common_files_path\nFILENAME: $file_name\n\n");
	our (undef, undef, $out) = say ($cc, "ls -l $home_dir/$pr_folder/$file_name");
print "\$out = $out \n";
	if($out=~ /.*(such file).*/i){
		tstlog(-comment,"Copy $file_name to $home_dir/$pr_folder");
		say ($cc, "cp $common_files_path/$file_name $home_dir/$pr_folder/$file_name", '-timeout', 300);
	}
	elsif($out=~ /.*(Failed|unable|perm).*/i){
		logresult('FAIL', "$home_dir/$pr_folder/$file_name");
		tstlog(-comment,"Failed to list the file $file_name at $home_dir/$pr_folder.");
		print "Exiting script, Follow steps in Pre-requiste and re-run script\n";
		exit;
  }
} # ends copy_common_files


## jkonjeti 05feb10: To create ontap user
sub create_ontap_user ($$$) {
  my $rsh_conn = shift;
  my $RSA_USERNAME = shift;
  my $RSA_PASSWORD = shift;
  my (undef,undef,$out,$addUser) = say($rsh_conn, "useradmin user add $RSA_USERNAME -g Administrators",-swallow, '-prompt', "New password", 'User is already present'); #jkonjeti 08sep10: added this line
  if ($addUser =~ /New password/i) {    #jkonjeti 08sep10: added if condition
        say($rsh_conn, "$RSA_PASSWORD",-swallow,'-prompt', "Retype new password", '-timeout', 40);
        my (undef,undef,$addUser) = say($rsh_conn, "$RSA_PASSWORD", -swallow,'-timeout', 40);
        if ($addUser =~ /The user '(.*)' has been added(.)|User\s\<(.*)\>\sadded/)
           {
             if ($1 =~ /$RSA_USERNAME/)
             {
                 tstlog(-comment, "$RSA_USERNAME ADDED SUCCESSFULLY");
             }
             if ($1 != /$RSA_USERNAME/)
             {
                logresult ('WARN', $1, $2, $3);
             }
        } else
          {
            logresult ('WARN', "CANNOT ADD USER");
        }
  } elsif ($out =~ /Error\: User name contains an invalid character/) {	#jkonjeti 08sep10: added elsif block
	logcomment ("Cannot add user $RSA_USERNAME");
  } elsif ($out =~ /Error\: User is already present/) {      #jkonjeti 08sep10: added else block
        logresult ('WARN', "CANNOT ADD USER: $RSA_USERNAME User is already present");
  }
}

## jkonjeti 05feb10: To mount the filer using qa_mount tool
sub mount_filer ($$) {
  my $cc = shift;
  my $FILER = shift;
  my (undef, undef, $mount_output) = say( $cc, "r qa_mount $FILER" ,
         "echo _''OK_",
         '-wait', "_OK_",
         '-eval_error', '-timeout', 60 );

  #jkonjeti 05feb10: Added the if condition to handle qa_mount errors
  if ($mount_output =~ /failed|down/) {
        logresult('FATAL', "Unable to mount filer, please make sure filer is pingable, NFS licnese & qa_mount tool availability etc");
  }
}

################ COMMON FUNCTIONS FOR HA ###############
## It  verifies installed RLM/SP Fw version and see if it supports Phoenix or not.
sub rlm_verify_rlm_version ($$) {
        my $r = shift;
	my $RLM = shift;
        my (undef, undef, $ver) = say ($r, "version");

        $ver =~ /Booted (primary|backup) firmware version/;
        unless ($1 =~ /primary/) {
                logresult ('FAIL', "$1 seen, primary should come");
        }

        if ($ver =~ /.*Primary firmware version (0|1|2)\..*/ && $RLM =~ /rlm/) {
                logresult ('FATAL', "RLM Phoenix build 3.X or later is Pre-requisite to run this script");
        } else {
                logcomment ("Phoenix build installed");
        }
}

## To verify ssl has be setup in ONTAP or not
sub rlm_verify_ssl_enable ($) {
        my $rsh_conn = shift;
        my (undef,undef,$secureAdmin) = say($rsh_conn, "options httpd.admin.ssl.enable", '-timeout', 40);
        if ($secureAdmin =~ /.*off.*/) {
                logresult('FATAL', "ONTAP secureadmin ssl not setup, Run \'secureadmin setup ssl\' to setup ssl access on ONTAP");
        }
}

## To set Phoenix options in ONTAP
sub rlm_set_ontap_options ($) {
        my $rsh_conn = shift;
        say($rsh_conn, "options telnet.access legacy");
        say($rsh_conn, "options telnet.distinct.enable on");
        say($rsh_conn, "options telnet.enable on");
        say($rsh_conn, "options httpd.admin.access legacy");
        say($rsh_conn, "options httpd.admin.enable on");
        say($rsh_conn, "options httpd.autoindex.enable on");
        say($rsh_conn, "options httpd.enable on");
        say($rsh_conn, "options ssl.enable on");
        say($rsh_conn, "options trusted.hosts *");
        say($rsh_conn, "options httpd.ipv6.enable on");              #this option to support IPV6
        say($rsh_conn, "options httpd.admin.ssl.enable on");
}

## To do RSA SETUP and TEST HTTP
sub rlm_verify_rsa ($$$$$$) {
        my ($rlm, $RSA_HOST_NAME, $RSA_HTTP_PORT, $RSA_USERNAME, $RSA_PASSWORD , $RSA_HTTPS_ENABLE) = @_;
        my(undef,undef,$setup_http) = say($rlm, "rsa setup http -hostname $RSA_HOST_NAME -port $RSA_HTTP_PORT -username $RSA_USERNAME -password $RSA_PASSWORD -ssl $RSA_HTTPS_ENABLE", '-timeout', 140);
        my(undef,undef,$testRsaHttp)  =say($rlm,"rsa test http", '-timeout', 940);
        if ($testRsaHttp =~ /.*failed.*/) {
                logresult ('FATAL', "RSA TEST FAILED - Pre-requisite not met");
        } else {
                logresult("INFO", "RSA HTTP TEST PASSED");
        }
        sleep (10);
}

## To make FILERA takeover by using "cf takeover -f" command from FILERB
sub rlm_make_filer_takeover ($$@) {
#        my ($fcA, $fcB, @prompts) = @_;

#        say($fcA, "bootargs set AUTOBOOT false");       #If AUTOBOOT not flase, then filerA will auto boot after filerB's takeover and waits for giveback
#        say($fcB, "cf takeover -f", -swallow, -blind);
#        sleep(30);
#        say($fcB, " ", -swallow, -noprompt, -prompt, "$FILERB" . '\(takeover\)\>', -timeout, 200);
#        sleep(30);
#        my (undef, undef, undef, $prompt) = say($fcA, " ", -swallow, -noprompt, -prompt, @prompts, -timeout, 200);
#        unless ($prompt =~ /LOADER/) {
#                logresult ("FATAL", "$FILERA is not going to LOADER after $FILERB taken over");
#        }
}


sub get_msg_from_console {
        my ($self, $part, $msg, $invert, $cc) = @_;

        say($cc,"r qa_mount $part",'-timeout',80);
        # Send say and then capture the lines from console which are
        # interesting to this test.
        my ($response) = say($cc,"r tail -f /t/$part/root/etc/log/ems",'-wait',$msg,'-noprompt','-timeout',180,'-eval_error');

        logcomment ($response);

        if($invert) {
                if(matchstrings($response, $msg)) {
                        logresult('FAIL',"Observed the Unexpected string $msg");
                } else {
                        logresult('PASS',"$msg did not observed with the following string: $response \n");
                }
        } else {
                if(matchstrings($response, $msg)) {
                        logresult('PASS',"$msg observed with the following string: $response \n");
                } else {
                        logresult('FAIL',"Did not see expected string $msg");
                }
        }
        say ($cc, "\cC");
        say ($cc, "r umount /t/$part/root", '-timeout',80);
        sleep(20);
}


sub send_cmd_to_filer {
        my ($fc, $part, @prompts) = @_;

        say($fc, "bootargs set AUTOBOOT false", -swallow, -noprompt, -prompt, @prompts, -timeout, 30);    #If AUTOBOOT not flase, then filerA will auto boot after filerB's takeover and waits for giveback

        my (undef, undef, $out, $prompt) = say($fc,"priv set test;systemshell", -swallow, -noprompt, -prompt, "login\:", @prompts, -timeout, 30);

        if ($out =~ /systemshell not found/) {
                # Running the watchdog wd_reset command on node A
                say($fc,"watchdog wd_reset",'-swallow','-blind','-noprompt','-timeout',900);
        } elsif ($prompt =~ /login\:/) {
                say($fc,"diag",-noprompt, -prompt,"Password\:",'-timeout',90);
                say($fc,"netapp1\!",'-timeout',90);

                say($fc,"sudo sysctl debug.watchdog",'-timeout',90);
                say($fc,"sudo sysctl debug.watchdog.disable=0",'-timeout',90);
                say($fc,"sudo sysctl debug.watchdog.ignore_nmi=1",'-timeout',90);
                say($fc,"sudo sysctl debug.watchdog.trigger_l2_timeout=1",'-timeout',90);
                say($fc,"sudo sysctl debug.watchdog.hang_cpu=1",'-timeout',900,'-eval_error');
        }
}

sub rlm_verify_ha($$$) {
	my ($fcA, $fcB, $ha, $flag) = @_;
	logcomment ("Verifying both filers are configured for HA");
	foreach my $eth ('e0M', 'e0a') {
        	my (undef, undef, $etha) = say($fcA, "ifconfig $eth", -swallow);
	        my (undef, undef, $ethb) = say($fcB, "ifconfig $eth", -swallow);
        	if (($etha =~ /partner\s+inet\s+[\d\.]+|partner\s+inet6\s+[\w\:]+/) && ($ethb =~ /partner\s+inet\s+[\d\.]+|partner\s+inet6\s+[\w\:]+/)) {
                	$flag = 1;
	                last;
	        }
	}
	unless ($flag) {
        	logresult ("FATAL", "Both filers are not configured as HA. Partner ip's are not found");
	}

	if ($ha == 1) {
        	my (undef, undef, $enblA) = say($fcA, "options cf.hw_assist.enable", -swallow);
	        my (undef, undef, $enblB) = say($fcB, "options cf.hw_assist.enable", -swallow);
		unless (($enblA =~ /on/) && ($enblB =~ /on/)) {
			logcomment ("HW Assist is not enable on both the filers. Trying to enable...");
			(undef, undef, $enblA) = say($fcA, "options cf.hw_assist.enable on", -swallow);
			(undef, undef, $enblB) = say($fcB, "options cf.hw_assist.enable on", -swallow);
			unless (($enblA =~ /on/) && ($enblB =~ /on/)) {
				logresult ("FATAL", "Both filers are not configured for HW Assist. Try again after enable \"options cf.hw_assist.enable on\"");
			}
		}
		my (undef, undef, $hwipA) = say($fcA, "options cf.hw_assist.partner.address", -swallow);
		my (undef, undef, $hwipB) = say($fcB, "options cf.hw_assist.partner.address", -swallow);
		unless (($hwipA =~ /[\d\.]+|[\w\:]+/) && ($hwipB =~ /[\d\.]+|[\w\:]+/)) {
			logresult ("FATAL", "partner ip is missing. Try again after setting ip-address to \"options cf.hw_assist.partner.address <ip>\"");
		}
	} elsif ($ha == 0) {
                my (undef, undef, $enblA) = say($fcA, "options cf.hw_assist.enable", -swallow);
                my (undef, undef, $enblB) = say($fcB, "options cf.hw_assist.enable", -swallow);
		unless (($enblA =~ /off/) && ($enblB =~ /off/)) {
			logcomment ("HW Assist is enable on both the filers, trying to disable for HA (normal Cluster takeover) functioality");
			(undef, undef, $enblA) = say($fcA, "options cf.hw_assist.enable off", -swallow);
                        (undef, undef, $enblB) = say($fcB, "options cf.hw_assist.enable off", -swallow);
			unless (($enblA =~ /off/) && ($enblB =~ /off/)) {
	                        logresult ("FATAL", "Both filers are configured for HW Assist. Try again after disable \"options cf.hw_assist.enable off\"");
			}
                }
	}
}

1;

