#$Id: //depot/prod/test/Rsierranevada/lib/raid_lib.pm#1 $
##
## @summary RAID library functions to be used by the real tests
##
## @author dl-step@netapp.com, dl-sar-qa@netapp.com
## @status	public


$THARN_DEBUG = 0;
$THARN_VERBOSE = 0;

sub get_old_raid_spare_disks {
my(@disks);
$SPARE_DISKS = saycmd($FILER, "sysconfig -r");

#print MY_LOG "$SPARE_DISKS\n";
#print MY_LOG "Sys output ends \n";

@sys_output = split(/\n/, $SPARE_DISKS);
	foreach $line (@sys_output) {
#		print MY_LOG "$line\n";
		if ($line =~ /^spare/) {
#			print MY_LOG "yup...\n";
			@words = split(/\s+/, $line);
			push(@disks, $words[1]);
		} else {
#			print MY_LOG "no...\n";
		}
	}


	@disks;	# return the disk list
}

sub get_new_raid_spare_disks {
my(@disks);
$SPARE_DISKS = saycmd($FILER, "vol status -r");

#	print MY_LOG "SPARE_DISKS= $SPARE_DISKS\n";

@sys_output = split(/\n/, $SPARE_DISKS);
	foreach $line (@sys_output) {
		if ($line =~ /^zero/) {
			@words = split(/\s+/, $line);
			push(@disks, $words[1]);
		}
	}
	@disks;	#return the disk list
}

#
# Return the data disks given the volume name as an argument.
#
sub get_data_disks {
my(@data_disks);
	$disks = saycmd($FILER, "vol status -r $_[0]");
	@status_output = split(/\n/, $disks);
	foreach $line (@status_output) {
		if ($line =~ /^data/) {
			@words = split(/\s+/, $line);
			push(@data_disks, $words[1]);
		}
	}
	@data_disks;
}

#
# Return the parity disk given the volume name as an argument.
#
sub get_parity_disk {
my(@parity_disks);
	$disks = saycmd($FILER, "vol status -r $_[0]");
	@status_output = split(/\n/, $disks);
	foreach $line (@status_output) {
		if ($line =~ /^parity/) {
			@words = split(/\s+/, $line);
			push(@parity_disks, $words[1]);
		}
	}
	@parity_disks;
}

sub get_reconstruct_disk {
my(@reconstruct_disk);
	$disks = saycmd($FILER, "vol status -r $_[0]");
	@status_output = split(/\n/, $disks);
	foreach $line (@status_output) {
		if ($line =~ /^recons/) {
			@words = split(/\s+/, $line);
			push(@reconstruct_disk, $words[1]);
		}
	}
	@reconstruct_disk;
}



sub remove_volume {
    my $volume = shift(@_);
    local ($o);    
	    $o = saycmd($FILER, "vol offline $volume");
	    if ($o !~ /Volume $volume is now offline./ ) {
	        tstlog -fatal, "vol offline $volume ::= $o failed";
		return 0;
	    }
  
    # Destroy the volume.  Use the '-f' flag to avoid getting prompted
    # for confirmation.
  
    $o = saycmd($FILER, "vol destroy $volume -f");
    if ($o !~ /volume $volume destroyed./ ) {
        tstlog -fatal, "vol destroy of $volume ::= $o failed";
	return 0;
    }
    return 1;
}


1;
