# $Id: //depot/prod/test/Rsierranevada/lib/raidv2_lib.pm#2 $
##
## @summary RAIDv2 library functions to be used by NATE tests 
## @status public
## @author dl-step-internal@netapp.com, dl-sar-qa@netapp.com

#----------------------------
# Functions
#----------------------------

# Clean list by:
#   grep "^sub raidv2_" raidv2_lib.pm | sed 's/.*\(raidv2_[^ ({]*\).*/\1/' | sort > /tmp/subs.txt
#   grep "^#raidv2_" raidv2_lib.pm    | sed 's/#\(raidv2_[^ ({]*\).*/\1/'  | sort > /tmp/comments.txt
#   diff /tmp/subs.txt /tmp/comments.txt  # some differences are data structures
# Find usage by:
#   find /rlse/mainN/test/raid* -name '*.thpl' -print | xargs grep <function> /dev/null

#raidv2_saycmd
#raidv2_client_saycmd
#raidv2_log
#raidv2_log_fatal
#raidv2_is_simulator

#raidv2_info_disk_load
#raidv2_info_vol_load
#raidv2_info_plex_load
#raidv2_info_group_load
#raidv2_info_load
#raidv2_info_label_load
#raidv2_info_label_load_maint
#raidv2_info_label_parse
#raidv2_info_status_load

#raidv2_get_disks_by_type
#raidv2_get_disks_by_group
#raidv2_get_disks_by_group_type  ---- added by htu
#raidv2_get_disks_by_plex_type  ---- added by skg
#raidv2_get_disks_by_state
#raidv2_get_disk_sec_name
#raidv2_get_groups_by_state
#raidv2_get_groups_by_vol  ----- added by htu, return the list of groups belong to volumeX
#raidv2_get_plexes_by_vol ---- added by htu, return the list of plexes belong to volume X
#raidv2_get_type_by_name

#raidv2_is_syncmirror_licensed
#raidv2_syncmirror_unlicense
#raidv2_syncmirror_license
#raidv2_is_syncmirror_local_licensed
#raidv2_syncmirror_local_unlicense
#raidv2_syncmirror_local_license

#raidv2_wafliron_status
#raidv2_wafliron_start

#raidv2_wait_for_zeroing
#raidv2_wait_for_complete_zeroing
#raidv2_wait_for_partial_zeroing
#raidv2_wait_on_vol_zeroing

#raidv2_vol_create
#raidv2_vol_create_no_wait
#raidv2_vol_add
#raidv2_vol_add_no_wait
#raidv2_vol_online
#raidv2_vol_online_readonly($)
#raidv2_vol_offline
#raidv2_vol_rename
#raidv2_vol_restrict
#raidv2_vol_mirror
#raidv2_vol_split
#raidv2_vol_property_check
#raidv2_remove_volume
#raidv2_destroy_volume
#raidv2_destroy_volumes
#raidv2_vol_exist  -- added by htu

#raidv2_plex_online
#raidv2_plex_offline

#raidv2_disk_online
#raidv2_disk_online_all
#raidv2_disk_offline
#raidv2_ata_verify_spasm
#raidv2_check_disk_status

#raidv2_shutdown -- add reboot, panic, halt 

#raidv2_fiji_add_filter
#raidv2_fiji_add_nvfilter
#raidv2_fiji_clear_all
#raidv2_fiji_add_filter_multi
#raidv2_read_error_inject
#raidv2_fiji_fail
#raidv2_fiji_fail_multi
#raidv2_fiji_fail_by_disk_type
#raidv2_fiji_fail_by_disk_type_in_group
#raidv2_fiji_fail_by_disk_type_in_group_multi

#raidv2_start_scrub
#raidv2_scrub_status   --- added by htu, return 0 if no scrub is running.
#raidv2_wait_for_scrub_completion
#raidv2_vol_start_scrub
#raidv2_vol_scrub_verify
#raidv2_vol_check_scrub_error

#raidv2_start_hammer 		: start hammer on vol or $FILER_VOL
#raidv2_start_multiple_hammers 	: on a specfied vol or $FILER_VOL
#raidv2_stop_hammer    		: abort all hammers
#raidv2_status_hammer           : return hammer status
#raidv2_reinitialize_test 	: stop hammer, remove volume, wait for zeroing to finish

#raidv2_disable_checksums

#raidv2_unfail_disks
#raidv2_wait_on_diskfail
#raidv2_wait_on_reconstruct
#raidv2_wait_on_reconstruct_type
#raidv2_wait_on_reconstruct_replace
#raidv2_wait_on_reconstruct_start
#raidv2_wait_on_reconstruct_complete

#raidv2_cleanup_test() 
#raidv2_cleanup_halt() 

#raidv2_cal_sleep_time()

#raidv2_get_pulled_disk_full_name
#raidv2_get_pulled_disk_names
#raidv2_disk_simpush
#raidv2_disk_simpush_all
#raidv2_disk_simpull

#raidv2_resort_disks_reversed
#raidv2_resort_disks

#raidv2_mvm_zero
#raidv2_mvm_reload
#raidv2_mvm_makekey
#raidv2_mvm_verify

#raidv2_get_timestamp
#raidv2_get_Month

#raidv2_mount_volume

#raidv2_set_debug_level_syslog  ---- added by Viv
#raidv2_check_log_for_message
#raidv2_check_log_for_scrub_success

#raidv2_is_aggr -- Added by Mindteck on 7/10/08

#----------------------------
# Data structures
#----------------------------

#raidv2_info_disk_by_name
#raidv2_info_disk_by_id
#raidv2_info_disk_raid_name
#raidv2_info_tree_disk_list
#raidv2_info_fsm_disk_list   # added by htu
#raidv2_info_plex_disk_list
#raidv2_info_group_disk_list     --   list of disks by group

#raidv2_info_status_by_name
#raidv2_info_status_by_id

#raidv2_info_vol_by_name
#raidv2_info_vol_by_id
#raidv2_info_vol_list  # added by htu

#raidv2_plex_vol_by_parentid
#raidv2_info_tree_plex_list
#raidv2_info_plex_by_name
#raidv2_info_plex_by_parentid

#raidv2_info_tree_group_list
#raidv2_info_group_by_name
#raidv2_info_group_by_id
#raidv2_info_tree_group_list

#raidv2_info_label

#------------------------------------------------------------------------------
# Global

# saycmd function, FILER_xxx vars
# //depot/tools/main/tharn/lib/tharnit_lib.pl, /x/eng/localtest/noarch/share/nate/latest/lib/tharnit_lib.pl
do "tharnit_lib.pl";
# license services on multiple platforms
use Admin::License qw(license);
use Storage::Misc qw(filer_cmd);

# global timeout, lets other sim environments (e.g. RTP) choose value
param("RAIDV2_TIMEOUT", "-default", 2400);
param("RAIDV2_SMALL_TIMEOUT", "-default", 60);

# global status variables
$PASSED = 1; 
$FAILED = 0; 
$NOOP   = 2; # no operation is required

# log versions
my ($call_pkg, $call_file) = caller();
my $this_file = __FILE__;
my $id = "^#.*Id: //depot";	# don't use $keyword:...$ in search code or it will be replaced!
my $call_id = `grep "$id" $call_file`;	
my $this_id = `grep "$id" $this_file`;
chomp($call_id);
chomp($this_id);
logcomment("Test versions:", $call_file, $call_id, $this_file, $this_id);

#------------------------------------------------------------------------------
# Subroutines

#MTK_EDIT 20080415: Returns the root volume type i.e traditional or flexible
sub raidv2_vol_type {
        my ($output) = saycmd_real($FILER, "aggr status");
        my @info = split(/\r?\n/, $output);
        shift @info;

        foreach my $line (@info) {
          $line =~ s/^\s+//;
          @vol_info = split(/\s{2,}/, $line);
          tstlog -comment, "Status: $vol_info[1] \t Options: $vol_info[2] ";
          if(($vol_info[1] =~ /aggr/) && ($vol_info[2] =~ /root/)) {
                return 1;       #aggr
                last;
          } elsif(($vol_info[1] =~ /trad/) && ($vol_info[2] =~ /root/)) {
                return 0;       #trad
                last;
          }
        }
}
#MTK_END

#MTK_EDIT 20080609: Returns the type of simulator i.e 1=>7g sim , 0=>vsim
sub raidv2_get_simtype() {
	my($o) = saycmd_real($FILER, "sysconfig -a");  #Always show Model Name, which helps to identify type.
	if($o =~ /Model\sName.+(?i)simulator/) {
		return 1;
	} elsif($o =~ /Model\sName.+(?i)simbox/) {
		return 0;
	}
}
#MTK_END

sub raidv2_client_saycmd($$) {
    my $ch = host $_[0], -fatal, "raidv2_saycmd failed to allocate $_[0]";
    my $cc = connect "#rsh", -fatal, "connection failed";  
    say $cc, $_[1], -fatal, "$_[1]: failed", -timeout, $RAIDV2_TIMEOUT;
}

sub raidv2_client_saycmd_fail($$) {
    my $ch = host $_[0], -fatal, "raidv2_saycmd failed to allocate $_[0]";
    my $cc = connect "#rsh", -fatal, "connection failed";
    say $cc, $_[1], -fail, "$_[1]: failed", -timeout, $RAIDV2_SMALL_TIMEOUT;
}

sub raidv2_saycmd($$) {
        #saycmd_real($_[0], $_[1], $RAIDV2_TIMEOUT);
        filer_cmd(host => host($_[0]), cmd =>"$_[1]", timeout=>$RAIDV2_TIMEOUT);

}

#  A Perl function to turn the automated label output into something
# more comprehensible.  This function is: raidv2_info_label_load().  It
# takes one parameter, a disk name, as input, and sets up the
# raidv2_info_label and raidv2_info_label_raw hashes as its output/side 
# effect, as follows:
#
# @data_disks = raidv2_get_disks_by_type("$FILER_VOL","DATA");
# $f = $data_disks[1];
#
# raidv2_info_label_load($f);
# tstlog -comment, "Label generation is $raidv2_info_label{'plex'}{'gen'}\n";
# if (!defined($raidv2_info_label{"plex"}{"gen"})) {
#        tstlog -fatal, "Couldn't get generation for label!";
# }       
#        
# The general format/structure of the raidv2_info_label data structure
# is as follows:
#
# 1) there is a top-level hash indicating which sub-structure you are
# looking at ('label', 'tree', 'vol', 'mirror', 'plex', 'group',
# 'disk').  Note that the pool and disk add structures are not currently
# supported.
# 2) there is a secondary hash for each field of these top-level
# structures.  So, you access the plex generation field (which is
# abbreviated to "gen"), you look at the following:
# 
# $plex_generation = $raidv2_info_label{"plex"}{"gen"};
# 
# 3) if the field is a composite type, having subfields, you can access
# each subfield with another level of hash indirection.  An example
# would be the base snap ID found in the mirror object, which has both a
# snap ID and a time val:
# 
# $miror_basesnap_snapid = $raidv2_info_label{"mirror"}{"basesnap"}{"snapid"};
# $miror_basesnap_timeval = $raidv2_info_label{"mirror"}{"basesnap"}{"timeval"};
# 
# 3) if the "field" is actually an array, you can index into the array.
# Usually, this gives you access to a lower-level hash, which holds the 
# subfields.  (As far as I know, there are no "pure" arrays within the
# label; they are all arrays of composite types.)  A good example would
# be the plex child map:
# 
# $plex_raid_group0_id = $raidv2_info_label{"plex"}{"childMap"}[0]{"childid"};
# $plex_raid_group0_state = $raidv2_info_label{"plex"}{"childMap"}[0]{"state"};
# $plex_raid_group0_online = $raidv2_info_label{"plex"}{"childMap"}[0]{"online"};
# 
# ... and those are the three major ways to access the various data
# found in the label.
#
# There is also the $raidv2_info_label_raw hash, which is only a single
# level hash; good for comparing two labels if you know their expected 
# differences, bad for finding a bit of information in the label.

sub raidv2_info_label_parse($) 
{
    my $output = $_[0];

    %raidv2_info_label = ();
    %raidv2_info_label_raw = ();

    chomp $output;
    my(%count) = ();
    my($entry);

    my(@label_info) = split(",", $output);
		
    #
    # Load the entry
    #
    foreach $entry (@label_info) {
	if ($entry =~ /(.*)=(.*)/) {
	    $raidv2_info_label_raw{$1} = $2;
	}
    }
    
    foreach $item (keys %raidv2_info_label_raw) {
	if ($item  =~ /(.+?)_(.*)/) {
	    $top_level_type = $1;
	    $subfield = $2;
#		tstlog -comment, "Item $item is top-level field $top_level_type and subfield $subfield, value $raidv2_info_label_raw{$item}\n";
	    if ($subfield =~ /(.+?)\.([0-9]+?)\.(.*)/) {
		# The type name has an array in it
		$raidv2_info_label{$top_level_type}{$1}[$2]{$3} = $raidv2_info_label_raw{$item};
#		    tstlog -comment,"Added $raidv2_info_label_raw{$item} to top-type $top_level_type, subfield $1, array index $2, subfield $3\n";
	    } elsif ($subfield =~ /(.+?)\.(\D+?)/) {
		# The type name has a sub-structure
		$raidv2_info_label{$top_level_type}{$1}{$2} = $raidv2_info_label_raw{$item};
#		    tstlog -comment, "Added $raidv2_info_label_raw{$item} to top-type $top_level_type, subfield $1, subfield $3\n";
	    } else {
		# The type name is just a field 
		$raidv2_info_label{$top_level_type}{$subfield} = $raidv2_info_label_raw{$item};
#		    tstlog -comment, "Added $raidv2_info_label_raw{$item} to top-type $top_level_type, subfield $subfield\n";
	    }		
	}
    }    
}

sub raidv2_info_label_load($) {
	my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);

	saycmd_real($FILER, "priv set -q diag; ps -h", $RAIDV2_TIMEOUT);
	my $output = "";
	($output) = saycmd_real($FILER, "priv set -q diag ; label examine $_[0] -a", $RAIDV2_TIMEOUT);
	
	# Now parse it
	raidv2_info_label_parse($output);
}

sub raidv2_info_label_load_maint($$) {
    my ($fc, $disk) = @_;    
    my $output = "";

    $output = (say($fc, "label examine $disk -a", '-wait', "\n", '-prompt', "\\*> "))[2];
    # Now parse it
    raidv2_info_label_parse($output);
    
}

sub raidv2_info_disk_load {
  #my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);
	filer_cmd(host => host($FILER), cmd =>"priv");
        my(@info);
	my($line);
	my($tree_count);

	%raidv2_info_disk_by_name = ();
	%raidv2_info_disk_by_id = ();
	%raidv2_info_disk_by_raid_name = ();
	%raidv2_info_tree_disk_list = ();
	%raidv2_info_tree_diskid_list = ();  ## add by htu
	%raidv2_info_fsm_disk_list = ();  # add by htu
	%raidv2_info_plex_disk_list = ();
	%raidv2_info_group_disk_list = ();

        #saycmd_real($FILER, "priv set -q diag; ps -h", $RAIDV2_TIMEOUT);
	filer_cmd(host => host($FILER), cmd =>"priv set -q diag; ps -h", timeout=> $RAIDV2_TIMEOUT);
	my $output = "";
        #($output) = saycmd_real($FILER, "priv set -q diag ; raid_config info listdisk $_[0]", $RAIDV2_TIMEOUT);
        $output = filer_cmd(host => host($FILER), cmd =>"priv set -q diag ; raid_config info listdisk $_[0]", timeout=> $RAIDV2_TIMEOUT);

        @info = split(/\r?\n/, $output);
	my(%count) = ();
	foreach $line (@info) {
		#chop $line;
		my(@disk_info) = split(",", $line);
		my($entry);
		my(%entrydb) = ();
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@disk_info) {
			if ($entry =~ /(.*)=(.*)/) {
				$entrydb{$1} = $2;
			}
		}

		#
		# Now, go back and get the disk name
		#
		my($name) = $entrydb{"name"};
		if (!$name) {
			next;
		}
		my($id) = $entrydb{"id"};
		my($raidname) = $entrydb{"raid_name"};
		
		my($tree) = $entrydb{"tree"};
		if ($tree) {
			if ($count{$tree}++ > 0) {
				$raidv2_info_tree_disk_list{$tree} .= ",";
			}
			$raidv2_info_tree_disk_list{$tree} .= $name;
		}
#############
		$tree = $entrydb{"tree"};
		if ($tree) {
			if ($count{$tree}++ > 0) {
				$raidv2_info_tree_diskid_list{$tree} .= ",";
			}
			$raidv2_info_tree_diskid_list{$tree} .= $id;
		}
##### 
		my($fsm) = $entrydb{"fsm_state"};
		if ($fsm) {
			if ($count{$fsm}++ > 0) {
				$raidv2_info_fsm_disk_list{$fsm} .= ",";
			}
			$raidv2_info_fsm_disk_list{$fsm} .= $name;
		}
#####

		if ($raidname =~ /^(\/.*\/plex[\d]+)\//) {
			my($plex) = $1;
			if ($count{$plex}++ > 0) {
				$raidv2_info_plex_disk_list{$plex} .= ",";
			}
			$raidv2_info_plex_disk_list{$plex} .= $name;
		}

		if ($raidname =~ /^(\/.*\/rg[\d]+)\//) {
			my($group) = $1;
			if ($count{$group}++ > 0) {
				$raidv2_info_group_disk_list{$group} .= ",";
			}
			$raidv2_info_group_disk_list{$group} .= $name;
		}
		
		my($e);

		foreach $e (keys %entrydb) {
			$raidv2_info_disk_by_name{$name}{$e} = $entrydb{$e};
			$raidv2_info_disk_by_id{$id}{$e} = $entrydb{$e};
			$raidv2_info_disk_by_raid_name{$raidname}{$e} =
							$entrydb{$e};
		}
	}
}

sub raidv2_info_status_load{
	my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);
	my(@info);
	my($line);
	my($tree_count);
	
	%raidv2_info_status_by_name = ();
	%raidv2_info_status_by_id = ();

	saycmd_real($FILER, "priv set -q diag; ps -h", $RAIDV2_TIMEOUT);	
	my($output) = saycmd_real($FILER, "priv set -q diag ; raid_config info liststatus $_[0]", $RAIDV2_TIMEOUT);
	@info = split(/\r?\n/, $output);
	my(%count) = ();
	foreach $line (@info) {
		#chop $line;
		my(@status_info) = split(",", $line);
		my($entry);
		my(%entrydb) = ();
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@status_info) {
			if ($entry =~ /(.*)=(.*)/) {
				$entrydb{$1} = $2;
			}
		}

		#
		# Now, go back and get the vol name
		#
		my($name) = $entrydb{"name"};
		if (!$name) {
			next;
		}
		my($id) = $entrydb{"id"};

		my($e);

		foreach my $e (keys %entrydb) {
		   	$raidv2_info_status_by_name{$name}{$e} = $entrydb{$e};
			$raidv2_info_status_by_id{$id}{$e} = $entrydb{$e};
		}
	}
}

sub raidv2_info_vol_load{

        #my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);
        filer_cmd(host=>host($FILER), cmd=>"priv"); 
	exit;
        my(@info);
	my($line);
	my($tree_count);
	my($flag) = 0;
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	
	%raidv2_info_vol_by_name = ();
	%raidv2_info_vol_by_id = ();

	@raidv2_info_vol_list =();
	
	saycmd_real($FILER, "priv -level -q diag; ps -h", $RAIDV2_TIMEOUT);
	my ($raid_info_cmd);
	if ($AGGR|$VVOLS) {
		$raid_info_cmd = "raid_config info listaggr $_[0]";
	} else {
		$raid_info_cmd = "raid_config info listvol $_[0]";
	}
	my($output) = saycmd_real($FILER, "priv set -q diag ; $raid_info_cmd", $RAIDV2_TIMEOUT);

	# burt146242 - work around, call cmd again  ---Viv
	# if no success after 4 retries, panic the filer
	for (my $i=0; $i<4; $i++) {
                if ($output eq "") {
                        #saycmd_real($FILER, "priv set -q diag; $cmd status", $RAIDV2_TIMEOUT);
                        filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; $cmd status", timeout => $RAIDV2_TIMEOUT);
                        #saycmd_real($FILER, "priv set -q diag; $cmd status -r $_[0]", $RAIDV2_TIMEOUT);
                        filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; $cmd status -r $[0]", timeout => $RAIDV2_TIMEOUT);
                        tstlog -comment, "$raid_info_cmd provides no output. Try again\n";
                        sleep(1);
                        #$output = saycmd_real($FILER, "priv set -q diag ; $raid_info_cmd", $RAIDV2_TIMEOUT);
                        filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; $raid_info_cmd", timeout => $RAIDV2_TIMEOUT);
                } else {
                        $flag = 1;
                        last;
                }
        }
        if ($flag != 1) {
                raidv2_log("panicking because $raid_info_cmd produce no output after retries.\n");
                #saycmd_real($FILER, "sysconfig -r");
                filer_cmd(host=>host($FILER), cmd=>"sysconfig -r", timeout => $RAIDV2_TIMEOUT);
                #saycmd_real($FILER, "priv set -q diag; panic", $RAIDV2_TIMEOUT);
                filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; panic", timeout => $RAIDV2_TIMEOUT);
        }

	@info = split(/\r?\n/, $output);
	my(%count) = ();
	my(%entrydb) = ();
	foreach $line (@info) {
		#chop $line;
		my(@vol_info) = split(",", $line);
		my($entry);
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@vol_info) {
			if ($entry =~ /(.*)=(.*)/) {
				$entrydb{$1} = $2;
			}
		}

		#
		# Now, go back and get the vol name
		#
		my($name) = $entrydb{"name"};
		push (@raidv2_info_vol_list, $name) ;
		if (!$name) {
			next;
		}
		my($id) = $entrydb{"id"};

		my($e);

		foreach $e (keys %entrydb) {
			$raidv2_info_vol_by_name{$name}{$e} = $entrydb{$e};
			$raidv2_info_vol_by_id{$id}{$e} = $entrydb{$e};
		}
	}

	#
	# Load the mirror voting record info, also.
	#
	%raidv2_info_mvm = ();
	%raidv2_info_mvm_count = ();
	%raidv2_info_mvm_by_key = ();
        #$output = saycmd_real($FILER, "priv set -q diag ; raid_config info listmvm $_[0]", $RAIDV2_TIMEOUT);
        filer_cmd(host=>host($FILER), cmd=>"priv set -q diag ; raid_config info listmvm $_[0]", timeout => $RAIDV2_TIMEOUT);
	@info = split(/\r?\n/, $output);
	foreach $line (@info) {
	    last if ($line =~ /^version/);
	}
	if ($line =~ /^version/) {
	    #chop $line;
	    local(@mvm_info) = split(",", $line);
	    foreach $entry (@mvm_info) {
		if ($entry =~ /(.*)=(.*)/) {
		    $raidv2_info_mvm{$1} = $2;
		}
	    }
	}
	foreach $line (@info) {
		#chop $line;
		local(@vol_info) = split(",", $line);
		local($entry);
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@vol_info) {
			if ($entry =~ /(.*)=(.*)/) {
				$entrydb{$1} = $2;
			}
		}

		my($id) = $entrydb{"id"};
		my($ctime) = $entrydb{"ctime"};
		my($creator_sysid) = $entrydb{"creator_sysid"};
		
		my($e);
		
		my($key) =
			"id=$id,ctime=$ctime,creator_sysid=$creator_sysid";
		$raidv2_info_mvm_by_key{$key}{key} = $key;
		
		$raidv2_info_mvm_count{$key}++;

		foreach $e (keys %entrydb) {
			$raidv2_info_mvm_by_key{$key}{$e} = $entrydb{$e};
		}
	}
}

sub raidv2_info_plex_load{
	my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);
	my(@info);
	my($line);
	my($tree_count);
	
	%raidv2_plex_vol_by_name = ();
	%raidv2_plex_vol_by_id = ();
	%raidv2_plex_vol_by_parentid = ();
	%raidv2_info_tree_plex_list = ();
	%raidv2_info_plex_by_name = ();
	%raidv2_info_plex_by_parentid = ();

	saycmd_real($FILER, "priv set -q diag; ps -h", $RAIDV2_TIMEOUT);
	my($output) = saycmd_real($FILER, "priv set -q diag ; raid_config info listplex $_[0]", $RAIDV2_TIMEOUT);
	@info = split(/\r?\n/, $output);
	my(%count) = ();
	foreach $line (@info) {
		#chop $line;
		my(@plex_info) = split(",", $line);
		my($entry);
		my(%entrydb) = ();
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@plex_info) {
			if ($entry =~ /(.*)=(.*)/) {
				$entrydb{$1} = $2;
			}
		}
		my($name) = $entrydb{"raid_name"};
		if (!$name) {
			next;
		}
		my($tree) = $entrydb{"tree"};
		
		if ($tree) {
			tstlog -comment, "tree is $tree, name is $name";
			if ($count{$tree}++ > 0) {
				$raidv2_info_tree_plex_list{$tree} .= ",";
			}
			$raidv2_info_tree_plex_list{$tree} .= $name;
		}
		#
		# Now, go back and get the vol name
		#
		$name = $entrydb{"raid_name"};
		if (!$name) {
			next;
		}
		my($id) = $entrydb{"id"};
		my($parentid) = $entrydb{"parent_id"};

		my($e);

		foreach $e (keys %entrydb) {
			$raidv2_info_plex_by_name{$name}{$e} = $entrydb{$e};
			$raidv2_info_plex_by_id{$id}{$e} = $entrydb{$e};
			$raidv2_info_plex_by_parentid{$parentid}{$e} = $entrydb{$e};
		}
	}
}

sub raidv2_info_group_load{
        #my($priv) = saycmd_real($FILER, "priv", $RAIDV2_TIMEOUT);
        my $priv = filer_cmd(host=>host($FILER), cmd=>"priv", timeout=>$RAIDV2_TIMEOUT); 
	my(@info);
	my($line);
	my($tree_count);
	my($flag) = 0;
	
	%raidv2_info_group_by_name = ();
	%raidv2_info_group_by_id = ();
	%raidv2_info_tree_group_list = ();
	
        #saycmd_real($FILER, "priv set -q diag; ps -h", $RAIDV2_TIMEOUT);
	filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; ps -h", timeout => $RAIDV2_TIMEOUT); 
        #my($output) = saycmd_real($FILER, "priv set -q diag ; raid_config info listgroup $_[0]", $RAIDV2_TIMEOUT);
	my $output  = filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; raid_config info listgroup $_[0]", timeout => $RAIDV2_TIMEOUT); 

        # burt146242 - work around, call cmd again  ---Viv
	# if no success after 4 retries, panic the filer
	for (my $i=0; $i<4; $i++) {
                if ($output eq "") {
                        tstlog -comment, "raid_config info listgroup provides no output. Try again\n";
                        sleep(1);
                        #$output = saycmd_real($FILER, "priv set -q diag ; raid_config info listgroup $_[0]", $RAIDV2_TIMEOUT);
                        $output = filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; raid_config info listgroup $_[0]", timeout => $RAIDV2_TIMEOUT); 

                } else {
                        $flag = 1;
                        last;
                }
        }
        if ($flag != 1) {
                raidv2_log("panicking because raid_config info listgroup produce no output after retries.\n");
                #saycmd_real($FILER, "sysconfig -r");
                filer_cmd(host=>host($FILER), cmd=>"sysconfig -r", timeout => $RAIDV2_TIMEOUT); 
                #saycmd_real($FILER, "priv set -q diag; panic", $RAIDV2_TIMEOUT);
                filer_cmd(host=>host($FILER), cmd=>"priv set -q diag; panic", timeout => $RAIDV2_TIMEOUT); 
        }

	@info = split(/\r?\n/, $output);
	my(%count) = ();
	foreach $line (@info) {
		my(@group_info) = split(",", $line);
		my($entry);
		my(%entrydb) = ();
		# print MY_LOG "*** $line\n";
		
		#
		# Load the entry
		#
		foreach $entry (@group_info) {
			if ($entry =~ /(.*)=(.*)/) {
				#tstlog -comment, "1 is $1 2 is $2";
				$entrydb{$1} = $2;
			}
		}

		#
		# Now, go back and get the raid name
		#
		my($name) = $entrydb{"raid_name"};
		if (!$name) {
			next;
		}
		my($id) = $entrydb{"id"};
		my($tree) = $entrydb{"tree"};
		
		if ($tree) {
			#tstlog -comment, "tree is $tree, name is $name";
			if ($count{$tree}++ > 0) {
				$raidv2_info_tree_group_list{$tree} .= ",";
			}
			$raidv2_info_tree_group_list{$tree} .= $name;
		}
		
		my($e);
		foreach $e (keys %entrydb) {
			$raidv2_info_group_by_name{$name}{$e} = $entrydb{$e};
			$raidv2_info_group_by_id{$id}{$e} = $entrydb{$e};
			$raidv2_info_tree_group_list{$tree}{$e} = $entrydb{$e};
			
		}

	}
}

sub raidv2_info_load {
	raidv2_info_disk_load();
	raidv2_info_group_load();
	raidv2_info_plex_load();
	raidv2_info_vol_load();
}

sub raidv2_fiji_add_filter($) {
	my($output) = saycmd_real($FILER, "priv set -q diag; fiji filter \"$_[0]\"", $RAIDV2_TIMEOUT);
	if (!($output =~ /filter set/)) {
		#raidv2_log("Fiji failure: $output");
		#return 0;
		# Catch bad filters by fatal
		# Filter error goes to console, not cmd response, so $output may be empty
		# Repeat filter string in case RAIDANT merged subtest logs separate it too much,
		# and keep on same log line as FATAL for greps
		tstlog -fatal, "Fiji failure: $output $_[0]"
	}
	return 1;

}

sub raidv2_fiji_add_nvfilter($) {
	my($output) = saycmd_real($FILER, "priv set -q diag; fiji nvfilter \"$_[0]\"", $RAIDV2_TIMEOUT);
	if (!($output =~ /filter set \(nvram\)/)) {
		tstlog -fatal, "Fiji failure: $output";
	}
	
}

sub raidv2_fiji_clear_all() {
	my($output) = saycmd_real($FILER, "priv set -q diag; fiji clear all", $RAIDV2_TIMEOUT);
	if (!($output =~ /filter cleared/)) {
		tstlog -fatal, "Fiji failure: $output";
	}

	$output = saycmd_real($FILER, "priv set -q diag; fiji nvclear all", $RAIDV2_TIMEOUT);
	# Feb 17, 2005 -- Tom Doan commented out the check since
        # there are problems on Anchorsteam tree which returns nothing
	#if (!($output =~ /filter cleared/)) {
	#	tstlog -fatal, "Fiji failure: $output";
	#}
	
}

sub raidv2_fiji_add_filter_multi($$) {
	my($output) = saycmd_real($FILER, "priv set -q diag; fiji filter \"$_[1]\"", $RAIDV2_TIMEOUT);
	if (!($output =~ /filter set/)) {
		tstlog -fatal, "Fiji failure: $output";
	}
	
}

sub raidv2_is_syncmirror_licensed {
	my(@info);
	my($output) = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);
	my($line);

	@info = split(/\n/, $output);
	foreach $line (@info) {
		if ($line =~ /syncmirror/) {
			if ($line =~ /not licensed/) {
				return 0;
			} else {
				return 1;
			}
		}
	}
	return 0;
}


sub raidv2_is_syncmirror_local_licensed {
	my(@info);
	my($output) = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);
	my($line);

	@info = split(/\n/, $output);
	foreach $line (@info) {
		if ($line =~ /syncmirror_local/) {
			if ($line =~ /not licensed/) {
				return 0;
			} else {
				return 1;
			}
		}
	}
	
	return 0;
}

sub raidv2_syncmirror_unlicense {
	my(@info);
	my($output) = saycmd_real($FILER, "priv set -q diag; license delete syncmirror_local", 
				  $RAIDV2_TIMEOUT);
	my($line);

	$output = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);

	@info = split(/\n/, $output);
	foreach $line (@info) {
		if ($line =~ /syncmirror/) {
			if ($line =~ /not licensed/) {
				return 1;
			} else {
				return 0;
			}
		}
	}
	
	return 0;
}

sub raidv2_syncmirror_local_unlicense {
	my(@info);
	my($output) = saycmd_real($FILER, "priv set -q diag; license delete syncmirror_local",
				 $RAIDV2_TIMEOUT);
	my($line);

	$output = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);

	@info = split(/\n/, $output);
	foreach $line (@info) {
		if ($line =~ /syncmirror/) {
			if ($line =~ /not licensed/) {
				return 1;
			} else {
				return 0;
			}
		}
	}
	
	return 0;
}

sub raidv2_syncmirror_license {
        my(@info);
        my($output) = saycmd_real($FILER,
                                  "priv set -q diag; license add UELJHSI", $RAIDV2_TIMEOUT);
	if($output =~ /"A syncmirror_local site license has been installed"/) {
		return 1;
	}
	
        $output = saycmd_real($FILER,
                                  "priv set -q diag; license add RIQTKCL", $RAIDV2_TIMEOUT);
	if($output =~ /"A syncmirror_local site license has been installed"/) {
		return 1;
	}

#       raidv2_saycmd($FILER, "priv set -q diag; license add RIQTKCL");
#       $output = saycmd_real($FILER,
#                        "priv set -q diag; license add UELJHSI", $RAIDV2_TIMEOUT);
        my($line);

        $output = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);

        @info = split(/\n/, $output);
        foreach $line (@info) {
                if ($line =~ /syncmirror_local/) {
                        if ($line =~ /not licensed/) {
                                return 0;
                        } else {
                                return 1;
                        }
                }
        }

        return 0;
}

sub raidv2_syncmirror_local_license {
	my(@info);
	my($output) = saycmd_real($FILER,
			"priv set -q diag; license add UELJHSI", $RAIDV2_TIMEOUT);
	my($line);

	$output = saycmd_real($FILER, "priv set -q diag; license", $RAIDV2_TIMEOUT);

	@info = split(/\n/, $output);
	foreach $line (@info) {
		if ($line =~ /syncmirror_local/) {
			if ($line =~ /not licensed/) {
				return 0;
			} else {
				return 1;
			}
		}
	}
	
	return 0;
}

sub raidv2_wafliron_status($) {
	my $vol = $_[0]; 
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	my $o = raidv2_saycmd($FILER, "priv set -q diag; $cmd wafliron status $vol");
	if ($o =~ /not currently/) {
		return 0;
	} elsif ($o =~ /active/) {
		return 1;
	}
	return 0;
}

sub raidv2_wafliron_start($) {
	my $vol = $_[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	my $o = raidv2_saycmd($FILER, "priv set -q diag; $cmd wafliron start $vol");
}


sub raidv2_wait_for_zeroing {
	my($mycount) = 0;
	my($total) = 0;
	my($time_waited) = 0;
	raidv2_info_disk_load();
	for ($mycount = 1; $mycount > 0; ) {
		raidv2_info_disk_load();
		$mycount = 0;
		$total = 0;
		foreach $e (keys %raidv2_info_disk_by_name) {
			my($mystate) = $raidv2_info_disk_by_name{$e}{fsm_state};
			if ($mystate eq "ZEROING") {
				$mycount++;
			}
			if ( $raidv2_info_disk_by_name{$e}{parent_state} eq "???" ) {
				# count only spares
				$total++;
			}
		}
	    tstlog -comment, "mycount is $mycount";

	    #
	    # Sleep while waiting (4 seconds for each disk
	    #
	    if ($mycount > 0) {
		    if (!raidv2_is_simulator()) {
			    if ($total - $mycount >= 12) {
				    return;
			    }
		    }
		    raidv2_log("waiting for zeroing");
		    my $wait_time = $mycount*4;
		    tstlog -comment, "Sleeping for $wait_time seconds, waiting for $mycount disks to finish zeroing";
		    sleep $wait_time;
		    $time_waited += $wait_time;
	    }
	}
	tstlog -comment, "waited $time_waited seconds for disks to zero";
}

sub raidv2_wait_for_complete_zeroing {
	my($mycount) = 0;
	my($total) = 0;
	my($time_waited) = 0;
	raidv2_info_disk_load();
	for ($mycount = 1; $mycount > 0; ) {
		raidv2_info_disk_load();
		$mycount = 0;
		$total = 0;
		foreach $e (keys %raidv2_info_disk_by_name) {
			my($mystate) = $raidv2_info_disk_by_name{$e}{fsm_state};
			if ($mystate eq "ZEROING") {
				$mycount++;
			}
			
			$total++;
		}
	        tstlog -comment, "mycount is $mycount";
		# Sleep while waiting (4 seconds for each disk
		if ($mycount > 0) {
			raidv2_log("waiting for zeroing");
			my $wait_time = $mycount*4;
			tstlog -comment, "Sleeping for $wait_time seconds, waiting for $mycount disks to finish zeroing";
			sleep $wait_time;
			$time_waited += $wait_time;
		}
	}
	tstlog -comment, "waited $time_waited seconds for disks to zero";
}


sub raidv2_wait_for_partial_zeroing {
	my($mycount) = 0;
	my($time_waited) = 0;
	raidv2_info_disk_load();
	for ($mycount = 1; $mycount > 0; ) {
	    $mycount = 0;
	    foreach $e (keys %raidv2_info_disk_by_name) {
		my($mystate) = $raidv2_info_disk_by_name{$e}{fsm_state};
		if ($mystate eq "ZEROING") {
		    $mycount++;
		}
	    }
	    tstlog -comment, "mycount is $mycount";

	    #
	    # Sleep while waiting (4 seconds for each disk
	    #
	    if ($mycount > 0) {
		    my $wait_time = $mycount*4;
		    tstlog -comment, "Sleeping for $wait_time seconds, waiting for $mycount disks to finish zeroing";
		    sleep $wait_time;
		    raidv2_info_disk_load();
		    $time_waited += $wait_time;
	    }
	}
	tstlog -comment, "waited $time_waited seconds for disks to zero";
}


sub raidv2_vol_create($) {
	my($attrs) = $_[0];
	my(@args) = split(/ /, $attrs);
	my($vol) = $args[0];
	my($aggr) = $vol;
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";

        print "hated by all";
        exit;
        
	if($cmd eq "aggr"){
	    $AGGR = $VVOLS = 1;
        }
     
        print "hated by all!";
	# Added by RAID QA NB
	if($VOL_REUSE){ 
		# If the existing vol properties match, we will use the same volume else we remove the vol and proceed with vol creation
	    if (raidv2_vol_property_check($vol)){
	        tstlog -comment, "Vol creation will be skipped because the required vol already exists and VOL RESUE is set";
	        return 1;
            }else{
                if (!raidv2_remove_volume($vol)){
		    tstlog -fatal, "Volume with same name exists and cannot be removed";
		}
	    }
        }
        
	# Added for LA support - Divyesh. 
        my $la = 0;
        if ($attrs =~ /-B\s+64/) {
        $la = 1;
        }

        if($AGGR_BITS == 64 || $FAKE_LA == 1){
                if($attrs =~ m/-B\s+\d+/) {
                        tstlog -comment, "In aggrbits $attrs";
                        $attrs =~ s/-B\s+\d+/-B 64/;
                }else{
                        $attrs = $vol.' -B 64 '.join(" ", @args[1..$#args]);
                }
        	@args = split(/ /, $attrs);
        }

	logcomment("Creating $cmd $vol...");

	#MTK_EDIT:25/09/08::Added parameters to add disks using -d option

             my $args1;
             my $args2;
             my $disk_list;
             my @list_disks;
             my $add_disks;
             my $spare_list = 0;

	
	#RAID QA NB: If Aggregate is 64 bit (LA), it could be FAKE_LA or normal LA. For FAKE_LA we set raidtop env var
	if($FAKE_LA==1) {
	    if ($attrs !~ /-r\s+\d+/) {
                $attrs = $vol . ' ' .join(" ", @args[1,2]) . ' -r ' . "$RG_SIZE " . join(" ", @args[3..$#args]);
                @args = split(/ /, $attrs);
            }

	    $la = 0; #when $la is removed all together, this has to be removed too
	    $AGGR_BITS = 64;
	    $AGGR = $VVOLS = 1;
	    $cmd = ($AGGR|$VVOLS) ? "aggr" : "vol";
	    $flex_vol = 1;
	    $_ = $attrs;
	    
	    if ($FAKE_RG_MAX_COUNT < 3){ 
	        tstlog -fatal, "Having less than FAKE RG doesn't garantee that we test >16t vvbn";
	    }
	     if (m/-m/i){
		$mirror = 1;
	     }
	     $min_disks_rg = 3;
	     $min_disks_rg = 6 if $mirror == 1;

	     if ((m/-t\s+4/i) || (m/-t\s+raid4/i)){
		 $min_disks_rg = 2;
	         $min_disks_rg = 4 if $mirror == 1;

	     }
             ($rg_size) = m/-r\s+(.*)\s+/;
	     # Dealing with condition where addition of disks doesn't create 
	     tstlog -comment, "FAKE LA min disks in rg is $min_disks_rg";
	     
	     #MTK_EDIT:25/09/08::Changed to add disks using -d option

             if ($attrs =~ /-d\s+/) {
                $spare_list = 1;
                ($args1,$args2) = split(/-d\s+/, $attrs);
                @list_disks = split(/ /,$args2);
                $disk_list = $#list_disks+1;

                if($disk_list < $min_disks_rg) {
                        tstlog -fatal, "FAKE LA cannot be created due to insufficient number of disks. Please make sure that the number of disks passed are enough to create a new raid group";
                }
		tstlog -comment,"MIN DISKS ARE: $min_disks_rg";

                $add_disks = join (" ", @list_disks[0..($min_disks_rg-1)]);
                $attrs = "$args1 ".'-d'." $add_disks";
                $no_disks = $disk_list - $min_disks_rg;
             } else {
                     $no_disks = $args[$#args] - $min_disks_rg;
                     # Performing a check to make sure that if a new raid group gets created while adding disks, it has the minimum number of disks required to create a full raid group
                     if (($rg_size == $min_disks_rg) && ($no_disks < $min_disks_rg)){
                        tstlog -fatal, "FAKE LA cannot be created due to insufficient number of disks. Please make sure that the number of disks passed are enough to create a new raid group";
                     }
                     $args[$#args] = $min_disks_rg;
                     $attrs = join(" ", @args);
            }

	    #Flex vol size specified must be greater than 24t. Otherwise a fatal error is thrown.
	    if($FLEX_VOL_SIZE){
	        $_ = $FLEX_VOL_SIZE;
		if (m/t/){
		    ($value) = m/(.*)t/;
		    if ($value < 24){
			$error_flag = 1;
		    }
		}elsif (m/g/){
		    ($value) = m/(.*)g/;
		    if ($value < 24*1024){
			$error_flag = 1;
		    }
		}elsif (m/m/){
		    ($value) = m/(.*)m/;
		    if ($value < 24*1024*1024){
			$error_flag = 1;
		    }
		}elsif (m/k/){
		    ($value) = m/(.*)k/;
		    if ($value < 24*1024*1024*1024){
			$error_flag = 1;
		    }
	        }else{
		    $error_flag = 1;
		}
		if ($error_flag){
	            tstlog -fatal, "Flex vol size of less than 24t is not necessarily enough to write to a > 16t vvbn";
	        }
            } 
	    raidv2_saycmd($FILER, "priv set test; bootargs set ntap.dblade.fake_large_aggr true");
	    raidv2_saycmd($FILER, "priv set test; bootargs set raidtop_fake_rg_max_count $FAKE_RG_MAX_COUNT");
        }
        
	if($flex_vol || $FLEX_VOL_SIZE){
	    $flex_vol_size = $FLEX_VOL_SIZE ? $FLEX_VOL_SIZE : "24t";
        }

	# Mar 20, 2008 Tomdoan -- added raid0 in priv test mode only
	my $o; 
	if ($attrs =~ /-t raid0/) {
	    $o = saycmd_real($FILER, "priv set -q test; $cmd create $attrs", $RAIDV2_TIMEOUT);
	}
	else {
	    $o = saycmd_real($FILER, "priv set -q diag; $cmd create $attrs", $RAIDV2_TIMEOUT);
	}
	raidv2_info_vol_load($vol);
	if (($o =~ /has completed/ || $o =~/has been created/ || $o =~ /has been initiated/ ) ) {
		if (!$raidv2_info_vol_by_name{$vol}) {
			saycmd_real($FILER, "sysconfig -r");
			return 0;
		}
		raidv2_wait_on_vol_zeroing($vol);
		sleep 60; # I sometime found that disk still listed as 
			  # NOTZEROED in following rountine, so add some 
		          # delay here. -htu
		raidv2_info_vol_load($vol);			#added by skg, getting 0k size without this 

	#MTK_EDIT:25/09/08::Changed to add disks using -d option

	if($FAKE_LA){
	    #$attrs_for_add = "$vol -s 4294967296 $no_disks"; 
            if ($spare_list == 0) {
                $attrs_for_add = "$vol -s 4294967296 $no_disks";
            } else {
                $remain_disks = join (" ", @list_disks[$min_disks_rg..$disk_list]);
                $attrs_for_add = "$vol -s 4294967296 -d $remain_disks";
            }
	    raidv2_vol_add($attrs_for_add); 
	}

		if ($AGGR|$VVOLS) {
                        if ($la) {
                            my $vol_size = "24t";  #added by divyesh for LA testing. Fixed value as of now.
                            saycmd_real($FILER, "priv set -q diag; vol create $vol -s none $aggr $vol_size", $RAIDV2_TIMEOUT);
                        }elsif($flex_vol){
                            saycmd_real($FILER, "priv set -q diag; vol create $vol -s none $aggr $flex_vol_size", $RAIDV2_TIMEOUT);
			}else {
			    my $vol_size= 3072 * $raidv2_info_vol_by_name{$vol}{raidsize};  #added by skg, using only 1/3 space of aggr without this
			    if ($flex_vol_size){
				$vol_size = $flex_vol_size;
			    }
			saycmd_real($FILER, "priv set -q diag; vol create $vol $aggr $vol_size", $RAIDV2_TIMEOUT);
                        }
		}
		raidv2_info_load();
		my @ldisklist = split(",", $raidv2_info_tree_disk_list{$vol});
		if ($raidv2_info_vol_by_name{$vol} &&
		    $#ldisklist == -1) {
			raidv2_log("panicking because volume exists with no disks");
			saycmd_real($FILER, "sysconfig -r; priv set -q diag; panic", $RAIDV2_TIMEOUT);
		}
		logcomment("$cmd $vol created and checked.");
		return 1;
	}
	
	return 0;
}

sub raidv2_vol_create_no_wait($) {
	my($attrs) = $_[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	my(@args) = split(/ /, $attrs);
	my($vol) = $args[0];
	$o = saycmd_real($FILER, "$cmd create $attrs", $RAIDV2_TIMEOUT);
	raidv2_info_vol_load($vol);
	if (($o =~ /has completed/ || $o =~/has been created/ || $o =~ /has been initiated/ )  && $raidv2_info_vol_by_name{$vol}) {
		return 1;
	}
	
	return 0;
}

# XXX check that the number of disks
# has in fact increased
sub raidv2_vol_add($) {
	my($attrs) = $_[0];
	my(@args) = split(/ /,$attrs);
	my($vol) = $args[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";

	my($o) = saycmd_real($FILER, "$cmd add $attrs", $RAIDV2_TIMEOUT);
	if ($o =~ /\bfailed\b/ || $o =~ /\bnot\b/ || $o =~ /\bwrong\b/) {	#MTK_UNIT: Edited, 2 Apr 2008
	#if ($o =~ /failed/) { 							#MTK_UNIT: Commented
		return 0;
	}

	my ($wait) = ($o =~ /need/); 
	raidv2_wait_on_vol_zeroing($vol);
	if ($AGGR|$VVOLS) {
		raidv2_info_vol_load($vol);
		saycmd_real($FILER, "vol size $vol $raidv2_info_vol_by_name{$vol}{raidsize}k", $RAIDV2_TIMEOUT);
	}
	if ($wait) {
	    return 2;
	}
	return 1;
}
sub raidv2_vol_add_no_wait($) {
	my($attrs) = $_[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	my(@args) = split(/ /,$attrs);
	$o = saycmd_real($FILER, "$cmd add $attrs", $RAIDV2_TIMEOUT);
	if ($o =~ /failed/ || $o =~ /Not enough/ || $o =~ /not enough/) {
		return 0;
	}
	return 1;
}

sub raidv2_vol_online($) {
	my($attrs) = $_[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	raidv2_log("waiting $RAIDV2_TIMEOUT seconds for online to succeed");
	my($o) = saycmd_real($FILER, "$cmd online $attrs -f", $RAIDV2_TIMEOUT);

        # If vol is busy in another op, give it time to finish that OP.

        my $i = 1;
        while($o =~ /busy/ && $i < 24 ){
           sleep(15);
           raidv2_log("Sleeping for the vol to become idle: $o");
           $o = saycmd_real($FILER, "$cmd online $attrs", $RAIDV2_TIMEOUT);
           $i++;
        }

	raidv2_info_vol_load($attrs);
	if ($o =~ "now online" && $raidv2_info_vol_by_name{$attrs}{state_name} eq "online") {
		return 1;
	}
	raidv2_log("state_name is $raidv2_info_vol_by_name{$attrs}{state_name}");
	return 0;
}

sub raidv2_vol_online_readonly($)
{
        my($attrs) = $_[0];
        my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
        raidv2_log("waiting $RAIDV2_TIMEOUT seconds for online to succeed");
	# ---------------------------------------------	
	# Tom Doan - the priv must be TEST in this case
	# ---------------------------------------------
        my($o) = saycmd_real($FILER, "priv set -q test; $cmd online $attrs -ro -f", $RAIDV2_TIMEOUT);
        raidv2_info_vol_load($attrs);
        if ($o =~ "now online" && $raidv2_info_vol_by_name{$attrs}{state_name} eq "online") {
                return 1;
        }
        raidv2_log("state_name is $raidv2_info_vol_by_name{$attrs}{state_name}") ;
        return 0;
}


sub raidv2_vol_offline($) {
	my($attrs) = $_[0];
	my $o;
    	raidv2_stop_hammer($volume);
	raidv2_log("waiting $RAIDV2_TIMEOUT seconds for offline to succeed");
	
	if ($AGGR|$VVOLS) {
		$o = saycmd_real($FILER, "priv set -q diag;aggr offline $attrs -a -f", $RAIDV2_TIMEOUT);
	} else {
		$o = saycmd_real($FILER, "vol offline $attrs", $RAIDV2_TIMEOUT);
	}
	raidv2_info_vol_load($attrs);
	if ($o =~ "now offline" && ($raidv2_info_vol_by_name{$attrs}{state_name} eq "offline" || ($raidv2_info_vol_by_name{$attrs}{state_name} eq "unmounting"))) {
		return 1;
	} else {
		tstlog -comment, "no snapshot reference, not offline, not unmounting - extremely confused";

#	raidv2_log("state_name is $raidv2_info_vol_by_name{$attrs}{state_name}");
	return 0;
	}
}

sub raidv2_vol_rename($$) {
	my($origname, $newname) = ($_[0], $_[1]);
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	raidv2_log("waiting $RAIDV2_TIMEOUT seconds for rename to succeed");
	my($o) = saycmd_real($FILER, "$cmd rename $origname $newname", $RAIDV2_TIMEOUT);
	raidv2_info_vol_load($attrs);
	if ($o =~ "renamed to" && $raidv2_info_vol_by_name{$newname} &&
	    !$raidv2_info_vol_by_name{$origname}) {
		return 1;
	}
	# Didn't succeed, print out status
	raidv2_log("state_name is $raidv2_info_vol_by_name{$origname}{state_name}");
	return 0;
}

sub raidv2_vol_restrict($) {
	my($attrs) = $_[0];
        my $o;
        raidv2_stop_hammer($volume);
        raidv2_log("waiting $RAIDV2_TIMEOUT seconds for restrict to succeed");

        if ($AGGR|$VVOLS) {
                $o = saycmd_real($FILER, "priv set -q diag;aggr restrict $attrs -a -f", $RAIDV2_TIMEOUT);
        } else {
                $o = saycmd_real($FILER, "vol restrict $attrs", $RAIDV2_TIMEOUT);
        }

#	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
#	$o = saycmd_real($FILER, "$cmd restrict $attrs", $RAIDV2_TIMEOUT);
	raidv2_info_vol_load($attrs);
	if ($o =~ "now restricted" && (($raidv2_info_vol_by_name{$attrs}{state_name} eq "restricted") || 
				       ($raidv2_info_vol_by_name{$attrs}{state_name} eq "unmounting"))) {
		return 1;
	}
	return 0;
}

sub raidv2_vol_mirror($) {
	my($vol) = $_[0];
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";

	$o = saycmd_real($FILER, "$cmd mirror $vol", $RAIDV2_TIMEOUT);
	raidv2_info_vol_load($attrs);
	if ($o =~ /has completed/ ) {
		return 1;
	} elsif ($o =~ /has been initiated/) {
		raidv2_wait_on_vol_zeroing($vol);
		return 1;
	} elsif ($raidv2_info_vol_by_name{$vol}{raidtree_type} eq "mirror_raid4") {
		return 1;
		raidv2_log("major badness: vol mirror returned no output"); 
	} elsif ($raidv2_info_vol_by_name{$vol}{raidtree_type} eq "mirror_raidrd") {
		return 1;
		raidv2_log("major badness: vol mirror returned no output"); 
	}

	return 0;
}

sub raidv2_plex_online($) {
	my($attrs) = $_[0];
	# ----------------------------------------------------------------------
	# Tom Doan 02/23/06 -- modify the routine to check for plex name without
	# a "/" and add it since raid_config info listplex requires this.
	# ----------------------------------------------------------------------
	if ($attrs !~ "^/") {
	    $attrs = "/" . $attrs; 
	}
	my($name) = "$attrs";
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol"; #added by skg on 06/13/05 to make it working for aggr
	my($o) = saycmd_real($FILER, "$cmd online $attrs", $RAIDV2_TIMEOUT);
        # If vol is busy in another op, give it time to finish that OP.
         my $i = 1;
         while($o =~ /busy/ && $i < 24 ){
            sleep(15);
            raidv2_log("Sleeping for the vol to become idle: $o");
            $o = saycmd_real($FILER, "$cmd online $attrs", $RAIDV2_TIMEOUT);
            $i++;
         }

	raidv2_info_plex_load($name);
	raidv2_log("state for \"$name\" is $raidv2_info_plex_by_name{$name}{online}");

	# ------------------------------------------------
	# Tom Doan - burt# 178639 verify if the plex is
	# brought back online or not
	# ------------------------------------------------
	if ($o =~ "The specified operation could not be completed") {
	    return 0; 
	}
	return 1 ;
	if ($o =~ "now online" && $raidv2_info_plex_by_name{$name}{online} == 1) {
		return 1;
	}
	raidv2_log("state for $name is $raidv2_info_plex_by_name{$name}{online}");
	return 0;
}

sub raidv2_plex_offline($) {
	my($attrs) = $_[0];
	# ----------------------------------------------------------------------
	# Tom Doan 02/23/06 -- modify the routine to check for plex name without
	# a "/" and add it since raid_config info listplex requires this.
	# ----------------------------------------------------------------------
	if ($attrs !~ "^/") {
	    $attrs = "/" . $attrs; 
	}
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol"; #added by skg on 06/13/05 to make it working for aggr
	my($o) = saycmd_real($FILER, "$cmd offline $attrs", $RAIDV2_TIMEOUT);
	raidv2_info_plex_load($attrs);
	saycmd($FILER,"priv set -q advanced;sysconfig -r");
       
	my($name) = "$attrs";
	raidv2_log("state for \"$name\" is $raidv2_info_plex_by_name{$name}{online}");
	if ($o =~ "now offline" && $raidv2_info_plex_by_name{$name}{online} == 0) {
		return 1;
	}
	raidv2_log("state for $attrs is $raidv2_info_plex_by_name{$name}{online}");
	return 0;
}

sub raidv2_vol_split($$) {
        my($vol) = $_[0];
        my($vol2) = $_[1];
        my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
        my($o) = saycmd_real($FILER, "$cmd split $vol $vol2", $RAIDV2_TIMEOUT);
        raidv2_info_vol_load($vol2);
        if ($raidv2_info_vol_by_name{$vol2} && ($o =~ /volume $vol2 completed/ ||
                                                $o =~ /$vol2 created/)) {
                return 1;
        }
        return 0;
}

# Removes volume.
# Returns 1 for success, 0 for failed -- fatal on fail.
sub raidv2_remove_volume($) {
	my $volume = shift(@_);
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";

	logcomment("Removing volume $volume.");

	raidv2_info_vol_load($volume);
	if (!$raidv2_info_vol_by_name{$volume}) {
		logcomment("No volume $volume.");
		return 1;
	}

	# --------------------------------------------------------------
	# Tom Doan 11/16/06 - During initialization, the volume could be 
	# temporary empty until all disks are zeroed. Before panic, the 
	# script should wait. 
	# --------------------------------------------------------------
	for (my $i = 0; $i <= 5; $i++) {
	    raidv2_info_disk_load();
	    my @ldisklist = split(",", $raidv2_info_tree_disk_list{$volume});
	    if ($#ldisklist == -1) {
		if ($i >= 5) {
		    raidv2_log("Panicking because volume: $volume exists with no disks after waiting for the init to complete.");
                    #saycmd_real($FILER, "sysconfig -r; priv set -q diag; panic", $RAIDV2_TIMEOUT);
                    filer_cmd(host => host($FILER), cmd =>"sysconfig -r; priv -level -q diag; panic", timeout=> $RAIDV2_TIMEOUT);
		}
		sleep(10); 
	    } else {
		last; # done if the volume has some disks
	    }
	} #for 

	raidv2_stop_hammer($volume);

	# Offline
	if ($raidv2_info_vol_by_name{$volume}{wafl_online}) {
		# Can offline during reparity, scrub, or recons.
		# Sometimes not during recons start:
		#   vol offline: The specified operation could not be completed as the volume is currently busy (dynamic grow).
		# or other ops:
		# - vol offline: The specified operation could not be completed as the volume is currently busy (dynamic create).
		# - Volume pyant_vol00 may not be offlined because of 1 snapshot reference
		#   vol offline: Volume is in use by other operations.
		# The following prevents offline of volume pyant_vol00:  mirror resync snapshots
		#   vol offline: Volume is in use by other operations.
		# Partial volumes (e.g. from orphan disks) are already offline:
		#   vol offline: Volume 'pyant_vol00500' is a partial volume.
		# Wait if vol busy or in use, don't need to wait for recons finish.
		# No vol or group flag for busy?
		# recons_progress, reparity_progress, scrub_progress show activity but don't prevent offline.
		# Just show status and retry.
		# Be careful of calling subs that may call this one again.
		my $wait_counts = 30;
		my $sleep_time  = 5;
		my $offline = 0;
		my $i;
		for ($i = 0; $i <= $wait_counts; $i ++) {
			if ($AGGR|$VVOLS) {
                                #$o = saycmd_real($FILER, "priv set -q diag;aggr offline $volume -a -f", $RAIDV2_TIMEOUT);
                                $o = filer_cmd(host => host($FILER), cmd =>"priv -level -q diag; aggr offline $volume -a -f", timeout=> $RAIDV2_TIMEOUT);

			} else {
                                #$o = saycmd_real($FILER, "$cmd offline $volume", $RAIDV2_TIMEOUT); 
			        $o = filer_cmd(host => host($FILER), cmd =>"$cmd offline $volume", timeout=> $RAIDV2_TIMEOUT);
                        }
			if ($o =~ /now offline/ || $o =~ /has failed/ || $o =~ /is a partial volume/) {
				$offline = 1;
				last;
			} elsif ($o =~ /currently busy/ || $o =~ /in use by other operations/) {
				#saycmd_real($FILER, "sysconfig -r", $RAIDV2_TIMEOUT);
				raidv2_info_vol_load($volume);
				raidv2_info_group_load($volume);
				if ($i < $wait_counts) {
					logcomment("Waiting $sleep_time seconds for offline retry...");
					sleep($sleep_time);
					next;
				} else {
					logcomment("Vol still busy after " . ($i * $sleep_time) . " wait seconds.");
					last;
				}
			} else {
				last;
			}
		}
		if ($offline != 1) {
			#tstlog -comment, "panicking because vol offline failed due to busy volume when it should not have ";
			#saycmd_real($FILER, "sysconfig -r; priv set -q diag; panic", $RAIDV2_TIMEOUT);
			saycmd_real($FILER, "sysconfig -r", $RAIDV2_TIMEOUT);
			tstlog -fatal, "$cmd offline $volume failed:  $o";
			return 0;
		}
	}

	# Destroy
	$o = saycmd_real($FILER, "$cmd destroy $volume -f", $RAIDV2_TIMEOUT);
	if ($o !~ /destroyed/ ) {
		tstlog -fatal, "vol destroy of $volume ::= $o failed";
		return 0;
	}
	# wait to confirm destroy
	for ($i = 0; $i < 6; $i ++) {
		raidv2_info_vol_load($volume);
		last if !$raidv2_info_vol_by_name{$volume};
		sleep 5;
	}
	if ($raidv2_info_vol_by_name{$volume}) {
		tstlog -fatal, "vol destroy of $volume failed -- vol still present";
		return 0;
	}

	logcomment("Volume $volume removed.");
	return 1;
}

# --------------------------------------------------------------
## @name ::raidv2_vol_property_check
## @summary verifies property of the existing aggr
## @description routine This routine checks various attributes
## of existing volume. For now we only check the name of the vol
## More functionality need to be added as per requirement - eg: 
## Checking whether there are scrub error/media errors/checking 
## type and so on.
## @arg $name Name of the vol
## @return
##  1 -- PASSED - Existing vol properties match
##  0 -- FAILED - New aggr has to be created. The vol properties
##                doesn't match
# --------------------------------------------------------------
sub raidv2_vol_property_check(@){
	my $name = shift(@_);
	if (raidv2_vol_exist($name)){
	    return 1;
        }
	$VOL_REUSE = 0;
	return 0;
}

sub raidv2_vol_exist($) {
	my $volume = shift(@_);
	raidv2_info_vol_load();
	my $vol =();

	foreach $vol (@raidv2_info_vol_list) {
	  if ( $vol eq $volume ) {
		return 1;
	  }
	}
return 0;
}	

# --------------------------------------------------------------
## @name ::raidv2_vol_start_scrub
## @summary starts scrub on the vol
## @description routine starts scrub on the specified volume
## and make sure it is started successfully. If the volume 
## is in DEGRADED state, then it should wait a little while
## @arg $vol specify the test volume to be scrub
## @return
##  1 -- PASSED - scrubbing is going
##  0 -- FAILED - unable to start scrub
##  2 -- NOOP - no need to run scrub 
# --------------------------------------------------------------
sub raidv2_vol_start_scrub($) {
    my $vol = $_[0];
    my $volr = "vol0";
    my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
    my $output; 

    if (! raidv2_vol_exist($vol)) {
        tstlog -comment, "** Volume <$vol> is no longer exist; No scrub will be started **";
        return $FAILED;
    }

    # ------------------------------------------------------------------
    # if the vol/aggr is in degraded mode then scrub will not be started
    # If it is DEGRADED then we should wait a litte bit.
    # ------------------------------------------------------------------
    my $cnt = 0;
    my $max_cnt = 100; 
    my $vol_in_degraded = 1; 
    while ($cnt++ < $max_cnt && $vol_in_degraded) {
	raidv2_info_group_load(); 
	my @groups = split(',', $raidv2_info_tree_group_list{$FILER_VOL});
	foreach my $vg (@groups) {
	    if ($raidv2_info_group_by_name{$vg}{fsm_state} =~ "DEGRADED") {
		tstlog (-comment,'vol <$vol> is in <$raidv2_info_group_by_name{$vg}{fsm_state}> state');
	    sleep(10); 
	    } else {
		$vol_in_degraded = 0; 
	    }
	}
    }
    
    if ($cnt > $max_cnt && $vol_in_degraded) {
	tstlog (-comment, "Unable to start scrub on <$vol> since it is in DEGRADED state"); 
	return $NOOP; 
    }    
    
    # ----------------------------------
    # Make sure scrubing will be started
    # ----------------------------------
    $cnt = 0; 
    while ($cnt++ < $max_cnt) {
        $output = saycmd_real($FILER, "priv -level -q diag; $cmd scrub start $vol", $RAIDV2_TIMEOUT);
        if ($output =~ /unable to start scrubbing/g) {
            sleep(20);
            next;
        }
        last;
    } #while

    $output = saycmd_real($FILER, "priv -level -q diag; $cmd scrub status $vol", $RAIDV2_TIMEOUT);
    if ($output =~ /no scrub running/) {
	tstlog -comment, "Unable to start scrubbing <$vol>"; 
	return $FAILED; 
    }

    tstlog -comment, "Successfully started scrub on <$vol>"; 
    return $PASSED;
} #raidv2_vol_start_scrub

# -----------------------------------------------------------------
## @name ::raidv2_vol_check_scrub_error
## @summary waits until scrub is completed and checks for scrub errors
## @description check for any media error, pi,and checksum error. 
## For non-simulator run, the routine should sleep a little bit longer
## @arg  specify the volume name
## @return 
##  1 -- PASSED - found no error
##  0 -- FAILED - found errors
##  2 -- NOOP - no need to run scrub if the flag is set
# ------------------------------------------------------------------
sub raidv2_vol_check_scrub_error($) {
    my $vol = $_[0];
    my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";#MTK_EDIT:24/09/08::added this line to work for both AGGR and VVOLS
    my $sleep_time = 120;

    if (raidv2_is_simulator()) {
          $sleep_time = 60;
    }# elsif LA {
    #      $sleep_time = 180; #MTK_EDIT:10/10/08::Not sure about the delay for LA. after testing we can make sure about this 
    #}

    # ---------------------------------------------------
    # wait until the scrub is complete on the test volume
    # ---------------------------------------------------
    while (1) {
	my $output = raidv2_saycmd($FILER, "priv set -q diag; $cmd scrub status $vol");
	sleep $sleep_time;

	if ($output =~ /no scrub running on $vol/ || $output =~ /suspended/) {
	    tstlog -comment, "Looks like scrub is completed on <$vol>"; 
	    last; 
	}
	if ($VERBOSE) {
	    tstlog -comment, "output string <$output>"; 
	}
	
	# if not simulator then we should sleep a bit longer
	if (raidv2_is_simulator()) {
	    sleep(5);
	} else { 
	    sleep(30); 
	}
    } # while

    # -----------------------------------------------
    # Looking for PI, media error, and checksum error
    # -----------------------------------------------
    raidv2_info_group_load();
    my @groups = split(',', $raidv2_info_tree_group_list{$vol});
    
    my $fail_cnt = 0; 
    foreach $group (@groups) {
	if ($raidv2_info_group_by_name{$group}{scrub_pi} != 0) {
	    tstlog -comment, "scrub ERROR found pi in <$group>";
	    $fail_cnt = $fail_cnt + 1; 
	} else {
	    tstlog -comment, "found NO PI error in group <$group>"; 
	}
	
	if ($raidv2_info_group_by_name{$group}{scrub_cksum_err} != 0) {
	    tstlog -comment, "scrub ERROR found checksum error in <$group>";
	    $fail_cnt = $fail_cnt + 1; 
	} else {
	    tstlog -comment, "found NO checksum error in group <$group>"; 
	}
    } #foreach 

    if ( $fail_cnt > 0 ) {
	return $FAILED; 
    }
    return $PASSED; 
} #raidv2_vol_check_scrub_error

# -----------------------------------------------------------
# @name ::raidv2_vol_scrub_verify
# @summary run scrub on the specified volume. Wait until the
# scrub is complete and then check for any errors.  
# Return failed if there is an error
# @arg:: 
# arg1 - volume name 
# @return::
#   PASSED 
#   FAILED
#   NOOP
# -----------------------------------------------------------
sub raidv2_vol_scrub_verify($) {
    my $vol = $_[0]; 
    my $status; 

    $status = raidv2_vol_start_scrub($vol); 

    if ($status == $FAILED) {
	tstlog -comment, "unable to start scrub on volume <$vol>"; 
	return $FAILED; 
    }

    # wait until scrubing is done then check for any type of errors
    $status = raidv2_vol_check_scrub_error($vol); 
    if ($status == $FAILED) {
	tstlog -comment, "Found scrub ERROR.";
	return $FAILED; 
    }

    return $status; 
} #raidv2_vol_scrub_verify

# Destroy volume
# Used by subs raidv2_destroy_volumes, destroy_temporary_volumes; not used in many scripts.
# See sub raidv2_remove_volume -- more error checking, used in more scripts.
sub raidv2_destroy_volume($) {
	my $volume = shift(@_);
	my($o);
	raidv2_info_vol_load($volume);
	if (!$raidv2_info_vol_by_name{$volume}) {
		return 1;
	}
	raidv2_stop_hammer($volume);
	# partial volumes are indicated as being online, but
	# apparently are not
	if ($raidv2_info_vol_by_name{$volume}{wafl_online}) {
		$o = saycmd_real($FILER, "vol offline $volume", $RAIDV2_TIMEOUT);
		if ($o =~ /is in progress/ || $o =~ /operation/) {
			#raidv2_wait_on_vol_zeroing($volume);
			# This is stupid - I can't offline it and I don't know
			# what disks are pending to it
			raidv2_wait_for_zeroing();
			$o = saycmd_real($FILER, "vol offline $volume", $RAIDV2_TIMEOUT);
		    } elsif ($o =~ /currently busy/) {
			tstlog -comment, "panicking because vol offline failed due to busy volume when itshould not have ";
			saycmd_real($FILER, "sysconfig -r; priv set -q diag; panic", $RAIDV2_TIMEOUT);
		    }
	    
#		if ($o !~ /now offline/ ) {   
#			tstlog -fatal, "could not offline volume: $o";
#		}


	    }
	
	# Destroy the volume.  Use the '-f' flag to avoid getting prompted
	# for confirmation.
	
	$o = saycmd_real($FILER, "vol destroy $volume -f", $RAIDV2_TIMEOUT);
	if ($o !~ /destroyed/ ) {
		return 0;
	}
	
	raidv2_info_vol_load($volume);
	if ($raidv2_info_vol_by_name{$volume}) {
		return 0;
	}
	
	return 1;
}
			  
# Destroy all volumes starting with prefix.  Only used by torture scripts.
sub raidv2_destroy_volumes($) {
	my $volume_prefix = $_[0];
	my $e; 
	raidv2_info_vol_load($volume_prefix);
	foreach $e (keys %raidv2_info_vol_by_name) {
		# xxx doesn't check that we start with it
		# just that it contains it 
		if ($e =~ /$volume_prefix/) {
			raidv2_destroy_volume($e);
		}

	}
}
# Look at the disks to make sure that we only have parity and data disks (no zeroing, etc).
sub raidv2_check_disk_status {
    my($d);
    #tstlog -comment, "ISAAC: Before: @_, #@_\n";
    #my(@disklist) = shift(@_);
    #tstlog -comment, "ISAAC: After: @disklist, #@disklist\n";
    my(@disklist) = (@_);
    foreach $d (@disklist) {
       my($type) = $raidv2_info_disk_by_name{$d}{parent_state};
       if ($d eq "") {
	   next;
       }
       tstlog -comment, "Disk $d type $type";
       if ($type =~ /PARITY/) {
	   next;
       }
       if ($type =~ /DATA/) {
	   next;
       }
       tstlog -fatal, "$FILER_VOL bad state $type for disk $d";
    }
}

# Returns list of disks by state type.
# Arg 1 is name of vol, plex, or group
# Arg 2 is DATA, PARITY, RECONSDATA, RECONSPARITY, etc.
sub raidv2_get_disks_by_type($$) {
    my(@ldisks) = ();
    my($type) = raidv2_get_type_by_name($_[0]);
    
    tstlog -comment, "Getting disks by type for:  $_[0], $_[1]";
    raidv2_info_disk_load();
    #tstlog -comment, "Hello, raidv2_get_disks_by_type  arg_0 $_[0]  arg_1 $_[1]";
    my(@disklist);
    
    if ($type == 2) {
    	@disklist = split(',', $raidv2_info_plex_disk_list{$_[0]});
    } elsif ($type == 3) {
    	@disklist = split(',', $raidv2_info_group_disk_list{$_[0]});
    } else {
	@disklist = split(',', $raidv2_info_tree_disk_list{$_[0]});
    }
    $parent_state = "parent_state";
    my @states;
    foreach my $e (@disklist) {
	#tstlog -comment, "$e has a parent_state of $raidv2_info_disk_by_name{$e}{$parent_state}"; 
	push @states, "$e has a parent_state of $raidv2_info_disk_by_name{$e}{$parent_state}"; 
	if ($raidv2_info_disk_by_name{$e}{parent_state} eq $_[1]) {
	    push @ldisks, $e;
	}
    }
    tstlog -comment, "The disk is @disklist";
    tstlog -comment, "Disks for $_[0]:", @states, scalar(@ldisks) . " disks of type $_[1].";

    return @ldisks;
}

sub raidv2_get_disks_by_state($$) {
    my(@ldisks) = ();
    my($type) = raidv2_get_type_by_name($_[0]);
    
    raidv2_info_disk_load();

    my(@disklist);
    if ($type == 2) {
    	@disklist = split(',', $raidv2_info_plex_disk_list{$_[0]});
    } elsif ($type == 3) {
    	@disklist = split(',', $raidv2_info_group_disk_list{$_[0]});
    } else {
	@disklist = split(',', $raidv2_info_tree_disk_list{$_[0]});
    }

    foreach my $e (@disklist) {
	if ($raidv2_info_disk_by_name{$e}{fsm_state} eq $_[1]) {
	    push @ldisks, $e;
	}
    }
    return @ldisks;
}

sub raidv2_get_disks_by_group($) {
    raidv2_info_disk_load();

    # get all the disks in a group
    my(@disklist) = ();
    @disklist = split(',', $raidv2_info_group_disk_list{$_[0]});
    if ($#disklist < 0) {
	tstlog -fatal,  "no disks in group named: $_[0]";
    }
    return @disklist;
}

sub raidv2_get_disks_by_group_type($$) {
    my(@ldisks) = ();
    raidv2_info_disk_load();
    raidv2_info_group_load();

    # get all the disks in a group
    my(@disklist) = ();
    @disklist = split(',', $raidv2_info_group_disk_list{$_[0]});
    if ($#disklist < 0) {
	tstlog -fatal,  "no disks in group named: $_[0]";
    }

    foreach my $e (@disklist) {
        if ($raidv2_info_disk_by_name{$e}{parent_state} eq $_[1]) {
            push @ldisks, $e;
        }
    }
   
    if ($#ldisks < 0) {
	tstlog -fatal,  "no disks in group named: $_[0], is a $_[1] disk\n";
    }
    return @ldisks;

}

sub raidv2_get_disks_by_plex_type($$) {
    my(@ldisks) = ();
    raidv2_info_disk_load();
    raidv2_info_plex_load();

    # get all the disks in a plex
    my(@disklist) = ();
    @disklist = split(',', $raidv2_info_plex_disk_list{$_[0]});
    if ($#disklist < 0) {
	tstlog -fatal,  "no disks in plex named: $_[0]";
    }

    foreach my $e (@disklist) {
        if ($raidv2_info_disk_by_name{$e}{parent_state} eq $_[1]) {
            push @ldisks, $e;
        }
    }
   
    if ($#ldisks < 0) {
	tstlog -fatal,  "no disks in plex named: $_[0], is a $_[1] disk\n";
    }
    return @ldisks;

}

sub raidv2_get_groups_by_state($$) {

    my(@lgroups) = ();
    
    raidv2_info_group_load();
    
    my(@grouplist) = split(',', $raidv2_info_tree_group_list{$_[0]});
    
    foreach my $e (@grouplist) {
	if ($raidv2_info_group_by_name{$e}{"fsm_state"} eq $_[1]) {
	    push @lgroups, $e;
	}
    }
    
    return @lgroups;
}

sub raidv2_get_groups_by_vol($) {
	my(@lgroups) = ();

	raidv2_info_group_load();
	@lgroups = split(',', $raidv2_info_tree_group_list{$_[0]});	
	return @lgroups;
}

sub raidv2_get_plexes_by_vol($) {
	my(@lplexes) = ();

	raidv2_info_plex_load();
	@lplexes = split(',', $raidv2_info_tree_plex_list{$_[0]});	
	return @lplexes;
}


#
# Hokey little routine that returns a type id based on the string name
# that we're provided
#
# Return 0 -- unknown
# Return 1 -- volume
# Return 2 -- plex
# Return 3 -- group
#
sub raidv2_get_type_by_name($) {
	#print "_ $_[0]\n";
	my(@list) = split /\//, $_[0];
	if ($list[0] eq "") {
		shift @list;
	}
	#print "list @list\n";
	return $#list + 1;
}
# --------------------------------------------------
## @name ::raidv2_shutdown
## @summary Perform shutdown, panic, halt, and others
## @description - based on the SHUTDOWN parameter, the script 
## shall invoke either shutdown, panic, or halt. 
## @arg $co - Required the console connection object
## @returns 0 -- FAILED
##          1 -- PASSED
## @status public 
# --------------------------------------------------
sub raidv2_shutdown($) {
    my $co = $_[0]; 

    if ($SHUTDOWN =~ /reboot/i) {
	if (reboot($co)) {
	    tstlog -comment, "Successfully rebooted the system"; 
	    return $PASSED; 
	}
	tstlog -fatal, "raidv2_shutdown: Failed to reboot the system";
        return $FAILED;
     }

    if ($SHUTDOWN =~ /panic/i) {
	my $panic_str = "panic"; #since panic will be deprecated soon 
	if (raidv2_is_simulator()) {
	    $panic_str = "panic -D"; 
	}

	# ---------------------------------------------------------
	# Tom Doan - "panic -D" must be under the 'priv set -q test'
	# or it could end up with a panic
	# ---------------------------------------------------------
#	my (undef, undef, $output) = say($co, "priv set -q test; $panic_str", "-noprompt"); 
#	if ($output =~ /PANIC: panic without core/g  || $output =~ /Wait...Filer will panic at the end of the next/g) {
#	    tstlog -comment, "Successfully panicked the system";
#	    return $PASSED;
#}
	
#MTKEDIT: Commented the above code and Modified the below code for success message
        my (undef, $before, $output) = say($co, "priv set -q test; $panic_str", "-noprompt","-wait", "START");
        if ($before =~ /PANIC: panic without core/g  || $before =~ /Wait...Filer will panic at the end of the next/g || $before =~ /PANIC: reboot -d panic without any arguments/g) {
            tstlog -comment, "Successfully panicked the system";
            return $PASSED;
        }

        # ------------------------------------------------------
	# Tom Doan -- we won't be able to match the result of 
	# panic on the real filer, let make it less sensitive
	# on matching the output here. 
	# ------------------------------------------------------
	tstlog -comment, "Unable to determine if <$SHUTDOWN> the system is success or not";
	return $PASSED; 
    }

    if ($SHUTDOWN =~ /halt/i) {
        if (halt($co)) {
            tstlog -comment, "Successfully halted the system";
            return $PASSED;
        }
        tstlog -fatal, "Failed to halt the system";
        return $FAILED;
    }

    # Any new shutdown command should go here
    tstlog -comment, "Unrecognized command <$SHUTDOWN>"; 
    return $FAILED; 
} #raidv2_shutdown

sub raidv2_read_error_inject($) { 
    my($mydisk) = shift(@_);
    raidv2_fiji_add_filter(fiji filter "(scope raidiotree (nil) tetrisio.event (&& (eq @type start_reads) ($mydisk)) (nil))  (raid.disk.read.done ($mydisk) (return (buf_Errno E_DISK_RECOMMEND_REASSIGN))) (raid.diskio.event (eq @type read_retry) (nil)) (raid.disk.read.done ($mydisk) (return (buf_Errno E_DISK_RECOMMEND_REASSIGN))) (raid.readerr.child.done ($mydisk) (return (raiderr_t EDISK_REASSIGN))))");
}

sub raidv2_fiji_fail($$) {
	my($condition) = shift(@_);
	my($mydisk) = shift(@_);
	raidv2_fiji_add_filter("( $condition ( eq \@disk $mydisk ) ( return ( buf_Errno E_DISK_FAILED ) ) )");
}

sub raidv2_fiji_fail_multi($$$) {
	my($slot) = shift(@_);
	my($condition) = shift(@_);
	my($mydisk) = shift(@_);
	raidv2_fiji_add_filter_multi($slot, "( $condition ( eq \@disk $mydisk ) ( return ( buf_Errno E_DISK_FAILED ) ) )");
}
 
sub raidv2_fiji_fail_by_disk_type($$$) {
	my($condition) = shift(@_);
	my($vol) = shift(@_);
	my($disk_type) = shift(@_);
	
	my(@disklist) = raidv2_get_disks_by_type($vol, $disk_type);
	if ($#disklist < 0) {
		tstlog -fatal, "no disks of type $disk_type";
	}
	raidv2_fiji_fail($condition, $disklist[0]);
	return $disklist[0];
}


sub raidv2_fiji_fail_by_disk_type_in_group($$$) {
	my($condition) = shift(@_);
	my($disk_type) = shift(@_);
	my($group) = shift(@_);
	my(@ldisks) = ();
	# raidv2_info_disk_load is done by the following
	# if get_disks_by_group is removed raidv2_info_disk_load
	# must be added above
	my(@disklist) = raidv2_get_disks_by_group($group);
	if ($#disklist < 0 ) {
	tstlog -fatal, "there were no disks in $group"; 
}
	foreach my $e (@disklist) {
		if ($raidv2_info_disk_by_name{$e}{"parent_state"} eq $disk_type) {
			push @ldisks, $e;
			tstlog -comment, "$e is of $disk_type type";
		}
	}
	
	if ($#ldisks < 0) {
		tstlog -fatal, "no disks of type $disk_type in group $group";
	}
	raidv2_fiji_fail($condition, $ldisks[0]);
	return $ldisks[0];
}


sub raidv2_fiji_fail_by_disk_type_in_group_multi($$$$) {
	my($slot) = shift(@_);
	my($condition) = shift(@_);
	my($disk_type) = shift(@_);
	my($group) = shift(@_);
	my(@ldisks) = ();
	# raidv2_info_disk_load is done by the following
	# if get_disks_by_group is removed raidv2_info_disk_load
	# must be added above
	my(@disklist) = raidv2_get_disks_by_group($group);
	if ($#disklist < 0 ) {
		tstlog -fatal, "there were no disks in $group"; 
	}
	foreach my $e (@disklist) {
		if ($raidv2_info_disk_by_name{$e}{"parent_state"} eq $disk_type) {
			push @ldisks, $e;
			tstlog -comment, "$e is of $disk_type type";
		}
    }
    
    if ($#ldisks < 0) {
	tstlog -fatal, "no disks of type $disk_type in group $group";
    }
    raidv2_fiji_fail_multi($slot, $condition, $ldisks[0]);
    return $ldisks[0];
}

# Add return value to check if scrub started or not ---Viv
sub raidv2_start_scrub($) {
	my $vol = $FILER_VOL;	
	if ($#_ == 0) {
		$vol = $_[0];
	}
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";  #added by skg for aggr support

	
	# Check if scrubing is started
       	my $output = saycmd_real($FILER, "priv -level -q diag; $cmd scrub start $vol", $RAIDV2_TIMEOUT);
       	if (!($output =~ /started scrub/g)) {
    		return 0;
	}
    	return 1;
} 

sub raidv2_scrub_status($) {
	my $vol = $FILER_VOL;
	if ($#_ == 0) {
                $vol = $_[0];
        }
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";  #added by skg for aggr support

	my $o = raidv2_saycmd($FILER, "priv set -q diag; $cmd scrub status $vol");
	if ($o =~ /no scrub running on $vol/ || $o =~ /suspended/) {
		return 0;
	} else {
		return 1;
	}
}

# modify to launch multiple hammers on a volume
sub raidv2_start_hammer {
	my($sim) = raidv2_is_simulator(); 
	my($iterations) = -1;
	my($filename) = "/vol/$FILER_VOL/testfile";
	if ($#_ > -1) {
		$filename = "/vol/$_[0]/testfile";
	} 
	my($blocksinfile) = 1000000;
	if ($sim) {
		$blocksinfile = 1000;
	} 
	
	my($o) = saycmd_real($FILER, "priv -level -q diag; hammer -f $iterations $filename $blocksinfile", $RAIDV2_TIMEOUT);
}

# -----------------------------------------------
## @name ::raidv2_start_multiple_hammers
## @summary starts 3 different hammers on the specified vol
## @description the routine will start multiple hammers 
## on the specified volume. One hammer is going to run
## until abort the other will run for a finite number. 
## 
## @arg - name of the volume (optional)
## @return none
# -----------------------------------------------
sub raidv2_start_multiple_hammers {
    my($iteration1) = -1;
    my($iteration2) = 10000;
    my($iteration3) = 1000;
    my($filename1) = "/vol/$FILER_VOL/hammer1";
    my($filename2) = "/vol/$FILER_VOL/hammer2";
    my($filename3) = "/vol/$FILER_VOL/hammer3";
    if ($#_ > -1) {
	$filename1 = "/vol/$_[0]/hammer1";
	$filename2 = "/vol/$_[0]/hammer2";
	$filename3 = "/vol/$_[0]/hammer3";
    } 
    
    my($blocksinfile1) = 100;
    my($blocksinfile2) = 10000;
    my($blocksinfile3) = 1000000;

    if (raidv2_is_simulator()) {
	$blocksinfile1 = 10;
	$blocksinfile2 = 100;
	$blocksinfile3 = 1000;
    }
    
    my($o) = saycmd_real($FILER, "priv -level -q diag; hammer -f $iteration1 $filename1 $blocksinfile1", $RAIDV2_TIMEOUT);
    $o = saycmd_real($FILER, "priv -level -q diag; hammer -f $iteration2 $filename2 $blocksinfile2", $RAIDV2_TIMEOUT);
    $o = saycmd_real($FILER, "priv -level -q diag; hammer -f $iteration3 $filename3 $blocksinfile3", $RAIDV2_TIMEOUT);
} #raidv2_start_multiple_hammers

sub raidv2_stop_hammer {
    my($hammer_status) = "foo";
    my($wait_interval) = 3;
    my($time_waited) = 0;
    my($max_wait) = 1800; # wait 30 minutes for hammer to abort
    #my($o) = saycmd_real($FILER, "priv -level -q diag; hammer abort", $RAIDV2_TIMEOUT);
    my $o = filer_cmd(host => host($FILER), cmd =>"priv -level -q diag; hammer abort", timeout=> $RAIDV2_TIMEOUT);

    # don't wait 30 min if in partner mode
    while (($hammer_status ne "" && $hammer_status !~ /Cannot run hammer in partner mode./) && $time_waited < $max_wait) {
        #$hammer_status = saycmd_real($FILER, "priv -level -q diag; hammer status", $RAIDV2_TIMEOUT);
	$hammer_status = filer_cmd(host => host($FILER), cmd =>"priv -level -q diag; hammer status", timeout=> $RAIDV2_TIMEOUT);
        $time_waited += $wait_interval;
	sleep $wait_interval;
    }
    tstlog -comment, "waited $time_waited seconds for hammer to abort";
}

# -----------------------------------------------
## @name ::raidv2_status_hammer
## @summary checks the current status of hammer. 
## 
## @description the function invokes the command
## hammer status to verify if the hammer is running
## or not. It returns 1 if hammer is going. 
## 
## @arg None
## @return 
##  1 - if hammer is going
##  0 - if there is no hammer
# -----------------------------------------------
sub raidv2_status_hammer {
    my $status = saycmd_real($FILER, "priv -level -q diag; hammer status", $RAIDV2_TIMEOUT);
    if ($status =~ /blacksmith/) {
	tstlog -comment, "Hammer is started"; 
	return 1; #hammer is running
    }
    tstlog -comment, "Hammer is not running"; 
    return 0; # hammer is not going
} #raidv2_status_hammer 

#sub raidv2_stop_hammer {
#	my($hammer_status) = "foo";
#	my($wait_interval) = 3;
#	my($time_waited) = 0;
#	my($max_wait) = 180;
#	my($o) = "foo";
#	my($volume) = $FILER_VOL;
#	if ($#_ == 0) {
#		$volume = $_[0];
#	}
#	while ($o ne "" && $time_waited < $max_wait) {
#		$o = saycmd_real($FILER, "priv -level -q diag; hammer abort $volume", $RAIDV2_TIMEOUT);
#		$time_waited += $wait_interval;
#		sleep $wait_interval;		
#	}
#	$time_waited = 0;
#	while ($hammer_status ne "" && $time_waited < $max_wait) {
#		$hammer_status = saycmd($FILER, "priv -level -q diag; hammer status $volume");
#		$time_waited += $wait_interval;
#		sleep $wait_interval;
#	}
#	tstlog -comment, "waited $time_waited for hammer to abort";

#}

sub raidv2_reinitialize_test {
	my($cmd) = ($AGGR|$VVOLS) ? "aggr" : "vol";
	logcomment("Reinitializing test...");
	raidv2_disk_simpush_all();
	raidv2_disk_online_all(); 
	logcomment("TWO");
	raidv2_stop_hammer();
	logcomment("THREE");
	tstlog -comment, "calling unfail disks";
#        raidv2_saycmd($FILER, "priv set -q diag; spares_zero");
        filer_cmd(host=>host($FILER), cmd => "priv set -q diag; disk zero spares");
#       XXX temporary - in case this is causing raid_config to hang
	sleep 30;
	# need to push back all pulled disks
	raidv2_unfail_disks();
	if($VOL_REUSE){
	    tstlog -comment, "VOL REUSE is set. Reinitialization will be skipped.";
	    return 1;
	}
        #saycmd_real($FILER, "$cmd verify stop $FILER_VOL", $RAIDV2_TIMEOUT);
	filer_cmd(host => host($FILER), cmd =>"$cmd verify stop $FILER_VOL", timeout=> $RAIDV2_TIMEOUT);
        raidv2_info_vol_load();
	foreach my $e (keys %raidv2_info_vol_by_name) {
		if ($e =~ $FILER_VOL) {
			raidv2_remove_volume($e);
		}
	}


#       this limits concurrency - wait for zeroing on a per volume basis
#	raidv2_wait_for_zeroing();
#       this resets all filters - obviously limits concurrency
#	saycmd($FILER, "priv -level -q test; fiji clear");

	raidv2_info_disk_load();

	# Add for work around burt146242  ---Viv
	foreach my $f (keys %raidv2_info_tree_disk_list) {
		if ($f =~ $FILER_VOL) {
			my $tmpAGGR=$AGGR;
			$AGGR=(raidv2_is_aggr($f))?1:0;
			raidv2_remove_volume($f);
			$AGGR=$tmpAGGR;
		}
	}

	#if ($TORTURE  == 0) {
		#raidv2_fiji_clear_all();
	#}
#      This might be causing timeouts 
#	saycmd_real($FILER, "priv -level -q test; setral raidrm 5 5", $RAIDV2_TIMEOUT);
#	if ($TORTURE ne "1") { 
		saycmd_real($FILER, "priv set -q diag; ps -z; fiji clear all", $RAIDV2_TIMEOUT);
#	}
	saycmd_real($FILER, "priv set -q diag; disk zero spares", $RAIDV2_TIMEOUT);

	logcomment("Done reinitializing test.");
}

sub raidv2_disable_checksums($) {
	saycmd_real($FILER, "vol options $_[0] raid_zoned off", $RAIDV2_TIMEOUT);
}

## @name ::raidv2_unfail_disks
## @summary Unfail all failed disks
## @description
## raidv2_unfail disks unfails all failed disks.
## The function determines the failed disks in the system
## and uses the disk unfail command (-s option needed for OnTap releases GB.0
## and beyond) to unfail the disks. It checks to see if the unfailed disk has become a spare.
## @arg none
## @status public
##
sub raidv2_unfail_disks() {
	logcomment("Unfailing disks...");
        raidv2_info_disk_load();
        my(@broken_disks) = split(",", $raidv2_info_tree_disk_list{"POOL:broken"});
        tstlog -comment, "there are " . scalar(@broken_disks) . " broken disks.";
        foreach $disk (@broken_disks) {
                #my $output = saycmd_real($FILER, "priv -level -q advanced; disk unfail -s $disk", $RAIDV2_TIMEOUT);
                my $output = filer_cmd(host => host($FILER), cmd =>"priv -level -q advanced; disk unfail -s $disk", timeout=> $RAIDV2_TIMEOUT);

                if($output =~ /usage/) {
                        #saycmd_real($FILER, "priv -level -q advanced; disk unfail $disk", $RAIDV2_TIMEOUT);
                        filer_cmd(host => host($FILER), cmd =>"priv -level -q advanced; disk unfail $disk", timeout=> $RAIDV2_TIMEOUT);
		}
		sleep 5;
		# replace spares get/compare loop, reduce log output:  
		# just check status of failed instead of loading all to get new spares list
		raidv2_info_disk_load($disk);
		if ($raidv2_info_disk_by_name{$disk}{fsm_state} ne "FAILED" &&
		    $raidv2_info_disk_by_name{$disk}{spare} eq "1") {
			logcomment("Disk $disk successfully unfailed.");
		} else {
			logcomment("Disk $disk could not be unfailed.");
		}
        }
}

sub raidv2_log($) {
	tstlog -comment, "$_[0]";
}

sub raidv2_wait_on_diskfail($) {
	my($sleep_count) = 0;
	while ($sleep_count < 30 && ($raidv2_info_disk_by_name{$_[0]}{fsm_state} ne "FAILED")) {
		raidv2_info_disk_load();
		$sleep_count += 2;
		sleep 2;
	}

	if ($raidv2_info_disk_by_name{$_[0]}{fsm_state} ne "FAILED") {
	    raidv2_saycmd($FILER, "sysconfig -r");
	    tstlog -fatal, "$_[0] did not get failed";
	}
}

sub raidv2_wait_on_reconstruct($) {
	my($sleep_count) = 0;
	my($found) = 0;
	my(@disks);
	while ($sleep_count < 30) {
		@disks = raidv2_get_disks_by_type($_[0], "RECONS");
		if ($disks[0] ne "") {
			return $disks[0];
		}
		$sleep_count += 1;
		sleep 1;
	}
	return "";
}

sub raidv2_wait_on_reconstruct_type($$) {
	my($sleep_count) = 0;
	my($found) = 0;
	my(@disks);
	while ($sleep_count < 150) {
	raidv2_saycmd($FILER, "sysconfig -r");	
		@disks = raidv2_get_disks_by_type($_[0], $_[1]);
		if ($disks[0] ne "") {
			return $disks[0];
		}
		$sleep_count += 5;
		sleep 5;
	}
	return "";
}

sub raidv2_wait_on_reconstruct_replace($$) {
	my($sleep_count) = 0;
	my($found) = 0;
	my($disk) = $_[1];
	my(@disks) ;
	$disks[0] = $_[1];
	while ($sleep_count < 30 && $disk eq $disks[0]) {
		@disks = raidv2_get_disks_by_type($_[0], "RECONS");
		if ($disk ne $disks[0]) {
			return $disk;
		} 
		$sleep_count += 2;
		sleep 2;
	}
}
# ------------------------------------------------------------------------------
## @name ::raidv2_wait_on_reconstruct_start
## @description 
## Wait for reconstruction to start after onlining a disk.
## Don't fatal out here if fails to start within wait time, since may be used 
## by reboot tests that need to halt first.
## @arg disk 		required	the offlined/onlined disk
## @arg wait_time	optional	wait time in seconds
## @arg optimized	optional	1 to check for optimized RECONS
## @return 1 for started, 0 for failed to start
# ------------------------------------------------------------------------------
sub raidv2_wait_on_reconstruct_start($;$$) {
	my ($disk, $wait_time, $optimized) = @_;
	if (!defined $wait_time) {$wait_time = 60};
	if (!defined $optimized) {$optimized = 0};
	my $return_code = 0;

	# scripts do start messages with their own formats, e.g. "Step:..."
	# another start msg here in case multiple disks for recon, e.g. with mirroring
	logcomment("Wait for reconstruction to start with disk $disk.");
	raidv2_info_disk_load($disk);
	my $disk_parent_id = $raidv2_info_disk_by_name{$disk}{parent_id};
	my $group_status = "";
	my $recons_wait;

	# Reconstruction may happen too fast on sim or minidisk
	# Could extend by using before offlining:
	#	raidv2_saycmd($FILER, "priv set -q diag; setflag wafl_hot_disk_avoidance_interval -1");
	# keeps generating I/O for the offline disk in buffer file so that recons would take longer?
	# But try to avoid sim/minidisk/filer differences, can just check for normal status after recons 
	for ($recons_wait = 0; 
	     ($group_status ne "RECONS" && $group_status ne "NORMAL") && $recons_wait < $wait_time;
	     $recons_wait++ ) {
		sleep 1;
		raidv2_info_group_load();
		$group_status = $raidv2_info_group_by_id{$disk_parent_id}{fsm_state};
	}
	if ($group_status eq "RECONS") {
		logcomment("Reconstruction has started");
		$return_code = 1;
		if ($optimized == 1) {
			# check in case just starting
			if ($raidv2_info_disk_by_name{$disk}{optimized_recons} != 1) {
				raidv2_info_disk_load($disk);
			}
			if ($raidv2_info_disk_by_name{$disk}{optimized_recons} == 1) {
				logcomment("Optimized reconstruction occurring here.");
			}
			elsif ($raidv2_info_disk_by_name{$disk}{fsm_state} eq "INUSE") {
				logcomment("Status is INUSE, assume optimized reconstruction occurred.");
			}
			else {
				logcomment("Optimized reconstruction should occur here.");
				$return_code = 0;
			}
		}
	}
	elsif ($group_status eq "NORMAL") {
		logcomment("Status is NORMAL, assume reconstruction already occurred.");
		$return_code = 1;
	}
	else {
		logcomment("Reconstruction did not start in $wait_time seconds; status: $group_status");
	}
	return $return_code;
}

# -----------------------------------------------------------
# @name ::raidv2_wait_on_reconstruct_complete
# @summary wait for reconstruct start and then complete 
# Fatal if reconstruct failed to start and complete within the 
# specified amount of time in seconds. 
# Uses $DISK_OFFLINE_TYPE to check for right recons state.
# @arg:: 
# arg1 - vol 
# arg2 - specify the offline disk
# arg3 - 1 -- if check for optimized RECONS
# -----------------------------------------------------------
sub raidv2_wait_on_reconstruct_complete($$$) {
    my ($vol) = $_[0]; 
    my ($offline_disk) = $_[1];
    my ($check_optimize) = $_[2]; 

    my $found_recons = 0;
    my $wait_cnts = 0; 
    my $sleep_time = 0; 
    #my $lookup_state = "RECONSDATA"; 
    #my $lookup_state = "RECONS"; 

    # Check frequently as possible 
    if (raidv2_is_simulator()) {
	# RAIDANT Sun sims are quick -- 5 sec, 
	# but Sanity Checker (Linux) sim test env. can take > 60 sleep secs
	$wait_cnts = 30; 
	$sleep_time = 5; 
    } else {
	$wait_cnts = 15000; 
	$sleep_time = 250; 
    }
    
    if ($VERBOSE) {
	raidv2_saycmd($FILER, "sysconfig -r"); 
    }

    # -------------------------
    # check for RECONS to start
    # -------------------------
    my $i = 0;
    for ($i=0; $i< $wait_cnts && $found_recons == 0; $i++) {
	# Check for double reconstruct:  avoids use of reconstruct finish on one disk
	# to assume reconstruct finish for the group
	raidv2_info_group_load(); 
	#raidv2_info_disk_load($offline_disk); 	
	# raidv2_info_disk_load() called in raidv2_get_disks_by_type(...) below
	my @recons_disks = raidv2_get_disks_by_type($vol, 'RECONS'.$DISK_OFFLINE_TYPE);

	if ($#recons_disks gt 0) {
	    tstlog -comment, "Double reconstruct have occurred with <@recons_disks>";
	}

	if ($VERBOSE) {
	    raidv2_saycmd($FILER, "sysconfig -r"); 
	    tstlog -comment, "recons_disks: <@recons_disks>"; 
	    raidv2_info_group_load(); 
	}

	if ($recons_disks[0] eq $offline_disk) {
	    $found_recons = 1;  
	    last;
	} 
	tstlog -comment, "Wait for RECONS in <$sleep_time> seconds"; 

	# Some time the recons process happens so quickly we just
	# need to check if the offline disk is online then just exit
	if ($raidv2_info_disk_by_name{$offline_disk}{fsm_state} eq "INUSE") {
	    tstlog -comment, "disk <$offline_disk> is back on line very quickly"; 
	    return $PASSED;
	}
	sleep $sleep_time; 
    } #for
    
    if ($found_recons == 0) {
        my $tot_sleep = $i * $sleep_time; 
	raidv2_cleanup_test ("-fatal", "RECONS has not started on <$offline_disk> after <$tot_sleep> seconds", 1); 
    }
    tstlog -comment, "Reconstruction started on <$offline_disk> in <" . ($i * $sleep_time) . "> seconds"; 

    # -------------------------------
    # Verify optimized reconstruction
    # -------------------------------
    if ($check_optimize == 1) {
	# !!! loading disk info here could potentially fail the test!!!!
	#raidv2_info_disk_load(); 
	if ($raidv2_info_disk_by_name{$offline_disk}{optimized_recons} == 1) {
	    tstlog -comment, "Disk <$offline_disk> is in optimized reconstruction"; 
	} else {
	    raidv2_cleanup_test("-fatal", "Disk <$offline_disk> is in full reconstruction", 1); 
	}
    }

    # ----------------------------    
    # check for RECONS to complete
    # ----------------------------
    for ($i=0; $i< $wait_cnts && $found_recons == 1; $i++) {
	my @recons_disks = raidv2_get_disks_by_type($vol, 'RECONS' . $DISK_OFFLINE_TYPE);
	if ($recons_disks[0] eq "") {
	    $found_recons = 0;  
	    last;
	}
	tstlog -comment, "Wait for RECONS in <$sleep_time> seconds..sleep time is $sleep_time wait_cnts is $wait_cnts"; 
	sleep $sleep_time; 
	raidv2_saycmd($FILER, "sysconfig -r"); 
    } #for
    
    if ($found_recons == 0) {
	logcomment("Reconstruction of <$offline_disk> completed in <" . ($i * $sleep_time) . "> seconds"); 
    } else {
	logcomment("Reconstruction of <$offline_disk> has not completed in <" . ($i * $sleep_time) . "> seconds"); 
	raidv2_saycmd($FILER, "sysconfig -r"); 
	# 0 = can't remove vol, since busy on recons, can't offline, but 
	# 1 = raidv2_cleanup_test uses raidv2_remove_vol which now waits for recons w/o calling this sub again
	raidv2_cleanup_test("-fatal", "RECONS has not completed.", 1);  
    }
    
} #raidv2_wait_on_reconstruct_complete

# ----------------------------------------------------
# Modified by Tom Doan 10/10/05. This function does not
# work since it assumed the disk name and filename are
# the same. For example, the disk name v4.28 has a 
# quite different filename such as "v0.28:NETAPP..." under
# ,disks/,pulled subdirectory. 
#
# One solution for this is to use part of the disk name
# and its size to match the filename. 
# 
# FILER=sanity-simXX;simhost=sanityXX
#
# EX: v1.24:NETAPP__:VD-50MB-520_____:96304607:158848
# the routine will match look for a disk name
# of 24: and the size of :158848
# 
# ----------------------------------------------------
sub raidv2_get_pulled_disk_full_name($) {
#    my(@list) = glob(",disks/,pulled/$_[0]\:*");
#    my(@name) = split("/", $list[0]);
 
    my $disk_alb = ":" . $raidv2_info_disk_by_name{$_[0]}{avl_blks}; 
    my @buf = split(/\./, $_[0]);  
    my $disk_name = $buf[1] . ":"; 
    my @list; 

    param("FILER", '-mesg', '...'); 
    my $h = host($FILER); 
    param("FILER_SIMDIR", '-default', $h->simdir()); 

    @list = glob("$FILER_SIMDIR/,disks/,pulled/*:*"); 
    my (@name, @names);
    foreach my $e (@list) {
	if ($e =~ /$disk_name/ && $e =~ /$disk_alb/) {
	    my @sel_disk = split("/", $e); 
	    tstlog -comment, "found a match $sel_disk[$#sel_disk]";
	    return $sel_disk[$#sel_disk]; 
	}
    } #foreach

    tstlog -fatal, "Unable to find a filename that matches the specified disk name: <$_[0]>"; 
    return "";
} #raidv2_get_pulled_disk_full_name 

# Return names of sim pulled disks
sub raidv2_get_pulled_disk_names() {
    my(@list) = glob("$FILER_SIMDIR/,disks/,pulled/*:*");
    my (@name, @names, $e);
    foreach $e (@list) {
	    tstlog -comment, "saw $e";
	    $e =~ s/.*\/(.*):NETAPP.*/$1/;
	    push @names, $e;
    }
    return @names;
}

# this can currently only push one disk - probably want to fix eventually
sub raidv2_disk_simpush($) {    
	#MTK_EDIT 07102008: Temporarily hard-coding pulled disks path till the time vsim console connection problem resolves.
	my $h = host($FILER);
	my $filertype = $h->hosttype();
	my $diskname;
	my $vendor = $raidv2_info_disk_by_name{$_[0]}{vendor};
	my $model = $raidv2_info_disk_by_name{$_[0]}{model};
	$vendor =~ s/\s/_/g;
	$model =~ s/\s/_/g;
	if ($filertype =~ /vsim/i) {
           $diskname = $raidv2_info_disk_by_name{$_[0]}{path_name2} . ':' . $vendor . ':' . $model . ':' . $raidv2_info_disk_by_name{$_[0]}{serialno} . ':' . $raidv2_info_disk_by_name{$_[0]}{avl_blks};
	} else {
	   $diskname = raidv2_get_pulled_disk_full_name($_[0]);
	}
	#MTK_EDIT: END
    	my($o) = saycmd_real($FILER, "disk simpush $diskname", $RAIDV2_TIMEOUT);
	if ($o eq "" ) {
		return 1;
	}
	return 0;
}
			
sub raidv2_disk_simpull($) {
	my($attrs) = $_[0];
	if (raidv2_saycmd($FILER, "disk simpull $attrs") eq "") {
		return 1;
	} else {
		return 0;
	} 
}

			
sub raidv2_disk_simpush_all() {
	# -----------------------------------------
	# 06/04/27 Tom Doan 
	# skip simpush if this is NOT for simulator
	# -----------------------------------------

	if (!raidv2_is_simulator()) {
		# C Schulz 4/08:  don't need warnings from raidv2_reinitialize_test().
		#tstlog("-warn", "Not simulator, no disk simpush all.");
		return; 
	}
	my(@list) = raidv2_get_pulled_disk_names();
	if (scalar(@list) > 0) {
		logcomment("Pushing pulled disks:  @list");
		raidv2_saycmd($FILER, "disk simpush all ");
	}
}

sub raidv2_is_simulator() {
	#my($o) = saycmd_real($FILER, "version -v");	# always show compile flags, incl. promoted builds 	#MTK_EDIT 06042008: Commented
	#if ($o =~ "<td>" || $o =~ "<Ld>" || $o =~ "<od>" || $o =~ "<Rd>" || $o =~ "<Pd>" || $o =~ "<tdc>"){
	# include non-debug builds, e.g. <t>
	# sims:  t = Sun, L = Linux, R = FreeBSD, o = UNIX/Alpha (obsolete), P = Linux w. NGPT (obsolete)
	#if ($o =~ /<.*[tLRoP].*>/) {	#MTK_EDIT 06042008: Commented
	#MTK_EDIT 06042008: Added the following lines to find simulator

        my $h = host($FILER);
	my $filertype = $h->hosttype();
	if ($filertype =~ /sim/i) {
		return 1;
	} elsif ($filertype =~ s/^\s+$//g) {
		my($o) = saycmd_real($FILER, "sysconfig -a");  #Always show Model Name, which helps to identify type.
		if ($o =~ /Model\sName.+(?i)sim/) {
			return 1;
		}
	}	 
	#MTK_EDIT: END
	return 0;
}

sub raidv2_wait_on_vol_zeroing($) {    
	my(@disklist);
#	raidv2_log("wait_on_vol_zeroing called for $_[0]");
	my($count) = 1;
	while ($count > 0) {
		raidv2_info_disk_load();
		@disklist = split(',', $raidv2_info_tree_disk_list{$_[0]});
		$count = 0;
		tstlog "-comment", "disklist is: @disklist \n";
		foreach $disk (@disklist) {
			raidv2_info_disk_load($disk);
			if ($raidv2_info_disk_by_name{$disk}{fsm_state} eq "ZEROING" || $raidv2_info_disk_by_name{$disk}{fsm_state} eq "NOTZEROED") {
				 raidv2_log("state=$raidv2_info_disk_by_name{$disk}{fsm_state}");
				$count++;
			}
		}
		raidv2_log("waiting for $count disks to zero");
		sleep (4*$count);
	}
}

# ------------------------------------------------------------------
# Oct 31 - Tom Doan - modify the function to select only ZEROED
# and ZEROING disks. Especially, I have seen disk in the 'UNFAILING'
# state for while
# ------------------------------------------------------------------
sub raidv2_resort_disks_reversed($) {
	raidv2_info_disk_load();
	my(@disklist) =  split(",", $raidv2_info_tree_disk_list{$_[0]});
	my(@zerodisks) = ();
	my(@freedisks) = ();
	foreach $disk (@disklist) {
	    if ($raidv2_info_disk_by_name{$disk}{fsm_state} !~ /ZEROING/ && $raidv2_info_disk_by_name{$disk}{fsm_state} !~ /ZEROED/) { 
		next;
	    }
	    raidv2_log("$disk is in \@disklist");
	    if ($raidv2_info_disk_by_name{$disk}{fsm_state} =~ /ZEROING/) {
		raidv2_log("$disk is zeroing");
		push @zerodisks, $disk;
	    } else {
		push @freedisks, $disk;
	    }
	}
	foreach $disk (@freedisks) {
	    push @zerodisks, $disk;
	}
	return @zerodisks;

}

sub raidv2_resort_disks {
	my(@disklist) =  shift(@_);
	raidv2_info_disk_load();
	foreach $disk (@disklist) {
		if ($raidv2_info_disk_by_name{$disk}{fsm_state} =~ /ZEROING/) {
			push @zerodisks, $disk;
		} else {
			push @freedisks, $disk;
			
		}
	}
	foreach $disk (@zerodisks) {
		push @freedisks, $disk;
	}
	
	return @freedisks;
}

## @name ::raidv2_disk_offline
## @summary Offline the specified disk 
## @description
## raidv2_disk_offline takes the specified disk offline.
## This function validates the specified argument before
## issuing a disk offline command. If the argument is blank
## it returns a fail status=0.   
## This function returns a successful status=1 if the return
## message has "successfully offlined". 
## @arg $disk_name Required a valid disk name
## @returns 0 -- failed; 1 -- success
## @status public 
##
sub raidv2_disk_offline($) {
	my($disk_name) = $_[0];
	
	if ($disk_name =~ /^\s*$/) {
            tstlog -comment, "raidv2_disk_offline: Invalid disk name.\n";
            return 0; 
        }

	# enable disk offline for raid4
	#
# Remove the obsolete disk offline options: TD 08/23/05
#	raidv2_saycmd($FILER, "priv set -q diag; options raid.disk.offline.raid4.enable on"); 
#	raidv2_saycmd($FILER, "priv set -q diag; options raid.disk.offline.enable on"); 
	raidv2_saycmd($FILER, "priv set -q diag; setflag raid_disk_offline_relaxed 1"); 
	my($o) = raidv2_saycmd($FILER, "priv set -q diag; disk offline $disk_name");
	
        # Return a successful status
	if ($o =~ "successfully offlined") {
	  tstlog -comment, "raidv2_disk_offline: successfully offlined disk: <$disk_name>\n"; 
	  return 1; 
	}
		       
	# --------------------------
	# Added 7/21/2004 TomDoan --
	# Output the sysconfig for debugging
	raidv2_saycmd($FILER, "sysconfig -r");

	# Return failed if the specified disk cannot be offline
	tstlog -comment, "raidv2_disk_offline: failed to offline disk: <$disk_name>\n"; 
	return 0;
} #raidv2_disk_offline


## @name ::raidv2_disk_online
## @summary Online the specified disk 
## @description
## raidv2_disk_online takes the specified disk online.
## This function validates the disk_name argument before
## issuing a disk online command. If the argument is blank
## it returns a fail status=0.   
## This function returns a successful status=1 if the return
## message has "successfully offlined". 
## @arg $disk_name Required a valid disk name
## @returns 0 -- failed; 1 -- success
## @status public 
##
sub raidv2_disk_online($) {
	my($disk_name) = $_[0];
	
	if ($disk_name =~ /^ *$/) {
            tstlog -comment, "raidv2_disk_online: Invalid disk name.\n";
        }

        my $o = filer_cmd(host => host($FILER), cmd =>"priv set -q diag; disk online $disk_name");
	
        # return a successful status
	if ($o =~ "successfully onlined") {
	  tstlog -comment, "raidv2_disk_online: successfully onlined disk: <$disk_name>\n"; 
	  return 1;
	}

        # return failed if the specified disk cannot be online
	tstlog -comment, "raidv2_disk_online: failed to online disk: <$disk_name>\n"; 
	return 0;
} #raidv2_disk_online

## @name ::raidv2_disk_online_all
## @summary online all offline disks
##
## @description
## raidv2_disk_online_all utilizes the hash table 
## %raidv2_info_fsm_disk_list to search for all
## offline disk then turn them online one by one. 
## Calling function raidv2_disk_online to carry
## out the online action. 
## This function returns a successful status=1 if 
## the return message has "successfully offlined". 
## @arg -- NONE
## @returns 0 -- failed; 1 -- success
## @status public 
##
sub raidv2_disk_online_all() {
    my $disk_state = "OFFLINE"; 
    
    raidv2_info_disk_load();
    @disks = split(",", $raidv2_info_fsm_disk_list{$disk_state}); 

    # --------------------------
    # Done if the list is empty
    # --------------------------
    if ($#disks < 0) {
	tstlog -comment, "There is no offline disk.";
	return 1; 
    }
	
    my $disk_count = $#disks +1; 
    for (my $i =0; $i< $disk_count; $i++) {
	if (!raidv2_disk_online($disks[$i])) {
	    tstlog -comment, "Unable to online disk <$disk[$i]>";
	}
    } 
    return 1; 
} #raidv2_disk_online_all

# ---------------------------------------------------------
## @name ::raidv2_cleanup_test 
## @summary remove the test vol, stop hammers, zero all 
## disks, and clean up all test objects. 
## @description remove the test vol, stop hammers,
## destroy the test volume if specified, online all disks, 
## and zero all disks. 
##
## @arg
## arg1 - one of the specified status: ("-fatal", "-comment",
##        "-info", "-config", "-warning", and "-na") 
## arg2 - the message string
## arg3 - 1 -- remove vol; 0 -- do not remove volume
## @returns 1 -- success
# ----------------------------------------------------------
sub raidv2_cleanup_test($$$) {
    my ($status, $message, $rmvol) = @_; 

    raidv2_stop_hammer();
    if ($rmvol) {
	raidv2_remove_volume($FILER_VOL); 
    }

    raidv2_disk_online_all(); 
    raidv2_unfail_disks(); 
    raidv2_saycmd($FILER, "priv set -q diag; disk zero spares");    
    
    #skip waiting for now 
    #raidv2_wait_for_zeroing();

    tstlog $status, $message; 
    return 1;
}#raidv2_cleanup_test

# ---------------------------------------------------------
## @name ::raidv2_cleanup_halt 
## 
## @description remove the test vol, stop hammers,
## destroy the test volume if specified, online all disks, 
## zero all disks, and halt the system if run on simulator. 
##
## @summary remove the test vol, stop hammers, zero all 
## disks, and clean up all test objects. 
## 
## @arg
## arg1 - one of the specified status: ("-fatal", "-comment",
##        "-info", "-config", "-warning", and "-na") 
## arg2 - the message string
## arg3 - 1 -- remove vol; 0 -- do not remove volume
## arg4 - optional -- console connection object
## @returns 1 -- success
# ----------------------------------------------------------
sub raidv2_cleanup_halt($$$$) {
    my ($status, $message, $rmvol, $co) = @_; 

    raidv2_stop_hammer();
    if ($rmvol) {
	raidv2_remove_volume($FILER_VOL); 
    }

    raidv2_disk_online_all(); 
    raidv2_unfail_disks(); 
    raidv2_saycmd($FILER, "priv set -q diag; disk zero spares");    
    
    #skip waiting for now 
    #raidv2_wait_for_zeroing();

    # -----------------------------------------------------    
    # For a reboot test, must halt the simulator before exit
    # otherwise it ends up with a core dump. 
    # -----------------------------------------------------
    if ($SHUTDOWN =~ /reboot/i || $SHUTDOWN =~ /panic/i || $SHUTDOWN =~ /halt/i ) {
	if (raidv2_is_simulator()) {
	    halt($co); 
	}
    }
    
    tstlog $status, $message; 
    return 1;
}#raidv2_cleanup_halt

# ---------------------------------------------------------
## @name ::raidv2_ata_verify_spasm 
## @description Verifies ata spasm by injecting error,
## waiting for offline, online, reconstruction.
## @arg vol 		required	volume
## @arg offline_disk	optional	disk to spasm
## @arg errorsRef	optional	array ref to errors to inject
## @return 		Not defined
# ----------------------------------------------------------
sub raidv2_ata_verify_spasm($$$) {

	my($vol, $offline_disk, $errorsRef) = @_;
	@errors_to_be_injected = @$errorsRef;

	tstlog -comment, "\$vol = $vol";
	tstlog -comment, "\$offline_disk = $offline_disk";
	tstlog -comment, "\@errors =", @errors_to_be_injected;

	# -------------------------------------------------------------
	# Get the group name of the disk to be offlined
	# -------------------------------------------------------------
	my $offline_disk_group_id = $raidv2_info_disk_by_name{$offline_disk}{parent_id};
	my $offline_disk_group = $raidv2_info_group_by_name{$offline_disk_group_id}{raid_name};

	# -------------------------------------------------------------
	# Inject the errors
	# -------------------------------------------------------------
	raidv2_fiji_clear_all();
	foreach (@errors_to_be_injected) {
		if(!raidv2_fiji_add_filter($_)) {
			tstlog -fatal, "Failed to set injection point : $_";
		}
	}

	# -------------------------------------------------------------
	# Set the recons disable flag and start hammer
	# -------------------------------------------------------------
	saycmd($FILER, "priv set -q diag; setflag raid_disable_new_recons 1");
	raidv2_start_multiple_hammers($vol);
	raidv2_info_disk_load($offline_disk);
	raidv2_info_group_load($offline_disk_group);

	# -------------------------------------------------------------
	# Check if the disk went to an offline state and the group went to DEGRADED state
	# -------------------------------------------------------------
	# may OFFLINE to ONLINING fast
	while (("OFFLINE ONLINING" !~ $raidv2_info_disk_by_name{$offline_disk}{fsm_state}) && 
	       ("DEGRADED" ne $raidv2_info_group_by_name{$offline_disk_group}{fsm_state})) {
		raidv2_info_disk_load($offline_disk);
		raidv2_info_group_load($offline_disk_group);
	}
	logcomment("Disk $offline_disk was offlined.");

	# -------------------------------------------------------------
	# Enable the recons flag
	# -------------------------------------------------------------
	saycmd($FILER, "priv set -q diag; setflag raid_disable_new_recons 0");

	# -------------------------------------------------------------
	# Wait for optimized reconstruction
	# -------------------------------------------------------------
	# Uses $DISK_OFFLINE_TYPE to check for right recons state
	raidv2_wait_on_reconstruct_complete($vol, $offline_disk, 1);	# 1 for optimized

	# -------------------------------------------------------------
	# Check to see if the disk is back to online state and the group state is NORMAL
	# -------------------------------------------------------------
	while (($raidv2_info_disk_by_name{$offline_disk}{fsm_state} ne "INUSE") && 
	       ($raidv2_info_group_by_name{$offline_disk_group}{fsm_state} ne "NORMAL")) {
		raidv2_info_disk_load($offline_disk);
		raidv2_info_group_load($offline_disk_group);
	}
	logcomment("Disk $offline_disk back to online state.");
	saycmd($FILER, "sysconfig -r");

	# Wait for SDC copy?  Cannot scrub if copying.
	#while (raidv2_get_disks_by_type($vol, '???')) {
	#	logcomment("Waiting for disk copy.");
	#	sleep 5;
	#}

	# -------------------------------------------------------------
	# Abort hammer
	# -------------------------------------------------------------
	saycmd($FILER, "priv set -q diag; hammer abort");
	raidv2_fiji_clear_all();
}

##############################################################
# NON-RAID section
############################################################



sub raidv2_mvm_zero {
	#
	# We're going to blast the mvm.  This will get rid of any stale
	# records, but existing mirrored volumes will get written into the
	# mvm on the next volume create.
	#
	saycmd_real($FILER, "priv set -q advanced; raid_config zeromvm", $RAIDV2_TIMEOUT);
}

sub raidv2_mvm_reload {
	#
	# We're going to reload the mvm from disk.  This forces any
	# incorrect in core data to get flushed.
	#
	saycmd_real($FILER, "priv set -q advanced; raid_config reloadmvm", $RAIDV2_TIMEOUT);
}

#
# Given a volume name, return an appropriate mvm key.
#
sub raidv2_mvm_makekey($) {
	my($vol) = @_;

	my $id = $raidv2_info_vol_by_name{$vol}{fsid};
	my $ctime = $raidv2_info_vol_by_name{$vol}{ctime};
	my $creator_sysid = $raidv2_info_vol_by_name{$vol}{creator_sysid};

	my $key = "id=$id,ctime=$ctime,creator_sysid=$creator_sysid";
	
	return $key;
}



#--------------------------------------------- 
# Create a temporary volume name, with the "expiration time" 
# embedded in the name.
#  
# The first optional argument provides an additional string 
# that gets embedded in the middle of the name, so we can 
# tell which test created it. 
#
# The second optional argument is the "expiration time". 
# By default, it is one hour.  If the volume exists for longer 
# than that, it is fair game for removal. 
#--------------------------------------------- 
 
sub create_temporary_volname { 
        my $expiration = 3600;  # one hour 
        my $middle = ""; 
        if ($#_ > -1) { 
                $middle = $_[0]; 
        } 
        if ($#_ > 0) { 
                $expiration = $_[1]; 
        } 
        my $tm = time() + $expiration; 
        return "nate_".$middle."_".$tm; 
} 

#--------------------------------------------- 
# Loop through all the volumes, looking for ones whose 
# expiration time has been exceeded, and offline/destroy them. 
#--------------------------------------------- 
sub destroy_temporary_volumes { 
        my $o = saycmd_real($FILER,"vol status", $RAIDV2_TIMEOUT); 
        my @lines = split('\n',$o); 
        my ($v, $i); 
        for ($i=1; $i <= $#lines; $i++) { 
                my $v = $lines[$i]; 
                $v =~ s/^\s+//; 
                my ($vol, $state, $dummy) = split(" ", $v); 
                if ($vol !~ /^nate_/ ) { next; } 
                my $tm = $vol; 
                $tm =~ s/.*_//; 
                my $now = time(); 
                if ("$now" > "$tm") { 
                        if (!raidv2_destroy_volume($vol)) { 
                                tstlog ("-comment", "Unable to destroy volume: $vol"); 
                        } 
                } 
        } 
} 

sub raidv2_mvm_verify($) {
	my $invoke = $_[0];
	my $count = 0;
	my $vol;
	my $key;
	
	#
	# Verify that header information
	#
	if ($raidv2_info_mvm{version} != 1) {
		tstlog -fatal, "raidv2_mvm($invoke): illegal version: $raidv2_info_mvm{version}";
	}

	local($timestamp) = $raidv2_info_mvm{last_update};
	if ($timestamp == 0) {
		tstlog -fatal, "raidv2_mvm($invoke): zero timestamp";
	}

	#
	# Make sure that we have exactly one record for every key
	#
	foreach $key (keys %raidv2_info_mvm_count) {
		if ($raidv2_info_mvm_count{$key} != 1) {
			tstlog -fatal, "raidv2_mvm($invoke): illegal count ($key): $raidv2_info_mvm_count{$key}";
		}
		
	}

	foreach $vol (keys %raidv2_info_vol_by_name) {
		if ($raidv2_info_vol_by_name{$vol}{plex_count} != 2) {
			next;
		}
		
		$count++;
		my $id = $raidv2_info_vol_by_name{$vol}{fsid};
		my $ctime = $raidv2_info_vol_by_name{$vol}{ctime};
		my $creator_sysid = $raidv2_info_vol_by_name{$vol}{creator_sysid};

		my $key = "id=$id,ctime=$ctime,creator_sysid=$creator_sysid";
		
		if ($raidv2_info_mvm_by_key{$key}{id} eq "") {
			tstlog -fatal, "raidv2_mvm($invoke): $vol ($key): no mvm entry";
		}
		
		if ($raidv2_info_mvm_by_key{$key}{id} != $id) {
			tstlog -fatal, "raidv2_mvm($invoke): $vol ($key): id mismatch";
		}
		if ($raidv2_info_mvm_by_key{$key}{ctime} != $ctime) {
			tstlog -fatal, "raidv2_mvm($invoke): $vol ($key): ctime mismatch";
		}
		if ($raidv2_info_mvm_by_key{$key}{creator_sysid} != $creator_sysid) {
			tstlog -fatal, "raidv2_mvm($invoke): $vol ($key): creator_sysid mismatch";
		}
	}
	
	if ($raidv2_info_mvm{nrecs} != $count) {
		tstlog -fatal, "raidv2_mvm($invoke): nrecs mismatch ($raidv2_info_mvm{nrecs}, $count)";
	}
}

# Function to get the integer equivalent of month that is passed in as a 3-character 
# string. This is needed because we perform month comparisons and comparing strings
# wouldn't exactly determine if a particular month indeed preceeds another month. For
# example, the string "Jan" is greater than the string "Feb" but January precedes 
# February. 
# @param Month represented as a 3-character string
# @return Month represented as an integer
#
sub raidv2_get_Month($)
{
	%MONTHS = (
                "Jan" => 1,
                "Feb" => 2,
                "Mar" => 3,
                "Apr" => 4,
                "May" => 5,
                "Jun" => 6,
                "Jul" => 7,
                "Aug" => 8,
                "Sep" => 9,
                "Oct" => 10,
                "Nov" => 11,
                "Dec" => 12
          );
	$intMonth = $MONTHS{$_[0]};

	return $intMonth; 
}

# Function to determine the date.
# @param Filer name
# @return array whose elements are month, day, hour, minute and second
#
sub raidv2_get_timestamp($)
{
	my @date;

	# - - - - - - - - - - - - - - - - - - - -
	# Determine the timestamp
	# - - - - - - - - - - - - - - - - - - - -

	my $mydate = saycmd($_[0], "date");
	$mydate =~ tr/G/:/;
	my @tmp0 = split(/:/,$mydate);
	my @tmp1 = split(/\s+/, $tmp0[0]);
	$date[0] = raidv2_get_Month($tmp1[1]);
	$date[1] = $tmp1[2];
	$date[2] = $tmp1[3];
	$date[3] = $tmp0[1];
	$date[4] = $tmp0[2];

	return @date;
}

# Function to clear any stale mounts and then mount the Filer and the volume.
# @param Name of the Filer
# @param Name of the volume
#
sub raidv2_mount_volume($$)
{
	my $FILERNAME = $_[0];
	my $FILER_VOL = $_[1];
	logcomment("Mounting $FILERNAME $FILER_VOL...");

	# - - - - - - - - - - - - - - - - - - - -
	# License NFS 
	# - - - - - - - - - - - - - - - - - - - -
	#saycmd($FILER, "priv set -q diag; license nfs=TZBGCKE");
	my $frsh = connect("$FILER#rsh");
	license($frsh, "nfs") or logresult('FATAL', $@);

	# - - - - - - - - - - - - - - - - - - - -
	# Unmount to clear stale mounts
	# - - - - - - - - - - - - - - - - - - - -
	raidv2_client_saycmd($CLIENT, "r umount -f /t/$FILERNAME/$FILER_VOL");
	raidv2_client_saycmd($CLIENT, "r umount -f /t/$FILERNAME/root");
	
	# - - - - - - - - - - - - - - - - - - - -
	# Mount the Filer
	# - - - - - - - - - - - - - - - - - - - -
	raidv2_client_saycmd($CLIENT, "sim_mount $FILERNAME");
{
	# - - - - - - - - - - - - - - - - - - - -
	#Need to do the following because of changes in NFS
	# - - - - - - - - - - - - - - - - - - - -
	raidv2_client_saycmd($CLIENT, "r chmod 777 /t/$FILERNAME/root/etc/exports");
	raidv2_client_saycmd($CLIENT, "echo  /vol/vol0 -anon=0 > /t/$FILERNAME/root/etc/exports");
	raidv2_client_saycmd($CLIENT, "echo  /vol/$FILER_VOL -anon=0 >> /t/$FILERNAME/root/etc/exports");
	raidv2_client_saycmd($CLIENT, "r chmod 644 /t/$FILERNAME/root/etc/exports");

	# - - - - - - - - - - - - - - - - - - - -
	# Mount the volume
	# - - - - - - - - - - - - - - - - - - - -
	saycmd($FILER, "exportfs -va");
};
	saycmd($FILER, "exportfs -p sec=sys,rw,anon=0 /vol/$FILER_VOL");	
	raidv2_client_saycmd($CLIENT, "sim_mount $FILERNAME $FILER_VOL");
}

#
# Function to change Filer's syslog.conf file to have the debug level msg
# @param Name of the Filer
#
sub raidv2_set_debug_level_syslog($)
{
	my $FILERNAME = $_[0];
	
	if (-e "/t/$FILERNAME/root/etc/syslog.conf") {
		`sudo -u root mv "/t/$FILERNAME/root/etc/syslog.conf" "/t/$FILERNAME/root/etc/syslog.conf.copy"`;
	  	`sudo -u root echo "*.debug             /dev/console" > "/tmp/syslog.conf"`;
	 	`sudo -u root echo "*.debug             /etc/messages" >> "/tmp/syslog.conf"`;
	  	`sudo -u root cp "/tmp/syslog.conf" "/t/$FILERNAME/root/etc/syslog.conf"`;
	} else {
		`sudo -u root echo "*.debug             /dev/console" > "/tmp/syslog.conf"`;
	  	`sudo -u root echo "*.debug             /etc/messages" >> "/tmp/syslog.conf"`;
	  	`sudo -u root cp "/tmp/syslog.conf" "/t/$FILERNAME/root/etc/syslog.conf"`;
	}
}
# Function to search for a particular string in /etc/messages file under the root
# directory of the simulator
# @param Name of the Filer
# @param String we are searching for in /etc/messages
# @param array whose elements are month, day, hour, minute and second corresponding to the
# timestamp when the test volume was created
# @return 1 if string is found and 0 if it is not
#
sub raidv2_check_log_for_message($$@)
{
	my ($FILERNAME, $search_string, @date) = @_;

	my $FLAG = 0;

	if(!open(FH, "/t/$FILERNAME/root/etc/messages")) {
		tstlog -comment, "Cannot open file /t/$FILERNAME/root/etc/messages";
		return $FLAG;
	}

	while ($line = <FH>) {
		$line =~ tr/G/:/;
		@tmp = split(/:/,$line);
		@tmp2 = split(/\s+/, $tmp[0]);
		my $log_mon = raidv2_get_Month($tmp2[1]);
		my $log_day = $tmp2[2];
		my $log_hr = $tmp2[3];
		my $log_min = $tmp[1];
		my $log_sec = $tmp[2];

		if(($log_mon < $date[0]) || (($log_mon == $date[0]) && ($log_day < $date[1])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr < $date[2])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr == $date[2]) && ($log_min < $date[3])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr == $date[2]) && ($log_min == $date[3]) && ($log_sec < $date[4]))) {
			next;
		}

		if($line =~ /$search_string/) {
			$FLAG = 1;
			tstlog -comment, "\$line = $line";
			last;
		}
	}
	close(FH); 
	return $FLAG;
}

# Function to determine if scrub found any errors
# @param Name of the Filer
# @param array whose elements are month, day, hour, minute and second corresponding to the
# timestamp when the test volume was created
#
sub raidv2_check_log_for_scrub_success($@)
{
	my ($FILERNAME, @date) = @_;

	my $FLAG = 0;

	if(!open(FH, "/t/$FILERNAME/root/etc/messages")) {
		tstlog -comment, "Cannot open file /t/$FILERNAME/root/etc/messages";
		return $FLAG;
	}

	# Return value if search string is not found	
	$FLAG = -1;

	while ($line = <FH>) {
		$line =~ tr/G/:/;
		@tmp = split(/:/,$line);
		@tmp2 = split(/\s+/, $tmp[0]);
		my $log_mon = raidv2_get_Month($tmp2[1]);
		my $log_day = $tmp2[2];
		my $log_hr = $tmp2[3];
		my $log_min = $tmp[1];
		my $log_sec = $tmp[2];

		if(($log_mon < $date[0]) || (($log_mon == $date[0]) && ($log_day < $date[1])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr < $date[2])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr == $date[2]) && ($log_min < $date[3])) || (($log_mon == $date[0]) && ($log_day == $date[1]) && ($log_hr == $date[2]) && ($log_min == $date[3]) && ($log_sec < $date[4]))) {
			next;
		}

		if($line =~ "Scrub found 0 parity inconsistencies") {
			$FLAG = 1;
		}
		else {
			$FLAG = -1;
			last;
		}

		if($FLAG && $line =~ "Scrub found 0 checksum errors") {
			$FLAG = 1;
		}
		else {
			$FLAG = -1;
			last;
		}

		if($FLAG && $line =~ "Scrub found 0 media errors") {
			$FLAG = 1;
		}
		else {
			$FLAG = -1;
			last;
		}
	}
	if($FLAG) {
		tstlog -comment, "Scrub found no errors";
	}
	else {
		tstlog -comment, "Scrub found errors";
	}
}

# ----------------------------------------------------------
## @name ::raidv2_cal_sleep_time 
## @summary return an sleep time based on disk size
## @description calculate the amount of sleep time based
## on disk size. The function shall handle indiscriminately
## both filers and simulators . 
##
## @arg - none
## @return - sleep time in seconds. 
# ----------------------------------------------------------

sub raidv2_cal_sleep_time() {
    raidv2_info_disk_load();

    my $sleep_time = 0; 
    # -------------------------------------------------------
    # search for spares from Pool0 -- I make the assumption 
    # that all disks should have the same size for both Pool0
    # and Pool1. In fact, we can just simply pick any disk ??
    # -------------------------------------------------------
    my @sdisks = split(",", $raidv2_info_tree_disk_list{"POOL:Pool0"}); 

    my $largest_size = $raidv2_info_disk_by_name{$sdisks[0]}{avl_blks};
    my $largest_disk = $sdisks[0]; 

    # ---------------------------
    # search for the largest disk 
    # ---------------------------
    for (my $i=1; $i <= $#sdisks; $i++ ) {
	if ($raidv2_info_disk_by_name{$sdisks[$i]}{avl_blks} > $largest_size) {
	    $largest_disk = $sdisks[$i]; 
	    $largest_size = $raidv2_info_disk_by_name{$sdisks[$i]}{avl_blks};
	}
    }

    # ------------------------------------
    # we could add more entries to support
    # different disks. 
    # ------------------------------------
    if ($largest_size >= 142410400) {
	$sleep_time = 300; #5 minutes for large disk
    } elsif ($largest_size >= 100000000) {
	$sleep_time = 240; #4 minutes
    } elsif ($largest_size >= 50000000) {
	$sleep_time = 210; #3 minutes
    } elsif ($largest_size >= 30000000) {
	$sleep_time = 120; #2 minutes
    } elsif ($largest_size >= 10000000) {
	$sleep_time =  60; #1 minutes
    } elsif ($largest_size >= 2390416) {
	$sleep_time = 30; #1/2 minute for mini disk
    } else {
	$sleep_time = 10; # 10 seconds for simulator with smaller disks
    }
    return $sleep_time;
} #raidv2_cal_sleep_time

# Function that waits for scrub to complete
# @param Name of volume
#
sub raidv2_wait_for_scrub_completion($)
{
	my $FILER_VOL = $_[0];

	my($sleep_time) = raidv2_cal_sleep_time(); 

	raidv2_info_group_load();
	my @groups = split(',', $raidv2_info_tree_group_list{$FILER_VOL});
	my $scrub_in_progress = 1;

	while ($scrub_in_progress == 1) {
		$scrub_in_progress = 0;
		foreach my $e (@groups) {
			if ($raidv2_info_group_by_name{$e}{"scrub_progress"} != -1) {
				$scrub_in_progress = 1;
			}
		}
		sleep $sleep_time; 
		raidv2_info_group_load();
	}
}

# -------------------------------------------------------------------
# If fatal error encountered, halt the simulator, then exit.
# Usage:raidv2_log_fatal($cfunc, "log messages here.\n");
# helper function (in your script)
# my $sim = raidv2_is_simulator();
# my $cfunc = sub {
#	if ($sim) {
#		tstlog -comment, "***About to halt the simulator.\n";
#		halt($c);
#	}
#};
# -------------------------------------------------------------------
sub raidv2_log_fatal($$)
{
	raidv2_stop_hammer();
	my ($handler, $logargs) = @_;
	&$handler();
	tstlog -fatal, "$logargs";
}
1;

#
# Argument: disk name
# returns the secondary name of the disk
# e.g. v0.1 secondary name is v4.1 if the disk is dual path
# It is needed due to the fact that simpulled disk name may be the primary name
# of the disk.
#
sub raidv2_get_disk_sec_name($) {
	my $disk_name = $_[0];
	my $ret = saycmd_real($FILER, 
		"priv set -q diag; storage show disk $disk_name", 
		"30");
	if ( $ret =~ /Sec Name:\s+([v0-9.])+\s*/) {
	    return $1;
	}
	return "";
}

sub raidv2_is_aggr($) {
	my $vol = $_[0];
	foreach my $v (keys %raidv2_info_vol_by_name){
		return 0 if ($v =~ $vol);
	}
	return 1;
}
