#/* $Id: //depot/prod/test/Rsierranevada/lib/rlmPhoenix.pm#1 $ */
package rlmPhoenix;

use strict;
use File::stat;
use Time::localtime;
use Time::gmtime;
use Tharn;

BEGIN {
    use Exporter ();

    @rlmPhoenix::ISA         = qw(Exporter);
    @rlmPhoenix::EXPORT      = qw();
    @rlmPhoenix::EXPORT_OK   = qw($test_result $status_result $show_result $md_results $HarnessAction $cmdname $dir_nos $dl_Result);
  }


#### RSA TEST VALIDATION ##########################
sub testRsa_getResult
{
   my $testRsa = shift;
   my @result1 = ('RSA');
   our $test_result;

    foreach my $line1 (split(/\n/, $testRsa)) {
     if ($line1 =~ /Testing storage controller (HTTP).*(ok|failed)(.*)/){
        if ($2 =~ /ok/){ 
           push (@result1,",", $1, "PASS");
           print "@result1\n";
         } # ends if
        else {     
           push (@result1, ",", $1, "FAIL");
           print "@result1\n";
         } # ends else  

       } # ends if

   } # ends foreach for results
  
  $test_result=join(":",@result1);
  print "$test_result\n";

} # ends sub testRsa_getResult
1;

#### RSA STATUS VALIDATION ##########################
sub statusRsa_getResult
{
   my $statusRsa = shift;
   my @result1 = ('RSA');
   our $status_result;

    foreach my $line1 (split(/\n/, $statusRsa)) {
     if ($line1 =~ /^(HTTP).*: (ok|failed|alert)(.*)/){
        if ($2 =~ /ok/){
           push (@result1,",", $1, "PASS");
           print "@result1\n";
         } # ends if
        else {
           push (@result1, ",", $1, "FAIL");
           print "@result1\n";
         } # ends else
       } # ends if
       
# Modified by Feroz to check for SEP not appearing with 'rsa status' command.      
     elsif ($line1 =~ /^(SEP entitlement).*/){
           push (@result1, ",", $1, "FAIL");
           print "@result1\n";
		} # ends if
   } # ends foreach for results

  $status_result=join(":",@result1);
  print "$status_result\n";

} # ends sub statusRsa_getResult
1;


#### RSA SHOW VALIDATION ########################
sub showRsa_getResult
{
  my $showRsa = shift;
  our $FILER_FQDN = shift;
  our $usrname = shift;
# our $telnet_port = shift;
  our $http_port = shift; 
  our $https_enable = shift;
  our $PROXY = shift;
  our $PROXY_PROTOCOL = shift;
  our $PROXY_IP = shift;
  our $PROXY_PORT_NUMBER = shift;
  our $PROXY_USER_NAME = shift;
  our @result1;
  @result1 = ('RSA');
  our $show_result;

  foreach my $line1 (split(/\n/, $showRsa)) { 
   if ($line1 =~ /not|invalid.*/i) { 
        push (@result1, ",", $line1, "FAIL");

   } 
   if ($line1 =~ /(Remote Support Agent is enabled.*)/) { 
    if ($1 =~ /Remote Support Agent is enabled.*/) {   
        push (@result1, ",", $line1, "PASS");
        }
       else { 
          push (@result1, "," ,$line1,"FAIL");
       } #ends else
   } # ends if 
   if ($line1 =~ /Storage controller (HTTP) host: (.*)/) { 
     if ($2 =~ $FILER_FQDN) { 
          push (@result1, ","," Pass SHOW host",$FILER_FQDN, "PASS");
        }
       else { 
          push (@result1, ",","Fail SHOW host",$FILER_FQDN, "FAIL");
       } #ends else
   } # ends if
    if ($line1 =~ /Use proxy: (\w\w+)/) {
	if ($1 eq $PROXY) {
		 push (@result1, ","," Pass Proxy Use",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Use",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy protocol: (\w\w\w\w+)/) {
      if ($1 eq $PROXY_PROTOCOL) {
		 push (@result1, ","," Pass Proxy Protocol",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Protocol",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy host: (\d\d\.\d\d\.\d\d\.\d\d\d)/) {
      if ($1 eq $PROXY_IP) {
		 push (@result1, ","," Pass Proxy IP",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy IP",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Proxy port: (\d\d\d\d)/) {
      if ($1 eq $PROXY_PORT_NUMBER) {
		 push (@result1, ","," Pass Proxy Port",$1, "PASS");
      }
      else {
         push (@result1, ",","Fail Proxy Port",$1, "FAIL");
      } #ends else
    } # ends if
    if ($line1 =~ /Use username\/password.*: (\w\w+)/) {
	  if ($1 eq "no") {
		  if ($PROXY_USER_NAME eq "NA") {
			 push (@result1, ",", "Pass proxy authentication not required",$1, "PASS");
		  }
		  else {
			 push (@result1, ",", "Fail proxy authentication required",$1, "FAIL");
	      }
	  }
	  if ($1 eq "yes") {
		  if ($PROXY_USER_NAME ne "NA") {
			 push (@result1, ",", "Pass proxy authentication required",$1, "PASS");
		  }
		  else {
			 push (@result1, ",", "Fail proxy authentication not required",$1, "FAIL");
	      }
	  }
	}
    if ($line1 =~ /Proxy username: (\w+\\*\w*)/) {
      if ($PROXY_USER_NAME ne "NA") {
      	 if ($1 eq $PROXY_USER_NAME) {
            push (@result1, ","," Pass Proxy username matches",$PROXY_USER_NAME, "PASS");
         }
         else {
         push (@result1, ",","Fail Proxy username mismatch",$PROXY_USER_NAME, "FAIL");
         } #ends else
	  }
    } # ends if
   if ($line1 =~ /Storage controller (HTTP) username: (.*)/) { 
     if ($2 =~ $usrname) { 
          push (@result1, ",","SHOW $1 username",$usrname, "PASS");
        }
       else { 
          push (@result1, ",","SHOW $1 username",$usrname, "FAIL");
       } #ends else
   } # ends if 
   if ($line1 =~ /Storage controller (HTTP) port: (.*)/) { 
     if ($2 =~ $http_port) { 
          push (@result1, ",","SHOW $1 port",$http_port, "PASS");
        }
       else { 
          push (@result1, ",","SHOW $1 port",$http_port, "FAIL");
       } #ends else
   } # ends if 
 if ($line1 =~ /HTTP with SSL enabled: (.*)/) {
     if ($1 =~ $https_enable) {
          push (@result1, ",","SHOW $1 https enabled",$https_enable, "PASS");
        }
       else {
          push (@result1, ",","SHOW $1 https",$https_enable, "FAIL");
       } #ends else
   } # ends if

 } #ends foreach
  $show_result=join(":",@result1);
  print "Printing results captured $show_result\n\n\n";
} # ends sub showRsa_getResult 
1;

###########Get Test Harness Details #################
sub get_harness_details
{
  our $testcase = shift; 
  our $file = shift; 
  our $rsaid = shift;
  our $HarnessServer = shift; 
  our $corePath = "etc/crash/"."$file"; 
  
  our $cmdname; 
  our $HarnessAction;
  our $case_id; 
  print "$testcase received \n\n";

  my $range = 100;
  $case_id = int(rand($range));
 
  if ($testcase =~/^6.2..*/) { 
    $cmdname = "coreUpload"; 
    $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/auto/0/case/$case_id/core/$corePath";
  } 
  if ($testcase =~/^6.3..*/) { 
    $cmdname = "fileUpload"; 
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/file/$file";
  } 
  if ($testcase =~/^6.4..*/) { 
    $cmdname = "dirList"; 
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid/?list=$file";
  } 
  if ($testcase =~/^6.5..*/) { 
    $cmdname = "triggerASUP"; 
      $HarnessAction = "http://$HarnessServer/$cmdname/rsa/$rsaid";
  } 
} #ends sub get_harness_server
1;

########### md5sum Compare ###################
sub md5sum_compare
{
  my $mdout = shift;
  our $reqd_file = shift;
  our $orig_file = shift;
  our $reqd_file_md;
  our $orig_file_md; 
  our $md_results;

  foreach my $line1 (split(/\n/, $mdout)) {
   if ($line1 =~ /(.*) $reqd_file/) {
      $reqd_file_md = $1;
    } 
   if ($line1 =~ /(.*) $orig_file/)  { 
      $orig_file_md = $1;    
    }
  } #ends foreach
  if ($reqd_file_md =~ /^$orig_file_md$/) { 
    $md_results = "PASS";
      print "$md_results \n\n";
  } # ends if
  else {
    $md_results = "FAIL";
      print "$md_results \n\n";
  } # ends else
} # ends sub md4sum_compare
1;

########### get dir listing details ###################
sub get_dir
{
  my @dir_names = shift;
  my $dirlist_file = shift;
  my $dirlist_name_file = shift;
  our $dir_nos = 0;
 
      print "FILE NAME = $dirlist_name_file\n"; 
 open DFH1, "> $dirlist_name_file" or die $!;
  foreach my $dir (@dir_names) { 
      print DFH1 "$dir\n"; 
      $dir_nos = $dir_nos + 1;
      print "$dir dirs nos $dir_nos\n";
  } #ends foreach
  close DFH1;
} # ends sub get_dir
1;


###########validate dir listing results ##################
sub validate_dir
{
  our $FILER = shift;
  our $dirlist_name_file = shift;
  our $destn_buf_file = shift;
  our $dl_Result;  
  
   open DFH2, "< $destn_buf_file" or die $!;
   while (<DFH2>) {
   print "Validating list dir Results \n\n";
          if ($_ =~ /.*(Index|directory not found).*/i) { 
              if ($1 =~ /(Index)/i) {                
                   valid_dir_chk($destn_buf_file, $FILER, $dirlist_name_file);
              }
              else {  
                 $dl_Result = "FAIL";
                 print "$_ = $dl_Result\n\n";
              } 
           }
 } # ends while
   close DFH2;
}# ends sub validate_dir
1;


###########valid_dir_chk ##################
sub valid_dir_chk
{
  our $dl_Result;  
  our $destn_buf_file = shift;
  our $FILER=shift; 
  our $dirlist_name_file=shift; 
  our $dirlist_filer = "$destn_buf_file" . "_from_filer.txt"; 
  our $dir_filer_location = "/t/$FILER/root";

  my ($node, $mod_time, $size, $mtime);

  open DFH2, "< $dirlist_name_file" or die $!;
  while (<DFH2>){ 
     my $dir_name = "$dir_filer_location"."$_";
     print "Validating directory contents....  $dir_name\n\n";
#     opendir MYDIR, "$dir_name" or die $!;
#     my @contents = readdir MYDIR;
#     print "dir contents @contents \n\n";
#     foreach my $listitem ( @contents )
#     {
#            print "Validating dir $listitem\n\n";
#            $node = stat("$dir_name$listitem");
#            $mtime = $node->mtime;
#            $size  = $node->size / 1024;
#            $mod_time=gmctime($mtime);  ## gives us a string format
#            if ($size =~/(.*)\.(.*)/) { 
#              $size = $1; 
#            }
#            print "$listitem\t $mod_time\t $size \n";
            $dl_Result = "PASS";
#            print "dl Result value = $dl_Result\n\n";
#  } # ends foreach 
 } # ends while
 close DFH2;
} # ends valid_dir_chk

########### copy_common_files ##################
# Modified by Feroz - Added code for coping the dependency files.
sub copy_common_files
{
	our $cc			= shift;
	our $home_dir	= shift;
	our $pr_folder 	= shift;
	our $common_files_path = shift;
	our $file_name 	= shift;

# Check if the file is located in common location.
	our (undef, undef, $out) = say ($cc, "ls -l $common_files_path/$file_name");

	if($out=~ /.*(such file|Failed|unable|perm).*/i){
		logresult('FAIL', "File \"$file_name\" is missing at \"$common_files_path\".");
		tstlog(-comment,"Pre-requisite NOT met. Copy \"$file_name\" to \"$common_files_path\".");
		print "Exiting script, Follow steps in Pre-requiste and re-run script\n";
		exit;
	}
		
#	print ("\n\nHOME_DIR : $home_dir\nPR_FOLDER : $pr_folder \nCOMMON : $common_files_path\nFILENAME: $file_name\n\n");
	our (undef, undef, $out) = say ($cc, "ls -l $home_dir/$pr_folder/$file_name");
	if($out=~ /.*(such file).*/i){
		tstlog(-comment,"Copy $file_name to $home_dir/$pr_folder");
		say ($cc, "cp $common_files_path/$file_name $home_dir/$pr_folder/$file_name", '-timeout', 300);
	}
	elsif($out=~ /.*(Failed|unable|perm).*/i){
		logresult('FAIL', "$home_dir/$pr_folder/$file_name");
		tstlog(-comment,"Failed to list the file $file_name at $home_dir/$pr_folder.");
		print "Exiting script, Follow steps in Pre-requiste and re-run script\n";
		exit;
  }
} # ends copy_common_files


1;


