#!/bin/sh
# $Id: //depot/prod/test/main/storage/hdd/NADQ_SEA/NDATE/SUPPORT_SCRIPTS/check.sh#1 $ 
# Copyright (c) 2005 Network Appliance, Inc.
# All rights reserved
#
## @summary Mode
## Check log directory size 


## @description
## Check log directory size 

FILE=$1;
MAIL=$2;

# Find shell.txt file exists.

while [ 1 ]
  do
    [ -f $FILE ] && break
done

# Read logpath from shell_<testsuitename>.txt file and assign to logdir variable.

while read line
  do
	if [ "$logdir" == "" ]
        then
        	if echo "$line" | grep "LOGDIR" >/dev/null 2>&1
        	then
        	logdir=`echo $line | awk -F\= '{print $2}'`
		logdir=`echo $logdir | sed 's/\/HDD\/.*$/\/HDD/'`
        	break;
        	fi
        fi
  done < "$FILE"

#DEEBUG

TESTSUITE=`echo $logdir | sed 's/.*\/[0-9][0-9]*_[0-9][0-9]*_\([^/]*\).*/\1/'`
export user=`eval whoami`
MK=`mkdir $logdir 2>/dev/null`;

# Remove created txt file.
 RMV=`rm -f $FILE`

# Get user name.
user=`whoami`;

# Get LOG_DIR_SIZE from default_params and assign to MAXSIZE.

 while read line
     do
        if [ "$dir_limit" == "" ]
                then
                if echo "$line" | grep "LOGDIRSIZE" >/dev/null 2>&1
                then
                dir_limit=`echo $line | awk -F\= '{print $2}'`
                break;
                fi
        fi
 done < "$HOME/NDATE/default_params"

 while read line
    do
        if echo "$line" | grep "FILER" >/dev/null 2>&1
        then
        FILER=`echo $line | awk -F\= '{print $2}'`
        break;
        fi
 done < "$HOME/NDATE/TEST_LISTS/$TESTSUITE"

 while read line
    do
        if echo "$line" | grep "connhost" >/dev/null 2>&1
        then
        TERM=`echo $line | awk -F'[}{=]' '/conn(host)/{print $NF}' RS=\;`
        PORT=`echo $line | awk -F'[}{=]' '/conn(port)/{print $NF}' RS=\;`
        break;
        fi
 done < "$HOME/NDATE/FILER_INFO/$FILER"

 HOST=`host $TERM`;
 HOST=`echo $HOST | awk -F\pointer '{print $2}'`
 HNAME=`echo $HOST | awk -F\. '{print $1}'`

while [ 1 ]
  do
	if [ "$dir_limit" ]; then
 	MAXSIZE=$dir_limit;
	else
	MAXSIZE=10485760
	fi

  if [ -d "$logdir" ]; then	
	FOLDERSIZE=`du -sx $logdir | cut -f 1` >/dev/null 2>&1;	
	
	if [ "$FOLDERSIZE" -ge "$MAXSIZE" ] >/dev/null 2>&1 ; then
        export user=`eval whoami`
	echo "";
        echo "Maximum Size Limit of LOG DIRECTORY exceeded, Terminating ntest process....";
	echo "LOG file (SHELL_TERMINATE.log) of this process is available in $logdir";
	echo "-------------------------------------------------------------------------------------------------"  >> $logdir/SHELL_TERMINATE.log
	echo " MAXIMUM SIZE LIMIT OF LOG DIRECTORY EXCEEDED, SHELL PROCESS HAS TERMINATED THE NTEST PROCESS."  >> $logdir/SHELL_TERMINATE.log
	echo "-------------------------------------------------------------------------------------------------"  >> $logdir/SHELL_TERMINATE.log
	echo "MAXIMUM SIZE LIMIT = $MAXSIZE  and LOG DIRECTORY SIZE = $FOLDERSIZE "  >> $logdir/SHELL_TERMINATE.log
	echo "Time: `date`" >>  $logdir/SHELL_TERMINATE.log
	echo "Test Suite Name : $TESTSUITE"  >> $logdir/SHELL_TERMINATE.log
	echo "Log Directory : $logdir"  >> $logdir/SHELL_TERMINATE.log
	echo "Mailed to : $MAIL"  >> $logdir/SHELL_TERMINATE.log 
	echo "-------------------------------------------------------------------------------------------------"  >> $logdir/SHELL_TERMINATE.log

#Kill process 
	NPS=`ps -ef | grep $user | grep ntest | grep $TESTSUITE | gawk '{ print $2 }'`
	for A in $NPS
	do
	`kill -9 $A 2>/dev/null`
	done
	
	PS=`ps -ef | grep $user | grep $TERM | grep $PORT | gawk '{ print $2 }'`
	if [ "$PS" ]; then
		`kill -9 $PS 2>/dev/null`
	else
		echo "No process "
	fi
	
	PS2=`ps -ef | grep $user | grep $HNAME | grep $PORT | gawk '{ print $2 }'`
	if [ "$PS2" ]; then
		`kill -9 $PS2 2>/dev/null`
	else
		echo "No Process"
	fi
	
	PS1=`ps -ef | grep $user | grep $PORT | gawk '{ print $2 }'`
	if [ "$PS1" ]; then
		`kill -9 $PS1 2>/dev/null`
	else
		echo "No Process"
	fi

	if [ PSD=`ps -ef | grep $user | grep ntest | grep $TESTSUITE | gawk '{ print $2 }'` ] ; then
		for ZOM in $PSD
		do
		`kill -9 $ZOM 2>/dev/null`
		done
		echo "ntest process terminated, press ENTER ..."
		
	fi
	
# Send Mail to user 
	SUBJECT="Automated Shell terminated logs"
	TO=$MAIL
	MESSAGE=$logdir/SHELL_TERMINATE.log
	/bin/mail -s "$SUBJECT" "$TO" < $MESSAGE
	break;
# End of Send Mail
    fi 
  fi
done
