package MyInterfaces::DfmService::DfmPort;
use strict;
use warnings;
use Class::Std::Fast::Storable;
use Scalar::Util qw(blessed);
use base qw(SOAP::WSDL::Client::Base);

# only load if it hasn't been loaded before
require MyTypemaps::DfmService
    if not MyTypemaps::DfmService->can('get_class');

sub START {
    $_[0]->set_proxy('https://HOST_NAME:8488/apis/soap/v1') if not $_[2]->{proxy};
    $_[0]->set_class_resolver('MyTypemaps::DfmService')
        if not $_[2]->{class_resolver};

    $_[0]->set_prefix($_[2]->{use_prefix}) if exists $_[2]->{use_prefix};
}

sub AggregateListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "AggregateListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateListInfoIterEnd',
        soap_action => 'urn:AggregateListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "AggregateListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateListInfoIterNext',
        soap_action => 'urn:AggregateListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "AggregateListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateListInfoIterStart',
        soap_action => 'urn:AggregateListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateModify {
    my ($self, $body, $header) = @_;
    die "AggregateModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateModify',
        soap_action => 'urn:AggregateModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateSpaceManagementAddOperation {
    my ($self, $body, $header) = @_;
    die "AggregateSpaceManagementAddOperation must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateSpaceManagementAddOperation',
        soap_action => 'urn:AggregateSpaceManagementAddOperation',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateSpaceManagementAddOperation )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateSpaceManagementBegin {
    my ($self, $body, $header) = @_;
    die "AggregateSpaceManagementBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateSpaceManagementBegin',
        soap_action => 'urn:AggregateSpaceManagementBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateSpaceManagementBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateSpaceManagementCommit {
    my ($self, $body, $header) = @_;
    die "AggregateSpaceManagementCommit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateSpaceManagementCommit',
        soap_action => 'urn:AggregateSpaceManagementCommit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateSpaceManagementCommit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateSpaceManagementRemoveOperation {
    my ($self, $body, $header) = @_;
    die "AggregateSpaceManagementRemoveOperation must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateSpaceManagementRemoveOperation',
        soap_action => 'urn:AggregateSpaceManagementRemoveOperation',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateSpaceManagementRemoveOperation )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AggregateSpaceManagementRollback {
    my ($self, $body, $header) = @_;
    die "AggregateSpaceManagementRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AggregateSpaceManagementRollback',
        soap_action => 'urn:AggregateSpaceManagementRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AggregateSpaceManagementRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmCreate {
    my ($self, $body, $header) = @_;
    die "AlarmCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmCreate',
        soap_action => 'urn:AlarmCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmDestroy {
    my ($self, $body, $header) = @_;
    die "AlarmDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmDestroy',
        soap_action => 'urn:AlarmDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmGetDefaults {
    my ($self, $body, $header) = @_;
    die "AlarmGetDefaults must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmGetDefaults',
        soap_action => 'urn:AlarmGetDefaults',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmGetDefaults )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "AlarmListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmListInfoIterEnd',
        soap_action => 'urn:AlarmListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "AlarmListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmListInfoIterNext',
        soap_action => 'urn:AlarmListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "AlarmListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmListInfoIterStart',
        soap_action => 'urn:AlarmListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmModify {
    my ($self, $body, $header) = @_;
    die "AlarmModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmModify',
        soap_action => 'urn:AlarmModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AlarmTest {
    my ($self, $body, $header) = @_;
    die "AlarmTest must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AlarmTest',
        soap_action => 'urn:AlarmTest',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AlarmTest )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApiProxy {
    my ($self, $body, $header) = @_;
    die "ApiProxy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApiProxy',
        soap_action => 'urn:ApiProxy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApiProxy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyCopy {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyCopy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyCopy',
        soap_action => 'urn:ApplicationPolicyCopy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyCopy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyCreate {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyCreate',
        soap_action => 'urn:ApplicationPolicyCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyDestroy {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyDestroy',
        soap_action => 'urn:ApplicationPolicyDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyEditBegin {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyEditBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyEditBegin',
        soap_action => 'urn:ApplicationPolicyEditBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyEditBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyEditCommit {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyEditCommit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyEditCommit',
        soap_action => 'urn:ApplicationPolicyEditCommit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyEditCommit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyEditRollback {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyEditRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyEditRollback',
        soap_action => 'urn:ApplicationPolicyEditRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyEditRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyListIterEnd {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyListIterEnd',
        soap_action => 'urn:ApplicationPolicyListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyListIterNext {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyListIterNext',
        soap_action => 'urn:ApplicationPolicyListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyListIterStart {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyListIterStart',
        soap_action => 'urn:ApplicationPolicyListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ApplicationPolicyModify {
    my ($self, $body, $header) = @_;
    die "ApplicationPolicyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ApplicationPolicyModify',
        soap_action => 'urn:ApplicationPolicyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ApplicationPolicyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub AuditLogAddEntry {
    my ($self, $body, $header) = @_;
    die "AuditLogAddEntry must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'AuditLogAddEntry',
        soap_action => 'urn:AuditLogAddEntry',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::AuditLogAddEntry )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CifsDomainListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "CifsDomainListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CifsDomainListInfoIterEnd',
        soap_action => 'urn:CifsDomainListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CifsDomainListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CifsDomainListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "CifsDomainListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CifsDomainListInfoIterNext',
        soap_action => 'urn:CifsDomainListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CifsDomainListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CifsDomainListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "CifsDomainListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CifsDomainListInfoIterStart',
        soap_action => 'urn:CifsDomainListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CifsDomainListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ClientRegistryDestroy {
    my ($self, $body, $header) = @_;
    die "ClientRegistryDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ClientRegistryDestroy',
        soap_action => 'urn:ClientRegistryDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ClientRegistryDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ClientRegistryGet {
    my ($self, $body, $header) = @_;
    die "ClientRegistryGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ClientRegistryGet',
        soap_action => 'urn:ClientRegistryGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ClientRegistryGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ClientRegistrySet {
    my ($self, $body, $header) = @_;
    die "ClientRegistrySet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ClientRegistrySet',
        soap_action => 'urn:ClientRegistrySet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ClientRegistrySet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldCreate {
    my ($self, $body, $header) = @_;
    die "CommentFieldCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldCreate',
        soap_action => 'urn:CommentFieldCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldDestroy {
    my ($self, $body, $header) = @_;
    die "CommentFieldDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldDestroy',
        soap_action => 'urn:CommentFieldDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "CommentFieldListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldListInfoIterEnd',
        soap_action => 'urn:CommentFieldListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "CommentFieldListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldListInfoIterNext',
        soap_action => 'urn:CommentFieldListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "CommentFieldListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldListInfoIterStart',
        soap_action => 'urn:CommentFieldListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldModify {
    my ($self, $body, $header) = @_;
    die "CommentFieldModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldModify',
        soap_action => 'urn:CommentFieldModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldValuesListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "CommentFieldValuesListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldValuesListInfoIterEnd',
        soap_action => 'urn:CommentFieldValuesListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldValuesListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldValuesListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "CommentFieldValuesListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldValuesListInfoIterNext',
        soap_action => 'urn:CommentFieldValuesListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldValuesListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentFieldValuesListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "CommentFieldValuesListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentFieldValuesListInfoIterStart',
        soap_action => 'urn:CommentFieldValuesListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentFieldValuesListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub CommentSetObjectValue {
    my ($self, $body, $header) = @_;
    die "CommentSetObjectValue must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'CommentSetObjectValue',
        soap_action => 'urn:CommentSetObjectValue',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::CommentSetObjectValue )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetAddMember {
    my ($self, $body, $header) = @_;
    die "DatasetAddMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetAddMember',
        soap_action => 'urn:DatasetAddMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetAddMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetAddMemberByDynamicReference {
    my ($self, $body, $header) = @_;
    die "DatasetAddMemberByDynamicReference must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetAddMemberByDynamicReference',
        soap_action => 'urn:DatasetAddMemberByDynamicReference',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetAddMemberByDynamicReference )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetAddResourcepool {
    my ($self, $body, $header) = @_;
    die "DatasetAddResourcepool must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetAddResourcepool',
        soap_action => 'urn:DatasetAddResourcepool',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetAddResourcepool )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetAddToExclusionList {
    my ($self, $body, $header) = @_;
    die "DatasetAddToExclusionList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetAddToExclusionList',
        soap_action => 'urn:DatasetAddToExclusionList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetAddToExclusionList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetBeginFailover {
    my ($self, $body, $header) = @_;
    die "DatasetBeginFailover must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetBeginFailover',
        soap_action => 'urn:DatasetBeginFailover',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetBeginFailover )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetBeginFailoverScriptTest {
    my ($self, $body, $header) = @_;
    die "DatasetBeginFailoverScriptTest must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetBeginFailoverScriptTest',
        soap_action => 'urn:DatasetBeginFailoverScriptTest',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetBeginFailoverScriptTest )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetChangeDrState {
    my ($self, $body, $header) = @_;
    die "DatasetChangeDrState must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetChangeDrState',
        soap_action => 'urn:DatasetChangeDrState',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetChangeDrState )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetComputeUsageMetric {
    my ($self, $body, $header) = @_;
    die "DatasetComputeUsageMetric must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetComputeUsageMetric',
        soap_action => 'urn:DatasetComputeUsageMetric',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetComputeUsageMetric )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetConformBegin {
    my ($self, $body, $header) = @_;
    die "DatasetConformBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetConformBegin',
        soap_action => 'urn:DatasetConformBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetConformBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetCreate {
    my ($self, $body, $header) = @_;
    die "DatasetCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetCreate',
        soap_action => 'urn:DatasetCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetDestroy {
    my ($self, $body, $header) = @_;
    die "DatasetDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetDestroy',
        soap_action => 'urn:DatasetDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetDynamicReferenceListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetDynamicReferenceListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetDynamicReferenceListInfoIterEnd',
        soap_action => 'urn:DatasetDynamicReferenceListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetDynamicReferenceListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetDynamicReferenceListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetDynamicReferenceListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetDynamicReferenceListInfoIterNext',
        soap_action => 'urn:DatasetDynamicReferenceListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetDynamicReferenceListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetDynamicReferenceListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetDynamicReferenceListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetDynamicReferenceListInfoIterStart',
        soap_action => 'urn:DatasetDynamicReferenceListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetDynamicReferenceListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetEditBegin {
    my ($self, $body, $header) = @_;
    die "DatasetEditBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetEditBegin',
        soap_action => 'urn:DatasetEditBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetEditBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetEditCommit {
    my ($self, $body, $header) = @_;
    die "DatasetEditCommit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetEditCommit',
        soap_action => 'urn:DatasetEditCommit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetEditCommit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetEditRollback {
    my ($self, $body, $header) = @_;
    die "DatasetEditRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetEditRollback',
        soap_action => 'urn:DatasetEditRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetEditRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetExclusionListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetExclusionListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetExclusionListInfoIterEnd',
        soap_action => 'urn:DatasetExclusionListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetExclusionListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetExclusionListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetExclusionListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetExclusionListInfoIterNext',
        soap_action => 'urn:DatasetExclusionListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetExclusionListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetExclusionListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetExclusionListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetExclusionListInfoIterStart',
        soap_action => 'urn:DatasetExclusionListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetExclusionListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetIoMetricListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetIoMetricListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetIoMetricListInfoIterEnd',
        soap_action => 'urn:DatasetIoMetricListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetIoMetricListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetIoMetricListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetIoMetricListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetIoMetricListInfoIterNext',
        soap_action => 'urn:DatasetIoMetricListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetIoMetricListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetIoMetricListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetIoMetricListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetIoMetricListInfoIterStart',
        soap_action => 'urn:DatasetIoMetricListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetIoMetricListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetListInfoIterEnd',
        soap_action => 'urn:DatasetListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetListInfoIterNext',
        soap_action => 'urn:DatasetListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetListInfoIterStart',
        soap_action => 'urn:DatasetListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberDedupeAbort {
    my ($self, $body, $header) = @_;
    die "DatasetMemberDedupeAbort must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberDedupeAbort',
        soap_action => 'urn:DatasetMemberDedupeAbort',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberDedupeAbort )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberDedupeStart {
    my ($self, $body, $header) = @_;
    die "DatasetMemberDedupeStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberDedupeStart',
        soap_action => 'urn:DatasetMemberDedupeStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberDedupeStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberDeleteSnapshots {
    my ($self, $body, $header) = @_;
    die "DatasetMemberDeleteSnapshots must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberDeleteSnapshots',
        soap_action => 'urn:DatasetMemberDeleteSnapshots',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberDeleteSnapshots )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetMemberListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberListInfoIterEnd',
        soap_action => 'urn:DatasetMemberListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetMemberListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberListInfoIterNext',
        soap_action => 'urn:DatasetMemberListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetMemberListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberListInfoIterStart',
        soap_action => 'urn:DatasetMemberListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMemberUndedupeStart {
    my ($self, $body, $header) = @_;
    die "DatasetMemberUndedupeStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMemberUndedupeStart',
        soap_action => 'urn:DatasetMemberUndedupeStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMemberUndedupeStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMissingMemberListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetMissingMemberListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMissingMemberListInfoIterEnd',
        soap_action => 'urn:DatasetMissingMemberListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMissingMemberListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMissingMemberListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetMissingMemberListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMissingMemberListInfoIterNext',
        soap_action => 'urn:DatasetMissingMemberListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMissingMemberListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetMissingMemberListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetMissingMemberListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetMissingMemberListInfoIterStart',
        soap_action => 'urn:DatasetMissingMemberListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetMissingMemberListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetModify {
    my ($self, $body, $header) = @_;
    die "DatasetModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetModify',
        soap_action => 'urn:DatasetModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetModifyNode {
    my ($self, $body, $header) = @_;
    die "DatasetModifyNode must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetModifyNode',
        soap_action => 'urn:DatasetModifyNode',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetModifyNode )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetProvisionMember {
    my ($self, $body, $header) = @_;
    die "DatasetProvisionMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetProvisionMember',
        soap_action => 'urn:DatasetProvisionMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetProvisionMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetRemoveFromExclusionList {
    my ($self, $body, $header) = @_;
    die "DatasetRemoveFromExclusionList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetRemoveFromExclusionList',
        soap_action => 'urn:DatasetRemoveFromExclusionList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetRemoveFromExclusionList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetRemoveMember {
    my ($self, $body, $header) = @_;
    die "DatasetRemoveMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetRemoveMember',
        soap_action => 'urn:DatasetRemoveMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetRemoveMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetRemoveMemberByDynamicReference {
    my ($self, $body, $header) = @_;
    die "DatasetRemoveMemberByDynamicReference must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetRemoveMemberByDynamicReference',
        soap_action => 'urn:DatasetRemoveMemberByDynamicReference',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetRemoveMemberByDynamicReference )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetRemoveResourcepool {
    my ($self, $body, $header) = @_;
    die "DatasetRemoveResourcepool must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetRemoveResourcepool',
        soap_action => 'urn:DatasetRemoveResourcepool',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetRemoveResourcepool )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetReplacePrimaryMembers {
    my ($self, $body, $header) = @_;
    die "DatasetReplacePrimaryMembers must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetReplacePrimaryMembers',
        soap_action => 'urn:DatasetReplacePrimaryMembers',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetReplacePrimaryMembers )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetResizeMember {
    my ($self, $body, $header) = @_;
    die "DatasetResizeMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetResizeMember',
        soap_action => 'urn:DatasetResizeMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetResizeMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetSet {
    my ($self, $body, $header) = @_;
    die "DatasetSet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetSet',
        soap_action => 'urn:DatasetSet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetSet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetSetStorageset {
    my ($self, $body, $header) = @_;
    die "DatasetSetStorageset must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetSetStorageset',
        soap_action => 'urn:DatasetSetStorageset',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetSetStorageset )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetSpaceMetricListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DatasetSpaceMetricListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetSpaceMetricListInfoIterEnd',
        soap_action => 'urn:DatasetSpaceMetricListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetSpaceMetricListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetSpaceMetricListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DatasetSpaceMetricListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetSpaceMetricListInfoIterNext',
        soap_action => 'urn:DatasetSpaceMetricListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetSpaceMetricListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetSpaceMetricListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DatasetSpaceMetricListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetSpaceMetricListInfoIterStart',
        soap_action => 'urn:DatasetSpaceMetricListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetSpaceMetricListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetUpdateDrStatus {
    my ($self, $body, $header) = @_;
    die "DatasetUpdateDrStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetUpdateDrStatus',
        soap_action => 'urn:DatasetUpdateDrStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetUpdateDrStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DatasetUpdateProtectionStatus {
    my ($self, $body, $header) = @_;
    die "DatasetUpdateProtectionStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DatasetUpdateProtectionStatus',
        soap_action => 'urn:DatasetUpdateProtectionStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DatasetUpdateProtectionStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmAbout {
    my ($self, $body, $header) = @_;
    die "DfmAbout must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmAbout',
        soap_action => 'urn:DfmAbout',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmAbout )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupScheduleDisable {
    my ($self, $body, $header) = @_;
    die "DfmBackupScheduleDisable must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupScheduleDisable',
        soap_action => 'urn:DfmBackupScheduleDisable',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupScheduleDisable )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupScheduleEnable {
    my ($self, $body, $header) = @_;
    die "DfmBackupScheduleEnable must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupScheduleEnable',
        soap_action => 'urn:DfmBackupScheduleEnable',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupScheduleEnable )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupScheduleGet {
    my ($self, $body, $header) = @_;
    die "DfmBackupScheduleGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupScheduleGet',
        soap_action => 'urn:DfmBackupScheduleGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupScheduleGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupScheduleSet {
    my ($self, $body, $header) = @_;
    die "DfmBackupScheduleSet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupScheduleSet',
        soap_action => 'urn:DfmBackupScheduleSet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupScheduleSet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupStart {
    my ($self, $body, $header) = @_;
    die "DfmBackupStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupStart',
        soap_action => 'urn:DfmBackupStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmBackupStatus {
    my ($self, $body, $header) = @_;
    die "DfmBackupStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmBackupStatus',
        soap_action => 'urn:DfmBackupStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmBackupStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmGetApiStatistics {
    my ($self, $body, $header) = @_;
    die "DfmGetApiStatistics must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmGetApiStatistics',
        soap_action => 'urn:DfmGetApiStatistics',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmGetApiStatistics )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmGetResourcePropertyValues {
    my ($self, $body, $header) = @_;
    die "DfmGetResourcePropertyValues must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmGetResourcePropertyValues',
        soap_action => 'urn:DfmGetResourcePropertyValues',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmGetResourcePropertyValues )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmMonitorTimestampList {
    my ($self, $body, $header) = @_;
    die "DfmMonitorTimestampList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmMonitorTimestampList',
        soap_action => 'urn:DfmMonitorTimestampList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmMonitorTimestampList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmNetworkAdd {
    my ($self, $body, $header) = @_;
    die "DfmNetworkAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmNetworkAdd',
        soap_action => 'urn:DfmNetworkAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmNetworkAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmNetworkDelete {
    my ($self, $body, $header) = @_;
    die "DfmNetworkDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmNetworkDelete',
        soap_action => 'urn:DfmNetworkDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmNetworkDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmNetworkListInfo {
    my ($self, $body, $header) = @_;
    die "DfmNetworkListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmNetworkListInfo',
        soap_action => 'urn:DfmNetworkListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmNetworkListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmNetworkModify {
    my ($self, $body, $header) = @_;
    die "DfmNetworkModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmNetworkModify',
        soap_action => 'urn:DfmNetworkModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmNetworkModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmObjectRefresh {
    my ($self, $body, $header) = @_;
    die "DfmObjectRefresh must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmObjectRefresh',
        soap_action => 'urn:DfmObjectRefresh',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmObjectRefresh )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmObjectsGetStatus {
    my ($self, $body, $header) = @_;
    die "DfmObjectsGetStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmObjectsGetStatus',
        soap_action => 'urn:DfmObjectsGetStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmObjectsGetStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmRelatedObjectsListInfo {
    my ($self, $body, $header) = @_;
    die "DfmRelatedObjectsListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmRelatedObjectsListInfo',
        soap_action => 'urn:DfmRelatedObjectsListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmRelatedObjectsListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleContentGet {
    my ($self, $body, $header) = @_;
    die "DfmScheduleContentGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleContentGet',
        soap_action => 'urn:DfmScheduleContentGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleContentGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleCreate {
    my ($self, $body, $header) = @_;
    die "DfmScheduleCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleCreate',
        soap_action => 'urn:DfmScheduleCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleDailyAdd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleDailyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleDailyAdd',
        soap_action => 'urn:DfmScheduleDailyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleDailyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleDailyDelete {
    my ($self, $body, $header) = @_;
    die "DfmScheduleDailyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleDailyDelete',
        soap_action => 'urn:DfmScheduleDailyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleDailyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleDailyModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleDailyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleDailyModify',
        soap_action => 'urn:DfmScheduleDailyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleDailyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleDependency {
    my ($self, $body, $header) = @_;
    die "DfmScheduleDependency must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleDependency',
        soap_action => 'urn:DfmScheduleDependency',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleDependency )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleDestroy {
    my ($self, $body, $header) = @_;
    die "DfmScheduleDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleDestroy',
        soap_action => 'urn:DfmScheduleDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleHourlyAdd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleHourlyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleHourlyAdd',
        soap_action => 'urn:DfmScheduleHourlyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleHourlyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleHourlyDelete {
    my ($self, $body, $header) = @_;
    die "DfmScheduleHourlyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleHourlyDelete',
        soap_action => 'urn:DfmScheduleHourlyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleHourlyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleHourlyModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleHourlyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleHourlyModify',
        soap_action => 'urn:DfmScheduleHourlyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleHourlyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleList {
    my ($self, $body, $header) = @_;
    die "DfmScheduleList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleList',
        soap_action => 'urn:DfmScheduleList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleListInfoIterEnd',
        soap_action => 'urn:DfmScheduleListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DfmScheduleListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleListInfoIterNext',
        soap_action => 'urn:DfmScheduleListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DfmScheduleListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleListInfoIterStart',
        soap_action => 'urn:DfmScheduleListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleModify',
        soap_action => 'urn:DfmScheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleMonthlyAdd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleMonthlyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleMonthlyAdd',
        soap_action => 'urn:DfmScheduleMonthlyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleMonthlyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleMonthlyDelete {
    my ($self, $body, $header) = @_;
    die "DfmScheduleMonthlyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleMonthlyDelete',
        soap_action => 'urn:DfmScheduleMonthlyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleMonthlyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleMonthlyModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleMonthlyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleMonthlyModify',
        soap_action => 'urn:DfmScheduleMonthlyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleMonthlyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleMonthlySubscheduleSet {
    my ($self, $body, $header) = @_;
    die "DfmScheduleMonthlySubscheduleSet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleMonthlySubscheduleSet',
        soap_action => 'urn:DfmScheduleMonthlySubscheduleSet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleMonthlySubscheduleSet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleMonthlySubscheduleUnset {
    my ($self, $body, $header) = @_;
    die "DfmScheduleMonthlySubscheduleUnset must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleMonthlySubscheduleUnset',
        soap_action => 'urn:DfmScheduleMonthlySubscheduleUnset',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleMonthlySubscheduleUnset )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleRename {
    my ($self, $body, $header) = @_;
    die "DfmScheduleRename must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleRename',
        soap_action => 'urn:DfmScheduleRename',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleRename )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklyAdd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklyAdd',
        soap_action => 'urn:DfmScheduleWeeklyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklyDelete {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklyDelete',
        soap_action => 'urn:DfmScheduleWeeklyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklyModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklyModify',
        soap_action => 'urn:DfmScheduleWeeklyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklySubscheduleAdd {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklySubscheduleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklySubscheduleAdd',
        soap_action => 'urn:DfmScheduleWeeklySubscheduleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklySubscheduleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklySubscheduleDelete {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklySubscheduleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklySubscheduleDelete',
        soap_action => 'urn:DfmScheduleWeeklySubscheduleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklySubscheduleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmScheduleWeeklySubscheduleModify {
    my ($self, $body, $header) = @_;
    die "DfmScheduleWeeklySubscheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmScheduleWeeklySubscheduleModify',
        soap_action => 'urn:DfmScheduleWeeklySubscheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmScheduleWeeklySubscheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmServerListDiagnosticInfo {
    my ($self, $body, $header) = @_;
    die "DfmServerListDiagnosticInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmServerListDiagnosticInfo',
        soap_action => 'urn:DfmServerListDiagnosticInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmServerListDiagnosticInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmSnmpSettingAdd {
    my ($self, $body, $header) = @_;
    die "DfmSnmpSettingAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmSnmpSettingAdd',
        soap_action => 'urn:DfmSnmpSettingAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmSnmpSettingAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmSnmpSettingDelete {
    my ($self, $body, $header) = @_;
    die "DfmSnmpSettingDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmSnmpSettingDelete',
        soap_action => 'urn:DfmSnmpSettingDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmSnmpSettingDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmSnmpSettingModify {
    my ($self, $body, $header) = @_;
    die "DfmSnmpSettingModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmSnmpSettingModify',
        soap_action => 'urn:DfmSnmpSettingModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmSnmpSettingModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmSnmpSettingsListInfo {
    my ($self, $body, $header) = @_;
    die "DfmSnmpSettingsListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmSnmpSettingsListInfo',
        soap_action => 'urn:DfmSnmpSettingsListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmSnmpSettingsListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DfmUserPrivGet {
    my ($self, $body, $header) = @_;
    die "DfmUserPrivGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DfmUserPrivGet',
        soap_action => 'urn:DfmUserPrivGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DfmUserPrivGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DiskListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DiskListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DiskListInfoIterEnd',
        soap_action => 'urn:DiskListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DiskListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DiskListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DiskListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DiskListInfoIterNext',
        soap_action => 'urn:DiskListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DiskListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DiskListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DiskListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DiskListInfoIterStart',
        soap_action => 'urn:DiskListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DiskListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentConfigure {
    my ($self, $body, $header) = @_;
    die "DpAgentConfigure must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentConfigure',
        soap_action => 'urn:DpAgentConfigure',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentConfigure )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentDiscover {
    my ($self, $body, $header) = @_;
    die "DpAgentDiscover must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentDiscover',
        soap_action => 'urn:DpAgentDiscover',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentDiscover )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpAgentListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentListInfoIterEnd',
        soap_action => 'urn:DpAgentListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpAgentListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentListInfoIterNext',
        soap_action => 'urn:DpAgentListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpAgentListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentListInfoIterStart',
        soap_action => 'urn:DpAgentListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentListUpgradeCandidates {
    my ($self, $body, $header) = @_;
    die "DpAgentListUpgradeCandidates must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentListUpgradeCandidates',
        soap_action => 'urn:DpAgentListUpgradeCandidates',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentListUpgradeCandidates )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentModify {
    my ($self, $body, $header) = @_;
    die "DpAgentModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentModify',
        soap_action => 'urn:DpAgentModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentPackageAdd {
    my ($self, $body, $header) = @_;
    die "DpAgentPackageAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentPackageAdd',
        soap_action => 'urn:DpAgentPackageAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentPackageAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentPackageDelete {
    my ($self, $body, $header) = @_;
    die "DpAgentPackageDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentPackageDelete',
        soap_action => 'urn:DpAgentPackageDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentPackageDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentPackageList {
    my ($self, $body, $header) = @_;
    die "DpAgentPackageList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentPackageList',
        soap_action => 'urn:DpAgentPackageList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentPackageList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentRegister {
    my ($self, $body, $header) = @_;
    die "DpAgentRegister must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentRegister',
        soap_action => 'urn:DpAgentRegister',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentRegister )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentStoragesystemListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpAgentStoragesystemListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentStoragesystemListInfoIterEnd',
        soap_action => 'urn:DpAgentStoragesystemListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentStoragesystemListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentStoragesystemListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpAgentStoragesystemListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentStoragesystemListInfoIterNext',
        soap_action => 'urn:DpAgentStoragesystemListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentStoragesystemListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentStoragesystemListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpAgentStoragesystemListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentStoragesystemListInfoIterStart',
        soap_action => 'urn:DpAgentStoragesystemListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentStoragesystemListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentUnregister {
    my ($self, $body, $header) = @_;
    die "DpAgentUnregister must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentUnregister',
        soap_action => 'urn:DpAgentUnregister',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentUnregister )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpAgentUpgrade {
    my ($self, $body, $header) = @_;
    die "DpAgentUpgrade must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpAgentUpgrade',
        soap_action => 'urn:DpAgentUpgrade',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpAgentUpgrade )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupContentListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpBackupContentListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupContentListIterEnd',
        soap_action => 'urn:DpBackupContentListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupContentListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupContentListIterNext {
    my ($self, $body, $header) = @_;
    die "DpBackupContentListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupContentListIterNext',
        soap_action => 'urn:DpBackupContentListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupContentListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupContentListIterStart {
    my ($self, $body, $header) = @_;
    die "DpBackupContentListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupContentListIterStart',
        soap_action => 'urn:DpBackupContentListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupContentListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupGetLocation {
    my ($self, $body, $header) = @_;
    die "DpBackupGetLocation must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupGetLocation',
        soap_action => 'urn:DpBackupGetLocation',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupGetLocation )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpBackupListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupListIterEnd',
        soap_action => 'urn:DpBackupListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupListIterNext {
    my ($self, $body, $header) = @_;
    die "DpBackupListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupListIterNext',
        soap_action => 'urn:DpBackupListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupListIterStart {
    my ($self, $body, $header) = @_;
    die "DpBackupListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupListIterStart',
        soap_action => 'urn:DpBackupListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupStart {
    my ($self, $body, $header) = @_;
    die "DpBackupStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupStart',
        soap_action => 'urn:DpBackupStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionCreate {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionCreate',
        soap_action => 'urn:DpBackupVersionCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionDelete {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionDelete',
        soap_action => 'urn:DpBackupVersionDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionListIterEnd',
        soap_action => 'urn:DpBackupVersionListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionListIterNext {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionListIterNext',
        soap_action => 'urn:DpBackupVersionListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionListIterStart {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionListIterStart',
        soap_action => 'urn:DpBackupVersionListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpBackupVersionModify {
    my ($self, $body, $header) = @_;
    die "DpBackupVersionModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpBackupVersionModify',
        soap_action => 'urn:DpBackupVersionModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpBackupVersionModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpDashboardGetDrDatasetCounts {
    my ($self, $body, $header) = @_;
    die "DpDashboardGetDrDatasetCounts must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpDashboardGetDrDatasetCounts',
        soap_action => 'urn:DpDashboardGetDrDatasetCounts',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpDashboardGetDrDatasetCounts )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpDashboardGetLaggedDatasets {
    my ($self, $body, $header) = @_;
    die "DpDashboardGetLaggedDatasets must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpDashboardGetLaggedDatasets',
        soap_action => 'urn:DpDashboardGetLaggedDatasets',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpDashboardGetLaggedDatasets )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpDashboardGetLaggedRelationships {
    my ($self, $body, $header) = @_;
    die "DpDashboardGetLaggedRelationships must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpDashboardGetLaggedRelationships',
        soap_action => 'urn:DpDashboardGetLaggedRelationships',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpDashboardGetLaggedRelationships )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpDashboardGetProtectedDataCounts {
    my ($self, $body, $header) = @_;
    die "DpDashboardGetProtectedDataCounts must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpDashboardGetProtectedDataCounts',
        soap_action => 'urn:DpDashboardGetProtectedDataCounts',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpDashboardGetProtectedDataCounts )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpDashboardGetProtectedDataCounts2 {
    my ($self, $body, $header) = @_;
    die "DpDashboardGetProtectedDataCounts2 must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpDashboardGetProtectedDataCounts2',
        soap_action => 'urn:DpDashboardGetProtectedDataCounts2',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpDashboardGetProtectedDataCounts2 )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpGetDatasetBackupJobsData {
    my ($self, $body, $header) = @_;
    die "DpGetDatasetBackupJobsData must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpGetDatasetBackupJobsData',
        soap_action => 'urn:DpGetDatasetBackupJobsData',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpGetDatasetBackupJobsData )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobAbort {
    my ($self, $body, $header) = @_;
    die "DpJobAbort must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobAbort',
        soap_action => 'urn:DpJobAbort',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobAbort )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpJobListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobListIterEnd',
        soap_action => 'urn:DpJobListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobListIterNext {
    my ($self, $body, $header) = @_;
    die "DpJobListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobListIterNext',
        soap_action => 'urn:DpJobListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobListIterStart {
    my ($self, $body, $header) = @_;
    die "DpJobListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobListIterStart',
        soap_action => 'urn:DpJobListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobProgressEventListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpJobProgressEventListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobProgressEventListIterEnd',
        soap_action => 'urn:DpJobProgressEventListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobProgressEventListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobProgressEventListIterNext {
    my ($self, $body, $header) = @_;
    die "DpJobProgressEventListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobProgressEventListIterNext',
        soap_action => 'urn:DpJobProgressEventListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobProgressEventListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobProgressEventListIterStart {
    my ($self, $body, $header) = @_;
    die "DpJobProgressEventListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobProgressEventListIterStart',
        soap_action => 'urn:DpJobProgressEventListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobProgressEventListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobPurge {
    my ($self, $body, $header) = @_;
    die "DpJobPurge must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobPurge',
        soap_action => 'urn:DpJobPurge',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobPurge )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobScheduleGetLastChanged {
    my ($self, $body, $header) = @_;
    die "DpJobScheduleGetLastChanged must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobScheduleGetLastChanged',
        soap_action => 'urn:DpJobScheduleGetLastChanged',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobScheduleGetLastChanged )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobScheduleListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpJobScheduleListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobScheduleListIterEnd',
        soap_action => 'urn:DpJobScheduleListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobScheduleListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobScheduleListIterNext {
    my ($self, $body, $header) = @_;
    die "DpJobScheduleListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobScheduleListIterNext',
        soap_action => 'urn:DpJobScheduleListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobScheduleListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpJobScheduleListIterStart {
    my ($self, $body, $header) = @_;
    die "DpJobScheduleListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpJobScheduleListIterStart',
        soap_action => 'urn:DpJobScheduleListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpJobScheduleListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationListInfoIterEnd',
        soap_action => 'urn:DpOssvApplicationListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationListInfoIterNext',
        soap_action => 'urn:DpOssvApplicationListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationListInfoIterStart',
        soap_action => 'urn:DpOssvApplicationListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationRestoreDestinationListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationRestoreDestinationListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationRestoreDestinationListInfoIterEnd',
        soap_action => 'urn:DpOssvApplicationRestoreDestinationListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationRestoreDestinationListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationRestoreDestinationListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationRestoreDestinationListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationRestoreDestinationListInfoIterNext',
        soap_action => 'urn:DpOssvApplicationRestoreDestinationListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationRestoreDestinationListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvApplicationRestoreDestinationListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpOssvApplicationRestoreDestinationListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvApplicationRestoreDestinationListInfoIterStart',
        soap_action => 'urn:DpOssvApplicationRestoreDestinationListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvApplicationRestoreDestinationListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryAdd {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryAdd',
        soap_action => 'urn:DpOssvDirectoryAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryBrowseIterEnd {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryBrowseIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryBrowseIterEnd',
        soap_action => 'urn:DpOssvDirectoryBrowseIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryBrowseIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryBrowseIterNext {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryBrowseIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryBrowseIterNext',
        soap_action => 'urn:DpOssvDirectoryBrowseIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryBrowseIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryBrowseIterStart {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryBrowseIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryBrowseIterStart',
        soap_action => 'urn:DpOssvDirectoryBrowseIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryBrowseIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryDiscoveredIterEnd {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryDiscoveredIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryDiscoveredIterEnd',
        soap_action => 'urn:DpOssvDirectoryDiscoveredIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryDiscoveredIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryDiscoveredIterNext {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryDiscoveredIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryDiscoveredIterNext',
        soap_action => 'urn:DpOssvDirectoryDiscoveredIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryDiscoveredIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryDiscoveredIterStart {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryDiscoveredIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryDiscoveredIterStart',
        soap_action => 'urn:DpOssvDirectoryDiscoveredIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryDiscoveredIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryModify {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryModify',
        soap_action => 'urn:DpOssvDirectoryModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryRootsIterEnd {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryRootsIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryRootsIterEnd',
        soap_action => 'urn:DpOssvDirectoryRootsIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryRootsIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryRootsIterNext {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryRootsIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryRootsIterNext',
        soap_action => 'urn:DpOssvDirectoryRootsIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryRootsIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpOssvDirectoryRootsIterStart {
    my ($self, $body, $header) = @_;
    die "DpOssvDirectoryRootsIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpOssvDirectoryRootsIterStart',
        soap_action => 'urn:DpOssvDirectoryRootsIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpOssvDirectoryRootsIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyCopy {
    my ($self, $body, $header) = @_;
    die "DpPolicyCopy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyCopy',
        soap_action => 'urn:DpPolicyCopy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyCopy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyDestroy {
    my ($self, $body, $header) = @_;
    die "DpPolicyDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyDestroy',
        soap_action => 'urn:DpPolicyDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyEditBegin {
    my ($self, $body, $header) = @_;
    die "DpPolicyEditBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyEditBegin',
        soap_action => 'urn:DpPolicyEditBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyEditBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyEditCommit {
    my ($self, $body, $header) = @_;
    die "DpPolicyEditCommit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyEditCommit',
        soap_action => 'urn:DpPolicyEditCommit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyEditCommit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyEditRollback {
    my ($self, $body, $header) = @_;
    die "DpPolicyEditRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyEditRollback',
        soap_action => 'urn:DpPolicyEditRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyEditRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyGetDefaultPropertyValues {
    my ($self, $body, $header) = @_;
    die "DpPolicyGetDefaultPropertyValues must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyGetDefaultPropertyValues',
        soap_action => 'urn:DpPolicyGetDefaultPropertyValues',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyGetDefaultPropertyValues )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyListIterEnd {
    my ($self, $body, $header) = @_;
    die "DpPolicyListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyListIterEnd',
        soap_action => 'urn:DpPolicyListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyListIterNext {
    my ($self, $body, $header) = @_;
    die "DpPolicyListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyListIterNext',
        soap_action => 'urn:DpPolicyListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyListIterStart {
    my ($self, $body, $header) = @_;
    die "DpPolicyListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyListIterStart',
        soap_action => 'urn:DpPolicyListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpPolicyModify {
    my ($self, $body, $header) = @_;
    die "DpPolicyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpPolicyModify',
        soap_action => 'urn:DpPolicyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpPolicyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRelationshipListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpRelationshipListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRelationshipListInfoIterEnd',
        soap_action => 'urn:DpRelationshipListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRelationshipListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRelationshipListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpRelationshipListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRelationshipListInfoIterNext',
        soap_action => 'urn:DpRelationshipListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRelationshipListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRelationshipListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpRelationshipListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRelationshipListInfoIterStart',
        soap_action => 'urn:DpRelationshipListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRelationshipListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRelationshipModify {
    my ($self, $body, $header) = @_;
    die "DpRelationshipModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRelationshipModify',
        soap_action => 'urn:DpRelationshipModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRelationshipModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRestoreToNewPath {
    my ($self, $body, $header) = @_;
    die "DpRestoreToNewPath must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRestoreToNewPath',
        soap_action => 'urn:DpRestoreToNewPath',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRestoreToNewPath )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRestoreToPrimary {
    my ($self, $body, $header) = @_;
    die "DpRestoreToPrimary must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRestoreToPrimary',
        soap_action => 'urn:DpRestoreToPrimary',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRestoreToPrimary )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpRestoreViStart {
    my ($self, $body, $header) = @_;
    die "DpRestoreViStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpRestoreViStart',
        soap_action => 'urn:DpRestoreViStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpRestoreViStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleContentGet {
    my ($self, $body, $header) = @_;
    die "DpScheduleContentGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleContentGet',
        soap_action => 'urn:DpScheduleContentGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleContentGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleCreate {
    my ($self, $body, $header) = @_;
    die "DpScheduleCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleCreate',
        soap_action => 'urn:DpScheduleCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleDailyAdd {
    my ($self, $body, $header) = @_;
    die "DpScheduleDailyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleDailyAdd',
        soap_action => 'urn:DpScheduleDailyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleDailyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleDailyDelete {
    my ($self, $body, $header) = @_;
    die "DpScheduleDailyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleDailyDelete',
        soap_action => 'urn:DpScheduleDailyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleDailyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleDailyModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleDailyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleDailyModify',
        soap_action => 'urn:DpScheduleDailyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleDailyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleDependency {
    my ($self, $body, $header) = @_;
    die "DpScheduleDependency must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleDependency',
        soap_action => 'urn:DpScheduleDependency',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleDependency )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleDestroy {
    my ($self, $body, $header) = @_;
    die "DpScheduleDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleDestroy',
        soap_action => 'urn:DpScheduleDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleHourlyAdd {
    my ($self, $body, $header) = @_;
    die "DpScheduleHourlyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleHourlyAdd',
        soap_action => 'urn:DpScheduleHourlyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleHourlyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleHourlyDelete {
    my ($self, $body, $header) = @_;
    die "DpScheduleHourlyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleHourlyDelete',
        soap_action => 'urn:DpScheduleHourlyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleHourlyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleHourlyModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleHourlyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleHourlyModify',
        soap_action => 'urn:DpScheduleHourlyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleHourlyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleList {
    my ($self, $body, $header) = @_;
    die "DpScheduleList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleList',
        soap_action => 'urn:DpScheduleList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpScheduleListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleListInfoIterEnd',
        soap_action => 'urn:DpScheduleListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpScheduleListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleListInfoIterNext',
        soap_action => 'urn:DpScheduleListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpScheduleListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleListInfoIterStart',
        soap_action => 'urn:DpScheduleListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleModify',
        soap_action => 'urn:DpScheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleMonthlyAdd {
    my ($self, $body, $header) = @_;
    die "DpScheduleMonthlyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleMonthlyAdd',
        soap_action => 'urn:DpScheduleMonthlyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleMonthlyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleMonthlyDelete {
    my ($self, $body, $header) = @_;
    die "DpScheduleMonthlyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleMonthlyDelete',
        soap_action => 'urn:DpScheduleMonthlyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleMonthlyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleMonthlyModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleMonthlyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleMonthlyModify',
        soap_action => 'urn:DpScheduleMonthlyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleMonthlyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleMonthlySubscheduleSet {
    my ($self, $body, $header) = @_;
    die "DpScheduleMonthlySubscheduleSet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleMonthlySubscheduleSet',
        soap_action => 'urn:DpScheduleMonthlySubscheduleSet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleMonthlySubscheduleSet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleMonthlySubscheduleUnset {
    my ($self, $body, $header) = @_;
    die "DpScheduleMonthlySubscheduleUnset must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleMonthlySubscheduleUnset',
        soap_action => 'urn:DpScheduleMonthlySubscheduleUnset',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleMonthlySubscheduleUnset )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleRename {
    my ($self, $body, $header) = @_;
    die "DpScheduleRename must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleRename',
        soap_action => 'urn:DpScheduleRename',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleRename )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklyAdd {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklyAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklyAdd',
        soap_action => 'urn:DpScheduleWeeklyAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklyAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklyDelete {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklyDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklyDelete',
        soap_action => 'urn:DpScheduleWeeklyDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklyDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklyModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklyModify',
        soap_action => 'urn:DpScheduleWeeklyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklySubscheduleAdd {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklySubscheduleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklySubscheduleAdd',
        soap_action => 'urn:DpScheduleWeeklySubscheduleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklySubscheduleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklySubscheduleDelete {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklySubscheduleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklySubscheduleDelete',
        soap_action => 'urn:DpScheduleWeeklySubscheduleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklySubscheduleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpScheduleWeeklySubscheduleModify {
    my ($self, $body, $header) = @_;
    die "DpScheduleWeeklySubscheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpScheduleWeeklySubscheduleModify',
        soap_action => 'urn:DpScheduleWeeklySubscheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpScheduleWeeklySubscheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleCreate {
    my ($self, $body, $header) = @_;
    die "DpThrottleCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleCreate',
        soap_action => 'urn:DpThrottleCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleDependency {
    my ($self, $body, $header) = @_;
    die "DpThrottleDependency must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleDependency',
        soap_action => 'urn:DpThrottleDependency',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleDependency )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleDestroy {
    my ($self, $body, $header) = @_;
    die "DpThrottleDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleDestroy',
        soap_action => 'urn:DpThrottleDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleItemAdd {
    my ($self, $body, $header) = @_;
    die "DpThrottleItemAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleItemAdd',
        soap_action => 'urn:DpThrottleItemAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleItemAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleItemDelete {
    my ($self, $body, $header) = @_;
    die "DpThrottleItemDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleItemDelete',
        soap_action => 'urn:DpThrottleItemDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleItemDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "DpThrottleListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleListInfoIterEnd',
        soap_action => 'urn:DpThrottleListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "DpThrottleListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleListInfoIterNext',
        soap_action => 'urn:DpThrottleListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "DpThrottleListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleListInfoIterStart',
        soap_action => 'urn:DpThrottleListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleModify {
    my ($self, $body, $header) = @_;
    die "DpThrottleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleModify',
        soap_action => 'urn:DpThrottleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub DpThrottleRename {
    my ($self, $body, $header) = @_;
    die "DpThrottleRename must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'DpThrottleRename',
        soap_action => 'urn:DpThrottleRename',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::DpThrottleRename )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventAcknowledge {
    my ($self, $body, $header) = @_;
    die "EventAcknowledge must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventAcknowledge',
        soap_action => 'urn:EventAcknowledge',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventAcknowledge )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventDelete {
    my ($self, $body, $header) = @_;
    die "EventDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventDelete',
        soap_action => 'urn:EventDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventGenerate {
    my ($self, $body, $header) = @_;
    die "EventGenerate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventGenerate',
        soap_action => 'urn:EventGenerate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventGenerate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventListIterEnd {
    my ($self, $body, $header) = @_;
    die "EventListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventListIterEnd',
        soap_action => 'urn:EventListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventListIterNext {
    my ($self, $body, $header) = @_;
    die "EventListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventListIterNext',
        soap_action => 'urn:EventListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventListIterStart {
    my ($self, $body, $header) = @_;
    die "EventListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventListIterStart',
        soap_action => 'urn:EventListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventStatusChangeListIterEnd {
    my ($self, $body, $header) = @_;
    die "EventStatusChangeListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventStatusChangeListIterEnd',
        soap_action => 'urn:EventStatusChangeListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventStatusChangeListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventStatusChangeListIterNext {
    my ($self, $body, $header) = @_;
    die "EventStatusChangeListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventStatusChangeListIterNext',
        soap_action => 'urn:EventStatusChangeListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventStatusChangeListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventStatusChangeListIterStart {
    my ($self, $body, $header) = @_;
    die "EventStatusChangeListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventStatusChangeListIterStart',
        soap_action => 'urn:EventStatusChangeListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventStatusChangeListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassAddCustom {
    my ($self, $body, $header) = @_;
    die "EventclassAddCustom must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassAddCustom',
        soap_action => 'urn:EventclassAddCustom',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassAddCustom )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassDeleteCustom {
    my ($self, $body, $header) = @_;
    die "EventclassDeleteCustom must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassDeleteCustom',
        soap_action => 'urn:EventclassDeleteCustom',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassDeleteCustom )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassList {
    my ($self, $body, $header) = @_;
    die "EventclassList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassList',
        soap_action => 'urn:EventclassList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassListIterEnd {
    my ($self, $body, $header) = @_;
    die "EventclassListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassListIterEnd',
        soap_action => 'urn:EventclassListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassListIterNext {
    my ($self, $body, $header) = @_;
    die "EventclassListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassListIterNext',
        soap_action => 'urn:EventclassListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub EventclassListIterStart {
    my ($self, $body, $header) = @_;
    die "EventclassListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'EventclassListIterStart',
        soap_action => 'urn:EventclassListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::EventclassListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub FcpTargetListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "FcpTargetListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'FcpTargetListInfoIterEnd',
        soap_action => 'urn:FcpTargetListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::FcpTargetListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub FcpTargetListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "FcpTargetListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'FcpTargetListInfoIterNext',
        soap_action => 'urn:FcpTargetListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::FcpTargetListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub FcpTargetListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "FcpTargetListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'FcpTargetListInfoIterStart',
        soap_action => 'urn:FcpTargetListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::FcpTargetListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GraphDataListInfo {
    my ($self, $body, $header) = @_;
    die "GraphDataListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GraphDataListInfo',
        soap_action => 'urn:GraphDataListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GraphDataListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GraphListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "GraphListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GraphListInfoIterEnd',
        soap_action => 'urn:GraphListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GraphListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GraphListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "GraphListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GraphListInfoIterNext',
        soap_action => 'urn:GraphListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GraphListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GraphListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "GraphListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GraphListInfoIterStart',
        soap_action => 'urn:GraphListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GraphListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupAddMember {
    my ($self, $body, $header) = @_;
    die "GroupAddMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupAddMember',
        soap_action => 'urn:GroupAddMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupAddMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupCopy {
    my ($self, $body, $header) = @_;
    die "GroupCopy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupCopy',
        soap_action => 'urn:GroupCopy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupCopy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupCreate {
    my ($self, $body, $header) = @_;
    die "GroupCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupCreate',
        soap_action => 'urn:GroupCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupDeleteMember {
    my ($self, $body, $header) = @_;
    die "GroupDeleteMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupDeleteMember',
        soap_action => 'urn:GroupDeleteMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupDeleteMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupDestroy {
    my ($self, $body, $header) = @_;
    die "GroupDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupDestroy',
        soap_action => 'urn:GroupDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupGetOptions {
    my ($self, $body, $header) = @_;
    die "GroupGetOptions must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupGetOptions',
        soap_action => 'urn:GroupGetOptions',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupGetOptions )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupGetStatus {
    my ($self, $body, $header) = @_;
    die "GroupGetStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupGetStatus',
        soap_action => 'urn:GroupGetStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupGetStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupIsMemberOf {
    my ($self, $body, $header) = @_;
    die "GroupIsMemberOf must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupIsMemberOf',
        soap_action => 'urn:GroupIsMemberOf',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupIsMemberOf )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupListIterEnd {
    my ($self, $body, $header) = @_;
    die "GroupListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupListIterEnd',
        soap_action => 'urn:GroupListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupListIterNext {
    my ($self, $body, $header) = @_;
    die "GroupListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupListIterNext',
        soap_action => 'urn:GroupListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupListIterStart {
    my ($self, $body, $header) = @_;
    die "GroupListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupListIterStart',
        soap_action => 'urn:GroupListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupMemberListIterEnd {
    my ($self, $body, $header) = @_;
    die "GroupMemberListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupMemberListIterEnd',
        soap_action => 'urn:GroupMemberListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupMemberListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupMemberListIterNext {
    my ($self, $body, $header) = @_;
    die "GroupMemberListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupMemberListIterNext',
        soap_action => 'urn:GroupMemberListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupMemberListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupMemberListIterStart {
    my ($self, $body, $header) = @_;
    die "GroupMemberListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupMemberListIterStart',
        soap_action => 'urn:GroupMemberListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupMemberListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupMove {
    my ($self, $body, $header) = @_;
    die "GroupMove must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupMove',
        soap_action => 'urn:GroupMove',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupMove )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupRename {
    my ($self, $body, $header) = @_;
    die "GroupRename must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupRename',
        soap_action => 'urn:GroupRename',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupRename )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub GroupSetOptions {
    my ($self, $body, $header) = @_;
    die "GroupSetOptions must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'GroupSetOptions',
        soap_action => 'urn:GroupSetOptions',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::GroupSetOptions )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostAdd {
    my ($self, $body, $header) = @_;
    die "HostAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostAdd',
        soap_action => 'urn:HostAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostAddLicense {
    my ($self, $body, $header) = @_;
    die "HostAddLicense must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostAddLicense',
        soap_action => 'urn:HostAddLicense',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostAddLicense )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostAddOssv {
    my ($self, $body, $header) = @_;
    die "HostAddOssv must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostAddOssv',
        soap_action => 'urn:HostAddOssv',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostAddOssv )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostAgentOssvServiceStart {
    my ($self, $body, $header) = @_;
    die "HostAgentOssvServiceStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostAgentOssvServiceStart',
        soap_action => 'urn:HostAgentOssvServiceStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostAgentOssvServiceStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostAgentOssvServiceStop {
    my ($self, $body, $header) = @_;
    die "HostAgentOssvServiceStop must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostAgentOssvServiceStop',
        soap_action => 'urn:HostAgentOssvServiceStop',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostAgentOssvServiceStop )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostCapabilityListIterEnd {
    my ($self, $body, $header) = @_;
    die "HostCapabilityListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostCapabilityListIterEnd',
        soap_action => 'urn:HostCapabilityListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostCapabilityListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostCapabilityListIterNext {
    my ($self, $body, $header) = @_;
    die "HostCapabilityListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostCapabilityListIterNext',
        soap_action => 'urn:HostCapabilityListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostCapabilityListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostCapabilityListIterStart {
    my ($self, $body, $header) = @_;
    die "HostCapabilityListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostCapabilityListIterStart',
        soap_action => 'urn:HostCapabilityListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostCapabilityListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostCreateNdmpuser {
    my ($self, $body, $header) = @_;
    die "HostCreateNdmpuser must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostCreateNdmpuser',
        soap_action => 'urn:HostCreateNdmpuser',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostCreateNdmpuser )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDelete {
    my ($self, $body, $header) = @_;
    die "HostDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDelete',
        soap_action => 'urn:HostDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserAdd {
    my ($self, $body, $header) = @_;
    die "HostDomainuserAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserAdd',
        soap_action => 'urn:HostDomainuserAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserListIterEnd {
    my ($self, $body, $header) = @_;
    die "HostDomainuserListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserListIterEnd',
        soap_action => 'urn:HostDomainuserListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserListIterNext {
    my ($self, $body, $header) = @_;
    die "HostDomainuserListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserListIterNext',
        soap_action => 'urn:HostDomainuserListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserListIterStart {
    my ($self, $body, $header) = @_;
    die "HostDomainuserListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserListIterStart',
        soap_action => 'urn:HostDomainuserListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserPush {
    my ($self, $body, $header) = @_;
    die "HostDomainuserPush must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserPush',
        soap_action => 'urn:HostDomainuserPush',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserPush )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostDomainuserRemove {
    my ($self, $body, $header) = @_;
    die "HostDomainuserRemove must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostDomainuserRemove',
        soap_action => 'urn:HostDomainuserRemove',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostDomainuserRemove )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostGetDefaults {
    my ($self, $body, $header) = @_;
    die "HostGetDefaults must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostGetDefaults',
        soap_action => 'urn:HostGetDefaults',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostGetDefaults )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "HostListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostListInfoIterEnd',
        soap_action => 'urn:HostListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "HostListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostListInfoIterNext',
        soap_action => 'urn:HostListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "HostListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostListInfoIterStart',
        soap_action => 'urn:HostListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostModify {
    my ($self, $body, $header) = @_;
    die "HostModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostModify',
        soap_action => 'urn:HostModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostModifyAgentCredentials {
    my ($self, $body, $header) = @_;
    die "HostModifyAgentCredentials must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostModifyAgentCredentials',
        soap_action => 'urn:HostModifyAgentCredentials',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostModifyAgentCredentials )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleCreate {
    my ($self, $body, $header) = @_;
    die "HostRoleCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleCreate',
        soap_action => 'urn:HostRoleCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleDelete {
    my ($self, $body, $header) = @_;
    die "HostRoleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleDelete',
        soap_action => 'urn:HostRoleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleListIterEnd {
    my ($self, $body, $header) = @_;
    die "HostRoleListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleListIterEnd',
        soap_action => 'urn:HostRoleListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleListIterNext {
    my ($self, $body, $header) = @_;
    die "HostRoleListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleListIterNext',
        soap_action => 'urn:HostRoleListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleListIterStart {
    my ($self, $body, $header) = @_;
    die "HostRoleListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleListIterStart',
        soap_action => 'urn:HostRoleListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRoleModify {
    my ($self, $body, $header) = @_;
    die "HostRoleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRoleModify',
        soap_action => 'urn:HostRoleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRoleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostRolePush {
    my ($self, $body, $header) = @_;
    die "HostRolePush must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostRolePush',
        soap_action => 'urn:HostRolePush',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostRolePush )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostSetOption {
    my ($self, $body, $header) = @_;
    die "HostSetOption must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostSetOption',
        soap_action => 'urn:HostSetOption',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostSetOption )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserAdd {
    my ($self, $body, $header) = @_;
    die "HostUserAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserAdd',
        soap_action => 'urn:HostUserAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserDelete {
    my ($self, $body, $header) = @_;
    die "HostUserDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserDelete',
        soap_action => 'urn:HostUserDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserListIterEnd {
    my ($self, $body, $header) = @_;
    die "HostUserListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserListIterEnd',
        soap_action => 'urn:HostUserListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserListIterNext {
    my ($self, $body, $header) = @_;
    die "HostUserListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserListIterNext',
        soap_action => 'urn:HostUserListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserListIterStart {
    my ($self, $body, $header) = @_;
    die "HostUserListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserListIterStart',
        soap_action => 'urn:HostUserListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserModify {
    my ($self, $body, $header) = @_;
    die "HostUserModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserModify',
        soap_action => 'urn:HostUserModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserModifyPassword {
    my ($self, $body, $header) = @_;
    die "HostUserModifyPassword must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserModifyPassword',
        soap_action => 'urn:HostUserModifyPassword',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserModifyPassword )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUserPush {
    my ($self, $body, $header) = @_;
    die "HostUserPush must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUserPush',
        soap_action => 'urn:HostUserPush',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUserPush )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupCreate {
    my ($self, $body, $header) = @_;
    die "HostUsergroupCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupCreate',
        soap_action => 'urn:HostUsergroupCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupDelete {
    my ($self, $body, $header) = @_;
    die "HostUsergroupDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupDelete',
        soap_action => 'urn:HostUsergroupDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupListIterEnd {
    my ($self, $body, $header) = @_;
    die "HostUsergroupListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupListIterEnd',
        soap_action => 'urn:HostUsergroupListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupListIterNext {
    my ($self, $body, $header) = @_;
    die "HostUsergroupListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupListIterNext',
        soap_action => 'urn:HostUsergroupListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupListIterStart {
    my ($self, $body, $header) = @_;
    die "HostUsergroupListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupListIterStart',
        soap_action => 'urn:HostUsergroupListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupModify {
    my ($self, $body, $header) = @_;
    die "HostUsergroupModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupModify',
        soap_action => 'urn:HostUsergroupModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub HostUsergroupPush {
    my ($self, $body, $header) = @_;
    die "HostUsergroupPush must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'HostUsergroupPush',
        soap_action => 'urn:HostUsergroupPush',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::HostUsergroupPush )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub IfcListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "IfcListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'IfcListInfoIterEnd',
        soap_action => 'urn:IfcListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::IfcListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub IfcListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "IfcListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'IfcListInfoIterNext',
        soap_action => 'urn:IfcListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::IfcListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub IfcListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "IfcListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'IfcListInfoIterStart',
        soap_action => 'urn:IfcListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::IfcListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LdapServerAdd {
    my ($self, $body, $header) = @_;
    die "LdapServerAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LdapServerAdd',
        soap_action => 'urn:LdapServerAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LdapServerAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LdapServerDelete {
    my ($self, $body, $header) = @_;
    die "LdapServerDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LdapServerDelete',
        soap_action => 'urn:LdapServerDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LdapServerDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LdapServerListInfo {
    my ($self, $body, $header) = @_;
    die "LdapServerListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LdapServerListInfo',
        soap_action => 'urn:LdapServerListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LdapServerListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LunDestroy {
    my ($self, $body, $header) = @_;
    die "LunDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LunDestroy',
        soap_action => 'urn:LunDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LunDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LunListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "LunListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LunListInfoIterEnd',
        soap_action => 'urn:LunListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LunListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LunListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "LunListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LunListInfoIterNext',
        soap_action => 'urn:LunListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LunListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LunListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "LunListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LunListInfoIterStart',
        soap_action => 'urn:LunListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LunListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub LunResize {
    my ($self, $body, $header) = @_;
    die "LunResize must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'LunResize',
        soap_action => 'urn:LunResize',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::LunResize )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateCancel {
    my ($self, $body, $header) = @_;
    die "MigrateCancel must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateCancel',
        soap_action => 'urn:MigrateCancel',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateCancel )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateChangeState {
    my ($self, $body, $header) = @_;
    die "MigrateChangeState must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateChangeState',
        soap_action => 'urn:MigrateChangeState',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateChangeState )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateCleanup {
    my ($self, $body, $header) = @_;
    die "MigrateCleanup must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateCleanup',
        soap_action => 'urn:MigrateCleanup',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateCleanup )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateComplete {
    my ($self, $body, $header) = @_;
    die "MigrateComplete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateComplete',
        soap_action => 'urn:MigrateComplete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateComplete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateFix {
    my ($self, $body, $header) = @_;
    die "MigrateFix must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateFix',
        soap_action => 'urn:MigrateFix',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateFix )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateRollback {
    my ($self, $body, $header) = @_;
    die "MigrateRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateRollback',
        soap_action => 'urn:MigrateRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateStart {
    my ($self, $body, $header) = @_;
    die "MigrateStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateStart',
        soap_action => 'urn:MigrateStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateUpdate {
    my ($self, $body, $header) = @_;
    die "MigrateUpdate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateUpdate',
        soap_action => 'urn:MigrateUpdate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateUpdate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub MigrateVolume {
    my ($self, $body, $header) = @_;
    die "MigrateVolume must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'MigrateVolume',
        soap_action => 'urn:MigrateVolume',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::MigrateVolume )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub NetifIpInterfaceListInfo {
    my ($self, $body, $header) = @_;
    die "NetifIpInterfaceListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'NetifIpInterfaceListInfo',
        soap_action => 'urn:NetifIpInterfaceListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::NetifIpInterfaceListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfAssocViewListIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfAssocViewListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfAssocViewListIterEnd',
        soap_action => 'urn:PerfAssocViewListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfAssocViewListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfAssocViewListIterNext {
    my ($self, $body, $header) = @_;
    die "PerfAssocViewListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfAssocViewListIterNext',
        soap_action => 'urn:PerfAssocViewListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfAssocViewListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfAssocViewListIterStart {
    my ($self, $body, $header) = @_;
    die "PerfAssocViewListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfAssocViewListIterStart',
        soap_action => 'urn:PerfAssocViewListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfAssocViewListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfClientStatsListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfClientStatsListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfClientStatsListInfoIterEnd',
        soap_action => 'urn:PerfClientStatsListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfClientStatsListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfClientStatsListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "PerfClientStatsListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfClientStatsListInfoIterNext',
        soap_action => 'urn:PerfClientStatsListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfClientStatsListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfClientStatsListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "PerfClientStatsListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfClientStatsListInfoIterStart',
        soap_action => 'urn:PerfClientStatsListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfClientStatsListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfClientStatsPurge {
    my ($self, $body, $header) = @_;
    die "PerfClientStatsPurge must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfClientStatsPurge',
        soap_action => 'urn:PerfClientStatsPurge',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfClientStatsPurge )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCollectClientOperationStatistics {
    my ($self, $body, $header) = @_;
    die "PerfCollectClientOperationStatistics must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCollectClientOperationStatistics',
        soap_action => 'urn:PerfCollectClientOperationStatistics',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCollectClientOperationStatistics )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCopyCounterConfiguration {
    my ($self, $body, $header) = @_;
    die "PerfCopyCounterConfiguration must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCopyCounterConfiguration',
        soap_action => 'urn:PerfCopyCounterConfiguration',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCopyCounterConfiguration )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupCreate {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupCreate',
        soap_action => 'urn:PerfCounterGroupCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupDestroy {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupDestroy',
        soap_action => 'urn:PerfCounterGroupDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupGetData {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupGetData must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupGetData',
        soap_action => 'urn:PerfCounterGroupGetData',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupGetData )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupGetDynamicDataSources {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupGetDynamicDataSources must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupGetDynamicDataSources',
        soap_action => 'urn:PerfCounterGroupGetDynamicDataSources',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupGetDynamicDataSources )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupListInfo {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupListInfo',
        soap_action => 'urn:PerfCounterGroupListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupListIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupListIterEnd',
        soap_action => 'urn:PerfCounterGroupListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupListIterNext {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupListIterNext',
        soap_action => 'urn:PerfCounterGroupListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupListIterStart {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupListIterStart',
        soap_action => 'urn:PerfCounterGroupListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupModify {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupModify',
        soap_action => 'urn:PerfCounterGroupModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupStart {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupStart',
        soap_action => 'urn:PerfCounterGroupStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfCounterGroupStop {
    my ($self, $body, $header) = @_;
    die "PerfCounterGroupStop must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfCounterGroupStop',
        soap_action => 'urn:PerfCounterGroupStop',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfCounterGroupStop )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfDiagTroubleshoot {
    my ($self, $body, $header) = @_;
    die "PerfDiagTroubleshoot must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfDiagTroubleshoot',
        soap_action => 'urn:PerfDiagTroubleshoot',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfDiagTroubleshoot )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfDisableDataCollection {
    my ($self, $body, $header) = @_;
    die "PerfDisableDataCollection must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfDisableDataCollection',
        soap_action => 'urn:PerfDisableDataCollection',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfDisableDataCollection )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfDisableObjectUpdate {
    my ($self, $body, $header) = @_;
    die "PerfDisableObjectUpdate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfDisableObjectUpdate',
        soap_action => 'urn:PerfDisableObjectUpdate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfDisableObjectUpdate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfEnableDataCollection {
    my ($self, $body, $header) = @_;
    die "PerfEnableDataCollection must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfEnableDataCollection',
        soap_action => 'urn:PerfEnableDataCollection',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfEnableDataCollection )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfEnableObjectUpdate {
    my ($self, $body, $header) = @_;
    die "PerfEnableObjectUpdate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfEnableObjectUpdate',
        soap_action => 'urn:PerfEnableObjectUpdate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfEnableObjectUpdate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfGetCounterData {
    my ($self, $body, $header) = @_;
    die "PerfGetCounterData must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfGetCounterData',
        soap_action => 'urn:PerfGetCounterData',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfGetCounterData )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfGetCounterDependents {
    my ($self, $body, $header) = @_;
    die "PerfGetCounterDependents must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfGetCounterDependents',
        soap_action => 'urn:PerfGetCounterDependents',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfGetCounterDependents )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfGetCounterListNotInView {
    my ($self, $body, $header) = @_;
    die "PerfGetCounterListNotInView must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfGetCounterListNotInView',
        soap_action => 'urn:PerfGetCounterListNotInView',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfGetCounterListNotInView )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfGetDefaultView {
    my ($self, $body, $header) = @_;
    die "PerfGetDefaultView must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfGetDefaultView',
        soap_action => 'urn:PerfGetDefaultView',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfGetDefaultView )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfGetServerStatus {
    my ($self, $body, $header) = @_;
    die "PerfGetServerStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfGetServerStatus',
        soap_action => 'urn:PerfGetServerStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfGetServerStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectCounterListInfo {
    my ($self, $body, $header) = @_;
    die "PerfObjectCounterListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectCounterListInfo',
        soap_action => 'urn:PerfObjectCounterListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectCounterListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectDependentCounterListInfo {
    my ($self, $body, $header) = @_;
    die "PerfObjectDependentCounterListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectDependentCounterListInfo',
        soap_action => 'urn:PerfObjectDependentCounterListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectDependentCounterListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectInstanceListIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfObjectInstanceListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectInstanceListIterEnd',
        soap_action => 'urn:PerfObjectInstanceListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectInstanceListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectInstanceListIterNext {
    my ($self, $body, $header) = @_;
    die "PerfObjectInstanceListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectInstanceListIterNext',
        soap_action => 'urn:PerfObjectInstanceListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectInstanceListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectInstanceListIterStart {
    my ($self, $body, $header) = @_;
    die "PerfObjectInstanceListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectInstanceListIterStart',
        soap_action => 'urn:PerfObjectInstanceListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectInstanceListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfObjectListInfo {
    my ($self, $body, $header) = @_;
    die "PerfObjectListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfObjectListInfo',
        soap_action => 'urn:PerfObjectListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfObjectListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfSetDefaultView {
    my ($self, $body, $header) = @_;
    die "PerfSetDefaultView must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfSetDefaultView',
        soap_action => 'urn:PerfSetDefaultView',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfSetDefaultView )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfStatusGet {
    my ($self, $body, $header) = @_;
    die "PerfStatusGet must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfStatusGet',
        soap_action => 'urn:PerfStatusGet',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfStatusGet )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdCreate {
    my ($self, $body, $header) = @_;
    die "PerfThresholdCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdCreate',
        soap_action => 'urn:PerfThresholdCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdCreate2 {
    my ($self, $body, $header) = @_;
    die "PerfThresholdCreate2 must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdCreate2',
        soap_action => 'urn:PerfThresholdCreate2',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdCreate2 )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdDelete {
    my ($self, $body, $header) = @_;
    die "PerfThresholdDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdDelete',
        soap_action => 'urn:PerfThresholdDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfoIterEnd',
        soap_action => 'urn:PerfThresholdListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfoIterNext',
        soap_action => 'urn:PerfThresholdListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfoIterStart',
        soap_action => 'urn:PerfThresholdListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfo2IterEnd {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfo2IterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfo2IterEnd',
        soap_action => 'urn:PerfThresholdListInfo2IterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfo2IterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfo2IterNext {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfo2IterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfo2IterNext',
        soap_action => 'urn:PerfThresholdListInfo2IterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfo2IterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdListInfo2IterStart {
    my ($self, $body, $header) = @_;
    die "PerfThresholdListInfo2IterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdListInfo2IterStart',
        soap_action => 'urn:PerfThresholdListInfo2IterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdListInfo2IterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdModify {
    my ($self, $body, $header) = @_;
    die "PerfThresholdModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdModify',
        soap_action => 'urn:PerfThresholdModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdModify2 {
    my ($self, $body, $header) = @_;
    die "PerfThresholdModify2 must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdModify2',
        soap_action => 'urn:PerfThresholdModify2',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdModify2 )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateAttachObjects {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateAttachObjects must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateAttachObjects',
        soap_action => 'urn:PerfThresholdTemplateAttachObjects',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateAttachObjects )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateCreate {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateCreate',
        soap_action => 'urn:PerfThresholdTemplateCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateDelete {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateDelete',
        soap_action => 'urn:PerfThresholdTemplateDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateDetachObjects {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateDetachObjects must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateDetachObjects',
        soap_action => 'urn:PerfThresholdTemplateDetachObjects',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateDetachObjects )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateListInfoIterEnd',
        soap_action => 'urn:PerfThresholdTemplateListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateListInfoIterNext',
        soap_action => 'urn:PerfThresholdTemplateListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateListInfoIterStart',
        soap_action => 'urn:PerfThresholdTemplateListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfThresholdTemplateModify {
    my ($self, $body, $header) = @_;
    die "PerfThresholdTemplateModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfThresholdTemplateModify',
        soap_action => 'urn:PerfThresholdTemplateModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfThresholdTemplateModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewAssociatedObjectsList {
    my ($self, $body, $header) = @_;
    die "PerfViewAssociatedObjectsList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewAssociatedObjectsList',
        soap_action => 'urn:PerfViewAssociatedObjectsList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewAssociatedObjectsList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewCreate {
    my ($self, $body, $header) = @_;
    die "PerfViewCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewCreate',
        soap_action => 'urn:PerfViewCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewDestroy {
    my ($self, $body, $header) = @_;
    die "PerfViewDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewDestroy',
        soap_action => 'urn:PerfViewDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewGetData {
    my ($self, $body, $header) = @_;
    die "PerfViewGetData must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewGetData',
        soap_action => 'urn:PerfViewGetData',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewGetData )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewListIterEnd {
    my ($self, $body, $header) = @_;
    die "PerfViewListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewListIterEnd',
        soap_action => 'urn:PerfViewListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewListIterNext {
    my ($self, $body, $header) = @_;
    die "PerfViewListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewListIterNext',
        soap_action => 'urn:PerfViewListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewListIterStart {
    my ($self, $body, $header) = @_;
    die "PerfViewListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewListIterStart',
        soap_action => 'urn:PerfViewListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewModify {
    my ($self, $body, $header) = @_;
    die "PerfViewModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewModify',
        soap_action => 'urn:PerfViewModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewObjectAssociationAdd {
    my ($self, $body, $header) = @_;
    die "PerfViewObjectAssociationAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewObjectAssociationAdd',
        soap_action => 'urn:PerfViewObjectAssociationAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewObjectAssociationAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub PerfViewObjectAssociationDelete {
    my ($self, $body, $header) = @_;
    die "PerfViewObjectAssociationDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'PerfViewObjectAssociationDelete',
        soap_action => 'urn:PerfViewObjectAssociationDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::PerfViewObjectAssociationDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyCopy {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyCopy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyCopy',
        soap_action => 'urn:ProvisioningPolicyCopy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyCopy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyCreate {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyCreate',
        soap_action => 'urn:ProvisioningPolicyCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyDestroy {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyDestroy',
        soap_action => 'urn:ProvisioningPolicyDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyEditBegin {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyEditBegin must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyEditBegin',
        soap_action => 'urn:ProvisioningPolicyEditBegin',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyEditBegin )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyEditCommit {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyEditCommit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyEditCommit',
        soap_action => 'urn:ProvisioningPolicyEditCommit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyEditCommit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyEditRollback {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyEditRollback must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyEditRollback',
        soap_action => 'urn:ProvisioningPolicyEditRollback',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyEditRollback )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyListIterEnd {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyListIterEnd',
        soap_action => 'urn:ProvisioningPolicyListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyListIterNext {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyListIterNext',
        soap_action => 'urn:ProvisioningPolicyListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyListIterStart {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyListIterStart',
        soap_action => 'urn:ProvisioningPolicyListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ProvisioningPolicyModify {
    my ($self, $body, $header) = @_;
    die "ProvisioningPolicyModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ProvisioningPolicyModify',
        soap_action => 'urn:ProvisioningPolicyModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ProvisioningPolicyModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "QtreeListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeListInfoIterEnd',
        soap_action => 'urn:QtreeListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "QtreeListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeListInfoIterNext',
        soap_action => 'urn:QtreeListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "QtreeListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeListInfoIterStart',
        soap_action => 'urn:QtreeListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeModify {
    my ($self, $body, $header) = @_;
    die "QtreeModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeModify',
        soap_action => 'urn:QtreeModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeRename {
    my ($self, $body, $header) = @_;
    die "QtreeRename must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeRename',
        soap_action => 'urn:QtreeRename',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeRename )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeStartMonitoring {
    my ($self, $body, $header) = @_;
    die "QtreeStartMonitoring must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeStartMonitoring',
        soap_action => 'urn:QtreeStartMonitoring',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeStartMonitoring )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub QtreeStopMonitoring {
    my ($self, $body, $header) = @_;
    die "QtreeStopMonitoring must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'QtreeStopMonitoring',
        soap_action => 'urn:QtreeStopMonitoring',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::QtreeStopMonitoring )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAccessCheck {
    my ($self, $body, $header) = @_;
    die "RbacAccessCheck must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAccessCheck',
        soap_action => 'urn:RbacAccessCheck',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAccessCheck )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "RbacAdminListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminListInfoIterEnd',
        soap_action => 'urn:RbacAdminListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "RbacAdminListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminListInfoIterNext',
        soap_action => 'urn:RbacAdminListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "RbacAdminListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminListInfoIterStart',
        soap_action => 'urn:RbacAdminListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminRoleAdd {
    my ($self, $body, $header) = @_;
    die "RbacAdminRoleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminRoleAdd',
        soap_action => 'urn:RbacAdminRoleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminRoleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminRoleInfoList {
    my ($self, $body, $header) = @_;
    die "RbacAdminRoleInfoList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminRoleInfoList',
        soap_action => 'urn:RbacAdminRoleInfoList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminRoleInfoList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacAdminRoleRemove {
    my ($self, $body, $header) = @_;
    die "RbacAdminRoleRemove must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacAdminRoleRemove',
        soap_action => 'urn:RbacAdminRoleRemove',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacAdminRoleRemove )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacOperationAdd {
    my ($self, $body, $header) = @_;
    die "RbacOperationAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacOperationAdd',
        soap_action => 'urn:RbacOperationAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacOperationAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacOperationDelete {
    my ($self, $body, $header) = @_;
    die "RbacOperationDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacOperationDelete',
        soap_action => 'urn:RbacOperationDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacOperationDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacOperationInfoList {
    my ($self, $body, $header) = @_;
    die "RbacOperationInfoList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacOperationInfoList',
        soap_action => 'urn:RbacOperationInfoList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacOperationInfoList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleAdd {
    my ($self, $body, $header) = @_;
    die "RbacRoleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleAdd',
        soap_action => 'urn:RbacRoleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleAdminInfoList {
    my ($self, $body, $header) = @_;
    die "RbacRoleAdminInfoList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleAdminInfoList',
        soap_action => 'urn:RbacRoleAdminInfoList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleAdminInfoList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleCapabilityAdd {
    my ($self, $body, $header) = @_;
    die "RbacRoleCapabilityAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleCapabilityAdd',
        soap_action => 'urn:RbacRoleCapabilityAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleCapabilityAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleCapabilityRemove {
    my ($self, $body, $header) = @_;
    die "RbacRoleCapabilityRemove must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleCapabilityRemove',
        soap_action => 'urn:RbacRoleCapabilityRemove',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleCapabilityRemove )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleDelete {
    my ($self, $body, $header) = @_;
    die "RbacRoleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleDelete',
        soap_action => 'urn:RbacRoleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleDisinherit {
    my ($self, $body, $header) = @_;
    die "RbacRoleDisinherit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleDisinherit',
        soap_action => 'urn:RbacRoleDisinherit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleDisinherit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleInfoList {
    my ($self, $body, $header) = @_;
    die "RbacRoleInfoList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleInfoList',
        soap_action => 'urn:RbacRoleInfoList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleInfoList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleInherit {
    my ($self, $body, $header) = @_;
    die "RbacRoleInherit must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleInherit',
        soap_action => 'urn:RbacRoleInherit',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleInherit )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub RbacRoleModify {
    my ($self, $body, $header) = @_;
    die "RbacRoleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'RbacRoleModify',
        soap_action => 'urn:RbacRoleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::RbacRoleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportCategoryList {
    my ($self, $body, $header) = @_;
    die "ReportCategoryList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportCategoryList',
        soap_action => 'urn:ReportCategoryList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportCategoryList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportDesignerList {
    my ($self, $body, $header) = @_;
    die "ReportDesignerList must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportDesignerList',
        soap_action => 'urn:ReportDesignerList',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportDesignerList )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportDesignerScheduleAdd {
    my ($self, $body, $header) = @_;
    die "ReportDesignerScheduleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportDesignerScheduleAdd',
        soap_action => 'urn:ReportDesignerScheduleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportDesignerScheduleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportDesignerScheduleDelete {
    my ($self, $body, $header) = @_;
    die "ReportDesignerScheduleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportDesignerScheduleDelete',
        soap_action => 'urn:ReportDesignerScheduleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportDesignerScheduleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportDesignerScheduleModify {
    my ($self, $body, $header) = @_;
    die "ReportDesignerScheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportDesignerScheduleModify',
        soap_action => 'urn:ReportDesignerScheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportDesignerScheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportDesignerShare {
    my ($self, $body, $header) = @_;
    die "ReportDesignerShare must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportDesignerShare',
        soap_action => 'urn:ReportDesignerShare',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportDesignerShare )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportGraphListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ReportGraphListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportGraphListInfoIterEnd',
        soap_action => 'urn:ReportGraphListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportGraphListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportGraphListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ReportGraphListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportGraphListInfoIterNext',
        soap_action => 'urn:ReportGraphListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportGraphListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportGraphListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ReportGraphListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportGraphListInfoIterStart',
        soap_action => 'urn:ReportGraphListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportGraphListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ReportListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportListInfoIterEnd',
        soap_action => 'urn:ReportListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ReportListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportListInfoIterNext',
        soap_action => 'urn:ReportListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ReportListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportListInfoIterStart',
        soap_action => 'urn:ReportListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportOutputDelete {
    my ($self, $body, $header) = @_;
    die "ReportOutputDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportOutputDelete',
        soap_action => 'urn:ReportOutputDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportOutputDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportOutputListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ReportOutputListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportOutputListInfoIterEnd',
        soap_action => 'urn:ReportOutputListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportOutputListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportOutputListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ReportOutputListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportOutputListInfoIterNext',
        soap_action => 'urn:ReportOutputListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportOutputListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportOutputListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ReportOutputListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportOutputListInfoIterStart',
        soap_action => 'urn:ReportOutputListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportOutputListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportOutputRead {
    my ($self, $body, $header) = @_;
    die "ReportOutputRead must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportOutputRead',
        soap_action => 'urn:ReportOutputRead',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportOutputRead )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleAdd {
    my ($self, $body, $header) = @_;
    die "ReportScheduleAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleAdd',
        soap_action => 'urn:ReportScheduleAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleDelete {
    my ($self, $body, $header) = @_;
    die "ReportScheduleDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleDelete',
        soap_action => 'urn:ReportScheduleDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleDisable {
    my ($self, $body, $header) = @_;
    die "ReportScheduleDisable must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleDisable',
        soap_action => 'urn:ReportScheduleDisable',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleDisable )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleEnable {
    my ($self, $body, $header) = @_;
    die "ReportScheduleEnable must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleEnable',
        soap_action => 'urn:ReportScheduleEnable',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleEnable )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ReportScheduleListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleListInfoIterEnd',
        soap_action => 'urn:ReportScheduleListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ReportScheduleListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleListInfoIterNext',
        soap_action => 'urn:ReportScheduleListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ReportScheduleListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleListInfoIterStart',
        soap_action => 'urn:ReportScheduleListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleModify {
    my ($self, $body, $header) = @_;
    die "ReportScheduleModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleModify',
        soap_action => 'urn:ReportScheduleModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ReportScheduleRun {
    my ($self, $body, $header) = @_;
    die "ReportScheduleRun must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ReportScheduleRun',
        soap_action => 'urn:ReportScheduleRun',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ReportScheduleRun )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolAddMember {
    my ($self, $body, $header) = @_;
    die "ResourcepoolAddMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolAddMember',
        soap_action => 'urn:ResourcepoolAddMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolAddMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolCreate {
    my ($self, $body, $header) = @_;
    die "ResourcepoolCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolCreate',
        soap_action => 'urn:ResourcepoolCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolDestroy {
    my ($self, $body, $header) = @_;
    die "ResourcepoolDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolDestroy',
        soap_action => 'urn:ResourcepoolDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolGetDefaults {
    my ($self, $body, $header) = @_;
    die "ResourcepoolGetDefaults must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolGetDefaults',
        soap_action => 'urn:ResourcepoolGetDefaults',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolGetDefaults )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ResourcepoolListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolListInfoIterEnd',
        soap_action => 'urn:ResourcepoolListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ResourcepoolListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolListInfoIterNext',
        soap_action => 'urn:ResourcepoolListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ResourcepoolListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolListInfoIterStart',
        soap_action => 'urn:ResourcepoolListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolMemberListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ResourcepoolMemberListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolMemberListInfoIterEnd',
        soap_action => 'urn:ResourcepoolMemberListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolMemberListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolMemberListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ResourcepoolMemberListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolMemberListInfoIterNext',
        soap_action => 'urn:ResourcepoolMemberListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolMemberListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolMemberListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ResourcepoolMemberListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolMemberListInfoIterStart',
        soap_action => 'urn:ResourcepoolMemberListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolMemberListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolModify {
    my ($self, $body, $header) = @_;
    die "ResourcepoolModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolModify',
        soap_action => 'urn:ResourcepoolModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolModifyMember {
    my ($self, $body, $header) = @_;
    die "ResourcepoolModifyMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolModifyMember',
        soap_action => 'urn:ResourcepoolModifyMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolModifyMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolRemoveMember {
    my ($self, $body, $header) = @_;
    die "ResourcepoolRemoveMember must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolRemoveMember',
        soap_action => 'urn:ResourcepoolRemoveMember',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolRemoveMember )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ResourcepoolUpdateFreeSpaceStatus {
    my ($self, $body, $header) = @_;
    die "ResourcepoolUpdateFreeSpaceStatus must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ResourcepoolUpdateFreeSpaceStatus',
        soap_action => 'urn:ResourcepoolUpdateFreeSpaceStatus',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ResourcepoolUpdateFreeSpaceStatus )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SnapshotGetReclaimableInfo {
    my ($self, $body, $header) = @_;
    die "SnapshotGetReclaimableInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SnapshotGetReclaimableInfo',
        soap_action => 'urn:SnapshotGetReclaimableInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SnapshotGetReclaimableInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SnapshotListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "SnapshotListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SnapshotListInfoIterEnd',
        soap_action => 'urn:SnapshotListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SnapshotListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SnapshotListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "SnapshotListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SnapshotListInfoIterNext',
        soap_action => 'urn:SnapshotListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SnapshotListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SnapshotListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "SnapshotListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SnapshotListInfoIterStart',
        soap_action => 'urn:SnapshotListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SnapshotListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SrmFileTypeAdd {
    my ($self, $body, $header) = @_;
    die "SrmFileTypeAdd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SrmFileTypeAdd',
        soap_action => 'urn:SrmFileTypeAdd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SrmFileTypeAdd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SrmFileTypeDelete {
    my ($self, $body, $header) = @_;
    die "SrmFileTypeDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SrmFileTypeDelete',
        soap_action => 'urn:SrmFileTypeDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SrmFileTypeDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub SrmFileTypeListInfo {
    my ($self, $body, $header) = @_;
    die "SrmFileTypeListInfo must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'SrmFileTypeListInfo',
        soap_action => 'urn:SrmFileTypeListInfo',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::SrmFileTypeListInfo )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceCreate {
    my ($self, $body, $header) = @_;
    die "StorageServiceCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceCreate',
        soap_action => 'urn:StorageServiceCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDatasetListIterEnd {
    my ($self, $body, $header) = @_;
    die "StorageServiceDatasetListIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDatasetListIterEnd',
        soap_action => 'urn:StorageServiceDatasetListIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDatasetListIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDatasetListIterNext {
    my ($self, $body, $header) = @_;
    die "StorageServiceDatasetListIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDatasetListIterNext',
        soap_action => 'urn:StorageServiceDatasetListIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDatasetListIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDatasetListIterStart {
    my ($self, $body, $header) = @_;
    die "StorageServiceDatasetListIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDatasetListIterStart',
        soap_action => 'urn:StorageServiceDatasetListIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDatasetListIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDatasetModify {
    my ($self, $body, $header) = @_;
    die "StorageServiceDatasetModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDatasetModify',
        soap_action => 'urn:StorageServiceDatasetModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDatasetModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDatasetProvision {
    my ($self, $body, $header) = @_;
    die "StorageServiceDatasetProvision must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDatasetProvision',
        soap_action => 'urn:StorageServiceDatasetProvision',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDatasetProvision )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceDestroy {
    my ($self, $body, $header) = @_;
    die "StorageServiceDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceDestroy',
        soap_action => 'urn:StorageServiceDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "StorageServiceListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceListInfoIterEnd',
        soap_action => 'urn:StorageServiceListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "StorageServiceListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceListInfoIterNext',
        soap_action => 'urn:StorageServiceListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "StorageServiceListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceListInfoIterStart',
        soap_action => 'urn:StorageServiceListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub StorageServiceModify {
    my ($self, $body, $header) = @_;
    die "StorageServiceModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'StorageServiceModify',
        soap_action => 'urn:StorageServiceModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::StorageServiceModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub TimezoneGetDefaults {
    my ($self, $body, $header) = @_;
    die "TimezoneGetDefaults must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'TimezoneGetDefaults',
        soap_action => 'urn:TimezoneGetDefaults',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::TimezoneGetDefaults )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub TimezoneListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "TimezoneListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'TimezoneListInfoIterEnd',
        soap_action => 'urn:TimezoneListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::TimezoneListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub TimezoneListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "TimezoneListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'TimezoneListInfoIterNext',
        soap_action => 'urn:TimezoneListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::TimezoneListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub TimezoneListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "TimezoneListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'TimezoneListInfoIterStart',
        soap_action => 'urn:TimezoneListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::TimezoneListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub TimezoneValidate {
    my ($self, $body, $header) = @_;
    die "TimezoneValidate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'TimezoneValidate',
        soap_action => 'urn:TimezoneValidate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::TimezoneValidate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserFavoriteReportDelete {
    my ($self, $body, $header) = @_;
    die "UserFavoriteReportDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserFavoriteReportDelete',
        soap_action => 'urn:UserFavoriteReportDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserFavoriteReportDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserFavoriteReportListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "UserFavoriteReportListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserFavoriteReportListInfoIterEnd',
        soap_action => 'urn:UserFavoriteReportListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserFavoriteReportListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserFavoriteReportListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "UserFavoriteReportListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserFavoriteReportListInfoIterNext',
        soap_action => 'urn:UserFavoriteReportListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserFavoriteReportListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserFavoriteReportListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "UserFavoriteReportListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserFavoriteReportListInfoIterStart',
        soap_action => 'urn:UserFavoriteReportListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserFavoriteReportListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserRecentReportDelete {
    my ($self, $body, $header) = @_;
    die "UserRecentReportDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserRecentReportDelete',
        soap_action => 'urn:UserRecentReportDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserRecentReportDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserRecentReportListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "UserRecentReportListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserRecentReportListInfoIterEnd',
        soap_action => 'urn:UserRecentReportListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserRecentReportListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserRecentReportListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "UserRecentReportListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserRecentReportListInfoIterNext',
        soap_action => 'urn:UserRecentReportListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserRecentReportListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub UserRecentReportListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "UserRecentReportListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'UserRecentReportListInfoIterStart',
        soap_action => 'urn:UserRecentReportListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::UserRecentReportListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerCreate {
    my ($self, $body, $header) = @_;
    die "VfilerCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerCreate',
        soap_action => 'urn:VfilerCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerDestroy {
    my ($self, $body, $header) = @_;
    die "VfilerDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerDestroy',
        soap_action => 'urn:VfilerDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerSetup {
    my ($self, $body, $header) = @_;
    die "VfilerSetup must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerSetup',
        soap_action => 'urn:VfilerSetup',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerSetup )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateCopy {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateCopy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateCopy',
        soap_action => 'urn:VfilerTemplateCopy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateCopy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateCreate {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateCreate must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateCreate',
        soap_action => 'urn:VfilerTemplateCreate',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateCreate )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateDelete {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateDelete must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateDelete',
        soap_action => 'urn:VfilerTemplateDelete',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateDelete )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateListInfoIterEnd',
        soap_action => 'urn:VfilerTemplateListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateListInfoIterNext',
        soap_action => 'urn:VfilerTemplateListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateListInfoIterStart',
        soap_action => 'urn:VfilerTemplateListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VfilerTemplateModify {
    my ($self, $body, $header) = @_;
    die "VfilerTemplateModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VfilerTemplateModify',
        soap_action => 'urn:VfilerTemplateModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VfilerTemplateModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatacenterListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViDatacenterListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatacenterListInfoIterEnd',
        soap_action => 'urn:ViDatacenterListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatacenterListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatacenterListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViDatacenterListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatacenterListInfoIterNext',
        soap_action => 'urn:ViDatacenterListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatacenterListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatacenterListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViDatacenterListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatacenterListInfoIterStart',
        soap_action => 'urn:ViDatacenterListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatacenterListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatastoreListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViDatastoreListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatastoreListInfoIterEnd',
        soap_action => 'urn:ViDatastoreListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatastoreListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatastoreListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViDatastoreListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatastoreListInfoIterNext',
        soap_action => 'urn:ViDatastoreListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatastoreListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViDatastoreListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViDatastoreListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViDatastoreListInfoIterStart',
        soap_action => 'urn:ViDatastoreListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViDatastoreListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViHypervisorListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViHypervisorListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViHypervisorListInfoIterEnd',
        soap_action => 'urn:ViHypervisorListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViHypervisorListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViHypervisorListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViHypervisorListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViHypervisorListInfoIterNext',
        soap_action => 'urn:ViHypervisorListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViHypervisorListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViHypervisorListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViHypervisorListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViHypervisorListInfoIterStart',
        soap_action => 'urn:ViHypervisorListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViHypervisorListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualCenterListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViVirtualCenterListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualCenterListInfoIterEnd',
        soap_action => 'urn:ViVirtualCenterListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualCenterListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualCenterListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViVirtualCenterListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualCenterListInfoIterNext',
        soap_action => 'urn:ViVirtualCenterListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualCenterListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualCenterListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViVirtualCenterListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualCenterListInfoIterStart',
        soap_action => 'urn:ViVirtualCenterListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualCenterListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualDiskListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViVirtualDiskListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualDiskListInfoIterEnd',
        soap_action => 'urn:ViVirtualDiskListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualDiskListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualDiskListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViVirtualDiskListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualDiskListInfoIterNext',
        soap_action => 'urn:ViVirtualDiskListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualDiskListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualDiskListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViVirtualDiskListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualDiskListInfoIterStart',
        soap_action => 'urn:ViVirtualDiskListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualDiskListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualMachineListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "ViVirtualMachineListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualMachineListInfoIterEnd',
        soap_action => 'urn:ViVirtualMachineListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualMachineListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualMachineListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "ViVirtualMachineListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualMachineListInfoIterNext',
        soap_action => 'urn:ViVirtualMachineListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualMachineListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub ViVirtualMachineListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "ViVirtualMachineListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'ViVirtualMachineListInfoIterStart',
        soap_action => 'urn:ViVirtualMachineListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::ViVirtualMachineListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeDedupe {
    my ($self, $body, $header) = @_;
    die "VolumeDedupe must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeDedupe',
        soap_action => 'urn:VolumeDedupe',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeDedupe )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeDestroy {
    my ($self, $body, $header) = @_;
    die "VolumeDestroy must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeDestroy',
        soap_action => 'urn:VolumeDestroy',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeDestroy )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeListInfoIterEnd {
    my ($self, $body, $header) = @_;
    die "VolumeListInfoIterEnd must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeListInfoIterEnd',
        soap_action => 'urn:VolumeListInfoIterEnd',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeListInfoIterEnd )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeListInfoIterNext {
    my ($self, $body, $header) = @_;
    die "VolumeListInfoIterNext must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeListInfoIterNext',
        soap_action => 'urn:VolumeListInfoIterNext',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeListInfoIterNext )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeListInfoIterStart {
    my ($self, $body, $header) = @_;
    die "VolumeListInfoIterStart must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeListInfoIterStart',
        soap_action => 'urn:VolumeListInfoIterStart',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeListInfoIterStart )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeModify {
    my ($self, $body, $header) = @_;
    die "VolumeModify must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeModify',
        soap_action => 'urn:VolumeModify',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeModify )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}


sub VolumeResize {
    my ($self, $body, $header) = @_;
    die "VolumeResize must be called as object method (\$self is <$self>)" if not blessed($self);
    return $self->SUPER::call({
        operation => 'VolumeResize',
        soap_action => 'urn:VolumeResize',
        style => 'document',
        body => {
            

           'use'            => 'literal',
            namespace       => 'http://schemas.xmlsoap.org/wsdl/soap/',
            encodingStyle   => '',
            parts           =>  [qw( MyElements::VolumeResize )],
        },
        header => {
            
        },
        headerfault => {
            
        }
    }, $body, $header);
}




1;



__END__

=pod

=head1 NAME

MyInterfaces::DfmService::DfmPort - SOAP Interface for the DfmService Web Service

=head1 SYNOPSIS

 use MyInterfaces::DfmService::DfmPort;
 my $interface = MyInterfaces::DfmService::DfmPort->new();

 my $response;
 $response = $interface->AggregateListInfoIterEnd();
 $response = $interface->AggregateListInfoIterNext();
 $response = $interface->AggregateListInfoIterStart();
 $response = $interface->AggregateModify();
 $response = $interface->AggregateSpaceManagementAddOperation();
 $response = $interface->AggregateSpaceManagementBegin();
 $response = $interface->AggregateSpaceManagementCommit();
 $response = $interface->AggregateSpaceManagementRemoveOperation();
 $response = $interface->AggregateSpaceManagementRollback();
 $response = $interface->AlarmCreate();
 $response = $interface->AlarmDestroy();
 $response = $interface->AlarmGetDefaults();
 $response = $interface->AlarmListInfoIterEnd();
 $response = $interface->AlarmListInfoIterNext();
 $response = $interface->AlarmListInfoIterStart();
 $response = $interface->AlarmModify();
 $response = $interface->AlarmTest();
 $response = $interface->ApiProxy();
 $response = $interface->ApplicationPolicyCopy();
 $response = $interface->ApplicationPolicyCreate();
 $response = $interface->ApplicationPolicyDestroy();
 $response = $interface->ApplicationPolicyEditBegin();
 $response = $interface->ApplicationPolicyEditCommit();
 $response = $interface->ApplicationPolicyEditRollback();
 $response = $interface->ApplicationPolicyListIterEnd();
 $response = $interface->ApplicationPolicyListIterNext();
 $response = $interface->ApplicationPolicyListIterStart();
 $response = $interface->ApplicationPolicyModify();
 $response = $interface->AuditLogAddEntry();
 $response = $interface->CifsDomainListInfoIterEnd();
 $response = $interface->CifsDomainListInfoIterNext();
 $response = $interface->CifsDomainListInfoIterStart();
 $response = $interface->ClientRegistryDestroy();
 $response = $interface->ClientRegistryGet();
 $response = $interface->ClientRegistrySet();
 $response = $interface->CommentFieldCreate();
 $response = $interface->CommentFieldDestroy();
 $response = $interface->CommentFieldListInfoIterEnd();
 $response = $interface->CommentFieldListInfoIterNext();
 $response = $interface->CommentFieldListInfoIterStart();
 $response = $interface->CommentFieldModify();
 $response = $interface->CommentFieldValuesListInfoIterEnd();
 $response = $interface->CommentFieldValuesListInfoIterNext();
 $response = $interface->CommentFieldValuesListInfoIterStart();
 $response = $interface->CommentSetObjectValue();
 $response = $interface->DatasetAddMember();
 $response = $interface->DatasetAddMemberByDynamicReference();
 $response = $interface->DatasetAddResourcepool();
 $response = $interface->DatasetAddToExclusionList();
 $response = $interface->DatasetBeginFailover();
 $response = $interface->DatasetBeginFailoverScriptTest();
 $response = $interface->DatasetChangeDrState();
 $response = $interface->DatasetComputeUsageMetric();
 $response = $interface->DatasetConformBegin();
 $response = $interface->DatasetCreate();
 $response = $interface->DatasetDestroy();
 $response = $interface->DatasetDynamicReferenceListInfoIterEnd();
 $response = $interface->DatasetDynamicReferenceListInfoIterNext();
 $response = $interface->DatasetDynamicReferenceListInfoIterStart();
 $response = $interface->DatasetEditBegin();
 $response = $interface->DatasetEditCommit();
 $response = $interface->DatasetEditRollback();
 $response = $interface->DatasetExclusionListInfoIterEnd();
 $response = $interface->DatasetExclusionListInfoIterNext();
 $response = $interface->DatasetExclusionListInfoIterStart();
 $response = $interface->DatasetIoMetricListInfoIterEnd();
 $response = $interface->DatasetIoMetricListInfoIterNext();
 $response = $interface->DatasetIoMetricListInfoIterStart();
 $response = $interface->DatasetListInfoIterEnd();
 $response = $interface->DatasetListInfoIterNext();
 $response = $interface->DatasetListInfoIterStart();
 $response = $interface->DatasetMemberDedupeAbort();
 $response = $interface->DatasetMemberDedupeStart();
 $response = $interface->DatasetMemberDeleteSnapshots();
 $response = $interface->DatasetMemberListInfoIterEnd();
 $response = $interface->DatasetMemberListInfoIterNext();
 $response = $interface->DatasetMemberListInfoIterStart();
 $response = $interface->DatasetMemberUndedupeStart();
 $response = $interface->DatasetMissingMemberListInfoIterEnd();
 $response = $interface->DatasetMissingMemberListInfoIterNext();
 $response = $interface->DatasetMissingMemberListInfoIterStart();
 $response = $interface->DatasetModify();
 $response = $interface->DatasetModifyNode();
 $response = $interface->DatasetProvisionMember();
 $response = $interface->DatasetRemoveFromExclusionList();
 $response = $interface->DatasetRemoveMember();
 $response = $interface->DatasetRemoveMemberByDynamicReference();
 $response = $interface->DatasetRemoveResourcepool();
 $response = $interface->DatasetReplacePrimaryMembers();
 $response = $interface->DatasetResizeMember();
 $response = $interface->DatasetSet();
 $response = $interface->DatasetSetStorageset();
 $response = $interface->DatasetSpaceMetricListInfoIterEnd();
 $response = $interface->DatasetSpaceMetricListInfoIterNext();
 $response = $interface->DatasetSpaceMetricListInfoIterStart();
 $response = $interface->DatasetUpdateDrStatus();
 $response = $interface->DatasetUpdateProtectionStatus();
 $response = $interface->DfmAbout();
 $response = $interface->DfmBackupScheduleDisable();
 $response = $interface->DfmBackupScheduleEnable();
 $response = $interface->DfmBackupScheduleGet();
 $response = $interface->DfmBackupScheduleSet();
 $response = $interface->DfmBackupStart();
 $response = $interface->DfmBackupStatus();
 $response = $interface->DfmGetApiStatistics();
 $response = $interface->DfmGetResourcePropertyValues();
 $response = $interface->DfmMonitorTimestampList();
 $response = $interface->DfmNetworkAdd();
 $response = $interface->DfmNetworkDelete();
 $response = $interface->DfmNetworkListInfo();
 $response = $interface->DfmNetworkModify();
 $response = $interface->DfmObjectRefresh();
 $response = $interface->DfmObjectsGetStatus();
 $response = $interface->DfmRelatedObjectsListInfo();
 $response = $interface->DfmScheduleContentGet();
 $response = $interface->DfmScheduleCreate();
 $response = $interface->DfmScheduleDailyAdd();
 $response = $interface->DfmScheduleDailyDelete();
 $response = $interface->DfmScheduleDailyModify();
 $response = $interface->DfmScheduleDependency();
 $response = $interface->DfmScheduleDestroy();
 $response = $interface->DfmScheduleHourlyAdd();
 $response = $interface->DfmScheduleHourlyDelete();
 $response = $interface->DfmScheduleHourlyModify();
 $response = $interface->DfmScheduleList();
 $response = $interface->DfmScheduleListInfoIterEnd();
 $response = $interface->DfmScheduleListInfoIterNext();
 $response = $interface->DfmScheduleListInfoIterStart();
 $response = $interface->DfmScheduleModify();
 $response = $interface->DfmScheduleMonthlyAdd();
 $response = $interface->DfmScheduleMonthlyDelete();
 $response = $interface->DfmScheduleMonthlyModify();
 $response = $interface->DfmScheduleMonthlySubscheduleSet();
 $response = $interface->DfmScheduleMonthlySubscheduleUnset();
 $response = $interface->DfmScheduleRename();
 $response = $interface->DfmScheduleWeeklyAdd();
 $response = $interface->DfmScheduleWeeklyDelete();
 $response = $interface->DfmScheduleWeeklyModify();
 $response = $interface->DfmScheduleWeeklySubscheduleAdd();
 $response = $interface->DfmScheduleWeeklySubscheduleDelete();
 $response = $interface->DfmScheduleWeeklySubscheduleModify();
 $response = $interface->DfmServerListDiagnosticInfo();
 $response = $interface->DfmSnmpSettingAdd();
 $response = $interface->DfmSnmpSettingDelete();
 $response = $interface->DfmSnmpSettingModify();
 $response = $interface->DfmSnmpSettingsListInfo();
 $response = $interface->DfmUserPrivGet();
 $response = $interface->DiskListInfoIterEnd();
 $response = $interface->DiskListInfoIterNext();
 $response = $interface->DiskListInfoIterStart();
 $response = $interface->DpAgentConfigure();
 $response = $interface->DpAgentDiscover();
 $response = $interface->DpAgentListInfoIterEnd();
 $response = $interface->DpAgentListInfoIterNext();
 $response = $interface->DpAgentListInfoIterStart();
 $response = $interface->DpAgentListUpgradeCandidates();
 $response = $interface->DpAgentModify();
 $response = $interface->DpAgentPackageAdd();
 $response = $interface->DpAgentPackageDelete();
 $response = $interface->DpAgentPackageList();
 $response = $interface->DpAgentRegister();
 $response = $interface->DpAgentStoragesystemListInfoIterEnd();
 $response = $interface->DpAgentStoragesystemListInfoIterNext();
 $response = $interface->DpAgentStoragesystemListInfoIterStart();
 $response = $interface->DpAgentUnregister();
 $response = $interface->DpAgentUpgrade();
 $response = $interface->DpBackupContentListIterEnd();
 $response = $interface->DpBackupContentListIterNext();
 $response = $interface->DpBackupContentListIterStart();
 $response = $interface->DpBackupGetLocation();
 $response = $interface->DpBackupListIterEnd();
 $response = $interface->DpBackupListIterNext();
 $response = $interface->DpBackupListIterStart();
 $response = $interface->DpBackupStart();
 $response = $interface->DpBackupVersionCreate();
 $response = $interface->DpBackupVersionDelete();
 $response = $interface->DpBackupVersionListIterEnd();
 $response = $interface->DpBackupVersionListIterNext();
 $response = $interface->DpBackupVersionListIterStart();
 $response = $interface->DpBackupVersionModify();
 $response = $interface->DpDashboardGetDrDatasetCounts();
 $response = $interface->DpDashboardGetLaggedDatasets();
 $response = $interface->DpDashboardGetLaggedRelationships();
 $response = $interface->DpDashboardGetProtectedDataCounts();
 $response = $interface->DpDashboardGetProtectedDataCounts2();
 $response = $interface->DpGetDatasetBackupJobsData();
 $response = $interface->DpJobAbort();
 $response = $interface->DpJobListIterEnd();
 $response = $interface->DpJobListIterNext();
 $response = $interface->DpJobListIterStart();
 $response = $interface->DpJobProgressEventListIterEnd();
 $response = $interface->DpJobProgressEventListIterNext();
 $response = $interface->DpJobProgressEventListIterStart();
 $response = $interface->DpJobPurge();
 $response = $interface->DpJobScheduleGetLastChanged();
 $response = $interface->DpJobScheduleListIterEnd();
 $response = $interface->DpJobScheduleListIterNext();
 $response = $interface->DpJobScheduleListIterStart();
 $response = $interface->DpOssvApplicationListInfoIterEnd();
 $response = $interface->DpOssvApplicationListInfoIterNext();
 $response = $interface->DpOssvApplicationListInfoIterStart();
 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterEnd();
 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterNext();
 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterStart();
 $response = $interface->DpOssvDirectoryAdd();
 $response = $interface->DpOssvDirectoryBrowseIterEnd();
 $response = $interface->DpOssvDirectoryBrowseIterNext();
 $response = $interface->DpOssvDirectoryBrowseIterStart();
 $response = $interface->DpOssvDirectoryDiscoveredIterEnd();
 $response = $interface->DpOssvDirectoryDiscoveredIterNext();
 $response = $interface->DpOssvDirectoryDiscoveredIterStart();
 $response = $interface->DpOssvDirectoryModify();
 $response = $interface->DpOssvDirectoryRootsIterEnd();
 $response = $interface->DpOssvDirectoryRootsIterNext();
 $response = $interface->DpOssvDirectoryRootsIterStart();
 $response = $interface->DpPolicyCopy();
 $response = $interface->DpPolicyDestroy();
 $response = $interface->DpPolicyEditBegin();
 $response = $interface->DpPolicyEditCommit();
 $response = $interface->DpPolicyEditRollback();
 $response = $interface->DpPolicyGetDefaultPropertyValues();
 $response = $interface->DpPolicyListIterEnd();
 $response = $interface->DpPolicyListIterNext();
 $response = $interface->DpPolicyListIterStart();
 $response = $interface->DpPolicyModify();
 $response = $interface->DpRelationshipListInfoIterEnd();
 $response = $interface->DpRelationshipListInfoIterNext();
 $response = $interface->DpRelationshipListInfoIterStart();
 $response = $interface->DpRelationshipModify();
 $response = $interface->DpRestoreToNewPath();
 $response = $interface->DpRestoreToPrimary();
 $response = $interface->DpRestoreViStart();
 $response = $interface->DpScheduleContentGet();
 $response = $interface->DpScheduleCreate();
 $response = $interface->DpScheduleDailyAdd();
 $response = $interface->DpScheduleDailyDelete();
 $response = $interface->DpScheduleDailyModify();
 $response = $interface->DpScheduleDependency();
 $response = $interface->DpScheduleDestroy();
 $response = $interface->DpScheduleHourlyAdd();
 $response = $interface->DpScheduleHourlyDelete();
 $response = $interface->DpScheduleHourlyModify();
 $response = $interface->DpScheduleList();
 $response = $interface->DpScheduleListInfoIterEnd();
 $response = $interface->DpScheduleListInfoIterNext();
 $response = $interface->DpScheduleListInfoIterStart();
 $response = $interface->DpScheduleModify();
 $response = $interface->DpScheduleMonthlyAdd();
 $response = $interface->DpScheduleMonthlyDelete();
 $response = $interface->DpScheduleMonthlyModify();
 $response = $interface->DpScheduleMonthlySubscheduleSet();
 $response = $interface->DpScheduleMonthlySubscheduleUnset();
 $response = $interface->DpScheduleRename();
 $response = $interface->DpScheduleWeeklyAdd();
 $response = $interface->DpScheduleWeeklyDelete();
 $response = $interface->DpScheduleWeeklyModify();
 $response = $interface->DpScheduleWeeklySubscheduleAdd();
 $response = $interface->DpScheduleWeeklySubscheduleDelete();
 $response = $interface->DpScheduleWeeklySubscheduleModify();
 $response = $interface->DpThrottleCreate();
 $response = $interface->DpThrottleDependency();
 $response = $interface->DpThrottleDestroy();
 $response = $interface->DpThrottleItemAdd();
 $response = $interface->DpThrottleItemDelete();
 $response = $interface->DpThrottleListInfoIterEnd();
 $response = $interface->DpThrottleListInfoIterNext();
 $response = $interface->DpThrottleListInfoIterStart();
 $response = $interface->DpThrottleModify();
 $response = $interface->DpThrottleRename();
 $response = $interface->EventAcknowledge();
 $response = $interface->EventDelete();
 $response = $interface->EventGenerate();
 $response = $interface->EventListIterEnd();
 $response = $interface->EventListIterNext();
 $response = $interface->EventListIterStart();
 $response = $interface->EventStatusChangeListIterEnd();
 $response = $interface->EventStatusChangeListIterNext();
 $response = $interface->EventStatusChangeListIterStart();
 $response = $interface->EventclassAddCustom();
 $response = $interface->EventclassDeleteCustom();
 $response = $interface->EventclassList();
 $response = $interface->EventclassListIterEnd();
 $response = $interface->EventclassListIterNext();
 $response = $interface->EventclassListIterStart();
 $response = $interface->FcpTargetListInfoIterEnd();
 $response = $interface->FcpTargetListInfoIterNext();
 $response = $interface->FcpTargetListInfoIterStart();
 $response = $interface->GraphDataListInfo();
 $response = $interface->GraphListInfoIterEnd();
 $response = $interface->GraphListInfoIterNext();
 $response = $interface->GraphListInfoIterStart();
 $response = $interface->GroupAddMember();
 $response = $interface->GroupCopy();
 $response = $interface->GroupCreate();
 $response = $interface->GroupDeleteMember();
 $response = $interface->GroupDestroy();
 $response = $interface->GroupGetOptions();
 $response = $interface->GroupGetStatus();
 $response = $interface->GroupIsMemberOf();
 $response = $interface->GroupListIterEnd();
 $response = $interface->GroupListIterNext();
 $response = $interface->GroupListIterStart();
 $response = $interface->GroupMemberListIterEnd();
 $response = $interface->GroupMemberListIterNext();
 $response = $interface->GroupMemberListIterStart();
 $response = $interface->GroupMove();
 $response = $interface->GroupRename();
 $response = $interface->GroupSetOptions();
 $response = $interface->HostAdd();
 $response = $interface->HostAddLicense();
 $response = $interface->HostAddOssv();
 $response = $interface->HostAgentOssvServiceStart();
 $response = $interface->HostAgentOssvServiceStop();
 $response = $interface->HostCapabilityListIterEnd();
 $response = $interface->HostCapabilityListIterNext();
 $response = $interface->HostCapabilityListIterStart();
 $response = $interface->HostCreateNdmpuser();
 $response = $interface->HostDelete();
 $response = $interface->HostDomainuserAdd();
 $response = $interface->HostDomainuserListIterEnd();
 $response = $interface->HostDomainuserListIterNext();
 $response = $interface->HostDomainuserListIterStart();
 $response = $interface->HostDomainuserPush();
 $response = $interface->HostDomainuserRemove();
 $response = $interface->HostGetDefaults();
 $response = $interface->HostListInfoIterEnd();
 $response = $interface->HostListInfoIterNext();
 $response = $interface->HostListInfoIterStart();
 $response = $interface->HostModify();
 $response = $interface->HostModifyAgentCredentials();
 $response = $interface->HostRoleCreate();
 $response = $interface->HostRoleDelete();
 $response = $interface->HostRoleListIterEnd();
 $response = $interface->HostRoleListIterNext();
 $response = $interface->HostRoleListIterStart();
 $response = $interface->HostRoleModify();
 $response = $interface->HostRolePush();
 $response = $interface->HostSetOption();
 $response = $interface->HostUserAdd();
 $response = $interface->HostUserDelete();
 $response = $interface->HostUserListIterEnd();
 $response = $interface->HostUserListIterNext();
 $response = $interface->HostUserListIterStart();
 $response = $interface->HostUserModify();
 $response = $interface->HostUserModifyPassword();
 $response = $interface->HostUserPush();
 $response = $interface->HostUsergroupCreate();
 $response = $interface->HostUsergroupDelete();
 $response = $interface->HostUsergroupListIterEnd();
 $response = $interface->HostUsergroupListIterNext();
 $response = $interface->HostUsergroupListIterStart();
 $response = $interface->HostUsergroupModify();
 $response = $interface->HostUsergroupPush();
 $response = $interface->IfcListInfoIterEnd();
 $response = $interface->IfcListInfoIterNext();
 $response = $interface->IfcListInfoIterStart();
 $response = $interface->LdapServerAdd();
 $response = $interface->LdapServerDelete();
 $response = $interface->LdapServerListInfo();
 $response = $interface->LunDestroy();
 $response = $interface->LunListInfoIterEnd();
 $response = $interface->LunListInfoIterNext();
 $response = $interface->LunListInfoIterStart();
 $response = $interface->LunResize();
 $response = $interface->MigrateCancel();
 $response = $interface->MigrateChangeState();
 $response = $interface->MigrateCleanup();
 $response = $interface->MigrateComplete();
 $response = $interface->MigrateFix();
 $response = $interface->MigrateRollback();
 $response = $interface->MigrateStart();
 $response = $interface->MigrateUpdate();
 $response = $interface->MigrateVolume();
 $response = $interface->NetifIpInterfaceListInfo();
 $response = $interface->PerfAssocViewListIterEnd();
 $response = $interface->PerfAssocViewListIterNext();
 $response = $interface->PerfAssocViewListIterStart();
 $response = $interface->PerfClientStatsListInfoIterEnd();
 $response = $interface->PerfClientStatsListInfoIterNext();
 $response = $interface->PerfClientStatsListInfoIterStart();
 $response = $interface->PerfClientStatsPurge();
 $response = $interface->PerfCollectClientOperationStatistics();
 $response = $interface->PerfCopyCounterConfiguration();
 $response = $interface->PerfCounterGroupCreate();
 $response = $interface->PerfCounterGroupDestroy();
 $response = $interface->PerfCounterGroupGetData();
 $response = $interface->PerfCounterGroupGetDynamicDataSources();
 $response = $interface->PerfCounterGroupListInfo();
 $response = $interface->PerfCounterGroupListIterEnd();
 $response = $interface->PerfCounterGroupListIterNext();
 $response = $interface->PerfCounterGroupListIterStart();
 $response = $interface->PerfCounterGroupModify();
 $response = $interface->PerfCounterGroupStart();
 $response = $interface->PerfCounterGroupStop();
 $response = $interface->PerfDiagTroubleshoot();
 $response = $interface->PerfDisableDataCollection();
 $response = $interface->PerfDisableObjectUpdate();
 $response = $interface->PerfEnableDataCollection();
 $response = $interface->PerfEnableObjectUpdate();
 $response = $interface->PerfGetCounterData();
 $response = $interface->PerfGetCounterDependents();
 $response = $interface->PerfGetCounterListNotInView();
 $response = $interface->PerfGetDefaultView();
 $response = $interface->PerfGetServerStatus();
 $response = $interface->PerfObjectCounterListInfo();
 $response = $interface->PerfObjectDependentCounterListInfo();
 $response = $interface->PerfObjectInstanceListIterEnd();
 $response = $interface->PerfObjectInstanceListIterNext();
 $response = $interface->PerfObjectInstanceListIterStart();
 $response = $interface->PerfObjectListInfo();
 $response = $interface->PerfSetDefaultView();
 $response = $interface->PerfStatusGet();
 $response = $interface->PerfThresholdCreate();
 $response = $interface->PerfThresholdCreate2();
 $response = $interface->PerfThresholdDelete();
 $response = $interface->PerfThresholdListInfoIterEnd();
 $response = $interface->PerfThresholdListInfoIterNext();
 $response = $interface->PerfThresholdListInfoIterStart();
 $response = $interface->PerfThresholdListInfo2IterEnd();
 $response = $interface->PerfThresholdListInfo2IterNext();
 $response = $interface->PerfThresholdListInfo2IterStart();
 $response = $interface->PerfThresholdModify();
 $response = $interface->PerfThresholdModify2();
 $response = $interface->PerfThresholdTemplateAttachObjects();
 $response = $interface->PerfThresholdTemplateCreate();
 $response = $interface->PerfThresholdTemplateDelete();
 $response = $interface->PerfThresholdTemplateDetachObjects();
 $response = $interface->PerfThresholdTemplateListInfoIterEnd();
 $response = $interface->PerfThresholdTemplateListInfoIterNext();
 $response = $interface->PerfThresholdTemplateListInfoIterStart();
 $response = $interface->PerfThresholdTemplateModify();
 $response = $interface->PerfViewAssociatedObjectsList();
 $response = $interface->PerfViewCreate();
 $response = $interface->PerfViewDestroy();
 $response = $interface->PerfViewGetData();
 $response = $interface->PerfViewListIterEnd();
 $response = $interface->PerfViewListIterNext();
 $response = $interface->PerfViewListIterStart();
 $response = $interface->PerfViewModify();
 $response = $interface->PerfViewObjectAssociationAdd();
 $response = $interface->PerfViewObjectAssociationDelete();
 $response = $interface->ProvisioningPolicyCopy();
 $response = $interface->ProvisioningPolicyCreate();
 $response = $interface->ProvisioningPolicyDestroy();
 $response = $interface->ProvisioningPolicyEditBegin();
 $response = $interface->ProvisioningPolicyEditCommit();
 $response = $interface->ProvisioningPolicyEditRollback();
 $response = $interface->ProvisioningPolicyListIterEnd();
 $response = $interface->ProvisioningPolicyListIterNext();
 $response = $interface->ProvisioningPolicyListIterStart();
 $response = $interface->ProvisioningPolicyModify();
 $response = $interface->QtreeListInfoIterEnd();
 $response = $interface->QtreeListInfoIterNext();
 $response = $interface->QtreeListInfoIterStart();
 $response = $interface->QtreeModify();
 $response = $interface->QtreeRename();
 $response = $interface->QtreeStartMonitoring();
 $response = $interface->QtreeStopMonitoring();
 $response = $interface->RbacAccessCheck();
 $response = $interface->RbacAdminListInfoIterEnd();
 $response = $interface->RbacAdminListInfoIterNext();
 $response = $interface->RbacAdminListInfoIterStart();
 $response = $interface->RbacAdminRoleAdd();
 $response = $interface->RbacAdminRoleInfoList();
 $response = $interface->RbacAdminRoleRemove();
 $response = $interface->RbacOperationAdd();
 $response = $interface->RbacOperationDelete();
 $response = $interface->RbacOperationInfoList();
 $response = $interface->RbacRoleAdd();
 $response = $interface->RbacRoleAdminInfoList();
 $response = $interface->RbacRoleCapabilityAdd();
 $response = $interface->RbacRoleCapabilityRemove();
 $response = $interface->RbacRoleDelete();
 $response = $interface->RbacRoleDisinherit();
 $response = $interface->RbacRoleInfoList();
 $response = $interface->RbacRoleInherit();
 $response = $interface->RbacRoleModify();
 $response = $interface->ReportCategoryList();
 $response = $interface->ReportDesignerList();
 $response = $interface->ReportDesignerScheduleAdd();
 $response = $interface->ReportDesignerScheduleDelete();
 $response = $interface->ReportDesignerScheduleModify();
 $response = $interface->ReportDesignerShare();
 $response = $interface->ReportGraphListInfoIterEnd();
 $response = $interface->ReportGraphListInfoIterNext();
 $response = $interface->ReportGraphListInfoIterStart();
 $response = $interface->ReportListInfoIterEnd();
 $response = $interface->ReportListInfoIterNext();
 $response = $interface->ReportListInfoIterStart();
 $response = $interface->ReportOutputDelete();
 $response = $interface->ReportOutputListInfoIterEnd();
 $response = $interface->ReportOutputListInfoIterNext();
 $response = $interface->ReportOutputListInfoIterStart();
 $response = $interface->ReportOutputRead();
 $response = $interface->ReportScheduleAdd();
 $response = $interface->ReportScheduleDelete();
 $response = $interface->ReportScheduleDisable();
 $response = $interface->ReportScheduleEnable();
 $response = $interface->ReportScheduleListInfoIterEnd();
 $response = $interface->ReportScheduleListInfoIterNext();
 $response = $interface->ReportScheduleListInfoIterStart();
 $response = $interface->ReportScheduleModify();
 $response = $interface->ReportScheduleRun();
 $response = $interface->ResourcepoolAddMember();
 $response = $interface->ResourcepoolCreate();
 $response = $interface->ResourcepoolDestroy();
 $response = $interface->ResourcepoolGetDefaults();
 $response = $interface->ResourcepoolListInfoIterEnd();
 $response = $interface->ResourcepoolListInfoIterNext();
 $response = $interface->ResourcepoolListInfoIterStart();
 $response = $interface->ResourcepoolMemberListInfoIterEnd();
 $response = $interface->ResourcepoolMemberListInfoIterNext();
 $response = $interface->ResourcepoolMemberListInfoIterStart();
 $response = $interface->ResourcepoolModify();
 $response = $interface->ResourcepoolModifyMember();
 $response = $interface->ResourcepoolRemoveMember();
 $response = $interface->ResourcepoolUpdateFreeSpaceStatus();
 $response = $interface->SnapshotGetReclaimableInfo();
 $response = $interface->SnapshotListInfoIterEnd();
 $response = $interface->SnapshotListInfoIterNext();
 $response = $interface->SnapshotListInfoIterStart();
 $response = $interface->SrmFileTypeAdd();
 $response = $interface->SrmFileTypeDelete();
 $response = $interface->SrmFileTypeListInfo();
 $response = $interface->StorageServiceCreate();
 $response = $interface->StorageServiceDatasetListIterEnd();
 $response = $interface->StorageServiceDatasetListIterNext();
 $response = $interface->StorageServiceDatasetListIterStart();
 $response = $interface->StorageServiceDatasetModify();
 $response = $interface->StorageServiceDatasetProvision();
 $response = $interface->StorageServiceDestroy();
 $response = $interface->StorageServiceListInfoIterEnd();
 $response = $interface->StorageServiceListInfoIterNext();
 $response = $interface->StorageServiceListInfoIterStart();
 $response = $interface->StorageServiceModify();
 $response = $interface->TimezoneGetDefaults();
 $response = $interface->TimezoneListInfoIterEnd();
 $response = $interface->TimezoneListInfoIterNext();
 $response = $interface->TimezoneListInfoIterStart();
 $response = $interface->TimezoneValidate();
 $response = $interface->UserFavoriteReportDelete();
 $response = $interface->UserFavoriteReportListInfoIterEnd();
 $response = $interface->UserFavoriteReportListInfoIterNext();
 $response = $interface->UserFavoriteReportListInfoIterStart();
 $response = $interface->UserRecentReportDelete();
 $response = $interface->UserRecentReportListInfoIterEnd();
 $response = $interface->UserRecentReportListInfoIterNext();
 $response = $interface->UserRecentReportListInfoIterStart();
 $response = $interface->VfilerCreate();
 $response = $interface->VfilerDestroy();
 $response = $interface->VfilerSetup();
 $response = $interface->VfilerTemplateCopy();
 $response = $interface->VfilerTemplateCreate();
 $response = $interface->VfilerTemplateDelete();
 $response = $interface->VfilerTemplateListInfoIterEnd();
 $response = $interface->VfilerTemplateListInfoIterNext();
 $response = $interface->VfilerTemplateListInfoIterStart();
 $response = $interface->VfilerTemplateModify();
 $response = $interface->ViDatacenterListInfoIterEnd();
 $response = $interface->ViDatacenterListInfoIterNext();
 $response = $interface->ViDatacenterListInfoIterStart();
 $response = $interface->ViDatastoreListInfoIterEnd();
 $response = $interface->ViDatastoreListInfoIterNext();
 $response = $interface->ViDatastoreListInfoIterStart();
 $response = $interface->ViHypervisorListInfoIterEnd();
 $response = $interface->ViHypervisorListInfoIterNext();
 $response = $interface->ViHypervisorListInfoIterStart();
 $response = $interface->ViVirtualCenterListInfoIterEnd();
 $response = $interface->ViVirtualCenterListInfoIterNext();
 $response = $interface->ViVirtualCenterListInfoIterStart();
 $response = $interface->ViVirtualDiskListInfoIterEnd();
 $response = $interface->ViVirtualDiskListInfoIterNext();
 $response = $interface->ViVirtualDiskListInfoIterStart();
 $response = $interface->ViVirtualMachineListInfoIterEnd();
 $response = $interface->ViVirtualMachineListInfoIterNext();
 $response = $interface->ViVirtualMachineListInfoIterStart();
 $response = $interface->VolumeDedupe();
 $response = $interface->VolumeDestroy();
 $response = $interface->VolumeListInfoIterEnd();
 $response = $interface->VolumeListInfoIterNext();
 $response = $interface->VolumeListInfoIterStart();
 $response = $interface->VolumeModify();
 $response = $interface->VolumeResize();



=head1 DESCRIPTION

SOAP Interface for the DfmService web service
located at https://HOST_NAME:8488/apis/soap/v1.

=head1 SERVICE DfmService



=head2 Port DfmPort



=head1 METHODS

=head2 General methods

=head3 new

Constructor.

All arguments are forwarded to L<SOAP::WSDL::Client|SOAP::WSDL::Client>.

=head2 SOAP Service methods

Method synopsis is displayed with hash refs as parameters.

The commented class names in the method's parameters denote that objects
of the corresponding class can be passed instead of the marked hash ref.

You may pass any combination of objects, hash and list refs to these
methods, as long as you meet the structure.

List items (i.e. multiple occurences) are not displayed in the synopsis.
You may generally pass a list ref of hash refs (or objects) instead of a hash
ref - this may result in invalid XML if used improperly, though. Note that
SOAP::WSDL always expects list references at maximum depth position.

XML attributes are not displayed in this synopsis and cannot be set using
hash refs. See the respective class' documentation for additional information.



=head3 AggregateListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::AggregateListInfoIterEndResult|MyElements::AggregateListInfoIterEndResult> object.

 $response = $interface->AggregateListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 AggregateListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::AggregateListInfoIterNextResult|MyElements::AggregateListInfoIterNextResult> object.

 $response = $interface->AggregateListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 AggregateListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::AggregateListInfoIterStartResult|MyElements::AggregateListInfoIterStartResult> object.

 $response = $interface->AggregateListInfoIterStart( {
    AggregateType =>  $some_value, # string
    BlockType => $some_value, # FileSystemBlockType
    IncludeDatasetSpaceInfo =>  $some_value, # boolean
    IncludeIsAvailable =>  $some_value, # boolean
    IsDirectMemberOnly =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsInDataset =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId =>  $some_value, # string
    RbacOperation =>  $some_value, # string
    ResourcepoolFilter =>  $some_value, # string
    VolumesToMigrate =>  { # MyTypes::ArrayOfObjectNameOrId
      ObjectNameOrId => $some_value, # ObjectNameOrId
    },
  },,
 );

=head3 AggregateModify

EOBJECTNOTFOUND 

Returns a L<MyElements::AggregateModifyResult|MyElements::AggregateModifyResult> object.

 $response = $interface->AggregateModify( {
    AggregateNameOrId =>  $some_value, # string
    IsDpIgnored =>  $some_value, # boolean
  },,
 );

=head3 AggregateSpaceManagementAddOperation

ESPACEMGMTSESSIONNOTFOUND 

Returns a L<MyElements::AggregateSpaceManagementAddOperationResult|MyElements::AggregateSpaceManagementAddOperationResult> object.

 $response = $interface->AggregateSpaceManagementAddOperation( {
    SpaceManagementOperationInfo =>  { # MyTypes::SpaceManagementOperationInfo
      BackupDeletionRequestInfo =>  { # MyTypes::BackupDeletionRequestInfo
        BackupIds =>  { # MyTypes::ArrayOfBackupId
          BackupId => $some_value, # BackupId
        },
      },
      DedupeRequestInfo =>  { # MyTypes::DedupeRequestInfo
        FullVolumeDedupe =>  $some_value, # boolean
      },
      ObjectNameOrId => $some_value, # ObjNameOrId
      ResizeVolumeRequestInfo =>  { # MyTypes::ResizeVolumeRequestInfo
        MaximumCapacity => $some_value, # atomic
        NewSize => $some_value, # atomic
        SnapReserve => $some_value, # atomic
      },
      SnapshotDeletionRequestInfo =>  { # MyTypes::SnapshotDeletionRequestInfo
        Snapshots =>  { # MyTypes::ArrayOfSnapshot
          Snapshot =>  { # MyTypes::Snapshot
            SnapshotName =>  $some_value, # string
            UniqueId =>  $some_value, # string
          },
        },
      },
      SpaceManagementOpType => $some_value, # SpaceManagementOpType
      VolumeMigrationRequestInfo =>  { # MyTypes::VolumeMigrationRequestInfo
        CleanupStaleStorage => $some_value, # CleanupStaleStorage
        DestinationAggregateNameOrId => $some_value, # ObjNameOrId
        RetentionType => $some_value, # DpBackupRetentionType
        RunDedupeScan =>  $some_value, # boolean
        RunOnDemandUpdate =>  $some_value, # boolean
      },
    },
    SpaceManagementSessionId => $some_value, # atomic
  },,
 );

=head3 AggregateSpaceManagementBegin

ESPACEMGMTSESSIONINPROGRESS 

Returns a L<MyElements::AggregateSpaceManagementBeginResult|MyElements::AggregateSpaceManagementBeginResult> object.

 $response = $interface->AggregateSpaceManagementBegin( {
    AggregateNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 AggregateSpaceManagementCommit

ESPACEMGMTSESSIONNOTFOUND 

Returns a L<MyElements::AggregateSpaceManagementCommitResult|MyElements::AggregateSpaceManagementCommitResult> object.

 $response = $interface->AggregateSpaceManagementCommit( {
    DryRun =>  $some_value, # boolean
    SpaceManagementSessionId => $some_value, # atomic
  },,
 );

=head3 AggregateSpaceManagementRemoveOperation

ESPCMGMTNOSUCHOP 

Returns a L<MyElements::AggregateSpaceManagementRemoveOperationResult|MyElements::AggregateSpaceManagementRemoveOperationResult> object.

 $response = $interface->AggregateSpaceManagementRemoveOperation( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    SpaceManagementOpType => $some_value, # SpaceManagementOpType
    SpaceManagementSessionId => $some_value, # atomic
  },,
 );

=head3 AggregateSpaceManagementRollback

ESPACEMGMTSESSIONNOTFOUND 

Returns a L<MyElements::AggregateSpaceManagementRollbackResult|MyElements::AggregateSpaceManagementRollbackResult> object.

 $response = $interface->AggregateSpaceManagementRollback( {
    SpaceManagementSessionId => $some_value, # atomic
  },,
 );

=head3 AlarmCreate

ERUNASUNSUPPORTED 

Returns a L<MyElements::AlarmCreateResult|MyElements::AlarmCreateResult> object.

 $response = $interface->AlarmCreate( {
    AlarmInfo =>  { # MyTypes::AlarmInfo
      AdminLoginNames =>  { # MyTypes::ArrayOfAdminName
        AdminName => $some_value, # AdminName
      },
      AlarmId => $some_value, # atomic
      AlarmScript =>  $some_value, # string
      AlarmScriptRunas =>  $some_value, # string
      EmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
        EmailAddress => $some_value, # EmailAddress
      },
      EventClass =>  $some_value, # string
      EventName =>  $some_value, # string
      EventSeverity => $some_value, # ObjStatus
      GroupId => $some_value, # atomic
      GroupName =>  $some_value, # string
      IsDisabled =>  $some_value, # boolean
      IsRepeatNotify =>  $some_value, # boolean
      PagerAdminLoginNames =>  { # MyTypes::ArrayOfAdminName
        AdminName => $some_value, # AdminName
      },
      PagerEmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
        EmailAddress => $some_value, # EmailAddress
      },
      RepeatInterval => $some_value, # atomic
      TimeFrom => $some_value, # atomic
      TimeTo => $some_value, # atomic
      TrapDestinations =>  { # MyTypes::ArrayOfTrapDestination
        TrapDestination =>  { # MyTypes::TrapDestination
          TrapCommunity =>  $some_value, # string
          TrapHost =>  $some_value, # string
          TrapPort => $some_value, # atomic
        },
      },
    },
  },,
 );

=head3 AlarmDestroy

EDATABASEERROR 

Returns a L<MyElements::AlarmDestroyResult|MyElements::AlarmDestroyResult> object.

 $response = $interface->AlarmDestroy( {
    AlarmId => $some_value, # atomic
  },,
 );

=head3 AlarmGetDefaults

supported 

Returns a L<MyElements::AlarmGetDefaultsResult|MyElements::AlarmGetDefaultsResult> object.

 $response = $interface->AlarmGetDefaults(,,
 );

=head3 AlarmListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::AlarmListInfoIterEndResult|MyElements::AlarmListInfoIterEndResult> object.

 $response = $interface->AlarmListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 AlarmListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::AlarmListInfoIterNextResult|MyElements::AlarmListInfoIterNextResult> object.

 $response = $interface->AlarmListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 AlarmListInfoIterStart

EDATABASEERROR 

Returns a L<MyElements::AlarmListInfoIterStartResult|MyElements::AlarmListInfoIterStartResult> object.

 $response = $interface->AlarmListInfoIterStart( {
    AlarmId => $some_value, # atomic
  },,
 );

=head3 AlarmModify

ERUNASUNSUPPORTED 

Returns a L<MyElements::AlarmModifyResult|MyElements::AlarmModifyResult> object.

 $response = $interface->AlarmModify( {
    AlarmInfo =>  { # MyTypes::AlarmInfo
      AdminLoginNames =>  { # MyTypes::ArrayOfAdminName
        AdminName => $some_value, # AdminName
      },
      AlarmId => $some_value, # atomic
      AlarmScript =>  $some_value, # string
      AlarmScriptRunas =>  $some_value, # string
      EmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
        EmailAddress => $some_value, # EmailAddress
      },
      EventClass =>  $some_value, # string
      EventName =>  $some_value, # string
      EventSeverity => $some_value, # ObjStatus
      GroupId => $some_value, # atomic
      GroupName =>  $some_value, # string
      IsDisabled =>  $some_value, # boolean
      IsRepeatNotify =>  $some_value, # boolean
      PagerAdminLoginNames =>  { # MyTypes::ArrayOfAdminName
        AdminName => $some_value, # AdminName
      },
      PagerEmailAddresses =>  { # MyTypes::ArrayOfEmailAddress
        EmailAddress => $some_value, # EmailAddress
      },
      RepeatInterval => $some_value, # atomic
      TimeFrom => $some_value, # atomic
      TimeTo => $some_value, # atomic
      TrapDestinations =>  { # MyTypes::ArrayOfTrapDestination
        TrapDestination =>  { # MyTypes::TrapDestination
          TrapCommunity =>  $some_value, # string
          TrapHost =>  $some_value, # string
          TrapPort => $some_value, # atomic
        },
      },
    },
  },,
 );

=head3 AlarmTest

EDATABASEERROR 

Returns a L<MyElements::AlarmTestResult|MyElements::AlarmTestResult> object.

 $response = $interface->AlarmTest( {
    AlarmId => $some_value, # atomic
  },,
 );

=head3 ApiProxy

EOBJECTNOTFOUND 

Returns a L<MyElements::ApiProxyResult|MyElements::ApiProxyResult> object.

 $response = $interface->ApiProxy( {
    Request =>  { # MyTypes::Request
      Args =>  {
      },
      Name =>  $some_value, # string
    },
    Target =>  $some_value, # string
    Timeout =>  $some_value, # integer
    Username =>  $some_value, # string
  },,
 );

=head3 ApplicationPolicyCopy

EPOLICYEXISTS 

Returns a L<MyElements::ApplicationPolicyCopyResult|MyElements::ApplicationPolicyCopyResult> object.

 $response = $interface->ApplicationPolicyCopy( {
    ApplicationPolicyDescription =>  $some_value, # string
    ApplicationPolicyName => $some_value, # ObjName
    GroupNameOrId => $some_value, # ObjNameOrId
    SourcePolicyNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ApplicationPolicyCreate

EPOLICYEXISTS 

Returns a L<MyElements::ApplicationPolicyCreateResult|MyElements::ApplicationPolicyCreateResult> object.

 $response = $interface->ApplicationPolicyCreate( {
    ApplicationPolicyInfo =>  { # MyTypes::ApplicationPolicyInfo
      ApplicationBackupOperationInfo =>  { # MyTypes::ApplicationBackupOperationInfo
        BackupSchedules =>  { # MyTypes::ArrayOfApplicationBackupScheduleInfo
          ApplicationBackupScheduleInfo =>  { # MyTypes::ApplicationBackupScheduleInfo
            HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
              AllowSavedStateBackup =>  $some_value, # boolean
            },
            RetentionType => $some_value, # DpBackupRetentionType
            ScheduleId =>  $some_value, # integer
            SimpleScheduleInfo =>  { # MyTypes::SimpleScheduleInfo
              DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
                DayOfMonth => $some_value, # DayOfMonth
              },
              DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
                DayOfWeek => $some_value, # DayOfWeek
              },
              TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
                EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                  TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                    Hour => $some_value, # atomic
                    Minute => $some_value, # atomic
                  },
                },
                Frequency => $some_value, # atomic
                StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                  TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                    Hour => $some_value, # atomic
                    Minute => $some_value, # atomic
                  },
                },
              },
            },
            StartRemoteBackupAfterLocalBackup =>  $some_value, # boolean
            VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
              CreateVmwareSnapshot =>  $some_value, # boolean
              IncludeIndependentDisks =>  $some_value, # boolean
            },
          },
        },
      },
      ApplicationPolicyDescription =>  $some_value, # string
      ApplicationPolicyId => $some_value, # ObjId
      ApplicationPolicyName => $some_value, # ObjName
      ApplicationPolicySettingsInfo =>  { # MyTypes::ApplicationPolicySettingsInfo
        BackupScript =>  $some_value, # string
        DailyRetentionCount => $some_value, # atomic
        DailyRetentionDuration => $some_value, # atomic
        HourlyRetentionCount => $some_value, # atomic
        HourlyRetentionDuration => $some_value, # atomic
        IsLagErrorEnabled =>  $some_value, # boolean
        IsLagWarningEnabled =>  $some_value, # boolean
        LagErrorThreshold => $some_value, # atomic
        LagWarningThreshold => $some_value, # atomic
        MonthlyRetentionCount => $some_value, # atomic
        MonthlyRetentionDuration => $some_value, # atomic
        WeeklyRetentionCount => $some_value, # atomic
        WeeklyRetentionDuration => $some_value, # atomic
      },
      ApplicationPolicyType => $some_value, # ApplicationPolicyType
      GroupNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 ApplicationPolicyDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::ApplicationPolicyDestroyResult|MyElements::ApplicationPolicyDestroyResult> object.

 $response = $interface->ApplicationPolicyDestroy( {
    ApplicationPolicyNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 ApplicationPolicyEditBegin

EOBJECTNOTFOUND 

Returns a L<MyElements::ApplicationPolicyEditBeginResult|MyElements::ApplicationPolicyEditBeginResult> object.

 $response = $interface->ApplicationPolicyEditBegin( {
    ApplicationPolicyNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 ApplicationPolicyEditCommit

EPOLICYEXISTS 

Returns a L<MyElements::ApplicationPolicyEditCommitResult|MyElements::ApplicationPolicyEditCommitResult> object.

 $response = $interface->ApplicationPolicyEditCommit( {
    DryRun =>  $some_value, # boolean
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 ApplicationPolicyEditRollback

EEDITSESSIONNOTFOUND 

Returns a L<MyElements::ApplicationPolicyEditRollbackResult|MyElements::ApplicationPolicyEditRollbackResult> object.

 $response = $interface->ApplicationPolicyEditRollback( {
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 ApplicationPolicyListIterEnd

EINVALIDTAG 

Returns a L<MyElements::ApplicationPolicyListIterEndResult|MyElements::ApplicationPolicyListIterEndResult> object.

 $response = $interface->ApplicationPolicyListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ApplicationPolicyListIterNext

EINVALIDTAG 

Returns a L<MyElements::ApplicationPolicyListIterNextResult|MyElements::ApplicationPolicyListIterNextResult> object.

 $response = $interface->ApplicationPolicyListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ApplicationPolicyListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ApplicationPolicyListIterStartResult|MyElements::ApplicationPolicyListIterStartResult> object.

 $response = $interface->ApplicationPolicyListIterStart( {
    ApplicationPolicyType => $some_value, # ApplicationPolicyType
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ApplicationPolicyModify

EOBJECTNOTFOUND 

Returns a L<MyElements::ApplicationPolicyModifyResult|MyElements::ApplicationPolicyModifyResult> object.

 $response = $interface->ApplicationPolicyModify( {
    ApplicationPolicyInfo =>  { # MyTypes::ApplicationPolicyInfo
      ApplicationBackupOperationInfo =>  { # MyTypes::ApplicationBackupOperationInfo
        BackupSchedules =>  { # MyTypes::ArrayOfApplicationBackupScheduleInfo
          ApplicationBackupScheduleInfo =>  { # MyTypes::ApplicationBackupScheduleInfo
            HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
              AllowSavedStateBackup =>  $some_value, # boolean
            },
            RetentionType => $some_value, # DpBackupRetentionType
            ScheduleId =>  $some_value, # integer
            SimpleScheduleInfo =>  { # MyTypes::SimpleScheduleInfo
              DaysOfMonth =>  { # MyTypes::ArrayOfDayOfMonth
                DayOfMonth => $some_value, # DayOfMonth
              },
              DaysOfWeek =>  { # MyTypes::ArrayOfDayOfWeek
                DayOfWeek => $some_value, # DayOfWeek
              },
              TimesOfDayInfo =>  { # MyTypes::TimesOfDayInfo
                EndTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                  TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                    Hour => $some_value, # atomic
                    Minute => $some_value, # atomic
                  },
                },
                Frequency => $some_value, # atomic
                StartTime =>  { # MyTypes::WrapperOfTimeOfDayInfo
                  TimeOfDayInfo =>  { # MyTypes::TimeOfDayInfo
                    Hour => $some_value, # atomic
                    Minute => $some_value, # atomic
                  },
                },
              },
            },
            StartRemoteBackupAfterLocalBackup =>  $some_value, # boolean
            VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
              CreateVmwareSnapshot =>  $some_value, # boolean
              IncludeIndependentDisks =>  $some_value, # boolean
            },
          },
        },
      },
      ApplicationPolicyDescription =>  $some_value, # string
      ApplicationPolicyId => $some_value, # ObjId
      ApplicationPolicyName => $some_value, # ObjName
      ApplicationPolicySettingsInfo =>  { # MyTypes::ApplicationPolicySettingsInfo
        BackupScript =>  $some_value, # string
        DailyRetentionCount => $some_value, # atomic
        DailyRetentionDuration => $some_value, # atomic
        HourlyRetentionCount => $some_value, # atomic
        HourlyRetentionDuration => $some_value, # atomic
        IsLagErrorEnabled =>  $some_value, # boolean
        IsLagWarningEnabled =>  $some_value, # boolean
        LagErrorThreshold => $some_value, # atomic
        LagWarningThreshold => $some_value, # atomic
        MonthlyRetentionCount => $some_value, # atomic
        MonthlyRetentionDuration => $some_value, # atomic
        WeeklyRetentionCount => $some_value, # atomic
        WeeklyRetentionDuration => $some_value, # atomic
      },
      ApplicationPolicyType => $some_value, # ApplicationPolicyType
      GroupNameOrId => $some_value, # ObjNameOrId
    },
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 AuditLogAddEntry

EINVALIDINPUT 

Returns a L<MyElements::AuditLogAddEntryResult|MyElements::AuditLogAddEntryResult> object.

 $response = $interface->AuditLogAddEntry( {
    AuditApplicationName =>  $some_value, # string
    AuditInterface =>  $some_value, # string
    AuditIpAddress =>  $some_value, # string
    AuditMessage =>  $some_value, # string
    AuditPriority =>  $some_value, # string
    AuditType =>  $some_value, # string
  },,
 );

=head3 CifsDomainListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::CifsDomainListInfoIterEndResult|MyElements::CifsDomainListInfoIterEndResult> object.

 $response = $interface->CifsDomainListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 CifsDomainListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::CifsDomainListInfoIterNextResult|MyElements::CifsDomainListInfoIterNextResult> object.

 $response = $interface->CifsDomainListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 CifsDomainListInfoIterStart

EDATABASEERROR 

Returns a L<MyElements::CifsDomainListInfoIterStartResult|MyElements::CifsDomainListInfoIterStartResult> object.

 $response = $interface->CifsDomainListInfoIterStart(,,
 );

=head3 ClientRegistryDestroy

ENAMENOTFOUND 

Returns a L<MyElements::ClientRegistryDestroyResult|MyElements::ClientRegistryDestroyResult> object.

 $response = $interface->ClientRegistryDestroy( {
    ApplicationName =>  $some_value, # string
    Match =>  $some_value, # string
    Option =>  $some_value, # string
  },,
 );

=head3 ClientRegistryGet

ENAMENOTFOUND 

Returns a L<MyElements::ClientRegistryGetResult|MyElements::ClientRegistryGetResult> object.

 $response = $interface->ClientRegistryGet( {
    ApplicationName =>  $some_value, # string
    Match =>  $some_value, # string
    Option =>  $some_value, # string
  },,
 );

=head3 ClientRegistrySet

supported 

Returns a L<MyElements::ClientRegistrySetResult|MyElements::ClientRegistrySetResult> object.

 $response = $interface->ClientRegistrySet( {
    ApplicationName =>  $some_value, # string
    Options =>  { # MyTypes::ArrayOfClientOptionInfo
      ClientOptionInfo =>  { # MyTypes::ClientOptionInfo
        Option =>  $some_value, # string
        Value =>  $some_value, # string
      },
    },
  },,
 );

=head3 CommentFieldCreate

EINVALIDINPUT 

Returns a L<MyElements::CommentFieldCreateResult|MyElements::CommentFieldCreateResult> object.

 $response = $interface->CommentFieldCreate( {
    CommentFieldInfo =>  { # MyTypes::CommentFieldInfo
      CommentFieldId => $some_value, # CommentFieldId
      CommentFieldName => $some_value, # CommentFieldName
      CommentFieldObjectTypes =>  { # MyTypes::ArrayOfCommentFieldObjectType
        CommentFieldObjectType => $some_value, # CommentFieldObjectType
      },
      IsSystemComment =>  $some_value, # boolean
    },
  },,
 );

=head3 CommentFieldDestroy

ESYSTEMCOMMENTFIELD 

Returns a L<MyElements::CommentFieldDestroyResult|MyElements::CommentFieldDestroyResult> object.

 $response = $interface->CommentFieldDestroy( {
    CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
  },,
 );

=head3 CommentFieldListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::CommentFieldListInfoIterEndResult|MyElements::CommentFieldListInfoIterEndResult> object.

 $response = $interface->CommentFieldListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 CommentFieldListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::CommentFieldListInfoIterNextResult|MyElements::CommentFieldListInfoIterNextResult> object.

 $response = $interface->CommentFieldListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 CommentFieldListInfoIterStart

EDATABASEERROR 

Returns a L<MyElements::CommentFieldListInfoIterStartResult|MyElements::CommentFieldListInfoIterStartResult> object.

 $response = $interface->CommentFieldListInfoIterStart( {
    CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
    CommentFieldObjectTypes =>  { # MyTypes::ArrayOfCommentFieldObjectType
      CommentFieldObjectType => $some_value, # CommentFieldObjectType
    },
    ShowSystemComments =>  $some_value, # boolean
  },,
 );

=head3 CommentFieldModify

ESYSTEMCOMMENTFIELD 

Returns a L<MyElements::CommentFieldModifyResult|MyElements::CommentFieldModifyResult> object.

 $response = $interface->CommentFieldModify( {
    CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
    CommentFieldObjectTypes =>  { # MyTypes::ArrayOfCommentFieldObjectType
      CommentFieldObjectType => $some_value, # CommentFieldObjectType
    },
    NewCommentFieldName => $some_value, # CommentFieldName
  },,
 );

=head3 CommentFieldValuesListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::CommentFieldValuesListInfoIterEndResult|MyElements::CommentFieldValuesListInfoIterEndResult> object.

 $response = $interface->CommentFieldValuesListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 CommentFieldValuesListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::CommentFieldValuesListInfoIterNextResult|MyElements::CommentFieldValuesListInfoIterNextResult> object.

 $response = $interface->CommentFieldValuesListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 CommentFieldValuesListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::CommentFieldValuesListInfoIterStartResult|MyElements::CommentFieldValuesListInfoIterStartResult> object.

 $response = $interface->CommentFieldValuesListInfoIterStart( {
    CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
    CommentFieldObjectTypes =>  { # MyTypes::ArrayOfCommentFieldObjectType
      CommentFieldObjectType => $some_value, # CommentFieldObjectType
    },
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 CommentSetObjectValue

EOBJECTNOTFOUND 

Returns a L<MyElements::CommentSetObjectValueResult|MyElements::CommentSetObjectValueResult> object.

 $response = $interface->CommentSetObjectValue( {
    CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
    CommentValue => $some_value, # CommentValue
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetAddMember

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetAddMemberResult|MyElements::DatasetAddMemberResult> object.

 $response = $interface->DatasetAddMember( {
    DatasetMemberParameters =>  { # MyTypes::ArrayOfDatasetMemberParameter
      DatasetMemberParameter =>  { # MyTypes::DatasetMemberParameter
        DpNodeName => $some_value, # DpPolicyNodeName
        ObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    EditLockId => $some_value, # atomic
    IsExistingMemberOk =>  $some_value, # boolean
  },,
 );

=head3 DatasetAddMemberByDynamicReference

ESTORAGE_MAP_NOT_FOUND 

Returns a L<MyElements::DatasetAddMemberByDynamicReferenceResult|MyElements::DatasetAddMemberByDynamicReferenceResult> object.

 $response = $interface->DatasetAddMemberByDynamicReference( {
    DatasetDynamicReferenceParameters =>  { # MyTypes::ArrayOfDatasetDynamicReferenceParameter
      DatasetDynamicReferenceParameter =>  { # MyTypes::DatasetDynamicReferenceParameter
        DpNodeName => $some_value, # DpPolicyNodeName
        ObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    EditLockId => $some_value, # atomic
  },,
 );

=head3 DatasetAddResourcepool

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetAddResourcepoolResult|MyElements::DatasetAddResourcepoolResult> object.

 $response = $interface->DatasetAddResourcepool( {
    DpNodeName => $some_value, # DpPolicyNodeName
    EditLockId => $some_value, # atomic
    ResourcepoolNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetAddToExclusionList

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetAddToExclusionListResult|MyElements::DatasetAddToExclusionListResult> object.

 $response = $interface->DatasetAddToExclusionList( {
    EditLockId => $some_value, # atomic
    IsExcludedMemberOk =>  $some_value, # boolean
    ObjectsToBeAdded =>  { # MyTypes::ArrayOfObjNameOrId
      ObjNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 DatasetBeginFailover

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetBeginFailoverResult|MyElements::DatasetBeginFailoverResult> object.

 $response = $interface->DatasetBeginFailover( {
    DatasetNameOrId =>  $some_value, # string
  },,
 );

=head3 DatasetBeginFailoverScriptTest

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetBeginFailoverScriptTestResult|MyElements::DatasetBeginFailoverScriptTestResult> object.

 $response = $interface->DatasetBeginFailoverScriptTest( {
    DatasetNameOrId =>  $some_value, # string
  },,
 );

=head3 DatasetChangeDrState

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetChangeDrStateResult|MyElements::DatasetChangeDrStateResult> object.

 $response = $interface->DatasetChangeDrState( {
    AllowInternalTransitions =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    DrState => $some_value, # DrState
  },,
 );

=head3 DatasetComputeUsageMetric

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetComputeUsageMetricResult|MyElements::DatasetComputeUsageMetricResult> object.

 $response = $interface->DatasetComputeUsageMetric( {
    ComputeIoUsageMetric =>  $some_value, # boolean
    ComputeSpaceUsageMetric =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    Timestamp => $some_value, # DpTimestamp
  },,
 );

=head3 DatasetConformBegin

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetConformBeginResult|MyElements::DatasetConformBeginResult> object.

 $response = $interface->DatasetConformBegin( {
    AssumeConfirmation =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetCreate

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetCreateResult|MyElements::DatasetCreateResult> object.

 $response = $interface->DatasetCreate( {
    ApplicationInfo =>  { # MyTypes::ApplicationInfo
      ApplicationName =>  $some_value, # string
      ApplicationServerName =>  $some_value, # string
      ApplicationVersion =>  $some_value, # string
      CarryPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
    },
    ApplicationPolicyNameOrId => $some_value, # ObjNameOrId
    DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
      IpAddress =>  $some_value, # string
      Netmask =>  $some_value, # string
    },
    DatasetContact => $some_value, # EmailAddressList
    DatasetDescription =>  $some_value, # string
    DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
      DfmMetadataField =>  { # MyTypes::DfmMetadataField
        FieldName =>  $some_value, # string
        FieldValue =>  $some_value, # string
      },
    },
    DatasetName => $some_value, # ObjName
    DatasetOwner =>  $some_value, # string
    GroupNameOrId => $some_value, # ObjNameOrId
    IsApplicationData =>  $some_value, # boolean
    IsDpSuspended =>  $some_value, # boolean
    IsSuspended =>  $some_value, # boolean
    OnlineMigration =>  $some_value, # boolean
    PrimaryVolumeNameFormat => $some_value, # PrimaryVolumeNameFormat
    ProtectionPolicyId => $some_value, # ObjId
    ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
    RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
    SecondaryQtreeNameFormat => $some_value, # SecondaryQtreeNameFormat
    SecondaryVolumeNameFormat => $some_value, # SecondaryVolumeNameFormat
    SnapshotNameFormat => $some_value, # SnapshotNameFormat
    TimezoneName =>  $some_value, # string
    VfilerNameOrId => $some_value, # ObjNameOrId
    VolumeQtreeNamePrefix =>  $some_value, # string
  },,
 );

=head3 DatasetDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetDestroyResult|MyElements::DatasetDestroyResult> object.

 $response = $interface->DatasetDestroy( {
    CancelEditSessions =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 DatasetDynamicReferenceListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetDynamicReferenceListInfoIterEndResult|MyElements::DatasetDynamicReferenceListInfoIterEndResult> object.

 $response = $interface->DatasetDynamicReferenceListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetDynamicReferenceListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetDynamicReferenceListInfoIterNextResult|MyElements::DatasetDynamicReferenceListInfoIterNextResult> object.

 $response = $interface->DatasetDynamicReferenceListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetDynamicReferenceListInfoIterStart

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetDynamicReferenceListInfoIterStartResult|MyElements::DatasetDynamicReferenceListInfoIterStartResult> object.

 $response = $interface->DatasetDynamicReferenceListInfoIterStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    DpNodeName => $some_value, # DpPolicyNodeName
    DynamicReferenceType =>  $some_value, # string
    IncludeDeleted =>  $some_value, # boolean
    IncludeIsAvailable =>  $some_value, # boolean
    StoragesetNameOrId => $some_value, # ObjNameOrId
    SuppressStatusRefresh =>  $some_value, # boolean
  },,
 );

=head3 DatasetEditBegin

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetEditBeginResult|MyElements::DatasetEditBeginResult> object.

 $response = $interface->DatasetEditBegin( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 DatasetEditCommit

EEDITSESSIONNOTFOUND 

Returns a L<MyElements::DatasetEditCommitResult|MyElements::DatasetEditCommitResult> object.

 $response = $interface->DatasetEditCommit( {
    AssumeConfirmation =>  $some_value, # boolean
    DryRun =>  $some_value, # boolean
    EditLockId => $some_value, # atomic
    IncludeDryRunReasonDetails =>  $some_value, # boolean
  },,
 );

=head3 DatasetEditRollback

EEDITSESSIONNOTFOUND 

Returns a L<MyElements::DatasetEditRollbackResult|MyElements::DatasetEditRollbackResult> object.

 $response = $interface->DatasetEditRollback( {
    EditLockId => $some_value, # atomic
  },,
 );

=head3 DatasetExclusionListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetExclusionListInfoIterEndResult|MyElements::DatasetExclusionListInfoIterEndResult> object.

 $response = $interface->DatasetExclusionListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetExclusionListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetExclusionListInfoIterNextResult|MyElements::DatasetExclusionListInfoIterNextResult> object.

 $response = $interface->DatasetExclusionListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetExclusionListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetExclusionListInfoIterStartResult|MyElements::DatasetExclusionListInfoIterStartResult> object.

 $response = $interface->DatasetExclusionListInfoIterStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    IncludeDeleted =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetIoMetricListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetIoMetricListInfoIterEndResult|MyElements::DatasetIoMetricListInfoIterEndResult> object.

 $response = $interface->DatasetIoMetricListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetIoMetricListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetIoMetricListInfoIterNextResult|MyElements::DatasetIoMetricListInfoIterNextResult> object.

 $response = $interface->DatasetIoMetricListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetIoMetricListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetIoMetricListInfoIterStartResult|MyElements::DatasetIoMetricListInfoIterStartResult> object.

 $response = $interface->DatasetIoMetricListInfoIterStart( {
    Day => $some_value, # atomic
    Month => $some_value, # Month
    ObjectNameOrId => $some_value, # ObjNameOrId
    Year => $some_value, # atomic
  },,
 );

=head3 DatasetListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetListInfoIterEndResult|MyElements::DatasetListInfoIterEndResult> object.

 $response = $interface->DatasetListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetListInfoIterNextResult|MyElements::DatasetListInfoIterNextResult> object.

 $response = $interface->DatasetListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetListInfoIterStartResult|MyElements::DatasetListInfoIterStartResult> object.

 $response = $interface->DatasetListInfoIterStart( {
    ApplicationName =>  $some_value, # string
    ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
    ApplicationServerName =>  $some_value, # string
    DrState => $some_value, # DrState
    HasApplicationPolicy =>  $some_value, # boolean
    HasProtection =>  $some_value, # boolean
    HasProtectionPolicy =>  $some_value, # boolean
    IncludeCanContainApplicationResourcesOnly =>  $some_value, # boolean
    IncludeCanContainStorageResourcesOnly =>  $some_value, # boolean
    IncludeConformanceCheckResults =>  $some_value, # boolean
    IncludeConformanceRunReasonDetails =>  $some_value, # boolean
    IncludeExportSettings =>  $some_value, # boolean
    IncludeMetadata =>  $some_value, # boolean
    IncludeMigrationInfo =>  $some_value, # boolean
    IncludeProtectionStatusProblems =>  $some_value, # boolean
    IsApplicationData =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsDrCapable =>  $some_value, # boolean
    IsProtected =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
    SuppressStatusRefresh =>  $some_value, # boolean
    VolumeQtreeNamePrefix =>  $some_value, # string
  },,
 );

=head3 DatasetMemberDedupeAbort

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetMemberDedupeAbortResult|MyElements::DatasetMemberDedupeAbortResult> object.

 $response = $interface->DatasetMemberDedupeAbort( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    VolumeNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetMemberDedupeStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetMemberDedupeStartResult|MyElements::DatasetMemberDedupeStartResult> object.

 $response = $interface->DatasetMemberDedupeStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    DedupeMemberRequestInfo =>  { # MyTypes::DedupeMemberRequestInfo
      FullVolumeDedupe =>  $some_value, # boolean
      VolumeId => $some_value, # ObjId
      VolumeName => $some_value, # ObjName
    },
  },,
 );

=head3 DatasetMemberDeleteSnapshots

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetMemberDeleteSnapshotsResult|MyElements::DatasetMemberDeleteSnapshotsResult> object.

 $response = $interface->DatasetMemberDeleteSnapshots( {
    DeleteSnapshotsRequestInfo =>  { # MyTypes::DeleteSnapshotsRequestInfo
      Snapshots =>  { # MyTypes::ArrayOfSnapshot
        Snapshot =>  { # MyTypes::Snapshot
          SnapshotName =>  $some_value, # string
          UniqueId =>  $some_value, # string
        },
      },
      VolumeId => $some_value, # ObjId
      VolumeName => $some_value, # ObjName
    },
    EditLockId => $some_value, # atomic
  },,
 );

=head3 DatasetMemberListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetMemberListInfoIterEndResult|MyElements::DatasetMemberListInfoIterEndResult> object.

 $response = $interface->DatasetMemberListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetMemberListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetMemberListInfoIterNextResult|MyElements::DatasetMemberListInfoIterNextResult> object.

 $response = $interface->DatasetMemberListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetMemberListInfoIterStart

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetMemberListInfoIterStartResult|MyElements::DatasetMemberListInfoIterStartResult> object.

 $response = $interface->DatasetMemberListInfoIterStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    DpNodeName => $some_value, # DpPolicyNodeName
    IncludeDeleted =>  $some_value, # boolean
    IncludeExportsInfo =>  $some_value, # boolean
    IncludeIndirect =>  $some_value, # boolean
    IncludeIsAvailable =>  $some_value, # boolean
    IncludeSpaceInfo =>  $some_value, # boolean
    MemberId => $some_value, # ObjId
    MemberNameOrId => $some_value, # ObjNameOrId
    MemberType =>  $some_value, # string
    StoragesetNameOrId => $some_value, # ObjNameOrId
    SuppressStatusRefresh =>  $some_value, # boolean
  },,
 );

=head3 DatasetMemberUndedupeStart

EUNDEDUPENOTSUPPORTED 

Returns a L<MyElements::DatasetMemberUndedupeStartResult|MyElements::DatasetMemberUndedupeStartResult> object.

 $response = $interface->DatasetMemberUndedupeStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    UndedupeMemberRequestInfo =>  { # MyTypes::UndedupeMemberRequestInfo
      VolumeId => $some_value, # ObjId
      VolumeName => $some_value, # ObjName
    },
  },,
 );

=head3 DatasetMissingMemberListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetMissingMemberListInfoIterEndResult|MyElements::DatasetMissingMemberListInfoIterEndResult> object.

 $response = $interface->DatasetMissingMemberListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetMissingMemberListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetMissingMemberListInfoIterNextResult|MyElements::DatasetMissingMemberListInfoIterNextResult> object.

 $response = $interface->DatasetMissingMemberListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetMissingMemberListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetMissingMemberListInfoIterStartResult|MyElements::DatasetMissingMemberListInfoIterStartResult> object.

 $response = $interface->DatasetMissingMemberListInfoIterStart( {
    DatasetNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetModify

ESERVICEISATTACHED 

Returns a L<MyElements::DatasetModifyResult|MyElements::DatasetModifyResult> object.

 $response = $interface->DatasetModify( {
    ApplicationInfo =>  { # MyTypes::ApplicationInfo
      ApplicationName =>  $some_value, # string
      ApplicationServerName =>  $some_value, # string
      ApplicationVersion =>  $some_value, # string
      CarryPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
    },
    ApplicationPolicyNameOrId => $some_value, # ObjNameOrId
    CheckProtectionPolicyOnCommit =>  $some_value, # boolean
    DatasetContact => $some_value, # EmailAddressList
    DatasetDescription =>  $some_value, # string
    DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
      DfmMetadataField =>  { # MyTypes::DfmMetadataField
        FieldName =>  $some_value, # string
        FieldValue =>  $some_value, # string
      },
    },
    DatasetName => $some_value, # ObjName
    DatasetOwner =>  $some_value, # string
    EditLockId => $some_value, # atomic
    IsApplicationData =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsDpSuspended =>  $some_value, # boolean
    IsSuspended =>  $some_value, # boolean
    PrimaryVolumeNameFormat => $some_value, # PrimaryVolumeNameFormat
    ProtectionPolicyId => $some_value, # ObjId
    ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
    RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
    SecondaryQtreeNameFormat => $some_value, # SecondaryQtreeNameFormat
    SecondaryVolumeNameFormat => $some_value, # SecondaryVolumeNameFormat
    SnapshotNameFormat => $some_value, # SnapshotNameFormat
    VolumeQtreeNamePrefix =>  $some_value, # string
  },,
 );

=head3 DatasetModifyNode

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetModifyNodeResult|MyElements::DatasetModifyNodeResult> object.

 $response = $interface->DatasetModifyNode( {
    DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
      IpAddress =>  $some_value, # string
      Netmask =>  $some_value, # string
    },
    DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
      DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
        CifsDomain =>  $some_value, # string
        DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
          DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
            CifsUsername =>  $some_value, # string
            Permission => $some_value, # CifsPermission
          },
        },
      },
      DatasetExportProtocol => $some_value, # DatasetExportProtocol
      DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
        IgroupOsType =>  $some_value, # string
        LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
          LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
            Hostname =>  $some_value, # string
            InitiatorId => $some_value, # InitiatorId
          },
        },
      },
      DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
        AnonymousAccessUser => $some_value, # atomic
        DisableSetuid =>  $some_value, # boolean
        IsReadonlyForAllHosts =>  $some_value, # boolean
        IsReadwriteForAllHosts =>  $some_value, # boolean
        NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
          NfsExportHost =>  { # MyTypes::NfsExportHost
            Hostname =>  $some_value, # string
            IsAnException =>  $some_value, # boolean
          },
        },
        NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
          NfsExportHost =>  { # MyTypes::NfsExportHost
            Hostname =>  $some_value, # string
            IsAnException =>  $some_value, # boolean
          },
        },
        NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
          NfsExportHost =>  { # MyTypes::NfsExportHost
            Hostname =>  $some_value, # string
            IsAnException =>  $some_value, # boolean
          },
        },
        NfsProtocolVersion =>  $some_value, # string
        NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
          NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
        },
      },
    },
    DpNodeName => $some_value, # DpPolicyNodeName
    EditLockId =>  $some_value, # integer
    OnlineMigration =>  $some_value, # boolean
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
    RelinquishVfiler =>  $some_value, # boolean
    ResourcepoolNameOrId => $some_value, # ObjNameOrId
    TimezoneName =>  $some_value, # string
    VfilerNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetProvisionMember

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetProvisionMemberResult|MyElements::DatasetProvisionMemberResult> object.

 $response = $interface->DatasetProvisionMember( {
    EditLockId => $some_value, # atomic
    ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
      Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
        ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
          CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
          CommentValue => $some_value, # CommentValue
        },
      },
      CreateNewVfiler =>  $some_value, # boolean
      DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
        DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
          CifsDomain =>  $some_value, # string
          DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
            DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
              CifsUsername =>  $some_value, # string
              Permission => $some_value, # CifsPermission
            },
          },
        },
        DatasetExportProtocol => $some_value, # DatasetExportProtocol
        DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
          IgroupOsType =>  $some_value, # string
          LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
            LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
              Hostname =>  $some_value, # string
              InitiatorId => $some_value, # InitiatorId
            },
          },
        },
        DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
          AnonymousAccessUser => $some_value, # atomic
          DisableSetuid =>  $some_value, # boolean
          IsReadonlyForAllHosts =>  $some_value, # boolean
          IsReadwriteForAllHosts =>  $some_value, # boolean
          NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsProtocolVersion =>  $some_value, # string
          NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
            NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
          },
        },
      },
      Description =>  $some_value, # string
      InitialSnapshotSpace => $some_value, # atomic
      MaximumDataSize => $some_value, # atomic
      MaximumSnapshotSpace => $some_value, # atomic
      Name =>  $some_value, # string
      OnlineMigration =>  $some_value, # boolean
      ProvisioningPolicyId => $some_value, # ObjId
      ProvisioningPolicyName => $some_value, # ObjFullName
      ResourceNameOrId => $some_value, # ObjNameOrId
      Size => $some_value, # atomic
      VfilerNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 DatasetRemoveFromExclusionList

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetRemoveFromExclusionListResult|MyElements::DatasetRemoveFromExclusionListResult> object.

 $response = $interface->DatasetRemoveFromExclusionList( {
    EditLockId => $some_value, # atomic
    ObjectsToBeRemoved =>  { # MyTypes::ArrayOfObjNameOrId
      ObjNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 DatasetRemoveMember

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetRemoveMemberResult|MyElements::DatasetRemoveMemberResult> object.

 $response = $interface->DatasetRemoveMember( {
    DatasetMemberParameters =>  { # MyTypes::ArrayOfDatasetMemberParameter
      DatasetMemberParameter =>  { # MyTypes::DatasetMemberParameter
        DpNodeName => $some_value, # DpPolicyNodeName
        ObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    Destroy =>  $some_value, # boolean
    EditLockId => $some_value, # atomic
  },,
 );

=head3 DatasetRemoveMemberByDynamicReference

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetRemoveMemberByDynamicReferenceResult|MyElements::DatasetRemoveMemberByDynamicReferenceResult> object.

 $response = $interface->DatasetRemoveMemberByDynamicReference( {
    DatasetDynamicReferenceParameters =>  { # MyTypes::ArrayOfDatasetDynamicReferenceParameter
      DatasetDynamicReferenceParameter =>  { # MyTypes::DatasetDynamicReferenceParameter
        DpNodeName => $some_value, # DpPolicyNodeName
        ObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    EditLockId => $some_value, # atomic
  },,
 );

=head3 DatasetRemoveResourcepool

ESTORAGESETNOTINDATASET 

Returns a L<MyElements::DatasetRemoveResourcepoolResult|MyElements::DatasetRemoveResourcepoolResult> object.

 $response = $interface->DatasetRemoveResourcepool( {
    DpNodeName => $some_value, # DpPolicyNodeName
    EditLockId => $some_value, # atomic
    ResourcepoolNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetReplacePrimaryMembers

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetReplacePrimaryMembersResult|MyElements::DatasetReplacePrimaryMembersResult> object.

 $response = $interface->DatasetReplacePrimaryMembers( {
    CancelEditSessions =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    DryRun =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetResizeMember

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetResizeMemberResult|MyElements::DatasetResizeMemberResult> object.

 $response = $interface->DatasetResizeMember( {
    EditLockId => $some_value, # atomic
    ResizeMemberRequestInfo =>  { # MyTypes::ResizeMemberRequestInfo
      MaximumCapacity => $some_value, # atomic
      MemberId => $some_value, # ObjId
      MemberName => $some_value, # ObjName
      NewSize => $some_value, # atomic
      SnapReserve => $some_value, # atomic
    },
  },,
 );

=head3 DatasetSet

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetSetResult|MyElements::DatasetSetResult> object.

 $response = $interface->DatasetSet( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    IsAllowCustomSettings =>  $some_value, # boolean
    IsEnableWriteGuaranteeChecks =>  $some_value, # boolean
    MaximumLunsPerVolume =>  $some_value, # integer
    MaximumQtreesPerVolume =>  $some_value, # integer
  },,
 );

=head3 DatasetSetStorageset

ESERVICEISATTACHED 

Returns a L<MyElements::DatasetSetStoragesetResult|MyElements::DatasetSetStoragesetResult> object.

 $response = $interface->DatasetSetStorageset( {
    DpNodeName => $some_value, # DpPolicyNodeName
    EditLockId => $some_value, # atomic
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetSpaceMetricListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DatasetSpaceMetricListInfoIterEndResult|MyElements::DatasetSpaceMetricListInfoIterEndResult> object.

 $response = $interface->DatasetSpaceMetricListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetSpaceMetricListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DatasetSpaceMetricListInfoIterNextResult|MyElements::DatasetSpaceMetricListInfoIterNextResult> object.

 $response = $interface->DatasetSpaceMetricListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DatasetSpaceMetricListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetSpaceMetricListInfoIterStartResult|MyElements::DatasetSpaceMetricListInfoIterStartResult> object.

 $response = $interface->DatasetSpaceMetricListInfoIterStart( {
    Day => $some_value, # atomic
    Month => $some_value, # Month
    ObjectNameOrId => $some_value, # ObjNameOrId
    Year => $some_value, # atomic
  },,
 );

=head3 DatasetUpdateDrStatus

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetUpdateDrStatusResult|MyElements::DatasetUpdateDrStatusResult> object.

 $response = $interface->DatasetUpdateDrStatus( {
    DatasetNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DatasetUpdateProtectionStatus

EOBJECTNOTFOUND 

Returns a L<MyElements::DatasetUpdateProtectionStatusResult|MyElements::DatasetUpdateProtectionStatusResult> object.

 $response = $interface->DatasetUpdateProtectionStatus( {
    DatasetNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmAbout

EAPIPRIVILEDGE 

Returns a L<MyElements::DfmAboutResult|MyElements::DfmAboutResult> object.

 $response = $interface->DfmAbout( {
    IncludeDirectorySizeInfo =>  $some_value, # boolean
  },,
 );

=head3 DfmBackupScheduleDisable

EINTERNALERROR 

Returns a L<MyElements::DfmBackupScheduleDisableResult|MyElements::DfmBackupScheduleDisableResult> object.

 $response = $interface->DfmBackupScheduleDisable(,,
 );

=head3 DfmBackupScheduleEnable

EINTERNALERROR 

Returns a L<MyElements::DfmBackupScheduleEnableResult|MyElements::DfmBackupScheduleEnableResult> object.

 $response = $interface->DfmBackupScheduleEnable(,,
 );

=head3 DfmBackupScheduleGet

EINTERNALERROR 

Returns a L<MyElements::DfmBackupScheduleGetResult|MyElements::DfmBackupScheduleGetResult> object.

 $response = $interface->DfmBackupScheduleGet(,,
 );

=head3 DfmBackupScheduleSet

EINVALIDINPUT 

Returns a L<MyElements::DfmBackupScheduleSetResult|MyElements::DfmBackupScheduleSetResult> object.

 $response = $interface->DfmBackupScheduleSet( {
    BackupType => $some_value, # BackupType
    Day => $some_value, # atomic
    Hour => $some_value, # atomic
    IsScheduleEnabled =>  $some_value, # boolean
    Minute => $some_value, # atomic
    RepeatInterval => $some_value, # atomic
    ScheduleType =>  $some_value, # string
  },,
 );

=head3 DfmBackupStart

EINVALIDINPUT 

Returns a L<MyElements::DfmBackupStartResult|MyElements::DfmBackupStartResult> object.

 $response = $interface->DfmBackupStart( {
    BackupType => $some_value, # BackupType
  },,
 );

=head3 DfmBackupStatus

EINTERNALERROR 

Returns a L<MyElements::DfmBackupStatusResult|MyElements::DfmBackupStatusResult> object.

 $response = $interface->DfmBackupStatus(,,
 );

=head3 DfmGetApiStatistics

EAPIPRIVILEDGE 

Returns a L<MyElements::DfmGetApiStatisticsResult|MyElements::DfmGetApiStatisticsResult> object.

 $response = $interface->DfmGetApiStatistics( {
    ClearApiStats =>  $some_value, # boolean
  },,
 );

=head3 DfmGetResourcePropertyValues

EINTERNALERROR 

Returns a L<MyElements::DfmGetResourcePropertyValuesResult|MyElements::DfmGetResourcePropertyValuesResult> object.

 $response = $interface->DfmGetResourcePropertyValues( {
    ResourceProperty =>  $some_value, # string
  },,
 );

=head3 DfmMonitorTimestampList

EOBJECTNOTFOUND 

Returns a L<MyElements::DfmMonitorTimestampListResult|MyElements::DfmMonitorTimestampListResult> object.

 $response = $interface->DfmMonitorTimestampList( {
    HostNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmNetworkAdd

EINVALIDINPUT 

Returns a L<MyElements::DfmNetworkAddResult|MyElements::DfmNetworkAddResult> object.

 $response = $interface->DfmNetworkAdd( {
    NetworkAddress => $some_value, # NetworkAddress
    PrefixLength => $some_value, # PrefixLength
  },,
 );

=head3 DfmNetworkDelete

EINVALIDINPUT 

Returns a L<MyElements::DfmNetworkDeleteResult|MyElements::DfmNetworkDeleteResult> object.

 $response = $interface->DfmNetworkDelete( {
    NetworkAddress => $some_value, # NetworkAddress
    NetworkId => $some_value, # ObjId
  },,
 );

=head3 DfmNetworkListInfo

EINVALIDINPUT 

Returns a L<MyElements::DfmNetworkListInfoResult|MyElements::DfmNetworkListInfoResult> object.

 $response = $interface->DfmNetworkListInfo( {
    NetworkId => $some_value, # NetworkId
  },,
 );

=head3 DfmNetworkModify

EINVALIDINPUT 

Returns a L<MyElements::DfmNetworkModifyResult|MyElements::DfmNetworkModifyResult> object.

 $response = $interface->DfmNetworkModify( {
    NetworkId => $some_value, # NetworkId
    PrefixLength => $some_value, # PrefixLength
  },,
 );

=head3 DfmObjectRefresh

EOBJECTNOTFOUND 

Returns a L<MyElements::DfmObjectRefreshResult|MyElements::DfmObjectRefreshResult> object.

 $response = $interface->DfmObjectRefresh( {
    ChildType =>  $some_value, # string
    MonitorNames =>  { # MyTypes::ArrayOfMonitorName
      MonitorName => $some_value, # MonitorName
    },
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmObjectsGetStatus

EOBJECTNOTFOUND 

Returns a L<MyElements::DfmObjectsGetStatusResult|MyElements::DfmObjectsGetStatusResult> object.

 $response = $interface->DfmObjectsGetStatus( {
    Objects =>  { # MyTypes::ArrayOfObjNameOrId
      ObjNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 DfmRelatedObjectsListInfo

EOBJECTNOTFOUND 

Returns a L<MyElements::DfmRelatedObjectsListInfoResult|MyElements::DfmRelatedObjectsListInfoResult> object.

 $response = $interface->DfmRelatedObjectsListInfo( {
    IncludeIndirect =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleContentGet

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleContentGetResult|MyElements::DfmScheduleContentGetResult> object.

 $response = $interface->DfmScheduleContentGet( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleCreate

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DfmScheduleCreateResult|MyElements::DfmScheduleCreateResult> object.

 $response = $interface->DfmScheduleCreate( {
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 DfmScheduleDailyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleDailyAddResult|MyElements::DfmScheduleDailyAddResult> object.

 $response = $interface->DfmScheduleDailyAdd( {
    DailyContent =>  { # MyTypes::WrapperOfDailyInfo
      DailyInfo =>  { # MyTypes::DailyInfo
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleDailyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleDailyDeleteResult|MyElements::DfmScheduleDailyDeleteResult> object.

 $response = $interface->DfmScheduleDailyDelete( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleDailyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleDailyModifyResult|MyElements::DfmScheduleDailyModifyResult> object.

 $response = $interface->DfmScheduleDailyModify( {
    DailyContent =>  { # MyTypes::WrapperOfDailyInfo
      DailyInfo =>  { # MyTypes::DailyInfo
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleDependency

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleDependencyResult|MyElements::DfmScheduleDependencyResult> object.

 $response = $interface->DfmScheduleDependency( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleDestroy

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleDestroyResult|MyElements::DfmScheduleDestroyResult> object.

 $response = $interface->DfmScheduleDestroy( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleHourlyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleHourlyAddResult|MyElements::DfmScheduleHourlyAddResult> object.

 $response = $interface->DfmScheduleHourlyAdd( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    HourlyContent =>  { # MyTypes::WrapperOfHourlyInfo
      HourlyInfo =>  { # MyTypes::HourlyInfo
        EndHour => $some_value, # atomic
        EndMinute => $some_value, # atomic
        Frequency => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleHourlyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleHourlyDeleteResult|MyElements::DfmScheduleHourlyDeleteResult> object.

 $response = $interface->DfmScheduleHourlyDelete( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleHourlyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleHourlyModifyResult|MyElements::DfmScheduleHourlyModifyResult> object.

 $response = $interface->DfmScheduleHourlyModify( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    HourlyContent =>  { # MyTypes::WrapperOfHourlyInfo
      HourlyInfo =>  { # MyTypes::HourlyInfo
        EndHour => $some_value, # atomic
        EndMinute => $some_value, # atomic
        Frequency => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleList

EDATABASEERROR 

Returns a L<MyElements::DfmScheduleListResult|MyElements::DfmScheduleListResult> object.

 $response = $interface->DfmScheduleList( {
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleListInfoIterEnd

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DfmScheduleListInfoIterEndResult|MyElements::DfmScheduleListInfoIterEndResult> object.

 $response = $interface->DfmScheduleListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DfmScheduleListInfoIterNext

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DfmScheduleListInfoIterNextResult|MyElements::DfmScheduleListInfoIterNextResult> object.

 $response = $interface->DfmScheduleListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DfmScheduleListInfoIterStart

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleListInfoIterStartResult|MyElements::DfmScheduleListInfoIterStartResult> object.

 $response = $interface->DfmScheduleListInfoIterStart( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleModifyResult|MyElements::DfmScheduleModifyResult> object.

 $response = $interface->DfmScheduleModify( {
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 DfmScheduleMonthlyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleMonthlyAddResult|MyElements::DfmScheduleMonthlyAddResult> object.

 $response = $interface->DfmScheduleMonthlyAdd( {
    MonthlyContent =>  { # MyTypes::WrapperOfMonthlyInfo
      MonthlyInfo =>  { # MyTypes::MonthlyInfo
        DayOfMonth => $some_value, # atomic
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
        WeekOfMonth => $some_value, # atomic
      },
    },
    MonthlyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleMonthlyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleMonthlyDeleteResult|MyElements::DfmScheduleMonthlyDeleteResult> object.

 $response = $interface->DfmScheduleMonthlyDelete( {
    ItemId => $some_value, # atomic
    MonthlyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleMonthlyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleMonthlyModifyResult|MyElements::DfmScheduleMonthlyModifyResult> object.

 $response = $interface->DfmScheduleMonthlyModify( {
    MonthlyContent =>  { # MyTypes::WrapperOfMonthlyInfo
      MonthlyInfo =>  { # MyTypes::MonthlyInfo
        DayOfMonth => $some_value, # atomic
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
        WeekOfMonth => $some_value, # atomic
      },
    },
    MonthlyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleMonthlySubscheduleSet

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleMonthlySubscheduleSetResult|MyElements::DfmScheduleMonthlySubscheduleSetResult> object.

 $response = $interface->DfmScheduleMonthlySubscheduleSet( {
    MonthlyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
    SubscheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleMonthlySubscheduleUnset

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleMonthlySubscheduleUnsetResult|MyElements::DfmScheduleMonthlySubscheduleUnsetResult> object.

 $response = $interface->DfmScheduleMonthlySubscheduleUnset( {
    MonthlyScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DfmScheduleRename

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleRenameResult|MyElements::DfmScheduleRenameResult> object.

 $response = $interface->DfmScheduleRename( {
    NewScheduleName =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleWeeklyAddResult|MyElements::DfmScheduleWeeklyAddResult> object.

 $response = $interface->DfmScheduleWeeklyAdd( {
    ScheduleCategory =>  $some_value, # string
    WeeklyContent =>  { # MyTypes::WrapperOfWeeklyInfo
      WeeklyInfo =>  { # MyTypes::WeeklyInfo
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleWeeklyDeleteResult|MyElements::DfmScheduleWeeklyDeleteResult> object.

 $response = $interface->DfmScheduleWeeklyDelete( {
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleWeeklyModifyResult|MyElements::DfmScheduleWeeklyModifyResult> object.

 $response = $interface->DfmScheduleWeeklyModify( {
    ScheduleCategory =>  $some_value, # string
    WeeklyContent =>  { # MyTypes::WrapperOfWeeklyInfo
      WeeklyInfo =>  { # MyTypes::WeeklyInfo
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklySubscheduleAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleWeeklySubscheduleAddResult|MyElements::DfmScheduleWeeklySubscheduleAddResult> object.

 $response = $interface->DfmScheduleWeeklySubscheduleAdd( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    EndDayOfWeek => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    StartDayOfWeek => $some_value, # atomic
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklySubscheduleDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DfmScheduleWeeklySubscheduleDeleteResult|MyElements::DfmScheduleWeeklySubscheduleDeleteResult> object.

 $response = $interface->DfmScheduleWeeklySubscheduleDelete( {
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmScheduleWeeklySubscheduleModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DfmScheduleWeeklySubscheduleModifyResult|MyElements::DfmScheduleWeeklySubscheduleModifyResult> object.

 $response = $interface->DfmScheduleWeeklySubscheduleModify( {
    DailyScheduleNameOrId => $some_value, # ObjNameOrId
    EndDayOfWeek => $some_value, # atomic
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    StartDayOfWeek => $some_value, # atomic
    WeeklyScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DfmServerListDiagnosticInfo

EAPIPRIVILEDGE 

Returns a L<MyElements::DfmServerListDiagnosticInfoResult|MyElements::DfmServerListDiagnosticInfoResult> object.

 $response = $interface->DfmServerListDiagnosticInfo(,,
 );

=head3 DfmSnmpSettingAdd

EINVALIDINPUT 

Returns a L<MyElements::DfmSnmpSettingAddResult|MyElements::DfmSnmpSettingAddResult> object.

 $response = $interface->DfmSnmpSettingAdd( {
    NetworkAddress => $some_value, # NetworkAddress
    PrefixLength => $some_value, # PrefixLength
    PrivacyPassword =>  $some_value, # string
    SnmpAuthenticationLogin =>  $some_value, # string
    SnmpAuthenticationPassword =>  $some_value, # string
    SnmpAuthenticationProtocol => $some_value, # SnmpAuthenticationProtocol
    SnmpCommunityName =>  $some_value, # string
    SnmpVersion => $some_value, # SnmpVersion
  },,
 );

=head3 DfmSnmpSettingDelete

EINVALIDINPUT 

Returns a L<MyElements::DfmSnmpSettingDeleteResult|MyElements::DfmSnmpSettingDeleteResult> object.

 $response = $interface->DfmSnmpSettingDelete( {
    NetworkAddress => $some_value, # NetworkAddress
    PrefixLength => $some_value, # PrefixLength
    SnmpId => $some_value, # SnmpId
  },,
 );

=head3 DfmSnmpSettingModify

EINVALIDINPUT 

Returns a L<MyElements::DfmSnmpSettingModifyResult|MyElements::DfmSnmpSettingModifyResult> object.

 $response = $interface->DfmSnmpSettingModify( {
    PrefixLength => $some_value, # PrefixLength
    PrivacyPassword =>  $some_value, # string
    SnmpAuthenticationLogin =>  $some_value, # string
    SnmpAuthenticationPassword =>  $some_value, # string
    SnmpAuthenticationProtocol => $some_value, # SnmpAuthenticationProtocol
    SnmpCommunityName =>  $some_value, # string
    SnmpId => $some_value, # SnmpId
    SnmpVersion => $some_value, # SnmpVersion
  },,
 );

=head3 DfmSnmpSettingsListInfo

EINVALIDINPUT 

Returns a L<MyElements::DfmSnmpSettingsListInfoResult|MyElements::DfmSnmpSettingsListInfoResult> object.

 $response = $interface->DfmSnmpSettingsListInfo( {
    NetworkAddress =>  $some_value, # string
    PrefixLength =>  $some_value, # integer
    SnmpId => $some_value, # SnmpId
  },,
 );

=head3 DfmUserPrivGet

ENAMENOTFOUND 

Returns a L<MyElements::DfmUserPrivGetResult|MyElements::DfmUserPrivGetResult> object.

 $response = $interface->DfmUserPrivGet(,,
 );

=head3 DiskListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DiskListInfoIterEndResult|MyElements::DiskListInfoIterEndResult> object.

 $response = $interface->DiskListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DiskListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DiskListInfoIterNextResult|MyElements::DiskListInfoIterNextResult> object.

 $response = $interface->DiskListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DiskListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DiskListInfoIterStartResult|MyElements::DiskListInfoIterStartResult> object.

 $response = $interface->DiskListInfoIterStart( {
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentConfigure

EINVALIDINPUTERROR 

Returns a L<MyElements::DpAgentConfigureResult|MyElements::DpAgentConfigureResult> object.

 $response = $interface->DpAgentConfigure( {
    DfmServerIpAddress =>  $some_value, # string
    DpAgentNameOrId => $some_value, # ObjNameOrId
    StorageSystemsConfiguration =>  { # MyTypes::ArrayOfStorageSystemConfiguration
      StorageSystemConfiguration =>  { # MyTypes::StorageSystemConfiguration
        LoginProtocol =>  $some_value, # string
        PushCredentials =>  $some_value, # boolean
        StorageSystemNameOrId => $some_value, # ObjNameOrId
      },
    },
    VcenterIpAddress =>  $some_value, # string
    VcenterPassword =>  $some_value, # string
    VcenterUsername =>  $some_value, # string
  },,
 );

=head3 DpAgentDiscover

EINVALIDINPUTERROR 

Returns a L<MyElements::DpAgentDiscoverResult|MyElements::DpAgentDiscoverResult> object.

 $response = $interface->DpAgentDiscover( {
    DpAgentNameOrId => $some_value, # ObjNameOrId
    ResourceNameOrId =>  $some_value, # string
    ResourceType =>  $some_value, # string
    TrackProgress =>  $some_value, # boolean
  },,
 );

=head3 DpAgentListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpAgentListInfoIterEndResult|MyElements::DpAgentListInfoIterEndResult> object.

 $response = $interface->DpAgentListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpAgentListInfoIterNext

EINTERNALERROR 

Returns a L<MyElements::DpAgentListInfoIterNextResult|MyElements::DpAgentListInfoIterNextResult> object.

 $response = $interface->DpAgentListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpAgentListInfoIterStart

EINTERNALERROR 

Returns a L<MyElements::DpAgentListInfoIterStartResult|MyElements::DpAgentListInfoIterStartResult> object.

 $response = $interface->DpAgentListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentListUpgradeCandidates

EOBJECTNOTFOUND 

Returns a L<MyElements::DpAgentListUpgradeCandidatesResult|MyElements::DpAgentListUpgradeCandidatesResult> object.

 $response = $interface->DpAgentListUpgradeCandidates( {
    PackageNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentModify

EOBJECTNOTFOUND 

Returns a L<MyElements::DpAgentModifyResult|MyElements::DpAgentModifyResult> object.

 $response = $interface->DpAgentModify( {
    DpAgentNameOrId =>  $some_value, # string
    HostserviceModifyInfo =>  { # MyTypes::HostserviceModifyInfo
      AccessProtocol =>  $some_value, # string
      AdminPort =>  $some_value, # integer
      IpAddress =>  $some_value, # string
      MgmtPort =>  $some_value, # integer
      UpdateServicePort =>  $some_value, # integer
    },
  },,
 );

=head3 DpAgentPackageAdd

EINTERNALERROR 

Returns a L<MyElements::DpAgentPackageAddResult|MyElements::DpAgentPackageAddResult> object.

 $response = $interface->DpAgentPackageAdd( {
    PackageVersion =>  $some_value, # string
    PackageZipPath =>  $some_value, # string
  },,
 );

=head3 DpAgentPackageDelete

EINTERNALERROR 

Returns a L<MyElements::DpAgentPackageDeleteResult|MyElements::DpAgentPackageDeleteResult> object.

 $response = $interface->DpAgentPackageDelete( {
    PackageNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentPackageList

EINTERNALERROR 

Returns a L<MyElements::DpAgentPackageListResult|MyElements::DpAgentPackageListResult> object.

 $response = $interface->DpAgentPackageList( {
    PackageNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentRegister

EOBJECTEXISTS 

Returns a L<MyElements::DpAgentRegisterResult|MyElements::DpAgentRegisterResult> object.

 $response = $interface->DpAgentRegister( {
    AdminPort =>  $some_value, # integer
    NameOrIpAddress =>  $some_value, # string
    SuppressRegisteredError =>  $some_value, # boolean
  },,
 );

=head3 DpAgentStoragesystemListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpAgentStoragesystemListInfoIterEndResult|MyElements::DpAgentStoragesystemListInfoIterEndResult> object.

 $response = $interface->DpAgentStoragesystemListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpAgentStoragesystemListInfoIterNext

EINTERNALERROR 

Returns a L<MyElements::DpAgentStoragesystemListInfoIterNextResult|MyElements::DpAgentStoragesystemListInfoIterNextResult> object.

 $response = $interface->DpAgentStoragesystemListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DpAgentStoragesystemListInfoIterStart

EINVALIDINPUTERROR 

Returns a L<MyElements::DpAgentStoragesystemListInfoIterStartResult|MyElements::DpAgentStoragesystemListInfoIterStartResult> object.

 $response = $interface->DpAgentStoragesystemListInfoIterStart( {
    DpAgentNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpAgentUnregister

EINVALIDINPUTERROR 

Returns a L<MyElements::DpAgentUnregisterResult|MyElements::DpAgentUnregisterResult> object.

 $response = $interface->DpAgentUnregister( {
    DpAgentNameOrId =>  $some_value, # string
  },,
 );

=head3 DpAgentUpgrade

EINTERNALERROR 

Returns a L<MyElements::DpAgentUpgradeResult|MyElements::DpAgentUpgradeResult> object.

 $response = $interface->DpAgentUpgrade( {
    DpAgentNameOrId => $some_value, # ObjNameOrId
    PackageNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpBackupContentListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpBackupContentListIterEndResult|MyElements::DpBackupContentListIterEndResult> object.

 $response = $interface->DpBackupContentListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupContentListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpBackupContentListIterNextResult|MyElements::DpBackupContentListIterNextResult> object.

 $response = $interface->DpBackupContentListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupContentListIterStart

EPATHDOESNOTEXIST 

Returns a L<MyElements::DpBackupContentListIterStartResult|MyElements::DpBackupContentListIterStartResult> object.

 $response = $interface->DpBackupContentListIterStart( {
    BackupId => $some_value, # atomic
    PrimarySnapshotName =>  $some_value, # string
    PrimarySnapshotUniqueId =>  $some_value, # string
    RootObjectNameOrId =>  $some_value, # string
    SubPath =>  $some_value, # string
    SuppressChildCount =>  $some_value, # boolean
  },,
 );

=head3 DpBackupGetLocation

supported 

Returns a L<MyElements::DpBackupGetLocationResult|MyElements::DpBackupGetLocationResult> object.

 $response = $interface->DpBackupGetLocation( {
    BackupId => $some_value, # atomic
    BackupVersion => $some_value, # DpTimestamp
    DatasetNameOrId => $some_value, # ObjNameOrId
    Paths =>  { # MyTypes::ArrayOfDpBackupPathInfo
      DpBackupPathInfo =>  { # MyTypes::DpBackupPathInfo
        MemberId => $some_value, # ObjId
        MemberName => $some_value, # ObjName
        Path =>  $some_value, # string
        PrimarySnapshotName =>  $some_value, # string
        PrimarySnapshotUniqueId =>  $some_value, # string
      },
    },
  },,
 );

=head3 DpBackupListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpBackupListIterEndResult|MyElements::DpBackupListIterEndResult> object.

 $response = $interface->DpBackupListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpBackupListIterNextResult|MyElements::DpBackupListIterNextResult> object.

 $response = $interface->DpBackupListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupListIterStart

EPATHDOESNOTEXIST 

Returns a L<MyElements::DpBackupListIterStartResult|MyElements::DpBackupListIterStartResult> object.

 $response = $interface->DpBackupListIterStart( {
    ApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
    BackupId => $some_value, # atomic
    BackupVersion => $some_value, # DpTimestamp
    DatasetNameOrId => $some_value, # ObjNameOrId
    HasApplicationResourcesOnly =>  $some_value, # boolean
    HasStorageResourcesOnly =>  $some_value, # boolean
    IncludeIsAvailable =>  $some_value, # boolean
    IncludeMetadata =>  $some_value, # boolean
    IncludeMetadataHostService => $some_value, # ObjNameOrId
    IsRootObjectRestorable =>  $some_value, # boolean
    RootObjectNameOrId => $some_value, # ObjNameOrId
    SearchKeys =>  { # MyTypes::ArrayOfSearchKey
      SearchKey => $some_value, # SearchKey
    },
    SnapshotUniqueId =>  $some_value, # string
    SubPath =>  $some_value, # string
    VolumeId => $some_value, # ObjId
  },,
 );

=head3 DpBackupStart

EUNUSEDAPPLICATIONOBJECTSETTING 

Returns a L<MyElements::DpBackupStartResult|MyElements::DpBackupStartResult> object.

 $response = $interface->DpBackupStart( {
    BackupDescription =>  $some_value, # string
    BackupDestination =>  $some_value, # string
    BackupDestinationNameOrId =>  $some_value, # string
    BackupMembers =>  { # MyTypes::ArrayOfObjNameOrId
      ObjNameOrId => $some_value, # ObjNameOrId
    },
    BackupScript =>  $some_value, # string
    DatasetNameOrId => $some_value, # ObjNameOrId
    HypervBackupSettingsInfo =>  { # MyTypes::WrapperOfHypervBackupScheduleSettingsInfo
      HypervBackupScheduleSettingsInfo =>  { # MyTypes::HypervBackupScheduleSettingsInfo
        AllowSavedStateBackup =>  $some_value, # boolean
      },
    },
    RetentionDuration => $some_value, # atomic
    RetentionType => $some_value, # DpBackupRetentionType
    VmwareBackupSettingsInfo =>  { # MyTypes::WrapperOfVmwareBackupScheduleSettingsInfo
      VmwareBackupScheduleSettingsInfo =>  { # MyTypes::VmwareBackupScheduleSettingsInfo
        CreateVmwareSnapshot =>  $some_value, # boolean
        IncludeIndependentDisks =>  $some_value, # boolean
      },
    },
  },,
 );

=head3 DpBackupVersionCreate

EOBJECTNOTFOUND 

Returns a L<MyElements::DpBackupVersionCreateResult|MyElements::DpBackupVersionCreateResult> object.

 $response = $interface->DpBackupVersionCreate( {
    BackupDescription =>  $some_value, # string
    BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
      DfmMetadata =>  { # MyTypes::DfmMetadata
        FieldName =>  $some_value, # string
        FieldValue =>  $some_value, # string
      },
    },
    DatasetNameOrId => $some_value, # ObjNameOrId
    IsAddingMembers =>  $some_value, # boolean
    IsComplete =>  $some_value, # boolean
    IsForPropagation =>  $some_value, # boolean
    IsNative =>  $some_value, # boolean
    JobId =>  $some_value, # integer
    RetentionType =>  $some_value, # string
    StoragesetId => $some_value, # ObjId
    VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
      VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
        HostAddress => $some_value, # IpAddress
        HostFqdn =>  $some_value, # string
        HostId => $some_value, # ObjId
        IsAvailable =>  $some_value, # boolean
        SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
          SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
            PrimaryId => $some_value, # ObjId
            PrimaryName => $some_value, # ObjName
            PrimarySnapshotHostServiceId =>  $some_value, # string
            PrimarySnapshotName =>  $some_value, # string
            PrimarySnapshotUniqueId =>  $some_value, # string
            SecondaryQtreeId => $some_value, # ObjId
            SecondaryQtreeName =>  $some_value, # string
            SecondaryQtreeNameOrId =>  $some_value, # string
          },
        },
        SnapshotName =>  $some_value, # string
        SnapshotUniqueId =>  $some_value, # string
        VolumeId => $some_value, # ObjId
        VolumeName => $some_value, # ObjName
      },
    },
    VersionTimestamp => $some_value, # DpTimestamp
  },,
 );

=head3 DpBackupVersionDelete

EOBJECTNOTFOUND 

Returns a L<MyElements::DpBackupVersionDeleteResult|MyElements::DpBackupVersionDeleteResult> object.

 $response = $interface->DpBackupVersionDelete( {
    AllowDeferredDelete =>  $some_value, # boolean
    BackupId => $some_value, # atomic
    BackupVersion => $some_value, # DpTimestamp
    DatasetNameOrId => $some_value, # ObjNameOrId
    DeleteMultipleBackups =>  $some_value, # boolean
    NodeName =>  $some_value, # string
  },,
 );

=head3 DpBackupVersionListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpBackupVersionListIterEndResult|MyElements::DpBackupVersionListIterEndResult> object.

 $response = $interface->DpBackupVersionListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupVersionListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpBackupVersionListIterNextResult|MyElements::DpBackupVersionListIterNextResult> object.

 $response = $interface->DpBackupVersionListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DpBackupVersionListIterStart

EPATHDOESNOTEXIST 

Returns a L<MyElements::DpBackupVersionListIterStartResult|MyElements::DpBackupVersionListIterStartResult> object.

 $response = $interface->DpBackupVersionListIterStart( {
    BackupVersion => $some_value, # DpTimestamp
    DatasetNameOrId => $some_value, # ObjNameOrId
    IncludeIsAvailable =>  $some_value, # boolean
    IncludeMetadata =>  $some_value, # boolean
    RootObjectNameOrId => $some_value, # ObjNameOrId
    SnapshotUniqueId =>  $some_value, # string
    SubPath =>  $some_value, # string
    VolumeId => $some_value, # ObjId
  },,
 );

=head3 DpBackupVersionModify

EOBJECTNOTFOUND 

Returns a L<MyElements::DpBackupVersionModifyResult|MyElements::DpBackupVersionModifyResult> object.

 $response = $interface->DpBackupVersionModify( {
    BackupDescription =>  $some_value, # string
    BackupId => $some_value, # atomic
    BackupMetadata =>  { # MyTypes::ArrayOfDfmMetadata
      DfmMetadata =>  { # MyTypes::DfmMetadata
        FieldName =>  $some_value, # string
        FieldValue =>  $some_value, # string
      },
    },
    BackupVersion => $some_value, # DpTimestamp
    DatasetNameOrId => $some_value, # ObjNameOrId
    DpBackupTransferInfo =>  { # MyTypes::DpBackupTransferInfo
      BackupTransferNeeded =>  $some_value, # boolean
      BackupTransferStatus =>  $some_value, # string
      ConnectionType =>  $some_value, # string
      DestinationBackupId => $some_value, # atomic
      DestinationNodeId => $some_value, # atomic
      DestinationNodeName =>  $some_value, # string
      DestinationStoragesetId => $some_value, # atomic
      JobId =>  $some_value, # integer
      SourceBackupId => $some_value, # atomic
      SourceNodeId => $some_value, # atomic
      SourceNodeName =>  $some_value, # string
      SourceStoragesetId => $some_value, # atomic
    },
    IsAddingMembers =>  $some_value, # boolean
    IsComplete =>  $some_value, # boolean
    NodeNameOrId =>  $some_value, # string
    RetentionType =>  $some_value, # string
    VersionMembers =>  { # MyTypes::ArrayOfVersionMemberInfo
      VersionMemberInfo =>  { # MyTypes::VersionMemberInfo
        HostAddress => $some_value, # IpAddress
        HostFqdn =>  $some_value, # string
        HostId => $some_value, # ObjId
        IsAvailable =>  $some_value, # boolean
        SnapshotContents =>  { # MyTypes::ArrayOfSnapshotMemberInfo
          SnapshotMemberInfo =>  { # MyTypes::SnapshotMemberInfo
            PrimaryId => $some_value, # ObjId
            PrimaryName => $some_value, # ObjName
            PrimarySnapshotHostServiceId =>  $some_value, # string
            PrimarySnapshotName =>  $some_value, # string
            PrimarySnapshotUniqueId =>  $some_value, # string
            SecondaryQtreeId => $some_value, # ObjId
            SecondaryQtreeName =>  $some_value, # string
            SecondaryQtreeNameOrId =>  $some_value, # string
          },
        },
        SnapshotName =>  $some_value, # string
        SnapshotUniqueId =>  $some_value, # string
        VolumeId => $some_value, # ObjId
        VolumeName => $some_value, # ObjName
      },
    },
  },,
 );

=head3 DpDashboardGetDrDatasetCounts

EINTERNALERROR 

Returns a L<MyElements::DpDashboardGetDrDatasetCountsResult|MyElements::DpDashboardGetDrDatasetCountsResult> object.

 $response = $interface->DpDashboardGetDrDatasetCounts( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 DpDashboardGetLaggedDatasets

EINTERNALERROR 

Returns a L<MyElements::DpDashboardGetLaggedDatasetsResult|MyElements::DpDashboardGetLaggedDatasetsResult> object.

 $response = $interface->DpDashboardGetLaggedDatasets( {
    GroupNameOrId => $some_value, # GroupNameOrId
    MaxDatasets => $some_value, # atomic
  },,
 );

=head3 DpDashboardGetLaggedRelationships

EINTERNALERROR 

Returns a L<MyElements::DpDashboardGetLaggedRelationshipsResult|MyElements::DpDashboardGetLaggedRelationshipsResult> object.

 $response = $interface->DpDashboardGetLaggedRelationships( {
    GroupNameOrId => $some_value, # GroupNameOrId
    IsExternalRelationship =>  $some_value, # boolean
    MaxRelationships => $some_value, # atomic
  },,
 );

=head3 DpDashboardGetProtectedDataCounts

EINTERNALERROR 

Returns a L<MyElements::DpDashboardGetProtectedDataCountsResult|MyElements::DpDashboardGetProtectedDataCountsResult> object.

 $response = $interface->DpDashboardGetProtectedDataCounts( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 DpDashboardGetProtectedDataCounts2

EINTERNALERROR 

Returns a L<MyElements::DpDashboardGetProtectedDataCounts2Result|MyElements::DpDashboardGetProtectedDataCounts2Result> object.

 $response = $interface->DpDashboardGetProtectedDataCounts2( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 DpGetDatasetBackupJobsData

EOBJECTNOTFOUND 

Returns a L<MyElements::DpGetDatasetBackupJobsDataResult|MyElements::DpGetDatasetBackupJobsDataResult> object.

 $response = $interface->DpGetDatasetBackupJobsData( {
    BackupDestination =>  $some_value, # string
    DatasetNameOrId => $some_value, # ObjNameOrId
    RetentionType => $some_value, # DpBackupRetentionType
  },,
 );

=head3 DpJobAbort

EJOBDOESNOTEXIST 

Returns a L<MyElements::DpJobAbortResult|MyElements::DpJobAbortResult> object.

 $response = $interface->DpJobAbort( {
    JobId => $some_value, # atomic
  },,
 );

=head3 DpJobListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpJobListIterEndResult|MyElements::DpJobListIterEndResult> object.

 $response = $interface->DpJobListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpJobListIterNextResult|MyElements::DpJobListIterNextResult> object.

 $response = $interface->DpJobListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobListIterStart

EINVALIDJOBTYPE 

Returns a L<MyElements::DpJobListIterStartResult|MyElements::DpJobListIterStartResult> object.

 $response = $interface->DpJobListIterStart( {
    JobContextApplicationResourceNamespace => $some_value, # ApplicationResourceNamespace
    JobContextApplicationResourcesOnly =>  $some_value, # boolean
    JobContextObjNameOrId =>  $some_value, # string
    JobId => $some_value, # atomic
    JobState => $some_value, # DpJobState
    JobType => $some_value, # DpJobType
    JobTypes =>  { # MyTypes::ArrayOfJobType
      JobType => $some_value, # JobType
    },
    MaxJobs => $some_value, # atomic
    ObjectNameOrId => $some_value, # ObjNameOrId
    StartedTimestampFrom => $some_value, # DpTimestamp
    StartedTimestampTo => $some_value, # DpTimestamp
  },,
 );

=head3 DpJobProgressEventListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpJobProgressEventListIterEndResult|MyElements::DpJobProgressEventListIterEndResult> object.

 $response = $interface->DpJobProgressEventListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobProgressEventListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpJobProgressEventListIterNextResult|MyElements::DpJobProgressEventListIterNextResult> object.

 $response = $interface->DpJobProgressEventListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobProgressEventListIterStart

EJOBDOESNOTEXIST 

Returns a L<MyElements::DpJobProgressEventListIterStartResult|MyElements::DpJobProgressEventListIterStartResult> object.

 $response = $interface->DpJobProgressEventListIterStart( {
    ConnectionId => $some_value, # atomic
    DatasetNameOrId =>  $some_value, # string
    EndTime => $some_value, # DpTimestamp
    History =>  $some_value, # boolean
    JobId => $some_value, # atomic
    JobType => $some_value, # DpJobType
    JobTypes =>  { # MyTypes::ArrayOfJobType
      JobType => $some_value, # JobType
    },
    ObjectNameOrId => $some_value, # ObjNameOrId
    StartTime => $some_value, # DpTimestamp
  },,
 );

=head3 DpJobPurge

EJOBDOESNOTEXIST 

Returns a L<MyElements::DpJobPurgeResult|MyElements::DpJobPurgeResult> object.

 $response = $interface->DpJobPurge( {
    CompletedTimestamp => $some_value, # DpTimestamp
    JobId => $some_value, # atomic
    PurgeJobsCompletedWithError =>  $some_value, # boolean
  },,
 );

=head3 DpJobScheduleGetLastChanged

EINVALIDTAG 

Returns a L<MyElements::DpJobScheduleGetLastChangedResult|MyElements::DpJobScheduleGetLastChangedResult> object.

 $response = $interface->DpJobScheduleGetLastChanged(,,
 );

=head3 DpJobScheduleListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpJobScheduleListIterEndResult|MyElements::DpJobScheduleListIterEndResult> object.

 $response = $interface->DpJobScheduleListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobScheduleListIterNext

EINVALIDTAG 

Returns a L<MyElements::DpJobScheduleListIterNextResult|MyElements::DpJobScheduleListIterNextResult> object.

 $response = $interface->DpJobScheduleListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpJobScheduleListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpJobScheduleListIterStartResult|MyElements::DpJobScheduleListIterStartResult> object.

 $response = $interface->DpJobScheduleListIterStart( {
    DatasetNameOrId => $some_value, # atomic
    FromTime =>  $some_value, # integer
    ToTime =>  $some_value, # integer
  },,
 );

=head3 DpOssvApplicationListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpOssvApplicationListInfoIterEndResult|MyElements::DpOssvApplicationListInfoIterEndResult> object.

 $response = $interface->DpOssvApplicationListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvApplicationListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DpOssvApplicationListInfoIterNextResult|MyElements::DpOssvApplicationListInfoIterNextResult> object.

 $response = $interface->DpOssvApplicationListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvApplicationListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvApplicationListInfoIterStartResult|MyElements::DpOssvApplicationListInfoIterStartResult> object.

 $response = $interface->DpOssvApplicationListInfoIterStart( {
    OssvApplicationPath =>  $some_value, # string
    OssvHostNameOrId => $some_value, # OssvHostNameOrId
  },,
 );

=head3 DpOssvApplicationRestoreDestinationListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpOssvApplicationRestoreDestinationListInfoIterEndResult|MyElements::DpOssvApplicationRestoreDestinationListInfoIterEndResult> object.

 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvApplicationRestoreDestinationListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DpOssvApplicationRestoreDestinationListInfoIterNextResult|MyElements::DpOssvApplicationRestoreDestinationListInfoIterNextResult> object.

 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvApplicationRestoreDestinationListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvApplicationRestoreDestinationListInfoIterStartResult|MyElements::DpOssvApplicationRestoreDestinationListInfoIterStartResult> object.

 $response = $interface->DpOssvApplicationRestoreDestinationListInfoIterStart( {
    ApplicationNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpOssvDirectoryAdd

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvDirectoryAddResult|MyElements::DpOssvDirectoryAddResult> object.

 $response = $interface->DpOssvDirectoryAdd( {
    DirectoryPath =>  $some_value, # string
    OssvHostNameOrId => $some_value, # OssvHostNameOrId
  },,
 );

=head3 DpOssvDirectoryBrowseIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryBrowseIterEndResult|MyElements::DpOssvDirectoryBrowseIterEndResult> object.

 $response = $interface->DpOssvDirectoryBrowseIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryBrowseIterNext

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryBrowseIterNextResult|MyElements::DpOssvDirectoryBrowseIterNextResult> object.

 $response = $interface->DpOssvDirectoryBrowseIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryBrowseIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvDirectoryBrowseIterStartResult|MyElements::DpOssvDirectoryBrowseIterStartResult> object.

 $response = $interface->DpOssvDirectoryBrowseIterStart( {
    DirectoryPath =>  $some_value, # string
    OssvHostNameOrId => $some_value, # OssvHostNameOrId
  },,
 );

=head3 DpOssvDirectoryDiscoveredIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryDiscoveredIterEndResult|MyElements::DpOssvDirectoryDiscoveredIterEndResult> object.

 $response = $interface->DpOssvDirectoryDiscoveredIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryDiscoveredIterNext

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryDiscoveredIterNextResult|MyElements::DpOssvDirectoryDiscoveredIterNextResult> object.

 $response = $interface->DpOssvDirectoryDiscoveredIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryDiscoveredIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvDirectoryDiscoveredIterStartResult|MyElements::DpOssvDirectoryDiscoveredIterStartResult> object.

 $response = $interface->DpOssvDirectoryDiscoveredIterStart( {
    IncludeIsAvailable =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsInBackupRelationship =>  $some_value, # boolean
    IsInDataset =>  $some_value, # boolean
    ObjectNameOrId =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryModify

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvDirectoryModifyResult|MyElements::DpOssvDirectoryModifyResult> object.

 $response = $interface->DpOssvDirectoryModify( {
    DpOssvDirectoryNameOrId =>  $some_value, # string
    IsDpIgnored =>  $some_value, # boolean
  },,
 );

=head3 DpOssvDirectoryRootsIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryRootsIterEndResult|MyElements::DpOssvDirectoryRootsIterEndResult> object.

 $response = $interface->DpOssvDirectoryRootsIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryRootsIterNext

EINVALIDTAG 

Returns a L<MyElements::DpOssvDirectoryRootsIterNextResult|MyElements::DpOssvDirectoryRootsIterNextResult> object.

 $response = $interface->DpOssvDirectoryRootsIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpOssvDirectoryRootsIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpOssvDirectoryRootsIterStartResult|MyElements::DpOssvDirectoryRootsIterStartResult> object.

 $response = $interface->DpOssvDirectoryRootsIterStart( {
    FsInfo =>  $some_value, # boolean
    OssvHostNameOrId => $some_value, # OssvHostNameOrId
  },,
 );

=head3 DpPolicyCopy

EPOLICYEXISTS 

Returns a L<MyElements::DpPolicyCopyResult|MyElements::DpPolicyCopyResult> object.

 $response = $interface->DpPolicyCopy( {
    DpPolicyDescription =>  $some_value, # string
    DpPolicyName => $some_value, # ObjName
    TemplateDpPolicyId => $some_value, # ObjId
    TemplateDpPolicyNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpPolicyDestroy

EPOLICYNOTMODIFIABLE 

Returns a L<MyElements::DpPolicyDestroyResult|MyElements::DpPolicyDestroyResult> object.

 $response = $interface->DpPolicyDestroy( {
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 DpPolicyEditBegin

EOBJECTNOTFOUND 

Returns a L<MyElements::DpPolicyEditBeginResult|MyElements::DpPolicyEditBeginResult> object.

 $response = $interface->DpPolicyEditBegin( {
    DpPolicyNameOrId => $some_value, # ObjNameOrId
    Force =>  $some_value, # boolean
  },,
 );

=head3 DpPolicyEditCommit

EPOLICYEXISTS 

Returns a L<MyElements::DpPolicyEditCommitResult|MyElements::DpPolicyEditCommitResult> object.

 $response = $interface->DpPolicyEditCommit( {
    DryRun =>  $some_value, # boolean
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 DpPolicyEditRollback

EEDITSESSIONNOTFOUND 

Returns a L<MyElements::DpPolicyEditRollbackResult|MyElements::DpPolicyEditRollbackResult> object.

 $response = $interface->DpPolicyEditRollback( {
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 DpPolicyGetDefaultPropertyValues

supported 

Returns a L<MyElements::DpPolicyGetDefaultPropertyValuesResult|MyElements::DpPolicyGetDefaultPropertyValuesResult> object.

 $response = $interface->DpPolicyGetDefaultPropertyValues(,,
 );

=head3 DpPolicyListIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpPolicyListIterEndResult|MyElements::DpPolicyListIterEndResult> object.

 $response = $interface->DpPolicyListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpPolicyListIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::DpPolicyListIterNextResult|MyElements::DpPolicyListIterNextResult> object.

 $response = $interface->DpPolicyListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpPolicyListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpPolicyListIterStartResult|MyElements::DpPolicyListIterStartResult> object.

 $response = $interface->DpPolicyListIterStart( {
    DpPolicyNameOrId => $some_value, # ObjNameOrId
    IsDrCapable =>  $some_value, # boolean
  },,
 );

=head3 DpPolicyModify

EPOLICYTOPOLOGYCHANGED 

Returns a L<MyElements::DpPolicyModifyResult|MyElements::DpPolicyModifyResult> object.

 $response = $interface->DpPolicyModify( {
    DpPolicyContent =>  { # MyTypes::DpPolicyContent
      Description =>  $some_value, # string
      DpPolicyConnections =>  { # MyTypes::ArrayOfDpPolicyConnectionInfo
        DpPolicyConnectionInfo =>  { # MyTypes::DpPolicyConnectionInfo
          BackupScheduleId => $some_value, # ObjId
          BackupScheduleName => $some_value, # ObjName
          FromNodeId => $some_value, # atomic
          FromNodeName =>  $some_value, # string
          Id => $some_value, # atomic
          IsDrCapable =>  $some_value, # boolean
          IsLagErrorEnabled =>  $some_value, # boolean
          IsLagWarningEnabled =>  $some_value, # boolean
          LagErrorThreshold => $some_value, # atomic
          LagWarningThreshold => $some_value, # atomic
          MirrorScheduleId => $some_value, # ObjId
          MirrorScheduleName => $some_value, # ObjName
          ThrottleScheduleId => $some_value, # ObjId
          ThrottleScheduleName => $some_value, # ObjName
          ToNodeId => $some_value, # atomic
          ToNodeName =>  $some_value, # string
          Type =>  $some_value, # string
        },
      },
      DpPolicyNodes =>  { # MyTypes::ArrayOfDpPolicyNodeInfo
        DpPolicyNodeInfo =>  { # MyTypes::DpPolicyNodeInfo
          BackupScriptPath =>  $some_value, # string
          BackupScriptRunAs =>  $some_value, # string
          DailyRetentionCount => $some_value, # atomic
          DailyRetentionDuration => $some_value, # atomic
          FailoverScriptPath =>  $some_value, # string
          FailoverScriptRunAs =>  $some_value, # string
          HourlyRetentionCount => $some_value, # atomic
          HourlyRetentionDuration => $some_value, # atomic
          Id => $some_value, # atomic
          IsLagErrorEnabled =>  $some_value, # boolean
          IsLagWarningEnabled =>  $some_value, # boolean
          LagErrorThreshold => $some_value, # atomic
          LagWarningThreshold => $some_value, # atomic
          MonthlyRetentionCount => $some_value, # atomic
          MonthlyRetentionDuration => $some_value, # atomic
          Name => $some_value, # DpPolicyNodeName
          SnapshotScheduleId => $some_value, # ObjId
          SnapshotScheduleName => $some_value, # ObjName
          WeeklyRetentionCount => $some_value, # atomic
          WeeklyRetentionDuration => $some_value, # atomic
        },
      },
      Name => $some_value, # ObjName
    },
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 DpRelationshipListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::DpRelationshipListInfoIterEndResult|MyElements::DpRelationshipListInfoIterEndResult> object.

 $response = $interface->DpRelationshipListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpRelationshipListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::DpRelationshipListInfoIterNextResult|MyElements::DpRelationshipListInfoIterNextResult> object.

 $response = $interface->DpRelationshipListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 DpRelationshipListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::DpRelationshipListInfoIterStartResult|MyElements::DpRelationshipListInfoIterStartResult> object.

 $response = $interface->DpRelationshipListInfoIterStart( {
    ConnectionId => $some_value, # atomic
    DatasetNameOrId => $some_value, # ObjNameOrId
    DestinationId => $some_value, # ObjId
    DestinationType => $some_value, # RelationshipEndpointType
    IncludeDeleted =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsDpManaged =>  $some_value, # boolean
    IsInDataset =>  $some_value, # boolean
    IsMigrationRelationship =>  $some_value, # boolean
    OperationalStatuses =>  { # MyTypes::ArrayOfOperationalStatus
      OperationalStatus => $some_value, # OperationalStatus
    },
    RelationshipId => $some_value, # ObjId
    RelationshipStates =>  { # MyTypes::ArrayOfRelationshipState
      RelationshipState => $some_value, # RelationshipState
    },
    RelationshipType => $some_value, # RelationshipType
    SourceId => $some_value, # ObjId
    SourceOrDestinationId => $some_value, # ObjId
    SourceType => $some_value, # RelationshipEndpointType
  },,
 );

=head3 DpRelationshipModify

EOBJECTNOTFOUND 

Returns a L<MyElements::DpRelationshipModifyResult|MyElements::DpRelationshipModifyResult> object.

 $response = $interface->DpRelationshipModify( {
    IsDpImported =>  $some_value, # boolean
    IsDpManaged =>  $some_value, # boolean
    RelationshipId => $some_value, # ObjId
  },,
 );

=head3 DpRestoreToNewPath

EOPERATIONNOTSUPPORTED 

Returns a L<MyElements::DpRestoreToNewPathResult|MyElements::DpRestoreToNewPathResult> object.

 $response = $interface->DpRestoreToNewPath( {
    BackupId => $some_value, # atomic
    BackupVersion => $some_value, # DpTimestamp
    CheckOverwrite =>  $some_value, # boolean
    CheckSpaceStatus =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    Members =>  { # MyTypes::ArrayOfDpRecoverMemberInfo
      DpRecoverMemberInfo =>  { # MyTypes::DpRecoverMemberInfo
        DestinationHost => $some_value, # ObjNameOrId
        DestinationPath =>  $some_value, # string
        DestinationPathSkipExtraDirectory =>  $some_value, # boolean
        MemberNameOrId => $some_value, # ObjNameOrId
        Path =>  $some_value, # string
        PrimarySnapshotName =>  $some_value, # string
        PrimarySnapshotUniqueId =>  $some_value, # string
        RestoreConfiguration =>  $some_value, # boolean
      },
    },
    MigrateRelationship =>  $some_value, # boolean
  },,
 );

=head3 DpRestoreToPrimary

EOPERATIONNOTSUPPORTED 

Returns a L<MyElements::DpRestoreToPrimaryResult|MyElements::DpRestoreToPrimaryResult> object.

 $response = $interface->DpRestoreToPrimary( {
    BackupId => $some_value, # atomic
    BackupVersion => $some_value, # DpTimestamp
    CheckOverwrite =>  $some_value, # boolean
    CheckSpaceStatus =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    Paths =>  { # MyTypes::ArrayOfDpPathInfo
      DpPathInfo =>  { # MyTypes::DpPathInfo
        MemberNameOrId => $some_value, # ObjNameOrId
        Path =>  $some_value, # string
        PrimarySnapshotName =>  $some_value, # string
        PrimarySnapshotUniqueId =>  $some_value, # string
        RestoreConfiguration =>  $some_value, # boolean
      },
    },
  },,
 );

=head3 DpRestoreViStart

EOBJECTNOTRESTORABLE 

Returns a L<MyElements::DpRestoreViStartResult|MyElements::DpRestoreViStartResult> object.

 $response = $interface->DpRestoreViStart( {
    BackupId => $some_value, # atomic
    DpViRestoreObjects =>  { # MyTypes::ArrayOfDpViRestoreObject
      DpViRestoreObject =>  { # MyTypes::DpViRestoreObject
        DpViObjectRestoreSettings =>  { # MyTypes::DpViObjectRestoreSettings
          DpViVmwareObjectRestoreSettings =>  { # MyTypes::DpViVmwareObjectRestoreSettings
            DestinationDatastoreNameOrId => $some_value, # ObjNameOrId
          },
        },
        RestoreObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    DpViRestoreSettings =>  { # MyTypes::DpViRestoreSettings
      DpViHypervRestoreSettings =>  { # MyTypes::DpViHypervRestoreSettings
        StartVmAfterRestore =>  $some_value, # boolean
      },
      DpViVmwareRestoreSettings =>  { # MyTypes::DpViVmwareRestoreSettings
        EsxServerNameOrId => $some_value, # ObjNameOrId
        StartVmAfterRestore =>  $some_value, # boolean
      },
      RestoreScript =>  $some_value, # string
    },
  },,
 );

=head3 DpScheduleContentGet

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleContentGetResult|MyElements::DpScheduleContentGetResult> object.

 $response = $interface->DpScheduleContentGet( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleCreate

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DpScheduleCreateResult|MyElements::DpScheduleCreateResult> object.

 $response = $interface->DpScheduleCreate( {
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 DpScheduleDailyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleDailyAddResult|MyElements::DpScheduleDailyAddResult> object.

 $response = $interface->DpScheduleDailyAdd( {
    DailyContent =>  { # MyTypes::WrapperOfDailyInfo
      DailyInfo =>  { # MyTypes::DailyInfo
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    DailyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleDailyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleDailyDeleteResult|MyElements::DpScheduleDailyDeleteResult> object.

 $response = $interface->DpScheduleDailyDelete( {
    DailyScheduleNameOrId =>  $some_value, # string
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleDailyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleDailyModifyResult|MyElements::DpScheduleDailyModifyResult> object.

 $response = $interface->DpScheduleDailyModify( {
    DailyContent =>  { # MyTypes::WrapperOfDailyInfo
      DailyInfo =>  { # MyTypes::DailyInfo
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    DailyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleDependency

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleDependencyResult|MyElements::DpScheduleDependencyResult> object.

 $response = $interface->DpScheduleDependency( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpScheduleDestroy

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleDestroyResult|MyElements::DpScheduleDestroyResult> object.

 $response = $interface->DpScheduleDestroy( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleHourlyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleHourlyAddResult|MyElements::DpScheduleHourlyAddResult> object.

 $response = $interface->DpScheduleHourlyAdd( {
    DailyScheduleNameOrId =>  $some_value, # string
    HourlyContent =>  { # MyTypes::WrapperOfHourlyInfo
      HourlyInfo =>  { # MyTypes::HourlyInfo
        EndHour => $some_value, # atomic
        EndMinute => $some_value, # atomic
        Frequency => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleHourlyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleHourlyDeleteResult|MyElements::DpScheduleHourlyDeleteResult> object.

 $response = $interface->DpScheduleHourlyDelete( {
    DailyScheduleNameOrId =>  $some_value, # string
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleHourlyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleHourlyModifyResult|MyElements::DpScheduleHourlyModifyResult> object.

 $response = $interface->DpScheduleHourlyModify( {
    DailyScheduleNameOrId =>  $some_value, # string
    HourlyContent =>  { # MyTypes::WrapperOfHourlyInfo
      HourlyInfo =>  { # MyTypes::HourlyInfo
        EndHour => $some_value, # atomic
        EndMinute => $some_value, # atomic
        Frequency => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleList

EDATABASEERROR 

Returns a L<MyElements::DpScheduleListResult|MyElements::DpScheduleListResult> object.

 $response = $interface->DpScheduleList( {
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleListInfoIterEnd

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DpScheduleListInfoIterEndResult|MyElements::DpScheduleListInfoIterEndResult> object.

 $response = $interface->DpScheduleListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpScheduleListInfoIterNext

ESCHEDULEINVALIDINPUT 

Returns a L<MyElements::DpScheduleListInfoIterNextResult|MyElements::DpScheduleListInfoIterNextResult> object.

 $response = $interface->DpScheduleListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DpScheduleListInfoIterStart

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleListInfoIterStartResult|MyElements::DpScheduleListInfoIterStartResult> object.

 $response = $interface->DpScheduleListInfoIterStart( {
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleModifyResult|MyElements::DpScheduleModifyResult> object.

 $response = $interface->DpScheduleModify( {
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 DpScheduleMonthlyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleMonthlyAddResult|MyElements::DpScheduleMonthlyAddResult> object.

 $response = $interface->DpScheduleMonthlyAdd( {
    MonthlyContent =>  { # MyTypes::WrapperOfMonthlyInfo
      MonthlyInfo =>  { # MyTypes::MonthlyInfo
        DayOfMonth => $some_value, # atomic
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
        WeekOfMonth => $some_value, # atomic
      },
    },
    MonthlyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleMonthlyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleMonthlyDeleteResult|MyElements::DpScheduleMonthlyDeleteResult> object.

 $response = $interface->DpScheduleMonthlyDelete( {
    ItemId => $some_value, # atomic
    MonthlyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleMonthlyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleMonthlyModifyResult|MyElements::DpScheduleMonthlyModifyResult> object.

 $response = $interface->DpScheduleMonthlyModify( {
    MonthlyContent =>  { # MyTypes::WrapperOfMonthlyInfo
      MonthlyInfo =>  { # MyTypes::MonthlyInfo
        DayOfMonth => $some_value, # atomic
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
        WeekOfMonth => $some_value, # atomic
      },
    },
    MonthlyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleMonthlySubscheduleSet

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleMonthlySubscheduleSetResult|MyElements::DpScheduleMonthlySubscheduleSetResult> object.

 $response = $interface->DpScheduleMonthlySubscheduleSet( {
    MonthlyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
    SubscheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleMonthlySubscheduleUnset

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleMonthlySubscheduleUnsetResult|MyElements::DpScheduleMonthlySubscheduleUnsetResult> object.

 $response = $interface->DpScheduleMonthlySubscheduleUnset( {
    MonthlyScheduleNameOrId =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
  },,
 );

=head3 DpScheduleRename

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleRenameResult|MyElements::DpScheduleRenameResult> object.

 $response = $interface->DpScheduleRename( {
    NewScheduleName =>  $some_value, # string
    ScheduleCategory =>  $some_value, # string
    ScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklyAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleWeeklyAddResult|MyElements::DpScheduleWeeklyAddResult> object.

 $response = $interface->DpScheduleWeeklyAdd( {
    ScheduleCategory =>  $some_value, # string
    WeeklyContent =>  { # MyTypes::WrapperOfWeeklyInfo
      WeeklyInfo =>  { # MyTypes::WeeklyInfo
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklyDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleWeeklyDeleteResult|MyElements::DpScheduleWeeklyDeleteResult> object.

 $response = $interface->DpScheduleWeeklyDelete( {
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklyModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleWeeklyModifyResult|MyElements::DpScheduleWeeklyModifyResult> object.

 $response = $interface->DpScheduleWeeklyModify( {
    ScheduleCategory =>  $some_value, # string
    WeeklyContent =>  { # MyTypes::WrapperOfWeeklyInfo
      WeeklyInfo =>  { # MyTypes::WeeklyInfo
        DayOfWeek => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
      },
    },
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklySubscheduleAdd

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleWeeklySubscheduleAddResult|MyElements::DpScheduleWeeklySubscheduleAddResult> object.

 $response = $interface->DpScheduleWeeklySubscheduleAdd( {
    DailyScheduleNameOrId =>  $some_value, # string
    EndDayOfWeek => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    StartDayOfWeek => $some_value, # atomic
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklySubscheduleDelete

ESCHEDULENOTFOUND 

Returns a L<MyElements::DpScheduleWeeklySubscheduleDeleteResult|MyElements::DpScheduleWeeklySubscheduleDeleteResult> object.

 $response = $interface->DpScheduleWeeklySubscheduleDelete( {
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpScheduleWeeklySubscheduleModify

ESCHEDULENOTMODIFIABLE 

Returns a L<MyElements::DpScheduleWeeklySubscheduleModifyResult|MyElements::DpScheduleWeeklySubscheduleModifyResult> object.

 $response = $interface->DpScheduleWeeklySubscheduleModify( {
    DailyScheduleNameOrId =>  $some_value, # string
    EndDayOfWeek => $some_value, # atomic
    ItemId => $some_value, # atomic
    ScheduleCategory =>  $some_value, # string
    StartDayOfWeek => $some_value, # atomic
    WeeklyScheduleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpThrottleCreate

ETHROTTLEINVALIDINPUT 

Returns a L<MyElements::DpThrottleCreateResult|MyElements::DpThrottleCreateResult> object.

 $response = $interface->DpThrottleCreate( {
    ThrottleContent =>  { # MyTypes::ThrottleContent
      IsModifiable =>  $some_value, # boolean
      ThrottleDescription =>  $some_value, # string
      ThrottleId => $some_value, # atomic
      ThrottleItemList =>  { # MyTypes::ArrayOfThrottleItemInfo
        ThrottleItemInfo =>  { # MyTypes::ThrottleItemInfo
          DayList =>  { # MyTypes::ArrayOfDayInfo
            DayInfo =>  { # MyTypes::DayInfo
              Day => $some_value, # atomic
            },
          },
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          Throughput => $some_value, # atomic
        },
      },
      ThrottleName =>  $some_value, # string
    },
  },,
 );

=head3 DpThrottleDependency

ETHROTTLENOTFOUND 

Returns a L<MyElements::DpThrottleDependencyResult|MyElements::DpThrottleDependencyResult> object.

 $response = $interface->DpThrottleDependency( {
    ThrottleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 DpThrottleDestroy

ETHROTTLENOTMODIFIABLE 

Returns a L<MyElements::DpThrottleDestroyResult|MyElements::DpThrottleDestroyResult> object.

 $response = $interface->DpThrottleDestroy( {
    ThrottleId => $some_value, # atomic
  },,
 );

=head3 DpThrottleItemAdd

ETHROTTLENOTMODIFIABLE 

Returns a L<MyElements::DpThrottleItemAddResult|MyElements::DpThrottleItemAddResult> object.

 $response = $interface->DpThrottleItemAdd( {
    ThrottleItemContent =>  { # MyTypes::WrapperOfThrottleItemInfo
      ThrottleItemInfo =>  { # MyTypes::ThrottleItemInfo
        DayList =>  { # MyTypes::ArrayOfDayInfo
          DayInfo =>  { # MyTypes::DayInfo
            Day => $some_value, # atomic
          },
        },
        EndHour => $some_value, # atomic
        EndMinute => $some_value, # atomic
        ItemId => $some_value, # atomic
        StartHour => $some_value, # atomic
        StartMinute => $some_value, # atomic
        Throughput => $some_value, # atomic
      },
    },
    ThrottleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpThrottleItemDelete

ETHROTTLENOTMODIFIABLE 

Returns a L<MyElements::DpThrottleItemDeleteResult|MyElements::DpThrottleItemDeleteResult> object.

 $response = $interface->DpThrottleItemDelete( {
    ThrottleItemId => $some_value, # atomic
    ThrottleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpThrottleListInfoIterEnd

ETHROTTLEINVALIDINPUT 

Returns a L<MyElements::DpThrottleListInfoIterEndResult|MyElements::DpThrottleListInfoIterEndResult> object.

 $response = $interface->DpThrottleListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 DpThrottleListInfoIterNext

ETHROTTLEINVALIDINPUT 

Returns a L<MyElements::DpThrottleListInfoIterNextResult|MyElements::DpThrottleListInfoIterNextResult> object.

 $response = $interface->DpThrottleListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 DpThrottleListInfoIterStart

ETHROTTLENOTFOUND 

Returns a L<MyElements::DpThrottleListInfoIterStartResult|MyElements::DpThrottleListInfoIterStartResult> object.

 $response = $interface->DpThrottleListInfoIterStart( {
    ThrottleNameOrId =>  $some_value, # string
  },,
 );

=head3 DpThrottleModify

ETHROTTLENOTMODIFIABLE 

Returns a L<MyElements::DpThrottleModifyResult|MyElements::DpThrottleModifyResult> object.

 $response = $interface->DpThrottleModify( {
    ThrottleContent =>  { # MyTypes::ThrottleContent
      IsModifiable =>  $some_value, # boolean
      ThrottleDescription =>  $some_value, # string
      ThrottleId => $some_value, # atomic
      ThrottleItemList =>  { # MyTypes::ArrayOfThrottleItemInfo
        ThrottleItemInfo =>  { # MyTypes::ThrottleItemInfo
          DayList =>  { # MyTypes::ArrayOfDayInfo
            DayInfo =>  { # MyTypes::DayInfo
              Day => $some_value, # atomic
            },
          },
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          Throughput => $some_value, # atomic
        },
      },
      ThrottleName =>  $some_value, # string
    },
  },,
 );

=head3 DpThrottleRename

ETHROTTLENOTMODIFIABLE 

Returns a L<MyElements::DpThrottleRenameResult|MyElements::DpThrottleRenameResult> object.

 $response = $interface->DpThrottleRename( {
    NewThrottleName =>  $some_value, # string
    ThrottleNameOrId =>  $some_value, # string
  },,
 );

=head3 EventAcknowledge

ENOSUCHEVENT 

Returns a L<MyElements::EventAcknowledgeResult|MyElements::EventAcknowledgeResult> object.

 $response = $interface->EventAcknowledge( {
    EventId => $some_value, # atomic
    EventIdList =>  { # MyTypes::ArrayOfEventIdType
      EventIdType => $some_value, # EventIdType
    },
  },,
 );

=head3 EventDelete

ENOSUCHEVENT 

Returns a L<MyElements::EventDeleteResult|MyElements::EventDeleteResult> object.

 $response = $interface->EventDelete( {
    EventId => $some_value, # atomic
    EventIdList =>  { # MyTypes::ArrayOfEventIdType
      EventIdType => $some_value, # EventIdType
    },
  },,
 );

=head3 EventGenerate

ENOTCUSTOMEVENTCLASS 

Returns a L<MyElements::EventGenerateResult|MyElements::EventGenerateResult> object.

 $response = $interface->EventGenerate( {
    EventMessage =>  $some_value, # string
    EventName =>  $some_value, # string
    Source =>  $some_value, # string
    Timestamp =>  $some_value, # integer
  },,
 );

=head3 EventListIterEnd

EINVALIDTAG 

Returns a L<MyElements::EventListIterEndResult|MyElements::EventListIterEndResult> object.

 $response = $interface->EventListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 EventListIterNext

EINVALIDTAG 

Returns a L<MyElements::EventListIterNextResult|MyElements::EventListIterNextResult> object.

 $response = $interface->EventListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 EventListIterStart

ENOSUCHEVENT 

Returns a L<MyElements::EventListIterStartResult|MyElements::EventListIterStartResult> object.

 $response = $interface->EventListIterStart( {
    EventApplicationList =>  { # MyTypes::ArrayOfEventApplicationType
      EventApplicationType => $some_value, # EventApplicationType
    },
    EventId =>  $some_value, # integer
    EventSeverities =>  { # MyTypes::ArrayOfObjStatus
      ObjStatus => $some_value, # ObjStatus
    },
    EventSourceId =>  $some_value, # integer
    EventTypeFilterList =>  { # MyTypes::ArrayOfEventTypeFilter
      EventTypeFilter =>  { # MyTypes::EventTypeFilter
        EventFilter =>  $some_value, # string
      },
    },
    GreaterThanId =>  $some_value, # integer
    IncludeDatasetResourceStatusEvents =>  $some_value, # boolean
    IncludeDeletedObjects =>  $some_value, # boolean
    IncludeEventArguments =>  $some_value, # boolean
    IncludeRelated =>  $some_value, # boolean
    IsAcknowledged =>  $some_value, # boolean
    IsDeleted =>  $some_value, # boolean
    IsHistory =>  $some_value, # boolean
    IsMostSevereFirst =>  $some_value, # boolean
    IsOldestFirst =>  $some_value, # boolean
    MaxEvents => $some_value, # atomic
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    TimeRange =>  { # MyTypes::WrapperOfEventTimestampRange
      EventTimestampRange =>  { # MyTypes::EventTimestampRange
        EndTime =>  $some_value, # integer
        StartTime =>  $some_value, # integer
      },
    },
    Timeout =>  $some_value, # integer
  },,
 );

=head3 EventStatusChangeListIterEnd

EINVALIDTAG 

Returns a L<MyElements::EventStatusChangeListIterEndResult|MyElements::EventStatusChangeListIterEndResult> object.

 $response = $interface->EventStatusChangeListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 EventStatusChangeListIterNext

EINVALIDTAG 

Returns a L<MyElements::EventStatusChangeListIterNextResult|MyElements::EventStatusChangeListIterNextResult> object.

 $response = $interface->EventStatusChangeListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 EventStatusChangeListIterStart

ENOSUCHEVENT 

Returns a L<MyElements::EventStatusChangeListIterStartResult|MyElements::EventStatusChangeListIterStartResult> object.

 $response = $interface->EventStatusChangeListIterStart( {
    MaxEvents => $some_value, # atomic
    TimeRange =>  { # MyTypes::WrapperOfEventTimestampRange
      EventTimestampRange =>  { # MyTypes::EventTimestampRange
        EndTime =>  $some_value, # integer
        StartTime =>  $some_value, # integer
      },
    },
    Timeout =>  $some_value, # integer
  },,
 );

=head3 EventclassAddCustom

EINVALIDINPUT 

Returns a L<MyElements::EventclassAddCustomResult|MyElements::EventclassAddCustomResult> object.

 $response = $interface->EventclassAddCustom( {
    AboutMessage =>  $some_value, # string
    EventClassName =>  $some_value, # string
    EventNames =>  { # MyTypes::ArrayOfEventNameInfo
      EventNameInfo =>  { # MyTypes::EventNameInfo
        EventNamePretty =>  $some_value, # string
        EventNameShort =>  $some_value, # string
        Severity =>  $some_value, # string
      },
    },
    EventNamespaceName =>  $some_value, # string
    IsAllowDuplicates =>  $some_value, # boolean
    IsMultiCurrent =>  $some_value, # boolean
  },,
 );

=head3 EventclassDeleteCustom

ENOSUCHEVENTCLASS 

Returns a L<MyElements::EventclassDeleteCustomResult|MyElements::EventclassDeleteCustomResult> object.

 $response = $interface->EventclassDeleteCustom( {
    EventClassName =>  $some_value, # string
  },,
 );

=head3 EventclassList

ENOSUCHEVENTCLASS 

Returns a L<MyElements::EventclassListResult|MyElements::EventclassListResult> object.

 $response = $interface->EventclassList( {
    EventClassObjects =>  { # MyTypes::ArrayOfEventClassObject
      EventClassObject =>  { # MyTypes::EventClassObject
        EventClassName =>  $some_value, # string
      },
    },
  },,
 );

=head3 EventclassListIterEnd

EINVALIDTAG 

Returns a L<MyElements::EventclassListIterEndResult|MyElements::EventclassListIterEndResult> object.

 $response = $interface->EventclassListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 EventclassListIterNext

EINVALIDTAG 

Returns a L<MyElements::EventclassListIterNextResult|MyElements::EventclassListIterNextResult> object.

 $response = $interface->EventclassListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 EventclassListIterStart

supported 

Returns a L<MyElements::EventclassListIterStartResult|MyElements::EventclassListIterStartResult> object.

 $response = $interface->EventclassListIterStart(,,
 );

=head3 FcpTargetListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::FcpTargetListInfoIterEndResult|MyElements::FcpTargetListInfoIterEndResult> object.

 $response = $interface->FcpTargetListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 FcpTargetListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::FcpTargetListInfoIterNextResult|MyElements::FcpTargetListInfoIterNextResult> object.

 $response = $interface->FcpTargetListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 FcpTargetListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::FcpTargetListInfoIterStartResult|MyElements::FcpTargetListInfoIterStartResult> object.

 $response = $interface->FcpTargetListInfoIterStart( {
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 GraphDataListInfo

EOBJECTNOTFOUND 

Returns a L<MyElements::GraphDataListInfoResult|MyElements::GraphDataListInfoResult> object.

 $response = $interface->GraphDataListInfo( {
    EndDate =>  $some_value, # integer
    GraphName =>  $some_value, # string
    GraphPeriod =>  $some_value, # string
    PrimaryObject => $some_value, # ObjNameOrId
    SecondaryObject => $some_value, # ObjNameOrId
    StartDate =>  $some_value, # integer
  },,
 );

=head3 GraphListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::GraphListInfoIterEndResult|MyElements::GraphListInfoIterEndResult> object.

 $response = $interface->GraphListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 GraphListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::GraphListInfoIterNextResult|MyElements::GraphListInfoIterNextResult> object.

 $response = $interface->GraphListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 GraphListInfoIterStart

EGRAPHNOTFOUND 

Returns a L<MyElements::GraphListInfoIterStartResult|MyElements::GraphListInfoIterStartResult> object.

 $response = $interface->GraphListInfoIterStart( {
    GraphName =>  $some_value, # string
  },,
 );

=head3 GroupAddMember

EOBJECTNOTFOUND 

Returns a L<MyElements::GroupAddMemberResult|MyElements::GroupAddMemberResult> object.

 $response = $interface->GroupAddMember( {
    GroupNameOrId => $some_value, # GroupNameOrId
    MemberNameOrId => $some_value, # ObjectNameOrId
  },,
 );

=head3 GroupCopy

EPARENTGROUPNAMEAMBIGUOUS 

Returns a L<MyElements::GroupCopyResult|MyElements::GroupCopyResult> object.

 $response = $interface->GroupCopy( {
    GroupNameOrId => $some_value, # GroupNameOrId
    NewGroupName =>  $some_value, # string
    ParentGroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupCreate

EPARENTGROUPNAMEAMBIGUOUS 

Returns a L<MyElements::GroupCreateResult|MyElements::GroupCreateResult> object.

 $response = $interface->GroupCreate( {
    GroupName =>  $some_value, # string
    ParentGroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupDeleteMember

EOBJECTNOTFOUND 

Returns a L<MyElements::GroupDeleteMemberResult|MyElements::GroupDeleteMemberResult> object.

 $response = $interface->GroupDeleteMember( {
    GroupNameOrId => $some_value, # GroupNameOrId
    MemberNameOrId => $some_value, # ObjectNameOrId
  },,
 );

=head3 GroupDestroy

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupDestroyResult|MyElements::GroupDestroyResult> object.

 $response = $interface->GroupDestroy( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupGetOptions

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupGetOptionsResult|MyElements::GroupGetOptionsResult> object.

 $response = $interface->GroupGetOptions( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupGetStatus

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupGetStatusResult|MyElements::GroupGetStatusResult> object.

 $response = $interface->GroupGetStatus( {
    GroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupIsMemberOf

EOBJECTNOTFOUND 

Returns a L<MyElements::GroupIsMemberOfResult|MyElements::GroupIsMemberOfResult> object.

 $response = $interface->GroupIsMemberOf( {
    GroupNameOrId => $some_value, # GroupNameOrId
    ObjectNameOrId => $some_value, # ObjectNameOrId
  },,
 );

=head3 GroupListIterEnd

EINVALIDTAG 

Returns a L<MyElements::GroupListIterEndResult|MyElements::GroupListIterEndResult> object.

 $response = $interface->GroupListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 GroupListIterNext

EINVALIDTAG 

Returns a L<MyElements::GroupListIterNextResult|MyElements::GroupListIterNextResult> object.

 $response = $interface->GroupListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 GroupListIterStart

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupListIterStartResult|MyElements::GroupListIterStartResult> object.

 $response = $interface->GroupListIterStart( {
    GroupNameOrId => $some_value, # GroupNameOrId
    ListSubgroups =>  $some_value, # boolean
    RbacOperation =>  $some_value, # string
  },,
 );

=head3 GroupMemberListIterEnd

EINVALIDTAG 

Returns a L<MyElements::GroupMemberListIterEndResult|MyElements::GroupMemberListIterEndResult> object.

 $response = $interface->GroupMemberListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 GroupMemberListIterNext

ESVCNOTAVAIL 

Returns a L<MyElements::GroupMemberListIterNextResult|MyElements::GroupMemberListIterNextResult> object.

 $response = $interface->GroupMemberListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 GroupMemberListIterStart

supported 

Returns a L<MyElements::GroupMemberListIterStartResult|MyElements::GroupMemberListIterStartResult> object.

 $response = $interface->GroupMemberListIterStart( {
    Groups =>  { # MyTypes::ArrayOfGroup
      Group => $some_value, # Group
    },
    HideSubgroupMembers =>  $some_value, # boolean
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    Type =>  $some_value, # string
  },,
 );

=head3 GroupMove

EPARENTGROUPNAMEAMBIGUOUS 

Returns a L<MyElements::GroupMoveResult|MyElements::GroupMoveResult> object.

 $response = $interface->GroupMove( {
    GroupNameOrId => $some_value, # GroupNameOrId
    NewGroupName =>  $some_value, # string
    ParentGroupNameOrId => $some_value, # GroupNameOrId
  },,
 );

=head3 GroupRename

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupRenameResult|MyElements::GroupRenameResult> object.

 $response = $interface->GroupRename( {
    GroupNameOrId => $some_value, # GroupNameOrId
    NewGroupName =>  $some_value, # string
  },,
 );

=head3 GroupSetOptions

EOBJECTAMBIGUOUS 

Returns a L<MyElements::GroupSetOptionsResult|MyElements::GroupSetOptionsResult> object.

 $response = $interface->GroupSetOptions( {
    GroupNameOrId => $some_value, # GroupNameOrId
    GroupOptionInfo =>  { # MyTypes::GroupOptionInfo
      ChargebackRate =>  $some_value, # string
      GroupContact => $some_value, # EmailAddressList
      GroupOwner =>  $some_value, # string
      SrmMaxLargeFiles => $some_value, # atomic
      SrmMaxNewMtimeFiles => $some_value, # atomic
      SrmMaxOldAtimeFiles => $some_value, # atomic
      SrmMaxOldMtimeFiles => $some_value, # atomic
    },
  },,
 );

=head3 HostAdd

EOBJECTNOTFOUND 

Returns a L<MyElements::HostAddResult|MyElements::HostAddResult> object.

 $response = $interface->HostAdd( {
    AddNetwork =>  $some_value, # boolean
    AdminPort => $some_value, # atomic
    BlockCmode =>  $some_value, # boolean
    HostNameOrId =>  $some_value, # string
  },,
 );

=head3 HostAddLicense

ELICENSEINUSE 

Returns a L<MyElements::HostAddLicenseResult|MyElements::HostAddLicenseResult> object.

 $response = $interface->HostAddLicense( {
    HostLicense =>  $some_value, # string
    HostNameOrId => $some_value, # HostNameOrId
    SuppressInuseError =>  $some_value, # boolean
  },,
 );

=head3 HostAddOssv

EOBJECTNOTFOUND 

Returns a L<MyElements::HostAddOssvResult|MyElements::HostAddOssvResult> object.

 $response = $interface->HostAddOssv( {
    HostNameOrId =>  $some_value, # string
    NdmpCredentials =>  { # MyTypes::WrapperOfFullNdmpCredentials
      FullNdmpCredentials =>  { # MyTypes::FullNdmpCredentials
        NdmpPassword => $some_value, # HostPassword
        NdmpPort => $some_value, # IpPortNumber
        NdmpUsername => $some_value, # NdmpUsername
      },
    },
  },,
 );

=head3 HostAgentOssvServiceStart

ESERVICESTATEUNKNOWN 

Returns a L<MyElements::HostAgentOssvServiceStartResult|MyElements::HostAgentOssvServiceStartResult> object.

 $response = $interface->HostAgentOssvServiceStart( {
    AgentNameOrId => $some_value, # HostNameOrId
    Timeout => $some_value, # atomic
  },,
 );

=head3 HostAgentOssvServiceStop

ESERVICESTATEUNKNOWN 

Returns a L<MyElements::HostAgentOssvServiceStopResult|MyElements::HostAgentOssvServiceStopResult> object.

 $response = $interface->HostAgentOssvServiceStop( {
    AgentNameOrId => $some_value, # HostNameOrId
    Timeout => $some_value, # atomic
  },,
 );

=head3 HostCapabilityListIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostCapabilityListIterEndResult|MyElements::HostCapabilityListIterEndResult> object.

 $response = $interface->HostCapabilityListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostCapabilityListIterNext

EINVALIDTAG 

Returns a L<MyElements::HostCapabilityListIterNextResult|MyElements::HostCapabilityListIterNextResult> object.

 $response = $interface->HostCapabilityListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostCapabilityListIterStart

EINVALIDINPUT 

Returns a L<MyElements::HostCapabilityListIterStartResult|MyElements::HostCapabilityListIterStartResult> object.

 $response = $interface->HostCapabilityListIterStart( {
    HostNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 HostCreateNdmpuser

EOBJECTAMBIGUOUS 

Returns a L<MyElements::HostCreateNdmpuserResult|MyElements::HostCreateNdmpuserResult> object.

 $response = $interface->HostCreateNdmpuser( {
    HostNameOrId => $some_value, # HostNameOrId
    NdmpUsername => $some_value, # NdmpUsername
  },,
 );

=head3 HostDelete

EOBJECTAMBIGUOUS 

Returns a L<MyElements::HostDeleteResult|MyElements::HostDeleteResult> object.

 $response = $interface->HostDelete( {
    HostNameOrId => $some_value, # ObjNameOrId
    IgnoreHostInUse =>  $some_value, # boolean
  },,
 );

=head3 HostDomainuserAdd

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostDomainuserAddResult|MyElements::HostDomainuserAddResult> object.

 $response = $interface->HostDomainuserAdd( {
    HostDomainuserNameOrIdOrSid => $some_value, # DomainuserNameOrIdOrSid
    HostNameOrId => $some_value, # ObjNameOrId
    HostUsergroupNamesOrIds =>  { # MyTypes::ArrayOfHostUsergroupNameOrId
      HostUsergroupNameOrId => $some_value, # HostUsergroupNameOrId
    },
  },,
 );

=head3 HostDomainuserListIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostDomainuserListIterEndResult|MyElements::HostDomainuserListIterEndResult> object.

 $response = $interface->HostDomainuserListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostDomainuserListIterNext

EINVALIDTAG 

Returns a L<MyElements::HostDomainuserListIterNextResult|MyElements::HostDomainuserListIterNextResult> object.

 $response = $interface->HostDomainuserListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostDomainuserListIterStart

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostDomainuserListIterStartResult|MyElements::HostDomainuserListIterStartResult> object.

 $response = $interface->HostDomainuserListIterStart( {
    HostDomainuserNameOrIdOrSid => $some_value, # DomainuserNameOrIdOrSid
    HostUsergroupNameOrId => $some_value, # UsergroupNameOrId
    ObjectNameOrId => $some_value, # ObjNameOrId
    Verbose =>  $some_value, # boolean
  },,
 );

=head3 HostDomainuserPush

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostDomainuserPushResult|MyElements::HostDomainuserPushResult> object.

 $response = $interface->HostDomainuserPush( {
    HostDomainuserNameOrIdOrSid => $some_value, # DomainuserNameOrIdOrSid
    HostNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 HostDomainuserRemove

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostDomainuserRemoveResult|MyElements::HostDomainuserRemoveResult> object.

 $response = $interface->HostDomainuserRemove( {
    HostDomainuserNameOrIdOrSid => $some_value, # DomainuserNameOrIdOrSid
    HostUsergroupNamesOrIds =>  { # MyTypes::ArrayOfHostUsergroupNameOrId
      HostUsergroupNameOrId => $some_value, # HostUsergroupNameOrId
    },
  },,
 );

=head3 HostGetDefaults

EAPIERROR 

Returns a L<MyElements::HostGetDefaultsResult|MyElements::HostGetDefaultsResult> object.

 $response = $interface->HostGetDefaults(,,
 );

=head3 HostListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostListInfoIterEndResult|MyElements::HostListInfoIterEndResult> object.

 $response = $interface->HostListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::HostListInfoIterNextResult|MyElements::HostListInfoIterNextResult> object.

 $response = $interface->HostListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::HostListInfoIterStartResult|MyElements::HostListInfoIterStartResult> object.

 $response = $interface->HostListInfoIterStart( {
    ExpandFilerToVfilers =>  $some_value, # boolean
    HostDpFilterInfo =>  { # MyTypes::HostDpFilterInfo
      IsDpIgnored =>  $some_value, # boolean
      IsInDataset =>  $some_value, # boolean
      IsInResourcepool =>  $some_value, # boolean
      IsSnapmirroredOnly =>  $some_value, # boolean
      IsSnapvaultPrimaryOnly =>  $some_value, # boolean
      IsSnapvaultSecondaryOnly =>  $some_value, # boolean
      IsUnprotected =>  $some_value, # boolean
    },
    HostTypes =>  { # MyTypes::ArrayOfHostType
      HostType => $some_value, # HostType
    },
    IncludeIsAvailable =>  $some_value, # boolean
    IncludeMigrationInfo =>  $some_value, # boolean
    IncludePerfSpaceDetails =>  $some_value, # boolean
    IsDirectMemberOnly =>  $some_value, # boolean
    LicenseFilter =>  { # MyTypes::ArrayOfLicense
      License => $some_value, # License
    },
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId => $some_value, # ObjNameOrId
    QueryHost =>  $some_value, # boolean
    VfilerIpspace => $some_value, # VfilerIpspace
  },,
 );

=head3 HostModify

EOBJECTAMBIGUOUS 

Returns a L<MyElements::HostModifyResult|MyElements::HostModifyResult> object.

 $response = $interface->HostModify( {
    HostModifyInfo =>  { # MyTypes::HostModifyInfo
      AdminPort => $some_value, # IpPortNumber
      AdminTransport =>  $some_value, # string
      HostAddress =>  $some_value, # string
      HostDescription =>  $some_value, # string
      HostDpModifyInfo =>  { # MyTypes::HostDpModifyInfo
        IsDpIgnored =>  $some_value, # boolean
        SnapvaultMaxBackupThreads => $some_value, # atomic
      },
      HostName => $some_value, # ObjName
      HostPassword => $some_value, # HostPassword
      HostUsername =>  $some_value, # string
      NdmpCredentials =>  { # MyTypes::NdmpCredentials
        NdmpPassword => $some_value, # HostPassword
        NdmpPort => $some_value, # IpPortNumber
        NdmpUsername => $some_value, # NdmpUsername
      },
      PerfAdvisorTransport => $some_value, # PerfAdvisorTransport
      UseHostsEquiv =>  $some_value, # boolean
    },
    HostNameOrId => $some_value, # HostNameOrId
  },,
 );

=head3 HostModifyAgentCredentials

EOBJECTAMBIGUOUS 

Returns a L<MyElements::HostModifyAgentCredentialsResult|MyElements::HostModifyAgentCredentialsResult> object.

 $response = $interface->HostModifyAgentCredentials( {
    AgentNameOrId => $some_value, # HostNameOrId
    ManagementPassword => $some_value, # HostPassword
    OsPassword => $some_value, # HostPassword
    OsUsername =>  $some_value, # string
  },,
 );

=head3 HostRoleCreate

EINVALIDROLENAME 

Returns a L<MyElements::HostRoleCreateResult|MyElements::HostRoleCreateResult> object.

 $response = $interface->HostRoleCreate( {
    HostRole =>  { # MyTypes::WrapperOfHostRoleInfo
      HostRoleInfo =>  { # MyTypes::HostRoleInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description => $some_value, # AccessObjectDescription
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleId => $some_value, # AccessObjectId
        HostRoleName => $some_value, # AccessObjectName
      },
    },
  },,
 );

=head3 HostRoleDelete

EROLEAMBIGUOUS 

Returns a L<MyElements::HostRoleDeleteResult|MyElements::HostRoleDeleteResult> object.

 $response = $interface->HostRoleDelete( {
    HostRoleNameOrId => $some_value, # AccessObjectNameOrId
  },,
 );

=head3 HostRoleListIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostRoleListIterEndResult|MyElements::HostRoleListIterEndResult> object.

 $response = $interface->HostRoleListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostRoleListIterNext

EINVALIDTAG 

Returns a L<MyElements::HostRoleListIterNextResult|MyElements::HostRoleListIterNextResult> object.

 $response = $interface->HostRoleListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostRoleListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::HostRoleListIterStartResult|MyElements::HostRoleListIterStartResult> object.

 $response = $interface->HostRoleListIterStart( {
    HostRoleNameOrId => $some_value, # AccessObjectNameOrId
    ObjectNameOrId => $some_value, # ObjNameOrId
    Verbose =>  $some_value, # boolean
  },,
 );

=head3 HostRoleModify

EROLEAMBIGUOUS 

Returns a L<MyElements::HostRoleModifyResult|MyElements::HostRoleModifyResult> object.

 $response = $interface->HostRoleModify( {
    HostRole =>  { # MyTypes::WrapperOfHostRoleInfo
      HostRoleInfo =>  { # MyTypes::HostRoleInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description => $some_value, # AccessObjectDescription
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleId => $some_value, # AccessObjectId
        HostRoleName => $some_value, # AccessObjectName
      },
    },
  },,
 );

=head3 HostRolePush

EROLEAMBIGUOUS 

Returns a L<MyElements::HostRolePushResult|MyElements::HostRolePushResult> object.

 $response = $interface->HostRolePush( {
    HostNameOrId => $some_value, # ObjNameOrId
    HostRoleNameOrId => $some_value, # AccessObjectNameOrId
  },,
 );

=head3 HostSetOption

EOBJECTAMBIGUOUS 

Returns a L<MyElements::HostSetOptionResult|MyElements::HostSetOptionResult> object.

 $response = $interface->HostSetOption( {
    HostNameOrId => $some_value, # HostNameOrId
    HostOptionName =>  $some_value, # string
    HostOptionValue =>  $some_value, # string
  },,
 );

=head3 HostUserAdd

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUserAddResult|MyElements::HostUserAddResult> object.

 $response = $interface->HostUserAdd( {
    HostUser =>  { # MyTypes::WrapperOfHostUserInfo
      HostUserInfo =>  { # MyTypes::HostUserInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description => $some_value, # AccessObjectDescription
        FullName =>  $some_value, # string
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
          HostRoleId => $some_value, # HostRoleId
        },
        HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
          HostRoleName => $some_value, # HostRoleName
        },
        HostUserId => $some_value, # AccessObjectId
        HostUserName => $some_value, # AccessObjectName
        HostUsergroupIds =>  { # MyTypes::ArrayOfHostUsergroupId
          HostUsergroupId => $some_value, # HostUsergroupId
        },
        HostUsergroupNames =>  { # MyTypes::ArrayOfHostUsergroupName
          HostUsergroupName => $some_value, # HostUsergroupName
        },
        MaximumPasswordAge =>  $some_value, # unsignedInt
        MinimumPasswordAge =>  $some_value, # unsignedInt
        Password => $some_value, # HostUserPassword
        Status =>  $some_value, # string
      },
    },
  },,
 );

=head3 HostUserDelete

EUSERAMBIGUOUS 

Returns a L<MyElements::HostUserDeleteResult|MyElements::HostUserDeleteResult> object.

 $response = $interface->HostUserDelete( {
    HostUserNameOrId => $some_value, # AccessObjectNameOrId
  },,
 );

=head3 HostUserListIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostUserListIterEndResult|MyElements::HostUserListIterEndResult> object.

 $response = $interface->HostUserListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostUserListIterNext

EINVALIDTAG 

Returns a L<MyElements::HostUserListIterNextResult|MyElements::HostUserListIterNextResult> object.

 $response = $interface->HostUserListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostUserListIterStart

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUserListIterStartResult|MyElements::HostUserListIterStartResult> object.

 $response = $interface->HostUserListIterStart( {
    HostUserNameOrId => $some_value, # AccessObjectNameOrId
    HostUsergroupNameOrId => $some_value, # UsergroupNameOrId
    ObjectNameOrId => $some_value, # ObjNameOrId
    Verbose =>  $some_value, # boolean
  },,
 );

=head3 HostUserModify

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUserModifyResult|MyElements::HostUserModifyResult> object.

 $response = $interface->HostUserModify( {
    HostUser =>  { # MyTypes::WrapperOfHostUserInfo
      HostUserInfo =>  { # MyTypes::HostUserInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description => $some_value, # AccessObjectDescription
        FullName =>  $some_value, # string
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
          HostRoleId => $some_value, # HostRoleId
        },
        HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
          HostRoleName => $some_value, # HostRoleName
        },
        HostUserId => $some_value, # AccessObjectId
        HostUserName => $some_value, # AccessObjectName
        HostUsergroupIds =>  { # MyTypes::ArrayOfHostUsergroupId
          HostUsergroupId => $some_value, # HostUsergroupId
        },
        HostUsergroupNames =>  { # MyTypes::ArrayOfHostUsergroupName
          HostUsergroupName => $some_value, # HostUsergroupName
        },
        MaximumPasswordAge =>  $some_value, # unsignedInt
        MinimumPasswordAge =>  $some_value, # unsignedInt
        Password => $some_value, # HostUserPassword
        Status =>  $some_value, # string
      },
    },
  },,
 );

=head3 HostUserModifyPassword

EUSERAMBIGUOUS 

Returns a L<MyElements::HostUserModifyPasswordResult|MyElements::HostUserModifyPasswordResult> object.

 $response = $interface->HostUserModifyPassword( {
    HostNameOrId => $some_value, # ObjNameOrId
    HostUserNameOrId => $some_value, # AccessObjectNameOrId
    NewPassword => $some_value, # HostUserPassword
    OldPassword => $some_value, # HostUserPassword
  },,
 );

=head3 HostUserPush

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUserPushResult|MyElements::HostUserPushResult> object.

 $response = $interface->HostUserPush( {
    HostNameOrId => $some_value, # ObjNameOrId
    HostUserNameOrId => $some_value, # AccessObjectNameOrId
    Password => $some_value, # HostUserPassword
  },,
 );

=head3 HostUsergroupCreate

ENOTFOUNDROLE 

Returns a L<MyElements::HostUsergroupCreateResult|MyElements::HostUsergroupCreateResult> object.

 $response = $interface->HostUsergroupCreate( {
    HostUsergroup =>  { # MyTypes::WrapperOfHostUsergroupInfo
      HostUsergroupInfo =>  { # MyTypes::HostUsergroupInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description =>  $some_value, # string
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
          HostRoleId => $some_value, # HostRoleId
        },
        HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
          HostRoleName => $some_value, # HostRoleName
        },
        HostUsergroupId => $some_value, # AccessObjectId
        HostUsergroupName => $some_value, # UsergroupName
      },
    },
  },,
 );

=head3 HostUsergroupDelete

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUsergroupDeleteResult|MyElements::HostUsergroupDeleteResult> object.

 $response = $interface->HostUsergroupDelete( {
    HostUsergroupNameOrId => $some_value, # UsergroupNameOrId
  },,
 );

=head3 HostUsergroupListIterEnd

EINVALIDTAG 

Returns a L<MyElements::HostUsergroupListIterEndResult|MyElements::HostUsergroupListIterEndResult> object.

 $response = $interface->HostUsergroupListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 HostUsergroupListIterNext

EINVALIDTAG 

Returns a L<MyElements::HostUsergroupListIterNextResult|MyElements::HostUsergroupListIterNextResult> object.

 $response = $interface->HostUsergroupListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 HostUsergroupListIterStart

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUsergroupListIterStartResult|MyElements::HostUsergroupListIterStartResult> object.

 $response = $interface->HostUsergroupListIterStart( {
    HostUsergroupNameOrId => $some_value, # UsergroupNameOrId
    ObjectNameOrId => $some_value, # ObjNameOrId
    Verbose =>  $some_value, # boolean
  },,
 );

=head3 HostUsergroupModify

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUsergroupModifyResult|MyElements::HostUsergroupModifyResult> object.

 $response = $interface->HostUsergroupModify( {
    HostUsergroup =>  { # MyTypes::WrapperOfHostUsergroupInfo
      HostUsergroupInfo =>  { # MyTypes::HostUsergroupInfo
        Capabilities =>  { # MyTypes::ArrayOfCapability
          Capability => $some_value, # Capability
        },
        Description =>  $some_value, # string
        HostId => $some_value, # ObjId
        HostName => $some_value, # ObjName
        HostRoleIds =>  { # MyTypes::ArrayOfHostRoleId
          HostRoleId => $some_value, # HostRoleId
        },
        HostRoleNames =>  { # MyTypes::ArrayOfHostRoleName
          HostRoleName => $some_value, # HostRoleName
        },
        HostUsergroupId => $some_value, # AccessObjectId
        HostUsergroupName => $some_value, # UsergroupName
      },
    },
    NewUsergroupName => $some_value, # UsergroupName
  },,
 );

=head3 HostUsergroupPush

EUSERGROUPNOTFOUND 

Returns a L<MyElements::HostUsergroupPushResult|MyElements::HostUsergroupPushResult> object.

 $response = $interface->HostUsergroupPush( {
    HostNameOrId => $some_value, # ObjNameOrId
    HostUsergroupNameOrId => $some_value, # UsergroupNameOrId
  },,
 );

=head3 IfcListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::IfcListInfoIterEndResult|MyElements::IfcListInfoIterEndResult> object.

 $response = $interface->IfcListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 IfcListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::IfcListInfoIterNextResult|MyElements::IfcListInfoIterNextResult> object.

 $response = $interface->IfcListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 IfcListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::IfcListInfoIterStartResult|MyElements::IfcListInfoIterStartResult> object.

 $response = $interface->IfcListInfoIterStart( {
    Ipspace =>  $some_value, # string
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 LdapServerAdd

EINVALIDINPUT 

Returns a L<MyElements::LdapServerAddResult|MyElements::LdapServerAddResult> object.

 $response = $interface->LdapServerAdd( {
    LdapServer =>  { # MyTypes::LdapServer
      LdapServerAddr => $some_value, # NetworkAddress
      LdapServerPort => $some_value, # atomic
    },
  },,
 );

=head3 LdapServerDelete

EINVALIDINPUT 

Returns a L<MyElements::LdapServerDeleteResult|MyElements::LdapServerDeleteResult> object.

 $response = $interface->LdapServerDelete( {
    LdapServer =>  { # MyTypes::LdapServer
      LdapServerAddr => $some_value, # NetworkAddress
      LdapServerPort => $some_value, # atomic
    },
  },,
 );

=head3 LdapServerListInfo

EINVALIDINPUT 

Returns a L<MyElements::LdapServerListInfoResult|MyElements::LdapServerListInfoResult> object.

 $response = $interface->LdapServerListInfo( {
    LdapServer =>  { # MyTypes::LdapServer
      LdapServerAddr => $some_value, # NetworkAddress
      LdapServerPort => $some_value, # atomic
    },
  },,
 );

=head3 LunDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::LunDestroyResult|MyElements::LunDestroyResult> object.

 $response = $interface->LunDestroy( {
    LunNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 LunListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::LunListInfoIterEndResult|MyElements::LunListInfoIterEndResult> object.

 $response = $interface->LunListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 LunListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::LunListInfoIterNextResult|MyElements::LunListInfoIterNextResult> object.

 $response = $interface->LunListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 LunListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::LunListInfoIterStartResult|MyElements::LunListInfoIterStartResult> object.

 $response = $interface->LunListInfoIterStart( {
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId => $some_value, # ObjNameOrId
    RbacOperation =>  $some_value, # string
  },,
 );

=head3 LunResize

EOBJECTNOTFOUND 

Returns a L<MyElements::LunResizeResult|MyElements::LunResizeResult> object.

 $response = $interface->LunResize( {
    LunNameOrId => $some_value, # ObjNameOrId
    NewSize => $some_value, # atomic
    ResizeUnderlyingVolume =>  $some_value, # boolean
  },,
 );

=head3 MigrateCancel

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateCancelResult|MyElements::MigrateCancelResult> object.

 $response = $interface->MigrateCancel( {
    DryRun =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 MigrateChangeState

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateChangeStateResult|MyElements::MigrateChangeStateResult> object.

 $response = $interface->MigrateChangeState( {
    NewMigrationStatus => $some_value, # MigrationStatus
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 MigrateCleanup

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateCleanupResult|MyElements::MigrateCleanupResult> object.

 $response = $interface->MigrateCleanup( {
    DryRun =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 MigrateComplete

EONLINENOTPOSSIBLE 

Returns a L<MyElements::MigrateCompleteResult|MyElements::MigrateCompleteResult> object.

 $response = $interface->MigrateComplete( {
    DryRun =>  $some_value, # boolean
    MaxCutoverTime =>  $some_value, # integer
    MigrateOffline =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    PersistentMigratedRoutes =>  $some_value, # boolean
    RouteMigrationMode => $some_value, # RouteMigrationMode
    RunDedupeScan =>  $some_value, # boolean
    ScriptPath =>  $some_value, # string
  },,
 );

=head3 MigrateFix

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateFixResult|MyElements::MigrateFixResult> object.

 $response = $interface->MigrateFix( {
    DatasetNameOrId => $some_value, # ObjNameOrId
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 MigrateRollback

EONLINENOTPOSSIBLE 

Returns a L<MyElements::MigrateRollbackResult|MyElements::MigrateRollbackResult> object.

 $response = $interface->MigrateRollback( {
    DryRun =>  $some_value, # boolean
    MaxCutoverTime =>  $some_value, # integer
    MigrateOffline =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    PersistentMigratedRoutes =>  $some_value, # boolean
    RouteMigrationMode => $some_value, # RouteMigrationMode
    RunDedupeScan =>  $some_value, # boolean
    ScriptPath =>  $some_value, # string
  },,
 );

=head3 MigrateStart

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateStartResult|MyElements::MigrateStartResult> object.

 $response = $interface->MigrateStart( {
    BandwidthThrottle => $some_value, # atomic
    Description => $some_value, # atomic
    DryRun =>  $some_value, # boolean
    IpBindings =>  { # MyTypes::ArrayOfIpBindingInfo
      IpBindingInfo =>  { # MyTypes::IpBindingInfo
        Interface => $some_value, # ObjNameOrId
        IpAddress => $some_value, # IpAddress
        MtuSize => $some_value, # atomic
        Netmask =>  $some_value, # string
        PartnerInterface => $some_value, # ObjNameOrId
        PrefixLength => $some_value, # atomic
        VlanIdentifier => $some_value, # atomic
      },
    },
    ObjectNameOrId => $some_value, # ObjNameOrId
    OnlineMigration =>  $some_value, # boolean
    PerformCutover =>  $some_value, # boolean
    PersistentMigratedRoutes =>  $some_value, # boolean
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
    ResourceNameOrId => $some_value, # ObjNameOrId
    RouteMigrationMode => $some_value, # RouteMigrationMode
    RunDedupeScan =>  $some_value, # boolean
    ScriptPath =>  $some_value, # string
    VolumeAggregateMap =>  { # MyTypes::ArrayOfVolumeAggregatePair
      VolumeAggregatePair =>  { # MyTypes::VolumeAggregatePair
        Aggregate => $some_value, # ObjNameOrId
        Volume => $some_value, # ObjNameOrId
      },
    },
  },,
 );

=head3 MigrateUpdate

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateUpdateResult|MyElements::MigrateUpdateResult> object.

 $response = $interface->MigrateUpdate( {
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 MigrateVolume

EOBJECTNOTFOUND 

Returns a L<MyElements::MigrateVolumeResult|MyElements::MigrateVolumeResult> object.

 $response = $interface->MigrateVolume( {
    DryRun =>  $some_value, # boolean
    MigrationRequestInfo =>  { # MyTypes::MigrationRequestInfo
      CleanupStaleStorage => $some_value, # CleanupStaleStorage
      DestinationAggregateNameOrId => $some_value, # ObjNameOrId
      RetentionType => $some_value, # DpBackupRetentionType
      RunDedupeScan =>  $some_value, # boolean
      RunOnDemandUpdate =>  $some_value, # boolean
      Volumes =>  { # MyTypes::ArrayOfObjNameOrId
        ObjNameOrId => $some_value, # ObjNameOrId
      },
    },
  },,
 );

=head3 NetifIpInterfaceListInfo

EINVALIDINPUTERROR 

Returns a L<MyElements::NetifIpInterfaceListInfoResult|MyElements::NetifIpInterfaceListInfoResult> object.

 $response = $interface->NetifIpInterfaceListInfo( {
    CommunityString =>  $some_value, # string
    Hostname =>  $some_value, # string
    Timeout => $some_value, # atomic
  },,
 );

=head3 PerfAssocViewListIterEnd

EINVALIDTAG 

Returns a L<MyElements::PerfAssocViewListIterEndResult|MyElements::PerfAssocViewListIterEndResult> object.

 $response = $interface->PerfAssocViewListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfAssocViewListIterNext

EINVALIDTAG 

Returns a L<MyElements::PerfAssocViewListIterNextResult|MyElements::PerfAssocViewListIterNextResult> object.

 $response = $interface->PerfAssocViewListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfAssocViewListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfAssocViewListIterStartResult|MyElements::PerfAssocViewListIterStartResult> object.

 $response = $interface->PerfAssocViewListIterStart( {
    AssocObjType => $some_value, # PerfAssocObjType
    IncludeEmptyViews =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    Verbose =>  $some_value, # boolean
    ViewType => $some_value, # ViewType
  },,
 );

=head3 PerfClientStatsListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::PerfClientStatsListInfoIterEndResult|MyElements::PerfClientStatsListInfoIterEndResult> object.

 $response = $interface->PerfClientStatsListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfClientStatsListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::PerfClientStatsListInfoIterNextResult|MyElements::PerfClientStatsListInfoIterNextResult> object.

 $response = $interface->PerfClientStatsListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfClientStatsListInfoIterStart

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfClientStatsListInfoIterStartResult|MyElements::PerfClientStatsListInfoIterStartResult> object.

 $response = $interface->PerfClientStatsListInfoIterStart( {
    EndTime => $some_value, # Timestamp
    LastOnly =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    StartTime => $some_value, # Timestamp
    StatId => $some_value, # StatId
  },,
 );

=head3 PerfClientStatsPurge

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfClientStatsPurgeResult|MyElements::PerfClientStatsPurgeResult> object.

 $response = $interface->PerfClientStatsPurge( {
    EndTime => $some_value, # Timestamp
    ObjectNameOrId => $some_value, # ObjNameOrId
    StartTime => $some_value, # Timestamp
    StatId => $some_value, # StatId
  },,
 );

=head3 PerfCollectClientOperationStatistics

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfCollectClientOperationStatisticsResult|MyElements::PerfCollectClientOperationStatisticsResult> object.

 $response = $interface->PerfCollectClientOperationStatistics( {
    CollectionPeriod => $some_value, # atomic
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 PerfCopyCounterConfiguration

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfCopyCounterConfigurationResult|MyElements::PerfCopyCounterConfigurationResult> object.

 $response = $interface->PerfCopyCounterConfiguration( {
    DestinationObjects =>  { # MyTypes::ArrayOfObjNameOrId
      ObjNameOrId => $some_value, # ObjNameOrId
    },
    Preview =>  $some_value, # boolean
    SourceHostNameOrId => $some_value, # HostNameOrId
    SrcIsDefault =>  $some_value, # boolean
  },,
 );

=head3 PerfCounterGroupCreate

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupCreateResult|MyElements::PerfCounterGroupCreateResult> object.

 $response = $interface->PerfCounterGroupCreate( {
    CounterGroup =>  { # MyTypes::WrapperOfPerfCounterGroup
      PerfCounterGroup =>  { # MyTypes::PerfCounterGroup
        ApplianceNameOrId =>  $some_value, # string
        CounterGroupName =>  $some_value, # string
        CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
          PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
            CounterDescription =>  $some_value, # string
            CounterName =>  $some_value, # string
            IsCalculatedStats =>  $some_value, # boolean
            LabelNames =>  $some_value, # string
            Metrics =>  { # MyTypes::ArrayOfMetric
              Metric =>  { # MyTypes::Metric
                Id =>  $some_value, # string
                MetricResult =>  $some_value, # string
                Period => $some_value, # atomic
                Slide =>  $some_value, # string
                Type =>  $some_value, # string
                Value =>  $some_value, # string
              },
            },
            ObjectType =>  $some_value, # string
            PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
              PerfLabel =>  { # MyTypes::PerfLabel
                LabelNames =>  $some_value, # string
              },
            },
            TimeConsolidationMethod =>  $some_value, # string
          },
        },
        DataSources =>  { # MyTypes::ArrayOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        EndTime =>  $some_value, # integer
        GroupNameOrId =>  $some_value, # string
        IsDefault =>  $some_value, # boolean
        IsDisableAll =>  $some_value, # boolean
        IsStopped =>  $some_value, # boolean
        NumberRecords =>  $some_value, # integer
        PerfFileName =>  $some_value, # string
        RealTime =>  $some_value, # boolean
        SampleBuffer =>  $some_value, # integer
        SampleRate =>  $some_value, # integer
        SpaceConsumed =>  $some_value, # unsignedLong
        SpaceProjected =>  $some_value, # unsignedLong
        StartTime =>  $some_value, # integer
      },
    },
  },,
 );

=head3 PerfCounterGroupDestroy

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupDestroyResult|MyElements::PerfCounterGroupDestroyResult> object.

 $response = $interface->PerfCounterGroupDestroy( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupGetData

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupGetDataResult|MyElements::PerfCounterGroupGetDataResult> object.

 $response = $interface->PerfCounterGroupGetData( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
      PerfDataGroup =>  { # MyTypes::PerfDataGroup
        DataGroupMethod =>  $some_value, # string
        DataSources =>  { # MyTypes::ArrayOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
      },
    },
    EndTime =>  $some_value, # integer
    GroupNameOrId =>  $some_value, # string
    SampleRate =>  $some_value, # integer
    StartTime =>  $some_value, # integer
    TimeConsolidationMethod =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupGetDynamicDataSources

EGROUPDOESNOTEXIST 

Returns a L<MyElements::PerfCounterGroupGetDynamicDataSourcesResult|MyElements::PerfCounterGroupGetDynamicDataSourcesResult> object.

 $response = $interface->PerfCounterGroupGetDynamicDataSources( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
      PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
        Color =>  $some_value, # string
        DataSource =>  { # MyTypes::WrapperOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        MaximumInstances =>  $some_value, # integer
        SelectAllInstances =>  $some_value, # boolean
        SortOrder =>  $some_value, # string
        TimeInterval =>  $some_value, # integer
      },
    },
    GroupNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupListInfo

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupListInfoResult|MyElements::PerfCounterGroupListInfoResult> object.

 $response = $interface->PerfCounterGroupListInfo( {
    ApplianceNameOrId =>  $some_value, # string
    ConsolidateHosts =>  $some_value, # boolean
    CounterGroupName =>  $some_value, # string
    CounterInfoOnly =>  $some_value, # boolean
    CustomOnly =>  $some_value, # boolean
    DisabledCounterInfoOnly =>  $some_value, # boolean
    GroupNameOrId =>  $some_value, # string
    IncludeCalculatedStats =>  $some_value, # boolean
    MetaDataOnly =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 PerfCounterGroupListIterEnd

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupListIterEndResult|MyElements::PerfCounterGroupListIterEndResult> object.

 $response = $interface->PerfCounterGroupListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupListIterNext

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupListIterNextResult|MyElements::PerfCounterGroupListIterNextResult> object.

 $response = $interface->PerfCounterGroupListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupListIterStart

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupListIterStartResult|MyElements::PerfCounterGroupListIterStartResult> object.

 $response = $interface->PerfCounterGroupListIterStart( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    CustomOnly =>  $some_value, # boolean
    GroupNameOrId =>  $some_value, # string
    MetaDataOnly =>  $some_value, # boolean
  },,
 );

=head3 PerfCounterGroupModify

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupModifyResult|MyElements::PerfCounterGroupModifyResult> object.

 $response = $interface->PerfCounterGroupModify( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroup =>  { # MyTypes::WrapperOfPerfCounterGroup
      PerfCounterGroup =>  { # MyTypes::PerfCounterGroup
        ApplianceNameOrId =>  $some_value, # string
        CounterGroupName =>  $some_value, # string
        CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
          PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
            CounterDescription =>  $some_value, # string
            CounterName =>  $some_value, # string
            IsCalculatedStats =>  $some_value, # boolean
            LabelNames =>  $some_value, # string
            Metrics =>  { # MyTypes::ArrayOfMetric
              Metric =>  { # MyTypes::Metric
                Id =>  $some_value, # string
                MetricResult =>  $some_value, # string
                Period => $some_value, # atomic
                Slide =>  $some_value, # string
                Type =>  $some_value, # string
                Value =>  $some_value, # string
              },
            },
            ObjectType =>  $some_value, # string
            PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
              PerfLabel =>  { # MyTypes::PerfLabel
                LabelNames =>  $some_value, # string
              },
            },
            TimeConsolidationMethod =>  $some_value, # string
          },
        },
        DataSources =>  { # MyTypes::ArrayOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        DataSourcesToBeDisabled =>  { # MyTypes::ArrayOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        EndTime =>  $some_value, # integer
        GroupNameOrId =>  $some_value, # string
        IsDefault =>  $some_value, # boolean
        IsDisableAll =>  $some_value, # boolean
        IsStopped =>  $some_value, # boolean
        NumberRecords =>  $some_value, # integer
        PerfFileName =>  $some_value, # string
        RealTime =>  $some_value, # boolean
        SampleBuffer =>  $some_value, # integer
        SampleRate =>  $some_value, # integer
        SpaceConsumed =>  $some_value, # unsignedLong
        SpaceProjected =>  $some_value, # unsignedLong
        StartTime =>  $some_value, # integer
      },
    },
    CounterGroupName =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupStart

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupStartResult|MyElements::PerfCounterGroupStartResult> object.

 $response = $interface->PerfCounterGroupStart( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfCounterGroupStop

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfCounterGroupStopResult|MyElements::PerfCounterGroupStopResult> object.

 $response = $interface->PerfCounterGroupStop( {
    ApplianceNameOrId =>  $some_value, # string
    CounterGroupName =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfDiagTroubleshoot

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfDiagTroubleshootResult|MyElements::PerfDiagTroubleshootResult> object.

 $response = $interface->PerfDiagTroubleshoot( {
    Duration =>  $some_value, # integer
    EndTime =>  $some_value, # unsignedInt
    ObjectNameOrId => $some_value, # ObjNameOrId
    StartTime =>  $some_value, # unsignedInt
  },,
 );

=head3 PerfDisableDataCollection

EINTERNALERROR 

Returns a L<MyElements::PerfDisableDataCollectionResult|MyElements::PerfDisableDataCollectionResult> object.

 $response = $interface->PerfDisableDataCollection( {
    IsAsync =>  $some_value, # boolean
    IsPersistent =>  $some_value, # boolean
  },,
 );

=head3 PerfDisableObjectUpdate

EINTERNALERROR 

Returns a L<MyElements::PerfDisableObjectUpdateResult|MyElements::PerfDisableObjectUpdateResult> object.

 $response = $interface->PerfDisableObjectUpdate(,,
 );

=head3 PerfEnableDataCollection

EINTERNALERROR 

Returns a L<MyElements::PerfEnableDataCollectionResult|MyElements::PerfEnableDataCollectionResult> object.

 $response = $interface->PerfEnableDataCollection(,,
 );

=head3 PerfEnableObjectUpdate

EINTERNALERROR 

Returns a L<MyElements::PerfEnableObjectUpdateResult|MyElements::PerfEnableObjectUpdateResult> object.

 $response = $interface->PerfEnableObjectUpdate(,,
 );

=head3 PerfGetCounterData

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfGetCounterDataResult|MyElements::PerfGetCounterDataResult> object.

 $response = $interface->PerfGetCounterData( {
    Direction =>  $some_value, # string
    Duration =>  $some_value, # unsignedInt
    EndTime =>  $some_value, # unsignedInt
    InstanceCounterInfo =>  { # MyTypes::InstanceCounterInfo
      CounterInfo =>  { # MyTypes::ArrayOfPerfObjectCounter
        PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
          CounterDescription =>  $some_value, # string
          CounterName =>  $some_value, # string
          IsCalculatedStats =>  $some_value, # boolean
          LabelNames =>  $some_value, # string
          Metrics =>  { # MyTypes::ArrayOfMetric
            Metric =>  { # MyTypes::Metric
              Id =>  $some_value, # string
              MetricResult =>  $some_value, # string
              Period => $some_value, # atomic
              Slide =>  $some_value, # string
              Type =>  $some_value, # string
              Value =>  $some_value, # string
            },
          },
          ObjectType =>  $some_value, # string
          PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
            PerfLabel =>  { # MyTypes::PerfLabel
              LabelNames =>  $some_value, # string
            },
          },
          TimeConsolidationMethod =>  $some_value, # string
        },
      },
      InstanceName =>  $some_value, # string
      ObjectNameOrId => $some_value, # ObjNameOrId
    },
    NumberSamples => $some_value, # atomic
    SampleRate => $some_value, # atomic
    StartTime =>  $some_value, # unsignedInt
    TimeConsolidationMethod =>  $some_value, # string
    TimeFilter =>  { # MyTypes::TimeFilter
      Days =>  { # MyTypes::ArrayOfDay
        Day => $some_value, # Day
      },
      Months =>  { # MyTypes::ArrayOfMonth
        Month => $some_value, # Month
      },
      TimeRanges =>  { # MyTypes::ArrayOfTimeRange
        TimeRange =>  { # MyTypes::TimeRange
          From => $some_value, # atomic
          To => $some_value, # atomic
        },
      },
    },
  },,
 );

=head3 PerfGetCounterDependents

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfGetCounterDependentsResult|MyElements::PerfGetCounterDependentsResult> object.

 $response = $interface->PerfGetCounterDependents( {
    Counters =>  { # MyTypes::ArrayOfPerfObjectCounter
      PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
        CounterDescription =>  $some_value, # string
        CounterName =>  $some_value, # string
        IsCalculatedStats =>  $some_value, # boolean
        LabelNames =>  $some_value, # string
        Metrics =>  { # MyTypes::ArrayOfMetric
          Metric =>  { # MyTypes::Metric
            Id =>  $some_value, # string
            MetricResult =>  $some_value, # string
            Period => $some_value, # atomic
            Slide =>  $some_value, # string
            Type =>  $some_value, # string
            Value =>  $some_value, # string
          },
        },
        ObjectType =>  $some_value, # string
        PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
          PerfLabel =>  { # MyTypes::PerfLabel
            LabelNames =>  $some_value, # string
          },
        },
        TimeConsolidationMethod =>  $some_value, # string
      },
    },
    HostNameOrId => $some_value, # HostNameOrId
  },,
 );

=head3 PerfGetCounterListNotInView

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfGetCounterListNotInViewResult|MyElements::PerfGetCounterListNotInViewResult> object.

 $response = $interface->PerfGetCounterListNotInView( {
    ObjectCounterList =>  { # MyTypes::ArrayOfPerfObjectCounterInfo
      PerfObjectCounterInfo =>  { # MyTypes::PerfObjectCounterInfo
        ObjectNameOrId => $some_value, # ObjNameOrId
        PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
          CounterDescription =>  $some_value, # string
          CounterName =>  $some_value, # string
          IsCalculatedStats =>  $some_value, # boolean
          LabelNames =>  $some_value, # string
          Metrics =>  { # MyTypes::ArrayOfMetric
            Metric =>  { # MyTypes::Metric
              Id =>  $some_value, # string
              MetricResult =>  $some_value, # string
              Period => $some_value, # atomic
              Slide =>  $some_value, # string
              Type =>  $some_value, # string
              Value =>  $some_value, # string
            },
          },
          ObjectType =>  $some_value, # string
          PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
            PerfLabel =>  { # MyTypes::PerfLabel
              LabelNames =>  $some_value, # string
            },
          },
          TimeConsolidationMethod =>  $some_value, # string
        },
      },
    },
  },,
 );

=head3 PerfGetDefaultView

EINTERNALERROR 

Returns a L<MyElements::PerfGetDefaultViewResult|MyElements::PerfGetDefaultViewResult> object.

 $response = $interface->PerfGetDefaultView( {
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 PerfGetServerStatus

EINTERNALERROR 

Returns a L<MyElements::PerfGetServerStatusResult|MyElements::PerfGetServerStatusResult> object.

 $response = $interface->PerfGetServerStatus(,,
 );

=head3 PerfObjectCounterListInfo

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfObjectCounterListInfoResult|MyElements::PerfObjectCounterListInfoResult> object.

 $response = $interface->PerfObjectCounterListInfo( {
    ApplianceNameOrId =>  $some_value, # string
    IncludeCalculatedStats =>  $some_value, # boolean
    ObjectName =>  $some_value, # string
  },,
 );

=head3 PerfObjectDependentCounterListInfo

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfObjectDependentCounterListInfoResult|MyElements::PerfObjectDependentCounterListInfoResult> object.

 $response = $interface->PerfObjectDependentCounterListInfo( {
    ApplianceNameOrId =>  $some_value, # string
    ObjectName =>  $some_value, # string
  },,
 );

=head3 PerfObjectInstanceListIterEnd

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfObjectInstanceListIterEndResult|MyElements::PerfObjectInstanceListIterEndResult> object.

 $response = $interface->PerfObjectInstanceListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfObjectInstanceListIterNext

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfObjectInstanceListIterNextResult|MyElements::PerfObjectInstanceListIterNextResult> object.

 $response = $interface->PerfObjectInstanceListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfObjectInstanceListIterStart

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfObjectInstanceListIterStartResult|MyElements::PerfObjectInstanceListIterStartResult> object.

 $response = $interface->PerfObjectInstanceListIterStart( {
    ApplianceNameOrId =>  $some_value, # string
    ObjectName =>  $some_value, # string
  },,
 );

=head3 PerfObjectListInfo

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfObjectListInfoResult|MyElements::PerfObjectListInfoResult> object.

 $response = $interface->PerfObjectListInfo( {
    ApplianceNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfSetDefaultView

EINTERNALERROR 

Returns a L<MyElements::PerfSetDefaultViewResult|MyElements::PerfSetDefaultViewResult> object.

 $response = $interface->PerfSetDefaultView( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfStatusGet

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfStatusGetResult|MyElements::PerfStatusGetResult> object.

 $response = $interface->PerfStatusGet( {
    HostNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfThresholdCreate

ETHRESHOLDEXIST 

Returns a L<MyElements::PerfThresholdCreateResult|MyElements::PerfThresholdCreateResult> object.

 $response = $interface->PerfThresholdCreate( {
    ThresholdInfo =>  { # MyTypes::ThresholdInfo
      IsEnabled =>  $some_value, # boolean
      ObjectFullName => $some_value, # ObjFullName
      ObjectNameOrId => $some_value, # ObjNameOrId
      PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
        CounterDescription =>  $some_value, # string
        CounterName =>  $some_value, # string
        IsCalculatedStats =>  $some_value, # boolean
        LabelNames =>  $some_value, # string
        Metrics =>  { # MyTypes::ArrayOfMetric
          Metric =>  { # MyTypes::Metric
            Id =>  $some_value, # string
            MetricResult =>  $some_value, # string
            Period => $some_value, # atomic
            Slide =>  $some_value, # string
            Type =>  $some_value, # string
            Value =>  $some_value, # string
          },
        },
        ObjectType =>  $some_value, # string
        PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
          PerfLabel =>  { # MyTypes::PerfLabel
            LabelNames =>  $some_value, # string
          },
        },
        TimeConsolidationMethod =>  $some_value, # string
      },
      ThresholdId => $some_value, # ThresholdId
      ThresholdInterval => $some_value, # atomic
      ThresholdType =>  $some_value, # string
      ThresholdUnit =>  $some_value, # string
      ThresholdValue => $some_value, # atomic
    },
  },,
 );

=head3 PerfThresholdCreate2

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfThresholdCreate2Result|MyElements::PerfThresholdCreate2Result> object.

 $response = $interface->PerfThresholdCreate2( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
      CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
        CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
          PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
            CounterDescription =>  $some_value, # string
            CounterName =>  $some_value, # string
            IsCalculatedStats =>  $some_value, # boolean
            LabelNames =>  $some_value, # string
            Metrics =>  { # MyTypes::ArrayOfMetric
              Metric =>  { # MyTypes::Metric
                Id =>  $some_value, # string
                MetricResult =>  $some_value, # string
                Period => $some_value, # atomic
                Slide =>  $some_value, # string
                Type =>  $some_value, # string
                Value =>  $some_value, # string
              },
            },
            ObjectType =>  $some_value, # string
            PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
              PerfLabel =>  { # MyTypes::PerfLabel
                LabelNames =>  $some_value, # string
              },
            },
            TimeConsolidationMethod =>  $some_value, # string
          },
          ThresholdType =>  $some_value, # string
          ThresholdUnit => $some_value, # CounterUnit
          ThresholdValue =>  $some_value, # unsignedLong
        },
      },
      IsEnabled =>  $some_value, # boolean
      IsIndirect =>  $some_value, # boolean
      ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
        ObjectInfo =>  { # MyTypes::ObjectInfo
          ObjectFullName => $some_value, # ObjFullName
          ObjectId => $some_value, # ObjId
          ObjectName => $some_value, # ObjName
          ObjectType =>  $some_value, # string
        },
      },
      ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
        ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
          Name =>  $some_value, # string
          Value =>  $some_value, # string
        },
      },
      TemplateId => $some_value, # atomic
      TemplateName =>  $some_value, # string
      ThresholdEventName =>  $some_value, # string
      ThresholdId => $some_value, # ThresholdId
      ThresholdInterval => $some_value, # atomic
    },
  },,
 );

=head3 PerfThresholdDelete

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfThresholdDeleteResult|MyElements::PerfThresholdDeleteResult> object.

 $response = $interface->PerfThresholdDelete( {
    ThresholdId => $some_value, # ThresholdId
  },,
 );

=head3 PerfThresholdListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdListInfoIterEndResult|MyElements::PerfThresholdListInfoIterEndResult> object.

 $response = $interface->PerfThresholdListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdListInfoIterNextResult|MyElements::PerfThresholdListInfoIterNextResult> object.

 $response = $interface->PerfThresholdListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdListInfoIterStartResult|MyElements::PerfThresholdListInfoIterStartResult> object.

 $response = $interface->PerfThresholdListInfoIterStart( {
    Query =>  { # MyTypes::WrapperOfThresholdInfo
      ThresholdInfo =>  { # MyTypes::ThresholdInfo
        IsEnabled =>  $some_value, # boolean
        ObjectFullName => $some_value, # ObjFullName
        ObjectNameOrId => $some_value, # ObjNameOrId
        PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
          CounterDescription =>  $some_value, # string
          CounterName =>  $some_value, # string
          IsCalculatedStats =>  $some_value, # boolean
          LabelNames =>  $some_value, # string
          Metrics =>  { # MyTypes::ArrayOfMetric
            Metric =>  { # MyTypes::Metric
              Id =>  $some_value, # string
              MetricResult =>  $some_value, # string
              Period => $some_value, # atomic
              Slide =>  $some_value, # string
              Type =>  $some_value, # string
              Value =>  $some_value, # string
            },
          },
          ObjectType =>  $some_value, # string
          PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
            PerfLabel =>  { # MyTypes::PerfLabel
              LabelNames =>  $some_value, # string
            },
          },
          TimeConsolidationMethod =>  $some_value, # string
        },
        ThresholdId => $some_value, # ThresholdId
        ThresholdInterval => $some_value, # atomic
        ThresholdType =>  $some_value, # string
        ThresholdUnit =>  $some_value, # string
        ThresholdValue => $some_value, # atomic
      },
    },
  },,
 );

=head3 PerfThresholdListInfo2IterEnd

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdListInfo2IterEndResult|MyElements::PerfThresholdListInfo2IterEndResult> object.

 $response = $interface->PerfThresholdListInfo2IterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdListInfo2IterNext

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdListInfo2IterNextResult|MyElements::PerfThresholdListInfo2IterNextResult> object.

 $response = $interface->PerfThresholdListInfo2IterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdListInfo2IterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdListInfo2IterStartResult|MyElements::PerfThresholdListInfo2IterStartResult> object.

 $response = $interface->PerfThresholdListInfo2IterStart( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    ThresholdId => $some_value, # ThresholdId
  },,
 );

=head3 PerfThresholdModify

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdModifyResult|MyElements::PerfThresholdModifyResult> object.

 $response = $interface->PerfThresholdModify( {
    Attributes =>  { # MyTypes::WrapperOfThresholdInfo
      ThresholdInfo =>  { # MyTypes::ThresholdInfo
        IsEnabled =>  $some_value, # boolean
        ObjectFullName => $some_value, # ObjFullName
        ObjectNameOrId => $some_value, # ObjNameOrId
        PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
          CounterDescription =>  $some_value, # string
          CounterName =>  $some_value, # string
          IsCalculatedStats =>  $some_value, # boolean
          LabelNames =>  $some_value, # string
          Metrics =>  { # MyTypes::ArrayOfMetric
            Metric =>  { # MyTypes::Metric
              Id =>  $some_value, # string
              MetricResult =>  $some_value, # string
              Period => $some_value, # atomic
              Slide =>  $some_value, # string
              Type =>  $some_value, # string
              Value =>  $some_value, # string
            },
          },
          ObjectType =>  $some_value, # string
          PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
            PerfLabel =>  { # MyTypes::PerfLabel
              LabelNames =>  $some_value, # string
            },
          },
          TimeConsolidationMethod =>  $some_value, # string
        },
        ThresholdId => $some_value, # ThresholdId
        ThresholdInterval => $some_value, # atomic
        ThresholdType =>  $some_value, # string
        ThresholdUnit =>  $some_value, # string
        ThresholdValue => $some_value, # atomic
      },
    },
  },,
 );

=head3 PerfThresholdModify2

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfThresholdModify2Result|MyElements::PerfThresholdModify2Result> object.

 $response = $interface->PerfThresholdModify2( {
    ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
      CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
        CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
          PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
            CounterDescription =>  $some_value, # string
            CounterName =>  $some_value, # string
            IsCalculatedStats =>  $some_value, # boolean
            LabelNames =>  $some_value, # string
            Metrics =>  { # MyTypes::ArrayOfMetric
              Metric =>  { # MyTypes::Metric
                Id =>  $some_value, # string
                MetricResult =>  $some_value, # string
                Period => $some_value, # atomic
                Slide =>  $some_value, # string
                Type =>  $some_value, # string
                Value =>  $some_value, # string
              },
            },
            ObjectType =>  $some_value, # string
            PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
              PerfLabel =>  { # MyTypes::PerfLabel
                LabelNames =>  $some_value, # string
              },
            },
            TimeConsolidationMethod =>  $some_value, # string
          },
          ThresholdType =>  $some_value, # string
          ThresholdUnit => $some_value, # CounterUnit
          ThresholdValue =>  $some_value, # unsignedLong
        },
      },
      IsEnabled =>  $some_value, # boolean
      IsIndirect =>  $some_value, # boolean
      ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
        ObjectInfo =>  { # MyTypes::ObjectInfo
          ObjectFullName => $some_value, # ObjFullName
          ObjectId => $some_value, # ObjId
          ObjectName => $some_value, # ObjName
          ObjectType =>  $some_value, # string
        },
      },
      ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
        ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
          Name =>  $some_value, # string
          Value =>  $some_value, # string
        },
      },
      TemplateId => $some_value, # atomic
      TemplateName =>  $some_value, # string
      ThresholdEventName =>  $some_value, # string
      ThresholdId => $some_value, # ThresholdId
      ThresholdInterval => $some_value, # atomic
    },
  },,
 );

=head3 PerfThresholdTemplateAttachObjects

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdTemplateAttachObjectsResult|MyElements::PerfThresholdTemplateAttachObjectsResult> object.

 $response = $interface->PerfThresholdTemplateAttachObjects( {
    NewObjects =>  { # MyTypes::ArrayOfObjectInfo
      ObjectInfo =>  { # MyTypes::ObjectInfo
        ObjectFullName => $some_value, # ObjFullName
        ObjectId => $some_value, # ObjId
        ObjectName => $some_value, # ObjName
        ObjectType =>  $some_value, # string
      },
    },
    TemplateNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateCreate

EPERFTEMPLATEEXISTS 

Returns a L<MyElements::PerfThresholdTemplateCreateResult|MyElements::PerfThresholdTemplateCreateResult> object.

 $response = $interface->PerfThresholdTemplateCreate( {
    MemberThresholds =>  { # MyTypes::ArrayOfThresholdInfo2
      ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
        CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
          CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
            PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
              CounterDescription =>  $some_value, # string
              CounterName =>  $some_value, # string
              IsCalculatedStats =>  $some_value, # boolean
              LabelNames =>  $some_value, # string
              Metrics =>  { # MyTypes::ArrayOfMetric
                Metric =>  { # MyTypes::Metric
                  Id =>  $some_value, # string
                  MetricResult =>  $some_value, # string
                  Period => $some_value, # atomic
                  Slide =>  $some_value, # string
                  Type =>  $some_value, # string
                  Value =>  $some_value, # string
                },
              },
              ObjectType =>  $some_value, # string
              PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
                PerfLabel =>  { # MyTypes::PerfLabel
                  LabelNames =>  $some_value, # string
                },
              },
              TimeConsolidationMethod =>  $some_value, # string
            },
            ThresholdType =>  $some_value, # string
            ThresholdUnit => $some_value, # CounterUnit
            ThresholdValue =>  $some_value, # unsignedLong
          },
        },
        IsEnabled =>  $some_value, # boolean
        IsIndirect =>  $some_value, # boolean
        ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
          ObjectInfo =>  { # MyTypes::ObjectInfo
            ObjectFullName => $some_value, # ObjFullName
            ObjectId => $some_value, # ObjId
            ObjectName => $some_value, # ObjName
            ObjectType =>  $some_value, # string
          },
        },
        ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
          ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
            Name =>  $some_value, # string
            Value =>  $some_value, # string
          },
        },
        TemplateId => $some_value, # atomic
        TemplateName =>  $some_value, # string
        ThresholdEventName =>  $some_value, # string
        ThresholdId => $some_value, # ThresholdId
        ThresholdInterval => $some_value, # atomic
      },
    },
    TemplateDescription =>  $some_value, # string
    TemplateName =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateDelete

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfThresholdTemplateDeleteResult|MyElements::PerfThresholdTemplateDeleteResult> object.

 $response = $interface->PerfThresholdTemplateDelete( {
    TemplateNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateDetachObjects

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdTemplateDetachObjectsResult|MyElements::PerfThresholdTemplateDetachObjectsResult> object.

 $response = $interface->PerfThresholdTemplateDetachObjects( {
    Objects =>  { # MyTypes::ArrayOfObjectInfo
      ObjectInfo =>  { # MyTypes::ObjectInfo
        ObjectFullName => $some_value, # ObjFullName
        ObjectId => $some_value, # ObjId
        ObjectName => $some_value, # ObjName
        ObjectType =>  $some_value, # string
      },
    },
    TemplateNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdTemplateListInfoIterEndResult|MyElements::PerfThresholdTemplateListInfoIterEndResult> object.

 $response = $interface->PerfThresholdTemplateListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::PerfThresholdTemplateListInfoIterNextResult|MyElements::PerfThresholdTemplateListInfoIterNextResult> object.

 $response = $interface->PerfThresholdTemplateListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfThresholdTemplateListInfoIterStartResult|MyElements::PerfThresholdTemplateListInfoIterStartResult> object.

 $response = $interface->PerfThresholdTemplateListInfoIterStart( {
    IncludeObjects =>  $some_value, # boolean
    IncludeThresholds =>  $some_value, # boolean
    TemplateNameOrId =>  $some_value, # string
  },,
 );

=head3 PerfThresholdTemplateModify

EINVALIDINPUTERROR 

Returns a L<MyElements::PerfThresholdTemplateModifyResult|MyElements::PerfThresholdTemplateModifyResult> object.

 $response = $interface->PerfThresholdTemplateModify( {
    IsEnabled =>  $some_value, # boolean
    MemberThresholds =>  { # MyTypes::ArrayOfThresholdInfo2
      ThresholdInfo2 =>  { # MyTypes::ThresholdInfo2
        CounterThresholds =>  { # MyTypes::ArrayOfCounterThresholdInfo
          CounterThresholdInfo =>  { # MyTypes::CounterThresholdInfo
            PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
              CounterDescription =>  $some_value, # string
              CounterName =>  $some_value, # string
              IsCalculatedStats =>  $some_value, # boolean
              LabelNames =>  $some_value, # string
              Metrics =>  { # MyTypes::ArrayOfMetric
                Metric =>  { # MyTypes::Metric
                  Id =>  $some_value, # string
                  MetricResult =>  $some_value, # string
                  Period => $some_value, # atomic
                  Slide =>  $some_value, # string
                  Type =>  $some_value, # string
                  Value =>  $some_value, # string
                },
              },
              ObjectType =>  $some_value, # string
              PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
                PerfLabel =>  { # MyTypes::PerfLabel
                  LabelNames =>  $some_value, # string
                },
              },
              TimeConsolidationMethod =>  $some_value, # string
            },
            ThresholdType =>  $some_value, # string
            ThresholdUnit => $some_value, # CounterUnit
            ThresholdValue =>  $some_value, # unsignedLong
          },
        },
        IsEnabled =>  $some_value, # boolean
        IsIndirect =>  $some_value, # boolean
        ObjectsInfo =>  { # MyTypes::ArrayOfObjectInfo
          ObjectInfo =>  { # MyTypes::ObjectInfo
            ObjectFullName => $some_value, # ObjFullName
            ObjectId => $some_value, # ObjId
            ObjectName => $some_value, # ObjName
            ObjectType =>  $some_value, # string
          },
        },
        ResourcePropertyConditions =>  { # MyTypes::ArrayOfResourcePropertyCondition
          ResourcePropertyCondition =>  { # MyTypes::ResourcePropertyCondition
            Name =>  $some_value, # string
            Value =>  $some_value, # string
          },
        },
        TemplateId => $some_value, # atomic
        TemplateName =>  $some_value, # string
        ThresholdEventName =>  $some_value, # string
        ThresholdId => $some_value, # ThresholdId
        ThresholdInterval => $some_value, # atomic
      },
    },
    TemplateDescription =>  $some_value, # string
    TemplateId => $some_value, # atomic
    TemplateName =>  $some_value, # string
  },,
 );

=head3 PerfViewAssociatedObjectsList

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfViewAssociatedObjectsListResult|MyElements::PerfViewAssociatedObjectsListResult> object.

 $response = $interface->PerfViewAssociatedObjectsList( {
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewCreate

EPERFUPDATEDISABLED 

Returns a L<MyElements::PerfViewCreateResult|MyElements::PerfViewCreateResult> object.

 $response = $interface->PerfViewCreate( {
    DataSources =>  { # MyTypes::ArrayOfPerfDataSource
      PerfDataSource =>  { # MyTypes::PerfDataSource
        ApplianceNameOrId =>  $some_value, # string
        CounterName =>  $some_value, # string
        GroupNameOrId =>  $some_value, # string
        InstanceName =>  $some_value, # string
        LabelNames =>  $some_value, # string
        ObjectFullName => $some_value, # ObjFullName
        ObjectName =>  $some_value, # string
        ObjectNameOrId => $some_value, # ObjNameOrId
        ObjectType =>  $some_value, # string
      },
    },
    RealTime =>  $some_value, # boolean
    View =>  { # MyTypes::WrapperOfPerfView
      PerfView =>  { # MyTypes::PerfView
        ApplianceNameOrId =>  $some_value, # string
        AreEventsShown =>  $some_value, # boolean
        AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
          PerfAssocObjType => $some_value, # PerfAssocObjType
        },
        Charts =>  { # MyTypes::ArrayOfPerfChart
          PerfChart =>  { # MyTypes::PerfChart
            ChartName =>  $some_value, # string
            DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
              PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
                Color =>  $some_value, # string
                DataSource =>  { # MyTypes::WrapperOfPerfDataSource
                  PerfDataSource =>  { # MyTypes::PerfDataSource
                    ApplianceNameOrId =>  $some_value, # string
                    CounterName =>  $some_value, # string
                    GroupNameOrId =>  $some_value, # string
                    InstanceName =>  $some_value, # string
                    LabelNames =>  $some_value, # string
                    ObjectFullName => $some_value, # ObjFullName
                    ObjectName =>  $some_value, # string
                    ObjectNameOrId => $some_value, # ObjNameOrId
                    ObjectType =>  $some_value, # string
                  },
                },
                MaximumInstances =>  $some_value, # integer
                SelectAllInstances =>  $some_value, # boolean
                SortOrder =>  $some_value, # string
                TimeInterval =>  $some_value, # integer
              },
            },
            Lines =>  { # MyTypes::ArrayOfPerfLine
              PerfLine =>  { # MyTypes::PerfLine
                Color =>  $some_value, # string
                DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
                  PerfDataGroup =>  { # MyTypes::PerfDataGroup
                    DataGroupMethod =>  $some_value, # string
                    DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                      PerfDataSource =>  { # MyTypes::PerfDataSource
                        ApplianceNameOrId =>  $some_value, # string
                        CounterName =>  $some_value, # string
                        GroupNameOrId =>  $some_value, # string
                        InstanceName =>  $some_value, # string
                        LabelNames =>  $some_value, # string
                        ObjectFullName => $some_value, # ObjFullName
                        ObjectName =>  $some_value, # string
                        ObjectNameOrId => $some_value, # ObjNameOrId
                        ObjectType =>  $some_value, # string
                      },
                    },
                  },
                },
                LineName =>  $some_value, # string
                Type =>  $some_value, # string
              },
            },
            MaximumY =>  $some_value, # integer
            Type =>  $some_value, # string
          },
        },
        CounterGroupName =>  $some_value, # string
        GroupNameOrId =>  $some_value, # string
        IsDefault =>  $some_value, # boolean
        IsStopped =>  $some_value, # boolean
        SampleBuffer =>  $some_value, # integer
        SampleRate =>  $some_value, # integer
        ViewName =>  $some_value, # string
        ViewType => $some_value, # ViewType
      },
    },
  },,
 );

=head3 PerfViewDestroy

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfViewDestroyResult|MyElements::PerfViewDestroyResult> object.

 $response = $interface->PerfViewDestroy( {
    ApplianceNameOrId =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
    IsCounterGroupAlsoDeleted =>  $some_value, # boolean
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewGetData

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfViewGetDataResult|MyElements::PerfViewGetDataResult> object.

 $response = $interface->PerfViewGetData( {
    Direction =>  $some_value, # string
    Duration =>  $some_value, # unsignedInt
    DynamicObjectInfo =>  { # MyTypes::WrapperOfPerfDynamicDataSources
      PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
        Color =>  $some_value, # string
        DataSource =>  { # MyTypes::WrapperOfPerfDataSource
          PerfDataSource =>  { # MyTypes::PerfDataSource
            ApplianceNameOrId =>  $some_value, # string
            CounterName =>  $some_value, # string
            GroupNameOrId =>  $some_value, # string
            InstanceName =>  $some_value, # string
            LabelNames =>  $some_value, # string
            ObjectFullName => $some_value, # ObjFullName
            ObjectName =>  $some_value, # string
            ObjectNameOrId => $some_value, # ObjNameOrId
            ObjectType =>  $some_value, # string
          },
        },
        MaximumInstances =>  $some_value, # integer
        SelectAllInstances =>  $some_value, # boolean
        SortOrder =>  $some_value, # string
        TimeInterval =>  $some_value, # integer
      },
    },
    EndTime =>  $some_value, # unsignedInt
    Instance =>  { # MyTypes::WrapperOfPerfCounterInstance
      PerfCounterInstance =>  { # MyTypes::PerfCounterInstance
        CounterInfo =>  { # MyTypes::WrapperOfPerfObjectCounter
          PerfObjectCounter =>  { # MyTypes::PerfObjectCounter
            CounterDescription =>  $some_value, # string
            CounterName =>  $some_value, # string
            IsCalculatedStats =>  $some_value, # boolean
            LabelNames =>  $some_value, # string
            Metrics =>  { # MyTypes::ArrayOfMetric
              Metric =>  { # MyTypes::Metric
                Id =>  $some_value, # string
                MetricResult =>  $some_value, # string
                Period => $some_value, # atomic
                Slide =>  $some_value, # string
                Type =>  $some_value, # string
                Value =>  $some_value, # string
              },
            },
            ObjectType =>  $some_value, # string
            PerfLabels =>  { # MyTypes::ArrayOfPerfLabel
              PerfLabel =>  { # MyTypes::PerfLabel
                LabelNames =>  $some_value, # string
              },
            },
            TimeConsolidationMethod =>  $some_value, # string
          },
        },
        InstanceName =>  $some_value, # string
        ObjectNameOrId => $some_value, # ObjNameOrId
      },
    },
    IsDynamic =>  $some_value, # boolean
    NumberSamples => $some_value, # atomic
    SampleRate => $some_value, # atomic
    StartTime =>  $some_value, # unsignedInt
    TimeConsolidationMethod =>  $some_value, # string
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewListIterEnd

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfViewListIterEndResult|MyElements::PerfViewListIterEndResult> object.

 $response = $interface->PerfViewListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfViewListIterNext

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfViewListIterNextResult|MyElements::PerfViewListIterNextResult> object.

 $response = $interface->PerfViewListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 PerfViewListIterStart

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfViewListIterStartResult|MyElements::PerfViewListIterStartResult> object.

 $response = $interface->PerfViewListIterStart( {
    ApplianceNameOrId =>  $some_value, # string
    CustomOnly =>  $some_value, # boolean
    GroupNameOrId =>  $some_value, # string
    IncludeEmptyViews =>  $some_value, # boolean
    InstanceName =>  $some_value, # string
    ObjectName =>  $some_value, # string
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewModify

EAPIPRIVILEDGE 

Returns a L<MyElements::PerfViewModifyResult|MyElements::PerfViewModifyResult> object.

 $response = $interface->PerfViewModify( {
    ApplianceNameOrId =>  $some_value, # string
    GroupNameOrId =>  $some_value, # string
    View =>  { # MyTypes::WrapperOfPerfView
      PerfView =>  { # MyTypes::PerfView
        ApplianceNameOrId =>  $some_value, # string
        AreEventsShown =>  $some_value, # boolean
        AssocObjType =>  { # MyTypes::ArrayOfPerfAssocObjType
          PerfAssocObjType => $some_value, # PerfAssocObjType
        },
        Charts =>  { # MyTypes::ArrayOfPerfChart
          PerfChart =>  { # MyTypes::PerfChart
            ChartName =>  $some_value, # string
            DynamicDataSources =>  { # MyTypes::WrapperOfPerfDynamicDataSources
              PerfDynamicDataSources =>  { # MyTypes::PerfDynamicDataSources
                Color =>  $some_value, # string
                DataSource =>  { # MyTypes::WrapperOfPerfDataSource
                  PerfDataSource =>  { # MyTypes::PerfDataSource
                    ApplianceNameOrId =>  $some_value, # string
                    CounterName =>  $some_value, # string
                    GroupNameOrId =>  $some_value, # string
                    InstanceName =>  $some_value, # string
                    LabelNames =>  $some_value, # string
                    ObjectFullName => $some_value, # ObjFullName
                    ObjectName =>  $some_value, # string
                    ObjectNameOrId => $some_value, # ObjNameOrId
                    ObjectType =>  $some_value, # string
                  },
                },
                MaximumInstances =>  $some_value, # integer
                SelectAllInstances =>  $some_value, # boolean
                SortOrder =>  $some_value, # string
                TimeInterval =>  $some_value, # integer
              },
            },
            Lines =>  { # MyTypes::ArrayOfPerfLine
              PerfLine =>  { # MyTypes::PerfLine
                Color =>  $some_value, # string
                DataGroup =>  { # MyTypes::WrapperOfPerfDataGroup
                  PerfDataGroup =>  { # MyTypes::PerfDataGroup
                    DataGroupMethod =>  $some_value, # string
                    DataSources =>  { # MyTypes::ArrayOfPerfDataSource
                      PerfDataSource =>  { # MyTypes::PerfDataSource
                        ApplianceNameOrId =>  $some_value, # string
                        CounterName =>  $some_value, # string
                        GroupNameOrId =>  $some_value, # string
                        InstanceName =>  $some_value, # string
                        LabelNames =>  $some_value, # string
                        ObjectFullName => $some_value, # ObjFullName
                        ObjectName =>  $some_value, # string
                        ObjectNameOrId => $some_value, # ObjNameOrId
                        ObjectType =>  $some_value, # string
                      },
                    },
                  },
                },
                LineName =>  $some_value, # string
                Type =>  $some_value, # string
              },
            },
            MaximumY =>  $some_value, # integer
            Type =>  $some_value, # string
          },
        },
        CounterGroupName =>  $some_value, # string
        GroupNameOrId =>  $some_value, # string
        IsDefault =>  $some_value, # boolean
        IsStopped =>  $some_value, # boolean
        SampleBuffer =>  $some_value, # integer
        SampleRate =>  $some_value, # integer
        ViewName =>  $some_value, # string
        ViewType => $some_value, # ViewType
      },
    },
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewObjectAssociationAdd

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfViewObjectAssociationAddResult|MyElements::PerfViewObjectAssociationAddResult> object.

 $response = $interface->PerfViewObjectAssociationAdd( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    ViewName =>  $some_value, # string
  },,
 );

=head3 PerfViewObjectAssociationDelete

EOBJECTNOTFOUND 

Returns a L<MyElements::PerfViewObjectAssociationDeleteResult|MyElements::PerfViewObjectAssociationDeleteResult> object.

 $response = $interface->PerfViewObjectAssociationDelete( {
    ObjectNameOrId => $some_value, # ObjNameOrId
    ViewName =>  $some_value, # string
  },,
 );

=head3 ProvisioningPolicyCopy

EPOLICYEXISTS 

Returns a L<MyElements::ProvisioningPolicyCopyResult|MyElements::ProvisioningPolicyCopyResult> object.

 $response = $interface->ProvisioningPolicyCopy( {
    ProvisioningPolicyDescription =>  $some_value, # string
    ProvisioningPolicyName => $some_value, # ObjName
    SourcePolicyNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ProvisioningPolicyCreate

EPOLICYEXISTS 

Returns a L<MyElements::ProvisioningPolicyCreateResult|MyElements::ProvisioningPolicyCreateResult> object.

 $response = $interface->ProvisioningPolicyCreate( {
    ProvisioningPolicyInfo =>  { # MyTypes::ProvisioningPolicyInfo
      AdvancedOptions =>  { # MyTypes::ArrayOfAdvancedOptionInfo
        AdvancedOptionInfo =>  { # MyTypes::AdvancedOptionInfo
          OptionName =>  $some_value, # string
          OptionValue =>  $some_value, # string
        },
      },
      CustomProvisioningScriptSettings =>  { # MyTypes::CustomProvisioningScriptSettings
        ScriptPath =>  $some_value, # string
      },
      DatasetMemberUsedSpaceThresholds =>  { # MyTypes::DatasetMemberUsedSpaceThresholds
        FullThreshold => $some_value, # atomic
        NearlyFullThreshold => $some_value, # atomic
      },
      DedupeEnabled =>  $some_value, # boolean
      DedupeSchedule =>  $some_value, # string
      IsPolicyReadonly =>  $some_value, # boolean
      NasContainerSettings =>  { # MyTypes::NasContainerSettings
        AutoDeleteSnapshots =>  $some_value, # boolean
        AutoGrowCapacity =>  $some_value, # boolean
        DefaultGroupQuota => $some_value, # atomic
        DefaultUserQuota => $some_value, # atomic
        SnapshotReserve =>  $some_value, # boolean
        SpaceOnDemand =>  $some_value, # boolean
        StorageContainerType => $some_value, # StorageContainerType
        ThinProvision =>  $some_value, # boolean
      },
      ProvisioningPolicyDescription =>  $some_value, # string
      ProvisioningPolicyId => $some_value, # ObjId
      ProvisioningPolicyName => $some_value, # ObjName
      ProvisioningPolicyType => $some_value, # ProvisioningPolicyType
      ResourceTag =>  $some_value, # string
      SanContainerSettings =>  { # MyTypes::SanContainerSettings
        GuaranteeWrites =>  $some_value, # boolean
        StorageContainerType => $some_value, # StorageContainerType
        ThinProvision =>  $some_value, # boolean
        ThinProvisioningConfiguration =>  $some_value, # string
      },
      StorageReliability =>  { # MyTypes::StorageReliability
        ControllerFailure =>  $some_value, # boolean
        DiskFailure =>  $some_value, # string
        SubSystemFailure =>  $some_value, # boolean
      },
    },
  },,
 );

=head3 ProvisioningPolicyDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::ProvisioningPolicyDestroyResult|MyElements::ProvisioningPolicyDestroyResult> object.

 $response = $interface->ProvisioningPolicyDestroy( {
    Force =>  $some_value, # boolean
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ProvisioningPolicyEditBegin

EOBJECTNOTFOUND 

Returns a L<MyElements::ProvisioningPolicyEditBeginResult|MyElements::ProvisioningPolicyEditBeginResult> object.

 $response = $interface->ProvisioningPolicyEditBegin( {
    Force =>  $some_value, # boolean
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ProvisioningPolicyEditCommit

EPOLICYEXISTS 

Returns a L<MyElements::ProvisioningPolicyEditCommitResult|MyElements::ProvisioningPolicyEditCommitResult> object.

 $response = $interface->ProvisioningPolicyEditCommit( {
    DryRun =>  $some_value, # boolean
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 ProvisioningPolicyEditRollback

EEDITSESSIONNOTFOUND 

Returns a L<MyElements::ProvisioningPolicyEditRollbackResult|MyElements::ProvisioningPolicyEditRollbackResult> object.

 $response = $interface->ProvisioningPolicyEditRollback( {
    EditLockId =>  $some_value, # integer
  },,
 );

=head3 ProvisioningPolicyListIterEnd

EINVALIDTAG 

Returns a L<MyElements::ProvisioningPolicyListIterEndResult|MyElements::ProvisioningPolicyListIterEndResult> object.

 $response = $interface->ProvisioningPolicyListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ProvisioningPolicyListIterNext

EINVALIDTAG 

Returns a L<MyElements::ProvisioningPolicyListIterNextResult|MyElements::ProvisioningPolicyListIterNextResult> object.

 $response = $interface->ProvisioningPolicyListIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ProvisioningPolicyListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ProvisioningPolicyListIterStartResult|MyElements::ProvisioningPolicyListIterStartResult> object.

 $response = $interface->ProvisioningPolicyListIterStart( {
    IsPolicyReadonly =>  $some_value, # boolean
    ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
    ProvisioningPolicyType => $some_value, # ProvisioningPolicyType
  },,
 );

=head3 ProvisioningPolicyModify

EOBJECTNOTFOUND 

Returns a L<MyElements::ProvisioningPolicyModifyResult|MyElements::ProvisioningPolicyModifyResult> object.

 $response = $interface->ProvisioningPolicyModify( {
    EditLockId =>  $some_value, # integer
    ProvisioningPolicyInfo =>  { # MyTypes::ProvisioningPolicyInfo
      AdvancedOptions =>  { # MyTypes::ArrayOfAdvancedOptionInfo
        AdvancedOptionInfo =>  { # MyTypes::AdvancedOptionInfo
          OptionName =>  $some_value, # string
          OptionValue =>  $some_value, # string
        },
      },
      CustomProvisioningScriptSettings =>  { # MyTypes::CustomProvisioningScriptSettings
        ScriptPath =>  $some_value, # string
      },
      DatasetMemberUsedSpaceThresholds =>  { # MyTypes::DatasetMemberUsedSpaceThresholds
        FullThreshold => $some_value, # atomic
        NearlyFullThreshold => $some_value, # atomic
      },
      DedupeEnabled =>  $some_value, # boolean
      DedupeSchedule =>  $some_value, # string
      IsPolicyReadonly =>  $some_value, # boolean
      NasContainerSettings =>  { # MyTypes::NasContainerSettings
        AutoDeleteSnapshots =>  $some_value, # boolean
        AutoGrowCapacity =>  $some_value, # boolean
        DefaultGroupQuota => $some_value, # atomic
        DefaultUserQuota => $some_value, # atomic
        SnapshotReserve =>  $some_value, # boolean
        SpaceOnDemand =>  $some_value, # boolean
        StorageContainerType => $some_value, # StorageContainerType
        ThinProvision =>  $some_value, # boolean
      },
      ProvisioningPolicyDescription =>  $some_value, # string
      ProvisioningPolicyId => $some_value, # ObjId
      ProvisioningPolicyName => $some_value, # ObjName
      ProvisioningPolicyType => $some_value, # ProvisioningPolicyType
      ResourceTag =>  $some_value, # string
      SanContainerSettings =>  { # MyTypes::SanContainerSettings
        GuaranteeWrites =>  $some_value, # boolean
        StorageContainerType => $some_value, # StorageContainerType
        ThinProvision =>  $some_value, # boolean
        ThinProvisioningConfiguration =>  $some_value, # string
      },
      StorageReliability =>  { # MyTypes::StorageReliability
        ControllerFailure =>  $some_value, # boolean
        DiskFailure =>  $some_value, # string
        SubSystemFailure =>  $some_value, # boolean
      },
    },
  },,
 );

=head3 QtreeListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::QtreeListInfoIterEndResult|MyElements::QtreeListInfoIterEndResult> object.

 $response = $interface->QtreeListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 QtreeListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::QtreeListInfoIterNextResult|MyElements::QtreeListInfoIterNextResult> object.

 $response = $interface->QtreeListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 QtreeListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::QtreeListInfoIterStartResult|MyElements::QtreeListInfoIterStartResult> object.

 $response = $interface->QtreeListInfoIterStart( {
    IncludeIsAvailable =>  $some_value, # boolean
    IsDirectMemberOnly =>  $some_value, # boolean
    IsDirectVfilerChild =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsInDataset =>  $some_value, # boolean
    IsSnapvaultSecondaryQtrees =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId =>  $some_value, # string
    RbacOperation =>  $some_value, # string
    SortResults =>  $some_value, # boolean
  },,
 );

=head3 QtreeModify

EOBJECTNOTFOUND 

Returns a L<MyElements::QtreeModifyResult|MyElements::QtreeModifyResult> object.

 $response = $interface->QtreeModify( {
    IsDpIgnored =>  $some_value, # boolean
    QtreeNameOrId =>  $some_value, # string
  },,
 );

=head3 QtreeRename

EQTREEDOESNOTEXIST 

Returns a L<MyElements::QtreeRenameResult|MyElements::QtreeRenameResult> object.

 $response = $interface->QtreeRename( {
    QtreeNameNew =>  $some_value, # string
    QtreeNameOrId => $some_value, # atomic
  },,
 );

=head3 QtreeStartMonitoring

EQTREEUNDELETEFAIL 

Returns a L<MyElements::QtreeStartMonitoringResult|MyElements::QtreeStartMonitoringResult> object.

 $response = $interface->QtreeStartMonitoring( {
    QtreeNameOrId => $some_value, # atomic
  },,
 );

=head3 QtreeStopMonitoring

EQTREEMONITOROFFFAIL 

Returns a L<MyElements::QtreeStopMonitoringResult|MyElements::QtreeStopMonitoringResult> object.

 $response = $interface->QtreeStopMonitoring( {
    QtreeNameOrId => $some_value, # atomic
  },,
 );

=head3 RbacAccessCheck

EINVALIDINPUTERROR 

Returns a L<MyElements::RbacAccessCheckResult|MyElements::RbacAccessCheckResult> object.

 $response = $interface->RbacAccessCheck( {
    AdminNameOrId =>  $some_value, # string
    Operation =>  $some_value, # string
    Resource =>  { # MyTypes::WrapperOfResourceIdentifier
      ResourceIdentifier =>  { # MyTypes::ResourceIdentifier
        Aggregate =>  { # MyTypes::WrapperOfAggregateResource
          AggregateResource =>  { # MyTypes::AggregateResource
            AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
              AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                AggregateId =>  $some_value, # unsignedInt
                AggregateName =>  $some_value, # string
              },
            },
            FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
              FilerResource =>  { # MyTypes::FilerResource
                FilerId =>  $some_value, # unsignedInt
                FilerName =>  $some_value, # string
              },
            },
          },
        },
        Dataset =>  { # MyTypes::WrapperOfDatasetResource
          DatasetResource =>  { # MyTypes::DatasetResource
            DatasetId =>  $some_value, # unsignedInt
            DatasetName =>  $some_value, # string
          },
        },
        Filer =>  { # MyTypes::WrapperOfFilerResource
          FilerResource =>  { # MyTypes::FilerResource
            FilerId =>  $some_value, # unsignedInt
            FilerName =>  $some_value, # string
          },
        },
        Group =>  { # MyTypes::WrapperOfGroupResource
          GroupResource =>  { # MyTypes::GroupResource
            GroupId =>  $some_value, # unsignedInt
            GroupName =>  $some_value, # string
          },
        },
        Host =>  { # MyTypes::WrapperOfHostResource
          HostResource =>  { # MyTypes::HostResource
            HostId =>  $some_value, # unsignedInt
            HostName =>  $some_value, # string
          },
        },
        Lun =>  { # MyTypes::WrapperOfLunResource
          LunResource =>  { # MyTypes::LunResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            LunIdentifierNameOrId =>  { # MyTypes::WrapperOfLunNameOrId
              LunNameOrId =>  { # MyTypes::LunNameOrId
                LunId =>  $some_value, # unsignedInt
                LunName =>  $some_value, # string
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        Policy =>  { # MyTypes::WrapperOfPolicyResource
          PolicyResource =>  { # MyTypes::PolicyResource
            PolicyId => $some_value, # ObjId
            PolicyName => $some_value, # ObjName
          },
        },
        Qtree =>  { # MyTypes::WrapperOfQtreeResource
          QtreeResource =>  { # MyTypes::QtreeResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            QtreeIdentifierNameOrId =>  { # MyTypes::WrapperOfQtreeNameOrId
              QtreeNameOrId =>  { # MyTypes::QtreeNameOrId
                QtreeId => $some_value, # ObjId
                QtreeName => $some_value, # ObjName
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        RbacRole =>  { # MyTypes::WrapperOfRbacRoleResource
          RbacRoleResource =>  { # MyTypes::RbacRoleResource
            RbacRoleId =>  $some_value, # unsignedInt
            RbacRoleName =>  $some_value, # string
          },
        },
        ResourceId =>  $some_value, # unsignedInt
        ResourcePool =>  { # MyTypes::WrapperOfResourcePoolResource
          ResourcePoolResource =>  { # MyTypes::ResourcePoolResource
            ResourcePoolId =>  $some_value, # unsignedInt
            ResourcePoolName =>  $some_value, # string
          },
        },
        StorageService =>  { # MyTypes::WrapperOfStorageServiceResource
          StorageServiceResource =>  { # MyTypes::StorageServiceResource
            StorageServiceId => $some_value, # ObjId
            StorageServiceName => $some_value, # ObjName
          },
        },
        Vfiler =>  { # MyTypes::WrapperOfVfilerResource
          VfilerResource =>  { # MyTypes::VfilerResource
            VfilerId =>  $some_value, # unsignedInt
            VfilerNameOrUuid =>  $some_value, # string
          },
        },
        VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateResource
          VfilerTemplateResource =>  { # MyTypes::VfilerTemplateResource
            VfilerTemplateId => $some_value, # ObjId
            VfilerTemplateName => $some_value, # ObjName
          },
        },
        Volume =>  { # MyTypes::WrapperOfVolumeResource
          VolumeResource =>  { # MyTypes::VolumeResource
            AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
              AggregateResource =>  { # MyTypes::AggregateResource
                AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                  AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                    AggregateId =>  $some_value, # unsignedInt
                    AggregateName =>  $some_value, # string
                  },
                },
                FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                  FilerResource =>  { # MyTypes::FilerResource
                    FilerId =>  $some_value, # unsignedInt
                    FilerName =>  $some_value, # string
                  },
                },
              },
            },
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
              VfilerResource =>  { # MyTypes::VfilerResource
                VfilerId =>  $some_value, # unsignedInt
                VfilerNameOrUuid =>  $some_value, # string
              },
            },
            VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
              VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                VolumeId =>  $some_value, # unsignedInt
                VolumeName =>  $some_value, # string
              },
            },
          },
        },
      },
    },
  },,
 );

=head3 RbacAdminListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::RbacAdminListInfoIterEndResult|MyElements::RbacAdminListInfoIterEndResult> object.

 $response = $interface->RbacAdminListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 RbacAdminListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::RbacAdminListInfoIterNextResult|MyElements::RbacAdminListInfoIterNextResult> object.

 $response = $interface->RbacAdminListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 RbacAdminListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::RbacAdminListInfoIterStartResult|MyElements::RbacAdminListInfoIterStartResult> object.

 $response = $interface->RbacAdminListInfoIterStart( {
    AdminNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacAdminRoleAdd

EROLEASSIGNED 

Returns a L<MyElements::RbacAdminRoleAddResult|MyElements::RbacAdminRoleAddResult> object.

 $response = $interface->RbacAdminRoleAdd( {
    AdminNameOrId =>  $some_value, # string
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacAdminRoleInfoList

ENOTASSIGNEDROLE 

Returns a L<MyElements::RbacAdminRoleInfoListResult|MyElements::RbacAdminRoleInfoListResult> object.

 $response = $interface->RbacAdminRoleInfoList( {
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacAdminRoleRemove

ENOTFOUNDUSER 

Returns a L<MyElements::RbacAdminRoleRemoveResult|MyElements::RbacAdminRoleRemoveResult> object.

 $response = $interface->RbacAdminRoleRemove( {
    AdminNameOrId =>  $some_value, # string
    DeleteAll =>  $some_value, # boolean
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacOperationAdd

EINVALIDSHORTDESC 

Returns a L<MyElements::RbacOperationAddResult|MyElements::RbacOperationAddResult> object.

 $response = $interface->RbacOperationAdd( {
    Operation =>  { # MyTypes::WrapperOfRbacOperation
      RbacOperation =>  { # MyTypes::RbacOperation
        OperationName =>  $some_value, # string
        OperationNameDetails =>  { # MyTypes::WrapperOfRbacOperationNameDetails
          RbacOperationNameDetails =>  { # MyTypes::RbacOperationNameDetails
            OperationDescription =>  $some_value, # string
            OperationSynopsis =>  $some_value, # string
            ResourceType =>  $some_value, # string
          },
        },
      },
    },
  },,
 );

=head3 RbacOperationDelete

EOPERATIONISPERMANENT 

Returns a L<MyElements::RbacOperationDeleteResult|MyElements::RbacOperationDeleteResult> object.

 $response = $interface->RbacOperationDelete( {
    Operation =>  $some_value, # string
  },,
 );

=head3 RbacOperationInfoList

ENOTFOUNDOPERATION 

Returns a L<MyElements::RbacOperationInfoListResult|MyElements::RbacOperationInfoListResult> object.

 $response = $interface->RbacOperationInfoList( {
    Operation =>  $some_value, # string
  },,
 );

=head3 RbacRoleAdd

ENOTFOUNDROLE 

Returns a L<MyElements::RbacRoleAddResult|MyElements::RbacRoleAddResult> object.

 $response = $interface->RbacRoleAdd( {
    Description =>  $some_value, # string
    OwnerNameOrId =>  $some_value, # string
    RoleName =>  $some_value, # string
  },,
 );

=head3 RbacRoleAdminInfoList

ENOTFOUNDUSER 

Returns a L<MyElements::RbacRoleAdminInfoListResult|MyElements::RbacRoleAdminInfoListResult> object.

 $response = $interface->RbacRoleAdminInfoList( {
    AdminNameOrId =>  $some_value, # string
    FollowRoleInheritance =>  $some_value, # boolean
  },,
 );

=head3 RbacRoleCapabilityAdd

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleCapabilityAddResult|MyElements::RbacRoleCapabilityAddResult> object.

 $response = $interface->RbacRoleCapabilityAdd( {
    Operation =>  $some_value, # string
    Resource =>  { # MyTypes::WrapperOfResourceIdentifier
      ResourceIdentifier =>  { # MyTypes::ResourceIdentifier
        Aggregate =>  { # MyTypes::WrapperOfAggregateResource
          AggregateResource =>  { # MyTypes::AggregateResource
            AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
              AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                AggregateId =>  $some_value, # unsignedInt
                AggregateName =>  $some_value, # string
              },
            },
            FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
              FilerResource =>  { # MyTypes::FilerResource
                FilerId =>  $some_value, # unsignedInt
                FilerName =>  $some_value, # string
              },
            },
          },
        },
        Dataset =>  { # MyTypes::WrapperOfDatasetResource
          DatasetResource =>  { # MyTypes::DatasetResource
            DatasetId =>  $some_value, # unsignedInt
            DatasetName =>  $some_value, # string
          },
        },
        Filer =>  { # MyTypes::WrapperOfFilerResource
          FilerResource =>  { # MyTypes::FilerResource
            FilerId =>  $some_value, # unsignedInt
            FilerName =>  $some_value, # string
          },
        },
        Group =>  { # MyTypes::WrapperOfGroupResource
          GroupResource =>  { # MyTypes::GroupResource
            GroupId =>  $some_value, # unsignedInt
            GroupName =>  $some_value, # string
          },
        },
        Host =>  { # MyTypes::WrapperOfHostResource
          HostResource =>  { # MyTypes::HostResource
            HostId =>  $some_value, # unsignedInt
            HostName =>  $some_value, # string
          },
        },
        Lun =>  { # MyTypes::WrapperOfLunResource
          LunResource =>  { # MyTypes::LunResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            LunIdentifierNameOrId =>  { # MyTypes::WrapperOfLunNameOrId
              LunNameOrId =>  { # MyTypes::LunNameOrId
                LunId =>  $some_value, # unsignedInt
                LunName =>  $some_value, # string
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        Policy =>  { # MyTypes::WrapperOfPolicyResource
          PolicyResource =>  { # MyTypes::PolicyResource
            PolicyId => $some_value, # ObjId
            PolicyName => $some_value, # ObjName
          },
        },
        Qtree =>  { # MyTypes::WrapperOfQtreeResource
          QtreeResource =>  { # MyTypes::QtreeResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            QtreeIdentifierNameOrId =>  { # MyTypes::WrapperOfQtreeNameOrId
              QtreeNameOrId =>  { # MyTypes::QtreeNameOrId
                QtreeId => $some_value, # ObjId
                QtreeName => $some_value, # ObjName
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        RbacRole =>  { # MyTypes::WrapperOfRbacRoleResource
          RbacRoleResource =>  { # MyTypes::RbacRoleResource
            RbacRoleId =>  $some_value, # unsignedInt
            RbacRoleName =>  $some_value, # string
          },
        },
        ResourceId =>  $some_value, # unsignedInt
        ResourcePool =>  { # MyTypes::WrapperOfResourcePoolResource
          ResourcePoolResource =>  { # MyTypes::ResourcePoolResource
            ResourcePoolId =>  $some_value, # unsignedInt
            ResourcePoolName =>  $some_value, # string
          },
        },
        StorageService =>  { # MyTypes::WrapperOfStorageServiceResource
          StorageServiceResource =>  { # MyTypes::StorageServiceResource
            StorageServiceId => $some_value, # ObjId
            StorageServiceName => $some_value, # ObjName
          },
        },
        Vfiler =>  { # MyTypes::WrapperOfVfilerResource
          VfilerResource =>  { # MyTypes::VfilerResource
            VfilerId =>  $some_value, # unsignedInt
            VfilerNameOrUuid =>  $some_value, # string
          },
        },
        VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateResource
          VfilerTemplateResource =>  { # MyTypes::VfilerTemplateResource
            VfilerTemplateId => $some_value, # ObjId
            VfilerTemplateName => $some_value, # ObjName
          },
        },
        Volume =>  { # MyTypes::WrapperOfVolumeResource
          VolumeResource =>  { # MyTypes::VolumeResource
            AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
              AggregateResource =>  { # MyTypes::AggregateResource
                AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                  AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                    AggregateId =>  $some_value, # unsignedInt
                    AggregateName =>  $some_value, # string
                  },
                },
                FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                  FilerResource =>  { # MyTypes::FilerResource
                    FilerId =>  $some_value, # unsignedInt
                    FilerName =>  $some_value, # string
                  },
                },
              },
            },
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
              VfilerResource =>  { # MyTypes::VfilerResource
                VfilerId =>  $some_value, # unsignedInt
                VfilerNameOrUuid =>  $some_value, # string
              },
            },
            VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
              VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                VolumeId =>  $some_value, # unsignedInt
                VolumeName =>  $some_value, # string
              },
            },
          },
        },
      },
    },
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleCapabilityRemove

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleCapabilityRemoveResult|MyElements::RbacRoleCapabilityRemoveResult> object.

 $response = $interface->RbacRoleCapabilityRemove( {
    DeleteAll =>  $some_value, # boolean
    Operation =>  $some_value, # string
    Resource =>  { # MyTypes::WrapperOfResourceIdentifier
      ResourceIdentifier =>  { # MyTypes::ResourceIdentifier
        Aggregate =>  { # MyTypes::WrapperOfAggregateResource
          AggregateResource =>  { # MyTypes::AggregateResource
            AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
              AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                AggregateId =>  $some_value, # unsignedInt
                AggregateName =>  $some_value, # string
              },
            },
            FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
              FilerResource =>  { # MyTypes::FilerResource
                FilerId =>  $some_value, # unsignedInt
                FilerName =>  $some_value, # string
              },
            },
          },
        },
        Dataset =>  { # MyTypes::WrapperOfDatasetResource
          DatasetResource =>  { # MyTypes::DatasetResource
            DatasetId =>  $some_value, # unsignedInt
            DatasetName =>  $some_value, # string
          },
        },
        Filer =>  { # MyTypes::WrapperOfFilerResource
          FilerResource =>  { # MyTypes::FilerResource
            FilerId =>  $some_value, # unsignedInt
            FilerName =>  $some_value, # string
          },
        },
        Group =>  { # MyTypes::WrapperOfGroupResource
          GroupResource =>  { # MyTypes::GroupResource
            GroupId =>  $some_value, # unsignedInt
            GroupName =>  $some_value, # string
          },
        },
        Host =>  { # MyTypes::WrapperOfHostResource
          HostResource =>  { # MyTypes::HostResource
            HostId =>  $some_value, # unsignedInt
            HostName =>  $some_value, # string
          },
        },
        Lun =>  { # MyTypes::WrapperOfLunResource
          LunResource =>  { # MyTypes::LunResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            LunIdentifierNameOrId =>  { # MyTypes::WrapperOfLunNameOrId
              LunNameOrId =>  { # MyTypes::LunNameOrId
                LunId =>  $some_value, # unsignedInt
                LunName =>  $some_value, # string
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        Policy =>  { # MyTypes::WrapperOfPolicyResource
          PolicyResource =>  { # MyTypes::PolicyResource
            PolicyId => $some_value, # ObjId
            PolicyName => $some_value, # ObjName
          },
        },
        Qtree =>  { # MyTypes::WrapperOfQtreeResource
          QtreeResource =>  { # MyTypes::QtreeResource
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            QtreeIdentifierNameOrId =>  { # MyTypes::WrapperOfQtreeNameOrId
              QtreeNameOrId =>  { # MyTypes::QtreeNameOrId
                QtreeId => $some_value, # ObjId
                QtreeName => $some_value, # ObjName
              },
            },
            VolumeIdentifier =>  { # MyTypes::WrapperOfVolumeResource
              VolumeResource =>  { # MyTypes::VolumeResource
                AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
                  AggregateResource =>  { # MyTypes::AggregateResource
                    AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                      AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                        AggregateId =>  $some_value, # unsignedInt
                        AggregateName =>  $some_value, # string
                      },
                    },
                    FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                      FilerResource =>  { # MyTypes::FilerResource
                        FilerId =>  $some_value, # unsignedInt
                        FilerName =>  $some_value, # string
                      },
                    },
                  },
                },
                HostIdentifier =>  { # MyTypes::WrapperOfHostResource
                  HostResource =>  { # MyTypes::HostResource
                    HostId =>  $some_value, # unsignedInt
                    HostName =>  $some_value, # string
                  },
                },
                VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
                  VfilerResource =>  { # MyTypes::VfilerResource
                    VfilerId =>  $some_value, # unsignedInt
                    VfilerNameOrUuid =>  $some_value, # string
                  },
                },
                VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
                  VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                    VolumeId =>  $some_value, # unsignedInt
                    VolumeName =>  $some_value, # string
                  },
                },
              },
            },
          },
        },
        RbacRole =>  { # MyTypes::WrapperOfRbacRoleResource
          RbacRoleResource =>  { # MyTypes::RbacRoleResource
            RbacRoleId =>  $some_value, # unsignedInt
            RbacRoleName =>  $some_value, # string
          },
        },
        ResourceId =>  $some_value, # unsignedInt
        ResourcePool =>  { # MyTypes::WrapperOfResourcePoolResource
          ResourcePoolResource =>  { # MyTypes::ResourcePoolResource
            ResourcePoolId =>  $some_value, # unsignedInt
            ResourcePoolName =>  $some_value, # string
          },
        },
        StorageService =>  { # MyTypes::WrapperOfStorageServiceResource
          StorageServiceResource =>  { # MyTypes::StorageServiceResource
            StorageServiceId => $some_value, # ObjId
            StorageServiceName => $some_value, # ObjName
          },
        },
        Vfiler =>  { # MyTypes::WrapperOfVfilerResource
          VfilerResource =>  { # MyTypes::VfilerResource
            VfilerId =>  $some_value, # unsignedInt
            VfilerNameOrUuid =>  $some_value, # string
          },
        },
        VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateResource
          VfilerTemplateResource =>  { # MyTypes::VfilerTemplateResource
            VfilerTemplateId => $some_value, # ObjId
            VfilerTemplateName => $some_value, # ObjName
          },
        },
        Volume =>  { # MyTypes::WrapperOfVolumeResource
          VolumeResource =>  { # MyTypes::VolumeResource
            AggregateIdentifier =>  { # MyTypes::WrapperOfAggregateResource
              AggregateResource =>  { # MyTypes::AggregateResource
                AggregateResourceNameOrId =>  { # MyTypes::WrapperOfAggregateNameOrId
                  AggregateNameOrId =>  { # MyTypes::AggregateNameOrId
                    AggregateId =>  $some_value, # unsignedInt
                    AggregateName =>  $some_value, # string
                  },
                },
                FilerIdentifier =>  { # MyTypes::WrapperOfFilerResource
                  FilerResource =>  { # MyTypes::FilerResource
                    FilerId =>  $some_value, # unsignedInt
                    FilerName =>  $some_value, # string
                  },
                },
              },
            },
            HostIdentifier =>  { # MyTypes::WrapperOfHostResource
              HostResource =>  { # MyTypes::HostResource
                HostId =>  $some_value, # unsignedInt
                HostName =>  $some_value, # string
              },
            },
            VfilerIdentifier =>  { # MyTypes::WrapperOfVfilerResource
              VfilerResource =>  { # MyTypes::VfilerResource
                VfilerId =>  $some_value, # unsignedInt
                VfilerNameOrUuid =>  $some_value, # string
              },
            },
            VolumeIdentifierNameOrId =>  { # MyTypes::WrapperOfVolumeNameOrId
              VolumeNameOrId =>  { # MyTypes::VolumeNameOrId
                VolumeId =>  $some_value, # unsignedInt
                VolumeName =>  $some_value, # string
              },
            },
          },
        },
      },
    },
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleDelete

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleDeleteResult|MyElements::RbacRoleDeleteResult> object.

 $response = $interface->RbacRoleDelete( {
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleDisinherit

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleDisinheritResult|MyElements::RbacRoleDisinheritResult> object.

 $response = $interface->RbacRoleDisinherit( {
    DisinheritAll =>  $some_value, # boolean
    DisinheritedRoleNameOrId =>  $some_value, # string
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleInfoList

ENOTFOUNDROLE 

Returns a L<MyElements::RbacRoleInfoListResult|MyElements::RbacRoleInfoListResult> object.

 $response = $interface->RbacRoleInfoList( {
    FollowRoleInheritance =>  $some_value, # boolean
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleInherit

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleInheritResult|MyElements::RbacRoleInheritResult> object.

 $response = $interface->RbacRoleInherit( {
    InheritedRoleNameOrId =>  $some_value, # string
    RoleNameOrId =>  $some_value, # string
  },,
 );

=head3 RbacRoleModify

EROLEISPERMANENT 

Returns a L<MyElements::RbacRoleModifyResult|MyElements::RbacRoleModifyResult> object.

 $response = $interface->RbacRoleModify( {
    RoleDescriptionNew =>  $some_value, # string
    RoleNameNew =>  $some_value, # string
    RoleNameOrIdOld =>  $some_value, # string
  },,
 );

=head3 ReportCategoryList

EREPORTCATEGORYNOTFOUND 

Returns a L<MyElements::ReportCategoryListResult|MyElements::ReportCategoryListResult> object.

 $response = $interface->ReportCategoryList( {
    CategoryNameOrId =>  $some_value, # string
    CategoryProvenance =>  $some_value, # string
  },,
 );

=head3 ReportDesignerList

EREPORTCATEGORYNOTFOUND 

Returns a L<MyElements::ReportDesignerListResult|MyElements::ReportDesignerListResult> object.

 $response = $interface->ReportDesignerList( {
    CategoryNameOrId =>  $some_value, # string
    ReportProvenance => $some_value, # ReportProvenance
  },,
 );

=head3 ReportDesignerScheduleAdd

EREPORTNOTFOUND 

Returns a L<MyElements::ReportDesignerScheduleAddResult|MyElements::ReportDesignerScheduleAddResult> object.

 $response = $interface->ReportDesignerScheduleAdd( {
    ReportScheduleInfo =>  { # MyTypes::ReportScheduleInfo
      ArchivalFormat => $some_value, # ReportOutputFormat
      EmailAddressList => $some_value, # EmailAddressList
      GraphName =>  $some_value, # string
      IncludeDeletedObjects =>  $some_value, # boolean
      ReportApplication => $some_value, # ReportApplication
      ReportNameOrId =>  $some_value, # string
      ReportScheduleName => $some_value, # ObjName
      SaveAllFields =>  $some_value, # boolean
      ScheduleNameOrId => $some_value, # ObjNameOrId
      TargetObjectNameOrId => $some_value, # ObjNameOrId
    },
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 ReportDesignerScheduleDelete

EOBJECTNOTFOUND 

Returns a L<MyElements::ReportDesignerScheduleDeleteResult|MyElements::ReportDesignerScheduleDeleteResult> object.

 $response = $interface->ReportDesignerScheduleDelete( {
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportDesignerScheduleModify

EREPORTNOTFOUND 

Returns a L<MyElements::ReportDesignerScheduleModifyResult|MyElements::ReportDesignerScheduleModifyResult> object.

 $response = $interface->ReportDesignerScheduleModify( {
    ReportScheduleInfo =>  { # MyTypes::ReportScheduleInfo
      ArchivalFormat => $some_value, # ReportOutputFormat
      EmailAddressList => $some_value, # EmailAddressList
      GraphName =>  $some_value, # string
      IncludeDeletedObjects =>  $some_value, # boolean
      ReportApplication => $some_value, # ReportApplication
      ReportNameOrId =>  $some_value, # string
      ReportScheduleName => $some_value, # ObjName
      SaveAllFields =>  $some_value, # boolean
      ScheduleNameOrId => $some_value, # ObjNameOrId
      TargetObjectNameOrId => $some_value, # ObjNameOrId
    },
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
    ScheduleContentInfo =>  { # MyTypes::ScheduleContentInfo
      DailyList =>  { # MyTypes::ArrayOfDailyInfo
        DailyInfo =>  { # MyTypes::DailyInfo
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      HourlyList =>  { # MyTypes::ArrayOfHourlyInfo
        HourlyInfo =>  { # MyTypes::HourlyInfo
          EndHour => $some_value, # atomic
          EndMinute => $some_value, # atomic
          Frequency => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      IsModifiable =>  $some_value, # boolean
      MonthlyList =>  { # MyTypes::ArrayOfMonthlyInfo
        MonthlyInfo =>  { # MyTypes::MonthlyInfo
          DayOfMonth => $some_value, # atomic
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
          WeekOfMonth => $some_value, # atomic
        },
      },
      MonthlySubscheduleList =>  { # MyTypes::ArrayOfMonthlySubscheduleInfo
        MonthlySubscheduleInfo =>  { # MyTypes::MonthlySubscheduleInfo
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
      ScheduleCategory =>  $some_value, # string
      ScheduleDescription =>  $some_value, # string
      ScheduleId => $some_value, # ObjId
      ScheduleName => $some_value, # ObjName
      ScheduleType =>  $some_value, # string
      WeeklyList =>  { # MyTypes::ArrayOfWeeklyInfo
        WeeklyInfo =>  { # MyTypes::WeeklyInfo
          DayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartHour => $some_value, # atomic
          StartMinute => $some_value, # atomic
        },
      },
      WeeklySubscheduleList =>  { # MyTypes::ArrayOfWeeklySubscheduleInfo
        WeeklySubscheduleInfo =>  { # MyTypes::WeeklySubscheduleInfo
          EndDayOfWeek => $some_value, # atomic
          ItemId => $some_value, # atomic
          StartDayOfWeek => $some_value, # atomic
          SubscheduleId => $some_value, # ObjId
          SubscheduleName => $some_value, # ObjName
        },
      },
    },
  },,
 );

=head3 ReportDesignerShare

EREPORTNOTFOUND 

Returns a L<MyElements::ReportDesignerShareResult|MyElements::ReportDesignerShareResult> object.

 $response = $interface->ReportDesignerShare( {
    EmailAddressList => $some_value, # EmailAddressList
    OutputFormat => $some_value, # ReportOutputFormat
    ReportNameOrId =>  $some_value, # string
    SubjectField =>  $some_value, # string
    TargetObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportGraphListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ReportGraphListInfoIterEndResult|MyElements::ReportGraphListInfoIterEndResult> object.

 $response = $interface->ReportGraphListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportGraphListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ReportGraphListInfoIterNextResult|MyElements::ReportGraphListInfoIterNextResult> object.

 $response = $interface->ReportGraphListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportGraphListInfoIterStart

EREPORTNOTFOUND 

Returns a L<MyElements::ReportGraphListInfoIterStartResult|MyElements::ReportGraphListInfoIterStartResult> object.

 $response = $interface->ReportGraphListInfoIterStart( {
    ReportApplication => $some_value, # ReportApplication
    ReportNameOrId =>  $some_value, # string
    TargetObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ReportListInfoIterEndResult|MyElements::ReportListInfoIterEndResult> object.

 $response = $interface->ReportListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ReportListInfoIterNextResult|MyElements::ReportListInfoIterNextResult> object.

 $response = $interface->ReportListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportListInfoIterStart

EREPORTNOTFOUND 

Returns a L<MyElements::ReportListInfoIterStartResult|MyElements::ReportListInfoIterStartResult> object.

 $response = $interface->ReportListInfoIterStart( {
    ReportApplication => $some_value, # ReportApplication
    ReportNameOrId =>  $some_value, # string
    ReportType =>  $some_value, # string
  },,
 );

=head3 ReportOutputDelete

EREPORTOUTPUTNOTFOUND 

Returns a L<MyElements::ReportOutputDeleteResult|MyElements::ReportOutputDeleteResult> object.

 $response = $interface->ReportOutputDelete( {
    ReportOutputId => $some_value, # atomic
  },,
 );

=head3 ReportOutputListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ReportOutputListInfoIterEndResult|MyElements::ReportOutputListInfoIterEndResult> object.

 $response = $interface->ReportOutputListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportOutputListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ReportOutputListInfoIterNextResult|MyElements::ReportOutputListInfoIterNextResult> object.

 $response = $interface->ReportOutputListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportOutputListInfoIterStart

EREPORTOUTPUTNOTFOUND 

Returns a L<MyElements::ReportOutputListInfoIterStartResult|MyElements::ReportOutputListInfoIterStartResult> object.

 $response = $interface->ReportOutputListInfoIterStart( {
    IsSuccessful =>  $some_value, # boolean
    ReportApplication => $some_value, # ReportApplication
    ReportNameOrId =>  $some_value, # string
    ReportOutputId => $some_value, # atomic
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
    TargetObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportOutputRead

EREPORTOUTPUTNOTFOUND 

Returns a L<MyElements::ReportOutputReadResult|MyElements::ReportOutputReadResult> object.

 $response = $interface->ReportOutputRead( {
    Length => $some_value, # atomic
    Offset => $some_value, # atomic
    ReportOutputId => $some_value, # atomic
  },,
 );

=head3 ReportScheduleAdd

EREPORTSCHEDULEDUPLICATE 

Returns a L<MyElements::ReportScheduleAddResult|MyElements::ReportScheduleAddResult> object.

 $response = $interface->ReportScheduleAdd( {
    ReportScheduleInfo =>  { # MyTypes::ReportScheduleInfo
      ArchivalFormat => $some_value, # ReportOutputFormat
      EmailAddressList => $some_value, # EmailAddressList
      GraphName =>  $some_value, # string
      IncludeDeletedObjects =>  $some_value, # boolean
      ReportApplication => $some_value, # ReportApplication
      ReportNameOrId =>  $some_value, # string
      ReportScheduleName => $some_value, # ObjName
      SaveAllFields =>  $some_value, # boolean
      ScheduleNameOrId => $some_value, # ObjNameOrId
      TargetObjectNameOrId => $some_value, # ObjNameOrId
    },
  },,
 );

=head3 ReportScheduleDelete

EREPORTSCHEDULEDELETEERROR 

Returns a L<MyElements::ReportScheduleDeleteResult|MyElements::ReportScheduleDeleteResult> object.

 $response = $interface->ReportScheduleDelete( {
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportScheduleDisable

EREPORTNOTSCHEDULABLE 

Returns a L<MyElements::ReportScheduleDisableResult|MyElements::ReportScheduleDisableResult> object.

 $response = $interface->ReportScheduleDisable( {
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportScheduleEnable

EREPORTNOTSCHEDULABLE 

Returns a L<MyElements::ReportScheduleEnableResult|MyElements::ReportScheduleEnableResult> object.

 $response = $interface->ReportScheduleEnable( {
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportScheduleListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ReportScheduleListInfoIterEndResult|MyElements::ReportScheduleListInfoIterEndResult> object.

 $response = $interface->ReportScheduleListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportScheduleListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ReportScheduleListInfoIterNextResult|MyElements::ReportScheduleListInfoIterNextResult> object.

 $response = $interface->ReportScheduleListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ReportScheduleListInfoIterStart

EREPORTNOTSCHEDULABLE 

Returns a L<MyElements::ReportScheduleListInfoIterStartResult|MyElements::ReportScheduleListInfoIterStartResult> object.

 $response = $interface->ReportScheduleListInfoIterStart( {
    IsEnabled =>  $some_value, # boolean
    ReportApplication => $some_value, # ReportApplication
    ReportNameOrId =>  $some_value, # string
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
    TargetObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportScheduleModify

EREPORTSCHEDULEDUPLICATE 

Returns a L<MyElements::ReportScheduleModifyResult|MyElements::ReportScheduleModifyResult> object.

 $response = $interface->ReportScheduleModify( {
    ReportScheduleInfo =>  { # MyTypes::ReportScheduleInfo
      ArchivalFormat => $some_value, # ReportOutputFormat
      EmailAddressList => $some_value, # EmailAddressList
      GraphName =>  $some_value, # string
      IncludeDeletedObjects =>  $some_value, # boolean
      ReportApplication => $some_value, # ReportApplication
      ReportNameOrId =>  $some_value, # string
      ReportScheduleName => $some_value, # ObjName
      SaveAllFields =>  $some_value, # boolean
      ScheduleNameOrId => $some_value, # ObjNameOrId
      TargetObjectNameOrId => $some_value, # ObjNameOrId
    },
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ReportScheduleRun

EREPORTNOTSCHEDULABLE 

Returns a L<MyElements::ReportScheduleRunResult|MyElements::ReportScheduleRunResult> object.

 $response = $interface->ReportScheduleRun( {
    ReportScheduleNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ResourcepoolAddMember

ERESOURCEPOOLDOESNOTEXIST 

Returns a L<MyElements::ResourcepoolAddMemberResult|MyElements::ResourcepoolAddMemberResult> object.

 $response = $interface->ResourcepoolAddMember( {
    MemberNameOrId =>  $some_value, # string
    MoveIfExists =>  $some_value, # boolean
    ResourceTag => $some_value, # ResourceTag
    ResourcepoolNameOrId =>  $some_value, # string
  },,
 );

=head3 ResourcepoolCreate

ERESOURCEPOOLEXISTS 

Returns a L<MyElements::ResourcepoolCreateResult|MyElements::ResourcepoolCreateResult> object.

 $response = $interface->ResourcepoolCreate( {
    Resourcepool =>  { # MyTypes::WrapperOfResourcepoolInfo
      ResourcepoolInfo =>  { # MyTypes::ResourcepoolInfo
        AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
        AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
        ResourceTag => $some_value, # ResourceTag
        ResourcepoolContact => $some_value, # EmailAddressList
        ResourcepoolDescription =>  $some_value, # string
        ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
        ResourcepoolFullThreshold => $some_value, # atomic
        ResourcepoolId =>  $some_value, # integer
        ResourcepoolIsProvisionable =>  $some_value, # boolean
        ResourcepoolKbytesAvailable => $some_value, # atomic
        ResourcepoolKbytesTotal => $some_value, # atomic
        ResourcepoolKbytesUsed => $some_value, # atomic
        ResourcepoolMemberCount => $some_value, # atomic
        ResourcepoolName =>  $some_value, # string
        ResourcepoolNearlyFullThreshold => $some_value, # atomic
        ResourcepoolOwner =>  $some_value, # string
        ResourcepoolPerfStatus => $some_value, # ObjStatus
        ResourcepoolSpaceStatus =>  $some_value, # string
        ResourcepoolStatus => $some_value, # ObjStatus
        ResourcepoolTimezone =>  $some_value, # string
      },
    },
  },,
 );

=head3 ResourcepoolDestroy

ERESOURCEPOOLNOTEMPTY 

Returns a L<MyElements::ResourcepoolDestroyResult|MyElements::ResourcepoolDestroyResult> object.

 $response = $interface->ResourcepoolDestroy( {
    Force =>  $some_value, # boolean
    ResourcepoolNameOrId =>  $some_value, # string
  },,
 );

=head3 ResourcepoolGetDefaults

supported 

Returns a L<MyElements::ResourcepoolGetDefaultsResult|MyElements::ResourcepoolGetDefaultsResult> object.

 $response = $interface->ResourcepoolGetDefaults(,,
 );

=head3 ResourcepoolListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ResourcepoolListInfoIterEndResult|MyElements::ResourcepoolListInfoIterEndResult> object.

 $response = $interface->ResourcepoolListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ResourcepoolListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ResourcepoolListInfoIterNextResult|MyElements::ResourcepoolListInfoIterNextResult> object.

 $response = $interface->ResourcepoolListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ResourcepoolListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ResourcepoolListInfoIterStartResult|MyElements::ResourcepoolListInfoIterStartResult> object.

 $response = $interface->ResourcepoolListInfoIterStart( {
    CheckLicenses =>  { # MyTypes::ArrayOfLicense
      License => $some_value, # License
    },
    DpNodeName =>  $some_value, # string
    IncludeFreeSpace =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
    ResourceTag => $some_value, # ResourceTag
    StorageReliability =>  { # MyTypes::StorageReliability
      ControllerFailure =>  $some_value, # boolean
      DiskFailure =>  $some_value, # string
      SubSystemFailure =>  $some_value, # boolean
    },
  },,
 );

=head3 ResourcepoolMemberListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ResourcepoolMemberListInfoIterEndResult|MyElements::ResourcepoolMemberListInfoIterEndResult> object.

 $response = $interface->ResourcepoolMemberListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ResourcepoolMemberListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ResourcepoolMemberListInfoIterNextResult|MyElements::ResourcepoolMemberListInfoIterNextResult> object.

 $response = $interface->ResourcepoolMemberListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ResourcepoolMemberListInfoIterStart

ERESOURCEPOOLDOESNOTEXIST 

Returns a L<MyElements::ResourcepoolMemberListInfoIterStartResult|MyElements::ResourcepoolMemberListInfoIterStartResult> object.

 $response = $interface->ResourcepoolMemberListInfoIterStart( {
    IncludeDatasetSpaceInfo =>  $some_value, # boolean
    IncludeIndirect =>  $some_value, # boolean
    MemberType =>  $some_value, # string
    ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
      Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
        ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
          CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
          CommentValue => $some_value, # CommentValue
        },
      },
      CreateNewVfiler =>  $some_value, # boolean
      DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
        DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
          CifsDomain =>  $some_value, # string
          DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
            DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
              CifsUsername =>  $some_value, # string
              Permission => $some_value, # CifsPermission
            },
          },
        },
        DatasetExportProtocol => $some_value, # DatasetExportProtocol
        DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
          IgroupOsType =>  $some_value, # string
          LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
            LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
              Hostname =>  $some_value, # string
              InitiatorId => $some_value, # InitiatorId
            },
          },
        },
        DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
          AnonymousAccessUser => $some_value, # atomic
          DisableSetuid =>  $some_value, # boolean
          IsReadonlyForAllHosts =>  $some_value, # boolean
          IsReadwriteForAllHosts =>  $some_value, # boolean
          NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
            NfsExportHost =>  { # MyTypes::NfsExportHost
              Hostname =>  $some_value, # string
              IsAnException =>  $some_value, # boolean
            },
          },
          NfsProtocolVersion =>  $some_value, # string
          NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
            NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
          },
        },
      },
      Description =>  $some_value, # string
      InitialSnapshotSpace => $some_value, # atomic
      MaximumDataSize => $some_value, # atomic
      MaximumSnapshotSpace => $some_value, # atomic
      Name =>  $some_value, # string
      OnlineMigration =>  $some_value, # boolean
      ProvisioningPolicyId => $some_value, # ObjId
      ProvisioningPolicyName => $some_value, # ObjFullName
      ResourceNameOrId => $some_value, # ObjNameOrId
      Size => $some_value, # atomic
      VfilerNameOrId => $some_value, # ObjNameOrId
    },
    ProvisioningPolicyNameOrId =>  $some_value, # string
    ResourcepoolMemberNameOrId =>  $some_value, # string
    ResourcepoolNameOrId =>  $some_value, # string
    RunProvisioningChecks =>  $some_value, # boolean
  },,
 );

=head3 ResourcepoolModify

ERESOURCEPOOLEXISTS 

Returns a L<MyElements::ResourcepoolModifyResult|MyElements::ResourcepoolModifyResult> object.

 $response = $interface->ResourcepoolModify( {
    Resourcepool =>  { # MyTypes::WrapperOfResourcepoolInfo
      ResourcepoolInfo =>  { # MyTypes::ResourcepoolInfo
        AggregateNearlyOvercommittedThreshold =>  $some_value, # unsignedShort
        AggregateOvercommittedThreshold =>  $some_value, # unsignedShort
        ResourceTag => $some_value, # ResourceTag
        ResourcepoolContact => $some_value, # EmailAddressList
        ResourcepoolDescription =>  $some_value, # string
        ResourcepoolFreeVfilers =>  $some_value, # unsignedLong
        ResourcepoolFullThreshold => $some_value, # atomic
        ResourcepoolId =>  $some_value, # integer
        ResourcepoolIsProvisionable =>  $some_value, # boolean
        ResourcepoolKbytesAvailable => $some_value, # atomic
        ResourcepoolKbytesTotal => $some_value, # atomic
        ResourcepoolKbytesUsed => $some_value, # atomic
        ResourcepoolMemberCount => $some_value, # atomic
        ResourcepoolName =>  $some_value, # string
        ResourcepoolNearlyFullThreshold => $some_value, # atomic
        ResourcepoolOwner =>  $some_value, # string
        ResourcepoolPerfStatus => $some_value, # ObjStatus
        ResourcepoolSpaceStatus =>  $some_value, # string
        ResourcepoolStatus => $some_value, # ObjStatus
        ResourcepoolTimezone =>  $some_value, # string
      },
    },
    ResourcepoolNameOrId =>  $some_value, # string
  },,
 );

=head3 ResourcepoolModifyMember

ERESOURCEPOOLDOESNOTEXIST 

Returns a L<MyElements::ResourcepoolModifyMemberResult|MyElements::ResourcepoolModifyMemberResult> object.

 $response = $interface->ResourcepoolModifyMember( {
    MemberNameOrId => $some_value, # ObjNameOrId
    ResourceTag => $some_value, # ResourceTag
    ResourcepoolNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ResourcepoolRemoveMember

ERESOURCEPOOLDOESNOTEXIST 

Returns a L<MyElements::ResourcepoolRemoveMemberResult|MyElements::ResourcepoolRemoveMemberResult> object.

 $response = $interface->ResourcepoolRemoveMember( {
    MemberNameOrId =>  $some_value, # string
    ResourcepoolNameOrId =>  $some_value, # string
  },,
 );

=head3 ResourcepoolUpdateFreeSpaceStatus

ERESOURCEPOOLDOESNOTEXIST 

Returns a L<MyElements::ResourcepoolUpdateFreeSpaceStatusResult|MyElements::ResourcepoolUpdateFreeSpaceStatusResult> object.

 $response = $interface->ResourcepoolUpdateFreeSpaceStatus( {
    ResourcepoolNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 SnapshotGetReclaimableInfo

EVOLUMEOFFLINE 

Returns a L<MyElements::SnapshotGetReclaimableInfoResult|MyElements::SnapshotGetReclaimableInfoResult> object.

 $response = $interface->SnapshotGetReclaimableInfo( {
    Snapshots =>  { # MyTypes::ArrayOfSnapshot
      Snapshot =>  { # MyTypes::Snapshot
        SnapshotName =>  $some_value, # string
        UniqueId =>  $some_value, # string
      },
    },
    VolumeNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 SnapshotListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::SnapshotListInfoIterEndResult|MyElements::SnapshotListInfoIterEndResult> object.

 $response = $interface->SnapshotListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 SnapshotListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::SnapshotListInfoIterNextResult|MyElements::SnapshotListInfoIterNextResult> object.

 $response = $interface->SnapshotListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 SnapshotListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::SnapshotListInfoIterStartResult|MyElements::SnapshotListInfoIterStartResult> object.

 $response = $interface->SnapshotListInfoIterStart( {
    IncludeBackupInfo =>  $some_value, # boolean
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 SrmFileTypeAdd

EINVALIDINPUT 

Returns a L<MyElements::SrmFileTypeAddResult|MyElements::SrmFileTypeAddResult> object.

 $response = $interface->SrmFileTypeAdd( {
    SrmFileTypeName =>  $some_value, # string
  },,
 );

=head3 SrmFileTypeDelete

EINVALIDINPUT 

Returns a L<MyElements::SrmFileTypeDeleteResult|MyElements::SrmFileTypeDeleteResult> object.

 $response = $interface->SrmFileTypeDelete( {
    SrmFileTypeNameOrIdList =>  { # MyTypes::ArrayOfObjectNameOrId
      ObjectNameOrId => $some_value, # ObjectNameOrId
    },
  },,
 );

=head3 SrmFileTypeListInfo

EINVALIDINPUT 

Returns a L<MyElements::SrmFileTypeListInfoResult|MyElements::SrmFileTypeListInfoResult> object.

 $response = $interface->SrmFileTypeListInfo( {
    SrmFileTypeId => $some_value, # ObjId
  },,
 );

=head3 StorageServiceCreate

ESERVICEEXISTS 

Returns a L<MyElements::StorageServiceCreateResult|MyElements::StorageServiceCreateResult> object.

 $response = $interface->StorageServiceCreate( {
    GroupNameOrId => $some_value, # ObjNameOrId
    ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
    StorageServiceContact => $some_value, # EmailAddressList
    StorageServiceDescription =>  $some_value, # string
    StorageServiceName => $some_value, # ObjName
    StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
      StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
        DpNodeName => $some_value, # DpPolicyNodeName
        OldDpNodeName => $some_value, # DpPolicyNodeName
        ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
        Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
          ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
        },
        VfilerTemplateNameOrId => $some_value, # ObjNameOrId
      },
    },
    StorageServiceOwner =>  $some_value, # string
  },,
 );

=head3 StorageServiceDatasetListIterEnd

EINVALIDTAG 

Returns a L<MyElements::StorageServiceDatasetListIterEndResult|MyElements::StorageServiceDatasetListIterEndResult> object.

 $response = $interface->StorageServiceDatasetListIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 StorageServiceDatasetListIterNext

EINVALIDTAG 

Returns a L<MyElements::StorageServiceDatasetListIterNextResult|MyElements::StorageServiceDatasetListIterNextResult> object.

 $response = $interface->StorageServiceDatasetListIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 StorageServiceDatasetListIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::StorageServiceDatasetListIterStartResult|MyElements::StorageServiceDatasetListIterStartResult> object.

 $response = $interface->StorageServiceDatasetListIterStart( {
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 StorageServiceDatasetModify

EOPERATIONNOTSUPPORTED 

Returns a L<MyElements::StorageServiceDatasetModifyResult|MyElements::StorageServiceDatasetModifyResult> object.

 $response = $interface->StorageServiceDatasetModify( {
    AssumeConfirmation =>  $some_value, # boolean
    DatasetNameOrId => $some_value, # ObjNameOrId
    DryRun =>  $some_value, # boolean
    IncludeDryRunReasonDetails =>  $some_value, # boolean
    OperationType =>  $some_value, # string
    StorageServiceNameOrId => $some_value, # ObjNameOrId
    StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
      StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
        DpNodeName => $some_value, # DpPolicyNodeName
        OldDpNodeName => $some_value, # DpPolicyNodeName
        ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
        Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
          ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
        },
        VfilerTemplateNameOrId => $some_value, # ObjNameOrId
      },
    },
  },,
 );

=head3 StorageServiceDatasetProvision

EVFILERINTERFACENOTSET 

Returns a L<MyElements::StorageServiceDatasetProvisionResult|MyElements::StorageServiceDatasetProvisionResult> object.

 $response = $interface->StorageServiceDatasetProvision( {
    ApplicationInfo =>  { # MyTypes::ApplicationInfo
      ApplicationName =>  $some_value, # string
      ApplicationServerName =>  $some_value, # string
      ApplicationVersion =>  $some_value, # string
      CarryPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationManagingPrimaryBackupRetention =>  $some_value, # boolean
      IsApplicationResponsibleForPrimaryBackup =>  $some_value, # boolean
    },
    AssumeConfirmation =>  $some_value, # boolean
    DatasetContact => $some_value, # EmailAddressList
    DatasetDescription =>  $some_value, # string
    DatasetMetadata =>  { # MyTypes::ArrayOfDfmMetadataField
      DfmMetadataField =>  { # MyTypes::DfmMetadataField
        FieldName =>  $some_value, # string
        FieldValue =>  $some_value, # string
      },
    },
    DatasetName => $some_value, # ObjName
    DatasetOwner =>  $some_value, # string
    DryRun =>  $some_value, # boolean
    GroupNameOrId => $some_value, # ObjNameOrId
    IncludeDryRunReasonDetails =>  $some_value, # boolean
    IsApplicationData =>  $some_value, # boolean
    IsSuspended =>  $some_value, # boolean
    OnlineMigration =>  $some_value, # boolean
    ProvisionMember =>  { # MyTypes::WrapperOfProvisionMemberRequestInfo
      ProvisionMemberRequestInfo =>  { # MyTypes::ProvisionMemberRequestInfo
        Comments =>  { # MyTypes::ArrayOfProvisionMemberComment
          ProvisionMemberComment =>  { # MyTypes::ProvisionMemberComment
            CommentFieldNameOrId => $some_value, # CommentFieldNameOrId
            CommentValue => $some_value, # CommentValue
          },
        },
        CreateNewVfiler =>  $some_value, # boolean
        DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
          DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
            CifsDomain =>  $some_value, # string
            DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
              DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
                CifsUsername =>  $some_value, # string
                Permission => $some_value, # CifsPermission
              },
            },
          },
          DatasetExportProtocol => $some_value, # DatasetExportProtocol
          DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
            IgroupOsType =>  $some_value, # string
            LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
              LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
                Hostname =>  $some_value, # string
                InitiatorId => $some_value, # InitiatorId
              },
            },
          },
          DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
            AnonymousAccessUser => $some_value, # atomic
            DisableSetuid =>  $some_value, # boolean
            IsReadonlyForAllHosts =>  $some_value, # boolean
            IsReadwriteForAllHosts =>  $some_value, # boolean
            NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsProtocolVersion =>  $some_value, # string
            NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
              NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
            },
          },
        },
        Description =>  $some_value, # string
        InitialSnapshotSpace => $some_value, # atomic
        MaximumDataSize => $some_value, # atomic
        MaximumSnapshotSpace => $some_value, # atomic
        Name =>  $some_value, # string
        OnlineMigration =>  $some_value, # boolean
        ProvisioningPolicyId => $some_value, # ObjId
        ProvisioningPolicyName => $some_value, # ObjFullName
        ResourceNameOrId => $some_value, # ObjNameOrId
        Size => $some_value, # atomic
        VfilerNameOrId => $some_value, # ObjNameOrId
      },
    },
    RequiresNonDisruptiveRestore => $some_value, # RequiresNonDisruptiveRestore
    StorageServiceNameOrId => $some_value, # ObjNameOrId
    StorageSetDetails =>  { # MyTypes::ArrayOfStorageSetInfo
      StorageSetInfo =>  { # MyTypes::StorageSetInfo
        DatasetAccessDetails =>  { # MyTypes::DatasetAccessDetails
          IpAddress =>  $some_value, # string
          Netmask =>  $some_value, # string
        },
        DatasetExportInfo =>  { # MyTypes::DatasetExportInfo
          DatasetCifsExportSetting =>  { # MyTypes::DatasetCifsExportSetting
            CifsDomain =>  $some_value, # string
            DatasetCifsSharePermissions =>  { # MyTypes::ArrayOfDatasetCifsSharePermission
              DatasetCifsSharePermission =>  { # MyTypes::DatasetCifsSharePermission
                CifsUsername =>  $some_value, # string
                Permission => $some_value, # CifsPermission
              },
            },
          },
          DatasetExportProtocol => $some_value, # DatasetExportProtocol
          DatasetLunMappingInfo =>  { # MyTypes::DatasetLunMappingInfo
            IgroupOsType =>  $some_value, # string
            LunMappingInitiators =>  { # MyTypes::ArrayOfLunMappingInitiator
              LunMappingInitiator =>  { # MyTypes::LunMappingInitiator
                Hostname =>  $some_value, # string
                InitiatorId => $some_value, # InitiatorId
              },
            },
          },
          DatasetNfsExportSetting =>  { # MyTypes::DatasetNfsExportSetting
            AnonymousAccessUser => $some_value, # atomic
            DisableSetuid =>  $some_value, # boolean
            IsReadonlyForAllHosts =>  $some_value, # boolean
            IsReadwriteForAllHosts =>  $some_value, # boolean
            NfsExportRoHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsExportRootHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsExportRwHosts =>  { # MyTypes::ArrayOfNfsExportHost
              NfsExportHost =>  { # MyTypes::NfsExportHost
                Hostname =>  $some_value, # string
                IsAnException =>  $some_value, # boolean
              },
            },
            NfsProtocolVersion =>  $some_value, # string
            NfsSecurityFlavors =>  { # MyTypes::ArrayOfNfsSecurityFlavor
              NfsSecurityFlavor => $some_value, # NfsSecurityFlavor
            },
          },
        },
        DpNodeName => $some_value, # DpPolicyNodeName
        ServerNameOrId => $some_value, # ObjNameOrId
        TimezoneName =>  $some_value, # string
      },
    },
    VolumeQtreeNamePrefix =>  $some_value, # string
  },,
 );

=head3 StorageServiceDestroy

ESTORAGESERVICEINUSE 

Returns a L<MyElements::StorageServiceDestroyResult|MyElements::StorageServiceDestroyResult> object.

 $response = $interface->StorageServiceDestroy( {
    Force =>  $some_value, # boolean
    StorageServiceNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 StorageServiceListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::StorageServiceListInfoIterEndResult|MyElements::StorageServiceListInfoIterEndResult> object.

 $response = $interface->StorageServiceListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 StorageServiceListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::StorageServiceListInfoIterNextResult|MyElements::StorageServiceListInfoIterNextResult> object.

 $response = $interface->StorageServiceListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 StorageServiceListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::StorageServiceListInfoIterStartResult|MyElements::StorageServiceListInfoIterStartResult> object.

 $response = $interface->StorageServiceListInfoIterStart( {
    IsDrCapable =>  $some_value, # boolean
    ObjectNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 StorageServiceModify

ESERVICEEXISTS 

Returns a L<MyElements::StorageServiceModifyResult|MyElements::StorageServiceModifyResult> object.

 $response = $interface->StorageServiceModify( {
    AssumeConfirmation =>  $some_value, # boolean
    DryRun =>  $some_value, # boolean
    IncludeDryRunReasonDetails =>  $some_value, # boolean
    ProtectionPolicyNameOrId => $some_value, # ObjNameOrId
    StorageServiceContact => $some_value, # EmailAddressList
    StorageServiceDescription =>  $some_value, # string
    StorageServiceName => $some_value, # ObjName
    StorageServiceNameOrId => $some_value, # ObjNameOrId
    StorageServiceNodeList =>  { # MyTypes::ArrayOfStorageServiceNodeAttributes
      StorageServiceNodeAttributes =>  { # MyTypes::StorageServiceNodeAttributes
        DpNodeName => $some_value, # DpPolicyNodeName
        OldDpNodeName => $some_value, # DpPolicyNodeName
        ProvisioningPolicyNameOrId => $some_value, # ObjNameOrId
        Resourcepools =>  { # MyTypes::ArrayOfResourcepoolNameOrId
          ResourcepoolNameOrId => $some_value, # ResourcepoolNameOrId
        },
        VfilerTemplateNameOrId => $some_value, # ObjNameOrId
      },
    },
    StorageServiceOwner =>  $some_value, # string
  },,
 );

=head3 TimezoneGetDefaults

supported 

Returns a L<MyElements::TimezoneGetDefaultsResult|MyElements::TimezoneGetDefaultsResult> object.

 $response = $interface->TimezoneGetDefaults(,,
 );

=head3 TimezoneListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::TimezoneListInfoIterEndResult|MyElements::TimezoneListInfoIterEndResult> object.

 $response = $interface->TimezoneListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 TimezoneListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::TimezoneListInfoIterNextResult|MyElements::TimezoneListInfoIterNextResult> object.

 $response = $interface->TimezoneListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 TimezoneListInfoIterStart

supported 

Returns a L<MyElements::TimezoneListInfoIterStartResult|MyElements::TimezoneListInfoIterStartResult> object.

 $response = $interface->TimezoneListInfoIterStart(,,
 );

=head3 TimezoneValidate

EINVALIDTIMEZONE 

Returns a L<MyElements::TimezoneValidateResult|MyElements::TimezoneValidateResult> object.

 $response = $interface->TimezoneValidate( {
    Timezone =>  $some_value, # string
  },,
 );

=head3 UserFavoriteReportDelete

ENOFAVORITES 

Returns a L<MyElements::UserFavoriteReportDeleteResult|MyElements::UserFavoriteReportDeleteResult> object.

 $response = $interface->UserFavoriteReportDelete( {
    UserName =>  $some_value, # string
  },,
 );

=head3 UserFavoriteReportListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::UserFavoriteReportListInfoIterEndResult|MyElements::UserFavoriteReportListInfoIterEndResult> object.

 $response = $interface->UserFavoriteReportListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 UserFavoriteReportListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::UserFavoriteReportListInfoIterNextResult|MyElements::UserFavoriteReportListInfoIterNextResult> object.

 $response = $interface->UserFavoriteReportListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 UserFavoriteReportListInfoIterStart

ENOFAVORITES 

Returns a L<MyElements::UserFavoriteReportListInfoIterStartResult|MyElements::UserFavoriteReportListInfoIterStartResult> object.

 $response = $interface->UserFavoriteReportListInfoIterStart( {
    UserName =>  $some_value, # string
  },,
 );

=head3 UserRecentReportDelete

ENORECENTVIEWED 

Returns a L<MyElements::UserRecentReportDeleteResult|MyElements::UserRecentReportDeleteResult> object.

 $response = $interface->UserRecentReportDelete( {
    UserName =>  $some_value, # string
  },,
 );

=head3 UserRecentReportListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::UserRecentReportListInfoIterEndResult|MyElements::UserRecentReportListInfoIterEndResult> object.

 $response = $interface->UserRecentReportListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 UserRecentReportListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::UserRecentReportListInfoIterNextResult|MyElements::UserRecentReportListInfoIterNextResult> object.

 $response = $interface->UserRecentReportListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 UserRecentReportListInfoIterStart

ENORECENTVIEWED 

Returns a L<MyElements::UserRecentReportListInfoIterStartResult|MyElements::UserRecentReportListInfoIterStartResult> object.

 $response = $interface->UserRecentReportListInfoIterStart( {
    UserName =>  $some_value, # string
  },,
 );

=head3 VfilerCreate

EOBJECTNOTFOUND 

Returns a L<MyElements::VfilerCreateResult|MyElements::VfilerCreateResult> object.

 $response = $interface->VfilerCreate( {
    AllowedProtocols =>  { # MyTypes::ArrayOfProtocol
      Protocol => $some_value, # Protocol
    },
    DryRun =>  $some_value, # boolean
    IpAddress => $some_value, # IpAddress
    Ipspace =>  $some_value, # string
    Name => $some_value, # ObjName
    ResourceNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::VfilerDestroyResult|MyElements::VfilerDestroyResult> object.

 $response = $interface->VfilerDestroy( {
    VfilerNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerSetup

EOBJECTNOTFOUND 

Returns a L<MyElements::VfilerSetupResult|MyElements::VfilerSetupResult> object.

 $response = $interface->VfilerSetup( {
    AllowedProtocols =>  { # MyTypes::ArrayOfProtocol
      Protocol => $some_value, # Protocol
    },
    CifsDomainPassword =>  $some_value, # string
    CifsDomainUser =>  $some_value, # string
    CifsWorkgroupName =>  $some_value, # string
    IpBindings =>  { # MyTypes::ArrayOfIpBindingInfo
      IpBindingInfo =>  { # MyTypes::IpBindingInfo
        Interface => $some_value, # ObjNameOrId
        IpAddress => $some_value, # IpAddress
        MtuSize => $some_value, # atomic
        Netmask =>  $some_value, # string
        PartnerInterface => $some_value, # ObjNameOrId
        PrefixLength => $some_value, # atomic
        VlanIdentifier => $some_value, # atomic
      },
    },
    RootPassword =>  $some_value, # string
    RunCifsSetup =>  $some_value, # boolean
    ScriptPath =>  $some_value, # string
    VfilerNameOrId => $some_value, # ObjNameOrId
    VfilerTemplateNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerTemplateCopy

EVFILERTEMPLATEEXISTS 

Returns a L<MyElements::VfilerTemplateCopyResult|MyElements::VfilerTemplateCopyResult> object.

 $response = $interface->VfilerTemplateCopy( {
    VfilerTemplateName => $some_value, # ObjName
    VfilerTemplateNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerTemplateCreate

EVFILERTEMPLATEEXISTS 

Returns a L<MyElements::VfilerTemplateCreateResult|MyElements::VfilerTemplateCreateResult> object.

 $response = $interface->VfilerTemplateCreate( {
    VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateInfo
      VfilerTemplateInfo =>  { # MyTypes::VfilerTemplateInfo
        AdministrativeHostIpAddress => $some_value, # IpAddress
        CifsAuthType =>  $some_value, # string
        CifsDomain =>  $some_value, # string
        CifsSecurityStyle =>  $some_value, # string
        Description =>  $some_value, # string
        DnsDomain =>  $some_value, # string
        DnsServers =>  { # MyTypes::ArrayOfIpAddress
          IpAddress => $some_value, # IpAddress
        },
        NisDomain =>  $some_value, # string
        NisServers =>  { # MyTypes::ArrayOfIpAddress
          IpAddress => $some_value, # IpAddress
        },
        VfilerTemplateId => $some_value, # ObjId
        VfilerTemplateName => $some_value, # ObjName
      },
    },
  },,
 );

=head3 VfilerTemplateDelete

EVFILERTEMPLATEINUSE 

Returns a L<MyElements::VfilerTemplateDeleteResult|MyElements::VfilerTemplateDeleteResult> object.

 $response = $interface->VfilerTemplateDelete( {
    VfilerTemplateNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerTemplateListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::VfilerTemplateListInfoIterEndResult|MyElements::VfilerTemplateListInfoIterEndResult> object.

 $response = $interface->VfilerTemplateListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 VfilerTemplateListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::VfilerTemplateListInfoIterNextResult|MyElements::VfilerTemplateListInfoIterNextResult> object.

 $response = $interface->VfilerTemplateListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 VfilerTemplateListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::VfilerTemplateListInfoIterStartResult|MyElements::VfilerTemplateListInfoIterStartResult> object.

 $response = $interface->VfilerTemplateListInfoIterStart( {
    VfilerTemplateNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VfilerTemplateModify

EVFILERTEMPLATEEXISTS 

Returns a L<MyElements::VfilerTemplateModifyResult|MyElements::VfilerTemplateModifyResult> object.

 $response = $interface->VfilerTemplateModify( {
    VfilerTemplate =>  { # MyTypes::WrapperOfVfilerTemplateInfo
      VfilerTemplateInfo =>  { # MyTypes::VfilerTemplateInfo
        AdministrativeHostIpAddress => $some_value, # IpAddress
        CifsAuthType =>  $some_value, # string
        CifsDomain =>  $some_value, # string
        CifsSecurityStyle =>  $some_value, # string
        Description =>  $some_value, # string
        DnsDomain =>  $some_value, # string
        DnsServers =>  { # MyTypes::ArrayOfIpAddress
          IpAddress => $some_value, # IpAddress
        },
        NisDomain =>  $some_value, # string
        NisServers =>  { # MyTypes::ArrayOfIpAddress
          IpAddress => $some_value, # IpAddress
        },
        VfilerTemplateId => $some_value, # ObjId
        VfilerTemplateName => $some_value, # ObjName
      },
    },
  },,
 );

=head3 ViDatacenterListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViDatacenterListInfoIterEndResult|MyElements::ViDatacenterListInfoIterEndResult> object.

 $response = $interface->ViDatacenterListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViDatacenterListInfoIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::ViDatacenterListInfoIterNextResult|MyElements::ViDatacenterListInfoIterNextResult> object.

 $response = $interface->ViDatacenterListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ViDatacenterListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViDatacenterListInfoIterStartResult|MyElements::ViDatacenterListInfoIterStartResult> object.

 $response = $interface->ViDatacenterListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ViDatastoreListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViDatastoreListInfoIterEndResult|MyElements::ViDatastoreListInfoIterEndResult> object.

 $response = $interface->ViDatastoreListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViDatastoreListInfoIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::ViDatastoreListInfoIterNextResult|MyElements::ViDatastoreListInfoIterNextResult> object.

 $response = $interface->ViDatastoreListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ViDatastoreListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViDatastoreListInfoIterStartResult|MyElements::ViDatastoreListInfoIterStartResult> object.

 $response = $interface->ViDatastoreListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ViHypervisorListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViHypervisorListInfoIterEndResult|MyElements::ViHypervisorListInfoIterEndResult> object.

 $response = $interface->ViHypervisorListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViHypervisorListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::ViHypervisorListInfoIterNextResult|MyElements::ViHypervisorListInfoIterNextResult> object.

 $response = $interface->ViHypervisorListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ViHypervisorListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViHypervisorListInfoIterStartResult|MyElements::ViHypervisorListInfoIterStartResult> object.

 $response = $interface->ViHypervisorListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
    VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
  },,
 );

=head3 ViVirtualCenterListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViVirtualCenterListInfoIterEndResult|MyElements::ViVirtualCenterListInfoIterEndResult> object.

 $response = $interface->ViVirtualCenterListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualCenterListInfoIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualCenterListInfoIterNextResult|MyElements::ViVirtualCenterListInfoIterNextResult> object.

 $response = $interface->ViVirtualCenterListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualCenterListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualCenterListInfoIterStartResult|MyElements::ViVirtualCenterListInfoIterStartResult> object.

 $response = $interface->ViVirtualCenterListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ViVirtualDiskListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViVirtualDiskListInfoIterEndResult|MyElements::ViVirtualDiskListInfoIterEndResult> object.

 $response = $interface->ViVirtualDiskListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualDiskListInfoIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualDiskListInfoIterNextResult|MyElements::ViVirtualDiskListInfoIterNextResult> object.

 $response = $interface->ViVirtualDiskListInfoIterNext( {
    Maximum => $some_value, # atomic
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualDiskListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualDiskListInfoIterStartResult|MyElements::ViVirtualDiskListInfoIterStartResult> object.

 $response = $interface->ViVirtualDiskListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 ViVirtualMachineListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::ViVirtualMachineListInfoIterEndResult|MyElements::ViVirtualMachineListInfoIterEndResult> object.

 $response = $interface->ViVirtualMachineListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualMachineListInfoIterNext

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualMachineListInfoIterNextResult|MyElements::ViVirtualMachineListInfoIterNextResult> object.

 $response = $interface->ViVirtualMachineListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 ViVirtualMachineListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::ViVirtualMachineListInfoIterStartResult|MyElements::ViVirtualMachineListInfoIterStartResult> object.

 $response = $interface->ViVirtualMachineListInfoIterStart( {
    IncludeDeleted =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjNameOrId => $some_value, # ObjNameOrId
    VirtualInfrastructureType => $some_value, # VirtualInfrastructureType
  },,
 );

=head3 VolumeDedupe

EOBJECTNOTFOUND 

Returns a L<MyElements::VolumeDedupeResult|MyElements::VolumeDedupeResult> object.

 $response = $interface->VolumeDedupe( {
    DedupeRequestInfo =>  { # MyTypes::DedupeRequestInfo
      FullVolumeDedupe =>  $some_value, # boolean
    },
    VolumeNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VolumeDestroy

EOBJECTNOTFOUND 

Returns a L<MyElements::VolumeDestroyResult|MyElements::VolumeDestroyResult> object.

 $response = $interface->VolumeDestroy( {
    VolumeNameOrId => $some_value, # ObjNameOrId
  },,
 );

=head3 VolumeListInfoIterEnd

EINVALIDTAG 

Returns a L<MyElements::VolumeListInfoIterEndResult|MyElements::VolumeListInfoIterEndResult> object.

 $response = $interface->VolumeListInfoIterEnd( {
    Tag =>  $some_value, # string
  },,
 );

=head3 VolumeListInfoIterNext

EINVALIDTAG 

Returns a L<MyElements::VolumeListInfoIterNextResult|MyElements::VolumeListInfoIterNextResult> object.

 $response = $interface->VolumeListInfoIterNext( {
    Maximum =>  $some_value, # integer
    Tag =>  $some_value, # string
  },,
 );

=head3 VolumeListInfoIterStart

EOBJECTNOTFOUND 

Returns a L<MyElements::VolumeListInfoIterStartResult|MyElements::VolumeListInfoIterStartResult> object.

 $response = $interface->VolumeListInfoIterStart( {
    BlockType => $some_value, # FileSystemBlockType
    IncludeIsAvailable =>  $some_value, # boolean
    IncludeMigrationInfo =>  $some_value, # boolean
    IncludeNextScheduledBackupTime =>  $some_value, # boolean
    IsDirectMemberOnly =>  $some_value, # boolean
    IsDpIgnored =>  $some_value, # boolean
    IsInDataset =>  $some_value, # boolean
    IsSisVolume =>  $some_value, # boolean
    IsSnapmirrorPrimaryCapable =>  $some_value, # boolean
    IsSnapmirrorSecondaryCapable =>  $some_value, # boolean
    IsSnapvaultPrimaryCapable =>  $some_value, # boolean
    IsSnapvaultSecondaryCapable =>  $some_value, # boolean
    IsUnprotected =>  $some_value, # boolean
    ObjectManagementFilter => $some_value, # ObjectManagementInterface
    ObjectNameOrId =>  $some_value, # string
    RbacOperation =>  $some_value, # string
    SnapvaultSecondaryScheduleName =>  $some_value, # string
    VolumeType =>  $some_value, # string
  },,
 );

=head3 VolumeModify

EOBJECTNOTFOUND 

Returns a L<MyElements::VolumeModifyResult|MyElements::VolumeModifyResult> object.

 $response = $interface->VolumeModify( {
    IsDpIgnored =>  $some_value, # boolean
    VolumeNameOrId =>  $some_value, # string
  },,
 );

=head3 VolumeResize

EOBJECTNOTFOUND 

Returns a L<MyElements::VolumeResizeResult|MyElements::VolumeResizeResult> object.

 $response = $interface->VolumeResize( {
    ResizeVolumeRequestInfo =>  { # MyTypes::ResizeVolumeRequestInfo
      MaximumCapacity => $some_value, # atomic
      NewSize => $some_value, # atomic
      SnapReserve => $some_value, # atomic
    },
    VolumeNameOrId => $some_value, # ObjNameOrId
  },,
 );



=head1 AUTHOR

Generated by SOAP::WSDL on Thu Mar  3 22:56:35 2011

=cut
