
package MyTypemaps::DfmService;
use strict;
use warnings;

our $typemap_1 = {
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/DatasetName' => 'MyTypes::ObjName',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
               'PerfViewGetData/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterStart' => 'MyElements::HostUsergroupListIterStart',
               'UserRecentReportListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfObjectInstanceListIterNextResult/Instances/PerfInstance/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts' => 'MyTypes::ArrayOfConformanceAlert',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ThrottleScheduleName' => 'MyTypes::ObjName',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'DatasetModify' => 'MyElements::DatasetModify',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/LagWarningThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagWarningThreshold',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'StorageServiceCreate/StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
               'EventListIterStart/EventTypeFilterList/EventTypeFilter' => 'MyTypes::EventTypeFilter',
               'DpBackupVersionCreate/BackupMetadata/DfmMetadata/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolumeResult/MigrationJobs' => 'MyTypes::ArrayOfMigrationJobInfo',
               'DatasetIoMetricListInfoIterStart/Year' => 'MyElements::DatasetIoMetricListInfoIterStart::_Year',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo/RelationshipId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'UserRecentReportListInfoIterNextResult/RecentViewed/UserReportInfo' => 'MyTypes::UserReportInfo',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings' => 'MyTypes::NasContainerSettings',
               'ReportOutputListInfoIterStartResult/Records' => 'MyElements::ReportOutputListInfoIterStartResult::_Records',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/DpBackupTransferInfo/BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo/DatasetId' => 'MyTypes::ObjId',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/StartHour' => 'MyTypes::ThrottleItemInfo::_StartHour',
               'PerfViewCreate/View/PerfView/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpGetDatasetBackupJobsData/BackupDestination' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'HostRoleListIterStart/HostRoleNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'DfmRelatedObjectsListInfoResult/ParentDatasetList/ParentDataset/Id' => 'MyTypes::ObjId',
               'DpScheduleWeeklySubscheduleAddResult' => 'MyElements::DpScheduleWeeklySubscheduleAddResult',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreateResult' => 'MyElements::StorageServiceCreateResult',
               'DpRestoreToNewPathResult/JobId' => 'MyElements::DpRestoreToNewPathResult::_JobId',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource/InterfaceId' => 'MyTypes::ObjId',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'DpBackupVersionDelete/NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo' => 'MyTypes::VfilerTemplateInfo',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterStartResult' => 'MyElements::VolumeListInfoIterStartResult',
               'EventStatusChangeListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostUserModify' => 'MyElements::HostUserModify',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo' => 'MyTypes::DpOssvDirectoryRootInfo',
               'ResourcepoolRemoveMember/ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualDiskListInfoIterEnd' => 'MyElements::ViVirtualDiskListInfoIterEnd',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupInfo/IgroupName' => 'MyTypes::ObjFullName',
               'DfmScheduleCreate/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionDuration',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/SystemTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/StoragesetName' => 'MyTypes::ObjName',
               'ResourcepoolMemberListInfoIterStart/IncludeDatasetSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/TotalDataSpace' => 'MyTypes::SpaceMeasurement::_TotalDataSpace',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAddResult/HostUserId' => 'MyTypes::AccessObjectId',
               'PerfViewCreate/View/PerfView/ViewType' => 'MyTypes::ViewType',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertType' => 'MyTypes::ConformanceAlertType',
               'DatasetEditCommitResult/JobIds' => 'MyTypes::ArrayOfJobInfo',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'ReportGraphListInfoIterStart' => 'MyElements::ReportGraphListInfoIterStart',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyName' => 'MyTypes::ObjName',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/FullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_FullThreshold',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'GroupMove/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DpScheduleWeeklySubscheduleDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterEnd' => 'MyElements::GraphListInfoIterEnd',
               'DfmServerListDiagnosticInfoResult/DiagInfo/DfmDiagCounterGroup' => 'MyTypes::DfmDiagCounterGroup',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'MigrateStart/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'HostAddOssvResult/HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectsGetStatusResult/ObjectsStatus' => 'MyTypes::ArrayOfObjStatusInfo',
               'DatasetCreate/TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterStart/OssvHostNameOrId' => 'MyTypes::OssvHostNameOrId',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/StartTime' => 'MyTypes::Timestamp',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Dataset/DatasetResource' => 'MyTypes::DatasetResource',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetAccessDetails/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'SnapshotGetReclaimableInfo/Snapshots/Snapshot' => 'MyTypes::Snapshot',
               'ProvisioningPolicyEditCommit' => 'MyElements::ProvisioningPolicyEditCommit',
               'DfmSnmpSettingDeleteResult' => 'MyElements::DfmSnmpSettingDeleteResult',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo/StorageServiceDatasetInfo' => 'MyTypes::StorageServiceDatasetInfo',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/NeedsUpgrade' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/SnapshotScheduleId' => 'MyTypes::ObjId',
               'ReportScheduleModify' => 'MyElements::ReportScheduleModify',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledge/EventId' => 'MyElements::EventAcknowledge::_EventId',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/BaseCounter' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'EventclassListResult/EventClasses/EventClassInfo/IsMultiCurrent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/EventSeverity' => 'MyTypes::ObjStatus',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes' => 'MyTypes::ArrayOfDpPolicyNodeInfo',
               'AlarmModify/AlarmInfo' => 'MyTypes::AlarmInfo',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterStart/EndTime' => 'MyTypes::Timestamp',
               'CommentFieldListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApiProxyResult/Response/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementBeginResult/SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementBeginResult::_SpaceManagementSessionId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo/SnapReserve' => 'MyTypes::ResizeMemberRequestInfo::_SnapReserve',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventClassId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateDetachObjects/Objects/ObjectInfo' => 'MyTypes::ObjectInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DpThrottleListInfoIterStartResult' => 'MyElements::DpThrottleListInfoIterStartResult',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetExclusionListInfoIterStartResult' => 'MyElements::DatasetExclusionListInfoIterStartResult',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth' => 'MyTypes::ArrayOfDayOfMonth',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/AdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'TimezoneListInfoIterNext' => 'MyElements::TimezoneListInfoIterNext',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource' => 'MyTypes::PerfDataSource',
               'HostListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/StartRemoteBackupAfterLocalBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberDedupeAbort/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpRelationshipListInfoIterNextResult/Records' => 'MyElements::DpRelationshipListInfoIterNextResult::_Records',
               'DfmSnmpSettingsListInfo/NetworkAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupStartResult' => 'MyElements::PerfCounterGroupStartResult',
               'UserRecentReportListInfoIterNextResult/RecentViewed/UserReportInfo/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'ReportScheduleAdd/ReportScheduleInfo/SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'CommentFieldValuesListInfoIterNext' => 'MyElements::CommentFieldValuesListInfoIterNext',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds' => 'MyTypes::DatasetMemberUsedSpaceThresholds',
               'EventclassAddCustom/EventNames/EventNameInfo/EventNamePretty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterStart/HostUsergroupNameOrId' => 'MyTypes::UsergroupNameOrId',
               'ViDatastoreListInfoIterNextResult/Records' => 'MyElements::ViDatastoreListInfoIterNextResult::_Records',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'DpOssvApplicationListInfoIterStartResult' => 'MyElements::DpOssvApplicationListInfoIterStartResult',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'PerfThresholdModify2' => 'MyElements::PerfThresholdModify2',
               'DfmScheduleHourlyAdd' => 'MyElements::DfmScheduleHourlyAdd',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'DfmScheduleMonthlySubscheduleSet/SubscheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ThresholdInterval' => 'MyTypes::ThresholdInfo::_ThresholdInterval',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditBegin/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberDedupeStart/DedupeMemberRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'PerfThresholdListInfoIterStart/Query' => 'MyTypes::WrapperOfThresholdInfo',
               'ReportOutputReadResult/OutputFormat' => 'MyTypes::ReportOutputFormat',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots' => 'MyTypes::ArrayOfSnapshotMemberInfo',
               'DatasetChangeDrState/AllowInternalTransitions' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmListInfoIterEnd' => 'MyElements::AlarmListInfoIterEnd',
               'PerfAssocViewListIterNextResult/Views/PerfView/AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'UserFavoriteReportListInfoIterEndResult' => 'MyElements::UserFavoriteReportListInfoIterEndResult',
               'EventclassListResult/EventClasses/EventClassInfo/IsAllowDuplicates' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportListInfoIterNext/Maximum' => 'MyElements::ReportListInfoIterNext::_Maximum',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList' => 'MyTypes::ArrayOfDayInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressHostServiceInfo/HostServiceName' => 'MyTypes::ObjFullName',
               'AlarmCreate/AlarmInfo/TrapDestinations/TrapDestination/TrapHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'ViDatastoreListInfoIterEnd' => 'MyElements::ViDatastoreListInfoIterEnd',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterNextResult/CifsDomainList' => 'MyTypes::ArrayOfCifsDomainInfo',
               'DpGetDatasetBackupJobsDataResult/DpJobsData' => 'MyTypes::ArrayOfDpJobData',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/PerfFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventSeverity' => 'MyTypes::ObjStatus',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetSpaceMetricListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportListInfoIterEndResult' => 'MyElements::ReportListInfoIterEndResult',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'CommentFieldCreate' => 'MyElements::CommentFieldCreate',
               'DpScheduleModify/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'ClientRegistryDestroyResult' => 'MyElements::ClientRegistryDestroyResult',
               'GroupListIterNextResult/GroupList/GroupInfo/ParentGroupId' => 'MyTypes::GroupInfo::_ParentGroupId',
               'DfmScheduleMonthlyModify/MonthlyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo/StorageServiceDatasetInfo/DatasetName' => 'MyTypes::ObjName',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/PhysicalUsedDataSpace' => 'MyTypes::SpaceMeasurement::_PhysicalUsedDataSpace',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules' => 'MyTypes::ArrayOfApplicationBackupScheduleInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DatasetId' => 'MyTypes::ObjId',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationStoragesetId' => 'MyTypes::DpBackupTransferInfo::_DestinationStoragesetId',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/DnsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleDisable/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'HostDomainuserAdd/HostUsergroupNamesOrIds' => 'MyTypes::ArrayOfHostUsergroupNameOrId',
               'AlarmModify/AlarmInfo/IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/StorageReliability/DiskFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo/AllowSavedStateBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'PerfThresholdTemplateAttachObjects/NewObjects' => 'MyTypes::ArrayOfObjectInfo',
               'DpBackupStart' => 'MyElements::DpBackupStart',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/HardLimit' => 'MyTypes::QtreeSizeInfo::_HardLimit',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo' => 'MyTypes::CifsShareInfo',
               'AlarmCreate/AlarmInfo/EventClass' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats' => 'MyTypes::ArrayOfHostClientStats',
               'PerfViewGetDataResult/DynamicData/DynamicData/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModifyResult' => 'MyElements::ResourcepoolModifyResult',
               'EventclassAddCustomResult/EventClassId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DpThrottleListInfoIterEnd' => 'MyElements::DpThrottleListInfoIterEnd',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools' => 'MyTypes::ArrayOfResourcepoolNameOrId',
               'UserRecentReportListInfoIterStart/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter/VirtualCenterName' => 'MyTypes::ObjName',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo' => 'MyTypes::StorageServiceNodeInfo',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo/CifsSharePermissions/CifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'PerfViewListIterNextResult/Views/PerfView/AssocObjType/PerfAssocObjType' => 'MyTypes::PerfAssocObjType',
               'HostListInfoIterNextResult/Hosts' => 'MyTypes::ArrayOfHostInfo',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/ObjectId' => 'MyTypes::ObjId',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/ObjectFullName' => 'MyTypes::ObjFullName',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/SnapshotReserveAvail' => 'MyTypes::VolumeSize::_SnapshotReserveAvail',
               'StorageServiceDatasetListIterNext' => 'MyElements::StorageServiceDatasetListIterNext',
               'PerfViewListIterNextResult' => 'MyElements::PerfViewListIterNextResult',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/CommittedSpace' => 'MyTypes::AggregateSpaceInfo::_CommittedSpace',
               'PerfThresholdTemplateListInfoIterStartResult' => 'MyElements::PerfThresholdTemplateListInfoIterStartResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'HostUserAdd/HostUser/HostUserInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'PerfThresholdListInfo2IterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualDiskListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Filer/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNext' => 'MyElements::IfcListInfoIterNext',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToPrimaryResult/OverwriteResults/OverwriteResult/FilePath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart/IncludeDatasetSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/ResourcePool' => 'MyTypes::WrapperOfResourcePoolResource',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/PacketsIn' => 'MyTypes::NetifIpInterfaceInfo::_PacketsIn',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/MgmtPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert' => 'MyTypes::ConformanceAlert',
               'DfmNetworkListInfoResult/Networks/NetworkInfo' => 'MyTypes::NetworkInfo',
               'HostUserAdd/HostUser/HostUserInfo/Description' => 'MyTypes::AccessObjectDescription',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/IsDedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'GroupCopy/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/NfsOpStats/WriteOperations' => 'MyTypes::NfsOpStats::_WriteOperations',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DatasetName' => 'MyTypes::ObjName',
               'VfilerTemplateListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterStart' => 'MyElements::AlarmListInfoIterStart',
               'HostUserAdd/HostUser/HostUserInfo' => 'MyTypes::HostUserInfo',
               'EventclassListIterEndResult' => 'MyElements::EventclassListIterEndResult',
               'DpJobProgressEventListIterStartResult' => 'MyElements::DpJobProgressEventListIterStartResult',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'DpBackupListIterStart/RootObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Policy' => 'MyTypes::WrapperOfPolicyResource',
               'PerfStatusGet/HostNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterData/TimeFilter/Days' => 'MyTypes::ArrayOfDay',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult' => 'MyElements::IfcListInfoIterNextResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModifyResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'VfilerTemplateListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/HostId' => 'MyTypes::DpOssvDirectoryRootInfo::_HostId',
               'ApiProxyResult/Response/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterNextResult/Disks/DiskInfo/DiskSize' => 'MyTypes::DiskInfo::_DiskSize',
               'DfmScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'ClientRegistryGetResult' => 'MyElements::ClientRegistryGetResult',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'DatasetCreate/IsDpSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/DedupeRequestInfo/FullVolumeDedupe' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/CustomProvisioningScriptSettings' => 'MyTypes::CustomProvisioningScriptSettings',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'AggregateSpaceManagementAddOperationResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'DpJobProgressEventListIterStart' => 'MyElements::DpJobProgressEventListIterStart',
               'PerfViewGetData/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter/VirtualCenterId' => 'MyTypes::ObjId',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceFullName' => 'MyTypes::ObjFullName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/Snapshots/Snapshot' => 'MyTypes::Snapshot',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapshotInfo/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterNextResult/Disks/DiskInfo/PlexName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'ViVirtualDiskListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleDailyAdd' => 'MyElements::DpScheduleDailyAdd',
               'DpOssvDirectoryDiscoveredIterStart/ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostUsergroupId' => 'MyTypes::AccessObjectId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DatasetCreate/ApplicationInfo/ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/AssocObjType/PerfAssocObjType' => 'MyTypes::PerfAssocObjType',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/MaximumSize' => 'MyTypes::VolumeSize::_MaximumSize',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'CommentFieldModify/CommentFieldObjectTypes/CommentFieldObjectType' => 'MyTypes::CommentFieldObjectType',
               'GroupListIterNextResult/GroupList/GroupInfo/GroupStatus' => 'MyTypes::ObjStatus',
               'AlarmModify/AlarmInfo/TrapDestinations/TrapDestination/TrapHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledge/EventIdList/EventIdType' => 'MyTypes::EventIdType',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines/GraphLineInfo/SampleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/SnmpAuthenticationLogin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/FailoverScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageList' => 'MyElements::DpAgentPackageList',
               'ApiProxyResult/Response/Results' => 'MyTypes::Response::_Results',
               'HostUserModify/HostUser/HostUserInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'DpScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DpOssvDirectoryAdd/DirectoryPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/DiscardsOut' => 'MyTypes::NetifIpInterfaceInfo::_DiscardsOut',
               'PerfViewListIterEndResult' => 'MyElements::PerfViewListIterEndResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQtreeInfo/VolumeId' => 'MyTypes::ObjId',
               'VolumeListInfoIterStart/IsSisVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserAdd/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupGetDynamicDataSources' => 'MyElements::PerfCounterGroupGetDynamicDataSources',
               'EventDeleteResult' => 'MyElements::EventDeleteResult',
               'EventListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'QtreeListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreViStart/DpViRestoreObjects' => 'MyTypes::ArrayOfDpViRestoreObject',
               'AggregateSpaceManagementBegin/AggregateNameOrId' => 'MyTypes::ObjNameOrId',
               'AlarmDestroy' => 'MyElements::AlarmDestroy',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetIoMetricListInfoIterStart/Month' => 'MyTypes::Month',
               'ReportListInfoIterStartResult/Records' => 'MyElements::ReportListInfoIterStartResult::_Records',
               'DfmServerListDiagnosticInfoResult/DiagInfo/DfmDiagCounterGroup/LastUpdated' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents' => 'MyTypes::ArrayOfSnapshotMemberInfo',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo/RelationshipState' => 'MyTypes::RelationshipState',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TimeTo' => 'MyTypes::AlarmInfo::_TimeTo',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolMembers/ResourcePoolMember/ResourcePoolMemberId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/IsApplicationManagingPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/UpdateServicePort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences' => 'MyTypes::ArrayOfDatasetDynamicReferenceInfo',
               'DpScheduleWeeklySubscheduleModify/EndDayOfWeek' => 'MyElements::DpScheduleWeeklySubscheduleModify::_EndDayOfWeek',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'DpAgentUpgrade' => 'MyElements::DpAgentUpgrade',
               'VfilerCreateResult/FilerId' => 'MyTypes::ObjId',
               'PerfThresholdTemplateDeleteResult/TemplateId' => 'MyElements::PerfThresholdTemplateDeleteResult::_TemplateId',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/BackupScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostRoleModify/HostRole' => 'MyTypes::WrapperOfHostRoleInfo',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModify/HostUser/HostUserInfo/HostUserName' => 'MyTypes::AccessObjectName',
               'EventclassListIterNextResult' => 'MyElements::EventclassListIterNextResult',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/FailureReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'PerfViewAssociatedObjectsListResult' => 'MyElements::PerfViewAssociatedObjectsListResult',
               'DatasetEditRollback/EditLockId' => 'MyElements::DatasetEditRollback::_EditLockId',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks/PerfHealthCheck/Observation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'ReportDesignerListResult/ReportList/ReportListInfo/IsIntervalAllowed' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk' => 'MyTypes::VirtualDisk',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/RelationshipId' => 'MyTypes::ObjId',
               'DpJobListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo' => 'MyTypes::VolumeInfo',
               'PerfThresholdModify2/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'DpThrottleCreate/ThrottleContent/ThrottleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/MaximumSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace',
               'DpThrottleRename/NewThrottleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterEnd' => 'MyElements::VfilerTemplateListInfoIterEnd',
               'DpScheduleHourlyModify/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommitResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource' => 'MyTypes::VolumeResource',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetIoMetricListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DedupeMemberRequestInfo/FullVolumeDedupe' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetListIterStartResult' => 'MyElements::StorageServiceDatasetListIterStartResult',
               'DfmAboutResult/ProtMgrNodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneListInfoIterNextResult' => 'MyElements::TimezoneListInfoIterNextResult',
               'DatasetComputeUsageMetricResult' => 'MyElements::DatasetComputeUsageMetricResult',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAdd/HostUser/HostUserInfo/MaximumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostDelete' => 'MyElements::HostDelete',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceId' => 'MyTypes::ObjId',
               'StorageServiceDatasetModify/OperationType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfo/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterNextResult/Views/PerfView' => 'MyTypes::PerfView',
               'LunListInfoIterNextResult/Luns/LunInfo/IsLunSpaceReserved' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklyModify/WeeklyContent/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'ApiProxy/Request' => 'MyTypes::Request',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldValuesListInfoIterStart/CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/ChartName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/NisDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateAttachObjects/NewObjects/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/LastRunTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetRemoveMember/DatasetMemberParameters/DatasetMemberParameter' => 'MyTypes::DatasetMemberParameter',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult' => 'MyElements::QtreeListInfoIterNextResult',
               'AggregateSpaceManagementCommit/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvApplicationListInfoIterStart/OssvHostNameOrId' => 'MyTypes::OssvHostNameOrId',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheckResult' => 'MyElements::RbacAccessCheckResult',
               'PerfViewListIterStart/IncludeEmptyViews' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreToPrimaryResult/OverwriteResults' => 'MyTypes::ArrayOfOverwriteResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupVersion' => 'MyTypes::DpTimestamp',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterStartResult/Records' => 'MyElements::DpOssvDirectoryRootsIterStartResult::_Records',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsWindowsPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterStartResult' => 'MyElements::ReportGraphListInfoIterStartResult',
               'DpThrottleDependencyResult/ThrottleAssignees' => 'MyTypes::ArrayOfThrottleAssignee',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/Id' => 'MyTypes::DpPolicyConnectionInfo::_Id',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/FileSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DfmNetworkDelete/NetworkAddress' => 'MyTypes::NetworkAddress',
               'DpOssvDirectoryAddResult' => 'MyElements::DpOssvDirectoryAddResult',
               'DatasetModify/IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'NetifIpInterfaceListInfoResult/Interfaces' => 'MyTypes::ArrayOfNetifIpInterfaceInfo',
               'VolumeResize' => 'MyElements::VolumeResize',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
               'PerfThresholdTemplateModify/MemberThresholds' => 'MyTypes::ArrayOfThresholdInfo2',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'DfmBackupScheduleSet/Hour' => 'MyElements::DfmBackupScheduleSet::_Hour',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfClientStatsPurge/EndTime' => 'MyTypes::Timestamp',
               'DpScheduleContentGetResult/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'ReportDesignerScheduleModify/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/DestinationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth/DayOfMonth' => 'MyTypes::DayOfMonth',
               'DatasetMemberDedupeStart' => 'MyElements::DatasetMemberDedupeStart',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdCreateResult' => 'MyElements::PerfThresholdCreateResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'DfmScheduleHourlyAdd/HourlyContent' => 'MyTypes::WrapperOfHourlyInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterEndResult' => 'MyElements::ReportScheduleListInfoIterEndResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/SpaceGuarantee' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostCapabilityListIterEndResult' => 'MyElements::HostCapabilityListIterEndResult',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventOriginatingId' => 'MyTypes::EventInfo::_EventOriginatingId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/DpNodeId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation' => 'MyTypes::RbacOperation',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun' => 'MyTypes::WrapperOfLunResource',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines/GraphLineInfo/SampleSuffix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassAddCustom/EventNames/EventNameInfo' => 'MyTypes::EventNameInfo',
               'DpJobScheduleGetLastChangedResult' => 'MyElements::DpJobScheduleGetLastChangedResult',
               'DfmBackupScheduleGetResult' => 'MyElements::DfmBackupScheduleGetResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeOptions/VolumeOption/OptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreateResult' => 'MyElements::ResourcepoolCreateResult',
               'DpPolicyGetDefaultPropertyValuesResult/MirrorScheduleName' => 'MyTypes::ObjName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId' => 'MyTypes::QtreeNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentStoragesystemListInfoIterEnd' => 'MyElements::DpAgentStoragesystemListInfoIterEnd',
               'EventListIterStart/IsHistory' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterData/InstanceCounterInfo/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'PerfThresholdTemplateModify/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyDelete/ItemId' => 'MyElements::DfmScheduleMonthlyDelete::_ItemId',
               'DpDashboardGetProtectedDataCountsResult/ProtectedVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_ProtectedVolumeCount',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/HostAddress' => 'MyTypes::IpAddress',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/Resourcepools/DatasetResourcepoolInfo/ResourcepoolName' => 'MyTypes::ObjName',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/TargetPortName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'ReportOutputListInfoIterStart/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos' => 'MyTypes::ArrayOfDpBackupIdInfo',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/StorageService' => 'MyTypes::WrapperOfStorageServiceResource',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterNextResult/CifsDomainList/CifsDomainInfo' => 'MyTypes::CifsDomainInfo',
               'DfmRelatedObjectsListInfoResult/ParentGroupList/ParentGroup/FullName' => 'MyTypes::ObjFullName',
               'GroupSetOptions/GroupOptionInfo/SrmMaxOldMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldMtimeFiles',
               'DpJobScheduleListIterNextResult/ScheduledJobs' => 'MyTypes::ArrayOfDpScheduledJob',
               'AggregateListInfoIterStart/VolumesToMigrate/ObjectNameOrId' => 'MyTypes::ObjectNameOrId',
               'HostModify/HostModifyInfo/HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpRelationshipModify/RelationshipId' => 'MyTypes::ObjId',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/DayList/DayInfo' => 'MyTypes::DayInfo',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressNfsexportInfo/QtreeName' => 'MyTypes::ObjFullName',
               'RbacRoleModify' => 'MyElements::RbacRoleModify',
               'DpPolicyEditBegin' => 'MyElements::DpPolicyEditBegin',
               'DpRestoreToPrimary/CheckOverwrite' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyListIterStartResult/Records' => 'MyElements::ApplicationPolicyListIterStartResult::_Records',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/EventId' => 'MyTypes::DpJobProgressEventInfo::_EventId',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo' => 'MyTypes::MetricDatasetNodeInfo',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo' => 'MyTypes::NetworkSnmpCredentialInfo',
               'DpBackupVersionListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks' => 'MyTypes::ArrayOfVirtualDisk',
               'UserRecentReportListInfoIterNext' => 'MyElements::UserRecentReportListInfoIterNext',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets' => 'MyTypes::ArrayOfDatasetInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostListInfoIterNextResult/Hosts/HostInfo/CifsDomainInfo/CifsDomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPath/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupVersionListIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportScheduleModify/ReportScheduleInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo' => 'MyTypes::DatasetSpaceMetricInfo',
               'SnapshotListInfoIterNextResult' => 'MyElements::SnapshotListInfoIterNextResult',
               'DfmScheduleDailyAdd/DailyContent/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DpRelationshipListInfoIterStartResult' => 'MyElements::DpRelationshipListInfoIterStartResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetId' => 'MyTypes::VolumeInfo::_DatasetId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'PerfViewListIterNextResult/Views/PerfView/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo/Day' => 'MyTypes::DayInfo::_Day',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo' => 'MyTypes::HypervBackupScheduleSettingsInfo',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/FilerName' => 'MyTypes::ObjFullName',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostUsergroupName' => 'MyTypes::UsergroupName',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DynamicReferenceSubtype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentConfigure/VcenterPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts' => 'MyTypes::ArrayOfPerfChart',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId' => 'MyTypes::WrapperOfLunNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpAgentRegister/NameOrIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUsergroupNames/HostUsergroupName' => 'MyTypes::HostUsergroupName',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/GroupMemberAttributes/GroupMemberAttribute/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo' => 'MyTypes::EventClassInfo',
               'GraphListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo/VolumeId' => 'MyTypes::ObjId',
               'DfmScheduleWeeklyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'DpThrottleItemDelete/ThrottleItemId' => 'MyElements::DpThrottleItemDelete::_ThrottleItemId',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'RbacRoleCapabilityRemove/Operation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommit' => 'MyElements::DatasetEditCommit',
               'VolumeListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'UserFavoriteReportListInfoIterNextResult/Records' => 'MyElements::UserFavoriteReportListInfoIterNextResult::_Records',
               'PerfViewListIterNextResult/Views/PerfView/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreViStart/DpViRestoreObjects/DpViRestoreObject/DpViObjectRestoreSettings/DpViVmwareObjectRestoreSettings' => 'MyTypes::DpViVmwareObjectRestoreSettings',
               'EventclassListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/ProtectionPolicyName' => 'MyTypes::ObjName',
               'DfmRelatedObjectsListInfoResult/ParentObjectList' => 'MyTypes::ArrayOfParentObject',
               'HostAgentOssvServiceStartResult' => 'MyElements::HostAgentOssvServiceStartResult',
               'RbacOperationInfoListResult' => 'MyElements::RbacOperationInfoListResult',
               'DpBackupVersionModify/VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DpRestoreToPrimaryResult/SpaceStatusResults/SpaceStatusResult/ReqSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'MigrateFix/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo/DedupeProgress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/HasProtectionPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmModify/AlarmInfo/RepeatInterval' => 'MyTypes::AlarmInfo::_RepeatInterval',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo' => 'MyTypes::ArrayOfDatasetSpaceInfo',
               'RbacRoleModify/RoleNameNew' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'DfmScheduleWeeklySubscheduleDelete/ItemId' => 'MyElements::DfmScheduleWeeklySubscheduleDelete::_ItemId',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'EventclassListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/AdvancedOptions' => 'MyTypes::ArrayOfAdvancedOptionInfo',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo' => 'MyTypes::PerfObjectCounterInfo',
               'GroupSetOptions/GroupOptionInfo/SrmMaxOldAtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldAtimeFiles',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/Snapshots/Snapshot/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterNext/Maximum' => 'MyElements::DpOssvDirectoryBrowseIterNext::_Maximum',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ScheduleId' => 'MyTypes::ReportScheduleContentInfo::_ScheduleId',
               'DfmScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DfmObjectsGetStatus/Objects/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetDrDatasetCounts/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'PerfGetCounterData/TimeFilter' => 'MyTypes::TimeFilter',
               'DfmScheduleModify/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'PerfCounterGroupGetData/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetEditCommit/EditLockId' => 'MyElements::DatasetEditCommit::_EditLockId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Dataset' => 'MyTypes::WrapperOfDatasetResource',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'PerfCounterGroupStart/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportCategoryList/CategoryNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/ResourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportScheduleListInfoIterStartResult/Records' => 'MyElements::ReportScheduleListInfoIterStartResult::_Records',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/ThresholdInterval' => 'MyTypes::ThresholdInfo::_ThresholdInterval',
               'ApiProxy/Timeout' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'MigrateStart/VolumeAggregateMap/VolumeAggregatePair/Aggregate' => 'MyTypes::ObjNameOrId',
               'HostAgentOssvServiceStop' => 'MyElements::HostAgentOssvServiceStop',
               'EventStatusChangeListIterStart/MaxEvents' => 'MyElements::EventStatusChangeListIterStart::_MaxEvents',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'ProvisioningPolicyEditRollback/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/IsPolicyReadonly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterStart/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'ApplicationPolicyListIterStart' => 'MyElements::ApplicationPolicyListIterStart',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'AggregateSpaceManagementBegin' => 'MyElements::AggregateSpaceManagementBegin',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/ResourceTag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DynamicReferenceStatus' => 'MyTypes::ObjStatus',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo/LdapServer/LdapServerPort' => 'MyTypes::LdapServer::_LdapServerPort',
               'DfmScheduleRename/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData' => 'MyElements::PerfGetCounterData',
               'LdapServerAdd/LdapServer' => 'MyTypes::LdapServer',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleModify/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportGraphListInfoIterEndResult' => 'MyElements::ReportGraphListInfoIterEndResult',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetChangeDrState/DrState' => 'MyTypes::DrState',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DpRestoreToPrimary/Paths/DpPathInfo/RestoreConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'LunListInfoIterNextResult/Luns/LunInfo/HostId' => 'MyTypes::ObjId',
               'HostAddOssvResult' => 'MyElements::HostAddOssvResult',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterStartResult/Records' => 'MyElements::CommentFieldListInfoIterStartResult::_Records',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo/DefaultUserQuota' => 'MyTypes::ProgressQuotaInfo::_DefaultUserQuota',
               'DpAgentRegister/AdminPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostName' => 'MyTypes::ObjName',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/RootObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerStorageInfo' => 'MyTypes::ProgressVfilerStorageInfo',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSize' => 'MyTypes::AggregateSize',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo/DestinationAggregateNameOrId' => 'MyTypes::ObjNameOrId',
               'HostRoleCreate/HostRole/HostRoleInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'ApiProxy/Target' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions/SpaceCondition/Severity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'PerfGetCounterDependentsResult/Views/PerfView/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobId' => 'MyTypes::DpJobInfo::_JobId',
               'DpOssvDirectoryAddResult/DirectoryId' => 'MyElements::DpOssvDirectoryAddResult::_DirectoryId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCopy' => 'MyElements::VfilerTemplateCopy',
               'DfmScheduleWeeklySubscheduleDeleteResult' => 'MyElements::DfmScheduleWeeklySubscheduleDeleteResult',
               'DpAgentPackageAdd' => 'MyElements::DpAgentPackageAdd',
               'DpScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'VfilerSetup/CifsDomainUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocation/Paths/DpBackupPathInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyDelete/MonthlyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/Records' => 'MyElements::DpThrottleListInfoIterNextResult::_Records',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DpScheduleWeeklySubscheduleAddResult/ItemId' => 'MyElements::DpScheduleWeeklySubscheduleAddResult::_ItemId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/HourlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionCount',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/ResourceTag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/TemplateDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'TimezoneListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/EnvironmentVariableList/EnvironmentVariableInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerSetup/IpBindings/IpBindingInfo/IpAddress' => 'MyTypes::IpAddress',
               'PerfCounterGroupModify/CounterGroup' => 'MyTypes::WrapperOfPerfCounterGroup',
               'DatasetIoMetricListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'DiskListInfoIterNextResult' => 'MyElements::DiskListInfoIterNextResult',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo' => 'MyTypes::OssvApplicationInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsEnableWriteGuaranteeChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModify/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'Fault/detail' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklySubscheduleDelete' => 'MyElements::DpScheduleWeeklySubscheduleDelete',
               'HostDomainuserListIterStart/HostDomainuserNameOrIdOrSid' => 'MyTypes::DomainuserNameOrIdOrSid',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets/DpDatasetLagInfo' => 'MyTypes::DpDatasetLagInfo',
               'VolumeDedupeResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationSynopsis' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyId' => 'MyTypes::ObjId',
               'ResourcepoolDestroy' => 'MyElements::ResourcepoolDestroy',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeOptions' => 'MyTypes::ArrayOfVolumeOption',
               'RbacAccessCheckResult/GlobalUsergroupStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRolePush/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmObjectsGetStatus/Objects' => 'MyTypes::ArrayOfObjNameOrId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'VfilerSetupResult' => 'MyElements::VfilerSetupResult',
               'DpRelationshipListInfoIterStart/RelationshipType' => 'MyTypes::RelationshipType',
               'DpAgentPackageAddResult' => 'MyElements::DpAgentPackageAddResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents' => 'MyTypes::ArrayOfSnapshotMemberInfo',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterStartResult' => 'MyElements::DpBackupContentListIterStartResult',
               'DfmBackupScheduleSetResult' => 'MyElements::DfmBackupScheduleSetResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdListInfoIterNextResult/AttributesList' => 'MyTypes::ArrayOfThresholdInfo',
               'PerfAssocViewListIterNextResult' => 'MyElements::PerfAssocViewListIterNextResult',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyDestroyResult' => 'MyElements::ApplicationPolicyDestroyResult',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/EndMinute' => 'MyTypes::ThrottleItemInfo::_EndMinute',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'DfmScheduleListResult/ScheduleList/ScheduleIdInfo' => 'MyTypes::ScheduleIdInfo',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo' => 'MyTypes::ThrottleItemInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/SourceVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmMonitorTimestampListResult/DfmMonitoringTimestamps/DfmMonitoringTimestamp' => 'MyTypes::DfmMonitoringTimestamp',
               'AlarmCreateResult/AlarmId' => 'MyElements::AlarmCreateResult::_AlarmId',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/VfilerTemplateId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/MaximumLunsPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools/ResourcepoolNameOrId' => 'MyTypes::ResourcepoolNameOrId',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/CumulativePercentageOfTotalBlocks' => 'MyTypes::SnapshotInfo::_CumulativePercentageOfTotalBlocks',
               'DpOssvDirectoryAdd' => 'MyElements::DpOssvDirectoryAdd',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/DedupeSpaceSavingsPercentage' => 'MyTypes::VolumeDedupeInfo::_DedupeSpaceSavingsPercentage',
               'StorageServiceDestroyResult' => 'MyElements::StorageServiceDestroyResult',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/ConnectionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/VirtualCenterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupStart/BackupType' => 'MyTypes::BackupType',
               'DatasetComputeUsageMetric/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'IfcListInfoIterEnd' => 'MyElements::IfcListInfoIterEnd',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/OssvApplicationRestoreDestinationList/OssvApplicationRestoreDestinationInfo' => 'MyTypes::OssvApplicationRestoreDestinationInfo',
               'DpThrottleCreate/ThrottleContent/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserModify/HostUser/HostUserInfo/HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
               'HostModify/HostModifyInfo' => 'MyTypes::HostModifyInfo',
               'GraphDataListInfo/PrimaryObject' => 'MyTypes::ObjNameOrId',
               'DpRestoreToPrimary/Paths' => 'MyTypes::ArrayOfDpPathInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressHostServiceInfo/HostServiceId' => 'MyTypes::ObjId',
               'AggregateSpaceManagementBegin/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleRename' => 'MyElements::DpThrottleRename',
               'DpScheduleDailyAddResult' => 'MyElements::DpScheduleDailyAddResult',
               'ReportScheduleDelete/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleAdd/EndDayOfWeek' => 'MyElements::DfmScheduleWeeklySubscheduleAdd::_EndDayOfWeek',
               'HostGetDefaultsResult' => 'MyElements::HostGetDefaultsResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Dataset/DatasetResource' => 'MyTypes::DatasetResource',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/SanContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolMemberListInfoIterStart/ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyDelete/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetComputeUsageMetric' => 'MyElements::DatasetComputeUsageMetric',
               'RbacAdminRoleRemove' => 'MyElements::RbacAdminRoleRemove',
               'HostCapabilityListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyDelete/ItemId' => 'MyElements::DfmScheduleHourlyDelete::_ItemId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyEditBeginResult' => 'MyElements::DpPolicyEditBeginResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo' => 'MyTypes::ApplicationInfo',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventSourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyId' => 'MyTypes::ObjId',
               'LunListInfoIterNextResult/Luns/LunInfo/LunSize' => 'MyTypes::LunInfo::_LunSize',
               'StorageServiceDatasetProvision/RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterNextResult',
               'UserRecentReportListInfoIterStartResult' => 'MyElements::UserRecentReportListInfoIterStartResult',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterNextResult' => 'MyElements::StorageServiceDatasetListIterNextResult',
               'DpScheduleModify/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'ResourcepoolListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostUserDeleteResult' => 'MyElements::HostUserDeleteResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunMapInfo/IgroupId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostCreateNdmpuser/NdmpUsername' => 'MyTypes::NdmpUsername',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationVolumeId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/SourceFilerName' => 'MyTypes::ObjFullName',
               'GroupMemberListIterNextResult' => 'MyElements::GroupMemberListIterNextResult',
               'PerfViewListIterNextResult/Records' => 'MyElements::PerfViewListIterNextResult::_Records',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource' => 'MyTypes::VfilerTemplateResource',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentPlugins/DpAgentPluginInfo' => 'MyTypes::DpAgentPluginInfo',
               'SnapshotListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceName' => 'MyTypes::ObjName',
               'PerfCounterGroupDestroy/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupLunId' => 'MyTypes::LunIgroupInfo::_IgroupLunId',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'HostRoleCreate/HostRole/HostRoleInfo/Description' => 'MyTypes::AccessObjectDescription',
               'DatasetMemberDeleteSnapshots/EditLockId' => 'MyElements::DatasetMemberDeleteSnapshots::_EditLockId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'RbacRoleAdminInfoListResult' => 'MyElements::RbacRoleAdminInfoListResult',
               'RbacAccessCheck' => 'MyElements::RbacAccessCheck',
               'MigrateRollback/MigrateOffline' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupListIterNext/Maximum' => 'MyElements::GroupListIterNext::_Maximum',
               'DpJobProgressEventListIterStart/History' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementAddOperation/SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementAddOperation::_SpaceManagementSessionId',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes' => 'MyTypes::StorageServiceNodeAttributes',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupListInfo/CustomOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo' => 'MyTypes::ProvisionRequestInfo',
               'HostUserModifyPasswordResult' => 'MyElements::HostUserModifyPasswordResult',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'MigrateCleanup/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleEnable/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportOutputListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpOssvDirectoryModify/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'AlarmModify/AlarmInfo/TrapDestinations/TrapDestination/TrapCommunity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'DpRestoreToPrimaryResult/OverwriteResults/OverwriteResult/OverwriteStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupMemberListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/PersistentMigratedRoutes' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmRelatedObjectsListInfoResult/ChildCountList/ChildCount' => 'MyTypes::ChildCount',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/CreateNewVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Group/GroupResource/GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateName' => 'MyTypes::ObjName',
               'DpAgentStoragesystemListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/UsedSpace' => 'MyTypes::AggregateSpaceInfo::_UsedSpace',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId' => 'MyTypes::QtreeNameOrId',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolModify/Resourcepool' => 'MyTypes::WrapperOfResourcepoolInfo',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DpBackupVersionModify/IsComplete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionDeleteResult' => 'MyElements::DpBackupVersionDeleteResult',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyEditRollbackResult' => 'MyElements::ApplicationPolicyEditRollbackResult',
               'RbacOperationAdd' => 'MyElements::RbacOperationAdd',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapvaultTransferJobData/ConnectionId' => 'MyTypes::DpSnapvaultTransferJobData::_ConnectionId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobContextApplicationResourceNamespaces' => 'MyTypes::ArrayOfApplicationResourceNamespace',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DatasetMemberListInfoIterStart/StoragesetNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'MigrateCleanupResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'MigrateRollback/MaxCutoverTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpThrottleListInfoIterNextResult' => 'MyElements::DpThrottleListInfoIterNextResult',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetData/Instance' => 'MyTypes::WrapperOfPerfCounterInstance',
               'HostSetOption/HostNameOrId' => 'MyTypes::HostNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource' => 'MyTypes::QtreeResource',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobState' => 'MyTypes::DpJobState',
               'DatasetAddResourcepoolResult' => 'MyElements::DatasetAddResourcepoolResult',
               'PerfThresholdTemplateDeleteResult' => 'MyElements::PerfThresholdTemplateDeleteResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/TargetObjectId' => 'MyTypes::ReportScheduleContentInfo::_TargetObjectId',
               'DfmNetworkAddResult/NetworkId' => 'MyTypes::NetworkId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'ReportDesignerScheduleAdd/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'DatasetModify/SnapshotNameFormat' => 'MyTypes::SnapshotNameFormat',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerListResult/ReportList/ReportListInfo' => 'MyTypes::ReportListInfo',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/VolumeName' => 'MyTypes::ObjName',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddMember/DatasetMemberParameters/DatasetMemberParameter/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfAssocViewListIterEnd' => 'MyElements::PerfAssocViewListIterEnd',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyDestroy/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdModify/Attributes/ThresholdInfo/ThresholdInterval' => 'MyTypes::ThresholdInfo::_ThresholdInterval',
               'DpJobScheduleListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleInfoListResult/AdminList/RbacAdminOrUsergroup/AdminOrUsergroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/SnapshotId' => 'MyTypes::SnapshotInfo::_SnapshotId',
               'DatasetEditCommitResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateId' => 'MyTypes::ObjId',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo' => 'MyTypes::DpFileInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobProgress' => 'MyTypes::DpJobProgress',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/TrapDestinations/TrapDestination/TrapPort' => 'MyTypes::TrapDestination::_TrapPort',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostUsergroupId' => 'MyTypes::AccessObjectId',
               'HostAddLicense/HostLicense' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryModifyResult' => 'MyElements::DpOssvDirectoryModifyResult',
               'DfmScheduleDailyDelete/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'HostDomainuserAdd' => 'MyElements::HostDomainuserAdd',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolStatus' => 'MyTypes::ObjStatus',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertType' => 'MyTypes::ConformanceAlertType',
               'MigrateVolumeResult/MigrationJobs/MigrationJobInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyEditBegin' => 'MyElements::ApplicationPolicyEditBegin',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberUsedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo' => 'MyTypes::ResourcepoolInfo',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolIsProvisionable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleContentGetResult/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts' => 'MyTypes::ArrayOfPerfChart',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd/ReportScheduleInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'MigrateRollback/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'RbacRoleDisinherit/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolModifyMember/ResourceTag' => 'MyTypes::ResourceTag',
               'PerfViewGetData/DynamicObjectInfo' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryName' => 'MyTypes::ObjName',
               'PerfObjectInstanceListIterEndResult' => 'MyElements::PerfObjectInstanceListIterEndResult',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ReportScheduleAddResult/ReportScheduleId' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek' => 'MyTypes::ArrayOfDayOfWeek',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools' => 'MyTypes::ArrayOfResourcepoolInfo',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfThresholdCreate2/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressBackupInfo/BackupVersion' => 'MyTypes::DpTimestamp',
               'DpRestoreToPrimaryResult/SpaceStatusResults/SpaceStatusResult/DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostUsergroupDelete' => 'MyElements::HostUsergroupDelete',
               'DpAgentModify/HostserviceModifyInfo/AccessProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry' => 'MyTypes::DatasetMapEntry',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/IsDpNodeEffectivePrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ClientRegistryGetResult/Options/ClientOptionInfo/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlySubscheduleUnset/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyModify/DailyContent/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DpAgentPackageList/PackageNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheckResult/Result' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterStart' => 'MyElements::DatasetDynamicReferenceListInfoIterStart',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/IoMeasurement/DataWritten' => 'MyTypes::IoMeasurement::_DataWritten',
               'HostCapabilityListIterStartResult' => 'MyElements::HostCapabilityListIterStartResult',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections' => 'MyTypes::ArrayOfDpPolicyConnectionInfo',
               'PerfCounterGroupListIterNextResult/Records' => 'MyElements::PerfCounterGroupListIterNextResult::_Records',
               'DpScheduleHourlyDeleteResult' => 'MyElements::DpScheduleHourlyDeleteResult',
               'DpPolicyGetDefaultPropertyValuesResult/BackupScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/OldDpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'ViVirtualMachineListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo' => 'MyTypes::ResourcepoolInfo',
               'ReportScheduleListInfoIterStart/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo' => 'MyTypes::HostRoleInfo',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/StorageServiceName' => 'MyTypes::ObjName',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
               'DpScheduleWeeklySubscheduleModify/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModify/AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/IsDeprecated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserModify/HostUser/HostUserInfo/HostId' => 'MyTypes::ObjId',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/AfsUsedPerDay' => 'MyTypes::VolumeSize::_AfsUsedPerDay',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentUnregisterResult' => 'MyElements::DpAgentUnregisterResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo' => 'MyTypes::VmwareBackupScheduleSettingsInfo',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'ResourcepoolAddMemberResult' => 'MyElements::ResourcepoolAddMemberResult',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VhdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList' => 'MyTypes::ArrayOfDayInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo' => 'MyTypes::ProgressVolumeDedupeInfo',
               'DpAgentStoragesystemListInfoIterNext' => 'MyElements::DpAgentStoragesystemListInfoIterNext',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentUnregister/DpAgentNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyAdd/DailyContent' => 'MyTypes::WrapperOfDailyInfo',
               'PerfCopyCounterConfiguration/SourceHostNameOrId' => 'MyTypes::HostNameOrId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'DpBackupGetLocationResult' => 'MyElements::DpBackupGetLocationResult',
               'CifsDomainListInfoIterNextResult' => 'MyElements::CifsDomainListInfoIterNextResult',
               'ClientRegistrySet/Options/ClientOptionInfo/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials' => 'MyTypes::ArrayOfNetworkSnmpCredentialInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'DpRestoreViStart/DpViRestoreSettings/DpViVmwareRestoreSettings/EsxServerNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCollectClientOperationStatisticsResult/Errors/ClientStatError/NfsError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'UserRecentReportListInfoIterNext/Maximum' => 'MyElements::UserRecentReportListInfoIterNext::_Maximum',
               'ReportDesignerScheduleModify/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetBeginFailoverScriptTestResult/JobId' => 'MyElements::DatasetBeginFailoverScriptTestResult::_JobId',
               'PerfThresholdTemplateAttachObjects' => 'MyElements::PerfThresholdTemplateAttachObjects',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo' => 'MyTypes::HypervBackupScheduleSettingsInfo',
               'UserRecentReportListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/IsNonDisruptiveRestoreCompatible' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateComplete/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryBrowseIterStart' => 'MyElements::DpOssvDirectoryBrowseIterStart',
               'DfmScheduleWeeklyAddResult' => 'MyElements::DfmScheduleWeeklyAddResult',
               'GroupGetOptionsResult/GroupOptionInfo/SrmMaxNewMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxNewMtimeFiles',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupListIterNextResult/GroupList/GroupInfo' => 'MyTypes::GroupInfo',
               'DatasetListInfoIterStart/IncludeConformanceCheckResults' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterStart/ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNext' => 'MyElements::DatasetMissingMemberListInfoIterNext',
               'DpRestoreToNewPathResult/OverwriteResults' => 'MyTypes::ArrayOfOverwriteResult',
               'DpScheduleMonthlySubscheduleUnsetResult' => 'MyElements::DpScheduleMonthlySubscheduleUnsetResult',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedApplicationResources/ApplicationResourceInfo' => 'MyTypes::ApplicationResourceInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationAggregateId' => 'MyTypes::ObjId',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'AlarmListInfoIterNextResult/AlarmList' => 'MyTypes::ArrayOfAlarmInfo',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/PhysicalUsedDataSpace' => 'MyTypes::SpaceMeasurement::_PhysicalUsedDataSpace',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/CurrentRetentionPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleCreate/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'DfmAboutResult/LicensedFeatures/Feature/IsLicenseExpired' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupStopResult' => 'MyElements::PerfCounterGroupStopResult',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualCenterReference/VirtualCenterId' => 'MyTypes::ObjId',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Host/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId' => 'MyTypes::WrapperOfQtreeNameOrId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSize/SizeAvailable' => 'MyTypes::AggregateSize::_SizeAvailable',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AggregateListInfoIterNextResult' => 'MyElements::AggregateListInfoIterNextResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/MaximumSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/NumberRecords' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ErrorMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'RbacRoleModify/RoleNameOrIdOld' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'DatasetDynamicReferenceListInfoIterEnd' => 'MyElements::DatasetDynamicReferenceListInfoIterEnd',
               'ClientRegistryDestroy/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterNext' => 'MyElements::DatasetIoMetricListInfoIterNext',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ObjectName' => 'MyTypes::ObjFullName',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Group/GroupResource/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUsergroupIds/HostUsergroupId' => 'MyTypes::HostUsergroupId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'TimezoneListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'EventAcknowledgeResult/EventsAcknowledgedList' => 'MyTypes::ArrayOfEventActionInfo',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/DatasetName' => 'MyTypes::ObjName',
               'VfilerTemplateListInfoIterStartResult/Records' => 'MyElements::VfilerTemplateListInfoIterStartResult::_Records',
               'RbacAccessCheck/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupDestroy/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DpRelationshipModifyResult' => 'MyElements::DpRelationshipModifyResult',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleRemoveResult' => 'MyElements::RbacAdminRoleRemoveResult',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/TrapDestinations' => 'MyTypes::ArrayOfTrapDestination',
               'DpAgentListInfoIterNext/Maximum' => 'MyElements::DpAgentListInfoIterNext::_Maximum',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/PrivilegeLevel' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDestroy/CancelEditSessions' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DpBackupStart/HypervBackupSettingsInfo' => 'MyTypes::WrapperOfHypervBackupScheduleSettingsInfo',
               'PerfDiagTroubleshoot/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ApplicationInfo' => 'MyTypes::ApplicationInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsSnapvaultSecondary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleListIterStartResult/Records' => 'MyElements::HostRoleListIterStartResult::_Records',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/SanContainerSettings/ThinProvisioningConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/MaximumY' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'EventListIterStart' => 'MyElements::EventListIterStart',
               'UserRecentReportListInfoIterStart' => 'MyElements::UserRecentReportListInfoIterStart',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/IsPolicyReadonly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/StorageServiceId' => 'MyTypes::ObjId',
               'ResourcepoolCreateResult/ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems/StorageSystemInfo' => 'MyTypes::StorageSystemInfo',
               'PerfViewGetData/SampleRate' => 'MyElements::PerfViewGetData::_SampleRate',
               'LdapServerDelete/LdapServer/LdapServerAddr' => 'MyTypes::NetworkAddress',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/Throughput' => 'MyTypes::ThrottleItemInfo::_Throughput',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostName' => 'MyTypes::ObjName',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'ReportDesignerScheduleModify/ReportScheduleInfo/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapmirrorTransferJobData/ConnectionId' => 'MyTypes::DpSnapmirrorTransferJobData::_ConnectionId',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterEnd' => 'MyElements::ReportScheduleListInfoIterEnd',
               'DfmSnmpSettingAdd/SnmpCommunityName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupMetadata/DfmMetadata/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDependencyResult/ScheduleAssignees' => 'MyTypes::ArrayOfScheduleAssignee',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines' => 'MyTypes::ArrayOfPerfLine',
               'PerfCounterGroupStop/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetDataResult/CounterData' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'AggregateListInfoIterStart/IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddMemberByDynamicReference/EditLockId' => 'MyElements::DatasetAddMemberByDynamicReference::_EditLockId',
               'DpScheduleDailyAdd/DailyContent/DailyInfo' => 'MyTypes::DailyInfo',
               'VfilerCreateResult/RootVolumeName' => 'MyTypes::ObjFullName',
               'DpAgentConfigure/StorageSystemsConfiguration/StorageSystemConfiguration/LoginProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolAddMember' => 'MyElements::ResourcepoolAddMember',
               'HostUsergroupPush/HostUsergroupNameOrId' => 'MyTypes::UsergroupNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Policy/PolicyResource' => 'MyTypes::PolicyResource',
               'DpScheduleDependencyResult/ScheduleAssignees' => 'MyTypes::ArrayOfScheduleAssignee',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetAccessDetails/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/BackupTransferNeeded' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/DayList/DayInfo/Day' => 'MyTypes::DayInfo::_Day',
               'PerfObjectDependentCounterListInfo/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeRenameResult' => 'MyElements::QtreeRenameResult',
               'MigrateStart/IpBindings/IpBindingInfo' => 'MyTypes::IpBindingInfo',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DatasetSet/IsEnableWriteGuaranteeChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModify/StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminListInfoIterNextResult/Admins/AdminInfo/PagerAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupMemberListIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'AlarmListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult' => 'MyElements::PerfCounterGroupListInfoResult',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'DpBackupStart/HypervBackupSettingsInfo/HypervBackupScheduleSettingsInfo' => 'MyTypes::HypervBackupScheduleSettingsInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/VfilerId' => 'MyTypes::ObjId',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassAddCustom/EventNames' => 'MyTypes::ArrayOfEventNameInfo',
               'EventListIterStart/EventSeverities' => 'MyTypes::ArrayOfObjStatus',
               'ProvisioningPolicyListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModifyPassword/NewPassword' => 'MyTypes::HostUserPassword',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource' => 'MyTypes::VfilerNetworkResource',
               'HostUserAdd/HostUser/HostUserInfo/HostName' => 'MyTypes::ObjName',
               'DatasetEditCommit/AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'DpPolicyModify' => 'MyElements::DpPolicyModify',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Size' => 'MyTypes::ProvisionMemberRequestInfo::_Size',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/NfsExportPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterNext' => 'MyElements::CommentFieldListInfoIterNext',
               'DfmScheduleDailyModify/DailyContent/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'DpAgentListUpgradeCandidates' => 'MyElements::DpAgentListUpgradeCandidates',
               'PerfDiagTroubleshoot/Duration' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolGetDefaultsResult/ResourcepoolDefaults/ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolDefaults::_ResourcepoolNearlyFullThreshold',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMetadata/DfmMetadataField' => 'MyTypes::DfmMetadataField',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'PerfViewObjectAssociationAdd/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo' => 'MyTypes::SnapshotMemberInfo',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools/ResourcepoolNameOrId' => 'MyTypes::ResourcepoolNameOrId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Filer' => 'MyTypes::WrapperOfFilerResource',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostId' => 'MyTypes::HostId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CifsDomainListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/AdministrativeHostIpAddress' => 'MyTypes::IpAddress',
               'DpBackupVersionModify/RetentionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'PerfAssocViewListIterNextResult/Views/PerfView/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostDomainuserListIterStartResult/Records' => 'MyElements::HostDomainuserListIterStartResult::_Records',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'VolumeModifyResult' => 'MyElements::VolumeModifyResult',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/SanContainerSettings' => 'MyTypes::SanContainerSettings',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRelationshipListInfoIterStart/ConnectionId' => 'MyElements::DpRelationshipListInfoIterStart::_ConnectionId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupId' => 'MyTypes::DpBackupInfo::_BackupId',
               'LunListInfoIterNextResult/Luns/LunInfo/ObjectPerfStatus' => 'MyTypes::ObjStatus',
               'ReportDesignerScheduleDeleteResult' => 'MyElements::ReportDesignerScheduleDeleteResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/ApplicationInfo/IsApplicationResponsibleForPrimaryBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'DfmUserPrivGet' => 'MyElements::DfmUserPrivGet',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/ActualVolumeSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterNextResult/Favorites/UserReportInfo/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/ResizeVolumeRequestInfo' => 'MyTypes::ResizeVolumeRequestInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/ScheduleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ClientRegistrySet/Options' => 'MyTypes::ArrayOfClientOptionInfo',
               'DatasetAddMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfCopyCounterConfigurationResult/CopyResult/DestinationHostInfo' => 'MyTypes::DestinationHostInfo',
               'DatasetRemoveResourcepool/ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingDelete/NetworkAddress' => 'MyTypes::NetworkAddress',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Group/GroupResource/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminListInfoIterNext' => 'MyElements::RbacAdminListInfoIterNext',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/IoMeasurement/DataRead' => 'MyTypes::IoMeasurement::_DataRead',
               'DpRelationshipListInfoIterStart/RelationshipId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'EventclassDeleteCustom/EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterStartResult' => 'MyElements::ViVirtualCenterListInfoIterStartResult',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo' => 'MyTypes::HostDpInfo',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostId' => 'MyTypes::ObjId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DfmObjectRefresh/ChildType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserPush/HostDomainuserNameOrIdOrSid' => 'MyTypes::DomainuserNameOrIdOrSid',
               'HostCreateNdmpuserResult' => 'MyElements::HostCreateNdmpuserResult',
               'FcpTargetListInfoIterEnd' => 'MyElements::FcpTargetListInfoIterEnd',
               'PerfViewListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors' => 'MyTypes::ArrayOfHypervisor',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterStart/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DpBackupGetLocation/BackupId' => 'MyElements::DpBackupGetLocation::_BackupId',
               'DpRelationshipListInfoIterNext' => 'MyElements::DpRelationshipListInfoIterNext',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo/BytesTransferred' => 'MyTypes::DpProgressSnapmirrorInfo::_BytesTransferred',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'PerfCounterGroupModify/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyAdd' => 'MyElements::DpScheduleWeeklyAdd',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostId' => 'MyTypes::ObjId',
               'DatasetListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeFullThreshold' => 'MyTypes::VolumeInfo::_VolumeFullThreshold',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'AggregateListInfoIterEndResult' => 'MyElements::AggregateListInfoIterEndResult',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/Records' => 'MyElements::DatasetSpaceMetricListInfoIterNextResult::_Records',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DynamicReferenceName' => 'MyTypes::ObjName',
               'RbacRoleDisinherit/DisinheritAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolMemberCount' => 'MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeId' => 'MyTypes::ObjId',
               'DpAgentPackageDelete/PackageNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/EventTypeFilterList/EventTypeFilter/EventFilter' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNext' => 'MyElements::ReportListInfoIterNext',
               'DpThrottleRenameResult' => 'MyElements::DpThrottleRenameResult',
               'DpScheduleContentGet' => 'MyElements::DpScheduleContentGet',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyEditCommitResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/LagWarningThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagWarningThreshold',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'IfcListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/MirrorScheduleId' => 'MyTypes::ObjId',
               'DpOssvDirectoryDiscoveredIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupStart' => 'MyElements::DfmBackupStart',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ViDatacenterListInfoIterNext/Maximum' => 'MyElements::ViDatacenterListInfoIterNext::_Maximum',
               'DpDashboardGetLaggedRelationships/IsExternalRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupDeleteMember' => 'MyElements::GroupDeleteMember',
               'DatasetExclusionListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPathResult/SpaceStatusResults/SpaceStatusResult/ReqSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'HostListInfoIterNextResult/Hosts/HostInfo/Licenses/License' => 'MyTypes::License',
               'DatasetExclusionListInfoIterNextResult/ExclusionList/ExcludedObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList' => 'MyTypes::ArrayOfPerfObjectCounterInfo',
               'DpAgentModify' => 'MyElements::DpAgentModify',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/HostServiceBackupId' => 'MyTypes::HostServiceUniqueId',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterStart' => 'MyElements::DiskListInfoIterStart',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModifyResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'ViVirtualCenterListInfoIterNextResult' => 'MyElements::ViVirtualCenterListInfoIterNextResult',
               'AggregateSpaceManagementBeginResult' => 'MyElements::AggregateSpaceManagementBeginResult',
               'DatasetExclusionListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetDynamicReferenceListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/Snapshots/Snapshot/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldValuesListInfoIterEnd' => 'MyElements::CommentFieldValuesListInfoIterEnd',
               'ApplicationPolicyListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentDiscover/ResourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterStart' => 'MyElements::UserFavoriteReportListInfoIterStart',
               'DpThrottleCreate/ThrottleContent' => 'MyTypes::ThrottleContent',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools' => 'MyTypes::ArrayOfResourcepoolNameOrId',
               'PerfThresholdCreate' => 'MyElements::PerfThresholdCreate',
               'HostCreateNdmpuser/HostNameOrId' => 'MyTypes::HostNameOrId',
               'PerfCollectClientOperationStatistics/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobContextObjId' => 'MyTypes::ObjId',
               'DpAgentDiscoverResult' => 'MyElements::DpAgentDiscoverResult',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphEdges/BackupGraphEdgeInfo' => 'MyTypes::BackupGraphEdgeInfo',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostModifyAgentCredentials' => 'MyElements::HostModifyAgentCredentials',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/StorageReliability/ControllerFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart' => 'MyTypes::PerfChart',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/RbacRole' => 'MyTypes::WrapperOfRbacRoleResource',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DfmAboutResult/DfmDirectories' => 'MyTypes::ArrayOfDirectoryInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DedupeMemberRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'PerfCollectClientOperationStatistics' => 'MyElements::PerfCollectClientOperationStatistics',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportScheduleId' => 'MyTypes::ObjId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree' => 'MyTypes::WrapperOfQtreeResource',
               'GroupMemberListIterNext' => 'MyElements::GroupMemberListIterNext',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules' => 'MyTypes::NfsExportRules',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'DpPolicyGetDefaultPropertyValuesResult/FailoverScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterStart/IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeListInfoIterStartResult/Records' => 'MyElements::QtreeListInfoIterStartResult::_Records',
               'QtreeStopMonitoringResult' => 'MyElements::QtreeStopMonitoringResult',
               'AggregateListInfoIterNextResult/Records' => 'MyElements::AggregateListInfoIterNextResult::_Records',
               'EventListIterStart/IsAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventStatusChangeListIterNext' => 'MyElements::EventStatusChangeListIterNext',
               'DfmScheduleDailyModify/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DatasetSetStorageset' => 'MyElements::DatasetSetStorageset',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/VfilerId' => 'MyTypes::ObjId',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo' => 'MyTypes::DpPolicyConnectionInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/LagStatus' => 'MyTypes::ObjStatus',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/PrimaryVolumeNameFormat' => 'MyTypes::PrimaryVolumeNameFormat',
               'StorageServiceDatasetModify' => 'MyElements::StorageServiceDatasetModify',
               'DpScheduleListResult/ScheduleList' => 'MyTypes::ArrayOfScheduleIdInfo',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreateResult' => 'MyElements::DpThrottleCreateResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'HostUsergroupListIterEnd' => 'MyElements::HostUsergroupListIterEnd',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/RbacRole/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'DfmScheduleCreate/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'RbacAccessCheckResult/LocalUsergroupStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/OperationalStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ClientRegistrySetResult' => 'MyElements::ClientRegistrySetResult',
               'PerfCopyCounterConfiguration/Preview' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleModify/HostRole/HostRoleInfo/HostRoleName' => 'MyTypes::AccessObjectName',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo' => 'MyTypes::SnapshotMemberInfo',
               'GroupGetOptionsResult/GroupOptionInfo' => 'MyTypes::GroupOptionInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationFullName' => 'MyTypes::ObjFullName',
               'DpScheduleCreate' => 'MyElements::DpScheduleCreate',
               'DpJobAbort/JobId' => 'MyElements::DpJobAbort::_JobId',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'IfcListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleHourlyModifyResult' => 'MyElements::DpScheduleHourlyModifyResult',
               'MigrateChangeState/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/Status' => 'MyTypes::ObjStatus',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressHostServiceInfo' => 'MyTypes::ProgressHostServiceInfo',
               'ResourcepoolRemoveMember' => 'MyElements::ResourcepoolRemoveMember',
               'ViVirtualDiskListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleHourlyAddResult' => 'MyElements::DpScheduleHourlyAddResult',
               'GroupDeleteMember/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'AuditLogAddEntry/AuditIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Host/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupListIterNextResult/Records' => 'MyElements::GroupListIterNextResult::_Records',
               'ApplicationPolicyEditRollback' => 'MyElements::ApplicationPolicyEditRollback',
               'HostListInfoIterNextResult/Hosts/HostInfo/ServiceStatuses/ServiceStatus' => 'MyTypes::ServiceStatus',
               'PerfViewListIterStart/CustomOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/DatasetName' => 'MyTypes::ObjName',
               'PerfThresholdTemplateAttachObjects/TemplateNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationAddResult' => 'MyElements::RbacOperationAddResult',
               'ViVirtualCenterListInfoIterNext' => 'MyElements::ViVirtualCenterListInfoIterNext',
               'HostListInfoIterStart/LicenseFilter' => 'MyTypes::ArrayOfLicense',
               'DatasetAddMember/DatasetMemberParameters' => 'MyTypes::ArrayOfDatasetMemberParameter',
               'ReportScheduleModify/ReportScheduleInfo/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyAdd/WeeklyContent/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DpScheduleMonthlyModifyResult' => 'MyElements::DpScheduleMonthlyModifyResult',
               'EventGenerate/EventMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipModify/IsDpManaged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/MemberName' => 'MyTypes::ObjName',
               'LdapServerListInfoResult/LdapServers' => 'MyTypes::ArrayOfLdapServerInfo',
               'DatasetMemberListInfoIterStart' => 'MyElements::DatasetMemberListInfoIterStart',
               'CommentFieldCreate/CommentFieldInfo' => 'MyTypes::CommentFieldInfo',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/DnsServers/IpAddress' => 'MyTypes::IpAddress',
               'HostUserAdd/HostUser/HostUserInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'PerfThresholdModify/Attributes/ThresholdInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'RbacRoleAdminInfoListResult/AdminNameOrId/RbacAdminNameOrId/AdminId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleModifyResult' => 'MyElements::ReportScheduleModifyResult',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'VolumeListInfoIterStart/IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleContentGet' => 'MyElements::DfmScheduleContentGet',
               'DpScheduleWeeklySubscheduleModify/ItemId' => 'MyElements::DpScheduleWeeklySubscheduleModify::_ItemId',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/OperationalStatus' => 'MyTypes::OperationalStatus',
               'DatasetRemoveMemberByDynamicReferenceResult' => 'MyElements::DatasetRemoveMemberByDynamicReferenceResult',
               'HostUserAdd/HostUser/HostUserInfo/HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/SnapshotReserve' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentListInfoIterNextResult' => 'MyElements::DpAgentListInfoIterNextResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapshotInfo/VolumeId' => 'MyTypes::DpProgressSnapshotInfo::_VolumeId',
               'DatasetListInfoIterStart/IncludeExportSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViHypervisorListInfoIterNextResult/Records' => 'MyElements::ViHypervisorListInfoIterNextResult::_Records',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/VolOrQtreeName' => 'MyTypes::ObjFullName',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/StorageSystemName' => 'MyTypes::ObjName',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatastoreId' => 'MyTypes::ObjId',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolIsProvisionable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfThresholdModify2Result' => 'MyElements::PerfThresholdModify2Result',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpJobType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyModify/WeeklyContent/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult' => 'MyTypes::ReplaceResult',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagWarningThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagWarningThreshold',
               'ViDatacenterListInfoIterStartResult/Records' => 'MyElements::ViDatacenterListInfoIterStartResult::_Records',
               'HostGetDefaultsResult/HostDefaults/AdminPortHost' => 'MyTypes::IpPortNumber',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/MaximumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeId' => 'MyTypes::ObjId',
               'VfilerTemplateDeleteResult' => 'MyElements::VfilerTemplateDeleteResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/RetentionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Reports' => 'MyTypes::ArrayOfPerfReport',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/SanContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'LunListInfoIterNextResult/Luns/LunInfo/HostName' => 'MyTypes::ObjName',
               'QtreeListInfoIterStart/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/StoragesetId' => 'MyTypes::ObjId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/IsDisableAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventListIterStart/TimeRange/EventTimestampRange/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'GroupListIterNextResult' => 'MyElements::GroupListIterNextResult',
               'PerfGetCounterDependentsResult/DependentCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfCopyCounterConfiguration' => 'MyElements::PerfCopyCounterConfiguration',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/DatastoreName' => 'MyTypes::ObjName',
               'DfmAboutResult' => 'MyElements::DfmAboutResult',
               'TimezoneListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource/PrefixLength' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/DestinationFilerId' => 'MyTypes::ObjId',
               'EventclassAddCustom/EventNames/EventNameInfo/EventNameShort' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldValuesListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views' => 'MyTypes::ArrayOfPerfView',
               'ReportDesignerShare/SubjectField' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionDuration',
               'DatasetSpaceMetricListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'VolumeListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerCreate' => 'MyElements::VfilerCreate',
               'DpOssvDirectoryBrowseIterNextResult/Subdirectories/DpOssvDirectoryName' => 'MyTypes::DpOssvDirectoryName',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrStatusProblems' => 'MyTypes::ArrayOfDrStatusProblem',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/NisServers/IpAddress' => 'MyTypes::IpAddress',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'EventListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair/Key' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateResource',
               'PerfGetServerStatusResult' => 'MyElements::PerfGetServerStatusResult',
               'DfmRelatedObjectsListInfoResult/ParentObjectList/ParentObject/FullName' => 'MyTypes::ObjFullName',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/FilerId' => 'MyTypes::QtreeInfo::_FilerId',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterEndResult' => 'MyElements::DpJobListIterEndResult',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/NumberRecords' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ClientRegistryDestroy/Option' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/AggregateId' => 'MyTypes::ObjId',
               'ClientRegistrySet' => 'MyElements::ClientRegistrySet',
               'LdapServerAdd/LdapServer/LdapServerAddr' => 'MyTypes::NetworkAddress',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo' => 'MyTypes::HostPerfInfo',
               'DatasetMemberDedupeStartResult/JobId' => 'MyElements::DatasetMemberDedupeStartResult::_JobId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'DfmSnmpSettingAdd/SnmpAuthenticationPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterStart/IncludeObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationStoragesetId' => 'MyTypes::DpBackupTransferInfo::_DestinationStoragesetId',
               'RbacRoleAdd/OwnerNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/InstalledPlugins/Plugin/ProductVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo' => 'MyTypes::ArrayOfStorageServiceDatasetInfo',
               'ApplicationPolicyListIterStartResult' => 'MyElements::ApplicationPolicyListIterStartResult',
               'DfmScheduleHourlyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment' => 'MyTypes::ProvisionMemberComment',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'AlarmModify/AlarmInfo/AlarmScriptRunas' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'PerfThresholdTemplateListInfoIterStart/TemplateNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/NearlyFullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_NearlyFullThreshold',
               'MigrateStart/IpBindings/IpBindingInfo/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerDestroy' => 'MyElements::VfilerDestroy',
               'DfmScheduleContentGet/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'MigrateStart/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/HourlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionDuration',
               'MigrateVolumeResult/MigrationJobs/MigrationJobInfo/VolumeName' => 'MyTypes::ObjName',
               'UserRecentReportListInfoIterStartResult/Records' => 'MyElements::UserRecentReportListInfoIterStartResult::_Records',
               'DpScheduleDependencyResult' => 'MyElements::DpScheduleDependencyResult',
               'PerfAssocViewListIterStart/ViewType' => 'MyTypes::ViewType',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacOperationDelete/Operation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddMember/DatasetMemberParameters/DatasetMemberParameter/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpRestoreToPrimary/Paths/DpPathInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventSourceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships' => 'MyTypes::ArrayOfDpRelationshipLagInfo',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSeverity' => 'MyTypes::ObjStatus',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo' => 'MyTypes::VfilerMigrationInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/StorageReliability/SubSystemFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleItemDelete/ThrottleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklyModifyResult' => 'MyElements::DfmScheduleWeeklyModifyResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'PerfGetCounterDependentsResult/Views/PerfView/AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/SourceStoragesetId' => 'MyTypes::DpBackupTransferInfo::_SourceStoragesetId',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DpScheduleListInfoIterStart/ScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAddResult' => 'MyElements::ReportDesignerScheduleAddResult',
               'DatasetResizeMember/ResizeMemberRequestInfo/MaximumCapacity' => 'MyTypes::ResizeMemberRequestInfo::_MaximumCapacity',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'MigrateComplete/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpPolicyEditCommitResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'DatasetRemoveResourcepool' => 'MyElements::DatasetRemoveResourcepool',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterNextResult/Records' => 'MyElements::ReportGraphListInfoIterNextResult::_Records',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCopy' => 'MyElements::ProvisioningPolicyCopy',
               'DpScheduleListResult/ScheduleList/ScheduleIdInfo' => 'MyTypes::ScheduleIdInfo',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'HostListInfoIterNextResult' => 'MyElements::HostListInfoIterNextResult',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ReportId' => 'MyTypes::ReportScheduleContentInfo::_ReportId',
               'EventListIterStart/IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo' => 'MyTypes::AdvancedOptionInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionDuration',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/BackupMetadata/DfmMetadata' => 'MyTypes::DfmMetadata',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/CreateVmwareSnapshot' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/NisDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerSetup/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfViewModify/View/PerfView/AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmGetDefaultsResult/AlarmDefaults/GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolMembers/ResourcePoolMember/ResourcePoolMemberName' => 'MyTypes::ObjFullName',
               'PerfViewCreateResult' => 'MyElements::PerfViewCreateResult',
               'PerfClientStatsPurge/StatId' => 'MyTypes::StatId',
               'DpDashboardGetDrDatasetCounts' => 'MyElements::DpDashboardGetDrDatasetCounts',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData' => 'MyTypes::PerfCounterData',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/NisServers/IpAddress' => 'MyTypes::IpAddress',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceId' => 'MyTypes::ObjId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionDuration',
               'RbacRoleAdminInfoListResult/RoleList/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToPrimaryResult/SpaceStatusResults/SpaceStatusResult/AvailSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpAgentRegisterResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapmirrorSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserRecentReportListInfoIterNextResult/Records' => 'MyElements::UserRecentReportListInfoIterNextResult::_Records',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/IsEmpty' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetAddToExclusionList' => 'MyElements::DatasetAddToExclusionList',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesUsed' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed',
               'DatasetEditRollbackResult' => 'MyElements::DatasetEditRollbackResult',
               'HostUsergroupCreateResult' => 'MyElements::HostUsergroupCreateResult',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpLocalSnapshotJobData/NodeId' => 'MyTypes::DpLocalSnapshotJobData::_NodeId',
               'MigrateVolumeResult/MigrationDryRunResults' => 'MyTypes::ArrayOfMigrationDryRunResult',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DrState' => 'MyTypes::DrState',
               'PerfViewModify/View/PerfView/ViewType' => 'MyTypes::ViewType',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/BackupScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleAddResult/RoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetDefaultViewResult' => 'MyElements::PerfGetDefaultViewResult',
               'DfmScheduleMonthlyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/BackupScheduleId' => 'MyTypes::ObjId',
               'DatasetMemberListInfoIterStart/MemberId' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/OssvApplicationRestoreDestinationList' => 'MyTypes::ArrayOfOssvApplicationRestoreDestinationInfo',
               'AlarmGetDefaultsResult/AlarmDefaults/IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleContentGet/ScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/FileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/SubmittedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentUpgrade/PackageNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'HostUserListIterNextResult/HostUsers/HostUserInfo' => 'MyTypes::HostUserInfo',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpDashboardGetProtectedDataCountsResult/UnprotectedQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_UnprotectedQtreeCount',
               'DpThrottleDependencyResult/ThrottleAssignees/ThrottleAssignee' => 'MyTypes::ThrottleAssignee',
               'PerfCounterGroupListInfo/IncludeCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter' => 'MyTypes::PerfCounter',
               'CommentFieldListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterStartResult' => 'MyElements::PerfClientStatsListInfoIterStartResult',
               'PerfClientStatsListInfoIterNext' => 'MyElements::PerfClientStatsListInfoIterNext',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualDiskListInfoIterEndResult' => 'MyElements::ViVirtualDiskListInfoIterEndResult',
               'DpScheduleWeeklySubscheduleModify' => 'MyElements::DpScheduleWeeklySubscheduleModify',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/MemberName' => 'MyTypes::ObjName',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'HostGetDefaultsResult/HostDefaults/AdminTransportAgent' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Group' => 'MyTypes::WrapperOfGroupResource',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/LastModifiedTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationHostName' => 'MyTypes::ObjFullName',
               'ApplicationPolicyListIterEndResult' => 'MyElements::ApplicationPolicyListIterEndResult',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails/ProtectionStatusJobDetail/ProtectionStatusJobStatus' => 'MyTypes::DpJobOverallStatus',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo/RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ThrottleScheduleId' => 'MyTypes::ObjId',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo' => 'MyTypes::SnapshotInfo',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo' => 'MyTypes::DpBackupIdInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo' => 'MyTypes::DatasetSpaceInfo',
               'VfilerSetup/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmRelatedObjectsListInfoResult/ChildCountList/ChildCount/Count' => 'MyTypes::ChildCount::_Count',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'DpScheduleModifyResult' => 'MyElements::DpScheduleModifyResult',
               'ViHypervisorListInfoIterNext/Maximum' => 'MyElements::ViHypervisorListInfoIterNext::_Maximum',
               'DpBackupContentListIterStart/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/HostServiceId' => 'MyTypes::ObjId',
               'ReportOutputListInfoIterNext/Maximum' => 'MyElements::ReportOutputListInfoIterNext::_Maximum',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/DefaultGroupQuota' => 'MyTypes::NasContainerSettings::_DefaultGroupQuota',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo' => 'MyTypes::DpJobProgressEventInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyName' => 'MyTypes::ObjName',
               'PerfViewDestroy' => 'MyElements::PerfViewDestroy',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpScheduleDailyModify/DailyContent/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'StorageServiceListInfoIterEndResult' => 'MyElements::StorageServiceListInfoIterEndResult',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/DeprecatedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'PerfThresholdTemplateAttachObjectsResult' => 'MyElements::PerfThresholdTemplateAttachObjectsResult',
               'DatasetChangeDrState/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationHostId' => 'MyTypes::ObjId',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo/TreeQuota' => 'MyTypes::ProgressQuotaInfo::_TreeQuota',
               'DpDashboardGetProtectedDataCountsResult/IgnoredDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_IgnoredDatasetCount',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationNameDetails' => 'MyTypes::WrapperOfRbacOperationNameDetails',
               'PerfClientStatsPurge/StartTime' => 'MyTypes::Timestamp',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCredentials/NdmpUsername' => 'MyTypes::NdmpUsername',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems' => 'MyTypes::ArrayOfStorageSystemInfo',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionDuration',
               'RbacAdminRoleRemove/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'DpJobListIterNextResult/Jobs/DpJobInfo/DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeModify' => 'MyElements::VolumeModify',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetModify/DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'PerfThresholdTemplateListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'PerfGetCounterDependents/HostNameOrId' => 'MyTypes::HostNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/DatasetId' => 'MyTypes::DpJobInfo::_DatasetId',
               'MigrateUpdateResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/MaximumQtreesPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'GroupMemberListIterStart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'QtreeListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DpJobPurge/PurgeJobsCompletedWithError' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree/TotalQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'ReportListInfoIterNextResult/Records' => 'MyElements::ReportListInfoIterNextResult::_Records',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek/DayOfWeek' => 'MyTypes::DayOfWeek',
               'DatasetDynamicReferenceListInfoIterEndResult' => 'MyElements::DatasetDynamicReferenceListInfoIterEndResult',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageSystemInfo/StorageSystemName' => 'MyTypes::ObjFullName',
               'DatasetUpdateProtectionStatus' => 'MyElements::DatasetUpdateProtectionStatus',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpLocalSnapshotJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo' => 'MyTypes::BackupInfo',
               'ApplicationPolicyEditRollback/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'DatasetSet/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterStartResult' => 'MyElements::DatasetListInfoIterStartResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine' => 'MyTypes::PerfLine',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobOverallStatus' => 'MyTypes::DpJobOverallStatus',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapmirrorTransferJobData' => 'MyTypes::DpSnapmirrorTransferJobData',
               'DpScheduleMonthlyDelete' => 'MyElements::DpScheduleMonthlyDelete',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/DpBackupExpiryTimestamp' => 'MyTypes::DpTimestamp',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceName' => 'MyTypes::ObjName',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdCreate2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetOptions' => 'MyElements::GroupGetOptions',
               'GroupGetStatusResult' => 'MyElements::GroupGetStatusResult',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo' => 'MyTypes::QtreeSizeInfo',
               'DpBackupVersionCreateResult/BackupId' => 'MyElements::DpBackupVersionCreateResult::_BackupId',
               'DpBackupStart/BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/IsDisplay' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools' => 'MyTypes::ArrayOfResourcepoolNameOrId',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'HostAddResult/HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'PerfSetDefaultViewResult' => 'MyElements::PerfSetDefaultViewResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressScriptRunInfo' => 'MyTypes::ProgressScriptRunInfo',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob' => 'MyTypes::DpScheduledJob',
               'RbacAdminListInfoIterStart/AdminNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolFreeVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DpRelationshipModify/IsDpImported' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModify/StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'HostUsergroupListIterNextResult' => 'MyElements::HostUsergroupListIterNextResult',
               'DpPolicyListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ViVirtualMachineListInfoIterEndResult' => 'MyElements::ViVirtualMachineListInfoIterEndResult',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'PerfObjectInstanceListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VfilerSetup/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/HostRoleName' => 'MyTypes::AccessObjectName',
               'ViDatastoreListInfoIterNext' => 'MyElements::ViDatastoreListInfoIterNext',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/HostingFilerName' => 'MyTypes::ObjFullName',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/SourceVfilerId' => 'MyTypes::ObjId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/MirrorScheduleName' => 'MyTypes::ObjName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/ProvisioningPolicyName' => 'MyTypes::ObjFullName',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'HostListInfoIterStart/IncludePerfSpaceDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmNetworkListInfoResult/Networks/NetworkInfo/HopCount' => 'MyTypes::NetworkInfo::_HopCount',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationStoragesetId' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'VolumeDedupe/DedupeRequestInfo' => 'MyTypes::DedupeRequestInfo',
               'VfilerSetup/AllowedProtocols/Protocol' => 'MyTypes::Protocol',
               'ReportScheduleModify/ReportScheduleInfo/SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleModify/ReportScheduleInfo/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DpNodeId' => 'MyTypes::DatasetSpaceInfo::_DpNodeId',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/AdminPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/CustomProvisioningScriptSettings' => 'MyTypes::CustomProvisioningScriptSettings',
               'DatasetRemoveFromExclusionList/ObjectsToBeRemoved' => 'MyTypes::ArrayOfObjNameOrId',
               'HostRoleCreate/HostRole/HostRoleInfo/HostRoleId' => 'MyTypes::AccessObjectId',
               'SrmFileTypeAdd/SrmFileTypeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo/NewSize' => 'MyTypes::ResizeMemberRequestInfo::_NewSize',
               'DpAgentStoragesystemListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryModify' => 'MyElements::DpOssvDirectoryModify',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/CategoryName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines/GraphLineInfo' => 'MyTypes::GraphLineInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DpDashboardGetProtectedDataCountsResult' => 'MyElements::DpDashboardGetProtectedDataCountsResult',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems/StorageSystemInfo/LoginStatusFromHs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageServiceInfo/StorageServiceId' => 'MyTypes::ObjId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeNearlyFullThreshold' => 'MyTypes::VolumeInfo::_VolumeNearlyFullThreshold',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpBackupListIterStart/SearchKeys' => 'MyTypes::ArrayOfSearchKey',
               'VolumeListInfoIterStart/VolumeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyCopy/TemplateDpPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'ProvisioningPolicyEditBegin/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DfmGetApiStatisticsResult' => 'MyElements::DfmGetApiStatisticsResult',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSeverity' => 'MyTypes::ObjStatus',
               'PerfThresholdCreate2/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Host/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateDetachObjectsResult' => 'MyElements::PerfThresholdTemplateDetachObjectsResult',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VirtualDiskId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryName' => 'MyTypes::ObjName',
               'PerfViewModify/View/PerfView/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupGetDataResult/Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/Hostname' => 'MyTypes::ObjName',
               'MigrateFixResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleModify/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagWarningThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagWarningThreshold',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines/GraphLineInfo/SampleSuffix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ReportScheduleInfo' => 'MyTypes::ReportScheduleInfo',
               'DpScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/ObjectName' => 'MyTypes::ObjFullName',
               'DatasetExclusionListInfoIterEnd' => 'MyElements::DatasetExclusionListInfoIterEnd',
               'ProvisioningPolicyListIterNext/Maximum' => 'MyElements::ProvisioningPolicyListIterNext::_Maximum',
               'MigrateComplete/MigrateOffline' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'IfcListInfoIterNextResult/Records' => 'MyElements::IfcListInfoIterNextResult::_Records',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/StoragesetId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'DpOssvDirectoryRootsIterStart' => 'MyElements::DpOssvDirectoryRootsIterStart',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyModify/DailyContent/DailyInfo' => 'MyTypes::DailyInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/PagerEmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'PerfObjectCounterListInfoResult' => 'MyElements::PerfObjectCounterListInfoResult',
               'PerfGetCounterDependentsResult/Views/PerfView/ViewType' => 'MyTypes::ViewType',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource' => 'MyTypes::AggregateResource',
               'DfmObjectRefresh/MonitorNames/MonitorName' => 'MyTypes::MonitorName',
               'HostAddOssv/NdmpCredentials/FullNdmpCredentials/NdmpPassword' => 'MyTypes::HostPassword',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDestroy/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'SnapshotGetReclaimableInfoResult/ReclaimableSize' => 'MyElements::SnapshotGetReclaimableInfoResult::_ReclaimableSize',
               'PerfGetCounterDependentsResult/Thresholds' => 'MyTypes::ArrayOfPerfThreshold',
               'DfmBackupScheduleGetResult/Minute' => 'MyElements::DfmBackupScheduleGetResult::_Minute',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/WeeklyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionCount',
               'VolumeListInfoIterStart/IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateCancel' => 'MyElements::MigrateCancel',
               'MigrateRollback/PersistentMigratedRoutes' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/HasProtection' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmGetResourcePropertyValues' => 'MyElements::DfmGetResourcePropertyValues',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpJobPurgeResult' => 'MyElements::DpJobPurgeResult',
               'PerfViewGetDataResult/DynamicData/DynamicData/Hostname' => 'MyTypes::ObjName',
               'DpBackupVersionDelete/AllowDeferredDelete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleDestroyResult' => 'MyElements::DfmScheduleDestroyResult',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/VfilerName' => 'MyTypes::ObjFullName',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapmirrorTransferJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'DatasetModifyNode/DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions' => 'MyTypes::ArrayOfSpaceCondition',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdTemplateListInfoIterNextResult/Records' => 'MyElements::PerfThresholdTemplateListInfoIterNextResult::_Records',
               'DpAgentListInfoIterEnd' => 'MyElements::DpAgentListInfoIterEnd',
               'DpScheduleDailyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterNextResult' => 'MyElements::ViDatacenterListInfoIterNextResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterEnd' => 'MyElements::ViHypervisorListInfoIterEnd',
               'DatasetMemberListInfoIterNext' => 'MyElements::DatasetMemberListInfoIterNext',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/ErrorsIn' => 'MyTypes::NetifIpInterfaceInfo::_ErrorsIn',
               'DatasetAddMember/DatasetMemberParameters/DatasetMemberParameter' => 'MyTypes::DatasetMemberParameter',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings' => 'MyTypes::NasContainerSettings',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ThresholdInterval' => 'MyTypes::ThresholdInfo::_ThresholdInterval',
               'MigrateVolumeResult/MigrationJobs/MigrationJobInfo' => 'MyTypes::MigrationJobInfo',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'DpAgentConfigure/DpAgentNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/SourceVolumeOrQtreeId' => 'MyTypes::DpProgressRelationshipInfo::_SourceVolumeOrQtreeId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource' => 'MyTypes::QtreeResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/ScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNext' => 'MyElements::PerfThresholdTemplateListInfoIterNext',
               'PerfViewModify/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNext' => 'MyElements::DpOssvApplicationListInfoIterNext',
               'FcpTargetListInfoIterNext/Maximum' => 'MyElements::FcpTargetListInfoIterNext::_Maximum',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrStatusProblems/DrStatusProblem' => 'MyTypes::DrStatusProblem',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ClientRegistryGetResult/Options/ClientOptionInfo/Option' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyModify/MonthlyContent' => 'MyTypes::WrapperOfMonthlyInfo',
               'RbacRoleDisinheritResult' => 'MyElements::RbacRoleDisinheritResult',
               'DpPolicyEditBegin/DpPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo' => 'MyTypes::DpRecoverMemberInfo',
               'DatasetListInfoIterStart/IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostAddLicense/HostNameOrId' => 'MyTypes::HostNameOrId',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/SnmpId' => 'MyTypes::SnmpId',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/IsPolicyReadonly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventListIterNextResult/Events/EventInfo' => 'MyTypes::EventInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/MonthlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionDuration',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/PagerEmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies' => 'MyTypes::ArrayOfProvisioningPolicyInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicyName' => 'MyTypes::ObjName',
               'ResourcepoolListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/RouteMigrationMode' => 'MyTypes::RouteMigrationMode',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee' => 'MyTypes::ScheduleAssignee',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo' => 'MyTypes::ApplicationBackupScheduleInfo',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics' => 'MyTypes::ArrayOfMetric',
               'AlarmCreate/AlarmInfo/TrapDestinations/TrapDestination/TrapPort' => 'MyTypes::TrapDestination::_TrapPort',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagErrorThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagErrorThreshold',
               'DatasetExclusionListInfoIterEndResult' => 'MyElements::DatasetExclusionListInfoIterEndResult',
               'HostAgentOssvServiceStart/Timeout' => 'MyElements::HostAgentOssvServiceStart::_Timeout',
               'EventListIterNextResult/Events/EventInfo/EventSourceId' => 'MyTypes::EventInfo::_EventSourceId',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo' => 'MyTypes::WrapperOfPerfObjectCounter',
               'DfmRelatedObjectsListInfoResult/ParentDatasetList' => 'MyTypes::ArrayOfParentDataset',
               'ViDatastoreListInfoIterNext/Maximum' => 'MyElements::ViDatastoreListInfoIterNext::_Maximum',
               'DpScheduleListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VfilerTemplateDelete' => 'MyElements::VfilerTemplateDelete',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'DpRestoreViStart/DpViRestoreObjects/DpViRestoreObject' => 'MyTypes::DpViRestoreObject',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource' => 'MyTypes::AggregateResource',
               'HostUsergroupListIterStart/Verbose' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerStorageInfo/VolumeName' => 'MyTypes::ObjFullName',
               'RbacAdminRoleInfoList' => 'MyElements::RbacAdminRoleInfoList',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/EventType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartHour' => 'MyTypes::ThrottleItemInfo::_StartHour',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/ErrCode' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AggregateListInfoIterStart/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo/Lag' => 'MyTypes::DpRelationshipLagInfo::_Lag',
               'ClientRegistrySet/Options/ClientOptionInfo' => 'MyTypes::ClientOptionInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo' => 'MyTypes::DpJobInfo',
               'DpAgentListInfoIterNextResult/Records' => 'MyElements::DpAgentListInfoIterNextResult::_Records',
               'DpScheduleDailyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreViStart/DpViRestoreSettings/DpViHypervRestoreSettings' => 'MyTypes::DpViHypervRestoreSettings',
               'DfmScheduleDependency' => 'MyElements::DfmScheduleDependency',
               'ReportDesignerScheduleModify/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/ApplicationBackupProperties' => 'MyTypes::ArrayOfPropertyInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingAdd/SnmpVersion' => 'MyTypes::SnmpVersion',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartMinute' => 'MyTypes::ThrottleItemInfo::_StartMinute',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependents/Counters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DatasetModify/DatasetMetadata/DfmMetadataField/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledge' => 'MyElements::EventAcknowledge',
               'ReportListInfoIterStart/ReportType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeDedupe/VolumeNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterListNotInView/ObjectCounterList' => 'MyTypes::ArrayOfPerfObjectCounterInfo',
               'DfmNetworkAdd/PrefixLength' => 'MyTypes::PrefixLength',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/HostServiceId' => 'MyTypes::ObjId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth/DayOfMonth' => 'MyTypes::DayOfMonth',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/IncludeIndependentDisks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAdminListInfoIterEnd' => 'MyElements::RbacAdminListInfoIterEnd',
               'DpBackupListIterStart/VolumeId' => 'MyTypes::ObjId',
               'StorageServiceDatasetModifyResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'VfilerCreate/IpAddress' => 'MyTypes::IpAddress',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventGenerate/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValues' => 'MyElements::DpPolicyGetDefaultPropertyValues',
               'DpOssvDirectoryDiscoveredIterStartResult/Records' => 'MyElements::DpOssvDirectoryDiscoveredIterStartResult::_Records',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/NextScheduledBackupTime' => 'MyTypes::DpTimestamp',
               'AggregateListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/ApplicationInfo/IsApplicationResponsibleForPrimaryBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceStoragesetId' => 'MyTypes::ObjId',
               'DpBackupContentListIterNextResult/Records' => 'MyElements::DpBackupContentListIterNextResult::_Records',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterNext/Maximum' => 'MyElements::PerfClientStatsListInfoIterNext::_Maximum',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/HostId' => 'MyTypes::ObjId',
               'PerfAssocViewListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityRemove/Resource' => 'MyTypes::WrapperOfResourceIdentifier',
               'DpAgentPackageListResult/DpAgentPackages' => 'MyTypes::ArrayOfDpAgentPackageInfo',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/CpuCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts' => 'MyTypes::ArrayOfPerfChart',
               'ApplicationPolicyEditCommit' => 'MyElements::ApplicationPolicyEditCommit',
               'DpScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Dataset' => 'MyTypes::WrapperOfDatasetResource',
               'HostUserPush/Password' => 'MyTypes::HostUserPassword',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'HostListInfoIterStart/IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/EnvironmentVariableList' => 'MyTypes::ArrayOfEnvironmentVariableInfo',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo' => 'MyTypes::StorageServiceInfo',
               'EventStatusChangeListIterStart/Timeout' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterStart/JobTypes' => 'MyTypes::ArrayOfJobType',
               'DatasetMemberListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRestoreToNewPathResult/SpaceStatusResults/SpaceStatusResult/AvailSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleAdminInfoList/FollowRoleInheritance' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DpScheduleMonthlyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryRootsIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo/AllowSavedStateBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleDependency' => 'MyElements::DpThrottleDependency',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesUsed' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed',
               'RbacOperationAdd/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationSynopsis' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleInfoListResult' => 'MyElements::RbacAdminRoleInfoListResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId' => 'MyTypes::LunNameOrId',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventSourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleId' => 'MyTypes::ThrottleContent::_ThrottleId',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines' => 'MyTypes::ArrayOfGraphLineInfo',
               'MigrateComplete/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement' => 'MyTypes::SpaceMeasurement',
               'ProvisioningPolicyCopy/ProvisioningPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingDelete' => 'MyElements::DfmSnmpSettingDelete',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'ViVirtualMachineListInfoIterNext' => 'MyElements::ViVirtualMachineListInfoIterNext',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource/IpAddress' => 'MyTypes::IpAddress',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModify/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetDynamicReferenceListInfoIterNextResult' => 'MyElements::DatasetDynamicReferenceListInfoIterNextResult',
               'ReportOutputListInfoIterStart' => 'MyElements::ReportOutputListInfoIterStart',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartHour' => 'MyTypes::ThrottleItemInfo::_StartHour',
               'DpScheduleModify' => 'MyElements::DpScheduleModify',
               'DatasetModify/ApplicationInfo/IsApplicationManagingPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneListInfoIterNextResult/Timezones/TimezoneInfo' => 'MyTypes::TimezoneInfo',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/RelationshipType' => 'MyTypes::RelationshipType',
               'PerfCounterGroupListIterStart' => 'MyElements::PerfCounterGroupListIterStart',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/IsMultiCurrent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'RbacAdminRoleInfoListResult/AdminList' => 'MyTypes::ArrayOfRbacAdminOrUsergroup',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterStart/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommit/SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementCommit::_SpaceManagementSessionId',
               'DpRelationshipListInfoIterNextResult' => 'MyElements::DpRelationshipListInfoIterNextResult',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/AdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'DfmMonitorTimestampListResult/DfmMonitoringTimestamps' => 'MyTypes::ArrayOfDfmMonitoringTimestamp',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/JunctionPathActive' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyEditRollback' => 'MyElements::ProvisioningPolicyEditRollback',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleWeeklySubscheduleAdd/StartDayOfWeek' => 'MyElements::DfmScheduleWeeklySubscheduleAdd::_StartDayOfWeek',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphEdges/BackupGraphEdgeInfo/FromResourceId' => 'MyTypes::ObjId',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/MigrationStatus' => 'MyTypes::MigrationStatus',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostModel' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateDelete/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'QtreeListInfoIterStart/IsDirectVfilerChild' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupContentListIterStart' => 'MyElements::DpBackupContentListIterStart',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrStatusProblems/DrStatusProblem/DrStatusDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDailyAdd/DailyContent' => 'MyTypes::WrapperOfDailyInfo',
               'EventDeleteResult/EventsDeletedList/EventActionInfo/ErrorMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/DedupeProgress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumePerfStatus' => 'MyTypes::ObjStatus',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates' => 'MyTypes::ArrayOfThresholdTemplateInfo',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'PerfThresholdCreate/ThresholdInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterStartResult/Records' => 'MyElements::DiskListInfoIterStartResult::_Records',
               'DatasetListInfoIterStart/IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreToNewPathResult/OverwriteResults/OverwriteResult/FilePath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo/CommentFieldName' => 'MyTypes::CommentFieldName',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostRoleModify/HostRole/HostRoleInfo/HostName' => 'MyTypes::ObjName',
               'EventclassList/EventClassObjects' => 'MyTypes::ArrayOfEventClassObject',
               'RbacAccessCheck/Resource/ResourceIdentifier/Host/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleModifyResult' => 'MyElements::DpThrottleModifyResult',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'AggregateModify' => 'MyElements::AggregateModify',
               'ApiProxyResult' => 'MyElements::ApiProxyResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'DfmScheduleRename' => 'MyElements::DfmScheduleRename',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo' => 'MyTypes::SnapshotMemberInfo',
               'PerfViewListIterNextResult/Views/PerfView/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetResizeMember/ResizeMemberRequestInfo/MemberName' => 'MyTypes::ObjName',
               'VolumeResize/ResizeVolumeRequestInfo/MaximumCapacity' => 'MyTypes::ResizeVolumeRequestInfo::_MaximumCapacity',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/PolicyId' => 'MyTypes::DpJobInfo::_PolicyId',
               'FcpTargetListInfoIterNextResult/Targets' => 'MyTypes::ArrayOfTargetInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/StoragesetTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'MigrateVolume' => 'MyElements::MigrateVolume',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/ResourceTag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'DpBackupGetLocation/Paths/DpBackupPathInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleModify/ReportScheduleInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'DpPolicyEditCommit/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'DatasetCreate/PrimaryVolumeNameFormat' => 'MyTypes::PrimaryVolumeNameFormat',
               'RbacAccessCheck/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyName' => 'MyTypes::ObjName',
               'HostUserAdd/HostUser/HostUserInfo/HostUserId' => 'MyTypes::AccessObjectId',
               'PerfViewModify/View/PerfView/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/Name' => 'MyTypes::ObjName',
               'FcpTargetListInfoIterNextResult' => 'MyElements::FcpTargetListInfoIterNextResult',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'DatasetModify/ApplicationInfo/CarryPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'AggregateModify/AggregateNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterEndResult' => 'MyElements::DatasetListInfoIterEndResult',
               'DatasetModify/ApplicationInfo' => 'MyTypes::ApplicationInfo',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostUsergroupName' => 'MyTypes::UsergroupName',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue' => 'MyTypes::CommentFieldValue',
               'ViDatacenterListInfoIterStart' => 'MyElements::ViDatacenterListInfoIterStart',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommit/IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacOperationAdd/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/ResourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionCount',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'AlarmGetDefaults' => 'MyElements::AlarmGetDefaults',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource' => 'MyTypes::VolumeResource',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/SnapvaultLagWarningThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VolumeListInfoIterStart' => 'MyElements::VolumeListInfoIterStart',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyAdd/WeeklyContent' => 'MyTypes::WrapperOfWeeklyInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNext' => 'MyElements::DpThrottleListInfoIterNext',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/ApplicationBackupProperties/PropertyInfo/PropertyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterStartResult/Records' => 'MyElements::DpJobListIterStartResult::_Records',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/ItemId' => 'MyTypes::ThrottleItemInfo::_ItemId',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Policy' => 'MyTypes::WrapperOfPolicyResource',
               'PerfObjectInstanceListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DatasetUpdateDrStatus/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetDynamicReferenceListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'EventListIterStart/EventSourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AlarmListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterStart/Day' => 'MyElements::DatasetSpaceMetricListInfoIterStart::_Day',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolUpdateFreeSpaceStatusResult' => 'MyElements::ResourcepoolUpdateFreeSpaceStatusResult',
               'VfilerTemplateListInfoIterStartResult' => 'MyElements::VfilerTemplateListInfoIterStartResult',
               'PerfCounterGroupListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'RbacRoleAddResult' => 'MyElements::RbacRoleAddResult',
               'DfmSnmpSettingAddResult/SnmpId' => 'MyTypes::SnmpId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentUpgradeResult' => 'MyElements::DpAgentUpgradeResult',
               'GraphDataListInfoResult/GraphLineValues' => 'MyTypes::ArrayOfGraphLineValueInfo',
               'ResourcepoolMemberListInfoIterNextResult' => 'MyElements::ResourcepoolMemberListInfoIterNextResult',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'DpOssvDirectoryDiscoveredIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupCopy/NewGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify' => 'MyElements::ProvisioningPolicyModify',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DpPolicyListIterStart/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo/LastUsedTime' => 'MyTypes::Timestamp',
               'PerfCounterGroupListInfo/CounterInfoOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/Resourcepools/DatasetResourcepoolInfo/ResourcepoolId' => 'MyTypes::ObjId',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'HostGetDefaultsResult/HostDefaults/SnapvaultMaxBackupThreads' => 'MyTypes::HostDefaults::_SnapvaultMaxBackupThreads',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo' => 'MyTypes::TimesOfDayInfo',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'DfmServerListDiagnosticInfoResult' => 'MyElements::DfmServerListDiagnosticInfoResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageSystemInfo' => 'MyTypes::ProgressStorageSystemInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceVolumeId' => 'MyTypes::ObjId',
               'DpPolicyCopyResult' => 'MyElements::DpPolicyCopyResult',
               'DfmScheduleMonthlyAdd' => 'MyElements::DfmScheduleMonthlyAdd',
               'PerfGetCounterData/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetDataResult/DynamicData/DynamicData/InstanceName/PerfInstance/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldValuesListInfoIterNextResult' => 'MyElements::CommentFieldValuesListInfoIterNextResult',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'AlarmCreate/AlarmInfo/AdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'DpBackupGetLocation/Paths/DpBackupPathInfo/MemberId' => 'MyTypes::ObjId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/FromNodeId' => 'MyTypes::DpPolicyConnectionInfo::_FromNodeId',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMetadata/DfmMetadataField/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterNextResult/Disks/DiskInfo/DiskName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'DpBackupVersionModify/BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerCreateResult/RootVolumeId' => 'MyTypes::ObjId',
               'EventAcknowledgeResult' => 'MyElements::EventAcknowledgeResult',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DfmUserPrivGetResult/Privilege' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyDelete/ItemId' => 'MyElements::DfmScheduleDailyDelete::_ItemId',
               'HostRoleModify/HostRole/HostRoleInfo/HostId' => 'MyTypes::ObjId',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo' => 'MyTypes::AggregateInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunMapInfo/LunPathId' => 'MyTypes::ObjId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'ApplicationPolicyCreate' => 'MyElements::ApplicationPolicyCreate',
               'DpJobProgressEventListIterNextResult' => 'MyElements::DpJobProgressEventListIterNextResult',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions/SpaceCondition/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/BytesTransferred' => 'MyTypes::DpJobInfo::_BytesTransferred',
               'PerfViewListIterEnd' => 'MyElements::PerfViewListIterEnd',
               'DpScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDependency/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DfmScheduleWeeklySubscheduleDelete/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDependentsResult/ThresholdTemplates' => 'MyTypes::ArrayOfThresholdTemplate',
               'RbacAccessCheck/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceId' => 'MyTypes::ObjId',
               'HostUserAdd/HostUser/HostUserInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'PerfViewGetData' => 'MyElements::PerfViewGetData',
               'DatasetMemberUndedupeStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/Throughput' => 'MyTypes::ThrottleItemInfo::_Throughput',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/ProvisioningPolicyType' => 'MyTypes::ProvisioningPolicyType',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateResource',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/PartnerInterfaceName' => 'MyTypes::ObjFullName',
               'DatasetSpaceMetricListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/VirtualCenterReference/VirtualCenterId' => 'MyTypes::ObjId',
               'DpOssvApplicationRestoreDestinationListInfoIterNext' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterNext',
               'DatasetModify/SecondaryVolumeNameFormat' => 'MyTypes::SecondaryVolumeNameFormat',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Policy' => 'MyTypes::WrapperOfPolicyResource',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/SnapshotReserve' => 'MyTypes::SpaceMeasurement::_SnapshotReserve',
               'DpThrottleModify/ThrottleContent/ThrottleId' => 'MyTypes::ThrottleContent::_ThrottleId',
               'StorageServiceModify/StorageServiceName' => 'MyTypes::ObjName',
               'DatasetCreateResult' => 'MyElements::DatasetCreateResult',
               'RbacRoleAdminInfoList/AdminNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementRemoveOperation/SpaceManagementOpType' => 'MyTypes::SpaceManagementOpType',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapmirrorTransferJobData' => 'MyTypes::DpSnapmirrorTransferJobData',
               'PerfObjectInstanceListIterNextResult/Records' => 'MyElements::PerfObjectInstanceListIterNextResult::_Records',
               'LunResizeResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleHourlyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation' => 'MyTypes::WrapperOfRbacOperation',
               'DatasetListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpDashboardGetLaggedDatasetsResult' => 'MyElements::DpDashboardGetLaggedDatasetsResult',
               'DatasetListInfoIterNext' => 'MyElements::DatasetListInfoIterNext',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics' => 'MyTypes::ArrayOfDatasetIoMetricInfo',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled' => 'MyTypes::ArrayOfPerfDataSource',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesTotal' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal',
               'ViHypervisorListInfoIterNextResult' => 'MyElements::ViHypervisorListInfoIterNextResult',
               'DfmScheduleModify/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'UserFavoriteReportListInfoIterNext/Maximum' => 'MyElements::UserFavoriteReportListInfoIterNext::_Maximum',
               'PerfAssocViewListIterNextResult/Views/PerfView/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart' => 'MyTypes::PerfChart',
               'ResourcepoolListInfoIterStart/ResourceTag' => 'MyTypes::ResourceTag',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo' => 'MyTypes::NetifIpInterfaceInfo',
               'AlarmCreate/AlarmInfo/AlarmId' => 'MyTypes::AlarmInfo::_AlarmId',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'AggregateSpaceManagementRemoveOperationResult' => 'MyElements::AggregateSpaceManagementRemoveOperationResult',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/DefaultGroupQuota' => 'MyTypes::NasContainerSettings::_DefaultGroupQuota',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndHour' => 'MyTypes::ThrottleItemInfo::_EndHour',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ReportScheduleId' => 'MyTypes::ObjId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/CreateVmwareSnapshot' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateVolume/MigrationRequestInfo/RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'StorageServiceModify/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'PerfCounterGroupListInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicyType' => 'MyTypes::ApplicationPolicyType',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Filer' => 'MyTypes::WrapperOfFilerResource',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'GroupGetOptionsResult' => 'MyElements::GroupGetOptionsResult',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModify/SecondaryQtreeNameFormat' => 'MyTypes::SecondaryQtreeNameFormat',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/UndedupeMemberRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/EmailAddressList' => 'MyTypes::EmailAddressList',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterEnd' => 'MyElements::HostUserListIterEnd',
               'PerfThresholdTemplateDeleteResult/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterStart/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsSnapmirrorHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserModify/HostUser/HostUserInfo/MaximumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetEditCommitResult/IsProvisioningFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserListIterNextResult/Records' => 'MyElements::HostUserListIterNextResult::_Records',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems/StorageSystemInfo/StorageSystemName' => 'MyTypes::ObjName',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'PerfThresholdTemplateDelete' => 'MyElements::PerfThresholdTemplateDelete',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Labels/PerfLabel' => 'MyTypes::PerfLabel',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'EventStatusChangeListIterStart/TimeRange/EventTimestampRange/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupGetData/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRestoreToPrimary/BackupVersion' => 'MyTypes::DpTimestamp',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUsergroupNames' => 'MyTypes::ArrayOfHostUsergroupName',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo' => 'MyTypes::LdapServerInfo',
               'DfmNetworkListInfo' => 'MyElements::DfmNetworkListInfo',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeResize/ResizeVolumeRequestInfo/NewSize' => 'MyTypes::ResizeVolumeRequestInfo::_NewSize',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapmirrorTransferJobData/ConnectionId' => 'MyTypes::DpSnapmirrorTransferJobData::_ConnectionId',
               'DpScheduleDailyModifyResult' => 'MyElements::DpScheduleDailyModifyResult',
               'DiskListInfoIterNextResult/Disks/DiskInfo/DiskUidOrWwn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd/ReportScheduleInfo/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/DestinationVfilerId' => 'MyTypes::ObjId',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TrapDestinations' => 'MyTypes::ArrayOfTrapDestination',
               'DfmObjectsGetStatusResult' => 'MyElements::DfmObjectsGetStatusResult',
               'DatasetRemoveFromExclusionList' => 'MyElements::DatasetRemoveFromExclusionList',
               'DpJobScheduleGetLastChangedResult/LastChangedTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VolumeListInfoIterStart/IsSnapvaultSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleContentGetResult' => 'MyElements::DfmScheduleContentGetResult',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'HostAgentOssvServiceStart' => 'MyElements::HostAgentOssvServiceStart',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DynamicReferenceCount' => 'MyTypes::DatasetInfo::_DynamicReferenceCount',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'PerfGetCounterDependentsResult/Views/PerfView/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/SourceStoragesetId' => 'MyTypes::DpBackupTransferInfo::_SourceStoragesetId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSize/SizeUsed' => 'MyTypes::AggregateSize::_SizeUsed',
               'DatasetSetStorageset/EditLockId' => 'MyElements::DatasetSetStorageset::_EditLockId',
               'HostRoleCreate/HostRole/HostRoleInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'DpPolicyModify/DpPolicyContent/Name' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterStart/BackupVersion' => 'MyTypes::DpTimestamp',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolume/MigrationRequestInfo/RunOnDemandUpdate' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewModify/View/PerfView/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'LunListInfoIterEnd' => 'MyElements::LunListInfoIterEnd',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolFreeVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo' => 'MyTypes::ProvisioningPolicyInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressNfsexportInfo' => 'MyTypes::ProgressNfsexportInfo',
               'CommentFieldModify' => 'MyElements::CommentFieldModify',
               'DpJobScheduleListIterNextResult' => 'MyElements::DpJobScheduleListIterNextResult',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/AdvancedOptions' => 'MyTypes::ArrayOfAdvancedOptionInfo',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeOptions/VolumeOption' => 'MyTypes::VolumeOption',
               'DatasetModify/DatasetMetadata/DfmMetadataField/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNext/Maximum' => 'MyElements::DatasetSpaceMetricListInfoIterNext::_Maximum',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectListInfoResult/Objects' => 'MyTypes::ArrayOfPerfObject',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerCreate/AllowedProtocols' => 'MyTypes::ArrayOfProtocol',
               'PerfObjectInstanceListIterNextResult/Instances' => 'MyTypes::ArrayOfPerfInstance',
               'ApplicationPolicyEditCommitResult' => 'MyElements::ApplicationPolicyEditCommitResult',
               'PerfThresholdTemplateListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupConfigInfo' => 'MyTypes::ProgressIgroupConfigInfo',
               'StorageServiceListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/MaxTime' => 'MyTypes::ApiStat::_MaxTime',
               'DpPolicyListIterStartResult/Records' => 'MyElements::DpPolicyListIterStartResult::_Records',
               'MigrateStartResult' => 'MyElements::MigrateStartResult',
               'PerfViewListIterNextResult/Views' => 'MyTypes::ArrayOfPerfView',
               'PerfViewAssociatedObjectsListResult/Objects/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'PerfObjectListInfoResult/Objects/PerfObject' => 'MyTypes::PerfObject',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DatasetModifyNode/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ApplicationResourceProperties/PropertyInfo' => 'MyTypes::PropertyInfo',
               'DfmScheduleCreate/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterStart/Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DfmScheduleDailyModifyResult' => 'MyElements::DfmScheduleDailyModifyResult',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostCapabilityListIterNext/Maximum' => 'MyElements::HostCapabilityListIterNext::_Maximum',
               'NetifIpInterfaceListInfoResult' => 'MyElements::NetifIpInterfaceListInfoResult',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'GroupMove' => 'MyElements::GroupMove',
               'DpOssvApplicationListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo/RelationshipSource' => 'MyTypes::ObjName',
               'ProvisioningPolicyEditBegin' => 'MyElements::ProvisioningPolicyEditBegin',
               'ResourcepoolListInfoIterStart' => 'MyElements::ResourcepoolListInfoIterStart',
               'PerfGetDefaultView/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'DiskListInfoIterNextResult/Disks/DiskInfo/HostId' => 'MyTypes::ObjId',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'ReportScheduleAdd/ReportScheduleInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/MirrorScheduleId' => 'MyTypes::ObjId',
               'ReportListInfoIterStart/ReportApplication' => 'MyTypes::ReportApplication',
               'DpOssvDirectoryDiscoveredIterNextResult' => 'MyElements::DpOssvDirectoryDiscoveredIterNextResult',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/AggregateId' => 'MyTypes::ObjId',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/TimeTo' => 'MyTypes::AlarmInfo::_TimeTo',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/AnonymousAccessUser' => 'MyTypes::NfsExportRules::_AnonymousAccessUser',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentSetObjectValueResult' => 'MyElements::CommentSetObjectValueResult',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpOssvDirectoryDiscoveredIterNext' => 'MyElements::DpOssvDirectoryDiscoveredIterNext',
               'PerfViewGetDataResult/DynamicData' => 'MyTypes::ArrayOfDynamicData',
               'ApplicationPolicyListIterNextResult/Records' => 'MyElements::ApplicationPolicyListIterNextResult::_Records',
               'PerfGetCounterDataResult' => 'MyElements::PerfGetCounterDataResult',
               'HostUserAdd/HostUser/HostUserInfo/Password' => 'MyTypes::HostUserPassword',
               'AuditLogAddEntry/AuditType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostModifyAgentCredentials/OsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetRemoveMember/DatasetMemberParameters/DatasetMemberParameter/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'EventListIterStart/IsOldestFirst' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LunDestroyResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportScheduleDisableResult' => 'MyElements::ReportScheduleDisableResult',
               'DpAgentListUpgradeCandidatesResult/DpAgentVersionInfos/DpAgentVersionInfo/DpAgentName' => 'MyTypes::ObjName',
               'DatasetExclusionListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Group/GroupResource/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/CifsAclList/CifsAcl/AccessRights' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/CollectionPeriod' => 'MyTypes::HostClientStats::_CollectionPeriod',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsDpOrphan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectInstanceListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateId' => 'MyTypes::ObjId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/DataUnavailableReason' => 'MyTypes::ArrayOfPerfStatusError',
               'PerfViewGetData/Direction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos' => 'MyTypes::ArrayOfAggregateSpaceInfo',
               'DatasetCreate/DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsAgentOssvEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostModify/HostModifyInfo/HostUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterNextResult/DpAgents' => 'MyTypes::ArrayOfDpAgentInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyEditBegin/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleModify' => 'MyElements::DfmScheduleModify',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfEnableDataCollection' => 'MyElements::PerfEnableDataCollection',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterNext' => 'MyElements::DpOssvDirectoryRootsIterNext',
               'DpRestoreViStart/DpViRestoreSettings/DpViVmwareRestoreSettings/StartVmAfterRestore' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleListInfoIterStart/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityRemove/DeleteAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/ProtectionPolicyId' => 'MyTypes::ObjId',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/Timestamp' => 'MyTypes::DpTimestamp',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DatasetRemoveMember/DatasetMemberParameters/DatasetMemberParameter/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DpScheduleDependency/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DedupeMemberRequestInfo' => 'MyTypes::DedupeMemberRequestInfo',
               'ReportScheduleEnable' => 'MyElements::ReportScheduleEnable',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/RelationshipId' => 'MyTypes::ObjId',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationType' => 'MyTypes::RelationshipEndpointType',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/MaximumSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace',
               'HostUserModify/HostUser/HostUserInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'LunListInfoIterNextResult/Luns/LunInfo/LunSerialNumber' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/Records' => 'MyElements::PerfThresholdListInfo2IterNextResult::_Records',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupVersion' => 'MyTypes::DpTimestamp',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate' => 'MyTypes::WrapperOfAggregateResource',
               'GroupRename' => 'MyElements::GroupRename',
               'VolumeListInfoIterStart/SnapvaultSecondaryScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ClientRegistryDestroy/Match' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassAddCustomResult' => 'MyElements::EventclassAddCustomResult',
               'DpThrottleDestroy/ThrottleId' => 'MyElements::DpThrottleDestroy::_ThrottleId',
               'HostUserListIterStart' => 'MyElements::HostUserListIterStart',
               'PerfViewGetData/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmRelatedObjectsListInfoResult/ParentResourcepoolList/ParentResourcepool' => 'MyTypes::ParentResourcepool',
               'DatasetMissingMemberListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsLinuxPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyListIterStart/IsPolicyReadonly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRelationshipListInfoIterStart/DestinationId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostModify/HostModifyInfo/AdminPort' => 'MyTypes::IpPortNumber',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ResourceStatus' => 'MyTypes::ObjStatus',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'ReportGraphListInfoIterStart/ReportApplication' => 'MyTypes::ReportApplication',
               'DpOssvDirectoryDiscoveredIterStartResult' => 'MyElements::DpOssvDirectoryDiscoveredIterStartResult',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/FromNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Vfiler' => 'MyTypes::WrapperOfVfilerResource',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/VirtualCenterReference/VirtualCenterId' => 'MyTypes::ObjId',
               'ReportOutputRead/Length' => 'MyElements::ReportOutputRead::_Length',
               'DfmScheduleListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DpJobProgressEventListIterNextResult/Records' => 'MyElements::DpJobProgressEventListIterNextResult::_Records',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/IsFullyPropagated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobContextObjName' => 'MyTypes::ObjFullName',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/NisDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDestroyResult' => 'MyElements::DpScheduleDestroyResult',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/GroupId' => 'MyTypes::AlarmInfo::_GroupId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'GroupRename/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'PerfGetCounterDependentsResult/ThresholdTemplates/ThresholdTemplate' => 'MyTypes::ThresholdTemplate',
               'ReportDesignerScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DfmScheduleWeeklySubscheduleAdd/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo' => 'MyTypes::DatasetMemberInfo',
               'SnapshotListInfoIterEnd' => 'MyElements::SnapshotListInfoIterEnd',
               'ReportScheduleListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap' => 'MyTypes::ArrayOfDatasetMapEntry',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/DnsServers/IpAddress' => 'MyTypes::IpAddress',
               'IfcListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/EnvironmentVariableList/EnvironmentVariableInfo' => 'MyTypes::EnvironmentVariableInfo',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DatasetSetResult' => 'MyElements::DatasetSetResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/HostResourcepool' => 'MyTypes::ObjName',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult' => 'MyTypes::ConformanceRunResult',
               'DatasetExclusionListInfoIterStart' => 'MyElements::DatasetExclusionListInfoIterStart',
               'DfmRelatedObjectsListInfo/IncludeIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/MaximumY' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult' => 'MyElements::DpBackupListIterNextResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/IpBindings/IpBindingInfo/VlanIdentifier' => 'MyTypes::IpBindingInfo::_VlanIdentifier',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpBackupGetLocation' => 'MyElements::DpBackupGetLocation',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'DatasetCreate/ApplicationPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfo2IterEnd' => 'MyElements::PerfThresholdListInfo2IterEnd',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/UndedupeMemberRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'DpRelationshipListInfoIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GraphDataListInfo/StartDate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId' => 'MyTypes::WrapperOfQtreeNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceJobId' => 'MyTypes::ObjId',
               'DatasetListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'SnapshotGetReclaimableInfo/Snapshots/Snapshot/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'EventclassAddCustom/AboutMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterStart/IsSuccessful' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmRelatedObjectsListInfoResult/ParentObjectList/ParentObject/Name' => 'MyTypes::ObjName',
               'DatasetSpaceMetricListInfoIterStart/Month' => 'MyTypes::Month',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourceTag' => 'MyTypes::ResourceTag',
               'ViVirtualDiskListInfoIterStartResult' => 'MyElements::ViVirtualDiskListInfoIterStartResult',
               'DpGetDatasetBackupJobsData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'AggregateListInfoIterStart/AggregateType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/CreateNewVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewCreate/View/PerfView' => 'MyTypes::PerfView',
               'ApplicationPolicyEditCommit/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'ProvisioningPolicyCreateResult' => 'MyElements::ProvisioningPolicyCreateResult',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolContact' => 'MyTypes::EmailAddressList',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'AlarmCreate/AlarmInfo/IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'SnapshotListInfoIterStart/IncludeBackupInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo' => 'MyTypes::DatasetSpaceInfo',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStartResult' => 'MyElements::AggregateListInfoIterStartResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems' => 'MyTypes::ArrayOfProtectionStatusProblem',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'MigrateCancelResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AlarmCreate/AlarmInfo/PagerEmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'CommentFieldCreate/CommentFieldInfo/CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'VfilerTemplateListInfoIterNextResult' => 'MyElements::VfilerTemplateListInfoIterNextResult',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Properties' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCollectClientOperationStatisticsResult/Errors/ClientStatError/CifsError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DatacenterReference/DatacenterId' => 'MyTypes::ObjId',
               'DfmSnmpSettingsListInfo/SnmpId' => 'MyTypes::SnmpId',
               'DfmMonitorTimestampListResult/DfmMonitoringTimestamps/DfmMonitoringTimestamp/LastMonitoringTimestamp' => 'MyTypes::DfmMonitoringTimestamp::_LastMonitoringTimestamp',
               'DpScheduleWeeklySubscheduleAdd/EndDayOfWeek' => 'MyElements::DpScheduleWeeklySubscheduleAdd::_EndDayOfWeek',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'ReportGraphListInfoIterNext/Maximum' => 'MyElements::ReportGraphListInfoIterNext::_Maximum',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/NearlyFullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_NearlyFullThreshold',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/NisServers' => 'MyTypes::ArrayOfIpAddress',
               'PerfCopyCounterConfigurationResult' => 'MyElements::PerfCopyCounterConfigurationResult',
               'AggregateSpaceManagementRemoveOperation' => 'MyElements::AggregateSpaceManagementRemoveOperation',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'DpOssvDirectoryDiscoveredIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViDatastoreListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'EventclassAddCustom' => 'MyElements::EventclassAddCustom',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo' => 'MyTypes::DpPolicyNodeInfo',
               'DpThrottleModify' => 'MyElements::DpThrottleModify',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'ViDatastoreListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpLocalSnapshotJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'EventListIterNextResult/Events/EventInfo/EventAcknowledgedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/ScheduleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupMemberListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'VfilerCreateResult/VfilerId' => 'MyTypes::ObjId',
               'SrmFileTypeAddResult' => 'MyElements::SrmFileTypeAddResult',
               'DpAgentStoragesystemListInfoIterStart/DpAgentNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleListInfoIterStart' => 'MyElements::DpThrottleListInfoIterStart',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'HostUserModify/HostUser' => 'MyTypes::WrapperOfHostUserInfo',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/RunTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacAccessCheck/Resource/ResourceIdentifier/StorageService/StorageServiceResource' => 'MyTypes::StorageServiceResource',
               'PerfThresholdListInfo2IterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'CommentFieldDestroy' => 'MyElements::CommentFieldDestroy',
               'DfmRelatedObjectsListInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterListNotInViewResult' => 'MyElements::PerfGetCounterListNotInViewResult',
               'DpJobListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberUndedupeStart/UndedupeMemberRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'ReportOutputRead' => 'MyElements::ReportOutputRead',
               'DpOssvApplicationRestoreDestinationListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModify/HostUser/HostUserInfo' => 'MyTypes::HostUserInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Size' => 'MyTypes::ProvisionMemberRequestInfo::_Size',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/AfsData' => 'MyTypes::VolumeSize::_AfsData',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'HostUserModify/HostUser/HostUserInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo' => 'MyTypes::DpPolicyConnectionInfo',
               'EventListIterNextResult/Events/EventInfo/EventTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterStart/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedApplicationResources/ApplicationResourceInfo/ApplicationObjectType' => 'MyTypes::ApplicationObjectType',
               'ReportDesignerScheduleDelete/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetAddResourcepool' => 'MyElements::DatasetAddResourcepool',
               'DfmSnmpSettingAdd/PrivacyPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupPushResult' => 'MyElements::HostUsergroupPushResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource' => 'MyTypes::VfilerTemplateResource',
               'RbacRoleDeleteResult' => 'MyElements::RbacRoleDeleteResult',
               'AlarmModify/AlarmInfo/EventSeverity' => 'MyTypes::ObjStatus',
               'NetifIpInterfaceListInfo/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmGetApiStatistics' => 'MyElements::DfmGetApiStatistics',
               'AlarmModify/AlarmInfo/PagerAdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageListResult/DpAgentPackages/DpAgentPackageInfo/PackageVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageListResult/DpAgentPackages/DpAgentPackageInfo' => 'MyTypes::DpAgentPackageInfo',
               'DpBackupVersionListIterStart' => 'MyElements::DpBackupVersionListIterStart',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'LunListInfoIterNextResult/Luns/LunInfo/QtreeId' => 'MyTypes::ObjId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/MigrationIncompatibilityReasons/MigrationIncompatibilityReason' => 'MyTypes::MigrationIncompatibilityReason',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/VolumeId' => 'MyTypes::ObjId',
               'DpPolicyGetDefaultPropertyValuesResult/LagErrorThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'CommentFieldModifyResult' => 'MyElements::CommentFieldModifyResult',
               'PerfViewCreate/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/HostId' => 'MyTypes::ObjId',
               'EventclassListResult/EventClasses/EventClassInfo/EventNames/EventNameInfo' => 'MyTypes::EventNameInfo',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleDelete/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo' => 'MyTypes::HostUsergroupInfo',
               'CommentFieldListInfoIterStart' => 'MyElements::CommentFieldListInfoIterStart',
               'GroupSetOptionsResult' => 'MyElements::GroupSetOptionsResult',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/WeeklyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionDuration',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'DpRestoreToPrimary/CheckSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'PerfThresholdDelete/ThresholdId' => 'MyTypes::ThresholdId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCredentials/NdmpPassword' => 'MyTypes::HostPassword',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/IpAddressType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/CommentFieldId' => 'MyTypes::CommentFieldId',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DatasetProvisionMember' => 'MyElements::DatasetProvisionMember',
               'ResourcepoolAddMember/ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingModify/SnmpAuthenticationPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNext/Maximum' => 'MyElements::DpPolicyListIterNext::_Maximum',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicyName' => 'MyTypes::ObjName',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmRelatedObjectsListInfoResult/ChildCountList/ChildCount/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleRename/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmSnmpSettingsListInfoResult' => 'MyElements::DfmSnmpSettingsListInfoResult',
               'DpBackupVersionModify/BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/MonthlyRetentionCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'SnapshotListInfoIterStart' => 'MyElements::SnapshotListInfoIterStart',
               'DatasetMemberDedupeAbortResult' => 'MyElements::DatasetMemberDedupeAbortResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'PerfThresholdTemplateAttachObjects/NewObjects/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'DfmSnmpSettingDelete/SnmpId' => 'MyTypes::SnmpId',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo/IsLeaf' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreToPrimaryResult/JobId' => 'MyElements::DpRestoreToPrimaryResult::_JobId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'HostUserListIterStart/HostUsergroupNameOrId' => 'MyTypes::UsergroupNameOrId',
               'EventclassList/EventClassObjects/EventClassObject/EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetReplacePrimaryMembers/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'DpBackupVersionModify/DpBackupTransferInfo/ConnectionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterStart/CommentFieldObjectTypes/CommentFieldObjectType' => 'MyTypes::CommentFieldObjectType',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAddOssv/NdmpCredentials' => 'MyTypes::WrapperOfFullNdmpCredentials',
               'HostRoleListIterEndResult' => 'MyElements::HostRoleListIterEndResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'DpScheduleMonthlySubscheduleSetResult' => 'MyElements::DpScheduleMonthlySubscheduleSetResult',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo' => 'MyTypes::DpBackupContentInfo',
               'DiskListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserAddResult' => 'MyElements::HostDomainuserAddResult',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ResourcepoolId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/SnapmirrorAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'GraphDataListInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup' => 'MyTypes::PerfCounterGroup',
               'DatasetMemberUndedupeStart/UndedupeMemberRequestInfo' => 'MyTypes::UndedupeMemberRequestInfo',
               'StorageServiceDatasetProvisionResult/DatasetId' => 'MyTypes::ObjId',
               'HostSetOption/HostOptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/Snapshots' => 'MyTypes::ArrayOfSnapshot',
               'TimezoneGetDefaultsResult/TimezoneDefaults' => 'MyTypes::TimezoneDefaults',
               'DatasetEditBeginResult' => 'MyElements::DatasetEditBeginResult',
               'GraphListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/SnapshotReserve' => 'MyTypes::SpaceMeasurement::_SnapshotReserve',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmObjectsGetStatusResult/ObjectsStatus/ObjStatusInfo' => 'MyTypes::ObjStatusInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo' => 'MyTypes::DpBackupInfo',
               'GraphListInfoIterEndResult' => 'MyElements::GraphListInfoIterEndResult',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/DestinationFilerId' => 'MyTypes::ObjId',
               'UserRecentReportListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupStartResult/JobId' => 'MyElements::DpBackupStartResult::_JobId',
               'HostAddOssv' => 'MyElements::HostAddOssv',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/NisServers/IpAddress' => 'MyTypes::IpAddress',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'PerfCounterGroupGetData/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'DiskListInfoIterNextResult/Disks/DiskInfo/HostName' => 'MyTypes::ObjName',
               'DpJobScheduleListIterStartResult' => 'MyElements::DpJobScheduleListIterStartResult',
               'DpScheduleWeeklySubscheduleAdd/StartDayOfWeek' => 'MyElements::DpScheduleWeeklySubscheduleAdd::_StartDayOfWeek',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'PerfStatusGetResult/DataUnavailableReason/PerfStatusError' => 'MyTypes::PerfStatusError',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Host/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetListInfoIterStart/IncludeProtectionStatusProblems' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetData/IsDynamic' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetProvisionMember/ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'DfmScheduleWeeklyModify/WeeklyContent/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'HostUserAdd/HostUser/HostUserInfo/MinimumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ApplicationPolicyListIterNextResult' => 'MyElements::ApplicationPolicyListIterNextResult',
               'SrmFileTypeDeleteResult' => 'MyElements::SrmFileTypeDeleteResult',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'PerfViewModify/View/PerfView/Charts/PerfChart/ChartName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo' => 'MyTypes::ProgressVolumeOptionInfo',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'ResourcepoolListInfoIterStart/DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedDatasets/MaxDatasets' => 'MyElements::DpDashboardGetLaggedDatasets::_MaxDatasets',
               'StorageServiceDatasetListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DpScheduleDailyModify/DailyContent' => 'MyTypes::WrapperOfDailyInfo',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates' => 'MyTypes::ArrayOfVfilerTemplateInfo',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpJobListIterNextResult/Jobs/DpJobInfo/CompletedTimestamp' => 'MyTypes::DpTimestamp',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQtreeInfo/QtreeName' => 'MyTypes::ObjFullName',
               'ViDatacenterListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesAvailable' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable',
               'DatasetResizeMember/ResizeMemberRequestInfo' => 'MyTypes::ResizeMemberRequestInfo',
               'DpScheduleWeeklyModify/WeeklyContent/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'HostRoleDelete' => 'MyElements::HostRoleDelete',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'ViHypervisorListInfoIterEndResult' => 'MyElements::ViHypervisorListInfoIterEndResult',
               'HostModify/HostModifyInfo/HostPassword' => 'MyTypes::HostPassword',
               'HostCapabilityListIterStartResult/Records' => 'MyElements::HostCapabilityListIterStartResult::_Records',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents' => 'MyTypes::ArrayOfSnapshotMemberInfo',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/SanContainerSettings' => 'MyTypes::SanContainerSettings',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Filer/FilerResource' => 'MyTypes::FilerResource',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/FullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_FullThreshold',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationResourceNamespaces/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'ClientRegistryDestroy' => 'MyElements::ClientRegistryDestroy',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'PerfViewCreate/View/PerfView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterStart/IncludeConformanceRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentSetObjectValue/CommentValue' => 'MyTypes::CommentValue',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassAddCustom/EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterStartResult' => 'MyElements::QtreeListInfoIterStartResult',
               'QtreeListInfoIterEnd' => 'MyElements::QtreeListInfoIterEnd',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/MigrationIncompatibilityReasons' => 'MyTypes::ArrayOfMigrationIncompatibilityReason',
               'PerfClientStatsListInfoIterStartResult/Records' => 'MyElements::PerfClientStatsListInfoIterStartResult::_Records',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'PerfClientStatsListInfoIterEndResult' => 'MyElements::PerfClientStatsListInfoIterEndResult',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterStart/VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'PerfObjectDependentCounterListInfo/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetServerStatusResult/PerfServerStatus/ObjectUpdateStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize' => 'MyTypes::VolumeSize',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree' => 'MyTypes::WrapperOfQtreeResource',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/AutoDeleteSnapshots' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'LunListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter' => 'MyTypes::PerfMissingHostObjectCounter',
               'VolumeListInfoIterStart/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreViStart' => 'MyElements::DpRestoreViStart',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'CommentFieldValuesListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyResult' => 'MyElements::DatasetModifyResult',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/SanContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacAccessCheck/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterStart' => 'MyElements::ViHypervisorListInfoIterStart',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DatacenterReference/DatacenterName' => 'MyTypes::ObjName',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/VfilerName' => 'MyTypes::ObjFullName',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo' => 'MyTypes::DayInfo',
               'PerfThresholdCreate2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/ProvisioningPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/BackupScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmMonitorTimestampListResult/DfmMonitoringTimestamps/DfmMonitoringTimestamp/MonitorName' => 'MyTypes::MonitorName',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'MigrateCleanupResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewGetData/Duration' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeName' => 'MyTypes::ObjName',
               'DpPolicyCopy/TemplateDpPolicyId' => 'MyTypes::ObjId',
               'RbacRoleAdminInfoListResult/AdminNameOrId/RbacAdminNameOrId' => 'MyTypes::RbacAdminNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/MirrorScheduleId' => 'MyTypes::ObjId',
               'CommentFieldModify/CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
               'PerfObjectInstanceListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/CopyResult/DestinationHostInfo/HostName' => 'MyTypes::ObjFullName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'PerfObjectCounterListInfoResult/Counters' => 'MyTypes::ArrayOfPerfCounter',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/DiskFreeSpacePercent' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/OperationalStatuses' => 'MyTypes::ArrayOfOperationalStatus',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/IsDisableAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserPush/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostUserModifyPassword/OldPassword' => 'MyTypes::HostUserPassword',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId' => 'MyTypes::WrapperOfLunNameOrId',
               'GroupSetOptions' => 'MyElements::GroupSetOptions',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ViVirtualDiskListInfoIterNextResult/Records' => 'MyElements::ViVirtualDiskListInfoIterNextResult::_Records',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/UsedSpace' => 'MyTypes::SpaceInfo::_UsedSpace',
               'PerfViewModify/View/PerfView/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleListInfoIterStart/ReportApplication' => 'MyTypes::ReportApplication',
               'PerfObjectCounterListInfo/IncludeCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateModify/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup' => 'MyTypes::PerfCounterGroup',
               'QtreeListInfoIterNextResult/Records' => 'MyElements::QtreeListInfoIterNextResult::_Records',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/FailoverScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreateResult' => 'MyElements::ApplicationPolicyCreateResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupMetadata/DfmMetadata/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Dataset' => 'MyTypes::WrapperOfDatasetResource',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DfmScheduleMonthlyModifyResult' => 'MyElements::DfmScheduleMonthlyModifyResult',
               'RbacAdminRoleInfoListResult/AdminList/RbacAdminOrUsergroup/AdminOrUsergroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetCreate' => 'MyElements::DatasetCreate',
               'CommentFieldDestroy/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/CallCount' => 'MyTypes::ApiStat::_CallCount',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters' => 'MyTypes::ArrayOfVirtualCenter',
               'PerfViewAssociatedObjectsListResult/Objects/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/GuaranteedSpace' => 'MyTypes::SpaceMeasurement::_GuaranteedSpace',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'ViDatastoreListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetName' => 'MyTypes::ObjName',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterStart' => 'MyElements::DpAgentListInfoIterStart',
               'DfmScheduleMonthlySubscheduleUnsetResult' => 'MyElements::DfmScheduleMonthlySubscheduleUnsetResult',
               'ApplicationPolicyCopy/SourcePolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'HostUsergroupModify' => 'MyElements::HostUsergroupModify',
               'AggregateSpaceManagementRollback' => 'MyElements::AggregateSpaceManagementRollback',
               'DatasetSet' => 'MyElements::DatasetSet',
               'DpOssvDirectoryDiscoveredIterNext/Maximum' => 'MyElements::DpOssvDirectoryDiscoveredIterNext::_Maximum',
               'DatasetListInfoIterStart/ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreateResult/ApplicationPolicyId' => 'MyTypes::ObjId',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo' => 'MyTypes::HourlyInfo',
               'DatasetCreate/IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleRename/NewScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdListInfo2IterNext' => 'MyElements::PerfThresholdListInfo2IterNext',
               'DpDashboardGetLaggedRelationships' => 'MyElements::DpDashboardGetLaggedRelationships',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DfmScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume' => 'MyTypes::WrapperOfVolumeResource',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/PagerAdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'DfmAboutResult/SerialNumber' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleDependency/ThrottleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'GroupCreate/ParentGroupNameOrId' => 'MyTypes::GroupNameOrId',
               'AggregateListInfoIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentStoragesystemListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo' => 'MyTypes::DpBackupVersionInfo',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/BackupDeletionRequestInfo/BackupIds/BackupId' => 'MyTypes::BackupId',
               'DpAgentListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'DfmRelatedObjectsListInfoResult/ParentResourcepoolList/ParentResourcepool/Name' => 'MyTypes::ObjName',
               'DpPolicyEditBeginResult/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Group/GroupResource/GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'CommentFieldValuesListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleAdd/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'AlarmModify/AlarmInfo/PagerEmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'PerfCounterGroupListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/PolicyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewDestroy/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'DfmBackupScheduleSet/RepeatInterval' => 'MyElements::DfmBackupScheduleSet::_RepeatInterval',
               'DiskListInfoIterNextResult/Disks/DiskInfo/DiskType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/NdmpAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo' => 'MyTypes::DatasetInfo',
               'DpScheduleDailyModify/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateId' => 'MyTypes::ObjId',
               'DpRestoreToPrimaryResult' => 'MyElements::DpRestoreToPrimaryResult',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'ApplicationPolicyListIterEnd' => 'MyElements::ApplicationPolicyListIterEnd',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo' => 'MyTypes::SnapshotMemberInfo',
               'RbacAdminRoleAddResult/AdminNameOrId/RbacAdminNameOrId/AdminId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDelete/IgnoreHostInUse' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails' => 'MyTypes::ArrayOfPerfPurgedObjectCountersDetails',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphDataListInfoResult/GraphLineValues/GraphLineValueInfo' => 'MyTypes::GraphLineValueInfo',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/IsDeprecated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingModify/SnmpAuthenticationLogin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/WeeklyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionCount',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserAdd/HostUser/HostUserInfo/FullName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode' => 'MyTypes::WrapperOfMetricDatasetNodeInfo',
               'GroupGetOptionsResult/GroupOptionInfo/SrmMaxOldAtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldAtimeFiles',
               'DfmScheduleWeeklyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterStart/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource' => 'MyTypes::ResourcePoolResource',
               'DfmScheduleHourlyDeleteResult' => 'MyElements::DfmScheduleHourlyDeleteResult',
               'AggregateListInfoIterNextResult/Aggregates' => 'MyTypes::ArrayOfAggregateInfo',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/VolumeId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/RoleNameAndId/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'HostSetOptionResult' => 'MyElements::HostSetOptionResult',
               'ReportScheduleAdd/ReportScheduleInfo/ArchivalFormat' => 'MyTypes::ReportOutputFormat',
               'ReportDesignerScheduleModify/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmAboutResult/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo' => 'MyTypes::DpOssvDirectoryInfo',
               'PerfClientStatsPurge/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/OssvApplicationRestoreDestinationList/OssvApplicationRestoreDestinationInfo/HostId' => 'MyTypes::ObjId',
               'AlarmCreate/AlarmInfo/TimeFrom' => 'MyTypes::AlarmInfo::_TimeFrom',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'HostUsergroupListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupSetOptions/GroupOptionInfo' => 'MyTypes::GroupOptionInfo',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserRecentReportDelete/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'LunListInfoIterNextResult/Luns/LunInfo/LunId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AlarmListInfoIterNextResult/Records' => 'MyElements::AlarmListInfoIterNextResult::_Records',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterStart/MetaDataOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo' => 'MyTypes::VersionMemberInfo',
               'PerfThresholdModifyResult' => 'MyElements::PerfThresholdModifyResult',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'ReportCategoryList' => 'MyElements::ReportCategoryList',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'MigrateComplete/PersistentMigratedRoutes' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostAddOssv/NdmpCredentials/FullNdmpCredentials/NdmpUsername' => 'MyTypes::NdmpUsername',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/GuaranteedSpace' => 'MyTypes::SpaceMeasurement::_GuaranteedSpace',
               'PerfDiagTroubleshoot/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfViewCreate/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/StorageService' => 'MyTypes::WrapperOfStorageServiceResource',
               'MigrateStartResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/VfilerTemplateName' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterStart/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementRollbackResult' => 'MyElements::AggregateSpaceManagementRollbackResult',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek/DayOfWeek' => 'MyTypes::DayOfWeek',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetDrDatasetCountsResult' => 'MyElements::DpDashboardGetDrDatasetCountsResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'PerfGetCounterDataResult/InvalidCounterInstances' => 'MyTypes::ArrayOfInvalidCounterInstance',
               'DfmAboutResult/LicensedFeatures/Feature/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/DiskFreeSpace' => 'MyTypes::DirectoryInfo::_DiskFreeSpace',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentDiscover' => 'MyElements::DpAgentDiscover',
               'MigrateStart/IpBindings/IpBindingInfo/Interface' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsShareNames/CifsShareName' => 'MyTypes::CifsShareName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'CommentFieldListInfoIterEnd' => 'MyElements::CommentFieldListInfoIterEnd',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult' => 'MyElements::RbacRoleInfoListResult',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/HostId' => 'MyTypes::ObjId',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DfmScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/CifsShareName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'HostUserModify/HostUser/HostUserInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'DpScheduleListInfoIterStart/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'PerfViewGetDataResult/DynamicData/DynamicData/ObjId' => 'MyTypes::ObjId',
               'DatasetCreate/ApplicationInfo/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventDeleteResult/EventsDeletedList/EventActionInfo/Timestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunMapInfo/LunName' => 'MyTypes::ObjFullName',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/VolumeId' => 'MyTypes::ObjId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId' => 'MyTypes::LunNameOrId',
               'PerfViewAssociatedObjectsListResult/Objects/ObjectInfo' => 'MyTypes::ObjectInfo',
               'PerfThresholdTemplateCreate/TemplateDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
               'PerfThresholdTemplateListInfoIterEndResult' => 'MyElements::PerfThresholdTemplateListInfoIterEndResult',
               'DpThrottleItemAdd' => 'MyElements::DpThrottleItemAdd',
               'AggregateModify/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'TimezoneListInfoIterStartResult' => 'MyElements::TimezoneListInfoIterStartResult',
               'PerfCounterGroupStop' => 'MyElements::PerfCounterGroupStop',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleMonthlyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventSourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterStartResult/Records' => 'MyElements::DpBackupListIterStartResult::_Records',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/IsApplicationResponsibleForPrimaryBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldListInfoIterEndResult' => 'MyElements::CommentFieldListInfoIterEndResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/CreationTimestamp' => 'MyTypes::DpTimestamp',
               'EventclassList/EventClassObjects/EventClassObject' => 'MyTypes::EventClassObject',
               'ApiProxyResult/Response/Errno' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDataResult' => 'MyElements::PerfCounterGroupGetDataResult',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo' => 'MyTypes::WrapperOfPerfObjectCounter',
               'DfmAboutResult/ProvMgrNodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetChangeDrState' => 'MyElements::DatasetChangeDrState',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'PerfThresholdModify/Attributes/ThresholdInfo/ThresholdUnit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo' => 'MyTypes::DpRelationshipInfo',
               'GroupMemberListIterNextResult/GroupMemberList' => 'MyTypes::ArrayOfGroupMemberInfo',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'MigrateVolume/MigrationRequestInfo/CleanupStaleStorage' => 'MyTypes::CleanupStaleStorage',
               'ViVirtualCenterListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DpDashboardGetProtectedDataCountsResult/UnprotectedDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_UnprotectedDatasetCount',
               'PerfViewCreate/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DpBackupVersionModify/DpBackupTransferInfo/DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeId' => 'MyTypes::ObjId',
               'ApplicationPolicyListIterNext/Maximum' => 'MyElements::ApplicationPolicyListIterNext::_Maximum',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/AlarmScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/ChartName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/SnapshotScheduleName' => 'MyTypes::ObjName',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/ReportId' => 'MyTypes::ReportInfo::_ReportId',
               'HostGetDefaultsResult/HostDefaults/AdminPortCacheHttps' => 'MyTypes::IpPortNumber',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentValue' => 'MyTypes::CommentValue',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSize/SpaceTotalCommitted' => 'MyTypes::AggregateSize::_SpaceTotalCommitted',
               'RbacAdminListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/TrapDestinations/TrapDestination' => 'MyTypes::TrapDestination',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/SnapshotReserveUsed' => 'MyTypes::VolumeSize::_SnapshotReserveUsed',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/DestinationPathSkipExtraDirectory' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'DatasetRemoveResourcepoolResult' => 'MyElements::DatasetRemoveResourcepoolResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunMapInfo/IgroupName' => 'MyTypes::ObjFullName',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/NodeId' => 'MyTypes::DpBackupIdInfo::_NodeId',
               'DpRestoreToPrimary/Paths/DpPathInfo' => 'MyTypes::DpPathInfo',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'DpScheduleMonthlyModify' => 'MyElements::DpScheduleMonthlyModify',
               'HostGetDefaultsResult/HostDefaults/UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo/SourceVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterStart/DynamicReferenceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModifyResult' => 'MyElements::VfilerTemplateModifyResult',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify' => 'MyElements::PerfThresholdModify',
               'PerfCounterGroupListIterNextResult' => 'MyElements::PerfCounterGroupListIterNextResult',
               'HostListInfoIterStartResult/Records' => 'MyElements::HostListInfoIterStartResult::_Records',
               'DpRelationshipModify' => 'MyElements::DpRelationshipModify',
               'DatasetSpaceMetricListInfoIterStartResult/Records' => 'MyElements::DatasetSpaceMetricListInfoIterStartResult::_Records',
               'DpOssvDirectoryDiscoveredIterStart' => 'MyElements::DpOssvDirectoryDiscoveredIterStart',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateStatus' => 'MyTypes::ObjStatus',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolContact' => 'MyTypes::EmailAddressList',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/DestinationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectsGetStatusResult/ObjectsStatus/ObjStatusInfo/ObjectStatus' => 'MyTypes::ObjStatus',
               'DpScheduleListInfoIterNextResult' => 'MyElements::DpScheduleListInfoIterNextResult',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportOutputId' => 'MyTypes::ReportOutputInfo::_ReportOutputId',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterStartResult' => 'MyElements::ProvisioningPolicyListIterStartResult',
               'EventListIterNextResult/Events' => 'MyTypes::ArrayOfEventInfo',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/CpuMinTime' => 'MyTypes::ApiStat::_CpuMinTime',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterStart/StatId' => 'MyTypes::StatId',
               'DatasetModify/CheckProtectionPolicyOnCommit' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklySubscheduleModify/StartDayOfWeek' => 'MyElements::DfmScheduleWeeklySubscheduleModify::_StartDayOfWeek',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/TemplateId' => 'MyTypes::ThresholdTemplateInfo::_TemplateId',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets/DpDatasetLagInfo/DatasetId' => 'MyTypes::ObjId',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/IfcId' => 'MyTypes::ObjId',
               'DfmNetworkDelete' => 'MyElements::DfmNetworkDelete',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults' => 'MyTypes::ArrayOfConformanceRunResult',
               'EventAcknowledgeResult/EventsAcknowledgedList/EventActionInfo/ErrorMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled' => 'MyTypes::ArrayOfPerfDataSource',
               'DatasetMissingMemberListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo/CommentFieldId' => 'MyTypes::CommentFieldId',
               'ViVirtualDiskListInfoIterNext/Maximum' => 'MyElements::ViVirtualDiskListInfoIterNext::_Maximum',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/HostAddress' => 'MyTypes::IpAddress',
               'ClientRegistryGet/Match' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDeleteResult' => 'MyElements::HostDeleteResult',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'VfilerSetup/CifsDomainPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetRemoveResourcepool/EditLockId' => 'MyElements::DatasetRemoveResourcepool::_EditLockId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'DfmScheduleDailyDelete' => 'MyElements::DfmScheduleDailyDelete',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'DpScheduleMonthlyModify/MonthlyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterStart/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleGetResult/IsScheduleEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Host' => 'MyTypes::WrapperOfHostResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails/ProtectionStatusJobDetail' => 'MyTypes::ProtectionStatusJobDetail',
               'DpScheduleHourlyAdd' => 'MyElements::DpScheduleHourlyAdd',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/DatacenterId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd' => 'MyElements::ReportDesignerScheduleAdd',
               'HostListInfoIterNextResult/Records' => 'MyElements::HostListInfoIterNextResult::_Records',
               'RbacAccessCheck/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'DfmScheduleMonthlyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/MemberCount' => 'MyTypes::DatasetInfo::_MemberCount',
               'CifsDomainListInfoIterStartResult' => 'MyElements::CifsDomainListInfoIterStartResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupDestroyResult' => 'MyElements::PerfCounterGroupDestroyResult',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DatasetResizeMember' => 'MyElements::DatasetResizeMember',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/CifsAclList/CifsAcl/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterEnd' => 'MyElements::DpPolicyListIterEnd',
               'DatasetRemoveMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter' => 'MyTypes::DatasetDynamicReferenceParameter',
               'MigrateCancelResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/IsDpManaged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupMemberListIterStart/Groups/Group' => 'MyTypes::Group',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ProtectionPolicyId' => 'MyTypes::ObjId',
               'HostModify/HostModifyInfo/NdmpCredentials/NdmpPort' => 'MyTypes::IpPortNumber',
               'DfmBackupScheduleGetResult/BackupType' => 'MyTypes::BackupType',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetAccessDetails/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/ProtectionPolicyName' => 'MyTypes::ObjName',
               'HostAgentOssvServiceStop/Timeout' => 'MyElements::HostAgentOssvServiceStop::_Timeout',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement' => 'MyTypes::WrapperOfSpaceMeasurement',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo/DestinationVolumeOrQtreeId' => 'MyTypes::DpProgressSnapmirrorInfo::_DestinationVolumeOrQtreeId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterNextResult' => 'MyElements::HostDomainuserListIterNextResult',
               'HostModifyAgentCredentialsResult' => 'MyElements::HostModifyAgentCredentialsResult',
               'DfmBackupScheduleGetResult/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionListIterNextResult/Records' => 'MyElements::DpBackupVersionListIterNextResult::_Records',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterStart/IncludeMigrationInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/PercentageOfTotalBlocks' => 'MyTypes::SnapshotInfo::_PercentageOfTotalBlocks',
               'DatasetIoMetricListInfoIterNext/Maximum' => 'MyElements::DatasetIoMetricListInfoIterNext::_Maximum',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/UpdateServiceVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter' => 'MyTypes::Datacenter',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'VfilerTemplateCreateResult' => 'MyElements::VfilerTemplateCreateResult',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/UsedCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DfmScheduleCreate' => 'MyElements::DfmScheduleCreate',
               'DpAgentUpgradeResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetIoMetricListInfoIterNextResult' => 'MyElements::DatasetIoMetricListInfoIterNextResult',
               'DpThrottleDependencyResult/ThrottleAssignees/ThrottleAssignee/AssigneeId' => 'MyTypes::ObjId',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources' => 'MyTypes::ArrayOfBackupGraphResourceInfo',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventNames/EventNameInfo' => 'MyTypes::EventNameInfo',
               'DfmScheduleContentGet/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsReadonlyVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList' => 'MyTypes::ArrayOfScheduleContentInfo',
               'EventAcknowledgeResult/EventsAcknowledgedList/EventActionInfo/EventId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'EventStatusChangeListIterStart/TimeRange/EventTimestampRange' => 'MyTypes::EventTimestampRange',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventclassDeleteCustomResult' => 'MyElements::EventclassDeleteCustomResult',
               'AlarmCreate/AlarmInfo/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate' => 'MyElements::PerfThresholdTemplateCreate',
               'DfmScheduleWeeklySubscheduleModifyResult' => 'MyElements::DfmScheduleWeeklySubscheduleModifyResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/StatId' => 'MyTypes::StatId',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/HostServiceId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'ResourcepoolDestroyResult' => 'MyElements::ResourcepoolDestroyResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo' => 'MyTypes::DpBackupTransferInfo',
               'GroupAddMember/MemberNameOrId' => 'MyTypes::ObjectNameOrId',
               'DfmRelatedObjectsListInfoResult/ParentObjectList/ParentObject/Id' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo' => 'MyTypes::ApplicationBackupScheduleInfo',
               'PerfObjectDependentCounterListInfoResult/DependentCounters' => 'MyTypes::ArrayOfPerfDependentCounterInfo',
               'PerfGetServerStatus' => 'MyElements::PerfGetServerStatus',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'GroupAddMemberResult' => 'MyElements::GroupAddMemberResult',
               'DpAgentConfigureResult' => 'MyElements::DpAgentConfigureResult',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'PerfObjectCounterListInfo/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModify/HostUser/HostUserInfo/Password' => 'MyTypes::HostUserPassword',
               'DfmAboutResult/LicensedFeatures/Feature' => 'MyTypes::Feature',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo' => 'MyTypes::BackupGraphInfo',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'StorageServiceDatasetProvision/DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserRecentReportDelete' => 'MyElements::UserRecentReportDelete',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/IsApplicationBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleHourlyModify/HourlyContent' => 'MyTypes::WrapperOfHourlyInfo',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'AlarmModify/AlarmInfo/AlarmScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmDestroyResult' => 'MyElements::AlarmDestroyResult',
               'CommentFieldValuesListInfoIterNext/Maximum' => 'MyElements::CommentFieldValuesListInfoIterNext::_Maximum',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToPrimaryResult/SpaceStatusResults/SpaceStatusResult' => 'MyTypes::SpaceStatusResult',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections' => 'MyTypes::ArrayOfDpPolicyConnectionInfo',
               'DpThrottleModify/ThrottleContent/ThrottleItemList' => 'MyTypes::ArrayOfThrottleItemInfo',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'StorageServiceCreate/StorageServiceContact' => 'MyTypes::EmailAddressList',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleList' => 'MyElements::DpScheduleList',
               'HostGetDefaults' => 'MyElements::HostGetDefaults',
               'DpDashboardGetProtectedDataCounts2Result/ProtectedDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_ProtectedDatasetCount',
               'DatasetAddMember/EditLockId' => 'MyElements::DatasetAddMember::_EditLockId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/FilesLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleListInfoIterEndResult' => 'MyElements::DfmScheduleListInfoIterEndResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/SpaceAllocatedFromAggr' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolListInfoIterNextResult/Resourcepools' => 'MyTypes::ArrayOfResourcepoolInfo',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/SpaceOnDemand' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/FileType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'PerfCollectClientOperationStatisticsResult' => 'MyElements::PerfCollectClientOperationStatisticsResult',
               'AlarmModifyResult' => 'MyElements::AlarmModifyResult',
               'DiskListInfoIterNext' => 'MyElements::DiskListInfoIterNext',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupSetOptions/GroupOptionInfo/GroupContact' => 'MyTypes::EmailAddressList',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/EventStatus' => 'MyTypes::ObjStatus',
               'PerfViewListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminListInfoIterNextResult/Admins/AdminInfo/AdminId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterNext' => 'MyElements::DpBackupListIterNext',
               'SnapshotGetReclaimableInfo/Snapshots/Snapshot/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Comments' => 'MyTypes::ArrayOfProvisionMemberComment',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/AdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserRemove/HostUsergroupNamesOrIds' => 'MyTypes::ArrayOfHostUsergroupNameOrId',
               'DfmScheduleModify/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetModifyNodeResult' => 'MyElements::DatasetModifyNodeResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree' => 'MyTypes::VolumeQtree',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter/HostServiceId' => 'MyTypes::ObjId',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterEnd' => 'MyElements::CifsDomainListInfoIterEnd',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource' => 'MyTypes::VolumeResource',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/TargetObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupIsMemberOf/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/SpaceStatus' => 'MyTypes::SpaceStatus',
               'DpPolicyEditCommitResult' => 'MyElements::DpPolicyEditCommitResult',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents' => 'MyTypes::ArrayOfSnapshotMemberInfo',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo' => 'MyTypes::ApplicationPolicyInfo',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/HostNameOrId' => 'MyTypes::HostNameOrId',
               'DpRelationshipListInfoIterStart/SourceType' => 'MyTypes::RelationshipEndpointType',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationNodeId' => 'MyTypes::DpBackupTransferInfo::_DestinationNodeId',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedDatasets' => 'MyElements::DpDashboardGetLaggedDatasets',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/StartRemoteBackupAfterLocalBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostModify/HostModifyInfo/PerfAdvisorTransport' => 'MyTypes::PerfAdvisorTransport',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/FailoverScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DestroyMemberRequestInfo/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'DatasetRemoveMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart' => 'MyTypes::PerfChart',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/BackupTransferNeeded' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeStopMonitoring/QtreeNameOrId' => 'MyElements::QtreeStopMonitoring::_QtreeNameOrId',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/SoftLimit' => 'MyTypes::QtreeSizeInfo::_SoftLimit',
               'DpAgentPackageListResult' => 'MyElements::DpAgentPackageListResult',
               'DpScheduleWeeklySubscheduleDelete/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/DfmDirectories/DirectoryInfo' => 'MyTypes::DirectoryInfo',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditBeginResult/EditLockId' => 'MyElements::DatasetEditBeginResult::_EditLockId',
               'ViDatacenterListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectsGetStatusResult/ObjectsStatus/ObjStatusInfo/ObjectPerfStatus' => 'MyTypes::ObjStatus',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/InstanceCounterInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/HostServiceId' => 'MyTypes::ObjId',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SnapshotDeletionRequestInfo' => 'MyTypes::SnapshotDeletionRequestInfo',
               'StorageServiceDatasetProvisionResult' => 'MyElements::StorageServiceDatasetProvisionResult',
               'StorageServiceDatasetProvision/VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectListInfo/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterStart/SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/PrimaryId' => 'MyTypes::ObjId',
               'LunListInfoIterStart' => 'MyElements::LunListInfoIterStart',
               'DpRestoreToNewPath/BackupVersion' => 'MyTypes::DpTimestamp',
               'RbacAdminListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/AbortRequestedTimestamp' => 'MyTypes::DpTimestamp',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCommunicationStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'HostRolePush/HostRoleNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationResourceNamespaces' => 'MyTypes::ArrayOfApplicationResourceNamespace',
               'RbacAdminListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/StorageService/StorageServiceResource' => 'MyTypes::StorageServiceResource',
               'DpBackupVersionCreate/BackupMetadata/DfmMetadata/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'ResourcepoolAddMember/MoveIfExists' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentPlugins/DpAgentPluginInfo/PluginType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationRestoreDestinationListInfoIterStart/ApplicationNameOrId' => 'MyTypes::ObjNameOrId',
               'ViVirtualCenterListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/DedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupStartResult' => 'MyElements::DpBackupStartResult',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SnapshotDeletionRequestInfo/Snapshots' => 'MyTypes::ArrayOfSnapshot',
               'DpRelationshipListInfoIterStart/RelationshipStates/RelationshipState' => 'MyTypes::RelationshipState',
               'VfilerSetup/AllowedProtocols' => 'MyTypes::ArrayOfProtocol',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'DpScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentListUpgradeCandidatesResult/DpAgentVersionInfos/DpAgentVersionInfo' => 'MyTypes::DpAgentVersionInfo',
               'DpScheduleDestroy/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'DpBackupStart/VmwareBackupSettingsInfo/VmwareBackupScheduleSettingsInfo/IncludeIndependentDisks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource' => 'MyTypes::AggregateResource',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolMemberCount' => 'MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/StorageServiceName' => 'MyTypes::ObjName',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'HostCapabilityListIterNextResult' => 'MyElements::HostCapabilityListIterNextResult',
               'ResourcepoolListInfoIterStart/StorageReliability/SubSystemFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressJobAbortInfo' => 'MyTypes::DpProgressJobAbortInfo',
               'VfilerTemplateCopyResult' => 'MyElements::VfilerTemplateCopyResult',
               'PerfCounterGroupListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterNextResult/Luns/LunInfo/VolumeName' => 'MyTypes::ObjName',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminListInfoIterNextResult/Admins/AdminInfo/EmailAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'DpAgentStoragesystemListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetReplacePrimaryMembersResult/ReplaceResults' => 'MyTypes::ArrayOfReplaceResult',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'DpScheduleWeeklySubscheduleModify/StartDayOfWeek' => 'MyElements::DpScheduleWeeklySubscheduleModify::_StartDayOfWeek',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewObjectAssociationAdd' => 'MyElements::PerfViewObjectAssociationAdd',
               'PerfGetCounterDependentsResult/Views/PerfView/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterStartResult' => 'MyElements::DpBackupListIterStartResult',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/ItemId' => 'MyTypes::ThrottleItemInfo::_ItemId',
               'HostUserAdd/HostUser/HostUserInfo/HostUsergroupIds/HostUsergroupId' => 'MyTypes::HostUsergroupId',
               'ReportGraphListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/ServiceStatuses' => 'MyTypes::ArrayOfServiceStatus',
               'ReportScheduleAdd/ReportScheduleInfo/EmailAddressList' => 'MyTypes::EmailAddressList',
               'DpScheduleDependency' => 'MyElements::DpScheduleDependency',
               'PerfThresholdListInfoIterEndResult' => 'MyElements::PerfThresholdListInfoIterEndResult',
               'MigrateCancel/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetModify/DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/AboutMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/VfilerTemplateId' => 'MyTypes::ObjId',
               'HostListInfoIterStart/HostDpFilterInfo/IsSnapvaultSecondaryOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNextResult/ReportList/ReportInfo' => 'MyTypes::ReportInfo',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'VolumeListInfoIterNextResult/Volumes' => 'MyTypes::ArrayOfVolumeInfo',
               'ReportScheduleListInfoIterNext/Maximum' => 'MyElements::ReportScheduleListInfoIterNext::_Maximum',
               'ReportScheduleModify/ReportScheduleInfo/ArchivalFormat' => 'MyTypes::ReportOutputFormat',
               'DpJobProgressEventListIterStart/JobType' => 'MyTypes::DpJobType',
               'ReportOutputReadResult/FileData' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetReplacePrimaryMembers/CancelEditSessions' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentModifyResult' => 'MyElements::DpAgentModifyResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupStart/VmwareBackupSettingsInfo/VmwareBackupScheduleSettingsInfo/CreateVmwareSnapshot' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyEditRollbackResult' => 'MyElements::ProvisioningPolicyEditRollbackResult',
               'DpAgentListInfoIterNext' => 'MyElements::DpAgentListInfoIterNext',
               'VolumeListInfoIterEnd' => 'MyElements::VolumeListInfoIterEnd',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterStartResult/Records' => 'MyElements::DpOssvApplicationListInfoIterStartResult::_Records',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/PagerAdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/SourceNodeId' => 'MyTypes::DpJobInfo::_SourceNodeId',
               'RbacOperationInfoListResult/OperationList' => 'MyTypes::ArrayOfRbacOperation',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventId' => 'MyTypes::EventInfo::_EventId',
               'GroupCreate/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListInfoIterNextResult/Records' => 'MyElements::DpScheduleListInfoIterNextResult::_Records',
               'DatasetMemberListInfoIterNextResult/DatasetMembers' => 'MyTypes::ArrayOfDatasetMemberInfo',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterStartResult' => 'MyElements::DatasetSpaceMetricListInfoIterStartResult',
               'VolumeDestroy/VolumeNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterEnd' => 'MyElements::DatasetListInfoIterEnd',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DatasetName' => 'MyTypes::ObjName',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'DpAgentListUpgradeCandidatesResult/DpAgentVersionInfos/DpAgentVersionInfo/DpAgentId' => 'MyTypes::ObjId',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo' => 'MyTypes::PerfObjectCounterInfo',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo' => 'MyTypes::HostUsergroupInfo',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Labels' => 'MyTypes::ArrayOfPerfLabel',
               'HostUsergroupModifyResult' => 'MyElements::HostUsergroupModifyResult',
               'CommentFieldCreate/CommentFieldInfo/CommentFieldId' => 'MyTypes::CommentFieldId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsSnapmirrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'EventListIterNextResult/Events/EventInfo/EventDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine' => 'MyTypes::PerfLine',
               'DfmRelatedObjectsListInfoResult/ChildCountList' => 'MyTypes::ArrayOfChildCount',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/DataUnavailableReason/PerfStatusError/Error' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSet/IsAllowCustomSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacOperationAdd/Operation/RbacOperation/OperationNameDetails' => 'MyTypes::WrapperOfRbacOperationNameDetails',
               'DpPolicyGetDefaultPropertyValuesResult/ThrottleScheduleId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'DatasetRemoveResourcepool/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/IsDirectVfilerChild' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun' => 'MyTypes::WrapperOfLunResource',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo' => 'MyTypes::ArrayOfDatasetSpaceInfo',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpLocalSnapshotJobData' => 'MyTypes::DpLocalSnapshotJobData',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateResource',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMeanCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionCreate/BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
               'ViDatastoreListInfoIterNextResult' => 'MyElements::ViDatastoreListInfoIterNextResult',
               'HostRoleModify/HostRole/HostRoleInfo' => 'MyTypes::HostRoleInfo',
               'DpJobListIterStart/StartedTimestampTo' => 'MyTypes::DpTimestamp',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DpBackupListIterStart/HasApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'HostUserPush/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupMemberListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'QtreeRename' => 'MyElements::QtreeRename',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostUsergroupId' => 'MyTypes::AccessObjectId',
               'DpPolicyListIterStart/DpPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks/PerfHealthCheck/HealthCheckName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/Throughput' => 'MyTypes::ThrottleItemInfo::_Throughput',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsUnixPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleModify/ThrottleContent' => 'MyTypes::ThrottleContent',
               'DpBackupContentListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterStart/VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
               'DfmGetResourcePropertyValuesResult/ResourcePropertyValues/ResourcePropertyValues/ResourceProperty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult' => 'MyElements::DatasetMissingMemberListInfoIterNextResult',
               'DpRelationshipListInfoIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'DpJobListIterStartResult' => 'MyElements::DpJobListIterStartResult',
               'PerfViewCreate/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostUsergroupListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCommunicationTimestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/HypervisorId' => 'MyTypes::ObjId',
               'DatasetModify/ApplicationPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfStatusGetResult/DataUnavailableReason' => 'MyTypes::ArrayOfPerfStatusError',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceAggregateId' => 'MyTypes::ObjId',
               'GraphDataListInfoResult/GraphLineValues/GraphLineValueInfo/SampleValues' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'ReportScheduleRun' => 'MyElements::ReportScheduleRun',
               'RbacRoleInfoList/FollowRoleInheritance' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'MigrateStart/IpBindings/IpBindingInfo/MtuSize' => 'MyTypes::IpBindingInfo::_MtuSize',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'DfmGetResourcePropertyValues/ResourceProperty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DpPolicyGetDefaultPropertyValuesResult/DailyRetentionCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/SnmpCommunityName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfCollectClientOperationStatisticsResult/Errors/ClientStatError/ObjectName' => 'MyTypes::ObjName',
               'ReportDesignerScheduleModify/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'DfmScheduleModify/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'LdapServerListInfo/LdapServer/LdapServerAddr' => 'MyTypes::NetworkAddress',
               'UserRecentReportDeleteResult' => 'MyElements::UserRecentReportDeleteResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'HostDomainuserRemove/HostDomainuserNameOrIdOrSid' => 'MyTypes::DomainuserNameOrIdOrSid',
               'DpPolicyCopy/DpPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/EventApplicationList' => 'MyTypes::ArrayOfEventApplicationType',
               'HostUserModify/HostUser/HostUserInfo/FullName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdCreate/ThresholdInfo/ThresholdId' => 'MyTypes::ThresholdId',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo' => 'MyTypes::ResourcepoolInfo',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo' => 'MyTypes::DpBackupTransferInfo',
               'DfmNetworkListInfoResult' => 'MyElements::DfmNetworkListInfoResult',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/TimezoneInfo' => 'MyTypes::TimezoneInfo',
               'DpRestoreViStart/DpViRestoreSettings' => 'MyTypes::DpViRestoreSettings',
               'QtreeListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'DatasetAddToExclusionList/IsExcludedMemberOk' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleDelete' => 'MyElements::RbacRoleDelete',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'PerfObjectListInfoResult/Objects/PerfObject/AssocObjType' => 'MyTypes::PerfAssocObjType',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventCondition' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmGetApiStatistics/ClearApiStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModifyResult' => 'MyElements::StorageServiceModifyResult',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterStart/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo' => 'MyTypes::ApplicationBackupOperationInfo',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/LagErrorThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagErrorThreshold',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterStart/DirectoryPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/StoragesetName' => 'MyTypes::ObjName',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionCount',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/MirrorScheduleName' => 'MyTypes::ObjName',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore' => 'MyTypes::Datastore',
               'PerfThresholdDelete' => 'MyElements::PerfThresholdDelete',
               'DatasetRemoveMember/Destroy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostCapabilityListIterStart' => 'MyElements::HostCapabilityListIterStart',
               'DfmNetworkListInfoResult/Networks/NetworkInfo/PrefixLength' => 'MyTypes::PrefixLength',
               'DfmScheduleHourlyAdd/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/ScriptSummary' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDestroy/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'DpRelationshipListInfoIterEnd' => 'MyElements::DpRelationshipListInfoIterEnd',
               'RbacAdminRoleRemove/AdminNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModify/ApplicationInfo/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/TargetStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View' => 'MyTypes::WrapperOfPerfView',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionCount',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Host' => 'MyTypes::WrapperOfHostResource',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/VolumeId' => 'MyTypes::ObjId',
               'ReportDesignerShare' => 'MyElements::ReportDesignerShare',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/Resourcepools/DatasetResourcepoolInfo' => 'MyTypes::DatasetResourcepoolInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'LunResize/LunNameOrId' => 'MyTypes::ObjNameOrId',
               'VfilerSetup/IpBindings/IpBindingInfo/Interface' => 'MyTypes::ObjNameOrId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/SourceNodeId' => 'MyTypes::DpBackupTransferInfo::_SourceNodeId',
               'HostRoleListIterNext' => 'MyElements::HostRoleListIterNext',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo' => 'MyTypes::TimesOfDayInfo',
               'SrmFileTypeListInfoResult' => 'MyElements::SrmFileTypeListInfoResult',
               'PerfCounterGroupStop/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListResult/EventClasses/EventClassInfo/EventClassId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacAdminRoleAddResult/AdminNameOrId' => 'MyTypes::WrapperOfRbacAdminNameOrId',
               'AlarmCreate/AlarmInfo/TimeTo' => 'MyTypes::AlarmInfo::_TimeTo',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'DpAgentUpgrade/DpAgentNameOrId' => 'MyTypes::ObjNameOrId',
               'VolumeListInfoIterStart/BlockType' => 'MyTypes::FileSystemBlockType',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks/PerfHealthCheck/Recommendation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressAggregateInfo/AggregateName' => 'MyTypes::ObjFullName',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/SanContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo' => 'MyTypes::HourlyInfo',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets/DpDatasetLagInfo/WorstLag' => 'MyTypes::DpDatasetLagInfo::_WorstLag',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModify/HostUser/HostUserInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'DfmRelatedObjectsListInfoResult' => 'MyElements::DfmRelatedObjectsListInfoResult',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/Throughput' => 'MyTypes::ThrottleItemInfo::_Throughput',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo' => 'MyTypes::CommentFieldInfo',
               'PerfObjectInstanceListIterStart' => 'MyElements::PerfObjectInstanceListIterStart',
               'EventListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleDailyAdd' => 'MyElements::DfmScheduleDailyAdd',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo' => 'MyTypes::AlarmInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier' => 'MyTypes::ResourceIdentifier',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapvaultTransferJobData' => 'MyTypes::DpSnapvaultTransferJobData',
               'DatasetMemberDedupeAbortResult/JobId' => 'MyElements::DatasetMemberDedupeAbortResult::_JobId',
               'DpScheduleDependencyResult/ScheduleInUse' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/Resourcepools/ResourcepoolNameOrId' => 'MyTypes::ResourcepoolNameOrId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo' => 'MyTypes::VmwareBackupScheduleSettingsInfo',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DpDashboardGetProtectedDataCounts2/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DfmScheduleDependency/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'ViVirtualMachineListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance' => 'MyTypes::PerfCounterInstance',
               'GroupIsMemberOf' => 'MyElements::GroupIsMemberOf',
               'ReportDesignerScheduleModify/ReportScheduleInfo/EmailAddressList' => 'MyTypes::EmailAddressList',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/ApplicationBackupProperties/PropertyInfo' => 'MyTypes::PropertyInfo',
               'DfmBackupStatusResult/BackupStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/CifsAuthType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'UserRecentReportListInfoIterEndResult' => 'MyElements::UserRecentReportListInfoIterEndResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId' => 'MyTypes::WrapperOfQtreeNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapshotInfo' => 'MyTypes::DpProgressSnapshotInfo',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/TemplateId' => 'MyElements::PerfThresholdTemplateModify::_TemplateId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesAvailable' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Group' => 'MyTypes::WrapperOfGroupResource',
               'CifsDomainListInfoIterNextResult/CifsDomainList/CifsDomainInfo/CifsDnsDomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/AfsTotal' => 'MyTypes::VolumeSize::_AfsTotal',
               'HostListInfoIterNextResult/Hosts/HostInfo/CifsDomainInfo' => 'MyTypes::CifsDomainInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/StorageService/StorageServiceResource' => 'MyTypes::StorageServiceResource',
               'HostUserListIterEndResult' => 'MyElements::HostUserListIterEndResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetOptionsResult/GroupOptionInfo/ChargebackRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo/CifsSharePermissions/CifsSharePermission/Permission' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetOptionsResult/GroupOptionInfo/SrmMaxOldMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxOldMtimeFiles',
               'DpAgentListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/DeprecatedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfSetDefaultView' => 'MyElements::PerfSetDefaultView',
               'RbacRoleInherit/InheritedRoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterNextResult/BackupContents' => 'MyTypes::ArrayOfDpBackupContentInfo',
               'DatasetMemberListInfoIterStart/IncludeExportsInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostAddLicense/SuppressInuseError' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberDeleteSnapshots' => 'MyElements::DatasetMemberDeleteSnapshots',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/ObjectId' => 'MyTypes::ObjId',
               'DpScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee' => 'MyTypes::ScheduleAssignee',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupDelete/HostUsergroupNameOrId' => 'MyTypes::UsergroupNameOrId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DfmScheduleDailyAdd/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInherit' => 'MyElements::RbacRoleInherit',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocation/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertType' => 'MyTypes::ConformanceAlertType',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo' => 'MyTypes::ResourcepoolMemberInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource' => 'MyTypes::ResourcePoolResource',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsNearstore' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventStatusChangeListIterNextResult/Records' => 'MyElements::EventStatusChangeListIterNextResult::_Records',
               'DpScheduleContentGetResult/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'DatasetModify/ProtectionPolicyId' => 'MyTypes::ObjId',
               'DatasetEditBegin' => 'MyElements::DatasetEditBegin',
               'ViVirtualMachineListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyGetDefaultPropertyValuesResult/WeeklyRetentionCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ViVirtualMachineListInfoIterStartResult/Records' => 'MyElements::ViVirtualMachineListInfoIterStartResult::_Records',
               'IfcListInfoIterEndResult' => 'MyElements::IfcListInfoIterEndResult',
               'DiskListInfoIterNextResult/Disks' => 'MyTypes::ArrayOfDiskInfo',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterStart/IncludeThresholds' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRolePushResult' => 'MyElements::HostRolePushResult',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'ViDatacenterListInfoIterNextResult/Datacenters' => 'MyTypes::ArrayOfDatacenter',
               'GroupGetOptionsResult/GroupOptionInfo/GroupOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/ProtectedQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_ProtectedQtreeCount',
               'RbacRoleCapabilityRemove' => 'MyElements::RbacRoleCapabilityRemove',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrStatus' => 'MyTypes::DrStatus',
               'RbacAccessCheck/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateId' => 'MyTypes::ObjId',
               'DfmScheduleWeeklyAdd/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/ApiName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult' => 'MyElements::EventStatusChangeListIterNextResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/BytesTransferred' => 'MyTypes::DpProgressRelationshipInfo::_BytesTransferred',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ToNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo/DestinationQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/HostAddress' => 'MyTypes::IpAddress',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DfmScheduleWeeklySubscheduleModify/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupContentListIterStart/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/MemberName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/EnvironmentVariableList/EnvironmentVariableInfo/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDailyModify/DailyContent/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'ViHypervisorListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModify/RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'PerfViewListIterNextResult/Views/PerfView/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateSpaceManagementRemoveOperation/SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementRemoveOperation::_SpaceManagementSessionId',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/FailoverScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/LastClientStatsCollectionTime' => 'MyTypes::Timestamp',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ObjectId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus' => 'MyTypes::DatasetStatus',
               'MigrateComplete' => 'MyElements::MigrateComplete',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedApplicationResources/ApplicationResourceInfo/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'RbacAccessCheck/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdModify2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentConfigure/VcenterIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'RbacAdminRoleAddResult' => 'MyElements::RbacAdminRoleAddResult',
               'EventListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair' => 'MyTypes::KeyValuePair',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/BackupVersion' => 'MyTypes::DpTimestamp',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'QtreeListInfoIterEndResult' => 'MyElements::QtreeListInfoIterEndResult',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo/CifsShareName' => 'MyTypes::CifsShareName',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DynamicReferenceId' => 'MyTypes::ObjId',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo' => 'MyTypes::ResourcepoolInfo',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/MemberStatus' => 'MyTypes::ObjStatus',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/SpaceOnDemand' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun' => 'MyTypes::WrapperOfLunResource',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Filer/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupVersionModify/NodeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNext' => 'MyElements::AlarmListInfoIterNext',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreateResult/ThresholdId' => 'MyTypes::ThresholdId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/Resourcepools' => 'MyTypes::ArrayOfDatasetResourcepoolInfo',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/InitialSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetAddMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter' => 'MyTypes::DatasetDynamicReferenceParameter',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'QtreeListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfo/Timeout' => 'MyElements::NetifIpInterfaceListInfo::_Timeout',
               'ClientRegistryGetResult/Options/ClientOptionInfo' => 'MyTypes::ClientOptionInfo',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleWeeklyModify/WeeklyContent/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleDailyModify/DailyContent/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryName' => 'MyTypes::ObjName',
               'HostRoleListIterNextResult/HostRoles' => 'MyTypes::ArrayOfHostRoleInfo',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DatasetMissingMemberListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ViHypervisorListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModify/StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/AutoDeleteSnapshots' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/CanContainApplicationResources' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/HypervisorReference/HypervisorId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'PerfGetCounterData/Duration' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'HostUsergroupPush' => 'MyElements::HostUsergroupPush',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DatasetModifyNode/RelinquishVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/HostId' => 'MyTypes::ObjId',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportDesignFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterStartResult' => 'MyElements::DpScheduleListInfoIterStartResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerSetup/CifsWorkgroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo' => 'MyTypes::DayInfo',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'RbacRoleAdminInfoListResult/GlobalUsergroupStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ThresholdUnit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/CifsOpStats/ReadOperations' => 'MyTypes::CifsOpStats::_ReadOperations',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobType' => 'MyTypes::DpJobType',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/ChartName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo' => 'MyTypes::ReportScheduleContentInfo',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'HostRoleDelete/HostRoleNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'DatasetModifyNode/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo' => 'MyTypes::TargetInfo',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DatasetId' => 'MyTypes::ObjId',
               'QtreeListInfoIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewModify' => 'MyElements::PerfViewModify',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/IsCapableOfMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyAdd/MonthlyContent' => 'MyTypes::WrapperOfMonthlyInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostRoleModifyResult' => 'MyElements::HostRoleModifyResult',
               'DpDashboardGetProtectedDataCountsResult/UnprotectedVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_UnprotectedVolumeCount',
               'ApplicationPolicyModify/ApplicationPolicyInfo' => 'MyTypes::ApplicationPolicyInfo',
               'DatasetDynamicReferenceListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ObjectId' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionCount',
               'EventStatusChangeListIterStart/TimeRange/EventTimestampRange/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'LunListInfoIterStart/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Host/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'ResourcepoolAddMember/ResourceTag' => 'MyTypes::ResourceTag',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DatasetId' => 'MyTypes::ObjId',
               'VfilerSetup/IpBindings/IpBindingInfo/VlanIdentifier' => 'MyTypes::IpBindingInfo::_VlanIdentifier',
               'DfmRelatedObjectsListInfo' => 'MyElements::DfmRelatedObjectsListInfo',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'DpScheduleCreateResult/ScheduleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupDestroy/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Group' => 'MyTypes::WrapperOfGroupResource',
               'PerfAssocViewListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterStart/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo/RunOnDemandUpdate' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/ItemId' => 'MyTypes::ThrottleItemInfo::_ItemId',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ThrottleScheduleName' => 'MyTypes::ObjName',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/ReplaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterEndResult' => 'MyElements::DpOssvDirectoryDiscoveredIterEndResult',
               'ResourcepoolMemberListInfoIterStart/ProvisioningPolicyNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlySubscheduleUnset' => 'MyElements::DfmScheduleMonthlySubscheduleUnset',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/HostId' => 'MyTypes::ObjId',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'RbacAccessCheck/Resource/ResourceIdentifier/Filer/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostUsergroupListIterNext' => 'MyElements::HostUsergroupListIterNext',
               'HostUserPush' => 'MyElements::HostUserPush',
               'ProvisioningPolicyCreateResult/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/LagWarningThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagWarningThreshold',
               'HostAdd/AddNetwork' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo' => 'MyTypes::VersionMemberInfo',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'SrmFileTypeListInfo' => 'MyElements::SrmFileTypeListInfo',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/VfilerTemplateId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/RbacRole' => 'MyTypes::WrapperOfRbacRoleResource',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/IsSpaceDataPartial' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyCopyResult' => 'MyElements::ProvisioningPolicyCopyResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/DpNodeName' => 'MyTypes::ObjName',
               'PerfThresholdTemplateCreateResult' => 'MyElements::PerfThresholdTemplateCreateResult',
               'DpScheduleWeeklyDelete/ItemId' => 'MyElements::DpScheduleWeeklyDelete::_ItemId',
               'DpOssvApplicationListInfoIterStart/OssvApplicationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterStart/ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterStartResult' => 'MyElements::IfcListInfoIterStartResult',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/MaximumSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumSnapshotSpace',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers' => 'MyTypes::ArrayOfMissingMemberInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleHourlyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdCreate2/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetEditCommitResult/JobIds/JobInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/TimezoneInfo/TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectRefresh' => 'MyElements::DfmObjectRefresh',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo' => 'MyTypes::AggregateSpaceInfo',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/StorageReliability/SubSystemFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerSetup/IpBindings/IpBindingInfo/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/IfcName' => 'MyTypes::ObjName',
               'DfmRelatedObjectsListInfoResult/ParentDatasetList/ParentDataset/Name' => 'MyTypes::ObjName',
               'PerfGetCounterData/TimeFilter/TimeRanges/TimeRange/From' => 'MyTypes::TimeRange::_From',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter' => 'MyTypes::VirtualCenter',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_UnprotectedVolumeCount',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/IpAddressList' => 'MyTypes::ArrayOfIpAddress',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree' => 'MyTypes::WrapperOfQtreeResource',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/MonthlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionCount',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolIsProvisionable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberUndedupeStart/UndedupeMemberRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo' => 'MyTypes::DayInfo',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostObjStatus' => 'MyTypes::ObjStatus',
               'DpBackupContentListIterNext' => 'MyElements::DpBackupContentListIterNext',
               'DfmScheduleListResult/ScheduleList/ScheduleIdInfo/Id' => 'MyTypes::ObjId',
               'VfilerCreate/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfDisableObjectUpdate' => 'MyElements::PerfDisableObjectUpdate',
               'DpDashboardGetProtectedDataCountsResult/ProtectedQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_ProtectedQtreeCount',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SrmFileTypeAdd' => 'MyElements::SrmFileTypeAdd',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree/UnprotectedQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMissingMemberListInfoIterStart' => 'MyElements::DatasetMissingMemberListInfoIterStart',
               'MigrateStart/IpBindings/IpBindingInfo/IpAddress' => 'MyTypes::IpAddress',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/MinimumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'ResourcepoolMemberListInfoIterStart/IncludeIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViDatastoreListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/OssvApplicationRestoreDestinationList/OssvApplicationRestoreDestinationInfo/HostFullName' => 'MyTypes::ObjFullName',
               'ReportOutputRead/Offset' => 'MyElements::ReportOutputRead::_Offset',
               'PerfCounterGroupListInfo/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines' => 'MyTypes::ArrayOfPerfLine',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/SecondaryMemberId' => 'MyTypes::ObjId',
               'DatasetMemberDedupeStart/DedupeMemberRequestInfo/FullVolumeDedupe' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/MemberId' => 'MyTypes::ObjId',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/DnsServers' => 'MyTypes::ArrayOfIpAddress',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo' => 'MyTypes::TimesOfDayInfo',
               'AlarmCreate/AlarmInfo/IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetBeginFailover' => 'MyElements::DatasetBeginFailover',
               'StorageServiceDatasetProvision/DatasetMetadata/DfmMetadataField' => 'MyTypes::DfmMetadataField',
               'DatasetRemoveMember/DatasetMemberParameters' => 'MyTypes::ArrayOfDatasetMemberParameter',
               'Fault' => 'SOAP::WSDL::SOAP::Typelib::Fault11',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo' => 'MyTypes::ReportOutputInfo',
               'GroupListIterNextResult/GroupList/GroupInfo/ShortName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/StorageServiceName' => 'MyTypes::ObjName',
               'DfmAbout' => 'MyElements::DfmAbout',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/PathFound' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/OldPrimaryMemberName' => 'MyTypes::ObjName',
               'ApplicationPolicyEditCommitResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem' => 'MyTypes::ProtectionStatusProblem',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'PerfGetCounterDependents' => 'MyElements::PerfGetCounterDependents',
               'DpAgentModify/HostserviceModifyInfo/MgmtPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleContentGetResult/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectInstanceListIterNextResult' => 'MyElements::PerfObjectInstanceListIterNextResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQtreeInfo' => 'MyTypes::ProgressQtreeInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Vfiler/VfilerResource' => 'MyTypes::VfilerResource',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/PerfStatus' => 'MyTypes::ObjStatus',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/IsDeprecated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'VolumeListInfoIterStart/IsSnapmirrorPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/HourlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionCount',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndMinute' => 'MyTypes::ThrottleItemInfo::_EndMinute',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'DpScheduleCreate/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'ReportScheduleListInfoIterNext' => 'MyElements::ReportScheduleListInfoIterNext',
               'DpBackupVersionCreate/BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
               'StorageServiceDatasetProvision' => 'MyElements::StorageServiceDatasetProvision',
               'MigrateStart/RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostAgentOssvServiceStart/AgentNameOrId' => 'MyTypes::HostNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/SecondaryVolumeNameFormat' => 'MyTypes::SecondaryVolumeNameFormat',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpOssvDirectoryBrowseIterEndResult' => 'MyElements::DpOssvDirectoryBrowseIterEndResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/SanContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementRemoveOperation/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleWeeklySubscheduleAdd' => 'MyElements::DpScheduleWeeklySubscheduleAdd',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier' => 'MyTypes::RoleAttributesIdentifier',
               'HostRoleCreateResult/HostRoleId' => 'MyTypes::AccessObjectId',
               'ReportScheduleListInfoIterNextResult' => 'MyElements::ReportScheduleListInfoIterNextResult',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Comments' => 'MyTypes::ArrayOfProvisionMemberComment',
               'RbacAdminListInfoIterNextResult/Admins/AdminInfo/AdminName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmGetApiStatisticsResult/ApiStatistics' => 'MyTypes::ArrayOfApiStat',
               'DpOssvDirectoryRootsIterStart/FsInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdCreate2/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'DfmScheduleListInfoIterStart/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyModify' => 'MyElements::DpScheduleWeeklyModify',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource' => 'MyTypes::QtreeResource',
               'DfmScheduleModify/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'PerfCounterGroupDestroy' => 'MyElements::PerfCounterGroupDestroy',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationNameDetails/RbacOperationNameDetails/ResourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklyModify/WeeklyContent/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'ReportGraphListInfoIterStart/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterNextResult/Luns/LunInfo/Igroups' => 'MyTypes::ArrayOfIgroupReference',
               'DpRestoreViStart/DpViRestoreSettings/DpViVmwareRestoreSettings' => 'MyTypes::DpViVmwareRestoreSettings',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'DpScheduleWeeklySubscheduleModifyResult' => 'MyElements::DpScheduleWeeklySubscheduleModifyResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterStart/HostDpFilterInfo/IsSnapmirroredOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/DailyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionDuration',
               'DpBackupVersionListIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleRename' => 'MyElements::DpScheduleRename',
               'PerfThresholdTemplateCreateResult/TemplateId' => 'MyElements::PerfThresholdTemplateCreateResult::_TemplateId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/RoleNameAndId/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommit/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressNfsexportInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStartResult' => 'MyElements::EventListIterStartResult',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo' => 'MyTypes::HypervBackupScheduleSettingsInfo',
               'PerfGetDefaultView' => 'MyElements::PerfGetDefaultView',
               'ViVirtualMachineListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfObjectInstanceListIterStart/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartMinute' => 'MyTypes::ThrottleItemInfo::_StartMinute',
               'DpAgentListUpgradeCandidatesResult/DpAgentVersionInfos/DpAgentVersionInfo/DpAgentVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocation/Paths/DpBackupPathInfo' => 'MyTypes::DpBackupPathInfo',
               'StorageServiceModify/StorageServiceContact' => 'MyTypes::EmailAddressList',
               'HostRoleListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult' => 'MyElements::StorageServiceListInfoIterNextResult',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DpOssvDirectoryModify/DpOssvDirectoryNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNext' => 'MyElements::DpScheduleListInfoIterNext',
               'PerfThresholdListInfoIterNext' => 'MyElements::PerfThresholdListInfoIterNext',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionCount',
               'GroupGetStatusResult/GroupStatus' => 'MyTypes::ObjStatus',
               'DpBackupVersionModify/DpBackupTransferInfo/BackupTransferNeeded' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleDeleteResult' => 'MyElements::ReportScheduleDeleteResult',
               'DfmObjectRefresh/MonitorNames' => 'MyTypes::ArrayOfMonitorName',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/CifsAuthType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterEnd' => 'MyElements::DatasetSpaceMetricListInfoIterEnd',
               'ResourcepoolMemberListInfoIterEnd' => 'MyElements::ResourcepoolMemberListInfoIterEnd',
               'HostUserModify/HostUser/HostUserInfo/Description' => 'MyTypes::AccessObjectDescription',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo/LdapServer' => 'MyTypes::LdapServer',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DfmAboutResult/InstalledPlugins/Plugin' => 'MyTypes::Plugin',
               'SnapshotGetReclaimableInfo/Snapshots' => 'MyTypes::ArrayOfSnapshot',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'HostUserAdd/HostUser' => 'MyTypes::WrapperOfHostUserInfo',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo' => 'MyTypes::VolumeDedupeInfo',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNext/Maximum' => 'MyElements::DpOssvApplicationListInfoIterNext::_Maximum',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DiskListInfoIterNext/Maximum' => 'MyElements::DiskListInfoIterNext::_Maximum',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceHostId' => 'MyTypes::ObjId',
               'PerfViewCreate/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberUndedupeStartResult' => 'MyElements::DatasetMemberUndedupeStartResult',
               'AuditLogAddEntry/AuditMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo' => 'MyTypes::AdvancedOptionInfo',
               'ApplicationPolicyDestroy' => 'MyElements::ApplicationPolicyDestroy',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateResource',
               'DatasetConformBegin' => 'MyElements::DatasetConformBegin',
               'DfmScheduleDependencyResult' => 'MyElements::DfmScheduleDependencyResult',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmAboutResult/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleDisable' => 'MyElements::DfmBackupScheduleDisable',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/DedupeRequestInfo' => 'MyTypes::DedupeRequestInfo',
               'ViDatacenterListInfoIterEndResult' => 'MyElements::ViDatacenterListInfoIterEndResult',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/RunStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListResult/EventClasses/EventClassInfo/AboutMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/FilesystemState' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionCount',
               'DpScheduleWeeklyAddResult/ItemId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterStart/HasApplicationPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolGetDefaultsResult' => 'MyElements::ResourcepoolGetDefaultsResult',
               'RbacRoleInherit/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions' => 'MyTypes::ArrayOfDpBackupVersionInfo',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TrapDestinations/TrapDestination/TrapCommunity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Dataset/DatasetResource' => 'MyTypes::DatasetResource',
               'DatasetExclusionListInfoIterNext' => 'MyElements::DatasetExclusionListInfoIterNext',
               'HostListInfoIterStart/HostTypes' => 'MyTypes::ArrayOfHostType',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/Ipaddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DpThrottleModify/ThrottleContent/ThrottleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterStartResult' => 'MyElements::SnapshotListInfoIterStartResult',
               'ApiProxy/Request/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModifyMember/ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'PerfViewListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterStart/IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DfmScheduleWeeklyAdd' => 'MyElements::DfmScheduleWeeklyAdd',
               'PerfThresholdModify2/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'AlarmModify/AlarmInfo/GroupId' => 'MyTypes::AlarmInfo::_GroupId',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNext' => 'MyElements::GraphListInfoIterNext',
               'PerfViewModifyResult' => 'MyElements::PerfViewModifyResult',
               'DpJobListIterStart/MaxJobs' => 'MyElements::DpJobListIterStart::_MaxJobs',
               'DpRelationshipListInfoIterStart' => 'MyElements::DpRelationshipListInfoIterStart',
               'ReportOutputListInfoIterStartResult' => 'MyElements::ReportOutputListInfoIterStartResult',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'HostListInfoIterNextResult/Hosts/HostInfo/UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListResult/ScheduleList/ScheduleIdInfo/Id' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsVfilerCreatedForMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventListIterStart/EventApplicationList/EventApplicationType' => 'MyTypes::EventApplicationType',
               'LunDestroy' => 'MyElements::LunDestroy',
               'DatasetCreateResult/DatasetId' => 'MyTypes::ObjId',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DpJobProgressEventListIterStartResult/Records' => 'MyElements::DpJobProgressEventListIterStartResult::_Records',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/MemberPerfStatus' => 'MyTypes::ObjStatus',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree/ProtectedDataSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapvaultPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'DpBackupVersionModify/DpBackupTransferInfo' => 'MyTypes::DpBackupTransferInfo',
               'PerfCounterGroupModify' => 'MyElements::PerfCounterGroupModify',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapmirrorPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesTotal' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal',
               'DpPolicyEditBegin/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmBackupScheduleEnableResult' => 'MyElements::DfmBackupScheduleEnableResult',
               'MigrateCleanup/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupListIterStart/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/StorageReliability/SubSystemFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleModify/ReportScheduleInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'PerfViewCreate/View/PerfView/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleWeeklyDelete/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'MigrateCompleteResult' => 'MyElements::MigrateCompleteResult',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/ProvisioningPolicyName' => 'MyTypes::ObjFullName',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationName' => 'MyTypes::ObjName',
               'PerfViewCreate/View/PerfView/AssocObjType/PerfAssocObjType' => 'MyTypes::PerfAssocObjType',
               'PerfAssocViewListIterNextResult/Views/PerfView/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterStart' => 'MyElements::DfmScheduleListInfoIterStart',
               'PerfCopyCounterConfigurationResult/CopyResult' => 'MyTypes::ArrayOfDestinationHostInfo',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportProvenance' => 'MyTypes::ReportProvenance',
               'DatasetMemberUndedupeStart' => 'MyElements::DatasetMemberUndedupeStart',
               'DfmScheduleMonthlySubscheduleSet/MonthlyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/VolumeName' => 'MyTypes::ObjName',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/CreateNewVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostListInfoIterEnd' => 'MyElements::HostListInfoIterEnd',
               'ViVirtualCenterListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'PerfAssocViewListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfStatusGetResult/DataUnavailableReason/PerfStatusError/Error' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceContact' => 'MyTypes::EmailAddressList',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/HostingFilerId' => 'MyTypes::ObjId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/ResizeVolumeRequestInfo/NewSize' => 'MyTypes::ResizeVolumeRequestInfo::_NewSize',
               'DfmSnmpSettingAdd/PrefixLength' => 'MyTypes::PrefixLength',
               'DpBackupVersionListIterStart/VolumeId' => 'MyTypes::ObjId',
               'DatasetMemberListInfoIterEnd' => 'MyElements::DatasetMemberListInfoIterEnd',
               'DfmScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo' => 'MyTypes::VersionMemberInfo',
               'HostUserModify/HostUser/HostUserInfo/MinimumPasswordAge' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'ReportDesignerListResult/ReportList/ReportListInfo/CategoryId' => 'MyTypes::ReportListInfo::_CategoryId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'DpBackupVersionListIterStart/RootObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterStartResult' => 'MyElements::ViVirtualMachineListInfoIterStartResult',
               'DatasetModify/DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
               'HostAgentOssvServiceStopResult' => 'MyElements::HostAgentOssvServiceStopResult',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/VirtualCenterReference/VirtualCenterName' => 'MyTypes::ObjName',
               'ReportScheduleRunResult/ReportOutputId' => 'MyElements::ReportScheduleRunResult::_ReportOutputId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/VolOrQtreeId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterEnd' => 'MyElements::DpOssvDirectoryRootsIterEnd',
               'DpOssvApplicationListInfoIterStart' => 'MyElements::DpOssvApplicationListInfoIterStart',
               'HostDomainuserAdd/HostUsergroupNamesOrIds/HostUsergroupNameOrId' => 'MyTypes::HostUsergroupNameOrId',
               'DpScheduleWeeklyModify/WeeklyContent/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'DfmNetworkListInfo/NetworkId' => 'MyTypes::NetworkId',
               'DpOssvApplicationRestoreDestinationListInfoIterEnd' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterEnd',
               'DpAgentPackageDeleteResult' => 'MyElements::DpAgentPackageDeleteResult',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputReadResult' => 'MyElements::ReportOutputReadResult',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViVirtualMachineListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceCreate/StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ReportScheduleInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'EventclassDeleteCustom' => 'MyElements::EventclassDeleteCustom',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo' => 'MyTypes::ApplicationPolicySettingsInfo',
               'DfmGetResourcePropertyValuesResult/ResourcePropertyValues/ResourcePropertyValues/Values' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterStartResult/Records' => 'MyElements::DpAgentListInfoIterStartResult::_Records',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth' => 'MyTypes::ArrayOfDayOfMonth',
               'HostModify/HostModifyInfo/NdmpCredentials/NdmpPassword' => 'MyTypes::HostPassword',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Filer/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyEditRollback/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/VfilerTemplateName' => 'MyTypes::ObjName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectInstanceListIterNextResult/Instances/PerfInstance' => 'MyTypes::PerfInstance',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterEndResult' => 'MyElements::PerfCounterGroupListIterEndResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'PerfCounterGroupListIterEnd' => 'MyElements::PerfCounterGroupListIterEnd',
               'DfmAboutResult/NodeLimit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ResourceType' => 'MyTypes::ApplicationObjectType',
               'ReportScheduleAdd/ReportScheduleInfo/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostGetDefaultsResult/HostDefaults' => 'MyTypes::HostDefaults',
               'DfmScheduleHourlyDelete/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'DpPolicyGetDefaultPropertyValuesResult' => 'MyElements::DpPolicyGetDefaultPropertyValuesResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'ProvisioningPolicyCreate' => 'MyElements::ProvisioningPolicyCreate',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/NisServers' => 'MyTypes::ArrayOfIpAddress',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressScriptRunInfo/ScriptName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerCreateResult' => 'MyElements::VfilerCreateResult',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/DirId' => 'MyTypes::DpOssvDirectoryInfo::_DirId',
               'DpRestoreToPrimary' => 'MyElements::DpRestoreToPrimary',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostModify/HostModifyInfo/NdmpCredentials' => 'MyTypes::NdmpCredentials',
               'DatasetListInfoIterStart/SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostGetDefaultsResult/HostDefaults/AdminPortHostHttps' => 'MyTypes::IpPortNumber',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/OverwriteReserveTotal' => 'MyTypes::VolumeSize::_OverwriteReserveTotal',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/CommentValue' => 'MyTypes::CommentValue',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunInfo' => 'MyTypes::ProgressLunInfo',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationDeleteResult' => 'MyElements::RbacOperationDeleteResult',
               'VfilerTemplateCopy/VfilerTemplateName' => 'MyTypes::ObjName',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters' => 'MyTypes::ArrayOfPerfPurgedHostObjectCounter',
               'PerfViewObjectAssociationAdd/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ThrottleScheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/ObjectId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeId' => 'MyTypes::ObjId',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/PartnerInterfaceId' => 'MyTypes::ObjId',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/EventClass' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/ResourcepoolId' => 'MyTypes::ObjId',
               'ProvisioningPolicyDestroy/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DatasetCreate/SecondaryVolumeNameFormat' => 'MyTypes::SecondaryVolumeNameFormat',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsNdmpEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAdd/HostUser/HostUserInfo/HostUserName' => 'MyTypes::AccessObjectName',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SnapshotDeletionRequestInfo/Snapshots/Snapshot' => 'MyTypes::Snapshot',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/DatasetName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterStart/IncludeNextScheduledBackupTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/TargetName' => 'MyTypes::ObjName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics' => 'MyTypes::ArrayOfDatasetSpaceMetricInfo',
               'DatasetAddMember' => 'MyElements::DatasetAddMember',
               'PerfCounterGroupCreateResult' => 'MyElements::PerfCounterGroupCreateResult',
               'PerfClientStatsPurgeResult' => 'MyElements::PerfClientStatsPurgeResult',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'PerfCollectClientOperationStatisticsResult/StatId' => 'MyTypes::StatId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes' => 'MyTypes::ArrayOfRoleAttributesIdentifier',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/MinTime' => 'MyTypes::ApiStat::_MinTime',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfDisableDataCollection/IsAsync' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/BackupId' => 'MyTypes::BackupLocationInfo::_BackupId',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo' => 'MyTypes::GroupMemberInfo',
               'DpJobProgressEventListIterStart/EndTime' => 'MyTypes::DpTimestamp',
               'DpScheduleWeeklySubscheduleAdd/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyAdd/MonthlyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeResize/ResizeVolumeRequestInfo' => 'MyTypes::ResizeVolumeRequestInfo',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DatasetModify/IsDpSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetModify/StorageServiceNodeList' => 'MyTypes::ArrayOfStorageServiceNodeAttributes',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/EndHour' => 'MyTypes::ThrottleItemInfo::_EndHour',
               'DpBackupContentListIterStartResult/Records' => 'MyElements::DpBackupContentListIterStartResult::_Records',
               'DpAgentPackageListResult/DpAgentPackages/DpAgentPackageInfo/PackageName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/NfsExportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/AutoDeleteSnapshots' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/ObjectName' => 'MyTypes::ObjName',
               'DpBackupContentListIterNextResult' => 'MyElements::DpBackupContentListIterNextResult',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListResult' => 'MyElements::DpScheduleListResult',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/ErrReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'EventStatusChangeListIterNextResult/Events/EventInfo' => 'MyTypes::EventInfo',
               'PerfGetCounterData/TimeFilter/Days/Day' => 'MyTypes::Day',
               'DfmRelatedObjectsListInfoResult/ParentGroupList/ParentGroup/Id' => 'MyTypes::ObjId',
               'PerfGetCounterDependentsResult/Views/PerfView' => 'MyTypes::PerfView',
               'ApiProxy/Username' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRelationshipListInfoIterStart/DestinationType' => 'MyTypes::RelationshipEndpointType',
               'DpScheduleCreateResult' => 'MyElements::DpScheduleCreateResult',
               'GraphDataListInfo/SecondaryObject' => 'MyTypes::ObjNameOrId',
               'DfmSnmpSettingAdd' => 'MyElements::DfmSnmpSettingAdd',
               'StorageServiceDatasetListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleMonthlySubscheduleUnset' => 'MyElements::DpScheduleMonthlySubscheduleUnset',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/CreateNewVfiler' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LunListInfoIterNextResult/Luns/LunInfo/Igroups/IgroupReference' => 'MyTypes::IgroupReference',
               'StorageServiceCreate/StorageServiceOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterEndResult' => 'MyElements::LunListInfoIterEndResult',
               'DpOssvDirectoryRootsIterNextResult/Roots' => 'MyTypes::ArrayOfDpOssvDirectoryRootInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'RbacRoleAdd/RoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterNext/Maximum' => 'MyElements::DpOssvDirectoryRootsIterNext::_Maximum',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceStatus' => 'MyTypes::SpaceStatus',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'EventStatusChangeListIterEnd' => 'MyElements::EventStatusChangeListIterEnd',
               'PerfThresholdListInfoIterStart' => 'MyElements::PerfThresholdListInfoIterStart',
               'ReportGraphListInfoIterEnd' => 'MyElements::ReportGraphListInfoIterEnd',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes' => 'MyTypes::StorageServiceNodeAttributes',
               'DpRestoreToNewPath/CheckOverwrite' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'NetifIpInterfaceListInfo' => 'MyElements::NetifIpInterfaceListInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ProtectionPolicyName' => 'MyTypes::ObjName',
               'AlarmCreate/AlarmInfo/EmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'DfmRelatedObjectsListInfoResult/ParentGroupList/ParentGroup' => 'MyTypes::ParentGroup',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetLaggedRelationshipsResult' => 'MyElements::DpDashboardGetLaggedRelationshipsResult',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetListIterStart' => 'MyElements::StorageServiceDatasetListIterStart',
               'PerfViewModify/View/PerfView' => 'MyTypes::PerfView',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/AutoGrowCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetProtectedDataCountsResult/IgnoredQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_IgnoredQtreeCount',
               'DpAgentListUpgradeCandidates/PackageNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterData/TimeFilter/TimeRanges/TimeRange/To' => 'MyTypes::TimeRange::_To',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Policy/PolicyResource' => 'MyTypes::PolicyResource',
               'ResourcepoolListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleRun/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/ProtectionPolicyName' => 'MyTypes::ObjName',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerAllowedProtocols' => 'MyTypes::ArrayOfProtocol',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationSynopsis' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterStartResult/Records' => 'MyElements::ProvisioningPolicyListIterStartResult::_Records',
               'ApplicationPolicyListIterStart/ApplicationPolicyType' => 'MyTypes::ApplicationPolicyType',
               'RbacAccessCheck/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeDestroy' => 'MyElements::VolumeDestroy',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/AvailableSpace' => 'MyTypes::SpaceInfo::_AvailableSpace',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostId' => 'MyTypes::ObjId',
               'AlarmModify/AlarmInfo/AlarmId' => 'MyTypes::AlarmInfo::_AlarmId',
               'DpRestoreToNewPath/Members' => 'MyTypes::ArrayOfDpRecoverMemberInfo',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Vfiler/VfilerResource' => 'MyTypes::VfilerResource',
               'DatasetMemberListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Vfiler/VfilerResource' => 'MyTypes::VfilerResource',
               'GroupListIterNextResult/GroupList/GroupInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSeverity' => 'MyTypes::ObjStatus',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/SnapshotVolumeId' => 'MyTypes::ObjId',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'ReportDesignerScheduleModify/ReportScheduleInfo/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup' => 'MyTypes::PerfCounterGroup',
               'PerfThresholdTemplateListInfoIterNextResult' => 'MyElements::PerfThresholdTemplateListInfoIterNextResult',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DestroyMemberRequestInfo/MemberId' => 'MyTypes::ObjId',
               'DpJobScheduleListIterNextResult/Records' => 'MyElements::DpJobScheduleListIterNextResult::_Records',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DfmScheduleWeeklyModify/WeeklyContent' => 'MyTypes::WrapperOfWeeklyInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceHostName' => 'MyTypes::ObjFullName',
               'StorageServiceListInfoIterStart/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionCount',
               'HostListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleModify/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/EventNameShort' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetRemoveFromExclusionListResult' => 'MyElements::DatasetRemoveFromExclusionListResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes' => 'MyTypes::ArrayOfStorageServiceNodeInfo',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/HostId' => 'MyTypes::ObjId',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo' => 'MyTypes::GraphInfo',
               'DatasetBeginFailoverScriptTestResult' => 'MyElements::DatasetBeginFailoverScriptTestResult',
               'DpPolicyGetDefaultPropertyValuesResult/DailyRetentionDuration' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostUserModify/HostUser/HostUserInfo/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetDataResult/DynamicData/DynamicData/InstanceName' => 'MyTypes::WrapperOfPerfInstance',
               'QtreeModify' => 'MyElements::QtreeModify',
               'DpRestoreToNewPath' => 'MyElements::DpRestoreToNewPath',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsShareNames' => 'MyTypes::ArrayOfCifsShareName',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateComplete/MaxCutoverTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId' => 'MyTypes::LunNameOrId',
               'QtreeStartMonitoring/QtreeNameOrId' => 'MyElements::QtreeStartMonitoring::_QtreeNameOrId',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo' => 'MyTypes::SpaceManagementOperationInfo',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert' => 'MyTypes::ConformanceAlert',
               'ReportDesignerListResult' => 'MyElements::ReportDesignerListResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource' => 'MyTypes::QtreeResource',
               'DfmNetworkAdd' => 'MyElements::DfmNetworkAdd',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/BytesTransferred' => 'MyTypes::DpProgressRestoreInfo::_BytesTransferred',
               'HostUsergroupListIterStartResult' => 'MyElements::HostUsergroupListIterStartResult',
               'DpScheduleWeeklyModifyResult' => 'MyElements::DpScheduleWeeklyModifyResult',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DpThrottleModify/ThrottleContent/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups' => 'MyTypes::ArrayOfPerfCounterGroup',
               'DatasetAddMemberResult' => 'MyElements::DatasetAddMemberResult',
               'GroupMemberListIterStart' => 'MyElements::GroupMemberListIterStart',
               'GroupCopy/ParentGroupNameOrId' => 'MyTypes::GroupNameOrId',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/VfilerTemplateName' => 'MyTypes::ObjName',
               'DpThrottleCreate/ThrottleContent/ThrottleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetComputeUsageMetric/ComputeSpaceUsageMetric' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfo2IterStartResult' => 'MyElements::PerfThresholdListInfo2IterStartResult',
               'ReportOutputListInfoIterNext' => 'MyElements::ReportOutputListInfoIterNext',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostGetDefaultsResult/HostDefaults/AdminTransportHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterStart/JobContextApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'DpBackupListIterStart' => 'MyElements::DpBackupListIterStart',
               'HostUsergroupCreate' => 'MyElements::HostUsergroupCreate',
               'DpRestoreToNewPathResult/OverwriteResults/OverwriteResult/DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions/SpaceCondition/Condition' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklySubscheduleDelete/ItemId' => 'MyElements::DpScheduleWeeklySubscheduleDelete::_ItemId',
               'EventGenerateResult' => 'MyElements::EventGenerateResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapmirrorSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDailyAdd/DailyContent/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'EventDeleteResult/EventsDeletedList/EventActionInfo/EventId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleDeleteResult' => 'MyElements::HostRoleDeleteResult',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/DedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerListResult/ReportList' => 'MyTypes::ArrayOfReportListInfo',
               'GroupDeleteMember/MemberNameOrId' => 'MyTypes::ObjectNameOrId',
               'HostUserModifyPassword/HostUserNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionDuration',
               'PerfThresholdTemplateAttachObjects/NewObjects/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo' => 'MyTypes::DpProgressSnapmirrorInfo',
               'NetifIpInterfaceListInfo/CommunityString' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterEndResult' => 'MyElements::CifsDomainListInfoIterEndResult',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'VolumeListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpScheduleMonthlyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/IsBusy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmServerListDiagnosticInfoResult/DiagInfo/DfmDiagCounterGroup/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/Id' => 'MyTypes::DpPolicyNodeInfo::_Id',
               'DpBackupListIterNextResult/Records' => 'MyElements::DpBackupListIterNextResult::_Records',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/ReportType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/VolumeName' => 'MyTypes::ObjName',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpBackupListIterEnd' => 'MyElements::DpBackupListIterEnd',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleModify/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleDailyDeleteResult' => 'MyElements::DfmScheduleDailyDeleteResult',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/StorageReliability' => 'MyTypes::StorageReliability',
               'DpScheduleCreate/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'VolumeListInfoIterStart/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GroupListIterNext' => 'MyElements::GroupListIterNext',
               'DpBackupVersionModify/DpBackupTransferInfo/SourceBackupId' => 'MyTypes::DpBackupTransferInfo::_SourceBackupId',
               'DpJobListIterStart/JobContextApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/EmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Filer/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/IsApplicationCompatible' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRolePush' => 'MyElements::HostRolePush',
               'DpBackupListIterStart/BackupId' => 'MyElements::DpBackupListIterStart::_BackupId',
               'DpJobProgressEventListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpLocalSnapshotJobData' => 'MyTypes::DpLocalSnapshotJobData',
               'DpScheduleContentGetResult/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/EmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostUsergroupNames/HostUsergroupName' => 'MyTypes::HostUsergroupName',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/IsVlanCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmMonitorTimestampList/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Group/GroupResource' => 'MyTypes::GroupResource',
               'HostListInfoIterNextResult/Hosts/HostInfo/OtherHostId' => 'MyTypes::HostId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/Frequency' => 'MyTypes::TimesOfDayInfo::_Frequency',
               'HostUserListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/BlockType' => 'MyTypes::FileSystemBlockType',
               'DpJobProgressEventListIterStart/JobTypes/JobType' => 'MyTypes::JobType',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VirtualDiskName' => 'MyTypes::ObjName',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/EffectiveUsedDataSpace' => 'MyTypes::SpaceMeasurement::_EffectiveUsedDataSpace',
               'DpAgentListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupVersionModify' => 'MyElements::DpBackupVersionModify',
               'AlarmModify/AlarmInfo/TimeFrom' => 'MyTypes::AlarmInfo::_TimeFrom',
               'HostModifyAgentCredentials/ManagementPassword' => 'MyTypes::HostPassword',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/RunBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/DatasetId' => 'MyTypes::ObjId',
               'DpScheduleHourlyDelete/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd' => 'MyElements::ReportScheduleAdd',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/ScheduledTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories' => 'MyTypes::ArrayOfDpOssvDirectoryInfo',
               'SnapshotListInfoIterStartResult/Records' => 'MyElements::SnapshotListInfoIterStartResult::_Records',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate' => 'MyElements::ResourcepoolCreate',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/LastDedupeError' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/AdminTransport' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'RbacAccessCheck/Resource/ResourceIdentifier/Vfiler' => 'MyTypes::WrapperOfVfilerResource',
               'PerfViewListIterNextResult/Views/PerfView/ViewType' => 'MyTypes::ViewType',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/BackupId' => 'MyTypes::BackupInfo::_BackupId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleMonthlySubscheduleSet' => 'MyElements::DfmScheduleMonthlySubscheduleSet',
               'DpBackupVersionListIterStart/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDailyDelete/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleHourlyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectsGetStatusResult/ObjectsStatus/ObjStatusInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'ReportOutputListInfoIterStart/ReportScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupMemberListIterStart/HideSubgroupMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventclassListResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/EventNamePretty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetBeginFailoverScriptTest' => 'MyElements::DatasetBeginFailoverScriptTest',
               'DatasetSpaceMetricListInfoIterNext' => 'MyElements::DatasetSpaceMetricListInfoIterNext',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacOperationAdd/Operation/RbacOperation' => 'MyTypes::RbacOperation',
               'PerfDisableDataCollectionResult' => 'MyElements::PerfDisableDataCollectionResult',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/Snapshots/Snapshot/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/Description' => 'MyTypes::AccessObjectDescription',
               'DfmScheduleDailyModify' => 'MyElements::DfmScheduleDailyModify',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'DfmBackupScheduleSet/Minute' => 'MyElements::DfmBackupScheduleSet::_Minute',
               'CommentFieldValuesListInfoIterStart' => 'MyElements::CommentFieldValuesListInfoIterStart',
               'DatasetReplacePrimaryMembers/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ClientRegistryGet/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo/VolumeName' => 'MyTypes::ObjFullName',
               'DfmScheduleCreateResult/ScheduleId' => 'MyTypes::ObjId',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolGetDefaults' => 'MyElements::ResourcepoolGetDefaults',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'EventListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListResult/ScheduleList/ScheduleIdInfo/Name' => 'MyTypes::ObjName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/StorageService/StorageServiceResource' => 'MyTypes::StorageServiceResource',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/CifsSecurityStyle' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'UserFavoriteReportListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInView' => 'MyElements::PerfGetCounterListNotInView',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicyId' => 'MyTypes::ObjId',
               'DpJobProgressEventListIterEndResult' => 'MyElements::DpJobProgressEventListIterEndResult',
               'HostGetDefaultsResult/HostDefaults/AdminPortCacheHttp' => 'MyTypes::IpPortNumber',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/CifsShareNames' => 'MyTypes::ArrayOfCifsShareName',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DpDashboardGetProtectedDataCounts2Result/IgnoredQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_IgnoredQtreeCount',
               'HostListInfoIterStart/HostDpFilterInfo' => 'MyTypes::HostDpFilterInfo',
               'StorageServiceDatasetProvision/StorageSetDetails' => 'MyTypes::ArrayOfStorageSetInfo',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleDailyModify' => 'MyElements::DpScheduleDailyModify',
               'VolumeListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ViVirtualDiskListInfoIterStart' => 'MyElements::ViVirtualDiskListInfoIterStart',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
               'ReportDesignerScheduleModify/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/SpaceUsed' => 'MyTypes::QtreeSizeInfo::_SpaceUsed',
               'DpScheduleDestroy/ScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo/StorageServiceDatasetInfo/StorageServiceId' => 'MyTypes::ObjId',
               'DpJobListIterStart/JobTypes' => 'MyTypes::ArrayOfJobType',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'MigrateChangeState' => 'MyElements::MigrateChangeState',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'ResourcepoolListInfoIterNext/Maximum' => 'MyElements::ResourcepoolListInfoIterNext::_Maximum',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo/Day' => 'MyTypes::DayInfo::_Day',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DpJobListIterStart/JobState' => 'MyTypes::DpJobState',
               'ReportCategoryList/CategoryProvenance' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'RbacAdminRoleInfoList/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DatasetResizeMember/ResizeMemberRequestInfo/SnapReserve' => 'MyTypes::ResizeMemberRequestInfo::_SnapReserve',
               'MigrateCompleteResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolPerfStatus' => 'MyTypes::ObjStatus',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'LdapServerDelete' => 'MyElements::LdapServerDelete',
               'TimezoneGetDefaults' => 'MyElements::TimezoneGetDefaults',
               'DatasetListInfoIterStart/IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GraphListInfoIterStart' => 'MyElements::GraphListInfoIterStart',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'CommentFieldValuesListInfoIterStart/CommentFieldObjectTypes/CommentFieldObjectType' => 'MyTypes::CommentFieldObjectType',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes' => 'MyTypes::StorageServiceNodeAttributes',
               'DpRelationshipListInfoIterEndResult' => 'MyElements::DpRelationshipListInfoIterEndResult',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'PerfThresholdTemplateDetachObjects/Objects/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'DpScheduleDailyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo' => 'MyTypes::DatasetDynamicReferenceInfo',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/ProvisioningPolicyType' => 'MyTypes::ProvisioningPolicyType',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'DpRestoreToPrimary/Paths/DpPathInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolStatus' => 'MyTypes::ObjStatus',
               'DpScheduleWeeklyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DfmScheduleModify/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'MigrateVolume/MigrationRequestInfo' => 'MyTypes::MigrationRequestInfo',
               'DpBackupListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'StorageServiceDatasetProvision/DatasetContact' => 'MyTypes::EmailAddressList',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/TotalSpace' => 'MyTypes::SpaceMeasurement::_TotalSpace',
               'DpScheduleListResult/ScheduleList/ScheduleIdInfo/Name' => 'MyTypes::ObjName',
               'DpPolicyListIterStart' => 'MyElements::DpPolicyListIterStart',
               'DpJobListIterNextResult/Records' => 'MyElements::DpJobListIterNextResult::_Records',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo' => 'MyTypes::DpPolicyNodeInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo/DpNodeId' => 'MyTypes::DatasetNodeInfo::_DpNodeId',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds' => 'MyTypes::DatasetMemberUsedSpaceThresholds',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult' => 'MyElements::PerfGetCounterDependentsResult',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart/VolumesToMigrate' => 'MyTypes::ArrayOfObjectNameOrId',
               'PerfViewGetDataResult/DynamicData/DynamicData' => 'MyTypes::DynamicData',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNext' => 'MyElements::VolumeListInfoIterNext',
               'PerfObjectListInfoResult/Objects/PerfObject/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleSet/IsScheduleEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupGetDynamicDataSources/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsDpRedundant' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LdapServerAdd/LdapServer/LdapServerPort' => 'MyTypes::LdapServer::_LdapServerPort',
               'DfmRelatedObjectsListInfoResult/ParentObjectList/ParentObject/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPath/CheckSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/ResizeVolumeRequestInfo/MaximumCapacity' => 'MyTypes::ResizeVolumeRequestInfo::_MaximumCapacity',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentPlugins/DpAgentPluginInfo/PluginVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/IpAddresses' => 'MyTypes::ArrayOfString',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource' => 'MyTypes::VolumeResource',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/SecondaryQtreeName' => 'MyTypes::ObjName',
               'DatasetCreate/RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/EventTypeFilterList' => 'MyTypes::ArrayOfEventTypeFilter',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/FullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_FullThreshold',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo/StorageServiceDatasetInfo/StorageServiceName' => 'MyTypes::ObjName',
               'PerfClientStatsListInfoIterStart/StartTime' => 'MyTypes::Timestamp',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'ApplicationPolicyEditBegin/ApplicationPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupVersionCreate/VersionMembers' => 'MyTypes::ArrayOfVersionMemberInfo',
               'DpScheduleRename/ScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleGet' => 'MyElements::DfmBackupScheduleGet',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/DailyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionDuration',
               'DpBackupVersionModifyResult' => 'MyElements::DpBackupVersionModifyResult',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserModifyResult' => 'MyElements::HostUserModifyResult',
               'DfmScheduleMonthlySubscheduleSet/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks' => 'MyTypes::ArrayOfPerfHealthCheck',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ThresholdUnit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DpBackupContentListIterEndResult' => 'MyElements::DpBackupContentListIterEndResult',
               'HostGetDefaultsResult/HostDefaults/AdminTransportCache' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'HostListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolPerfStatus' => 'MyTypes::ObjStatus',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/EffectiveUsedDataSpace' => 'MyTypes::SpaceMeasurement::_EffectiveUsedDataSpace',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/Resourcepools/DatasetResourcepoolInfo/ResourcepoolName' => 'MyTypes::ObjName',
               'GroupSetOptions/GroupOptionInfo/ChargebackRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfAssocViewListIterNextResult/Views' => 'MyTypes::ArrayOfPerfView',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentRegisterResult/HostServiceId' => 'MyTypes::ObjId',
               'HostRoleCreate' => 'MyElements::HostRoleCreate',
               'EventStatusChangeListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement' => 'MyTypes::WrapperOfSpaceMeasurement',
               'EventListIterStart/TimeRange/EventTimestampRange' => 'MyTypes::EventTimestampRange',
               'HostUserListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNextResult/Graphs' => 'MyTypes::ArrayOfGraphInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'ReportScheduleModify/ReportScheduleInfo/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'PerfViewModify/View/PerfView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'RbacAccessCheck/Resource/ResourceIdentifier/ResourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpRestoreViStartResult/JobId' => 'MyElements::DpRestoreViStartResult::_JobId',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines' => 'MyTypes::ArrayOfVirtualMachine',
               'DfmSnmpSettingsListInfo' => 'MyElements::DfmSnmpSettingsListInfo',
               'DpScheduleListInfoIterStart' => 'MyElements::DpScheduleListInfoIterStart',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphDataListInfo/EndDate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'MigrateVolume/MigrationRequestInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateName' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'PerfGetServerStatusResult/PerfServerStatus' => 'MyTypes::PerfServerStatus',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'MigrateStart/IpBindings' => 'MyTypes::ArrayOfIpBindingInfo',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'DpOssvApplicationRestoreDestinationListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentPlugins' => 'MyTypes::ArrayOfDpAgentPluginInfo',
               'ResourcepoolMemberListInfoIterNextResult/Records' => 'MyElements::ResourcepoolMemberListInfoIterNextResult::_Records',
               'HostRoleCreate/HostRole' => 'MyTypes::WrapperOfHostRoleInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo/SourceQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/CifsAuthType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'DatasetUpdateDrStatusResult' => 'MyElements::DatasetUpdateDrStatusResult',
               'EventDelete/EventIdList/EventIdType' => 'MyTypes::EventIdType',
               'ReportScheduleRunResult' => 'MyElements::ReportScheduleRunResult',
               'DpRestoreToNewPathResult' => 'MyElements::DpRestoreToNewPathResult',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleDailyDeleteResult' => 'MyElements::DpScheduleDailyDeleteResult',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/SnmpAuthenticationProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo' => 'MyTypes::ResizeMemberRequestInfo',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/Id' => 'MyTypes::ObjId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Dataset/DatasetResource' => 'MyTypes::DatasetResource',
               'StorageServiceListInfoIterStart' => 'MyElements::StorageServiceListInfoIterStart',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldListInfoIterNext/Maximum' => 'MyElements::CommentFieldListInfoIterNext::_Maximum',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DiskListInfoIterNextResult/Disks/DiskInfo/AggregateId' => 'MyTypes::ObjId',
               'DpOssvDirectoryAdd/OssvHostNameOrId' => 'MyTypes::OssvHostNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetAccessDetails/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers' => 'MyTypes::ArrayOfResourcepoolMemberInfo',
               'DpPolicyGetDefaultPropertyValuesResult/HourlyRetentionDuration' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DpNodeId' => 'MyTypes::DatasetSpaceInfo::_DpNodeId',
               'DfmNetworkModify/PrefixLength' => 'MyTypes::PrefixLength',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressHostServiceInfo/OperationId' => 'MyTypes::HostServiceUniqueId',
               'PerfThresholdListInfo2IterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpAgentStoragesystemListInfoIterNextResult' => 'MyElements::DpAgentStoragesystemListInfoIterNextResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'DpDashboardGetProtectedDataCountsResult/IgnoredVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_IgnoredVolumeCount',
               'DpScheduleDailyAdd/DailyContent/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'RbacRoleModify/RoleDescriptionNew' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpDashboardGetProtectedDataCounts2' => 'MyElements::DpDashboardGetProtectedDataCounts2',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapvaultTransferJobData' => 'MyTypes::DpSnapvaultTransferJobData',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'DpPolicyListIterEndResult' => 'MyElements::DpPolicyListIterEndResult',
               'StorageServiceDestroy/StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleCreateResult' => 'MyElements::DfmScheduleCreateResult',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/OutputFormatList/ReportOutputFormat' => 'MyTypes::ReportOutputFormat',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedApplicationResources/ApplicationResourceInfo/Count' => 'MyTypes::ApplicationResourceInfo::_Count',
               'AlarmModify/AlarmInfo/EmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects' => 'MyTypes::ArrayOfObjectInfo',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'ViVirtualCenterListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatastoreName' => 'MyTypes::ObjName',
               'PerfGetCounterData/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDestroy/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'EventListIterStart/IncludeEventArguments' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/DestinationVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupSetOptions/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobContextApplicationResourceNamespaces/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'ViDatacenterListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionDuration',
               'VfilerSetup/IpBindings' => 'MyTypes::ArrayOfIpBindingInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostCommunicationStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterEndResult' => 'MyElements::DatasetMemberListInfoIterEndResult',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo' => 'MyTypes::DeleteSnapshotsRequestInfo',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'DatasetMemberListInfoIterStart/MemberNameOrId' => 'MyTypes::ObjNameOrId',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines' => 'MyTypes::ArrayOfGraphLineInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo' => 'MyTypes::ProvisioningPolicyInfo',
               'PerfViewGetDataResult' => 'MyElements::PerfViewGetDataResult',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentValue' => 'MyTypes::CommentValue',
               'PerfCounterGroupStart/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode' => 'MyTypes::WrapperOfMetricDatasetNodeInfo',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/ErrorsOut' => 'MyTypes::NetifIpInterfaceInfo::_ErrorsOut',
               'DatasetAddMember/IsExistingMemberOk' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters' => 'MyTypes::ArrayOfPerfCounterData',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/StoragesetTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterEndResult' => 'MyElements::HostDomainuserListIterEndResult',
               'QtreeListInfoIterStart/IsSnapvaultSecondaryQtrees' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'PerfThresholdModify2/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'VfilerCreate/AllowedProtocols/Protocol' => 'MyTypes::Protocol',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'DpBackupVersionListIterStart/SubPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/DailyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionCount',
               'PerfThresholdListInfo2IterStart/ThresholdId' => 'MyTypes::ThresholdId',
               'LunResize/NewSize' => 'MyElements::LunResize::_NewSize',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TimeFrom' => 'MyTypes::AlarmInfo::_TimeFrom',
               'RbacAdminRoleAddResult/AdminNameOrId/RbacAdminNameOrId/AdminName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/SanContainerSettings/GuaranteeWrites' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleDisinherit/DisinheritedRoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndHour' => 'MyTypes::ThrottleItemInfo::_EndHour',
               'PerfViewDestroyResult' => 'MyElements::PerfViewDestroyResult',
               'DatasetResizeMember/ResizeMemberRequestInfo/NewSize' => 'MyTypes::ResizeMemberRequestInfo::_NewSize',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerCreateResult/FilerName' => 'MyTypes::ObjFullName',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Host/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklySubscheduleAdd/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateName' => 'MyTypes::ObjName',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/CanContainStorageResources' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentRegister/SuppressRegisteredError' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/ProvisioningPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterStart' => 'MyElements::DatasetSpaceMetricListInfoIterStart',
               'ProvisioningPolicyModify/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'MigrateStart' => 'MyElements::MigrateStart',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DpScheduleContentGetResult/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'VolumeListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModify/ApplicationInfo/ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'HostUserModifyPassword' => 'MyElements::HostUserModifyPassword',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/StorageReliability' => 'MyTypes::StorageReliability',
               'QtreeStartMonitoring' => 'MyElements::QtreeStartMonitoring',
               'ResourcepoolDestroy/ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo' => 'MyTypes::BackupLocationInfo',
               'DpBackupStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetReplacePrimaryMembersResult' => 'MyElements::DatasetReplacePrimaryMembersResult',
               'DfmScheduleListInfoIterNext' => 'MyElements::DfmScheduleListInfoIterNext',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/VolumeId' => 'MyTypes::ObjId',
               'DpJobScheduleListIterStart/ToTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume' => 'MyTypes::WrapperOfVolumeResource',
               'MigrateStart/BandwidthThrottle' => 'MyElements::MigrateStart::_BandwidthThrottle',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AuditLogAddEntryResult' => 'MyElements::AuditLogAddEntryResult',
               'DpBackupStart/BackupDestinationNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/AssocObjType/PerfAssocObjType' => 'MyTypes::PerfAssocObjType',
               'CommentFieldCreateResult/CommentFieldId' => 'MyTypes::CommentFieldId',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterEnd' => 'MyElements::HostDomainuserListIterEnd',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/DeprecatedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/MigrationStatus' => 'MyTypes::MigrationStatus',
               'PerfThresholdModify2/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'HostUsergroupListIterNextResult/Records' => 'MyElements::HostUsergroupListIterNextResult::_Records',
               'ProvisioningPolicyListIterNextResult' => 'MyElements::ProvisioningPolicyListIterNextResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/SnapshotReserveTotal' => 'MyTypes::VolumeSize::_SnapshotReserveTotal',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupAddMember' => 'MyElements::GroupAddMember',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyId' => 'MyTypes::ObjId',
               'HostRoleCreate/HostRole/HostRoleInfo/HostId' => 'MyTypes::ObjId',
               'LunListInfoIterNextResult/Luns' => 'MyTypes::ArrayOfLunInfo',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesUsed' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/PrefixLength' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'GroupRenameResult' => 'MyElements::GroupRenameResult',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateInfo',
               'VfilerCreate/Ipspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/StorageService' => 'MyTypes::WrapperOfStorageServiceResource',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate' => 'MyTypes::WrapperOfAggregateResource',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSpaceMetricListInfoIterStart/Year' => 'MyElements::DatasetSpaceMetricListInfoIterStart::_Year',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSize/SizeTotal' => 'MyTypes::AggregateSize::_SizeTotal',
               'DfmScheduleMonthlyModify/MonthlyContent/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'ResourcepoolListInfoIterStart/CheckLicenses' => 'MyTypes::ArrayOfLicense',
               'StorageServiceDatasetProvision/DatasetMetadata/DfmMetadataField/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsData/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupListIterStartResult' => 'MyElements::GroupListIterStartResult',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleItemDeleteResult' => 'MyElements::DpThrottleItemDeleteResult',
               'DpDashboardGetProtectedDataCounts2Result/IgnoredDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_IgnoredDatasetCount',
               'LunListInfoIterNextResult/Luns/LunInfo/QtreeName' => 'MyTypes::ObjName',
               'DpBackupVersionCreate/IsComplete' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterNextResult/Views/PerfView/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostSetOption' => 'MyElements::HostSetOption',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled' => 'MyTypes::ArrayOfPerfDataSource',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/SanContainerSettings/ThinProvisioningConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'EventStatusChangeListIterStart/TimeRange' => 'MyTypes::WrapperOfEventTimestampRange',
               'PerfEnableObjectUpdate' => 'MyElements::PerfEnableObjectUpdate',
               'MigrateUpdate/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupListIterStartResult/Records' => 'MyElements::GroupListIterStartResult::_Records',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlySubscheduleSet/SubscheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualDiskListInfoIterStartResult/Records' => 'MyElements::ViVirtualDiskListInfoIterStartResult::_Records',
               'UserFavoriteReportListInfoIterNextResult/Favorites/UserReportInfo' => 'MyTypes::UserReportInfo',
               'HostListInfoIterStart/HostDpFilterInfo/IsInResourcepool' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobScheduleListIterEndResult' => 'MyElements::DpJobScheduleListIterEndResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails/ProtectionStatusJobDetail/ProtectionStatusJobId' => 'MyTypes::ProtectionStatusJobDetail::_ProtectionStatusJobId',
               'ViVirtualCenterListInfoIterStart' => 'MyElements::ViVirtualCenterListInfoIterStart',
               'PerfGetCounterDataResult/PerfInstances' => 'MyTypes::ArrayOfPerfInstanceCounterData',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
               'HostAddResult' => 'MyElements::HostAddResult',
               'AlarmGetDefaultsResult/AlarmDefaults/IsRepeatNotify' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'DatasetExclusionListInfoIterNext/Maximum' => 'MyElements::DatasetExclusionListInfoIterNext::_Maximum',
               'DpScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines/GraphLineInfo/SampleFormat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/BackupMetadata/DfmMetadata/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDestroyResult' => 'MyElements::DatasetDestroyResult',
               'DpBackupVersionListIterNext' => 'MyElements::DpBackupVersionListIterNext',
               'DpDashboardGetLaggedRelationships/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListUpgradeCandidatesResult/DpAgentVersionInfos' => 'MyTypes::ArrayOfDpAgentVersionInfo',
               'HostUserListIterStart/Verbose' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostCapabilityListIterStart/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapvaultSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/RoleNameAndId' => 'MyTypes::WrapperOfRbacRoleResource',
               'PerfClientStatsPurge' => 'MyElements::PerfClientStatsPurge',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunSeverity' => 'MyTypes::ObjStatus',
               'CommentFieldDestroyResult' => 'MyElements::CommentFieldDestroyResult',
               'ReportScheduleModify/ReportScheduleInfo/EmailAddressList' => 'MyTypes::EmailAddressList',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeState' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventSourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapvaultTransferJobData/ConnectionId' => 'MyTypes::DpSnapvaultTransferJobData::_ConnectionId',
               'GroupListIterEndResult' => 'MyElements::GroupListIterEndResult',
               'UserFavoriteReportListInfoIterNext' => 'MyElements::UserFavoriteReportListInfoIterNext',
               'DatasetExclusionListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/RootObjectId' => 'MyTypes::ObjId',
               'RbacOperationAdd/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ClientRegistrySet/Options/ClientOptionInfo/Option' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/MaximumDataSize' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize',
               'ResourcepoolMemberListInfoIterStartResult' => 'MyElements::ResourcepoolMemberListInfoIterStartResult',
               'EventclassListResult/EventClasses/EventClassInfo/EventNames' => 'MyTypes::ArrayOfEventNameInfo',
               'EventclassListIterNextResult/EventClasses' => 'MyTypes::ArrayOfEventClassInfo',
               'DatasetModify/DatasetName' => 'MyTypes::ObjName',
               'DatasetBeginFailoverResult' => 'MyElements::DatasetBeginFailoverResult',
               'DpScheduleWeeklySubscheduleAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LdapServerAdd' => 'MyElements::LdapServerAdd',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/DatasetNode/MetricDatasetNodeInfo/DatasetId' => 'MyTypes::ObjId',
               'DpBackupStart/BackupMembers/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets' => 'MyTypes::ArrayOfDpDatasetLagInfo',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo' => 'MyTypes::ApplicationBackupOperationInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyId' => 'MyTypes::ObjId',
               'ResourcepoolModifyMemberResult' => 'MyElements::ResourcepoolModifyMemberResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/MaximumY' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewDestroy/IsCounterGroupAlsoDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'HostModifyAgentCredentials/AgentNameOrId' => 'MyTypes::HostNameOrId',
               'PerfCollectClientOperationStatisticsResult/Errors' => 'MyTypes::ArrayOfClientStatError',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DatasetAddMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo/CifsSharePermissions/CifsSharePermission' => 'MyTypes::CifsSharePermission',
               'ReportScheduleDelete' => 'MyElements::ReportScheduleDelete',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'UserFavoriteReportListInfoIterNextResult/Favorites' => 'MyTypes::ArrayOfUserReportInfo',
               'RbacAdminListInfoIterNextResult/Admins/AdminInfo' => 'MyTypes::AdminInfo',
               'DpJobProgressEventListIterNext' => 'MyElements::DpJobProgressEventListIterNext',
               'LunResize/ResizeUnderlyingVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ObjectName' => 'MyTypes::ObjName',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Size' => 'MyTypes::ProvisionMemberRequestInfo::_Size',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolMemberCount' => 'MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'DpRestoreToNewPath/MigrateRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/Name' => 'MyTypes::DpPolicyNodeName',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/IsDisableAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmAboutResult/InstalledPlugins' => 'MyTypes::ArrayOfPlugin',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo' => 'MyTypes::ProvisioningPolicyInfo',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagErrorThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagErrorThreshold',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos' => 'MyTypes::ArrayOfDpBackupTransferInfo',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/NisServers' => 'MyTypes::ArrayOfIpAddress',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/Name' => 'MyTypes::DpPolicyNodeName',
               'StorageServiceDatasetProvisionResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'PerfCounterGroupCreate' => 'MyElements::PerfCounterGroupCreate',
               'StorageServiceDatasetModify/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpSnapvaultTransferJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'ViHypervisorListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters' => 'MyTypes::ArrayOfPerfMissingHostObjectCounter',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'MigrateCancelResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressJobAbortInfo/AbortedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/EventClass' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo' => 'MyTypes::HostInfo',
               'DpAgentListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolFullThreshold',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModifyResult' => 'MyElements::DpPolicyModifyResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/DiscardsIn' => 'MyTypes::NetifIpInterfaceInfo::_DiscardsIn',
               'PerfThresholdCreate2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'GroupListIterNextResult/GroupList/GroupInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults' => 'MyTypes::ArrayOfDryRunResult',
               'PerfViewGetData/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/DpFileInfo/ChildCount' => 'MyTypes::DpFileInfo::_ChildCount',
               'RbacRoleAdminInfoListResult/RoleList' => 'MyTypes::ArrayOfRbacRoleResource',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/DatasetId' => 'MyTypes::QtreeInfo::_DatasetId',
               'EventclassListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmModify/AlarmInfo/PagerEmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceName' => 'MyTypes::ObjName',
               'GroupListIterEnd' => 'MyElements::GroupListIterEnd',
               'PerfThresholdCreate2' => 'MyElements::PerfThresholdCreate2',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos/AggregateSpaceInfo/AggregateId' => 'MyTypes::ObjId',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/UsedSnapshotSpace' => 'MyTypes::SpaceMeasurement::_UsedSnapshotSpace',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterEnd' => 'MyElements::DiskListInfoIterEnd',
               'DpAgentListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostListInfoIterStart/HostDpFilterInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Group/GroupResource/GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportOutputReadResult/Length' => 'MyElements::ReportOutputReadResult::_Length',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupName' => 'MyTypes::ObjName',
               'QtreeModify/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine' => 'MyTypes::PerfLine',
               'ViVirtualCenterListInfoIterStartResult/Records' => 'MyElements::ViVirtualCenterListInfoIterStartResult::_Records',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/ObjectId' => 'MyTypes::ObjId',
               'PerfViewListIterNextResult/Views/PerfView/AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/DestinationVfilerName' => 'MyTypes::ObjFullName',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DfmScheduleMonthlyDeleteResult' => 'MyElements::DfmScheduleMonthlyDeleteResult',
               'ViVirtualCenterListInfoIterEnd' => 'MyElements::ViVirtualCenterListInfoIterEnd',
               'MigrateFixResult' => 'MyElements::MigrateFixResult',
               'HostListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource' => 'MyTypes::VfilerTemplateResource',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/CommittedSpace' => 'MyTypes::AggregateSpaceInfo::_CommittedSpace',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolContact' => 'MyTypes::EmailAddressList',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ThresholdValue' => 'MyTypes::ThresholdInfo::_ThresholdValue',
               'ResourcepoolMemberListInfoIterStart/ResourcepoolMemberNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleModify/ReportScheduleInfo' => 'MyTypes::ReportScheduleInfo',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolSpaceStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterStart' => 'MyElements::HostRoleListIterStart',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/DnsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterStart/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'ResourcepoolModifyMember' => 'MyElements::ResourcepoolModifyMember',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'DpThrottleListInfoIterNextResult/ThrottleList' => 'MyTypes::ArrayOfThrottleContent',
               'StorageServiceListInfoIterNextResult/StorageServices' => 'MyTypes::ArrayOfStorageServiceInfo',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualMachineId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DfmScheduleDestroy' => 'MyElements::DfmScheduleDestroy',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId' => 'MyTypes::QtreeNameOrId',
               'HostUserModify/HostUser/HostUserInfo/HostName' => 'MyTypes::ObjName',
               'AggregateListInfoIterNext/Maximum' => 'MyElements::AggregateListInfoIterNext::_Maximum',
               'DpScheduleHourlyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmServerListDiagnosticInfoResult/DiagInfo/DfmDiagCounterGroup/Histogram' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/GuestOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/DatasetName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Dependencies/SnapshotDependency' => 'MyTypes::SnapshotDependency',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/AdministrativeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/ResizeVolumeRequestInfo/SnapReserve' => 'MyTypes::ResizeVolumeRequestInfo::_SnapReserve',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues' => 'MyTypes::ArrayOfCommentFieldValue',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled' => 'MyTypes::ArrayOfPerfDataSource',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'PerfAssocViewListIterNextResult/Records' => 'MyElements::PerfAssocViewListIterNextResult::_Records',
               'DatasetEditCommitResult/JobIds/JobInfo' => 'MyTypes::JobInfo',
               'HostModify/HostModifyInfo/HostDpModifyInfo' => 'MyTypes::HostDpModifyInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'PerfThresholdTemplateAttachObjects/NewObjects/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModifyResult' => 'MyElements::ReportDesignerScheduleModifyResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostDomainuserName' => 'MyTypes::DomainuserName',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd/ReportScheduleInfo/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'IfcListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/EmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DedupeMemberRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportListInfoIterEnd' => 'MyElements::ReportListInfoIterEnd',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo/CanBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo/SourceQtreeId' => 'MyTypes::DpProgressSnapvaultInfo::_SourceQtreeId',
               'PerfViewCreate/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'EventclassAddCustom/IsMultiCurrent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DpRestoreViStart/DpViRestoreSettings/DpViHypervRestoreSettings/StartVmAfterRestore' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventclassListResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/Severity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCopyCounterConfiguration/DestinationObjects/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberDeleteSnapshotsResult' => 'MyElements::DatasetMemberDeleteSnapshotsResult',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/LastDedupeBeginTimestamp' => 'MyTypes::Timestamp',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/GroupMemberAttributes/GroupMemberAttribute/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupContentListIterEnd' => 'MyElements::DpBackupContentListIterEnd',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Size' => 'MyTypes::ProvisionMemberRequestInfo::_Size',
               'MigrateCleanupResult' => 'MyElements::MigrateCleanupResult',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo/IgroupInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DfmSnmpSettingDelete/PrefixLength' => 'MyTypes::PrefixLength',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/CpuMaxTime' => 'MyTypes::ApiStat::_CpuMaxTime',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/FromNodeId' => 'MyTypes::DpPolicyConnectionInfo::_FromNodeId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupInfo/IgroupId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource' => 'MyTypes::LunResource',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/MonthlyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionCount',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/NfsOpStats/OtherOperations' => 'MyTypes::NfsOpStats::_OtherOperations',
               'DiskListInfoIterNextResult/Disks/DiskInfo/DiskId' => 'MyTypes::ObjId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DpBackupStart/BackupMembers' => 'MyTypes::ArrayOfObjNameOrId',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterStart' => 'MyElements::DpJobScheduleListIterStart',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/IsCapableOfMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryRootsIterNextResult' => 'MyElements::DpOssvDirectoryRootsIterNextResult',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo' => 'MyTypes::DeleteSnapshotsRequestInfo',
               'ResourcepoolListInfoIterNextResult' => 'MyElements::ResourcepoolListInfoIterNextResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeId' => 'MyTypes::ObjId',
               'DpThrottleItemAdd/ThrottleItemContent' => 'MyTypes::WrapperOfThrottleItemInfo',
               'EventAcknowledgeResult/EventAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacOperationInfoList/Operation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'DpScheduleWeeklySubscheduleModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleAddResult' => 'MyElements::DfmScheduleWeeklySubscheduleAddResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldListInfoIterStartResult' => 'MyElements::CommentFieldListInfoIterStartResult',
               'TimezoneListInfoIterEnd' => 'MyElements::TimezoneListInfoIterEnd',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionDuration',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'PerfViewGetData/Instance/PerfCounterInstance/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ResourcepoolListInfoIterNext' => 'MyElements::ResourcepoolListInfoIterNext',
               'DfmRelatedObjectsListInfoResult/ParentResourcepoolList/ParentResourcepool/Id' => 'MyTypes::ObjId',
               'HostModify/HostModifyInfo/HostName' => 'MyTypes::ObjName',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/SanContainerSettings/ThinProvisioningConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/DatacenterName' => 'MyTypes::ObjName',
               'DpScheduleWeeklyDelete' => 'MyElements::DpScheduleWeeklyDelete',
               'QtreeListInfoIterStart' => 'MyElements::QtreeListInfoIterStart',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'DpBackupVersionListIterStartResult' => 'MyElements::DpBackupVersionListIterStartResult',
               'MigrateCompleteResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'GraphDataListInfo' => 'MyElements::GraphDataListInfo',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement' => 'MyTypes::SpaceMeasurement',
               'CommentFieldCreate/CommentFieldInfo/IsSystemComment' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'StorageServiceListInfoIterStartResult' => 'MyElements::StorageServiceListInfoIterStartResult',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewObjectAssociationDelete' => 'MyElements::PerfViewObjectAssociationDelete',
               'StorageServiceModify/IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetDrDatasetCountsResult/DrStateStatusCounts/DrStateStatusCount/Count' => 'MyTypes::DrStateStatusCount::_Count',
               'RbacRoleAdminInfoListResult/RoleList/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/TimeToFull' => 'MyTypes::AggregateInfo::_TimeToFull',
               'PerfCounterGroupGetDynamicDataSources/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/OverwriteReserveAvail' => 'MyTypes::VolumeSize::_OverwriteReserveAvail',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledgeResult/EventsAcknowledgedList/EventActionInfo/Timestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'TimezoneValidateResult' => 'MyElements::TimezoneValidateResult',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicyType' => 'MyTypes::ApplicationPolicyType',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleHourlyModify' => 'MyElements::DpScheduleHourlyModify',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionCount',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/InheritedRoles/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatacenterReference' => 'MyTypes::DatacenterReference',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/StartRemoteBackupAfterLocalBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_UnprotectedDatasetCount',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRestoreToPrimary/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfAssocViewListIterNextResult/Views/PerfView/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupContentListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterStart/HostDpFilterInfo/IsSnapvaultPrimaryOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterStartResult' => 'MyElements::DatasetMemberListInfoIterStartResult',
               'GraphDataListInfoResult/GraphLineValues/GraphLineValueInfo/SampleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostSetOption/HostOptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/StoragesetId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementAddOperation' => 'MyElements::AggregateSpaceManagementAddOperation',
               'EventclassListIterNext' => 'MyElements::EventclassListIterNext',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo' => 'MyTypes::VersionMemberInfo',
               'AggregateModifyResult' => 'MyElements::AggregateModifyResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryName' => 'MyTypes::ObjName',
               'DpJobListIterEnd' => 'MyElements::DpJobListIterEnd',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/RbacRole' => 'MyTypes::WrapperOfRbacRoleResource',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndMinute' => 'MyTypes::ThrottleItemInfo::_EndMinute',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'PerfThresholdModify/Attributes/ThresholdInfo/ThresholdValue' => 'MyTypes::ThresholdInfo::_ThresholdValue',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyDelete/MonthlyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupMoveResult' => 'MyElements::GroupMoveResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/ResourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/BackupScheduleId' => 'MyTypes::ObjId',
               'RbacAdminListInfoIterNextResult/Admins' => 'MyTypes::ArrayOfAdminInfo',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreateResult/VfilerTemplateId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionCount',
               'PerfCounterGroupStart/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/EditLockId' => 'MyElements::DatasetProvisionMember::_EditLockId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'AggregateListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyModify' => 'MyElements::DfmScheduleMonthlyModify',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'ResourcepoolListInfoIterStartResult/Records' => 'MyElements::ResourcepoolListInfoIterStartResult::_Records',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceId' => 'MyTypes::ObjId',
               'PerfCounterGroupListIterStart/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklyAdd/WeeklyContent/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DfmScheduleList' => 'MyElements::DfmScheduleList',
               'MigrateStart/VolumeAggregateMap/VolumeAggregatePair/Volume' => 'MyTypes::ObjNameOrId',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleRename/NewScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldCreate/CommentFieldInfo/CommentFieldObjectTypes/CommentFieldObjectType' => 'MyTypes::CommentFieldObjectType',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedRelationships/MaxRelationships' => 'MyElements::DpDashboardGetLaggedRelationships::_MaxRelationships',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DatasetMemberListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacAdminListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmScheduleWeeklySubscheduleModify/ItemId' => 'MyElements::DfmScheduleWeeklySubscheduleModify::_ItemId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectRefreshResult' => 'MyElements::DfmObjectRefreshResult',
               'DpPolicyGetDefaultPropertyValuesResult/HourlyRetentionCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMemberListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/ResourceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'RbacAccessCheck/Resource/ResourceIdentifier/RbacRole' => 'MyTypes::WrapperOfRbacRoleResource',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/SnapshotScheduleId' => 'MyTypes::ObjId',
               'ReportGraphListInfoIterNextResult' => 'MyElements::ReportGraphListInfoIterNextResult',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'DfmSnmpSettingAddResult' => 'MyElements::DfmSnmpSettingAddResult',
               'DfmScheduleDailyAddResult' => 'MyElements::DfmScheduleDailyAddResult',
               'DfmNetworkDelete/NetworkId' => 'MyTypes::ObjId',
               'HostGetDefaultsResult/HostDefaults/AdminPortHostHttp' => 'MyTypes::IpPortNumber',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetResizeMember/ResizeMemberRequestInfo/MemberId' => 'MyTypes::ObjId',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/LastDiscoveryStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/LicensedFeatures/Feature/Summary' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/MaximumY' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'QtreeModifyResult' => 'MyElements::QtreeModifyResult',
               'DpPolicyDestroyResult' => 'MyElements::DpPolicyDestroyResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo' => 'MyTypes::ApplicationPolicySettingsInfo',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource' => 'MyTypes::ResourcePoolResource',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/HostPerfStatus' => 'MyTypes::ObjStatus',
               'HostUserListIterNext' => 'MyElements::HostUserListIterNext',
               'PerfCopyCounterConfigurationResult/CopyResult/DestinationHostInfo/ErrorReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListResult/EventClasses/EventClassInfo/EventClassName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/StorageReliability/ControllerFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'HostRoleListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance' => 'MyTypes::InvalidCounterInstance',
               'PerfClientStatsListInfoIterEnd' => 'MyElements::PerfClientStatsListInfoIterEnd',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMissingMemberListInfoIterStartResult' => 'MyElements::DatasetMissingMemberListInfoIterStartResult',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataGroupMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/HostNameOrId' => 'MyTypes::HostNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/EventNameShort' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDestroy' => 'MyElements::StorageServiceDestroy',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/CategoryStatus' => 'MyTypes::ObjStatus',
               'HostListInfoIterNextResult/Hosts/HostInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleContentGetResult/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetDynamicReferenceListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'IfcListInfoIterNext/Maximum' => 'MyElements::IfcListInfoIterNext::_Maximum',
               'ReportScheduleModify/ReportScheduleInfo/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'UserRecentReportListInfoIterNextResult' => 'MyElements::UserRecentReportListInfoIterNextResult',
               'CommentFieldListInfoIterStart/ShowSystemComments' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleDependency/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/SystemMemory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'PerfViewModify/View/PerfView/Charts/PerfChart' => 'MyTypes::PerfChart',
               'DpGetDatasetBackupJobsData' => 'MyElements::DpGetDatasetBackupJobsData',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/Total' => 'MyTypes::VolumeSize::_Total',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DatasetAddToExclusionList/ObjectsToBeAdded' => 'MyTypes::ArrayOfObjNameOrId',
               'HostDomainuserListIterNext/Maximum' => 'MyElements::HostDomainuserListIterNext::_Maximum',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'DpAgentModify/HostserviceModifyInfo' => 'MyTypes::HostserviceModifyInfo',
               'SrmFileTypeDelete/SrmFileTypeNameOrIdList' => 'MyTypes::ArrayOfObjectNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeOptions/VolumeOption/OptionValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterStartResult/Records' => 'MyElements::LunListInfoIterStartResult::_Records',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklySubscheduleModify/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine' => 'MyTypes::PerfLine',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
               'SnapshotListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphEdges' => 'MyTypes::ArrayOfBackupGraphEdgeInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/DedupeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetExclusionListInfoIterStartResult/Records' => 'MyElements::DatasetExclusionListInfoIterStartResult::_Records',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/SecondaryMemberName' => 'MyTypes::ObjName',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo' => 'MyTypes::DpRelationshipLagInfo',
               'HostModifyResult' => 'MyElements::HostModifyResult',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/SanContainerSettings' => 'MyTypes::SanContainerSettings',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleListIterNextResult/Records' => 'MyElements::HostRoleListIterNextResult::_Records',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/DisplayTab' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyModifyResult' => 'MyElements::ProvisioningPolicyModifyResult',
               'DfmScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCredentialsStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/Speed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'ResourcepoolCreate/Resourcepool' => 'MyTypes::WrapperOfResourcepoolInfo',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos' => 'MyTypes::ArrayOfAggregateSpaceInfo',
               'DpJobListIterStart/JobType' => 'MyTypes::DpJobType',
               'CommentSetObjectValue/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/AlarmId' => 'MyTypes::AlarmInfo::_AlarmId',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo/CifsSecurityStyle' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'HostUserModifyPassword/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'EventStatusChangeListIterEndResult' => 'MyElements::EventStatusChangeListIterEndResult',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'LunListInfoIterNextResult/Luns/LunInfo/LunPath' => 'MyTypes::ObjName',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'MigrateStart/IpBindings/IpBindingInfo/PartnerInterface' => 'MyTypes::ObjNameOrId',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo' => 'MyTypes::HourlyInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Policy/PolicyResource' => 'MyTypes::PolicyResource',
               'DfmBackupStatusResult' => 'MyElements::DfmBackupStatusResult',
               'DpScheduleWeeklyAdd/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo' => 'MyTypes::ArrayOfLunIgroupInfo',
               'FcpTargetListInfoIterNextResult/Records' => 'MyElements::FcpTargetListInfoIterNextResult::_Records',
               'DatasetCreate/ProtectionPolicyId' => 'MyTypes::ObjId',
               'Fault/faultcode' => 'SOAP::WSDL::XSD::Typelib::Builtin::anyURI',
               'DpJobListIterStart/JobId' => 'MyElements::DpJobListIterStart::_JobId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/BackupScheduleName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource' => 'MyTypes::AggregateResource',
               'HostRoleModify/HostRole/HostRoleInfo/Capabilities/Capability' => 'MyTypes::Capability',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterNextResult/Views/PerfView' => 'MyTypes::PerfView',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleListResult/ScheduleList/ScheduleIdInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModify/VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/RoleNameAndId/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'VolumeListInfoIterEndResult' => 'MyElements::VolumeListInfoIterEndResult',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolStatus' => 'MyTypes::ObjStatus',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingModify' => 'MyElements::DfmSnmpSettingModify',
               'SnapshotGetReclaimableInfo/VolumeNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupListIterNextResult/GroupList/GroupInfo/HasPrivilege' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlySubscheduleUnset/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpScheduleListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventAbout' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupMemberListIterStart/Groups' => 'MyTypes::ArrayOfGroup',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DatacenterReference' => 'MyTypes::DatacenterReference',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationInfoList' => 'MyElements::RbacOperationInfoList',
               'RbacRoleCapabilityAdd/Resource' => 'MyTypes::WrapperOfResourceIdentifier',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupInfo' => 'MyTypes::ProgressIgroupInfo',
               'QtreeListInfoIterNext/Maximum' => 'MyElements::QtreeListInfoIterNext::_Maximum',
               'PerfObjectInstanceListIterStart/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ReportScheduleInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmAbout/IncludeDirectorySizeInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert' => 'MyTypes::ConformanceAlert',
               'DpRestoreToPrimaryResult/SpaceStatusResults/SpaceStatusResult/DestVol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/QuotaSoftLimit' => 'MyTypes::MissingMemberInfo::_QuotaSoftLimit',
               'GroupMemberListIterEndResult' => 'MyElements::GroupMemberListIterEndResult',
               'EventListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdModify/Attributes/ThresholdInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/DpNodeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdListInfoIterNextResult' => 'MyElements::PerfThresholdListInfoIterNextResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo' => 'MyTypes::DpProgressRestoreInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/DestinationFilerName' => 'MyTypes::ObjFullName',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'RbacRoleCapabilityAdd' => 'MyElements::RbacRoleCapabilityAdd',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'DfmRelatedObjectsListInfoResult/ParentGroupList/ParentGroup/Name' => 'MyTypes::ObjName',
               'GroupCreateResult' => 'MyElements::GroupCreateResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'DiskListInfoIterNextResult/Disks/DiskInfo' => 'MyTypes::DiskInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQtreeInfo/VolumeName' => 'MyTypes::ObjFullName',
               'DiskListInfoIterNextResult/Records' => 'MyElements::DiskListInfoIterNextResult::_Records',
               'DpBackupVersionDelete' => 'MyElements::DpBackupVersionDelete',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree' => 'MyTypes::WrapperOfQtreeResource',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/MaximumDataSize' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize',
               'DatasetListInfoIterNextResult' => 'MyElements::DatasetListInfoIterNextResult',
               'ReportGraphListInfoIterStart/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmBackupScheduleSet/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndHour' => 'MyTypes::ThrottleItemInfo::_EndHour',
               'RbacRoleInfoList' => 'MyElements::RbacRoleInfoList',
               'DpScheduleModify/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/FromNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/SnapvaultAccessSpecifier' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetAccessDetails/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'AlarmModify/AlarmInfo/AdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolStatus' => 'MyTypes::ObjStatus',
               'DfmMonitorTimestampList' => 'MyElements::DfmMonitorTimestampList',
               'VfilerTemplateListInfoIterStart/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupListIterStart/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'DpRestoreViStart/DpViRestoreObjects/DpViRestoreObject/RestoreObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateModify/VfilerTemplate/VfilerTemplateInfo' => 'MyTypes::VfilerTemplateInfo',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList/DayInfo/Day' => 'MyTypes::DayInfo::_Day',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DpScheduleMonthlyDelete/ItemId' => 'MyElements::DpScheduleMonthlyDelete::_ItemId',
               'RbacRoleCapabilityAddResult' => 'MyElements::RbacRoleCapabilityAddResult',
               'AlarmCreate/AlarmInfo/AdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo' => 'MyTypes::ApplicationBackupScheduleInfo',
               'DpScheduleCreate/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupDeleteResult' => 'MyElements::HostUsergroupDeleteResult',
               'UserFavoriteReportListInfoIterStart/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddMemberByDynamicReference' => 'MyElements::DatasetAddMemberByDynamicReference',
               'DpJobListIterNext' => 'MyElements::DpJobListIterNext',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/AllocatedCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ProvisioningPolicyCopy/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'LdapServerListInfo' => 'MyElements::LdapServerListInfo',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets/DpDatasetLagInfo/LagStatus' => 'MyTypes::ObjStatus',
               'ReportScheduleListInfoIterStart' => 'MyElements::ReportScheduleListInfoIterStart',
               'DpScheduleCreate/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreateResult' => 'MyElements::AlarmCreateResult',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/TotalDataSpace' => 'MyTypes::SpaceMeasurement::_TotalDataSpace',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAdminRoleInfoListResult/AdminList/RbacAdminOrUsergroup' => 'MyTypes::RbacAdminOrUsergroup',
               'DpBackupVersionCreate/VersionTimestamp' => 'MyTypes::DpTimestamp',
               'ProvisioningPolicyEditBeginResult/EditLockId' => 'MyElements::ProvisioningPolicyEditBeginResult::_EditLockId',
               'DatasetCreate/SnapshotNameFormat' => 'MyTypes::SnapshotNameFormat',
               'EventListIterStart/IncludeDeletedObjects' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolFreeVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory' => 'MyTypes::PerfDiagCategory',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'HostAddLicenseResult' => 'MyElements::HostAddLicenseResult',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/QtreeStatus' => 'MyTypes::ObjStatus',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionCreate/IsNative' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'VfilerTemplateListInfoIterStart' => 'MyElements::VfilerTemplateListInfoIterStart',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'TimezoneValidateResult/UtcOffset' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolKbytesUsed' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesUsed',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceType' => 'MyTypes::RelationshipEndpointType',
               'VolumeModify/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleModify/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'DfmScheduleDailyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterStartResult' => 'MyElements::UserFavoriteReportListInfoIterStartResult',
               'DpOssvDirectoryRootsIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNext/Maximum' => 'MyElements::PerfThresholdListInfoIterNext::_Maximum',
               'HostRoleCreate/HostRole/HostRoleInfo/HostRoleName' => 'MyTypes::AccessObjectName',
               'HostAdd/BlockCmode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModify' => 'MyElements::StorageServiceModify',
               'DpJobProgressEventListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetExclusionListInfoIterNextResult' => 'MyElements::DatasetExclusionListInfoIterNextResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/CarryPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetCreate/ApplicationInfo/ApplicationVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/VolumeAggregateMap' => 'MyTypes::ArrayOfVolumeAggregatePair',
               'PerfThresholdTemplateListInfoIterNext/Maximum' => 'MyElements::PerfThresholdTemplateListInfoIterNext::_Maximum',
               'RbacAccessCheck/Resource/ResourceIdentifier/Dataset' => 'MyTypes::WrapperOfDatasetResource',
               'DpBackupListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TrapDestinations/TrapDestination' => 'MyTypes::TrapDestination',
               'AlarmListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterStartResult' => 'MyElements::ViDatacenterListInfoIterStartResult',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter' => 'MyTypes::PerfPurgedHostObjectCounter',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostUsergroupIds/HostUsergroupId' => 'MyTypes::HostUsergroupId',
               'DpScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/EventSeverity' => 'MyTypes::ObjStatus',
               'GraphListInfoIterStartResult/Records' => 'MyElements::GraphListInfoIterStartResult::_Records',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourceTag' => 'MyTypes::ResourceTag',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCopyResult/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/ApplicationInfo' => 'MyTypes::ApplicationInfo',
               'DpJobScheduleListIterNext/Maximum' => 'MyElements::DpJobScheduleListIterNext::_Maximum',
               'HostUsergroupModify/NewUsergroupName' => 'MyTypes::UsergroupName',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/DatasetMetadata/DfmMetadataField/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/PerfFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentDiscoverResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolModify/ResourcepoolNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo' => 'MyTypes::HostUsergroupInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetBeginFailoverResult/JobId' => 'MyElements::DatasetBeginFailoverResult::_JobId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes' => 'MyTypes::ArrayOfDatasetNodeInfo',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupGetData/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCopy/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'DpDashboardGetDrDatasetCountsResult/DrStateStatusCounts' => 'MyTypes::ArrayOfDrStateStatusCount',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterNextResult/Luns/LunInfo/ObjectStatus' => 'MyTypes::ObjStatus',
               'ApplicationPolicyCopyResult' => 'MyElements::ApplicationPolicyCopyResult',
               'PerfThresholdModify2/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmScheduleWeeklyDelete/ItemId' => 'MyElements::DfmScheduleWeeklyDelete::_ItemId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'GroupListIterNextResult/GroupList/GroupInfo/Id' => 'MyTypes::GroupInfo::_Id',
               'ViVirtualMachineListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupContentListIterStart/SuppressChildCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupStart/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerIpspace' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCleanupResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'ReportOutputDelete/ReportOutputId' => 'MyElements::ReportOutputDelete::_ReportOutputId',
               'GroupListIterNextResult/GroupList/GroupInfo/SubgroupCount' => 'MyTypes::GroupInfo::_SubgroupCount',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/IpAddressList/IpAddress' => 'MyTypes::IpAddress',
               'PerfCounterGroupStart' => 'MyElements::PerfCounterGroupStart',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/DatasetId' => 'MyTypes::ObjId',
               'DatasetConformBeginResult' => 'MyElements::DatasetConformBeginResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/LastDedupeEndTimestamp' => 'MyTypes::Timestamp',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DpDashboardGetProtectedDataCounts2Result/IgnoredOssvDirectoryCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_IgnoredOssvDirectoryCount',
               'DpAgentConfigure/VcenterUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree/UnprotectedDataSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'PerfViewObjectAssociationDelete/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Filer/FilerResource' => 'MyTypes::FilerResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'QtreeListInfoIterStart/IsDirectMemberOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvApplicationRestoreDestinationListInfoIterStartResult' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterStartResult',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationNodeId' => 'MyTypes::DpBackupTransferInfo::_DestinationNodeId',
               'DpScheduleCreate/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'AlarmCreate/AlarmInfo/TrapDestinations/TrapDestination/TrapCommunity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNext/Maximum' => 'MyElements::DpJobProgressEventListIterNext::_Maximum',
               'GroupGetOptions/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/DatasetContact' => 'MyTypes::EmailAddressList',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMeanTime' => 'MyTypes::ApiStat::_DbMeanTime',
               'ViVirtualCenterListInfoIterNextResult/Records' => 'MyElements::ViVirtualCenterListInfoIterNextResult::_Records',
               'HostModify' => 'MyElements::HostModify',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/FullName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/QtreePerfStatus' => 'MyTypes::ObjStatus',
               'PerfCopyCounterConfiguration/SrcIsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAccessCheck/Resource/ResourceIdentifier/ResourcePool' => 'MyTypes::WrapperOfResourcePoolResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressAggregateInfo' => 'MyTypes::ProgressAggregateInfo',
               'DpScheduleMonthlySubscheduleSet/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/IsMostSevereFirst' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerDestroyResult' => 'MyElements::VfilerDestroyResult',
               'DpThrottleCreate/ThrottleContent/ThrottleId' => 'MyTypes::ThrottleContent::_ThrottleId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'CommentFieldListInfoIterNextResult/CommentFields' => 'MyTypes::ArrayOfCommentFieldInfo',
               'ReportScheduleListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/Frequency' => 'MyTypes::TimesOfDayInfo::_Frequency',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/HostFqdn' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationRestoreDestinationListInfoIterNextResult/OssvApplicationRestoreDestinationList/OssvApplicationRestoreDestinationInfo/HostName' => 'MyTypes::ObjName',
               'ReportListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'DatasetDynamicReferenceListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'ProvisioningPolicyEditCommit/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo' => 'MyTypes::SnapshotMemberInfo',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores' => 'MyTypes::ArrayOfDatastore',
               'ViVirtualMachineListInfoIterNextResult/Records' => 'MyElements::ViVirtualMachineListInfoIterNextResult::_Records',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DpThrottleItemDelete' => 'MyElements::DpThrottleItemDelete',
               'HostListInfoIterNextResult/Hosts/HostInfo/ServiceStatuses/ServiceStatus/Service' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/SourceNodeId' => 'MyTypes::DpBackupTransferInfo::_SourceNodeId',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'DatasetCreate/DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUserName' => 'MyTypes::AccessObjectName',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventSourceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/Sid' => 'MyTypes::Sid',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceModifyResult/ConformanceAlerts' => 'MyTypes::ArrayOfConformanceAlert',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/SnapvaultMaxBackupThreads' => 'MyTypes::HostDpInfo::_SnapvaultMaxBackupThreads',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleModify/ReportScheduleInfo/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart' => 'MyElements::ResourcepoolMemberListInfoIterStart',
               'SnapshotListInfoIterNextResult/Snapshots' => 'MyTypes::ArrayOfSnapshotInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterStart/CustomOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetUpdateProtectionStatus/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/IsVfilerCreatedForMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'HostUserListIterStartResult' => 'MyElements::HostUserListIterStartResult',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/DedupeSpaceSavings' => 'MyTypes::VolumeDedupeInfo::_DedupeSpaceSavings',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'SrmFileTypeDelete' => 'MyElements::SrmFileTypeDelete',
               'EventListIterStart/TimeRange' => 'MyTypes::WrapperOfEventTimestampRange',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetChangeDrStateResult' => 'MyElements::DatasetChangeDrStateResult',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DfmScheduleContentGetResult/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'MigrateVolume/MigrationRequestInfo/DestinationAggregateNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'DpJobScheduleListIterStart/FromTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/ProvisioningChecksPassed' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/DatasetName' => 'MyTypes::ObjName',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/MemberNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo' => 'MyTypes::ThresholdInfo',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicyName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ProvisioningPolicyName' => 'MyTypes::ObjName',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotHostServiceId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterStart/VfilerIpspace' => 'MyTypes::VfilerIpspace',
               'DpBackupGetLocation/Paths' => 'MyTypes::ArrayOfDpBackupPathInfo',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertType' => 'MyTypes::ConformanceAlertType',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventclassListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/AfsUsed' => 'MyTypes::VolumeSize::_AfsUsed',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationBackupId' => 'MyTypes::DpBackupTransferInfo::_DestinationBackupId',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'DpScheduleListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'EventclassAddCustom/EventNamespaceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolMembers/ResourcePoolMember' => 'MyTypes::ResourcePoolMember',
               'DpPolicyGetDefaultPropertyValuesResult/BackupScheduleId' => 'MyTypes::ObjId',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert' => 'MyTypes::ConformanceAlert',
               'PerfThresholdListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/ThresholdId' => 'MyTypes::ThresholdId',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'CommentSetObjectValue' => 'MyElements::CommentSetObjectValue',
               'DfmSnmpSettingModify/SnmpVersion' => 'MyTypes::SnmpVersion',
               'ResourcepoolMemberListInfoIterNext/Maximum' => 'MyElements::ResourcepoolMemberListInfoIterNext::_Maximum',
               'DpRelationshipListInfoIterNext/Maximum' => 'MyElements::DpRelationshipListInfoIterNext::_Maximum',
               'GroupRename/NewGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyEditCommit/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleMonthlyAdd/MonthlyContent' => 'MyTypes::WrapperOfMonthlyInfo',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DpBackupStart/VmwareBackupSettingsInfo/VmwareBackupScheduleSettingsInfo' => 'MyTypes::VmwareBackupScheduleSettingsInfo',
               'PerfCollectClientOperationStatisticsResult/Errors/ClientStatError' => 'MyTypes::ClientStatError',
               'ReportDesignerScheduleModify/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'DpRestoreToNewPath/BackupId' => 'MyElements::DpRestoreToNewPath::_BackupId',
               'DpScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine' => 'MyTypes::PerfLine',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/SourceBackupId' => 'MyTypes::DpBackupTransferInfo::_SourceBackupId',
               'DpScheduleModify/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'DatasetListInfoIterStart/HasProtectionPolicy' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LunListInfoIterNext/Maximum' => 'MyElements::LunListInfoIterNext::_Maximum',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo' => 'MyTypes::DpProgressFailoverInfo',
               'PerfClientStatsListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds' => 'MyTypes::DatasetMemberUsedSpaceThresholds',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/DataUnavailableReason/PerfStatusError' => 'MyTypes::PerfStatusError',
               'DatasetCreate/ApplicationInfo/CarryPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'AlarmGetDefaultsResult/AlarmDefaults/TrapPort' => 'MyTypes::AlarmDefaults::_TrapPort',
               'RbacOperationInfoListResult/OperationList/RbacOperation' => 'MyTypes::RbacOperation',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/VolumeId' => 'MyTypes::ObjId',
               'RbacAdminListInfoIterStart' => 'MyElements::RbacAdminListInfoIterStart',
               'AlarmModify' => 'MyElements::AlarmModify',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ToNodeId' => 'MyTypes::DpPolicyConnectionInfo::_ToNodeId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo/DestinationVolumeOrQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold',
               'ApplicationPolicyCopy/ApplicationPolicyName' => 'MyTypes::ObjName',
               'DpAgentModify/DpAgentNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageAdd/PackageZipPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources' => 'MyTypes::ArrayOfPerfDataSource',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportOutputListInfoIterNextResult/ReportOutputList' => 'MyTypes::ArrayOfReportOutputInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/Resourcepools/DatasetResourcepoolInfo/ResourcepoolId' => 'MyTypes::ObjId',
               'StorageServiceDatasetProvision/StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfAssocViewListIterStart/AssocObjType' => 'MyTypes::PerfAssocObjType',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/AfsAvail' => 'MyTypes::VolumeSize::_AfsAvail',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'VolumeDedupe/DedupeRequestInfo/FullVolumeDedupe' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRestoreViStart/DpViRestoreObjects/DpViRestoreObject/DpViObjectRestoreSettings/DpViVmwareObjectRestoreSettings/DestinationDatastoreNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfObjectCounterListInfo' => 'MyElements::PerfObjectCounterListInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/SourceFilerId' => 'MyTypes::ObjId',
               'RbacAdminListInfoIterEndResult' => 'MyElements::RbacAdminListInfoIterEndResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Vfiler/VfilerResource' => 'MyTypes::VfilerResource',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/ProvisioningPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/CifsAclList' => 'MyTypes::ArrayOfCifsAcl',
               'ReportListInfoIterStartResult' => 'MyElements::ReportListInfoIterStartResult',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'DpThrottleDependencyResult/ThrottleInUse' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'VolumeResizeResult' => 'MyElements::VolumeResizeResult',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleRemove/DeleteAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterData/TimeFilter/TimeRanges' => 'MyTypes::ArrayOfTimeRange',
               'PerfThresholdListInfoIterStartResult' => 'MyElements::PerfThresholdListInfoIterStartResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd/ReportScheduleInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'DpDashboardGetProtectedDataCountsResult/IgnoredOssvDirectoryCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_IgnoredOssvDirectoryCount',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/HostId' => 'MyTypes::ObjId',
               'Fault/faultstring' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/NodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo' => 'MyTypes::ApplicationPolicySettingsInfo',
               'DfmScheduleListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList' => 'MyTypes::ArrayOfOssvApplicationInfo',
               'ResourcepoolListInfoIterStart/StorageReliability' => 'MyTypes::StorageReliability',
               'ReportScheduleAdd/ReportScheduleInfo' => 'MyTypes::ReportScheduleInfo',
               'CifsDomainListInfoIterNext' => 'MyElements::CifsDomainListInfoIterNext',
               'DfmScheduleRenameResult' => 'MyElements::DfmScheduleRenameResult',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/Direction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApiProxy' => 'MyElements::ApiProxy',
               'DpJobProgressEventListIterStart/DatasetNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobPurge/CompletedTimestamp' => 'MyTypes::DpTimestamp',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'GroupListIterStart' => 'MyElements::GroupListIterStart',
               'DpBackupListIterStart/SearchKeys/SearchKey' => 'MyTypes::SearchKey',
               'DatasetExclusionListInfoIterNextResult/ExclusionList/ExcludedObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'DfmScheduleWeeklySubscheduleDelete' => 'MyElements::DfmScheduleWeeklySubscheduleDelete',
               'PerfStatusGetResult/IsDataAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesAvailable' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList' => 'MyTypes::ArrayOfReportScheduleContentInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserRecentReportListInfoIterEnd' => 'MyElements::UserRecentReportListInfoIterEnd',
               'ClientRegistryGet/Option' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmNetworkAddResult' => 'MyElements::DfmNetworkAddResult',
               'HostListInfoIterStart' => 'MyElements::HostListInfoIterStart',
               'PerfViewCreate/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'AlarmListInfoIterNextResult' => 'MyElements::AlarmListInfoIterNextResult',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/CustomProvisioningScriptSettings' => 'MyTypes::CustomProvisioningScriptSettings',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/VirtualCenterReference/VirtualCenterName' => 'MyTypes::ObjName',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TrapDestinations/TrapDestination/TrapPort' => 'MyTypes::TrapDestination::_TrapPort',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMetadata/DfmMetadataField/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/SnapvaultSecondaryScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/JobType' => 'MyTypes::DpJobType',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/IsMirrorDestinationNode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmBackupScheduleGetResult/Day' => 'MyElements::DfmBackupScheduleGetResult::_Day',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo' => 'MyTypes::DailyInfo',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesAvailable' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesAvailable',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo/QtreeName' => 'MyTypes::ObjFullName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'LunResizeResult' => 'MyElements::LunResizeResult',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'AlarmGetDefaultsResult/AlarmDefaults/RepeatInterval' => 'MyTypes::AlarmDefaults::_RepeatInterval',
               'ReportDesignerScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'HostUsergroupPush/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/RestoreConfiguration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportOutputDelete' => 'MyElements::ReportOutputDelete',
               'HostUserAdd/HostUser/HostUserInfo/HostId' => 'MyTypes::ObjId',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/MemberCommittedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'CommentFieldCreateResult' => 'MyElements::CommentFieldCreateResult',
               'GroupIsMemberOfResult' => 'MyElements::GroupIsMemberOfResult',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/AggregateId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId' => 'MyTypes::LunNameOrId',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/AdvancedOptions' => 'MyTypes::ArrayOfAdvancedOptionInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'ResourcepoolListInfoIterStart/IncludeFreeSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfViewCreate/View' => 'MyTypes::WrapperOfPerfView',
               'PerfThresholdListInfo2IterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeId' => 'MyTypes::QtreeInfo::_QtreeId',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/DestinationVfilerName' => 'MyTypes::ObjFullName',
               'DfmScheduleWeeklyDeleteResult' => 'MyElements::DfmScheduleWeeklyDeleteResult',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneListInfoIterNextResult/Timezones' => 'MyTypes::ArrayOfTimezoneInfo',
               'DpOssvApplicationRestoreDestinationListInfoIterStartResult/Records' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterStartResult::_Records',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/CifsOpStats/OtherOperations' => 'MyTypes::CifsOpStats::_OtherOperations',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/IsOvercharge' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo/CommentFieldObjectTypes/CommentFieldObjectType' => 'MyTypes::CommentFieldObjectType',
               'EventListIterNext' => 'MyElements::EventListIterNext',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateDetachObjects/Objects' => 'MyTypes::ArrayOfObjectInfo',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ArchivalFormat' => 'MyTypes::ReportOutputFormat',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DpScheduleMonthlyAdd/MonthlyContent/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo' => 'MyTypes::ApplicationBackupOperationInfo',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterStart/HostDpFilterInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUsergroupModify/HostUsergroup' => 'MyTypes::WrapperOfHostUsergroupInfo',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment' => 'MyTypes::ProvisionMemberComment',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'GraphDataListInfo/GraphPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterStart/IncludeIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmModify/AlarmInfo/TrapDestinations' => 'MyTypes::ArrayOfTrapDestination',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/NewRetentionPeriod' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewCreate/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume' => 'MyTypes::WrapperOfVolumeResource',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmUserPrivGetResult' => 'MyElements::DfmUserPrivGetResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/RbacRole/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewModify/View/PerfView/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/FilesystemDevice' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobAbortResult' => 'MyElements::DpJobAbortResult',
               'ReportOutputListInfoIterEnd' => 'MyElements::ReportOutputListInfoIterEnd',
               'AlarmListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'AlarmCreate/AlarmInfo' => 'MyTypes::AlarmInfo',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/RelationshipStates' => 'MyTypes::ArrayOfRelationshipState',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
               'PerfThresholdModify2/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Filer/FilerResource' => 'MyTypes::FilerResource',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo/DatasetName' => 'MyTypes::ObjName',
               'ProvisioningPolicyListIterStart/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleModify/HostRole/HostRoleInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupCopyResult' => 'MyElements::GroupCopyResult',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterStart/HostUserNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListResult' => 'MyElements::EventclassListResult',
               'DpRestoreToPrimary/Paths/DpPathInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourceTag' => 'MyTypes::ResourceTag',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DpScheduleDailyModify/DailyContent/DailyInfo' => 'MyTypes::DailyInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify2/ThresholdInfo2/ThresholdEventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterStartResult' => 'MyElements::PerfCounterGroupListIterStartResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList' => 'MyTypes::ArrayOfThrottleItemInfo',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatastoreOnOntap' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo' => 'MyTypes::ThrottleItemInfo',
               'ReportOutputListInfoIterEndResult' => 'MyElements::ReportOutputListInfoIterEndResult',
               'DpBackupVersionModify/DpBackupTransferInfo/DestinationNodeId' => 'MyTypes::DpBackupTransferInfo::_DestinationNodeId',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate' => 'MyElements::StorageServiceCreate',
               'SrmFileTypeAddResult/SrmFileTypeId' => 'MyTypes::ObjId',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'DpJobProgressEventListIterStart/ConnectionId' => 'MyElements::DpJobProgressEventListIterStart::_ConnectionId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/DnsServers' => 'MyTypes::ArrayOfIpAddress',
               'VolumeDestroyResult' => 'MyElements::VolumeDestroyResult',
               'DpScheduleDailyAdd/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupSetOptions/GroupOptionInfo/SrmMaxLargeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxLargeFiles',
               'DatasetEditRollback' => 'MyElements::DatasetEditRollback',
               'DatasetMissingMemberListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostCapabilityListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventAcknowledgedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmRelatedObjectsListInfoResult/ParentObjectList/ParentObject' => 'MyTypes::ParentObject',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/AggregateName' => 'MyTypes::ObjName',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/PerfFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Host' => 'MyTypes::WrapperOfHostResource',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/ProtectedVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_ProtectedVolumeCount',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/SanContainerSettings/GuaranteeWrites' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyGetDefaultPropertyValuesResult/ThrottleScheduleName' => 'MyTypes::ObjName',
               'ReportListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/LagErrorThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagErrorThreshold',
               'DpRelationshipListInfoIterNextResult/DpRelationships' => 'MyTypes::ArrayOfDpRelationshipInfo',
               'ViVirtualDiskListInfoIterNextResult' => 'MyElements::ViVirtualDiskListInfoIterNextResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserAddResult/HostDomainuserId' => 'MyTypes::AccessObjectId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek/DayOfWeek' => 'MyTypes::DayOfWeek',
               'HostRoleModify' => 'MyElements::HostRoleModify',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetExclusionListInfoIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/SupportsNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/BackupVersion' => 'MyTypes::DpTimestamp',
               'DpThrottleDestroy' => 'MyElements::DpThrottleDestroy',
               'ReportScheduleModify/ReportScheduleInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'UserRecentReportListInfoIterNextResult/RecentViewed' => 'MyTypes::ArrayOfUserReportInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrProtectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterStart/IncludeMetadataHostService' => 'MyTypes::ObjNameOrId',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek' => 'MyTypes::ArrayOfDayOfWeek',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent' => 'MyTypes::ThrottleContent',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunListInfoIterNext' => 'MyElements::LunListInfoIterNext',
               'ViDatastoreListInfoIterStart' => 'MyElements::ViDatastoreListInfoIterStart',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateId' => 'MyTypes::AggregateInfo::_AggregateId',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsDpManaged' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModify/ApplicationInfo/ApplicationVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateDetachObjects/Objects/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'DfmScheduleDependencyResult/ScheduleInUse' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo' => 'MyTypes::AggregateSpaceInfo',
               'MigrateChangeStateResult' => 'MyElements::MigrateChangeStateResult',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo' => 'MyTypes::HourlyInfo',
               'ReportScheduleListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterEndResult' => 'MyElements::ResourcepoolListInfoIterEndResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupConfigInfo/IgroupName' => 'MyTypes::ObjFullName',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimarySnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DestroyMemberRequestInfo' => 'MyTypes::DestroyMemberRequestInfo',
               'HostDomainuserRemoveResult' => 'MyElements::HostDomainuserRemoveResult',
               'DatasetListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DatasetModify/ApplicationInfo/IsApplicationResponsibleForPrimaryBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Policy/PolicyResource/PolicyName' => 'MyTypes::ObjName',
               'DatasetDynamicReferenceListInfoIterNext' => 'MyElements::DatasetDynamicReferenceListInfoIterNext',
               'EventListIterStart/IncludeRelated' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo' => 'MyTypes::ThresholdInfo',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationRestoreDestinationListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'DpBackupVersionModify/BackupId' => 'MyElements::DpBackupVersionModify::_BackupId',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'DpOssvDirectoryDiscoveredIterNextResult/Records' => 'MyElements::DpOssvDirectoryDiscoveredIterNextResult::_Records',
               'HostDomainuserListIterNext' => 'MyElements::HostDomainuserListIterNext',
               'AggregateListInfoIterEnd' => 'MyElements::AggregateListInfoIterEnd',
               'ResourcepoolUpdateFreeSpaceStatus' => 'MyElements::ResourcepoolUpdateFreeSpaceStatus',
               'PerfThresholdTemplateModify' => 'MyElements::PerfThresholdTemplateModify',
               'DatasetAddToExclusionList/EditLockId' => 'MyElements::DatasetAddToExclusionList::_EditLockId',
               'ViDatacenterListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionCount',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleEnable' => 'MyElements::DfmBackupScheduleEnable',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'PerfViewCreate/View/PerfView/Charts/PerfChart' => 'MyTypes::PerfChart',
               'ReportDesignerShare/OutputFormat' => 'MyTypes::ReportOutputFormat',
               'DfmScheduleListInfoIterNextResult' => 'MyElements::DfmScheduleListInfoIterNextResult',
               'ViVirtualCenterListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupContentListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/Frequency' => 'MyTypes::TimesOfDayInfo::_Frequency',
               'SnapshotListInfoIterNext' => 'MyElements::SnapshotListInfoIterNext',
               'PerfAssocViewListIterNext' => 'MyElements::PerfAssocViewListIterNext',
               'DpThrottleModify/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartMinute' => 'MyTypes::ThrottleItemInfo::_StartMinute',
               'ReportOutputListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewAssociatedObjectsList/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageDelete' => 'MyElements::DpAgentPackageDelete',
               'HostCapabilityListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Policy/PolicyResource' => 'MyTypes::PolicyResource',
               'PerfThresholdTemplateDelete/TemplateNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDelete/HostNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeInfo/VolumeId' => 'MyTypes::ObjId',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/StorageSystemId' => 'MyTypes::ObjId',
               'DatasetAddMemberByDynamicReference/DatasetDynamicReferenceParameters' => 'MyTypes::ArrayOfDatasetDynamicReferenceParameter',
               'PerfAssocViewListIterStart/Verbose' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceModifyResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetDataResult/DynamicData/DynamicData/InstanceName/PerfInstance' => 'MyTypes::PerfInstance',
               'RbacAdminListInfoIterStartResult' => 'MyElements::RbacAdminListInfoIterStartResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos' => 'MyTypes::ArrayOfDpBackupTransferInfo',
               'DpScheduleHourlyAdd/HourlyContent/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ViVirtualCenterListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'ViDatastoreListInfoIterEndResult' => 'MyElements::ViDatastoreListInfoIterEndResult',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'VolumeListInfoIterNextResult' => 'MyElements::VolumeListInfoIterNextResult',
               'GraphListInfoIterNext/Maximum' => 'MyElements::GraphListInfoIterNext::_Maximum',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings' => 'MyTypes::NasContainerSettings',
               'DfmAboutResult/OperatingSystem' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAddLicense' => 'MyElements::HostAddLicense',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/SpaceOnDemand' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DfmScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'AlarmGetDefaultsResult' => 'MyElements::AlarmGetDefaultsResult',
               'DatasetCreate/SecondaryQtreeNameFormat' => 'MyTypes::SecondaryQtreeNameFormat',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Group/GroupResource' => 'MyTypes::GroupResource',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ProvisioningPolicyDestroy/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/NetworkAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetDefaultViewResult/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmObjectRefresh/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceName' => 'MyTypes::ObjName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/CifsUsername' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/BytesOut' => 'MyTypes::NetifIpInterfaceInfo::_BytesOut',
               'PerfDiagTroubleshootResult' => 'MyElements::PerfDiagTroubleshootResult',
               'PerfViewListIterNext' => 'MyElements::PerfViewListIterNext',
               'PerfViewListIterNextResult/Views/PerfView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPathResult/OverwriteResults/OverwriteResult/OverwriteStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostName' => 'MyTypes::ObjName',
               'PerfCounterGroupGetData/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AlarmDestroy/AlarmId' => 'MyElements::AlarmDestroy::_AlarmId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/Snapshots/Snapshot/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/StartMinute' => 'MyTypes::ThrottleItemInfo::_StartMinute',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetConformBegin/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobContextObjType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfDisableDataCollection' => 'MyElements::PerfDisableDataCollection',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/IsAddingMembers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfo2IterNext/Maximum' => 'MyElements::PerfThresholdListInfo2IterNext::_Maximum',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DatasetAddMemberByDynamicReferenceResult' => 'MyElements::DatasetAddMemberByDynamicReferenceResult',
               'DatasetCreate/DatasetMetadata/DfmMetadataField' => 'MyTypes::DfmMetadataField',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageServiceInfo/StorageServiceName' => 'MyTypes::ObjFullName',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/DatasetMemberUsedSpaceThresholds/NearlyFullThreshold' => 'MyTypes::DatasetMemberUsedSpaceThresholds::_NearlyFullThreshold',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ThresholdId' => 'MyTypes::ThresholdId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Group/GroupResource/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetServerStatusResult/PerfServerStatus/ServerStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupGetLocationResult/BackupLocations' => 'MyTypes::ArrayOfBackupLocationInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectInstanceListIterStartResult' => 'MyElements::PerfObjectInstanceListIterStartResult',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/StoragesetId' => 'MyTypes::ObjId',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine' => 'MyTypes::VirtualMachine',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'DpRelationshipListInfoIterStart/IsMigrationRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationPolicyName' => 'MyTypes::ObjName',
               'DpBackupStart/RetentionDuration' => 'MyElements::DpBackupStart::_RetentionDuration',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryId' => 'MyTypes::ObjId',
               'DatasetModify/DatasetContact' => 'MyTypes::EmailAddressList',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/QuotaHardLimit' => 'MyTypes::MissingMemberInfo::_QuotaHardLimit',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource/MtuSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'DfmScheduleMonthlyAdd/MonthlyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterStart/StartedTimestampFrom' => 'MyTypes::DpTimestamp',
               'HostListInfoIterNextResult/Hosts/HostInfo/PerfAdvisorTransport' => 'MyTypes::PerfAdvisorTransport',
               'ViVirtualMachineListInfoIterNextResult' => 'MyElements::ViVirtualMachineListInfoIterNextResult',
               'DfmScheduleListInfoIterStart/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpRestoreToPrimaryResult/OverwriteResults/OverwriteResult/DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/InstalledPlugins/Plugin/PluginType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult' => 'MyElements::DpGetDatasetBackupJobsDataResult',
               'EventListIterNextResult/Events/EventInfo/EventOriginatingId' => 'MyTypes::EventInfo::_EventOriginatingId',
               'DpAgentListUpgradeCandidatesResult' => 'MyElements::DpAgentListUpgradeCandidatesResult',
               'ApplicationPolicyEditCommit/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/VirtualCenterReference/VirtualCenterName' => 'MyTypes::ObjName',
               'ProvisioningPolicyDestroyResult' => 'MyElements::ProvisioningPolicyDestroyResult',
               'DpJobScheduleListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterStartResult/Records' => 'MyElements::DpJobScheduleListIterStartResult::_Records',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/ArchivalFormat' => 'MyTypes::ReportOutputFormat',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/Id' => 'MyTypes::DpPolicyConnectionInfo::_Id',
               'PerfObjectInstanceListIterEnd' => 'MyElements::PerfObjectInstanceListIterEnd',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources' => 'MyTypes::ArrayOfVfilerNetworkResource',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource' => 'MyTypes::WrapperOfPerfDataSource',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier' => 'MyTypes::ResourceIdentifier',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo/MemberId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate' => 'MyTypes::WrapperOfAggregateResource',
               'RbacRoleAdminInfoListResult/AdminNameOrId/RbacAdminNameOrId/AdminName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleItemAdd/ThrottleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmNetworkModify/NetworkId' => 'MyTypes::NetworkId',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'CommentFieldValuesListInfoIterNextResult/CommentFieldValues/CommentFieldValue/CommentFieldName' => 'MyTypes::CommentFieldName',
               'DpPolicyEditRollbackResult' => 'MyElements::DpPolicyEditRollbackResult',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/OutputFormatList' => 'MyTypes::ArrayOfReportOutputFormat',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'PerfThresholdModify/Attributes/ThresholdInfo/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CifsDomainListInfoIterNextResult/CifsDomainList/CifsDomainInfo/CifsDomainId' => 'MyTypes::CifsDomainInfo::_CifsDomainId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ReportGraphListInfoIterNext' => 'MyElements::ReportGraphListInfoIterNext',
               'DfmScheduleMonthlyDelete' => 'MyElements::DfmScheduleMonthlyDelete',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines/GraphLineInfo/SampleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ApplicationInfo/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/MonthlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_MonthlyRetentionCount',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo' => 'MyTypes::ProgressQuotaInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo' => 'MyTypes::SpaceManagementResultInfo',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/HostServiceId' => 'MyTypes::ObjId',
               'DfmScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStart/VolumeAggregateMap/VolumeAggregatePair' => 'MyTypes::VolumeAggregatePair',
               'PerfThresholdListInfo2IterNextResult/AttributesList' => 'MyTypes::ArrayOfThresholdInfo2',
               'RbacOperationAdd/Operation/RbacOperation/OperationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportDelete/UserName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeInfo/VolumeName' => 'MyTypes::ObjFullName',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds' => 'MyTypes::ArrayOfThresholdInfo2',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/DynamicReferenceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/DestinationVolumeOrQtreeId' => 'MyTypes::DpProgressRelationshipInfo::_DestinationVolumeOrQtreeId',
               'DatasetListInfoIterStart' => 'MyElements::DatasetListInfoIterStart',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'DpBackupVersionModify/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlySubscheduleSetResult' => 'MyElements::DfmScheduleMonthlySubscheduleSetResult',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/FileCount' => 'MyTypes::DirectoryInfo::_FileCount',
               'DatasetMemberDedupeAbort/VolumeNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryId' => 'MyTypes::ObjId',
               'DpOssvDirectoryBrowseIterStartResult/Records' => 'MyElements::DpOssvDirectoryBrowseIterStartResult::_Records',
               'DpPolicyGetDefaultPropertyValuesResult/WeeklyRetentionDuration' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate' => 'MyTypes::WrapperOfAggregateResource',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DatasetId' => 'MyTypes::ObjId',
               'DpScheduleModify/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/IsForPropagation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/AvgSpaceMeasurement/SpaceMeasurement/UsedSnapshotSpace' => 'MyTypes::SpaceMeasurement::_UsedSnapshotSpace',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpScheduleDailyDelete' => 'MyElements::DpScheduleDailyDelete',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/ServerNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines/GraphLineInfo/SamplePrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/PagerAdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/StorageReliability/DiskFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/NumberRecords' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyModifyResult' => 'MyElements::ApplicationPolicyModifyResult',
               'DatasetExclusionListInfoIterNextResult/Records' => 'MyElements::DatasetExclusionListInfoIterNextResult::_Records',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SrmFileTypeListInfoResult/SrmFileTypes/SrmFileTypeInfo/SrmFileTypeId' => 'MyTypes::ObjId',
               'DfmAboutResult/InstalledPlugins/Plugin/SpecialBuild' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicyType' => 'MyTypes::ApplicationPolicyType',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo/CifsShareInfo/CifsSharePermissions' => 'MyTypes::ArrayOfCifsSharePermission',
               'EventListIterNextResult/Events/EventInfo/EventId' => 'MyTypes::EventInfo::_EventId',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/VfilerTemplateName' => 'MyTypes::ObjName',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterStartResult' => 'MyElements::FcpTargetListInfoIterStartResult',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/ResourceType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetLaggedRelationshipsResult/DpRelationships/DpRelationshipLagInfo/RelationshipType' => 'MyTypes::RelationshipType',
               'AlarmTestResult' => 'MyElements::AlarmTestResult',
               'DpBackupVersionListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolId' => 'MyTypes::ObjId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'HostAddOssvResult/OssvId' => 'MyTypes::HostId',
               'EventDeleteResult/EventsDeletedList' => 'MyTypes::ArrayOfEventActionInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/SourceFilerId' => 'MyTypes::ObjId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'MigrateStart/PerformCutover' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'DpJobProgressEventListIterStart/JobId' => 'MyElements::DpJobProgressEventListIterStart::_JobId',
               'DpScheduleDestroy' => 'MyElements::DpScheduleDestroy',
               'EventclassListResult/EventClasses/EventClassInfo' => 'MyTypes::EventClassInfo',
               'VolumeDestroyResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyListIterNextResult' => 'MyElements::DpPolicyListIterNextResult',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/LagWarningThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterData/TimeFilter/Months/Month' => 'MyTypes::Month',
               'ApplicationPolicyListIterNext' => 'MyElements::ApplicationPolicyListIterNext',
               'GroupMemberListIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VirtualMachineId' => 'MyTypes::ObjId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressBackupInfo/Retention' => 'MyTypes::DpBackupRetentionType',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/SanContainerSettings/GuaranteeWrites' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterStart/IsSnapvaultPrimaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceModify/StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'PerfThresholdTemplateAttachObjects/NewObjects/ObjectInfo' => 'MyTypes::ObjectInfo',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DfmScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/RootPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/Version' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ThresholdType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleAdd/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/DatasetName' => 'MyTypes::ObjName',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SpaceManagementOpType' => 'MyTypes::SpaceManagementOpType',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'DfmSnmpSettingModify/PrefixLength' => 'MyTypes::PrefixLength',
               'DatasetRemoveMemberResult' => 'MyElements::DatasetRemoveMemberResult',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/HoleReserve' => 'MyTypes::VolumeSize::_HoleReserve',
               'StorageServiceCreate/StorageServiceName' => 'MyTypes::ObjName',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'HostUsergroupListIterNext/Maximum' => 'MyElements::HostUsergroupListIterNext::_Maximum',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualCenterReference' => 'MyTypes::VirtualCenterReference',
               'CommentFieldListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/OperationalStatuses/OperationalStatus' => 'MyTypes::OperationalStatus',
               'DatasetEditBegin/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LdapServerListInfo/LdapServer/LdapServerPort' => 'MyTypes::LdapServer::_LdapServerPort',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerStorageInfo/VolumeId' => 'MyTypes::ObjId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterEnd' => 'MyElements::HostRoleListIterEnd',
               'GroupMove/NewGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostName' => 'MyTypes::ObjName',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetRemoveFromExclusionList/ObjectsToBeRemoved/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/SecondaryQtreeNameFormat' => 'MyTypes::SecondaryQtreeNameFormat',
               'QtreeStartMonitoringResult' => 'MyElements::QtreeStartMonitoringResult',
               'GroupDestroy' => 'MyElements::GroupDestroy',
               'ResourcepoolListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/VolumeId' => 'MyTypes::ObjId',
               'DpBackupVersionListIterNextResult' => 'MyElements::DpBackupVersionListIterNextResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo/QtreeId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/DestinationFilerName' => 'MyTypes::ObjFullName',
               'DfmSnmpSettingModify/SnmpCommunityName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterNext' => 'MyElements::DpJobScheduleListIterNext',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DiscoveredTimestamp' => 'MyTypes::DpTimestamp',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/Resourcepools' => 'MyTypes::ArrayOfDatasetResourcepoolInfo',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/GroupId' => 'MyTypes::AlarmInfo::_GroupId',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'DfmAboutResult/InstallDir' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines/GraphLineInfo/SampleFormat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostCapabilityListIterNextResult/Capabilities/Capability' => 'MyTypes::Capability',
               'DpScheduleWeeklyAddResult' => 'MyElements::DpScheduleWeeklyAddResult',
               'EventListIterStart/IncludeDatasetResourceStatusEvents' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateFix' => 'MyElements::MigrateFix',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/BackupScheduleName' => 'MyTypes::ObjName',
               'DpBackupVersionDelete/BackupId' => 'MyElements::DpBackupVersionDelete::_BackupId',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'ViDatastoreListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsAllowCustomSettings' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'EventclassAddCustom/EventNames/EventNameInfo/Severity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/BytesIn' => 'MyTypes::NetifIpInterfaceInfo::_BytesIn',
               'TimezoneValidate' => 'MyElements::TimezoneValidate',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/DailyRetentionCount' => 'MyTypes::DpPolicyNodeInfo::_DailyRetentionCount',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/ConnectionType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions/SpaceCondition' => 'MyTypes::SpaceCondition',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/AdministrativeHostIpAddress' => 'MyTypes::IpAddress',
               'DatasetSet/MaximumLunsPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMemberListInfoIterNextResult' => 'MyElements::DatasetMemberListInfoIterNextResult',
               'PerfEnableObjectUpdateResult' => 'MyElements::PerfEnableObjectUpdateResult',
               'DfmBackupScheduleGetResult/Hour' => 'MyElements::DfmBackupScheduleGetResult::_Hour',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/BackupMetadata/DfmMetadata/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo' => 'MyTypes::VfilerInfo',
               'ViDatacenterListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportId' => 'MyTypes::ReportOutputInfo::_ReportId',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/IsInBackupRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/HostId' => 'MyTypes::DpOssvDirectoryInfo::_HostId',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/SnmpVersion' => 'MyTypes::SnmpVersion',
               'HostListInfoIterStart/HostTypes/HostType' => 'MyTypes::HostType',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/LunIgroupsInfo/LunIgroupInfo' => 'MyTypes::LunIgroupInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo' => 'MyTypes::SimpleScheduleInfo',
               'ViVirtualMachineListInfoIterStart/VirtualInfrastructureType' => 'MyTypes::VirtualInfrastructureType',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/PerfFileName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold',
               'HostListInfoIterNextResult/Hosts/HostInfo/CifsDomainInfo/CifsDnsDomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/HostServiceId' => 'MyTypes::ObjId',
               'MigrateRollback' => 'MyElements::MigrateRollback',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DfmScheduleListResult' => 'MyElements::DfmScheduleListResult',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'HostUserAdd/HostUser/HostUserInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventArguments' => 'MyTypes::ArrayOfKeyValuePair',
               'LunDestroyResult' => 'MyElements::LunDestroyResult',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationAdd/Operation' => 'MyTypes::WrapperOfRbacOperation',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNext' => 'MyElements::VfilerTemplateListInfoIterNext',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventDeletedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingAdd/SnmpAuthenticationProtocol' => 'MyTypes::SnmpAuthenticationProtocol',
               'DatasetDynamicReferenceListInfoIterStart/SuppressStatusRefresh' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterEndResult' => 'MyElements::DpAgentListInfoIterEndResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolGetDefaultsResult/ResourcepoolDefaults' => 'MyTypes::ResourcepoolDefaults',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo/BytesTransferred' => 'MyTypes::DpProgressSnapvaultInfo::_BytesTransferred',
               'EventAcknowledgeResult/EventsAcknowledgedList/EventActionInfo' => 'MyTypes::EventActionInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerAllowedProtocols/Protocol' => 'MyTypes::Protocol',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/ScheduleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/JunctionPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledge/EventIdList' => 'MyTypes::ArrayOfEventIdType',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines' => 'MyTypes::ArrayOfPerfLine',
               'HostListInfoIterNextResult/Hosts/HostInfo/AdminPort' => 'MyTypes::IpPortNumber',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterEnd' => 'MyElements::DpBackupVersionListIterEnd',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'DfmBackupScheduleSet/BackupType' => 'MyTypes::BackupType',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/PerformanceStatus' => 'MyTypes::ObjStatus',
               'DpAgentStoragesystemListInfoIterStartResult' => 'MyElements::DpAgentStoragesystemListInfoIterStartResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'DfmNetworkModify' => 'MyElements::DfmNetworkModify',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/JobDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleSet' => 'MyElements::DfmBackupScheduleSet',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/MaximumDataSize' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DpPolicyEditCommit/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData' => 'MyTypes::DpJobData',
               'HostListInfoIterNextResult/Hosts/HostInfo/PartnerStorageSystemId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsDpSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetContact' => 'MyTypes::EmailAddressList',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/StoragesetName' => 'MyTypes::ObjName',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment' => 'MyTypes::ProvisionMemberComment',
               'DpDashboardGetProtectedDataCounts2Result/ProtectedOssvDirectoryCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_ProtectedOssvDirectoryCount',
               'DatasetComputeUsageMetric/ComputeIoUsageMetric' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/ItemId' => 'MyTypes::ThrottleItemInfo::_ItemId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/DestinationVfilerId' => 'MyTypes::ObjId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'DatasetSpaceMetricListInfoIterNextResult' => 'MyElements::DatasetSpaceMetricListInfoIterNextResult',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlySubscheduleSet' => 'MyElements::DpScheduleMonthlySubscheduleSet',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/FailoverScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetBeginFailoverScriptTest/DatasetNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DpAgentConfigure' => 'MyElements::DpAgentConfigure',
               'ApplicationPolicyCopy' => 'MyElements::ApplicationPolicyCopy',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'AggregateListInfoIterStartResult/Records' => 'MyElements::AggregateListInfoIterStartResult::_Records',
               'DatasetAddResourcepool/EditLockId' => 'MyElements::DatasetAddResourcepool::_EditLockId',
               'HostUserListIterNext/Maximum' => 'MyElements::HostUserListIterNext::_Maximum',
               'HostRoleCreate/HostRole/HostRoleInfo/HostName' => 'MyTypes::ObjName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateDetachObjects/TemplateNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentStoragesystemListInfoIterStart' => 'MyElements::DpAgentStoragesystemListInfoIterStart',
               'HostDomainuserListIterStart/Verbose' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmServerListDiagnosticInfo' => 'MyElements::DfmServerListDiagnosticInfo',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterStart/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmNetworkListInfoResult/Networks/NetworkInfo/LastSearchedTime' => 'MyTypes::Timestamp',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DatasetDynamicReferenceListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapvaultTransferJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'EventStatusChangeListIterStartResult' => 'MyElements::EventStatusChangeListIterStartResult',
               'DatasetIoMetricListInfoIterEnd' => 'MyElements::DatasetIoMetricListInfoIterEnd',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'DfmScheduleWeeklyModify' => 'MyElements::DfmScheduleWeeklyModify',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/PacketsOut' => 'MyTypes::NetifIpInterfaceInfo::_PacketsOut',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/OldPrimaryMemberId' => 'MyTypes::ObjId',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups/BackupInfo/DpNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/MemberId' => 'MyTypes::ObjId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource' => 'MyTypes::WrapperOfResourceIdentifier',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource/VfilerTemplateName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupStart/BackupDestination' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToPrimaryResult/SpaceStatusResults' => 'MyTypes::ArrayOfSpaceStatusResult',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyListIterStartResult' => 'MyElements::DpPolicyListIterStartResult',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission/Permission' => 'MyTypes::CifsPermission',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo/CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
               'GraphListInfoIterStart/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'CommentFieldModify/NewCommentFieldName' => 'MyTypes::CommentFieldName',
               'HostRoleListIterNext/Maximum' => 'MyElements::HostRoleListIterNext::_Maximum',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/IsProtected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems/StorageSystemInfo/StorageSystemId' => 'MyTypes::ObjId',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos/AggregateSpaceInfo' => 'MyTypes::AggregateSpaceInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneValidate/Timezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeQtree/ProtectedQtreeCount' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/Lag' => 'MyTypes::DpRelationshipInfo::_Lag',
               'DfmScheduleList/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Reports/PerfReport/ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/MemberName' => 'MyTypes::ObjName',
               'DatasetMemberDeleteSnapshots/DeleteSnapshotsRequestInfo/VolumeName' => 'MyTypes::ObjName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatastoreListInfoIterStartResult' => 'MyElements::ViDatastoreListInfoIterStartResult',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/AdministrativeHostIpAddress' => 'MyTypes::IpAddress',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'SnapshotGetReclaimableInfoResult' => 'MyElements::SnapshotGetReclaimableInfoResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ApplicationResourceProperties/PropertyInfo/PropertyValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/CifsShareNames/CifsShareName' => 'MyTypes::CifsShareName',
               'DpPolicyListIterNext' => 'MyElements::DpPolicyListIterNext',
               'DfmScheduleCreate/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'ViHypervisorListInfoIterStart/IncludeDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/DefaultUserQuota' => 'MyTypes::NasContainerSettings::_DefaultUserQuota',
               'ReportDesignerShare/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'DpPolicyListIterNextResult/DpPolicyInfos' => 'MyTypes::ArrayOfDpPolicyInfo',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'CommentFieldValuesListInfoIterStartResult' => 'MyElements::CommentFieldValuesListInfoIterStartResult',
               'DpBackupGetLocation/BackupVersion' => 'MyTypes::DpTimestamp',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapmirrorPrimaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserDelete' => 'MyElements::HostUserDelete',
               'ViDatastoreListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleCreate/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/Metrics/Metric' => 'MyTypes::Metric',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpPolicyModify/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfWeek' => 'MyTypes::ArrayOfDayOfWeek',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryRootsIterNextResult/Records' => 'MyElements::DpOssvDirectoryRootsIterNextResult::_Records',
               'ReportScheduleAddResult' => 'MyElements::ReportScheduleAddResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceDatasetProvisionResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostModifyAgentCredentials/OsPassword' => 'MyTypes::HostPassword',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/RepeatInterval' => 'MyTypes::AlarmInfo::_RepeatInterval',
               'DpOssvApplicationListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/SourceVfilerName' => 'MyTypes::ObjFullName',
               'HostListInfoIterStart/QueryHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterStartResult' => 'MyElements::PerfAssocViewListIterStartResult',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualCenterReference/VirtualCenterName' => 'MyTypes::ObjName',
               'DpScheduleRename/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAddResult' => 'MyElements::HostUserAddResult',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsSnapvaultEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewAssociatedObjectsList' => 'MyElements::PerfViewAssociatedObjectsList',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsVsmSecondaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerTemplateModify' => 'MyElements::VfilerTemplateModify',
               'EventGenerate/Timestamp' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpOssvDirectoryBrowseIterEnd' => 'MyElements::DpOssvDirectoryBrowseIterEnd',
               'SrmFileTypeListInfoResult/SrmFileTypes' => 'MyTypes::ArrayOfSrmFileTypeInfo',
               'DfmSnmpSettingAdd/SnmpAuthenticationLogin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'ReportListInfoIterStart/ReportNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleHourlyModify/HourlyContent/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMemberDedupeStart/DedupeMemberRequestInfo' => 'MyTypes::DedupeMemberRequestInfo',
               'VfilerSetup/IpBindings/IpBindingInfo/PrefixLength' => 'MyTypes::IpBindingInfo::_PrefixLength',
               'MigrateStartResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/ResourcepoolName' => 'MyTypes::ObjName',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostAdd/HostNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'PerfObjectDependentCounterListInfoResult' => 'MyElements::PerfObjectDependentCounterListInfoResult',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostType' => 'MyTypes::HostType',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsWindowsOfmPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserPush' => 'MyElements::HostDomainuserPush',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DfmScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo' => 'MyTypes::VolumeMigrationRequestInfo',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/ProvisioningPolicyName' => 'MyTypes::ObjFullName',
               'DfmScheduleWeeklyModify/WeeklyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheck/Resource' => 'MyTypes::WrapperOfResourceIdentifier',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'HostUserModify/HostUser/HostUserInfo/HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
               'DpAgentRegister' => 'MyElements::DpAgentRegister',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModify/AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentConfigure/StorageSystemsConfiguration' => 'MyTypes::ArrayOfStorageSystemConfiguration',
               'RbacAccessCheck/Resource/ResourceIdentifier/RbacRole/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Comments' => 'MyTypes::ArrayOfProvisionMemberComment',
               'MigrateChangeState/NewMigrationStatus' => 'MyTypes::MigrationStatus',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterEnd' => 'MyElements::EventListIterEnd',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/HostRoleId' => 'MyTypes::AccessObjectId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo' => 'MyTypes::DatasetNodeInfo',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/ProvisioningPolicyName' => 'MyTypes::ObjFullName',
               'HostListInfoIterNextResult/Hosts/HostInfo/PartnerStorageSystemName' => 'MyTypes::ObjFullName',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Desc' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/StartHour' => 'MyTypes::HourlyInfo::_StartHour',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetDataResult/Unit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/CifsSecurityStyle' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/SourceId' => 'MyTypes::ObjId',
               'PerfGetCounterDependentsResult/Thresholds/PerfThreshold' => 'MyTypes::PerfThreshold',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventCondition' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DpNodeId' => 'MyTypes::DatasetMapEntry::_DpNodeId',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/SnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'VfilerCreate/Name' => 'MyTypes::ObjName',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/SubType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNext/Maximum' => 'MyElements::VfilerTemplateListInfoIterNext::_Maximum',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/IsPartOfBackupVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo' => 'MyTypes::ProgressCifsShareInfo',
               'AggregateListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetAccessDetails/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'AlarmCreate' => 'MyElements::AlarmCreate',
               'LunListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'UserFavoriteReportListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNextResult' => 'MyElements::DpOssvApplicationListInfoIterNextResult',
               'AlarmTest/AlarmId' => 'MyElements::AlarmTest::_AlarmId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Host/HostResource' => 'MyTypes::HostResource',
               'QtreeListInfoIterNext' => 'MyElements::QtreeListInfoIterNext',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'StorageServiceListInfoIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/VolumeMigrationRequestInfo/CleanupStaleStorage' => 'MyTypes::CleanupStaleStorage',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ToNodeId' => 'MyTypes::DpPolicyConnectionInfo::_ToNodeId',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats' => 'MyTypes::ClientStats',
               'DpScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo' => 'MyTypes::SimpleScheduleInfo',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'DpDashboardGetLaggedDatasetsResult/DpDatasets/DpDatasetLagInfo/DatasetName' => 'MyTypes::ObjName',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/SpaceManagementOpType' => 'MyTypes::SpaceManagementOpType',
               'LunListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/TotalSpace' => 'MyTypes::SpaceInfo::_TotalSpace',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo' => 'MyTypes::ThrottleItemInfo',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/LagErrorThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagErrorThreshold',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/TotalSpace' => 'MyTypes::MissingMemberInfo::_TotalSpace',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/PrefixLength' => 'MyTypes::IfcInfo::_PrefixLength',
               'DatasetEditCommitResult/ConformanceAlerts' => 'MyTypes::ArrayOfConformanceAlert',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DpScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'DfmNetworkDeleteResult' => 'MyElements::DfmNetworkDeleteResult',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/MaxSpaceMeasurement/SpaceMeasurement/TotalSpace' => 'MyTypes::SpaceMeasurement::_TotalSpace',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/IsDpNodeEffectivePrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetRemoveFromExclusionList/EditLockId' => 'MyElements::DatasetRemoveFromExclusionList::_EditLockId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'EventListIterNextResult' => 'MyElements::EventListIterNextResult',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolName' => 'MyTypes::ObjFullName',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfViewCreate/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'DfmScheduleModifyResult' => 'MyElements::DfmScheduleModifyResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/AnonymousAccessUser' => 'MyTypes::DatasetNfsExportSetting::_AnonymousAccessUser',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterStart/SourceId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails/ProtectionStatusJobDetail/ProtectionStatusJobType' => 'MyTypes::DpJobType',
               'HostUserAdd/HostUser/HostUserInfo/HostUsergroupIds' => 'MyTypes::ArrayOfHostUsergroupId',
               'ResourcepoolListInfoIterStart/StorageReliability/DiskFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/StartHour' => 'MyTypes::ThrottleItemInfo::_StartHour',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo/MaximumCapacity' => 'MyTypes::ResizeMemberRequestInfo::_MaximumCapacity',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupListIterNext' => 'MyElements::PerfCounterGroupListIterNext',
               'MigrateStart/ResourceNameOrId' => 'MyTypes::ObjNameOrId',
               'DpBackupVersionCreate' => 'MyElements::DpBackupVersionCreate',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateSpaceStatus' => 'MyTypes::ObjectSpaceStatus',
               'PerfCounterGroupStop/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DpBackupVersionDelete/BackupVersion' => 'MyTypes::DpTimestamp',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AlarmListInfoIterStartResult' => 'MyElements::AlarmListInfoIterStartResult',
               'AlarmModify/AlarmInfo/TrapDestinations/TrapDestination' => 'MyTypes::TrapDestination',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleModify/ReportScheduleInfo/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapshotInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts' => 'MyTypes::ArrayOfPerfChart',
               'AlarmCreate/AlarmInfo/RepeatInterval' => 'MyTypes::AlarmInfo::_RepeatInterval',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpBackupListIterStart/BackupVersion' => 'MyTypes::DpTimestamp',
               'GraphListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateModify/TemplateDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Group/GroupResource' => 'MyTypes::GroupResource',
               'TimezoneGetDefaultsResult/TimezoneDefaults/ServerTimezoneDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/PhysicalAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ThresholdId' => 'MyTypes::ThresholdId',
               'DpDashboardGetDrDatasetCountsResult/DrStateStatusCounts/DrStateStatusCount/DrStatus' => 'MyTypes::DrStatus',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadwriteForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewCreate/View/PerfView/AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails' => 'MyTypes::PerfPurgedObjectCountersDetails',
               'DatasetIoMetricListInfoIterStartResult' => 'MyElements::DatasetIoMetricListInfoIterStartResult',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmAboutResult/LicensedFeatures' => 'MyTypes::ArrayOfFeature',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAdd' => 'MyElements::HostUserAdd',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'StorageServiceCreateResult/StorageServiceId' => 'MyTypes::ObjId',
               'DatasetReplacePrimaryMembers' => 'MyElements::DatasetReplacePrimaryMembers',
               'DpJobListIterNext/Maximum' => 'MyElements::DpJobListIterNext::_Maximum',
               'DatasetCreate/DatasetAccessDetails/Netmask' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/Resourcepools/DatasetResourcepoolInfo' => 'MyTypes::DatasetResourcepoolInfo',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateUpdateResult' => 'MyElements::MigrateUpdateResult',
               'DfmScheduleHourlyModify/HourlyContent' => 'MyTypes::WrapperOfHourlyInfo',
               'DfmObjectsGetStatus' => 'MyElements::DfmObjectsGetStatus',
               'DatasetIoMetricListInfoIterStart/Day' => 'MyElements::DatasetIoMetricListInfoIterStart::_Day',
               'DpJobAbort' => 'MyElements::DpJobAbort',
               'ViVirtualDiskListInfoIterStart/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportOutputListInfoIterStart/ReportOutputId' => 'MyElements::ReportOutputListInfoIterStart::_ReportOutputId',
               'DfmScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'DpDashboardGetProtectedDataCountsResult/ProtectedOssvDirectoryCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_ProtectedOssvDirectoryCount',
               'PerfEnableDataCollectionResult' => 'MyElements::PerfEnableDataCollectionResult',
               'CommentFieldValuesListInfoIterEndResult' => 'MyElements::CommentFieldValuesListInfoIterEndResult',
               'StorageServiceDatasetModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSeverity' => 'MyTypes::ObjStatus',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/ApplicationBackupProperties/PropertyInfo/PropertyValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/UndedupeMemberRequestInfo' => 'MyTypes::UndedupeMemberRequestInfo',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DiskListInfoIterEndResult' => 'MyElements::DiskListInfoIterEndResult',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostUsergroupName' => 'MyTypes::UsergroupName',
               'DpBackupGetLocation/Paths/DpBackupPathInfo/MemberName' => 'MyTypes::ObjName',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies' => 'MyTypes::ArrayOfApplicationPolicyInfo',
               'QtreeModify/QtreeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationDelete' => 'MyElements::RbacOperationDelete',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/PrimaryName' => 'MyTypes::ObjName',
               'DpRestoreToNewPathResult/SpaceStatusResults/SpaceStatusResult/DestHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToPrimaryResult/OverwriteResults/OverwriteResult' => 'MyTypes::OverwriteResult',
               'PerfStatusGetResult' => 'MyElements::PerfStatusGetResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Filer/FilerResource' => 'MyTypes::FilerResource',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetProvisionResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterStart/DrState' => 'MyTypes::DrState',
               'GroupSetOptions/GroupOptionInfo/SrmMaxNewMtimeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxNewMtimeFiles',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/OldDpNodeName' => 'MyTypes::DpPolicyNodeName',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolFreeVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DfmServerListDiagnosticInfoResult/DiagInfo/DfmDiagCounterGroup/GroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource' => 'MyTypes::ResourcePoolResource',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/SourceBackupId' => 'MyTypes::DpBackupTransferInfo::_SourceBackupId',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SnapshotDeletionRequestInfo/Snapshots/Snapshot/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetStatus/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines' => 'MyTypes::ArrayOfPerfLine',
               'PerfAssocViewListIterNextResult/Views/PerfView/ViewType' => 'MyTypes::ViewType',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'ProvisioningPolicyListIterStart' => 'MyElements::ProvisioningPolicyListIterStart',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfSetDefaultView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeStopMonitoring' => 'MyElements::QtreeStopMonitoring',
               'VolumeDedupe' => 'MyElements::VolumeDedupe',
               'HostUserPush/HostUserNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterEndResult' => 'MyElements::ViVirtualCenterListInfoIterEndResult',
               'DpPolicyModify/DpPolicyContent/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo' => 'MyTypes::DpProgressSnapvaultInfo',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo' => 'MyTypes::ThresholdTemplateInfo',
               'HostUserPushResult' => 'MyElements::HostUserPushResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/SnapshotScheduleId' => 'MyTypes::ObjId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'EventStatusChangeListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/InstanceCounterInfo' => 'MyTypes::InstanceCounterInfo',
               'HostUserDelete/HostUserNameOrId' => 'MyTypes::AccessObjectNameOrId',
               'LunListInfoIterStartResult' => 'MyElements::LunListInfoIterStartResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo' => 'MyTypes::ProgressVfilerInfo',
               'DiskListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCopy/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetModify/StorageServiceNodeList/StorageServiceNodeAttributes/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Labels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DatasetEditCommitResult' => 'MyElements::DatasetEditCommitResult',
               'EventclassListIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'EventclassListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/GraphLines/GraphLineInfo/SamplePrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup' => 'MyTypes::PerfDataGroup',
               'ProvisioningPolicyListIterStart/ProvisioningPolicyType' => 'MyTypes::ProvisioningPolicyType',
               'GraphListInfoIterNextResult/Graphs/GraphInfo' => 'MyTypes::GraphInfo',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo' => 'MyTypes::DpProgressRelationshipInfo',
               'DpScheduleWeeklyModify/WeeklyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModify/PrimaryVolumeNameFormat' => 'MyTypes::PrimaryVolumeNameFormat',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMinTime' => 'MyTypes::ApiStat::_DbMinTime',
               'StorageServiceDatasetProvision/ApplicationInfo/CarryPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'IfcListInfoIterStart' => 'MyElements::IfcListInfoIterStart',
               'DatasetIoMetricListInfoIterNextResult/Records' => 'MyElements::DatasetIoMetricListInfoIterNextResult::_Records',
               'DpJobScheduleListIterEnd' => 'MyElements::DpJobScheduleListIterEnd',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/RootObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAddResult/ReportScheduleId' => 'MyTypes::ObjId',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DpPolicyModify/DpPolicyContent' => 'MyTypes::DpPolicyContent',
               'DatasetRemoveMember' => 'MyElements::DatasetRemoveMember',
               'RbacRoleAdminInfoListResult/RoleList/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/StoragesetId' => 'MyTypes::ObjId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DatasetModifyNode/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateComplete/RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryRootsIterNextResult/Roots/DpOssvDirectoryRootInfo/FilesystemType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'VfilerSetup/RootPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetOptionsResult/GroupOptionInfo/GroupContact' => 'MyTypes::EmailAddressList',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'UserFavoriteReportDeleteResult' => 'MyElements::UserFavoriteReportDeleteResult',
               'ApplicationPolicyModify/EditLockId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'AlarmGetDefaultsResult/AlarmDefaults' => 'MyTypes::AlarmDefaults',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/PercentageSpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/AutoGrowCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryDiscoveredIterStart/IsInBackupRelationship' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserListIterNextResult/Records' => 'MyElements::HostDomainuserListIterNextResult::_Records',
               'PerfClientStatsListInfoIterNextResult' => 'MyElements::PerfClientStatsListInfoIterNextResult',
               'StorageServiceDatasetProvision/IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleCreate/ThrottleContent/ThrottleItemList' => 'MyTypes::ArrayOfThrottleItemInfo',
               'PerfDisableObjectUpdateResult' => 'MyElements::PerfDisableObjectUpdateResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/IsDrCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes' => 'MyTypes::ArrayOfDpPolicyNodeInfo',
               'DfmNetworkListInfoResult/Networks/NetworkInfo/NetworkAddress' => 'MyTypes::NetworkAddress',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAddResult/ApplianceId' => 'MyTypes::HostId',
               'SnapshotGetReclaimableInfo' => 'MyElements::SnapshotGetReclaimableInfo',
               'PerfGetCounterDependentsResult/ThresholdTemplates/ThresholdTemplate/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetServerStatusResult/PerfServerStatus/DataCollectionStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostOs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterStart/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberUndedupeStartResult/JobId' => 'MyElements::DatasetMemberUndedupeStartResult::_JobId',
               'HostDomainuserListIterStart/HostUsergroupNameOrId' => 'MyTypes::UsergroupNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpScheduleHourlyDelete' => 'MyElements::DpScheduleHourlyDelete',
               'DpPolicyGetDefaultPropertyValuesResult/SnapshotScheduleName' => 'MyTypes::ObjName',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo' => 'MyTypes::DpAgentInfo',
               'AlarmCreate/AlarmInfo/PagerAdminLoginNames/AdminName' => 'MyTypes::AdminName',
               'ReportDesignerList/CategoryNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldCreate/CommentFieldInfo/CommentFieldName' => 'MyTypes::CommentFieldName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMissingMemberListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterStart' => 'MyElements::EventclassListIterStart',
               'DatasetMemberListInfoIterStart/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceDatasetListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/HostId' => 'MyTypes::ObjId',
               'EventclassListResult/EventClasses' => 'MyTypes::ArrayOfEventClassInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicyId' => 'MyTypes::ObjId',
               'StorageServiceModify/ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/HostId' => 'MyTypes::ObjId',
               'PerfGetCounterData/TimeFilter/TimeRanges/TimeRange' => 'MyTypes::TimeRange',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/ResourcePool' => 'MyTypes::WrapperOfResourcePoolResource',
               'ReportDesignerScheduleModify/ReportScheduleInfo/ArchivalFormat' => 'MyTypes::ReportOutputFormat',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'EventclassListIterEnd' => 'MyElements::EventclassListIterEnd',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupMetadata/DfmMetadata' => 'MyTypes::DfmMetadata',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/StorageReliability/DiskFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatacenterReference/DatacenterId' => 'MyTypes::ObjId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts' => 'MyElements::DpDashboardGetProtectedDataCounts',
               'DpBackupVersionModify/DpBackupTransferInfo/SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportDelete' => 'MyElements::UserFavoriteReportDelete',
               'DpOssvApplicationListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo' => 'MyTypes::MonthlySubscheduleInfo',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'ResourcepoolListInfoIterStartResult' => 'MyElements::ResourcepoolListInfoIterStartResult',
               'DfmBackupScheduleDisableResult' => 'MyElements::DfmBackupScheduleDisableResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'DfmSnmpSettingsListInfo/PrefixLength' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfClientStatsPurgeResult/DeletedStatsCount' => 'MyElements::PerfClientStatsPurgeResult::_DeletedStatsCount',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/IsSnapvaultSecondaryQtree' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleMonthlyDeleteResult' => 'MyElements::DpScheduleMonthlyDeleteResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerStorageInfo/VfilerId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'AuditLogAddEntry/AuditApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedQtreeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_UnprotectedQtreeCount',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DfmScheduleMonthlyAddResult' => 'MyElements::DfmScheduleMonthlyAddResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/ResourcePool' => 'MyTypes::WrapperOfResourcePoolResource',
               'AggregateSpaceManagementCommit' => 'MyElements::AggregateSpaceManagementCommit',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/VolumeName' => 'MyTypes::ObjFullName',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2' => 'MyTypes::ThresholdInfo2',
               'PerfViewCreate/DataSources/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/ThresholdUnit' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfo' => 'MyElements::PerfObjectDependentCounterListInfo',
               'DatasetListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingsListInfoResult/NetworkSnmpCredentials/NetworkSnmpCredentialInfo/IsSnmpPrivacyEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/HostAddress' => 'MyTypes::IpAddress',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/GroupMemberAttributes/GroupMemberAttribute' => 'MyTypes::GroupMemberAttribute',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/ProvisioningPolicyType' => 'MyTypes::ProvisioningPolicyType',
               'CifsDomainListInfoIterNext/Maximum' => 'MyElements::CifsDomainListInfoIterNext::_Maximum',
               'DpBackupContentListIterNextResult/BackupContents/DpBackupContentInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNext' => 'MyElements::AggregateListInfoIterNext',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionDuration',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/DailyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_DailyRetentionDuration',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId' => 'MyTypes::WrapperOfLunNameOrId',
               'DfmRelatedObjectsListInfoResult/ParentResourcepoolList' => 'MyTypes::ArrayOfParentResourcepool',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolIsProvisionable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldValuesListInfoIterStartResult/Records' => 'MyElements::CommentFieldValuesListInfoIterStartResult::_Records',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationInfo/ApplicationVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList/HourlyInfo' => 'MyTypes::HourlyInfo',
               'DfmScheduleHourlyModify/DailyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetSpaceMetricListInfoIterEndResult' => 'MyElements::DatasetSpaceMetricListInfoIterEndResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/BackupScriptRunAs' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacOperationInfoListResult/OperationList/RbacOperation/OperationNameDetails/RbacOperationNameDetails' => 'MyTypes::RbacOperationNameDetails',
               'GroupListIterStart/ListSubgroups' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo/SpaceConditions/SpaceCondition/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpDashboardGetProtectedDataCounts2Result/IgnoredVolumeCount' => 'MyElements::DpDashboardGetProtectedDataCounts2Result::_IgnoredVolumeCount',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/RelationshipState' => 'MyTypes::RelationshipState',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCredentials' => 'MyTypes::NdmpCredentials',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/RbacRole/RbacRoleResource' => 'MyTypes::RbacRoleResource',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/VirtualMachineName' => 'MyTypes::ObjName',
               'DpRestoreViStart/BackupId' => 'MyElements::DpRestoreViStart::_BackupId',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/Timestamp' => 'MyTypes::DpTimestamp',
               'StorageServiceDatasetProvision/ApplicationInfo/IsApplicationManagingPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup' => 'MyTypes::WrapperOfPerfDataGroup',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeFullName' => 'MyTypes::ObjFullName',
               'DpOssvDirectoryRootsIterStart/OssvHostNameOrId' => 'MyTypes::OssvHostNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/MemberType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModifyMember/MemberNameOrId' => 'MyTypes::ObjNameOrId',
               'HostUserAdd/HostUser/HostUserInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'PerfCollectClientOperationStatistics/CollectionPeriod' => 'MyElements::PerfCollectClientOperationStatistics::_CollectionPeriod',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'DpScheduleListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo' => 'MyTypes::IfcInfo',
               'RbacAdminListInfoIterNextResult/Records' => 'MyElements::RbacAdminListInfoIterNextResult::_Records',
               'MigrateRollback/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/BackupMetadata/DfmMetadata/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/LagWarningThreshold' => 'MyTypes::DpPolicyNodeInfo::_LagWarningThreshold',
               'MigrateFix/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeName' => 'MyTypes::ObjName',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume' => 'MyTypes::WrapperOfVolumeResource',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo' => 'MyTypes::VmwareBackupScheduleSettingsInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Filer' => 'MyTypes::WrapperOfFilerResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupConfigInfo/Initiators' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo' => 'MyTypes::DpPolicyInfo',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateFullThreshold' => 'MyTypes::AggregateInfo::_AggregateFullThreshold',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/EventTimestamp' => 'MyTypes::DpTimestamp',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'ResourcepoolDestroy/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/CifsOpStats' => 'MyTypes::CifsOpStats',
               'DfmScheduleHourlyAddResult' => 'MyElements::DfmScheduleHourlyAddResult',
               'DatasetModifyNode' => 'MyElements::DatasetModifyNode',
               'HostAgentOssvServiceStop/AgentNameOrId' => 'MyTypes::HostNameOrId',
               'MigrateCancel/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/BackupDeletionRequestInfo' => 'MyTypes::BackupDeletionRequestInfo',
               'DpOssvApplicationRestoreDestinationListInfoIterEndResult' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterEndResult',
               'EventListIterStart/Timeout' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/IncludeIndependentDisks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'CommentFieldListInfoIterStart/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'DpBackupVersionModify/DpBackupTransferInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRestoreViStartResult' => 'MyElements::DpRestoreViStartResult',
               'DpJobPurge' => 'MyElements::DpJobPurge',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo' => 'MyTypes::StorageSetInfo',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/MaximumDataSize' => 'MyTypes::ProvisionMemberRequestInfo::_MaximumDataSize',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DatasetCreate/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'TimezoneListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/JobId' => 'MyTypes::DpJobProgressEventInfo::_JobId',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/DatasetsSpaceInfo/DatasetSpaceInfo/UsedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerCreate/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunInfo/LunPathId' => 'MyTypes::ObjId',
               'GroupMemberListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'PerfObjectListInfoResult' => 'MyElements::PerfObjectListInfoResult',
               'DatasetModify/IsSuspended' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/IsSuccessful' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetModify/DatasetMetadata/DfmMetadataField' => 'MyTypes::DfmMetadataField',
               'DpAgentStoragesystemListInfoIterNextResult/StorageSystems/StorageSystemInfo/AccessProtocol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Thresholds/PerfThreshold/PerfThresholdName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterStartResult' => 'MyElements::ReportScheduleListInfoIterStartResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails' => 'MyTypes::ArrayOfProtectionStatusJobDetail',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/VfilerTemplate/VfilerTemplateResource' => 'MyTypes::VfilerTemplateResource',
               'EventclassAddCustom/IsAllowDuplicates' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateRollback/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ViVirtualDiskListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'DpScheduleDailyDelete/ItemId' => 'MyElements::DpScheduleDailyDelete::_ItemId',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'ViHypervisorListInfoIterStartResult' => 'MyElements::ViHypervisorListInfoIterStartResult',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Dataset/DatasetResource/DatasetId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats' => 'MyTypes::ArrayOfClientStats',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostRoleNames' => 'MyTypes::ArrayOfHostRoleName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostUsergroupCreateResult/HostUsergroupId' => 'MyTypes::AccessObjectId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeName' => 'MyTypes::ObjName',
               'DpScheduleHourlyAdd/HourlyContent' => 'MyTypes::WrapperOfHourlyInfo',
               'DpScheduleDailyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'StorageServiceModify/StorageServiceNodeList/StorageServiceNodeAttributes/OldDpNodeName' => 'MyTypes::DpPolicyNodeName',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'PerfViewListIterNextResult/Views/PerfView/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterNextResult/Directories/DpOssvDirectoryInfo/IsBrowsable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LdapServerDelete/LdapServer/LdapServerPort' => 'MyTypes::LdapServer::_LdapServerPort',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryRootsIterStartResult' => 'MyElements::DpOssvDirectoryRootsIterStartResult',
               'ReportDesignerScheduleModify/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNextResult/Hosts/HostInfo/CifsDomainInfo/CifsDomainId' => 'MyTypes::CifsDomainInfo::_CifsDomainId',
               'DpThrottleListInfoIterStart/ThrottleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/EndDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_EndDayOfWeek',
               'PerfCounterGroupCreate/CounterGroup' => 'MyTypes::WrapperOfPerfCounterGroup',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'VfilerDestroy/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'CommentFieldListInfoIterStart/CommentFieldObjectTypes' => 'MyTypes::ArrayOfCommentFieldObjectType',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolContact' => 'MyTypes::EmailAddressList',
               'DatasetCreate/DatasetAccessDetails/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SrmFileTypeDelete/SrmFileTypeNameOrIdList/ObjectNameOrId' => 'MyTypes::ObjectNameOrId',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/DestinationPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterData/SampleRate' => 'MyElements::PerfGetCounterData::_SampleRate',
               'DatasetCreate/ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupMemberListIterEnd' => 'MyElements::GroupMemberListIterEnd',
               'ProvisioningPolicyListIterNext' => 'MyElements::ProvisioningPolicyListIterNext',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'HostUsergroupCreate/HostUsergroup' => 'MyTypes::WrapperOfHostUsergroupInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/IsAllowDuplicates' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Filer/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/MonthlyRetentionDuration' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'ViHypervisorListInfoIterNext' => 'MyElements::ViHypervisorListInfoIterNext',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportId' => 'MyTypes::ReportListInfo::_ReportId',
               'StorageServiceDatasetProvision/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeListInfoIterStart/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpRelationshipListInfoIterStartResult/Records' => 'MyElements::DpRelationshipListInfoIterStartResult::_Records',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMaxCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetMemberListInfoIterStart/IncludeSpaceInfo' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportGraphListInfoIterStartResult/Records' => 'MyElements::ReportGraphListInfoIterStartResult::_Records',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DestinationId' => 'MyTypes::ObjId',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/NfsOpStats/ReadOperations' => 'MyTypes::NfsOpStats::_ReadOperations',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/MeanTime' => 'MyTypes::ApiStat::_MeanTime',
               'DfmMonitorTimestampListResult' => 'MyElements::DfmMonitorTimestampListResult',
               'DatasetMemberDedupeStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMinCalls' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ReportDesignerScheduleModify/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/VfilerTemplateId' => 'MyTypes::ObjId',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetDestroy' => 'MyElements::DatasetDestroy',
               'HostListInfoIterStart/HostDpFilterInfo/IsUnprotected' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks/PerfHealthCheck' => 'MyTypes::PerfHealthCheck',
               'VolumeResize/VolumeNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdCreate2/ThresholdInfo2/ObjectsInfo/ObjectInfo' => 'MyTypes::ObjectInfo',
               'HostRoleListIterNextResult/HostRoles/HostRoleInfo/HostName' => 'MyTypes::ObjName',
               'MigrateStartResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair' => 'MyTypes::KeyValuePair',
               'DpScheduleWeeklyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/Severity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmRelatedObjectsListInfoResult/ParentGroupList' => 'MyTypes::ArrayOfParentGroup',
               'DatasetSet/MaximumQtreesPerVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting' => 'MyTypes::DatasetCifsExportSetting',
               'ResourcepoolMemberListInfoIterStartResult/Records' => 'MyElements::ResourcepoolMemberListInfoIterStartResult::_Records',
               'DpAgentStoragesystemListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportListInfoIterNextResult/ReportList' => 'MyTypes::ArrayOfReportInfo',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/HypervisorName' => 'MyTypes::ObjName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/InheritedRoles/RbacRoleResource/RbacRoleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassList' => 'MyElements::EventclassList',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/InitialSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace',
               'DfmScheduleMonthlyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentDiscover/TrackProgress' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleListIterNextResult' => 'MyElements::HostRoleListIterNextResult',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo/ResourcePoolMembers' => 'MyTypes::ArrayOfResourcePoolMember',
               'HostUserModify/HostUser/HostUserInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'PerfThresholdCreate2Result/ThresholdId' => 'MyTypes::ThresholdId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeInfo' => 'MyTypes::ProgressVolumeInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource' => 'MyTypes::VolumeResource',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/Description' => 'MyTypes::AccessObjectDescription',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'ReportScheduleDisable' => 'MyElements::ReportScheduleDisable',
               'PerfAssocViewListIterEndResult' => 'MyElements::PerfAssocViewListIterEndResult',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/BackupTransferStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetOptionsResult/GroupOptionInfo/SrmMaxLargeFiles' => 'MyTypes::GroupOptionInfo::_SrmMaxLargeFiles',
               'DatasetDestroy/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleRenameResult' => 'MyElements::DpScheduleRenameResult',
               'DpBackupStart/VmwareBackupSettingsInfo' => 'MyTypes::WrapperOfVmwareBackupScheduleSettingsInfo',
               'ProvisioningPolicyListIterEndResult' => 'MyElements::ProvisioningPolicyListIterEndResult',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/CifsSharesInfo' => 'MyTypes::ArrayOfCifsShareInfo',
               'EventStatusChangeListIterStart' => 'MyElements::EventStatusChangeListIterStart',
               'DpScheduleListInfoIterEnd' => 'MyElements::DpScheduleListInfoIterEnd',
               'PerfStatusGet' => 'MyElements::PerfStatusGet',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemoveResult' => 'MyElements::RbacRoleCapabilityRemoveResult',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageServiceInfo' => 'MyTypes::ProgressStorageServiceInfo',
               'DpJobListIterNextResult' => 'MyElements::DpJobListIterNextResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserListIterNextResult/HostUsers' => 'MyTypes::ArrayOfHostUserInfo',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsSnapvaultPrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/GraphLines/GraphLineInfo' => 'MyTypes::GraphLineInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/IgroupOsType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier' => 'MyTypes::ResourceIdentifier',
               'HostUsergroupListIterNextResult/HostUsergroups/HostUsergroupInfo/HostName' => 'MyTypes::ObjName',
               'DfmNetworkListInfoResult/Networks' => 'MyTypes::ArrayOfNetworkInfo',
               'PerfDiagTroubleshootResult/Categories/PerfDiagCategory/HealthChecks/PerfHealthCheck/HealthCheckStatus' => 'MyTypes::ObjStatus',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/IsRestorable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewCreate/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo/DnsServers' => 'MyTypes::ArrayOfIpAddress',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/EventMessage' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddResourcepool/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolNearlyFullThreshold' => 'MyTypes::ResourcepoolInfo::_ResourcepoolNearlyFullThreshold',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'PerfViewCreate/RealTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterStartResult/Records' => 'MyElements::ViHypervisorListInfoIterStartResult::_Records',
               'DpPolicyDestroy' => 'MyElements::DpPolicyDestroy',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolumeResult/MigrationJobs/MigrationJobInfo/VolumeId' => 'MyTypes::ObjId',
               'PerfViewAssociatedObjectsListResult/Objects/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/TimeInterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/CreateVmwareSnapshot' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'UserFavoriteReportListInfoIterEnd' => 'MyElements::UserFavoriteReportListInfoIterEnd',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities' => 'MyTypes::ArrayOfRbacResourceOperation',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/StartDayOfWeek' => 'MyTypes::WeeklySubscheduleInfo::_StartDayOfWeek',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo' => 'MyTypes::DatasetIoMetricInfo',
               'AlarmModify/AlarmInfo/PagerAdminLoginNames' => 'MyTypes::ArrayOfAdminName',
               'DpDashboardGetProtectedDataCounts2Result/UnprotectedApplicationResources' => 'MyTypes::ArrayOfApplicationResourceInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/HostDataset' => 'MyTypes::ObjName',
               'PerfCounterGroupGetDynamicDataSourcesResult' => 'MyElements::PerfCounterGroupGetDynamicDataSourcesResult',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'CommentFieldValuesListInfoIterStart/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQtreeInfo/QtreeId' => 'MyTypes::ObjId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth' => 'MyTypes::ArrayOfDayOfMonth',
               'HostGetDefaultsResult/HostDefaults/Timeout' => 'MyTypes::HostDefaults::_Timeout',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventNames/EventNameInfo/EventNamePretty' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPath/Members/DpRecoverMemberInfo/DestinationHost' => 'MyTypes::ObjNameOrId',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/SourceNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo' => 'MyTypes::ArrayOfObjectInfo',
               'DfmScheduleListInfoIterEnd' => 'MyElements::DfmScheduleListInfoIterEnd',
               'RbacAccessCheck/Resource/ResourceIdentifier/StorageService/StorageServiceResource/StorageServiceName' => 'MyTypes::ObjName',
               'HostRoleModify/HostRole/HostRoleInfo/Description' => 'MyTypes::AccessObjectDescription',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAddOssv/NdmpCredentials/FullNdmpCredentials/NdmpPort' => 'MyTypes::IpPortNumber',
               'DpOssvDirectoryBrowseIterNextResult' => 'MyElements::DpOssvDirectoryBrowseIterNextResult',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules' => 'MyTypes::ArrayOfApplicationBackupScheduleInfo',
               'DpJobProgressEventListIterEnd' => 'MyElements::DpJobProgressEventListIterEnd',
               'DpBackupListIterStart/IsRootObjectRestorable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'StorageServiceDatasetModifyResult' => 'MyElements::StorageServiceDatasetModifyResult',
               'LdapServerListInfoResult' => 'MyElements::LdapServerListInfoResult',
               'DfmScheduleHourlyDelete' => 'MyElements::DfmScheduleHourlyDelete',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/DefaultUserQuota' => 'MyTypes::NasContainerSettings::_DefaultUserQuota',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/DpBackupTransferInfo/DestinationBackupId' => 'MyTypes::DpBackupTransferInfo::_DestinationBackupId',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/SnapshotReserve' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ProvisioningPolicyListIterEnd' => 'MyElements::ProvisioningPolicyListIterEnd',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/IoMeasurement' => 'MyTypes::IoMeasurement',
               'ViDatacenterListInfoIterNextResult/Datacenters/Datacenter/VirtualCenterReference/VirtualCenterId' => 'MyTypes::ObjId',
               'DpBackupVersionModify/VersionMembers/VersionMemberInfo/VolumeName' => 'MyTypes::ObjName',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/Snapshots/SnapshotMemberInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'VolumeListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/BackupMetadata/DfmMetadata/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LunDestroy/LunNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo' => 'MyTypes::DatasetMigrationInfo',
               'DpOssvDirectoryBrowseIterNext' => 'MyElements::DpOssvDirectoryBrowseIterNext',
               'DfmRelatedObjectsListInfoResult/ParentDatasetList/ParentDataset' => 'MyTypes::ParentDataset',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/IsIndirect' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/IsIoDataPartial' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateCancelResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Effect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults' => 'MyTypes::ArrayOfSpaceManagementResultInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'IfcListInfoIterStartResult/Records' => 'MyElements::IfcListInfoIterStartResult::_Records',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/VfilerName' => 'MyTypes::ObjFullName',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunAction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleAdd/AdminNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetBeginFailover/DatasetNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CifsDomainListInfoIterNextResult/CifsDomainList/CifsDomainInfo/CifsDomainName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ResourcepoolName' => 'MyTypes::ObjName',
               'PerfThresholdListInfoIterNextResult/Records' => 'MyElements::PerfThresholdListInfoIterNextResult::_Records',
               'DatasetCreate/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdModify/Attributes' => 'MyTypes::WrapperOfThresholdInfo',
               'DpBackupContentListIterStart/BackupId' => 'MyElements::DpBackupContentListIterStart::_BackupId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/SpaceGuarantee' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterNextResult/Disks/DiskInfo/AggregateName' => 'MyTypes::ObjFullName',
               'PerfThresholdCreate2/ThresholdInfo2/ThresholdId' => 'MyTypes::ThresholdId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'HostGetDefaultsResult/HostDefaults/PerfAdvisorTransportHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'DfmScheduleWeeklySubscheduleModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/CustomProvisioningScriptSettings/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'HostAddOssv/HostNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterData/NumberSamples' => 'MyElements::PerfGetCounterData::_NumberSamples',
               'ApiProxy/Request/Args' => 'MyTypes::Request::_Args',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfSetDefaultView/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostCredentialsStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventclassListIterNextResult/EventClasses/EventClassInfo/EventNames' => 'MyTypes::ArrayOfEventNameInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Group/GroupResource' => 'MyTypes::GroupResource',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesTotal' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'LunListInfoIterNextResult' => 'MyElements::LunListInfoIterNextResult',
               'RbacRoleCapabilityAdd/Operation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostCapabilityListIterNextResult/Records' => 'MyElements::HostCapabilityListIterNextResult::_Records',
               'AggregateSpaceManagementCommitResult' => 'MyElements::AggregateSpaceManagementCommitResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/DrStatusProblems/DrStatusProblem/DrStatusSeverity' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetRemoveMemberByDynamicReference' => 'MyElements::DatasetRemoveMemberByDynamicReference',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'GroupAddMember/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'ResourcepoolListInfoIterStart/CheckLicenses/License' => 'MyTypes::License',
               'RbacRoleDisinherit' => 'MyElements::RbacRoleDisinherit',
               'PerfViewObjectAssociationDelete/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'EventGenerate/Source' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateListInfoIterEndResult' => 'MyElements::VfilerTemplateListInfoIterEndResult',
               'DfmBackupScheduleGetResult/RepeatInterval' => 'MyElements::DfmBackupScheduleGetResult::_RepeatInterval',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId' => 'MyTypes::WrapperOfQtreeNameOrId',
               'HostUsergroupListIterStartResult/Records' => 'MyElements::HostUsergroupListIterStartResult::_Records',
               'PerfAssocViewListIterNextResult/Views/PerfView/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeResize/ResizeVolumeRequestInfo/SnapReserve' => 'MyTypes::ResizeVolumeRequestInfo::_SnapReserve',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewObjectAssociationDeleteResult' => 'MyElements::PerfViewObjectAssociationDeleteResult',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DatasetId' => 'MyTypes::DpScheduledJob::_DatasetId',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/Password' => 'MyTypes::HostUserPassword',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats' => 'MyTypes::HostClientStats',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'NetifIpInterfaceListInfoResult/Interfaces/NetifIpInterfaceInfo/IpAddresses/String' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNext/Maximum' => 'MyElements::PerfAssocViewListIterNext::_Maximum',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/CpuMeanTime' => 'MyTypes::ApiStat::_CpuMeanTime',
               'HostModify/HostModifyInfo/HostDpModifyInfo/SnapvaultMaxBackupThreads' => 'MyTypes::HostDpModifyInfo::_SnapvaultMaxBackupThreads',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetRemoveMemberByDynamicReference/EditLockId' => 'MyElements::DatasetRemoveMemberByDynamicReference::_EditLockId',
               'DpPolicyListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryBrowseIterStartResult' => 'MyElements::DpOssvDirectoryBrowseIterStartResult',
               'StorageServiceListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents' => 'MyTypes::ArrayOfDpJobProgressEventInfo',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleAdd/ReportScheduleInfo/ScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DatasetUpdateProtectionStatusResult' => 'MyElements::DatasetUpdateProtectionStatusResult',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMemberDedupeStart/DedupeMemberRequestInfo/VolumeId' => 'MyTypes::ObjId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionDelete/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpRestoreToNewPathResult/OverwriteResults/OverwriteResult' => 'MyTypes::OverwriteResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerStorageInfo/VfilerName' => 'MyTypes::ObjFullName',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/VersionMembers/VersionMemberInfo/VolumeName' => 'MyTypes::ObjName',
               'HostDomainuserRemove/HostUsergroupNamesOrIds/HostUsergroupNameOrId' => 'MyTypes::HostUsergroupNameOrId',
               'DpBackupListIterStart/HasStorageResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/CifsOpStats/WriteOperations' => 'MyTypes::CifsOpStats::_WriteOperations',
               'GroupDestroyResult' => 'MyElements::GroupDestroyResult',
               'DpScheduleMonthlySubscheduleUnset/MonthlyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/SnapshotNameFormat' => 'MyTypes::SnapshotNameFormat',
               'HostDomainuserAdd/HostDomainuserNameOrIdOrSid' => 'MyTypes::DomainuserNameOrIdOrSid',
               'DatasetListInfoIterStart/RequiresNonDisruptiveRestore' => 'MyTypes::RequiresNonDisruptiveRestore',
               'DpOssvApplicationListInfoIterEnd' => 'MyElements::DpOssvApplicationListInfoIterEnd',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'DfmScheduleContentGetResult/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/InheritedRoles/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ViDatacenterListInfoIterEnd' => 'MyElements::ViDatacenterListInfoIterEnd',
               'HostRoleModify/HostRole/HostRoleInfo/HostRoleId' => 'MyTypes::AccessObjectId',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo/HostDomainuserId' => 'MyTypes::AccessObjectId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines' => 'MyTypes::ArrayOfPerfLine',
               'EventDelete' => 'MyElements::EventDelete',
               'ClientRegistryGetResult/Options' => 'MyTypes::ArrayOfClientOptionInfo',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SelectAllInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/IsAutosizeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'DpAgentDiscover/DpAgentNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/NumberRecords' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetModify/ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'StorageServiceDatasetProvision/DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
               'PerfThresholdListInfoIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ReportDesignerList/ReportProvenance' => 'MyTypes::ReportProvenance',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DiskListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfViewCreate/View/PerfView/AreEventsShown' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklySubscheduleModify/EndDayOfWeek' => 'MyElements::DfmScheduleWeeklySubscheduleModify::_EndDayOfWeek',
               'ResourcepoolModify' => 'MyElements::ResourcepoolModify',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/Capabilities' => 'MyTypes::ArrayOfCapability',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostListInfoIterNext/Maximum' => 'MyElements::HostListInfoIterNext::_Maximum',
               'PerfViewModify/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo/OptionName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/DpBackupTransferInfo/DestinationStoragesetId' => 'MyTypes::DpBackupTransferInfo::_DestinationStoragesetId',
               'DpOssvDirectoryDiscoveredIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/TargetObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViDatacenterListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent' => 'MyTypes::DpPolicyContent',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUserAdd/HostUser/HostUserInfo/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVfilerInfo/FilerId' => 'MyTypes::ObjId',
               'ReportDesignerScheduleModify/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViDatacenterListInfoIterNext' => 'MyElements::ViDatacenterListInfoIterNext',
               'DfmScheduleContentGetResult/ScheduleContentInfo/DailyList' => 'MyTypes::ArrayOfDailyInfo',
               'AlarmListInfoIterEndResult' => 'MyElements::AlarmListInfoIterEndResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetEditCommitResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolume/MigrationRequestInfo/Volumes' => 'MyTypes::ArrayOfObjNameOrId',
               'EventListIterStart/TimeRange/EventTimestampRange/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/MetricResult' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate' => 'MyElements::VfilerTemplateCreate',
               'DfmScheduleWeeklySubscheduleModify' => 'MyElements::DfmScheduleWeeklySubscheduleModify',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'PerfThresholdListInfoIterEnd' => 'MyElements::PerfThresholdListInfoIterEnd',
               'ReportDesignerScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'DpScheduleWeeklyModify/WeeklyContent/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/BackupDeletionRequestInfo/BackupIds' => 'MyTypes::ArrayOfBackupId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/ApplicationPolicyId' => 'MyTypes::ObjId',
               'DfmScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/MonthlyList/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'HostAddResult/AgentId' => 'MyTypes::HostId',
               'ReportListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'ResourcepoolMemberListInfoIterEndResult' => 'MyElements::ResourcepoolMemberListInfoIterEndResult',
               'EventDeleteResult/EventsDeletedList/EventActionInfo/ErrorCode' => 'MyTypes::EventActionInfo::_ErrorCode',
               'StorageServiceListInfoIterNext' => 'MyElements::StorageServiceListInfoIterNext',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'DpScheduleWeeklyModify/WeeklyContent' => 'MyTypes::WrapperOfWeeklyInfo',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/ProvisioningPolicyName' => 'MyTypes::ObjFullName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails/OperationDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupCopyResult/GroupId' => 'MyElements::GroupCopyResult::_GroupId',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat/DbMaxTime' => 'MyTypes::ApiStat::_DbMaxTime',
               'PerfCounterGroupListInfoResult/CounterGroups' => 'MyTypes::ArrayOfPerfCounterGroup',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusJobDetails/ProtectionStatusJobDetail/ProtectionStatusJobDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'HostUsergroupListIterNextResult/HostUsergroups' => 'MyTypes::ArrayOfHostUsergroupInfo',
               'ViDatacenterListInfoIterNextResult/Records' => 'MyElements::ViDatacenterListInfoIterNextResult::_Records',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData' => 'MyTypes::PerfInstanceCounterData',
               'DpBackupGetLocation/Paths/DpBackupPathInfo/PrimarySnapshotUniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleDependencyResult/ThrottleAssignees/ThrottleAssignee/AssigneeFullName' => 'MyTypes::ObjFullName',
               'ApiProxyResult/Response' => 'MyTypes::Response',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
               'ReportDesignerScheduleModify/ReportScheduleInfo' => 'MyTypes::ReportScheduleInfo',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult' => 'MyTypes::MigrationDryRunResult',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'DpThrottleCreateResult/ThrottleId' => 'MyElements::DpThrottleCreateResult::_ThrottleId',
               'DpBackupContentListIterStart/RootObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/ReportScheduleName' => 'MyTypes::ObjName',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/EndMinute' => 'MyTypes::ThrottleItemInfo::_EndMinute',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressCifsShareInfo/CifsAclList/CifsAcl' => 'MyTypes::CifsAcl',
               'DpDashboardGetDrDatasetCountsResult/DrStateStatusCounts/DrStateStatusCount/DrState' => 'MyTypes::DrState',
               'DatasetRemoveMemberByDynamicReference/DatasetDynamicReferenceParameters' => 'MyTypes::ArrayOfDatasetDynamicReferenceParameter',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/AggregateNearlyOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo/PerfObjectCounter/TimeConsolidationMethod' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostId' => 'MyTypes::ObjId',
               'TimezoneListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentListInfoIterNextResult/DpAgents/DpAgentInfo/DpAgentId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/SanContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklyList/WeeklyInfo/DayOfWeek' => 'MyTypes::WeeklyInfo::_DayOfWeek',
               'HostUserAdd/HostUser/HostUserInfo/HostRoleNames/HostRoleName' => 'MyTypes::HostRoleName',
               'TimezoneListInfoIterEndResult' => 'MyElements::TimezoneListInfoIterEndResult',
               'AlarmCreate/AlarmInfo/PagerEmailAddresses' => 'MyTypes::ArrayOfEmailAddress',
               'PerfViewCreate/View/PerfView/SampleBuffer' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos/AggregateSpaceInfo/UsedSpace' => 'MyTypes::AggregateSpaceInfo::_UsedSpace',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'PerfThresholdTemplateModifyResult' => 'MyElements::PerfThresholdTemplateModifyResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Policy' => 'MyTypes::WrapperOfPolicyResource',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo' => 'MyTypes::TimeOfDayInfo',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'PerfGetCounterListNotInView/ObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'DpPolicyCopy/DpPolicyName' => 'MyTypes::ObjName',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapvaultInfo/DestinationQtreeId' => 'MyTypes::DpProgressSnapvaultInfo::_DestinationQtreeId',
               'HostRoleListIterStart/Verbose' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmSnmpSettingModify/SnmpAuthenticationProtocol' => 'MyTypes::SnmpAuthenticationProtocol',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/ItemId' => 'MyTypes::WeeklySubscheduleInfo::_ItemId',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventArguments/KeyValuePair/Key' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterEndResult' => 'MyElements::DpBackupListIterEndResult',
               'DpScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/Frequency' => 'MyTypes::HourlyInfo::_Frequency',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AuditLogAddEntry' => 'MyElements::AuditLogAddEntry',
               'PerfGetCounterDataResult/PerfInstances/PerfInstanceCounterData/Counters/PerfCounterData/CounterData' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNextResult/Records' => 'MyElements::SnapshotListInfoIterNextResult::_Records',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ObjectNameWhenBackedUp' => 'MyTypes::ObjName',
               'ReportGraphListInfoIterNextResult/GraphList' => 'MyTypes::ArrayOfGraphInfo',
               'PerfViewDestroy/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ApplicationResourceProperties/PropertyInfo/PropertyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ReportScheduleInfo/EmailAddressList' => 'MyTypes::EmailAddressList',
               'ResourcepoolMemberListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId' => 'MyTypes::WrapperOfLunNameOrId',
               'DatasetCreate/ApplicationInfo/IsApplicationManagingPrimaryBackupRetention' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpRestoreToNewPathResult/SpaceStatusResults/SpaceStatusResult' => 'MyTypes::SpaceStatusResult',
               'EventListIterStart/MaxEvents' => 'MyElements::EventListIterStart::_MaxEvents',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/StartTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DfmAboutResult/DfmDirectories/DirectoryInfo/Size' => 'MyTypes::DirectoryInfo::_Size',
               'StorageServiceDatasetModify/IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostDomainuserListIterStartResult' => 'MyElements::HostDomainuserListIterStartResult',
               'PerfViewGetData/NumberSamples' => 'MyElements::PerfViewGetData::_NumberSamples',
               'PerfThresholdListInfo2IterStart' => 'MyElements::PerfThresholdListInfo2IterStart',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvApplicationRestoreDestinationListInfoIterNext/Maximum' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterNext::_Maximum',
               'DpBackupListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateListInfoIterStart/ObjectNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserPushResult' => 'MyElements::HostDomainuserPushResult',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'DatasetExclusionListInfoIterNextResult/ExclusionList/ExcludedObjectInfo/ObjectName' => 'MyTypes::ObjName',
               'DpPolicyGetDefaultPropertyValuesResult/BackupScheduleName' => 'MyTypes::ObjName',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressSnapmirrorInfo/SourceVolumeOrQtreeId' => 'MyTypes::DpProgressSnapmirrorInfo::_SourceVolumeOrQtreeId',
               'GroupCopy' => 'MyElements::GroupCopy',
               'DfmServerListDiagnosticInfoResult/DiagInfo' => 'MyTypes::ArrayOfDfmDiagCounterGroup',
               'ResourcepoolRemoveMemberResult' => 'MyElements::ResourcepoolRemoveMemberResult',
               'ResourcepoolListInfoIterEnd' => 'MyElements::ResourcepoolListInfoIterEnd',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/TemplateId' => 'MyTypes::ThresholdInfo2::_TemplateId',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/DatastoreId' => 'MyTypes::ObjId',
               'EventListIterNextResult/Events/EventInfo/EventArguments' => 'MyTypes::ArrayOfKeyValuePair',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/Snapshots' => 'MyTypes::ArrayOfSnapshot',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleWeeklyModify/WeeklyContent/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/DatasetNodes/DatasetNodeInfo/IsDpNodeEffectivePrimary' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource/FilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/HourlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_HourlyRetentionDuration',
               'RbacAccessCheck/Operation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleDailyModify/DailyContent/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpJobScheduleListIterNextResult/ScheduledJobs/DpScheduledJob/DpLocalSnapshotJobData/IsConfirmationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo' => 'MyTypes::ProvisionMemberRequestInfo',
               'HostModify/HostModifyInfo/UseHostsEquiv' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerSetup/IpBindings/IpBindingInfo/MtuSize' => 'MyTypes::IpBindingInfo::_MtuSize',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicyId' => 'MyTypes::ObjId',
               'PerfAssocViewListIterStart' => 'MyElements::PerfAssocViewListIterStart',
               'ProvisioningPolicyEditCommitResult' => 'MyElements::ProvisioningPolicyEditCommitResult',
               'GroupCreate' => 'MyElements::GroupCreate',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/StorageService' => 'MyTypes::WrapperOfStorageServiceResource',
               'AuditLogAddEntry/AuditPriority' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSetStorageset/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostAddOssv/NdmpCredentials/FullNdmpCredentials' => 'MyTypes::FullNdmpCredentials',
               'AlarmModify/AlarmInfo/IsDisabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DatacenterReference/DatacenterName' => 'MyTypes::ObjName',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourceTag' => 'MyTypes::ResourceTag',
               'DpRelationshipListInfoIterStart/SourceOrDestinationId' => 'MyTypes::ObjId',
               'ReportListInfoIterNextResult/ReportList/ReportInfo/ReportPrettyName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklyAdd/WeeklyContent' => 'MyTypes::WrapperOfWeeklyInfo',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsCapableOfMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'DatasetMissingMemberListInfoIterEndResult' => 'MyElements::DatasetMissingMemberListInfoIterEndResult',
               'QtreeRename/QtreeNameNew' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyCopy/SourcePolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/IsDataAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModifyResult' => 'MyElements::PerfCounterGroupModifyResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/BlockType' => 'MyTypes::FileSystemBlockType',
               'DpJobListIterStart/JobContextObjNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/ProvisioningPolicyId' => 'MyTypes::ObjId',
               'DatasetMissingMemberListInfoIterEnd' => 'MyElements::DatasetMissingMemberListInfoIterEnd',
               'DfmScheduleWeeklyModify/WeeklyContent/WeeklyInfo' => 'MyTypes::WeeklyInfo',
               'DpJobListIterStart' => 'MyElements::DpJobListIterStart',
               'PerfViewListIterNextResult/Views/PerfView/SampleRate' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'AggregateListInfoIterStart/BlockType' => 'MyTypes::FileSystemBlockType',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/RetentionDuration' => 'MyTypes::DpBackupInfo::_RetentionDuration',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementRemoveOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/UsedSpace' => 'MyTypes::AggregateSpaceInfo::_UsedSpace',
               'DatasetExclusionListInfoIterNextResult/ExclusionList' => 'MyTypes::ArrayOfExcludedObjectInfo',
               'PerfClientStatsListInfoIterStart/LastOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/DefaultUserQuota' => 'MyTypes::NasContainerSettings::_DefaultUserQuota',
               'ApplicationPolicyModify/ApplicationPolicyInfo/GroupNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleHourlyAdd/DailyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentModify/HostserviceModifyInfo/UpdateServicePort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfCounterGroupDestroy/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupMemberListIterStartResult' => 'MyElements::GroupMemberListIterStartResult',
               'ClientRegistryGet' => 'MyElements::ClientRegistryGet',
               'ReportOutputDeleteResult' => 'MyElements::ReportOutputDeleteResult',
               'StorageServiceDatasetProvision/DatasetMetadata/DfmMetadataField/FieldName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunSeverity' => 'MyTypes::ObjStatus',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DpScheduleCreate/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'HostUserModify/HostUser/HostUserInfo/HostUsergroupIds/HostUsergroupId' => 'MyTypes::HostUsergroupId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList' => 'MyTypes::ArrayOfScheduleContentInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressQuotaInfo/DefaultGroupQuota' => 'MyTypes::ProgressQuotaInfo::_DefaultGroupQuota',
               'GroupListIterStart/RbacOperation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ProvisioningPolicyEditBegin/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleCreate/ScheduleContentInfo/ScheduleName' => 'MyTypes::ObjName',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/TargetObjectId' => 'MyTypes::ReportOutputInfo::_TargetObjectId',
               'VfilerTemplateModify/VfilerTemplate' => 'MyTypes::WrapperOfVfilerTemplateInfo',
               'PerfViewModify/View/PerfView/Charts/PerfChart/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetMemberDedupeAbort' => 'MyElements::DatasetMemberDedupeAbort',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectFullName' => 'MyTypes::ObjFullName',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeSize/OverwriteReserveUsed' => 'MyTypes::VolumeSize::_OverwriteReserveUsed',
               'MigrateUpdate' => 'MyElements::MigrateUpdate',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Group' => 'MyTypes::WrapperOfGroupResource',
               'CifsDomainListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupContentListIterNext/Maximum' => 'MyElements::DpBackupContentListIterNext::_Maximum',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/FilerIdentifier/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleWeeklySubscheduleAddResult/ItemId' => 'MyElements::DfmScheduleWeeklySubscheduleAddResult::_ItemId',
               'PerfViewModify/View/PerfView/IsStopped' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklyDelete' => 'MyElements::DfmScheduleWeeklyDelete',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/Id' => 'MyTypes::DpPolicyNodeInfo::_Id',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpLocalSnapshotJobData/NodeId' => 'MyTypes::DpLocalSnapshotJobData::_NodeId',
               'PerfCounterGroupGetDynamicDataSourcesResult/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/MissingHostObjectCounters/PerfMissingHostObjectCounter/MissingObjectCounters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DfmNetworkAdd/NetworkAddress' => 'MyTypes::NetworkAddress',
               'DpScheduleListInfoIterEndResult' => 'MyElements::DpScheduleListInfoIterEndResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Host' => 'MyTypes::WrapperOfHostResource',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressBackupInfo' => 'MyTypes::DpProgressBackupInfo',
               'DatasetSpaceMetricListInfoIterNextResult/DatasetSpaceMetrics/DatasetSpaceMetricInfo/DatasetNode/MetricDatasetNodeInfo' => 'MyTypes::MetricDatasetNodeInfo',
               'DatasetReplacePrimaryMembers/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleHourlyModify/HourlyContent/HourlyInfo/ItemId' => 'MyTypes::HourlyInfo::_ItemId',
               'ReportDesignerScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'DfmScheduleContentGetResult/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DpBackupListIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetDynamicReferenceListInfoIterStart/StoragesetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/WeekOfMonth' => 'MyTypes::MonthlyInfo::_WeekOfMonth',
               'SrmFileTypeListInfoResult/SrmFileTypes/SrmFileTypeInfo' => 'MyTypes::SrmFileTypeInfo',
               'RbacRoleInfoList/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterNext/Maximum' => 'MyElements::SnapshotListInfoIterNext::_Maximum',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressFailoverInfo/ScriptExitStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'ReportOutputListInfoIterNextResult/ReportOutputList/ReportOutputInfo/GraphName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterEnd' => 'MyElements::PerfThresholdTemplateListInfoIterEnd',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'DpBackupVersionCreate/IsForPropagation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition' => 'MyTypes::ResourcePropertyCondition',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupTransferInfos/DpBackupTransferInfo/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdCreate/ThresholdInfo' => 'MyTypes::ThresholdInfo',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressNfsexportInfo/QtreeId' => 'MyTypes::ObjId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMigrationInfo/SourceVfilerName' => 'MyTypes::ObjFullName',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationNameDetails' => 'MyTypes::WrapperOfRbacOperationNameDetails',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor' => 'MyTypes::Hypervisor',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfWeek' => 'MyTypes::MonthlyInfo::_DayOfWeek',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions/DatasetCifsSharePermission' => 'MyTypes::DatasetCifsSharePermission',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/BackupScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMemberResult' => 'MyElements::DatasetProvisionMemberResult',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/AggregateName' => 'MyTypes::ObjName',
               'LunListInfoIterNextResult/Luns/LunInfo/LunUsedSpace' => 'MyTypes::LunInfo::_LunUsedSpace',
               'PerfViewListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateDetachObjects/Objects/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpRestoreToNewPathResult/SpaceStatusResults' => 'MyTypes::ArrayOfSpaceStatusResult',
               'PerfViewListIterNextResult/Views/PerfView/Charts' => 'MyTypes::ArrayOfPerfChart',
               'PerfClientStatsListInfoIterNextResult/Records' => 'MyElements::PerfClientStatsListInfoIterNextResult::_Records',
               'PerfClientStatsListInfoIterStart' => 'MyElements::PerfClientStatsListInfoIterStart',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterStart' => 'MyElements::AggregateListInfoIterStart',
               'DfmScheduleCreate/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'DpScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime/TimeOfDayInfo/Hour' => 'MyTypes::TimeOfDayInfo::_Hour',
               'DpAgentStoragesystemListInfoIterEndResult' => 'MyElements::DpAgentStoragesystemListInfoIterEndResult',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphEdges/BackupGraphEdgeInfo/ToResourceId' => 'MyTypes::ObjId',
               'CifsDomainListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostDomainuserListIterStart' => 'MyElements::HostDomainuserListIterStart',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'LdapServerDelete/LdapServer' => 'MyTypes::LdapServer',
               'LunListInfoIterNextResult/Luns/LunInfo/Igroups/IgroupReference/IgroupId' => 'MyTypes::ObjId',
               'DpOssvDirectoryRootsIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo' => 'MyTypes::CounterThresholdInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunSuggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'PerfObjectCounterListInfoResult/Counters/PerfCounter/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentSetObjectValue/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfThresholdListInfo2IterNextResult' => 'MyElements::PerfThresholdListInfo2IterNextResult',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatastoreType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateRollback/RouteMigrationMode' => 'MyTypes::RouteMigrationMode',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/Path' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/MaximumY' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfAssocViewListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'MigrateRollback/RunDedupeScan' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionCount' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionCount',
               'DatasetMissingMemberListInfoIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleDailyModify/DailyContent' => 'MyTypes::WrapperOfDailyInfo',
               'StorageServiceModify/StorageServiceNameOrId' => 'MyTypes::ObjNameOrId',
               'ReportDesignerScheduleModify/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'PerfClientStatsListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'HostModify/HostNameOrId' => 'MyTypes::HostNameOrId',
               'DpScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeId' => 'MyTypes::ObjId',
               'DatasetCreate/ProvisioningPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'HostUserListIterStartResult/Records' => 'MyElements::HostUserListIterStartResult::_Records',
               'DpBackupGetLocationResult/BackupLocations/BackupLocationInfo/SnapshotName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'GraphDataListInfoResult' => 'MyElements::GraphDataListInfoResult',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostCapabilityListIterNextResult/Capabilities' => 'MyTypes::ArrayOfCapability',
               'PerfViewGetData/DynamicObjectInfo/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostModify/HostModifyInfo/HostDpModifyInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpAgentConfigure/StorageSystemsConfiguration/StorageSystemConfiguration/PushCredentials' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'MigrateCancelResult' => 'MyElements::MigrateCancelResult',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeRename/QtreeNameOrId' => 'MyElements::QtreeRename::_QtreeNameOrId',
               'EventclassListIterStartResult' => 'MyElements::EventclassListIterStartResult',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpAgentStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterNextResult/BackupVersions/DpBackupVersionInfo/BackupIdInfos/DpBackupIdInfo/BackupId' => 'MyTypes::DpBackupIdInfo::_BackupId',
               'DiskListInfoIterStartResult' => 'MyElements::DiskListInfoIterStartResult',
               'CommentFieldListInfoIterNextResult' => 'MyElements::CommentFieldListInfoIterNextResult',
               'DiskListInfoIterNextResult/Disks/DiskInfo/RaidgroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmBackupScheduleSet/Day' => 'MyElements::DfmBackupScheduleSet::_Day',
               'DatasetListInfoIterStart/IncludeCanContainApplicationResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfDiagTroubleshootResult/Categories' => 'MyTypes::ArrayOfPerfDiagCategory',
               'ReportOutputRead/ReportOutputId' => 'MyElements::ReportOutputRead::_ReportOutputId',
               'ResourcepoolMemberListInfoIterStart/RunProvisioningChecks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ViVirtualMachineListInfoIterEnd' => 'MyElements::ViVirtualMachineListInfoIterEnd',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/DnsServers/IpAddress' => 'MyTypes::IpAddress',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/Datasets' => 'MyTypes::ArrayOfDatasetReference',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/CustomProvisioningScriptSettings/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'DpPolicyListIterNextResult/Records' => 'MyElements::DpPolicyListIterNextResult::_Records',
               'MigrateComplete/RouteMigrationMode' => 'MyTypes::RouteMigrationMode',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/NodeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfAssocViewListIterNextResult/Views/PerfView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventDeletedUser' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmCreate/AlarmInfo/AlarmScriptRunas' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostId' => 'MyTypes::ObjId',
               'AggregateListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterNextResult/Favorites/UserReportInfo/Count' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'StorageServiceDatasetProvision/IsApplicationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'HostUserAdd/HostUser/HostUserInfo/HostUsergroupNames/HostUsergroupName' => 'MyTypes::HostUsergroupName',
               'DpPolicyCopyResult/DpPolicyId' => 'MyTypes::ObjId',
               'DfmScheduleDailyModify/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfo/MetaDataOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetExportProtocol' => 'MyTypes::DatasetExportProtocol',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier/FilerResource' => 'MyTypes::FilerResource',
               'DatasetConformBegin/AssumeConfirmation' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/HypervBackupScheduleSettingsInfo/AllowSavedStateBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/DatasetCifsSharePermissions' => 'MyTypes::ArrayOfDatasetCifsSharePermission',
               'LunResize' => 'MyElements::LunResize',
               'RbacAdminListInfoIterNextResult' => 'MyElements::RbacAdminListInfoIterNextResult',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleModify/ReportScheduleInfo/SaveAllFields' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'VfilerTemplateListInfoIterNextResult/VfilerTemplates/VfilerTemplateInfo' => 'MyTypes::VfilerTemplateInfo',
               'CifsDomainListInfoIterStart' => 'MyElements::CifsDomainListInfoIterStart',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/StartedTimestamp' => 'MyTypes::DpTimestamp',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetId' => 'MyTypes::ObjId',
               'MigrateVolumeResult' => 'MyElements::MigrateVolumeResult',
               'MigrateVolume/MigrationRequestInfo/Volumes/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressBackupInfo/BackupId' => 'MyTypes::DpProgressBackupInfo::_BackupId',
               'DpJobListIterStart/JobTypes/JobType' => 'MyTypes::JobType',
               'PerfViewModify/View/PerfView/AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
               'DfmScheduleDependencyResult/ScheduleAssignees/ScheduleAssignee/AssigneeFullName' => 'MyTypes::ObjFullName',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting' => 'MyTypes::DatasetNfsExportSetting',
               'HostCapabilityListIterNext' => 'MyElements::HostCapabilityListIterNext',
               'PerfCounterGroupGetDataResult/CounterData' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupListIterEndResult' => 'MyElements::HostUsergroupListIterEndResult',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfo' => 'MyElements::PerfCounterGroupListInfo',
               'HostDomainuserListIterNextResult/HostDomainusers' => 'MyTypes::ArrayOfHostDomainuserInfo',
               'CifsDomainListInfoIterStartResult/Records' => 'MyElements::CifsDomainListInfoIterStartResult::_Records',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Filer/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/BackupVersion' => 'MyTypes::DpTimestamp',
               'DfmScheduleListInfoIterStartResult' => 'MyElements::DfmScheduleListInfoIterStartResult',
               'EventStatusChangeListIterNextResult/Events/EventInfo/IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerListResult/ReportList/ReportListInfo/ReportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/IpAddress' => 'MyTypes::IpAddress',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/TrapDestinations/TrapDestination/TrapHost' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos' => 'MyTypes::ArrayOfAggregateSpaceInfo',
               'DpAgentConfigure/StorageSystemsConfiguration/StorageSystemConfiguration' => 'MyTypes::StorageSystemConfiguration',
               'MigrateCleanupResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Action' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify/Attributes/ThresholdInfo' => 'MyTypes::ThresholdInfo',
               'StorageServiceDestroy/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupContentListIterStart/SubPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/VfilerId' => 'MyTypes::ObjId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Host/HostResource' => 'MyTypes::HostResource',
               'ViVirtualDiskListInfoIterNextResult/VirtualDisks/VirtualDisk/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/SpaceConsumed' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpRelationshipListInfoIterNextResult/DpRelationships/DpRelationshipInfo/IsDpImported' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleAdd' => 'MyElements::RbacRoleAdd',
               'AggregateListInfoIterStart/ResourcepoolFilter' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpLocalSnapshotJobData/IsConfirmationData' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleMonthlySubscheduleUnset/MonthlyScheduleNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleDailyAdd/DailyContent/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo/DedupeStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/Hostname' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmSnmpSettingModifyResult' => 'MyElements::DfmSnmpSettingModifyResult',
               'PerfGetCounterDependentsResult/Reports/PerfReport' => 'MyTypes::PerfReport',
               'VfilerSetup/IpBindings/IpBindingInfo/PartnerInterface' => 'MyTypes::ObjNameOrId',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ViVirtualDiskListInfoIterNext' => 'MyElements::ViVirtualDiskListInfoIterNext',
               'ApplicationPolicyDestroy/Force' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceCreate/StorageServiceNodeList/StorageServiceNodeAttributes/VfilerTemplateNameOrId' => 'MyTypes::ObjNameOrId',
               'GroupListIterNextResult/GroupList/GroupInfo/GroupPerfStatus' => 'MyTypes::ObjStatus',
               'VolumeListInfoIterStart/IsSnapmirrorSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmNetworkListInfoResult/Networks/NetworkInfo/NetworkId' => 'MyTypes::NetworkId',
               'DpAgentStoragesystemListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup' => 'MyTypes::PerfCounterGroup',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/Datasets/DatasetReference/DatasetId' => 'MyTypes::ObjId',
               'DfmGetResourcePropertyValuesResult/ResourcePropertyValues/ResourcePropertyValues' => 'MyTypes::ResourcePropertyValues',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupCreateResult/GroupId' => 'MyElements::GroupCreateResult::_GroupId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DatasetIoMetricListInfoIterEndResult' => 'MyElements::DatasetIoMetricListInfoIterEndResult',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo/LdapServer/LdapServerAddr' => 'MyTypes::NetworkAddress',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/AdvancedOptions/AdvancedOptionInfo' => 'MyTypes::AdvancedOptionInfo',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupModify/HostUsergroup/HostUsergroupInfo/HostRoleIds' => 'MyTypes::ArrayOfHostRoleId',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostRoleCreate/HostRole/HostRoleInfo' => 'MyTypes::HostRoleInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource' => 'MyTypes::LunResource',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/IsReadonlyForAllHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklySubscheduleAdd' => 'MyElements::DfmScheduleWeeklySubscheduleAdd',
               'UserRecentReportListInfoIterNextResult/RecentViewed/UserReportInfo/Count' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'HostGetDefaultsResult/HostDefaults/NdmpPort' => 'MyTypes::IpPortNumber',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobScheduleListIterStart/DatasetNameOrId' => 'MyElements::DpJobScheduleListIterStart::_DatasetNameOrId',
               'FcpTargetListInfoIterNext' => 'MyElements::FcpTargetListInfoIterNext',
               'DpDashboardGetDrDatasetCountsResult/DrStateStatusCounts/DrStateStatusCount' => 'MyTypes::DrStateStatusCount',
               'AlarmModify/AlarmInfo/EmailAddresses/EmailAddress' => 'MyTypes::EmailAddress',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'RbacAccessCheck/Resource/ResourceIdentifier/Filer' => 'MyTypes::WrapperOfFilerResource',
               'DatasetExclusionListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectInstanceListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/EventSeverities/ObjStatus' => 'MyTypes::ObjStatus',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/DnsName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleCreate/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'HostCreateNdmpuser' => 'MyElements::HostCreateNdmpuser',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'ResourcepoolRemoveMember/MemberNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetListIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/DatasetName' => 'MyTypes::ObjName',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList' => 'MyTypes::ArrayOfHourlyInfo',
               'DpDashboardGetProtectedDataCountsResult/UnprotectedOssvDirectoryCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_UnprotectedOssvDirectoryCount',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregatePerfStatus' => 'MyTypes::ObjStatus',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRelationshipInfo/RelationshipType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ClientRegistrySet/ApplicationName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSetStoragesetResult' => 'MyElements::DatasetSetStoragesetResult',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewDestroy/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember' => 'MyTypes::WrapperOfProvisionMemberRequestInfo',
               'DfmGetResourcePropertyValuesResult/ResourcePropertyValues' => 'MyTypes::ArrayOfResourcePropertyValues',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupMemberListIterStartResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacOperationAdd/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails' => 'MyTypes::RbacOperationNameDetails',
               'DpOssvApplicationListInfoIterEndResult' => 'MyElements::DpOssvApplicationListInfoIterEndResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
               'FcpTargetListInfoIterEndResult' => 'MyElements::FcpTargetListInfoIterEndResult',
               'DpAgentUnregister' => 'MyElements::DpAgentUnregister',
               'DatasetRemoveMember/EditLockId' => 'MyElements::DatasetRemoveMember::_EditLockId',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterEndResult' => 'MyElements::EventListIterEndResult',
               'DatasetListInfoIterStart/HasProtection' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SrmFileTypeListInfo/SrmFileTypeId' => 'MyTypes::ObjId',
               'DpBackupVersionCreate/BackupMetadata/DfmMetadata' => 'MyTypes::DfmMetadata',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources' => 'MyTypes::WrapperOfPerfDynamicDataSources',
               'ReportListInfoIterStart' => 'MyElements::ReportListInfoIterStart',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun' => 'MyTypes::WrapperOfLunResource',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetCifsExportSetting/CifsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdModify2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules' => 'MyTypes::ArrayOfApplicationBackupScheduleInfo',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/SourceFilerName' => 'MyTypes::ObjFullName',
               'StorageServiceDatasetModifyResult/ConformanceAlerts' => 'MyTypes::ArrayOfConformanceAlert',
               'Fault/faultactor' => 'SOAP::WSDL::XSD::Typelib::Builtin::token',
               'DfmScheduleHourlyModifyResult' => 'MyElements::DfmScheduleHourlyModifyResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/BackupId' => 'MyTypes::DpProgressRestoreInfo::_BackupId',
               'RbacAccessCheck/Resource/ResourceIdentifier/Filer/FilerResource/FilerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'DatasetResizeMember/EditLockId' => 'MyElements::DatasetResizeMember::_EditLockId',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/WeeklyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_WeeklyRetentionDuration',
               'CommentFieldListInfoIterNextResult/CommentFields/CommentFieldInfo/IsSystemComment' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostGetDefaultsResult/HostDefaults/AdminPortAgent' => 'MyTypes::IpPortNumber',
               'DpBackupVersionModify/DpBackupTransferInfo/SourceStoragesetId' => 'MyTypes::DpBackupTransferInfo::_SourceStoragesetId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetCreate/DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
               'DpBackupVersionListIterStartResult/Records' => 'MyElements::DpBackupVersionListIterStartResult::_Records',
               'DfmScheduleDailyAdd/DailyContent/DailyInfo' => 'MyTypes::DailyInfo',
               'ProvisioningPolicyDestroy' => 'MyElements::ProvisioningPolicyDestroy',
               'DpAgentConfigure/DfmServerIpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'GroupDeleteMemberResult' => 'MyElements::GroupDeleteMemberResult',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'PerfViewModify/View/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources' => 'MyTypes::PerfDynamicDataSources',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'EventStatusChangeListIterNextResult/Events' => 'MyTypes::ArrayOfEventInfo',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DatacenterReference' => 'MyTypes::DatacenterReference',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerMigrationInfo/SourceVfilerId' => 'MyTypes::ObjId',
               'DpScheduleContentGetResult/ScheduleContentInfo/HourlyList/HourlyInfo/EndHour' => 'MyTypes::HourlyInfo::_EndHour',
               'HostListInfoIterStartResult' => 'MyElements::HostListInfoIterStartResult',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/DailyList/DailyInfo/ItemId' => 'MyTypes::DailyInfo::_ItemId',
               'DatasetComputeUsageMetric/Timestamp' => 'MyTypes::DpTimestamp',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/DaysOfMonth/DayOfMonth' => 'MyTypes::DayOfMonth',
               'SnapshotListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfo/DisabledCounterInfoOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterStart/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/BackupScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleModify/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'PerfDiagTroubleshoot/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCopy/ApplicationPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleListResult/ScheduleList' => 'MyTypes::ArrayOfScheduleIdInfo',
               'DiskListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/SortOrder' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupGetStatus' => 'MyElements::GroupGetStatus',
               'PerfDiagTroubleshoot' => 'MyElements::PerfDiagTroubleshoot',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo' => 'MyTypes::QtreeInfo',
               'ReportDesignerList' => 'MyElements::ReportDesignerList',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/PerfLabels' => 'MyTypes::ArrayOfPerfLabel',
               'TimezoneListInfoIterNextResult/Timezones/TimezoneInfo/TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DfmSnmpSettingAdd/NetworkAddress' => 'MyTypes::NetworkAddress',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'DpScheduleCreate/ScheduleContentInfo/MonthlySubscheduleList/MonthlySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos' => 'MyTypes::ArrayOfApplicationBackupInfo',
               'RbacAccessCheck/Resource/ResourceIdentifier/Vfiler/VfilerResource/VfilerId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DatacenterReference/DatacenterId' => 'MyTypes::ObjId',
               'ProvisioningPolicyEditBeginResult' => 'MyElements::ProvisioningPolicyEditBeginResult',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/StartTime/TimeOfDayInfo/Minute' => 'MyTypes::TimeOfDayInfo::_Minute',
               'HostDomainuserListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklyDeleteResult' => 'MyElements::DpScheduleWeeklyDeleteResult',
               'StorageServiceDatasetProvision/ApplicationInfo/ApplicationServerName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/AssocObjType/PerfAssocObjType' => 'MyTypes::PerfAssocObjType',
               'DpScheduleHourlyDelete/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AlarmListInfoIterStart/AlarmId' => 'MyElements::AlarmListInfoIterStart::_AlarmId',
               'DatasetResizeMemberResult' => 'MyElements::DatasetResizeMemberResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageServiceInfo/StorageServiceDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyCopyResult/ApplicationPolicyId' => 'MyTypes::ObjId',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCleanup' => 'MyElements::MigrateCleanup',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/IsDpIgnored' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/AggregateNearlyFullThreshold' => 'MyTypes::AggregateInfo::_AggregateNearlyFullThreshold',
               'DpAgentConfigureResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpAgentModify/HostserviceModifyInfo/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'RbacRoleModifyResult' => 'MyElements::RbacRoleModifyResult',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressResourcePoolInfo' => 'MyTypes::ProgressResourcePoolInfo',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectInstanceListIterNext' => 'MyElements::PerfObjectInstanceListIterNext',
               'AggregateSpaceManagementCommitResult/SpaceManagementResults/SpaceManagementResultInfo/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail' => 'MyTypes::ResultDetail',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfThresholdTemplateCreate/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/ResourcepoolPerfStatus' => 'MyTypes::ObjStatus',
               'DatasetListInfoIterStart/IncludeCanContainStorageResourcesOnly' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/HostUserId' => 'MyTypes::AccessObjectId',
               'HostUserListIterNextResult/HostUsers/HostUserInfo/Status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult/Ifcs' => 'MyTypes::ArrayOfIfcInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/CustomProvisioningScriptSettings/ScriptPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds' => 'MyTypes::ArrayOfThresholdInfo2',
               'RbacAccessCheck/Resource/ResourceIdentifier/RbacRole/RbacRoleResource/RbacRoleId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/HostIdentifier/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/DatasetId' => 'MyTypes::ObjId',
               'EventListIterNext/Maximum' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupVersionModify/BackupMetadata/DfmMetadata' => 'MyTypes::DfmMetadata',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/Comments' => 'MyTypes::ArrayOfProvisionMemberComment',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ThresholdInterval' => 'MyTypes::ThresholdInfo2::_ThresholdInterval',
               'AlarmListInfoIterNextResult/AlarmList/AlarmInfo/AlarmScriptRunas' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventAcknowledgeResult/EventsAcknowledgedList/EventActionInfo/ErrorCode' => 'MyTypes::EventActionInfo::_ErrorCode',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeOptionInfo/VolumeName' => 'MyTypes::ObjFullName',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/Datasets/DatasetReference/DatasetName' => 'MyTypes::ObjName',
               'DfmBackupStatus' => 'MyElements::DfmBackupStatus',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmGetResourcePropertyValuesResult' => 'MyElements::DfmGetResourcePropertyValuesResult',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'ApplicationPolicyDestroy/ApplicationPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/CounterDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/ThresholdValue' => 'MyTypes::ThresholdInfo::_ThresholdValue',
               'TimezoneGetDefaultsResult' => 'MyElements::TimezoneGetDefaultsResult',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/InitialSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupMetadata' => 'MyTypes::ArrayOfDfmMetadata',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'HostCapabilityListIterEnd' => 'MyElements::HostCapabilityListIterEnd',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentValue' => 'MyTypes::CommentValue',
               'RbacAccessCheck/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier' => 'MyTypes::WrapperOfVolumeResource',
               'DatasetIoMetricListInfoIterNextResult/DatasetIoMetrics/DatasetIoMetricInfo/IsOvercharge' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleCreate/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'DfmBackupStartResult' => 'MyElements::DfmBackupStartResult',
               'ResourcepoolMemberListInfoIterNext' => 'MyElements::ResourcepoolMemberListInfoIterNext',
               'ResourcepoolAddMember/MemberNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/BackupTransferInfos/DpBackupTransferInfo/DestinationBackupId' => 'MyTypes::DpBackupTransferInfo::_DestinationBackupId',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolMemberCount' => 'MyTypes::ResourcepoolInfo::_ResourcepoolMemberCount',
               'EventDelete/EventId' => 'MyElements::EventDelete::_EventId',
               'ProvisioningPolicyListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'IfcListInfoIterNextResult/Ifcs/IfcInfo/MtuSize' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Dependencies' => 'MyTypes::ArrayOfSnapshotDependency',
               'EventStatusChangeListIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerSetup/IpBindings/IpBindingInfo' => 'MyTypes::IpBindingInfo',
               'DpDashboardGetProtectedDataCounts2Result' => 'MyElements::DpDashboardGetProtectedDataCounts2Result',
               'StorageServiceListInfoIterEnd' => 'MyElements::StorageServiceListInfoIterEnd',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos/AggregateSpaceInfo/CommittedSpace' => 'MyTypes::AggregateSpaceInfo::_CommittedSpace',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment/CommentValue' => 'MyTypes::CommentValue',
               'VfilerSetup' => 'MyElements::VfilerSetup',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'PerfCounterGroupListInfo/CounterGroupName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportGraphListInfoIterNextResult/GraphList/GraphInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/EndTime' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfGetCounterListNotInViewResult/OrphanObjectCounterList/PerfObjectCounterInfo/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleListInfoIterEndResult' => 'MyElements::DpThrottleListInfoIterEndResult',
               'PerfGetCounterData/TimeFilter/Months' => 'MyTypes::ArrayOfMonth',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo' => 'MyTypes::PerfDependentCounterInfo',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Vfiler' => 'MyTypes::WrapperOfVfilerResource',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryId' => 'MyTypes::ObjId',
               'ApplicationPolicyEditBeginResult/EditLockId' => 'MyElements::ApplicationPolicyEditBeginResult::_EditLockId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/ResourcePool/ResourcePoolResource/ResourcePoolId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'PerfViewGetData/Instance/PerfCounterInstance/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdDeleteResult' => 'MyElements::PerfThresholdDeleteResult',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/VirtualMachineName' => 'MyTypes::ObjName',
               'DfmScheduleHourlyAdd/HourlyContent/HourlyInfo/EndMinute' => 'MyTypes::HourlyInfo::_EndMinute',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo/TimesOfDayInfo/EndTime' => 'MyTypes::WrapperOfTimeOfDayInfo',
               'GroupListIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleAddResult/AdminNameOrId/RbacAdminNameOrId' => 'MyTypes::RbacAdminNameOrId',
               'DatasetCreate/VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventSeverity' => 'MyTypes::ObjStatus',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors' => 'MyTypes::ArrayOfNfsSecurityFlavor',
               'LunListInfoIterNextResult/Luns/LunInfo/VolumeId' => 'MyTypes::ObjId',
               'DpAgentModify/HostserviceModifyInfo/AdminPort' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DatasetMemberDedupeStartResult' => 'MyElements::DatasetMemberDedupeStartResult',
               'PerfCounterGroupListIterNextResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterEndResult' => 'MyElements::DpBackupVersionListIterEndResult',
               'DatasetListInfoIterStart/ApplicationResourceNamespace' => 'MyTypes::ApplicationResourceNamespace',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/VfilerIdentifier' => 'MyTypes::WrapperOfVfilerResource',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Host/HostResource' => 'MyTypes::HostResource',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/DpProgressRestoreInfo/MemberId' => 'MyTypes::DpProgressRestoreInfo::_MemberId',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Comments/ProvisionMemberComment' => 'MyTypes::ProvisionMemberComment',
               'GroupSetOptions/GroupOptionInfo/GroupOwner' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource' => 'MyTypes::LunResource',
               'DatasetRemoveMemberByDynamicReference/DatasetDynamicReferenceParameters/DatasetDynamicReferenceParameter/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'DpAgentRegisterResult' => 'MyElements::DpAgentRegisterResult',
               'DatasetModify/EditLockId' => 'MyElements::DatasetModify::_EditLockId',
               'ReportScheduleEnableResult' => 'MyElements::ReportScheduleEnableResult',
               'PerfViewCreate/View/PerfView/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressStorageSystemInfo/StorageSystemId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'FcpTargetListInfoIterStart' => 'MyElements::FcpTargetListInfoIterStart',
               'DpJobScheduleGetLastChanged' => 'MyElements::DpJobScheduleGetLastChanged',
               'DfmSnmpSettingModify/PrivacyPassword' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'AggregateSpaceManagementAddOperationResult' => 'MyElements::AggregateSpaceManagementAddOperationResult',
               'DpRelationshipListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'PerfViewListIterStart' => 'MyElements::PerfViewListIterStart',
               'DpBackupVersionDelete/DeleteMultipleBackups' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobListIterNextResult/Jobs' => 'MyTypes::ArrayOfDpJobInfo',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/VolumeId' => 'MyTypes::QtreeInfo::_VolumeId',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'DfmSnmpSettingModify/SnmpId' => 'MyTypes::SnmpId',
               'VolumeModify/VolumeNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetIoMetricListInfoIterStartResult/Records' => 'MyElements::DatasetIoMetricListInfoIterStartResult::_Records',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionModify/DpBackupTransferInfo/SourceNodeId' => 'MyTypes::DpBackupTransferInfo::_SourceNodeId',
               'DatasetAddResourcepool/ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/NdmpCredentials/NdmpPort' => 'MyTypes::IpPortNumber',
               'PerfThresholdListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GraphListInfoIterNextResult' => 'MyElements::GraphListInfoIterNextResult',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleCreate' => 'MyElements::DpThrottleCreate',
               'DpOssvApplicationRestoreDestinationListInfoIterStart' => 'MyElements::DpOssvApplicationRestoreDestinationListInfoIterStart',
               'DpDashboardGetProtectedDataCountsResult/ProtectedDatasetCount' => 'MyElements::DpDashboardGetProtectedDataCountsResult::_ProtectedDatasetCount',
               'HostModify/HostModifyInfo/AdminTransport' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyModify/MonthlyContent/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'DpRelationshipListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpGetDatasetBackupJobsDataResult/DpJobsData/DpJobData/DpSnapmirrorTransferJobData/RetentionType' => 'MyTypes::DpBackupRetentionType',
               'PerfGetCounterDependentsResult/Views/PerfView/ViewName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewListIterStart/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostDomainuserRemove' => 'MyElements::HostDomainuserRemove',
               'DatasetIoMetricListInfoIterStart' => 'MyElements::DatasetIoMetricListInfoIterStart',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'HostDomainuserListIterNextResult/HostDomainusers/HostDomainuserInfo' => 'MyTypes::HostDomainuserInfo',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagErrorThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagErrorThreshold',
               'PerfThresholdModify2/ThresholdInfo2/ResourcePropertyConditions' => 'MyTypes::ArrayOfResourcePropertyCondition',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/MemberId' => 'MyTypes::ObjId',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicyDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportOutputListInfoIterStart/ReportApplication' => 'MyTypes::ReportApplication',
               'DatasetAddToExclusionListResult' => 'MyElements::DatasetAddToExclusionListResult',
               'DpOssvDirectoryBrowseIterNextResult/Records' => 'MyElements::DpOssvDirectoryBrowseIterNextResult::_Records',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldModify/CommentFieldNameOrId' => 'MyTypes::CommentFieldNameOrId',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId' => 'MyTypes::WrapperOfAggregateNameOrId',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo' => 'MyTypes::ThrottleItemInfo',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource' => 'MyTypes::LunResource',
               'DpScheduleDailyAdd/DailyContent/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'PerfThresholdModify2/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/SnapshotScheduleName' => 'MyTypes::ObjName',
               'CommentFieldListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/LunIdentifierNameOrId/LunNameOrId/LunName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator' => 'MyTypes::LunMappingInitiator',
               'DpThrottleDestroyResult' => 'MyElements::DpThrottleDestroyResult',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/ClientNameOrIp' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyAddResult' => 'MyElements::DpScheduleMonthlyAddResult',
               'DpRestoreToPrimary/Paths/DpPathInfo/MemberNameOrId' => 'MyTypes::ObjNameOrId',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerShare/EmailAddressList' => 'MyTypes::EmailAddressList',
               'StorageServiceModifyResult/ConformanceAlerts/ConformanceAlert/ConformanceAlertReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpAgentPackageListResult/DpAgentPackages/DpAgentPackageInfo/PackageId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'LdapServerListInfoResult/LdapServers/LdapServerInfo/LastFailedTime' => 'MyTypes::Timestamp',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Host/HostResource/HostId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DeleteSnapshotsRequestInfo/Snapshots/Snapshot' => 'MyTypes::Snapshot',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/DayOfMonth' => 'MyTypes::MonthlyInfo::_DayOfMonth',
               'FcpTargetListInfoIterNextResult/Targets/TargetInfo/TargetId' => 'MyTypes::ObjId',
               'ApplicationPolicyEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize' => 'MyTypes::WrapperOfQtreeSizeInfo',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/FilerIdentifier' => 'MyTypes::WrapperOfFilerResource',
               'DatasetDynamicReferenceListInfoIterStart/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressVolumeDedupeInfo/DedupeSchedule' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/ScheduleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'GroupListIterNextResult/GroupList' => 'MyTypes::ArrayOfGroupInfo',
               'HostModify/HostModifyInfo/HostDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostUsergroupCreate/HostUsergroup/HostUsergroupInfo/HostRoleIds/HostRoleId' => 'MyTypes::HostRoleId',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/LagErrorThreshold' => 'MyTypes::DpPolicyConnectionInfo::_LagErrorThreshold',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ProvisionMemberRequestInfo/InitialSnapshotSpace' => 'MyTypes::ProvisionMemberRequestInfo::_InitialSnapshotSpace',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/StoragesetName' => 'MyTypes::ObjName',
               'GroupMemberListIterNextResult/GroupMemberList/GroupMemberInfo/GroupMemberAttributes' => 'MyTypes::ArrayOfGroupMemberAttribute',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventAbout' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo' => 'MyTypes::ApplicationBackupInfo',
               'DpScheduleCreate/ScheduleContentInfo/WeeklySubscheduleList' => 'MyTypes::ArrayOfWeeklySubscheduleInfo',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/OnlineMigration' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleDailyAdd/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupGetData/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleContentGetResult/ScheduleContentInfo/MonthlyList/MonthlyInfo' => 'MyTypes::MonthlyInfo',
               'ResourcepoolModify/Resourcepool/ResourcepoolInfo/AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/SnapshotReserve' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfCounterGroupGetDynamicDataSources/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualCenterListInfoIterNextResult/VirtualCenters/VirtualCenter/DeletedBy' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ResourcepoolUpdateFreeSpaceStatus/ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
               'HostListInfoIterNextResult/Hosts/HostInfo/Licenses' => 'MyTypes::ArrayOfLicense',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/InheritedRoles' => 'MyTypes::ArrayOfRbacRoleResource',
               'PerfObjectCounterListInfo/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionListIterStart/IncludeMetadata' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdModify2/ThresholdInfo2/TemplateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleId' => 'MyTypes::ObjId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Host/HostResource' => 'MyTypes::HostResource',
               'PerfGetCounterDependentsResult/BaseCounters/PerfObjectCounter/Metrics/Metric/Period' => 'MyTypes::Metric::_Period',
               'DpAgentListInfoIterStartResult' => 'MyElements::DpAgentListInfoIterStartResult',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo' => 'MyTypes::ApplicationPolicyInfo',
               'HostListInfoIterStart/ExpandFilerToVfilers' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier' => 'MyTypes::WrapperOfAggregateResource',
               'QtreeListInfoIterNextResult/Qtrees/QtreeInfo/QtreeSize/QtreeSizeInfo/FilesUsed' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfViewAssociatedObjectsListResult/Objects/ObjectInfo/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterNextResult/Events/EventInfo/EventAcknowledged' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolListInfoIterStart/StorageReliability/ControllerFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleModify/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'DfmScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'DatasetDynamicReferenceListInfoIterStartResult' => 'MyElements::DatasetDynamicReferenceListInfoIterStartResult',
               'ReportDesignerShareResult' => 'MyElements::ReportDesignerShareResult',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/IsBackupDestinationNode' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementRollback/SpaceManagementSessionId' => 'MyElements::AggregateSpaceManagementRollback::_SpaceManagementSessionId',
               'AggregateSpaceManagementAddOperationResult/AggregateDiffSpaceInfos/AggregateSpaceInfo/AggregateName' => 'MyTypes::ObjName',
               'MigrateVolumeResult/MigrationDryRunResults/MigrationDryRunResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators' => 'MyTypes::ArrayOfLunMappingInitiator',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/AggregateOvercommittedThreshold' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedShort',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/Metrics/Metric/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ReportApplication' => 'MyTypes::ReportApplication',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/StorageReliability' => 'MyTypes::StorageReliability',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRootHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetCreate/DatasetMetadata/DfmMetadataField/FieldValue' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmNetworkModifyResult' => 'MyElements::DfmNetworkModifyResult',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId' => 'MyTypes::AggregateNameOrId',
               'EventListIterNextResult/Records' => 'MyElements::EventListIterNextResult::_Records',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/SnapshotVolumeName' => 'MyTypes::ObjFullName',
               'LdapServerDeleteResult' => 'MyElements::LdapServerDeleteResult',
               'PerfThresholdTemplateCreate/MemberThresholds/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/ThinProvision' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostListInfoIterNextResult/Hosts/HostInfo/VfilerInfo/VfilerNetworkResources/VfilerNetworkResource/InterfaceName' => 'MyTypes::ObjName',
               'PerfThresholdCreate2/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'DpAgentDiscover/ResourceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'DpOssvDirectoryBrowseIterNextResult/Subdirectories' => 'MyTypes::ArrayOfDpOssvDirectoryName',
               'PerfCopyCounterConfiguration/DestinationObjects' => 'MyTypes::ArrayOfObjNameOrId',
               'TimezoneGetDefaultsResult/TimezoneDefaults/DefaultTimezone' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/HourlyRetentionDuration' => 'MyTypes::ApplicationPolicySettingsInfo::_HourlyRetentionDuration',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/VfilerNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartHour' => 'MyTypes::MonthlyInfo::_StartHour',
               'RbacAccessCheck/AdminNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'CommentFieldValuesListInfoIterNextResult/Records' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'LdapServerListInfo/LdapServer' => 'MyTypes::LdapServer',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'UserFavoriteReportListInfoIterNextResult' => 'MyElements::UserFavoriteReportListInfoIterNextResult',
               'DpBackupListIterNextResult/Backups' => 'MyTypes::ArrayOfDpBackupInfo',
               'DpScheduleMonthlyModify/MonthlyContent' => 'MyTypes::WrapperOfMonthlyInfo',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapvaultPrimaryVolume' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LunListInfoIterNextResult/Luns/LunInfo/Igroups/IgroupReference/IgroupName' => 'MyTypes::ObjName',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/ChartName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminListInfoIterNext/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetAddToExclusionList/ObjectsToBeAdded/ObjNameOrId' => 'MyTypes::ObjNameOrId',
               'GraphListInfoIterNextResult/Graphs/GraphInfo/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportListInfoIterNextResult' => 'MyElements::ReportListInfoIterNextResult',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/ThresholdUnit' => 'MyTypes::CounterUnit',
               'DpScheduleMonthlySubscheduleSet/MonthlyScheduleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleWeeklySubscheduleDeleteResult' => 'MyElements::DpScheduleWeeklySubscheduleDeleteResult',
               'DpThrottleRename/ThrottleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetSetStorageset/DpNodeName' => 'MyTypes::DpPolicyNodeName',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/NfsSecurityFlavors/NfsSecurityFlavor' => 'MyTypes::NfsSecurityFlavor',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList' => 'MyTypes::ArrayOfMonthlyInfo',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/EventId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/MemberThresholds/ThresholdInfo2/ObjectsInfo/ObjectInfo/ObjectId' => 'MyTypes::ObjId',
               'ProvisioningPolicyListIterNextResult/ProvisioningPolicies/ProvisioningPolicyInfo/NasContainerSettings/DefaultGroupQuota' => 'MyTypes::NasContainerSettings::_DefaultGroupQuota',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult' => 'MyTypes::DryRunResult',
               'StorageServiceDatasetListIterNextResult/StorageServiceDatasetsInfo/StorageServiceDatasetInfo/DatasetId' => 'MyTypes::ObjId',
               'DpScheduleModify/ScheduleContentInfo/MonthlyList/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/LineName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotListInfoIterEndResult' => 'MyElements::SnapshotListInfoIterEndResult',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo/LunMappingInitiators/LunMappingInitiator/InitiatorId' => 'MyTypes::InitiatorId',
               'DfmScheduleModify/ScheduleContentInfo/WeeklyList/WeeklyInfo/ItemId' => 'MyTypes::WeeklyInfo::_ItemId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/HostIdentifier/HostResource' => 'MyTypes::HostResource',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts/NfsExportHost/IsAnException' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleItemAdd/ThrottleItemContent/ThrottleItemInfo/DayList' => 'MyTypes::ArrayOfDayInfo',
               'DpBackupStart/BackupDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/ObjectName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyGetDefaultPropertyValuesResult/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpThrottleModify/ThrottleContent/ThrottleDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleAdminInfoList' => 'MyElements::RbacRoleAdminInfoList',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetUpdateDrStatus' => 'MyElements::DatasetUpdateDrStatus',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/CounterInfo/PerfObjectCounter/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCopyCounterConfigurationResult/CopyResult/DestinationHostInfo/HostId' => 'MyTypes::ObjId',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/VmwareBackupScheduleSettingsInfo/IncludeIndependentDisks' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/TimezoneName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpOssvDirectoryDiscoveredIterEnd' => 'MyElements::DpOssvDirectoryDiscoveredIterEnd',
               'PerfThresholdTemplateModify/MemberThresholds/ThresholdInfo2/ResourcePropertyConditions/ResourcePropertyCondition/Value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventListIterStart/GreaterThanId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo' => 'MyTypes::BackupGraphResourceInfo',
               'EventDelete/EventIdList' => 'MyTypes::ArrayOfEventIdType',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier/HostResource/HostName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetExclusionListInfoIterNextResult/ExclusionList/ExcludedObjectInfo' => 'MyTypes::ExcludedObjectInfo',
               'DpOssvApplicationListInfoIterNextResult/OssvApplicationList/OssvApplicationInfo/Name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAccessCheck/Resource/ResourceIdentifier/Aggregate/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostDpInfo/Datasets/DatasetReference' => 'MyTypes::DatasetReference',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/StorageReliability/ControllerFailure' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/BaseCounters' => 'MyTypes::ArrayOfPerfObjectCounter',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo/DeletedTimestamp' => 'MyTypes::DpTimestamp',
               'MigrateVolume/DryRun' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'QtreeListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId' => 'MyTypes::QtreeNameOrId',
               'HostListInfoIterNext' => 'MyElements::HostListInfoIterNext',
               'DatasetDynamicReferenceListInfoIterNextResult/DatasetDynamicReferences/DatasetDynamicReferenceInfo/IsDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleWeeklyAdd/WeeklyContent/WeeklyInfo/StartHour' => 'MyTypes::WeeklyInfo::_StartHour',
               'RbacRoleAdminInfoListResult/AdminNameOrId' => 'MyTypes::WrapperOfRbacAdminNameOrId',
               'PerfCounterGroupListInfo/ConsolidateHosts' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfAssocViewListIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'ViHypervisorListInfoIterStartResult/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DatasetDynamicReferenceListInfoIterStart/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DfmScheduleHourlyModify' => 'MyElements::DfmScheduleHourlyModify',
               'PerfThresholdListInfoIterStart/Query/ThresholdInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'PerfThresholdCreate/ThresholdInfo/ThresholdValue' => 'MyTypes::ThresholdInfo::_ThresholdValue',
               'RbacAccessCheck/Resource/ResourceIdentifier/Group/GroupResource/GroupId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'StorageServiceListInfoIterNextResult/StorageServices/StorageServiceInfo/StorageServiceNodes/StorageServiceNodeInfo/Resourcepools/ResourcepoolInfo/ResourcepoolPerfStatus' => 'MyTypes::ObjStatus',
               'AlarmModify/AlarmInfo/EventName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Volume/VolumeResource/HostIdentifier' => 'MyTypes::WrapperOfHostResource',
               'DpScheduleHourlyDelete/ItemId' => 'MyElements::DpScheduleHourlyDelete::_ItemId',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/ObjectType' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetModifyNode/DatasetExportInfo' => 'MyTypes::DatasetExportInfo',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Operation/RbacOperation/OperationNameDetails/RbacOperationNameDetails' => 'MyTypes::RbacOperationNameDetails',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/ItemId' => 'MyTypes::MonthlyInfo::_ItemId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/AggregateIdentifier/AggregateResource' => 'MyTypes::AggregateResource',
               'PerfThresholdTemplateListInfoIterNextResult/ThresholdTemplates/ThresholdTemplateInfo/AppliedObjects/ObjectInfo' => 'MyTypes::ObjectInfo',
               'HostUserListIterNextResult' => 'MyElements::HostUserListIterNextResult',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/HypervisorReference' => 'MyTypes::HypervisorReference',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/HourlyList/HourlyInfo/StartMinute' => 'MyTypes::HourlyInfo::_StartMinute',
               'HostRoleCreateResult' => 'MyElements::HostRoleCreateResult',
               'ReportDesignerScheduleModify' => 'MyElements::ReportDesignerScheduleModify',
               'VolumeResizeResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'ResourcepoolListInfoIterNextResult/Resourcepools/ResourcepoolInfo/ResourcepoolKbytesTotal' => 'MyTypes::ResourcepoolInfo::_ResourcepoolKbytesTotal',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/DatasetsSpaceInfo/DatasetSpaceInfo/UsedSpace' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedLong',
               'DpRestoreViStart/DpViRestoreObjects/DpViRestoreObject/DpViObjectRestoreSettings' => 'MyTypes::DpViObjectRestoreSettings',
               'VfilerSetup/RunCifsSetup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AggregateSpaceManagementCommitResult/AggregateSpaceInfos/AggregateSpaceInfo/AggregateName' => 'MyTypes::ObjName',
               'AggregateSpaceManagementAddOperation/SpaceManagementOperationInfo/SnapshotDeletionRequestInfo/Snapshots/Snapshot/UniqueId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewListIterNextResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource/InstanceName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleDependencyResult' => 'MyElements::DpThrottleDependencyResult',
               'DpScheduleModify/ScheduleContentInfo/IsModifiable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/DataSource/PerfDataSource' => 'MyTypes::PerfDataSource',
               'DfmScheduleMonthlyAdd/MonthlyContent/MonthlyInfo/StartMinute' => 'MyTypes::MonthlyInfo::_StartMinute',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/QtreeIdentifierNameOrId/QtreeNameOrId/QtreeName' => 'MyTypes::ObjName',
               'DpJobListIterNextResult/Jobs/DpJobInfo/DestinationNodeId' => 'MyTypes::DpJobInfo::_DestinationNodeId',
               'ViHypervisorListInfoIterNextResult/Hypervisors/Hypervisor/DatacenterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ApplicationPolicyModify' => 'MyElements::ApplicationPolicyModify',
               'DatasetModifyNode/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRoHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'PerfViewListIterNextResult/Views/PerfView/AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
               'ResourcepoolMemberListInfoIterNextResult/ResourcepoolMembers/ResourcepoolMemberInfo/ResourceTag' => 'MyTypes::ResourceTag',
               'PerfGetCounterData/InstanceCounterInfo/CounterInfo' => 'MyTypes::ArrayOfPerfObjectCounter',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/ResourcepoolName' => 'MyTypes::ObjName',
               'DpJobPurge/JobId' => 'MyElements::DpJobPurge::_JobId',
               'ApplicationPolicyEditBeginResult' => 'MyElements::ApplicationPolicyEditBeginResult',
               'EventDeleteResult/EventsDeletedList/EventActionInfo' => 'MyTypes::EventActionInfo',
               'DatasetMissingMemberListInfoIterNextResult/MissingMembers/MissingMemberInfo' => 'MyTypes::MissingMemberInfo',
               'ResourcepoolListInfoIterNextResult/Records' => 'MyElements::ResourcepoolListInfoIterNextResult::_Records',
               'ApplicationPolicyCreate/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo' => 'MyTypes::WeeklySubscheduleInfo',
               'PerfCounterGroupGetData' => 'MyElements::PerfCounterGroupGetData',
               'PerfGetCounterDependents/Counters/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'TimezoneListInfoIterStart' => 'MyElements::TimezoneListInfoIterStart',
               'RbacAdminRoleAdd/RoleNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics/Metric/Slide' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'MigrateCompleteResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfGetCounterDependentsResult/Views/PerfView/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/SpaceInfo' => 'MyTypes::SpaceInfo',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'DfmScheduleModify/ScheduleContentInfo/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceCreate/ProtectionPolicyNameOrId' => 'MyTypes::ObjNameOrId',
               'DpThrottleItemAddResult' => 'MyElements::DpThrottleItemAddResult',
               'PerfThresholdTemplateDetachObjects/Objects/ObjectInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'AuditLogAddEntry/AuditInterface' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'PerfGetCounterDependentsResult/Views/PerfView/Charts/PerfChart/DynamicDataSources/PerfDynamicDataSources/MaximumInstances' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'LunListInfoIterNextResult/Records' => 'MyElements::LunListInfoIterNextResult::_Records',
               'DfmScheduleDailyAdd/DailyContent/DailyInfo/StartMinute' => 'MyTypes::DailyInfo::_StartMinute',
               'DpPolicyEditCommit' => 'MyElements::DpPolicyEditCommit',
               'AlarmTest' => 'MyElements::AlarmTest',
               'FcpTargetListInfoIterStartResult/Records' => 'MyElements::FcpTargetListInfoIterStartResult::_Records',
               'MigrateStart/Description' => 'MyElements::MigrateStart::_Description',
               'PerfCounterGroupListInfoResult/CounterGroups/PerfCounterGroup/DataSourcesToBeDisabled/PerfDataSource/CounterName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostRoleListIterStartResult' => 'MyElements::HostRoleListIterStartResult',
               'MigrateStart/IpBindings/IpBindingInfo/PrefixLength' => 'MyTypes::IpBindingInfo::_PrefixLength',
               'GraphListInfoIterStartResult' => 'MyElements::GraphListInfoIterStartResult',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'MigrateRollbackResult' => 'MyElements::MigrateRollbackResult',
               'DpDashboardGetLaggedDatasets/GroupNameOrId' => 'MyTypes::GroupNameOrId',
               'StorageServiceDatasetProvision/StorageSetDetails/StorageSetInfo/DatasetAccessDetails/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ApplicationInfo/ApplicationVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetAccessDetails/IpAddress' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'VfilerTemplateCreate/VfilerTemplate/VfilerTemplateInfo/DnsDomain' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterNextResult/Views/PerfView/AssocObjType' => 'MyTypes::ArrayOfPerfAssocObjType',
               'PerfViewObjectAssociationAddResult' => 'MyElements::PerfViewObjectAssociationAddResult',
               'MigrateRollbackResult/DryRunResults/DryRunResult/DryRunEffect' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ViVirtualMachineListInfoIterStart' => 'MyElements::ViVirtualMachineListInfoIterStart',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/ResizeMemberRequestInfo/MemberName' => 'MyTypes::ObjName',
               'PerfViewListIterStartResult' => 'MyElements::PerfViewListIterStartResult',
               'DpAgentPackageAdd/PackageVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfObjectListInfo' => 'MyElements::PerfObjectListInfo',
               'VolumeDedupeResult' => 'MyElements::VolumeDedupeResult',
               'DfmScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/DailyList/DailyInfo/StartHour' => 'MyTypes::DailyInfo::_StartHour',
               'DpBackupListIterStart/SubPath' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'ReportDesignerScheduleDelete' => 'MyElements::ReportDesignerScheduleDelete',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeStatus' => 'MyTypes::ObjStatus',
               'DfmScheduleContentGetResult/ScheduleContentInfo/MonthlySubscheduleList' => 'MyTypes::ArrayOfMonthlySubscheduleInfo',
               'GroupIsMemberOf/ObjectNameOrId' => 'MyTypes::ObjectNameOrId',
               'MigrateStartResult/DryRunResults/DryRunResult/DryRunReasonDetails' => 'MyTypes::ArrayOfResultDetail',
               'StorageServiceDatasetListIterEndResult' => 'MyElements::StorageServiceDatasetListIterEndResult',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/IsSnapvaultSecondaryCapable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportGraphListInfoIterEnd/Tag' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'UserFavoriteReportListInfoIterStartResult/Records' => 'MyElements::UserFavoriteReportListInfoIterStartResult::_Records',
               'DpRestoreToNewPathResult/SpaceStatusResults/SpaceStatusResult/DestVol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAdd' => 'MyElements::HostAdd',
               'ViDatastoreListInfoIterNextResult/Datastores/Datastore/DatacenterReference/DatacenterName' => 'MyTypes::ObjName',
               'DpPolicyEditRollback' => 'MyElements::DpPolicyEditRollback',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/VolumeQtreeNamePrefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyListIterNextResult/DpPolicyInfos/DpPolicyInfo/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/WeeklyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_WeeklyRetentionDuration',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier' => 'MyTypes::ResourceIdentifier',
               'PerfThresholdCreate/ThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel' => 'MyTypes::PerfLabel',
               'DpScheduleModify/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'PerfCounterGroupModify/ApplianceNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfDisableDataCollection/IsPersistent' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfObjectDependentCounterListInfoResult/DependentCounters/PerfDependentCounterInfo/ObjectCounters/PerfObjectCounter/IsCalculatedStats' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetMap/DatasetMapEntry/DatasetAccessDetails' => 'MyTypes::DatasetAccessDetails',
               'RbacRoleAdminInfoListResult/LocalUsergroupStatus' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/CounterInfo/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfViewCreate' => 'MyElements::PerfViewCreate',
               'HostListInfoIterEndResult' => 'MyElements::HostListInfoIterEndResult',
               'PerfThresholdTemplateListInfoIterStart' => 'MyElements::PerfThresholdTemplateListInfoIterStart',
               'DpBackupVersionCreate/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/PrimaryId' => 'MyTypes::ObjId',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/HostServiceObjectId' => 'MyTypes::HostServiceUniqueId',
               'PerfCopyCounterConfigurationResult/PurgedHostObjectCounters/PerfPurgedHostObjectCounter/PurgedObjectCountersDetails/PerfPurgedObjectCountersDetails/PurgedObjectCounters/PerfObjectCounter/Metrics/Metric' => 'MyTypes::Metric',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/VersionMembers/VersionMemberInfo/SnapshotContents/SnapshotMemberInfo/SecondaryQtreeId' => 'MyTypes::ObjId',
               'DatasetEditCommitResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Reason' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdCreate/ThresholdInfo/ObjectFullName' => 'MyTypes::ObjFullName',
               'ApplicationPolicyModify/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/LagWarningThreshold' => 'MyTypes::ApplicationPolicySettingsInfo::_LagWarningThreshold',
               'DpRestoreViStart/DpViRestoreSettings/RestoreScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyCopy' => 'MyElements::DpPolicyCopy',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/NasContainerSettings/StorageContainerType' => 'MyTypes::StorageContainerType',
               'ViVirtualMachineListInfoIterNextResult/VirtualMachines/VirtualMachine/HypervisorReference/HypervisorName' => 'MyTypes::ObjName',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId/VolumeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/ToNodeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpScheduleMonthlyAdd' => 'MyElements::DpScheduleMonthlyAdd',
               'DpRestoreToPrimary/BackupId' => 'MyElements::DpRestoreToPrimary::_BackupId',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ProtectionStatusProblems/ProtectionStatusProblem/ProtectionStatusDescription' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds' => 'MyTypes::ArrayOfCounterThresholdInfo',
               'ReportScheduleListInfoIterStart/IsEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewGetData/Instance/PerfCounterInstance/CounterInfo/PerfObjectCounter/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfAssocViewListIterStart/IncludeEmptyViews' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpScheduleList/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/NewPrimaryMemberName' => 'MyTypes::ObjName',
               'ResourcepoolCreate/Resourcepool/ResourcepoolInfo/ResourcepoolName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacAdminRoleAdd' => 'MyElements::RbacAdminRoleAdd',
               'VfilerTemplateCopyResult/VfilerTemplateId' => 'MyTypes::ObjId',
               'CommentFieldValuesListInfoIterStart/ObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Volume/VolumeResource/AggregateIdentifier/AggregateResource/AggregateResourceNameOrId/AggregateNameOrId/AggregateId' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'LdapServerAddResult' => 'MyElements::LdapServerAddResult',
               'PerfCounterGroupCreate/CounterGroup/PerfCounterGroup/IsDisableAll' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfThresholdListInfo2IterNextResult/AttributesList/ThresholdInfo2/CounterThresholds/CounterThresholdInfo/PerfObjectCounter/PerfLabels/PerfLabel/LabelNames' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'HostAdd/AdminPort' => 'MyElements::HostAdd::_AdminPort',
               'DpBackupListIterNextResult/Backups/DpBackupInfo/ApplicationBackupInfos/ApplicationBackupInfo/BackupGraphInfo/GraphResources/BackupGraphResourceInfo/ApplicationResourceProperties' => 'MyTypes::ArrayOfPropertyInfo',
               'DpPolicyModify/DpPolicyContent/DpPolicyConnections/DpPolicyConnectionInfo/IsLagErrorEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'AlarmCreate/AlarmInfo/AlarmScript' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleCapabilityRemove/Resource/ResourceIdentifier/Lun/LunResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource/VfilerNameOrUuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdTemplateDetachObjects' => 'MyElements::PerfThresholdTemplateDetachObjects',
               'RbacRoleCapabilityAdd/Resource/ResourceIdentifier/Vfiler' => 'MyTypes::WrapperOfVfilerResource',
               'PerfGetCounterDependents/Counters/PerfObjectCounter' => 'MyTypes::PerfObjectCounter',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsProtocolVersion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpBackupVersionCreateResult' => 'MyElements::DpBackupVersionCreateResult',
               'DpScheduleContentGetResult' => 'MyElements::DpScheduleContentGetResult',
               'ProvisioningPolicyListIterNextResult/Records' => 'MyElements::ProvisioningPolicyListIterNextResult::_Records',
               'RbacRoleInheritResult' => 'MyElements::RbacRoleInheritResult',
               'ResourcepoolMemberListInfoIterStart/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts/NfsExportHost' => 'MyTypes::NfsExportHost',
               'DatasetReplacePrimaryMembersResult/ReplaceResults/ReplaceResult/NewPrimaryMemberId' => 'MyTypes::ObjId',
               'DpScheduleContentGet/ScheduleCategory' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventStatusChangeListIterNextResult/Events/EventInfo/EventSourceId' => 'MyTypes::EventInfo::_EventSourceId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressIgroupConfigInfo/IgroupId' => 'MyTypes::ObjId',
               'DatasetProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetNfsExportSetting/NfsExportRwHosts' => 'MyTypes::ArrayOfNfsExportHost',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressAggregateInfo/AggregateId' => 'MyTypes::ObjId',
               'HostUserModify/HostUser/HostUserInfo/HostUsergroupNames/HostUsergroupName' => 'MyTypes::HostUsergroupName',
               'DpScheduleListResult/ScheduleList/ScheduleIdInfo/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'EventGenerate' => 'MyElements::EventGenerate',
               'DpPolicyModify/DpPolicyContent/DpPolicyNodes/DpPolicyNodeInfo/MonthlyRetentionDuration' => 'MyTypes::DpPolicyNodeInfo::_MonthlyRetentionDuration',
               'DpPolicyGetDefaultPropertyValuesResult/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList/WeeklyInfo/StartMinute' => 'MyTypes::WeeklyInfo::_StartMinute',
               'RbacAccessCheck/Resource/ResourceIdentifier/Volume/VolumeResource/VolumeIdentifierNameOrId' => 'MyTypes::WrapperOfVolumeNameOrId',
               'ReportDesignerScheduleAdd/ScheduleContentInfo/WeeklySubscheduleList/WeeklySubscheduleInfo/SubscheduleName' => 'MyTypes::ObjName',
               'PerfClientStatsListInfoIterNextResult/HostsClientStats/HostClientStats/Stats/ClientStats/NfsOpStats' => 'MyTypes::NfsOpStats',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationBackupOperationInfo/BackupSchedules/ApplicationBackupScheduleInfo/SimpleScheduleInfo' => 'MyTypes::SimpleScheduleInfo',
               'MigrateRollbackResult/JobId' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'PerfThresholdListInfo2IterEndResult' => 'MyElements::PerfThresholdListInfo2IterEndResult',
               'PerfViewCreate/View/PerfView/Charts/PerfChart/Lines/PerfLine/DataGroup/PerfDataGroup/DataSources/PerfDataSource/GroupNameOrId' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VolumeIdentifierNameOrId/VolumeNameOrId' => 'MyTypes::VolumeNameOrId',
               'ResourcepoolGetDefaultsResult/ResourcepoolDefaults/ResourcepoolFullThreshold' => 'MyTypes::ResourcepoolDefaults::_ResourcepoolFullThreshold',
               'GroupIsMemberOfResult/IsMember' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfViewAssociatedObjectsListResult/Objects' => 'MyTypes::ArrayOfObjectInfo',
               'AggregateListInfoIterNextResult/Aggregates/AggregateInfo/FilerId' => 'MyTypes::AggregateInfo::_FilerId',
               'PerfThresholdCreate2Result' => 'MyElements::PerfThresholdCreate2Result',
               'DatasetMemberListInfoIterNextResult/DatasetMembers/DatasetMemberInfo/NfsExportRules/DisableSetuid' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'LunListInfoIterNextResult/Luns/LunInfo' => 'MyTypes::LunInfo',
               'PerfCounterGroupGetDynamicDataSources/DynamicDataSources/PerfDynamicDataSources/Color' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DpThrottleListInfoIterNextResult/ThrottleList/ThrottleContent/ThrottleItemList/ThrottleItemInfo/DayList' => 'MyTypes::ArrayOfDayInfo',
               'DpBackupStart/HypervBackupSettingsInfo/HypervBackupScheduleSettingsInfo/AllowSavedStateBackup' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpOssvDirectoryRootsIterEndResult' => 'MyElements::DpOssvDirectoryRootsIterEndResult',
               'ReportDesignerShare/TargetObjectNameOrId' => 'MyTypes::ObjNameOrId',
               'VolumeListInfoIterStart/IncludeIsAvailable' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/DatasetExportInfo/DatasetLunMappingInfo' => 'MyTypes::DatasetLunMappingInfo',
               'GroupMove/ParentGroupNameOrId' => 'MyTypes::GroupNameOrId',
               'PerfGetCounterDataResult/InvalidCounterInstances/InvalidCounterInstance/CounterInfo/PerfObjectCounter/Metrics' => 'MyTypes::ArrayOfMetric',
               'EventDeleteResult/EventDeleted' => 'SOAP::WSDL::XSD::Typelib::Builtin::unsignedInt',
               'ProvisioningPolicyCreate/ProvisioningPolicyInfo/DedupeEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpBackupVersionCreate/DatasetNameOrId' => 'MyTypes::ObjNameOrId',
               'DpScheduleListInfoIterNextResult/ScheduleContentList/ScheduleContentInfo/ScheduleId' => 'MyTypes::ObjId',
               'HostListInfoIterNextResult/Hosts/HostInfo/HostPerfInfo/SpaceProjected' => 'SOAP::WSDL::XSD::Typelib::Builtin::integer',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunInfo/LunName' => 'MyTypes::ObjFullName',
               'SnapshotListInfoIterNextResult/Snapshots/SnapshotInfo/Backups' => 'MyTypes::ArrayOfBackupInfo',
               'DpAgentConfigure/StorageSystemsConfiguration/StorageSystemConfiguration/StorageSystemNameOrId' => 'MyTypes::ObjNameOrId',
               'QtreeListInfoIterStart/SortResults' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ReportCategoryListResult' => 'MyElements::ReportCategoryListResult',
               'DfmGetApiStatisticsResult/ApiStatistics/ApiStat' => 'MyTypes::ApiStat',
               'StorageServiceDatasetProvision/IncludeDryRunReasonDetails' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation' => 'MyTypes::RbacResourceOperation',
               'DatasetModifyNode/ResourcepoolNameOrId' => 'MyTypes::ObjNameOrId',
               'DpJobProgressEventListIterNextResult/ProgressEvents/DpJobProgressEventInfo/ProgressLunMapInfo' => 'MyTypes::ProgressLunMapInfo',
               'DatasetCreate/DatasetMetadata' => 'MyTypes::ArrayOfDfmMetadataField',
               'DpOssvDirectoryDiscoveredIterStart/IsInDataset' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'PerfGetCounterDependentsResult/DependentCounters/PerfObjectCounter/Metrics/Metric/Type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'StorageServiceDatasetProvision/ProvisionMember/ProvisionMemberRequestInfo/Description' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'RbacRoleInfoListResult/RoleAttributes/RoleAttributesIdentifier/Capabilities/RbacResourceOperation/Resource/ResourceIdentifier/Qtree/QtreeResource/VolumeIdentifier/VolumeResource/VfilerIdentifier/VfilerResource' => 'MyTypes::VfilerResource',
               'DatasetListInfoIterNextResult/Datasets/DatasetInfo/DatasetStatus/ConformanceCheckResults/ConformanceRunResult/ConformanceRunReasonDetails/ResultDetail/Suggestion' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'SnapshotGetReclaimableInfoResult/SnapshotSharedData' => 'MyElements::SnapshotGetReclaimableInfoResult::_SnapshotSharedData',
               'ApplicationPolicyListIterNextResult/ApplicationPolicies/ApplicationPolicyInfo/ApplicationPolicySettingsInfo/IsLagWarningEnabled' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'ProvisioningPolicyModify/ProvisioningPolicyInfo/NasContainerSettings/AutoGrowCapacity' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'DpJobProgressEventListIterStart/StartTime' => 'MyTypes::DpTimestamp',
               'StorageServiceDatasetModifyResult/DryRunResults/DryRunResult/DryRunReasonDetails/ResultDetail/Severity' => 'MyTypes::ObjStatus',
               'StorageServiceDatasetListIterEnd' => 'MyElements::StorageServiceDatasetListIterEnd',
               'QtreeListInfoIterNextResult/Qtrees' => 'MyTypes::ArrayOfQtreeInfo',
               'ReportScheduleListInfoIterNextResult/ReportScheduleList/ReportScheduleContentInfo/ScheduleName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfThresholdListInfoIterNextResult/AttributesList/ThresholdInfo/PerfObjectCounter/Metrics/Metric/Id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'DfmScheduleContentGetResult/ScheduleContentInfo' => 'MyTypes::ScheduleContentInfo',
               'DfmScheduleContentGetResult/ScheduleContentInfo/WeeklyList' => 'MyTypes::ArrayOfWeeklyInfo',
               'SrmFileTypeListInfoResult/SrmFileTypes/SrmFileTypeInfo/SrmFileTypeName' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'PerfCounterGroupModify/CounterGroup/PerfCounterGroup/IsDefault' => 'SOAP::WSDL::XSD::Typelib::Builtin::boolean',
               'HostUserModify/HostUser/HostUserInfo/HostUserId' => 'MyTypes::AccessObjectId',
               'HostListInfoIterStart/LicenseFilter/License' => 'MyTypes::License',
               'VolumeListInfoIterNextResult/Volumes/VolumeInfo/VolumeDedupeInfo/LastDedupeScannedSize' => 'MyTypes::VolumeDedupeInfo::_LastDedupeScannedSize',
               'EventListIterStart/ObjectManagementFilter' => 'MyTypes::ObjectManagementInterface',
               'DpJobListIterNextResult/Jobs/DpJobInfo/ProvisionRequestInfo/DestroyMemberRequestInfo/MemberName' => 'MyTypes::ObjFullName',
               'ReportOutputListInfoIterNextResult' => 'MyElements::ReportOutputListInfoIterNextResult',
               'HostModify/HostModifyInfo/NdmpCredentials/NdmpUsername' => 'MyTypes::NdmpUsername'
             };
;

sub get_class {
  my $name = join '/', @{ $_[1] };
  return $typemap_1->{ $name };
}

sub get_typemap {
    return $typemap_1;
}

1;

__END__

__END__

=pod

=head1 NAME

MyTypemaps::DfmService - typemap for DfmService

=head1 DESCRIPTION

Typemap created by SOAP::WSDL for map-based SOAP message parsers.

=cut

