#$Id: //depot/prod/test/Rsierranevada/lib/RaidSqa.pm#1 $
##
## @summary RaidSqa.pm - RAID SQA library for commands and utilities
##
## @status TESTME
##
## @author skg@netapp.com 
## @change 2009-04-03 Divya.Srinivas@netapp.com: function "RaidSqa_aggr_media_scrub_start", "RaidSqa_aggr_media_scrub_status"## , "RaidSqa_aggr_media_scrub_stop"
## 
## @change 2009-04-03 sukesh@netapp.com: function "RaidSqa_disk_remove", "RaidSqa_check_disk_fsm_state"
## @change 2009-04-08 skg@netapp.com: Fixed typo from chsum to cksum in function RaidSqa_get_scrub_report_by_group
## @change 2009-04-10 amrita@netapp.com: Enhanced function "RaidSqa_aggr_scrub_status" to handle verbose option(-v)
## @change 2009-04-13 skg@netapp.com: Added RaidSqa_filer_cmd function to run any filer command which does not not expect any o/p
## @change 2009-04-13 skg@netapp.com: Removed hardcodes console connection from media_scrub_enable and _disable function
## @change 2009-04-15 gdeepa@netapp.com: Modified function "RaidSqa_aggr_create" for equal disk list and 
##					 even disk count error scenario for mirrored aggregate
##
## @change 2009-04-15 puneetp@netapp.com: Modified RaidSqa_aggr_create for handling disk size input and for handling negative##                                        cases when creating an aggregate with already existing aggregate name and creating
##                                        an aggregate with invalid disk-size
## @change 2009-05-12 narsimha@netapp.com:Modified the RaidSqa_get_group_list() to handle NULL aggr_obj and NULL plex_obj situations. RaidSqa_aggr_scrub_start,RaidSqa_aggr_scrub_suspend,RaidSqa_aggr_scrub_stop,RaidSqa_aggr_scrub_resume subroutines dependent on  RaidSqa_get_group_list() have been modified to handle this situation
## @change 2009-05-12 sujathat@netapp.com:Modified the subroutine RaidSqa_aggr_undestroy to support interactive mode
## @change 2009-05-20 sridhars@netapp.com:Modified RaidSqa_aggr_add subroutine to return output value along with the execution status, as the output messages are required for validation
## @change 2009-05-26 sujathat@netapp.com:Reverted back the changes done with respect to burt number 359153 in subroutine RaidSqa_aggr_undestroy
##
## @change 2009-09-16 bhoomika@netapp.com: Added library functions to implement IOC on root feature and some supporting functions like RaidSqa_create_temproot_vol(),RaidSqa_get_setup_information(),RaidSqa_get_invalid_diskid(), RaidSqa_temp_rootvol_verify(),RaidSqa_check_ioc_support(),RaidSqa_verify_root_aggr_vol_spare_disks(),RaidSqa_setup(),RaidSqa_aggr_set_as_root()
##
## @change 2009-09-24 nazir.ebrahim@netapp.com: fixed to run RaidSqa_create_temproot_vol for failure condition
## @change 2009-09-24 skg@netapp.com: modified _aggr_verify_start and _wait_for_verify_completion
## @change 2009-10-20 thontesh@netapp.com: Added the package declaration for RaidSqa.pm -  "package RaidSqa;"
## @change 2009-10-23 sajitha@netapp.com: Modified the subroutine RaidSqa_check_raid_size_valid_range with respect to the burt 383692"
## @change 2009-10-26 ritu.mathur@netapp.com: Modified RaidSqa_nv_trash function with respect to burt 383475.
## @change 2009-10-27 kuppam@netapp.com: Added library function to get the disk list based on the checksum type.
## @change 2009-11-02 kuppam@netapp.com: Changed RaidSqa_filer_cmd() to take options field during the filer cmd execution.
## @change 2009-11-10 sajitha@netapp.com: Burt 386492 Replaced 'context_parity_valid' with 'context_parity_protected'
## @change 2009-11-11 kuppam@netapp.com: Edited the function RaidSqa_aggr_wafliron_status() to collect the output of the say command.
## @change 2009-11-16 ritu.mathur@netapp.com: Burt 387110: Added subroutine RaidSqa_get_disk_storage_type.
## @change 2009-11-16 ritu.mathur@netapp.com: Burt 387110: Added subroutine RaidSqa_media_error_inject.
## @change 2009-11-30 melan.singh@netapp.com: Burt 389380: Added support for 'count' parameter in RaidSqa_dd function.
## @change 2009-11-30 pravin.salgond@netapp.com: Burt 385894: Added package declaration to RaidSqa.pm and Exported all the functions of raidsqa
##@change 2009-12-7 sowmya.krishnamurthy@netapp.com: Burt 390189: Added subroutine RaidSqa_get_disk_rgdn.
## @change 2009-12-07 sajitha@netapp.com: Burt 389855: Added subroutine RaidSqa_check_disk_block_is_zeroed_out.
## @change 2009-12-15 thontesh@netapp.com: Burt 385894: Modified to handle the issues after making RaidSqa package. Moved the library importing statements inside BEGIN block.
# @burt 381953 TW-RAID initial interaction tracking BURT
## @change 2010-01-06 kuppam@netapp.com: Burt 393285: Edited the function RaidSqa_aggr_media_scrub_status() to have one more parameter disk_name to get the media scrub status on a given disk.
## @change 2010-01-06 kuppam@netapp.com: Given wrong burtId in the above change comment,hence edited for correct burtid.
## @change 2010-01-13 sajitha@netapp.com: Burt 394392: Added subroutine RaidSqa_check_group_reparity_in_progress
## @change 2010-01-13 ritu.mathur@netapp.com: Burt 394339: Modified subroutine RaidSqa_filer_cmd to support multiple arguments to say function.
## @change 2010-02-01 pravin.salgond@netapp.com: Burt 385894 : Added five functions RaidSqa_get_aggr_raid_lw_enabled, RaidSqa_get_aggr_raid_lw_allowed, RaidSqa_get_group_raid_lw_scrub,RaidSqa_check_aggr_lw_flags, RaidSqa_check_group_lw_flags.
## @change 2010-03-08 pravin.salgond@netapp.com: Burt 386292 : Added one function RaidSqa_get_group_scrub_suspended_block
## @change 2010-03-11 Malleshwar.Rao@netapp.com: Burt 386292 : Added one function RaidSqa_get_disk_offline_ref_count
## @change 2010-03-18 thontesh@netapp.com: Burt: 244854 Modified RaidSqa_wait_for_plex_resync_completion after the burt 244854 fix 
## @change 2010-03-18 sajitha@netapp.com: Burt 386292 Added subroutines to perform upgrade/revert operations
## @change 2010-03030 ritu.mathur@netapp.com: Burt 399098 Added RaidSqa_find_active_path_disk_name to EXPORTER list. 
## @change 2010-04-01 sajitha@netapp.com: Burt 394392: Added subroutine RaidSqa_disk_replace_start
## @change 2010-04-08 akanksha.sharma@netapp.com: Burt 406389: Added subroutine RaidSqa_take_mirror_to
## @change 2010-04-08 akanksha.sharma@netapp.com: Burt 406389: Added subroutine RaidSqa_get_one_plex_of_state
## @change 2010-04-09 akanksha.sharma@netapp.com: Burt 406927: Added subroutine RaidSqa_get_bypassed_disk_list 
## @change 2010-04-09 akanksha.sharma@netapp.com: Burt 386662: Added support for BSAS disks wherever applicable
## @change 2010-05-02 sajitha@netapp.com: Burt 394392: Added new subroutine RaidSqa_get_aggr_uuid
## @change 2010-04-09 pravin.salgond@netapp.com: Burt 421749: Added library functions RaidSqa_set_raid_lw_opt, RaidSqa_set_aggr_raid_lost_write, RaidSqa_get_label_vuinfo, RaidSqa_get_aggr_fsid
## @change 2010-06-29 pravin.salgond@netapp.com: Burt 429447: Added library functions RaidSqa_label_buildtree, RaidSqa_get_label_buildtree_cmd_string.
## @change 2010-07-12 melan.singh@netapp.com: Burt 432258 : commenting the check for raid_lost_write option (now rlw_*) in RaidSqa_check_group_lw_flags.
## @change 2010-07-13 pravin.salgond@netapp.com: Burt 431831: Added ZCSv2 support for RaidSqa_dd command.
## @change 2010-07-12 melan.singh@netapp.com: Burt 432258 : Added check using aggr status -v option for function RaidSqa_check_aggr_lw_flags
## @change 2010-09-06 pravin.salgond@netapp.com: Burt 438681 : Updated RaidSqa_get_raid_size_value to use raid_config command.
## @change 2012-12-18 amal@netapp.com: Burt 664746 : Updated  updated RaidSqa_get_options to use filer_cmd for cmode support
## @pod here

=head1 NAME

RaidSqa

=head1 DESCRIPTION

      	This library use RaidInfo.pm library to get various raidinfo o/ps.
      	This is to replace existing raidv2_lib.pm and raidqa_lib.pm.
	This contains all raid library functions for commands and utililties.

=head1 SYNOPSIS

	package RaidSqa;

        use RaidSqa.pm;

        my $host = host($FILER);

	##FUNCTIONS RELATED TO COMMANDS ##

	RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type, aggr_bits=>$aggr_bits);

	-or-

	RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@disk_list, disk_list1=>\@disk_list1, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type);

	-or-

	RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, aggr_type=>$aggr_type, rpm=>$rpm, more_options=>$more_options);

	RaidSqa_aggr_add(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, group_name=>$group_name, disk_count=>$disk_count, disk_size=>$disk_size, disk_list=>\@disk_list, $disk_list1=>\@disk_list1, options=>$options);

	RaidSqa_aggr_rename(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_aggr_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_aggr_online(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_aggr_restrict(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_aggr_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_aggr_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_aggr_split(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, splitted_vol=>$splitted_vol);

	RaidSqa_aggr_mirror(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, splitted_vol=>$splitted_vol, disk_list=>\@disk_list, options=>options);

	RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

	RaidSqa_plex_online(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

	RaidSqa_plex_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

	RaidSqa_hammer_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, iterations=>$iterations, file_name=>$file_name, file_size=>$file_size);

	RaidSqa_hammer_abort(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_hammer_pause(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_hammer_restart(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_hammer_status(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_aggr_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_aggr_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_aggr_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, $plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_aggr_scrub_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_aggr_scrub_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

        RaidSqa_aggr_media_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_aggr_media_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, disk_name=>$disk_name, group_name=>$group_name);

        RaidSqa_aggr_media_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

	RaidSqa_aggr_verify_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol); 

	RaidSqa_aggr_verify_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_number=>$plex_number); 

	RaidSqa_aggr_verify_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol); 

	RaidSqa_aggr_verify_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol); 

	RaidSqa_aggr_verify_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol); 

	RaidSqa_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options, value=>$value); 
	
    RaidSqa_set_aggr_raid_lost_write(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, option_value=>$option_value);
	
	RaidSqa_disk_zero_spares(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_disk_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

	RaidSqa_disk_fail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>$options);

	RaidSqa_disk_unfail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>options);

        RaidSqa_disk_replace_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, replacing_disk => $replacing_disk, options=>$options);

	RaidSqa_disk_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>options);

	RaidSqa_disk_online(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

	RaidSqa_disk_mung(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, sector=>$sector, bits=>$bits);

	RaidSqa_disk_assign(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, $disk_list=>\@disk_list,pool=>$pool);

	RaidSqa_disk_remove_ownership(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, $disk_list=>\@disk_list);

	RaidSqa_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name, flag_value=>$flag_value);

	RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name, option_value=>$option_value);

    RaidSqa_set_raid_lw_opt(host=>$host, filermode=>$filermode, conntype=>$conntype, option_value=>$option_value);	
	
	RaidSqa_license_add_by_code(host=>$host, filermode=>$filermode, conntype=>$conntype, code=>$code);

	RaidSqa_license_add_by_service(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

	RaidSqa_license_delete(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

	RaidSqa_fiji_filter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_fiji_nvfilter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_fiji_clear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_fiji_nvclear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_fiji_show(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_nv_trash(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_savecore(host=>$host, filermode=>$filermode, conntype=>$conntype, options=>$options);

	RaidSqa_media_scrub_disable(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_media_scrub_enable(host=>$host, filermode=>$filermode, conntype=>$conntype);

	RaidSqa_log(host=>$host, filermode=>$filermode, conntype=>$conntype, marker=>$marker);

	RaidSqa_exportfs(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);
	
	RaidSqa_aggr_undestroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type, raidtree_id => $raidtree_id);

	RaidSqa_aggr_wafliron_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

	RaidSqa_aggr_wafliron_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

	RaidSqa_dd(host=>$host, filermode=>$filermode, conntype=>$conntype, if=>$if, of=$of, din=$din, bin=$bin, dout=$dout, bout=$bout, count=$count, options=>$options);

	RaidSqa_filer_cmd(host=>$host, filermode=>$filermode, conntype=>$conntype, cmd=>$cmd, timeout=$timeout);

	
	##FUNCTIONS CHECKING STATUS## 

	RaidSqa_check_disk_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_check_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, fsm_state=>$fsm_state);   

	RaidSqa_check_disk_is_doing_optimized_recons(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_check_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, parent_state=>$parent_state);   

	RaidSqa_check_disk_is_prefailed(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_check_disk_block_is_pseudo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, dbn=>$dbn);   

        RaidSqa_check_disk_block_is_zeroed_out(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn=>$dbn);

	RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_check_aggr_exist_anytype(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, state_name=>$state_name);

	RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, mirror_state=>$mirror_state);

	RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, fsm_state=>$fsm_state);

	RaidSqa_check_plex_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

	RaidSqa_check_plex_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, state_name=>$state_name);

	RaidSqa_check_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, fsm_state=>$fsm_state);

	RaidSqa_check_plex_resyncing(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, resync_level=>$resync_level);

	RaidSqa_check_group_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name, fsm_state=>$fsm_state);

	RaidSqa_check_group_recons_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

        RaidSqa_check_group_reparity_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_check_group_scrub_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_check_group_is_running_context_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_check_group_recons_is_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_check_raid_size_valid_range(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);

	RaidSqa_check_license(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

	RaidSqa_check_fiji(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_check_hammer_running(host=>$host, filermode=>$filermode, conntype=>$conntype, hammer_number=>$hammer_number);
	
	RaidSqa_check_existing_aggr_ok(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, disk_count=>$disk_count, aggr_bits=>$aggr_bits, aggr_fsm_state=>$aggr_fsm_state, aggr_state_name=>$aggr_state_name, aggr_wafl_online=>$aggr_wafl_online, aggr_wafl_mounted=>$aggr_wafl_mounted, aggr_ignore_inconsist=>$aggr_ignore_inconsist, aggr_snapmirrored=>$aggr_snapmirrored, all_group_fsm_state=>$all_group_fsm_state, all_group_sdc=>$all_group_sdc);


	##FUNCTIONS GETTING INFORMATION##

	RaidSqa_get_vol_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

	RaidSqa_get_aggr_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

	RaidSqa_get_aggr_list(host=>$host, filermode=>$filermode, conntype=>$conntype); 

	RaidSqa_get_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options); 

	RaidSqa_get_aggr_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_cksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_raidtree_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_bits(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_has_bad_blocks(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_bad_block_count(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_tetris_opt_disabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

	RaidSqa_get_aggr_uuid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);
	
    RaidSqa_get_aggr_fsid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);	

	RaidSqa_get_root_aggr(host=>$host, filermode=>$filermode, conntype=>$conntype); 

	RaidSqa_get_root_vol(host=>$host, filermode=>$filermode, conntype=>$conntype); 

	RaidSqa_get_plex_resync_level(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name); 

	RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol); 

	RaidSqa_get_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

	RaidSqa_get_group_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name); 

	RaidSqa_get_group_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, filer_vol=>$filer_vol, plex_name=>$plex_name); 

	RaidSqa_get_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_get_group_recons_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);
        RaidSqa_get_group_scrub_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_get_group_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

	RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_pool(host=>$host, filermode=>$filermode, conntype=>$conntype, pool_name=>$pool_name, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, parent_state=>$parent_state, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_raid_type(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_type=>$raid_type, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, storage_type=>$storage_type, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_list_by_rpm(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_rpm=>$disk_rpm, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 

	RaidSqa_get_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_used_size(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_group_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_plex_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_aggr_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_other_path_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_disk_sdc_target(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);   

	RaidSqa_get_preferred_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype); 

	RaidSqa_get_raid_size_value(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type, override=>$override); 

	RaidSqa_get_scrub_report_by_group(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name); 

	RaidSqa_get_fiji_slot(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

	RaidSqa_get_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name);

	RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name);

	RaidSqa_get_fileid(host=>$host, filermode=>$filermode, conntype=>$conntype, file_name=>$file_name);

	RaidSqa_get_file_block_info(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, file_name=>$file_name, $block_number=>$block_number);

        RaidSqa_get_disk_rgdn(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

	##OTHER FUNCTIONS## 

	RaidSqa_test_init(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

	RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, timeout=>$timeout);

	RaidSqa_wait_for_plex_resync_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, resync_level=>$resync_level, timeout=>$timeout);

	RaidSqa_wait_for_reconstruction_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name, timeout=>$timeout);

	RaidSqa_wait_for_reparity_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name,group_name=>$group_name, timeout=>$timeout);

	RaidSqa_wait_for_verify_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, timeout=>$timeout); 

	RaidSqa_wait_for_scrub_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout); 

	RaidSqa_wait_for_disk_sdc_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, timeout=>$timeout); 

	RaidSqa_wait_for_spare_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list, timeout=>$timeout);
	
	RaidSqa_get_one_plex_of_state (host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, plex_state => $plex_state);
	
	RaidSqa_take_mirror_to (host=>$host, filermode=>$filermode, conntype=>$conntype, aggr_type => $aggr, filer_vol => $filer_vol, mirror_state => $mirror_state,plex_name => $plex_name);

	RaidSqa_get_bypassed_disk_list (host=>$host, filermode=>$filermode, conntype=>$conntype);
	
	##FUNCTIONS RELATED TO FEATURE OLM##

	RaidSqa_labelmaint_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, arg_list=>\@arg_list); 

	RaidSqa_get_labelmaint_list(host=>$host, filermode=>$filermode, conntype=>$conntype); 

	RaidSqa_labelmaint_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype);
	
    RaidSqa_label_buildtree(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, disk_args=>$disk_args, fsid=>$fsid, raid_type=>$raid_type, aggr_bits=>$aggr_bits, aggr_type => $aggr_type, options=>$options);

        RaidSqa_get_disk_offline_ref_count (host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

	RaidSqa_check_disk_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

	RaidSqa_check_disk_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, fsm_state=>$fsm_state);

	RaidSqa_check_aggr_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, $vol_disk_list=>\@vol_disk_list);

	RaidSqa_check_aggr_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, $vol_disk_list=>\@vol_disk_list);

    RaidSqa_get_label_vuinfo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list);	
	
	RaidSqa_get_label_buildtree_cmd_string(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);
	
	##FUNCTIONS RELATED TO FEATURE IOC on ROOT##

	RaidSqa_create_temproot_vol(host=>$host, vol_name=>$trad_vol_name, disk_list=>$disk_list_ref, setup_info=>\%setupinfo);
	or
        create_temproot_vol(host=>$host, vol_name=>$trad_vol_name, disk_list=>$disk_list_ref, setup_info=>\%setupinfo, verify_flg=>$flag, raid_type=>$raid_type);

	RaidSqa_temp_rootvol_verify(host=>$host, vol_name=>$trad_vol_name, disk_list=>$disk_list_ref);

	RaidSqa_verify_root_aggr_vol_spare_disks(conn=>$fc, root_aggr=>$root_aggr, root_vol=>$root_vol, disks=>$ref_array_of_disks);

	RaidSqa_aggr_set_as_root(conn=>$fc, aggr=>$aggr, restore=>1);

        RaidSqa_get_setup_information(conn => $fc, filer => $FILER);

        RaidSqa_get_invalid_diskid(conn => $conn, num_disks => $no_of_disks);

	RaidSqa_setup($conn, \%setup_args);

	RaidSqa_check_ioc_support(host => $host);

        ##FUNCTIONS FOR UPGRADE AND REVERT OPERATIONS##

        RaidSqa_software_update_HTTP(host=>$host, url => $url, timeout => $timeout);

        RaidSqa_copy_system_files_HTTP_download(host=>$host, url => $url, timeout => $timeout);

        RaidSqa_software_revert_to_HTTP(host=>$host, url => $url, version_id => $version_id, timeout => $timeout);

        RaidSqa_software_upgrade_HTTP(host=>$host, url => $url, timeout => $timeout);


=head1 ROUTINES

=cut
package RaidSqa;
use strict;
no strict "subs";
use warnings;
require Exporter;

BEGIN { 
use Carp qw(confess croak);
use Params::Validate qw(validate OBJECT SCALAR ARRAYREF HASHREF CODEREF UNDEF);
use Tharn qw(say script_result host logcomment logresult param);
use Module::Common qw(validate_mixed);
use Utils qw(make_conn);
use Data::Dumper;
use RaidInfo;
use filer;
use Aggregate qw(aggr_options aggr_root);
use Storage::Misc qw(misc_printflag filer_cmd);
use Volume qw(vol_status vol_exists vol_options vol_disks vol_root);
use SayWrap qw(sayEOF sayWAIT);
use CLI::FileIO qw(rdfile);
use FS::Util::Setup qw(mount_root_vol umount_vol);
use FS::commonParams;
use boot;
use misc qw(cli);
use ExportFS qw(export_path);
use wafl_utils qw(snap_list);
use vars qw(@ISA @EXPORT);
Params::Validate::validation_options(
    on_fail => sub {my @msgs = @_; chomp(@msgs);
        Carp::confess(Tharn::script_result(@msgs))}
   );
}

#use vars qw($RaidSqa_TIMEOUT);
#param("RaidSqa_TIMEOUT", "-default", 300);

# The following sub-routines are exported by RaidSqa.pm, apart from RaidSqa.pm sub-routines.
# The corresponding library names are also mentioned:
# make_conn - Utils.pm
# aggr_options aggr_root - Aggregate.pm
# misc_printflag - Storage::Misc.pm
# vol_status vol_exists vol_options vol_disks vol_root - Volume.pm
# sayEOF sayWAIT - SayWrap.pm
# cli - misc.pm
# export_path - ExportFS.pm
# snap_list - wafl_utils.pm
# boot_state transit_to boot halt reboot_to reboot netboot_setup wait_for_rsh @BOOTSTATES - boot.pm
# all_aggregates aggregate all_volumes volume all_plexes plex all_raid_groups raid_group
# all_disks disk failed_disks spare_disks prefailed_disks sdc_target_disks spare_disks_pool0
# spare_disks_pool1 my_disks partner_disks print_info root_aggregate root_volume refresh
# - RaidInfo.pm
# confess croak - Carp.pm
# validate OBJECT SCALAR ARRAYREF HASHREF CODEREF UNDEF - Params::Validate.pm
# say script_result host logcomment logresult param - Tharn.pm
# validate_mixed - Module::Common.pm
# filer_file_append filer_file_destroy filer_vfiler_context_get
# filer_kernel_is_debug filer_vfiler_status_get filer_version_get
# filer_showfh filer_if_netmask_get - filer.pm


use vars qw(@ISA @EXPORT);
my $RaidSqa_TIMEOUT = 300;
@ISA = qw(Exporter) ;
@EXPORT = qw (
    RaidSqa_aggr_create
    RaidSqa_aggr_add
    RaidSqa_aggr_rename
    RaidSqa_aggr_offline
    RaidSqa_aggr_online
    RaidSqa_aggr_restrict
    RaidSqa_aggr_destroy
    RaidSqa_aggr_remove
    RaidSqa_aggr_mirror
    RaidSqa_aggr_split
    RaidSqa_plex_offline
    RaidSqa_plex_online
    RaidSqa_plex_destroy
    RaidSqa_hammer_start
    RaidSqa_hammer_abort
    RaidSqa_hammer_pause
    RaidSqa_hammer_restart
    RaidSqa_hammer_status
    RaidSqa_aggr_scrub_status
    RaidSqa_aggr_scrub_start
    RaidSqa_aggr_scrub_stop
    RaidSqa_aggr_scrub_suspend
    RaidSqa_aggr_scrub_resume
    RaidSqa_aggr_media_scrub_start
    RaidSqa_aggr_media_scrub_status
    RaidSqa_aggr_media_scrub_stop
    RaidSqa_aggr_verify_status
    RaidSqa_aggr_verify_start
    RaidSqa_aggr_verify_stop
    RaidSqa_aggr_verify_suspend
    RaidSqa_aggr_verify_resume
    RaidSqa_aggr_options
    RaidSqa_set_aggr_raid_lost_write	
    RaidSqa_disk_zero_spares
    RaidSqa_disk_remove
    RaidSqa_disk_fail
    RaidSqa_disk_unfail
    RaidSqa_disk_replace_start
    RaidSqa_disk_offline
    RaidSqa_disk_online
    RaidSqa_disk_mung
    RaidSqa_disk_assign
    RaidSqa_disk_remove_ownership
    RaidSqa_setflag
    RaidSqa_set_options
    RaidSqa_set_raid_lw_opt	
    RaidSqa_license_add_by_code
    RaidSqa_license_add_by_service
    RaidSqa_license_delete
    RaidSqa_fiji_filter
    RaidSqa_fiji_nvfilter
    RaidSqa_fiji_clear
    RaidSqa_fiji_nvclear
    RaidSqa_fiji_show
    RaidSqa_find_active_path_disk_name 
    RaidSqa_nv_trash
    RaidSqa_savecore
    RaidSqa_media_scrub_disable
    RaidSqa_media_scrub_enable
    RaidSqa_log
    RaidSqa_exportfs
    RaidSqa_aggr_undestroy
    RaidSqa_aggr_wafliron_start
    RaidSqa_aggr_wafliron_status
    RaidSqa_dd
    RaidSqa_filer_cmd
    RaidSqa_check_disk_exist
    RaidSqa_check_disk_fsm_state
    RaidSqa_check_disk_is_doing_optimized_recons
    RaidSqa_check_disk_parent_state
    RaidSqa_check_disk_is_prefailed
    RaidSqa_check_disk_sdc_start
    RaidSqa_check_disk_block_is_pseudo
    RaidSqa_check_disk_block_is_zeroed_out   
    RaidSqa_check_aggr_exist
    RaidSqa_check_aggr_exist_anytype
    RaidSqa_check_aggr_state_name
    RaidSqa_check_aggr_mirror_state
    RaidSqa_check_aggr_fsm_state
    RaidSqa_check_plex_exist
    RaidSqa_check_plex_state_name
    RaidSqa_check_plex_fsm_state
    RaidSqa_check_plex_resyncing
    RaidSqa_check_group_exist
    RaidSqa_check_group_fsm_state
    RaidSqa_check_group_recons_in_progress
    RaidSqa_check_group_reparity_in_progress
    RaidSqa_check_group_scrub_in_progress
    RaidSqa_check_group_is_running_context_scrub
    RaidSqa_check_group_recons_is_suspend
    RaidSqa_check_raid_size_valid_range
    RaidSqa_check_license
    RaidSqa_check_fiji
    RaidSqa_check_hammer_running
    RaidSqa_check_existing_aggr_ok
    RaidSqa_get_vol_status
    RaidSqa_get_aggr_status
    RaidSqa_get_aggr_list
    RaidSqa_get_aggr_options
    RaidSqa_get_aggr_type
    RaidSqa_get_aggr_cksum_type
    RaidSqa_get_aggr_fsm_state
    RaidSqa_get_aggr_raidtree_type
    RaidSqa_get_aggr_storage_type
    RaidSqa_get_aggr_bits
    RaidSqa_get_aggr_mirror_state
    RaidSqa_get_aggr_context_parity_valid
    RaidSqa_get_aggr_has_bad_blocks
    RaidSqa_get_aggr_bad_block_count
    RaidSqa_get_aggr_tetris_opt_disabled
    RaidSqa_get_aggr_uuid
    RaidSqa_get_aggr_fsid	
    RaidSqa_get_root_aggr
    RaidSqa_get_root_vol
    RaidSqa_get_plex_resync_level
    RaidSqa_get_plex_fsm_state
    RaidSqa_get_plex_list
    RaidSqa_get_group_list
    RaidSqa_get_group_list_by_fsm_state
    RaidSqa_get_group_fsm_state
    RaidSqa_get_group_recons_suspended_block
    RaidSqa_get_group_scrub_suspended_block
    RaidSqa_get_group_context_parity_valid
    RaidSqa_get_disk_list
    RaidSqa_get_disk_list_by_pool
    RaidSqa_get_disk_list_by_fsm_state
    RaidSqa_get_disk_list_by_parent_state
    RaidSqa_get_disk_list_by_raid_type
    RaidSqa_get_disk_list_by_storage_type
    RaidSqa_get_disk_list_by_rpm
    RaidSqa_get_disk_fsm_state
    RaidSqa_get_disk_used_size
    RaidSqa_get_disk_parent_state
    RaidSqa_get_disk_group_name
    RaidSqa_get_disk_plex_name
    RaidSqa_get_disk_aggr_name
    RaidSqa_get_disk_other_path_name
    RaidSqa_get_disk_sdc_target
    RaidSqa_get_preferred_storage_type
    RaidSqa_get_raid_size_value
    RaidSqa_get_scrub_report_by_group
    RaidSqa_get_fiji_slot
    RaidSqa_get_setflag
    RaidSqa_get_options
    RaidSqa_get_fileid
    RaidSqa_get_file_block_info
    RaidSqa_get_disk_storage_type
    RaidSqa_media_error_inject
    RaidSqa_test_init
    RaidSqa_wait_for_aggr_disks_zeroing_completion
    RaidSqa_wait_for_plex_resync_completion
    RaidSqa_wait_for_reconstruction_completion
    RaidSqa_wait_for_reparity_completion
    RaidSqa_wait_for_verify_completion
    RaidSqa_wait_for_scrub_completion
    RaidSqa_wait_for_disk_sdc_completion
    RaidSqa_wait_for_spare_disks_zeroing_completion
    RaidSqa_labelmaint_isolate
    RaidSqa_get_labelmaint_list
    RaidSqa_labelmaint_unisolate
    RaidSqa_label_buildtree
    RaidSqa_check_disk_after_isolate
    RaidSqa_check_disk_after_unisolate
    RaidSqa_check_aggr_after_isolate
    RaidSqa_check_aggr_after_unisolate
    RaidSqa_get_label_vuinfo
    RaidSqa_get_label_buildtree_cmd_string
    RaidSqa_check_ioc_support
    RaidSqa_get_setup_information
    RaidSqa_get_invalid_diskid
    RaidSqa_create_temproot_vol
    RaidSqa_temp_rootvol_verify
    RaidSqa_verify_root_aggr_vol_spare_disks
    RaidSqa_software_update_HTTP
    RaidSqa_copy_system_files_HTTP_download
    RaidSqa_software_revert_to_HTTP
    RaidSqa_software_upgrade_HTTP 
    RaidSqa_setup
    RaidSqa_aggr_set_as_root
    RaidSqa_get_disk_list_by_checksum_type
    RaidSqa_get_disk_rgdn
    RaidSqa_get_disk_offline_ref_count
    RaidSqa_get_aggr_raid_lw_enabled
    RaidSqa_get_aggr_raid_lw_allowed
    RaidSqa_get_group_raid_lw_scrub
    RaidSqa_check_aggr_lw_flags
    RaidSqa_check_group_lw_flags   
	RaidSqa_get_one_plex_of_state
	RaidSqa_take_mirror_to
    RaidSqa_get_bypassed_disk_list 
	make_conn
    aggr_options
    aggr_root
    misc_printflag
    vol_status
    vol_exists
    vol_options
    vol_disks
    vol_root
    sayEOF
    sayWAIT
    rdfile
    mount_root_vol
    umount_vol 
    cli
    export_path
    snap_list
    boot_state
    transit_to
    boot
    halt
    reboot_to
    reboot
    netboot_setup
    wait_for_rsh    
    @BOOTSTATES
    all_aggregates
    aggregate
    all_volumes
    volume
    all_plexes
    plex
    all_raid_groups
    raid_group
    all_disks
    disk
    failed_disks
    spare_disks
    prefailed_disks
    sdc_target_disks
    spare_disks_pool0
    spare_disks_pool1
    my_disks
    partner_disks
    print_info
    root_aggregate
    root_volume
    refresh
    confess
    croak
    validate 
    OBJECT
    SCALAR
    ARRAYREF
    HASHREF
    CODEREF
    UNDEF
    say
    script_result
    host
    logcomment
    logresult
    param
    validate_mixed
    filer_file_append
    filer_file_destroy
    filer_vfiler_context_get
    filer_kernel_is_debug
    filer_vfiler_status_get
    filer_version_get
    filer_showfh
    filer_if_netmask_get      
);
##############################################################################
# LIST OF FUNCTIONS WHICH ARE RAID COMMNADS                                  #
##############################################################################

#------------------------------------------------------------------------------

# @burt 354485 Modified for equal disk list and even disk count error scenario for mirrored aggregate

=head2 RaidSqa_aggr_create

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type, aggr_bits=>$aggr_bits);

-or-

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@disk_list, disk_list1=>\@disk_list1, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type);

-or-

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, aggr_type=>$aggr_type, rpm=>$rpm, more_options=>$more_options);

This subroutine create the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item options

(Optional) : We can use this to define all options needed for vol/aggr create if we do not want to specify all the paremeters to this function instead want to create options in the script.

=item disk_count

(Optional) : Number of of disk to be used for volume/aggegate creation. Need to define at least on parameter from disk_count and disk_list for volume creation, if none is defined, it will use disk_count as 6

=item disk_list

(Optional) : Reference to the list of disks to be used for volume creation. Need to define at least one parameter from disk_count or disk_list. But can not defined both.

=item disk_list1

(Optional) : Reference to the list of 2nd set of disks. Need to define this if mirror is 1 and disk_list is also defined. Can not define if disk_count is defined.

=item raid_type

(Optional): Raid type of the volume/aggregate to be created. By default it is raid_dp. Other options is raid4.

=item raid_size

(Optional): Raid size of the volume/aggregate to be created. By default it is default. Other values can be min, max or user_defined count but that should be in allowed range for a given storage_type.

=item mirror

(Optional): 1 for mirror volume and 0 for nonmirror. Default is 0.

=item storage_type

(Optional):  Disk storage type. Can be ATA, SAS, FCAL, BSAS. If nothing is defined  than it tries to find the prefered storage type and use that type of disk.

=item rpm

(Optional):  Disk rpm type. Can be 7200, 10000, 15000. If nothing is defined than it use any rpm disks to create volume/aggr.

=item aggr_type

(Optional): 1 for aggregate and 0 for traditional. Default it is 1.

=item more_options

(Optional) : We can use this to define more options needed for vol/aggr create.

=item aggr_bits

(Optional): 32 for normal volume/aggr, 64 for larger aggregate. Default it is 32.

=item fake_la

(Optional): 1 for fake larger aggregate of size > 16TB and 0 for not. Default is 0

=item fake_rg_max_count

(Optional): Default is 3, it controls the env variable needed to create fake larger aggregate

=item fake_vol_size

(Optional): The value of fake larger flex volume in TB. Default is 24


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_create {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                disk_count => { type=>SCALAR,optional=>1 },
                                disk_list => { type=>ARRAYREF,optional=>1 },
                                disk_list1 => { type=>ARRAYREF,optional=>1 },
                                raid_type => { type=>SCALAR, default=>"raid_dp",optional=>1 },
                                raid_size => { type=>SCALAR, default=>"default",optional=>1 },
                                mirror => { type=>SCALAR,default=>0,optional=>1 },
                                storage_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                rpm => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
								aggr_type => { type=>SCALAR,default=>1,optional=>1 },
								aggr_bits => { type=>SCALAR,default=>undef,optional=>1 },   
								snaplock => { type=>SCALAR,optional=>1 },
                                more_options => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                fake_la => {type=>SCALAR,default=>0,optional=>1 },        
								fake_rg_max_count => {type=>SCALAR,default=>3,optional=>1 },
								fake_vol_size => {type=>SCALAR,default=>24,optional=>1},
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $more_options = $opts{more_options};
        my $disk_count = $opts{disk_count};
        my $disk_list = $opts{disk_list};
		my @disk_list;
        my $disk_list1 = $opts{disk_list1};
		my @disk_list1;
        my $raid_type = $opts{raid_type};
        my $raid_size = $opts{raid_size};
        my $mirror = $opts{mirror};
        my $storage_type = $opts{storage_type};
        my $rpm = $opts{rpm};
		my $aggr_type = $opts{aggr_type};
		my $snaplock = $opts{snaplock};
        my $snap_lock = "";

	# Code added for 64 bit larger aggregate for normal and fake_la  by skg@netapp.com 01/27/09

	my $aggr_bits = $opts{aggr_bits};
    my $fake_la = $opts{fake_la};
	my $fake_rg_max_count = $opts{fake_rg_max_count};
	my $fake_vol_size = $opts{fake_vol_size};

	# Code added end for 64 bit larger aggregate for normal and fake_la by skg@netapp.com 01/27/09

	# create connection 
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# dereference array of disk_list if specified 
	if ($disk_list) {
		@disk_list = @$disk_list;
	}
	if ($disk_list1) {
		@disk_list1 = @$disk_list1;
	}
		
	# use default disk_count if disk_list and disk_count both are not given, also check that user did not specified both together
	if ((!$disk_count) && (!@disk_list)) {
		$disk_count=6;
	} elsif (($disk_count) && (@disk_list)) {
		logcomment("RaidSqa.pm: Need to provide only one parameter disk_count or disk_list to aggr create argument");
		return 0;
	}

	# Check that for mirror volume either disk_count or two disk_lists are specified
	if (($mirror) && (!$disk_count) && (!@disk_list) && (!@disk_list1)) {
		logcomment("RaidSqa.pm: Need to provide either disk count or both disk_list and disk_list1 if mirror volume/aggr is needed");
		return 0;
	}

	# Get preferred storage type if not specified by user
	if (!defined($storage_type)) {
  		logcomment("RaidSqa.pm: Getting storage type, as not defined");
  		$storage_type=RaidSqa_get_preferred_storage_type(host=>$host, conntype=>$conntype);
  		logcomment("RaidSqa.pm: Preferred storage type is $storage_type");
	} 

	# get raid_size value for min/max/default raid_size and if a user defined size is given than check that it is in valid range
	if ($raid_size =~ /\D/) {

  		$raid_size=RaidSqa_get_raid_size_value(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);  

	} else {

  		if (!RaidSqa_check_raid_size_valid_range(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type)) {
		logcomment("RaidSqa.pm: raid_size $raid_size is not in teh valid range");
		return 0;
		}

	}

	logcomment("RaidSqa.pm: Raid size used for creating volume/aggregate is: $raid_size");

        if ($snaplock) { 
		my $filer_version = filer_version_get($conn);
		# Add snaplock license. For AS only one license can be installed at a given time.

		if ( ( $filer_version =~ /RanchorsteamN/) || ( $filer_version =~ /7.0/ ) ) {
			if ( ($snaplock eq "compliance") || ($snaplock eq "enterprise") ) {
				$snap_lock = "-L";
			} else {
				$snap_lock = "";
			}
		} else {
			if ($snaplock eq "compliance") {
                        	$snap_lock = "-L $snaplock";
	                } elsif ($snaplock eq "enterprise") {
        	                $snap_lock = "-L";
	                } else {
        	                $snap_lock = "";
	                }
 		}
	}

	# Code added for 64 bit larger aggregate for normal and fake_la  by skg@netapp.com 02/10/09
	if ($fake_la) {
		if ($aggr_bits != 64) {
			logcomment("RaidSqa.pm: fake_la is supported only on 64 bits aggregates");
			return 0;
		}
		if ($fake_rg_max_count < 3)  {
			logcomment("RaidSqa.pm: for fake_la fake_rg_max_count should be >= 3");
			return 0;
		}
            	if ($fake_vol_size < 24){
                    	logcomment("Fake Flex vol size of less than 24 TB is not necessarily enough to write to a > 16 TB vvbn");
			return 0;
                }

            	say($conn, "priv set test; bootargs set bootarg.dblade.fake_large_aggr true");
            	say($conn, "priv set test; bootargs set raidtop_fake_rg_max_count $fake_rg_max_count");
		

		if ($raid_size <= 3)  {
                    	logcomment("RaidSqa.pm: Increasing raid size for fake_la by adding 2 if raid size is <= 3");
			$raid_size = $raid_size + 2;
		}
	}
	# Code added end for 64 bit larger aggregate for normal and fake_la  by skg@netapp.com 02/10/09
	

	my $vol_create_args="$filer_vol -f $snap_lock -t $raid_type -r $raid_size";

	# if more mores are needed to be specified to vol_create_args
	if ($more_options) {
		$vol_create_args="$vol_create_args" . " $more_options";
	}

	# Code added for 64 bit larger aggregate for normal and fake_la  by skg@netapp.com 02/10/09
	# if aggr_bits is 64 than add that options also but this is supported only Br.0 onwards
	if (defined($aggr_bits)){
		if (($aggr_bits == 64) && ($aggr_type == 0)) {
			logcomment("RaidSqa.pm: 64 bit type is not supported on traditional volumes, AGGR should be 1");
			return 0;
		}
		if($aggr_type==1){
			$vol_create_args="$vol_create_args" . " -B $aggr_bits";
		}
	}
	
	# Added by Kilol for FAKE LA creation
	my @fake_disk_add_list;
	my @fake_disk_add_list1;
	my $fake_add_disk_count;
	if ($disk_list) {
		
		if($fake_la){
			if($raid_type eq "raid_dp"){
				@fake_disk_add_list=@disk_list[3..$#disk_list];
				@fake_disk_add_list1=@disk_list1[3..$#disk_list] if($mirror);
				@disk_list=@disk_list[0..2];
				@disk_list1=@disk_list1[0..2] if($mirror);
			}elsif($raid_type eq "raid4"){
				@fake_disk_add_list=@disk_list[2..$#disk_list];
				@fake_disk_add_list1=@disk_list1[2..$#disk_list] if($mirror);
				@disk_list=@disk_list[0..1];
				@disk_list1=@disk_list1[0..1] if($mirror);
			}
			if(($#fake_disk_add_list <= -1)||($mirror && $#fake_disk_add_list1 <= -1)){
				logresult("FATAL", "RaidSqa: Number of disks is not sufficient for creation of FAKE LA. Number of disks available for addition seems to be less. \n");
			}
		}
	# Added by Kilol for FAKE LA creation	
		if (!$mirror) {

        # Modified to handle disk size input

                        if ( $disk_list[0] !~ /\d+\@\d+[mgtMGT]/ ) {
                                $vol_create_args = "$vol_create_args" . " -d @disk_list";
                        } else {
                                $vol_create_args = "$vol_create_args" . " @disk_list";
                        }

		} else {
    			$vol_create_args = "$vol_create_args" . " -m -d @disk_list -d @disk_list1" ;
		} 
	} else {
	# create vol_create_args when disk_list is not given
		if (!$mirror) {
  			if ($disk_count eq "default")  {
    				$disk_count=$raid_size;
  			}
	# Added by Kilol for FAKE LA creation	
			if($fake_la){
				if ($raid_type eq "raid_dp") {
					$fake_add_disk_count=$disk_count-3;
					$disk_count=3;
                		} else {
					$fake_add_disk_count=$disk_count-2;
					$disk_count=2;
                		}
				if($fake_add_disk_count <= 0){
					logresult("FATAL", "RaidSqa: Number of disks is not sufficient for creation of FAKE LA. Number of disks available for addition seems to be less.\n");
				}
			}
# Added by Kilol for FAKE LA creation

			my @spares_list=RaidSqa_get_disk_list_by_storage_type(host=>$host, conntype=>$conntype, spare_only=>"yes", storage_type=>$storage_type);
			my $spares_count=@spares_list;
			my $disk_count_check= $disk_count;

			# create a disk list from the disk_count, so that it can be passed to vol_create_args using -d option
			my $n = $disk_count;
			my @spare_used_list=();
 			while ($n > 0 ) {
				$n--;
				$spare_used_list[$n]= shift @spares_list;
			}

			if ((!$rpm) && ($aggr_type)) {
    				$vol_create_args = "$vol_create_args" . " -T $storage_type $disk_count";
			} elsif (($rpm) && ($aggr_type)) {
    				$vol_create_args = "$vol_create_args" . " -T $storage_type -R $rpm $disk_count";
			} elsif (!$aggr_type) {
                                $vol_create_args = "$vol_create_args" . " -d @spare_used_list";
			}
		
		} elsif ($mirror) {
			#if(!RaidSqa_check_license(host=> $host, conntype=>$conntype, service=>"syncmirror_local")) {
			#	logcomment("RaidSqa.pm: Tests can not be run as syncmiror is not licensed");
			#	return 0;
			#}

  			if ($disk_count eq "default") {
    				$disk_count= 2 * $raid_size;
  			}
	# Added by Kilol for FAKE LA creation		
			if($fake_la){
				if ($raid_type eq "raid_dp") {
					$fake_add_disk_count=$disk_count-6;
					$disk_count=6;
                		} else {
					$fake_add_disk_count=$disk_count-4;
					$disk_count=4;
                		}
				if($fake_add_disk_count <= 0){
					logresult("FATAL", "RaidSqa: Number of disks is not sufficient for creation of FAKE LA. Number of disks available for addition seems to be less. \n");
				}
			}
			
# Added by Kilol for FAKE LA creation
			my @spares_storage_list=RaidSqa_get_disk_list_by_storage_type(host=>$host, conntype=>$conntype, spare_only=>"yes", storage_type=>$storage_type);
			my @spares_pool0_list=RaidSqa_get_disk_list_by_pool(host=>$host, conntype=>$conntype, pool_name=>"Pool0", disk_list=>\@spares_storage_list);
			my $spares_pool0_count=@spares_pool0_list;
        		my @spares_pool1_list=RaidSqa_get_disk_list_by_pool(host=>$host, conntype=>$conntype, pool_name=>"Pool1", disk_list=>\@spares_storage_list);
			my $spares_pool1_count=@spares_pool1_list;


			my $disk_count_check= 1 + $disk_count / 2;

			# create two disk lists from different pool for mirror aggr/volume from the disk_count, so that it can be passed to vol_create_args using -d option
			my $n = $disk_count / 2;
			my @spare_used_pool0_list=();
			my @spare_used_pool1_list=();
 			while ($n > 0 ) {
				$n--;
				$spare_used_pool0_list[$n]= shift @spares_pool0_list;
				$spare_used_pool1_list[$n]= shift @spares_pool1_list;
			}

			if ((!$rpm) && ($aggr_type)) {
    				$vol_create_args = "$vol_create_args" . " -T $storage_type -m $disk_count";
			} elsif (($rpm) && ($aggr_type)) {
    				$vol_create_args = "$vol_create_args" . " -T $storage_type -R $rpm -m $disk_count";
			} elsif (!$aggr_type) {
    				$vol_create_args = "$vol_create_args" . " -m -d @spare_used_pool0_list -d @spare_used_pool1_list";
			}
		}
}

#	my $disk_add_count_fake_la;
#	if ($fake_la) {
#		if (@disk_list) {
#			$disk_add_count_fake_la=@disk_list;
#		} elsif ($disk_count) {
#			$disk_add_count_fake_la=$disk_count;
#		} 
#		
#		if ($mirror) {
#			if ($raid_type eq "raid_dp") {
#				$disk_add_count_fake_la= $disk_add_count_fake_la - 6;
#			} else {
#				$disk_add_count_fake_la= $disk_add_count_fake_la - 4;
#			}
#		} else {
#			if ($raid_type eq "raid_dp") {
#				$disk_add_count_fake_la= $disk_add_count_fake_la - 3;
 #                       } else {
	#			$disk_add_count_fake_la= $disk_add_count_fake_la - 2;
     #                   }
#}
#		if ($disk_add_count_fake_la == 0) {
#			$disk_add_count_fake_la = 4;
#		}
#	}

	logcomment("RaidSqa.pm: create testing aggr/volume $filer_vol");
	my $output;
	
	if ($fake_la) {
		logcomment("RaidSqa.pm: creating fake_la with 1st minimun number of disk and will add remaining disk after creating a hole ");
	}
	if ($aggr_type) {  
    	(undef, undef, $output) = say($conn, "priv set -q test;aggr create $vol_create_args", -timeout, $RaidSqa_TIMEOUT);
    	} else {
    	(undef, undef, $output) = say($conn, "priv set -q test;vol create $vol_create_args", -timeout, $RaidSqa_TIMEOUT);
    	}
	
	
	sleep 30;

    	# Added condition to handle negative case when creating an aggregate with already existing aggregate name

    	if ($output =~ /already exists/) {
      		logcomment("RaidSqa.pm :Aggregate $vol_create_args already exists");
      		return 0;
      	}

    	# Added condition to handle negative case when creating an aggregate with invalid disk-size

    	if ($output =~ /aggr create: disk $disk_list[0] does not exist/) {
        	logcomment("RaidSqa.pm : Aggregate couldn't be created with Invalid disk-size");
         	return 0;
        }

        # Check for equal disk count of two disk lists for mirrored aggregate

        if ($output =~ /aggr create: mirrored aggregate requires equal count of disks in the two disk lists./) {

            logcomment("RaidSqa.pm:Mirrored aggregate creation failed because different number of disk ids for mirror and the original one is specified");
            return 0;

        }

        # Check for even diskcount for mirrored aggregate

        if ($output =~ /aggr create: Couldn't create aggregate: The number of disks specified must be a multiple/) {

           logcomment("RaidSqa.pm: Mirrored aggregate creation failed because diskcount specified is not an even number");
           return 0;

        }


	# Check test aggr/volume got created
	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj =$raid_obj->aggregate("$filer_vol");

        if (!$aggr_obj) {
               	logcomment("RaidSqa.pm: Aggr/Volume creation appears to have failed.\n");
		return 0;
        }

        sleep 30;

	# wait for zeroing to finish
        RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol);

	if ($fake_la) {
		logcomment("RaidSqa.pm: for fake_la creating a hole of $fake_vol_size TB and than adding remaining disks ");
		my $disk_size= int ($fake_vol_size * 1024 * 1024 * 256); 	
# Added by Kilol for FAKE LA creation
		if ($disk_list) {
			RaidSqa_aggr_add(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@fake_disk_add_list, options=>"-s $disk_size -f") if(!$mirror);
			RaidSqa_aggr_add(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@fake_disk_add_list, disk_list1=>\@fake_disk_add_list1, options=>"-s $disk_size -f") if($mirror);
		}else{
			RaidSqa_aggr_add(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$fake_add_disk_count, options=>"-s $disk_size");
		}
	}
# Added by Kilol for FAKE LA creation
        # Create flex volume in case test volume is aggr, having same name of aggregate with 3/4th of its size, except for fake_la

	if($aggr_type) {
                $raid_obj->refresh();
                $aggr_obj =$raid_obj->aggregate("$filer_vol");
		
		## Code added for LA and fake_la by skg@netapp.com on 01/27/09

                if($fake_la){
			my $aggr_size_in_gb = $aggr_obj->parameter("raidsize") * 4 / (1024*1024) ;
			my $fake_vol_size_in_bytes = $fake_vol_size *1024*1024*1024*1024;
			my $aggr_size_needed_in_gb = ($fake_vol_size_in_bytes * 3)  /  (100*1024*1024*1024); 

			if ( $aggr_size_in_gb >= $aggr_size_needed_in_gb) {  
                   		my $o = say($conn, "priv set -q test; vol create $filer_vol -s none $filer_vol $fake_vol_size_in_bytes", -timeout, $RaidSqa_TIMEOUT);
			} else {
				logcomment("RaidSqa.pm: aggr $filer_vol size is $aggr_size_in_gb GB and to create fake_la of flex vol size $fake_vol_size TB, need aggr of size $aggr_size_needed_in_gb GB,  Now to run this test either use normal size disk or use more disk to create aggr ");
				return 0;
			}

                } else {

                   	my $size = 3072 * $aggr_obj->parameter("raidsize");
                   	my $o = say($conn, "vol create $filer_vol $filer_vol $size",-timeout, $RaidSqa_TIMEOUT);
               	}

        }
        $raid_obj->refresh();
        my $vol_obj =$raid_obj->volume("$filer_vol");

        if (!$vol_obj) {
               	logcomment("RaidSqa.pm: Flex volume creation appears to have failed.\n");
		return 0;
        } else {
        	logcomment("RaidSqa.pm: Aggr/Volume creation is successful\n");
        	return 1
	}
	# Code added and modified end for 64 bit larger aggregate for normal and fake_la  by skg@netapp.com 02/10/09

}

#------------------------------------------------------------------------------

# @burt 359164 Modified RaidSqa_aggr_add subroutine to return output value along with the execution status, as the output messages are required for validation 

=head2 RaidSqa_aggr_add

RaidSqa_aggr_add(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, group_name=>$group_name, disk_count=>$disk_count, disk_size=>$disk_size, disk_list=>$disk_list, $disk_list1=>$disk_list1, options=>$options);

This subroutine add disks to an existing aggregate or traditional volume. You can use either disk_count or disk_count and disk_size or disk_list. Also if group_name is provided than it will add disk to that particular raidgroup. options is used to use either "-n" to get a comamnd string instaed of actually adding or "-f" to force add disks. For mirror volume is disk_list if being used than need to defined disk_list1 also. 

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item group_name

(Optional) : Provide this if want to add disk this particular raid group. But disks will be added if raidsize allows to add disk to that particular raid group.

=item disk_count

(Optional) : Number of of disk to be add 

=item disk_size

(Optional) : Size of the disks to be used for addition. This can be used only when disk_count is also defined. but can not be used along with disk_list.

=item disk_list

(Optional) : Reference to the list of disks to be add. Need to define at least one parameter from disk_count or disk_list. But can not defined both.

=item disk_list1

(Optional) : If aggr/volume is mirror and disk_list is defined than need to defined this also as 2 disk list needed fro mirroa.

=item options

(Optional):  This can have 2 values "-f" to force add disks and "-n" to get a comamnd string instaed of actually adding disks.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_add {

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                group_name => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_count => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_size => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef,optional=>1 },
                                disk_list1 => { type=>ARRAYREF|UNDEF, default=>undef,optional=>1 },
                                options => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $group_name = $opts{group_name};
        my $disk_count = $opts{disk_count};
        my $disk_size = $opts{disk_size};
        my $disk_list = $opts{disk_list};
	my @disk_list;
        my $disk_list1 = $opts{disk_list1};
	my @disk_list1;
        my $options = $opts{options};
	
	# create connection 
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# dereference array of disk_list if specified 
	if (defined($disk_list)) {
		@disk_list = @$disk_list;
	}
	if (defined($disk_list1)) {
		@disk_list1 = @$disk_list1;
	}
		
	# check that user did not specified both disk_count and disk_list together
	if (defined($disk_count) && (@disk_list)) {
		logcomment("RaidSqa.pm: Need to provide only one parameter disk_count or disk_list to aggr add argument");
		return 0;
	}

	my $aggr_add_args1;
	if (defined($group_name)) {
    		$aggr_add_args1 = "-g $group_name";
	} else {
		$aggr_add_args1 = "";
	}
	
	my $aggr_add_args2;
	if (defined($disk_count)) {
		if (defined($disk_size)) {
			$aggr_add_args2="$aggr_add_args1 $disk_count\@$disk_size";
		} else {
			$aggr_add_args2="$aggr_add_args1 $disk_count";
		}
	} elsif (defined($disk_list)) {
		if (defined($disk_list1)) {
			$aggr_add_args2="$aggr_add_args1 -d @disk_list -d @disk_list1";
		} else {
			$aggr_add_args2="$aggr_add_args1 -d @disk_list";
		}
	}		

	my $output;
	if (defined($options)) {
        	(undef, undef, $output) = say($conn, "aggr add $filer_vol $options $aggr_add_args2", -timeout, $RaidSqa_TIMEOUT);
        
        } else {
        (undef, undef, $output) =
          say($conn, "aggr add $filer_vol $aggr_add_args2",
              -timeout, $RaidSqa_TIMEOUT);

    }

#	if ($options eq "-n") {
#          	(undef, undef, $output) = say($conn, "aggr add $filer_vol -n $aggr_add_args2", -timeout, $RaidSqa_TIMEOUT);
#		return $output;
#	} elsif ($options eq "-f") {
#          	(undef, undef, $output) = say($conn, "aggr add $filer_vol -f $aggr_add_args2", -timeout, $RaidSqa_TIMEOUT);
#	} elsif ($options eq "-s") {
#          	(undef, undef, $output) = say($conn, "aggr add $filer_vol -s $aggr_add_args2", -timeout, $RaidSqa_TIMEOUT);
#        } else {
#          	(undef, undef, $output) = say($conn, "aggr add $filer_vol $aggr_add_args2", -timeout, $RaidSqa_TIMEOUT);
#	} 
       

	sleep 20;

	# wait for zeroing to finish
        RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol);

        if ($output =~ /Couldn't add disks:/
        || $output =~ /Invalid set-of-disks specification/ || $output =~ /does not match type of other disks/) {
        logcomment("RaidSqa.pm: Aggr/Volume disk addition is unsuccessful\n");
        return ($output,0);

    } else {
        logcomment("RaidSqa.pm: Aggr/Volume disk addition is successful\n");
	return ($output,1);
    }
} ## end sub RaidSqa_aggr_add

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_rename

RaidSqa_aggr_rename(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, new_vol=>$new_vol);

This subroutine rename the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be renamed.

=item new_vol

(Required) : New name of aggregate  or traditional volume.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_rename {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => { type=>SCALAR },
				new_vol => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $new_vol = $opts{new_vol};
	my $ret_val   = 0;

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my (undef, undef, $output) = say($conn, "priv set -q diag;aggr rename $filer_vol $new_vol", -timeout, $RaidSqa_TIMEOUT);
	
	# If the output string doesn't contain "renamed to" , means the aggr rename failed.

	if ($output !~ /renamed to/) {
	    goto RAID_AGGR_RENAME_EXIT;
	}
	
	sleep 5;
	my $raid_obj = new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate($new_vol);

	# Verifying if aggregate object exists for the renamed aggregate

	if ($aggr_obj) {
	    $ret_val=1;	
	} 
	
RAID_AGGR_RENAME_EXIT:
         return $ret_val;
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_offline

RaidSqa_aggr_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine offline the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be offlined.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_offline {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";
        my $ret_val = 0;

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Offlining $cmd $filer_vol");
	
	# pause hammer before starting aggr/volume offline
        RaidSqa_hammer_pause(host=>$host, conntype=>$conntype);
	sleep 10;
	
	# Check test aggr/volume exists before starting offline
	if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
		 goto RAID_AGGR_OFFLINE_EXIT;
	} else {
	       # offline test aggr/volume
               if ($aggr_type) {
	 
                       my $o;        
                      (undef, undef, $o) = say($conn, "priv set -q diag;$cmd offline $filer_vol -a -f", -timeout, $RaidSqa_TIMEOUT);
        
                       # If the output string doesn't contain "now offline" , means the aggr offline failed.

                       if ($o !~ /now offline/) {
                       goto RAID_AGGR_OFFLINE_EXIT;
                       }

                } else {
           
                        my $o;
         	       (undef, undef, $o) = say($conn, "$cmd offline $filer_vol", -timeout, $RaidSqa_TIMEOUT);

                       # If the output string doesn't contain "now offline" , means the volume offline failed.

                       if ($o !~ /now offline/) {
                       goto RAID_AGGR_OFFLINE_EXIT;
                       }

        	}
		
		# check that aggr/volume got successfully offlined
                
                if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type, state_name=>"offline")) {
        	        logcomment("RaidSqa.pm: $cmd $filer_vol successfully offlined");
		
                        $ret_val=1;
                        goto RAID_AGGR_OFFLINE_EXIT;

        	} else {
        		logcomment("RaidSqa.pm: $cmd $filer_vol could not be offlined");
			goto RAID_AGGR_OFFLINE_EXIT;
        	}
	}


RAID_AGGR_OFFLINE_EXIT:

	# Restart hammer after aggr/volume offline
        RaidSqa_hammer_restart(host=>$host, conntype=>$conntype);

        return $ret_val;        
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_online

RaidSqa_aggr_online(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine online the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be onlined.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_online {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Onlining $cmd $filer_vol");

	# check aggr/volume exists
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
                return 0;
        } else {
		# online aggr/volume
                my $o = say($conn, "$cmd online $filer_vol -f", -timeout, $RaidSqa_TIMEOUT);

		# check aggr came online successfully
		if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type, state_name=>"online")) {
        		logcomment("RaidSqa.pm: $cmd $filer_vol successfully onlined");
			return 1;
        	} else {
        		logcomment("RaidSqa.pm: $cmd $filer_vol could not be onlined");
			return 0;
        	}

        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_restrict

RaidSqa_aggr_restrict(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine restrict the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be restricted.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_restrict {
    my (%opts) =
      validate(@_,
               {host => {type => OBJECT, isa => 'Hostrec'},
                filermode =>
                  {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#rsh", optional => 1},
                filer_vol => {type => SCALAR},
                aggr_type => {type => SCALAR},});
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};
    my ($cmd) = $aggr_type ? "aggr" : "vol";
    my $ret_value = 0;
    my $restrict_output;

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    logcomment("RaidSqa.pm: Restricting $cmd $filer_vol");

    # Pause hammer before starting restricting aggr/volume

    RaidSqa_hammer_pause(host => $host, conntype => $conntype);

    # check aggr/volume exists

    if (!RaidSqa_check_aggr_exist(host      => $host,
                                  conntype  => $conntype,
                                  filer_vol => $filer_vol,
                                  aggr_type => $aggr_type)
    ) {
        return 0;
    } else {

        # restrict aggr/volume

        if ($aggr_type) {
            (undef, undef, $restrict_output) =
              say($conn, "priv set -q diag;$cmd restrict $filer_vol -a -f",
                  -timeout, $RaidSqa_TIMEOUT);

        } else {
            (undef, undef, $restrict_output) =
              say($conn, "$cmd restrict $filer_vol", -timeout,
                  $RaidSqa_TIMEOUT);

        } 

        # If the output string contains "already restricted" then aggr/vol state need not be checked hence exit.

        if ($restrict_output =~ /already restricted/) {
             goto RAID_AGGR_RESTRICT_EXIT;
        }

        # check aggr/volume got restricted successfully

        if (RaidSqa_check_aggr_state_name(host       => $host,
                                          conntype   => $conntype,
                                          filer_vol  => $filer_vol,
                                          aggr_type  => $aggr_type,
                                          state_name => "restricted")
        ) {
            logcomment("RaidSqa.pm: $cmd $filer_vol successfully restricted");
            $ret_value = 1;
        } else {
            logcomment("RaidSqa.pm: $cmd $filer_vol could not be restricted");
        }
    } 

RAID_AGGR_RESTRICT_EXIT:

    # Restart hammer after aggr/volume restrict

    RaidSqa_hammer_restart(host => $host, conntype => $conntype);
    return $ret_value;

} 

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_destroy

RaidSqa_aggr_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine destroy the already offlined test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be destroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_destroy {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Destroying the $cmd $filer_vol");

	# destroy aggr /volume and check if destroy successful	
	# run aggr destroy or vol destoy comamnd based upon its type
	if ($aggr_type) {
		my $o = say($conn, "priv set -q diag;$cmd destroy $filer_vol -f", -timeout, $RaidSqa_TIMEOUT);
	} else {
		my $o = say($conn, "$cmd destroy $filer_vol -f", -timeout, $RaidSqa_TIMEOUT);
	}
	sleep 30;

	# Check that aggr/volume got destroyed successfully
	if (RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
		logcomment("RaidSqa.pm: $cmd $filer_vol still exist, destroy failed");
		return 0;
	} else {
		logcomment("RaidSqa.pm: $cmd $filer_vol does not exist, destroy successful");
		return 1;
	}
	
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_remove

RaidSqa_aggr_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine remove the test aggregate or traditional volume. It 1st offline and than destroy it.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be removed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_remove {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my $cmd = $aggr_type ? "aggr" : "vol";

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Trying to remove $cmd $filer_vol if it exists");

	# check that tets aggr/volume exists
	if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
           	logcomment("RaidSqa.pm: $cmd $filer_vol does not exist, so no need to remove the $cmd");
		return 1;
	}

	# make test aggr/volume offline
        if (!RaidSqa_aggr_offline(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
		logcomment("RaidSqa.pm: $cmd $filer_vol could not be offlined, may be already offline otherwise will not be possible to remove it");
	}
	sleep 10;
	
	# make test aggr/volume destroyed
        if (!RaidSqa_aggr_destroy(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
		logcomment("RaidSqa.pm: $cmd $filer_vol could not be destroyed");
	}
	sleep 10;
	
	# check test aggr/volume do not exist anymore
	if (RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
           	logcomment("RaidSqa.pm: $cmd $filer_vol still exist, $cmd remove failed");
		return 0;
	} else {
        	logcomment("RaidSqa.pm: $cmd $filer_vol removed.");
		return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_mirror

RaidSqa_aggr_mirror(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

-or-

RaidSqa_aggr_mirror(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@disk_list);

-or-

RaidSqa_aggr_mirror(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, splitted_vol=>$splitted_vol);

This subroutine mirror the test aggregate or traditional volume using either a splitted_vol (vol created using vol split) or using a list of disks or just use option "-n" to get the command line needed to create a mirror volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item options

(Optional) : There is only one options "-n" availabel which givesthe complete comamnd line needed to create a covert a unmirror volume to mirror

=item disk_list

(Optional) : Reference to the list of disks to be used for mirror volume creation from unmirror.

=item splitted_vol

(Optional) : Name of splitted_vol volume which was created by vol split command from the test volume when it was mirrored.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_mirror {

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                disk_list => { type=>ARRAYREF,optional=>1 },
				splitted_vol => { type=>SCALAR,optional=>1 },
                                options => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};
        my $disk_list = $opts{disk_list};
	my @disk_list;
        my $splitted_vol = $opts{splitted_vol};
	
	# create connection 
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# dereference array of disk_list if specified 
	my $output;
	if ($disk_list) {
		@disk_list = @$disk_list;
          	(undef, undef, $output) = say($conn, "aggr mirror $filer_vol -f -d @disk_list", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($splitted_vol) {
          	(undef, undef, $output) = say($conn, "aggr mirror $filer_vol -f -v $splitted_vol", -timeout, $RaidSqa_TIMEOUT);
	} elsif ($options eq "-n") {
		(undef, undef, $output) = say($conn, "aggr mirror $filer_vol -n", -timeout, $RaidSqa_TIMEOUT);
        	my @info = split(/\r?\n/, $output);
		return $info[0];
	} else {
          	(undef, undef, $output) = say($conn, "aggr mirror $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	}

	
	sleep 20;
	
	if (!$options) {

		# Check test aggr/volume mirror got created
		my $raid_obj=new RaidInfo($conn);
		my $aggr_obj =$raid_obj->aggregate("$filer_vol");

        	if ($aggr_obj->parameter("plex_count") ne "2") {
               		logcomment("RaidSqa.pm: Aggr/Volume mirror creation has failed.\n");
               		return 0;
        	}

		# wait for zeroing to finish
        	RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol);
        	logcomment("RaidSqa.pm: Aggr/Volume got mirrored but may be still doing resync\n");
        	return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_split

RaidSqa_aggr_split(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, splitted_vol=>$splitted_vol);

This subroutine split one plex of a mirror volume and create a new aggr/trad vol.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be splitted.

=item splitted_vol

(Required) : name of new volume to be created from splitted plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_split {

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                splitted_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};
        my $splitted_vol = $opts{splitted_vol};
	
	# create connection 
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
        (undef, undef, $output) = say($conn, "aggr split $plex_name $splitted_vol", -timeout, $RaidSqa_TIMEOUT);
	
	my $raid_obj = new RaidInfo($conn);
	if ($raid_obj->plex($plex_name)) {
               	logcomment("RaidSqa.pm: Plex $plex_name still exists, split of plex failed.\n");
		return 0;
	}

	if ($raid_obj->aggregate($splitted_vol)) {
               	logcomment("RaidSqa.pm: New aggr/volume $splitted_vol got created after plex split.\n");
		return 1;
	} else {
               	logcomment("RaidSqa.pm: New aggr/volume $splitted_vol did not created after plex split.\n");
		return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_plex_offline

RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine offline the plex of a mirror volume/aggr.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to offline.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_plex_offline {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				plex_name => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Offlining plex $plex_name");

	# check given plex is existing before starting offline
	if (!RaidSqa_check_plex_exist(host=>$host, conntype=>$conntype, plex_name=> $plex_name)) {
		return 0;
	} else {

		# Offline given plex 
      		my $o = say($conn, "aggr offline $plex_name", -timeout, $RaidSqa_TIMEOUT);

		# Check that plex got offlined successfully
		if (RaidSqa_check_plex_state_name(host=>$host, conntype=>$conntype, plex_name=> $plex_name, state_name=>"offline")) {
        		logcomment("RaidSqa.pm: plex $plex_name successfully offlined");
			return 1;
        	} else {
        		logcomment("RaidSqa.pm: plex $plex_name could not be offlined");
			return 0;
        	}
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_plex_online

RaidSqa_plex_online(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine online the plex of a mirror volume/aggr.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to online.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_plex_online {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				plex_name => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Offlining plex $plex_name");

	# check plex exists
	if (!RaidSqa_check_plex_exist(host=>$host, conntype=>$conntype, plex_name=> $plex_name)) {
		return 0;
	} else {
		
		# online plex
      		my $o = say($conn, "aggr online $plex_name", -timeout, $RaidSqa_TIMEOUT);

		# check plex got online successfully
		if (RaidSqa_check_plex_state_name(host=>$host, conntype=>$conntype, plex_name=> $plex_name, state_name=>"online")) {
        		logcomment("RaidSqa.pm: plex $plex_name successfully onlined");
			return 1;
        	} else {
        		logcomment("RaidSqa.pm: plex $plex_name could not be onlined");
			return 0;
        	}
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_plex_destroy

RaidSqa_plex_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine destroy the plex of a mirror volume/aggr.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to destroy.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_plex_destroy {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
				conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				plex_name => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

	if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: destroying plex $plex_name");

	# check given plex is offline before starting destroy
	if (!RaidSqa_check_plex_state_name(host=>$host, conntype=>$conntype, plex_name=> $plex_name, state_name=>"offline")) {
        	logcomment("RaidSqa.pm: Can not destroy plex $plex_name as it is not offline");
		return 0;
	} else {

		# destroy given plex 
      		my $o = say($conn, "aggr destroy $plex_name -f ", -timeout, $RaidSqa_TIMEOUT);

		# Check that plex got destroyed successfully
		my $raid_obj=new RaidInfo($conn);
		my $plex_obj=$raid_obj->plex("$plex_name");

		if (!defined($plex_obj)) {
        		logcomment("RaidSqa.pm: plex $plex_name successfully destroyed");
			return 1;
        	} else {
        		logcomment("RaidSqa.pm: plex $plex_name could not be destroyed");
			return 0;
        	}
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_start

RaidSqa_hammer_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, iterations=>$iterations, file_name=>$file_name, file_size=>$file_size);

This subroutine start one hammer one a specified flex or trad volume with specified parameter on the filer.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of the test flex or trad volume.

=item iterations

(Optional): Number of iterations to run hammer. Default is "-1" which means always.

=item file_name

(Optional): Name of file to be created by hammer. Default is "HAMMER_9001"

=item file_size

(Optional): size of file to be created by hammer. Default is "-1" which means max capacity of flex or trad volume.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => {type=>SCALAR},
                                iterations => {type=>SCALAR,default=>"-1",optional=>1},
                                file_name => {type=>SCALAR,default=>"HAMMER_001",optional=>1},
                                file_size => {type=>SCALAR,default=>"-1",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $iterations = $opts{iterations};
        my $file_name = $opts{file_name};
        my $file_size = $opts{file_size};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# restarting hammer
        my($o) = say($conn, "priv -level -q diag; hammer -f $iterations /vol/$filer_vol/$file_name.$$ $file_size", -timeout, $RaidSqa_TIMEOUT);
        sleep 10;
        logcomment("RaidSqa.pm: hammer started");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_abort

RaidSqa_hammer_abort(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine abort all hammers on the filer.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_abort {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                        	conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# checking every 5 sec for a max time up to 30 minutes for hammer abort
        my($hammer_status) = "foo";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 1800; # wait 30 minutes for hammer to abort
        my($o) = say($conn, "priv -level -q diag; hammer abort", -timeout, $RaidSqa_TIMEOUT);
        while ($hammer_status ne "" && $time_waited < $max_wait) {
                $hammer_status = say($conn, "priv -level -q diag; hammer status", -timeout, $RaidSqa_TIMEOUT);
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }       
        logcomment("RaidSqa.pm: waited $time_waited seconds for hammer to abort");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_pause

RaidSqa_hammer_pause(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine pause all hammers on the filer.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_pause {
        my (%opts) = validate(@_, {
				host => { type=>OBJECT, isa=>'Hostrec' },
				filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                        	conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# checking every 5 sec for a max time up to 30 minutes for hammer pause
        my($hammer_status) = "foo";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 1800; # wait 30 minutes for hammer to abort
        my($o) = say($conn, "priv -level -q diag; hammer pause", -timeout, $RaidSqa_TIMEOUT);
        while ($hammer_status ne "" && $time_waited < $max_wait) {
                $hammer_status = say($conn, "priv -level -q diag; hammer status", -timeout, $RaidSqa_TIMEOUT);
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }       
        logcomment("RaidSqa.pm: waited $time_waited seconds for hammer to pause");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_restart

RaidSqa_hammer_restart(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine restart all hammers on the filer.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_restart {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# restarting hammer
        my($o) = say($conn, "priv -level -q diag; hammer restart", -timeout, $RaidSqa_TIMEOUT);
        sleep 30;
        logcomment("RaidSqa.pm: hammer restarted");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_status

RaidSqa_hammer_status(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine give status of hammers on the filer.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# hammer status
        logcomment("RaidSqa.pm: hammer status");
        my($o) = say($conn, "priv -level -q diag; hammer status", -timeout, $RaidSqa_TIMEOUT);
        sleep 30;
}

#------------------------------------------------------------------------------

# @burt 353764 Added the verbose option in RaidSqa_aggr_scrub_status subroutine

=head2 RaidSqa_aggr_scrub_status

RaidSqa_aggr_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default provide scrub status on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it start scrub on that particular raid object.

It returns nothing but just the scrub status o/p

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=item verbose 

(Optional) : Set this Option to get the verbose output. Default is 0. 

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_aggr_scrub_status {
               my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                verbose => { type=>SCALAR|UNDEF, default=>0,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $verbose= $opts{verbose};
        my $options = "";

        if ($verbose)
        {
            $options = "-v";
        }

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        if ($filer_vol) {
            my (undef,undef,$status) = say($conn, "priv -level -q diag;aggr scrub status $filer_vol $options", -timeout, $RaidSqa_TIMEOUT);
            return $status;
        } elsif ($plex_name) {
             my (undef,undef,$status) = say($conn, "priv -level -q diag; aggr scrub status $plex_name $options", -timeout, $RaidSqa_TIMEOUT);
             return $status;
        } elsif ($group_name) {
             my (undef,undef,$status) = say($conn, "priv -level -q diag; aggr scrub status $group_name $options", -timeout, $RaidSqa_TIMEOUT);
             return $status;
        } else {
             my (undef,undef,$status) = say($conn, "priv -level -q diag; aggr scrub status  $options", -timeout, $RaidSqa_TIMEOUT);
             return $status;
        }

}
#------------------------------------------------------------------------------
# @burt 359148 to handle null group_list in RaidSqa_aggr_scrub_start subroutine 

=head2 RaidSqa_aggr_scrub_start

RaidSqa_aggr_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default start scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it start scrub on that particular raid object.

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my @group_list;
	my $o;

        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub start $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub start $plex_name", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($group_name) {
                @group_list= "$group_name";
                (undef,undef,$o)  = say($conn, "priv -level -q diag; aggr scrub start $group_name", -timeout, $RaidSqa_TIMEOUT);
        } else {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
                (undef,undef,$o)  = say($conn, "priv -level -q diag; aggr scrub start ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") eq "-1") {
                        logcomment("RaidSqa.pm: scrub could not start on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa.pm: scrub started on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------
# @burt 359148 to handle null group_list in RaidSqa_aggr_scrub_stop subroutine

=head2 RaidSqa_aggr_scrub_stop

RaidSqa_aggr_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default stop all scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it stop scrub on that particular raid object.

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_stop {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
	my $o;
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my @group_list;
        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub stop $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub stop $plex_name", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($group_name) {
                @group_list= "$group_name";
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub stop $group_name", -timeout, $RaidSqa_TIMEOUT);
        } else {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub stop ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") ne "-1") {
                        logcomment("RaidSqa.pm: scrub could not stop on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa.pm: scrub stopped on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------
# @burt 359148 to handle null group_list in RaidSqa_aggr_scrub_suspend subroutine

=head2 RaidSqa_aggr_scrub_suspend

RaidSqa_aggr_scrub_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default suspend all scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it suspend scrub on that particular raid object.

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_suspend {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
	my $o;
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my @group_list;

        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub suspend $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub suspend $plex_name", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($group_name) {
                @group_list= "$group_name";
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub suspend $group_name", -timeout, $RaidSqa_TIMEOUT);
        } else {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub suspend ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") ne "-1") {
                        logcomment("RaidSqa.pm: scrub could not suspend on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa.pm: scrub suspended on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------
# @burt 359148 to handle null group_list in RaidSqa_aggr_scrub_resume subroutine

=head2 RaidSqa_aggr_scrub_resume

RaidSqa_aggr_scrub_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default resume scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it resume scrub on that particular raid object.

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_resume {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
	my $o;
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my @group_list;
        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
               (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub resume $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub resume $plex_name", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($group_name) {
                @group_list= "$group_name";
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub resume $group_name", -timeout, $RaidSqa_TIMEOUT);
        } else {
                @group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
                (undef,undef,$o) = say($conn, "priv -level -q diag; aggr scrub resume ", -timeout, $RaidSqa_TIMEOUT);
        }

        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") eq "-1") {
                        logcomment("RaidSqa.pm: scrub could not resume on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa.pm: scrub resumed on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------
# @burt 352313 New subroutine for providing media scrub start

=head2 RaidSqa_aggr_media_scrub_start

RaidSqa_aggr_media_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default start media_scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it start media_scrub on that particular raid object.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_aggr_media_scrub_start {
    my (%opts) =
      validate(@_,
               {host => {type => OBJECT, isa => 'Hostrec'},
                filermode =>
                  {type => SCALAR, default => "normal", optional => 1},
                conntype => {type => SCALAR, default => "#rsh", optional => 1},
                filer_vol =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                plex_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                group_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},});
    my $host       = $opts{host};
    my $filermode  = $opts{filermode};
    my $conntype   = $opts{conntype};
    my $filer_vol  = $opts{filer_vol};
    my $plex_name  = $opts{plex_name};
    my $group_name = $opts{group_name};
    my $ret_val    = 0;
    my $o;
    my @group_list;
    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);
    my $RaidSqa_TIMEOUT = 300;

    my (undef, undef, $output1) =
      say($conn, "priv set -q diag; options raid.media_scrub.enable",
          -timeout, $RaidSqa_TIMEOUT);
    my @output1 = split(/\r?\n/, $output1);
    if (grep(/on/, @output1)) {
        logcomment(
             "RaidSqa.pm: Media scrubbing is currently enabled on this system");
    }

    else {
        $ret_val = 0;
        goto AGGR_MEDIA_SCRUB_START_EXIT;
     }

    if ($filer_vol) {
       if(RaidSqa_check_aggr_exist(host=>$host, filer_vol=>$filer_vol, aggr_type  => "1" )){
        @group_list = RaidSqa_get_group_list(host => $host,filer_vol=>$filer_vol);
        }
        (undef, undef, $o) =
          say($conn, "priv set -q diag ; aggr media_scrub start $filer_vol",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($plex_name) {
       if(RaidSqa_check_plex_exist(host=>$host, plex_name=>$plex_name)){
       @group_list = RaidSqa_get_group_list(host => $host,plex_name=>$plex_name);
       }
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub start $plex_name",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($group_name) {
        @group_list = $group_name;
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub start $group_name",
              -timeout, $RaidSqa_TIMEOUT);
    } else {
         my @aggr_list = RaidSqa_get_aggr_list(host => $host);

         foreach my $aggr_list (@aggr_list) {
            if (RaidSqa_check_aggr_state_name(host       => $host,
                                              filer_vol  => $aggr_list,
                                              aggr_type  => "1",
                                              state_name => "online")
            ) {
                 @group_list = RaidSqa_get_group_list(host => $host,filer_vol=>$aggr_list);
              }
        }
        (undef, undef, $o) = say($conn, "priv set -q diag; aggr media_scrub start ",
                                 -timeout, $RaidSqa_TIMEOUT);
    }

    if ( ($o =~ /No/) || ($o =~ /Invalid/) || ($o =~ /Illegal/) ) {
        goto AGGR_MEDIA_SCRUB_START_EXIT;
    }

    foreach my $group_list (@group_list) {
        if($o!~/enabled background media scrub of $group_list/) {
            goto AGGR_MEDIA_SCRUB_START_EXIT;
        }
    }
    $ret_val = 1;

AGGR_MEDIA_SCRUB_START_EXIT:
    return $ret_val;

}


#------------------------------------------------------------------------------
# @burt 352313 New subroutine to check media scrub status 
# @burt 393285 New parameter disk_name is added 

=head2 RaidSqa_aggr_media_scrub_status

RaidSqa_aggr_media_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, disk_name=>$disk_name, group_name=>$group_name);

This subroutine by default provide media_scrub status on a given filer. But if any of the options from filer_vol, plex_name, disk_name or group_name is specified than it start media_scrub on that particular raid object.

It returns nothing but just the media_scrub status o/p

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item disk_name

(Optional) : Name of disk.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_media_scrub_status {
    my (%opts) =
      validate(@_,
               {host => {type => OBJECT, isa => 'Hostrec'},
                filermode =>
                  {type => SCALAR, default => "normal", optional => 1},
                conntype => {type => SCALAR, default => "#rsh", optional => 1},
                filer_vol =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                plex_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                disk_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                group_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},});
    my $host       = $opts{host};
    my $filermode  = $opts{filermode};
    my $conntype   = $opts{conntype};
    my $filer_vol  = $opts{filer_vol};
    my $plex_name  = $opts{plex_name};
    my $disk_name  = $opts{disk_name};
    my $group_name = $opts{group_name};
    my $o;

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);
    my $RaidSqa_TIMEOUT = 300;
    if ($filer_vol) {
        (undef, undef, $o) =
          say($conn, "priv set -q diag ; aggr media_scrub status $filer_vol",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($plex_name) {
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub status $plex_name",
              -timeout, $RaidSqa_TIMEOUT);
	}elsif ($disk_name) {
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub status -s $disk_name",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($group_name) {
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub status $group_name",
              -timeout, $RaidSqa_TIMEOUT);
    } else {
        (undef, undef, $o) = say($conn, "priv set -q diag; aggr media_scrub status ",
                                 -timeout, $RaidSqa_TIMEOUT);

    }

    return $o;
}

#------------------------------------------------------------------------------
# @burt 352313 New subroutine for providing media scrub stop

=head2 RaidSqa_aggr_media_scrub_stop

RaidSqa_aggr_media_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default stop all media scrub on a given filer. But if any of the options from filer_vol, plex_name or group_name is specified than it stop media_scrub on that particular raid object.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_media_scrub_stop {
    my (%opts) =
      validate(@_,
               {host => {type => OBJECT, isa => 'Hostrec'},
                filermode =>
                  {type => SCALAR, default => "normal", optional => 1},
                conntype => {type => SCALAR, default => "#rsh", optional => 1},
                filer_vol =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                plex_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},
                group_name =>
                  {type => SCALAR | UNDEF, default => undef, optional => 1},});
    my $host       = $opts{host};
    my $filermode  = $opts{filermode};
    my $conntype   = $opts{conntype};
    my $filer_vol  = $opts{filer_vol};
    my $plex_name  = $opts{plex_name};
    my $group_name = $opts{group_name};
    my $ret_val    = 0;
    my $o;
    my @group_list;

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);
    my $RaidSqa_TIMEOUT = 300;

    my (undef, undef, $output1) =
      say($conn, "priv set -q diag; options raid.media_scrub.enable",
          -timeout, $RaidSqa_TIMEOUT);
    my @output1 = split(/\r?\n/, $output1);
    if (grep(/on/, @output1)) {
        logcomment(
             "RaidSqa.pm: Media scrubbing is currently enabled on this system");
    }
    else {
        goto AGGR_MEDIA_SCRUB_STOP_EXIT;
    }


    if ($filer_vol) {
        if(RaidSqa_check_aggr_exist(host=>$host, filer_vol=>$filer_vol, aggr_type  => "1" )){
            @group_list = RaidSqa_get_group_list(host => $host,filer_vol=>$filer_vol);
        }
        (undef, undef, $o) =
          say($conn, "priv set -q diag  ; aggr media_scrub stop $filer_vol",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($plex_name) {
        if(RaidSqa_check_plex_exist(host=>$host, plex_name=>$plex_name)){
            @group_list = RaidSqa_get_group_list(host => $host,plex_name=>$plex_name);
        }
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub stop $plex_name",
              -timeout, $RaidSqa_TIMEOUT);
    } elsif ($group_name) {
        @group_list = $group_name;
        (undef, undef, $o) =
          say($conn, "priv set -q diag; aggr media_scrub stop $group_name",
              -timeout, $RaidSqa_TIMEOUT);
    } else {
         my @aggr_list = RaidSqa_get_aggr_list(host => $host);

         foreach my $aggr_list (@aggr_list) {
             if (RaidSqa_check_aggr_state_name(host       => $host,
                                              filer_vol  => $aggr_list,
                                              aggr_type  => "1",
                                              state_name => "online")
              ) {
                   @group_list = RaidSqa_get_group_list(host => $host,filer_vol=>$aggr_list);
             }
        }
        (undef, undef, $o) = say($conn, "priv set -q diag; aggr media_scrub stop ",
                                 -timeout, $RaidSqa_TIMEOUT);
    }

    if ( ($o =~ /No/) || ($o =~ /Invalid/) || ($o =~ /Illegal/) ) {
        goto AGGR_MEDIA_SCRUB_STOP_EXIT;
    }

    foreach my $group_list (@group_list) {
        if($o!~/disabled background media scrub of $group_list/){
            goto AGGR_MEDIA_SCRUB_STOP_EXIT;
        }
    }

    $ret_val = 1;

AGGR_MEDIA_SCRUB_STOP_EXIT:

    return $ret_val;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_verify_status

RaidSqa_aggr_verify_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by check the status of verify on a given filer. But if option filer_vol is given than start verify on that particular aggr/tradvol.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_verify_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
	if ($filer_vol) {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify status $filer_vol", -timeout, $RaidSqa_TIMEOUT);
		return $output;
	} else {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify status ", -timeout, $RaidSqa_TIMEOUT);
		return $output;
	}

}


#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_verify_start

RaidSqa_aggr_verify_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_number=>$plex_number);

This subroutine by default start verify on a given filer's all mirrored aggr/tradvols. But if option filer_vol is given than start verify on that particular aggr/tradvol. If plex_number along with filer_vol is given than use that plex as destination for verify.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_number

(Optional) : Number of plex.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_verify_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_number => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_number = $opts{plex_number};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
	if (($filer_vol) && !defined($plex_number))  {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify start $filer_vol");
	} elsif (($filer_vol) && ($plex_number)) {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify start $filer_vol -f $plex_number");
	} else {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify start ");
	}

       # if($output =~ /not/ || $output =~ /already running/ ) {
       #   	return 0; 
       # } elsif ($output =~ /start mirror verification/) {
       #   	return 1;
       # }

# need to enable following code once burt 249002 got fixed
        #sleep 10;
	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate("$filer_vol");
	
       if ($aggr_obj->parameter("verifypct") eq "-1") {
                sleep 5;
                $raid_obj->refresh();
                if ($aggr_obj->parameter("verifypct") eq "-1") {
                        logcomment("RaidSqa.pm: verify could not start on aggr/tradvol $filer_vol");
                        return 0;
                } else {
                        logcomment("RaidSqa.pm: verify started on aggr/tradvol $filer_vol");
                        return 1;
                }

	} else {
		logcomment("RaidSqa.pm: verify started on aggr/tradvol $filer_vol"); 	
		return 1;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_verify_stop

RaidSqa_aggr_verify_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by default stop all aggr/vol verify on a given filer. But if filer_vol is defined than it run verify only on that aggr/travol but it should be mirrored.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_verify_stop {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
	if ($filer_vol) {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify stop $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	} else {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify stop ", -timeout, $RaidSqa_TIMEOUT);
	}

#        if($output =~ /No verify running/ || $output =~ //) {
#          	return 1; 
#        } else {
#          	return 0;
#        }
	
        sleep 20;
	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate("$filer_vol");
	
       	if ($aggr_obj->parameter("verifypct") ne "-1") {
		logcomment("RaidSqa.pm: verify could not stop on aggr/tradvol $filer_vol"); 	
		return 0;
	} else {
		logcomment("RaidSqa.pm: verify stopped on aggr/tradvol $filer_vol"); 	
		return 1;
	}
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_verify_suspend

RaidSqa_aggr_verify_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by default suspend all verify on a given filer. But if filer_vol is provided than suspend verify only on that aggr/tradvol.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_verify_suspend {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
	if ($filer_vol) {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify suspend $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	} else {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify suspend ", -timeout, $RaidSqa_TIMEOUT);
	}
	
#        if($output =~ /suspend mirror verification/ ) {
#          	return 1; 
#        } else {
#          	return 0;
#        }
	
        sleep 10;
	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate("$filer_vol");
	
       if ($aggr_obj->parameter("verifypct") ne "-1") {
		logcomment("RaidSqa.pm: verify could not suspend on aggr/tradvol $filer_vol"); 	
		return 0;
	} else {
		logcomment("RaidSqa.pm: verify suspened on aggr/tradvol $filer_vol"); 	
		return 1;
	}
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_verify_resume

RaidSqa_aggr_verify_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by default resume verify on a given filer. But if filer_vol is provided than resum verify only on that.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_verify_resume {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
	if ($filer_vol) {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify resume $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	} else {
        	(undef, undef, $output) = say($conn, "priv -level -q diag; aggr verify resume ", -timeout, $RaidSqa_TIMEOUT);
	}
	
#        if($output =~ /resume mirror verification/ ) {
#          	return 1; 
#        } else {
#          	return 0;
#        }
	
        sleep 10;
	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate("$filer_vol");
	
       if ($aggr_obj->parameter("verifypct") eq "-1") {
		logcomment("RaidSqa.pm: verify could not resume on aggr/tradvol $filer_vol"); 	
		return 0;
	} else {
		logcomment("RaidSqa.pm: verify resumed on aggr/tradvol $filer_vol"); 	
		return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_options

RaidSqa_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options, value=>$value);

This subroutine set various options specified by options parameter to a value specified by value parameter for a given volume/aggregate.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggr or trad vol.

=item options

(Required) : Name of options or trad set or change.

=item value

(Required) : value of the options.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR},
                                options => {type=>SCALAR},
                                value => {type=>SCALAR},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};
        my $value = $opts{value};
	
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
	
        (undef, undef, $output) = say($conn, "priv -level -q diag; aggr options $filer_vol $options $value", -timeout, $RaidSqa_TIMEOUT);

	if (RaidSqa_get_aggr_options(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol, options=>$options) eq "$value") {
		return 1;
	} else {
		return 0;
	}

}



#------------------------------------------------------------------------------

=head2 RaidSqa_set_aggr_raid_lost_write

RaidSqa_set_aggr_raid_lost_write(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, option_value=>$option_value);

This subroutine enables/disables the aggr option raid_lost_write.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(required) : Name of vol/aggr on/for which raid_lost_write option should be disabled.

=item option_value

(Optional): Value of option raid_lost_write to be set for aggr $filer_vol

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_set_aggr_raid_lost_write {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                option_value => {type=>SCALAR},
                                filer_vol => {type=>SCALAR}
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_value = $opts{option_value};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $option_name1 = 'raid_lost_write';
        my $option_name2 = "raid.lost_write.interactive.enable";

        my $value_raid_lost_write = RaidSqa_get_aggr_options(host => $host,filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol,options => $option_name1);

        if ($value_raid_lost_write eq $option_value) {
            logcomment("RaidSqa.pm: options $option_name1 for $filer_vol is set to $option_value\n");
        } else {

            # Get value for option raid.lost_write.interactive.enable to set it back to original value
            # $value_lw_interactive_option holds orginal value of system option raid.lost_write.interactive.enable
            my $value_lw_interactive_option = RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2);
            
            # $reset_interactive_flag is used to indicate if resetting the value of lw interactive option is required.
            # If 1, lw interactive option will be reset to its orignal value
            my $reset_interactive_flag = undef;
            # Disable option raid.lost_write.interactive.enable
            if ($value_lw_interactive_option eq "on" ) {
                RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2, option_value=>"off");                
                $reset_interactive_flag = 1;
                sleep(5);
            }
            # -f is required even if interactive option is off
            RaidSqa_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$option_name1, value=>"$option_value -f");
            sleep(5);
            $value_raid_lost_write = RaidSqa_get_aggr_options(host => $host, filermode=>$filermode, conntype=>$conntype,filer_vol => $filer_vol, options => $option_name1);
                
            if ($value_raid_lost_write ne $option_value) {
                logcomment("RaidSqa.pm: options $option_name1 for $filer_vol could not set to $option_value\n");
                return(0);
            } else {
                logcomment("RaidSqa.pm: options $option_name1 for $filer_vol set to $option_value\n");
            }
            # Reset the value for options raid.lost_write.interactive.enable
            if (defined($reset_interactive_flag)) {
                RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2, option_value=>$value_lw_interactive_option);
            }
        }
        return(1);
}


#------------------------------------------------------------------------------

=head2 RaidSqa_disk_zero_spares

RaidSqa_disk_zero_spares(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine start zeroing on all notzeroed spares.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_zero_spares {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# starting zeroing on all spares
        logcomment("RaidSqa.pm: starting zeroing in spare disk.");
        my($o) = say($conn, "disk zero spares", -timeout, $RaidSqa_TIMEOUT);
}

#------------------------------------------------------------------------------

# @burt 352332 Modified for the case when disk is already in broken pool.

=head2 RaidSqa_disk_remove

RaidSqa_disk_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine remove the one spare disk or all spare disks from spare list and move them to broken list nonpersistantly.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of spare disk to remove, if all than it will remove all spare disks.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_disk_remove {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	# removing all spare disks from raid if disk_name is given as "all"
        if ($disk_name eq "all" ) {
        #	$raid_obj = new RaidInfo($conn);
        	my %spare_disks_hash = $raid_obj->spare_disks();
        	my @spare_disks_list = keys(%spare_disks_hash);

                if (!@spare_disks_list) {
                        logcomment("RaidSqa.pm: No spare Disk in system.");
                        return 1;
                }

                logcomment("RaidSqa.pm: Removing all spare disks : @spare_disks_list \n");

       	 	my $disk;
                foreach $disk (@spare_disks_list) {
                        #my $disk_obj=$raid_obj->disk("$disk");
			#my $disk_path1=$disk_obj->parameter("path_name1");
			#my $disk_path2=$disk_obj->parameter("path_name2");
			my $disk_obj;
			my $disk_path1=$spare_disks_hash{$disk}{"path_name1"};
			my $disk_path2=$spare_disks_hash{$disk}{"path_name2"};
                        my $output = say($conn, "priv -level -q diag; disk remove $disk", -timeout, $RaidSqa_TIMEOUT);
                        sleep 10;
                        $raid_obj->refresh();
                        sleep 10;
                        if (!($disk_obj=$raid_obj->disk("$disk_path1"))) {
				$disk_obj=$raid_obj->disk("$disk_path2");
			}
                        if ($disk_obj->parameter("fsm_state") ne "FAILED") {
                                logcomment("RaidSqa.pm: Disk $disk could not be admin removed.");
                                return 0;
			} else {
                        	logcomment("RaidSqa.pm: Disk $disk successfully removed.");
                	}
                }

        	$raid_obj->refresh();
        	%spare_disks_hash = $raid_obj->spare_disks();
        	@spare_disks_list = keys(%spare_disks_hash);

		# checking all spare disks has been removed
		if (!@spare_disks_list) {
                	logcomment("RaidSqa.pm: There is no spare disk in the system");
                	return 1;

		} else {

			logcomment("RaidSqa.pm: Filer still have some spare disks: @spare_disks_list \n"); 
			return 0;
		}

	} else {
	
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		# removing a specified disk from raid

		my (undef, undef,$output)=say($conn, "disk remove $disk_name", -timeout, $RaidSqa_TIMEOUT);
		sleep 10;

                if ($output =~ /broken pool/) {                                                                    
                        logcomment("$disk_name is already in broken pool");                                       
                        return 0;                                           
                }                                                                               

		if (!RaidSqa_check_disk_fsm_state(host=>$host, conntype=>$conntype, disk_name =>$disk_name, fsm_state=>"FAILED")) {
                	logcomment("RaidSqa.pm: disk $disk_name is still not in failed (admin removed) state");
               		return 0;

		} else {
                	logcomment("RaidSqa.pm: spare disk $disk_name removed from spare list");
			return 1;
		}
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_fail

RaidSqa_disk_fail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, options=>$options);

This subroutine fail/prefail the disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to fail/prefail.

=item options

(Optional) : need to give as "-i" for disk fail otherwise disk will prefail.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_fail {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
				options => { type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
			my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
			if($disk_name1){
				logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
				$disk_name=$disk_name1;
			}else{
				logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
				return(0);
			}
		}
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $output;

	# checking that specified disk is a file system disk before failing it
	if ($disk_obj->parameter("fsm_state") eq "INUSE") {
		if (defined($options)) {
        		$output=say($conn, "disk fail $options -f $disk_name", -timeout, $RaidSqa_TIMEOUT);
        		sleep 10;
		} else {
        		$output=say($conn, "disk fail -f $disk_name", -timeout, $RaidSqa_TIMEOUT);
        		sleep 10;
		}
		
	} else {
		logcomment("RaidSqa.pm: disk $disk_name is not a file system disk, so can not fail/prefail");
                return 0;
	}	

    $raid_obj->refresh();
    $disk_name =
      RaidSqa_find_active_path_disk_name(host      => $host,
                                         filermode => $filermode,
                                         conntype  => $conntype,
                                         disk_name => $disk_name);
    $disk_obj = $raid_obj->disk("$disk_name");
    if (!defined($disk_obj)) {
        logcomment("RaidSqa.pm: The disk with name $disk_name does not exist");
        return (0);
    }

	# check disk got failed/prefailed successfully	
	if (!defined($options)) {
		if ($disk_obj->parameter("prefail") eq "1") {
                	logcomment("RaidSqa.pm: disk $disk_name got prefailed successfully");
                	return 1;
		} else {
                	logcomment("RaidSqa.pm: Disk $disk_name could not be prefailed.");
			return 0;
        	}
	
	} elsif ($options eq "-i") {
		if ($disk_obj->parameter("fsm_state") eq "FAILED") {
                	logcomment("RaidSqa.pm: disk $disk_name got failed successfully");
                	return 1;
		} else {
                	logcomment("RaidSqa.pm: Disk $disk_name could not be failed.");
			return 0;
        	}
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_unfail

RaidSqa_disk_unfail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>$options);

This subroutine unfail one failed disk or all failed disks. If no options given than it is just use "disk unfail" otherwise we can pass options "-s" to this function to make disk as spare in all cases.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of failed disk to unfail, if all than it will unfail all failed disks.

=item options

(Optional) : we can pass options "-s" if we want to spare out the failed disk.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_unfail {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
				options => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);

	# if disk_name is given as "all" than unfail all disks using specified options like "-s" to make it spare or without "-s" to assimilate to previous state
	if ($disk_name eq "all" ) {
       		my %failed_disks_hash = $raid_obj->failed_disks();
       		my @failed_disks_list = keys(%failed_disks_hash);

		if (!@failed_disks_list) {
			logcomment("RaidSqa.pm: No failed Disk in system.");
                	return 1;
		}

        	logcomment("RaidSqa.pm: Unfailing all failed disks: @failed_disks_list \n");
        	my $disk;
        	foreach $disk (@failed_disks_list) {
			my $disk_obj;
				my $disk_path1=$failed_disks_hash{$disk}{"path_name1"};
				my $disk_path2=$failed_disks_hash{$disk}{"path_name2"};

				my $output = say($conn, "priv -level -q diag; disk unfail $options $disk", -timeout, $RaidSqa_TIMEOUT);
				sleep 10;
				$raid_obj->refresh();
				sleep 10;
				if (!($disk_obj=$raid_obj->disk("$disk_path1"))) {
				   $disk_obj=$raid_obj->disk("$disk_path2");
				}
				#my $disk_obj=$raid_obj->disk("$disk");
				if ($disk_obj->parameter("fsm_state") eq "FAILED") {
					logcomment("RaidSqa.pm: Disk $disk could not be unfailed.");
				} else {
					logcomment("RaidSqa.pm: Disk $disk successfully unfailed.");
				}
        	}

        	$raid_obj->refresh();
        	%failed_disks_hash = $raid_obj->failed_disks();
        	@failed_disks_list = keys(%failed_disks_hash);

		# check all disk got unfailed
		if (!@failed_disks_list) {
                	logcomment("RaidSqa.pm: There is no failed disk in the system");
                	return 1;

		} else {

			logcomment("RaidSqa.pm: Filer still have some failed disks: @failed_disks_list \n"); 
			return 0;
		}

	} else {
		# unfail a specified disk using specified options like "-s" to make it spare or without "-s" to assimilate to previous state
		my $output;
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		if ($options) {
                	$output=say($conn, "priv -level -q diag; disk unfail $options $disk_name", -timeout, $RaidSqa_TIMEOUT);
		} else {
                	$output=say($conn, "priv -level -q diag; disk unfail $disk_name", -timeout, $RaidSqa_TIMEOUT);
		}
		sleep 10;
		$raid_obj->refresh();
        $disk_name =
          RaidSqa_find_active_path_disk_name(host      => $host,
                                             filermode => $filermode,
                                             conntype  => $conntype,
                                             disk_name => $disk_name);        
        my $disk_obj = $raid_obj->disk("$disk_name");
        if (!$disk_obj) {
            logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
            return 0;
        }
                if ($disk_obj->parameter("fsm_state") eq "FAILED") {
                       	logcomment("RaidSqa.pm: Disk $disk_name could not be unfailed.");
			return 0;
		} else {
                       	logcomment("RaidSqa.pm: Disk $disk_name successfully unfailed.");
			return 1;
                }
	}
}
#------------------------------------------------------------------------------

=head2 RaidSqa_disk_replace_start

RaidSqa_disk_replace_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, replacing_disk => $replacing_disk, options=>$options);

This subroutine replace the disk with specified disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be replaced.

=item replacing_disk

(Required) : Name of disk to replace .

=item options

(Optional) : The option -m allows mixing disks with different characteristics.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_replace_start {
    my (%opts) =
      validate(@_,
               {host      => {type => OBJECT, isa     => 'Hostrec'},
                filermode => {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#rsh", optional => 1},
                disk_name => {type => SCALAR},
                replacing_disk => {type => SCALAR},
                options   => {type => SCALAR | UNDEF, default => undef, optional => 1},});

    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
    my $replacing_disk = $opts{replacing_disk};
    my $options = $opts{options};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    #Check if disk name exists or has an equivalent path_name2.
    if (defined($disk_name)) {
        my $disk_name1 = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $disk_name);
        if ($disk_name1) {
            logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
            $disk_name = $disk_name1;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    my $raid_obj = new RaidInfo($conn);
    my $disk_obj = $raid_obj->disk("$disk_name");
    my $output;

    #Check if replacing disk name exists or has an equivalent path_name2.
    if (defined($replacing_disk)) {
        my $replacing_disk1 = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $replacing_disk);
        if ($replacing_disk1) {
            logcomment("RaidSqa.pm: Using path name $replacing_disk1 for any operations on $replacing_disk.\n");
            $replacing_disk = $replacing_disk1;
        } else {
            logcomment("RaidSqa.pm: The disk name $replacing_disk specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    # checking that specified disk is a file system disk before replacing it
    if ($disk_obj->parameter("fsm_state") eq "INUSE") {
        if (defined($options)) {
            $output = say($conn, "disk replace start -f $options $disk_name $replacing_disk", -timeout, $RaidSqa_TIMEOUT);
            sleep 10;
        } else {
            $output = say($conn, "disk replace start -f $disk_name $replacing_disk", -timeout, $RaidSqa_TIMEOUT);
            sleep 10;
        }

    } else {
        logcomment("RaidSqa.pm: disk $disk_name is not a file system disk, so can not replace");
        return 0;
    }

    #Check if disk name exists after replace or has an equivalent path_name2.
    if (defined($disk_name)) {
        my $disk_name1 = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $disk_name);
        if ($disk_name1) {
            logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
            $disk_name = $disk_name1;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    $raid_obj->refresh();
    $disk_name =
      RaidSqa_find_active_path_disk_name(host      => $host,
                                         disk_name => $disk_name);
    $disk_obj = $raid_obj->disk("$disk_name");
    if (!$disk_obj) {
        logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
        return 0;
    }

    # check disk got replaced successfully
        if ($disk_obj->parameter("replace") eq "1") {
            logcomment("RaidSqa.pm: disk $disk_name got replaced successfully");
            return 1;
        } else {
            logcomment("RaidSqa.pm: Disk $disk_name could not be replaced with disk $replacing_disk");
            return 0;
        }

} 

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_offline

RaidSqa_disk_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, options=>$options);

This subroutine offline the disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to offline.

=item options

(Optional) : bdfu or timeout.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_offline {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
				options => { type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	if (!defined($options)) {
        	my $output=say($conn, "priv set -q diag;disk offline $disk_name", -timeout, $RaidSqa_TIMEOUT);
	} else {
        	my $output=say($conn, "priv set -q diag;disk offline -t $options $disk_name", -timeout, $RaidSqa_TIMEOUT);
	}	

	sleep 10;
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");

	# check disk got offlined	
	if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
               	logcomment("RaidSqa.pm: disk $disk_name got offline successfully");
               	return 1;
	} else {
               	logcomment("RaidSqa.pm: Disk $disk_name could not be offlined.");
		return 0;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_online

RaidSqa_disk_online(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine online one disk or all offline disks if disk name is given as "all".

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to online. if all than online all offline disks in filer

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_online {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj = new RaidInfo($conn);

	if ($disk_name eq "all") {
		my @offline_disks=RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, fsm_state=>"OFFLINE");		
		foreach my $disk_name (@offline_disks) {
        		my $output=say($conn, "priv set -q diag;disk online $disk_name", -timeout, $RaidSqa_TIMEOUT);
			sleep 10;
            $raid_obj->refresh();
            $disk_name = RaidSqa_find_active_path_disk_name(host => $host, disk_name => $disk_name);
            my $disk_obj = $raid_obj->disk("$disk_name");

            if (!$disk_obj) {
                logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
                return 0;
            }
			# check disk got onlined	
			if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
               			logcomment("RaidSqa.pm: Disk $disk_name still offlined.");
				return 0;
			} elsif (($disk_obj->parameter("fsm_state") eq "RECONS") || ($disk_obj->parameter("fsm_state") eq "INUSE") || ($disk_obj->parameter("fsm_state") eq "ZEROED") || ($disk_obj->parameter("fsm_state") eq "NOTZEROED")) {
               			logcomment("RaidSqa.pm: disk $disk_name got online successfully");
			} else {
               			logcomment("RaidSqa.pm: Disk $disk_name could not be onlined.");
				return 0;
        		}
		}
		return 1;
	} else {
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
        	my $output=say($conn, "priv set -q diag;disk online $disk_name", -timeout, $RaidSqa_TIMEOUT);
		sleep 10;
        $raid_obj->refresh();
        $disk_name = RaidSqa_find_active_path_disk_name(host => $host, disk_name => $disk_name);
        my $disk_obj = $raid_obj->disk("$disk_name");
        if (!$disk_obj) {
            logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
            return 0;
        }

		# check disk got onlined	
		if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
               		logcomment("RaidSqa.pm: Disk $disk_name still offlined.");
			return 0;
        	} elsif (($disk_obj->parameter("fsm_state") eq "RECONS") || ($disk_obj->parameter("fsm_state") eq "INUSE") || ($disk_obj->parameter("fsm_state") eq "ZEROED") || ($disk_obj->parameter("fsm_state") eq "NOTZEROED")) {
               		logcomment("RaidSqa.pm: disk $disk_name got onlined successfully");
               		return 1;
		} else {
               		logcomment("RaidSqa.pm: Disk $disk_name could not be onlined.");
			return 0;
        }
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_mung

RaidSqa_disk_mung(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, sector=>$sector, bits=>$bits);

This subroutine mung a sector(block) of disks. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of the disk.

=item sector

(Required): sector number of disk.

=item bits

(Optional): Number of consecutive bits to mung. 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_mung {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                sector => { type=>SCALAR },
                                bits => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
        my $sector = $opts{sector};
        my $bits = $opts{bits};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	
	if (defined($bits)) {
		(undef,undef,$output)=say($conn, "priv set -q test; disk_mung $disk_name $sector $bits ", -timeout, $RaidSqa_TIMEOUT);
	} else {
		(undef,undef,$output)=say($conn, "priv set -q test; disk_mung $disk_name $sector ", -timeout, $RaidSqa_TIMEOUT);
	}

        if ($output =~ /scsi_write_long succeeded on block $sector/ ) {
                return 1;
        } else {
                return 0;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_assign

RaidSqa_disk_assign(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, disk_list=>\@disk_list, pool=>$pool);

This subroutine assign one or more disk to filer in defined pool.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): name of disk. (but any one of disk_list or disk_name is required)

=item disk_list

(Optional): refrence to the list of disk (but any one of disk_list or disk_name is required)

=item pool

(Required): pool 0 or 1 .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_assign {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef, optional=>1  },
                                disk_name => { type=>SCALAR|UNDEF, default=>undef, optional=>1  },
                                pool => { type=>SCALAR,default=>0,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        my $disk_list = $opts{disk_list};
        my $pool = $opts{pool};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	if (!defined($disk_name) && !defined($disk_list)) {
		logcomment("RaidSqa.pm: None of the parameter $disk_list or $disk_name defined, need to define one of them \n");
		return 0;
	} elsif (defined($disk_name) && defined($disk_list))  {
		logcomment("RaidSqa.pm: Both of the parameter $disk_list or $disk_name defined, need to define only one of them \n");
		return 0;
	} 
		

	my $output;
	
	if (defined($disk_name)) {
		say($conn, "priv set -q diag; disk assign -f  -p $pool $disk_name", -timeout, $RaidSqa_TIMEOUT);
		return 1;
	} elsif (defined($disk_list)) {
        	my @disk_list = @$disk_list;
		say($conn, "priv set -q test; disk assign -f  -p $pool @disk_list", -timeout, $RaidSqa_TIMEOUT);
		return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_remove_ownership

RaidSqa_disk_remove_ownership(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, disk_list=>\@disk_list);

This subroutine remove_ownership of one or more disk from filer .

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): name of disk. (but any one of disk_list or disk_name is required)

=item disk_list

(Optional): refrence to the list of disk (but any one of disk_list or disk_name is required)

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_remove_ownership {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef, optional=>1  },
                                disk_name => { type=>SCALAR|UNDEF, default=>undef, optional=>1  },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		my $disk_list = $opts{disk_list};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	if (!defined($disk_name) && !defined($disk_list)) {
		logcomment("RaidSqa.pm: None of the parameter $disk_list or $disk_name defined, need to define one of them \n");
		return 0;
	} elsif (defined($disk_name) && defined($disk_list))  {
		logcomment("RaidSqa.pm: Both of the parameter $disk_list or $disk_name defined, need to define only one of them \n");
		return 0;
	} 
		
	
	if (defined($disk_name)) {
		say($conn, "priv set -q diag; disk remove_ownership -f  $disk_name", -timeout, $RaidSqa_TIMEOUT);
		return 1;
	} elsif (defined($disk_list)) {
        	my @disk_list = @$disk_list;
		say($conn, "priv set -q test; disk remove_ownership -f  @disk_list", -timeout, $RaidSqa_TIMEOUT);
		return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_setflag

RaidSqa_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name, flag_value=>$flag_value);

This subroutine set flags using setflag command. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item flag_name

(Required): Name of the flag to add.

=item flag_value

(Required): Value of the flag to add.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_setflag {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                flag_name => { type=>SCALAR },
                                flag_value => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $flag_name = $opts{flag_name};
        my $flag_value = $opts{flag_value};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        # Adding specified flag using setflag command
        (undef,undef,$output)=say($conn, "priv set -q test; setflag $flag_name $flag_value", -timeout, $RaidSqa_TIMEOUT);
	logcomment("RaidSqa.pm: setflag $flag_name $flag_value set \n");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_set_options

RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name, option_value=>$option_value);

This subroutine set options on filer using options command.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item option_name

(Required): Name of the option to change.

=item option_value

(Required): Value of the option to change.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_set_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                option_name => { type=>SCALAR },
                                option_value => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_name = $opts{option_name};
        my $option_value = $opts{option_value};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        # changing options value using options command
        (undef,undef,$output)=say($conn, "priv set -q test; options $option_name $option_value", -timeout, $RaidSqa_TIMEOUT);
	logcomment("RaidSqa.pm: options $option_name $option_value set \n");
}


#------------------------------------------------------------------------------
=head2 RaidSqa_set_raid_lw_opt

RaidSqa_set_raid_lw_opt(host=>$host, filermode=>$filermode, conntype=>$conntype, option_value=>$option_value);

This subroutine enables/disables the system wide option raid_lw_opt.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
             options doesn't exist in maint mode. So this function is not applicable to maint mode.

=item conntype

(Optional): Connection type to use. Default is "#rsh"

=item option_value

(Optional): Value of option raid_lw_opt to be set

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_set_raid_lw_opt {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                option_value => {type=>SCALAR}
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_value = $opts{option_value};

        my $conn = make_conn($host,$conntype);
        my $option_name1 = "raid.lost_write.enable";
        my $option_name2 = "raid.lost_write.interactive.enable";

        if($filermode eq "MAINT") {
            logcomment("RaidSqa.pm: Options command is not available in MAINT mode");
            return(0);
        }
        
        my $value_raid_lost_write = RaidSqa_get_options(host => $host, filermode=>$filermode, conntype=>$conntype,option_name => $option_name1);
        if ($value_raid_lost_write eq $option_value) {
            logcomment("RaidSqa.pm: options $option_name1 already set to $option_value\n");			
        } else {
            # Get value for option raid.lost_write.interactive.enable to set it back to original value
            # $value_lw_interactive_option holds orginal value of system option raid.lost_write.interactive.enable
            my $value_lw_interactive_option = RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2);
            
            # $reset_interactive_flag is used to indicate if resetting the value of lw interactive option is required.
            # If 1, lw interactive option will be reset to its orignal value
            my $reset_interactive_flag = undef;
            # Disable option raid.lost_write.interactive.enable
            if ($value_lw_interactive_option eq "on" ) {
                RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2, option_value=>"off");
                $reset_interactive_flag = 1;
                sleep(5);
            }
            RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name1, option_value=>$option_value);
            sleep(5);
            $value_raid_lost_write = RaidSqa_get_options(host => $host, filermode=>$filermode, conntype=>$conntype,option_name => $option_name1);
                
            if ($value_raid_lost_write ne $option_value ) {
                logcomment("RaidSqa.pm: options $option_name1 could not set to $option_value\n");
                return(0);
            } else {
                logcomment("RaidSqa.pm: options $option_name1 set to $option_value\n");
            }
            # Reset the value for options raid.lost_write.interactive.enable
            if (defined($reset_interactive_flag)) {
                RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name2, option_value=>$value_lw_interactive_option);
            }
        }
        return(1);
}

#------------------------------------------------------------------------------

#------------------------------------------------------------------------------

=head2 RaidSqa_license_add_by_code

RaidSqa_license_add_by_code(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine add license using a particular code. It does not check the platform or any thing. 

return 1 on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item code

(Required): Particular code for license to add.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_license_add_by_code {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                code => { type=>SCALAR },
                                }
                        );
        my $code  = $opts{code};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);
	return 1;
}
	
#------------------------------------------------------------------------------

=head2 RaidSqa_license_add_by_service

RaidSqa_license_add_by_service(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine add license for a particular service. Need a non-promoted debug build as 1st get code for that particular service for particular platform and than add that code.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to add license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_license_add_by_service {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $service  = $opts{service};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	my $line;
	my @info;
	my $code ="0";
	
	# Adding license for a specified service by getting it using secret_code for legacy platforms
	(undef,undef,$output)=say($conn, "priv set -q test; secret_code 1 $service", -timeout, $RaidSqa_TIMEOUT);
	@info = split(/\r?\n/, $output);
	foreach $line (@info){
		if ($line =~ /$service/  && $line =~ /(.*)=(.*)/ ) {
		  $code=$2;
		  logcomment("RaidSqa.pm: lic for $service is: $code. \n");
		 }
	}
	if ($code eq "0" ) {
		logresult('FATAL', "There's no such service: $service exists. \n");
		exit;
	}

	(undef,undef,$output) = say ($conn, "priv set -q diag; license add $code");
	
	# Adding license for a specified service by getting it using secret_code for Gateway 
	if ($output =~ /invalid platform/ ) {
		(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p Gateway 1 $service", -timeout, $RaidSqa_TIMEOUT);
		@info = split(/\r?\n/, $output);
		foreach $line (@info){
		  if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
		    $code=$2;
		  }
		 }
	}
	(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);
	
	# Adding license for a specified service by getting it using secret_code for NearStore 
	if ($output =~ /invalid platform/ ) {
		(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p NearStore 1 $service", -timeout, $RaidSqa_TIMEOUT);
		@info = split(/\r?\n/, $output);
		foreach $line (@info){
		  if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
		    $code=$2;
		  }
		 }
	}
	(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);
	
	# Adding license for a specified service by getting it using secret_code for simulator 
	if ($output =~ /invalid platform/ ) {
		(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p SIM 1 $service", -timeout, $RaidSqa_TIMEOUT);
		@info = split(/\r?\n/, $output);
		foreach $line (@info){
		  if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
		    $code=$2;
		  }
		 }
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_license_delete

RaidSqa_license_delete(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine delete license for a particular service.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to delete license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_license_delete {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $service  = $opts{service};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; license delete $service", -timeout, $RaidSqa_TIMEOUT);

	if (RaidSqa_check_license(host=>$host, conntype=>$conntype, service=>$service)) {
		return 0;
	} else {
		return 1;
	} 
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_filter

RaidSqa_fiji_filter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine add a defined fiji filter to the filer.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to add to the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_filter {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; fiji filter \"$fiji_point\" ", -timeout, $RaidSqa_TIMEOUT);

	if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
		return 1;
	} else {
		return 0;
	} 
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_nvfilter

RaidSqa_fiji_nvfilter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine add a defined fiji nvfilter to the filer.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to add to the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_nvfilter {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvfilter \"$fiji_point\" ", -timeout, $RaidSqa_TIMEOUT);

	if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
		return 1;
	} else {
		return 0;
	} 
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_clear

RaidSqa_fiji_clear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine clear a defined fiji filter from the filer. Use all  as fiji point for clearing all fiji filter

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to clear from the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_clear {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	my $slot;
	if ($fiji_point eq "all") {
		(undef,undef,$output) = say($conn, "priv set -q diag; fiji clear all", -timeout, $RaidSqa_TIMEOUT);
	} else {
		my @fiji_slot=RaidSqa_get_fiji_slot(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point);
		foreach $slot (@fiji_slot) {
			(undef,undef,$output) = say($conn, "priv set -q diag; fiji clear $slot ", -timeout, $RaidSqa_TIMEOUT);
		}

	}
	if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
		return 0;
	} else {
		return 1;
	} 

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_nvclear

RaidSqa_fiji_nvclear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine nvclear a defined fiji nvfilter from the filer. Give fiji_point as all if want to delete all fiji filters.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to nvclear from the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_nvclear {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	my $slot;

	if ($fiji_point eq "all") {
		(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvclear all", -timeout, $RaidSqa_TIMEOUT);
		if ($output =~ /filter cleared/) {
			logcomment("RaidSqa.pm : fiji: filter cleared (nvram only) from slot $slot");
		} else {
			logcomment("RaidSqa.pm : fiji: filter not cleared (nvram only) from slot $slot");
			return 0;
		}
	} else {
		my @fiji_slot=RaidSqa_get_fiji_slot(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point);
		foreach $slot (@fiji_slot) {
			(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvclear $slot ", -timeout, $RaidSqa_TIMEOUT);
			if ($output =~ /filter cleared/) {
				logcomment("RaidSqa.pm : fiji: filter cleared (nvram only) from slot $slot");
			} else {
				logcomment("RaidSqa.pm : fiji: filter not cleared (nvram only) from slot $slot");
				return 0;
			}
		}
	}
	return 1;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_show

RaidSqa_fiji_show(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets o/p of fiji show command and show all fiji filters/nvfilter set on the filer.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_show {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        (undef, undef, $output)=say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);
        my @fiji_show= split(/\r?\n/, $output);
        return @fiji_show;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_nv_trash

RaidSqa_nv_trash(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine Trash nvram to cause a panic with nvram loss so that there is reparity on boot.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_nv_trash {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

       	$conntype = "#console";

        my $conn = make_conn($host,$conntype);

        my $output;
	(undef, undef, $output) = say($conn, "priv set -q test; nv_trash toc all 0x12345678", "-noprompt","-timeout",$RaidSqa_TIMEOUT,"-prompt", "((previous shutdown was dirty, there is a possible loss of data)||(NVRAM trashed))");

}

#------------------------------------------------------------------------------

=head2 RaidSqa_savecore

RaidSqa_savecore(host=>$host, filermode=>$filermode, conntype=>$conntype, options=>$options);

This subroutine run savecore command with various options provided by user.

It returns output of command.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item options

(Optional): Options of savecore command.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_savecore {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                options => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }
        my $conn = make_conn($host,$conntype);

        my $output;
	(undef, undef, $output) = say($conn, "priv set -q diag; savecore $options",-timeout,$RaidSqa_TIMEOUT);
	return $output;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_media_scrub_disable

RaidSqa_media_scrub_disable(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine disable the media_scrub on filer by turning off the raid options raid.media.scrub.enable 

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_media_scrub_disable {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my ($output, $output1, @output1);
	(undef, undef, $output) = say($conn, "priv set -q diag; options raid.media_scrub.enable off", "-timeout",$RaidSqa_TIMEOUT);
	(undef, undef, $output1) = say($conn, "priv set -q diag; aggr media_scrub status", "-timeout",$RaidSqa_TIMEOUT);
	@output1 = split(/\r?\n/, $output1);
	if (grep(/Media scrubbing is currently disabled on this system/, @output1)) {
                logcomment("RaidSqa.pm: Media scrubbing is currently disabled on this system");
                return 1;
        } else {
		logcomment("RaidSqa.pm: Media scrubbing is currently not disabled on this system");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_media_scrub_enable

RaidSqa_media_scrub_enable(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine enable the media_scrub on filer by turning on the raid options raid.media.scrub.enable 

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_media_scrub_enable {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my ($output, $output1, @output1);
	(undef, undef, $output) = say($conn, "priv set -q diag; options raid.media_scrub.enable on", "-timeout",$RaidSqa_TIMEOUT);
	(undef, undef, $output1) = say($conn, "priv set -q diag; options raid.media_scrub.enable", "-timeout",$RaidSqa_TIMEOUT);
	@output1 = split(/\r?\n/, $output1);
	if (grep(/on/, @output1)) {
                logcomment("RaidSqa.pm: Media scrubbing is currently enabled on this system");
                return 1;
        } else {
		logcomment("RaidSqa.pm: Media scrubbing is currently not enabled on this system");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_log

RaidSqa_log(host=>$host, filermode=>$filermode, conntype=>$conntype, marker=>$marker);

This subroutine log a marker in syslog file.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item marker

(Required): Name of the marker (message) which we want to add to log for marking purpose.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_log {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                marker => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $marker  = $opts{marker};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; log $marker", -timeout, $RaidSqa_TIMEOUT);
	return 1;
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_exportfs

RaidSqa_exportfs(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

This subroutine exportfs a volume.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of volume to be exported.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_exportfs {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                options => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol  = $opts{filer_vol};
        my $options  = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef,undef,$output) = say($conn, "priv set -q diag; exportfs $options /vol/$filer_vol", -timeout, $RaidSqa_TIMEOUT);
	return 1;
	
}

#------------------------------------------------------------------------------
# @burt 359153 Modified the subroutine RaidSqa_aggr_undestroy to support interactive mode 
# @burt 359153 Reverted the changes done in RaidSqa_aggr_undestroy for support of interactive mode

=head2 RaidSqa_aggr_undestroy

RaidSqa_aggr_undestroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type, raidtree_id => $raidtree_id);

This subroutine undestroys the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be undestroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=item raidtree_id

(Optional) : Raidtree Id of the aggregate to be undestroyed

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_aggr_undestroy {
        my (%opts) = validate(@_, {
                host => { type=>OBJECT, isa=>'Hostrec' },
                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                filer_vol => { type=>SCALAR },
                aggr_type => { type=>SCALAR, default=>"1", optional=>1 },
                raidtree_id => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
        });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};
        my $raidtree_id = $opts{raidtree_id};
        my $option;
        my $before;
        my $match;
        my $after;
		
		if($filermode ne "normal"){
            $conntype = "#console";
        }

		if(!$aggr_type){
			logcomment("RaidSqa.pm: Aggr Undestroy is designed for aggregates only. Please run the test on Aggregate. \n");
			return 0;
		}
    logcomment("RaidSqa.pm: Undestroying aggregate $filer_vol");

        #Check if aggr/vol does not already exist
        if (RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)){
                logcomment("RaidSqa.pm: Aggregate $filer_vol is already present. Cannot undestroy it. \n");
                return 0;
        }

        my $conn = make_conn($host, "#console");
		#Undestroy test aggr/volume
        ($match,$before,$after)=say($conn, "priv set -q diag;aggr undestroy $filer_vol", '-noprompt', '-wait', "Selection", -timeout, $RaidSqa_TIMEOUT);
        if($raidtree_id){
                if($before =~ /\[(\d+)\].*($raidtree_id)/){
                $option=$1;
                }
        }else{
                $option='2';
        }
        say($conn, "$option", '-prompt', "\\*>", '-wait', '\n');

        # check that aggr/volume got successfully undestroyed
        # and it exists after undestroy

        if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)){
                return 0;
        }else{
                logcomment("RaidSqa.pm: Successfully undestroyed $filer_vol");
                return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_wafliron_start

RaidSqa_aggr_wafliron_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine starts wafliron on the test aggregate or traditional volume.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be undestroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_start{
	my (%opts) = validate(@_, {
		host => { type=>OBJECT, isa=>'Hostrec' },
		filermode => { type=>SCALAR, default=>"normal", optional=>1 },
		conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
		filer_vol => { type=>SCALAR },
		aggr_type => { type=>SCALAR },
	});

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};
	
	my($cmd) = $aggr_type ? "aggr" : "vol";

	if($filermode ne "normal"){
		$conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa.pm:Starting wafliron on $cmd $filer_vol");
	
	#Starting wafliron on test aggr/volume
   	say($conn, "priv set -q diag;$cmd wafliron start $filer_vol", -timeout, $RaidSqa_TIMEOUT);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_wafliron_status

RaidSqa_aggr_wafliron_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine checks the status of wafliron on the test aggregate or traditional volume.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be undestroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_status{
	my (%opts) = validate(@_, {
		host => { type=>OBJECT, isa=>'Hostrec' },
		filermode => { type=>SCALAR, default=>"normal", optional=>1 },
		conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
		filer_vol => { type=>SCALAR },
		aggr_type => { type=>SCALAR },
	});

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};
	
	my($cmd) = $aggr_type ? "aggr" : "vol";

	if($filermode ne "normal"){
		$conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa.pm:Checking Status of wafliron on $cmd $filer_vol");
	
	#Starting wafliron on test aggr/volume
	my (undef,undef,$o) = say($conn, "priv set -q diag;$cmd wafliron status $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	if($o =~ /not currently/){
		return 0;
	}elsif($o =~ /active/){
		return 1;
	}
	return 0;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_dd

RaidSqa_dd(host=>$host, filermode=>$filermode, conntype=>$conntype, if=>$if, of=$of, din=$din, bin=>$bin, dout=$dout, bout=$bout, count=$count, options=>$options);

This subroutine run dd command to corrupt the disk blocks. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item if

(Required): Name of input file.

=item of

(Required): Name of output file.

=item din

(Required): name of source disk.

=item bin

(Optional): Block number of source disk (wafl block 8k size). 

=item dout

(Required): name of destination disk.

=item bout

(Optional): Block number of destination disk (wafl block 8k size). 

=item count

(Optional): Number of block to be copied. 

=item options

(Optional): additional options to be passed to dd command. 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_dd {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                if => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                of => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                din => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                bin => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                dout => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                bout => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                count => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                options => { type=>SCALAR|UNDEF, default=>"-c", optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $if = $opts{if};
        my $of = $opts{of};
        my $din = $opts{din};
        my $bin = $opts{bin};
        my $dout = $opts{dout};
        my $bout = $opts{bout};
        my $count = $opts{count};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	
	my $cmd_args;
	if (defined($if)) {
		if (defined($of) && defined($count)) {
			$cmd_args= "dd if=$if of=$of count=$count";
		} elsif (defined($of))  {
			$cmd_args= "dd if=$if of=$of";
		} elsif (defined($dout) && defined($bout) && defined($count)) {
			$cmd_args= "dd if=$if dout=$dout bout=$bout count=$count";
		}
	} elsif (defined($din) && defined($bin)) {
		if (defined($of) && defined($count)) {
       		       $cmd_args= "dd din=$din bin=$bin of=$of count=$count";
        } elsif (defined($of))  {
			$cmd_args= "dd din=$din bin=$bin of=$of"; 
		} elsif (defined($dout) && defined($bout) && defined($count)) {
		        $cmd_args= "dd din=$din bin=$bin dout=$dout bout=$bout count=$count";
		}
	} else {
		logcomment("RaidSqa.pm: right paramter no defined to dd command");
                return 0;
	}
	
	#Options will be of no use where input and output source is file
	if($options && !(defined($of) && defined($if))) {
		$cmd_args .= " $options";
	}

	(undef,undef,$output)=say($conn, "priv set -q test; $cmd_args ", -timeout, $RaidSqa_TIMEOUT);
	return 1;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_filer_cmd

RaidSqa_filer_cmd(host=>$host, filermode=>$filermode, conntype=>$conntype, cmd=>$cmd, options=>$options, prompt=>$prompt, timeout=>$timeout);

This subroutine runs any filer comamnd.

It returns o/p of the command if any

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item cmd

(Optional): filer command.

=item options

(Optional): gives options to be used while executing the filer command.

=item prompt

(Optional): gives prompt to be wait for in case of executing say command.

=item timeout

(Optional): timeout value in secs.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_filer_cmd {
    my (%opts) =
      validate(@_,
               {host      => {type => OBJECT, isa     => 'Hostrec'},
                filermode => {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#rsh", optional => 1},
                cmd     => {type => SCALAR},
                options => {type => SCALAR, optional => 1},
                prompt => {type => SCALAR, optional => 1},
                timeout => {type => SCALAR, default => $RaidSqa_TIMEOUT, optional => 1},});

    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $cmd       = $opts{cmd};
    my $options   = $opts{options};
    my $prompt   = $opts{prompt};
    my $timeout   = $opts{timeout};
    if ($filermode ne "normal") {
        $conntype = "#console";
    }
    my $conn = make_conn($host, $conntype);
    my $output;

    if ((!defined($options))&&(!defined($prompt))) {
        (undef, undef, $output) = say($conn, "$cmd", -timeout, $timeout);
    } elsif ((defined($options))&&(!defined($prompt))) {
        (undef, undef, $output) = say($conn, "$cmd", "$options", -timeout, $timeout);
    } elsif ((!defined($options))&&(defined($prompt))) {
        (undef, undef, $output) = say($conn, "$cmd", -prompt, $prompt, -timeout, $timeout);
    } else {
        (undef, undef, $output) = say($conn, "$cmd", -prompt, $prompt, $options, -timeout, $timeout);
    }

    return $output;
}

##############################################################################
# LIST OF FUNCTIONS WHICH ARE CHECKING STATUS                                #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_exist 

RaidSqa_check_disk_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine checks that a particular disk exist in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked if it exist in filer or not.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
	my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);
	my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
	# check if specified disk exists in raid
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
	} else {
                logcomment("RaidSqa.pm: disk $disk_name does exist in filer");
                return 1;
        }

}

#------------------------------------------------------------------------------

# @burt 352332 Modified for returning proper value to RaidSqa_disk_remove when fsm state is non spare

=head2 RaidSqa_check_disk_fsm_state 

RaidSqa_check_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, fsm_state=>$fsm_state);

This subroutine checks a particular disk's fsm state in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item fsm_state

(Required) : FSM state of the disk to be checked against. Like INUSE|ZEROED|ZEROING|NOTZEROED|OFFLINE|FAILED|

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};
        if($filermode ne "normal"){
            $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
        my $fsm_state = $opts{fsm_state};

	# check if specified disk exist in specific fsm_state
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");

        # checking for NULL disk_obj                                         

        if ( ! ( $disk_obj ) )                                               
        {                                                                    
           logcomment("RaidSqa.pm: Invalid disk_object! ");                  
           return 0;                                                         
        }                                          

	my $disk_fsm_state=$disk_obj->parameter("fsm_state");

	if ($disk_fsm_state eq $fsm_state) {
                logcomment("RaidSqa.pm: disk $disk_name is in $fsm_state fsm state");
                return 1;
        } else {
		logcomment("RaidSqa.pm: disk $disk_name fsm state is not $fsm_state instead it is: $disk_fsm_state");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_is_doing_optimized_recons 

RaidSqa_check_disk_is_doing_optimized_recons(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine checks a particular disk's is doing optimized reconstruction.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_is_doing_optimized_recons {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
	# check if specified disk exist in specific fsm_state
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_optimized_state=$disk_obj->parameter("optimized_recons");
	my $disk_parent_state=$disk_obj->parameter("parent_state");

	if (!defined($disk_obj)) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
	} elsif (($disk_optimized_state) && ($disk_parent_state =~ /RECONS/)) {
                logcomment("RaidSqa.pm: disk $disk_name is in optimized reconstruction state");
                return 1;
        } else {
                logcomment("RaidSqa.pm: disk $disk_name is not in optimized reconstruction state");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_parent_state 

RaidSqa_check_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, parent_state=>$parent_state);

This subroutine checks a particular disk's parent_state state in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item parent_state

(Required) : parent_state of the disk to be checked against. Like DATA|PARITY|DPARITY|RECONSDATA|RECONSPARITY|RECONSDPARITY

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_parent_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                parent_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
        my $parent_state = $opts{parent_state};

	# check if specified disk exist in specific parent_state
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_parent_state=$disk_obj->parameter("parent_state");

	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
	} elsif ($disk_parent_state eq $parent_state) {
                logcomment("RaidSqa.pm: disk $disk_name is in $parent_state parent state");
                return 1;
        } else {
		logcomment("RaidSqa.pm: disk $disk_name parent state is not $parent_state instead it is: $disk_parent_state");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_is_prefailed 

RaidSqa_check_disk_is_prefailed(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine checks that a particular disk is in prefail state.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_is_prefailed {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};
        if($filermode ne "normal"){
            $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	# check if specified disk exist in specific fsm_state
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_prefail_state=$disk_obj->parameter("prefail");

	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
	} elsif ($disk_prefail_state eq "1") {
                logcomment("RaidSqa.pm: disk $disk_name is in prefail state");
                return 1;
        } else {
		logcomment("RaidSqa.pm: disk $disk_name is not in prefail state");
                return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_sdc_start 

RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine checks that sdc started on a particular prefailed disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_sdc_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		my $conntype = $opts{conntype};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

		# check if specified disk exist in specific fsm_state
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_sdc_progress=$disk_obj->parameter("copy_progress");

	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
	} elsif ($disk_sdc_progress ne "-1") {
                logcomment("RaidSqa.pm: sdc started on disk $disk_name ");
                return 1;
	} else {
                logcomment("RaidSqa.pm: sdc didn't started on disk $disk_name ");
                return 0;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_block_is_pseudo 

RaidSqa_check_disk_block_is_pseudo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn=>$dbn);

This subroutine checks that a particular disk blocks number (dbn) is pseudo.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item dbn

(Required) : disk block number (dbn) of the disks to be checked for pseudo.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_block_is_pseudo {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                dbn => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};
        if($filermode ne "normal"){
            $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		my $dbn = $opts{dbn};
	my $output;
        (undef, undef, $output) = say($conn, "priv -level -q diag; dumpblock dbn -c $disk_name $dbn", -timeout, $RaidSqa_TIMEOUT);
	my @output_array = split(/\r?\n/, $output);
	my @line3 = split(" ", $output_array[3]);
	my @bit_to_comp_in_hex = split(//, $line3[4]);
	my $bit_to_comp_in_bin = sprintf "%04b", hex($bit_to_comp_in_hex[9]);
	my @last_bit_to_comp = split(//, $bit_to_comp_in_bin);

	if($last_bit_to_comp[3] == 1 ) {
                logcomment("RaidSqa.pm: dbn $dbn in disk $disk_name is a pseudo bad block");
                return 1;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_block_is_zeroed_out 

RaidSqa_check_disk_block_is_zeroed_out(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn=>$dbn);

This subroutine checks that a particular disk blocks number (dbn) is zeroed out.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item dbn

(Required) : disk block number (dbn) of the disks to be checked for zeroed out.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_block_is_zeroed_out {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                dbn => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $dbn = $opts{dbn};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $output;
        (undef, undef, $output) = say($conn, "priv -level -q diag; dumpblock dbn -c $disk_name $dbn", -timeout, $RaidSqa_TIMEOUT);
	my @output_array = split(/\r?\n/, $output);
	my @line1 = split(" ", $output_array[1]);
	my $hex_value = hex($line1[2]);

	if($hex_value == 0x02000001) {
                logcomment("RaidSqa.pm: dbn $dbn in disk $disk_name is zeroed out");
                return 1;
	} else {
                logcomment("RaidSqa.pm: dbn $dbn in disk $disk_name is not zeroed out");
                return 0;
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_exist

RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type);

This subroutine checks that a particular volume/aggergate exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it exist in in filer.

=item aggr_type

(Required) : 1 for aggregate and 0 for traditional. 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);

    	my $vol_obj = $raid_obj->aggregate("$filer_vol");
    	my $flex_obj = $raid_obj->volume("$filer_vol");
	
	# check if a specified aggr/tradvol/fklex exist in filer or not
	if ((!$vol_obj) && (!$flex_obj)) {
	    logcomment("RaidSqa.pm: no trad or aggregate or flex with name $filer_vol exists");
            return 0;				
	} elsif(defined($vol_obj)) {
		if (($aggr_type) && ($vol_obj->parameter("store_type") eq 'aggr')) {
		    logcomment("RaidSqa.pm: aggregate $filer_vol exist.\n");
		    return 1;
                } elsif (($aggr_type) && ($vol_obj->parameter("store_type") eq 'trad')) {
                    logcomment("RaidSqa.pm: aggregate $filer_vol does not exist, instead a trad vol $filer_vol exists");
                    return 0;
                } elsif ((!$aggr_type) && ($vol_obj->parameter("store_type") eq 'trad')) {
		    logcomment("RaidSqa.pm: trad vol $filer_vol exist.\n");
                    return 1;
		} elsif ((!$aggr_type) && ($vol_obj->parameter("store_type") eq 'aggr')) {
		    logcomment("RaidSqa.pm: trad vol $filer_vol does not exist, instead an aggregate $filer_vol exists");
		    return 0;
		}
	} elsif ((!$aggr_type) && ($flex_obj) && ($flex_obj->parameter("store_type") eq 'flex')) {
	    logcomment("RaidSqa.pm: trad vol $filer_vol does not exist, instead a flex $filer_vol exists");
            return 0;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_exist_anytype

RaidSqa_check_aggr_exist_anytype(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine checks that any flex/trad or aggr of partricular name exist in filer or not.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_exist_anytype {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);

    	my $vol_obj = $raid_obj->aggregate("$filer_vol");
    	my $flex_obj = $raid_obj->volume("$filer_vol");
	
        # check that a aggr or tradvol or flex of specified name exists or not
        if ((!$vol_obj) && (!$flex_obj)) {
	    	logcomment("RaidSqa.pm: no trad or aggregate or flex with name $filer_vol exists");
	    	return 0;
	} elsif (defined($vol_obj)) {
	    if($vol_obj->parameter("store_type") eq 'aggr') {
	        logcomment("RaidSqa.pm: aggregate $filer_vol exist.\n");
                return 1;
            } elsif ($vol_obj->parameter("store_type") eq 'trad') {
                logcomment("RaidSqa.pm: A trad vol $filer_vol exists");
                return 1;
            }
        } elsif ($flex_obj->parameter("store_type") eq 'flex') {
            logcomment("RaidSqa.pm: trad vol $filer_vol exist.\n");
            return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_state_name

RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type, state_name=>$state_name);

This subroutine checks that a particular volume/aggergate is state_name(online/offline/restricted) is as defined by user.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it is online.

=item aggr_type

(Required) : 1 for aggregate and 0 for traditional.

=item state_name

(Required) : State name of aggr/volume (offline/online/restricted).

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_state_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR },
                                state_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";
        my $state_name = $opts{state_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);


	# check a test aggr/volume is having specified mirror state
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("state_name") ne $state_name) {
			logcomment("RaidSqa.pm: state name for $filer_vol is not $state_name as expected");
                        return 0;
                } else {
			logcomment("RaidSqa.pm: state name for $filer_vol is $state_name as expected");
                        return 1;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_mirror_state

RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type,mirror_state=>$mirror_state);

This subroutine checks mirror_state for a particular volume/aggergate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it is restricted.

=item aggr_type

(Required) : 1 for aggregate and 0 for traditional.

=item mirror_state

(Required) : mirror state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_mirror_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR },
                                mirror_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $mirror_state = $opts{mirror_state};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test aggr/volume is having specified mirror state
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("mirror_state") ne $mirror_state) {
			logcomment("RaidSqa.pm: Mirror state for $filer_vol is not $mirror_state as expected");
                        return 0;
                } else {
			logcomment("RaidSqa.pm: Mirror state for $filer_vol is $mirror_state as expected");
                        return 1;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_fsm_state

RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type,fsm_state=>$fsm_state);

This subroutine checks fsm_state for a particular volume/aggergate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it is restricted.

=item aggr_type

(Required) : 1 for aggregate and 0 for traditional.

=item fsm_state

(Required) : fsm state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $fsm_state = $opts{fsm_state};
        my $aggr_type = $opts{aggr_type};
        my($cmd) = $aggr_type ? "aggr" : "vol";

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test aggr/volume is having specified mirror state
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("fsm_state") ne $fsm_state) {
			logcomment("RaidSqa.pm: fsm state for $filer_vol is not $fsm_state as expected");
                        return 0;
                } else {
			logcomment("RaidSqa.pm: fsm state for $filer_vol is $fsm_state as expected");
                        return 1;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_plex_exist

RaidSqa_check_plex_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine checks that a particular plex exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_plex_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);

    	my $plex_obj = $raid_obj->plex("$plex_name");
	
	# check a specified plex exist in filer
	if (!$plex_obj) {
		logcomment("RaidSqa.pm: plex $plex_name does not exist in the filer");
                return 0;
	} else {
		logcomment("RaidSqa.pm: plex $plex_name exist in the filer");
                return 1;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_plex_state_name

RaidSqa_check_plex_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name, state_name=>$state_name);

This subroutine checks that a particular plex state is offline or online.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be checked if it is offline.

=item state_name

(Required) : state_name of plex. Either offline or online.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_plex_state_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				plex_name => { type=>SCALAR },
				state_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};
        my $state_name = $opts{state_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
    	my $plex_obj = $raid_obj->plex("$plex_name");

	# check test plex exists in filer and it is offline
	if (!RaidSqa_check_plex_exist(host=>$host, conntype=>$conntype, plex_name=>$plex_name)) {
		return 0;
	} elsif ($state_name eq "online") {
        	if ($plex_obj->parameter("online") ne "1") {
			return 0;
        	} else {
			logcomment("RaidSqa.pm: Plex $plex_name is online");
			return 1;
        	}
	} elsif ($state_name eq "offline") {
        	if ($plex_obj->parameter("online") ne "0") {
			return 0;
        	} else {
			logcomment("RaidSqa.pm: Plex $plex_name is offline");
			return 1;
		}
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_plex_fsm_state

RaidSqa_check_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name, fsm_state=>$fsm_state);

This subroutine checks fsm state of a particular raid plex

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of raid plex to be checked 

=item fsm_state

(Required) : fsm_state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_plex_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};
        my $fsm_state = $opts{fsm_state};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test plex exists and is having specified fsm_state
        if (!RaidSqa_check_plex_exist(host=>$host, conntype=>$conntype, plex_name=> $plex_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $plex_obj = $raid_obj->plex("$plex_name");

                if ($plex_obj->parameter("fsm_state") eq "$fsm_state") {
			logcomment("RaidSqa.pm: raid plex $plex_name is in $fsm_state as expected");
                        return 1;
                } else {
			logcomment("RaidSqa.pm: raid plex $plex_name is not in $fsm_state as expected");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_plex_resyncing

RaidSqa_check_plex_resyncing(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, resync_level=>$resync_level);

This subroutine checks that a particular raid plex is resyncing with specified resync level.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of raid plex to be checked 

=item resync_level

(Required) : resync_level to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_plex_resyncing {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                resync_level => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};
        my $resync_level = $opts{resync_level};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test plex exists and is having specified fsm_state
        if (!RaidSqa_check_plex_exist(host=>$host, conntype=>$conntype, plex_name=> $plex_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $plex_obj = $raid_obj->plex("$plex_name");

		if ($plex_obj->parameter("resyncing") eq "1") {
                	if ($plex_obj->parameter("resync_level") eq "$resync_level") {
				logcomment("RaidSqa.pm: raid plex $plex_name is resyncing with level $resync_level as expected");
                        	return 1;
                	} else {
				logcomment("RaidSqa.pm: raid plex $plex_name is not resyncing with level $resync_level");
                        	return 0;
                	}
		} else {
			logcomment("RaidSqa.pm: raid plex $plex_name is not resyncing ");
                       	return 0;
		}
			
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_exist

RaidSqa_check_group_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name);

This subroutine checks that a particular raid group exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of the raid group to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_check_group_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);

        my $group_obj = $raid_obj->raid_group("$group_name");

	# check a specified group exist in filer
        if (!$group_obj) {
                logcomment("RaidSqa.pm: no raid group with name $group_name exist in the filer");
                return 0;
        } else  {
                logcomment("RaidSqa.pm: raid group with name $group_name exist in the filer");
                return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_fsm_state

RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name, fsm_state=>$fsm_state);

This subroutine checks fsm state of a particular raid group

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=item fsm_state

(Required) : fsm_state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};
        my $fsm_state = $opts{fsm_state};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if ($group_obj->parameter("fsm_state") eq "$fsm_state") {
			logcomment("RaidSqa.pm: raid group $group_name is in $fsm_state as expected");
                        return 1;
                } else {
			logcomment("RaidSqa.pm: raid group $group_name is not in $fsm_state as expected");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_recons_in_progress

RaidSqa_check_group_recons_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group recons is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_recons_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("fsm_state") =~ /RECONS/) && ($group_obj->parameter("recons_progress") ne "-1") && ($group_obj->parameter("recons_suspended_block") eq "-1")) {
			logcomment("RaidSqa.pm: raid group $group_name reconstruction is in progress");
                        return 1;
                } else {
			logcomment("RaidSqa.pm: raid group $group_name reconstruction is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_reparity_in_progress

RaidSqa_check_group_reparity_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group reparity is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_reparity_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if ($group_obj->parameter("reparity_progress") ne "-1") {
			            logcomment("RaidSqa.pm: raid group $group_name reparity is in progress");
                        return 1;
                } else {
			            logcomment("RaidSqa.pm: raid group $group_name reparity is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_scrub_in_progress

RaidSqa_check_group_scrub_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group scrub is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_scrub_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("scrub_progress") ne "-1") && ($group_obj->parameter("scrub_suspended_block") eq "-1")) {
			logcomment("RaidSqa.pm: raid group $group_name scrub is in progress");
                        return 1;
                } else {
			logcomment("RaidSqa.pm: raid group $group_name scrub is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_is_running_context_scrub

RaidSqa_check_group_is_running_context_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group is running context scrub

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_is_running_context_scrub {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");
		if (($group_obj->parameter("context_scrub") eq "1") && ($group_obj->parameter("context_parity_protected") eq "0") && ($group_obj->parameter("scrub_progress") ne "-1") && ($group_obj->parameter("scrub_suspended_block") eq "-1")) {

                        logcomment("RaidSqa.pm: raid group $group_name is running context scrub");
                        return 1;
                } else {
                        logcomment("RaidSqa.pm: raid group $group_name scrub is not running context scrub");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_recons_is_suspend

RaidSqa_check_group_recons_is_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group recons is suspend or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_recons_is_suspend {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("fsm_state") =~ /RECONS/) && ($group_obj->parameter("recons_suspended_block") ne "-1")) {
			logcomment("RaidSqa.pm: raid group $group_name reconstruction is in suspend state");
                        return 1;
                } else {
			logcomment("RaidSqa.pm: raid group $group_name reconstruction is not in suspend state");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_raid_size_valid_range

RaidSqa_check_raid_size_valid_range(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);

This subroutine checks that a particular raid_size is in valid range for a given raid_type and storage_type.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item raid_size

(Required) : Raid size of the volume/aggregate to be created.  No default. Any user_defined count.

=item raid_type

(Required) : Raid type of the volume/aggregate to be created. No default. cane be raid4 or raid_dp.

=item storage_type

(Required) : Disk storage type. Can be ATA, SAS, FCAL, BSAS.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_raid_size_valid_range {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                raid_size => { type=>SCALAR },
                                raid_type => { type=>SCALAR },
                                storage_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $raid_size = $opts{raid_size};
        my $raid_type = $opts{raid_type};
        my $storage_type = $opts{storage_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# checks that raid_size specified by user is in valide range as range are different for raid4/raidp for different type disks ATA/FCAL/SAS
	if ($storage_type eq "ATA" || $storage_type eq "BSAS") {
    		if ($raid_type eq "raid4") {
      			if ($raid_size >= 2 &&  $raid_size <= 7) {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (2-7)");   
				return 1;
      			} else {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (2-7), can not continue test, rerun test with correct raid_size value");
				return 0;
      			}
    		}
    		if ($raid_type eq "raid_dp") {
      			if ($raid_size >= 3 &&  $raid_size <= 16) {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (3-16)");   
				return 1;
      			} else {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (3-16), can not continue test, rerun test with correct raid_size value");
				return 0;
      			}
    		}
  	} elsif ($storage_type eq "FCAL" || $storage_type eq "SAS"){
    		if ($raid_type eq "raid4") {
      			if ($raid_size >= 2 &&  $raid_size <= 14) {
       				logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (2-14)");   
				return 1;
      			} else {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (2-14, rerun test with correct raid_size value");
				return 0;
      			}
    		}
    		if ($raid_type eq "raid_dp") {
      			if ($raid_size >= 3 &&  $raid_size <= 28) {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (3-28)");   
				return 1;
      			} else {
        			logcomment("RaidSqa.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (3-28), can not continue test, rerun test with correct raid_size value");
				return 0;

      			}
    		}
  	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_license

RaidSqa_check_license(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine check that filer is having license for a particular service.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to check license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_license {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $service = $opts{service};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a particuler license is tehre on filer
        my $output;
        my $line;
        (undef,undef, $output) = say($conn, "priv set -q diag;license", -timeout, $RaidSqa_TIMEOUT);
        my @info = split(/\r?\n/, $output);
        foreach $line (@info) {
                my (@data) = split(" ", $line);
                if ($data[0] eq $service) {
                        logcomment("RaidSqa.pm: $data[0], $data[1] licensed\n");
                        if ($data[1] eq "not") {
                                return 0;
                        } else {
                                return 1;
                        }
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_fiji

RaidSqa_check_fiji(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine check that filer is having fiji set.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point for which we want to check fiji.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_fiji {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        my $line;
        (undef,undef, $output) = say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);
        my @info = split(/\r?\n/, $output);
	if(index($output, $fiji_point) ne "-1") { 
                 logcomment("RaidSqa.pm: fiji filter/nvfilter $fiji_point is set\n");
                 return 1;
        } else {
        	logcomment("RaidSqa.pm: fiji filter/nvfilter $fiji_point is not set\n");
        	return 0;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_hammer_running

RaidSqa_check_hammer_running(host=>$host, filermode=>$filermode, conntype=>$conntype, hammer_number=>$hammer_number);

This subroutine check that any or a particular hammer is running.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item hammer_number

(Optional): default is any, but we can check for a particular hammer number

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_hammer_running {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                hammer_number => {type=>SCALAR, default=>"any", optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $hammer_number = $opts{hammer_number};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $check;
	if ($hammer_number eq "any") {
		$check="blacksmith";
	} else {
		$check="blacksmith #" . $hammer_number;
	}

        my $output;
        (undef,undef, $output) = say($conn, "priv set -q diag;hammer status", -timeout, $RaidSqa_TIMEOUT);
    	if ($output =~ /$check/) {
        	logcomment(" Hammer number: $hammer_number is running");
        	return 1;
    	} else {
        	logcomment("Hammer number: $hammer_number is not running");
        	return 0;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_existing_aggr_ok

RaidSqa_check_existing_aggr_ok(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, disk_count=>$disk_count, aggr_bits=>$aggr_bits, aggr_fsm_state=>$aggr_fsm_state, aggr_state_name=>$aggr_state_name, aggr_wafl_online=>$aggr_wafl_online, aggr_wafl_mounted=>$aggr_wafl_mounted, aggr_ignore_inconsist=>$aggr_ignore_inconsist, aggr_snapmirrored=>$aggr_snapmirrored, all_group_fsm_state=>$all_group_fsm_state, all_group_sdc=>$all_group_sdc);

This subroutine checks the existing aggr/vol if it is in the state required to run the test.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item aggr_type

(Optional): 1 for aggregate and 0 for traditional. Default it is 1.

=item raid_type

(Optional): Raid type of the volume/aggregate to be created. By default it is raid_dp. Other options is raid4.

=item raid_size

(Optional): Raid size of the volume/aggregate. By default it is default. Other values can be min, max or user_defined count but that should be in allowed range for a given storage_type.

=item mirror

(Optional): 1 for mirror volume and 0 for nonmirror. Default is 0.

=item storage_type

(Optional):  Disk storage type. Can be ATA, SAS, FCAL, BSAS. If nothing is defined  than it does not run that check.

=item disk_count

(Optional): No of disk in aggr

=item aggr_bits

(Optional): 32 or 64

=item aggr_fsm_state

(Optional): aggr fsm state, default is "NORMAL".

=item aggr_state_name

(Optional): aggr state name, default is "online".

=item aggr_wafl_online

(Optional): aggr wafl_online state, default is "1".

=item aggr_wafl_mounted

(Optional): aggr wafl_mounted state, default is "1".

=item aggr_ignore_inconsist

(Optional): aggr ignore_inconsist state, default is "0".

=item aggr_snapmirrored

(Optional): aggr snapmirrored state, default is "0".

=item all_group_fsm_state

(Optional): all groups fsm state, default is "NORMAL".

=item all_group_sdc

(Optional): all groups sdc state, default is "0".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_existing_aggr_ok {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => { type=>SCALAR, default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                raid_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                raid_size => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                mirror => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                storage_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                storage_type_strict => { type=>SCALAR,default=>0,optional=>1 },
                                disk_count => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                aggr_bits => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                aggr_fsm_state => { type=>SCALAR,default=>"NORMAL",optional=>1 },
                                aggr_state_name => { type=>SCALAR,default=>"online",optional=>1 },
                                aggr_wafl_online => { type=>SCALAR,default=>"1",optional=>1 },
                                aggr_wafl_mounted => { type=>SCALAR,default=>"1",optional=>1 },
                                aggr_ignore_inconsist => { type=>SCALAR,default=>"0",optional=>1 },
                                aggr_snapmirrored => { type=>SCALAR,default=>"0",optional=>1 },
                                all_group_fsm_state => { type=>SCALAR,default=>"NORMAL",optional=>1 },
                                all_group_sdc => { type=>SCALAR,default=>"0",optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my $raid_type = $opts{raid_type};
        my $raid_size = $opts{raid_size};
        my $mirror = $opts{mirror};
        my $storage_type = $opts{storage_type};
        my $storage_type_strict = $opts{storage_type_strict};
        my $disk_count = $opts{disk_count};
        my $aggr_bits = $opts{aggr_bits};
        my $aggr_fsm_state = $opts{aggr_fsm_state};
        my $aggr_state_name = $opts{aggr_state_name};
        my $aggr_wafl_online = $opts{aggr_wafl_online};
        my $aggr_wafl_mounted = $opts{aggr_wafl_mounted};
        my $aggr_ignore_inconsist = $opts{aggr_ignore_inconsist};
        my $aggr_snapmirrored = $opts{aggr_snapmirrored};
        my $all_group_fsm_state = $opts{all_group_fsm_state};
        my $all_group_sdc = $opts{all_group_sdc};

	#my $aggr_trad;
	#	if ($aggr_type){
        #		$aggr_trad =  "aggr" ;
	#	} else {
	#		$aggr_trad =  "trad" ;
	#	}

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);

   	my $vol_obj = $raid_obj->aggregate("$filer_vol");
    	my %vol_rg_hash = $vol_obj->all_raid_groups();
        my @vol_rg_list = keys(%vol_rg_hash);

        my %vol_disk_hash = $vol_obj->all_disks();
        my @vol_disk_list = keys(%vol_disk_hash);
	my $disk_obj = $vol_obj->disk("$vol_disk_list[0]");

	my $store_type = $vol_obj->parameter("store_type") ;
	my $fsm_state = $vol_obj->parameter("fsm_state") ;
	my $state_name = $vol_obj->parameter("state_name") ;
	my $wafl_online = $vol_obj->parameter("wafl_online") ;
	my $wafl_mounted = $vol_obj->parameter("wafl_mounted") ;
	my $ignore_inconsist = $vol_obj->parameter("ignore_inconsist") ;
	my $snapmirrored = $vol_obj->parameter("snapmirrored") ;
	my $mirror_state = $vol_obj->parameter("mirror_state") ;
	my $raidtree_type = $vol_obj->parameter("raidtree_type") ;
        my $raidtree_size = $vol_obj->parameter("size") ;
	my $number_of_disks = $vol_obj->parameter("disk_count") ;
        my $aggr_format = $vol_obj->parameter("aggr_format") ;

	
        #logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol is normal/online/mounted and not inconsistent/snapmirror destination.\n");

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required fsm state \n");
        if ($fsm_state ne $aggr_fsm_state) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_fsm_state fsm state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_fsm_state fsm state as required \n");
        }

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required state name \n");
        if ($state_name ne $aggr_state_name) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_state_name state name state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_state_name state name as required \n");
        }

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required wafl_online state \n");
        if ($wafl_online ne $aggr_wafl_online) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_wafl_online wafl online state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_wafl_online wafl online state as required \n");
        }

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required wafl_mounted state \n");
        if ($wafl_mounted ne $aggr_wafl_mounted) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_wafl_mounted wafl mounted state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_wafl_mounted wafl mounted state as required \n");
        }

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required ignore_inconsist state \n");
        if ($ignore_inconsist ne $aggr_ignore_inconsist) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_ignore_inconsist ignore_inconsist state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_ignore_inconsist ignore_inconsist state as required \n");
        }

        logcomment("RaidSqa.pm: Verifying if the existing $filer_vol have required snapmirrored state \n");
        if ($snapmirrored ne $aggr_snapmirrored) {
                logcomment("RaidSqa.pm: Existing $filer_vol does not has the $aggr_snapmirrored snapmirrored state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa.pm: Existing $filer_vol has the $aggr_snapmirrored snapmirrored state as required \n");
        }


        #if ($fsm_state ne "NORMAL" || $state_name ne "online" || $wafl_online ne "1" || $wafl_mounted ne "1" || $ignore_inconsist ne "0" || $snapmirrored ne "0") {
        #        logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not in ONLINE/NORMAL state.\n");
        #        return 0;
        #}

        #logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol raidgroups are in normal state\n");
#
#        my $group;
#        foreach $group (@vol_rg_list) {
#                my $group_obj = $vol_obj->raid_group("$group") ;
#                if ($group_obj->parameter("fsm_state") ne "NORMAL" || $group_obj->parameter("disk_copy_source_id") ne "-1" || $group_obj->parameter("disk_copy_target_id") ne "-1") {
#                        logcomment("RaidSqa.pm: Not all the raidgroups are in normal state.\n");
#                        return 0;
#                }
#        }
        my $group;
        foreach $group (@vol_rg_list) {
        	logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol raidgroup $group is in required fsm state\n");
                my $group_obj = $vol_obj->raid_group("$group") ;
                if ($group_obj->parameter("fsm_state") ne $all_group_fsm_state)  {
                        logcomment("RaidSqa.pm: raidgroup $group is not in $all_group_fsm_state fsm state.\n");
                        return 0;
                }
        	logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol raidgroup $group is in required sdc state\n");
                if ($group_obj->parameter("disk_copy_source_id") ne "-1" || $group_obj->parameter("disk_copy_target_id") ne "-1") {
                        logcomment("RaidSqa.pm: raidgroup $group is not in required sdc state.\n");
                        return 0;
                }
	}

        if (defined($raid_type)) {
                logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol is matching the RAID_TYPE requirement for the test.\n");
                if ($raid_type eq "raid4") {
                        if (!($raidtree_type =~ /raid4/)) {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type RAID4.\n");
                                return 0;
                        }
                } elsif ($raid_type eq "raid_dp") {
                        if (!($raidtree_type =~ /raidrd/)) {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type RAID-DP.\n");
                                return 0;
                        }
                }
        }

        if (defined($storage_type)) {
                logcomment("RaidSqa.pm: Verifying if existing aggr/trad vol $filer_vol is matching the storage_type requirement for the test.\n");
				my $aggr_storage_type = $disk_obj->parameter("disk_type");
				if($storage_type =~ /^(ATA|FCAL|BSAS|SAS|SATA)$/) {
					if ($aggr_storage_type ne $storage_type) {						
						logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required storage type $storage_type");
						if($storage_type_strict) {
							return 0;
						} else {
							if(($storage_type =~ /^(ATA|BSAS|SATA)$/) && ($aggr_storage_type !~ /^(ATA|BSAS|SATA)$/)) {
								logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to any of storage type ATA|BSAS|SATA");
								return 0;
							} elsif(($storage_type =~ /^(FCAL|SAS)$/) && ($aggr_storage_type !~ /^(FCAL|SAS)$/)) {
								logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to any of storage type FCAL|SAS");
								return 0;
							}
						}
					}
				}
        }
		
		
        if (defined($aggr_type)) {
                logcomment("RaidSqa.pm: Verifying if the existing $filer_vol is having the same aggr type as required \n");
                if ($aggr_type) {
                        if ($store_type ne "aggr") {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type aggr type.\n");
                                return 0;
                        } else {
                                logcomment("RaidSqa.pm: Verifying if existing aggr $filer_vol contains the required flex vol for the test.\n");

                                my $flex_obj = $raid_obj->volume("$filer_vol");

                                if (!$flex_obj) {
                                        logcomment("RaidSqa.pm: Aggregate $filer_vol does not contain the required flex volume.\n");
                                        return 0;
                                } elsif ($flex_obj->parameter("state_name") ne "online") {
                                        logcomment("RaidSqa.pm: Aggregate $filer_vol does not contain an online required flex volume.\n");
                                        return 0;
                                }
                        }

                } else  {
                        if ($store_type ne "trad") {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type aggr type.\n");
                                return 0;
                        }
                }
        }

        if (defined($raid_size)) {
                if ($raid_size =~ /\D/) {
                        $raid_size=RaidSqa_get_raid_size_value(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);
                }

                logcomment("RaidSqa.pm: Verifying if the existing $filer_vol is having the same raid size as required \n");
                if($raid_size != $raidtree_size) {
                        logcomment("RaidSqa.pm: Existing $filer_vol does not have the same raid size as required \n");
                        return 0;
                }else {
                        logcomment("RaidSqa.pm: Existing $filer_vol has the same raid size as required \n");
                }
        }

        if (defined($mirror)) {
                logcomment("RaidSqa.pm: Verifying if the existing $filer_vol is having the same mirror state as required \n");
                if ($mirror) {
                        if ($mirror_state ne "NORMAL") {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type mirror state.\n");
                                return 0;
                        }
                } else  {
                        if ($mirror_state ne "UNMIRRORED") {
                                logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required type mirror state.\n");
                                return 0;
                        }
                }
        }

        if (defined($disk_count)) {
                logcomment("RaidSqa.pm: Verifying if the existing $filer_vol is having the same number of disks as required \n");
                if($disk_count ne $number_of_disks) {
                        logcomment("RaidSqa.pm: Existing $filer_vol does not have the same number of disks as required \n");
                        return 0;
                }else {
                        logcomment("RaidSqa.pm: Existing $filer_vol has the same number of disks as required \n");
                }
        }

        if (defined($aggr_bits)) {
                logcomment("RaidSqa.pm: Verifying if the existing $filer_vol is having the same aggr bits type as required \n");
                if (!($aggr_format =~ /$aggr_bits/)) {
                        logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol is not matching to its required aggr bits type.\n");
                        return 0;
                }
        }

	logcomment("RaidSqa.pm: Existing aggr/trad vol $filer_vol meets all the requirement for testing");
	return 1
}

##############################################################################
# LIST OF FUNCTIONS WHICH ARE GETTING INFORMATIONS                           #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_get_vol_status

RaidSqa_get_vol_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets o/p of vol status command for all volumes/one volume/or-with different options.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume to get vol status for. If not given, it will give o/p of all volumes. By default it is 
undefined.

=item options

(Optional) : Any options with vol status o/p for a volume or all volumes. By default it is "-r".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_vol_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF, default=>undef, optional=>1 },
                                options => { type=>SCALAR, default=>"-r", optional=>1 },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# get o/p of vol status command with specified options
        my $output;
        (undef, undef, $output)=say($conn, "priv set -q diag;vol status $options $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        my @vol_status= split(/\r?\n/, $output);
        return @vol_status;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_status

RaidSqa_get_aggr_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets o/p of aggr status command for all aggr/one aggr/or-with different options.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume to get aggr status for. If not given, it will give o/p of all aggr. By default it is 
undefined.

=item options

(Optional) : Any options with vol status o/p for a aggr or all aggr. By default it is "-r".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF, default=>undef, optional=>1 },
                                options => { type=>SCALAR, default=>undef, optional=>1 },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# get o/p of aggr status command with specified options
        my $output;
	if (defined($options)) {
        	(undef, undef, $output)=say($conn, "priv set -q diag;aggr status $options $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	} else {
        	(undef, undef, $output)=say($conn, "priv set -q diag;aggr status $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	}
        my @aggr_status= split(/\r?\n/, $output);
        return @aggr_status;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_list

RaidSqa_get_aggr_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by default gets list of aggr/tradvol in a given filer. 

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my %aggr_list= $raid_obj->all_aggregates();
	my @aggr_list=keys(%aggr_list);

        return  @aggr_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_options

RaidSqa_check_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets value of an options of a particular volume/aggergate.

It returns scalar value.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=item options

(Required) : Name of options to get the value.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                options => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $output;
	(undef, undef, $output) = say($conn, "priv set -q diag;aggr options $filer_vol", -timeout, $RaidSqa_TIMEOUT);
	my @options_raw = split(/\r?\n/, $output);

	my $options_all;
	my $line;
 	my $line1;
	foreach $line (@options_raw){
		$options_all=$options_all . $line;
	}

	my @options_list= split(/, /, $options_all);
	my %options_hash;
	foreach $line1 (@options_list) {
		(my $key, my $value) = split(/=/, $line1);
		$options_hash{$key}=$value;
	}
	
	my $i;
	foreach $i (keys(%options_hash)) {
		if ($i eq $options) {
			return $options_hash{$i};
		}
	}
	
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_type

RaidSqa_check_aggr_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets info whether a particular volume/aggergate is aggregate or traditional volume.

It returns scalar value.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $vol_obj = $raid_obj->volume("$filer_vol");
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	if ($aggr_obj) {
		return $aggr_obj->parameter("store_type");
	} else {
		return $vol_obj->parameter("store_type");
	} 

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_cksum_type

RaidSqa_check_aggr_cksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets checksum type info of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_cksum_type {
	my (%opts) = validate(@_, {
							host => { type=>OBJECT, isa=>'Hostrec' },
							filermode => { type=>SCALAR, default=>"normal", optional=>1 },
							conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
							filer_vol => { type=>SCALAR },
							}       
					);      
	my $host = $opts{host};
	my $filermode = $opts{filermode};
	my $conntype = $opts{conntype};
	my $filer_vol = $opts{filer_vol};

	if($filermode ne "normal"){
			$conntype = "#console";
	}

	my $conn = make_conn($host,$conntype);

	my $raid_obj = new RaidInfo($conn);
	my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	my $cksum_type = $aggr_obj->parameter("cksum_type");
	$cksum_type = "block" if ($cksum_type eq '520byte');
	$cksum_type = "zoned" if ($cksum_type eq 'fixedVbns');
	logcomment("RaidSqa.pm: aggr/vol-$filer_vol has Checksum_type-$cksum_type");
	return($cksum_type);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_fsm_state

RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets fsm_state of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("fsm_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_raidtree_type

RaidSqa_check_aggr_raidtree_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets raidtree_type of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_raidtree_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("raidtree_type");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_storage_type

RaidSqa_check_aggr_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets storage type of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_storage_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        my %aggr_disk_hash = $aggr_obj->all_disks();
        my @aggr_disk_list = keys(%aggr_disk_hash);
        my $disk_obj = $aggr_obj->disk("$aggr_disk_list[0]");

        return $disk_obj->parameter("disk_type");
        
}
#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_bits

RaidSqa_check_aggr_bits(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets aggr bits of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_bits {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        return $aggr_obj->parameter("aggr_format");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_mirror_state

RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets mirror_state of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_mirror_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("mirror_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_context_parity_valid

RaidSqa_check_aggr_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag context_parity_valid of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_context_parity_valid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("context_parity_valid");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_has_bad_blocks

RaidSqa_check_aggr_has_bad_blocks(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag has_bad_blocks of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_has_bad_blocks {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("has_bad_blocks");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_bad_block_count

RaidSqa_check_aggr_bad_block_count(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag bad_block_count of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_bad_block_count {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("bad_block_count");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_tetris_opt_disabled

RaidSqa_check_aggr_tetris_opt_disabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag tetris_opt_disabled of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_tetris_opt_disabled {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
	return $aggr_obj->parameter("tetris_opt_disabled");
}
#------------------------------------------------------------------------------
 
=head2 RaidSqa_get_aggr_uuid
 
RaidSqa_get_aggr_uuid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);
 
This subroutine gets value of flag uuid of a particular volume/aggregate.
 
It returns scalar.
 
The following arguments are accepted:
 
=over
 
=item host
 
(Required): Hostspec to filer
 
=item filermode
 
(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"
 
=item conntype
 
(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.
 
=item filer_vol
 
(Required) : Name of aggregate or traditional volume to be checked.
 
=back
 
=cut
 
#------------------------------------------------------------------------------
 
sub RaidSqa_get_aggr_uuid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
 
        if($filermode ne "normal"){
                $conntype = "#console";
        }
 
        my $conn = make_conn($host,$conntype);
 
        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        return $aggr_obj->parameter("uuid");
}



#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_fsid

RaidSqa_get_aggr_fsid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine returns fsid parameter from raid_config ouput for given aggr

It returns fsid of a given aggr

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(required) : Name of vol/aggr who's fsid is to be returned

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_fsid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $vol_obj = $raid_obj->volume("$filer_vol");
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
    if ($aggr_obj) {
        return $aggr_obj->parameter("fsid");
    } else {
        return $vol_obj->parameter("fsid");
    }
}



#------------------------------------------------------------------------------

=head2 RaidSqa_get_root_aggr

RaidSqa_get_root_aggr(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by gets root aggr name in a given filer. 

It returns an scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_root_aggr {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my %all_aggr=$raid_obj->all_aggregates();
	my @all_aggr=keys(%all_aggr);
	my $aggr;
	foreach $aggr (@all_aggr) {
		my $aggr_obj=$raid_obj->aggregate("$aggr");
		if ($aggr_obj->parameter("root") eq "1") {
			return $aggr;
		} 
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_root_vol

RaidSqa_get_root_vol(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by gets root volume name in a given filer. 

It returns an scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_root_vol {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my %all_vol=$raid_obj->all_volumes();
	my @all_vol=keys(%all_vol);
	my $vol;
	foreach $vol (@all_vol) {
		my $vol_obj=$raid_obj->volume("$vol");
		if ($vol_obj->parameter("root") eq "1") {
			return $vol;
		} 
	}
}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_plex_resync_level

RaidSqa_get_plex_resync_level(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine gets resync level of a given plex if it is 0 or 1.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_plex_resync_level {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# get list of groups in a specified plex
        my $raid_obj = new RaidInfo($conn);
        my $plex_obj = $raid_obj->plex("$plex_name");
        my $plex_resync_level = $plex_obj->parameter("resync_level");
        return  $plex_resync_level;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_plex_fsm_state

RaidSqa_check_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

This subroutine gets fsm_state of a particular plex.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_plex_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $plex_obj = $raid_obj->plex("$plex_name");
	return $plex_obj->parameter("fsm_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_plex_list

RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by default gets list of all plexes in a given filer. If filer_vol is given than it gives plex in that volume/aggregate.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_plex_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my @plex_list;
	if ($filer_vol) {
        	my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        	my %plex_list = $aggr_obj->all_plexes();
        	@plex_list = keys(%plex_list);
	} else {
        	my %plex_list = $raid_obj->all_plexes();
        	@plex_list = keys(%plex_list);
	}
        return  @plex_list;
}

#------------------------------------------------------------------------------
# @burt 359148 handle NULL aggr_obj and NULL plex_obj situations in RaidSqa_get_group_list subroutine 

=head2 RaidSqa_get_group_list

RaidSqa_get_group_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name);

This subroutine by default gets list of raid groups in a given filer. If any one of filer_vol or plex_name is given than it gives list of raid groups in that.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume.

=item plex_name

(Optional) : Name of plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my @group_list;
	if ($filer_vol) {
        	my $aggr_obj = $raid_obj->aggregate("$filer_vol");
                # Check if the aggr_obj is valid
                if ( ! ( $aggr_obj ) )
                {
                   return  @group_list;
                }
        	my %group_list = $aggr_obj->all_raid_groups();
        	@group_list = keys(%group_list);
	} elsif ($plex_name) {
        	my $plex_obj = $raid_obj->plex("$plex_name");
                # Check if the plex_obj is valid
                if ( ! ( $plex_obj ) )
                {
                   return  @group_list;
                }
        	my %group_list = $plex_obj->all_raid_groups();
        	@group_list = keys(%group_list);
	} else {
        	my %group_list = $raid_obj->all_raid_groups();
        	@group_list = keys(%group_list);

	}
        return  @group_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_list_by_fsm_state

RaidSqa_get_group_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, filer_vol=>$filer_vol, plex_name=>$plex_name);

This subroutine by default gets list of raid groups of particular fsm_state in a given filer. If any one of filer_vol or plex_name is given than it gives list of raid groups of particular fsm_state in that.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Fsm_state of raidgroup, we want the list of.

=item filer_vol

(Optional) : Name of aggregate or traditional volume.

=item plex_name

(Optional) : Name of plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_list_by_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fsm_state => { type=>SCALAR },
                                filer_vol => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $fsm_state = $opts{fsm_state};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
	my @group_list;
	if ($filer_vol) {
        	my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        	my %group_list = $aggr_obj->all_raid_groups();
        	@group_list = keys(%group_list);
	} elsif ($plex_name) {
        	my $plex_obj = $raid_obj->plex("$plex_name");
        	my %group_list = $plex_obj->all_raid_groups();
        	@group_list = keys(%group_list);
	} else {
        	my %group_list = $raid_obj->all_raid_groups();
        	@group_list = keys(%group_list);

	}
	my $group;
	my $n=0;
	my @group_fsm_state;
        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("fsm_state") eq $fsm_state) {
                        $group_fsm_state[$n]=$group;
                        $n++;
                }
        }
	return @group_fsm_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_fsm_state

RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets fsm_state of a particular raid group.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid_group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
	return $group_obj->parameter("fsm_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_recons_suspended_block

RaidSqa_check_group_recons_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets recons_suspended_block of a particular raid group.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid_group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_recons_suspended_block {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
	return $group_obj->parameter("recons_suspended_block");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_scrub_suspended_block

RaidSqa_get_group_scrub_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine returns suspended block number for a group

It returns value of parameter scrub_suspended_block for a given group_name
It returns -1 if scrub is not suspended
It returns 0 if group does not exist

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group whose parameter value is to be returned

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_group_scrub_suspended_block {
                my (%opts) =
                  validate(@_,
                                   {host      => {type => OBJECT, isa     => 'Hostrec'},
                                        filermode => {type => SCALAR, default => "normal", optional => 1},
                                        conntype  => {type => SCALAR, default => "#rsh", optional => 1},
                                        group_name => {type => SCALAR},});
                my $host       = $opts{host};
                my $filermode  = $opts{filermode};
                my $conntype   = $opts{conntype};
                my $group_name = $opts{group_name};

                if ($filermode ne "normal") {
                        $conntype = "#console";
                }

                my $conn = make_conn($host, $conntype);

                # check a test group exists
                if (!RaidSqa_check_group_exist(host => $host, conntype => $conntype, group_name => $group_name)) {
                        logcomment("RaidSqa.pm: Raid group $group_name does not exist");
                        return 0;
                } else {
                        my $raid_obj  = new RaidInfo($conn);
                        my $group_obj = $raid_obj->raid_group("$group_name");
                        return $group_obj->parameter("scrub_suspended_block");
                }
}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_context_parity_valid

RaidSqa_check_group_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name);

This subroutine gets value of flag context_parity_protected of a particular group in volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of group_name to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_context_parity_valid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
	return $group_obj->parameter("context_parity_protected");
}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list

RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of all disks recognized by raid in a given filer. By specifing any one of the options from spare_only, filer_vol, plex_name or group_name, we can get the disk list in that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                spare_only => {type=>SCALAR,default=>"no",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $spare_only = $opts{spare_only};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	
	if ($spare_only =~ /yes|Yes|YES/ ) {
		my %all_spare_disks=$raid_obj->spare_disks();
		my @spare_disks=keys(%all_spare_disks);
		return @spare_disks; 
	} elsif ($filer_vol) {
		my $aggr_obj=$raid_obj->aggregate($filer_vol);
		my %aggr_disk_list=$aggr_obj->all_disks();
		my @aggr_disk_list=keys(%aggr_disk_list);
		return @aggr_disk_list; 
	} elsif ($plex_name) {
		my $plex_obj=$raid_obj->plex($plex_name);
		my %plex_disk_list=$plex_obj->all_disks();
		my @plex_disk_list=keys(%plex_disk_list);
		return @plex_disk_list; 
	} elsif ($group_name) {
		my $group_obj=$raid_obj->raid_group($group_name);
		my %group_disk_list=$group_obj->all_disks();
		my @group_disk_list=keys(%group_disk_list);
		return @group_disk_list; 
	} else {
    		my %all_disks = $raid_obj->all_disks();
		my @all_disks=keys(%all_disks);
		return @all_disks; 
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_pool

RaidSqa_get_disk_list_by_pool(host=>$host, filermode=>$filermode, conntype=>$conntype, pool_name =>$pool_name, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks in a given pool recognized by raid in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list in a given pool from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item pool_name

(Required) : Name of pool to get the list of disks. Options are "pool0" or "pool1".

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks from a pool.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_pool {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                pool_name => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $pool_name = $opts{pool_name};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	my @disk_list;

	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    	my $a=0;
    	my $b=0;
	my $disk;
	my @disks_pool0;
	my @disks_pool1;
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
      		if ($disk_obj->parameter("pool") eq "0") {
        		$disks_pool0[$a]=$disk;
        		$a++;
		} elsif ($disk_obj->parameter("pool") eq "1") {
			$disks_pool1[$b]=$disk;
                        $b++;
               	} 
	}
		
	if ($pool_name =~ /pool0|Pool0|POOL0/ ) {
		return @disks_pool0; 
	} elsif ($pool_name =~ /pool1|Pool1|POOL1/ ) {
		return @disks_pool1;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_fsm_state

RaidSqa_get_disk_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state =>$fsm_state, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given fsm_state in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given fsm_state from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Name of fsm_state to get the list of disk.  Possible values are OFFLINE, INUSE, RECONS and more

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_fsm_state {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                fsm_state => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fsm_state = $opts{fsm_state};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	my @disk_list;
	my @disk_fsm_state;

	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    	my $a=0;
	my $disk;
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
      		if ($disk_obj->parameter("fsm_state") eq $fsm_state) {
       			$disk_fsm_state[$a]=$disk;
       			$a++;
		}
	}
		
	return @disk_fsm_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_parent_state

RaidSqa_get_disk_list_by_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, parent_state =>$parent_state, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given parent_state in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given parent_state from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Name of fsm_state to get the list of disk.  Possible values are OFFLINE, INUSE, RECONS and more

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_parent_state {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                parent_state => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $parent_state = $opts{parent_state};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	my @disk_list;
	my @disk_parent_state;

	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    	my $a=0;
	my $disk;
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
      		if ($disk_obj->parameter("parent_state") =~ "$parent_state") {
       			$disk_parent_state[$a]=$disk;
       			$a++;
		}
	}
		
	return @disk_parent_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_raid_type

RaidSqa_get_disk_list_by_raid_type(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_type =>$raid_type, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given raid_type in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given raid_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item raid_type

(Required) : Name of raid_type to get the list of disk. Possible values are data, parity, dparity 

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_raid_type {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                raid_type => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $raid_type = $opts{raid_type};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	my @disk_list;
	my @disk_raid_type;

	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    	my $a=0;
	my $disk;
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
      		if ($disk_obj->parameter("raid_type") eq $raid_type) {
       			$disk_raid_type[$a]=$disk;
       			$a++;
		}
	}
		
	return @disk_raid_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_storage_type

RaidSqa_get_disk_list_by_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, storage_type =>$storage_type, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given storage_type in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given storage_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item storage_type

(Required) : Name of storage_type to get the list of disk. Possible values are ATA, FCAL, SAS, BSAS. 

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.

=item enable_mixed_disktype

(Optional): Defines if raid.disktype.enable should be checked or not to return disks by storagetype
            Possible values - on, off, default - on
            on - refers that we should consider value of options 'raid.disktype.enable' before selecting the disk list
            off - refers that we should stick to input storage type while selecting disk list irrespective of value of raid.disktype.enable

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_storage_type {
	my (%opts) = validate(@_, {
                        host         => { type=>OBJECT, isa=>'Hostrec' },
                        filermode    => { type=>SCALAR,default=>"normal", optional=>1},
                        conntype     => {type=>SCALAR,default=>"#rsh",optional=>1},
                        storage_type => { type=>SCALAR },
                        spare_only   => { type=>SCALAR,default=>"no", optional=>1},
                        disk_list    => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
                        filer_vol    => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                        plex_name    => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                        group_name   => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                        enable_mixed_disktype => {type => SCALAR, default => "on", optional => 1},
                    });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $storage_type = $opts{storage_type};
    my $spare_only = $opts{spare_only};
    my $disk_list = $opts{disk_list};
    my $filer_vol = $opts{filer_vol};
    my $plex_name = $opts{plex_name};
    my $group_name = $opts{group_name};
    my $enable_mixed_disktype = $opts{enable_mixed_disktype};

    if($filermode ne "normal"){
            $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    my $raid_obj = new RaidInfo($conn);
	my @disk_list;
	my @disk_storage_type;


	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    my $a=0;
	my $disk;
	my $mixed_disk_not_allowed_flag=0;
	my @mixed_storage_type=();
	
	$mixed_disk_not_allowed_flag=RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>"raid.disktype.enable");
	
    #If enable_mixed_disktype is set to off, it will select single storage type even if option 'raid.disktype.enable' is set to off!
	if($mixed_disk_not_allowed_flag=~/on/i or lc $enable_mixed_disktype eq "off"){
		logcomment("RaidSqa.pm: Mixed Disk Types are not allowed. Only Storage specific disks of type $storage_type will be returned.\n");
		@mixed_storage_type=($storage_type);
	}else{
		logcomment("RaidSqa.pm: Mixed Disk Types are allowed. All supported combinations of disks with type $storage_type will be returned.\n");
		@mixed_storage_type=($storage_type);
        @mixed_storage_type=("FCAL","SAS") if ($storage_type eq 'FCAL' || $storage_type eq 'SAS');
        @mixed_storage_type=("ATA","SATA","BSAS") if ($storage_type eq 'ATA' || $storage_type eq 'SATA' || $storage_type eq 'BSAS');
	}
	
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
		foreach my $disk_type(@mixed_storage_type){
			if ($disk_obj->parameter("disk_type") eq $disk_type) {
				$disk_storage_type[$a]=$disk;
				$a++;
			}
		}
	}
		
	return @disk_storage_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_rpm

RaidSqa_get_disk_list_by_rpm(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_rpm =>$disk_rpm, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given disk_rpm in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given disk_rpm from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_rpm

(Required) : Value of disk_rpm to get the list of disk. Possible values are 7200, 10000, 15000. 

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_rpm {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_rpm => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
				filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
				group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_rpm = $opts{disk_rpm};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    	my $raid_obj = new RaidInfo($conn);
	my @disk_list;
	my @list_disk_rpm;


	if (!$disk_list) {
		@disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name); 
	} else {
		@disk_list=@$disk_list;
	} 

    	my $a=0;
	my $disk;
	foreach $disk (@disk_list) {
		my $disk_obj=$raid_obj->disk("$disk");
      		if ($disk_obj->parameter("rpm") eq $disk_rpm) {
       			$list_disk_rpm[$a]=$disk;
       			$a++;
		}
	}
		
	return @list_disk_rpm;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_fsm_state 

RaidSqa_get_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the fsm state of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}


	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_fsm_state=$disk_obj->parameter("fsm_state");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_fsm_state;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_used_size 

RaidSqa_get_disk_used_size(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the used_size of a particular disk in MB .

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_used_size {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_used_sz=$disk_obj->parameter("used_sz");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_used_sz;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_parent_state 

RaidSqa_get_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the parent_state state of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_parent_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_parent_state=$disk_obj->parameter("parent_state");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_parent_state;
	}

}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_group_name 

RaidSqa_get_disk_group_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the group name of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_group_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_raid_name=$disk_obj->parameter("raid_name");

	my $disk_name_length = length $disk_name;
	my $disk_raid_name_length = length $disk_raid_name;
	my $substr_length = $disk_raid_name_length - $disk_name_length - 1;
	my $disk_group_name = substr($disk_raid_name, 0, $substr_length); 
        return $disk_group_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_plex_name 

RaidSqa_get_disk_plex_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the plex name of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_plex_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_raid_name=$disk_obj->parameter("raid_name");
	my $disk_group_rgid=$disk_obj->parameter("group_rgid");

	my $disk_name_length = length $disk_name;
	my $disk_group_rgid_length= length $disk_group_rgid;
	my $disk_raid_name_length = length $disk_raid_name;
	my $substr_length = $disk_raid_name_length - $disk_name_length - $disk_group_rgid_length - 4;
	my $disk_plex_name = substr($disk_raid_name, 0, $substr_length); 
        return $disk_plex_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_aggr_name 

RaidSqa_get_disk_aggr_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the aggr/vol name of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_aggr_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_raid_name=$disk_obj->parameter("raid_name");
	my $disk_group_rgid=$disk_obj->parameter("group_rgid");
	my $disk_plex_pid=$disk_obj->parameter("plex_pid");

	my $disk_name_length = length $disk_name;
	my $disk_group_rgid_length= length $disk_group_rgid;
	my $disk_plex_pid_length= length $disk_plex_pid;
	my $disk_raid_name_length = length $disk_raid_name;
	my $substr_length = $disk_raid_name_length - $disk_name_length - $disk_group_rgid_length - $disk_plex_pid_length - 10;
	my $disk_aggr_name = substr($disk_raid_name, 1, $substr_length); 
        return $disk_aggr_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_other_path_name 

RaidSqa_get_disk_other_path_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the other path name of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_other_path_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
				my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
		
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
		my $disk_path_name2=$disk_obj->parameter("path_name2");
		my $disk_path_name1=$disk_obj->parameter("path_name1");
		if ( $disk_path_name2 eq $disk_name) {
                	return $disk_path_name1;
		} else {
                	return $disk_path_name2;
		}
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_sdc_target 

RaidSqa_get_disk_sdc_target(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the sdc target disks of a particular disk being copied in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_sdc_target {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}


	my $disk;
	my $raid_obj = new RaidInfo($conn);
	my %disk_hash = $raid_obj->all_disks();
    	my @disk_list = keys(%disk_hash);

	my $disk_obj = $raid_obj->disk("$disk_name");

	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
		my $disk_copy_target_id=$disk_obj->parameter("copy_target_id");
		foreach $disk (@disk_list) {
			my $disk_obj1=$raid_obj->disk("$disk");
      			if ($disk_obj1->parameter("id") eq $disk_copy_target_id) {
                		return $disk;
			}
		}
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_preferred_storage_type

RaidSqa_get_preferred_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets preferred storage type in a mix environment based upon which storage type is having more spare disks available.

It returns an scalar $storage_type on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_preferred_storage_type {
    my (%opts) =
               validate(@_,
                       {host      => {type => OBJECT, isa     => 'Hostrec'},
                        filermode => {type => SCALAR, default => "normal", optional => 1},
                        checksum_type  => {type => SCALAR | UNDEF, default => undef, optional => 1},
                        conntype  => {type => SCALAR, default => "#rsh", optional => 1},});

    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $checksum_type  = $opts{checksum_type};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    my $raid_obj    = new RaidInfo($conn);
    my %spare_disks = $raid_obj->spare_disks();
    my @spare_disks = keys(%spare_disks);	
    my @spares_ata  = ();
    my @spares_fcal = ();
    my @spares_sas  = ();
    my @spares_bsas = ();
    my $disk;

    # get spare based upon storage type
    foreach $disk (@spare_disks) {
        my $disk_obj = $raid_obj->disk("$disk");
        next if(!defined($disk_obj));
		if(defined($checksum_type)) {
			my $disk_cksum = $disk_obj->parameter("checksum_type");
			next if(defined($disk_cksum) && $disk_cksum ne $checksum_type);
		}
        if ($disk_obj->parameter("disk_type") eq "ATA") {
            push(@spares_ata, $disk);
        } elsif ($disk_obj->parameter("disk_type") eq "BSAS") {
            push(@spares_bsas, $disk);
        } elsif ($disk_obj->parameter("disk_type") eq "FCAL") {
            push(@spares_fcal, $disk);
        } elsif ($disk_obj->parameter("disk_type") eq "SAS") {
            push(@spares_sas, $disk);
        }
    } ## end foreach $disk (@spare_disks)

    my %disk_type_count = ();
    $disk_type_count{scalar(@spares_sas)}  = "SAS";
    $disk_type_count{scalar(@spares_bsas)} = "BSAS";
    $disk_type_count{scalar(@spares_ata)}  = "ATA";
    $disk_type_count{scalar(@spares_fcal)} = "FCAL";

    #check which storage type spare are more in system and use that as preferred storage type
    # If they have same count, the one listed last above will take the priority
    my @counts = sort { $a <=> $b } keys %disk_type_count;
    my $storage_type = $disk_type_count{$counts[$#counts]};
    return $storage_type;    
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_raid_size_value

RaidSqa_get_raid_size_value(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type, override=>$override); 

This subroutine gets value of raid_size for min/max/default for a given raid_type and storage_type.

It returns a scalar $raid_size on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item raid_size

(Required) : Raid size of the volume/aggregate to be created.  No default. Any value from min, max or default.

=item raid_type

(Required) : Raid type of the volume/aggregate to be created. No default. Can be raid4 or raid_dp.

=item storage_type

(Required) : Disk storage type. Can be ATA, SAS, FCAL, BSAS.

=item override

(Required) : override options value, can be on, off

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_raid_size_value {
        
		my (%opts) = validate(@_, {
						host => { type=>OBJECT, isa=>'Hostrec' },
						filermode => { type=>SCALAR, default=>"normal", optional=>1 },
						conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
						storage_type => {type=>SCALAR},
						raid_type => {type=>SCALAR},
						raid_size => {type=>SCALAR},
						override => {type=>SCALAR,default=>"off",optional=>1},
					}
		);

	my $host = $opts{host};
	my $filermode = $opts{filermode};
	my $conntype = $opts{conntype};
	my $storage_type = uc $opts{storage_type};
	my $raid_type = $opts{raid_type};
	my $raid_size = lc $opts{raid_size};
	my $override = $opts{override};	
	
	my @storage_types = ("FCAL", "ATA", "BSAS", "SSD", "SAS");
    my @raid_types = ("raid_dp", "raid4", "raid0");
	my %hash = ();
    my $index = 0;
	my $entry = 0;
	my $entry_for = "";		
	my $raid_size_value = undef;	
		
	# create connection
	if($filermode ne "normal"){
            $conntype = "#console";
	}
	
	if(!(grep /$raid_type/i, @raid_types)){
	    logcomment("RaidSqa.pm: Unrecongnized value for raid_type: $raid_type, should be one of @raid_types");
	    return 0;
	}

	#defining some default values for older builds where raid_config command is not available
    if($storage_type =~ /ATA|BSAS/) {
        if($raid_type eq "raid4") {
            $raid_size_value = 7    #For both default and max
        } elsif($raid_type eq "raid_dp") {
            $raid_size_value = 14 if ($raid_size eq "default");
            $raid_size_value = 16 if ($raid_size eq "max");
        }
    } elsif($storage_type =~ /FCAL|SAS/) {
        if($raid_type eq "raid4") {
            $raid_size_value = 8  if ($raid_size eq "default");
            $raid_size_value = 14 if ($raid_size eq "max");
        } elsif($raid_type eq "raid_dp") {
            $raid_size_value = 16 if ($raid_size eq "default");
            $raid_size_value = 28 if ($raid_size eq "max");
        }
    }
    
	if($raid_size =~ /^(max|min|default)$/i) {
	    if($raid_size =~ /min/) {
		return 1 if($raid_type eq "raid0");
		return 2 if($raid_type eq "raid4");
		return 3 if($raid_type eq "raid_dp");
	    }
	} else {
	    logcomment("RaidSqa.pm: Unrecongnized value for raid_size: $raid_size, should be min|max|default");
	    return 0 ;
	}
	
	if(!(grep /$storage_type/i, @storage_types)){
	    logcomment("RaidSqa.pm: Unrecongnized value for storage_type: $storage_type, should be one of @storage_types");
	    return 0;
	}
	
	
	if($override =~ /^(on|off)$/i) {
	    $override = "override_".$override;
	} else {
	    logcomment("RaidSqa.pm: Unrecongnized value for override option: $override, should be on/off");
	    return 0;
	}
	
	 
	my $conn = make_conn($host,$conntype);
	my (undef, undef, $output) = say($conn, "priv set -q test; raid_config group_size_override");
	my @output = split(/\r*\n/,$output);        
	
	#get index from where table starts
	for($index=0; $index<=$#output; $index++){
			if($output[$index] =~ /Disk Type/) {
					last;
			}
	}
	$index+=2;
	
	for(;$index <= $#output; $index++) {		
		my @line = split(/\s+/, $output[$index]);	
		if(defined($line[0]) && grep /$line[0]/, @storage_types) {
			if(grep /$line[1]/, @raid_types) {	
				$entry = 1 ;
				$entry_for = uc $line[0];		
				$hash{$entry_for}->{$line[1]}->{override_off}->{default} = $line[2];
				$hash{$entry_for}->{$line[1]}->{override_off}->{max} = $line[3];
				$hash{$entry_for}->{$line[1]}->{override_on}->{default} = $line[4];
				$hash{$entry_for}->{$line[1]}->{override_on}->{max} = $line[5];
			} else {				
				$entry = 0;
				next;
			}
		} elsif($line[0]) {				
			logcomment("RaidSqa.pm: unknown disk_type found: $line[0]");
			$entry = 0;
			$entry_for = "";
			next;
		} elsif($entry) {
			if((defined($line[1]) && grep /$line[1]/, @raid_types)) {					
				$hash{$entry_for}->{$line[1]}->{override_off}->{default} = $line[2];
				$hash{$entry_for}->{$line[1]}->{override_off}->{max} = $line[3];
				$hash{$entry_for}->{$line[1]}->{override_on}->{default} = $line[4];
				$hash{$entry_for}->{$line[1]}->{override_on}->{max} = $line[5];				
			} else {
				next;
			}
		}
	}
	
    my $value = $hash{$storage_type}->{$raid_type}->{$override}->{$raid_size};
	if($value =~ /\d+/) {
		logcomment("RaidSqa.pm: $raid_size raid_size for $storage_type for $raid_type is $value");
		return $value;
	} elsif(defined($raid_size_value)) { 
		logcomment("RaidSqa.pm: $raid_size raid_size for $storage_type for $raid_type is $raid_size_value ");
		return $raid_size_value;
    } else {
		logcomment("RaidSqa.pm: Disks of storage type $storage_type are not present");
		return 0;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_scrub_report_by_group

RaidSqa_get_scrub_report_by_group(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets scrub report (PI/checksum/media error) of a particular raid group.

It returns reference to a hash on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_scrub_report_by_group {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                group_name => { type=>SCALAR },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
        my %hash;

	# check if filer is having a flex vol of specified name
        if ($group_obj->parameter("scrub_progress") ne "-1") {
		logcomment("RaidSqa.pm: Scrub not complete yet on raid group $group_name");
		return 0;
	} else  {
                $hash{pi} = $group_obj->parameter("scrub_pi");
                $hash{cksum_err} = $group_obj->parameter("scrub_cksum_err");
                $hash{media_err} = $group_obj->parameter("scrub_media_err");
                $hash{lw_err} = $group_obj->parameter("scrub_lw_err");
        }       
        return \%hash; 
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_fiji_slot 

RaidSqa_get_fiji_slot(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine get the fiji slot numbers for a particular fiji point.

It returns an array on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required) : Name of fiji_point .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_fiji_slot {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#rsh", optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $fiji_point = $opts{fiji_point};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        my $line;
	my $n=0;
	my @fiji_slot;
        (undef,undef, $output) = say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);
        my @info = split(/\r?\n/, $output);
	foreach $line (@info) {
		my (@data) = split(": ", $line);
		if (index($line, "$fiji_point") ne "-1") {
			if (index($data[0], " (nvram)") ne "-1") {
                               substr($data[0], index($data[0], " (nvram)"))="";
                       	}
			$fiji_slot[$n]=$data[0];
			$n++;
		}
	}
	return @fiji_slot;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_setflag

RaidSqa_get_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name);

This subroutine get value of a setflag using printflag command. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item flag_name

(Required): Name of the flag to get value for.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_setflag {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                flag_name => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $flag_name = $opts{flag_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        # get value of a specified flag using printflag command
        (undef,undef,$output)=say($conn, "priv set -q test; printflag $flag_name", -timeout, $RaidSqa_TIMEOUT);
	my @output1 = split(/\r?\n/, $output);
	my ($flag, $value) = split(/ = /, $output1[0]);
	return $value;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_options

RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name);

This subroutine get value of an options.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item option_name

(Required): Name of the option to get value.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                option_name => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_name = $opts{option_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        # get value of a specified option
        #(undef,undef,$output)=say($conn, "priv set -q test; options $option_name", -timeout, $RaidSqa_TIMEOUT);
        $output = filer_cmd(host=>$host, cmd=>"options $option_name");
        my @output1 = split(/\r?\n/, $output);
	my ($option, $value) = split(/\s+/, $output1[0]);
	return $value;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_fileid

RaidSqa_get_fileid(host=>$host, filermode=>$filermode, conntype=>$conntype, file_name=>$file_name);

This subroutine get fileid of a file.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item file_name

(Required): Name of the file_name to get id.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_fileid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                file_name => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $file_name = $opts{file_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
	my $entry;
	my $file_id;
	
        (undef,undef,$output)=say($conn, "priv set -q test; showfh $file_name", -timeout, $RaidSqa_TIMEOUT);
	my @file_info = split(/ /, $output);
	foreach $entry (@file_info) {
    		if ($entry =~ /fileid=(.*)/) {
    			$file_id=$1;
			logcomment("RaidSqa.pm: fileid of file $file_name is $file_id");
    			last;
    		}
	}

	if(!$file_id ) {
		logresult("FATAL", "RaidSqa.pm: Could not get the fileid of file $file_name ");	

	} else {
		return $file_id;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_file_block_info

RaidSqa_get_file_block_info(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, file_name=>$file_name, $block_number=>$block_number);

This subroutine get disk and dbn number for a file block.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item file_name

(Required): Name of the file_name .

=item block_number

(Required): the block number of file .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_file_block_info {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol=> {type=>SCALAR},
                                file_name => { type=>SCALAR },
                                block_number => { type=>SCALAR },
                                }
                        );
	my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $file_name = $opts{file_name};
        my $block_number = $opts{block_number};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $file_id = RaidSqa_get_fileid(host=>$host, conntype=>$conntype, file_name=>$file_name);

        my $output;
	my $entry;
	
        #say($conn, "priv set -q test; dumpblock info $filer_vol $file_id $block_number", "disk.+",-timeout, $RaidSqa_TIMEOUT);
	my $o;
        (undef, undef, $o) = say($conn, "priv set -q test; dumpblock info $filer_vol $file_id $block_number", -timeout, $RaidSqa_TIMEOUT);

	#my @block_info = split(/, /, $RESPONSE);
	my @block_info = split(/\r?\n/, $o);
                	logcomment("RaidSqa.pm: vbn is @block_info");
	my $disk_id;
	my $dbn_no;
	my $vbn_no;
	foreach $entry (@block_info) {
        	if ($entry =~ /disk (.*)/) {
                	$disk_id=$1;
                	logcomment("RaidSqa.pm: diskid is $disk_id");
                	next;
        	}
        	if ($entry =~ /^dbn (.*)/) {
                	$dbn_no=$1;
                	logcomment("RaidSqa.pm: dbn is $dbn_no");
                	next;
        	}
        	if ($entry =~ /pvbn (.*)/) {
                	$vbn_no=$1;
                	logcomment("RaidSqa.pm: vbn is $vbn_no");
                	next;
        	}
	}

	if (!$disk_id  || !$dbn_no || !$vbn_no ) {
		logresult("FATAL", "RaidSqa.pm: Could not get the disk_id  or dbn_no or vbn_no of file $file_name, block $block_number ");	
	} else {
		return ($disk_id, $dbn_no, $vbn_no);
	}

}

=head2 RaidSqa_get_disk_storage_type

RaidSqa_get_disk_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk);

This subroutine gets the storage_type of the given disk.

It returns the storage type of disk on success otherwise returns 0.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): Name of disk whose storage type is required.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_storage_type {
    my (%opts) =
      validate(
                @_,
                {
                   host => { type => OBJECT, isa => 'Hostrec' },
                   filermode =>
                     { type => SCALAR, default => "normal", optional => 1 },
                   conntype =>
                     { type => SCALAR, default => "#rsh", optional => 1 },
                   disk_name => { type => SCALAR | UNDEF },
                }
      );
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
			
    if ( $filermode ne "normal" ) {
        $conntype = "#console";
    }

    my $conn = make_conn( $host, $conntype );
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

    my $raid_obj = new RaidInfo($conn);
    my @disk_list;
    my %disk_storage_type = ();

    if ( !$disk_name ) {
        logcomment("RaidSqa.pm: disk_name is the required parameter.");
        return 0;
    }

    my $disk_obj     = $raid_obj->disk("$disk_name");
    my $storage_type = $disk_obj->parameter("disk_type");
    return $storage_type;
}

=head2 RaidSqa_media_error_inject

RaidSqa_media_error_inject(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn => $dbn);

This subroutine injects media error on given disk at given dbn depending on storage type.

It returns 1 on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item dbn

(Required) : dbn no to inject media error.

=item disk_name

(Required): Name of disk to inject media erro.


=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_media_error_inject {
    my (%opts) =
      validate(
                @_,
                {
                   host => { type => OBJECT, isa => 'Hostrec' },
                   filermode =>
                     { type => SCALAR, default => "normal", optional => 1 },
                   conntype =>
                     { type => SCALAR, default => "#rsh", optional => 1 },
                   disk_name => { type => SCALAR },
                   dbn       => { type => SCALAR },
                }
      );
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
		if(defined($disk_name)){
			my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
			if($disk_name1){
				logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
				$disk_name=$disk_name1;
			}else{
				logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
				return(0);
			}
		}
		my $dbn       = $opts{dbn};

    if ( $filermode ne "normal" ) {
        $conntype = "#console";
    }

    my $storage_type =
      RaidSqa_get_disk_storage_type(
                                     host      => $host,
                                     filermode => $filermode,
                                     disk_name => $disk_name
      );
    if ( !$storage_type ) {
        return 0;
    }
    if ( $storage_type =~ /ata|bsas|sata/i ) {
        logcomment("RaidSqa.pm: Injecting media error through fiji.");
        my $media_error_1 =
            '(repeat 100000 (raid.disk.read.done.check (eq @disk'
          . " $disk_name)(return 1)))";
        my $media_error_2 =
            '((raid.disk.read.done.buf (&&(eq @disk'
          . " $disk_name) (eq " . '@bno'
          . " $dbn))(return (buf_Errno E_DISK_BAD_SECTOR_ERROR))))";
        if (
             !RaidSqa_fiji_filter(
                                   host       => $host,
                                   fiji_point => $media_error_1,
                                   filermode  => $filermode
             )
          )
        {
            logcomment(
                    "RaidSqa.pm: Media error 1 injection on disk $disk_name failed");
            return 0;
        }
        elsif (
                !RaidSqa_fiji_filter(
                                      host       => $host,
                                      fiji_point => $media_error_2,
                                      filermode  => $filermode
                )
          )
        {
            logcomment(
                    "RaidSqa.pm: Media error 2 injection on disk $disk_name failed");
            return 0;
        } else {
            logcomment(
                "RaidSqa.pm: Media error injected successfully using fiji. \n");
            return 1;
        }
    } elsif ( $storage_type =~ /FCAL|SAS/i ) {
        logcomment("RaidSqa.pm: Injecting media error through disk_mung.");
        my $sector = 8 * $dbn;
        RaidSqa_disk_mung(
                           host      => $host,
                           filermode => $filermode,
                           disk_name => $disk_name,
                           sector    => $sector
        );
        logcomment(
             "RaidSqa.pm: Media error injected successfully using disk_mung. \n"
        );
        return 1;
    } else {
        logresult(
"RaidSqa.pm: Disk has unknown storage type.Its storage type is $storage_type."
        );
        return 0;
    }
}

##############################################################################
# LIST OF OTHER FUNCTIONS 			                             #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_test_init

RaidSqa_test_init(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type);

This subroutine is called before starting any tests, this will do following:
a. stop hammer, 
b. unisolate any disk in olm,
c. online all offline disks
d. unfail all failed disks,
e. remove a particular aggregate/volume having same name as required for test volume/agregate,

It returns nothing.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=item aggr_type

(Required) : Aggregate or traditional. If 1 aggregate and if 0 than traditional.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_test_init{
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                aggr_type => { type=>SCALAR },
                                filer_vol => { type=>SCALAR },
                                }       
                        );      

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $aggr_type = $opts{aggr_type};
        my $filer_vol = $opts{filer_vol};
        my $cmd = $aggr_type ? "aggr" : "vol";

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        
	# abort hammer on filer
        RaidSqa_hammer_abort(host=>$host, conntype=>$conntype);
	# Unisolate all disk if any disk is in OLM
        RaidSqa_labelmaint_unisolate(host=>$host, conntype=>$conntype);
	# online all offline disk if any disk 
        RaidSqa_disk_online(host=>$host, conntype=>$conntype, disk_name=>"all");
	# Unfail all disk to spare on filer
        RaidSqa_disk_unfail(host=>$host, conntype=>$conntype, disk_name=>"all", options=>"-s");
	# remove the tradvol if any exist with specified name
        RaidSqa_aggr_remove(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>0);
	# remove the aggr if any exist with specified name
        RaidSqa_aggr_remove(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>1);
#        my $output1 = say($conn, "priv set -q diag; disk zero spares", -timeout, $RaidSqa_TIMEOUT);
#        my $output2 = say($conn, "priv set -q diag; disk scrub stop", -timeout, $RaidSqa_TIMEOUT);
#        my $output3 = say($conn, "priv set -q diag; $cmd verify stop", -timeout, $RaidSqa_TIMEOUT);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_aggr_disks_zeroing_completion

RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, timeout=>$timeout);

This subroutine wait till the disk zeroing in a particular aggregate/volume gets completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked .

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_aggr_disks_zeroing_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
				timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj=new RaidInfo($conn);
        my $aggr_obj =$raid_obj->aggregate("$filer_vol");
        my %disklist=$aggr_obj->all_disks();
        my @disklist=keys(%disklist);
        my $count = 1;
        my $disk;
        while ($count > 0) {
                $raid_obj->refresh();
        	$aggr_obj =$raid_obj->aggregate("$filer_vol");
        if (!$aggr_obj) {
            logcomment("RaidSqa.pm: Aggr with name $filer_vol does not exist");
            return 0;
        }
        	%disklist=$aggr_obj->all_disks();
        	@disklist=keys(%disklist);
                $count = 0;
                logcomment("RaidSqa.pm: disklist in test volume/aggr is: @disklist ");

                foreach $disk (@disklist) {
                        my $disk_obj=$aggr_obj->disk("$disk");
                        if ($disk_obj->parameter("fsm_state") eq "ZEROING" || $disk_obj->parameter("fsm_state") eq "NOTZEROED") {
                                logcomment("RaidSqa.pm: disk $disk in test volume/aggr is not zeroed yet ");
                                $count++;
                        }
                }
                logcomment("RaidSqa.pm: waiting for $count disks to zero");
                sleep $timeout;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_plex_resync_completion

RaidSqa_wait_for_plex_resync_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name, resync_level=>$resync_level, timeout=>$timeout);

This subroutine wait till the resync (level 0 or level1) in a particular plex gets completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be checked .

=item resync_level

(Required) : 1 for level1 and 0 for level0. 

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_plex_resync_completion {
        my (%opts) = validate(@_, {
                                host => {type=>OBJECT,isa=>'Hostrec'},
                                filermode => {type=>SCALAR,default=>"normal",optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                plex_name => {type=>SCALAR },
                                resync_level => {type=>SCALAR,default=>"1",optional=>1},
				timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};
        my $resync_level = $opts{resync_level};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj=new RaidInfo($conn);
        my $plex_obj =$raid_obj->plex("$plex_name");

	if ($plex_obj->parameter("resyncing") eq "1") {
		logcomment("RaidSqa.pm: resyncing is going on plex $plex_name");
		if ($resync_level eq "1") {
			if ($plex_obj->parameter("resync_level") eq "1") {
				logcomment("RaidSqa.pm: level 1 resyncing is going on plex $plex_name");
			} else {
				logcomment("RaidSqa.pm: resyncing is not level 1 as expected on plex $plex_name");
				return 0;
			}
		} elsif ($resync_level eq "0") {
			if ($plex_obj->parameter("resync_level") eq "0") {
				logcomment("RaidSqa.pm: level 0 resyncing is going on plex $plex_name");
			} else {
				logcomment("RaidSqa.pm: resyncing is not level 0 as expected on plex $plex_name");
				return 0;
			}
		}
		# need to fix following after fix of burt 244854
		sleep 30;
		my $plex_resync_progress=$plex_obj->parameter("resync_progress");
		while ($plex_obj->parameter("resyncing") eq "1") {
			logcomment("RaidSqa.pm: resync is still $plex_resync_progress % on plex $plex_name, waiting for $timeout seconds"); 
			sleep $timeout;
        		$raid_obj->refresh();
        		$plex_obj = $raid_obj->plex("$plex_name");
            if (!$plex_obj) {
                logcomment("RaidSqa.pm: Plex with name $plex_name does not exist");
                return 0;
            }
			$plex_resync_progress=$plex_obj->parameter("resync_progress");
		}
		return 1;
	} else  {
		logcomment("RaidSqa.pm: No resync going on plex $plex_name, so looks like resync completed.");
		return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_reconstruction_completion

RaidSqa_wait_for_reconstruction_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name, timeout=>$timeout);

This subroutine by default wait till all reconstructions in a given filer get completed. But if any of the options from filer_vol, plex_name or group_name or disk_name is specified than it check reconstruction completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr/trad volume to be checked .

=item plex_name

(Optional) : Name of plex to be checked .

=item group_name

(Optional) : Name of raid group to be checked .

=item disk_name

(Optional) : Name of disk to be checked .

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_reconstruction_completion {
        my (%opts) = validate(@_, {
                                host => {type=>OBJECT,isa=>'Hostrec'},
                                filermode => {type=>SCALAR,default=>"normal",optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                disk_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
				timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
		if(defined($disk_name)){
			my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
			if($disk_name1){
				logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
				$disk_name=$disk_name1;
			}else{
				logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
				return(0);
			}
		}
		my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj=new RaidInfo($conn);
	my @group_list;
	if (defined($filer_vol)) {
		@group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
	} elsif (defined($plex_name)) {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
	} elsif (defined($group_name)) {
		push @group_list, $group_name;
	} else {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
	}

       	my $recons_in_progress = 1;
	if (defined($disk_name)) {
       		while ($recons_in_progress == 1) {
               		$recons_in_progress = 0;
			my $disk_obj=$raid_obj->disk("$disk_name");
                       	if ($disk_obj->parameter("parent_state") =~ /RECONS/ ) {
				logcomment("RaidSqa.pm: disk $disk_name is still doing reconstruction "); 	
                               	$recons_in_progress = 1;
			}
			sleep $timeout;
			$raid_obj->refresh();
		}
		
	} else {

       		while ($recons_in_progress == 1) {
               		$recons_in_progress = 0;
			my $group;
               		foreach $group (@group_list) {
				my $group_obj=$raid_obj->raid_group("$group");
				my $group_recons_progress=$group_obj->parameter("recons_progress");
                       		if ($group_recons_progress != -1) {
					logcomment("RaidSqa.pm: reconstruction still $group_recons_progress % on raid_group $group"); 	
                               		$recons_in_progress = 1;
				}
			}
			sleep $timeout;
			$raid_obj->refresh();
        	}
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_reparity_completion

RaidSqa_wait_for_reparity_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout);

This subroutine by default wait till the reparity gets completed on all raidgroups in filer. But if any of the options from filer_vol, plex_name or group_name is specified than it check reparity completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Use filer_vol if we want to check reparity progress on that particular aggr/trad volume.

=item plex_name

(Optional) : Use plex_name if we want to check reparity progress on that particular plex.

=item group_name

(Optional) : Use group_name if we want to check reparity progress on that particular raid group.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_reparity_completion {
        my (%opts) = validate(@_, {
                                host => {type=>OBJECT,isa=>'Hostrec'},
                                filermode => {type=>SCALAR,default=>"normal",optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
				timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj=new RaidInfo($conn);
	my $aggr_obj=$raid_obj->aggregate("$filer_vol");
	my $plex_obj=$raid_obj->plex("$plex_name");
	my $group_obj=$raid_obj->raid_group("$group_name");

	my @group_list;
	if (defined($aggr_obj)) {
		@group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
	} elsif (defined($plex_obj)) {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
	} elsif (defined($group_obj)) {
                @group_list= "$group_name";
	} else {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
	}
	
       	my $reparity_in_progress = 1;
       	while ($reparity_in_progress == 1) {
               	$reparity_in_progress = 0;
		my $group;
               	foreach $group (@group_list) {
			my $group_obj=$raid_obj->raid_group("$group");
			my $group_reparity_progress=$group_obj->parameter("reparity_progress");
                       	if ($group_reparity_progress != -1) {
				logcomment("RaidSqa.pm: reparity still $group_reparity_progress % on raid_group $group"); 	
                               	$reparity_in_progress = 1;
			}
		}
		sleep $timeout;
		$raid_obj->refresh();
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_verify_completion

RaidSqa_wait_for_verify_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, timeout=>$timeout);

This subroutine by default wait till the verify get completed on on all raid groups in filer. But if any of the options from filer_vol is specified than it check verify completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Use filer_vol if we want to check scrub progress on that particular aggr/trad volume.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_verify_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj=new RaidInfo($conn);

	my @aggr_list;
	if (defined($filer_vol)) {
		@aggr_list= "$filer_vol";
	} else {
		@aggr_list=RaidSqa_get_aggr_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
	}
	
       	my $verify_in_progress = 1;
       	while ($verify_in_progress == 1) {
               	$verify_in_progress = 0;
		my $aggr;
               	foreach $aggr (@aggr_list) {
			my $aggr_obj=$raid_obj->aggregate("$aggr");
			my $aggr_verify_progress=$aggr_obj->parameter("verifypct");
                       	if ($aggr_verify_progress != -1) {
				logcomment("RaidSqa.pm: aggr verify still $aggr_verify_progress % on aggr $aggr"); 	
                               	$verify_in_progress = 1;
			}
		}
		sleep $timeout;
		$raid_obj->refresh();
        }
}


#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_scrub_completion

RaidSqa_wait_for_scrub_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout);

This subroutine by default wait till the scrub get completed on on all raid groups in filer. But if any of the options from filer_vol, plex_name or group_name is specified than it check scrub completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Use filer_vol if we want to check scrub progress on that particular aggr/trad volume.

=item plex_name

(Optional) : Use plex_name if we want to check scrub progress on that particular plex.

=item group_name

(Optional) : Use group_name if we want to check scrub progress on that particular raid group.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_scrub_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
				timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj=new RaidInfo($conn);

	my @group_list;
	if (defined($filer_vol)) {
		@group_list= RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
	} elsif (defined($plex_name)) {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
	} elsif (defined($group_name)) {
                push @group_list, $group_name;
	} else {
		@group_list=RaidSqa_get_group_list(host =>$host, filermode =>$filermode, conntype =>$conntype);
	}
	
       	my $scrub_in_progress = 1;
       	while ($scrub_in_progress == 1) {
               	$scrub_in_progress = 0;
		my $group;
               	foreach $group (@group_list) {
			my $group_obj=$raid_obj->raid_group("$group");
			my $group_scrub_progress=$group_obj->parameter("scrub_progress");
                       	if ($group_scrub_progress != -1) {
				logcomment("RaidSqa.pm: scrub still $group_scrub_progress % on raid_group $group"); 	
                               	$scrub_in_progress = 1;
			}
		}
		sleep $timeout;
		$raid_obj->refresh();
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_disk_sdc_completion

RaidSqa_wait_for_disk_sdc_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, timeout=>$timeout);

This subroutine wait till the sdc on a particular disk get completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk on which sdc is running.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_disk_sdc_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
				disk_name => {type=>SCALAR},
				timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	my $raid_obj=new RaidInfo($conn);
	my $disk_obj=$raid_obj->disk("$disk_name");

#	if (RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name)) {
       		my $disk_sdc_progress = $disk_obj->parameter("copy_progress");
       		while ($disk_sdc_progress  ne "-1") {
			logcomment("RaidSqa.pm: sdc still $disk_sdc_progress % on disk $disk_name"); 	
			sleep $timeout;
        $raid_obj->refresh();
        $disk_name = RaidSqa_find_active_path_disk_name(host => $host, disk_name => $disk_name);
        $disk_obj = $raid_obj->disk("$disk_name");
        if (!$disk_obj) {
            logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
            return 0;
        }
       			$disk_sdc_progress = $disk_obj->parameter("copy_progress");
		}
#	} else {
#
#		logcomment("RaidSqa.pm: sdc on disk $didn't start, so can not check its completion");
#		return 0;
#	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_spare_disks_zeroing_completion

RaidSqa_wait_for_spare_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list, timeout=>$timeout);

This subroutine wait till the disk zeroing on list of spare disks get completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_list

(Optional) : list of spare disk for which we want to check and wait till zeroing completion. Default is undefined.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_spare_disks_zeroing_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_list => { type=>ARRAYREF,default=>undef,optional=>1},
				timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_list = $opts{disk_list};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	if (!RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, spare_only=>"yes", fsm_state=>"ZEROING")) {
		logcomment("RaidSqa.pm: There is no spare disk in the systen which is zeroing");
		return 0;
	} else {

        	my $raid_obj=new RaidInfo($conn);
		my @disk_list=();

		if (!defined($disk_list)) {
        		@disk_list=RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, spare_only=>"yes", fsm_state=>"ZEROING");
		} else {
			@disk_list=@$disk_list;
		}
		# keep on checking until all spare disks are zeroed
        	my $count = 1;        	
        	while ($count > 0) {
                	$raid_obj->refresh();
                	$count = 0;
                	logcomment("RaidSqa.pm: list of spare disks is: @disk_list ");

            foreach my $disk_name (@disk_list) {
                my $disk_obj = $raid_obj->disk("$disk_name");
                if (!$disk_obj) {
                    logcomment("RaidSqa.pm: Disk with name $disk_name does not exist");
                    next;
                }
                        	if ($disk_obj->parameter("fsm_state") eq "ZEROING" ) {
                                	logcomment("RaidSqa.pm: disk $disk_name is not zeroed yet ");
                                	$count++;
                        	}
                	}
		}
                logcomment("RaidSqa.pm: waiting for $count disks to zero");
                sleep $timeout;
        }
}

##############################################################################
# LIST OF FUNCTIONS SPECIFIC TO FEATURE OLM                                  #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_labelmaint_isolate

RaidSqa_labelmaint_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, arg_list=>\@arg_list);

This subroutine isolate a list of disks/volumes/or-mix of them for OLM.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item arg_list

(Required): Reference to a list of argument need to be isolated. The list can have all disks, all volume name or mix of both.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_labelmaint_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                arg_list => { type=>ARRAYREF },
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $arg_list = $opts{arg_list};
        my @arg_list = @$arg_list;

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

    my @error_strings = (
        "doesn't exist or is ineligible",
        "No disk or aggregate named",
        "Only non-filesystem disks or offline aggregates may be isolated into Online Maintenance Mode"
    );
    
    my $regex = join "|", @error_strings;
	my $output;
	# labelmain isolate a list of aggr/volume and spare list
        if (!@arg_list) {
                logcomment("RaidSqa.pm: Need to define at least one parameter to this funtion");
		return 0;
        } else {
                logcomment("RaidSqa.pm: Isolating @arg_list");
                (undef, undef, $output) = say($conn, "priv set -q diag;labelmaint isolate @arg_list", -timeout, $RaidSqa_TIMEOUT);
        }       

	if ($output =~ /($regex)/mi) {
        return 0;
	} else {
        return 1;
	}

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_labelmaint_list

RaidSqa_get_labelmaint_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets an array of disks which are in OLM.

It returns an array of olm disk on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_labelmaint_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        (undef, undef, $output) = say($conn, "priv set -q diag;labelmaint list", -timeout, $RaidSqa_TIMEOUT);
        my @olm_list= split(/\r?\n/, $output);
		#shift(@olm_list);
		#pop(@olm_list);    # Reverting the changes as other modules use this output as input.
        logcomment("RaidSqa.pm: Here is the list of disk in olm: @olm_list");
        return @olm_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_labelmaint_unisolate

RaidSqa_labelmaint_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine unisolate all disk from olm to normal mode.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_labelmaint_unisolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }       
                        );      
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        logcomment("RaidSqa.pm: Unisolating any disks in OLM...");

        my $output =say($conn, "priv set -q diag;labelmaint unisolate", -timeout, $RaidSqa_TIMEOUT);

        my @olm_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);
        if (grep /No disks in online maintenance/, @olm_list) {
                logcomment("RaidSqa.pm: There is no disk in labelmaint list"); 
                return 1;
        } else {
                logcomment("RaidSqa.pm: There is still disk in labelmaint list"); 
                return 0;
        }
}


#------------------------------------------------------------------------------

=head2 RaidSqa_label_buildtree

RaidSqa_label_buildtree(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, disk_args=>$disk_args, fsid=>$fsid, raid_type=>$raid_type, aggr_bits=>$aggr_bits, aggr_type => $aggr_type, options=>$options);

This function executes buildtree command on the given disk list

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be onlined.

=item disk_args

(Required) : disk argument to be sent to buildtree command

=item fsid

(Required) : fsid value of test volume

=item aggr_bits

(Required) : 32 for 32-bit aggr/volume, 64 for 64-bit aggr/volume

=item raid_type

(Required) : Raid type parameter (possible values: raid_dp, raid4)

=item options

(Required) : Other options to be passed to buildtree command (e.g -lw)

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_label_buildtree {
    my (%opts) = validate(
        @_,
        {   
            host           => { type => OBJECT, isa=>'Hostrec' },
            filermode      => { type => SCALAR, default=>"normal", optional=>1 },
            conntype       => { type => SCALAR, default=>"#rsh",optional=>1},
            filer_vol      => { type => SCALAR },
            disk_args      => { type => SCALAR | UNDEF,  default => undef,      optional => 1 },            
            fsid           => { type => SCALAR },
            aggr_type      => { type => SCALAR,  default => 1,         optional => 1 },
            aggr_bits      => { type => SCALAR,  default => "32",      optional => 1 },
            raid_type      => { type => SCALAR,  default => "raid_dp", optional => 1 },
            options        => { type => SCALAR | UNDEF,  default => undef,  optional => 1 },
        }
    );

    my $host          = $opts{'host'};
    my $filermode     = $opts{'filermode'};
    my $conntype      = $opts{'conntype'};
    my $filer_vol     = $opts{'filer_vol'};
    my $options       = $opts{'options'};
    my $disk_args     = $opts{'disk_args'};        
    my $fsid          = $opts{'fsid'};
    my $aggr_type     = $opts{'aggr_type'};
    my $aggr_bits     = $opts{'aggr_bits'};
    my $raid_type     = $opts{'raid_type'};
    my $opt_aggr      = ($aggr_type) ? "-a" : "";
    my $opt_aggr_bits = ( $aggr_bits eq "64" ) ? "-B" : "";
    
	my $conn = make_conn($host, "#console");
	
    if ( defined($disk_args) ) {
        my $cmd
            = "priv set -q diag;label buildtree -n $filer_vol -f $fsid -c b -t $raid_type $opt_aggr_bits $opt_aggr $options -F $disk_args";
		RaidSqa_filer_cmd(host=>$host, cmd=>$cmd);
        sleep(5);
        logcomment("RaidSqa.pm: label buildtree is executed successfully");
        return 1;
    }
    else {
        logcomment("RaidSqa.pm: disk_args is mandatory for non-interactive buildtree command");
        return 0;
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_after_isolate

RaidSqa_check_disk_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

This subroutine checks a disk after isolate that it is not in filer raid recognised disk list but in OLM.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of disk which was isolated.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_after_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my @labelmaint_list= RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

        logcomment("RaidSqa.pm: checking that disk $disk_name is not in filer raid recognized list, but instaed in OLM");

        if (RaidSqa_check_disk_exist(host=>$host, conntype=>$conntype, disk_name =>$disk_name)) {
                logcomment("RaidSqa.pm: disk $disk_name is still exist in filer raid recognized list");
		return 0;
        } else {
		if (grep /$disk_name/, @labelmaint_list) {
                      	logcomment("RaidSqa.pm: disk $disk_name is in labelmaint list");
			return 1;
		} else {
                      	logcomment("RaidSqa.pm: disk $disk_name is not in labelmaint list");
			return 0;
		}

        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_after_unisolate

RaidSqa_check_disk_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

This subroutine checks a disk after unisolate that it is not olm list but in filer raid recognized list.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of disk which got unisolated.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_after_unisolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_name1=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_name1){
			logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
			$disk_name=$disk_name1;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}
		
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
	my $raid_obj=new RaidInfo($conn);

        my @labelmaint_list= RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

        logcomment("RaidSqa.pm: checking that disk $disk_name is in filer raid recognized list, but not in labelmaint list");

        if (!RaidSqa_check_disk_exist(host=>$host, conntype=>$conntype, disk_name =>$disk_name)) {
                logcomment("RaidSqa.pm: disk $disk_name is does not exist in filer raid recognized list");
		return 0;
        } else {
		logcomment("RaidSqa.pm: disk $disk_name is in filer raid recognized list as expected");
		my $disk_obj=$raid_obj->disk($disk_name);
		my $disk_2nd = $disk_obj->parameter("path_name2");
		if ($disk_2nd) {
			if ((grep /$disk_name/, @labelmaint_list) || ( grep /$disk_2nd/, @labelmaint_list)) {
                        	logcomment("RaidSqa.pm: disk $disk_name is in labelmaint list");
				return 0;
			} else {
                        	logcomment("RaidSqa.pm: disk $disk_name is not in labelmaint list");
				return 1;
			}
				
                } else {
			if (grep /$disk_name/, @labelmaint_list) {
                       		logcomment("RaidSqa.pm: disk $disk_name is in labelmaint list");
				return 0;
			} else {
                       		logcomment("RaidSqa.pm: disk $disk_name is not in labelmaint list");
				return 1;
			}
                }

        }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_after_isolate

RaidSqa_check_aggr_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, vo
l_disk_list=>\@vol_disk_list);

This subroutine checks an aggregate/volume after isolate that its disks are in olm list and vol/aggr is not in aggr/vol list.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of aggregate/volume.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional.

=item vol_disk_list

(Required): Reference to the array of disks in aggr/volume.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_after_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                vol_disk_list => { type=>ARRAYREF },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	my $aggr_type = $opts{aggr_type};
        my $vol_disk_list = $opts{vol_disk_list};
        my @vol_disk_list =@$vol_disk_list;
        my($cmd) = $aggr_type ? "aggr" : "vol";

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my @labelmaint_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

	logcomment("RaidSqa.pm: checking that $cmd $filer_vol does not exists after isolate");

        if (RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
		return 0;
        } else {

        	logcomment("RaidSqa.pm: checking that all disks of $cmd $filer_vol are in OLM list");
		my $disk;
		
        	foreach $disk (@vol_disk_list) {
			if (grep /$disk/, @labelmaint_list) {
                        	logcomment("RaidSqa.pm: disk $disk is in labelmaint list");
			} else {
                        	logcomment("RaidSqa.pm: disk $disk is not in labelmaint list");
				return 0;
			}
        	}
		return 1;
	}
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_after_unisolate

RaidSqa_check_aggr_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, vol_disk_list=>\@vol_disk_list);

This subroutine checks an aggregate/volume after unisolate that its disks are not olm list and vol/aggr is in aggr/vol list as offline.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of aggregate/volume.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional.

=item vol_disk_list

(Required): Reference to the array of disks in aggr/volume. 

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_aggr_after_unisolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
				aggr_type => { type=>SCALAR },
                                vol_disk_list => { type=>ARRAYREF },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
	my $aggr_type = $opts{aggr_type};
        my $vol_disk_list = $opts{vol_disk_list};
        my @vol_disk_list = @$vol_disk_list;

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my @labelmaint_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

	my($cmd) = $aggr_type ? "aggr" : "vol";

        logcomment("RaidSqa.pm: checking that $cmd $filer_vol comes back after unisolate");

        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type =>$aggr_type)) {
		return 0;
        } else {

        	logcomment("RaidSqa.pm: checking that $cmd $filer_vol is offline");

        	if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, state_name=>"offline")) {
                	logcomment("RaidSqa.pm: $cmd $filer_vol is offline as expected");
        	} else {
                	logcomment("RaidSqa.pm: $cmd $filer_vol is not offline as expected");
			return 0;
        	}

        	logcomment("RaidSqa.pm: checking that no disks of $cmd $filer_vol are not in OLM list");
		
		my $raid_obj = new RaidInfo($conn);
        	my $disk;

        	foreach $disk (@vol_disk_list) {
			
			my $disk_obj=$raid_obj->disk($disk);
			my $disk_2nd = $disk_obj->parameter("path_name2");

			if ($disk_2nd) {
				if ((grep /$disk/, @labelmaint_list) || ( grep /$disk_2nd/, @labelmaint_list)) {
                        		logcomment("RaidSqa.pm: disk $disk is still in labelmaint list");
					return 0;
				} else {
                        		logcomment("RaidSqa.pm: disk $disk is not in labelmaint list");
				}
				
                	} else {
				if (grep /$disk/, @labelmaint_list) {
                        		logcomment("RaidSqa.pm: disk $disk is still in labelmaint list");
					return 0;
				} else {
                        		logcomment("RaidSqa.pm: disk $disk is not in labelmaint list");
				}
                	}
        	}
		return 1;
        }


}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_label_vuinfo

RaidSqa_get_label_vuinfo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list);

This subroutines parses the output of label vuinfo command and returns values for different parameters.

It returns a reference to a hash

ref_hash= {            
            disk => {
                        error               => <ErrorString>  #This will be defined if it is not able to executed command on disk
                        group_raid_lw_scrub => <value>
                        lw_disk_signature   => <value>
                        cxt_parity          => <value>
                        ha_policy           => <value>
                        <param_name>        => <value>
                    }
          }

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_list

(required) : list of disks for which vuinfo command output is required

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_label_vuinfo {
     my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},                                
                                disk_list => { type=>ARRAYREF},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my @disk_list = @{$opts{disk_list}};

        
        my @param_list = ('group_raid_lw_scrub', 'lw_disk_signature', 'cxt_parity', 'ha_policy',
                          'Raidtree', 'magic', 'version', 'time', 'ID', 'type',
                          'ndisks', 'striping', 'max groupsize', 'tricky_heritage', 
                          'cksum type', 'nplex', 'plexid', 'ngroup', 'rgid', 'ndisk', 
                          'rgdn', 'global id', 'vol_flag', 'disk_cksum_type', 'cksum_zone_size',
                          'cksum_offset', 'vr_start', 'size');
        my %label_vuinfo_output = ();
        
        if($filermode ne "normal"){
                $conntype = "#console";
        }
        my $conn = make_conn($host,$conntype);
        
        foreach my $disk (@disk_list) {
            my $cmd = "priv set -q diag; label vuinfo $disk";
            my (undef, undef, $output) = say($conn, $cmd, -timeout, $RaidSqa_TIMEOUT);
            if($output =~ /(Unable to read undestroy information)|(No undestroy information found)/m) {
                logcomment("RaidSqa.pm: Label vuinfo command failed for $disk");
                $label_vuinfo_output{$disk}->{error} = $output;
                next;
            }
            my @lines = split(/\r?\n/, $output);            
            foreach my $line (@lines) {
                foreach my $param (@param_list) {                    
                    if ($line =~ /$param\s(\w+)/) {                        
                        $label_vuinfo_output{$disk}->{$param} = $1;
                    }
                }
            }
        }
        
        logcomment("RaidSqa.pm: ".Dumper(\%label_vuinfo_output));
        if(!(keys %label_vuinfo_output)){
            return 0 ;
        } else {
            return \%label_vuinfo_output;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_label_buildtree_cmd_string

RaidSqa_get_label_buildtree_cmd_string(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

Return value is a SCALAR which contains a string with disk names arranged in a manner required for buildtree command
label buildtree command needs disk in the order in which plex, groups are defined. 

Example return value is=>  "0a.18 0a.19 0a.20 -r 0b.18 0b.19 0b.20 -p 0a.21 0a.22 0a.23 -r 0b.21 0b.22 0b.23

Algorithm used for building the string:
    1.  It finds all list of all the plexes present in the aggr.
    2.  For each plex, it finds all groups present in it
    3.  Then for each group, it lists all the disks present in it
    4.  This all data is stored in multilevel hash format (example given below)
    5.  First level of hash contains plex indexes as their keys, value to which will be a ref to second level hash.
    6.  Second level hash will contains index of each raid group as keys present in plex represented by parent hash key. 
        Value for second level hash keys will be an array ref, whcih contains disk list in the raid group represented by key
    7.  During cmd string building, it will traverse through hash for each plex and then for each raid group.
    8.  For each plex, it will add -p option if it is other than plex0.
    9.  For each raid group, it will add -r followed by list of disks, if raid group is other than rg0 
    10. for plex0 and for rg0, it does not add any command line siwtch (like -p or -r)

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume whose disk string is to be created.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_label_buildtree_cmd_string {
    my (%opts) = validate(@_, {
                host      => { type=>OBJECT, isa=>'Hostrec'},
                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                conntype  => {type=>SCALAR,default=>"#rsh",optional=>1},
                filer_vol => { type=>SCALAR },}
                );
    my $host      = $opts{host};
    my $filermode      = $opts{filermode};
    my $conntype      = $opts{conntype};
    my $filer_vol      = $opts{filer_vol};
    my %aggr_disk_list = ();

    my @plex_list = RaidSqa_get_plex_list( host => $host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);    
    my @buildtree_disk_list = ();
    my ( $plex_index, $rg_index );
    foreach my $plex (@plex_list) {
        $plex_index = undef;
        $rg_index   = undef;
        if ( $plex =~ /plex(\d+)/ ) {
            $plex_index = $1;
            my @group_list = RaidSqa_get_group_list( host => $host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex );
            foreach my $group (@group_list) {
                if ( $group =~ /rg(\d+)/ ) {
                    $rg_index = $1;
                    my @disk_list = RaidSqa_get_disk_list( host => $host, filermode=>$filermode, conntype=>$conntype, group_name => $group );
                    my %disk_rgdn = ();
                    foreach my $disk (@disk_list) {
                        my $disk_rgdn = RaidSqa_get_disk_rgdn( host => $host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk );
                        $disk_rgdn{$disk_rgdn} = $disk;
                    }
                    my @buildtree_disk_list = ();
                    foreach my $rgdn ( sort keys %disk_rgdn ) {
                        push( @buildtree_disk_list, $disk_rgdn{$rgdn} );
                    }
                    $aggr_disk_list{$plex_index}->{$rg_index} = \@buildtree_disk_list;
                }
                else {
                    logcomment("RaidSqa.pm: Could not find rg_index for group $group");
                    return 0;
                }
            }
        }
        else {
            logcomment("RaidSqa.pm: Could not find plex index for plex $plex");
            return 0;
        }
    }

    logcomment("RaidSqa.pm: aggr_disk_list: " . Dumper( \%aggr_disk_list ));
    my $disk_arg = "";
    my @plex_indexs = sort {$a <=> $b} keys %aggr_disk_list;
    my $first_index = shift @plex_indexs;
    foreach my $plex_index ( sort {$a <=> $b} keys %aggr_disk_list ) {
        if ( $plex_index !~ /$first_index/ ) {
            $disk_arg .= " -p";
        }
        foreach my $rg_index ( sort {$a <=> $b} keys %{ $aggr_disk_list{$plex_index} } ) {
            if ( $rg_index !~ /0/ ) {
                $disk_arg .= " -r";
            }
            $disk_arg .= " " . join( " ", @{ $aggr_disk_list{$plex_index}->{$rg_index} } );
        }
    }
    logcomment("RaidSqa.pm: disk_arg: $disk_arg");
    return $disk_arg;    
}


##############################################################################
# LIST OF FUNCTIONS FOR UPGRADE AND REVERT OPERATIONS                        #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_software_update_HTTP

RaidSqa_software_update_HTTP(host=>$host, url => $url, timeout => $timeout);

This subroutine upgrades the filer to specified version.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item url

(Required) : URL of the desired version of DATA ONTAP to be upgraded.

=item timeout

(Optional): timeout value in secs.Default is 1200.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_software_update_HTTP {
    my (%opts) =
      validate(@_,
               {host    => {type => OBJECT, isa     => 'Hostrec'},
                url     => {type => SCALAR},
                timeout => {type => SCALAR, default => "1200"},});

    my $host     = $opts{host};
    my $url      = $opts{url};
    my $timeout  = $opts{timeout};
    my $conntype = "#console";

    my $conn = make_conn($host, $conntype);

    # Software update
	# Burt:480560 Added extra param in '-wait' as for some build wait string download completed doesn't appear.
    logcomment("RaidSqa.pm: Updating the filer");
    my $unsupported_command = 'software not found';
    my ($match, $before, $after) = say($conn, "software update $url -f", '-wait', ["download completed", $unsupported_command, "Please type \"reboot\" for the changes to take effect"], '-timeout', $timeout);

    if ($match =~ m/$unsupported_command/) {
        logcomment("RaidSqa.pm: filer could not be upgraded");
        return 0;
    } else {
        logcomment("RaidSqa.pm: filer successfully upgraded");
        return 1;
    }

} ## end sub RaidSqa_software_update_HTTP

#------------------------------------------------------------------------------

=head2 RaidSqa_copy_system_files_HTTP_download

RaidSqa_copy_system_files_HTTP_download(host=>$host, url => $url, timeout => $timeout);

This subroutine performs software install and download.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item url

(Required) : URL of the desired version of DATA ONTAP .

=item timeout

(Optional): timeout value in secs.Default is 1200.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_copy_system_files_HTTP_download {
    my (%opts) =
      validate(@_,
               {host    => {type => OBJECT, isa     => 'Hostrec'},
                url     => {type => SCALAR},
                timeout => {type => SCALAR, default => "1200"},});

    my $host     = $opts{host};
    my $url      = $opts{url};
    my $timeout  = $opts{timeout};
    my $conntype = "#console";

    my $conn = make_conn($host, $conntype);

    # Software install
    logcomment("RaidSqa.pm: Starting software install");
    my $unsupported_command = 'was not successful';
    my ($match, $before, $after) = say($conn,
        "software install $url -f",
        '-wait',
        [                             # Gordonbiersch.1 or later
           "software: installation of .* completed",

           # Anchorsteam, Gordonbiersch.0
           "software: installation completed",
           $unsupported_command,],
        '-timeout',
        $timeout,
        '-eval_error');
    die $@ if $@;

    if ($match =~ m/$unsupported_command/) {
        logcomment("RaidSqa.pm: Could not copy file system");
        return 0;
    } else {

        # Software download
        logcomment("RaidSqa.pm: Starting software download");
        my (undef, undef, $out) = say($conn, "download", '-prompt', "Operator requested download completed", '-timeout', $timeout, '-prompt', "\\*> ");
        logcomment("RaidSqa.pm: Successfully copied and downloaded the file system");
        return 1;
    }
} ## end sub RaidSqa_copy_system_files_HTTP_download

#------------------------------------------------------------------------------

=head2 RaidSqa_software_revert_to_HTTP

RaidSqa_software_revert_to_HTTP(host=>$host, url => $url, version_id => $version_id, timeout => $timeout);

This subroutine performs revert_to operation after deleting the Snapshots of all Aggregates/Volumes.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item url

(Required) : URL of the desired version of DATA ONTAP to be reverted to.

=item version_id

(Required) : Numeric version of the desired version of DATA ONTAP to be reverted to.

=item timeout

(Optional): timeout value in secs. Default is 1200.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_software_revert_to_HTTP {
    my (%opts) =
      validate(@_,
               {host       => {type => OBJECT, isa     => 'Hostrec'},
                url        => {type => SCALAR},
                version_id => {type => SCALAR},
                timeout    => {type => SCALAR, default => "1200"},});

    my $host       = $opts{host};
    my $url        = $opts{url};
    my $version_id = $opts{version_id};
    my $timeout    = $opts{timeout};
    my $conntype   = "#console";

    my $conn = make_conn($host, $conntype);

    # Software install and Download
    logcomment("RaidSqa.pm: Starting Software install and Download");
    if (!RaidSqa_copy_system_files_HTTP_download(host => $host, url => $url, timeout => $timeout)) {
        return 0;
    }

    # deleting snap shots
    my @aggrs = RaidSqa_get_aggr_list(host => $host);
    logcomment("RaidSqa.pm: Deleting the snap shots");
    foreach my $aggr (@aggrs) {
        say($conn, "snap delete -A -a -f $aggr", '-timeout', $RaidSqa_TIMEOUT);
        say($conn, "snap delete -V -a -f $aggr", '-timeout', $RaidSqa_TIMEOUT);
    }

    my $root_vol = RaidSqa_get_root_vol(host => $host);
    say($conn, "snap delete -V -a -f $root_vol", '-timeout', $RaidSqa_TIMEOUT);
    say($conn, "priv set diag; snapmirror off;");
    say($conn, "priv set diag; nfs off;");
    say($conn, "priv set diag; cifs terminate;");

    # reverting the filer
    logcomment("RaidSqa.pm: Reverting the filer");
    my (undef, undef, $output) = say($conn, "revert_to -if $version_id", '-timeout', $timeout);
    while ($output =~ /wafl scan status/) {
        sleep 60;
        undef, undef, $output = say($conn, "revert_to -if $version_id", '-timeout', $timeout);
    }

    return 1;
} ## end sub RaidSqa_software_revert_to_HTTP

#------------------------------------------------------------------------------

=head2 RaidSqa_software_upgrade_HTTP

RaidSqa_software_upgrade_HTTP(host=>$host, url => $url, timeout => $timeout);

This subroutine performs software install, download and reboot to upgrade the filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item url

(Required) : URL of the desired version of DATA ONTAP to be upgraded.

=item timeout

(Optional): timeout value in secs.Default is 300.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_software_upgrade_HTTP {
    my (%opts) =
      validate(@_,
               {host    => {type => OBJECT, isa     => 'Hostrec'},
                url     => {type => SCALAR},
                timeout => {type => SCALAR, default => "300"},});

    my $host    = $opts{host};
    my $url     = $opts{url};
    my $timeout = $opts{timeout};

    my $conntype = "#console";
    my $conn = make_conn($host, $conntype);

    # Software install and Download
    logcomment("RaidSqa.pm: Starting Software install and Download");
    if (!RaidSqa_copy_system_files_HTTP_download(host => $host, url => $url, timeout => $timeout)) {
        return 0;
    }

    # Rebooting the filer
    logcomment("RaidSqa.pm: Rebooting the filer");
    my ($match, $before, $after) = say($conn, "reboot", '-timeout', $timeout);
    return 1;

} ## end sub RaidSqa_software_upgrade_HTTP

#------------------------------------------------------------------------------

=head2 RaidSqa_check_ioc_support

checks for ioc on root support in the build.

RETURNS
        0 on failure
	1 on success

ARGUMENTS

=over

=item %opts

(Required):
  host : Named host object hash.

=back

EXAMPLE

        my $ret = RaidSqa_check_ioc_support(host => $host);

=cut

sub RaidSqa_check_ioc_support {

    my %opts = validate(@_, {host => {type => OBJECT, isa => 'Hostrec'},});
    my $host = $opts{host};

    my $ret = misc_printflag(host => $host,
                             flag => "wafl_iron_optional_commit_root_enabled");

    if ((!defined($ret)) || ($ret eq "")) {
        $@ = "IOC on root is not supported on current build";
        return 0;
    }

    logcomment("IOC on root is supported on current build \n");
    return 1;
} ## end sub RaidSqa_check_ioc_support

##==========================================================================

=head2 RaidSqa_get_setup_information

        Get the setup information of the filer

RETURNS
        A reference to a hash of all the setup values like
	 IP address, netmask, default gateway, active port etc.
	
	Returns 0 on failure.


ARGUMENTS

=over

=item conn

(Required):  Named connection object. Pass an rsh connection object.
	     Console connections can cause some failures

=back

EXAMPLE

        RaidSqa_get_setup_information(conn => $fc, filer => $FILER);

=cut

sub RaidSqa_get_setup_information {

    my %opts = validate(@_,
                        {conn => {type => OBJECT, isa => "Connectrec"},
                         filer => {SCALAR | UNDEF | HASHREF | OBJECT}});
    my $conn  = $opts{conn};
    my $filer = $opts{filer};

    my ($perform_read_flg, $config_file_path, @log, $line, $count, $text,
        %setup_info, $ret, @lines, $dns_list);

    $count            = 0;
    $perform_read_flg = 1;
    $config_file_path = "/etc/configs/config_saved";
    %setup_info       = ();

    ## getting the setup information of the filer.

    $setup_info{PASSWD}   = $conn->hostp->default_password();
    $setup_info{IP}       = $conn->hostp->default_ip();
    $setup_info{HOSTNAME} = $conn->hostp->hostname();

    ## if the $perform_read_flg is set to 1 we read the file
    ## /etc/configs/config_saved.
    while ($perform_read_flg) {

        $perform_read_flg = 0;

        ## reading the file /etc/configs/config_saved to get the configuration
        ## settings
        $text = cli($filer, "rdfile $config_file_path", $::TIMEOUT);
        if ($text =~ /No such file or directory/) {

            ## if the file does not exist we will generate the file
            $ret = &_config_saved_file_creation($conn);
            if ($ret) {
                $perform_read_flg = 1;
            } else {
                logcomment("Failed to generate the config file");
                return 0;
            }

        } elsif ($text =~ /^$config_file_path\:/) {
            logcomment(" Error in 'rdfile': $text");
            return 0;
        }
    } ## end while ($perform_read_flg)

    @log = split(/\n/, $text);
    foreach $line (@log) {

        if ($line =~ /options\.if\.(\w+)\.netmask=(\d+\.\d+\.\d+\.\d+)/) {
            logcomment("Matched fetching IFC and NETMASK details");
            if (!defined($1) || ($1 eq "")) {
                logcomment("Failed to get the IFC port");
                return 0;
            }

            if (!defined($2) || ($2 eq "")) {
                logcomment("Failed to get the netmask value");
                return 0;
            }

            $setup_info{IFC}     = $1;
            $setup_info{NETMASK} = $2;

        } elsif ($line =~ /route add default\s+(\d+\.\d+\.\d+\.\d+)\s+/) {
            if (!defined($1) || ($1 eq "")) {
                logcomment("Failed to get the gateway ip address");
                return 0;
            }
            $setup_info{GATEWAY} = $1;
        }
        if($line =~ /(\d+\.\d+\.\d+\.\d+)\s+$setup_info{HOSTNAME}\-([\w]+)/){
            logcomment("$2 $1");
            $setup_info{$2} = $1;
        }
        # if($line =~ /(\d+\.\d+\.\d+\.\d+)\s+$setup_info{HOSTNAME}\-e0b/){
            # logcomment("(\d+\.\d+\.\d+\.\d+)\s+$setup_info{HOSTNAME}\-e0b == $1");
            # $setup_info{e0b} = $1;
        # }
        if($line =~ /(\d+\.\d+\.\d+\.\d+)\s+$setup_info{HOSTNAME}\s+$setup_info{HOSTNAME}\-([\w]+)/){
            logcomment("$2 $1");
            $setup_info{$2} = $1;
        }
    } ## end foreach $line (@log)

    $ret = cli($filer, "dns info", $::TIMEOUT);
    @lines = split(/\n/, $ret);
    foreach $line (@lines) {

        if ($line =~ /DNS is enabled/i) {
            $setup_info{DNS} = 'y';
        }

        if ($setup_info{DNS} eq 'y') {
            if ($line =~ /(\d+\.\d+\.\d+\.\d+).*/) {
                if (defined($dns_list)) {
                    $dns_list = "$dns_list," . $1;
                } else {
                    $dns_list = $1;
                }
            }

            if ($line =~ /Default domain:\s+(.*)/i) {
                $setup_info{DNS_DOMAINNAME} = $1;
            }
        } ## end if ($setup_info{DNS} eq...

    } ## end foreach $line (@lines)

    if (!defined($setup_info{DNS})) {
        $setup_info{DNS}            = 'n';
        $setup_info{DNS_DOMAINNAME} = "";
        $setup_info{DNS_SERVERLIST} = "";
    }

    $setup_info{DNS_SERVERLIST} = $dns_list;

    return (\%setup_info);
} ## end sub RaidSqa_get_setup_information

##===========================================================================

=head2 RaidSqa_get_invalid_diskid

Get invalid disk id's for creation of temporary root volume

RETURNS
        0 on failure
	A single invalid disk or 
	reference to an invalid disk list on success

ARGUMENTS

=over

=item conn

(Required): Connection object. Use rsh connection as there might 
	    be issues with console connection.

=item No. of disks

(Optional):  No of invalid disk id's needed. Defaults to 1.

=back

EXAMPLE

        my $ret = RaidSqa_get_invalid_diskid(conn => $conn,
				     num_disks => $no_of_disks);

=cut

sub RaidSqa_get_invalid_diskid {

    my %opts = validate(@_,
                        {conn => {type => OBJECT, isa => "Connectrec"},
                         num_disks =>
                           {type => SCALAR, optional => 1, default => 1},});

    my $conn         = $opts{conn};
    my $num_of_disks = $opts{num_disks};

    my ($count, @disk_list, $disk_id, $i, $raid_obj, %spare_disks,
        @filer_disks_list);

    $raid_obj         = new RaidInfo($conn);
    %spare_disks      = $raid_obj->spare_disks();
    @filer_disks_list = keys %spare_disks;
    $i                = 1;

    while ($i <= $num_of_disks) {
        $disk_id = rand(200);
        $count = grep(/^$disk_id$/, @filer_disks_list);
        if (0 == $count) {
            push(@disk_list, $disk_id);
        }
        $i++;
    }

    if (0 == scalar(@disk_list)) {
        logcomment("Failed to generate invalid disk id's");
        return 0;
    }

    if (1 == scalar(@disk_list)) {
        return ($disk_id);
    } else {
        return (\@disk_list);
    }
} ## end sub RaidSqa_get_invalid_diskid

##===========================================================================

=head2 RaidSqa_create_temproot_vol

Create the temp root volume followed by setup.
This function will create the temporary root volume at the boot menu.
It will take care of trnsitioning to the boot menu and will then proceed
with volume creation.

RETURNS
       0 on failure. $@ will be set with error message
       1 on success

ARGUMENTS

=over

=item %args

(Required): a hash containing host record volume name, disk list,
	    raid type and verify flag which can be used to check if the
	    temporary root volumes creation was successful after the
	    system comes up.

=back

EXAMPLE

        my $ret = RaidSqa_create_temproot_vol(host         => $host,
				      vol_name     => $trad_vol_name,
				      disk_list    => $disk_list_ref,
				      setup_info   => \%setupinfo);

=cut

sub RaidSqa_create_temproot_vol {

    my (%args) =
      validate(@_,
               {host     => {type => OBJECT, isa      => 'Hostrec'},
                vol_name => {type => SCALAR, optional => 1, default => undef},
                disk_list => {type => ARRAYREF, optional => 1, default => []},
                setup_info =>
                  {type => HASHREF, optional => 1, default => undef},
                verify_flg => {type => SCALAR, optional => 1, default => 0},
                raid_type =>
                  {type => SCALAR, optional => 1, default => 'raid0'},});

    my $host             = $args{host};
    my $trad_vol_name    = $args{vol_name};
    my $verification_flg = $args{verify_flg};
    my $raid_type        = $args{raid_type};

    my ($conn,     $cmd,       $err_msg1,  $err_msg2,  $err_msg3,
        $err_msg4, $err_msg5,  $err_msg6,  $err_msg7,  $err_msg8,
        $err_msg9, $err_msg10, $err_msg11, $err_msg12, $err_msg13,
        $pass_msg, $fail_msg,  $query1,    $query2,    $start_setup,
        $dhcp_str, $match,     $before,    $after);

    ##making cosole connection required for this function

    $conn = make_conn($host, "#console");

    $cmd = "create_temp_root $trad_vol_name -t $raid_type @{$args{disk_list}}";
    $err_msg1    = 'Invalid Volume name for command create_temp_root';
    $err_msg2    = 'No (disk|disks) specified for command create_temp_root';
    $err_msg3    = 'Invalid syntax for command create_temp_root';
    $err_msg4    = 'Invalid option .* for command create_temp_root';
    $err_msg5    = 'Invalid raid type.*for command create_temp_root';
    $err_msg6    = 'No disk or invalid disk name specified';
    $err_msg7    = 'Disk \w+\.\w+ is listed twice';
    $err_msg8    = 'Disk \w+\.\w+ does not exist\.';
    $err_msg9    = 'Disk \w+ does not exist';
    $err_msg10   = 'Disk \w+\.\w+ is not a spare disk';
    $err_msg11   = 'Disk \w+\.\w+ is not owned by local host';
    $err_msg12   = 'Assimilation failed';
    $err_msg13   = 'No raid-type specified for command create_temp_root';
    $pass_msg    = 'wafl\.vol\.add:notice';
    $fail_msg    = 'raid\.label\.io\.writeError';
    $query1      = 'Install a new file system\?';
    $query2      = 'This will erase all the data on the disks, are you sure\?';
    $start_setup = 'new hostname';
    $dhcp_str    = 'Ctrl-C to skip DHCP search';

    ##Going to boot menu for creation of temp root volume
    transit_to($conn, 'BOOT_MENU') or die("$@");

    logcomment("Creating temp root volume");
    ($match, $before, $after) =
      say($conn, $cmd, qr/$err_msg13|$err_msg1|$err_msg2|$err_msg3|$err_msg4|$err_msg5|$err_msg6|$err_msg7|$err_msg8|$err_msg9|$err_msg10|$err_msg11|$err_msg12|$query1|$dhcp_str|$fail_msg/, -swallow,   -eval_error, -noprompt, '-timeout', $::CMDTIMEOUT * 10, '-maxidle', $::TIMEOUT);

    if ($@) { return 0; }

    if ($match =~ /$err_msg1|$err_msg2|$err_msg3|$err_msg4|$err_msg5|$err_msg6|$err_msg7|$err_msg8|$err_msg9|$err_msg10|$err_msg11|$err_msg12|$err_msg13|$fail_msg/) {

        logcomment(
                 "Temporary trad vol creation failed with error : $match");

        ## bringing the filer up incase it is not.
        transit_to($conn, "UP") or die("$@");

        $@ = $match;
        return 0;
    } ## end if ($match =~ ...
    if ($match =~ /$query1/i) {

        ($match, $before, $after) =
          say($conn, 'yes', qr/$query2/,
              -swallow,   -eval_error,        -noprompt,
              '-timeout', $::CMDTIMEOUT * 10, '-maxidle',
              $::TIMEOUT);
    }
    if ($match =~ /$query2/i) {

        ($match, $before, $after) =
          say($conn, 'yes', qr/$dhcp_str|$fail_msg/, -swallow, -eval_error,
              -noprompt, '-timeout', $::CMDTIMEOUT * 10,
              '-maxidle', $::TIMEOUT);

    }
    if (($before =~ /$pass_msg/) && ($match =~ /$dhcp_str/)) {
        logcomment(
            "Temporary trad vol creation successfull. Starting Setup\n\n");

       ($match, $before, $after) = say($conn, "\cC", qr/new hostname/,
            -swallow,   -eval_error,        -noprompt,
            '-timeout', $::CMDTIMEOUT * 10, '-maxidle',
            $::TIMEOUT);

        if (!(RaidSqa_setup($conn, $args{setup_info}))) {
            $@ = "Failed to implement the setup configuration";

            return 0;
        }
        sleep 30;
        logcomment("Set options rsh.enable to on.");
        RaidSqa_set_options(host         => $host,
                            option_name  => "rsh.enable",
                            option_value => "on",
                            conntype     => "#console");

        logcomment("Set options telnet.enable to on.");
        RaidSqa_set_options(host         => $host,
                            option_name  => "telnet.enable",
                            option_value => "on",
                            conntype     => "#console");
    } else {
        logcomment(
                 "Temporary trad vol creation failed with error : $match");

        transit_to($conn, "UP") or die("$@");

        $@ = $match;
        return 0;
    }

    if ($verification_flg) {

        if (!(RaidSqa_temp_rootvol_verify(host      => $host,
                                   vol_name  => $trad_vol_name,
                                   disk_list => $args{disk_list},))
          ) {
            return 0;
        }
    }

    return 1;
} ## end sub RaidSqa_create_temproot_vol

##============================================================

=head2 RaidSqa_temp_rootvol_verify

Verify if the temp root volume was created with disks passed.
Also check if the root flag is set for temporary root volume.

RETURNS
        0 on failure. $@ will be set with error message
	1 on success

ARGUMENTS

=over

=item %args

	Required 
	host     : Host object. 
	vol_name : Name of the volume whose root flag needs to be verified
	disk_list: Reference to an array containing the Disk id's
                   used for temp root vol creation


=back

EXAMPLE

        my $ret = RaidSqa_temp_rootvol_verify(host      => $host,
				      vol_name  => $trad_vol_name,
				      disk_list => $disk_list_ref);

=cut

sub RaidSqa_temp_rootvol_verify() {

    my (%args) =
      validate(@_,
               {host      => {type => OBJECT, isa => 'Hostrec'},
                vol_name  => {type => SCALAR},
                disk_list => {type => ARRAYREF},});

    my $host          = $args{host};
    my $trad_vol_name = $args{vol_name};

    my ($conn, @vol_disk_list, $ref, @disk_details, $disk, $status);

    ##cheking if the filer is up.
    if (boot_state($host) ne 'UP') {
        transit_to($host, 'UP')
          or die("The filer is is in un-expected state :$@");
    }

    $conn = make_conn($host, "#rsh-socket");

    ## Getting the list of disks owned by the temp root vol
    logcomment("Get the volume disk list \n\n");
    if (vol_exists($conn, $trad_vol_name)) {
        @disk_details = vol_disks($conn, $trad_vol_name);
    } else {
        $@ = "Volume $trad_vol_name does not exists";
        return 0;
    }

    foreach $disk (@disk_details) {
        push(@vol_disk_list, $disk->{name});
    }

    ## checking if the disks passed belong to the volume
    foreach $disk (@{$args{disk_list}}) {
        unless (grep (/^$disk$/, @vol_disk_list)) {
            $@ = "The disk $disk is not present in volume";
            return 0;
        }
    }
    logcomment("The passed disks belong to the volume $trad_vol_name");

    ##checking if the root flag has been set for $trad_vol_name
    $ref = vol_options($conn, $trad_vol_name);
    if (!defined($ref->{root})) {
        $@ = "The root flag for volume $trad_vol_name is not set";
        return 0;
    }

    logcomment(
             "The temporary volume $trad_vol_name has the root flag set");

    ## checking if the root volume is of raid type raid0
    (undef, $status, undef, undef) = vol_status($conn,$trad_vol_name);

    if($status !~ /raid0/) {
        $@ = "The volume $trad_vol_name is not of type raid0";
        return 0;
    }

    logcomment(
             "The temporary volume $trad_vol_name is of type raid0");
    
    return 1;
} ## end sub RaidSqa_temp_rootvol_verify()

##========================================================================

=head2 RaidSqa_verify_root_aggr_vol_spare_disks(%opt)

This function will check if root flag is set to root aggr,
root volume and spare disks which were used to create the
tradvol, are returned to the spare disks pool.

Returns 1 on success and 0 on failure.
(set $@ to contain a string describing the failure);

=item %opt
This is the hash with the following keys

     conn => filer connection object required.(It should be console
              connection).

     root_aggr  => name of the root aggr. Required.

     root_vol => name of the root volume. Required.
     disks => reference to the array of disks. Required.
Usage:
     RaidSqa_verify_root_aggr_vol_spare_disks
    (conn =>$fc, root_aggr=>$root_aggr, root_vol=>$root_vol, disks=>$ref_array_of_disks);
=cut

sub RaidSqa_verify_root_aggr_vol_spare_disks {
    my ($fc, $root_aggr, $root_vol, $disk_list, $ref, %opt);
    %opt = validate(@_,
                    {conn      => {type => OBJECT, isa => "Connectrec"},
                     root_aggr => {type => SCALAR},
                     root_vol  => {type => SCALAR},
                     disk_list => {type => ARRAYREF},});

    $fc = $opt{conn};

    #Get the root aggr, root vol and disks.
    $root_aggr = defined($opt{root_aggr}) ? $opt{root_aggr} : aggr_root($fc);
    $root_vol  = defined($opt{root_vol})  ? $opt{root_vol}  : vol_root($fc);
    $disk_list = $opt{disk_list};

    #Check the root flag of the root aggr.
    $ref = aggr_options($fc, $root_aggr);
    if (!defined($ref->{root})) {
        $@ = "The root aggr does not have root flag";
        return 0;
    } else {
        logcomment("The root aggr has root flag");
    }

    #Check the root flag of the root vol.
    $ref = vol_options($fc, $root_vol);
    if (!defined($ref->{root})) {
        $@ = "The root vol does not have root flag";
        return 0;
    } else {
        logcomment("The root vol has root flag");
    }

    #Check the specified disks are in spare disks pool.
    my ($raid_obj, %spare_disks, @spare_disks_list);
    $raid_obj         = new RaidInfo($fc);
    %spare_disks      = $raid_obj->spare_disks();
    @spare_disks_list = keys %spare_disks;

    foreach my $disk (@$disk_list) {
        unless (grep (/^$disk$/, @spare_disks_list)) {
            $@ = "The disk $disk has not been found in the spare disk pool";
            return 0;
        } else {
            logcomment("The disk $disk has been found in the spare disk pool");
        }
    }

    return 1;
} ## end sub RaidSqa_verify_root_aggr_vol_spare_disks
##=========================================================================

=head2 RaidSqa_setup

This function will go through the setup configuration setting values
for various parameters like IP, DNS, NETMASK etc

RETURNS
        0 on failure. $@ will be set with error message
        1 on success

ARGUMENTS

=over

=item %args

        Required
        conn     : Connection object. Should be an console connection.
        Setup arguments : Reference to a hash containing the setup
                          information like ip, dns, netmask etc


=back

=cut

sub RaidSqa_setup {

    my ($conn, $setup_args) = @_;

    my ($ifc, $type, @dns_server_list, $flow, @strings, $prompt);

    $ifc  = $setup_args->{IFC};
    $type = "auto";
    $flow = "full";

    if (defined($setup_args->{DNS_SERVERLIST})) {
        @dns_server_list = split(/,/, $setup_args->{DNS_SERVERLIST});
    }

    ##@string is an array of strings which might be encountered while doing
    ##setup configuartion on the filer along with the values to be passed

    @strings = (
        "new hostname"               => $setup_args->{HOSTNAME},
        "Do you want to configure interface groups" => "n",
        "Do you want to enable IPv6" => "n",
        "Do you want to configure virtual network interfaces\\?" => "n",
        'IP address for Network Interface e0M' => $setup_args->{e0M},
        'IP address for Network Interface e0a' => $setup_args->{e0a},
        'IP address for Network Interface e0b' => $setup_args->{e0b},
        'IP address for Network Interface e0c' => $setup_args->{e0c},
        'IP address for Network Interface e0d' => $setup_args->{e0d},
        'IP address for Network Interface e0P' => $setup_args->{e0P},
        '(media type for\s+\w+\s+.*)' => "auto",
        '(enter flow control for\s+\w+\s+.*)' =>"full",
        '(netmask for Network Interface\s+\w+\s+.*)' => sub {
            _get_data($ifc, $1, $setup_args->{NETMASK}) || "255.255.0.0";
        },
        '(Should interface\s+\w+\s+take over a partner IP address during failover)'
          => sub {
            _get_data($ifc, $1, "n") || "n";
          },
        '(Do you want\s+\w+\s+to support jumbo frames)'                   => "n",
        "Would you like to continue setup through the web interface\\?" => "n",
        "Please enter the name or IP address of the IPv4 default gateway" =>
          $setup_args->{GATEWAY},

        "Please enter the name or IP address of the default gateway" => $setup_args->{GATEWAY},
        "IP address of the administration host" => "",
        "Where is the filer located\\?"         => "",
        "Do you want to run DNS resolver"       => $setup_args->{DNS},
        "enter DNS domain name"            => $setup_args->{DNS_DOMAINNAME},
        "IP address for [a-z]+ nameserver" => sub {
            shift(@dns_server_list) || "";
        },
        "another nameserver" => sub {
            @dns_server_list ? "y" : "n";
        },
        "Do you want to run NIS client"                          => "n",
        "Would you like to configure the RLM LAN interface"      => "y",
        "Would you like to enable DHCP on the RLM LAN interface" => "y",
        "IP address of the mail host"                            => "",
        "Do you want to configure the Shelf Alternate Control"   =>"",
        "key to continue"                                        => "",
        "netmask for the RLM"                                    => "",
        "IP address for the RLM gateway"                         => "",
        "Do you want to run NIS client"                          => "n",
        "NIS domain name"                                        => "n",
        "preferred NIS servers"                                  => "",
        "root directory for HTTP files"                          => "",
        "Path Management interface for SAS shelves"              => "n",        #new added
        "(N|n)ew password"                          => $setup_args->{PASSWD},
        "enter timezone"                            => "",
        "What language .* for multi-protocol files" => "");

    #logcomment("_set_up :: @strings");
    ##the below function will go through setup procedure looking for the
    ## prompts similar to one's defined in @strings and pass the
    ##corresponding values. This would be done repeatedly till
    ##the max tries are exhausted or the expected filer prompts are seen.

    $prompt = _prompt_loop(connection => $conn,
                           table      => \@strings,
                           done       => [$conn->prompts()],
                           max_tries  => 50);

    if ($prompt) {
        logcomment("\n\nSetup completed successfully\n");
        return 1;
    }

    $@ = "Failed to complete setup configuration";
    return 0;
} ## end sub RaidSqa_setup

##===============================================================

=head2 RaidSqa_aggr_set_as_root

This function sets root option to the specified aggr
in the maintanenance mode.

Returns 1 on success and 0 on failure.
(set $@ to contain a string describing the failure);

=item %opt
This is the hash with the following keys

     conn => filer connection object required.(It should be console
              connection).

     aggr  => name of the aggr. Required.

     restore => 1 or 0. whether user wants to restore the filer to it's
                previous state. default is 1.
Usage:
     RaidSqa_aggr_set_as_root
    (conn =>$fc, aggr=>$aggr, restore=>1);
=cut

sub RaidSqa_aggr_set_as_root {
    my ($fc,      $aggr, %opt);
    my ($restore, $ret,  $state);
    %opt = validate(@_,
                    {conn    => {type => OBJECT},
                     aggr    => {type => SCALAR},
                     restore => {type => SCALAR, optional => 1, default => 1},}
                   );

    $fc      = $opt{conn};
    $aggr    = $opt{aggr};
    $restore = $opt{restore};

    #Go to maintanenance mode.
    $state = boot_state($fc);
    if ($state ne "MAINT") {
        $ret = transit_to($fc, "MAINT");
        if (!$ret) {
            $@ = "Failed to boot to maintanenance mode";
            return 0;
        }
    }

    #Set the root flag to the original root aggr.
    my $pass_str = "Aggregate '$aggr' will become root at the next boot";
    my $err_str  = "No aggregate named '$aggr' exists";
    my $prompt   = '\*>';
    my $str      = qr/$pass_str|$err_str|$prompt/i;
    my $root_set_flag = 0;
    #Introducing delay due to burt 376706
    sleep(30);
    my ($match, $after) = sayWAIT($fc, "aggr options $aggr root ", $str);
    if ($match !~ /$pass_str/i) {
        (undef, undef,$after) = say($fc, "aggr status $aggr", -prompt, $prompt);
        my @str_output = split(/\n/,$after);
        logcomment("RaidSqa : output got $after ; array : @str_output"); 
        foreach my $temp_str (@str_output)
        {
            if ($temp_str =~ /$aggr.*root/){
                $root_set_flag = 1;
            }
        }
        if (!$root_set_flag) {
            $@ = "Marking the $aggr as root is failed";
            return 0;
        }
    }

    #restore the filer to it's previous state.
    if ($restore) {
        $ret = transit_to($fc, $state);
        if (!$ret) {
            $@ = "Failed to go $state";
            return 0;
        }
    }

    return 1;
} ## end sub RaidSqa_aggr_set_as_root
##=========================================================================
##   PRIVATE FUNCTIONS
##=========================================================================

=head2  _config_saved_file_creation($fc)

This function will create the /etc/configs/config_saved file
on the filer.

Returns 1 on success and 0 on failure.
(set $@ to contain a string describing the failure);

=item $fc

     fc => filer connection object required.(It should be rsh
              connection).

config_saved will not be available on the filer by default/If
some one removed '/etc/configs/config_saved' from the filer
user create this file by running
'config dump <file-name{config_saved}>' on the filer or
follow the below registry upgradation method (steps 1 to 6)
1.Set the below option on the filer.

  admin.config.list            /etc/registry.default,/etc/registry.local

2.Copy the registry file from /etc directory or snapshot to
/etc directory on the filer as temproary file.
Temp file name will be registry.default if the /etc/registry.default
file is not present on the filer or /etc/registry.good.
3.Disable the registry periodic processes.
4.Make a backup of /etc/registry and /etc/registry.local file.
(If it is on filer else ignore this step)
5.Restoring the old value of the registy file to registry.default ,
so that registry.local gets created
6.Enable the registry periodic processes, depending on the
customer's earlier settings.
7.Run config_dump config_saved
Usage:
     _config_saved_file_creation($fc);
=cut

sub _config_saved_file_creation {
    my ($fc) = @_;
    my ($bakup_file_name, $cc, $ch, $cmd, $mount_root, $out);
    my ($audit_val, $config_val, $etc_val, $root_vol, $sudopath);

    #create the client connection
    $cc = make_conn($::CLIENT,$::CLIENT_CONN) 
       or die("Failed to create the client connection object");

    $cmd = "which sudo";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
    if ($out =~ /sudo: Command not found/) {
        $@ = "SUDO command is not found on client";
        return 0;
    } else {
        $sudopath = $out;
    }

    my $sudo_cmd = defined($main::SUDO_PATH) ? $main::SUDO_PATH : $sudopath;

    #export root volume on client.
    $root_vol = vol_root($fc);
    export_path($fc, "/vol/" . $root_vol,
                OPTIONS => "sec=sys,anon=0,rw,nosuid");
    if ($@) {
        return 0;
    }

    #Mounting the root volume
    $mount_root = mount_root_vol($fc->hostp());
    if ($@) {
        return 0;
    }

    $bakup_file_name = "registry.default";

    #Set the admin.config.list option.
    filer_options_set($fc, "admin.config.list",
                      "/etc/registry.default,/etc/registry.local");

    #Checks the existence of the /etc/registry.default file.
    #to create the temp file with the name of /etc/registry.default
    #if /etc/registry.default exists on the filer then
    #create the file with the name of /etc/registry.good.
    $cmd = $sudo_cmd . " ls $mount_root/etc/registry.default";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);

    if ($out =~ /No such file or directory/i) {
        logcomment(
            "Copy the /etc/registry file to the temp file /etc/registry.default"
        );
    } else {
        logcomment(  "Move the registry.default file to the "
                   . "temp file /etc/registry.default.backup");
        $cmd =
            $sudo_cmd
          . " mv $mount_root/etc/registry.default "
          . "$mount_root/etc/registry.default.backup";
        $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
    }

    #Check the existence of the /etc/registry file
    $cmd = $sudo_cmd . " ls $mount_root/etc/registry";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);

    #if /etc/registry does not exist copy from .snapshot dir
    if ($out =~ /No such file or directory/i) {

        #get the snapshot name.
        my @root_dir_snap_list = snap_list($fc, $root_vol, options => '-n');
        my ($i, @system_snaps);

        # snap_list() returns an empty string if no snapshots exists.
        if (defined($root_dir_snap_list[0]{name})) {
            for ($i = 0 ; $i <= $#root_dir_snap_list ; $i++) {
                if ($root_dir_snap_list[$i]{name} =~ /^(hourly|nightly)/i) {
                    push(@system_snaps, $root_dir_snap_list[$i]{name});
                }
            }
        }

        if (scalar(@system_snaps) >= 1) {
            foreach my $snap (@system_snaps) {
                my $snapshot = shift(@system_snaps);
                logcomment("Copy the registry file from .snapshot dir");
                $cmd = $sudo_cmd
                  . " ls $mount_root/etc/.snapshot/$snapshot/registry";
                $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
                next if ($out =~ /No such file or directory/i);
                $cmd =
                    $sudo_cmd
                  . " cp $mount_root/etc/.snapshot/$snapshot/registry "
                  . "$mount_root/etc/$bakup_file_name";
                $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
                if ($out =~ /cp: cannot create regular file /i) {
                    $@ = "Could not copy the registry file, $out";
                    return 0;
                }
                last;
            } ## end foreach my $snap (@system_snaps)
        } else {
            $@ = "registry file does not exist either inside /etc or "
              . ".snapshot dir";
            return 0;
        }

    } else {
        $cmd =
            $sudo_cmd
          . " cp $mount_root/etc/registry "
          . "$mount_root/etc/$bakup_file_name";

        $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
        if ($out =~ /cp: cannot create regular file /i) {
            $@ = "Could not copy the registry file, $out";
            return 0;
        }
    } ## end else [ if ($out =~ /No such file or directory/i)

    #verify existence of temp file (/etc/registry.default)
    $cmd = $sudo_cmd . " ls $mount_root/etc/$bakup_file_name";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);

    if ($out =~ /No such file or directory/i) {
        $@ = "Failed to copy the /etc/registry file";
        return 0;
    }

    #Take backup of the /etc/registry.local file.
    $cmd =
        $sudo_cmd
      . " cp $mount_root/etc/registry.local "
      . "$mount_root/etc/registry.local.good";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);

    #Disable the registry periodic processes
    $audit_val = filer_options_get($fc, "admin.audit.refresh.rate");
    if (($audit_val != 0) || ($audit_val eq "")) {
        filer_options_set($fc, "admin.audit.refresh.rate", 0);
    }

    $config_val = filer_options_get($fc, "admin.config.refresh.rate");
    if (($config_val != 0) || ($config_val eq "")) {
        filer_options_set($fc, "admin.config.refresh.rate", 0);
    }

    $etc_val = filer_options_get($fc, "admin.etc.refresh.rate");
    if (($etc_val != 0) || ($etc_val eq "")) {
        filer_options_set($fc, "admin.etc.refresh.rate", 0);
    }

    #Remove the /etc/registry.local file if it exists.
    $cmd = $sudo_cmd . " ls $mount_root/etc/registry.local";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
    if ($out !~ /No such file or directory/i) {
        $cmd = $sudo_cmd . " rm $mount_root/etc/registry.local";
        $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
    }

    #Restoring the old value of the registry file to $bakup_file_name.
    $cmd = "priv set -q diag;registry restore /etc/$bakup_file_name";
    my $pass_str = "Registry has been restored from /etc/$bakup_file_name";
    my $err_str1 =
      "An error occurred while trying to restore the registry (No such file or directory)";
    my $err_str2 = "Didn't find expected first line of registry file!";
    my $str      = qr/$pass_str|$err_str1|$err_str2/i;
    my ($match, $before, $after) =
      say($fc, "$cmd", $str, -noprompt, -timeout, $::CMDTIMEOUT, -maxidle,
          $::TIMEOUT);

    if ($match !~ /$pass_str/i) {
        $@ = "Failed to restore /etc/$bakup_file_name";
        return 0;
    }

    $cmd = "priv set -q diag;registry periodic";
    say($fc, $cmd);

    #Check the existence of registry.local file.
    $cmd = "rdfile /etc/registry\.local";
    $out = cli($fc->hostp->hostname(), $cmd, $::TIMEOUT);
    if ($out =~ /No such file or directory/i) {
        $@ = "System is failed to create registry.local file";
        return 0;
    }

    #Disable the registry periodic processes
    if ($audit_val eq "") {
        $audit_val = '""';
        filer_options_set($fc, "admin.audit.refresh.rate", $audit_val,0);
    } else {
        filer_options_set($fc, "admin.audit.refresh.rate", $audit_val);
    }

    if ($config_val eq "") {
        $config_val = '""';
        filer_options_set($fc, "admin.config.refresh.rate", $config_val,0);
    } else {
        filer_options_set($fc, "admin.config.refresh.rate", $config_val);
    }

    if ($etc_val eq "") {
        $etc_val = '""';
        filer_options_set($fc, "admin.etc.refresh.rate", $etc_val,0);
    } else {
        filer_options_set($fc, "admin.etc.refresh.rate", $etc_val);
    }

    #Run the config dump command.
    $cmd = "config dump config_saved";
    say($fc, $cmd, -blind);

    #Verify the creation of config_saved file.
    $cmd = $sudo_cmd . " ls $mount_root/etc/configs/config_saved";
    $out = sayEOF($cc, $cmd, timeout => $::CMDTIMEOUT);
    if ($out =~ /No such file or directory/i) {
        $@ = "Failed to create config_saved file";
        return 0;
    }
    umount_vol($mount_root);

    return 1;
} ## end sub _config_saved_file_creation

##----------------------------------------------------------------------

##----------------------------------------------------------------------

=head2 _get_data

This function will return a value for netmask, ip, etc based on
active filer port. 

RETURNS
        undef on failure
        1 on success

ARGUMENTS

=over

=item %args

        Required
        ifc     : active filer port
        $str    : The prompt string on the filer
	$data   : the value which should be set corresponding to
		  active filer port.


=back

=cut

sub _get_data {

    my ($ifc, $str, $data) = @_;
    my ($result, $count);

    $result = undef;
    $count  = 0;

    ## check if the prompt string has the active port string.
    ## if found then only pass the corresponding value back.
    ## else return undef.

    $count = grep (/$ifc/, $str);
    if ($count > 0) {
        $result = $data;
    }
    return $result;
} ## end sub _get_data

##----------------------------------------------------------------------

=head2 _prompt_loop

This function will go through the setup configuration looking
for expected filer prompts and passing necessary values
to complete the setup.

RETURNS
        0 on failure. Stores the error message in $@
        1 on success

ARGUMENTS

=over

=item %opts

        Required
        conn  : Connection object. Should be a console connection.
        table : Reference to an array containing the expected
		prompts during setup and the values to be passed.
	done  : The prompts which when seen can exit the loop
		and return success.
	max_tries: The max no. of times the below loop will be executed
		   looking for expeceted prompts and die incase the tries
		   are exhausted before the finish_prompt is seen.

=back

=cut

sub _prompt_loop {
    my %opts = validate(@_,
                        {connection => {isa  => "Connectrec"},
                         table      => {type => ARRAYREF},
                         done       => {type => ARRAYREF},
                         max_tries  => {type => SCALAR},});
    my %table;
    my @keys;
    while (@{$opts{table}}) {
        my $key   = shift @{$opts{table}};
        my $value = shift @{$opts{table}};
        logcomment("key = $key  value= $value");
        $table{$key} = $value;
        push @keys, $key;
    }
    my $prompt;
    my $tries;

    sleep(200);

     $prompt = "new hostname";
     logcomment("_prompt_loop : PROMPT_0 ::: $prompt");
    ##the below code will go through each prompt in setup, looking
    ##for expected prompts and pass the corresponding values till
    ##the filer prompts are reached or max tries are exhausted.

  LOOP:
    for ($tries = 0 ; $tries < $opts{max_tries} ; $tries++) {
        foreach my $key (@keys) {
            if ($prompt =~ /$key/) {
                my $value = $table{$key};
                my $send = (ref($value) eq "CODE") ? &$value($prompt) : $value;
                logcomment(" Before if prompt =$prompt: send::: $send ");
                if (defined($send) && ($send ne "")) {
                    logcomment("Inside if  send command :: $send ");
                    (undef, undef, undef, $prompt) =
                      say($opts{connection}, "$send", '-noprompt', '-prompt',
                          [@keys, @{$opts{done}}],
                          '-timeout', $::TIMEOUT);
                    logcomment("After say commmand prompt ::$prompt");
                } else {
                    logcomment(" Inside else prompt =$prompt ");
                    (undef, undef, undef, $prompt) =
                      say($opts{connection}, "\r",
                          '-noprompt', '-swallow',
                          '-nocr',     '-prompt',
                          [@keys, @{$opts{done}}], '-timeout',
                          $::TIMEOUT);
                    logcomment("Inside else After say commmand prompt ::$prompt");
                }
                next LOOP;
            } ## end if ($prompt =~ /$key/)
        } ## end foreach my $key (@keys)

        # $prompt did not match any of the keys in @keys;
        # so it must be from $opts{done}.
        last LOOP;
    } ## end for ($tries = 0 ; $tries...

    if ($tries == $opts{max_tries}) {
        $@ = "Too many prompts ($opts{max_tries}), probably a loop\n";
        return 0;
    }
    return ($prompt);
} ## end sub _prompt_loop

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_checksum_type

RaidSqa_get_disk_list_by_checksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, checksum_type =>$checksum_type, pool_name=>$pool_name, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given checksum type in a given filer. By specifing any one of the options from disk_list, pool_name, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given checksum_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item checksum_type

(Optional) : Name of the required checksumtype, to get the list of disk.
Possible values are block, zoned.

(Optional) : bps value of the required checksumtype, to get the list of disk.
Possible value is 520 or 512.

= item pool_name

(Optional): Name of the spare pool from which to get the list of given checksum_type disks.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks of given checksum_type only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given checksum_type.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list of given checksum_type.

=item plex_name

(Optional): Name of plex of which we want to get the disk list of given checksum_type .

=item group_name

(Optional): Name of raid group of which we want to get the disk list of given checksum_type.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_disk_list_by_checksum_type {
    my (%opts) =
      validate(@_,
               {host          => {type => OBJECT, isa      => 'Hostrec'},
                filermode     => {type => SCALAR, default  => "normal", optional => 1},
                conntype      => {type => SCALAR, default  => "#rsh", optional => 1},
                checksum_type => {type => SCALAR, optional => 1},
                bps           => {type => SCALAR, optional => 1},
                pool_name     => {type => SCALAR, default  => undef, optional => 1},
                spare_only    => {type => SCALAR, default  => "no", optional => 1},
                disk_list  => {type => ARRAYREF | UNDEF, default => undef, optional => 1},
                filer_vol  => {type => SCALAR | UNDEF,   default => undef, optional => 1},
                plex_name  => {type => SCALAR | UNDEF,   default => undef, optional => 1},
                group_name => {type => SCALAR | UNDEF,   default => undef, optional => 1},});
    my $host          = $opts{host};
    my $filermode     = $opts{filermode};
    my $conntype      = $opts{conntype};
    my $checksum_type = $opts{checksum_type};
    my $bps	      = $opts{bps};
    my $pool_name     = $opts{pool_name};
    my $spare_only    = $opts{spare_only};
    my $disk_list     = $opts{disk_list};
    my $filer_vol     = $opts{filer_vol};
    my $plex_name     = $opts{plex_name};
    my $group_name    = $opts{group_name};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    my $raid_obj = new RaidInfo($conn);
    my @disk_list;
    my @disk_checksum_type = ();
	my %cksum_bps_mapping = (); 
	$cksum_bps_mapping{"zoned"} = 512;
	$cksum_bps_mapping{"block"} = 520;	
	$cksum_bps_mapping{"advanced_zoned"} = 512;
	
	if($checksum_type !~ /^(block|zoned|advanced_zoned)$/) {
		logcomment("RaidSqa_7mode.pm: $checksum_type is unknown checksum type");
		return @disk_checksum_type;
	}
	
    my $bps_required = $cksum_bps_mapping{$checksum_type};
	if (!$disk_list) {
        @disk_list = RaidSqa_get_disk_list(host       => $host,
                                           filermode  => $filermode,
                                           conntype   => $conntype,
                                           spare_only => $spare_only,
                                           filer_vol  => $filer_vol,
                                           plex_name  => $plex_name,
                                           group_name => $group_name);
    } else {
        @disk_list = @$disk_list;
    }

    my $a = 0;
    my $disk;
    if ($pool_name) {
        my $b = 0;
        my @disks_pool0_checksum_type;
        my @disks_pool1_checksum_type;
        foreach $disk (@disk_list) {
            my $disk_obj = $raid_obj->disk("$disk");
            if ($disk_obj->parameter("pool") eq "0") {
                if ($disk_obj->parameter("bps") eq $bps_required) {
                    $disks_pool0_checksum_type[$a] = $disk;
                    $a++;
                }
            } elsif ($disk_obj->parameter("pool") eq "1") {
                if ($disk_obj->parameter("bps") eq $bps_required) {
                    $disks_pool1_checksum_type[$b] = $disk;
                    $b++;
                }
            }
        } ## end foreach $disk (@disk_list)

        if ($pool_name =~ /pool0|Pool0|POOL0/) {
            return @disks_pool0_checksum_type;
        } elsif ($pool_name =~ /pool1|Pool1|POOL1/) {
            return @disks_pool1_checksum_type;
        }
    } else {
        foreach $disk (@disk_list) {
            my $disk_obj = $raid_obj->disk("$disk");
            if ($disk_obj->parameter("bps") eq $bps_required) {
                $disk_checksum_type[$a] = $disk;
                $a++;
            }
        }

        return @disk_checksum_type;
    } ## end else [ if ($pool_name)
} ## end sub RaidSqa_get_disk_list_by_checksum_type

#------------------------------------------------------------------------------
=head2 RaidSqa_find_active_path_disk_name

RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine finds the active disk name of a given disk.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Find the active disk name of the given disk.

=back

=cut

#------------------------------------------------------------------------------
	
sub RaidSqa_find_active_path_disk_name {
	my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                              }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
		my $disk_name = $opts{disk_name};
		my $orig_disk=undef;
		
        if($filermode ne "normal"){
                $conntype = "#console";
        }
  	    my $conn = make_conn($host,$conntype);
    	my $raid_obj = new RaidInfo($conn);
		if (defined($disk_name)){
			logcomment("RaidSqa.pm: Getting orig disk name of the disk $disk_name.\n");
		}else{
			logcomment("RaidSqa.pm: No disk_name is specified.\n");
			return(0);
		}
	my %disks_hash = $raid_obj->all_disks();
	if(exists $disks_hash{$disk_name}) {
		logcomment("RaidSqa.pm: The diskname is same $disk_name ");
		return $disk_name;
	}else {
		foreach my $key(keys %disks_hash) {
			if($disk_name eq $disks_hash{$key}{"path_name2"}) {
				$orig_disk=$disks_hash{$key}{"name"};
				logcomment("RaidSqa.pm:The disk name for $disk_name seems to have changed to $orig_disk after reboot.");
				return $orig_disk;
			}
		}
	}
}
#------------------------------------------------------------------------------
=head2 RaidSqa_get_disk_rgdn

RaidSqa_get_disk_rgdn(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the disk rgdn value of a particular disk in system..

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_disk_rgdn {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name= $opts{disk_name};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $disk_obj = $raid_obj->disk("$disk_name");
        my $disk_rgdn=$disk_obj->parameter("disk_rgdn");

    if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_rgdn;
    }
}

#------------------------------------------------------------------------------
=head2 RaidSqa_get_aggr_raid_lw_enabled

RaidSqa_get_aggr_raid_lw_enabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This function gets the value for parameter raid_lw_enabled
raid_lw_enabled : possible values: 0 or 1: if 1, aggr will be lost write protected

It returns value of raid_lw_enabled.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of volume for which parameter value to be extracted.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_get_aggr_raid_lw_enabled {
    my (%opts) = validate(@_, {
                                host       => {type =>OBJECT, isa=>'Hostrec' },
                                filermode  => {type =>SCALAR, default=>"normal", optional=>1 },
                                conntype   => {type =>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol  => {type => SCALAR},                                
                                }
                        );
    
    my $host                = $opts{host};    
    my $filermode           = $opts{filermode};    
    my $conntype            = $opts{conntype};    
    my $filer_vol           = $opts{filer_vol};    
    
    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    my $raid_obj=new RaidInfo($conn);    
    my $vol_obj = $raid_obj->aggregate($filer_vol);

    if(!defined($vol_obj)) {
        logcomment("RaidSqa.pm: AggregateInvalidException: Aggr of name $filer_vol does not exist");
        return 0 ;
    } else {
        my $value = $vol_obj->parameter('raid_lw_enabled');
        logcomment("RaidSqa.pm: raid_lw_enabled is set to $value");
        return $value;
    }
}

    
#------------------------------------------------------------------------------
=head2 RaidSqa_get_aggr_raid_lw_allowed

RaidSqa_get_aggr_raid_lw_allowed(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This function gets the value for parameter raid_lw_allowed
raid_lw_allowed : possible values: 0 or 1: if 1 indicates that lost write protection can be turned 'ON' on that volume

It returns value of raid_lw_allowed.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of volume for which parameter value to be extracted.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_get_aggr_raid_lw_allowed {        
    my (%opts) = validate(@_, {
                                host       => {type =>OBJECT, isa=>'Hostrec' },
                                filermode  => {type =>SCALAR, default=>"normal", optional=>1 },
                                conntype   => {type =>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol  => {type => SCALAR},                                
                                }
                        );
    
    my $host        = $opts{host};    
    my $filermode   = $opts{filermode};    
    my $conntype    = $opts{conntype};    
    my $filer_vol   = $opts{filer_vol};    

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    my $raid_obj=new RaidInfo($conn);    
    my $vol_obj = $raid_obj->aggregate($filer_vol);

    if(!defined($vol_obj)) {
        logcomment("RaidSqa.pm: AggregateInvalidException: Aggr of name $filer_vol does not exist");
        return 0 ;
    } else {
        my $value = $vol_obj->parameter('raid_lw_allowed');
        logcomment("RaidSqa.pm: raid_lw_allowed is set to $value");
        return $value;
    }
}


#------------------------------------------------------------------------------
=head2 RaidSqa_get_group_raid_lw_scrub

RaidSqa_get_group_raid_lw_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This function gets the value for parameter group_raid_lw_scrub
group_raid_lw_scrub represents the LW state of the group.
Possible values: DISABLED, ABORTED, INACTIVE, DONE
DISABLED: Parameter will have this value when aggr wide options is OFF
ABORTED : Parameter will have this value when lw scrub detects non zero gen id on disk
INACTIVE: Parameter will have this value when at least once system wide LW option was turned off and no scrub is run on that group ever since.
DONE    : When LW scrub completes and does not find any gen id inconsistancy, it will mark raid group as DONE and this group will be LW protected

It returns value of group_raid_lw_scrub.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required): Name of raid group for which parameter value to be extracted.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_get_group_raid_lw_scrub {    
    my (%opts) = validate(@_, {
                                host       => {type =>OBJECT, isa=>'Hostrec' },
                                filermode  => {type =>SCALAR, default=>"normal", optional=>1 },
                                conntype   => {type =>SCALAR,default=>"#rsh",optional=>1},
                                group_name => {type => SCALAR},                                
                                }
                        );
    
    my $host        = $opts{host};    
    my $filermode   = $opts{filermode};    
    my $conntype    = $opts{conntype};    
    my $group_name  = $opts{group_name};    
    
    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    my $raid_obj=new RaidInfo($conn);    
    my $group_obj = $raid_obj->raid_group($group_name);

    if(!defined($group_obj)) {
        logcomment ("RaidSqa.pm: GroupInvalidException: Group name $group_name does not exist");
        return 0;
    } else {
        my $value = $group_obj->parameter('group_raid_lw_scrub');
        logcomment("RaidSqa.pm: group_raid_lw_scrub is set to $value");
        return $value;        
    }           
}

#------------------------------------------------------------------------------
=head2 RaidSqa_check_group_lw_flags

RaidSqa_check_group_lw_flags(host=>$host, filermode=>$filermode, conntype=>$conntype, group_list=>\@group_list, group_raid_lw_scrub=>$group_raid_lw_scrub);

This function checks the value for raid_config flag against expected group_raid_lw_scrub provided as arg to function
Parameter group_raid_lw_scrub represents the LW state of the group.
Possible values: DISABLED, ABORTED, INACTIVE, DONE
DISABLED: Parameter will have this value when aggr wide options is OFF
ABORTED : Parameter will have this value when lw scrub detects non zero gen id on disk
INACTIVE: Parameter will have this value when at least once system wide LW option was turned off and no scrub is run on that group ever since.
DONE    : When LW scrub completes and does not find any gen id inconsistancy, it will mark raid group as DONE and this group will be LW protected

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item group_list

(Required): reference to an array containing a list of group for which flag value is to be checked.

=item group_raid_lw_scrub

(Required): Expected value of group_raid_lw_scrub raid_config flag.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_check_group_lw_flags {    
        my (%opts) = validate(@_, {
                                host                => {type =>OBJECT, isa=>'Hostrec' },
                                filermode           => {type =>SCALAR, default=>"normal", optional=>1 },
                                conntype            => {type =>SCALAR,default=>"#rsh",optional=>1},
                                group_list          => {type => ARRAYREF},
                                group_raid_lw_scrub => {type => SCALAR},                                
                                }
                        );
    
    my $host                = $opts{host};    
    my $filermode           = $opts{filermode};    
    my $conntype            = $opts{conntype};    
    my $group_list          = $opts{group_list};    
    my $group_raid_lw_scrub = $opts{group_raid_lw_scrub};    
    my $result = 1;
    
    if($filermode ne "normal"){
        $conntype = "#console";
    }
    
    foreach my $group (@$group_list) {
        my $flagval = RaidSqa_get_group_raid_lw_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group);
        if($flagval eq $group_raid_lw_scrub) {
            logcomment("RaidSqa.pm: $group has group_raid_lw_scrub set to $flagval");
        } else {
            logcomment("RaidSqa.pm: $group has group_raid_lw_scrub not set to $group_raid_lw_scrub :: $flagval");
            $result=0;
        }
    }
    return $result;
}

#------------------------------------------------------------------------------
=head2 RaidSqa_check_aggr_lw_flags

RaidSqa_check_aggr_lw_flags(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, raid_lw_allowed=>$raid_lw_allowed, raid_lw_enabled=>$raid_lw_enabled, raid_lost_write=>$raid_lost_write);

This function checks the value for raid_config flags raid_lw_allowed, raid_lw_enabled, raid_lost_write against expected value sent as arg to function

Flags and defination:
raid_lw_allowed : possible values: 0 or 1: if 1 indicates that lost write protection can be turned 'ON' on that volume
raid_lw_enabled : possible values: 0 or 1: if 1, aggr will be lost write protected
raid_lost_write : possible values: on, off, upgrading, partial, upgrade partial, aborted, inoperative

on              : This indicates that aggr is cuurently LW protected
off             : This indicates that aggr is not LW protected
partial         : This indicates that some of raid groups are LW protected and some raid groups are in aborted state (See flag desc group_raid_lw_scrub for group lw states)
upgrade partial : This indicates that some of raid groups are LW protected and some of raid group are still in INACTIVE state
upgrading       : This indicates that all raid groups that aggr are in INACTIVE state
aborted         : This indicated that all raid groups that aggr are in aborted state
inoperative     : This indicates that aggr wide lw protection is on, but system wide LW protection is OFF. In this case aggr will not have protection against lost write

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of aggr/volume for which flag values are to be tested.

=item raid_lw_allowed

(Optional): Expected value of raid_lw_allowed raid_config flag.

=item raid_lw_enabled

(Optional): Expected value of raid_lw_enabled raid_config flag.

=item raid_lost_write

(Optional): Expected value of raid_lost_write option for aggr.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_check_aggr_lw_flags {
    my (%opts) = validate(@_, {
                                host            => {type =>OBJECT, isa=>'Hostrec' },
                                filermode       => {type =>SCALAR, default=>"normal", optional=>1 },
                                conntype        => {type =>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol       => {type =>SCALAR},
                                raid_lw_allowed => {type => SCALAR|UNDEF, default=>undef, optional=>1},
                                raid_lw_enabled => {type => SCALAR|UNDEF, default=>undef, optional=>1},
                                raid_lost_write => {type => SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
    
    my $host            = $opts{host};    
    my $filermode       = $opts{filermode};    
    my $conntype        = $opts{conntype};    
    my $filer_vol       = $opts{filer_vol};    
    my $raid_lw_allowed = $opts{raid_lw_allowed};
    my $raid_lw_enabled = $opts{raid_lw_enabled};
    my $raid_lost_write = $opts{raid_lost_write};
    my $result = 1;

    if($filermode ne "normal"){
        $conntype = "#console";
    }
    
    logcomment("RaidSqa.pm: Testing aggr flags for $filer_vol");
        
    if(defined($raid_lw_allowed)) {
        logcomment("RaidSqa.pm: Expected Values: raid_lw_allowed: $raid_lw_allowed");
        my $flag_value = RaidSqa_get_aggr_raid_lw_allowed(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);
        if($flag_value == $raid_lw_allowed) {
            logcomment("RaidSqa.pm: raid_lw_allowed is set to $raid_lw_allowed as expected");
        } else {
            logcomment("RaidSqa.pm: raid_lw_allowed is not set to expected value: exp: $raid_lw_allowed and actual: $flag_value");
            $result = 0;
        }
    }
    
    if(defined($raid_lw_enabled)) {
        logcomment("RaidSqa.pm: Expected Values: raid_lw_enabled: $raid_lw_enabled");
        my $flag_value = RaidSqa_get_aggr_raid_lw_enabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);
        if($flag_value == $raid_lw_enabled) {
            logcomment("RaidSqa.pm: raid_lw_enabled is set to $raid_lw_enabled as expected");
        } else {
            logcomment("RaidSqa.pm: raid_lw_enabled is not set to expected value: exp: $raid_lw_enabled and actual: $flag_value");
            $result = 0;
        }
    }
    
    if(defined($raid_lost_write)){    
        logcomment("RaidSqa.pm: Expected Values: raid_lost_write: $raid_lost_write");
        #using aggr status -v
		my $cmd    = "priv set test;aggr status -v $filer_vol";
		my $output = RaidSqa_filer_cmd(host => $host, cmd => $cmd);
		my @options_raw = split(/\r?\n/, $output);

		my $options_all;
		my $line;
		my $line1;
		my $lw_state;
		foreach $line (@options_raw) {
			$options_all = $options_all . $line;
		}

		my @options_list = split(/[,\s+] /, $options_all);
		foreach $line1 (@options_list) {
			if ($line1 =~ /.*rlw_(\w+).*/) {
				$lw_state = $1;
				last;
			}
		}
        if ($lw_state eq $raid_lost_write) {
            logcomment("RaidSqa.pm: rlw status for $filer_vol is set to $raid_lost_write as expected");
        } else {
            logcomment("RaidSqa.pm: rlw status for $filer_vol is not set to expected value: exp: $raid_lost_write and actual: $lw_state");
			$result = 0
        }    
    }
    
    return $result;
}

#-------------------------------------------------------------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_offline_ref_count

RaidSqa_get_disk_offline_ref_count (host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the disk offline reference count of a particular disk in system..

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_offline_ref_count {
    my (%opts) =
      validate(@_,
               {host      => {type => OBJECT, isa     => 'Hostrec'},
                filermode => {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#rsh", optional => 1},
                disk_name => {type => SCALAR},});
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    if (defined($disk_name)) {
        my $disk_name1 = RaidSqa_find_active_path_disk_name(host      => $host,
                                                            filermode => $filermode,
                                                            conntype  => $conntype,
                                                            disk_name => $disk_name);
        if ($disk_name1) {
            logcomment("RaidSqa.pm: Using path name $disk_name1 for any operations on $disk_name.\n");
            $disk_name = $disk_name1;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...
    my $raid_obj    = new RaidInfo($conn);
    my $disk_obj    = $raid_obj->disk("$disk_name");
    my $offline_ref = $disk_obj->parameter("offline_ref");

    if (!$disk_obj) {
        logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
        return 0;
    } else {
        return $offline_ref;
    }
} ## end sub RaidSqa_get_disk_offline_ref_count

#-------------------------------------------------------------------------------------------------------------------------------------
=head2 RaidSqa_get_one_plex_of_state

RaidSqa_get_one_plex_of_state (host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, plex_state => $plex_state);

This subroutine returns the name of the plex which is in given state.
It returns the name of the plex which is in given state else 0.

The following arguments are accepted:
=over

=item host
(Required): Hostspec to filer

=item filermode
(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype
(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item plex_state
(Required) : state of the plex

=item filer_vol
(Required) : Name of the mirrored volume.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_get_one_plex_of_state {
    my (%opts) = validate(@_, {
        host       => { type=>OBJECT, isa=>'Hostrec' },
       filermode  => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype   => { type=>SCALAR,default=>"#rsh",optional=>1},
        filer_vol  => { type=>SCALAR },
        plex_state => { type => SCALAR},
        }
    );

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $plex_state = $opts{plex_state};
 
    if($filermode ne "normal"){
       $conntype = "#console";
    }
 
    my $conn = make_conn($host,$conntype);
	my @plexes = RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

    my $normal_plex;
    my $resync_plex;
    my $offlined_plex;
 
    foreach my $plex (@plexes) {
        my $online_state = 0;
        if (RaidSqa_check_plex_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex, state_name => 'online',) ){
            $online_state = 1;
        }
        # get list of groups in a specified plex
        my $raid_obj = new RaidInfo($conn);
        my $plex_obj = $raid_obj->plex("$plex");
        my $parent_state_resync = $plex_obj->parameter("parent_state_resync");
 
        if ($online_state == 1 && $parent_state_resync == 0) {
                $normal_plex = $plex;
        } elsif ($online_state == 1 && $parent_state_resync == 1) {
                $resync_plex = $plex;
        } elsif ($online_state == 0) {
                $offlined_plex = $plex;
        }
    }
 

  if (uc $plex_state eq "NORMAL") {
        return $normal_plex;
    } elsif (uc $plex_state eq "RESYNC") {
        return $resync_plex;

  } elsif (uc $plex_state eq "OFFLINED") {
        return $offlined_plex;

  } else {
        return 0;
    }
} ## end sub RaidSqa_get_one_plex_of_state

#-------------------------------------------------------------------------------------------------------------------------------------
=head2 RaidSqa_take_mirror_to
RaidSqa_take_mirror_to (host=>$host, filermode=>$filermode, conntype=>$conntype, aggr_type => $aggr, filer_vol => $filer_vol, mirror_state => $mirror_state,plex_name => $plex_name);

This subroutine takes mirrored volume to the required state. The state are DEGRADED, RESYNCL1, RESYNCL0 

It returns 1 on success else 0.

The following arguments are accepted:

=over

=item host
(Required): Hostspec to filer

=item filermode
(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype
(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item aggr_type
(Required): 1 for aggregate and 0 for traditional.

=item plex_name
(Required) : Name of plex whose state needs to be changed.

=item filer_vol
(Required) : Name of the mirrored volume.

=item mirror_state
(Required) : State to which plex needs to be taken. Acceptable states are DEGRADED, RESYNCL0, RESYNCL1.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_take_mirror_to {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec' },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
       conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
        filer_vol => { type=>SCALAR },
        mirror_state => {type => SCALAR},
        aggr_type => { type=>SCALAR},
        plex_name => {type=>SCALAR,default=>undef,optional=>1},
        }
  );

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $plex_name = $opts{plex_name};
    my $aggr_type = $opts{aggr_type};
    my $mirror_state = $opts{mirror_state};
 
    if($filermode ne "normal"){
       $conntype = "#console";
    }
 
    my $conn = make_conn($host,$conntype);
	logcomment("RaidSqa.pm : Got plex _name : $plex_name");
    if ( (!RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode,
                                           conntype=>$conntype, filer_vol => $filer_vol,
                                           aggr_type=>$aggr_type,mirror_state=>'NORMAL') ) ||
    (!RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode,
                                    conntype=>$conntype, filer_vol => $filer_vol,
                                    aggr_type=>$aggr_type, state_name=>'online') ) ) {
        logcomment("RaidSqa.pm: The volume doesn't seem online and mirrored to begin with.\n");
        return 0;
    }

    if (!defined $plex_name){
        my @plexes = RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);
        $plex_name = $plexes[0];
    }
 
    if (uc $mirror_state eq 'DEGRADED' ) {
        if (!RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name)) {
            logcomment("RaidSqa.pm: Failed to change the state of plex $plex_name to 'DEGRADED'");
            return 0;
        }
       logcomment("RaidSqa.pm: State of plex $plex_name is 'DEGRADED'");
        sleep 10;
        return 1;
    } elsif (uc $mirror_state eq "RESYNCL1") {
        if (!RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name)) {
            logcomment("RaidSqa.pm: Failed to change the state of plex $plex_name to 'RESYNCL1'");
            return 0;
        }
        
 #start hammer so resync takes more time
        RaidSqa_hammer_start( host      => $host,
                            filermode => $filermode,
                            conntype => $conntype,
                            filer_vol => $filer_vol);
	sleep 120;
        if (!RaidSqa_plex_online(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name)) {
            logcomment("RaidSqa.pm: Failed to change the state of plex $plex_name to 'RESYNCL1'");
            return 0;
        }
        sleep 30;
  	 RaidSqa_hammer_abort(host => $host); 
	     return 1;
    } elsif (uc $mirror_state eq "RESYNCL0") {
		logcomment("RaidSqa.pm : Got plex _name : $plex_name");
		# get a list of plexes
		my @temp_plex_list = RaidSqa_get_plex_list(host => $host, filer_vol=>$filer_vol);
		# destroy one plex - other than the one sent as argument
		my $plex_to_destroy = '';
		foreach my $temp_plex (@temp_plex_list) {
			if ($temp_plex ne $plex_name) {
				$plex_to_destroy = $temp_plex;
				last;
			}
		}
        if (!RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_to_destroy)) {            
			logcomment("RaidSqa.pm : Failed to offline other plex $plex_to_destroy- cannot change mirror state to 'DEGRADED' ");
            return 0;
        }
        sleep 20;
        if (!RaidSqa_plex_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_to_destroy)) {
            logcomment("RaidSqa.pm: Failed to destroy plex  $plex_to_destroy - cannot bring plex $plex_name to 'RESYNCL0'");
            return 0;
        }
		sleep 20;
		 #start hammer so resync takes more time
        RaidSqa_hammer_start( host      => $host,
                            filermode => $filermode,
                            conntype => $conntype,
                            filer_vol => $filer_vol);
        sleep 120;
        RaidSqa_disk_zero_spares(host=>$host, filermode=>$filermode, conntype=>$conntype);
        sleep 30;
		# mirror the volume now
		if (!RaidSqa_aggr_mirror(host => $host, filermode => $filermode, conntype => $conntype, filer_vol => $filer_vol) ){
			logcomment("RaidSqa.pm: Failed to mirror volume $filer_vol - cannot bring plex $plex_name to 'RESYNCL0'");
            return 0;
		}
		sleep 10;    		 		
        if (RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode,
                                   conntype=>$conntype, filer_vol => $filer_vol,
                                   aggr_type=>$aggr_type,mirror_state=>'UNMIRRORED') 
		){
           logcomment("RaidSqa.pm: It seems that destroy of the offlined plex failed. Hence unable to change the state of plex $plex_name to RESYNCL0\n" );
           return 0;
       }
		 RaidSqa_hammer_abort(host => $host);
       return 1;
    } else {
        logcomment("RaidSqa.pm: Unknown mirror state.");
        return 0;
    }
 } ## end sub RaidSqa_take_mirror_to
 
#-------------------------------------------------------------------------------------------------------------------------------------
=head2 RaidSqa_get_bypassed_disk_list 
RaidSqa_get_bypassed_disk_list (host=>$host, filermode=>$filermode, conntype=>$conntype);
This subroutine returns a list of bypassed disks on the filer 

It returns a list of all disks bypassed on success and null on failure

The following arguments are accepted:

=over

=item host
(Required): Hostspec to filer

=item filermode
(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype
(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_get_bypassed_disk_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }
        my $conn = make_conn($host,$conntype);
        my @bypassed_disks_list;
        my $output;

        (undef, undef, $output) = say($conn, "priv set -q diag;sysconfig -v", -timeout, $RaidSqa_TIMEOUT);
        my @unformatted_output= split(/\r?\n/, $output);
                        foreach my $line(@unformatted_output){
                                    if($line=~/Disk (.*) in Shelf.*is bypassed/){
                                                push @bypassed_disks_list, $1;
                                    }
                        }
        logcomment("RaidSqa.pm: Here is the list of bypassed disks: @bypassed_disks_list");
        return @bypassed_disks_list;
} #end sub RaidSqa_get_bypassed_disk_list 


1;
