#$Id: //depot/prod/test/Rsierranevada/lib/RaidSqa_Cmode.pm#1 $
##
## @summary RaidSqa_Cmode.pm - RAID SQA library for commands and utilities fpr Cmode
##
## @status TESTME
##
## @author skg@netapp.com
##
## @change 2010-07-13 pravin.salgond@netapp.com: Burt 431831: Added ZCSv2 support for RaidSqa_dd command.
## @change 2010-09-06 pravin.salgond@netapp.com: Burt 438681 : Updated RaidSqa_get_raid_size_value to use raid_config command.
## @change 2010-10-22 pravin.salgond@netapp.com: Burt 457342 : Added subroutine RaidSqa_get_disk_offline_ref_count
## @change 2010-12-07 sajitha.ram@netapp.com: Burt 468155 : Added disk multi path fix
##
## @pod here

=head1 NAME

RaidSqa

=head1 DESCRIPTION

         This library use RaidInfo.pm library to get various raidinfo o/ps for Cmode filer.
   This contains all raid library functions for commands and utililties.

=head1 SYNOPSIS

        use RaidSqa_Cmode.pm;


   ##FUNCTIONS RELATED TO COMMANDS ##

   RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type, aggr_bits=>$aggr_bits);

   -or-

   RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@disk_list, disk_list1=>\@disk_list1, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type);

   -or-

   RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, aggr_type=>$aggr_type, rpm=>$rpm, more_options=>$more_options);

   RaidSqa_aggr_add(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, group_name=>$group_name, disk_count=>$disk_count, disk_size=>$disk_size, disk_list=>\@disk_list, $disk_list1=>\@disk_list1, options=>$options);

   RaidSqa_aggr_rename(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_aggr_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

   RaidSqa_aggr_online(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

   RaidSqa_aggr_restrict(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

   RaidSqa_aggr_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

   RaidSqa_aggr_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

#  RaidSqa_aggr_split(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, splitted_vol=>$splitted_vol);

#  RaidSqa_aggr_mirror(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, splitted_vol=>$splitted_vol, disk_list=>\@disk_list, options=>options);

#  RaidSqa_plex_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

#  RaidSqa_plex_online(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

#  RaidSqa_plex_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

   RaidSqa_hammer_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, iterations=>$iterations, file_name=>$file_name, file_size=>$file_size);

   RaidSqa_hammer_abort(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_hammer_pause(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_hammer_restart(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_hammer_status(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_aggr_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   RaidSqa_aggr_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

   RaidSqa_aggr_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, $plex_name=>$plex_name, group_name=>$group_name);

   RaidSqa_aggr_scrub_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

   RaidSqa_aggr_scrub_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_aggr_media_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

        RaidSqa_aggr_media_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

        RaidSqa_aggr_media_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

#  RaidSqa_aggr_verify_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_number=>$plex_number);

#  RaidSqa_aggr_verify_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

#  RaidSqa_aggr_verify_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

#  RaidSqa_aggr_verify_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options, value=>$value);

   RaidSqa_disk_zero_spares(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_disk_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_disk_fail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>$options);

   RaidSqa_disk_unfail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>options);

   RaidSqa_disk_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>options);

   RaidSqa_disk_online(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_disk_mung(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, sector=>$sector, bits=>$bits);

   RaidSqa_disk_assign(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, $disk_list=>\@disk_list,pool=>$pool);

   RaidSqa_disk_remove_ownership(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, $disk_list=>\@disk_list);

   RaidSqa_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name, flag_value=>$flag_value);

   RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name, option_value=>$option_value);

   RaidSqa_license_add_by_code(host=>$host, filermode=>$filermode, conntype=>$conntype, code=>$code);

   RaidSqa_license_add_by_service(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

   RaidSqa_license_delete(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

   RaidSqa_fiji_filter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

   RaidSqa_fiji_nvfilter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

   RaidSqa_fiji_clear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

   RaidSqa_fiji_nvclear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

   RaidSqa_fiji_show(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_nv_trash(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_savecore(host=>$host, filermode=>$filermode, conntype=>$conntype, options=>$options);

   RaidSqa_media_scrub_disable(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_media_scrub_enable(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_log(host=>$host, filermode=>$filermode, conntype=>$conntype, marker=>$marker);

#  RaidSqa_exportfs(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

#  RaidSqa_aggr_undestroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type, raidtree_id => $raidtree_id);

   RaidSqa_aggr_wafliron_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

   RaidSqa_aggr_wafliron_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

   RaidSqa_dd(host=>$host, filermode=>$filermode, conntype=>$conntype, if=>$if, of=$of, din=$din, bin=$bin, dout=$dout, bout=$bout, count=$count, options=>$options);

   RaidSqa_filer_cmd(host=>$host, filermode=>$filermode, conntype=>$conntype, cmd=>$cmd, timeout=$timeout);


   ##FUNCTIONS CHECKING STATUS##

   RaidSqa_check_disk_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_check_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, fsm_state=>$fsm_state);

   RaidSqa_check_disk_is_doing_optimized_recons(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_check_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, parent_state=>$parent_state);

   RaidSqa_check_disk_is_prefailed(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

   RaidSqa_check_disk_block_is_pseudo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, dbn=>$dbn);

   RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

   RaidSqa_check_aggr_exist_anytype(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_check_plex_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

   RaidSqa_check_group_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

   RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, state_name=>$state_name);

   RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, mirror_state=>$mirror_state);

   RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, fsm_state=>$fsm_state);

#  RaidSqa_check_plex_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, state_name=>$state_name);

#  RaidSqa_check_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, fsm_state=>$fsm_state);

#  RaidSqa_check_plex_resyncing(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, resync_level=>$resync_level);

   RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name, fsm_state=>$fsm_state);

   RaidSqa_check_group_recons_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

   RaidSqa_check_group_scrub_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

   RaidSqa_check_group_is_running_context_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

   RaidSqa_check_group_recons_is_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

   RaidSqa_check_raid_size_valid_range(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);

   RaidSqa_check_license(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

   RaidSqa_check_fiji(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

   RaidSqa_check_hammer_running(host=>$host, filermode=>$filermode, conntype=>$conntype, hammer_number=>$hammer_number);

   RaidSqa_check_existing_aggr_ok(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, disk_count=>$disk_count, aggr_bits=>$aggr_bits, aggr_fsm_state=>$aggr_fsm_state, aggr_state_name=>$aggr_state_name, aggr_wafl_online=>$aggr_wafl_online, aggr_wafl_mounted=>$aggr_wafl_mounted, aggr_ignore_inconsist=>$aggr_ignore_inconsist, aggr_snapmirrored=>$aggr_snapmirrored, all_group_fsm_state=>$all_group_fsm_state, all_group_sdc=>$all_group_sdc);


   ##FUNCTIONS GETTING INFORMATION##

   RaidSqa_get_vol_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

   RaidSqa_get_aggr_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

   RaidSqa_get_aggr_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_get_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options);

   RaidSqa_get_aggr_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_cksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_raidtree_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_bits(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_has_bad_blocks(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_bad_block_count(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_aggr_tetris_opt_disabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

   RaidSqa_get_root_aggr(host=>$host, filermode=>$filermode, conntype=>$conntype);

   		RaidSqa_get_root_vol(host=>$host, filermode=>$filermode, conntype=>$conntype);

   RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

#        RaidSqa_get_plex_resync_level(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

#        RaidSqa_get_plex_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name);

        RaidSqa_get_group_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name);

        RaidSqa_get_group_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, filer_vol=>$filer_vol, plex_name=>$plex_name);

        RaidSqa_get_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

        RaidSqa_get_group_recons_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

        RaidSqa_get_group_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

        RaidSqa_get_disk_offline_ref_count(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

        RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_pool(host=>$host, filermode=>$filermode, conntype=>$conntype, pool_name=>$pool_name, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, parent_state=>$parent_state, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_raid_type(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_type=>$raid_type, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, storage_type=>$storage_type, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_list_by_rpm(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_rpm=>$disk_rpm, spare_only=>$spare_only, disk_list=>\@disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

        RaidSqa_get_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_used_size(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_group_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_plex_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_aggr_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_other_path_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_disk_sdc_target(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_get_preferred_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype);

        RaidSqa_get_raid_size_value(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type, override=>$override);

        RaidSqa_get_scrub_report_by_group(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

        RaidSqa_get_fiji_slot(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

        RaidSqa_get_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name);

        RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name);
        RaidSqa_get_fileid(host=>$host, filermode=>$filermode, conntype=>$conntype, file_name=>$file_name);

        RaidSqa_get_file_block_info(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, file_name=>$file_name, $block_number=>$block_number);

        RaidSqa_get_vserver_ip_addr(host=>$host, filermode=>$filermode, conntype=>$conntype, vserver=>$vserver);

        RaidSqa_get_volume_junc_path(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

        RaidSqa_get_disk_rgdn(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

        RaidSqa_ems_log_get_mark(host=>$host, timeout=>60);

        RaidSqa_ems_log_dump_by_type(host=>$host, timestamp=>$mark);

        RaidSqa_ems_log_dump_by_id(host=>$host, timeout=>300, timestamp=>23456788t);

        RaidSqa_ems_log_check(host=>$host, eventtype=>"fci.adapter.offline", key=>"adapterName" value=>"6a", timestamp=>$mark);

        ##OTHER FUNCTIONS##

        RaidSqa_test_init(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type);

        RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, timeout=>$timeout);

        RaidSqa_wait_for_reconstruction_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name, timeout=>$timeout);

        RaidSqa_wait_for_plex_resync_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name=>$plex_name, resync_level=>$resync_level, timeout=>$timeout);

        RaidSqa_wait_for_reparity_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name,group_name=>$group_name, timeout=>$timeout);

        RaidSqa_wait_for_scrub_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout);

        RaidSqa_wait_for_disk_sdc_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, timeout=>$timeout);

        RaidSqa_wait_for_spare_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list, timeout=>$timeout);

        ##FUNCTIONS RELATED TO FEATURE OLM##

        RaidSqa_labelmaint_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, arg_list=>\@arg_list);

        RaidSqa_get_labelmaint_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

        RaidSqa_labelmaint_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype);

        RaidSqa_check_disk_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

        RaidSqa_check_disk_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, fsm_state=>$fsm_state);

        RaidSqa_check_aggr_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, $vol_disk_list=>\@vol_disk_list);

        RaidSqa_check_aggr_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, $vol_disk_list=>\@vol_disk_list);

        RaidSqa_diskbypass(host=>$host, filermode=>$filermode, conntype=>$conntype, error=>$error, disk_id=>$disk_id, portAorB=>$portAorB);

=head1 ROUTINES

=cut

package RaidSqa_Cmode;
use strict;
no strict "subs";
use warnings;
use RaidInfo;
#use Storage::Ems qw(emslog_parseNR emslog_parse emslog_process_line);

use vars qw (@ISA @EXPORT);
require Exporter;
@ISA = qw (Exporter);
@EXPORT = qw ( RaidSqa_aggr_create
      RaidSqa_aggr_add
      RaidSqa_aggr_rename
      RaidSqa_aggr_offline
      RaidSqa_aggr_online
      RaidSqa_aggr_restrict
      RaidSqa_check_group_reparity_in_progress      
      RaidSqa_aggr_destroy
      RaidSqa_aggr_remove
      RaidSqa_hammer_start
      RaidSqa_hammer_abort
      RaidSqa_hammer_pause
      RaidSqa_hammer_restart
      RaidSqa_hammer_status
      RaidSqa_aggr_scrub_status
      RaidSqa_aggr_scrub_start
      RaidSqa_aggr_scrub_stop
      RaidSqa_aggr_scrub_suspend
      RaidSqa_aggr_scrub_resume
      RaidSqa_aggr_media_scrub_start
      RaidSqa_aggr_media_scrub_status
      RaidSqa_aggr_media_scrub_stop
      RaidSqa_aggr_options
      RaidSqa_disk_zero_spares
      RaidSqa_disk_remove
      RaidSqa_disk_fail
      RaidSqa_disk_unfail
      RaidSqa_disk_offline
      RaidSqa_disk_online
      RaidSqa_disk_mung
      RaidSqa_disk_assign
      RaidSqa_disk_remove_ownership
      RaidSqa_disk_replace_start
      RaidSqa_setflag
      RaidSqa_set_options
      RaidSqa_license_add_by_code
      RaidSqa_license_add_by_service
      RaidSqa_license_delete
      RaidSqa_fiji_filter
      RaidSqa_fiji_nvfilter
      RaidSqa_fiji_clear
      RaidSqa_fiji_nvclear
      RaidSqa_fiji_show
      RaidSqa_nv_trash
      RaidSqa_savecore
      RaidSqa_media_scrub_disable
      RaidSqa_media_scrub_enable
      RaidSqa_log
      RaidSqa_dd
      RaidSqa_filer_cmd
      RaidSqa_filer_saycmd
      RaidSqa_aggr_wafliron_start
      RaidSqa_aggr_wafliron_status
      RaidSqa_check_disk_exist
      RaidSqa_check_disk_fsm_state
      RaidSqa_check_disk_is_doing_optimized_recons
      RaidSqa_check_disk_parent_state
      RaidSqa_check_disk_is_prefailed
      RaidSqa_check_disk_sdc_start
      RaidSqa_check_disk_block_is_pseudo
      RaidSqa_check_aggr_exist
      RaidSqa_check_aggr_exist_anytype
      RaidSqa_check_plex_exist
      RaidSqa_check_group_exist
      RaidSqa_check_aggr_state_name
      RaidSqa_check_aggr_mirror_state
      RaidSqa_check_aggr_fsm_state
      RaidSqa_check_group_fsm_state
      RaidSqa_check_group_recons_in_progress
      RaidSqa_check_group_scrub_in_progress
      RaidSqa_check_group_is_running_context_scrub
      RaidSqa_check_group_recons_is_suspend
      RaidSqa_check_raid_size_valid_range
      RaidSqa_check_license
      RaidSqa_check_fiji
      RaidSqa_check_hammer_running
      RaidSqa_check_existing_aggr_ok
      RaidSqa_get_vol_status
      RaidSqa_get_aggr_status
      RaidSqa_get_aggr_list
      RaidSqa_get_aggr_options
      RaidSqa_get_aggr_type
      RaidSqa_get_aggr_cksum_type
      RaidSqa_get_aggr_fsm_state
      RaidSqa_get_aggr_raidtree_type
      RaidSqa_get_aggr_storage_type
      RaidSqa_get_aggr_bits
      RaidSqa_get_aggr_mirror_state
      RaidSqa_get_aggr_context_parity_valid
      RaidSqa_get_aggr_has_bad_blocks
      RaidSqa_get_aggr_bad_block_count
      RaidSqa_get_aggr_tetris_opt_disabled
      RaidSqa_get_root_aggr
      RaidSqa_get_root_vol
      RaidSqa_get_plex_list
      RaidSqa_get_group_list
      RaidSqa_get_group_list_by_fsm_state
      RaidSqa_get_group_fsm_state
      RaidSqa_get_group_recons_suspended_block
      RaidSqa_get_group_context_parity_valid
      RaidSqa_get_disk_offline_ref_count
      RaidSqa_get_disk_list
      RaidSqa_get_disk_list_by_pool
      RaidSqa_get_disk_list_by_fsm_state
      RaidSqa_get_disk_list_by_parent_state
      RaidSqa_get_disk_list_by_raid_type
      RaidSqa_get_disk_list_by_storage_type
      RaidSqa_get_disk_list_by_rpm
      RaidSqa_get_disk_fsm_state
      RaidSqa_get_disk_used_size
      RaidSqa_get_disk_parent_state
      RaidSqa_get_disk_group_name
      RaidSqa_get_disk_plex_name
      RaidSqa_get_disk_aggr_name
      RaidSqa_get_disk_other_path_name
      RaidSqa_get_disk_sdc_target
      RaidSqa_get_preferred_storage_type
      RaidSqa_get_raid_size_value
      RaidSqa_get_scrub_report_by_group
      RaidSqa_get_fiji_slot
      RaidSqa_get_setflag
      RaidSqa_get_options
      RaidSqa_get_fileid
      RaidSqa_get_file_block_info
      RaidSqa_get_disk_storage_type
      RaidSqa_media_error_inject
      RaidSqa_get_volume_junc_path
      RaidSqa_get_vserver_ip_addr
      RaidSqa_get_disk_rgdn
      RaidSqa_get_disk_list_by_checksum_type
      RaidSqa_get_disk_parent_state
      RaidSqa_test_init
      RaidSqa_wait_for_aggr_disks_zeroing_completion
      RaidSqa_wait_for_reconstruction_completion
      RaidSqa_wait_for_reparity_completion
      RaidSqa_wait_for_scrub_completion
      RaidSqa_wait_for_disk_sdc_completion
      RaidSqa_wait_for_spare_disks_zeroing_completion
      RaidSqa_labelmaint_isolate
      RaidSqa_get_labelmaint_list
      RaidSqa_labelmaint_unisolate
      RaidSqa_check_disk_after_isolate
      RaidSqa_check_disk_after_unisolate
      RaidSqa_check_aggr_after_isolate
      RaidSqa_check_aggr_after_unisolate
      RaidSqa_ems_log_get_mark
      RaidSqa_ems_log_dump_by_type
      RaidSqa_ems_log_dump_by_id
      RaidSqa_ems_log_check
      RaidSqa_ems_get_value_by_key
      RaidSqa_create_temproot_vol
      RaidSqa_check_ioc_support
      RaidSqa_cleanup_ioc_vol
      RaidSqa_transit_to
      RaidSqa_verify_root_aggr_vol_spare_disks
      RaidSqa_temp_rootvol_verify
      RaidSqa_get_invalid_diskid
      RaidSqa_aggr_set_as_root
	  RaidSqa_find_active_path_disk_name
      RaidSqa_root_recovery
      RaidSqa_aggr_recovery_from_dblade
      RaidSqa_diskbypass


   );


use Carp qw(confess croak);
use Params::Validate qw(validate OBJECT SCALAR ARRAYREF HASHREF UNDEF);
use Tharn qw(say script_result logcomment logresult param);
use Module::Common qw(validate_mixed);
BEGIN {
Params::Validate::validation_options(
    on_fail => sub {my @msgs = @_; chomp(@msgs);
        Carp::confess(Tharn::script_result(@msgs))}
   );
}

use Utils qw(make_conn);
use Data::Dumper;
use filer;
use Server;
use boot;

my $RaidSqa_TIMEOUT = 300;

##############################################################################
# LIST OF FUNCTIONS WHICH ARE RAID COMMNADS                                  #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_create

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type, aggr_bits=>$aggr_bits);

-or-

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@disk_list, disk_list1=>\@disk_list1, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, rpm=>$rpm, aggr_type=>$aggr_type);

-or-

RaidSqa_aggr_create(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$disk_count, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, aggr_type=>$aggr_type, rpm=>$rpm, more_options=>$more_options);


This subroutine create the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item options

(Optional) : We can use this to define all options needed for vol/aggr create if we do not want to specify all the paremeters to this function instead want to create options in the script.

=item disk_count

(Optional) : Number of disk to be used for volume/aggegate creation. Need to define at least on parameter from disk_count and disk_list for volume creation, if none is defined, it will use disk_count as 6

=item disk_list

(Optional) : Reference to the list of disks to be used for volume creation. Need to define at least one parameter from disk_count or disk_list. But can not defined both.

=item disk_list1

(Optional) : Reference to the list of 2nd set of disks. Need to define this if mirror is 1 and disk_list is also defined. Can not define if disk_count is defined. For Cmode as mirror is not supported, we will just ignore this.

=item raid_type

(Optional): Raid type of the volume/aggregate to be created. By default it is raid_dp. Other options is raid4.

=item raid_size

(Optional): Raid size of the volume/aggregate to be created. By default it is default. Other values can be min, max or user_defined count but that should be in allowed range for a given storage_type.

=item mirror

(Optional): 1 for mirror volume and 0 for nonmirror. Default is 0. For Cmode as mirror is not supported, we will set it to 0

=item storage_type

(Optional):  Disk storage type. Can be ATA, SAS, FCAL. If nothing is defined  than it tries to find the prefered storage type and use that type of disk.

=item rpm

(Optional):  Disk rpm type. Can be 7200, 10000, 15000. If nothing is defined than it use any rpm disks to create volume/aggr.

=item aggr_type

(Optional): 1 for aggregate and 0 for traditional. Default it is 1. For Cmode as traditional is not supported, we will set it to 1

=item more_options

(Optional) : We can use this to define more options needed for vol/aggr create.

=item aggr_bits

(Optional): 32 for normal volume/aggr, 64 for larger aggregate. Default it is 32.

=item fake_la

(Optional): 1 for fake larger aggregate of size > 16TB and 0 for not.

=item fake_rg_max_count

(Optional): Default is 3, it controls the env variable needed to create fake larger aggregate.

=item fake_vol_size

(Optional): The value of fake larger flex volume in TB.

=item vserver

(Optional): Name of vserver for volume to be created, default is vs0

=item security_style

(Optional): Security style of volume. default is mixed.

=item unix_permissions

(Optional): unix permission of the volume, default is 0755


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_create {

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                disk_count => { type=>SCALAR,optional=>1 },
                                disk_size => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                disk_list => { type=>ARRAYREF,optional=>1 },
                                disk_list1 => { type=>ARRAYREF,optional=>1 },
                                raid_type => { type=>SCALAR, default=>"raid_dp",optional=>1 },
                                raid_size => { type=>SCALAR, default=>"default",optional=>1 },
                                mirror => { type=>SCALAR,default=>0,optional=>1 },
                                storage_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                rpm => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                aggr_type => { type=>SCALAR,default=>1,optional=>1 },
                                aggr_bits => { type=>SCALAR|UNDEF ,default=>undef,optional=>1 },
                                snaplock => { type=>SCALAR,optional=>1 },
                                more_options => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                fake_la => {type=>SCALAR,default=>0,optional=>1 },
                                fake_rg_max_count => {type=>SCALAR,default=>3,optional=>1 },
                                fake_vol_size => {type=>SCALAR,default=>24,optional=>1},
                                vserver => { type=>SCALAR,default=>"vs0",optional=>1 },
                                security_style => { type=>SCALAR,default=>"mixed",optional=>1 },
                                unix_permissions => { type=>SCALAR,default=>"0755",optional=>1 },

                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $disk_count = $opts{disk_count};
        my $disk_size = $opts{disk_size};
        my $disk_list = $opts{disk_list};
        my $disk_list1 = $opts{disk_list};
        my @disk_list;
        my $raid_type = $opts{raid_type};
        my $raid_size = $opts{raid_size};
        my $mirror = $opts{mirror};
        my $storage_type = $opts{storage_type};
        my $rpm = $opts{rpm};
        my $aggr_type = $opts{aggr_type};
        my $snaplock = $opts{snaplock};
        my $snap_lock = "";
        my $more_options = $opts{more_options};
        my $aggr_bits = $opts{aggr_bits};
        my $fake_la = $opts{fake_la};
        my $fake_rg_max_count = $opts{fake_rg_max_count};
        my $fake_vol_size = $opts{fake_vol_size};
        my $vserver = $opts{vserver};
        my $security_style = $opts{security_style};
        my $unix_permissions = $opts{unix_permissions};

    # create connection
    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    # dereference array of disk_list if specified
    if ($disk_list) {
        @disk_list = @$disk_list;
    }
    if ($disk_list1) {
        logcomment("RaidSqa_Cmode.pm: As mirror is not supported, there is no significance of $disk_list1 here, ignoring");
    }

    if (!$aggr_type) {
        logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
        $aggr_type = 1;
    }

    if ($snaplock) {
        logcomment("RaidSqa_Cmode.pm: As snaplock is not supported, there is no significance of snaplock here, ignoring");
    }

    if ($mirror) {
        logcomment("RaidSqa_Cmode.pm: As syncmirror aggr is not supported, hence changing the mirror to 0");
        $mirror = 0;
    }

    # use default disk_count if disk_list and disk_count both are not given, also check that user did not specified both together
    if ((!$disk_count) && (!@disk_list)) {
        $disk_count = 6;
    } elsif (($disk_count) && (@disk_list)) {
        logcomment("RaidSqa_Cmode.pm: Need to provide only one parameter disk_count or disk_list to aggr create argument");
        return 0;
    }

    # Get preferred storage type if not specified by user
    if (!defined($storage_type)) {
        logcomment("RaidSqa_Cmode.pm: Getting storage type, as not defined");
        $storage_type = RaidSqa_get_preferred_storage_type(host=>$host, conntype=>$conntype);
        logcomment("RaidSqa_Cmode.pm: Preferred storage type is $storage_type");
    }

    # get raid_size value for min/max/default raid_size and if a user defined size is given than check that it is in valid range
    if ($raid_size =~ /\D/) {
        $raid_size = RaidSqa_get_raid_size_value(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);

    } else {
        if (!RaidSqa_check_raid_size_valid_range(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type)) {
            logcomment("RaidSqa_Cmode.pm: raid_size $raid_size is not in the valid range");
            return 0;
        }

    }

    sleep 30;

    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    if ($fake_la) {
        if ($aggr_bits != 64) {
            logcomment("RaidSqa_Cmode.pm: fake_la is supported only on 64 bits aggregates");
            return 0;
        }
        if ($fake_rg_max_count < 3) {
            logcomment("RaidSqa_Cmode.pm: for fake_la fake_rg_max_count should be >= 3");
            return 0;
        }
        if ($fake_vol_size < 24) {
            logcomment("Fake Flex vol size of less than 24 TB is not necessarily enough to write to a > 16 TB vvbn");
            return 0;
        }

        $server->cli(cmd=>"set -privilege test");
        $server->cli(cmd=>"run local bootargs set bootarg.dblade.fake_large_aggr true");
        $server->cli(cmd=>"run local bootargs set raidtop_fake_rg_max_count $fake_rg_max_count");

        if ($raid_size <= 3) {
            logcomment("RaidSqa_Cmode.pm: Increasing raid size for fake_la by adding 2 if raid size is <= 3");
            $raid_size = $raid_size + 2;
        }
    }
    logcomment("RaidSqa_Cmode.pm: Raid size used for creating volume/aggregate is: $raid_size");

    my $vol_create_args = "-aggregate $filer_vol -raidtype $raid_type -maxraidsize $raid_size";

    # if more options are needed to be specified to vol_create_args
    if ($more_options) { $vol_create_args = "$vol_create_args" . " $more_options"; }

    if (defined($aggr_bits)){
            if (($aggr_bits == 64) && ($aggr_type == 0)) {
                    logcomment("RaidSqa_Cmode.pm: 64 bit type is not supported on traditional volumes, AGGR should be 1");
                    return 0;
            }
            if($aggr_type==1){
                    $vol_create_args="$vol_create_args" . " -B $aggr_bits";
            }
    }

    my @fake_disk_add_list;
    my $fake_add_disk_count;
    if ($disk_list) {
        if($fake_la) {
            if($raid_type eq "raid_dp"){
                @fake_disk_add_list = @disk_list[3..$#disk_list];
                @disk_list = @disk_list[0..2];
            }elsif($raid_type eq "raid4"){
                @fake_disk_add_list = @disk_list[2..$#disk_list];
                @disk_list = @disk_list[0..1];
            }
            if($#fake_disk_add_list <= -1){
                logresult("FATAL", "RaidSqa_Cmode: Number of disks is not sufficient for creation of FAKE LA. Number of disks available for addition seems to be less. \n");
            }
        }

        # Modified to handle disk size input
        if ( $disk_list[0] !~ /\d+\@\d+[mgtMGT]/ ) {

            $vol_create_args = "$vol_create_args" . " -d @disk_list";
        } else {
            $vol_create_args = "$vol_create_args" . " @disk_list";
        }


    } else {
        if ($disk_count eq "default") {
            $disk_count = $raid_size;
        }
        if($fake_la){
            if ($raid_type eq "raid_dp") {
                $fake_add_disk_count = $disk_count-3;
                $disk_count = 3;
            } else {
                $fake_add_disk_count = $disk_count-2;
                $disk_count = 2;
            }
            if($fake_add_disk_count <= 0){
                logresult("FATAL", "RaidSqa_Cmode: Number of disks is not sufficient for creation of FAKE LA. Number of disks available for addition seems to be less.\n");
            }
        }

        my @spares_list = RaidSqa_get_disk_list_by_storage_type(host=>$host, conntype=>$conntype, spare_only=>"yes", storage_type=>$storage_type);
        my $spares_count = @spares_list;
        my $disk_count_check = $disk_count;

        # create a disk list from the disk_count, so that it can be passed to vol_create_args using -d option
        my $n = $disk_count;
        my @spare_used_list = ();
        while ($n > 0 ) {
        $n--;
        $spare_used_list[$n] = shift @spares_list;
        }

        if ((!$rpm) && ($aggr_type)) {
            $vol_create_args = "$vol_create_args" . " -disktype $storage_type -diskcount $disk_count";
        } elsif (($rpm) && ($aggr_type)) {
            $vol_create_args = "$vol_create_args" . " -disktype=>$storage_type -diskrpm $rpm -diskcount $disk_count";
        } elsif (!$aggr_type) {
            $vol_create_args = "$vol_create_args" . " -d @spare_used_list";
        }

        if ($disk_size) {
            $vol_create_args = "$vol_create_args" . " -disksize $disk_size";
        }

    }
	$vol_create_args = "$vol_create_args" . " -f"; 
    logcomment("RaidSqa_Cmode.pm: here is vol create args: $vol_create_args");
    logcomment("RaidSqa_Cmode.pm: create testing aggr/volume $filer_vol");

    if ($fake_la) {
        logcomment("RaidSqa_Cmode.pm: creating fake_la with 1st minimun number of disk and will add remaining disk after creating a hole ");
    }
    $server->cli(cmd=>"storage aggregate create $vol_create_args");

    sleep 30;

    # Check test aggr/volume got created
    my $raid_obj = new RaidInfo($conn);
    my $aggr_obj = $raid_obj->aggregate($filer_vol);

    if (!$aggr_obj) {
        logcomment("RaidSqa_Cmode.pm: Aggr creation appears to have failed.\n");
        return 0;
    }

    sleep 30;

    # wait for zeroing to finish
    RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol);

    if ($fake_la) {
        logcomment("RaidSqa_Cmode.pm: for fake_la creating a hole of $fake_vol_size TB and than adding remaining disks ");
        my $disk_size = int ($fake_vol_size * 1024 * 1024 * 256);
        if ($disk_list) {
            RaidSqa_aggr_add(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, disk_list=>\@fake_disk_add_list, options=>"-s $disk_size -f");
        } else{
            RaidSqa_aggr_add(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, disk_count=>$fake_add_disk_count, options=>"-s $disk_size");
        }
        }
        # Create flex volume in case test volume is aggr, having same name of aggregate with 3/4th of its size, except for fake_la
    if($aggr_type) {
        $raid_obj->refresh();
        $aggr_obj = $raid_obj->aggregate($filer_vol);
        my $junc_path = "/" . "$filer_vol";
        if($fake_la) {
            my $aggr_size_in_gb = $aggr_obj->parameter("raidsize") * 4 / (1024 * 1024) ;
            my $fake_vol_size_in_bytes = $fake_vol_size * 1024 * 1024 * 1024 * 1024;
            my $aggr_size_needed_in_gb = ($fake_vol_size_in_bytes * 3) / (100 * 1024 * 1024 * 1024);

            if ( $aggr_size_in_gb >= $aggr_size_needed_in_gb) {
                $server->cli(cmd=>"set -privilege test");
                $server->cli(cmd=>"volume create -vserver $vserver -volume $filer_vol -s none -aggregate $filer_vol -size $fake_vol_size_in_bytes  -security-style $security_style -unix-permissions $unix_permissions -junction-path $junc_path");
            } else {
                logcomment("RaidSqa_Cmode.pm: aggr $filer_vol size is $aggr_size_in_gb GB and to create fake_la of flex vol size $fake_vol_size TB, need aggr of size $aggr_size_needed_in_gb GB,  Now to run this test either use normal size disk or use more disk to create aggr ");
                return 0;
            }

        } else {
            my $size = 3072 * $aggr_obj->parameter("raidsize");
            $server->volume_create(vserver=>$vserver, volume=>$filer_vol, aggregate=>$filer_vol, size=>$size, 'security-style'=>$security_style, 'unix-permissions'=>$unix_permissions, 'junction-path'=>$junc_path);
        }
        sleep 5;

        $raid_obj->refresh();
        my $vol_obj = $raid_obj->volume("$filer_vol");

        if (!$vol_obj) {
            logcomment("RaidSqa_Cmode.pm: Flex volume creation appears to have failed.\n");
        return 0;
        } else {
            logcomment("RaidSqa_Cmode.pm: Aggr/flexvol creation is successful\n");
            return 1
        }

    }
}
#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_add

RaidSqa_aggr_add(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, group_name=>$group_name, disk_count=>$disk_count, disk_size=>$disk_size, disk_list=>$disk_list, disk_list1=>$disk_list1, options=>$options);

This subroutine add disks to an existing aggregate. You can use either disk_count or disk_count and disk_size or disk_list. Also if group_name is provided than it will add disk to that particular raidgroup. options is used to use either "-n" to get a command string instaed of actually adding or "-f" to force add disks. As mirror is not supported on Cmode there is no significance of disk_list1

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item group_name

(Optional) : Provide this if want to add disk this particular raid group. But disks will be added if raidsize allows to add disk to that particular raid group.

=item disk_count

(Optional) : Number of of disk to be add

=item disk_size

(Optional) : Size of the disks to be used for addition. This can be used only when disk_count is also defined. but can not be used along with disk_list.

=item disk_list

(Optional) : Reference to the list of disks to be add. Need to define at least one parameter from disk_count or disk_list. But can not defined both.

=item disk_list1

(Optional) : This is needed fro mirror aggr, but as it is not supported in cmode, we will ignore this.

=item options

(Optional):  This can have 2 values "-f" to force add disks and "-n" to get a comamnd string instaed of actually adding disks.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_add {

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                group_name => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_count => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_size => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef,optional=>1 },
                                disk_list1 => { type=>ARRAYREF|UNDEF, default=>undef,optional=>1 },
                                options => { type=>SCALAR|UNDEF, default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $group_name = $opts{group_name};
        my $disk_count = $opts{disk_count};
        my $disk_size = $opts{disk_size};
        my $disk_list = $opts{disk_list};
   my @disk_list;
        my $disk_list1 = $opts{disk_list1};
        my $options = $opts{options};

   # create connection
        if($filermode ne "normal"){
                $conntype = "#console";
        }

   my $conn = make_conn($host,$conntype);

   # dereference array of disk_list if specified
   if (defined($disk_list)) {
      @disk_list = @$disk_list;
   }

   if ($disk_list1) {
      logcomment("RaidSqa_Cmode.pm: As mirror is not supported, there is no significance of $disk_list1 here, ignoring");
   }

   # check that user did not specified both disk_count and disk_list together
   if (defined($disk_count) && (@disk_list)) {
      logcomment("RaidSqa_Cmode.pm: Need to provide only one parameter disk_count or disk_list to aggr add argument");
      return 0;
   }

   my $aggr_add_args1;
   if (defined($group_name)) {
         $aggr_add_args1 = "-g $group_name";
   } else {
      $aggr_add_args1 = "";
   }

   my $aggr_add_args2;
   if (defined($disk_count)) {
      if (defined($disk_size)) {
         $aggr_add_args2="$aggr_add_args1 $disk_count\@$disk_size";
      } else {
         $aggr_add_args2="$aggr_add_args1 $disk_count";
      }
   } elsif (defined($disk_list)) {
      $aggr_add_args2="$aggr_add_args1 -d @disk_list";
   }
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   my $output;
   if (defined($options)) {
         $output = $server->cli(cmd=>"run local aggr add $filer_vol $options $aggr_add_args2");

        } else {
         $output = $server->cli(cmd=>"run local aggr add $filer_vol $aggr_add_args2");

      }

   sleep 20;

   # wait for zeroing to finish
        RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol);

        if ($output =~ /Couldn't add disks:/
        || $output =~ /Invalid set-of-disks specification/ || $output =~ /does not match type of other disks/) {
        logcomment("RaidSqa_Cmode.pm: Aggr/Volume disk addition is unsuccessful\n");
        return ($output,0);

    } else {
        logcomment("RaidSqa_Cmode.pm: Aggr/Volume disk addition is successful\n");
   return ($output,1);
    }
} ## end sub RaidSqa_aggr_add

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_rename

RaidSqa_aggr_rename(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, new_vol=>$new_vol);

This subroutine rename the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be renamed.

=item new_vol

(Required) : New name of aggregate.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_rename {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec'  },
            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
            conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => { type=>SCALAR },
            new_vol => { type=>SCALAR },
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $new_vol = $opts{new_vol};

   if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

        my $output = $server->cli(cmd=>"aggr rename -aggregate $filer_vol -newname $new_vol");

   sleep 5;
   my $raid_obj = new RaidInfo($conn);
   my $aggr_obj=$raid_obj->aggregate($new_vol);

   # Verifying if aggregate object exists for the renamed aggregate

   if ($aggr_obj) {
       return 1;
   } else {
       return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_offline

RaidSqa_aggr_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine offline the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be offlined.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional volume is not supported, hence we  will set it to 1 if provided as 0.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_offline {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        filer_vol => { type=>SCALAR },
        aggr_type => { type=>SCALAR, default=>1, optional=>1 },
                            }
                    );

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    if (!$aggr_type) {
        logcomment("RaidSqa_Cmode.pm: aggr_type as 0 is not supported in Cmode hence chnaging it to 1");
        $aggr_type=1;
    }

   my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

        logcomment("RaidSqa_Cmode.pm: offlining aggregate $filer_vol");

        # check aggr/volume exists
   if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
                logcomment("RaidSqa_Cmode.pm: aggr $filer_vol does not exists");
                return 0;
   } else {
                # offline aggr/volume
               RaidSqa_hammer_pause(host=>$host, conntype => $conntype);
                # $server->set_diagnostic(confirmations=>'off');
                $server->cli(cmd=>"set diagnostic -confirmations off");
                $server->storage_aggregate_modify(aggregate=>$filer_vol, state=>'offline');
                # $server->cli(cmd=>"run local \"priv set -q diag; aggr offline $filer_vol -a -f \" ");

                # check aggr came online successfully
                if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, state_name=>"offline", aggr_type=>$aggr_type)) {
                        logcomment("RaidSqa_Cmode.pm: aggr $filer_vol successfully offlined");
                        return 1;
                } else {
                        logcomment("RaidSqa_Cmode.pm: aggr $filer_vol could not be offlined");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_online

RaidSqa_aggr_online(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine online the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be onlined.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional is not supported, hence will set to 1 if 0 provided.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_online {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        filer_vol => { type=>SCALAR },
        aggr_type => { type=>SCALAR, default=>1, optional=>1 },
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    if (!$aggr_type) {
        logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
        $aggr_type = 1;
    }

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

        logcomment("RaidSqa_Cmode.pm: Onlining aggregate $filer_vol");

   # check aggr/volume exists
   if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
         logcomment("RaidSqa_Cmode.pm: aggr $filer_vol does not exists");
                return 0;
        } else {
      # online aggr/volume
      $server->storage_aggregate_modify(aggregate => $filer_vol,state=>'online');
         #my $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr online $filer_vol -f \" ");

      # check aggr came online successfully
      if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type, state_name=>"online")) {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol successfully onlined");
         return 1;
         } else {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol could not be onlined");
         return 0;
         }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_restrict

RaidSqa_aggr_restrict(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine restrict the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be restricted.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional is not supported, hence will set to 1 if 0 provided.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_restrict {
   my (%opts) = validate(@_,{
               host => { type=>OBJECT, isa=>'Hostrec' },
                  filermode => {type => SCALAR, default => "normal", optional => 1},
                  conntype  => {type => SCALAR, default => "#ssh", optional => 1},
                  filer_vol => {type => SCALAR},
                  aggr_type => {type => SCALAR, default =>1, optional => 1}
      }
   );

      my $host = $opts{host};
      my $filermode = $opts{filermode};
      my $conntype  = $opts{conntype};
      my $filer_vol = $opts{filer_vol};
      my $aggr_type = $opts{aggr_type};

      if ($filermode ne "normal") {
         $conntype = "#console";
      }

        my $conn = make_conn($host,$conntype);

        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
                $aggr_type = 1;
        }

      logcomment("RaidSqa_Cmode.pm: restricting the aggregate $filer_vol");
      my $server = new Server;
      $server->set_execution_server(-Server => $host->{hostname});
      if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type =>$aggr_type)) {
               logcomment("RaidSqa_Cmode.pm: aggr $filer_vol does not exists");
         return 0;
   } else {
               RaidSqa_hammer_pause(host=>$host, conntype => $conntype);
         $server->storage_aggregate_modify(aggregate => $filer_vol,state=>'restricted');
         if (RaidSqa_check_aggr_state_name(host=>$host,conntype=> $conntype,filer_vol=> $filer_vol,state_name=>"restricted", aggr_type =>$aggr_type)) {
         logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol successfully got restricted");
         return 1;
         } else {
         logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol could not be restricted");
         return 0;
         }
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_destroy

RaidSqa_aggr_destroy(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine delete an aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be destroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional is not supported, hence will set to 1 if 0 provided.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_destroy {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        filer_vol => { type=>SCALAR },
        aggr_type => {type => SCALAR, default =>1, optional => 1}});

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    if (!$aggr_type) {
        logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
        $aggr_type = 1;
    }

    logcomment("RaidSqa_Cmode.pm: deleting the aggregate $filer_vol");
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    if (RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
        my @vol;
        eval { @vol=$server->volume_show(aggregate => $filer_vol); };
        if ($@ =~ /There are no entries matching your query/) {
            $server->storage_aggregate_delete(aggregate => $filer_vol);
        } else {
            for my $vol (@vol) {
                $server->cli(cmd=>"volume unmount -volume $vol->{volume} -vserver $vol->{vserver}");
                logcomment("unmounted the volume:$vol->{volume}");
                $server->cli(cmd=>"volume offline -volume $vol->{volume} -vserver $vol->{vserver}");
                logcomment("offlined the volume:$vol->{volume}");
                $server->cli(cmd=>"volume delete  -volume $vol->{volume} -vserver $vol->{vserver}");
                logcomment("deleted the volume:$vol->{volume}");
            }
            $server->storage_aggregate_delete(aggregate => $filer_vol);
        }

        if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol deleted successfully");
            return 1;
        } else {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol could not be deleted");
            return 0;
        }
    } else {
        logcomment("RaidSqa_Cmode.pm: aggr $filer_vol does not exist");
        return 1;
    }
}

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_reparity_in_progress

RaidSqa_check_group_reparity_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group reparity is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_reparity_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

	# check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if ($group_obj->parameter("reparity_progress") ne "-1") {
			            logcomment("RaidSqa_Cmode.pm: raid group $group_name reparity is in progress");
                        return 1;
                } else {
			            logcomment("RaidSqa_Cmode.pm: raid group $group_name reparity is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
=head2 RaidSqa_aggr_remove

RaidSqa_aggr_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type => $aggr_type);

This subroutine delete an aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be destroyed.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional is not supported, hence will set to 1 if 0 provided.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_remove {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        filer_vol => { type=>SCALAR },
                 aggr_type => {type => SCALAR, default =>1, optional => 1}
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $aggr_type = $opts{aggr_type};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    if (!$aggr_type) {
        logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
        $aggr_type = 1;
    }
    logcomment("RaidSqa_Cmode.pm: deleting the aggregate $filer_vol");
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    if (RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
        if (!RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, state_name=>'online', aggr_type=>$aggr_type)) {
            if (!RaidSqa_aggr_online(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
                 logcomment("RaidSqa_Cmode.pm: aggr $filer_vol is not online, hence can not delete it as it can have flex vols in it");
              return 0;
            }
        }

        my @vol;
        eval { @vol=$server->volume_show(aggregate => $filer_vol); };
        if ($@ =~ /There are no entries matching your query/) {
            $server->storage_aggregate_delete(aggregate => $filer_vol);
        } else {
            for my $vol (@vol) {
                 $server->cli(cmd=>"volume unmount -volume $vol->{volume} -vserver $vol->{vserver}");
                 logcomment("unmounted the volume:$vol->{volume}");
                 $server->cli(cmd=>"volume offline -volume $vol->{volume} -vserver $vol->{vserver}");
                 logcomment("offlined the volume:$vol->{volume}");
                 $server->cli(cmd=>"volume delete  -volume $vol->{volume} -vserver $vol->{vserver}");
                 logcomment("deleted the volume:$vol->{volume}");
            }
            $server->storage_aggregate_delete(aggregate => $filer_vol);
        }
        if (!RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode,conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type)) {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol deleted successfully");
            return 1;
        } else {
            logcomment("RaidSqa_Cmode.pm: aggr $filer_vol could not be deleted");
            return 0;
        }
   } else {
        logcomment("RaidSqa_Cmode.pm: aggr $filer_vol does not exist");
        return 1;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_start

RaidSqa_hammer_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, iterations=>$iterations, file_name=>$file_name, file_size=>$file_size);

This subroutine start one hammer one a specified flex or trad volume with specified parameter on the filer.

return 1 if hammer started as needed and 0 if not.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of the test flex or trad volume.

=item iterations

(Optional): Number of iterations to run hammer. Default is "-1" which means always.

=item file_name

(Optional): Name of file to be created by hammer. Default is "HAMMER_9001"

=item file_size

(Optional): size of file to be created by hammer. Default is "-1" which means max capacity of flex or trad volume.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => {type=>SCALAR},
                                iterations => {type=>SCALAR,default=>"-1",optional=>1},
                                file_name => {type=>SCALAR,default=>"HAMMER_001",optional=>1},
                                file_size => {type=>SCALAR,default=>"-1",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $iterations = $opts{iterations};
        my $file_name = $opts{file_name};
        my $file_size = $opts{file_size};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # checking every 5 sec for a max time up to 5 minutes for hammer to start
        my($hammer_status) = "foo";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 300; # wait 5 minutes for hammer to abort
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
   my $file_name1 = $file_name.$$;
        my $o = $server->cli(cmd=>"run local \"priv set -q diag; hammer -f $iterations /vol/$filer_vol/$file_name1 $file_size \" ");

        while ($hammer_status !~  "/vol/$filer_vol/$file_name1" && $time_waited < $max_wait) {
         $hammer_status = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }
   if ($hammer_status =~ "/vol/$filer_vol/$file_name1") {
         logcomment("RaidSqa_Cmode.pm: hammer start on $filer_vol with filename $file_name1");
      return 1;
   } else {
         logcomment("RaidSqa_Cmode.pm: waited $time_waited seconds for hammer to start, but it could not start");
      return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_abort

RaidSqa_hammer_abort(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine abort all hammers on the filer.

return 1 if hammer abort and 0 if not.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_abort {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec'  },
            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                           conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # checking every 5 sec for a max time up to 5 minutes for hammer abort
        my($hammer_status) = "foo";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 300; # wait 5 minutes for hammer to abort
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $o = $server->cli(cmd=>"run local \"priv set -q diag; hammer abort \" ");

        #my($o) = say($conn, "priv -level -q diag; hammer abort", -timeout, $RaidSqa_TIMEOUT);
        while ($hammer_status ne "" && $time_waited < $max_wait) {
         $hammer_status = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");
                #$hammer_status = say($conn, "priv -level -q advanced; hammer status", -timeout, $RaidSqa_TIMEOUT);
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }
   if ($hammer_status eq "") {
         logcomment("RaidSqa_Cmode.pm: Hammer aborted");
      return 1;
   } else {
         logcomment("RaidSqa_Cmode.pm: waited $time_waited seconds for hammer to abort, but it failed to abort");
      return 0;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_pause

RaidSqa_hammer_pause(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine pause all hammers on the filer.

return 1 if hammer pause and 0 if not.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_pause {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec'  },
            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                           conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

   # checking every 5 sec for a max time up to 5 minutes for hammer pause
        my($hammer_status) = "foo";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 300; # wait 5 minutes for hammer to abort
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $o = $server->cli(cmd=>"run local \"priv set -q diag; hammer pause \" ");

        while ($hammer_status ne "" && $time_waited < $max_wait) {
         $hammer_status = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }
   if ($hammer_status eq "") {
         logcomment("RaidSqa_Cmode.pm: Hammer paused");
      return 1;
   } else {
         logcomment("RaidSqa_Cmode.pm: waited $time_waited seconds for hammer to pause, but it failed to pause");
      return 0;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_restart

RaidSqa_hammer_restart(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine restart all hammers on the filer.

return 1 if any hammer restart, 0 if no hammer restart.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_restart {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

   # checking every 5 sec for a max time up to 5 minutes for hammer  to restart
        my($hammer_status) = "";
        my($wait_interval) = 5;
        my($time_waited) = 0;
        my($max_wait) = 300; # wait 5 minutes for hammer to abort
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $o = $server->cli(cmd=>"run local \"priv set -q diag; hammer restart \" ");

        while ($hammer_status eq "" && $time_waited < $max_wait) {
         $hammer_status = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");
                $time_waited += $wait_interval;
                sleep $wait_interval;
        }
   if ($hammer_status eq "") {
         logcomment("RaidSqa_Cmode.pm: waited $time_waited seconds for hammer to restart, but it failed or there is no paused hammer to restart");
      return 0;
   } else {
         logcomment("RaidSqa_Cmode.pm: Hammer restared ");
      return 1;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_hammer_status

RaidSqa_hammer_status(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine give status of hammers on the filer.

return hammer status o/p.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_hammer_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

   # hammer status
        logcomment("RaidSqa_Cmode.pm: hammer status");
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $o = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");
   return $o;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_scrub_status

RaidSqa_aggr_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default provide scrub status on a given filer. But if any of the options from filer_vol, or group_name is specified than it start scrub on that particular raid object.
plex_name is not supported in Cmode

It returns scrub status o/p

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr .

=item plex_name

(Optional) : Name of plex. plex_name is not supported in Cmode, we just ignore it.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_aggr_scrub_status {
               my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $status;

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

        if ($filer_vol) {
            $status = $server->storage_aggregate_scrub(aggregate=>$filer_vol, action=>'status');
            # $status = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub status $filer_vol $options \" ");
            #my (undef,undef,$status) = say($conn, "priv -level -q advanced;aggr scrub status $filer_vol $options", -timeout, $RaidSqa_TIMEOUT);
            return $status;
        } elsif ($plex_name) {
            # $status = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub status $plex_name $options \" ");
            # my (undef,undef,$status) = say($conn, "priv -level -q advanced; aggr scrub status $plex_name $options", -timeout, $RaidSqa_TIMEOUT);
            logcomment("RaidSqa_Cmode.pm: In cmode we can not provide plex_name to scrub command, hence ignoring");
        } elsif ($group_name) {
       (undef, $filer_vol, $plex_name, my $group) = split("/", $group_name);
            $status = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", raidgroup=>"$group", action=>'status');
            # $status = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub status $group_name \" ");
             return $status;
        } else {
            $status = $server->storage_aggregate_scrub(aggregate=>'*', action=>'status');
            # $status = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub status $options \" ");
            return $status;
        }

}
#------------------------------------------------------------------------------
=head2 RaidSqa_aggr_scrub_start

RaidSqa_aggr_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default start scrub on a given filer. But if any of the options from filer_vol, or group_name is specified than it start scrub on that particular raid object.
plex_name is not supported in Cmode

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr .

=item plex_name

(Optional) : Name of plex. plex_name is not supported in Cmode, we just ignore it.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

   my @group_list;
   my $o;
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});


        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                #$o = $server->cli(cmd=>"storage aggregate scrub -aggregate $filer_vol -action start");
                $o = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", action=>'start');
        } elsif ($plex_name) {
               logcomment("RaidSqa_Cmode.pm: In cmode we can not provide plex_name to scrub command, hence ignoring");
        } elsif ($group_name) {
                @group_list= "$group_name";
      (undef, $filer_vol, $plex_name, my $group) = split("/", $group_name);
                $o = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", raidgroup=>"$group", action=>'start');
                # $o = $server->cli(cmd=>"storage aggregate scrub -raidgroup $group -action start,  -aggregate $filer_vol");
        } else {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
                $o = $server->storage_aggregate_scrub(aggregate=>'*', action=>'start');
                #$o = $server->cli(cmd=>"storage aggregate scrub -aggregate * -action start");
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") eq "-1") {
                        logcomment("RaidSqa_Cmode.pm: scrub could not start on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa_Cmode.pm: scrub started on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_scrub_stop

RaidSqa_aggr_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default stop all scrub on a given filer. But if any of the options from filer_vol, or group_name is specified than it stop scrub on that particular raid object.
plex_name is not supported in Cmode

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr .

=item plex_name

(Optional) : Name of plex. plex_name is not supported in Cmode, we just ignore it.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_stop {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
   my $o;
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   my @group_list;
        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                $o = $server->storage_aggregate_scrub(aggregate=>$filer_vol, action=>'stop');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub stop $filer_vol\" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub stop $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                # @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub stop $plex_name\" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub stop $plex_name", -timeout, $RaidSqa_TIMEOUT);
               logcomment("RaidSqa_Cmode.pm: In cmode we can not provide plex_name to scrub command, hence ignoring");
        } elsif ($group_name) {
                @group_list= "$group_name";
      (undef, $filer_vol, $plex_name, my $group) = split("/", $group_name);
                $o = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", raidgroup=>"$group", action=>'stop');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub stop $group_name\" ");
        } else {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
                $o = $server->storage_aggregate_scrub(aggregate=>'*', action=>'stop');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub stop \" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub stop ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") ne "-1") {
                        logcomment("RaidSqa_Cmode.pm: scrub could not stop on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa_Cmode.pm: scrub stopped on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_scrub_suspend

RaidSqa_aggr_scrub_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default suspend all scrub on a given filer. But if any of the options from filer_vol, or group_name is specified than it suspend scrub on that particular raid object.
plex_name is not supported in Cmode

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex. plex_name is not supported in Cmode, we just ignore it.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_suspend {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
   my $o;

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

   my @group_list;
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});


        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                $o = $server->storage_aggregate_scrub(aggregate=>$filer_vol, action=>'suspend');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend $filer_vol \" ");
                #(undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                # @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend $plex_name \" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend $plex_name", -timeout, $RaidSqa_TIMEOUT);
               logcomment("RaidSqa_Cmode.pm: In cmode we can not provide plex_name to scrub command, hence ignoring");
        } elsif ($group_name) {
                @group_list= "$group_name";
      (undef, $filer_vol, $plex_name, my $group) = split("/", $group_name);
                $o = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", raidgroup=>"$group", action=>'suspend');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend $group_name \" ");
        } else {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
                $o = $server->storage_aggregate_scrub(aggregate=>'*', action=>'suspend');
         # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend \" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") ne "-1") {
                        logcomment("RaidSqa_Cmode.pm: scrub could not suspend on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa_Cmode.pm: scrub suspended on raid_group $group");
                }
        }
        return ($o,1);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_scrub_resume

RaidSqa_aggr_scrub_resume(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default resume scrub on a given filer. But if any of the options from filer_vol, or group_name is specified than it resume scrub on that particular raid object.
plex_name is not supported in Cmode

It returns the command execution status(0/1) and output message.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex. plex_name is not supported in Cmode, we just ignore it.

=item group_name

(Optional) : Name of group.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_scrub_resume {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
   my $o;

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
   my @group_list;
        if ($filer_vol) {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
                $o = $server->storage_aggregate_scrub(aggregate=>$filer_vol, action=>'resume');
                # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend $filer_vol \" ");
                #(undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        } elsif ($plex_name) {
                # @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
                # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend $plex_name \" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend $plex_name", -timeout, $RaidSqa_TIMEOUT);
                logcomment("RaidSqa_Cmode.pm: In cmode we can not provide plex_name to scrub command, hence ignoring");
        } elsif ($group_name) {
                @group_list= "$group_name";
      (undef, $filer_vol, $plex_name, my $group) = split("/", $group_name);
                $o = $server->storage_aggregate_scrub(aggregate=>"$filer_vol", raidgroup=>"$group", action=>'resume');
                # $o = $server->storage_aggregate_scrub(raidgroup=>$group_name, action=>'resume');
        } else {
                @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
                $o = $server->storage_aggregate_scrub(aggregate=>'*', action=>'resume');
                # $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr scrub suspend \" ");
                # (undef,undef,$o) = say($conn, "priv -level -q advanced; aggr scrub suspend ", -timeout, $RaidSqa_TIMEOUT);
        }
        sleep 20;
        my $raid_obj=new RaidInfo($conn);

        my $group;
        # Check if the group list is valid

        if (  ! ( @group_list ) )
        {
           return ($o,1);
        }

        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("scrub_progress") eq "-1") {
                        logcomment("RaidSqa_Cmode.pm: scrub could not resume on raid_group $group");
                        return ($o,0);
                } else {
                        logcomment("RaidSqa_Cmode.pm: scrub resumed on raid_group $group");
                }
        }
        return ($o,1);


}

#------------------------------------------------------------------------------
=head2 RaidSqa_aggr_media_scrub_start

RaidSqa_aggr_media_scrub_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

This subroutine by default start media_scrub on a given filer. But if any of the options from filer_vol, plex_name, group_name or disk_name is specified than it start media_scrub on that particular raid object.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=item disk_name

(Optional) : Name of disk.


=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_media_scrub_start {
      my (%opts) = validate(@_, {
         host => { type=>OBJECT, isa=>'Hostrec' },
                  filermode => {type => SCALAR, default => "normal", optional => 1},
                  conntype => {type => SCALAR, default => "#ssh", optional => 1},
                  filer_vol => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  plex_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  group_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  disk_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
         }
      );

      my $host       = $opts{host};
      my $filermode  = $opts{filermode};
      my $conntype   = $opts{conntype};
      my $filer_vol  = $opts{filer_vol};
      my $plex_name  = $opts{plex_name};
      my $group_name = $opts{group_name};
      my $disk_name = $opts{disk_name};
      my $ret_val    = 0;
      my $o;
      my @group_list;

      if ($filermode ne "normal") {
         $conntype = "#console";
      }


      my $conn = make_conn($host, $conntype);

      my $server= new Server;
      $server->set_execution_server(-Server => $host->{hostname});

      my $output1 = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable \" ");
      my @output1 = split(/\r?\n/, $output1);
      if (grep(/on/, @output1)) {
         logcomment( "RaidSqa_Cmode.pm: Media scrubbing is currently enabled on this system");
      } else {
         $ret_val = 0;
         goto AGGR_MEDIA_SCRUB_START_EXIT;
      }

      if ($filer_vol) {
            if(RaidSqa_check_aggr_exist(host=>$host, filer_vol=>$filer_vol)){
            @group_list = RaidSqa_get_group_list(host=>$host,filer_vol=>$filer_vol);
         }
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub start $filer_vol\" ");
      } elsif ($plex_name) {
            if(RaidSqa_check_plex_exist(host=>$host, plex_name=>$plex_name)){
               @group_list = RaidSqa_get_group_list(host=>$host,plex_name=>$plex_name);
            }
            $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub start $plex_name\" ");
      } elsif ($group_name) {
         @group_list = $group_name;
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub start $group_name\" ");
      } elsif ($disk_name) {
         if (defined($disk_name)) {
             my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
             if ($disk_active_path_name) {
                logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
                $disk_name = $disk_active_path_name;
             } else {
                logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
                return 0;
             }
         }
         @group_list = $disk_name;
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub start -s $disk_name\" ");
      } else {
            my @aggr_list = RaidSqa_get_aggr_list(host=>$host);

            foreach my $aggr_list (@aggr_list) {
                  if (RaidSqa_check_aggr_state_name(host=>$host, filer_vol => $aggr_list, state_name => "online")) {
                     @group_list = RaidSqa_get_group_list(host=>$host,filer_vol=>$aggr_list);
                  }
         }
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub start \" ");
      }

      if ( ($o =~ /No/) || ($o =~ /Invalid/) || ($o =~ /Illegal/) ) {
         goto AGGR_MEDIA_SCRUB_START_EXIT;
      }

      foreach my $group_list (@group_list) {
         if($o !~ /enabled background media scrub of $group_list/) {
                  goto AGGR_MEDIA_SCRUB_START_EXIT;
         }
      }
      $ret_val = 1;

   AGGR_MEDIA_SCRUB_START_EXIT:
      return $ret_val;

}

#------------------------------------------------------------------------------
=head2 RaidSqa_aggr_media_scrub_status

RaidSqa_aggr_media_scrub_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

This subroutine by default provide media_scrub status on a given filer. But if any of the options from filer_vol, plex_name, group_name or disk_name is specified than it provide media_scrub status on that particular raid object.

It returns nothing but just the media_scrub status o/p

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=item disk_name

(Optional) : Name of disk.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_aggr_media_scrub_status {
      my (%opts) = validate(@_,{
                  host => { type => OBJECT, isa => 'Hostrec' },
                  filermode => {type => SCALAR, default => "normal", optional => 1},
                  conntype => {type => SCALAR, default => "#ssh", optional => 1},
                  filer_vol => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  plex_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  group_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  disk_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
         }
      );

      my $host       = $opts{host};
      my $filermode  = $opts{filermode};
      my $conntype   = $opts{conntype};
      my $filer_vol  = $opts{filer_vol};
      my $plex_name  = $opts{plex_name};
      my $group_name = $opts{group_name};
      my $disk_name = $opts{disk_name};
      my $o;
      my @group_list;

      if ($filermode ne "normal") {
         $conntype = "#console";
      }


      my $conn = make_conn($host, $conntype);

      my $server= new Server;
      $server->set_execution_server(-Server => $host->{hostname});

      if ($filer_vol) {
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub status $filer_vol\" ");
      } elsif ($plex_name) {
            $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub status $plex_name\" ");
      } elsif ($group_name) {
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub status $group_name\" ");
      } elsif ($disk_name) {
         if (defined($disk_name)) {
             my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
             if ($disk_active_path_name) {
                logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
                $disk_name = $disk_active_path_name;
             } else {
                logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
                return 0;
             }
         }
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub status -s $disk_name\" ");
      } else {
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub status \" ");
      }

      return $o;
}

#------------------------------------------------------------------------------
=head2 RaidSqa_aggr_media_scrub_stop

RaidSqa_aggr_media_scrub_stop(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name);

This subroutine by default stop all media scrub on a given filer. But if any of the options from filer_vol, plex_name, group_name, or disk_name is specified than it stop media_scrub on that particular raid object.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr or trad vol.

=item plex_name

(Optional) : Name of plex.

=item group_name

(Optional) : Name of group.

=item disk_name

(Optional) : Name of disk.

=back

=cut
#------------------------------------------------------------------------------
sub RaidSqa_aggr_media_scrub_stop {
      my (%opts) = validate(@_,
                     {host => {type => SCALAR},
                  filermode => {type => SCALAR, default => "normal", optional => 1},
                  conntype => {type => SCALAR, default => "#ssh", optional => 1},
                  filer_vol => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  plex_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  group_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
                  disk_name => {type => SCALAR | UNDEF, default => undef, optional => 1},
         }
      );

      my $host       = $opts{host};
      my $filermode  = $opts{filermode};
      my $conntype   = $opts{conntype};
      my $filer_vol  = $opts{filer_vol};
      my $plex_name  = $opts{plex_name};
      my $group_name = $opts{group_name};
      my $disk_name = $opts{disk_name};
      my $ret_val    = 0;
      my $o;
      my @group_list;

      if ($filermode ne "normal") {
         $conntype = "#console";
      }


      my $conn = make_conn($host, $conntype);

      my $server= new Server;
      $server->set_execution_server(-Server => $host->{hostname});

      my $output1 = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable \" ");
      my @output1 = split(/\r?\n/, $output1);
      if (grep(/on/, @output1)) {
         logcomment( "RaidSqa_Cmode.pm: Media scrubbing is currently enabled on this system");
      } else {
         goto AGGR_MEDIA_SCRUB_START_EXIT;
      }

      if ($filer_vol) {
            if(RaidSqa_check_aggr_exist(host=>$host, filer_vol=>$filer_vol)){
            @group_list = RaidSqa_get_group_list(host=>$host,filer_vol=>$filer_vol);
         }
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub stop $filer_vol\" ");
      } elsif ($plex_name) {
            if(RaidSqa_check_plex_exist(host=>$host, plex_name=>$plex_name)){
               @group_list = RaidSqa_get_group_list(host=>$host,plex_name=>$plex_name);
            }
            $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub stop $plex_name\" ");
      } elsif ($group_name) {
         @group_list = $group_name;
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub stop $group_name\" ");
      } elsif ($disk_name) {
         if (defined($disk_name)) {
             my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
             if ($disk_active_path_name) {
                logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
                $disk_name = $disk_active_path_name;
             } else {
                logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
                return 0;
             }
         }
         @group_list = $disk_name;
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub stop -s $disk_name\" ");
      } else {
            my @aggr_list = RaidSqa_get_aggr_list(host=>$host);

            foreach my $aggr_list (@aggr_list) {
                  if (RaidSqa_check_aggr_state_name(host=>$host, filer_vol => $aggr_list, state_name => "online")) {
                     @group_list = RaidSqa_get_group_list(host=>$host,filer_vol=>$aggr_list);
                  }
         }
         $o = $server->cli(cmd=>"run local \"priv set -q diag;  aggr media_scrub stop \" ");
      }

      if ( ($o =~ /No/) || ($o =~ /Invalid/) || ($o =~ /Illegal/) ) {
         goto AGGR_MEDIA_SCRUB_START_EXIT;
      }

      foreach my $group_list (@group_list) {
         if($o !~ /disabled background media scrub of $group_list/) {
                  goto AGGR_MEDIA_SCRUB_START_EXIT;
         }
      }
      $ret_val = 1;

   AGGR_MEDIA_SCRUB_START_EXIT:
      return $ret_val;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_options

RaidSqa_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, options=>$options, value=>$value);

This subroutine set various options specified by options parameter to a value specified by value parameter for a given aggregate.

It returns 1 on pass and 0 on fail

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggr.

=item options

(Required) : Name of options or trad set or change.

=item value

(Required) : value of the options.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_aggr_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR},
                                options => {type=>SCALAR},
                                value => {type=>SCALAR},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};
        my $value = $opts{value};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


      my $conn = make_conn($host, $conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; aggr options $filer_vol $options $value \" ");
        #$server->cli(cmd=>"set diagnostic -confirmations off");
        #my $output = $server->storage_aggregate_options(aggergate => $filer_vol, $options => $value);

   if (RaidSqa_get_aggr_options(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol, options=>$options) eq "$value") {
      return 1;
   } else {
      return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_zero_spares

RaidSqa_disk_zero_spares(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine start zeroing on all notzeroed spares.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_zero_spares {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   # starting zeroing on all spares
        logcomment("RaidSqa_Cmode.pm: starting zeroing in spare disk.");
        #my($o) = say($conn, "disk zero spares", -timeout, $RaidSqa_TIMEOUT);
        my $o = $server->cli(cmd=>"storage disk zerospares -owner $host->{hostname}");

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_remove

RaidSqa_disk_remove(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine remove the one spare disk or all spare disks from spare list and move them to broken list nonpersistantly.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of spare disk to remove, if all than it will remove all spare disks.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_disk_remove {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

        my $raid_obj = new RaidInfo($conn);
   # removing all spare disks from raid if disk_name is given as "all"
        if ($disk_name eq "all" ) {
         my %spare_disks_hash = $raid_obj->spare_disks();
         my @spare_disks_list = keys(%spare_disks_hash);

                if (!@spare_disks_list) {
                        logcomment("RaidSqa_Cmode.pm: No spare Disk in system.");
                        return 1;
                }

                logcomment("RaidSqa_Cmode.pm: Removing all spare disks : @spare_disks_list \n");

            my $disk;
                foreach $disk (@spare_disks_list) {
                        #my $disk_obj=$raid_obj->disk("$disk");
         #my $disk_path1=$disk_obj->parameter("path_name1");
         #my $disk_path2=$disk_obj->parameter("path_name2");
         my $disk_obj;
         my $disk_path1=$spare_disks_hash{$disk}{"path_name1"};
         my $disk_path2=$spare_disks_hash{$disk}{"path_name2"};
            #my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk remove $disk \" ");
            my $output = $server->cli(cmd=>"storage disk modify -state removed $disk ");
                        sleep 10;
                        $raid_obj->refresh();
                        sleep 10;
                        if (!($disk_obj=$raid_obj->disk("$disk_path1"))) {
            $disk_obj=$raid_obj->disk("$disk_path2");
         }
                        if ($disk_obj->parameter("fsm_state") ne "FAILED") {
                                logcomment("RaidSqa_Cmode.pm: Disk $disk could not be admin removed.");
                                return 0;
         } else {
                           logcomment("RaidSqa_Cmode.pm: Disk $disk successfully removed.");
                  }
                }

         $raid_obj->refresh();
         %spare_disks_hash = $raid_obj->spare_disks();
         @spare_disks_list = keys(%spare_disks_hash);

      # checking all spare disks has been removed
      if (!@spare_disks_list) {
                  logcomment("RaidSqa_Cmode.pm: There is no spare disk in the system");
                  return 1;

      } else {

         logcomment("RaidSqa_Cmode.pm: Filer still have some spare disks: @spare_disks_list \n");
         return 0;
      }

   } else {
      # removing a specified disk from raid

         #my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk remove $disk_name \" ");
         my $output = $server->cli(cmd=>"storage disk modify -state removed $disk_name ");
      #my (undef, undef,$output)=say($conn, "disk remove $disk_name", -timeout, $RaidSqa_TIMEOUT);
      sleep 10;

                if ($output =~ /broken pool/) {
                        logcomment("$disk_name is already in broken pool");
                        return 0;
                }

      if (!RaidSqa_check_disk_fsm_state(host=>$host, conntype=>$conntype, disk_name =>$disk_name, fsm_state=>"FAILED")) {
                  logcomment("RaidSqa_Cmode.pm: disk $disk_name is still not in failed (admin removed) state");
                     return 0;

      } else {
                  logcomment("RaidSqa_Cmode.pm: spare disk $disk_name removed from spare list");
         return 1;
      }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_fail

RaidSqa_disk_fail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, options=>$options);

This subroutine fail/prefail the disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to fail/prefail.

=item options

(Optional) : need to give as "-i" for disk fail otherwise disk will prefail.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_fail {
    my (%opts) = validate(@_, {
                            host => { type=>OBJECT, isa=>'Hostrec'  },
                            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                            conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                            disk_name => { type=>SCALAR },
                            options => { type=>SCALAR|UNDEF,default=>undef,optional=>1},
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $disk_name = $opts{disk_name};
    my $options = $opts{options};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    if (defined($disk_name)) {
        my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
        if ($disk_active_path_name) {
            logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name = $disk_active_path_name;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return 0;
        }
    }

    my $conn = make_conn($host,$conntype);

    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    my $raid_obj = new RaidInfo($conn);
    my $disk_obj = $raid_obj->disk("$disk_name");
    my $output;

    my $cmd = "storage disk fail -disk $disk_name ";
    if($options eq "-i") {
        $cmd .= " -immediate true";
    } elsif(defined($options)) {
        $cmd .= " $options";
    }
	
    # checking that specified disk is a file system disk before failing it
    if ($disk_obj->parameter("fsm_state") eq "INUSE") {
        $output = $server->cli(cmd=>"$cmd");
        sleep 10;
    } else {
        logcomment("RaidSqa_Cmode.pm: disk $disk_name is not a file system disk, so can not fail/prefail");
        return 0;
    }

    $raid_obj->refresh();
    $disk_obj = $raid_obj->disk("$disk_name");

    # check disk got failed/prefailed successfully
    if (!defined($options)) {
        if ($disk_obj->parameter("prefail") eq "1") {
            logcomment("RaidSqa_Cmode.pm: disk $disk_name got prefailed successfully");
            return 1;
        } else {
            logcomment("RaidSqa_Cmode.pm: Disk $disk_name could not be prefailed.");
            return 0;
        }

    } elsif ($options eq "-i") {
        if ($disk_obj->parameter("fsm_state") eq "FAILED") {
            logcomment("RaidSqa_Cmode.pm: disk $disk_name got failed successfully");
            return 1;
        } else {
            logcomment("RaidSqa_Cmode.pm: Disk $disk_name could not be failed.");
            return 0;
        }
    }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_unfail

RaidSqa_disk_unfail(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, options=>$options);

This subroutine unfail one failed disk or all failed disks. If no options given than it is just use "disk unfail" otherwise we can pass options "-s" to this function to make disk as spare in all cases.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of failed disk to unfail, if all than it will unfail all failed disks.

=item options

(Optional) : we can pass options "-s" if we want to spare out the failed disk.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_unfail {
    my (%opts) = validate(@_, {
                            host => { type=>OBJECT, isa=>'Hostrec'  },
                            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                            conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                            disk_name => { type=>SCALAR },
                            options => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $disk_name = $opts{disk_name};
    my $options = $opts{options};

    if($filermode ne "normal"){
        $conntype = "#console";
    }


    my $conn   = make_conn($host,$conntype);
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    my $raid_obj = new RaidInfo($conn);

    my $output;
   # if disk_name is given as "all" than unfail all disks using specified options like "-s" to make it spare or without "-s" to assimilate to previous state
    if ($disk_name eq "all" ) {
        my %failed_disks_hash = $raid_obj->failed_disks();
        my @failed_disks_list = keys(%failed_disks_hash);

        if (!@failed_disks_list) {
            logcomment("RaidSqa_Cmode.pm: No failed Disk in system.");
            return 1;
        }

        logcomment("RaidSqa_Cmode.pm: Unfailing all failed disks: @failed_disks_list \n");
        my $disk;
        foreach $disk (@failed_disks_list) {
            my $disk_obj;
            my $disk_path1 = $failed_disks_hash{$disk}{"path_name1"};
            my $disk_path2 = $failed_disks_hash{$disk}{"path_name2"};

            #my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk unfail $options $disk \" ");
            if ($options eq "-s") {
                $output = $server->cli(cmd=>"storage disk modify -state spare $disk");
            } else {
                $output = $server->cli(cmd=>"storage disk modify -state unfail $disk");
            }

            sleep 10;
            $raid_obj->refresh();
            sleep 10;
            if (!($disk_obj = $raid_obj->disk("$disk_path1"))) {
                $disk_obj = $raid_obj->disk("$disk_path2");
            }
            #my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("fsm_state") eq "FAILED") {
                logcomment("RaidSqa_Cmode.pm: Disk $disk could not be unfailed.");
                return 0;
            } else {
                logcomment("RaidSqa_Cmode.pm: Disk $disk successfully unfailed.");
            }
        }

        $raid_obj->refresh();
        %failed_disks_hash = $raid_obj->failed_disks();
        @failed_disks_list = keys(%failed_disks_hash);

        # check all disk got unfailed
        if (!@failed_disks_list) {
            logcomment("RaidSqa_Cmode.pm: There is no failed disk in the system");
            return 1;
        } else {
            logcomment("RaidSqa_Cmode.pm: Filer still have some failed disks: @failed_disks_list \n");
            return 0;
        }

    } else {
        if (defined($disk_name)) {
            my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
            if ($disk_active_path_name) {
                logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
                $disk_name = $disk_active_path_name;
            } else {
                logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
                return 0;
            }
        }
        # unfail a specified disk using specified options like "-s" to make it spare or without "-s" to assimilate to previous state
        if ($options eq "-s") {
            # $output = $server->cli(cmd=>"run local \"priv set -q diag; disk unfail $options $disk_name \" ");
            $output = $server->cli(cmd=>"storage disk modify -state spare $disk_name");
        } else {
            # $output = $server->cli(cmd=>"run local \"priv set -q diag; disk unfail $disk_name \" ");
            $output = $server->cli(cmd=>"storage disk modify -state unfail $disk_name");
        }
        sleep 10;
        $raid_obj->refresh();
        sleep 10;
        my $disk_obj = $raid_obj->disk("$disk_name");
        if ($disk_obj->parameter("fsm_state") eq "FAILED") {
            logcomment("RaidSqa_Cmode.pm: Disk $disk_name could not be unfailed.");
            return 0;
        } else {
            logcomment("RaidSqa_Cmode.pm: Disk $disk_name successfully unfailed.");
            return 1;
        }
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_replace_start

RaidSqa_disk_replace_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, replacing_disk => $replacing_disk, options=>$options);

This subroutine replace the disk with specified disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be replaced.

=item replacing_disk

(Required) : Name of disk to replace .

=item options

(Optional) : The option -m allows mixing disks with different characteristics.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_replace_start {
    my (%opts) =
      validate(@_,
               {host      => {type => OBJECT, isa     => 'Hostrec'},
                filermode => {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#ssh", optional => 1},
                disk_name => {type => SCALAR},
                replacing_disk => {type => SCALAR},
                options   => {type => SCALAR | UNDEF, default => undef, optional => 1},});

    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
    my $replacing_disk = $opts{replacing_disk};
    my $options = $opts{options};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);
    my $conn_console = make_conn($host,"#console");

    #Check if disk name exists or has an equivalent path_name2.
    if (defined($disk_name)) {
        my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $disk_name);
        if ($disk_active_path_name) {
            logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name = $disk_active_path_name;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    my $raid_obj = new RaidInfo($conn);
    my $disk_obj = $raid_obj->disk("$disk_name");
    my $output;

    #Check if replacing disk name exists or has an equivalent path_name2.
    if (defined($replacing_disk)) {
        my $replacing_disk1 = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $replacing_disk);
        if ($replacing_disk1) {
            logcomment("RaidSqa.pm: Using path name $replacing_disk1 for any operations on $replacing_disk.\n");
            $replacing_disk = $replacing_disk1;
        } else {
            logcomment("RaidSqa.pm: The disk name $replacing_disk specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    # checking that specified disk is a file system disk before replacing it
    if ($disk_obj->parameter("fsm_state") eq "INUSE") {
        if (defined($options)) {
            $output = say($conn_console, "run local disk replace start -f $options $disk_name $replacing_disk", -timeout, $RaidSqa_TIMEOUT);
            sleep 10;
        } else {
            $output = say($conn_console, "run local disk replace start -f $disk_name $replacing_disk", -timeout, $RaidSqa_TIMEOUT);
            sleep 10;
        }

    } else {
        logcomment("RaidSqa.pm: disk $disk_name is not a file system disk, so can not replace");
        return 0;
    }

    #Check if disk name exists after replace or has an equivalent path_name2.
    if (defined($disk_name)) {
        my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host => $host, filermode => $filermode, conntype => $conntype, disk_name => $disk_name);
        if ($disk_active_path_name) {
            logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name = $disk_active_path_name;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return (0);
        }
    } ## end if (defined($disk_name...

    $raid_obj->refresh();
    $disk_obj = $raid_obj->disk("$disk_name");

    # check disk got replaced successfully
        if ($disk_obj->parameter("replace") eq "1") {
            logcomment("RaidSqa.pm: disk $disk_name got replaced successfully");
            return 1;
        } else {
            logcomment("RaidSqa.pm: Disk $disk_name could not be replaced with disk $replacing_disk");
            return 0;
        }

} 

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_offline

RaidSqa_disk_offline(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, options=>$options);

This subroutine offline the disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to offline.

=item options

(Optional) : bdfu or timeout.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_offline {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
            options => { type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }
 
	if (defined($disk_name)) {
            my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
            if ($disk_active_path_name) {
               logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
               $disk_name = $disk_active_path_name;
            } else {
               logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
               return 0;
            }
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   if (!defined($options)) {
         my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk offline $disk_name \" ");
        #   my $output=say($conn, "priv set -q diag;disk offline $disk_name", -timeout, $RaidSqa_TIMEOUT);
   } else {
         my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk offline -t $options $disk_name \" ");
        #   my $output=say($conn, "priv set -q diag;disk offline -t $options $disk_name", -timeout, $RaidSqa_TIMEOUT);
   }

   if (defined($disk_name)) {
         my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
         if ($disk_active_path_name) {
            logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name = $disk_active_path_name;
         } else {
            logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return 0;
         }
   }

   sleep 10;
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");

   # check disk got offlined
   if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
                  logcomment("RaidSqa_Cmode.pm: disk $disk_name got offline successfully");
                  return 1;
   } else {
                  logcomment("RaidSqa_Cmode.pm: Disk $disk_name could not be offlined.");
      return 0;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_online

RaidSqa_disk_online(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine online one disk or all offline disks if disk name is given as "all".

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to online. if all than online all offline disks in filer

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_online {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   my $raid_obj = new RaidInfo($conn);

   if ($disk_name eq "all") {
      my @offline_disks=RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, fsm_state=>"OFFLINE");
      my $disk;
      foreach $disk (@offline_disks) {

         if (defined($disk)) {
             my $disk1 = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk);
             if ($disk1) {
                logcomment("RaidSqa_Cmode.pm: Using path name $disk1 for any operations on $disk.\n");
                $disk = $disk1;
             } else {
                logcomment("RaidSqa_Cmode.pm: The disk_name $disk specified does not exist. Please check again.\n");
                return 0;
             }
         }
       my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk online $disk \" ");
#              my $output=say($conn, "priv set -q diag;disk online $disk", -timeout, $RaidSqa_TIMEOUT);
         sleep 10;
         $raid_obj->refresh();
         my $disk_obj = $raid_obj->disk("$disk");

         # check disk got onlined
         if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
                        logcomment("RaidSqa_Cmode.pm: Disk $disk still offlined.");
            return 0;
         } elsif (($disk_obj->parameter("fsm_state") eq "RECONS") || ($disk_obj->parameter("fsm_state") eq "INUSE") || ($disk_obj->parameter("fsm_state") eq "ZEROED") || ($disk_obj->parameter("fsm_state") eq "NOTZEROED")) {
                        logcomment("RaidSqa_Cmode.pm: disk $disk got online successfully");
         } else {
                        logcomment("RaidSqa_Cmode.pm: Disk $disk could not be onlined.");
            return 0;
            }
      }
      return 1;
   } else {

      if (defined($disk_name)) {
          my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
          if ($disk_active_path_name) {
             logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
             $disk_name = $disk_active_path_name;
          } else {
             logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
             return 0;
          }
      }
      my $output = $server->cli(cmd=>"run local \"priv set -q diag; disk online $disk_name \" ");
#           my $output=say($conn, "priv set -q diag;disk online $disk_name", -timeout, $RaidSqa_TIMEOUT);
      sleep 10;

      my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
      if ($disk_active_path_name) {
        logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
        $disk_name = $disk_active_path_name;
      }
      $raid_obj->refresh();
      my $disk_obj = $raid_obj->disk("$disk_name");

      # check disk got onlined
      if ($disk_obj->parameter("fsm_state") eq "OFFLINE") {
                     logcomment("RaidSqa_Cmode.pm: Disk $disk_name still offlined.");
         return 0;
         } elsif (($disk_obj->parameter("fsm_state") eq "RECONS") || ($disk_obj->parameter("fsm_state") eq "INUSE") || ($disk_obj->parameter("fsm_state") eq "ZEROED") || ($disk_obj->parameter("fsm_state") eq "NOTZEROED")) {
                     logcomment("RaidSqa_Cmode.pm: disk $disk_name got onlined successfully");
                     return 1;
      } else {
                     logcomment("RaidSqa_Cmode.pm: Disk $disk_name could not be onlined.");
         return 0;
         }
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_mung

RaidSqa_disk_mung(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, sector=>$sector, bits=>$bits);

This subroutine mung a sector(block) of disks. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of the disk.

=item sector

(Required): sector number of disk.

=item bits

(Optional): Number of consecutive bits to mung.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_mung {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                sector => { type=>SCALAR },
                                bits => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $sector = $opts{sector};
        my $bits = $opts{bits};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
        if ($disk_active_path_name) {
            logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	    $disk_name = $disk_active_path_name;
        } else {
	    logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	    return 0;
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
   my $output;

   if (defined($bits)) {
         $output = $server->cli(cmd=>"run local \"priv set -q test; disk_mung $disk_name $sector $bits \" ");
   #  (undef,undef,$output)=say($conn, "priv set -q test; disk_mung $disk_name $sector $bits ", -timeout, $RaidSqa_TIMEOUT);
   } else {
         $output = $server->cli(cmd=>"run local \"priv set -q test; disk_mung $disk_name $sector \" ");
   #  (undef,undef,$output)=say($conn, "priv set -q test; disk_mung $disk_name $sector ", -timeout, $RaidSqa_TIMEOUT);
   }

        if ($output =~ /scsi_write_long succeeded on block $sector/ ) {
                return 1;
        } else {
                return 0;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_assign

RaidSqa_disk_assign(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, disk_list=>\@disk_list, pool=>$pool);

This subroutine assign one or more disk to filer in defined pool.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): name of disk. (but any one of disk_list or disk_name is required)

=item disk_list

(Optional): refrence to the list of disk (but any one of disk_list or disk_name is required)

=item pool

(Required): pool 0 or 1 .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_assign {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef, optional=>1  },
                                disk_name => { type=>SCALAR|UNDEF, default=>undef, optional=>1  },
                                pool => { type=>SCALAR,default=>0,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $disk_list = $opts{disk_list};
        my $pool = $opts{pool};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});


   if (!defined($disk_name) && !defined($disk_list)) {
      logcomment("RaidSqa_Cmode.pm: None of the parameter $disk_list or $disk_name defined, need to define one of them \n");
      return 0;
   } elsif (defined($disk_name) && defined($disk_list))  {
      logcomment("RaidSqa_Cmode.pm: Both of the parameter $disk_list or $disk_name defined, need to define only one of them \n");
      return 0;
   }


   my $output;

   if (defined($disk_name)) {
         $server->cli(cmd=>"run local \"priv set -q diag; disk assign -f  -p $pool $disk_name \" ");
      #say($conn, "priv set -q diag; disk assign -f  -p $pool $disk_name", -timeout, $RaidSqa_TIMEOUT);
      return 1;
   } elsif (defined($disk_list)) {
         my @disk_list = @$disk_list;
         $server->cli(cmd=>"run local \"priv set -q diag; disk assign -f  -p $pool @disk_list \" ");
      #say($conn, "priv set -q test; disk assign -f  -p $pool @disk_list", -timeout, $RaidSqa_TIMEOUT);

      return 1;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_disk_remove_ownership

RaidSqa_disk_remove_ownership(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, disk_list=>\@disk_list);

This subroutine remove_ownership of one or more disk from filer .

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): name of disk. (but any one of disk_list or disk_name is required)

=item disk_list

(Optional): refrence to the list of disk (but any one of disk_list or disk_name is required)

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_disk_remove_ownership {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF, default=>undef, optional=>1  },
                                disk_name => { type=>SCALAR|UNDEF, default=>undef, optional=>1  },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $disk_list = $opts{disk_list};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});


   if (!defined($disk_name) && !defined($disk_list)) {
      logcomment("RaidSqa_Cmode.pm: None of the parameter $disk_list or $disk_name defined, need to define one of them \n");
      return 0;
   } elsif (defined($disk_name) && defined($disk_list))  {
      logcomment("RaidSqa_Cmode.pm: Both of the parameter $disk_list or $disk_name defined, need to define only one of them \n");
      return 0;
   }


   if (defined($disk_name)) {
     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }
         $server->cli(cmd=>"run local \"priv set -q diag; disk remove_ownership -f  $disk_name \" ");
   #  say($conn, "priv set -q diag; disk remove_ownership -f  $disk_name", -timeout, $RaidSqa_TIMEOUT);
      return 1;
   } elsif (defined($disk_list)) {
         my @disk_list = @$disk_list;
         $server->cli(cmd=>"run local \"priv set -q test; disk remove_ownership -f  @disk_list \" ");
   #  say($conn, "priv set -q test; disk remove_ownership -f  @disk_list", -timeout, $RaidSqa_TIMEOUT);
      return 1;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_setflag

RaidSqa_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name, flag_value=>$flag_value);

This subroutine set flags using setflag command. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item flag_name

(Required): Name of the flag to add.

=item flag_value

(Required): Value of the flag to add.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_setflag {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                flag_name => { type=>SCALAR },
                                flag_value => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $flag_name = $opts{flag_name};
        my $flag_value = $opts{flag_value};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        # Adding specified flag using setflag command
        my $output = $server->cli(cmd=>"run local \"priv set -q test; setflag $flag_name $flag_value \" ");
        #my $output;
        #(undef,undef,$output)=say($conn, "priv set -q test; setflag $flag_name $flag_value", -timeout, $RaidSqa_TIMEOUT);
   logcomment("RaidSqa_Cmode.pm: setflag $flag_name $flag_value set \n");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_set_options

RaidSqa_set_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name, option_value=>$option_value);

This subroutine set options on filer using options command.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item option_name

(Required): Name of the option to change.

=item option_value

(Required): Value of the option to change.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_set_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                option_name => { type=>SCALAR },
                                option_value => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_name = $opts{option_name};
        my $option_value = $opts{option_value};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        # changing options value using options command
        my $output = $server->cli(cmd=>"run local \"priv set -q test; options $option_name $option_value \" ");
#        my $output;
#        (undef,undef,$output)=say($conn, "priv set -q test; options $option_name $option_value", -timeout, $RaidSqa_TIMEOUT);
   logcomment("RaidSqa_Cmode.pm: options $option_name $option_value set \n");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_license_add_by_code

RaidSqa_license_add_by_code(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine add license using a particular code. It does not check the platform or any thing.

return 1 on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item code

(Required): Particular code for license to add.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_license_add_by_code {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                code => { type=>SCALAR },
                                }
                        );
        my $code  = $opts{code};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; license add $code \" ");

#  my $output;
#  (undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);
   return 1;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_license_add_by_service

RaidSqa_license_add_by_service(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine add license for a particular service. Need a non-promoted debug build as 1st get code for that particular service for particular platform and than add that code.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to add license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_license_add_by_service {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $service  = $opts{service};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $output;
   my $line;
   my @info;
   my $code ="0";
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   # Adding license for a specified service by getting it using secret_code for legacy platforms
        $output = $server->cli(cmd=>"run local \"priv set -q test; secret_code 1 $service \" ");
   #(undef,undef,$output)=say($conn, "priv set -q test; secret_code 1 $service", -timeout, $RaidSqa_TIMEOUT);
   @info = split(/\r?\n/, $output);
   foreach $line (@info){
      if ($line =~ /$service/  && $line =~ /(.*)=(.*)/ ) {
        $code=$2;
        logcomment("RaidSqa_Cmode.pm: lic for $service is: $code. \n");
       }
   }
   if ($code eq "0" ) {
      logresult('FATAL', "There's no such service: $service exists. \n");
      exit;
   }

   $output = $server->cli(cmd=>"run local \"priv set -q diag; license add $code \" ");
   #(undef,undef,$output) = say ($conn, "priv set -q diag; license add $code");

   # Adding license for a specified service by getting it using secret_code for Gateway
   if ($output =~ /invalid platform/ ) {
      $output = $server->cli(cmd=>"run local \"priv set -q test; secret_code -p Gateway 1 $service \" ");
      #(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p Gateway 1 $service", -timeout, $RaidSqa_TIMEOUT);
      @info = split(/\r?\n/, $output);
      foreach $line (@info){
        if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
          $code=$2;
        }
       }
   }
   $output = $server->cli(cmd=>"run local \"priv set -q diag; license add $code \" ");
   #(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);

   # Adding license for a specified service by getting it using secret_code for NearStore
   if ($output =~ /invalid platform/ ) {
      $output = $server->cli(cmd=>"run local \"priv set -q test; secret_code -p NearStore 1 $service \" ");
      #(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p NearStore 1 $service", -timeout, $RaidSqa_TIMEOUT);
      @info = split(/\r?\n/, $output);
      foreach $line (@info){
        if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
          $code=$2;
        }
       }
   }
   $output = $server->cli(cmd=>"run local \"priv set -q diag; license add $code \" ");
   #(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);

   # Adding license for a specified service by getting it using secret_code for simulator
   if ($output =~ /invalid platform/ ) {
      $output = $server->cli(cmd=>"run local \"priv set -q test; secret_code -p SIM 1 $service \" ");
      #(undef,undef,$output) = say($conn, "priv set -q test; secret_code -p SIM 1 $service", -timeout, $RaidSqa_TIMEOUT);
      @info = split(/\r?\n/, $output);
      foreach $line (@info){
        if ($line =~ /$service/ && $line =~ /(.*)=(.*)/ ) {
          $code=$2;
        }
       }
   }
   $output = $server->cli(cmd=>"run local \"priv set -q diag; license add $code \" ");
   #(undef,undef,$output) = say($conn, "priv set -q diag; license add $code", -timeout, $RaidSqa_TIMEOUT);

}

#------------------------------------------------------------------------------

=head2 RaidSqa_license_delete

RaidSqa_license_delete(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine delete license for a particular service.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to delete license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_license_delete {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $service  = $opts{service};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   #my $output;
   #(undef,undef,$output) = say($conn, "priv set -q diag; license delete $service", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; license delete $service \" ");

   if (RaidSqa_check_license(host=>$host, conntype=>$conntype, service=>$service)) {
      return 0;
   } else {
      return 1;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_filter

RaidSqa_fiji_filter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine add a defined fiji filter to the filer.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to add to the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_filter {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   #my $output;
   #(undef,undef,$output) = say($conn, "priv set -q diag; fiji filter \"$fiji_point\" ", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji filter '$fiji_point' \" ");

   if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
      return 1;
   } else {
      return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_nvfilter

RaidSqa_fiji_nvfilter(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine add a defined fiji nvfilter to the filer.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to add to the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_nvfilter {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   #my $output;
   #(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvfilter \"$fiji_point\" ", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji nvfilter \"$fiji_point\" \" ");

   if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
      return 1;
   } else {
      return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_clear

RaidSqa_fiji_clear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine clear a defined fiji filter from the filer. Use all  as fiji point for clearing all fiji filter

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to clear from the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_clear {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $output;
   my $slot;
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   if ($fiji_point eq "all") {
         $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji clear all\" ");
      #(undef,undef,$output) = say($conn, "priv set -q diag; fiji clear all", -timeout, $RaidSqa_TIMEOUT);
   } else {
      my @fiji_slot=RaidSqa_get_fiji_slot(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point);
      foreach $slot (@fiji_slot) {
            $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji clear $slot\" ");
         #(undef,undef,$output) = say($conn, "priv set -q diag; fiji clear $slot ", -timeout, $RaidSqa_TIMEOUT);
      }

   }
   if (RaidSqa_check_fiji(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point)) {
      return 0;
   } else {
      return 1;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_nvclear

RaidSqa_fiji_nvclear(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine nvclear a defined fiji nvfilter from the filer. Give fiji_point as all if want to delete all fiji filters.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point which we want to nvclear from the filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_nvclear {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point  = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $output;
   my $slot;
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});


   if ($fiji_point eq "all") {
         $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji nvclear all\" ");
      #(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvclear all", -timeout, $RaidSqa_TIMEOUT);
      if ($output =~ /filter cleared/) {
         logcomment("RaidSqa_Cmode.pm : fiji: filter cleared (nvram only) from slot $slot");
      } else {
         logcomment("RaidSqa_Cmode.pm : fiji: filter not cleared (nvram only) from slot $slot");
         return 0;
      }
   } else {
      my @fiji_slot=RaidSqa_get_fiji_slot(host=>$host, conntype=>$conntype, fiji_point=>$fiji_point);
      foreach $slot (@fiji_slot) {
            $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji nvclear $slot\" ");
         #(undef,undef,$output) = say($conn, "priv set -q diag; fiji nvclear $slot ", -timeout, $RaidSqa_TIMEOUT);
         if ($output =~ /filter cleared/) {
            logcomment("RaidSqa_Cmode.pm : fiji: filter cleared (nvram only) from slot $slot");
         } else {
            logcomment("RaidSqa_Cmode.pm : fiji: filter not cleared (nvram only) from slot $slot");
            return 0;
         }
      }
   }
   return 1;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_fiji_show

RaidSqa_fiji_show(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets o/p of fiji show command and show all fiji filters/nvfilter set on the filer.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_fiji_show {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        #my $output;
        #(undef, undef, $output)=say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji show \" ");

        my @fiji_show= split(/\r?\n/, $output);
        return @fiji_show;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_nv_trash

RaidSqa_nv_trash(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine Trash nvram to cause a panic with nvram loss so that there is reparity on boot.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_nv_trash {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

         $conntype = "#console";

        my $conn = make_conn($host,$conntype);

        my $output;
   #(undef, undef, $output) = say($conn, "priv set -q test; nv_trash toc all 0x12345678", "-noprompt","-timeout",$RaidSqa_TIMEOUT,"-prompt", "previous shutdown was dirty, there is a possible loss of data");
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        $output = $server->cli(cmd=>"run local \"priv set -q test; nv_trash toc all 0x12345678 \" ");

}

#------------------------------------------------------------------------------

=head2 RaidSqa_savecore

RaidSqa_savecore(host=>$host, filermode=>$filermode, conntype=>$conntype, options=>$options);

This subroutine run savecore command with various options provided by user.

It returns output of command.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item options

(Optional): Options of savecore command.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_savecore {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                options => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }
        my $conn = make_conn($host,$conntype);

        #my $output;
   #(undef, undef, $output) = say($conn, "priv set -q diag; savecore $options",-timeout,$RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; savecore $options \" ");

   return $output;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_media_scrub_disable

RaidSqa_media_scrub_disable(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine disable the media_scrub on filer by turning off the raid options raid.media.scrub.enable

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_media_scrub_disable {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my ($output, $output1, @output1);
   #(undef, undef, $output) = say($conn, "priv set -q diag; options raid.media_scrub.enable off", "-timeout",$RaidSqa_TIMEOUT);
   #(undef, undef, $output1) = say($conn, "priv set -q diag; aggr media_scrub status", "-timeout",$RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        $output = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable off\" ");
        $output1 = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable \" ");
   @output1 = split(/\r?\n/, $output1);
   if (grep(/Media scrubbing is currently disabled on this system/, @output1)) {
                logcomment("RaidSqa_Cmode.pm: Media scrubbing is currently disabled on this system");
                return 1;
        } else {
      logcomment("RaidSqa_Cmode.pm: Media scrubbing is currently not disabled on this system");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_media_scrub_enable

RaidSqa_media_scrub_enable(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine enable the media_scrub on filer by turning on the raid options raid.media.scrub.enable

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_media_scrub_enable {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my ($output, $output1, @output1);
   #(undef, undef, $output) = say($conn, "priv set -q diag; options raid.media_scrub.enable on", "-timeout",$RaidSqa_TIMEOUT);
   #(undef, undef, $output1) = say($conn, "priv set -q diag; options raid.media_scrub.enable", "-timeout",$RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        $output = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable on\" ");
        $output1 = $server->cli(cmd=>"run local \"priv set -q diag; options raid.media_scrub.enable \" ");

   @output1 = split(/\r?\n/, $output1);
   if (grep(/on/, @output1)) {
                logcomment("RaidSqa_Cmode.pm: Media scrubbing is currently enabled on this system");
                return 1;
        } else {
      logcomment("RaidSqa_Cmode.pm: Media scrubbing is currently not enabled on this system");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_log

RaidSqa_log(host=>$host, filermode=>$filermode, conntype=>$conntype, marker=>$marker);

This subroutine log a marker in syslog file.

Return 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item marker

(Required): Name of the marker (message) which we want to add to log for marking purpose.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_log {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                marker => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $marker  = $opts{marker};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

#  my $output;
#  (undef,undef,$output) = say($conn, "priv set -q diag; log $marker", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; log $marker \" ");

   return 1;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_dd

RaidSqa_dd(host=>$host, filermode=>$filermode, conntype=>$conntype, if=>$if, of=$of, din=$din, bin=>$bin, dout=$dout, bout=$bout, count=$count, options=>$options);

This subroutine run dd command to corrupt the disk blocks. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item if

(Required): Name of input file.

=item of

(Required): Name of output file.

=item din

(Required): name of source disk.

=item bin

(Optional): Block number of source disk (wafl block 8k size).

=item dout

(Required): name of destination disk.

=item bout

(Optional): Block number of destination disk (wafl block 8k size).

=item count

(Optional): Number of block to be copied.

=item options

(Optional): additional options to be passed to dd command. 

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_dd {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                if => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                of => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                din => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                bin => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                dout => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                bout => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                count => { type=>SCALAR|UNDEF, default=>undef, optional=>1},
                                options => { type=>SCALAR|UNDEF, default=>"-c", optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $if = $opts{if};
        my $of = $opts{of};
        my $din = $opts{din};
        my $bin = $opts{bin};
        my $dout = $opts{dout};
        my $bout = $opts{bout};
        my $count = $opts{count};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   #my $output;

    my $cmd_args;
    if (defined($if)) {
        if (defined($of) && defined($count)) {
            $cmd_args= "dd if=$if of=$of count=$count";
        } elsif (defined($of))  {
            $cmd_args= "dd if=$if of=$of";
        } elsif (defined($dout) && defined($bout) && defined($count)) {
            $cmd_args= "dd if=$if dout=$dout bout=$bout count=$count";
        }
    } elsif (defined($din) && defined($bin)) {
        if (defined($of) && defined($count)) {
            $cmd_args= "dd din=$din bin=$bin of=$of count=$count";
        } elsif (defined($of))  {
            $cmd_args= "dd din=$din bin=$bin of=$of";
        } elsif (defined($dout) && defined($bout) && defined($count)) {
            $cmd_args= "dd din=$din bin=$bin dout=$dout bout=$bout count=$count";
        }
    } else {
        logcomment("RaidSqa_Cmode.pm: right parameter not defined to dd command");
                return 0;
    }

	#Options will be of no use where input and output source is file
	if($options && !(defined($of) && defined($if))) {
		$cmd_args .= " $options";
	}
	
	#(undef,undef,$output)=say($conn, "priv set -q test; $cmd_args ", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q test; $cmd_args \" ");

   return 1;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_filer_cmd

RaidSqa_filer_cmd(host=>$host, filermode=>$filermode, conntype=>$conntype, cmd=>$cmd, timeout=>$timeout);

This subroutine run run any filer comamnd where we are not expecting o/p for analysis, just want to run the command

It returns o/p of the command if any

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item cmd

(Optional): filer command.

=item options

(Optional): gives options to be used while executing the filer command.

=item prompt

(Optional): gives prompt to be wait for in case of executing say command.

=item timeout

(Optional): timeout value in secs.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_filer_cmd {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        cmd => {type=>SCALAR},
        options => {type => SCALAR, optional => 1},
        prompt => {type => SCALAR, optional => 1},
        timeout => {type=>SCALAR,default=>$RaidSqa_TIMEOUT, optional=>1},
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $cmd = $opts{cmd};
    my $options   = $opts{options};
    my $prompt   = $opts{prompt};
    my $timeout = $opts{timeout};

    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn_console = make_conn($host,"#console");

    my $output;
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});
 
    if ((!defined($options))&&(!defined($prompt))) {
         $output = $server->cli(cmd=>"run local \"priv set -q diag; $cmd \" ");
    } elsif ((defined($options))&&(!defined($prompt))) {
        (undef, undef, $output) = say($conn_console, "run local \"priv set -q diag; $cmd \" ", "$options", -timeout, $timeout);
    } elsif ((!defined($options))&&(defined($prompt))) {
        (undef, undef, $output) = say($conn_console, "run local \"priv set -q diag; $cmd \" ", -prompt, $prompt, -timeout, $timeout);
    } else {
        (undef, undef, $output) = say($conn_console, "run local \"priv set -q diag; $cmd \" ", -prompt, $prompt, $options, -timeout, $timeout);
    }
 
    return $output;
}

#--------------------------------------------------------------------------------------------------

=head2 RaidSqa_filer_saycmd

RaidSqa_filer_saycmd(host=>$host, filermode=>$filermode, conntype=>$conntype, cmd=>$cmd, options=>$options,prompt=>$prompt,timeout=>$timeout);

This subroutine run run any filer comamnd where we are not expecting o/p for analysis, just want to run the command

It returns o/p of the command if any

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#console". For filermode "MAINT" it is "#console" by default.

=item cmd

(Optional): filer command.

=item options

(Optional): filer options like -noprompt, -nocr.

=item prompt

(Optional): filer prompt like .*> (or) waitstring.

=item timeout

(Optional): timeout value in secs.

=back

=cut
#--------------------------------------------------------------------------------------------------

sub RaidSqa_filer_saycmd {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#console",optional=>1},
        cmd => {type=>SCALAR},
        options => {type => SCALAR, optional => 1},
        prompt => {type => SCALAR, optional => 1},
        timeout => {type=>SCALAR,default=>$RaidSqa_TIMEOUT, optional=>1},
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $cmd = $opts{cmd};
    my $options   = $opts{options};
    my $prompt   = $opts{prompt};
    my $timeout = $opts{timeout};

    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);
    my $output;
    if ((!defined($options))&&(!defined($prompt))) {
        (undef, undef, $output) = Tharn::say($conn, "$cmd", -timeout, $timeout);
    } elsif ((defined($options))&&(!defined($prompt))) {
        (undef, undef, $output) = Tharn::say($conn, "$cmd", "$options", -timeout, $timeout);
    } elsif ((!defined($options))&&(defined($prompt))) {
        (undef, undef, $output) = Tharn::say($conn, "$cmd", -prompt, $prompt, -timeout, $timeout);
    } else {
        (undef, undef, $output) = Tharn::say($conn, "$cmd", -prompt, $prompt, $options, -timeout, $timeout);
    }
    return $output;
}

#--------------------------------------------------------------------------------------------------
=head2 RaidSqa_aggr_wafliron_start
RaidSqa_aggr_wafliron_start(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine starts wafliron on the test aggregate .

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_start{
   my (%opts) = validate(@_, {
      host => { type=>OBJECT, isa=>'Hostrec'  },
      filermode => { type=>SCALAR, default=>"normal", optional=>1 },
      conntype => {type=>SCALAR, default=>"#ssh",optional=>1},
      filer_vol => { type=>SCALAR },
      oc => { type=>SCALAR, default=>0, optional=>1 },
   });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $oc = $opts{oc};
    my $cmd;
    my $output;
    
    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa_Cmode.pm: Starting wafliron on aggr $filer_vol");

    #Starting wafliron on test aggr/volume
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    $cmd = "aggr wafliron start $filer_vol";
    if ($oc) {
        $cmd = $cmd . " -o";
    }
    $output = $server->cli(cmd => "run local \"priv set -q diag; $cmd \" ", -Timeout => $RaidSqa_TIMEOUT);
    if ($output =~ /aggr wafliron start $filer_vol: ./) {
        logcomment("RaidSqa_Cmode.pm: Wafliron started on $filer_vol successfully");
    }
}

#--------------------------------------------------------------------------------------------------
=head2 RaidSqa_aggr_wafliron_review
RaidSqa_aggr_wafliron_review(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine review wafliron on the test aggregate .

It returns the output string of the review command .

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_review{
   my (%opts) = validate(@_, {
      host => { type=>OBJECT, isa=>'Hostrec'  },
      filermode => { type=>SCALAR, default=>"normal", optional=>1 },
      conntype => {type=>SCALAR, default=>"#ssh",optional=>1},
      filer_vol => { type=>SCALAR },
   });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};
    my $output;
    
    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa_Cmode.pm: Review wafliron on aggr $filer_vol");

    # Review wafliron on test aggr/volume
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    $output = $server->cli(cmd => "run local \"priv set -q diag; aggr wafliron review $filer_vol \" ", -Timeout => $RaidSqa_TIMEOUT);
    return $output;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_wafliron_status

RaidSqa_aggr_wafliron_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine checks the status of wafliron on the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate .


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_status{
   my (%opts) = validate(@_, {
      host => { type=>OBJECT, isa=>'Hostrec' },
      filermode => { type=>SCALAR, default=>"normal", optional=>1 },
      conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
      filer_vol => { type=>SCALAR },
   });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};

    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa_Cmode.pm:Checking Status of wafliron on aggr $filer_vol");

    #Starting wafliron on test aggr/volume
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    my $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr wafliron status $filer_vol \" ");
    if ($o =~ /not currently/) {
        return 0;
    } elsif ($o =~ /active/ || $0 =~ /wafliron in optional commit mode has completed on aggregate/) {
        logcomment("RaidSqa_Cmode.pm:Wafliron is completed successfully on $filer_vol");
        return 1;
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_aggr_wafliron_commit

RaidSqa_aggr_wafliron_commit(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine commits wafliron on the test aggregate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate .


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_wafliron_commit{
   my (%opts) = validate(@_, {
      host => { type=>OBJECT, isa=>'Hostrec' },
      filermode => { type=>SCALAR, default=>"normal", optional=>1 },
      conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
      filer_vol => { type=>SCALAR },
   });

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};

    if($filermode ne "normal"){
        $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa_Cmode.pm:Commit wafliron on aggr $filer_vol");

    # Commit wafliron on test aggr/volume
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    my $o = $server->cli(cmd=>"run local \"priv set -q diag; aggr wafliron commit $filer_vol \" ");
    if ($o =~ /Committed change log files for aggregate $filer_vol/) {
        logcomment("RaidSqa_Cmode.pm:Wafliron committed the chages successfully");
        return 1;
    } else {
        logcomment("RaidSqa_Cmode.pm:Wafliron commit is not successful");
        return 0;
    }
}

##===============================================================

=head2 RaidSqa_aggr_set_as_root

This function sets root option to the specified aggr
in the maintanenance mode.

Returns 1 on success and 0 on failure.
(set $@ to contain a string describing the failure);

=item %opt
This is the hash with the following keys

     host => filer host object required.

     aggr  => name of the aggr. Required.

     restore => 1 or 0. whether user wants to restore the filer to it's
                previous state. default is 1.
Usage:
     RaidSqa_aggr_set_as_root
    (conn =>$fc, aggr=>$aggr, restore=>1);
=cut

sub RaidSqa_aggr_set_as_root {
    my ($fc, $host,    $aggr, %opt);
    my ($restore, $ret,  $state);
    %opt = validate(@_,
                    {host    => {type => OBJECT, isa=>'Hostrec'},
                     aggr    => {type => SCALAR},
                     restore => {type => SCALAR, optional => 1, default => 1},}
                   );

    $host    = $opt{host};
    $aggr    = $opt{aggr};
    $restore = $opt{restore};
    $fc = make_conn($host,"#console");
    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    $state = boot_state($fc);
    logcomment("RaidSqa_Cmode.pm:Current filer state is: $state");

    # Go to maintanenance mode
    RaidSqa_transit_to(host=>$host, state_name=>"MAINT");
    $server->console(cmd=>"aggr online $aggr", noprompt => 1);
    $server->console(cmd=>"aggr options $aggr root", noprompt => 1);
    $server->console(cmd=>"aggr options $aggr root", noprompt => 1);
    logcomment("RaidSqa_Cmode.pm: Setting as root is done");
    # Restore the filer to it's previous state
    if ($restore) {
        logcomment("RaidSqa_Cmode.pm: Restoring the state $state");
        $ret = RaidSqa_transit_to(host=>$host, state_name=>$state);
        if (!$ret) {
            logcomment("Failed to go $state");
            return 0;
        }
    }

    return 1;
} ## end sub RaidSqa_aggr_set_as_root

##############################################################################
# LIST OF FUNCTIONS WHICH ARE CHECKING STATUS                                #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_exist

RaidSqa_check_disk_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine checks that a particular disk exist in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked if it exist in filer or not.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $disk_name = $opts{disk_name};
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exists in raid
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
   } else {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does exist in filer");
                return 1;
        }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_fsm_state

RaidSqa_check_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, fsm_state=>$fsm_state);

This subroutine checks a particular disk's fsm state in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item fsm_state

(Required) : FSM state of the disk to be checked against. Like INUSE|ZEROED|ZEROING|NOTZEROED|OFFLINE|FAILED|

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $fsm_state = $opts{fsm_state};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exist in specific fsm_state
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");

        # checking for NULL disk_obj

        if ( ! ( $disk_obj ) )
        {
           logcomment("RaidSqa_Cmode.pm: Invalid disk_object! ");
           return 0;
        }

   my $disk_fsm_state=$disk_obj->parameter("fsm_state");

   if ($disk_fsm_state eq $fsm_state) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is in $fsm_state fsm state");
                return 1;
        } else {
      logcomment("RaidSqa_Cmode.pm: disk $disk_name fsm state is not $fsm_state instead it is: $disk_fsm_state");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_is_doing_optimized_recons

RaidSqa_check_disk_is_doing_optimized_recons(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine checks a particular disk's is doing optimized reconstruction.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_is_doing_optimized_recons {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exist in specific fsm_state
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_optimized_state=$disk_obj->parameter("optimized_recons");
   my $disk_parent_state=$disk_obj->parameter("parent_state");

   if (!defined($disk_obj)) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
   } elsif (($disk_optimized_state) && ($disk_parent_state =~ /RECONS/)) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is in optimized reconstruction state");
                return 1;
        } else {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is not in optimized reconstruction state");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_parent_state

RaidSqa_check_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name, parent_state=>$parent_state);

This subroutine checks a particular disk's parent_state state in system.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item parent_state

(Required) : parent_state of the disk to be checked against. Like DATA|PARITY|DPARITY|RECONSDATA|RECONSPARITY|RECONSDPARITY

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_parent_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                parent_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $parent_state = $opts{parent_state};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exist in specific parent_state
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_parent_state=$disk_obj->parameter("parent_state");

   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
   } elsif ($disk_parent_state eq $parent_state) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is in $parent_state parent state");
                return 1;
        } else {
      logcomment("RaidSqa_Cmode.pm: disk $disk_name parent state is not $parent_state instead it is: $disk_parent_state");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_is_prefailed

RaidSqa_check_disk_is_prefailed(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine checks that a particular disk is in prefail state.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_is_prefailed {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exist in specific fsm_state
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_prefail_state=$disk_obj->parameter("prefail");

   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
   } elsif ($disk_prefail_state eq "1") {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is in prefail state");
                return 1;
        } else {
      logcomment("RaidSqa_Cmode.pm: disk $disk_name is not in prefail state");
                return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_sdc_start

RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine checks that sdc started on a particular prefailed disk.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_sdc_start {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   # check if specified disk exist in specific fsm_state
   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_sdc_progress=$disk_obj->parameter("copy_progress");

   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
   } elsif ($disk_sdc_progress ne "-1") {
                logcomment("RaidSqa_Cmode.pm: sdc started on disk $disk_name ");
                return 1;
   } else {
                logcomment("RaidSqa_Cmode.pm: sdc didn't started on disk $disk_name ");
                return 0;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_block_is_pseudo

RaidSqa_check_disk_block_is_pseudo(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn=>$dbn);

This subroutine checks that a particular disk blocks number (dbn) is pseudo.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk to be checked.

=item dbn

(Required) : disk block number (dbn) of the disks to be checked for pseudo.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_block_is_pseudo {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                dbn => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $dbn = $opts{dbn};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
   #my $output;
        #(undef, undef, $output) = say($conn, "priv -level -q diag; dumpblock dbn -c $disk_name $dbn", -timeout, $RaidSqa_TIMEOUT);
     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; dumpblock dbn -c $disk_name $dbn\" ");

   my @output_array = split(/\r?\n/, $output);
   my @line3 = split(" ", $output_array[3]);
   my @bit_to_comp_in_hex = split(//, $line3[4]);
   my $bit_to_comp_in_bin = sprintf "%04b", hex($bit_to_comp_in_hex[9]);
   my @last_bit_to_comp = split(//, $bit_to_comp_in_bin);

   if($last_bit_to_comp[3] == 1 ) {
                logcomment("RaidSqa_Cmode.pm: dbn $dbn in disk $disk_name is a pseudo bad block");
                return 1;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_exist

RaidSqa_check_aggr_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type);

This subroutine checks that a particular aggergate exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be checked if it exist in in filer.

=item aggr_type

(Optional): 1 for aggregate and 0 for traditional. Default it is 1. For Cmode as traditional is not supported, we will set it to 1

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_check_aggr_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'},
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                              aggr_type => { type=>SCALAR, default=>1, optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

       my $conn = make_conn($host,$conntype);
        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
                $aggr_type = 1;
        }


        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate($filer_vol);

        # check if a specified aggr/tradvol/flex exist in filer or not
   if ($aggr_obj) {
                logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol exist.\n");
                return 1;
   } else {
                logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol does not exist.\n");
                return 0;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_exist_anytype

RaidSqa_check_aggr_exist_anytype(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine checks that any flex/trad or aggr of partricular name exist in filer or not.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_exist_anytype {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);

        my $vol_obj = $raid_obj->aggregate("$filer_vol");
        my $flex_obj = $raid_obj->volume("$filer_vol");

        # check that a aggr or tradvol or flex of specified name exists or not
        if ((!$vol_obj) && (!$flex_obj)) {
                logcomment("RaidSqa_Cmode.pm: no trad or aggregate or flex with name $filer_vol exists");
                return 0;
        } elsif ($vol_obj->parameter("store_type") eq 'aggr') {
                logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol exist.\n");
                return 1;
        } elsif ($vol_obj->parameter("store_type") eq 'trad') {
                logcomment("RaidSqa_Cmode.pm: A trad vol $filer_vol exists");
                return 1;
        } elsif ($flex_obj->parameter("store_type") eq 'flex') {
                logcomment("RaidSqa_Cmode.pm: trad vol $filer_vol exist.\n");
                return 1;
        }
}


#------------------------------------------------------------------------------
=head2 RaidSqa_check_plex_exist

RaidSqa_check_plex_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, plex_name => $plex_name);

This subroutine checks that a particular plex exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item plex_name

(Required) : Name of plex to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_plex_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                plex_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);

        my $plex_obj = $raid_obj->plex("$plex_name");

        # check a specified plex exist in filer
        if (!$plex_obj) {
                logcomment("RaidSqa_Cmode.pm: plex $plex_name does not exist in the filer");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: plex $plex_name exist in the filer");
                return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_exist

RaidSqa_check_group_exist(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name);

This subroutine checks that a particular raid group exist in filer.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): name of filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of the raid group to be checked if it exist in in filer.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_check_group_exist {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");

   # check a specified group exist in filer
        if (!$group_obj) {
                logcomment("RaidSqa_Cmode.pm: no raid group with name $group_name exist in the filer");
                return 0;
        } else  {
                logcomment("RaidSqa_Cmode.pm: raid group with name $group_name exist in the filer");
                return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_state_name

RaidSqa_check_aggr_state_name(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, state_name=>$state_name,  aggr_type =>$aggr_type);

This subroutine checks that a particular aggergate is state_name(online/offline/restricted) is as defined by user.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be checked if it is online.

=item state_name

(Required) : State name of aggr/volume (offline/online/restricted).

=item aggr_type

(Optional): 1 for aggregate and 0 for traditional. Default it is 1. For Cmode as traditional is not supported, we will set it to 1

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_state_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                state_name => { type=>SCALAR },
                                aggr_type => { type=>SCALAR,default=>1,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $state_name = $opts{state_name};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
                $aggr_type = 1;
        }


    #    my $server = new Server;
    # $server->set_execution_server(-Server => $host->{hostname});

   # check a test aggr/volume is having specified state
        if (!RaidSqa_check_aggr_exist(host=>$host,conntype=>$conntype,filer_vol => $filer_vol, aggr_type =>$aggr_type)) {
      logcomment("RaidSqa_Cmode.pm: aggregate $filer_vol does not exists");
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("state_name") ne $state_name) {
         logcomment("RaidSqa_Cmode.pm: state name for $filer_vol is not $state_name as expected");
                        return 0;
                } else {
         logcomment("RaidSqa_Cmode.pm: state name for $filer_vol is $state_name as expected");
                        return 1;
                }
        }
}
#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_mirror_state

RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type,mirror_state=>$mirror_state);

This subroutine checks mirror_state for a particular volume/aggergate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked if it is restricted.

=item aggr_type

(Required) : 1 for aggregate and 0 for traditional.

=item mirror_state

(Required) : mirror state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_mirror_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR, default=>1,optional=>1 },
                                mirror_state => { type=>SCALAR, default=>"UNMIRRORED",optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $mirror_state = $opts{mirror_state};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);
        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: As traditional volume is not supported, hence changing the aggr_type to 1");
                $aggr_type = 1;
        }


        # check a test aggr/volume is having specified mirror state
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type=>$aggr_type)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("mirror_state") ne $mirror_state) {
                        logcomment("RaidSqa_Cmode.pm: Mirror state for $filer_vol is not $mirror_state as expected");
                        return 0;
                } else {
                        logcomment("RaidSqa_Cmode.pm: Mirror state for $filer_vol is $mirror_state as expected");
                        return 1;
                }
        }
}


#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_fsm_state

RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, fsm_state=>$fsm_state, aggr_type=>$aggr_type);

This subroutine checks fsm_state for a particular aggergate.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be checked if it is restricted.

=item fsm_state

(Required) : fsm state to be checked against.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional volume is not supported, hence we  will set it to 1 if provided as 0.



=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                aggr_type => { type=>SCALAR, default=>1, optional=>1 },

                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $fsm_state = $opts{fsm_state};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: aggr_type as 0 is not supported in Cmode hence chnaging it to 1");
                $aggr_type=1;
        }


   # check a test aggr/volume is having specified mirror state
        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=> $filer_vol, aggr_type =>$aggr_type)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $vol_obj = $raid_obj->aggregate("$filer_vol");

                if ($vol_obj->parameter("fsm_state") ne $fsm_state) {
         logcomment("RaidSqa_Cmode.pm: fsm state for $filer_vol is not $fsm_state as expected");
                        return 0;
                } else {
         logcomment("RaidSqa_Cmode.pm: fsm state for $filer_vol is $fsm_state as expected");
                        return 1;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_fsm_state

RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name, fsm_state=>$fsm_state);

This subroutine checks fsm state of a particular raid group

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=item fsm_state

(Required) : fsm_state to be checked against.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                fsm_state => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};
        my $fsm_state = $opts{fsm_state};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if ($group_obj->parameter("fsm_state") eq "$fsm_state") {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name is in $fsm_state as expected");
                        return 1;
                } else {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name is not in $fsm_state as expected");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_recons_in_progress

RaidSqa_check_group_recons_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group recons is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_recons_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("fsm_state") =~ /RECONS/) && ($group_obj->parameter("recons_progress") ne "-1") && ($group_obj->parameter("recons_suspended_block") eq "-1")) {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name reconstruction is in progress");
                        return 1;
                } else {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name reconstruction is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_scrub_in_progress

RaidSqa_check_group_scrub_in_progress(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group scrub is running or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_scrub_in_progress {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("scrub_progress") ne "-1") && ($group_obj->parameter("scrub_suspended_block") eq "-1")) {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name scrub is in progress");
                        return 1;
                } else {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name scrub is not in progress");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_is_running_context_scrub

RaidSqa_check_group_is_running_context_scrub(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group is running context scrub

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_is_running_context_scrub {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");
      if (($group_obj->parameter("context_scrub") eq "1") && ($group_obj->parameter("context_parity_protected") eq "0") && ($group_obj->parameter("scrub_progress") ne "-1") && ($group_obj->parameter("scrub_suspended_block") eq "-1")) {

                        logcomment("RaidSqa_Cmode.pm: raid group $group_name is running context scrub");
                        return 1;
                } else {
                        logcomment("RaidSqa_Cmode.pm: raid group $group_name scrub is not running context scrub");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_group_recons_is_suspend

RaidSqa_check_group_recons_is_suspend(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine checks that raid group recons is suspend or not

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_group_recons_is_suspend {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # check a test group exists and is having specified fsm_state
        if (!RaidSqa_check_group_exist(host=>$host, conntype=>$conntype, group_name=> $group_name)) {
                return 0;
        } else {

                my $raid_obj = new RaidInfo($conn);
                my $group_obj = $raid_obj->raid_group("$group_name");

                if (($group_obj->parameter("fsm_state") =~ /RECONS/) && ($group_obj->parameter("recons_suspended_block") ne "-1")) {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name reconstruction is in suspend state");
                        return 1;
                } else {
         logcomment("RaidSqa_Cmode.pm: raid group $group_name reconstruction is not in suspend state");
                        return 0;
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_raid_size_valid_range

RaidSqa_check_raid_size_valid_range(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);

This subroutine checks that a particular raid_size is in valid range for a given raid_type and storage_type.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item raid_size

(Required) : Raid size of the volume/aggregate to be created.  No default. Any user_defined count.

=item raid_type

(Required) : Raid type of the volume/aggregate to be created. No default. cane be raid4 or raid_dp.

=item storage_type

(Required) : Disk storage type. Can be ATA, SAS, FCAL, BSAS.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_raid_size_valid_range {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                raid_size => { type=>SCALAR },
                                raid_type => { type=>SCALAR },
                                storage_type => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $raid_size = $opts{raid_size};
        my $raid_type = $opts{raid_type};
        my $storage_type = $opts{storage_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # checks that raid_size specified by user is in valide range as range are different for raid4/raidp for different type disks ATA/FCAL/SAS
   if ($storage_type eq "ATA" || $storage_type eq "BSAS") {
         if ($raid_type eq "raid4") {
               if ($raid_size >= 2 &&  $raid_size <= 7) {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (2-7)");
            return 1;
               } else {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (2-7), can not continue test, rerun test with correct raid_size value");
            return 0;
               }
         }
         if ($raid_type eq "raid_dp") {
               if ($raid_size >= 3 &&  $raid_size <= 14) {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (3-14)");
            return 1;
               } else {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (3-14), can not continue test, rerun test with correct raid_size value");
            return 0;
               }
         }
   } elsif ($storage_type eq "FCAL" || $storage_type eq "SAS"){
         if ($raid_type eq "raid4") {
               if ($raid_size >= 2 &&  $raid_size <= 16) {
                  logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (2-7)");
            return 1;
               } else {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (2-16, rerun test with correct raid_size value");
            return 0;
               }
         }
         if ($raid_type eq "raid_dp") {
               if ($raid_size >= 3 &&  $raid_size <= 28) {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is in valid range (3-28)");
            return 1;
               } else {
               logcomment("RaidSqa_Cmode.pm: raid size:$raid_size for disktype: $storage_type disks and raidtype: $raid_type is not in valid range (3-28), can not continue test, rerun test with correct raid_size value");
            return 0;

               }
         }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_license

RaidSqa_check_license(host=>$host, filermode=>$filermode, conntype=>$conntype, service=>$service);

This subroutine check that filer is having license for a particular service.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item service

(Required): Name of the service for which we want to check license.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_license {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                service => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $service = $opts{service};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # check a particuler license is tehre on filer
        #my $output;
        my $line;
        #(undef,undef, $output) = say($conn, "priv set -q diag;license", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; license\" ");

        my @info = split(/\r?\n/, $output);
        foreach $line (@info) {
                my (@data) = split(" ", $line);
                if ($data[0] eq $service) {
                        logcomment("RaidSqa_Cmode.pm: $data[0], $data[1] licensed\n");
                        if ($data[1] eq "not") {
                                return 0;
                        } else {
                                return 1;
                        }
                }
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_fiji

RaidSqa_check_fiji(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine check that filer is having fiji set.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required): Name of the fiji_point for which we want to check fiji.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_fiji {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fiji_point = $opts{fiji_point};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        #my $output;
        my $line;
        #(undef,undef, $output) = say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji show \" ");

        my @info = split(/\r?\n/, $output);
   if(index($output, $fiji_point) ne "-1") {
                 logcomment("RaidSqa_Cmode.pm: fiji filter/nvfilter $fiji_point is set\n");
                 return 1;
        } else {
         logcomment("RaidSqa_Cmode.pm: fiji filter/nvfilter $fiji_point is not set\n");
         return 0;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_hammer_running

RaidSqa_check_hammer_running(host=>$host, filermode=>$filermode, conntype=>$conntype, hammer_number=>$hammer_number);

This subroutine check that any or a particular hammer is running.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item hammer_number

(Optional): default is any, but we can check for a particular hammer number

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_hammer_running {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                hammer_number => {type=>SCALAR, default=>"any", optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $hammer_number = $opts{hammer_number};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $check;
   if ($hammer_number eq "any") {
      $check="blacksmith";
   } else {
      $check="blacksmith #" . $hammer_number;
   }

        #my $output;
        #(undef,undef, $output) = say($conn, "priv set -q diag;hammer status", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; hammer status \" ");

      if ($output =~ /$check/) {
         logcomment(" Hammer number: $hammer_number is running");
         return 1;
      } else {
         logcomment("Hammer number: $hammer_number is not running");
         return 0;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_existing_aggr_ok

RaidSqa_check_existing_aggr_ok(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type, raid_type=>$raid_type, raid_size=>$raid_size, mirror=>$mirror, storage_type=>$storage_type, disk_count=>$disk_count, aggr_bits=>$aggr_bits, aggr_fsm_state=>$aggr_fsm_state, aggr_state_name=>$aggr_state_name, aggr_wafl_online=>$aggr_wafl_online, aggr_wafl_mounted=>$aggr_wafl_mounted, aggr_ignore_inconsist=>$aggr_ignore_inconsist, aggr_snapmirrored=>$aggr_snapmirrored, all_group_fsm_state=>$all_group_fsm_state, all_group_sdc=>$all_group_sdc);


This subroutine checks the existing aggr/vol if it is in the state required to run the test.

It returns 1 on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate  or traditional volume to be created.

=item raid_type

(Optional): Raid type of the volume/aggregate

=item aggr_type

(Optional): aggr type of the volume/aggregate

=item raid_size

(Optional): Raid size of the volume/aggregate.

=item mirror

(Optional): 1 for mirror volume and 0 for nonmirror.

=item storage_type

(Optional):  Disk storage type. Can be ATA, SAS, FCAL, BSAS.

=item disk_count

(Optional):  total number of disk in aggr.

=item aggr_bits

(Optional):  type of aggr, 32 or 64 bits

=item aggr_fsm_state

(Optional): aggr fsm state, default is "NORMAL".

=item aggr_state_name

(Optional): aggr state name, default is "online".

=item aggr_wafl_online

(Optional): aggr wafl_online state, default is "1".

=item aggr_wafl_mounted

(Optional): aggr wafl_mounted state, default is "1".

=item aggr_ignore_inconsist

(Optional): aggr ignore_inconsist state, default is "0".

=item aggr_snapmirrored

(Optional): aggr snapmirrored state, default is "0".

=item all_group_fsm_state

(Optional): all groups fsm state, default is "NORMAL".

=item all_group_sdc

(Optional): all groups sdc state, default is "0".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_existing_aggr_ok {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => { type=>SCALAR, default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                raid_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                raid_size => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                mirror => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                storage_type => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
            disk_count => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
            aggr_bits => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                aggr_fsm_state => { type=>SCALAR,default=>"NORMAL",optional=>1 },
                                aggr_state_name => { type=>SCALAR,default=>"online",optional=>1 },
                                aggr_wafl_online => { type=>SCALAR,default=>"1",optional=>1 },
                                aggr_wafl_mounted => { type=>SCALAR,default=>"1",optional=>1 },
                                aggr_ignore_inconsist => { type=>SCALAR,default=>"0",optional=>1 },
                                aggr_snapmirrored => { type=>SCALAR,default=>"0",optional=>1 },
                                all_group_fsm_state => { type=>SCALAR,default=>"NORMAL",optional=>1 },
                                all_group_sdc => { type=>SCALAR,default=>"0",optional=>1 },

                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};
        my $raid_type = $opts{raid_type};
        my $raid_size = $opts{raid_size};
        my $mirror = $opts{mirror};
        my $storage_type = $opts{storage_type};
   my $disk_count = $opts{disk_count};
   my $aggr_bits = $opts{aggr_bits};
        my $aggr_fsm_state = $opts{aggr_fsm_state};
        my $aggr_state_name = $opts{aggr_state_name};
        my $aggr_wafl_online = $opts{aggr_wafl_online};
        my $aggr_wafl_mounted = $opts{aggr_wafl_mounted};
        my $aggr_ignore_inconsist = $opts{aggr_ignore_inconsist};
        my $aggr_snapmirrored = $opts{aggr_snapmirrored};
        my $all_group_fsm_state = $opts{all_group_fsm_state};
        my $all_group_sdc = $opts{all_group_sdc};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);

      my $vol_obj = $raid_obj->aggregate("$filer_vol");
      my %vol_rg_hash = $vol_obj->all_raid_groups();
        my @vol_rg_list = keys(%vol_rg_hash);

        my %vol_disk_hash = $vol_obj->all_disks();
        my @vol_disk_list = keys(%vol_disk_hash);
   my $disk_obj = $vol_obj->disk("$vol_disk_list[0]");

   my $store_type = $vol_obj->parameter("store_type") ;
   my $fsm_state = $vol_obj->parameter("fsm_state") ;
   my $state_name = $vol_obj->parameter("state_name") ;
   my $wafl_online = $vol_obj->parameter("wafl_online") ;
   my $wafl_mounted = $vol_obj->parameter("wafl_mounted") ;
   my $ignore_inconsist = $vol_obj->parameter("ignore_inconsist") ;
   my $snapmirrored = $vol_obj->parameter("snapmirrored") ;
   my $mirror_state = $vol_obj->parameter("mirror_state") ;
   my $raidtree_type = $vol_obj->parameter("raidtree_type") ;
   my $raidtree_size = $vol_obj->parameter("size") ;
   my $number_of_disks = $vol_obj->parameter("disk_count") ;
   my $aggr_format = $vol_obj->parameter("aggr_format") ;

        #logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol is normal/online/mounted and not inconsistent/snapmirror destination.\n");

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required fsm state \n");
        if ($fsm_state ne $aggr_fsm_state) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_fsm_state fsm state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_fsm_state fsm state as required \n");
        }

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required state name \n");
        if ($state_name ne $aggr_state_name) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_state_name state name state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_state_name state name as required \n");
        }

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required wafl_online state \n");
        if ($wafl_online ne $aggr_wafl_online) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_wafl_online wafl online state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_wafl_online wafl online state as required \n");
        }

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required wafl_mounted state \n");
        if ($wafl_mounted ne $aggr_wafl_mounted) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_wafl_mounted wafl mounted state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_wafl_mounted wafl mounted state as required \n");
        }

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required ignore_inconsist state \n");
        if ($ignore_inconsist ne $aggr_ignore_inconsist) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_ignore_inconsist ignore_inconsist state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_ignore_inconsist ignore_inconsist state as required \n");
        }

        logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol have required snapmirrored state \n");
        if ($snapmirrored ne $aggr_snapmirrored) {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not has the $aggr_snapmirrored snapmirrored state as required \n");
                return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the $aggr_snapmirrored snapmirrored state as required \n");
        }


        #if ($fsm_state ne "NORMAL" || $state_name ne "online" || $wafl_online ne "1" || $wafl_mounted ne "1" || $ignore_inconsist ne "0" || $snapmirrored ne "0") {
        #        logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not in ONLINE/NORMAL state.\n");
        #        return 0;
        #}

        #logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol raidgroups are in normal state\n");
#
#        my $group;
#        foreach $group (@vol_rg_list) {
#                my $group_obj = $vol_obj->raid_group("$group") ;
#                if ($group_obj->parameter("fsm_state") ne "NORMAL" || $group_obj->parameter("disk_copy_source_id") ne "-1" || $group_obj->parameter("disk_copy_target_id") ne "-1") {
#                        logcomment("RaidSqa_Cmode.pm: Not all the raidgroups are in normal state.\n");
#                        return 0;
#                }
#        }
        my $group;
        foreach $group (@vol_rg_list) {
                logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol raidgroup $group is in required fsm state\n");
                my $group_obj = $vol_obj->raid_group("$group") ;
                if ($group_obj->parameter("fsm_state") ne $all_group_fsm_state)  {
                        logcomment("RaidSqa_Cmode.pm: raidgroup $group is not in $all_group_fsm_state fsm state.\n");
                        return 0;
                }
                logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol raidgroup $group is in required sdc state\n");
                if ($group_obj->parameter("disk_copy_source_id") ne "-1" || $group_obj->parameter("disk_copy_target_id") ne "-1") {
                        logcomment("RaidSqa_Cmode.pm: raidgroup $group is not in required sdc state.\n");
                        return 0;
                }
        }

   if (defined($raid_type)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol is matching the RAID_TYPE requirement for the test.\n");
      if ($raid_type eq "raid4") {
         if (!($raidtree_type =~ /raid4/)) {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type RAID4.\n");
               return 0;
            }
      } elsif ($raid_type eq "raid_dp") {
            if (!($raidtree_type =~ /raidrd/)) {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type RAID-DP.\n");
               return 0;
            }
         }
   }

   if (defined($storage_type)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr/trad vol $filer_vol is matching the storage_type requirement for the test.\n");

      if ($storage_type eq "ATA") {
         if ($disk_obj->parameter("disk_type") ne "ATA") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required storage type ATA.\n");
               return 0;
               }
      } elsif ($storage_type eq "FCAL") {
         if ($disk_obj->parameter("disk_type") ne "FCAL") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required storage type FCAL.\n");
               return 0;
            }
      } elsif ($storage_type eq "BSAS") {
            if ($disk_obj->parameter("disk_type") ne "BSAS") {
                     logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required storage type BSAS.\n");
                     return 0;
            }
      
      } elsif ($storage_type eq "SAS") {
                        if ($disk_obj->parameter("disk_type") ne "SAS") {
                                 logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required storage type SAS.\n");
                                 return 0;
                        }
      }
   }

   if (defined($aggr_type)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol is having the same aggr type as required \n");
      if ($aggr_type) {
         if ($store_type ne "aggr") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type aggr type.\n");
               return 0;
            } else {
            logcomment("RaidSqa_Cmode.pm: Verifying if existing aggr $filer_vol contains the required flex vol for the test.\n");

               my $flex_obj = $raid_obj->volume("$filer_vol");

            if (!$flex_obj) {
               logcomment("RaidSqa_Cmode.pm: Aggregate $filer_vol does not contain the required flex volume.\n");
                  return 0;
                  } elsif ($flex_obj->parameter("state_name") ne "online") {
                  logcomment("RaidSqa_Cmode.pm: Aggregate $filer_vol does not contain an online required flex volume.\n");
                  return 0;
            }
         }

      } else  {
            if ($store_type ne "trad") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type aggr type.\n");
               return 0;
            }
      }
   }

   if (defined($raid_size)) {
      if ($raid_size =~ /\D/) {
         $raid_size=RaidSqa_get_raid_size_value(host=>$host, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type);
      }

      logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol is having the same raid size as required \n");
      if($raid_size != $raidtree_size) {
         logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not have the same raid size as required \n");
         return 0;
      }else {
         logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the same raid size as required \n");
      }
   }

   if (defined($mirror)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol is having the same mirror state as required \n");
      if ($mirror) {
         if ($mirror_state ne "MIRRORED") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type mirror state.\n");
               return 0;
            }
      } else  {
            if ($mirror_state ne "UNMIRRORED") {
               logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required type mirror state.\n");
               return 0;
            }
      }
   }

   if (defined($disk_count)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol is having the same number of disks as required \n");
      if($disk_count ne $number_of_disks) {
         logcomment("RaidSqa_Cmode.pm: Existing $filer_vol does not have the same number of disks as required \n");
         return 0;
      }else {
         logcomment("RaidSqa_Cmode.pm: Existing $filer_vol has the same number of disks as required \n");
      }
   }

   if (defined($aggr_bits)) {
      logcomment("RaidSqa_Cmode.pm: Verifying if the existing $filer_vol is having the same aggr bits type as required \n");
      if (!($aggr_format =~ /$aggr_bits/)) {
            logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol is not matching to its required aggr bits type.\n");
            return 0;
      }
   }


   logcomment("RaidSqa_Cmode.pm: Existing aggr/trad vol $filer_vol meets all the requirement for testing");
   return 1
}

##############################################################################
# LIST OF FUNCTIONS WHICH ARE GETTING INFORMATIONS                           #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_get_vol_status

RaidSqa_get_vol_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets o/p of vol status command for all volumes/one volume/or-with different options.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume to get vol status for. If not given, it will give o/p of all volumes. By default it is
undefined.

=item options

(Optional) : Any options with vol status o/p for a volume or all volumes. By default it is "-r".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_vol_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF, default=>undef, optional=>1 },
                                options => { type=>SCALAR, default=>"-r", optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # get o/p of vol status command with specified options
      my $server= new Server;
      $server->set_execution_server(-Server => $host->{hostname});
      my $output = $server->cli(cmd=>"run local \"priv set -q diag; vol status $options $filer_vol \" ");

        #my $output;
        #(undef, undef, $output)=say($conn, "priv set -q diag;vol status $options $filer_vol", -timeout, $RaidSqa_TIMEOUT);
        my @vol_status= split(/\r?\n/, $output);
        return @vol_status;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_status

RaidSqa_get_aggr_status(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets o/p of aggr status command for all aggr/one aggr/or-with different options.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume to get aggr status for. If not given, it will give o/p of all aggr. By default it is
undefined.

=item options

(Optional) : Any options with vol status o/p for a aggr or all aggr. By default it is "-r".

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_status {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF, default=>undef, optional=>1 },
                                options => { type=>SCALAR, default=>undef, optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   # get o/p of aggr status command with specified options
      my $server= new Server;
      $server->set_execution_server(-Server => $host->{hostname});
        my $output;
   if (defined($options)) {
         $output = $server->cli(cmd=>"run local \"priv set -q diag; aggr status $options $filer_vol \" ");
        #   (undef, undef, $output)=say($conn, "priv set -q diag;aggr status $options $filer_vol", -timeout, $RaidSqa_TIMEOUT);
   } else {
         $output = $server->cli(cmd=>"run local \"priv set -q diag; aggr status $filer_vol \" ");
        #   (undef, undef, $output)=say($conn, "priv set -q diag;aggr status $filer_vol", -timeout, $RaidSqa_TIMEOUT);
   }
        my @aggr_status= split(/\r?\n/, $output);
        return @aggr_status;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_list

RaidSqa_get_aggr_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by default gets list of aggr/tradvol in a given filer.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'},
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
   my %aggr_list= $raid_obj->all_aggregates();
   my @aggr_list=keys(%aggr_list);

        return  @aggr_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_options

RaidSqa_check_aggr_options(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, options=>$options);

This subroutine gets value of an options of a particular volume/aggergate.

It returns scalar value.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=item options

(Required) : Name of options to get the value.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                options => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $options = $opts{options};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
   #my $output;
   #(undef, undef, $output) = say($conn, "priv set -q advanced;aggr options $filer_vol", -timeout, $RaidSqa_TIMEOUT);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag;aggr options $filer_vol \" ");
   my @options_raw = split(/\r?\n/, $output);

   my $options_all;
   my $line;
   my $line1;
   foreach $line (@options_raw){
      $options_all=$options_all . $line;
   }

   my @options_list= split(/, /, $options_all);
   my %options_hash;
   foreach $line1 (@options_list) {
      (my $key, my $value) = split(/=/, $line1);
      $options_hash{$key}=$value;
   }

   my $i;
   foreach $i (keys(%options_hash)) {
      if ($i eq $options) {
         return $options_hash{$i};
      }
   }

}
#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_type

RaidSqa_get_aggr_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets info whether a particular volume/aggergate is aggregate or traditional volume.

It returns scalar value.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => { type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $vol_obj = $raid_obj->volume("$filer_vol");
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        if ($aggr_obj) {
                return $aggr_obj->parameter("store_type");
        } else {
                return $vol_obj->parameter("store_type");
        }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_cksum_type

RaidSqa_check_aggr_cksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets checksum type info of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_cksum_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("cksum_type");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_fsm_state

RaidSqa_check_aggr_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets fsm_state of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("fsm_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_raidtree_type

RaidSqa_check_aggr_raidtree_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets raidtree_type of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_raidtree_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("raidtree_type");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_storage_type

RaidSqa_check_aggr_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets storage_type of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_storage_type {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   my %aggr_disk_hash = $aggr_obj->all_disks();
        my @aggr_disk_list = keys(%aggr_disk_hash);
        my $disk_obj = $aggr_obj->disk("$aggr_disk_list[0]");

        return $disk_obj->parameter("disk_type");

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_bits

RaidSqa_check_aggr_bits(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets aggr_bits of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_bits {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");

        return $aggr_obj->parameter("aggr_format");

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_mirror_state

RaidSqa_check_aggr_mirror_state(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets mirror_state of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_mirror_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
        return $aggr_obj->parameter("mirror_state");
}



#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_context_parity_valid

RaidSqa_check_aggr_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag context_parity_valid of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_context_parity_valid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("context_parity_valid");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_has_bad_blocks

RaidSqa_check_aggr_has_bad_blocks(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag has_bad_blocks of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_has_bad_blocks {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("has_bad_blocks");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_bad_block_count

RaidSqa_check_aggr_bad_block_count(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag bad_block_count of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_bad_block_count {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("bad_block_count");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_aggr_tetris_opt_disabled

RaidSqa_check_aggr_tetris_opt_disabled(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);

This subroutine gets value of flag tetris_opt_disabled of a particular volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_aggr_tetris_opt_disabled {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $aggr_obj = $raid_obj->aggregate("$filer_vol");
   return $aggr_obj->parameter("tetris_opt_disabled");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_root_aggr

RaidSqa_get_root_aggr(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by gets root aggr name in a given filer.

It returns an scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_root_aggr {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
   my %all_aggr=$raid_obj->all_aggregates();
   my @all_aggr=keys(%all_aggr);
   my $aggr;
   foreach $aggr (@all_aggr) {
      my $aggr_obj=$raid_obj->aggregate("$aggr");
      if ($aggr_obj->parameter("root") eq "1") {
         return $aggr;
      }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_root_vol

RaidSqa_get_root_vol(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine by gets root volume name in a given filer.

It returns an scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_root_vol {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
   my %all_vol=$raid_obj->all_volumes();
   my @all_vol=keys(%all_vol);
   my $vol;
   foreach $vol (@all_vol) {
      my $vol_obj=$raid_obj->volume("$vol");
      if ($vol_obj->parameter("root") eq "1") {
         return $vol;
      }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_plex_list

RaidSqa_get_plex_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol);

This subroutine by default gets list of all plexes in a given filer. If filer_vol is given than it gives plex in that volume/aggregate.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_plex_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#rsh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my @plex_list;
        if ($filer_vol) {
            my $aggr_obj = $raid_obj->aggregate("$filer_vol");
            my %plex_list = $aggr_obj->all_plexes();
            @plex_list = keys(%plex_list);
        } else {
            my %plex_list = $raid_obj->all_plexes();
            @plex_list = keys(%plex_list);
        }
        return  @plex_list;
}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_list

RaidSqa_get_group_list(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name);

This subroutine by default gets list of raid groups in a given filer. If any one of filer_vol or plex_name is given than it gives list of raid groups in that.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggregate or traditional volume.

=item plex_name

(Optional) : Name of plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
   my @group_list;
   if ($filer_vol) {
         my $aggr_obj = $raid_obj->aggregate("$filer_vol");
                # Check if the aggr_obj is valid
                if ( ! ( $aggr_obj ) )
                {
                   return  @group_list;
                }
         my %group_list = $aggr_obj->all_raid_groups();
         @group_list = keys(%group_list);
   } elsif ($plex_name) {
         my $plex_obj = $raid_obj->plex("$plex_name");
                # Check if the plex_obj is valid
                if ( ! ( $plex_obj ) )
                {
                   return  @group_list;
                }
         my %group_list = $plex_obj->all_raid_groups();
         @group_list = keys(%group_list);
   } else {
         my %group_list = $raid_obj->all_raid_groups();
         @group_list = keys(%group_list);

   }
        return  @group_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_list_by_fsm_state

RaidSqa_get_group_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state=>$fsm_state, filer_vol=>$filer_vol, plex_name=>$plex_name);

This subroutine by default gets list of raid groups of particular fsm_state in a given filer. If any one of filer_vol or plex_name is given than it gives list of raid groups of particular fsm_state in that.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Fsm_state of raidgroup, we want the list of.

=item filer_vol

(Optional) : Name of aggregate or traditional volume.

=item plex_name

(Optional) : Name of plex.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_list_by_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fsm_state => { type=>SCALAR },
                                filer_vol => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => { type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $fsm_state = $opts{fsm_state};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
   my @group_list;
   if ($filer_vol) {
         my $aggr_obj = $raid_obj->aggregate("$filer_vol");
         my %group_list = $aggr_obj->all_raid_groups();
         @group_list = keys(%group_list);
   } elsif ($plex_name) {
         my $plex_obj = $raid_obj->plex("$plex_name");
         my %group_list = $plex_obj->all_raid_groups();
         @group_list = keys(%group_list);
   } else {
         my %group_list = $raid_obj->all_raid_groups();
         @group_list = keys(%group_list);

   }
   my $group;
   my $n=0;
   my @group_fsm_state;
        foreach $group (@group_list) {
                my $group_obj=$raid_obj->raid_group("$group");
                if ($group_obj->parameter("fsm_state") eq $fsm_state) {
                        $group_fsm_state[$n]=$group;
                        $n++;
                }
        }
   return @group_fsm_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_fsm_state

RaidSqa_check_group_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets fsm_state of a particular raid group.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid_group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_fsm_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
   return $group_obj->parameter("fsm_state");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_recons_suspended_block

RaidSqa_check_group_recons_suspended_block(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets recons_suspended_block of a particular raid group.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid_group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_recons_suspended_block {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
   return $group_obj->parameter("recons_suspended_block");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_group_context_parity_valid

RaidSqa_check_group_context_parity_valid(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name => $group_name);

This subroutine gets value of flag context_parity_valid of a particular group in volume/aggregate.

It returns scalar.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of group_name to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_group_context_parity_valid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
   return $group_obj->parameter("context_parity_valid");
}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_offline_ref_count

RaidSqa_get_disk_offline_ref_count(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the disk offline reference count of a particular disk in system..

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_offline_ref_count {
    my (%opts) =
      validate(@_,
               {host      => {type => OBJECT, isa     => 'Hostrec'},
                filermode => {type => SCALAR, default => "normal", optional => 1},
                conntype  => {type => SCALAR, default => "#ssh", optional => 1},
                disk_name => {type => SCALAR},});
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
	
    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    if (defined($disk_name)) {
	$disk_name = RaidSqa_find_active_path_disk_name(host      => $host,
							filermode => $filermode,
							conntype  => $conntype,
							disk_name => $disk_name);
	if (!defined($disk_name)) {
            logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	    return (0);
	}
    } ## end if (defined($disk_name...
    my $raid_obj    = new RaidInfo($conn);
    my $disk_obj    = $raid_obj->disk("$disk_name");
    my $offline_ref = $disk_obj->parameter("offline_ref");

    if (!$disk_obj) {
 	logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
	return 0;
    } else {
 	return $offline_ref;
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list

RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of all disks recognized by raid in a given filer. By specifing any one of the options from spare_only, filer_vol, plex_name or group_name, we can get the disk list in that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                spare_only => {type=>SCALAR,default=>"no",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $spare_only = $opts{spare_only};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);

   if ($spare_only =~ /yes|Yes|YES/ ) {
      my %all_spare_disks=$raid_obj->spare_disks();
      my @spare_disks=keys(%all_spare_disks);
      return @spare_disks;
   } elsif ($filer_vol) {
      my $aggr_obj=$raid_obj->aggregate($filer_vol);
      my %aggr_disk_list=$aggr_obj->all_disks();
      my @aggr_disk_list=keys(%aggr_disk_list);
      return @aggr_disk_list;
   } elsif ($plex_name) {
      my $plex_obj=$raid_obj->plex($plex_name);
      my %plex_disk_list=$plex_obj->all_disks();
      my @plex_disk_list=keys(%plex_disk_list);
      return @plex_disk_list;
   } elsif ($group_name) {
      my $group_obj=$raid_obj->raid_group($group_name);
      my %group_disk_list=$group_obj->all_disks();
      my @group_disk_list=keys(%group_disk_list);
      return @group_disk_list;
   } else {
         my %all_disks = $raid_obj->all_disks();
      my @all_disks=keys(%all_disks);
      return @all_disks;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_pool

RaidSqa_get_disk_list_by_pool(host=>$host, filermode=>$filermode, conntype=>$conntype, pool_name =>$pool_name, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks in a given pool recognized by raid in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list in a given pool from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item pool_name

(Required) : Name of pool to get the list of disks. Options are "pool0" or "pool1".

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks from a pool.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_pool {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                pool_name => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $pool_name = $opts{pool_name};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
   my @disk_list;

   if (!$disk_list) {
      @disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   } else {
      @disk_list=@$disk_list;
   }

      my $a=0;
      my $b=0;
   my $disk;
   my @disks_pool0;
   my @disks_pool1;
   foreach $disk (@disk_list) {
      my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("pool") eq "0") {
            $disks_pool0[$a]=$disk;
            $a++;
      } elsif ($disk_obj->parameter("pool") eq "1") {
         $disks_pool1[$b]=$disk;
                        $b++;
                  }
   }

   if ($pool_name =~ /pool0|Pool0|POOL0/ ) {
      return @disks_pool0;
   } elsif ($pool_name =~ /pool1|Pool1|POOL1/ ) {
      return @disks_pool1;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_fsm_state

RaidSqa_get_disk_list_by_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, fsm_state =>$fsm_state, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given fsm_state in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given fsm_state from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Name of fsm_state to get the list of disk.  Possible values are OFFLINE, INUSE, RECONS and more

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_fsm_state {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                fsm_state => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $fsm_state = $opts{fsm_state};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
   my @disk_list;
   my @disk_fsm_state;

   if (!$disk_list) {
      @disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   } else {
      @disk_list=@$disk_list;
   }

      my $a=0;
   my $disk;
   foreach $disk (@disk_list) {
if(defined($disk)){
            my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk);
            if($disk_active_path_name){
                logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk.\n");
                $disk=$disk_active_path_name;
            }else{
                logcomment("RaidSqa_Cmode.pm: The disk_name $disk specified does not exist. Please check again.\n");
                return(0);
            }
        }

      my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("fsm_state") eq $fsm_state) {
               $disk_fsm_state[$a]=$disk;
               $a++;
      }
   }

   return @disk_fsm_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_parent_state

RaidSqa_get_disk_list_by_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, parent_state =>$parent_state, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given parent_state in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given parent_state from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fsm_state

(Required) : Name of fsm_state to get the list of disk.  Possible values are OFFLINE, INUSE, RECONS and more

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_parent_state {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                parent_state => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $parent_state = $opts{parent_state};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
   my @disk_list;
   my @disk_parent_state;

   if (!$disk_list) {
      @disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   } else {
      @disk_list=@$disk_list;
   }

      my $a=0;
   my $disk;
   foreach $disk (@disk_list) {
      my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("parent_state") =~ "$parent_state") {
               $disk_parent_state[$a]=$disk;
               $a++;
      }
   }

   return @disk_parent_state;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_raid_type

RaidSqa_get_disk_list_by_raid_type(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_type =>$raid_type, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given raid_type in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given raid_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item raid_type

(Required) : Name of raid_type to get the list of disk. Possible values are data, parity, dparity

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_raid_type {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                raid_type => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $raid_type = $opts{raid_type};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
   my @disk_list;
   my @disk_raid_type;

   if (!$disk_list) {
      @disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   } else {
      @disk_list=@$disk_list;
   }

      my $a=0;
   my $disk;
   foreach $disk (@disk_list) {
      my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("raid_type") eq $raid_type) {
               $disk_raid_type[$a]=$disk;
               $a++;
      }
   }

   return @disk_raid_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_storage_type

RaidSqa_get_disk_list_by_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, storage_type =>$storage_type, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given storage_type in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given storage_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item storage_type

(Required) : Name of storage_type to get the list of disk. Possible values are ATA, FCAL, SAS, BSAS.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_storage_type {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                storage_type => { type=>SCALAR },
                                spare_only => { type=>SCALAR,default=>"no", optional=>1},
                                disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
            filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
            group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $storage_type = $opts{storage_type};
        my $spare_only = $opts{spare_only};
        my $disk_list = $opts{disk_list};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
   my @disk_list;
   my @disk_storage_type;


   if (!$disk_list) {
      @disk_list = RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
   } else {
      @disk_list = @$disk_list;
   }

      my $a = 0;
   my $disk;
   foreach $disk (@disk_list) {
      my $disk_obj = $raid_obj->disk("$disk");
            if ($disk_obj->parameter("disk_type") eq $storage_type) {
               $disk_storage_type[$a] = $disk;
               $a++;
      }
   }

   return @disk_storage_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_rpm

RaidSqa_get_disk_list_by_rpm(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_rpm =>$disk_rpm, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given disk_rpm in a given filer. By specifing any one of the options from disk_list, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given disk_rpm from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_rpm

(Required) : Value of disk_rpm to get the list of disk. Possible values are 7200, 10000, 15000.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given fsm_state.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list.

=item plex_name

(Optional): Name of plex of which we want to get the disk list.

=item group_name

(Optional): Name of raid group of which we want to get the disk list.


=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_list_by_rpm {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR,default=>"normal", optional=>1},
        conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
        disk_rpm => { type=>SCALAR },
        spare_only => { type=>SCALAR,default=>"no", optional=>1},
        disk_list => { type=>ARRAYREF|UNDEF,default=>undef, optional=>1},
        filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
        plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
        group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1},
                                 }
                         );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $disk_rpm = $opts{disk_rpm};
    my $spare_only = $opts{spare_only};
    my $disk_list = $opts{disk_list};
    my $filer_vol = $opts{filer_vol};
    my $plex_name = $opts{plex_name};
    my $group_name = $opts{group_name};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    my $raid_obj = new RaidInfo($conn);
    my @disk_list;
    my @list_disk_rpm;


    if (!$disk_list) {
        @disk_list=RaidSqa_get_disk_list(host=>$host, filermode=>$filermode, conntype=>$conntype, spare_only=>$spare_only, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);
    } else {
        @disk_list=@$disk_list;
    }

    my $a=0;
    my $disk;
    foreach $disk (@disk_list) {
        #Check if disk name exists or has an equivalent path_name2.
        if(defined($disk)){
            my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk);
            if($disk_active_path_name){
                logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk.\n");
                $disk=$disk_active_path_name;
            }else{
                logcomment("RaidSqa.pm: The disk_name $disk specified does not exist. Please check again.\n");
                return(0);
            }
        }

        my $disk_obj=$raid_obj->disk("$disk");
        if ($disk_obj->parameter("rpm") eq $disk_rpm) {
            $list_disk_rpm[$a]=$disk;
            $a++;
        }
    }
    return @list_disk_rpm;
}
#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_fsm_state

RaidSqa_get_disk_fsm_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the fsm state of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_fsm_state {
    my (%opts) = validate(@_, {
                            host => { type=>OBJECT, isa=>'Hostrec'  },
                            filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                            conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                            disk_name => { type=>SCALAR },
                            }
                    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $disk_name = $opts{disk_name};
    my $conntype = $opts{conntype};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    #Check if disk name exists or has an equivalent path_name2.
    if(defined($disk_name)){
        my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
        if($disk_active_path_name){
            logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name=$disk_active_path_name;
        }else{
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return(0);
        }
    }

    my $raid_obj = new RaidInfo($conn);
    my $disk_obj = $raid_obj->disk("$disk_name");
    my $disk_fsm_state=$disk_obj->parameter("fsm_state");
    if (!$disk_obj) {
        logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
        return 0;
    } else {
        return $disk_fsm_state;
    }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_used_size

RaidSqa_get_disk_used_size(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the used_size of a particular disk in MB .

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_used_size {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
        disk_name => { type=>SCALAR },
        }
    );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $disk_name = $opts{disk_name};
    my $conntype = $opts{conntype};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    #Check if disk name exists or has an equivalent path_name2.
    if (defined($disk_name)) {
        my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
        if ($disk_active_path_name) {
            logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
            $disk_name=$disk_active_path_name;
        } else {
            logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
            return(0);
        }
    }

    my $raid_obj = new RaidInfo($conn);
    my $disk_obj = $raid_obj->disk("$disk_name");
    my $disk_used_sz=$disk_obj->parameter("used_sz");
    if (!$disk_obj) {
        logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
        return 0;
    } else {
        return $disk_used_sz;
    }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_parent_state

RaidSqa_get_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the parent_state state of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_parent_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_parent_state=$disk_obj->parameter("parent_state");
   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_parent_state;
   }

}


#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_group_name

RaidSqa_get_disk_group_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the group name of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_group_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_raid_name=$disk_obj->parameter("raid_name");

   my $disk_name_length = length $disk_name;
   my $disk_raid_name_length = length $disk_raid_name;
   my $substr_length = $disk_raid_name_length - $disk_name_length - 1;
   my $disk_group_name = substr($disk_raid_name, 0, $substr_length);
        return $disk_group_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_plex_name

RaidSqa_get_disk_plex_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the plex name of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_plex_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_raid_name=$disk_obj->parameter("raid_name");
   my $disk_group_rgid=$disk_obj->parameter("group_rgid");

   my $disk_name_length = length $disk_name;
   my $disk_group_rgid_length= length $disk_group_rgid;
   my $disk_raid_name_length = length $disk_raid_name;
   my $substr_length = $disk_raid_name_length - $disk_name_length - $disk_group_rgid_length - 4;
   my $disk_plex_name = substr($disk_raid_name, 0, $substr_length);
        return $disk_plex_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_aggr_name

RaidSqa_get_disk_aggr_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the aggr/vol name of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_aggr_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   my $disk_raid_name=$disk_obj->parameter("raid_name");
   my $disk_group_rgid=$disk_obj->parameter("group_rgid");
   my $disk_plex_pid=$disk_obj->parameter("plex_pid");

   my $disk_name_length = length $disk_name;
   my $disk_group_rgid_length= length $disk_group_rgid;
   my $disk_plex_pid_length= length $disk_plex_pid;
   my $disk_raid_name_length = length $disk_raid_name;
   my $substr_length = $disk_raid_name_length - $disk_name_length - $disk_group_rgid_length - $disk_plex_pid_length - 10;
   my $disk_aggr_name = substr($disk_raid_name, 1, $substr_length);
        return $disk_aggr_name;

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_other_path_name

RaidSqa_get_disk_other_path_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the other path name of a particular disk in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_other_path_name {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $raid_obj = new RaidInfo($conn);
   my $disk_obj = $raid_obj->disk("$disk_name");
   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
      my $disk_path_name2=$disk_obj->parameter("path_name2");
      my $disk_path_name1=$disk_obj->parameter("path_name1");
      if ( $disk_path_name2 eq $disk_name) {
                  return $disk_path_name1;
      } else {
                  return $disk_path_name2;
      }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_sdc_target

RaidSqa_get_disk_sdc_target(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the sdc target disks of a particular disk being copied in system.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_sdc_target {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $disk;
   my $raid_obj = new RaidInfo($conn);
   my %disk_hash = $raid_obj->all_disks();
      my @disk_list = keys(%disk_hash);

   my $disk_obj = $raid_obj->disk("$disk_name");

   if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
      my $disk_copy_target_id=$disk_obj->parameter("copy_target_id");
      foreach $disk (@disk_list) {
         my $disk_obj1=$raid_obj->disk("$disk");
               if ($disk_obj1->parameter("id") eq $disk_copy_target_id) {
                     return $disk;
         }
      }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_preferred_storage_type

RaidSqa_get_preferred_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets preferred storage type in a mix environment based upon which storage type is having more spare disks available.

It returns an scalar $storage_type on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_preferred_storage_type {
   my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

      my $raid_obj = new RaidInfo($conn);
      my %spare_disks = $raid_obj->spare_disks();
      my @spare_disks = keys(%spare_disks);
      my $n=0;
      my $m=0;
      my $p=0;
      my $q=0;
      my @spares_ata=();
      my @spares_fcal=();
      my @spares_sas=();
      my @spares_bsas=();
   my $disk;
   # get spare based upon storage type
      foreach $disk (@spare_disks) {
      my $disk_obj=$raid_obj->disk("$disk");
            if ($disk_obj->parameter("disk_type")eq "ATA") {
            $spares_ata[$n]=$disk;
            $n++;
            } elsif ($disk_obj->parameter("disk_type") eq "BSAS") {
            $spares_bsas[$q] = $disk;
            $q++;
            } elsif ($disk_obj->parameter("disk_type") eq "FCAL") {
            $spares_fcal[$m]=$disk;
            $m++;
            } elsif ($disk_obj->parameter("disk_type") eq "SAS") {
            $spares_sas[$p]=$disk;
            $p++;
            }
      }
      my $spare_ata_disks_count=@spares_ata;
      my $spare_fcal_disks_count=@spares_fcal;
      my $spare_sas_disks_count=@spares_sas;
      my $spare_bsas_disks_count=@spares_bsas;
   my $storage_type;

   # check which storage type spare are more in system and use that as preferred storage type
      if ( $spare_ata_disks_count ge $spare_fcal_disks_count && $spare_ata_disks_count ge $spare_sas_disks_count  && $spare_ata_disks_count ge $spare_bsas_disks_count) {
            $storage_type="ATA";
      } elsif ($spare_fcal_disks_count ge $spare_ata_disks_count && $spare_fcal_disks_count ge $spare_sas_disks_count && $spare_fcal_disks_count ge $spare_bsas_disks_count) {
            $storage_type="FCAL";
      } elsif ($spare_sas_disks_count ge $spare_ata_disks_count && $spare_sas_disks_count ge $spare_fcal_disks_count && $spare_sas_disks_count ge $spare_bsas_disks_count) {
            $storage_type="SAS";
      } elsif ($spare_bsas_disks_count ge $spare_ata_disks_count && $spare_bsas_disks_count ge $spare_fcal_disks_count && $spare_bsas_disks_count ge $spare_sas_disks_count) {
            $storage_type="BSAS";
      }

      return $storage_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_raid_size_value

RaidSqa_get_raid_size_value(host=>$host, filermode=>$filermode, conntype=>$conntype, raid_size=>$raid_size, raid_type=>$raid_type, storage_type=>$storage_type, override=>$override); 

This subroutine gets value of raid_size for min/max/default for a given raid_type and storage_type.

It returns a scalar $raid_size on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item raid_size

(Required) : Raid size of the volume/aggregate to be created.  No default. Any value from min, max or default.

=item raid_type

(Required) : Raid type of the volume/aggregate to be created. No default. Can be raid4 or raid_dp.

=item storage_type

(Required) : Disk storage type. Can be ATA, SAS, FCAL, BSAS.

=item override

(Required) : override options value, can be on, off

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_raid_size_value {
 		my (%opts) = validate(@_, {
						host => { type=>OBJECT, isa=>'Hostrec' },
						filermode => { type=>SCALAR, default=>"normal", optional=>1 },
						conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
						storage_type => {type=>SCALAR},
						raid_type => {type=>SCALAR},
						raid_size => {type=>SCALAR},
						override => {type=>SCALAR,default=>"off",optional=>1},
					}
		);

    my $host = $opts{host};
	my $filermode = $opts{filermode};
	my $conntype = $opts{conntype};
	my $storage_type = uc $opts{storage_type};
	my $raid_type = $opts{raid_type};
	my $raid_size = lc $opts{raid_size};
	my $override = $opts{override};	

    my @storage_types = ("FCAL", "ATA", "BSAS", "SSD", "SAS");
    my @raid_types = ("raid_dp", "raid4", "raid0");
	my %hash = ();
    my $index = 0;
	my $entry = 0;
	my $entry_for = "";		
	my $raid_size_value = undef;
	
	# create connection
	if($filermode ne "normal"){
           $conntype = "#console";
	}
	
	if(!(grep /$raid_type/i, @raid_types)){
	    logcomment("RaidSqa_Cmode.pm: Unrecongnized value for raid_type: $raid_type, should be one of @raid_types");
	    return 0;
	}
    
    #defining some default values for older builds where raid_config command is not available
    if($storage_type =~ /ATA|BSAS/) {
        if($raid_type eq "raid4") {
            $raid_size_value = 7    #For both default and max
        } elsif($raid_type eq "raid_dp") {
            $raid_size_value = 14 if ($raid_size eq "default");
            $raid_size_value = 16 if ($raid_size eq "max");
        }
    } elsif($storage_type =~ /FCAL|SAS/) {
        if($raid_type eq "raid4") {
            $raid_size_value = 8  if ($raid_size eq "default");
            $raid_size_value = 14 if ($raid_size eq "max");
        } elsif($raid_type eq "raid_dp") {
            $raid_size_value = 16 if ($raid_size eq "default");
            $raid_size_value = 28 if ($raid_size eq "max");
        }
    }
    
	if($raid_size =~ /^(max|min|default)$/i) {
	    if($raid_size =~ /min/) {
		return 1 if($raid_type eq "raid0");
		return 2 if($raid_type eq "raid4");
		return 3 if($raid_type eq "raid_dp");
	    }
	} else {
	    logcomment("RaidSqa_Cmode.pm: Unrecongnized value for raid_size: $raid_size, should be min|max|default");
	    return 0 ;
	}
	
	if(!(grep /$storage_type/i, @storage_types)){
	    logcomment("RaidSqa_Cmode.pm: Unrecongnized value for storage_type: $storage_type, should be one of @storage_types");
	    return 0;
	}
	
	
	if($override =~ /^(on|off)$/i) {
	    $override = "override_".$override;
	} else {
	    logcomment("RaidSqa_Cmode.pm: Unrecongnized value for override option: $override, should be on/off");
	    return 0;
	}
	
	my $conn = make_conn($host,$conntype);
	my $server= new Server;
	$server->set_execution_server(-Server => $host->{hostname});
	my $output;
    
    eval {        
        $output = $server->cli(cmd=>"run local \"priv set -q test; raid_config group_size_override\"");
	};
    
    my @output = split(/\r*\n/,$output);
    
    #get index from where table starts
    for($index=0; $index<=$#output; $index++){
            if($output[$index] =~ /Disk Type/) {
        last;
        }
    }
    $index+=2;
    
    for(;$index <= $#output; $index++) {		
        my @line = split(/\s+/, $output[$index]);	
        if(defined($line[0]) && grep /$line[0]/, @storage_types) {
            if(grep /$line[1]/, @raid_types) {	
                $entry = 1 ;
                $entry_for = uc $line[0];		
                $hash{$entry_for}->{$line[1]}->{override_off}->{default} = $line[2];
                $hash{$entry_for}->{$line[1]}->{override_off}->{max} = $line[3];
                $hash{$entry_for}->{$line[1]}->{override_on}->{default} = $line[4];
                $hash{$entry_for}->{$line[1]}->{override_on}->{max} = $line[5];
            } else {				
                $entry = 0;
                next;
            }
        } elsif($line[0]) {				
            logcomment("RaidSqa.pm: unknown disk_type found: $line[0]");
            $entry = 0;
            $entry_for = "";
            next;
        } elsif($entry) {
            if((defined($line[1]) && grep /$line[1]/, @raid_types)) {					
                $hash{$entry_for}->{$line[1]}->{override_off}->{default} = $line[2];
                $hash{$entry_for}->{$line[1]}->{override_off}->{max} = $line[3];
                $hash{$entry_for}->{$line[1]}->{override_on}->{default} = $line[4];
                $hash{$entry_for}->{$line[1]}->{override_on}->{max} = $line[5];				
            } else {
                next;
            }
        }
    }
    
    my $value = $hash{$storage_type}->{$raid_type}->{$override}->{$raid_size};
    if($value =~ /\d+/) {
        logcomment("RaidSqa_Cmode.pm: $raid_size raid_size for $storage_type for $raid_type is $value ");
        return $value;
    } elsif(defined($raid_size_value)) { 
        logcomment("RaidSqa.pm: $raid_size raid_size for $storage_type for $raid_type is $raid_size_value ");
        return $raid_size_value;
    } else {
        logcomment("RaidSqai_Cmode.pm: Disks of storage type $storage_type are not present");
        return 0;
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_scrub_report_by_group

RaidSqa_get_scrub_report_by_group(host=>$host, filermode=>$filermode, conntype=>$conntype, group_name=>$group_name);

This subroutine gets scrub report (PI/checksum/media error) of a particular raid group.

It returns reference to a hash on success and 0 on failure

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item group_name

(Required) : Name of raid group to be checked.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_scrub_report_by_group {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                group_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $group_name = $opts{group_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj = new RaidInfo($conn);
        my $group_obj = $raid_obj->raid_group("$group_name");
        my %hash;

   # check if filer is having a flex vol of specified name
        if ($group_obj->parameter("scrub_progress") ne "-1") {
      logcomment("RaidSqa_Cmode.pm: Scrub not complete yet on raid group $group_name");
      return 0;
   } else  {
                $hash{pi} = $group_obj->parameter("scrub_pi");
                $hash{cksum_err} = $group_obj->parameter("scrub_cksum_err");
                $hash{media_err} = $group_obj->parameter("scrub_media_err");
        }
        return \%hash;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_fiji_slot

RaidSqa_get_fiji_slot(host=>$host, filermode=>$filermode, conntype=>$conntype, fiji_point=>$fiji_point);

This subroutine get the fiji slot numbers for a particular fiji point.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item fiji_point

(Required) : Name of fiji_point .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_fiji_slot {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                fiji_point => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $fiji_point = $opts{fiji_point};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $output;
        my $line;
   my $n=0;
   my @fiji_slot;
#        (undef,undef, $output) = say($conn, "priv set -q diag;fiji show", -timeout, $RaidSqa_TIMEOUT);

        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        $output = $server->cli(cmd=>"run local \"priv set -q diag; fiji show \" ");

        my @info = split(/\r?\n/, $output);
   foreach $line (@info) {
      my (@data) = split(": ", $line);
      if (index($line, "$fiji_point") ne "-1") {
         if (index($data[0], " (nvram)") ne "-1") {
                               substr($data[0], index($data[0], " (nvram)"))="";
                        }
         $fiji_slot[$n]=$data[0];
         $n++;
      }
   }
   return @fiji_slot;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_setflag

RaidSqa_get_setflag(host=>$host, filermode=>$filermode, conntype=>$conntype, flag_name=>$flag_name);

This subroutine get value of a setflag using printflag command. Need a non-promoted debug build.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item flag_name

(Required): Name of the flag to get value for.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_setflag {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                flag_name => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $flag_name = $opts{flag_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        # get value of a specified flag using printflag command
        # (undef,undef,$output)=say($conn, "priv set -q test; printflag $flag_name", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q test; printflag $flag_name \" ");

   my @output1 = split(/\r?\n/, $output);
   my ($flag, $value) = split(/ = /, $output1[0]);
   return $value;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_options

RaidSqa_get_options(host=>$host, filermode=>$filermode, conntype=>$conntype, option_name=>$option_name);

This subroutine get value of an options.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item option_name

(Required): Name of the option to get value.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_options {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                option_name => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $option_name = $opts{option_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        # get value of a specified option
        #(undef,undef,$output)=say($conn, "priv set -q test; options $option_name", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q test; options $option_name \" ");

   my @output1 = split(/\r?\n/, $output);
   my ($option, $value) = split(/\s+/, $output1[0]);
   return $value;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_fileid

RaidSqa_get_fileid(host=>$host, filermode=>$filermode, conntype=>$conntype, file_name=>$file_name);

This subroutine get fileid of a file.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item file_name

(Required): Name of the file_name to get id.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_fileid {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                file_name => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $file_name = $opts{file_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $entry;
   my $file_id;

        #(undef,undef,$output)=say($conn, "priv set -q test; showfh $file_name", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q test; showfh $file_name\" ");

   my @file_info = split(/ /, $output);
   foreach $entry (@file_info) {
         if ($entry =~ /fileid=(.*)/) {
            $file_id=$1;
         logcomment("RaidSqa_Cmode.pm: fileid of file $file_name is $file_id");
            last;
         }
   }

   if(!$file_id ) {
      logresult("FATAL", "RaidSqa_Cmode.pm: Could not get the fileid of file $file_name ");

   } else {
      return $file_id;
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_file_block_info

RaidSqa_get_file_block_info(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, file_name=>$file_name, $block_number=>$block_number);

This subroutine get disk and dbn number for a file block.

Does not return anything.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item file_name

(Required): Name of the file_name .

=item block_number

(Required): the block number of file .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_file_block_info {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol=> {type=>SCALAR},
                                file_name => { type=>SCALAR },
                                block_number => { type=>SCALAR },
                                }
                        );
   my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $file_name = $opts{file_name};
        my $block_number = $opts{block_number};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $file_id = RaidSqa_get_fileid(host=>$host, conntype=>$conntype, file_name=>$file_name);

        my $output;
   my $entry;

        #say($conn, "priv set -q test; dumpblock info $filer_vol $file_id $block_number", "disk.+",-timeout, $RaidSqa_TIMEOUT);
   #my $o;
        #(undef, undef, $o) = say($conn, "priv set -q test; dumpblock info $filer_vol $file_id $block_number", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $o = $server->cli(cmd=>"run local \"priv set -q test; dumpblock info $filer_vol $file_id $block_number\" ");


   #my @block_info = split(/, /, $RESPONSE);
   my @block_info = split(/\r?\n/, $o);
                  logcomment("RaidSqa_Cmode.pm: vbn is @block_info");
   my $disk_id;
   my $dbn_no;
   my $vbn_no;
   foreach $entry (@block_info) {
         if ($entry =~ /disk (.*)/) {
                  $disk_id=$1;
                  logcomment("RaidSqa_Cmode.pm: diskid is $disk_id");
                  next;
         }
         if ($entry =~ /^dbn (.*)/) {
                  $dbn_no=$1;
                  logcomment("RaidSqa_Cmode.pm: dbn is $dbn_no");
                  next;
         }
         if ($entry =~ /pvbn (.*)/) {
                  $vbn_no=$1;
                  logcomment("RaidSqa_Cmode.pm: vbn is $vbn_no");
                  next;
         }
   }

   if (!$disk_id  || !$dbn_no || !$vbn_no ) {
      logresult("FATAL", "RaidSqa_Cmode.pm: Could not get the disk_id  or dbn_no or vbn_no of file $file_name, block $block_number ");
   } else {
      return ($disk_id, $dbn_no, $vbn_no);
   }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_storage_type

RaidSqa_get_disk_storage_type(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk);

This subroutine gets the storage_type of the given disk.

It returns the storage type of disk on success otherwise returns 0.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Optional): Name of disk whose storage type is required.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_storage_type {
    my (%opts) =
      validate(
                @_,
                {
                   host => { type => OBJECT, isa => 'Hostrec' },
                   filermode =>
                     { type => SCALAR, default => "normal", optional => 1 },
                   conntype =>
                     { type => SCALAR, default => "#ssh", optional => 1 },
                   disk_name => { type => SCALAR | UNDEF },
                }
      );
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
			
    if ( $filermode ne "normal" ) {
        $conntype = "#console";
    }

    my $conn = make_conn( $host, $conntype );
#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_active_path_name){
			logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
			$disk_name=$disk_active_path_name;
		}else{
			logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

    my $raid_obj = new RaidInfo($conn);
    my @disk_list;
    my %disk_storage_type = ();

    if ( !$disk_name ) {
        logcomment("RaidSqa_Cmode.pm: disk_name is the required parameter.");
        return 0;
    }

    my $disk_obj     = $raid_obj->disk("$disk_name");
    my $storage_type = $disk_obj->parameter("disk_type");
    return $storage_type;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_media_error_inject

RaidSqa_media_error_inject(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name, dbn => $dbn);

This subroutine injects media error on given disk at given dbn depending on storage type.

It returns 1 on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item dbn

(Required) : dbn no to inject media error.

=item disk_name

(Required): Name of disk to inject media erro.


=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_media_error_inject {
    my (%opts) =
      validate(
                @_,
                {
                   host => { type => OBJECT, isa => 'Hostrec' },
                   filermode =>
                     { type => SCALAR, default => "normal", optional => 1 },
                   conntype =>
                     { type => SCALAR, default => "#ssh", optional => 1 },
                   disk_name => { type => SCALAR },
                   dbn       => { type => SCALAR },
                }
      );
    my $host      = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype  = $opts{conntype};
    my $disk_name = $opts{disk_name};
#Check if disk name exists or has an equivalent path_name2.
		if(defined($disk_name)){
			my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
			if($disk_active_path_name){
				logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
				$disk_name=$disk_active_path_name;
			}else{
				logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
				return(0);
			}
		}
		my $dbn       = $opts{dbn};

    if ( $filermode ne "normal" ) {
        $conntype = "#console";
    }

    my $storage_type =
      RaidSqa_get_disk_storage_type(
                                     host      => $host,
                                     filermode => $filermode,
                                     disk_name => $disk_name
      );
    if ( !$storage_type ) {
        return 0;
    }
    if ( $storage_type =~ /ata|bsas|sata/i ) {
        logcomment("RaidSqa_Cmode.pm: Injecting media error through fiji.");
        my $media_error_1 =
            '(repeat 100000 (raid.disk.read.done.check (eq @disk'
          . " $disk_name)(return 1)))";
        my $media_error_2 =
            '((raid.disk.read.done.buf (&&(eq @disk'
          . " $disk_name) (eq " . '@bno'
          . " $dbn))(return (buf_Errno E_DISK_BAD_SECTOR_ERROR))))";
        if (
             !RaidSqa_fiji_filter(
                                   host       => $host,
                                   fiji_point => $media_error_1,
                                   filermode  => $filermode
             )
          )
        {
            logcomment(
                    "RaidSqa_Cmode.pm: Media error 1 injection on disk $disk_name failed");
            return 0;
        }
        elsif (
                !RaidSqa_fiji_filter(
                                      host       => $host,
                                      fiji_point => $media_error_2,
                                      filermode  => $filermode
                )
          )
        {
            logcomment(
                    "RaidSqa_Cmode.pm: Media error 2 injection on disk $disk_name failed");
            return 0;
        } else {
            logcomment(
                "RaidSqa_Cmode.pm: Media error injected successfully using fiji. \n");
            return 1;
        }
    } elsif ( $storage_type =~ /FCAL|SAS/i ) {
        logcomment("RaidSqa_Cmode.pm: Injecting media error through disk_mung.");
        my $sector = 8 * $dbn;
        RaidSqa_disk_mung(
                           host      => $host,
                           filermode => $filermode,
                           disk_name => $disk_name,
                           sector    => $sector
        );
        logcomment(
             "RaidSqa_Cmode.pm: Media error injected successfully using disk_mung. \n"
        );
        return 1;
    } else {
        logresult(
"RaidSqa_Cmode.pm: Disk has unknown storage type.Its storage type is $storage_type."
        );
        return 0;
    }
}

##############################################################################
# LIST OF OTHER FUNCTIONS                                     #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_test_init

RaidSqa_test_init(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, aggr_type=>$aggr_type);

This subroutine is called before starting any tests, this will do following:
a. stop hammer,
b. unisolate any disk in olm,
c. online all offline disks
d. unfail all failed disks,
e. remove a particular aggregate having same name as required for test agregate,

It returns nothing.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate to be checked.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional volume is not supported, hence we  will set it to 1 if provided as 0.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_test_init{
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                aggr_type => { type=>SCALAR, default=>1, optional=>1 },

                                }
                        );

        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: aggr_type as 0 is not supported in Cmode hence chnaging it to 1");
                $aggr_type=1;
        }

   # abort hammer on filer
        RaidSqa_hammer_abort(host=>$host, conntype=>$conntype);
   # Unisolate all disk if any disk is in OLM
        RaidSqa_labelmaint_unisolate(host=>$host, conntype=>$conntype);
   # online all offline disk if any disk
        RaidSqa_disk_online(host=>$host, conntype=>$conntype, disk_name=>"all");
   # Unfail all disk to spare on filer
        RaidSqa_disk_unfail(host=>$host, conntype=>$conntype, disk_name=>"all", options=>"-s");
   # remove the tradvol if any exist with specified name
        RaidSqa_aggr_remove(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type =>$aggr_type);
#        my $output1 = say($conn, "priv set -q diag; disk zero spares", -timeout, $RaidSqa_TIMEOUT);
#        my $output2 = say($conn, "priv set -q diag; disk scrub stop", -timeout, $RaidSqa_TIMEOUT);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_aggr_disks_zeroing_completion

RaidSqa_wait_for_aggr_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol, timeout=>$timeout);

This subroutine wait till the disk zeroing in a particular aggregate/volume gets completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate or traditional volume to be checked .

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_aggr_disks_zeroing_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
            timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my $raid_obj=new RaidInfo($conn);
        my $aggr_obj =$raid_obj->aggregate("$filer_vol");
        my %disklist=$aggr_obj->all_disks();
        my @disklist=keys(%disklist);
        my $count = 1;
        my $disk;
        while ($count > 0) {
                $raid_obj->refresh();
         $aggr_obj =$raid_obj->aggregate("$filer_vol");
         %disklist=$aggr_obj->all_disks();
         @disklist=keys(%disklist);
                $count = 0;
                logcomment("RaidSqa_Cmode.pm: disklist in test volume/aggr is: @disklist ");

                foreach $disk (@disklist) {
                        my $disk_obj=$aggr_obj->disk("$disk");
                        if ($disk_obj->parameter("fsm_state") eq "ZEROING" || $disk_obj->parameter("fsm_state") eq "NOTZEROED") {
                                logcomment("RaidSqa_Cmode.pm: disk $disk in test volume/aggr is not zeroed yet ");
                                $count++;
                        }
                }
                logcomment("RaidSqa_Cmode.pm: waiting for $count disks to zero");
                sleep $timeout;
        }
}

=head2 RaidSqa_wait_for_reconstruction_completion

RaidSqa_wait_for_reconstruction_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, disk_name=>$disk_name, timeout=>$timeout);

This subroutine by default wait till all reconstructions in a given filer get completed. But if any of the options from filer_vol, plex_name or group_name or disk_name is specified than it check reconstruction completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Name of aggr/trad volume to be checked .

=item plex_name

(Optional) : Name of plex to be checked .

=item group_name

(Optional) : Name of raid group to be checked .

=item disk_name

(Optional) : Name of disk to be checked .

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_reconstruction_completion {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => {type=>SCALAR,default=>"normal",optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                disk_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
            timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $disk_name = $opts{disk_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $raid_obj=new RaidInfo($conn);
   my @group_list;
   if (defined($filer_vol)) {
      @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
   } elsif (defined($plex_name)) {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
   } elsif (defined($group_name)) {
      push @group_list, $group_name;
   } else {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
   }

         my $recons_in_progress = 1;
   if (defined($disk_name)) {
     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }
        while ($recons_in_progress == 1) {
                     $recons_in_progress = 0;
         my $disk_obj=$raid_obj->disk("$disk_name");
                        if ($disk_obj->parameter("parent_state") =~ /RECONS/ ) {
            logcomment("RaidSqa_Cmode.pm: disk $disk_name is still doing reconstruction ");
                                 $recons_in_progress = 1;
         }
         sleep $timeout;
         $raid_obj->refresh();
      }

   } else {

            while ($recons_in_progress == 1) {
                     $recons_in_progress = 0;
         my $group;
                     foreach $group (@group_list) {
            my $group_obj=$raid_obj->raid_group("$group");
            my $group_recons_progress=$group_obj->parameter("recons_progress");
                           if ($group_recons_progress != -1) {
               logcomment("RaidSqa_Cmode.pm: reconstruction still $group_recons_progress % on raid_group $group");
                                    $recons_in_progress = 1;
            }
         }
         sleep $timeout;
         $raid_obj->refresh();
         }
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_reparity_completion

RaidSqa_wait_for_reparity_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout);

This subroutine by default wait till the reparity gets completed on all raidgroups in filer. But if any of the options from filer_vol, plex_name or group_name is specified than it check reparity completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Use filer_vol if we want to check reparity progress on that particular aggr/trad volume.

=item plex_name

(Optional) : Use plex_name if we want to check reparity progress on that particular plex.

=item group_name

(Optional) : Use group_name if we want to check reparity progress on that particular raid group.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_reparity_completion {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => {type=>SCALAR,default=>"normal",optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                plex_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
                                group_name => {type=>SCALAR|UNDEF,default=>undef,optional=>1 },
            timeout => {type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $raid_obj=new RaidInfo($conn);
   my $aggr_obj=$raid_obj->aggregate("$filer_vol");
   my $plex_obj=$raid_obj->plex("$plex_name");
   my $group_obj=$raid_obj->raid_group("$group_name");

   my @group_list;
   if (defined($aggr_obj)) {
      @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
   } elsif (defined($plex_obj)) {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
   } elsif (defined($group_obj)) {
                @group_list= "$group_name";
   } else {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
   }

         my $reparity_in_progress = 1;
         while ($reparity_in_progress == 1) {
                  $reparity_in_progress = 0;
      my $group;
                  foreach $group (@group_list) {
         my $group_obj=$raid_obj->raid_group("$group");
         my $group_reparity_progress=$group_obj->parameter("reparity_progress");
                        if ($group_reparity_progress != -1) {
            logcomment("RaidSqa_Cmode.pm: reparity still $group_reparity_progress % on raid_group $group");
                                 $reparity_in_progress = 1;
         }
      }
      sleep $timeout;
      $raid_obj->refresh();
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_scrub_completion

RaidSqa_wait_for_scrub_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name, timeout=>$timeout);

This subroutine by default wait till the scrub get completed on on all raid groups in filer. But if any of the options from filer_vol, plex_name or group_name is specified than it check scrub completion on that particular raid object.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Optional) : Use filer_vol if we want to check scrub progress on that particular aggr/trad volume.

=item plex_name

(Optional) : Use plex_name if we want to check scrub progress on that particular plex.

=item group_name

(Optional) : Use group_name if we want to check scrub progress on that particular raid group.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_scrub_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            filer_vol => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            plex_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            group_name => {type=>SCALAR|UNDEF, default=>undef, optional=>1},
            timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $plex_name = $opts{plex_name};
        my $group_name = $opts{group_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   my $raid_obj=new RaidInfo($conn);

   my @group_list;
   if (defined($filer_vol)) {
      @group_list= RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, filer_vol=>$filer_vol);
   } elsif (defined($plex_name)) {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype, plex_name=>$plex_name);
   } elsif (defined($group_name)) {
                push @group_list, $group_name;
   } else {
      @group_list=RaidSqa_get_group_list(host=>$host, filermode =>$filermode, conntype =>$conntype);
   }

         my $scrub_in_progress = 1;
         while ($scrub_in_progress == 1) {
                  $scrub_in_progress = 0;
      my $group;
                  foreach $group (@group_list) {
         my $group_obj=$raid_obj->raid_group("$group");
         my $group_scrub_progress=$group_obj->parameter("scrub_progress");
                        if ($group_scrub_progress != -1) {
            logcomment("RaidSqa_Cmode.pm: scrub still $group_scrub_progress % on raid_group $group");
                                 $scrub_in_progress = 1;
         }
      }
      sleep $timeout;
      $raid_obj->refresh();
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_disk_sdc_completion

RaidSqa_wait_for_disk_sdc_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name, timeout=>$timeout);

This subroutine wait till the sdc on a particular disk get completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk on which sdc is running.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_wait_for_disk_sdc_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
            disk_name => {type=>SCALAR},
            timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

   my $raid_obj=new RaidInfo($conn);
   my $disk_obj=$raid_obj->disk("$disk_name");

#  if (RaidSqa_check_disk_sdc_start(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name)) {
            my $disk_sdc_progress = $disk_obj->parameter("copy_progress");
            while ($disk_sdc_progress  ne "-1") {
         logcomment("RaidSqa_Cmode.pm: sdc still $disk_sdc_progress % on disk $disk_name");
         sleep $timeout;
         $raid_obj->refresh();
         $disk_obj=$raid_obj->disk("$disk_name");
               $disk_sdc_progress = $disk_obj->parameter("copy_progress");
      }
#  } else {
#
#     logcomment("RaidSqa_Cmode.pm: sdc on disk $didn't start, so can not check its completion");
#     return 0;
#  }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_wait_for_spare_disks_zeroing_completion

RaidSqa_wait_for_spare_disks_zeroing_completion(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_list=>\@disk_list, timeout=>$timeout);

This subroutine wait till the disk zeroing on list of spare disks get completed.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_list

(Optional) : list of spare disk for which we want to check and wait till zeroing completion. Default is undefined.

=item timeout

(Optional): Value of timeout in secs to wait while checking the status again.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_wait_for_spare_disks_zeroing_completion {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1},
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_list => { type=>ARRAYREF,default=>undef,optional=>1},
            timeout=>{type=>SCALAR,default=>"10",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_list = $opts{disk_list};
        my $timeout = $opts{timeout};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

   if (!RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, spare_only=>"yes", fsm_state=>"ZEROING")) {
      logcomment("RaidSqa_Cmode.pm: There is no spare disk in the systen which is zeroing");
      return 0;
   } else {

         my $raid_obj=new RaidInfo($conn);
      my @disk_list=();

      if (!defined($disk_list)) {
            @disk_list=RaidSqa_get_disk_list_by_fsm_state(host=>$host, conntype=>$conntype, spare_only=>"yes", fsm_state=>"ZEROING");
      } else {
         @disk_list=@$disk_list;
      }
      # keep on checking until all spare disks are zeroed
         my $count = 1;
         my $disk;
         while ($count > 0) {
                  $raid_obj->refresh();
                  $count = 0;
                  logcomment("RaidSqa_Cmode.pm: list of spare disks is: @disk_list ");

                     foreach $disk (@disk_list) {
                           my $disk_obj=$raid_obj->disk("$disk");
                           if ($disk_obj->parameter("fsm_state") eq "ZEROING" ) {
                                 logcomment("RaidSqa_Cmode.pm: disk $disk is not zeroed yet ");
                                 $count++;
                           }
                  }
      }
                logcomment("RaidSqa_Cmode.pm: waiting for $count disks to zero");
                sleep $timeout;
        }
}

##############################################################################
# LIST OF FUNCTIONS SPECIFIC TO FEATURE OLM                                  #
##############################################################################

#------------------------------------------------------------------------------

=head2 RaidSqa_labelmaint_isolate

RaidSqa_labelmaint_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, arg_list=>\@arg_list);

This subroutine isolate a list of disks/volumes/or-mix of them for OLM.

It returns nothing

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item arg_list

(Required): Reference to a list of argument need to be isolated. The list can have all disks, all volume name or mix of both.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_labelmaint_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                arg_list => { type=>ARRAYREF },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $arg_list = $opts{arg_list};
        my @arg_list = @$arg_list;

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my @error_strings = (
            "doesn't exist or is ineligible",
            "No disk or aggregate named",
            "Only non-filesystem disks or offline aggregates may be isolated into Online Maintenance Mode"
        );
        
        my $regex = join "|", @error_strings;
        my $output;
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});

   # labelmaint isolate a list of aggr/volume and spare list
        if (!@arg_list) {
                logcomment("RaidSqa_Cmode.pm: Need to define at least one parameter to this funtion");
      return 0;
        } else {
                logcomment("RaidSqa_Cmode.pm: Isolating @arg_list");
         $output = $server->cli(cmd=>"run local \"priv set -q diag; labelmaint isolate @arg_list\" ");
                #(undef, undef, $output) = say($conn, "priv set -q diag;labelmaint isolate @arg_list", -timeout, $RaidSqa_TIMEOUT);
        }

        if ($output =~ /($regex)/mi) {
                return 0;
        } else {
                return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_labelmaint_list

RaidSqa_get_labelmaint_list(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine gets an array of disks which are in OLM.

It returns an array of olm disk on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_labelmaint_list {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
#        my $output;
#        (undef, undef, $output) = say($conn, "priv set -q diag;labelmaint list", -timeout, $RaidSqa_TIMEOUT);
        my $server= new Server;
        $server->set_execution_server(-Server => $host->{hostname});
        my $output = $server->cli(cmd=>"run local \"priv set -q diag; labelmaint list\" ");

        my @olm_list= split(/\r?\n\s/, $output);
      #shift(@olm_list);
      #pop(@olm_list);    # Reverting the changes as other modules use this output as input.
        logcomment("RaidSqa_Cmode.pm: Here is the list of disk in olm: @olm_list");
        return @olm_list;
}

#------------------------------------------------------------------------------

=head2 RaidSqa_labelmaint_unisolate

RaidSqa_labelmaint_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype);

This subroutine unisolate all disk from olm to normal mode.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec of filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_labelmaint_unisolate {
        my (%opts) = validate(@_, {
            host => { type=>OBJECT, isa=>'Hostrec' },
                               # host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        logcomment("RaidSqa_Cmode.pm: Unisolating any disks in OLM...");

        my $server= new Server;
   my $output;
        $server->set_execution_server(-Server => $host->{hostname});
        #$output = $server->cli(cmd=>"run local \"priv set -q diag; labelmaint unisolate \" ");

         $output = $server->cli(cmd=>"run local \"priv set -q diag; labelmaint unisolate \" ");

        my @olm_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);
        if (grep /No disks in online maintenance/, @olm_list) {
                logcomment("RaidSqa_Cmode.pm: There is no disk in labelmaint list");
                return 1;
        } else {
                logcomment("RaidSqa_Cmode.pm: There is still disk in labelmaint list");
                return 0;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_after_isolate

RaidSqa_check_disk_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

This subroutine checks a disk after isolate that it is not in filer raid recognised disk list but in OLM.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of disk which was isolated.

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_disk_after_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

        my @labelmaint_list= RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

        logcomment("RaidSqa_Cmode.pm: checking that disk $disk_name is not in filer raid recognized list, but instaed in OLM");

        if (RaidSqa_check_disk_exist(host=>$host, conntype=>$conntype, disk_name =>$disk_name)) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is still exist in filer raid recognized list");
      return 0;
        } else {
      if (grep /$disk_name/, @labelmaint_list) {
                        logcomment("RaidSqa_Cmode.pm: disk $disk_name is in labelmaint list");
         return 1;
      } else {
                        logcomment("RaidSqa_Cmode.pm: disk $disk_name is not in labelmaint list");
         return 0;
      }

        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_disk_after_unisolate

RaidSqa_check_disk_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name=>$disk_name);

This subroutine checks a disk after unisolate that it is not olm list but in filer raid recognized list.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Name of disk which got unisolated.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_disk_after_unisolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
   my $raid_obj=new RaidInfo($conn);

        my @labelmaint_list= RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

        logcomment("RaidSqa_Cmode.pm: checking that disk $disk_name is in filer raid recognized list, but not in labelmaint list");

        if (!RaidSqa_check_disk_exist(host=>$host, conntype=>$conntype, disk_name =>$disk_name)) {
                logcomment("RaidSqa_Cmode.pm: disk $disk_name is does not exist in filer raid recognized list");
      return 0;
        } else {
      logcomment("RaidSqa_Cmode.pm: disk $disk_name is in filer raid recognized list as expected");
      my $disk_obj=$raid_obj->disk($disk_name);
      my $disk_2nd = $disk_obj->parameter("path_name2");
      if ($disk_2nd) {
         if ((grep /$disk_name/, @labelmaint_list) || ( grep /$disk_2nd/, @labelmaint_list)) {
                           logcomment("RaidSqa_Cmode.pm: disk $disk_name is in labelmaint list");
            return 0;
         } else {
                           logcomment("RaidSqa_Cmode.pm: disk $disk_name is not in labelmaint list");
            return 1;
         }

                } else {
         if (grep /$disk_name/, @labelmaint_list) {
                           logcomment("RaidSqa_Cmode.pm: disk $disk_name is in labelmaint list");
            return 0;
         } else {
                           logcomment("RaidSqa_Cmode.pm: disk $disk_name is not in labelmaint list");
            return 1;
         }
                }

        }

}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_after_isolate

RaidSqa_check_aggr_after_isolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, vol_disk_list=>\@vol_disk_list);

This subroutine checks an aggregate after isolate that its disks are in olm list and aggr is not in aggr list.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of aggregate.

=item vol_disk_list

(Required): Reference to the array of disks in aggr/volume.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional volume is not supported, hence we  will set it to 1 if provided as 0.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_check_aggr_after_isolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                vol_disk_list => { type=>ARRAYREF },
                                aggr_type => { type=>SCALAR, default=>1, optional=>1 },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $vol_disk_list = $opts{vol_disk_list};
        my @vol_disk_list =@$vol_disk_list;
   my $aggr_type = $opts{aggr_type};


        if($filermode ne "normal"){
                $conntype = "#console";
        }



        my $conn = make_conn($host,$conntype);

        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: aggr_type as 0 is not supported in Cmode hence chnaging it to 1");
                $aggr_type=1;
        }

        my @labelmaint_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

   logcomment("RaidSqa_Cmode.pm: checking that aggr $filer_vol does not exists after isolate");

        if (RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
      return 0;
        } else {

         logcomment("RaidSqa_Cmode.pm: checking that all disks of aggr $filer_vol are in OLM list");
      my $disk;

         foreach $disk (@vol_disk_list) {
         if (grep /$disk/, @labelmaint_list) {
                           logcomment("RaidSqa_Cmode.pm: disk $disk is in labelmaint list");
         } else {
                           logcomment("RaidSqa_Cmode.pm: disk $disk is not in labelmaint list");
            return 0;
         }
         }
      return 1;
   }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_check_aggr_after_unisolate

RaidSqa_check_aggr_after_unisolate(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol=>$filer_vol, vol_disk_list=>\@vol_disk_list, aggr_type=>$aggr_type);

This subroutine checks an aggregate after unisolate that its disks are not olm list and aggr is in aggr list as offline.

It returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required): Name of aggregate.

=item vol_disk_list

(Required): Reference to the array of disks in aggr/volume.

=item aggr_type

(Required): 1 for aggregate and 0 for traditional. Default it is 1. For cmode traditional volume is not supported, hence we  will set it to 1 if provided as 0

=back

=cut

#------------------------------------------------------------------------------


sub RaidSqa_check_aggr_after_unisolate {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },
                                vol_disk_list => { type=>ARRAYREF },
                           aggr_type => { type=>SCALAR, default=>1, optional=>1 },

                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $filer_vol = $opts{filer_vol};
        my $vol_disk_list = $opts{vol_disk_list};
        my @vol_disk_list = @$vol_disk_list;
        my $aggr_type = $opts{aggr_type};

        if($filermode ne "normal"){
                $conntype = "#console";
        }


        my $conn = make_conn($host,$conntype);

        if (!$aggr_type) {
                logcomment("RaidSqa_Cmode.pm: aggr_type as 0 is not supported in Cmode hence chnaging it to 1");
                $aggr_type=1;
        }

        my @labelmaint_list=RaidSqa_get_labelmaint_list(host=>$host, conntype=>$conntype);

        logcomment("RaidSqa_Cmode.pm: checking that aggr $filer_vol comes back after unisolate");

        if (!RaidSqa_check_aggr_exist(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, aggr_type=>$aggr_type)) {
      return 0;
        } else {

         logcomment("RaidSqa_Cmode.pm: checking that aggr $filer_vol is offline");

         if (RaidSqa_check_aggr_state_name(host=>$host, conntype=>$conntype, filer_vol=>$filer_vol, state_name=>"offline",aggr_type=>$aggr_type)) {
                  logcomment("RaidSqa_Cmode.pm: aggr $filer_vol is offline as expected");
         } else {
                  logcomment("RaidSqa_Cmode.pm: aggr $filer_vol is not offline as expected");
         return 0;
         }

         logcomment("RaidSqa_Cmode.pm: checking that no disks of aggr $filer_vol are not in OLM list");

      my $raid_obj = new RaidInfo($conn);
         my $disk;

         foreach $disk (@vol_disk_list) {

         my $disk_obj=$raid_obj->disk($disk);
         my $disk_2nd = $disk_obj->parameter("path_name2");

         if ($disk_2nd) {
            if ((grep /$disk/, @labelmaint_list) || ( grep /$disk_2nd/, @labelmaint_list)) {
                              logcomment("RaidSqa_Cmode.pm: disk $disk is still in labelmaint list");
               return 0;
            } else {
                              logcomment("RaidSqa_Cmode.pm: disk $disk is not in labelmaint list");
            }

                  } else {
            if (grep /$disk/, @labelmaint_list) {
                              logcomment("RaidSqa_Cmode.pm: disk $disk is still in labelmaint list");
               return 0;
            } else {
                              logcomment("RaidSqa_Cmode.pm: disk $disk is not in labelmaint list");
            }
                  }
         }
      return 1;
        }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_volume_junc_path

RaidSqa_get_volume_junc_path(host=>$host, filermode=>$filermode, conntype=>$conntype, filer_vol => $filer_vol);


This subroutine gets a junction path for a given volume.

It returns a junction path on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item filer_vol

(Required) : Name of aggregate volume.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_volume_junc_path {
    my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                filer_vol => { type=>SCALAR },

                                }
                            );

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $filer_vol = $opts{filer_vol};

    if($filermode ne "normal"){
            $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    my $server = new Server;
    my @vols = $server->volume_show('volume' => "$filer_vol");
    my $jp = "";
    foreach my $vol (@vols) {
        if ( exists($vol->{'junction-path'}) ) {
            $jp = $vol->{'junction-path'};
            last;
        }
    }
    return $jp;
} # end get_junc_path

#------------------------------------------------------------------------------

=head2 RaidSqa_get_vserver_ip_addr

RaidSqa_get_vserver_ip_addr(host=>$host, filermode=>$filermode, conntype=>$conntype, vserver=>$vserver);


This subroutine gets the ip address of vserver.

It returns a ip address on success.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item vserver

(Required) : Name of the vserver.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_vserver_ip_addr {

    my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec'  },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                vserver => { type=>SCALAR },
                                }
                                );

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $vserver = $opts{vserver};

    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);
    my $server = new Server;

    my @ni_all = $server->network_interface_show('server' => "$vserver");
    my $ip = "";
    foreach my $ni (@ni_all) {
        if ( exists($ni->{address}) ) {
            $ip = $ni->{address};
            last;
        }
    }
    return $ip;
} # end get_ip_addr

#------------------------------------------------------------------------------

=head2 RaidSqa_ems_log_get_mark

This routine returns the current mark(timestamp in format <n>t) of the event
log

my $host = host($FILER);
my $ret = RaidSqa_ems_log_get_mark(host=>$host);
my $ret = RaidSqa_ems_log_get_mark(host=>$host, timeout=>60);

The following named arguments are accepted,

=over

=item host

(Required) : Hostspec to filer

=item timeout

(Optional) : Timeout value for the say. Default : 1200

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_ems_log_get_mark {
    my (%opts) = validate(@_, { host => { type=>OBJECT, isa=>'Hostrec' },
                     timeout => { type=>SCALAR, default=>1200, optional=>1 },
                 });

    my $host = $opts{host};
    my $conn = make_conn($opts{host});
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    $server->cli(cmd=>"run local options ems.log.dupsuppress.enable off");
    $server->cli(cmd=>"run local options ems.autosuppress.enable off");
    # To Disable ems duplicate events

    my $output = $server->cli(cmd=>"run local ems log dump 1s", -Timeout  =>1200);

    my(@lines) = split(/\r*\n/, $output);
    # removing rsh related console messages that were reported from few clients,from the command output
    @lines = grep /<NR/, @lines;
    #Use header (NR) only to get the timestamp
    my %emslog_nr = emslog_parseNR($lines[0]);
    logcomment("RaidSqa_Cmode: Timestamp is : ".$emslog_nr{t} . "t" );
    return ($emslog_nr{t} . "t");
}

#------------------------------------------------------------------------------

=head2 RaidSqa_ems_log_dump_by_type

This routine returns pointer to hash table having event name as key and
array of event ids as value.

my $host = host($FILER);
my $ret = RaidSqa_ems_log_dump_by_type(host=>$host);
OR
my $mark = RaidSqa_ems_log_get_mark(host=>$host);
my $event_by_type = RaidSqa_ems_log_dump_by_type(host=>$host, timestamp=>$mark);
$event = $event_by_type->{"dfu.firmwareDownloading"};
if ($event eq "") {
    croak "Disk firmware download is not started yet";
}

$event = $event_by_type->{"dfu.firmwareUpToDate"};
if ($event eq "") {
    croak "Disk firmware download didn't complete in given time";
}

The output looks like:
$VAR1 = {
          'fci.adapter.offlining' => [
                                       '1133838353/531',
                                       '1133838353/539'
                                     ],
          'fci.adapter.offline' => [
                                     '1133838353/532',
                                     '1133838353/540'
                                   ],
          'fci.adapter.onlining' => [
                                      '1133838353/536',
                                      '1133838353/543'
                                    ],
          'unowned.disk.reminder' => [
                                       '1133838353/529'
                                     ],
          'monitor.shelf.fault' => [
                                     '1133838353/527',
                                     '1133838353/528'
                                   ],
          'fci.adapter.online' => [
                                    '1133838353/537',
                                    '1133838353/544'
                                  ],
          'kern.syslog.msg' => [
                                 '1133838353/530',
                                 '1133838353/533',
                                 '1133838353/534',
                                 '1133838353/535',
                                 '1133838353/538',
                                 '1133838353/542'
                               ],
          'config.NotMultiPath' => [
                                     '1133838353/541'
                                   ],
          'kern.uptime.filer' => [
                                   '1133838353/526'
                                 ]
        };

The following named arguments are accepted,

=over

=item host

(Required) : Hostspec to filer

=item timestamp

(Optional) : Get the event from timestamp Default : ""(means only header)

Timestamp semantic can be :

<n>s    Last n seconds
<n>m    Last n minutes
<n>h    Last n hours
<n>d    Last n days
<n>t    Since timestamp <n>

=item log

(Optional) : The logfile to get events from. Default : "" (means current)

=item verbose

(Optional) : Set this Option to get the verbose output. Default is Yes.

=item timeout

(Optional) : Timeout value for the say. Default : 1200

=item ems_file

(Optional) : The ems_file to get events from. Default : "none"

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_ems_log_dump_by_type {
    my (%opts) = validate(@_, { host => { type=>OBJECT, isa=>'Hostrec',default=>"",optional=>1 },
                     timestamp => { type=>SCALAR,default=>"", optional=>1 },
                     log => { type=>SCALAR,default=>"", optional=>1 },
                     verbose => { type=>SCALAR,default=>"yes", optional=>1 },
                     timeout => { type=>SCALAR, default=>1200, optional=>1 },
                     ems_file => {type=>SCALAR,default=>"none",optional=>1},
                 });

    my $emslog_entry;
    my @emslog_events;
    my @emslog_event_lines;
    my %emslog_event_by_id;
    my %emslog_event_by_type;
    my %emslog_nr;
    my @lines;
    my $verbose = " ";
    my $host = $opts{host};
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    if($opts{verbose} eq "no"){
         $verbose = "-noverbose";
    }
    if ($opts{ems_file} eq "none"){
        my $conn = make_conn($opts{host});
        my $cmd = "ems log dump $opts{log} $opts{timestamp}";
        logcomment("Issuing $cmd  $verbose");

        my $output = $server->cli(cmd=>"run local $cmd","$verbose");

        @lines = split(/\r*\n/, $output);
    }
    else{
    open(FILE,"< $opts{ems_file}") or die "Could not open file $opts{ems_file} for reading: $!\n";
    while(<FILE>){
        push @lines,$_;
        }
    }

    foreach my $line (@lines) {
        if (!emslog_parse($line, \%emslog_nr, \$emslog_entry)) {
            next;
    }
    emslog_process_line($emslog_entry, \@emslog_events,
                            \@emslog_event_lines,
                            \%emslog_event_by_id,
                            \%emslog_event_by_type);
    $emslog_entry = "";
    }
    return(\%emslog_event_by_type);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_ems_log_dump_by_id

This routine returns pointer to hash table having event info by id

my $ret = RaidSqa_ems_log_dump_by_id(host=>$host);
my $ret = RaidSqa_ems_log_dump_by_id(host=>$host, timeout=>300, timestamp=>23456788t);

The output looks like:
$VAR1 = {
          '1133838353/530' => {
                                'vfilerName' => '',
                                'header' => {
                                              'n' => 'raid-u23',
                                              'o' => 'rc',
                                              'p' => 6,
                                              's' => 'OK',
                                              't' => '1134007568',
                                              'd' => '08Dec2005 02:06:08',
                                              'vf' => '',
                                              'id' => '1133838353/530'
                                            },
                                'msg' => 'Taking adapter 6a offline at administrator&apos;s request.&nl;',
                                'type' => 'kern.syslog.msg',
                                'attr' => 'msg,vfilerName'
                              },
          '1133838353/531' => {
                                'header' => {
                                              'n' => 'raid-u23',
                                              'o' => 'rc',
                                              'p' => 6,
                                              's' => 'OK',
                                              't' => '1134007568',
                                              'd' => '08Dec2005 02:06:08',
                                              'vf' => '',
                                              'id' => '1133838353/531'
                                            },
                                'adapterName' => '6a',
                                'type' => 'fci.adapter.offlining',
                                'attr' => 'adapterName'
                              },
          .
          .
          .
}


The following named arguments are accepted,

=over

=item host

(Required) : Hostspec to filer

=item timestamp

(Optional) : Get the event from this timestamp Default : ""(means only header)

Timestamp semantic can be :

<n>s    Last n seconds
<n>m    Last n minutes
<n>h    Last n hours
<n>d    Last n days
<n>t    Since timestamp <n>

=item log

(Optional) : The logfile to get events from. Default : "" (means current)

=item verbose

(Optional) : Set this Option to get the verbose output. Default is Yes.

=item timeout

(Optional) : Timeout value for the say. Default : 1200: Increasing the default
value as the log file might be quite big and can take longer to dump the file

=item ems_file

(Optional) : The ems_file to get events from. Default : "none"

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_ems_log_dump_by_id {
    my (%opts) = validate(@_, { host => { type=>OBJECT, isa=>'Hostrec',default=>"",optional=>1 },
                     timestamp => { type=>SCALAR,default=>"", optional=>1 },
                     log => { type=>SCALAR,default=>"", optional=>1 },
                     verbose => { type=>SCALAR,default=>"yes", optional=>1 },
                     timeout => { type=>SCALAR, default=>1200, optional=>1 },
                     ems_file => {type=>SCALAR,default=>"none",optional=>1},
                 });

    my $emslog_entry;
    my @emslog_events;
    my @emslog_event_lines;
    my %emslog_event_by_id;
    my %emslog_event_by_type;
    my %emslog_nr;
    my @lines;
    my $verbose = " ";

    my $host = $opts{host};
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    if($opts{verbose} eq "no"){
        $verbose = "-noverbose";
    }

    if ($opts{ems_file} eq "none"){
        my $conn = make_conn($opts{host});
        my $cmd = "ems log dump $opts{log} $opts{timestamp}";
        logcomment("Issuing $cmd  $verbose");
        my $output = $server->cli(cmd=>"run local $cmd","$verbose");
        @lines = split(/\r*\n/, $output);
    }
    else{
        open(FILE,"< $opts{ems_file}") or die "Could not open file $opts{ems_file} for reading: $!\n";
        while(<FILE>){
            push @lines,$_;
            }
    }

    foreach my $line (@lines) {
        if (!emslog_parse($line, \%emslog_nr, \$emslog_entry)) {
            next;
    }
    emslog_process_line($emslog_entry, \@emslog_events,
                            \@emslog_event_lines,
                            \%emslog_event_by_id,
                            \%emslog_event_by_type);
    $emslog_entry = "";
    }
    return(\%emslog_event_by_id);
}

#------------------------------------------------------------------------------

=head2 RaidSqa_ems_log_check

This routine returns 0 if a given event on given objectname is not found from a specified timestamp otherwise returns <n> for the n number of instances found in the log.

my $host = host($FILER);
my $mark = RaidSqa_ems_log_get_mark(host=>$host);
my $ret = RaidSqa_ems_log_check(host=>$host, eventtype=>"fci.adapter.offline", key=>"adapterName" value=>"6a", timestamp=>$mark);
if ($ret == 0) {
    logcomment("The specified event is not found in the ems log");
} else {
    logcomment("Found the specified ems event $ret times in the ems log");
}

The following named arguments are accepted,

=over

=item host

(Required) : Hostspec to filer

=item eventtype

(Required) : The type of events to look into, like "fci_adapter_offline"...

=item key

(Required) : What is the key (the objectname for a given event type) to look into the event
message. For example, in the following ems message key is "adapterName":

<LR d="07Dec2005 18:45:31" n="raid-u23" t="1133981131" id="1133838353/404" p="6" s="OK" o="ispfc_init_2" vf="">
<fci_adapter_offline_1
        adapterName="6a"/>
</LR>

=item value

(Required) : What is the value (the objectname for a given event type) to look into for the
given event type and key. To check for the above ems message the value would be "6a".

=item timestamp

(Required) : Get the event from this timestamp.

Timestamp semantic can be :

<n>s    Last n seconds
<n>m    Last n minutes
<n>h    Last n hours
<n>d    Last n days
<n>t    Since timestamp <n>

=item log

(Optional) : The logfile to get events from. Default : "" (means current)

=item timeout

(Optional) : Timeout value for the say. Default : 1200: Increasing the default
value as the log file might be quite big and can take longer to dump the file

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_ems_log_check {
    my (%opts) = validate(@_, { host => { type=>OBJECT, isa=>'Hostrec' },
                     eventtype => { type=>SCALAR },
                     key => { type=>SCALAR },
                     value => { type=>SCALAR },
                     timestamp => { type=>SCALAR },
                     log => { type=>SCALAR,default=>"", optional=>1 },
                     timeout => { type=>SCALAR, default=>1200, optional=>1 },
                 });

    my $event_by_type;
    my $event_by_id;
    my $host = $opts{host};
    if (defined($opts{log})) {
        $event_by_type = RaidSqa_ems_log_dump_by_type(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout}, log=>$opts{log});
    } else {
        $event_by_type = RaidSqa_ems_log_dump_by_type(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout});
    }

    if (defined($opts{log})) {
        $event_by_id = RaidSqa_ems_log_dump_by_id(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout}, log=>$opts{log});
    } else {
        $event_by_id = RaidSqa_ems_log_dump_by_id(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout});
    }

    my $event = $event_by_type->{"$opts{eventtype}"};
    if(!defined($event)) {
        return (0);
    } else {
        my $found;
        $found = 0;
        foreach my $id (@{$event}) {
            if ($event_by_id->{$id}{$opts{key}} eq "$opts{value}") {
                ++$found;
            }
        }
        return($found);
    }
}

#------------------------------------------------------------------------------
=head2 RaidSqa_get_disk_rgdn

RaidSqa_get_disk_rgdn(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the disk rgdn value of a particular disk in system..

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_disk_rgdn {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $disk_name = $opts{disk_name};
        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);

     my $disk_active_path_name = RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
     if ($disk_active_path_name) {
	logcomment("RaidSqa_Cmode.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
	$disk_name = $disk_active_path_name;
     } else {
	logcomment("RaidSqa_Cmode.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
	return 0;
     }

        my $raid_obj = new RaidInfo($conn);
        my $disk_obj = $raid_obj->disk("$disk_name");
        if (!$disk_obj) {
                logcomment("RaidSqa_Cmode.pm: Disk $disk_name does not exist in filer.");
                return 0;
        } else {
                my $disk_rgdn = $disk_obj->parameter("disk_rgdn");
                return $disk_rgdn;
        }
}


##===========================================================================

=head2 RaidSqa_get_invalid_diskid

Get invalid disk id's for creation of temporary root volume

RETURNS
        0 on failure
    A single invalid disk or
    reference to an invalid disk list on success

ARGUMENTS

=over

=item conn

(Required): Connection object. Use rsh connection as there might
        be issues with console connection.

=item No. of disks

(Optional):  No of invalid disk id's needed. Defaults to 1.

=back

EXAMPLE

        my $ret = RaidSqa_get_invalid_diskid(conn => $conn,
                     num_disks => $no_of_disks);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_get_invalid_diskid {

    my %opts = validate(@_,
                        {conn => {type => OBJECT, isa => "Connectrec"},
                         num_disks =>
                           {type => SCALAR, optional => 1, default => 1},});

    my $conn         = $opts{conn};
    my $num_of_disks = $opts{num_disks};

    my ($count, @disk_list, $disk_id, $i, $raid_obj, %spare_disks,
        @filer_disks_list);

    $raid_obj         = new RaidInfo($conn);
    %spare_disks      = $raid_obj->spare_disks();
    @filer_disks_list = keys %spare_disks;
    $i                = 1;

    while ($i <= $num_of_disks) {
        $disk_id = rand(200);
        $count = grep(/^$disk_id$/, @filer_disks_list);
        if (0 == $count) {
            push(@disk_list, $disk_id);
        }
        $i++;
    }

    if (0 == scalar(@disk_list)) {
        logcomment("Failed to generate invalid disk id's");
        return 0;
    }

    if (1 == scalar(@disk_list)) {
        return ($disk_id);
    } else {
        return (\@disk_list);
    }
} ## end sub RaidSqa_get_invalid_diskid

##===========================================================================

=head2 RaidSqa_create_temproot_vol

Create the temp root volume followed by setup.
This function will create the temporary root volume at the boot menu.
It will take care of trnsitioning to the boot menu and will then proceed
with volume creation.

RETURNS
       0 on failure. $@ will be set with error message
       1 on success

ARGUMENTS

=over

=item %args

(Required): a hash containing host record volume name, disk list,
        raid type and verify flag which can be used to check if the
        temporary root volumes creation was successful after the
        system comes up.

=back

EXAMPLE

        my $ret = RaidSqa_create_temproot_vol(host         => $host,
                      vol_name     => $trad_vol_name,
                      disk_list    => $disk_list_ref,
                      setup_info   => \%setupinfo);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_create_temproot_vol {

    my (%args) =
      validate(@_,
               {host     => {type => OBJECT, isa      => 'Hostrec'},
                vol_name => {type => SCALAR, optional => 1, default => undef},
                disk_list => {type => ARRAYREF, optional => 1, default => []},
                verify_flg => {type => SCALAR, optional => 1, default => 0},
                fiji_bootmenu => {type => SCALAR, optional => 1, default => 0},
                raid_type =>
                  {type => SCALAR, optional => 1, default => 'raid0'},});

    my $host             = $args{host};
    my $trad_vol_name    = $args{vol_name};
    my $verification_flg = $args{verify_flg};
    my $raid_type        = $args{raid_type};
    my $fiji_bootmenu    = $args{fiji_bootmenu};

    my ($conn, $cmd,       $err_msg1,  $err_msg2,  $err_msg3,
    $err_msg4, $err_msg5,  $err_msg6,  $err_msg7,  $err_msg8,
    $err_msg9, $err_msg10, $err_msg11, $err_msg12, $err_msg13,
    $pass_msg, $fail_msg,  $match,     $before,    $after,     
    $select,   $ctrl_c, $current_state, $return_state, $err_msg14);

    $err_msg1    = 'Invalid Volume name for command create_temp_root';
    $err_msg2    = 'No (disk|disks) specified for command create_temp_root';
    $err_msg3    = 'Invalid syntax for command create_temp_root';
    $err_msg4    = 'Invalid option .* for command create_temp_root';
    $err_msg5    = 'Invalid raid type.*for command create_temp_root';
    $err_msg6    = 'No disk or invalid disk name specified';
    $err_msg7    = 'Disk \w+\.\w+ is listed twice';
    $err_msg8    = 'Disk \w+\.\w+ does not exist\.';
    $err_msg9    = 'Disk \w+ does not exist';
    $err_msg10   = 'Disk \w+\.\w+ is not a spare disk';
    $err_msg11   = 'Disk \w+\.\w+ is not owned by local host';
    $err_msg12   = 'Assimilation failed';
    $err_msg13   = 'No raid-type specified for command create_temp_root';
    $err_msg14   = 'Unable to create root volume: Not enough disks';
    $pass_msg    = 'Created root volume $trad_vol_name';
    $fail_msg    = 'raid\.label\.io\.writeError';
    $ctrl_c      = "Press Ctrl-C for Boot Menu.";
    $select      = "Please make a selection:";

    my $server= new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    logcomment("RaidSqa_Cmode.pm: Going to BOOT_MENU");
    $conn = make_conn($host, "#console");
    if ($fiji_bootmenu) {
        $cmd="reboot -node $host->{hostname} -dump true";
    } else {
        $cmd="reboot -node $host->{hostname}";
    }

    ($match, $before, $after) =
      Tharn::say($conn, $cmd, qr/$ctrl_c/, -swallow,   -eval_error, -noprompt, '-timeout', $::CMDTIMEOUT * 10);

    $cmd = "\cC";
    if ($match =~ /$ctrl_c/) {
        ($match, $before, $after) =
      Tharn::say($conn, $cmd, qr/$select/, -swallow,   -eval_error, -noprompt, '-timeout', $::CMDTIMEOUT * 10);
    }

    logcomment("RaidSqa_Cmode.pm: Creating temp root volume");

    $cmd = "create_temp_root $trad_vol_name -t $raid_type @{$args{disk_list}}";

    ($match, $before, $after) =
      Tharn::say($conn, $cmd, qr/$select/, -swallow,   -eval_error, -noprompt, '-timeout', $::CMDTIMEOUT * 10, '-maxidle', $::TIMEOUT);

    $cmd = "normal";
    if ($match =~ /$select/) {
        ($match, $before, $after) =
      Tharn::say($conn, $cmd, qr/$err_msg13|$err_msg14|$err_msg1|$err_msg2|$err_msg3|$err_msg4|$err_msg5|$err_msg6|$err_msg7|$err_msg8|$err_msg9|$err_msg10|$err_msg11|$err_msg12|$fail_msg|$pass_msg/, -swallow,   -eval_error, -noprompt, '-timeout', $::CMDTIMEOUT * 10, '-maxidle', $::TIMEOUT);
    }

    if ($match =~ /$err_msg1|$err_msg2|$err_msg3|$err_msg4|$err_msg5|$err_msg6|$err_msg7|$err_msg8|$err_msg9|$err_msg10|$err_msg11|$err_msg12|$err_msg13|$err_msg14|$fail_msg/) {
        logcomment("Temporary trad vol creation failed with error : $match");
        logcomment("RaidSqa_Cmode.pm: Wait for loader prompt");
        foreach (1..20) { #Check for additional 300 secs
            $current_state = $server->state();
            logcomment("RaidSqa_Cmode.pm: Current filer state is: $current_state");
            if ($current_state =~ /CFE/) {
                logcomment("RaidSqa_Cmode.pm: Filer is in Loader prompt now");
                last;
            } else {
                sleep(10);
            }
        }
        ## bringing the filer up incase it is not.
        RaidSqa_transit_to(host=>$host, state_name=>"UP");

        $@ = $match;
        return 0;
    } ## end if ($match =~ ...

        logcomment("Temporary root vol creation successful.");
        logcomment("RaidSqa_Cmode.pm: Wait for login prompt");
        foreach (1..30) { #Check for additional 300 secs
            $current_state = $server->state();
            logcomment("RaidSqa_Cmode.pm: Current filer state is: $current_state");
            if ($current_state =~ /LOGIN/) {
                logcomment("RaidSqa_Cmode.pm: Filer is in Login prompt now");
                last;
            } else {
                sleep(10);
            }
        }
        RaidSqa_transit_to(host=>$host, state_name=>"UP");
        if ($verification_flg) {
            if (!(RaidSqa_temp_rootvol_verify(host      => $host,
                                              vol_name  => $trad_vol_name,
                                              disk_list => $args{disk_list},))
              ) {
                return 0;
            }
        }

    return 1;
}

##===========================================================================

=head2 RaidSqa_check_ioc_support

checks for ioc on root support in the build.

RETURNS
    0 on failure
    1 on success
ARGUMENTS

=over

=item %opts

(Required):
  host : Named host object hash.
=back

EXAMPLE
        my $ret = RaidSqa_check_ioc_support(host => $host);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_check_ioc_support {

    my %opts = validate(@_, {host => {type => OBJECT, isa => 'Hostrec'},});
    my $host = $opts{host};

    my $ret = RaidSqa_get_setflag(host      => $host,
                                  flag_name => "wafl_iron_optional_commit_root_enabled");

    if ((!defined($ret)) || ($ret eq "")) {
        logcomment("IOC on root is not supported on current build");
        return 0;
    }

    logcomment("IOC on root is supported on current build");
    return 1;
} ## end sub RaidSqa_check_ioc_support

##===========================================================================

=head2 RaidSqa_temp_rootvol_verify

Verify if the temp root volume was created with disks passed.
Also check if the root flag is set for temporary root volume.

RETURNS
        0 on failure. $@ will be set with error message
    1 on success

ARGUMENTS

=over

=item %args

    Required 
    host     : Host object. 
    vol_name : Name of the volume whose root flag needs to be verified
    disk_list: Reference to an array containing the Disk id's
                   used for temp root vol creation


=back

EXAMPLE

        my $ret = RaidSqa_temp_rootvol_verify(host      => $host,
                      vol_name  => $trad_vol_name,
                      disk_list => $disk_list_ref);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_temp_rootvol_verify {

    my (%args) =
      validate(@_,
               {host      => {type => OBJECT, isa => 'Hostrec'},
                vol_name  => {type => SCALAR},
                disk_list => {type => ARRAYREF}});

    my $host          = $args{host};
    my $trad_vol_name = $args{vol_name};

    my ($conn, $conn_console, @vol_disk_list, $ref, $disk, $status);
    $conn_console = make_conn($host, "#console");
    ##cheking if the filer is up.
    if (boot_state($conn_console) ne 'UP') {
        transit_to($conn_console, 'UP')
          or die("The filer is is in un-expected state :$@");
    }

    $conn = make_conn($host, "#ssh");
    my $raid_obj = new RaidInfo($conn);
    my $flex_obj = $raid_obj->volume("$trad_vol_name");

    # check that tradvol of specified name exists or not
    if (!$flex_obj) {
        logcomment("RaidSqa_Cmode.pm: no trad or aggregate or flex with name $trad_vol_name exists");
        return 0;
    } 
    my $aggr = $flex_obj->parameter("tree");

    ## Getting the list of disks owned by the temp root vol
    logcomment("RaidSqa_Cmode.pm: Get the volume disk list");
    @vol_disk_list = RaidSqa_get_disk_list(host => $host, filer_vol => $aggr); 
    logcomment("RaidSqa_Cmode.pm: Disk list from aggr $aggr : @vol_disk_list");

    ## checking if the disks passed belong to the volume
    foreach $disk (@{$args{disk_list}}) {
        unless (grep (/^$disk$/, @vol_disk_list)) {
            logcomment("RaidSqa_Cmode.pm: The disk $disk is not present in volume");
            return 0;
        }
    }
    logcomment("RaidSqa_Cmode.pm: The passed disks belong to the volume $trad_vol_name");

    ##checking if the root flag has been set for $trad_vol_name
    if ($flex_obj->parameter("root") ne "1") {
       logcomment("RaidSqa_Cmode.pm: The root flag for volume $trad_vol_name is not set");
       return 0;
    }
    logcomment("RaidSqa_Cmode.pm: The temporary volume $trad_vol_name has the root flag set");

    ## checking if the root volume is of raid type raid0
    my $raid_type = RaidSqa_get_aggr_options(host=>$host,filer_vol => $aggr, options=>'raidtype');

    if($raid_type !~ /raid0/) {
        logcomment("RaidSqa_Cmode.pm: The volume $trad_vol_name is not of type raid0");
        return 0;
    }

    logcomment(
             "The temporary volume $trad_vol_name is of type raid0");

    return 1;
} ## end sub RaidSqa_temp_rootvol_verify()

##===========================================================================

=head2 RaidSqa_verify_root_aggr_vol_spare_disks(%opt)

This function will check if root flag is set to root aggr,
root volume and spare disks which were used to create the
tradvol, are returned to the spare disks pool.

Returns 1 on success and 0 on failure.
(set $@ to contain a string describing the failure);

=item %opt
This is the hash with the following keys

     conn => filer connection object required.(It should be console
              connection).

     root_aggr  => name of the root aggr. Required.

     root_vol => name of the root volume. Required.
     disks => reference to the array of disks. Required.
Usage:
     RaidSqa_verify_root_aggr_vol_spare_disks
    (conn =>$fc, root_aggr=>$root_aggr, root_vol=>$root_vol, disks=>$ref_array_of_disks);
=cut
#------------------------------------------------------------------------------

sub RaidSqa_verify_root_aggr_vol_spare_disks {
    my ($host, $root_aggr, $root_vol, $disk_list, $ref, %opt);
    %opt = validate(@_,
                    {host => {type => OBJECT, isa => 'Hostrec'},
                     root_aggr => {type => SCALAR},
                     root_vol  => {type => SCALAR},
                     disk_list => {type => ARRAYREF},});

    $host = $opt{host};

    #Get the root aggr, root vol and disks.
    $root_aggr = defined($opt{root_aggr}) ? $opt{root_aggr} : RaidSqa_get_root_aggr(host=>$host);
    $root_vol  = defined($opt{root_vol})  ? $opt{root_vol}  : RaidSqa_get_root_vol(host=>$host);
    $disk_list = $opt{disk_list};

    my $output = join("",
                      RaidSqa_get_aggr_status(host      => $host,
                                              filer_vol => $root_aggr,
                                              options => ''));
    logcomment("RaidSqa_Cmode.pm: Output from aggr status : $output");
    if ($output =~ /root/g) {
        logcomment("RaidSqa_Cmode.pm: The root aggr has root flag");
    } else {
        logcomment("RaidSqa_Cmode.pm: The root aggr does not have root flag");
        return 0;
    }

    $output = join("",
                      RaidSqa_get_vol_status(host      => $host,
                                              filer_vol => $root_vol,
                                              options => ''));
    logcomment("RaidSqa_Cmode.pm: Output from vol status : $output");
    if ($output =~ /root/g) {
        logcomment("RaidSqa_Cmode.pm: The root vol has root flag");
    } else {
        logcomment("RaidSqa_Cmode.pm: The root vol does not have root flag");
        return 0;
    }

    my @spare_disks_list = RaidSqa_get_disk_list(host => $host, spare_only => "yes");

    foreach my $disk (@$disk_list) {
        unless (grep (/^$disk$/, @spare_disks_list)) {
            logcomment("RaidSqa_Cmode.pm: The disk $disk has not been found in the spare disk pool");
            return 0;
        } else {
            logcomment("RaidSqa_Cmode.pm: The disk $disk has been found in the spare disk pool");
        }
    }

    return 1;
} ## end sub RaidSqa_verify_root_aggr_vol_spare_disks

##===========================================================================

=head2 RaidSqa_cleanup_ioc_vol

Cleanup the filer after created temp root volume.

ARGUMENTS

=over

=item %args

    Required 
    host            : Host object
    temp_root_vol   : Name of the temp root volume
    old_root_vol    : Name of the old root volume, which exists before creating temp root

=back

EXAMPLE

        my $ret = RaidSqa_cleanup_ioc_vol(host      => $host,
                      temp_root_vol  => $trad_vol_name,
                      old_root_vol   => $root_vol);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_cleanup_ioc_vol {
    my (%args) =
      validate(@_,
               {host          => {type => OBJECT, isa      => 'Hostrec'},
                temp_root_vol => {type => SCALAR},
                old_root_vol  => {type => SCALAR},});
    my $host                 = $args{host};
    my $temp_vol_name        = $args{temp_root_vol};
    my $old_root_vol_name    = $args{old_root_vol};
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    my $root_aggr = RaidSqa_get_root_aggr(host => $host);
    if ($root_aggr ne $old_root_vol_name) {
        RaidSqa_aggr_set_as_root(host => $host, aggr => $old_root_vol_name, restore => 0);
    } else {
        # Go to maintanenance mode
        RaidSqa_transit_to(host=>$host, state_name=>"MAINT");
    }

    $server->console(cmd=>"aggr offline $temp_vol_name", noprompt => 1);
    $server->console(cmd=>"aggr destroy $temp_vol_name -f", noprompt => 1);
    RaidSqa_transit_to(host=>$host, state_name=>"UP");

    RaidSqa_root_recovery(host => $host);

    RaidSqa_disk_zero_spares(host=>$host);
} ## end sub RaidSqa_cleanup_ioc_vol

##===========================================================================

=head2 RaidSqa_root_recovery

This function will do the root recovery process.

ARGUMENTS

=over

=item %args

    Required 
    host            : Host object

=back

EXAMPLE

        my $ret = RaidSqa_root_recovery(host => $host);

=cut
#------------------------------------------------------------------------------

sub RaidSqa_root_recovery {
    my (%args) =
      validate(@_,
               {host          => {type => OBJECT, isa      => 'Hostrec'},});
    my $host                 = $args{host};

    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});

    $server->cli(cmd=>"set -privilege diagnostic -confirmations off");
    RaidSqa_transit_to(host=>$host, state_name=>"SHELL");
    $server->shell(cmd => 'kenv bootarg.init.boot_recovery');
    $server->shell(cmd => 'sudo sysctl kern.bootargs=--bootarg.init.boot_recovery');
    $server->shell(cmd => 'ls /mroot/etc/cluster_config/monitor_mroot.nvfail');
    $server->shell(cmd => 'sudo rm /mroot/etc/cluster_config/monitor_mroot.nvfail');
    $server->transit_to(state => $server->CLI());

    RaidSqa_transit_to(host=>$host, state_name=>"REBOOT");

} ## end sub RaidSqa_root_recovery

##===========================================================================

=head2 RaidSqa_aggr_recovery_from_dblade

This function will recover aggregate from Dblade to VLDB.

ARGUMENTS

=over

=item %args

    Required 
    host            : Host object
    filer_vol       : Name of the aggregate to recover
    vserver         : Name of the vserver

=back

EXAMPLE

        RaidSqa_aggr_recovery_from_dblade(host      => $host,
                                          filer_vol => $filer_vol,
                                          vserver   => $vserver);

=cut

#------------------------------------------------------------------------------

sub RaidSqa_aggr_recovery_from_dblade {
    my (%args) =
      validate(@_,
               {host          => {type => OBJECT, isa      => 'Hostrec'},
                filer_vol     => {type => SCALAR},
                vserver       => {type => SCALAR},
                recover_vol   => {type => SCALAR, default => undef},});
    my $host        = $args{host};
    my $filer_vol   = $args{filer_vol};
    my $vserver     = $args{vserver};
    my $recover_vol = $args{recover_vol};
    my $server = new Server;
    $server->set_execution_server(-Server => $host->{hostname});
    $server->cli(cmd=>"vol show");
    $server->cli(cmd=>"aggr show");
    $server->cli(cmd=>"set -privilege diagnostic -confirmations off");
    my $output = $server->cli(cmd=>"debug vreport show -type aggregate -object $filer_vol");
    if ($output !~ /There are no entries matching your query/) {
        $server->cli(cmd=>"debug vreport fix -type aggregate -object $filer_vol");
    }
    if ($recover_vol) {
        my $output = $server->cli(cmd=>"debug vreport show -type volume -object $vserver:$filer_vol");
        if ($output !~ /There are no entries matching your query/) {
            $server->cli(cmd=>"debug vreport fix -type volume -object $vserver:$filer_vol");
        }
    }

} ## end sub RaidSqa_aggr_recovery_from_dblade

##===========================================================================

=head2 RaidSqa_transit_to

RaidSqa_transit_to(host=>$host, filermode=>$filermode, conntype=>$conntype, state_name => $state_name);


This subroutine transits the filer into the specified state.

Returns 1 on success and 0 on failure.

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#console".

=item state_name

(Required) : Name of state name to be transit.

=back

=cut
#------------------------------------------------------------------------------

sub RaidSqa_transit_to {
    my (%opts) = validate(@_, {
        host => { type=>OBJECT, isa=>'Hostrec'  },
        filermode => { type=>SCALAR, default=>"normal", optional=>1 },
        conntype => {type=>SCALAR,default=>"#console",optional=>1},
        state_name => {type=>SCALAR},});

    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $state_name = $opts{state_name};

    # create connection
    if($filermode ne "normal"){
        $conntype = "#console";
    }

    my $conn = make_conn($host,$conntype);

    logcomment("RaidSqa_Cmode.pm: Created conn object of $conntype");
    my  $current_state = boot_state($conn);
    logcomment("RaidSqa_Cmode.pm: Current filer state is: $current_state");

    my %srv_args = ();
    if($current_state !~ /UP/) {
        $srv_args{no_cli} = 1;
    }
    my $server= new Server(%srv_args);
    $server->set_execution_server(-Server => $host->{hostname});

    if($current_state =~ /MAINT/){          #Adding this block as Transit_to does not support maint mode yet
        $server->console(cmd=>"halt -f", noprompt=>1);
        $server->transit_to(state=>$server->CFE());
        $current_state = $server->state();
        logcomment("RaidSqa_Cmode.pm: Current filer state is: $current_state");
    }

    if($state_name =~ /BOOT_MENU/i){
        $server->transit_to(state=>$server->IBM());
    } elsif($state_name =~ /UP/i) {
        $server->transit_to(state=>$server->CLI());
        logcomment("Going to disconnect ssh connection");
        Tharn::disconnect("#ssh",'-ok');
    } elsif($state_name =~ /REBOOT/i) {
        $server->transit_to(state=>$server->REBOOT());
        $server->transit_to(state=>$server->CLI());
        logcomment("Going to disconnect ssh connection");
        Tharn::disconnect("#ssh",'-ok');
        $state_name = "UP";
    } elsif($state_name =~ /MAINT/i) {      
        #First go to maint mode, and then execute maint command and wait for 300 sec
        $server->transit_to(state=>$server->IBM());
        $server->console(cmd=>"maint", noprompt=>1);
        sleep(100);
        foreach (1..20) {       #Check for additional 200 secs
            $current_state = $server->state();
            if($current_state =~ /MAINT/i) {
                last;
            } else {
                sleep(10);
            }
        }
    } elsif($state_name =~ /FIRMWARE/i) {
        $server->transit_to(state=>$server->CFE());
    } elsif($state_name =~ /SHELL/i) {
        $server->transit_to(state=>$server->SHELL());
    } elsif ($state_name =~ /LOGIN/i) {
        $server->transit_to(state=>$server->LOGIN());
    }
    sleep(10);
    $current_state = $server->state();
    if($current_state =~ /$state_name/) {
        return 1;
    } else {
        $current_state = boot_state($conn);         #Check against traditional boot state value
        if($current_state =~ /$state_name/) {
            return 1;
        } else {
            return 0;
        }
    }
}

#------------------------------------------------------------------------------
=head2 RaidSqa_find_active_path_disk_name

RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);

This subroutine finds the active disk name of a given disk.

It returns a scalar on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required): Find the active disk name of the given disk.

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_find_active_path_disk_name {
    my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR,default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR,default=>"#ssh",optional=>1},
                                disk_name => { type=>SCALAR },
                              }
                        );
    my $host = $opts{host};
    my $filermode = $opts{filermode};
    my $conntype = $opts{conntype};
    my $disk_name = $opts{disk_name};
    my $orig_disk = undef;
    
    if($filermode ne "normal"){
            $conntype = "#console";
    }
    my $conn = make_conn($host,$conntype);
    my $raid_obj = new RaidInfo($conn);
    if (defined($disk_name)) {
        logcomment("RaidSqa_Cmode.pm: Getting orig disk name of the disk $disk_name.\n");
    } else {
        logcomment("RaidSqa_Cmode.pm: No disk_name is specified.\n");
        return(0);
    }
    my %disks_hash = $raid_obj->all_disks();
    if (exists $disks_hash{$disk_name}) {
        logcomment("RaidSqa_Cmode.pm: The diskname is same $disk_name ");
        return $disk_name;
    } else {
        foreach my $key(keys %disks_hash) {
            if($disk_name eq $disks_hash{$key}{"path_name2"}) {
                $orig_disk = $disks_hash{$key}{"name"};
                logcomment("RaidSqa_Cmode.pm:The disk name for $disk_name seems to have changed to $orig_disk after reboot.");
                return $orig_disk;
            }
        }
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_list_by_checksum_type

RaidSqa_get_disk_list_by_checksum_type(host=>$host, filermode=>$filermode, conntype=>$conntype, checksum_type =>$checksum_type, pool_name=>$pool_name, spare_only=>$spare_only, disk_list=>$disk_list, filer_vol=>$filer_vol, plex_name=>$plex_name, group_name=>$group_name);

This subroutine by default gets list of disks of a given checksum type in a given filer. By specifing any one of the options from disk_list, pool_name, spare_only, filer_vol, plex_name or group_name, we can get the disk list of a given checksum_type from that particular raid object.

It returns an array on success

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#ssh". For filermode "MAINT" it is "#console" by default.

=item checksum_type

(Optional) : Name of the required checksumtype, to get the list of disk.
Possible values are block, zoned.

(Optional) : bps value of the required checksumtype, to get the list of disk.
Possible value is 520 or 512.

= item pool_name

(Optional): Name of the spare pool from which to get the list of given checksum_type disks.

=item spare_only

(Optional): Its values are "yes" or "no". If "yes" than provide spare disks of given checksum_type only.

=item disk_list

(Optional) : List of disks from which need to get disks of a given checksum_type.

=item filer_vol

(Optional): Name of aggr/volume of which we want to get the disk list of given checksum_type.

=item plex_name

(Optional): Name of plex of which we want to get the disk list of given checksum_type .

=item group_name

(Optional): Name of raid group of which we want to get the disk list of given checksum_type.

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_get_disk_list_by_checksum_type {
    my (%opts) =
      validate(@_,
               {host          => {type => OBJECT, isa      => 'Hostrec'},
                filermode     => {type => SCALAR, default  => "normal", optional => 1},
                conntype      => {type => SCALAR, default  => "#ssh", optional => 1},
                checksum_type => {type => SCALAR, optional => 1},
                bps           => {type => SCALAR, optional => 1},
                pool_name     => {type => SCALAR, default  => undef, optional => 1},
                spare_only    => {type => SCALAR, default  => "no", optional => 1},
                disk_list  => {type => ARRAYREF | UNDEF, default => undef, optional => 1},
                filer_vol  => {type => SCALAR | UNDEF,   default => undef, optional => 1},
                plex_name  => {type => SCALAR | UNDEF,   default => undef, optional => 1},
                group_name => {type => SCALAR | UNDEF,   default => undef, optional => 1},});
    my $host          = $opts{host};
    my $filermode     = $opts{filermode};
    my $conntype      = $opts{conntype};
    my $checksum_type = $opts{checksum_type};
    my $bps	      = $opts{bps};
    my $pool_name     = $opts{pool_name};
    my $spare_only    = $opts{spare_only};
    my $disk_list     = $opts{disk_list};
    my $filer_vol     = $opts{filer_vol};
    my $plex_name     = $opts{plex_name};
    my $group_name    = $opts{group_name};

    if ($filermode ne "normal") {
        $conntype = "#console";
    }

    my $conn = make_conn($host, $conntype);

    my $raid_obj = new RaidInfo($conn);
    my @disk_list;
    my @disk_checksum_type;
    my $bps_required = 0;
    if (($checksum_type eq "block") || ($bps eq "520")) {
        $bps_required = 520;
    } elsif (($checksum_type eq "zoned") || ($bps eq "512")) {
        $bps_required = 512;
    }
    if (!$disk_list) {
        @disk_list = RaidSqa_get_disk_list(host       => $host,
                                           filermode  => $filermode,
                                           conntype   => $conntype,
                                           spare_only => $spare_only,
                                           filer_vol  => $filer_vol,
                                           plex_name  => $plex_name,
                                           group_name => $group_name);
    } else {
        @disk_list = @$disk_list;
    }

    my $a = 0;
    my $disk;
    if ($pool_name) {
        my $b = 0;
        my @disks_pool0_checksum_type;
        my @disks_pool1_checksum_type;
        foreach $disk (@disk_list) {
            my $disk_obj = $raid_obj->disk("$disk");
            if ($disk_obj->parameter("pool") eq "0") {
                if ($disk_obj->parameter("bps") eq $bps_required) {
                    $disks_pool0_checksum_type[$a] = $disk;
                    $a++;
                }
            } elsif ($disk_obj->parameter("pool") eq "1") {
                if ($disk_obj->parameter("bps") eq $bps_required) {
                    $disks_pool1_checksum_type[$b] = $disk;
                    $b++;
                }
            }
        } ## end foreach $disk (@disk_list)

        if ($pool_name =~ /pool0|Pool0|POOL0/) {
            return @disks_pool0_checksum_type;
        } elsif ($pool_name =~ /pool1|Pool1|POOL1/) {
            return @disks_pool1_checksum_type;
        }
    } else {
        foreach $disk (@disk_list) {
            my $disk_obj = $raid_obj->disk("$disk");
            if ($disk_obj->parameter("bps") eq $bps_required) {
                $disk_checksum_type[$a] = $disk;
                $a++;
            }
        }

        return @disk_checksum_type;
    } ## end else [ if ($pool_name)
} ## end sub RaidSqa_get_disk_list_by_checksum_type


sub RaidSqa_ems_get_value_by_key {
    my (%opts) = validate(@_, { host => { type=>OBJECT, isa=>'Hostrec' },
                     eventtype => { type=>SCALAR },
                     key => { type=>SCALAR },
                     timestamp => { type=>SCALAR },
                     log => { type=>SCALAR,default=>"", optional=>1 },
                     timeout => { type=>SCALAR, default=>1200, optional=>1 },
                 });

    my $event_by_type;
    my $event_by_id;

    if (defined($opts{log})) {
        $event_by_type = RaidSqa_ems_log_dump_by_type(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout}, log=>$opts{log});
    } else {
        $event_by_type = RaidSqa_ems_log_dump_by_type(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout});
    }

    if (defined($opts{log})) {
        $event_by_id = RaidSqa_ems_log_dump_by_id(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout}, log=>$opts{log});
    } else {
        $event_by_id = RaidSqa_ems_log_dump_by_id(host=>$opts{host}, timestamp=>$opts{timestamp}, timeout=>$opts{timeout});
    }
 
    my $event = $event_by_type->{"$opts{eventtype}"};
    if(!defined($event)) {
        return (0);
    } else {
        foreach my $id (@{$event}) {
            return $event_by_id->{$id}{$opts{key}} ;
        }
        return(undef);
    }
}

#------------------------------------------------------------------------------

=head2 RaidSqa_get_disk_parent_state 

RaidSqa_get_disk_parent_state(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name => $disk_name);

This subroutine get the parent_state state of a particular disk in system.

It returns a scalar on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item disk_name

(Required) : Name of disk .

=back

=cut

#------------------------------------------------------------------------------

sub RaidSqa_get_disk_parent_state {
        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                disk_name => { type=>SCALAR },
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $disk_name = $opts{disk_name};
		my $conntype = $opts{conntype};

        if($filermode ne "normal"){
                $conntype = "#console";
        }

        my $conn = make_conn($host,$conntype);
		#Check if disk name exists or has an equivalent path_name2.
	if(defined($disk_name)){
		my $disk_active_path_name=RaidSqa_find_active_path_disk_name(host=>$host, filermode=>$filermode, conntype=>$conntype, disk_name =>$disk_name);
		if($disk_active_path_name){
			logcomment("RaidSqa.pm: Using path name $disk_active_path_name for any operations on $disk_name.\n");
			$disk_name=$disk_active_path_name;
		}else{
			logcomment("RaidSqa.pm: The disk_name $disk_name specified does not exist. Please check again.\n");
			return(0);
		}
	}

	my $raid_obj = new RaidInfo($conn);
	my $disk_obj = $raid_obj->disk("$disk_name");
	my $disk_parent_state=$disk_obj->parameter("parent_state");
	if (!$disk_obj) {
                logcomment("RaidSqa.pm: disk $disk_name does not exist in filer");
                return 0;
        } else {
                return $disk_parent_state;
	}

}



#------------------------------------------------------------------------------
=head2 RaidSqa_diskbypass

RaidSqa_diskbypass(host=>$host, filermode=>$filermode, conntype=>$conntype, error=>$error, disk_id=>$disk_id, portAorB=>$portAorB);

This Subroutine to bypass/unbypass a disk. Bypasses/unbypasses an ESH drive port.

It returns a 1 on success 

The following arguments are accepted:

=over

=item host

(Required): Hostspec to filer

=item filermode

(Optional) : Specifies to run tests in normal or maintenance mode. Default is normal.
For maintenance mode the variable will be "MAINT"

=item conntype

(Optional): Connection type to use. Default is "#rsh". For filermode "MAINT" it is "#console" by default.

=item error

(Required) :  Error type to inject for bypassing drives.Following types of errors can be injected:
                       "0x02" => "FORCE BYPASS".
                       "0xa0" => "Clock Delta Fault Bypass".
                       "0xa1" => "CRC Fault Bypass".
                       "0xa2" => "WRD Fault Bypass".
                       "0xa3" => "Increment CRC error +1".
                       "0xa4" => "Increment CRC error +2".
                       "0xa5" => "Increment WRD error +1000".
=item disk_id

(Required) : disk id to be bypassed.


=item portAorB

(Optional) : To bypass port A or port B of the drive. "A" or "B", if not defined that will bypass/unbypass both ports

=back

=cut

#------------------------------------------------------------------------------
sub RaidSqa_diskbypass {

        my ( $a , $b , $c , $i , %wwnmap, %portid);

        my (%opts) = validate(@_, {
                                host => { type=>OBJECT, isa=>'Hostrec' },
                                filermode => { type=>SCALAR, default=>"normal", optional=>1 },
                                conntype => {type=>SCALAR, default=>"#ssh", optional=>1},
                                error    => {type=>SCALAR},
                                disk_id => { type=>SCALAR },
                                portAorB => {type=>SCALAR, optional=>1},
                                }
                        );
        my $host = $opts{host};
        my $filermode = $opts{filermode};
        my $conntype = $opts{conntype};
        my $error    = $opts{error};
        my $diskidraw_list = $opts{disk_id};
        my $portAorB = $opts{portAorB};

        $c = RaidSqa_filer_cmd(host => $host,
                               cmd  => "storage show hub");
        my @hub = split(/\r?\n/,$c);

        #### First create an array of adapters connected to hub

        my @channels = grep /Channel/, @hub;
        my @channel1;
        my $n =0;
        while ( $n <= $#channels) {
                my @hub1 = split(/\s+/,$channels[$n]);
                $channel1[$n] = $hub1[1];
                $n++;
        }

        #### Create an array of  shelf ids of disks

        $n = 0;
        my( @shelf1 , @shelves, @shelf );
        @shelves = grep /Shelf id:/, @hub;
        while ($n <= $#shelves) {
                @shelf = split(/\s+/,$shelves[$n]);
                $shelf1[$n] = $shelf[2];
                $n++
        }

	#### Create an array of wwn nos.

	$n =0;
	my ( @wwn , @wwn2 , @wwn1);
	@wwn = grep /UID/ , @hub;
	while ( $n <= $#wwn) {
		@wwn2 = split(/\s+/,$wwn[$n]);
		$wwn1[$n] = $wwn2[2];
		$n++;
	}

        #### Create a hash table of adapters , shelves and wwns

        $i =0;
        my ( %wwnmap1 ,$adshelf ,@wwnmap);
        while ( $i <= $#channel1 ) {
                $adshelf = $channel1[$i].".".$shelf1[$i] ;
                %wwnmap = ($adshelf, $wwn1[$i]);
                %wwnmap1 = (%wwnmap1,%wwnmap);
                $i++;
        }

    foreach my $diskidraw (split " ", $diskidraw_list){
        my ( @diskid , $diskid , $adapid ,$shelfid);
        @diskid = split(/\./ , $diskidraw);
        $diskid = $diskid[1];
        $adapid = $diskid[0];
        if ( $diskid <= 13) {
                $shelfid = 0;
                }
        elsif( $diskid >=16 && $diskid <=29) {
                $shelfid =1;
                }
        elsif( $diskid >=32 && $diskid <= 45) {
                $shelfid = 2;
                }
        elsif( $diskid >=48 && $diskid <=61 ) {
                $shelfid = 3;
                }
        elsif( $diskid >=64 && $diskid <=77) {
                $shelfid = 4;
                }
        elsif( $diskid >=80 && $diskid <=93 ) {
                $shelfid = 5;
                }
        elsif( $diskid >=96 && $diskid <=109) {
                $shelfid = 6;
                }
        else { $shelfid = 7;}

        my $diskkey = "$adapid" . "." . "$shelfid";

        ### Check for ESH or ESH2


        $c = RaidSqa_filer_cmd(host => $host,
                               cmd  => "environ shelf $adapid");
        my @eshtype = split(/\r?\n/,$c);
        my $tt = "no";
        my $eshtype;
        my $eshtype1;
        foreach $eshtype (@eshtype){
                if($eshtype =~  /Shelf:\s+$shelfid/){
                        $tt = "yes";
                }
                if(($eshtype  =~ /Module type/) && ($tt eq "yes")){
                        $eshtype1 = "$eshtype";
                        goto LABEL ;
                }
        }



        LABEL : my $diskwwn = 0;

        $diskwwn = $wwnmap1{$diskkey};

        my  $j ;

        for ( $i = 0 ; $i <=13 ; $i++) {
                $j = $i;
                while ( $j <= 112 + $i){

                        if($eshtype1 =~ /ESH;/){
                                $portid{$j} = $i + 2;
                        }

                        if($eshtype1 =~ /ESH2/){
                                $portid{$j} = $i + 4;
                        }
#MTK_EDIT: Added the below code for ESH4 model type shelfs
                        if($eshtype1 =~ /ESH4/){
                                $portid{$j} = $i + 4;
                        }

                        $j = $j + 16;

                        }
                }
        my $port = $portid{$diskid};

        if ( $diskwwn eq '') {
                logresult("FATAL", "$diskidraw is not a hub disk");
                }
        else {

        #print "WWN for disk: $diskidraw is $diskwwn and it's port no is

           if ($error eq "0x02") {
#MTK_EDIT: Chaned the prompt string from "Manually bypassed" to "DBG4: PORT CONTROL request port: $port"
#MTK_EDIT: Chaned the prompt string from "" to "fcadmin: hub request in progress to shelf UID: 50:05:0c:c0:02:10:60:ff"
                if ( $portAorB eq "") {

                        RaidSqa_filer_cmd(host    => $host,
                                          cmd     => "fcadmin hub pctrl -w $diskwwn -p $port -v $error -l A",
                                          prompt  => "fcadmin: hub request in progress to shelf UID: $diskwwn");
                        sleep 30;
                        RaidSqa_filer_cmd(host    => $host,
                                          cmd     => "fcadmin hub pctrl -w $diskwwn -p $port -v $error -l B",
                                          prompt  => "fcadmin: hub request in progress to shelf UID: $diskwwn");

                } else {
                        RaidSqa_filer_cmd(host    => $host,
                                          cmd     => "fcadmin hub pctrl -w $diskwwn -p $port -v $error -l $portAorB",
                                          prompt  => "fcadmin: hub request in progress to shelf UID: $diskwwn");
                }

           } else {
                if ( $portAorB eq "") {
                        RaidSqa_filer_saycmd(host    => $host,
                                             cmd     => "run local \"priv set -q advanced;fcadmin hub pctrl -w $diskwwn -p $port -v $error -l A\"",
                                             prompt  => "\n");
                        sleep 30;
                        RaidSqa_filer_saycmd(host    => $host,
                                             cmd     => "run local \"priv set -q advanced;fcadmin hub pctrl -w $diskwwn -p $port -v $error -l B\"",
                                             prompt  => "\n");

                } else {
                        RaidSqa_filer_saycmd(host    => $host,
                                             cmd     => "run local \"priv set -q advanced;fcadmin hub pctrl -w $diskwwn -p $port -v $error -l $portAorB\"",
                                             prompt  => "\n");
                }
           }
        }
        sleep 30;
    }
    return (1);

}


##############################################################################
# The local rotines are coded in the following section                       #
##############################################################################

sub emslog_parseNR {
    my($line) = @_;
    my %emslog_nr = ();
    my($header);
    if ($line =~ /^\s*<NR (.*)\/>\s*$/) {
        $header = "$1";
    } else {
        logcomment("parseNR mismatch: '$line'\n");
        croak $line;
    }

    #
    # Parse the header (NR) section of the event record
    #
    while ($header ne "") {
        if ($header =~ /^\s*([^=]+)=\"([^\"]*)\"\s*(.*)$/) {
            $emslog_nr{$1} = $2;
            $header = $3;
        } else {
            $header = "";
        }
    }
    return (%emslog_nr);
}
sub emslog_parse {
    my($line, $emslog_nr, $emslog_entry) = @_;

    if ($line =~ /^<NR/) {
        %{$emslog_nr} = emslog_parseNR($line);
        return 0;
    }

    if ($line =~ /^<LR/) {
        ${$emslog_entry} = $line;
        return 0;
    }

    if ($line =~ /^<\/LR/) {
        ${$emslog_entry} = ${$emslog_entry} . $line;
        return 1;
    }

    ${$emslog_entry} = ${$emslog_entry} . " $line";
    return 0;
}

sub emslog_process_line {
    my($line, $emslog_events, $emslog_event_lines, $emslog_event_by_id,
       $emslog_event_by_type) = @_;

    my($header, $event, $id, $i);
    my(@headerlist, @eventlist);
    my($type, $version);

    if ($line =~ /^\s*<LR (.*)>\s*<(.*)\/>\s*<\/LR>\s*$/) {
        $header = "$1";
        $event = $2;
    } else {
        logcomment("emslog_process_line: mismatch\n");
        return;
    }

    #
    # Get the id.
    #
    if ($header =~ /\s*id=\"([^\"]+)\"/) {
        $id = $1;
    }

    push @{$emslog_events}, $id;
    push @{$emslog_event_lines}, $line;


    #
    # Parse the header (LR) section of the event record
    #
    while ($header ne "") {
        if ($header =~ /^\s*([^=]+)=\"([^\"]*)\"\s*(.*)$/) {
            $emslog_event_by_id->{$id}{header}{$1} = $2;
            $header = $3;
        } else {
            $header = "";
        }
    }

    if ($event =~ /^\s*(\S+)\s*(.*)/) {
        $type = $1;
        $event = $2;
    }

    if ($type =~ /^(\S+)_([0-9]+)$/) {
        $type = $1;
        $type =~ s/_/\./g;
    }

    emslog_add_by_type($type, $id, $emslog_event_by_type);
    $emslog_event_by_id->{$id}{type} = $type;

    #
    # Parse the per-event specific part of the event record
    #
    while ($event ne "") {
        if ($event =~ /^\s*([^=]+)=\"([^\"]*)\"\s*(.*)$/) {
            $emslog_event_by_id->{$id}{$1} = $2;
            if (!exists($emslog_event_by_id->{$id}{attr})) {
                $emslog_event_by_id->{$id}{attr} = $1;
            } else {
                $emslog_event_by_id->{$id}{attr} .= ",$1";
            }
            $event = $3;
        } else {
            $event = "";
        }
    }
}

sub emslog_add_by_type {
    my($type, $id, $emslog_event_by_type) = @_;
    push(@{$emslog_event_by_type->{$type}}, $id);
}

1;

